/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/base/common/types","vs/nls","electron","vs/base/common/network","vs/base/common/errors","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/base/common/arrays","os","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/base/common/uuid","vs/base/common/extpath","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/base/common/process","vs/base/common/labels","vs/platform/environment/common/environment","vs/platform/state/electron-main/state","vs/platform/policy/common/policy","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/map","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/json","vs/base/common/objects","vs/base/common/errorMessage","child_process","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/base/common/functional","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/remote/common/remoteHosts","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/electron-main/themeMainService","vs/base/common/iterator","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/window/common/window","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/normalization","crypto","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensions/common/extensions","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/update/electron-main/abstractUpdateService","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/common/linkedList","vs/base/node/ports","vs/base/common/severity","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/shell/node/shellEnv","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/codicons","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetryUtils","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/launch/electron-main/launchMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/backup/electron-main/backupMainService","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","graceful-fs","https","string_decoder","vscode-policy-watcher","zlib","vs/code/electron-main/main"],re=function(H){for(var e=[],E=0,t=H.length;E<t;E++)e[E]=ie[H[E]];return e};define(ie[120],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function E(R){return R?R.replace(/\$\((.*?)\)/g,(A,P)=>` ${P} `).trim():""}e.getCodiconAriaLabel=E;class t{constructor(A,P,g){this.id=A,this.definition=P,this.description=g,t.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t.a}}e.Codicon=t,t.a=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.commentDraft=new t("comment-draft",{fontCharacter:"\\ec0e"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);var C;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function P(b){if(b instanceof t)return["codicon","codicon-"+b.id];const S=A.exec(b.id);if(!S)return P(t.error);const[,y,u]=S,d=["codicon","codicon-"+y];return u&&d.push("codicon-modifier-"+u.substring(1)),d}R.asClassNameArray=P;function g(b){return P(b).join(" ")}R.asClassName=g;function w(b){return"."+P(b).join(".")}R.asCSSSelector=w})(C=e.CSSIcon||(e.CSSIcon={}))}),define(ie[121],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function E(P,g){const w=Math.pow(10,g);return Math.round(P*w)/w}class t{constructor(g,w,b,S=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,g))|0,this.g=Math.min(255,Math.max(0,w))|0,this.b=Math.min(255,Math.max(0,b))|0,this.a=E(Math.max(Math.min(1,S),0),3)}static equals(g,w){return g.r===w.r&&g.g===w.g&&g.b===w.b&&g.a===w.a}}e.RGBA=t;class C{constructor(g,w,b,S){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,g),0)|0,this.s=E(Math.max(Math.min(1,w),0),3),this.l=E(Math.max(Math.min(1,b),0),3),this.a=E(Math.max(Math.min(1,S),0),3)}static equals(g,w){return g.h===w.h&&g.s===w.s&&g.l===w.l&&g.a===w.a}static fromRGBA(g){const w=g.r/255,b=g.g/255,S=g.b/255,y=g.a,u=Math.max(w,b,S),d=Math.min(w,b,S);let v=0,h=0;const l=(d+u)/2,p=u-d;if(p>0){switch(h=Math.min(l<=.5?p/(2*l):p/(2-2*l),1),u){case w:v=(b-S)/p+(b<S?6:0);break;case b:v=(S-w)/p+2;break;case S:v=(w-b)/p+4;break}v*=60,v=Math.round(v)}return new C(v,h,l,y)}static i(g,w,b){return b<0&&(b+=1),b>1&&(b-=1),b<1/6?g+(w-g)*6*b:b<1/2?w:b<2/3?g+(w-g)*(2/3-b)*6:g}static toRGBA(g){const w=g.h/360,{s:b,l:S,a:y}=g;let u,d,v;if(b===0)u=d=v=S;else{const h=S<.5?S*(1+b):S+b-S*b,l=2*S-h;u=C.i(l,h,w+1/3),d=C.i(l,h,w),v=C.i(l,h,w-1/3)}return new t(Math.round(u*255),Math.round(d*255),Math.round(v*255),y)}}e.HSLA=C;class R{constructor(g,w,b,S){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,g),0)|0,this.s=E(Math.max(Math.min(1,w),0),3),this.v=E(Math.max(Math.min(1,b),0),3),this.a=E(Math.max(Math.min(1,S),0),3)}static equals(g,w){return g.h===w.h&&g.s===w.s&&g.v===w.v&&g.a===w.a}static fromRGBA(g){const w=g.r/255,b=g.g/255,S=g.b/255,y=Math.max(w,b,S),u=Math.min(w,b,S),d=y-u,v=y===0?0:d/y;let h;return d===0?h=0:y===w?h=((b-S)/d%6+6)%6:y===b?h=(S-w)/d+2:h=(w-b)/d+4,new R(Math.round(h*60),v,y,g.a)}static toRGBA(g){const{h:w,s:b,v:S,a:y}=g,u=S*b,d=u*(1-Math.abs(w/60%2-1)),v=S-u;let[h,l,p]=[0,0,0];return w<60?(h=u,l=d):w<120?(h=d,l=u):w<180?(l=u,p=d):w<240?(l=d,p=u):w<300?(h=d,p=u):w<=360&&(h=u,p=d),h=Math.round((h+v)*255),l=Math.round((l+v)*255),p=Math.round((p+v)*255),new t(h,l,p,y)}}e.HSVA=R;class A{static fromHex(g){return A.Format.CSS.parseHex(g)||A.red}static equals(g,w){return!g&&!w?!0:!g||!w?!1:g.equals(w)}get hsla(){return this.i?this.i:C.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:R.fromRGBA(this.rgba)}constructor(g){if(g)if(g instanceof t)this.rgba=g;else if(g instanceof C)this.i=g,this.rgba=C.toRGBA(g);else if(g instanceof R)this.j=g,this.rgba=R.toRGBA(g);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(g){return!!g&&t.equals(this.rgba,g.rgba)&&C.equals(this.hsla,g.hsla)&&R.equals(this.hsva,g.hsva)}getRelativeLuminance(){const g=A.k(this.rgba.r),w=A.k(this.rgba.g),b=A.k(this.rgba.b),S=.2126*g+.7152*w+.0722*b;return E(S,4)}static k(g){const w=g/255;return w<=.03928?w/12.92:Math.pow((w+.055)/1.055,2.4)}getContrastRatio(g){const w=this.getRelativeLuminance(),b=g.getRelativeLuminance();return w>b?(w+.05)/(b+.05):(b+.05)/(w+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(g){const w=this.getRelativeLuminance(),b=g.getRelativeLuminance();return w>b}isDarkerThan(g){const w=this.getRelativeLuminance(),b=g.getRelativeLuminance();return w<b}lighten(g){return new A(new C(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*g,this.hsla.a))}darken(g){return new A(new C(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*g,this.hsla.a))}transparent(g){const{r:w,g:b,b:S,a:y}=this.rgba;return new A(new t(w,b,S,y*g))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new A(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(g){const w=g.rgba,b=this.rgba.a,S=w.a,y=b+S*(1-b);if(y<1e-6)return A.transparent;const u=this.rgba.r*b/y+w.r*S*(1-b)/y,d=this.rgba.g*b/y+w.g*S*(1-b)/y,v=this.rgba.b*b/y+w.b*S*(1-b)/y;return new A(new t(u,d,v,y))}makeOpaque(g){if(this.isOpaque()||g.rgba.a!==1)return this;const{r:w,g:b,b:S,a:y}=this.rgba;return new A(new t(g.rgba.r-y*(g.rgba.r-w),g.rgba.g-y*(g.rgba.g-b),g.rgba.b-y*(g.rgba.b-S),1))}flatten(...g){const w=g.reduceRight((b,S)=>A.o(S,b));return A.o(this,w)}static o(g,w){const b=1-g.rgba.a;return new A(new t(b*w.rgba.r+g.rgba.a*g.rgba.r,b*w.rgba.g+g.rgba.a*g.rgba.g,b*w.rgba.b+g.rgba.a*g.rgba.b))}toString(){return this.u||(this.u=A.Format.CSS.format(this)),this.u}static getLighterColor(g,w,b){if(g.isLighterThan(w))return g;b=b||.5;const S=g.getRelativeLuminance(),y=w.getRelativeLuminance();return b=b*(y-S)/y,g.lighten(b)}static getDarkerColor(g,w,b){if(g.isDarkerThan(w))return g;b=b||.5;const S=g.getRelativeLuminance(),y=w.getRelativeLuminance();return b=b*(S-y)/S,g.darken(b)}}e.Color=A,A.white=new A(new t(255,255,255,1)),A.black=new A(new t(0,0,0,1)),A.red=new A(new t(255,0,0,1)),A.blue=new A(new t(0,0,255,1)),A.green=new A(new t(0,255,0,1)),A.cyan=new A(new t(0,255,255,1)),A.lightgrey=new A(new t(211,211,211,1)),A.transparent=new A(new t(0,0,0,0)),function(P){let g;(function(w){let b;(function(S){function y(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:P.Format.CSS.formatRGBA(i)}S.formatRGB=y;function u(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}S.formatRGBA=u;function d(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:P.Format.CSS.formatHSLA(i)}S.formatHSL=d;function v(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}S.formatHSLA=v;function h(i){const r=i.toString(16);return r.length!==2?"0"+r:r}function l(i){return`#${h(i.rgba.r)}${h(i.rgba.g)}${h(i.rgba.b)}`}S.formatHex=l;function p(i,r=!1){return r&&i.rgba.a===1?P.Format.CSS.formatHex(i):`#${h(i.rgba.r)}${h(i.rgba.g)}${h(i.rgba.b)}${h(Math.round(i.rgba.a*255))}`}S.formatHexA=p;function k(i){return i.isOpaque()?P.Format.CSS.formatHex(i):P.Format.CSS.formatRGBA(i)}S.format=k;function I(i){const r=i.length;if(r===0||i.charCodeAt(0)!==35)return null;if(r===7){const n=16*m(i.charCodeAt(1))+m(i.charCodeAt(2)),a=16*m(i.charCodeAt(3))+m(i.charCodeAt(4)),o=16*m(i.charCodeAt(5))+m(i.charCodeAt(6));return new P(new t(n,a,o,1))}if(r===9){const n=16*m(i.charCodeAt(1))+m(i.charCodeAt(2)),a=16*m(i.charCodeAt(3))+m(i.charCodeAt(4)),o=16*m(i.charCodeAt(5))+m(i.charCodeAt(6)),c=16*m(i.charCodeAt(7))+m(i.charCodeAt(8));return new P(new t(n,a,o,c/255))}if(r===4){const n=m(i.charCodeAt(1)),a=m(i.charCodeAt(2)),o=m(i.charCodeAt(3));return new P(new t(16*n+n,16*a+a,16*o+o))}if(r===5){const n=m(i.charCodeAt(1)),a=m(i.charCodeAt(2)),o=m(i.charCodeAt(3)),c=m(i.charCodeAt(4));return new P(new t(16*n+n,16*a+a,16*o+o,(16*c+c)/255))}return null}S.parseHex=I;function m(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(b=w.CSS||(w.CSS={}))})(g=P.Format||(P.Format={}))}(A=e.Color||(e.Color={}))}),define(ie[54],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function E(A){return(P,g,w)=>{let b=null,S=null;if(typeof w.value=="function"?(b="value",S=w.value):typeof w.get=="function"&&(b="get",S=w.get),!S)throw new Error("not supported");w[b]=A(S,g)}}function t(A,P,g){let w=null,b=null;if(typeof g.value=="function"?(w="value",b=g.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(w="get",b=g.get),!b)throw new Error("not supported");const S=`$memoize$${P}`;g[w]=function(...y){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,y)}),this[S]}}e.memoize=t;function C(A,P,g){return E((w,b)=>{const S=`$debounce$${b}`,y=`$debounce$result$${b}`;return function(...u){this[y]||(this[y]=g?g():void 0),clearTimeout(this[S]),P&&(this[y]=P(this[y],...u),u=[this[y]]),this[S]=setTimeout(()=>{w.apply(this,u),this[y]=g?g():void 0},A)}})}e.debounce=C;function R(A,P,g){return E((w,b)=>{const S=`$throttle$timer$${b}`,y=`$throttle$result$${b}`,u=`$throttle$lastRun$${b}`,d=`$throttle$pending$${b}`;return function(...v){if(this[y]||(this[y]=g?g():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),P&&(this[y]=P(this[y],...v)),this[d])return;const h=this[u]+A;h<=Date.now()?(this[u]=Date.now(),w.apply(this,[this[y]]),this[y]=g?g():void 0):(this[d]=!0,this[S]=setTimeout(()=>{this[d]=!1,this[u]=Date.now(),w.apply(this,[this[y]]),this[y]=g?g():void 0},h-Date.now()))}})}e.throttle=R}),define(ie[15],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class E{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?k.isErrorNoTelemetry(i)?new k(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(r=>{r(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.ErrorHandler=E,e.errorHandler=new E;function t(m){e.errorHandler.setUnexpectedErrorHandler(m)}e.setUnexpectedErrorHandler=t;function C(m){g(m)||e.errorHandler.onUnexpectedError(m)}e.onUnexpectedError=C;function R(m){g(m)||e.errorHandler.onUnexpectedExternalError(m)}e.onUnexpectedExternalError=R;function A(m){if(m instanceof Error){const{name:i,message:r}=m,n=m.stacktrace||m.stack;return{$isError:!0,name:i,message:r,stack:n,noTelemetry:k.isErrorNoTelemetry(m)}}return m}e.transformErrorForSerialization=A;const P="Canceled";function g(m){return m instanceof w?!0:m instanceof Error&&m.name===P&&m.message===P}e.isCancellationError=g;class w extends Error{constructor(){super(P),this.name=this.message}}e.CancellationError=w;function b(){const m=new Error(P);return m.name=m.message,m}e.canceled=b;function S(m){return m?new Error(`Illegal argument: ${m}`):new Error("Illegal argument")}e.illegalArgument=S;function y(m){return m?new Error(`Illegal state: ${m}`):new Error("Illegal state")}e.illegalState=y;function u(m){return m?new Error(`readonly property '${m} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=u;function d(m){const i=new Error(`${m} has been disposed`);return i.name="DISPOSED",i}e.disposed=d;function v(m){return m?m.message?m.message:m.stack?m.stack.split(`
`)[0]:String(m):"Error"}e.getErrorMessage=v;class h extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=h;class l extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=l;class p extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=p;class k extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof k)return i;const r=new k;return r.message=i.message,r.stack=i.stack,r}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=k;class I extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,I.prototype);debugger}}e.BugIndicatingError=I}),define(ie[24],re([0,1,15]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(B,Z=0){return B[B.length-(1+Z)]}e.tail=t;function C(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}e.tail2=C;function R(B,Z,te=(ae,ge)=>ae===ge){if(B===Z)return!0;if(!B||!Z||B.length!==Z.length)return!1;for(let ae=0,ge=B.length;ae<ge;ae++)if(!te(B[ae],Z[ae]))return!1;return!0}e.equals=R;function A(B,Z){const te=B.length-1;Z<te&&(B[Z]=B[te]),B.pop()}e.removeFastWithoutKeepingOrder=A;function P(B,Z,te){return g(B.length,ae=>te(B[ae],Z))}e.binarySearch=P;function g(B,Z){let te=0,ae=B-1;for(;te<=ae;){const ge=(te+ae)/2|0,ke=Z(ge);if(ke<0)te=ge+1;else if(ke>0)ae=ge-1;else return ge}return-(te+1)}e.binarySearch2=g;function w(B,Z){let te=0,ae=B.length;if(ae===0)return 0;for(;te<ae;){const ge=Math.floor((te+ae)/2);Z(B[ge])?ae=ge:te=ge+1}return te}e.findFirstInSorted=w;function b(B,Z,te){if(B=B|0,B>=Z.length)throw new TypeError("invalid index");const ae=Z[Math.floor(Z.length*Math.random())],ge=[],ke=[],Oe=[];for(const De of Z){const Re=te(De,ae);Re<0?ge.push(De):Re>0?ke.push(De):Oe.push(De)}return B<ge.length?b(B,ge,te):B<ge.length+Oe.length?Oe[0]:b(B-(ge.length+Oe.length),ke,te)}e.quickSelect=b;function S(B,Z){const te=[];let ae;for(const ge of B.slice(0).sort(Z))!ae||Z(ae[0],ge)!==0?(ae=[ge],te.push(ae)):ae.push(ge);return te}e.groupBy=S;function y(B,Z,te){const ae=[];function ge(De,Re,ve){if(Re===0&&ve.length===0)return;const we=ae[ae.length-1];we&&we.start+we.deleteCount===De?(we.deleteCount+=Re,we.toInsert.push(...ve)):ae.push({start:De,deleteCount:Re,toInsert:ve})}let ke=0,Oe=0;for(;;){if(ke===B.length){ge(ke,0,Z.slice(Oe));break}if(Oe===Z.length){ge(ke,B.length-ke,[]);break}const De=B[ke],Re=Z[Oe],ve=te(De,Re);ve===0?(ke+=1,Oe+=1):ve<0?(ge(ke,1,[]),ke+=1):ve>0&&(ge(ke,0,[Re]),Oe+=1)}return ae}e.sortedDiff=y;function u(B,Z,te){const ae=y(B,Z,te),ge=[],ke=[];for(const Oe of ae)ge.push(...B.slice(Oe.start,Oe.start+Oe.deleteCount)),ke.push(...Oe.toInsert);return{removed:ge,added:ke}}e.delta=u;function d(B,Z,te){if(te===0)return[];const ae=B.slice(0,te).sort(Z);return h(B,Z,ae,te,B.length),ae}e.top=d;function v(B,Z,te,ae,ge){return te===0?Promise.resolve([]):new Promise((ke,Oe)=>{(async()=>{const De=B.length,Re=B.slice(0,te).sort(Z);for(let ve=te,we=Math.min(te+ae,De);ve<De;ve=we,we=Math.min(we+ae,De)){if(ve>te&&await new Promise(ye=>setTimeout(ye)),ge&&ge.isCancellationRequested)throw new E.CancellationError;h(B,Z,Re,ve,we)}return Re})().then(ke,Oe)})}e.topAsync=v;function h(B,Z,te,ae,ge){for(const ke=te.length;ae<ge;ae++){const Oe=B[ae];if(Z(Oe,te[ke-1])<0){te.pop();const De=w(te,Re=>Z(Oe,Re)<0);te.splice(De,0,Oe)}}}function l(B){return B.filter(Z=>!!Z)}e.coalesce=l;function p(B){let Z=0;for(let te=0;te<B.length;te++)B[te]&&(B[Z]=B[te],Z+=1);B.length=Z}e.coalesceInPlace=p;function k(B,Z,te){B.splice(te,0,B.splice(Z,1)[0])}e.move=k;function I(B){return!Array.isArray(B)||B.length===0}e.isFalsyOrEmpty=I;function m(B){return Array.isArray(B)&&B.length>0}e.isNonEmptyArray=m;function i(B,Z=te=>te){const te=new Set;return B.filter(ae=>{const ge=Z(ae);return te.has(ge)?!1:(te.add(ge),!0)})}e.distinct=i;function r(B){const Z=new Set;return te=>{const ae=B(te);return Z.has(ae)?!1:(Z.add(ae),!0)}}e.uniqueFilter=r;function n(B,Z){const te=a(B,Z);if(te!==-1)return B[te]}e.findLast=n;function a(B,Z){for(let te=B.length-1;te>=0;te--){const ae=B[te];if(Z(ae))return te}return-1}e.lastIndex=a;function o(B,Z){return B.length>0?B[0]:Z}e.firstOrDefault=o;function c(B,Z){return B.length>0?B[B.length-1]:Z}e.lastOrDefault=c;function s(B,Z,te=(ae,ge)=>ae===ge){let ae=0;for(let ge=0,ke=Math.min(B.length,Z.length);ge<ke&&te(B[ge],Z[ge]);ge++)ae++;return ae}e.commonPrefixLength=s;function f(B){return[].concat(...B)}e.flatten=f;function M(B,Z){let te=typeof Z=="number"?B:0;typeof Z=="number"?te=B:(te=0,Z=B);const ae=[];if(te<=Z)for(let ge=te;ge<Z;ge++)ae.push(ge);else for(let ge=te;ge>Z;ge--)ae.push(ge);return ae}e.range=M;function L(B,Z,te){return B.reduce((ae,ge)=>(ae[Z(ge)]=te?te(ge):ge,ae),Object.create(null))}e.index=L;function T(B,Z){return B.push(Z),()=>U(B,Z)}e.insert=T;function U(B,Z){const te=B.indexOf(Z);if(te>-1)return B.splice(te,1),Z}e.remove=U;function K(B,Z,te){const ae=B.slice(0,Z),ge=B.slice(Z);return ae.concat(te,ge)}e.arrayInsert=K;function V(B,Z){let te;if(typeof Z=="number"){let ae=Z;te=()=>{const ge=Math.sin(ae++)*179426549;return ge-Math.floor(ge)}}else te=Math.random;for(let ae=B.length-1;ae>0;ae-=1){const ge=Math.floor(te()*(ae+1)),ke=B[ae];B[ae]=B[ge],B[ge]=ke}}e.shuffle=V;function G(B,Z){const te=B.indexOf(Z);te>-1&&(B.splice(te,1),B.unshift(Z))}e.pushToStart=G;function _(B,Z){const te=B.indexOf(Z);te>-1&&(B.splice(te,1),B.push(Z))}e.pushToEnd=_;function se(B,Z){for(const te of Z)B.push(te)}e.pushMany=se;function ce(B,Z){return Array.isArray(B)?B.map(Z):Z(B)}e.mapArrayOrNot=ce;function X(B){return Array.isArray(B)?B:[B]}e.asArray=X;function ue(B){return B[Math.floor(Math.random()*B.length)]}e.getRandomElement=ue;function z(B,Z){for(const te of B){const ae=Z(te);if(ae!==void 0)return ae}}e.mapFind=z;function N(B,Z,te){const ae=q(B,Z),ge=B.length,ke=te.length;B.length=ge+ke;for(let Oe=ge-1;Oe>=ae;Oe--)B[Oe+ke]=B[Oe];for(let Oe=0;Oe<ke;Oe++)B[Oe+ae]=te[Oe]}e.insertInto=N;function F(B,Z,te,ae){const ge=q(B,Z),ke=B.splice(ge,te);return N(B,ge,ae),ke}e.splice=F;function q(B,Z){return Z<0?Math.max(Z+B.length,0):Math.min(Z,B.length)}var Q;(function(B){function Z(ge){return ge<0}B.isLessThan=Z;function te(ge){return ge>0}B.isGreaterThan=te;function ae(ge){return ge===0}B.isNeitherLessOrGreaterThan=ae,B.greaterThan=1,B.lessThan=-1,B.neitherLessOrGreaterThan=0})(Q=e.CompareResult||(e.CompareResult={}));function oe(B,Z){return(te,ae)=>Z(B(te),B(ae))}e.compareBy=oe;function x(...B){return(Z,te)=>{for(const ae of B){const ge=ae(Z,te);if(!Q.isNeitherLessOrGreaterThan(ge))return ge}return Q.neitherLessOrGreaterThan}}e.tieBreakComparators=x;const D=(B,Z)=>B-Z;e.numberComparator=D;function O(B,Z){if(B.length===0)return;let te=B[0];for(let ae=1;ae<B.length;ae++){const ge=B[ae];Z(ge,te)>0&&(te=ge)}return te}e.findMaxBy=O;function W(B,Z){if(B.length===0)return;let te=B[0];for(let ae=1;ae<B.length;ae++){const ge=B[ae];Z(ge,te)>=0&&(te=ge)}return te}e.findLastMaxBy=W;function j(B,Z){return O(B,(te,ae)=>-Z(te,ae))}e.findMinBy=j;class ${constructor(Z){this.f=Z,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(Z){let te=this.c;for(;te<this.f.length&&Z(this.f[te]);)te++;const ae=te===this.c?null:this.f.slice(this.c,te);return this.c=te,ae}takeFromEndWhile(Z){let te=this.d;for(;te>=0&&Z(this.f[te]);)te--;const ae=te===this.d?null:this.f.slice(te+1,this.d+1);return this.d=te,ae}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const Z=this.f[this.c];return this.c++,Z}removeLast(){const Z=this.f[this.d];return this.d--,Z}takeCount(Z){const te=this.f.slice(this.c,this.c+Z);return this.c+=Z,te}}e.ArrayQueue=$;class Y{constructor(Z){this.iterate=Z}forEach(Z){this.iterate(te=>(Z(te),!0))}toArray(){const Z=[];return this.iterate(te=>(Z.push(te),!0)),Z}filter(Z){return new Y(te=>this.iterate(ae=>Z(ae)?te(ae):!0))}map(Z){return new Y(te=>this.iterate(ae=>te(Z(ae))))}some(Z){let te=!1;return this.iterate(ae=>(te=Z(ae),!te)),te}findFirst(Z){let te;return this.iterate(ae=>Z(ae)?(te=ae,!1):!0),te}findLast(Z){let te;return this.iterate(ae=>(Z(ae)&&(te=ae),!0)),te}findLastMaxBy(Z){let te,ae=!0;return this.iterate(ge=>((ae||Q.isGreaterThan(Z(ge,te)))&&(ae=!1,te=ge),!0)),te}}e.CallbackIterable=Y,Y.empty=new Y(B=>{})}),define(ie[122],re([0,1,15]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(g,w){if(!g)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=t;function C(g,w="Unreachable"){throw new Error(w)}e.assertNever=C;function R(g){if(!g)throw new E.BugIndicatingError("Assertion Failed")}e.assert=R;function A(g){if(!g()){debugger;g(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}e.assertFn=A;function P(g,w){let b=0;for(;b<g.length-1;){const S=g[b],y=g[b+1];if(!w(S,y))return!1;b++}return!0}e.checkAdjacentItems=P}),define(ie[50],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function E(t){const C=this;let R=!1,A;return function(){return R||(R=!0,A=t.apply(C,arguments)),A}}e.once=E}),define(ie[67],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(t){function C(I){return I&&typeof I=="object"&&typeof I[Symbol.iterator]=="function"}t.is=C;const R=Object.freeze([]);function A(){return R}t.empty=A;function*P(I){yield I}t.single=P;function g(I){return C(I)?I:P(I)}t.wrap=g;function w(I){return I||R}t.from=w;function b(I){return!I||I[Symbol.iterator]().next().done===!0}t.isEmpty=b;function S(I){return I[Symbol.iterator]().next().value}t.first=S;function y(I,m){for(const i of I)if(m(i))return!0;return!1}t.some=y;function u(I,m){for(const i of I)if(m(i))return i}t.find=u;function*d(I,m){for(const i of I)m(i)&&(yield i)}t.filter=d;function*v(I,m){let i=0;for(const r of I)yield m(r,i++)}t.map=v;function*h(...I){for(const m of I)for(const i of m)yield i}t.concat=h;function l(I,m,i){let r=i;for(const n of I)r=m(r,n);return r}t.reduce=l;function*p(I,m,i=I.length){for(m<0&&(m+=I.length),i<0?i+=I.length:i>I.length&&(i=I.length);m<i;m++)yield I[m]}t.slice=p;function k(I,m=Number.POSITIVE_INFINITY){const i=[];if(m===0)return[i,I];const r=I[Symbol.iterator]();for(let n=0;n<m;n++){const a=r.next();if(a.done)return[i,t.empty()];i.push(a.value)}return[i,{[Symbol.iterator](){return r}}]}t.consume=k})(E=e.Iterable||(e.Iterable={}))}),define(ie[43],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(E=e.ScanError||(e.ScanError={}));var t;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var C;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(C=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(i){i.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function A(i,r=!1){let n=0;const a=i.length;let o="",c=0,s=16,f=0;function M(_){let se=0,ce=0;for(;se<_;){const X=i.charCodeAt(n);if(X>=48&&X<=57)ce=ce*16+X-48;else if(X>=65&&X<=70)ce=ce*16+X-65+10;else if(X>=97&&X<=102)ce=ce*16+X-97+10;else break;n++,se++}return se<_&&(ce=-1),ce}function L(_){n=_,o="",c=0,s=16,f=0}function T(){const _=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&w(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&w(i.charCodeAt(n)))for(n++;n<i.length&&w(i.charCodeAt(n));)n++;else return f=3,i.substring(_,n);let se=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&w(i.charCodeAt(n))){for(n++;n<i.length&&w(i.charCodeAt(n));)n++;se=n}else f=3;return i.substring(_,se)}function U(){let _="",se=n;for(;;){if(n>=a){_+=i.substring(se,n),f=2;break}const ce=i.charCodeAt(n);if(ce===34){_+=i.substring(se,n),n++;break}if(ce===92){if(_+=i.substring(se,n),n++,n>=a){f=2;break}switch(i.charCodeAt(n++)){case 34:_+='"';break;case 92:_+="\\";break;case 47:_+="/";break;case 98:_+="\b";break;case 102:_+="\f";break;case 110:_+=`
`;break;case 114:_+="\r";break;case 116:_+="	";break;case 117:{const ue=M(4);ue>=0?_+=String.fromCharCode(ue):f=4;break}default:f=5}se=n;continue}if(ce>=0&&ce<=31)if(g(ce)){_+=i.substring(se,n),f=2;break}else f=6;n++}return _}function K(){if(o="",f=0,c=n,n>=a)return c=a,s=17;let _=i.charCodeAt(n);if(P(_)){do n++,o+=String.fromCharCode(_),_=i.charCodeAt(n);while(P(_));return s=15}if(g(_))return n++,o+=String.fromCharCode(_),_===13&&i.charCodeAt(n)===10&&(n++,o+=`
`),s=14;switch(_){case 123:return n++,s=1;case 125:return n++,s=2;case 91:return n++,s=3;case 93:return n++,s=4;case 58:return n++,s=6;case 44:return n++,s=5;case 34:return n++,o=U(),s=10;case 47:{const se=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<a&&!g(i.charCodeAt(n));)n++;return o=i.substring(se,n),s=12}if(i.charCodeAt(n+1)===42){n+=2;const ce=a-1;let X=!1;for(;n<ce;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,X=!0;break}n++}return X||(n++,f=1),o=i.substring(se,n),s=13}return o+=String.fromCharCode(_),n++,s=16}case 45:if(o+=String.fromCharCode(_),n++,n===a||!w(i.charCodeAt(n)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=T(),s=11;default:for(;n<a&&V(_);)n++,_=i.charCodeAt(n);if(c!==n){switch(o=i.substring(c,n),o){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return o+=String.fromCharCode(_),n++,s=16}}function V(_){if(P(_)||g(_))return!1;switch(_){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function G(){let _;do _=K();while(_>=12&&_<=15);return _}return{setPosition:L,getPosition:()=>n,scan:r?G:K,getToken:()=>s,getTokenValue:()=>o,getTokenOffset:()=>c,getTokenLength:()=>n-c,getTokenError:()=>f}}e.createScanner=A;function P(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function g(i){return i===10||i===13||i===8232||i===8233}function w(i){return i>=48&&i<=57}var b;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(b||(b={}));function S(i,r){const n=[],a=new Object;let o;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function f(M,L,T,U){c.value=M,c.offset=L,c.length=T,c.type=U,c.colonOffset=void 0,o=c}try{k(i,{onObjectBegin:(M,L)=>{if(r<=M)throw a;o=void 0,s=r>M,n.push("")},onObjectProperty:(M,L,T)=>{if(r<L||(f(M,L,T,"property"),n[n.length-1]=M,r<=L+T))throw a},onObjectEnd:(M,L)=>{if(r<=M)throw a;o=void 0,n.pop()},onArrayBegin:(M,L)=>{if(r<=M)throw a;o=void 0,n.push(0)},onArrayEnd:(M,L)=>{if(r<=M)throw a;o=void 0,n.pop()},onLiteralValue:(M,L,T)=>{if(r<L||(f(M,L,T,m(M)),r<=L+T))throw a},onSeparator:(M,L,T)=>{if(r<=L)throw a;if(M===":"&&o&&o.type==="property")o.colonOffset=L,s=!1,o=void 0;else if(M===","){const U=n[n.length-1];typeof U=="number"?n[n.length-1]=U+1:(s=!0,n[n.length-1]=""),o=void 0}}})}catch(M){if(M!==a)throw M}return{path:n,previousNode:o,isAtPropertyKey:s,matches:M=>{let L=0;for(let T=0;L<M.length&&T<n.length;T++)if(M[L]===n[T]||M[L]==="*")L++;else if(M[L]!=="**")return!1;return L===M.length}}}e.getLocation=S;function y(i,r=[],n=R.DEFAULT){let a=null,o=[];const c=[];function s(M){Array.isArray(o)?o.push(M):a!==null&&(o[a]=M)}return k(i,{onObjectBegin:()=>{const M={};s(M),c.push(o),o=M,a=null},onObjectProperty:M=>{a=M},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const M=[];s(M),c.push(o),o=M,a=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:s,onError:(M,L,T)=>{r.push({error:M,offset:L,length:T})}},n),o[0]}e.parse=y;function u(i,r=[],n=R.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(M){a.type==="property"&&(a.length=M-a.offset,a=a.parent)}function c(M){return a.children.push(M),M}k(i,{onObjectBegin:M=>{a=c({type:"object",offset:M,length:-1,parent:a,children:[]})},onObjectProperty:(M,L,T)=>{a=c({type:"property",offset:L,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:M,offset:L,length:T,parent:a})},onObjectEnd:(M,L)=>{a.length=M+L-a.offset,a=a.parent,o(M+L)},onArrayBegin:(M,L)=>{a=c({type:"array",offset:M,length:-1,parent:a,children:[]})},onArrayEnd:(M,L)=>{a.length=M+L-a.offset,a=a.parent,o(M+L)},onLiteralValue:(M,L,T)=>{c({type:m(M),offset:L,length:T,parent:a,value:M}),o(L+T)},onSeparator:(M,L,T)=>{a.type==="property"&&(M===":"?a.colonOffset=L:M===","&&o(L))},onError:(M,L,T)=>{r.push({error:M,offset:L,length:T})}},n);const f=a.children[0];return f&&delete f.parent,f}e.parseTree=u;function d(i,r){if(!i)return;let n=i;for(const a of r)if(typeof a=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let o=!1;for(const c of n.children)if(Array.isArray(c.children)&&c.children[0].value===a){n=c.children[1],o=!0;break}if(!o)return}else{const o=a;if(n.type!=="array"||o<0||!Array.isArray(n.children)||o>=n.children.length)return;n=n.children[o]}return n}e.findNodeAtLocation=d;function v(i){if(!i.parent||!i.parent.children)return[];const r=v(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;r.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&r.push(n)}return r}e.getNodePath=v;function h(i){switch(i.type){case"array":return i.children.map(h);case"object":{const r=Object.create(null);for(const n of i.children){const a=n.children[1];a&&(r[n.children[0].value]=h(a))}return r}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=h;function l(i,r,n=!1){return r>=i.offset&&r<i.offset+i.length||n&&r===i.offset+i.length}e.contains=l;function p(i,r,n=!1){if(l(i,r,n)){const a=i.children;if(Array.isArray(a))for(let o=0;o<a.length&&a[o].offset<=r;o++){const c=p(a[o],r,n);if(c)return c}return i}}e.findNodeAtOffset=p;function k(i,r,n=R.DEFAULT){const a=A(i,!1);function o(oe){return oe?()=>oe(a.getTokenOffset(),a.getTokenLength()):()=>!0}function c(oe){return oe?x=>oe(x,a.getTokenOffset(),a.getTokenLength()):()=>!0}const s=o(r.onObjectBegin),f=c(r.onObjectProperty),M=o(r.onObjectEnd),L=o(r.onArrayBegin),T=o(r.onArrayEnd),U=c(r.onLiteralValue),K=c(r.onSeparator),V=o(r.onComment),G=c(r.onError),_=n&&n.disallowComments,se=n&&n.allowTrailingComma;function ce(){for(;;){const oe=a.scan();switch(a.getTokenError()){case 4:X(14);break;case 5:X(15);break;case 3:X(13);break;case 1:_||X(11);break;case 2:X(12);break;case 6:X(16);break}switch(oe){case 12:case 13:_?X(10):V();break;case 16:X(1);break;case 15:case 14:break;default:return oe}}}function X(oe,x=[],D=[]){if(G(oe),x.length+D.length>0){let O=a.getToken();for(;O!==17;){if(x.indexOf(O)!==-1){ce();break}else if(D.indexOf(O)!==-1)break;O=ce()}}}function ue(oe){const x=a.getTokenValue();return oe?U(x):f(x),ce(),!0}function z(){switch(a.getToken()){case 11:{let oe=0;try{oe=JSON.parse(a.getTokenValue()),typeof oe!="number"&&(X(2),oe=0)}catch{X(2)}U(oe);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return ce(),!0}function N(){return a.getToken()!==10?(X(3,[],[2,5]),!1):(ue(!1),a.getToken()===6?(K(":"),ce(),Q()||X(4,[],[2,5])):X(5,[],[2,5]),!0)}function F(){s(),ce();let oe=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(oe||X(4,[],[]),K(","),ce(),a.getToken()===2&&se)break}else oe&&X(6,[],[]);N()||X(4,[],[2,5]),oe=!0}return M(),a.getToken()!==2?X(7,[2],[]):ce(),!0}function q(){L(),ce();let oe=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(oe||X(4,[],[]),K(","),ce(),a.getToken()===4&&se)break}else oe&&X(6,[],[]);Q()||X(4,[],[4,5]),oe=!0}return T(),a.getToken()!==4?X(8,[4],[]):ce(),!0}function Q(){switch(a.getToken()){case 3:return q();case 1:return F();case 10:return ue(!0);default:return z()}}return ce(),a.getToken()===17?n.allowEmptyContent?!0:(X(4,[],[]),!1):Q()?(a.getToken()!==17&&X(9,[],[]),!0):(X(4,[],[]),!1)}e.visit=k;function I(i,r){const n=A(i),a=[];let o,c=0,s;do switch(s=n.getPosition(),o=n.scan(),o){case 12:case 13:case 17:c!==s&&a.push(i.substring(c,s)),r!==void 0&&a.push(n.getTokenValue().replace(/[^\r\n]/g,r)),c=n.getPosition();break}while(o!==17);return a.join("")}e.stripComments=I;function m(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=m}),define(ie[123],re([0,1,43]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(w,b,S){let y,u,d,v,h;if(b){for(v=b.offset,h=v+b.length,d=v;d>0&&!g(w,d-1);)d--;let s=h;for(;s<w.length&&!g(w,s);)s++;u=w.substring(d,s),y=A(u,S)}else u=w,y=0,d=0,v=0,h=w.length;const l=P(S,w);let p=!1,k=0,I;S.insertSpaces?I=R(" ",S.tabSize||4):I="	";const m=(0,E.createScanner)(u,!1);let i=!1;function r(){return l+R(I,y+k)}function n(){let s=m.scan();for(p=!1;s===15||s===14;)p=p||s===14,s=m.scan();return i=s===16||m.getTokenError()!==0,s}const a=[];function o(s,f,M){!i&&f<h&&M>v&&w.substring(f,M)!==s&&a.push({offset:f,length:M-f,content:s})}let c=n();if(c!==17){const s=m.getTokenOffset()+d,f=R(I,y);o(f,d,s)}for(;c!==17;){let s=m.getTokenOffset()+m.getTokenLength()+d,f=n(),M="";for(;!p&&(f===12||f===13);){const T=m.getTokenOffset()+d;o(" ",s,T),s=m.getTokenOffset()+m.getTokenLength()+d,M=f===12?r():"",f=n()}if(f===2)c!==1&&(k--,M=r());else if(f===4)c!==3&&(k--,M=r());else{switch(c){case 3:case 1:k++,M=r();break;case 5:case 12:M=r();break;case 13:p?M=r():M=" ";break;case 6:M=" ";break;case 10:if(f===6){M="";break}case 7:case 8:case 9:case 11:case 2:case 4:f===12||f===13?M=" ":f!==5&&f!==17&&(i=!0);break;case 16:i=!0;break}p&&(f===12||f===13)&&(M=r())}const L=m.getTokenOffset()+d;o(M,s,L),c=f}return a}e.format=t;function C(w,b){const S=JSON.stringify(w,void 0,b.insertSpaces?b.tabSize||4:"	");return b.eol!==void 0?S.replace(/\r\n|\r|\n/g,b.eol):S}e.toFormattedString=C;function R(w,b){let S="";for(let y=0;y<b;y++)S+=w;return S}function A(w,b){let S=0,y=0;const u=b.tabSize||4;for(;S<w.length;){const d=w.charAt(S);if(d===" ")y++;else if(d==="	")y+=u;else break;S++}return Math.floor(y/u)}function P(w,b){for(let S=0;S<b.length;S++){const y=b.charAt(S);if(y==="\r")return S+1<b.length&&b.charAt(S+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return w&&w.eol||`
`}e.getEOL=P;function g(w,b){return`\r
`.indexOf(w.charAt(b))!==-1}e.isEOL=g}),define(ie[124],re([0,1,43,123]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function C(w,b,S){return R(w,b,void 0,S)}e.removeProperty=C;function R(w,b,S,y,u){const d=b.slice(),v=[],h=(0,E.parseTree)(w,v);let l,p;for(;d.length>0&&(p=d.pop(),l=(0,E.findNodeAtLocation)(h,d),l===void 0&&S!==void 0);)typeof p=="string"?S={[p]:S}:S=[S];if(l)if(l.type==="object"&&typeof p=="string"&&Array.isArray(l.children)){const k=(0,E.findNodeAtLocation)(l,[p]);if(k!==void 0)if(S===void 0){if(!k.parent)throw new Error("Malformed AST");const I=l.children.indexOf(k.parent);let m,i=k.parent.offset+k.parent.length;if(I>0){const r=l.children[I-1];m=r.offset+r.length}else m=l.offset+1,l.children.length>1&&(i=l.children[1].offset);return A(w,{offset:m,length:i-m,content:""},y)}else return A(w,{offset:k.offset,length:k.length,content:JSON.stringify(S)},y);else{if(S===void 0)return[];const I=`${JSON.stringify(p)}: ${JSON.stringify(S)}`,m=u?u(l.children.map(r=>r.children[0].value)):l.children.length;let i;if(m>0){const r=l.children[m-1];i={offset:r.offset+r.length,length:0,content:","+I}}else l.children.length===0?i={offset:l.offset+1,length:0,content:I}:i={offset:l.offset+1,length:0,content:I+","};return A(w,i,y)}}else if(l.type==="array"&&typeof p=="number"&&Array.isArray(l.children))if(S!==void 0){const k=`${JSON.stringify(S)}`;let I;if(l.children.length===0||p===0)I={offset:l.offset+1,length:0,content:l.children.length===0?k:k+","};else{const m=p===-1||p>l.children.length?l.children.length:p,i=l.children[m-1];I={offset:i.offset+i.length,length:0,content:","+k}}return A(w,I,y)}else{const k=p,I=l.children[k];let m;if(l.children.length===1)m={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===k){const i=l.children[k-1],r=i.offset+i.length,n=l.offset+l.length;m={offset:r,length:n-2-r,content:""}}else m={offset:I.offset,length:l.children[k+1].offset-I.offset,content:""};return A(w,m,y)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${l.type}`);else{if(S===void 0)throw new Error("Can not delete in empty document");return A(w,{offset:h?h.offset:0,length:h?h.length:0,content:JSON.stringify(S)},y)}}e.setProperty=R;function A(w,b,S){let y=P(w,b),u=b.offset,d=b.offset+b.content.length;if(b.length===0||b.content.length===0){for(;u>0&&!(0,t.isEOL)(y,u-1);)u--;for(;d<y.length&&!(0,t.isEOL)(y,d);)d++}const v=(0,t.format)(y,{offset:u,length:d-u},S);for(let l=v.length-1;l>=0;l--){const p=v[l];y=P(y,p),u=Math.min(u,p.offset),d=Math.max(d,p.offset+p.length),d+=p.content.length-p.length}const h=w.length-(y.length-d)-u;return[{offset:u,length:h,content:y.substring(u,d)}]}e.withFormatting=A;function P(w,b){return w.substring(0,b.offset)+b.content+w.substring(b.offset+b.length)}e.applyEdit=P;function g(w,b){const S=b.slice(0).sort((u,d)=>{const v=u.offset-d.offset;return v===0?u.length-d.length:v});let y=w.length;for(let u=S.length-1;u>=0;u--){const d=S[u];if(d.offset+d.length<=y)w=P(w,d);else throw new Error("Overlapping edit");y=d.offset}return w}e.applyEdits=g}),define(ie[125],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class E{constructor(C){this.d=C,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(C){this.c=C}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(C){return new E(()=>C(this.getValue()))}}e.Lazy=E}),define(ie[2],re([0,1,50,67]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const C=!1;let R=null;function A(c){R=c}if(e.setDisposableTracker=A,C){const c="__is_disposable_tracked__";A(new class{trackDisposable(s){const f=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[c]||console.log(f)},3e3)}setParent(s,f){if(s&&s!==p.None)try{s[c]=!0}catch{}}markAsDisposed(s){if(s&&s!==p.None)try{s[c]=!0}catch{}}markAsSingleton(s){}})}function P(c){return R?.trackDisposable(c),c}function g(c){R?.markAsDisposed(c)}function w(c,s){R?.setParent(c,s)}function b(c,s){if(!!R)for(const f of c)R.setParent(f,s)}function S(c){return R?.markAsSingleton(c),c}e.markAsSingleton=S;function y(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=y;function u(c){if(t.Iterable.is(c)){const s=[];for(const f of c)if(f)try{f.dispose()}catch(M){s.push(M)}if(s.length===1)throw s[0];if(s.length>1)throw new AggregateError(s,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.dispose=u;function d(c){for(const s of c)y(s)&&s.dispose();return[]}e.disposeIfDisposable=d;function v(...c){const s=h(()=>u(c));return b(c,s),s}e.combinedDisposable=v;function h(c){const s=P({dispose:(0,E.once)(()=>{g(s),c()})});return s}e.toDisposable=h;class l{constructor(){this.c=new Set,this.f=!1,P(this)}dispose(){this.f||(g(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{u(this.c)}finally{this.c.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return w(s,this),this.f?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(s),s}}e.DisposableStore=l,l.DISABLE_DISPOSED_WARNING=!1;class p{constructor(){this.q=new l,P(this),w(this.q,this)}dispose(){g(this),this.q.dispose()}B(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(s)}}e.Disposable=p,p.None=Object.freeze({dispose(){}});class k{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(s){this.b||s===this.a||(this.a?.dispose(),s&&w(s,this),this.a=s)}clear(){this.value=void 0}dispose(){this.b=!0,g(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const s=this.a;return this.a=void 0,s&&w(s,null),s}}e.MutableDisposable=k;class I{constructor(s){this.b=s,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=I;class m{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(s){let f=s;return this.unset=()=>f=void 0,this.isset=()=>f!==void 0,this.dispose=()=>{f&&(f(),f=void 0,g(this))},this}}e.SafeDisposable=m;class i{constructor(){this.a=new Map}acquire(s,...f){let M=this.a.get(s);M||(M={counter:0,object:this.b(s,...f)},this.a.set(s,M));const{object:L}=M,T=(0,E.once)(()=>{--M.counter===0&&(this.c(s,M.object),this.a.delete(s))});return M.counter++,{object:L,dispose:T}}}e.ReferenceCollection=i;class r{constructor(s){this.a=s}async acquire(s,...f){const M=this.a.acquire(s,...f);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(L){throw M.dispose(),L}}}e.AsyncReferenceCollection=r;class n{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=n;function a(c){const s=new l;try{c(s)}finally{s.dispose()}}e.disposeOnReturn=a;class o{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){g(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{u(this.a.values())}finally{this.a.clear()}}has(s){return this.a.has(s)}get(s){return this.a.get(s)}set(s,f,M=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this.a.get(s)?.dispose(),this.a.set(s,f)}deleteAndDispose(s){this.a.get(s)?.dispose(),this.a.delete(s)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=o}),define(ie[96],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class E{constructor(R){this.element=R,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class t{constructor(){this.a=E.Undefined,this.b=E.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===E.Undefined}clear(){let R=this.a;for(;R!==E.Undefined;){const A=R.next;R.prev=E.Undefined,R.next=E.Undefined,R=A}this.a=E.Undefined,this.b=E.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,A){const P=new E(R);if(this.a===E.Undefined)this.a=P,this.b=P;else if(A){const w=this.b;this.b=P,P.prev=w,w.next=P}else{const w=this.a;this.a=P,P.next=w,w.prev=P}this.c+=1;let g=!1;return()=>{g||(g=!0,this.e(P))}}shift(){if(this.a!==E.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==E.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==E.Undefined&&R.next!==E.Undefined){const A=R.prev;A.next=R.next,R.next.prev=A}else R.prev===E.Undefined&&R.next===E.Undefined?(this.a=E.Undefined,this.b=E.Undefined):R.next===E.Undefined?(this.b=this.b.prev,this.b.next=E.Undefined):R.prev===E.Undefined&&(this.a=this.a.next,this.a.prev=E.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==E.Undefined;)yield R.element,R=R.next}}e.LinkedList=t}),define(ie[39],re([0,1]),function(H,e){"use strict";var E,t,C;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function R(d,v,h){let l=d.get(v);return l===void 0&&(l=h,d.set(v,l)),l}e.getOrSet=R;function A(d){const v=[];return d.forEach((h,l)=>{v.push(`${l} => ${h}`)}),`Map(${d.size}) {${v.join(", ")}}`}e.mapToString=A;function P(d){const v=[];return d.forEach(h=>{v.push(h)}),`Set(${d.size}) {${v.join(", ")}}`}e.setToString=P;class g{constructor(v,h){this.uri=v,this.value=h}}class w{constructor(v,h){this[E]="ResourceMap",v instanceof w?(this.b=new Map(v.b),this.c=h??w.a):(this.b=new Map,this.c=v??w.a)}set(v,h){return this.b.set(this.c(v),new g(v,h)),this}get(v){return this.b.get(this.c(v))?.value}has(v){return this.b.has(this.c(v))}get size(){return this.b.size}clear(){this.b.clear()}delete(v){return this.b.delete(this.c(v))}forEach(v,h){typeof h<"u"&&(v=v.bind(h));for(const[l,p]of this.b)v(p.value,p.uri,this)}*values(){for(const v of this.b.values())yield v.value}*keys(){for(const v of this.b.values())yield v.uri}*entries(){for(const v of this.b.values())yield[v.uri,v.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,v]of this.b)yield[v.uri,v.value]}}e.ResourceMap=w,w.a=d=>d.toString();class b{constructor(v,h){this[t]="ResourceSet",!v||typeof v=="function"?this.a=new w(v):(this.a=new w(h),v.forEach(this.add,this))}get size(){return this.a.size}add(v){return this.a.set(v,v),this}clear(){this.a.clear()}delete(v){return this.a.delete(v)}forEach(v,h){this.a.forEach((l,p)=>v.call(h,p,p,this))}has(v){return this.a.has(v)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=b;var S;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(S=e.Touch||(e.Touch={}));class y{constructor(){this[C]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(v){return this.a.has(v)}get(v,h=0){const l=this.a.get(v);if(!!l)return h!==0&&this.j(l,h),l.value}set(v,h,l=0){let p=this.a.get(v);if(p)p.value=h,l!==0&&this.j(p,l);else{switch(p={key:v,value:h,next:void 0,previous:void 0},l){case 0:this.h(p);break;case 1:this.g(p);break;case 2:this.h(p);break;default:this.h(p);break}this.a.set(v,p),this.d++}return this}delete(v){return!!this.remove(v)}remove(v){const h=this.a.get(v);if(!!h)return this.a.delete(v),this.i(h),this.d--,h.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const v=this.b;return this.a.delete(v.key),this.i(v),this.d--,v.value}forEach(v,h){const l=this.e;let p=this.b;for(;p;){if(h?v.bind(h)(p.value,p.key,this):v(p.value,p.key,this),this.e!==l)throw new Error("LinkedMap got modified during iteration.");p=p.next}}keys(){const v=this,h=this.e;let l=this.b;const p={[Symbol.iterator](){return p},next(){if(v.e!==h)throw new Error("LinkedMap got modified during iteration.");if(l){const k={value:l.key,done:!1};return l=l.next,k}else return{value:void 0,done:!0}}};return p}values(){const v=this,h=this.e;let l=this.b;const p={[Symbol.iterator](){return p},next(){if(v.e!==h)throw new Error("LinkedMap got modified during iteration.");if(l){const k={value:l.value,done:!1};return l=l.next,k}else return{value:void 0,done:!0}}};return p}entries(){const v=this,h=this.e;let l=this.b;const p={[Symbol.iterator](){return p},next(){if(v.e!==h)throw new Error("LinkedMap got modified during iteration.");if(l){const k={value:[l.key,l.value],done:!1};return l=l.next,k}else return{value:void 0,done:!0}}};return p}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(v){if(v>=this.size)return;if(v===0){this.clear();return}let h=this.b,l=this.size;for(;h&&l>v;)this.a.delete(h.key),h=h.next,l--;this.b=h,this.d=l,h&&(h.previous=void 0),this.e++}g(v){if(!this.b&&!this.c)this.c=v;else if(this.b)v.next=this.b,this.b.previous=v;else throw new Error("Invalid list");this.b=v,this.e++}h(v){if(!this.b&&!this.c)this.b=v;else if(this.c)v.previous=this.c,this.c.next=v;else throw new Error("Invalid list");this.c=v,this.e++}i(v){if(v===this.b&&v===this.c)this.b=void 0,this.c=void 0;else if(v===this.b){if(!v.next)throw new Error("Invalid list");v.next.previous=void 0,this.b=v.next}else if(v===this.c){if(!v.previous)throw new Error("Invalid list");v.previous.next=void 0,this.c=v.previous}else{const h=v.next,l=v.previous;if(!h||!l)throw new Error("Invalid list");h.previous=l,l.next=h}v.next=void 0,v.previous=void 0,this.e++}j(v,h){if(!this.b||!this.c)throw new Error("Invalid list");if(!(h!==1&&h!==2)){if(h===1){if(v===this.b)return;const l=v.next,p=v.previous;v===this.c?(p.next=void 0,this.c=p):(l.previous=p,p.next=l),v.previous=void 0,v.next=this.b,this.b.previous=v,this.b=v,this.e++}else if(h===2){if(v===this.c)return;const l=v.next,p=v.previous;v===this.b?(l.previous=void 0,this.b=l):(l.previous=p,p.next=l),v.next=void 0,v.previous=this.c,this.c.next=v,this.c=v,this.e++}}}toJSON(){const v=[];return this.forEach((h,l)=>{v.push([l,h])}),v}fromJSON(v){this.clear();for(const[h,l]of v)this.set(h,l)}}e.LinkedMap=y;class u extends y{constructor(v,h=1){super(),this.k=v,this.l=Math.min(Math.max(0,h),1)}get limit(){return this.k}set limit(v){this.k=v,this.m()}get ratio(){return this.l}set ratio(v){this.l=Math.min(Math.max(0,v),1),this.m()}get(v,h=2){return super.get(v,h)}peek(v){return super.get(v,0)}set(v,h){return super.set(v,h,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=u}),define(ie[77],re([0,1,39]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new E.LRUCache(1e4);function C(w){return g(w,"NFC",t)}e.normalizeNFC=C;const R=new E.LRUCache(1e4);function A(w){return g(w,"NFD",R)}e.normalizeNFD=A;const P=/[^\u0000-\u0080]/;function g(w,b,S){if(!w)return w;const y=S.get(w);if(y)return y;let u;return P.test(w)?u=w.normalize(b):u=w,S.set(w,u),u}e.removeAccents=function(){const w=/[\u0300-\u036f]/g;return function(b){return A(b).replace(w,"")}}()}),define(ie[126],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function E(P,g,w){return Math.min(Math.max(P,g),w)}e.clamp=E;function t(P,g){return(g+P%g)%g}e.rot=t;class C{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=C;class R{constructor(){this.a=1,this.b=0}update(g){return this.b=this.b+(g-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=R;class A{constructor(g){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(g),this.c.fill(0,0,g)}update(g){const w=this.c[this.d];return this.c[this.d]=g,this.d=(this.d+1)%this.c.length,this.e-=w,this.e+=g,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=A}),function(){function H(C){const R=[];typeof C=="number"&&R.push("code/timeOrigin",C);function A(g){R.push(g,Date.now())}function P(){const g=[];for(let w=0;w<R.length;w+=2)g.push({name:R[w],startTime:R[w+1]});return g}return{mark:A,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?H():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const A of performance.getEntriesByType("mark"))R.push({name:A.name,startTime:Math.round(C+A.startTime)});return R}};if(typeof process=="object"){const C=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return H(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),H()}function E(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=E(t))}(),function(H,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var t in E)(typeof exports=="object"?exports:H)[t]=E[t]}}(typeof self<"u"?self:this,function(){return function(H){var e={};function E(t){if(e[t])return e[t].exports;var C=e[t]={i:t,l:!1,exports:{}};return H[t].call(C.exports,C,C.exports,E),C.l=!0,C.exports}return E.m=H,E.c=e,E.d=function(t,C,R){E.o(t,C)||Object.defineProperty(t,C,{enumerable:!0,get:R})},E.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},E.t=function(t,C){if(1&C&&(t=E(t)),8&C||4&C&&typeof t=="object"&&t&&t.__esModule)return t;var R=Object.create(null);if(E.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:t}),2&C&&typeof t!="string")for(var A in t)E.d(R,A,function(P){return t[P]}.bind(null,A));return R},E.n=function(t){var C=t&&t.__esModule?function(){return t.default}:function(){return t};return E.d(C,"a",C),C},E.o=function(t,C){return Object.prototype.hasOwnProperty.call(t,C)},E.p="",E(E.s=0)}([function(H,e,E){(function(t){var C;e=H.exports=D,C=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var ne=Array.prototype.slice.call(arguments,0);ne.unshift("SEMVER"),console.log.apply(console,ne)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],g=e.src=[],w=0,b=w++;g[b]="0|[1-9]\\d*";var S=w++;g[S]="[0-9]+";var y=w++;g[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var u=w++;g[u]="("+g[b]+")\\.("+g[b]+")\\.("+g[b]+")";var d=w++;g[d]="("+g[S]+")\\.("+g[S]+")\\.("+g[S]+")";var v=w++;g[v]="(?:"+g[b]+"|"+g[y]+")";var h=w++;g[h]="(?:"+g[S]+"|"+g[y]+")";var l=w++;g[l]="(?:-("+g[v]+"(?:\\."+g[v]+")*))";var p=w++;g[p]="(?:-?("+g[h]+"(?:\\."+g[h]+")*))";var k=w++;g[k]="[0-9A-Za-z-]+";var I=w++;g[I]="(?:\\+("+g[k]+"(?:\\."+g[k]+")*))";var m=w++,i="v?"+g[u]+g[l]+"?"+g[I]+"?";g[m]="^"+i+"$";var r="[v=\\s]*"+g[d]+g[p]+"?"+g[I]+"?",n=w++;g[n]="^"+r+"$";var a=w++;g[a]="((?:<|>)?=?)";var o=w++;g[o]=g[S]+"|x|X|\\*";var c=w++;g[c]=g[b]+"|x|X|\\*";var s=w++;g[s]="[v=\\s]*("+g[c]+")(?:\\.("+g[c]+")(?:\\.("+g[c]+")(?:"+g[l]+")?"+g[I]+"?)?)?";var f=w++;g[f]="[v=\\s]*("+g[o]+")(?:\\.("+g[o]+")(?:\\.("+g[o]+")(?:"+g[p]+")?"+g[I]+"?)?)?";var M=w++;g[M]="^"+g[a]+"\\s*"+g[s]+"$";var L=w++;g[L]="^"+g[a]+"\\s*"+g[f]+"$";var T=w++;g[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=w++;g[U]="(?:~>?)";var K=w++;g[K]="(\\s*)"+g[U]+"\\s+",P[K]=new RegExp(g[K],"g");var V=w++;g[V]="^"+g[U]+g[s]+"$";var G=w++;g[G]="^"+g[U]+g[f]+"$";var _=w++;g[_]="(?:\\^)";var se=w++;g[se]="(\\s*)"+g[_]+"\\s+",P[se]=new RegExp(g[se],"g");var ce=w++;g[ce]="^"+g[_]+g[s]+"$";var X=w++;g[X]="^"+g[_]+g[f]+"$";var ue=w++;g[ue]="^"+g[a]+"\\s*("+r+")$|^$";var z=w++;g[z]="^"+g[a]+"\\s*("+i+")$|^$";var N=w++;g[N]="(\\s*)"+g[a]+"\\s*("+r+"|"+g[s]+")",P[N]=new RegExp(g[N],"g");var F=w++;g[F]="^\\s*("+g[s]+")\\s+-\\s+("+g[s]+")\\s*$";var q=w++;g[q]="^\\s*("+g[f]+")\\s+-\\s+("+g[f]+")\\s*$";var Q=w++;g[Q]="(<|>)?=?\\s*\\*";for(var oe=0;oe<35;oe++)C(oe,g[oe]),P[oe]||(P[oe]=new RegExp(g[oe]));function x(ne,fe){if(ne instanceof D)return ne;if(typeof ne!="string"||ne.length>R||!(fe?P[n]:P[m]).test(ne))return null;try{return new D(ne,fe)}catch{return null}}function D(ne,fe){if(ne instanceof D){if(ne.loose===fe)return ne;ne=ne.version}else if(typeof ne!="string")throw new TypeError("Invalid Version: "+ne);if(ne.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof D))return new D(ne,fe);C("SemVer",ne,fe),this.loose=fe;var de=ne.trim().match(fe?P[n]:P[m]);if(!de)throw new TypeError("Invalid Version: "+ne);if(this.raw=ne,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Pe=+be;if(Pe>=0&&Pe<A)return Pe}return be}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=x,e.valid=function(ne,fe){var de=x(ne,fe);return de?de.version:null},e.clean=function(ne,fe){var de=x(ne.trim().replace(/^[=v]+/,""),fe);return de?de.version:null},e.SemVer=D,D.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},D.prototype.toString=function(){return this.version},D.prototype.compare=function(ne){return C("SemVer.compare",this.version,this.loose,ne),ne instanceof D||(ne=new D(ne,this.loose)),this.compareMain(ne)||this.comparePre(ne)},D.prototype.compareMain=function(ne){return ne instanceof D||(ne=new D(ne,this.loose)),W(this.major,ne.major)||W(this.minor,ne.minor)||W(this.patch,ne.patch)},D.prototype.comparePre=function(ne){if(ne instanceof D||(ne=new D(ne,this.loose)),this.prerelease.length&&!ne.prerelease.length)return-1;if(!this.prerelease.length&&ne.prerelease.length)return 1;if(!this.prerelease.length&&!ne.prerelease.length)return 0;var fe=0;do{var de=this.prerelease[fe],be=ne.prerelease[fe];if(C("prerelease compare",fe,de,be),de===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(de===void 0)return-1;if(de!==be)return W(de,be)}while(++fe)},D.prototype.inc=function(ne,fe){switch(ne){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+ne)}return this.format(),this.raw=this.version,this},e.inc=function(ne,fe,de,be){typeof de=="string"&&(be=de,de=void 0);try{return new D(ne,de).inc(fe,be).version}catch{return null}},e.diff=function(ne,fe){if(B(ne,fe))return null;var de=x(ne),be=x(fe);if(de.prerelease.length||be.prerelease.length){for(var Pe in de)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&de[Pe]!==be[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in de)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&de[Pe]!==be[Pe])return Pe},e.compareIdentifiers=W;var O=/^[0-9]+$/;function W(ne,fe){var de=O.test(ne),be=O.test(fe);return de&&be&&(ne=+ne,fe=+fe),de&&!be?-1:be&&!de?1:ne<fe?-1:ne>fe?1:0}function j(ne,fe,de){return new D(ne,de).compare(new D(fe,de))}function $(ne,fe,de){return j(ne,fe,de)>0}function Y(ne,fe,de){return j(ne,fe,de)<0}function B(ne,fe,de){return j(ne,fe,de)===0}function Z(ne,fe,de){return j(ne,fe,de)!==0}function te(ne,fe,de){return j(ne,fe,de)>=0}function ae(ne,fe,de){return j(ne,fe,de)<=0}function ge(ne,fe,de,be){var Pe;switch(fe){case"===":typeof ne=="object"&&(ne=ne.version),typeof de=="object"&&(de=de.version),Pe=ne===de;break;case"!==":typeof ne=="object"&&(ne=ne.version),typeof de=="object"&&(de=de.version),Pe=ne!==de;break;case"":case"=":case"==":Pe=B(ne,de,be);break;case"!=":Pe=Z(ne,de,be);break;case">":Pe=$(ne,de,be);break;case">=":Pe=te(ne,de,be);break;case"<":Pe=Y(ne,de,be);break;case"<=":Pe=ae(ne,de,be);break;default:throw new TypeError("Invalid operator: "+fe)}return Pe}function ke(ne,fe){if(ne instanceof ke){if(ne.loose===fe)return ne;ne=ne.value}if(!(this instanceof ke))return new ke(ne,fe);C("comparator",ne,fe),this.loose=fe,this.parse(ne),this.semver===Oe?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(ne,fe){return W(fe,ne)},e.major=function(ne,fe){return new D(ne,fe).major},e.minor=function(ne,fe){return new D(ne,fe).minor},e.patch=function(ne,fe){return new D(ne,fe).patch},e.compare=j,e.compareLoose=function(ne,fe){return j(ne,fe,!0)},e.rcompare=function(ne,fe,de){return j(fe,ne,de)},e.sort=function(ne,fe){return ne.sort(function(de,be){return e.compare(de,be,fe)})},e.rsort=function(ne,fe){return ne.sort(function(de,be){return e.rcompare(de,be,fe)})},e.gt=$,e.lt=Y,e.eq=B,e.neq=Z,e.gte=te,e.lte=ae,e.cmp=ge,e.Comparator=ke;var Oe={};function De(ne,fe){if(ne instanceof De)return ne.loose===fe?ne:new De(ne.raw,fe);if(ne instanceof ke)return new De(ne.value,fe);if(!(this instanceof De))return new De(ne,fe);if(this.loose=fe,this.raw=ne,this.set=ne.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ne);this.format()}function Re(ne){return!ne||ne.toLowerCase()==="x"||ne==="*"}function ve(ne,fe,de,be,Pe,We,Te,qe,Ue,je,Xe,$e,Ke){return((fe=Re(de)?"":Re(be)?">="+de+".0.0":Re(Pe)?">="+de+"."+be+".0":">="+fe)+" "+(qe=Re(Ue)?"":Re(je)?"<"+(+Ue+1)+".0.0":Re(Xe)?"<"+Ue+"."+(+je+1)+".0":$e?"<="+Ue+"."+je+"."+Xe+"-"+$e:"<="+qe)).trim()}function we(ne,fe){for(var de=0;de<ne.length;de++)if(!ne[de].test(fe))return!1;if(fe.prerelease.length){for(de=0;de<ne.length;de++)if(C(ne[de].semver),ne[de].semver!==Oe&&ne[de].semver.prerelease.length>0){var be=ne[de].semver;if(be.major===fe.major&&be.minor===fe.minor&&be.patch===fe.patch)return!0}return!1}return!0}function ye(ne,fe,de){try{fe=new De(fe,de)}catch{return!1}return fe.test(ne)}function Me(ne,fe,de,be){var Pe,We,Te,qe,Ue;switch(ne=new D(ne,be),fe=new De(fe,be),de){case">":Pe=$,We=ae,Te=Y,qe=">",Ue=">=";break;case"<":Pe=Y,We=te,Te=$,qe="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ye(ne,fe,be))return!1;for(var je=0;je<fe.set.length;++je){var Xe=fe.set[je],$e=null,Ke=null;if(Xe.forEach(function(J){J.semver===Oe&&(J=new ke(">=0.0.0")),$e=$e||J,Ke=Ke||J,Pe(J.semver,$e.semver,be)?$e=J:Te(J.semver,Ke.semver,be)&&(Ke=J)}),$e.operator===qe||$e.operator===Ue||(!Ke.operator||Ke.operator===qe)&&We(ne,Ke.semver)||Ke.operator===Ue&&Te(ne,Ke.semver))return!1}return!0}ke.prototype.parse=function(ne){var fe=this.loose?P[ue]:P[z],de=ne.match(fe);if(!de)throw new TypeError("Invalid comparator: "+ne);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new D(de[2],this.loose):this.semver=Oe},ke.prototype.toString=function(){return this.value},ke.prototype.test=function(ne){return C("Comparator.test",ne,this.loose),this.semver===Oe||(typeof ne=="string"&&(ne=new D(ne,this.loose)),ge(ne,this.operator,this.semver,this.loose))},ke.prototype.intersects=function(ne,fe){if(!(ne instanceof ke))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new De(ne.value,fe),ye(this.value,de,fe);if(ne.operator==="")return de=new De(this.value,fe),ye(ne.semver,de,fe);var be=!(this.operator!==">="&&this.operator!==">"||ne.operator!==">="&&ne.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||ne.operator!=="<="&&ne.operator!=="<"),We=this.semver.version===ne.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||ne.operator!==">="&&ne.operator!=="<="),qe=ge(this.semver,"<",ne.semver,fe)&&(this.operator===">="||this.operator===">")&&(ne.operator==="<="||ne.operator==="<"),Ue=ge(this.semver,">",ne.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(ne.operator===">="||ne.operator===">");return be||Pe||We&&Te||qe||Ue},e.Range=De,De.prototype.format=function(){return this.range=this.set.map(function(ne){return ne.join(" ").trim()}).join("||").trim(),this.range},De.prototype.toString=function(){return this.range},De.prototype.parseRange=function(ne){var fe=this.loose;ne=ne.trim(),C("range",ne,fe);var de=fe?P[q]:P[F];ne=ne.replace(de,ve),C("hyphen replace",ne),ne=ne.replace(P[N],"$1$2$3"),C("comparator trim",ne,P[N]),ne=(ne=(ne=ne.replace(P[K],"$1~")).replace(P[se],"$1^")).split(/\s+/).join(" ");var be=fe?P[ue]:P[z],Pe=ne.split(" ").map(function(We){return function(Te,qe){return C("comp",Te),Te=function(Ue,je){return Ue.trim().split(/\s+/).map(function(Xe){return function($e,Ke){C("caret",$e,Ke);var J=Ke?P[X]:P[ce];return $e.replace(J,function(le,he,me,Se,Le){var Be;return C("caret",$e,le,he,me,Se,Le),Re(he)?Be="":Re(me)?Be=">="+he+".0.0 <"+(+he+1)+".0.0":Re(Se)?Be=he==="0"?">="+he+"."+me+".0 <"+he+"."+(+me+1)+".0":">="+he+"."+me+".0 <"+(+he+1)+".0.0":Le?(C("replaceCaret pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),Be=he==="0"?me==="0"?">="+he+"."+me+"."+Se+Le+" <"+he+"."+me+"."+(+Se+1):">="+he+"."+me+"."+Se+Le+" <"+he+"."+(+me+1)+".0":">="+he+"."+me+"."+Se+Le+" <"+(+he+1)+".0.0"):(C("no pr"),Be=he==="0"?me==="0"?">="+he+"."+me+"."+Se+" <"+he+"."+me+"."+(+Se+1):">="+he+"."+me+"."+Se+" <"+he+"."+(+me+1)+".0":">="+he+"."+me+"."+Se+" <"+(+he+1)+".0.0"),C("caret return",Be),Be})}(Xe,je)}).join(" ")}(Te,qe),C("caret",Te),Te=function(Ue,je){return Ue.trim().split(/\s+/).map(function(Xe){return function($e,Ke){var J=Ke?P[G]:P[V];return $e.replace(J,function(le,he,me,Se,Le){var Be;return C("tilde",$e,le,he,me,Se,Le),Re(he)?Be="":Re(me)?Be=">="+he+".0.0 <"+(+he+1)+".0.0":Re(Se)?Be=">="+he+"."+me+".0 <"+he+"."+(+me+1)+".0":Le?(C("replaceTilde pr",Le),Le.charAt(0)!=="-"&&(Le="-"+Le),Be=">="+he+"."+me+"."+Se+Le+" <"+he+"."+(+me+1)+".0"):Be=">="+he+"."+me+"."+Se+" <"+he+"."+(+me+1)+".0",C("tilde return",Be),Be})}(Xe,je)}).join(" ")}(Te,qe),C("tildes",Te),Te=function(Ue,je){return C("replaceXRanges",Ue,je),Ue.split(/\s+/).map(function(Xe){return function($e,Ke){$e=$e.trim();var J=Ke?P[L]:P[M];return $e.replace(J,function(le,he,me,Se,Le,Be){C("xRange",$e,le,he,me,Se,Le,Be);var it=Re(me),xe=it||Re(Se),He=xe||Re(Le);return he==="="&&He&&(he=""),it?le=he===">"||he==="<"?"<0.0.0":"*":he&&He?(xe&&(Se=0),He&&(Le=0),he===">"?(he=">=",xe?(me=+me+1,Se=0,Le=0):He&&(Se=+Se+1,Le=0)):he==="<="&&(he="<",xe?me=+me+1:Se=+Se+1),le=he+me+"."+Se+"."+Le):xe?le=">="+me+".0.0 <"+(+me+1)+".0.0":He&&(le=">="+me+"."+Se+".0 <"+me+"."+(+Se+1)+".0"),C("xRange return",le),le})}(Xe,je)}).join(" ")}(Te,qe),C("xrange",Te),Te=function(Ue,je){return C("replaceStars",Ue,je),Ue.trim().replace(P[Q],"")}(Te,qe),C("stars",Te),Te}(We,fe)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(We){return!!We.match(be)})),Pe=Pe.map(function(We){return new ke(We,fe)})},De.prototype.intersects=function(ne,fe){if(!(ne instanceof De))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(be){return ne.set.some(function(Pe){return Pe.every(function(We){return be.intersects(We,fe)})})})})},e.toComparators=function(ne,fe){return new De(ne,fe).set.map(function(de){return de.map(function(be){return be.value}).join(" ").trim().split(" ")})},De.prototype.test=function(ne){if(!ne)return!1;typeof ne=="string"&&(ne=new D(ne,this.loose));for(var fe=0;fe<this.set.length;fe++)if(we(this.set[fe],ne))return!0;return!1},e.satisfies=ye,e.maxSatisfying=function(ne,fe,de){var be=null,Pe=null;try{var We=new De(fe,de)}catch{return null}return ne.forEach(function(Te){We.test(Te)&&(be&&Pe.compare(Te)!==-1||(Pe=new D(be=Te,de)))}),be},e.minSatisfying=function(ne,fe,de){var be=null,Pe=null;try{var We=new De(fe,de)}catch{return null}return ne.forEach(function(Te){We.test(Te)&&(be&&Pe.compare(Te)!==1||(Pe=new D(be=Te,de)))}),be},e.validRange=function(ne,fe){try{return new De(ne,fe).range||"*"}catch{return null}},e.ltr=function(ne,fe,de){return Me(ne,fe,"<",de)},e.gtr=function(ne,fe,de){return Me(ne,fe,">",de)},e.outside=Me,e.prerelease=function(ne,fe){var de=x(ne,fe);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(ne,fe,de){return ne=new De(ne,de),fe=new De(fe,de),ne.intersects(fe)},e.coerce=function(ne){if(ne instanceof D)return ne;if(typeof ne!="string")return null;var fe=ne.match(P[T]);return fe==null?null:x((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,E(1))},function(H,e){var E,t,C=H.exports={};function R(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function P(h){if(E===setTimeout)return setTimeout(h,0);if((E===R||!E)&&setTimeout)return E=setTimeout,setTimeout(h,0);try{return E(h,0)}catch{try{return E.call(null,h,0)}catch{return E.call(this,h,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:R}catch{E=R}try{t=typeof clearTimeout=="function"?clearTimeout:A}catch{t=A}})();var g,w=[],b=!1,S=-1;function y(){b&&g&&(b=!1,g.length?w=g.concat(w):S=-1,w.length&&u())}function u(){if(!b){var h=P(y);b=!0;for(var l=w.length;l;){for(g=w,w=[];++S<l;)g&&g[S].run();S=-1,l=w.length}g=null,b=!1,function(p){if(t===clearTimeout)return clearTimeout(p);if((t===A||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(p);try{t(p)}catch{try{return t.call(null,p)}catch{return t.call(this,p)}}}(h)}}function d(h,l){this.fun=h,this.array=l}function v(){}C.nextTick=function(h){var l=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)l[p-1]=arguments[p];w.push(new d(h,l)),w.length!==1||b||P(u)},d.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=v,C.addListener=v,C.once=v,C.off=v,C.removeListener=v,C.removeAllListeners=v,C.emit=v,C.prependListener=v,C.prependOnceListener=v,C.listeners=function(h){return[]},C.binding=function(h){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(h){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(ie[127],re([0,1]),function(H,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(P,g,w){this.level=P,this.key=g,this.value=w,this.forward=[]}}const C=void 0;class R{constructor(P,g=2**16){this.comparator=P,this[E]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(g)|0),this.e=new t(this.c,C,C)}get size(){return this.f}clear(){this.e=new t(this.c,C,C)}has(P){return Boolean(R.g(this,P,this.comparator))}get(P){return R.g(this,P,this.comparator)?.value}set(P,g){return R.h(this,P,g,this.comparator)&&(this.f+=1),this}delete(P){const g=R.k(this,P,this.comparator);return g&&(this.f-=1),g}forEach(P,g){let w=this.e.forward[0];for(;w;)P.call(g,w.value,w.key,this),w=w.forward[0]}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",g=this.e.forward[0];for(;g;)P+=`node(${g.key}, ${g.value}, lvl:${g.level})`,g=g.forward[0];return P}static g(P,g,w){let b=P.e;for(let S=P.d-1;S>=0;S--)for(;b.forward[S]&&w(b.forward[S].key,g)<0;)b=b.forward[S];if(b=b.forward[0],b&&w(b.key,g)===0)return b}static h(P,g,w,b){const S=[];let y=P.e;for(let u=P.d-1;u>=0;u--){for(;y.forward[u]&&b(y.forward[u].key,g)<0;)y=y.forward[u];S[u]=y}if(y=y.forward[0],y&&b(y.key,g)===0)return y.value=w,!1;{const u=R.j(P);if(u>P.d){for(let d=P.d;d<u;d++)S[d]=P.e;P.d=u}y=new t(u,g,w);for(let d=0;d<u;d++)y.forward[d]=S[d].forward[d],S[d].forward[d]=y;return!0}}static j(P,g=.5){let w=1;for(;Math.random()<g&&w<P.c;)w+=1;return w}static k(P,g,w){const b=[];let S=P.e;for(let y=P.d-1;y>=0;y--){for(;S.forward[y]&&w(S.forward[y].key,g)<0;)S=S.forward[y];b[y]=S}if(S=S.forward[0],!S||w(S.key,g)!==0)return!1;for(let y=0;y<P.d&&b[y].forward[y]===S;y++)b[y].forward[y]=S.forward[y];for(;P.d>0&&P.e.forward[P.d-1]===C;)P.d-=1;return!0}}e.SkipList=R}),define(ie[59],re([0,1,15,2]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function C(I){const m=I;return m?typeof m.read=="function":!1}e.isReadable=C;function R(I){const m=I;return m?[m.on,m.pause,m.resume,m.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=R;function A(I){const m=I;return m?R(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}e.isReadableBufferedStream=A;function P(I,m){return new g(I,m)}e.newWriteableStream=P;class g{constructor(m,i){this.e=m,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(m){if(!this.a.destroyed){if(this.a.flowing)this.g(m);else if(this.b.data.push(m),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(m){this.a.destroyed||(this.a.flowing?this.h(m):this.b.error.push(m))}end(m){this.a.destroyed||(typeof m<"u"&&this.write(m),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(m){this.c.data.slice(0).forEach(i=>i(m))}h(m){this.c.error.length===0?(0,E.onUnexpectedError)(m):this.c.error.slice(0).forEach(i=>i(m))}i(){this.c.end.slice(0).forEach(m=>m())}on(m,i){if(!this.a.destroyed)switch(m){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(m,i){if(this.a.destroyed)return;let r;switch(m){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const n=r.indexOf(i);n>=0&&r.splice(n,1)}}j(){if(this.b.data.length>0){const m=this.e(this.b.data);this.g(m),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const m of this.b.error)this.h(m);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function w(I,m){const i=[];let r;for(;(r=I.read())!==null;)i.push(r);return m(i)}e.consumeReadable=w;function b(I,m,i){const r=[];let n;for(;(n=I.read())!==null&&r.length<i;)r.push(n);return n===null&&r.length>0?m(r):{read:()=>{if(r.length>0)return r.shift();if(typeof n<"u"){const a=n;return n=void 0,a}return I.read()}}}e.peekReadable=b;function S(I,m){return new Promise((i,r)=>{const n=[];y(I,{onData:a=>{m&&n.push(a)},onError:a=>{m?r(a):i(void 0)},onEnd:()=>{i(m?m(n):void 0)}})})}e.consumeStream=S;function y(I,m){let i=!1;return I.on("error",r=>{i||m.onError(r)}),I.on("end",()=>{i||m.onEnd()}),I.on("data",r=>{i||m.onData(r)}),(0,t.toDisposable)(()=>i=!0)}e.listenStream=y;function u(I,m){return new Promise((i,r)=>{const n=new t.DisposableStore,a=[],o=f=>{if(a.push(f),a.length>m)return n.dispose(),I.pause(),i({stream:I,buffer:a,ended:!1})},c=f=>r(f),s=()=>i({stream:I,buffer:a,ended:!0});n.add((0,t.toDisposable)(()=>I.removeListener("error",c))),I.on("error",c),n.add((0,t.toDisposable)(()=>I.removeListener("end",s))),I.on("end",s),n.add((0,t.toDisposable)(()=>I.removeListener("data",o))),I.on("data",o)})}e.peekStream=u;function d(I,m){const i=P(m);return i.end(I),i}e.toStream=d;function v(){const I=P(()=>{throw new Error("not supported")});return I.end(),I}e.emptyStream=v;function h(I){let m=!1;return{read:()=>m?null:(m=!0,I)}}e.toReadable=h;function l(I,m,i){const r=P(i);return y(I,{onData:n=>r.write(m.data(n)),onError:n=>r.error(m.error?m.error(n):n),onEnd:()=>r.end()}),r}e.transform=l;function p(I,m,i){let r=!1;return{read:()=>{const n=m.read();return r?n:(r=!0,n!==null?i([I,n]):I)}}}e.prefixedReadable=p;function k(I,m,i){let r=!1;const n=P(i);return y(m,{onData:a=>r?n.write(a):(r=!0,n.write(i([I,a]))),onError:a=>n.error(a),onEnd:()=>{r||(r=!0,n.write(I)),n.end()}}),n}e.prefixedStream=k}),define(ie[17],re([0,1,59]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let C,R;class A{static alloc(f){return t?new A(Buffer.allocUnsafe(f)):new A(new Uint8Array(f))}static wrap(f){return t&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new A(f)}static fromString(f,M){return!(M?.dontUseNodeBuffer||!1)&&t?new A(Buffer.from(f)):(C||(C=new TextEncoder),new A(C.encode(f)))}static fromByteArray(f){const M=A.alloc(f.length);for(let L=0,T=f.length;L<T;L++)M.buffer[L]=f[L];return M}static concat(f,M){if(typeof M>"u"){M=0;for(let U=0,K=f.length;U<K;U++)M+=f[U].byteLength}const L=A.alloc(M);let T=0;for(let U=0,K=f.length;U<K;U++){const V=f[U];L.set(V,T),T+=V.byteLength}return L}constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}clone(){const f=A.alloc(this.byteLength);return f.set(this),f}toString(){return t?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(f,M){return new A(this.buffer.subarray(f,M))}set(f,M){if(f instanceof A)this.buffer.set(f.buffer,M);else if(f instanceof Uint8Array)this.buffer.set(f,M);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),M);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return w(this.buffer,f)}writeUInt32BE(f,M){b(this.buffer,f,M)}readUInt32LE(f){return S(this.buffer,f)}writeUInt32LE(f,M){y(this.buffer,f,M)}readUInt8(f){return u(this.buffer,f)}writeUInt8(f,M){d(this.buffer,f,M)}}e.VSBuffer=A;function P(s,f){return s[f+0]<<0>>>0|s[f+1]<<8>>>0}e.readUInt16LE=P;function g(s,f,M){s[M+0]=f&255,f=f>>>8,s[M+1]=f&255}e.writeUInt16LE=g;function w(s,f){return s[f]*2**24+s[f+1]*2**16+s[f+2]*2**8+s[f+3]}e.readUInt32BE=w;function b(s,f,M){s[M+3]=f,f=f>>>8,s[M+2]=f,f=f>>>8,s[M+1]=f,f=f>>>8,s[M]=f}e.writeUInt32BE=b;function S(s,f){return s[f+0]<<0>>>0|s[f+1]<<8>>>0|s[f+2]<<16>>>0|s[f+3]<<24>>>0}e.readUInt32LE=S;function y(s,f,M){s[M+0]=f&255,f=f>>>8,s[M+1]=f&255,f=f>>>8,s[M+2]=f&255,f=f>>>8,s[M+3]=f&255}e.writeUInt32LE=y;function u(s,f){return s[f]}e.readUInt8=u;function d(s,f,M){s[M]=f}e.writeUInt8=d;function v(s){return E.consumeReadable(s,f=>A.concat(f))}e.readableToBuffer=v;function h(s){return E.toReadable(s)}e.bufferToReadable=h;function l(s){return E.consumeStream(s,f=>A.concat(f))}e.streamToBuffer=l;async function p(s){return s.ended?A.concat(s.buffer):A.concat([...s.buffer,await l(s.stream)])}e.bufferedStreamToBuffer=p;function k(s){return E.toStream(s,f=>A.concat(f))}e.bufferToStream=k;function I(s){return E.transform(s,{data:f=>typeof f=="string"?A.fromString(f):A.wrap(f)},f=>A.concat(f))}e.streamToBufferReadableStream=I;function m(s){return E.newWriteableStream(f=>A.concat(f),s)}e.newWriteableBufferStream=m;function i(s,f){return E.prefixedReadable(s,f,M=>A.concat(M))}e.prefixedBufferReadable=i;function r(s,f){return E.prefixedStream(s,f,M=>A.concat(M))}e.prefixedBufferStream=r;function n(s){let f=0,M=0,L=0;const T=new Uint8Array(Math.floor(s.length/4*3)),U=V=>{switch(M){case 3:T[L++]=f|V,M=0;break;case 2:T[L++]=f|V>>>2,f=V<<6,M=3;break;case 1:T[L++]=f|V>>>4,f=V<<4,M=2;break;default:f=V<<2,M=1}};for(let V=0;V<s.length;V++){const G=s.charCodeAt(V);if(G>=65&&G<=90)U(G-65);else if(G>=97&&G<=122)U(G-97+26);else if(G>=48&&G<=57)U(G-48+52);else if(G===43||G===45)U(62);else if(G===47||G===95)U(63);else{if(G===61)break;throw new SyntaxError(`Unexpected base64 character ${s[V]}`)}}const K=L;for(;M>0;)U(0);return A.wrap(T).slice(0,K)}e.decodeBase64=n;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:s},f=!0,M=!1){const L=M?o:a;let T="";const U=s.byteLength%3;let K=0;for(;K<s.byteLength-U;K+=3){const V=s[K+0],G=s[K+1],_=s[K+2];T+=L[V>>>2],T+=L[(V<<4|G>>>4)&63],T+=L[(G<<2|_>>>6)&63],T+=L[_&63]}if(U===1){const V=s[K+0];T+=L[V>>>2],T+=L[V<<4&63],f&&(T+="==")}else if(U===2){const V=s[K+0],G=s[K+1];T+=L[V>>>2],T+=L[(V<<4|G>>>4)&63],T+=L[G<<2&63],f&&(T+="=")}return T}e.encodeBase64=c}),define(ie[11],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function E(r){return typeof r=="string"}e.isString=E;function t(r){return Array.isArray(r)&&r.every(n=>E(n))}e.isStringArray=t;function C(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=C;function R(r){const n=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof n}e.isTypedArray=R;function A(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=A;function P(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=P;function g(r){return r===!0||r===!1}e.isBoolean=g;function w(r){return typeof r>"u"}e.isUndefined=w;function b(r){return!S(r)}e.isDefined=b;function S(r){return w(r)||r===null}e.isUndefinedOrNull=S;function y(r,n){if(!r)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.assertType=y;function u(r){if(S(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=u;function d(...r){const n=[];for(let a=0;a<r.length;a++){const o=r[a];if(S(o))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);n.push(o)}return n}e.assertAllDefined=d;const v=Object.prototype.hasOwnProperty;function h(r){if(!C(r))return!1;for(const n in r)if(v.call(r,n))return!1;return!0}e.isEmptyObject=h;function l(r){return typeof r=="function"}e.isFunction=l;function p(...r){return r.length>0&&r.every(l)}e.areFunctions=p;function k(r,n){const a=Math.min(r.length,n.length);for(let o=0;o<a;o++)I(r[o],n[o])}e.validateConstraints=k;function I(r,n){if(E(n)){if(typeof r!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(l(n)){try{if(r instanceof n)return}catch{}if(!S(r)&&r.constructor===n||n.length===1&&n.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=I;function m(r){return r===null?void 0:r}e.withNullAsUndefined=m;function i(r){return typeof r>"u"?null:r}e.withUndefinedAsNull=i}),define(ie[44],re([0,1,11]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const p=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([k,I])=>{p[k]=I&&typeof I=="object"?t(I):I}),p}e.deepClone=t;function C(l){if(!l||typeof l!="object")return l;const p=[l];for(;p.length>0;){const k=p.shift();Object.freeze(k);for(const I in k)if(R.call(k,I)){const m=k[I];typeof m=="object"&&!Object.isFrozen(m)&&!(0,E.isTypedArray)(m)&&p.push(m)}}return l}e.deepFreeze=C;const R=Object.prototype.hasOwnProperty;function A(l,p){return P(l,p,new Set)}e.cloneAndChange=A;function P(l,p,k){if((0,E.isUndefinedOrNull)(l))return l;const I=p(l);if(typeof I<"u")return I;if(Array.isArray(l)){const m=[];for(const i of l)m.push(P(i,p,k));return m}if((0,E.isObject)(l)){if(k.has(l))throw new Error("Cannot clone recursive data-structure");k.add(l);const m={};for(const i in l)R.call(l,i)&&(m[i]=P(l[i],p,k));return k.delete(l),m}return l}function g(l,p,k=!0){return(0,E.isObject)(l)?((0,E.isObject)(p)&&Object.keys(p).forEach(I=>{I in l?k&&((0,E.isObject)(l[I])&&(0,E.isObject)(p[I])?g(l[I],p[I],k):l[I]=p[I]):l[I]=p[I]}),l):p}e.mixin=g;function w(l,p){if(l===p)return!0;if(l==null||p===null||p===void 0||typeof l!=typeof p||typeof l!="object"||Array.isArray(l)!==Array.isArray(p))return!1;let k,I;if(Array.isArray(l)){if(l.length!==p.length)return!1;for(k=0;k<l.length;k++)if(!w(l[k],p[k]))return!1}else{const m=[];for(I in l)m.push(I);m.sort();const i=[];for(I in p)i.push(I);if(i.sort(),!w(m,i))return!1;for(k=0;k<m.length;k++)if(!w(l[m[k]],p[m[k]]))return!1}return!0}e.equals=w;function b(l){const p=new Set;return JSON.stringify(l,(k,I)=>{if((0,E.isObject)(I)||Array.isArray(I)){if(p.has(I))return"[Circular]";p.add(I)}return I})}e.safeStringify=b;function S(l,p){const k=Object.create(null);return!l||!p||Object.keys(p).forEach(m=>{const i=l[m],r=p[m];w(i,r)||(k[m]=r)}),k}e.distinct=S;function y(l,p){const k=p.toLowerCase(),I=Object.keys(l).find(m=>m.toLowerCase()===k);return I?l[I]:l[p]}e.getCaseInsensitive=y;function u(l,p){const k=Object.create(null);for(const[I,m]of Object.entries(l))p(I,m)&&(k[I]=m);return k}e.filter=u;function d(l){let p=[],k=Object.getPrototypeOf(l);for(;Object.prototype!==k;)p=p.concat(Object.getOwnPropertyNames(k)),k=Object.getPrototypeOf(k);return p}e.getAllPropertyNames=d;function v(l){const p=[];for(const k of d(l))typeof l[k]=="function"&&p.push(k);return p}e.getAllMethodNames=v;function h(l,p){const k=m=>function(){const i=Array.prototype.slice.call(arguments,0);return p(m,i)},I={};for(const m of l)I[m]=k(m);return I}e.createProxyObject=h}),define(ie[29],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(C){return E.test(C)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(P){for(let g=0;g<P.length;g++)P[g]=Math.floor(Math.random()*256);return P};const R=new Uint8Array(16),A=[];for(let P=0;P<256;P++)A.push(P.toString(16).padStart(2,"0"));return function(){C(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let g=0,w="";return w+=A[R[g++]],w+=A[R[g++]],w+=A[R[g++]],w+=A[R[g++]],w+="-",w+=A[R[g++]],w+=A[R[g++]],w+="-",w+=A[R[g++]],w+=A[R[g++]],w+="-",w+=A[R[g++]],w+=A[R[g++]],w+="-",w+=A[R[g++]],w+=A[R[g++]],w+=A[R[g++]],w+=A[R[g++]],w+=A[R[g++]],w+=A[R[g++]],w}}()}),define(ie[128],re([0,1,78,40,50]),function(H,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function R(A,P){if(await new Promise((b,S)=>{const y=t.createReadStream(A),u=E.createHash("sha1");y.pipe(u);const d=(0,C.once)((v,h)=>{y.removeAllListeners(),u.removeAllListeners(),v?S(v):b(h)});y.once("error",d),y.once("end",d),u.once("error",d),u.once("data",v=>d(void 0,v.toString("hex")))})!==P)throw new Error("Hash mismatch")}e.checksum=R}),define(ie[129],re([0,1,25]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function C(A){const P=A.replace(/\-/g,":").toLowerCase();return!t.has(P)}function R(){const A=(0,E.networkInterfaces)();for(const P in A){const g=A[P];if(g){for(const{mac:w}of g)if(C(w))return w}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(ie[97],re([0,1,79]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(P,g,w,b=1){let S=!1;return new Promise(y=>{const u=setTimeout(()=>{if(!S)return S=!0,y(0)},w);C(P,g,b,d=>{if(!S)return S=!0,clearTimeout(u),y(d)})})}e.findFreePort=t;function C(P,g,w,b){if(g===0)return b(0);const S=new E.Socket;S.once("connect",()=>(A(S),C(P+w,g-1,w,b))),S.once("data",()=>{}),S.once("error",y=>(A(S),y.code!=="ECONNREFUSED"?C(P+w,g-1,w,b):b(P))),S.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(P,g,w,b="127.0.0.1"){let S=!1,y,u=1;const d=E.createServer({pauseOnConnect:!0});function v(h,l){S||(S=!0,d.removeAllListeners(),d.close(),y&&clearTimeout(y),l(h))}return new Promise(h=>{y=setTimeout(()=>{v(0,h)},w),d.on("listening",()=>{v(P,h)}),d.on("error",l=>{l&&(l.code==="EADDRINUSE"||l.code==="EACCES")&&u<g?(P++,u++,d.listen(P,b)):v(0,h)}),d.on("close",()=>{v(0,h)}),d.listen(P,b)})}e.findFreePortFaster=R;function A(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(g){console.error(g)}}}),define(ie[130],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ie[131],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class E{constructor(C,R){this.a=C,this.onMessage=R}send(C){try{this.a.send("vscode:message",C.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.Protocol=E}),define(ie[41],re([0,1,13,15]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class C{constructor(){this.a=new WeakMap}on(A,P){const g=(w,...b)=>{this.b(A,w)&&P(w,...b)};return this.a.set(P,g),E.ipcMain.on(A,g),this}once(A,P){return E.ipcMain.once(A,(g,...w)=>{this.b(A,g)&&P(g,...w)}),this}handle(A,P){return E.ipcMain.handle(A,(g,...w)=>this.b(A,g)?P(g,...w):Promise.reject(`Invalid channel '${A}' or sender for ipcMain.handle() usage.`)),this}removeHandler(A){return E.ipcMain.removeHandler(A),this}removeListener(A,P){const g=this.a.get(P);return g&&(E.ipcMain.removeListener(A,g),this.a.delete(P)),this}b(A,P){if(!A||!A.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${A}' because the channel is unknown.`),!1;const g=P.senderFrame,w=g.url;if(!w)return!0;let b="unknown";try{b=new URL(w).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${A}' because of a malformed URL '${w}'.`),!1}return b!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${A}' because of a bad origin of '${b}'.`),!1):g.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${A}' because sender of origin '${b}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new C}),define(ie[132],re([0,1,13,41,11,130]),function(H,e,E,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function A(){t.validatedIpcMain.on(R.CONTEXT_MENU_CHANNEL,(g,w,b,S,y)=>{const u=P(g,S,b);u.popup({window:(0,C.withNullAsUndefined)(E.BrowserWindow.fromWebContents(g.sender)),x:y?y.x:void 0,y:y?y.y:void 0,positioningItem:y?y.positioningItem:void 0,callback:()=>{u&&g.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,w)}})})}e.registerContextMenuListener=A;function P(g,w,b){const S=new E.Menu;return b.forEach(y=>{let u;y.type==="separator"?u=new E.MenuItem({type:y.type}):Array.isArray(y.submenu)?u=new E.MenuItem({submenu:P(g,w,y.submenu),label:y.label}):u=new E.MenuItem({label:y.label,type:y.type,accelerator:y.accelerator,checked:y.checked,enabled:y.enabled,visible:y.visible,click:(d,v,h)=>g.sender.send(w,y.id,h)}),S.append(u)}),S}}),define(ie[133],re([12,10]),function(H,e){return H.create("vs/base/common/date",e)}),define(ie[134],re([0,1,133]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,C=t*60,R=C*24,A=R*7,P=R*30,g=R*365;function w(S,y,u){typeof S!="number"&&(S=S.getTime());const d=Math.round((new Date().getTime()-S)/1e3);if(d<-30)return(0,E.localize)(0,null,w(new Date().getTime()+d*1e3,!1));if(d<30)return(0,E.localize)(1,null);let v;return d<t?(v=d,y?v===1?u?(0,E.localize)(2,null,v):(0,E.localize)(3,null,v):u?(0,E.localize)(4,null,v):(0,E.localize)(5,null,v):v===1?u?(0,E.localize)(6,null,v):(0,E.localize)(7,null,v):u?(0,E.localize)(8,null,v):(0,E.localize)(9,null,v)):d<C?(v=Math.floor(d/t),y?v===1?u?(0,E.localize)(10,null,v):(0,E.localize)(11,null,v):u?(0,E.localize)(12,null,v):(0,E.localize)(13,null,v):v===1?u?(0,E.localize)(14,null,v):(0,E.localize)(15,null,v):u?(0,E.localize)(16,null,v):(0,E.localize)(17,null,v)):d<R?(v=Math.floor(d/C),y?v===1?u?(0,E.localize)(18,null,v):(0,E.localize)(19,null,v):u?(0,E.localize)(20,null,v):(0,E.localize)(21,null,v):v===1?u?(0,E.localize)(22,null,v):(0,E.localize)(23,null,v):u?(0,E.localize)(24,null,v):(0,E.localize)(25,null,v)):d<A?(v=Math.floor(d/R),y?v===1?(0,E.localize)(26,null,v):(0,E.localize)(27,null,v):v===1?(0,E.localize)(28,null,v):(0,E.localize)(29,null,v)):d<P?(v=Math.floor(d/A),y?v===1?u?(0,E.localize)(30,null,v):(0,E.localize)(31,null,v):u?(0,E.localize)(32,null,v):(0,E.localize)(33,null,v):v===1?u?(0,E.localize)(34,null,v):(0,E.localize)(35,null,v):u?(0,E.localize)(36,null,v):(0,E.localize)(37,null,v)):d<g?(v=Math.floor(d/P),y?v===1?u?(0,E.localize)(38,null,v):(0,E.localize)(39,null,v):u?(0,E.localize)(40,null,v):(0,E.localize)(41,null,v):v===1?u?(0,E.localize)(42,null,v):(0,E.localize)(43,null,v):u?(0,E.localize)(44,null,v):(0,E.localize)(45,null,v)):(v=Math.floor(d/g),y?v===1?u?(0,E.localize)(46,null,v):(0,E.localize)(47,null,v):u?(0,E.localize)(48,null,v):(0,E.localize)(49,null,v):v===1?u?(0,E.localize)(50,null,v):(0,E.localize)(51,null,v):u?(0,E.localize)(52,null,v):(0,E.localize)(53,null,v))}e.fromNow=w;function b(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=b}),define(ie[135],re([12,10]),function(H,e){return H.create("vs/base/common/errorMessage",e)}),define(ie[45],re([0,1,24,11,135]),function(H,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(S,y){return y&&(S.stack||S.stacktrace)?C.localize(0,null,P(S),A(S.stack)||A(S.stacktrace)):P(S)}function A(S){return Array.isArray(S)?S.join(`
`):S}function P(S){return typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?C.localize(1,null,S.message):S.message||C.localize(2,null)}function g(S=null,y=!1){if(!S)return C.localize(3,null);if(Array.isArray(S)){const u=E.coalesce(S),d=g(u[0],y);return u.length>1?C.localize(4,null,d,u.length):d}if(t.isString(S))return S;if(S.detail){const u=S.detail;if(u.error)return R(u.error,y);if(u.exception)return R(u.exception,y)}return S.stack?R(S,y):S.message?S.message:C.localize(5,null)}e.toErrorMessage=g;function w(S){const y=S;return y instanceof Error&&Array.isArray(y.actions)}e.isErrorWithActions=w;function b(S,y){let u;return typeof S=="string"?u=new Error(S):u=S,u.actions=y,u}e.createErrorWithActions=b}),define(ie[136],re([12,10]),function(H,e){return H.create("vs/base/common/jsonErrorMessages",e)}),define(ie[137],re([0,1,136]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(C){switch(C){case 1:return(0,E.localize)(0,null);case 2:return(0,E.localize)(1,null);case 3:return(0,E.localize)(2,null);case 4:return(0,E.localize)(3,null);case 5:return(0,E.localize)(4,null);case 6:return(0,E.localize)(5,null);case 7:return(0,E.localize)(6,null);case 8:return(0,E.localize)(7,null);case 9:return(0,E.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(ie[138],re([12,10]),function(H,e){return H.create("vs/base/common/platform",e)}),define(ie[4],re([0,1,138]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,C=!1,R=!1,A=!1,P=!1,g=!1,w=!1,b=!1,S=!1,y=!1,u,d=e.LANGUAGE_DEFAULT,v,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?l=e.globals.vscode.process:typeof process<"u"&&(l=process);const p=typeof l?.versions?.electron=="string",k=p&&l?.type==="renderer";if(typeof navigator=="object"&&!k)h=navigator.userAgent,t=h.indexOf("Windows")>=0,C=h.indexOf("Macintosh")>=0,b=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=h.indexOf("Linux")>=0,y=h?.indexOf("Mobi")>=0,g=!0,u=E.getConfiguredDefaultLocale(E.localize(0,null))||e.LANGUAGE_DEFAULT,d=u;else if(typeof l=="object"){t=l.platform==="win32",C=l.platform==="darwin",R=l.platform==="linux",A=R&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,w=p,S=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=e.LANGUAGE_DEFAULT,d=e.LANGUAGE_DEFAULT;const s=l.env.VSCODE_NLS_CONFIG;if(s)try{const f=JSON.parse(s),M=f.availableLanguages["*"];u=f.locale,d=M||e.LANGUAGE_DEFAULT,v=f._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var I;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(I=e.Platform||(e.Platform={}));function m(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=m;let i=0;C?i=1:t?i=3:R&&(i=2),e.isWindows=t,e.isMacintosh=C,e.isLinux=R,e.isLinuxSnap=A,e.isNative=P,e.isElectron=w,e.isWeb=g,e.isWebWorker=g&&typeof e.globals.importScripts=="function",e.isIOS=b,e.isMobile=y,e.isCI=S,e.platform=i,e.userAgent=h,e.language=d;var r;(function(s){function f(){return e.language}s.value=f;function M(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=M;function L(){return e.language==="en"}s.isDefault=L})(r=e.Language||(e.Language={})),e.locale=u,e.translationsConfigFile=v,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const s=[];e.globals.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let L=0,T=s.length;L<T;L++){const U=s[L];if(U.id===M.data.vscodeScheduleAsyncWork){s.splice(L,1),U.callback();return}}});let f=0;return M=>{const L=++f;s.push({id:L,callback:M}),e.globals.postMessage({vscodeScheduleAsyncWork:L},"*")}}return s=>setTimeout(s)})();var n;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(n=e.OperatingSystem||(e.OperatingSystem={})),e.OS=C||b?2:t?1:3;let a=!0,o=!1;function c(){if(!o){o=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,a=new Uint16Array(s.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ie[33],re([0,1,4]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const C=E.globals.vscode.process;t={get platform(){return C.platform},get arch(){return C.arch},get env(){return C.env},cwd(){return C.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(ie[9],re([0,1,33]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,C=97,R=90,A=122,P=46,g=47,w=92,b=58,S=63;class y extends Error{constructor(r,n,a){let o;typeof n=="string"&&n.indexOf("not ")===0?(o="must not be",n=n.replace(/^not /,"")):o="must be";const c=r.indexOf(".")!==-1?"property":"argument";let s=`The "${r}" ${c} ${o} of type ${n}`;s+=`. Received type ${typeof a}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function u(i,r){if(i===null||typeof i!="object")throw new y(r,"Object",i)}function d(i,r){if(typeof i!="string")throw new y(r,"string",i)}const v=E.platform==="win32";function h(i){return i===g||i===w}function l(i){return i===g}function p(i){return i>=t&&i<=R||i>=C&&i<=A}function k(i,r,n,a){let o="",c=0,s=-1,f=0,M=0;for(let L=0;L<=i.length;++L){if(L<i.length)M=i.charCodeAt(L);else{if(a(M))break;M=g}if(a(M)){if(!(s===L-1||f===1))if(f===2){if(o.length<2||c!==2||o.charCodeAt(o.length-1)!==P||o.charCodeAt(o.length-2)!==P){if(o.length>2){const T=o.lastIndexOf(n);T===-1?(o="",c=0):(o=o.slice(0,T),c=o.length-1-o.lastIndexOf(n)),s=L,f=0;continue}else if(o.length!==0){o="",c=0,s=L,f=0;continue}}r&&(o+=o.length>0?`${n}..`:"..",c=2)}else o.length>0?o+=`${n}${i.slice(s+1,L)}`:o=i.slice(s+1,L),c=L-s-1;s=L,f=0}else M===P&&f!==-1?++f:f=-1}return o}function I(i,r){u(r,"pathObject");const n=r.dir||r.root,a=r.base||`${r.name||""}${r.ext||""}`;return n?n===r.root?`${n}${a}`:`${n}${i}${a}`:a}e.win32={resolve(...i){let r="",n="",a=!1;for(let o=i.length-1;o>=-1;o--){let c;if(o>=0){if(c=i[o],d(c,"path"),c.length===0)continue}else r.length===0?c=E.cwd():(c=E.env[`=${r}`]||E.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==r.toLowerCase()&&c.charCodeAt(2)===w)&&(c=`${r}\\`));const s=c.length;let f=0,M="",L=!1;const T=c.charCodeAt(0);if(s===1)h(T)&&(f=1,L=!0);else if(h(T))if(L=!0,h(c.charCodeAt(1))){let U=2,K=U;for(;U<s&&!h(c.charCodeAt(U));)U++;if(U<s&&U!==K){const V=c.slice(K,U);for(K=U;U<s&&h(c.charCodeAt(U));)U++;if(U<s&&U!==K){for(K=U;U<s&&!h(c.charCodeAt(U));)U++;(U===s||U!==K)&&(M=`\\\\${V}\\${c.slice(K,U)}`,f=U)}}}else f=1;else p(T)&&c.charCodeAt(1)===b&&(M=c.slice(0,2),f=2,s>2&&h(c.charCodeAt(2))&&(L=!0,f=3));if(M.length>0)if(r.length>0){if(M.toLowerCase()!==r.toLowerCase())continue}else r=M;if(a){if(r.length>0)break}else if(n=`${c.slice(f)}\\${n}`,a=L,L&&r.length>0)break}return n=k(n,!a,"\\",h),a?`${r}\\${n}`:`${r}${n}`||"."},normalize(i){d(i,"path");const r=i.length;if(r===0)return".";let n=0,a,o=!1;const c=i.charCodeAt(0);if(r===1)return l(c)?"\\":i;if(h(c))if(o=!0,h(i.charCodeAt(1))){let f=2,M=f;for(;f<r&&!h(i.charCodeAt(f));)f++;if(f<r&&f!==M){const L=i.slice(M,f);for(M=f;f<r&&h(i.charCodeAt(f));)f++;if(f<r&&f!==M){for(M=f;f<r&&!h(i.charCodeAt(f));)f++;if(f===r)return`\\\\${L}\\${i.slice(M)}\\`;f!==M&&(a=`\\\\${L}\\${i.slice(M,f)}`,n=f)}}}else n=1;else p(c)&&i.charCodeAt(1)===b&&(a=i.slice(0,2),n=2,r>2&&h(i.charCodeAt(2))&&(o=!0,n=3));let s=n<r?k(i.slice(n),!o,"\\",h):"";return s.length===0&&!o&&(s="."),s.length>0&&h(i.charCodeAt(r-1))&&(s+="\\"),a===void 0?o?`\\${s}`:s:o?`${a}\\${s}`:`${a}${s}`},isAbsolute(i){d(i,"path");const r=i.length;if(r===0)return!1;const n=i.charCodeAt(0);return h(n)||r>2&&p(n)&&i.charCodeAt(1)===b&&h(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let r,n;for(let c=0;c<i.length;++c){const s=i[c];d(s,"path"),s.length>0&&(r===void 0?r=n=s:r+=`\\${s}`)}if(r===void 0)return".";let a=!0,o=0;if(typeof n=="string"&&h(n.charCodeAt(0))){++o;const c=n.length;c>1&&h(n.charCodeAt(1))&&(++o,c>2&&(h(n.charCodeAt(2))?++o:a=!1))}if(a){for(;o<r.length&&h(r.charCodeAt(o));)o++;o>=2&&(r=`\\${r.slice(o)}`)}return e.win32.normalize(r)},relative(i,r){if(d(i,"from"),d(r,"to"),i===r)return"";const n=e.win32.resolve(i),a=e.win32.resolve(r);if(n===a||(i=n.toLowerCase(),r=a.toLowerCase(),i===r))return"";let o=0;for(;o<i.length&&i.charCodeAt(o)===w;)o++;let c=i.length;for(;c-1>o&&i.charCodeAt(c-1)===w;)c--;const s=c-o;let f=0;for(;f<r.length&&r.charCodeAt(f)===w;)f++;let M=r.length;for(;M-1>f&&r.charCodeAt(M-1)===w;)M--;const L=M-f,T=s<L?s:L;let U=-1,K=0;for(;K<T;K++){const G=i.charCodeAt(o+K);if(G!==r.charCodeAt(f+K))break;G===w&&(U=K)}if(K!==T){if(U===-1)return a}else{if(L>T){if(r.charCodeAt(f+K)===w)return a.slice(f+K+1);if(K===2)return a.slice(f+K)}s>T&&(i.charCodeAt(o+K)===w?U=K:K===2&&(U=3)),U===-1&&(U=0)}let V="";for(K=o+U+1;K<=c;++K)(K===c||i.charCodeAt(K)===w)&&(V+=V.length===0?"..":"\\..");return f+=U,V.length>0?`${V}${a.slice(f,M)}`:(a.charCodeAt(f)===w&&++f,a.slice(f,M))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const r=e.win32.resolve(i);if(r.length<=2)return i;if(r.charCodeAt(0)===w){if(r.charCodeAt(1)===w){const n=r.charCodeAt(2);if(n!==S&&n!==P)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(p(r.charCodeAt(0))&&r.charCodeAt(1)===b&&r.charCodeAt(2)===w)return`\\\\?\\${r}`;return i},dirname(i){d(i,"path");const r=i.length;if(r===0)return".";let n=-1,a=0;const o=i.charCodeAt(0);if(r===1)return h(o)?i:".";if(h(o)){if(n=a=1,h(i.charCodeAt(1))){let f=2,M=f;for(;f<r&&!h(i.charCodeAt(f));)f++;if(f<r&&f!==M){for(M=f;f<r&&h(i.charCodeAt(f));)f++;if(f<r&&f!==M){for(M=f;f<r&&!h(i.charCodeAt(f));)f++;if(f===r)return i;f!==M&&(n=a=f+1)}}}}else p(o)&&i.charCodeAt(1)===b&&(n=r>2&&h(i.charCodeAt(2))?3:2,a=n);let c=-1,s=!0;for(let f=r-1;f>=a;--f)if(h(i.charCodeAt(f))){if(!s){c=f;break}}else s=!1;if(c===-1){if(n===-1)return".";c=n}return i.slice(0,c)},basename(i,r){r!==void 0&&d(r,"ext"),d(i,"path");let n=0,a=-1,o=!0,c;if(i.length>=2&&p(i.charCodeAt(0))&&i.charCodeAt(1)===b&&(n=2),r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let s=r.length-1,f=-1;for(c=i.length-1;c>=n;--c){const M=i.charCodeAt(c);if(h(M)){if(!o){n=c+1;break}}else f===-1&&(o=!1,f=c+1),s>=0&&(M===r.charCodeAt(s)?--s===-1&&(a=c):(s=-1,a=f))}return n===a?a=f:a===-1&&(a=i.length),i.slice(n,a)}for(c=i.length-1;c>=n;--c)if(h(i.charCodeAt(c))){if(!o){n=c+1;break}}else a===-1&&(o=!1,a=c+1);return a===-1?"":i.slice(n,a)},extname(i){d(i,"path");let r=0,n=-1,a=0,o=-1,c=!0,s=0;i.length>=2&&i.charCodeAt(1)===b&&p(i.charCodeAt(0))&&(r=a=2);for(let f=i.length-1;f>=r;--f){const M=i.charCodeAt(f);if(h(M)){if(!c){a=f+1;break}continue}o===-1&&(c=!1,o=f+1),M===P?n===-1?n=f:s!==1&&(s=1):n!==-1&&(s=-1)}return n===-1||o===-1||s===0||s===1&&n===o-1&&n===a+1?"":i.slice(n,o)},format:I.bind(null,"\\"),parse(i){d(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const n=i.length;let a=0,o=i.charCodeAt(0);if(n===1)return h(o)?(r.root=r.dir=i,r):(r.base=r.name=i,r);if(h(o)){if(a=1,h(i.charCodeAt(1))){let U=2,K=U;for(;U<n&&!h(i.charCodeAt(U));)U++;if(U<n&&U!==K){for(K=U;U<n&&h(i.charCodeAt(U));)U++;if(U<n&&U!==K){for(K=U;U<n&&!h(i.charCodeAt(U));)U++;U===n?a=U:U!==K&&(a=U+1)}}}}else if(p(o)&&i.charCodeAt(1)===b){if(n<=2)return r.root=r.dir=i,r;if(a=2,h(i.charCodeAt(2))){if(n===3)return r.root=r.dir=i,r;a=3}}a>0&&(r.root=i.slice(0,a));let c=-1,s=a,f=-1,M=!0,L=i.length-1,T=0;for(;L>=a;--L){if(o=i.charCodeAt(L),h(o)){if(!M){s=L+1;break}continue}f===-1&&(M=!1,f=L+1),o===P?c===-1?c=L:T!==1&&(T=1):c!==-1&&(T=-1)}return f!==-1&&(c===-1||T===0||T===1&&c===f-1&&c===s+1?r.base=r.name=i.slice(s,f):(r.name=i.slice(s,c),r.base=i.slice(s,f),r.ext=i.slice(c,f))),s>0&&s!==a?r.dir=i.slice(0,s-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const m=(()=>{if(v){const i=/\\/g;return()=>{const r=E.cwd().replace(i,"/");return r.slice(r.indexOf("/"))}}return()=>E.cwd()})();e.posix={resolve(...i){let r="",n=!1;for(let a=i.length-1;a>=-1&&!n;a--){const o=a>=0?i[a]:m();d(o,"path"),o.length!==0&&(r=`${o}/${r}`,n=o.charCodeAt(0)===g)}return r=k(r,!n,"/",l),n?`/${r}`:r.length>0?r:"."},normalize(i){if(d(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===g,n=i.charCodeAt(i.length-1)===g;return i=k(i,!r,"/",l),i.length===0?r?"/":n?"./":".":(n&&(i+="/"),r?`/${i}`:i)},isAbsolute(i){return d(i,"path"),i.length>0&&i.charCodeAt(0)===g},join(...i){if(i.length===0)return".";let r;for(let n=0;n<i.length;++n){const a=i[n];d(a,"path"),a.length>0&&(r===void 0?r=a:r+=`/${a}`)}return r===void 0?".":e.posix.normalize(r)},relative(i,r){if(d(i,"from"),d(r,"to"),i===r||(i=e.posix.resolve(i),r=e.posix.resolve(r),i===r))return"";const n=1,a=i.length,o=a-n,c=1,s=r.length-c,f=o<s?o:s;let M=-1,L=0;for(;L<f;L++){const U=i.charCodeAt(n+L);if(U!==r.charCodeAt(c+L))break;U===g&&(M=L)}if(L===f)if(s>f){if(r.charCodeAt(c+L)===g)return r.slice(c+L+1);if(L===0)return r.slice(c+L)}else o>f&&(i.charCodeAt(n+L)===g?M=L:L===0&&(M=0));let T="";for(L=n+M+1;L<=a;++L)(L===a||i.charCodeAt(L)===g)&&(T+=T.length===0?"..":"/..");return`${T}${r.slice(c+M)}`},toNamespacedPath(i){return i},dirname(i){if(d(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===g;let n=-1,a=!0;for(let o=i.length-1;o>=1;--o)if(i.charCodeAt(o)===g){if(!a){n=o;break}}else a=!1;return n===-1?r?"/":".":r&&n===1?"//":i.slice(0,n)},basename(i,r){r!==void 0&&d(r,"ext"),d(i,"path");let n=0,a=-1,o=!0,c;if(r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let s=r.length-1,f=-1;for(c=i.length-1;c>=0;--c){const M=i.charCodeAt(c);if(M===g){if(!o){n=c+1;break}}else f===-1&&(o=!1,f=c+1),s>=0&&(M===r.charCodeAt(s)?--s===-1&&(a=c):(s=-1,a=f))}return n===a?a=f:a===-1&&(a=i.length),i.slice(n,a)}for(c=i.length-1;c>=0;--c)if(i.charCodeAt(c)===g){if(!o){n=c+1;break}}else a===-1&&(o=!1,a=c+1);return a===-1?"":i.slice(n,a)},extname(i){d(i,"path");let r=-1,n=0,a=-1,o=!0,c=0;for(let s=i.length-1;s>=0;--s){const f=i.charCodeAt(s);if(f===g){if(!o){n=s+1;break}continue}a===-1&&(o=!1,a=s+1),f===P?r===-1?r=s:c!==1&&(c=1):r!==-1&&(c=-1)}return r===-1||a===-1||c===0||c===1&&r===a-1&&r===n+1?"":i.slice(r,a)},format:I.bind(null,"/"),parse(i){d(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const n=i.charCodeAt(0)===g;let a;n?(r.root="/",a=1):a=0;let o=-1,c=0,s=-1,f=!0,M=i.length-1,L=0;for(;M>=a;--M){const T=i.charCodeAt(M);if(T===g){if(!f){c=M+1;break}continue}s===-1&&(f=!1,s=M+1),T===P?o===-1?o=M:L!==1&&(L=1):o!==-1&&(L=-1)}if(s!==-1){const T=c===0&&n?1:c;o===-1||L===0||L===1&&o===s-1&&o===c+1?r.base=r.name=i.slice(T,s):(r.name=i.slice(T,o),r.base=i.slice(T,s),r.ext=i.slice(o,s))}return c>0?r.dir=i.slice(0,c-1):n&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v?e.win32.normalize:e.posix.normalize,e.isAbsolute=v?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v?e.win32.join:e.posix.join,e.resolve=v?e.win32.resolve:e.posix.resolve,e.relative=v?e.win32.relative:e.posix.relative,e.dirname=v?e.win32.dirname:e.posix.dirname,e.basename=v?e.win32.basename:e.posix.basename,e.extname=v?e.win32.extname:e.posix.extname,e.format=v?e.win32.format:e.posix.format,e.parse=v?e.win32.parse:e.posix.parse,e.toNamespacedPath=v?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v?e.win32.sep:e.posix.sep,e.delimiter=v?e.win32.delimiter:e.posix.delimiter}),define(ie[80],re([0,1,4]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var C;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(C=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(P,...g){const w=g.reduce((y,u)=>(y[u]=!0,y),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(y=>!w[y]).forEach(y=>{for(let u=0;u<b.length;u++)if(y.search(b[u])!==-1){delete P[y];break}})}e.sanitizeProcessEnvironment=R;function A(P){!P||(delete P.DEBUG,E.isMacintosh&&delete P.DYLD_LIBRARY_PATH,E.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=A}),define(ie[81],re([0,1,4]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=E.globals.performance&&typeof E.globals.performance.now=="function";class C{static create(A=!0){return new C(A)}constructor(A){this.a=t&&A,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?E.globals.performance.now():Date.now()}}e.StopWatch=C}),define(ie[3],re([0,1,15,50,2,96,81]),function(H,e,E,t,C,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,g=!1;var w;(function(c){c.None=()=>C.Disposable.None;function s(j){if(g){const{onDidAddListener:$}=j,Y=d.create();let B=0;j.onDidAddListener=()=>{++B===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Y.print()),$?.()}}}function f(j,$){return se(j,()=>{},0,void 0,void 0,$)}c.defer=f;function M(j){return($,Y=null,B)=>{let Z=!1,te;return te=j(ae=>{if(!Z)return te?te.dispose():Z=!0,$.call(Y,ae)},null,B),Z&&te.dispose(),te}}c.once=M;function L(j,$,Y){return _((B,Z=null,te)=>j(ae=>B.call(Z,$(ae)),null,te),Y)}c.map=L;function T(j,$,Y){return _((B,Z=null,te)=>j(ae=>{$(ae),B.call(Z,ae)},null,te),Y)}c.forEach=T;function U(j,$,Y){return _((B,Z=null,te)=>j(ae=>$(ae)&&B.call(Z,ae),null,te),Y)}c.filter=U;function K(j){return j}c.signal=K;function V(...j){return($,Y=null,B)=>(0,C.combinedDisposable)(...j.map(Z=>Z(te=>$.call(Y,te),null,B)))}c.any=V;function G(j,$,Y,B){let Z=Y;return L(j,te=>(Z=$(Z,te),Z),B)}c.reduce=G;function _(j,$){let Y;const B={onWillAddFirstListener(){Y=j(Z.fire,Z)},onDidRemoveLastListener(){Y?.dispose()}};$||s(B);const Z=new h(B);return $?.add(Z),Z.event}function se(j,$,Y=100,B=!1,Z,te){let ae,ge,ke,Oe=0;const De={leakWarningThreshold:Z,onWillAddFirstListener(){ae=j(ve=>{Oe++,ge=$(ge,ve),B&&!ke&&(Re.fire(ge),ge=void 0),clearTimeout(ke),ke=setTimeout(()=>{const we=ge;ge=void 0,ke=void 0,(!B||Oe>1)&&Re.fire(we),Oe=0},Y)})},onDidRemoveLastListener(){ae.dispose()}};te||s(De);const Re=new h(De);return te?.add(Re),Re.event}c.debounce=se;function ce(j,$=0,Y){return c.debounce(j,(B,Z)=>B?(B.push(Z),B):[Z],$,void 0,void 0,Y)}c.accumulate=ce;function X(j,$=(B,Z)=>B===Z,Y){let B=!0,Z;return U(j,te=>{const ae=B||!$(te,Z);return B=!1,Z=te,ae},Y)}c.latch=X;function ue(j,$,Y){return[c.filter(j,$,Y),c.filter(j,B=>!$(B),Y)]}c.split=ue;function z(j,$=!1,Y=[]){let B=Y.slice(),Z=j(ge=>{B?B.push(ge):ae.fire(ge)});const te=()=>{B?.forEach(ge=>ae.fire(ge)),B=null},ae=new h({onWillAddFirstListener(){Z||(Z=j(ge=>ae.fire(ge)))},onDidAddFirstListener(){B&&($?setTimeout(te):te())},onDidRemoveLastListener(){Z&&Z.dispose(),Z=null}});return ae.event}c.buffer=z;class N{constructor($){this.event=$,this.c=new C.DisposableStore}map($){return new N(L(this.event,$,this.c))}forEach($){return new N(T(this.event,$,this.c))}filter($){return new N(U(this.event,$,this.c))}reduce($,Y){return new N(G(this.event,$,Y,this.c))}latch(){return new N(X(this.event,void 0,this.c))}debounce($,Y=100,B=!1,Z){return new N(se(this.event,$,Y,B,Z,this.c))}on($,Y,B){return this.event($,Y,B)}once($,Y,B){return M(this.event)($,Y,B)}dispose(){this.c.dispose()}}function F(j){return new N(j)}c.chain=F;function q(j,$,Y=B=>B){const B=(...ge)=>ae.fire(Y(...ge)),Z=()=>j.on($,B),te=()=>j.removeListener($,B),ae=new h({onWillAddFirstListener:Z,onDidRemoveLastListener:te});return ae.event}c.fromNodeEventEmitter=q;function Q(j,$,Y=B=>B){const B=(...ge)=>ae.fire(Y(...ge)),Z=()=>j.addEventListener($,B),te=()=>j.removeEventListener($,B),ae=new h({onWillAddFirstListener:Z,onDidRemoveLastListener:te});return ae.event}c.fromDOMEventEmitter=Q;function oe(j){return new Promise($=>M(j)($))}c.toPromise=oe;function x(j,$){return $(void 0),j(Y=>$(Y))}c.runAndSubscribe=x;function D(j,$){let Y=null;function B(te){Y?.dispose(),Y=new C.DisposableStore,$(te,Y)}B(void 0);const Z=j(te=>B(te));return(0,C.toDisposable)(()=>{Z.dispose(),Y?.dispose()})}c.runAndSubscribeWithStore=D;class O{constructor($,Y){this.obs=$,this.c=0,this.d=!1;const B={onWillAddFirstListener:()=>{$.addObserver(this)},onDidRemoveLastListener:()=>{$.removeObserver(this)}};Y||s(B),this.emitter=new h(B),Y&&Y.add(this.emitter)}beginUpdate($){this.c++}handleChange($,Y){this.d=!0}endUpdate($){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function W(j,$){return new O(j,$).emitter.event}c.fromObservable=W})(w=e.Event||(e.Event={}));class b{constructor(s){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${s}_${b.c++}`,b.all.add(this)}start(s){this.d=new A.StopWatch(!0),this.listenerCount=s}stop(){if(this.d){const s=this.d.elapsed();this.durations.push(s),this.elapsedOverall+=s,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=b,b.all=new Set,b.c=0;let S=-1;function y(c){const s=S;return S=c,{dispose(){S=s}}}e.setGlobalLeakWarningThreshold=y;class u{constructor(s,f=Math.random().toString(18).slice(2,5)){this.threshold=s,this.name=f,this.d=0}dispose(){this.c?.clear()}check(s,f){const M=this.threshold;if(M<=0||f<M)return;this.c||(this.c=new Map);const L=this.c.get(s.value)||0;if(this.c.set(s.value,L+1),this.d-=1,this.d<=0){this.d=M*.5;let T,U=0;for(const[K,V]of this.c)(!T||U<V)&&(T=K,U=V);console.warn(`[${this.name}] potential listener LEAK detected, having ${f} listeners already. MOST frequent listener (${U}):`),console.warn(T)}return()=>{const T=this.c.get(s.value)||0;this.c.set(s.value,T-1)}}}class d{static create(){return new d(new Error().stack??"")}constructor(s){this.value=s}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class v{constructor(s,f,M){this.callback=s,this.callbackThis=f,this.stack=M,this.subscription=new C.SafeDisposable}invoke(s){this.callback.call(this.callbackThis,s)}}class h{constructor(s){this.j=!1,this.d=s,this.f=S>0||this.d?.leakWarningThreshold?new u(this.d?.leakWarningThreshold??S):void 0,this.g=this.d?._profName?new b(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(P){const s=Array.from(this.q);queueMicrotask(()=>{for(const f of s)f.subscription.isset()&&(f.subscription.unset(),f.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(s,f,M)=>{if(this.q||(this.q=new R.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),C.Disposable.None;const L=this.q.isEmpty();L&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let T,U;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(U=d.create(),T=this.f.check(U,this.q.size+1)),P&&(U=U??d.create());const K=new v(s,f,U),V=this.q.push(K);L&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,s,f);const G=K.subscription.set(()=>{T?.(),this.j||(V(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return M instanceof C.DisposableStore?M.add(G):Array.isArray(M)&&M.push(G),G}),this.l}fire(s){if(this.q){this.m||(this.m=new p);for(const f of this.q)this.m.push(this,f,s);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=h;class l{constructor(){this.c=new R.LinkedList}get size(){return this.c.size}push(s,f,M){this.c.push(new k(s,f,M))}clear(s){const f=new R.LinkedList;for(const M of this.c)M.emitter!==s&&f.push(M);this.c=f}deliver(){for(;this.c.size>0;){const s=this.c.shift();try{s.listener.invoke(s.event)}catch(f){(0,E.onUnexpectedError)(f)}}}}e.EventDeliveryQueue=l;class p extends l{clear(s){this.c.clear()}}class k{constructor(s,f,M){this.emitter=s,this.listener=f,this.event=M}}class I extends h{async fireAsync(s,f,M){if(!!this.q){this.c||(this.c=new R.LinkedList);for(const L of this.q)this.c.push([L,s]);for(;this.c.size>0&&!f.isCancellationRequested;){const[L,T]=this.c.shift(),U=[],K={...T,token:f,waitUntil:V=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");M&&(V=M(V,L.callback)),U.push(V)}};try{L.invoke(K)}catch(V){(0,E.onUnexpectedError)(V);continue}Object.freeze(U),await Promise.allSettled(U).then(V=>{for(const G of V)G.status==="rejected"&&(0,E.onUnexpectedError)(G.reason)})}}}}e.AsyncEmitter=I;class m extends h{constructor(s){super(s),this.h=0,this.s=new R.LinkedList,this.t=s?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const s=Array.from(this.s);this.s.clear(),super.fire(this.t(s))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(s){this.q&&(this.h!==0?this.s.push(s):super.fire(s))}}e.PauseableEmitter=m;class i extends m{constructor(s){super(s),this.c=s.delay??100}fire(s){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(s)}}e.DebounceEmitter=i;class r extends h{constructor(s){super(s),this.c=[],this.h=s?.merge}fire(s){!this.hasListeners()||(this.c.push(s),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(f=>super.fire(f)),this.c=[]}))}}e.MicrotaskEmitter=r;class n{constructor(){this.d=!1,this.f=[],this.c=new h({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(s){const f={event:s,listener:null};this.f.push(f),this.d&&this.j(f);const M=()=>{this.d&&this.k(f);const L=this.f.indexOf(f);this.f.splice(L,1)};return(0,C.toDisposable)((0,t.once)(M))}g(){this.d=!0,this.f.forEach(s=>this.j(s))}h(){this.d=!1,this.f.forEach(s=>this.k(s))}j(s){s.listener=s.event(f=>this.c.fire(f))}k(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=n;class a{constructor(){this.c=[]}wrapEvent(s){return(f,M,L)=>s(T=>{const U=this.c[this.c.length-1];U?U.push(()=>f.call(M,T)):f.call(M,T)},void 0,L)}bufferEvents(s){const f=[];this.c.push(f);const M=s();return this.c.pop(),f.forEach(L=>L()),M}}e.EventBufferer=a;class o{constructor(){this.c=!1,this.d=w.None,this.f=C.Disposable.None,this.g=new h({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(s){this.d=s,this.c&&(this.f.dispose(),this.f=s(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=o}),define(ie[22],re([0,1,3]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(P,g){const w=setTimeout(P.bind(g),0);return{dispose(){clearTimeout(w)}}});var C;(function(P){function g(w){return w===P.None||w===P.Cancelled||w instanceof R?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}P.isCancellationToken=g,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(C=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new E.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(g){this.a=void 0,this.b=void 0,this.b=g&&g.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new R),this.a}cancel(){this.a?this.a instanceof R&&this.a.cancel():this.a=C.Cancelled}dispose(g=!1){g&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof R&&this.a.dispose():this.a=C.None}}e.CancellationTokenSource=A}),define(ie[139],re([0,1,22]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new E.CancellationTokenSource,g=this.b(P.token);return this.a={promise:g,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.Cache=t;class C{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const g=JSON.stringify(P);return this.b!==g&&(this.b=g,this.a=this.c(P)),this.a}}e.LRUCachedFunction=C;class R{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const g=this.b(P);return this.a.set(P,g),g}}e.CachedFunction=R}),define(ie[26],re([0,1,139,125]),function(H,e,E,t){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(J){return!J||typeof J!="string"?!0:J.trim().length===0}e.isFalsyOrWhitespace=R;const A=/{(\d+)}/g;function P(J,...le){return le.length===0?J:J.replace(A,function(he,me){const Se=parseInt(me,10);return isNaN(Se)||Se<0||Se>=le.length?he:le[Se]})}e.format=P;const g=/{([^}]+)}/g;function w(J,le){return J.replace(g,(he,me)=>le[me]??he)}e.format2=w;function b(J){return J.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=b;function S(J){return J.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function y(J,le){let he=0;const me=le.charCodeAt(0);for(let Se=J.length-1;Se>=0;Se--)J.charCodeAt(Se)===me&&he++;return he}e.count=y;function u(J,le,he="\u2026"){return J.length<=le?J:`${J.substr(0,le)}${he}`}e.truncate=u;function d(J,le=" "){const he=v(J,le);return h(he,le)}e.trim=d;function v(J,le){if(!J||!le)return J;const he=le.length;if(he===0||J.length===0)return J;let me=0;for(;J.indexOf(le,me)===me;)me=me+he;return J.substring(me)}e.ltrim=v;function h(J,le){if(!J||!le)return J;const he=le.length,me=J.length;if(he===0||me===0)return J;let Se=me,Le=-1;for(;Le=J.lastIndexOf(le,Se-1),!(Le===-1||Le+he!==Se);){if(Le===0)return"";Se=Le}return J.substring(0,Se)}e.rtrim=h;function l(J){return J.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=l;function p(J){return J.replace(/\*/g,"")}e.stripWildcards=p;function k(J,le,he={}){if(!J)throw new Error("Cannot create regex from empty string");le||(J=S(J)),he.wholeWord&&(/\B/.test(J.charAt(0))||(J="\\b"+J),/\B/.test(J.charAt(J.length-1))||(J=J+"\\b"));let me="";return he.global&&(me+="g"),he.matchCase||(me+="i"),he.multiline&&(me+="m"),he.unicode&&(me+="u"),new RegExp(J,me)}e.createRegExp=k;function I(J){return J.source==="^"||J.source==="^$"||J.source==="$"||J.source==="^\\s*$"?!1:!!(J.exec("")&&J.lastIndex===0)}e.regExpLeadsToEndlessLoop=I;function m(J){return!!J.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=m;function i(J){return(J.global?"g":"")+(J.ignoreCase?"i":"")+(J.multiline?"m":"")+(J.unicode?"u":"")}e.regExpFlags=i;function r(J){return J.split(/\r\n|\r|\n/)}e.splitLines=r;function n(J){for(let le=0,he=J.length;le<he;le++){const me=J.charCodeAt(le);if(me!==32&&me!==9)return le}return-1}e.firstNonWhitespaceIndex=n;function a(J,le=0,he=J.length){for(let me=le;me<he;me++){const Se=J.charCodeAt(me);if(Se!==32&&Se!==9)return J.substring(le,me)}return J.substring(le,he)}e.getLeadingWhitespace=a;function o(J,le=J.length-1){for(let he=le;he>=0;he--){const me=J.charCodeAt(he);if(me!==32&&me!==9)return he}return-1}e.lastNonWhitespaceIndex=o;function c(J,le,he){const me=[];let Se=0;for(const Le of J.matchAll(le)){if(me.push(J.slice(Se,Le.index)),Le.index===void 0)throw new Error("match.index should be defined");Se=Le.index+Le[0].length,me.push(he(Le[0],...Le.slice(1),Le.index,J,Le.groups))}return me.push(J.slice(Se)),Promise.all(me).then(Le=>Le.join(""))}e.replaceAsync=c;function s(J,le){return J<le?-1:J>le?1:0}e.compare=s;function f(J,le,he=0,me=J.length,Se=0,Le=le.length){for(;he<me&&Se<Le;he++,Se++){const xe=J.charCodeAt(he),He=le.charCodeAt(Se);if(xe<He)return-1;if(xe>He)return 1}const Be=me-he,it=Le-Se;return Be<it?-1:Be>it?1:0}e.compareSubstring=f;function M(J,le){return L(J,le,0,J.length,0,le.length)}e.compareIgnoreCase=M;function L(J,le,he=0,me=J.length,Se=0,Le=le.length){for(;he<me&&Se<Le;he++,Se++){let xe=J.charCodeAt(he),He=le.charCodeAt(Se);if(xe===He)continue;if(xe>=128||He>=128)return f(J.toLowerCase(),le.toLowerCase(),he,me,Se,Le);U(xe)&&(xe-=32),U(He)&&(He-=32);const tt=xe-He;if(tt!==0)return tt}const Be=me-he,it=Le-Se;return Be<it?-1:Be>it?1:0}e.compareSubstringIgnoreCase=L;function T(J){return J>=48&&J<=57}e.isAsciiDigit=T;function U(J){return J>=97&&J<=122}e.isLowerAsciiLetter=U;function K(J){return J>=65&&J<=90}e.isUpperAsciiLetter=K;function V(J,le){return J.length===le.length&&L(J,le)===0}e.equalsIgnoreCase=V;function G(J,le){const he=le.length;return le.length>J.length?!1:L(J,le,0,he)===0}e.startsWithIgnoreCase=G;function _(J,le){const he=Math.min(J.length,le.length);let me;for(me=0;me<he;me++)if(J.charCodeAt(me)!==le.charCodeAt(me))return me;return he}e.commonPrefixLength=_;function se(J,le){const he=Math.min(J.length,le.length);let me;const Se=J.length-1,Le=le.length-1;for(me=0;me<he;me++)if(J.charCodeAt(Se-me)!==le.charCodeAt(Le-me))return me;return he}e.commonSuffixLength=se;function ce(J){return 55296<=J&&J<=56319}e.isHighSurrogate=ce;function X(J){return 56320<=J&&J<=57343}e.isLowSurrogate=X;function ue(J,le){return(J-55296<<10)+(le-56320)+65536}e.computeCodePoint=ue;function z(J,le,he){const me=J.charCodeAt(he);if(ce(me)&&he+1<le){const Se=J.charCodeAt(he+1);if(X(Se))return ue(me,Se)}return me}e.getNextCodePoint=z;function N(J,le){const he=J.charCodeAt(le-1);if(X(he)&&le>1){const me=J.charCodeAt(le-2);if(ce(me))return ue(me,he)}return he}class F{get offset(){return this.e}constructor(le,he=0){this.c=le,this.d=le.length,this.e=he}setOffset(le){this.e=le}prevCodePoint(){const le=N(this.c,this.e);return this.e-=le>=65536?2:1,le}nextCodePoint(){const le=z(this.c,this.d,this.e);return this.e+=le>=65536?2:1,le}eol(){return this.e>=this.d}}e.CodePointIterator=F;class q{get offset(){return this.c.offset}constructor(le,he=0){this.c=new F(le,he)}nextGraphemeLength(){const le=We.getInstance(),he=this.c,me=he.offset;let Se=le.getGraphemeBreakType(he.nextCodePoint());for(;!he.eol();){const Le=he.offset,Be=le.getGraphemeBreakType(he.nextCodePoint());if(be(Se,Be)){he.setOffset(Le);break}Se=Be}return he.offset-me}prevGraphemeLength(){const le=We.getInstance(),he=this.c,me=he.offset;let Se=le.getGraphemeBreakType(he.prevCodePoint());for(;he.offset>0;){const Le=he.offset,Be=le.getGraphemeBreakType(he.prevCodePoint());if(be(Be,Se)){he.setOffset(Le);break}Se=Be}return me-he.offset}eol(){return this.c.eol()}}e.GraphemeIterator=q;function Q(J,le){return new q(J,le).nextGraphemeLength()}e.nextCharLength=Q;function oe(J,le){return new q(J,le).prevGraphemeLength()}e.prevCharLength=oe;function x(J,le){le>0&&X(J.charCodeAt(le))&&le--;const he=le+Q(J,le);return[he-oe(J,he),he]}e.getCharContainingOffset=x;function D(J){const le=new q(J);let he=0;for(;!le.eol();)he++,le.nextGraphemeLength();return he}e.charCount=D;let O;function W(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function j(J){return O||(O=W()),O.test(J)}e.containsRTL=j;const $=/^[\t\n\r\x20-\x7E]*$/;function Y(J){return $.test(J)}e.isBasicASCII=Y,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function B(J){return e.UNUSUAL_LINE_TERMINATORS.test(J)}e.containsUnusualLineTerminators=B;function Z(J){return J>=11904&&J<=55215||J>=63744&&J<=64255||J>=65281&&J<=65374}e.isFullWidthCharacter=Z;function te(J){return J>=127462&&J<=127487||J===8986||J===8987||J===9200||J===9203||J>=9728&&J<=10175||J===11088||J===11093||J>=127744&&J<=128591||J>=128640&&J<=128764||J>=128992&&J<=129008||J>=129280&&J<=129535||J>=129648&&J<=129782}e.isEmojiImprecise=te;function ae(J,le){if(J.length<le)return J;const he=/\b/g;let me=0;for(;he.test(J)&&!(J.length-he.lastIndex<le);)me=he.lastIndex,he.lastIndex+=1;return J.substring(me).replace(/^\s/,"")}e.lcut=ae;const ge=/\x1B\x5B[12]?K/g,ke=/\x1b\[\d+m/g,Oe=/\x1b\[0?m/g;function De(J){return J&&(J=J.replace(ge,""),J=J.replace(ke,""),J=J.replace(Oe,"")),J}e.removeAnsiEscapeCodes=De,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Re(J){return!!(J&&J.length>0&&J.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Re;function ve(J){return Re(J)?J.substr(1):J}e.stripUTF8BOM=ve;function we(J,le){if(!J||!le||J.length<le.length)return!1;const he=le.length,me=J.toLowerCase();let Se=0,Le=-1;for(;Se<he;){const Be=me.indexOf(le[Se],Le+1);if(Be<0)return!1;Le=Be,Se++}return!0}e.fuzzyContains=we;function ye(J,le=!1){return J?(le&&(J=J.replace(/\\./g,"")),J.toLowerCase()!==J):!1}e.containsUppercaseCharacter=ye;function Me(J){return J.charAt(0).toUpperCase()+J.slice(1)}e.uppercaseFirstLetter=Me;function ne(J,le=1){if(le===0)return"";let he=-1;do he=J.indexOf(`
`,he+1),le--;while(le>0&&he>=0);return he===-1?J:(J[he-1]==="\r"&&he--,J.substr(0,he))}e.getNLines=ne;function fe(J){return J=J%(2*26),J<26?String.fromCharCode(97+J):String.fromCharCode(65+J-26)}e.singleLetterHash=fe;function de(J){return We.getInstance().getGraphemeBreakType(J)}e.getGraphemeBreakType=de;function be(J,le){return J===0?le!==5&&le!==7:J===2&&le===3?!1:J===4||J===2||J===3||le===4||le===2||le===3?!0:!(J===8&&(le===8||le===9||le===11||le===12)||(J===11||J===9)&&(le===9||le===10)||(J===12||J===10)&&le===10||le===5||le===13||le===7||J===1||J===13&&le===14||J===6&&le===6)}var Pe;(function(J){J[J.Other=0]="Other",J[J.Prepend=1]="Prepend",J[J.CR=2]="CR",J[J.LF=3]="LF",J[J.Control=4]="Control",J[J.Extend=5]="Extend",J[J.Regional_Indicator=6]="Regional_Indicator",J[J.SpacingMark=7]="SpacingMark",J[J.L=8]="L",J[J.V=9]="V",J[J.T=10]="T",J[J.LV=11]="LV",J[J.LVT=12]="LVT",J[J.ZWJ=13]="ZWJ",J[J.Extended_Pictographic=14]="Extended_Pictographic"})(Pe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class We{static getInstance(){return We.c||(We.c=new We),We.c}constructor(){this.d=Te()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const he=this.d,me=he.length/3;let Se=1;for(;Se<=me;)if(le<he[3*Se])Se=2*Se;else if(le>he[3*Se+1])Se=2*Se+1;else return he[3*Se+2];return 0}}We.c=null;function Te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function qe(J,le){if(J===0)return 0;const he=Ue(J,le);if(he!==void 0)return he;const me=new F(le,J);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=qe;function Ue(J,le){const he=new F(le,J);let me=he.prevCodePoint();for(;je(me)||me===65039||me===8419;){if(he.offset===0)return;me=he.prevCodePoint()}if(!te(me))return;let Se=he.offset;return Se>0&&he.prevCodePoint()===8205&&(Se=he.offset),Se}function je(J){return 127995<=J&&J<=127999}var Xe;(function(J){J[J.zwj=8205]="zwj",J[J.emojiVariantSelector=65039]="emojiVariantSelector",J[J.enclosingKeyCap=8419]="enclosingKeyCap"})(Xe||(Xe={})),e.noBreakWhitespace="\xA0";class $e{static getInstance(le){return $e.d.get(Array.from(le))}static getLocales(){return $e.e.getValue()}constructor(le){this.f=le}isAmbiguous(le){return this.f.has(le)}getPrimaryConfusable(le){return this.f.get(le)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=$e,C=$e,$e.c=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),$e.d=new E.LRUCachedFunction(J=>{function le(He){const tt=new Map;for(let nt=0;nt<He.length;nt+=2)tt.set(He[nt],He[nt+1]);return tt}function he(He,tt){const nt=new Map(He);for(const[lt,at]of tt)nt.set(lt,at);return nt}function me(He,tt){if(!He)return tt;const nt=new Map;for(const[lt,at]of He)tt.has(lt)&&nt.set(lt,at);return nt}const Se=C.c.getValue();let Le=J.filter(He=>!He.startsWith("_")&&He in Se);Le.length===0&&(Le=["_default"]);let Be;for(const He of Le){const tt=le(Se[He]);Be=me(Be,tt)}const it=le(Se._common),xe=he(it,Be);return new $e(xe)}),$e.e=new t.Lazy(()=>Object.keys($e.c.getValue()).filter(J=>!J.startsWith("_")));class Ke{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ke.c())),this.d}static isInvisibleCharacter(le){return Ke.e().has(le)}static get codePoints(){return Ke.e()}}e.InvisibleCharacters=Ke,Ke.d=void 0}),define(ie[30],re([0,1,9,4,26,11]),function(H,e,E,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(o){return o===47||o===92}e.isPathSeparator=A;function P(o){return o.replace(/[\\/]/g,E.posix.sep)}e.toSlashes=P;function g(o){return o.indexOf("/")===-1&&(o=P(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=g;function w(o,c=E.posix.sep){if(!o)return"";const s=o.length,f=o.charCodeAt(0);if(A(f)){if(A(o.charCodeAt(1))&&!A(o.charCodeAt(2))){let L=3;const T=L;for(;L<s&&!A(o.charCodeAt(L));L++);if(T!==L&&!A(o.charCodeAt(L+1))){for(L+=1;L<s;L++)if(A(o.charCodeAt(L)))return o.slice(0,L+1).replace(/[\\/]/g,c)}}return c}else if(l(f)&&o.charCodeAt(1)===58)return A(o.charCodeAt(2))?o.slice(0,2)+c:o.slice(0,2);let M=o.indexOf("://");if(M!==-1){for(M+=3;M<s;M++)if(A(o.charCodeAt(M)))return o.slice(0,M+1)}return""}e.getRoot=w;function b(o){if(!t.isWindows||!o||o.length<5)return!1;let c=o.charCodeAt(0);if(c!==92||(c=o.charCodeAt(1),c!==92))return!1;let s=2;const f=s;for(;s<o.length&&(c=o.charCodeAt(s),c!==92);s++);return!(f===s||(c=o.charCodeAt(s+1),isNaN(c)||c===92))}e.isUNC=b;const S=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(o,c=t.isWindows){const s=c?S:y;return!(!o||o.length===0||/^\s+$/.test(o)||(s.lastIndex=0,s.test(o))||c&&u.test(o)||o==="."||o===".."||c&&o[o.length-1]==="."||c&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=d;function v(o,c,s){const f=o===c;return!s||f?f:!o||!c?!1:(0,C.equalsIgnoreCase)(o,c)}e.isEqual=v;function h(o,c,s,f=E.sep){if(o===c)return!0;if(!o||!c||c.length>o.length)return!1;if(s){if(!(0,C.startsWithIgnoreCase)(o,c))return!1;if(c.length===o.length)return!0;let L=c.length;return c.charAt(c.length-1)===f&&L--,o.charAt(L)===f}return c.charAt(c.length-1)!==f&&(c+=f),o.indexOf(c)===0}e.isEqualOrParent=h;function l(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=l;function p(o,c){return t.isWindows&&o.endsWith(":")&&(o+=E.sep),(0,E.isAbsolute)(o)||(o=(0,E.join)(c,o)),o=(0,E.normalize)(o),t.isWindows?(o=(0,C.rtrim)(o,E.sep),o.endsWith(":")&&(o+=E.sep)):(o=(0,C.rtrim)(o,E.sep),o||(o=E.sep)),o}e.sanitizeFilePath=p;function k(o){const c=(0,E.normalize)(o);return t.isWindows?o.length>3?!1:I(c)&&(o.length===2||c.charCodeAt(2)===92):c===E.posix.sep}e.isRootOrDriveLetter=k;function I(o,c=t.isWindows){return c?l(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=I;function m(o){return I(o)?o[0]:void 0}e.getDriveLetter=m;function i(o,c,s){return c.length>o.length?-1:o===c?0:(s&&(o=o.toLowerCase(),c=c.toLowerCase()),o.indexOf(c))}e.indexOfPath=i;function r(o){const c=o.split(":");let s,f,M;for(const L of c){const T=Number(L);(0,R.isNumber)(T)?f===void 0?f=T:M===void 0&&(M=T):s=s?[s,L].join(":"):L}if(!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:f!==void 0?f:void 0,column:M!==void 0?M:f!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function a(o,c,s=8){let f="";for(let L=0;L<s;L++)f+=n.charAt(Math.floor(Math.random()*n.length));let M;return c?M=`${c}-${f}`:M=f,o?(0,E.join)(o,M):M}e.randomPath=a}),define(ie[68],re([0,1,26]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(l){return C(l,0)}e.hash=t;function C(l,p){switch(typeof l){case"object":return l===null?R(349,p):Array.isArray(l)?g(l,p):w(l,p);case"string":return P(l,p);case"boolean":return A(l,p);case"number":return R(l,p);case"undefined":return R(937,p);default:return R(617,p)}}e.doHash=C;function R(l,p){return(p<<5)-p+l|0}e.numberHash=R;function A(l,p){return R(l?433:863,p)}function P(l,p){p=R(149417,p);for(let k=0,I=l.length;k<I;k++)p=R(l.charCodeAt(k),p);return p}e.stringHash=P;function g(l,p){return p=R(104579,p),l.reduce((k,I)=>C(I,k),p)}function w(l,p){return p=R(181387,p),Object.keys(l).sort().reduce((k,I)=>(k=P(I,k),C(l[I],k)),p)}class b{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=C(p,this.g),this.g}}e.Hasher=b;var S;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function y(l,p,k=32){const I=k-p,m=~((1<<I)-1);return(l<<p|(m&l)>>>I)>>>0}function u(l,p=0,k=l.byteLength,I=0){for(let m=0;m<k;m++)l[p+m]=I}function d(l,p,k="0"){for(;l.length<p;)l=k+l;return l}function v(l,p=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(k=>k.toString(16).padStart(2,"0")).join(""):d((l>>>0).toString(16),p/4)}e.toHexString=v;class h{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const k=p.length;if(k===0)return;const I=this.p;let m=this.r,i=this.u,r,n;for(i!==0?(r=i,n=-1,i=0):(r=p.charCodeAt(0),n=0);;){let a=r;if(E.isHighSurrogate(r))if(n+1<k){const o=p.charCodeAt(n+1);E.isLowSurrogate(o)?(n++,a=E.computeCodePoint(r,o)):a=65533}else{i=r;break}else E.isLowSurrogate(r)&&(a=65533);if(m=this.w(I,m,a),n++,n<k)r=p.charCodeAt(n);else break}this.r=m,this.u=i}w(p,k,I){return I<128?p[k++]=I:I<2048?(p[k++]=192|(I&1984)>>>6,p[k++]=128|(I&63)>>>0):I<65536?(p[k++]=224|(I&61440)>>>12,p[k++]=128|(I&4032)>>>6,p[k++]=128|(I&63)>>>0):(p[k++]=240|(I&1835008)>>>18,p[k++]=128|(I&258048)>>>12,p[k++]=128|(I&4032)>>>6,p[k++]=128|(I&63)>>>0),k>=64&&(this.y(),k-=64,this.t+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),k}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,u(this.p,this.r),this.r>56&&(this.y(),u(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=h.g,k=this.q;for(let s=0;s<64;s+=4)p.setUint32(s,k.getUint32(s,!1),!1);for(let s=64;s<320;s+=4)p.setUint32(s,y(p.getUint32(s-12,!1)^p.getUint32(s-32,!1)^p.getUint32(s-56,!1)^p.getUint32(s-64,!1),1),!1);let I=this.h,m=this.l,i=this.m,r=this.n,n=this.o,a,o,c;for(let s=0;s<80;s++)s<20?(a=m&i|~m&r,o=1518500249):s<40?(a=m^i^r,o=1859775393):s<60?(a=m&i|m&r|i&r,o=2400959708):(a=m^i^r,o=3395469782),c=y(I,5)+a+n+o+p.getUint32(s*4,!1)&4294967295,n=r,r=i,i=y(m,30),m=I,I=c;this.h=this.h+I&4294967295,this.l=this.l+m&4294967295,this.m=this.m+i&4294967295,this.n=this.n+r&4294967295,this.o=this.o+n&4294967295}}e.StringSHA1=h,h.g=new DataView(new ArrayBuffer(320))}),define(ie[98],re([0,1,26]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(t||(t={})),function(C){const R="error",A="warning",P="warn",g="info",w="ignore";function b(y){return y?E.equalsIgnoreCase(R,y)?C.Error:E.equalsIgnoreCase(A,y)||E.equalsIgnoreCase(P,y)?C.Warning:E.equalsIgnoreCase(g,y)?C.Info:C.Ignore:C.Ignore}C.fromValue=b;function S(y){switch(y){case C.Error:return R;case C.Warning:return A;case C.Info:return g;default:return w}}C.toString=S}(t||(t={})),e.default=t}),define(ie[60],re([0,1,24,26]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class C{constructor(){this.b="",this.c=0}reset(u){return this.b=u,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(u){const d=u.charCodeAt(0),v=this.b.charCodeAt(this.c);return d-v}value(){return this.b[this.c]}}e.StringIterator=C;class R{constructor(u=!0){this.e=u}reset(u){return this.b=u,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let u=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(u)this.c++;else break;else u=!1;return this}cmp(u){return this.e?(0,t.compareSubstring)(u,this.b,0,u.length,this.c,this.d):(0,t.compareSubstringIgnoreCase)(u,this.b,0,u.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=R;class A{constructor(u=!0,d=!0){this.f=u,this.g=d}reset(u){this.d=0,this.e=0,this.b=u,this.c=u.length;for(let d=u.length-1;d>=0;d--,this.c--){const v=this.b.charCodeAt(d);if(!(v===47||this.f&&v===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let u=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===47||this.f&&d===92)if(u)this.d++;else break;else u=!1}return this}cmp(u){return this.g?(0,t.compareSubstring)(u,this.b,0,u.length,this.d,this.e):(0,t.compareSubstringIgnoreCase)(u,this.b,0,u.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=A;var P;(function(y){y[y.Scheme=1]="Scheme",y[y.Authority=2]="Authority",y[y.Path=3]="Path",y[y.Query=4]="Query",y[y.Fragment=5]="Fragment"})(P||(P={}));class g{constructor(u,d){this.f=u,this.g=d,this.d=[],this.e=0}reset(u){return this.c=u,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(u)),this.b.reset(u.path),this.b.value()&&this.d.push(3)),this.g(u)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(u){if(this.d[this.e]===1)return(0,t.compareIgnoreCase)(u,this.c.scheme);if(this.d[this.e]===2)return(0,t.compareIgnoreCase)(u,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(u);if(this.d[this.e]===4)return(0,t.compare)(u,this.c.query);if(this.d[this.e]===5)return(0,t.compare)(u,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=g;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const u=this.right;return this.right=u.left,u.left=this,this.updateHeight(),u.updateHeight(),u}rotateRight(){const u=this.left;return this.left=u.right,u.right=this,this.updateHeight(),u.updateHeight(),u}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(y){y[y.Left=-1]="Left",y[y.Mid=0]="Mid",y[y.Right=1]="Right"})(b||(b={}));class S{static forUris(u=()=>!1,d=()=>!1){return new S(new g(u,d))}static forPaths(u=!1){return new S(new A(void 0,!u))}static forStrings(){return new S(new C)}static forConfigKeys(){return new S(new R)}constructor(u){this.b=u}clear(){this.c=void 0}fill(u,d){if(d){const v=d.slice(0);(0,E.shuffle)(v);for(const h of v)this.set(h,u)}else{const v=u.slice(0);(0,E.shuffle)(v);for(const h of v)this.set(h[0],h[1])}}set(u,d){const v=this.b.reset(u);let h;this.c||(this.c=new w,this.c.segment=v.value());const l=[];for(h=this.c;;){const k=v.cmp(h.segment);if(k>0)h.left||(h.left=new w,h.left.segment=v.value()),l.push([-1,h]),h=h.left;else if(k<0)h.right||(h.right=new w,h.right.segment=v.value()),l.push([1,h]),h=h.right;else if(v.hasNext())v.next(),h.mid||(h.mid=new w,h.mid.segment=v.value()),l.push([0,h]),h=h.mid;else break}const p=h.value;h.value=d,h.key=u;for(let k=l.length-1;k>=0;k--){const I=l[k][1];I.updateHeight();const m=I.balanceFactor();if(m<-1||m>1){const i=l[k][0],r=l[k+1][0];if(i===1&&r===1)l[k][1]=I.rotateLeft();else if(i===-1&&r===-1)l[k][1]=I.rotateRight();else if(i===1&&r===-1)I.right=l[k+1][1]=l[k+1][1].rotateRight(),l[k][1]=I.rotateLeft();else if(i===-1&&r===1)I.left=l[k+1][1]=l[k+1][1].rotateLeft(),l[k][1]=I.rotateRight();else throw new Error;if(k>0)switch(l[k-1][0]){case-1:l[k-1][1].left=l[k][1];break;case 1:l[k-1][1].right=l[k][1];break;case 0:l[k-1][1].mid=l[k][1];break}else this.c=l[0][1]}}return p}get(u){return this.d(u)?.value}d(u){const d=this.b.reset(u);let v=this.c;for(;v;){const h=d.cmp(v.segment);if(h>0)v=v.left;else if(h<0)v=v.right;else if(d.hasNext())d.next(),v=v.mid;else break}return v}has(u){const d=this.d(u);return!(d?.value===void 0&&d?.mid===void 0)}delete(u){return this.e(u,!1)}deleteSuperstr(u){return this.e(u,!0)}e(u,d){const v=this.b.reset(u),h=[];let l=this.c;for(;l;){const p=v.cmp(l.segment);if(p>0)h.push([-1,l]),l=l.left;else if(p<0)h.push([1,l]),l=l.right;else if(v.hasNext())v.next(),h.push([0,l]),l=l.mid;else break}if(!!l){if(d?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const p=this.f(l.right);if(p.key){const{key:k,value:I,segment:m}=p;this.e(p.key,!1),l.key=k,l.value=I,l.segment=m}}else{const p=l.left??l.right;if(h.length>0){const[k,I]=h[h.length-1];switch(k){case-1:I.left=p;break;case 0:I.mid=p;break;case 1:I.right=p;break}}else this.c=p}for(let p=h.length-1;p>=0;p--){const k=h[p][1];k.updateHeight();const I=k.balanceFactor();if(I>1?(k.right.balanceFactor()>=0||(k.right=k.right.rotateRight()),h[p][1]=k.rotateLeft()):I<-1&&(k.left.balanceFactor()<=0||(k.left=k.left.rotateLeft()),h[p][1]=k.rotateRight()),p>0)switch(h[p-1][0]){case-1:h[p-1][1].left=h[p][1];break;case 1:h[p-1][1].right=h[p][1];break;case 0:h[p-1][1].mid=h[p][1];break}else this.c=h[0][1]}}}f(u){for(;u.left;)u=u.left;return u}findSubstr(u){const d=this.b.reset(u);let v=this.c,h;for(;v;){const l=d.cmp(v.segment);if(l>0)v=v.left;else if(l<0)v=v.right;else if(d.hasNext())d.next(),h=v.value||h,v=v.mid;else break}return v&&v.value||h}findSuperstr(u){const d=this.b.reset(u);let v=this.c;for(;v;){const h=d.cmp(v.segment);if(h>0)v=v.left;else if(h<0)v=v.right;else if(d.hasNext())d.next(),v=v.mid;else return v.mid?this.g(v.mid):void 0}}forEach(u){for(const[d,v]of this)u(v,d)}*[Symbol.iterator](){yield*this.g(this.c)}g(u){const d=[];return this.h(u,d),d[Symbol.iterator]()}h(u,d){!u||(u.left&&this.h(u.left,d),u.value&&d.push([u.key,u.value]),u.mid&&this.h(u.mid,d),u.right&&this.h(u.right,d))}_isBalanced(){const u=d=>{if(!d)return!0;const v=d.balanceFactor();return v<-1||v>1?!1:u(d.left)&&u(d.right)};return u(this.c)}}e.TernarySearchTree=S}),define(ie[7],re([0,1,9,4]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const C=/^\w[\w\d+.-]*$/,R=/^\//,A=/^\/\//;function P(n,a){if(!n.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!C.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!R.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function g(n,a){return!n&&!a?"file":n}function w(n,a){switch(n){case"https":case"http":case"file":a?a[0]!==S&&(a=S+a):a=S;break}return a}const b="",S="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{static isUri(a){return a instanceof u?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,o,c,s,f,M=!1){typeof a=="object"?(this.scheme=a.scheme||b,this.authority=a.authority||b,this.path=a.path||b,this.query=a.query||b,this.fragment=a.fragment||b):(this.scheme=g(a,M),this.authority=o||b,this.path=w(this.scheme,c||b),this.query=s||b,this.fragment=f||b,P(this,M))}get fsPath(){return k(this,!1)}with(a){if(!a)return this;let{scheme:o,authority:c,path:s,query:f,fragment:M}=a;return o===void 0?o=this.scheme:o===null&&(o=b),c===void 0?c=this.authority:c===null&&(c=b),s===void 0?s=this.path:s===null&&(s=b),f===void 0?f=this.query:f===null&&(f=b),M===void 0?M=this.fragment:M===null&&(M=b),o===this.scheme&&c===this.authority&&s===this.path&&f===this.query&&M===this.fragment?this:new v(o,c,s,f,M)}static parse(a,o=!1){const c=y.exec(a);return c?new v(c[2]||b,r(c[4]||b),r(c[5]||b),r(c[7]||b),r(c[9]||b),o):new v(b,b,b,b,b)}static file(a){let o=b;if(t.isWindows&&(a=a.replace(/\\/g,S)),a[0]===S&&a[1]===S){const c=a.indexOf(S,2);c===-1?(o=a.substring(2),a=S):(o=a.substring(2,c),a=a.substring(c)||S)}return new v("file",o,a,b,b)}static from(a){const o=new v(a.scheme,a.authority,a.path,a.query,a.fragment);return P(o,!0),o}static joinPath(a,...o){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return t.isWindows&&a.scheme==="file"?c=u.file(E.win32.join(k(a,!0),...o)).path:c=E.posix.join(a.path,...o),a.with({path:c})}toString(a=!1){return I(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof u)return a;{const o=new v(a);return o._formatted=a.external,o._fsPath=a._sep===d?a.fsPath:null,o}}else return a}}e.URI=u;const d=t.isWindows?1:void 0;class v extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=k(this,!1)),this._fsPath}toString(a=!1){return a?I(this,!0):(this._formatted||(this._formatted=I(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=d),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const h={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function l(n,a,o){let c,s=-1;for(let f=0;f<n.length;f++){const M=n.charCodeAt(f);if(M>=97&&M<=122||M>=65&&M<=90||M>=48&&M<=57||M===45||M===46||M===95||M===126||a&&M===47||o&&M===91||o&&M===93||o&&M===58)s!==-1&&(c+=encodeURIComponent(n.substring(s,f)),s=-1),c!==void 0&&(c+=n.charAt(f));else{c===void 0&&(c=n.substr(0,f));const L=h[M];L!==void 0?(s!==-1&&(c+=encodeURIComponent(n.substring(s,f)),s=-1),c+=L):s===-1&&(s=f)}}return s!==-1&&(c+=encodeURIComponent(n.substring(s))),c!==void 0?c:n}function p(n){let a;for(let o=0;o<n.length;o++){const c=n.charCodeAt(o);c===35||c===63?(a===void 0&&(a=n.substr(0,o)),a+=h[c]):a!==void 0&&(a+=n[o])}return a!==void 0?a:n}function k(n,a){let o;return n.authority&&n.path.length>1&&n.scheme==="file"?o=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?a?o=n.path.substr(1):o=n.path[1].toLowerCase()+n.path.substr(2):o=n.path,t.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=k;function I(n,a){const o=a?p:l;let c="",{scheme:s,authority:f,path:M,query:L,fragment:T}=n;if(s&&(c+=s,c+=":"),(f||s==="file")&&(c+=S,c+=S),f){let U=f.indexOf("@");if(U!==-1){const K=f.substr(0,U);f=f.substr(U+1),U=K.lastIndexOf(":"),U===-1?c+=o(K,!1,!1):(c+=o(K.substr(0,U),!1,!1),c+=":",c+=o(K.substr(U+1),!1,!0)),c+="@"}f=f.toLowerCase(),U=f.lastIndexOf(":"),U===-1?c+=o(f,!1,!0):(c+=o(f.substr(0,U),!1,!0),c+=f.substr(U))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const U=M.charCodeAt(1);U>=65&&U<=90&&(M=`/${String.fromCharCode(U+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const U=M.charCodeAt(0);U>=65&&U<=90&&(M=`${String.fromCharCode(U+32)}:${M.substr(2)}`)}c+=o(M,!0,!1)}return L&&(c+="?",c+=o(L,!1,!1)),T&&(c+="#",c+=a?T:l(T,!1,!1)),c}function m(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+m(n.substr(3)):n}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(n){return n.match(i)?n.replace(i,a=>m(a)):n}}),define(ie[140],re([0,1,7]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(w){const b=w;return b&&typeof b.type=="string"&&typeof b.severity=="string"}e.isRemoteConsoleLog=t;function C(w){const b=[];let S;try{const y=JSON.parse(w.arguments),u=y[y.length-1];u&&u.__$stack&&(y.pop(),S=u.__$stack),b.push(...y)}catch{b.push("Unable to log remote console arguments",w.arguments)}return{args:b,stack:S}}e.parse=C;function R(w){if(typeof w!="string")return R(C(w).stack);const b=w;if(b){const S=A(b),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(S||"");if(y&&y.length===4)return{uri:E.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.getFirstFrame=R;function A(w){if(!w)return w;const b=w.indexOf(`
`);return b===-1?w:w.substring(0,b)}function P(w,b){const{args:S,stack:y}=C(w),u=typeof S[0]=="string"&&S.length===1;let d=A(y);d&&(d=`(${d.trim()})`);let v=[];if(typeof S[0]=="string"?d&&u?v=[`%c[${b}] %c${S[0]} %c${d}`,g("blue"),g(""),g("grey")]:v=[`%c[${b}] %c${S[0]}`,g("blue"),g(""),...S.slice(1)]:v=[`%c[${b}]%`,g("blue"),...S],d&&!u&&v.push(d),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,v)}e.log=P;function g(w){return`color: ${w}`}}),define(ie[69],re([0,1,17,26,7]),function(H,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(w){return JSON.stringify(w,P)}e.stringify=R;function A(w){let b=JSON.parse(w);return b=g(b),b}e.parse=A;function P(w,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,t.regExpFlags)(b)}:b}function g(w,b=0){if(!w||b>200)return w;if(typeof w=="object"){switch(w.$mid){case 1:return C.URI.revive(w);case 2:return new RegExp(w.source,w.flags);case 16:return new Date(w.source)}if(w instanceof E.VSBuffer||w instanceof Uint8Array)return w;if(Array.isArray(w))for(let S=0;S<w.length;++S)w[S]=g(w[S],b+1);else for(const S in w)Object.hasOwnProperty.call(w,S)&&(w[S]=g(w[S],b+1))}return w}e.revive=g}),define(ie[14],re([0,1,4,7]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var C;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebook="vscode-notebook",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractive="vscode-interactive",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(C=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${C.vscodeRemoteResource}`}setPreferredWebSchema(w){this.d=w}setDelegate(w){this.e=w}setServerRootPath(w){this.f=`${w}/${C.vscodeRemoteResource}`}set(w,b,S){this.a[w]=b,this.b[w]=S}setConnectionToken(w,b){this.c[w]=b}getPreferredWebSchema(){return this.d}rewrite(w){if(this.e)return this.e(w);const b=w.authority;let S=this.a[b];S&&S.indexOf(":")!==-1&&S.indexOf("[")===-1&&(S=`[${S}]`);const y=this.b[b],u=this.c[b];let d=`path=${encodeURIComponent(w.path)}`;return typeof u=="string"&&(d+=`&${e.connectionTokenQueryName}=${encodeURIComponent(u)}`),t.URI.from({scheme:E.isWeb?this.d:C.vscodeRemoteResource,authority:`${S}:${y}`,path:this.f,query:d})}}e.RemoteAuthorities=new R,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class A{asBrowserUri(w){const b=this.b(w,H);return this.uriToBrowserUri(b)}uriToBrowserUri(w){return w.scheme===C.vscodeRemote?e.RemoteAuthorities.rewrite(w):w.scheme===C.file&&(E.isNative||E.isWebWorker&&E.globals.origin===`${C.vscodeFileResource}://${A.a}`)?w.with({scheme:C.vscodeFileResource,authority:w.authority||A.a,query:null,fragment:null}):w}asFileUri(w){const b=this.b(w,H);return this.uriToFileUri(b)}uriToFileUri(w){return w.scheme===C.vscodeFileResource?w.with({scheme:C.file,authority:w.authority!==A.a?w.authority:null,query:null,fragment:null}):w}b(w,b){return t.URI.isUri(w)?w:t.URI.parse(b.toUrl(w))}}A.a="vscode-app",e.FileAccess=new A;var P;(function(g){const w=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(w.get("3"));const b="vscode-coi";function S(u){let d;typeof u=="string"?d=new URL(u).searchParams:u instanceof URL?d=u.searchParams:t.URI.isUri(u)&&(d=new URL(u.toString(!0)).searchParams);const v=d?.get(b);if(!!v)return w.get(v)}g.getHeadersFromQuery=S;function y(u,d,v){if(!globalThis.crossOriginIsolated)return;const h=d&&v?"3":v?"2":"1";u instanceof URLSearchParams?u.set(b,h):u[b]=h}g.addSearchParam=y})(P=e.COI||(e.COI={}))}),define(ie[20],re([0,1,30,14,9,4,26,7]),function(H,e,E,t,C,R,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function g(u){return(0,P.uriToFsPath)(u,!0)}e.originalFSPath=g;class w{constructor(d){this.a=d}compare(d,v,h=!1){return d===v?0:(0,A.compare)(this.getComparisonKey(d,h),this.getComparisonKey(v,h))}isEqual(d,v,h=!1){return d===v?!0:!d||!v?!1:this.getComparisonKey(d,h)===this.getComparisonKey(v,h)}getComparisonKey(d,v=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,v,h=!1){if(d.scheme===v.scheme){if(d.scheme===t.Schemas.file)return E.isEqualOrParent(g(d),g(v),this.a(d))&&d.query===v.query&&(h||d.fragment===v.fragment);if((0,e.isEqualAuthority)(d.authority,v.authority))return E.isEqualOrParent(d.path,v.path,this.a(d),"/")&&d.query===v.query&&(h||d.fragment===v.fragment)}return!1}joinPath(d,...v){return P.URI.joinPath(d,...v)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return C.posix.basename(d.path)}extname(d){return C.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let v;return d.scheme===t.Schemas.file?v=P.URI.file(C.dirname(g(d))).path:(v=C.posix.dirname(d.path),d.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),v="/")),d.with({path:v})}normalizePath(d){if(!d.path.length)return d;let v;return d.scheme===t.Schemas.file?v=P.URI.file(C.normalize(g(d))).path:v=C.posix.normalize(d.path),d.with({path:v})}relativePath(d,v){if(d.scheme!==v.scheme||!(0,e.isEqualAuthority)(d.authority,v.authority))return;if(d.scheme===t.Schemas.file){const p=C.relative(g(d),g(v));return R.isWindows?E.toSlashes(p):p}let h=d.path||"/";const l=v.path||"/";if(this.a(d)){let p=0;for(const k=Math.min(h.length,l.length);p<k&&!(h.charCodeAt(p)!==l.charCodeAt(p)&&h.charAt(p).toLowerCase()!==l.charAt(p).toLowerCase());p++);h=l.substr(0,p)+h.substr(p)}return C.posix.relative(h,l)}resolvePath(d,v){if(d.scheme===t.Schemas.file){const h=P.URI.file(C.resolve(g(d),v));return d.with({authority:h.authority,path:h.path})}return v=E.toPosixPath(v),d.with({path:C.posix.resolve(d.path,v)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,v){return d===v||d!==void 0&&v!==void 0&&(0,A.equalsIgnoreCase)(d,v)}hasTrailingPathSeparator(d,v=C.sep){if(d.scheme===t.Schemas.file){const h=g(d);return h.length>E.getRoot(h).length&&h[h.length-1]===v}else{const h=d.path;return h.length>1&&h.charCodeAt(h.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,v=C.sep){return(0,e.hasTrailingPathSeparator)(d,v)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,v=C.sep){let h=!1;if(d.scheme===t.Schemas.file){const l=g(d);h=l!==void 0&&l.length===E.getRoot(l).length&&l[l.length-1]===v}else{v="/";const l=d.path;h=l.length===1&&l.charCodeAt(l.length-1)===47}return!h&&!(0,e.hasTrailingPathSeparator)(d,v)?d.with({path:d.path+"/"}):d}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(u=>u.scheme===t.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new w(u=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function b(u,d){const v=[];for(let h=0;h<u.length;h++){const l=d(u[h]);u.some((p,k)=>k===h?!1:(0,e.isEqualOrParent)(l,d(p)))||v.push(u[h])}return v}e.distinctParents=b;var S;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function d(v){const h=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(k=>{const[I,m]=k.split(":");I&&m&&h.set(I,m)});const p=v.path.substring(0,v.path.indexOf(";"));return p&&h.set(u.META_DATA_MIME,p),h}u.parseMetaData=d})(S=e.DataUri||(e.DataUri={}));function y(u,d,v){if(d){let h=u.path;return h&&h[0]!==C.posix.sep&&(h=C.posix.sep+h),u.with({scheme:v,authority:d,path:h})}return u.with({scheme:v})}e.toLocalResource=y}),define(ie[8],re([0,1,22,15,3,2,20,4]),function(H,e,E,t,C,R,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function g(x){return!!x&&typeof x.then=="function"}e.isThenable=g;function w(x){const D=new E.CancellationTokenSource,O=x(D.token),W=new Promise((j,$)=>{const Y=D.token.onCancellationRequested(()=>{Y.dispose(),D.dispose(),$(new t.CancellationError)});Promise.resolve(O).then(B=>{Y.dispose(),D.dispose(),j(B)},B=>{Y.dispose(),D.dispose(),$(B)})});return new class{cancel(){D.cancel()}then(j,$){return W.then(j,$)}catch(j){return this.then(void 0,j)}finally(j){return W.finally(j)}}}e.createCancelablePromise=w;function b(x,D,O){return new Promise((W,j)=>{const $=D.onCancellationRequested(()=>{$.dispose(),W(O)});x.then(W,j).finally(()=>$.dispose())})}e.raceCancellation=b;function S(x,D){return new Promise((O,W)=>{const j=D.onCancellationRequested(()=>{j.dispose(),W(new t.CancellationError)});x.then(O,W).finally(()=>j.dispose())})}e.raceCancellationError=S;async function y(x){let D=-1;const O=x.map((j,$)=>j.then(Y=>(D=$,Y))),W=await Promise.race(O);return x.forEach((j,$)=>{$!==D&&j.cancel()}),W}e.raceCancellablePromises=y;function u(x,D,O){let W;const j=setTimeout(()=>{W?.(void 0),O?.()},D);return Promise.race([x.finally(()=>clearTimeout(j)),new Promise($=>W=$)])}e.raceTimeout=u;function d(x){return new Promise((D,O)=>{const W=x();g(W)?W.then(D,O):D(W)})}e.asPromise=d;class v{constructor(){this.a=null,this.b=null,this.d=null}queue(D){if(this.a){if(this.d=D,!this.b){const O=()=>{this.b=null;const W=this.queue(this.d);return this.d=null,W};this.b=new Promise(W=>{this.a.then(O,O).then(W)})}return new Promise((O,W)=>{this.b.then(O,W)})}return this.a=D(),new Promise((O,W)=>{this.a.then(j=>{this.a=null,O(j)},j=>{this.a=null,W(j)})})}}e.Throttler=v;class h{constructor(){this.a=Promise.resolve(null)}queue(D){return this.a=this.a.then(()=>D(),()=>D())}}e.Sequencer=h;class l{constructor(){this.a=new Map}queue(D,O){const j=(this.a.get(D)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.a.get(D)===j&&this.a.delete(D)});return this.a.set(D,j),j}}e.SequencerByKey=l;const p=(x,D)=>{let O=!0;const W=setTimeout(()=>{O=!1,D()},x);return{isTriggered:()=>O,dispose:()=>{clearTimeout(W),O=!1}}},k=x=>{let D=!0;return queueMicrotask(()=>{D&&(D=!1,x())}),{isTriggered:()=>D,dispose:()=>{D=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class I{constructor(D){this.defaultDelay=D,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(D,O=this.defaultDelay){this.g=D,this.h(),this.b||(this.b=new Promise((j,$)=>{this.d=j,this.f=$}).then(()=>{if(this.b=null,this.d=null,this.g){const j=this.g;return this.g=null,j()}}));const W=()=>{this.a=null,this.d?.(null)};return this.a=O===e.MicrotaskDelay?k(W):p(O,W),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=I;class m{constructor(D){this.a=new I(D),this.b=new v}trigger(D,O){return this.a.trigger(()=>this.b.queue(D),O)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=m;class i{constructor(){this.a=!1,this.b=new Promise((D,O)=>{this.d=D})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=i;class r extends i{constructor(D){super(),this.f=setTimeout(()=>this.open(),D)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function n(x,D){return D?new Promise((O,W)=>{const j=setTimeout(()=>{$.dispose(),O()},x),$=D.onCancellationRequested(()=>{clearTimeout(j),$.dispose(),W(new t.CancellationError)})}):w(O=>n(x,O))}e.timeout=n;function a(x,D=0){const O=setTimeout(x,D);return(0,R.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=a;function o(x){const D=[];let O=0;const W=x.length;function j(){return O<W?x[O++]():null}function $(Y){Y!=null&&D.push(Y);const B=j();return B?B.then($):Promise.resolve(D)}return Promise.resolve(null).then($)}e.sequence=o;function c(x,D=W=>!!W,O=null){let W=0;const j=x.length,$=()=>{if(W>=j)return Promise.resolve(O);const Y=x[W++];return Promise.resolve(Y()).then(Z=>D(Z)?Promise.resolve(Z):$())};return $()}e.first=c;function s(x,D=W=>!!W,O=null){if(x.length===0)return Promise.resolve(O);let W=x.length;const j=()=>{W=-1;for(const $ of x)$.cancel?.()};return new Promise(($,Y)=>{for(const B of x)B.then(Z=>{--W>=0&&D(Z)?(j(),$(Z)):W===0&&$(O)}).catch(Z=>{--W>=0&&(j(),Y(Z))})})}e.firstParallel=s;class f{constructor(D){this.a=0,this.d=D,this.f=[],this.b=0,this.g=new C.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(D){return this.a++,new Promise((O,W)=>{this.f.push({factory:D,c:O,e:W}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const D=this.f.shift();this.b++;const O=D.factory();O.then(D.c,D.e),O.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=f;class M extends f{constructor(){super(1)}}e.Queue=M;class L{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const D=new z;return this.b.add(D),D.p}d(){for(const[,D]of this.a)if(D.size>0)return!1;return!0}queueFor(D,O=A.extUri){const W=O.getComparisonKey(D);let j=this.a.get(W);return j||(j=new M,C.Event.once(j.onDrained)(()=>{j?.dispose(),this.a.delete(W),this.f()}),this.a.set(W,j)),j}f(){!this.d()||this.g()}g(){for(const D of this.b)D.complete();this.b.clear()}dispose(){for(const[,D]of this.a)D.dispose();this.a.clear(),this.g()}}e.ResourceQueue=L;class T{constructor(D,O){this.a=-1,typeof D=="function"&&typeof O=="number"&&this.setIfNotSet(D,O)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(D,O){this.cancel(),this.a=setTimeout(()=>{this.a=-1,D()},O)}setIfNotSet(D,O){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,D()},O))}}e.TimeoutTimer=T;class U{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(D,O){this.cancel(),this.a=setInterval(()=>{D()},O)}}e.IntervalTimer=U;class K{constructor(D,O){this.b=-1,this.a=D,this.d=O,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(D=this.d){this.cancel(),this.b=setTimeout(this.f,D)}get delay(){return this.d}set delay(D){this.d=D}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=K;class V{constructor(D,O){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.a=D,this.b=O,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(D=this.b){D%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${D}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(D/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=V;class G extends K{constructor(D,O){super(D,O),this.j=[]}work(D){this.j.push(D),this.isScheduled()||this.schedule()}h(){const D=this.j;this.j=[],this.a?.(D)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=G;class _ extends R.Disposable{constructor(D,O){super(),this.g=D,this.h=O,this.a=[],this.b=this.B(new R.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(D){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+D.length>this.g.maxBufferedWork)return!1}else if(this.pending+D.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const O of D)this.a.push(O);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new K(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=_,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=x=>{(0,P.setTimeout0)(()=>{if(D)return;const O=Date.now()+15;x(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let D=!1;return{dispose(){D||(D=!0)}}}:e.runWhenIdle=(x,D)=>{const O=requestIdleCallback(x,typeof D=="number"?{timeout:D}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(O))}}}}();class se{constructor(D){this.d=!1,this.a=()=>{try{this.f=D()}catch(O){this.g=O}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=se;async function ce(x,D,O){let W;for(let j=0;j<O;j++)try{return await x()}catch($){W=$,await n(D)}throw W}e.retry=ce;class X{hasPending(D){return this.a?typeof D=="number"?this.a.taskId===D:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(D,O,W){return this.a={taskId:D,cancel:()=>W?.(),promise:O},O.then(()=>this.d(D),()=>this.d(D)),O}d(D){this.a&&D===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const D=this.b;this.b=void 0,D.run().then(D.promiseResolve,D.promiseReject)}}setNext(D){if(this.b)this.b.run=D;else{let O,W;const j=new Promise(($,Y)=>{O=$,W=Y});this.b={run:D,promise:j,promiseResolve:O,promiseReject:W}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=X;class ue{constructor(D,O=()=>Date.now()){this.d=D,this.f=O,this.a=0,this.b=0}increment(){const D=this.f();return D-this.a>this.d&&(this.a=D,this.b=0),this.b++,this.b}}e.IntervalCounter=ue;class z{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((D,O)=>{this.a=D,this.b=O})}complete(D){return new Promise(O=>{this.a(D),this.f=!0,O()})}error(D){return new Promise(O=>{this.b(D),this.d=!0,O()})}cancel(){new Promise(D=>{this.b(new t.CancellationError),this.d=!0,D()})}}e.DeferredPromise=z;var N;(function(x){async function D(W){let j;const $=await Promise.all(W.map(Y=>Y.then(B=>B,B=>{j||(j=B)})));if(typeof j<"u")throw j;return $}x.settled=D;function O(W){return new Promise(async(j,$)=>{try{await W(j,$)}catch(Y){$(Y)}})}x.withAsyncBody=O})(N=e.Promises||(e.Promises={}));var F;(function(x){x[x.Initial=0]="Initial",x[x.DoneOK=1]="DoneOK",x[x.DoneError=2]="DoneError"})(F||(F={}));class q{static fromArray(D){return new q(O=>{O.emitMany(D)})}static fromPromise(D){return new q(async O=>{O.emitMany(await D)})}static fromPromises(D){return new q(async O=>{await Promise.all(D.map(async W=>O.emitOne(await W)))})}static merge(D){return new q(async O=>{await Promise.all(D.map(async W=>{for await(const j of W)O.emitOne(j)}))})}constructor(D){this.a=0,this.b=[],this.d=null,this.f=new C.Emitter,queueMicrotask(async()=>{const O={emitOne:W=>this.g(W),emitMany:W=>this.h(W),reject:W=>this.k(W)};try{await Promise.resolve(D(O)),this.j()}catch(W){this.k(W)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}[Symbol.asyncIterator](){let D=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(D<this.b.length)return{done:!1,value:this.b[D++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.f.event)}while(!0)}}}static map(D,O){return new q(async W=>{for await(const j of D)W.emitOne(O(j))})}map(D){return q.map(this,D)}static filter(D,O){return new q(async W=>{for await(const j of D)O(j)&&W.emitOne(j)})}filter(D){return q.filter(this,D)}static coalesce(D){return q.filter(D,O=>!!O)}coalesce(){return q.coalesce(this)}static async toPromise(D){const O=[];for await(const W of D)O.push(W);return O}toPromise(){return q.toPromise(this)}g(D){this.a===0&&(this.b.push(D),this.f.fire())}h(D){this.a===0&&(this.b=this.b.concat(D),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(D){this.a===0&&(this.a=2,this.d=D,this.f.fire())}}e.AsyncIterableObject=q,q.EMPTY=q.fromArray([]);class Q extends q{constructor(D,O){super(O),this.l=D}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=Q;function oe(x){const D=new E.CancellationTokenSource,O=x(D.token);return new Q(D,async W=>{const j=D.token.onCancellationRequested(()=>{j.dispose(),D.dispose(),W.reject(new t.CancellationError)});try{for await(const $ of O){if(D.token.isCancellationRequested)return;W.emitOne($)}j.dispose(),D.dispose()}catch($){j.dispose(),D.dispose(),W.reject($)}})}e.createCancelableAsyncIterable=oe}),define(ie[99],re([0,1,24,8,30,39,9,4,26]),function(H,e,E,t,C,R,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function w(){return Object.create(null)}e.getEmptyExpression=w,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const b="[/\\\\]",S="[^/\\\\]",y=/\//g;function u(z,N){switch(z){case 0:return"";case 1:return`${S}*?`;default:return`(?:${b}|${S}+${b}${N?`|${b}${S}+`:""})*?`}}function d(z,N){if(!z)return[];const F=[];let q=!1,Q=!1,oe="";for(const x of z){switch(x){case N:if(!q&&!Q){F.push(oe),oe="";continue}break;case"{":q=!0;break;case"}":q=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}oe+=x}return oe&&F.push(oe),F}e.splitGlobAware=d;function v(z){if(!z)return"";let N="";const F=d(z,e.GLOB_SPLIT);if(F.every(q=>q===e.GLOBSTAR))N=".*";else{let q=!1;F.forEach((Q,oe)=>{if(Q===e.GLOBSTAR){if(q)return;N+=u(2,oe===F.length-1)}else{let x=!1,D="",O=!1,W="";for(const j of Q){if(j!=="}"&&x){D+=j;continue}if(O&&(j!=="]"||!W)){let $;j==="-"?$=j:(j==="^"||j==="!")&&!W?$="^":j===e.GLOB_SPLIT?$="":$=(0,g.escapeRegExpCharacters)(j),W+=$;continue}switch(j){case"{":x=!0;continue;case"[":O=!0;continue;case"}":{N+=`(?:${d(D,",").map(B=>v(B)).join("|")})`,x=!1,D="";break}case"]":{N+="["+W+"]",O=!1,W="";break}case"?":N+=S;continue;case"*":N+=u(1);continue;default:N+=(0,g.escapeRegExpCharacters)(j)}}oe<F.length-1&&(F[oe+1]!==e.GLOBSTAR||oe+2<F.length)&&(N+=b)}q=Q===e.GLOBSTAR})}return N}const h=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,k=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,I=/^\*\*((\/[\w\.-]+)+)\/?$/,m=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new R.LRUCache(1e4),r=function(){return!1},n=function(){return null};function a(z,N){if(!z)return n;let F;typeof z!="string"?F=z.pattern:F=z,F=F.trim();const q=`${F}_${!!N.trimForExclusions}`;let Q=i.get(q);if(Q)return o(Q,z);let oe;return h.test(F)?Q=s(F.substr(4),F):(oe=l.exec(c(F,N)))?Q=f(oe[1],F):(N.trimForExclusions?k:p).test(F)?Q=M(F,N):(oe=I.exec(c(F,N)))?Q=L(oe[1].substr(1),F,!0):(oe=m.exec(c(F,N)))?Q=L(oe[1],F,!1):Q=T(F),i.set(q,Q),o(Q,z)}function o(z,N){if(typeof N=="string")return z;const F=function(q,Q){return(0,C.isEqualOrParent)(q,N.base,!P.isLinux)?z((0,g.ltrim)(q.substr(N.base.length),A.sep),Q):null};return F.allBasenames=z.allBasenames,F.allPaths=z.allPaths,F.basenames=z.basenames,F.patterns=z.patterns,F}function c(z,N){return N.trimForExclusions&&z.endsWith("/**")?z.substr(0,z.length-2):z}function s(z,N){return function(F,q){return typeof F=="string"&&F.endsWith(z)?N:null}}function f(z,N){const F=`/${z}`,q=`\\${z}`,Q=function(x,D){return typeof x!="string"?null:D?D===z?N:null:x===z||x.endsWith(F)||x.endsWith(q)?N:null},oe=[z];return Q.basenames=oe,Q.patterns=[N],Q.allBasenames=oe,Q}function M(z,N){const F=X(z.slice(1,-1).split(",").map(D=>a(D,N)).filter(D=>D!==n),z),q=F.length;if(!q)return n;if(q===1)return F[0];const Q=function(D,O){for(let W=0,j=F.length;W<j;W++)if(F[W](D,O))return z;return null},oe=F.find(D=>!!D.allBasenames);oe&&(Q.allBasenames=oe.allBasenames);const x=F.reduce((D,O)=>O.allPaths?D.concat(O.allPaths):D,[]);return x.length&&(Q.allPaths=x),Q}function L(z,N,F){const q=A.sep===A.posix.sep,Q=q?z:z.replace(y,A.sep),oe=A.sep+Q,x=A.posix.sep+z;let D;return F?D=function(O,W){return typeof O=="string"&&(O===Q||O.endsWith(oe)||!q&&(O===z||O.endsWith(x)))?N:null}:D=function(O,W){return typeof O=="string"&&(O===Q||!q&&O===z)?N:null},D.allPaths=[(F?"*/":"./")+z],D}function T(z){try{const N=new RegExp(`^${v(z)}$`);return function(F){return N.lastIndex=0,typeof F=="string"&&N.test(F)?z:null}}catch{return n}}function U(z,N,F){return!z||typeof N!="string"?!1:K(z)(N,void 0,F)}e.match=U;function K(z,N={}){if(!z)return r;if(typeof z=="string"||V(z)){const F=a(z,N);if(F===n)return r;const q=function(Q,oe){return!!F(Q,oe)};return F.allBasenames&&(q.allBasenames=F.allBasenames),F.allPaths&&(q.allPaths=F.allPaths),q}return se(z,N)}e.parse=K;function V(z){const N=z;return N?typeof N.base=="string"&&typeof N.pattern=="string":!1}e.isRelativePattern=V;function G(z){return z.allBasenames||[]}e.getBasenameTerms=G;function _(z){return z.allPaths||[]}e.getPathTerms=_;function se(z,N){const F=X(Object.getOwnPropertyNames(z).map(D=>ce(D,z[D],N)).filter(D=>D!==n)),q=F.length;if(!q)return n;if(!F.some(D=>!!D.requiresSiblings)){if(q===1)return F[0];const D=function(j,$){let Y;for(let B=0,Z=F.length;B<Z;B++){const te=F[B](j,$);if(typeof te=="string")return te;(0,t.isThenable)(te)&&(Y||(Y=[]),Y.push(te))}return Y?(async()=>{for(const B of Y){const Z=await B;if(typeof Z=="string")return Z}return null})():null},O=F.find(j=>!!j.allBasenames);O&&(D.allBasenames=O.allBasenames);const W=F.reduce((j,$)=>$.allPaths?j.concat($.allPaths):j,[]);return W.length&&(D.allPaths=W),D}const Q=function(D,O,W){let j,$;for(let Y=0,B=F.length;Y<B;Y++){const Z=F[Y];Z.requiresSiblings&&W&&(O||(O=(0,A.basename)(D)),j||(j=O.substr(0,O.length-(0,A.extname)(D).length)));const te=Z(D,O,j,W);if(typeof te=="string")return te;(0,t.isThenable)(te)&&($||($=[]),$.push(te))}return $?(async()=>{for(const Y of $){const B=await Y;if(typeof B=="string")return B}return null})():null},oe=F.find(D=>!!D.allBasenames);oe&&(Q.allBasenames=oe.allBasenames);const x=F.reduce((D,O)=>O.allPaths?D.concat(O.allPaths):D,[]);return x.length&&(Q.allPaths=x),Q}function ce(z,N,F){if(N===!1)return n;const q=a(z,F);if(q===n)return n;if(typeof N=="boolean")return q;if(N){const Q=N.when;if(typeof Q=="string"){const oe=(x,D,O,W)=>{if(!W||!q(x,D))return null;const j=Q.replace("$(basename)",()=>O),$=W(j);return(0,t.isThenable)($)?$.then(Y=>Y?z:null):$?z:null};return oe.requiresSiblings=!0,oe}}return q}function X(z,N){const F=z.filter(D=>!!D.basenames);if(F.length<2)return z;const q=F.reduce((D,O)=>{const W=O.basenames;return W?D.concat(W):D},[]);let Q;if(N){Q=[];for(let D=0,O=q.length;D<O;D++)Q.push(N)}else Q=F.reduce((D,O)=>{const W=O.patterns;return W?D.concat(W):D},[]);const oe=function(D,O){if(typeof D!="string")return null;if(!O){let j;for(j=D.length;j>0;j--){const $=D.charCodeAt(j-1);if($===47||$===92)break}O=D.substr(j)}const W=q.indexOf(O);return W!==-1?Q[W]:null};oe.basenames=q,oe.patterns=Q,oe.allBasenames=q;const x=z.filter(D=>!D.basenames);return x.push(oe),x}function ue(z,N){return(0,E.equals)(z,N,(F,q)=>typeof F=="string"&&typeof q=="string"?F===q:typeof F!="string"&&typeof q!="string"?F.base===q.base&&F.pattern===q.pattern:!1)}e.patternsEquals=ue}),define(ie[34],re([0,1,24,30,9,4,20,26]),function(H,e,E,t,C,R,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function g(n,a){const{os:o,tildify:c,relative:s}=a;if(s){const L=w(n,s,o);if(typeof L=="string")return L}let f=n.fsPath;if(o===1&&!R.isWindows?f=f.replace(/\//g,"\\"):o!==1&&R.isWindows&&(f=f.replace(/\\/g,"/")),o!==1&&c?.userHome){const L=c.userHome.fsPath;let T;n.scheme!==c.userHome.scheme&&n.path.startsWith(C.posix.sep)?T=c.userHome.with({path:n.path}).fsPath:T=n.fsPath,f=y(T,L,o)}return(o===1?C.win32:C.posix).normalize(b(f,o===1))}e.getPathLabel=g;function w(n,a,o){const c=o===1?C.win32:C.posix,s=o===3?A.extUri:A.extUriIgnorePathCase,f=a.getWorkspace(),M=(0,E.firstOrDefault)(f.folders);if(!M)return;n.scheme!==M.uri.scheme&&n.path.startsWith(C.posix.sep)&&(n=M.uri.with({path:n.path}));const L=a.getWorkspaceFolder(n);if(!L)return;let T;if(s.isEqual(L.uri,n)?T="":T=s.relativePath(L.uri,n)??"",T&&(T=c.normalize(T)),f.folders.length>1&&!a.noPrefix){const U=L.name?L.name:s.basenameOrAuthority(L.uri);T=T?`${U} \u2022 ${T}`:U}return T}function b(n,a=R.isWindows){return(0,t.hasDriveLetter)(n,a)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=b;let S=Object.create(null);function y(n,a,o=R.OS){if(o===1||!n||!a)return n;let c=S.original===a?S.normalized:void 0;c||(c=a,R.isWindows&&(c=(0,t.toSlashes)(c)),c=`${(0,P.rtrim)(c,C.posix.sep)}${C.posix.sep}`,S={original:a,normalized:c});let s=n;return R.isWindows&&(s=(0,t.toSlashes)(s)),(o===3?s.startsWith(c):(0,P.startsWithIgnoreCase)(s,c))?`~/${s.substr(c.length)}`:n}e.tildify=y;function u(n,a){return n.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=u;const d="\u2026",v="\\\\",h="~";function l(n,a=C.sep){const o=new Array(n.length);let c=!1;for(let s=0;s<n.length;s++){const f=n[s];if(f===""){o[s]=`.${a}`;continue}if(!f){o[s]=f;continue}c=!0;let M="",L=f;L.indexOf(v)===0?(M=L.substr(0,L.indexOf(v)+v.length),L=L.substr(L.indexOf(v)+v.length)):L.indexOf(a)===0?(M=L.substr(0,L.indexOf(a)+a.length),L=L.substr(L.indexOf(a)+a.length)):L.indexOf(h)===0&&(M=L.substr(0,L.indexOf(h)+h.length),L=L.substr(L.indexOf(h)+h.length));const T=L.split(a);for(let U=1;c&&U<=T.length;U++)for(let K=T.length-U;c&&K>=0;K--){c=!1;let V=T.slice(K,K+U).join(a);for(let G=0;!c&&G<n.length;G++)if(G!==s&&n[G]&&n[G].indexOf(V)>-1){const _=K+U===T.length,se=K>0&&n[G].indexOf(a)>-1?a+V:V,ce=n[G].endsWith(se);c=!_||ce}if(!c){let G="";(T[0].endsWith(":")||M!=="")&&(K===1&&(K=0,U++,V=T[0]+a+V),K>0&&(G=T[0]+a),G=M+G),K>0&&(G=G+d+a),G=G+V,K+U<T.length&&(G=G+a+d),o[s]=G}}c&&(o[s]=f)}return o}e.shorten=l;var p;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function k(n,a=Object.create(null)){const o=[];let c=!1,s="";for(const f of n)if(f==="$"||c&&f==="{")s&&o.push({value:s,type:p.TEXT}),s="",c=!0;else if(f==="}"&&c){const M=a[s];if(typeof M=="string")M.length&&o.push({value:M,type:p.VARIABLE});else if(M){const L=o[o.length-1];(!L||L.type!==p.SEPARATOR)&&o.push({value:M.label,type:p.SEPARATOR})}s="",c=!1}else s+=f;return s&&!c&&o.push({value:s,type:p.TEXT}),o.filter((f,M)=>{if(f.type===p.SEPARATOR){const L=o[M-1],T=o[M+1];return[L,T].every(U=>U&&(U.type===p.VARIABLE||U.type===p.TEXT)&&U.value.length>0)}return!0}).map(f=>f.value).join("")}e.template=k;function I(n,a){return R.isMacintosh||a?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):n.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=I;function m(n,a){return R.isMacintosh||a?n.replace(/\(&&\w\)|&&/g,""):R.isWindows?n.replace(/&&|&/g,o=>o==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=m;function i(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=i;function r(n){const a=n.indexOf("/")!==-1?C.posix:C.win32,o=a.basename(n),c=a.dirname(n);return o.length?{name:o,parentPath:c}:{name:c,parentPath:""}}e.splitName=r}),define(ie[141],re([0,1,7]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(b){return b.toJSON()}class C{constructor(S){this.a=S}transformIncoming(S){const y=this.a.transformIncoming(S);return y===S?S:t(E.URI.from(y))}transformOutgoing(S){const y=this.a.transformOutgoing(S);return y===S?S:t(E.URI.from(y))}transformOutgoingURI(S){const y=this.a.transformOutgoing(S);return y===S?S:E.URI.from(y)}transformOutgoingScheme(S){return this.a.transformOutgoingScheme(S)}}e.URITransformer=C,e.DefaultURITransformer=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function R(b,S,y){if(!b||y>200)return null;if(typeof b=="object"){if(b instanceof E.URI)return S.transformOutgoing(b);for(const u in b)if(Object.hasOwnProperty.call(b,u)){const d=R(b[u],S,y+1);d!==null&&(b[u]=d)}}return null}function A(b,S){const y=R(b,S,0);return y===null?b:y}e.transformOutgoingURIs=A;function P(b,S,y,u){if(!b||u>200)return null;if(typeof b=="object"){if(b.$mid===1)return y?E.URI.revive(S.transformIncoming(b)):S.transformIncoming(b);for(const d in b)if(Object.hasOwnProperty.call(b,d)){const v=P(b[d],S,y,u+1);v!==null&&(b[d]=v)}}return null}function g(b,S){const y=P(b,S,!1,0);return y===null?b:y}e.transformIncomingURIs=g;function w(b,S){const y=P(b,S,!0,0);return y===null?b:y}e.transformAndReviveIncomingURIs=w}),define(ie[82],re([0,1,25,15,60,29,129]),function(H,e,E,t,C,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(b){return this.a||(this.a=C.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(b)}value(){if(this.b===void 0){let b=0,S=0;const y=(0,E.networkInterfaces)();for(const u in y){const d=y[u];if(d)for(const{mac:v,internal:h}of d)h||(S+=1,this.c(v.toUpperCase())&&(b+=1))}this.b=S>0?b/S:0}return this.b}};let P;async function g(){return P||(P=(async()=>await w()||R.generateUuid())()),P}e.getMachineId=g;async function w(){try{const b=await new Promise((y,u)=>{H(["crypto"],y,u)}),S=(0,A.getMac)();return b.createHash("sha256").update(S,"utf8").digest("hex")}catch(b){t.onUnexpectedError(b);return}}}),define(ie[23],re([0,1,40,25,142,8,30,77,9,4,20,7]),function(H,e,E,t,C,R,A,P,g,w,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function u(se,ce=y.UNLINK){if((0,A.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");return ce===y.UNLINK?v(se):d(se)}async function d(se){try{const ce=(0,A.randomPath)((0,t.tmpdir)());try{await E.promises.rename(se,ce)}catch(X){return X.code==="ENOENT"?void 0:v(se)}v(ce).catch(X=>{})}catch(ce){if(ce.code!=="ENOENT")throw ce}}async function v(se){return(0,C.promisify)(E.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function h(se){if((0,A.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");E.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=h;async function l(se,ce){return I(await(ce?p(se):(0,C.promisify)(E.readdir)(se)))}async function p(se){try{return await(0,C.promisify)(E.readdir)(se,{withFileTypes:!0})}catch(ue){console.warn("[node.js fs] readdir with filetypes failed with error: ",ue)}const ce=[],X=await l(se);for(const ue of X){let z=!1,N=!1,F=!1;try{const q=await e.Promises.lstat((0,g.join)(se,ue));z=q.isFile(),N=q.isDirectory(),F=q.isSymbolicLink()}catch(q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",q)}ce.push({name:ue,isFile:()=>z,isDirectory:()=>N,isSymbolicLink:()=>F})}return ce}function k(se){return I(E.readdirSync(se))}e.readdirSync=k;function I(se){return se.map(ce=>typeof ce=="string"?w.isMacintosh?(0,P.normalizeNFC)(ce):ce:(ce.name=w.isMacintosh?(0,P.normalizeNFC)(ce.name):ce.name,ce))}async function m(se){const ce=await l(se),X=[];for(const ue of ce)await r.existsDirectory((0,g.join)(se,ue))&&X.push(ue);return X}function i(se,ce=1e3){return new Promise(X=>{let ue=!1;const z=setInterval(()=>{ue||(ue=!0,E.access(se,N=>{ue=!1,N&&(clearInterval(z),X(void 0))}))},ce)})}e.whenDeleted=i;var r;(function(se){async function ce(z){let N;try{if(N=await e.Promises.lstat(z),!N.isSymbolicLink())return{stat:N}}catch{}try{return{stat:await e.Promises.stat(z),symbolicLink:N?.isSymbolicLink()?{dangling:!1}:void 0}}catch(F){if(F.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(w.isWindows&&F.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(z)),symbolicLink:{dangling:!1}}}catch(q){if(q.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw q}throw F}}se.stat=ce;async function X(z){try{const{stat:N,symbolicLink:F}=await se.stat(z);return N.isFile()&&F?.dangling!==!0}catch{}return!1}se.existsFile=X;async function ue(z){try{const{stat:N,symbolicLink:F}=await se.stat(z);return N.isDirectory()&&F?.dangling!==!0}catch{}return!1}se.existsDirectory=ue})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new R.ResourceQueue;function a(se,ce,X){return n.queueFor(S.URI.file(se),b.extUriBiasedIgnorePathCase).queue(()=>{const ue=M(X);return new Promise((z,N)=>s(se,ce,ue,F=>F?N(F):z()))})}let o=!0;function c(se){o=se}e.configureFlushOnWrite=c;function s(se,ce,X,ue){if(!o)return E.writeFile(se,ce,{mode:X.mode,flag:X.flag},ue);E.open(se,X.flag,X.mode,(z,N)=>{if(z)return ue(z);E.writeFile(N,ce,F=>{if(F)return E.close(N,()=>ue(F));E.fdatasync(N,q=>(q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",q),c(!1)),E.close(N,Q=>ue(Q))))})})}function f(se,ce,X){const ue=M(X);if(!o)return E.writeFileSync(se,ce,{mode:ue.mode,flag:ue.flag});const z=E.openSync(se,ue.flag,ue.mode);try{E.writeFileSync(z,ce);try{E.fdatasyncSync(z)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),c(!1)}}finally{E.closeSync(z)}}e.writeFileSync=f;function M(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function L(se,ce){if(se!==ce)try{await e.Promises.rename(se,ce)}catch(X){if(se.toLowerCase()!==ce.toLowerCase()&&X.code==="EXDEV"||se.endsWith("."))await T(se,ce,{preserveSymlinks:!1}),await u(se,y.MOVE);else throw X}}async function T(se,ce,X){return K(se,ce,{root:{source:se,target:ce},options:X,handledSourcePaths:new Set})}const U=511;async function K(se,ce,X){if(X.handledSourcePaths.has(se))return;X.handledSourcePaths.add(se);const{stat:ue,symbolicLink:z}=await r.stat(se);if(z){if(X.options.preserveSymlinks)try{return await _(se,ce,X)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if(z.dangling)return}return ue.isDirectory()?V(se,ce,ue.mode&U,X):G(se,ce,ue.mode&U)}async function V(se,ce,X,ue){await e.Promises.mkdir(ce,{recursive:!0,mode:X});const z=await l(se);for(const N of z)await K((0,g.join)(se,N),(0,g.join)(ce,N),ue)}async function G(se,ce,X){await e.Promises.copyFile(se,ce),await e.Promises.chmod(ce,X)}async function _(se,ce,X){let ue=await e.Promises.readlink(se);(0,A.isEqualOrParent)(ue,X.root.source,!w.isLinux)&&(ue=(0,g.join)(X.root.target,ue.substr(X.root.source.length+1))),await e.Promises.symlink(ue,ce)}e.Promises=new class{get access(){return(0,C.promisify)(E.access)}get stat(){return(0,C.promisify)(E.stat)}get lstat(){return(0,C.promisify)(E.lstat)}get utimes(){return(0,C.promisify)(E.utimes)}get read(){return(se,ce,X,ue,z)=>new Promise((N,F)=>{E.read(se,ce,X,ue,z,(q,Q,oe)=>q?F(q):N({bytesRead:Q,buffer:oe}))})}get readFile(){return(0,C.promisify)(E.readFile)}get write(){return(se,ce,X,ue,z)=>new Promise((N,F)=>{E.write(se,ce,X,ue,z,(q,Q,oe)=>q?F(q):N({bytesWritten:Q,buffer:oe}))})}get appendFile(){return(0,C.promisify)(E.appendFile)}get fdatasync(){return(0,C.promisify)(E.fdatasync)}get truncate(){return(0,C.promisify)(E.truncate)}get rename(){return(0,C.promisify)(E.rename)}get copyFile(){return(0,C.promisify)(E.copyFile)}get open(){return(0,C.promisify)(E.open)}get close(){return(0,C.promisify)(E.close)}get symlink(){return(0,C.promisify)(E.symlink)}get readlink(){return(0,C.promisify)(E.readlink)}get chmod(){return(0,C.promisify)(E.chmod)}get mkdir(){return(0,C.promisify)(E.mkdir)}get unlink(){return(0,C.promisify)(E.unlink)}get rmdir(){return(0,C.promisify)(E.rmdir)}get realpath(){return(0,C.promisify)(E.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return l}get readDirsInDir(){return m}get writeFile(){return a}get rm(){return u}get move(){return L}get copy(){return T}}}),define(ie[100],re([0,1,40,9,4,26,23]),function(H,e,E,t,C,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(y){if(C.isLinux)return y;const u=(0,t.dirname)(y);if(y===u)return y;const d=((0,t.basename)(y)||y).toLowerCase();try{const h=(0,A.readdirSync)(u).filter(l=>l.toLowerCase()===d);if(h.length===1){const l=P(u);if(l)return(0,t.join)(l,h[0])}else if(h.length>1){const l=h.indexOf(d);if(l>=0){const p=P(u);if(p)return(0,t.join)(p,h[l])}}}catch{}return null}e.realcaseSync=P;async function g(y){if(C.isLinux)return y;const u=(0,t.dirname)(y);if(y===u)return y;const d=((0,t.basename)(y)||y).toLowerCase();try{const h=(await A.Promises.readdir(u)).filter(l=>l.toLowerCase()===d);if(h.length===1){const l=await g(u);if(l)return(0,t.join)(l,h[0])}else if(h.length>1){const l=h.indexOf(d);if(l>=0){const p=await g(u);if(p)return(0,t.join)(p,h[l])}}}catch{}return null}e.realcase=g;async function w(y){try{return await A.Promises.realpath(y)}catch{const d=S(y);return await A.Promises.access(d,E.constants.R_OK),d}}e.realpath=w;function b(y){try{return E.realpathSync(y)}catch{const d=S(y);return E.accessSync(d,E.constants.R_OK),d}}e.realpathSync=b;function S(y){return(0,R.rtrim)((0,t.normalize)(y),t.sep)}}),define(ie[143],re([0,1,25,9,23]),function(H,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,A=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var g;(function(I){I[I.x64=0]="x64",I[I.x86=1]="x86",I[I.ARM=2]="ARM"})(g||(g={}));let w;switch(process.arch){case"ia32":case"x32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class S{constructor(m,i,r){this.exePath=m,this.displayName=i,this.a=r}async exists(){return this.a===void 0&&(this.a=await C.SymlinkSupport.existsFile(this.exePath)),this.a}}function y({useAlternateBitness:I=!1}={}){return I?w===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function u({useAlternateBitness:I=!1,findPreview:m=!1}={}){const i=y({useAlternateBitness:I});if(!i)return null;const r=t.join(i,"PowerShell");if(!await C.SymlinkSupport.existsDirectory(r))return null;let n=-1,a=null;for(const s of await C.Promises.readdir(r)){let f=-1;if(m){const L=s.indexOf("-");if(L<0)continue;const T=s.substring(0,L);if(!R.test(T)||s.substring(L+1)!=="preview")continue;f=parseInt(T,10)}else{if(!R.test(s))continue;f=parseInt(s,10)}if(f<=n)continue;const M=t.join(r,s,"pwsh.exe");!await C.SymlinkSupport.existsFile(M)||(a=M,n=f)}if(!a)return null;const o=i.includes("x86")?" (x86)":"",c=m?" Preview":"";return new S(a,`PowerShell${c}${o}`,!0)}async function d({findPreview:I}={}){if(!process.env.LOCALAPPDATA)return null;const m=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await C.SymlinkSupport.existsDirectory(m))return null;const{pwshMsixDirRegex:i,pwshMsixName:r}=I?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const n of await C.Promises.readdir(m))if(i.test(n)){const a=t.join(m,n,"pwsh.exe");return new S(a,r)}return null}function v(){const I=t.join(E.homedir(),".dotnet","tools","pwsh.exe");return new S(I,".NET Core PowerShell Global Tool")}function h(){const I=t.join(process.env.windir,w===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new S(I,"Windows PowerShell",!0)}async function*l(){let I=await u();I&&(yield I),I=await u({useAlternateBitness:!0}),I&&(yield I),I=await d(),I&&(yield I),I=v(),I&&(yield I),I=await u({findPreview:!0}),I&&(yield I),I=await d({findPreview:!0}),I&&(yield I),I=await u({useAlternateBitness:!0,findPreview:!0}),I&&(yield I),I=h(),I&&(yield I)}async function*p(){for await(const I of l())await I.exists()&&(yield I)}e.enumeratePowerShellInstallations=p;async function k(){for await(const I of p())return I;return null}e.getFirstAvailablePowerShellInstallation=k}),define(ie[83],re([0,1,9,4,33,80,11,23]),function(H,e,E,t,C,R,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function g(S=C.env){return S.comspec||"cmd.exe"}e.getWindowsShell=g;function w(S){let y=[],u=!1;const d=function(v){if(u){y.push(v);return}(!S.send(v,l=>{if(l&&console.error(l),u=!1,y.length>0){const p=y.slice(0);y=[],p.forEach(k=>d(k))}})||t.isWindows)&&(u=!0)};return{send:d}}e.createQueuedSender=w;var b;(function(S){async function y(u,d,v){if(E.isAbsolute(u))return u;if(d===void 0&&(d=C.cwd()),E.dirname(u)!=="."||(v===void 0&&A.isString(C.env.PATH)&&(v=C.env.PATH.split(E.delimiter)),v===void 0||v.length===0))return E.join(d,u);async function l(p){if(await P.Promises.exists(p)){let k;try{k=await P.Promises.stat(p)}catch(I){I.message.startsWith("EACCES")&&(k=await P.Promises.lstat(p))}return k?!k.isDirectory():!1}return!1}for(const p of v){let k;if(E.isAbsolute(p)?k=E.join(p,u):k=E.join(d,p,u),await l(k))return k;let I=k+".com";if(await l(I)||(I=k+".exe",await l(I)))return I}return E.join(d,u)}S.findExecutable=y})(b=e.win32||(e.win32={}))}),define(ie[101],re([0,1,46,14]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function C(A){return new Promise((P,g)=>{let w;const b=new Map;function S(u,d,v,h,l){const p=b.get(d);if(u===A||p){const k={name:y(v),cmd:v,pid:u,ppid:d,load:h,mem:l};b.set(u,k),u===A&&(w=k),p&&(p.children||(p.children=[]),p.children.push(k),p.children.length>1&&(p.children=p.children.sort((I,m)=>I.pid-m.pid)))}}function y(u){const d=/--vscode-window-kind=shared-process/,v=/--vscode-window-kind=issue-reporter/,h=/--vscode-window-kind=process-explorer/,l=/--utility-sub-type=network/,p=/--utility-sub-type=node.mojom.NodeService/,k=/--crashes-directory/,I=/\\pipe\\winpty-control/,m=/conhost\.exe/,i=/--type=([a-zA-Z-]+)/;if(k.exec(u))return"electron-crash-reporter";if(I.exec(u))return"winpty-process";if(m.exec(u))return"console-window-host (Windows internal process)";let r=i.exec(u);if(r&&r.length===2){if(r[1]==="renderer")return d.exec(u)?"shared-process":v.exec(u)?"issue-reporter":h.exec(u)?"process-explorer":"window";if(r[1]==="utility"){if(l.exec(u))return"utility-network-service";if(p.exec(u))return"extension-host"}return r[1]}const n=/[a-zA-Z-]+\.js/g;let a="";do r=n.exec(u),r&&(a+=r+" ");while(r);return a&&u.indexOf("node ")<0&&u.indexOf("node.exe")<0?`electron_node ${a}`:u}if(process.platform==="win32"){const u=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,v)=>{H(["windows-process-tree"],d,v)}).then(d=>{d.getProcessList(A,v=>{if(!v){g(new Error(`Root process ${A} not found`));return}d.getProcessCpuUsage(v,h=>{const l=new Map;h.forEach(p=>{const k=u(p.commandLine||"");l.set(p.pid,{name:y(k),cmd:k,pid:p.pid,ppid:p.ppid,load:p.cpu||0,mem:p.memory||0})}),w=l.get(A),w?(l.forEach(p=>{const k=l.get(p.ppid);k&&(k.children||(k.children=[]),k.children.push(p))}),l.forEach(p=>{p.children&&(p.children=p.children.sort((k,I)=>k.pid-I.pid))}),P(w)):g(new Error(`Root process ${A} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let u=function(){let d=[w];const v=[];for(;d.length;){const l=d.shift();l&&(v.push(l.pid),l.children&&(d=d.concat(l.children)))}let h=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);h+=" "+v.join(" "),(0,E.exec)(h,{},(l,p,k)=>{if(l||k)g(l||new Error(k.toString()));else{const I=p.toString().split(`
`);for(let m=0;m<v.length;m++){const i=b.get(v[m]);i.load=parseFloat(I[m])}if(!w){g(new Error(`Root process ${A} not found`));return}P(w)}})};(0,E.exec)("which ps",{},(d,v,h)=>{if(d||h)if(process.platform!=="linux")g(d||new Error(h.toString()));else{const l=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,E.exec)(l,{},(p,k,I)=>{p||I?g(p||new Error(I.toString())):(R(k,S),u())})}else{const l=v.toString().trim(),p="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,E.exec)(`${l} ${p}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(k,I,m)=>{k||m&&!m.includes("screen size is bogus")?g(k||new Error(m.toString())):(R(I,S),process.platform==="linux"?u():w?P(w):g(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=C;function R(A,P){const g=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=A.toString().split(`
`);for(const b of w){const S=g.exec(b.trim());S&&S.length===6&&P(parseInt(S[1]),parseInt(S[2]),S[5],parseFloat(S[3]),parseFloat(S[4]))}}}),define(ie[144],re([0,1,25,4,143,83]),function(H,e,E,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function A(S,y){return S===1?t.isWindows?b():R.getWindowsShell(y):g(S,y)}e.getSystemShell=A;let P=null;function g(S,y){if(t.isLinux&&S===2||t.isMacintosh&&S===3)return"/bin/bash";if(!P){let u;if(t.isWindows)u="/bin/bash";else{if(u=y.SHELL,!u)try{u=(0,E.userInfo)().shell}catch{}u||(u="sh"),u==="/bin/false"&&(u="/bin/bash")}P=u}return P}let w=null;async function b(){return w||(w=(await(0,C.getFirstAvailablePowerShellInstallation)()).exePath),w}});var pe=this&&this.__decorate||function(H,e,E,t){var C=arguments.length,R=C<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,E):t,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(H,e,E,t);else for(var P=H.length-1;P>=0;P--)(A=H[P])&&(R=(C<3?A(R):C>3?A(e,E,R):A(e,E))||R);return C>3&&R&&Object.defineProperty(e,E,R),R};define(ie[47],re([0,1,24,8,17,22,54,15,3,2,69,26,11]),function(H,e,E,t,C,R,A,P,g,w,b,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var u;(function(N){N[N.Promise=100]="Promise",N[N.PromiseCancel=101]="PromiseCancel",N[N.EventListen=102]="EventListen",N[N.EventDispose=103]="EventDispose"})(u||(u={}));function d(N){switch(N){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(N){N[N.Initialize=200]="Initialize",N[N.PromiseSuccess=201]="PromiseSuccess",N[N.PromiseError=202]="PromiseError",N[N.PromiseErrorObj=203]="PromiseErrorObj",N[N.EventFire=204]="EventFire"})(v||(v={}));function h(N){switch(N){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(N){N[N.Uninitialized=0]="Uninitialized",N[N.Idle=1]="Idle"})(l||(l={}));function p(N){let F=0;for(let q=0;;q+=7){const Q=N.read(1);if(F|=(Q.buffer[0]&127)<<q,!(Q.buffer[0]&128))return F}}const k=n(0);function I(N,F){if(F===0){N.write(k);return}let q=0;for(let oe=F;oe!==0;oe=oe>>>7)q++;const Q=C.VSBuffer.alloc(q);for(let oe=0;F!==0;oe++)Q.buffer[oe]=F&127,F=F>>>7,F>0&&(Q.buffer[oe]|=128);N.write(Q)}class m{constructor(F){this.b=F,this.a=0}read(F){const q=this.b.slice(this.a,this.a+F);return this.a+=q.byteLength,q}}e.BufferReader=m;class i{constructor(){this.a=[]}get buffer(){return C.VSBuffer.concat(this.a)}write(F){this.a.push(F)}}e.BufferWriter=i;var r;(function(N){N[N.Undefined=0]="Undefined",N[N.String=1]="String",N[N.Buffer=2]="Buffer",N[N.VSBuffer=3]="VSBuffer",N[N.Array=4]="Array",N[N.Object=5]="Object",N[N.Int=6]="Int"})(r||(r={}));function n(N){const F=C.VSBuffer.alloc(1);return F.writeUInt8(N,0),F}const a={Undefined:n(r.Undefined),String:n(r.String),Buffer:n(r.Buffer),VSBuffer:n(r.VSBuffer),Array:n(r.Array),Object:n(r.Object),Uint:n(r.Int)},o=typeof Buffer<"u";function c(N,F){if(typeof F>"u")N.write(a.Undefined);else if(typeof F=="string"){const q=C.VSBuffer.fromString(F);N.write(a.String),I(N,q.byteLength),N.write(q)}else if(o&&Buffer.isBuffer(F)){const q=C.VSBuffer.wrap(F);N.write(a.Buffer),I(N,q.byteLength),N.write(q)}else if(F instanceof C.VSBuffer)N.write(a.VSBuffer),I(N,F.byteLength),N.write(F);else if(Array.isArray(F)){N.write(a.Array),I(N,F.length);for(const q of F)c(N,q)}else if(typeof F=="number"&&(F|0)===F)N.write(a.Uint),I(N,F);else{const q=C.VSBuffer.fromString(JSON.stringify(F));N.write(a.Object),I(N,q.byteLength),N.write(q)}}e.serialize=c;function s(N){switch(N.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return N.read(p(N)).toString();case r.Buffer:return N.read(p(N)).buffer;case r.VSBuffer:return N.read(p(N));case r.Array:{const q=p(N),Q=[];for(let oe=0;oe<q;oe++)Q.push(s(N));return Q}case r.Object:return JSON.parse(N.read(p(N)).toString());case r.Int:return p(N)}}e.deserialize=s;class f{constructor(F,q,Q=null,oe=1e3){this.h=F,this.j=q,this.k=Q,this.l=oe,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(x=>this.q(x)),this.m({type:200})}registerChannel(F,q){this.b.set(F,q),setTimeout(()=>this.w(F),0)}m(F){switch(F.type){case 200:{const q=this.o([F.type]);this.k?.logOutgoing(q,0,1,h(F.type));return}case 201:case 202:case 204:case 203:{const q=this.o([F.type,F.id],F.data);this.k?.logOutgoing(q,F.id,1,h(F.type),F.data);return}}}o(F,q=void 0){const Q=new i;return c(Q,F),c(Q,q),this.p(Q.buffer)}p(F){try{return this.h.send(F),F.byteLength}catch{return 0}}q(F){const q=new m(F),Q=s(q),oe=s(q),x=Q[0];switch(x){case 100:return this.k?.logIncoming(F.byteLength,Q[1],1,`${d(x)}: ${Q[2]}.${Q[3]}`,oe),this.s({type:x,id:Q[1],channelName:Q[2],name:Q[3],arg:oe});case 102:return this.k?.logIncoming(F.byteLength,Q[1],1,`${d(x)}: ${Q[2]}.${Q[3]}`,oe),this.t({type:x,id:Q[1],channelName:Q[2],name:Q[3],arg:oe});case 101:return this.k?.logIncoming(F.byteLength,Q[1],1,`${d(x)}`),this.u({type:x,id:Q[1]});case 103:return this.k?.logIncoming(F.byteLength,Q[1],1,`${d(x)}`),this.u({type:x,id:Q[1]})}}s(F){const q=this.b.get(F.channelName);if(!q){this.v(F);return}const Q=new R.CancellationTokenSource;let oe;try{oe=q.call(this.j,F.name,F.arg,Q.token)}catch(O){oe=Promise.reject(O)}const x=F.id;oe.then(O=>{this.m({id:x,data:O,type:201}),this.d.delete(F.id)},O=>{O instanceof Error?this.m({id:x,data:{message:O.message,name:O.name,stack:O.stack?O.stack.split?O.stack.split(`
`):O.stack:void 0},type:202}):this.m({id:x,data:O,type:203}),this.d.delete(F.id)});const D=(0,w.toDisposable)(()=>Q.cancel());this.d.set(F.id,D)}t(F){const q=this.b.get(F.channelName);if(!q){this.v(F);return}const Q=F.id,x=q.listen(this.j,F.name,F.arg)(D=>this.m({id:Q,data:D,type:204}));this.d.set(F.id,x)}u(F){const q=this.d.get(F.id);q&&(q.dispose(),this.d.delete(F.id))}v(F){let q=this.g.get(F.channelName);q||(q=[],this.g.set(F.channelName,q));const Q=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.m({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);q.push({request:F,timeoutTimer:Q})}w(F){const q=this.g.get(F);if(q){for(const Q of q)switch(clearTimeout(Q.timeoutTimer),Q.request.type){case 100:this.s(Q.request);break;case 102:this.t(Q.request);break}this.g.delete(F)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,w.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=f;var M;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(M=e.RequestInitiator||(e.RequestInitiator={}));class L{constructor(F,q=null){this.l=F,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new g.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Q=>this.s(Q)),this.j=q}getChannel(F){const q=this;return{call(Q,oe,x){return q.a?Promise.reject(new P.CancellationError):q.m(F,Q,oe,x)},listen(Q,oe){return q.a?g.Event.None:q.o(F,Q,oe)}}}m(F,q,Q,oe=R.CancellationToken.None){const x=this.g++,O={id:x,type:100,channelName:F,name:q,arg:Q};if(oe.isCancellationRequested)return Promise.reject(new P.CancellationError);let W;return new Promise(($,Y)=>{if(oe.isCancellationRequested)return Y(new P.CancellationError);const B=()=>{const ge=ke=>{switch(ke.type){case 201:this.f.delete(x),$(ke.data);break;case 202:{this.f.delete(x);const Oe=new Error(ke.data.message);Oe.stack=Array.isArray(ke.data.stack)?ke.data.stack.join(`
`):ke.data.stack,Oe.name=ke.data.name,Y(Oe);break}case 203:this.f.delete(x),Y(ke.data);break}};this.f.set(x,ge),this.p(O)};let Z=null;this.b===l.Idle?B():(Z=(0,t.createCancelablePromise)(ge=>this.u()),Z.then(()=>{Z=null,B()}));const te=()=>{Z?(Z.cancel(),Z=null):this.p({id:x,type:101}),Y(new P.CancellationError)},ae=oe.onCancellationRequested(te);W=(0,w.combinedDisposable)((0,w.toDisposable)(te),ae),this.d.add(W)}).finally(()=>{this.d.delete(W)})}o(F,q,Q){const oe=this.g++,D={id:oe,type:102,channelName:F,name:q,arg:Q};let O=null;const W=new g.Emitter({onWillAddFirstListener:()=>{O=(0,t.createCancelablePromise)($=>this.u()),O.then(()=>{O=null,this.d.add(W),this.p(D)})},onDidRemoveLastListener:()=>{O?(O.cancel(),O=null):(this.d.delete(W),this.p({id:oe,type:103}))}}),j=$=>W.fire($.data);return this.f.set(oe,j),W.event}p(F){switch(F.type){case 100:case 102:{const q=this.q([F.type,F.id,F.channelName,F.name],F.arg);this.j?.logOutgoing(q,F.id,0,`${d(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const q=this.q([F.type,F.id]);this.j?.logOutgoing(q,F.id,0,d(F.type));return}}}q(F,q=void 0){const Q=new i;return c(Q,F),c(Q,q),this.r(Q.buffer)}r(F){try{return this.l.send(F),F.byteLength}catch{return 0}}s(F){const q=new m(F),Q=s(q),oe=s(q),x=Q[0];switch(x){case 200:return this.j?.logIncoming(F.byteLength,0,0,h(x)),this.t({type:Q[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(F.byteLength,Q[1],0,h(x),oe),this.t({type:Q[0],id:Q[1],data:oe})}}t(F){if(F.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(F.id)?.(F)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,w.dispose)(this.d.values()),this.d.clear()}}pe([A.memoize],L.prototype,"onDidInitializePromise",null),e.ChannelClient=L;class T{get connections(){const F=[];return this.f.forEach(q=>F.push(q)),F}constructor(F){this.a=new Map,this.f=new Set,this.g=new g.Emitter,this.onDidAddConnection=this.g.event,this.h=new g.Emitter,this.onDidRemoveConnection=this.h.event,F(({protocol:q,onDidClientDisconnect:Q})=>{g.Event.once(q.onMessage)(x=>{const D=new m(x),O=s(D),W=new f(q,O),j=new L(q);this.a.forEach((Y,B)=>W.registerChannel(B,Y));const $={channelServer:W,channelClient:j,ctx:O};this.f.add($),this.g.fire($),Q(()=>{W.dispose(),j.dispose(),this.f.delete($),this.h.fire($)})})})}getChannel(F,q){const Q=this;return{call(oe,x,D){let O;if((0,y.isFunction)(q)){const j=(0,E.getRandomElement)(Q.connections.filter(q));O=j?Promise.resolve(j):g.Event.toPromise(g.Event.filter(Q.onDidAddConnection,q))}else O=q.routeCall(Q,oe,x);const W=O.then(j=>j.channelClient.getChannel(F));return K(W).call(oe,x,D)},listen(oe,x){if((0,y.isFunction)(q))return Q.j(F,q,oe,x);const D=q.routeEvent(Q,oe,x).then(O=>O.channelClient.getChannel(F));return K(D).listen(oe,x)}}}j(F,q,Q,oe){const x=this;let D=new w.DisposableStore;const O=new g.Emitter({onWillAddFirstListener:()=>{D=new w.DisposableStore;const W=new g.EventMultiplexer,j=new Map,$=B=>{const te=B.channelClient.getChannel(F).listen(Q,oe),ae=W.add(te);j.set(B,ae)},Y=B=>{const Z=j.get(B);!Z||(Z.dispose(),j.delete(B))};x.connections.filter(q).forEach($),g.Event.filter(x.onDidAddConnection,q)($,void 0,D),x.onDidRemoveConnection(Y,void 0,D),W.event(O.fire,O,D),D.add(W)},onDidRemoveLastListener:()=>{D.dispose()}});return O.event}registerChannel(F,q){this.a.set(F,q),this.f.forEach(Q=>{Q.channelServer.registerChannel(F,q)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=T;class U{constructor(F,q,Q=null){const oe=new i;c(oe,q),F.send(oe.buffer),this.a=new L(F,Q),this.d=new f(F,q,Q)}getChannel(F){return this.a.getChannel(F)}registerChannel(F,q){this.d.registerChannel(F,q)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=U;function K(N){return{call(F,q,Q){return N.then(oe=>oe.call(F,q,Q))},listen(F,q){const Q=new g.Relay;return N.then(oe=>Q.input=oe.listen(F,q)),Q.event}}}e.getDelayedChannel=K;function V(N){let F=!1;return{call(q,Q,oe){return F?N.call(q,Q,oe):(0,t.timeout)(0).then(()=>F=!0).then(()=>N.call(q,Q,oe))},listen(q,Q){if(F)return N.listen(q,Q);const oe=new g.Relay;return(0,t.timeout)(0).then(()=>F=!0).then(()=>oe.input=N.listen(q,Q)),oe.event}}}e.getNextTickChannel=V;class G{constructor(F){this.a=F}routeCall(F){return this.b(F)}routeEvent(F){return this.b(F)}async b(F){for(const q of F.connections)if(await Promise.resolve(this.a(q.ctx)))return Promise.resolve(q);return await g.Event.toPromise(F.onDidAddConnection),await this.b(F)}}e.StaticRouter=G;var _;(function(N){function F(x,D){const O=x,W=D&&D.disableMarshalling,j=new Map;for(const $ in O)Q($)&&j.set($,g.Event.buffer(O[$],!0));return new class{listen($,Y,B){const Z=j.get(Y);if(Z)return Z;if(oe(Y)){const te=O[Y];if(typeof te=="function")return te.call(O,B)}throw new Error(`Event not found: ${Y}`)}call($,Y,B){const Z=O[Y];if(typeof Z=="function"){if(!W&&Array.isArray(B))for(let te=0;te<B.length;te++)B[te]=(0,b.revive)(B[te]);return Z.apply(O,B)}throw new Error(`Method not found: ${Y}`)}}}N.fromService=F;function q(x,D){const O=D&&D.disableMarshalling;return new Proxy({},{get(W,j){if(typeof j=="string")return D?.properties?.has(j)?D.properties.get(j):oe(j)?function($){return x.listen(j,$)}:Q(j)?x.listen(j):async function(...$){let Y;D&&!(0,y.isUndefinedOrNull)(D.context)?Y=[D.context,...$]:Y=$;const B=await x.call(j,Y);return O?B:(0,b.revive)(B)};throw new Error(`Property not found: ${String(j)}`)}})}N.toService=q;function Q(x){return x[0]==="o"&&x[1]==="n"&&S.isUpperAsciiLetter(x.charCodeAt(2))}function oe(x){return/^onDynamic/.test(x)&&S.isUpperAsciiLetter(x.charCodeAt(9))}})(_=e.ProxyChannel||(e.ProxyChannel={}));const se=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(N){if(Array.isArray(N))return N;if(N&&typeof N=="object"&&typeof N.toString=="function"){const F=N.toString();if(F!=="[object Object]")return F}return N}function X(N){return Array.isArray(N)?N.map(ce):ce(N)}function ue(N,F,q,Q,oe,x,D){D=X(D);const O=se[oe],W=O[Q%O.length];let j=[`%c[${N}]%c[${String(F).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(Q).padStart(5," ")} - ${x}`,"color: darkgreen","color: grey","color: grey",`color: ${W}`];/\($/.test(x)?(j=j.concat(D),j.push(")")):j.push(D),console.log.apply(console,j)}class z{constructor(F,q){this.d=F,this.f=q,this.a=0,this.b=0}logOutgoing(F,q,Q,oe,x){this.b+=F,ue(this.d,this.b,F,q,Q,oe,x)}logIncoming(F,q,Q,oe,x){this.a+=F,ue(this.f,this.a,F,q,Q,oe,x)}}e.IPCLogger=z}),define(ie[145],re([0,1,17,3,47]),function(H,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(g){this.a=g,this.onMessage=t.Event.fromDOMEventEmitter(this.a,"message",w=>E.VSBuffer.wrap(w.data)),g.start()}send(g){this.a.postMessage(g.buffer)}disconnect(){this.a.close()}}e.Protocol=R;class A extends C.IPCClient{constructor(g,w){const b=new R(g);super(b,w),this.b=b}dispose(){this.b.disconnect()}}e.Client=A}),define(ie[102],re([0,1,8,17,3,2,47]),function(H,e,E,t,C,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(L){L.Created="created",L.Read="read",L.Write="write",L.Open="open",L.Error="error",L.Close="close",L.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",L.NodeEndReceived="nodeEndReceived",L.NodeEndSent="nodeEndSent",L.NodeDrainBegin="nodeDrainBegin",L.NodeDrainEnd="nodeDrainEnd",L.zlibInflateError="zlibInflateError",L.zlibInflateData="zlibInflateData",L.zlibInflateInitialWrite="zlibInflateInitialWrite",L.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",L.zlibInflateWrite="zlibInflateWrite",L.zlibInflateFlushFired="zlibInflateFlushFired",L.zlibDeflateError="zlibDeflateError",L.zlibDeflateData="zlibDeflateData",L.zlibDeflateWrite="zlibDeflateWrite",L.zlibDeflateFlushFired="zlibDeflateFlushFired",L.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",L.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",L.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",L.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",L.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",L.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",L.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",L.ProtocolHeaderRead="protocolHeaderRead",L.ProtocolMessageRead="protocolMessageRead",L.ProtocolHeaderWrite="protocolHeaderWrite",L.ProtocolMessageWrite="protocolMessageWrite",L.ProtocolWrite="protocolWrite"})(P=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var g;(function(L){L.enableDiagnostics=!1,L.records=[];const T=new WeakMap;let U=0;function K(G,_){if(!T.has(G)){const se=String(++U);T.set(G,se)}return T.get(G)}function V(G,_,se,ce){if(!L.enableDiagnostics)return;const X=K(G,_);if(ce instanceof t.VSBuffer||ce instanceof Uint8Array||ce instanceof ArrayBuffer||ArrayBuffer.isView(ce)){const ue=t.VSBuffer.alloc(ce.byteLength);ue.set(ce),L.records.push({timestamp:Date.now(),id:X,label:_,type:se,buff:ue})}else L.records.push({timestamp:Date.now(),id:X,label:_,type:se,data:ce})}L.traceSocketEvent=V})(g=e.SocketDiagnostics||(e.SocketDiagnostics={}));var w;(function(L){L[L.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",L[L.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w=e.SocketCloseEventType||(e.SocketCloseEventType={}));let b=null;function S(){return b||(b=t.VSBuffer.alloc(0)),b}class y{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(T){this.a.push(T),this.b+=T.byteLength}read(T){return this.c(T,!0)}peek(T){return this.c(T,!1)}c(T,U){if(T===0)return S();if(T>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===T){const _=this.a[0];return U&&(this.a.shift(),this.b-=T),_}if(this.a[0].byteLength>T){const _=this.a[0].slice(0,T);return U&&(this.a[0]=this.a[0].slice(T),this.b-=T),_}const K=t.VSBuffer.alloc(T);let V=0,G=0;for(;T>0;){const _=this.a[G];if(_.byteLength>T){const se=_.slice(0,T);K.set(se,V),V+=T,U&&(this.a[G]=_.slice(T),this.b-=T),T-=T}else K.set(_,V),V+=_.byteLength,U?(this.a.shift(),this.b-=_.byteLength):G++,T-=_.byteLength}return K}}e.ChunkStream=y;var u;(function(L){L[L.None=0]="None",L[L.Regular=1]="Regular",L[L.Control=2]="Control",L[L.Ack=3]="Ack",L[L.Disconnect=5]="Disconnect",L[L.ReplayRequest=6]="ReplayRequest",L[L.Pause=7]="Pause",L[L.Resume=8]="Resume",L[L.KeepAlive=9]="KeepAlive",L[L.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",L[L.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(u||(u={}));function d(L){switch(L){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var v;(function(L){L[L.HeaderLength=13]="HeaderLength",L[L.AcknowledgeTime=2e3]="AcknowledgeTime",L[L.TimeoutTime=2e4]="TimeoutTime",L[L.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",L[L.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",L[L.KeepAliveSendTime=5e3]="KeepAliveSendTime",L[L.LatencySampleTime=6e4]="LatencySampleTime",L[L.LatencySampleCount=5]="LatencySampleCount",L[L.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",L[L.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(v=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(T,U,K,V){this.type=T,this.id=U,this.ack=K,this.data=V,this.writtenTime=0}get size(){return this.data.byteLength}}class l extends R.Disposable{constructor(T){super(),this.f=this.B(new C.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=T,this.b=!1,this.c=new y,this.B(this.a.onData(U=>this.acceptChunk(U))),this.lastReadTime=Date.now()}acceptChunk(T){if(!(!T||T.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(T);this.c.byteLength>=this.g.readLen;){const U=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=U.readUInt32BE(9),this.g.messageType=U.readUInt8(0),this.g.id=U.readUInt32BE(1),this.g.ack=U.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:d(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const K=this.g.messageType,V=this.g.id,G=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",U),this.f.fire(new h(K,V,G,U)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class p{constructor(T){this.k=null,this.a=!1,this.b=!1,this.c=T,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(T){if(this.a)return;T.writtenTime=Date.now(),this.lastWriteTime=Date.now();const U=t.VSBuffer.alloc(13);U.writeUInt8(T.type,0),U.writeUInt32BE(T.id,1),U.writeUInt32BE(T.ack,5),U.writeUInt32BE(T.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:d(T.type),id:T.id,ack:T.ack,messageSize:T.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",T.data),this.j(U,T.data)}g(T,U){const K=this.f===0;return this.d.push(T,U),this.f+=T.byteLength+U.byteLength,K}h(){const T=t.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,T}j(T,U){this.g(T,U)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const T=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:T.byteLength}),this.c.write(T)}}class k extends R.Disposable{constructor(T){super(),this.f=new C.Emitter,this.onMessage=this.f.event,this.g=new C.Emitter,this.onDidDispose=this.g.event,this.a=T,this.b=this.B(new p(this.a)),this.c=this.B(new l(this.a)),this.B(this.c.onMessage(U=>{U.type===1&&this.f.fire(U.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(T){this.b.write(new h(1,0,0,T))}}e.Protocol=k;class I extends A.IPCClient{static fromSocket(T,U){return new I(new k(T),U)}get onDidDispose(){return this.b.onDidDispose}constructor(T,U,K=null){super(T,U,K),this.b=T}dispose(){super.dispose();const T=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),T.end()}}e.Client=I;class m{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new C.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(T){this.b?this.d.length>0?this.d.push(T):this.a.fire(T):this.d.push(T)}flushBuffer(){this.d=[]}}e.BufferedEmitter=m;class i{constructor(T){this.data=T,this.next=null}}class r{constructor(){this.a=null,this.b=null}length(){let T=0,U=this.a;for(;U;)U=U.next,T++;return T}peek(){return this.a?this.a.data:null}toArray(){const T=[];let U=0,K=this.a;for(;K;)T[U++]=K.data,K=K.next;return T}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(T){const U=new i(T);if(!this.a){this.a=U,this.b=U;return}this.b.next=U,this.b=U}}class n{static getInstance(){return n.b||(n.b=new n),n.b}constructor(){this.c=[];const T=Date.now();for(let U=0;U<n.a;U++)this.c[U]=T-1e3*U;setInterval(()=>{for(let U=n.a;U>=1;U--)this.c[U]=this.c[U-1];this.c[0]=Date.now()},1e3)}d(){const T=Date.now(),U=(1+n.a)*1e3;let K=0;for(let V=0;V<n.a;V++)T-this.c[V]<=U&&K++;return 1-K/n.a}hasHighLoad(){return this.d()>=.5}}n.a=10,n.b=null;var a;(function(L){L[L.Good=0]="Good",L[L.Poor=1]="Poor"})(a=e.ConnectionHealth||(e.ConnectionHealth={}));function o(L){switch(L){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=o;class c{constructor(T){this.connectionHealth=T}}e.ConnectionHealthChangedEvent=c;class s{constructor(T,U){this.roundTripTime=T,this.recentHighRoundTripCount=U}}e.HighRoundTripTimeEvent=s;class f{get unacknowledgedCount(){return this.c-this.d}constructor(T){this.x=new m,this.onControlMessage=this.x.event,this.y=new m,this.onMessage=this.y.event,this.z=new m,this.onDidDispose=this.z.event,this.A=new m,this.onSocketClose=this.A.event,this.B=new m,this.onSocketTimeout=this.B.event,this.C=new m,this.onHighRoundTripTime=this.C.event,this.D=new m,this.onDidChangeConnectionHealth=this.D.event,this.u=T.loadEstimator??n.getInstance(),this.v=T.measureRoundTripTime??!1,this.w=T.sendKeepAlive??!0,this.a=!1,this.b=new r,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new R.DisposableStore,this.o=T.socket,this.p=this.t.add(new p(this.o)),this.q=this.t.add(new l(this.o)),this.t.add(this.q.onMessage(U=>this.E(U))),this.t.add(this.o.onClose(U=>this.A.fire(U))),this.r=this.t.add(new M),this.t.add(this.r.onSendLatencyRequest(U=>this.J(U))),this.t.add(this.r.onHighRoundTripTime(U=>this.C.fire(U))),this.t.add(this.r.onDidChangeConnectionHealth(U=>this.D.fire(U))),this.v&&this.r.start(),T.initialChunk&&this.q.acceptChunk(T.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const T=new h(5,0,0,S());this.p.write(T),this.p.flush()}sendPause(){const T=new h(7,0,0,S());this.p.write(T)}sendResume(){const T=new h(8,0,0,S());this.p.write(T)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(T,U){this.a=!0,this.t.dispose(),this.t=new R.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=T,this.p=this.t.add(new p(this.o)),this.q=this.t.add(new l(this.o)),this.t.add(this.q.onMessage(K=>this.E(K))),this.t.add(this.o.onClose(K=>this.A.fire(K))),this.r=this.t.add(new M),this.t.add(this.r.onSendLatencyRequest(K=>this.J(K))),this.t.add(this.r.onHighRoundTripTime(K=>this.C.fire(K))),this.t.add(this.r.onDidChangeConnectionHealth(K=>this.D.fire(K))),this.q.acceptChunk(U)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const T=new h(3,0,this.h,S());this.p.write(T);const U=this.b.toArray();for(let K=0,V=U.length;K<V;K++)this.p.write(U[K]);this.G()}acceptDisconnect(){this.z.fire()}E(T){if(T.ack>this.d){this.d=T.ack;do{const U=this.b.peek();if(U&&U.id<=T.ack)this.b.pop();else break}while(!0)}switch(T.type){case 0:break;case 1:{if(T.id>this.g)if(T.id!==this.g+1){const U=Date.now();U-this.m>1e4&&(this.m=U,this.p.write(new h(6,0,0,S())))}else this.g=T.id,this.j=Date.now(),this.F(),this.y.fire(T.data);break}case 2:{this.x.fire(T.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const U=this.b.toArray();for(let K=0,V=U.length;K<V;K++)this.p.write(U[K]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(T.data);break}case 11:{this.r.handleResponse(T.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(T){const U=++this.c;this.h=this.g;const K=new h(1,U,this.h,T);this.b.push(K),this.a||(this.p.write(K),this.G())}sendControl(T){const U=new h(2,0,0,T);this.p.write(U)}F(){if(this.g<=this.h||this.k)return;const T=Date.now()-this.j;if(T>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-T+5)}G(){if(this.c<=this.d||this.f||this.a)return;const T=this.b.peek(),U=Date.now()-T.writtenTime,K=Date.now()-this.q.lastReadTime,V=Date.now()-this.n;if(U>=2e4&&K>=2e4&&V>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:U,timeSinceLastReceivedSomeData:K});return}const G=Math.max(2e4-U,2e4-K,2e4-V,500);this.f=setTimeout(()=>{this.f=null,this.G()},G)}H(){if(this.g<=this.h)return;this.h=this.g;const T=new h(3,0,this.h,S());this.p.write(T)}I(){this.h=this.g;const T=new h(9,0,this.h,S());this.p.write(T)}J(T){this.h=this.g;const U=new h(10,0,this.h,T);this.p.write(U)}K(T){this.h=this.g;const U=new h(11,0,this.h,T);this.p.write(U)}}e.PersistentProtocol=f;class M extends R.Disposable{constructor(){super(),this.a=this.B(new C.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new C.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new C.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new E.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},T=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const T=++this.h,U=t.VSBuffer.alloc(4);U.writeUInt32BE(T,0),this.a.fire(U)},6e4)}handleResponse(T){if(T.byteLength!==4)return;const U=T.readUInt32BE(0);if(this.g<=0||U!==this.h)return;const K=Date.now()-this.g,V=this.k++;this.j[V%this.j.length]=K;const G=this.l,_=this.j.filter(se=>se>=1e3).length;this.l=_>=3?1:0,K>1e3&&this.b.fire(new s(K,_)),G!==this.l&&this.c.fire(this.l)}}}),define(ie[146],re([0,1,41,17,3,2,47,131]),function(H,e,E,t,C,R,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function g(b,S){const y=C.Event.fromNodeEventEmitter(E.validatedIpcMain,S,(d,v)=>({event:d,message:v})),u=C.Event.filter(y,({event:d})=>d.sender.id===b);return C.Event.map(u,({message:d})=>d&&t.VSBuffer.wrap(d))}class w extends A.IPCServer{static d(){const S=C.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:hello",({sender:y})=>y);return C.Event.map(S,y=>{const u=y.id;w.b.get(u)?.dispose();const v=new C.Emitter;w.b.set(u,(0,R.toDisposable)(()=>v.fire()));const h=g(u,"vscode:message"),l=C.Event.any(C.Event.signal(g(u,"vscode:disconnect")),v.event);return{protocol:new P.Protocol(y,h),onDidClientDisconnect:l}})}constructor(){super(w.d())}}e.Server=w,w.b=new Map}),define(ie[103],re([0,1,41,3,29,145]),function(H,e,E,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class A extends R.Client{constructor(w,b){super({addEventListener:(S,y)=>w.addListener(S,y),removeEventListener:(S,y)=>w.removeListener(S,y),postMessage:S=>w.postMessage(S),start:()=>w.start(),close:()=>w.close()},b)}}e.Client=A;async function P(g){if(g.isDestroyed()||g.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const w=(0,C.generateUuid)();g.webContents.send("vscode:createMessageChannel",w);const b=t.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:createMessageChannelResult",(y,u)=>({nonce:u,port:y.ports[0]})),{port:S}=await t.Event.toPromise(t.Event.once(t.Event.filter(b,y=>y.nonce===w)));return S}e.connect=P}),define(ie[147],re([0,1,46,8,17,22,140,15,3,2,44,83,80,47]),function(H,e,E,t,C,R,A,P,g,w,b,S,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends u.ChannelServer{constructor(l){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",p=>C.VSBuffer.wrap(Buffer.from(p,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.Server=d;class v{constructor(l,p){this.i=l,this.j=p,this.c=new Set,this.g=new Map,this.h=new g.Emitter,this.onDidProcessExit=this.h.event;const k=p&&p.timeout?p.timeout:6e4;this.b=new t.Delayer(k),this.d=null,this.f=null}getChannel(l){const p=this;return{call(k,I,m){return p.k(l,k,I,m)},listen(k,I){return p.l(l,k,I)}}}k(l,p,k,I=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(I.isCancellationRequested)return Promise.reject(P.canceled());this.b.cancel();const m=this.n(l),i=(0,t.createCancelablePromise)(a=>m.call(p,k,a)),r=I.onCancellationRequested(()=>i.cancel()),n=(0,w.toDisposable)(()=>i.cancel());return this.c.add(n),i.finally(()=>{r.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(l,p,k){if(!this.b)return g.Event.None;this.b.cancel();let I;const m=new g.Emitter({onWillAddFirstListener:()=>{I=this.n(l).listen(p,k)(m.fire,m),this.c.add(I)},onDidRemoveLastListener:()=>{this.c.delete(I),I.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return m.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],p=Object.create(null);p.env={...(0,b.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(p.env={...p.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(p.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,y.removeDangerousEnvVariables)(p.env),this.d=(0,E.fork)(this.i,l,p);const k=new g.Emitter;g.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,A.isRemoteConsoleLog)(o)){(0,A.log)(o,`IPC Library: ${this.j.serverName}`);return}k.fire(C.VSBuffer.wrap(Buffer.from(o,"base64")))});const m=this.j.useQueue?(0,S.createQueuedSender)(this.d):this.d,i=o=>this.d&&this.d.connected&&m.send(o.buffer.toString("base64")),r=k.event,n={send:i,onMessage:r};this.f=new u.ChannelClient(n);const a=()=>this.o();process.once("exit",a),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,c)=>{process.removeListener("exit",a),this.c.forEach(s=>(0,w.dispose)(s)),this.c.clear(),o!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:c})})}return this.f}n(l){let p=this.g.get(l);return p||(p=this.m.getChannel(l),this.g.set(l,p)),p}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=v}),define(ie[84],re([0,1,17,15,3,2,9,4,29,47,102]),function(H,e,E,t,C,R,A,P,g,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function S(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class y{traceSocketEvent(s,f){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,s,f)}constructor(s,f=""){this.f=!0,this.debugLabel=f,this.socket=s,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=M=>{if(this.traceSocketEvent("error",{code:M?.code,message:M?.message}),M){if(M.code==="EPIPE")return;(0,t.onUnexpectedError)(M)}},this.socket.on("error",this.a),this.b=M=>{this.traceSocketEvent("close",{hadError:M}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(s){const f=M=>{this.traceSocketEvent("read",M),s(E.VSBuffer.wrap(M))};return this.socket.on("data",f),{dispose:()=>this.socket.off("data",f)}}onClose(s){const f=M=>{s({type:0,hadError:M,error:void 0})};return this.socket.on("close",f),{dispose:()=>this.socket.off("close",f)}}onEnd(s){const f=()=>{s()};return this.socket.on("end",f),{dispose:()=>this.socket.off("end",f)}}write(s){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",s),this.socket.write(s.buffer,f=>{if(f){if(f.code==="EPIPE")return;(0,t.onUnexpectedError)(f)}})}catch(f){if(f.code==="EPIPE")return;(0,t.onUnexpectedError)(f)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((s,f)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),s();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent("nodeDrainEnd"),s()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.NodeSocket=y;var u;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(u||(u={}));var d;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(d||(d={}));class v extends R.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(s,f){this.socket.traceSocketEvent(s,f)}constructor(s,f,M,L){super(),this.f=this.B(new C.Emitter),this.g=this.B(new C.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=s,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:f,inflateBytesLength:M?.byteLength||0,recordInflateBytes:L}),this.a=this.B(new h(this,f,M,L,this.f,(T,U)=>this.k(T,U))),this.B(this.a.onError(T=>{console.error(T),(0,t.onUnexpectedError)(T),this.g.fire({type:0,hadError:!0,error:T})})),this.b=new b.ChunkStream,this.B(this.socket.onData(T=>this.l(T))),this.B(this.socket.onClose(T=>this.g.fire(T)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(s){return this.f.event(s)}onClose(s){return this.g.event(s)}onEnd(s){return this.socket.onEnd(s)}write(s){this.a.writeMessage(s)}k(s,f){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",s);let M=2;s.byteLength<126?M+=0:s.byteLength<2**16?M+=2:M+=8;const L=E.VSBuffer.alloc(M);if(f?L.writeUInt8(194,0):L.writeUInt8(130,0),s.byteLength<126)L.writeUInt8(s.byteLength,1);else if(s.byteLength<2**16){L.writeUInt8(126,1);let T=1;L.writeUInt8(s.byteLength>>>8&255,++T),L.writeUInt8(s.byteLength>>>0&255,++T)}else{L.writeUInt8(127,1);let T=1;L.writeUInt8(0,++T),L.writeUInt8(0,++T),L.writeUInt8(0,++T),L.writeUInt8(0,++T),L.writeUInt8(s.byteLength>>>24&255,++T),L.writeUInt8(s.byteLength>>>16&255,++T),L.writeUInt8(s.byteLength>>>8&255,++T),L.writeUInt8(s.byteLength>>>0&255,++T)}this.socket.write(E.VSBuffer.concat([L,s]))}end(){this.h=!0,this.socket.end()}l(s){if(s.byteLength!==0){for(this.b.acceptChunk(s);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const f=this.b.peek(this.j.readLen),M=f.readUInt8(0),L=(M&128)>>>7,T=(M&64)>>>6,U=f.readUInt8(1),K=(U&128)>>>7,V=U&127;this.j.state=2,this.j.readLen=2+(K?4:0)+(V===126?2:0)+(V===127?8:0),this.j.fin=L,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(T)),this.j.firstFrameOfMessage=Boolean(L),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const f=this.b.read(this.j.readLen),M=f.readUInt8(1),L=(M&128)>>>7;let T=M&127,U=1;T===126?T=f.readUInt8(++U)*2**8+f.readUInt8(++U):T===127&&(T=f.readUInt8(++U)*0+f.readUInt8(++U)*0+f.readUInt8(++U)*0+f.readUInt8(++U)*0+f.readUInt8(++U)*2**24+f.readUInt8(++U)*2**16+f.readUInt8(++U)*2**8+f.readUInt8(++U));let K=0;L&&(K=f.readUInt8(++U)*2**24+f.readUInt8(++U)*2**16+f.readUInt8(++U)*2**8+f.readUInt8(++U)),this.j.state=3,this.j.readLen=T,this.j.mask=K,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const f=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",f),k(f,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",f),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(f,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await C.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=v;class h extends R.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:E.VSBuffer.alloc(0)}constructor(s,f,M,L,T,U){super(),this.k=s,this.l=T,this.m=U,this.a=this.B(new C.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new C.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,f?(this.b=this.B(new l(this.k,L,M,{windowBits:15})),this.f=this.B(new p(this.k,{windowBits:15})),this.B(this.b.onError(K=>this.a.fire(K))),this.B(this.f.onError(K=>this.a.fire(K)))):(this.b=null,this.f=null)}writeMessage(s){this.g.push(s),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const s=this.g.shift();if(this.f){const f=await this.r(this.f,s);this.m(f,!0)}else this.m(s,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(s,f){return new Promise((M,L)=>{s.write(f),s.flush(T=>M(T))})}acceptFrame(s,f,M){this.h.push({data:s,isCompressed:f,isLastFrameOfMessage:M}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const s=this.h.shift();if(this.b&&s.isCompressed){const f=await this.u(this.b,s.data,s.isLastFrameOfMessage);this.l.fire(f)}else this.l.fire(s.data)}this.s=!1}}u(s,f,M){return new Promise((L,T)=>{s.write(f),M&&s.write(E.VSBuffer.fromByteArray([0,0,255,255])),s.flush(U=>L(U))})}}class l extends R.Disposable{get recordedInflateBytes(){return this.j?E.VSBuffer.concat(this.f):E.VSBuffer.alloc(0)}constructor(s,f,M,L){super(),this.h=s,this.j=f,this.a=this.B(new C.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=S().zlib.createInflateRaw(L),this.b.on("error",T=>{this.h.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.h.traceSocketEvent("zlibInflateData",T),this.g.push(E.VSBuffer.wrap(T))}),M&&(this.h.traceSocketEvent("zlibInflateInitialWrite",M.buffer),this.b.write(M.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(s){this.j&&this.f.push(s.clone()),this.h.traceSocketEvent("zlibInflateWrite",s),this.b.write(s.buffer)}flush(s){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const f=E.VSBuffer.concat(this.g);this.g.length=0,s(f)})}}class p extends R.Disposable{constructor(s,f){super(),this.g=s,this.a=this.B(new C.Emitter),this.onError=this.a.event,this.f=[],this.b=S().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",M=>{this.g.traceSocketEvent("zlibDeflateError",{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.g.traceSocketEvent("zlibDeflateData",M),this.f.push(E.VSBuffer.wrap(M))})}write(s){this.g.traceSocketEvent("zlibDeflateWrite",s.buffer),this.b.write(s.buffer)}flush(s){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let f=E.VSBuffer.concat(this.f);this.f.length=0,f=f.slice(0,f.byteLength-4),s(f)})}}function k(c,s){if(s===0)return;const f=c.byteLength>>>2;for(let V=0;V<f;V++){const G=c.readUInt32BE(V*4);c.writeUInt32BE(G^s,V*4)}const M=f*4,L=c.byteLength-M,T=s>>>24&255,U=s>>>16&255,K=s>>>8&255;L>=1&&c.writeUInt8(c.readUInt8(M)^T,M),L>=2&&c.writeUInt8(c.readUInt8(M+1)^U,M+1),L>=3&&c.writeUInt8(c.readUInt8(M+2)^K,M+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const I={[2]:107,[1]:103};function m(){const c=(0,g.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let s;return e.XDG_RUNTIME_DIR?s=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):s=(0,A.join)(S().os.tmpdir(),`vscode-ipc-${c}.sock`),r(s),s}e.createRandomIPCHandle=m;function i(c,s,f){const M=S().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${M}-${f}-${s}-sock`;let L;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?L=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-${M.substr(0,8)}-${f}-${s}.sock`):L=(0,A.join)(c,`${f}-${s}.sock`),r(L),L}e.createStaticIPCHandle=i;function r(c){const s=I[P.platform];typeof s=="number"&&c.length>=s&&console.warn(`WARNING: IPC handle "${c}" is longer than ${s} chars, try a shorter --user-data-dir`)}class n extends w.IPCServer{static b(s){const f=C.Event.fromNodeEventEmitter(s,"connection");return C.Event.map(f,M=>({protocol:new b.Protocol(new y(M,"ipc-server-connection")),onDidClientDisconnect:C.Event.once(C.Event.fromNodeEventEmitter(M,"close"))}))}constructor(s){super(n.b(s)),this.d=s}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=n;function a(c){return new Promise((s,f)=>{const M=S().net.createServer();M.on("error",f),M.listen(c,()=>{M.removeListener("error",f),s(new n(M))})})}e.serve=a;function o(c,s){return new Promise((f,M)=>{const L=S().net.createConnection(c,()=>{L.removeListener("error",M),f(b.Client.fromSocket(new y(L,`ipc-client${s}`),s))});L.once("error",M)})}e.connect=o}),define(ie[104],re([0,1,8,3,2,11]),function(H,e,E,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var A;(function(S){S[S.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",S[S.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(A=e.StorageHint||(e.StorageHint={}));function P(S){const y=S;return y?.changed instanceof Map||y?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var g;(function(S){S[S.None=0]="None",S[S.Initialized=1]="Initialized",S[S.Closed=2]="Closed"})(g=e.StorageState||(e.StorageState={}));class w extends C.Disposable{constructor(y,u=Object.create(null)){super(),this.m=y,this.n=u,this.b=this.B(new t.Emitter),this.onDidChangeStorage=this.b.event,this.c=g.None,this.f=new Map,this.g=new E.ThrottledDelayer(w.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(y=>this.r(y)))}r(y){y.changed?.forEach((u,d)=>this.s(d,u)),y.deleted?.forEach(u=>this.s(u,void 0))}s(y,u){if(this.c===g.Closed)return;let d=!1;(0,R.isUndefinedOrNull)(u)?d=this.f.delete(y):this.f.get(y)!==u&&(this.f.set(y,u),d=!0),d&&this.b.fire(y)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===g.None&&(this.c=g.Initialized,this.n.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(y,u){const d=this.f.get(y);return(0,R.isUndefinedOrNull)(d)?u:d}getBoolean(y,u){const d=this.get(y);return(0,R.isUndefinedOrNull)(d)?u:d==="true"}getNumber(y,u){const d=this.get(y);return(0,R.isUndefinedOrNull)(d)?u:parseInt(d,10)}async set(y,u){if(this.c===g.Closed)return;if((0,R.isUndefinedOrNull)(u))return this.delete(y);const d=String(u);if(this.f.get(y)!==d)return this.f.set(y,d),this.j.set(y,d),this.h.delete(y),this.b.fire(y),this.w()}async delete(y){if(!(this.c===g.Closed||!this.f.delete(y)))return this.h.has(y)||this.h.add(y),this.j.delete(y),this.b.fire(y),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=g.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const y={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(y).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(y){if(!!this.u)return this.w(y)}async w(y){return this.g.trigger(()=>this.v(),y)}async whenFlushed(){if(!!this.u)return new Promise(y=>this.l.push(y))}isInMemory(){return this.n.hint===A.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=w,w.a=100;class b{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(y){y.insert?.forEach((u,d)=>this.a.set(d,u)),y.delete?.forEach(u=>this.a.delete(u))}async close(){}}e.InMemoryStorageDatabase=b}),define(ie[148],re([0,1,8,3,39,9,23]),function(H,e,E,t,C,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class P{get onDidChangeItemsExternal(){return t.Event.None}constructor(b,S=Object.create(null)){this.g=b,this.h=S,this.c=(0,R.basename)(this.g),this.d=new g(this.h.logging),this.f=this.n(this.g)}async getItems(){const b=await this.f,S=new Map;return(await this.s(b,"SELECT * FROM ItemTable")).forEach(u=>S.set(u.key,u.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${S.size} rows`),S}async updateItems(b){const S=await this.f;return this.j(S,b)}j(b,S){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${S.insert?(0,C.mapToString)(S.insert):"0"}), delete(${S.delete?(0,C.setToString)(S.delete):"0"})`),this.t(b,()=>{const y=S.insert,u=S.delete;if(y&&y.size>0){const d=[];d.push([]);let v=0;y.forEach((h,l)=>{let p=d[v];p.length>P.b&&(v++,p=[],d.push(p)),p.push(l,h)}),d.forEach(h=>{this.u(b,`INSERT INTO ItemTable VALUES ${new Array(h.length/2).fill("(?,?)").join(",")}`,l=>l.run(h),()=>{const l=[];let p=0;return y.forEach((k,I)=>{l.push(I),p+=k.length}),`Keys: ${l.join(", ")} Length: ${p}`})})}if(u&&u.size){const d=[];d.push([]);let v=0;u.forEach(h=>{let l=d[v];l.length>P.b&&(v++,l=[],d.push(l)),l.push(h)}),d.forEach(h=>{this.u(b,`DELETE FROM ItemTable WHERE key IN (${new Array(h.length).fill("?").join(",")})`,l=>l.run(h),()=>{const l=[];return u.forEach(p=>{l.push(p)}),`Keys: ${l.join(", ")}`})})}})}async close(b){this.d.trace(`[storage ${this.c}] close()`);const S=await this.f;return this.k(S,b)}k(b,S){return new Promise((y,u)=>{b.db.close(d=>(d&&this.o(b,`[storage ${this.c}] close(): ${d}`),this.g===P.IN_MEMORY_PATH?y():!b.isErroneous&&!b.isInMemory?this.l().then(y,v=>(this.d.error(`[storage ${this.c}] backup(): ${v}`),y())):typeof S=="function"?A.Promises.unlink(this.g).then(()=>this.p(this.g).then(v=>{const h=()=>this.k(v,void 0);return this.j(v,{insert:S()}).then(()=>h(),l=>(h(),Promise.reject(l)))})).then(y,u):u(d||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const b=this.m(this.g);return A.Promises.copy(this.g,b,{preserveSymlinks:!1})}m(b){return`${b}.backup`}async checkIntegrity(b){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${b})`);const S=await this.f,y=await this.r(S,b?"PRAGMA integrity_check":"PRAGMA quick_check"),u=b?y.integrity_check:y.quick_check;return S.isErroneous?`${u} (last error: ${S.lastError})`:S.isInMemory?`${u} (in-memory!)`:u}async n(b,S=!0){this.d.trace(`[storage ${this.c}] open(${b}, retryOnBusy: ${S})`);try{return await this.p(b)}catch(y){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${y}`),y.code==="SQLITE_BUSY"&&S)return await(0,E.timeout)(P.a),this.n(b,!1);try{await A.Promises.unlink(b);try{await A.Promises.rename(this.m(b),b)}catch{}return await this.p(b)}catch(u){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${u}`),this.p(P.IN_MEMORY_PATH)}}}o(b,S){b.isErroneous=!0,b.lastError=S,this.d.error(S)}p(b){return new Promise((S,y)=>{new Promise((u,d)=>{H(["@vscode/sqlite3"],u,d)}).then(u=>{const d={db:new(this.d.isTracing?u.verbose().Database:u.Database)(b,v=>v?d.db&&v.code!=="SQLITE_CANTOPEN"?d.db.close(()=>y(v)):y(v):this.q(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>S(d),h=>d.db.close(()=>y(h)))),isInMemory:b===P.IN_MEMORY_PATH};d.db.on("error",v=>this.o(d,`[storage ${this.c}] Error (event): ${v}`)),this.d.isTracing&&d.db.on("trace",v=>this.d.trace(`[storage ${this.c}] Trace (event): ${v}`))},y)})}q(b,S){return new Promise((y,u)=>{b.db.exec(S,d=>d?(this.o(b,`[storage ${this.c}] exec(): ${d}`),u(d)):y())})}r(b,S){return new Promise((y,u)=>{b.db.get(S,(d,v)=>d?(this.o(b,`[storage ${this.c}] get(): ${d}`),u(d)):y(v))})}s(b,S){return new Promise((y,u)=>{b.db.all(S,(d,v)=>d?(this.o(b,`[storage ${this.c}] all(): ${d}`),u(d)):y(v))})}t(b,S){return new Promise((y,u)=>{b.db.serialize(()=>{b.db.run("BEGIN TRANSACTION"),S(),b.db.run("END TRANSACTION",d=>d?(this.o(b,`[storage ${this.c}] transaction(): ${d}`),u(d)):y())})})}u(b,S,y,u){const d=b.db.prepare(S),v=h=>{this.o(b,`[storage ${this.c}] prepare(): ${h} (${S}). Details: ${u()}`)};d.on("error",v),y(d),d.finalize(h=>{h&&v(h),d.removeListener("error",v)})}}e.SQLiteStorageDatabase=P,P.IN_MEMORY_PATH=":memory:",P.a=2e3,P.b=256;class g{constructor(b){b&&typeof b.logTrace=="function"&&process.env[g.VSCODE_TRACE_STORAGE]&&(this.a=b.logTrace),b&&typeof b.logError=="function"&&(this.b=b.logError)}get isTracing(){return!!this.a}trace(b){this.a?.(b)}error(b){this.b?.(b)}}g.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(ie[149],re([12,10]),function(H,e){return H.create("vs/code/electron-main/app",e)}),define(ie[150],re([12,10]),function(H,e){return H.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ie[151],re([12,10]),function(H,e){return H.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ie[152],re([12,10]),function(H,e){return H.create("vs/platform/environment/node/argv",e)}),define(ie[153],re([12,10]),function(H,e){return H.create("vs/platform/environment/node/argvHelper",e)}),define(ie[154],re([12,10]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ie[155],re([12,10]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ie[156],re([12,10]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ie[157],re([12,10]),function(H,e){return H.create("vs/platform/extensions/common/extensionValidator",e)}),define(ie[158],re([12,10]),function(H,e){return H.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ie[159],re([12,10]),function(H,e){return H.create("vs/platform/files/common/fileService",e)}),define(ie[160],re([12,10]),function(H,e){return H.create("vs/platform/files/common/files",e)}),define(ie[161],re([12,10]),function(H,e){return H.create("vs/platform/files/common/io",e)}),define(ie[162],re([12,10]),function(H,e){return H.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ie[163],re([12,10]),function(H,e){return H.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ie[164],re([12,10]),function(H,e){return H.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ie[165],re([12,10]),function(H,e){return H.create("vs/platform/menubar/electron-main/menubar",e)}),define(ie[166],re([12,10]),function(H,e){return H.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ie[167],re([12,10]),function(H,e){return H.create("vs/platform/request/common/request",e)}),define(ie[168],re([12,10]),function(H,e){return H.create("vs/platform/shell/node/shellEnv",e)}),define(ie[169],re([12,10]),function(H,e){return H.create("vs/platform/telemetry/common/telemetryService",e)}),define(ie[170],re([12,10]),function(H,e){return H.create("vs/platform/update/common/update.config.contribution",e)}),define(ie[171],re([12,10]),function(H,e){return H.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ie[172],re([12,10]),function(H,e){return H.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ie[173],re([12,10]),function(H,e){return H.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ie[174],re([12,10]),function(H,e){return H.create("vs/platform/workspace/common/workspace",e)}),define(ie[175],re([12,10]),function(H,e){return H.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ie[176],re([12,10]),function(H,e){return H.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ie[177],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function E(C){return C&&C.hasOwnProperty("folderUri")}e.isFolderBackupInfo=E;function t(C){return C&&C.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(ie[178],re([0,1,7]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function t(A){return typeof A?.backupFolder=="string"}e.isEmptyWindowBackupInfo=t;function C(A){let P=[];try{Array.isArray(A.workspaces)&&(P=A.workspaces.map(g=>({workspace:{id:g.id,configPath:E.URI.parse(g.configURIPath)},remoteAuthority:g.remoteAuthority})))}catch{}return P}e.deserializeWorkspaceInfos=C;function R(A){let P=[];try{Array.isArray(A.folders)&&(P=A.folders.map(g=>({folderUri:E.URI.parse(g.folderUri),remoteAuthority:g.remoteAuthority})))}catch{}return P}e.deserializeFolderInfos=R}),define(ie[179],re([0,1,3,2]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class C{constructor(){this.a=new E.Emitter,this.b=new E.Emitter,this.c=new E.Emitter,this.d=new E.Emitter}call(P,g,w){switch(g){case"close":return Promise.resolve(this.a.fire({sessionId:w[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:w[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:w[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:w[0],port:w[1],subId:w[2]}))}throw new Error("Method not implemented.")}listen(P,g,w){switch(g){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=C,C.ChannelName="extensionhostdebugservice";class R extends t.Disposable{constructor(P){super(),this.b=P}reload(P){this.b.call("reload",[P])}get onReload(){return this.b.listen("reload")}close(P){this.b.call("close",[P])}get onClose(){return this.b.listen("close")}attachSession(P,g,w){this.b.call("attach",[P,g,w])}get onAttachSession(){return this.b.listen("attach")}terminateSession(P,g){this.b.call("terminate",[P,g])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(P,g){return this.b.call("openExtensionDevelopmentHostWindow",[P,g])}}e.ExtensionHostDebugChannelClient=R}),define(ie[180],re([0,1,134,54,14,9,33,20,7]),function(H,e,E,t,C,R,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class w{get appRoot(){return(0,R.dirname)(C.FileAccess.asFileUri("").fsPath)}get userHome(){return g.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return g.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.b.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,E.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return g.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return g.URI.file((0,R.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(g.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=A.env.VSCODE_PORTABLE;return d?g.URI.file((0,R.join)(d,"argv.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,R.resolve)(d):(0,R.normalize)((0,R.join)(C.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?g.URI.file((0,R.resolve)(d)):g.URI.file((0,R.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,R.resolve)(d);const v=A.env.VSCODE_EXTENSIONS;if(v)return v;const h=A.env.VSCODE_PORTABLE;return h?(0,R.join)(h,"extensions"):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(v=>/^[^:/?#]+?:\/\//.test(v)?g.URI.parse(v):g.URI.file((0,R.normalize)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?g.URI.parse(d):g.URI.file((0,R.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(d))}get extensionLogLevel(){const d=[];for(const v of this.args.log||[]){const h=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(v);h&&h[1]&&h[2]&&d.push([h[1],h[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return g.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=A.env.VSCODE_PORTABLE;return d?g.URI.file((0,R.join)(d,"policy.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,v,h){this.a=d,this.b=v,this.c=h,this.editSessionId=this.args.editSessionId}}pe([t.memoize],w.prototype,"appRoot",null),pe([t.memoize],w.prototype,"userHome",null),pe([t.memoize],w.prototype,"userDataPath",null),pe([t.memoize],w.prototype,"appSettingsHome",null),pe([t.memoize],w.prototype,"tmpDir",null),pe([t.memoize],w.prototype,"cacheHome",null),pe([t.memoize],w.prototype,"stateResource",null),pe([t.memoize],w.prototype,"userRoamingDataHome",null),pe([t.memoize],w.prototype,"userDataSyncHome",null),pe([t.memoize],w.prototype,"userDataSyncLogResource",null),pe([t.memoize],w.prototype,"editSessionsLogResource",null),pe([t.memoize],w.prototype,"sync",null),pe([t.memoize],w.prototype,"machineSettingsResource",null),pe([t.memoize],w.prototype,"workspaceStorageHome",null),pe([t.memoize],w.prototype,"localHistoryHome",null),pe([t.memoize],w.prototype,"keyboardLayoutResource",null),pe([t.memoize],w.prototype,"argvResource",null),pe([t.memoize],w.prototype,"isExtensionDevelopment",null),pe([t.memoize],w.prototype,"untitledWorkspacesHome",null),pe([t.memoize],w.prototype,"installSourcePath",null),pe([t.memoize],w.prototype,"builtinExtensionsPath",null),pe([t.memoize],w.prototype,"extensionsPath",null),pe([t.memoize],w.prototype,"extensionDevelopmentLocationURI",null),pe([t.memoize],w.prototype,"extensionDevelopmentKind",null),pe([t.memoize],w.prototype,"extensionTestsLocationURI",null),pe([t.memoize],w.prototype,"debugExtensionHost",null),pe([t.memoize],w.prototype,"logLevel",null),pe([t.memoize],w.prototype,"extensionLogLevel",null),pe([t.memoize],w.prototype,"serviceMachineIdResource",null),pe([t.memoize],w.prototype,"telemetryLogResource",null),pe([t.memoize],w.prototype,"disableWorkspaceTrust",null),pe([t.memoize],w.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=w;function b(u,d){return y(u["inspect-extensions"],u["inspect-brk-extensions"],5870,d,u.debugId,u.extensionEnvironment)}e.parseExtensionHostPort=b;function S(u,d){return y(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,d,u.extensionEnvironment)}e.parsePtyHostPort=S;function y(u,d,v,h,l,p){const I=Number(d||u)||(h?null:v),m=I?Boolean(!!d):!1;let i;if(p)try{i=JSON.parse(p)}catch{}return{port:I,break:m,debugId:l,env:i}}}),define(ie[105],re([0,1,280,4,152]),function(H,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,C.localize)(0,null),e:(0,C.localize)(1,null),t:(0,C.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,C.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,C.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,C.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,C.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,C.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,C.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,C.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,C.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,C.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,C.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,C.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,C.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,C.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,C.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,C.localize)(17,null)},category:{type:"string",cat:"e",description:(0,C.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,C.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,C.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,C.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,C.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,C.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,C.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,C.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,C.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,C.localize)(27,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,C.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,C.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,C.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,C.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,C.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,C.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,C.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,C.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(v,h,l=A){const p=v.find(c=>c.length>0&&c[0]!=="-"),k={},I=["_"],m=[],i={};let r;for(const c in h){const s=h[c];s.type==="subcommand"?c===p&&(r=s):(s.alias&&(k[c]=s.alias),s.type==="string"||s.type==="string[]"?(I.push(c),s.deprecates&&I.push(...s.deprecates)):s.type==="boolean"&&(m.push(c),s.deprecates&&m.push(...s.deprecates)),s.global&&(i[c]=s))}if(r&&p){const c=i;for(const L in r.options)c[L]=r.options[L];const s=v.filter(L=>L!==p),f=l.getSubcommandReporter?l.getSubcommandReporter(p):void 0,M=P(s,c,f);return{[p]:M,_:[]}}const n=E(v,{string:I,boolean:m,alias:k}),a={},o=n;a._=n._.map(c=>String(c)).filter(c=>c.length>0),delete o._;for(const c in h){const s=h[c];if(s.type==="subcommand")continue;s.alias&&delete o[s.alias];let f=o[c];if(s.deprecates)for(const M of s.deprecates)o.hasOwnProperty(M)&&(f||(f=o[M],f&&l.onDeprecatedOption(M,s.deprecationMessage||(0,C.localize)(36,null,c))),delete o[M]);if(typeof f<"u"){if(s.type==="string[]"){if(Array.isArray(f)||(f=[f]),!s.allowEmptyValue){const M=f.filter(L=>L.length>0);M.length!==f.length&&(l.onEmptyValue(c),f=M.length>0?M:void 0)}}else s.type==="string"&&(Array.isArray(f)?(f=f.pop(),l.onMultipleValues(c,f)):!f&&!s.allowEmptyValue&&(l.onEmptyValue(c),f=void 0));a[c]=f,s.deprecationMessage&&l.onDeprecatedOption(c,s.deprecationMessage)}delete o[c]}for(const c in o)l.onUnknownOption(c);return a}e.parseArgs=P;function g(v,h){let l="";return h.args&&(Array.isArray(h.args)?l=` <${h.args.join("> <")}>`:l=` <${h.args}>`),h.alias?`-${h.alias} --${v}${l}`:`--${v}${l}`}function w(v,h){const l=[];for(const p in v){const k=v[p],I=g(p,k);l.push([I,k.description])}return b(l,h)}e.formatOptions=w;function b(v,h){const p=v.reduce((m,i)=>Math.max(m,i[0].length),12)+2+1;if(h-p<25)return v.reduce((m,i)=>m.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const k=h-p-1,I=[];for(const m of v){const i=m[0],r=y(m[1],k),n=S(p-i.length-2);I.push("  "+i+n+r[0]);for(let a=1;a<r.length;a++)I.push(S(p)+r[a])}return I}function S(v){return" ".repeat(v)}function y(v,h){const l=[];for(;v.length;){const p=v.length<h?v.length:v.lastIndexOf(" ",h),k=v.slice(0,p).trim();v=v.slice(p),l.push(k)}return l}function u(v,h,l,p,k){const I=process.stdout.isTTY&&process.stdout.columns||80,m=k?.noInputFiles!==!0?`[${(0,C.localize)(37,null)}...]`:"",i=[`${v} ${l}`];i.push(""),i.push(`${(0,C.localize)(38,null)}: ${h} [${(0,C.localize)(39,null)}]${m}`),i.push(""),k?.noPipe!==!0&&(t.isWindows?i.push((0,C.localize)(40,null,h)):i.push((0,C.localize)(41,null,h)),i.push(""));const r={},n=[];for(const a in p){const o=p[a];if(o.type==="subcommand")o.description&&n.push({command:a,description:o.description});else if(o.description&&o.cat){let c=r[o.cat];c||(r[o.cat]=c={}),c[a]=o}}for(const a in r){const o=a,c=r[o];c&&(i.push(R[o]),i.push(...w(c,I)),i.push(""))}return n.length&&(i.push((0,C.localize)(42,null)),i.push(...b(n.map(a=>[a.command,a.description]),I)),i.push("")),i.join(`
`)}e.buildHelpMessage=u;function d(v,h){return`${v||(0,C.localize)(43,null)}
${h||(0,C.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=d}),define(ie[181],re([0,1,79,179,105]),function(H,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class R extends t.ExtensionHostDebugBroadcastChannel{constructor(P){super(),this.f=P}call(P,g,w){return g==="openExtensionDevelopmentHostWindow"?this.g(w[0],w[1]):super.call(P,g,w)}async g(P,g){const w=(0,C.parseArgs)(P,C.OPTIONS);w.debugRenderer=g;const b=w.extensionDevelopmentPath;if(!b)return{success:!1};const[S]=await this.f.openExtensionDevelopmentHostWindow(b,{context:5,cli:w,forceProfile:w.profile,forceTempProfile:w["profile-temp"]});if(!g)return{success:!0};const y=S.win;if(!y)return{success:!0};const u=y.webContents.debugger;let d=u.isAttached()?1/0:0;const v=(0,E.createServer)(h=>{d++===0&&u.attach();let l=!1;const p=m=>{l||h.write(JSON.stringify(m)+"\0")},k=(m,i,r,n)=>p({method:i,params:r,sessionId:n});y.on("close",()=>{u.removeListener("message",k),h.end(),l=!0}),u.addListener("message",k);let I=Buffer.alloc(0);h.on("data",m=>{I=Buffer.concat([I,m]);for(let i=I.indexOf(0);i!==-1;i=I.indexOf(0)){let r;try{const n=I.slice(0,i).toString("utf8");I=I.slice(i+1),r=JSON.parse(n)}catch(n){console.error("error reading cdp line",n)}u.sendCommand(r.method,r.params,r.sessionId).then(n=>p({id:r.id,sessionId:r.sessionId,result:n})).catch(n=>p({id:r.id,sessionId:r.sessionId,error:{code:0,message:n.message}}))}}),h.on("error",m=>{console.error("error on cdp pipe:",m)}),h.on("close",()=>{l=!0,--d===0&&u.detach()})});return await new Promise(h=>v.listen(0,h)),y.on("close",()=>v.close()),{rendererDebugPort:v.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=R}),define(ie[61],re([0,1,281,153,105]),function(H,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const R=2048;function A(y,u){const d=(I,m)=>{console.warn((0,t.localize)(0,null,I,m))},v=I=>{console.warn((0,t.localize)(1,null,I))},h=(I,m)=>{console.warn((0,t.localize)(2,null,I,m))},l=I=>({onUnknownOption:m=>{I!=="tunnel"&&console.warn((0,t.localize)(3,null,m,I))},onMultipleValues:d,onEmptyValue:v,onDeprecatedOption:h,getSubcommandReporter:I!=="tunnel"?l:void 0}),p={onUnknownOption:I=>{console.warn((0,t.localize)(4,null,I))},onMultipleValues:d,onEmptyValue:v,onDeprecatedOption:h,getSubcommandReporter:l},k=(0,C.parseArgs)(y,C.OPTIONS,u?p:void 0);return k.goto&&k._.forEach(I=>E(/^(\w:)?[^:]+(:\d*){0,2}$/.test(I),(0,t.localize)(5,null))),k["max-memory"]&&E(parseInt(k["max-memory"])>=R,`The max-memory argument cannot be specified lower than ${R} MB.`),k}function P(y){const u=y.findIndex(d=>!/^-/.test(d));if(u>-1)return[...y.slice(0,u),...y.slice(u+1)]}function g(y){let[,...u]=y;process.env.VSCODE_DEV&&(u=P(u)||[]);const d=!S(process.env);return A(u,d)}e.parseMainProcessArgv=g;function w(y){let[,,...u]=y;return process.env.VSCODE_DEV&&(u=P(u)||[]),A(u,!0)}e.parseCLIProcessArgv=w;function b(y,...u){const d=y.indexOf("--");return d===-1?y.push(...u):y.splice(d,0,...u),y}e.addArg=b;function S(y){return y.VSCODE_CLI==="1"}e.isLaunchedFromCli=S}),function(){"use strict";function H(e,E,t){function C(A,P){const g=R(A,P),w=[g];return e.isAbsolute(g)||w.unshift(t),e.resolve(...w)}function R(A,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const g=process.env.VSCODE_PORTABLE;if(g)return e.join(g,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,P);const b=A["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const S=process.env.USERPROFILE;if(typeof S!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(S,"AppData","Roaming")}break;case"darwin":w=e.join(E.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(E.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,P)}return{getUserDataPath:C}}if(typeof define=="function")define(ie[182],re([183,25,33]),function(e,E,t){return H(e,E,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),E=require("os");module.exports=H(e,E,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ie[184],re([0,1,25,180,182]),function(H,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends t.AbstractNativeEnvironmentService{constructor(P,g){super(P,{homeDir:(0,E.homedir)(),tmpDir:(0,E.tmpdir)(),userDataDir:(0,C.getUserDataPath)(P,g.nameShort)},g)}}e.NativeEnvironmentService=R}),define(ie[185],re([0,1,40,25,30]),function(H,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function R(A){const P=(0,C.randomPath)((0,t.tmpdir)());try{return(0,E.writeFileSync)(P,""),A&&console.log(`Marker file for --wait created: ${P}`),P}catch(g){A&&console.error(`Failed to create marker file for --wait: ${g}`);return}}e.createWaitMarkerFileSync=R}),define(ie[186],re([0,1,11,155]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function C(A,P,g){try{R(A,P,g)}catch(w){console.error(w?.message??w)}return A}e.localizeManifest=C;function R(A,P,g){const w=(b,S,y)=>{const u=b[S];if((0,E.isString)(u)){const d=u,v=d.length;if(v>1&&d[0]==="%"&&d[v-1]==="%"){const h=d.substr(1,v-2);let l=P[h];l===void 0&&g&&(l=g[h]);const p=typeof l=="string"?l:l?.message,k=g?.[h],I=typeof k=="string"?k:k?.message;if(!p){I||console.warn(`[${A.name}]: ${(0,t.localize)(0,null,h)}`);return}if(y&&(S==="title"||S==="category")&&I&&I!==p){const m={value:p,original:I};b[S]=m}else b[S]=p}}else if((0,E.isObject)(u))for(const d in u)u.hasOwnProperty(d)&&(d==="commands"?w(u,d,!0):w(u,d,y));else if(Array.isArray(u))for(let d=0;d<u.length;d++)w(u,d,y)};for(const b in A)A.hasOwnProperty(b)&&w(A,b)}}),define(ie[187],re([0,1,15]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class t{constructor(){this.a=new Map}register(R,A){this.a.set(R,A)}updateManifest(R){if(!(typeof R.main>"u"&&typeof R.browser>"u")&&(R.activationEvents===void 0&&Object.assign(R,{activationEvents:[]}),!(!Array.isArray(R.activationEvents)||!R.contributes)))for(const A in R.contributes){const P=this.a.get(A);if(!P)continue;const g=R.contributes[A],w=Array.isArray(g)?g:[g];try{P(w,R.activationEvents)}catch(b){(0,E.onUnexpectedError)(b)}}}}e.ImplicitActivationEventsImpl=t,e.ImplicitActivationEvents=new t}),define(ie[188],re([0,1,20,98,157,189]),function(H,e,E,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function g(l){return l=l.trim(),l==="*"||A.test(l)}e.isValidVersionStr=g;function w(l){if(!g(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=l.match(A);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=w;function b(l){if(!l)return null;const p=l.majorBase,k=l.majorMustEqual,I=l.minorBase;let m=l.minorMustEqual;const i=l.patchBase;let r=l.patchMustEqual;l.hasCaret&&(p===0||(m=!1),r=!1);let n=0;if(l.preRelease){const a=P.exec(l.preRelease);if(a){const[,o,c,s]=a;n=Date.UTC(Number(o),Number(c)-1,Number(s))}}return{majorBase:p,majorMustEqual:k,minorBase:I,minorMustEqual:m,patchBase:i,patchMustEqual:r,isMinimum:l.hasGreaterEquals,notBefore:n}}e.normalizeVersion=b;function S(l,p,k){let I;typeof l=="string"?I=b(w(l)):I=l;let m;p instanceof Date?m=p.getTime():typeof p=="string"&&(m=new Date(p).getTime());let i;if(typeof k=="string"?i=b(w(k)):i=k,!I||!i)return!1;const r=I.majorBase,n=I.minorBase,a=I.patchBase;let o=i.majorBase,c=i.minorBase,s=i.patchBase;const f=i.notBefore;let M=i.majorMustEqual,L=i.minorMustEqual,T=i.patchMustEqual;return i.isMinimum?r>o?!0:r<o?!1:n>c?!0:n<c||m&&m<f?!1:a>=s:(r===1&&o===0&&(!M||!L||!T)&&(o=1,c=0,s=0,M=!0,L=!1,T=!1),r<o?!1:r>o?!M:n<c?!1:n>c?!L:a<s?!1:a>s?!T:!(m&&m<f))}e.isValidVersion=S;function y(l,p,k,I,m){const i=[];if(typeof I.publisher<"u"&&typeof I.publisher!="string")return i.push([t.default.Error,C.localize(0,null)]),i;if(typeof I.name!="string")return i.push([t.default.Error,C.localize(1,null,"name")]),i;if(typeof I.version!="string")return i.push([t.default.Error,C.localize(2,null,"version")]),i;if(!I.engines)return i.push([t.default.Error,C.localize(3,null,"engines")]),i;if(typeof I.engines.vscode!="string")return i.push([t.default.Error,C.localize(4,null,"engines.vscode")]),i;if(typeof I.extensionDependencies<"u"&&!h(I.extensionDependencies))return i.push([t.default.Error,C.localize(5,null,"extensionDependencies")]),i;if(typeof I.activationEvents<"u"){if(!h(I.activationEvents))return i.push([t.default.Error,C.localize(6,null,"activationEvents")]),i;if(typeof I.main>"u"&&typeof I.browser>"u")return i.push([t.default.Error,C.localize(7,null,"activationEvents","main")]),i}if(typeof I.extensionKind<"u"&&typeof I.main>"u"&&i.push([t.default.Warning,C.localize(8,null,"extensionKind")]),typeof I.main<"u"){if(typeof I.main!="string")return i.push([t.default.Error,C.localize(9,null,"main")]),i;{const a=(0,E.joinPath)(k,I.main);(0,E.isEqualOrParent)(a,k)||i.push([t.default.Warning,C.localize(10,null,a.path,k.path)])}if(typeof I.activationEvents>"u")return i.push([t.default.Error,C.localize(11,null,"activationEvents","main")]),i}if(typeof I.browser<"u"){if(typeof I.browser!="string")return i.push([t.default.Error,C.localize(12,null,"browser")]),i;{const a=(0,E.joinPath)(k,I.browser);(0,E.isEqualOrParent)(a,k)||i.push([t.default.Warning,C.localize(13,null,a.path,k.path)])}if(typeof I.activationEvents>"u")return i.push([t.default.Error,C.localize(14,null,"activationEvents","browser")]),i}if(!R.valid(I.version))return i.push([t.default.Error,C.localize(15,null)]),i;const r=[];if(!u(l,p,I,m,r))for(const a of r)i.push([t.default.Error,a]);return i}e.validateExtensionManifest=y;function u(l,p,k,I,m){return I||typeof k.main>"u"&&typeof k.browser>"u"?!0:v(l,p,k.engines.vscode,m)}e.isValidExtensionVersion=u;function d(l,p,k){return l==="*"||v(p,k,l)}e.isEngineValid=d;function v(l,p,k,I=[]){const m=b(w(k));if(!m)return I.push(C.localize(16,null,k)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return I.push(C.localize(17,null,k)),!1}else if(!m.majorMustEqual)return I.push(C.localize(18,null,k)),!1;return S(l,p,m)?!0:(I.push(C.localize(19,null,l,k)),!1)}function h(l){if(!Array.isArray(l))return!1;for(let p=0,k=l.length;p<k;p++)if(typeof l[p]!="string")return!1;return!0}}),define(ie[190],re([0,1,17,29]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function C(R,A,P){let g=P&&P.get("storage.serviceMachineId",-1)||null;if(g)return g;try{const b=(await A.readFile(R.serviceMachineIdResource)).value.toString();g=(0,t.isUUID)(b)?b:null}catch{g=null}if(!g){g=(0,t.generateUuid)();try{await A.writeFile(R.serviceMachineIdResource,E.VSBuffer.fromString(g))}catch{}}return P?.store("storage.serviceMachineId",g,-1,1),g}e.getServiceMachineId=C}),define(ie[70],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class E{constructor(C,R=[],A=!1){this.ctor=C,this.staticArguments=R,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=E}),define(ie[191],re([0,1,70]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var C;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(C=e.InstantiationType||(e.InstantiationType={}));function R(P,g,w){g instanceof E.SyncDescriptor||(g=new E.SyncDescriptor(g,[],Boolean(w))),t.push([P,g])}e.registerSingleton=R;function A(){return t}e.getSingletonServiceDescriptors=A}),define(ie[192],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class E{constructor(R,A){this.key=R,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.Node=E;class t{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const A of this.a.values())A.outgoing.size===0&&R.push(A);return R}insertEdge(R,A){const P=this.lookupOrInsertNode(R),g=this.lookupOrInsertNode(A);P.outgoing.set(g.key,g),g.incoming.set(P.key,P)}removeNode(R){const A=this.b(R);this.a.delete(A);for(const P of this.a.values())P.outgoing.delete(A),P.incoming.delete(A)}lookupOrInsertNode(R){const A=this.b(R);let P=this.a.get(A);return P||(P=new E(A,R),this.a.set(A,P)),P}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[A,P]of this.a)R.push(`${A}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,A]of this.a){const P=new Set([R]),g=this.c(A,P);if(g)return g}}c(R,A){for(const[P,g]of R.outgoing){if(A.has(P))return[...A,P].join(" -> ");A.add(P);const w=this.c(g,A);if(w)return w;A.delete(P)}}}e.Graph=t}),define(ie[5],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var E;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function P(g){return g[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=P})(E=e._util||(e._util={})),e.IInstantiationService=C("instantiationService");function t(A,P,g){P[E.DI_TARGET]===P?P[E.DI_DEPENDENCIES].push({id:A,index:g}):(P[E.DI_DEPENDENCIES]=[{id:A,index:g}],P[E.DI_TARGET]=P)}function C(A){if(E.serviceIds.has(A))return E.serviceIds.get(A);const P=function(g,w,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(P,g,b)};return P.toString=()=>A,E.serviceIds.set(A,P),P}e.createDecorator=C;function R(A){return A}e.refineServiceDecorator=R}),define(ie[62],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,E.createDecorator)("backupMainService")}),define(ie[18],re([0,1,11,7,5]),function(H,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,C.createDecorator)("configurationService");function R(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof t.URI)}e.isConfigurationOverrides=R;function A(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=A;var P;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function g(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=g;function w(l,p){const k=Object.create(null);for(const I in l)b(k,I,l[I],p);return k}e.toValuesTree=w;function b(l,p,k,I){const m=p.split("."),i=m.pop();let r=l;for(let n=0;n<m.length;n++){const a=m[n];let o=r[a];switch(typeof o){case"undefined":o=r[a]=Object.create(null);break;case"object":break;default:I(`Ignoring ${p} as ${m.slice(0,n+1).join(".")} is ${JSON.stringify(o)}`);return}r=o}if(typeof r=="object"&&r!==null)try{r[i]=k}catch{I(`Ignoring ${p} as ${m.join(".")} is ${JSON.stringify(r)}`)}else I(`Ignoring ${p} as ${m.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=b;function S(l,p){const k=p.split(".");y(l,k)}e.removeFromValueTree=S;function y(l,p){const k=p.shift();if(p.length===0){delete l[k];return}if(Object.keys(l).indexOf(k)!==-1){const I=l[k];typeof I=="object"&&!Array.isArray(I)&&(y(I,p),Object.keys(I).length===0&&delete l[k])}}function u(l,p,k){function I(r,n){let a=r;for(const o of n){if(typeof a!="object"||a===null)return;a=a[o]}return a}const m=p.split("."),i=I(l,m);return typeof i>"u"?k:i}e.getConfigurationValue=u;function d(l,p,k){Object.keys(p).forEach(I=>{I!=="__proto__"&&(I in l?E.isObject(l[I])&&E.isObject(p[I])?d(l[I],p[I],k):k&&(l[I]=p[I]):l[I]=p[I])})}e.merge=d;function v(l,p,k){const I=l.inspect(p),m=l.inspect(k);return typeof I.userValue<"u"||typeof I.workspaceValue<"u"||typeof I.workspaceFolderValue<"u"?I.value:typeof m.userValue<"u"||typeof m.workspaceValue<"u"||typeof m.workspaceFolderValue<"u"?m.value:I.defaultValue}e.getMigratedSettingValue=v;function h(l){return l.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=h}),define(ie[71],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,E.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,E.createDecorator)("credentialsMainService");class t{constructor(){this.a={}}async getPassword(R,A){return this.a[R]?.[A]??null}async setPassword(R,A,P){this.a[R]=this.a[R]??{},this.a[R][A]=P}async deletePassword(R,A){return this.a[R]?.[A]?(delete this.a[R][A],Object.keys(this.a[R]).length===0&&delete this.a[R],!0):!1}async findPassword(R){return JSON.stringify(this.a[R])??null}async findCredentials(R){const A=[];for(const P of Object.keys(this.a[R]||{}))A.push({account:P,password:this.a[R][P]});return A}async clear(){this.a={}}}e.InMemoryCredentialsProvider=t}),define(ie[85],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,E.createDecorator)(e.ID);function t(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=t;class C{async getPerformanceInfo(A,P){return{}}async getSystemInfo(A,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,P){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.NullDiagnosticsService=C}),define(ie[106],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,E.createDecorator)("encryptionMainService")}),define(ie[35],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,E.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,E.refineServiceDecorator)(e.IEnvironmentService)}),define(ie[27],re([0,1,54,9,84,35,184,5]),function(H,e,E,t,C,R,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,P.refineServiceDecorator)(R.IEnvironmentService);class g extends A.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,C.createStaticIPCHandle)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}pe([E.memoize],g.prototype,"cachedLanguagesPath",null),pe([E.memoize],g.prototype,"backupHome",null),pe([E.memoize],g.prototype,"mainIPCHandle",null),pe([E.memoize],g.prototype,"mainLockfile",null),pe([E.memoize],g.prototype,"disableUpdates",null),pe([E.memoize],g.prototype,"disableKeytar",null),pe([E.memoize],g.prototype,"crossOriginIsolated",null),pe([E.memoize],g.prototype,"codeCachePath",null),pe([E.memoize],g.prototype,"useCodeCache",null),e.EnvironmentMainService=g}),define(ie[193],re([0,1,154,5]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function C(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=C;function R(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function A(l,p){switch(l){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=A;function P(l,p){return p==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function g(l,p,k){return P(p,k)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===k?!0:w(k).includes(l)}e.isTargetPlatformCompatible=g;function w(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=w;function b(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=b;var S;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(S=e.SortBy||(e.SortBy={}));var y;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(y=e.SortOrder||(e.SortOrder={}));var u;(function(l){l.Install="install",l.Uninstall="uninstall"})(u=e.StatisticType||(e.StatisticType={}));var d;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var v;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal",l.Signature="Signature"})(v=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class h extends Error{constructor(p,k){super(p),this.code=k,this.name=k}}e.ExtensionManagementError=h,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,E.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,E.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ie[194],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,E.createDecorator)("extensionUrlTrustService")}),define(ie[195],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,E.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(ie[107],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,E.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,E.createDecorator)("externalTerminal")}),define(ie[196],re([0,1,46,14,9,4,80,23,83,158,107]),function(H,e,E,t,C,R,A,P,g,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const S=w.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:u.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class u extends y{openTerminal(I,m){return this.spawnTerminal(E,I,g.getWindowsShell(),m)}spawnTerminal(I,m,i,r){const n=m.windowsExec||u.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const a=C.basename(n).toLowerCase();if(a==="cmder"||a==="cmder.exe")return I.spawn(n,r?[r]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return n.indexOf(" ")>=0&&o.push('""'),o.push(n),(a==="wt"||a==="wt.exe")&&o.push("-d ."),new Promise((c,s)=>{const f=h(process),M=I.spawn(i,o,{cwd:r,env:f});M.on("error",s),M.on("exit",()=>c())})}runInTerminal(I,m,i,r,n){const a="windowsExec"in n&&n.windowsExec?n.windowsExec:u.getDefaultTerminalWindows();return new Promise((o,c)=>{const s=`"${m} - ${S}"`,f=`""${i.join('" "')}" & pause"`,M=["/c","start",s,"/wait",a,"/c",f],L=Object.assign({},h(process),r);Object.keys(L).filter(K=>L[K]===null).forEach(K=>delete L[K]);const T={cwd:m,env:L,windowsVerbatimArguments:!0};E.spawn(u.b,M,T).on("error",K=>{c(l(K))}),o(void 0)})}static getDefaultTerminalWindows(){if(!u.d){const I=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");u.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${I?"Sysnative":"System32"}\\cmd.exe`}return u.d}}e.WindowsExternalTerminalService=u,u.b="cmd.exe";class d extends y{openTerminal(I,m){return this.spawnTerminal(E,I,m)}runInTerminal(I,m,i,r,n){const a=n.osxExec||b.DEFAULT_TERMINAL_OSX;return new Promise((o,c)=>{if(a===b.DEFAULT_TERMINAL_OSX||a==="iTerm.app"){const s=a===b.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",M=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${s}.scpt`).fsPath,"-t",I||S,"-w",m];for(const U of i)M.push("-a"),M.push(U);if(r){const U=Object.assign({},h(process),r);for(const K in U){const V=U[K];V===null?(M.push("-u"),M.push(K)):(M.push("-e"),M.push(`${K}=${V}`))}}let L="";const T=E.spawn(d.b,M);T.on("error",U=>{c(l(U))}),T.stderr.on("data",U=>{L+=U.toString()}),T.on("exit",U=>{if(U===0)o(void 0);else if(L){const K=L.split(`
`,1);c(new Error(K[0]))}else c(new Error(w.localize(1,null,s,U)))})}else c(new Error(w.localize(2,null,a)))})}spawnTerminal(I,m,i){const r=m.osxExec||b.DEFAULT_TERMINAL_OSX;return new Promise((n,a)=>{const o=["-a",r];i&&o.push(i);const c=h(process),s=I.spawn("/usr/bin/open",o,{cwd:i,env:c});s.on("error",a),s.on("exit",()=>n())})}}e.MacExternalTerminalService=d,d.b="/usr/bin/osascript";class v extends y{openTerminal(I,m){return this.spawnTerminal(E,I,m)}runInTerminal(I,m,i,r,n){const a=n.linuxExec?Promise.resolve(n.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((o,c)=>{const s=[];a.then(f=>{f.indexOf("gnome-terminal")>=0?s.push("-x"):s.push("-e"),s.push("bash"),s.push("-c");const M=`${p(i)}; echo; read -p "${v.b}" -n1;`;s.push(`''${M}''`);const L=Object.assign({},h(process),r);Object.keys(L).filter(V=>L[V]===null).forEach(V=>delete L[V]);const T={cwd:m,env:L};let U="";const K=E.spawn(f,s,T);K.on("error",V=>{c(l(V))}),K.stderr.on("data",V=>{U+=V.toString()}),K.on("exit",V=>{if(V===0)o(void 0);else if(U){const G=U.split(`
`,1);c(new Error(G[0]))}else c(new Error(w.localize(4,null,f,V)))})})})}static async getDefaultTerminalLinuxReady(){if(!v.d)if(!R.isLinux)v.d=Promise.resolve("xterm");else{const I=await P.Promises.exists("/etc/debian_version");v.d=new Promise(m=>{I?m("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?m("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?m("konsole"):process.env.COLORTERM?m(process.env.COLORTERM):process.env.TERM?m(process.env.TERM):m("xterm")})}return v.d}spawnTerminal(I,m,i){const r=m.linuxExec?Promise.resolve(m.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((n,a)=>{r.then(o=>{const c=h(process),s=I.spawn(o,[],{cwd:i,env:c});s.on("error",a),s.on("exit",()=>n())})})}}e.LinuxExternalTerminalService=v,v.b=w.localize(3,null);function h(k){const I={...k.env};return(0,A.sanitizeProcessEnvironment)(I),I}function l(k){return"errno"in k&&k.errno==="ENOENT"&&"path"in k&&typeof k.path=="string"?new Error(w.localize(5,null,k.path)):k}function p(k){let I="";for(const m of k)m.indexOf(" ")>=0?I+='"'+m+'"':I+=m,I+=" ";return I}}),define(ie[16],re([0,1,60,9,26,11,7,160,5]),function(H,e,E,t,C,R,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,g.createDecorator)("fileService");function w(X){return X.create===!0}e.isFileOpenForWriteOptions=w;var b;(function(X){X[X.Unknown=0]="Unknown",X[X.File=1]="File",X[X.Directory=2]="Directory",X[X.SymbolicLink=64]="SymbolicLink"})(b=e.FileType||(e.FileType={}));var S;(function(X){X[X.Readonly=1]="Readonly"})(S=e.FilePermission||(e.FilePermission={}));var y;(function(X){X[X.None=0]="None",X[X.FileReadWrite=2]="FileReadWrite",X[X.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",X[X.FileReadStream=16]="FileReadStream",X[X.FileFolderCopy=8]="FileFolderCopy",X[X.PathCaseSensitive=1024]="PathCaseSensitive",X[X.Readonly=2048]="Readonly",X[X.Trash=4096]="Trash",X[X.FileWriteUnlock=8192]="FileWriteUnlock",X[X.FileAtomicRead=16384]="FileAtomicRead",X[X.FileClone=32768]="FileClone"})(y=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function u(X){return!!(X.capabilities&2)}e.hasReadWriteCapability=u;function d(X){return!!(X.capabilities&8)}e.hasFileFolderCopyCapability=d;function v(X){return!!(X.capabilities&32768)}e.hasFileCloneCapability=v;function h(X){return!!(X.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function l(X){return!!(X.capabilities&16)}e.hasFileReadStreamCapability=l;function p(X){return u(X)?!!(X.capabilities&16384):!1}e.hasFileAtomicReadCapability=p;var k;(function(X){X.FileExists="EntryExists",X.FileNotFound="EntryNotFound",X.FileNotADirectory="EntryNotADirectory",X.FileIsADirectory="EntryIsADirectory",X.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",X.FileTooLarge="EntryTooLarge",X.FileWriteLocked="EntryWriteLocked",X.NoPermissions="NoPermissions",X.Unavailable="Unavailable",X.Unknown="Unknown"})(k=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class I extends Error{constructor(ue,z){super(ue),this.code=z}}e.FileSystemProviderError=I;function m(X,ue){const z=new I(X.toString(),ue);return r(z,ue),z}e.createFileSystemProviderError=m;function i(X){return X||m((0,P.localize)(0,null),k.Unknown)}e.ensureFileSystemProviderError=i;function r(X,ue){return X.name=ue?`${ue} (FileSystemError)`:"FileSystemError",X}e.markAsFileSystemProviderError=r;function n(X){if(!X)return k.Unknown;if(X instanceof I)return X.code;const ue=/^(.+) \(FileSystemError\)$/.exec(X.name);if(!ue)return k.Unknown;switch(ue[1]){case k.FileExists:return k.FileExists;case k.FileIsADirectory:return k.FileIsADirectory;case k.FileNotADirectory:return k.FileNotADirectory;case k.FileNotFound:return k.FileNotFound;case k.FileExceedsMemoryLimit:return k.FileExceedsMemoryLimit;case k.FileTooLarge:return k.FileTooLarge;case k.FileWriteLocked:return k.FileWriteLocked;case k.NoPermissions:return k.NoPermissions;case k.Unavailable:return k.Unavailable}return k.Unknown}e.toFileSystemProviderErrorCode=n;function a(X){if(X instanceof L)return X.fileOperationResult;switch(n(X)){case k.FileNotFound:return 1;case k.FileIsADirectory:return 0;case k.FileNotADirectory:return 10;case k.FileWriteLocked:return 5;case k.NoPermissions:return 6;case k.FileExists:return 4;case k.FileExceedsMemoryLimit:return 9;case k.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var o;(function(X){X[X.CREATE=0]="CREATE",X[X.DELETE=1]="DELETE",X[X.MOVE=2]="MOVE",X[X.COPY=3]="COPY",X[X.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class c{constructor(ue,z,N){this.resource=ue,this.operation=z,this.target=N}isOperation(ue){return this.operation===ue}}e.FileOperationEvent=c;var s;(function(X){X[X.UPDATED=0]="UPDATED",X[X.ADDED=1]="ADDED",X[X.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class f{constructor(ue,z){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const N=new Map;for(const F of ue){const q=N.get(F.type);switch(q?q.push([F.resource,F]):N.set(F.type,[[F.resource,F]]),F.type){case 1:this.rawAdded.push(F.resource);break;case 0:this.rawUpdated.push(F.resource);break;case 2:this.rawDeleted.push(F.resource);break}}for(const[F,q]of N)switch(F){case 1:this.a=E.TernarySearchTree.forUris(()=>z),this.a.fill(q);break;case 0:this.b=E.TernarySearchTree.forUris(()=>z),this.b.fill(q);break;case 2:this.c=E.TernarySearchTree.forUris(()=>z),this.c.fill(q);break}}contains(ue,...z){return this.d(ue,{includeChildren:!1},...z)}affects(ue,...z){return this.d(ue,{includeChildren:!0},...z)}d(ue,z,...N){if(!ue)return!1;const F=N.length>0;return!!((!F||N.includes(1))&&(this.a?.get(ue)||z.includeChildren&&this.a?.findSuperstr(ue))||(!F||N.includes(0))&&(this.b?.get(ue)||z.includeChildren&&this.b?.findSuperstr(ue))||(!F||N.includes(2))&&(this.c?.findSubstr(ue)||z.includeChildren&&this.c?.findSuperstr(ue)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=f;function M(X,ue,z){return!X||!ue||X===ue||ue.length>X.length?!1:(ue.charAt(ue.length-1)!==t.sep&&(ue+=t.sep),z?(0,C.startsWithIgnoreCase)(X,ue):X.indexOf(ue)===0)}e.isParent=M;class L extends Error{constructor(ue,z,N){super(ue),this.fileOperationResult=z,this.options=N}}e.FileOperationError=L;class T extends L{constructor(ue,z,N){super(ue,2,N),this.stat=z}}e.NotModifiedSinceFileOperationError=T;var U;(function(X){X[X.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",X[X.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",X[X.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",X[X.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",X[X.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",X[X.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",X[X.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",X[X.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",X[X.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",X[X.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",X[X.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",X[X.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(U=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var K;(function(X){X[X.FILE=0]="FILE",X[X.FOLDER=1]="FOLDER",X[X.ROOT_FOLDER=2]="ROOT_FOLDER"})(K=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function V(X){if(!(typeof X.size!="number"||typeof X.mtime!="number"))return X.mtime.toString(29)+X.size.toString(31)}e.etag=V;async function G(X,ue){if(!ue.hasProvider(A.URI.from({scheme:X.scheme})))return new Promise(z=>{const N=ue.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===X.scheme&&F.added&&(N.dispose(),z())})})}e.whenProviderRegistered=G,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class _{static formatSize(ue){return(0,R.isNumber)(ue)||(ue=0),ue<_.KB?(0,P.localize)(1,null,ue.toFixed(0)):ue<_.MB?(0,P.localize)(2,null,(ue/_.KB).toFixed(2)):ue<_.GB?(0,P.localize)(3,null,(ue/_.MB).toFixed(2)):ue<_.TB?(0,P.localize)(4,null,(ue/_.GB).toFixed(2)):(0,P.localize)(5,null,(ue/_.TB).toFixed(2))}}e.ByteSize=_,_.KB=1024,_.MB=_.KB*_.KB,_.GB=_.MB*_.KB,_.TB=_.GB*_.KB;var se;(function(X){X[X.IA32=0]="IA32",X[X.OTHER=1]="OTHER"})(se=e.Arch||(e.Arch={}));function ce(X){return{maxFileSize:X===0?300*_.MB:16*_.GB,maxHeapSize:X===0?700*_.MB:2*700*_.MB}}e.getPlatformLimits=ce}),define(ie[197],re([0,1,17,45,15,3,2,59,7,29,16]),function(H,e,E,t,C,R,A,P,g,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class S extends A.Disposable{constructor(u,d){super(),this.a=u,this.b=d,this.onDidChangeCapabilities=R.Event.None,this.f=this.B(new R.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new R.Emitter),this.onDidWatchError=this.g.event,this.h=(0,w.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(u){return this.a.call("stat",[u])}readdir(u){return this.a.call("readdir",[u])}async readFile(u,d){const{buffer:v}=await this.a.call("readFile",[u,d]);return v}readFileStream(u,d,v){const h=(0,P.newWriteableStream)(p=>E.VSBuffer.concat(p.map(k=>E.VSBuffer.wrap(k))).buffer),l=this.a.listen("readFileStream",[u,d])(p=>{if(p instanceof E.VSBuffer)h.write(p.buffer);else{if(p==="end")h.end();else{let k;if(p instanceof Error)k=p;else{const I=p;k=(0,b.createFileSystemProviderError)(I.message??(0,t.toErrorMessage)(I),I.code??b.FileSystemProviderErrorCode.Unknown)}h.error(k),h.end()}l.dispose()}});return v.onCancellationRequested(()=>{h.error((0,C.canceled)()),h.end(),l.dispose()}),h}writeFile(u,d,v){return this.a.call("writeFile",[u,E.VSBuffer.wrap(d),v])}open(u,d){return this.a.call("open",[u,d])}close(u){return this.a.call("close",[u])}async read(u,d,v,h,l){const[p,k]=await this.a.call("read",[u,d,l]);return v.set(p.buffer.slice(0,k),h),k}write(u,d,v,h,l){return this.a.call("write",[u,d,E.VSBuffer.wrap(v),h,l])}mkdir(u){return this.a.call("mkdir",[u])}delete(u,d){return this.a.call("delete",[u,d])}rename(u,d,v){return this.a.call("rename",[u,d,v])}copy(u,d,v){return this.a.call("copy",[u,d,v])}cloneFile(u,d){return this.a.call("cloneFile",[u,d])}i(){this.B(this.a.listen("fileChange",[this.h])(u=>{if(Array.isArray(u)){const d=u;this.f.fire(d.map(v=>({resource:g.URI.revive(v.resource),type:v.type})))}else{const d=u;this.g.fire(d)}}))}watch(u,d){const v=(0,w.generateUuid)();return this.a.call("watch",[this.h,v,u,d]),(0,A.toDisposable)(()=>this.a.call("unwatch",[this.h,v]))}}e.DiskFileSystemProviderClient=S}),define(ie[108],re([0,1,17,15,161,16]),function(H,e,E,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function A(b,S,y,u,d,v){let h;try{await P(b,S,y,u,d,v)}catch(l){h=l}finally{h&&d.errorTransformer&&(h=d.errorTransformer(h)),typeof h<"u"&&y.error(h),y.end()}}e.readFileIntoStream=A;async function P(b,S,y,u,d,v){g(v);const h=await b.open(S,{create:!1});try{g(v);let l=0,p=0,k=d&&typeof d.length=="number"?d.length:void 0,I=E.VSBuffer.alloc(Math.min(d.bufferSize,typeof k=="number"?k:d.bufferSize)),m=d&&typeof d.position=="number"?d.position:0,i=0;do p=await b.read(h,m,I.buffer,i,I.byteLength-i),m+=p,i+=p,l+=p,typeof k=="number"&&(k-=p),i===I.byteLength&&(await y.write(u(I)),I=E.VSBuffer.alloc(Math.min(d.bufferSize,typeof k=="number"?k:d.bufferSize)),i=0);while(p>0&&(typeof k!="number"||k>0)&&g(v)&&w(l,d));if(i>0){let r=i;typeof k=="number"&&(r=Math.min(i,k)),y.write(u(I.slice(0,r)))}}catch(l){throw(0,R.ensureFileSystemProviderError)(l)}finally{await b.close(h)}}function g(b){if(b.isCancellationRequested)throw(0,t.canceled)();return!0}function w(b,S){if(S?.limits){if(typeof S.limits.memory=="number"&&b>S.limits.memory)throw(0,R.createFileSystemProviderError)((0,C.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof S.limits.size=="number"&&b>S.limits.size)throw(0,R.createFileSystemProviderError)((0,C.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ie[72],re([0,1,99,2,9,4,7,16]),function(H,e,E,t,C,R,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function g(l){return l.recursive===!0}e.isRecursiveWatchRequest=g;class w extends t.Disposable{constructor(p,k,I,m){super(),this.h=p,this.i=k,this.j=I,this.k=m,this.c=this.B(new t.MutableDisposable),this.f=void 0,this.g=0}m(){const p=new t.DisposableStore;this.c.value=p,this.b=this.l(p),this.b.setVerboseLogging(this.j),p.add(this.b.onDidChangeFile(k=>this.h(k))),p.add(this.b.onDidLogMessage(k=>this.i(k))),p.add(this.b.onDidError(k=>this.n(k)))}n(p){this.k.restartOnError?this.g<w.a&&this.f?(this.r(`restarting watcher after error: ${p}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${p}`):this.r(p)}p(p){this.g++,this.m(),this.watch(p)}async watch(p){this.f=p,await this.b?.watch(p)}async setVerboseLogging(p){this.j=p,await this.b?.setVerboseLogging(p)}r(p){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${p}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=w,w.a=5;class b extends w{constructor(p,k,I){super(p,k,I,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=b;class S extends w{constructor(p,k,I){super(p,k,I,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=S;function y(l){return l.map(p=>({type:p.type,resource:A.URI.file(p.path)}))}e.toFileChanges=y;function u(l){const p=new h;for(const k of l)p.processEvent(k);return p.coalesce()}e.coalesceEvents=u;function d(l,p){return typeof p=="string"&&!p.startsWith(E.GLOBSTAR)&&!(0,C.isAbsolute)(p)?{base:l,pattern:p}:p}e.normalizeWatcherPattern=d;function v(l,p){const k=[];for(const I of p)k.push((0,E.parse)(d(l,I)));return k}e.parseWatcherPatterns=v;class h{constructor(){this.a=new Set,this.b=new Map}c(p){return R.isLinux?p.path:p.path.toLowerCase()}processEvent(p){const k=this.b.get(this.c(p));let I=!1;if(k){const m=k.type,i=p.type;k.path!==p.path&&(p.type===2||p.type===1)?I=!0:m===1&&i===2?(this.b.delete(this.c(p)),this.a.delete(k)):m===2&&i===1?k.type=0:m===1&&i===0||(k.type=i)}else I=!0;I&&(this.a.add(p),this.b.set(this.c(p),p))}coalesce(){const p=[],k=[];return Array.from(this.a).filter(I=>I.type!==2?(p.push(I),!1):!0).sort((I,m)=>I.path.length-m.path.length).filter(I=>k.some(m=>(0,P.isParent)(I.path,m,!R.isLinux))?!1:(k.push(I.path),!0)).concat(p)}}}),define(ie[198],re([0,1,40,8,22,30,2,77,9,4,100,23,72]),function(H,e,E,t,C,R,A,P,g,w,b,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class u extends A.Disposable{constructor(h,l,p,k){super(),this.j=h,this.k=l,this.l=p,this.m=k,this.c=this.B(new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},I=>this.k(I))),this.f=this.B(new t.RunOnceWorker(I=>this.u(I),u.b)),this.g=(0,y.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,y.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new C.CancellationTokenSource,this.ready=this.n()}async n(){try{const h=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const l=await S.Promises.stat(h);this.B(await this.s(h,l.isDirectory()))}catch(h){h.code!=="ENOENT"?this.w(h):this.z(h)}}async r(h){let l=h.path;try{l=await S.Promises.realpath(h.path),h.path===l&&(l=await(0,b.realcase)(h.path)??h.path),h.path!==l&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${h.path}, real: ${l})`)}catch{}return l}async s(h,l){if(w.isMacintosh&&(0,R.isEqualOrParent)(h,"/Volumes/",!0))return this.w(`Refusing to watch ${h} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.Disposable.None;const p=new C.CancellationTokenSource(this.i.token),k=new A.DisposableStore;try{const I=(0,g.basename)(h),m=(0,E.watch)(h);k.add((0,A.toDisposable)(()=>{m.removeAllListeners(),m.close()})),this.z(`Started watching: '${h}'`);const i=new Set;if(l)try{for(const n of await S.Promises.readdir(h))i.add(n)}catch(n){this.w(n)}const r=new Map;k.add((0,A.toDisposable)(()=>{for(const[,n]of r)n.dispose();r.clear()})),m.on("error",(n,a)=>{this.w(`Failed to watch ${h} for changes using fs.watch() (${n}, ${a})`),this.dispose()}),m.on("change",(n,a)=>{if(p.token.isCancellationRequested)return;this.z(`[raw] ["${n}"] ${a}`);let o="";if(a&&(o=a.toString(),w.isMacintosh&&(o=(0,P.normalizeNFC)(o))),!(!o||n!=="change"&&n!=="rename"))if(l)if(n==="rename"){r.get(o)?.dispose();const c=setTimeout(async()=>{if(r.delete(o),o===I&&!await S.Promises.exists(h)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const s=await this.v((0,g.join)(h,o));if(p.token.isCancellationRequested)return;let f;s?i.has(o)?f=0:(f=1,i.add(o)):(i.delete(o),f=2),this.t({path:(0,g.join)(this.j.path,o),type:f})},u.a);r.set(o,(0,A.toDisposable)(()=>clearTimeout(c)))}else{let c;i.has(o)?c=0:(c=1,i.add(o)),this.t({path:(0,g.join)(this.j.path,o),type:c})}else if(n==="rename"||o!==I){const c=setTimeout(async()=>{const s=await S.Promises.exists(h);p.token.isCancellationRequested||(s?(this.t({path:this.j.path,type:0},!0),k.add(await this.s(h,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},u.a);k.clear(),k.add((0,A.toDisposable)(()=>clearTimeout(c)))}else this.t({path:this.j.path,type:0},!0)})}catch(I){await S.Promises.exists(h)&&!p.token.isCancellationRequested&&this.w(`Failed to watch ${h} for changes using fs.watch() (${I.toString()})`)}return(0,A.toDisposable)(()=>{p.dispose(!0),k.dispose()})}t(h,l=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`),!l&&this.g.some(p=>p(h.path))?this.m&&this.z(` >> ignored (excluded) ${h.path}`):!l&&this.h&&this.h.length>0&&!this.h.some(p=>p(h.path))?this.m&&this.z(` >> ignored (not included) ${h.path}`):this.f.work(h))}u(h){const l=(0,y.coalesceEvents)(h);if(l.length>0){if(this.m)for(const k of l)this.z(`>> normalized ${k.type===1?"[ADDED]":k.type===2?"[DELETED]":"[CHANGED]"} ${k.path}`);this.c.work(l)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${l[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(h){if(w.isLinux)return S.Promises.exists(h);try{const l=(0,g.basename)(h);return(await S.Promises.readdir((0,g.dirname)(h))).some(k=>k===l)}catch(l){return this.z(l),!1}}setVerboseLogging(h){this.m=h}w(h){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${h}`})}y(h){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${h}`})}z(h){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${h}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=u,u.a=100,u.b=75;async function d(v,h,l,p,k=512){const I=await S.Promises.open(v,"r"),m=Buffer.allocUnsafe(k),i=new C.CancellationTokenSource(p);let r,n=!1;const a={path:v,excludes:[],recursive:!1},o=new u(a,c=>{(async()=>{for(const{type:s}of c)if(s===0){if(n)return;n=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:f}=await S.Promises.read(I,m,0,k,null);if(!f||i.token.isCancellationRequested)break;h(m.slice(0,f))}}catch(f){r=new Error(f),i.dispose(!0)}finally{n=!1}}})()});return await o.ready,l(),new Promise((c,s)=>{i.token.onCancellationRequested(async()=>{o.dispose();try{await S.Promises.close(I)}catch(f){r=new Error(f)}r?s(r):c()})})}e.watchFileContents=d}),define(ie[199],re([0,1,3,99,2,4,198]),function(H,e,E,t,C,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends C.Disposable{constructor(){super(...arguments),this.a=this.B(new E.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new E.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=E.Event.None,this.c=new Map,this.f=!1}async watch(w){const b=this.i(w),S=b.filter(u=>{const d=this.c.get(u.path);return d?!(0,t.patternsEquals)(d.request.excludes,u.excludes)||!(0,t.patternsEquals)(d.request.includes,u.includes):!0}),y=Array.from(this.c.values()).filter(({request:u})=>!b.find(d=>d.path===u.path&&(0,t.patternsEquals)(d.excludes,u.excludes)&&(0,t.patternsEquals)(d.includes,u.includes))).map(({request:u})=>u.path);S.length&&this.j(`Request to start watching: ${S.map(u=>`${u.path} (excludes: ${u.excludes.length>0?u.excludes:"<none>"}, includes: ${u.includes&&u.includes.length>0?JSON.stringify(u.includes):"<all>"})`).join(",")}`),y.length&&this.j(`Request to stop watching: ${y.join(",")}`);for(const u of y)this.h(u);for(const u of S)this.g(u)}g(w){const b=new A.NodeJSFileWatcherLibrary(w,y=>this.a.fire(y),y=>this.b.fire(y),this.f),S={request:w,instance:b};this.c.set(w.path,S)}async stop(){for(const[w]of this.c)this.h(w);this.c.clear()}h(w){const b=this.c.get(w);b&&(this.c.delete(w),b.instance.dispose())}i(w){const b=new Map;for(const S of w){const y=R.isLinux?S.path:S.path.toLowerCase();b.set(y,S)}return Array.from(b.values())}async setVerboseLogging(w){this.f=w;for(const[,b]of this.c)b.instance.setVerboseLogging(w)}j(w){this.f&&this.b.fire({type:"trace",message:this.k(w)})}k(w,b){return b?`[File Watcher (node.js)] ${w} (path: ${b.request.path})`:`[File Watcher (node.js)] ${w}`}}e.NodeJSWatcher=P}),define(ie[200],re([0,1,72,199]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class C extends E.AbstractNonRecursiveWatcherClient{constructor(A,P,g){super(A,P,g),this.m()}l(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=C}),define(ie[201],re([0,1,14,47,147,72]),function(H,e,E,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends R.AbstractUniversalWatcherClient{constructor(g,w,b){super(g,w,b),this.m()}l(g){const w=g.add(new C.Client(E.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return g.add(w.onDidProcessExit(({code:b,signal:S})=>this.n(`terminated by itself with code ${b}, signal: ${S}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(w.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(ie[86],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class E{constructor(...C){this.a=new Map;for(const[R,A]of C)this.set(R,A)}set(C,R){const A=this.a.get(C);return this.a.set(C,R),A}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.ServiceCollection=E}),define(ie[202],re([0,1,8,15,2,70,192,5,86,96]),function(H,e,E,t,C,R,A,P,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class S extends Error{constructor(h){super("cyclic dependency between services"),this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class y{constructor(h=new g.ServiceCollection,l=!1,p,k=b){this.f=h,this.g=l,this.h=p,this.i=k,this.o=new Set,this.f.set(P.IInstantiationService,this),this._globalGraph=k?p?._globalGraph??new A.Graph(I=>I):void 0}createChild(h){return new y(h,this.g,this,this.i)}invokeFunction(h,...l){const p=d.traceInvocation(this.i,h);let k=!1;try{return h({get:m=>{if(k)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(m,p);if(!i)throw new Error(`[invokeFunction] unknown service '${m}'`);return i}},...l)}finally{k=!0,p.stop()}}createInstance(h,...l){let p,k;return h instanceof R.SyncDescriptor?(p=d.traceCreation(this.i,h.ctor),k=this.j(h.ctor,h.staticArguments.concat(l),p)):(p=d.traceCreation(this.i,h),k=this.j(h,l,p)),p.stop(),k}j(h,l=[],p){const k=P._util.getServiceDependencies(h).sort((i,r)=>i.index-r.index),I=[];for(const i of k){const r=this.m(i.id,p);r||this.u(`[createInstance] ${h.name} depends on UNKNOWN service ${i.id}.`,!1),I.push(r)}const m=k.length>0?k[0].index:l.length;if(l.length!==m){console.trace(`[createInstance] First service dependency of ${h.name} at position ${m+1} conflicts with ${l.length} static arguments`);const i=m-l.length;i>0?l=l.concat(new Array(i)):l=l.slice(0,m)}return Reflect.construct(h,l.concat(I))}k(h,l){if(this.f.get(h)instanceof R.SyncDescriptor)this.f.set(h,l);else if(this.h)this.h.k(h,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(h){const l=this.f.get(h);return!l&&this.h?this.h.l(h):l}m(h,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(h));const p=this.l(h);return p instanceof R.SyncDescriptor?this.q(h,p,l.branch(h,!0)):(l.branch(h,!1),p)}q(h,l,p){if(this.o.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this.o.add(h);try{return this.r(h,l,p)}finally{this.o.delete(h)}}r(h,l,p){const k=new A.Graph(i=>i.id.toString());let I=0;const m=[{id:h,desc:l,_trace:p}];for(;m.length;){const i=m.pop();if(k.lookupOrInsertNode(i),I++>1e3)throw new S(k);for(const r of P._util.getServiceDependencies(i.desc.ctor)){const n=this.l(r.id);if(n||this.u(`[createInstance] ${h} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(r.id)),n instanceof R.SyncDescriptor){const a={id:r.id,desc:n,_trace:i._trace.branch(r.id,!0)};k.insertEdge(i,a),m.push(a)}}}for(;;){const i=k.roots();if(i.length===0){if(!k.isEmpty())throw new S(k);break}for(const{data:r}of i){if(this.l(r.id)instanceof R.SyncDescriptor){const a=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,a)}k.removeNode(r)}}return this.l(h)}s(h,l,p=[],k,I){if(this.f.get(h)instanceof R.SyncDescriptor)return this.t(h,l,p,k,I);if(this.h)return this.h.s(h,l,p,k,I);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(h,l,p=[],k,I){if(k){const m=new y(void 0,this.g,this,this.i);m.c=String(h);const i=new Map,r=new E.IdleValue(()=>{const n=m.j(l,p,I);for(const[a,o]of i){const c=n[a];if(typeof c=="function")for(const s of o)c.apply(n,s)}return i.clear(),n});return new Proxy(Object.create(null),{get(n,a){if(!r.isInitialized&&typeof a=="string"&&(a.startsWith("onDid")||a.startsWith("onWill"))){let s=i.get(a);return s||(s=new w.LinkedList,i.set(a,s)),(M,L,T)=>{const U=s.push([M,L,T]);return(0,C.toDisposable)(U)}}if(a in n)return n[a];const o=r.value;let c=o[a];return typeof c!="function"||(c=c.bind(o),n[a]=c),c},set(n,a,o){return r.value[a]=o,!0},getPrototypeOf(n){return l.prototype}})}else return this.j(l,p,I)}u(h,l){if(l&&console.warn(h),this.g)throw new Error(h)}}e.InstantiationService=y;var u;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(u||(u={}));class d{static traceInvocation(h,l){return h?new d(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(h,l){return h?new d(1,l.name):d.c}constructor(h,l){this.type=h,this.name=l,this.g=Date.now(),this.h=[]}branch(h,l){const p=new d(3,h.toString());return this.h.push([h,l,p]),p}stop(){const h=Date.now()-this.g;d.f+=h;let l=!1;function p(I,m){const i=[],r=new Array(I+1).join("	");for(const[n,a,o]of m.h)if(a&&o){l=!0,i.push(`${r}CREATES -> ${n}`);const c=p(I+1,o);c&&i.push(c)}else i.push(`${r}uses -> ${n}`);return i.join(`
`)}const k=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(h>2||l)&&d.all.add(k.join(`
`))}}e.Trace=d,d.all=new Set,d.c=new class extends d{constructor(){super(0,null)}stop(){}branch(){return this}},d.f=0}),define(ie[6],re([0,1,45,3,2,39,4,7,5]),function(H,e,E,t,C,R,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,g.createDecorator)("logService"),e.ILoggerService=(0,g.createDecorator)("loggerService");function w(){return new Date().toISOString()}var b;(function(c){c[c.Off=0]="Off",c[c.Trace=1]="Trace",c[c.Debug=2]="Debug",c[c.Info=3]="Info",c[c.Warning=4]="Warning",c[c.Error=5]="Error"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function S(c,s,f){switch(s){case b.Trace:c.trace(f);break;case b.Debug:c.debug(f);break;case b.Info:c.info(f);break;case b.Warning:c.warn(f);break;case b.Error:c.error(f);break;case b.Off:break;default:throw new Error(`Invalid log level ${s}`)}}e.log=S;function y(c){let s="";for(let f=0;f<c.length;f++){let M=c[f];if(typeof M=="object")try{M=JSON.stringify(M)}catch{}s+=(f>0?" ":"")+M}return s}e.format=y;class u extends C.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new t.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(s){this.b!==s&&(this.b=s,this.c.fire(this.b))}getLevel(){return this.b}f(s){return this.b!==b.Off&&this.b<=s}}e.AbstractLogger=u;class d extends u{constructor(s){super(),this.h=s}f(s){return this.h||super.f(s)}trace(s,...f){this.f(b.Trace)&&this.g(b.Trace,y([s,...f]))}debug(s,...f){this.f(b.Debug)&&this.g(b.Debug,y([s,...f]))}info(s,...f){this.f(b.Info)&&this.g(b.Info,y([s,...f]))}warn(s,...f){this.f(b.Warning)&&this.g(b.Warning,y([s,...f]))}error(s,...f){if(this.f(b.Error))if(s instanceof Error){const M=Array.prototype.slice.call(arguments);M[0]=s.stack,this.g(b.Error,y(M))}else this.g(b.Error,y([s,...f]))}flush(){}}e.AbstractMessageLogger=d;class v extends u{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s),this.g=!A.isWindows}trace(s,...f){this.f(b.Trace)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,s,...f):console.log(`[main ${w()}]`,s,...f))}debug(s,...f){this.f(b.Debug)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,s,...f):console.log(`[main ${w()}]`,s,...f))}info(s,...f){this.f(b.Info)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,s,...f):console.log(`[main ${w()}]`,s,...f))}warn(s,...f){this.f(b.Warning)&&(this.g?console.warn(`\x1B[93m[main ${w()}]\x1B[0m`,s,...f):console.warn(`[main ${w()}]`,s,...f))}error(s,...f){this.f(b.Error)&&(this.g?console.error(`\x1B[91m[main ${w()}]\x1B[0m`,s,...f):console.error(`[main ${w()}]`,s,...f))}dispose(){}flush(){}}e.ConsoleMainLogger=v;class h extends u{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s)}trace(s,...f){this.f(b.Trace)&&console.log("%cTRACE","color: #888",s,...f)}debug(s,...f){this.f(b.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",s,...f)}info(s,...f){this.f(b.Info)&&console.log("%c INFO","color: #33f",s,...f)}warn(s,...f){this.f(b.Warning)&&console.log("%c WARN","color: #993",s,...f)}error(s,...f){this.f(b.Error)&&console.log("%c  ERR","color: #f33",s,...f)}dispose(){}flush(){}}e.ConsoleLogger=h;class l extends u{constructor(s,f=e.DEFAULT_LOG_LEVEL){super(),this.g=s,this.setLevel(f)}trace(s,...f){this.f(b.Trace)&&this.g.log(b.Trace,[this.h(s),...f])}debug(s,...f){this.f(b.Debug)&&this.g.log(b.Debug,[this.h(s),...f])}info(s,...f){this.f(b.Info)&&this.g.log(b.Info,[this.h(s),...f])}warn(s,...f){this.f(b.Warning)&&this.g.log(b.Warning,[this.h(s),...f])}error(s,...f){this.f(b.Error)&&this.g.log(b.Error,[this.h(s),...f])}h(s){return typeof s=="string"?s:(0,E.toErrorMessage)(s,this.f(b.Trace))}dispose(){}flush(){}}e.AdapterLogger=l;class p extends u{constructor(s){super(),this.g=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const f of this.g)f.setLevel(s);super.setLevel(s)}trace(s,...f){for(const M of this.g)M.trace(s,...f)}debug(s,...f){for(const M of this.g)M.debug(s,...f)}info(s,...f){for(const M of this.g)M.info(s,...f)}warn(s,...f){for(const M of this.g)M.warn(s,...f)}error(s,...f){for(const M of this.g)M.error(s,...f)}flush(){for(const s of this.g)s.flush()}dispose(){for(const s of this.g)s.dispose()}}e.MultiplexLogService=p;class k extends C.Disposable{constructor(s){super(),this.b=s,this.B(s)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(s){this.b.setLevel(s)}getLevel(){return this.b.getLevel()}trace(s,...f){this.b.trace(s,...f)}debug(s,...f){this.b.debug(s,...f)}info(s,...f){this.b.info(s,...f)}warn(s,...f){this.b.warn(s,...f)}error(s,...f){this.b.error(s,...f)}flush(){this.b.flush()}}e.LogService=k;class I extends C.Disposable{constructor(s,f){super(),this.c=s,this.b=new R.ResourceMap,this.B(f(M=>this.setLevel(M)))}getLoggers(){return[...this.b.values()].map(({logger:s})=>s)}getLogger(s){return this.b.get(s)?.logger}createLogger(s,f,M){let L=this.b.get(s)?.logger;return L||(M=f?.always?b.Trace:M,L=this.f(s,M??this.c,f),this.b.set(s,{logger:L,logLevel:M})),L}setLevel(s,f){const M=P.URI.isUri(s)?s:void 0,L=M?f:s;if(M){const T=this.b.get(M);T&&T.logLevel!==L&&(T.logLevel=L,T.logger.setLevel(L))}else this.c=L,this.b.forEach(({logLevel:T,logger:U})=>{T===void 0&&U.setLevel(this.c)})}getLogLevel(s){return this.b.get(s)?.logLevel}dispose(){this.b.forEach(({logger:s})=>s.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=I;class m{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(s){}getLevel(){return b.Info}trace(s,...f){}debug(s,...f){}info(s,...f){}warn(s,...f){}error(s,...f){}critical(s,...f){}dispose(){}flush(){}}e.NullLogger=m;class i extends m{}e.NullLogService=i;class r extends I{constructor(){super(b.Info,t.Event.None)}f(s,f,M){return new m}}e.NullLoggerService=r;function n(c){if(c.verbose)return b.Trace;if(typeof c.logLevel=="string"){const s=o(c.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=n;function a(c){switch(c){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}e.LogLevelToString=a;function o(c){switch(c){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.parseLogLevel=o});var ee=this&&this.__param||function(H,e){return function(E,t){e(E,t,H)}};define(ie[203],re([0,1,71,3,2,6,4,8]),function(H,e,E,t,C,R,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let g=class Et extends C.Disposable{constructor(b){super(),this.g=b,this.c=this.B(new t.Emitter),this.onDidChangePassword=this.c.event}async getPassword(b,S){this.g.trace("Getting password from keytar:",b,S);let y;try{y=await this.h()}catch{return null}const u=await(0,P.retry)(()=>y.getPassword(b,S),50,3);if(!u)return this.g.trace("Did not get a password from keytar for account:",S),u;let d,v;try{const h=JSON.parse(u);d=h.content,v=h.hasNextChunk}catch{}if(!d||!v)return this.g.trace("Got password from keytar for account:",S),u;try{let h=1;for(;v;){const l=await(0,P.retry)(()=>y.getPassword(b,`${S}-${h}`),50,3),p=JSON.parse(l);d+=p.content,v=p.hasNextChunk,h++}return this.g.trace(`Got ${h}-chunked password from keytar for account:`,S),d}catch(h){return this.g.error(h),u}}async setPassword(b,S,y){this.g.trace("Setting password using keytar:",b,S);let u;try{u=await this.h()}catch(d){throw this.i?.(d),d}if(A.isWindows&&y.length>Et.a){let d=0,v=0,h=!0;for(;h;){const l=y.substring(d,d+Et.b);d+=Et.b,h=y.length-d>0;const p={content:l,hasNextChunk:h};await(0,P.retry)(()=>u.setPassword(b,v?`${S}-${v}`:S,JSON.stringify(p)),50,3),v++}this.g.trace(`Got${v?` ${v}-chunked`:""} password from keytar for account:`,S)}else await(0,P.retry)(()=>u.setPassword(b,S,y),50,3),this.g.trace("Got password from keytar for account:",S);this.c.fire({service:b,account:S})}async deletePassword(b,S){this.g.trace("Deleting password using keytar:",b,S);let y;try{y=await this.h()}catch(l){throw this.i?.(l),l}const u=await y.getPassword(b,S);if(!u)return this.g.trace("Did not get a password to delete from keytar for account:",S),!1;let d,v;try{const l=JSON.parse(u);d=l.content,v=l.hasNextChunk}catch{}let h=0;if(d&&v)try{for(h++;v;){const l=`${S}-${h}`,p=await y.getPassword(b,l);await y.deletePassword(b,l),v=JSON.parse(p).hasNextChunk,h++}}catch(l){this.g.error(l)}return await y.deletePassword(b,S)?(this.c.fire({service:b,account:S}),this.g.trace(`Deleted${h?` ${h}-chunked`:""} password from keytar for account:`,S),!0):(this.g.trace(`Keytar failed to delete${h?` ${h}-chunked`:""} password for account:`,S),!1)}async findPassword(b){let S;try{S=await this.h()}catch{return null}return await S.findPassword(b)}async findCredentials(b){let S;try{S=await this.h()}catch{return[]}return await S.findCredentials(b)}clear(){return this.f instanceof E.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};g.a=2500,g.b=g.a-100,g=pe([ee(0,R.ILogService)],g),e.BaseCredentialsMainService=g}),define(ie[204],re([0,1,6]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let t=class{constructor(R,A){this.a=R,this.b=A}c(){return new Promise((R,A)=>H(["vscode-encrypt"],R,A))}async encrypt(R){let A;try{A=await this.c()}catch{return R}try{return A.encrypt(this.a,R)}catch(P){return this.b.error(P),R}}async decrypt(R){let A;try{A=await this.c()}catch{return R}try{return A.decrypt(this.a,R)}catch(P){return this.b.error(P),R}}};t=pe([ee(1,E.ILogService)],t),e.EncryptionMainService=t}),define(ie[205],re([0,1,24,8,15,3,2,9,72,6]),function(H,e,E,t,C,R,A,P,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class b extends A.Disposable{constructor(y,u){super(),this.a=y,this.b=u,this.c=this.B(new R.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new R.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new t.ThrottledDelayer(0)),this.s=[],this.t=this.B(new t.ThrottledDelayer(0))}watch(y,u){return u.recursive||this.b?.watcher?.forceUniversal?this.l(y,u):this.u(y,u)}l(y,u){const d={path:this.C(y),excludes:u.excludes,includes:u.includes,recursive:u.recursive},v=(0,E.insert)(this.j,d);return this.m(),(0,A.toDisposable)(()=>{v(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(y=>(0,C.onUnexpectedError)(y))}n(){this.h||(this.h=this.B(this.p(u=>this.c.fire((0,g.toFileChanges)(u)),u=>this.z(u),this.a.getLevel()===w.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===w.LogLevel.Trace)})));const y=this.b?.watcher?.recursive?.usePolling;if(y===!0)for(const u of this.j)(0,g.isRecursiveWatchRequest)(u)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const u of this.j)(0,g.isRecursiveWatchRequest)(u)&&y.includes(u.path)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(y,u){const d={path:this.C(y),excludes:u.excludes,includes:u.includes,recursive:!1},v=(0,E.insert)(this.s,d);return this.v(),(0,A.toDisposable)(()=>{v(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(y=>(0,C.onUnexpectedError)(y))}w(){return this.r||(this.r=this.B(this.y(y=>this.c.fire((0,g.toFileChanges)(y)),y=>this.z(y),this.a.getLevel()===w.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===w.LogLevel.Trace)}))),this.r.watch(this.s)}z(y){y.type==="error"&&this.g.fire(y.message),this.a[y.type](y.message)}C(y){return(0,P.normalize)(y.fsPath)}}e.AbstractDiskFileSystemProvider=b}),define(ie[206],re([0,1,24,8,17,22,3,68,67,2,60,14,73,20,59,159,16,108,6]),function(H,e,E,t,C,R,A,P,g,w,b,S,y,u,d,v,h,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let k=class extends w.Disposable{constructor(m){super(),this.b=m,this.a=256*1024,this.c=this.B(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new A.Emitter),this.onDidRunOperation=this.m.event,this.Q=this.B(new A.Emitter),this.onDidFilesChange=this.Q.event,this.R=this.B(new A.Emitter),this.onDidWatchError=this.R.event,this.S=new Map,this.W=this.B(new t.ResourceQueue)}registerProvider(m,i){if(this.h.has(m))throw new Error(`A filesystem provider for the scheme '${m}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${m}`);const r=new w.DisposableStore;return this.h.set(m,i),this.c.fire({added:!0,scheme:m,provider:i}),r.add(i.onDidChangeFile(n=>this.Q.fire(new h.FileChangesEvent(n,!this.N(i))))),typeof i.onDidWatchError=="function"&&r.add(i.onDidWatchError(n=>this.R.fire(new Error(n)))),r.add(i.onDidChangeCapabilities(()=>this.g.fire({provider:i,scheme:m}))),(0,w.toDisposable)(()=>{this.c.fire({added:!1,scheme:m,provider:i}),this.h.delete(m),(0,w.dispose)(r)})}getProvider(m){return this.h.get(m)}async activateProvider(m){const i=[];this.f.fire({scheme:m,join(r){i.push(r)}}),!this.h.has(m)&&await t.Promises.settled(i)}async canHandleResource(m){return await this.activateProvider(m.scheme),this.hasProvider(m)}hasProvider(m){return this.h.has(m.scheme)}hasCapability(m,i){const r=this.h.get(m.scheme);return!!(r&&r.capabilities&i)}listCapabilities(){return g.Iterable.map(this.h,([m,i])=>({scheme:m,capabilities:i.capabilities}))}async j(m){if(!(0,u.isAbsolutePath)(m))throw new h.FileOperationError((0,v.localize)(0,null,this.mb(m)),8);await this.activateProvider(m.scheme);const i=this.h.get(m.scheme);if(!i){const r=new Error;throw r.name="ENOPRO",r.message=(0,v.localize)(1,null,m.toString()),r}return i}async k(m){const i=await this.j(m);if((0,h.hasOpenReadWriteCloseCapability)(i)||(0,h.hasReadWriteCapability)(i)||(0,h.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${m.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(m){const i=await this.j(m);if((0,h.hasOpenReadWriteCloseCapability)(i)||(0,h.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${m.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(m,i){try{return await this.n(m,i)}catch(r){throw(0,h.toFileSystemProviderErrorCode)(r)===h.FileSystemProviderErrorCode.FileNotFound?new h.FileOperationError((0,v.localize)(2,null,this.mb(m)),1):(0,h.ensureFileSystemProviderError)(r)}}async n(m,i){const r=await this.j(m),n=this.N(r),a=i?.resolveTo,o=i?.resolveSingleChildDescendants,c=i?.resolveMetadata,s=await r.stat(m);let f;return this.p(r,m,s,void 0,!!c,(M,L)=>(f||(f=b.TernarySearchTree.forUris(()=>!n),f.set(m,!0),a&&f.fill(!0,a)),f.get(M.resource)||f.findSuperstr(M.resource.with({query:null,fragment:null}))?!0:M.isDirectory&&o?L===1:!1))}async p(m,i,r,n,a,o){const{providerExtUri:c}=this.M(m),s={resource:i,name:c.basename(i),isFile:(r.type&h.FileType.File)!==0,isDirectory:(r.type&h.FileType.Directory)!==0,isSymbolicLink:(r.type&h.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&h.FilePermission.Readonly)||Boolean(m.capabilities&2048),etag:(0,h.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(s.isDirectory&&o(s,n)){try{const f=await m.readdir(i),M=await t.Promises.settled(f.map(async([L,T])=>{try{const U=c.joinPath(i,L),K=a?await m.stat(U):{type:T};return await this.p(m,U,K,f.length,a,o)}catch(U){return this.b.trace(U),null}}));s.children=(0,E.coalesce)(M)}catch(f){this.b.trace(f),s.children=[]}return s}return s}async resolveAll(m){return t.Promises.settled(m.map(async i=>{try{return{stat:await this.n(i.resource,i.options),success:!0}}catch(r){return this.b.trace(r),{stat:void 0,success:!1}}}))}async stat(m){const i=await this.j(m),r=await i.stat(m);return this.p(i,m,r,void 0,!0,()=>!1)}async exists(m){const i=await this.j(m);try{return!!await i.stat(m)}catch{return!1}}async canCreateFile(m,i){try{await this.r(m,i)}catch(r){return r}return!0}async r(m,i){if(!i?.overwrite&&await this.exists(m))throw new h.FileOperationError((0,v.localize)(3,null,this.mb(m)),3,i)}async createFile(m,i=C.VSBuffer.fromString(""),r){await this.r(m,r);const n=await this.writeFile(m,i);return this.m.fire(new h.FileOperationEvent(m,0,n)),n}async writeFile(m,i,r){const n=this.kb(await this.l(m),m),{providerExtUri:a}=this.M(n);try{await this.s(n,m,r)||await this.O(n,a.dirname(m));let c;if((0,h.hasReadWriteCapability)(n)&&!(i instanceof C.VSBuffer))if((0,d.isReadableStream)(i)){const s=await(0,d.peekStream)(i,3);s.ended?c=C.VSBuffer.concat(s.buffer):c=s}else c=(0,d.peekReadable)(i,s=>C.VSBuffer.concat(s),3);else c=i;!(0,h.hasOpenReadWriteCloseCapability)(n)||(0,h.hasReadWriteCapability)(n)&&c instanceof C.VSBuffer?await this.bb(n,m,r,c):await this.X(n,m,r,c instanceof C.VSBuffer?(0,C.bufferToReadable)(c):c),this.m.fire(new h.FileOperationEvent(m,4))}catch(o){throw new h.FileOperationError((0,v.localize)(4,null,this.mb(m),(0,h.ensureFileSystemProviderError)(o).toString()),(0,h.toFileOperationResult)(o),r)}return this.resolve(m,{resolveMetadata:!0})}async s(m,i,r){if(!!r?.unlock&&!(m.capabilities&8192))throw new Error((0,v.localize)(5,null,this.mb(i)));let a;try{a=await m.stat(i)}catch{return}if((a.type&h.FileType.Directory)!==0)throw new h.FileOperationError((0,v.localize)(6,null,this.mb(i)),0,r);if(this.lb(i,a),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==h.ETAG_DISABLED&&typeof a.mtime=="number"&&typeof a.size=="number"&&r.mtime<a.mtime&&r.etag!==(0,h.etag)({mtime:r.mtime,size:a.size}))throw new h.FileOperationError((0,v.localize)(7,null),3,r);return a}async readFile(m,i,r){const n=await this.k(m);return i?.atomic?this.t(n,m,i,r):this.u(n,m,i,r)}async t(m,i,r,n){return new Promise((a,o)=>{this.W.queueFor(i,this.M(m).providerExtUri).queue(async()=>{try{const c=await this.u(m,i,r,n);a(c)}catch(c){o(c)}})})}async u(m,i,r,n){const a=await this.v(m,i,{...r,preferUnbuffered:!0},n);return{...a,value:await(0,C.streamToBuffer)(a.value)}}async readFileStream(m,i,r){const n=await this.k(m);return this.v(n,m,i,r)}async v(m,i,r,n){const a=new R.CancellationTokenSource(n),o=this.D(i,r).then(s=>s,s=>{throw a.cancel(),s});let c;try{return typeof r?.etag=="string"&&r.etag!==h.ETAG_DISABLED&&await o,r?.atomic&&(0,h.hasFileAtomicReadCapability)(m)||!((0,h.hasOpenReadWriteCloseCapability)(m)||(0,h.hasFileReadStreamCapability)(m))||(0,h.hasReadWriteCapability)(m)&&r?.preferUnbuffered?c=this.C(m,i,r):(0,h.hasFileReadStreamCapability)(m)?c=this.w(m,i,a.token,r):c=this.z(m,i,a.token,r),{...await o,value:c}}catch(s){c&&await(0,d.consumeStream)(c);const f=(0,v.localize)(8,null,this.mb(i),(0,h.ensureFileSystemProviderError)(s).toString());throw s instanceof h.NotModifiedSinceFileOperationError?new h.NotModifiedSinceFileOperationError(f,s.stat,r):new h.FileOperationError(f,(0,h.toFileOperationResult)(s),r)}}w(m,i,r,n=Object.create(null)){const a=m.readFileStream(i,n,r);return(0,d.transform)(a,{data:o=>o instanceof C.VSBuffer?o:C.VSBuffer.wrap(o),error:o=>new h.FileOperationError((0,v.localize)(9,null,this.mb(i),(0,h.ensureFileSystemProviderError)(o).toString()),(0,h.toFileOperationResult)(o),n)},o=>C.VSBuffer.concat(o))}z(m,i,r,n=Object.create(null)){const a=(0,C.newWriteableBufferStream)();return(0,l.readFileIntoStream)(m,i,a,o=>o,{...n,bufferSize:this.a,errorTransformer:o=>new h.FileOperationError((0,v.localize)(10,null,this.mb(i),(0,h.ensureFileSystemProviderError)(o).toString()),(0,h.toFileOperationResult)(o),n)},r),a}C(m,i,r){const n=(0,d.newWriteableStream)(a=>C.VSBuffer.concat(a));return(async()=>{try{let a;r?.atomic&&(0,h.hasFileAtomicReadCapability)(m)?a=await m.readFile(i,{atomic:!0}):a=await m.readFile(i),typeof r?.position=="number"&&(a=a.slice(r.position)),typeof r?.length=="number"&&(a=a.slice(0,r.length)),this.F(i,a.byteLength,r),n.end(C.VSBuffer.wrap(a))}catch(a){n.error(a),n.end()}})(),n}async D(m,i){const r=await this.resolve(m,{resolveMetadata:!0});if(r.isDirectory)throw new h.FileOperationError((0,v.localize)(11,null,this.mb(m)),0,i);if(typeof i?.etag=="string"&&i.etag!==h.ETAG_DISABLED&&i.etag===r.etag)throw new h.NotModifiedSinceFileOperationError((0,v.localize)(12,null),r,i);return this.F(m,r.size,i),r}F(m,i,r){if(r?.limits){let n;if(typeof r.limits.memory=="number"&&i>r.limits.memory&&(n=9),typeof r.limits.size=="number"&&i>r.limits.size&&(n=7),typeof n=="number")throw new h.FileOperationError((0,v.localize)(13,null,this.mb(m)),n)}}async canMove(m,i,r){return this.G(m,i,"move",r)}async canCopy(m,i,r){return this.G(m,i,"copy",r)}async G(m,i,r,n){if(m.toString()!==i.toString())try{const a=r==="move"?this.kb(await this.l(m),m):await this.k(m),o=this.kb(await this.l(i),i);await this.L(a,m,o,i,r,n)}catch(a){return a}return!0}async move(m,i,r){const n=this.kb(await this.l(m),m),a=this.kb(await this.l(i),i),o=await this.H(n,m,a,i,"move",!!r),c=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new h.FileOperationEvent(m,o==="move"?2:3,c)),c}async copy(m,i,r){const n=await this.k(m),a=this.kb(await this.l(i),i),o=await this.H(n,m,a,i,"copy",!!r),c=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new h.FileOperationEvent(m,o==="copy"?3:2,c)),c}async H(m,i,r,n,a,o){if(i.toString()===n.toString())return a;const{exists:c,isSameResourceWithDifferentPathCase:s}=await this.L(m,i,r,n,a,o);if(c&&!s&&o&&await this.del(n,{recursive:!0}),await this.O(r,this.M(r).providerExtUri.dirname(n)),a==="copy"){if(m===r&&(0,h.hasFileFolderCopyCapability)(m))await m.copy(i,n,{overwrite:o});else{const f=await this.resolve(i);f.isDirectory?await this.J(m,f,r,n):await this.I(m,i,r,n)}return a}else return m===r?(await m.rename(i,n,{overwrite:o}),a):(await this.H(m,i,r,n,"copy",o),await this.del(i,{recursive:!0}),"copy")}async I(m,i,r,n){if((0,h.hasOpenReadWriteCloseCapability)(m)&&(0,h.hasOpenReadWriteCloseCapability)(r))return this.db(m,i,r,n);if((0,h.hasOpenReadWriteCloseCapability)(m)&&(0,h.hasReadWriteCapability)(r))return this.jb(m,i,r,n);if((0,h.hasReadWriteCapability)(m)&&(0,h.hasOpenReadWriteCloseCapability)(r))return this.hb(m,i,r,n);if((0,h.hasReadWriteCapability)(m)&&(0,h.hasReadWriteCapability)(r))return this.fb(m,i,r,n)}async J(m,i,r,n){await r.mkdir(n),Array.isArray(i.children)&&await t.Promises.settled(i.children.map(async a=>{const o=this.M(r).providerExtUri.joinPath(n,a.name);return a.isDirectory?this.J(m,await this.resolve(a.resource),r,o):this.I(m,a.resource,r,o)}))}async L(m,i,r,n,a,o){let c=!1;if(m===r){const{providerExtUri:f,isPathCaseSensitive:M}=this.M(m);if(M||(c=f.isEqual(i,n)),c&&a==="copy")throw new Error((0,v.localize)(14,null,this.mb(i),this.mb(n)));if(!c&&f.isEqualOrParent(n,i))throw new Error((0,v.localize)(15,null,this.mb(i),this.mb(n)))}const s=await this.exists(n);if(s&&!c){if(!o)throw new h.FileOperationError((0,v.localize)(16,null,this.mb(i),this.mb(n)),4);if(m===r){const{providerExtUri:f}=this.M(m);if(f.isEqualOrParent(i,n))throw new Error((0,v.localize)(17,null,this.mb(i),this.mb(n)))}}return{exists:s,isSameResourceWithDifferentPathCase:c}}M(m){const i=this.N(m);return{providerExtUri:i?u.extUri:u.extUriIgnorePathCase,isPathCaseSensitive:i}}N(m){return!!(m.capabilities&1024)}async createFolder(m){const i=this.kb(await this.j(m),m);await this.O(i,m);const r=await this.resolve(m,{resolveMetadata:!0});return this.m.fire(new h.FileOperationEvent(m,0,r)),r}async O(m,i){const r=[],{providerExtUri:n}=this.M(m);for(;!n.isEqual(i,n.dirname(i));)try{if(((await m.stat(i)).type&h.FileType.Directory)===0)throw new Error((0,v.localize)(18,null,this.mb(i)));break}catch(a){if((0,h.toFileSystemProviderErrorCode)(a)!==h.FileSystemProviderErrorCode.FileNotFound)throw a;r.push(n.basename(i)),i=n.dirname(i)}for(let a=r.length-1;a>=0;a--){i=n.joinPath(i,r[a]);try{await m.mkdir(i)}catch(o){if((0,h.toFileSystemProviderErrorCode)(o)!==h.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(m,i){try{await this.P(m,i)}catch(r){return r}return!0}async P(m,i){const r=this.kb(await this.j(m),m);if(!!i?.useTrash&&!(r.capabilities&4096))throw new Error((0,v.localize)(19,null,this.mb(m)));let a;try{a=await r.stat(m)}catch{}if(a)this.lb(m,a);else throw new h.FileOperationError((0,v.localize)(20,null,this.mb(m)),1);if(!!!i?.recursive){const c=await this.resolve(m);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,v.localize)(21,null,this.mb(m)))}return r}async del(m,i){const r=await this.P(m,i),n=!!i?.useTrash,a=!!i?.recursive;await r.delete(m,{recursive:a,useTrash:n}),this.m.fire(new h.FileOperationEvent(m,1))}async cloneFile(m,i){const r=await this.j(m),n=this.kb(await this.l(i),i);if(r===n&&this.M(r).providerExtUri.isEqual(m,i))return;if(r===n&&(0,h.hasFileCloneCapability)(r))return r.cloneFile(m,i);await this.O(n,this.M(n).providerExtUri.dirname(i));const a=this.W.queueFor(m,this.M(r).providerExtUri);return r===n&&(0,h.hasFileFolderCopyCapability)(r)?a.queue(()=>r.copy(m,i,{overwrite:!0})):a.queue(()=>this.I(r,m,n,i))}watch(m,i={recursive:!1,excludes:[]}){const r=new w.DisposableStore;let n=!1,a=()=>{n=!0};return r.add((0,w.toDisposable)(()=>a())),(async()=>{try{const o=await this.U(m,i);n?(0,w.dispose)(o):a=()=>(0,w.dispose)(o)}catch(o){this.b.error(o)}})(),r}async U(m,i){const r=await this.j(m),n=(0,P.hash)([this.M(r).providerExtUri.getComparisonKey(m),i]);let a=this.S.get(n);return a||(a={count:0,disposable:r.watch(m,i)},this.S.set(n,a)),a.count+=1,(0,w.toDisposable)(()=>{a&&(a.count--,a.count===0&&((0,w.dispose)(a.disposable),this.S.delete(n)))})}dispose(){super.dispose();for(const[,m]of this.S)(0,w.dispose)(m.disposable);this.S.clear()}async X(m,i,r,n){return this.W.queueFor(i,this.M(m).providerExtUri).queue(async()=>{const a=await m.open(i,{create:!0,unlock:r?.unlock??!1});try{(0,d.isReadableStream)(n)||(0,d.isReadableBufferedStream)(n)?await this.Y(m,a,n):await this.Z(m,a,n)}catch(o){throw(0,h.ensureFileSystemProviderError)(o)}finally{await m.close(a)}})}async Y(m,i,r){let n=0,a;if((0,d.isReadableBufferedStream)(r)){if(r.buffer.length>0){const o=C.VSBuffer.concat(r.buffer);await this.ab(m,i,o,o.byteLength,n,0),n+=o.byteLength}if(r.ended)return;a=r.stream}else a=r;return new Promise((o,c)=>{(0,d.listenStream)(a,{onData:async s=>{a.pause();try{await this.ab(m,i,s,s.byteLength,n,0)}catch(f){return c(f)}n+=s.byteLength,setTimeout(()=>a.resume())},onError:s=>c(s),onEnd:()=>o()})})}async Z(m,i,r){let n=0,a;for(;(a=r.read())!==null;)await this.ab(m,i,a,a.byteLength,n,0),n+=a.byteLength}async ab(m,i,r,n,a,o){let c=0;for(;c<n;)c+=await m.write(i,a+c,r.buffer,o+c,n-c)}async bb(m,i,r,n){return this.W.queueFor(i,this.M(m).providerExtUri).queue(()=>this.cb(m,i,r,n))}async cb(m,i,r,n){let a;n instanceof C.VSBuffer?a=n:(0,d.isReadableStream)(n)?a=await(0,C.streamToBuffer)(n):(0,d.isReadableBufferedStream)(n)?a=await(0,C.bufferedStreamToBuffer)(n):a=(0,C.readableToBuffer)(n),await m.writeFile(i,a.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async db(m,i,r,n){return this.W.queueFor(n,this.M(r).providerExtUri).queue(()=>this.eb(m,i,r,n))}async eb(m,i,r,n){let a,o;try{a=await m.open(i,{create:!1}),o=await r.open(n,{create:!0,unlock:!1});const c=C.VSBuffer.alloc(this.a);let s=0,f=0,M=0;do M=await m.read(a,s,c.buffer,f,c.byteLength-f),await this.ab(r,o,c,M,s,f),s+=M,f+=M,f===c.byteLength&&(f=0);while(M>0)}catch(c){throw(0,h.ensureFileSystemProviderError)(c)}finally{await t.Promises.settled([typeof a=="number"?m.close(a):Promise.resolve(),typeof o=="number"?r.close(o):Promise.resolve()])}}async fb(m,i,r,n){return this.W.queueFor(n,this.M(r).providerExtUri).queue(()=>this.gb(m,i,r,n))}async gb(m,i,r,n){return r.writeFile(n,await m.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async hb(m,i,r,n){return this.W.queueFor(n,this.M(r).providerExtUri).queue(()=>this.ib(m,i,r,n))}async ib(m,i,r,n){const a=await r.open(n,{create:!0,unlock:!1});try{const o=await m.readFile(i);await this.ab(r,a,C.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,h.ensureFileSystemProviderError)(o)}finally{await r.close(a)}}async jb(m,i,r,n){const a=await(0,C.streamToBuffer)(this.z(m,i,R.CancellationToken.None));await this.bb(r,n,void 0,a)}kb(m,i){if(m.capabilities&2048)throw new h.FileOperationError((0,v.localize)(22,null,this.mb(i)),6);return m}lb(m,i){if((i.permissions??0)&h.FilePermission.Readonly)throw new h.FileOperationError((0,v.localize)(23,null,this.mb(m)),6)}mb(m){return m.scheme===S.Schemas.file?m.fsPath:m.toString(!0)}};k=pe([ee(0,p.ILogService)],k),e.FileService=k}),define(ie[87],re([0,1,40,282,8,39,17,3,30,2,9,4,20,59,23,163,16,108,205,45,201,200]),function(H,e,E,t,C,R,A,P,g,w,b,S,y,u,d,v,h,l,p,k,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(E)}catch(r){console.error(`Error enabling graceful-fs: ${(0,k.toErrorMessage)(r)}`)}})();class i extends p.AbstractDiskFileSystemProvider{constructor(n,a){super(n,a),this.onDidChangeCapabilities=P.Event.None,this.H=new R.ResourceMap(o=>y.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,S.isLinux&&(this.F|=1024)),this.F}async stat(n){try{const{stat:a,symbolicLink:o}=await d.SymlinkSupport.stat(this.C(n));return{type:this.G(a,o),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.Y(a)}}async readdir(n){try{const a=await d.Promises.readdir(this.C(n),{withFileTypes:!0}),o=[];return await Promise.all(a.map(async c=>{try{let s;c.isSymbolicLink()?s=(await this.stat((0,y.joinPath)(n,c.name))).type:s=this.G(c),o.push([c.name,s])}catch(s){this.a.trace(s)}})),o}catch(a){throw this.Y(a)}}G(n,a){let o;return a?.dangling?o=h.FileType.Unknown:n.isFile()?o=h.FileType.File:n.isDirectory()?o=h.FileType.Directory:o=h.FileType.Unknown,a&&(o|=h.FileType.SymbolicLink),o}async I(n){const a=this.C(n);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${a})`);let o;for(;o=this.H.get(n);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${a})`),await o.wait();const c=new C.Barrier;return this.H.set(n,c),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${a})`),(0,w.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${a})`),this.H.get(n)===c&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${a})`),this.H.delete(n)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${a})`),c.open()})}async readFile(n,a){let o;try{a?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(n)})`),o=await this.I(n));const c=this.C(n);return await d.Promises.readFile(c)}catch(c){throw this.Y(c)}finally{o?.dispose()}}J(n){i.D&&this.a.trace(n)}readFileStream(n,a,o){const c=(0,u.newWriteableStream)(s=>A.VSBuffer.concat(s.map(f=>A.VSBuffer.wrap(f))).buffer);return(0,l.readFileIntoStream)(this,n,c,s=>s.buffer,{...a,bufferSize:256*1024},o),c}async writeFile(n,a,o){let c;try{const s=this.C(n);if(!o.create||!o.overwrite){if(await d.Promises.exists(s)){if(!o.overwrite)throw(0,h.createFileSystemProviderError)((0,v.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,h.createFileSystemProviderError)((0,v.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(n,{create:!0,unlock:o.unlock}),await this.write(c,0,a,0,a.byteLength)}catch(s){throw await this.Z(n,s)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(n){i.O=n}async open(n,a){const o=this.C(n);let c;(0,h.isFileOpenForWriteOptions)(a)&&(c=await this.I(n));let s;try{if((0,h.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:M}=await d.SymlinkSupport.stat(o);M.mode&128||await d.Promises.chmod(o,M.mode|128)}catch(M){this.a.trace(M)}let f;if((0,h.isFileOpenForWriteOptions)(a)){if(S.isWindows)try{await d.Promises.truncate(o,0),f="r+"}catch(M){M.code!=="ENOENT"&&this.a.trace(M)}f||(f="w")}else f="r";s=await d.Promises.open(o,f)}catch(f){throw c?.dispose(),(0,h.isFileOpenForWriteOptions)(a)?await this.Z(n,f):this.Y(f)}if(this.L.set(s,0),(0,h.isFileOpenForWriteOptions)(a)&&this.N.set(s,n),c){const f=this.M.get(s);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${s} (${o})`),this.M.set(s,c),f&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${s} (${o})`),f.dispose())}return s}async close(n){const a=this.M.get(n);try{if(this.L.delete(n),this.N.delete(n)&&i.O)try{await d.Promises.fdatasync(n)}catch(o){i.configureFlushOnWrite(!1),this.a.error(o)}return await d.Promises.close(n)}catch(o){throw this.Y(o)}finally{a&&(this.M.get(n)===a&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.M.delete(n)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),a.dispose())}}async read(n,a,o,c,s){const f=this.P(n,a);let M=null;try{M=(await d.Promises.read(n,o,c,s,f)).bytesRead}catch(L){throw this.Y(L)}finally{this.Q(n,f,M)}return M}P(n,a){return a===this.L.get(n)?null:a}Q(n,a,o){const c=this.L.get(n);typeof c=="number"&&(typeof a=="number"||(typeof o=="number"?this.L.set(n,c+o):this.L.delete(n)))}async write(n,a,o,c,s){return(0,C.retry)(()=>this.R(n,a,o,c,s),100,3)}async R(n,a,o,c,s){const f=this.P(n,a);let M=null;try{M=(await d.Promises.write(n,o,c,s,f)).bytesWritten}catch(L){throw await this.Z(this.N.get(n),L)}finally{this.Q(n,f,M)}return M}async mkdir(n){try{await d.Promises.mkdir(this.C(n))}catch(a){throw this.Y(a)}}async delete(n,a){try{const o=this.C(n);a.recursive?await d.Promises.rm(o,d.RimRafMode.MOVE):await d.Promises.unlink(o)}catch(o){throw this.Y(o)}}async rename(n,a,o){const c=this.C(n),s=this.C(a);if(c!==s)try{await this.S(n,a,"move",o.overwrite),await d.Promises.move(c,s)}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,v.localize)(2,null,(0,b.basename)(c),(0,b.basename)((0,b.dirname)(s)),f.toString()))),this.Y(f)}}async copy(n,a,o){const c=this.C(n),s=this.C(a);if(c!==s)try{await this.S(n,a,"copy",o.overwrite),await d.Promises.copy(c,s,{preserveSymlinks:!0})}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,v.localize)(3,null,(0,b.basename)(c),(0,b.basename)((0,b.dirname)(s)),f.toString()))),this.Y(f)}}async S(n,a,o,c){const s=this.C(n),f=this.C(a);let M=!1;if(!!(this.capabilities&1024)||(M=(0,g.isEqual)(s,f,!0)),M&&o==="copy")throw(0,h.createFileSystemProviderError)((0,v.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(!M&&await d.Promises.exists(f)){if(!c)throw(0,h.createFileSystemProviderError)((0,v.localize)(5,null),h.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}async cloneFile(n,a){return this.U(n,a,!1)}async U(n,a,o){const c=this.C(n),s=this.C(a),f=!!(this.capabilities&1024);if((0,g.isEqual)(c,s,!f))return;const M=new w.DisposableStore;try{const[L,T]=await Promise.all([this.I(n),this.I(a)]);M.add(L),M.add(T),o&&await d.Promises.mkdir((0,b.dirname)(s),{recursive:!0}),await d.Promises.copyFile(c,s)}catch(L){if(L.code==="ENOENT"&&!o)return this.U(n,a,!0);throw this.Y(L)}finally{M.dispose()}}p(n,a,o){return new I.UniversalWatcherClient(c=>n(c),c=>a(c),o)}y(n,a,o){return new m.NodeJSWatcherClient(c=>n(c),c=>a(c),o)}Y(n){if(n instanceof h.FileSystemProviderError)return n;let a;switch(n.code){case"ENOENT":a=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=h.FileSystemProviderErrorCode.NoPermissions;break;default:a=h.FileSystemProviderErrorCode.Unknown}return(0,h.createFileSystemProviderError)(n,a)}async Z(n,a){let o=this.Y(a);if(n&&o.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await d.SymlinkSupport.stat(this.C(n));c.mode&128||(o=(0,h.createFileSystemProviderError)(a,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return o}}e.DiskFileSystemProvider=i,i.D=!1,i.O=!0}),define(ie[207],re([0,1,3,87,2,17,59,22]),function(H,e,E,t,C,R,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class g extends C.Disposable{constructor(S,y){super(),this.a=S,this.b=y,this.w=new Map,this.y=new Map}call(S,y,u){const d=this.c(S);switch(y){case"stat":return this.g(d,u[0]);case"readdir":return this.h(d,u[0]);case"open":return this.l(d,u[0],u[1]);case"close":return this.m(u[0]);case"read":return this.n(u[0],u[1],u[2]);case"readFile":return this.i(d,u[0],u[1]);case"write":return this.p(u[0],u[1],u[2],u[3],u[4]);case"writeFile":return this.k(d,u[0],u[1],u[2]);case"rename":return this.t(d,u[0],u[1],u[2]);case"copy":return this.u(d,u[0],u[1],u[2]);case"cloneFile":return this.v(d,u[0],u[1]);case"mkdir":return this.r(d,u[0]);case"delete":return this.s(d,u[0],u[1]);case"watch":return this.C(d,u[0],u[1],u[2],u[3]);case"unwatch":return this.D(u[0],u[1])}throw new Error(`IPC Command ${y} not found`)}listen(S,y,u){const d=this.c(S);switch(y){case"fileChange":return this.z(d,u[0]);case"readFileStream":return this.j(d,u[0],u[1])}throw new Error(`Unknown event ${y}`)}g(S,y){const u=this.f(S,y,!0);return this.a.stat(u)}h(S,y){const u=this.f(S,y);return this.a.readdir(u)}async i(S,y,u){const d=this.f(S,y,!0),v=await this.a.readFile(d,u);return R.VSBuffer.wrap(v)}j(S,y,u){const d=this.f(S,y,!0),v=new P.CancellationTokenSource,h=new E.Emitter({onDidRemoveLastListener:()=>{v.cancel()}}),l=this.a.readFileStream(d,u,v.token);return(0,A.listenStream)(l,{onData:p=>h.fire(R.VSBuffer.wrap(p)),onError:p=>h.fire(p),onEnd:()=>{h.fire("end"),h.dispose(),v.dispose()}}),h.event}k(S,y,u,d){const v=this.f(S,y);return this.a.writeFile(v,u.buffer,d)}l(S,y,u){const d=this.f(S,y,!0);return this.a.open(d,u)}m(S){return this.a.close(S)}async n(S,y,u){const d=R.VSBuffer.alloc(u),v=0,h=await this.a.read(S,y,d.buffer,v,u);return[d,h]}p(S,y,u,d,v){return this.a.write(S,y,u.buffer,d,v)}r(S,y){const u=this.f(S,y);return this.a.mkdir(u)}s(S,y,u){const d=this.f(S,y);return this.a.delete(d,u)}t(S,y,u,d){const v=this.f(S,y),h=this.f(S,u);return this.a.rename(v,h,d)}u(S,y,u,d){const v=this.f(S,y),h=this.f(S,u);return this.a.copy(v,h,d)}v(S,y,u){const d=this.f(S,y),v=this.f(S,u);return this.a.cloneFile(d,v)}z(S,y){const u=new E.Emitter({onWillAddFirstListener:()=>{this.w.set(y,this.F(S,u))},onDidRemoveLastListener:()=>{(0,C.dispose)(this.w.get(y)),this.w.delete(y)}});return u.event}async C(S,y,u,d,v){const h=this.w.get(y);if(h){const l=this.f(S,d),p=h.watch(u,l,v);this.y.set(y+u,p)}}async D(S,y){const u=S+y,d=this.y.get(u);d&&((0,C.dispose)(d),this.y.delete(u))}dispose(){super.dispose();for(const[,S]of this.y)S.dispose();this.y.clear();for(const[,S]of this.w)S.dispose();this.w.clear()}}e.AbstractDiskFileSystemProviderChannel=g;class w extends C.Disposable{constructor(S,y,u,d){super(),this.c=S,this.f=u,this.g=d,this.a=new Map,this.b=this.B(new t.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(y)}h(S){const y=this.B(new E.Emitter);this.B(y.event(u=>{S.fire(u.map(d=>({resource:this.c.transformOutgoingURI(d.resource),type:d.type})))})),this.B(this.b.onDidChangeFile(u=>y.fire(u))),this.B(this.b.onDidWatchError(u=>S.fire(u)))}i(S){}j(S){}watch(S,y,u){const d=this.j(this.g);return Array.isArray(d)&&(u.excludes=[...u.excludes,...d]),this.a.set(S,this.b.watch(y,u)),(0,C.toDisposable)(()=>{(0,C.dispose)(this.a.get(S)),this.a.delete(S)})}dispose(){super.dispose();for(const[,S]of this.a)S.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=w}),define(ie[208],re([0,1,13,162,4,7,16,9,207,141]),function(H,e,E,t,C,R,A,P,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class b extends g.AbstractDiskFileSystemProviderChannel{constructor(u,d,v){super(u,d),this.G=v}c(u){return w.DefaultURITransformer}f(u,d){return R.URI.revive(d)}async s(u,d,v){if(!v.useTrash)return super.s(u,d,v);const h=this.f(u,d),l=(0,P.normalize)(h.fsPath);try{await E.shell.trashItem(l)}catch{throw(0,A.createFileSystemProviderError)(C.isWindows?(0,t.localize)(0,null,(0,P.basename)(l)):(0,t.localize)(1,null,(0,P.basename)(l)),A.FileSystemProviderErrorCode.Unknown)}}F(u,d){return new S(u,d,this.b,this.G)}}e.DiskFileSystemProviderChannel=b;class S extends g.AbstractSessionFileWatcher{watch(u,d,v){if(v.recursive)throw(0,A.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",A.FileSystemProviderErrorCode.Unavailable);return super.watch(u,d,v)}}}),define(ie[209],re([0,1,6]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;class t extends E.AbstractMessageLogger{constructor(R=E.DEFAULT_LOG_LEVEL){super(),this.k=[],this.l=void 0,this.setLevel(R),this.B(this.onDidChangeLogLevel(A=>{this.l?.setLevel(A)}))}set logger(R){this.l=R;for(const{level:A,message:P}of this.k)(0,E.log)(R,A,P);this.k=[]}g(R,A){this.l?(0,E.log)(this.l,R,A):this.getLevel()<=R&&this.k.push({level:R,message:A})}dispose(){this.l?.dispose()}flush(){this.l?.flush()}}e.BufferLogService=t}),define(ie[210],re([0,1,3,7,6]),function(H,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(y,u){this.a=y,this.b=u,this.onDidChangeLogLevel=E.Event.buffer(y.onDidChangeLogLevel,!0)}listen(y,u){switch(u){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${u}`)}async call(y,u,d){switch(u){case"setLevel":return d[1]?this.b.setLevel(t.URI.revive(d[1]),d[0]):this.a.setLevel(d[0])}throw new Error(`Call not found: ${u}`)}}e.LogLevelChannel=R;class A{constructor(y){this.a=y}get onDidChangeLogLevel(){return this.a.listen("onDidChangeLogLevel")}setLevel(y,u){A.setLevel(this.a,y,u)}static setLevel(y,u,d){return y.call("setLevel",[u,d])}}e.LogLevelChannelClient=A;class P{constructor(y){this.b=y,this.a=new Map}listen(y,u){throw new Error(`Event not found: ${u}`)}async call(y,u,d){switch(u){case"createLogger":this.c(t.URI.revive(d[0]),d[1]);return;case"log":return this.e(t.URI.revive(d[0]),d[1]);case"consoleLog":return this.d(d[0],d[1])}throw new Error(`Call not found: ${u}`)}c(y,u){this.a.set(y.toString(),this.b.createLogger(y,u))}d(y,u){let d=console.log;switch(y){case C.LogLevel.Error:d=console.error;break;case C.LogLevel.Warning:d=console.warn;break;case C.LogLevel.Info:d=console.info;break}d.call(console,...u)}e(y,u){const d=this.a.get(y.toString());if(!d)throw new Error("Create the logger before logging");for(const[v,h]of u)(0,C.log)(d,v,h)}}e.LoggerChannel=P;class g extends C.AbstractLoggerService{constructor(y,u,d){super(y,u),this.g=d}createConsoleMainLogger(){return new C.AdapterLogger({log:(y,u)=>{this.g.call("consoleLog",[y,u])}})}f(y,u,d){return new w(this.g,y,u,d)}}e.LoggerChannelClient=g;class w extends C.AbstractMessageLogger{constructor(y,u,d,v){super(v?.always),this.m=y,this.n=u,this.k=!1,this.l=[],this.setLevel(d),this.m.call("createLogger",[u,v]).then(()=>{this.r(this.l),this.k=!0})}g(y,u){const d=[[y,u]];this.k?this.r(d):this.l.push(...d)}r(y){this.m.call("log",[this.n,y])}}class b extends C.LogService{constructor(y,u){super(u),this.c=y,this.B(y.onDidChangeLogLevel(d=>u.setLevel(d)))}setLevel(y){super.setLevel(y),this.c.setLevel(y)}}e.FollowerLogService=b}),define(ie[211],re([0,1,16,6]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var C;(function(w){w[w.Trace=0]="Trace",w[w.Debug=1]="Debug",w[w.Info=2]="Info",w[w.Warning=3]="Warning",w[w.Error=4]="Error",w[w.Critical=5]="Critical",w[w.Off=6]="Off"})(C||(C={}));async function R(w,b,S,y,u){try{const d=await new Promise((h,l)=>{H(["spdlog"],h,l)});d.setFlushOn(C.Trace);const v=await d.createAsyncRotatingLogger(w,b,S,y);return u?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(d){console.error(d)}return null}function A(w,b,S){switch(b){case t.LogLevel.Trace:w.trace(S);break;case t.LogLevel.Debug:w.debug(S);break;case t.LogLevel.Info:w.info(S);break;case t.LogLevel.Warning:w.warn(S);break;case t.LogLevel.Error:w.error(S);break;case t.LogLevel.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function P(w,b){switch(b){case t.LogLevel.Trace:w.setLevel(C.Trace);break;case t.LogLevel.Debug:w.setLevel(C.Debug);break;case t.LogLevel.Info:w.setLevel(C.Info);break;case t.LogLevel.Warning:w.setLevel(C.Warning);break;case t.LogLevel.Error:w.setLevel(C.Error);break;case t.LogLevel.Off:w.setLevel(C.Off);break;default:throw new Error(`Invalid log level ${b}`)}}class g extends t.AbstractMessageLogger{constructor(b,S,y,u,d){super(),this.k=[],this.setLevel(d),this.l=this.n(b,S,y,u),this.B(this.onDidChangeLogLevel(v=>{this.m&&P(this.m,v)}))}async n(b,S,y,u){const d=y?6:1,v=30/d*E.ByteSize.MB,h=await R(b,S,v,d,u);if(h){this.m=h,P(this.m,this.getLevel());for(const{level:l,message:p}of this.k)A(this.m,l,p);this.k=[]}}g(b,S){this.m?A(this.m,b,S):this.getLevel()<=b&&this.k.push({level:b,message:S})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=g}),define(ie[212],re([0,1,29,6,211]),function(H,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let R=class extends t.AbstractLoggerService{constructor(P){super(P.getLevel(),P.onDidChangeLogLevel)}f(P,g,w){return new C.SpdLogLogger(w?.name||(0,E.generateUuid)(),P.fsPath,!w?.donotRotate,!!w?.donotUseFormatters,g)}};R=pe([ee(0,t.ILogService)],R),e.LoggerService=R}),define(ie[213],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function E(A){return A.submenu!==void 0}e.isMenubarMenuItemSubmenu=E;function t(A){return A.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function C(A){return A.uri!==void 0}e.isMenubarMenuItemRecentAction=C;function R(A){return!E(A)&&!t(A)&&!C(A)}e.isMenubarMenuItemAction=R}),define(ie[37],re([0,1,3,67,2,5]),function(H,e,E,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class A extends C.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new E.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(w){const b=Object.keys(this.f).length;return this.f={...w,...this.f},b!==Object.keys(this.f).length&&await this.i(w),t.Iterable.reduce(this.g.entries(),(S,[y,u])=>({...S,[y]:u}),{})}getPolicyValue(w){return this.g.get(w)}serialize(){return t.Iterable.reduce(Object.entries(this.f),(w,[b,S])=>({...w,[b]:{definition:S,value:this.g.get(b)}}),{})}}e.AbstractPolicyService=A;class P{constructor(){this.onDidChange=E.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(ie[214],re([0,1,8,3,67,11,16,6,37]),function(H,e,E,t,C,R,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function w(S,y){const u=[];for(const d of new Set(C.Iterable.concat(S.keys(),y.keys())))S.get(d)!==y.get(d)&&u.push(d);return u}let b=class extends g.AbstractPolicyService{constructor(y,u,d){super(),this.j=y,this.k=u,this.l=d,this.c=this.B(new E.ThrottledDelayer(500));const v=t.Event.filter(u.onDidFilesChange,h=>h.affects(y));this.B(u.watch(y)),this.B(v(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const y=new Map;try{const u=await this.k.readFile(this.j),d=JSON.parse(u.value.toString());if(!(0,R.isObject)(d))throw new Error("Policy file isn't a JSON object");for(const v of Object.keys(d))this.f[v]&&y.set(v,d[v])}catch(u){u.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",u)}return y}async p(){const y=await this.n(),u=w(this.g,y);this.g=y,u.length>0&&this.h.fire(u)}};b=pe([ee(1,A.IFileService),ee(2,P.ILogService)],b),e.FilePolicyService=b}),define(ie[215],re([0,1,3,2,37]),function(H,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class R{constructor(g){this.b=g,this.a=new t.DisposableStore}listen(g,w){switch(w){case"onDidChange":return E.Event.map(this.b.onDidChange,b=>b.reduce((S,y)=>({...S,[y]:this.b.getPolicyValue(y)??null}),{}),this.a)}throw new Error(`Event not found: ${w}`)}call(g,w,b){switch(w){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(b)}throw new Error(`Call not found: ${w}`)}dispose(){this.a.dispose()}}e.PolicyChannel=R;class A extends C.AbstractPolicyService{constructor(g,w){super(),this.a=w;for(const b in g){const{definition:S,value:y}=g[b];this.f[b]=S,y!==void 0&&this.g.set(b,y)}this.a.listen("onDidChange")(b=>{for(const S in b){const y=b[S];y===null?this.g.delete(S):this.g.set(S,y)}this.h.fire(Object.keys(b))})}async i(g){const w=await this.a.call("updatePolicyDefinitions",g);for(const b in w)this.g.set(b,w[b])}}e.PolicyChannelClient=A}),define(ie[63],re([0,1,4,33]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let C;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.context<"u"){const R=E.globals.vscode.context.configuration();if(R)C=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(C=globalThis._VSCODE_PRODUCT_JSON,t.env.VSCODE_DEV&&Object.assign(C,{nameShort:`${C.nameShort} Dev`,nameLong:`${C.nameLong} Dev`,dataFolderName:`${C.dataFolderName}-dev`,serverDataFolderName:C.serverDataFolderName?`${C.serverDataFolderName}-dev`:void 0}),!C.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(C,{version:R.version})}}else C={},Object.keys(C).length===0&&Object.assign(C,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=C}),define(ie[19],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,E.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ie[216],re([0,1,78,6,19]),function(H,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let R=class{constructor(P,g){this.b=P,this.c=g,this.a=new Map}async isExtensionUrlTrusted(P,g){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const w=/^(.*)#([^#]+)$/.exec(g);if(!w)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",g),!1;const[,b,S]=w;let y=this.a.get(P);if(!y){if(y=this.b.trustedExtensionUrlPublicKeys[P],!y||y.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",P),!1;this.a.set(P,[...y])}const u=Buffer.from(decodeURIComponent(S),"base64");if(u.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",g),!1;const d=u.slice(0,6),v=u.readUIntBE(0,6),h=Date.now()-v;if(h<0||h>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",g),!1;const l=u.slice(6),p=E.createVerify("SHA256");p.write(d),p.write(Buffer.from(b)),p.end();for(let k=0;k<y.length;k++){let I=y[k];if(I!==null){if(typeof I=="string")try{I=E.createPublicKey({key:Buffer.from(I,"base64"),format:"der",type:"spki"}),y[k]=I}catch(m){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${k+1} for ${P}:`,m),y[k]=null;continue}if(p.verify(I,l))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",g),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",g),!1}};R=pe([ee(0,C.IProductService),ee(1,t.ILogService)],R),e.ExtensionUrlTrustService=R}),define(ie[217],re([0,1,8,6]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let C=class{constructor(A,P,g){this.a=A,this.b=P,this.c=g}async inspect(A){await this.d();const P=this.a.webContents.debugger;await P.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,E.timeout)(A);const g=await P.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),g.profile}async d(){const A=this.a.webContents.debugger;A.attach(),await A.sendCommand("Profiler.enable")}async e(){const A=this.a.webContents.debugger;await A.sendCommand("Profiler.disable"),A.detach()}};C=pe([ee(2,t.ILogService)],C),e.WindowProfiler=C}),define(ie[64],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,E.createDecorator)("protocolMainService")}),define(ie[48],re([0,1,122,11]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.a=new Map}add(A,P){E.ok(t.isString(A)),E.ok(t.isObject(P)),E.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,P)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.Registry=new C}),define(ie[218],re([0,1,3,48]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class R{constructor(){this.b=new E.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,w){this.a[C(g)]=w,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const A=new R;t.Registry.add(e.Extensions.JSONContribution,A)}),define(ie[65],re([0,1,24,3,11,150,18,218,48]),function(H,e,E,t,C,R,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var w;(function(m){m.Multiline="multilineText",m.Singleline="singlelineText"})(w=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const S=g.Registry.as(P.Extensions.JSONContribution);class y{constructor(){this.h=new Set,this.i=new t.Emitter,this.onDidSchemaChange=this.i.event,this.j=new t.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.r()}registerConfiguration(i,r=!0){this.registerConfigurations([i],r)}registerConfigurations(i,r=!0){const n=this.k(i,r);S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(i){const r=this.l(i);S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:i,remove:r}){const n=[];n.push(...this.l(r)),n.push(...this.k(i,!1)),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:(0,E.distinct)(n)})}registerDefaultConfigurations(i){const r=[],n=[];for(const{overrides:a,source:o}of i)for(const c in a)if(r.push(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const s=this.a.get(c),f=s?.valuesSources??new Map;if(o)for(const U of Object.keys(a[c]))f.set(U,o);const M={...s?.value||{},...a[c]};this.a.set(c,{source:o,value:M,valuesSources:f});const L=(0,A.getLanguageTagSettingPlainKey)(c),T={type:"object",default:M,description:R.localize(1,null,L),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:M,source:C.isString(o)?void 0:o,defaultValueSource:o};n.push(...v(c)),this.d[c]=T,this.b.properties[c]=T}else{this.a.set(c,{value:a[c],source:o});const s=this.d[c];s&&(this.s(c,s),this.o(c,s))}this.registerOverrideIdentifiers(n),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const r=[];for(const{overrides:n,source:a}of i)for(const o in n){const c=this.a.get(o),s=C.isString(a)?a:a?.id,f=C.isString(c?.source)?c?.source:c?.source?.id;if(s===f)if(r.push(o),this.a.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.d[o],delete this.b.properties[o];else{const M=this.d[o];M&&(this.s(o,M),this.o(o,M))}}this.q(),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){for(const r of i)this.h.add(r);this.q()}k(i,r){const n=[];return i.forEach(a=>{n.push(...this.m(a,r,a.extensionInfo,a.restrictedProperties)),this.c.push(a),this.n(a)}),n}l(i){const r=[],n=a=>{if(a.properties)for(const o in a.properties){r.push(o);const c=this.d[o];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[o],this.p(o,a.properties[o])}a.allOf?.forEach(o=>n(o))};for(const a of i){n(a);const o=this.c.indexOf(a);o!==-1&&this.c.splice(o,1)}return r}m(i,r=!0,n,a,o=3){o=C.isUndefinedOrNull(i.scope)?o:i.scope;const c=[],s=i.properties;if(s)for(const M in s){const L=s[M];if(r&&k(M,L)){delete s[M];continue}if(L.source=n,L.defaultDefaultValue=s[M].default,this.s(M,L),e.OVERRIDE_PROPERTY_REGEX.test(M)?L.scope=void 0:(L.scope=C.isUndefinedOrNull(L.scope)?o:L.scope,L.restricted=C.isUndefinedOrNull(L.restricted)?!!a?.includes(M):L.restricted),s[M].hasOwnProperty("included")&&!s[M].included){this.f[M]=s[M],delete s[M];continue}else this.d[M]=s[M],s[M].policy?.name&&this.e.set(s[M].policy.name,M);!s[M].deprecationMessage&&s[M].markdownDeprecationMessage&&(s[M].deprecationMessage=s[M].markdownDeprecationMessage),c.push(M)}const f=i.allOf;if(f)for(const M of f)c.push(...this.m(M,r,n,a,o));return c}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}n(i){const r=n=>{const a=n.properties;if(a)for(const c in a)this.o(c,a[c]);n.allOf?.forEach(r)};r(i)}o(i,r){switch(e.allSettings.properties[i]=r,r.scope){case 1:e.applicationSettings.properties[i]=r;break;case 2:e.machineSettings.properties[i]=r;break;case 6:e.machineOverridableSettings.properties[i]=r;break;case 3:e.windowSettings.properties[i]=r;break;case 4:e.resourceSettings.properties[i]=r;break;case 5:e.resourceSettings.properties[i]=r,this.g.properties[i]=r;break}}p(i,r){switch(delete e.allSettings.properties[i],r.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}q(){for(const i of this.h.values()){const r=`[${i}]`,n={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.s(r,n),e.allSettings.properties[r]=n,e.applicationSettings.properties[r]=n,e.machineSettings.properties[r]=n,e.machineOverridableSettings.properties[r]=n,e.windowSettings.properties[r]=n,e.resourceSettings.properties[r]=n}this.i.fire()}r(){const i={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}s(i,r){const n=this.a.get(i);let a=n?.value,o=n?.source;C.isUndefined(a)&&(a=r.defaultDefaultValue,o=void 0),C.isUndefined(a)&&(a=l(r.type)),r.default=a,r.defaultValueSource=o}}const u="\\[([^\\]]+)\\]",d=new RegExp(u,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${u})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function v(m){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(m)){let r=d.exec(m);for(;r?.length;){const n=r[1].trim();n&&i.push(n),r=d.exec(m)}}return(0,E.distinct)(i)}e.overrideIdentifiersFromKey=v;function h(m){return m.reduce((i,r)=>`${i}[${r}]`,"")}e.keyFromOverrideIdentifiers=h;function l(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const p=new y;g.Registry.add(e.Extensions.Configuration,p);function k(m,i){return m.trim()?e.OVERRIDE_PROPERTY_REGEX.test(m)?R.localize(7,null,m):p.getConfigurationProperties()[m]!==void 0?R.localize(8,null,m):i.policy?.name&&p.getPolicyConfigurations().get(i.policy?.name)!==void 0?R.localize(9,null,m,i.policy?.name,p.getPolicyConfigurations().get(i.policy?.name)):null:R.localize(6,null)}e.validateProperty=k;function I(){const m=[],i=p.getConfigurationProperties();for(const r of Object.keys(i))m.push([r,i[r].scope]);return m.push(["launch",4]),m.push(["task",4]),m}e.getScopes=I}),define(ie[109],re([0,1,24,3,43,2,39,44,11,7,18,65,48]),function(H,e,E,t,C,R,A,P,g,w,b,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class u{constructor(r={},n=[],a=[],o){this.c=r,this.d=n,this.f=a,this.raw=o,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const r=this.raw.map(n=>{if(n instanceof u)return n;const a=new d("");return a.parseRaw(n),a.configurationModel});this.g=r.reduce((n,a)=>a===n?a:n.merge(a),r[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(r){return r?(0,b.getConfigurationValue)(this.contents,r):this.contents}inspect(r,n){const a=this.rawConfiguration.getValue(r),o=n?this.rawConfiguration.getOverrideValue(r,n):void 0,c=n?this.rawConfiguration.override(n).getValue(r):a;return{value:a,override:o,merged:c}}getOverrideValue(r,n){const a=this.l(n);return a?r?(0,b.getConfigurationValue)(a,r):a:void 0}getKeysForOverrideIdentifier(r){const n=[];for(const a of this.overrides)a.identifiers.includes(r)&&n.push(...a.keys);return E.distinct(n)}getAllOverrideIdentifiers(){const r=[];for(const n of this.overrides)r.push(...n.identifiers);return E.distinct(r)}override(r){let n=this.b.get(r);return n||(n=this.h(r),this.b.set(r,n)),n}merge(...r){const n=P.deepClone(this.contents),a=P.deepClone(this.overrides),o=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const s of r)if(c.push(...s.raw?.length?s.raw:[s]),!s.isEmpty()){this.j(n,s.contents);for(const f of s.overrides){const[M]=a.filter(L=>E.equals(L.identifiers,f.identifiers));M?(this.j(M.contents,f.contents),M.keys.push(...f.keys),M.keys=E.distinct(M.keys)):a.push(P.deepClone(f))}for(const f of s.keys)o.indexOf(f)===-1&&o.push(f)}return new u(n,o,a,c.every(s=>s instanceof u)?void 0:c)}freeze(){return this.a=!0,this}clone(){return new u(P.deepClone(this.contents),[...this.keys],P.deepClone(this.overrides))}h(r){const n=this.l(r);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const a={};for(const o of E.distinct([...Object.keys(this.contents),...Object.keys(n)])){let c=this.contents[o];const s=n[o];s&&(typeof c=="object"&&typeof s=="object"?(c=P.deepClone(c),this.j(c,s)):c=s),a[o]=c}return new u(a,this.keys,this.overrides)}j(r,n){for(const a of Object.keys(n)){if(a in r&&g.isObject(r[a])&&g.isObject(n[a])){this.j(r[a],n[a]);continue}r[a]=P.deepClone(n[a])}}k(r){return this.a&&!Object.isFrozen(r)?P.deepFreeze(r):r}l(r){let n=null,a=null;const o=c=>{c&&(a?this.j(a,c):a=P.deepClone(c))};for(const c of this.overrides)E.equals(c.identifiers,[r])?n=c.contents:c.identifiers.includes(r)&&o(c.contents);return o(n),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,n){this.m(r),(0,b.addToValueTree)(this.contents,r,n,a=>{throw new Error(a)})}removeValue(r){this.n(r)&&(0,b.removeFromValueTree)(this.contents,r)}m(r){let n=this.keys.length;for(let a=0;a<n;a++)r.indexOf(this.keys[a])===0&&(n=a);this.keys.splice(n,1,r)}n(r){const n=this.keys.indexOf(r);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=u;class d{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new u}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,n){if(!g.isUndefinedOrNull(r)){const a=this.g(r);this.parseRaw(a,n)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,n){this.a=r;const{contents:a,keys:o,overrides:c,restricted:s,hasExcludedProperties:f}=this.h(r,n);this.b=new u(a,o,c,f?[r]:void 0),this.c=s||[]}g(r){let n={},a=null,o=[];const c=[],s=[];function f(L){Array.isArray(o)?o.push(L):a!==null&&(o[a]=L)}const M={onObjectBegin:()=>{const L={};f(L),c.push(o),o=L,a=null},onObjectProperty:L=>{a=L},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const L=[];f(L),c.push(o),o=L,a=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:f,onError:(L,T,U)=>{s.push({error:L,offset:T,length:U})}};if(r)try{C.visit(r,M),n=o[0]||{}}catch(L){console.error(`Error while parsing settings file ${this.f}: ${L}`),this.d=[L]}return n}h(r,n){const a=y.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),o=this.j(r,a,!0,n);r=o.raw;const c=(0,b.toValuesTree)(r,M=>console.error(`Conflict in settings file ${this.f}: ${M}`)),s=Object.keys(r),f=this.l(r,M=>console.error(`Conflict in settings file ${this.f}: ${M}`));return{contents:c,keys:s,overrides:f,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}j(r,n,a,o){let c=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:c};const s={},f=[];for(const M in r)if(S.OVERRIDE_PROPERTY_REGEX.test(M)&&a){const L=this.j(r[M],n,!1,o);s[M]=L.raw,c=c||L.hasExcludedProperties,f.push(...L.restricted)}else{const L=n[M],T=L?typeof L.scope<"u"?L.scope:3:void 0;L?.restricted&&f.push(M),(T===void 0||o.scopes===void 0||o.scopes.includes(T))&&!(o.skipRestricted&&L?.restricted)?s[M]=r[M]:c=!0}return{raw:s,restricted:f,hasExcludedProperties:c}}l(r,n){const a=[];for(const o of Object.keys(r))if(S.OVERRIDE_PROPERTY_REGEX.test(o)){const c={};for(const s in r[o])c[s]=r[o][s];a.push({identifiers:(0,S.overrideIdentifiersFromKey)(o),keys:Object.keys(c),contents:(0,b.toValuesTree)(c,n)})}return a}}e.ConfigurationModelParser=d;class v extends R.Disposable{constructor(r,n,a,o){super(),this.f=r,this.g=n,this.h=o,this.c=this.B(new t.Emitter),this.onDidChange=this.c.event,this.a=new d(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(a.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(t.Event.any(t.Event.filter(this.h.onDidFilesChange,c=>c.contains(this.f)),t.Event.filter(this.h.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&a.isEqual(c.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new u}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=v;class h{constructor(r,n,a,o,c,s,f,M,L,T,U,K,V){this.a=r,this.b=n,this.value=a,this.overrideIdentifiers=o,this.c=c,this.d=s,this.f=f,this.g=M,this.h=L,this.j=T,this.k=U,this.l=K,this.m=V}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class l{constructor(r,n,a,o,c=new u,s=new u,f=new A.ResourceMap,M=new u,L=new A.ResourceMap,T=!0){this.c=r,this.d=n,this.f=a,this.g=o,this.h=c,this.j=s,this.l=f,this.m=M,this.n=L,this.p=T,this.a=null,this.b=new A.ResourceMap,this.q=null}getValue(r,n,a){return this.s(r,n,a).getValue(r)}updateValue(r,n,a={}){let o;a.resource?(o=this.n.get(a.resource),o||(o=new u,this.n.set(a.resource,o))):o=this.m,n===void 0?o.removeValue(r):o.setValue(r,n),a.resource||(this.a=null)}inspect(r,n,a){const o=this.s(r,n,a),c=this.w(n.resource,a),s=n.resource?this.n.get(n.resource)||this.m:this.m,f=new Set;for(const M of o.overrides)for(const L of M.identifiers)o.getOverrideValue(r,L)!==void 0&&f.add(L);return new h(r,n,o.getValue(r),f.size?[...f]:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),a?this.j.freeze():void 0,c?c.freeze():void 0,s.inspect(r,n.overrideIdentifier))}keys(r){const n=this.w(void 0,r);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.j=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,n){this.l.set(r,n),this.b.delete(r)}deleteFolderConfiguration(r){this.r.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,n){const a=[];if(!n){const{added:o,updated:c,removed:s}=I(this.c,r);n=[...o,...c,...s]}for(const o of n)for(const c of(0,S.overrideIdentifiersFromKey)(o)){const s=this.c.getKeysForOverrideIdentifier(c),f=r.getKeysForOverrideIdentifier(c),M=[...f.filter(L=>s.indexOf(L)===-1),...s.filter(L=>f.indexOf(L)===-1),...s.filter(L=>!P.equals(this.c.override(c).getValue(L),r.override(c).getValue(L)))];a.push([c,M])}return this.updateDefaultConfiguration(r),{keys:n,overrides:a}}compareAndUpdatePolicyConfiguration(r){const{added:n,updated:a,removed:o}=I(this.d,r),c=[...n,...a,...o];return c.length&&this.updatePolicyConfiguration(r),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:n,updated:a,removed:o,overrides:c}=I(this.applicationConfiguration,r),s=[...n,...a,...o];return s.length&&this.updateApplicationConfiguration(r),{keys:s,overrides:c}}compareAndUpdateLocalUserConfiguration(r){const{added:n,updated:a,removed:o,overrides:c}=I(this.localUserConfiguration,r),s=[...n,...a,...o];return s.length&&this.updateLocalUserConfiguration(r),{keys:s,overrides:c}}compareAndUpdateRemoteUserConfiguration(r){const{added:n,updated:a,removed:o,overrides:c}=I(this.remoteUserConfiguration,r),s=[...n,...a,...o];return s.length&&this.updateRemoteUserConfiguration(r),{keys:s,overrides:c}}compareAndUpdateWorkspaceConfiguration(r){const{added:n,updated:a,removed:o,overrides:c}=I(this.workspaceConfiguration,r),s=[...n,...a,...o];return s.length&&this.updateWorkspaceConfiguration(r),{keys:s,overrides:c}}compareAndUpdateFolderConfiguration(r,n){const a=this.r.get(r),{added:o,updated:c,removed:s,overrides:f}=I(a,n),M=[...o,...c,...s];return(M.length||!a)&&this.updateFolderConfiguration(r,n),{keys:M,overrides:f}}compareAndDeleteFolderConfiguration(r){const n=this.r.get(r);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:a,updated:o,removed:c,overrides:s}=I(n,void 0);return{keys:[...a,...o,...c],overrides:s}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(r,n,a){let o=this.t(n,a);return n.overrideIdentifier&&(o=o.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(o=o.merge(this.d)),o}t({resource:r},n){let a=this.u();if(n&&r){const o=n.getFolder(r);o&&(a=this.v(o.uri)||a);const c=this.n.get(r);c&&(a=a.merge(c))}return a}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(r){let n=this.b.get(r);if(!n){const a=this.u(),o=this.l.get(r);o?(n=a.merge(o),this.p&&(n=n.freeze()),this.b.set(r,n)):n=a}return n}w(r,n){if(n&&r){const a=n.getFolder(r);if(a)return this.l.get(a.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((r,n)=>{const{contents:a,overrides:o,keys:c}=this.l.get(n);return r.push([n,{contents:a,overrides:o,keys:c}]),r},[])}}allKeys(){const r=new Set;return this.c.freeze().keys.forEach(n=>r.add(n)),this.userConfiguration.freeze().keys.forEach(n=>r.add(n)),this.j.freeze().keys.forEach(n=>r.add(n)),this.l.forEach(n=>n.freeze().keys.forEach(a=>r.add(a))),[...r.values()]}x(){const r=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this.j.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this.l.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(a=>r.add(a))),[...r.values()]}y(r){const n=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(a=>n.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(a=>n.add(a)),this.j.getKeysForOverrideIdentifier(r).forEach(a=>n.add(a)),this.l.forEach(a=>a.getKeysForOverrideIdentifier(r).forEach(o=>n.add(o))),[...n.values()]}static parse(r){const n=this.z(r.defaults),a=this.z(r.policy),o=this.z(r.application),c=this.z(r.user),s=this.z(r.workspace),f=r.folders.reduce((M,L)=>(M.set(w.URI.revive(L[0]),this.z(L[1])),M),new A.ResourceMap);return new l(n,a,o,c,new u,s,f,new u,new A.ResourceMap,!1)}static z(r){return new u(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=l;function p(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const r=new Set,n=new Map;for(const o of i)o.keys.forEach(c=>r.add(c)),o.overrides.forEach(([c,s])=>{const f=(0,A.getOrSet)(n,c,new Set);s.forEach(M=>f.add(M))});const a=[];return n.forEach((o,c)=>a.push([c,[...o.values()]])),{keys:[...r.values()],overrides:a}}e.mergeChanges=p;class k{constructor(r,n,a,o){this.change=r,this.b=n,this.c=a,this.d=o,this.f=void 0;const c=new Set;r.keys.forEach(f=>c.add(f)),r.overrides.forEach(([,f])=>f.forEach(M=>c.add(M))),this.affectedKeys=[...c.values()];const s=new u;this.affectedKeys.forEach(f=>s.setValue(f,{})),this.a=s.contents}get previousConfiguration(){return!this.f&&this.b&&(this.f=l.parse(this.b.data)),this.f}affectsConfiguration(r,n){if(this.g(this.a,r)){if(n){const a=this.previousConfiguration?this.previousConfiguration.getValue(r,n,this.b?.workspace):void 0,o=this.c.getValue(r,n,this.d);return!P.equals(a,o)}return!0}return!1}g(r,n){let a=(0,b.toValuesTree)({[n]:!0},()=>{}),o;for(;typeof a=="object"&&(o=Object.keys(a)[0]);){if(r=r[o],!r)return!1;a=a[o]}return!0}}e.ConfigurationChangeEvent=k;function I(i,r){const{added:n,removed:a,updated:o}=m(r?.rawConfiguration,i?.rawConfiguration),c=[],s=i?.getAllOverrideIdentifiers()||[],f=r?.getAllOverrideIdentifiers()||[];if(r){const M=f.filter(L=>!s.includes(L));for(const L of M)c.push([L,r.getKeysForOverrideIdentifier(L)])}if(i){const M=s.filter(L=>!f.includes(L));for(const L of M)c.push([L,i.getKeysForOverrideIdentifier(L)])}if(r&&i){for(const M of s)if(f.includes(M)){const L=m({contents:i.getOverrideValue(void 0,M)||{},keys:i.getKeysForOverrideIdentifier(M)},{contents:r.getOverrideValue(void 0,M)||{},keys:r.getKeysForOverrideIdentifier(M)});c.push([M,[...L.added,...L.removed,...L.updated]])}}return{added:n,removed:a,updated:o,overrides:c}}function m(i,r){const n=i?r?i.keys.filter(c=>r.keys.indexOf(c)===-1):[...i.keys]:[],a=r?i?r.keys.filter(c=>i.keys.indexOf(c)===-1):[...r.keys]:[],o=[];if(i&&r){for(const c of r.keys)if(i.keys.indexOf(c)!==-1){const s=(0,b.getConfigurationValue)(r.contents,c),f=(0,b.getConfigurationValue)(i.contents,c);P.equals(s,f)||o.push(c)}}return{added:n,removed:a,updated:o}}}),define(ie[219],re([0,1,24,3,2,44,11,18,109,65,6,37,48]),function(H,e,E,t,C,R,A,P,g,w,b,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class u extends C.Disposable{constructor(){super(...arguments),this.a=this.B(new t.Emitter),this.onDidChangeConfiguration=this.a.event}get configurationModel(){return this.b||(this.b=new d(this.f())),this.b}async initialize(){return this.b=void 0,this.B(y.Registry.as(w.Extensions.Configuration).onDidUpdateConfiguration(({properties:p,defaultsOverrides:k})=>this.c(p,k))),this.configurationModel}reload(){return this.b=void 0,this.configurationModel}c(p,k){this.b=void 0,this.a.fire({defaults:this.configurationModel,properties:p})}f(){return{}}}e.DefaultConfiguration=u;class d extends g.ConfigurationModel{constructor(p={}){const k=y.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),I=Object.keys(k),m=Object.create(null),i=[];for(const r in k){const n=p[r],a=n!==void 0?n:k[r].default;(0,P.addToValueTree)(m,r,a,o=>console.error(`Conflict in default settings: ${o}`))}for(const r of Object.keys(m))w.OVERRIDE_PROPERTY_REGEX.test(r)&&i.push({identifiers:(0,w.overrideIdentifiersFromKey)(r),keys:Object.keys(m[r]),contents:(0,P.toValuesTree)(m[r],n=>console.error(`Conflict in default settings file: ${n}`))});super(m,I,i)}}e.DefaultConfigurationModel=d;class v{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new g.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=v;let h=class extends C.Disposable{get configurationModel(){return this.b}constructor(p,k,I){super(),this.c=p,this.f=k,this.g=I,this.a=this.B(new t.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new g.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(p=>this.i(p))),this.B(this.c.onDidChangeConfiguration(async({properties:p})=>this.j(await this.h(p),!0))),this.b}async h(p){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",p);const k={},I=[],m=y.Registry.as(w.Extensions.Configuration).getConfigurationProperties();for(const i of p){const r=m[i];if(!r){I.push(i);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.g.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}I.push(i),k[r.policy.name]={type:r.type}}}return(0,A.isEmptyObject)(k)||await this.f.updatePolicyDefinitions(k),I}i(p){this.g.trace("PolicyConfiguration#onDidChangePolicies",p);const k=y.Registry.as(w.Extensions.Configuration).getPolicyConfigurations(),I=(0,E.coalesce)(p.map(m=>k.get(m)));this.j(I,!0)}j(p,k){this.g.trace("PolicyConfiguration#update",p);const I=y.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),m=[],i=this.b.isEmpty();for(const r of p){const n=I[r]?.policy?.name;if(n){const a=this.f.getPolicyValue(n);(i?a!==void 0:!(0,R.equals)(this.b.getValue(r),a))&&m.push([r,a])}else this.b.getValue(r)!==void 0&&m.push([r,void 0])}if(m.length){this.g.trace("PolicyConfiguration#changed",m);const r=this.b;this.b=new g.ConfigurationModel;for(const n of r.keys)this.b.setValue(n,r.getValue(n));for(const[n,a]of m)a===void 0?this.b.removeValue(n):this.b.setValue(n,a);k&&this.a.fire(this.b)}}};h=pe([ee(1,S.IPolicyService),ee(2,b.ILogService)],h),e.PolicyConfiguration=h}),define(ie[220],re([0,1,8,3,2,20,18,109,219,37]),function(H,e,E,t,C,R,A,P,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class b extends C.Disposable{constructor(y,u,d,v){super(),this.i=y,this.h=this.B(new t.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new g.DefaultConfiguration),this.c=d instanceof w.NullPolicyService?new g.NullPolicyConfiguration:this.B(new g.PolicyConfiguration(this.b,d,v)),this.f=this.B(new P.UserSettings(this.i,void 0,R.extUriBiasedIgnorePathCase,u)),this.a=new P.Configuration(this.b.configurationModel,this.c.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.g=this.B(new E.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:h,properties:l})=>this.k(h,l))),this.B(this.c.onDidChangeConfiguration(h=>this.l(h))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[y,u,d]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.Configuration(y,u,new P.ConfigurationModel,d)}getConfigurationData(){return this.a.toData()}getValue(y,u){const d=typeof y=="string"?y:void 0,v=(0,A.isConfigurationOverrides)(y)?y:(0,A.isConfigurationOverrides)(u)?u:{};return this.a.getValue(d,v,void 0)}updateValue(y,u,d,v){return Promise.reject(new Error("not supported"))}inspect(y){return this.a.inspect(y,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const y=await this.f.loadConfiguration();this.j(y)}j(y){const u=this.a.toData(),d=this.a.compareAndUpdateLocalUserConfiguration(y);this.m(d,u,2)}k(y,u){const d=this.a.toData(),v=this.a.compareAndUpdateDefaultConfiguration(y,u);this.m(v,d,7)}l(y){const u=this.a.toData(),d=this.a.compareAndUpdatePolicyConfiguration(y);this.m(d,u,7)}m(y,u,d){const v=new P.ConfigurationChangeEvent(y,{data:u},this.a);v.source=d,v.sourceConfig=this.n(d),this.h.fire(v)}n(y){switch(y){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=b}),define(ie[221],re([0,1,15,5]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var C;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(C=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends E.ErrorNoTelemetry{static isNotAvailable(P){return P instanceof R&&P._code===C.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof R&&P._code===C.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof R&&P._code===C.NoResolverFound}static isHandled(P){return P instanceof R&&P.isHandled}constructor(P,g=C.Unknown,w){super(P),this._message=P,this._code=g,this._detail=w,this.isHandled=g===C.NotAvailable&&w===!0,Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R}),define(ie[55],re([0,1,14]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(w){return w.scheme===E.Schemas.vscodeRemote?w.authority:void 0}e.getRemoteAuthority=t;function C(w){if(!w)return;const b=w.indexOf("+");return b<0?w:w.substr(0,b)}e.getRemoteName=C;function R(w){return`/${w.quality??"oss"}-${w.commit??"dev"}`}e.getRemoteServerRootPath=R;function A(w){const{host:b,port:S}=g(w);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:b,port:S}}e.parseAuthorityWithPort=A;function P(w,b){let{host:S,port:y}=g(w);return typeof y>"u"&&(y=b),{host:S,port:y}}e.parseAuthorityWithOptionalPort=P;function g(w){const b=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const S=w.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const y=w.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:w,port:void 0}}}),define(ie[88],re([0,1,26,5,55]),function(H,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=R;function A(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var g;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(g=e.TargetPlatform||(e.TargetPlatform={}));class w{constructor(v){this.value=v,this.c=v.toLowerCase()}static equals(v,h){if(typeof v>"u"||v===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof v=="string"||typeof h=="string"){const l=typeof v=="string"?v:v.value,p=typeof h=="string"?h:h.value;return E.equalsIgnoreCase(l,p)}return v.c===h.c}static toKey(v){return typeof v=="string"?v.toLowerCase():v.c}}e.ExtensionIdentifier=w;function b(d){return S(d)}e.isApplicationScopedExtension=b;function S(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function y(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=y;function u(d,v){if(v){const h=`onResolveRemoteAuthority:${(0,C.getRemoteName)(v)}`;return d.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=u,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ie[222],re([0,1,8,17,22,15,3,2,29,102,221,55]),function(H,e,E,t,C,R,A,P,g,w,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const y=30*1e3;var u;(function(D){D[D.Management=1]="Management",D[D.ExtensionHost=2]="ExtensionHost",D[D.Tunnel=3]="Tunnel"})(u=e.ConnectionType||(e.ConnectionType={}));function d(D){switch(D){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function v(D){const O=new C.CancellationTokenSource;return setTimeout(()=>O.cancel(),D),O.token}function h(D,O){if(D.isCancellationRequested||O.isCancellationRequested)return C.CancellationToken.Cancelled;const W=new C.CancellationTokenSource;return D.onCancellationRequested(()=>W.cancel()),O.onCancellationRequested(()=>W.cancel()),W.token}class l{get didTimeout(){return this.c==="timedout"}constructor(O){this.c="pending",this.d=new P.DisposableStore,this.promise=new Promise((W,j)=>{this.f=W,this.g=j}),O.isCancellationRequested?this.h():this.d.add(O.onCancellationRequested(()=>this.h()))}registerDisposable(O){this.c==="pending"?this.d.add(O):O.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const O=new Error("Time limit reached");return O.code="ETIMEDOUT",O.syscall="connect",O}resolve(O){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(O))}reject(O){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(O))}}function p(D,O){const W=new l(O);return W.registerDisposable(D.onControlMessage(j=>{const $=JSON.parse(j.toString()),Y=N($);Y?W.reject(Y):W.resolve($)})),W.promise}function k(D,O,W,j,$,Y,B,Z){const te=new l(Z);return O.connect(W,j,$,Y,B,(ae,ge)=>{te.didTimeout?(ae&&D.error(ae),ge?.dispose()):ae||!ge?te.reject(ae):te.resolve(ge)}),te.promise}function I(D,O){const W=new l(O);return D.then(j=>{W.didTimeout||W.resolve(j)},j=>{W.didTimeout||W.reject(j)}),W.promise}async function m(D,O,W,j){const $=oe(D,O);D.logService.trace(`${$} 1/6. invoking socketFactory.connect().`);let Y;try{Y=await k(D.logService,D.socketFactory,D.host,D.port,(0,S.getRemoteServerRootPath)(D),`reconnectionToken=${D.reconnectionToken}&reconnection=${D.reconnectionProtocol?"true":"false"}`,`renderer-${d(O)}-${D.reconnectionToken}`,j)}catch(ge){throw D.logService.error(`${$} socketFactory.connect() failed or timed out. Error:`),D.logService.error(ge),ge}D.logService.trace(`${$} 2/6. socketFactory.connect() was successful.`);let B,Z;D.reconnectionProtocol?(D.reconnectionProtocol.beginAcceptReconnection(Y,null),B=D.reconnectionProtocol,Z=!1):(B=new w.PersistentProtocol({socket:Y,measureRoundTripTime:!0}),Z=!0),D.logService.trace(`${$} 3/6. sending AuthRequest control message.`);const te=await I(D.signService.createNewMessage((0,g.generateUuid)()),j),ae={type:"auth",auth:D.connectionToken||"00000000000000000000",data:te.data};B.sendControl(t.VSBuffer.fromString(JSON.stringify(ae)));try{const ge=await p(B,h(j,v(1e4)));if(ge.type!=="sign"||typeof ge.data!="string"){const Re=new Error("Unexpected handshake message");throw Re.code="VSCODE_CONNECTION_ERROR",Re}if(D.logService.trace(`${$} 4/6. received SignRequest control message.`),!await I(D.signService.validate(te,ge.signedData),j)){const Re=new Error("Refused to connect to unsupported server");throw Re.code="VSCODE_CONNECTION_ERROR",Re}const Oe=await I(D.signService.sign(ge.data),j),De={type:"connectionType",commit:D.commit,signedData:Oe,desiredConnectionType:O};return W&&(De.args=W),D.logService.trace(`${$} 5/6. sending ConnectionTypeRequest control message.`),B.sendControl(t.VSBuffer.fromString(JSON.stringify(De))),{protocol:B,ownsProtocol:Z}}catch(ge){throw ge&&ge.code==="ETIMEDOUT"&&(D.logService.error(`${$} the handshake timed out. Error:`),D.logService.error(ge)),ge&&ge.code==="VSCODE_CONNECTION_ERROR"&&(D.logService.error(`${$} received error control message when negotiating connection. Error:`),D.logService.error(ge)),Z&&z(B),ge}}async function i(D,O,W,j){const $=Date.now(),Y=oe(D,O),{protocol:B,ownsProtocol:Z}=await m(D,O,W,j),te=new l(j);return te.registerDisposable(B.onControlMessage(ae=>{const ge=JSON.parse(ae.toString()),ke=N(ge);ke?(D.logService.error(`${Y} received error control message when negotiating connection. Error:`),D.logService.error(ke),Z&&z(B),te.reject(ke)):(D.reconnectionProtocol?.endAcceptReconnection(),D.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${x($)}!`),te.resolve({protocol:B,firstMessage:ge}))})),te.promise}async function r(D,O){const{protocol:W}=await i(D,1,void 0,O);return{protocol:W}}async function n(D,O,W){const{protocol:j,firstMessage:$}=await i(D,2,O,W),Y=$&&$.debugPort;return{protocol:j,debugPort:Y}}async function a(D,O,W){const j=Date.now(),$=oe(D,3),{protocol:Y}=await m(D,3,O,W);return D.logService.trace(`${$} 6/6. handshake finished, connection is up and running after ${x(j)}!`),Y}async function o(D,O,W){const{host:j,port:$,connectionToken:Y}=await D.addressProvider.getAddress();return{commit:D.commit,quality:D.quality,host:j,port:$,connectionToken:Y,reconnectionToken:O,reconnectionProtocol:W,socketFactory:D.socketFactory,signService:D.signService,logService:D.logService}}async function c(D,O,W){return f(D,async j=>{const{protocol:$}=await r(j,C.CancellationToken.None);return new X(D,O,W,j.reconnectionToken,$)})}e.connectRemoteAgentManagement=c;async function s(D,O){return f(D,async W=>{const{protocol:j,debugPort:$}=await n(W,O,C.CancellationToken.None);return new ue(D,O,W.reconnectionToken,j,$)})}e.connectRemoteAgentExtensionHost=s;async function f(D,O){for(let j=1;;j++)try{const $=(0,g.generateUuid)(),Y=await o(D,$,null);return await O(Y)}catch($){if(j<5)D.logService.error(`[remote-connection][attempt ${j}] An error occurred in initial connection! Will retry... Error:`),D.logService.error($);else throw D.logService.error(`[remote-connection][attempt ${j}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),D.logService.error($),ce.triggerPermanentFailure(0,0,b.RemoteAuthorityResolverError.isHandled($)),$}}async function M(D,O,W){const j=await o(D,(0,g.generateUuid)(),null);return await a(j,{host:O,port:W},C.CancellationToken.None)}e.connectRemoteAgentTunnel=M;function L(D){return(0,E.createCancelablePromise)(O=>new Promise((W,j)=>{const $=setTimeout(W,D*1e3);O.onCancellationRequested(()=>{clearTimeout($),W()})}))}var T;(function(D){D[D.ConnectionLost=0]="ConnectionLost",D[D.ReconnectionWait=1]="ReconnectionWait",D[D.ReconnectionRunning=2]="ReconnectionRunning",D[D.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",D[D.ConnectionGain=4]="ConnectionGain",D[D.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(T=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class U{constructor(O,W){this.reconnectionToken=O,this.millisSinceLastIncomingData=W,this.type=0}}e.ConnectionLostEvent=U;class K{constructor(O,W,j,$){this.reconnectionToken=O,this.millisSinceLastIncomingData=W,this.durationSeconds=j,this.c=$,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=K;class V{constructor(O,W,j){this.reconnectionToken=O,this.millisSinceLastIncomingData=W,this.attempt=j,this.type=2}}e.ReconnectionRunningEvent=V;class G{constructor(O,W,j){this.reconnectionToken=O,this.millisSinceLastIncomingData=W,this.attempt=j,this.type=4}}e.ConnectionGainEvent=G;class _{constructor(O,W){this.reconnectionToken=O,this.connectionHealth=W,this.type=5}}e.ConnectionHealthChangedEvent=_;class se{constructor(O,W,j,$){this.reconnectionToken=O,this.millisSinceLastIncomingData=W,this.attempt=j,this.handled=$,this.type=3}}e.ReconnectionPermanentFailureEvent=se;class ce extends P.Disposable{static triggerPermanentFailure(O,W,j){this._permanentFailure=!0,this.f=O,this.g=W,this.h=j,this.i.forEach($=>$.u(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(O=>O.r())}static debugPauseSocketWriting(){this.i.forEach(O=>O.v())}get k(){return this.c||ce._permanentFailure}constructor(O,W,j,$,Y){super(),this.m=O,this.n=W,this.reconnectionToken=j,this.protocol=$,this.p=Y,this.j=this.B(new A.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.j.fire(new G(this.reconnectionToken,0,0)),this.B($.onSocketClose(B=>{const Z=Q(this.m,this.reconnectionToken,!0);B?B.type===0?(this.n.logService.info(`${Z} received socket close event (hadError: ${B.hadError}).`),B.error&&this.n.logService.error(B.error)):(this.n.logService.info(`${Z} received socket close event (wasClean: ${B.wasClean}, code: ${B.code}, reason: ${B.reason}).`),B.event&&this.n.logService.error(B.event)):this.n.logService.info(`${Z} received socket close event.`),this.r()})),this.B($.onSocketTimeout(B=>{const Z=Q(this.m,this.reconnectionToken,!0);this.n.logService.info(`${Z} received socket timeout event (unacknowledgedMsgCount: ${B.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${B.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${B.timeSinceLastReceivedSomeData}).`),this.r()})),this.B($.onHighRoundTripTime(B=>{const Z=q(this.m,this.reconnectionToken);this.n.logService.info(`${Z} high roundtrip time: ${B.roundTripTime}ms (${B.recentHighRoundTripCount} of ${5} recent samples)`)})),this.B($.onDidChangeConnectionHealth(B=>{this.j.fire(new _(this.reconnectionToken,B))})),ce.i.push(this),this.B((0,P.toDisposable)(()=>{const B=ce.i.indexOf(this);B>=0&&ce.i.splice(B,1)})),this.k&&this.u(ce.f,ce.g,ce.h)}async r(){if(!this.l)try{this.l=!0,await this.s()}finally{this.l=!1}}async s(){if(this.k)return;const O=Q(this.m,this.reconnectionToken,!0);this.n.logService.info(`${O} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const W=[0,5,5,10,10,10,10,10,30];let j=-1;do{j++;const $=j<W.length?W[j]:W[W.length-1];try{if($>0){const B=L($);this.j.fire(new K(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),$,B)),this.n.logService.info(`${O} waiting for ${$} seconds before reconnecting...`);try{await B}catch{}}if(this.k){this.n.logService.error(`${O} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j+1)),this.n.logService.info(`${O} resolving connection...`);const Y=await o(this.n,this.reconnectionToken,this.protocol);this.n.logService.info(`${O} connecting to ${Y.host}:${Y.port}...`),await this.w(Y,v(y)),this.n.logService.info(`${O} reconnected!`),this.j.fire(new G(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j+1));break}catch(Y){if(Y.code==="VSCODE_CONNECTION_ERROR"){this.n.logService.error(`${O} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.n.logService.error(Y),this.t(this.protocol.getMillisSinceLastIncomingData(),j+1,!1);break}if(j>360){this.n.logService.error(`${O} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.n.logService.error(Y),this.t(this.protocol.getMillisSinceLastIncomingData(),j+1,!1);break}if(b.RemoteAuthorityResolverError.isTemporarilyNotAvailable(Y)){this.n.logService.info(`${O} A temporarily not available error occurred while trying to reconnect, will try again...`),this.n.logService.trace(Y);continue}if((Y.code==="ETIMEDOUT"||Y.code==="ENETUNREACH"||Y.code==="ECONNREFUSED"||Y.code==="ECONNRESET")&&Y.syscall==="connect"){this.n.logService.info(`${O} A network error occurred while trying to reconnect, will try again...`),this.n.logService.trace(Y);continue}if((0,R.isCancellationError)(Y)){this.n.logService.info(`${O} A promise cancelation error occurred while trying to reconnect, will try again...`),this.n.logService.trace(Y);continue}if(Y instanceof b.RemoteAuthorityResolverError){this.n.logService.error(`${O} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.n.logService.error(Y),this.t(this.protocol.getMillisSinceLastIncomingData(),j+1,b.RemoteAuthorityResolverError.isHandled(Y));break}this.n.logService.error(`${O} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.n.logService.error(Y),this.t(this.protocol.getMillisSinceLastIncomingData(),j+1,!1);break}}while(!this.k)}t(O,W,j){this.p?ce.triggerPermanentFailure(O,W,j):this.u(O,W,j)}u(O,W,j){this.j.fire(new se(this.reconnectionToken,O,W,j)),z(this.protocol)}v(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=ce,ce._permanentFailure=!1,ce.f=0,ce.g=0,ce.h=!1,ce.i=[];class X extends ce{constructor(O,W,j,$,Y){super(1,O,$,Y,!0),this.client=this.B(new w.Client(Y,{remoteAuthority:W,clientId:j},O.ipcLogger))}async w(O,W){await r(O,W)}}e.ManagementPersistentConnection=X;class ue extends ce{constructor(O,W,j,$,Y){super(2,O,j,$,!1),this.y=W,this.debugPort=Y}async w(O,W){await n(O,this.y,W)}}e.ExtensionHostPersistentConnection=ue;function z(D){try{D.acceptDisconnect();const O=D.getSocket();D.dispose(),O.dispose()}catch(O){(0,R.onUnexpectedError)(O)}}function N(D){if(D&&D.type==="error"){const O=new Error(`Connection error: ${D.reason}`);return O.code="VSCODE_CONNECTION_ERROR",O}return null}function F(D,O){for(;D.length<O;)D+=" ";return D}function q(D,O){return`[remote-connection][${F(d(D),13)}][${O.substr(0,5)}\u2026]`}function Q(D,O,W){return`${q(D,O)}[${W?"reconnect":"initial"}]`}function oe(D,O){return`${Q(O,D.reconnectionToken,!!D.reconnectionProtocol)}[${D.host}:${D.port}]`}function x(D){return`${Date.now()-D} ms`}}),define(ie[223],re([0,1,79,84]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(C,R,A,P,g,w){const b=y=>w(y,void 0),S=E.createConnection({host:C,port:R},()=>{S.removeListener("error",b);const y=Buffer.alloc(16);for(let h=0;h<16;h++)y[h]=Math.round(Math.random()*256);const u=y.toString("base64"),d=[`GET ws://${/:/.test(C)?`[${C}]`:C}:${R}${A}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${u}`];S.write(d.join(`\r
`)+`\r
\r
`);const v=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(S.off("data",v),w(void 0,new t.NodeSocket(S,g)))};S.on("data",v)});S.setNoDelay(!0),S.once("error",b)}}}),define(ie[224],re([0,1,25,46,40,183]),function(H,e,E,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let A;async function P(u=!1){return(A===void 0||u)&&(A=g()),A}e.hasWSLFeatureInstalled=P;async function g(){const u=w();if(u===void 0)return!1;if(u>=22e3){const d=S();if(d)return new Promise(v=>{t.execFile(d,["--status"],h=>v(!h))})}else{const d=y();if(d)try{if((await C.promises.stat(d)).isFile())return!0}catch{}}return!1}function w(){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());if(u)return parseInt(u[3])}function b(u){const d=process.env.SystemRoot;if(d){const v=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return R.join(d,v?"Sysnative":"System32",u)}}function S(){return b("wsl.exe")}function y(){return b("lxss\\LxssManager.dll")}}),define(ie[56],re([0,1,17,167,65,5,48]),function(H,e,E,t,C,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function P(v){return v.res.statusCode&&v.res.statusCode>=200&&v.res.statusCode<300||v.res.statusCode===1223}e.isSuccess=P;function g(v){return v.res.statusCode===204}async function w(v){return g(v)?null:(await(0,E.streamToBuffer)(v.stream)).toString()}e.asText=w;async function b(v){if(!P(v))throw new Error("Server returned "+v.res.statusCode);return w(v)}e.asTextOrError=b;async function S(v){if(!P(v))throw new Error("Server returned "+v.res.statusCode);if(g(v))return null;const l=(await(0,E.streamToBuffer)(v.stream)).toString();try{return JSON.parse(l)}catch(p){throw p.message+=`:
`+l,p}}e.asJson=S;function y(v){d(v)}e.updateProxyConfigurationsScope=y;let u;function d(v){const h=A.Registry.as(C.Extensions.Configuration),l=u;u={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:v,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},h.updateConfigurations({add:[u],remove:l?[l]:[]})}d(2)}),define(ie[225],re([0,1,17,22]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class C{constructor(P){this.a=P}listen(P,g){throw new Error("Invalid listen")}call(P,g,w,b=t.CancellationToken.None){switch(g){case"request":return this.a.request(w[0],b).then(async({res:S,stream:y})=>{const u=await(0,E.streamToBuffer)(y);return[{statusCode:S.statusCode,headers:S.headers},u]});case"resolveProxy":return this.a.resolveProxy(w[0])}throw new Error("Invalid call")}}e.RequestChannel=C;class R{constructor(P){this.a=P}async request(P,g){const[w,b]=await this.a.call("request",[P],g);return{res:w,stream:(0,E.bufferToStream)(b)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}}e.RequestChannelClient=R}),define(ie[226],re([0,1,227,11]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function C(A,P){return A.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:A.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function R(A,P,g={}){const w=(0,E.parse)(A),b=g.proxyUrl||C(w,P);if(!b)return null;const S=(0,E.parse)(b);if(!/^https?:$/.test(S.protocol||""))return null;const y={host:S.hostname||"",port:S.port||(S.protocol==="https"?"443":"80"),auth:S.auth,rejectUnauthorized:(0,t.isBoolean)(g.strictSSL)?g.strictSSL:!0};return w.protocol==="http:"?new(await new Promise((u,d)=>{H(["http-proxy-agent"],u,d)}))(y):new(await new Promise((u,d)=>{H(["https-proxy-agent"],u,d)}))(y)}e.getProxyAgent=R}),define(ie[110],re([0,1,46,9,168,22,45,15,4,29,144,61,8,126]),function(H,e,E,t,C,R,A,P,g,w,b,S,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let d;async function v(l,p,k,I){return k["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):g.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,S.isLaunchedFromCli)(I)&&!k["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,S.isLaunchedFromCli)(I)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=y.Promises.withAsyncBody(async(m,i)=>{const r=new R.CancellationTokenSource;let n=1e4;const a=l.getValue("application.shellEnvironmentResolutionTimeout");typeof a=="number"&&(n=(0,u.clamp)(a,1,120)*1e3);const o=setTimeout(()=>{r.dispose(!0),i(new Error((0,C.localize)(0,null)))},n);try{m(await h(p,r.token))}catch(c){!(0,P.isCancellationError)(c)&&!r.token.isCancellationRequested?i(new Error((0,C.localize)(1,null,(0,A.toErrorMessage)(c)))):m({})}finally{clearTimeout(o),r.dispose()}})),d)}e.getResolvedShellEnv=v;async function h(l,p){const k=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",k);const I=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",I);const m=(0,w.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(m+"({.*})"+m),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};l.trace("getUnixShellEnvironment#env",r);const n=await(0,b.getSystemShell)(g.OS,r);return l.trace("getUnixShellEnvironment#shell",n),new Promise((a,o)=>{if(p.isCancellationRequested)return o(new P.CancellationError);const c=(0,t.basename)(n);let s,f;const M=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(s=`& '${process.execPath}' ${M} -p '''${m}'' + JSON.stringify(process.env) + ''${m}'''`,f=["-Login","-Command"]):(s=`'${process.execPath}' ${M} -p '"${m}" + JSON.stringify(process.env) + "${m}"'`,c==="tcsh"?f=["-ic"]:f=["-ilc"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(f),s);const L=(0,E.spawn)(n,[...f,s],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});p.onCancellationRequested(()=>(L.kill(),o(new P.CancellationError))),L.on("error",K=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(K)),o(K)});const T=[];L.stdout.on("data",K=>T.push(K));const U=[];L.stderr.on("data",K=>U.push(K)),L.on("close",(K,V)=>{const G=Buffer.concat(T).toString("utf8");l.trace("getUnixShellEnvironment#raw",G);const _=Buffer.concat(U).toString("utf8");if(_.trim()&&l.trace("getUnixShellEnvironment#stderr",_),K||V)return o(new Error((0,C.localize)(2,null,K,V)));const se=i.exec(G),ce=se?se[1]:"{}";try{const X=JSON.parse(ce);k?X.ELECTRON_RUN_AS_NODE=k:delete X.ELECTRON_RUN_AS_NODE,I?X.ELECTRON_NO_ATTACH_CONSOLE=I:delete X.ELECTRON_NO_ATTACH_CONSOLE,delete X.VSCODE_RESOLVING_ENVIRONMENT,delete X.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",X),a(X)}catch(X){l.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(X)),o(X)}})})}}),define(ie[89],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,E.createDecorator)(e.SIGN_SERVICE_ID)}),define(ie[228],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class E{constructor(){this.b=new Map}c(){return new Promise((C,R)=>H(["vsda"],C,R))}async createNewMessage(C){try{const R=await this.c(),A=new R.validator;if(A){const P=String(E.a++);return this.b.set(P,A),{id:P,data:A.createNewMessage(C)}}}catch{}return{id:"",data:C}}async validate(C,R){if(!C.id)return!0;const A=this.b.get(C.id);if(!A)return!1;this.b.delete(C.id);try{return A.validate(R)==="ok"}catch{return!1}}async sign(C){try{const R=await this.c(),A=new R.signer;if(A)return A.sign(C)}catch{}return C}}e.SignService=E,E.a=1}),define(ie[36],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,E.createDecorator)("stateMainService")}),define(ie[21],re([0,1,13,41,8,3,2,4,33,11,5,6,36,27]),function(H,e,E,t,C,R,A,P,g,w,b,S,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,b.createDecorator)("lifecycleMainService");var d;(function(l){l[l.QUIT=1]="QUIT",l[l.KILL=2]="KILL"})(d=e.ShutdownReason||(e.ShutdownReason={}));var v;(function(l){l[l.Starting=1]="Starting",l[l.Ready=2]="Ready",l[l.AfterWindowOpen=3]="AfterWindowOpen",l[l.Eventually=4]="Eventually"})(v=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let h=class It extends A.Disposable{get quitRequested(){return this.i}get wasRestarted(){return this.j}get phase(){return this.k}constructor(p,k,I){super(),this.v=p,this.w=k,this.y=I,this.c=this.B(new R.Emitter),this.onBeforeShutdown=this.c.event,this.f=this.B(new R.Emitter),this.onWillShutdown=this.f.event,this.g=this.B(new R.Emitter),this.onWillLoadWindow=this.g.event,this.h=this.B(new R.Emitter),this.onBeforeCloseWindow=this.h.event,this.i=!1,this.j=!1,this.k=1,this.l=new Set,this.m=0,this.n=0,this.p=void 0,this.r=void 0,this.s=void 0,this.t=new Map,this.u=new Map,this.z(),this.when(2).then(()=>this.C())}z(){this.j=!!this.w.getItem(It.b),this.j&&this.w.removeItem(It.b)}C(){const p=()=>{this.i||(this.L("Lifecycle#app.on(before-quit)"),this.i=!0,this.L("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),P.isMacintosh&&this.n===0&&this.D(1))};E.app.addListener("before-quit",p);const k=()=>{this.L("Lifecycle#app.on(window-all-closed)"),(this.i||!P.isMacintosh)&&E.app.quit()};E.app.addListener("window-all-closed",k),E.app.once("will-quit",I=>{this.L("Lifecycle#app.on(will-quit)"),I.preventDefault(),this.D(1).finally(()=>{this.H(!1),E.app.removeListener("before-quit",p),E.app.removeListener("window-all-closed",k),E.app.quit()})})}D(p){if(this.s)return this.s;this.L("Lifecycle#onWillShutdown.fire()");const k=[];return this.f.fire({reason:p,join(I){k.push(I)}}),this.s=(async()=>{try{await C.Promises.settled(k)}catch(I){this.v.error(I)}try{await this.w.close()}catch(I){this.v.error(I)}})(),this.s}set phase(p){if(p<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.k===p)return;this.L(`lifecycle (main): phase changed (value: ${p})`),this.k=p;const k=this.u.get(this.k);k&&(k.open(),this.u.delete(this.k))}async when(p){if(p<=this.k)return;let k=this.u.get(p);k||(k=new C.Barrier,this.u.set(p,k)),await k.wait()}registerWindow(p){const k=new A.DisposableStore;this.n++,k.add(p.onWillLoad(m=>this.g.fire({window:p,workspace:m.workspace,reason:m.reason})));const I=(0,w.assertIsDefined)(p.win);I.on("close",m=>{const i=p.id;if(this.l.has(i)){this.l.delete(i);return}this.L(`Lifecycle#window.on('close') - window ID ${p.id}`),m.preventDefault(),this.unload(p,1).then(r=>{if(r){this.l.delete(i);return}this.l.add(i),this.L(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${i}`),this.h.fire(p),p.close()})}),I.on("closed",()=>{this.L(`Lifecycle#window.on('closed') - window ID ${p.id}`),this.n--,k.dispose(),this.n===0&&(!P.isMacintosh||this.i)&&this.D(1)})}async reload(p,k){await this.unload(p,3)||p.reload(k)}unload(p,k){const I=this.t.get(p.id);if(I)return I;const m=this.F(p,k).finally(()=>{this.t.delete(p.id)});return this.t.set(p.id,m),m}async F(p,k){if(!p.isReady)return!1;this.L(`Lifecycle#unload() - window ID ${p.id}`);const I=this.i?2:k,m=await this.I(p,I);return m?(this.L(`Lifecycle#unload() - veto in renderer (window ID ${p.id})`),this.G(m)):(await this.J(p,I),!1)}G(p){return p?(this.H(!0),this.i=!1,!0):!1}H(p){this.r&&(this.r(p),this.r=void 0,this.p=void 0)}I(p,k){return new Promise(I=>{const m=this.m++,i=`vscode:ok${m}`,r=`vscode:cancel${m}`;t.validatedIpcMain.once(i,()=>{I(!1)}),t.validatedIpcMain.once(r,()=>{I(!0)}),p.send("vscode:onBeforeUnload",{okChannel:i,cancelChannel:r,reason:k})})}J(p,k){return new Promise(I=>{const i=`vscode:reply${this.m++}`;t.validatedIpcMain.once(i,()=>I()),p.send("vscode:onWillUnload",{replyChannel:i,reason:k})})}quit(p){return this.L(`Lifecycle#quit() - begin (willRestart: ${p})`),this.p?(this.L("Lifecycle#quit() - returning pending quit promise"),this.p):(p&&this.w.setItem(It.b,!0),this.p=new Promise(k=>{this.r=k,this.L("Lifecycle#quit() - calling app.quit()"),E.app.quit()}),this.p)}L(p){this.y.args["enable-smoke-test-driver"]?this.v.info(p):this.v.trace(p)}async relaunch(p){this.L("Lifecycle#relaunch()");const k=process.argv.slice(1);if(p?.addArgs&&k.push(...p.addArgs),p?.removeArgs)for(const i of p.removeArgs){const r=k.indexOf(i);r>=0&&k.splice(r,1)}const I=()=>{try{if(P.isWindows){const i=(0,g.cwd)();i!==process.cwd()&&process.chdir(i)}}catch(i){this.v.error(i)}this.L("Lifecycle#relaunch() - calling app.relaunch()"),E.app.relaunch({args:k})};E.app.once("quit",I),await this.quit(!0)&&E.app.removeListener("quit",I)}async kill(p){this.L("Lifecycle#kill()"),await this.D(2),await Promise.race([(0,C.timeout)(1e3),(async()=>{for(const k of E.BrowserWindow.getAllWindows())if(k&&!k.isDestroyed()){let I;k.webContents&&!k.webContents.isDestroyed()?I=new Promise(m=>k.once("closed",m)):I=Promise.resolve(),k.destroy(),await I}})()]),E.app.exit(p)}};h.b="lifecycle.quitAndRestart",h=pe([ee(0,S.ILogService),ee(1,y.IStateMainService),ee(2,u.IEnvironmentMainService)],h),e.LifecycleMainService=h}),define(ie[229],re([0,1,4,3,2,5,21]),function(H,e,E,t,C,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let P=class extends C.Disposable{constructor(b){super(),this.a=this.B(new t.Emitter),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,b.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const b=await new Promise((S,y)=>{H(["native-keymap"],S,y)});this.c=g(b),E.isCI||b.onDidChangeKeyboardLayout(()=>{this.c=g(b),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};P=pe([ee(0,A.ILifecycleMainService)],P),e.KeyboardLayoutMainService=P;function g(w){const b=w.getKeyMap(),S=w.getCurrentKeyboardLayout();return{keyboardMapping:b,keyboardLayoutInfo:S}}}),define(ie[230],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,E.createDecorator)("stateService")}),define(ie[231],re([0,1,8,17,11,35,16,6]),function(H,e,E,t,C,R,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class g{constructor(S,y,u){this.f=S,this.g=y,this.h=u,this.a=Object.create(null),this.b="",this.c=new E.ThrottledDelayer(100),this.d=void 0,this.e=void 0}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(S){S.fileOperationResult!==1&&this.g.error(S)}}getItem(S,y){const u=this.a[S];return(0,C.isUndefinedOrNull)(u)?y:u}setItem(S,y){this.setItems([{key:S,data:y}])}setItems(S){let y=!1;for(const{key:u,data:d}of S)this.a[u]!==d&&((0,C.isUndefinedOrNull)(d)?(0,C.isUndefined)(this.a[u])||(this.a[u]=void 0,y=!0):(this.a[u]=d,y=!0));y&&this.j()}removeItem(S){(0,C.isUndefined)(this.a[S])||(this.a[S]=void 0,this.j())}async j(){if(!this.e)return this.c.trigger(()=>this.k())}async k(){if(!this.d)return;await this.d;const S=JSON.stringify(this.a,null,4);if(S!==this.b)try{await this.h.writeFile(this.f,t.VSBuffer.fromString(S)),this.b=S}catch(y){this.g.error(y)}}async close(){return this.e||(this.e=this.c.trigger(()=>this.k(),0)),this.e}}e.FileStorage=g;let w=class{constructor(S,y,u){this.a=new g(S.stateResource,y,u)}async init(){await this.a.init()}getItem(S,y){return this.a.getItem(S,y)}};w=pe([ee(0,R.IEnvironmentService),ee(1,P.ILogService),ee(2,A.IFileService)],w),e.StateService=w}),define(ie[232],re([0,1,231]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class t extends E.StateService{setItem(R,A){this.a.setItem(R,A)}setItems(R){this.a.setItems(R)}removeItem(R){this.a.removeItem(R)}close(){return this.a.close()}}e.StateMainService=t}),define(ie[90],re([0,1,4,33,7,29]),function(H,e,E,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(w){if(E.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}async function P(w,b,S,y,u,d,v,h,l,p){const k=Object.create(null);k["common.machineId"]=v,k.sessionID=(0,R.generateUuid)()+Date.now(),k.commitHash=u,k.version=d,k["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),k["common.platform"]=(0,E.PlatformToString)(E.platform),k["common.nodePlatform"]=t.platform,k["common.nodeArch"]=y,k["common.product"]=p||"desktop",h&&(k["common.msftInternal"]=h);let I=0;const m=Date.now();Object.defineProperties(k,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-m,enumerable:!0},"common.sequence":{get:()=>I++,enumerable:!0}}),E.isLinuxSnap&&(k["common.snap"]="true");const i=A(S);i&&(k["common.platformDetail"]=i);try{const r=await w.readFile(C.URI.file(l));k["common.source"]=r.value.toString().slice(0,30)}catch{}return k}e.resolveCommonProperties=P;function g(w){const b=t.env.USERDNSDOMAIN;if(!b)return!1;const S=b.toLowerCase();return w.some(y=>S===y)}e.verifyMicrosoftInternalDomain=g}),define(ie[31],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,E.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,E.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var C;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(C=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ie[233],re([0,1,25,8,43,14,9,4,7,82,23,101,85,16,19,31]),function(H,e,E,t,C,R,A,P,g,w,b,S,y,u,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const h=new Map;async function l(i,r){const n=`${i}::${r.join(":")}`,a=h.get(n);if(a)return a;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,s=new Map,f=2e4;function M(T,U,K,V){const G=U.substring(T.length+1);return t.Promises.withAsyncBody(async _=>{let se;try{se=await b.Promises.readdir(U,{withFileTypes:!0})}catch{_();return}if(V.count>=f){V.count+=se.length,V.maxReached=!0,_();return}let ce=se.length;if(ce===0){_();return}let X=se;V.count+se.length>f&&(V.maxReached=!0,ce=f-V.count,X=se.slice(0,ce)),V.count+=se.length;for(const ue of X)if(ue.isDirectory()){if(K.includes(ue.name)||await M(T,(0,A.join)(U,ue.name),K,V),--ce===0){_();return}}else{const z=ue.name.lastIndexOf(".");if(z>=0){const N=ue.name.substring(z+1);N&&c.set(N,(c.get(N)??0)+1)}for(const N of o)N.relativePathPattern?.test(G)!==!1&&N.filePattern.test(ue.name)&&s.set(N.tag,(s.get(N.tag)??0)+1);if(--ce===0){_();return}}})}const L=t.Promises.withAsyncBody(async T=>{const U={count:0,maxReached:!1};await M(i,i,r,U);const K=await I(i);T({configFiles:p(s),fileTypes:p(c),fileCount:U.count,maxFilesReached:U.maxReached,launchConfigFiles:K})});return h.set(n,L),L}e.collectWorkspaceStats=l;function p(i){return Array.from(i.entries(),([r,n])=>({name:r,count:n})).sort((r,n)=>n.count-r.count)}function k(){const i={os:`${E.type()} ${E.arch()} ${E.release()}`,memory:`${(E.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(w.virtualMachineHint.value()*100)}%`},r=E.cpus();return r&&r.length>0&&(i.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),i}e.getMachineInfo=k;async function I(i){try{const r=new Map,n=(0,A.join)(i,".vscode","launch.json"),a=await b.Promises.readFile(n),o=[],c=(0,C.parse)(a.toString(),o);if(o.length)return console.log(`Unable to parse ${n}`),[];if((0,C.getNodeType)(c)==="object"&&c.configurations)for(const s of c.configurations){const f=s.type;f&&(r.has(f)?r.set(f,r.get(f)+1):r.set(f,1))}return p(r)}catch{return[]}}e.collectLaunchConfigs=I;let m=class{constructor(r,n){this.c=r,this.d=n}f(r){const n=[];return n.push(`OS Version:       ${r.os}`),n.push(`CPUs:             ${r.cpus}`),n.push(`Memory (System):  ${r.memory}`),n.push(`VM:               ${r.vmHint}`),n.join(`
`)}g(r){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${E.type()} ${E.arch()} ${E.release()}`);const a=E.cpus();return a&&a.length>0&&n.push(`CPUs:             ${a[0].model} (${a.length} x ${a[0].speed})`),n.push(`Memory (System):  ${(E.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||n.push(`Load (avg):       ${E.loadavg().map(o=>Math.round(o)).join(", ")}`),n.push(`VM:               ${Math.round(w.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${r.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(r,n){return Promise.all([(0,S.listProcesses)(r.mainPID),this.k(r)]).then(async a=>{let[o,c]=a,s=this.m(r,o);return n.forEach(f=>{if((0,y.isRemoteDiagnosticError)(f))s+=`
${f.errorMessage}`,c+=`
${f.errorMessage}`;else if(s+=`

Remote: ${f.hostName}`,f.processes&&(s+=`
${this.m(r,f.processes)}`),f.workspaceMetadata){c+=`
|  Remote: ${f.hostName}`;for(const M of Object.keys(f.workspaceMetadata)){const L=f.workspaceMetadata[M];let T=`${L.fileCount} files`;L.maxFilesReached&&(T=`more than ${T}`),c+=`|    Folder (${M}): ${T}`,c+=this.h(L)}}}),{processInfo:s,workspaceInfo:c}})}async getSystemInfo(r,n){const{memory:a,vmHint:o,os:c,cpus:s}=k(),f={os:c,memory:a,cpus:s,vmHint:o,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:n};return P.isWindows||(f.load=`${E.loadavg().map(M=>Math.round(M)).join(", ")}`),P.isLinux&&(f.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(f)}async getDiagnostics(r,n){const a=[];return(0,S.listProcesses)(r.mainPID).then(async o=>(a.push(""),a.push(this.g(r)),a.push(""),a.push(this.m(r,o)),r.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(a.push(""),a.push("Workspace Stats: "),a.push(await this.k(r))),n.forEach(c=>{if((0,y.isRemoteDiagnosticError)(c))a.push(`
${c.errorMessage}`);else if(a.push(`

`),a.push(`Remote:           ${c.hostName}`),a.push(this.f(c.machineInfo)),c.processes&&a.push(this.m(r,c.processes)),c.workspaceMetadata)for(const s of Object.keys(c.workspaceMetadata)){const f=c.workspaceMetadata[s];let M=`${f.fileCount} files`;f.maxFilesReached&&(M=`more than ${M}`),a.push(`Folder (${s}): ${M}`),a.push(this.h(f))}}),a.push(""),a.push(""),a.join(`
`)))}h(r){const n=[];let o=0;const c=(L,T)=>{const U=` ${L}(${T})`;o+U.length>60?(n.push(s),s="|                 ",o=s.length):o+=U.length,s+=U};let s="|      File types:";const f=10,M=r.fileTypes.length>f?f:r.fileTypes.length;for(let L=0;L<M;L++){const T=r.fileTypes[L];c(T.name,T.count)}if(n.push(s),r.configFiles.length>=0&&(s="|      Conf files:",o=0,r.configFiles.forEach(L=>{c(L.name,L.count)}),n.push(s)),r.launchConfigFiles.length>0){let L="|      Launch Configs:";r.launchConfigFiles.forEach(T=>{L+=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`}),n.push(L)}return n.join(`
`)}j(r){const n=Math.max(...Object.keys(r).map(a=>a.length));return Object.keys(r).map(a=>`${a}:  ${" ".repeat(n-a.length)}  ${r[a]}`).join(`
                  `)}k(r){const n=[],a=[];return r.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(n.push(`|  Window (${o.title})`),o.folderURIs.forEach(c=>{const s=g.URI.revive(c);if(s.scheme===R.Schemas.file){const f=s.fsPath;a.push(l(f,["node_modules",".git"]).then(M=>{let L=`${M.fileCount} files`;M.maxFilesReached&&(L=`more than ${L}`),n.push(`|    Folder (${(0,A.basename)(f)}): ${L}`),n.push(this.h(M))}).catch(M=>{n.push(`|      Error: Unable to collect workspace stats for folder ${f} (${M.toString()})`)}))}else n.push(`|    Folder (${s.toString()}): Workspace stats not available.`)}))}),Promise.all(a).then(o=>n.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}m(r,n){const a=new Map;r.windows.forEach(c=>a.set(c.pid,c.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),n&&this.n(r.mainPID,a,o,n,0),o.join(`
`)}n(r,n,a,o,c){const s=c===0;let f;s?f=o.pid===r?`${this.d.applicationName} main`:"remote agent":(f=`${"  ".repeat(c)} ${o.name}`,o.name==="window"&&(f=`${f} (${n.get(o.pid)})`));const M=process.platform==="win32"?o.mem:E.totalmem()*(o.mem/100);a.push(`${o.load.toFixed(0).padStart(5," ")}	${(M/u.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${f}`),Array.isArray(o.children)&&o.children.forEach(L=>this.n(r,n,a,L,c+1))}async getWorkspaceFileExtensions(r){const n=new Set;for(const{uri:a}of r.folders){const o=g.URI.revive(a);if(o.scheme!==R.Schemas.file)continue;const c=o.fsPath;try{(await l(c,["node_modules",".git"])).fileTypes.forEach(f=>n.add(f.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(r){for(const{uri:n}of r.folders){const a=g.URI.revive(n);if(a.scheme!==R.Schemas.file)continue;const o=a.fsPath;try{const c=await l(o,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),c.fileTypes.forEach(s=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:s.name,count:s.count})}),c.launchConfigFiles.forEach(s=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:s.name,count:s.count})}),c.configFiles.forEach(s=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:s.name,count:s.count})})}catch{}}}};m=pe([ee(0,v.ITelemetryService),ee(1,d.IProductService)],m),e.DiagnosticsService=m}),define(ie[234],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class E{constructor(R){this.b=R}listen(R,A){throw new Error(`Event not found: ${A}`)}call(R,A,{eventName:P,data:g}){return this.b.forEach(w=>w.log(P,g)),Promise.resolve(null)}}e.TelemetryAppenderChannel=E;class t{constructor(R){this.b=R}log(R,A){return this.b.call("log",{eventName:R,data:A}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(ie[51],re([0,1,44,11,18,55,90,31]),function(H,e,E,t,C,R,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class g{constructor(c){this.value=c}}e.TrustedTelemetryValue=g;class w{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(c,s){return Promise.resolve(void 0)}publicLog2(c,s){return this.publicLog(c,s)}publicLogError(c,s){return Promise.resolve(void 0)}publicLogError2(c,s){return this.publicLogError(c,s)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=w,e.NullTelemetryService=new w;class b{async publicLog(c,s,f){}async publicLogError(c,s,f){}}e.NullEndpointTelemetryService=b,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function S(o,c){return c.onDidChangeConfiguration(s=>{s.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,C.ConfigurationTargetToString)(s.source),configurationKeys:k(s.sourceConfig)})})}e.configurationTelemetry=S;function y(o,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!o.enableTelemetry||c.extensionTestsLocationURI)}e.supportsTelemetry=y;function u(o,c){return!(c.isBuilt||c.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.isLoggingOnly=u;function d(o){const c=o.getValue(P.TELEMETRY_SETTING_ID),s=o.getValue("telemetry.enableCrashReporter");if(o.getValue(P.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=d;function v(o){const c={},s={},f={};p(o,f);for(let M in f){M=M.length>150?M.substr(M.length-149):M;const L=f[M];typeof L=="number"?s[M]=L:typeof L=="boolean"?s[M]=L?1:0:typeof L=="string"?(L.length>8192&&console.warn(`Telemetry property: ${M} has been trimmed to 8192, the original length is ${L.length}`),c[M]=L.substring(0,8191)):typeof L<"u"&&L!==null&&(c[M]=L)}return{properties:c,measurements:s}}e.validateTelemetryData=v;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function l(o){if(!o)return"none";const c=(0,R.getRemoteName)(o);return h.has(c)?c:"other"}e.cleanRemoteAuthority=l;function p(o,c,s=0,f){if(!!o)for(const M of Object.getOwnPropertyNames(o)){const L=o[M],T=f?f+M:M;Array.isArray(L)?c[T]=(0,E.safeStringify)(L):L instanceof Date?c[T]=L.toISOString():(0,t.isObject)(L)?s<2?p(L,c,s+1,T+"."):c[T]=(0,E.safeStringify)(L):c[T]=L}}function k(o){if(!o)return[];const c=[];return I(c,"",o),c}function I(o,c,s){s&&typeof s=="object"&&!Array.isArray(s)?Object.keys(s).forEach(f=>I(o,c?`${c}.${f}`:f,s[f])):o.push(c)}function m(o,c){const s=o.msftInternalDomains||[],f=c.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(s)||f}e.isInternalTelemetry=m;function i(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.getPiiPathsFromEnvironment=i;function r(o,c){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let s=o;const f=[];for(const U of c)for(;;){const K=U.exec(o);if(!K)break;f.push([K.index,U.lastIndex])}const M=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,L=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let T=0;for(s="";;){const U=L.exec(o);if(!U)break;const K=f.some(([V,G])=>U.index<G&&V<L.lastIndex);!M.test(U[0])&&!K&&(s+=o.substring(T,U.index)+"<REDACTED: user-file-path>",T=L.lastIndex)}return T<o.length&&(s+=o.substr(T)),s}function n(o){if(!o)return o;const c=o.toLowerCase(),s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of s)if(f.regex.test(c))return`<REDACTED: ${f.label}>`;return o}function a(o,c){return(0,E.cloneAndChange)(o,s=>{if(s instanceof g)return s.value;if(typeof s=="string"){let f=s.replaceAll("%20"," ");f=r(f,c);for(const M of c)f=f.replace(M,"");return f=n(f),f}})}e.cleanData=a}),define(ie[111],re([0,1,26,193,88,4,7,15,33,51]),function(H,e,E,t,C,R,A,P,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function b(n,a){return n.uuid&&a.uuid?n.uuid===a.uuid:n.id===a.id?!0:(0,E.compareIgnoreCase)(n.id,a.id)===0}e.areSameExtensions=b;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(a){const o=a.manifest?a.manifest.version:a.version,c=a.manifest?a.targetPlatform:a.properties.targetPlatform;return new y(a.identifier,o,c)}static parse(a){const o=S.exec(a);return o&&o[1]&&o[2]?new y({id:o[1]},o[2],o[4]||void 0):null}constructor(a,o,c="undefined"){this.version=o,this.targetPlatform=c,this.id=a.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(a){return a instanceof y?b(this,a)&&this.version===a.version&&this.targetPlatform===a.targetPlatform:!1}}e.ExtensionKey=y;const u=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(n){const a=u.exec(n);return a&&a[1]?[h(a[1]),a[2]]:[h(n),void 0]}e.getIdAndVersion=d;function v(n,a){return`${n}.${a}`}e.getExtensionId=v;function h(n){return n.toLocaleLowerCase()}e.adoptToGalleryExtensionId=h;function l(n,a){return h(v(n,a))}e.getGalleryExtensionId=l;function p(n,a){const o=[],c=s=>{for(const f of o)if(f.some(M=>b(a(M),a(s))))return f;return null};for(const s of n){const f=c(s);f?f.push(s):o.push([s])}return o}e.groupByExtension=p;function k(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=k;function I(n){return{id:new w.TrustedTelemetryValue(n.identifier.id),name:new w.TrustedTelemetryValue(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new C.ExtensionIdentifier("pprice.better-merge");function m(n,a){const o=[],c=a.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const s=c.shift();if(s&&o.every(f=>!b(f.identifier,{id:s}))){const f=n.filter(M=>b(M.identifier,{id:s}));f.length===1&&(o.push(f[0]),c.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.getExtensionDependencies=m;async function i(n,a){if(!R.isLinux)return!1;let o;try{o=(await n.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await n.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(s){a.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(s))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=i;async function r(n,a){const o=await i(n,a),c=(0,t.getTargetPlatform)(o?"alpine":R.platform,g.arch);return a.debug("ComputeTargetPlatform:",c),c}e.computeTargetPlatform=r}),define(ie[235],re([0,1,190,51]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function C(R,A,P,g,w,b,S){const y={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${A.nameShort})`};if((0,t.supportsTelemetry)(A,P)&&(0,t.getTelemetryLevel)(g)===3){const u=await(0,E.getServiceMachineId)(P,w,b),{machineId:d}=await S.getTelemetryInfo();y["X-Market-User-Id"]=u,y["VSCode-SessionId"]=d||u}return y}e.resolveMarketplaceHeaders=C}),define(ie[236],re([0,1,15,44,51]),function(H,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const R="https://mobile.events.data.microsoft.com/OneCollector/1.0",A="https://mobile.events.data.microsoft.com/ping";async function P(w,b,S){const y=await new Promise((l,p)=>{H(["@microsoft/1ds-core-js"],l,p)}),u=await new Promise((l,p)=>{H(["@microsoft/1ds-post-js"],l,p)}),d=new y.AppInsightsCore,v=new u.PostChannel,h={instrumentationKey:w,endpointUrl:R,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[v]]};if(S){h.extensionConfig={};const l={alwaysUseXhrOverride:!0,httpXHROverride:S};h.extensionConfig[v.identifier]=l}return d.initialize(h,[]),d.addTelemetryInitializer(l=>{b&&(l.ext=l.ext??{},l.ext.utc=l.ext.utc??{},l.ext.utc.flags=8462029)}),d}class g{constructor(b,S,y,u,d){this.e=b,this.f=S,this.g=y,this.h=d,this.c=R,this.d=A,this.g||(this.g={}),typeof u=="function"?this.a=u():this.a=u,this.b=null}i(b){if(!!this.a){if(typeof this.a!="string"){b(this.a);return}this.b||(this.b=P(this.a,this.e,this.h)),this.b.then(S=>{b(S)},S=>{(0,E.onUnexpectedError)(S),console.error(S)})}}log(b,S){if(!this.a)return;S=(0,t.mixin)(S,this.g),S=(0,C.validateTelemetryData)(S);const y=this.f+"/"+b;try{this.i(u=>{u.pluginVersionString=S?.properties.version??"Unknown",u.track({name:y,baseData:{name:y,properties:S?.properties,measurements:S?.measurements}})})}catch{}}flush(){return this.a?new Promise(b=>{this.i(S=>{S.unload(!0,()=>{this.a=void 0,b(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=g}),define(ie[112],re([0,1,2,44,4,26,169,18,65,63,19,48,31,51]),function(H,e,E,t,C,R,A,P,g,w,b,S,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let d=class{constructor(l,p,k){this.k=p,this.l=k,this.d={},this.i=new E.DisposableStore,this.j=[],this.b=l.appenders,this.c=l.commonProperties||Promise.resolve({}),this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const I of this.f)this.j.push(new RegExp((0,R.escapeRegExpCharacters)(I),"gi")),I.indexOf("\\")>=0&&this.j.push(new RegExp((0,R.escapeRegExpCharacters)(I.replace(/\\/g,"/")),"gi"));this.m(),this.k.onDidChangeConfiguration(this.m,this,this.i)}setExperimentProperty(l,p){this.d[l]=p}m(){let l=(0,u.getTelemetryLevel)(this.k);const p=this.l.enabledTelemetryLevels;if(p){this.h=this.sendErrorTelemetry?p.error:!1;const k=p.usage?3:p.error?2:0;l=Math.min(l,k)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const l=await this.c,p=l.sessionID,k=l["common.machineId"],I=l["common.firstSessionDate"],m=l["common.msftInternal"];return{sessionId:p,machineId:k,firstSessionDate:I,msftInternal:m}}dispose(){this.i.dispose()}n(l,p,k){return this.g<p?Promise.resolve(void 0):this.c.then(I=>{k=(0,t.mixin)(k,this.d),k=(0,u.cleanData)(k,this.j),k=(0,t.mixin)(k,I),this.b.forEach(m=>m.log(l,k))},I=>{console.error(I)})}publicLog(l,p){return this.n(l,3,p)}publicLog2(l,p){return this.publicLog(l,p)}publicLogError(l,p){return this.h?this.n(l,2,p):Promise.resolve(void 0)}publicLogError2(l,p){return this.publicLogError(l,p)}};d.IDLE_START_EVENT_NAME="UserIdleStart",d.IDLE_STOP_EVENT_NAME="UserIdleStop",d=pe([ee(1,P.IConfigurationService),ee(2,b.IProductService)],d),e.TelemetryService=d;function v(){const h=(0,A.localize)(0,null,w.default.nameLong),l=w.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",w.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=C.isWeb?"":(0,A.localize)(3,null),k=(0,A.localize)(4,null),I=(0,A.localize)(5,null),m=(0,A.localize)(6,null),i=(0,A.localize)(7,null),r=`
|       | ${k} | ${I} | ${m} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,A.localize)(8,null);return`
${h} ${l} ${p}

&nbsp;

${i}
${r}

&nbsp;

${n}
`}S.Registry.as(g.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(9,null),properties:{[y.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:v(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.Registry.as(g.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[y.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:w.default.privacyStatementUrl?(0,A.localize)(16,null,w.default.nameLong,w.default.privacyStatementUrl):(0,A.localize)(15,null,w.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${y.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ie[237],re([0,1,283,236]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class C extends t.AbstractOneDataSystemAppender{constructor(A,P,g,w){const b={sendPOST:(S,y)=>{const u={method:"POST",headers:{...S.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(S.data)}};try{const d=E.request(S.urlString,u,v=>{v.on("data",function(h){y(v.statusCode??200,v.headers,h.toString())}),v.on("error",function(h){y(0,{})})});d.write(S.data),d.end()}catch{y(0,{})}}};super(A,P,g,w,b)}}e.OneDataSystemAppender=C}),define(ie[238],re([0,1,4,82,31]),function(H,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function R(A){let P=A.getItem(C.machineIdKey);return(typeof P!="string"||E.isMacintosh&&P==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(P=await(0,t.getMachineId)()),P}e.resolveMachineId=R}),define(ie[113],re([0,1,31,238]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function C(R){const A=await(0,t.resolveMachineId)(R);return R.setItem(E.machineIdKey,A),A}e.resolveMachineId=C}),define(ie[239],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var E;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST_DARK="hcDark",R.HIGH_CONTRAST_LIGHT="hcLight"})(E=e.ColorScheme||(e.ColorScheme={}));function t(R){return R===E.HIGH_CONTRAST_DARK||R===E.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function C(R){return R===E.DARK||R===E.HIGH_CONTRAST_DARK}e.isDark=C}),define(ie[240],re([0,1,120,3,2,5,48,239]),function(H,e,E,t,C,R,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var g;(function(h){function l(p){return p&&typeof p=="object"&&typeof p.id=="string"}h.isThemeColor=l})(g=e.ThemeColor||(e.ThemeColor={}));function w(h){return{id:h}}e.themeColorFromId=w;var b;(function(h){function l(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||g.isThemeColor(a.color))}h.isThemeIcon=l;const p=new RegExp(`^\\$\\((${E.CSSIcon.iconNameExpression}(?:${E.CSSIcon.iconModifierExpression})?)\\)$`);function k(a){const o=p.exec(a);if(!o)return;const[,c]=o;return{id:c}}h.fromString=k;function I(a){return{id:a}}h.fromId=I;function m(a,o){let c=a.id;const s=c.lastIndexOf("~");return s!==-1&&(c=c.substring(0,s)),o&&(c=`${c}~${o}`),{id:c}}h.modify=m;function i(a){const o=a.id.lastIndexOf("~");if(o!==-1)return a.id.substring(o+1)}h.getModifier=i;function r(a,o){return a.id===o.id&&a.color?.id===o.color?.id}h.isEqual=r;function n(a,o){return{id:a.id,color:o?w(o):void 0}}h.asThemeIcon=n,h.asClassNameArray=E.CSSIcon.asClassNameArray,h.asClassName=E.CSSIcon.asClassName,h.asCSSSelector=E.CSSIcon.asCSSSelector})(b=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=E.Codicon.file,e.FolderThemeIcon=E.Codicon.folder;function S(h){switch(h){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case P.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=S,e.Extensions={ThemingContribution:"base.contributions.theming"};class y{constructor(){this.a=[],this.a=[],this.b=new t.Emitter}onColorThemeChange(l){return this.a.push(l),this.b.fire(l),(0,C.toDisposable)(()=>{const p=this.a.indexOf(l);this.a.splice(p,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const u=new y;A.Registry.add(e.Extensions.ThemingContribution,u);function d(h){return u.onColorThemeChange(h)}e.registerThemingParticipant=d;class v extends C.Disposable{constructor(l){super(),this.k=l,this.h=l.getColorTheme(),this.B(this.k.onDidColorThemeChange(p=>this.n(p)))}n(l){this.h=l,this.updateStyles()}updateStyles(){}w(l,p){let k=this.h.getColor(l);return k&&p&&(k=p(k,this.h)),k?k.toString():null}}e.Themable=v}),define(ie[66],re([0,1,13,3,2,4,18,5,36]),function(H,e,E,t,C,R,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const w="#FFFFFF",b="#1E1E1E",S="#000000",y="#FFFFFF",u="theme",d="themeBackground",v="windowSplash";e.IThemeMainService=(0,P.createDecorator)("themeMainService");let h=class extends C.Disposable{constructor(p,k){super(),this.b=p,this.c=k,this.a=this.B(new t.Emitter),this.onDidChangeColorScheme=this.a.event,E.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(R.isWindows){if(E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.isMacintosh){if(E.nativeTheme.shouldUseInvertedColorScheme||E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.isLinux&&E.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const p=this.getColorScheme();if(p.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return p.dark?S:y;let k=this.b.getItem(d,null);if(!k)switch(this.b.getItem(u,"vs-dark").split(" ")[0]){case"vs":k=w;break;case"hc-black":k=S;break;case"hc-light":k=y;break;default:k=b}return R.isMacintosh&&k.toUpperCase()===b&&(k="#171717"),k}saveWindowSplash(p,k){this.b.setItems([{key:u,data:k.baseTheme},{key:d,data:k.colorInfo.background},{key:v,data:k}]),typeof p=="number"&&this.f(p,k)}f(p,k){for(const I of E.BrowserWindow.getAllWindows())if(I.id===p){I.setBackgroundColor(k.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(v)}};h=pe([ee(0,g.IStateMainService),ee(1,A.IConfigurationService)],h),e.ThemeMainService=h}),define(ie[114],re([0,1,3,18,5,6]),function(H,e,E,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,C.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,C.createDecorator)("sharedTunnelsService");var A;(function(v){v.Http="http",v.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(v){v.ConstantPrivate="constantPrivate",v.Private="private",v.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var g;(function(v){v[v.Notify=1]="Notify",v[v.OpenBrowser=2]="OpenBrowser",v[v.OpenPreview=3]="OpenPreview",v[v.Silent=4]="Silent",v[v.Ignore=5]="Ignore",v[v.OpenBrowserOnce=6]="OpenBrowserOnce"})(g=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function w(v){if(v.scheme!=="http"&&v.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(v.authority);if(!!h)return{address:h[1],port:+h[2]}}e.extractLocalHostUriMetaDataForPortMapping=w,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(v){return e.LOCALHOST_ADDRESSES.indexOf(v)>=0}e.isLocalhost=b,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function S(v){return e.ALL_INTERFACES_ADDRESSES.indexOf(v)>=0}e.isAllInterfaces=S;function y(v,h,l,p){if(l===1)return!1;if(l===2&&S(h)){const k=/(\d+)\.(\d+)\.(\d+)/g.exec(p);if(k?.length===4&&parseInt(k[1])>=18)return!1}return v<1024}e.isPortPrivileged=y;class u{constructor(h,l,p){this.remoteAddress=h,this.localAddress=l,this.b=p,this.a=new E.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=u;let d=class{constructor(h,l){this.i=h,this.j=l,this.a=new E.Emitter,this.onTunnelOpened=this.a.event,this.b=new E.Emitter,this.onTunnelClosed=this.b.event,this.c=new E.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const h=this.j.getValue("remote.localPortHost");return!h||h==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(h){return this.e=h,h?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this.f=h.elevation,this.g=h.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const h=[],l=Array.from(this.d.values());for(const p of l){const k=Array.from(p.values());for(const I of k){const m=await I.value;m&&h.push(m)}}return h}async dispose(){for(const h of this.d.values()){for(const{value:l}of h.values())await l.then(p=>p?.dispose());h.clear()}this.d.clear()}setEnvironmentTunnel(h,l,p,k,I){this.o(h,l,Promise.resolve({tunnelRemoteHost:h,tunnelRemotePort:l,localAddress:p,privacy:k,protocol:I,dispose:()=>Promise.resolve()}))}async getExistingTunnel(h,l){(S(h)||b(h))&&(h=e.LOCALHOST_ADDRESSES[0]);const p=this.q(h,l);if(p)return++p.refcount,p.value}openTunnel(h,l,p,k,I=!1,m,i){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${p} on local port ${k}.`),!h)return;if(l||(l="localhost"),this.e&&this.h.has(p)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.r(h,l,p,k,I,m,i);return r?r.then(n=>{if(!n){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(l,p);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.m(n);return(n.tunnelRemoteHost!==l||n.tunnelRemotePort!==p)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(a),a}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}m(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const l=this.d.get(h.tunnelRemoteHost);if(l){const p=l.get(h.tunnelRemotePort);p&&(p.refcount--,await this.n(h.tunnelRemoteHost,h.tunnelRemotePort,p))}}}}async n(h,l,p){if(p.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${l}.`);const k=p.value.then(async I=>{I&&(await I.dispose(!0),this.b.fire({host:I.tunnelRemoteHost,port:I.tunnelRemotePort}))});return this.d.has(h)&&this.d.get(h).delete(l),k}}async closeTunnel(h,l){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${l} `);const p=this.d.get(h);if(p&&p.has(l)){const k=p.get(l);k.refcount=0,await this.n(h,l,k)}}o(h,l,p){this.d.has(h)||this.d.set(h,new Map),this.d.get(h).set(l,{refcount:1,value:p})}async p(h,l){const p=this.d.get(h);p&&(await p.get(l)||p.delete(l),p.size===0&&this.d.delete(h))}q(h,l){const p=[h];b(h)?(p.push(...e.LOCALHOST_ADDRESSES),p.push(...e.ALL_INTERFACES_ADDRESSES)):S(h)&&p.push(...e.ALL_INTERFACES_ADDRESSES);const k=p.map(I=>this.d.get(I));for(const I of k){const m=I?.get(l);if(m)return m}}canTunnel(h){return!!w(h)}s(h,l,p,k,I,m,i){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${p} on local port ${k}.`);const r=p;this.h.add(r);const n=k===void 0?p:k,a={elevationRequired:I?this.isPortPrivileged(n):!1},o={remoteAddress:{host:l,port:p},localAddressPort:k,privacy:m,public:m?m!==P.Private:void 0,protocol:i},c=h.forwardPort(o,a);return c?(this.o(l,p,c),c.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(r)})):this.h.delete(r),c}};d=pe([ee(0,R.ILogService),ee(1,t.IConfigurationService)],d),e.AbstractTunnelService=d}),define(ie[241],re([0,1,79,25,97,223,8,2,18,6,19,222,114,89,4]),function(H,e,E,t,C,R,A,P,g,w,b,S,y,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function v(I,m,i,r,n){let a;for(let o=3;o&&(a?.dispose(),a=await new h(I,m,i,r,n).waitForReady(),!(n&&C.BROWSER_RESTRICTED_PORTS[n]||!C.BROWSER_RESTRICTED_PORTS[a.tunnelLocalPort]));o--);return a}class h extends P.Disposable{constructor(m,i,r,n,a){super(),this.j=i,this.k=a,this.privacy=y.TunnelPrivacyId.Private,this.i=new Map,this.a=m,this.b=E.createServer(),this.c=new A.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=o=>this.l(o),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=r}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(i=>{i()})}async waitForReady(){const m=this.k??this.tunnelRemotePort,i=(0,y.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let r=await(0,C.findFreePortFaster)(m,2,1e3,i),n=null;return this.b.listen(r,this.j),await this.c.wait(),n=this.b.address(),n||(r=0,this.b.listen(r,this.j),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async l(m){m.pause();const i=(0,y.isLocalhost)(this.tunnelRemoteHost)||(0,y.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,r=await(0,S.connectRemoteAgentTunnel)(this.a,i,this.tunnelRemotePort),n=r.getSocket().socket,a=r.readEntireBuffer();r.dispose(),a.byteLength>0&&m.write(a.buffer),m.on("end",()=>{m.localAddress&&this.i.delete(m.localAddress),n.end()}),m.on("close",()=>n.end()),m.on("error",()=>{m.localAddress&&this.i.delete(m.localAddress),n.destroy()}),n.on("end",()=>m.end()),n.on("close",()=>m.end()),n.on("error",()=>{m.destroy()}),m.pipe(n),n.pipe(m),m.localAddress&&this.i.set(m.localAddress,()=>{m.end(),n.end()})}}let l=class extends y.AbstractTunnelService{constructor(m,i,r,n,a){super(i,a),this.t=m,this.u=r,this.v=n}isPortPrivileged(m){return(0,y.isPortPrivileged)(m,this.k,d.OS,t.release())}r(m,i,r,n,a,o,c){const s=this.q(i,r);if(s)return++s.refcount,s.value;if(this.e)return this.s(this.e,i,r,n,a,o,c);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${i}:${r} on local port ${n}.`);const f={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:m,signService:this.u,logService:this.i,ipcLogger:null},M=v(f,this.k,i,r,n);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(i,r,M),M}}};l=pe([ee(1,w.ILogService),ee(2,u.ISignService),ee(3,b.IProductService),ee(4,g.IConfigurationService)],l),e.BaseTunnelService=l;let p=class extends l{constructor(m,i,r,n){super(R.nodeSocketFactory,m,i,r,n)}};p=pe([ee(0,w.ILogService),ee(1,u.ISignService),ee(2,b.IProductService),ee(3,g.IConfigurationService)],p),e.TunnelService=p;let k=class extends P.Disposable{constructor(m,i,r,n){super(),this.b=m,this.c=i,this.f=r,this.g=n,this.a=new Map}async openTunnel(m,i,r,n,a,o,c,s){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${r}:${n} on local port ${a}.`),!this.a.has(m)){const f=new p(this.b,this.f,this.c,this.g);this.B(f),this.a.set(m,f),f.onTunnelClosed(async()=>{(await f.tunnels).length===0&&(f.dispose(),this.a.delete(m))})}return this.a.get(m).openTunnel(i,r,n,a,o,c,s)}};k=pe([ee(0,w.ILogService),ee(1,b.IProductService),ee(2,u.ISignService),ee(3,g.IConfigurationService)],k),e.SharedTunnelsService=k}),define(ie[49],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(t=e.StateType||(e.StateType={}));var C;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap"})(C=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(R,A)=>({type:"idle",updateType:R,error:A}),CheckingForUpdates:R=>({type:"checking for updates",explicit:R}),AvailableForDownload:R=>({type:"available for download",update:R}),Downloading:R=>({type:"downloading",update:R}),Downloaded:R=>({type:"downloaded",update:R}),Updating:R=>({type:"updating",update:R}),Ready:R=>({type:"ready",update:R})},e.IUpdateService=(0,E.createDecorator)("updateService")}),define(ie[242],re([0,1,4,170,65,48]),function(H,e,E,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.Registry.as(C.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:E.isWindows&&!E.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ie[243],re([0,1,3,49]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class C{constructor(P){this.a=P}listen(P,g){switch(g){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${g}`)}call(P,g,w){switch(g){case"checkForUpdates":return this.a.checkForUpdates(w);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(w)}throw new Error(`Call not found: ${g}`)}}e.UpdateChannel=C;class R{get state(){return this.b}set state(P){this.b=P,this.a.fire(P)}constructor(P){this.c=P,this.a=new E.Emitter,this.onStateChange=this.a.event,this.b=t.State.Uninitialized,this.c.listen("onStateChange")(g=>this.state=g),this.c.call("_getInitialState").then(g=>this.state=g)}checkForUpdates(P){return this.c.call("checkForUpdates",P)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(P){return this.c.call("_applySpecificUpdate",P)}}e.UpdateChannelClient=R}),define(ie[91],re([0,1,8,22,3,18,27,21,6,19,56,49]),function(H,e,E,t,C,R,A,P,g,w,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function y(d,v,h){return`${h.updateUrl}/api/update/${d}/${v}/${h.commit}`}e.createUpdateURL=y;let u=class{get state(){return this.b}d(v){this.j.info("update#setState",v.type),this.b=v,this.c.fire(v)}constructor(v,h,l,p,k,I){this.f=v,this.g=h,this.h=l,this.i=p,this.j=k,this.k=I,this.b=S.State.Uninitialized,this.c=new C.Emitter,this.onStateChange=this.c.event}async initialize(){if(!this.h.isBuilt)return;if(this.h.disableUpdates){this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.j.info("update#ctor - updates are disabled as there is no update URL");return}const v=this.l(),h=this.m(v);if(!h){this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(h),!this.a){this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(S.State.Idle(this.q())),v==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}v==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,l=>this.j.error(l))}l(){return(0,R.getMigratedSettingValue)(this.g,"update.mode","update.channel")}m(v){return v==="none"?void 0:this.k.quality}n(v=60*60*1e3){return(0,E.timeout)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(v){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(v)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(v){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(v=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){return this.a?await this.l()==="none"?!1:(await this.i.request({url:this.a},t.CancellationToken.None)).res.statusCode===204:void 0}async _applySpecificUpdate(v){}q(){return 1}r(){}};u=pe([ee(0,P.ILifecycleMainService),ee(1,R.IConfigurationService),ee(2,A.IEnvironmentMainService),ee(3,b.IRequestService),ee(4,g.ILogService),ee(5,w.IProductService)],u),e.AbstractUpdateService=u}),define(ie[244],re([0,1,13,54,3,2,18,27,21,6,19,56,31,49,91]),function(H,e,E,t,C,R,A,P,g,w,b,S,y,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let v=class extends d.AbstractUpdateService{get v(){return C.Event.fromNodeEventEmitter(E.autoUpdater,"error",(l,p)=>p)}get w(){return C.Event.fromNodeEventEmitter(E.autoUpdater,"update-not-available")}get x(){return C.Event.fromNodeEventEmitter(E.autoUpdater,"update-available",(l,p,k)=>({url:p,version:k,productVersion:k}))}get y(){return C.Event.fromNodeEventEmitter(E.autoUpdater,"update-downloaded",(l,p,k,I)=>({releaseNotes:p,version:k,productVersion:k,date:I}))}constructor(l,p,k,I,m,i,r){super(l,p,I,m,i,r),this.z=k,this.u=new R.DisposableStore}async initialize(){await super.initialize(),this.v(this.A,this,this.u),this.x(this.D,this,this.u),this.y(this.E,this,this.u),this.w(this.F,this,this.u)}A(l){this.j.error("UpdateService error:",l);const k=(this.state.type==="checking for updates"?this.state.explicit:!0)?l:void 0;this.d(u.State.Idle(1,k))}s(l){let p;this.k.darwinUniversalAssetId?p=this.k.darwinUniversalAssetId:p=process.arch==="x64"?"darwin":"darwin-arm64";const k=(0,d.createUpdateURL)(p,l,this.k);try{E.autoUpdater.setFeedURL({url:k})}catch(I){this.j.error("Failed to set update feed URL",I);return}return k}t(l){this.d(u.State.CheckingForUpdates(l)),E.autoUpdater.checkForUpdates()}D(l){this.state.type==="checking for updates"&&this.d(u.State.Downloading(l))}E(l){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:l.version}),this.d(u.State.Ready(l)))}F(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(u.State.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),E.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};pe([t.memoize],v.prototype,"v",null),pe([t.memoize],v.prototype,"w",null),pe([t.memoize],v.prototype,"x",null),pe([t.memoize],v.prototype,"y",null),v=pe([ee(0,g.ILifecycleMainService),ee(1,A.IConfigurationService),ee(2,y.ITelemetryService),ee(3,P.IEnvironmentMainService),ee(4,S.IRequestService),ee(5,w.ILogService),ee(6,b.IProductService)],v),e.DarwinUpdateService=v}),define(ie[245],re([0,1,46,40,8,3,9,27,21,6,31,49]),function(H,e,E,t,C,R,A,P,g,w,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let y=class{get state(){return this.a}d(v){this.g.info("update#setState",v.type),this.a=v,this.b.fire(v)}constructor(v,h,l){if(this.f=v,this.g=l,this.a=S.State.Uninitialized,this.b=new R.Emitter,this.onStateChange=this.b.event,h.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(S.State.Idle(this.k())),this.h(30*1e3).then(void 0,p=>this.g.error(p))}h(v=60*60*1e3){return(0,C.timeout)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(v){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(v)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(v){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(v=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(v){}};y=pe([ee(0,g.ILifecycleMainService),ee(1,P.IEnvironmentMainService),ee(2,w.ILogService)],y);let u=class extends y{constructor(v,h,l,p,k,I){super(l,p,k),this.o=v,this.p=h,this.q=I;const m=(0,t.watch)(A.dirname(this.o)),i=R.Event.fromNodeEventEmitter(m,"change",(o,c)=>c),r=R.Event.filter(i,o=>o==="current"),a=R.Event.debounce(r,(o,c)=>c,2e3)(()=>this.checkForUpdates(!1));l.onWillShutdown(()=>{a.dispose(),m.close()})}m(){this.d(S.State.CheckingForUpdates(!1)),this.u().then(v=>{v?this.d(S.State.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(S.State.Idle(2)))},v=>{this.g.error(v),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(S.State.Idle(2,v.message||v))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,E.spawn)("sleep 3 && "+A.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const v=await new Promise((l,p)=>(0,t.realpath)(`${A.dirname(this.o)}/current`,(k,I)=>k?p(k):l(I))),h=A.basename(v);return this.p!==h}isLatestVersion(){return this.u().then(void 0,v=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};u=pe([ee(2,g.ILifecycleMainService),ee(3,P.IEnvironmentMainService),ee(4,w.ILogService),ee(5,b.ITelemetryService)],u),e.SnapUpdateService=u}),define(ie[42],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,E.createDecorator)("IUriIdentityService")}),define(ie[246],re([0,1,42,191,16,20,127,3,2]),function(H,e,E,t,C,R,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class w{constructor(y){this.uri=y,this.time=w._clock++}touch(){return this.time=w._clock++,this}}w._clock=0;let b=class{constructor(y){this.g=y,this.c=new g.DisposableStore,this.f=2**16;const u=new Map,d=v=>{let h=u.get(v.scheme);return h===void 0&&(h=y.hasProvider(v)&&!this.g.hasCapability(v,1024),u.set(v.scheme,h)),h};this.c.add(P.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(v=>{u.delete(v.scheme)})),this.extUri=new R.ExtUri(d),this.d=new A.SkipList((v,h)=>this.extUri.compare(v,h,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(y){this.g.hasProvider(y)&&(y=(0,R.normalizePath)(y));const u=this.d.get(y);return u?u.touch().uri.with({fragment:y.fragment}):(this.d.set(y,new w(y)),this.h(),y)}h(){if(this.d.size<this.f)return;const y=[...this.d.entries()].sort((d,v)=>d[1].touch<v[1].touch?1:d[1].touch>v[1].touch?-1:0);w._clock=0,this.d.clear();const u=this.f*.5;for(let d=0;d<u;d++)this.d.set(y[d][0],y[d][1].touch())}};b=pe([ee(0,C.IFileService)],b),e.UriIdentityService=b,(0,t.registerSingleton)(E.IUriIdentityService,b,1)}),define(ie[115],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,E.createDecorator)("urlService")}),define(ie[247],re([0,1,7]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(P){this.a=P}listen(P,g){throw new Error(`Event not found: ${g}`)}call(P,g,w){switch(g){case"handleURL":return this.a.handleURL(E.URI.revive(w[0]),w[1])}throw new Error(`Call not found: ${g}`)}}e.URLHandlerChannel=t;class C{constructor(P){this.a=P}handleURL(P,g){return this.a.call("handleURL",[P.toJSON(),g])}}e.URLHandlerChannelClient=C;class R{constructor(P){this.a=P}async routeCall(P,g,w,b){if(g!=="handleURL")throw new Error(`Call not found: ${g}`);if(w){const S=E.URI.revive(w);if(S&&S.query){const y=/\bwindowId=(\d+)/.exec(S.query);if(y){const u=y[1],d=new RegExp(`window:${u}`),v=P.connections.find(h=>d.test(h.ctx));if(v)return v}}}return this.a.routeCall(P,g,w,b)}routeEvent(P,g){throw new Error(`Event not found: ${g}`)}}e.URLHandlerRouter=R}),define(ie[248],re([0,1,8,2,7,19]),function(H,e,E,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class A extends t.Disposable{constructor(){super(...arguments),this.a=new Set}open(w,b){const S=[...this.a.values()];return(0,E.first)(S.map(y=>()=>y.handleURL(w,b)),void 0,!1).then(y=>y||!1)}registerHandler(w){return this.a.add(w),(0,t.toDisposable)(()=>this.a.delete(w))}}e.AbstractURLService=A;let P=class extends A{constructor(w){super(),this.b=w}create(w){let{authority:b,path:S,query:y,fragment:u}=w||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return b&&S&&S.indexOf("/")!==0&&(S=`/${S}`),C.URI.from({scheme:this.b.urlProtocol,authority:b,path:S,query:y,fragment:u})}};P=pe([ee(0,R.IProductService)],P),e.NativeURLService=P}),define(ie[249],re([0,1,13,8,3,2,4,7]),function(H,e,E,t,C,R,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function g(b){try{return P.URI.parse(b)}catch{return null}}class w{constructor(S,y,u,d,v){if(this.f=y,this.a=[],this.b=0,this.c=R.Disposable.None,this.d=new R.DisposableStore,this.a=S,A.isWindows){const p=d.isBuilt?[]:[`"${d.appRoot}"`];p.push("--open-url","--"),E.app.setAsDefaultProtocolClient(v.urlProtocol,process.execPath,p)}const h=C.Event.map(C.Event.fromNodeEventEmitter(E.app,"open-url",(p,k)=>({event:p,url:k})),({event:p,url:k})=>(p.preventDefault(),k));this.d.add(h(p=>{const k=g(p);!k||this.f.open(k,{originalUrl:p})})),u.getWindows().filter(p=>p.isReady).length>0?this.g():C.Event.once(u.onDidSignalReadyWindow)(this.g,this,this.d)}async g(){if(this.b++>10)return;const S=[];for(const y of this.a)await this.f.open(y.uri,{originalUrl:y.url})||S.push(y);S.length!==0&&(this.a=S,this.c=(0,t.disposableTimeout)(()=>this.g(),500))}dispose(){this.d.dispose(),this.c.dispose()}}e.ElectronURLListener=w}),define(ie[250],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,E.createDecorator)("webviewManagerService")}),define(ie[251],re([0,1,13,2,14,7]),function(H,e,E,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class A extends t.Disposable{constructor(){super();const g=this.b.bind(this);E.protocol.registerFileProtocol(C.Schemas.vscodeWebview,g)}b(g,w){try{const b=R.URI.parse(g.url),S=A.a.get(b.path);if(typeof S=="string"){const y=`vs/workbench/contrib/webview/browser/pre/${S}`,u=C.FileAccess.asFileUri(y);return w({path:decodeURIComponent(u.fsPath),headers:{...C.COI.getHeadersFromQuery(g.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return w({error:-10})}catch{}return w({error:-2})}}e.WebviewProtocolProvider=A,A.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(ie[74],re([0,1,4]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(b){return!!b.workspaceUri}e.isWorkspaceToOpen=t;function C(b){return!!b.folderUri}e.isFolderToOpen=C;function R(b){return!!b.fileUri}e.isFileToOpen=R;function A(b){const S=P(b),y=b.getValue("window.menuBarVisibility");return y==="default"||S==="native"&&y==="compact"||E.isMacintosh&&E.isNative?"classic":y}e.getMenuBarVisibility=A;function P(b){if(E.isWeb)return"custom";const S=b.getValue("window");if(S){if(E.isMacintosh&&S.nativeTabs===!0||E.isMacintosh&&S.nativeFullScreen===!1)return"native";const d=S.titleBarStyle;if(d==="native"||d==="custom")return d}return E.isLinux?"native":"custom"}e.getTitleBarStyle=P;function g(b){if(!E.isWindows||E.isWeb||P(b)==="native")return!1;const S=b.getValue("window.experimental.windowControlsOverlay.enabled");return typeof S=="boolean"?S:!0}e.useWindowControlsOverlay=g;function w(b=0){return Math.pow(1.2,b)}e.zoomLevelToZoomFactor=w}),define(ie[116],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var E;(function(P){P[P.INITIAL=1]="INITIAL",P[P.LOAD=2]="LOAD",P[P.RELOAD=3]="RELOAD"})(E=e.LoadReason||(e.LoadReason={}));var t;(function(P){P[P.CLOSE=1]="CLOSE",P[P.QUIT=2]="QUIT",P[P.RELOAD=3]="RELOAD",P[P.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const C=function(P=1){return{width:1024,height:768,mode:P}};e.defaultWindowState=C;var R;(function(P){P[P.Maximized=0]="Maximized",P[P.Normal=1]="Normal",P[P.Minimized=2]="Minimized",P[P.Fullscreen=3]="Fullscreen"})(R=e.WindowMode||(e.WindowMode={}));var A;(function(P){P[P.UNRESPONSIVE=1]="UNRESPONSIVE",P[P.PROCESS_GONE=2]="PROCESS_GONE",P[P.LOAD=3]="LOAD"})(A=e.WindowError||(e.WindowError={}))}),define(ie[32],re([0,1,5]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,E.createDecorator)("windowsMainService");var t;(function(C){C[C.CLI=0]="CLI",C[C.DOCK=1]="DOCK",C[C.MENU=2]="MENU",C[C.DIALOG=3]="DIALOG",C[C.DESKTOP=4]="DESKTOP",C[C.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(ie[252],re([0,1,13,22,3,68,2,29,71,106,6,19,32]),function(H,e,E,t,C,R,A,P,g,w,b,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var u;(function(v){v[v.Initial=1]="Initial",v[v.StoredCredentialsUsed=2]="StoredCredentialsUsed",v[v.LoginDialogShown=3]="LoginDialogShown"})(u||(u={}));let d=class extends A.Disposable{constructor(h,l,p,k,I){super(),this.g=h,this.h=l,this.i=p,this.j=k,this.k=I,this.a=`${this.k.urlProtocol}.proxy-credentials`,this.b=void 0,this.c=u.Initial,this.f=void 0,this.l()}l(){const h=C.Event.fromNodeEventEmitter(E.app,"login",(l,p,k,I,m)=>({event:l,webContents:p,req:k,authInfo:I,callback:m}));this.B(h(this.m,this))}async m({event:h,authInfo:l,req:p,callback:k}){if(!l.isProxy)return;if(!this.b&&this.c===u.LoginDialogShown&&p.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}h.preventDefault();let I;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),I=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.n(l);try{I=await this.b}finally{this.b=void 0}}k(I?.username,I?.password)}async n(h){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const l=await this.p(h);if(l)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),l;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async p(h){this.g.trace("auth#doResolveProxyCredentials - enter",h);const l=String((0,R.hash)({scheme:h.scheme,host:h.host,port:h.port}));let p,k;try{const r=await this.i.getPassword(this.a,l);if(r){const n=JSON.parse(await this.j.decrypt(r));p=n.username,k=n.password}}catch(r){this.g.error(r)}if(this.c!==u.StoredCredentialsUsed&&typeof p=="string"&&typeof k=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=u.StoredCredentialsUsed,{username:p,password:k};const I=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!I){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${I.id} to handle proxy login`);const m={authInfo:h,username:this.f?.username??p,password:this.f?.password??k,replyChannel:`vscode:proxyAuthResponse:${(0,P.generateUuid)()}`};I.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,m),this.c=u.LoginDialogShown;const i=await new Promise(r=>{const n=async(a,o,c)=>{if(o===m.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${I.id}`),I.win?.webContents.off("ipc-message",n),c){const s={username:c.username,password:c.password};try{if(c.remember){const f=await this.j.encrypt(JSON.stringify(s));await this.i.setPassword(this.a,l,f)}else await this.i.deletePassword(this.a,l)}catch(f){this.g.error(f)}r({username:s.username,password:s.password})}else r(void 0)};I.win?.webContents.on("ipc-message",n)});return this.f=i,i}};d=pe([ee(0,b.ILogService),ee(1,y.IWindowsMainService),ee(2,g.ICredentialsMainService),ee(3,w.IEncryptionMainService),ee(4,S.IProductService)],d),e.ProxyAuthHandler=d}),define(ie[253],re([0,1,71,6,35,19,32,203]),function(H,e,E,t,C,R,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let g=class extends P.BaseCredentialsMainService{constructor(b,S,y,u){super(b),this.j=S,this.k=y,this.l=u,this.i=d=>{this.l.sendToFocused("vscode:showCredentialsError",d.message??d)}}async getSecretStoragePrefix(){return Promise.resolve(this.k.urlProtocol)}async h(){if(this.f)return this.f;if(this.j.disableKeytar)return this.g.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new E.InMemoryCredentialsProvider,this.f;const b=await new Promise((S,y)=>{H(["keytar"],S,y)});return await b.findCredentials("test-keytar-loads"),this.f=b,this.f}};g=pe([ee(0,t.ILogService),ee(1,C.INativeEnvironmentService),ee(2,R.IProductService),ee(3,A.IWindowsMainService)],g),e.CredentialsNativeMainService=g}),define(ie[254],re([0,1,15,2,3,6,21,81,46,284,8,14,44,4,33,13,32]),function(H,e,E,t,C,R,A,P,g,w,b,S,y,u,d,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;const l=v.utilityProcess,p=typeof l<"u";let k=class Nt{constructor(r,n,a){this.d=r,this.f=a,this.c=!1,this.b=new Map,n.onWillShutdown(o=>{this.c=!0,o.join(this._waitForAllExit(6e3))})}dispose(){}g(r){const n=this.b.get(r);if(!n)throw new Error("Unknown extension host!");return n}onDynamicStdout(r){return this.g(r).onStdout}onDynamicStderr(r){return this.g(r).onStderr}onDynamicMessage(r){return this.g(r).onMessage}onDynamicError(r){return this.g(r).onError}onDynamicExit(r){return this.g(r).onExit}async canUseUtilityProcess(){return p}async createExtensionHost(r){if(this.c)throw(0,E.canceled)();const n=String(++Nt.a);let a;if(r){if(!p)throw new Error("Cannot use UtilityProcess!");a=new m(n,this.d,this.f)}else a=new I(n,this.d);return this.b.set(n,a),a.onExit(({pid:o,code:c,signal:s})=>{this.d.info(`Extension host with pid ${o} exited with code: ${c}, signal: ${s}.`),setTimeout(()=>{a.dispose(),this.b.delete(n)})}),{id:n}}async start(r,n){if(this.c)throw(0,E.canceled)();return this.g(r).start(n)}async enableInspectPort(r){if(this.c)throw(0,E.canceled)();const n=this.b.get(r);return n?n.enableInspectPort():!1}async kill(r){if(this.c)throw(0,E.canceled)();const n=this.b.get(r);!n||n.kill()}async _killAllNow(){for(const[,r]of this.b)r.kill()}async _waitForAllExit(r){const n=[];for(const[,a]of this.b)n.push(a.waitForExit(r));return b.Promises.settled(n).then(()=>{})}};k.a=0,k=pe([ee(0,R.ILogService),ee(1,A.ILifecycleMainService),ee(2,h.IWindowsMainService)],k),e.ExtensionHostStarter=k;let I=class extends t.Disposable{constructor(r,n){super(),this.id=r,this.c=n,this._onStdout=this.B(new C.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this.B(new C.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this.B(new C.Emitter),this.onMessage=this._onMessage.event,this._onError=this.B(new C.Emitter),this.onError=this._onError.event,this._onExit=this.B(new C.Emitter),this.onExit=this._onExit.event,this.a=null,this.b=!1}start(r){u.isCI&&this.c.info("Calling fork to start extension host...");const n=P.StopWatch.create(!1);this.a=(0,g.fork)(S.FileAccess.asFileUri("bootstrap-fork").fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,y.mixin)({cwd:(0,d.cwd)()},r));const a=n.elapsed(),o=this.a.pid;this.c.info(`Starting extension host with pid ${o} (fork() took ${a} ms).`);const c=new w.StringDecoder("utf-8");this.a.stdout?.on("data",f=>{const M=typeof f=="string"?f:c.write(f);this._onStdout.fire(M)});const s=new w.StringDecoder("utf-8");this.a.stderr?.on("data",f=>{const M=typeof f=="string"?f:s.write(f);this._onStderr.fire(M)}),this.a.on("message",f=>{this._onMessage.fire(f)}),this.a.on("error",f=>{this._onError.fire({error:(0,E.transformErrorForSerialization)(f)})}),this.a.on("exit",(f,M)=>{this.b=!0,this._onExit.fire({pid:o,code:f,signal:M})})}enableInspectPort(){return this.a?(this.c.info(`Enabling inspect port on extension host with pid ${this.a.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this.a.pid),!0):u.isWindows?!1:(this.a.kill("SIGUSR1"),!0)):!1}kill(){!this.a||(this.c.info(`Killing extension host with pid ${this.a.pid}.`),this.a.kill())}async waitForExit(r){if(!this.a)return;const n=this.a.pid;this.c.info(`Waiting for extension host with pid ${n} to exit.`),await Promise.race([C.Event.toPromise(this.onExit),(0,b.timeout)(r)]),this.b||(this.c.info(`Extension host with pid ${n} did not exit within ${r}ms.`),this.a.kill())}};I=pe([ee(1,R.ILogService)],I);let m=class extends t.Disposable{constructor(r,n,a){super(),this.id=r,this.c=n,this.f=a,this.onError=C.Event.None,this._onStdout=this.B(new C.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this.B(new C.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this.B(new C.Emitter),this.onMessage=this._onMessage.event,this._onExit=this.B(new C.Emitter),this.onExit=this._onExit.event,this.a=null,this.b=!1}start(r){const n=this.f.getWindowById(r.responseWindowId);if(!n){this.c.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const a=n.win;if(!a||a.isDestroyed()||a.webContents.isDestroyed()){this.c.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const o=`extensionHost${this.id}`,c=S.FileAccess.asFileUri("bootstrap-fork.js").fsPath,s=["--type=extensionHost","--skipWorkspaceStorageLock"],f=r.execArgv||[],M={...r.env},L=!0,T="pipe";for(const se of Object.keys(M))M[se]=String(M[se]);this.c.info(`UtilityProcess<${this.id}>: Creating new...`),this.a=l.fork(c,s,{serviceName:o,env:M,execArgv:f,allowLoadingUnsignedLibraries:L,stdio:T});const U=new w.StringDecoder("utf-8");this.a.stdout?.on("data",se=>{const ce=typeof se=="string"?se:U.write(se);this._onStdout.fire(ce)});const K=new w.StringDecoder("utf-8");this.a.stderr?.on("data",se=>{const ce=typeof se=="string"?se:K.write(se);this._onStderr.fire(ce)}),this.a.on("message",se=>{this._onMessage.fire(se)}),this.B(C.Event.fromNodeEventEmitter(this.a,"spawn")(()=>{this.c.info(`UtilityProcess<${this.id}>: received spawn event.`)}));const V=C.Event.fromNodeEventEmitter(this.a,"exit",se=>se);this.B(V(se=>{this.c.info(`UtilityProcess<${this.id}>: received exit event with code ${se}.`),this.b=!0,this._onExit.fire({pid:this.a.pid,code:se,signal:""})}));const{port1:G,port2:_}=new v.MessageChannelMain;this.a.postMessage("null",[_]),a.webContents.postMessage(r.responseChannel,r.responseNonce,[G])}enableInspectPort(){return this.a?(this.c.info(`UtilityProcess<${this.id}>: Enabling inspect port on extension host with pid ${this.a.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this.a.pid),!0):!1):!1}kill(){!this.a||(this.c.info(`UtilityProcess<${this.id}>: Killing extension host with pid ${this.a.pid}.`),this.a.kill())}async waitForExit(r){if(!this.a)return;const n=this.a.pid;this.c.info(`UtilityProcess<${this.id}>: Waiting for extension host with pid ${n} to exit.`),await Promise.race([C.Event.toPromise(this.onExit),(0,b.timeout)(r)]),this.b||(this.c.info(`UtilityProcess<${this.id}>: Extension host with pid ${n} did not exit within ${r}ms, will kill it now.`),this.a.kill())}};m=pe([ee(1,R.ILogService),ee(2,h.IWindowsMainService)],m)}),define(ie[255],re([0,1,13,24,4,7,23,18,61,5,6,115,32]),function(H,e,E,t,C,R,A,P,g,w,b,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,w.createDecorator)(e.ID);let u=class{constructor(v,h,l,p){this.a=v,this.b=h,this.c=l,this.d=p}async start(v,h){this.a.trace("Received data from other instance: ",v,h),C.isMacintosh&&E.app.focus({steal:!0});const l=this.e(v);if(l.length){let p=Promise.resolve();if(this.b.getWindowCount()===0){const k=(0,t.firstOrDefault)(await this.b.openEmptyWindow({context:4}));k&&(p=k.ready())}p.then(()=>{for(const{uri:k,url:I}of l)this.c.open(k,{originalUrl:I})})}else return this.f(v,h)}e(v){return v["open-url"]&&v._urls&&v._urls.length>0?(0,t.coalesce)(v._urls.map(h=>{try{return{uri:R.URI.parse(h),url:h}}catch{return null}})):[]}async f(v,h){const l=(0,g.isLaunchedFromCli)(h)?0:4;let p=[];const k=v.wait&&v.waitMarkerFilePath?R.URI.file(v.waitMarkerFilePath):void 0,I=v.remote||void 0,m={context:l,cli:v,userEnv:h,waitMarkerFileURI:k,remoteAuthority:I,forceProfile:v.profile,forceTempProfile:v["profile-temp"]};if(v.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(v.extensionDevelopmentPath,m);else if(!v._.length&&!v["folder-uri"]&&!v["file-uri"]){let i=!1;if(v["new-window"]||v["unity-launch"]||m.forceProfile||m.forceTempProfile)i=!0;else if(v["reuse-window"])i=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":i=!0;break;case"off":i=!1;break;default:i=!C.isMacintosh}if(i)p=await this.b.open({...m,forceNewWindow:!0,forceEmpty:!0});else{const r=this.b.getLastActiveWindow();r?(this.b.openExistingWindow(r,m),p=[r]):p=await this.b.open({...m,forceEmpty:!0})}}else p=await this.b.open({...m,forceNewWindow:v["new-window"],preferNewWindow:!v["reuse-window"]&&!v.wait,forceReuseWindow:v["reuse-window"],diffMode:v.diff,mergeMode:v.merge,addMode:v.add,noRecentEntry:!!v["skip-add-to-recently-opened"],gotoLineMode:v.goto});if(k&&p.length===1&&p[0])return Promise.race([p[0].whenClosedOrLoaded,(0,A.whenDeleted)(k.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};u=pe([ee(0,b.ILogService),ee(1,y.IWindowsMainService),ee(2,S.IURLService),ee(3,P.IConfigurationService)],u),e.LaunchMainService=u}),define(ie[256],re([0,1,13,3,2,251,32]),function(H,e,E,t,C,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let P=class extends C.Disposable{constructor(w){super(),this.b=w,this.a=this.B(new t.Emitter),this.onFoundInFrame=this.a.event,this.B(new R.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(w,b){let S;if(typeof w.windowId=="number"){const{windowId:y}=w,u=this.b.getWindowById(y);if(!u?.win)throw new Error(`Invalid windowId: ${y}`);S=u.win.webContents}else{const{webContentsId:y}=w;if(S=E.webContents.fromId(y),!S)throw new Error(`Invalid webContentsId: ${y}`)}S.isDestroyed()||S.setIgnoreMenuShortcuts(b)}async findInFrame(w,b,S,y){const d=this.c(w,b);if(typeof d.findInFrame=="function"){d.findInFrame(S,{findNext:y.findNext,forward:y.forward});const v=(h,l)=>{l.finalUpdate&&(this.a.fire(l),d.removeListener("found-in-frame",v))};d.on("found-in-frame",v)}}async stopFindInFrame(w,b,S){const u=this.c(w,b);typeof u.stopFindInFrame=="function"&&u.stopFindInFrame(S.keepSelection?"keepSelection":"clearSelection")}c(w,b){const S=this.b.getWindowById(w.windowId);if(!S?.win)throw new Error(`Invalid windowId: ${w}`);const y=S.win.webContents.mainFrame.framesInSubtree.find(u=>u.name===b);if(!y)throw new Error(`Unknown frame: ${b}`);return y}};P=pe([ee(0,A.IWindowsMainService)],P),e.WebviewMainService=P}),define(ie[257],re([0,1,8,3,2]),function(H,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends C.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:g,getActiveWindowId:w}){super(),this.a=this.B(new C.DisposableStore),t.Event.latch(t.Event.any(P,g))(this.f,this,this.a),this.b=(0,E.createCancelablePromise)(()=>w()),(async()=>{try{const S=await this.b;this.c=typeof this.c=="number"?this.c:S}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=R}),define(ie[28],re([0,1,174,9,60,20,7,5,14]),function(H,e,E,t,C,R,A,P,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function w(n){const a=n;return typeof a?.id=="string"&&A.URI.isUri(a.uri)}e.isSingleFolderWorkspaceIdentifier=w;function b(n){return typeof n?.id=="string"&&!w(n)&&!y(n)}e.isEmptyWorkspaceIdentifier=b,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function S(n,a){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,t.basename)(n)}:a?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=n;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.toWorkspaceIdentifier=S;function y(n){const a=n;return typeof a?.id=="string"&&A.URI.isUri(a.configPath)}e.isWorkspaceIdentifier=y;function u(n){const a=n;if(a?.uri)return{id:a.id,uri:A.URI.revive(a.uri)};const o=n;if(o?.configPath)return{id:o.id,configPath:A.URI.revive(o.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=u;var d;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(d=e.WorkbenchState||(e.WorkbenchState={}));function v(n){const a=n;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}e.isWorkspace=v;function h(n){const a=n;return!!(a&&typeof a=="object"&&A.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}e.isWorkspaceFolder=h;class l{constructor(a,o,c,s,f){this.h=a,this.j=c,this.k=s,this.l=f,this.c=C.TernarySearchTree.forUris(this.l,()=>!0),this.folders=o}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=C.TernarySearchTree.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=l;class p{constructor(a,o){this.raw=o,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,R.joinPath)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function k(n){return new p({uri:n,index:0,name:(0,R.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=k,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,E.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function I(n,a){return R.extUriBiasedIgnorePathCase.isEqualOrParent(n,a.untitledWorkspacesHome)}e.isUntitledWorkspace=I;function m(n){let a;return A.URI.isUri(n)?a=n:a=n.configuration,a?.scheme===g.Schemas.tmp}e.isTemporaryWorkspace=m;function i(n,a){return!I(n,a)&&!m(n)}e.isSavedWorkspace=i;function r(n){return(typeof n=="string"?(0,t.extname)(n):(0,R.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(ie[57],re([0,1,13,8,68,34,2,77,4,11,23,151,5,6,28]),function(H,e,E,t,C,R,A,P,g,w,b,S,y,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,y.createDecorator)("dialogMainService");let v=class{constructor(l){this.d=l,this.a=new Map,this.b=new Map,this.c=new t.Queue}pickFileFolder(l,p){return this.e({...l,pickFolders:!0,pickFiles:!0,title:(0,S.localize)(0,null)},p)}pickFolder(l,p){return this.e({...l,pickFolders:!0,title:(0,S.localize)(1,null)},p)}pickFile(l,p){return this.e({...l,pickFiles:!0,title:(0,S.localize)(2,null)},p)}pickWorkspace(l,p){const k=(0,S.localize)(3,null),I=(0,R.mnemonicButtonLabel)((0,S.localize)(4,null)),m=d.WORKSPACE_FILTER;return this.e({...l,pickFiles:!0,title:k,filters:m,buttonLabel:I},p)}async e(l,p){const k={title:l.title,buttonLabel:l.buttonLabel,filters:l.filters,defaultPath:l.defaultPath};(typeof l.pickFiles=="boolean"||typeof l.pickFolders=="boolean")&&(k.properties=void 0,l.pickFiles&&l.pickFolders&&(k.properties=["multiSelections","openDirectory","openFile","createDirectory"])),k.properties||(k.properties=["multiSelections",l.pickFolders?"openDirectory":"openFile","createDirectory"]),g.isMacintosh&&k.properties.push("treatPackageAsDirectory");const I=await this.showOpenDialog(k,(0,w.withNullAsUndefined)(p||E.BrowserWindow.getFocusedWindow()));if(I&&I.filePaths&&I.filePaths.length>0)return I.filePaths}f(l){if(l){let p=this.b.get(l.id);return p||(p=new t.Queue,this.b.set(l.id,p)),p}else return this.c}showMessageBox(l,p){return this.f(p).queue(async()=>p?E.dialog.showMessageBox(p,l):E.dialog.showMessageBox(l))}async showSaveDialog(l,p){const k=this.i(l,p);if(!k)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.f(p).queue(async()=>{let I;return p?I=await E.dialog.showSaveDialog(p,l):I=await E.dialog.showSaveDialog(l),I.filePath=this.g(I.filePath),I})}finally{(0,A.dispose)(k)}}g(l){return l&&g.isMacintosh&&(l=(0,P.normalizeNFC)(l)),l}h(l){return l.map(p=>this.g(p))}async showOpenDialog(l,p){l.defaultPath&&(await b.Promises.exists(l.defaultPath)||(l.defaultPath=void 0));const k=this.i(l,p);if(!k)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.f(p).queue(async()=>{let I;return p?I=await E.dialog.showOpenDialog(p,l):I=await E.dialog.showOpenDialog(l),I.filePaths=this.h(I.filePaths),I})}finally{(0,A.dispose)(k)}}i(l,p){if(!p)return A.Disposable.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",l);let k=this.a.get(p.id);k||(k=new Set,this.a.set(p.id,k));const I=(0,C.hash)(l);if(!k.has(I))return this.d.trace("[DialogMainService]: new file dialog lock created",l),k.add(I),(0,A.toDisposable)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",l),k?.delete(I),k?.size===0&&this.a.delete(p.id)})}};v=pe([ee(0,u.ILogService)],v),e.DialogMainService=v}),define(ie[258],re([0,1,3,2,69,28]),function(H,e,E,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class A extends t.Disposable{constructor(g,w){super(),this.f=g,this.g=w,this.b=this.B(new E.Emitter),this.c=new Map,this.h(w.applicationStorage,this.b)}h(g,w){this.B(E.Event.debounce(g.onDidChangeStorage,(b,S)=>(b?b.push(S):b=[S],b),A.a)(b=>{b.length&&w.fire(this.i(b,g))}))}i(g,w){const b=new Map,S=new Set;return g.forEach(y=>{const u=w.get(y.key);typeof u=="string"?b.set(y.key,u):S.add(y.key)}),{changed:Array.from(b.entries()),deleted:Array.from(S.values())}}listen(g,w,b){switch(w){case"onDidChangeStorage":{const S=b.profile?(0,C.revive)(b.profile):void 0;if(!S)return this.b.event;let y=this.c.get(S.id);return y||(y=this.B(new E.Emitter),this.h(this.g.profileStorage(S),y),this.c.set(S.id,y)),y.event}}throw new Error(`Event not found: ${w}`)}async call(g,w,b){const S=b.profile?(0,C.revive)(b.profile):void 0,y=(0,R.reviveIdentifier)(b.workspace),u=await this.j(S,y);switch(w){case"getItems":return Array.from(u.items.entries());case"updateItems":{const d=b;if(d.insert)for(const[v,h]of d.insert)u.set(v,h);d.delete?.forEach(v=>u.delete(v));break}case"isUsed":{const d=b.payload;if(typeof d=="string")return this.g.isUsed(d)}default:throw new Error(`Call not found: ${w}`)}}async j(g,w){let b;w?b=this.g.workspaceStorage(w):g?b=this.g.profileStorage(g):b=this.g.applicationStorage;try{await b.init()}catch(S){this.f.error(`StorageIPC#init: Unable to init ${w?"workspace":g?"profile":"application"} storage due to ${S}`)}return b}}e.StorageDatabaseChannel=A,A.a=100}),define(ie[38],re([0,1,68,3,2,20,7,171,35,16,5,6,28,39,42,8,29,26,11]),function(H,e,E,t,C,R,A,P,g,w,b,S,y,u,d,v,h,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function k(n){const a=n;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&typeof a.isDefault=="boolean"&&typeof a.name=="string"&&A.URI.isUri(a.location)&&A.URI.isUri(a.globalStorageHome)&&A.URI.isUri(a.settingsResource)&&A.URI.isUri(a.keybindingsResource)&&A.URI.isUri(a.tasksResource)&&A.URI.isUri(a.snippetsHome)&&A.URI.isUri(a.extensionsResource))}e.isUserDataProfile=k,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,b.createDecorator)("IUserDataProfilesService");function I(n,a){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:A.URI.revive(n.location).with({scheme:a}),globalStorageHome:A.URI.revive(n.globalStorageHome).with({scheme:a}),settingsResource:A.URI.revive(n.settingsResource).with({scheme:a}),keybindingsResource:A.URI.revive(n.keybindingsResource).with({scheme:a}),tasksResource:A.URI.revive(n.tasksResource).with({scheme:a}),snippetsHome:A.URI.revive(n.snippetsHome).with({scheme:a}),extensionsResource:A.URI.revive(n.extensionsResource)?.with({scheme:a}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=I;function m(n,a,o,c){return{id:n,name:a,location:o,isDefault:!1,shortName:c?.shortName,globalStorageHome:(0,R.joinPath)(o,"globalStorage"),settingsResource:(0,R.joinPath)(o,"settings.json"),keybindingsResource:(0,R.joinPath)(o,"keybindings.json"),tasksResource:(0,R.joinPath)(o,"tasks.json"),snippetsHome:(0,R.joinPath)(o,"snippets"),extensionsResource:(0,R.joinPath)(o,"extensions.json"),useDefaultFlags:c?.useDefaultFlags,isTransient:c?.transient}}e.toUserDataProfile=m;let i=class extends C.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(a,o,c,s){super(),this.m=a,this.n=o,this.r=c,this.s=s,this.f=!1,this.g=this.B(new t.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new t.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new t.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new t.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new u.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,R.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(a){this.f!==a&&(this.t=void 0,this.f=a)}isEnabled(){return this.f}get u(){if(!this.t){const a=[];if(this.f)for(const f of this.G()){if(!f.name||!(0,p.isString)(f.name)||!f.location){this.s.warn("Skipping the invalid stored profile",f.location||f.name);continue}a.push(m((0,R.basename)(f.location),f.name,f.location,{shortName:f.shortName,useDefaultFlags:f.useDefaultFlags}))}const o=new u.ResourceMap,c=new Map,s=m((0,E.hash)(this.m.userRoamingDataHome.path).toString(16),(0,P.localize)(0,null),this.m.userRoamingDataHome);if(a.unshift({...s,extensionsResource:this.L()??s.extensionsResource,isDefault:!0}),a.length){const f=this.I();if(f.workspaces)for(const[M,L]of Object.entries(f.workspaces)){const T=A.URI.parse(M),U=A.URI.parse(L),K=a.find(V=>this.r.extUri.isEqual(V.location,U));K&&o.set(T,K)}if(f.emptyWindows)for(const[M,L]of Object.entries(f.emptyWindows)){const T=A.URI.parse(L),U=a.find(K=>this.r.extUri.isEqual(K.location,T));U&&c.set(M,U)}}this.t={profiles:a,workspaces:o,emptyWindows:c}}return this.t}async createTransientProfile(a){const o="Temp",c=new RegExp(`${(0,l.escapeRegExpCharacters)(o)}\\s(\\d+)`);let s=0;for(const M of this.profiles){const L=c.exec(M.name),T=L?parseInt(L[1]):0;s=T>s?T:s}const f=`${o} ${s+1}`;return this.createProfile((0,E.hash)((0,h.generateUuid)()).toString(16),f,{transient:!0},a)}async createNamedProfile(a,o,c){return this.createProfile((0,E.hash)((0,h.generateUuid)()).toString(16),a,o,c)}async createProfile(a,o,c,s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const f=await this.v(a,o,c);return s&&await this.setProfileForWorkspace(s,f),f}async v(a,o,c){if(!(0,p.isString)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let s=this.k.get(o);return s||(s=(async()=>{try{const f=this.profiles.find(T=>T.name===o||T.id===a);if(f)return f;const M=m(a,o,(0,R.joinPath)(this.profilesHome,a),c);await this.n.createFolder(M.location);const L=[];return this.h.fire({profile:M,join(T){L.push(T)}}),await v.Promises.settled(L),this.z([M],[],[]),M}finally{this.k.delete(o)}})(),this.k.set(o,s)),s}async updateProfile(a,o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let c=this.profiles.find(s=>s.id===a.id);if(!c)throw new Error(`Profile '${a.name}' does not exist`);return c=m(c.id,o.name??c.name,c.location,{shortName:o.shortName??c.shortName,transient:o.transient??c.isTransient,useDefaultFlags:o.useDefaultFlags??c.useDefaultFlags}),this.z([],[],[c]),c}async removeProfile(a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(a.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(s=>s.id===a.id);if(!o)throw new Error(`Profile '${a.name}' does not exist`);const c=[];this.i.fire({profile:o,join(s){c.push(s)}});try{await Promise.allSettled(c)}catch(s){this.s.error(s)}for(const s of[...this.u.emptyWindows.keys()])o.id===this.u.emptyWindows.get(s)?.id&&this.u.emptyWindows.delete(s);for(const s of[...this.u.workspaces.keys()])o.id===this.u.workspaces.get(s)?.id&&this.u.workspaces.delete(s);this.F(),this.z([],[o],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(o.location,{recursive:!0})}catch(s){this.s.error(s)}}async setProfileForWorkspace(a,o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const c=this.profiles.find(s=>s.id===o.id);if(!c)throw new Error(`Profile '${o.name}' does not exist`);this.D(a,c)}unsetWorkspace(a,o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.D(a,void 0,o)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.F(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const a=await this.n.resolve(this.profilesHome);await Promise.all((a.children||[]).filter(o=>o.isDirectory&&this.profiles.every(c=>!this.r.extUri.isEqual(c.location,o.resource))).map(o=>this.n.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const a=this.l.profiles.filter(o=>!this.y(o));await Promise.allSettled(a.map(o=>this.removeProfile(o)))}getProfileForWorkspace(a){const o=this.w(a);return A.URI.isUri(o)?this.l.workspaces.get(o)??this.u.workspaces.get(o):this.l.emptyWindows.get(o)??this.u.emptyWindows.get(o)}w(a){return(0,y.isSingleFolderWorkspaceIdentifier)(a)?a.uri:(0,y.isWorkspaceIdentifier)(a)?a.configPath:a.id}y(a){return!!([...this.l.emptyWindows.values()].some(o=>this.r.extUri.isEqual(o.location,a.location))||[...this.l.workspaces.values()].some(o=>this.r.extUri.isEqual(o.location,a.location))||[...this.u.emptyWindows.values()].some(o=>this.r.extUri.isEqual(o.location,a.location))||[...this.u.workspaces.values()].some(o=>this.r.extUri.isEqual(o.location,a.location)))}z(a,o,c){const s=[...this.profiles,...a],f=[];this.l.profiles=[];for(let M of s)M.isDefault||o.some(L=>M.id===L.id)||(M=c.find(L=>M.id===L.id)??M,M.isTransient?this.l.profiles.push(M):f.push({location:M.location,name:M.name,shortName:M.shortName,useDefaultFlags:M.useDefaultFlags}));this.H(f),this.t=void 0,this.C(a,o,c)}C(a,o,c){this.g.fire({added:a,removed:o,updated:c,all:this.profiles})}D(a,o,c){c=o?.isTransient?!0:c,c||this.D(a,void 0,!0);const s=this.w(a),f=c?this.l:this.u;A.URI.isUri(s)?(f.workspaces.delete(s),o&&f.workspaces.set(s,o)):(f.emptyWindows.delete(s),o&&f.emptyWindows.set(s,o)),c||this.F()}F(){const a={};for(const[c,s]of this.u.workspaces.entries())a[c.toString()]=s.location.toString();const o={};for(const[c,s]of this.u.emptyWindows.entries())o[c.toString()]=s.location.toString();this.J({workspaces:a,emptyWindows:o}),this.t=void 0}G(){return[]}H(a){throw new Error("not implemented")}I(){return{}}J(a){throw new Error("not implemented")}L(){}};i.b="userDataProfiles",i.c="profileAssociations",i=pe([ee(0,g.IEnvironmentService),ee(1,w.IFileService),ee(2,d.IUriIdentityService),ee(3,S.ILogService)],i),e.UserDataProfilesService=i;class r extends i{constructor(){super(...arguments),this.a=[],this.O={}}G(){return this.a}H(a){this.a=a}I(){return this.O}J(a){this.O=a}}e.InMemoryUserDataProfilesService=r}),define(ie[92],re([0,1,8,17,2,3,39,7,111,88,16,5,6,38,42,11,14]),function(H,e,E,t,C,R,A,P,g,w,b,S,y,u,d,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,S.createDecorator)("IExtensionsProfileScannerService");let l=class extends C.Disposable{constructor(m,i,r,n){super(),this.h=m,this.i=i,this.j=r,this.k=n,this.a=this.B(new R.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new R.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new R.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new R.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new A.ResourceMap}scanProfileExtensions(m){return this.l(m)}async addExtensionsToProfile(m,i){const r=[],n=[];try{return await this.l(i,a=>{const o=[];for(const c of a)m.some(([s])=>(0,g.areSameExtensions)(s.identifier,c.identifier)&&s.manifest.version!==c.version)?r.push(c):o.push(c);for(const[c,s]of m)if(!o.some(f=>(0,g.areSameExtensions)(f.identifier,c.identifier)&&f.version===c.manifest.version)){const f={identifier:c.identifier,version:c.manifest.version,location:c.location,metadata:s};n.push(f),o.push(f)}return n.length&&this.a.fire({extensions:n,profileLocation:i}),r.length&&this.c.fire({extensions:r,profileLocation:i}),o}),n.length&&this.b.fire({extensions:n,profileLocation:i}),r.length&&this.f.fire({extensions:r,profileLocation:i}),n}catch(a){throw n.length&&this.b.fire({extensions:n,error:a,profileLocation:i}),r.length&&this.f.fire({extensions:r,error:a,profileLocation:i}),a}}async removeExtensionFromProfile(m,i){const r=[];this.c.fire({extensions:r,profileLocation:i});try{await this.l(i,n=>{const a=[];for(const o of n)(0,g.areSameExtensions)(o.identifier,m.identifier)?r.push(o):a.push(o);return r.length&&this.c.fire({extensions:r,profileLocation:i}),a}),r.length&&this.f.fire({extensions:r,profileLocation:i})}catch(n){throw r.length&&this.f.fire({extensions:r,error:n,profileLocation:i}),n}}async l(m,i){return this.s(m).queue(async()=>{let r=[],n;try{const a=await this.h.readFile(m);n=JSON.parse(a.value.toString())}catch(a){if((0,b.toFileOperationResult)(a)!==1)throw a;this.j.extUri.isEqual(m,this.i.defaultProfile.extensionsResource)&&(n=await this.r())}if(n){if(!Array.isArray(n))throw new Error(`Invalid extensions content in ${m.toString()}`);let a=!1;for(const o of n){if(!p(o))throw new Error(`Invalid extensions content in ${m.toString()}`);let c;if((0,v.isString)(o.location))c=this.n(m,o.location);else{c=P.URI.revive(o.location);const s=this.m(m,c);s&&(a=!0,o.location=s)}r.push({identifier:o.identifier,location:c,version:o.version,metadata:o.metadata})}a&&await this.h.writeFile(m,t.VSBuffer.fromString(JSON.stringify(n)))}if(i){r=i(r);const a=r.map(o=>({identifier:o.identifier,version:o.version,location:this.m(m,o.location)??o.location.toJSON(),metadata:o.metadata}));await this.h.writeFile(m,t.VSBuffer.fromString(JSON.stringify(a)))}return r})}m(m,i){const r=this.j.extUri.dirname(m).with({scheme:h.Schemas.file});if(this.j.extUri.isEqualOrParent(i,r))return this.j.extUri.relativePath(r,i)}n(m,i){return this.j.extUri.joinPath(this.j.extUri.dirname(m),i).with({scheme:h.Schemas.file})}async r(){return this.p||(this.p=(async()=>{const m=this.j.extUri.joinPath(this.i.defaultProfile.location,"extensions.json");let i;try{i=(await this.h.readFile(m)).value.toString()}catch(n){if((0,b.toFileOperationResult)(n)===1)return;throw n}this.k.info("Migrating extensions from old default profile location",m.toString());let r;try{const n=JSON.parse(i);Array.isArray(n)&&n.every(a=>p(a))?r=n:this.k.warn("Skipping migrating from old default profile locaiton: Found invalid data",n)}catch(n){this.k.error(n)}if(r)try{await this.h.createFile(this.i.defaultProfile.extensionsResource,t.VSBuffer.fromString(JSON.stringify(r)),{overwrite:!1}),this.k.info("Migrated extensions from old default profile location to new location",m.toString(),this.i.defaultProfile.extensionsResource.toString())}catch(n){if((0,b.toFileOperationResult)(n)===3)this.k.info("Migration from old default profile location to new location is done by another window",m.toString(),this.i.defaultProfile.extensionsResource.toString());else throw n}try{await this.h.del(m)}catch(n){(0,b.toFileOperationResult)(n)!==1&&this.k.error(n)}return r})()),this.p}s(m){let i=this.g.get(m);return i||(i=new E.Queue,this.g.set(m,i)),i}};l=pe([ee(0,b.IFileService),ee(1,u.IUserDataProfilesService),ee(2,d.IUriIdentityService),ee(3,y.ILogService)],l),e.ExtensionsProfileScannerService=l;function p(I){return(0,v.isObject)(I)&&(0,w.isIExtensionIdentifier)(I.identifier)&&(k(I.location)||(0,v.isString)(I.location))&&I.version&&(0,v.isString)(I.version)}function k(I){return I?(0,v.isString)(I.path)&&(0,v.isString)(I.scheme):!1}}),define(ie[117],re([0,1,24,8,44,17,15,43,137,2,14,9,4,20,189,98,11,7,156,35,111,88,188,16,5,6,19,3,69,92,38,42,186,187]),function(H,e,E,t,C,R,A,P,g,w,b,S,y,u,d,v,h,l,p,k,I,m,i,r,n,a,o,c,s,f,M,L,T,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var K;(function(ue){function z(N,F){if(N===F)return!0;const q=Object.keys(N),Q=new Set;for(const oe of Object.keys(F))Q.add(oe);if(q.length!==Q.size)return!1;for(const oe of q){if(N[oe]!==F[oe])return!1;Q.delete(oe)}return Q.size===0}ue.equals=z})(K=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let V=class extends w.Disposable{constructor(z,N,F,q,Q,oe,x,D,O,W,j,$){super(),this.systemExtensionsLocation=z,this.userExtensionsLocation=N,this.l=F,this.m=q,this.n=Q,this.p=oe,this.r=x,this.s=D,this.t=O,this.u=W,this.v=j,this.w=$,this.g=this.B(new c.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,u.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(se,(0,u.joinPath)(this.m,m.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(se,(0,u.joinPath)(this.m,m.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(_,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,I.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(z,N,F){const[q,Q]=await Promise.all([this.scanSystemExtensions(z),this.scanUserExtensions(N)]),oe=F?await this.scanExtensionsUnderDevelopment(z,[...q,...Q]):[];return this.D(q,Q,oe,await this.getTargetPlatform(),!0)}async scanSystemExtensions(z){const N=[];N.push(this.F(!!z.useCache,z.language)),N.push(this.G(z.language,!!z.checkControlFile));const[F,q]=await Promise.all(N);return this.C([...F,...q],0,z,!1)}async scanUserExtensions(z){const N=z.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",N);const F=await this.I(N,!!z.profileLocation,1,!z.includeUninstalled,z.language);let Q=await(z.useCache&&!F.devMode&&F.excludeObsolete?this.j:this.k).scanExtensions(F);return Q=await this.C(Q,1,z,!0),this.s.trace("Scanned user extensions:",Q.length),Q}async scanExtensionsUnderDevelopment(z,N){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const F=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(q=>q.scheme===b.Schemas.file).map(async q=>{const Q=await this.I(q,!1,1,!0,z.language,!1);return(await this.k.scanOneOrMultipleExtensions(Q)).map(x=>(x.type=N.find(D=>(0,I.areSameExtensions)(D.identifier,x.identifier))?.type??x.type,this.k.validate(x,Q)))}))).flat();return this.C(F,"development",z,!0)}return[]}async scanExistingExtension(z,N,F){const q=await this.I(z,!1,N,!0,F.language),Q=await this.k.scanExtension(q);return!Q||!F.includeInvalid&&!Q.isValid?null:Q}async scanOneOrMultipleExtensions(z,N,F){const q=await this.I(z,!1,N,!0,F.language),Q=await this.k.scanOneOrMultipleExtensions(q);return this.C(Q,N,F,!0)}async scanMetadata(z){const N=(0,u.joinPath)(z,"package.json"),F=(await this.r.readFile(N)).value.toString();return JSON.parse(F).__metadata}async updateMetadata(z,N){const F=(0,u.joinPath)(z,"package.json"),q=(await this.r.readFile(F)).value.toString(),Q=JSON.parse(q);N.isMachineScoped=N.isMachineScoped||void 0,N.isBuiltin=N.isBuiltin||void 0,N.installedTimestamp=N.installedTimestamp||void 0,Q.__metadata={...Q.__metadata,...N},await this.r.writeFile((0,u.joinPath)(z,"package.json"),R.VSBuffer.fromString(JSON.stringify(Q,null,"	")))}initializeDefaultProfileExtensions(){return this.z||(this.z=(async()=>{try{const z=this.v.extUri.joinPath(this.userExtensionsLocation,".init-default-profile-extensions");if(await this.r.exists(z))return;let N=(await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource)).length>0;N||(N=await this.r.exists(this.n.defaultProfile.extensionsResource));const F=this.v.extUri.joinPath(this.n.defaultProfile.location,"extensions.json");let q=(await this.p.scanProfileExtensions(F)).length>0;if(q||(q=await this.r.exists(F)),!N&&!q){this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Q=await this.scanUserExtensions({includeInvalid:!0});await this.p.addExtensionsToProfile(Q.map(oe=>[oe,oe.metadata]),this.n.defaultProfile.extensionsResource),this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}try{await this.r.createFile(z,R.VSBuffer.fromString(""))}catch(Q){(0,r.toFileOperationResult)(Q)!==1&&this.s.warn("Failed to create default profile extensions initialize marker in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.getErrorMessage)(Q))}}catch(z){throw this.s.error(z),z}})()),this.z}async C(z,N,F,q){return F.includeAllVersions||(z=this.D(N===0?z:void 0,N===1?z:void 0,N==="development"?z:void 0,await this.getTargetPlatform(),q)),F.includeInvalid||(z=z.filter(Q=>Q.isValid)),z.sort((Q,oe)=>{const x=S.basename(Q.location.fsPath),D=S.basename(oe.location.fsPath);return x<D?-1:x>D?1:0})}D(z,N,F,q,Q){const oe=(D,O,W)=>{if(D.isValid&&!O.isValid)return!1;if(D.isValid===O.isValid){if(Q&&d.gt(D.manifest.version,O.manifest.version))return this.s.debug(`Skipping extension ${O.location.path} with lower version ${O.manifest.version} in favour of ${D.location.path} with version ${D.manifest.version}`),!1;if(d.eq(D.manifest.version,O.manifest.version)){if(D.type===0)return this.s.debug(`Skipping extension ${O.location.path} in favour of system extension ${D.location.path} with same version`),!1;if(D.targetPlatform===q)return this.s.debug(`Skipping extension ${O.location.path} from different target platform ${O.targetPlatform}`),!1}}return W?this.s.warn(`Overwriting user extension ${D.location.path} with ${O.location.path}.`):this.s.debug(`Overwriting user extension ${D.location.path} with ${O.location.path}.`),!0},x=new Map;return z?.forEach(D=>{const O=m.ExtensionIdentifier.toKey(D.identifier.id),W=x.get(O);(!W||oe(W,D,!1))&&x.set(O,D)}),N?.forEach(D=>{const O=m.ExtensionIdentifier.toKey(D.identifier.id),W=x.get(O);if(!W&&z&&D.type===0){this.s.debug(`Skipping obsolete system extension ${D.location.path}.`);return}(!W||oe(W,D,!1))&&x.set(O,D)}),F?.forEach(D=>{const O=m.ExtensionIdentifier.toKey(D.identifier.id),W=x.get(O);(!W||oe(W,D,!0))&&x.set(O,D),x.set(O,D)}),[...x.values()]}async F(z,N){this.s.trace("Started scanning system extensions");const F=await this.I(this.systemExtensionsLocation,!1,0,!0,N),Q=await(z&&!F.devMode?this.i:this.k).scanExtensions(F);return this.s.trace("Scanned system extensions:",Q.length),Q}async G(z,N){const F=this.t.isBuilt?[]:this.u.builtInExtensions;if(!F?.length)return[];this.s.trace("Started scanning dev system extensions");const q=N?await this.H():{},Q=[],oe=l.URI.file(S.normalize(S.join(b.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const D of F){const O=q[D.name]||"marketplace";switch(O){case"disabled":break;case"marketplace":Q.push((0,u.joinPath)(oe,D.name));break;default:Q.push(l.URI.file(O));break}}const x=await Promise.all(Q.map(async D=>this.k.scanExtension(await this.I(D,!1,0,!0,z))));return this.s.trace("Scanned dev system extensions:",x.length),(0,E.coalesce)(x)}async H(){try{const z=await this.r.readFile(this.l);return JSON.parse(z.value.toString())}catch{return{}}}async I(z,N,F,q,Q,oe=!0){const x=await this.f(Q??y.language),D=await this.J(z),O=N&&!this.v.extUri.isEqual(z,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,W=O?await this.J(O):void 0;return new G(z,D,O,W,N,F,q,oe,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,Q,x)}async J(z){try{const N=await this.r.stat(z);if(typeof N.mtime=="number")return N.mtime}catch{}}};V=pe([ee(4,M.IUserDataProfilesService),ee(5,f.IExtensionsProfileScannerService),ee(6,r.IFileService),ee(7,a.ILogService),ee(8,k.IEnvironmentService),ee(9,o.IProductService),ee(10,L.IUriIdentityService),ee(11,n.IInstantiationService)],V),e.AbstractExtensionsScannerService=V;class G{constructor(z,N,F,q,Q,oe,x,D,O,W,j,$,Y,B){this.location=z,this.mtime=N,this.applicationExtensionslocation=F,this.applicationExtensionslocationMtime=q,this.profile=Q,this.type=oe,this.excludeObsolete=x,this.validate=D,this.productVersion=O,this.productDate=W,this.productCommit=j,this.devMode=$,this.language=Y,this.translations=B}static createNlsConfiguration(z){return{language:z.language,pseudo:z.language==="pseudo",devMode:z.devMode,translations:z.translations}}static equals(z,N){return(0,u.isEqual)(z.location,N.location)&&z.mtime===N.mtime&&(0,u.isEqual)(z.applicationExtensionslocation,N.applicationExtensionslocation)&&z.applicationExtensionslocationMtime===N.applicationExtensionslocationMtime&&z.profile===N.profile&&z.type===N.type&&z.excludeObsolete===N.excludeObsolete&&z.validate===N.validate&&z.productVersion===N.productVersion&&z.productDate===N.productDate&&z.productCommit===N.productCommit&&z.devMode===N.devMode&&z.language===N.language&&K.equals(z.translations,N.translations)}}let _=class extends w.Disposable{constructor(z,N,F,q,Q){super(),this.f=z,this.g=N,this.h=F,this.i=q,this.j=Q}async scanExtensions(z){const N=z.profile?await this.l(z):await this.k(z);let F={};if(z.excludeObsolete&&z.type===1)try{const q=(await this.i.readFile(this.f)).value.toString();F=JSON.parse(q)}catch{}return(0,h.isEmptyObject)(F)?N:N.filter(q=>!F[I.ExtensionKey.create(q).toString()])}async k(z){const N=await this.i.resolve(z.location);if(!N.children?.length)return[];const F=await Promise.all(N.children.map(async q=>{if(!q.isDirectory||z.type===1&&(0,u.basename)(q.resource).indexOf(".")===0)return null;const Q=new G(q.resource,z.mtime,z.applicationExtensionslocation,z.applicationExtensionslocationMtime,z.profile,z.type,z.excludeObsolete,z.validate,z.productVersion,z.productDate,z.productCommit,z.devMode,z.language,z.translations);return this.scanExtension(Q)}));return(0,E.coalesce)(F).sort((q,Q)=>q.location.path<Q.location.path?-1:1)}async l(z){let N=await this.m(z.location,()=>!0,z);if(z.applicationExtensionslocation&&!this.h.extUri.isEqual(z.location,z.applicationExtensionslocation)){N=N.filter(q=>!q.metadata?.isApplicationScoped);const F=await this.m(z.applicationExtensionslocation,q=>!!q.metadata?.isApplicationScoped,z);N.push(...F)}return N}async m(z,N,F){const q=await this.g.scanProfileExtensions(z);if(!q.length)return[];const Q=await Promise.all(q.map(async oe=>{if(N(oe)){const x=new G(oe.location,F.mtime,F.applicationExtensionslocation,F.applicationExtensionslocationMtime,F.profile,F.type,F.excludeObsolete,F.validate,F.productVersion,F.productDate,F.productCommit,F.devMode,F.language,F.translations);return this.scanExtension(x,oe.metadata)}return null}));return(0,E.coalesce)(Q)}async scanOneOrMultipleExtensions(z){try{if(await this.i.exists((0,u.joinPath)(z.location,"package.json"))){const N=await this.scanExtension(z);return N?[N]:[]}else return await this.scanExtensions(z)}catch(N){return this.j.error(`Error scanning extensions at ${z.location.path}:`,(0,A.getErrorMessage)(N)),[]}}async scanExtension(z,N){try{let F=await this.scanExtensionManifest(z.location);if(F){F.publisher||(F.publisher=m.UNDEFINED_PUBLISHER),N=N??F.__metadata,delete F.__metadata;const q=(0,I.getGalleryExtensionId)(F.publisher,F.name),Q=N?.id?{id:q,uuid:N.id}:{id:q},oe=N?.isSystem?0:z.type,x=oe===0||!!N?.isBuiltin;U.ImplicitActivationEvents.updateManifest(F),F=await this.n(z.location,F,G.createNlsConfiguration(z));const D={type:oe,identifier:Q,manifest:F,location:z.location,isBuiltin:x,targetPlatform:N?.targetPlatform??"undefined",metadata:N,isValid:!0,validations:[]};return z.validate?this.validate(D,z):D}}catch(F){z.type!==0&&this.j.error(F)}return null}validate(z,N){let F=!0;const q=(0,i.validateExtensionManifest)(N.productVersion,N.productDate,N.location,z.manifest,z.isBuiltin);for(const[Q,oe]of q)Q===v.default.Error&&(F=!1,this.j.error(this.t(N.location,oe)));return z.isValid=F,z.validations=q,z}async scanExtensionManifest(z){const N=(0,u.joinPath)(z,"package.json");let F;try{F=(await this.i.readFile(N)).value.toString()}catch(Q){return(0,r.toFileOperationResult)(Q)!==1&&this.j.error(this.t(z,(0,p.localize)(0,null,N.path,Q.message))),null}let q;try{q=JSON.parse(F)}catch{const oe=[];(0,P.parse)(F,oe);for(const x of oe)this.j.error(this.t(z,(0,p.localize)(1,null,N.path,x.offset,x.length,(0,g.getParseErrorMessage)(x.error))));return null}return(0,P.getNodeType)(q)!=="object"?(this.j.error(this.t(z,(0,p.localize)(2,null,N.path))),null):q}async n(z,N,F){const q=await this.p(z,N,F);if(q)try{const Q=[],oe=await this.r(q.default,Q);if(Q.length>0)return Q.forEach(D=>{this.j.error(this.t(z,(0,p.localize)(3,null,q.default?.path,(0,g.getParseErrorMessage)(D.error))))}),N;if((0,P.getNodeType)(q)!=="object")return this.j.error(this.t(z,(0,p.localize)(4,null,q.default?.path))),N;const x=q.values||Object.create(null);return(0,T.localizeManifest)(N,x,oe)}catch{}return N}async p(z,N,F){const q=(0,u.joinPath)(z,"package.nls.json"),Q=(O,W)=>{W.forEach(j=>{this.j.error(this.t(z,(0,p.localize)(5,null,O?.path,(0,g.getParseErrorMessage)(j.error))))})},oe=O=>{this.j.error(this.t(z,(0,p.localize)(6,null,O?.path)))},x=`${N.publisher}.${N.name}`,D=F.translations[x];if(D)try{const O=l.URI.file(D),W=(await this.i.readFile(O)).value.toString(),j=[],$=(0,P.parse)(W,j);return j.length>0?(Q(O,j),{values:void 0,default:q}):(0,P.getNodeType)($)!=="object"?(oe(O),{values:void 0,default:q}):{values:$.contents?$.contents.package:void 0,default:q}}catch{return{values:void 0,default:q}}else{if(!await this.i.exists(q))return;let W;try{W=await this.s(z,F)}catch{return}if(!W.localized)return{values:void 0,default:W.original};try{const j=(await this.i.readFile(W.localized)).value.toString(),$=[],Y=(0,P.parse)(j,$);return $.length>0?(Q(W.localized,$),{values:void 0,default:W.original}):(0,P.getNodeType)(Y)!=="object"?(oe(W.localized),{values:void 0,default:W.original}):{values:Y,default:W.original}}catch{return{values:void 0,default:W.original}}}}async r(z,N){if(z)try{const F=(await this.i.readFile(z)).value.toString();return(0,P.parse)(F,N)}catch{}}s(z,N){return new Promise((F,q)=>{const Q=oe=>{const x=(0,u.joinPath)(z,`package.nls.${oe}.json`);this.i.exists(x).then(D=>{D&&F({localized:x,original:(0,u.joinPath)(z,"package.nls.json")});const O=oe.lastIndexOf("-");O===-1?F({localized:(0,u.joinPath)(z,"package.nls.json"),original:null}):(oe=oe.substring(0,O),Q(oe))})};if(N.devMode||N.pseudo||!N.language)return F({localized:(0,u.joinPath)(z,"package.nls.json"),original:null});Q(N.language)})}t(z,N){return`[${z.path}]: ${N}`}};_=pe([ee(1,f.IExtensionsProfileScannerService),ee(2,L.IUriIdentityService),ee(3,r.IFileService),ee(4,a.ILogService)],_);let se=class extends _{constructor(z,N,F,q,Q,oe){super(N,F,q,Q,oe),this.y=z,this.v=this.B(new t.ThrottledDelayer(3e3)),this.w=this.B(new c.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(z){const N=await this.z();if(this.u=z,N&&N.input&&G.equals(N.input,this.u))return this.v.trigger(()=>this.D()),N.result.map(q=>(q.location=l.URI.revive(q.location),q));const F=await super.scanExtensions(z);return await this.C({input:z,result:F}),F}async z(){try{const z=await this.i.readFile(this.y),N=JSON.parse(z.value.toString());return{result:N.result,input:(0,s.revive)(N.input)}}catch(z){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,A.getErrorMessage)(z))}return null}async C(z){try{await this.i.writeFile(this.y,R.VSBuffer.fromString(JSON.stringify(z)))}catch(N){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,A.getErrorMessage)(N))}}async D(){if(!this.u)return;const z=await this.z();if(!z)return;const N=z.result,F=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!C.equals(F,N))try{await this.i.del(this.y),this.w.fire()}catch(q){this.j.error(q)}}};se=pe([ee(2,f.IExtensionsProfileScannerService),ee(3,L.IUriIdentityService),ee(4,r.IFileService),ee(5,a.ILogService)],se);function ce(ue,z){const N=(0,I.getExtensionId)(ue.manifest.publisher,ue.manifest.name);return{id:N,identifier:new m.ExtensionIdentifier(N),isBuiltin:ue.type===0,isUserBuiltin:ue.type===1&&ue.isBuiltin,isUnderDevelopment:z,extensionLocation:ue.location,uuid:ue.identifier.uuid,targetPlatform:ue.targetPlatform,...ue.manifest}}e.toExtensionDescription=ce;class X extends V{constructor(z,N,F,q,Q,oe,x,D,O,W,j,$){super(z,N,(0,u.joinPath)(F,".vscode-oss-dev","extensions","control.json"),(0,u.joinPath)(q,m.MANIFEST_CACHE_FOLDER),Q,oe,x,D,O,W,j,$),this.L=(async()=>{if(y.translationsConfigFile)try{const Y=await this.r.readFile(l.URI.file(y.translationsConfigFile));return JSON.parse(Y.value.toString())}catch{}return Object.create(null)})()}f(z){return this.L}}e.NativeExtensionsScannerService=X}),define(ie[259],re([0,1,7,35,92,117,16,5,6,19,42,38]),function(H,e,E,t,C,R,A,P,g,w,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let y=class extends R.NativeExtensionsScannerService{constructor(d,v,h,l,p,k,I,m){super(E.URI.file(p.builtinExtensionsPath),E.URI.file(p.extensionsPath),p.userHome,E.URI.file(p.userDataPath),d,v,h,l,p,k,I,m)}};y=pe([ee(0,S.IUserDataProfilesService),ee(1,C.IExtensionsProfileScannerService),ee(2,A.IFileService),ee(3,g.ILogService),ee(4,t.INativeEnvironmentService),ee(5,w.IProductService),ee(6,b.IUriIdentityService),ee(7,P.IInstantiationService)],y),e.ExtensionsScannerService=y}),define(ie[260],re([0,1,13,2,14,9,4,60,7,29,41,35,6,38]),function(H,e,E,t,C,R,A,P,g,w,b,S,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let d=class extends t.Disposable{constructor(h,l,p){super(),this.c=h,this.f=p,this.a=P.TernarySearchTree.forPaths(!A.isLinux),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(h.appRoot),this.addValidFileRoot(h.extensionsPath),this.addValidFileRoot(l.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(h.workspaceStorageHome.fsPath),this.g()}g(){const{defaultSession:h}=E.session;h.protocol.registerFileProtocol(C.Schemas.vscodeFileResource,(l,p)=>this.i(l,p)),h.protocol.interceptFileProtocol(C.Schemas.file,(l,p)=>this.h(l,p)),this.B((0,t.toDisposable)(()=>{h.protocol.unregisterProtocol(C.Schemas.vscodeFileResource),h.protocol.uninterceptProtocol(C.Schemas.file)}))}addValidFileRoot(h){const l=(0,R.normalize)(h);return this.a.get(l)?t.Disposable.None:(this.a.set(l,!0),(0,t.toDisposable)(()=>this.a.delete(l)))}h(h,l){const p=g.URI.parse(h.url);return this.f.error(`Refused to load resource ${p.fsPath} from ${C.Schemas.file}: protocol (original URL: ${h.url})`),l({error:-3})}i(h,l){const p=this.j(h);let k;return this.c.crossOriginIsolated&&((0,R.basename)(p)==="workbench.html"||(0,R.basename)(p)==="workbench-dev.html"?k=C.COI.CoopAndCoep:k=C.COI.getHeadersFromQuery(h.url)),this.a.findSubstr(p)?l({path:p,headers:k}):this.b.has((0,R.extname)(p).toLowerCase())?l({path:p}):(this.f.error(`${C.Schemas.vscodeFileResource}: Refused to load resource ${p} from ${C.Schemas.vscodeFileResource}: protocol (original URL: ${h.url})`),l({error:-3}))}j(h){const l=g.URI.parse(h.url),p=C.FileAccess.uriToFileUri(l);return(0,R.normalize)(p.fsPath)}createIPCObjectUrl(){let h;const l=g.URI.from({scheme:"vscode",path:(0,w.generateUuid)()}),p=l.toString(),k=async()=>h;return b.validatedIpcMain.handle(p,k),this.f.trace(`IPC Object URL: Registered new channel ${p}.`),{resource:l,update:I=>h=I,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${p}.`),b.validatedIpcMain.removeHandler(p)}}}};d=pe([ee(0,S.INativeEnvironmentService),ee(1,u.IUserDataProfilesService),ee(2,y.ILogService)],d),e.ProtocolMainService=d}),define(ie[261],re([0,1,13,41,8,3,2,14,11,103,27,21,6,63,64,66,45,38,37]),function(H,e,E,t,C,R,A,P,g,w,b,S,y,u,d,v,h,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let k=class extends A.Disposable{constructor(m,i,r,n,a,o,c,s,f){super(),this.g=m,this.h=i,this.i=r,this.j=n,this.k=a,this.l=o,this.m=c,this.n=s,this.p=f,this.a=new C.Barrier,this.b=void 0,this.c=void 0,this.f=this.B(new R.Emitter),this.onDidError=R.Event.buffer(this.f.event),this.w=void 0,this.y=void 0,this.r()}r(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(m,i)=>this.s(m,i)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(m,i)=>this.t(m,i)),this.B(this.k.onWillShutdown(()=>this.u()))}async s(m,i){this.l.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.a.isOpen()||this.a.open(),await this.whenReady();const r=await this.connect();if(m.sender.isDestroyed())return r.close();m.sender.postMessage("vscode:createSharedProcessMessageChannelResult",i,[r])}t(m,i){this.l.trace("SharedProcess: onWorkerConnection",i);const r=new A.DisposableStore,n=o=>{!this.F()||(this.l.trace(`SharedProcess: disposing worker (reason: '${o}')`,i),r.dispose(),this.v("vscode:electron-main->shared-process=disposeWorker",i))},a=E.BrowserWindow.fromId(i.reply.windowId);if(!a||a.isDestroyed()||a.webContents.isDestroyed()||!i.reply.channel){n("unavailable");return}r.add(R.Event.filter(this.k.onWillLoadWindow,o=>o.window.win===a)(()=>n("load"))),r.add(R.Event.fromNodeEventEmitter(a,"closed")(()=>n("closed"))),a.webContents.postMessage(i.reply.channel,i.reply.nonce,m.ports)}u(){const m=this.b;!m||(this.v("vscode:electron-main->shared-process=exit"),this.c&&(m.removeListener("close",this.c),this.c=void 0),setTimeout(()=>{try{m.close()}catch{}this.b=void 0},0))}v(m,...i){if(!this.F()){this.l.warn(`Sending IPC message to channel '${m}' for shared process window that is destroyed`);return}try{this.b?.webContents.send(m,...i)}catch(r){this.l.warn(`Error sending IPC message to channel '${m}' of shared process: ${(0,h.toErrorMessage)(r)}`)}}whenReady(){return this.w||(this.w=new Promise(m=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.l.trace("SharedProcess: Overall ready"),m()}))),this.w}get z(){return this.y||(this.y=(async()=>{await this.a.wait(),this.C(),this.D(),await new Promise(m=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.l.trace("SharedProcess: IPC ready"),m()}))})()),this.y}C(){const m=this.B(this.p.createIPCObjectUrl());this.b=new E.BrowserWindow({show:!1,backgroundColor:this.n.getBackgroundColor(),webPreferences:{preload:P.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${m.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.i.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),m.update({machineId:this.g,windowId:this.b.id,appRoot:this.i.appRoot,codeCachePath:this.i.codeCachePath,profiles:this.j.profiles,userEnv:this.h,args:this.i.args,logLevel:this.l.getLevel(),product:u.default,policiesData:this.m.serialize()}),this.b.loadURL(P.FileAccess.asBrowserUri(`vs/code/electron-browser/sharedProcess/sharedProcess${this.i.isBuilt?"":"-dev"}.html`).toString(!0))}D(){!this.b||(this.c=m=>{this.l.trace("SharedProcess#close prevented"),m.preventDefault(),this.b?.isVisible()&&this.b.hide()},this.b.on("close",this.c),this.b.webContents.on("render-process-gone",(m,i)=>this.f.fire({type:2,details:i})),this.b.on("unresponsive",()=>this.f.fire({type:1})),this.b.webContents.on("did-fail-load",(m,i,r)=>this.f.fire({type:3,details:{reason:r,exitCode:i}})))}async connect(){await this.z;const m=(0,g.assertIsDefined)(this.b);return(0,w.connect)(m)}async toggle(){await this.z,this.b&&(this.b.isVisible()?(this.b.webContents.closeDevTools(),this.b.hide()):(this.b.show(),this.b.webContents.openDevTools()))}isVisible(){return this.b?.isVisible()??!1}F(){const m=this.b;return m?!m.isDestroyed()&&!m.webContents.isDestroyed():!1}};k=pe([ee(2,b.IEnvironmentMainService),ee(3,l.IUserDataProfilesService),ee(4,S.ILifecycleMainService),ee(5,y.ILogService),ee(6,p.IPolicyService),ee(7,v.IThemeMainService),ee(8,d.IProtocolMainService)],k),e.SharedProcess=k}),define(ie[93],re([0,1,8,3,2,73,11,104,5,38]),function(H,e,E,t,C,R,A,P,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,g.createDecorator)("storageService");var b;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(b=e.WillSaveStateReason||(e.WillSaveStateReason={}));var S;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(S=e.StorageScope||(e.StorageScope={}));var y;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(y=e.StorageTarget||(e.StorageTarget={}));function u(p){const k=p.get(e.TARGET_KEY);if(k)try{return JSON.parse(k)}catch{}return Object.create(null)}e.loadKeyTargets=u;class d extends C.Disposable{constructor(k={flushInterval:d.a}){super(),this.j=k,this.b=this.B(new t.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new t.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new t.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new E.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new C.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,E.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,C.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.J()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(k,I){if(I===e.TARGET_KEY){switch(k){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:k})}else this.b.fire({scope:k,key:I,target:this.F(k)[I]})}r(k){this.f.fire({reason:k})}get(k,I,m){return this.L(I)?.get(k,m)}getBoolean(k,I,m){return this.L(I)?.getBoolean(k,m)}getNumber(k,I,m){return this.L(I)?.getNumber(k,m)}store(k,I,m,i){if((0,A.isUndefinedOrNull)(I)){this.remove(k,m);return}this.t(()=>{this.u(k,m,i),this.L(m)?.set(k,I)})}remove(k,I){this.t(()=>{this.u(k,I,void 0),this.L(I)?.delete(k)})}t(k){this.b.pause(),this.c.pause();try{k()}finally{this.b.resume(),this.c.resume()}}keys(k,I){const m=[],i=this.F(k);for(const r of Object.keys(i))i[r]===I&&m.push(r);return m}u(k,I,m){const i=this.F(I);typeof m=="number"?i[k]!==m&&(i[k]=m,this.L(I)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[k]=="number"&&(delete i[k],this.L(I)?.set(e.TARGET_KEY,JSON.stringify(i)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(k){switch(k){case-1:return this.D;case 0:return this.z;default:return this.w}}G(k){const I=this.L(k);return I?u(I):Object.create(null)}isNew(k){return this.getBoolean(e.IS_NEW_KEY,k)===!0}async flush(k=b.NONE){this.f.fire({reason:k});const I=this.L(-1),m=this.L(0),i=this.L(1);switch(k){case b.NONE:await E.Promises.settled([I?.whenFlushed()??Promise.resolve(),m?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await E.Promises.settled([I?.flush(0)??Promise.resolve(),m?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const k=this.L(-1)?.items??new Map,I=this.L(0)?.items??new Map,m=this.L(1)?.items??new Map;return l(k,I,m,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(k,I){return this.r(b.NONE),(0,w.isUserDataProfile)(k)?this.N(k,I):this.O(k,I)}H(k,I){return!(k.id===I.id||v(I)&&v(k))}I(k,I,m,i){this.t(()=>{if(i)for(const[r,n]of k)I.set(r,n);else{const r=new Set;for(const[n,a]of k)r.add(n),I.get(n)!==a&&this.n(m,n);for(const[n]of I.items)r.has(n)||this.n(m,n)}})}}e.AbstractStorageService=d,d.a=60*1e3;function v(p){return p.isDefault||!!p.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=v;class h extends d{constructor(){super(),this.p=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(k=>this.n(1,k))),this.B(this.P.onDidChangeStorage(k=>this.n(0,k))),this.B(this.p.onDidChangeStorage(k=>this.n(-1,k)))}L(k){switch(k){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(k){switch(k){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(k){return!1}}e.InMemoryStorageService=h;async function l(p,k,I,m,i,r){const n=U=>{try{return JSON.parse(U)}catch{return U}},a=new Map,o=new Map;p.forEach((U,K)=>{a.set(K,U),o.set(K,n(U))});const c=new Map,s=new Map;k.forEach((U,K)=>{c.set(K,U),s.set(K,n(U))});const f=new Map,M=new Map;I.forEach((U,K)=>{f.set(K,U),M.set(K,n(U))}),console.group(m!==i?`Storage: Application (path: ${m})`:`Storage: Application & Profile (path: ${m}, default profile)`);const L=[];if(a.forEach((U,K)=>{L.push({key:K,value:U})}),console.table(L),console.groupEnd(),console.log(o),m!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const U=[];c.forEach((K,V)=>{U.push({key:V,value:K})}),console.table(U),console.groupEnd(),console.log(s)}console.group(`Storage: Workspace (path: ${r})`);const T=[];f.forEach((U,K)=>{T.push({key:K,value:U})}),console.table(T),console.groupEnd(),console.log(M)}e.logStorage=l}),define(ie[262],re([0,1,24,8,3,2,9,81,7,23,104,148,6,93,31,28]),function(H,e,E,t,C,R,A,P,g,w,b,S,y,u,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class h extends R.Disposable{get storage(){return this.f}constructor(r,n){super(),this.j=r,this.k=n,this.b=this.B(new C.Emitter),this.onDidChangeStorage=this.b.event,this.c=this.B(new C.Emitter),this.onDidCloseStorage=this.c.event,this.f=new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY}),this.g=void 0,this.h=new t.DeferredPromise,this.whenInit=this.h.p,this.i=b.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.i===b.StorageState.None)try{const r=await this.n();this.f.dispose(),this.f=r,this.B(r.onDidChangeStorage(a=>this.b.fire({key:a}))),await this.m(r);const n=r.getBoolean(u.IS_NEW_KEY);n===void 0?r.set(u.IS_NEW_KEY,!0):n&&r.set(u.IS_NEW_KEY,!1)}catch(r){this.j.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.i=b.StorageState.Initialized,this.h.complete()}})()),this.g}l(){return{logTrace:this.j.getLevel()===y.LogLevel.Trace?r=>this.j.trace(r):void 0,logError:r=>this.j.error(r)}}m(r){return r.init()}get items(){return this.f.items}get(r,n){return this.f.get(r,n)}set(r,n){return this.f.set(r,n)}delete(r){return this.f.delete(r)}async close(){const r=new P.StopWatch(!1);await this.s(),r.stop(),r.elapsed()>h.a&&await this.r(r),this.c.fire()}async r(r){if(!!this.path)try{const n=(0,E.top)(Array.from(this.f.items.entries()).map(([o,c])=>({key:o,length:c.length})),(o,c)=>c.length-o.length,5).map(o=>`${o.key}:${o.length}`).join(", "),a=(await this.k.stat(g.URI.file(this.path))).size;this.j.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${a}b, Large Keys: ${n}`)}catch(n){this.j.error("[storage main] figuring out stats for slow DB on close() resulted in an error",n)}}async s(){this.g&&await this.g,this.i=b.StorageState.Closed,await this.f.close()}}h.a=2e3;class l extends h{get path(){if(!this.v.useInMemoryStorage)return(0,A.join)(this.u.globalStorageHome.fsPath,l.t)}constructor(r,n,a,o){super(a,o),this.u=r,this.v=n}async n(){return new b.Storage(new S.SQLiteStorageDatabase(this.path??S.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.l()}),this.path?void 0:{hint:b.StorageHint.STORAGE_IN_MEMORY})}}l.t="state.vscdb";class p extends l{constructor(r,n,a,o){super(r,n,a,o)}}e.ProfileStorageMain=p;class k extends l{constructor(r,n,a,o){super(n.defaultProfile,r,a,o)}async m(r){await super.m(r),this.z(r)}z(r){r.get(d.firstSessionDateStorageKey,void 0)===void 0&&r.set(d.firstSessionDateStorageKey,new Date().toUTCString());const a=r.get(d.currentSessionDateStorageKey,void 0),o=new Date().toUTCString();r.set(d.lastSessionDateStorageKey,typeof a>"u"?null:a),r.set(d.currentSessionDateStorageKey,o)}}e.ApplicationStorageMain=k;class I extends h{get path(){if(!this.w.useInMemoryStorage)return(0,A.join)(this.y.workspaceStorageHome.fsPath,this.v.id,I.t)}constructor(r,n,a,o,c){super(a,c),this.v=r,this.w=n,this.y=o}async n(){const{storageFilePath:r,wasCreated:n}=await this.C();return new b.Storage(new S.SQLiteStorageDatabase(r,{logging:this.l()}),{hint:this.w.useInMemoryStorage?b.StorageHint.STORAGE_IN_MEMORY:n?b.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async C(){if(this.w.useInMemoryStorage)return{storageFilePath:S.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const r=(0,A.join)(this.y.workspaceStorageHome.fsPath,this.v.id),n=(0,A.join)(r,I.t);return await w.Promises.exists(r)?{storageFilePath:n,wasCreated:!1}:(await w.Promises.mkdir(r,{recursive:!0}),this.D(r),{storageFilePath:n,wasCreated:!0})}async D(r){let n;if((0,v.isSingleFolderWorkspaceIdentifier)(this.v)?n={folder:this.v.uri.toString()}:(0,v.isWorkspaceIdentifier)(this.v)&&(n={workspace:this.v.configPath.toString()}),n)try{const a=(0,A.join)(r,I.u);await w.Promises.exists(a)||await w.Promises.writeFile(a,JSON.stringify(n,void 0,2))}catch(a){this.j.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${a}`)}}}e.WorkspaceStorageMain=I,I.t="state.vscdb",I.u="workspace.json";class m extends h{get path(){}async n(){return new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=m}),define(ie[263],re([0,1,3,2,93]),function(H,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class R extends t.Disposable{constructor(P,g,w){super(),this.b=P,this.c=g,this.f=w;const b=this.B(new t.MutableDisposable);this.a=this.B(new E.Emitter({onWillAddFirstListener:()=>b.value=this.g(),onDidRemoveLastListener:()=>b.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const P=new t.DisposableStore;return P.add(E.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(g,w)=>(g?g.push(w.key):g=[w.key],g),100)(g=>this.h(g))),P.add(E.Event.debounce(this.b.onDidChangeProfileStorage,(g,w)=>{g||(g=new Map);let b=g.get(w.profile.id);return b||g.set(w.profile.id,b={profile:w.profile,keys:[],storage:w.storage}),b.keys.push(w.key),g},100)(g=>this.i(g))),P}h(P){const g=P.includes(C.TARGET_KEY)?[this.c.defaultProfile]:[],w=[];if(P=P.filter(b=>b!==C.TARGET_KEY),P.length){const b=(0,C.loadKeyTargets)(this.b.applicationStorage.storage);w.push({profile:this.c.defaultProfile,changes:P.map(S=>({key:S,scope:0,target:b[S]}))})}this.j(g,w)}i(P){const g=[],w=new Map;for(const[b,S]of P.entries()){S.keys.includes(C.TARGET_KEY)&&g.push(S.profile);const y=S.keys.filter(u=>u!==C.TARGET_KEY);if(y.length){const u=(0,C.loadKeyTargets)(S.storage.storage);w.set(b,{profile:S.profile,changes:y.map(d=>({key:d,scope:0,target:u[d]}))})}}this.j(g,[...w.values()])}j(P,g){(P.length||g.length)&&this.a.fire({valueChanges:g,targetChanges:P})}listen(P,g,w){switch(g){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${g}`)}async call(P,g){throw new Error(`Call not found: ${g}`)}}e.ProfileStorageChangesListenerChannel=R}),define(ie[264],re([0,1,69,7,35,16,6,230,42,38]),function(H,e,E,t,C,R,A,P,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.ServerUserDataProfilesService=void 0;let b=class extends w.UserDataProfilesService{constructor(u,d,v,h){super(d,v,u,h),this.a=d}L(){return this.r.extUri.joinPath(t.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};b=pe([ee(0,g.IUriIdentityService),ee(1,C.INativeEnvironmentService),ee(2,R.IFileService),ee(3,A.ILogService)],b),e.ServerUserDataProfilesService=b;let S=class Lt extends b{constructor(u,d,v,h,l){super(d,v,h,l),this.N=u}G(){return(0,E.revive)(this.N.getItem(Lt.b,[]))}I(){return(0,E.revive)(this.N.getItem(Lt.c,{}))}L(){return this.r.extUri.joinPath(t.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};S=pe([ee(0,P.IStateService),ee(1,g.IUriIdentityService),ee(2,C.INativeEnvironmentService),ee(3,R.IFileService),ee(4,A.ILogService)],S),e.UserDataProfilesService=S}),define(ie[52],re([0,1,7,35,16,5,6,36,42,38,264]),function(H,e,E,t,C,R,A,P,g,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,R.refineServiceDecorator)(w.IUserDataProfilesService);let S=class dt extends b.UserDataProfilesService{constructor(u,d,v,h,l){super(u,d,v,h,l),this.R=u}setEnablement(u){super.setEnablement(u),this.f||(this.H([]),this.J({}))}getAssociatedEmptyWindows(){const u=[];for(const d of this.u.emptyWindows.keys())u.push({id:d});return u}H(u){u.length?this.R.setItem(dt.b,u):this.R.removeItem(dt.b)}J(u){u.emptyWindows||u.workspaces?this.R.setItem(dt.c,u):this.R.removeItem(dt.c)}I(){const u="workspaceAndProfileInfo",d=this.R.getItem(u,void 0);if(d){this.R.removeItem(u);const v=d.reduce((h,{workspace:l,profile:p})=>(h[E.URI.revive(l).toString()]=E.URI.revive(p).toString(),h),{});this.R.setItem(dt.c,{workspaces:v})}return super.I()}};S=pe([ee(0,P.IStateMainService),ee(1,g.IUriIdentityService),ee(2,t.INativeEnvironmentService),ee(3,C.IFileService),ee(4,A.ILogService)],S),e.UserDataProfilesMainService=S}),define(ie[75],re([0,1,7,50,3,2,35,16,5,21,6,93,262,38,52,42]),function(H,e,E,t,C,R,A,P,g,w,b,S,y,u,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,g.createDecorator)("storageMainService");let h=class extends R.Disposable{constructor(k,I,m,i,r,n){super(),this.c=k,this.f=I,this.g=m,this.h=i,this.i=r,this.j=n,this.a=void 0,this.b=this.B(new C.Emitter),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.m(),this.n=new Map,this.r=new Map,this.l()}k(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}l(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(k=>{k.window.profile&&this.profileStorage(k.window.profile).init(),k.workspace&&this.workspaceStorage(k.workspace).init()})),this.B(this.h.onWillShutdown(k=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=k.reason,k.join(this.applicationStorage.close());for(const[,I]of this.n)k.join(I.close());for(const[,I]of this.r)k.join(I.close())})),this.B(this.g.onWillCreateProfile(k=>{k.join((async()=>{await this.i.exists(k.profile.globalStorageHome)||await this.i.createFolder(k.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(k=>{const I=this.n.get(k.profile.id);I&&k.join(I.close())}))}m(){this.c.trace("StorageMainService: creating application storage");const k=new y.ApplicationStorageMain(this.k(),this.g,this.c,this.i);return(0,t.once)(k.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")}),k}profileStorage(k){if((0,S.isProfileUsingDefaultStorage)(k))return this.applicationStorage;let I=this.n.get(k.id);if(!I){this.c.trace(`StorageMainService: creating profile storage (${k.name})`),I=this.p(k),this.n.set(k.id,I);const m=this.B(I.onDidChangeStorage(i=>this.b.fire({...i,storage:I,profile:k})));(0,t.once)(I.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${k.name})`),this.n.delete(k.id),m.dispose()})}return I}p(k){return this.a===2?new y.InMemoryStorageMain(this.c,this.i):new y.ProfileStorageMain(k,this.k(),this.c,this.i)}workspaceStorage(k){let I=this.r.get(k.id);return I||(this.c.trace(`StorageMainService: creating workspace storage (${k.id})`),I=this.s(k),this.r.set(k.id,I),(0,t.once)(I.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${k.id})`),this.r.delete(k.id)})),I}s(k){return this.a===2?new y.InMemoryStorageMain(this.c,this.i):new y.WorkspaceStorageMain(k,this.k(),this.c,this.f,this.i)}isUsed(k){const I=E.URI.file(k);for(const m of[this.applicationStorage,...this.n.values(),...this.r.values()])if(!!m.path&&this.j.extUri.isEqualOrParent(E.URI.file(m.path),I))return!0;return!1}};h=pe([ee(0,b.ILogService),ee(1,A.IEnvironmentService),ee(2,d.IUserDataProfilesMainService),ee(3,w.ILifecycleMainService),ee(4,P.IFileService),ee(5,v.IUriIdentityService)],h),e.StorageMainService=h,e.IApplicationStorageMainService=(0,g.createDecorator)("applicationStorageMainService");let l=class extends S.AbstractStorageService{constructor(k,I){super(),this.p=k,this.s=I,this.whenReady=this.s.applicationStorage.whenInit}J(){return this.s.applicationStorage.whenInit}L(k){if(k===-1)return this.s.applicationStorage.storage}M(k){if(k===-1)return this.p.defaultProfile.globalStorageHome.fsPath}l(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}N(){throw new Error("Switching storage profile is unsupported from main process")}O(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};l=pe([ee(0,u.IUserDataProfilesService),ee(1,e.IStorageMainService)],l),e.ApplicationStorageMainService=l}),define(ie[265],re([0,1,2,21,52,28,8,32]),function(H,e,E,t,C,R,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let g=class extends E.Disposable{constructor(b,S,y){super(),this.a=S,this.b=y,this.B(b.onWillLoadWindow(u=>{u.reason===2&&this.c(u.window)})),this.B(b.onBeforeCloseWindow(u=>this.c(u))),this.B(new A.RunOnceScheduler(()=>this.g(),30*1e3)).schedule()}async c(b){const S=this.f(b),y=this.a.getProfileForWorkspace(S);y&&((0,R.isEmptyWorkspaceIdentifier)(S)||y.isTransient)&&(this.a.unsetWorkspace(S,y.isTransient),y.isTransient&&await this.a.cleanUpTransientProfiles())}f(b){return b.openedWorkspace??(0,R.toWorkspaceIdentifier)(b.backupPath,b.isExtensionDevelopmentHost)}g(){const b=this.a.getAssociatedEmptyWindows();if(b.length===0)return;const S=this.b.getWindows().map(y=>this.f(y));for(const y of b)S.some(u=>u.id===y.id)||this.a.unsetWorkspace(y,!1)}};g=pe([ee(0,t.ILifecycleMainService),ee(1,C.IUserDataProfilesMainService),ee(2,P.IWindowsMainService)],g),e.UserDataProfilesHandler=g}),define(ie[118],re([0,1,20,7,28]),function(H,e,E,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function R(g,w,b){for(const y of g){const u=y.openedWorkspace;if((0,C.isWorkspaceIdentifier)(u)){const d=await b(u);if(d){if(d.folders.some(v=>E.extUriBiasedIgnorePathCase.isEqualOrParent(w,v.uri)))return y}else if(E.extUriBiasedIgnorePathCase.isEqualOrParent(w,u.configPath))return y}}const S=g.filter(y=>(0,C.isSingleFolderWorkspaceIdentifier)(y.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqualOrParent(w,y.openedWorkspace.uri));if(S.length)return S.sort((y,u)=>-(y.openedWorkspace.uri.path.length-u.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=R;function A(g,w){for(const b of g)if((0,C.isWorkspaceIdentifier)(b.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(b.openedWorkspace.configPath,w)||(0,C.isSingleFolderWorkspaceIdentifier)(b.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(b.openedWorkspace.uri,w))return b}e.findWindowOnWorkspaceOrFolder=A;function P(g,w){const b=S=>w.some(y=>E.extUriBiasedIgnorePathCase.isEqual(t.URI.file(y),t.URI.file(S)));for(const S of g)if(S.config?.extensionDevelopmentPath?.some(y=>b(y)))return S}e.findWindowOnExtensionDevelopmentPath=P}),define(ie[266],re([0,1,13,2,4,20,7,18,21,6,36,32,116,28]),function(H,e,E,t,C,R,A,P,g,w,b,S,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let d=class Ot extends t.Disposable{get state(){return this.b}constructor(I,m,i,r,n){super(),this.g=I,this.h=m,this.i=i,this.j=r,this.k=n,this.b=v(this.h.getItem(Ot.a)),this.c=void 0,this.f=!1,this.l()}l(){E.app.on("browser-window-blur",()=>{this.f||this.n()}),this.i.onBeforeCloseWindow(I=>this.p(I)),this.i.onBeforeShutdown(()=>this.m()),this.g.onDidChangeWindowsCount(I=>{I.newCount-I.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(I=>this.p(I))}m(){this.f=!0,this.n()}n(){const I=new Set,m={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!m.lastActiveWindow){let n=this.g.getLastActiveWindow();(!n||n.isExtensionDevelopmentHost)&&(n=this.g.getWindows().find(a=>!a.isExtensionDevelopmentHost)),n&&(m.lastActiveWindow=this.r(n),m.lastActiveWindow.uiState.mode===3&&I.add(m.lastActiveWindow.uiState.display))}const i=this.g.getWindows().find(n=>n.isExtensionDevelopmentHost&&!n.isExtensionTestHost);i&&(m.lastPluginDevelopmentHostWindow=this.r(i),m.lastPluginDevelopmentHostWindow.uiState.mode===3&&(I.has(m.lastPluginDevelopmentHostWindow.uiState.display)?C.isMacintosh&&!i.win?.isSimpleFullScreen()&&(m.lastPluginDevelopmentHostWindow.uiState.mode=1):I.add(m.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(m.openedWindows=this.g.getWindows().filter(n=>!n.isExtensionDevelopmentHost).map(n=>{const a=this.r(n);return a.uiState.mode===3&&(I.has(a.uiState.display)?C.isMacintosh&&a.windowId!==m.lastActiveWindow?.windowId&&!n.win?.isSimpleFullScreen()&&(a.uiState.mode=1):I.add(a.uiState.display)),a}));const r=l(m);this.h.setItem(Ot.a,r),this.f&&this.j.trace("[WindowsStateHandler] onBeforeShutdown",r)}p(I){if(this.i.quitRequested)return;const m=this.r(I);I.isExtensionDevelopmentHost&&!I.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=m:!I.isExtensionDevelopmentHost&&I.openedWorkspace&&this.b.openedWindows.forEach(i=>{const r=(0,u.isWorkspaceIdentifier)(I.openedWorkspace)&&i.workspace?.id===I.openedWorkspace.id,n=(0,u.isSingleFolderWorkspaceIdentifier)(I.openedWorkspace)&&i.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(i.folderUri,I.openedWorkspace.uri);(r||n)&&(i.uiState=m.uiState)}),this.g.getWindowCount()===1&&(this.c=m)}r(I){return{windowId:I.id,workspace:(0,u.isWorkspaceIdentifier)(I.openedWorkspace)?I.openedWorkspace:void 0,folderUri:(0,u.isSingleFolderWorkspaceIdentifier)(I.openedWorkspace)?I.openedWorkspace.uri:void 0,backupPath:I.backupPath,remoteAuthority:I.remoteAuthority,uiState:I.serializeWindowState()}}getNewWindowState(I){const m=this.s(I),i=this.k.getValue("window");if(m.mode===3){let r;m.hasDefaultState?r=!!(i?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(i.newWindowDimensions)>=0):r=!!(this.i.wasRestarted||i?.restoreFullscreen),r||(m.mode=1)}return m}s(I){const m=this.g.getLastActiveWindow();if(!I.extensionTestsPath){if(!!I.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const c=I.workspace;if((0,u.isWorkspaceIdentifier)(c)){const f=this.state.openedWindows.filter(M=>M.workspace&&M.workspace.id===c.id).map(M=>M.uiState);if(f.length)return f[0]}if((0,u.isSingleFolderWorkspaceIdentifier)(c)){const f=this.state.openedWindows.filter(M=>M.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(M.folderUri,c.uri)).map(M=>M.uiState);if(f.length)return f[0]}else if(I.backupPath){const f=this.state.openedWindows.filter(M=>M.backupPath===I.backupPath).map(M=>M.uiState);if(f.length)return f[0]}const s=this.c||this.state.lastActiveWindow;if(!m&&s)return s.uiState}let i;const r=E.screen.getAllDisplays();if(r.length===1)i=r[0];else{if(C.isMacintosh){const c=E.screen.getCursorScreenPoint();i=E.screen.getDisplayNearestPoint(c)}!i&&m&&(i=E.screen.getDisplayMatching(m.getBounds())),i||(i=E.screen.getPrimaryDisplay()||r[0])}let n=(0,y.defaultWindowState)();n.x=Math.round(i.bounds.x+i.bounds.width/2-n.width/2),n.y=Math.round(i.bounds.y+i.bounds.height/2-n.height/2);const a=this.k.getValue("window");let o=!0;if(a?.newWindowDimensions){if(a.newWindowDimensions==="maximized")n.mode=0,o=!1;else if(a.newWindowDimensions==="fullscreen")n.mode=3,o=!1;else if((a.newWindowDimensions==="inherit"||a.newWindowDimensions==="offset")&&m){const c=m.serializeWindowState();c.mode===3?n.mode=3:n=c,o=n.mode!==3&&a.newWindowDimensions==="offset"}}return o&&(n=this.t(n)),n.hasDefaultState=!0,n}t(I){if(this.g.getWindows().length===0)return I;I.x=typeof I.x=="number"?I.x:0,I.y=typeof I.y=="number"?I.y:0;const m=this.g.getWindows().map(i=>i.getBounds());for(;m.some(i=>i.x===I.x||i.y===I.y);)I.x+=30,I.y+=30;return I}};d.a="windowsState",d=pe([ee(0,S.IWindowsMainService),ee(1,b.IStateMainService),ee(2,g.ILifecycleMainService),ee(3,w.ILogService),ee(4,P.IConfigurationService)],d),e.WindowsStateHandler=d;function v(k){const I={openedWindows:[]},m=k||{openedWindows:[]};return m.lastActiveWindow&&(I.lastActiveWindow=h(m.lastActiveWindow)),m.lastPluginDevelopmentHostWindow&&(I.lastPluginDevelopmentHostWindow=h(m.lastPluginDevelopmentHostWindow)),Array.isArray(m.openedWindows)&&(I.openedWindows=m.openedWindows.map(i=>h(i))),I}e.restoreWindowsState=v;function h(k){const I={uiState:k.uiState};return k.backupPath&&(I.backupPath=k.backupPath),k.remoteAuthority&&(I.remoteAuthority=k.remoteAuthority),k.folder&&(I.folderUri=A.URI.parse(k.folder)),k.workspaceIdentifier&&(I.workspace={id:k.workspaceIdentifier.id,configPath:A.URI.parse(k.workspaceIdentifier.configURIPath)}),I}function l(k){return{lastActiveWindow:k.lastActiveWindow&&p(k.lastActiveWindow),lastPluginDevelopmentHostWindow:k.lastPluginDevelopmentHostWindow&&p(k.lastPluginDevelopmentHostWindow),openedWindows:k.openedWindows.map(I=>p(I))}}e.getWindowsStateStoreData=l;function p(k){return{workspaceIdentifier:k.workspace&&{id:k.workspace.id,configURIPath:k.workspace.configPath.toString()},folder:k.folderUri&&k.folderUri.toString(),backupPath:k.backupPath,remoteAuthority:k.remoteAuthority,uiState:k.uiState}}}),define(ie[94],re([0,1,30,43,124,34,14,9,4,20,7,5,55,28]),function(H,e,E,t,C,R,A,P,g,w,b,S,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,S.createDecorator)("workspacesService");function d(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=d;function v(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=v;function h(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=h;function l(M){return p(M)||k(M)}e.isStoredWorkspaceFolder=l;function p(M){const L=M;return typeof L?.path=="string"&&(!L.name||typeof L.name=="string")}function k(M){const L=M;return typeof L?.uri=="string"&&(!L.name||typeof L.name=="string")}function I(M,L,T,U,K){if(M.scheme!==U.scheme)return{name:T,uri:M.toString(!0)};let V=L?void 0:K.relativePath(U,M);if(V!==void 0)V.length===0?V=".":g.isWindows&&(V=m(V));else if(M.scheme===A.Schemas.file)V=M.fsPath,g.isWindows&&(V=m(V));else if(K.isEqualAuthority(M.authority,U.authority))V=M.path;else return{name:T,uri:M.toString(!0)};return{name:T,path:V}}e.getStoredWorkspaceFolder=I;function m(M){return M=(0,R.normalizeDriveLetter)(M),(0,E.isUNC)(M)||(M=(0,E.toSlashes)(M)),M}function i(M,L,T){const U=[],K=new Set,V=T.dirname(L);for(const G of M){let _;if(p(G))G.path&&(_=T.resolvePath(V,G.path));else if(k(G))try{_=b.URI.parse(G.uri),_.path[0]!==P.posix.sep&&(_=_.with({path:P.posix.sep+_.path}))}catch(se){console.warn(se)}if(_){const se=T.getComparisonKey(_);if(!K.has(se)){K.add(se);const ce=G.name||T.basenameOrAuthority(_);U.push(new u.WorkspaceFolder({uri:_,name:ce,index:U.length},G))}}}return U}e.toWorkspaceFolders=i;function r(M,L,T,U,K){const V=n(L,M),G=K.dirname(L),_=K.dirname(U),se=[];for(const z of V.folders){const N=p(z)?K.resolvePath(G,z.path):b.URI.parse(z.uri);let F;T?F=!1:F=!p(z)||(0,P.isAbsolute)(z.path),se.push(I(N,F,z.name,_,K))}const ce={insertSpaces:!1,tabSize:4,eol:g.isLinux||g.isMacintosh?`
`:`\r
`},X=C.setProperty(M,["folders"],se,ce);let ue=C.applyEdits(M,X);return(0,w.isEqualAuthority)(V.remoteAuthority,(0,y.getRemoteAuthority)(U))&&(ue=C.applyEdits(ue,C.removeProperty(ue,["remoteAuthority"],ce))),ue}e.rewriteWorkspaceFileForNewLocation=r;function n(M,L){const T=t.parse(L);if(T&&Array.isArray(T.folders))T.folders=T.folders.filter(U=>l(U));else throw new Error(`${M} looks like an invalid workspace file.`);return T}function a(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function o(M){return typeof M.folderUri=="string"}function c(M){return typeof M.fileUri=="string"}function s(M,L){const T={workspaces:[],files:[]};if(M){const U=function(V,G){for(let _=0;_<V.length;_++)try{G(V[_],_)}catch(se){L.warn(`Error restoring recent entry ${JSON.stringify(V[_])}: ${se.toString()}. Skip entry.`)}},K=M;Array.isArray(K.entries)&&U(K.entries,V=>{const G=V.label,_=V.remoteAuthority;a(V)?T.workspaces.push({label:G,remoteAuthority:_,workspace:{id:V.workspace.id,configPath:b.URI.parse(V.workspace.configPath)}}):o(V)?T.workspaces.push({label:G,remoteAuthority:_,folderUri:b.URI.parse(V.folderUri)}):c(V)&&T.files.push({label:G,remoteAuthority:_,fileUri:b.URI.parse(V.fileUri)})})}return T}e.restoreRecentlyOpened=s;function f(M){const L={entries:[]};for(const T of M.workspaces)v(T)?L.entries.push({folderUri:T.folderUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority}):L.entries.push({workspace:{id:T.workspace.id,configPath:T.workspace.configPath.toString()},label:T.label,remoteAuthority:T.remoteAuthority});for(const T of M.files)L.entries.push({fileUri:T.fileUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority});return L}e.toStoreData=f}),define(ie[95],re([0,1,78,14,4,20]),function(H,e,E,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function A(w){function b(){let S=w.scheme===t.Schemas.file?(0,R.originalFSPath)(w):w.toString();return C.isLinux||(S=S.toLowerCase()),(0,E.createHash)("md5").update(S).digest("hex")}return{id:b(),configPath:w}}e.getWorkspaceIdentifier=A;function P(w,b){function S(){if(w.scheme!==t.Schemas.file)return(0,E.createHash)("md5").update(w.toString()).digest("hex");if(!b)return;let u;return C.isLinux?u=b.ino:C.isMacintosh?u=b.birthtime.getTime():C.isWindows&&(typeof b.birthtimeMs=="number"?u=Math.floor(b.birthtimeMs):u=b.birthtime.getTime()),(0,E.createHash)("md5").update(w.fsPath).update(u?String(u):"").digest("hex")}const y=S();if(typeof y=="string")return{id:y,uri:w}}e.getSingleFolderWorkspaceIdentifier=P;function g(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=g}),define(ie[267],re([0,1,78,30,14,9,4,20,23,178,18,27,36,16,6,177,28,95]),function(H,e,E,t,C,R,A,P,g,w,b,S,y,u,d,v,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let p=class Tt{constructor(I,m,i,r){this.j=I,this.k=m,this.l=i,this.m=r,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=P.extUriBiasedIgnorePathCase,this.i={isEqual:(n,a)=>(0,t.isEqual)(n,a,!A.isLinux)}}async initialize(){const I=this.m.getItem(Tt.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(I.emptyWindows),this.d=await this.u((0,w.deserializeWorkspaceInfos)(I)),this.e=await this.v((0,w.deserializeFolderInfos)(I)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==u.HotExitConfiguration.OFF}q(){return this.s()===u.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||u.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(I,m){this.d.some(r=>I.workspace.id===r.workspace.id)||(this.d.push(I),this.C());const i=(0,R.join)(this.c,I.workspace.id);return m?this.t(i,m).then(()=>i):i}async t(I,m){if(await g.Promises.exists(I)&&await this.z(I),await g.Promises.exists(m))try{await g.Promises.rename(m,I)}catch(i){this.l.error(`Backup: Could not move backup folder to new location: ${i.toString()}`)}}registerFolderBackup(I){return this.e.some(m=>this.h.isEqual(I.folderUri,m.folderUri))||(this.e.push(I),this.C()),(0,R.join)(this.c,this.D(I))}registerEmptyWindowBackup(I){return this.g.some(m=>!!m.backupFolder&&this.i.isEqual(m.backupFolder,I.backupFolder))||(this.g.push(I),this.C()),(0,R.join)(this.c,I.backupFolder)}async u(I){if(!Array.isArray(I))return[];const m=new Set,i=[];for(const r of I){const n=r.workspace;if(!(0,h.isWorkspaceIdentifier)(n))return[];if(!m.has(n.id)){m.add(n.id);const a=(0,R.join)(this.c,n.id);await this.B(a)?n.configPath.scheme!==C.Schemas.file||await g.Promises.exists(n.configPath.fsPath)?i.push(r):await this.z(a):await this.x(a)}}return i}async v(I){if(!Array.isArray(I))return[];const m=[],i=new Set;for(const r of I){const n=r.folderUri,a=this.h.getComparisonKey(n);if(!i.has(a)){i.add(a);const o=(0,R.join)(this.c,this.D(r));await this.B(o)?n.scheme!==C.Schemas.file||await g.Promises.exists(n.fsPath)?m.push(r):await this.z(o):await this.x(o)}}return m}async w(I){if(!Array.isArray(I))return[];const m=[],i=new Set;for(const r of I){const n=r.backupFolder;if(typeof n!="string")return[];if(!i.has(n)){i.add(n);const a=(0,R.join)(this.c,n);await this.B(a)?m.push(r):await this.x(a)}}return m}async x(I){try{await g.Promises.rm(I,g.RimRafMode.MOVE)}catch(m){this.l.error(`Backup: Could not delete stale backup: ${m.toString()}`)}}y(){let I=(0,l.createEmptyWorkspaceIdentifier)();for(;this.g.some(m=>!!m.backupFolder&&this.i.isEqual(m.backupFolder,I.id));)I=(0,l.createEmptyWorkspaceIdentifier)();return{backupFolder:I.id}}async z(I){const m=this.y(),i=(0,R.join)(this.c,m.backupFolder);try{await g.Promises.rename(I,i)}catch(r){return this.l.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.g.push(m),!0}async getDirtyWorkspaces(){const I=[];for(const m of this.d)await this.A(m)&&I.push(m);for(const m of this.e)await this.A(m)&&I.push(m);return I}A(I){let m;return(0,w.isEmptyWindowBackupInfo)(I)?m=(0,R.join)(this.c,I.backupFolder):(0,v.isFolderBackupInfo)(I)?m=(0,R.join)(this.c,this.D(I)):m=(0,R.join)(this.c,I.workspace.id),this.B(m)}async B(I){try{const m=await g.Promises.readdir(I);for(const i of m)try{if((await g.Promises.readdir((0,R.join)(I,i))).length>0)return!0}catch{}}catch{}return!1}C(){const I={workspaces:this.d.map(({workspace:m,remoteAuthority:i})=>{const r={id:m.id,configURIPath:m.configPath.toString()};return i&&(r.remoteAuthority=i),r}),folders:this.e.map(({folderUri:m,remoteAuthority:i})=>{const r={folderUri:m.toString()};return i&&(r.remoteAuthority=i),r}),emptyWindows:this.g.map(({backupFolder:m,remoteAuthority:i})=>{const r={backupFolder:m};return i&&(r.remoteAuthority=i),r})};this.m.setItem(Tt.a,I)}D(I){const m=I.folderUri;let i;return m.scheme===C.Schemas.file?i=A.isLinux?m.fsPath:m.fsPath.toLowerCase():i=m.toString().toLowerCase(),(0,E.createHash)("md5").update(i).digest("hex")}};p.a="backupWorkspaces",p=pe([ee(0,S.IEnvironmentMainService),ee(1,b.IConfigurationService),ee(2,d.ILogService),ee(3,y.IStateMainService)],p),e.BackupMainService=p}),define(ie[53],re([0,1,13,3,43,34,2,14,9,20,11,23,176,62,57,27,5,6,19,52,118,28,94,95]),function(H,e,E,t,C,R,A,P,g,w,b,S,y,u,d,v,h,l,p,k,I,m,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,h.createDecorator)("workspacesManagementMainService");let n=class extends A.Disposable{constructor(o,c,s,f,M,L){super(),this.g=o,this.h=c,this.i=s,this.j=f,this.k=M,this.l=L,this.a=this.B(new t.Emitter),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new t.Emitter),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const o=(await S.Promises.readdir(this.c.fsPath)).map(c=>(0,w.joinPath)(this.c,c,m.UNTITLED_WORKSPACE_NAME));for(const c of o){const s=(0,r.getWorkspaceIdentifier)(c),f=await this.resolveLocalWorkspace(c);f?this.f.push({workspace:s,remoteAuthority:f.remoteAuthority}):await this.deleteUntitledWorkspace(s)}}catch(o){o.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${o}).`)}}resolveLocalWorkspace(o){return this.m(o,c=>S.Promises.readFile(c,"utf8"))}m(o,c){if(!!this.n(o)&&o.scheme===P.Schemas.file)try{const s=c(o.fsPath);return s instanceof Promise?s.then(f=>this.p(o,f),f=>{}):this.p(o,s)}catch{return}}n(o){return(0,m.isUntitledWorkspace)(o,this.g)||(0,m.hasWorkspaceFileExtension)(o)}p(o,c){try{const s=this.r(o,c),f=(0,r.getWorkspaceIdentifier)(o);return{id:f.id,configPath:f.configPath,folders:(0,i.toWorkspaceFolders)(s.folders,f.configPath,w.extUriBiasedIgnorePathCase),remoteAuthority:s.remoteAuthority,transient:s.transient}}catch(s){this.h.warn(s.toString())}}r(o,c){const s=(0,C.parse)(c);if(s&&Array.isArray(s.folders))s.folders=s.folders.filter(f=>(0,i.isStoredWorkspaceFolder)(f));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return s}async createUntitledWorkspace(o,c){const{workspace:s,storedWorkspace:f}=this.s(o,c),M=s.configPath.fsPath;return await S.Promises.mkdir((0,g.dirname)(M),{recursive:!0}),await S.Promises.writeFile(M,JSON.stringify(f,null,"	")),this.f.push({workspace:s,remoteAuthority:c}),s}s(o=[],c){const s=(Date.now()+Math.round(Math.random()*1e3)).toString(),f=(0,w.joinPath)(this.c,s),M=(0,w.joinPath)(f,m.UNTITLED_WORKSPACE_NAME),L=[];for(const T of o)L.push((0,i.getStoredWorkspaceFolder)(T.uri,!0,T.name,f,w.extUriBiasedIgnorePathCase));return{workspace:(0,r.getWorkspaceIdentifier)(M),storedWorkspace:{folders:L,remoteAuthority:c}}}async getWorkspaceIdentifier(o){return(0,r.getWorkspaceIdentifier)(o)}isUntitledWorkspace(o){return(0,m.isUntitledWorkspace)(o.configPath,this.g)}async deleteUntitledWorkspace(o){!this.isUntitledWorkspace(o)||(await this.t(o),this.i.isEnabled()&&this.i.unsetWorkspace(o),this.a.fire(o))}async t(o){const c=(0,w.originalFSPath)(o.configPath);try{await S.Promises.rm((0,g.dirname)(c));const s=(0,g.join)(this.g.workspaceStorageHome.fsPath,o.id);await S.Promises.exists(s)&&await S.Promises.writeFile((0,g.join)(s,"obsolete"),""),this.f=this.f.filter(f=>f.workspace.id!==o.id)}catch(s){this.h.warn(`Unable to delete untitled workspace ${c} (${s}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(o,c,s){if(!o||!o.win||!o.isReady||!await this.u(o,c,s))return;const M=await this.v(o,(0,r.getWorkspaceIdentifier)(s));if(!!M)return this.b.fire({window:o,workspace:M.workspace}),M}async u(o,c,s){if(!s)return!0;if((0,m.isWorkspaceIdentifier)(o.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(o.openedWorkspace.configPath,s))return!1;if((0,I.findWindowOnWorkspaceOrFolder)(c,s)){const f={title:this.l.nameLong,type:"info",buttons:[(0,R.mnemonicButtonLabel)((0,y.localize)(0,null))],message:(0,y.localize)(1,null,(0,w.basename)(s)),detail:(0,y.localize)(2,null),noLink:!0,defaultId:0};return await this.k.showMessageBox(f,(0,b.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow())),!1}return!0}async v(o,c){if(!o.config)return;o.focus();let s;return o.config.extensionDevelopmentPath||(o.config.backupPath?s=await this.j.registerWorkspaceBackup({workspace:c,remoteAuthority:o.remoteAuthority},o.config.backupPath):s=this.j.registerWorkspaceBackup({workspace:c,remoteAuthority:o.remoteAuthority})),(0,m.isWorkspaceIdentifier)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=c,o.config.backupPath=s,{workspace:c,backupPath:s}}};n=pe([ee(0,v.IEnvironmentMainService),ee(1,l.ILogService),ee(2,k.IUserDataProfilesMainService),ee(3,u.IBackupMainService),ee(4,d.IDialogMainService),ee(5,p.IProductService)],n),e.WorkspacesManagementMainService=n}),define(ie[119],re([0,1,13,41,22,5,32,28,53,11,6]),function(H,e,E,t,C,R,A,P,g,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,R.createDecorator)(e.ID);let S=class{constructor(u,d,v){this.a=u,this.b=d,this.c=v}async getRemoteDiagnostics(u){const d=this.a.getWindows();return(await Promise.all(d.map(async h=>{const l=h.remoteAuthority;if(!l)return;const p=`vscode:getDiagnosticInfoResponse${h.id}`,k={includeProcesses:u.includeProcesses,folders:u.includeWorkspaceMetadata?await this.f(h):void 0};return new Promise(I=>{h.sendWhenReady("vscode:getDiagnosticInfo",C.CancellationToken.None,{replyChannel:p,args:k}),t.validatedIpcMain.once(p,(m,i)=>{i||I({hostName:l,errorMessage:`Unable to resolve connection to '${l}'.`}),I(i)}),setTimeout(()=>{I({hostName:l,errorMessage:`Connection to '${l}' could not be established`})},5e3)})}))).filter(h=>!!h)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const u=[];for(const d of E.BrowserWindow.getAllWindows()){const v=this.a.getWindowById(d.id);v?u.push(await this.d(v)):u.push(this.e(d))}return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:u,screenReader:!!E.app.accessibilitySupportEnabled,gpuFeatureStatus:E.app.getGPUFeatureStatus()}}async d(u){const d=await this.f(u),v=(0,w.assertIsDefined)(u.win);return this.e(v,d,u.remoteAuthority)}e(u,d=[],v){return{pid:u.webContents.getOSProcessId(),title:u.getTitle(),folderURIs:d,remoteAuthority:v}}async f(u){const d=[],v=u.openedWorkspace;if((0,P.isSingleFolderWorkspaceIdentifier)(v))d.push(v.uri);else if((0,P.isWorkspaceIdentifier)(v)){const h=await this.b.resolveLocalWorkspace(v.configPath);h&&h.folders.forEach(p=>{d.push(p.uri)})}return d}};S=pe([ee(0,A.IWindowsMainService),ee(1,g.IWorkspacesManagementMainService),ee(2,b.ILogService)],S),e.DiagnosticsMainService=S}),define(ie[58],re([0,1,46,13,25,142,54,3,34,2,14,9,4,7,100,82,23,97,166,57,27,5,21,6,19,66,32,28,53,17,224,217,36]),function(H,e,E,t,C,R,A,P,g,w,b,S,y,u,d,v,h,l,p,k,I,m,i,r,n,a,o,c,s,f,M,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,m.createDecorator)("nativeHostMainService");let U=class extends w.Disposable{constructor(V,G,_,se,ce,X,ue,z,N,F){super(),this.a=V,this.b=G,this.c=_,this.f=se,this.g=ce,this.h=X,this.i=ue,this.j=z,this.k=N,this.l=F,this.onDidOpenWindow=P.Event.map(this.b.onDidOpenWindow,q=>q.id),this.onDidTriggerSystemContextMenu=P.Event.filter(P.Event.map(this.b.onDidTriggerSystemContextMenu,({window:q,x:Q,y:oe})=>({windowId:q.id,x:Q,y:oe})),({windowId:q})=>!!this.b.getWindowById(q)),this.onDidMaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",(q,Q)=>Q.id),q=>!!this.b.getWindowById(q)),this.onDidUnmaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",(q,Q)=>Q.id),q=>!!this.b.getWindowById(q)),this.onDidBlurWindow=P.Event.filter(P.Event.fromNodeEventEmitter(t.app,"browser-window-blur",(q,Q)=>Q.id),q=>!!this.b.getWindowById(q)),this.onDidFocusWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.b.onDidChangeWindowsCount,()=>this.b.getLastActiveWindow()),q=>!!q),q=>q.id),P.Event.filter(P.Event.fromNodeEventEmitter(t.app,"browser-window-focus",(q,Q)=>Q.id),q=>!!this.b.getWindowById(q))),this.onDidResumeOS=P.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.j.onDidChangeColorScheme,this.m=this.B(new P.Emitter),this.onDidChangePassword=this.m.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",(q,Q,oe)=>oe),q=>!(Array.isArray(q)&&q.length===1&&q[0]==="workArea")),P.Event.fromNodeEventEmitter(t.screen,"display-added"),P.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.b.getWindows().map(G=>({id:G.id,workspace:G.openedWorkspace??(0,c.toWorkspaceIdentifier)(G.backupPath,G.isExtensionDevelopmentHost),title:G.win?.getTitle()??"",filename:G.getRepresentedFilename(),dirty:G.isDocumentEdited()}))}async getWindowCount(V){return this.b.getWindowCount()}async getActiveWindowId(V){const G=t.BrowserWindow.getFocusedWindow()||this.b.getLastActiveWindow();if(G)return G.id}openWindow(V,G,_){return Array.isArray(G)?this.n(V,G,_):this.p(V,G)}async n(V,G,_=Object.create(null)){G.length>0&&await this.b.open({context:5,contextWindowId:V,urisToOpen:G,cli:this.g.args,forceNewWindow:_.forceNewWindow,forceReuseWindow:_.forceReuseWindow,preferNewWindow:_.preferNewWindow,diffMode:_.diffMode,mergeMode:_.mergeMode,addMode:_.addMode,gotoLineMode:_.gotoLineMode,noRecentEntry:_.noRecentEntry,waitMarkerFileURI:_.waitMarkerFileURI,remoteAuthority:_.remoteAuthority||void 0})}async p(V,G){await this.b.openEmptyWindow({context:5,contextWindowId:V},G)}async toggleFullScreen(V){this.w(V)?.toggleFullScreen()}async handleTitleDoubleClick(V){this.w(V)?.handleTitleDoubleClick()}async isMaximized(V){const G=this.w(V);return G?.win?G.win.isMaximized():!1}async maximizeWindow(V){const G=this.w(V);G?.win&&G.win.maximize()}async unmaximizeWindow(V){const G=this.w(V);G?.win&&G.win.unmaximize()}async minimizeWindow(V){const G=this.w(V);G?.win&&G.win.minimize()}async updateWindowControls(V,G){const _=this.w(V);_&&_.updateWindowControls(G)}async focusWindow(V,G){G&&typeof G.windowId=="number"&&(V=G.windowId),this.w(V)?.focus({force:G?.force??!1})}async setMinimumSize(V,G,_){const se=this.w(V);if(se?.win){const[ce,X]=se.win.getSize(),[ue,z]=se.win.getMinimumSize(),[N,F]=[G??ue,_??z],[q,Q]=[Math.max(ce,N),Math.max(X,F)];(ue!==N||z!==F)&&se.win.setMinimumSize(N,F),(ce!==q||X!==Q)&&se.win.setSize(q,Q)}}async saveWindowSplash(V,G){this.j.saveWindowSplash(V,G)}async installShellCommand(V){const{source:G,target:_}=await this.r();try{const{symbolicLink:se}=await h.SymlinkSupport.stat(G);if(se&&!se.dangling){const ce=await(0,d.realpath)(G);if(_===ce)return}await h.Promises.unlink(G)}catch(se){if(se.code!=="ENOENT")throw se}try{await h.Promises.symlink(_,G)}catch(se){if(se.code!=="EACCES"&&se.code!=="ENOENT")throw se;const{response:ce}=await this.showMessageBox(V,{title:this.i.nameLong,type:"info",message:(0,p.localize)(0,null,this.i.nameShort),buttons:[(0,g.mnemonicButtonLabel)((0,p.localize)(1,null)),(0,g.mnemonicButtonLabel)((0,p.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(ce===0)try{const X=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${_}' '${G}'\\" with administrator privileges"`;await(0,R.promisify)(E.exec)(X)}catch{throw new Error((0,p.localize)(3,null,G))}}}async uninstallShellCommand(V){const{source:G}=await this.r();try{await h.Promises.unlink(G)}catch(_){switch(_.code){case"EACCES":{const{response:se}=await this.showMessageBox(V,{title:this.i.nameLong,type:"info",message:(0,p.localize)(4,null,this.i.nameShort),buttons:[(0,g.mnemonicButtonLabel)((0,p.localize)(5,null)),(0,g.mnemonicButtonLabel)((0,p.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(se===0)try{const ce=`osascript -e "do shell script \\"rm '${G}'\\" with administrator privileges"`;await(0,R.promisify)(E.exec)(ce)}catch{throw new Error((0,p.localize)(7,null,G))}break}case"ENOENT":break;default:throw _}}}async r(){const V=(0,S.resolve)(this.g.appRoot,"bin","code"),G=`/usr/local/bin/${this.i.applicationName}`;if(!await h.Promises.exists(V))throw new Error((0,p.localize)(8,null,V));return{source:G,target:V}}async showMessageBox(V,G){return this.c.showMessageBox(G,this.s(V))}async showSaveDialog(V,G){return this.c.showSaveDialog(G,this.s(V))}async showOpenDialog(V,G){return this.c.showOpenDialog(G,this.s(V))}s(V){const G=this.w(V);if(G?.win)return G.win}async pickFileFolderAndOpen(V,G){const _=await this.c.pickFileFolder(G);_&&await this.t(await Promise.all(_.map(async se=>await h.SymlinkSupport.existsDirectory(se)?{folderUri:u.URI.file(se)}:{fileUri:u.URI.file(se)})),G,V)}async pickFolderAndOpen(V,G){const _=await this.c.pickFolder(G);_&&await this.t(_.map(se=>({folderUri:u.URI.file(se)})),G,V)}async pickFileAndOpen(V,G){const _=await this.c.pickFile(G);_&&await this.t(_.map(se=>({fileUri:u.URI.file(se)})),G,V)}async pickWorkspaceAndOpen(V,G){const _=await this.c.pickWorkspace(G);_&&await this.t(_.map(se=>({workspaceUri:u.URI.file(se)})),G,V)}async t(V,G,_){await this.b.open({context:3,contextWindowId:_,cli:this.g.args,urisToOpen:V,forceNewWindow:G.forceNewWindow})}async showItemInFolder(V,G){t.shell.showItemInFolder(G)}async setRepresentedFilename(V,G){this.w(V)?.setRepresentedFilename(G)}async setDocumentEdited(V,G){this.w(V)?.setDocumentEdited(G)}async openExternal(V,G){return y.isLinuxSnap?this.u(G):t.shell.openExternal(G),!0}u(V){const G=process.env.GDK_PIXBUF_MODULE_FILE,_=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(V),process.env.GDK_PIXBUF_MODULE_FILE=G,process.env.GDK_PIXBUF_MODULEDIR=_}moveItemToTrash(V,G){return t.shell.trashItem(G)}async isAdmin(){let V;return y.isWindows?V=(await new Promise((G,_)=>{H(["native-is-elevated"],G,_)}))():V=process.getuid()===0,V}async writeElevated(V,G,_,se){const ce=await new Promise((X,ue)=>{H(["@vscode/sudo-prompt"],X,ue)});return new Promise((X,ue)=>{const z=[`"${this.v}"`];se?.unlock&&z.push("--file-chmod"),z.push("--file-write",`"${G.fsPath}"`,`"${_.fsPath}"`);const N={name:this.i.nameLong.replace("-",""),icns:y.isMacintosh&&this.g.isBuilt?(0,S.join)((0,S.dirname)(this.g.appRoot),`${this.i.nameShort}.icns`):void 0};ce.exec(z.join(" "),N,(F,q,Q)=>{q&&this.h.trace(`[sudo-prompt] received stdout: ${q}`),Q&&this.h.trace(`[sudo-prompt] received stderr: ${Q}`),F?ue(F):X(void 0)})})}get v(){return y.isWindows?this.g.isBuilt?(0,S.join)((0,S.dirname)(process.execPath),"bin",`${this.i.applicationName}.cmd`):(0,S.join)(this.g.appRoot,"scripts","code-cli.bat"):y.isLinux?this.g.isBuilt?(0,S.join)((0,S.dirname)(process.execPath),"bin",`${this.i.applicationName}`):(0,S.join)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,S.join)(this.g.appRoot,"bin","code"):(0,S.join)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,C.totalmem)(),freemem:(0,C.freemem)(),loadavg:(0,C.loadavg)()}}async getOSProperties(){return{arch:(0,C.arch)(),platform:(0,C.platform)(),release:(0,C.release)(),type:(0,C.type)(),cpus:(0,C.cpus)()}}async getOSVirtualMachineHint(){return v.virtualMachineHint.value()}async getOSColorScheme(){return this.j.getColorScheme()}async hasWSLFeatureInstalled(){return y.isWindows&&(0,M.hasWSLFeatureInstalled)()}async killProcess(V,G,_){process.kill(G,_)}async readClipboardText(V,G){return t.clipboard.readText(G)}async writeClipboardText(V,G,_){return t.clipboard.writeText(G,_)}async readClipboardFindText(V){return t.clipboard.readFindText()}async writeClipboardFindText(V,G){return t.clipboard.writeFindText(G)}async writeClipboardBuffer(V,G,_,se){return t.clipboard.writeBuffer(G,Buffer.from(_.buffer),se)}async readClipboardBuffer(V,G){return f.VSBuffer.wrap(t.clipboard.readBuffer(G))}async hasClipboard(V,G,_){return t.clipboard.has(G,_)}async newWindowTab(){await this.b.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(V,G){this.w(V)?.updateTouchBar(G)}async notifyReady(V){this.w(V)?.setReady()}async relaunch(V,G){return this.f.relaunch(G)}async reload(V,G){const _=this.w(V);if(_){if((0,c.isWorkspaceIdentifier)(_.openedWorkspace)){const se=_.openedWorkspace.configPath;if(se.scheme===b.Schemas.file&&(await this.l.resolveLocalWorkspace(se))?.transient)return this.openWindow(_.id,{forceReuseWindow:!0})}return this.f.reload(_,G?.disableExtensions!==void 0?{_:[],"disable-extensions":G.disableExtensions}:void 0)}}async closeWindow(V){this.closeWindowById(V,V)}async closeWindowById(V,G){const _=this.w(G);if(_?.win)return _.win.close()}async quit(V){const G=this.b.getLastActiveWindow();G?.isExtensionDevelopmentHost&&this.b.getWindowCount()>1&&G.win?G.win.close():this.f.quit()}async exit(V,G){await this.f.kill(G)}async resolveProxy(V,G){const se=this.w(V)?.win?.webContents?.session;if(se)return se.resolveProxy(G)}findFreePort(V,G,_,se,ce=1){return(0,l.findFreePort)(G,_,se,ce)}async openDevTools(V,G){const _=this.w(V);_?.win&&_.win.webContents.openDevTools(G)}async toggleDevTools(V){const G=this.w(V);G?.win&&G.win.webContents.toggleDevTools()}async sendInputEvent(V,G){const _=this.w(V);_?.win&&(G.type==="mouseDown"||G.type==="mouseUp")&&_.win.webContents.sendInputEvent(G)}async enableSandbox(V,G){G?this.k.setItem("window.experimental.useSandbox",!0):this.k.removeItem("window.experimental.useSandbox")}async toggleSharedProcessWindow(){return this.a.toggle()}async profileRenderer(V,G,_){const se=this.w(V);if(!se||!se.win)throw new Error;return await new L.WindowProfiler(se.win,G,this.h).inspect(_)}async windowsGetStringRegKey(V,G,_,se){if(!y.isWindows)return;const ce=await new Promise((X,ue)=>{H(["@vscode/windows-registry"],X,ue)});try{return ce.GetStringRegKey(G,_,se)}catch{return}}w(V){if(typeof V=="number")return this.b.getWindowById(V)}};pe([A.memoize],U.prototype,"v",null),U=pe([ee(1,o.IWindowsMainService),ee(2,k.IDialogMainService),ee(3,i.ILifecycleMainService),ee(4,I.IEnvironmentMainService),ee(5,r.ILogService),ee(6,n.IProductService),ee(7,a.IThemeMainService),ee(8,T.IStateMainService),ee(9,s.IWorkspacesManagementMainService)],U),e.NativeHostMainService=U}),define(ie[268],re([0,1,13,41,25,34,2,14,4,101,164,85,119,57,27,5,6,58,63,19,64,74,30,11,75]),function(H,e,E,t,C,R,A,P,g,w,b,S,y,u,d,v,h,l,p,k,I,m,i,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,v.createDecorator)("issueMainService");const a="issue.processExplorerWindowState";let o=class jt{constructor(f,M,L,T,U,K,V,G,_,se){this.g=f,this.h=M,this.i=L,this.j=T,this.k=U,this.l=K,this.m=V,this.n=G,this.o=_,this.p=se,this.b=null,this.c=null,this.d=null,this.f=null,this.q()}q(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async f=>{const[M,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),T=await this.j.getSystemInfo(M,L);this.r(f,"vscode:issueSystemInfoResponse",T)}),t.validatedIpcMain.on("vscode:listProcesses",async f=>{const M=[];try{M.push({name:(0,b.localize)(0,null),rootProcess:await(0,w.listProcesses)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(T=>{(0,S.isRemoteDiagnosticError)(T)?M.push({name:T.hostName,rootProcess:T}):T.processes&&M.push({name:T.hostName,rootProcess:T.processes})})}catch(L){this.i.error(`Listing processes failed: ${L}`)}this.r(f,"vscode:listProcessesResponse",M)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async f=>{const M={title:this.o.nameLong,message:(0,b.localize)(1,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,b.localize)(2,null)),(0,R.mnemonicButtonLabel)((0,b.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.b){const L=await this.l.showMessageBox(M,this.b);this.r(f,"vscode:issueReporterClipboardResponse",L.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async f=>{const M=await this.w();this.r(f,"vscode:issuePerformanceInfoResponse",M)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const f={title:this.o.nameLong,message:(0,b.localize)(4,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,b.localize)(5,null)),(0,R.mnemonicButtonLabel)((0,b.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.b&&(await this.l.showMessageBox(f,this.b)).response===0&&this.b&&(this.b.destroy(),this.b=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(f,M)=>{const{id:L,from:T,args:U}=M;let K;switch(T){case"issueReporter":K=this.c;break;case"processExplorer":K=this.f;break;default:throw new Error(`Unexpected command source: ${T}`)}K?.webContents.send("vscode:runAction",{id:L,from:T,args:U})}),t.validatedIpcMain.on("vscode:openExternal",(f,M)=>{this.m.openExternal(void 0,M)}),t.validatedIpcMain.on("vscode:closeIssueReporter",f=>{this.b?.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",f=>{this.d?.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async f=>{const M=await this.k.getMainDiagnostics();this.r(f,"vscode:windowsInfoResponse",M.windows)})}r(f,M,...L){f.sender.isDestroyed()||f.sender.send(M,...L)}s(f,M){try{return f&&JSON.parse(f)||M}catch{return M}}async openReporter(f){if(!this.b&&(this.c=E.BrowserWindow.getFocusedWindow(),this.c)){const M=new A.DisposableStore,L=M.add(this.n.createIPCObjectUrl()),T=this.v(this.c,700,800);this.b=this.u(T,L,{backgroundColor:f.styles.backgroundColor,title:(0,b.localize)(7,null),zoomLevel:f.zoomLevel,alwaysOnTop:!1},"issue-reporter"),L.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:f,disableExtensions:!!this.h.disableExtensions,os:{type:(0,C.type)(),arch:(0,C.arch)(),release:(0,C.release)()},product:p.default}),this.b.loadURL(P.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,M.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,M.dispose())})}this.b&&this.t(this.b)}async openProcessExplorer(f){if(!this.d&&(this.f=E.BrowserWindow.getFocusedWindow(),this.f)){const M=new A.DisposableStore,L=M.add(this.n.createIPCObjectUrl()),T=this.s(this.p.get(a,-1),void 0),U=c(T)?T:this.v(this.f,800,500),K=E.screen.getDisplayNearestPoint({x:U.x,y:U.y});U.width/=K.scaleFactor,U.height/=K.scaleFactor,this.d=this.u(U,L,{backgroundColor:f.styles.backgroundColor,title:(0,b.localize)(8,null),zoomLevel:f.zoomLevel,alwaysOnTop:!0},"process-explorer"),L.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:f,product:p.default}),this.d.loadURL(P.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,M.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,M.dispose())});const V=()=>{if(!this.d)return;const G=this.d.getSize(),_=this.d.getPosition();if(!G||!_)return;const se={width:G[0],height:G[1],x:_[0],y:_[1]};this.p.store(a,JSON.stringify(se),-1,1)};this.d.on("moved",V),this.d.on("resized",V)}this.d&&this.t(this.d)}t(f){f.isMinimized()&&f.restore(),f.focus()}u(f,M,L,T){const U=new E.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:f.width,height:f.height,minWidth:300,minHeight:200,x:f.x,y:f.y,title:L.title,backgroundColor:L.backgroundColor||jt.a,webPreferences:{preload:P.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${M.resource.toString()}`,`--vscode-window-kind=${T}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,m.zoomLevelToZoomFactor)(L.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:L.alwaysOnTop,experimentalDarkMode:!0});return U.setMenuBarVisibility(!1),U}async getSystemStatus(){const[f,M]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(f,M)}v(f,M,L){let T;const U=E.screen.getAllDisplays();if(U.length===1)T=U[0];else{if(g.isMacintosh){const G=E.screen.getCursorScreenPoint();T=E.screen.getDisplayNearestPoint(G)}!T&&f&&(T=E.screen.getDisplayMatching(f.getBounds())),T||(T=E.screen.getPrimaryDisplay()||U[0])}const K=T.bounds,V={width:M,height:L,x:K.x+K.width/2-M/2,y:K.y+K.height/2-L/2};return K.width>0&&K.height>0&&(V.x<K.x&&(V.x=K.x),V.y<K.y&&(V.y=K.y),V.x>K.x+K.width&&(V.x=K.x),V.y>K.y+K.height&&(V.y=K.y),V.width>K.width&&(V.width=K.width),V.height>K.height&&(V.height=K.height)),V}async w(){try{const[f,M]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(f,M)}catch(f){throw this.i.warn("issueService#getPerformanceInfo ",f.message),f}}async stopTracing(){if(!this.h.args.trace)return;const f=await E.contentTracing.stopRecording(`${(0,i.randomPath)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({title:this.o.nameLong,type:"info",message:(0,b.localize)(9,null),detail:(0,b.localize)(10,null,f),buttons:[(0,R.mnemonicButtonLabel)((0,b.localize)(11,null))],defaultId:0,noLink:!0},(0,r.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow())),this.m.showItemInFolder(void 0,f)}};o.a="#1E1E1E",o=pe([ee(1,d.IEnvironmentMainService),ee(2,h.ILogService),ee(3,S.IDiagnosticsService),ee(4,y.IDiagnosticsMainService),ee(5,u.IDialogMainService),ee(6,l.INativeHostMainService),ee(7,I.IProtocolMainService),ee(8,k.IProductService),ee(9,n.IApplicationStorageMainService)],o),e.IssueMainService=o;function c(s){return typeof s!="object"||s===null?!1:"x"in s&&"y"in s&&"width"in s&&"height"in s}}),define(ie[269],re([0,1,22,18,27,21,6,58,19,56,31,49,91]),function(H,e,E,t,C,R,A,P,g,w,b,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let u=class extends y.AbstractUpdateService{constructor(v,h,l,p,k,I,m,i){super(v,h,p,k,I,i),this.e=l,this.u=m}s(v){return(0,y.createUpdateURL)(`linux-${process.arch}`,v,this.k)}t(v){!this.a||(this.d(S.State.CheckingForUpdates(v)),this.i.request({url:this.a},E.CancellationToken.None).then(w.asJson).then(h=>{!h||!h.url||!h.version||!h.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!v}),this.d(S.State.Idle(1))):this.d(S.State.AvailableForDownload(h))}).then(void 0,h=>{this.j.error(h),this.e.publicLog2("update:notAvailable",{explicit:!!v});const l=v?h.message||h:void 0;this.d(S.State.Idle(1,l))}))}async o(v){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):v.update.url&&this.u.openExternal(void 0,v.update.url),this.d(S.State.Idle(1))}};u=pe([ee(0,R.ILifecycleMainService),ee(1,t.IConfigurationService),ee(2,b.ITelemetryService),ee(3,C.IEnvironmentMainService),ee(4,w.IRequestService),ee(5,A.ILogService),ee(6,P.INativeHostMainService),ee(7,g.IProductService)],u),e.LinuxUpdateService=u}),define(ie[270],re([0,1,46,40,25,8,22,54,9,7,128,23,18,27,16,21,6,58,19,56,31,49,91]),function(H,e,E,t,C,R,A,P,g,w,b,S,y,u,d,v,h,l,p,k,I,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function r(c,s=1e3){for(;!c();)await(0,R.timeout)(s)}let n;function a(){return typeof n>"u"&&(n=t.existsSync(g.join(g.dirname(process.execPath),"unins000.exe"))?0:1),n}let o=class extends i.AbstractUpdateService{get cachePath(){const s=g.join((0,C.tmpdir)(),`vscode-update-${this.k.target}-${process.arch}`);return S.Promises.mkdir(s,{recursive:!0}).then(()=>s)}constructor(s,f,M,L,T,U,K,V,G){super(s,f,L,T,U,G),this.u=M,this.v=K,this.w=V}async initialize(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}s(s){let f="win32";return process.arch!=="ia32"&&(f+=`-${process.arch}`),a()===1?f+="-archive":this.k.target==="user"&&(f+="-user"),(0,i.createUpdateURL)(f,s,this.k)}t(s){!this.a||(this.d(m.State.CheckingForUpdates(s)),this.i.request({url:this.a},A.CancellationToken.None).then(k.asJson).then(f=>{const M=a();return!f||!f.url||!f.version||!f.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!s}),this.d(m.State.Idle(M)),Promise.resolve(null)):M===1?(this.d(m.State.AvailableForDownload(f)),Promise.resolve(null)):(this.d(m.State.Downloading(f)),this.B(f.version).then(()=>this.A(f.version).then(L=>S.Promises.exists(L).then(T=>{if(T)return Promise.resolve(L);const U=f.url,K=f.hash,V=`${L}.tmp`;return this.i.request({url:U},A.CancellationToken.None).then(G=>this.v.writeFile(w.URI.file(V),G.stream)).then(K?()=>(0,b.checksum)(V,f.hash):()=>{}).then(()=>S.Promises.rename(V,L)).then(()=>L)})).then(L=>{const T=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:L},T&&f.supportsFastUpdate?this.k.target==="user"?this.p():this.d(m.State.Downloaded(f)):this.d(m.State.Ready(f))})))}).then(void 0,f=>{this.j.error(f),this.u.publicLog2("update:notAvailable",{explicit:!!s});const M=s?f.message||f:void 0;this.d(m.State.Idle(a(),M))}))}async o(s){s.update.url&&this.w.openExternal(void 0,s.update.url),this.d(m.State.Idle(a()))}async A(s){const f=await this.cachePath;return g.join(f,`CodeSetup-${this.k.quality}-${s}.exe`)}async B(s=null){const f=s?U=>!new RegExp(`${this.k.quality}-${s}\\.exe$`).test(U):()=>!0,M=await this.cachePath,T=(await S.Promises.readdir(M)).filter(f).map(async U=>{try{await S.Promises.unlink(g.join(M,U))}catch{}});await Promise.all(T)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const s=this.state.update;this.d(m.State.Updating(s));const f=await this.cachePath;this.e.updateFilePath=g.join(f,`CodeSetup-${this.k.quality}-${s.version}.flag`),await S.Promises.writeFile(this.e.updateFilePath,"flag"),(0,E.spawn)(this.e.packagePath,["/verysilent",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(m.State.Idle(a()))});const L=`${this.k.win32MutexName}-ready`,T=await new Promise((U,K)=>{H(["windows-mutex"],U,K)});r(()=>T.isActive(L)).then(()=>this.d(m.State.Ready(s)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.e.updateFilePath?t.unlinkSync(this.e.updateFilePath):(0,E.spawn)(this.e.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return a()}async _applySpecificUpdate(s){if(this.state.type!=="idle")return;const f=this.g.getValue("update.enableWindowsBackgroundUpdates"),M={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!f};this.d(m.State.Downloading(M)),this.e={packagePath:s},f?this.k.target==="user"?this.p():this.d(m.State.Downloaded(M)):this.d(m.State.Ready(M))}};pe([P.memoize],o.prototype,"cachePath",null),o=pe([ee(0,v.ILifecycleMainService),ee(1,y.IConfigurationService),ee(2,I.ITelemetryService),ee(3,u.IEnvironmentMainService),ee(4,k.IRequestService),ee(5,h.ILogService),ee(6,d.IFileService),ee(7,l.INativeHostMainService),ee(8,p.IProductService)],o),e.Win32UpdateService=o}),define(ie[271],re([0,1,13,8,22,45,3,34,2,14,9,73,4,7,172,62,18,57,27,61,16,21,6,19,64,235,75,31,240,66,74,32,28,53,116,121,37,36,52,58,237,112,51,90,25,113]),function(H,e,E,t,C,R,A,P,g,w,b,S,y,u,d,v,h,l,p,k,I,m,i,r,n,a,o,c,s,f,M,L,T,U,K,V,G,_,se,ce,X,ue,z,N,F,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var Q;(function(x){x[x.NONE=0]="NONE",x[x.NAVIGATING=1]="NAVIGATING",x[x.READY=2]="READY"})(Q||(Q={}));let oe=class gt extends g.Disposable{get id(){return this.k}get win(){return this.l}get lastFocusTime(){return this.m}get backupPath(){return this.n?.backupPath}get openedWorkspace(){return this.n?.workspace}get profile(){if(!this.config)return;const D=this.O.profiles.find(O=>O.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&D?D:this.O.getProfileForWorkspace(this.config.workspace??(0,T.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.O.defaultProfile}get remoteAuthority(){return this.n?.remoteAuthority}get config(){return this.n}get isExtensionDevelopmentHost(){return!!this.n?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.n?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.n?.debugId}constructor(D,O,W,j,$,Y,B,Z,te,ae,ge,ke,Oe,De,Re,ve,we,ye,Me,ne){super(),this.L=O,this.M=W,this.N=j,this.O=$,this.P=Y,this.Q=B,this.R=Z,this.S=te,this.U=ae,this.W=ge,this.X=ke,this.Y=Oe,this.Z=De,this.ab=Re,this.bb=ve,this.db=we,this.eb=ye,this.fb=Me,this.gb=ne,this.c=this.B(new A.Emitter),this.onWillLoad=this.c.event,this.f=this.B(new A.Emitter),this.onDidSignalReady=this.f.event,this.g=this.B(new A.Emitter),this.onDidTriggerSystemContextMenu=this.g.event,this.h=this.B(new A.Emitter),this.onDidClose=this.h.event,this.j=this.B(new A.Emitter),this.onDidDestroy=this.j.event,this.m=-1,this.t=void 0,this.u=void 0,this.z=!1,this.C=[],this.D=[],this.F=void 0,this.G=void 0,this.H=this.B(this.db.createIPCObjectUrl()),this.J=!1,this.hb=0;{const[fe,de]=this.sb(D.state);this.r=fe,this.L.trace("window#ctor: using window state",fe);const be=this.r.mode===0||this.r.mode===3;typeof gt.b>"u"&&(gt.b=this.fb.getItem("window.experimental.useSandbox",!1));const Pe=this.S.getValue("window");let We=!1;typeof Pe?.experimental?.useSandbox=="boolean"?We=Pe.experimental.useSandbox:this.bb.quality==="stable"&&gt.b?We=!0:We=typeof this.bb.quality=="string"&&this.bb.quality!=="stable";const Te={width:this.r.width,height:this.r.height,x:this.r.x,y:this.r.y,backgroundColor:this.U.getBackgroundColor(),minWidth:M.WindowMinimumSize.WIDTH,minHeight:M.WindowMinimumSize.HEIGHT,show:!be,title:this.bb.nameLong,webPreferences:{preload:w.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.H.resource.toString()}`],v8CacheOptions:this.M.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,M.zoomLevelToZoomFactor)(Pe?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...We?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};y.isLinux?Te.icon=(0,b.join)(this.M.appRoot,"resources/linux/code.png"):y.isWindows&&!this.M.isBuilt&&(Te.icon=(0,b.join)(this.M.appRoot,"resources/win32/code_150x150.png")),y.isMacintosh&&!this.zb()&&(Te.fullscreenable=!1),y.isMacintosh&&(Te.acceptFirstMouse=!0,Pe?.clickThroughInactive===!1&&(Te.acceptFirstMouse=!1));const qe=y.isMacintosh&&Pe?.nativeTabs===!0;qe&&(Te.tabbingIdentifier=this.bb.nameShort);const Ue=(0,M.getTitleBarStyle)(this.S)==="custom";if(Ue&&(Te.titleBarStyle="hidden",y.isMacintosh||(Te.frame=!1),(0,M.useWindowControlsOverlay)(this.S))){const je=this.U.getWindowSplash()?.colorInfo.titleBarBackground??this.U.getBackgroundColor(),Xe=V.Color.fromHex(je).isDarker()?"#FFFFFF":"#000000";Te.titleBarOverlay={height:29,color:je,symbolColor:Xe},this.z=!0}if((0,S.mark)("code/willCreateCodeBrowserWindow"),this.l=new E.BrowserWindow(Te),(0,S.mark)("code/didCreateCodeBrowserWindow"),this.k=this.l.id,y.isMacintosh&&Ue&&this.l.setSheetOffset(22),Ue&&(y.isWindows&&(0,M.useWindowControlsOverlay)(this.S)||y.isMacintosh)){const je=this.fb.getItem(gt.a);je&&this.updateWindowControls({height:je})}y.isWindows&&Ue&&this.l.hookWindowMessage(278,()=>{const[Xe,$e]=this.l.getPosition(),Ke=E.screen.getCursorScreenPoint(),J=Ke.x-Xe,le=Ke.y-$e;return(()=>!(J>30&&le>=0&&le<=Math.max(this.l.getBounds().height*.15,35)))()||(this.l.setEnabled(!1),this.l.setEnabled(!0),this.g.fire({x:J,y:le})),0}),(y.isMacintosh||y.isWindows)&&de&&(!qe||E.BrowserWindow.getAllWindows().length===1)&&[this.r.width,this.r.height,this.r.x,this.r.y].every(je=>typeof je=="number")&&this.l.setBounds({width:this.r.width,height:this.r.height,x:this.r.x,y:this.r.y}),be&&((0,S.mark)("code/willMaximizeCodeWindow"),this.l.maximize(),this.r.mode===3&&this.vb(!0),this.l.show(),(0,S.mark)("code/didMaximizeCodeWindow")),this.m=Date.now()}this.M.args["open-devtools"]===!0&&this.l.webContents.openDevTools(),this.pb(),this.Db(),this.ib()}setRepresentedFilename(D){y.isMacintosh?this.l.setRepresentedFilename(D):this.v=D}getRepresentedFilename(){return y.isMacintosh?this.l.getRepresentedFilename():this.v}setDocumentEdited(D){y.isMacintosh&&this.l.setDocumentEdited(D),this.w=D}isDocumentEdited(){return y.isMacintosh?this.l.isDocumentEdited():!!this.w}focus(D){y.isMacintosh&&D?.force&&E.app.focus({steal:!0}),this.l&&(this.l.isMinimized()&&this.l.restore(),this.l.focus())}setReady(){for(this.L.trace(`window#load: window reported ready (id: ${this.k})`),this.hb=2;this.C.length;)this.C.pop()(this);this.f.fire()}ready(){return new Promise(D=>{if(this.isReady)return D(this);this.C.push(D)})}get isReady(){return this.hb===2}get whenClosedOrLoaded(){return new Promise(D=>{function O(){W.dispose(),j.dispose(),D()}const W=this.onDidClose(()=>O()),j=this.onWillLoad(()=>O())})}ib(){this.l.on("unresponsive",()=>this.lb(1)),this.l.webContents.on("render-process-gone",(O,W)=>this.lb(2,W)),this.l.webContents.on("did-fail-load",(O,W,j)=>this.lb(3,{reason:j,exitCode:W})),this.l.webContents.on("will-prevent-unload",O=>{O.preventDefault()}),this.l.on("closed",()=>{this.h.fire(),this.dispose()}),this.l.webContents.on("did-finish-load",()=>{this.I&&(this.n=this.I,this.I=void 0)}),this.l.on("focus",()=>{this.m=Date.now()}),this.l.on("maximize",O=>{this.n&&(this.n.maximized=!0),E.app.emit("browser-window-maximize",O,this.l)}),this.l.on("unmaximize",O=>{this.n&&(this.n.maximized=!1),E.app.emit("browser-window-unmaximize",O,this.l)}),this.l.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",C.CancellationToken.None),this.u?.complete(),this.u=void 0}),this.l.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",C.CancellationToken.None),this.u?.complete(),this.u=void 0}),this.B(this.S.onDidChangeConfiguration(O=>this.pb(O))),this.B(this.W.onDidDeleteUntitledWorkspace(O=>this.ob(O)));const D=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.l.webContents.session.webRequest.onBeforeSendHeaders({urls:D},async(O,W)=>{const j=await this.kb();W({cancel:!1,requestHeaders:Object.assign(O.requestHeaders,j)})})}kb(){return this.jb||(this.jb=(0,a.resolveMarketplaceHeaders)(this.bb.version,this.bb,this.M,this.S,this.P,this.Q,this.Y)),this.jb}async lb(D,O){switch(D){case 2:this.L.error(`CodeWindow: renderer process gone (reason: ${O?.reason||"<unknown>"}, code: ${O?.exitCode||"<unknown>"})`);break;case 1:this.L.error("CodeWindow: detected unresponsive");break;case 3:this.L.error(`CodeWindow: failed to load (reason: ${O?.reason||"<unknown>"}, code: ${O?.exitCode||"<unknown>"})`);break}switch(this.Y.publicLog2("windowerror",{type:D,reason:O?.reason,code:O?.exitCode}),D){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.ab.kill(1);return}if(this.M.args["enable-smoke-test-driver"]){await this.nb(!1,!1),this.ab.quit();return}if(D===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.l&&this.l.webContents&&this.l.webContents.isDevToolsOpened())return;const W=await this.Z.showMessageBox({title:this.bb.nameLong,type:"warning",buttons:[(0,P.mnemonicButtonLabel)((0,d.localize)(0,null)),(0,P.mnemonicButtonLabel)((0,d.localize)(1,null)),(0,P.mnemonicButtonLabel)((0,d.localize)(2,null))],message:(0,d.localize)(3,null),detail:(0,d.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this.n?.workspace?(0,d.localize)(5,null):void 0},this.l);if(W.response!==1){const j=W.response===0;await this.nb(j,W.checkboxChecked)}}else if(D===2)if(y.isWindows&&O?.reason==="launch-failed"&&O.exitCode===18&&await this.gb.isAdmin(void 0))await this.mb(O);else{let W;O?W=(0,d.localize)(7,null,O.reason,O.exitCode??"<unknown>"):W=(0,d.localize)(6,null);const j=await this.Z.showMessageBox({title:this.bb.nameLong,type:"warning",buttons:[this.n?.workspace?(0,P.mnemonicButtonLabel)((0,d.localize)(8,null)):(0,P.mnemonicButtonLabel)((0,d.localize)(9,null)),(0,P.mnemonicButtonLabel)((0,d.localize)(10,null))],message:W,detail:this.n?.workspace?(0,d.localize)(11,null):(0,d.localize)(12,null),noLink:!0,defaultId:0,checkboxLabel:this.n?.workspace?(0,d.localize)(13,null):void 0},this.l),$=j.response===0;await this.nb($,j.checkboxChecked)}break}}async mb(D){const O=[],W=(0,z.isInternalTelemetry)(this.bb,this.S);if((0,z.supportsTelemetry)(this.bb,this.M)){this.bb.aiConfig&&this.bb.aiConfig.ariaKey&&O.push(new X.OneDataSystemAppender(W,"monacoworkbench",null,this.bb.aiConfig.ariaKey));const{installSourcePath:$}=this.M,Y=await(0,q.resolveMachineId)(this.fb),B={appenders:O,sendErrorTelemetry:!1,commonProperties:(0,N.resolveCommonProperties)(this.P,(0,F.release)(),(0,F.hostname)(),process.arch,this.bb.commit,this.bb.version,Y,W,$),piiPaths:(0,z.getPiiPathsFromEnvironment)(this.M)};await new ue.TelemetryService(B,this.S,this.bb).publicLog2("windowadminerror",{reason:D.reason,code:D.exitCode})}(await this.Z.showMessageBox({title:this.bb.nameLong,type:"error",buttons:[(0,P.mnemonicButtonLabel)((0,d.localize)(14,null)),(0,P.mnemonicButtonLabel)((0,d.localize)(15,null))],message:(0,d.localize)(16,null),detail:(0,d.localize)(17,null,this.bb.nameLong),noLink:!0,defaultId:0},this.l)).response===0&&await this.gb.openExternal(void 0,"https://go.microsoft.com/fwlink/?linkid=2220179"),await Promise.all(O.map($=>$.flush())),await this.nb(!1,!1)}async nb(D,O){const W=this.n?.workspace;if(O&&W)try{const j=this.R.workspaceStorage(W);await j.init(),j.delete("memento/workbench.parts.editor"),await j.close()}catch(j){this.L.error(j)}if(this.j.fire(),this.l?.destroy(),D&&this.n){let j,$;(0,T.isSingleFolderWorkspaceIdentifier)(W)?j={folderUri:W.uri}:(0,T.isWorkspaceIdentifier)(W)?j={workspaceUri:W.configPath}:$=!0;const[Y]=await this.eb.open({context:5,userEnv:this.n.userEnv,cli:{...this.M.args,_:[]},urisToOpen:j?[j]:void 0,forceEmpty:$,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});Y.focus()}}ob(D){this.n?.workspace?.id===D.id&&(this.n.workspace=void 0)}pb(D){const O=this.Ab();O!==this.s&&(this.s=O,this.Bb(O));let W=(this.S.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;W?.endsWith("/")&&(W=W.substr(0,W.length-1));const j=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((W||"").indexOf("@")===-1&&(W!==this.F||j!==this.G)){this.F=W,this.G=j;const $=W||"",Y=j?`${j},<local>`:"<local>";this.L.trace(`Setting proxy to '${$}', bypassing '${Y}'`),this.l.webContents.session.setProxy({proxyRules:$,proxyBypassRules:Y,pacScript:""})}}addTabbedWindow(D){y.isMacintosh&&D.win&&this.l.addTabbedWindow(D.win)}load(D,O=Object.create(null)){this.L.trace(`window#load: attempt to load window (id: ${this.k})`),this.isDocumentEdited()&&(!O.isReload||!this.X.isHotExitEnabled())&&this.setDocumentEdited(!1),O.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.l.setTitle(this.bb.nameLong)),this.qb(D,O),this.hb===0?this.n=D:this.I=D,this.hb=1,this.l.loadURL(w.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.M.isBuilt?"":"-dev"}.html`).toString(!0));const W=this.J;this.J=!0,!this.M.isBuilt&&!this.M.extensionTestsLocationURI&&this.B(new t.RunOnceScheduler(()=>{this.l&&!this.l.isVisible()&&!this.l.isMinimized()&&(this.l.show(),this.focus({force:!0}),this.l.webContents.openDevTools())},1e4)).schedule(),this.c.fire({workspace:D.workspace,reason:O.isReload?3:W?2:1})}qb(D,O){const W=(this.n??this.I)?.userEnv;if(W){const j=(0,k.isLaunchedFromCli)(W)&&!(0,k.isLaunchedFromCli)(D.userEnv),$=this.isExtensionDevelopmentHost;(j||$)&&(D.userEnv={...W,...D.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(D.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),O.disableExtensions!==void 0&&(D["disable-extensions"]=O.disableExtensions),D.fullscreen=this.isFullScreen,D.maximized=this.l.isMaximized(),D.partsSplash=this.U.getWindowSplash(),(0,S.mark)("code/willOpenNewWindow"),D.perfMarks=(0,S.getMarks)(),this.H.update(D)}async reload(D){const O=Object.assign({},this.n);O.workspace=await this.rb(O),delete O.filesToOpenOrCreate,delete O.filesToDiff,delete O.filesToMerge,delete O.filesToWait,this.isExtensionDevelopmentHost&&D&&(O.verbose=D.verbose,O.debugId=D.debugId,O.extensionEnvironment=D.extensionEnvironment,O["inspect-extensions"]=D["inspect-extensions"],O["inspect-brk-extensions"]=D["inspect-brk-extensions"],O["extensions-dir"]=D["extensions-dir"]),O.accessibilitySupport=E.app.isAccessibilitySupportEnabled(),O.isInitialStartup=!1,O.policiesData=this.N.serialize(),O.continueOn=this.M.continueOn,O.profiles={all:this.O.profiles,profile:this.profile||this.O.defaultProfile},O.logLevel=this.L.getLevel(),this.load(O,{isReload:!0,disableExtensions:D?.["disable-extensions"]})}async rb(D){if((0,T.isWorkspaceIdentifier)(D.workspace)){const O=D.workspace.configPath;if(O.scheme===w.Schemas.file&&!await this.P.exists(O))return}else if((0,T.isSingleFolderWorkspaceIdentifier)(D.workspace)){const O=D.workspace.uri;if(O.scheme===w.Schemas.file&&!await this.P.exists(O))return}return D.workspace}serializeWindowState(){if(!this.l)return(0,K.defaultWindowState)();if(this.isFullScreen){let W;try{W=E.screen.getDisplayMatching(this.getBounds())}catch{}const j=(0,K.defaultWindowState)();return{mode:3,display:W?W.id:void 0,width:this.r.width||j.width,height:this.r.height||j.height,x:this.r.x||0,y:this.r.y||0}}const D=Object.create(null);let O;if(!y.isMacintosh&&this.l.isMaximized()?O=0:O=1,O===0?D.mode=0:D.mode=1,O===1||O===0){let W;O===1?W=this.getBounds():W=this.l.getNormalBounds(),D.x=W.x,D.y=W.y,D.width=W.width,D.height=W.height}return D}updateWindowControls(D){if(D.height&&this.fb.setItem(gt.a,D.height),y.isWindows&&this.z)this.l.setTitleBarOverlay({color:D.backgroundColor?.trim()===""?void 0:D.backgroundColor,symbolColor:D.foregroundColor?.trim()===""?void 0:D.foregroundColor,height:D.height?D.height-1:void 0});else if(y.isMacintosh&&D.height!==void 0){const O=(D.height-15)/2;this.l.setTrafficLightPosition({x:O,y:O})}}sb(D){(0,S.mark)("code/willRestoreCodeWindowState");let O=!1;if(D)try{const W=E.screen.getAllDisplays();O=W.length>1,D=this.tb(D,W)}catch(W){this.L.warn(`Unexpected error validating window state: ${W}
${W.stack}`)}return(0,S.mark)("code/didRestoreCodeWindowState"),[D||(0,K.defaultWindowState)(),O]}tb(D,O){if(this.L.trace(`window#validateWindowState: validating window state on ${O.length} display(s)`,D),typeof D.x!="number"||typeof D.y!="number"||typeof D.width!="number"||typeof D.height!="number"){this.L.trace("window#validateWindowState: unexpected type of state values");return}if(D.width<=0||D.height<=0){this.L.trace("window#validateWindowState: unexpected negative values");return}if(O.length===1){const $=this.ub(O[0]);if($){let Y=function(){!D||typeof D.x!="number"||typeof D.y!="number"||!$||(D.x<$.x&&(D.x=$.x),D.y<$.y&&(D.y=$.y))};this.L.trace("window#validateWindowState: 1 monitor working area",$),Y(),D.width>$.width&&(D.width=$.width),D.height>$.height&&(D.height=$.height),D.x>$.x+$.width-128&&(D.x=$.x+$.width-D.width),D.y>$.y+$.height-128&&(D.y=$.y+$.height-D.height),Y()}return D}if(D.display&&D.mode===3){const $=O.find(Y=>Y.id===D.display);if($&&typeof $.bounds?.x=="number"&&typeof $.bounds?.y=="number"){this.L.trace("window#validateWindowState: restoring fullscreen to previous display");const Y=(0,K.defaultWindowState)(3);return Y.x=$.bounds.x,Y.y=$.bounds.y,Y}}let W,j;try{W=E.screen.getDisplayMatching({x:D.x,y:D.y,width:D.width,height:D.height}),j=this.ub(W)}catch{}if(W&&j&&D.x+D.width>j.x&&D.y+D.height>j.y&&D.x<j.x+j.width&&D.y<j.y+j.height)return this.L.trace("window#validateWindowState: multi-monitor working area",j),D}ub(D){if(D.workArea.width>0&&D.workArea.height>0)return D.workArea;if(D.bounds.width>0&&D.bounds.height>0)return D.bounds}getBounds(){const[D,O]=this.l.getPosition(),[W,j]=this.l.getSize();return{x:D,y:O,width:W,height:j}}toggleFullScreen(){this.vb(!this.isFullScreen)}vb(D){this.zb()?this.wb(D):this.yb(D),this.sendWhenReady(D?"vscode:enterFullScreen":"vscode:leaveFullScreen",C.CancellationToken.None),this.s&&this.Bb(this.s,!1)}get isFullScreen(){return y.isMacintosh&&typeof this.t=="boolean"?this.t:this.l.isFullScreen()||this.l.isSimpleFullScreen()}wb(D){this.l.isSimpleFullScreen()&&this.l.setSimpleFullScreen(!1),this.xb(D)}xb(D){y.isMacintosh&&(this.t=D,this.u=new t.DeferredPromise,Promise.race([this.u.p,(0,t.timeout)(1e3)]).finally(()=>this.t=void 0)),this.l.setFullScreen(D)}yb(D){this.l.isFullScreen()&&this.xb(!1),this.l.setSimpleFullScreen(D),this.l.webContents.focus()}zb(){const D=this.S.getValue("window");return!D||typeof D.nativeFullScreen!="boolean"||D.nativeTabs?!0:D.nativeFullScreen!==!1}isMinimized(){return this.l.isMinimized()}Ab(){let D=(0,M.getMenuBarVisibility)(this.S);return["visible","toggle","hidden"].indexOf(D)<0&&(D="classic"),D}Bb(D,O=!0){y.isMacintosh||(D==="toggle"&&O&&this.send("vscode:showInfoMessage",(0,d.localize)(18,null)),D==="hidden"?setTimeout(()=>{this.Cb(D)}):this.Cb(D))}Cb(D){const O=this.isFullScreen;switch(D){case"classic":this.l.setMenuBarVisibility(!O),this.l.autoHideMenuBar=O;break;case"visible":this.l.setMenuBarVisibility(!0),this.l.autoHideMenuBar=!1;break;case"toggle":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!0;break;case"hidden":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(y.isMacintosh)switch(E.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.l.minimize();break;case"None":break;case"Maximize":default:this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}else this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}close(){this.l?.close()}sendWhenReady(D,O,...W){this.isReady?this.send(D,...W):this.ready().then(()=>{O.isCancellationRequested||this.send(D,...W)})}send(D,...O){if(this.l){if(this.l.isDestroyed()||this.l.webContents.isDestroyed()){this.L.warn(`Sending IPC message to channel '${D}' for window that is destroyed`);return}try{this.l.webContents.send(D,...O)}catch(W){this.L.warn(`Error sending IPC message to channel '${D}' of window ${this.k}: ${(0,R.toErrorMessage)(W)}`)}}}updateTouchBar(D){!y.isMacintosh||this.D.forEach((O,W)=>{const j=D[W];O.segments=this.Fb(j)})}Db(){if(!!y.isMacintosh){for(let D=0;D<10;D++){const O=this.Eb();this.D.push(O)}this.l.setTouchBar(new E.TouchBar({items:this.D}))}}Eb(D=[]){const O=this.Fb(D),W=new E.TouchBar.TouchBarSegmentedControl({segments:O,mode:"buttons",segmentStyle:"automatic",change:j=>{this.sendWhenReady("vscode:runAction",C.CancellationToken.None,{id:W.segments[j].id,from:"touchbar"})}});return W}Fb(D=[]){return D.map(W=>{let j;W.icon&&!s.ThemeIcon.isThemeIcon(W.icon)&&W.icon?.dark?.scheme===w.Schemas.file&&(j=E.nativeImage.createFromPath(u.URI.revive(W.icon.dark).fsPath),j.isEmpty()&&(j=void 0));let $;return typeof W.title=="string"?$=W.title:$=W.title.value,{id:W.id,label:j?void 0:$,icon:j}})}dispose(){super.dispose(),this.l=null}};oe.a="windowControlHeight",oe.b=void 0,oe=pe([ee(1,i.ILogService),ee(2,p.IEnvironmentMainService),ee(3,G.IPolicyService),ee(4,se.IUserDataProfilesMainService),ee(5,I.IFileService),ee(6,o.IApplicationStorageMainService),ee(7,o.IStorageMainService),ee(8,h.IConfigurationService),ee(9,f.IThemeMainService),ee(10,U.IWorkspacesManagementMainService),ee(11,v.IBackupMainService),ee(12,c.ITelemetryService),ee(13,l.IDialogMainService),ee(14,m.ILifecycleMainService),ee(15,r.IProductService),ee(16,n.IProtocolMainService),ee(17,L.IWindowsMainService),ee(18,_.IStateMainService),ee(19,ce.INativeHostMainService)],oe),e.CodeWindow=oe}),define(ie[76],re([0,1,13,24,8,3,34,2,14,4,20,7,23,175,5,21,6,75,94,28,53,39]),function(H,e,E,t,C,R,A,P,g,w,b,S,y,u,d,v,h,l,p,k,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,d.createDecorator)("workspacesHistoryMainService");let i=class rt extends P.Disposable{constructor(n,a,o,c){super(),this.f=n,this.g=a,this.h=o,this.j=c,this.c=this.B(new R.Emitter),this.onDidChangeRecentlyOpened=this.c.event,this.z=this.B(new C.ThrottledDelayer(800)),this.k()}k(){this.h.when(4).then(()=>this.C()),this.B(this.g.onDidEnterWorkspace(n=>this.addRecentlyOpened([{workspace:n.workspace,remoteAuthority:n.window.remoteAuthority}])))}async addRecentlyOpened(n){let a=[],o=[];for(const s of n)if((0,p.isRecentWorkspace)(s))!this.g.isUntitledWorkspace(s.workspace)&&!this.r(a,s.workspace)&&a.push(s);else if((0,p.isRecentFolder)(s))this.s(a,s.folderUri)||a.push(s);else{const f=this.t(o,s.fileUri),M=s.fileUri.scheme===g.Schemas.file&&rt.y.indexOf((0,b.basename)(s.fileUri))>=0;!f&&!M&&(o.push(s),w.isWindows&&s.fileUri.scheme===g.Schemas.file&&E.app.addRecentDocument(s.fileUri.fsPath))}const c=await this.l({workspaces:a,files:o});a=c.workspaces,o=c.files,a.length>rt.a&&(a.length=rt.a),o.length>rt.a&&(o.length=rt.a),await this.n({workspaces:a,files:o}),this.c.fire(),w.isMacintosh&&this.z.trigger(()=>this.H())}async removeRecentlyOpened(n){const a=f=>{const M=this.p(f);for(const L of n)if(b.extUriBiasedIgnorePathCase.isEqual(L,M))return!1;return!0},o=await this.getRecentlyOpened(),c=o.workspaces.filter(a),s=o.files.filter(a);(c.length!==o.workspaces.length||s.length!==o.files.length)&&(await this.n({files:s,workspaces:c}),this.c.fire(),w.isMacintosh&&this.z.trigger(()=>this.H()))}async clearRecentlyOpened(){await this.n({workspaces:[],files:[]}),E.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.l()}async l(n){const a=new m.ResourceMap(s=>b.extUriBiasedIgnorePathCase.getComparisonKey(s));if(n?.workspaces)for(const s of n.workspaces)a.set(this.p(s),s);const o=new m.ResourceMap(s=>b.extUriBiasedIgnorePathCase.getComparisonKey(s));if(n?.files)for(const s of n.files)o.set(this.p(s),s);const c=await this.m();for(const s of c.workspaces){const f=a.get(this.p(s));f?f.label=f.label??s.label:a.set(this.p(s),s)}for(const s of c.files){const f=o.get(this.p(s));f?f.label=f.label??s.label:o.set(this.p(s),s)}return{workspaces:[...a.values()],files:[...o.values()]}}async m(){await this.j.whenReady;let n;const a=this.j.get(rt.b,-1);if(typeof a=="string")try{n=JSON.parse(a)}catch(o){this.f.error("Unexpected error parsing opened paths list",o)}return(0,p.restoreRecentlyOpened)(n,this.f)}async n(n){await this.j.whenReady,this.j.store(rt.b,JSON.stringify((0,p.toStoreData)(n)),-1,1)}p(n){return(0,p.isRecentFolder)(n)?n.folderUri:(0,p.isRecentFile)(n)?n.fileUri:n.workspace.configPath}r(n,a){return!!n.find(o=>(0,p.isRecentWorkspace)(o)&&o.workspace.id===a.id)}s(n,a){return!!n.find(o=>(0,p.isRecentFolder)(o)&&b.extUriBiasedIgnorePathCase.isEqual(o.folderUri,a))}t(n,a){return!!n.find(o=>b.extUriBiasedIgnorePathCase.isEqual(o.fileUri,a))}async C(){!w.isWindows||(await this.D(),this.B(this.onDidChangeRecentlyOpened(()=>this.D())))}async D(){if(!w.isWindows)return;const n=[];if(n.push({type:"tasks",items:[{type:"task",title:(0,u.localize)(0,null),description:(0,u.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const a=[];for(const s of E.app.getJumpListSettings().removedItems){const f=s.args;if(f){const M=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(f);M&&a.push(S.URI.parse(M[2]))}}await this.removeRecentlyOpened(a);let o=!1;const c=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,rt.w).map(s=>{const f=(0,p.isRecentWorkspace)(s)?s.workspace:s.folderUri,{title:M,description:L}=this.F(f,s.label);let T;return S.URI.isUri(f)?T=`--folder-uri "${f.toString()}"`:(o=!0,T=`--file-uri "${f.configPath.toString()}"`),{type:"task",title:M.substr(0,255),description:L.substr(0,255),program:process.execPath,args:T,iconPath:"explorer.exe",iconIndex:0}}));c.length>0&&n.push({type:"custom",name:o?(0,u.localize)(2,null):(0,u.localize)(3,null),items:c})}n.push({type:"recent"});try{const a=E.app.setJumpList(n);a&&a!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${a}`)}catch(a){this.f.warn("updateWindowsJumpList#setJumpList",a)}}F(n,a){if(a)return{title:(0,A.splitName)(a).name,description:a};if(S.URI.isUri(n))return{title:(0,b.basename)(n),description:this.G(n)};if(this.g.isUntitledWorkspace(n))return{title:(0,u.localize)(4,null),description:""};let o=(0,b.basename)(n.configPath);return o.endsWith(k.WORKSPACE_EXTENSION)&&(o=o.substr(0,o.length-k.WORKSPACE_EXTENSION.length-1)),{title:(0,u.localize)(5,null,o),description:this.G(n.configPath)}}G(n){return n.scheme==="file"?(0,A.normalizeDriveLetter)(n.fsPath):n.toString()}async H(){if(!w.isMacintosh)return;E.app.clearRecentDocuments();const n=await this.getRecentlyOpened(),a=[];let o=0;for(let s=0;s<n.workspaces.length&&o<rt.u;s++){const f=this.p(n.workspaces[s]);if(f.scheme===g.Schemas.file){const M=(0,b.originalFSPath)(f);await y.Promises.exists(M)&&(a.push(M),o++)}}const c=[];for(let s=0;s<n.files.length&&o<rt.v;s++){const f=this.p(n.files[s]);if(f.scheme===g.Schemas.file){const M=(0,b.originalFSPath)(f);if(rt.y.includes((0,b.basename)(f))||a.includes(M))continue;await y.Promises.exists(M)&&(c.push(M),o++)}}c.reverse().forEach(s=>E.app.addRecentDocument(s)),a.reverse().forEach(s=>E.app.addRecentDocument(s))}};i.a=500,i.b="history.recentlyOpenedPathsList",i.u=7,i.v=10,i.w=7,i.y=["COMMIT_EDITMSG","MERGE_MSG"],i=pe([ee(0,h.ILogService),ee(1,I.IWorkspacesManagementMainService),ee(2,v.ILifecycleMainService),ee(3,l.IApplicationStorageMainService)],i),e.WorkspacesHistoryMainService=i}),define(ie[272],re([0,1,13,8,22,34,4,7,165,18,27,21,6,213,58,19,36,31,49,74,32,76]),function(H,e,E,t,C,R,A,P,g,w,b,S,y,u,d,v,h,l,p,k,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const i="menu";let r=class Ft{constructor(o,c,s,f,M,L,T,U,K,V,G){this.n=o,this.o=c,this.p=s,this.q=f,this.r=M,this.s=L,this.t=T,this.u=U,this.v=K,this.w=V,this.x=G,this.m=Object.create(null),this.g=new t.RunOnceScheduler(()=>this.E(),0),this.h=new t.RunOnceScheduler(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(A.isMacintosh||(0,k.getTitleBarStyle)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const o=this.t.getItem(Ft.a);o&&(o.menus&&(this.k=o.menus),o.keybindings&&(this.l=o.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(L,T,U)=>this.p.openEmptyWindow({context:2,contextWindowId:T?.id}),this.m["workbench.action.newWindow"]=(L,T,U)=>this.p.openEmptyWindow({context:2,contextWindowId:T?.id}),this.m["workbench.action.files.openFileFolder"]=(L,T,U)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(U),telemetryExtraData:{from:i}}),this.m["workbench.action.files.openFolder"]=(L,T,U)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(U),telemetryExtraData:{from:i}}),this.m["workbench.action.openWorkspace"]=(L,T,U)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(U),telemetryExtraData:{from:i}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const o=this.x.twitterUrl;o&&(this.m["workbench.action.openTwitterUrl"]=()=>this.Z(o,"openTwitterUrl"));const c=this.x.requestFeatureUrl;c&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(c,"openUserVoiceUrl"));const s=this.x.reportIssueUrl;s&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(s,"openReportIssues"));const f=this.x.licenseUrl;f&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(A.language){const L=f.indexOf("?")>0?"&":"?";this.Z(`${f}${L}lang=${A.language}`,"openLicenseUrl")}else this.Z(f,"openLicenseUrl")});const M=this.x.privacyStatementUrl;M&&f&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(M,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(o=>this.F(o)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const o=this.o.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get C(){if(!A.isMacintosh)return!1;const o=this.o.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,c){this.k=o.menus,this.l=o.keybindings,this.t.setItem(Ft.a,o),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(o){!A.isMacintosh||(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.d=o.newCount===0,this.D())}G(){!A.isMacintosh||(this.f=!E.BrowserWindow.getFocusedWindow(),this.D())}H(){const o=E.Menu.getApplicationMenu();if(o&&this.j.push(o),Object.keys(this.k).length===0){E.Menu.setApplicationMenu(A.isMacintosh?new E.Menu:null);return}const c=new E.Menu;let s;if(A.isMacintosh){const M=new E.Menu;s=new E.MenuItem({label:this.x.nameShort,submenu:M}),this.I(M),c.append(s)}if(A.isMacintosh&&!this.c){this.c=!0;const M=new E.Menu;M.append(new E.MenuItem({label:this.bb(g.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),E.app.dock.setMenu(M)}if(this.K("File")){const M=new E.Menu,L=new E.MenuItem({label:this.bb(g.localize(1,null)),submenu:M});this.M(M,"File"),c.append(L)}if(this.K("Edit")){const M=new E.Menu,L=new E.MenuItem({label:this.bb(g.localize(2,null)),submenu:M});this.M(M,"Edit"),c.append(L)}if(this.K("Selection")){const M=new E.Menu,L=new E.MenuItem({label:this.bb(g.localize(3,null)),submenu:M});this.M(M,"Selection"),c.append(L)}if(this.K("View")){const M=new E.Menu,L=new E.MenuItem({label:this.bb(g.localize(4,null)),submenu:M});this.M(M,"View"),c.append(L)}if(this.K("Go")){const M=new E.Menu,L=new E.MenuItem({label:this.bb(g.localize(5,null)),submenu:M});this.M(M,"Go"),c.append(L)}if(this.K("Run")){const M=new E.Menu,L=new E.MenuItem({label:this.bb(g.localize(6,null)),submenu:M});this.M(M,"Run"),c.append(L)}if(this.K("Terminal")){const M=new E.Menu,L=new E.MenuItem({label:this.bb(g.localize(7,null)),submenu:M});this.M(M,"Terminal"),c.append(L)}let f;if(this.K("Window")){const M=new E.Menu;f=new E.MenuItem({label:this.bb(g.localize(8,null)),submenu:M,role:"window"}),this.S(M)}if(f&&c.append(f),this.K("Help")){const M=new E.Menu,L=new E.MenuItem({label:this.bb(g.localize(9,null)),submenu:M,role:"help"});this.M(M,"Help"),c.append(L)}c.items&&c.items.length>0?E.Menu.setApplicationMenu(c):E.Menu.setApplicationMenu(null),this.h.schedule()}I(o){const c=this.U(g.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),s=this.T();let f;if(this.K("Preferences")){const _=new E.Menu;this.M(_,"Preferences"),f=new E.MenuItem({label:this.bb(g.localize(11,null)),submenu:_})}const M=new E.Menu,L=new E.MenuItem({label:g.localize(12,null),role:"services",submenu:M}),T=new E.MenuItem({label:g.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),U=new E.MenuItem({label:g.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),K=new E.MenuItem({label:g.localize(15,null),role:"unhide"}),V=new E.MenuItem(this.Y("workbench.action.quit",{label:g.localize(16,null,this.x.nameLong),click:async(_,se,ce)=>{const X=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||!!E.BrowserWindow.getFocusedWindow()||X?.isMinimized())&&await this.J(ce)&&this.w.quit(void 0)}})),G=[c];G.push(...s),f&&G.push(n(),f),G.push(n(),L,n(),T,U,K,n(),V),G.forEach(_=>o.append(_))}async J(o){if(this.p.getWindowCount()===0)return!0;const c=this.o.getValue("window.confirmBeforeClose");if(c==="always"||c==="keyboardOnly"&&this.Q(o)){const s={title:this.x.nameLong,type:"question",buttons:[(0,R.mnemonicButtonLabel)(g.localize(17,null)),(0,R.mnemonicButtonLabel)(g.localize(18,null))],message:g.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:f}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,s);return f===0}return!0}K(o){if(!A.isMacintosh&&(0,k.getTitleBarStyle)(this.o)==="custom")return!1;switch(o){case"File":case"Help":if(A.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[o];case"Window":if(A.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[o]}}L(o,c){c.forEach(s=>{if((0,u.isMenubarMenuItemSeparator)(s))o.append(n());else if((0,u.isMenubarMenuItemSubmenu)(s)){const f=new E.Menu,M=new E.MenuItem({label:this.bb(s.label),submenu:f});this.L(f,s.submenu.items),o.append(M)}else(0,u.isMenubarMenuItemRecentAction)(s)?o.append(this.O(s)):(0,u.isMenubarMenuItemAction)(s)&&(s.id==="workbench.action.showAboutDialog"&&this.N(o),A.isMacintosh?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[s.id]?o.append(new E.MenuItem(this.Y(s.id,{label:this.bb(s.label),click:this.m[s.id]}))):o.append(this.U(s.label,s.id,!1,s.checked)):o.append(this.U(s.label,s.id,s.enabled!==!1,!!s.checked)):o.append(this.U(s.label,s.id,s.enabled!==!1,!!s.checked)))})}M(o,c){this.k&&this.k[c]&&this.L(o,this.k[c].items)}N(o){const c=this.T();c.length&&(c.forEach(s=>o.append(s)),o.append(n()))}O(o){const c=P.URI.revive(o.uri),s=o.id,f=s==="openRecentFile"?{fileUri:c}:s==="openRecentWorkspace"?{workspaceUri:c}:{folderUri:c};return new E.MenuItem(this.Y(s,{label:o.label,click:async(M,L,T)=>{const U=this.P(T);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[f],forceNewWindow:U,gotoLineMode:!1,remoteAuthority:o.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([c])}},!1))}P(o){return!!(o&&(!A.isMacintosh&&(o.ctrlKey||o.shiftKey)||A.isMacintosh&&(o.metaKey||o.altKey)))}Q(o){return!!(o.triggeredByAccelerator||o.altKey||o.ctrlKey||o.metaKey||o.shiftKey)}R(o,c,s){const f={label:this.bb(o),role:s,enabled:!0};return new E.MenuItem(this.X(c,f))}S(o){const c=new E.MenuItem({label:g.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),s=new E.MenuItem({label:g.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),f=new E.MenuItem({label:g.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),M=this.U(g.localize(23,null),"workbench.action.switchWindow"),L=[];this.C&&(L.push(n()),L.push(this.U(g.localize(24,null),"workbench.action.newWindowTab")),L.push(this.R(g.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),L.push(this.R(g.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),L.push(this.R(g.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),L.push(this.R(g.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[c,s,n(),M,...L,n(),f].forEach(T=>o.append(T))}T(){switch(this.n.state.type){case"uninitialized":return[];case"idle":return[new E.MenuItem({label:this.bb(g.localize(29,null)),click:()=>setTimeout(()=>{this.ab("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new E.MenuItem({label:g.localize(30,null),enabled:!1})];case"available for download":return[new E.MenuItem({label:this.bb(g.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new E.MenuItem({label:g.localize(32,null),enabled:!1})];case"downloaded":return[new E.MenuItem({label:this.bb(g.localize(33,null)),click:()=>{this.ab("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new E.MenuItem({label:g.localize(34,null),enabled:!1})];case"ready":return[new E.MenuItem({label:this.bb(g.localize(35,null)),click:()=>{this.ab("RestartToUpdate"),this.n.quitAndInstall()}})]}}U(o,c,s,f){const M=this.bb(o),L=typeof c=="function"?c:(G,_,se)=>{const ce=G?G.userSettingsLabel:null;let X=c;Array.isArray(c)&&(X=this.P(se)?c[1]:c[0]),ce&&se.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:ce}):this.W({type:"commandId",commandId:X})},T=typeof s=="boolean"?s:this.p.getWindowCount()>0,U=typeof f=="boolean"?f:!1,K={label:M,click:L,enabled:T};U&&(K.type="checkbox",K.checked=U);let V;return typeof c=="string"?V=c:Array.isArray(c)&&(V=c[0]),A.isMacintosh&&(V==="editor.action.clipboardCutAction"?K.role="cut":V==="editor.action.clipboardCopyAction"?K.role="copy":V==="editor.action.clipboardPasteAction"&&(K.role="paste"),V==="undo"?K.click=this.V(L,{inDevTools:G=>G.undo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("undo:")}):V==="redo"?K.click=this.V(L,{inDevTools:G=>G.redo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("redo:")}):V==="editor.action.selectAll"&&(K.click=this.V(L,{inDevTools:G=>G.selectAll(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("selectAll:")}))),new E.MenuItem(this.X(V,K))}V(o,c){return(s,f,M)=>{const L=E.BrowserWindow.getFocusedWindow();if(!L)return c.inNoWindow();if(L.webContents.isDevToolsFocused()&&L.webContents.devToolsWebContents)return c.inDevTools(L.webContents.devToolsWebContents);o(s,f||L,M)}}W(o){let c=E.BrowserWindow.getFocusedWindow();if(!c){const f=this.p.getLastActiveWindow();f?.isMinimized()&&(c=f.win)}const s=c?this.p.getWindowById(c.id):void 0;if(s){if(this.v.trace("menubar#runActionInRenderer",o),A.isMacintosh&&!this.q.isBuilt&&!s.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const f={id:o.commandId,from:"menu"};s.sendWhenReady("vscode:runAction",C.CancellationToken.None,f)}else{const f={userSettingsLabel:o.userSettingsLabel};s.sendWhenReady("vscode:runKeybinding",C.CancellationToken.None,f)}}else this.v.trace("menubar#runActionInRenderer: no active window found",o)}X(o,c){const s=typeof o=="string"?this.l[o]:void 0;if(s?.label){if(s.isNative!==!1)c.accelerator=s.label,c.userSettingsLabel=s.userSettingsLabel;else if(typeof c.label=="string"){const f=c.label.indexOf("[");f>=0?c.label=`${c.label.substr(0,f)} [${s.label}]`:c.label=`${c.label} [${s.label}]`}}else c.accelerator=void 0;return c}Y(o,c,s=!c.accelerator){s&&(c=this.X(o,c));const f=c.click;return c.click=(M,L,T)=>{this.ab(o),f?.(M,L,T)},c}Z(o,c){this.w.openExternal(void 0,o),this.ab(c)}ab(o){this.r.publicLog2("workbenchActionExecuted",{id:o,from:i})}bb(o){return(0,R.mnemonicMenuLabel)(o,!this.B)}};r.a="lastKnownMenubarData",r=pe([ee(0,p.IUpdateService),ee(1,w.IConfigurationService),ee(2,I.IWindowsMainService),ee(3,b.IEnvironmentMainService),ee(4,l.ITelemetryService),ee(5,m.IWorkspacesHistoryMainService),ee(6,h.IStateMainService),ee(7,S.ILifecycleMainService),ee(8,y.ILogService),ee(9,d.INativeHostMainService),ee(10,v.IProductService)],r),e.Menubar=r;function n(){return new E.MenuItem({type:"separator"})}}),define(ie[273],re([0,1,5,21,6,272]),function(H,e,E,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,E.createDecorator)("menubarMainService");let A=class{constructor(g,w,b){this.b=g,this.c=w,this.d=b,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(R.Menubar)}async updateMenubar(g,w){this.d.trace("menubarService#updateMenubar",g),(await this.a).updateMenu(w,g)}};A=pe([ee(0,E.IInstantiationService),ee(1,t.ILifecycleMainService),ee(2,C.ILogService)],A),e.MenubarMainService=A}),define(ie[274],re([0,1,13,23,25,24,22,3,30,50,34,2,14,9,73,4,33,20,11,7,173,62,18,57,27,16,5,21,6,63,19,64,55,36,74,271,118,266,28,95,76,53,66,37,52]),function(H,e,E,t,C,R,A,P,g,w,b,S,y,u,d,v,h,l,p,k,I,m,i,r,n,a,o,c,s,f,M,L,T,U,K,V,G,_,se,ce,X,ue,z,N,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function q(x){return(0,se.isWorkspaceIdentifier)(x?.workspace)}function Q(x){return(0,se.isSingleFolderWorkspaceIdentifier)(x?.workspace)}let oe=class mt extends S.Disposable{constructor(D,O,W,j,$,Y,B,Z,te,ae,ge,ke,Oe,De,Re,ve,we,ye){super(),this.k=D,this.l=O,this.m=W,this.n=j,this.r=$,this.s=Y,this.t=B,this.u=Z,this.v=te,this.w=ae,this.z=ge,this.C=ke,this.D=Oe,this.F=De,this.G=Re,this.H=ve,this.I=we,this.J=ye,this.b=this.B(new P.Emitter),this.onDidOpenWindow=this.b.event,this.c=this.B(new P.Emitter),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new P.Emitter),this.onDidDestroyWindow=this.f.event,this.g=this.B(new P.Emitter),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new P.Emitter),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new _.WindowsStateHandler(this,this.n,this.u,this.m,this.w)),this.L()}L(){this.B(this.C.onDidEnterWorkspace(D=>this.c.fire(D.window))),this.B(this.onDidSignalReadyWindow(D=>{if(D.config?.extensionDevelopmentPath||D.config?.extensionTestsPath){const O=new S.DisposableStore;if(O.add(P.Event.any(D.onDidClose,D.onDidDestroy)(()=>O.dispose())),D.config.extensionDevelopmentPath)for(const W of D.config.extensionDevelopmentPath)O.add(this.I.addValidFileRoot(W));D.config.extensionTestsPath&&O.add(this.I.addValidFileRoot(D.config.extensionTestsPath))}}))}openEmptyWindow(D,O){const W=this.s.args,j=O?.remoteAuthority||void 0,$=!0,Y=O?.forceReuseWindow,B=!Y;return this.open({...D,cli:W,forceEmpty:$,forceNewWindow:B,forceReuseWindow:Y,remoteAuthority:j})}openExistingWindow(D,O){D.focus(),this.M(O,[D])}async open(D){this.m.trace("windowsManager#open"),D.addMode&&(D.initialStartup||!this.getLastActiveWindow())&&(D.addMode=!1);const O=[],W=[],j=[],$=[],Y=[];let B,Z=0;const te=await this.S(D);this.m.trace("windowsManager#open pathsToOpen",te);for(const De of te)Q(De)?D.addMode?O.push(De):W.push(De):q(De)?j.push(De):De.fileUri?(B||(B={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:De.remoteAuthority}),B.filesToOpenOrCreate.push(De)):De.backupPath?Y.push({backupFolder:(0,u.basename)(De.backupPath),remoteAuthority:De.remoteAuthority}):Z++;D.diffMode&&B&&B.filesToOpenOrCreate.length>=2&&(B.filesToDiff=B.filesToOpenOrCreate.slice(0,2),B.filesToOpenOrCreate=[]),D.mergeMode&&B&&B.filesToOpenOrCreate.length===4&&(B.filesToMerge=B.filesToOpenOrCreate.slice(0,4),B.filesToOpenOrCreate=[],B.filesToDiff=[]),B&&D.waitMarkerFileURI&&(B.filesToWait={paths:(0,R.coalesce)([...B.filesToDiff,B.filesToMerge[3],...B.filesToOpenOrCreate]),waitMarkerFileUri:D.waitMarkerFileURI}),D.initialStartup?($.push(...this.C.getUntitledWorkspaces()),j.push(...$),Y.push(...this.v.getEmptyWindowBackups())):Y.length=0;const{windows:ae,filesOpenedInWindow:ge}=await this.N(D,j,W,Y,Z,B,O);if(this.m.trace(`windowsManager#open used window count ${ae.length} (workspacesToOpen: ${j.length}, foldersToOpen: ${W.length}, emptyToRestore: ${Y.length}, emptyToOpen: ${Z})`),ae.length>1)if(ge)ge.focus();else{const De=this.j.state.lastActiveWindow&&!D.forceEmpty&&!D.cli._.length&&!D.cli["file-uri"]&&!D.cli["folder-uri"]&&!(D.urisToOpen&&D.urisToOpen.length);let Re=!0,ve=!0;if(De){const we=ae.filter(ye=>this.j.state.lastActiveWindow&&ye.backupPath===this.j.state.lastActiveWindow.backupPath);we.length&&(we[0].focus(),Re=!1,ve=!1)}if(Re)for(let we=ae.length-1;we>=0;we--){const ye=ae[we];if(!(ye.openedWorkspace&&$.some(Me=>ye.openedWorkspace&&Me.workspace.id===ye.openedWorkspace.id)||ye.backupPath&&Y.some(Me=>ye.backupPath&&Me.backupFolder===(0,u.basename)(ye.backupPath)))){ye.focus(),ve=!1;break}}ve&&ae[ae.length-1].focus()}const ke=B&&B.filesToDiff.length>0,Oe=B&&B.filesToMerge.length>0;if(!ae.some(De=>De.isExtensionDevelopmentHost)&&!ke&&!Oe&&!D.noRecentEntry){const De=[];for(const Re of te)q(Re)&&!Re.transient?De.push({label:Re.label,workspace:Re.workspace,remoteAuthority:Re.remoteAuthority}):Q(Re)?De.push({label:Re.label,folderUri:Re.workspace.uri,remoteAuthority:Re.remoteAuthority}):Re.fileUri&&De.push({label:Re.label,fileUri:Re.fileUri,remoteAuthority:Re.remoteAuthority});this.z.addRecentlyOpened(De)}return this.M(D,ae),ae}M(D,O){const W=D.waitMarkerFileURI;D.context===0&&W&&O.length===1&&O[0]&&(async()=>{await O[0].whenClosedOrLoaded;try{await this.G.del(W)}catch{}})()}async N(D,O,W,j,$,Y,B){const Z=[];let te;function ae(we,ye){Z.push(we),ye&&(te=we,Y=void 0)}let{openFolderInNewWindow:ge,openFilesInNewWindow:ke}=this.fb(D);if(!D.initialStartup&&B.length>0){const we=B[0].remoteAuthority,ye=this.kb(we);ye&&ae(this.P(ye,B.map(Me=>Me.workspace.uri)))}const Oe=W.length+O.length+j.length;if(Y&&Oe===0){const we=Y.filesToOpenOrCreate[0]||Y.filesToDiff[0]||Y.filesToMerge[3],ye=this.getWindows().filter(ne=>Y&&(0,l.isEqualAuthority)(ne.remoteAuthority,Y.remoteAuthority));let Me;we?.fileUri&&!ke&&((D.context===4||D.context===0||D.context===1)&&(Me=await(0,G.findWindowOnFile)(ye,we.fileUri,async ne=>ne.configPath.scheme===y.Schemas.file?this.C.resolveLocalWorkspace(ne.configPath):void 0)),Me||(Me=this.lb(ye))),Me?(0,se.isWorkspaceIdentifier)(Me.openedWorkspace)?O.push({workspace:Me.openedWorkspace,remoteAuthority:Me.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(Me.openedWorkspace)?W.push({workspace:Me.openedWorkspace,remoteAuthority:Me.remoteAuthority}):ae(this.O(D,Me,Y),!0):ae(await this.gb({userEnv:D.userEnv,cli:D.cli,initialStartup:D.initialStartup,filesToOpen:Y,forceNewWindow:!0,remoteAuthority:Y.remoteAuthority,forceNewTabbedWindow:D.forceNewTabbedWindow,forceProfile:D.forceProfile,forceTempProfile:D.forceTempProfile}),!0)}const De=(0,R.distinct)(O,we=>we.workspace.id);if(De.length>0){const we=(0,R.coalesce)(De.map(ye=>(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),ye.workspace.configPath)));if(we.length>0){const ye=we[0],Me=(0,l.isEqualAuthority)(Y?.remoteAuthority,ye.remoteAuthority)?Y:void 0;ae(this.O(D,ye,Me),!!Me),ge=!0}for(const ye of De){if(we.some(fe=>fe.openedWorkspace&&fe.openedWorkspace.id===ye.workspace.id))continue;const Me=ye.remoteAuthority,ne=(0,l.isEqualAuthority)(Y?.remoteAuthority,Me)?Y:void 0;ae(await this.R(D,ye,ge,ne),!!ne),ge=!0}}const Re=(0,R.distinct)(W,we=>l.extUriBiasedIgnorePathCase.getComparisonKey(we.workspace.uri));if(Re.length>0){const we=(0,R.coalesce)(Re.map(ye=>(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),ye.workspace.uri)));if(we.length>0){const ye=we[0],Me=(0,l.isEqualAuthority)(Y?.remoteAuthority,ye.remoteAuthority)?Y:void 0;ae(this.O(D,ye,Me),!!Me),ge=!0}for(const ye of Re){if(we.some(fe=>(0,se.isSingleFolderWorkspaceIdentifier)(fe.openedWorkspace)&&l.extUriBiasedIgnorePathCase.isEqual(fe.openedWorkspace.uri,ye.workspace.uri)))continue;const Me=ye.remoteAuthority,ne=(0,l.isEqualAuthority)(Y?.remoteAuthority,Me)?Y:void 0;ae(await this.R(D,ye,ge,ne),!!ne),ge=!0}}const ve=(0,R.distinct)(j,we=>we.backupFolder);if(ve.length>0)for(const we of ve){const ye=we.remoteAuthority,Me=(0,l.isEqualAuthority)(Y?.remoteAuthority,ye)?Y:void 0;ae(await this.Q(D,!0,ye,Me,we),!!Me),ge=!0}if(Z.length===0||Y){Y&&!$&&$++;const we=Y?Y.remoteAuthority:D.remoteAuthority;for(let ye=0;ye<$;ye++)ae(await this.Q(D,ge,we,Y),!!Y),ge=!0}return{windows:(0,R.distinct)(Z),filesOpenedInWindow:te}}O(D,O,W){this.m.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:W}),O.focus();const j={filesToOpenOrCreate:W?.filesToOpenOrCreate,filesToDiff:W?.filesToDiff,filesToMerge:W?.filesToMerge,filesToWait:W?.filesToWait,termProgram:D?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",A.CancellationToken.None,j),O}P(D,O){this.m.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:O}),D.focus();const W={foldersToAdd:O};return D.sendWhenReady("vscode:addFolders",A.CancellationToken.None,W),D}Q(D,O,W,j,$){this.m.trace("windowsManager#doOpenEmpty",{restore:!!$,remoteAuthority:W,filesToOpen:j,forceNewWindow:O});let Y;return!O&&typeof D.contextWindowId=="number"&&(Y=this.getWindowById(D.contextWindowId)),this.gb({userEnv:D.userEnv,cli:D.cli,initialStartup:D.initialStartup,remoteAuthority:W,forceNewWindow:O,forceNewTabbedWindow:D.forceNewTabbedWindow,filesToOpen:j,windowToUse:Y,emptyWindowBackupInfo:$,forceProfile:D.forceProfile,forceTempProfile:D.forceTempProfile})}R(D,O,W,j,$){return this.m.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:O,filesToOpen:j}),!W&&!$&&typeof D.contextWindowId=="number"&&($=this.getWindowById(D.contextWindowId)),this.gb({workspace:O.workspace,userEnv:D.userEnv,cli:D.cli,initialStartup:D.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:W,forceNewTabbedWindow:D.forceNewTabbedWindow,filesToOpen:j,windowToUse:$,forceProfile:D.forceProfile,forceTempProfile:D.forceTempProfile})}async S(D){let O,W=!1,j=!1;if(D.urisToOpen&&D.urisToOpen.length>0?(O=await this.U(D),W=!0):D.forceEmpty?O=[Object.create(null)]:D.cli._.length||D.cli["folder-uri"]||D.cli["file-uri"]?(O=await this.W(D.cli),O.length===0&&O.push(Object.create(null)),W=!0):(O=await this.Y(),O.length===0&&O.push(Object.create(null)),j=!0),!D.addMode&&W){const $=O.filter(Y=>Q(Y));if($.length>1){const Y=$[0].remoteAuthority;if($.every(B=>(0,l.isEqualAuthority)(B.remoteAuthority,Y))){const B=await this.C.createUntitledWorkspace($.map(Z=>({uri:Z.workspace.uri})));O.push({workspace:B,remoteAuthority:Y}),O=O.filter(Z=>!Q(Z))}}}if(D.initialStartup&&!j&&this.w.getValue("window")?.restoreWindows==="preserve"){const $=await this.Y();O.unshift(...$.filter(Y=>q(Y)||Q(Y)||Y.backupPath))}return O}async U(D){const O={gotoLineMode:D.gotoLineMode,remoteAuthority:D.remoteAuthority},W=await Promise.all((0,R.coalesce)(D.urisToOpen||[]).map(async j=>{const $=await this.ab(j,O);if($)return $.label=j.label,$;const Y=this.cb(j),B={title:this.H.nameLong,type:"info",buttons:[(0,b.mnemonicButtonLabel)((0,I.localize)(0,null))],defaultId:0,message:Y.scheme===y.Schemas.file?(0,I.localize)(1,null):(0,I.localize)(2,null),detail:Y.scheme===y.Schemas.file?(0,I.localize)(3,null,(0,b.getPathLabel)(Y,{os:v.OS,tildify:this.s})):(0,I.localize)(4,null,Y.toString(!0)),noLink:!0};this.F.showMessageBox(B,(0,p.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow()))}));return(0,R.coalesce)(W)}async W(D){const O=[],W={ignoreFileNotFound:!0,gotoLineMode:D.goto,remoteAuthority:D.remote||void 0,forceOpenWorkspaceAsFile:D.diff&&D._.length===2||D.merge&&D._.length===4},j=D["folder-uri"];if(j){const B=await Promise.all(j.map(Z=>{const te=this.X(Z);if(!!te)return this.ab({folderUri:te},W)}));O.push(...(0,R.coalesce)(B))}const $=D["file-uri"];if($){const B=await Promise.all($.map(Z=>{const te=this.X(Z);if(!!te)return this.ab((0,se.hasWorkspaceFileExtension)(Z)?{workspaceUri:te}:{fileUri:te},W)}));O.push(...(0,R.coalesce)(B))}const Y=await Promise.all(D._.map(B=>W.remoteAuthority?this.eb(B,W):this.db(B,W)));return O.push(...(0,R.coalesce)(Y)),O}X(D){try{const O=k.URI.parse(D);if(!O.scheme){this.m.error(`Invalid URI input string, scheme missing: ${D}`);return}return O}catch(O){this.m.error(`Invalid URI input string: ${D}, ${O.message}`)}}async Y(){const D=this.Z();switch(D){case"none":return[];case"one":case"all":case"preserve":case"folders":{const O=[];D!=="one"&&O.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&O.push(this.j.state.lastActiveWindow);const W=await Promise.all(O.map(async j=>{if(j.workspace){const $=await this.ab({workspaceUri:j.workspace.configPath},{remoteAuthority:j.remoteAuthority,rejectTransientWorkspaces:!0});if(q($))return $}else if(j.folderUri){const $=await this.ab({folderUri:j.folderUri},{remoteAuthority:j.remoteAuthority});if(Q($))return $}else if(D!=="folders"&&j.backupPath)return{backupPath:j.backupPath,remoteAuthority:j.remoteAuthority}}));return(0,R.coalesce)(W)}}}Z(){let D;return this.u.wasRestarted?D="all":(D=this.w.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(D)||(D="all")),D}async ab(D,O=Object.create(null)){const W=this.cb(D);return W.scheme===y.Schemas.file?((0,K.isFileToOpen)(D)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.db(W.fsPath,O)):this.bb(D,O)}bb(D,O){let W=this.cb(D);const j=(0,T.getRemoteAuthority)(W)||O.remoteAuthority;if(W=(0,l.removeTrailingPathSeparator)((0,l.normalizePath)(W)),(0,K.isFileToOpen)(D)){if(O.gotoLineMode){const{path:$,line:Y,column:B}=(0,g.parseLineAndColumnAware)(W.path);return{fileUri:W.with({path:$}),options:{selection:Y?{startLineNumber:Y,startColumn:B||1}:void 0},remoteAuthority:j}}return{fileUri:W,remoteAuthority:j}}else if((0,K.isWorkspaceToOpen)(D))return{workspace:(0,ce.getWorkspaceIdentifier)(W),remoteAuthority:j};return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)(W),remoteAuthority:j}}cb(D){return(0,K.isWorkspaceToOpen)(D)?D.workspaceUri:(0,K.isFolderToOpen)(D)?D.folderUri:D.fileUri}async db(D,O){let W,j;O.gotoLineMode&&({path:D,line:W,column:j}=(0,g.parseLineAndColumnAware)(D)),D=(0,g.sanitizeFilePath)((0,u.normalize)(D),(0,h.cwd)());try{const $=await t.Promises.stat(D);if($.isFile()){if(!O.forceOpenWorkspaceAsFile){const Y=await this.C.resolveLocalWorkspace(k.URI.file(D));if(Y)return Y.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:Y.id,configPath:Y.configPath},type:a.FileType.File,exists:!0,remoteAuthority:Y.remoteAuthority,transient:Y.transient}}return{fileUri:k.URI.file(D),type:a.FileType.File,exists:!0,options:{selection:W?{startLineNumber:W,startColumn:j||1}:void 0}}}else{if($.isDirectory())return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)(k.URI.file(D),$),type:a.FileType.Directory,exists:!0};if(!v.isWindows&&D==="/dev/null")return{fileUri:k.URI.file(D),type:a.FileType.File,exists:!0}}}catch{const Y=k.URI.file(D);if(this.z.removeRecentlyOpened([Y]),O.ignoreFileNotFound)return{fileUri:Y,type:a.FileType.File,exists:!1}}}eb(D,O){const W=D.charCodeAt(0),j=O.remoteAuthority;let $,Y;O.gotoLineMode&&({path:D,line:$,column:Y}=(0,g.parseLineAndColumnAware)(D)),W!==47&&((0,g.isWindowsDriveLetter)(W)&&D.charCodeAt(D.charCodeAt(1))===58&&(D=(0,g.toSlashes)(D)),D=`/${D}`);const B=k.URI.from({scheme:y.Schemas.vscodeRemote,authority:j,path:D});if(D.charCodeAt(D.length-1)!==47){if((0,se.hasWorkspaceFileExtension)(D))return O.forceOpenWorkspaceAsFile?{fileUri:B,options:{selection:$?{startLineNumber:$,startColumn:Y||1}:void 0},remoteAuthority:O.remoteAuthority}:{workspace:(0,ce.getWorkspaceIdentifier)(B),remoteAuthority:j};if(O.gotoLineMode||u.posix.basename(D).indexOf(".")!==-1)return{fileUri:B,options:{selection:$?{startLineNumber:$,startColumn:Y||1}:void 0},remoteAuthority:j}}return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)(B),remoteAuthority:j}}fb(D){const O=this.w.getValue("window"),W=O?.openFoldersInNewWindow||"default",j=O?.openFilesInNewWindow||"off";let $=(D.preferNewWindow||D.forceNewWindow)&&!D.forceReuseWindow;!D.forceNewWindow&&!D.forceReuseWindow&&(W==="on"||W==="off")&&($=W==="on");let Y=!1;return D.forceNewWindow||D.forceReuseWindow?Y=!!D.forceNewWindow&&!D.forceReuseWindow:(v.isMacintosh?D.context===1&&(Y=!0):D.context!==3&&D.context!==2&&!(D.userEnv&&D.userEnv.TERM_PROGRAM==="vscode")&&(Y=!0),!D.cli.extensionDevelopmentPath&&(j==="on"||j==="off")&&(Y=j==="on")),{openFolderInNewWindow:!!$,openFilesInNewWindow:Y}}async openExtensionDevelopmentHostWindow(D,O){const W=(0,G.findWindowOnExtensionDevelopmentPath)(this.getWindows(),D);if(W)return this.u.reload(W,O.cli),W.focus(),[W];let j=O.cli["folder-uri"]||[],$=O.cli["file-uri"]||[],Y=O.cli._;if(!Y.length&&!j.length&&!$.length&&!O.cli.extensionTestsPath){const te=this.j.state.lastPluginDevelopmentHostWindow,ae=te?.workspace??te?.folderUri;ae&&(k.URI.isUri(ae)?ae.scheme===y.Schemas.file?Y=[ae.fsPath]:j=[ae.toString()]:ae.configPath.scheme===y.Schemas.file?Y=[(0,l.originalFSPath)(ae.configPath)]:$=[ae.configPath.toString()])}let B=O.remoteAuthority;for(const te of D)if(te.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ae=k.URI.parse(te),ge=(0,T.getRemoteAuthority)(ae);ge&&(B?(0,l.isEqualAuthority)(ge,B)||this.m.error("more than one extension development path authority"):B=ge)}Y=Y.filter(te=>{const ae=k.URI.file(te);return(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),ae)?!1:(0,l.isEqualAuthority)((0,T.getRemoteAuthority)(ae),B)}),j=j.filter(te=>{const ae=this.X(te);return ae&&!!(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),ae)?!1:ae?(0,l.isEqualAuthority)((0,T.getRemoteAuthority)(ae),B):!1}),$=$.filter(te=>{const ae=this.X(te);return ae&&!!(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),ae)?!1:ae?(0,l.isEqualAuthority)((0,T.getRemoteAuthority)(ae),B):!1}),O.cli._=Y,O.cli["folder-uri"]=j,O.cli["file-uri"]=$;const Z={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:!Y.length&&!j.length&&!$.length,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:B,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile};return this.open(Z)}async gb(D){const O=this.w.getValue("window");let W;!D.forceNewWindow&&!D.forceNewTabbedWindow&&(W=D.windowToUse||this.getLastActiveWindow(),W&&W.focus());const j={...this.s.args,...D.cli,machineId:this.k,windowId:-1,mainPid:process.pid,appRoot:this.s.appRoot,execPath:process.execPath,codeCachePath:this.s.codeCachePath,backupPath:D.emptyWindowBackupInfo?(0,u.join)(this.s.backupHome,D.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.t.profiles,profile:this.t.defaultProfile},homeDir:this.s.userHome.fsPath,tmpDir:this.s.tmpDir.fsPath,userDataDir:this.s.userDataPath,remoteAuthority:D.remoteAuthority,workspace:D.workspace,userEnv:{...this.l,...D.userEnv},filesToOpenOrCreate:D.filesToOpen?.filesToOpenOrCreate,filesToDiff:D.filesToOpen?.filesToDiff,filesToMerge:D.filesToOpen?.filesToMerge,filesToWait:D.filesToOpen?.filesToWait,logLevel:this.m.getLevel(),logsPath:this.s.logsPath,product:f.default,isInitialStartup:D.initialStartup,perfMarks:(0,d.getMarks)(),os:{release:(0,C.release)(),hostname:(0,C.hostname)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,autoDetectColorScheme:O?.autoDetectColorScheme??!1,accessibilitySupport:E.app.accessibilitySupportEnabled,colorScheme:this.J.getColorScheme(),policiesData:this.r.serialize(),continueOn:this.s.continueOn};if(W){const $=W.config;!j.extensionDevelopmentPath&&$?.extensionDevelopmentPath&&(j.extensionDevelopmentPath=$.extensionDevelopmentPath,j.extensionDevelopmentKind=$.extensionDevelopmentKind,j["enable-proposed-api"]=$["enable-proposed-api"],j.verbose=$.verbose,j["inspect-extensions"]=$["inspect-extensions"],j["inspect-brk-extensions"]=$["inspect-brk-extensions"],j.debugId=$.debugId,j.extensionEnvironment=$.extensionEnvironment,j["extensions-dir"]=$["extensions-dir"],j["disable-extensions"]=$["disable-extensions"])}else{const $=this.j.getNewWindowState(j);(0,d.mark)("code/willCreateCodeWindow");const Y=W=this.D.createInstance(V.CodeWindow,{state:$,extensionDevelopmentPath:j.extensionDevelopmentPath,isExtensionTestHost:!!j.extensionTestsPath});(0,d.mark)("code/didCreateCodeWindow"),D.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(Y),mt.a.push(Y),this.b.fire(Y),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,w.once)(Y.onDidSignalReady)(()=>this.c.fire(Y)),(0,w.once)(Y.onDidClose)(()=>this.jb(Y)),(0,w.once)(Y.onDidDestroy)(()=>this.f.fire(Y)),Y.onDidTriggerSystemContextMenu(({x:Z,y:te})=>this.h.fire({window:Y,x:Z,y:te}));const B=(0,p.assertIsDefined)(Y.win?.webContents);B.removeAllListeners("devtools-reload-page"),B.on("devtools-reload-page",()=>this.u.reload(Y)),this.u.registerWindow(Y)}return j.windowId=W.id,W.isReady?this.u.unload(W,4).then(async $=>{$||await this.hb(W,j,D)}):await this.hb(W,j,D),W}async hb(D,O,W){if(O.extensionDevelopmentPath||((0,se.isWorkspaceIdentifier)(O.workspace)?O.backupPath=this.v.registerWorkspaceBackup({workspace:O.workspace,remoteAuthority:O.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(O.workspace)?O.backupPath=this.v.registerFolderBackup({folderUri:O.workspace.uri,remoteAuthority:O.remoteAuthority}):O.backupPath=this.v.registerEmptyWindowBackup({backupFolder:W.emptyWindowBackupInfo?.backupFolder??(0,ce.createEmptyWorkspaceIdentifier)().id,remoteAuthority:O.remoteAuthority})),this.t.isEnabled()){const j=O.workspace??(0,se.toWorkspaceIdentifier)(O.backupPath,!1),$=this.ib(W,j),Y=$ instanceof Promise?await $:$;O.profiles.profile=Y,O.extensionDevelopmentPath||await this.t.setProfileForWorkspace(j,Y)}D.load(O)}ib(D,O){return D.forceProfile?this.t.profiles.find(W=>W.name===D.forceProfile)??this.t.createNamedProfile(D.forceProfile):D.forceTempProfile?this.t.createTransientProfile():this.t.getProfileForWorkspace(O)??this.t.defaultProfile}jb(D){const O=mt.a.indexOf(D);mt.a.splice(O,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const D=E.BrowserWindow.getFocusedWindow();if(D)return this.getWindowById(D.id)}getLastActiveWindow(){return this.lb(this.getWindows())}kb(D){return this.lb(this.getWindows().filter(O=>(0,l.isEqualAuthority)(O.remoteAuthority,D)))}lb(D){const O=Math.max.apply(Math,D.map(W=>W.lastFocusTime));return D.find(W=>W.lastFocusTime===O)}sendToFocused(D,...O){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(D,A.CancellationToken.None,...O)}sendToAll(D,O,W){for(const j of this.getWindows())W&&W.indexOf(j.id)>=0||j.sendWhenReady(D,A.CancellationToken.None,O)}getWindows(){return mt.a}getWindowCount(){return mt.a.length}getWindowById(D){const O=this.getWindows().filter(W=>W.id===D);return(0,R.firstOrDefault)(O)}getWindowByWebContents(D){const O=E.BrowserWindow.fromWebContents(D);if(!!O)return this.getWindowById(O.id)}};oe.a=[],oe=pe([ee(2,s.ILogService),ee(3,U.IStateMainService),ee(4,N.IPolicyService),ee(5,n.IEnvironmentMainService),ee(6,F.IUserDataProfilesMainService),ee(7,c.ILifecycleMainService),ee(8,m.IBackupMainService),ee(9,i.IConfigurationService),ee(10,X.IWorkspacesHistoryMainService),ee(11,ue.IWorkspacesManagementMainService),ee(12,o.IInstantiationService),ee(13,r.IDialogMainService),ee(14,a.IFileService),ee(15,M.IProductService),ee(16,L.IProtocolMainService),ee(17,z.IThemeMainService)],oe),e.WindowsMainService=oe}),define(ie[275],re([0,1,62,32,76,53]),function(H,e,E,t,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let A=class{constructor(g,w,b,S){this.a=g,this.b=w,this.c=b,this.d=S,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(g,w){const b=this.b.getWindowById(g);if(b)return this.a.enterWorkspace(b,this.b.getWindows(),w)}createUntitledWorkspace(g,w,b){return this.a.createUntitledWorkspace(w,b)}deleteUntitledWorkspace(g,w){return this.a.deleteUntitledWorkspace(w)}getWorkspaceIdentifier(g,w){return this.a.getWorkspaceIdentifier(w)}getRecentlyOpened(g){return this.c.getRecentlyOpened()}addRecentlyOpened(g,w){return this.c.addRecentlyOpened(w)}removeRecentlyOpened(g,w){return this.c.removeRecentlyOpened(w)}clearRecentlyOpened(g){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};A=pe([ee(0,R.IWorkspacesManagementMainService),ee(1,t.IWindowsMainService),ee(2,C.IWorkspacesHistoryMainService),ee(3,E.IBackupMainService)],A),e.WorkspacesMainService=A}),define(ie[276],re([0,1,13,41,25,17,45,15,30,50,43,34,2,14,9,4,11,7,29,132,47,146,103,252,149,62,267,18,71,181,85,119,57,106,204,27,61,110,194,216,195,254,107,196,197,16,208,87,70,5,86,268,229,255,21,6,210,273,58,19,55,261,89,36,258,75,90,31,234,112,51,49,243,244,269,245,270,115,247,248,249,250,256,32,274,257,28,94,76,275,53,253,37,215,52,225,56,92,117,259,265,263,8,113]),function(H,e,E,t,C,R,A,P,g,w,b,S,y,u,d,v,h,l,p,k,I,m,i,r,n,a,o,c,s,f,M,L,T,U,K,V,G,_,se,ce,X,ue,z,N,F,q,Q,oe,x,D,O,W,j,$,Y,B,Z,te,ae,ge,ke,Oe,De,Re,ve,we,ye,Me,ne,fe,de,be,Pe,We,Te,qe,Ue,je,Xe,$e,Ke,J,le,he,me,Se,Le,Be,it,xe,He,tt,nt,lt,at,Bt,$t,Wt,zt,qt,Ht,Vt,Pt,Gt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Ct=class extends y.Disposable{constructor(Ee,Ce,Ae,Ie,Fe,ze,_e,et,Ne,Ge,Je){super(),this.c=Ee,this.f=Ce,this.g=Ae,this.h=Ie,this.i=Fe,this.j=ze,this.k=_e,this.l=et,this.m=Ne,this.n=Ge,this.p=Je,this.r(),this.s()}r(){const Ee=Ne=>Ne?.startsWith(`${u.Schemas.vscodeWebview}://`),Ce=new Set(["clipboard-read","clipboard-sanitized-write"]);E.session.defaultSession.setPermissionRequestHandler((Ne,Ge,Je,Ze)=>Ee(Ze.requestingUrl)?Je(Ce.has(Ge)):Je(!1)),E.session.defaultSession.setPermissionCheckHandler((Ne,Ge,Je,Ze)=>Ee(Ze.requestingUrl)?Ce.has(Ge):!1);const Ae=new Set([u.Schemas.file,u.Schemas.vscodeFileResource,u.Schemas.vscodeRemoteResource,"devtools"]),Ie=Ne=>{for(let Ge=Ne;Ge;Ge=Ge.parent)if(Ge.url.startsWith(`${u.Schemas.vscodeWebview}://`))return!0;return!1},Fe=Ne=>Ne.resourceType==="xhr"||Ie(Ne.frame),ze=Ne=>{const Ge=Ne.frame;if(!Ge||!this.a)return!1;const Je=E.BrowserWindow.getAllWindows();for(const Ze of Je)if(Ge.processId===Ze.webContents.mainFrame.processId)return!0;return!1},_e=(Ne,Ge)=>{if(Ne.path!=="/index.html")return!0;const Je=Ge.frame;if(!Je||!this.a)return!1;for(const Ze of this.a.getWindows())if(Ze.win&&Je.processId===Ze.win.webContents.mainFrame.processId)return!0;return!1};E.session.defaultSession.webRequest.onBeforeRequest((Ne,Ge)=>{const Je=l.URI.parse(Ne.url);return Je.scheme===u.Schemas.vscodeWebview&&!_e(Je,Ne)?(this.h.error("Blocked vscode-webview request",Ne.url),Ge({cancel:!0})):Je.scheme===u.Schemas.vscodeFileResource&&!ze(Ne)?(this.h.error("Blocked vscode-file request",Ne.url),Ge({cancel:!0})):Je.path.endsWith(".svg")&&!Ae.has(Je.scheme)?Ge({cancel:!Fe(Ne)}):Ge({cancel:!1})}),E.session.defaultSession.webRequest.onHeadersReceived((Ne,Ge)=>{const Je=Ne.responseHeaders,Ze=Je["content-type"]||Je["Content-Type"];if(Ze&&Array.isArray(Ze)){const st=l.URI.parse(Ne.url);if(st.path.endsWith(".svg")&&Ae.has(st.scheme))return Je["Content-Type"]=["image/svg+xml"],Ge({cancel:!1,responseHeaders:Je});if(!st.path.endsWith(u.Schemas.vscodeRemoteResource)&&Ze.some(ct=>ct.toLowerCase().includes("image/svg")))return Ge({cancel:!Fe(Ne)})}return Ge({cancel:!1})});const et=E.session.defaultSession;typeof et.setCodeCachePath=="function"&&this.i.codeCachePath&&et.setCodeCachePath((0,d.join)(this.i.codeCachePath,"chrome"))}s(){(0,P.setUnexpectedErrorHandler)(Ae=>this.u(Ae)),process.on("uncaughtException",Ae=>(0,P.onUnexpectedError)(Ae)),process.on("unhandledRejection",Ae=>(0,P.onUnexpectedError)(Ae)),this.j.onWillShutdown(()=>this.dispose()),(0,k.registerContextMenuListener)(),E.app.on("accessibility-support-changed",(Ae,Ie)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",Ie)}),E.app.on("activate",async(Ae,Ie)=>{this.h.trace("app#activate"),Ie||await this.a?.openEmptyWindow({context:1})}),E.app.on("web-contents-created",(Ae,Ie)=>{Ie.on("will-navigate",Fe=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),Fe.preventDefault()}),Ie.setWindowOpenHandler(({url:Fe})=>(this.b?.openExternal(void 0,Fe),{action:"deny"}))});let Ee=[],Ce;E.app.on("open-file",(Ae,Ie)=>{this.h.trace("app#open-file: ",Ie),Ae.preventDefault(),Ee.push((0,Le.hasWorkspaceFileExtension)(Ie)?{workspaceUri:l.URI.file(Ie)}:{fileUri:l.URI.file(Ie)}),Ce!==void 0&&(clearTimeout(Ce),Ce=void 0),Ce=setTimeout(async()=>{await this.a?.open({context:1,cli:this.i.args,urisToOpen:Ee,gotoLineMode:!1,preferNewWindow:!0}),Ee=[],Ce=void 0},100)}),E.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",Ae=>{const Ie=this.a?.getWindowByWebContents(Ae.sender);let Fe,ze;return Ie?.config?(Fe=Ie.config,ze={...process.env,...Ie.config.userEnv}):(Fe=this.i.args,ze=process.env),this.J(Fe,ze,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(Ae,Ie,Fe)=>{const ze=this.t([Ie]);if(!ze||typeof Fe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.m.writeFile(ze,R.VSBuffer.fromString(Fe))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(Ae,...Ie)=>{const Fe=this.t(Ie);if(!Fe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.m.readFile(Fe)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",Ae=>Ae.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",Ae=>Ae.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",Ae=>Ae.sender.reload())}t(Ee){let Ce;for(const Ae of Ee)typeof Ae=="string"&&(typeof Ce!="string"?Ce=Ae:Ce=(0,d.join)(Ce,Ae));if(!(typeof Ce!="string"||!(0,d.isAbsolute)(Ce)||!(0,g.isEqualOrParent)(Ce,this.i.cachedLanguagesPath,!v.isLinux)))return l.URI.file(Ce)}u(Ee){if(Ee){const Ce={message:`[uncaught exception in main]: ${Ee.message}`,stack:Ee.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(Ce))}this.h.error(`[uncaught exception in main]: ${Ee}`),Ee.stack&&this.h.error(Ee.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.i.appRoot}`),this.h.debug("args:",this.i.args);const Ee=this.n.win32AppUserModelId;v.isWindows&&Ee&&E.app.setAppUserModelId(Ee);try{v.isMacintosh&&this.k.getValue("window.nativeTabs")===!0&&!E.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&E.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ne){this.h.error(Ne)}const Ce=new m.Server;this.j.onWillShutdown(Ne=>{Ne.reason===2&&Ce.dispose()}),this.h.trace("Resolving machine identifier...");const Ae=await(0,Gt.resolveMachineId)(this.l);this.h.trace(`Resolved machine identifier: ${Ae}`);const{sharedProcess:Ie,sharedProcessReady:Fe,sharedProcessClient:ze}=this.w(Ae),_e=await this.y(Ae,Ie,Fe);this.v(_e),_e.invokeFunction(Ne=>this.z(Ne,Ce,ze)),await _e.invokeFunction(Ne=>this.C(Ne,Ce)),_e.invokeFunction(Ne=>this.G(Ne,Ie)),this.B(new Pt.RunOnceScheduler(()=>{this.B((0,Pt.runWhenIdle)(()=>this.j.phase=4,2500))},2500)).schedule()}v(Ee){this.B(Ee.createInstance(r.ProxyAuthHandler)),this.B(Ee.createInstance(Ht.UserDataProfilesHandler))}w(Ee){const Ce=this.B(this.g.createInstance(Oe.SharedProcess,Ee,this.f)),Ae=(async()=>{this.h.trace("Main->SharedProcess#connect");const Fe=await Ce.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new i.Client(Fe,"main")})(),Ie=(async()=>(await Ce.whenReady(),Ae))();return{sharedProcess:Ce,sharedProcessReady:Ie,sharedProcessClient:Ae}}async y(Ee,Ce,Ae){const Ie=new O.ServiceCollection;switch(process.platform){case"win32":Ie.set(be.IUpdateService,new x.SyncDescriptor(Ue.Win32UpdateService));break;case"linux":v.isLinuxSnap?Ie.set(be.IUpdateService,new x.SyncDescriptor(qe.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Ie.set(be.IUpdateService,new x.SyncDescriptor(Te.LinuxUpdateService));break;case"darwin":Ie.set(be.IUpdateService,new x.SyncDescriptor(We.DarwinUpdateService));break}Ie.set(he.IWindowsMainService,new x.SyncDescriptor(me.WindowsMainService,[Ee,this.f],!1));const Fe=new T.DialogMainService(this.h);Ie.set(T.IDialogMainService,Fe),Ie.set($.ILaunchMainService,new x.SyncDescriptor($.LaunchMainService,void 0,!1)),Ie.set(L.IDiagnosticsMainService,new x.SyncDescriptor(L.DiagnosticsMainService,void 0,!1)),Ie.set(M.IDiagnosticsService,I.ProxyChannel.toService((0,I.getDelayedChannel)(Ae.then(et=>et.getChannel("diagnostics"))))),Ie.set(W.IIssueMainService,new x.SyncDescriptor(W.IssueMainService,[this.f])),Ie.set(U.IEncryptionMainService,new x.SyncDescriptor(K.EncryptionMainService,[Ee])),Ie.set(j.IKeyboardLayoutMainService,new x.SyncDescriptor(j.KeyboardLayoutMainService)),Ie.set(ae.INativeHostMainService,new x.SyncDescriptor(ae.NativeHostMainService,[Ce],!1)),Ie.set(s.ICredentialsMainService,new x.SyncDescriptor(tt.CredentialsNativeMainService)),Ie.set(J.IWebviewManagerService,new x.SyncDescriptor(le.WebviewMainService)),Ie.set(te.IMenubarMainService,new x.SyncDescriptor(te.MenubarMainService)),Ie.set(se.IExtensionUrlTrustService,new x.SyncDescriptor(ce.ExtensionUrlTrustService)),Ie.set(X.IExtensionHostStarter,new x.SyncDescriptor(ue.ExtensionHostStarter)),Ie.set(we.IStorageMainService,new x.SyncDescriptor(we.StorageMainService)),Ie.set(we.IApplicationStorageMainService,new x.SyncDescriptor(we.ApplicationStorageMainService)),v.isWindows?Ie.set(z.IExternalTerminalMainService,new x.SyncDescriptor(N.WindowsExternalTerminalService)):v.isMacintosh?Ie.set(z.IExternalTerminalMainService,new x.SyncDescriptor(N.MacExternalTerminalService)):v.isLinux&&Ie.set(z.IExternalTerminalMainService,new x.SyncDescriptor(N.LinuxExternalTerminalService));const ze=new o.BackupMainService(this.i,this.k,this.h,this.l);Ie.set(a.IBackupMainService,ze);const _e=new He.WorkspacesManagementMainService(this.i,this.h,this.p,ze,Fe,this.n);if(Ie.set(He.IWorkspacesManagementMainService,_e),Ie.set(Be.IWorkspacesService,new x.SyncDescriptor(xe.WorkspacesMainService,void 0,!1)),Ie.set(it.IWorkspacesHistoryMainService,new x.SyncDescriptor(it.WorkspacesHistoryMainService,void 0,!1)),Ie.set(je.IURLService,new x.SyncDescriptor($e.NativeURLService,void 0,!1)),(0,de.supportsTelemetry)(this.n,this.i)){const et=(0,de.isInternalTelemetry)(this.n,this.k),Ne=(0,I.getDelayedChannel)(Ae.then(ct=>ct.getChannel("telemetryAppender"))),Ge=new ne.TelemetryAppenderClient(Ne),Je=(0,ye.resolveCommonProperties)(this.m,(0,C.release)(),(0,C.hostname)(),process.arch,this.n.commit,this.n.version,Ee,et,this.i.installSourcePath),Ze=(0,de.getPiiPathsFromEnvironment)(this.i),st={appenders:[Ge],commonProperties:Je,piiPaths:Ze,sendErrorTelemetry:!0};Ie.set(Me.ITelemetryService,new x.SyncDescriptor(fe.TelemetryService,[st],!1))}else Ie.set(Me.ITelemetryService,de.NullTelemetryService);return Ie.set(Wt.IExtensionsProfileScannerService,new x.SyncDescriptor(Wt.ExtensionsProfileScannerService,void 0,!0)),Ie.set(zt.IExtensionsScannerService,new x.SyncDescriptor(qt.ExtensionsScannerService,void 0,!0)),await Pt.Promises.settled([ze.initialize(),_e.initialize()]),this.g.createChild(Ie)}z(Ee,Ce,Ae){const Ie=I.ProxyChannel.fromService(Ee.get($.ILaunchMainService),{disableMarshalling:!0});this.c.registerChannel("launch",Ie);const Fe=I.ProxyChannel.fromService(Ee.get(L.IDiagnosticsMainService),{disableMarshalling:!0});this.c.registerChannel("diagnostics",Fe);const ze=new lt.PolicyChannel(Ee.get(nt.IPolicyService));Ce.registerChannel("policy",ze),Ae.then(Ye=>Ye.registerChannel("policy",ze));const _e=this.m.getProvider(u.Schemas.file);(0,h.assertType)(_e instanceof oe.DiskFileSystemProvider);const et=new Q.DiskFileSystemProviderChannel(_e,this.h,this.i);Ce.registerChannel(F.LOCAL_FILE_SYSTEM_CHANNEL_NAME,et),Ae.then(Ye=>Ye.registerChannel(F.LOCAL_FILE_SYSTEM_CHANNEL_NAME,et));const Ne=I.ProxyChannel.fromService(Ee.get(at.IUserDataProfilesMainService));Ce.registerChannel("userDataProfiles",Ne),Ae.then(Ye=>Ye.registerChannel("userDataProfiles",Ne));const Ge=new Bt.RequestChannel(Ee.get($t.IRequestService));Ae.then(Ye=>Ye.registerChannel("request",Ge));const Je=new Pe.UpdateChannel(Ee.get(be.IUpdateService));Ce.registerChannel("update",Je);const Ze=I.ProxyChannel.fromService(Ee.get(W.IIssueMainService));Ce.registerChannel("issue",Ze);const st=I.ProxyChannel.fromService(Ee.get(U.IEncryptionMainService));Ce.registerChannel("encryption",st);const ct=I.ProxyChannel.fromService(Ee.get(s.ICredentialsMainService));Ce.registerChannel("credentials",ct);const kt=I.ProxyChannel.fromService(Ee.get(De.ISignService));Ce.registerChannel("sign",kt);const Qe=I.ProxyChannel.fromService(Ee.get(j.IKeyboardLayoutMainService));Ce.registerChannel("keyboardLayout",Qe),this.b=Ee.get(ae.INativeHostMainService);const wt=I.ProxyChannel.fromService(this.b);Ce.registerChannel("nativeHost",wt),Ae.then(Ye=>Ye.registerChannel("nativeHost",wt));const pt=I.ProxyChannel.fromService(Ee.get(Be.IWorkspacesService));Ce.registerChannel("workspaces",pt);const yt=I.ProxyChannel.fromService(Ee.get(te.IMenubarMainService));Ce.registerChannel("menubar",yt);const Dt=I.ProxyChannel.fromService(Ee.get(je.IURLService));Ce.registerChannel("url",Dt);const Mt=I.ProxyChannel.fromService(Ee.get(se.IExtensionUrlTrustService));Ce.registerChannel("extensionUrlTrust",Mt);const vt=I.ProxyChannel.fromService(Ee.get(J.IWebviewManagerService));Ce.registerChannel("webview",vt);const ut=this.B(new ve.StorageDatabaseChannel(this.h,Ee.get(we.IStorageMainService)));Ce.registerChannel("storage",ut),Ae.then(Ye=>Ye.registerChannel("storage",ut));const St=this.B(new Vt.ProfileStorageChangesListenerChannel(Ee.get(we.IStorageMainService),Ee.get(at.IUserDataProfilesMainService),this.h));Ae.then(Ye=>Ye.registerChannel("profileStorageListener",St));const bt=I.ProxyChannel.fromService(Ee.get(z.IExternalTerminalMainService));Ce.registerChannel("externalTerminal",bt);const ht=new Z.LogLevelChannel(Ee.get(B.ILogService),Ee.get(B.ILoggerService));Ce.registerChannel("logLevel",ht),Ae.then(Ye=>Ye.registerChannel("logLevel",ht));const Ve=new Z.LoggerChannel(Ee.get(B.ILoggerService));Ce.registerChannel("logger",Ve),Ae.then(Ye=>Ye.registerChannel("logger",Ve));const ot=new f.ElectronExtensionHostDebugBroadcastChannel(Ee.get(he.IWindowsMainService));Ce.registerChannel("extensionhostdebugservice",ot);const ft=I.ProxyChannel.fromService(Ee.get(X.IExtensionHostStarter));Ce.registerChannel(X.ipcExtensionHostStarterChannelName,ft)}async C(Ee,Ce){const Ae=this.a=Ee.get(he.IWindowsMainService),Ie=Ee.get(je.IURLService),Fe=Ee.get(ae.INativeHostMainService);this.j.phase=2;const ze=[],_e=[...this.i.args["open-url"]?this.i.args._urls||[]:[],...global.getOpenUrls()||[]].map(Ve=>{try{return{uri:l.URI.parse(Ve),url:Ve}}catch{return}}).filter(Ve=>{if(!Ve||this.D(Ve.uri))return!1;const ot=this.F(Ve.uri);return ot?(ze.push(ot),!1):!0}),et=this,Ne=this.i,Ge=this.n,Je=this.h;Ie.registerHandler({async handleURL(Ve,ot){if(Je.trace("app#handleURL: ",Ve.toString(!0),ot),Ve.scheme===Ge.urlProtocol&&Ve.path==="workspace"&&(Ve=Ve.with({authority:"file",path:l.URI.parse(Ve.query).path,query:""})),et.D(Ve))return!0;let ft=!1;const Ye=new URLSearchParams(Ve.query);Ye.get("windowId")==="_blank"&&(Ye.delete("windowId"),Ve=Ve.with({query:Ye.toString()}),ft=!0),ft||=v.isMacintosh&&Ae.getWindowCount()===0;const Ut=Ye.get("continueOn");Ut!==null&&(Ne.continueOn=Ut??void 0,Ye.delete("continueOn"),Ve=Ve.with({query:Ye.toString()}));const Rt=et.F(Ve);if(Je.trace("app#handleURL: windowOpenableFromProtocolLink = ",Rt),Rt){const[At]=await Ae.open({context:5,cli:{...Ne.args},urisToOpen:[Rt],forceNewWindow:ft,gotoLineMode:!0});return At.focus(),!0}if(ft){const[At]=await Ae.open({context:5,cli:{...Ne.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ke.getRemoteAuthority)(Ve)});return await At.ready(),Ie.open(Ve,ot)}return!1}});const Ze=this.B(new Se.ActiveWindowManager({onDidOpenWindow:Fe.onDidOpenWindow,onDidFocusWindow:Fe.onDidFocusWindow,getActiveWindowId:()=>Fe.getActiveWindowId(-1)})),st=new I.StaticRouter(Ve=>Ze.getActiveClientId().then(ot=>Ve===ot)),ct=new Xe.URLHandlerRouter(st),kt=Ce.getChannel("urlHandler",ct);Ie.registerHandler(new Xe.URLHandlerChannelClient(kt)),this.B(new Ke.ElectronURLListener(_e,Ie,Ae,this.i,this.n));const Qe=this.i.args,wt=global.macOpenFiles,pt=(0,G.isLaunchedFromCli)(process.env)?0:4,yt=Qe._.length,Dt=!!Qe["folder-uri"],Mt=!!Qe["file-uri"],vt=Qe["skip-add-to-recently-opened"]===!0,ut=Qe.wait&&Qe.waitMarkerFilePath?l.URI.file(Qe.waitMarkerFilePath):void 0,St=Qe.remote||void 0,bt=Qe.profile,ht=Qe["profile-temp"];if(ze.length>0)return Ae.open({context:pt,cli:Qe,urisToOpen:ze,gotoLineMode:!0,initialStartup:!0});if(!yt&&!Dt&&!Mt){if(Qe["new-window"]||bt||ht)return Ae.open({context:pt,cli:Qe,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:vt,waitMarkerFileURI:ut,initialStartup:!0,remoteAuthority:St,forceProfile:bt,forceTempProfile:ht});if(wt.length)return Ae.open({context:1,cli:Qe,urisToOpen:wt.map(Ve=>(0,Le.hasWorkspaceFileExtension)(Ve)?{workspaceUri:l.URI.file(Ve)}:{fileUri:l.URI.file(Ve)}),noRecentEntry:vt,waitMarkerFileURI:ut,initialStartup:!0})}return Ae.open({context:pt,cli:Qe,forceNewWindow:Qe["new-window"]||!yt&&Qe["unity-launch"],diffMode:Qe.diff,mergeMode:Qe.merge,noRecentEntry:vt,waitMarkerFileURI:ut,gotoLineMode:Qe.goto,initialStartup:!0,remoteAuthority:St,forceProfile:bt,forceTempProfile:ht})}D(Ee){return!!(Ee.authority===u.Schemas.file&&v.isWindows&&E.dialog.showMessageBoxSync({title:this.n.nameLong,type:"question",buttons:[(0,S.mnemonicButtonLabel)((0,n.localize)(0,null)),(0,S.mnemonicButtonLabel)((0,n.localize)(1,null))],defaultId:0,cancelId:1,message:(0,n.localize)(2,null,(0,S.getPathLabel)(Ee,{os:v.OS,tildify:this.i}),this.n.nameShort),detail:(0,n.localize)(3,null),noLink:!0})===1)}F(Ee){if(!!Ee.path){if(Ee.authority===u.Schemas.file){const Ce=l.URI.file(Ee.fsPath);return(0,Le.hasWorkspaceFileExtension)(Ce)?{workspaceUri:Ce}:{fileUri:Ce}}else if(Ee.authority===u.Schemas.vscodeRemote){const Ce=Ee.path.indexOf(d.posix.sep,1);if(Ce!==-1){const Ae=Ee.path.substring(1,Ce),Ie=Ee.path.substring(Ce),Fe=l.URI.from({scheme:u.Schemas.vscodeRemote,authority:Ae,path:Ie,query:Ee.query,fragment:Ee.fragment});return(0,Le.hasWorkspaceFileExtension)(Ie)?{workspaceUri:Fe}:/:[\d]+$/.test(Ie)?{fileUri:Fe}:{folderUri:Fe}}}}}G(Ee,Ce){const Ae=Ee.get(Me.ITelemetryService),Ie=Ee.get(be.IUpdateService);this.j.phase=3,this.I(Ae,Ce),this.H(),E.protocol.registerHttpProtocol(u.Schemas.vscodeRemoteResource,(Fe,ze)=>{ze({url:Fe.url.replace(/^vscode-remote-resource:/,"http:"),method:Fe.method})}),(Ie instanceof Ue.Win32UpdateService||Ie instanceof Te.LinuxUpdateService||Ie instanceof We.DarwinUpdateService)&&Ie.initialize(),this.J(this.i.args,process.env,!0),this.L()}async H(){const Ee=this.n.win32MutexName;if(v.isWindows&&Ee)try{const Ce=await new Promise((Ie,Fe)=>{H(["windows-mutex"],Ie,Fe)}),Ae=new Ce.Mutex(Ee);(0,w.once)(this.j.onWillShutdown)(()=>Ae.release())}catch(Ce){this.h.error(Ce)}}I(Ee,Ce){let Ae=!1;(0,w.once)(this.j.onWillShutdown)(()=>Ae=!0),this.B(Ce.onDidError(({type:Ie,details:Fe})=>{let ze;switch(Ie){case 1:ze="SharedProcess: detected unresponsive window";break;case 2:ze=`SharedProcess: renderer process gone (detail: ${Fe?.reason??"<unknown>"}, code: ${Fe?.exitCode??"<unknown>"})`;break;case 3:ze=`SharedProcess: failed to load (detail: ${Fe?.reason??"<unknown>"}, code: ${Fe?.exitCode??"<unknown>"})`;break}(0,P.onUnexpectedError)(new Error(ze)),Ee.publicLog2("sharedprocesserror",{type:Ie,reason:Fe?.reason,code:Fe?.exitCode,visible:Ce.isVisible(),shuttingdown:Ae})}))}async J(Ee,Ce,Ae){try{return await(0,_.getResolvedShellEnv)(this.k,this.h,Ee,Ce)}catch(Ie){const Fe=(0,A.toErrorMessage)(Ie);Ae?this.a?.sendToFocused("vscode:showResolveShellEnvError",Fe):this.h.error(Fe)}return{}}async L(){try{const Ce=(await this.m.readFile(this.i.argvResource)).value.toString(),Ae=JSON.parse((0,b.stripComments)(Ce)),Fe=(0,de.getTelemetryLevel)(this.k)>=1;if(Ae["enable-crash-reporter"]===void 0){const ze=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Fe},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,p.generateUuid)()}"`,"}"],_e=Ce.substring(0,Ce.length-2).concat(`,
`,ze.join(`
`));await this.m.writeFile(this.i.argvResource,R.VSBuffer.fromString(_e))}else{const ze=Ce.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Fe},`);ze!==Ce&&await this.m.writeFile(this.i.argvResource,R.VSBuffer.fromString(ze))}}catch(Ee){this.h.error(Ee)}}};Ct=pe([ee(2,D.IInstantiationService),ee(3,B.ILogService),ee(4,V.IEnvironmentMainService),ee(5,Y.ILifecycleMainService),ee(6,c.IConfigurationService),ee(7,Re.IStateMainService),ee(8,q.IFileService),ee(9,ge.IProductService),ee(10,at.IUserDataProfilesMainService)],Ct),e.CodeApplication=Ct}),define(ie[277],re([0,1,37,8,285,2,6]),function(H,e,E,t,C,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let P=class extends E.AbstractPolicyService{constructor(w,b){super(),this.j=w,this.k=b,this.a=new t.Throttler,this.b=this.B(new R.MutableDisposable)}async i(w){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(w).length} policy definitions`),await this.a.queue(()=>new Promise((b,S)=>{try{this.b.value=(0,C.createWatcher)(this.k,w,y=>{this.m(y),b()})}catch(y){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",y),S(y)}}))}m(w){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(w)}`);for(const b in w){const S=w[b];S===void 0?this.g.delete(b):this.g.set(b,S)}this.h.fire(Object.keys(w))}};P=pe([ee(0,A.ILogService)],P),e.NativePolicyService=P}),define(ie[278],re([0,1,227,8,17,15,2,11,18,35,110,6,226,286]),function(H,e,E,t,C,R,A,P,g,w,b,S,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let d=class extends A.Disposable{constructor(h,l,p){super(),this.h=h,this.i=l,this.j=p,this.k(h.getValue()),this.B(h.onDidChangeConfiguration(()=>this.k(h.getValue()),this))}k(h){this.a=h.http&&h.http.proxy,this.b=!!(h.http&&h.http.proxyStrictSSL),this.f=h.http&&h.http.proxyAuthorization}async request(h,l){this.j.trace("RequestService#request (node) - begin",h.url);const{a:p,b:k}=this;let I;try{I=await(0,b.getResolvedShellEnv)(this.h,this.j,this.i.args,process.env)}catch(r){this.g||(this.g=!0,this.j.error("RequestService#request (node) resolving shell environment failed",r))}const m={...process.env,...I},i=h.agent?h.agent:await(0,y.getProxyAgent)(h.url||"",m,{proxyUrl:p,strictSSL:k});h.agent=i,h.strictSSL=k,this.f&&(h.headers={...h.headers||{},"Proxy-Authorization":this.f});try{const r=await this.m(h,l);return this.j.trace("RequestService#request (node) - success",h.url),r}catch(r){throw this.j.trace("RequestService#request (node) - error",h.url,r),r}}async l(h){return((0,E.parse)(h.url).protocol==="https:"?await new Promise((k,I)=>{H(["https"],k,I)}):await new Promise((k,I)=>{H(["http"],k,I)})).request}m(h,l){return t.Promises.withAsyncBody(async(p,k)=>{const I=(0,E.parse)(h.url),m=h.getRawRequest?h.getRawRequest(h):await this.l(h),i={hostname:I.hostname,port:I.port?parseInt(I.port):I.protocol==="https:"?443:80,protocol:I.protocol,path:I.path,method:h.type||"GET",headers:h.headers,agent:h.agent,rejectUnauthorized:(0,P.isBoolean)(h.strictSSL)?h.strictSSL:!0};h.user&&h.password&&(i.auth=h.user+":"+h.password);const r=m(i,n=>{const a=(0,P.isNumber)(h.followRedirects)?h.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&a>0&&n.headers.location)this.m({...h,url:n.headers.location,followRedirects:a-1},l).then(p,k);else{let o=n;!h.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(o=n.pipe((0,u.createGunzip)())),p({res:n,stream:(0,C.streamToBufferReadableStream)(o)})}});r.on("error",k),h.timeout&&r.setTimeout(h.timeout),h.isChromiumNetwork&&r.removeHeader("Content-Length"),h.data&&typeof h.data=="string"&&r.write(h.data),r.end(),l.onCancellationRequested(()=>{r.abort(),k(new R.CancellationError)})})}async resolveProxy(h){}};d=pe([ee(0,g.IConfigurationService),ee(1,w.INativeEnvironmentService),ee(2,S.ILogService)],d),e.RequestService=d}),define(ie[279],re([0,1,13,278]),function(H,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function C(A){return E.net.request}class R extends t.RequestService{request(P,g){return super.request({...P||{},getRawRequest:C,isChromiumNetwork:!0},g)}}e.RequestMainService=R}),define(ie[287],re([0,1,13,40,7,24,8,45,15,30,50,34,14,9,73,4,33,26,23,47,84,276,10,18,220,233,27,61,185,16,206,87,70,202,86,21,209,6,212,63,19,64,260,114,241,56,279,89,228,36,232,51,66,52,37,277,214,2,42,246,38,242]),function(H,e,E,t,C,R,A,P,g,w,b,S,y,u,d,v,h,l,p,k,I,m,i,r,n,a,o,c,s,f,M,L,T,U,K,V,G,_,se,ce,X,ue,z,N,F,q,Q,oe,x,D,O,W,j,$,Y,B,Z,te,ae,ge,ke){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Oe{main(){try{this.a()}catch(ve){console.error(ve.message),E.app.exit(1)}}async a(){(0,g.setUnexpectedErrorHandler)(Pe=>console.error(Pe));const[ve,we,ye,Me,ne,fe,de,be]=this.b();try{try{await this.d(ye,be,Me,ne,de)}catch(Pe){throw this.f(ye,de.nameLong,Pe),Pe}await ve.invokeFunction(async Pe=>{const We=Pe.get(_.ILogService),Te=Pe.get(V.ILifecycleMainService),qe=Pe.get(f.IFileService),Ue=Pe.get(_.ILoggerService),je=await this.e(We,ye,Te,ve,de,!0);return p.Promises.writeFile(ye.mainLockfile,String(process.pid)).catch(Xe=>{We.warn(`Error writing main lockfile: ${Xe.stack}`)}),fe.logger=Ue.createLogger(C.URI.file((0,u.join)(ye.logsPath,"main.log")),{name:"main"}),(0,b.once)(Te.onWillShutdown)(Xe=>{qe.dispose(),Me.dispose(),Xe.join(p.Promises.unlink(ye.mainLockfile).catch(()=>{}))}),ve.createInstance(m.CodeApplication,je,we).startup()})}catch(Pe){ve.invokeFunction(this.i,Pe)}}b(){const ve=new K.ServiceCollection,we=new te.DisposableStore;process.once("exit",()=>we.dispose());const ye={_serviceBrand:void 0,...ce.default};ve.set(X.IProductService,ye);const Me=new o.EnvironmentMainService(this.j(),ye),ne=this.c(Me);ve.set(o.IEnvironmentMainService,Me);const fe=new G.BufferLogService,de=we.add(new _.MultiplexLogService([new _.ConsoleMainLogger((0,_.getLogLevel)(Me)),fe]));ve.set(_.ILogService,de);const be=new M.FileService(de);ve.set(f.IFileService,be);const Pe=new L.DiskFileSystemProvider(de);be.registerProvider(y.Schemas.file,Pe);const We=new ge.UriIdentityService(be);ve.set(ae.IUriIdentityService,We),ve.set(_.ILoggerService,new se.LoggerService(de));const Te=new O.StateMainService(Me,de,be);ve.set(D.IStateMainService,Te);const qe=new $.UserDataProfilesMainService(Te,We,Me,be,de);ve.set($.IUserDataProfilesMainService,qe);const Ue=v.isWindows&&ye.win32RegValueName?we.add(new B.NativePolicyService(de,ye.win32RegValueName)):Me.policyFile?we.add(new Z.FilePolicyService(Me.policyFile,be,de)):new Y.NullPolicyService;ve.set(Y.IPolicyService,Ue);const je=new n.ConfigurationService(qe.defaultProfile.settingsResource,be,Ue,de);return ve.set(r.IConfigurationService,je),ve.set(V.ILifecycleMainService,new T.SyncDescriptor(V.LifecycleMainService,void 0,!1)),ve.set(q.IRequestService,new T.SyncDescriptor(Q.RequestMainService,void 0,!0)),ve.set(j.IThemeMainService,new T.SyncDescriptor(j.ThemeMainService)),ve.set(oe.ISignService,new T.SyncDescriptor(x.SignService,void 0,!1)),ve.set(N.ITunnelService,new T.SyncDescriptor(F.TunnelService)),ve.set(ue.IProtocolMainService,new z.ProtocolMainService(Me,qe,de)),[new U.InstantiationService(ve,!0),ne,Me,je,Te,fe,ye,qe]}c(ve){const we={VSCODE_IPC_HOOK:ve.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ye=>{const Me=process.env[ye];typeof Me=="string"&&(we[ye]=Me)}),Object.assign(process.env,we),we}async d(ve,we,ye,Me,ne){await A.Promises.settled([Promise.all([ve.extensionsPath,ve.codeCachePath,ve.logsPath,we.defaultProfile.globalStorageHome.fsPath,ve.workspaceStorageHome.fsPath,ve.localHistoryHome.fsPath,ve.backupHome].map(fe=>fe?p.Promises.mkdir(fe,{recursive:!0}):void 0)),Me.init(),ye.initialize()]),we.setEnablement(ne.quality!=="stable"||ye.getValue(ke.PROFILES_ENABLEMENT_CONFIG))}async e(ve,we,ye,Me,ne,fe){let de;try{(0,d.mark)("code/willStartMainServer"),de=await(0,I.serve)(we.mainIPCHandle),(0,d.mark)("code/didStartMainServer"),(0,b.once)(ye.onWillShutdown)(()=>de.dispose())}catch(be){if(be.code!=="EADDRINUSE")throw this.f(we,ne.nameLong,be),be;let Pe;try{Pe=await(0,I.connect)(we.mainIPCHandle,"main")}catch(Ue){if(!fe||v.isWindows||Ue.code!=="ECONNREFUSED")throw Ue.code==="EPERM"&&this.g((0,i.localize)(0,null,ne.nameShort),(0,i.localize)(1,null),ne.nameLong),Ue;try{(0,t.unlinkSync)(we.mainIPCHandle)}catch(je){throw ve.warn("Could not delete obsolete instance handle",je),je}return this.e(ve,we,ye,Me,ne,!1)}if(we.extensionTestsLocationURI&&!we.debugExtensionHost.break){const Ue=`Running extension tests from the command line is currently only supported if no other instance of ${ne.nameShort} is running.`;throw ve.error(Ue),Pe.dispose(),new Error(Ue)}let We;!we.args.wait&&!we.args.status&&(We=setTimeout(()=>{this.g((0,i.localize)(2,null,ne.nameShort),(0,i.localize)(3,null),ne.nameLong)},1e4));const Te=k.ProxyChannel.toService(Pe.getChannel("launch"),{disableMarshalling:!0}),qe=k.ProxyChannel.toService(Pe.getChannel("diagnostics"),{disableMarshalling:!0});if(we.args.status)return Me.invokeFunction(async()=>{const Ue=new a.DiagnosticsService(W.NullTelemetryService,ne),je=await qe.getMainDiagnostics(),Xe=await qe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),$e=await Ue.getDiagnostics(je,Xe);throw console.log($e),new g.ExpectedError});throw v.isWindows&&await this.h(Te,ve),ve.trace("Sending env to running instance..."),await Te.start(we.args,process.env),Pe.dispose(),We&&clearTimeout(We),new g.ExpectedError("Sent env to running instance. Terminating...")}if(we.args.status)throw ve.warn(`Warning: The --status argument can only be used if ${ne.nameShort} is already running. Please run it again after {0} has started.`),new g.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),de}f(ve,we,ye){if(ye.code==="EACCES"||ye.code==="EPERM"){const Me=(0,R.coalesce)([ve.userDataPath,ve.extensionsPath,I.XDG_RUNTIME_DIR]).map(ne=>(0,S.getPathLabel)(C.URI.file(ne),{os:v.OS,tildify:ve}));this.g((0,i.localize)(4,null),(0,i.localize)(5,null,(0,P.toErrorMessage)(ye),Me.join(`
`)),we)}}g(ve,we,ye){E.dialog.showMessageBoxSync({title:ye,type:"warning",buttons:[(0,S.mnemonicButtonLabel)((0,i.localize)(6,null))],message:ve,detail:we,defaultId:0,noLink:!0})}async h(ve,we){if(v.isWindows){const ye=await ve.getMainProcessId();we.trace("Sending some foreground love to the running instance:",ye);try{(await new Promise((Me,ne)=>{H(["windows-foreground-love"],Me,ne)})).allowSetForegroundWindow(ye)}catch(Me){we.error(Me)}}}i(ve,we){const ye=ve.get(_.ILogService),Me=ve.get(V.ILifecycleMainService);let ne=0;we&&(we.isExpected?we.message&&ye.trace(we.message):(ne=1,we.stack?ye.error(we.stack):ye.error(`Startup error: ${we.toString()}`))),Me.kill(ne)}j(){const ve=this.k((0,c.parseMainProcessArgv)(process.argv));if(ve.wait&&!ve.waitMarkerFilePath){const we=(0,s.createWaitMarkerFileSync)(ve.verbose);we&&((0,c.addArg)(process.argv,"--waitMarkerFilePath",we),ve.waitMarkerFilePath=we)}return ve}k(ve){if(ve["open-url"]&&(ve._urls=ve._,ve._=[]),!ve.remote){const we=this.l(ve._,ve.goto);ve._=we}return ve}l(ve,we){const ye=(0,h.cwd)(),Me=ve.map(de=>{let be=String(de),Pe;we&&(Pe=(0,w.parseLineAndColumnAware)(be),be=Pe.path),be&&(be=this.m(ye,be));const We=(0,w.sanitizeFilePath)(be,ye),Te=(0,u.basename)(We);return Te&&!(0,w.isValidBasename)(Te)?null:we&&Pe?(Pe.path=We,this.n(Pe)):We}),ne=v.isWindows||v.isMacintosh,fe=(0,R.distinct)(Me,de=>de&&ne?de.toLowerCase():de||"");return(0,R.coalesce)(fe)}m(ve,we){return v.isWindows&&(we=(0,l.rtrim)(we,'"')),we=(0,l.trim)((0,l.trim)(we," "),"	"),v.isWindows&&(we=(0,u.resolve)(ve,we),we=(0,l.rtrim)(we,".")),we}n(ve){const we=[ve.path];return typeof ve.line=="number"&&we.push(String(ve.line)),typeof ve.column=="number"&&we.push(String(ve.column)),we.join(":")}}new Oe().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/42814d18a7d46adfb1c24e1349b7ab18833ec6ac/core/vs/code/electron-main/main.js.map
