/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/base/common/errors","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/strings","vs/base/common/codicons","vs/nls","vs/base/common/arrays","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/browser/mouseEvent","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/platform/instantiation/common/instantiation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/network","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/color","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/scrollable","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/browser/ui/list/listWidget","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/platform/instantiation/common/descriptors","vs/platform/theme/common/themeService","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/collections","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/map","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stream","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/mime","vs/base/common/stopwatch","vs/base/browser/canIUse","vs/base/common/cache","vs/base/common/extpath","vs/base/common/hash","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],be=function(J){for(var t=[],v=0,i=J.length;v<i;v++)t[v]=me[J[v]];return t};/*! @license DOMPurify 2.3.1 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/2.3.1/LICENSE */function $t(J){if(Array.isArray(J)){for(var t=0,v=Array(J.length);t<J.length;t++)v[t]=J[t];return v}else return Array.from(J)}var jt=Object.hasOwnProperty,Nt=Object.setPrototypeOf,Kt=Object.isFrozen,Vt=Object.getPrototypeOf,qt=Object.getOwnPropertyDescriptor,et=Object.freeze,ot=Object.seal,Gt=Object.create,It=typeof Reflect<"u"&&Reflect,vt=It.apply,Ct=It.construct;vt||(vt=function(t,v,i){return t.apply(v,i)}),et||(et=function(t){return t}),ot||(ot=function(t){return t}),Ct||(Ct=function(t,v){return new(Function.prototype.bind.apply(t,[null].concat($t(v))))});var Yt=nt(Array.prototype.forEach),Mt=nt(Array.prototype.pop),mt=nt(Array.prototype.push),ut=nt(String.prototype.toLowerCase),Pt=nt(String.prototype.match),lt=nt(String.prototype.replace),Xt=nt(String.prototype.indexOf),Zt=nt(String.prototype.trim),at=nt(RegExp.prototype.test),Rt=Qt(TypeError);function nt(J){return function(t){for(var v=arguments.length,i=Array(v>1?v-1:0),z=1;z<v;z++)i[z-1]=arguments[z];return vt(J,t,i)}}function Qt(J){return function(){for(var t=arguments.length,v=Array(t),i=0;i<t;i++)v[i]=arguments[i];return Ct(J,v)}}function He(J,t){Nt&&Nt(J,null);for(var v=t.length;v--;){var i=t[v];if(typeof i=="string"){var z=ut(i);z!==i&&(Kt(t)||(t[v]=z),i=z)}J[i]=!0}return J}function ct(J){var t=Gt(null),v=void 0;for(v in J)vt(jt,J,[v])&&(t[v]=J[v]);return t}function Dt(J,t){for(;J!==null;){var v=qt(J,t);if(v){if(v.get)return nt(v.get);if(typeof v.value=="function")return nt(v.value)}J=Vt(J)}function i(z){return console.warn("fallback value for",z),null}return i}var Ot=et(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),At=et(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),St=et(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),Jt=et(["animate","color-profile","cursor","discard","fedropshadow","feimage","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),kt=et(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover"]),xt=et(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Bt=et(["#text"]),Ht=et(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Ft=et(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),Ut=et(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),yt=et(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),ei=ot(/\{\{[\s\S]*|[\s\S]*\}\}/gm),ti=ot(/<%[\s\S]*|[\s\S]*%>/gm),ii=ot(/^data-[\-\w.\u00B7-\uFFFF]/),ni=ot(/^aria-[\-\w]+$/),si=ot(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),ri=ot(/^(?:\w+script|data):/i),oi=ot(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),bt=typeof Symbol=="function"&&typeof Symbol.iterator=="symbol"?function(J){return typeof J}:function(J){return J&&typeof Symbol=="function"&&J.constructor===Symbol&&J!==Symbol.prototype?"symbol":typeof J};function rt(J){if(Array.isArray(J)){for(var t=0,v=Array(J.length);t<J.length;t++)v[t]=J[t];return v}else return Array.from(J)}var ai=function(){return typeof window>"u"?null:window},li=function(t,v){if((typeof t>"u"?"undefined":bt(t))!=="object"||typeof t.createPolicy!="function")return null;var i=null,z="data-tt-policy-suffix";v.currentScript&&v.currentScript.hasAttribute(z)&&(i=v.currentScript.getAttribute(z));var U="dompurify"+(i?"#"+i:"");try{return t.createPolicy(U,{createHTML:function(b){return b}})}catch{return console.warn("TrustedTypes policy "+U+" could not be created."),null}};function zt(){var J=arguments.length>0&&arguments[0]!==void 0?arguments[0]:ai(),t=function(ae){return zt(ae)};if(t.version="2.3.1",t.removed=[],!J||!J.document||J.document.nodeType!==9)return t.isSupported=!1,t;var v=J.document,i=J.document,z=J.DocumentFragment,U=J.HTMLTemplateElement,y=J.Node,b=J.Element,u=J.NodeFilter,c=J.NamedNodeMap,f=c===void 0?J.NamedNodeMap||J.MozNamedAttrMap:c,I=J.Text,o=J.Comment,n=J.DOMParser,e=J.trustedTypes,s=b.prototype,r=Dt(s,"cloneNode"),a=Dt(s,"nextSibling"),l=Dt(s,"childNodes"),p=Dt(s,"parentNode");if(typeof U=="function"){var k=i.createElement("template");k.content&&k.content.ownerDocument&&(i=k.content.ownerDocument)}var S=li(e,v),g=S&&Y?S.createHTML(""):"",E=i,N=E.implementation,F=E.createNodeIterator,d=E.createDocumentFragment,w=E.getElementsByTagName,m=v.importNode,D={};try{D=ct(i).documentMode?i.documentMode:{}}catch{}var R={};t.isSupported=typeof p=="function"&&N&&typeof N.createHTMLDocument<"u"&&D!==9;var V=ei,Z=ti,X=ii,x=ni,ne=ri,le=oi,se=si,fe=null,Ae=He({},[].concat(rt(Ot),rt(At),rt(St),rt(kt),rt(Bt))),te=null,ve=He({},[].concat(rt(Ht),rt(Ft),rt(Ut),rt(yt))),Ne=null,he=null,Q=!0,oe=!0,re=!1,ie=!1,A=!1,C=!1,h=!1,B=!1,_=!1,$=!0,Y=!1,T=!0,H=!0,W=!1,L={},M=null,P=He({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]),O=null,j=He({},["audio","video","img","source","image","track"]),ee=null,ce=He({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),de="http://www.w3.org/1998/Math/MathML",De="http://www.w3.org/2000/svg",ye="http://www.w3.org/1999/xhtml",Ie=ye,Se=!1,we=null,Re=i.createElement("form"),Pe=function(ae){we&&we===ae||((!ae||(typeof ae>"u"?"undefined":bt(ae))!=="object")&&(ae={}),ae=ct(ae),fe="ALLOWED_TAGS"in ae?He({},ae.ALLOWED_TAGS):Ae,te="ALLOWED_ATTR"in ae?He({},ae.ALLOWED_ATTR):ve,ee="ADD_URI_SAFE_ATTR"in ae?He(ct(ce),ae.ADD_URI_SAFE_ATTR):ce,O="ADD_DATA_URI_TAGS"in ae?He(ct(j),ae.ADD_DATA_URI_TAGS):j,M="FORBID_CONTENTS"in ae?He({},ae.FORBID_CONTENTS):P,Ne="FORBID_TAGS"in ae?He({},ae.FORBID_TAGS):{},he="FORBID_ATTR"in ae?He({},ae.FORBID_ATTR):{},L="USE_PROFILES"in ae?ae.USE_PROFILES:!1,Q=ae.ALLOW_ARIA_ATTR!==!1,oe=ae.ALLOW_DATA_ATTR!==!1,re=ae.ALLOW_UNKNOWN_PROTOCOLS||!1,ie=ae.SAFE_FOR_TEMPLATES||!1,A=ae.WHOLE_DOCUMENT||!1,B=ae.RETURN_DOM||!1,_=ae.RETURN_DOM_FRAGMENT||!1,$=ae.RETURN_DOM_IMPORT!==!1,Y=ae.RETURN_TRUSTED_TYPE||!1,h=ae.FORCE_BODY||!1,T=ae.SANITIZE_DOM!==!1,H=ae.KEEP_CONTENT!==!1,W=ae.IN_PLACE||!1,se=ae.ALLOWED_URI_REGEXP||se,Ie=ae.NAMESPACE||ye,ie&&(oe=!1),_&&(B=!0),L&&(fe=He({},[].concat(rt(Bt))),te=[],L.html===!0&&(He(fe,Ot),He(te,Ht)),L.svg===!0&&(He(fe,At),He(te,Ft),He(te,yt)),L.svgFilters===!0&&(He(fe,St),He(te,Ft),He(te,yt)),L.mathMl===!0&&(He(fe,kt),He(te,Ut),He(te,yt))),ae.ADD_TAGS&&(fe===Ae&&(fe=ct(fe)),He(fe,ae.ADD_TAGS)),ae.ADD_ATTR&&(te===ve&&(te=ct(te)),He(te,ae.ADD_ATTR)),ae.ADD_URI_SAFE_ATTR&&He(ee,ae.ADD_URI_SAFE_ATTR),ae.FORBID_CONTENTS&&(M===P&&(M=ct(M)),He(M,ae.FORBID_CONTENTS)),H&&(fe["#text"]=!0),A&&He(fe,["html","head","body"]),fe.table&&(He(fe,["tbody"]),delete Ne.tbody),et&&et(ae),we=ae)},Ke=He({},["mi","mo","mn","ms","mtext"]),Ue=He({},["foreignobject","desc","title","annotation-xml"]),We=He({},At);He(We,St),He(We,Jt);var xe=He({},kt);He(xe,xt);var it=function(ae){var Ce=p(ae);(!Ce||!Ce.tagName)&&(Ce={namespaceURI:ye,tagName:"template"});var Le=ut(ae.tagName),ze=ut(Ce.tagName);if(ae.namespaceURI===De)return Ce.namespaceURI===ye?Le==="svg":Ce.namespaceURI===de?Le==="svg"&&(ze==="annotation-xml"||Ke[ze]):Boolean(We[Le]);if(ae.namespaceURI===de)return Ce.namespaceURI===ye?Le==="math":Ce.namespaceURI===De?Le==="math"&&Ue[ze]:Boolean(xe[Le]);if(ae.namespaceURI===ye){if(Ce.namespaceURI===De&&!Ue[ze]||Ce.namespaceURI===de&&!Ke[ze])return!1;var Ge=He({},["title","style","font","a","script"]);return!xe[Le]&&(Ge[Le]||!We[Le])}return!1},Be=function(ae){mt(t.removed,{element:ae});try{ae.parentNode.removeChild(ae)}catch{try{ae.outerHTML=g}catch{ae.remove()}}},je=function(ae,Ce){try{mt(t.removed,{attribute:Ce.getAttributeNode(ae),from:Ce})}catch{mt(t.removed,{attribute:null,from:Ce})}if(Ce.removeAttribute(ae),ae==="is"&&!te[ae])if(B||_)try{Be(Ce)}catch{}else try{Ce.setAttribute(ae,"")}catch{}},Ye=function(ae){var Ce=void 0,Le=void 0;if(h)ae="<remove></remove>"+ae;else{var ze=Pt(ae,/^[\r\n\t ]+/);Le=ze&&ze[0]}var Ge=S?S.createHTML(ae):ae;if(Ie===ye)try{Ce=new n().parseFromString(Ge,"text/html")}catch{}if(!Ce||!Ce.documentElement){Ce=N.createDocument(Ie,"template",null);try{Ce.documentElement.innerHTML=Se?"":Ge}catch{}}var Ze=Ce.body||Ce.documentElement;return ae&&Le&&Ze.insertBefore(i.createTextNode(Le),Ze.childNodes[0]||null),Ie===ye?w.call(Ce,A?"html":"body")[0]:A?Ce.documentElement:Ze},K=function(ae){return F.call(ae.ownerDocument||ae,ae,u.SHOW_ELEMENT|u.SHOW_COMMENT|u.SHOW_TEXT,null,!1)},ue=function(ae){return ae instanceof I||ae instanceof o?!1:typeof ae.nodeName!="string"||typeof ae.textContent!="string"||typeof ae.removeChild!="function"||!(ae.attributes instanceof f)||typeof ae.removeAttribute!="function"||typeof ae.setAttribute!="function"||typeof ae.namespaceURI!="string"||typeof ae.insertBefore!="function"},pe=function(ae){return(typeof y>"u"?"undefined":bt(y))==="object"?ae instanceof y:ae&&(typeof ae>"u"?"undefined":bt(ae))==="object"&&typeof ae.nodeType=="number"&&typeof ae.nodeName=="string"},Ee=function(ae,Ce,Le){!R[ae]||Yt(R[ae],function(ze){ze.call(t,Ce,Le,we)})},Fe=function(ae){var Ce=void 0;if(Ee("beforeSanitizeElements",ae,null),ue(ae)||Pt(ae.nodeName,/[\u0080-\uFFFF]/))return Be(ae),!0;var Le=ut(ae.nodeName);if(Ee("uponSanitizeElement",ae,{tagName:Le,allowedTags:fe}),!pe(ae.firstElementChild)&&(!pe(ae.content)||!pe(ae.content.firstElementChild))&&at(/<[/\w]/g,ae.innerHTML)&&at(/<[/\w]/g,ae.textContent)||Le==="select"&&at(/<template/i,ae.innerHTML))return Be(ae),!0;if(!fe[Le]||Ne[Le]){if(H&&!M[Le]){var ze=p(ae)||ae.parentNode,Ge=l(ae)||ae.childNodes;if(Ge&&ze)for(var Ze=Ge.length,Qe=Ze-1;Qe>=0;--Qe)ze.insertBefore(r(Ge[Qe],!0),a(ae))}return Be(ae),!0}return ae instanceof b&&!it(ae)||(Le==="noscript"||Le==="noembed")&&at(/<\/no(script|embed)/i,ae.innerHTML)?(Be(ae),!0):(ie&&ae.nodeType===3&&(Ce=ae.textContent,Ce=lt(Ce,V," "),Ce=lt(Ce,Z," "),ae.textContent!==Ce&&(mt(t.removed,{element:ae.cloneNode()}),ae.textContent=Ce)),Ee("afterSanitizeElements",ae,null),!1)},Oe=function(ae,Ce,Le){if(T&&(Ce==="id"||Ce==="name")&&(Le in i||Le in Re))return!1;if(!(oe&&!he[Ce]&&at(X,Ce))){if(!(Q&&at(x,Ce))){if(!te[Ce]||he[Ce])return!1;if(!ee[Ce]){if(!at(se,lt(Le,le,""))){if(!((Ce==="src"||Ce==="xlink:href"||Ce==="href")&&ae!=="script"&&Xt(Le,"data:")===0&&O[ae])){if(!(re&&!at(ne,lt(Le,le,"")))){if(Le)return!1}}}}}}return!0},$e=function(ae){var Ce=void 0,Le=void 0,ze=void 0,Ge=void 0;Ee("beforeSanitizeAttributes",ae,null);var Ze=ae.attributes;if(!!Ze){var Qe={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:te};for(Ge=Ze.length;Ge--;){Ce=Ze[Ge];var st=Ce,ht=st.name,Et=st.namespaceURI;if(Le=Zt(Ce.value),ze=ut(ht),Qe.attrName=ze,Qe.attrValue=Le,Qe.keepAttr=!0,Qe.forceKeepAttr=void 0,Ee("uponSanitizeAttribute",ae,Qe),Le=Qe.attrValue,!Qe.forceKeepAttr&&(je(ht,ae),!!Qe.keepAttr)){if(at(/\/>/i,Le)){je(ht,ae);continue}ie&&(Le=lt(Le,V," "),Le=lt(Le,Z," "));var Tt=ae.nodeName.toLowerCase();if(!!Oe(Tt,ze,Le))try{Et?ae.setAttributeNS(Et,ht,Le):ae.setAttribute(ht,Le),Mt(t.removed)}catch{}}}Ee("afterSanitizeAttributes",ae,null)}},tt=function Me(ae){var Ce=void 0,Le=K(ae);for(Ee("beforeSanitizeShadowDOM",ae,null);Ce=Le.nextNode();)Ee("uponSanitizeShadowNode",Ce,null),!Fe(Ce)&&(Ce.content instanceof z&&Me(Ce.content),$e(Ce));Ee("afterSanitizeShadowDOM",ae,null)};return t.sanitize=function(Me,ae){var Ce=void 0,Le=void 0,ze=void 0,Ge=void 0,Ze=void 0;if(Se=!Me,Se&&(Me="<!-->"),typeof Me!="string"&&!pe(Me)){if(typeof Me.toString!="function")throw Rt("toString is not a function");if(Me=Me.toString(),typeof Me!="string")throw Rt("dirty is not a string, aborting")}if(!t.isSupported){if(bt(J.toStaticHTML)==="object"||typeof J.toStaticHTML=="function"){if(typeof Me=="string")return J.toStaticHTML(Me);if(pe(Me))return J.toStaticHTML(Me.outerHTML)}return Me}if(C||Pe(ae),t.removed=[],typeof Me=="string"&&(W=!1),!W)if(Me instanceof y)Ce=Ye("<!---->"),Le=Ce.ownerDocument.importNode(Me,!0),Le.nodeType===1&&Le.nodeName==="BODY"||Le.nodeName==="HTML"?Ce=Le:Ce.appendChild(Le);else{if(!B&&!ie&&!A&&Me.indexOf("<")===-1)return S&&Y?S.createHTML(Me):Me;if(Ce=Ye(Me),!Ce)return B?null:g}Ce&&h&&Be(Ce.firstChild);for(var Qe=K(W?Me:Ce);ze=Qe.nextNode();)ze.nodeType===3&&ze===Ge||Fe(ze)||(ze.content instanceof z&&tt(ze.content),$e(ze),Ge=ze);if(Ge=null,W)return Me;if(B){if(_)for(Ze=d.call(Ce.ownerDocument);Ce.firstChild;)Ze.appendChild(Ce.firstChild);else Ze=Ce;return $&&(Ze=m.call(v,Ze,!0)),Ze}var st=A?Ce.outerHTML:Ce.innerHTML;return ie&&(st=lt(st,V," "),st=lt(st,Z," ")),S&&Y?S.createHTML(st):st},t.setConfig=function(Me){Pe(Me),C=!0},t.clearConfig=function(){we=null,C=!1},t.isValidAttribute=function(Me,ae,Ce){we||Pe({});var Le=ut(Me),ze=ut(ae);return Oe(Le,ze,Ce)},t.addHook=function(Me,ae){typeof ae=="function"&&(R[Me]=R[Me]||[],mt(R[Me],ae))},t.removeHook=function(Me){R[Me]&&Mt(R[Me])},t.removeHooks=function(Me){R[Me]&&(R[Me]=[])},t.removeAllHooks=function(){R={}},t}var hi=zt();define("vs/base/browser/dompurify/dompurify",function(){return hi}),define(me[39],be([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createFastDomNode=t.FastDomNode=void 0;class v{constructor(y){this.domNode=y,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(y){const b=i(y);this.a!==b&&(this.a=b,this.domNode.style.maxWidth=this.a)}setWidth(y){const b=i(y);this.b!==b&&(this.b=b,this.domNode.style.width=this.b)}setHeight(y){const b=i(y);this.c!==b&&(this.c=b,this.domNode.style.height=this.c)}setTop(y){const b=i(y);this.d!==b&&(this.d=b,this.domNode.style.top=this.d)}setLeft(y){const b=i(y);this.e!==b&&(this.e=b,this.domNode.style.left=this.e)}setBottom(y){const b=i(y);this.f!==b&&(this.f=b,this.domNode.style.bottom=this.f)}setRight(y){const b=i(y);this.g!==b&&(this.g=b,this.domNode.style.right=this.g)}setPaddingTop(y){const b=i(y);this.h!==b&&(this.h=b,this.domNode.style.paddingTop=this.h)}setPaddingLeft(y){const b=i(y);this.i!==b&&(this.i=b,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(y){const b=i(y);this.j!==b&&(this.j=b,this.domNode.style.paddingBottom=this.j)}setPaddingRight(y){const b=i(y);this.k!==b&&(this.k=b,this.domNode.style.paddingRight=this.k)}setFontFamily(y){this.l!==y&&(this.l=y,this.domNode.style.fontFamily=this.l)}setFontWeight(y){this.m!==y&&(this.m=y,this.domNode.style.fontWeight=this.m)}setFontSize(y){const b=i(y);this.n!==b&&(this.n=b,this.domNode.style.fontSize=this.n)}setFontStyle(y){this.o!==y&&(this.o=y,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(y){this.p!==y&&(this.p=y,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(y){this.q!==y&&(this.q=y,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(y){this.r!==y&&(this.r=y,this.domNode.style.textDecoration=this.r)}setLineHeight(y){const b=i(y);this.s!==b&&(this.s=b,this.domNode.style.lineHeight=this.s)}setLetterSpacing(y){const b=i(y);this.t!==b&&(this.t=b,this.domNode.style.letterSpacing=this.t)}setClassName(y){this.u!==y&&(this.u=y,this.domNode.className=this.u)}toggleClassName(y,b){this.domNode.classList.toggle(y,b),this.u=this.domNode.className}setDisplay(y){this.v!==y&&(this.v=y,this.domNode.style.display=this.v)}setPosition(y){this.w!==y&&(this.w=y,this.domNode.style.position=this.w)}setVisibility(y){this.x!==y&&(this.x=y,this.domNode.style.visibility=this.x)}setColor(y){this.y!==y&&(this.y=y,this.domNode.style.color=this.y)}setBackgroundColor(y){this.z!==y&&(this.z=y,this.domNode.style.backgroundColor=this.z)}setLayerHinting(y){this.A!==y&&(this.A=y,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(y){this.C!==y&&(this.C=y,this.domNode.style.boxShadow=y)}setContain(y){this.B!==y&&(this.B=y,this.domNode.style.contain=this.B)}setAttribute(y,b){this.domNode.setAttribute(y,b)}removeAttribute(y){this.domNode.removeAttribute(y)}appendChild(y){this.domNode.appendChild(y.domNode)}removeChild(y){this.domNode.removeChild(y.domNode)}}t.FastDomNode=v;function i(U){return typeof U=="number"?`${U}px`:U}function z(U){return new v(U)}t.createFastDomNode=z}),define(me[67],be([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IframeUtils=void 0;let v=!1,i=null;function z(y){if(!y.parent||y.parent===y)return null;try{const b=y.location,u=y.parent.location;if(b.origin!=="null"&&u.origin!=="null"&&b.origin!==u.origin)return v=!0,null}catch{return v=!0,null}return y.parent}class U{static getSameOriginWindowChain(){if(!i){i=[];let b=window,u;do u=z(b),u?i.push({window:b,iframeElement:b.frameElement||null}):i.push({window:b,iframeElement:null}),b=u;while(b)}return i.slice(0)}static hasDifferentOriginAncestor(){return i||this.getSameOriginWindowChain(),v}static getPositionOfChildWindowRelativeToAncestorWindow(b,u){if(!u||b===u)return{top:0,left:0};let c=0,f=0;const I=this.getSameOriginWindowChain();for(const o of I){if(c+=o.window.scrollY,f+=o.window.scrollX,o.window===u||!o.iframeElement)break;const n=o.iframeElement.getBoundingClientRect();c+=n.top,f+=n.left}return{top:c,left:f}}}t.IframeUtils=U}),define(me[68],be([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedListVirtualDelegate=t.ListError=t.ListDragOverReactions=t.ListDragOverEffect=void 0;var v;(function(U){U[U.Copy=0]="Copy",U[U.Move=1]="Move"})(v=t.ListDragOverEffect||(t.ListDragOverEffect={})),t.ListDragOverReactions={reject(){return{accept:!1}},accept(){return{accept:!0}}};class i extends Error{constructor(y,b){super(`ListError [${y}] ${b}`)}}t.ListError=i;class z{constructor(){this.c=new WeakMap}getHeight(y){return this.c.get(y)??this.d(y)}setDynamicHeight(y,b){b>0&&this.c.set(y,b)}}t.CachedListVirtualDelegate=z}),define(me[69],be([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CombinedSpliceable=void 0;class v{constructor(z){this.a=z}splice(z,U,y){this.a.forEach(b=>b.splice(z,U,y))}}t.CombinedSpliceable=v}),define(me[40],be([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarState=void 0;const v=20;class i{constructor(U,y,b,u,c,f){this.a=Math.round(y),this.b=Math.round(b),this.c=Math.round(U),this.d=u,this.e=c,this.f=f,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new i(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(U){const y=Math.round(U);return this.d!==y?(this.d=y,this.m(),!0):!1}setScrollSize(U){const y=Math.round(U);return this.e!==y?(this.e=y,this.m(),!0):!1}setScrollPosition(U){const y=Math.round(U);return this.f!==y?(this.f=y,this.m(),!0):!1}setScrollbarSize(U){this.a=Math.round(U)}setOppositeScrollbarSize(U){this.b=Math.round(U)}static l(U,y,b,u,c){const f=Math.max(0,b-U),I=Math.max(0,f-2*y),o=u>0&&u>b;if(!o)return{computedAvailableSize:Math.round(f),computedIsNeeded:o,computedSliderSize:Math.round(I),computedSliderRatio:0,computedSliderPosition:0};const n=Math.round(Math.max(v,Math.floor(b*I/u))),e=(I-n)/(u-b),s=c*e;return{computedAvailableSize:Math.round(f),computedIsNeeded:o,computedSliderSize:Math.round(n),computedSliderRatio:e,computedSliderPosition:Math.round(s)}}m(){const U=i.l(this.b,this.c,this.d,this.e,this.f);this.g=U.computedAvailableSize,this.h=U.computedIsNeeded,this.i=U.computedSliderSize,this.j=U.computedSliderRatio,this.k=U.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(U){if(!this.h)return 0;const y=U-this.c-this.i/2;return Math.round(y/this.j)}getDesiredScrollPositionFromOffsetPaged(U){if(!this.h)return 0;const y=U-this.c;let b=this.f;return y<this.k?b-=this.d:b+=this.d,b}getDesiredScrollPositionFromDelta(U){if(!this.h)return 0;const y=this.k+U;return Math.round(y/this.j)}}t.ScrollbarState=i}),define(me[23],be([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WeakMapper=t.TreeError=t.TreeDragOverReactions=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.TreeVisibility=void 0;var v;(function(b){b[b.Hidden=0]="Hidden",b[b.Visible=1]="Visible",b[b.Recurse=2]="Recurse"})(v=t.TreeVisibility||(t.TreeVisibility={}));var i;(function(b){b[b.Unknown=0]="Unknown",b[b.Twistie=1]="Twistie",b[b.Element=2]="Element",b[b.Filter=3]="Filter"})(i=t.TreeMouseEventTarget||(t.TreeMouseEventTarget={}));var z;(function(b){b[b.Down=0]="Down",b[b.Up=1]="Up"})(z=t.TreeDragOverBubble||(t.TreeDragOverBubble={})),t.TreeDragOverReactions={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(b=!1){return{accept:!0,bubble:0,autoExpand:b}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(b=!1){return{accept:!0,bubble:0,effect:0,autoExpand:b}}};class U extends Error{constructor(u,c){super(`TreeError [${u}] ${c}`)}}t.TreeError=U;class y{constructor(u){this.a=u,this.b=new WeakMap}map(u){let c=this.b.get(u);return c||(c=this.a(u),this.b.set(u,c)),c}}t.WeakMapper=y}),define(me[12],be([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CSSIcon=t.Codicon=t.getCodiconAriaLabel=void 0;function v(U){return U?U.replace(/\$\((.*?)\)/g,(y,b)=>` ${b} `).trim():""}t.getCodiconAriaLabel=v;class i{constructor(y,b,u){this.id=y,this.definition=b,this.description=u,i.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i.a}}t.Codicon=i,i.a=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",i.circleFilled.definition),i.closeDirty=new i("close-dirty",i.circleFilled.definition),i.debugBreakpoint=new i("debug-breakpoint",i.circleFilled.definition),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",i.circleFilled.definition),i.debugHint=new i("debug-hint",i.circleFilled.definition),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circle=new i("circle",{fontCharacter:"\\eabc"}),i.circleOutline=new i("circle-outline",i.circle.definition),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",i.circle.definition),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.circleSmallFilled=new i("circle-small-filled",{fontCharacter:"\\eb8a"}),i.debugStackframeDot=new i("debug-stackframe-dot",i.circleSmallFilled.definition),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLarge=new i("circle-large",{fontCharacter:"\\ebb5"}),i.circleLargeOutline=new i("circle-large-outline",i.circleLarge.definition),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.layoutActivitybarLeft=new i("layout-activitybar-left",{fontCharacter:"\\ebec"}),i.layoutActivitybarRight=new i("layout-activitybar-right",{fontCharacter:"\\ebed"}),i.layoutPanelLeft=new i("layout-panel-left",{fontCharacter:"\\ebee"}),i.layoutPanelCenter=new i("layout-panel-center",{fontCharacter:"\\ebef"}),i.layoutPanelJustify=new i("layout-panel-justify",{fontCharacter:"\\ebf0"}),i.layoutPanelRight=new i("layout-panel-right",{fontCharacter:"\\ebf1"}),i.layoutPanel=new i("layout-panel",{fontCharacter:"\\ebf2"}),i.layoutSidebarLeft=new i("layout-sidebar-left",{fontCharacter:"\\ebf3"}),i.layoutSidebarRight=new i("layout-sidebar-right",{fontCharacter:"\\ebf4"}),i.layoutStatusbar=new i("layout-statusbar",{fontCharacter:"\\ebf5"}),i.layoutMenubar=new i("layout-menubar",{fontCharacter:"\\ebf6"}),i.layoutCentered=new i("layout-centered",{fontCharacter:"\\ebf7"}),i.layoutSidebarRightOff=new i("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),i.layoutPanelOff=new i("layout-panel-off",{fontCharacter:"\\ec01"}),i.layoutSidebarLeftOff=new i("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),i.target=new i("target",{fontCharacter:"\\ebf8"}),i.indent=new i("indent",{fontCharacter:"\\ebf9"}),i.recordSmall=new i("record-small",{fontCharacter:"\\ebfa"}),i.errorSmall=new i("error-small",{fontCharacter:"\\ebfb"}),i.arrowCircleDown=new i("arrow-circle-down",{fontCharacter:"\\ebfc"}),i.arrowCircleLeft=new i("arrow-circle-left",{fontCharacter:"\\ebfd"}),i.arrowCircleRight=new i("arrow-circle-right",{fontCharacter:"\\ebfe"}),i.arrowCircleUp=new i("arrow-circle-up",{fontCharacter:"\\ebff"}),i.heartFilled=new i("heart-filled",{fontCharacter:"\\ec04"}),i.map=new i("map",{fontCharacter:"\\ec05"}),i.mapFilled=new i("map-filled",{fontCharacter:"\\ec06"}),i.circleSmall=new i("circle-small",{fontCharacter:"\\ec07"}),i.bellSlash=new i("bell-slash",{fontCharacter:"\\ec08"}),i.bellSlashDot=new i("bell-slash-dot",{fontCharacter:"\\ec09"}),i.commentUnresolved=new i("comment-unresolved",{fontCharacter:"\\ec0a"}),i.gitPullRequestGoToChanges=new i("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),i.gitPullRequestNewChanges=new i("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),i.searchFuzzy=new i("search-fuzzy",{fontCharacter:"\\ec0d"}),i.commentDraft=new i("comment-draft",{fontCharacter:"\\ec0e"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);var z;(function(U){U.iconNameSegment="[A-Za-z0-9]+",U.iconNameExpression="[A-Za-z0-9-]+",U.iconModifierExpression="~[A-Za-z]+",U.iconNameCharacter="[A-Za-z0-9~-]";const y=new RegExp(`^(${U.iconNameExpression})(${U.iconModifierExpression})?$`);function b(f){if(f instanceof i)return["codicon","codicon-"+f.id];const I=y.exec(f.id);if(!I)return b(i.error);const[,o,n]=I,e=["codicon","codicon-"+o];return n&&e.push("codicon-modifier-"+n.substring(1)),e}U.asClassNameArray=b;function u(f){return b(f).join(" ")}U.asClassName=u;function c(f){return"."+b(f).join(".")}U.asCSSSelector=c})(z=t.CSSIcon||(t.CSSIcon={}))}),define(me[70],be([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.diffMaps=t.diffSets=t.groupBy=void 0;function v(y,b){const u=Object.create(null);for(const c of y){const f=b(c);let I=u[f];I||(I=u[f]=[]),I.push(c)}return u}t.groupBy=v;function i(y,b){const u=[],c=[];for(const f of y)b.has(f)||u.push(f);for(const f of b)y.has(f)||c.push(f);return{removed:u,added:c}}t.diffSets=i;function z(y,b){const u=[],c=[];for(const[f,I]of y)b.has(f)||u.push(I);for(const[f,I]of b)y.has(f)||c.push(I);return{removed:u,added:c}}t.diffMaps=z;class U{constructor(){this.a=new Map}add(b,u){let c=this.a.get(b);c||(c=new Set,this.a.set(b,c)),c.add(u)}delete(b,u){const c=this.a.get(b);!c||(c.delete(u),c.size===0&&this.a.delete(b))}forEach(b,u){const c=this.a.get(b);!c||c.forEach(u)}}t.SetMap=U}),define(me[41],be([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function v(b,u){const c=Math.pow(10,u);return Math.round(b*c)/c}class i{constructor(u,c,f,I=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,u))|0,this.g=Math.min(255,Math.max(0,c))|0,this.b=Math.min(255,Math.max(0,f))|0,this.a=v(Math.max(Math.min(1,I),0),3)}static equals(u,c){return u.r===c.r&&u.g===c.g&&u.b===c.b&&u.a===c.a}}t.RGBA=i;class z{constructor(u,c,f,I){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=v(Math.max(Math.min(1,c),0),3),this.l=v(Math.max(Math.min(1,f),0),3),this.a=v(Math.max(Math.min(1,I),0),3)}static equals(u,c){return u.h===c.h&&u.s===c.s&&u.l===c.l&&u.a===c.a}static fromRGBA(u){const c=u.r/255,f=u.g/255,I=u.b/255,o=u.a,n=Math.max(c,f,I),e=Math.min(c,f,I);let s=0,r=0;const a=(e+n)/2,l=n-e;if(l>0){switch(r=Math.min(a<=.5?l/(2*a):l/(2-2*a),1),n){case c:s=(f-I)/l+(f<I?6:0);break;case f:s=(I-c)/l+2;break;case I:s=(c-f)/l+4;break}s*=60,s=Math.round(s)}return new z(s,r,a,o)}static i(u,c,f){return f<0&&(f+=1),f>1&&(f-=1),f<1/6?u+(c-u)*6*f:f<1/2?c:f<2/3?u+(c-u)*(2/3-f)*6:u}static toRGBA(u){const c=u.h/360,{s:f,l:I,a:o}=u;let n,e,s;if(f===0)n=e=s=I;else{const r=I<.5?I*(1+f):I+f-I*f,a=2*I-r;n=z.i(a,r,c+1/3),e=z.i(a,r,c),s=z.i(a,r,c-1/3)}return new i(Math.round(n*255),Math.round(e*255),Math.round(s*255),o)}}t.HSLA=z;class U{constructor(u,c,f,I){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=v(Math.max(Math.min(1,c),0),3),this.v=v(Math.max(Math.min(1,f),0),3),this.a=v(Math.max(Math.min(1,I),0),3)}static equals(u,c){return u.h===c.h&&u.s===c.s&&u.v===c.v&&u.a===c.a}static fromRGBA(u){const c=u.r/255,f=u.g/255,I=u.b/255,o=Math.max(c,f,I),n=Math.min(c,f,I),e=o-n,s=o===0?0:e/o;let r;return e===0?r=0:o===c?r=((f-I)/e%6+6)%6:o===f?r=(I-c)/e+2:r=(c-f)/e+4,new U(Math.round(r*60),s,o,u.a)}static toRGBA(u){const{h:c,s:f,v:I,a:o}=u,n=I*f,e=n*(1-Math.abs(c/60%2-1)),s=I-n;let[r,a,l]=[0,0,0];return c<60?(r=n,a=e):c<120?(r=e,a=n):c<180?(a=n,l=e):c<240?(a=e,l=n):c<300?(r=e,l=n):c<=360&&(r=n,l=e),r=Math.round((r+s)*255),a=Math.round((a+s)*255),l=Math.round((l+s)*255),new i(r,a,l,o)}}t.HSVA=U;class y{static fromHex(u){return y.Format.CSS.parseHex(u)||y.red}static equals(u,c){return!u&&!c?!0:!u||!c?!1:u.equals(c)}get hsla(){return this.i?this.i:z.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:U.fromRGBA(this.rgba)}constructor(u){if(u)if(u instanceof i)this.rgba=u;else if(u instanceof z)this.i=u,this.rgba=z.toRGBA(u);else if(u instanceof U)this.j=u,this.rgba=U.toRGBA(u);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(u){return!!u&&i.equals(this.rgba,u.rgba)&&z.equals(this.hsla,u.hsla)&&U.equals(this.hsva,u.hsva)}getRelativeLuminance(){const u=y.k(this.rgba.r),c=y.k(this.rgba.g),f=y.k(this.rgba.b),I=.2126*u+.7152*c+.0722*f;return v(I,4)}static k(u){const c=u/255;return c<=.03928?c/12.92:Math.pow((c+.055)/1.055,2.4)}getContrastRatio(u){const c=this.getRelativeLuminance(),f=u.getRelativeLuminance();return c>f?(c+.05)/(f+.05):(f+.05)/(c+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(u){const c=this.getRelativeLuminance(),f=u.getRelativeLuminance();return c>f}isDarkerThan(u){const c=this.getRelativeLuminance(),f=u.getRelativeLuminance();return c<f}lighten(u){return new y(new z(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*u,this.hsla.a))}darken(u){return new y(new z(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*u,this.hsla.a))}transparent(u){const{r:c,g:f,b:I,a:o}=this.rgba;return new y(new i(c,f,I,o*u))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new y(new i(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(u){const c=u.rgba,f=this.rgba.a,I=c.a,o=f+I*(1-f);if(o<1e-6)return y.transparent;const n=this.rgba.r*f/o+c.r*I*(1-f)/o,e=this.rgba.g*f/o+c.g*I*(1-f)/o,s=this.rgba.b*f/o+c.b*I*(1-f)/o;return new y(new i(n,e,s,o))}makeOpaque(u){if(this.isOpaque()||u.rgba.a!==1)return this;const{r:c,g:f,b:I,a:o}=this.rgba;return new y(new i(u.rgba.r-o*(u.rgba.r-c),u.rgba.g-o*(u.rgba.g-f),u.rgba.b-o*(u.rgba.b-I),1))}flatten(...u){const c=u.reduceRight((f,I)=>y.o(I,f));return y.o(this,c)}static o(u,c){const f=1-u.rgba.a;return new y(new i(f*c.rgba.r+u.rgba.a*u.rgba.r,f*c.rgba.g+u.rgba.a*u.rgba.g,f*c.rgba.b+u.rgba.a*u.rgba.b))}toString(){return this.u||(this.u=y.Format.CSS.format(this)),this.u}static getLighterColor(u,c,f){if(u.isLighterThan(c))return u;f=f||.5;const I=u.getRelativeLuminance(),o=c.getRelativeLuminance();return f=f*(o-I)/o,u.lighten(f)}static getDarkerColor(u,c,f){if(u.isDarkerThan(c))return u;f=f||.5;const I=u.getRelativeLuminance(),o=c.getRelativeLuminance();return f=f*(I-o)/I,u.darken(f)}}t.Color=y,y.white=new y(new i(255,255,255,1)),y.black=new y(new i(0,0,0,1)),y.red=new y(new i(255,0,0,1)),y.blue=new y(new i(0,0,255,1)),y.green=new y(new i(0,255,0,1)),y.cyan=new y(new i(0,255,255,1)),y.lightgrey=new y(new i(211,211,211,1)),y.transparent=new y(new i(0,0,0,0)),function(b){let u;(function(c){let f;(function(I){function o(g){return g.rgba.a===1?`rgb(${g.rgba.r}, ${g.rgba.g}, ${g.rgba.b})`:b.Format.CSS.formatRGBA(g)}I.formatRGB=o;function n(g){return`rgba(${g.rgba.r}, ${g.rgba.g}, ${g.rgba.b}, ${+g.rgba.a.toFixed(2)})`}I.formatRGBA=n;function e(g){return g.hsla.a===1?`hsl(${g.hsla.h}, ${(g.hsla.s*100).toFixed(2)}%, ${(g.hsla.l*100).toFixed(2)}%)`:b.Format.CSS.formatHSLA(g)}I.formatHSL=e;function s(g){return`hsla(${g.hsla.h}, ${(g.hsla.s*100).toFixed(2)}%, ${(g.hsla.l*100).toFixed(2)}%, ${g.hsla.a.toFixed(2)})`}I.formatHSLA=s;function r(g){const E=g.toString(16);return E.length!==2?"0"+E:E}function a(g){return`#${r(g.rgba.r)}${r(g.rgba.g)}${r(g.rgba.b)}`}I.formatHex=a;function l(g,E=!1){return E&&g.rgba.a===1?b.Format.CSS.formatHex(g):`#${r(g.rgba.r)}${r(g.rgba.g)}${r(g.rgba.b)}${r(Math.round(g.rgba.a*255))}`}I.formatHexA=l;function p(g){return g.isOpaque()?b.Format.CSS.formatHex(g):b.Format.CSS.formatRGBA(g)}I.format=p;function k(g){const E=g.length;if(E===0||g.charCodeAt(0)!==35)return null;if(E===7){const N=16*S(g.charCodeAt(1))+S(g.charCodeAt(2)),F=16*S(g.charCodeAt(3))+S(g.charCodeAt(4)),d=16*S(g.charCodeAt(5))+S(g.charCodeAt(6));return new b(new i(N,F,d,1))}if(E===9){const N=16*S(g.charCodeAt(1))+S(g.charCodeAt(2)),F=16*S(g.charCodeAt(3))+S(g.charCodeAt(4)),d=16*S(g.charCodeAt(5))+S(g.charCodeAt(6)),w=16*S(g.charCodeAt(7))+S(g.charCodeAt(8));return new b(new i(N,F,d,w/255))}if(E===4){const N=S(g.charCodeAt(1)),F=S(g.charCodeAt(2)),d=S(g.charCodeAt(3));return new b(new i(16*N+N,16*F+F,16*d+d))}if(E===5){const N=S(g.charCodeAt(1)),F=S(g.charCodeAt(2)),d=S(g.charCodeAt(3)),w=S(g.charCodeAt(4));return new b(new i(16*N+N,16*F+F,16*d+d,(16*w+w)/255))}return null}I.parseHex=k;function S(g){switch(g){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(f=c.CSS||(c.CSS={}))})(u=b.Format||(b.Format={}))}(y=t.Color||(t.Color={}))}),define(me[24],be([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=void 0;function v(y){return(b,u,c)=>{let f=null,I=null;if(typeof c.value=="function"?(f="value",I=c.value):typeof c.get=="function"&&(f="get",I=c.get),!I)throw new Error("not supported");c[f]=y(I,u)}}function i(y,b,u){let c=null,f=null;if(typeof u.value=="function"?(c="value",f=u.value,f.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(c="get",f=u.get),!f)throw new Error("not supported");const I=`$memoize$${b}`;u[c]=function(...o){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:f.apply(this,o)}),this[I]}}t.memoize=i;function z(y,b,u){return v((c,f)=>{const I=`$debounce$${f}`,o=`$debounce$result$${f}`;return function(...n){this[o]||(this[o]=u?u():void 0),clearTimeout(this[I]),b&&(this[o]=b(this[o],...n),n=[this[o]]),this[I]=setTimeout(()=>{c.apply(this,n),this[o]=u?u():void 0},y)}})}t.debounce=z;function U(y,b,u){return v((c,f)=>{const I=`$throttle$timer$${f}`,o=`$throttle$result$${f}`,n=`$throttle$lastRun$${f}`,e=`$throttle$pending$${f}`;return function(...s){if(this[o]||(this[o]=u?u():void 0),(this[n]===null||this[n]===void 0)&&(this[n]=-Number.MAX_VALUE),b&&(this[o]=b(this[o],...s)),this[e])return;const r=this[n]+y;r<=Date.now()?(this[n]=Date.now(),c.apply(this,[this[o]]),this[o]=u?u():void 0):(this[e]=!0,this[I]=setTimeout(()=>{this[e]=!1,this[n]=Date.now(),c.apply(this,[this[o]]),this[o]=u?u():void 0},r-Date.now()))}})}t.throttle=U}),define(me[71],be([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class v{constructor(z,U,y,b){this.originalStart=z,this.originalLength=U,this.modifiedStart=y,this.modifiedLength=b}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=v}),define(me[9],be([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class v{constructor(){this.b=[],this.a=function(g){setTimeout(()=>{throw g.stack?p.isErrorNoTelemetry(g)?new p(g.message+`

`+g.stack):new Error(g.message+`

`+g.stack):g},0)}}addListener(g){return this.b.push(g),()=>{this.d(g)}}c(g){this.b.forEach(E=>{E(g)})}d(g){this.b.splice(this.b.indexOf(g),1)}setUnexpectedErrorHandler(g){this.a=g}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(g){this.a(g),this.c(g)}onUnexpectedExternalError(g){this.a(g)}}t.ErrorHandler=v,t.errorHandler=new v;function i(S){t.errorHandler.setUnexpectedErrorHandler(S)}t.setUnexpectedErrorHandler=i;function z(S){u(S)||t.errorHandler.onUnexpectedError(S)}t.onUnexpectedError=z;function U(S){u(S)||t.errorHandler.onUnexpectedExternalError(S)}t.onUnexpectedExternalError=U;function y(S){if(S instanceof Error){const{name:g,message:E}=S,N=S.stacktrace||S.stack;return{$isError:!0,name:g,message:E,stack:N,noTelemetry:p.isErrorNoTelemetry(S)}}return S}t.transformErrorForSerialization=y;const b="Canceled";function u(S){return S instanceof c?!0:S instanceof Error&&S.name===b&&S.message===b}t.isCancellationError=u;class c extends Error{constructor(){super(b),this.name=this.message}}t.CancellationError=c;function f(){const S=new Error(b);return S.name=S.message,S}t.canceled=f;function I(S){return S?new Error(`Illegal argument: ${S}`):new Error("Illegal argument")}t.illegalArgument=I;function o(S){return S?new Error(`Illegal state: ${S}`):new Error("Illegal state")}t.illegalState=o;function n(S){return S?new Error(`readonly property '${S} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=n;function e(S){const g=new Error(`${S} has been disposed`);return g.name="DISPOSED",g}t.disposed=e;function s(S){return S?S.message?S.message:S.stack?S.stack.split(`
`)[0]:String(S):"Error"}t.getErrorMessage=s;class r extends Error{constructor(g){super("NotImplemented"),g&&(this.message=g)}}t.NotImplementedError=r;class a extends Error{constructor(g){super("NotSupported"),g&&(this.message=g)}}t.NotSupportedError=a;class l extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=l;class p extends Error{constructor(g){super(g),this.name="CodeExpectedError"}static fromError(g){if(g instanceof p)return g;const E=new p;return E.message=g.message,E.stack=g.stack,E}static isErrorNoTelemetry(g){return g.name==="CodeExpectedError"}}t.ErrorNoTelemetry=p;class k extends Error{constructor(g){super(g||"An unexpected bug occurred."),Object.setPrototypeOf(this,k.prototype);debugger}}t.BugIndicatingError=k}),define(me[14],be([1,0,9]),function(J,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function i(T,H=0){return T[T.length-(1+H)]}t.tail=i;function z(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}t.tail2=z;function U(T,H,W=(L,M)=>L===M){if(T===H)return!0;if(!T||!H||T.length!==H.length)return!1;for(let L=0,M=T.length;L<M;L++)if(!W(T[L],H[L]))return!1;return!0}t.equals=U;function y(T,H){const W=T.length-1;H<W&&(T[H]=T[W]),T.pop()}t.removeFastWithoutKeepingOrder=y;function b(T,H,W){return u(T.length,L=>W(T[L],H))}t.binarySearch=b;function u(T,H){let W=0,L=T-1;for(;W<=L;){const M=(W+L)/2|0,P=H(M);if(P<0)W=M+1;else if(P>0)L=M-1;else return M}return-(W+1)}t.binarySearch2=u;function c(T,H){let W=0,L=T.length;if(L===0)return 0;for(;W<L;){const M=Math.floor((W+L)/2);H(T[M])?L=M:W=M+1}return W}t.findFirstInSorted=c;function f(T,H,W){if(T=T|0,T>=H.length)throw new TypeError("invalid index");const L=H[Math.floor(H.length*Math.random())],M=[],P=[],O=[];for(const j of H){const ee=W(j,L);ee<0?M.push(j):ee>0?P.push(j):O.push(j)}return T<M.length?f(T,M,W):T<M.length+O.length?O[0]:f(T-(M.length+O.length),P,W)}t.quickSelect=f;function I(T,H){const W=[];let L;for(const M of T.slice(0).sort(H))!L||H(L[0],M)!==0?(L=[M],W.push(L)):L.push(M);return W}t.groupBy=I;function o(T,H,W){const L=[];function M(j,ee,ce){if(ee===0&&ce.length===0)return;const de=L[L.length-1];de&&de.start+de.deleteCount===j?(de.deleteCount+=ee,de.toInsert.push(...ce)):L.push({start:j,deleteCount:ee,toInsert:ce})}let P=0,O=0;for(;;){if(P===T.length){M(P,0,H.slice(O));break}if(O===H.length){M(P,T.length-P,[]);break}const j=T[P],ee=H[O],ce=W(j,ee);ce===0?(P+=1,O+=1):ce<0?(M(P,1,[]),P+=1):ce>0&&(M(P,0,[ee]),O+=1)}return L}t.sortedDiff=o;function n(T,H,W){const L=o(T,H,W),M=[],P=[];for(const O of L)M.push(...T.slice(O.start,O.start+O.deleteCount)),P.push(...O.toInsert);return{removed:M,added:P}}t.delta=n;function e(T,H,W){if(W===0)return[];const L=T.slice(0,W).sort(H);return r(T,H,L,W,T.length),L}t.top=e;function s(T,H,W,L,M){return W===0?Promise.resolve([]):new Promise((P,O)=>{(async()=>{const j=T.length,ee=T.slice(0,W).sort(H);for(let ce=W,de=Math.min(W+L,j);ce<j;ce=de,de=Math.min(de+L,j)){if(ce>W&&await new Promise(De=>setTimeout(De)),M&&M.isCancellationRequested)throw new v.CancellationError;r(T,H,ee,ce,de)}return ee})().then(P,O)})}t.topAsync=s;function r(T,H,W,L,M){for(const P=W.length;L<M;L++){const O=T[L];if(H(O,W[P-1])<0){W.pop();const j=c(W,ee=>H(O,ee)<0);W.splice(j,0,O)}}}function a(T){return T.filter(H=>!!H)}t.coalesce=a;function l(T){let H=0;for(let W=0;W<T.length;W++)T[W]&&(T[H]=T[W],H+=1);T.length=H}t.coalesceInPlace=l;function p(T,H,W){T.splice(W,0,T.splice(H,1)[0])}t.move=p;function k(T){return!Array.isArray(T)||T.length===0}t.isFalsyOrEmpty=k;function S(T){return Array.isArray(T)&&T.length>0}t.isNonEmptyArray=S;function g(T,H=W=>W){const W=new Set;return T.filter(L=>{const M=H(L);return W.has(M)?!1:(W.add(M),!0)})}t.distinct=g;function E(T){const H=new Set;return W=>{const L=T(W);return H.has(L)?!1:(H.add(L),!0)}}t.uniqueFilter=E;function N(T,H){const W=F(T,H);if(W!==-1)return T[W]}t.findLast=N;function F(T,H){for(let W=T.length-1;W>=0;W--){const L=T[W];if(H(L))return W}return-1}t.lastIndex=F;function d(T,H){return T.length>0?T[0]:H}t.firstOrDefault=d;function w(T,H){return T.length>0?T[T.length-1]:H}t.lastOrDefault=w;function m(T,H,W=(L,M)=>L===M){let L=0;for(let M=0,P=Math.min(T.length,H.length);M<P&&W(T[M],H[M]);M++)L++;return L}t.commonPrefixLength=m;function D(T){return[].concat(...T)}t.flatten=D;function R(T,H){let W=typeof H=="number"?T:0;typeof H=="number"?W=T:(W=0,H=T);const L=[];if(W<=H)for(let M=W;M<H;M++)L.push(M);else for(let M=W;M>H;M--)L.push(M);return L}t.range=R;function V(T,H,W){return T.reduce((L,M)=>(L[H(M)]=W?W(M):M,L),Object.create(null))}t.index=V;function Z(T,H){return T.push(H),()=>X(T,H)}t.insert=Z;function X(T,H){const W=T.indexOf(H);if(W>-1)return T.splice(W,1),H}t.remove=X;function x(T,H,W){const L=T.slice(0,H),M=T.slice(H);return L.concat(W,M)}t.arrayInsert=x;function ne(T,H){let W;if(typeof H=="number"){let L=H;W=()=>{const M=Math.sin(L++)*179426549;return M-Math.floor(M)}}else W=Math.random;for(let L=T.length-1;L>0;L-=1){const M=Math.floor(W()*(L+1)),P=T[L];T[L]=T[M],T[M]=P}}t.shuffle=ne;function le(T,H){const W=T.indexOf(H);W>-1&&(T.splice(W,1),T.unshift(H))}t.pushToStart=le;function se(T,H){const W=T.indexOf(H);W>-1&&(T.splice(W,1),T.push(H))}t.pushToEnd=se;function fe(T,H){for(const W of H)T.push(W)}t.pushMany=fe;function Ae(T,H){return Array.isArray(T)?T.map(H):H(T)}t.mapArrayOrNot=Ae;function te(T){return Array.isArray(T)?T:[T]}t.asArray=te;function ve(T){return T[Math.floor(Math.random()*T.length)]}t.getRandomElement=ve;function Ne(T,H){for(const W of T){const L=H(W);if(L!==void 0)return L}}t.mapFind=Ne;function he(T,H,W){const L=oe(T,H),M=T.length,P=W.length;T.length=M+P;for(let O=M-1;O>=L;O--)T[O+P]=T[O];for(let O=0;O<P;O++)T[O+L]=W[O]}t.insertInto=he;function Q(T,H,W,L){const M=oe(T,H),P=T.splice(M,W);return he(T,M,L),P}t.splice=Q;function oe(T,H){return H<0?Math.max(H+T.length,0):Math.min(H,T.length)}var re;(function(T){function H(M){return M<0}T.isLessThan=H;function W(M){return M>0}T.isGreaterThan=W;function L(M){return M===0}T.isNeitherLessOrGreaterThan=L,T.greaterThan=1,T.lessThan=-1,T.neitherLessOrGreaterThan=0})(re=t.CompareResult||(t.CompareResult={}));function ie(T,H){return(W,L)=>H(T(W),T(L))}t.compareBy=ie;function A(...T){return(H,W)=>{for(const L of T){const M=L(H,W);if(!re.isNeitherLessOrGreaterThan(M))return M}return re.neitherLessOrGreaterThan}}t.tieBreakComparators=A;const C=(T,H)=>T-H;t.numberComparator=C;function h(T,H){if(T.length===0)return;let W=T[0];for(let L=1;L<T.length;L++){const M=T[L];H(M,W)>0&&(W=M)}return W}t.findMaxBy=h;function B(T,H){if(T.length===0)return;let W=T[0];for(let L=1;L<T.length;L++){const M=T[L];H(M,W)>=0&&(W=M)}return W}t.findLastMaxBy=B;function _(T,H){return h(T,(W,L)=>-H(W,L))}t.findMinBy=_;class ${constructor(H){this.f=H,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(H){let W=this.c;for(;W<this.f.length&&H(this.f[W]);)W++;const L=W===this.c?null:this.f.slice(this.c,W);return this.c=W,L}takeFromEndWhile(H){let W=this.d;for(;W>=0&&H(this.f[W]);)W--;const L=W===this.d?null:this.f.slice(W+1,this.d+1);return this.d=W,L}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const H=this.f[this.c];return this.c++,H}removeLast(){const H=this.f[this.d];return this.d--,H}takeCount(H){const W=this.f.slice(this.c,this.c+H);return this.c+=H,W}}t.ArrayQueue=$;class Y{constructor(H){this.iterate=H}forEach(H){this.iterate(W=>(H(W),!0))}toArray(){const H=[];return this.iterate(W=>(H.push(W),!0)),H}filter(H){return new Y(W=>this.iterate(L=>H(L)?W(L):!0))}map(H){return new Y(W=>this.iterate(L=>W(H(L))))}some(H){let W=!1;return this.iterate(L=>(W=H(L),!W)),W}findFirst(H){let W;return this.iterate(L=>H(L)?(W=L,!1):!0),W}findLast(H){let W;return this.iterate(L=>(H(L)&&(W=L),!0)),W}findLastMaxBy(H){let W,L=!0;return this.iterate(M=>((L||re.isGreaterThan(H(M,W)))&&(L=!1,W=M),!0)),W}}t.CallbackIterable=Y,Y.empty=new Y(T=>{})}),define(me[72],be([1,0,9]),function(J,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.assert=t.assertNever=t.ok=void 0;function i(u,c){if(!u)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}t.ok=i;function z(u,c="Unreachable"){throw new Error(c)}t.assertNever=z;function U(u){if(!u)throw new v.BugIndicatingError("Assertion Failed")}t.assert=U;function y(u){if(!u()){debugger;u(),(0,v.onUnexpectedError)(new v.BugIndicatingError("Assertion Failed"))}}t.assertFn=y;function b(u,c){let f=0;for(;f<u.length-1;){const I=u[f],o=u[f+1];if(!c(I,o))return!1;f++}return!0}t.checkAdjacentItems=b}),define(me[42],be([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function v(i){const z=this;let U=!1,y;return function(){return U||(U=!0,y=i.apply(z,arguments)),y}}t.once=v}),define(me[73],be([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.defaultGenerator=t.IdGenerator=void 0;class v{constructor(z){this.a=z,this.b=0}nextId(){return this.a+ ++this.b}}t.IdGenerator=v,t.defaultGenerator=new v("id#")}),define(me[25],be([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var v;(function(i){function z(k){return k&&typeof k=="object"&&typeof k[Symbol.iterator]=="function"}i.is=z;const U=Object.freeze([]);function y(){return U}i.empty=y;function*b(k){yield k}i.single=b;function u(k){return z(k)?k:b(k)}i.wrap=u;function c(k){return k||U}i.from=c;function f(k){return!k||k[Symbol.iterator]().next().done===!0}i.isEmpty=f;function I(k){return k[Symbol.iterator]().next().value}i.first=I;function o(k,S){for(const g of k)if(S(g))return!0;return!1}i.some=o;function n(k,S){for(const g of k)if(S(g))return g}i.find=n;function*e(k,S){for(const g of k)S(g)&&(yield g)}i.filter=e;function*s(k,S){let g=0;for(const E of k)yield S(E,g++)}i.map=s;function*r(...k){for(const S of k)for(const g of S)yield g}i.concat=r;function a(k,S,g){let E=g;for(const N of k)E=S(E,N);return E}i.reduce=a;function*l(k,S,g=k.length){for(S<0&&(S+=k.length),g<0?g+=k.length:g>k.length&&(g=k.length);S<g;S++)yield k[S]}i.slice=l;function p(k,S=Number.POSITIVE_INFINITY){const g=[];if(S===0)return[g,k];const E=k[Symbol.iterator]();for(let N=0;N<S;N++){const F=E.next();if(F.done)return[g,i.empty()];g.push(F.value)}return[g,{[Symbol.iterator](){return E}}]}i.consume=p})(v=t.Iterable||(t.Iterable={}))}),define(me[43],be([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var v;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.Clear=126]="Clear",e[e.MAX_VALUE=127]="MAX_VALUE"})(v=t.KeyCode||(t.KeyCode={}));var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(i=t.ScanCode||(t.ScanCode={}));class z{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(s,r){this._keyCodeToStr[s]=r,this._strToKeyCode[r.toLowerCase()]=s}keyCodeToStr(s){return this._keyCodeToStr[s]}strToKeyCode(s){return this._strToKeyCode[s.toLowerCase()]||0}}const U=new z,y=new z,b=new z;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const u=[],c=Object.create(null),f=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>f[e]||0,toEnum:e=>c[e]||0,toString:e=>u[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",s=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],r=[],a=[];for(const l of s){const[p,k,S,g,E,N,F,d,w,m]=l;if(a[S]||(a[S]=!0,u[S]=g,c[g]=S,f[g.toLowerCase()]=S,k&&(t.IMMUTABLE_CODE_TO_KEY_CODE[S]=E,E!==0&&E!==3&&E!==5&&E!==4&&E!==6&&E!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[E]=S))),!r[E]){if(r[E]=!0,!N)throw new Error(`String representation missing for key code ${E} around scan code ${g}`);U.define(E,N),y.define(E,w||N),b.define(E,m||w||N)}F&&(t.EVENT_KEY_CODE_MAP[F]=E),d&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[d]=E)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var I;(function(e){function s(S){return U.keyCodeToStr(S)}e.toString=s;function r(S){return U.strToKeyCode(S)}e.fromString=r;function a(S){return y.keyCodeToStr(S)}e.toUserSettingsUS=a;function l(S){return b.keyCodeToStr(S)}e.toUserSettingsGeneral=l;function p(S){return y.strToKeyCode(S)||b.strToKeyCode(S)}e.fromUserSettings=p;function k(S){if(S>=93&&S<=108)return null;switch(S){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return U.keyCodeToStr(S)}e.toElectronAccelerator=k})(I=t.KeyCodeUtils||(t.KeyCodeUtils={}));var o;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(o=t.KeyMod||(t.KeyMod={}));function n(e,s){const r=(s&65535)<<16>>>0;return(e|r)>>>0}t.KeyChord=n}),define(me[74],be([1,0,9]),function(J,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedKeybindingPart=t.ScanCodeBinding=t.ChordKeybinding=t.SimpleKeybinding=t.createSimpleKeybinding=t.createKeybinding=void 0;var i;(function(I){I[I.CtrlCmd=2048]="CtrlCmd",I[I.Shift=1024]="Shift",I[I.Alt=512]="Alt",I[I.WinCtrl=256]="WinCtrl",I[I.KeyCode=255]="KeyCode"})(i||(i={}));function z(I,o){if(I===0)return null;const n=(I&65535)>>>0,e=(I&4294901760)>>>16;return e!==0?new b([U(n,o),U(e,o)]):new b([U(n,o)])}t.createKeybinding=z;function U(I,o){const n=!!(I&2048),e=!!(I&256),s=o===2?e:n,r=!!(I&1024),a=!!(I&512),l=o===2?n:e,p=I&255;return new y(s,r,a,l,p)}t.createSimpleKeybinding=U;class y{constructor(o,n,e,s,r){this.ctrlKey=o,this.shiftKey=n,this.altKey=e,this.metaKey=s,this.keyCode=r}equals(o){return this.ctrlKey===o.ctrlKey&&this.shiftKey===o.shiftKey&&this.altKey===o.altKey&&this.metaKey===o.metaKey&&this.keyCode===o.keyCode}getHashCode(){const o=this.ctrlKey?"1":"0",n=this.shiftKey?"1":"0",e=this.altKey?"1":"0",s=this.metaKey?"1":"0";return`${o}${n}${e}${s}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new b([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.SimpleKeybinding=y;class b{constructor(o){if(o.length===0)throw(0,v.illegalArgument)("parts");this.parts=o}getHashCode(){let o="";for(let n=0,e=this.parts.length;n<e;n++)n!==0&&(o+=";"),o+=this.parts[n].getHashCode();return o}equals(o){if(o===null||this.parts.length!==o.parts.length)return!1;for(let n=0;n<this.parts.length;n++)if(!this.parts[n].equals(o.parts[n]))return!1;return!0}}t.ChordKeybinding=b;class u{constructor(o,n,e,s,r){this.ctrlKey=o,this.shiftKey=n,this.altKey=e,this.metaKey=s,this.scanCode=r}equals(o){return this.ctrlKey===o.ctrlKey&&this.shiftKey===o.shiftKey&&this.altKey===o.altKey&&this.metaKey===o.metaKey&&this.scanCode===o.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.ScanCodeBinding=u;class c{constructor(o,n,e,s,r,a){this.ctrlKey=o,this.shiftKey=n,this.altKey=e,this.metaKey=s,this.keyLabel=r,this.keyAriaLabel=a}}t.ResolvedKeybindingPart=c;class f{}t.ResolvedKeybinding=f}),define(me[44],be([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class v{constructor(z){this.d=z,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(z){this.c=z}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(z){return new v(()=>z(this.getValue()))}}t.Lazy=v}),define(me[2],be([1,0,42,25]),function(J,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.disposeIfDisposable=t.dispose=t.isDisposable=t.markAsSingleton=t.setDisposableTracker=void 0;const z=!1;let U=null;function y(w){U=w}if(t.setDisposableTracker=y,z){const w="__is_disposable_tracked__";y(new class{trackDisposable(m){const D=new Error("Potentially leaked disposable").stack;setTimeout(()=>{m[w]||console.log(D)},3e3)}setParent(m,D){if(m&&m!==l.None)try{m[w]=!0}catch{}}markAsDisposed(m){if(m&&m!==l.None)try{m[w]=!0}catch{}}markAsSingleton(m){}})}function b(w){return U?.trackDisposable(w),w}function u(w){U?.markAsDisposed(w)}function c(w,m){U?.setParent(w,m)}function f(w,m){if(!!U)for(const D of w)U.setParent(D,m)}function I(w){return U?.markAsSingleton(w),w}t.markAsSingleton=I;function o(w){return typeof w.dispose=="function"&&w.dispose.length===0}t.isDisposable=o;function n(w){if(i.Iterable.is(w)){const m=[];for(const D of w)if(D)try{D.dispose()}catch(R){m.push(R)}if(m.length===1)throw m[0];if(m.length>1)throw new AggregateError(m,"Encountered errors while disposing of store");return Array.isArray(w)?[]:w}else if(w)return w.dispose(),w}t.dispose=n;function e(w){for(const m of w)o(m)&&m.dispose();return[]}t.disposeIfDisposable=e;function s(...w){const m=r(()=>n(w));return f(w,m),m}t.combinedDisposable=s;function r(w){const m=b({dispose:(0,v.once)(()=>{u(m),w()})});return m}t.toDisposable=r;class a{constructor(){this.c=new Set,this.f=!1,b(this)}dispose(){this.f||(u(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{n(this.c)}finally{this.c.clear()}}add(m){if(!m)return m;if(m===this)throw new Error("Cannot register a disposable on itself!");return c(m,this),this.f?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(m),m}}t.DisposableStore=a,a.DISABLE_DISPOSED_WARNING=!1;class l{constructor(){this.q=new a,b(this),c(this.q,this)}dispose(){u(this),this.q.dispose()}B(m){if(m===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(m)}}t.Disposable=l,l.None=Object.freeze({dispose(){}});class p{constructor(){this.b=!1,b(this)}get value(){return this.b?void 0:this.a}set value(m){this.b||m===this.a||(this.a?.dispose(),m&&c(m,this),this.a=m)}clear(){this.value=void 0}dispose(){this.b=!0,u(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const m=this.a;return this.a=void 0,m&&c(m,null),m}}t.MutableDisposable=p;class k{constructor(m){this.b=m,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.RefCountedDisposable=k;class S{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(m){let D=m;return this.unset=()=>D=void 0,this.isset=()=>D!==void 0,this.dispose=()=>{D&&(D(),D=void 0,u(this))},this}}t.SafeDisposable=S;class g{constructor(){this.a=new Map}acquire(m,...D){let R=this.a.get(m);R||(R={counter:0,object:this.b(m,...D)},this.a.set(m,R));const{object:V}=R,Z=(0,v.once)(()=>{--R.counter===0&&(this.c(m,R.object),this.a.delete(m))});return R.counter++,{object:V,dispose:Z}}}t.ReferenceCollection=g;class E{constructor(m){this.a=m}async acquire(m,...D){const R=this.a.acquire(m,...D);try{return{object:await R.object,dispose:()=>R.dispose()}}catch(V){throw R.dispose(),V}}}t.AsyncReferenceCollection=E;class N{constructor(m){this.object=m}dispose(){}}t.ImmortalReference=N;function F(w){const m=new a;try{w(m)}finally{m.dispose()}}t.disposeOnReturn=F;class d{constructor(){this.a=new Map,this.b=!1,b(this)}dispose(){u(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{n(this.a.values())}finally{this.a.clear()}}has(m){return this.a.has(m)}get(m){return this.a.get(m)}set(m,D,R=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),R||this.a.get(m)?.dispose(),this.a.set(m,D)}deleteAndDispose(m){this.a.get(m)?.dispose(),this.a.delete(m)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.DisposableMap=d}),define(me[45],be([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class v{constructor(U){this.element=U,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class i{constructor(){this.a=v.Undefined,this.b=v.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===v.Undefined}clear(){let U=this.a;for(;U!==v.Undefined;){const y=U.next;U.prev=v.Undefined,U.next=v.Undefined,U=y}this.a=v.Undefined,this.b=v.Undefined,this.c=0}unshift(U){return this.d(U,!1)}push(U){return this.d(U,!0)}d(U,y){const b=new v(U);if(this.a===v.Undefined)this.a=b,this.b=b;else if(y){const c=this.b;this.b=b,b.prev=c,c.next=b}else{const c=this.a;this.a=b,b.next=c,c.prev=b}this.c+=1;let u=!1;return()=>{u||(u=!0,this.e(b))}}shift(){if(this.a!==v.Undefined){const U=this.a.element;return this.e(this.a),U}}pop(){if(this.b!==v.Undefined){const U=this.b.element;return this.e(this.b),U}}e(U){if(U.prev!==v.Undefined&&U.next!==v.Undefined){const y=U.prev;y.next=U.next,U.next.prev=y}else U.prev===v.Undefined&&U.next===v.Undefined?(this.a=v.Undefined,this.b=v.Undefined):U.next===v.Undefined?(this.b=this.b.prev,this.b.next=v.Undefined):U.prev===v.Undefined&&(this.a=this.a.next,this.a.prev=v.Undefined);this.c-=1}*[Symbol.iterator](){let U=this.a;for(;U!==v.Undefined;)yield U.element,U=U.next}}t.LinkedList=i}),define(me[75],be([1,0]),function(J,t){"use strict";var v,i,z;Object.defineProperty(t,"__esModule",{value:!0}),t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=t.setToString=t.mapToString=t.getOrSet=void 0;function U(e,s,r){let a=e.get(s);return a===void 0&&(a=r,e.set(s,a)),a}t.getOrSet=U;function y(e){const s=[];return e.forEach((r,a)=>{s.push(`${a} => ${r}`)}),`Map(${e.size}) {${s.join(", ")}}`}t.mapToString=y;function b(e){const s=[];return e.forEach(r=>{s.push(r)}),`Set(${e.size}) {${s.join(", ")}}`}t.setToString=b;class u{constructor(s,r){this.uri=s,this.value=r}}class c{constructor(s,r){this[v]="ResourceMap",s instanceof c?(this.b=new Map(s.b),this.c=r??c.a):(this.b=new Map,this.c=s??c.a)}set(s,r){return this.b.set(this.c(s),new u(s,r)),this}get(s){return this.b.get(this.c(s))?.value}has(s){return this.b.has(this.c(s))}get size(){return this.b.size}clear(){this.b.clear()}delete(s){return this.b.delete(this.c(s))}forEach(s,r){typeof r<"u"&&(s=s.bind(r));for(const[a,l]of this.b)s(l.value,l.uri,this)}*values(){for(const s of this.b.values())yield s.value}*keys(){for(const s of this.b.values())yield s.uri}*entries(){for(const s of this.b.values())yield[s.uri,s.value]}*[(v=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.b)yield[s.uri,s.value]}}t.ResourceMap=c,c.a=e=>e.toString();class f{constructor(s,r){this[i]="ResourceSet",!s||typeof s=="function"?this.a=new c(s):(this.a=new c(r),s.forEach(this.add,this))}get size(){return this.a.size}add(s){return this.a.set(s,s),this}clear(){this.a.clear()}delete(s){return this.a.delete(s)}forEach(s,r){this.a.forEach((a,l)=>s.call(r,l,l,this))}has(s){return this.a.has(s)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=f;var I;(function(e){e[e.None=0]="None",e[e.AsOld=1]="AsOld",e[e.AsNew=2]="AsNew"})(I=t.Touch||(t.Touch={}));class o{constructor(){this[z]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(s){return this.a.has(s)}get(s,r=0){const a=this.a.get(s);if(!!a)return r!==0&&this.j(a,r),a.value}set(s,r,a=0){let l=this.a.get(s);if(l)l.value=r,a!==0&&this.j(l,a);else{switch(l={key:s,value:r,next:void 0,previous:void 0},a){case 0:this.h(l);break;case 1:this.g(l);break;case 2:this.h(l);break;default:this.h(l);break}this.a.set(s,l),this.d++}return this}delete(s){return!!this.remove(s)}remove(s){const r=this.a.get(s);if(!!r)return this.a.delete(s),this.i(r),this.d--,r.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const s=this.b;return this.a.delete(s.key),this.i(s),this.d--,s.value}forEach(s,r){const a=this.e;let l=this.b;for(;l;){if(r?s.bind(r)(l.value,l.key,this):s(l.value,l.key,this),this.e!==a)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const s=this,r=this.e;let a=this.b;const l={[Symbol.iterator](){return l},next(){if(s.e!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const p={value:a.key,done:!1};return a=a.next,p}else return{value:void 0,done:!0}}};return l}values(){const s=this,r=this.e;let a=this.b;const l={[Symbol.iterator](){return l},next(){if(s.e!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const p={value:a.value,done:!1};return a=a.next,p}else return{value:void 0,done:!0}}};return l}entries(){const s=this,r=this.e;let a=this.b;const l={[Symbol.iterator](){return l},next(){if(s.e!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const p={value:[a.key,a.value],done:!1};return a=a.next,p}else return{value:void 0,done:!0}}};return l}[(z=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(s){if(s>=this.size)return;if(s===0){this.clear();return}let r=this.b,a=this.size;for(;r&&a>s;)this.a.delete(r.key),r=r.next,a--;this.b=r,this.d=a,r&&(r.previous=void 0),this.e++}g(s){if(!this.b&&!this.c)this.c=s;else if(this.b)s.next=this.b,this.b.previous=s;else throw new Error("Invalid list");this.b=s,this.e++}h(s){if(!this.b&&!this.c)this.b=s;else if(this.c)s.previous=this.c,this.c.next=s;else throw new Error("Invalid list");this.c=s,this.e++}i(s){if(s===this.b&&s===this.c)this.b=void 0,this.c=void 0;else if(s===this.b){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this.b=s.next}else if(s===this.c){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this.c=s.previous}else{const r=s.next,a=s.previous;if(!r||!a)throw new Error("Invalid list");r.previous=a,a.next=r}s.next=void 0,s.previous=void 0,this.e++}j(s,r){if(!this.b||!this.c)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(s===this.b)return;const a=s.next,l=s.previous;s===this.c?(l.next=void 0,this.c=l):(a.previous=l,l.next=a),s.previous=void 0,s.next=this.b,this.b.previous=s,this.b=s,this.e++}else if(r===2){if(s===this.c)return;const a=s.next,l=s.previous;s===this.b?(a.previous=void 0,this.b=a):(a.previous=l,l.next=a),s.next=void 0,s.previous=this.c,this.c.next=s,this.c=s,this.e++}}}toJSON(){const s=[];return this.forEach((r,a)=>{s.push([a,r])}),s}fromJSON(s){this.clear();for(const[r,a]of s)this.set(r,a)}}t.LinkedMap=o;class n extends o{constructor(s,r=1){super(),this.k=s,this.l=Math.min(Math.max(0,r),1)}get limit(){return this.k}set limit(s){this.k=s,this.m()}get ratio(){return this.l}set ratio(s){this.l=Math.min(Math.max(0,s),1),this.m()}get(s,r=2){return super.get(s,r)}peek(s){return super.get(s,0)}set(s,r){return super.set(s,r,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}t.LRUCache=n}),function(J,t){typeof exports=="object"&&typeof module<"u"?t(exports):typeof define=="function"&&define.amd?define(me[76],be([0]),t):(J=typeof globalThis<"u"?globalThis:J||self,t(J.marked={}))}(this,function(J){"use strict";function t(T,H){for(var W=0;W<H.length;W++){var L=H[W];L.enumerable=L.enumerable||!1,L.configurable=!0,"value"in L&&(L.writable=!0),Object.defineProperty(T,L.key,L)}}function v(T,H,W){return H&&t(T.prototype,H),W&&t(T,W),Object.defineProperty(T,"prototype",{writable:!1}),T}function i(T,H){if(!!T){if(typeof T=="string")return z(T,H);var W=Object.prototype.toString.call(T).slice(8,-1);if(W==="Object"&&T.constructor&&(W=T.constructor.name),W==="Map"||W==="Set")return Array.from(T);if(W==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(W))return z(T,H)}}function z(T,H){(H==null||H>T.length)&&(H=T.length);for(var W=0,L=new Array(H);W<H;W++)L[W]=T[W];return L}function U(T,H){var W=typeof Symbol<"u"&&T[Symbol.iterator]||T["@@iterator"];if(W)return(W=W.call(T)).next.bind(W);if(Array.isArray(T)||(W=i(T))||H&&T&&typeof T.length=="number"){W&&(T=W);var L=0;return function(){return L>=T.length?{done:!0}:{done:!1,value:T[L++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function y(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}J.defaults=y();function b(T){J.defaults=T}var u=/[&<>"']/,c=/[&<>"']/g,f=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,o={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},n=function(H){return o[H]};function e(T,H){if(H){if(u.test(T))return T.replace(c,n)}else if(f.test(T))return T.replace(I,n);return T}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function r(T){return T.replace(s,function(H,W){return W=W.toLowerCase(),W==="colon"?":":W.charAt(0)==="#"?W.charAt(1)==="x"?String.fromCharCode(parseInt(W.substring(2),16)):String.fromCharCode(+W.substring(1)):""})}var a=/(^|[^\[])\^/g;function l(T,H){T=typeof T=="string"?T:T.source,H=H||"";var W={replace:function(M,P){return P=P.source||P,P=P.replace(a,"$1"),T=T.replace(M,P),W},getRegex:function(){return new RegExp(T,H)}};return W}var p=/[^\w:]/g,k=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function S(T,H,W){if(T){var L;try{L=decodeURIComponent(r(W)).replace(p,"").toLowerCase()}catch{return null}if(L.indexOf("javascript:")===0||L.indexOf("vbscript:")===0||L.indexOf("data:")===0)return null}H&&!k.test(W)&&(W=d(H,W));try{W=encodeURI(W).replace(/%25/g,"%")}catch{return null}return W}var g={},E=/^[^:]+:\/*[^/]*$/,N=/^([^:]+:)[\s\S]*$/,F=/^([^:]+:\/*[^/]*)[\s\S]*$/;function d(T,H){g[" "+T]||(E.test(T)?g[" "+T]=T+"/":g[" "+T]=R(T,"/",!0)),T=g[" "+T];var W=T.indexOf(":")===-1;return H.substring(0,2)==="//"?W?H:T.replace(N,"$1")+H:H.charAt(0)==="/"?W?H:T.replace(F,"$1")+H:T+H}var w={exec:function(){}};function m(T){for(var H=1,W,L;H<arguments.length;H++){W=arguments[H];for(L in W)Object.prototype.hasOwnProperty.call(W,L)&&(T[L]=W[L])}return T}function D(T,H){var W=T.replace(/\|/g,function(P,O,j){for(var ee=!1,ce=O;--ce>=0&&j[ce]==="\\";)ee=!ee;return ee?"|":" |"}),L=W.split(/ \|/),M=0;if(L[0].trim()||L.shift(),L.length>0&&!L[L.length-1].trim()&&L.pop(),L.length>H)L.splice(H);else for(;L.length<H;)L.push("");for(;M<L.length;M++)L[M]=L[M].trim().replace(/\\\|/g,"|");return L}function R(T,H,W){var L=T.length;if(L===0)return"";for(var M=0;M<L;){var P=T.charAt(L-M-1);if(P===H&&!W)M++;else if(P!==H&&W)M++;else break}return T.slice(0,L-M)}function V(T,H){if(T.indexOf(H[1])===-1)return-1;for(var W=T.length,L=0,M=0;M<W;M++)if(T[M]==="\\")M++;else if(T[M]===H[0])L++;else if(T[M]===H[1]&&(L--,L<0))return M;return-1}function Z(T){T&&T.sanitize&&!T.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function X(T,H){if(H<1)return"";for(var W="";H>1;)H&1&&(W+=T),H>>=1,T+=T;return W+T}function x(T,H,W,L){var M=H.href,P=H.title?e(H.title):null,O=T[1].replace(/\\([\[\]])/g,"$1");if(T[0].charAt(0)!=="!"){L.state.inLink=!0;var j={type:"link",raw:W,href:M,title:P,text:O,tokens:L.inlineTokens(O)};return L.state.inLink=!1,j}return{type:"image",raw:W,href:M,title:P,text:e(O)}}function ne(T,H){var W=T.match(/^(\s+)(?:```)/);if(W===null)return H;var L=W[1];return H.split(`
`).map(function(M){var P=M.match(/^\s+/);if(P===null)return M;var O=P[0];return O.length>=L.length?M.slice(L.length):M}).join(`
`)}var le=function(){function T(W){this.options=W||J.defaults}var H=T.prototype;return H.space=function(L){var M=this.rules.block.newline.exec(L);if(M&&M[0].length>0)return{type:"space",raw:M[0]}},H.code=function(L){var M=this.rules.block.code.exec(L);if(M){var P=M[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:M[0],codeBlockStyle:"indented",text:this.options.pedantic?P:R(P,`
`)}}},H.fences=function(L){var M=this.rules.block.fences.exec(L);if(M){var P=M[0],O=ne(P,M[3]||"");return{type:"code",raw:P,lang:M[2]?M[2].trim():M[2],text:O}}},H.heading=function(L){var M=this.rules.block.heading.exec(L);if(M){var P=M[2].trim();if(/#$/.test(P)){var O=R(P,"#");(this.options.pedantic||!O||/ $/.test(O))&&(P=O.trim())}return{type:"heading",raw:M[0],depth:M[1].length,text:P,tokens:this.lexer.inline(P)}}},H.hr=function(L){var M=this.rules.block.hr.exec(L);if(M)return{type:"hr",raw:M[0]}},H.blockquote=function(L){var M=this.rules.block.blockquote.exec(L);if(M){var P=M[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:M[0],tokens:this.lexer.blockTokens(P,[]),text:P}}},H.list=function(L){var M=this.rules.block.list.exec(L);if(M){var P,O,j,ee,ce,de,De,ye,Ie,Se,we,Re,Pe=M[1].trim(),Ke=Pe.length>1,Ue={type:"list",raw:"",ordered:Ke,start:Ke?+Pe.slice(0,-1):"",loose:!1,items:[]};Pe=Ke?"\\d{1,9}\\"+Pe.slice(-1):"\\"+Pe,this.options.pedantic&&(Pe=Ke?Pe:"[*+-]");for(var We=new RegExp("^( {0,3}"+Pe+")((?:[	 ][^\\n]*)?(?:\\n|$))");L&&(Re=!1,!(!(M=We.exec(L))||this.rules.block.hr.test(L)));){if(P=M[0],L=L.substring(P.length),ye=M[2].split(`
`,1)[0],Ie=L.split(`
`,1)[0],this.options.pedantic?(ee=2,we=ye.trimLeft()):(ee=M[2].search(/[^ ]/),ee=ee>4?1:ee,we=ye.slice(ee),ee+=M[1].length),de=!1,!ye&&/^ *$/.test(Ie)&&(P+=Ie+`
`,L=L.substring(Ie.length+1),Re=!0),!Re)for(var xe=new RegExp("^ {0,"+Math.min(3,ee-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,ee-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Be=new RegExp("^ {0,"+Math.min(3,ee-1)+"}(?:```|~~~)"),je=new RegExp("^ {0,"+Math.min(3,ee-1)+"}#");L&&(Se=L.split(`
`,1)[0],ye=Se,this.options.pedantic&&(ye=ye.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Be.test(ye)||je.test(ye)||xe.test(ye)||it.test(L)));){if(ye.search(/[^ ]/)>=ee||!ye.trim())we+=`
`+ye.slice(ee);else if(!de)we+=`
`+ye;else break;!de&&!ye.trim()&&(de=!0),P+=Se+`
`,L=L.substring(Se.length+1)}Ue.loose||(De?Ue.loose=!0:/\n *\n *$/.test(P)&&(De=!0)),this.options.gfm&&(O=/^\[[ xX]\] /.exec(we),O&&(j=O[0]!=="[ ] ",we=we.replace(/^\[[ xX]\] +/,""))),Ue.items.push({type:"list_item",raw:P,task:!!O,checked:j,loose:!1,text:we}),Ue.raw+=P}Ue.items[Ue.items.length-1].raw=P.trimRight(),Ue.items[Ue.items.length-1].text=we.trimRight(),Ue.raw=Ue.raw.trimRight();var Ye=Ue.items.length;for(ce=0;ce<Ye;ce++){this.lexer.state.top=!1,Ue.items[ce].tokens=this.lexer.blockTokens(Ue.items[ce].text,[]);var K=Ue.items[ce].tokens.filter(function(pe){return pe.type==="space"}),ue=K.every(function(pe){for(var Ee=pe.raw.split(""),Fe=0,Oe=U(Ee),$e;!($e=Oe()).done;){var tt=$e.value;if(tt===`
`&&(Fe+=1),Fe>1)return!0}return!1});!Ue.loose&&K.length&&ue&&(Ue.loose=!0,Ue.items[ce].loose=!0)}return Ue}},H.html=function(L){var M=this.rules.block.html.exec(L);if(M){var P={type:"html",raw:M[0],pre:!this.options.sanitizer&&(M[1]==="pre"||M[1]==="script"||M[1]==="style"),text:M[0]};if(this.options.sanitize){var O=this.options.sanitizer?this.options.sanitizer(M[0]):e(M[0]);P.type="paragraph",P.text=O,P.tokens=this.lexer.inline(O)}return P}},H.def=function(L){var M=this.rules.block.def.exec(L);if(M){M[3]&&(M[3]=M[3].substring(1,M[3].length-1));var P=M[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:P,raw:M[0],href:M[2],title:M[3]}}},H.table=function(L){var M=this.rules.block.table.exec(L);if(M){var P={type:"table",header:D(M[1]).map(function(De){return{text:De}}),align:M[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:M[3]&&M[3].trim()?M[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(P.header.length===P.align.length){P.raw=M[0];var O=P.align.length,j,ee,ce,de;for(j=0;j<O;j++)/^ *-+: *$/.test(P.align[j])?P.align[j]="right":/^ *:-+: *$/.test(P.align[j])?P.align[j]="center":/^ *:-+ *$/.test(P.align[j])?P.align[j]="left":P.align[j]=null;for(O=P.rows.length,j=0;j<O;j++)P.rows[j]=D(P.rows[j],P.header.length).map(function(De){return{text:De}});for(O=P.header.length,ee=0;ee<O;ee++)P.header[ee].tokens=this.lexer.inline(P.header[ee].text);for(O=P.rows.length,ee=0;ee<O;ee++)for(de=P.rows[ee],ce=0;ce<de.length;ce++)de[ce].tokens=this.lexer.inline(de[ce].text);return P}}},H.lheading=function(L){var M=this.rules.block.lheading.exec(L);if(M)return{type:"heading",raw:M[0],depth:M[2].charAt(0)==="="?1:2,text:M[1],tokens:this.lexer.inline(M[1])}},H.paragraph=function(L){var M=this.rules.block.paragraph.exec(L);if(M){var P=M[1].charAt(M[1].length-1)===`
`?M[1].slice(0,-1):M[1];return{type:"paragraph",raw:M[0],text:P,tokens:this.lexer.inline(P)}}},H.text=function(L){var M=this.rules.block.text.exec(L);if(M)return{type:"text",raw:M[0],text:M[0],tokens:this.lexer.inline(M[0])}},H.escape=function(L){var M=this.rules.inline.escape.exec(L);if(M)return{type:"escape",raw:M[0],text:e(M[1])}},H.tag=function(L){var M=this.rules.inline.tag.exec(L);if(M)return!this.lexer.state.inLink&&/^<a /i.test(M[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(M[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(M[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(M[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:M[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(M[0]):e(M[0]):M[0]}},H.link=function(L){var M=this.rules.inline.link.exec(L);if(M){var P=M[2].trim();if(!this.options.pedantic&&/^</.test(P)){if(!/>$/.test(P))return;var O=R(P.slice(0,-1),"\\");if((P.length-O.length)%2===0)return}else{var j=V(M[2],"()");if(j>-1){var ee=M[0].indexOf("!")===0?5:4,ce=ee+M[1].length+j;M[2]=M[2].substring(0,j),M[0]=M[0].substring(0,ce).trim(),M[3]=""}}var de=M[2],De="";if(this.options.pedantic){var ye=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(de);ye&&(de=ye[1],De=ye[3])}else De=M[3]?M[3].slice(1,-1):"";return de=de.trim(),/^</.test(de)&&(this.options.pedantic&&!/>$/.test(P)?de=de.slice(1):de=de.slice(1,-1)),x(M,{href:de&&de.replace(this.rules.inline._escapes,"$1"),title:De&&De.replace(this.rules.inline._escapes,"$1")},M[0],this.lexer)}},H.reflink=function(L,M){var P;if((P=this.rules.inline.reflink.exec(L))||(P=this.rules.inline.nolink.exec(L))){var O=(P[2]||P[1]).replace(/\s+/g," ");if(O=M[O.toLowerCase()],!O||!O.href){var j=P[0].charAt(0);return{type:"text",raw:j,text:j}}return x(P,O,P[0],this.lexer)}},H.emStrong=function(L,M,P){P===void 0&&(P="");var O=this.rules.inline.emStrong.lDelim.exec(L);if(!!O&&!(O[3]&&P.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var j=O[1]||O[2]||"";if(!j||j&&(P===""||this.rules.inline.punctuation.exec(P))){var ee=O[0].length-1,ce,de,De=ee,ye=0,Ie=O[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ie.lastIndex=0,M=M.slice(-1*L.length+ee);(O=Ie.exec(M))!=null;)if(ce=O[1]||O[2]||O[3]||O[4]||O[5]||O[6],!!ce){if(de=ce.length,O[3]||O[4]){De+=de;continue}else if((O[5]||O[6])&&ee%3&&!((ee+de)%3)){ye+=de;continue}if(De-=de,!(De>0)){if(de=Math.min(de,de+De+ye),Math.min(ee,de)%2){var Se=L.slice(1,ee+O.index+de);return{type:"em",raw:L.slice(0,ee+O.index+de+1),text:Se,tokens:this.lexer.inlineTokens(Se)}}var we=L.slice(2,ee+O.index+de-1);return{type:"strong",raw:L.slice(0,ee+O.index+de+1),text:we,tokens:this.lexer.inlineTokens(we)}}}}}},H.codespan=function(L){var M=this.rules.inline.code.exec(L);if(M){var P=M[2].replace(/\n/g," "),O=/[^ ]/.test(P),j=/^ /.test(P)&&/ $/.test(P);return O&&j&&(P=P.substring(1,P.length-1)),P=e(P,!0),{type:"codespan",raw:M[0],text:P}}},H.br=function(L){var M=this.rules.inline.br.exec(L);if(M)return{type:"br",raw:M[0]}},H.del=function(L){var M=this.rules.inline.del.exec(L);if(M)return{type:"del",raw:M[0],text:M[2],tokens:this.lexer.inlineTokens(M[2])}},H.autolink=function(L,M){var P=this.rules.inline.autolink.exec(L);if(P){var O,j;return P[2]==="@"?(O=e(this.options.mangle?M(P[1]):P[1]),j="mailto:"+O):(O=e(P[1]),j=O),{type:"link",raw:P[0],text:O,href:j,tokens:[{type:"text",raw:O,text:O}]}}},H.url=function(L,M){var P;if(P=this.rules.inline.url.exec(L)){var O,j;if(P[2]==="@")O=e(this.options.mangle?M(P[0]):P[0]),j="mailto:"+O;else{var ee;do ee=P[0],P[0]=this.rules.inline._backpedal.exec(P[0])[0];while(ee!==P[0]);O=e(P[0]),P[1]==="www."?j="http://"+O:j=O}return{type:"link",raw:P[0],text:O,href:j,tokens:[{type:"text",raw:O,text:O}]}}},H.inlineText=function(L,M){var P=this.rules.inline.text.exec(L);if(P){var O;return this.lexer.state.inRawBlock?O=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(P[0]):e(P[0]):P[0]:O=e(this.options.smartypants?M(P[0]):P[0]),{type:"text",raw:P[0],text:O}}},T}(),se={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:w,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};se._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,se._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,se.def=l(se.def).replace("label",se._label).replace("title",se._title).getRegex(),se.bullet=/(?:[*+-]|\d{1,9}[.)])/,se.listItemStart=l(/^( *)(bull) */).replace("bull",se.bullet).getRegex(),se.list=l(se.list).replace(/bull/g,se.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+se.def.source+")").getRegex(),se._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",se._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,se.html=l(se.html,"i").replace("comment",se._comment).replace("tag",se._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),se.paragraph=l(se._paragraph).replace("hr",se.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",se._tag).getRegex(),se.blockquote=l(se.blockquote).replace("paragraph",se.paragraph).getRegex(),se.normal=m({},se),se.gfm=m({},se.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),se.gfm.table=l(se.gfm.table).replace("hr",se.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",se._tag).getRegex(),se.gfm.paragraph=l(se._paragraph).replace("hr",se.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",se.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",se._tag).getRegex(),se.pedantic=m({},se.normal,{html:l(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",se._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:w,paragraph:l(se.normal._paragraph).replace("hr",se.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",se.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var fe={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:w,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:w,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};fe._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",fe.punctuation=l(fe.punctuation).replace(/punctuation/g,fe._punctuation).getRegex(),fe.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,fe.escapedEmSt=/\\\*|\\_/g,fe._comment=l(se._comment).replace("(?:-->|$)","-->").getRegex(),fe.emStrong.lDelim=l(fe.emStrong.lDelim).replace(/punct/g,fe._punctuation).getRegex(),fe.emStrong.rDelimAst=l(fe.emStrong.rDelimAst,"g").replace(/punct/g,fe._punctuation).getRegex(),fe.emStrong.rDelimUnd=l(fe.emStrong.rDelimUnd,"g").replace(/punct/g,fe._punctuation).getRegex(),fe._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,fe._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,fe._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,fe.autolink=l(fe.autolink).replace("scheme",fe._scheme).replace("email",fe._email).getRegex(),fe._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,fe.tag=l(fe.tag).replace("comment",fe._comment).replace("attribute",fe._attribute).getRegex(),fe._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,fe._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,fe._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,fe.link=l(fe.link).replace("label",fe._label).replace("href",fe._href).replace("title",fe._title).getRegex(),fe.reflink=l(fe.reflink).replace("label",fe._label).replace("ref",se._label).getRegex(),fe.nolink=l(fe.nolink).replace("ref",se._label).getRegex(),fe.reflinkSearch=l(fe.reflinkSearch,"g").replace("reflink",fe.reflink).replace("nolink",fe.nolink).getRegex(),fe.normal=m({},fe),fe.pedantic=m({},fe.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:l(/^!?\[(label)\]\((.*?)\)/).replace("label",fe._label).getRegex(),reflink:l(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",fe._label).getRegex()}),fe.gfm=m({},fe.normal,{escape:l(fe.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),fe.gfm.url=l(fe.gfm.url,"i").replace("email",fe.gfm._extended_email).getRegex(),fe.breaks=m({},fe.gfm,{br:l(fe.br).replace("{2,}","*").getRegex(),text:l(fe.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function Ae(T){return T.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function te(T){var H="",W,L,M=T.length;for(W=0;W<M;W++)L=T.charCodeAt(W),Math.random()>.5&&(L="x"+L.toString(16)),H+="&#"+L+";";return H}var ve=function(){function T(W){this.tokens=[],this.tokens.links=Object.create(null),this.options=W||J.defaults,this.options.tokenizer=this.options.tokenizer||new le,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var L={block:se.normal,inline:fe.normal};this.options.pedantic?(L.block=se.pedantic,L.inline=fe.pedantic):this.options.gfm&&(L.block=se.gfm,this.options.breaks?L.inline=fe.breaks:L.inline=fe.gfm),this.tokenizer.rules=L}T.lex=function(L,M){var P=new T(M);return P.lex(L)},T.lexInline=function(L,M){var P=new T(M);return P.inlineTokens(L)};var H=T.prototype;return H.lex=function(L){L=L.replace(/\r\n|\r/g,`
`),this.blockTokens(L,this.tokens);for(var M;M=this.inlineQueue.shift();)this.inlineTokens(M.src,M.tokens);return this.tokens},H.blockTokens=function(L,M){var P=this;M===void 0&&(M=[]),this.options.pedantic?L=L.replace(/\t/g,"    ").replace(/^ +$/gm,""):L=L.replace(/^( *)(\t+)/gm,function(De,ye,Ie){return ye+"    ".repeat(Ie.length)});for(var O,j,ee,ce;L;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(De){return(O=De.call({lexer:P},L,M))?(L=L.substring(O.raw.length),M.push(O),!0):!1}))){if(O=this.tokenizer.space(L)){L=L.substring(O.raw.length),O.raw.length===1&&M.length>0?M[M.length-1].raw+=`
`:M.push(O);continue}if(O=this.tokenizer.code(L)){L=L.substring(O.raw.length),j=M[M.length-1],j&&(j.type==="paragraph"||j.type==="text")?(j.raw+=`
`+O.raw,j.text+=`
`+O.text,this.inlineQueue[this.inlineQueue.length-1].src=j.text):M.push(O);continue}if(O=this.tokenizer.fences(L)){L=L.substring(O.raw.length),M.push(O);continue}if(O=this.tokenizer.heading(L)){L=L.substring(O.raw.length),M.push(O);continue}if(O=this.tokenizer.hr(L)){L=L.substring(O.raw.length),M.push(O);continue}if(O=this.tokenizer.blockquote(L)){L=L.substring(O.raw.length),M.push(O);continue}if(O=this.tokenizer.list(L)){L=L.substring(O.raw.length),M.push(O);continue}if(O=this.tokenizer.html(L)){L=L.substring(O.raw.length),M.push(O);continue}if(O=this.tokenizer.def(L)){L=L.substring(O.raw.length),j=M[M.length-1],j&&(j.type==="paragraph"||j.type==="text")?(j.raw+=`
`+O.raw,j.text+=`
`+O.raw,this.inlineQueue[this.inlineQueue.length-1].src=j.text):this.tokens.links[O.tag]||(this.tokens.links[O.tag]={href:O.href,title:O.title});continue}if(O=this.tokenizer.table(L)){L=L.substring(O.raw.length),M.push(O);continue}if(O=this.tokenizer.lheading(L)){L=L.substring(O.raw.length),M.push(O);continue}if(ee=L,this.options.extensions&&this.options.extensions.startBlock&&function(){var De=1/0,ye=L.slice(1),Ie=void 0;P.options.extensions.startBlock.forEach(function(Se){Ie=Se.call({lexer:this},ye),typeof Ie=="number"&&Ie>=0&&(De=Math.min(De,Ie))}),De<1/0&&De>=0&&(ee=L.substring(0,De+1))}(),this.state.top&&(O=this.tokenizer.paragraph(ee))){j=M[M.length-1],ce&&j.type==="paragraph"?(j.raw+=`
`+O.raw,j.text+=`
`+O.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=j.text):M.push(O),ce=ee.length!==L.length,L=L.substring(O.raw.length);continue}if(O=this.tokenizer.text(L)){L=L.substring(O.raw.length),j=M[M.length-1],j&&j.type==="text"?(j.raw+=`
`+O.raw,j.text+=`
`+O.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=j.text):M.push(O);continue}if(L){var de="Infinite loop on byte: "+L.charCodeAt(0);if(this.options.silent){console.error(de);break}else throw new Error(de)}}return this.state.top=!0,M},H.inline=function(L,M){return M===void 0&&(M=[]),this.inlineQueue.push({src:L,tokens:M}),M},H.inlineTokens=function(L,M){var P=this;M===void 0&&(M=[]);var O,j,ee,ce=L,de,De,ye;if(this.tokens.links){var Ie=Object.keys(this.tokens.links);if(Ie.length>0)for(;(de=this.tokenizer.rules.inline.reflinkSearch.exec(ce))!=null;)Ie.includes(de[0].slice(de[0].lastIndexOf("[")+1,-1))&&(ce=ce.slice(0,de.index)+"["+X("a",de[0].length-2)+"]"+ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(de=this.tokenizer.rules.inline.blockSkip.exec(ce))!=null;)ce=ce.slice(0,de.index)+"["+X("a",de[0].length-2)+"]"+ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(de=this.tokenizer.rules.inline.escapedEmSt.exec(ce))!=null;)ce=ce.slice(0,de.index)+"++"+ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;L;)if(De||(ye=""),De=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(we){return(O=we.call({lexer:P},L,M))?(L=L.substring(O.raw.length),M.push(O),!0):!1}))){if(O=this.tokenizer.escape(L)){L=L.substring(O.raw.length),M.push(O);continue}if(O=this.tokenizer.tag(L)){L=L.substring(O.raw.length),j=M[M.length-1],j&&O.type==="text"&&j.type==="text"?(j.raw+=O.raw,j.text+=O.text):M.push(O);continue}if(O=this.tokenizer.link(L)){L=L.substring(O.raw.length),M.push(O);continue}if(O=this.tokenizer.reflink(L,this.tokens.links)){L=L.substring(O.raw.length),j=M[M.length-1],j&&O.type==="text"&&j.type==="text"?(j.raw+=O.raw,j.text+=O.text):M.push(O);continue}if(O=this.tokenizer.emStrong(L,ce,ye)){L=L.substring(O.raw.length),M.push(O);continue}if(O=this.tokenizer.codespan(L)){L=L.substring(O.raw.length),M.push(O);continue}if(O=this.tokenizer.br(L)){L=L.substring(O.raw.length),M.push(O);continue}if(O=this.tokenizer.del(L)){L=L.substring(O.raw.length),M.push(O);continue}if(O=this.tokenizer.autolink(L,te)){L=L.substring(O.raw.length),M.push(O);continue}if(!this.state.inLink&&(O=this.tokenizer.url(L,te))){L=L.substring(O.raw.length),M.push(O);continue}if(ee=L,this.options.extensions&&this.options.extensions.startInline&&function(){var we=1/0,Re=L.slice(1),Pe=void 0;P.options.extensions.startInline.forEach(function(Ke){Pe=Ke.call({lexer:this},Re),typeof Pe=="number"&&Pe>=0&&(we=Math.min(we,Pe))}),we<1/0&&we>=0&&(ee=L.substring(0,we+1))}(),O=this.tokenizer.inlineText(ee,Ae)){L=L.substring(O.raw.length),O.raw.slice(-1)!=="_"&&(ye=O.raw.slice(-1)),De=!0,j=M[M.length-1],j&&j.type==="text"?(j.raw+=O.raw,j.text+=O.text):M.push(O);continue}if(L){var Se="Infinite loop on byte: "+L.charCodeAt(0);if(this.options.silent){console.error(Se);break}else throw new Error(Se)}}return M},v(T,null,[{key:"rules",get:function(){return{block:se,inline:fe}}}]),T}(),Ne=function(){function T(W){this.options=W||J.defaults}var H=T.prototype;return H.code=function(L,M,P){var O=(M||"").match(/\S*/)[0];if(this.options.highlight){var j=this.options.highlight(L,O);j!=null&&j!==L&&(P=!0,L=j)}return L=L.replace(/\n$/,"")+`
`,O?'<pre><code class="'+this.options.langPrefix+e(O,!0)+'">'+(P?L:e(L,!0))+`</code></pre>
`:"<pre><code>"+(P?L:e(L,!0))+`</code></pre>
`},H.blockquote=function(L){return`<blockquote>
`+L+`</blockquote>
`},H.html=function(L){return L},H.heading=function(L,M,P,O){if(this.options.headerIds){var j=this.options.headerPrefix+O.slug(P);return"<h"+M+' id="'+j+'">'+L+"</h"+M+`>
`}return"<h"+M+">"+L+"</h"+M+`>
`},H.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},H.list=function(L,M,P){var O=M?"ol":"ul",j=M&&P!==1?' start="'+P+'"':"";return"<"+O+j+`>
`+L+"</"+O+`>
`},H.listitem=function(L){return"<li>"+L+`</li>
`},H.checkbox=function(L){return"<input "+(L?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},H.paragraph=function(L){return"<p>"+L+`</p>
`},H.table=function(L,M){return M&&(M="<tbody>"+M+"</tbody>"),`<table>
<thead>
`+L+`</thead>
`+M+`</table>
`},H.tablerow=function(L){return`<tr>
`+L+`</tr>
`},H.tablecell=function(L,M){var P=M.header?"th":"td",O=M.align?"<"+P+' align="'+M.align+'">':"<"+P+">";return O+L+("</"+P+`>
`)},H.strong=function(L){return"<strong>"+L+"</strong>"},H.em=function(L){return"<em>"+L+"</em>"},H.codespan=function(L){return"<code>"+L+"</code>"},H.br=function(){return this.options.xhtml?"<br/>":"<br>"},H.del=function(L){return"<del>"+L+"</del>"},H.link=function(L,M,P){if(L=S(this.options.sanitize,this.options.baseUrl,L),L===null)return P;var O='<a href="'+e(L)+'"';return M&&(O+=' title="'+M+'"'),O+=">"+P+"</a>",O},H.image=function(L,M,P){if(L=S(this.options.sanitize,this.options.baseUrl,L),L===null)return P;var O='<img src="'+L+'" alt="'+P+'"';return M&&(O+=' title="'+M+'"'),O+=this.options.xhtml?"/>":">",O},H.text=function(L){return L},T}(),he=function(){function T(){}var H=T.prototype;return H.strong=function(L){return L},H.em=function(L){return L},H.codespan=function(L){return L},H.del=function(L){return L},H.html=function(L){return L},H.text=function(L){return L},H.link=function(L,M,P){return""+P},H.image=function(L,M,P){return""+P},H.br=function(){return""},T}(),Q=function(){function T(){this.seen={}}var H=T.prototype;return H.serialize=function(L){return L.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},H.getNextSafeSlug=function(L,M){var P=L,O=0;if(this.seen.hasOwnProperty(P)){O=this.seen[L];do O++,P=L+"-"+O;while(this.seen.hasOwnProperty(P))}return M||(this.seen[L]=O,this.seen[P]=0),P},H.slug=function(L,M){M===void 0&&(M={});var P=this.serialize(L);return this.getNextSafeSlug(P,M.dryrun)},T}(),oe=function(){function T(W){this.options=W||J.defaults,this.options.renderer=this.options.renderer||new Ne,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new he,this.slugger=new Q}T.parse=function(L,M){var P=new T(M);return P.parse(L)},T.parseInline=function(L,M){var P=new T(M);return P.parseInline(L)};var H=T.prototype;return H.parse=function(L,M){M===void 0&&(M=!0);var P="",O,j,ee,ce,de,De,ye,Ie,Se,we,Re,Pe,Ke,Ue,We,xe,it,Be,je,Ye=L.length;for(O=0;O<Ye;O++){if(we=L[O],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[we.type]&&(je=this.options.extensions.renderers[we.type].call({parser:this},we),je!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(we.type))){P+=je||"";continue}switch(we.type){case"space":continue;case"hr":{P+=this.renderer.hr();continue}case"heading":{P+=this.renderer.heading(this.parseInline(we.tokens),we.depth,r(this.parseInline(we.tokens,this.textRenderer)),this.slugger);continue}case"code":{P+=this.renderer.code(we.text,we.lang,we.escaped);continue}case"table":{for(Ie="",ye="",ce=we.header.length,j=0;j<ce;j++)ye+=this.renderer.tablecell(this.parseInline(we.header[j].tokens),{header:!0,align:we.align[j]});for(Ie+=this.renderer.tablerow(ye),Se="",ce=we.rows.length,j=0;j<ce;j++){for(De=we.rows[j],ye="",de=De.length,ee=0;ee<de;ee++)ye+=this.renderer.tablecell(this.parseInline(De[ee].tokens),{header:!1,align:we.align[ee]});Se+=this.renderer.tablerow(ye)}P+=this.renderer.table(Ie,Se);continue}case"blockquote":{Se=this.parse(we.tokens),P+=this.renderer.blockquote(Se);continue}case"list":{for(Re=we.ordered,Pe=we.start,Ke=we.loose,ce=we.items.length,Se="",j=0;j<ce;j++)We=we.items[j],xe=We.checked,it=We.task,Ue="",We.task&&(Be=this.renderer.checkbox(xe),Ke?We.tokens.length>0&&We.tokens[0].type==="paragraph"?(We.tokens[0].text=Be+" "+We.tokens[0].text,We.tokens[0].tokens&&We.tokens[0].tokens.length>0&&We.tokens[0].tokens[0].type==="text"&&(We.tokens[0].tokens[0].text=Be+" "+We.tokens[0].tokens[0].text)):We.tokens.unshift({type:"text",text:Be}):Ue+=Be),Ue+=this.parse(We.tokens,Ke),Se+=this.renderer.listitem(Ue,it,xe);P+=this.renderer.list(Se,Re,Pe);continue}case"html":{P+=this.renderer.html(we.text);continue}case"paragraph":{P+=this.renderer.paragraph(this.parseInline(we.tokens));continue}case"text":{for(Se=we.tokens?this.parseInline(we.tokens):we.text;O+1<Ye&&L[O+1].type==="text";)we=L[++O],Se+=`
`+(we.tokens?this.parseInline(we.tokens):we.text);P+=M?this.renderer.paragraph(Se):Se;continue}default:{var K='Token with "'+we.type+'" type was not found.';if(this.options.silent){console.error(K);return}else throw new Error(K)}}}return P},H.parseInline=function(L,M){M=M||this.renderer;var P="",O,j,ee,ce=L.length;for(O=0;O<ce;O++){if(j=L[O],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[j.type]&&(ee=this.options.extensions.renderers[j.type].call({parser:this},j),ee!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(j.type))){P+=ee||"";continue}switch(j.type){case"escape":{P+=M.text(j.text);break}case"html":{P+=M.html(j.text);break}case"link":{P+=M.link(j.href,j.title,this.parseInline(j.tokens,M));break}case"image":{P+=M.image(j.href,j.title,j.text);break}case"strong":{P+=M.strong(this.parseInline(j.tokens,M));break}case"em":{P+=M.em(this.parseInline(j.tokens,M));break}case"codespan":{P+=M.codespan(j.text);break}case"br":{P+=M.br();break}case"del":{P+=M.del(this.parseInline(j.tokens,M));break}case"text":{P+=M.text(j.text);break}default:{var de='Token with "'+j.type+'" type was not found.';if(this.options.silent){console.error(de);return}else throw new Error(de)}}}return P},T}();function re(T,H,W){if(typeof T>"u"||T===null)throw new Error("marked(): input parameter is undefined or null");if(typeof T!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(T)+", string expected");if(typeof H=="function"&&(W=H,H=null),H=m({},re.defaults,H||{}),Z(H),W){var L=H.highlight,M;try{M=ve.lex(T,H)}catch(ce){return W(ce)}var P=function(de){var De;if(!de)try{H.walkTokens&&re.walkTokens(M,H.walkTokens),De=oe.parse(M,H)}catch(ye){de=ye}return H.highlight=L,de?W(de):W(null,De)};if(!L||L.length<3||(delete H.highlight,!M.length))return P();var O=0;re.walkTokens(M,function(ce){ce.type==="code"&&(O++,setTimeout(function(){L(ce.text,ce.lang,function(de,De){if(de)return P(de);De!=null&&De!==ce.text&&(ce.text=De,ce.escaped=!0),O--,O===0&&P()})},0))}),O===0&&P();return}function j(ce){if(ce.message+=`
Please report this to https://github.com/markedjs/marked.`,H.silent)return"<p>An error occurred:</p><pre>"+e(ce.message+"",!0)+"</pre>";throw ce}try{var ee=ve.lex(T,H);if(H.walkTokens){if(H.async)return Promise.all(re.walkTokens(ee,H.walkTokens)).then(function(){return oe.parse(ee,H)}).catch(j);re.walkTokens(ee,H.walkTokens)}return oe.parse(ee,H)}catch(ce){j(ce)}}re.options=re.setOptions=function(T){return m(re.defaults,T),b(re.defaults),re},re.getDefaults=y,re.defaults=J.defaults,re.use=function(){for(var T=arguments.length,H=new Array(T),W=0;W<T;W++)H[W]=arguments[W];var L=m.apply(void 0,[{}].concat(H)),M=re.defaults.extensions||{renderers:{},childTokens:{}},P;H.forEach(function(O){if(O.extensions&&(P=!0,O.extensions.forEach(function(ee){if(!ee.name)throw new Error("extension name required");if(ee.renderer){var ce=M.renderers?M.renderers[ee.name]:null;ce?M.renderers[ee.name]=function(){for(var de=arguments.length,De=new Array(de),ye=0;ye<de;ye++)De[ye]=arguments[ye];var Ie=ee.renderer.apply(this,De);return Ie===!1&&(Ie=ce.apply(this,De)),Ie}:M.renderers[ee.name]=ee.renderer}if(ee.tokenizer){if(!ee.level||ee.level!=="block"&&ee.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");M[ee.level]?M[ee.level].unshift(ee.tokenizer):M[ee.level]=[ee.tokenizer],ee.start&&(ee.level==="block"?M.startBlock?M.startBlock.push(ee.start):M.startBlock=[ee.start]:ee.level==="inline"&&(M.startInline?M.startInline.push(ee.start):M.startInline=[ee.start]))}ee.childTokens&&(M.childTokens[ee.name]=ee.childTokens)})),O.renderer&&function(){var ee=re.defaults.renderer||new Ne,ce=function(ye){var Ie=ee[ye];ee[ye]=function(){for(var Se=arguments.length,we=new Array(Se),Re=0;Re<Se;Re++)we[Re]=arguments[Re];var Pe=O.renderer[ye].apply(ee,we);return Pe===!1&&(Pe=Ie.apply(ee,we)),Pe}};for(var de in O.renderer)ce(de);L.renderer=ee}(),O.tokenizer&&function(){var ee=re.defaults.tokenizer||new le,ce=function(ye){var Ie=ee[ye];ee[ye]=function(){for(var Se=arguments.length,we=new Array(Se),Re=0;Re<Se;Re++)we[Re]=arguments[Re];var Pe=O.tokenizer[ye].apply(ee,we);return Pe===!1&&(Pe=Ie.apply(ee,we)),Pe}};for(var de in O.tokenizer)ce(de);L.tokenizer=ee}(),O.walkTokens){var j=re.defaults.walkTokens;L.walkTokens=function(ee){var ce=[];return ce.push(O.walkTokens.call(this,ee)),j&&(ce=ce.concat(j.call(this,ee))),ce}}P&&(L.extensions=M),re.setOptions(L)})},re.walkTokens=function(T,H){for(var W=[],L=function(){var j=P.value;switch(W=W.concat(H.call(re,j)),j.type){case"table":{for(var ee=U(j.header),ce;!(ce=ee()).done;){var de=ce.value;W=W.concat(re.walkTokens(de.tokens,H))}for(var De=U(j.rows),ye;!(ye=De()).done;)for(var Ie=ye.value,Se=U(Ie),we;!(we=Se()).done;){var Re=we.value;W=W.concat(re.walkTokens(Re.tokens,H))}break}case"list":{W=W.concat(re.walkTokens(j.items,H));break}default:re.defaults.extensions&&re.defaults.extensions.childTokens&&re.defaults.extensions.childTokens[j.type]?re.defaults.extensions.childTokens[j.type].forEach(function(Pe){W=W.concat(re.walkTokens(j[Pe],H))}):j.tokens&&(W=W.concat(re.walkTokens(j.tokens,H)))}},M=U(T),P;!(P=M()).done;)L();return W},re.parseInline=function(T,H){if(typeof T>"u"||T===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof T!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(T)+", string expected");H=m({},re.defaults,H||{}),Z(H);try{var W=ve.lexInline(T,H);return H.walkTokens&&re.walkTokens(W,H.walkTokens),oe.parseInline(W,H)}catch(L){if(L.message+=`
Please report this to https://github.com/markedjs/marked.`,H.silent)return"<p>An error occurred:</p><pre>"+e(L.message+"",!0)+"</pre>";throw L}},re.Parser=oe,re.parser=oe.parse,re.Renderer=Ne,re.TextRenderer=he,re.Lexer=ve,re.lexer=ve.lex,re.Tokenizer=le,re.Slugger=Q,re.parse=re;var ie=re.options,A=re.setOptions,C=re.use,h=re.walkTokens,B=re.parseInline,_=re,$=oe.parse,Y=ve.lex;J.Lexer=ve,J.Parser=oe,J.Renderer=Ne,J.Slugger=Q,J.TextRenderer=he,J.Tokenizer=le,J.getDefaults=y,J.lexer=Y,J.marked=re,J.options=ie,J.parse=_,J.parseInline=B,J.parser=$,J.setOptions=A,J.use=C,J.walkTokens=h,Object.defineProperty(J,"__esModule",{value:!0})}),define(me[77],be([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayNavigator=void 0;class v{constructor(z,U=0,y=z.length,b=U-1){this.a=z,this.b=U,this.c=y,this.d=b}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.ArrayNavigator=v}),define(me[78],be([1,0,77]),function(J,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryNavigator2=t.HistoryNavigator=void 0;class i{constructor(y=[],b=10){this.h(y),this.b=b,this.d()}getHistory(){return this.j}add(y){this.a.delete(y),this.a.add(y),this.d()}next(){return this.g()!==this.j.length-1?this.c.next():null}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}has(y){return this.a.has(y)}clear(){this.h([]),this.d()}d(){this.f();const y=this.j;this.c=new v.ArrayNavigator(y,0,y.length,y.length)}f(){const y=this.j;y.length>this.b&&this.h(y.slice(y.length-this.b))}g(){const y=this.c.current();return y?this.j.indexOf(y):-1}h(y){this.a=new Set;for(const b of y)this.a.add(b)}get j(){const y=[];return this.a.forEach(b=>y.push(b)),y}}t.HistoryNavigator=i;class z{constructor(y,b=10){if(this.f=b,y.length<1)throw new Error("not supported");this.d=1,this.a=this.b=this.c={value:y[0],previous:void 0,next:void 0};for(let u=1;u<y.length;u++)this.add(y[u])}add(y){const b={value:y,previous:this.b,next:void 0};for(this.b.next=b,this.b=b,this.c=this.b,this.d++;this.d>this.f;)this.a=this.a.next,this.a.previous=void 0,this.d--}replaceLast(y){const b=this.b.value;return this.b.value=y,b}isAtEnd(){return this.c===this.b}current(){return this.c.value}previous(){return this.c.previous&&(this.c=this.c.previous),this.c.value}next(){return this.c.next&&(this.c=this.c.next),this.c.value}has(y){let b=this.a;for(;b;){if(b.value===y)return!0;b=b.next}return!1}resetCursor(){return this.c=this.b,this.c.value}*[Symbol.iterator](){let y=this.a;for(;y;)yield y.value,y=y.next}}t.HistoryNavigator2=z}),define(me[46],be([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SlidingWindowAverage=t.MovingAverage=t.Counter=t.rot=t.clamp=void 0;function v(b,u,c){return Math.min(Math.max(b,u),c)}t.clamp=v;function i(b,u){return(u+b%u)%u}t.rot=i;class z{constructor(){this.a=0}getNext(){return this.a++}}t.Counter=z;class U{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.MovingAverage=U;class y{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const c=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.SlidingWindowAverage=y}),define(me[47],be([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var v;(function(i){function z(u,c){if(u.start>=c.end||c.start>=u.end)return{start:0,end:0};const f=Math.max(u.start,c.start),I=Math.min(u.end,c.end);return I-f<=0?{start:0,end:0}:{start:f,end:I}}i.intersect=z;function U(u){return u.end-u.start<=0}i.isEmpty=U;function y(u,c){return!U(z(u,c))}i.intersects=y;function b(u,c){const f=[],I={start:u.start,end:Math.min(c.start,u.end)},o={start:Math.max(c.end,u.start),end:u.end};return U(I)||f.push(I),U(o)||f.push(o),f}i.relativeComplement=b})(v=t.Range||(t.Range={}))}),define(me[79],be([1,0,47]),function(J,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMap=t.consolidate=t.shift=t.groupIntersect=void 0;function i(u,c){const f=[];for(const I of c){if(u.start>=I.range.end)continue;if(u.end<I.range.start)break;const o=v.Range.intersect(u,I.range);v.Range.isEmpty(o)||f.push({range:o,size:I.size})}return f}t.groupIntersect=i;function z({start:u,end:c},f){return{start:u+f,end:c+f}}t.shift=z;function U(u){const c=[];let f=null;for(const I of u){const o=I.range.start,n=I.range.end,e=I.size;if(f&&e===f.size){f.range.end=n;continue}f={range:{start:o,end:n},size:e},c.push(f)}return c}t.consolidate=U;function y(...u){return U(u.reduce((c,f)=>c.concat(f),[]))}class b{constructor(){this.a=[],this.b=0}splice(c,f,I=[]){const o=I.length-f,n=i({start:0,end:c},this.a),e=i({start:c+f,end:Number.POSITIVE_INFINITY},this.a).map(r=>({range:z(r.range,o),size:r.size})),s=I.map((r,a)=>({range:{start:c+a,end:c+a+1},size:r.size}));this.a=y(n,s,e),this.b=this.a.reduce((r,a)=>r+a.size*(a.range.end-a.range.start),0)}get count(){const c=this.a.length;return c?this.a[c-1].range.end:0}get size(){return this.b}indexAt(c){if(c<0)return-1;let f=0,I=0;for(const o of this.a){const n=o.range.end-o.range.start,e=I+n*o.size;if(c<e)return f+Math.floor((c-I)/o.size);f+=n,I=e}return f}indexAfter(c){return Math.min(this.indexAt(c)+1,this.count)}positionAt(c){if(c<0)return-1;let f=0,I=0;for(const o of this.a){const n=o.range.end-o.range.start,e=I+n;if(c<e)return f+(c-I)*o.size;f+=n*o.size,I=e}return-1}}t.RangeMap=b}),define(me[80],be([1,0,9,2]),function(J,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=t.isReadable=void 0;function z(k){const S=k;return S?typeof S.read=="function":!1}t.isReadable=z;function U(k){const S=k;return S?[S.on,S.pause,S.resume,S.destroy].every(g=>typeof g=="function"):!1}t.isReadableStream=U;function y(k){const S=k;return S?U(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}t.isReadableBufferedStream=y;function b(k,S){return new u(k,S)}t.newWriteableStream=b;class u{constructor(S,g){this.e=S,this.f=g,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(S){if(!this.a.destroyed){if(this.a.flowing)this.g(S);else if(this.b.data.push(S),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(g=>this.d.push(g))}}error(S){this.a.destroyed||(this.a.flowing?this.h(S):this.b.error.push(S))}end(S){this.a.destroyed||(typeof S<"u"&&this.write(S),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(S){this.c.data.slice(0).forEach(g=>g(S))}h(S){this.c.error.length===0?(0,v.onUnexpectedError)(S):this.c.error.slice(0).forEach(g=>g(S))}i(){this.c.end.slice(0).forEach(S=>S())}on(S,g){if(!this.a.destroyed)switch(S){case"data":this.c.data.push(g),this.resume();break;case"end":this.c.end.push(g),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(g),this.a.flowing&&this.k();break}}removeListener(S,g){if(this.a.destroyed)return;let E;switch(S){case"data":E=this.c.data;break;case"end":E=this.c.end;break;case"error":E=this.c.error;break}if(E){const N=E.indexOf(g);N>=0&&E.splice(N,1)}}j(){if(this.b.data.length>0){const S=this.e(this.b.data);this.g(S),this.b.data.length=0;const g=[...this.d];this.d.length=0,g.forEach(E=>E())}}k(){if(this.c.error.length>0){for(const S of this.b.error)this.h(S);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(k,S){const g=[];let E;for(;(E=k.read())!==null;)g.push(E);return S(g)}t.consumeReadable=c;function f(k,S,g){const E=[];let N;for(;(N=k.read())!==null&&E.length<g;)E.push(N);return N===null&&E.length>0?S(E):{read:()=>{if(E.length>0)return E.shift();if(typeof N<"u"){const F=N;return N=void 0,F}return k.read()}}}t.peekReadable=f;function I(k,S){return new Promise((g,E)=>{const N=[];o(k,{onData:F=>{S&&N.push(F)},onError:F=>{S?E(F):g(void 0)},onEnd:()=>{g(S?S(N):void 0)}})})}t.consumeStream=I;function o(k,S){let g=!1;return k.on("error",E=>{g||S.onError(E)}),k.on("end",()=>{g||S.onEnd()}),k.on("data",E=>{g||S.onData(E)}),(0,i.toDisposable)(()=>g=!0)}t.listenStream=o;function n(k,S){return new Promise((g,E)=>{const N=new i.DisposableStore,F=[],d=D=>{if(F.push(D),F.length>S)return N.dispose(),k.pause(),g({stream:k,buffer:F,ended:!1})},w=D=>E(D),m=()=>g({stream:k,buffer:F,ended:!0});N.add((0,i.toDisposable)(()=>k.removeListener("error",w))),k.on("error",w),N.add((0,i.toDisposable)(()=>k.removeListener("end",m))),k.on("end",m),N.add((0,i.toDisposable)(()=>k.removeListener("data",d))),k.on("data",d)})}t.peekStream=n;function e(k,S){const g=b(S);return g.end(k),g}t.toStream=e;function s(){const k=b(()=>{throw new Error("not supported")});return k.end(),k}t.emptyStream=s;function r(k){let S=!1;return{read:()=>S?null:(S=!0,k)}}t.toReadable=r;function a(k,S,g){const E=b(g);return o(k,{onData:N=>E.write(S.data(N)),onError:N=>E.error(S.error?S.error(N):N),onEnd:()=>E.end()}),E}t.transform=a;function l(k,S,g){let E=!1;return{read:()=>{const N=S.read();return E?N:(E=!0,N!==null?g([k,N]):k)}}}t.prefixedReadable=l;function p(k,S,g){let E=!1;const N=b(g);return o(S,{onData:F=>E?N.write(F):(E=!0,N.write(g([k,F]))),onError:F=>N.error(F),onEnd:()=>{E||(E=!0,N.write(k)),N.end()}}),N}t.prefixedStream=p}),define(me[29],be([1,0,80]),function(J,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.encodeBase64=t.decodeBase64=t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const i=typeof Buffer<"u";let z,U;class y{static alloc(D){return i?new y(Buffer.allocUnsafe(D)):new y(new Uint8Array(D))}static wrap(D){return i&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new y(D)}static fromString(D,R){return!(R?.dontUseNodeBuffer||!1)&&i?new y(Buffer.from(D)):(z||(z=new TextEncoder),new y(z.encode(D)))}static fromByteArray(D){const R=y.alloc(D.length);for(let V=0,Z=D.length;V<Z;V++)R.buffer[V]=D[V];return R}static concat(D,R){if(typeof R>"u"){R=0;for(let X=0,x=D.length;X<x;X++)R+=D[X].byteLength}const V=y.alloc(R);let Z=0;for(let X=0,x=D.length;X<x;X++){const ne=D[X];V.set(ne,Z),Z+=ne.byteLength}return V}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=y.alloc(this.byteLength);return D.set(this),D}toString(){return i?this.buffer.toString():(U||(U=new TextDecoder),U.decode(this.buffer))}slice(D,R){return new y(this.buffer.subarray(D,R))}set(D,R){if(D instanceof y)this.buffer.set(D.buffer,R);else if(D instanceof Uint8Array)this.buffer.set(D,R);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),R);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return c(this.buffer,D)}writeUInt32BE(D,R){f(this.buffer,D,R)}readUInt32LE(D){return I(this.buffer,D)}writeUInt32LE(D,R){o(this.buffer,D,R)}readUInt8(D){return n(this.buffer,D)}writeUInt8(D,R){e(this.buffer,D,R)}}t.VSBuffer=y;function b(m,D){return m[D+0]<<0>>>0|m[D+1]<<8>>>0}t.readUInt16LE=b;function u(m,D,R){m[R+0]=D&255,D=D>>>8,m[R+1]=D&255}t.writeUInt16LE=u;function c(m,D){return m[D]*2**24+m[D+1]*2**16+m[D+2]*2**8+m[D+3]}t.readUInt32BE=c;function f(m,D,R){m[R+3]=D,D=D>>>8,m[R+2]=D,D=D>>>8,m[R+1]=D,D=D>>>8,m[R]=D}t.writeUInt32BE=f;function I(m,D){return m[D+0]<<0>>>0|m[D+1]<<8>>>0|m[D+2]<<16>>>0|m[D+3]<<24>>>0}t.readUInt32LE=I;function o(m,D,R){m[R+0]=D&255,D=D>>>8,m[R+1]=D&255,D=D>>>8,m[R+2]=D&255,D=D>>>8,m[R+3]=D&255}t.writeUInt32LE=o;function n(m,D){return m[D]}t.readUInt8=n;function e(m,D,R){m[R]=D}t.writeUInt8=e;function s(m){return v.consumeReadable(m,D=>y.concat(D))}t.readableToBuffer=s;function r(m){return v.toReadable(m)}t.bufferToReadable=r;function a(m){return v.consumeStream(m,D=>y.concat(D))}t.streamToBuffer=a;async function l(m){return m.ended?y.concat(m.buffer):y.concat([...m.buffer,await a(m.stream)])}t.bufferedStreamToBuffer=l;function p(m){return v.toStream(m,D=>y.concat(D))}t.bufferToStream=p;function k(m){return v.transform(m,{data:D=>typeof D=="string"?y.fromString(D):y.wrap(D)},D=>y.concat(D))}t.streamToBufferReadableStream=k;function S(m){return v.newWriteableStream(D=>y.concat(D),m)}t.newWriteableBufferStream=S;function g(m,D){return v.prefixedReadable(m,D,R=>y.concat(R))}t.prefixedBufferReadable=g;function E(m,D){return v.prefixedStream(m,D,R=>y.concat(R))}t.prefixedBufferStream=E;function N(m){let D=0,R=0,V=0;const Z=new Uint8Array(Math.floor(m.length/4*3)),X=ne=>{switch(R){case 3:Z[V++]=D|ne,R=0;break;case 2:Z[V++]=D|ne>>>2,D=ne<<6,R=3;break;case 1:Z[V++]=D|ne>>>4,D=ne<<4,R=2;break;default:D=ne<<2,R=1}};for(let ne=0;ne<m.length;ne++){const le=m.charCodeAt(ne);if(le>=65&&le<=90)X(le-65);else if(le>=97&&le<=122)X(le-97+26);else if(le>=48&&le<=57)X(le-48+52);else if(le===43||le===45)X(62);else if(le===47||le===95)X(63);else{if(le===61)break;throw new SyntaxError(`Unexpected base64 character ${m[ne]}`)}}const x=V;for(;R>0;)X(0);return y.wrap(Z).slice(0,x)}t.decodeBase64=N;const F="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function w({buffer:m},D=!0,R=!1){const V=R?d:F;let Z="";const X=m.byteLength%3;let x=0;for(;x<m.byteLength-X;x+=3){const ne=m[x+0],le=m[x+1],se=m[x+2];Z+=V[ne>>>2],Z+=V[(ne<<4|le>>>4)&63],Z+=V[(le<<2|se>>>6)&63],Z+=V[se&63]}if(X===1){const ne=m[x+0];Z+=V[ne>>>2],Z+=V[ne<<4&63],D&&(Z+="==")}else if(X===2){const ne=m[x+0],le=m[x+1];Z+=V[ne>>>2],Z+=V[(ne<<4|le>>>4)&63],Z+=V[le<<2&63],D&&(Z+="=")}return Z}t.encodeBase64=w}),define(me[6],be([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.withUndefinedAsNull=t.withNullAsUndefined=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function v(E){return typeof E=="string"}t.isString=v;function i(E){return Array.isArray(E)&&E.every(N=>v(N))}t.isStringArray=i;function z(E){return typeof E=="object"&&E!==null&&!Array.isArray(E)&&!(E instanceof RegExp)&&!(E instanceof Date)}t.isObject=z;function U(E){const N=Object.getPrototypeOf(Uint8Array);return typeof E=="object"&&E instanceof N}t.isTypedArray=U;function y(E){return typeof E=="number"&&!isNaN(E)}t.isNumber=y;function b(E){return!!E&&typeof E[Symbol.iterator]=="function"}t.isIterable=b;function u(E){return E===!0||E===!1}t.isBoolean=u;function c(E){return typeof E>"u"}t.isUndefined=c;function f(E){return!I(E)}t.isDefined=f;function I(E){return c(E)||E===null}t.isUndefinedOrNull=I;function o(E,N){if(!E)throw new Error(N?`Unexpected type, expected '${N}'`:"Unexpected type")}t.assertType=o;function n(E){if(I(E))throw new Error("Assertion Failed: argument is undefined or null");return E}t.assertIsDefined=n;function e(...E){const N=[];for(let F=0;F<E.length;F++){const d=E[F];if(I(d))throw new Error(`Assertion Failed: argument at index ${F} is undefined or null`);N.push(d)}return N}t.assertAllDefined=e;const s=Object.prototype.hasOwnProperty;function r(E){if(!z(E))return!1;for(const N in E)if(s.call(E,N))return!1;return!0}t.isEmptyObject=r;function a(E){return typeof E=="function"}t.isFunction=a;function l(...E){return E.length>0&&E.every(a)}t.areFunctions=l;function p(E,N){const F=Math.min(E.length,N.length);for(let d=0;d<F;d++)k(E[d],N[d])}t.validateConstraints=p;function k(E,N){if(v(N)){if(typeof E!==N)throw new Error(`argument does not match constraint: typeof ${N}`)}else if(a(N)){try{if(E instanceof N)return}catch{}if(!I(E)&&E.constructor===N||N.length===1&&N.call(void 0,E)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=k;function S(E){return E===null?void 0:E}t.withNullAsUndefined=S;function g(E){return typeof E>"u"?null:E}t.withUndefinedAsNull=g}),define(me[30],be([1,0,6]),function(J,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function i(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const l=Array.isArray(a)?[]:{};return Object.entries(a).forEach(([p,k])=>{l[p]=k&&typeof k=="object"?i(k):k}),l}t.deepClone=i;function z(a){if(!a||typeof a!="object")return a;const l=[a];for(;l.length>0;){const p=l.shift();Object.freeze(p);for(const k in p)if(U.call(p,k)){const S=p[k];typeof S=="object"&&!Object.isFrozen(S)&&!(0,v.isTypedArray)(S)&&l.push(S)}}return a}t.deepFreeze=z;const U=Object.prototype.hasOwnProperty;function y(a,l){return b(a,l,new Set)}t.cloneAndChange=y;function b(a,l,p){if((0,v.isUndefinedOrNull)(a))return a;const k=l(a);if(typeof k<"u")return k;if(Array.isArray(a)){const S=[];for(const g of a)S.push(b(g,l,p));return S}if((0,v.isObject)(a)){if(p.has(a))throw new Error("Cannot clone recursive data-structure");p.add(a);const S={};for(const g in a)U.call(a,g)&&(S[g]=b(a[g],l,p));return p.delete(a),S}return a}function u(a,l,p=!0){return(0,v.isObject)(a)?((0,v.isObject)(l)&&Object.keys(l).forEach(k=>{k in a?p&&((0,v.isObject)(a[k])&&(0,v.isObject)(l[k])?u(a[k],l[k],p):a[k]=l[k]):a[k]=l[k]}),a):l}t.mixin=u;function c(a,l){if(a===l)return!0;if(a==null||l===null||l===void 0||typeof a!=typeof l||typeof a!="object"||Array.isArray(a)!==Array.isArray(l))return!1;let p,k;if(Array.isArray(a)){if(a.length!==l.length)return!1;for(p=0;p<a.length;p++)if(!c(a[p],l[p]))return!1}else{const S=[];for(k in a)S.push(k);S.sort();const g=[];for(k in l)g.push(k);if(g.sort(),!c(S,g))return!1;for(p=0;p<S.length;p++)if(!c(a[S[p]],l[S[p]]))return!1}return!0}t.equals=c;function f(a){const l=new Set;return JSON.stringify(a,(p,k)=>{if((0,v.isObject)(k)||Array.isArray(k)){if(l.has(k))return"[Circular]";l.add(k)}return k})}t.safeStringify=f;function I(a,l){const p=Object.create(null);return!a||!l||Object.keys(l).forEach(S=>{const g=a[S],E=l[S];c(g,E)||(p[S]=E)}),p}t.distinct=I;function o(a,l){const p=l.toLowerCase(),k=Object.keys(a).find(S=>S.toLowerCase()===p);return k?a[k]:a[l]}t.getCaseInsensitive=o;function n(a,l){const p=Object.create(null);for(const[k,S]of Object.entries(a))l(k,S)&&(p[k]=S);return p}t.filter=n;function e(a){let l=[],p=Object.getPrototypeOf(a);for(;Object.prototype!==p;)l=l.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return l}t.getAllPropertyNames=e;function s(a){const l=[];for(const p of e(a))typeof a[p]=="function"&&l.push(p);return l}t.getAllMethodNames=s;function r(a,l){const p=S=>function(){const g=Array.prototype.slice.call(arguments,0);return l(S,g)},k={};for(const S of a)k[S]=p(S);return k}t.createProxyObject=r}),define(me[81],be([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CONTEXT_MENU_CLOSE_CHANNEL=t.CONTEXT_MENU_CHANNEL=void 0,t.CONTEXT_MENU_CHANNEL="vscode:contextmenu",t.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(me[82],be([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Protocol=void 0;class v{constructor(z,U){this.a=z,this.onMessage=U}send(z){try{this.a.send("vscode:message",z.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.Protocol=v}),define(me[48],be([7]),{}),define(me[83],be([7]),{}),define(me[84],be([7]),{}),define(me[85],be([7]),{}),define(me[86],be([1,0,12,84,85]),function(J,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.formatRule=void 0;function i(z){let U=z.definition;for(;U instanceof v.Codicon;)U=U.definition;return`.codicon-${z.id}:before { content: '${U.fontCharacter}'; }`}t.formatRule=i}),define(me[87],be([7]),{}),define(me[88],be([7]),{}),define(me[89],be([7]),{}),define(me[90],be([7]),{}),define(me[91],be([7]),{}),define(me[92],be([7]),{}),define(me[93],be([7]),{}),define(me[94],be([7]),{}),define(me[95],be([7]),{}),define(me[96],be([13,10]),function(J,t){return J.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(me[97],be([13,10]),function(J,t){return J.create("vs/base/browser/ui/findinput/findInput",t)}),define(me[98],be([13,10]),function(J,t){return J.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(me[99],be([13,10]),function(J,t){return J.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(me[100],be([13,10]),function(J,t){return J.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(me[101],be([13,10]),function(J,t){return J.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(me[102],be([13,10]),function(J,t){return J.create("vs/base/browser/ui/tree/abstractTree",t)}),define(me[103],be([13,10]),function(J,t){return J.create("vs/base/common/actions",t)}),define(me[104],be([13,10]),function(J,t){return J.create("vs/base/common/platform",t)}),define(me[5],be([1,0,104]),function(J,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=t.LANGUAGE_DEFAULT=void 0,t.LANGUAGE_DEFAULT="en";let i=!1,z=!1,U=!1,y=!1,b=!1,u=!1,c=!1,f=!1,I=!1,o=!1,n,e=t.LANGUAGE_DEFAULT,s,r;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let a;typeof t.globals.vscode<"u"&&typeof t.globals.vscode.process<"u"?a=t.globals.vscode.process:typeof process<"u"&&(a=process);const l=typeof a?.versions?.electron=="string",p=l&&a?.type==="renderer";if(typeof navigator=="object"&&!p)r=navigator.userAgent,i=r.indexOf("Windows")>=0,z=r.indexOf("Macintosh")>=0,f=(r.indexOf("Macintosh")>=0||r.indexOf("iPad")>=0||r.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,U=r.indexOf("Linux")>=0,o=r?.indexOf("Mobi")>=0,u=!0,n=v.getConfiguredDefaultLocale(v.localize(0,null))||t.LANGUAGE_DEFAULT,e=n;else if(typeof a=="object"){i=a.platform==="win32",z=a.platform==="darwin",U=a.platform==="linux",y=U&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,c=l,I=!!a.env.CI||!!a.env.BUILD_ARTIFACTSTAGINGDIRECTORY,n=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const m=a.env.VSCODE_NLS_CONFIG;if(m)try{const D=JSON.parse(m),R=D.availableLanguages["*"];n=D.locale,e=R||t.LANGUAGE_DEFAULT,s=D._translationsConfigFile}catch{}b=!0}else console.error("Unable to resolve platform.");var k;(function(m){m[m.Web=0]="Web",m[m.Mac=1]="Mac",m[m.Linux=2]="Linux",m[m.Windows=3]="Windows"})(k=t.Platform||(t.Platform={}));function S(m){switch(m){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=S;let g=0;z?g=1:i?g=3:U&&(g=2),t.isWindows=i,t.isMacintosh=z,t.isLinux=U,t.isLinuxSnap=y,t.isNative=b,t.isElectron=c,t.isWeb=u,t.isWebWorker=u&&typeof t.globals.importScripts=="function",t.isIOS=f,t.isMobile=o,t.isCI=I,t.platform=g,t.userAgent=r,t.language=e;var E;(function(m){function D(){return t.language}m.value=D;function R(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}m.isDefaultVariant=R;function V(){return t.language==="en"}m.isDefault=V})(E=t.Language||(t.Language={})),t.locale=n,t.translationsConfigFile=s,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const m=[];t.globals.addEventListener("message",R=>{if(R.data&&R.data.vscodeScheduleAsyncWork)for(let V=0,Z=m.length;V<Z;V++){const X=m[V];if(X.id===R.data.vscodeScheduleAsyncWork){m.splice(V,1),X.callback();return}}});let D=0;return R=>{const V=++D;m.push({id:V,callback:R}),t.globals.postMessage({vscodeScheduleAsyncWork:V},"*")}}return m=>setTimeout(m)})();var N;(function(m){m[m.Windows=1]="Windows",m[m.Macintosh=2]="Macintosh",m[m.Linux=3]="Linux"})(N=t.OperatingSystem||(t.OperatingSystem={})),t.OS=z||f?2:i?1:3;let F=!0,d=!1;function w(){if(!d){d=!0;const m=new Uint8Array(2);m[0]=1,m[1]=2,F=new Uint16Array(m.buffer)[0]===(2<<8)+1}return F}t.isLittleEndian=w,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),define(me[105],be([1,0,5]),function(J,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let i;if(typeof v.globals.vscode<"u"&&typeof v.globals.vscode.process<"u"){const z=v.globals.vscode.process;i={get platform(){return z.platform},get arch(){return z.arch},get env(){return z.env},cwd(){return z.cwd()}}}else typeof process<"u"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=i.cwd,t.env=i.env,t.platform=i.platform,t.arch=i.arch}),define(me[21],be([1,0,105]),function(J,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const i=65,z=97,U=90,y=122,b=46,u=47,c=92,f=58,I=63;class o extends Error{constructor(E,N,F){let d;typeof N=="string"&&N.indexOf("not ")===0?(d="must not be",N=N.replace(/^not /,"")):d="must be";const w=E.indexOf(".")!==-1?"property":"argument";let m=`The "${E}" ${w} ${d} of type ${N}`;m+=`. Received type ${typeof F}`,super(m),this.code="ERR_INVALID_ARG_TYPE"}}function n(g,E){if(g===null||typeof g!="object")throw new o(E,"Object",g)}function e(g,E){if(typeof g!="string")throw new o(E,"string",g)}const s=v.platform==="win32";function r(g){return g===u||g===c}function a(g){return g===u}function l(g){return g>=i&&g<=U||g>=z&&g<=y}function p(g,E,N,F){let d="",w=0,m=-1,D=0,R=0;for(let V=0;V<=g.length;++V){if(V<g.length)R=g.charCodeAt(V);else{if(F(R))break;R=u}if(F(R)){if(!(m===V-1||D===1))if(D===2){if(d.length<2||w!==2||d.charCodeAt(d.length-1)!==b||d.charCodeAt(d.length-2)!==b){if(d.length>2){const Z=d.lastIndexOf(N);Z===-1?(d="",w=0):(d=d.slice(0,Z),w=d.length-1-d.lastIndexOf(N)),m=V,D=0;continue}else if(d.length!==0){d="",w=0,m=V,D=0;continue}}E&&(d+=d.length>0?`${N}..`:"..",w=2)}else d.length>0?d+=`${N}${g.slice(m+1,V)}`:d=g.slice(m+1,V),w=V-m-1;m=V,D=0}else R===b&&D!==-1?++D:D=-1}return d}function k(g,E){n(E,"pathObject");const N=E.dir||E.root,F=E.base||`${E.name||""}${E.ext||""}`;return N?N===E.root?`${N}${F}`:`${N}${g}${F}`:F}t.win32={resolve(...g){let E="",N="",F=!1;for(let d=g.length-1;d>=-1;d--){let w;if(d>=0){if(w=g[d],e(w,"path"),w.length===0)continue}else E.length===0?w=v.cwd():(w=v.env[`=${E}`]||v.cwd(),(w===void 0||w.slice(0,2).toLowerCase()!==E.toLowerCase()&&w.charCodeAt(2)===c)&&(w=`${E}\\`));const m=w.length;let D=0,R="",V=!1;const Z=w.charCodeAt(0);if(m===1)r(Z)&&(D=1,V=!0);else if(r(Z))if(V=!0,r(w.charCodeAt(1))){let X=2,x=X;for(;X<m&&!r(w.charCodeAt(X));)X++;if(X<m&&X!==x){const ne=w.slice(x,X);for(x=X;X<m&&r(w.charCodeAt(X));)X++;if(X<m&&X!==x){for(x=X;X<m&&!r(w.charCodeAt(X));)X++;(X===m||X!==x)&&(R=`\\\\${ne}\\${w.slice(x,X)}`,D=X)}}}else D=1;else l(Z)&&w.charCodeAt(1)===f&&(R=w.slice(0,2),D=2,m>2&&r(w.charCodeAt(2))&&(V=!0,D=3));if(R.length>0)if(E.length>0){if(R.toLowerCase()!==E.toLowerCase())continue}else E=R;if(F){if(E.length>0)break}else if(N=`${w.slice(D)}\\${N}`,F=V,V&&E.length>0)break}return N=p(N,!F,"\\",r),F?`${E}\\${N}`:`${E}${N}`||"."},normalize(g){e(g,"path");const E=g.length;if(E===0)return".";let N=0,F,d=!1;const w=g.charCodeAt(0);if(E===1)return a(w)?"\\":g;if(r(w))if(d=!0,r(g.charCodeAt(1))){let D=2,R=D;for(;D<E&&!r(g.charCodeAt(D));)D++;if(D<E&&D!==R){const V=g.slice(R,D);for(R=D;D<E&&r(g.charCodeAt(D));)D++;if(D<E&&D!==R){for(R=D;D<E&&!r(g.charCodeAt(D));)D++;if(D===E)return`\\\\${V}\\${g.slice(R)}\\`;D!==R&&(F=`\\\\${V}\\${g.slice(R,D)}`,N=D)}}}else N=1;else l(w)&&g.charCodeAt(1)===f&&(F=g.slice(0,2),N=2,E>2&&r(g.charCodeAt(2))&&(d=!0,N=3));let m=N<E?p(g.slice(N),!d,"\\",r):"";return m.length===0&&!d&&(m="."),m.length>0&&r(g.charCodeAt(E-1))&&(m+="\\"),F===void 0?d?`\\${m}`:m:d?`${F}\\${m}`:`${F}${m}`},isAbsolute(g){e(g,"path");const E=g.length;if(E===0)return!1;const N=g.charCodeAt(0);return r(N)||E>2&&l(N)&&g.charCodeAt(1)===f&&r(g.charCodeAt(2))},join(...g){if(g.length===0)return".";let E,N;for(let w=0;w<g.length;++w){const m=g[w];e(m,"path"),m.length>0&&(E===void 0?E=N=m:E+=`\\${m}`)}if(E===void 0)return".";let F=!0,d=0;if(typeof N=="string"&&r(N.charCodeAt(0))){++d;const w=N.length;w>1&&r(N.charCodeAt(1))&&(++d,w>2&&(r(N.charCodeAt(2))?++d:F=!1))}if(F){for(;d<E.length&&r(E.charCodeAt(d));)d++;d>=2&&(E=`\\${E.slice(d)}`)}return t.win32.normalize(E)},relative(g,E){if(e(g,"from"),e(E,"to"),g===E)return"";const N=t.win32.resolve(g),F=t.win32.resolve(E);if(N===F||(g=N.toLowerCase(),E=F.toLowerCase(),g===E))return"";let d=0;for(;d<g.length&&g.charCodeAt(d)===c;)d++;let w=g.length;for(;w-1>d&&g.charCodeAt(w-1)===c;)w--;const m=w-d;let D=0;for(;D<E.length&&E.charCodeAt(D)===c;)D++;let R=E.length;for(;R-1>D&&E.charCodeAt(R-1)===c;)R--;const V=R-D,Z=m<V?m:V;let X=-1,x=0;for(;x<Z;x++){const le=g.charCodeAt(d+x);if(le!==E.charCodeAt(D+x))break;le===c&&(X=x)}if(x!==Z){if(X===-1)return F}else{if(V>Z){if(E.charCodeAt(D+x)===c)return F.slice(D+x+1);if(x===2)return F.slice(D+x)}m>Z&&(g.charCodeAt(d+x)===c?X=x:x===2&&(X=3)),X===-1&&(X=0)}let ne="";for(x=d+X+1;x<=w;++x)(x===w||g.charCodeAt(x)===c)&&(ne+=ne.length===0?"..":"\\..");return D+=X,ne.length>0?`${ne}${F.slice(D,R)}`:(F.charCodeAt(D)===c&&++D,F.slice(D,R))},toNamespacedPath(g){if(typeof g!="string"||g.length===0)return g;const E=t.win32.resolve(g);if(E.length<=2)return g;if(E.charCodeAt(0)===c){if(E.charCodeAt(1)===c){const N=E.charCodeAt(2);if(N!==I&&N!==b)return`\\\\?\\UNC\\${E.slice(2)}`}}else if(l(E.charCodeAt(0))&&E.charCodeAt(1)===f&&E.charCodeAt(2)===c)return`\\\\?\\${E}`;return g},dirname(g){e(g,"path");const E=g.length;if(E===0)return".";let N=-1,F=0;const d=g.charCodeAt(0);if(E===1)return r(d)?g:".";if(r(d)){if(N=F=1,r(g.charCodeAt(1))){let D=2,R=D;for(;D<E&&!r(g.charCodeAt(D));)D++;if(D<E&&D!==R){for(R=D;D<E&&r(g.charCodeAt(D));)D++;if(D<E&&D!==R){for(R=D;D<E&&!r(g.charCodeAt(D));)D++;if(D===E)return g;D!==R&&(N=F=D+1)}}}}else l(d)&&g.charCodeAt(1)===f&&(N=E>2&&r(g.charCodeAt(2))?3:2,F=N);let w=-1,m=!0;for(let D=E-1;D>=F;--D)if(r(g.charCodeAt(D))){if(!m){w=D;break}}else m=!1;if(w===-1){if(N===-1)return".";w=N}return g.slice(0,w)},basename(g,E){E!==void 0&&e(E,"ext"),e(g,"path");let N=0,F=-1,d=!0,w;if(g.length>=2&&l(g.charCodeAt(0))&&g.charCodeAt(1)===f&&(N=2),E!==void 0&&E.length>0&&E.length<=g.length){if(E===g)return"";let m=E.length-1,D=-1;for(w=g.length-1;w>=N;--w){const R=g.charCodeAt(w);if(r(R)){if(!d){N=w+1;break}}else D===-1&&(d=!1,D=w+1),m>=0&&(R===E.charCodeAt(m)?--m===-1&&(F=w):(m=-1,F=D))}return N===F?F=D:F===-1&&(F=g.length),g.slice(N,F)}for(w=g.length-1;w>=N;--w)if(r(g.charCodeAt(w))){if(!d){N=w+1;break}}else F===-1&&(d=!1,F=w+1);return F===-1?"":g.slice(N,F)},extname(g){e(g,"path");let E=0,N=-1,F=0,d=-1,w=!0,m=0;g.length>=2&&g.charCodeAt(1)===f&&l(g.charCodeAt(0))&&(E=F=2);for(let D=g.length-1;D>=E;--D){const R=g.charCodeAt(D);if(r(R)){if(!w){F=D+1;break}continue}d===-1&&(w=!1,d=D+1),R===b?N===-1?N=D:m!==1&&(m=1):N!==-1&&(m=-1)}return N===-1||d===-1||m===0||m===1&&N===d-1&&N===F+1?"":g.slice(N,d)},format:k.bind(null,"\\"),parse(g){e(g,"path");const E={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return E;const N=g.length;let F=0,d=g.charCodeAt(0);if(N===1)return r(d)?(E.root=E.dir=g,E):(E.base=E.name=g,E);if(r(d)){if(F=1,r(g.charCodeAt(1))){let X=2,x=X;for(;X<N&&!r(g.charCodeAt(X));)X++;if(X<N&&X!==x){for(x=X;X<N&&r(g.charCodeAt(X));)X++;if(X<N&&X!==x){for(x=X;X<N&&!r(g.charCodeAt(X));)X++;X===N?F=X:X!==x&&(F=X+1)}}}}else if(l(d)&&g.charCodeAt(1)===f){if(N<=2)return E.root=E.dir=g,E;if(F=2,r(g.charCodeAt(2))){if(N===3)return E.root=E.dir=g,E;F=3}}F>0&&(E.root=g.slice(0,F));let w=-1,m=F,D=-1,R=!0,V=g.length-1,Z=0;for(;V>=F;--V){if(d=g.charCodeAt(V),r(d)){if(!R){m=V+1;break}continue}D===-1&&(R=!1,D=V+1),d===b?w===-1?w=V:Z!==1&&(Z=1):w!==-1&&(Z=-1)}return D!==-1&&(w===-1||Z===0||Z===1&&w===D-1&&w===m+1?E.base=E.name=g.slice(m,D):(E.name=g.slice(m,w),E.base=g.slice(m,D),E.ext=g.slice(w,D))),m>0&&m!==F?E.dir=g.slice(0,m-1):E.dir=E.root,E},sep:"\\",delimiter:";",win32:null,posix:null};const S=(()=>{if(s){const g=/\\/g;return()=>{const E=v.cwd().replace(g,"/");return E.slice(E.indexOf("/"))}}return()=>v.cwd()})();t.posix={resolve(...g){let E="",N=!1;for(let F=g.length-1;F>=-1&&!N;F--){const d=F>=0?g[F]:S();e(d,"path"),d.length!==0&&(E=`${d}/${E}`,N=d.charCodeAt(0)===u)}return E=p(E,!N,"/",a),N?`/${E}`:E.length>0?E:"."},normalize(g){if(e(g,"path"),g.length===0)return".";const E=g.charCodeAt(0)===u,N=g.charCodeAt(g.length-1)===u;return g=p(g,!E,"/",a),g.length===0?E?"/":N?"./":".":(N&&(g+="/"),E?`/${g}`:g)},isAbsolute(g){return e(g,"path"),g.length>0&&g.charCodeAt(0)===u},join(...g){if(g.length===0)return".";let E;for(let N=0;N<g.length;++N){const F=g[N];e(F,"path"),F.length>0&&(E===void 0?E=F:E+=`/${F}`)}return E===void 0?".":t.posix.normalize(E)},relative(g,E){if(e(g,"from"),e(E,"to"),g===E||(g=t.posix.resolve(g),E=t.posix.resolve(E),g===E))return"";const N=1,F=g.length,d=F-N,w=1,m=E.length-w,D=d<m?d:m;let R=-1,V=0;for(;V<D;V++){const X=g.charCodeAt(N+V);if(X!==E.charCodeAt(w+V))break;X===u&&(R=V)}if(V===D)if(m>D){if(E.charCodeAt(w+V)===u)return E.slice(w+V+1);if(V===0)return E.slice(w+V)}else d>D&&(g.charCodeAt(N+V)===u?R=V:V===0&&(R=0));let Z="";for(V=N+R+1;V<=F;++V)(V===F||g.charCodeAt(V)===u)&&(Z+=Z.length===0?"..":"/..");return`${Z}${E.slice(w+R)}`},toNamespacedPath(g){return g},dirname(g){if(e(g,"path"),g.length===0)return".";const E=g.charCodeAt(0)===u;let N=-1,F=!0;for(let d=g.length-1;d>=1;--d)if(g.charCodeAt(d)===u){if(!F){N=d;break}}else F=!1;return N===-1?E?"/":".":E&&N===1?"//":g.slice(0,N)},basename(g,E){E!==void 0&&e(E,"ext"),e(g,"path");let N=0,F=-1,d=!0,w;if(E!==void 0&&E.length>0&&E.length<=g.length){if(E===g)return"";let m=E.length-1,D=-1;for(w=g.length-1;w>=0;--w){const R=g.charCodeAt(w);if(R===u){if(!d){N=w+1;break}}else D===-1&&(d=!1,D=w+1),m>=0&&(R===E.charCodeAt(m)?--m===-1&&(F=w):(m=-1,F=D))}return N===F?F=D:F===-1&&(F=g.length),g.slice(N,F)}for(w=g.length-1;w>=0;--w)if(g.charCodeAt(w)===u){if(!d){N=w+1;break}}else F===-1&&(d=!1,F=w+1);return F===-1?"":g.slice(N,F)},extname(g){e(g,"path");let E=-1,N=0,F=-1,d=!0,w=0;for(let m=g.length-1;m>=0;--m){const D=g.charCodeAt(m);if(D===u){if(!d){N=m+1;break}continue}F===-1&&(d=!1,F=m+1),D===b?E===-1?E=m:w!==1&&(w=1):E!==-1&&(w=-1)}return E===-1||F===-1||w===0||w===1&&E===F-1&&E===N+1?"":g.slice(E,F)},format:k.bind(null,"/"),parse(g){e(g,"path");const E={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return E;const N=g.charCodeAt(0)===u;let F;N?(E.root="/",F=1):F=0;let d=-1,w=0,m=-1,D=!0,R=g.length-1,V=0;for(;R>=F;--R){const Z=g.charCodeAt(R);if(Z===u){if(!D){w=R+1;break}continue}m===-1&&(D=!1,m=R+1),Z===b?d===-1?d=R:V!==1&&(V=1):d!==-1&&(V=-1)}if(m!==-1){const Z=w===0&&N?1:w;d===-1||V===0||V===1&&d===m-1&&d===w+1?E.base=E.name=g.slice(Z,m):(E.name=g.slice(Z,d),E.base=g.slice(Z,m),E.ext=g.slice(d,m))}return w>0?E.dir=g.slice(0,w-1):N&&(E.dir="/"),E},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=s?t.win32.normalize:t.posix.normalize,t.isAbsolute=s?t.win32.isAbsolute:t.posix.isAbsolute,t.join=s?t.win32.join:t.posix.join,t.resolve=s?t.win32.resolve:t.posix.resolve,t.relative=s?t.win32.relative:t.posix.relative,t.dirname=s?t.win32.dirname:t.posix.dirname,t.basename=s?t.win32.basename:t.posix.basename,t.extname=s?t.win32.extname:t.posix.extname,t.format=s?t.win32.format:t.posix.format,t.parse=s?t.win32.parse:t.posix.parse,t.toNamespacedPath=s?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=s?t.win32.sep:t.posix.sep,t.delimiter=s?t.win32.delimiter:t.posix.delimiter}),define(me[106],be([1,0,21]),function(J,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeMimeType=t.getExtensionForMimeType=t.getMediaMime=t.getMediaOrTextMime=t.Mimes=void 0,t.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const i={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},z={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function U(f){const I=(0,v.extname)(f),o=i[I.toLowerCase()];return o!==void 0?o:y(f)}t.getMediaOrTextMime=U;function y(f){const I=(0,v.extname)(f);return z[I.toLowerCase()]}t.getMediaMime=y;function b(f){for(const I in z)if(z[I]===f)return I}t.getExtensionForMimeType=b;const u=/^(.+)\/(.+?)(;.+)?$/;function c(f,I){const o=u.exec(f);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${o[3]??""}`:I?void 0:f}t.normalizeMimeType=c}),define(me[107],be([1,0,5]),function(J,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const i=v.globals.performance&&typeof v.globals.performance.now=="function";class z{static create(y=!0){return new z(y)}constructor(y){this.a=i&&y,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?v.globals.performance.now():Date.now()}}t.StopWatch=z}),define(me[3],be([1,0,9,42,2,45,107]),function(J,t,v,i,z,U,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.EventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.EventProfiling=t.Event=void 0;const b=!1,u=!1;var c;(function(w){w.None=()=>z.Disposable.None;function m(_){if(u){const{onDidAddListener:$}=_,Y=e.create();let T=0;_.onDidAddListener=()=>{++T===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Y.print()),$?.()}}}function D(_,$){return fe(_,()=>{},0,void 0,void 0,$)}w.defer=D;function R(_){return($,Y=null,T)=>{let H=!1,W;return W=_(L=>{if(!H)return W?W.dispose():H=!0,$.call(Y,L)},null,T),H&&W.dispose(),W}}w.once=R;function V(_,$,Y){return se((T,H=null,W)=>_(L=>T.call(H,$(L)),null,W),Y)}w.map=V;function Z(_,$,Y){return se((T,H=null,W)=>_(L=>{$(L),T.call(H,L)},null,W),Y)}w.forEach=Z;function X(_,$,Y){return se((T,H=null,W)=>_(L=>$(L)&&T.call(H,L),null,W),Y)}w.filter=X;function x(_){return _}w.signal=x;function ne(..._){return($,Y=null,T)=>(0,z.combinedDisposable)(..._.map(H=>H(W=>$.call(Y,W),null,T)))}w.any=ne;function le(_,$,Y,T){let H=Y;return V(_,W=>(H=$(H,W),H),T)}w.reduce=le;function se(_,$){let Y;const T={onWillAddFirstListener(){Y=_(H.fire,H)},onDidRemoveLastListener(){Y?.dispose()}};$||m(T);const H=new r(T);return $?.add(H),H.event}function fe(_,$,Y=100,T=!1,H,W){let L,M,P,O=0;const j={leakWarningThreshold:H,onWillAddFirstListener(){L=_(ce=>{O++,M=$(M,ce),T&&!P&&(ee.fire(M),M=void 0),clearTimeout(P),P=setTimeout(()=>{const de=M;M=void 0,P=void 0,(!T||O>1)&&ee.fire(de),O=0},Y)})},onDidRemoveLastListener(){L.dispose()}};W||m(j);const ee=new r(j);return W?.add(ee),ee.event}w.debounce=fe;function Ae(_,$=0,Y){return w.debounce(_,(T,H)=>T?(T.push(H),T):[H],$,void 0,void 0,Y)}w.accumulate=Ae;function te(_,$=(T,H)=>T===H,Y){let T=!0,H;return X(_,W=>{const L=T||!$(W,H);return T=!1,H=W,L},Y)}w.latch=te;function ve(_,$,Y){return[w.filter(_,$,Y),w.filter(_,T=>!$(T),Y)]}w.split=ve;function Ne(_,$=!1,Y=[]){let T=Y.slice(),H=_(M=>{T?T.push(M):L.fire(M)});const W=()=>{T?.forEach(M=>L.fire(M)),T=null},L=new r({onWillAddFirstListener(){H||(H=_(M=>L.fire(M)))},onDidAddFirstListener(){T&&($?setTimeout(W):W())},onDidRemoveLastListener(){H&&H.dispose(),H=null}});return L.event}w.buffer=Ne;class he{constructor($){this.event=$,this.c=new z.DisposableStore}map($){return new he(V(this.event,$,this.c))}forEach($){return new he(Z(this.event,$,this.c))}filter($){return new he(X(this.event,$,this.c))}reduce($,Y){return new he(le(this.event,$,Y,this.c))}latch(){return new he(te(this.event,void 0,this.c))}debounce($,Y=100,T=!1,H){return new he(fe(this.event,$,Y,T,H,this.c))}on($,Y,T){return this.event($,Y,T)}once($,Y,T){return R(this.event)($,Y,T)}dispose(){this.c.dispose()}}function Q(_){return new he(_)}w.chain=Q;function oe(_,$,Y=T=>T){const T=(...M)=>L.fire(Y(...M)),H=()=>_.on($,T),W=()=>_.removeListener($,T),L=new r({onWillAddFirstListener:H,onDidRemoveLastListener:W});return L.event}w.fromNodeEventEmitter=oe;function re(_,$,Y=T=>T){const T=(...M)=>L.fire(Y(...M)),H=()=>_.addEventListener($,T),W=()=>_.removeEventListener($,T),L=new r({onWillAddFirstListener:H,onDidRemoveLastListener:W});return L.event}w.fromDOMEventEmitter=re;function ie(_){return new Promise($=>R(_)($))}w.toPromise=ie;function A(_,$){return $(void 0),_(Y=>$(Y))}w.runAndSubscribe=A;function C(_,$){let Y=null;function T(W){Y?.dispose(),Y=new z.DisposableStore,$(W,Y)}T(void 0);const H=_(W=>T(W));return(0,z.toDisposable)(()=>{H.dispose(),Y?.dispose()})}w.runAndSubscribeWithStore=C;class h{constructor($,Y){this.obs=$,this.c=0,this.d=!1;const T={onWillAddFirstListener:()=>{$.addObserver(this)},onDidRemoveLastListener:()=>{$.removeObserver(this)}};Y||m(T),this.emitter=new r(T),Y&&Y.add(this.emitter)}beginUpdate($){this.c++}handleChange($,Y){this.d=!0}endUpdate($){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function B(_,$){return new h(_,$).emitter.event}w.fromObservable=B})(c=t.Event||(t.Event={}));class f{constructor(m){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${m}_${f.c++}`,f.all.add(this)}start(m){this.d=new y.StopWatch(!0),this.listenerCount=m}stop(){if(this.d){const m=this.d.elapsed();this.durations.push(m),this.elapsedOverall+=m,this.invocationCount+=1,this.d=void 0}}}t.EventProfiling=f,f.all=new Set,f.c=0;let I=-1;function o(w){const m=I;return I=w,{dispose(){I=m}}}t.setGlobalLeakWarningThreshold=o;class n{constructor(m,D=Math.random().toString(18).slice(2,5)){this.threshold=m,this.name=D,this.d=0}dispose(){this.c?.clear()}check(m,D){const R=this.threshold;if(R<=0||D<R)return;this.c||(this.c=new Map);const V=this.c.get(m.value)||0;if(this.c.set(m.value,V+1),this.d-=1,this.d<=0){this.d=R*.5;let Z,X=0;for(const[x,ne]of this.c)(!Z||X<ne)&&(Z=x,X=ne);console.warn(`[${this.name}] potential listener LEAK detected, having ${D} listeners already. MOST frequent listener (${X}):`),console.warn(Z)}return()=>{const Z=this.c.get(m.value)||0;this.c.set(m.value,Z-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(m){this.value=m}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class s{constructor(m,D,R){this.callback=m,this.callbackThis=D,this.stack=R,this.subscription=new z.SafeDisposable}invoke(m){this.callback.call(this.callbackThis,m)}}class r{constructor(m){this.j=!1,this.d=m,this.f=I>0||this.d?.leakWarningThreshold?new n(this.d?.leakWarningThreshold??I):void 0,this.g=this.d?._profName?new f(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(b){const m=Array.from(this.q);queueMicrotask(()=>{for(const D of m)D.subscription.isset()&&(D.subscription.unset(),D.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(m,D,R)=>{if(this.q||(this.q=new U.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),z.Disposable.None;const V=this.q.isEmpty();V&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let Z,X;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(X=e.create(),Z=this.f.check(X,this.q.size+1)),b&&(X=X??e.create());const x=new s(m,D,X),ne=this.q.push(x);V&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,m,D);const le=x.subscription.set(()=>{Z?.(),this.j||(ne(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return R instanceof z.DisposableStore?R.add(le):Array.isArray(R)&&R.push(le),le}),this.l}fire(m){if(this.q){this.m||(this.m=new l);for(const D of this.q)this.m.push(this,D,m);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}t.Emitter=r;class a{constructor(){this.c=new U.LinkedList}get size(){return this.c.size}push(m,D,R){this.c.push(new p(m,D,R))}clear(m){const D=new U.LinkedList;for(const R of this.c)R.emitter!==m&&D.push(R);this.c=D}deliver(){for(;this.c.size>0;){const m=this.c.shift();try{m.listener.invoke(m.event)}catch(D){(0,v.onUnexpectedError)(D)}}}}t.EventDeliveryQueue=a;class l extends a{clear(m){this.c.clear()}}class p{constructor(m,D,R){this.emitter=m,this.listener=D,this.event=R}}class k extends r{async fireAsync(m,D,R){if(!!this.q){this.c||(this.c=new U.LinkedList);for(const V of this.q)this.c.push([V,m]);for(;this.c.size>0&&!D.isCancellationRequested;){const[V,Z]=this.c.shift(),X=[],x={...Z,token:D,waitUntil:ne=>{if(Object.isFrozen(X))throw new Error("waitUntil can NOT be called asynchronous");R&&(ne=R(ne,V.callback)),X.push(ne)}};try{V.invoke(x)}catch(ne){(0,v.onUnexpectedError)(ne);continue}Object.freeze(X),await Promise.allSettled(X).then(ne=>{for(const le of ne)le.status==="rejected"&&(0,v.onUnexpectedError)(le.reason)})}}}}t.AsyncEmitter=k;class S extends r{constructor(m){super(m),this.h=0,this.s=new U.LinkedList,this.t=m?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const m=Array.from(this.s);this.s.clear(),super.fire(this.t(m))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(m){this.q&&(this.h!==0?this.s.push(m):super.fire(m))}}t.PauseableEmitter=S;class g extends S{constructor(m){super(m),this.c=m.delay??100}fire(m){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(m)}}t.DebounceEmitter=g;class E extends r{constructor(m){super(m),this.c=[],this.h=m?.merge}fire(m){!this.hasListeners()||(this.c.push(m),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(D=>super.fire(D)),this.c=[]}))}}t.MicrotaskEmitter=E;class N{constructor(){this.d=!1,this.f=[],this.c=new r({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(m){const D={event:m,listener:null};this.f.push(D),this.d&&this.j(D);const R=()=>{this.d&&this.k(D);const V=this.f.indexOf(D);this.f.splice(V,1)};return(0,z.toDisposable)((0,i.once)(R))}g(){this.d=!0,this.f.forEach(m=>this.j(m))}h(){this.d=!1,this.f.forEach(m=>this.k(m))}j(m){m.listener=m.event(D=>this.c.fire(D))}k(m){m.listener&&m.listener.dispose(),m.listener=null}dispose(){this.c.dispose()}}t.EventMultiplexer=N;class F{constructor(){this.c=[]}wrapEvent(m){return(D,R,V)=>m(Z=>{const X=this.c[this.c.length-1];X?X.push(()=>D.call(R,Z)):D.call(R,Z)},void 0,V)}bufferEvents(m){const D=[];this.c.push(D);const R=m();return this.c.pop(),D.forEach(V=>V()),R}}t.EventBufferer=F;class d{constructor(){this.c=!1,this.d=c.None,this.f=z.Disposable.None,this.g=new r({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(m){this.d=m,this.c&&(this.f.dispose(),this.f=m(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}t.Relay=d}),define(me[17],be([1,0,3,2]),function(J,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isWCOEnabled=t.isStandalone=t.isAndroid=t.isElectron=t.isWebkitWebView=t.isSafari=t.isChrome=t.isWebKit=t.isFirefox=t.onDidChangeFullscreen=t.isFullscreen=t.setFullscreen=t.setZoomFactor=t.getZoomFactor=t.getZoomLevel=t.setZoomLevel=t.PixelRatio=t.addMatchMediaChangeListener=void 0;class z{constructor(){this.a=0,this.b=1,this.c=!1,this.d=new v.Emitter,this.onDidChangeFullscreen=this.d.event}getZoomLevel(){return this.a}setZoomLevel(k,S){this.a!==k&&(this.a=k)}getZoomFactor(){return this.b}setZoomFactor(k){this.b=k}setFullscreen(k){this.c!==k&&(this.c=k,this.d.fire())}isFullscreen(){return this.c}}z.INSTANCE=new z;class U extends i.Disposable{constructor(){super(),this.a=this.B(new v.Emitter),this.onDidChange=this.a.event,this.b=()=>this.f(!0),this.c=null,this.f(!1)}f(k){this.c?.removeEventListener("change",this.b),this.c=window.matchMedia(`(resolution: ${window.devicePixelRatio}dppx)`),this.c.addEventListener("change",this.b),k&&this.a.fire()}}class y extends i.Disposable{get value(){return this.b}constructor(){super(),this.a=this.B(new v.Emitter),this.onDidChange=this.a.event,this.b=this.c();const k=this.B(new U);this.B(k.onDidChange(()=>{this.b=this.c(),this.a.fire(this.b)}))}c(){const k=document.createElement("canvas").getContext("2d"),S=window.devicePixelRatio||1,g=k.webkitBackingStorePixelRatio||k.mozBackingStorePixelRatio||k.msBackingStorePixelRatio||k.oBackingStorePixelRatio||k.backingStorePixelRatio||1;return S/g}}class b{constructor(){this.a=null}b(){return this.a||(this.a=(0,i.markAsSingleton)(new y)),this.a}get value(){return this.b().value}get onDidChange(){return this.b().onDidChange}}function u(p,k){typeof p=="string"&&(p=window.matchMedia(p)),p.addEventListener("change",k)}t.addMatchMediaChangeListener=u,t.PixelRatio=new b;function c(p,k){z.INSTANCE.setZoomLevel(p,k)}t.setZoomLevel=c;function f(){return z.INSTANCE.getZoomLevel()}t.getZoomLevel=f;function I(){return z.INSTANCE.getZoomFactor()}t.getZoomFactor=I;function o(p){z.INSTANCE.setZoomFactor(p)}t.setZoomFactor=o;function n(p){z.INSTANCE.setFullscreen(p)}t.setFullscreen=n;function e(){return z.INSTANCE.isFullscreen()}t.isFullscreen=e,t.onDidChangeFullscreen=z.INSTANCE.onDidChangeFullscreen;const s=navigator.userAgent;t.isFirefox=s.indexOf("Firefox")>=0,t.isWebKit=s.indexOf("AppleWebKit")>=0,t.isChrome=s.indexOf("Chrome")>=0,t.isSafari=!t.isChrome&&s.indexOf("Safari")>=0,t.isWebkitWebView=!t.isChrome&&!t.isSafari&&t.isWebKit,t.isElectron=s.indexOf("Electron/")>=0,t.isAndroid=s.indexOf("Android")>=0;let r=!1;if(window.matchMedia){const p=window.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),k=window.matchMedia("(display-mode: fullscreen)");r=p.matches,u(p,({matches:S})=>{r&&k.matches||(r=S)})}function a(){return r}t.isStandalone=a;function l(){return navigator?.windowControlsOverlay?.visible}t.isWCOEnabled=l}),define(me[108],be([1,0,17,5]),function(J,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BrowserFeatures=t.KeyboardSupport=void 0;var z;(function(U){U[U.Always=0]="Always",U[U.FullScreen=1]="FullScreen",U[U.None=2]="None"})(z=t.KeyboardSupport||(t.KeyboardSupport={})),t.BrowserFeatures={clipboard:{writeText:i.isNative||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:i.isNative||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>i.isNative||v.isStandalone()?0:navigator.keyboard||v.isSafari?1:2)(),touch:"ontouchstart"in window||navigator.maxTouchPoints>0,pointerEvents:window.PointerEvent&&("ontouchstart"in window||window.navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define(me[19],be([1,0,3]),function(J,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomEmitter=void 0;class i{get event(){return this.a.event}constructor(U,y,b){const u=c=>this.a.fire(c);this.a=new v.Emitter({onWillAddFirstListener:()=>U.addEventListener(y,u,b),onDidRemoveLastListener:()=>U.removeEventListener(y,u,b)})}dispose(){this.a.dispose()}}t.DomEmitter=i}),define(me[15],be([1,0,17,43,74,5]),function(J,t,v,i,z,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardKeyboardEvent=t.printStandardKeyboardEvent=t.printKeyboardEvent=void 0;function y(e){if(e.charCode){const r=String.fromCharCode(e.charCode).toUpperCase();return i.KeyCodeUtils.fromString(r)}const s=e.keyCode;if(s===3)return 7;if(v.isFirefox){if(s===59)return 80;if(s===107)return 81;if(s===109)return 83;if(U.isMacintosh&&s===224)return 57}else if(v.isWebKit){if(s===91)return 57;if(U.isMacintosh&&s===93)return 57;if(!U.isMacintosh&&s===92)return 57}return i.EVENT_KEY_CODE_MAP[s]||0}const b=U.isMacintosh?256:2048,u=512,c=1024,f=U.isMacintosh?2048:256;function I(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.printKeyboardEvent=I;function o(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${i.KeyCodeUtils.toString(e.keyCode)}')`}t.printStandardKeyboardEvent=o;class n{constructor(s){this._standardKeyboardEventBrand=!0;const r=s;this.browserEvent=r,this.target=r.target,this.ctrlKey=r.ctrlKey,this.shiftKey=r.shiftKey,this.altKey=r.altKey,this.metaKey=r.metaKey,this.altGraphKey=r.getModifierState("AltGraph"),this.keyCode=y(r),this.code=r.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeybinding(){return this.b}equals(s){return this.a===s}c(){let s=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode);let r=0;return this.ctrlKey&&(r|=b),this.altKey&&(r|=u),this.shiftKey&&(r|=c),this.metaKey&&(r|=f),r|=s,r}d(){let s=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode),new z.SimpleKeybinding(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,s)}}t.StandardKeyboardEvent=n}),define(me[20],be([1,0,17,67,5]),function(J,t,v,i,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardWheelEvent=t.DragMouseEvent=t.StandardMouseEvent=void 0;class U{constructor(c){this.timestamp=Date.now(),this.browserEvent=c,this.leftButton=c.button===0,this.middleButton=c.button===1,this.rightButton=c.button===2,this.buttons=c.buttons,this.target=c.target,this.detail=c.detail||1,c.type==="dblclick"&&(this.detail=2),this.ctrlKey=c.ctrlKey,this.shiftKey=c.shiftKey,this.altKey=c.altKey,this.metaKey=c.metaKey,typeof c.pageX=="number"?(this.posx=c.pageX,this.posy=c.pageY):(this.posx=c.clientX+document.body.scrollLeft+document.documentElement.scrollLeft,this.posy=c.clientY+document.body.scrollTop+document.documentElement.scrollTop);const f=i.IframeUtils.getPositionOfChildWindowRelativeToAncestorWindow(self,c.view);this.posx-=f.left,this.posy-=f.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.StandardMouseEvent=U;class y extends U{constructor(c){super(c),this.dataTransfer=c.dataTransfer}}t.DragMouseEvent=y;class b{constructor(c,f=0,I=0){if(this.browserEvent=c||null,this.target=c?c.target||c.targetNode||c.srcElement:null,this.deltaY=I,this.deltaX=f,c){const o=c,n=c;if(typeof o.wheelDeltaY<"u")this.deltaY=o.wheelDeltaY/120;else if(typeof n.VERTICAL_AXIS<"u"&&n.axis===n.VERTICAL_AXIS)this.deltaY=-n.detail/3;else if(c.type==="wheel"){const e=c;e.deltaMode===e.DOM_DELTA_LINE?v.isFirefox&&!z.isMacintosh?this.deltaY=-c.deltaY/3:this.deltaY=-c.deltaY:this.deltaY=-c.deltaY/40}if(typeof o.wheelDeltaX<"u")v.isSafari&&z.isWindows?this.deltaX=-(o.wheelDeltaX/120):this.deltaX=o.wheelDeltaX/120;else if(typeof n.HORIZONTAL_AXIS<"u"&&n.axis===n.HORIZONTAL_AXIS)this.deltaX=-c.detail/3;else if(c.type==="wheel"){const e=c;e.deltaMode===e.DOM_DELTA_LINE?v.isFirefox&&!z.isMacintosh?this.deltaX=-c.deltaX/3:this.deltaX=-c.deltaX:this.deltaX=-c.deltaX/40}this.deltaY===0&&this.deltaX===0&&c.wheelDelta&&(this.deltaY=c.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.StandardWheelEvent=b}),define(me[31],be([1,0,3,2,103]),function(J,t,v,i,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toAction=t.EmptySubmenuAction=t.SubmenuAction=t.Separator=t.ActionRunner=t.Action=void 0;class U extends i.Disposable{constructor(o,n="",e="",s=!0,r){super(),this.h=this.B(new v.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=o,this.m=n,this.u=e,this.w=s,this.C=r}get id(){return this.j}get label(){return this.m}set label(o){this.D(o)}D(o){this.m!==o&&(this.m=o,this.h.fire({label:o}))}get tooltip(){return this.n||""}set tooltip(o){this.F(o)}F(o){this.n!==o&&(this.n=o,this.h.fire({tooltip:o}))}get class(){return this.u}set class(o){this.G(o)}G(o){this.u!==o&&(this.u=o,this.h.fire({class:o}))}get enabled(){return this.w}set enabled(o){this.H(o)}H(o){this.w!==o&&(this.w=o,this.h.fire({enabled:o}))}get checked(){return this.z}set checked(o){this.I(o)}I(o){this.z!==o&&(this.z=o,this.h.fire({checked:o}))}async run(o,n){this.C&&await this.C(o)}}t.Action=U;class y extends i.Disposable{constructor(){super(...arguments),this.f=this.B(new v.Emitter),this.onWillRun=this.f.event,this.h=this.B(new v.Emitter),this.onDidRun=this.h.event}async run(o,n){if(!o.enabled)return;this.f.fire({action:o});let e;try{await this.runAction(o,n)}catch(s){e=s}this.h.fire({action:o,error:e})}async runAction(o,n){await o.run(n)}}t.ActionRunner=y;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...o){let n=[];for(const e of o)e.length&&(n.length?n=[...n,new b,...e]:n=e);return n}async run(){}}t.Separator=b,b.ID="vs.actions.separator";class u{get actions(){return this.a}constructor(o,n,e,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=o,this.label=n,this.class=s,this.a=e}async run(){}}t.SubmenuAction=u;class c extends U{constructor(){super(c.ID,z.localize(0,null),void 0,!1)}}t.EmptySubmenuAction=c,c.ID="vs.actions.empty";function f(I){return{id:I.id,label:I.label,class:void 0,enabled:I.enabled??!0,checked:I.checked??!1,run:async()=>I.run(),tooltip:I.label}}t.toAction=f}),define(me[26],be([1,0,3]),function(J,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const i=Object.freeze(function(b,u){const c=setTimeout(b.bind(u),0);return{dispose(){clearTimeout(c)}}});var z;(function(b){function u(c){return c===b.None||c===b.Cancelled||c instanceof U?!0:!c||typeof c!="object"?!1:typeof c.isCancellationRequested=="boolean"&&typeof c.onCancellationRequested=="function"}b.isCancellationToken=u,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(z=t.CancellationToken||(t.CancellationToken={}));class U{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?i:(this.b||(this.b=new v.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class y{constructor(u){this.a=void 0,this.b=void 0,this.b=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new U),this.a}cancel(){this.a?this.a instanceof U&&this.a.cancel():this.a=z.Cancelled}dispose(u=!1){u&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof U&&this.a.dispose():this.a=z.None}}t.CancellationTokenSource=y}),define(me[109],be([1,0,26]),function(J,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class i{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new v.CancellationTokenSource,u=this.b(b.token);return this.a={promise:u,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}t.Cache=i;class z{constructor(b){this.c=b,this.a=void 0,this.b=void 0}get(b){const u=JSON.stringify(b);return this.b!==u&&(this.b=u,this.a=this.c(b)),this.a}}t.LRUCachedFunction=z;class U{get cachedValues(){return this.a}constructor(b){this.b=b,this.a=new Map}get(b){if(this.a.has(b))return this.a.get(b);const u=this.b(b);return this.a.set(b,u),u}}t.CachedFunction=U}),define(me[49],be([1,0,3,2]),function(J,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SmoothScrollingOperation=t.SmoothScrollingUpdate=t.Scrollable=t.ScrollState=t.ScrollbarVisibility=void 0;var z;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(z=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));class U{constructor(e,s,r,a,l,p,k){this.c=e,this._scrollStateBrand=void 0,this.c&&(s=s|0,r=r|0,a=a|0,l=l|0,p=p|0,k=k|0),this.rawScrollLeft=a,this.rawScrollTop=k,s<0&&(s=0),a+s>r&&(a=r-s),a<0&&(a=0),l<0&&(l=0),k+l>p&&(k=p-l),k<0&&(k=0),this.width=s,this.scrollWidth=r,this.scrollLeft=a,this.height=l,this.scrollHeight=p,this.scrollTop=k}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,s){return new U(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,s?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,s?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new U(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,s){const r=this.width!==e.width,a=this.scrollWidth!==e.scrollWidth,l=this.scrollLeft!==e.scrollLeft,p=this.height!==e.height,k=this.scrollHeight!==e.scrollHeight,S=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:s,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:r,scrollWidthChanged:a,scrollLeftChanged:l,heightChanged:p,scrollHeightChanged:k,scrollTopChanged:S}}}t.ScrollState=U;class y extends i.Disposable{constructor(e){super(),this._scrollableBrand=void 0,this.i=this.B(new v.Emitter),this.onScroll=this.i.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new U(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,s){const r=this.g.withScrollDimensions(e,s);this.k(r,Boolean(this.h)),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const s=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.k(s,!1)}setScrollPositionSmooth(e,s){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const r=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===r.scrollLeft&&this.h.to.scrollTop===r.scrollTop)return;let a;s?a=new f(this.h.from,r,this.h.startTime,this.h.duration):a=this.h.combine(this.g,r,this.c),this.h.dispose(),this.h=a}else{const r=this.g.withScrollPosition(e);this.h=f.start(this.g,r,this.c)}this.h.animationFrameDisposable=this.f(()=>{!this.h||(this.h.animationFrameDisposable=null,this.j())})}j(){if(!this.h)return;const e=this.h.tick(),s=this.g.withScrollPosition(e);if(this.k(s,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{!this.h||(this.h.animationFrameDisposable=null,this.j())})}}k(e,s){const r=this.g;r.equals(e)||(this.g=e,this.i.fire(this.g.createScrollEvent(r,s)))}}t.Scrollable=y;class b{constructor(e,s,r){this.scrollLeft=e,this.scrollTop=s,this.isDone=r}}t.SmoothScrollingUpdate=b;function u(n,e){const s=e-n;return function(r){return n+s*o(r)}}function c(n,e,s){return function(r){return r<s?n(r/s):e((r-s)/(1-s))}}class f{constructor(e,s,r,a){this.from=e,this.to=s,this.duration=a,this.startTime=r,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,s,r){if(Math.abs(e-s)>2.5*r){let l,p;return e<s?(l=e+.75*r,p=s-.75*r):(l=e-.75*r,p=s+.75*r),c(u(e,l),u(p,s),.33)}return u(e,s)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const s=(e-this.startTime)/this.duration;if(s<1){const r=this.c(s),a=this.d(s);return new b(r,a,!1)}return new b(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,s,r){return f.start(e,s,r)}static start(e,s,r){r=r+10;const a=Date.now()-10;return new f(e,s,a,r)}}t.SmoothScrollingOperation=f;function I(n){return Math.pow(n,3)}function o(n){return 1-I(1-n)}}),define(me[11],be([1,0,109,44]),function(J,t,v,i){"use strict";var z;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.charCount=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function U(K){return!K||typeof K!="string"?!0:K.trim().length===0}t.isFalsyOrWhitespace=U;const y=/{(\d+)}/g;function b(K,...ue){return ue.length===0?K:K.replace(y,function(pe,Ee){const Fe=parseInt(Ee,10);return isNaN(Fe)||Fe<0||Fe>=ue.length?pe:ue[Fe]})}t.format=b;const u=/{([^}]+)}/g;function c(K,ue){return K.replace(u,(pe,Ee)=>ue[Ee]??pe)}t.format2=c;function f(K){return K.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}t.escape=f;function I(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=I;function o(K,ue){let pe=0;const Ee=ue.charCodeAt(0);for(let Fe=K.length-1;Fe>=0;Fe--)K.charCodeAt(Fe)===Ee&&pe++;return pe}t.count=o;function n(K,ue,pe="\u2026"){return K.length<=ue?K:`${K.substr(0,ue)}${pe}`}t.truncate=n;function e(K,ue=" "){const pe=s(K,ue);return r(pe,ue)}t.trim=e;function s(K,ue){if(!K||!ue)return K;const pe=ue.length;if(pe===0||K.length===0)return K;let Ee=0;for(;K.indexOf(ue,Ee)===Ee;)Ee=Ee+pe;return K.substring(Ee)}t.ltrim=s;function r(K,ue){if(!K||!ue)return K;const pe=ue.length,Ee=K.length;if(pe===0||Ee===0)return K;let Fe=Ee,Oe=-1;for(;Oe=K.lastIndexOf(ue,Fe-1),!(Oe===-1||Oe+pe!==Fe);){if(Oe===0)return"";Fe=Oe}return K.substring(0,Fe)}t.rtrim=r;function a(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=a;function l(K){return K.replace(/\*/g,"")}t.stripWildcards=l;function p(K,ue,pe={}){if(!K)throw new Error("Cannot create regex from empty string");ue||(K=I(K)),pe.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let Ee="";return pe.global&&(Ee+="g"),pe.matchCase||(Ee+="i"),pe.multiline&&(Ee+="m"),pe.unicode&&(Ee+="u"),new RegExp(K,Ee)}t.createRegExp=p;function k(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}t.regExpLeadsToEndlessLoop=k;function S(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=S;function g(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}t.regExpFlags=g;function E(K){return K.split(/\r\n|\r|\n/)}t.splitLines=E;function N(K){for(let ue=0,pe=K.length;ue<pe;ue++){const Ee=K.charCodeAt(ue);if(Ee!==32&&Ee!==9)return ue}return-1}t.firstNonWhitespaceIndex=N;function F(K,ue=0,pe=K.length){for(let Ee=ue;Ee<pe;Ee++){const Fe=K.charCodeAt(Ee);if(Fe!==32&&Fe!==9)return K.substring(ue,Ee)}return K.substring(ue,pe)}t.getLeadingWhitespace=F;function d(K,ue=K.length-1){for(let pe=ue;pe>=0;pe--){const Ee=K.charCodeAt(pe);if(Ee!==32&&Ee!==9)return pe}return-1}t.lastNonWhitespaceIndex=d;function w(K,ue,pe){const Ee=[];let Fe=0;for(const Oe of K.matchAll(ue)){if(Ee.push(K.slice(Fe,Oe.index)),Oe.index===void 0)throw new Error("match.index should be defined");Fe=Oe.index+Oe[0].length,Ee.push(pe(Oe[0],...Oe.slice(1),Oe.index,K,Oe.groups))}return Ee.push(K.slice(Fe)),Promise.all(Ee).then(Oe=>Oe.join(""))}t.replaceAsync=w;function m(K,ue){return K<ue?-1:K>ue?1:0}t.compare=m;function D(K,ue,pe=0,Ee=K.length,Fe=0,Oe=ue.length){for(;pe<Ee&&Fe<Oe;pe++,Fe++){const Me=K.charCodeAt(pe),ae=ue.charCodeAt(Fe);if(Me<ae)return-1;if(Me>ae)return 1}const $e=Ee-pe,tt=Oe-Fe;return $e<tt?-1:$e>tt?1:0}t.compareSubstring=D;function R(K,ue){return V(K,ue,0,K.length,0,ue.length)}t.compareIgnoreCase=R;function V(K,ue,pe=0,Ee=K.length,Fe=0,Oe=ue.length){for(;pe<Ee&&Fe<Oe;pe++,Fe++){let Me=K.charCodeAt(pe),ae=ue.charCodeAt(Fe);if(Me===ae)continue;if(Me>=128||ae>=128)return D(K.toLowerCase(),ue.toLowerCase(),pe,Ee,Fe,Oe);X(Me)&&(Me-=32),X(ae)&&(ae-=32);const Ce=Me-ae;if(Ce!==0)return Ce}const $e=Ee-pe,tt=Oe-Fe;return $e<tt?-1:$e>tt?1:0}t.compareSubstringIgnoreCase=V;function Z(K){return K>=48&&K<=57}t.isAsciiDigit=Z;function X(K){return K>=97&&K<=122}t.isLowerAsciiLetter=X;function x(K){return K>=65&&K<=90}t.isUpperAsciiLetter=x;function ne(K,ue){return K.length===ue.length&&V(K,ue)===0}t.equalsIgnoreCase=ne;function le(K,ue){const pe=ue.length;return ue.length>K.length?!1:V(K,ue,0,pe)===0}t.startsWithIgnoreCase=le;function se(K,ue){const pe=Math.min(K.length,ue.length);let Ee;for(Ee=0;Ee<pe;Ee++)if(K.charCodeAt(Ee)!==ue.charCodeAt(Ee))return Ee;return pe}t.commonPrefixLength=se;function fe(K,ue){const pe=Math.min(K.length,ue.length);let Ee;const Fe=K.length-1,Oe=ue.length-1;for(Ee=0;Ee<pe;Ee++)if(K.charCodeAt(Fe-Ee)!==ue.charCodeAt(Oe-Ee))return Ee;return pe}t.commonSuffixLength=fe;function Ae(K){return 55296<=K&&K<=56319}t.isHighSurrogate=Ae;function te(K){return 56320<=K&&K<=57343}t.isLowSurrogate=te;function ve(K,ue){return(K-55296<<10)+(ue-56320)+65536}t.computeCodePoint=ve;function Ne(K,ue,pe){const Ee=K.charCodeAt(pe);if(Ae(Ee)&&pe+1<ue){const Fe=K.charCodeAt(pe+1);if(te(Fe))return ve(Ee,Fe)}return Ee}t.getNextCodePoint=Ne;function he(K,ue){const pe=K.charCodeAt(ue-1);if(te(pe)&&ue>1){const Ee=K.charCodeAt(ue-2);if(Ae(Ee))return ve(Ee,pe)}return pe}class Q{get offset(){return this.e}constructor(ue,pe=0){this.c=ue,this.d=ue.length,this.e=pe}setOffset(ue){this.e=ue}prevCodePoint(){const ue=he(this.c,this.e);return this.e-=ue>=65536?2:1,ue}nextCodePoint(){const ue=Ne(this.c,this.d,this.e);return this.e+=ue>=65536?2:1,ue}eol(){return this.e>=this.d}}t.CodePointIterator=Q;class oe{get offset(){return this.c.offset}constructor(ue,pe=0){this.c=new Q(ue,pe)}nextGraphemeLength(){const ue=Ke.getInstance(),pe=this.c,Ee=pe.offset;let Fe=ue.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Oe=pe.offset,$e=ue.getGraphemeBreakType(pe.nextCodePoint());if(Re(Fe,$e)){pe.setOffset(Oe);break}Fe=$e}return pe.offset-Ee}prevGraphemeLength(){const ue=Ke.getInstance(),pe=this.c,Ee=pe.offset;let Fe=ue.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Oe=pe.offset,$e=ue.getGraphemeBreakType(pe.prevCodePoint());if(Re($e,Fe)){pe.setOffset(Oe);break}Fe=$e}return Ee-pe.offset}eol(){return this.c.eol()}}t.GraphemeIterator=oe;function re(K,ue){return new oe(K,ue).nextGraphemeLength()}t.nextCharLength=re;function ie(K,ue){return new oe(K,ue).prevGraphemeLength()}t.prevCharLength=ie;function A(K,ue){ue>0&&te(K.charCodeAt(ue))&&ue--;const pe=ue+re(K,ue);return[pe-ie(K,pe),pe]}t.getCharContainingOffset=A;function C(K){const ue=new oe(K);let pe=0;for(;!ue.eol();)pe++,ue.nextGraphemeLength();return pe}t.charCount=C;let h;function B(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function _(K){return h||(h=B()),h.test(K)}t.containsRTL=_;const $=/^[\t\n\r\x20-\x7E]*$/;function Y(K){return $.test(K)}t.isBasicASCII=Y,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function T(K){return t.UNUSUAL_LINE_TERMINATORS.test(K)}t.containsUnusualLineTerminators=T;function H(K){return K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}t.isFullWidthCharacter=H;function W(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129008||K>=129280&&K<=129535||K>=129648&&K<=129782}t.isEmojiImprecise=W;function L(K,ue){if(K.length<ue)return K;const pe=/\b/g;let Ee=0;for(;pe.test(K)&&!(K.length-pe.lastIndex<ue);)Ee=pe.lastIndex,pe.lastIndex+=1;return K.substring(Ee).replace(/^\s/,"")}t.lcut=L;const M=/\x1B\x5B[12]?K/g,P=/\x1b\[\d+m/g,O=/\x1b\[0?m/g;function j(K){return K&&(K=K.replace(M,""),K=K.replace(P,""),K=K.replace(O,"")),K}t.removeAnsiEscapeCodes=j,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ee(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}t.startsWithUTF8BOM=ee;function ce(K){return ee(K)?K.substr(1):K}t.stripUTF8BOM=ce;function de(K,ue){if(!K||!ue||K.length<ue.length)return!1;const pe=ue.length,Ee=K.toLowerCase();let Fe=0,Oe=-1;for(;Fe<pe;){const $e=Ee.indexOf(ue[Fe],Oe+1);if($e<0)return!1;Oe=$e,Fe++}return!0}t.fuzzyContains=de;function De(K,ue=!1){return K?(ue&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}t.containsUppercaseCharacter=De;function ye(K){return K.charAt(0).toUpperCase()+K.slice(1)}t.uppercaseFirstLetter=ye;function Ie(K,ue=1){if(ue===0)return"";let pe=-1;do pe=K.indexOf(`
`,pe+1),ue--;while(ue>0&&pe>=0);return pe===-1?K:(K[pe-1]==="\r"&&pe--,K.substr(0,pe))}t.getNLines=Ie;function Se(K){return K=K%(2*26),K<26?String.fromCharCode(97+K):String.fromCharCode(65+K-26)}t.singleLetterHash=Se;function we(K){return Ke.getInstance().getGraphemeBreakType(K)}t.getGraphemeBreakType=we;function Re(K,ue){return K===0?ue!==5&&ue!==7:K===2&&ue===3?!1:K===4||K===2||K===3||ue===4||ue===2||ue===3?!0:!(K===8&&(ue===8||ue===9||ue===11||ue===12)||(K===11||K===9)&&(ue===9||ue===10)||(K===12||K===10)&&ue===10||ue===5||ue===13||ue===7||K===1||K===13&&ue===14||K===6&&ue===6)}var Pe;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(Pe=t.GraphemeBreakType||(t.GraphemeBreakType={}));class Ke{static getInstance(){return Ke.c||(Ke.c=new Ke),Ke.c}constructor(){this.d=Ue()}getGraphemeBreakType(ue){if(ue<32)return ue===10?3:ue===13?2:4;if(ue<127)return 0;const pe=this.d,Ee=pe.length/3;let Fe=1;for(;Fe<=Ee;)if(ue<pe[3*Fe])Fe=2*Fe;else if(ue>pe[3*Fe+1])Fe=2*Fe+1;else return pe[3*Fe+2];return 0}}Ke.c=null;function Ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function We(K,ue){if(K===0)return 0;const pe=xe(K,ue);if(pe!==void 0)return pe;const Ee=new Q(ue,K);return Ee.prevCodePoint(),Ee.offset}t.getLeftDeleteOffset=We;function xe(K,ue){const pe=new Q(ue,K);let Ee=pe.prevCodePoint();for(;it(Ee)||Ee===65039||Ee===8419;){if(pe.offset===0)return;Ee=pe.prevCodePoint()}if(!W(Ee))return;let Fe=pe.offset;return Fe>0&&pe.prevCodePoint()===8205&&(Fe=pe.offset),Fe}function it(K){return 127995<=K&&K<=127999}var Be;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(Be||(Be={})),t.noBreakWhitespace="\xA0";class je{static getInstance(ue){return je.d.get(Array.from(ue))}static getLocales(){return je.e.getValue()}constructor(ue){this.f=ue}isAmbiguous(ue){return this.f.has(ue)}getPrimaryConfusable(ue){return this.f.get(ue)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.AmbiguousCharacters=je,z=je,je.c=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),je.d=new v.LRUCachedFunction(K=>{function ue(ae){const Ce=new Map;for(let Le=0;Le<ae.length;Le+=2)Ce.set(ae[Le],ae[Le+1]);return Ce}function pe(ae,Ce){const Le=new Map(ae);for(const[ze,Ge]of Ce)Le.set(ze,Ge);return Le}function Ee(ae,Ce){if(!ae)return Ce;const Le=new Map;for(const[ze,Ge]of ae)Ce.has(ze)&&Le.set(ze,Ge);return Le}const Fe=z.c.getValue();let Oe=K.filter(ae=>!ae.startsWith("_")&&ae in Fe);Oe.length===0&&(Oe=["_default"]);let $e;for(const ae of Oe){const Ce=ue(Fe[ae]);$e=Ee($e,Ce)}const tt=ue(Fe._common),Me=pe(tt,$e);return new je(Me)}),je.e=new i.Lazy(()=>Object.keys(je.c.getValue()).filter(K=>!K.startsWith("_")));class Ye{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ye.c())),this.d}static isInvisibleCharacter(ue){return Ye.e().has(ue)}static get codePoints(){return Ye.e()}}t.InvisibleCharacters=Ye,Ye.d=void 0}),define(me[110],be([1,0,21,5,11,6]),function(J,t,v,i,z,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.randomPath=t.parseLineAndColumnAware=t.indexOfPath=t.getDriveLetter=t.hasDriveLetter=t.isRootOrDriveLetter=t.sanitizeFilePath=t.isWindowsDriveLetter=t.isEqualOrParent=t.isEqual=t.isValidBasename=t.isUNC=t.getRoot=t.toPosixPath=t.toSlashes=t.isPathSeparator=void 0;function y(d){return d===47||d===92}t.isPathSeparator=y;function b(d){return d.replace(/[\\/]/g,v.posix.sep)}t.toSlashes=b;function u(d){return d.indexOf("/")===-1&&(d=b(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}t.toPosixPath=u;function c(d,w=v.posix.sep){if(!d)return"";const m=d.length,D=d.charCodeAt(0);if(y(D)){if(y(d.charCodeAt(1))&&!y(d.charCodeAt(2))){let V=3;const Z=V;for(;V<m&&!y(d.charCodeAt(V));V++);if(Z!==V&&!y(d.charCodeAt(V+1))){for(V+=1;V<m;V++)if(y(d.charCodeAt(V)))return d.slice(0,V+1).replace(/[\\/]/g,w)}}return w}else if(a(D)&&d.charCodeAt(1)===58)return y(d.charCodeAt(2))?d.slice(0,2)+w:d.slice(0,2);let R=d.indexOf("://");if(R!==-1){for(R+=3;R<m;R++)if(y(d.charCodeAt(R)))return d.slice(0,R+1)}return""}t.getRoot=c;function f(d){if(!i.isWindows||!d||d.length<5)return!1;let w=d.charCodeAt(0);if(w!==92||(w=d.charCodeAt(1),w!==92))return!1;let m=2;const D=m;for(;m<d.length&&(w=d.charCodeAt(m),w!==92);m++);return!(D===m||(w=d.charCodeAt(m+1),isNaN(w)||w===92))}t.isUNC=f;const I=/[\\/:\*\?"<>\|]/g,o=/[\\/]/g,n=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(d,w=i.isWindows){const m=w?I:o;return!(!d||d.length===0||/^\s+$/.test(d)||(m.lastIndex=0,m.test(d))||w&&n.test(d)||d==="."||d===".."||w&&d[d.length-1]==="."||w&&d.length!==d.trim().length||d.length>255)}t.isValidBasename=e;function s(d,w,m){const D=d===w;return!m||D?D:!d||!w?!1:(0,z.equalsIgnoreCase)(d,w)}t.isEqual=s;function r(d,w,m,D=v.sep){if(d===w)return!0;if(!d||!w||w.length>d.length)return!1;if(m){if(!(0,z.startsWithIgnoreCase)(d,w))return!1;if(w.length===d.length)return!0;let V=w.length;return w.charAt(w.length-1)===D&&V--,d.charAt(V)===D}return w.charAt(w.length-1)!==D&&(w+=D),d.indexOf(w)===0}t.isEqualOrParent=r;function a(d){return d>=65&&d<=90||d>=97&&d<=122}t.isWindowsDriveLetter=a;function l(d,w){return i.isWindows&&d.endsWith(":")&&(d+=v.sep),(0,v.isAbsolute)(d)||(d=(0,v.join)(w,d)),d=(0,v.normalize)(d),i.isWindows?(d=(0,z.rtrim)(d,v.sep),d.endsWith(":")&&(d+=v.sep)):(d=(0,z.rtrim)(d,v.sep),d||(d=v.sep)),d}t.sanitizeFilePath=l;function p(d){const w=(0,v.normalize)(d);return i.isWindows?d.length>3?!1:k(w)&&(d.length===2||w.charCodeAt(2)===92):w===v.posix.sep}t.isRootOrDriveLetter=p;function k(d,w=i.isWindows){return w?a(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}t.hasDriveLetter=k;function S(d){return k(d)?d[0]:void 0}t.getDriveLetter=S;function g(d,w,m){return w.length>d.length?-1:d===w?0:(m&&(d=d.toLowerCase(),w=w.toLowerCase()),d.indexOf(w))}t.indexOfPath=g;function E(d){const w=d.split(":");let m,D,R;for(const V of w){const Z=Number(V);(0,U.isNumber)(Z)?D===void 0?D=Z:R===void 0&&(R=Z):m=m?[m,V].join(":"):V}if(!m)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:m,line:D!==void 0?D:void 0,column:R!==void 0?R:D!==void 0?1:void 0}}t.parseLineAndColumnAware=E;const N="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function F(d,w,m=8){let D="";for(let V=0;V<m;V++)D+=N.charAt(Math.floor(Math.random()*N.length));let R;return w?R=`${w}-${D}`:R=D,d?(0,v.join)(d,R):R}t.randomPath=F}),define(me[32],be([1,0,75,11]),function(J,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fuzzyScoreGraceful=t.fuzzyScoreGracefulAggressive=t.fuzzyScore=t.FuzzyScoreOptions=t.FuzzyScore=t.isPatternInWord=t.createMatches=t.anyScore=t.matchesFuzzy2=t.matchesFuzzy=t.matchesWords=t.matchesCamelCase=t.isUpper=t.matchesSubString=t.matchesContiguousSubString=t.matchesPrefix=t.matchesStrictPrefix=t.or=void 0;function z(...P){return function(O,j){for(let ee=0,ce=P.length;ee<ce;ee++){const de=P[ee](O,j);if(de)return de}return null}}t.or=z,t.matchesStrictPrefix=U.bind(void 0,!1),t.matchesPrefix=U.bind(void 0,!0);function U(P,O,j){if(!j||j.length<O.length)return null;let ee;return P?ee=i.startsWithIgnoreCase(j,O):ee=j.indexOf(O)===0,ee?O.length>0?[{start:0,end:O.length}]:[]:null}function y(P,O){const j=O.toLowerCase().indexOf(P.toLowerCase());return j===-1?null:[{start:j,end:j+P.length}]}t.matchesContiguousSubString=y;function b(P,O){return u(P.toLowerCase(),O.toLowerCase(),0,0)}t.matchesSubString=b;function u(P,O,j,ee){if(j===P.length)return[];if(ee===O.length)return null;if(P[j]===O[ee]){let ce=null;return(ce=u(P,O,j+1,ee+1))?a({start:ee,end:ee+1},ce):null}return u(P,O,j,ee+1)}function c(P){return 97<=P&&P<=122}function f(P){return 65<=P&&P<=90}t.isUpper=f;function I(P){return 48<=P&&P<=57}function o(P){return P===32||P===9||P===10||P===13}const n=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(P=>n.add(P.charCodeAt(0)));function e(P){return o(P)||n.has(P)}function s(P,O){return P===O||e(P)&&e(O)}function r(P){return c(P)||f(P)||I(P)}function a(P,O){return O.length===0?O=[P]:P.end===O[0].start?O[0].start=P.start:O.unshift(P),O}function l(P,O){for(let j=O;j<P.length;j++){const ee=P.charCodeAt(j);if(f(ee)||I(ee)||j>0&&!r(P.charCodeAt(j-1)))return j}return P.length}function p(P,O,j,ee){if(j===P.length)return[];if(ee===O.length)return null;if(P[j]!==O[ee].toLowerCase())return null;{let ce=null,de=ee+1;for(ce=p(P,O,j+1,ee+1);!ce&&(de=l(O,de))<O.length;)ce=p(P,O,j+1,de),de++;return ce===null?null:a({start:ee,end:ee+1},ce)}}function k(P){let O=0,j=0,ee=0,ce=0,de=0;for(let we=0;we<P.length;we++)de=P.charCodeAt(we),f(de)&&O++,c(de)&&j++,r(de)&&ee++,I(de)&&ce++;const De=O/P.length,ye=j/P.length,Ie=ee/P.length,Se=ce/P.length;return{upperPercent:De,lowerPercent:ye,alphaPercent:Ie,numericPercent:Se}}function S(P){const{upperPercent:O,lowerPercent:j}=P;return j===0&&O>.6}function g(P){const{upperPercent:O,lowerPercent:j,alphaPercent:ee,numericPercent:ce}=P;return j>.2&&O<.8&&ee>.6&&ce<.2}function E(P){let O=0,j=0,ee=0,ce=0;for(let de=0;de<P.length;de++)ee=P.charCodeAt(de),f(ee)&&O++,c(ee)&&j++,o(ee)&&ce++;return(O===0||j===0)&&ce===0?P.length<=30:O<=5}function N(P,O){if(!O||(O=O.trim(),O.length===0)||!E(P)||O.length>60)return null;const j=k(O);if(!g(j)){if(!S(j))return null;O=O.toLowerCase()}let ee=null,ce=0;for(P=P.toLowerCase();ce<O.length&&(ee=p(P,O,0,ce))===null;)ce=l(O,ce+1);return ee}t.matchesCamelCase=N;function F(P,O,j=!1){if(!O||O.length===0)return null;let ee=null,ce=0;for(P=P.toLowerCase(),O=O.toLowerCase();ce<O.length&&(ee=d(P,O,0,ce,j))===null;)ce=w(O,ce+1);return ee}t.matchesWords=F;function d(P,O,j,ee,ce){if(j===P.length)return[];if(ee===O.length)return null;if(s(P.charCodeAt(j),O.charCodeAt(ee))){let de=null,De=ee+1;if(de=d(P,O,j+1,ee+1,ce),!ce)for(;!de&&(De=w(O,De))<O.length;)de=d(P,O,j+1,De,ce),De++;return de?P.charCodeAt(j)!==O.charCodeAt(ee)?de:a({start:ee,end:ee+1},de):null}else return null}function w(P,O){for(let j=O;j<P.length;j++)if(e(P.charCodeAt(j))||j>0&&e(P.charCodeAt(j-1)))return j;return P.length}const m=z(t.matchesPrefix,N,y),D=z(t.matchesPrefix,N,b),R=new v.LRUCache(1e4);function V(P,O,j=!1){if(typeof P!="string"||typeof O!="string")return null;let ee=R.get(P);ee||(ee=new RegExp(i.convertSimple2RegExpPattern(P),"i"),R.set(P,ee));const ce=ee.exec(O);return ce?[{start:ce.index,end:ce.index+ce[0].length}]:j?D(P,O):m(P,O)}t.matchesFuzzy=V;function Z(P,O){const j=$(P,P.toLowerCase(),0,O,O.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return j?x(j):null}t.matchesFuzzy2=Z;function X(P,O,j,ee,ce,de){const De=Math.min(13,P.length);for(;j<De;j++){const ye=$(P,O,j,ee,ce,de,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ye)return ye}return[0,de]}t.anyScore=X;function x(P){if(typeof P>"u")return[];const O=[],j=P[1];for(let ee=P.length-1;ee>1;ee--){const ce=P[ee]+j,de=O[O.length-1];de&&de.end===ce?de.end=ce+1:O.push({start:ce,end:ce+1})}return O}t.createMatches=x;const ne=128;function le(){const P=[],O=[];for(let j=0;j<=ne;j++)O[j]=0;for(let j=0;j<=ne;j++)P.push(O.slice(0));return P}function se(P){const O=[];for(let j=0;j<=P;j++)O[j]=0;return O}const fe=se(2*ne),Ae=se(2*ne),te=le(),ve=le(),Ne=le(),he=!1;function Q(P,O,j,ee,ce){function de(ye,Ie,Se=" "){for(;ye.length<Ie;)ye=Se+ye;return ye}let De=` |   |${ee.split("").map(ye=>de(ye,3)).join("|")}
`;for(let ye=0;ye<=j;ye++)ye===0?De+=" |":De+=`${O[ye-1]}|`,De+=P[ye].slice(0,ce+1).map(Ie=>de(Ie.toString(),3)).join("|")+`
`;return De}function oe(P,O,j,ee){P=P.substr(O),j=j.substr(ee),console.log(Q(ve,P,P.length,j,j.length)),console.log(Q(Ne,P,P.length,j,j.length)),console.log(Q(te,P,P.length,j,j.length))}function re(P,O){if(O<0||O>=P.length)return!1;const j=P.codePointAt(O);switch(j){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!i.isEmojiImprecise(j)}}function ie(P,O){if(O<0||O>=P.length)return!1;switch(P.charCodeAt(O)){case 32:case 9:return!0;default:return!1}}function A(P,O,j){return O[P]!==j[P]}function C(P,O,j,ee,ce,de,De=!1){for(;O<j&&ce<de;)P[O]===ee[ce]&&(De&&(fe[O]=ce),O+=1),ce+=1;return O===j}t.isPatternInWord=C;var h;(function(P){P[P.Diag=1]="Diag",P[P.Left=2]="Left",P[P.LeftLeft=3]="LeftLeft"})(h||(h={}));var B;(function(P){P.Default=[-100,0];function O(j){return!j||j.length===2&&j[0]===-100&&j[1]===0}P.isDefault=O})(B=t.FuzzyScore||(t.FuzzyScore={}));class _{constructor(O,j){this.firstMatchCanBeWeak=O,this.boostFullMatch=j}}t.FuzzyScoreOptions=_,_.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function $(P,O,j,ee,ce,de,De=_.default){const ye=P.length>ne?ne:P.length,Ie=ee.length>ne?ne:ee.length;if(j>=ye||de>=Ie||ye-j>Ie-de||!C(O,j,ye,ce,de,Ie,!0))return;Y(ye,Ie,j,de,O,ce);let Se=1,we=1,Re=j,Pe=de;const Ke=[!1];for(Se=1,Re=j;Re<ye;Se++,Re++){const Be=fe[Re],je=Ae[Re],Ye=Re+1<ye?Ae[Re+1]:Ie;for(we=Be-de+1,Pe=Be;Pe<Ye;we++,Pe++){let K=Number.MIN_SAFE_INTEGER,ue=!1;Pe<=je&&(K=T(P,O,Re,j,ee,ce,Pe,Ie,de,te[Se-1][we-1]===0,Ke));let pe=0;K!==Number.MAX_SAFE_INTEGER&&(ue=!0,pe=K+ve[Se-1][we-1]);const Ee=Pe>Be,Fe=Ee?ve[Se][we-1]+(te[Se][we-1]>0?-5:0):0,Oe=Pe>Be+1&&te[Se][we-1]>0,$e=Oe?ve[Se][we-2]+(te[Se][we-2]>0?-5:0):0;if(Oe&&(!Ee||$e>=Fe)&&(!ue||$e>=pe))ve[Se][we]=$e,Ne[Se][we]=3,te[Se][we]=0;else if(Ee&&(!ue||Fe>=pe))ve[Se][we]=Fe,Ne[Se][we]=2,te[Se][we]=0;else if(ue)ve[Se][we]=pe,Ne[Se][we]=1,te[Se][we]=te[Se-1][we-1]+1;else throw new Error("not possible")}}if(he&&oe(P,j,ee,de),!Ke[0]&&!De.firstMatchCanBeWeak)return;Se--,we--;const Ue=[ve[Se][we],de];let We=0,xe=0;for(;Se>=1;){let Be=we;do{const je=Ne[Se][Be];if(je===3)Be=Be-2;else if(je===2)Be=Be-1;else break}while(Be>=1);We>1&&O[j+Se-1]===ce[de+we-1]&&!A(Be+de-1,ee,ce)&&We+1>te[Se][Be]&&(Be=we),Be===we?We++:We=1,xe||(xe=Be),Se--,we=Be-1,Ue.push(we)}Ie===ye&&De.boostFullMatch&&(Ue[0]+=2);const it=xe-ye;return Ue[0]-=it,Ue}t.fuzzyScore=$;function Y(P,O,j,ee,ce,de){let De=P-1,ye=O-1;for(;De>=j&&ye>=ee;)ce[De]===de[ye]&&(Ae[De]=ye,De--),ye--}function T(P,O,j,ee,ce,de,De,ye,Ie,Se,we){if(O[j]!==de[De])return Number.MIN_SAFE_INTEGER;let Re=1,Pe=!1;return De===j-ee?Re=P[j]===ce[De]?7:5:A(De,ce,de)&&(De===0||!A(De-1,ce,de))?(Re=P[j]===ce[De]?7:5,Pe=!0):re(de,De)&&(De===0||!re(de,De-1))?Re=5:(re(de,De-1)||ie(de,De-1))&&(Re=5,Pe=!0),Re>1&&j===ee&&(we[0]=!0),Pe||(Pe=A(De,ce,de)||re(de,De-1)||ie(de,De-1)),j===ee?De>Ie&&(Re-=Pe?3:5):Se?Re+=Pe?2:0:Re+=Pe?0:1,De+1===ye&&(Re-=Pe?3:5),Re}function H(P,O,j,ee,ce,de,De){return L(P,O,j,ee,ce,de,!0,De)}t.fuzzyScoreGracefulAggressive=H;function W(P,O,j,ee,ce,de,De){return L(P,O,j,ee,ce,de,!1,De)}t.fuzzyScoreGraceful=W;function L(P,O,j,ee,ce,de,De,ye){let Ie=$(P,O,j,ee,ce,de,ye);if(Ie&&!De)return Ie;if(P.length>=3){const Se=Math.min(7,P.length-1);for(let we=j+1;we<Se;we++){const Re=M(P,we);if(Re){const Pe=$(Re,Re.toLowerCase(),j,ee,ce,de,ye);Pe&&(Pe[0]-=3,(!Ie||Pe[0]>Ie[0])&&(Ie=Pe))}}}return Ie}function M(P,O){if(O+1>=P.length)return;const j=P[O],ee=P[O+1];if(j!==ee)return P.slice(0,O)+ee+j+P.slice(O+2)}}),define(me[111],be([1,0,11]),function(J,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function i(a){return z(a,0)}t.hash=i;function z(a,l){switch(typeof a){case"object":return a===null?U(349,l):Array.isArray(a)?u(a,l):c(a,l);case"string":return b(a,l);case"boolean":return y(a,l);case"number":return U(a,l);case"undefined":return U(937,l);default:return U(617,l)}}t.doHash=z;function U(a,l){return(l<<5)-l+a|0}t.numberHash=U;function y(a,l){return U(a?433:863,l)}function b(a,l){l=U(149417,l);for(let p=0,k=a.length;p<k;p++)l=U(a.charCodeAt(p),l);return l}t.stringHash=b;function u(a,l){return l=U(104579,l),a.reduce((p,k)=>z(k,p),l)}function c(a,l){return l=U(181387,l),Object.keys(a).sort().reduce((p,k)=>(p=b(k,p),z(a[k],p)),l)}class f{constructor(){this.g=0}get value(){return this.g}hash(l){return this.g=z(l,this.g),this.g}}t.Hasher=f;var I;(function(a){a[a.BLOCK_SIZE=64]="BLOCK_SIZE",a[a.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function o(a,l,p=32){const k=p-l,S=~((1<<k)-1);return(a<<l|(S&a)>>>k)>>>0}function n(a,l=0,p=a.byteLength,k=0){for(let S=0;S<p;S++)a[l+S]=k}function e(a,l,p="0"){for(;a.length<l;)a=p+a;return a}function s(a,l=32){return a instanceof ArrayBuffer?Array.from(new Uint8Array(a)).map(p=>p.toString(16).padStart(2,"0")).join(""):e((a>>>0).toString(16),l/4)}t.toHexString=s;class r{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(l){const p=l.length;if(p===0)return;const k=this.p;let S=this.r,g=this.u,E,N;for(g!==0?(E=g,N=-1,g=0):(E=l.charCodeAt(0),N=0);;){let F=E;if(v.isHighSurrogate(E))if(N+1<p){const d=l.charCodeAt(N+1);v.isLowSurrogate(d)?(N++,F=v.computeCodePoint(E,d)):F=65533}else{g=E;break}else v.isLowSurrogate(E)&&(F=65533);if(S=this.w(k,S,F),N++,N<p)E=l.charCodeAt(N);else break}this.r=S,this.u=g}w(l,p,k){return k<128?l[p++]=k:k<2048?(l[p++]=192|(k&1984)>>>6,l[p++]=128|(k&63)>>>0):k<65536?(l[p++]=224|(k&61440)>>>12,l[p++]=128|(k&4032)>>>6,l[p++]=128|(k&63)>>>0):(l[p++]=240|(k&1835008)>>>18,l[p++]=128|(k&258048)>>>12,l[p++]=128|(k&4032)>>>6,l[p++]=128|(k&63)>>>0),p>=64&&(this.y(),p-=64,this.t+=64,l[0]=l[64+0],l[1]=l[64+1],l[2]=l[64+2]),p}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),s(this.h)+s(this.l)+s(this.m)+s(this.n)+s(this.o)}x(){this.p[this.r++]=128,n(this.p,this.r),this.r>56&&(this.y(),n(this.p));const l=8*this.t;this.q.setUint32(56,Math.floor(l/4294967296),!1),this.q.setUint32(60,l%4294967296,!1),this.y()}y(){const l=r.g,p=this.q;for(let m=0;m<64;m+=4)l.setUint32(m,p.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)l.setUint32(m,o(l.getUint32(m-12,!1)^l.getUint32(m-32,!1)^l.getUint32(m-56,!1)^l.getUint32(m-64,!1),1),!1);let k=this.h,S=this.l,g=this.m,E=this.n,N=this.o,F,d,w;for(let m=0;m<80;m++)m<20?(F=S&g|~S&E,d=1518500249):m<40?(F=S^g^E,d=1859775393):m<60?(F=S&g|S&E|g&E,d=2400959708):(F=S^g^E,d=3395469782),w=o(k,5)+F+N+d+l.getUint32(m*4,!1)&4294967295,N=E,E=g,g=o(S,30),S=k,k=w;this.h=this.h+k&4294967295,this.l=this.l+S&4294967295,this.m=this.m+g&4294967295,this.n=this.n+E&4294967295,this.o=this.o+N&4294967295}}t.StringSHA1=r,r.g=new DataView(new ArrayBuffer(320))}),define(me[112],be([1,0,71,111]),function(J,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.stringDiff=t.StringDiffSequence=void 0;class z{constructor(o){this.a=o}getElements(){const o=this.a,n=new Int32Array(o.length);for(let e=0,s=o.length;e<s;e++)n[e]=o.charCodeAt(e);return n}}t.StringDiffSequence=z;function U(I,o,n){return new f(new z(I),new z(o)).ComputeDiff(n).changes}t.stringDiff=U;class y{static Assert(o,n){if(!o)throw new Error(n)}}class b{static Copy(o,n,e,s,r){for(let a=0;a<r;a++)e[s+a]=o[n+a]}static Copy2(o,n,e,s,r){for(let a=0;a<r;a++)e[s+a]=o[n+a]}}var u;(function(I){I[I.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(u||(u={}));class c{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new v.DiffChange(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(o,n){this.b=Math.min(this.b,o),this.c=Math.min(this.c,n),this.d++}AddModifiedElement(o,n){this.b=Math.min(this.b,o),this.c=Math.min(this.c,n),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class f{constructor(o,n,e=null){this.a=e,this.b=o,this.c=n;const[s,r,a]=f.o(o),[l,p,k]=f.o(n);this.d=a&&k,this.e=s,this.f=r,this.g=l,this.h=p,this.k=[],this.m=[]}static n(o){return o.length>0&&typeof o[0]=="string"}static o(o){const n=o.getElements();if(f.n(n)){const e=new Int32Array(n.length);for(let s=0,r=n.length;s<r;s++)e[s]=(0,i.stringHash)(n[s],0);return[n,e,!0]}return n instanceof Int32Array?[[],n,!1]:[[],new Int32Array(n),!1]}p(o,n){return this.f[o]!==this.h[n]?!1:this.d?this.e[o]===this.g[n]:!0}q(o,n){if(!this.p(o,n))return!1;const e=f.r(this.b,o),s=f.r(this.c,n);return e===s}static r(o,n){return typeof o.getStrictElement=="function"?o.getStrictElement(n):null}s(o,n){return this.f[o]!==this.f[n]?!1:this.d?this.e[o]===this.e[n]:!0}u(o,n){return this.h[o]!==this.h[n]?!1:this.d?this.g[o]===this.g[n]:!0}ComputeDiff(o){return this.v(0,this.f.length-1,0,this.h.length-1,o)}v(o,n,e,s,r){const a=[!1];let l=this.w(o,n,e,s,a);return r&&(l=this.z(l)),{quitEarly:a[0],changes:l}}w(o,n,e,s,r){for(r[0]=!1;o<=n&&e<=s&&this.p(o,e);)o++,e++;for(;n>=o&&s>=e&&this.p(n,s);)n--,s--;if(o>n||e>s){let g;return e<=s?(y.Assert(o===n+1,"originalStart should only be one more than originalEnd"),g=[new v.DiffChange(o,0,e,s-e+1)]):o<=n?(y.Assert(e===s+1,"modifiedStart should only be one more than modifiedEnd"),g=[new v.DiffChange(o,n-o+1,e,0)]):(y.Assert(o===n+1,"originalStart should only be one more than originalEnd"),y.Assert(e===s+1,"modifiedStart should only be one more than modifiedEnd"),g=[]),g}const a=[0],l=[0],p=this.y(o,n,e,s,a,l,r),k=a[0],S=l[0];if(p!==null)return p;if(!r[0]){const g=this.w(o,k,e,S,r);let E=[];return r[0]?E=[new v.DiffChange(k+1,n-(k+1)+1,S+1,s-(S+1)+1)]:E=this.w(k+1,n,S+1,s,r),this.H(g,E)}return[new v.DiffChange(o,n-o+1,e,s-e+1)]}x(o,n,e,s,r,a,l,p,k,S,g,E,N,F,d,w,m,D){let R=null,V=null,Z=new c,X=n,x=e,ne=N[0]-w[0]-s,le=-1073741824,se=this.k.length-1;do{const fe=ne+o;fe===X||fe<x&&k[fe-1]<k[fe+1]?(g=k[fe+1],F=g-ne-s,g<le&&Z.MarkNextChange(),le=g,Z.AddModifiedElement(g+1,F),ne=fe+1-o):(g=k[fe-1]+1,F=g-ne-s,g<le&&Z.MarkNextChange(),le=g-1,Z.AddOriginalElement(g,F+1),ne=fe-1-o),se>=0&&(k=this.k[se],o=k[0],X=1,x=k.length-1)}while(--se>=-1);if(R=Z.getReverseChanges(),D[0]){let fe=N[0]+1,Ae=w[0]+1;if(R!==null&&R.length>0){const te=R[R.length-1];fe=Math.max(fe,te.getOriginalEnd()),Ae=Math.max(Ae,te.getModifiedEnd())}V=[new v.DiffChange(fe,E-fe+1,Ae,d-Ae+1)]}else{Z=new c,X=a,x=l,ne=N[0]-w[0]-p,le=1073741824,se=m?this.m.length-1:this.m.length-2;do{const fe=ne+r;fe===X||fe<x&&S[fe-1]>=S[fe+1]?(g=S[fe+1]-1,F=g-ne-p,g>le&&Z.MarkNextChange(),le=g+1,Z.AddOriginalElement(g+1,F+1),ne=fe+1-r):(g=S[fe-1],F=g-ne-p,g>le&&Z.MarkNextChange(),le=g,Z.AddModifiedElement(g+1,F+1),ne=fe-1-r),se>=0&&(S=this.m[se],r=S[0],X=1,x=S.length-1)}while(--se>=-1);V=Z.getChanges()}return this.H(R,V)}y(o,n,e,s,r,a,l){let p=0,k=0,S=0,g=0,E=0,N=0;o--,e--,r[0]=0,a[0]=0,this.k=[],this.m=[];const F=n-o+(s-e),d=F+1,w=new Int32Array(d),m=new Int32Array(d),D=s-e,R=n-o,V=o-e,Z=n-s,x=(R-D)%2===0;w[D]=o,m[R]=n,l[0]=!1;for(let ne=1;ne<=F/2+1;ne++){let le=0,se=0;S=this.J(D-ne,ne,D,d),g=this.J(D+ne,ne,D,d);for(let Ae=S;Ae<=g;Ae+=2){Ae===S||Ae<g&&w[Ae-1]<w[Ae+1]?p=w[Ae+1]:p=w[Ae-1]+1,k=p-(Ae-D)-V;const te=p;for(;p<n&&k<s&&this.p(p+1,k+1);)p++,k++;if(w[Ae]=p,p+k>le+se&&(le=p,se=k),!x&&Math.abs(Ae-R)<=ne-1&&p>=m[Ae])return r[0]=p,a[0]=k,te<=m[Ae]&&1447>0&&ne<=1447+1?this.x(D,S,g,V,R,E,N,Z,w,m,p,n,r,k,s,a,x,l):null}const fe=(le-o+(se-e)-ne)/2;if(this.a!==null&&!this.a(le,fe))return l[0]=!0,r[0]=le,a[0]=se,fe>0&&1447>0&&ne<=1447+1?this.x(D,S,g,V,R,E,N,Z,w,m,p,n,r,k,s,a,x,l):(o++,e++,[new v.DiffChange(o,n-o+1,e,s-e+1)]);E=this.J(R-ne,ne,R,d),N=this.J(R+ne,ne,R,d);for(let Ae=E;Ae<=N;Ae+=2){Ae===E||Ae<N&&m[Ae-1]>=m[Ae+1]?p=m[Ae+1]-1:p=m[Ae-1],k=p-(Ae-R)-Z;const te=p;for(;p>o&&k>e&&this.p(p,k);)p--,k--;if(m[Ae]=p,x&&Math.abs(Ae-D)<=ne&&p<=w[Ae])return r[0]=p,a[0]=k,te>=w[Ae]&&1447>0&&ne<=1447+1?this.x(D,S,g,V,R,E,N,Z,w,m,p,n,r,k,s,a,x,l):null}if(ne<=1447){let Ae=new Int32Array(g-S+2);Ae[0]=D-S+1,b.Copy2(w,S,Ae,1,g-S+1),this.k.push(Ae),Ae=new Int32Array(N-E+2),Ae[0]=R-E+1,b.Copy2(m,E,Ae,1,N-E+1),this.m.push(Ae)}}return this.x(D,S,g,V,R,E,N,Z,w,m,p,n,r,k,s,a,x,l)}z(o){for(let n=0;n<o.length;n++){const e=o[n],s=n<o.length-1?o[n+1].originalStart:this.f.length,r=n<o.length-1?o[n+1].modifiedStart:this.h.length,a=e.originalLength>0,l=e.modifiedLength>0;for(;e.originalStart+e.originalLength<s&&e.modifiedStart+e.modifiedLength<r&&(!a||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!l||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const k=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!k)break;e.originalStart++,e.modifiedStart++}const p=[null];if(n<o.length-1&&this.I(o[n],o[n+1],p)){o[n]=p[0],o.splice(n+1,1),n--;continue}}for(let n=o.length-1;n>=0;n--){const e=o[n];let s=0,r=0;if(n>0){const g=o[n-1];s=g.originalStart+g.originalLength,r=g.modifiedStart+g.modifiedLength}const a=e.originalLength>0,l=e.modifiedLength>0;let p=0,k=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let g=1;;g++){const E=e.originalStart-g,N=e.modifiedStart-g;if(E<s||N<r||a&&!this.s(E,E+e.originalLength)||l&&!this.u(N,N+e.modifiedLength))break;const d=(E===s&&N===r?5:0)+this.G(E,e.originalLength,N,e.modifiedLength);d>k&&(k=d,p=g)}e.originalStart-=p,e.modifiedStart-=p;const S=[null];if(n>0&&this.I(o[n-1],o[n],S)){o[n-1]=S[0],o.splice(n,1),n++;continue}}if(this.d)for(let n=1,e=o.length;n<e;n++){const s=o[n-1],r=o[n],a=r.originalStart-s.originalStart-s.originalLength,l=s.originalStart,p=r.originalStart+r.originalLength,k=p-l,S=s.modifiedStart,g=r.modifiedStart+r.modifiedLength,E=g-S;if(a<5&&k<20&&E<20){const N=this.A(l,k,S,E,a);if(N){const[F,d]=N;(F!==s.originalStart+s.originalLength||d!==s.modifiedStart+s.modifiedLength)&&(s.originalLength=F-s.originalStart,s.modifiedLength=d-s.modifiedStart,r.originalStart=F+a,r.modifiedStart=d+a,r.originalLength=p-r.originalStart,r.modifiedLength=g-r.modifiedStart)}}}return o}A(o,n,e,s,r){if(n<r||s<r)return null;const a=o+n-r+1,l=e+s-r+1;let p=0,k=0,S=0;for(let g=o;g<a;g++)for(let E=e;E<l;E++){const N=this.B(g,E,r);N>0&&N>p&&(p=N,k=g,S=E)}return p>0?[k,S]:null}B(o,n,e){let s=0;for(let r=0;r<e;r++){if(!this.p(o+r,n+r))return 0;s+=this.e[o+r].length}return s}C(o){return o<=0||o>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[o])}D(o,n){if(this.C(o)||this.C(o-1))return!0;if(n>0){const e=o+n;if(this.C(e-1)||this.C(e))return!0}return!1}E(o){return o<=0||o>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[o])}F(o,n){if(this.E(o)||this.E(o-1))return!0;if(n>0){const e=o+n;if(this.E(e-1)||this.E(e))return!0}return!1}G(o,n,e,s){const r=this.D(o,n)?1:0,a=this.F(e,s)?1:0;return r+a}H(o,n){const e=[];if(o.length===0||n.length===0)return n.length>0?n:o;if(this.I(o[o.length-1],n[0],e)){const s=new Array(o.length+n.length-1);return b.Copy(o,0,s,0,o.length-1),s[o.length-1]=e[0],b.Copy(n,1,s,o.length,n.length-1),s}else{const s=new Array(o.length+n.length);return b.Copy(o,0,s,0,o.length),b.Copy(n,0,s,o.length,n.length),s}}I(o,n,e){if(y.Assert(o.originalStart<=n.originalStart,"Left change is not less than or equal to right change"),y.Assert(o.modifiedStart<=n.modifiedStart,"Left change is not less than or equal to right change"),o.originalStart+o.originalLength>=n.originalStart||o.modifiedStart+o.modifiedLength>=n.modifiedStart){const s=o.originalStart;let r=o.originalLength;const a=o.modifiedStart;let l=o.modifiedLength;return o.originalStart+o.originalLength>=n.originalStart&&(r=n.originalStart+n.originalLength-o.originalStart),o.modifiedStart+o.modifiedLength>=n.modifiedStart&&(l=n.modifiedStart+n.modifiedLength-o.modifiedStart),e[0]=new v.DiffChange(s,r,a,l),!0}else return e[0]=null,!1}J(o,n,e,s){if(o>=0&&o<s)return o;const r=e,a=s-e-1,l=n%2===0;if(o<0){const p=r%2===0;return l===p?0:1}else{const p=a%2===0;return l===p?s-1:s-2}}}t.LcsDiff=f}),define(me[33],be([1,0,12,32,11]),function(J,t,v,i,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.matchesFuzzyIconAware=t.parseLabelWithIcons=t.stripIcons=t.markdownEscapeEscapedIcons=t.escapeIcons=void 0;const U="$(",y=new RegExp(`\\$\\(${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${y.source}`,"g");function u(r){return r.replace(b,(a,l)=>l?a:`\\${a}`)}t.escapeIcons=u;const c=new RegExp(`\\\\${y.source}`,"g");function f(r){return r.replace(c,a=>`\\${a}`)}t.markdownEscapeEscapedIcons=f;const I=new RegExp(`(\\s)?(\\\\)?${y.source}(\\s)?`,"g");function o(r){return r.indexOf(U)===-1?r:r.replace(I,(a,l,p,k)=>p?a:l||k||"")}t.stripIcons=o;const n=new RegExp(`\\$\\(${v.CSSIcon.iconNameCharacter}+\\)`,"g");function e(r){n.lastIndex=0;let a="";const l=[];let p=0;for(;;){const k=n.lastIndex,S=n.exec(r),g=r.substring(k,S?.index);if(g.length>0){a+=g;for(let E=0;E<g.length;E++)l.push(p)}if(!S)break;p+=S[0].length}return{text:a,iconOffsets:l}}t.parseLabelWithIcons=e;function s(r,a,l=!1){const{text:p,iconOffsets:k}=a;if(!k||k.length===0)return(0,i.matchesFuzzy)(r,p,l);const S=(0,z.ltrim)(p," "),g=p.length-S.length,E=(0,i.matchesFuzzy)(r,S,l);if(E)for(const N of E){const F=k[N.start+g]+g;N.start+=F,N.end+=F}return E}t.matchesFuzzyIconAware=s}),define(me[113],be([1,0,14,11]),function(J,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TernarySearchTree=t.UriIterator=t.PathIterator=t.ConfigKeysIterator=t.StringIterator=void 0;class z{constructor(){this.b="",this.c=0}reset(n){return this.b=n,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(n){const e=n.charCodeAt(0),s=this.b.charCodeAt(this.c);return e-s}value(){return this.b[this.c]}}t.StringIterator=z;class U{constructor(n=!0){this.e=n}reset(n){return this.b=n,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let n=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(n)this.c++;else break;else n=!1;return this}cmp(n){return this.e?(0,i.compareSubstring)(n,this.b,0,n.length,this.c,this.d):(0,i.compareSubstringIgnoreCase)(n,this.b,0,n.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.ConfigKeysIterator=U;class y{constructor(n=!0,e=!0){this.f=n,this.g=e}reset(n){this.d=0,this.e=0,this.b=n,this.c=n.length;for(let e=n.length-1;e>=0;e--,this.c--){const s=this.b.charCodeAt(e);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let n=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(n)this.d++;else break;else n=!1}return this}cmp(n){return this.g?(0,i.compareSubstring)(n,this.b,0,n.length,this.d,this.e):(0,i.compareSubstringIgnoreCase)(n,this.b,0,n.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.PathIterator=y;var b;(function(o){o[o.Scheme=1]="Scheme",o[o.Authority=2]="Authority",o[o.Path=3]="Path",o[o.Query=4]="Query",o[o.Fragment=5]="Fragment"})(b||(b={}));class u{constructor(n,e){this.f=n,this.g=e,this.d=[],this.e=0}reset(n){return this.c=n,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new y(!1,!this.f(n)),this.b.reset(n.path),this.b.value()&&this.d.push(3)),this.g(n)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(n){if(this.d[this.e]===1)return(0,i.compareIgnoreCase)(n,this.c.scheme);if(this.d[this.e]===2)return(0,i.compareIgnoreCase)(n,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(n);if(this.d[this.e]===4)return(0,i.compare)(n,this.c.query);if(this.d[this.e]===5)return(0,i.compare)(n,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.UriIterator=u;class c{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var f;(function(o){o[o.Left=-1]="Left",o[o.Mid=0]="Mid",o[o.Right=1]="Right"})(f||(f={}));class I{static forUris(n=()=>!1,e=()=>!1){return new I(new u(n,e))}static forPaths(n=!1){return new I(new y(void 0,!n))}static forStrings(){return new I(new z)}static forConfigKeys(){return new I(new U)}constructor(n){this.b=n}clear(){this.c=void 0}fill(n,e){if(e){const s=e.slice(0);(0,v.shuffle)(s);for(const r of s)this.set(r,n)}else{const s=n.slice(0);(0,v.shuffle)(s);for(const r of s)this.set(r[0],r[1])}}set(n,e){const s=this.b.reset(n);let r;this.c||(this.c=new c,this.c.segment=s.value());const a=[];for(r=this.c;;){const p=s.cmp(r.segment);if(p>0)r.left||(r.left=new c,r.left.segment=s.value()),a.push([-1,r]),r=r.left;else if(p<0)r.right||(r.right=new c,r.right.segment=s.value()),a.push([1,r]),r=r.right;else if(s.hasNext())s.next(),r.mid||(r.mid=new c,r.mid.segment=s.value()),a.push([0,r]),r=r.mid;else break}const l=r.value;r.value=e,r.key=n;for(let p=a.length-1;p>=0;p--){const k=a[p][1];k.updateHeight();const S=k.balanceFactor();if(S<-1||S>1){const g=a[p][0],E=a[p+1][0];if(g===1&&E===1)a[p][1]=k.rotateLeft();else if(g===-1&&E===-1)a[p][1]=k.rotateRight();else if(g===1&&E===-1)k.right=a[p+1][1]=a[p+1][1].rotateRight(),a[p][1]=k.rotateLeft();else if(g===-1&&E===1)k.left=a[p+1][1]=a[p+1][1].rotateLeft(),a[p][1]=k.rotateRight();else throw new Error;if(p>0)switch(a[p-1][0]){case-1:a[p-1][1].left=a[p][1];break;case 1:a[p-1][1].right=a[p][1];break;case 0:a[p-1][1].mid=a[p][1];break}else this.c=a[0][1]}}return l}get(n){return this.d(n)?.value}d(n){const e=this.b.reset(n);let s=this.c;for(;s;){const r=e.cmp(s.segment);if(r>0)s=s.left;else if(r<0)s=s.right;else if(e.hasNext())e.next(),s=s.mid;else break}return s}has(n){const e=this.d(n);return!(e?.value===void 0&&e?.mid===void 0)}delete(n){return this.e(n,!1)}deleteSuperstr(n){return this.e(n,!0)}e(n,e){const s=this.b.reset(n),r=[];let a=this.c;for(;a;){const l=s.cmp(a.segment);if(l>0)r.push([-1,a]),a=a.left;else if(l<0)r.push([1,a]),a=a.right;else if(s.hasNext())s.next(),r.push([0,a]),a=a.mid;else break}if(!!a){if(e?(a.left=void 0,a.mid=void 0,a.right=void 0,a.height=1):(a.key=void 0,a.value=void 0),!a.mid&&!a.value)if(a.left&&a.right){const l=this.f(a.right);if(l.key){const{key:p,value:k,segment:S}=l;this.e(l.key,!1),a.key=p,a.value=k,a.segment=S}}else{const l=a.left??a.right;if(r.length>0){const[p,k]=r[r.length-1];switch(p){case-1:k.left=l;break;case 0:k.mid=l;break;case 1:k.right=l;break}}else this.c=l}for(let l=r.length-1;l>=0;l--){const p=r[l][1];p.updateHeight();const k=p.balanceFactor();if(k>1?(p.right.balanceFactor()>=0||(p.right=p.right.rotateRight()),r[l][1]=p.rotateLeft()):k<-1&&(p.left.balanceFactor()<=0||(p.left=p.left.rotateLeft()),r[l][1]=p.rotateRight()),l>0)switch(r[l-1][0]){case-1:r[l-1][1].left=r[l][1];break;case 1:r[l-1][1].right=r[l][1];break;case 0:r[l-1][1].mid=r[l][1];break}else this.c=r[0][1]}}}f(n){for(;n.left;)n=n.left;return n}findSubstr(n){const e=this.b.reset(n);let s=this.c,r;for(;s;){const a=e.cmp(s.segment);if(a>0)s=s.left;else if(a<0)s=s.right;else if(e.hasNext())e.next(),r=s.value||r,s=s.mid;else break}return s&&s.value||r}findSuperstr(n){const e=this.b.reset(n);let s=this.c;for(;s;){const r=e.cmp(s.segment);if(r>0)s=s.left;else if(r<0)s=s.right;else if(e.hasNext())e.next(),s=s.mid;else return s.mid?this.g(s.mid):void 0}}forEach(n){for(const[e,s]of this)n(s,e)}*[Symbol.iterator](){yield*this.g(this.c)}g(n){const e=[];return this.h(n,e),e[Symbol.iterator]()}h(n,e){!n||(n.left&&this.h(n.left,e),n.value&&e.push([n.key,n.value]),n.mid&&this.h(n.mid,e),n.right&&this.h(n.right,e))}_isBalanced(){const n=e=>{if(!e)return!0;const s=e.balanceFactor();return s<-1||s>1?!1:n(e.left)&&n(e.right)};return n(this.c)}}t.TernarySearchTree=I}),define(me[16],be([1,0,21,5]),function(J,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const z=/^\w[\w\d+.-]*$/,U=/^\//,y=/^\/\//;function b(N,F){if(!N.scheme&&F)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${N.authority}", path: "${N.path}", query: "${N.query}", fragment: "${N.fragment}"}`);if(N.scheme&&!z.test(N.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(N.path){if(N.authority){if(!U.test(N.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(N.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(N,F){return!N&&!F?"file":N}function c(N,F){switch(N){case"https":case"http":case"file":F?F[0]!==I&&(F=I+F):F=I;break}return F}const f="",I="/",o=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class n{static isUri(F){return F instanceof n?!0:F?typeof F.authority=="string"&&typeof F.fragment=="string"&&typeof F.path=="string"&&typeof F.query=="string"&&typeof F.scheme=="string"&&typeof F.fsPath=="string"&&typeof F.with=="function"&&typeof F.toString=="function":!1}constructor(F,d,w,m,D,R=!1){typeof F=="object"?(this.scheme=F.scheme||f,this.authority=F.authority||f,this.path=F.path||f,this.query=F.query||f,this.fragment=F.fragment||f):(this.scheme=u(F,R),this.authority=d||f,this.path=c(this.scheme,w||f),this.query=m||f,this.fragment=D||f,b(this,R))}get fsPath(){return p(this,!1)}with(F){if(!F)return this;let{scheme:d,authority:w,path:m,query:D,fragment:R}=F;return d===void 0?d=this.scheme:d===null&&(d=f),w===void 0?w=this.authority:w===null&&(w=f),m===void 0?m=this.path:m===null&&(m=f),D===void 0?D=this.query:D===null&&(D=f),R===void 0?R=this.fragment:R===null&&(R=f),d===this.scheme&&w===this.authority&&m===this.path&&D===this.query&&R===this.fragment?this:new s(d,w,m,D,R)}static parse(F,d=!1){const w=o.exec(F);return w?new s(w[2]||f,E(w[4]||f),E(w[5]||f),E(w[7]||f),E(w[9]||f),d):new s(f,f,f,f,f)}static file(F){let d=f;if(i.isWindows&&(F=F.replace(/\\/g,I)),F[0]===I&&F[1]===I){const w=F.indexOf(I,2);w===-1?(d=F.substring(2),F=I):(d=F.substring(2,w),F=F.substring(w)||I)}return new s("file",d,F,f,f)}static from(F){const d=new s(F.scheme,F.authority,F.path,F.query,F.fragment);return b(d,!0),d}static joinPath(F,...d){if(!F.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let w;return i.isWindows&&F.scheme==="file"?w=n.file(v.win32.join(p(F,!0),...d)).path:w=v.posix.join(F.path,...d),F.with({path:w})}toString(F=!1){return k(this,F)}toJSON(){return this}static revive(F){if(F){if(F instanceof n)return F;{const d=new s(F);return d._formatted=F.external,d._fsPath=F._sep===e?F.fsPath:null,d}}else return F}}t.URI=n;const e=i.isWindows?1:void 0;class s extends n{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(F=!1){return F?k(this,!0):(this._formatted||(this._formatted=k(this,!1)),this._formatted)}toJSON(){const F={$mid:1};return this._fsPath&&(F.fsPath=this._fsPath,F._sep=e),this._formatted&&(F.external=this._formatted),this.path&&(F.path=this.path),this.scheme&&(F.scheme=this.scheme),this.authority&&(F.authority=this.authority),this.query&&(F.query=this.query),this.fragment&&(F.fragment=this.fragment),F}}const r={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function a(N,F,d){let w,m=-1;for(let D=0;D<N.length;D++){const R=N.charCodeAt(D);if(R>=97&&R<=122||R>=65&&R<=90||R>=48&&R<=57||R===45||R===46||R===95||R===126||F&&R===47||d&&R===91||d&&R===93||d&&R===58)m!==-1&&(w+=encodeURIComponent(N.substring(m,D)),m=-1),w!==void 0&&(w+=N.charAt(D));else{w===void 0&&(w=N.substr(0,D));const V=r[R];V!==void 0?(m!==-1&&(w+=encodeURIComponent(N.substring(m,D)),m=-1),w+=V):m===-1&&(m=D)}}return m!==-1&&(w+=encodeURIComponent(N.substring(m))),w!==void 0?w:N}function l(N){let F;for(let d=0;d<N.length;d++){const w=N.charCodeAt(d);w===35||w===63?(F===void 0&&(F=N.substr(0,d)),F+=r[w]):F!==void 0&&(F+=N[d])}return F!==void 0?F:N}function p(N,F){let d;return N.authority&&N.path.length>1&&N.scheme==="file"?d=`//${N.authority}${N.path}`:N.path.charCodeAt(0)===47&&(N.path.charCodeAt(1)>=65&&N.path.charCodeAt(1)<=90||N.path.charCodeAt(1)>=97&&N.path.charCodeAt(1)<=122)&&N.path.charCodeAt(2)===58?F?d=N.path.substr(1):d=N.path[1].toLowerCase()+N.path.substr(2):d=N.path,i.isWindows&&(d=d.replace(/\//g,"\\")),d}t.uriToFsPath=p;function k(N,F){const d=F?l:a;let w="",{scheme:m,authority:D,path:R,query:V,fragment:Z}=N;if(m&&(w+=m,w+=":"),(D||m==="file")&&(w+=I,w+=I),D){let X=D.indexOf("@");if(X!==-1){const x=D.substr(0,X);D=D.substr(X+1),X=x.lastIndexOf(":"),X===-1?w+=d(x,!1,!1):(w+=d(x.substr(0,X),!1,!1),w+=":",w+=d(x.substr(X+1),!1,!0)),w+="@"}D=D.toLowerCase(),X=D.lastIndexOf(":"),X===-1?w+=d(D,!1,!0):(w+=d(D.substr(0,X),!1,!0),w+=D.substr(X))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const X=R.charCodeAt(1);X>=65&&X<=90&&(R=`/${String.fromCharCode(X+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const X=R.charCodeAt(0);X>=65&&X<=90&&(R=`${String.fromCharCode(X+32)}:${R.substr(2)}`)}w+=d(R,!0,!1)}return V&&(w+="?",w+=d(V,!1,!1)),Z&&(w+="#",w+=F?Z:a(Z,!1,!1)),w}function S(N){try{return decodeURIComponent(N)}catch{return N.length>3?N.substr(0,3)+S(N.substr(3)):N}}const g=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function E(N){return N.match(g)?N.replace(g,F=>S(F)):N}}),define(me[50],be([1,0,29,11,16]),function(J,t,v,i,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function U(c){return JSON.stringify(c,b)}t.stringify=U;function y(c){let f=JSON.parse(c);return f=u(f),f}t.parse=y;function b(c,f){return f instanceof RegExp?{$mid:2,source:f.source,flags:(0,i.regExpFlags)(f)}:f}function u(c,f=0){if(!c||f>200)return c;if(typeof c=="object"){switch(c.$mid){case 1:return z.URI.revive(c);case 2:return new RegExp(c.source,c.flags);case 16:return new Date(c.source)}if(c instanceof v.VSBuffer||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let I=0;I<c.length;++I)c[I]=u(c[I],f+1);else for(const I in c)Object.hasOwnProperty.call(c,I)&&(c[I]=u(c[I],f+1))}return c}t.revive=u}),define(me[34],be([1,0,5,16]),function(J,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.FileAccess=t.nodeModulesAsarUnpackedPath=t.nodeModulesAsarPath=t.nodeModulesPath=t.builtinExtensionsPath=t.RemoteAuthorities=t.connectionTokenQueryName=t.connectionTokenCookieName=t.Schemas=void 0;var z;(function(u){u.inMemory="inmemory",u.vscode="vscode",u.internal="private",u.walkThrough="walkThrough",u.walkThroughSnippet="walkThroughSnippet",u.http="http",u.https="https",u.file="file",u.mailto="mailto",u.untitled="untitled",u.data="data",u.command="command",u.vscodeRemote="vscode-remote",u.vscodeRemoteResource="vscode-remote-resource",u.vscodeUserData="vscode-userdata",u.vscodeCustomEditor="vscode-custom-editor",u.vscodeNotebook="vscode-notebook",u.vscodeNotebookCell="vscode-notebook-cell",u.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",u.vscodeNotebookCellOutput="vscode-notebook-cell-output",u.vscodeInteractive="vscode-interactive",u.vscodeInteractiveInput="vscode-interactive-input",u.vscodeSettings="vscode-settings",u.vscodeWorkspaceTrust="vscode-workspace-trust",u.vscodeTerminal="vscode-terminal",u.webviewPanel="webview-panel",u.vscodeWebview="vscode-webview",u.extension="extension",u.vscodeFileResource="vscode-file",u.tmp="tmp",u.vsls="vsls",u.vscodeSourceControl="vscode-scm"})(z=t.Schemas||(t.Schemas={})),t.connectionTokenCookieName="vscode-tkn",t.connectionTokenQueryName="tkn";class U{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${z.vscodeRemoteResource}`}setPreferredWebSchema(c){this.d=c}setDelegate(c){this.e=c}setServerRootPath(c){this.f=`${c}/${z.vscodeRemoteResource}`}set(c,f,I){this.a[c]=f,this.b[c]=I}setConnectionToken(c,f){this.c[c]=f}getPreferredWebSchema(){return this.d}rewrite(c){if(this.e)return this.e(c);const f=c.authority;let I=this.a[f];I&&I.indexOf(":")!==-1&&I.indexOf("[")===-1&&(I=`[${I}]`);const o=this.b[f],n=this.c[f];let e=`path=${encodeURIComponent(c.path)}`;return typeof n=="string"&&(e+=`&${t.connectionTokenQueryName}=${encodeURIComponent(n)}`),i.URI.from({scheme:v.isWeb?this.d:z.vscodeRemoteResource,authority:`${I}:${o}`,path:this.f,query:e})}}t.RemoteAuthorities=new U,t.builtinExtensionsPath="vs/../../extensions",t.nodeModulesPath="vs/../../node_modules",t.nodeModulesAsarPath="vs/../../node_modules.asar",t.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class y{asBrowserUri(c){const f=this.b(c,J);return this.uriToBrowserUri(f)}uriToBrowserUri(c){return c.scheme===z.vscodeRemote?t.RemoteAuthorities.rewrite(c):c.scheme===z.file&&(v.isNative||v.isWebWorker&&v.globals.origin===`${z.vscodeFileResource}://${y.a}`)?c.with({scheme:z.vscodeFileResource,authority:c.authority||y.a,query:null,fragment:null}):c}asFileUri(c){const f=this.b(c,J);return this.uriToFileUri(f)}uriToFileUri(c){return c.scheme===z.vscodeFileResource?c.with({scheme:z.file,authority:c.authority!==y.a?c.authority:null,query:null,fragment:null}):c}b(c,f){return i.URI.isUri(c)?c:i.URI.parse(f.toUrl(c))}}y.a="vscode-app",t.FileAccess=new y;var b;(function(u){const c=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);u.CoopAndCoep=Object.freeze(c.get("3"));const f="vscode-coi";function I(n){let e;typeof n=="string"?e=new URL(n).searchParams:n instanceof URL?e=n.searchParams:i.URI.isUri(n)&&(e=new URL(n.toString(!0)).searchParams);const s=e?.get(f);if(!!s)return c.get(s)}u.getHeadersFromQuery=I;function o(n,e,s){if(!globalThis.crossOriginIsolated)return;const r=e&&s?"3":s?"2":"1";n instanceof URLSearchParams?n.set(f,r):n[f]=r}u.addSearchParam=o})(b=t.COI||(t.COI={}))}),define(me[35],be([1,0,110,34,21,5,11,16]),function(J,t,v,i,z,U,y,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalResource=t.DataUri=t.distinctParents=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=t.originalFSPath=void 0;function u(n){return(0,b.uriToFsPath)(n,!0)}t.originalFSPath=u;class c{constructor(e){this.a=e}compare(e,s,r=!1){return e===s?0:(0,y.compare)(this.getComparisonKey(e,r),this.getComparisonKey(s,r))}isEqual(e,s,r=!1){return e===s?!0:!e||!s?!1:this.getComparisonKey(e,r)===this.getComparisonKey(s,r)}getComparisonKey(e,s=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,s,r=!1){if(e.scheme===s.scheme){if(e.scheme===i.Schemas.file)return v.isEqualOrParent(u(e),u(s),this.a(e))&&e.query===s.query&&(r||e.fragment===s.fragment);if((0,t.isEqualAuthority)(e.authority,s.authority))return v.isEqualOrParent(e.path,s.path,this.a(e),"/")&&e.query===s.query&&(r||e.fragment===s.fragment)}return!1}joinPath(e,...s){return b.URI.joinPath(e,...s)}basenameOrAuthority(e){return(0,t.basename)(e)||e.authority}basename(e){return z.posix.basename(e.path)}extname(e){return z.posix.extname(e.path)}dirname(e){if(e.path.length===0)return e;let s;return e.scheme===i.Schemas.file?s=b.URI.file(z.dirname(u(e))).path:(s=z.posix.dirname(e.path),e.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),s="/")),e.with({path:s})}normalizePath(e){if(!e.path.length)return e;let s;return e.scheme===i.Schemas.file?s=b.URI.file(z.normalize(u(e))).path:s=z.posix.normalize(e.path),e.with({path:s})}relativePath(e,s){if(e.scheme!==s.scheme||!(0,t.isEqualAuthority)(e.authority,s.authority))return;if(e.scheme===i.Schemas.file){const l=z.relative(u(e),u(s));return U.isWindows?v.toSlashes(l):l}let r=e.path||"/";const a=s.path||"/";if(this.a(e)){let l=0;for(const p=Math.min(r.length,a.length);l<p&&!(r.charCodeAt(l)!==a.charCodeAt(l)&&r.charAt(l).toLowerCase()!==a.charAt(l).toLowerCase());l++);r=a.substr(0,l)+r.substr(l)}return z.posix.relative(r,a)}resolvePath(e,s){if(e.scheme===i.Schemas.file){const r=b.URI.file(z.resolve(u(e),s));return e.with({authority:r.authority,path:r.path})}return s=v.toPosixPath(s),e.with({path:z.posix.resolve(e.path,s)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,s){return e===s||e!==void 0&&s!==void 0&&(0,y.equalsIgnoreCase)(e,s)}hasTrailingPathSeparator(e,s=z.sep){if(e.scheme===i.Schemas.file){const r=u(e);return r.length>v.getRoot(r).length&&r[r.length-1]===s}else{const r=e.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,s=z.sep){return(0,t.hasTrailingPathSeparator)(e,s)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,s=z.sep){let r=!1;if(e.scheme===i.Schemas.file){const a=u(e);r=a!==void 0&&a.length===v.getRoot(a).length&&a[a.length-1]===s}else{s="/";const a=e.path;r=a.length===1&&a.charCodeAt(a.length-1)===47}return!r&&!(0,t.hasTrailingPathSeparator)(e,s)?e.with({path:e.path+"/"}):e}}t.ExtUri=c,t.extUri=new c(()=>!1),t.extUriBiasedIgnorePathCase=new c(n=>n.scheme===i.Schemas.file?!U.isLinux:!0),t.extUriIgnorePathCase=new c(n=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri);function f(n,e){const s=[];for(let r=0;r<n.length;r++){const a=e(n[r]);n.some((l,p)=>p===r?!1:(0,t.isEqualOrParent)(a,e(l)))||s.push(n[r])}return s}t.distinctParents=f;var I;(function(n){n.META_DATA_LABEL="label",n.META_DATA_DESCRIPTION="description",n.META_DATA_SIZE="size",n.META_DATA_MIME="mime";function e(s){const r=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(p=>{const[k,S]=p.split(":");k&&S&&r.set(k,S)});const l=s.path.substring(0,s.path.indexOf(";"));return l&&r.set(n.META_DATA_MIME,l),r}n.parseMetaData=e})(I=t.DataUri||(t.DataUri={}));function o(n,e,s){if(e){let r=n.path;return r&&r[0]!==z.posix.sep&&(r=z.posix.sep+r),n.with({scheme:s,authority:e,path:r})}return n.with({scheme:s})}t.toLocalResource=o}),define(me[8],be([1,0,26,9,3,2,35,5]),function(J,t,v,i,z,U,y,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createCancelableAsyncIterable=t.CancelableAsyncIterableObject=t.AsyncIterableObject=t.Promises=t.DeferredPromise=t.IntervalCounter=t.TaskSequentializer=t.retry=t.IdleValue=t.runWhenIdle=t.ThrottledWorker=t.RunOnceWorker=t.ProcessTimeRunOnceScheduler=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.Queue=t.Limiter=t.firstParallel=t.first=t.sequence=t.disposableTimeout=t.timeout=t.AutoOpenBarrier=t.Barrier=t.ThrottledDelayer=t.Delayer=t.MicrotaskDelay=t.SequencerByKey=t.Sequencer=t.Throttler=t.asPromise=t.raceTimeout=t.raceCancellablePromises=t.raceCancellationError=t.raceCancellation=t.createCancelablePromise=t.isThenable=void 0;function u(A){return!!A&&typeof A.then=="function"}t.isThenable=u;function c(A){const C=new v.CancellationTokenSource,h=A(C.token),B=new Promise((_,$)=>{const Y=C.token.onCancellationRequested(()=>{Y.dispose(),C.dispose(),$(new i.CancellationError)});Promise.resolve(h).then(T=>{Y.dispose(),C.dispose(),_(T)},T=>{Y.dispose(),C.dispose(),$(T)})});return new class{cancel(){C.cancel()}then(_,$){return B.then(_,$)}catch(_){return this.then(void 0,_)}finally(_){return B.finally(_)}}}t.createCancelablePromise=c;function f(A,C,h){return new Promise((B,_)=>{const $=C.onCancellationRequested(()=>{$.dispose(),B(h)});A.then(B,_).finally(()=>$.dispose())})}t.raceCancellation=f;function I(A,C){return new Promise((h,B)=>{const _=C.onCancellationRequested(()=>{_.dispose(),B(new i.CancellationError)});A.then(h,B).finally(()=>_.dispose())})}t.raceCancellationError=I;async function o(A){let C=-1;const h=A.map((_,$)=>_.then(Y=>(C=$,Y))),B=await Promise.race(h);return A.forEach((_,$)=>{$!==C&&_.cancel()}),B}t.raceCancellablePromises=o;function n(A,C,h){let B;const _=setTimeout(()=>{B?.(void 0),h?.()},C);return Promise.race([A.finally(()=>clearTimeout(_)),new Promise($=>B=$)])}t.raceTimeout=n;function e(A){return new Promise((C,h)=>{const B=A();u(B)?B.then(C,h):C(B)})}t.asPromise=e;class s{constructor(){this.a=null,this.b=null,this.d=null}queue(C){if(this.a){if(this.d=C,!this.b){const h=()=>{this.b=null;const B=this.queue(this.d);return this.d=null,B};this.b=new Promise(B=>{this.a.then(h,h).then(B)})}return new Promise((h,B)=>{this.b.then(h,B)})}return this.a=C(),new Promise((h,B)=>{this.a.then(_=>{this.a=null,h(_)},_=>{this.a=null,B(_)})})}}t.Throttler=s;class r{constructor(){this.a=Promise.resolve(null)}queue(C){return this.a=this.a.then(()=>C(),()=>C())}}t.Sequencer=r;class a{constructor(){this.a=new Map}queue(C,h){const _=(this.a.get(C)??Promise.resolve()).catch(()=>{}).then(h).finally(()=>{this.a.get(C)===_&&this.a.delete(C)});return this.a.set(C,_),_}}t.SequencerByKey=a;const l=(A,C)=>{let h=!0;const B=setTimeout(()=>{h=!1,C()},A);return{isTriggered:()=>h,dispose:()=>{clearTimeout(B),h=!1}}},p=A=>{let C=!0;return queueMicrotask(()=>{C&&(C=!1,A())}),{isTriggered:()=>C,dispose:()=>{C=!1}}};t.MicrotaskDelay=Symbol("MicrotaskDelay");class k{constructor(C){this.defaultDelay=C,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(C,h=this.defaultDelay){this.g=C,this.h(),this.b||(this.b=new Promise((_,$)=>{this.d=_,this.f=$}).then(()=>{if(this.b=null,this.d=null,this.g){const _=this.g;return this.g=null,_()}}));const B=()=>{this.a=null,this.d?.(null)};return this.a=h===t.MicrotaskDelay?p(B):l(h,B),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new i.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.Delayer=k;class S{constructor(C){this.a=new k(C),this.b=new s}trigger(C,h){return this.a.trigger(()=>this.b.queue(C),h)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}t.ThrottledDelayer=S;class g{constructor(){this.a=!1,this.b=new Promise((C,h)=>{this.d=C})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.Barrier=g;class E extends g{constructor(C){super(),this.f=setTimeout(()=>this.open(),C)}open(){clearTimeout(this.f),super.open()}}t.AutoOpenBarrier=E;function N(A,C){return C?new Promise((h,B)=>{const _=setTimeout(()=>{$.dispose(),h()},A),$=C.onCancellationRequested(()=>{clearTimeout(_),$.dispose(),B(new i.CancellationError)})}):c(h=>N(A,h))}t.timeout=N;function F(A,C=0){const h=setTimeout(A,C);return(0,U.toDisposable)(()=>clearTimeout(h))}t.disposableTimeout=F;function d(A){const C=[];let h=0;const B=A.length;function _(){return h<B?A[h++]():null}function $(Y){Y!=null&&C.push(Y);const T=_();return T?T.then($):Promise.resolve(C)}return Promise.resolve(null).then($)}t.sequence=d;function w(A,C=B=>!!B,h=null){let B=0;const _=A.length,$=()=>{if(B>=_)return Promise.resolve(h);const Y=A[B++];return Promise.resolve(Y()).then(H=>C(H)?Promise.resolve(H):$())};return $()}t.first=w;function m(A,C=B=>!!B,h=null){if(A.length===0)return Promise.resolve(h);let B=A.length;const _=()=>{B=-1;for(const $ of A)$.cancel?.()};return new Promise(($,Y)=>{for(const T of A)T.then(H=>{--B>=0&&C(H)?(_(),$(H)):B===0&&$(h)}).catch(H=>{--B>=0&&(_(),Y(H))})})}t.firstParallel=m;class D{constructor(C){this.a=0,this.d=C,this.f=[],this.b=0,this.g=new z.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(C){return this.a++,new Promise((h,B)=>{this.f.push({factory:C,c:h,e:B}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const C=this.f.shift();this.b++;const h=C.factory();h.then(C.c,C.e),h.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}t.Limiter=D;class R extends D{constructor(){super(1)}}t.Queue=R;class V{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const C=new Ne;return this.b.add(C),C.p}d(){for(const[,C]of this.a)if(C.size>0)return!1;return!0}queueFor(C,h=y.extUri){const B=h.getComparisonKey(C);let _=this.a.get(B);return _||(_=new R,z.Event.once(_.onDrained)(()=>{_?.dispose(),this.a.delete(B),this.f()}),this.a.set(B,_)),_}f(){!this.d()||this.g()}g(){for(const C of this.b)C.complete();this.b.clear()}dispose(){for(const[,C]of this.a)C.dispose();this.a.clear(),this.g()}}t.ResourceQueue=V;class Z{constructor(C,h){this.a=-1,typeof C=="function"&&typeof h=="number"&&this.setIfNotSet(C,h)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(C,h){this.cancel(),this.a=setTimeout(()=>{this.a=-1,C()},h)}setIfNotSet(C,h){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,C()},h))}}t.TimeoutTimer=Z;class X{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(C,h){this.cancel(),this.a=setInterval(()=>{C()},h)}}t.IntervalTimer=X;class x{constructor(C,h){this.b=-1,this.a=C,this.d=h,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(C=this.d){this.cancel(),this.b=setTimeout(this.f,C)}get delay(){return this.d}set delay(C){this.d=C}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.RunOnceScheduler=x;class ne{constructor(C,h){h%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${h}ms is not a multiple of 1000ms.`),this.a=C,this.b=h,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(C=this.b){C%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${C}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(C/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.ProcessTimeRunOnceScheduler=ne;class le extends x{constructor(C,h){super(C,h),this.j=[]}work(C){this.j.push(C),this.isScheduled()||this.schedule()}h(){const C=this.j;this.j=[],this.a?.(C)}dispose(){this.j=[],super.dispose()}}t.RunOnceWorker=le;class se extends U.Disposable{constructor(C,h){super(),this.g=C,this.h=h,this.a=[],this.b=this.B(new U.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(C){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+C.length>this.g.maxBufferedWork)return!1}else if(this.pending+C.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const h of C)this.a.push(h);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new x(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.ThrottledWorker=se,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.runWhenIdle=A=>{(0,b.setTimeout0)(()=>{if(C)return;const h=Date.now()+15;A(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,h-Date.now())}}))});let C=!1;return{dispose(){C||(C=!0)}}}:t.runWhenIdle=(A,C)=>{const h=requestIdleCallback(A,typeof C=="number"?{timeout:C}:void 0);let B=!1;return{dispose(){B||(B=!0,cancelIdleCallback(h))}}}}();class fe{constructor(C){this.d=!1,this.a=()=>{try{this.f=C()}catch(h){this.g=h}finally{this.d=!0}},this.b=(0,t.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}t.IdleValue=fe;async function Ae(A,C,h){let B;for(let _=0;_<h;_++)try{return await A()}catch($){B=$,await N(C)}throw B}t.retry=Ae;class te{hasPending(C){return this.a?typeof C=="number"?this.a.taskId===C:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(C,h,B){return this.a={taskId:C,cancel:()=>B?.(),promise:h},h.then(()=>this.d(C),()=>this.d(C)),h}d(C){this.a&&C===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const C=this.b;this.b=void 0,C.run().then(C.promiseResolve,C.promiseReject)}}setNext(C){if(this.b)this.b.run=C;else{let h,B;const _=new Promise(($,Y)=>{h=$,B=Y});this.b={run:C,promise:_,promiseResolve:h,promiseReject:B}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.TaskSequentializer=te;class ve{constructor(C,h=()=>Date.now()){this.d=C,this.f=h,this.a=0,this.b=0}increment(){const C=this.f();return C-this.a>this.d&&(this.a=C,this.b=0),this.b++,this.b}}t.IntervalCounter=ve;class Ne{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((C,h)=>{this.a=C,this.b=h})}complete(C){return new Promise(h=>{this.a(C),this.f=!0,h()})}error(C){return new Promise(h=>{this.b(C),this.d=!0,h()})}cancel(){new Promise(C=>{this.b(new i.CancellationError),this.d=!0,C()})}}t.DeferredPromise=Ne;var he;(function(A){async function C(B){let _;const $=await Promise.all(B.map(Y=>Y.then(T=>T,T=>{_||(_=T)})));if(typeof _<"u")throw _;return $}A.settled=C;function h(B){return new Promise(async(_,$)=>{try{await B(_,$)}catch(Y){$(Y)}})}A.withAsyncBody=h})(he=t.Promises||(t.Promises={}));var Q;(function(A){A[A.Initial=0]="Initial",A[A.DoneOK=1]="DoneOK",A[A.DoneError=2]="DoneError"})(Q||(Q={}));class oe{static fromArray(C){return new oe(h=>{h.emitMany(C)})}static fromPromise(C){return new oe(async h=>{h.emitMany(await C)})}static fromPromises(C){return new oe(async h=>{await Promise.all(C.map(async B=>h.emitOne(await B)))})}static merge(C){return new oe(async h=>{await Promise.all(C.map(async B=>{for await(const _ of B)h.emitOne(_)}))})}constructor(C){this.a=0,this.b=[],this.d=null,this.f=new z.Emitter,queueMicrotask(async()=>{const h={emitOne:B=>this.g(B),emitMany:B=>this.h(B),reject:B=>this.k(B)};try{await Promise.resolve(C(h)),this.j()}catch(B){this.k(B)}finally{h.emitOne=void 0,h.emitMany=void 0,h.reject=void 0}})}[Symbol.asyncIterator](){let C=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(C<this.b.length)return{done:!1,value:this.b[C++]};if(this.a===1)return{done:!0,value:void 0};await z.Event.toPromise(this.f.event)}while(!0)}}}static map(C,h){return new oe(async B=>{for await(const _ of C)B.emitOne(h(_))})}map(C){return oe.map(this,C)}static filter(C,h){return new oe(async B=>{for await(const _ of C)h(_)&&B.emitOne(_)})}filter(C){return oe.filter(this,C)}static coalesce(C){return oe.filter(C,h=>!!h)}coalesce(){return oe.coalesce(this)}static async toPromise(C){const h=[];for await(const B of C)h.push(B);return h}toPromise(){return oe.toPromise(this)}g(C){this.a===0&&(this.b.push(C),this.f.fire())}h(C){this.a===0&&(this.b=this.b.concat(C),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(C){this.a===0&&(this.a=2,this.d=C,this.f.fire())}}t.AsyncIterableObject=oe,oe.EMPTY=oe.fromArray([]);class re extends oe{constructor(C,h){super(h),this.l=C}cancel(){this.l.cancel()}}t.CancelableAsyncIterableObject=re;function ie(A){const C=new v.CancellationTokenSource,h=A(C.token);return new re(C,async B=>{const _=C.token.onCancellationRequested(()=>{_.dispose(),C.dispose(),B.reject(new i.CancellationError)});try{for await(const $ of h){if(C.token.isCancellationRequested)return;B.emitOne($)}_.dispose(),C.dispose()}catch($){_.dispose(),C.dispose(),B.reject($)}})}t.createCancelableAsyncIterable=ie}),define(me[4],be([1,0,17,108,15,20,8,9,3,114,2,34,5,6,16]),function(J,t,v,i,z,U,y,b,u,c,f,I,o,n,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.h=t.DragAndDropObserver=t.getCookieValue=t.ModifierKeyEmitter=t.multibyteAwareBtoa=t.safeInnerHtml=t.basicMarkupHtmlTags=t.hookDomPurifyHrefAndSrcSanitizer=t.detectFullscreen=t.DetectedFullscreenMode=t.triggerUpload=t.triggerDownload=t.asCssValueWithDefault=t.asCSSPropertyValue=t.asCSSUrl=t.animate=t.windowOpenWithSuccess=t.windowOpenPopup=t.windowOpenNoOpener=t.computeScreenAwareSize=t.domContentLoaded=t.finalHandler=t.removeTabIndexAndUpdateFocus=t.hide=t.show=t.join=t.$=t.Namespace=t.reset=t.prepend=t.append=t.after=t.trackFocus=t.restoreParentsScrollTop=t.saveParentsScrollTop=t.EventHelper=t.isEventLike=t.EventType=t.isHTMLElement=t.removeCSSRulesContainingSelector=t.createCSSRule=t.createMetaElement=t.createStyleSheet=t.getActiveElement=t.getShadowRoot=t.isInShadowDOM=t.isShadowRoot=t.hasParentWithClass=t.findParentWithClass=t.isAncestorUsingFlowTo=t.setParentFlowTo=t.isAncestor=t.getLargestChildWidth=t.getTotalHeight=t.getContentHeight=t.getTotalScrollWidth=t.getContentWidth=t.getTotalWidth=t.getDomNodeZoomLevel=t.getDomNodePagePosition=t.position=t.size=t.getTopLeftOffset=t.Dimension=t.getClientArea=t.getComputedStyle=t.addDisposableThrottledListener=t.modify=t.measure=t.scheduleAtNextAnimationFrame=t.runAtThisOrScheduleAtNextAnimationFrame=t.addDisposableGenericMouseUpListener=t.addDisposableGenericMouseMoveListener=t.addDisposableGenericMouseDownListener=t.addStandardDisposableGenericMouseUpListener=t.addStandardDisposableGenericMouseDownListener=t.addStandardDisposableListener=t.addDisposableListener=t.isInDOM=t.clearNode=void 0;function s(G){for(;G.firstChild;)G.firstChild.remove()}t.clearNode=s;function r(G){return G?.isConnected??!1}t.isInDOM=r;class a{constructor(q,ge,ke,Te){this.f=q,this.g=ge,this.d=ke,this.j=Te||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){!this.d||(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function l(G,q,ge,ke){return new a(G,q,ge,ke)}t.addDisposableListener=l;function p(G){return function(q){return G(new U.StandardMouseEvent(q))}}function k(G){return function(q){return G(new z.StandardKeyboardEvent(q))}}const S=function(q,ge,ke,Te){let Ve=ke;return ge==="click"||ge==="mousedown"?Ve=p(ke):(ge==="keydown"||ge==="keypress"||ge==="keyup")&&(Ve=k(ke)),l(q,ge,Ve,Te)};t.addStandardDisposableListener=S;const g=function(q,ge,ke){const Te=p(ge);return N(q,Te,ke)};t.addStandardDisposableGenericMouseDownListener=g;const E=function(q,ge,ke){const Te=p(ge);return d(q,Te,ke)};t.addStandardDisposableGenericMouseUpListener=E;function N(G,q,ge){return l(G,o.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_DOWN:t.EventType.MOUSE_DOWN,q,ge)}t.addDisposableGenericMouseDownListener=N;function F(G,q,ge){return l(G,o.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_MOVE:t.EventType.MOUSE_MOVE,q,ge)}t.addDisposableGenericMouseMoveListener=F;function d(G,q,ge){return l(G,o.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_UP:t.EventType.MOUSE_UP,q,ge)}t.addDisposableGenericMouseUpListener=d;class w{constructor(q,ge=0){this.d=q,this.priority=ge,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(q){(0,b.onUnexpectedError)(q)}}static sort(q,ge){return ge.priority-q.priority}}(function(){let G=[],q=null,ge=!1,ke=!1;const Te=()=>{for(ge=!1,q=G,G=[],ke=!0;q.length>0;)q.sort(w.sort),q.shift().execute();ke=!1};t.scheduleAtNextAnimationFrame=(Ve,_e=0)=>{const Xe=new w(Ve,_e);return G.push(Xe),ge||(ge=!0,requestAnimationFrame(Te)),Xe},t.runAtThisOrScheduleAtNextAnimationFrame=(Ve,_e)=>{if(ke){const Xe=new w(Ve,_e);return q.push(Xe),Xe}else return(0,t.scheduleAtNextAnimationFrame)(Ve,_e)}})();function m(G){return(0,t.scheduleAtNextAnimationFrame)(G,1e4)}t.measure=m;function D(G){return(0,t.scheduleAtNextAnimationFrame)(G,-1e4)}t.modify=D;const R=8,V=function(G,q){return q};class Z extends f.Disposable{constructor(q,ge,ke,Te=V,Ve=R){super();let _e=null,Xe=0;const Je=this.B(new y.TimeoutTimer),ft=()=>{Xe=new Date().getTime(),ke(_e),_e=null};this.B(l(q,ge,Lt=>{_e=Te(_e,Lt);const gt=new Date().getTime()-Xe;gt>=Ve?(Je.cancel(),ft()):Je.setIfNotSet(ft,Ve-gt)}))}}function X(G,q,ge,ke,Te){return new Z(G,q,ge,ke,Te)}t.addDisposableThrottledListener=X;function x(G){return document.defaultView.getComputedStyle(G,null)}t.getComputedStyle=x;function ne(G){if(G!==document.body)return new se(G.clientWidth,G.clientHeight);if(o.isIOS&&window.visualViewport)return new se(window.visualViewport.width,window.visualViewport.height);if(window.innerWidth&&window.innerHeight)return new se(window.innerWidth,window.innerHeight);if(document.body&&document.body.clientWidth&&document.body.clientHeight)return new se(document.body.clientWidth,document.body.clientHeight);if(document.documentElement&&document.documentElement.clientWidth&&document.documentElement.clientHeight)return new se(document.documentElement.clientWidth,document.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.getClientArea=ne;class le{static d(q,ge){return parseFloat(ge)||0}static f(q,ge,ke){const Te=x(q),Ve=Te?Te.getPropertyValue(ge):"0";return le.d(q,Ve)}static getBorderLeftWidth(q){return le.f(q,"border-left-width","borderLeftWidth")}static getBorderRightWidth(q){return le.f(q,"border-right-width","borderRightWidth")}static getBorderTopWidth(q){return le.f(q,"border-top-width","borderTopWidth")}static getBorderBottomWidth(q){return le.f(q,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(q){return le.f(q,"padding-left","paddingLeft")}static getPaddingRight(q){return le.f(q,"padding-right","paddingRight")}static getPaddingTop(q){return le.f(q,"padding-top","paddingTop")}static getPaddingBottom(q){return le.f(q,"padding-bottom","paddingBottom")}static getMarginLeft(q){return le.f(q,"margin-left","marginLeft")}static getMarginTop(q){return le.f(q,"margin-top","marginTop")}static getMarginRight(q){return le.f(q,"margin-right","marginRight")}static getMarginBottom(q){return le.f(q,"margin-bottom","marginBottom")}}class se{constructor(q,ge){this.width=q,this.height=ge}with(q=this.width,ge=this.height){return q!==this.width||ge!==this.height?new se(q,ge):this}static is(q){return typeof q=="object"&&typeof q.height=="number"&&typeof q.width=="number"}static lift(q){return q instanceof se?q:new se(q.width,q.height)}static equals(q,ge){return q===ge?!0:!q||!ge?!1:q.width===ge.width&&q.height===ge.height}}t.Dimension=se,se.None=new se(0,0);function fe(G){let q=G.offsetParent,ge=G.offsetTop,ke=G.offsetLeft;for(;(G=G.parentNode)!==null&&G!==document.body&&G!==document.documentElement;){ge-=G.scrollTop;const Te=W(G)?null:x(G);Te&&(ke-=Te.direction!=="rtl"?G.scrollLeft:-G.scrollLeft),G===q&&(ke+=le.getBorderLeftWidth(G),ge+=le.getBorderTopWidth(G),ge+=G.offsetTop,ke+=G.offsetLeft,q=G.offsetParent)}return{left:ke,top:ge}}t.getTopLeftOffset=fe;function Ae(G,q,ge){typeof q=="number"&&(G.style.width=`${q}px`),typeof ge=="number"&&(G.style.height=`${ge}px`)}t.size=Ae;function te(G,q,ge,ke,Te,Ve="absolute"){typeof q=="number"&&(G.style.top=`${q}px`),typeof ge=="number"&&(G.style.right=`${ge}px`),typeof ke=="number"&&(G.style.bottom=`${ke}px`),typeof Te=="number"&&(G.style.left=`${Te}px`),G.style.position=Ve}t.position=te;function ve(G){const q=G.getBoundingClientRect();return{left:q.left+window.scrollX,top:q.top+window.scrollY,width:q.width,height:q.height}}t.getDomNodePagePosition=ve;function Ne(G){let q=G,ge=1;do{const ke=x(q).zoom;ke!=null&&ke!=="1"&&(ge*=ke),q=q.parentElement}while(q!==null&&q!==document.documentElement);return ge}t.getDomNodeZoomLevel=Ne;function he(G){const q=le.getMarginLeft(G)+le.getMarginRight(G);return G.offsetWidth+q}t.getTotalWidth=he;function Q(G){const q=le.getBorderLeftWidth(G)+le.getBorderRightWidth(G),ge=le.getPaddingLeft(G)+le.getPaddingRight(G);return G.offsetWidth-q-ge}t.getContentWidth=Q;function oe(G){const q=le.getMarginLeft(G)+le.getMarginRight(G);return G.scrollWidth+q}t.getTotalScrollWidth=oe;function re(G){const q=le.getBorderTopWidth(G)+le.getBorderBottomWidth(G),ge=le.getPaddingTop(G)+le.getPaddingBottom(G);return G.offsetHeight-q-ge}t.getContentHeight=re;function ie(G){const q=le.getMarginTop(G)+le.getMarginBottom(G);return G.offsetHeight+q}t.getTotalHeight=ie;function A(G,q){if(G===null)return 0;const ge=fe(G),ke=fe(q);return ge.left-ke.left}function C(G,q){const ge=q.map(Te=>Math.max(oe(Te),he(Te))+A(Te,G)||0);return Math.max(...ge)}t.getLargestChildWidth=C;function h(G,q){for(;G;){if(G===q)return!0;G=G.parentNode}return!1}t.isAncestor=h;const B="parentFlowToElementId";function _(G,q){G.dataset[B]=q.id}t.setParentFlowTo=_;function $(G){const q=G.dataset[B];return typeof q=="string"?document.getElementById(q):null}function Y(G,q){let ge=G;for(;ge;){if(ge===q)return!0;if(ge instanceof HTMLElement){const ke=$(ge);if(ke){ge=ke;continue}}ge=ge.parentNode}return!1}t.isAncestorUsingFlowTo=Y;function T(G,q,ge){for(;G&&G.nodeType===G.ELEMENT_NODE;){if(G.classList.contains(q))return G;if(ge){if(typeof ge=="string"){if(G.classList.contains(ge))return null}else if(G===ge)return null}G=G.parentNode}return null}t.findParentWithClass=T;function H(G,q,ge){return!!T(G,q,ge)}t.hasParentWithClass=H;function W(G){return G&&!!G.host&&!!G.mode}t.isShadowRoot=W;function L(G){return!!M(G)}t.isInShadowDOM=L;function M(G){for(;G.parentNode;){if(G===document.body)return null;G=G.parentNode}return W(G)?G:null}t.getShadowRoot=M;function P(){let G=document.activeElement;for(;G?.shadowRoot;)G=G.shadowRoot.activeElement;return G}t.getActiveElement=P;function O(G=document.getElementsByTagName("head")[0]){const q=document.createElement("style");return q.type="text/css",q.media="screen",G.appendChild(q),q}t.createStyleSheet=O;function j(G=document.getElementsByTagName("head")[0]){const q=document.createElement("meta");return G.appendChild(q),q}t.createMetaElement=j;let ee=null;function ce(){return ee||(ee=O()),ee}function de(G){return G?.sheet?.rules?G.sheet.rules:G?.sheet?.cssRules?G.sheet.cssRules:[]}function De(G,q,ge=ce()){!ge||!q||ge.sheet.insertRule(G+"{"+q+"}",0)}t.createCSSRule=De;function ye(G,q=ce()){if(!q)return;const ge=de(q),ke=[];for(let Te=0;Te<ge.length;Te++)ge[Te].selectorText.indexOf(G)!==-1&&ke.push(Te);for(let Te=ke.length-1;Te>=0;Te--)q.sheet.deleteRule(ke[Te])}t.removeCSSRulesContainingSelector=ye;function Ie(G){return typeof HTMLElement=="object"?G instanceof HTMLElement:G&&typeof G=="object"&&G.nodeType===1&&typeof G.nodeName=="string"}t.isHTMLElement=Ie,t.EventType={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:v.isWebKit?"webkitAnimationStart":"animationstart",ANIMATION_END:v.isWebKit?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:v.isWebKit?"webkitAnimationIteration":"animationiteration"};function Se(G){const q=G;return!!(q&&typeof q.preventDefault=="function"&&typeof q.stopPropagation=="function")}t.isEventLike=Se,t.EventHelper={stop:(G,q)=>(G.preventDefault(),q&&G.stopPropagation(),G)};function we(G){const q=[];for(let ge=0;G&&G.nodeType===G.ELEMENT_NODE;ge++)q[ge]=G.scrollTop,G=G.parentNode;return q}t.saveParentsScrollTop=we;function Re(G,q){for(let ge=0;G&&G.nodeType===G.ELEMENT_NODE;ge++)G.scrollTop!==q[ge]&&(G.scrollTop=q[ge]),G=G.parentNode}t.restoreParentsScrollTop=Re;class Pe extends f.Disposable{static l(q){const ge=M(q),ke=ge?ge.activeElement:document.activeElement;return h(ke,q)}constructor(q){super(),this.f=this.B(new u.Emitter),this.onDidFocus=this.f.event,this.g=this.B(new u.Emitter),this.onDidBlur=this.g.event;let ge=Pe.l(q),ke=!1;const Te=()=>{ke=!1,ge||(ge=!0,this.f.fire())},Ve=()=>{ge&&(ke=!0,window.setTimeout(()=>{ke&&(ke=!1,ge=!1,this.g.fire())},0))};this.j=()=>{Pe.l(q)!==ge&&(ge?Ve():Te())},this.B(l(q,t.EventType.FOCUS,Te,!0)),this.B(l(q,t.EventType.BLUR,Ve,!0)),this.B(l(q,t.EventType.FOCUS_IN,()=>this.j())),this.B(l(q,t.EventType.FOCUS_OUT,()=>this.j()))}refreshState(){this.j()}}function Ke(G){return new Pe(G)}t.trackFocus=Ke;function Ue(G,q){return G.after(q),q}t.after=Ue;function We(G,...q){if(G.append(...q),q.length===1&&typeof q[0]!="string")return q[0]}t.append=We;function xe(G,q){return G.insertBefore(q,G.firstChild),q}t.prepend=xe;function it(G,...q){G.innerText="",We(G,...q)}t.reset=it;const Be=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var je;(function(G){G.HTML="http://www.w3.org/1999/xhtml",G.SVG="http://www.w3.org/2000/svg"})(je=t.Namespace||(t.Namespace={}));function Ye(G,q,ge,...ke){const Te=Be.exec(q);if(!Te)throw new Error("Bad use of emmet");const Ve=Te[1]||"div";let _e;return G!==je.HTML?_e=document.createElementNS(G,Ve):_e=document.createElement(Ve),Te[3]&&(_e.id=Te[3]),Te[4]&&(_e.className=Te[4].replace(/\./g," ").trim()),ge&&Object.entries(ge).forEach(([Xe,Je])=>{typeof Je>"u"||(/^on\w+$/.test(Xe)?_e[Xe]=Je:Xe==="selected"?Je&&_e.setAttribute(Xe,"true"):_e.setAttribute(Xe,Je))}),_e.append(...ke),_e}function K(G,q,...ge){return Ye(je.HTML,G,q,...ge)}t.$=K,K.SVG=function(G,q,...ge){return Ye(je.SVG,G,q,...ge)};function ue(G,q){const ge=[];return G.forEach((ke,Te)=>{Te>0&&(q instanceof Node?ge.push(q.cloneNode()):ge.push(document.createTextNode(q))),ge.push(ke)}),ge}t.join=ue;function pe(...G){for(const q of G)q.style.display="",q.removeAttribute("aria-hidden")}t.show=pe;function Ee(...G){for(const q of G)q.style.display="none",q.setAttribute("aria-hidden","true")}t.hide=Ee;function Fe(G,q){for(;G&&G.nodeType===G.ELEMENT_NODE;){if(G instanceof HTMLElement&&G.hasAttribute(q))return G;G=G.parentNode}return null}function Oe(G){!G||!G.hasAttribute("tabIndex")||(document.activeElement===G&&Fe(G.parentElement,"tabIndex")?.focus(),G.removeAttribute("tabindex"))}t.removeTabIndexAndUpdateFocus=Oe;function $e(G){return q=>{q.preventDefault(),q.stopPropagation(),G(q)}}t.finalHandler=$e;function tt(){return new Promise(G=>{document.readyState==="complete"||document&&document.body!==null?G(void 0):window.addEventListener("DOMContentLoaded",G,!1)})}t.domContentLoaded=tt;function Me(G){const q=window.devicePixelRatio*G;return Math.max(1,Math.floor(q))/window.devicePixelRatio}t.computeScreenAwareSize=Me;function ae(G){window.open(G,"_blank","noopener")}t.windowOpenNoOpener=ae;const Ce=780,Le=640;function ze(G){const q=Math.floor(window.screenLeft+window.innerWidth/2-Ce/2),ge=Math.floor(window.screenTop+window.innerHeight/2-Le/2);window.open(G,"_blank",`width=${Ce},height=${Le},top=${ge},left=${q}`)}t.windowOpenPopup=ze;function Ge(G,q=!0){const ge=window.open();return ge?(q&&(ge.opener=null),ge.location.href=G,!0):!1}t.windowOpenWithSuccess=Ge;function Ze(G){const q=()=>{G(),ge=(0,t.scheduleAtNextAnimationFrame)(q)};let ge=(0,t.scheduleAtNextAnimationFrame)(q);return(0,f.toDisposable)(()=>ge.dispose())}t.animate=Ze,I.RemoteAuthorities.setPreferredWebSchema(/^https:/.test(window.location.href)?"https":"http");function Qe(G){return G?`url('${I.FileAccess.uriToBrowserUri(G).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.asCSSUrl=Qe;function st(G){return`'${G.replace(/'/g,"%27")}'`}t.asCSSPropertyValue=st;function ht(G,q){if(G!==void 0){const ge=G.match(/^\s*var\((.+)\)$/);if(ge){const ke=ge[1].split(",",2);return ke.length===2&&(q=ht(ke[1].trim(),q)),`var(${ke[0]}, ${q})`}return G}return q}t.asCssValueWithDefault=ht;function Et(G,q){let ge;if(e.URI.isUri(G))ge=G.toString(!0);else{const Te=new Blob([G]);ge=URL.createObjectURL(Te),setTimeout(()=>URL.revokeObjectURL(ge))}const ke=document.createElement("a");document.body.appendChild(ke),ke.download=q,ke.href=ge,ke.click(),setTimeout(()=>document.body.removeChild(ke))}t.triggerDownload=Et;function Tt(){return new Promise(G=>{const q=document.createElement("input");document.body.appendChild(q),q.type="file",q.multiple=!0,u.Event.once(u.Event.fromDOMEventEmitter(q,"input"))(()=>{G((0,n.withNullAsUndefined)(q.files))}),q.click(),setTimeout(()=>document.body.removeChild(q))})}t.triggerUpload=Tt;var wt;(function(G){G[G.DOCUMENT=1]="DOCUMENT",G[G.BROWSER=2]="BROWSER"})(wt=t.DetectedFullscreenMode||(t.DetectedFullscreenMode={}));function ui(){return document.fullscreenElement||document.webkitFullscreenElement||document.webkitIsFullScreen?{mode:wt.DOCUMENT,guess:!1}:window.innerHeight===screen.height?{mode:wt.BROWSER,guess:!1}:(o.isMacintosh||o.isLinux)&&window.outerHeight===screen.height&&window.outerWidth===screen.width?{mode:wt.BROWSER,guess:!0}:null}t.detectFullscreen=ui;function Wt(G,q=!1){const ge=document.createElement("a");return c.addHook("afterSanitizeAttributes",ke=>{for(const Te of["href","src"])if(ke.hasAttribute(Te)){const Ve=ke.getAttribute(Te);if(Te==="href"&&Ve.startsWith("#"))continue;if(ge.href=Ve,!G.includes(ge.protocol.replace(/:$/,""))){if(q&&Te==="src"&&ge.href.startsWith("data:"))continue;ke.removeAttribute(Te)}}}),(0,f.toDisposable)(()=>{c.removeHook("afterSanitizeAttributes")})}t.hookDomPurifyHrefAndSrcSanitizer=Wt;const ci=[I.Schemas.http,I.Schemas.https,I.Schemas.command];t.basicMarkupHtmlTags=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const di=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function fi(G,q){const ge=Wt(ci);try{const ke=c.sanitize(q,di);G.innerHTML=ke}finally{ge.dispose()}}t.safeInnerHtml=fi;function gi(G){const q=new Uint16Array(G.length);for(let Te=0;Te<q.length;Te++)q[Te]=G.charCodeAt(Te);let ge="";const ke=new Uint8Array(q.buffer);for(let Te=0;Te<ke.length;Te++)ge+=String.fromCharCode(ke[Te]);return ge}function mi(G){return btoa(gi(G))}t.multibyteAwareBtoa=mi;class dt extends u.Emitter{constructor(){super(),this.s=new f.DisposableStore,this.t={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.s.add(l(window,"keydown",q=>{if(q.defaultPrevented)return;const ge=new z.StandardKeyboardEvent(q);if(!(ge.keyCode===6&&q.repeat)){if(q.altKey&&!this.t.altKey)this.t.lastKeyPressed="alt";else if(q.ctrlKey&&!this.t.ctrlKey)this.t.lastKeyPressed="ctrl";else if(q.metaKey&&!this.t.metaKey)this.t.lastKeyPressed="meta";else if(q.shiftKey&&!this.t.shiftKey)this.t.lastKeyPressed="shift";else if(ge.keyCode!==6)this.t.lastKeyPressed=void 0;else return;this.t.altKey=q.altKey,this.t.ctrlKey=q.ctrlKey,this.t.metaKey=q.metaKey,this.t.shiftKey=q.shiftKey,this.t.lastKeyPressed&&(this.t.event=q,this.fire(this.t))}},!0)),this.s.add(l(window,"keyup",q=>{q.defaultPrevented||(!q.altKey&&this.t.altKey?this.t.lastKeyReleased="alt":!q.ctrlKey&&this.t.ctrlKey?this.t.lastKeyReleased="ctrl":!q.metaKey&&this.t.metaKey?this.t.lastKeyReleased="meta":!q.shiftKey&&this.t.shiftKey?this.t.lastKeyReleased="shift":this.t.lastKeyReleased=void 0,this.t.lastKeyPressed!==this.t.lastKeyReleased&&(this.t.lastKeyPressed=void 0),this.t.altKey=q.altKey,this.t.ctrlKey=q.ctrlKey,this.t.metaKey=q.metaKey,this.t.shiftKey=q.shiftKey,this.t.lastKeyReleased&&(this.t.event=q,this.fire(this.t)))},!0)),this.s.add(l(document.body,"mousedown",()=>{this.t.lastKeyPressed=void 0},!0)),this.s.add(l(document.body,"mouseup",()=>{this.t.lastKeyPressed=void 0},!0)),this.s.add(l(document.body,"mousemove",q=>{q.buttons&&(this.t.lastKeyPressed=void 0)},!0)),this.s.add(l(window,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.t}get isModifierPressed(){return this.t.altKey||this.t.ctrlKey||this.t.metaKey||this.t.shiftKey}resetKeyStatus(){this.v(),this.fire(this.t)}v(){this.t={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return dt.u||(dt.u=new dt),dt.u}dispose(){super.dispose(),this.s.dispose()}}t.ModifierKeyEmitter=dt;function bi(G){const q=document.cookie.match("(^|[^;]+)\\s*"+G+"\\s*=\\s*([^;]+)");return q?q.pop():void 0}t.getCookieValue=bi;class pi extends f.Disposable{constructor(q,ge){super(),this.j=q,this.l=ge,this.f=0,this.g=0,this.m()}m(){this.B(l(this.j,t.EventType.DRAG_ENTER,q=>{this.f++,this.g=q.timeStamp,this.l.onDragEnter(q)})),this.B(l(this.j,t.EventType.DRAG_OVER,q=>{q.preventDefault(),this.l.onDragOver?.(q,q.timeStamp-this.g)})),this.B(l(this.j,t.EventType.DRAG_LEAVE,q=>{this.f--,this.f===0&&(this.g=0,this.l.onDragLeave(q))})),this.B(l(this.j,t.EventType.DRAG_END,q=>{this.f=0,this.g=0,this.l.onDragEnd(q)})),this.B(l(this.j,t.EventType.DROP,q=>{this.f=0,this.g=0,this.l.onDrop(q)}))}}t.DragAndDropObserver=pi;const wi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function vi(G,...q){let ge,ke;Array.isArray(q[0])?(ge={},ke=q[0]):(ge=q[0]||{},ke=q[1]);const Te=wi.exec(G);if(!Te||!Te.groups)throw new Error("Bad use of h");const Ve=Te.groups.tag||"div",_e=document.createElement(Ve);Te.groups.id&&(_e.id=Te.groups.id),Te.groups.class&&(_e.className=Te.groups.class.replace(/\./g," ").trim());const Xe={};if(Te.groups.name&&(Xe[Te.groups.name]=_e),ke)for(const Je of ke)Je instanceof HTMLElement?_e.appendChild(Je):typeof Je=="string"?_e.append(Je):(Object.assign(Xe,Je),_e.appendChild(Je.root));for(const[Je,ft]of Object.entries(ge))if(Je==="style")for(const[Lt,gt]of Object.entries(ft))_e.style.setProperty(_t(Lt),typeof gt=="number"?gt+"px":""+gt);else Je==="tabIndex"?_e.tabIndex=ft:_e.setAttribute(_t(Je),ft.toString());return Xe.root=_e,Xe}t.h=vi;function _t(G){return G.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}}),define(me[51],be([1,0,4,2,106]),function(J,t,v,i,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.applyDragImage=t.DataTransfers=t.DelayedDragHandler=void 0;class U extends i.Disposable{constructor(u,c){super(),this.B((0,v.addDisposableListener)(u,"dragover",f=>{f.preventDefault(),this.a||(this.a=setTimeout(()=>{c(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(f=>{this.B((0,v.addDisposableListener)(u,f,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.DelayedDragHandler=U,t.DataTransfers={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:z.Mimes.text};function y(b,u,c,f,I){const o=document.createElement("div");o.className=c,o.textContent=u,I&&(o.style.color=I),f&&(o.style.background=f),b.dataTransfer&&(document.body.appendChild(o),b.dataTransfer.setDragImage(o,-10,-10),setTimeout(()=>document.body.removeChild(o),0))}t.applyDragImage=y}),define(me[52],be([1,0,4]),function(J,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createElement=t.renderFormattedText=t.renderText=void 0;function i(o,n={}){const e=U(n);return e.textContent=o,e}t.renderText=i;function z(o,n={}){const e=U(n);return u(e,c(o,!!n.renderCodeSegments),n.actionHandler,n.renderCodeSegments),e}t.renderFormattedText=z;function U(o){const n=o.inline?"span":"div",e=document.createElement(n);return o.className&&(e.className=o.className),e}t.createElement=U;class y{constructor(n){this.b=n,this.c=0}eos(){return this.c>=this.b.length}next(){const n=this.peek();return this.advance(),n}peek(){return this.b[this.c]}advance(){this.c++}}var b;(function(o){o[o.Invalid=0]="Invalid",o[o.Root=1]="Root",o[o.Text=2]="Text",o[o.Bold=3]="Bold",o[o.Italics=4]="Italics",o[o.Action=5]="Action",o[o.ActionClose=6]="ActionClose",o[o.Code=7]="Code",o[o.NewLine=8]="NewLine"})(b||(b={}));function u(o,n,e,s){let r;if(n.type===2)r=document.createTextNode(n.content||"");else if(n.type===3)r=document.createElement("b");else if(n.type===4)r=document.createElement("i");else if(n.type===7&&s)r=document.createElement("code");else if(n.type===5&&e){const a=document.createElement("a");e.disposables.add(v.addStandardDisposableListener(a,"click",l=>{e.callback(String(n.index),l)})),r=a}else n.type===8?r=document.createElement("br"):n.type===1&&(r=o);r&&o!==r&&o.appendChild(r),r&&Array.isArray(n.children)&&n.children.forEach(a=>{u(r,a,e,s)})}function c(o,n){const e={type:1,children:[]};let s=0,r=e;const a=[],l=new y(o);for(;!l.eos();){let p=l.next();const k=p==="\\"&&I(l.peek(),n)!==0;if(k&&(p=l.next()),!k&&f(p,n)&&p===l.peek()){l.advance(),r.type===2&&(r=a.pop());const S=I(p,n);if(r.type===S||r.type===5&&S===6)r=a.pop();else{const g={type:S,children:[]};S===5&&(g.index=s,s++),r.children.push(g),a.push(r),r=g}}else if(p===`
`)r.type===2&&(r=a.pop()),r.children.push({type:8});else if(r.type!==2){const S={type:2,content:p};r.children.push(S),a.push(r),r=S}else r.content+=p}return r.type===2&&(r=a.pop()),a.length,e}function f(o,n){return I(o,n)!==0}function I(o,n){switch(o){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return n?7:0;default:return 0}}}),define(me[53],be([1,0,4,2]),function(J,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GlobalPointerMoveMonitor=void 0;class z{constructor(){this.a=new i.DisposableStore,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(y,b){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const u=this.c;this.c=null,y&&u&&u(b)}isMonitoring(){return!!this.b}startMonitoring(y,b,u,c,f){this.isMonitoring()&&this.stopMonitoring(!1),this.b=c,this.c=f;let I=y;try{y.setPointerCapture(b),this.a.add((0,i.toDisposable)(()=>{try{y.releasePointerCapture(b)}catch{}}))}catch{I=window}this.a.add(v.addDisposableListener(I,v.EventType.POINTER_MOVE,o=>{if(o.buttons!==u){this.stopMonitoring(!0);return}o.preventDefault(),this.b(o)})),this.a.add(v.addDisposableListener(I,v.EventType.POINTER_UP,o=>this.stopMonitoring(!0)))}}t.GlobalPointerMoveMonitor=z});var qe=this&&this.__decorate||function(J,t,v,i){var z=arguments.length,U=z<3?t:i===null?i=Object.getOwnPropertyDescriptor(t,v):i,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")U=Reflect.decorate(J,t,v,i);else for(var b=J.length-1;b>=0;b--)(y=J[b])&&(U=(z<3?y(U):z>3?y(t,v,U):y(t,v))||U);return z>3&&U&&Object.defineProperty(t,v,U),U};define(me[22],be([1,0,4,14,24,2,45]),function(J,t,v,i,z,U,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Gesture=t.EventType=void 0;var b;(function(c){c.Tap="-monaco-gesturetap",c.Change="-monaco-gesturechange",c.Start="-monaco-gesturestart",c.End="-monaco-gesturesend",c.Contextmenu="-monaco-gesturecontextmenu"})(b=t.EventType||(t.EventType={}));class u extends U.Disposable{constructor(){super(),this.f=!1,this.g=new y.LinkedList,this.h=new y.LinkedList,this.k={},this.j=null,this.l=0,this.B(v.addDisposableListener(document,"touchstart",f=>this.n(f),{passive:!1})),this.B(v.addDisposableListener(document,"touchend",f=>this.p(f))),this.B(v.addDisposableListener(document,"touchmove",f=>this.v(f),{passive:!1}))}static addTarget(f){if(!u.isTouchDevice())return U.Disposable.None;u.b||(u.b=new u);const I=u.b.g.push(f);return(0,U.toDisposable)(I)}static ignoreTarget(f){if(!u.isTouchDevice())return U.Disposable.None;u.b||(u.b=new u);const I=u.b.h.push(f);return(0,U.toDisposable)(I)}static isTouchDevice(){return"ontouchstart"in window||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}n(f){const I=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let o=0,n=f.targetTouches.length;o<n;o++){const e=f.targetTouches.item(o);this.k[e.identifier]={id:e.identifier,initialTarget:e.target,initialTimeStamp:I,initialPageX:e.pageX,initialPageY:e.pageY,rollingTimestamps:[I],rollingPageX:[e.pageX],rollingPageY:[e.pageY]};const s=this.r(b.Start,e.target);s.pageX=e.pageX,s.pageY=e.pageY,this.s(s)}this.f&&(f.preventDefault(),f.stopPropagation(),this.f=!1)}p(f){const I=Date.now(),o=Object.keys(this.k).length;for(let n=0,e=f.changedTouches.length;n<e;n++){const s=f.changedTouches.item(n);if(!this.k.hasOwnProperty(String(s.identifier))){console.warn("move of an UNKNOWN touch",s);continue}const r=this.k[s.identifier],a=Date.now()-r.initialTimeStamp;if(a<u.c&&Math.abs(r.initialPageX-i.tail(r.rollingPageX))<30&&Math.abs(r.initialPageY-i.tail(r.rollingPageY))<30){const l=this.r(b.Tap,r.initialTarget);l.pageX=i.tail(r.rollingPageX),l.pageY=i.tail(r.rollingPageY),this.s(l)}else if(a>=u.c&&Math.abs(r.initialPageX-i.tail(r.rollingPageX))<30&&Math.abs(r.initialPageY-i.tail(r.rollingPageY))<30){const l=this.r(b.Contextmenu,r.initialTarget);l.pageX=i.tail(r.rollingPageX),l.pageY=i.tail(r.rollingPageY),this.s(l)}else if(o===1){const l=i.tail(r.rollingPageX),p=i.tail(r.rollingPageY),k=i.tail(r.rollingTimestamps)-r.rollingTimestamps[0],S=l-r.rollingPageX[0],g=p-r.rollingPageY[0],E=[...this.g].filter(N=>r.initialTarget instanceof Node&&N.contains(r.initialTarget));this.u(E,I,Math.abs(S)/k,S>0?1:-1,l,Math.abs(g)/k,g>0?1:-1,p)}this.s(this.r(b.End,r.initialTarget)),delete this.k[s.identifier]}this.f&&(f.preventDefault(),f.stopPropagation(),this.f=!1)}r(f,I){const o=document.createEvent("CustomEvent");return o.initEvent(f,!1,!0),o.initialTarget=I,o.tapCount=0,o}s(f){if(f.type===b.Tap){const I=new Date().getTime();let o=0;I-this.l>u.m?o=1:o=2,this.l=I,f.tapCount=o}else(f.type===b.Change||f.type===b.Contextmenu)&&(this.l=0);if(f.initialTarget instanceof Node){for(const I of this.h)if(I.contains(f.initialTarget))return;for(const I of this.g)I.contains(f.initialTarget)&&(I.dispatchEvent(f),this.f=!0)}}u(f,I,o,n,e,s,r,a){this.j=v.scheduleAtNextAnimationFrame(()=>{const l=Date.now(),p=l-I;let k=0,S=0,g=!0;o+=u.a*p,s+=u.a*p,o>0&&(g=!1,k=n*o*p),s>0&&(g=!1,S=r*s*p);const E=this.r(b.Change);E.translationX=k,E.translationY=S,f.forEach(N=>N.dispatchEvent(E)),g||this.u(f,l,o,n,e+k,s,r,a+S)})}v(f){const I=Date.now();for(let o=0,n=f.changedTouches.length;o<n;o++){const e=f.changedTouches.item(o);if(!this.k.hasOwnProperty(String(e.identifier))){console.warn("end of an UNKNOWN touch",e);continue}const s=this.k[e.identifier],r=this.r(b.Change,s.initialTarget);r.translationX=e.pageX-i.tail(s.rollingPageX),r.translationY=e.pageY-i.tail(s.rollingPageY),r.pageX=e.pageX,r.pageY=e.pageY,this.s(r),s.rollingPageX.length>3&&(s.rollingPageX.shift(),s.rollingPageY.shift(),s.rollingTimestamps.shift()),s.rollingPageX.push(e.pageX),s.rollingPageY.push(e.pageY),s.rollingTimestamps.push(I)}this.f&&(f.preventDefault(),f.stopPropagation(),this.f=!1)}}u.a=-.005,u.c=700,u.m=400,qe([z.memoize],u,"isTouchDevice",null),t.Gesture=u}),define(me[54],be([1,0,4,5,83]),function(J,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.status=t.alert=t.setARIAContainer=void 0;const z=2e4;let U,y,b,u,c;function f(e){U=document.createElement("div"),U.className="monaco-aria-container";const s=()=>{const a=document.createElement("div");return a.className="monaco-alert",a.setAttribute("role","alert"),a.setAttribute("aria-atomic","true"),U.appendChild(a),a};y=s(),b=s();const r=()=>{const a=document.createElement("div");return a.className="monaco-status",a.setAttribute("role","complementary"),a.setAttribute("aria-live","polite"),a.setAttribute("aria-atomic","true"),U.appendChild(a),a};u=r(),c=r(),e.appendChild(U)}t.setARIAContainer=f;function I(e){!U||(y.textContent!==e?(v.clearNode(b),n(y,e)):(v.clearNode(y),n(b,e)))}t.alert=I;function o(e){!U||(i.isMacintosh?I(e):u.textContent!==e?(v.clearNode(c),n(u,e)):(v.clearNode(u),n(c,e)))}t.status=o;function n(e,s){v.clearNode(e),s.length>z&&(s=s.substr(0,z)),e.textContent=s,e.style.visibility="hidden",e.style.visibility="visible"}}),define(me[115],be([1,0,4,12]),function(J,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderIcon=t.renderLabelWithIcons=void 0;const z=new RegExp(`(\\\\)?\\$\\((${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?)\\)`,"g");function U(b){const u=new Array;let c,f=0,I=0;for(;(c=z.exec(b))!==null;){I=c.index||0,f<I&&u.push(b.substring(f,I)),f=(c.index||0)+c[0].length;const[,o,n]=c;u.push(o?`$(${n})`:y({id:n}))}return f<b.length&&u.push(b.substring(f)),u}t.renderLabelWithIcons=U;function y(b){const u=v.$("span");return u.classList.add(...i.CSSIcon.asClassNameArray(b)),u}t.renderIcon=y}),define(me[116],be([1,0,4]),function(J,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RowCache=void 0;function i(U){try{U.parentElement?.removeChild(U)}catch{}}class z{constructor(y){this.d=y,this.a=new Map,this.b=new Set,this.c=!1}alloc(y){let b=this.h(y).pop(),u=!1;if(b)u=this.b.has(b.domNode),u&&this.b.delete(b.domNode);else{const c=(0,v.$)(".monaco-list-row"),I=this.i(y).renderTemplate(c);b={domNode:c,templateId:y,templateData:I}}return{row:b,isReusingConnectedDomNode:u}}release(y){!y||this.f(y)}transact(y){if(this.c)throw new Error("Already in transaction");this.c=!0;try{y()}finally{for(const b of this.b)this.g(b);this.b.clear(),this.c=!1}}f(y){const{domNode:b,templateId:u}=y;b&&(this.c?this.b.add(b):this.g(b)),this.h(u).push(y)}g(y){y.classList.remove("scrolling"),i(y)}h(y){let b=this.a.get(y);return b||(b=[],this.a.set(y,b)),b}dispose(){this.a.forEach((y,b)=>{for(const u of y)this.i(b).disposeTemplate(u.templateData),u.templateData=null}),this.a.clear(),this.b.clear()}i(y){const b=this.d.get(y);if(!b)throw new Error(`No renderer found for ${y}`);return b}}t.RowCache=z}),define(me[117],be([1,0,8,2]),function(J,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarVisibilityController=void 0;class z extends i.Disposable{constructor(y,b,u){super(),this.a=y,this.b=b,this.c=u,this.f=null,this.j=!1,this.i=!1,this.g=!1,this.h=!1,this.k=this.B(new v.TimeoutTimer)}setVisibility(y){this.a!==y&&(this.a=y,this.m())}setShouldBeVisible(y){this.g=y,this.m()}l(){return this.a===2?!1:this.a===3?!0:this.g}m(){const y=this.l();this.h!==y&&(this.h=y,this.ensureVisibility())}setIsNeeded(y){this.i!==y&&(this.i=y,this.ensureVisibility())}setDomNode(y){this.f=y,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.i){this.p(!1);return}this.h?this.n():this.p(!0)}n(){this.j||(this.j=!0,this.k.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}p(y){this.k.cancel(),this.j&&(this.j=!1,this.f?.setClassName(this.c+(y?" fade":"")))}}t.ScrollbarVisibilityController=z}),define(me[118],be([1,0,4,22,14,3,2,5]),function(J,t,v,i,z,U,y,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxNative=void 0;class u extends y.Disposable{constructor(f,I,o,n){super(),this.f=0,this.b=n||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new U.Emitter),this.h=o,this.i(),this.setOptions(f,I)}i(){this.B(i.Gesture.addTarget(this.a)),[i.EventType.Tap].forEach(f=>{this.B(v.addDisposableListener(this.a,f,I=>{this.a.focus()}))}),this.B(v.addStandardDisposableListener(this.a,"click",f=>{v.EventHelper.stop(f,!0)})),this.B(v.addStandardDisposableListener(this.a,"change",f=>{this.a.title=f.target.value,this.g.fire({index:f.target.selectedIndex,selected:f.target.value})})),this.B(v.addStandardDisposableListener(this.a,"keydown",f=>{let I=!1;b.isMacintosh?(f.keyCode===18||f.keyCode===16||f.keyCode===10)&&(I=!0):(f.keyCode===18&&f.altKey||f.keyCode===10||f.keyCode===3)&&(I=!0),I&&f.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(f,I){(!this.c||!z.equals(this.c,f))&&(this.c=f,this.a.options.length=0,this.c.forEach((o,n)=>{this.a.add(this.j(o.text,n,o.isDisabled))})),I!==void 0&&this.select(I)}select(f){this.c.length===0?this.f=0:f>=0&&f<this.c.length?this.f=f:f>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(f){this.b.ariaLabel=f,this.a.setAttribute("aria-label",f)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(f){this.a.tabIndex=f?0:-1}render(f){f.classList.add("select-container"),f.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(f){this.h=f,this.applyStyles()}applyStyles(){if(this.a){const f=this.h.selectBackground?this.h.selectBackground.toString():"",I=this.h.selectForeground?this.h.selectForeground.toString():"",o=this.h.selectBorder?this.h.selectBorder.toString():"";this.a.style.backgroundColor=f,this.a.style.color=I,this.a.style.borderColor=o}}j(f,I,o){const n=document.createElement("option");return n.value=f,n.text=f,n.disabled=!!o,n}}t.SelectBoxNative=u}),define(me[55],be([1,0,23,14,8,112,3,25]),function(J,t,v,i,z,U,y,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IndexTreeModel=t.getVisibleState=t.isFilterResult=void 0;function u(o){return typeof o=="object"&&"visibility"in o&&"data"in o}t.isFilterResult=u;function c(o){switch(o){case!0:return 1;case!1:return 0;default:return o}}t.getVisibleState=c;function f(o){return typeof o.collapsible=="boolean"}class I{constructor(n,e,s,r={}){this.o=n,this.p=e,this.rootRef=[],this.d=new y.EventBufferer,this.f=new y.Emitter,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new y.Emitter,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new y.Emitter,this.onDidSplice=this.l.event,this.m=new z.Delayer(z.MicrotaskDelay),this.h=typeof r.collapseByDefault>"u"?!1:r.collapseByDefault,this.j=r.filter,this.k=typeof r.autoExpandSingleChildren>"u"?!1:r.autoExpandSingleChildren,this.c={parent:void 0,element:s,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(n,e,s=b.Iterable.empty(),r={}){if(n.length===0)throw new v.TreeError(this.o,"Invalid tree location");r.diffIdentityProvider?this.q(r.diffIdentityProvider,n,e,s,r):this.s(n,e,s,r)}q(n,e,s,r=b.Iterable.empty(),a,l=a.diffDepth??0){const{parentNode:p}=this.G(e);if(!p.lastDiffIds)return this.s(e,s,r,a);const k=[...r],S=e[e.length-1],g=new U.LcsDiff({getElements:()=>p.lastDiffIds},{getElements:()=>[...p.children.slice(0,S),...k,...p.children.slice(S+s)].map(w=>n.getId(w.element).toString())}).ComputeDiff(!1);if(g.quitEarly)return p.lastDiffIds=void 0,this.s(e,s,k,a);const E=e.slice(0,-1),N=(w,m,D)=>{if(l>0)for(let R=0;R<D;R++)w--,m--,this.q(n,[...E,w,0],Number.MAX_SAFE_INTEGER,k[m].children,a,l-1)};let F=Math.min(p.children.length,S+s),d=k.length;for(const w of g.changes.sort((m,D)=>D.originalStart-m.originalStart))N(F,d,F-(w.originalStart+w.originalLength)),F=w.originalStart,d=w.modifiedStart-S,this.s([...E,F],w.originalLength,b.Iterable.slice(k,d,d+w.modifiedLength),a);N(F,d,F)}s(n,e,s=b.Iterable.empty(),{onDidCreateNode:r,onDidDeleteNode:a,diffIdentityProvider:l}){const{parentNode:p,listIndex:k,revealed:S,visible:g}=this.G(n),E=[],N=b.Iterable.map(s,ne=>this.w(ne,p,p.visible?1:0,S,E,r)),F=n[n.length-1],d=p.children.length>0;let w=0;for(let ne=F;ne>=0&&ne<p.children.length;ne--){const le=p.children[ne];if(le.visible){w=le.visibleChildIndex;break}}const m=[];let D=0,R=0;for(const ne of N)m.push(ne),R+=ne.renderNodeCount,ne.visible&&(ne.visibleChildIndex=w+D++);const V=(0,i.splice)(p.children,F,e,m);l?p.lastDiffIds?(0,i.splice)(p.lastDiffIds,F,e,m.map(ne=>l.getId(ne.element).toString())):p.lastDiffIds=p.children.map(ne=>l.getId(ne.element).toString()):p.lastDiffIds=void 0;let Z=0;for(const ne of V)ne.visible&&Z++;if(Z!==0)for(let ne=F+m.length;ne<p.children.length;ne++){const le=p.children[ne];le.visible&&(le.visibleChildIndex-=Z)}if(p.visibleChildrenCount+=D-Z,S&&g){const ne=V.reduce((le,se)=>le+(se.visible?se.renderNodeCount:0),0);this.B(p,R-ne),this.p.splice(k,ne,E)}if(V.length>0&&a){const ne=le=>{a(le),le.children.forEach(ne)};V.forEach(ne)}this.l.fire({insertedNodes:m,deletedNodes:V});const X=p.children.length>0;d!==X&&this.setCollapsible(n.slice(0,-1),X);let x=p;for(;x;){if(x.visibility===2){this.m.trigger(()=>this.refilter());break}x=x.parent}}rerender(n){if(n.length===0)throw new v.TreeError(this.o,"Invalid tree location");const{node:e,listIndex:s,revealed:r}=this.F(n);e.visible&&r&&this.p.splice(s,1,[e])}updateElementHeight(n,e){if(n.length===0)throw new v.TreeError(this.o,"Invalid tree location");const{listIndex:s}=this.F(n);this.p.updateElementHeight(s,e)}has(n){return this.D(n)}getListIndex(n){const{listIndex:e,visible:s,revealed:r}=this.F(n);return s&&r?e:-1}getListRenderCount(n){return this.E(n).renderNodeCount}isCollapsible(n){return this.E(n).collapsible}setCollapsible(n,e){const s=this.E(n);typeof e>"u"&&(e=!s.collapsible);const r={collapsible:e};return this.d.bufferEvents(()=>this.t(n,r))}isCollapsed(n){return this.E(n).collapsed}setCollapsed(n,e,s){const r=this.E(n);typeof e>"u"&&(e=!r.collapsed);const a={collapsed:e,recursive:s||!1};return this.d.bufferEvents(()=>this.t(n,a))}t(n,e){const{node:s,listIndex:r,revealed:a}=this.F(n),l=this.u(s,r,a,e);if(s!==this.c&&this.k&&l&&!f(e)&&s.collapsible&&!s.collapsed&&!e.recursive){let p=-1;for(let k=0;k<s.children.length;k++)if(s.children[k].visible)if(p>-1){p=-1;break}else p=k;p>-1&&this.t([...n,p],e)}return l}u(n,e,s,r){const a=this.v(n,r,!1);if(!s||!n.visible||!a)return a;const l=n.renderNodeCount,p=this.x(n),k=l-(e===-1?0:1);return this.p.splice(e+1,k,p.slice(1)),a}v(n,e,s){let r;if(n===this.c?r=!1:(f(e)?(r=n.collapsible!==e.collapsible,n.collapsible=e.collapsible):n.collapsible?(r=n.collapsed!==e.collapsed,n.collapsed=e.collapsed):r=!1,r&&this.f.fire({node:n,deep:s})),!f(e)&&e.recursive)for(const a of n.children)r=this.v(a,e,!0)||r;return r}expandTo(n){this.d.bufferEvents(()=>{let e=this.E(n);for(;e.parent;)e=e.parent,n=n.slice(0,n.length-1),e.collapsed&&this.t(n,{collapsed:!1,recursive:!1})})}refilter(){const n=this.c.renderNodeCount,e=this.z(this.c);this.p.splice(0,n,e),this.m.cancel()}w(n,e,s,r,a,l){const p={parent:e,element:n.element,children:[],depth:e.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof n.collapsible=="boolean"?n.collapsible:typeof n.collapsed<"u",collapsed:typeof n.collapsed>"u"?this.h:n.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},k=this.C(p,s);p.visibility=k,r&&a.push(p);const S=n.children||b.Iterable.empty(),g=r&&k!==0&&!p.collapsed;let E=0,N=1;for(const F of S){const d=this.w(F,p,k,g,a,l);p.children.push(d),N+=d.renderNodeCount,d.visible&&(d.visibleChildIndex=E++)}return p.collapsible=p.collapsible||p.children.length>0,p.visibleChildrenCount=E,p.visible=k===2?E>0:k===1,p.visible?p.collapsed||(p.renderNodeCount=N):(p.renderNodeCount=0,r&&a.pop()),l?.(p),p}x(n){const e=n.renderNodeCount,s=[];return this.y(n,s),this.B(n.parent,s.length-e),s}y(n,e){if(n.visible===!1)return 0;if(e.push(n),n.renderNodeCount=1,!n.collapsed)for(const s of n.children)n.renderNodeCount+=this.y(s,e);return this.g.fire(n),n.renderNodeCount}z(n){const e=n.renderNodeCount,s=[];return this.A(n,n.visible?1:0,s),this.B(n.parent,s.length-e),s}A(n,e,s,r=!0){let a;if(n!==this.c){if(a=this.C(n,e),a===0)return n.visible=!1,n.renderNodeCount=0,!1;r&&s.push(n)}const l=s.length;n.renderNodeCount=n===this.c?0:1;let p=!1;if(!n.collapsed||a!==0){let k=0;for(const S of n.children)p=this.A(S,a,s,r&&!n.collapsed)||p,S.visible&&(S.visibleChildIndex=k++);n.visibleChildrenCount=k}else n.visibleChildrenCount=0;return n!==this.c&&(n.visible=a===2?p:a===1,n.visibility=a),n.visible?n.collapsed||(n.renderNodeCount+=s.length-l):(n.renderNodeCount=0,r&&s.pop()),this.g.fire(n),n.visible}B(n,e){if(e!==0)for(;n;)n.renderNodeCount+=e,this.g.fire(n),n=n.parent}C(n,e){const s=this.j?this.j.filter(n.element,e):1;return typeof s=="boolean"?(n.filterData=void 0,s?1:0):u(s)?(n.filterData=s.data,c(s.visibility)):(n.filterData=void 0,c(s))}D(n,e=this.c){if(!n||n.length===0)return!0;const[s,...r]=n;return s<0||s>e.children.length?!1:this.D(r,e.children[s])}E(n,e=this.c){if(!n||n.length===0)return e;const[s,...r]=n;if(s<0||s>e.children.length)throw new v.TreeError(this.o,"Invalid tree location");return this.E(r,e.children[s])}F(n){if(n.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:e,listIndex:s,revealed:r,visible:a}=this.G(n),l=n[n.length-1];if(l<0||l>e.children.length)throw new v.TreeError(this.o,"Invalid tree location");const p=e.children[l];return{node:p,listIndex:s,revealed:r,visible:a&&p.visible}}G(n,e=this.c,s=0,r=!0,a=!0){const[l,...p]=n;if(l<0||l>e.children.length)throw new v.TreeError(this.o,"Invalid tree location");for(let k=0;k<l;k++)s+=e.children[k].renderNodeCount;return r=r&&!e.collapsed,a=a&&e.visible,p.length===0?{parentNode:e,listIndex:s,revealed:r,visible:a}:this.G(p,e.children[l],s+1,r,a)}getNode(n=[]){return this.E(n)}getNodeLocation(n){const e=[];let s=n;for(;s.parent;)e.push(s.parent.children.indexOf(s)),s=s.parent;return e.reverse()}getParentNodeLocation(n){if(n.length!==0)return n.length===1?[]:(0,i.tail2)(n)[0]}getFirstElementChild(n){const e=this.E(n);if(e.children.length!==0)return e.children[0].element}getLastElementAncestor(n=[]){const e=this.E(n);if(e.children.length!==0)return this.H(e)}H(n){return n.children.length===0?n.element:this.H(n.children[n.children.length-1])}}t.IndexTreeModel=I}),define(me[119],be([1,0,55,23,25]),function(J,t,v,i,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObjectTreeModel=void 0;class U{get size(){return this.d.size}constructor(b,u,c={}){this.k=b,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new v.IndexTreeModel(b,u,null,c),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,c.sorter&&(this.j={compare(f,I){return c.sorter.compare(f.element,I.element)}}),this.h=c.identityProvider}setChildren(b,u=z.Iterable.empty(),c={}){const f=this.o(b);this.l(f,this.m(u),c)}l(b,u=z.Iterable.empty(),c){const f=new Set,I=new Set,o=e=>{if(e.element===null)return;const s=e;if(f.add(s.element),this.d.set(s.element,s),this.h){const r=this.h.getId(s.element).toString();I.add(r),this.f.set(r,s)}c.onDidCreateNode?.(s)},n=e=>{if(e.element===null)return;const s=e;if(f.has(s.element)||this.d.delete(s.element),this.h){const r=this.h.getId(s.element).toString();I.has(r)||this.f.delete(r)}c.onDidDeleteNode?.(s)};this.c.splice([...b,0],Number.MAX_VALUE,u,{...c,onDidCreateNode:o,onDidDeleteNode:n})}m(b=z.Iterable.empty()){return this.j&&(b=[...b].sort(this.j.compare.bind(this.j))),z.Iterable.map(b,u=>{let c=this.d.get(u.element);if(!c&&this.h){const o=this.h.getId(u.element).toString();c=this.f.get(o)}if(!c)return{...u,children:this.m(u.children)};const f=typeof u.collapsible=="boolean"?u.collapsible:c.collapsible,I=typeof u.collapsed<"u"?u.collapsed:c.collapsed;return{...u,collapsible:f,collapsed:I,children:this.m(u.children)}})}rerender(b){const u=this.o(b);this.c.rerender(u)}updateElementHeight(b,u){const c=this.o(b);this.c.updateElementHeight(c,u)}resort(b=null,u=!0){if(!this.j)return;const c=this.o(b),f=this.c.getNode(c);this.l(c,this.n(f,u),{})}n(b,u,c=!0){let f=[...b.children];return(u||c)&&(f=f.sort(this.j.compare.bind(this.j))),z.Iterable.map(f,I=>({element:I.element,collapsible:I.collapsible,collapsed:I.collapsed,children:this.n(I,u,!1)}))}getFirstElementChild(b=null){const u=this.o(b);return this.c.getFirstElementChild(u)}getLastElementAncestor(b=null){const u=this.o(b);return this.c.getLastElementAncestor(u)}has(b){return this.d.has(b)}getListIndex(b){const u=this.o(b);return this.c.getListIndex(u)}getListRenderCount(b){const u=this.o(b);return this.c.getListRenderCount(u)}isCollapsible(b){const u=this.o(b);return this.c.isCollapsible(u)}setCollapsible(b,u){const c=this.o(b);return this.c.setCollapsible(c,u)}isCollapsed(b){const u=this.o(b);return this.c.isCollapsed(u)}setCollapsed(b,u,c){const f=this.o(b);return this.c.setCollapsed(f,u,c)}expandTo(b){const u=this.o(b);this.c.expandTo(u)}refilter(){this.c.refilter()}getNode(b=null){if(b===null)return this.c.getNode(this.c.rootRef);const u=this.d.get(b);if(!u)throw new i.TreeError(this.k,`Tree element not found: ${b}`);return u}getNodeLocation(b){return b.element}getParentNodeLocation(b){if(b===null)throw new i.TreeError(this.k,"Invalid getParentNodeLocation call");const u=this.d.get(b);if(!u)throw new i.TreeError(this.k,`Tree element not found: ${b}`);const c=this.c.getNodeLocation(u),f=this.c.getParentNodeLocation(c);return this.c.getNode(f).element}o(b){if(b===null)return[];const u=this.d.get(b);if(!u)throw new i.TreeError(this.k,`Tree element not found: ${b}`);return this.c.getNodeLocation(u)}}t.ObjectTreeModel=U}),define(me[18],be([1,0,4,15,20,22,2]),function(J,t,v,i,z,U,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Widget=void 0;class b extends y.Disposable{f(c,f){this.B(v.addDisposableListener(c,v.EventType.CLICK,I=>f(new z.StandardMouseEvent(I))))}j(c,f){this.B(v.addDisposableListener(c,v.EventType.MOUSE_DOWN,I=>f(new z.StandardMouseEvent(I))))}k(c,f){this.B(v.addDisposableListener(c,v.EventType.MOUSE_OVER,I=>f(new z.StandardMouseEvent(I))))}m(c,f){this.B(v.addDisposableListener(c,v.EventType.MOUSE_LEAVE,I=>f(new z.StandardMouseEvent(I))))}p(c,f){this.B(v.addDisposableListener(c,v.EventType.KEY_DOWN,I=>f(new i.StandardKeyboardEvent(I))))}u(c,f){this.B(v.addDisposableListener(c,v.EventType.KEY_UP,I=>f(new i.StandardKeyboardEvent(I))))}z(c,f){this.B(v.addDisposableListener(c,v.EventType.INPUT,f))}C(c,f){this.B(v.addDisposableListener(c,v.EventType.BLUR,f))}D(c,f){this.B(v.addDisposableListener(c,v.EventType.FOCUS,f))}F(c,f){this.B(v.addDisposableListener(c,v.EventType.CHANGE,f))}G(c){return U.Gesture.ignoreTarget(c)}}t.Widget=b}),define(me[36],be([1,0,53,18,8,4]),function(J,t,v,i,z,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarArrow=t.ARROW_IMG_SIZE=void 0,t.ARROW_IMG_SIZE=11;class y extends i.Widget{constructor(u){super(),this.a=u.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=u.bgWidth+"px",this.bgDomNode.style.height=u.bgHeight+"px",typeof u.top<"u"&&(this.bgDomNode.style.top="0px"),typeof u.left<"u"&&(this.bgDomNode.style.left="0px"),typeof u.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof u.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=u.className,this.domNode.classList.add(...u.icon.classNamesArray),this.domNode.style.position="absolute",this.domNode.style.width=t.ARROW_IMG_SIZE+"px",this.domNode.style.height=t.ARROW_IMG_SIZE+"px",typeof u.top<"u"&&(this.domNode.style.top=u.top+"px"),typeof u.left<"u"&&(this.domNode.style.left=u.left+"px"),typeof u.bottom<"u"&&(this.domNode.style.bottom=u.bottom+"px"),typeof u.right<"u"&&(this.domNode.style.right=u.right+"px"),this.g=this.B(new v.GlobalPointerMoveMonitor),this.B(U.addStandardDisposableListener(this.bgDomNode,U.EventType.POINTER_DOWN,c=>this.h(c))),this.B(U.addStandardDisposableListener(this.domNode,U.EventType.POINTER_DOWN,c=>this.h(c))),this.b=this.B(new z.IntervalTimer),this.c=this.B(new z.TimeoutTimer)}h(u){if(!u.target||!(u.target instanceof Element))return;const c=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24)};this.a(),this.b.cancel(),this.c.cancelAndSet(c,200),this.g.startMonitoring(u.target,u.pointerId,u.buttons,f=>{},()=>{this.b.cancel(),this.c.cancel()}),u.preventDefault()}}t.ScrollbarArrow=y}),define(me[56],be([1,0,4,39,53,36,117,18,5]),function(J,t,v,i,z,U,y,b,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractScrollbar=void 0;const c=140;class f extends b.Widget{constructor(o){super(),this.g=o.lazyRender,this.a=o.host,this.b=o.scrollable,this.c=o.scrollByPage,this.h=o.scrollbarState,this.i=this.B(new y.ScrollbarVisibilityController(o.visibility,"visible scrollbar "+o.extraScrollbarClassName,"invisible scrollbar "+o.extraScrollbarClassName)),this.i.setIsNeeded(this.h.isNeeded()),this.l=this.B(new z.GlobalPointerMoveMonitor),this.n=!0,this.domNode=(0,i.createFastDomNode)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.i.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(v.addDisposableListener(this.domNode.domNode,v.EventType.POINTER_DOWN,n=>this.y(n)))}r(o){const n=this.B(new U.ScrollbarArrow(o));this.domNode.domNode.appendChild(n.bgDomNode),this.domNode.domNode.appendChild(n.domNode)}s(o,n,e,s){this.slider=(0,i.createFastDomNode)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(o),this.slider.setLeft(n),typeof e=="number"&&this.slider.setWidth(e),typeof s=="number"&&this.slider.setHeight(s),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(v.addDisposableListener(this.slider.domNode,v.EventType.POINTER_DOWN,r=>{r.button===0&&(r.preventDefault(),this.I(r))})),this.f(this.slider.domNode,r=>{r.leftButton&&r.stopPropagation()})}t(o){return this.h.setVisibleSize(o)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}v(o){return this.h.setScrollSize(o)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}w(o){return this.h.setScrollPosition(o)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}beginReveal(){this.i.setShouldBeVisible(!0)}beginHide(){this.i.setShouldBeVisible(!1)}render(){!this.n||(this.n=!1,this.L(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.M(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}y(o){o.target===this.domNode.domNode&&this.H(o)}delegatePointerDown(o){const n=this.domNode.domNode.getClientRects()[0].top,e=n+this.h.getSliderPosition(),s=n+this.h.getSliderPosition()+this.h.getSliderSize(),r=this.O(o);e<=r&&r<=s?o.button===0&&(o.preventDefault(),this.I(o)):this.H(o)}H(o){let n,e;if(o.target===this.domNode.domNode&&typeof o.offsetX=="number"&&typeof o.offsetY=="number")n=o.offsetX,e=o.offsetY;else{const r=v.getDomNodePagePosition(this.domNode.domNode);n=o.pageX-r.left,e=o.pageY-r.top}const s=this.N(n,e);this.J(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(s):this.h.getDesiredScrollPositionFromOffset(s)),o.button===0&&(o.preventDefault(),this.I(o))}I(o){if(!o.target||!(o.target instanceof Element))return;const n=this.O(o),e=this.P(o),s=this.h.clone();this.slider.toggleClassName("active",!0),this.l.startMonitoring(o.target,o.pointerId,o.buttons,r=>{const a=this.P(r),l=Math.abs(a-e);if(u.isWindows&&l>c){this.J(s.getScrollPosition());return}const k=this.O(r)-n;this.J(s.getDesiredScrollPositionFromDelta(k))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}J(o){const n={};this.writeScrollPosition(n,o),this.b.setScrollPositionNow(n)}updateScrollbarSize(o){this.Q(o),this.h.setScrollbarSize(o),this.n=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.AbstractScrollbar=f}),define(me[120],be([1,0,20,56,36,40,12]),function(J,t,v,i,z,U,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HorizontalScrollbar=void 0;class b extends i.AbstractScrollbar{constructor(c,f,I){const o=c.getScrollDimensions(),n=c.getCurrentScrollPosition();if(super({lazyRender:f.lazyRender,host:I,scrollbarState:new U.ScrollbarState(f.horizontalHasArrows?f.arrowSize:0,f.horizontal===2?0:f.horizontalScrollbarSize,f.vertical===2?0:f.verticalScrollbarSize,o.width,o.scrollWidth,n.scrollLeft),visibility:f.horizontal,extraScrollbarClassName:"horizontal",scrollable:c,scrollByPage:f.scrollByPage}),f.horizontalHasArrows){const e=(f.arrowSize-z.ARROW_IMG_SIZE)/2,s=(f.horizontalScrollbarSize-z.ARROW_IMG_SIZE)/2;this.r({className:"scra",icon:y.Codicon.scrollbarButtonLeft,top:s,left:e,bottom:void 0,right:void 0,bgWidth:f.arrowSize,bgHeight:f.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new v.StandardWheelEvent(null,1,0))}),this.r({className:"scra",icon:y.Codicon.scrollbarButtonRight,top:s,left:void 0,bottom:void 0,right:e,bgWidth:f.arrowSize,bgHeight:f.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new v.StandardWheelEvent(null,-1,0))})}this.s(Math.floor((f.horizontalScrollbarSize-f.horizontalSliderSize)/2),0,void 0,f.horizontalSliderSize)}M(c,f){this.slider.setWidth(c),this.slider.setLeft(f)}L(c,f){this.domNode.setWidth(c),this.domNode.setHeight(f),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(c){return this.n=this.v(c.scrollWidth)||this.n,this.n=this.w(c.scrollLeft)||this.n,this.n=this.t(c.width)||this.n,this.n}N(c,f){return c}O(c){return c.pageX}P(c){return c.pageY}Q(c){this.slider.setHeight(c)}writeScrollPosition(c,f){c.scrollLeft=f}updateOptions(c){this.updateScrollbarSize(c.horizontal===2?0:c.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(c.vertical===2?0:c.verticalScrollbarSize),this.i.setVisibility(c.horizontal),this.c=c.scrollByPage}}t.HorizontalScrollbar=b}),define(me[121],be([1,0,20,56,36,40,12]),function(J,t,v,i,z,U,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VerticalScrollbar=void 0;class b extends i.AbstractScrollbar{constructor(c,f,I){const o=c.getScrollDimensions(),n=c.getCurrentScrollPosition();if(super({lazyRender:f.lazyRender,host:I,scrollbarState:new U.ScrollbarState(f.verticalHasArrows?f.arrowSize:0,f.vertical===2?0:f.verticalScrollbarSize,0,o.height,o.scrollHeight,n.scrollTop),visibility:f.vertical,extraScrollbarClassName:"vertical",scrollable:c,scrollByPage:f.scrollByPage}),f.verticalHasArrows){const e=(f.arrowSize-z.ARROW_IMG_SIZE)/2,s=(f.verticalScrollbarSize-z.ARROW_IMG_SIZE)/2;this.r({className:"scra",icon:y.Codicon.scrollbarButtonUp,top:e,left:s,bottom:void 0,right:void 0,bgWidth:f.verticalScrollbarSize,bgHeight:f.arrowSize,onActivate:()=>this.a.onMouseWheel(new v.StandardWheelEvent(null,0,1))}),this.r({className:"scra",icon:y.Codicon.scrollbarButtonDown,top:void 0,left:s,bottom:e,right:void 0,bgWidth:f.verticalScrollbarSize,bgHeight:f.arrowSize,onActivate:()=>this.a.onMouseWheel(new v.StandardWheelEvent(null,0,-1))})}this.s(0,Math.floor((f.verticalScrollbarSize-f.verticalSliderSize)/2),f.verticalSliderSize,void 0)}M(c,f){this.slider.setHeight(c),this.slider.setTop(f)}L(c,f){this.domNode.setWidth(f),this.domNode.setHeight(c),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(c){return this.n=this.v(c.scrollHeight)||this.n,this.n=this.w(c.scrollTop)||this.n,this.n=this.t(c.height)||this.n,this.n}N(c,f){return f}O(c){return c.pageY}P(c){return c.pageX}Q(c){this.slider.setWidth(c)}writeScrollPosition(c,f){c.scrollTop=f}updateOptions(c){this.updateScrollbarSize(c.vertical===2?0:c.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.i.setVisibility(c.vertical),this.c=c.scrollByPage}}t.VerticalScrollbar=b}),define(me[57],be([1,0,17,4,39,20,120,121,18,8,3,2,5,49,90]),function(J,t,v,i,z,U,y,b,u,c,f,I,o,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomScrollableElement=t.SmoothScrollableElement=t.ScrollableElement=t.AbstractScrollableElement=t.MouseWheelClassifier=void 0;const e=500,s=50,r=!0;class a{constructor(F,d,w){this.timestamp=F,this.deltaX=d,this.deltaY=w,this.score=0}}class l{constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let F=1,d=0,w=1,m=this.d;do{const D=m===this.c?F:Math.pow(2,-w);if(F-=D,d+=this.b[m].score*D,m===this.c)break;m=(this.a+m-1)%this.a,w++}while(!0);return d<=.5}acceptStandardWheelEvent(F){const d=window.devicePixelRatio/(0,v.getZoomFactor)();o.isWindows||o.isLinux?this.accept(Date.now(),F.deltaX/d,F.deltaY/d):this.accept(Date.now(),F.deltaX,F.deltaY)}accept(F,d,w){const m=new a(F,d,w);m.score=this.f(m),this.c===-1&&this.d===-1?(this.b[0]=m,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=m)}f(F){if(Math.abs(F.deltaX)>0&&Math.abs(F.deltaY)>0)return 1;let d=.5;const w=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(F.deltaX)||!this.g(F.deltaY))&&(d+=.25),Math.min(Math.max(d,0),1)}g(F){return Math.abs(Math.round(F)-F)<.01}}t.MouseWheelClassifier=l,l.INSTANCE=new l;class p extends u.Widget{get options(){return this.a}constructor(F,d,w){super(),this.I=this.B(new f.Emitter),this.onScroll=this.I.event,this.J=this.B(new f.Emitter),this.onWillScroll=this.J.event,F.style.overflow="hidden",this.a=E(d),this.b=w,this.B(this.b.onScroll(D=>{this.J.fire(D),this.N(D),this.I.fire(D)}));const m={onMouseWheel:D=>this.M(D),onDragStart:()=>this.P(),onDragEnd:()=>this.Q()};this.c=this.B(new b.VerticalScrollbar(this.b,this.a,m)),this.g=this.B(new y.HorizontalScrollbar(this.b,this.a,m)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(F),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.i=(0,z.createFastDomNode)(document.createElement("div")),this.i.setClassName("shadow"),this.h.appendChild(this.i.domNode),this.l=(0,z.createFastDomNode)(document.createElement("div")),this.l.setClassName("shadow"),this.h.appendChild(this.l.domNode),this.n=(0,z.createFastDomNode)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode)):(this.i=null,this.l=null,this.n=null),this.r=this.a.listenOnDomNode||this.h,this.s=[],this.L(this.a.handleMouseWheel),this.k(this.r,D=>this.S(D)),this.m(this.r,D=>this.R(D)),this.w=this.B(new c.TimeoutTimer),this.t=!1,this.v=!1,this.y=!0,this.H=!0}dispose(){this.s=(0,I.dispose)(this.s),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(F){this.c.delegatePointerDown(F)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(F){this.b.setScrollDimensions(F,!1)}updateClassName(F){this.a.className=F,o.isMacintosh&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(F){typeof F.handleMouseWheel<"u"&&(this.a.handleMouseWheel=F.handleMouseWheel,this.L(this.a.handleMouseWheel)),typeof F.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=F.mouseWheelScrollSensitivity),typeof F.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=F.fastScrollSensitivity),typeof F.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=F.scrollPredominantAxis),typeof F.horizontal<"u"&&(this.a.horizontal=F.horizontal),typeof F.vertical<"u"&&(this.a.vertical=F.vertical),typeof F.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=F.horizontalScrollbarSize),typeof F.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=F.verticalScrollbarSize),typeof F.scrollByPage<"u"&&(this.a.scrollByPage=F.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.O()}setRevealOnScroll(F){this.H=F}delegateScrollFromMouseWheelEvent(F){this.M(new U.StandardWheelEvent(F))}L(F){if(this.s.length>0!==F&&(this.s=(0,I.dispose)(this.s),F)){const w=m=>{this.M(new U.StandardWheelEvent(m))};this.s.push(i.addDisposableListener(this.r,i.EventType.MOUSE_WHEEL,w,{passive:!1}))}}M(F){const d=l.INSTANCE;r&&d.acceptStandardWheelEvent(F);let w=!1;if(F.deltaY||F.deltaX){let D=F.deltaY*this.a.mouseWheelScrollSensitivity,R=F.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(Math.abs(D)>=Math.abs(R)?R=0:D=0),this.a.flipAxes&&([D,R]=[R,D]);const V=!o.isMacintosh&&F.browserEvent&&F.browserEvent.shiftKey;(this.a.scrollYToX||V)&&!R&&(R=D,D=0),F.browserEvent&&F.browserEvent.altKey&&(R=R*this.a.fastScrollSensitivity,D=D*this.a.fastScrollSensitivity);const Z=this.b.getFutureScrollPosition();let X={};if(D){const x=s*D,ne=Z.scrollTop-(x<0?Math.floor(x):Math.ceil(x));this.c.writeScrollPosition(X,ne)}if(R){const x=s*R,ne=Z.scrollLeft-(x<0?Math.floor(x):Math.ceil(x));this.g.writeScrollPosition(X,ne)}X=this.b.validateScrollPosition(X),(Z.scrollLeft!==X.scrollLeft||Z.scrollTop!==X.scrollTop)&&(r&&this.a.mouseWheelSmoothScroll&&d.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(X):this.b.setScrollPositionNow(X),w=!0)}let m=w;!m&&this.a.alwaysConsumeMouseWheel&&(m=!0),!m&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(m=!0),m&&(F.preventDefault(),F.stopPropagation())}N(F){this.y=this.g.onDidScroll(F)||this.y,this.y=this.c.onDidScroll(F)||this.y,this.a.useShadows&&(this.y=!0),this.H&&this.U(),this.a.lazyRender||this.O()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.O()}O(){if(!!this.y&&(this.y=!1,this.g.render(),this.c.render(),this.a.useShadows)){const F=this.b.getCurrentScrollPosition(),d=F.scrollTop>0,w=F.scrollLeft>0,m=w?" left":"",D=d?" top":"",R=w||d?" top-left-corner":"";this.i.setClassName(`shadow${m}`),this.l.setClassName(`shadow${D}`),this.n.setClassName(`shadow${R}${D}${m}`)}}P(){this.t=!0,this.U()}Q(){this.t=!1,this.W()}R(F){this.v=!1,this.W()}S(F){this.v=!0,this.U()}U(){this.c.beginReveal(),this.g.beginReveal(),this.X()}W(){!this.v&&!this.t&&(this.c.beginHide(),this.g.beginHide())}X(){!this.v&&!this.t&&this.w.cancelAndSet(()=>this.W(),e)}}t.AbstractScrollableElement=p;class k extends p{constructor(F,d){d=d||{},d.mouseWheelSmoothScroll=!1;const w=new n.Scrollable({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:m=>i.scheduleAtNextAnimationFrame(m)});super(F,d,w),this.B(w)}setScrollPosition(F){this.b.setScrollPositionNow(F)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.ScrollableElement=k;class S extends p{constructor(F,d,w){super(F,d,w)}setScrollPosition(F){F.reuseAnimation?this.b.setScrollPositionSmooth(F,F.reuseAnimation):this.b.setScrollPositionNow(F)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.SmoothScrollableElement=S;class g extends p{constructor(F,d){d=d||{},d.mouseWheelSmoothScroll=!1;const w=new n.Scrollable({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:m=>i.scheduleAtNextAnimationFrame(m)});super(F,d,w),this.B(w),this.Y=F,this.onScroll(m=>{m.scrollTopChanged&&(this.Y.scrollTop=m.scrollTop),m.scrollLeftChanged&&(this.Y.scrollLeft=m.scrollLeft)}),this.scanDomNode()}setScrollPosition(F){this.b.setScrollPositionNow(F)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.Y.clientWidth,scrollWidth:this.Y.scrollWidth,height:this.Y.clientHeight,scrollHeight:this.Y.scrollHeight}),this.setScrollPosition({scrollLeft:this.Y.scrollLeft,scrollTop:this.Y.scrollTop})}}t.DomScrollableElement=g;function E(N){const F={lazyRender:typeof N.lazyRender<"u"?N.lazyRender:!1,className:typeof N.className<"u"?N.className:"",useShadows:typeof N.useShadows<"u"?N.useShadows:!0,handleMouseWheel:typeof N.handleMouseWheel<"u"?N.handleMouseWheel:!0,flipAxes:typeof N.flipAxes<"u"?N.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof N.consumeMouseWheelIfScrollbarIsNeeded<"u"?N.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof N.alwaysConsumeMouseWheel<"u"?N.alwaysConsumeMouseWheel:!1,scrollYToX:typeof N.scrollYToX<"u"?N.scrollYToX:!1,mouseWheelScrollSensitivity:typeof N.mouseWheelScrollSensitivity<"u"?N.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof N.fastScrollSensitivity<"u"?N.fastScrollSensitivity:5,scrollPredominantAxis:typeof N.scrollPredominantAxis<"u"?N.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof N.mouseWheelSmoothScroll<"u"?N.mouseWheelSmoothScroll:!0,arrowSize:typeof N.arrowSize<"u"?N.arrowSize:11,listenOnDomNode:typeof N.listenOnDomNode<"u"?N.listenOnDomNode:null,horizontal:typeof N.horizontal<"u"?N.horizontal:1,horizontalScrollbarSize:typeof N.horizontalScrollbarSize<"u"?N.horizontalScrollbarSize:10,horizontalSliderSize:typeof N.horizontalSliderSize<"u"?N.horizontalSliderSize:0,horizontalHasArrows:typeof N.horizontalHasArrows<"u"?N.horizontalHasArrows:!1,vertical:typeof N.vertical<"u"?N.vertical:1,verticalScrollbarSize:typeof N.verticalScrollbarSize<"u"?N.verticalScrollbarSize:10,verticalHasArrows:typeof N.verticalHasArrows<"u"?N.verticalHasArrows:!1,verticalSliderSize:typeof N.verticalSliderSize<"u"?N.verticalSliderSize:0,scrollByPage:typeof N.scrollByPage<"u"?N.scrollByPage:!1};return F.horizontalSliderSize=typeof N.horizontalSliderSize<"u"?N.horizontalSliderSize:F.horizontalScrollbarSize,F.verticalSliderSize=typeof N.verticalSliderSize<"u"?N.verticalSliderSize:F.verticalScrollbarSize,o.isMacintosh&&(F.className+=" mac"),F}}),define(me[58],be([1,0,51,4,19,22,57,14,8,24,3,2,47,49,79,116,9]),function(J,t,v,i,z,U,y,b,u,c,f,I,o,n,e,s,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ListView=t.NativeDragAndDropData=t.ExternalElementsDragAndDropData=t.ElementsDragAndDropData=void 0;const a={CurrentDragAndDropData:void 0},l={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(F){return[F]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class p{get context(){return this.d}set context(d){this.d=d}constructor(d){this.elements=d}update(){}getData(){return this.elements}}t.ElementsDragAndDropData=p;class k{constructor(d){this.elements=d}update(){}getData(){return this.elements}}t.ExternalElementsDragAndDropData=k;class S{constructor(){this.types=[],this.files=[]}update(d){if(d.types&&this.types.splice(0,this.types.length,...d.types),d.files){this.files.splice(0,this.files.length);for(let w=0;w<d.files.length;w++){const m=d.files.item(w);m&&(m.size||m.type)&&this.files.push(m)}}}getData(){return{types:this.types,files:this.files}}}t.NativeDragAndDropData=S;function g(F,d){return Array.isArray(F)&&Array.isArray(d)?(0,b.equals)(F,d):F===d}class E{constructor(d){d?.getSetSize?this.getSetSize=d.getSetSize.bind(d):this.getSetSize=(w,m,D)=>D,d?.getPosInSet?this.getPosInSet=d.getPosInSet.bind(d):this.getPosInSet=(w,m)=>m+1,d?.getRole?this.getRole=d.getRole.bind(d):this.getRole=w=>"listitem",d?.isChecked?this.isChecked=d.isChecked.bind(d):this.isChecked=w=>{}}}class N{get contentHeight(){return this.g.size}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get O(){return this.N}set O(d){if(d!==this.N){if(d&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.N=d,this.domNode.classList.toggle("horizontal-scrolling",this.N),this.N){for(const w of this.d)this.X(w);this.U(),this.q.setScrollDimensions({width:(0,i.getContentWidth)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(d,w,m,D=l){if(this.P=w,this.domId=`list_id_${++N.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new u.Delayer(50),this.v=!1,this.x=I.Disposable.None,this.y=0,this.G=!1,this.J=I.Disposable.None,this.K=I.Disposable.None,this.L=new I.DisposableStore,this.M=new f.Emitter,this.onDidChangeContentHeight=f.Event.latch(this.M.event,void 0,this.L),this.N=!1,D.horizontalScrolling&&D.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=new e.RangeMap;for(const V of m)this.j.set(V.templateId,V);this.h=this.L.add(new s.RowCache(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof D.mouseSupport=="boolean"?D.mouseSupport:!0),this.N=D.horizontalScrolling??l.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.N),this.C=typeof D.additionalScrollHeight>"u"?0:D.additionalScrollHeight,this.D=new E(D.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(D.transformOptimization??l.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.L.add(U.Gesture.addTarget(this.o)),this.p=new n.Scrollable({forceIntegerValues:!0,smoothScrollDuration:D.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:V=>(0,i.scheduleAtNextAnimationFrame)(V)}),this.q=this.L.add(new y.SmoothScrollableElement(this.o,{alwaysConsumeMouseWheel:D.alwaysConsumeMouseWheel??l.alwaysConsumeMouseWheel,horizontal:1,vertical:D.verticalScrollMode??l.verticalScrollMode,useShadows:D.useShadows??l.useShadows,mouseWheelScrollSensitivity:D.mouseWheelScrollSensitivity,fastScrollSensitivity:D.fastScrollSensitivity},this.p)),this.domNode.appendChild(this.q.getDomNode()),d.appendChild(this.domNode),this.q.onScroll(this.fb,this,this.L),this.L.add((0,i.addDisposableListener)(this.o,U.EventType.Change,V=>this.gb(V))),this.L.add((0,i.addDisposableListener)(this.q.getDomNode(),"scroll",V=>V.target.scrollTop=0)),this.L.add((0,i.addDisposableListener)(this.domNode,"dragover",V=>this.ib(this.eb(V)))),this.L.add((0,i.addDisposableListener)(this.domNode,"drop",V=>this.kb(this.eb(V)))),this.L.add((0,i.addDisposableListener)(this.domNode,"dragleave",V=>this.jb(this.eb(V)))),this.L.add((0,i.addDisposableListener)(this.domNode,"dragend",V=>this.lb(V))),this.z=D.setRowLineHeight??l.setRowLineHeight,this.A=D.setRowHeight??l.setRowHeight,this.B=D.supportDynamicHeights??l.supportDynamicHeights,this.F=D.dnd??l.dnd,this.layout(D.initialSize?.height,D.initialSize?.width)}updateOptions(d){d.additionalScrollHeight!==void 0&&(this.C=d.additionalScrollHeight,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),d.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(d.smoothScrolling?125:0),d.horizontalScrolling!==void 0&&(this.O=d.horizontalScrolling),d.mouseWheelScrollSensitivity!==void 0&&this.q.updateOptions({mouseWheelScrollSensitivity:d.mouseWheelScrollSensitivity}),d.fastScrollSensitivity!==void 0&&this.q.updateOptions({fastScrollSensitivity:d.fastScrollSensitivity})}delegateScrollFromMouseWheelEvent(d){this.q.delegateScrollFromMouseWheelEvent(d)}delegateVerticalScrollbarPointerDown(d){this.q.delegateVerticalScrollbarPointerDown(d)}updateElementHeight(d,w,m){if(d<0||d>=this.d.length)return;const D=this.d[d].size;if(typeof w>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[d].lastDynamicHeightWidth=void 0,w=D+this.tb(d)}if(D===w)return;const R=this.rb(this.k,this.m);let V=0;d<R.start||m!==null&&m>d&&m<=R.end?V=w-D:V=0,this.g.splice(d,1,[{size:w}]),this.d[d].size=w,this.V(R,Math.max(0,this.k+V),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.R(),this.B&&this.sb(this.k,this.m)}splice(d,w,m=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.Q(d,w,m)}finally{this.v=!1,this.M.fire(this.contentHeight)}}Q(d,w,m=[]){const D=this.rb(this.k,this.m),R={start:d,end:d+w},V=o.Range.intersect(D,R),Z=new Map;for(let ie=V.end-1;ie>=V.start;ie--){const A=this.d[ie];if(A.dragStartDisposable.dispose(),A.checkedDisposable.dispose(),A.row){let C=Z.get(A.templateId);C||(C=[],Z.set(A.templateId,C));const h=this.j.get(A.templateId);h&&h.disposeElement&&h.disposeElement(A.element,ie,A.row.templateData,A.size),C.push(A.row)}A.row=null}const X={start:d+w,end:this.d.length},x=o.Range.intersect(X,D),ne=o.Range.relativeComplement(X,D),le=m.map(ie=>({id:String(this.f++),element:ie,templateId:this.P.getTemplateId(ie),size:this.P.getHeight(ie),width:void 0,hasDynamicHeight:!!this.P.hasDynamicHeight&&this.P.hasDynamicHeight(ie),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:I.Disposable.None,checkedDisposable:I.Disposable.None}));let se;d===0&&w>=this.d.length?(this.g=new e.RangeMap,this.g.splice(0,0,le),se=this.d,this.d=le):(this.g.splice(d,w,le),se=this.d.splice(d,w,...le));const fe=m.length-w,Ae=this.rb(this.k,this.m),te=(0,e.shift)(x,fe),ve=o.Range.intersect(Ae,te);for(let ie=ve.start;ie<ve.end;ie++)this.Y(this.d[ie],ie);const Ne=o.Range.relativeComplement(te,Ae);for(const ie of Ne)for(let A=ie.start;A<ie.end;A++)this.Z(A);const he=ne.map(ie=>(0,e.shift)(ie,fe)),oe=[{start:d,end:d+m.length},...he].map(ie=>o.Range.intersect(Ae,ie)),re=this.ub(oe);for(const ie of oe)for(let A=ie.start;A<ie.end;A++){const C=this.d[A],B=Z.get(C.templateId)?.pop();this.W(A,re,B)}for(const ie of Z.values())for(const A of ie)this.h.release(A);return this.R(),this.B&&this.sb(this.scrollTop,this.renderHeight),se.map(ie=>ie.element)}R(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,i.scheduleAtNextAnimationFrame)(()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.U(),this.t=null}))}S(){if(!this.O){this.u.cancel();return}this.u.trigger(()=>this.U())}U(){if(!this.O)return;let d=0;for(const w of this.d)typeof w.width<"u"&&(d=Math.max(d,w.width));this.E=d,this.q.setScrollDimensions({scrollWidth:d===0?0:d+10})}updateWidth(d){if(!this.O||typeof this.E>"u")return;const w=this.d[d];this.X(w),typeof w.width<"u"&&w.width>this.E&&(this.E=w.width,this.q.setScrollDimensions({scrollWidth:this.E+10}))}rerender(){if(!!this.B){for(const d of this.d)d.lastDynamicHeightWidth=void 0;this.sb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){const d=this.rb(this.k,this.m),w=this.g.positionAt(d.start),m=this.g.positionAt(d.start+1);return m!==-1&&(m-w)/2+w<this.scrollTop?d.start+1:d.start}get lastVisibleIndex(){return this.rb(this.k,this.m).end-1}element(d){return this.d[d].element}indexOf(d){return this.d.findIndex(w=>w.element===d)}domElement(d){const w=this.d[d].row;return w&&w.domNode}elementHeight(d){return this.d[d].size}elementTop(d){return this.g.positionAt(d)}indexAt(d){return this.g.indexAt(d)}indexAfter(d){return this.g.indexAfter(d)}layout(d,w){const m={height:typeof d=="number"?d:(0,i.getContentHeight)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,m.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(m),typeof w<"u"&&(this.n=w,this.B&&this.sb(this.scrollTop,this.renderHeight)),this.O&&this.q.setScrollDimensions({width:typeof w=="number"?w:(0,i.getContentWidth)(this.domNode)})}V(d,w,m,D,R,V=!1){const Z=this.rb(w,m),X=o.Range.relativeComplement(Z,d),x=o.Range.relativeComplement(d,Z),ne=this.ub(X);if(V){const le=o.Range.intersect(d,Z);for(let se=le.start;se<le.end;se++)this.Y(this.d[se],se)}this.h.transact(()=>{for(const le of x)for(let se=le.start;se<le.end;se++)this.Z(se);for(const le of X)for(let se=le.start;se<le.end;se++)this.W(se,ne)}),D!==void 0&&(this.o.style.left=`-${D}px`),this.o.style.top=`-${w}px`,this.O&&R!==void 0&&(this.o.style.width=`${Math.max(R,this.n)}px`),this.k=w,this.m=m}W(d,w,m){const D=this.d[d];let R=!1;if(!D.row)if(m)D.row=m;else{const ne=this.h.alloc(D.templateId);D.row=ne.row,R=ne.isReusingConnectedDomNode}const V=this.D.getRole(D.element)||"listitem";D.row.domNode.setAttribute("role",V);const Z=this.D.isChecked(D.element);if(typeof Z=="boolean")D.row.domNode.setAttribute("aria-checked",String(!!Z));else if(Z){const ne=le=>D.row.domNode.setAttribute("aria-checked",String(!!le));ne(Z.value),D.checkedDisposable=Z.onDidChange(ne)}(R||!D.row.domNode.parentElement)&&(w?this.o.insertBefore(D.row.domNode,w):this.o.appendChild(D.row.domNode)),this.Y(D,d);const X=this.j.get(D.templateId);if(!X)throw new Error(`No renderer found for template id ${D.templateId}`);X?.renderElement(D.element,d,D.row.templateData,D.size);const x=this.F.getDragURI(D.element);D.dragStartDisposable.dispose(),D.row.domNode.draggable=!!x,x&&(D.dragStartDisposable=(0,i.addDisposableListener)(D.row.domNode,"dragstart",ne=>this.hb(D.element,x,ne))),this.O&&(this.X(D),this.S())}X(d){if(!d.row||!d.row.domNode)return;d.row.domNode.style.width="fit-content",d.width=(0,i.getContentWidth)(d.row.domNode);const w=window.getComputedStyle(d.row.domNode);w.paddingLeft&&(d.width+=parseFloat(w.paddingLeft)),w.paddingRight&&(d.width+=parseFloat(w.paddingRight)),d.row.domNode.style.width=""}Y(d,w){d.row.domNode.style.top=`${this.elementTop(w)}px`,this.A&&(d.row.domNode.style.height=`${d.size}px`),this.z&&(d.row.domNode.style.lineHeight=`${d.size}px`),d.row.domNode.setAttribute("data-index",`${w}`),d.row.domNode.setAttribute("data-last-element",w===this.length-1?"true":"false"),d.row.domNode.setAttribute("data-parity",w%2===0?"even":"odd"),d.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(d.element,w,this.length))),d.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(d.element,w))),d.row.domNode.setAttribute("id",this.getElementDomId(w)),d.row.domNode.classList.toggle("drop-target",d.dropTarget)}Z(d){const w=this.d[d];if(w.dragStartDisposable.dispose(),w.checkedDisposable.dispose(),w.row){const m=this.j.get(w.templateId);m&&m.disposeElement&&m.disposeElement(w.element,d,w.row.templateData,w.size),this.h.release(w.row),w.row=null}this.O&&this.S()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(d,w){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:d,reuseAnimation:w})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(d){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:d})}get scrollTop(){return this.getScrollTop()}set scrollTop(d){this.setScrollTop(d)}get scrollHeight(){return this.s+(this.O?10:0)+this.C}get onMouseClick(){return f.Event.map(this.L.add(new z.DomEmitter(this.domNode,"click")).event,d=>this.ab(d),this.L)}get onMouseDblClick(){return f.Event.map(this.L.add(new z.DomEmitter(this.domNode,"dblclick")).event,d=>this.ab(d),this.L)}get onMouseMiddleClick(){return f.Event.filter(f.Event.map(this.L.add(new z.DomEmitter(this.domNode,"auxclick")).event,d=>this.ab(d),this.L),d=>d.browserEvent.button===1,this.L)}get onMouseUp(){return f.Event.map(this.L.add(new z.DomEmitter(this.domNode,"mouseup")).event,d=>this.ab(d),this.L)}get onMouseDown(){return f.Event.map(this.L.add(new z.DomEmitter(this.domNode,"mousedown")).event,d=>this.ab(d),this.L)}get onMouseOver(){return f.Event.map(this.L.add(new z.DomEmitter(this.domNode,"mouseover")).event,d=>this.ab(d),this.L)}get onMouseMove(){return f.Event.map(this.L.add(new z.DomEmitter(this.domNode,"mousemove")).event,d=>this.ab(d),this.L)}get onMouseOut(){return f.Event.map(this.L.add(new z.DomEmitter(this.domNode,"mouseout")).event,d=>this.ab(d),this.L)}get onContextMenu(){return f.Event.any(f.Event.map(this.L.add(new z.DomEmitter(this.domNode,"contextmenu")).event,d=>this.ab(d),this.L),f.Event.map(this.L.add(new z.DomEmitter(this.domNode,U.EventType.Contextmenu)).event,d=>this.db(d),this.L))}get onTouchStart(){return f.Event.map(this.L.add(new z.DomEmitter(this.domNode,"touchstart")).event,d=>this.bb(d),this.L)}get onTap(){return f.Event.map(this.L.add(new z.DomEmitter(this.o,U.EventType.Tap)).event,d=>this.db(d),this.L)}ab(d){const w=this.qb(d.target||null),m=typeof w>"u"?void 0:this.d[w],D=m&&m.element;return{browserEvent:d,index:w,element:D}}bb(d){const w=this.qb(d.target||null),m=typeof w>"u"?void 0:this.d[w],D=m&&m.element;return{browserEvent:d,index:w,element:D}}db(d){const w=this.qb(d.initialTarget||null),m=typeof w>"u"?void 0:this.d[w],D=m&&m.element;return{browserEvent:d,index:w,element:D}}eb(d){const w=this.qb(d.target||null),m=typeof w>"u"?void 0:this.d[w],D=m&&m.element;return{browserEvent:d,index:w,element:D}}fb(d){try{const w=this.rb(this.k,this.m);this.V(w,d.scrollTop,d.height,d.scrollLeft,d.scrollWidth),this.B&&this.sb(d.scrollTop,d.height,d.inSmoothScrolling)}catch(w){throw console.error("Got bad scroll event:",d),w}}gb(d){d.preventDefault(),d.stopPropagation(),this.scrollTop-=d.translationY}hb(d,w,m){if(!m.dataTransfer)return;const D=this.F.getDragElements(d);if(m.dataTransfer.effectAllowed="copyMove",m.dataTransfer.setData(v.DataTransfers.TEXT,w),m.dataTransfer.setDragImage){let R;this.F.getDragLabel&&(R=this.F.getDragLabel(D,m)),typeof R>"u"&&(R=String(D.length));const V=(0,i.$)(".monaco-drag-image");V.textContent=R,document.body.appendChild(V),m.dataTransfer.setDragImage(V,-10,-10),setTimeout(()=>document.body.removeChild(V),0)}this.domNode.classList.add("dragging"),this.H=new p(D),a.CurrentDragAndDropData=new k(D),this.F.onDragStart?.(this.H,m)}ib(d){if(d.browserEvent.preventDefault(),this.K.dispose(),a.CurrentDragAndDropData&&a.CurrentDragAndDropData.getData()==="vscode-ui"||(this.nb(d.browserEvent),!d.browserEvent.dataTransfer))return!1;if(!this.H)if(a.CurrentDragAndDropData)this.H=a.CurrentDragAndDropData;else{if(!d.browserEvent.dataTransfer.types)return!1;this.H=new S}const w=this.F.onDragOver(this.H,d.element,d.index,d.browserEvent);if(this.G=typeof w=="boolean"?w:w.accept,!this.G)return this.I=void 0,this.J.dispose(),!1;d.browserEvent.dataTransfer.dropEffect=typeof w!="boolean"&&w.effect===0?"copy":"move";let m;if(typeof w!="boolean"&&w.feedback?m=w.feedback:typeof d.index>"u"?m=[-1]:m=[d.index],m=(0,b.distinct)(m).filter(D=>D>=-1&&D<this.length).sort((D,R)=>D-R),m=m[0]===-1?[-1]:m,g(this.I,m))return!0;if(this.I=m,this.J.dispose(),m[0]===-1)this.domNode.classList.add("drop-target"),this.o.classList.add("drop-target"),this.J=(0,I.toDisposable)(()=>{this.domNode.classList.remove("drop-target"),this.o.classList.remove("drop-target")});else{for(const D of m){const R=this.d[D];R.dropTarget=!0,R.row?.domNode.classList.add("drop-target")}this.J=(0,I.toDisposable)(()=>{for(const D of m){const R=this.d[D];R.dropTarget=!1,R.row?.domNode.classList.remove("drop-target")}})}return!0}jb(d){this.K.dispose(),this.K=(0,u.disposableTimeout)(()=>this.mb(),100),this.H&&this.F.onDragLeave?.(this.H,d.element,d.index,d.browserEvent)}kb(d){if(!this.G)return;const w=this.H;this.pb(),this.mb(),this.domNode.classList.remove("dragging"),this.H=void 0,a.CurrentDragAndDropData=void 0,!(!w||!d.browserEvent.dataTransfer)&&(d.browserEvent.preventDefault(),w.update(d.browserEvent.dataTransfer),this.F.drop(w,d.element,d.index,d.browserEvent))}lb(d){this.G=!1,this.pb(),this.mb(),this.domNode.classList.remove("dragging"),this.H=void 0,a.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(d)}mb(){this.I=void 0,this.J.dispose(),this.J=I.Disposable.None}nb(d){if(!this.w){const w=(0,i.getTopLeftOffset)(this.domNode).top;this.w=(0,i.animate)(this.ob.bind(this,w))}this.x.dispose(),this.x=(0,u.disposableTimeout)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3),this.y=d.pageY}ob(d){if(this.y===void 0)return;const w=this.y-d,m=this.renderHeight-35;w<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(w-35))):w>m&&(this.scrollTop+=Math.min(14,Math.floor(.3*(w-m))))}pb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}qb(d){const w=this.q.getDomNode();let m=d;for(;m instanceof HTMLElement&&m!==this.o&&w.contains(m);){const D=m.getAttribute("data-index");if(D){const R=Number(D);if(!isNaN(R))return R}m=m.parentElement}}rb(d,w){return{start:this.g.indexAt(d),end:this.g.indexAfter(d+w-1)}}sb(d,w,m){const D=this.rb(d,w);let R,V;d===this.elementTop(D.start)?(R=D.start,V=0):D.end-D.start>1&&(R=D.start+1,V=this.elementTop(R)-d);let Z=0;for(;;){const X=this.rb(d,w);let x=!1;for(let ne=X.start;ne<X.end;ne++){const le=this.tb(ne);le!==0&&this.g.splice(ne,1,[this.d[ne]]),Z+=le,x=x||le!==0}if(!x){Z!==0&&this.R();const ne=o.Range.relativeComplement(D,X);for(const se of ne)for(let fe=se.start;fe<se.end;fe++)this.d[fe].row&&this.Z(fe);const le=o.Range.relativeComplement(X,D);for(const se of le)for(let fe=se.start;fe<se.end;fe++){const Ae=fe+1,te=Ae<this.d.length?this.d[Ae].row:null,ve=te?te.domNode:null;this.W(fe,ve)}for(let se=X.start;se<X.end;se++)this.d[se].row&&this.Y(this.d[se],se);if(typeof R=="number"){const se=this.p.getFutureScrollPosition().scrollTop-d,fe=this.elementTop(R)-V+se;this.setScrollTop(fe,m)}this.M.fire(this.contentHeight);return}}}tb(d){const w=this.d[d];if(this.P.getDynamicHeight){const V=this.P.getDynamicHeight(w.element);if(V!==null){const Z=w.size;return w.size=V,w.lastDynamicHeightWidth=this.n,V-Z}}if(!w.hasDynamicHeight||w.lastDynamicHeightWidth===this.n||!!this.P.hasDynamicHeight&&!this.P.hasDynamicHeight(w.element))return 0;const m=w.size;if(w.row)return w.row.domNode.style.height="",w.size=w.row.domNode.offsetHeight,w.lastDynamicHeightWidth=this.n,w.size-m;const{row:D}=this.h.alloc(w.templateId);D.domNode.style.height="",this.o.appendChild(D.domNode);const R=this.j.get(w.templateId);if(!R)throw new r.BugIndicatingError("Missing renderer for templateId: "+w.templateId);return R.renderElement(w.element,d,D.templateData,void 0),w.size=D.domNode.offsetHeight,R.disposeElement?.(w.element,d,D.templateData,void 0),this.P.setDynamicHeight?.(w.element,w.size),w.lastDynamicHeightWidth=this.n,this.o.removeChild(D.domNode),this.h.release(D),w.size-m}ub(d){const w=d[d.length-1];if(!w)return null;const m=this.d[w.end];return!m||!m.row?null:m.row.domNode}getElementDomId(d){return`${this.domId}_${d}`}dispose(){if(this.d){for(const d of this.d)if(d.row){const w=this.j.get(d.row.templateId);w&&(w.disposeElement?.(d.element,-1,d.row.templateData,void 0),w.disposeTemplate(d.row.templateData))}this.d=[]}this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),(0,I.dispose)(this.L)}}N.c=0,qe([c.memoize],N.prototype,"onMouseClick",null),qe([c.memoize],N.prototype,"onMouseDblClick",null),qe([c.memoize],N.prototype,"onMouseMiddleClick",null),qe([c.memoize],N.prototype,"onMouseUp",null),qe([c.memoize],N.prototype,"onMouseDown",null),qe([c.memoize],N.prototype,"onMouseOver",null),qe([c.memoize],N.prototype,"onMouseMove",null),qe([c.memoize],N.prototype,"onMouseOut",null),qe([c.memoize],N.prototype,"onContextMenu",null),qe([c.memoize],N.prototype,"onTouchStart",null),qe([c.memoize],N.prototype,"onTap",null),t.ListView=N}),define(me[59],be([1,0,4,19,15,22,54,69,14,8,41,24,3,32,2,46,30,5,6,68,58,89]),function(J,t,v,i,z,U,y,b,u,c,f,I,o,n,e,s,r,a,l,p,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.List=t.DefaultStyleController=t.MouseController=t.isSelectionRangeChangeEvent=t.isSelectionSingleChangeEvent=t.DefaultKeyboardNavigationDelegate=t.TypeNavigationMode=t.isButton=t.isMonacoEditor=t.isInputElement=void 0;class S{constructor(h){this.d=h,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(h){return h}renderElement(h,B,_){const $=this.c.findIndex(Y=>Y.templateData===_);if($>=0){const Y=this.c[$];this.d.unrender(_),Y.index=B}else{const Y={index:B,templateData:_};this.c.push(Y)}this.d.renderIndex(B,_)}splice(h,B,_){const $=[];for(const Y of this.c)Y.index<h?$.push(Y):Y.index>=h+B&&$.push({index:Y.index+_-B,templateData:Y.templateData});this.c=$}renderIndexes(h){for(const{index:B,templateData:_}of this.c)h.indexOf(B)>-1&&this.d.renderIndex(B,_)}disposeTemplate(h){const B=this.c.findIndex(_=>_.templateData===h);B<0||this.c.splice(B,1)}}class g{get name(){return this.h}get renderer(){return new S(this)}constructor(h){this.h=h,this.c=0,this.d=[],this.f=[],this.g=new o.Emitter,this.onChange=this.g.event}splice(h,B,_){B=Math.max(0,Math.min(B,this.c-h));const $=_.length-B,Y=h+B,T=[...this.f.filter(W=>W<h),..._.map((W,L)=>W?L+h:-1).filter(W=>W!==-1),...this.f.filter(W=>W>=Y).map(W=>W+$)],H=this.c+$;if(this.f.length>0&&T.length===0&&H>0){const W=this.f.find(L=>L>=h)??H-1;T.push(Math.min(W,H-1))}this.renderer.splice(h,B,_.length),this.k(T,T),this.c=H}renderIndex(h,B){B.classList.toggle(this.h,this.contains(h))}unrender(h){h.classList.remove(this.h)}set(h,B){return this.k(h,[...h].sort(Q),B)}k(h,B,_){const $=this.d,Y=this.f;this.d=h,this.f=B;const T=Ne(Y,h);return this.renderer.renderIndexes(T),this.g.fire({indexes:h,browserEvent:_}),$}get(){return this.d}contains(h){return(0,u.binarySearch)(this.f,h,Q)>=0}dispose(){(0,e.dispose)(this.g)}}qe([I.memoize],g.prototype,"renderer",null);class E extends g{constructor(h){super("selected"),this.l=h}renderIndex(h,B){super.renderIndex(h,B),this.l&&(this.contains(h)?B.setAttribute("aria-selected","true"):B.setAttribute("aria-selected","false"))}}class N{constructor(h,B,_){this.c=h,this.d=B,this.f=_}splice(h,B,_){if(!this.f)return this.c.splice(h,B,_.map(()=>!1));const $=this.c.get().map(T=>this.f.getId(this.d.element(T)).toString()),Y=_.map(T=>$.indexOf(this.f.getId(T).toString())>-1);this.c.splice(h,B,Y)}}function F(C){return C.tagName==="INPUT"||C.tagName==="TEXTAREA"}t.isInputElement=F;function d(C){return C.classList.contains("monaco-editor")?!0:C.classList.contains("monaco-list")||!C.parentElement?!1:d(C.parentElement)}t.isMonacoEditor=d;function w(C){return C.tagName==="A"&&C.classList.contains("monaco-button")||C.tagName==="DIV"&&C.classList.contains("monaco-button-dropdown")?!0:C.classList.contains("monaco-list")||!C.parentElement?!1:w(C.parentElement)}t.isButton=w;class m{get f(){return this.c.add(o.Event.chain(this.c.add(new i.DomEmitter(this.h.domNode,"keydown")).event).filter(h=>!F(h.target)).map(h=>new z.StandardKeyboardEvent(h)))}constructor(h,B,_){this.g=h,this.h=B,this.c=new e.DisposableStore,this.d=new e.DisposableStore,this.f.filter($=>$.keyCode===3).on(this.k,this,this.c),this.f.filter($=>$.keyCode===16).on(this.l,this,this.c),this.f.filter($=>$.keyCode===18).on(this.o,this,this.c),this.f.filter($=>$.keyCode===11).on(this.p,this,this.c),this.f.filter($=>$.keyCode===12).on(this.q,this,this.c),this.f.filter($=>$.keyCode===9).on(this.t,this,this.c),_.multipleSelectionSupport!==!1&&this.f.filter($=>(a.isMacintosh?$.metaKey:$.ctrlKey)&&$.keyCode===31).on(this.s,this,this.d)}updateOptions(h){h.multipleSelectionSupport!==void 0&&(this.d.clear(),h.multipleSelectionSupport&&this.f.filter(B=>(a.isMacintosh?B.metaKey:B.ctrlKey)&&B.keyCode===31).on(this.s,this,this.d))}k(h){h.preventDefault(),h.stopPropagation(),this.g.setSelection(this.g.getFocus(),h.browserEvent)}l(h){h.preventDefault(),h.stopPropagation(),this.g.focusPrevious(1,!1,h.browserEvent);const B=this.g.getFocus()[0];this.g.setAnchor(B),this.g.reveal(B),this.h.domNode.focus()}o(h){h.preventDefault(),h.stopPropagation(),this.g.focusNext(1,!1,h.browserEvent);const B=this.g.getFocus()[0];this.g.setAnchor(B),this.g.reveal(B),this.h.domNode.focus()}p(h){h.preventDefault(),h.stopPropagation(),this.g.focusPreviousPage(h.browserEvent);const B=this.g.getFocus()[0];this.g.setAnchor(B),this.g.reveal(B),this.h.domNode.focus()}q(h){h.preventDefault(),h.stopPropagation(),this.g.focusNextPage(h.browserEvent);const B=this.g.getFocus()[0];this.g.setAnchor(B),this.g.reveal(B),this.h.domNode.focus()}s(h){h.preventDefault(),h.stopPropagation(),this.g.setSelection((0,u.range)(this.g.length),h.browserEvent),this.g.setAnchor(void 0),this.h.domNode.focus()}t(h){this.g.getSelection().length&&(h.preventDefault(),h.stopPropagation(),this.g.setSelection([],h.browserEvent),this.g.setAnchor(void 0),this.h.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}qe([I.memoize],m.prototype,"f",null);var D;(function(C){C[C.Automatic=0]="Automatic",C[C.Trigger=1]="Trigger"})(D=t.TypeNavigationMode||(t.TypeNavigationMode={}));var R;(function(C){C[C.Idle=0]="Idle",C[C.Typing=1]="Typing"})(R||(R={})),t.DefaultKeyboardNavigationDelegate=new class{mightProducePrintableCharacter(C){return C.ctrlKey||C.metaKey||C.altKey?!1:C.keyCode>=31&&C.keyCode<=56||C.keyCode>=21&&C.keyCode<=30||C.keyCode>=93&&C.keyCode<=102||C.keyCode>=80&&C.keyCode<=90}};class V{constructor(h,B,_,$,Y){this.o=h,this.p=B,this.q=_,this.s=$,this.t=Y,this.c=!1,this.d=R.Idle,this.f=D.Automatic,this.g=!1,this.h=-1,this.k=new e.DisposableStore,this.l=new e.DisposableStore,this.updateOptions(h.options)}updateOptions(h){h.typeNavigationEnabled??!0?this.u():this.v(),this.f=h.typeNavigationMode??D.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let h=!1;const B=this.k.add(o.Event.chain(this.k.add(new i.DomEmitter(this.p.domNode,"keydown")).event)).filter(Y=>!F(Y.target)).filter(()=>this.f===D.Automatic||this.g).map(Y=>new z.StandardKeyboardEvent(Y)).filter(Y=>h||this.s(Y)).filter(Y=>this.t.mightProducePrintableCharacter(Y)).forEach(Y=>v.EventHelper.stop(Y,!0)).map(Y=>Y.browserEvent.key).event,_=o.Event.debounce(B,()=>null,800,void 0,void 0,this.k);o.Event.reduce(o.Event.any(B,_),(Y,T)=>T===null?null:(Y||"")+T,void 0,this.k)(this.z,this,this.k),_(this.w,this,this.k),B(()=>h=!0,void 0,this.k),_(()=>h=!1,void 0,this.k),this.c=!0,this.g=!1}v(){!this.c||(this.k.clear(),this.c=!1,this.g=!1)}w(){const h=this.o.getFocus();if(h.length>0&&h[0]===this.h){const B=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(h[0]));B&&(0,y.alert)(B)}this.h=-1}z(h){if(!h){this.d=R.Idle,this.g=!1;return}const B=this.o.getFocus(),_=B.length>0?B[0]:0,$=this.d===R.Idle?1:0;this.d=R.Typing;for(let Y=0;Y<this.o.length;Y++){const T=(_+Y+$)%this.o.length,H=this.q.getKeyboardNavigationLabel(this.p.element(T)),W=H&&H.toString();if(typeof W>"u"||(0,n.matchesPrefix)(h,W)){this.h=_,this.o.setFocus([T]),this.o.reveal(T);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class Z{constructor(h,B){this.d=h,this.f=B,this.c=new e.DisposableStore,this.c.add(o.Event.chain(this.c.add(new i.DomEmitter(B.domNode,"keydown")).event)).filter($=>!F($.target)).map($=>new z.StandardKeyboardEvent($)).filter($=>$.keyCode===2&&!$.ctrlKey&&!$.metaKey&&!$.shiftKey&&!$.altKey).on(this.g,this,this.c)}g(h){if(h.target!==this.f.domNode)return;const B=this.d.getFocus();if(B.length===0)return;const _=this.f.domElement(B[0]);if(!_)return;const $=_.querySelector("[tabIndex]");if(!$||!($ instanceof HTMLElement)||$.tabIndex===-1)return;const Y=window.getComputedStyle($);Y.visibility==="hidden"||Y.display==="none"||(h.preventDefault(),h.stopPropagation(),$.focus())}dispose(){this.c.dispose()}}function X(C){return a.isMacintosh?C.browserEvent.metaKey:C.browserEvent.ctrlKey}t.isSelectionSingleChangeEvent=X;function x(C){return C.browserEvent.shiftKey}t.isSelectionRangeChangeEvent=x;function ne(C){return C instanceof MouseEvent&&C.button===2}const le={isSelectionSingleChangeEvent:X,isSelectionRangeChangeEvent:x};class se{constructor(h){this.k=h,this.f=new e.DisposableStore,this.g=new o.Emitter,this.onPointer=this.g.event,h.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||le),this.d=typeof h.options.mouseSupport>"u"||!!h.options.mouseSupport,this.d&&(h.onMouseDown(this.s,this,this.f),h.onContextMenu(this.t,this,this.f),h.onMouseDblClick(this.v,this,this.f),h.onTouchStart(this.s,this,this.f),this.f.add(U.Gesture.addTarget(h.getHTMLElement()))),o.Event.any(h.onMouseClick,h.onMouseMiddleClick,h.onTap)(this.u,this,this.f)}updateOptions(h){h.multipleSelectionSupport!==void 0&&(this.c=void 0,h.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||le))}o(h){return this.c?this.c.isSelectionSingleChangeEvent(h):!1}p(h){return this.c?this.c.isSelectionRangeChangeEvent(h):!1}q(h){return this.o(h)||this.p(h)}s(h){d(h.browserEvent.target)||document.activeElement!==h.browserEvent.target&&this.k.domFocus()}t(h){if(d(h.browserEvent.target))return;const B=typeof h.index>"u"?[]:[h.index];this.k.setFocus(B,h.browserEvent)}u(h){if(!this.d||F(h.browserEvent.target)||d(h.browserEvent.target))return;const B=h.index;if(typeof B>"u"){this.k.setFocus([],h.browserEvent),this.k.setSelection([],h.browserEvent),this.k.setAnchor(void 0);return}if(this.p(h))return this.w(h);if(this.q(h))return this.w(h);this.k.setFocus([B],h.browserEvent),this.k.setAnchor(B),ne(h.browserEvent)||this.k.setSelection([B],h.browserEvent),this.g.fire(h)}v(h){if(F(h.browserEvent.target)||d(h.browserEvent.target)||this.q(h))return;const B=this.k.getFocus();this.k.setSelection(B,h.browserEvent)}w(h){const B=h.index;let _=this.k.getAnchor();if(this.p(h)){typeof _>"u"&&(_=this.k.getFocus()[0]??B,this.k.setAnchor(_));const $=Math.min(_,B),Y=Math.max(_,B),T=(0,u.range)($,Y+1),H=this.k.getSelection(),W=ve(Ne(H,[_]),_);if(W.length===0)return;const L=Ne(T,he(H,W));this.k.setSelection(L,h.browserEvent),this.k.setFocus([B],h.browserEvent)}else if(this.o(h)){const $=this.k.getSelection(),Y=$.filter(T=>T!==B);this.k.setFocus([B]),this.k.setAnchor(B),$.length===Y.length?this.k.setSelection([...Y,B],h.browserEvent):this.k.setSelection(Y,h.browserEvent)}}dispose(){this.f.dispose()}}t.MouseController=se;class fe{constructor(h,B){this.c=h,this.d=B}style(h){const B=this.d&&`.${this.d}`,_=[];h.listBackground&&(h.listBackground.isOpaque()?_.push(`.monaco-list${B} .monaco-list-rows { background: ${h.listBackground}; }`):a.isMacintosh||console.warn(`List with id '${this.d}' was styled with a non-opaque background color. This will break sub-pixel antialiasing.`)),h.listFocusBackground&&(_.push(`.monaco-list${B}:focus .monaco-list-row.focused { background-color: ${h.listFocusBackground}; }`),_.push(`.monaco-list${B}:focus .monaco-list-row.focused:hover { background-color: ${h.listFocusBackground}; }`)),h.listFocusForeground&&_.push(`.monaco-list${B}:focus .monaco-list-row.focused { color: ${h.listFocusForeground}; }`),h.listActiveSelectionBackground&&(_.push(`.monaco-list${B}:focus .monaco-list-row.selected { background-color: ${h.listActiveSelectionBackground}; }`),_.push(`.monaco-list${B}:focus .monaco-list-row.selected:hover { background-color: ${h.listActiveSelectionBackground}; }`)),h.listActiveSelectionForeground&&_.push(`.monaco-list${B}:focus .monaco-list-row.selected { color: ${h.listActiveSelectionForeground}; }`),h.listActiveSelectionIconForeground&&_.push(`.monaco-list${B}:focus .monaco-list-row.selected .codicon { color: ${h.listActiveSelectionIconForeground}; }`),h.listFocusAndSelectionOutline&&_.push(`.monaco-list${B}:focus .monaco-list-row.selected { outline-color: ${h.listFocusAndSelectionOutline} !important; }`),h.listFocusAndSelectionBackground&&_.push(`
				.monaco-drag-image,
				.monaco-list${B}:focus .monaco-list-row.selected.focused { background-color: ${h.listFocusAndSelectionBackground}; }
			`),h.listFocusAndSelectionForeground&&_.push(`
				.monaco-drag-image,
				.monaco-list${B}:focus .monaco-list-row.selected.focused { color: ${h.listFocusAndSelectionForeground}; }
			`),h.listInactiveFocusForeground&&(_.push(`.monaco-list${B} .monaco-list-row.focused { color:  ${h.listInactiveFocusForeground}; }`),_.push(`.monaco-list${B} .monaco-list-row.focused:hover { color:  ${h.listInactiveFocusForeground}; }`)),h.listInactiveSelectionIconForeground&&_.push(`.monaco-list${B} .monaco-list-row.focused .codicon { color:  ${h.listInactiveSelectionIconForeground}; }`),h.listInactiveFocusBackground&&(_.push(`.monaco-list${B} .monaco-list-row.focused { background-color:  ${h.listInactiveFocusBackground}; }`),_.push(`.monaco-list${B} .monaco-list-row.focused:hover { background-color:  ${h.listInactiveFocusBackground}; }`)),h.listInactiveSelectionBackground&&(_.push(`.monaco-list${B} .monaco-list-row.selected { background-color:  ${h.listInactiveSelectionBackground}; }`),_.push(`.monaco-list${B} .monaco-list-row.selected:hover { background-color:  ${h.listInactiveSelectionBackground}; }`)),h.listInactiveSelectionForeground&&_.push(`.monaco-list${B} .monaco-list-row.selected { color: ${h.listInactiveSelectionForeground}; }`),h.listHoverBackground&&_.push(`.monaco-list${B}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${h.listHoverBackground}; }`),h.listHoverForeground&&_.push(`.monaco-list${B}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${h.listHoverForeground}; }`),h.listSelectionOutline&&_.push(`.monaco-list${B} .monaco-list-row.selected { outline: 1px dotted ${h.listSelectionOutline}; outline-offset: -1px; }`),h.listFocusOutline&&_.push(`
				.monaco-drag-image,
				.monaco-list${B}:focus .monaco-list-row.focused { outline: 1px solid ${h.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${B}.last-focused .monaco-list-row.focused { outline: 1px solid ${h.listFocusOutline}; outline-offset: -1px; }
			`),h.listInactiveFocusOutline&&_.push(`.monaco-list${B} .monaco-list-row.focused { outline: 1px dotted ${h.listInactiveFocusOutline}; outline-offset: -1px; }`),h.listHoverOutline&&_.push(`.monaco-list${B} .monaco-list-row:hover { outline: 1px dashed ${h.listHoverOutline}; outline-offset: -1px; }`),h.listDropBackground&&_.push(`
				.monaco-list${B}.drop-target,
				.monaco-list${B} .monaco-list-rows.drop-target,
				.monaco-list${B} .monaco-list-row.drop-target { background-color: ${h.listDropBackground} !important; color: inherit !important; }
			`),h.tableColumnsBorder&&_.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${h.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),h.tableOddRowsBackgroundColor&&_.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${h.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=_.join(`
`)}}t.DefaultStyleController=fe;const Ae={listFocusBackground:f.Color.fromHex("#7FB0D0"),listActiveSelectionBackground:f.Color.fromHex("#0E639C"),listActiveSelectionForeground:f.Color.fromHex("#FFFFFF"),listActiveSelectionIconForeground:f.Color.fromHex("#FFFFFF"),listFocusAndSelectionOutline:f.Color.fromHex("#90C2F9"),listFocusAndSelectionBackground:f.Color.fromHex("#094771"),listFocusAndSelectionForeground:f.Color.fromHex("#FFFFFF"),listInactiveSelectionBackground:f.Color.fromHex("#3F3F46"),listInactiveSelectionIconForeground:f.Color.fromHex("#FFFFFF"),listHoverBackground:f.Color.fromHex("#2A2D2E"),listDropBackground:f.Color.fromHex("#383B3D"),treeIndentGuidesStroke:f.Color.fromHex("#a9a9a9"),tableColumnsBorder:f.Color.fromHex("#cccccc").transparent(.2),tableOddRowsBackgroundColor:f.Color.fromHex("#cccccc").transparent(.04)},te={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}}};function ve(C,h){const B=C.indexOf(h);if(B===-1)return[];const _=[];let $=B-1;for(;$>=0&&C[$]===h-(B-$);)_.push(C[$--]);for(_.reverse(),$=B;$<C.length&&C[$]===h+($-B);)_.push(C[$++]);return _}function Ne(C,h){const B=[];let _=0,$=0;for(;_<C.length||$<h.length;)if(_>=C.length)B.push(h[$++]);else if($>=h.length)B.push(C[_++]);else if(C[_]===h[$]){B.push(C[_]),_++,$++;continue}else C[_]<h[$]?B.push(C[_++]):B.push(h[$++]);return B}function he(C,h){const B=[];let _=0,$=0;for(;_<C.length||$<h.length;)if(_>=C.length)B.push(h[$++]);else if($>=h.length)B.push(C[_++]);else if(C[_]===h[$]){_++,$++;continue}else C[_]<h[$]?B.push(C[_++]):$++;return B}const Q=(C,h)=>C-h;class oe{constructor(h,B){this.c=h,this.d=B}get templateId(){return this.c}renderTemplate(h){return this.d.map(B=>B.renderTemplate(h))}renderElement(h,B,_,$){let Y=0;for(const T of this.d)T.renderElement(h,B,_[Y++],$)}disposeElement(h,B,_,$){let Y=0;for(const T of this.d)T.disposeElement?.(h,B,_[Y],$),Y+=1}disposeTemplate(h){let B=0;for(const _ of this.d)_.disposeTemplate(h[B++])}}class re{constructor(h){this.c=h,this.templateId="a18n"}renderTemplate(h){return h}renderElement(h,B,_){const $=this.c.getAriaLabel(h);$?_.setAttribute("aria-label",$):_.removeAttribute("aria-label");const Y=this.c.getAriaLevel&&this.c.getAriaLevel(h);typeof Y=="number"?_.setAttribute("aria-level",`${Y}`):_.removeAttribute("aria-level")}disposeTemplate(h){}}class ie{constructor(h,B){this.c=h,this.d=B}getDragElements(h){const B=this.c.getSelectedElements();return B.indexOf(h)>-1?B:[h]}getDragURI(h){return this.d.getDragURI(h)}getDragLabel(h,B){if(this.d.getDragLabel)return this.d.getDragLabel(h,B)}onDragStart(h,B){this.d.onDragStart?.(h,B)}onDragOver(h,B,_,$){return this.d.onDragOver(h,B,_,$)}onDragLeave(h,B,_,$){this.d.onDragLeave?.(h,B,_,$)}onDragEnd(h){this.d.onDragEnd?.(h)}drop(h,B,_,$){this.d.drop(h,B,_,$)}}class A{get onDidChangeFocus(){return o.Event.map(this.g.wrapEvent(this.c.onChange),h=>this.H(h),this.A)}get onDidChangeSelection(){return o.Event.map(this.g.wrapEvent(this.d.onChange),h=>this.H(h),this.A)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let h=!1;const B=this.A.add(o.Event.chain(this.A.add(new i.DomEmitter(this.k.domNode,"keydown")).event)).map(Y=>new z.StandardKeyboardEvent(Y)).filter(Y=>h=Y.keyCode===58||Y.shiftKey&&Y.keyCode===68).map(Y=>v.EventHelper.stop(Y,!0)).filter(()=>!1).event,_=this.A.add(o.Event.chain(this.A.add(new i.DomEmitter(this.k.domNode,"keyup")).event)).forEach(()=>h=!1).map(Y=>new z.StandardKeyboardEvent(Y)).filter(Y=>Y.keyCode===58||Y.shiftKey&&Y.keyCode===68).map(Y=>v.EventHelper.stop(Y,!0)).map(({browserEvent:Y})=>{const T=this.getFocus(),H=T.length?T[0]:void 0,W=typeof H<"u"?this.k.element(H):void 0,L=typeof H<"u"?this.k.domElement(H):this.k.domNode;return{index:H,element:W,anchor:L,browserEvent:Y}}).event,$=this.A.add(o.Event.chain(this.k.onContextMenu)).filter(Y=>!h).map(({element:Y,index:T,browserEvent:H})=>({element:Y,index:T,anchor:{x:H.pageX+1,y:H.pageY},browserEvent:H})).event;return o.Event.any(B,_,$)}get onKeyDown(){return this.A.add(new i.DomEmitter(this.k.domNode,"keydown")).event}get onKeyUp(){return this.A.add(new i.DomEmitter(this.k.domNode,"keyup")).event}get onKeyPress(){return this.A.add(new i.DomEmitter(this.k.domNode,"keypress")).event}get onDidFocus(){return o.Event.signal(this.A.add(new i.DomEmitter(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return o.Event.signal(this.A.add(new i.DomEmitter(this.k.domNode,"blur",!0)).event)}constructor(h,B,_,$,Y=te){this.C=h,this.D=Y,this.c=new g("focused"),this.f=new g("anchor"),this.g=new o.EventBufferer,this.z="",this.A=new e.DisposableStore,this.B=new o.Emitter,this.onDidDispose=this.B.event;const T=this.D.accessibilityProvider&&this.D.accessibilityProvider.getWidgetRole?this.D.accessibilityProvider?.getWidgetRole():"list";this.d=new E(T!=="listbox"),(0,r.mixin)(Y,Ae,!1);const H=[this.c.renderer,this.d.renderer];this.u=Y.accessibilityProvider,this.u&&(H.push(new re(this.u)),this.u.onDidChangeActiveDescendant?.(this.J,this,this.A)),$=$.map(L=>new oe(L.templateId,[...H,L]));const W={...Y,dnd:Y.dnd&&new ie(this,Y.dnd)};if(this.k=new k.ListView(B,_,$,W),this.k.domNode.setAttribute("role",T),Y.styleController)this.q=Y.styleController(this.k.domId);else{const L=(0,v.createStyleSheet)(this.k.domNode);this.q=new fe(L,this.k.domId)}if(this.o=new b.CombinedSpliceable([new N(this.c,this.k,Y.identityProvider),new N(this.d,this.k,Y.identityProvider),new N(this.f,this.k,Y.identityProvider),this.k]),this.A.add(this.c),this.A.add(this.d),this.A.add(this.f),this.A.add(this.k),this.A.add(this.B),this.A.add(new Z(this,this.k)),(typeof Y.keyboardSupport!="boolean"||Y.keyboardSupport)&&(this.v=new m(this,this.k,Y),this.A.add(this.v)),Y.keyboardNavigationLabelProvider){const L=Y.keyboardNavigationDelegate||t.DefaultKeyboardNavigationDelegate;this.t=new V(this,this.k,Y.keyboardNavigationLabelProvider,Y.keyboardNavigationEventFilter??(()=>!0),L),this.A.add(this.t)}this.w=this.E(Y),this.A.add(this.w),this.onDidChangeFocus(this.I,this,this.A),this.onDidChangeSelection(this.K,this,this.A),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.D.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}E(h){return new se(this)}updateOptions(h={}){this.D={...this.D,...h},this.t?.updateOptions(this.D),this.D.multipleSelectionController!==void 0&&(this.D.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(h),this.v?.updateOptions(h),this.k.updateOptions(h)}get options(){return this.D}splice(h,B,_=[]){if(h<0||h>this.k.length)throw new p.ListError(this.C,`Invalid start index: ${h}`);if(B<0)throw new p.ListError(this.C,`Invalid delete count: ${B}`);B===0&&_.length===0||this.g.bufferEvents(()=>this.o.splice(h,B,_))}updateWidth(h){this.k.updateWidth(h)}updateElementHeight(h,B){this.k.updateElementHeight(h,B,null)}rerender(){this.k.rerender()}element(h){return this.k.element(h)}indexOf(h){return this.k.indexOf(h)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get scrollTop(){return this.k.getScrollTop()}set scrollTop(h){this.k.setScrollTop(h)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(h){this.k.setScrollLeft(h)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.z}set ariaLabel(h){this.z=h,this.k.domNode.setAttribute("aria-label",h)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(h,B){this.k.layout(h,B)}triggerTypeNavigation(){this.t?.trigger()}setSelection(h,B){for(const _ of h)if(_<0||_>=this.length)throw new p.ListError(this.C,`Invalid index ${_}`);this.d.set(h,B)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(h=>this.k.element(h))}setAnchor(h){if(typeof h>"u"){this.f.set([]);return}if(h<0||h>=this.length)throw new p.ListError(this.C,`Invalid index ${h}`);this.f.set([h])}getAnchor(){return(0,u.firstOrDefault)(this.f.get(),void 0)}getAnchorElement(){const h=this.getAnchor();return typeof h>"u"?void 0:this.element(h)}setFocus(h,B){for(const _ of h)if(_<0||_>=this.length)throw new p.ListError(this.C,`Invalid index ${_}`);this.c.set(h,B)}focusNext(h=1,B=!1,_,$){if(this.length===0)return;const Y=this.c.get(),T=this.F(Y.length>0?Y[0]+h:0,B,$);T>-1&&this.setFocus([T],_)}focusPrevious(h=1,B=!1,_,$){if(this.length===0)return;const Y=this.c.get(),T=this.G(Y.length>0?Y[0]-h:0,B,$);T>-1&&this.setFocus([T],_)}async focusNextPage(h,B){let _=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);_=_===0?0:_-1;const $=this.getFocus()[0];if($!==_&&($===void 0||_>$)){const Y=this.G(_,!1,B);Y>-1&&$!==Y?this.setFocus([Y],h):this.setFocus([_],h)}else{const Y=this.k.getScrollTop();let T=Y+this.k.renderHeight;_>$&&(T-=this.k.elementHeight(_)),this.k.setScrollTop(T),this.k.getScrollTop()!==Y&&(this.setFocus([]),await(0,c.timeout)(0),await this.focusNextPage(h,B))}}async focusPreviousPage(h,B){let _;const $=this.k.getScrollTop();$===0?_=this.k.indexAt($):_=this.k.indexAfter($-1);const Y=this.getFocus()[0];if(Y!==_&&(Y===void 0||Y>=_)){const T=this.F(_,!1,B);T>-1&&Y!==T?this.setFocus([T],h):this.setFocus([_],h)}else{const T=$;this.k.setScrollTop($-this.k.renderHeight),this.k.getScrollTop()!==T&&(this.setFocus([]),await(0,c.timeout)(0),await this.focusPreviousPage(h,B))}}focusLast(h,B){if(this.length===0)return;const _=this.G(this.length-1,!1,B);_>-1&&this.setFocus([_],h)}focusFirst(h,B){this.focusNth(0,h,B)}focusNth(h,B,_){if(this.length===0)return;const $=this.F(h,!1,_);$>-1&&this.setFocus([$],B)}F(h,B=!1,_){for(let $=0;$<this.length;$++){if(h>=this.length&&!B)return-1;if(h=h%this.length,!_||_(this.element(h)))return h;h++}return-1}G(h,B=!1,_){for(let $=0;$<this.length;$++){if(h<0&&!B)return-1;if(h=(this.length+h%this.length)%this.length,!_||_(this.element(h)))return h;h--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(h=>this.k.element(h))}reveal(h,B){if(h<0||h>=this.length)throw new p.ListError(this.C,`Invalid index ${h}`);const _=this.k.getScrollTop(),$=this.k.elementTop(h),Y=this.k.elementHeight(h);if((0,l.isNumber)(B)){const T=Y-this.k.renderHeight;this.k.setScrollTop(T*(0,s.clamp)(B,0,1)+$)}else{const T=$+Y,H=_+this.k.renderHeight;$<_&&T>=H||($<_||T>=H&&Y>=this.k.renderHeight?this.k.setScrollTop($):T>=H&&this.k.setScrollTop(T-this.k.renderHeight))}}getRelativeTop(h){if(h<0||h>=this.length)throw new p.ListError(this.C,`Invalid index ${h}`);const B=this.k.getScrollTop(),_=this.k.elementTop(h),$=this.k.elementHeight(h);if(_<B||_+$>B+this.k.renderHeight)return null;const Y=$-this.k.renderHeight;return Math.abs((B-_)/Y)}isDOMFocused(){return this.k.domNode===document.activeElement}getHTMLElement(){return this.k.domNode}getElementID(h){return this.k.getElementDomId(h)}style(h){this.q.style(h)}H({indexes:h,browserEvent:B}){return{indexes:h,elements:h.map(_=>this.k.element(_)),browserEvent:B}}I(){const h=this.c.get();this.k.domNode.classList.toggle("element-focused",h.length>0),this.J()}J(){const h=this.c.get();if(h.length>0){let B;this.u?.getActiveDescendantId&&(B=this.u.getActiveDescendantId(this.k.element(h[0]))),this.k.domNode.setAttribute("aria-activedescendant",B||this.k.getElementDomId(h[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}K(){const h=this.d.get();this.k.domNode.classList.toggle("selection-none",h.length===0),this.k.domNode.classList.toggle("selection-single",h.length===1),this.k.domNode.classList.toggle("selection-multiple",h.length>1)}dispose(){this.B.fire(),this.A.dispose(),this.B.dispose()}}qe([I.memoize],A.prototype,"onDidChangeFocus",null),qe([I.memoize],A.prototype,"onDidChangeSelection",null),qe([I.memoize],A.prototype,"onContextMenu",null),qe([I.memoize],A.prototype,"onKeyDown",null),qe([I.memoize],A.prototype,"onKeyUp",null),qe([I.memoize],A.prototype,"onKeyPress",null),qe([I.memoize],A.prototype,"onDidFocus",null),qe([I.memoize],A.prototype,"onDidBlur",null),t.List=A}),define(me[60],be([1,0,9,33,35,11,16]),function(J,t,v,i,z,U,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseHrefAndDimensions=t.removeMarkdownEscapes=t.escapeDoubleQuotes=t.escapeMarkdownSyntaxTokens=t.markdownStringEqual=t.isMarkdownString=t.isEmptyMarkdownString=t.MarkdownString=t.MarkdownStringTextNewlineStyle=void 0;var b;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(b=t.MarkdownStringTextNewlineStyle||(t.MarkdownStringTextNewlineStyle={}));class u{constructor(a="",l=!1){if(this.value=a,typeof this.value!="string")throw(0,v.illegalArgument)("value");typeof l=="boolean"?(this.isTrusted=l,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=l.isTrusted??void 0,this.supportThemeIcons=l.supportThemeIcons??!1,this.supportHtml=l.supportHtml??!1)}appendText(a,l=0){return this.value+=o(this.supportThemeIcons?(0,i.escapeIcons)(a):a).replace(/([ \t]+)/g,(p,k)=>"&nbsp;".repeat(k.length)).replace(/\>/gm,"\\>").replace(/\n/g,l===1?`\\
`:`

`),this}appendMarkdown(a){return this.value+=a,this}appendCodeblock(a,l){return this.value+="\n```",this.value+=a,this.value+=`
`,this.value+=l,this.value+="\n```\n",this}appendLink(a,l,p){return this.value+="[",this.value+=this.c(l,"]"),this.value+="](",this.value+=this.c(String(a),")"),p&&(this.value+=` "${this.c(this.c(p,'"'),")")}"`),this.value+=")",this}c(a,l){const p=new RegExp((0,U.escapeRegExpCharacters)(l),"g");return a.replace(p,(k,S)=>a.charAt(S-1)!=="\\"?`\\${k}`:k)}}t.MarkdownString=u;function c(r){return f(r)?!r.value:Array.isArray(r)?r.every(c):!0}t.isEmptyMarkdownString=c;function f(r){return r instanceof u?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}t.isMarkdownString=f;function I(r,a){return r===a?!0:!r||!a?!1:r.value===a.value&&r.isTrusted===a.isTrusted&&r.supportThemeIcons===a.supportThemeIcons&&r.supportHtml===a.supportHtml&&(r.baseUri===a.baseUri||!!r.baseUri&&!!a.baseUri&&(0,z.isEqual)(y.URI.from(r.baseUri),y.URI.from(a.baseUri)))}t.markdownStringEqual=I;function o(r){return r.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}t.escapeMarkdownSyntaxTokens=o;function n(r){return r.replace(/"/g,"&quot;")}t.escapeDoubleQuotes=n;function e(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}t.removeMarkdownEscapes=e;function s(r){const a=[],l=r.split("|").map(k=>k.trim());r=l[0];const p=l[1];if(p){const k=/height=(\d+)/.exec(p),S=/width=(\d+)/.exec(p),g=k?k[1]:"",E=S?S[1]:"",N=isFinite(parseInt(E)),F=isFinite(parseInt(g));N&&a.push(`width="${E}"`),F&&a.push(`height="${g}"`)}return{href:r,dimensions:a}}t.parseHrefAndDimensions=s}),define(me[122],be([1,0,4,114,19,52,15,20,115,9,3,60,33,73,44,2,76,50,34,30,35,11,16]),function(J,t,v,i,z,U,y,b,u,c,f,I,o,n,e,s,r,a,l,p,k,S,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderMarkdownAsPlaintext=t.renderStringAsPlaintext=t.allowedMarkdownAttr=t.renderMarkdown=void 0;const E=Object.freeze({image:(X,x,ne)=>{let le=[],se=[];return X&&({href:X,dimensions:le}=(0,I.parseHrefAndDimensions)(X),se.push(`src="${(0,I.escapeDoubleQuotes)(X)}"`)),ne&&se.push(`alt="${(0,I.escapeDoubleQuotes)(ne)}"`),x&&se.push(`title="${(0,I.escapeDoubleQuotes)(x)}"`),le.length&&(se=se.concat(le)),"<img "+se.join(" ")+">"},paragraph:X=>`<p>${X}</p>`,link:(X,x,ne)=>typeof X!="string"?"":(X===ne&&(ne=(0,I.removeMarkdownEscapes)(ne)),x=typeof x=="string"?(0,I.escapeDoubleQuotes)((0,I.removeMarkdownEscapes)(x)):"",X=(0,I.removeMarkdownEscapes)(X),X=X.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${X}" title="${x||X}">${ne}</a>`)});function N(X,x={},ne={}){const le=new s.DisposableStore;let se=!1;const fe=(0,U.createElement)(x),Ae=function(ie){let A;try{A=(0,a.parse)(decodeURIComponent(ie))}catch{}return A?(A=(0,p.cloneAndChange)(A,C=>{if(X.uris&&X.uris[C])return g.URI.revive(X.uris[C])}),encodeURIComponent(JSON.stringify(A))):ie},te=function(ie,A){const C=X.uris&&X.uris[ie];let h=g.URI.revive(C);return A?ie.startsWith(l.Schemas.data+":")?ie:(h||(h=g.URI.parse(ie)),l.FileAccess.uriToBrowserUri(h).toString(!0)):!h||g.URI.parse(ie).toString()===h.toString()?ie:(h.query&&(h=h.with({query:Ae(h.query)})),h.toString())},ve=new r.marked.Renderer;ve.image=E.image,ve.link=E.link,ve.paragraph=E.paragraph;const Ne=[];if(x.codeBlockRenderer&&(ve.code=(ie,A)=>{const C=n.defaultGenerator.nextId(),h=x.codeBlockRenderer(F(A),ie);return Ne.push(h.then(B=>[C,B])),`<div class="code" data-code="${C}">${(0,S.escape)(ie)}</div>`}),x.actionHandler){const ie=function(h){let B=h.target;if(!(B.tagName!=="A"&&(B=B.parentElement,!B||B.tagName!=="A")))try{let _=B.dataset.href;_&&(X.baseUri&&(_=d(g.URI.from(X.baseUri),_)),x.actionHandler.callback(_,h))}catch(_){(0,c.onUnexpectedError)(_)}finally{h.preventDefault()}},A=x.actionHandler.disposables.add(new z.DomEmitter(fe,"click")),C=x.actionHandler.disposables.add(new z.DomEmitter(fe,"auxclick"));x.actionHandler.disposables.add(f.Event.any(A.event,C.event)(h=>{const B=new b.StandardMouseEvent(h);!B.leftButton&&!B.middleButton||ie(B)})),x.actionHandler.disposables.add(v.addDisposableListener(fe,"keydown",h=>{const B=new y.StandardKeyboardEvent(h);!B.equals(10)&&!B.equals(3)||ie(B)}))}X.supportHtml||(ne.sanitizer=ie=>(X.isTrusted?ie.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?ie:"",ne.sanitize=!0,ne.silent=!0),ne.renderer=ve;let he=X.value??"";he.length>1e5&&(he=`${he.substr(0,1e5)}\u2026`),X.supportThemeIcons&&(he=(0,o.markdownEscapeEscapedIcons)(he));let Q=r.marked.parse(he,ne);X.supportThemeIcons&&(Q=(0,u.renderLabelWithIcons)(Q).map(A=>typeof A=="string"?A:A.outerHTML).join(""));const re=new DOMParser().parseFromString(w(X,Q),"text/html");if(re.body.querySelectorAll("img").forEach(ie=>{const A=ie.getAttribute("src");if(A){let C=A;try{X.baseUri&&(C=d(g.URI.from(X.baseUri),C))}catch{}ie.src=te(C,!0)}}),re.body.querySelectorAll("a").forEach(ie=>{const A=ie.getAttribute("href");if(ie.removeAttribute("href"),!A||/^data:|javascript:/i.test(A)||/^command:/i.test(A)&&!X.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(A))ie.replaceWith(...ie.childNodes);else{let C=te(A,!1);X.baseUri&&(C=d(g.URI.from(X.baseUri),A)),ie.dataset.href=C}}),fe.innerHTML=w(X,re.body.innerHTML),Ne.length>0&&Promise.all(Ne).then(ie=>{if(se)return;const A=new Map(ie),C=fe.querySelectorAll("div[data-code]");for(const h of C){const B=A.get(h.dataset.code??"");B&&v.reset(h,B)}x.asyncRenderCallback?.()}),x.asyncRenderCallback)for(const ie of fe.getElementsByTagName("img")){const A=le.add(v.addDisposableListener(ie,"load",()=>{A.dispose(),x.asyncRenderCallback()}))}return{element:fe,dispose:()=>{se=!0,le.dispose()}}}t.renderMarkdown=N;function F(X){if(!X)return"";const x=X.split(/[\s+|:|,|\{|\?]/,1);return x.length?x[0]:X}function d(X,x){return/^\w[\w\d+.-]*:/.test(x)?x:X.path.endsWith("/")?(0,k.resolvePath)(X,x).toString():(0,k.resolvePath)((0,k.dirname)(X),x).toString()}function w(X,x){const{config:ne,allowedSchemes:le}=m(X);i.addHook("uponSanitizeAttribute",(fe,Ae)=>{if(Ae.attrName==="style"||Ae.attrName==="class"){if(fe.tagName==="SPAN"){if(Ae.attrName==="style"){Ae.keepAttr=/^(color\:#[0-9a-fA-F]+;)?(background-color\:#[0-9a-fA-F]+;)?$/.test(Ae.attrValue);return}else if(Ae.attrName==="class"){Ae.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(Ae.attrValue);return}}Ae.keepAttr=!1;return}});const se=v.hookDomPurifyHrefAndSrcSanitizer(le);try{return i.sanitize(x,{...ne,RETURN_TRUSTED_TYPE:!0})}finally{i.removeHook("uponSanitizeAttribute"),se.dispose()}}t.allowedMarkdownAttr=["align","autoplay","alt","class","controls","data-code","data-href","height","href","loop","muted","playsinline","poster","src","style","target","title","width"];function m(X){const x=[l.Schemas.http,l.Schemas.https,l.Schemas.mailto,l.Schemas.data,l.Schemas.file,l.Schemas.vscodeFileResource,l.Schemas.vscodeRemote,l.Schemas.vscodeRemoteResource];return X.isTrusted&&x.push(l.Schemas.command),{config:{ALLOWED_TAGS:[...v.basicMarkupHtmlTags],ALLOWED_ATTR:t.allowedMarkdownAttr,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:x}}function D(X){return typeof X=="string"?X:R(X)}t.renderStringAsPlaintext=D;function R(X){let x=X.value??"";x.length>1e5&&(x=`${x.substr(0,1e5)}\u2026`);const ne=r.marked.parse(x,{renderer:Z.getValue()}).replace(/&(#\d+|[a-zA-Z]+);/g,le=>V.get(le)??le);return w({isTrusted:!1},ne).toString()}t.renderMarkdownAsPlaintext=R;const V=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),Z=new e.Lazy(()=>{const X=new r.marked.Renderer;return X.code=x=>x,X.blockquote=x=>x,X.html=x=>"",X.heading=(x,ne,le)=>x+`
`,X.hr=()=>"",X.list=(x,ne)=>x,X.listitem=x=>x+`
`,X.paragraph=x=>x+`
`,X.table=(x,ne)=>x+ne+`
`,X.tablerow=x=>x,X.tablecell=(x,ne)=>x+" ",X.strong=x=>x,X.em=x=>x,X.codespan=x=>x,X.br=()=>`
`,X.del=x=>x,X.image=(x,ne,le)=>"",X.text=x=>x,X.link=(x,ne,le)=>le,X})}),define(me[123],be([1,0,4,8,26,60,33,2,6,99]),function(J,t,v,i,z,U,y,b,u,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setupCustomHover=t.setupNativeHover=void 0;function f(n,e){(0,u.isString)(e)?n.title=(0,y.stripIcons)(e):e?.markdownNotSupportedFallback?n.title=e.markdownNotSupportedFallback:n.removeAttribute("title")}t.setupNativeHover=f;class I{constructor(e,s,r){this.c=e,this.d=s,this.f=r}async update(e,s,r){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let a;if(e===void 0||(0,u.isString)(e)||e instanceof HTMLElement)a=e;else if(!(0,u.isFunction)(e.markdown))a=e.markdown??e.markdownNotSupportedFallback;else{this.a||this.g((0,c.localize)(0,null),s),this.b=new z.CancellationTokenSource;const l=this.b.token;if(a=await e.markdown(l),a===void 0&&(a=e.markdownNotSupportedFallback),this.isDisposed||l.isCancellationRequested)return}this.g(a,s,r)}g(e,s,r){const a=this.a;if(this.h(e)){const l={content:e,target:this.d,showPointer:this.c.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.f||!!a,...r};this.a=this.c.showHover(l,s)}a?.dispose()}h(e){return e?(0,U.isMarkdownString)(e)?!!e.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function o(n,e,s,r){let a,l;const p=(N,F)=>{N&&(l?.dispose(),l=void 0),F&&(a?.dispose(),a=void 0),n.onDidHideHover?.()},k=(N,F,d)=>new i.TimeoutTimer(async()=>{(!l||l.isDisposed)&&(l=new I(n,d||e,N>0),await l.update(s,F,r))},N),S=()=>{if(a)return;const N=new b.DisposableStore,F=m=>p(!1,m.fromElement===e);N.add(v.addDisposableListener(e,v.EventType.MOUSE_LEAVE,F,!0));const d=()=>p(!0,!0);N.add(v.addDisposableListener(e,v.EventType.MOUSE_DOWN,d,!0));const w={targetElements:[e],dispose:()=>{}};if(n.placement===void 0||n.placement==="mouse"){const m=D=>{w.x=D.x+10,D.target instanceof HTMLElement&&D.target.classList.contains("action-label")&&p(!0,!0)};N.add(v.addDisposableListener(e,v.EventType.MOUSE_MOVE,m,!0))}N.add(k(n.delay,!1,w)),a=N},g=v.addDisposableListener(e,v.EventType.MOUSE_OVER,S,!0);return{show:N=>{p(!1,!0),k(0,N)},hide:()=>{p(!0,!0)},update:async(N,F)=>{s=N,await l?.update(s,void 0,F)},dispose:()=>{g.dispose(),p(!0,!0)}}}t.setupCustomHover=o}),define(me[124],be([1,0,4,19,15,122,59,14,3,43,2,5,101,92]),function(J,t,v,i,z,U,y,b,u,c,f,I,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxList=void 0;const n=v.$,e="selectOption.entry.template";class s{get templateId(){return e}renderTemplate(l){const p=Object.create(null);return p.root=l,p.text=v.append(l,n(".option-text")),p.detail=v.append(l,n(".option-detail")),p.decoratorRight=v.append(l,n(".option-decorator-right")),p}renderElement(l,p,k){const S=k,g=l.text,E=l.detail,N=l.decoratorRight,F=l.isDisabled;S.text.textContent=g,S.detail.textContent=E||"",S.decoratorRight.innerText=N||"",F?S.root.classList.add("option-disabled"):S.root.classList.remove("option-disabled")}disposeTemplate(l){}}class r extends f.Disposable{constructor(l,p,k,S,g){super(),this.k=[],this.y=0,this.C=!1,this.F=!1,this.G=!1,this.f=!1,this.g=g||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=r.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.m=new u.Emitter,this.B(this.m),this.n=S,this.I(),this.H(k),this.l=p||0,l&&this.setOptions(l,p)}getHeight(){return 22}getTemplateId(){return e}H(l){this.r=l,this.s=v.$(".monaco-select-box-dropdown-container"),this.s.classList.add("monaco-select-box-dropdown-padding"),this.D=v.append(this.s,n(".select-box-details-pane"));const p=v.append(this.s,n(".select-box-dropdown-container-width-control")),k=v.append(p,n(".width-control-div"));this.w=document.createElement("span"),this.w.className="option-text-width-control",v.append(k,this.w),this.z=0,this.t=v.createStyleSheet(this.s),this.s.setAttribute("draggable","true"),this.B(v.addDisposableListener(this.s,v.EventType.DRAG_START,S=>{v.EventHelper.stop(S,!0)}))}I(){this.B(v.addStandardDisposableListener(this.h,"change",p=>{this.l=p.target.selectedIndex,this.m.fire({index:p.target.selectedIndex,selected:p.target.value}),!!this.k[this.l]&&!!this.k[this.l].text&&(this.h.title=this.k[this.l].text)})),this.B(v.addDisposableListener(this.h,v.EventType.CLICK,p=>{v.EventHelper.stop(p),this.f?this.O(!0):this.N()})),this.B(v.addDisposableListener(this.h,v.EventType.MOUSE_DOWN,p=>{v.EventHelper.stop(p)}));let l;this.B(v.addDisposableListener(this.h,"touchstart",p=>{l=this.f})),this.B(v.addDisposableListener(this.h,"touchend",p=>{v.EventHelper.stop(p),l?this.O(!0):this.N()})),this.B(v.addDisposableListener(this.h,v.EventType.KEY_DOWN,p=>{const k=new z.StandardKeyboardEvent(p);let S=!1;I.isMacintosh?(k.keyCode===18||k.keyCode===16||k.keyCode===10||k.keyCode===3)&&(S=!0):(k.keyCode===18&&k.altKey||k.keyCode===16&&k.altKey||k.keyCode===10||k.keyCode===3)&&(S=!0),S&&(this.N(),v.EventHelper.stop(p,!0))}))}get onDidSelect(){return this.m.event}setOptions(l,p){b.equals(this.k,l)||(this.k=l,this.h.options.length=0,this.C=!1,this.k.forEach((k,S)=>{this.h.add(this.M(k.text,S,k.isDisabled)),typeof k.description=="string"&&(this.C=!0)})),p!==void 0&&(this.select(p),this.y=this.l)}J(){this.u?.splice(0,this.u.length,this.k)}select(l){l>=0&&l<this.k.length?this.l=l:l>this.k.length-1?this.select(this.k.length-1):this.l<0&&(this.l=0),this.h.selectedIndex=this.l,!!this.k[this.l]&&!!this.k[this.l].text&&(this.h.title=this.k[this.l].text)}setAriaLabel(l){this.g.ariaLabel=l,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(l){this.h.tabIndex=l?0:-1}render(l){this.j=l,l.classList.add("select-container"),l.appendChild(this.h),this.applyStyles()}style(l){const p=[];this.n=l,this.n.listFocusBackground&&p.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.n.listFocusBackground} !important; }`),this.n.listFocusForeground&&p.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.n.listFocusForeground} !important; }`),this.n.decoratorRightForeground&&p.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.n.decoratorRightForeground}; }`),this.n.selectBackground&&this.n.selectBorder&&!this.n.selectBorder.equals(this.n.selectBackground)?(p.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.n.selectBorder} } `),p.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.n.selectBorder} } `),p.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.n.selectBorder} } `)):this.n.selectListBorder&&(p.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.n.selectListBorder} } `),p.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.n.selectListBorder} } `)),this.n.listHoverForeground&&p.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.n.listHoverForeground} !important; }`),this.n.listHoverBackground&&p.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.n.listHoverBackground} !important; }`),this.n.listFocusOutline&&p.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.n.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.n.listHoverOutline&&p.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.n.listHoverOutline} !important; outline-offset: -1.6px !important; }`),p.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),p.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.t.textContent=p.join(`
`),this.applyStyles()}applyStyles(){if(this.h){const l=this.n.selectBackground?this.n.selectBackground.toString():"",p=this.n.selectForeground?this.n.selectForeground.toString():"",k=this.n.selectBorder?this.n.selectBorder.toString():"";this.h.style.backgroundColor=l,this.h.style.color=p,this.h.style.borderColor=k}this.u&&this.L()}L(){if(this.u){const l=this.n.selectBackground?this.n.selectBackground.toString():"";this.u.style({});const p=this.n.selectListBackground?this.n.selectListBackground.toString():l;this.v.style.backgroundColor=p,this.D.style.backgroundColor=p;const k=this.n.focusBorder?this.n.focusBorder.toString():"";this.s.style.outlineColor=k,this.s.style.outlineOffset="-1px"}}M(l,p,k){const S=document.createElement("option");return S.value=l,S.text=l,S.disabled=!!k,S}N(){this.D.innerText="",!(!this.r||this.f)&&(this.U(this.s),this.J(),this.r.showContextView({getAnchor:()=>this.h,render:l=>this.P(l,!0),layout:()=>{this.R()},onHide:()=>{this.s.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.z},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.O(!1),this.r.showContextView({getAnchor:()=>this.h,render:l=>this.P(l),layout:()=>this.R(),onHide:()=>{this.s.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.z},this.g.optionsAsChildren?this.j:void 0),this.y=this.l,this.f=!0,this.h.setAttribute("aria-expanded","true"))}O(l){!this.r||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),l&&this.h.focus(),this.r.hideContextView())}P(l,p){return l.appendChild(this.s),this.R(p),{dispose:()=>{try{l.removeChild(this.s)}catch{}}}}Q(){let l=0;return this.k.forEach((p,k)=>{this.ab(k),this.D.offsetHeight>l&&(l=this.D.offsetHeight)}),l}R(l){if(this.F)return!1;if(this.u){this.s.classList.add("visible");const p=v.getDomNodePagePosition(this.h),k=getComputedStyle(this.h),S=parseFloat(k.getPropertyValue("--dropdown-padding-top"))+parseFloat(k.getPropertyValue("--dropdown-padding-bottom")),g=window.innerHeight-p.top-p.height-(this.g.minBottomMargin||0),E=p.top-r.b,N=this.h.offsetWidth,F=this.S(this.w),d=Math.max(F,Math.round(N)).toString()+"px";this.s.style.width=d,this.u.getHTMLElement().style.height="",this.u.layout();let w=this.u.contentHeight;const m=this.C?this.Q():0,D=w+S+m,R=Math.floor((g-S-m)/this.getHeight()),V=Math.floor((E-S-m)/this.getHeight());if(l)return p.top+p.height>window.innerHeight-22||p.top<r.b||R<1&&V<1?!1:(R<r.c&&V>R&&this.k.length>R?(this.z=1,this.s.removeChild(this.v),this.s.removeChild(this.D),this.s.appendChild(this.D),this.s.appendChild(this.v),this.D.classList.remove("border-top"),this.D.classList.add("border-bottom")):(this.z=0,this.s.removeChild(this.v),this.s.removeChild(this.D),this.s.appendChild(this.v),this.s.appendChild(this.D),this.D.classList.remove("border-bottom"),this.D.classList.add("border-top")),!0);if(p.top+p.height>window.innerHeight-22||p.top<r.b||this.z===0&&R<1||this.z===1&&V<1)return this.O(!0),!1;if(this.z===0){if(this.f&&R+V<1)return this.O(!0),!1;D>g&&(w=R*this.getHeight())}else D>E&&(w=V*this.getHeight());return this.u.layout(w),this.u.domFocus(),this.u.length>0&&(this.u.setFocus([this.l||0]),this.u.reveal(this.u.getFocus()[0]||0)),this.C?(this.u.getHTMLElement().style.height=w+S+"px",this.s.style.height=""):this.s.style.height=w+S+"px",this.ab(this.l),this.s.style.width=d,this.v.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.s.classList.add("synthetic-focus"),!0}else return!1}S(l){let p=0;if(l){let k=0,S=0;this.k.forEach((g,E)=>{const N=g.detail?g.detail.length:0,F=g.decoratorRight?g.decoratorRight.length:0,d=g.text.length+N+F;d>S&&(k=E,S=d)}),l.textContent=this.k[k].text+(this.k[k].decoratorRight?this.k[k].decoratorRight+" ":""),p=v.getTotalWidth(l)}return p}U(l){if(this.u)return;this.v=v.append(l,n(".select-box-dropdown-list-container")),this.p=new s,this.u=new y.List("SelectBoxCustom",this.v,this,[this.p],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:S=>{let g=S.text;return S.detail&&(g+=`. ${S.detail}`),S.decoratorRight&&(g+=`. ${S.decoratorRight}`),S.description&&(g+=`. ${S.description}`),g},getWidgetAriaLabel:()=>(0,o.localize)(0,null),getRole:()=>"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.u.ariaLabel=this.g.ariaLabel);const p=this.B(new i.DomEmitter(this.v,"keydown")),k=u.Event.chain(p.event).filter(()=>this.u.length>0).map(S=>new z.StandardKeyboardEvent(S));this.B(k.filter(S=>S.keyCode===3).on(S=>this.cb(S),this)),this.B(k.filter(S=>S.keyCode===2).on(S=>this.cb(S),this)),this.B(k.filter(S=>S.keyCode===9).on(S=>this.bb(S),this)),this.B(k.filter(S=>S.keyCode===16).on(S=>this.eb(S),this)),this.B(k.filter(S=>S.keyCode===18).on(S=>this.db(S),this)),this.B(k.filter(S=>S.keyCode===12).on(this.gb,this)),this.B(k.filter(S=>S.keyCode===11).on(this.fb,this)),this.B(k.filter(S=>S.keyCode===14).on(this.hb,this)),this.B(k.filter(S=>S.keyCode===13).on(this.ib,this)),this.B(k.filter(S=>S.keyCode>=21&&S.keyCode<=56||S.keyCode>=80&&S.keyCode<=108).on(this.jb,this)),this.B(v.addDisposableListener(this.u.getHTMLElement(),v.EventType.POINTER_UP,S=>this.W(S))),this.B(this.u.onMouseOver(S=>typeof S.index<"u"&&this.u.setFocus([S.index]))),this.B(this.u.onDidChangeFocus(S=>this.Z(S))),this.B(v.addDisposableListener(this.s,v.EventType.FOCUS_OUT,S=>{!this.f||v.isAncestor(S.relatedTarget,this.s)||this.X()})),this.u.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.u.getHTMLElement().setAttribute("aria-expanded","true"),this.L()}W(l){if(!this.u.length)return;v.EventHelper.stop(l);const p=l.target;if(!p||p.classList.contains("slider"))return;const k=p.closest(".monaco-list-row");if(!k)return;const S=Number(k.getAttribute("data-index")),g=k.classList.contains("option-disabled");S>=0&&S<this.k.length&&!g&&(this.l=S,this.select(this.l),this.u.setFocus([this.l]),this.u.reveal(this.u.getFocus()[0]),this.l!==this.y&&(this.y=this.l,this.m.fire({index:this.h.selectedIndex,selected:this.k[this.l].text}),!!this.k[this.l]&&!!this.k[this.l].text&&(this.h.title=this.k[this.l].text)),this.O(!0))}X(){this.G||(this.l!==this.y&&this.select(this.y),this.O(!1))}Y(l,p){const k=g=>{for(let E=0;E<g.childNodes.length;E++){const N=g.childNodes.item(E);(N.tagName&&N.tagName.toLowerCase())==="img"?g.removeChild(N):k(N)}},S=(0,U.renderMarkdown)({value:l,supportThemeIcons:!0},{actionHandler:p});return S.element.classList.add("select-box-description-markdown"),k(S.element),S.element}Z(l){!this.f||!this.C||this.ab(l.indexes[0])}ab(l){this.D.innerText="";const p=this.k[l],k=p?.description??"",S=p?.descriptionIsMarkdown??!1;if(k){if(S){const g=p.descriptionMarkdownActionHandler;this.D.appendChild(this.Y(k,g))}else this.D.innerText=k;this.D.style.display="block"}else this.D.style.display="none";this.F=!0,this.r.layout(),this.F=!1}bb(l){v.EventHelper.stop(l),this.select(this.y),this.O(!0)}cb(l){v.EventHelper.stop(l),this.l!==this.y&&(this.y=this.l,this.m.fire({index:this.h.selectedIndex,selected:this.k[this.l].text}),!!this.k[this.l]&&!!this.k[this.l].text&&(this.h.title=this.k[this.l].text)),this.O(!0)}db(l){if(this.l<this.k.length-1){v.EventHelper.stop(l,!0);const p=this.k[this.l+1].isDisabled;if(p&&this.k.length>this.l+2)this.l+=2;else{if(p)return;this.l++}this.select(this.l),this.u.setFocus([this.l]),this.u.reveal(this.u.getFocus()[0])}}eb(l){this.l>0&&(v.EventHelper.stop(l,!0),this.k[this.l-1].isDisabled&&this.l>1?this.l-=2:this.l--,this.select(this.l),this.u.setFocus([this.l]),this.u.reveal(this.u.getFocus()[0]))}fb(l){v.EventHelper.stop(l),this.u.focusPreviousPage(),setTimeout(()=>{this.l=this.u.getFocus()[0],this.k[this.l].isDisabled&&this.l<this.k.length-1&&(this.l++,this.u.setFocus([this.l])),this.u.reveal(this.l),this.select(this.l)},1)}gb(l){v.EventHelper.stop(l),this.u.focusNextPage(),setTimeout(()=>{this.l=this.u.getFocus()[0],this.k[this.l].isDisabled&&this.l>0&&(this.l--,this.u.setFocus([this.l])),this.u.reveal(this.l),this.select(this.l)},1)}hb(l){v.EventHelper.stop(l),!(this.k.length<2)&&(this.l=0,this.k[this.l].isDisabled&&this.l>1&&this.l++,this.u.setFocus([this.l]),this.u.reveal(this.l),this.select(this.l))}ib(l){v.EventHelper.stop(l),!(this.k.length<2)&&(this.l=this.k.length-1,this.k[this.l].isDisabled&&this.l>1&&this.l--,this.u.setFocus([this.l]),this.u.reveal(this.l),this.select(this.l))}jb(l){const p=c.KeyCodeUtils.toString(l.keyCode);let k=-1;for(let S=0;S<this.k.length-1;S++)if(k=(S+this.l+1)%this.k.length,this.k[k].text.charAt(0).toUpperCase()===p&&!this.k[k].isDisabled){this.select(k),this.u.setFocus([k]),this.u.reveal(this.u.getFocus()[0]),v.EventHelper.stop(l);break}}dispose(){this.O(!1),super.dispose()}}t.SelectBoxList=r,r.a=32,r.b=2,r.c=3}),define(me[125],be([1,0,124,118,18,41,30,5,91]),function(J,t,v,i,z,U,y,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBox=t.defaultStyles=void 0,t.defaultStyles={selectBackground:U.Color.fromHex("#3C3C3C"),selectForeground:U.Color.fromHex("#F0F0F0"),selectBorder:U.Color.fromHex("#3C3C3C")};class u extends z.Widget{constructor(f,I,o,n=(0,y.deepClone)(t.defaultStyles),e){super(),b.isMacintosh&&!e?.useCustomDrawn?this.a=new i.SelectBoxNative(f,I,n,e):this.a=new v.SelectBoxList(f,I,o,n,e),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(f,I){this.a.setOptions(f,I)}select(f){this.a.select(f)}setAriaLabel(f){this.a.setAriaLabel(f)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(f){this.a.setFocusable(f)}render(f){this.a.render(f)}style(f){this.a.style(f)}applyStyles(){this.a.applyStyles()}}t.SelectBox=u}),define(me[61],be([1,0,17,51,4,22,123,125,31,2,5,6,96,48]),function(J,t,v,i,z,U,y,b,u,c,f,I,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectActionViewItem=t.ActionViewItem=t.BaseActionViewItem=void 0;class n extends c.Disposable{get action(){return this._action}constructor(a,l,p={}){super(),this.k=p,this._context=a||this,this._action=l,l instanceof u.Action&&this.B(l.onDidChange(k=>{!this.element||this.m(k)}))}m(a){a.enabled!==void 0&&this.t(),a.checked!==void 0&&this.updateChecked(),a.class!==void 0&&this.updateClass(),a.label!==void 0&&(this.updateLabel(),this.w()),a.tooltip!==void 0&&this.w()}get actionRunner(){return this.j||(this.j=this.B(new u.ActionRunner)),this.j}set actionRunner(a){this.j=a}isEnabled(){return this._action.enabled}setActionContext(a){this._context=a}render(a){const l=this.element=a;this.B(U.Gesture.addTarget(a));const p=this.k&&this.k.draggable;p&&(a.draggable=!0,v.isFirefox&&this.B((0,z.addDisposableListener)(a,z.EventType.DRAG_START,k=>k.dataTransfer?.setData(i.DataTransfers.TEXT,this._action.label)))),this.B((0,z.addDisposableListener)(l,U.EventType.Tap,k=>this.onClick(k,!0))),this.B((0,z.addDisposableListener)(l,z.EventType.MOUSE_DOWN,k=>{p||z.EventHelper.stop(k,!0),this._action.enabled&&k.button===0&&l.classList.add("active")})),f.isMacintosh&&this.B((0,z.addDisposableListener)(l,z.EventType.CONTEXT_MENU,k=>{k.button===0&&k.ctrlKey===!0&&this.onClick(k)})),this.B((0,z.addDisposableListener)(l,z.EventType.CLICK,k=>{z.EventHelper.stop(k,!0),this.k&&this.k.isMenu||this.onClick(k)})),this.B((0,z.addDisposableListener)(l,z.EventType.DBLCLICK,k=>{z.EventHelper.stop(k,!0)})),[z.EventType.MOUSE_UP,z.EventType.MOUSE_OUT].forEach(k=>{this.B((0,z.addDisposableListener)(l,k,S=>{z.EventHelper.stop(S),l.classList.remove("active")}))})}onClick(a,l=!1){z.EventHelper.stop(a,!0);const p=I.isUndefinedOrNull(this._context)?this.k?.useEventAsContext?a:{preserveFocus:l}:this._context;this.actionRunner.run(this._action,p)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(a){this.element&&(this.element.tabIndex=a?0:-1)}get trapsArrowNavigation(){return!1}t(){}updateLabel(){}u(){return this.action.tooltip}w(){if(!this.element)return;const a=this.u()??"";this.z(),this.k.hoverDelegate?(this.element.title="",this.f?this.f.update(a):(this.f=(0,y.setupCustomHover)(this.k.hoverDelegate,this.element,a),this.q.add(this.f))):this.element.title=a}z(){if(this.element){const a=this.u()??"";this.element.setAttribute("aria-label",a)}}updateClass(){}updateChecked(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.BaseActionViewItem=n;class e extends n{constructor(a,l,p){super(a,l,p),this.k=p,this.k.icon=p.icon!==void 0?p.icon:!1,this.k.label=p.label!==void 0?p.label:!0,this.C=""}render(a){super.render(a),this.element&&(this.g=(0,z.append)(this.element,(0,z.$)("a.action-label"))),this.g&&(this._action.id===u.Separator.ID?this.g.setAttribute("role","presentation"):this.k.isMenu?this.g.setAttribute("role","menuitem"):this.g.setAttribute("role","button")),this.k.label&&this.k.keybinding&&this.element&&((0,z.append)(this.element,(0,z.$)("span.keybinding")).textContent=this.k.keybinding),this.updateClass(),this.updateLabel(),this.w(),this.t(),this.updateChecked()}focus(){this.g&&(this.g.tabIndex=0,this.g.focus())}isFocused(){return!!this.g&&this.g?.tabIndex===0}blur(){this.g&&(this.g.tabIndex=-1)}setFocusable(a){this.g&&(this.g.tabIndex=a?0:-1)}updateLabel(){this.k.label&&this.g&&(this.g.textContent=this.action.label)}u(){let a=null;return this.action.tooltip?a=this.action.tooltip:!this.k.label&&this.action.label&&this.k.icon&&(a=this.action.label,this.k.keybinding&&(a=o.localize(0,null,a,this.k.keybinding))),a??void 0}updateClass(){this.C&&this.g&&this.g.classList.remove(...this.C.split(" ")),this.k.icon?(this.C=this.action.class,this.g&&(this.g.classList.add("codicon"),this.C&&this.g.classList.add(...this.C.split(" "))),this.t()):this.g?.classList.remove("codicon")}t(){this.action.enabled?(this.g&&(this.g.removeAttribute("aria-disabled"),this.g.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.g&&(this.g.setAttribute("aria-disabled","true"),this.g.classList.add("disabled")),this.element?.classList.add("disabled"))}z(){if(this.g){const a=this.u()??"";this.g.setAttribute("aria-label",a)}}updateChecked(){this.g&&(this.action.checked?this.g.classList.add("checked"):this.g.classList.remove("checked"))}}t.ActionViewItem=e;class s extends n{constructor(a,l,p,k,S,g){super(a,l),this.b=new b.SelectBox(p,k,S,void 0,g),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(a,l){this.b.setOptions(a,l)}select(a){this.b.select(a)}g(){this.B(this.b.onDidSelect(a=>this.n(a.selected,a.index)))}n(a,l){this.actionRunner.run(this._action,this.r(a,l))}r(a,l){return a}setFocusable(a){this.b.setFocusable(a)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(a){this.b.render(a)}}t.SelectActionViewItem=s}),define(me[62],be([1,0,4,15,61,31,3,2,6,48]),function(J,t,v,i,z,U,y,b,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prepareActions=t.ActionBar=t.ActionsOrientation=void 0;var c;(function(o){o[o.HORIZONTAL=0]="HORIZONTAL",o[o.VERTICAL=1]="VERTICAL"})(c=t.ActionsOrientation||(t.ActionsOrientation={}));class f extends b.Disposable{constructor(n,e={}){super(),this.f=this.B(new b.DisposableStore),this.m=this.B(new b.DisposableMap),this.s=!1,this.t=!0,this.v=this.B(new y.Emitter),this.onDidBlur=this.v.event,this.w=this.B(new y.Emitter({onWillAddFirstListener:()=>this.y=!0})),this.onDidCancel=this.w.event,this.y=!1,this.z=this.B(new y.Emitter),this.onDidRun=this.z.event,this.C=this.B(new y.Emitter),this.onWillRun=this.C.event,this.b=e,this.g=e.context??null,this.j=this.b.orientation??0,this.l={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.c=this.b.actionRunner:(this.c=new U.ActionRunner,this.f.add(this.c)),this.f.add(this.c.onDidRun(a=>this.z.fire(a))),this.f.add(this.c.onWillRun(a=>this.C.fire(a))),this.viewItems=[],this.p=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let s,r;switch(this.j){case 0:s=[15],r=[17];break;case 1:s=[16],r=[18],this.domNode.className+=" vertical";break}this.B(v.addDisposableListener(this.domNode,v.EventType.KEY_DOWN,a=>{const l=new i.StandardKeyboardEvent(a);let p=!0;const k=typeof this.p=="number"?this.viewItems[this.p]:void 0;s&&(l.equals(s[0])||l.equals(s[1]))?p=this.L():r&&(l.equals(r[0])||l.equals(r[1]))?p=this.J():l.equals(9)&&this.y?this.w.fire():l.equals(14)?p=this.H():l.equals(13)?p=this.I():l.equals(2)&&k instanceof z.BaseActionViewItem&&k.trapsArrowNavigation?p=this.J():this.F(l)?this.l.keyDown?this.N(l):this.s=!0:p=!1,p&&(l.preventDefault(),l.stopPropagation())})),this.B(v.addDisposableListener(this.domNode,v.EventType.KEY_UP,a=>{const l=new i.StandardKeyboardEvent(a);this.F(l)?(!this.l.keyDown&&this.s&&(this.s=!1,this.N(l)),l.preventDefault(),l.stopPropagation()):(l.equals(2)||l.equals(1026))&&this.G()})),this.r=this.B(v.trackFocus(this.domNode)),this.B(this.r.onDidBlur(()=>{(v.getActiveElement()===this.domNode||!v.isAncestor(v.getActiveElement(),this.domNode))&&(this.v.fire(),this.p=void 0,this.n=void 0,this.s=!1)})),this.B(this.r.onDidFocus(()=>this.G())),this.u=document.createElement("ul"),this.u.className="actions-container",this.u.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.u.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.u),n.appendChild(this.domNode)}D(){this.length()>=2?this.u.setAttribute("role",this.b.ariaRole||"toolbar"):this.u.setAttribute("role","presentation")}setAriaLabel(n){n?this.u.setAttribute("aria-label",n):this.u.removeAttribute("aria-label")}setFocusable(n){if(this.t=n,this.t){const e=this.viewItems.find(s=>s instanceof z.BaseActionViewItem&&s.isEnabled());e instanceof z.BaseActionViewItem&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof z.BaseActionViewItem&&e.setFocusable(!1)})}F(n){let e=!1;return this.l.keys.forEach(s=>{e=e||n.equals(s)}),e}G(){for(let n=0;n<this.u.children.length;n++){const e=this.u.children[n];if(v.isAncestor(v.getActiveElement(),e)){this.p=n;break}}}get context(){return this.g}set context(n){this.g=n,this.viewItems.forEach(e=>e.setActionContext(n))}get actionRunner(){return this.c}set actionRunner(n){this.c=n,this.f.clear(),this.f.add(this.c.onDidRun(e=>this.z.fire(e))),this.f.add(this.c.onWillRun(e=>this.C.fire(e))),this.viewItems.forEach(e=>e.actionRunner=n)}getContainer(){return this.domNode}hasAction(n){return this.viewItems.findIndex(e=>e.action.id===n.id)!==-1}getAction(n){if(typeof n=="number")return this.viewItems[n]?.action;if(n instanceof HTMLElement){for(;n.parentElement!==this.u;){if(!n.parentElement)return;n=n.parentElement}for(let e=0;e<this.u.childNodes.length;e++)if(this.u.childNodes[e]===n)return this.viewItems[e].action}}push(n,e={}){const s=Array.isArray(n)?n:[n];let r=u.isNumber(e.index)?e.index:null;s.forEach(a=>{const l=document.createElement("li");l.className="action-item",l.setAttribute("role","presentation");let p;this.b.actionViewItemProvider&&(p=this.b.actionViewItemProvider(a)),p||(p=new z.ActionViewItem(this.context,a,{hoverDelegate:this.b.hoverDelegate,...e})),this.b.allowContextMenu||this.m.set(p,v.addDisposableListener(l,v.EventType.CONTEXT_MENU,k=>{v.EventHelper.stop(k,!0)})),p.actionRunner=this.c,p.setActionContext(this.context),p.render(l),this.t&&p instanceof z.BaseActionViewItem&&this.viewItems.length===0&&p.setFocusable(!0),r===null||r<0||r>=this.u.children.length?(this.u.appendChild(l),this.viewItems.push(p)):(this.u.insertBefore(l,this.u.children[r]),this.viewItems.splice(r,0,p),r++)}),typeof this.p=="number"&&this.focus(this.p),this.D()}getWidth(n){if(n>=0&&n<this.u.children.length){const e=this.u.children.item(n);if(e)return e.clientWidth}return 0}getHeight(n){if(n>=0&&n<this.u.children.length){const e=this.u.children.item(n);if(e)return e.clientHeight}return 0}pull(n){n>=0&&n<this.viewItems.length&&(this.u.removeChild(this.u.childNodes[n]),this.m.deleteAndDispose(this.viewItems[n]),(0,b.dispose)(this.viewItems.splice(n,1)),this.D())}clear(){this.isEmpty()||(this.viewItems=(0,b.dispose)(this.viewItems),this.m.clearAndDisposeAll(),v.clearNode(this.u),this.D())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(n){let e=!1,s;if(n===void 0?e=!0:typeof n=="number"?s=n:typeof n=="boolean"&&(e=n),e&&typeof this.p>"u"){const r=this.viewItems.findIndex(a=>a.isEnabled());this.p=r===-1?void 0:r,this.M(void 0,void 0,!0)}else s!==void 0&&(this.p=s),this.M(void 0,void 0,!0)}H(){return this.p=this.length()-1,this.J(!0)}I(){return this.p=0,this.L(!0)}J(n){if(typeof this.p>"u")this.p=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.p;let s;do{if(!n&&this.b.preventLoopNavigation&&this.p+1>=this.viewItems.length)return this.p=e,!1;this.p=(this.p+1)%this.viewItems.length,s=this.viewItems[this.p]}while(this.p!==e&&(this.b.focusOnlyEnabledItems&&!s.isEnabled()||s.action.id===U.Separator.ID));return this.M(),!0}L(n){if(typeof this.p>"u")this.p=0;else if(this.viewItems.length<=1)return!1;const e=this.p;let s;do{if(this.p=this.p-1,this.p<0){if(!n&&this.b.preventLoopNavigation)return this.p=e,!1;this.p=this.viewItems.length-1}s=this.viewItems[this.p]}while(this.p!==e&&(this.b.focusOnlyEnabledItems&&!s.isEnabled()||s.action.id===U.Separator.ID));return this.M(!0),!0}M(n,e,s=!1){typeof this.p>"u"&&this.u.focus({preventScroll:e}),this.n!==void 0&&this.n!==this.p&&this.viewItems[this.n]?.blur();const r=this.p!==void 0&&this.viewItems[this.p];if(r){let a=!0;u.isFunction(r.focus)||(a=!1),this.b.focusOnlyEnabledItems&&u.isFunction(r.isEnabled)&&!r.isEnabled()&&(a=!1),r.action.id===U.Separator.ID&&(a=!1),a?(s||this.n!==this.p)&&(r.focus(n),this.n=this.p):(this.u.focus({preventScroll:e}),this.n=void 0)}}N(n){if(typeof this.p>"u")return;const e=this.viewItems[this.p];if(e instanceof z.BaseActionViewItem){const s=e._context===null||e._context===void 0?n:e._context;this.run(e._action,s)}}async run(n,e){await this.c.run(n,e)}dispose(){this.g=void 0,this.viewItems=(0,b.dispose)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.ActionBar=f;function I(o){if(!o.length)return o;let n=-1;for(let s=0;s<o.length;s++)if(o[s].id!==U.Separator.ID){n=s;break}if(n===-1)return[];o=o.slice(n);for(let s=o.length-1;s>=0&&o[s].id===U.Separator.ID;s--)o.splice(s,1);let e=!1;for(let s=o.length-1;s>=0;s--){const r=o[s].id===U.Separator.ID;r&&!e?o.splice(s,1):r?r&&(e=!1):e=!0}return o}t.prepareActions=I}),define(me[63],be([1,0,4,19,52,62,54,57,18,3,78,100,88]),function(J,t,v,i,z,U,y,b,u,c,f,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryInputBox=t.InputBox=t.unthemedInboxStyles=t.MessageType=void 0;const o=v.$;var n;(function(r){r[r.INFO=1]="INFO",r[r.WARNING=2]="WARNING",r[r.ERROR=3]="ERROR"})(n=t.MessageType||(t.MessageType={})),t.unthemedInboxStyles={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class e extends u.Widget{constructor(a,l,p){super(),this.s="idle",this.y=Number.POSITIVE_INFINITY,this.I=this.B(new c.Emitter),this.onDidChange=this.I.event,this.J=this.B(new c.Emitter),this.onDidHeightChange=this.J.event,this.a=l,this.g=p,this.h=null,this.i=this.g.placeholder||"",this.l=this.g.tooltip??(this.i||""),this.n=this.g.ariaLabel||"",this.g.validationOptions&&(this.r=this.g.validationOptions.validation),this.element=v.append(a,o(".monaco-inputbox.idle"));const k=this.g.flexibleHeight?"textarea":"input",S=v.append(this.element,o(".ibwrapper"));if(this.b=v.append(S,o(k+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.D(this.b,()=>this.element.classList.add("synthetic-focus")),this.C(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.y=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.t=v.append(S,o("div.mirror")),this.t.innerText="\xA0",this.H=new b.ScrollableElement(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.t.style.whiteSpace="pre",this.t.style.wordWrap="initial"),v.append(a,this.H.getDomNode()),this.B(this.H),this.B(this.H.onScroll(N=>this.b.scrollTop=N.scrollTop));const g=this.B(new i.DomEmitter(document,"selectionchange")),E=c.Event.filter(g.event,()=>document.getSelection()?.anchorNode===S);this.B(E(this.N,this)),this.B(this.onDidHeightChange(this.N,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.n&&this.b.setAttribute("aria-label",this.n),this.i&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.i),this.l&&this.setTooltip(this.l),this.z(this.b,()=>this.R()),this.C(this.b,()=>this.L()),this.D(this.b,()=>this.M()),this.B(this.G(this.b)),setTimeout(()=>this.S(),0),this.g.actions&&(this.c=this.B(new U.ActionBar(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.U()}L(){this.Q(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}M(){this.P(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.i||"")}setPlaceHolder(a){this.i=a,this.b.setAttribute("placeholder",a)}setTooltip(a){this.l=a,this.b.title=a}setAriaLabel(a){this.n=a,a?this.b.setAttribute("aria-label",this.n):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.n}get mirrorElement(){return this.t}get inputElement(){return this.b}get value(){return this.b.value}set value(a){this.b.value!==a&&(this.b.value=a,this.R())}get step(){return this.b.step}set step(a){this.b.step=a}get height(){return typeof this.v=="number"?this.v:v.getTotalHeight(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return document.activeElement===this.b}select(a=null){this.b.select(),a&&(this.b.setSelectionRange(a.start,a.end),a.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.Q()}setEnabled(a){a?this.enable():this.disable()}get width(){return v.getTotalWidth(this.b)}set width(a){if(this.g.flexibleHeight&&this.g.flexibleWidth){let l=0;if(this.t){const p=parseFloat(this.t.style.paddingLeft||"")||0,k=parseFloat(this.t.style.paddingRight||"")||0;l=p+k}this.b.style.width=a-l+"px"}else this.b.style.width=a+"px";this.t&&(this.t.style.width=a+"px")}set paddingRight(a){this.b.style.width=`calc(100% - ${a}px)`,this.t&&(this.t.style.paddingRight=a+"px")}N(){if(typeof this.w!="number"||typeof this.v!="number"||!this.H)return;const a=this.w,l=this.v,p=this.b.scrollTop;this.H.setScrollDimensions({scrollHeight:a,height:l}),this.H.setScrollPosition({scrollTop:p})}showMessage(a,l){this.h=a,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.O(a.type));const p=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${v.asCssValueWithDefault(p.border,"transparent")}`,this.h.content&&(this.hasFocus()||l)&&this.P()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.Q(),this.U()}isInputValid(){return!!this.r&&!this.r(this.value)}validate(){let a=null;return this.r&&(a=this.r(this.value),a?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(a)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),a?.type}stylesForType(a){const l=this.g.inputBoxStyles;switch(a){case 1:return{border:l.inputValidationInfoBorder,background:l.inputValidationInfoBackground,foreground:l.inputValidationInfoForeground};case 2:return{border:l.inputValidationWarningBorder,background:l.inputValidationWarningBackground,foreground:l.inputValidationWarningForeground};default:return{border:l.inputValidationErrorBorder,background:l.inputValidationErrorBackground,foreground:l.inputValidationErrorForeground}}}O(a){switch(a){case 1:return"info";case 2:return"warning";default:return"error"}}P(){if(!this.a||!this.h)return;let a;const l=()=>a.style.width=v.getTotalWidth(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:k=>{if(!this.h)return null;a=v.append(k,o(".monaco-inputbox-container")),l();const S={inline:!0,className:"monaco-inputbox-message"},g=this.h.formatContent?(0,z.renderFormattedText)(this.h.content,S):(0,z.renderText)(this.h.content,S);g.classList.add(this.O(this.h.type));const E=this.stylesForType(this.h.type);return g.style.backgroundColor=E.background?E.background.toString():"",g.style.color=E.foreground?E.foreground.toString():"",g.style.border=E.border?`1px solid ${E.border}`:"",v.append(a,g),null},onHide:()=>{this.s="closed"},layout:l});let p;this.h.type===3?p=I.localize(0,null,this.h.content):this.h.type===2?p=I.localize(1,null,this.h.content):p=I.localize(2,null,this.h.content),y.alert(p),this.s="open"}Q(){!this.a||(this.s==="open"&&this.a.hideContextView(),this.s="idle")}R(){this.I.fire(this.value),this.validate(),this.S(),this.b.classList.toggle("empty",!this.value),this.s==="open"&&this.a&&this.a.layout()}S(){if(!this.t)return;const a=this.value,p=a.charCodeAt(a.length-1)===10?" ":"";(a+p).replace(/\u000c/g,"")?this.t.textContent=a+p:this.t.innerText="\xA0",this.layout()}U(){const a=this.g.inputBoxStyles,l=a.inputBackground??"",p=a.inputForeground??"",k=a.inputBorder??"";this.element.style.backgroundColor=l,this.element.style.color=p,this.b.style.backgroundColor="inherit",this.b.style.color=p,this.element.style.border=`1px solid ${v.asCssValueWithDefault(k,"transparent")}`}layout(){if(!this.t)return;const a=this.w;this.w=v.getTotalHeight(this.t),a!==this.w&&(this.v=Math.min(this.w,this.y),this.b.style.height=this.v+"px",this.J.fire(this.w))}insertAtCursor(a){const l=this.inputElement,p=l.selectionStart,k=l.selectionEnd,S=l.value;p!==null&&k!==null&&(this.value=S.substr(0,p)+a+S.substr(k),l.setSelectionRange(p+1,p+1),this.layout())}dispose(){this.Q(),this.h=null,this.c?.dispose(),super.dispose()}}t.InputBox=e;class s extends e{constructor(a,l,p){const k=I.localize(3,null),S=` or \u21C5 ${k}`,g=` (\u21C5 ${k})`;super(a,l,p),this.Y=this.B(new c.Emitter),this.onDidFocus=this.Y.event,this.Z=this.B(new c.Emitter),this.onDidBlur=this.Z.event,this.W=new f.HistoryNavigator(p.history,100);const E=()=>{if(p.showHistoryHint&&p.showHistoryHint()&&!this.i.endsWith(S)&&!this.i.endsWith(g)&&this.W.getHistory().length){const N=this.i.endsWith(")")?S:g,F=this.i+N;p.showPlaceholderOnFocus&&document.activeElement!==this.b?this.i=F:this.setPlaceHolder(F)}};this.X=new MutationObserver((N,F)=>{N.forEach(d=>{d.target.textContent||E()})}),this.X.observe(this.b,{attributeFilter:["class"]}),this.D(this.b,()=>E()),this.C(this.b,()=>{const N=F=>{if(this.i.endsWith(F)){const d=this.i.slice(0,this.i.length-F.length);return p.showPlaceholderOnFocus?this.i=d:this.setPlaceHolder(d),!0}else return!1};N(g)||N(S)})}dispose(){super.dispose(),this.X&&(this.X.disconnect(),this.X=void 0)}addToHistory(){this.value&&this.value!==this.cb()&&this.W.add(this.value)}getHistory(){return this.W.getHistory()}showNextValue(){this.W.has(this.value)||this.addToHistory();let a=this.eb();a&&(a=a===this.value?this.eb():a),a&&(this.value=a,y.status(this.value))}showPreviousValue(){this.W.has(this.value)||this.addToHistory();let a=this.db();a&&(a=a===this.value?this.db():a),a&&(this.value=a,y.status(this.value))}clearHistory(){this.W.clear()}L(){super.L(),this.Z.fire()}M(){super.M(),this.Y.fire()}cb(){let a=this.W.current();return a||(a=this.W.last(),this.W.next()),a}db(){return this.W.previous()||this.W.first()}eb(){return this.W.next()||this.W.last()}}t.HistoryInputBox=s}),define(me[64],be([1,0,61,18,12,3,93]),function(J,t,v,i,z,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Checkbox=t.Toggle=t.ToggleActionViewItem=t.unthemedToggleStyles=void 0,t.unthemedToggleStyles={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class y extends v.BaseActionViewItem{constructor(f,I,o){super(f,I,o),this.a=this.B(new b({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.k.keybinding?`${this._action.label} (${this.k.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:o.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:o.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:o.toggleStyles?.inputActiveOptionForeground})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(f){this.element=f,this.element.appendChild(this.a.domNode)}t(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}updateChecked(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(f){this.a.domNode.tabIndex=f?0:-1}}t.ToggleActionViewItem=y;class b extends i.Widget{constructor(f){super(),this.a=this.B(new U.Emitter),this.onChange=this.a.event,this.b=this.B(new U.Emitter),this.onKeyDown=this.b.event,this.c=f,this.s=this.c.isChecked;const I=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,I.push(...z.CSSIcon.asClassNameArray(this.g))),this.c.actionClassName&&I.push(...this.c.actionClassName.split(" ")),this.s&&I.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...I),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,o=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),o.preventDefault())}),this.B(this.G(this.domNode)),this.p(this.domNode,o=>{if(o.keyCode===10||o.keyCode===3){this.checked=!this.s,this.a.fire(!0),o.preventDefault(),o.stopPropagation();return}this.b.fire(o)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(f){this.s=f,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(f){this.g&&this.domNode.classList.remove(...z.CSSIcon.asClassNameArray(this.g)),this.g=f,this.g&&this.domNode.classList.add(...z.CSSIcon.asClassNameArray(this.g))}width(){return 2+2+2+16}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(f){this.domNode.title=f,this.domNode.setAttribute("aria-label",f)}}t.Toggle=b;class u extends i.Widget{constructor(f,I,o){super(),this.c=f,this.g=I,this.a=new b({title:this.c,isChecked:this.g,icon:z.Codicon.check,actionClassName:"monaco-checkbox",...t.unthemedToggleStyles}),this.domNode=this.a.domNode,this.b=o,this.h()}get checked(){return this.a.checked}set checked(f){this.a.checked=f}focus(){this.domNode.focus()}hasFocus(){return this.domNode===document.activeElement}h(){this.domNode.style.color=this.b.checkboxForeground||"",this.domNode.style.backgroundColor=this.b.checkboxBackground||"",this.domNode.style.borderColor=this.b.checkboxBorder||""}}t.Checkbox=u}),define(me[126],be([1,0,64,12,98]),function(J,t,v,i,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RegexToggle=t.WholeWordsToggle=t.CaseSensitiveToggle=void 0;const U=z.localize(0,null),y=z.localize(1,null),b=z.localize(2,null);class u extends v.Toggle{constructor(o){super({icon:i.Codicon.caseSensitive,title:U+o.appendTitle,isChecked:o.isChecked,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.CaseSensitiveToggle=u;class c extends v.Toggle{constructor(o){super({icon:i.Codicon.wholeWord,title:y+o.appendTitle,isChecked:o.isChecked,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.WholeWordsToggle=c;class f extends v.Toggle{constructor(o){super({icon:i.Codicon.regex,title:b+o.appendTitle,isChecked:o.isChecked,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.RegexToggle=f}),define(me[127],be([1,0,4,126,63,18,3,97,2,87]),function(J,t,v,i,z,U,y,b,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FindInput=void 0;const c=b.localize(0,null);class f extends U.Widget{constructor(o,n,e){super(),this.i=!0,this.l=!1,this.n=new u.DisposableStore,this.H=[],this.I=this.B(new y.Emitter),this.onDidOptionChange=this.I.event,this.J=this.B(new y.Emitter),this.onKeyDown=this.J.event,this.L=this.B(new y.Emitter),this.onMouseDown=this.L.event,this.M=this.B(new y.Emitter),this.onInput=this.M.event,this.N=this.B(new y.Emitter),this.onKeyUp=this.N.event,this.O=this.B(new y.Emitter),this.onCaseSensitiveKeyDown=this.O.event,this.P=this.B(new y.Emitter),this.onRegexKeyDown=this.P.event,this.Q=0,this.a=e.placeholder||"",this.b=e.validation,this.c=e.label||c,this.h=!!e.showCommonFindToggles;const s=e.appendCaseSensitiveLabel||"",r=e.appendWholeWordsLabel||"",a=e.appendRegexLabel||"",l=e.history||[],p=!!e.flexibleHeight,k=!!e.flexibleWidth,S=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new z.HistoryInputBox(this.domNode,n,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:l,showHistoryHint:e.showHistoryHint,flexibleHeight:p,flexibleWidth:k,flexibleMaxHeight:S,inputBoxStyles:e.inputBoxStyles})),this.h){this.v=this.B(new i.RegexToggle({appendTitle:a,isChecked:!1,...e.toggleStyles})),this.B(this.v.onChange(E=>{this.I.fire(E),!E&&this.i&&this.inputBox.focus(),this.validate()})),this.B(this.v.onKeyDown(E=>{this.P.fire(E)})),this.w=this.B(new i.WholeWordsToggle({appendTitle:r,isChecked:!1,...e.toggleStyles})),this.B(this.w.onChange(E=>{this.I.fire(E),!E&&this.i&&this.inputBox.focus(),this.validate()})),this.y=this.B(new i.CaseSensitiveToggle({appendTitle:s,isChecked:!1,...e.toggleStyles})),this.B(this.y.onChange(E=>{this.I.fire(E),!E&&this.i&&this.inputBox.focus(),this.validate()})),this.B(this.y.onKeyDown(E=>{this.O.fire(E)}));const g=[this.y.domNode,this.w.domNode,this.v.domNode];this.p(this.domNode,E=>{if(E.equals(15)||E.equals(17)||E.equals(9)){const N=g.indexOf(document.activeElement);if(N>=0){let F=-1;E.equals(17)?F=(N+1)%g.length:E.equals(15)&&(N===0?F=g.length-1:F=N-1),E.equals(9)?(g[N].blur(),this.inputBox.focus()):F>=0&&g[F].focus(),v.EventHelper.stop(E,!0)}}})}this.s=document.createElement("div"),this.s.className="controls",this.s.style.display=this.h?"block":"none",this.y&&this.s.append(this.y.domNode),this.w&&this.s.appendChild(this.w.domNode),this.v&&this.s.appendChild(this.v.domNode),this.setAdditionalToggles(e?.additionalToggles),this.s&&this.domNode.appendChild(this.s),o?.appendChild(this.domNode),this.B(v.addDisposableListener(this.inputBox.inputElement,"compositionstart",g=>{this.l=!0})),this.B(v.addDisposableListener(this.inputBox.inputElement,"compositionend",g=>{this.l=!1,this.M.fire()})),this.p(this.inputBox.inputElement,g=>this.J.fire(g)),this.u(this.inputBox.inputElement,g=>this.N.fire(g)),this.z(this.inputBox.inputElement,g=>this.M.fire()),this.j(this.inputBox.inputElement,g=>this.L.fire(g))}get isImeSessionInProgress(){return this.l}get onDidChange(){return this.inputBox.onDidChange}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.v?.enable(),this.w?.enable(),this.y?.enable();for(const o of this.H)o.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.v?.disable(),this.w?.disable(),this.y?.disable();for(const o of this.H)o.disable()}setFocusInputOnOptionClick(o){this.i=o}setEnabled(o){o?this.enable():this.disable()}setAdditionalToggles(o){for(const n of this.H)n.domNode.remove();this.H=[],this.n.dispose(),this.n=new u.DisposableStore;for(const n of o??[])this.n.add(n),this.s.appendChild(n.domNode),this.n.add(n.onChange(e=>{this.I.fire(e),!e&&this.i&&this.inputBox.focus()})),this.H.push(n);this.H.length>0&&(this.s.style.display="block"),this.inputBox.paddingRight=(this.y?.width()??0)+(this.w?.width()??0)+(this.v?.width()??0)+this.H.reduce((n,e)=>n+e.width(),0)}clear(){this.R(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(o){this.inputBox.value!==o&&(this.inputBox.value=o)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.y?.checked??!1}setCaseSensitive(o){this.y&&(this.y.checked=o)}getWholeWords(){return this.w?.checked??!1}setWholeWords(o){this.w&&(this.w.checked=o)}getRegex(){return this.v?.checked??!1}setRegex(o){this.v&&(this.v.checked=o,this.validate())}focusOnCaseSensitive(){this.y?.focus()}focusOnRegex(){this.v?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Q),this.Q=1-this.Q,this.domNode.classList.add("highlight-"+this.Q)}validate(){this.inputBox.validate()}showMessage(o){this.inputBox.showMessage(o)}clearMessage(){this.inputBox.hideMessage()}R(){this.inputBox.hideMessage()}}t.FindInput=f,f.OPTION_CHANGE="optionChange"}),define(me[128],be([1,0,4,19,15,62,127,63,58,59,64,55,23,31,14,8,12,70,3,32,2,46,6,102,94]),function(J,t,v,i,z,U,y,b,u,c,f,I,o,n,e,s,r,a,l,p,k,S,g,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractTree=t.TreeFindMode=t.ModeToggle=t.RenderIndentGuides=t.AbstractTreeViewState=t.ComposedTreeDelegate=void 0;class N extends u.ElementsDragAndDropData{set context(A){this.c.context=A}get context(){return this.c.context}constructor(A){super(A.elements.map(C=>C.element)),this.c=A}}function F(ie){return ie instanceof u.ElementsDragAndDropData?new N(ie):ie}class d{constructor(A,C){this.c=A,this.d=C,this.b=k.Disposable.None}getDragURI(A){return this.d.getDragURI(A.element)}getDragLabel(A,C){if(this.d.getDragLabel)return this.d.getDragLabel(A.map(h=>h.element),C)}onDragStart(A,C){this.d.onDragStart?.(F(A),C)}onDragOver(A,C,h,B,_=!0){const $=this.d.onDragOver(F(A),C&&C.element,h,B),Y=this.a!==C;if(Y&&(this.b.dispose(),this.a=C),typeof C>"u")return $;if(Y&&typeof $!="boolean"&&$.autoExpand&&(this.b=(0,s.disposableTimeout)(()=>{const M=this.c(),P=M.getNodeLocation(C);M.isCollapsed(P)&&M.setCollapsed(P,!1),this.a=void 0},500)),typeof $=="boolean"||!$.accept||typeof $.bubble>"u"||$.feedback){if(!_){const M=typeof $=="boolean"?$:$.accept,P=typeof $=="boolean"?void 0:$.effect;return{accept:M,effect:P,feedback:[h]}}return $}if($.bubble===1){const M=this.c(),P=M.getNodeLocation(C),O=M.getParentNodeLocation(P),j=M.getNode(O),ee=O&&M.getListIndex(O);return this.onDragOver(A,j,ee,B,!1)}const T=this.c(),H=T.getNodeLocation(C),W=T.getListIndex(H),L=T.getListRenderCount(H);return{...$,feedback:(0,e.range)(W,W+L)}}drop(A,C,h,B){this.b.dispose(),this.a=void 0,this.d.drop(F(A),C&&C.element,h,B)}onDragEnd(A){this.d.onDragEnd?.(A)}}function w(ie,A){return A&&{...A,identityProvider:A.identityProvider&&{getId(C){return A.identityProvider.getId(C.element)}},dnd:A.dnd&&new d(ie,A.dnd),multipleSelectionController:A.multipleSelectionController&&{isSelectionSingleChangeEvent(C){return A.multipleSelectionController.isSelectionSingleChangeEvent({...C,element:C.element})},isSelectionRangeChangeEvent(C){return A.multipleSelectionController.isSelectionRangeChangeEvent({...C,element:C.element})}},accessibilityProvider:A.accessibilityProvider&&{...A.accessibilityProvider,getSetSize(C){const h=ie(),B=h.getNodeLocation(C),_=h.getParentNodeLocation(B);return h.getNode(_).visibleChildrenCount},getPosInSet(C){return C.visibleChildIndex+1},isChecked:A.accessibilityProvider&&A.accessibilityProvider.isChecked?C=>A.accessibilityProvider.isChecked(C.element):void 0,getRole:A.accessibilityProvider&&A.accessibilityProvider.getRole?C=>A.accessibilityProvider.getRole(C.element):()=>"treeitem",getAriaLabel(C){return A.accessibilityProvider.getAriaLabel(C.element)},getWidgetAriaLabel(){return A.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:A.accessibilityProvider&&A.accessibilityProvider.getWidgetRole?()=>A.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:A.accessibilityProvider&&A.accessibilityProvider.getAriaLevel?C=>A.accessibilityProvider.getAriaLevel(C.element):C=>C.depth,getActiveDescendantId:A.accessibilityProvider.getActiveDescendantId&&(C=>A.accessibilityProvider.getActiveDescendantId(C.element))},keyboardNavigationLabelProvider:A.keyboardNavigationLabelProvider&&{...A.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(C){return A.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(C.element)}}}}class m{constructor(A){this.a=A}getHeight(A){return this.a.getHeight(A.element)}getTemplateId(A){return this.a.getTemplateId(A.element)}hasDynamicHeight(A){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(A.element)}setDynamicHeight(A,C){this.a.setDynamicHeight?.(A.element,C)}}t.ComposedTreeDelegate=m;class D{static lift(A){return A instanceof D?A:new D(A)}static empty(A=0){return new D({focus:[],selection:[],expanded:Object.create(null),scrollTop:A})}constructor(A){if(this.focus=new Set(A.focus),this.selection=new Set(A.selection),A.expanded instanceof Array){this.expanded=Object.create(null);for(const C of A.expanded)this.expanded[C]=1}else this.expanded=A.expanded;this.expanded=A.expanded,this.scrollTop=A.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.AbstractTreeViewState=D;var R;(function(ie){ie.None="none",ie.OnHover="onHover",ie.Always="always"})(R=t.RenderIndentGuides||(t.RenderIndentGuides={}));class V{get elements(){return this.b}constructor(A,C=[]){this.b=C,this.a=new k.DisposableStore,this.onDidChange=l.Event.forEach(A,h=>this.b=h,this.a)}dispose(){this.a.dispose()}}class Z{constructor(A,C,h,B,_,$={}){this.o=A,this.p=C,this.q=B,this.s=_,this.b=new Map,this.c=new Map,this.d=Z.a,this.f=!1,this.g=!1,this.j=new Set,this.k=k.Disposable.None,this.m=new k.DisposableStore,this.templateId=A.templateId,this.updateOptions($),l.Event.map(h,Y=>Y.node)(this.u,this,this.m),A.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(A={}){if(typeof A.indent<"u"){const C=(0,S.clamp)(A.indent,0,40);if(C!==this.d){this.d=C;for(const[h,B]of this.c)this.v(h,B)}}if(typeof A.renderIndentGuides<"u"){const C=A.renderIndentGuides!==R.None;if(C!==this.g){this.g=C;for(const[h,B]of this.c)this.w(h,B);if(this.k.dispose(),C){const h=new k.DisposableStore;this.q.onDidChange(this.x,this,h),this.k=h,this.x(this.q.elements)}}}typeof A.hideTwistiesOfChildlessElements<"u"&&(this.f=A.hideTwistiesOfChildlessElements)}renderTemplate(A){const C=(0,v.append)(A,(0,v.$)(".monaco-tl-row")),h=(0,v.append)(C,(0,v.$)(".monaco-tl-indent")),B=(0,v.append)(C,(0,v.$)(".monaco-tl-twistie")),_=(0,v.append)(C,(0,v.$)(".monaco-tl-contents")),$=this.o.renderTemplate(_);return{container:A,indent:h,twistie:B,indentGuidesDisposable:k.Disposable.None,templateData:$}}renderElement(A,C,h,B){this.c.set(A,h),this.b.set(A.element,A),this.v(A,h),this.o.renderElement(A,C,h.templateData,B)}disposeElement(A,C,h,B){h.indentGuidesDisposable.dispose(),this.o.disposeElement?.(A,C,h.templateData,B),typeof B=="number"&&(this.c.delete(A),this.b.delete(A.element))}disposeTemplate(A){this.o.disposeTemplate(A.templateData)}t(A){const C=this.b.get(A);!C||this.u(C)}u(A){const C=this.c.get(A);!C||(this.x(this.q.elements),this.v(A,C))}v(A,C){const h=Z.a+(A.depth-1)*this.d;C.twistie.style.paddingLeft=`${h}px`,C.indent.style.width=`${h+this.d-16}px`,A.collapsible?C.container.setAttribute("aria-expanded",String(!A.collapsed)):C.container.removeAttribute("aria-expanded"),C.twistie.classList.remove(...r.Codicon.treeItemExpanded.classNamesArray);let B=!1;this.o.renderTwistie&&(B=this.o.renderTwistie(A.element,C.twistie)),A.collapsible&&(!this.f||A.visibleChildrenCount>0)?(B||C.twistie.classList.add(...r.Codicon.treeItemExpanded.classNamesArray),C.twistie.classList.add("collapsible"),C.twistie.classList.toggle("collapsed",A.collapsed)):C.twistie.classList.remove("collapsible","collapsed"),this.w(A,C)}w(A,C){if((0,v.clearNode)(C.indent),C.indentGuidesDisposable.dispose(),!this.g)return;const h=new k.DisposableStore,B=this.p();for(;;){const _=B.getNodeLocation(A),$=B.getParentNodeLocation(_);if(!$)break;const Y=B.getNode($),T=(0,v.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(Y)&&T.classList.add("active"),C.indent.childElementCount===0?C.indent.appendChild(T):C.indent.insertBefore(T,C.indent.firstElementChild),this.s.add(Y,T),h.add((0,k.toDisposable)(()=>this.s.delete(Y,T))),A=Y}C.indentGuidesDisposable=h}x(A){if(!this.g)return;const C=new Set,h=this.p();A.forEach(B=>{const _=h.getNodeLocation(B);try{const $=h.getParentNodeLocation(_);B.collapsible&&B.children.length>0&&!B.collapsed?C.add(B):$&&C.add(h.getNode($))}catch{}}),this.j.forEach(B=>{C.has(B)||this.s.forEach(B,_=>_.classList.remove("active"))}),C.forEach(B=>{this.j.has(B)||this.s.forEach(B,_=>_.classList.add("active"))}),this.j=C}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,k.dispose)(this.m)}}Z.a=8;class X{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(A){this.c=A,this.d=A.toLowerCase()}constructor(A,C,h){this.g=A,this.j=C,this.k=h,this.a=0,this.b=0,this.c="",this.d="",this.f=new k.DisposableStore,A.onWillRefilter(this.m,this,this.f)}filter(A,C){let h=1;if(this.k){const $=this.k.filter(A,C);if(typeof $=="boolean"?h=$?1:0:(0,I.isFilterResult)($)?h=(0,I.getVisibleState)($.visibility):h=$,h===0)return!1}if(this.a++,!this.c)return this.b++,{data:p.FuzzyScore.Default,visibility:h};const B=this.j.getKeyboardNavigationLabel(A),_=Array.isArray(B)?B:[B];for(const $ of _){const Y=$&&$.toString();if(typeof Y>"u")return{data:p.FuzzyScore.Default,visibility:h};const T=(0,p.fuzzyScore)(this.c,this.d,0,Y,Y.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(T)return this.b++,_.length===1?{data:T,visibility:h}:{data:{label:Y,score:T},visibility:h}}return this.g.findMode===le.Filter?2:{data:p.FuzzyScore.Default,visibility:h}}m(){this.a=0,this.b=0}dispose(){(0,k.dispose)(this.f)}}class x extends f.Toggle{constructor(A){super({icon:r.Codicon.listFilter,title:(0,E.localize)(0,null),isChecked:A.isChecked??!1,inputActiveOptionBorder:A.inputActiveOptionBorder,inputActiveOptionForeground:A.inputActiveOptionForeground,inputActiveOptionBackground:A.inputActiveOptionBackground})}}t.ModeToggle=x;const ne={inputBoxStyles:b.unthemedInboxStyles,toggleStyles:f.unthemedToggleStyles,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var le;(function(ie){ie[ie.Highlight=0]="Highlight",ie[ie.Filter=1]="Filter"})(le=t.TreeFindMode||(t.TreeFindMode={}));class se extends k.Disposable{set mode(A){this.b.checked=A===le.Filter,this.c.inputBox.setPlaceHolder(A===le.Filter?(0,E.localize)(1,null):(0,E.localize)(2,null))}get value(){return this.c.inputBox.value}set value(A){this.c.inputBox.value=A}constructor(A,C,h,B,_){super(),this.m=C,this.a=(0,v.h)(".monaco-tree-type-filter",[(0,v.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,v.h)(".monaco-tree-type-filter-input@findInput"),(0,v.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.g=0,this.j=0,this.k=0,this._onDidDisable=new l.Emitter,this.onDidDisable=this._onDidDisable.event,A.appendChild(this.a.root),this.B((0,k.toDisposable)(()=>A.removeChild(this.a.root)));const $=_?.styles??ne;$.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=$.listFilterWidgetBackground),$.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${$.listFilterWidgetShadow}`),this.b=this.B(new x({...$.toggleStyles,isChecked:B===le.Filter})),this.onDidChangeMode=l.Event.map(this.b.onChange,()=>this.b.checked?le.Filter:le.Highlight,this.q),this.c=this.B(new y.FindInput(this.a.findInput,h,{label:(0,E.localize)(3,null),additionalToggles:[this.b],showCommonFindToggles:!1,inputBoxStyles:$.inputBoxStyles,toggleStyles:$.toggleStyles})),this.f=this.B(new U.ActionBar(this.a.actionbar)),this.mode=B;const Y=this.B(new i.DomEmitter(this.c.inputBox.inputElement,"keydown")),T=this.B(l.Event.chain(Y.event)).map(M=>new z.StandardKeyboardEvent(M)).event;this.B(T(M=>{switch(M.keyCode){case 18:M.preventDefault(),M.stopPropagation(),this.m.domFocus();return}}));const H=this.B(new n.Action("close",(0,E.localize)(4,null),"codicon codicon-close",!0,()=>this.dispose()));this.f.push(H,{icon:!0,label:!1});const W=this.B(new i.DomEmitter(this.a.grab,"mousedown"));this.B(W.event(M=>{const P=new k.DisposableStore,O=P.add(new i.DomEmitter(window,"mousemove")),j=P.add(new i.DomEmitter(window,"mouseup")),ee=this.j,ce=M.pageX,de=this.k,De=M.pageY;this.a.grab.classList.add("grabbing");const ye=this.a.root.style.transition;this.a.root.style.transition="unset";const Ie=Se=>{const we=Se.pageX-ce;this.j=ee-we;const Re=Se.pageY-De;this.k=de+Re,this.layout()};P.add(O.event(Ie)),P.add(j.event(Se=>{Ie(Se),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=ye,P.dispose()}))}));const L=this.B(l.Event.chain(this.B(new i.DomEmitter(this.a.grab,"keydown")).event)).map(M=>new z.StandardKeyboardEvent(M)).event;this.B(L(M=>{let P,O;if(M.keyCode===15?P=Number.POSITIVE_INFINITY:M.keyCode===17?P=0:M.keyCode===10&&(P=this.j===0?Number.POSITIVE_INFINITY:0),M.keyCode===16?O=0:M.keyCode===18&&(O=Number.POSITIVE_INFINITY),P!==void 0&&(M.preventDefault(),M.stopPropagation(),this.j=P,this.layout()),O!==void 0){M.preventDefault(),M.stopPropagation(),this.k=O;const j=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=j},0)}})),this.onDidChangeValue=this.c.onDidChange}focus(){this.c.focus()}select(){this.c.select()}layout(A=this.g){this.g=A,this.j=(0,S.clamp)(this.j,0,Math.max(0,A-212)),this.a.root.style.right=`${this.j}px`,this.k=(0,S.clamp)(this.k,0,24),this.a.root.style.top=`${this.k}px`}showMessage(A){this.c.showMessage(A)}clearMessage(){this.c.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,s.timeout)(300),super.dispose()}}class fe{get pattern(){return this.a}get mode(){return this.c}set mode(A){A!==this.c&&(this.c=A,this.d&&(this.d.mode=this.c),this.p.refilter(),this.x(),this.g.fire(A))}constructor(A,C,h,B,_,$={}){this.p=A,this.q=h,this.s=B,this.t=_,this.u=$,this.a="",this.b="",this.f=0,this.g=new l.Emitter,this.onDidChangeMode=this.g.event,this.j=new l.Emitter,this.onDidChangePattern=this.j.event,this.k=new l.Emitter,this.onDidChangeOpenState=this.k.event,this.m=new k.DisposableStore,this.o=new k.DisposableStore,this.c=A.options.defaultFindMode??le.Highlight,C.onDidSplice(this.w,this,this.o)}open(){if(this.d){this.d.focus(),this.d.select();return}this.mode=this.p.options.defaultFindMode??le.Highlight,this.d=new se(this.q.getHTMLElement(),this.p,this.t,this.mode,this.u),this.m.add(this.d),this.d.onDidChangeValue(this.v,this,this.m),this.d.onDidChangeMode(A=>this.mode=A,void 0,this.m),this.d.onDidDisable(this.close,this,this.m),this.d.layout(this.f),this.d.focus(),this.d.value=this.b,this.d.select(),this.k.fire(!0)}close(){!this.d||(this.d=void 0,this.m.dispose(),this.m=new k.DisposableStore,this.b=this.pattern,this.v(""),this.p.domFocus(),this.k.fire(!1))}v(A){this.a=A,this.j.fire(A),this.s.pattern=A,this.p.refilter(),A&&this.p.focusNext(0,!0,void 0,h=>!p.FuzzyScore.isDefault(h.filterData));const C=this.p.getFocus();if(C.length>0){const h=C[0];this.p.getRelativeTop(h)===null&&this.p.reveal(h,.5)}this.x()}w(){!this.d||this.pattern.length===0||(this.p.refilter(),this.x())}x(){const A=this.s.totalCount>0&&this.s.matchCount===0;this.pattern&&A?this.p.options.showNotFoundMessage??!0?this.d?.showMessage({type:2,content:(0,E.localize)(5,null)}):this.d?.showMessage({type:2}):this.d?.clearMessage()}shouldAllowFocus(A){return!this.d||!this.pattern||this.c===le.Filter||this.s.totalCount>0&&this.s.matchCount<=1?!0:!p.FuzzyScore.isDefault(A.filterData)}layout(A){this.f=A,this.d?.layout(A)}dispose(){this.j.dispose(),this.m.dispose(),this.o.dispose()}}function Ae(ie){let A=o.TreeMouseEventTarget.Unknown;return(0,v.hasParentWithClass)(ie.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?A=o.TreeMouseEventTarget.Twistie:(0,v.hasParentWithClass)(ie.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?A=o.TreeMouseEventTarget.Element:(0,v.hasParentWithClass)(ie.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(A=o.TreeMouseEventTarget.Filter),{browserEvent:ie.browserEvent,element:ie.element?ie.element.element:null,target:A}}function te(ie){return{element:ie.element?ie.element.element:null,browserEvent:ie.browserEvent,anchor:ie.anchor}}function ve(ie,A){A(ie),ie.children.forEach(C=>ve(C,A))}class Ne{get f(){return this.d||(this.d=this.m()),this.d}constructor(A,C){this.g=A,this.j=C,this.a=[],this.c=new l.Emitter,this.onDidChange=this.c.event}set(A,C){!C?.__forceEvent&&(0,e.equals)(this.a,A)||this.k(A,!1,C)}k(A,C,h){if(this.a=[...A],this.b=void 0,this.d=void 0,!C){const B=this;this.c.fire({get elements(){return B.get()},browserEvent:h})}}get(){return this.b||(this.b=this.a.map(A=>A.element)),[...this.b]}getNodes(){return this.a}has(A){return this.f.has(A)}onDidModelSplice({insertedNodes:A,deletedNodes:C}){if(!this.j){const T=this.m(),H=W=>T.delete(W);C.forEach(W=>ve(W,H)),this.set([...T.values()]);return}const h=new Set,B=T=>h.add(this.j.getId(T.element).toString());C.forEach(T=>ve(T,B));const _=new Map,$=T=>_.set(this.j.getId(T.element).toString(),T);A.forEach(T=>ve(T,$));const Y=[];for(const T of this.a){const H=this.j.getId(T.element).toString();if(!h.has(H))Y.push(T);else{const L=_.get(H);L&&Y.push(L)}}if(this.a.length>0&&Y.length===0){const T=this.g();T&&Y.push(T)}this.k(Y,!0)}m(){const A=new Set;for(const C of this.a)A.add(C);return A}}class he extends c.MouseController{constructor(A,C){super(A),this.z=C}u(A){if((0,c.isButton)(A.browserEvent.target)||(0,c.isInputElement)(A.browserEvent.target)||(0,c.isMonacoEditor)(A.browserEvent.target))return;const C=A.element;if(!C)return super.u(A);if(this.p(A)||this.o(A))return super.u(A);const h=A.browserEvent.target,B=h.classList.contains("monaco-tl-twistie")||h.classList.contains("monaco-icon-label")&&h.classList.contains("folder-icon")&&A.browserEvent.offsetX<16;let _=!1;if(typeof this.z.expandOnlyOnTwistieClick=="function"?_=this.z.expandOnlyOnTwistieClick(C.element):_=!!this.z.expandOnlyOnTwistieClick,_&&!B&&A.browserEvent.detail!==2)return super.u(A);if(!this.z.expandOnDoubleClick&&A.browserEvent.detail===2)return super.u(A);if(C.collapsible){const $=this.z.getNodeLocation(C),Y=A.browserEvent.altKey;if(this.z.setFocus([$]),this.z.toggleCollapsed($,Y),_&&B)return}super.u(A)}v(A){A.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.z.expandOnDoubleClick||super.v(A)}}class Q extends c.List{constructor(A,C,h,B,_,$,Y,T){super(A,C,h,B,T),this.p=_,this.s=$,this.L=Y}E(A){return new he(this,A.tree)}splice(A,C,h=[]){if(super.splice(A,C,h),h.length===0)return;const B=[],_=[];let $;h.forEach((Y,T)=>{this.p.has(Y)&&B.push(A+T),this.s.has(Y)&&_.push(A+T),this.L.has(Y)&&($=A+T)}),B.length>0&&super.setFocus((0,e.distinct)([...super.getFocus(),...B])),_.length>0&&super.setSelection((0,e.distinct)([...super.getSelection(),..._])),typeof $=="number"&&super.setAnchor($)}setFocus(A,C,h=!1){super.setFocus(A,C),h||this.p.set(A.map(B=>this.element(B)),C)}setSelection(A,C,h=!1){super.setSelection(A,C),h||this.s.set(A.map(B=>this.element(B)),C)}setAnchor(A,C=!1){super.setAnchor(A),C||(typeof A>"u"?this.L.set([]):this.L.set([this.element(A)]))}}class oe{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.w.wrapEvent(this.p.onDidChange)}get onDidChangeSelection(){return this.w.wrapEvent(this.q.onDidChange)}get onMouseClick(){return l.Event.map(this.j.onMouseClick,Ae)}get onMouseDblClick(){return l.Event.filter(l.Event.map(this.j.onMouseDblClick,Ae),A=>A.target!==o.TreeMouseEventTarget.Filter)}get onContextMenu(){return l.Event.map(this.j.onContextMenu,te)}get onTap(){return l.Event.map(this.j.onTap,Ae)}get onPointer(){return l.Event.map(this.j.onPointer,Ae)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return l.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.x?.mode??le.Highlight}set findMode(A){this.x&&(this.x.mode=A)}get onDidChangeFindPattern(){return this.x?this.x.onDidChangePattern:l.Event.None}get expandOnDoubleClick(){return typeof this.E.expandOnDoubleClick>"u"?!0:this.E.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.E.expandOnlyOnTwistieClick>"u"?!0:this.E.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(A,C,h,B,_={}){this.D=A,this.E=_,this.w=new l.EventBufferer,this.onDidChangeFindOpenState=l.Event.None,this.A=new k.DisposableStore,this.B=new l.Emitter,this.onWillRefilter=this.B.event,this.C=new l.Emitter,this.onDidUpdateOptions=this.C.event;const $=new m(h),Y=new l.Relay,T=new l.Relay,H=this.A.add(new V(T.event)),W=new a.SetMap;this.k=B.map(P=>new Z(P,()=>this.o,Y.event,H,W,_));for(const P of this.k)this.A.add(P);let L;_.keyboardNavigationLabelProvider&&(L=new X(this,_.keyboardNavigationLabelProvider,_.filter),_={..._,filter:L},this.A.add(L)),this.p=new Ne(()=>this.j.getFocusedElements()[0],_.identityProvider),this.q=new Ne(()=>this.j.getSelectedElements()[0],_.identityProvider),this.u=new Ne(()=>this.j.getAnchorElement(),_.identityProvider),this.j=new Q(A,C,$,this.k,this.p,this.q,this.u,{...w(()=>this.o,_),tree:this}),this.o=this.I(A,this.j,_),Y.input=this.o.onDidChangeCollapseState;const M=l.Event.forEach(this.o.onDidSplice,P=>{this.w.bufferEvents(()=>{this.p.onDidModelSplice(P),this.q.onDidModelSplice(P)})},this.A);if(M(()=>null,null,this.A),T.input=l.Event.chain(l.Event.any(M,this.p.onDidChange,this.q.onDidChange)).debounce(()=>null,0).map(()=>{const P=new Set;for(const O of this.p.getNodes())P.add(O);for(const O of this.q.getNodes())P.add(O);return[...P.values()]}).event,_.keyboardSupport!==!1){const P=l.Event.chain(this.j.onKeyDown).filter(O=>!(0,c.isInputElement)(O.target)).map(O=>new z.StandardKeyboardEvent(O));P.filter(O=>O.keyCode===15).on(this.F,this,this.A),P.filter(O=>O.keyCode===17).on(this.G,this,this.A),P.filter(O=>O.keyCode===10).on(this.H,this,this.A)}if((_.findWidgetEnabled??!0)&&_.keyboardNavigationLabelProvider&&_.contextViewProvider){const P=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.x=new fe(this,this.o,this.j,L,_.contextViewProvider,P),this.y=O=>this.x.shouldAllowFocus(O),this.onDidChangeFindOpenState=this.x.onDidChangeOpenState,this.A.add(this.x),this.onDidChangeFindMode=this.x.onDidChangeMode}else this.onDidChangeFindMode=l.Event.None;this.z=(0,v.createStyleSheet)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===R.Always)}updateOptions(A={}){this.E={...this.E,...A};for(const C of this.k)C.updateOptions(A);this.j.updateOptions(this.E),this.C.fire(this.E),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===R.Always)}get options(){return this.E}updateWidth(A){const C=this.o.getListIndex(A);C!==-1&&this.j.updateWidth(C)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get scrollTop(){return this.j.scrollTop}set scrollTop(A){this.j.scrollTop=A}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(A){this.j.scrollLeft=A}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){const A=this.j.firstVisibleIndex;return A<0||A>=this.j.length?void 0:this.j.element(A).element}get lastVisibleElement(){const A=this.j.lastVisibleIndex;return this.j.element(A).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(A){this.j.ariaLabel=A}domFocus(){this.j.domFocus()}isDOMFocused(){return this.getHTMLElement()===document.activeElement}layout(A,C){this.j.layout(A,C),(0,g.isNumber)(C)&&this.x?.layout(C)}style(A){const C=`.${this.j.domId}`,h=[];A.treeIndentGuidesStroke&&(h.push(`.monaco-list${C}:hover .monaco-tl-indent > .indent-guide, .monaco-list${C}.always .monaco-tl-indent > .indent-guide  { border-color: ${A.treeIndentGuidesStroke.transparent(.4)}; }`),h.push(`.monaco-list${C} .monaco-tl-indent > .indent-guide.active { border-color: ${A.treeIndentGuidesStroke}; }`)),this.z.textContent=h.join(`
`),this.j.style(A)}getParentElement(A){const C=this.o.getParentNodeLocation(A);return this.o.getNode(C).element}getFirstElementChild(A){return this.o.getFirstElementChild(A)}getNode(A){return this.o.getNode(A)}getNodeLocation(A){return this.o.getNodeLocation(A)}collapse(A,C=!1){return this.o.setCollapsed(A,!0,C)}expand(A,C=!1){return this.o.setCollapsed(A,!1,C)}toggleCollapsed(A,C=!1){return this.o.setCollapsed(A,void 0,C)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(A){return this.o.isCollapsible(A)}setCollapsible(A,C){return this.o.setCollapsible(A,C)}isCollapsed(A){return this.o.isCollapsed(A)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.x?.open()}closeFind(){this.x?.close()}refilter(){this.B.fire(void 0),this.o.refilter()}setAnchor(A){if(typeof A>"u")return this.j.setAnchor(void 0);const C=this.o.getNode(A);this.u.set([C]);const h=this.o.getListIndex(A);h>-1&&this.j.setAnchor(h,!0)}getAnchor(){return(0,e.firstOrDefault)(this.u.get(),void 0)}setSelection(A,C){const h=A.map(_=>this.o.getNode(_));this.q.set(h,C);const B=A.map(_=>this.o.getListIndex(_)).filter(_=>_>-1);this.j.setSelection(B,C,!0)}getSelection(){return this.q.get()}setFocus(A,C){const h=A.map(_=>this.o.getNode(_));this.p.set(h,C);const B=A.map(_=>this.o.getListIndex(_)).filter(_=>_>-1);this.j.setFocus(B,C,!0)}focusNext(A=1,C=!1,h,B=this.y){this.j.focusNext(A,C,h,B)}focusPrevious(A=1,C=!1,h,B=this.y){this.j.focusPrevious(A,C,h,B)}focusNextPage(A,C=this.y){return this.j.focusNextPage(A,C)}focusPreviousPage(A,C=this.y){return this.j.focusPreviousPage(A,C)}focusLast(A,C=this.y){this.j.focusLast(A,C)}focusFirst(A,C=this.y){this.j.focusFirst(A,C)}getFocus(){return this.p.get()}reveal(A,C){this.o.expandTo(A);const h=this.o.getListIndex(A);h!==-1&&this.j.reveal(h,C)}getRelativeTop(A){const C=this.o.getListIndex(A);return C===-1?null:this.j.getRelativeTop(C)}getViewState(A=this.options.identityProvider){if(!A)throw new o.TreeError(this.D,"Can't get tree view state without an identity provider");const C=$=>A.getId($).toString(),h=D.empty(this.scrollTop);for(const $ of this.getFocus())h.focus.add(C($));for(const $ of this.getSelection())h.selection.add(C($));const B=this.o.getNode(),_=[B];for(;_.length>0;){const $=_.shift();$!==B&&$.collapsible&&(h.expanded[C($.element)]=$.collapsed?0:1),_.push(...$.children)}return h}F(A){A.preventDefault(),A.stopPropagation();const C=this.j.getFocusedElements();if(C.length===0)return;const h=C[0],B=this.o.getNodeLocation(h);if(!this.o.setCollapsed(B,!0)){const $=this.o.getParentNodeLocation(B);if(!$)return;const Y=this.o.getListIndex($);this.j.reveal(Y),this.j.setFocus([Y])}}G(A){A.preventDefault(),A.stopPropagation();const C=this.j.getFocusedElements();if(C.length===0)return;const h=C[0],B=this.o.getNodeLocation(h);if(!this.o.setCollapsed(B,!1)){if(!h.children.some(T=>T.visible))return;const[$]=this.j.getFocus(),Y=$+1;this.j.reveal(Y),this.j.setFocus([Y])}}H(A){A.preventDefault(),A.stopPropagation();const C=this.j.getFocusedElements();if(C.length===0)return;const h=C[0],B=this.o.getNodeLocation(h),_=A.browserEvent.altKey;this.o.setCollapsed(B,void 0,_)}navigate(A){return new re(this.j,this.o,A)}dispose(){(0,k.dispose)(this.A),this.j.dispose()}}t.AbstractTree=oe;class re{constructor(A,C,h){this.b=A,this.c=C,h?this.a=this.c.getListIndex(h):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(me[129],be([1,0,128,119,23,25]),function(J,t,v,i,z,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTree=void 0;class y extends v.AbstractTree{constructor(u,c,f,I,o,n={}){super(u,c,f,I,n),this.f=u,this.g=o,this.d=new Map,this.c=n.identityProvider}getInput(){return this.b}setInput(u,c){if(c&&!this.c)throw new z.TreeError(this.f,"Can't restore tree view state without an identity provider");if(this.b=u,!u){this.d.clear(),this.o.setChildren(null,U.Iterable.empty());return}if(!c){this.m(u);return}const f=[],I=[],o=e=>{const s=this.c.getId(e).toString();return!c.expanded[s]},n=e=>{const s=this.c.getId(e.element).toString();c.focus.has(s)&&f.push(e.element),c.selection.has(s)&&I.push(e.element)};this.m(u,o,n),this.setFocus(f),this.setSelection(I),c&&typeof c.scrollTop=="number"&&(this.scrollTop=c.scrollTop)}updateChildren(u=this.b){if(typeof this.b>"u")throw new z.TreeError(this.f,"Tree input not set");let c;this.c&&(c=f=>{const I=this.c.getId(f).toString(),o=this.d.get(I);if(!!o)return o.collapsed}),this.m(u,c)}resort(u=this.b,c=!0){this.o.resort(u===this.b?null:u,c)}refresh(u){if(u===void 0){this.j.rerender();return}this.o.rerender(u)}m(u,c,f){let I;if(this.c){const o=new Set,n=f;f=e=>{const s=this.c.getId(e.element).toString();o.add(s),this.d.set(s,e),n?.(e)},I=e=>{const s=this.c.getId(e.element).toString();o.has(s)||this.d.delete(s)}}this.o.setChildren(u===this.b?null:u,this.s(u,c).elements,{onDidCreateNode:f,onDidDeleteNode:I})}s(u,c){const f=[...this.g.getChildren(u)];return{elements:U.Iterable.map(f,o=>{const{elements:n,size:e}=this.s(o,c),s=this.g.hasChildren?this.g.hasChildren(o):void 0,r=e===0?void 0:c&&c(o);return{element:o,children:n,collapsible:s,collapsed:r}}),size:f.length}}I(u,c,f){return new i.ObjectTreeModel(u,c,f)}}t.DataTree=y}),define(me[37],be([1,0,14,8,29,26,24,9,3,2,50,11,6]),function(J,t,v,i,z,U,y,b,u,c,f,I,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.deserialize=t.serialize=t.BufferWriter=t.BufferReader=void 0;var n;(function(he){he[he.Promise=100]="Promise",he[he.PromiseCancel=101]="PromiseCancel",he[he.EventListen=102]="EventListen",he[he.EventDispose=103]="EventDispose"})(n||(n={}));function e(he){switch(he){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var s;(function(he){he[he.Initialize=200]="Initialize",he[he.PromiseSuccess=201]="PromiseSuccess",he[he.PromiseError=202]="PromiseError",he[he.PromiseErrorObj=203]="PromiseErrorObj",he[he.EventFire=204]="EventFire"})(s||(s={}));function r(he){switch(he){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var a;(function(he){he[he.Uninitialized=0]="Uninitialized",he[he.Idle=1]="Idle"})(a||(a={}));function l(he){let Q=0;for(let oe=0;;oe+=7){const re=he.read(1);if(Q|=(re.buffer[0]&127)<<oe,!(re.buffer[0]&128))return Q}}const p=N(0);function k(he,Q){if(Q===0){he.write(p);return}let oe=0;for(let ie=Q;ie!==0;ie=ie>>>7)oe++;const re=z.VSBuffer.alloc(oe);for(let ie=0;Q!==0;ie++)re.buffer[ie]=Q&127,Q=Q>>>7,Q>0&&(re.buffer[ie]|=128);he.write(re)}class S{constructor(Q){this.b=Q,this.a=0}read(Q){const oe=this.b.slice(this.a,this.a+Q);return this.a+=oe.byteLength,oe}}t.BufferReader=S;class g{constructor(){this.a=[]}get buffer(){return z.VSBuffer.concat(this.a)}write(Q){this.a.push(Q)}}t.BufferWriter=g;var E;(function(he){he[he.Undefined=0]="Undefined",he[he.String=1]="String",he[he.Buffer=2]="Buffer",he[he.VSBuffer=3]="VSBuffer",he[he.Array=4]="Array",he[he.Object=5]="Object",he[he.Int=6]="Int"})(E||(E={}));function N(he){const Q=z.VSBuffer.alloc(1);return Q.writeUInt8(he,0),Q}const F={Undefined:N(E.Undefined),String:N(E.String),Buffer:N(E.Buffer),VSBuffer:N(E.VSBuffer),Array:N(E.Array),Object:N(E.Object),Uint:N(E.Int)},d=typeof Buffer<"u";function w(he,Q){if(typeof Q>"u")he.write(F.Undefined);else if(typeof Q=="string"){const oe=z.VSBuffer.fromString(Q);he.write(F.String),k(he,oe.byteLength),he.write(oe)}else if(d&&Buffer.isBuffer(Q)){const oe=z.VSBuffer.wrap(Q);he.write(F.Buffer),k(he,oe.byteLength),he.write(oe)}else if(Q instanceof z.VSBuffer)he.write(F.VSBuffer),k(he,Q.byteLength),he.write(Q);else if(Array.isArray(Q)){he.write(F.Array),k(he,Q.length);for(const oe of Q)w(he,oe)}else if(typeof Q=="number"&&(Q|0)===Q)he.write(F.Uint),k(he,Q);else{const oe=z.VSBuffer.fromString(JSON.stringify(Q));he.write(F.Object),k(he,oe.byteLength),he.write(oe)}}t.serialize=w;function m(he){switch(he.read(1).readUInt8(0)){case E.Undefined:return;case E.String:return he.read(l(he)).toString();case E.Buffer:return he.read(l(he)).buffer;case E.VSBuffer:return he.read(l(he));case E.Array:{const oe=l(he),re=[];for(let ie=0;ie<oe;ie++)re.push(m(he));return re}case E.Object:return JSON.parse(he.read(l(he)).toString());case E.Int:return l(he)}}t.deserialize=m;class D{constructor(Q,oe,re=null,ie=1e3){this.h=Q,this.j=oe,this.k=re,this.l=ie,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(A=>this.q(A)),this.m({type:200})}registerChannel(Q,oe){this.b.set(Q,oe),setTimeout(()=>this.w(Q),0)}m(Q){switch(Q.type){case 200:{const oe=this.o([Q.type]);this.k?.logOutgoing(oe,0,1,r(Q.type));return}case 201:case 202:case 204:case 203:{const oe=this.o([Q.type,Q.id],Q.data);this.k?.logOutgoing(oe,Q.id,1,r(Q.type),Q.data);return}}}o(Q,oe=void 0){const re=new g;return w(re,Q),w(re,oe),this.p(re.buffer)}p(Q){try{return this.h.send(Q),Q.byteLength}catch{return 0}}q(Q){const oe=new S(Q),re=m(oe),ie=m(oe),A=re[0];switch(A){case 100:return this.k?.logIncoming(Q.byteLength,re[1],1,`${e(A)}: ${re[2]}.${re[3]}`,ie),this.s({type:A,id:re[1],channelName:re[2],name:re[3],arg:ie});case 102:return this.k?.logIncoming(Q.byteLength,re[1],1,`${e(A)}: ${re[2]}.${re[3]}`,ie),this.t({type:A,id:re[1],channelName:re[2],name:re[3],arg:ie});case 101:return this.k?.logIncoming(Q.byteLength,re[1],1,`${e(A)}`),this.u({type:A,id:re[1]});case 103:return this.k?.logIncoming(Q.byteLength,re[1],1,`${e(A)}`),this.u({type:A,id:re[1]})}}s(Q){const oe=this.b.get(Q.channelName);if(!oe){this.v(Q);return}const re=new U.CancellationTokenSource;let ie;try{ie=oe.call(this.j,Q.name,Q.arg,re.token)}catch(h){ie=Promise.reject(h)}const A=Q.id;ie.then(h=>{this.m({id:A,data:h,type:201}),this.d.delete(Q.id)},h=>{h instanceof Error?this.m({id:A,data:{message:h.message,name:h.name,stack:h.stack?h.stack.split?h.stack.split(`
`):h.stack:void 0},type:202}):this.m({id:A,data:h,type:203}),this.d.delete(Q.id)});const C=(0,c.toDisposable)(()=>re.cancel());this.d.set(Q.id,C)}t(Q){const oe=this.b.get(Q.channelName);if(!oe){this.v(Q);return}const re=Q.id,A=oe.listen(this.j,Q.name,Q.arg)(C=>this.m({id:re,data:C,type:204}));this.d.set(Q.id,A)}u(Q){const oe=this.d.get(Q.id);oe&&(oe.dispose(),this.d.delete(Q.id))}v(Q){let oe=this.g.get(Q.channelName);oe||(oe=[],this.g.set(Q.channelName,oe));const re=setTimeout(()=>{console.error(`Unknown channel: ${Q.channelName}`),Q.type===100&&this.m({id:Q.id,data:{name:"Unknown channel",message:`Channel name '${Q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);oe.push({request:Q,timeoutTimer:re})}w(Q){const oe=this.g.get(Q);if(oe){for(const re of oe)switch(clearTimeout(re.timeoutTimer),re.request.type){case 100:this.s(re.request);break;case 102:this.t(re.request);break}this.g.delete(Q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.dispose)(this.d.values()),this.d.clear()}}t.ChannelServer=D;var R;(function(he){he[he.LocalSide=0]="LocalSide",he[he.OtherSide=1]="OtherSide"})(R=t.RequestInitiator||(t.RequestInitiator={}));class V{constructor(Q,oe=null){this.l=Q,this.a=!1,this.b=a.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new u.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(re=>this.s(re)),this.j=oe}getChannel(Q){const oe=this;return{call(re,ie,A){return oe.a?Promise.reject(new b.CancellationError):oe.m(Q,re,ie,A)},listen(re,ie){return oe.a?u.Event.None:oe.o(Q,re,ie)}}}m(Q,oe,re,ie=U.CancellationToken.None){const A=this.g++,h={id:A,type:100,channelName:Q,name:oe,arg:re};if(ie.isCancellationRequested)return Promise.reject(new b.CancellationError);let B;return new Promise(($,Y)=>{if(ie.isCancellationRequested)return Y(new b.CancellationError);const T=()=>{const M=P=>{switch(P.type){case 201:this.f.delete(A),$(P.data);break;case 202:{this.f.delete(A);const O=new Error(P.data.message);O.stack=Array.isArray(P.data.stack)?P.data.stack.join(`
`):P.data.stack,O.name=P.data.name,Y(O);break}case 203:this.f.delete(A),Y(P.data);break}};this.f.set(A,M),this.p(h)};let H=null;this.b===a.Idle?T():(H=(0,i.createCancelablePromise)(M=>this.u()),H.then(()=>{H=null,T()}));const W=()=>{H?(H.cancel(),H=null):this.p({id:A,type:101}),Y(new b.CancellationError)},L=ie.onCancellationRequested(W);B=(0,c.combinedDisposable)((0,c.toDisposable)(W),L),this.d.add(B)}).finally(()=>{this.d.delete(B)})}o(Q,oe,re){const ie=this.g++,C={id:ie,type:102,channelName:Q,name:oe,arg:re};let h=null;const B=new u.Emitter({onWillAddFirstListener:()=>{h=(0,i.createCancelablePromise)($=>this.u()),h.then(()=>{h=null,this.d.add(B),this.p(C)})},onDidRemoveLastListener:()=>{h?(h.cancel(),h=null):(this.d.delete(B),this.p({id:ie,type:103}))}}),_=$=>B.fire($.data);return this.f.set(ie,_),B.event}p(Q){switch(Q.type){case 100:case 102:{const oe=this.q([Q.type,Q.id,Q.channelName,Q.name],Q.arg);this.j?.logOutgoing(oe,Q.id,0,`${e(Q.type)}: ${Q.channelName}.${Q.name}`,Q.arg);return}case 101:case 103:{const oe=this.q([Q.type,Q.id]);this.j?.logOutgoing(oe,Q.id,0,e(Q.type));return}}}q(Q,oe=void 0){const re=new g;return w(re,Q),w(re,oe),this.r(re.buffer)}r(Q){try{return this.l.send(Q),Q.byteLength}catch{return 0}}s(Q){const oe=new S(Q),re=m(oe),ie=m(oe),A=re[0];switch(A){case 200:return this.j?.logIncoming(Q.byteLength,0,0,r(A)),this.t({type:re[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Q.byteLength,re[1],0,r(A),ie),this.t({type:re[0],id:re[1],data:ie})}}t(Q){if(Q.type===200){this.b=a.Idle,this.k.fire();return}this.f.get(Q.id)?.(Q)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}u(){return this.b===a.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.dispose)(this.d.values()),this.d.clear()}}qe([y.memoize],V.prototype,"onDidInitializePromise",null),t.ChannelClient=V;class Z{get connections(){const Q=[];return this.f.forEach(oe=>Q.push(oe)),Q}constructor(Q){this.a=new Map,this.f=new Set,this.g=new u.Emitter,this.onDidAddConnection=this.g.event,this.h=new u.Emitter,this.onDidRemoveConnection=this.h.event,Q(({protocol:oe,onDidClientDisconnect:re})=>{u.Event.once(oe.onMessage)(A=>{const C=new S(A),h=m(C),B=new D(oe,h),_=new V(oe);this.a.forEach((Y,T)=>B.registerChannel(T,Y));const $={channelServer:B,channelClient:_,ctx:h};this.f.add($),this.g.fire($),re(()=>{B.dispose(),_.dispose(),this.f.delete($),this.h.fire($)})})})}getChannel(Q,oe){const re=this;return{call(ie,A,C){let h;if((0,o.isFunction)(oe)){const _=(0,v.getRandomElement)(re.connections.filter(oe));h=_?Promise.resolve(_):u.Event.toPromise(u.Event.filter(re.onDidAddConnection,oe))}else h=oe.routeCall(re,ie,A);const B=h.then(_=>_.channelClient.getChannel(Q));return x(B).call(ie,A,C)},listen(ie,A){if((0,o.isFunction)(oe))return re.j(Q,oe,ie,A);const C=oe.routeEvent(re,ie,A).then(h=>h.channelClient.getChannel(Q));return x(C).listen(ie,A)}}}j(Q,oe,re,ie){const A=this;let C=new c.DisposableStore;const h=new u.Emitter({onWillAddFirstListener:()=>{C=new c.DisposableStore;const B=new u.EventMultiplexer,_=new Map,$=T=>{const W=T.channelClient.getChannel(Q).listen(re,ie),L=B.add(W);_.set(T,L)},Y=T=>{const H=_.get(T);!H||(H.dispose(),_.delete(T))};A.connections.filter(oe).forEach($),u.Event.filter(A.onDidAddConnection,oe)($,void 0,C),A.onDidRemoveConnection(Y,void 0,C),B.event(h.fire,h,C),C.add(B)},onDidRemoveLastListener:()=>{C.dispose()}});return h.event}registerChannel(Q,oe){this.a.set(Q,oe),this.f.forEach(re=>{re.channelServer.registerChannel(Q,oe)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}t.IPCServer=Z;class X{constructor(Q,oe,re=null){const ie=new g;w(ie,oe),Q.send(ie.buffer),this.a=new V(Q,re),this.d=new D(Q,oe,re)}getChannel(Q){return this.a.getChannel(Q)}registerChannel(Q,oe){this.d.registerChannel(Q,oe)}dispose(){this.a.dispose(),this.d.dispose()}}t.IPCClient=X;function x(he){return{call(Q,oe,re){return he.then(ie=>ie.call(Q,oe,re))},listen(Q,oe){const re=new u.Relay;return he.then(ie=>re.input=ie.listen(Q,oe)),re.event}}}t.getDelayedChannel=x;function ne(he){let Q=!1;return{call(oe,re,ie){return Q?he.call(oe,re,ie):(0,i.timeout)(0).then(()=>Q=!0).then(()=>he.call(oe,re,ie))},listen(oe,re){if(Q)return he.listen(oe,re);const ie=new u.Relay;return(0,i.timeout)(0).then(()=>Q=!0).then(()=>ie.input=he.listen(oe,re)),ie.event}}}t.getNextTickChannel=ne;class le{constructor(Q){this.a=Q}routeCall(Q){return this.b(Q)}routeEvent(Q){return this.b(Q)}async b(Q){for(const oe of Q.connections)if(await Promise.resolve(this.a(oe.ctx)))return Promise.resolve(oe);return await u.Event.toPromise(Q.onDidAddConnection),await this.b(Q)}}t.StaticRouter=le;var se;(function(he){function Q(A,C){const h=A,B=C&&C.disableMarshalling,_=new Map;for(const $ in h)re($)&&_.set($,u.Event.buffer(h[$],!0));return new class{listen($,Y,T){const H=_.get(Y);if(H)return H;if(ie(Y)){const W=h[Y];if(typeof W=="function")return W.call(h,T)}throw new Error(`Event not found: ${Y}`)}call($,Y,T){const H=h[Y];if(typeof H=="function"){if(!B&&Array.isArray(T))for(let W=0;W<T.length;W++)T[W]=(0,f.revive)(T[W]);return H.apply(h,T)}throw new Error(`Method not found: ${Y}`)}}}he.fromService=Q;function oe(A,C){const h=C&&C.disableMarshalling;return new Proxy({},{get(B,_){if(typeof _=="string")return C?.properties?.has(_)?C.properties.get(_):ie(_)?function($){return A.listen(_,$)}:re(_)?A.listen(_):async function(...$){let Y;C&&!(0,o.isUndefinedOrNull)(C.context)?Y=[C.context,...$]:Y=$;const T=await A.call(_,Y);return h?T:(0,f.revive)(T)};throw new Error(`Property not found: ${String(_)}`)}})}he.toService=oe;function re(A){return A[0]==="o"&&A[1]==="n"&&I.isUpperAsciiLetter(A.charCodeAt(2))}function ie(A){return/^onDynamic/.test(A)&&I.isUpperAsciiLetter(A.charCodeAt(9))}})(se=t.ProxyChannel||(t.ProxyChannel={}));const fe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Ae(he){if(Array.isArray(he))return he;if(he&&typeof he=="object"&&typeof he.toString=="function"){const Q=he.toString();if(Q!=="[object Object]")return Q}return he}function te(he){return Array.isArray(he)?he.map(Ae):Ae(he)}function ve(he,Q,oe,re,ie,A,C){C=te(C);const h=fe[ie],B=h[re%h.length];let _=[`%c[${he}]%c[${String(Q).padStart(7," ")}]%c[len: ${String(oe).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${A}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(A)?(_=_.concat(C),_.push(")")):_.push(C),console.log.apply(console,_)}class Ne{constructor(Q,oe){this.d=Q,this.f=oe,this.a=0,this.b=0}logOutgoing(Q,oe,re,ie,A){this.b+=Q,ve(this.d,this.b,Q,oe,re,ie,A)}logIncoming(Q,oe,re,ie,A){this.a+=Q,ve(this.f,this.a,Q,oe,re,ie,A)}}t.IPCLogger=Ne}),define(me[27],be([1,0,5]),function(J,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.context=t.process=t.webFrame=t.ipcMessagePort=t.ipcRenderer=void 0,t.ipcRenderer=v.globals.vscode.ipcRenderer,t.ipcMessagePort=v.globals.vscode.ipcMessagePort,t.webFrame=v.globals.vscode.webFrame,t.process=v.globals.vscode.process,t.context=v.globals.vscode.context}),define(me[130],be([1,0,81,27]),function(J,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.popup=void 0;let z=0;function U(b,u,c){const f=[],I=z++,o=`vscode:onContextMenu${I}`,n=(e,s,r)=>{f[s].click?.(r)};i.ipcRenderer.once(o,n),i.ipcRenderer.once(v.CONTEXT_MENU_CLOSE_CHANNEL,(e,s)=>{s===I&&(i.ipcRenderer.removeListener(o,n),c?.())}),i.ipcRenderer.send(v.CONTEXT_MENU_CHANNEL,I,b.map(e=>y(e,f)),o,u)}t.popup=U;function y(b,u){const c={id:u.length,label:b.label,type:b.type,accelerator:b.accelerator,checked:b.checked,enabled:typeof b.enabled=="boolean"?b.enabled:!0,visible:typeof b.visible=="boolean"?b.visible:!0};return u.push(b),Array.isArray(b.submenu)&&(c.submenu=b.submenu.map(f=>y(f,u))),c}}),define(me[131],be([1,0,29,3,37,82,27]),function(J,t,v,i,z,U,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=void 0;class b extends z.IPCClient{static f(){const c=i.Event.fromNodeEventEmitter(y.ipcRenderer,"vscode:message",(f,I)=>v.VSBuffer.wrap(I));return y.ipcRenderer.send("vscode:hello"),new U.Protocol(y.ipcRenderer,c)}constructor(c){const f=b.f();super(f,c),this.b=f}dispose(){this.b.disconnect()}}t.Client=b}),define(me[132],be([13,10]),function(J,t){return J.create("vs/platform/files/common/files",t)}),define(me[133],be([13,10]),function(J,t){return J.create("vs/platform/theme/common/iconRegistry",t)}),define(me[65],be([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class v{constructor(z,U=[],y=!1){this.ctor=z,this.staticArguments=U,this.supportsDelayedInstantiation=y}}t.SyncDescriptor=v}),define(me[134],be([1,0,65]),function(J,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSingletonServiceDescriptors=t.registerSingleton=t.InstantiationType=void 0;const i=[];var z;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(z=t.InstantiationType||(t.InstantiationType={}));function U(b,u,c){u instanceof v.SyncDescriptor||(u=new v.SyncDescriptor(u,[],Boolean(c))),i.push([b,u])}t.registerSingleton=U;function y(){return i}t.getSingletonServiceDescriptors=y}),define(me[28],be([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.refineServiceDecorator=t.createDecorator=t.IInstantiationService=t._util=void 0;var v;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function b(u){return u[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=b})(v=t._util||(t._util={})),t.IInstantiationService=z("instantiationService");function i(y,b,u){b[v.DI_TARGET]===b?b[v.DI_DEPENDENCIES].push({id:y,index:u}):(b[v.DI_DEPENDENCIES]=[{id:y,index:u}],b[v.DI_TARGET]=b)}function z(y){if(v.serviceIds.has(y))return v.serviceIds.get(y);const b=function(u,c,f){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(b,u,f)};return b.toString=()=>y,v.serviceIds.set(y,b),b}t.createDecorator=z;function U(y){return y}t.refineServiceDecorator=U}),define(me[135],be([1,0,28]),function(J,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullDiagnosticsService=t.isRemoteDiagnosticError=t.IDiagnosticsService=t.ID=void 0,t.ID="diagnosticsService",t.IDiagnosticsService=(0,v.createDecorator)(t.ID);function i(U){return!!U.hostName&&!!U.errorMessage}t.isRemoteDiagnosticError=i;class z{async getPerformanceInfo(y,b){return{}}async getSystemInfo(y,b){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(y,b){return""}async getWorkspaceFileExtensions(y){return{extensions:[]}}async reportWorkspaceStats(y){}}t.NullDiagnosticsService=z}),define(me[136],be([1,0,113,21,11,6,16,132,28]),function(J,t,v,i,z,U,y,b,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPlatformLimits=t.Arch=t.ByteSize=t.FALLBACK_MAX_MEMORY_SIZE_MB=t.MIN_MAX_MEMORY_SIZE_MB=t.whenProviderRegistered=t.etag=t.ETAG_DISABLED=t.FileKind=t.FILES_EXCLUDE_CONFIG=t.FILES_ASSOCIATIONS_CONFIG=t.HotExitConfiguration=t.AutoSaveConfiguration=t.FileOperationResult=t.NotModifiedSinceFileOperationError=t.FileOperationError=t.isParent=t.FileChangesEvent=t.FileChangeType=t.FileOperationEvent=t.FileOperation=t.toFileOperationResult=t.toFileSystemProviderErrorCode=t.markAsFileSystemProviderError=t.ensureFileSystemProviderError=t.createFileSystemProviderError=t.FileSystemProviderError=t.FileSystemProviderErrorCode=t.hasFileAtomicReadCapability=t.hasFileReadStreamCapability=t.hasOpenReadWriteCloseCapability=t.hasFileCloneCapability=t.hasFileFolderCopyCapability=t.hasReadWriteCapability=t.FileSystemProviderCapabilities=t.FilePermission=t.FileType=t.isFileOpenForWriteOptions=t.IFileService=void 0,t.IFileService=(0,u.createDecorator)("fileService");function c(te){return te.create===!0}t.isFileOpenForWriteOptions=c;var f;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(f=t.FileType||(t.FileType={}));var I;(function(te){te[te.Readonly=1]="Readonly"})(I=t.FilePermission||(t.FilePermission={}));var o;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileClone=32768]="FileClone"})(o=t.FileSystemProviderCapabilities||(t.FileSystemProviderCapabilities={}));function n(te){return!!(te.capabilities&2)}t.hasReadWriteCapability=n;function e(te){return!!(te.capabilities&8)}t.hasFileFolderCopyCapability=e;function s(te){return!!(te.capabilities&32768)}t.hasFileCloneCapability=s;function r(te){return!!(te.capabilities&4)}t.hasOpenReadWriteCloseCapability=r;function a(te){return!!(te.capabilities&16)}t.hasFileReadStreamCapability=a;function l(te){return n(te)?!!(te.capabilities&16384):!1}t.hasFileAtomicReadCapability=l;var p;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(p=t.FileSystemProviderErrorCode||(t.FileSystemProviderErrorCode={}));class k extends Error{constructor(ve,Ne){super(ve),this.code=Ne}}t.FileSystemProviderError=k;function S(te,ve){const Ne=new k(te.toString(),ve);return E(Ne,ve),Ne}t.createFileSystemProviderError=S;function g(te){return te||S((0,b.localize)(0,null),p.Unknown)}t.ensureFileSystemProviderError=g;function E(te,ve){return te.name=ve?`${ve} (FileSystemError)`:"FileSystemError",te}t.markAsFileSystemProviderError=E;function N(te){if(!te)return p.Unknown;if(te instanceof k)return te.code;const ve=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!ve)return p.Unknown;switch(ve[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}t.toFileSystemProviderErrorCode=N;function F(te){if(te instanceof V)return te.fileOperationResult;switch(N(te)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}t.toFileOperationResult=F;var d;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(d=t.FileOperation||(t.FileOperation={}));class w{constructor(ve,Ne,he){this.resource=ve,this.operation=Ne,this.target=he}isOperation(ve){return this.operation===ve}}t.FileOperationEvent=w;var m;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(m=t.FileChangeType||(t.FileChangeType={}));class D{constructor(ve,Ne){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const he=new Map;for(const Q of ve){const oe=he.get(Q.type);switch(oe?oe.push([Q.resource,Q]):he.set(Q.type,[[Q.resource,Q]]),Q.type){case 1:this.rawAdded.push(Q.resource);break;case 0:this.rawUpdated.push(Q.resource);break;case 2:this.rawDeleted.push(Q.resource);break}}for(const[Q,oe]of he)switch(Q){case 1:this.a=v.TernarySearchTree.forUris(()=>Ne),this.a.fill(oe);break;case 0:this.b=v.TernarySearchTree.forUris(()=>Ne),this.b.fill(oe);break;case 2:this.c=v.TernarySearchTree.forUris(()=>Ne),this.c.fill(oe);break}}contains(ve,...Ne){return this.d(ve,{includeChildren:!1},...Ne)}affects(ve,...Ne){return this.d(ve,{includeChildren:!0},...Ne)}d(ve,Ne,...he){if(!ve)return!1;const Q=he.length>0;return!!((!Q||he.includes(1))&&(this.a?.get(ve)||Ne.includeChildren&&this.a?.findSuperstr(ve))||(!Q||he.includes(0))&&(this.b?.get(ve)||Ne.includeChildren&&this.b?.findSuperstr(ve))||(!Q||he.includes(2))&&(this.c?.findSubstr(ve)||Ne.includeChildren&&this.c?.findSuperstr(ve)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}t.FileChangesEvent=D;function R(te,ve,Ne){return!te||!ve||te===ve||ve.length>te.length?!1:(ve.charAt(ve.length-1)!==i.sep&&(ve+=i.sep),Ne?(0,z.startsWithIgnoreCase)(te,ve):te.indexOf(ve)===0)}t.isParent=R;class V extends Error{constructor(ve,Ne,he){super(ve),this.fileOperationResult=Ne,this.options=he}}t.FileOperationError=V;class Z extends V{constructor(ve,Ne,he){super(ve,2,he),this.stat=Ne}}t.NotModifiedSinceFileOperationError=Z;var X;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",te[te.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(X=t.FileOperationResult||(t.FileOperationResult={})),t.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.FILES_ASSOCIATIONS_CONFIG="files.associations",t.FILES_EXCLUDE_CONFIG="files.exclude";var x;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(x=t.FileKind||(t.FileKind={})),t.ETAG_DISABLED="";function ne(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}t.etag=ne;async function le(te,ve){if(!ve.hasProvider(y.URI.from({scheme:te.scheme})))return new Promise(Ne=>{const he=ve.onDidChangeFileSystemProviderRegistrations(Q=>{Q.scheme===te.scheme&&Q.added&&(he.dispose(),Ne())})})}t.whenProviderRegistered=le,t.MIN_MAX_MEMORY_SIZE_MB=2048,t.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class se{static formatSize(ve){return(0,U.isNumber)(ve)||(ve=0),ve<se.KB?(0,b.localize)(1,null,ve.toFixed(0)):ve<se.MB?(0,b.localize)(2,null,(ve/se.KB).toFixed(2)):ve<se.GB?(0,b.localize)(3,null,(ve/se.MB).toFixed(2)):ve<se.TB?(0,b.localize)(4,null,(ve/se.GB).toFixed(2)):(0,b.localize)(5,null,(ve/se.TB).toFixed(2))}}t.ByteSize=se,se.KB=1024,se.MB=se.KB*se.KB,se.GB=se.MB*se.KB,se.TB=se.GB*se.KB;var fe;(function(te){te[te.IA32=0]="IA32",te[te.OTHER=1]="OTHER"})(fe=t.Arch||(t.Arch={}));function Ae(te){return{maxFileSize:te===0?300*se.MB:16*se.GB,maxHeapSize:te===0?700*se.MB:2*700*se.MB}}t.getPlatformLimits=Ae}),define(me[137],be([1,0,2,131]),function(J,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ElectronIPCMainProcessService=void 0;class z extends v.Disposable{constructor(y){super(),this.a=this.B(new i.Client(`window:${y}`))}getChannel(y){return this.a.getChannel(y)}registerChannel(y,b){this.a.registerChannel(y,b)}}t.ElectronIPCMainProcessService=z});var pt=this&&this.__param||function(J,t){return function(v,i){t(v,i,J)}};define(me[138],be([1,0,37,65,134,28]),function(J,t,v,i,z,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.registerSharedProcessRemoteService=t.ISharedProcessService=t.registerMainProcessRemoteService=t.IMainProcessService=void 0;class y{constructor(n,e,s,r){const a=s.getChannel(n);return b(e)?r.createInstance(new i.SyncDescriptor(e.channelClientCtor,[a])):v.ProxyChannel.toService(a,e?.proxyOptions)}}function b(o){return!!o?.channelClientCtor}t.IMainProcessService=(0,U.createDecorator)("mainProcessService");let u=class extends y{constructor(n,e,s,r){super(n,e,s,r)}};u=qe([pt(2,t.IMainProcessService),pt(3,U.IInstantiationService)],u);function c(o,n,e){(0,z.registerSingleton)(o,new i.SyncDescriptor(u,[n,e],!0))}t.registerMainProcessRemoteService=c,t.ISharedProcessService=(0,U.createDecorator)("sharedProcessService");let f=class extends y{constructor(n,e,s,r){super(n,e,s,r)}};f=qe([pt(2,t.ISharedProcessService),pt(3,U.IInstantiationService)],f);function I(o,n,e){(0,z.registerSingleton)(o,new i.SyncDescriptor(f,[n,e],!0))}t.registerSharedProcessRemoteService=I}),define(me[139],be([1,0,37,138]),function(J,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeHostService=void 0;let z=class{constructor(y,b){return this.windowId=y,v.ProxyChannel.toService(b.getChannel("nativeHost"),{context:y,properties:(()=>{const u=new Map;return u.set("windowId",y),u})()})}};z=qe([pt(1,i.IMainProcessService)],z),t.NativeHostService=z}),define(me[38],be([1,0,72,6]),function(J,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class z{constructor(){this.a=new Map}add(y,b){v.ok(i.isString(y)),v.ok(i.isObject(b)),v.ok(!this.a.has(y),"There is already an extension with this id"),this.a.set(y,b)}knows(y){return this.a.has(y)}as(y){return this.a.get(y)||null}}t.Registry=new z}),define(me[140],be([1,0,3,38]),function(J,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function z(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class U{constructor(){this.b=new v.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,c){this.a[z(u)]=c,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}}const y=new U;i.Registry.add(t.Extensions.JSONContribution,y)}),define(me[141],be([1,0]),function(J,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isDark=t.isHighContrast=t.ColorScheme=void 0;var v;(function(U){U.DARK="dark",U.LIGHT="light",U.HIGH_CONTRAST_DARK="hcDark",U.HIGH_CONTRAST_LIGHT="hcLight"})(v=t.ColorScheme||(t.ColorScheme={}));function i(U){return U===v.HIGH_CONTRAST_DARK||U===v.HIGH_CONTRAST_LIGHT}t.isHighContrast=i;function z(U){return U===v.DARK||U===v.HIGH_CONTRAST_DARK}t.isDark=z}),define(me[66],be([1,0,12,3,2,28,38,141]),function(J,t,v,i,z,U,y,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Themable=t.registerThemingParticipant=t.Extensions=t.getThemeTypeSelector=t.FolderThemeIcon=t.FileThemeIcon=t.ThemeIcon=t.themeColorFromId=t.ThemeColor=t.IThemeService=void 0,t.IThemeService=(0,U.createDecorator)("themeService");var u;(function(r){function a(l){return l&&typeof l=="object"&&typeof l.id=="string"}r.isThemeColor=a})(u=t.ThemeColor||(t.ThemeColor={}));function c(r){return{id:r}}t.themeColorFromId=c;var f;(function(r){function a(F){return F&&typeof F=="object"&&typeof F.id=="string"&&(typeof F.color>"u"||u.isThemeColor(F.color))}r.isThemeIcon=a;const l=new RegExp(`^\\$\\((${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?)\\)$`);function p(F){const d=l.exec(F);if(!d)return;const[,w]=d;return{id:w}}r.fromString=p;function k(F){return{id:F}}r.fromId=k;function S(F,d){let w=F.id;const m=w.lastIndexOf("~");return m!==-1&&(w=w.substring(0,m)),d&&(w=`${w}~${d}`),{id:w}}r.modify=S;function g(F){const d=F.id.lastIndexOf("~");if(d!==-1)return F.id.substring(d+1)}r.getModifier=g;function E(F,d){return F.id===d.id&&F.color?.id===d.color?.id}r.isEqual=E;function N(F,d){return{id:F.id,color:d?c(d):void 0}}r.asThemeIcon=N,r.asClassNameArray=v.CSSIcon.asClassNameArray,r.asClassName=v.CSSIcon.asClassName,r.asCSSSelector=v.CSSIcon.asCSSSelector})(f=t.ThemeIcon||(t.ThemeIcon={})),t.FileThemeIcon=v.Codicon.file,t.FolderThemeIcon=v.Codicon.folder;function I(r){switch(r){case b.ColorScheme.DARK:return"vs-dark";case b.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case b.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}t.getThemeTypeSelector=I,t.Extensions={ThemingContribution:"base.contributions.theming"};class o{constructor(){this.a=[],this.a=[],this.b=new i.Emitter}onColorThemeChange(a){return this.a.push(a),this.b.fire(a),(0,z.toDisposable)(()=>{const l=this.a.indexOf(a);this.a.splice(l,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const n=new o;y.Registry.add(t.Extensions.ThemingContribution,n);function e(r){return n.onColorThemeChange(r)}t.registerThemingParticipant=e;class s extends z.Disposable{constructor(a){super(),this.k=a,this.h=a.getColorTheme(),this.B(this.k.onDidColorThemeChange(l=>this.n(l)))}n(a){this.h=a,this.updateStyles()}updateStyles(){}w(a,l){let p=this.h.getColor(a);return p&&l&&(p=l(p,this.h)),p?p.toString():null}}t.Themable=s}),define(me[142],be([1,0,8,12,3,6,16,133,140,38,66]),function(J,t,v,i,z,U,y,b,u,c,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.spinningLoading=t.syncing=t.gotoNextLocation=t.gotoPreviousLocation=t.widgetClose=t.iconsSchemaId=t.getIconRegistry=t.registerIcon=t.IconFontDefinition=t.IconContribution=t.Extensions=void 0,t.Extensions={IconContribution:"base.contributions.icons"};var I;(function(k){function S(g,E){let N=g.defaults;for(;f.ThemeIcon.isThemeIcon(N);){const F=e.getIcon(N.id);if(!F)return;N=F.defaults}return N}k.getDefinition=S})(I=t.IconContribution||(t.IconContribution={}));var o;(function(k){function S(E){return{weight:E.weight,style:E.style,src:E.src.map(N=>({format:N.format,location:N.location.toString()}))}}k.toJSONObject=S;function g(E){const N=F=>(0,U.isString)(F)?F:void 0;if(E&&Array.isArray(E.src)&&E.src.every(F=>(0,U.isString)(F.format)&&(0,U.isString)(F.location)))return{weight:N(E.weight),style:N(E.style),src:E.src.map(F=>({format:F.format,location:y.URI.parse(F.location)}))}}k.fromJSONObject=g})(o=t.IconFontDefinition||(t.IconFontDefinition={}));class n{constructor(){this.a=new z.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,b.localize)(0,null)},fontCharacter:{type:"string",description:(0,b.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${i.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(S,g,E,N){const F=this.b[S];if(F){if(E&&!F.description){F.description=E,this.d.properties[S].markdownDescription=`${E} $(${S})`;const m=this.e.enum.indexOf(S);m!==-1&&(this.e.enumDescriptions[m]=E),this.a.fire()}return F}const d={id:S,description:E,defaults:g,deprecationMessage:N};this.b[S]=d;const w={$ref:"#/definitions/icons"};return N&&(w.deprecationMessage=N),E&&(w.markdownDescription=`${E}: $(${S})`),this.d.properties[S]=w,this.e.enum.push(S),this.e.enumDescriptions.push(E||""),this.a.fire(),{id:S}}deregisterIcon(S){delete this.b[S],delete this.d.properties[S];const g=this.e.enum.indexOf(S);g!==-1&&(this.e.enum.splice(g,1),this.e.enumDescriptions.splice(g,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(S=>this.b[S])}getIcon(S){return this.b[S]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(S,g){const E=this.f[S];return E||(this.f[S]=g,this.a.fire(),g)}deregisterIconFont(S){delete this.f[S]}getIconFont(S){return this.f[S]}toString(){const S=(F,d)=>F.id.localeCompare(d.id),g=F=>{for(;f.ThemeIcon.isThemeIcon(F.defaults);)F=this.b[F.defaults.id];return`codicon codicon-${F?F.id:""}`},E=[];E.push("| preview     | identifier                        | default codicon ID                | description"),E.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const N=Object.keys(this.b).map(F=>this.b[F]);for(const F of N.filter(d=>!!d.description).sort(S))E.push(`|<i class="${g(F)}"></i>|${F.id}|${f.ThemeIcon.isThemeIcon(F.defaults)?F.defaults.id:F.id}|${F.description||""}|`);E.push("| preview     | identifier                        "),E.push("| ----------- | --------------------------------- |");for(const F of N.filter(d=>!f.ThemeIcon.isThemeIcon(d.defaults)).sort(S))E.push(`|<i class="${g(F)}"></i>|${F.id}|`);return E.join(`
`)}}const e=new n;c.Registry.add(t.Extensions.IconContribution,e);function s(k,S,g,E){return e.registerIcon(k,S,g,E)}t.registerIcon=s;function r(){return e}t.getIconRegistry=r;function a(){for(const k of i.Codicon.getAll())e.registerIcon(k.id,k.definition,k.description)}a(),t.iconsSchemaId="vscode://schemas/icons";const l=c.Registry.as(u.Extensions.JSONContribution);l.registerSchema(t.iconsSchemaId,e.getIconSchema());const p=new v.RunOnceScheduler(()=>l.notifySchemaChanged(t.iconsSchemaId),200);e.onDidChange(()=>{p.isScheduled()||p.schedule()}),t.widgetClose=s("widget-close",i.Codicon.close,(0,b.localize)(2,null)),t.gotoPreviousLocation=s("goto-previous-location",i.Codicon.arrowUp,(0,b.localize)(3,null)),t.gotoNextLocation=s("goto-next-location",i.Codicon.arrowDown,(0,b.localize)(4,null)),t.syncing=f.ThemeIcon.modify(i.Codicon.sync,"spin"),t.spinningLoading=f.ThemeIcon.modify(i.Codicon.loading,"spin")}),define(me[143],be([1,0,4,3,142,66]),function(J,t,v,i,z,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnthemedProductIconTheme=t.getIconsStyleSheet=void 0;function y(u){const c=new i.Emitter,f=(0,z.getIconRegistry)();return f.onDidChange(()=>c.fire()),u?.onDidProductIconThemeChange(()=>c.fire()),{onDidChange:c.event,getCSS(){const I=u?u.getProductIconTheme():new b,o={},n=s=>{const r=I.getIcon(s);if(!r)return;const a=r.font;return a?(o[a.id]=a.definition,`.codicon-${s.id}:before { content: '${r.fontCharacter}'; font-family: ${(0,v.asCSSPropertyValue)(a.id)}; }`):`.codicon-${s.id}:before { content: '${r.fontCharacter}'; }`},e=[];for(const s of f.getIcons()){const r=n(s);r&&e.push(r)}for(const s in o){const r=o[s],a=r.weight?`font-weight: ${r.weight};`:"",l=r.style?`font-style: ${r.style};`:"",p=r.src.map(k=>`${(0,v.asCSSUrl)(k.location)} format('${k.format}')`).join(", ");e.push(`@font-face { src: ${p}; font-family: ${(0,v.asCSSPropertyValue)(s)};${a}${l} font-display: block; }`)}return e.join(`
`)}}}t.getIconsStyleSheet=y;class b{getIcon(c){const f=(0,z.getIconRegistry)();let I=c.defaults;for(;U.ThemeIcon.isThemeIcon(I);){const o=f.getIcon(I.id);if(!o)return;I=o.defaults}return I}}t.UnthemedProductIconTheme=b}),define(me[144],be([1,0,5]),function(J,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomLevelToZoomFactor=t.useWindowControlsOverlay=t.getTitleBarStyle=t.getMenuBarVisibility=t.isFileToOpen=t.isFolderToOpen=t.isWorkspaceToOpen=t.WindowMinimumSize=void 0,t.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function i(f){return!!f.workspaceUri}t.isWorkspaceToOpen=i;function z(f){return!!f.folderUri}t.isFolderToOpen=z;function U(f){return!!f.fileUri}t.isFileToOpen=U;function y(f){const I=b(f),o=f.getValue("window.menuBarVisibility");return o==="default"||I==="native"&&o==="compact"||v.isMacintosh&&v.isNative?"classic":o}t.getMenuBarVisibility=y;function b(f){if(v.isWeb)return"custom";const I=f.getValue("window");if(I){if(v.isMacintosh&&I.nativeTabs===!0||v.isMacintosh&&I.nativeFullScreen===!1)return"native";const e=I.titleBarStyle;if(e==="native"||e==="custom")return e}return v.isLinux?"native":"custom"}t.getTitleBarStyle=b;function u(f){if(!v.isWindows||v.isWeb||b(f)==="native")return!1;const I=f.getValue("window.experimental.windowControlsOverlay.enabled");return typeof I=="boolean"?I:!0}t.useWindowControlsOverlay=u;function c(f=0){return Math.pow(1.2,f)}t.zoomLevelToZoomFactor=c}),define(me[145],be([1,0,17,27,144]),function(J,t,v,i,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomOut=t.zoomIn=t.applyZoom=void 0;function U(u){i.webFrame.setZoomLevel(u),(0,v.setZoomFactor)((0,z.zoomLevelToZoomFactor)(u)),(0,v.setZoomLevel)(u,!1)}t.applyZoom=U;function y(){U((0,v.getZoomLevel)()+1)}t.zoomIn=y;function b(){U((0,v.getZoomLevel)()-1)}t.zoomOut=b}),define(me[146],be([1,0,10,4,129,8,130,27,135,136,137,139,143,145,15,95,86]),function(J,t,v,i,z,U,y,b,u,c,f,I,o,n,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const s=/\s--(inspect|debug)(-brk|port)?=(\d+)?/,r=/\s--(inspect|debug)-port=(\d+)/;class a{getHeight(R){return 22}getTemplateId(R){return F(R)?"process":E(R)?"machine":(0,u.isRemoteDiagnosticError)(R)?"error":N(R)?"header":""}}class l{hasChildren(R){return(0,u.isRemoteDiagnosticError)(R)?!1:F(R)?!!R.children?.length:!0}getChildren(R){return F(R)?R.children?R.children:[]:(0,u.isRemoteDiagnosticError)(R)?[]:N(R)?R.processRoots.length>1?R.processRoots:[R.processRoots[0].rootProcess]:E(R)?[R.rootProcess]:[R.processes]}}class p{constructor(){this.templateId="header"}renderTemplate(R){const V=Object.create(null),Z=(0,i.append)(R,(0,i.$)(".row"));return V.name=(0,i.append)(Z,(0,i.$)(".nameLabel")),V.CPU=(0,i.append)(Z,(0,i.$)(".cpu")),V.memory=(0,i.append)(Z,(0,i.$)(".memory")),V.PID=(0,i.append)(Z,(0,i.$)(".pid")),V}renderElement(R,V,Z,X){Z.name.textContent=(0,v.localize)(0,null),Z.CPU.textContent=(0,v.localize)(1,null),Z.PID.textContent=(0,v.localize)(2,null),Z.memory.textContent=(0,v.localize)(3,null)}disposeTemplate(R){}}class k{constructor(){this.templateId="machine"}renderTemplate(R){const V=Object.create(null),Z=(0,i.append)(R,(0,i.$)(".row"));return V.name=(0,i.append)(Z,(0,i.$)(".nameLabel")),V}renderElement(R,V,Z,X){Z.name.textContent=R.element.name}disposeTemplate(R){}}class S{constructor(){this.templateId="error"}renderTemplate(R){const V=Object.create(null),Z=(0,i.append)(R,(0,i.$)(".row"));return V.name=(0,i.append)(Z,(0,i.$)(".nameLabel")),V}renderElement(R,V,Z,X){Z.name.textContent=R.element.errorMessage}disposeTemplate(R){}}class g{constructor(R,V,Z){this.a=R,this.b=V,this.c=Z,this.templateId="process"}renderTemplate(R){const V=Object.create(null),Z=(0,i.append)(R,(0,i.$)(".row"));return V.name=(0,i.append)(Z,(0,i.$)(".nameLabel")),V.CPU=(0,i.append)(Z,(0,i.$)(".cpu")),V.memory=(0,i.append)(Z,(0,i.$)(".memory")),V.PID=(0,i.append)(Z,(0,i.$)(".pid")),V}renderElement(R,V,Z,X){const{element:x}=R;let ne=x.name;ne==="window"&&(ne=this.c.get(x.pid)!==void 0?`${ne} (${this.c.get(x.pid)})`:ne);const le=x.pid.toFixed(0);Z.name.textContent=ne,Z.name.title=x.cmd,Z.CPU.textContent=x.load.toFixed(0),Z.PID.textContent=le,Z.PID.parentElement.id=`pid-${le}`;const se=this.a==="win32"?x.mem:this.b*(x.mem/100);Z.memory.textContent=(se/c.ByteSize.MB).toFixed(0)}disposeTemplate(R){}}function E(D){return!!D.name&&!!D.rootProcess}function N(D){return!!D.processRoots}function F(D){return!!D.pid}class d{constructor(R,V){this.f=V,this.b=new Map;const Z=new f.ElectronIPCMainProcessService(R);this.c=new I.NativeHostService(R,Z),this.k(V.styles),this.g(V),b.ipcRenderer.on("vscode:windowsInfoResponse",(X,x)=>{this.b=new Map,x.forEach(ne=>this.b.set(ne.pid,ne.title))}),b.ipcRenderer.on("vscode:listProcessesResponse",async(X,x)=>{x.forEach((ne,le)=>{F(ne.rootProcess)&&(ne.rootProcess.name=le===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:x}}),this.d.layout(window.innerHeight,window.innerWidth)):await this.h(x),this.m(0)}),this.a=Date.now(),b.ipcRenderer.send("vscode:windowsInfoRequest"),b.ipcRenderer.send("vscode:listProcesses")}g(R){document.onkeydown=V=>{const Z=R.platform==="darwin"?V.metaKey:V.ctrlKey;Z&&V.keyCode===87&&(V.stopPropagation(),V.preventDefault(),b.ipcRenderer.send("vscode:closeProcessExplorer")),Z&&V.keyCode===187&&(0,n.zoomIn)(),Z&&V.keyCode===189&&(0,n.zoomOut)()}}async h(R){const V=document.getElementById("process-list");if(!V)return;const{totalmem:Z}=await this.c.getOSStatistics(),X=[new g(this.f.platform,Z,this.b),new p,new k,new S];this.d=new z.DataTree("processExplorer",V,new a,X,new l,{identityProvider:{getId:x=>F(x)?x.pid.toString():(0,u.isRemoteDiagnosticError)(x)?x.hostName:N(x)?"processes":E(x)?x.name:"header"}}),this.d.setInput({processes:{processRoots:R}}),this.d.layout(window.innerHeight,window.innerWidth),this.d.onKeyDown(x=>{const ne=new e.StandardKeyboardEvent(x);if(ne.keyCode===35&&ne.altKey){const le=this.n();Promise.all(le.map(se=>this.c.killProcess(se,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(x=>{F(x.element)&&this.l(x.element,!0)}),V.style.height=`${window.innerHeight}px`,window.addEventListener("resize",()=>{V.style.height=`${window.innerHeight}px`,this.d?.layout(window.innerHeight,window.innerWidth)})}i(R){const V=s.exec(R);return V&&V.length>=2||R.indexOf("node ")>=0||R.indexOf("node.exe")>=0}j(R){const V={type:"node",request:"attach",name:`process ${R.pid}`};let Z=s.exec(R.cmd);Z&&Z.length>=2?(Z.length===4&&Z[3]&&(V.port=parseInt(Z[3])),V.protocol=Z[1]==="debug"?"legacy":"inspector"):V.processId=String(R.pid),Z=r.exec(R.cmd),Z&&Z.length===3&&(V.port=parseInt(Z[2])),b.ipcRenderer.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[V]})}k(R){const V=(0,i.createStyleSheet)(),Z=[];R.listFocusBackground&&(Z.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${R.listFocusBackground}; }`),Z.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${R.listFocusBackground}; }`)),R.listFocusForeground&&Z.push(`.monaco-list:focus .monaco-list-row.focused { color: ${R.listFocusForeground}; }`),R.listActiveSelectionBackground&&(Z.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${R.listActiveSelectionBackground}; }`),Z.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${R.listActiveSelectionBackground}; }`)),R.listActiveSelectionForeground&&Z.push(`.monaco-list:focus .monaco-list-row.selected { color: ${R.listActiveSelectionForeground}; }`),R.listHoverBackground&&Z.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${R.listHoverBackground}; }`),R.listHoverForeground&&Z.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${R.listHoverForeground}; }`),R.listFocusOutline&&Z.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${R.listFocusOutline}; outline-offset: -1px; }`),R.listHoverOutline&&Z.push(`.monaco-list-row:hover { outline: 1px dashed ${R.listHoverOutline}; outline-offset: -1px; }`),R.scrollbarShadowColor&&Z.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${R.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${R.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${R.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),R.scrollbarSliderBackgroundColor&&Z.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${R.scrollbarSliderBackgroundColor};
				}
			`),R.scrollbarSliderHoverBackgroundColor&&Z.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${R.scrollbarSliderHoverBackgroundColor};
				}
			`),R.scrollbarSliderActiveBackgroundColor&&Z.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${R.scrollbarSliderActiveBackgroundColor};
				}
			`),V.textContent=Z.join(`
`),R.color&&(document.body.style.color=R.color)}l(R,V){const Z=[],X=Number(R.pid);V&&(Z.push({label:(0,v.localize)(4,null),click:()=>{this.c.killProcess(X,"SIGTERM")}}),Z.push({label:(0,v.localize)(5,null),click:()=>{this.c.killProcess(X,"SIGKILL")}}),Z.push({type:"separator"})),Z.push({label:(0,v.localize)(6,null),click:()=>{const x=this.n();x?.includes(X)||(x.length=0,x.push(X));const ne=x?.map(le=>document.getElementById(`pid-${le}`)).filter(le=>!!le);if(ne){const le=ne.map(se=>se.innerText).filter(se=>!!se);this.c.writeClipboardText(le.join(`
`))}}}),Z.push({label:(0,v.localize)(7,null),click:()=>{const x=document.getElementById("process-list");x&&this.c.writeClipboardText(x.innerText)}}),R&&V&&this.i(R.cmd)&&(Z.push({type:"separator"}),Z.push({label:(0,v.localize)(8,null),click:()=>{this.j(R)}})),(0,y.popup)(Z)}m(R){setTimeout(()=>{const V=Date.now(),Z=R+V-this.a;this.a=V,Z>1e3?(b.ipcRenderer.send("vscode:windowsInfoRequest"),b.ipcRenderer.send("vscode:listProcesses")):this.m(Z)},200)}n(){return this.d?.getSelection()?.map(R=>{if(!(!R||!("pid"in R)))return R.pid}).filter(R=>!!R)}}function w(){const D=(0,i.createStyleSheet)();D.id="codiconStyles";const R=(0,o.getIconsStyleSheet)(void 0);function V(){D.textContent=R.getCSS()}const Z=new U.RunOnceScheduler(V,0);R.onDidChange(()=>Z.schedule()),Z.schedule()}function m(D){const R=D.data.platform==="win32"?"windows":D.data.platform==="linux"?"linux":"mac";document.body.classList.add(R),w(),(0,n.applyZoom)(D.data.zoomLevel),new d(D.windowId,D.data)}t.startup=m})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/42814d18a7d46adfb1c24e1349b7ab18833ec6ac/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
