/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ye=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/errors","vs/base/common/types","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/network","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/editor/common/core/range","vs/base/common/process","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/registry/common/platform","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/ternarySearchTree","fs","vs/editor/common/languages","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/lazy","vs/base/common/normalization","vs/base/common/mime","vs/base/common/hash","vs/base/common/marshalling","os","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/processes","vs/base/common/filters","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/dataTransfer","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],Ce=function(ne){for(var e=[],o=0,t=ne.length;o<t;o++)e[o]=ye[ne[o]];return e};define(ye[80],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function o(R){return R?R.replace(/\$\((.*?)\)/g,(I,A)=>` ${A} `).trim():""}e.getCodiconAriaLabel=o;class t{constructor(I,A,S){this.id=I,this.definition=A,this.description=S,t.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t.a}}e.Codicon=t,t.a=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.commentDraft=new t("comment-draft",{fontCharacter:"\\ec0e"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);var k;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function A(L){if(L instanceof t)return["codicon","codicon-"+L.id];const P=I.exec(L.id);if(!P)return A(t.error);const[,y,D]=P,v=["codicon","codicon-"+y];return D&&v.push("codicon-modifier-"+D.substring(1)),v}R.asClassNameArray=A;function S(L){return A(L).join(" ")}R.asClassName=S;function C(L){return"."+A(L).join(".")}R.asCSSSelector=C})(k=e.CSSIcon||(e.CSSIcon={}))}),define(ye[81],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function o(I,A){const S=Object.create(null);for(const C of I){const L=A(C);let P=S[L];P||(P=S[L]=[]),P.push(C)}return S}e.groupBy=o;function t(I,A){const S=[],C=[];for(const L of I)A.has(L)||S.push(L);for(const L of A)I.has(L)||C.push(L);return{removed:S,added:C}}e.diffSets=t;function k(I,A){const S=[],C=[];for(const[L,P]of I)A.has(L)||S.push(P);for(const[L,P]of A)I.has(L)||C.push(P);return{removed:S,added:C}}e.diffMaps=k;class R{constructor(){this.a=new Map}add(A,S){let C=this.a.get(A);C||(C=new Set,this.a.set(A,C)),C.add(S)}delete(A,S){const C=this.a.get(A);!C||(C.delete(S),C.size===0&&this.a.delete(A))}forEach(A,S){const C=this.a.get(A);!C||C.forEach(S)}}e.SetMap=R}),define(ye[60],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function o(I){return(A,S,C)=>{let L=null,P=null;if(typeof C.value=="function"?(L="value",P=C.value):typeof C.get=="function"&&(L="get",P=C.get),!P)throw new Error("not supported");C[L]=I(P,S)}}function t(I,A,S){let C=null,L=null;if(typeof S.value=="function"?(C="value",L=S.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(C="get",L=S.get),!L)throw new Error("not supported");const P=`$memoize$${A}`;S[C]=function(...y){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,y)}),this[P]}}e.memoize=t;function k(I,A,S){return o((C,L)=>{const P=`$debounce$${L}`,y=`$debounce$result$${L}`;return function(...D){this[y]||(this[y]=S?S():void 0),clearTimeout(this[P]),A&&(this[y]=A(this[y],...D),D=[this[y]]),this[P]=setTimeout(()=>{C.apply(this,D),this[y]=S?S():void 0},I)}})}e.debounce=k;function R(I,A,S){return o((C,L)=>{const P=`$throttle$timer$${L}`,y=`$throttle$result$${L}`,D=`$throttle$lastRun$${L}`,v=`$throttle$pending$${L}`;return function(...d){if(this[y]||(this[y]=S?S():void 0),(this[D]===null||this[D]===void 0)&&(this[D]=-Number.MAX_VALUE),A&&(this[y]=A(this[y],...d)),this[v])return;const m=this[D]+I;m<=Date.now()?(this[D]=Date.now(),C.apply(this,[this[y]]),this[y]=S?S():void 0):(this[v]=!0,this[P]=setTimeout(()=>{this[v]=!1,this[D]=Date.now(),C.apply(this,[this[y]]),this[y]=S?S():void 0},m-Date.now()))}})}e.throttle=R}),define(ye[10],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class o{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?g.isErrorNoTelemetry(i)?new g(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(s=>{s(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.ErrorHandler=o,e.errorHandler=new o;function t(b){e.errorHandler.setUnexpectedErrorHandler(b)}e.setUnexpectedErrorHandler=t;function k(b){S(b)||e.errorHandler.onUnexpectedError(b)}e.onUnexpectedError=k;function R(b){S(b)||e.errorHandler.onUnexpectedExternalError(b)}e.onUnexpectedExternalError=R;function I(b){if(b instanceof Error){const{name:i,message:s}=b,a=b.stacktrace||b.stack;return{$isError:!0,name:i,message:s,stack:a,noTelemetry:g.isErrorNoTelemetry(b)}}return b}e.transformErrorForSerialization=I;const A="Canceled";function S(b){return b instanceof C?!0:b instanceof Error&&b.name===A&&b.message===A}e.isCancellationError=S;class C extends Error{constructor(){super(A),this.name=this.message}}e.CancellationError=C;function L(){const b=new Error(A);return b.name=b.message,b}e.canceled=L;function P(b){return b?new Error(`Illegal argument: ${b}`):new Error("Illegal argument")}e.illegalArgument=P;function y(b){return b?new Error(`Illegal state: ${b}`):new Error("Illegal state")}e.illegalState=y;function D(b){return b?new Error(`readonly property '${b} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=D;function v(b){const i=new Error(`${b} has been disposed`);return i.name="DISPOSED",i}e.disposed=v;function d(b){return b?b.message?b.message:b.stack?b.stack.split(`
`)[0]:String(b):"Error"}e.getErrorMessage=d;class m extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=m;class h extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=h;class w extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=w;class g extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof g)return i;const s=new g;return s.message=i.message,s.stack=i.stack,s}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=g;class p extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,p.prototype);debugger}}e.BugIndicatingError=p}),define(ye[18],Ce([1,0,10]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(se,le=0){return se[se.length-(1+le)]}e.tail=t;function k(se){if(se.length===0)throw new Error("Invalid tail call");return[se.slice(0,se.length-1),se[se.length-1]]}e.tail2=k;function R(se,le,ue=(ee,ae)=>ee===ae){if(se===le)return!0;if(!se||!le||se.length!==le.length)return!1;for(let ee=0,ae=se.length;ee<ae;ee++)if(!ue(se[ee],le[ee]))return!1;return!0}e.equals=R;function I(se,le){const ue=se.length-1;le<ue&&(se[le]=se[ue]),se.pop()}e.removeFastWithoutKeepingOrder=I;function A(se,le,ue){return S(se.length,ee=>ue(se[ee],le))}e.binarySearch=A;function S(se,le){let ue=0,ee=se-1;for(;ue<=ee;){const ae=(ue+ee)/2|0,ie=le(ae);if(ie<0)ue=ae+1;else if(ie>0)ee=ae-1;else return ae}return-(ue+1)}e.binarySearch2=S;function C(se,le){let ue=0,ee=se.length;if(ee===0)return 0;for(;ue<ee;){const ae=Math.floor((ue+ee)/2);le(se[ae])?ee=ae:ue=ae+1}return ue}e.findFirstInSorted=C;function L(se,le,ue){if(se=se|0,se>=le.length)throw new TypeError("invalid index");const ee=le[Math.floor(le.length*Math.random())],ae=[],ie=[],O=[];for(const H of le){const x=ue(H,ee);x<0?ae.push(H):x>0?ie.push(H):O.push(H)}return se<ae.length?L(se,ae,ue):se<ae.length+O.length?O[0]:L(se-(ae.length+O.length),ie,ue)}e.quickSelect=L;function P(se,le){const ue=[];let ee;for(const ae of se.slice(0).sort(le))!ee||le(ee[0],ae)!==0?(ee=[ae],ue.push(ee)):ee.push(ae);return ue}e.groupBy=P;function y(se,le,ue){const ee=[];function ae(H,x,Y){if(x===0&&Y.length===0)return;const de=ee[ee.length-1];de&&de.start+de.deleteCount===H?(de.deleteCount+=x,de.toInsert.push(...Y)):ee.push({start:H,deleteCount:x,toInsert:Y})}let ie=0,O=0;for(;;){if(ie===se.length){ae(ie,0,le.slice(O));break}if(O===le.length){ae(ie,se.length-ie,[]);break}const H=se[ie],x=le[O],Y=ue(H,x);Y===0?(ie+=1,O+=1):Y<0?(ae(ie,1,[]),ie+=1):Y>0&&(ae(ie,0,[x]),O+=1)}return ee}e.sortedDiff=y;function D(se,le,ue){const ee=y(se,le,ue),ae=[],ie=[];for(const O of ee)ae.push(...se.slice(O.start,O.start+O.deleteCount)),ie.push(...O.toInsert);return{removed:ae,added:ie}}e.delta=D;function v(se,le,ue){if(ue===0)return[];const ee=se.slice(0,ue).sort(le);return m(se,le,ee,ue,se.length),ee}e.top=v;function d(se,le,ue,ee,ae){return ue===0?Promise.resolve([]):new Promise((ie,O)=>{(async()=>{const H=se.length,x=se.slice(0,ue).sort(le);for(let Y=ue,de=Math.min(ue+ee,H);Y<H;Y=de,de=Math.min(de+ee,H)){if(Y>ue&&await new Promise(be=>setTimeout(be)),ae&&ae.isCancellationRequested)throw new o.CancellationError;m(se,le,x,Y,de)}return x})().then(ie,O)})}e.topAsync=d;function m(se,le,ue,ee,ae){for(const ie=ue.length;ee<ae;ee++){const O=se[ee];if(le(O,ue[ie-1])<0){ue.pop();const H=C(ue,x=>le(O,x)<0);ue.splice(H,0,O)}}}function h(se){return se.filter(le=>!!le)}e.coalesce=h;function w(se){let le=0;for(let ue=0;ue<se.length;ue++)se[ue]&&(se[le]=se[ue],le+=1);se.length=le}e.coalesceInPlace=w;function g(se,le,ue){se.splice(ue,0,se.splice(le,1)[0])}e.move=g;function p(se){return!Array.isArray(se)||se.length===0}e.isFalsyOrEmpty=p;function b(se){return Array.isArray(se)&&se.length>0}e.isNonEmptyArray=b;function i(se,le=ue=>ue){const ue=new Set;return se.filter(ee=>{const ae=le(ee);return ue.has(ae)?!1:(ue.add(ae),!0)})}e.distinct=i;function s(se){const le=new Set;return ue=>{const ee=se(ue);return le.has(ee)?!1:(le.add(ee),!0)}}e.uniqueFilter=s;function a(se,le){const ue=u(se,le);if(ue!==-1)return se[ue]}e.findLast=a;function u(se,le){for(let ue=se.length-1;ue>=0;ue--){const ee=se[ue];if(le(ee))return ue}return-1}e.lastIndex=u;function c(se,le){return se.length>0?se[0]:le}e.firstOrDefault=c;function l(se,le){return se.length>0?se[se.length-1]:le}e.lastOrDefault=l;function n(se,le,ue=(ee,ae)=>ee===ae){let ee=0;for(let ae=0,ie=Math.min(se.length,le.length);ae<ie&&ue(se[ae],le[ae]);ae++)ee++;return ee}e.commonPrefixLength=n;function r(se){return[].concat(...se)}e.flatten=r;function f(se,le){let ue=typeof le=="number"?se:0;typeof le=="number"?ue=se:(ue=0,le=se);const ee=[];if(ue<=le)for(let ae=ue;ae<le;ae++)ee.push(ae);else for(let ae=ue;ae>le;ae--)ee.push(ae);return ee}e.range=f;function E(se,le,ue){return se.reduce((ee,ae)=>(ee[le(ae)]=ue?ue(ae):ae,ee),Object.create(null))}e.index=E;function T(se,le){return se.push(le),()=>M(se,le)}e.insert=T;function M(se,le){const ue=se.indexOf(le);if(ue>-1)return se.splice(ue,1),le}e.remove=M;function G(se,le,ue){const ee=se.slice(0,le),ae=se.slice(le);return ee.concat(ue,ae)}e.arrayInsert=G;function V(se,le){let ue;if(typeof le=="number"){let ee=le;ue=()=>{const ae=Math.sin(ee++)*179426549;return ae-Math.floor(ae)}}else ue=Math.random;for(let ee=se.length-1;ee>0;ee-=1){const ae=Math.floor(ue()*(ee+1)),ie=se[ee];se[ee]=se[ae],se[ae]=ie}}e.shuffle=V;function N(se,le){const ue=se.indexOf(le);ue>-1&&(se.splice(ue,1),se.unshift(le))}e.pushToStart=N;function U(se,le){const ue=se.indexOf(le);ue>-1&&(se.splice(ue,1),se.push(le))}e.pushToEnd=U;function F(se,le){for(const ue of le)se.push(ue)}e.pushMany=F;function z(se,le){return Array.isArray(se)?se.map(le):le(se)}e.mapArrayOrNot=z;function B(se){return Array.isArray(se)?se:[se]}e.asArray=B;function W(se){return se[Math.floor(Math.random()*se.length)]}e.getRandomElement=W;function X(se,le){for(const ue of se){const ee=le(ue);if(ee!==void 0)return ee}}e.mapFind=X;function q(se,le,ue){const ee=Q(se,le),ae=se.length,ie=ue.length;se.length=ae+ie;for(let O=ae-1;O>=ee;O--)se[O+ie]=se[O];for(let O=0;O<ie;O++)se[O+ee]=ue[O]}e.insertInto=q;function _(se,le,ue,ee){const ae=Q(se,le),ie=se.splice(ae,ue);return q(se,ae,ee),ie}e.splice=_;function Q(se,le){return le<0?Math.max(le+se.length,0):Math.min(le,se.length)}var Z;(function(se){function le(ae){return ae<0}se.isLessThan=le;function ue(ae){return ae>0}se.isGreaterThan=ue;function ee(ae){return ae===0}se.isNeitherLessOrGreaterThan=ee,se.greaterThan=1,se.lessThan=-1,se.neitherLessOrGreaterThan=0})(Z=e.CompareResult||(e.CompareResult={}));function ge(se,le){return(ue,ee)=>le(se(ue),se(ee))}e.compareBy=ge;function te(...se){return(le,ue)=>{for(const ee of se){const ae=ee(le,ue);if(!Z.isNeitherLessOrGreaterThan(ae))return ae}return Z.neitherLessOrGreaterThan}}e.tieBreakComparators=te;const J=(se,le)=>se-le;e.numberComparator=J;function fe(se,le){if(se.length===0)return;let ue=se[0];for(let ee=1;ee<se.length;ee++){const ae=se[ee];le(ae,ue)>0&&(ue=ae)}return ue}e.findMaxBy=fe;function ve(se,le){if(se.length===0)return;let ue=se[0];for(let ee=1;ee<se.length;ee++){const ae=se[ee];le(ae,ue)>=0&&(ue=ae)}return ue}e.findLastMaxBy=ve;function Ee(se,le){return fe(se,(ue,ee)=>-le(ue,ee))}e.findMinBy=Ee;class Ae{constructor(le){this.f=le,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(le){let ue=this.c;for(;ue<this.f.length&&le(this.f[ue]);)ue++;const ee=ue===this.c?null:this.f.slice(this.c,ue);return this.c=ue,ee}takeFromEndWhile(le){let ue=this.d;for(;ue>=0&&le(this.f[ue]);)ue--;const ee=ue===this.d?null:this.f.slice(ue+1,this.d+1);return this.d=ue,ee}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const le=this.f[this.c];return this.c++,le}removeLast(){const le=this.f[this.d];return this.d--,le}takeCount(le){const ue=this.f.slice(this.c,this.c+le);return this.c+=le,ue}}e.ArrayQueue=Ae;class Fe{constructor(le){this.iterate=le}forEach(le){this.iterate(ue=>(le(ue),!0))}toArray(){const le=[];return this.iterate(ue=>(le.push(ue),!0)),le}filter(le){return new Fe(ue=>this.iterate(ee=>le(ee)?ue(ee):!0))}map(le){return new Fe(ue=>this.iterate(ee=>ue(le(ee))))}some(le){let ue=!1;return this.iterate(ee=>(ue=le(ee),!ue)),ue}findFirst(le){let ue;return this.iterate(ee=>le(ee)?(ue=ee,!1):!0),ue}findLast(le){let ue;return this.iterate(ee=>(le(ee)&&(ue=ee),!0)),ue}findLastMaxBy(le){let ue,ee=!0;return this.iterate(ae=>((ee||Z.isGreaterThan(le(ae,ue)))&&(ee=!1,ue=ae),!0)),ue}}e.CallbackIterable=Fe,Fe.empty=new Fe(se=>{})}),define(ye[49],Ce([1,0,10]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(S,C){if(!S)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=t;function k(S,C="Unreachable"){throw new Error(C)}e.assertNever=k;function R(S){if(!S)throw new o.BugIndicatingError("Assertion Failed")}e.assert=R;function I(S){if(!S()){debugger;S(),(0,o.onUnexpectedError)(new o.BugIndicatingError("Assertion Failed"))}}e.assertFn=I;function A(S,C){let L=0;for(;L<S.length-1;){const P=S[L],y=S[L+1];if(!C(P,y))return!1;L++}return!0}e.checkAdjacentItems=A}),define(ye[61],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function o(t){const k=this;let R=!1,I;return function(){return R||(R=!0,I=t.apply(k,arguments)),I}}e.once=o}),define(ye[100],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class o{constructor(k){this.a=k,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=o,e.defaultGenerator=new o("id#")}),define(ye[62],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var o;(function(t){function k(p){return p&&typeof p=="object"&&typeof p[Symbol.iterator]=="function"}t.is=k;const R=Object.freeze([]);function I(){return R}t.empty=I;function*A(p){yield p}t.single=A;function S(p){return k(p)?p:A(p)}t.wrap=S;function C(p){return p||R}t.from=C;function L(p){return!p||p[Symbol.iterator]().next().done===!0}t.isEmpty=L;function P(p){return p[Symbol.iterator]().next().value}t.first=P;function y(p,b){for(const i of p)if(b(i))return!0;return!1}t.some=y;function D(p,b){for(const i of p)if(b(i))return i}t.find=D;function*v(p,b){for(const i of p)b(i)&&(yield i)}t.filter=v;function*d(p,b){let i=0;for(const s of p)yield b(s,i++)}t.map=d;function*m(...p){for(const b of p)for(const i of b)yield i}t.concat=m;function h(p,b,i){let s=i;for(const a of p)s=b(s,a);return s}t.reduce=h;function*w(p,b,i=p.length){for(b<0&&(b+=p.length),i<0?i+=p.length:i>p.length&&(i=p.length);b<i;b++)yield p[b]}t.slice=w;function g(p,b=Number.POSITIVE_INFINITY){const i=[];if(b===0)return[i,p];const s=p[Symbol.iterator]();for(let a=0;a<b;a++){const u=s.next();if(u.done)return[i,t.empty()];i.push(u.value)}return[i,{[Symbol.iterator](){return s}}]}t.consume=g})(o=e.Iterable||(e.Iterable={}))}),define(ye[146],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var o;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(o=e.ScanError||(e.ScanError={}));var t;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(i){i.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function I(i,s=!1){let a=0;const u=i.length;let c="",l=0,n=16,r=0;function f(U){let F=0,z=0;for(;F<U;){const B=i.charCodeAt(a);if(B>=48&&B<=57)z=z*16+B-48;else if(B>=65&&B<=70)z=z*16+B-65+10;else if(B>=97&&B<=102)z=z*16+B-97+10;else break;a++,F++}return F<U&&(z=-1),z}function E(U){a=U,c="",l=0,n=16,r=0}function T(){const U=a;if(i.charCodeAt(a)===48)a++;else for(a++;a<i.length&&C(i.charCodeAt(a));)a++;if(a<i.length&&i.charCodeAt(a)===46)if(a++,a<i.length&&C(i.charCodeAt(a)))for(a++;a<i.length&&C(i.charCodeAt(a));)a++;else return r=3,i.substring(U,a);let F=a;if(a<i.length&&(i.charCodeAt(a)===69||i.charCodeAt(a)===101))if(a++,(a<i.length&&i.charCodeAt(a)===43||i.charCodeAt(a)===45)&&a++,a<i.length&&C(i.charCodeAt(a))){for(a++;a<i.length&&C(i.charCodeAt(a));)a++;F=a}else r=3;return i.substring(U,F)}function M(){let U="",F=a;for(;;){if(a>=u){U+=i.substring(F,a),r=2;break}const z=i.charCodeAt(a);if(z===34){U+=i.substring(F,a),a++;break}if(z===92){if(U+=i.substring(F,a),a++,a>=u){r=2;break}switch(i.charCodeAt(a++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const W=f(4);W>=0?U+=String.fromCharCode(W):r=4;break}default:r=5}F=a;continue}if(z>=0&&z<=31)if(S(z)){U+=i.substring(F,a),r=2;break}else r=6;a++}return U}function G(){if(c="",r=0,l=a,a>=u)return l=u,n=17;let U=i.charCodeAt(a);if(A(U)){do a++,c+=String.fromCharCode(U),U=i.charCodeAt(a);while(A(U));return n=15}if(S(U))return a++,c+=String.fromCharCode(U),U===13&&i.charCodeAt(a)===10&&(a++,c+=`
`),n=14;switch(U){case 123:return a++,n=1;case 125:return a++,n=2;case 91:return a++,n=3;case 93:return a++,n=4;case 58:return a++,n=6;case 44:return a++,n=5;case 34:return a++,c=M(),n=10;case 47:{const F=a-1;if(i.charCodeAt(a+1)===47){for(a+=2;a<u&&!S(i.charCodeAt(a));)a++;return c=i.substring(F,a),n=12}if(i.charCodeAt(a+1)===42){a+=2;const z=u-1;let B=!1;for(;a<z;){if(i.charCodeAt(a)===42&&i.charCodeAt(a+1)===47){a+=2,B=!0;break}a++}return B||(a++,r=1),c=i.substring(F,a),n=13}return c+=String.fromCharCode(U),a++,n=16}case 45:if(c+=String.fromCharCode(U),a++,a===u||!C(i.charCodeAt(a)))return n=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=T(),n=11;default:for(;a<u&&V(U);)a++,U=i.charCodeAt(a);if(l!==a){switch(c=i.substring(l,a),c){case"true":return n=8;case"false":return n=9;case"null":return n=7}return n=16}return c+=String.fromCharCode(U),a++,n=16}}function V(U){if(A(U)||S(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function N(){let U;do U=G();while(U>=12&&U<=15);return U}return{setPosition:E,getPosition:()=>a,scan:s?N:G,getToken:()=>n,getTokenValue:()=>c,getTokenOffset:()=>l,getTokenLength:()=>a-l,getTokenError:()=>r}}e.createScanner=I;function A(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function S(i){return i===10||i===13||i===8232||i===8233}function C(i){return i>=48&&i<=57}var L;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(L||(L={}));function P(i,s){const a=[],u=new Object;let c;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let n=!1;function r(f,E,T,M){l.value=f,l.offset=E,l.length=T,l.type=M,l.colonOffset=void 0,c=l}try{g(i,{onObjectBegin:(f,E)=>{if(s<=f)throw u;c=void 0,n=s>f,a.push("")},onObjectProperty:(f,E,T)=>{if(s<E||(r(f,E,T,"property"),a[a.length-1]=f,s<=E+T))throw u},onObjectEnd:(f,E)=>{if(s<=f)throw u;c=void 0,a.pop()},onArrayBegin:(f,E)=>{if(s<=f)throw u;c=void 0,a.push(0)},onArrayEnd:(f,E)=>{if(s<=f)throw u;c=void 0,a.pop()},onLiteralValue:(f,E,T)=>{if(s<E||(r(f,E,T,b(f)),s<=E+T))throw u},onSeparator:(f,E,T)=>{if(s<=E)throw u;if(f===":"&&c&&c.type==="property")c.colonOffset=E,n=!1,c=void 0;else if(f===","){const M=a[a.length-1];typeof M=="number"?a[a.length-1]=M+1:(n=!0,a[a.length-1]=""),c=void 0}}})}catch(f){if(f!==u)throw f}return{path:a,previousNode:c,isAtPropertyKey:n,matches:f=>{let E=0;for(let T=0;E<f.length&&T<a.length;T++)if(f[E]===a[T]||f[E]==="*")E++;else if(f[E]!=="**")return!1;return E===f.length}}}e.getLocation=P;function y(i,s=[],a=R.DEFAULT){let u=null,c=[];const l=[];function n(f){Array.isArray(c)?c.push(f):u!==null&&(c[u]=f)}return g(i,{onObjectBegin:()=>{const f={};n(f),l.push(c),c=f,u=null},onObjectProperty:f=>{u=f},onObjectEnd:()=>{c=l.pop()},onArrayBegin:()=>{const f=[];n(f),l.push(c),c=f,u=null},onArrayEnd:()=>{c=l.pop()},onLiteralValue:n,onError:(f,E,T)=>{s.push({error:f,offset:E,length:T})}},a),c[0]}e.parse=y;function D(i,s=[],a=R.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(f){u.type==="property"&&(u.length=f-u.offset,u=u.parent)}function l(f){return u.children.push(f),f}g(i,{onObjectBegin:f=>{u=l({type:"object",offset:f,length:-1,parent:u,children:[]})},onObjectProperty:(f,E,T)=>{u=l({type:"property",offset:E,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:f,offset:E,length:T,parent:u})},onObjectEnd:(f,E)=>{u.length=f+E-u.offset,u=u.parent,c(f+E)},onArrayBegin:(f,E)=>{u=l({type:"array",offset:f,length:-1,parent:u,children:[]})},onArrayEnd:(f,E)=>{u.length=f+E-u.offset,u=u.parent,c(f+E)},onLiteralValue:(f,E,T)=>{l({type:b(f),offset:E,length:T,parent:u,value:f}),c(E+T)},onSeparator:(f,E,T)=>{u.type==="property"&&(f===":"?u.colonOffset=E:f===","&&c(E))},onError:(f,E,T)=>{s.push({error:f,offset:E,length:T})}},a);const r=u.children[0];return r&&delete r.parent,r}e.parseTree=D;function v(i,s){if(!i)return;let a=i;for(const u of s)if(typeof u=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let c=!1;for(const l of a.children)if(Array.isArray(l.children)&&l.children[0].value===u){a=l.children[1],c=!0;break}if(!c)return}else{const c=u;if(a.type!=="array"||c<0||!Array.isArray(a.children)||c>=a.children.length)return;a=a.children[c]}return a}e.findNodeAtLocation=v;function d(i){if(!i.parent||!i.parent.children)return[];const s=d(i.parent);if(i.parent.type==="property"){const a=i.parent.children[0].value;s.push(a)}else if(i.parent.type==="array"){const a=i.parent.children.indexOf(i);a!==-1&&s.push(a)}return s}e.getNodePath=d;function m(i){switch(i.type){case"array":return i.children.map(m);case"object":{const s=Object.create(null);for(const a of i.children){const u=a.children[1];u&&(s[a.children[0].value]=m(u))}return s}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=m;function h(i,s,a=!1){return s>=i.offset&&s<i.offset+i.length||a&&s===i.offset+i.length}e.contains=h;function w(i,s,a=!1){if(h(i,s,a)){const u=i.children;if(Array.isArray(u))for(let c=0;c<u.length&&u[c].offset<=s;c++){const l=w(u[c],s,a);if(l)return l}return i}}e.findNodeAtOffset=w;function g(i,s,a=R.DEFAULT){const u=I(i,!1);function c(ge){return ge?()=>ge(u.getTokenOffset(),u.getTokenLength()):()=>!0}function l(ge){return ge?te=>ge(te,u.getTokenOffset(),u.getTokenLength()):()=>!0}const n=c(s.onObjectBegin),r=l(s.onObjectProperty),f=c(s.onObjectEnd),E=c(s.onArrayBegin),T=c(s.onArrayEnd),M=l(s.onLiteralValue),G=l(s.onSeparator),V=c(s.onComment),N=l(s.onError),U=a&&a.disallowComments,F=a&&a.allowTrailingComma;function z(){for(;;){const ge=u.scan();switch(u.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:U||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(ge){case 12:case 13:U?B(10):V();break;case 16:B(1);break;case 15:case 14:break;default:return ge}}}function B(ge,te=[],J=[]){if(N(ge),te.length+J.length>0){let fe=u.getToken();for(;fe!==17;){if(te.indexOf(fe)!==-1){z();break}else if(J.indexOf(fe)!==-1)break;fe=z()}}}function W(ge){const te=u.getTokenValue();return ge?M(te):r(te),z(),!0}function X(){switch(u.getToken()){case 11:{let ge=0;try{ge=JSON.parse(u.getTokenValue()),typeof ge!="number"&&(B(2),ge=0)}catch{B(2)}M(ge);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return z(),!0}function q(){return u.getToken()!==10?(B(3,[],[2,5]),!1):(W(!1),u.getToken()===6?(G(":"),z(),Z()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function _(){n(),z();let ge=!1;for(;u.getToken()!==2&&u.getToken()!==17;){if(u.getToken()===5){if(ge||B(4,[],[]),G(","),z(),u.getToken()===2&&F)break}else ge&&B(6,[],[]);q()||B(4,[],[2,5]),ge=!0}return f(),u.getToken()!==2?B(7,[2],[]):z(),!0}function Q(){E(),z();let ge=!1;for(;u.getToken()!==4&&u.getToken()!==17;){if(u.getToken()===5){if(ge||B(4,[],[]),G(","),z(),u.getToken()===4&&F)break}else ge&&B(6,[],[]);Z()||B(4,[],[4,5]),ge=!0}return T(),u.getToken()!==4?B(8,[4],[]):z(),!0}function Z(){switch(u.getToken()){case 3:return Q();case 1:return _();case 10:return W(!0);default:return X()}}return z(),u.getToken()===17?a.allowEmptyContent?!0:(B(4,[],[]),!1):Z()?(u.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}e.visit=g;function p(i,s){const a=I(i),u=[];let c,l=0,n;do switch(n=a.getPosition(),c=a.scan(),c){case 12:case 13:case 17:l!==n&&u.push(i.substring(l,n)),s!==void 0&&u.push(a.getTokenValue().replace(/[^\r\n]/g,s)),l=a.getPosition();break}while(c!==17);return u.join("")}e.stripComments=p;function b(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=b}),define(ye[82],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class o{constructor(k){this.d=k,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(k){this.c=k}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(k){return new o(()=>k(this.getValue()))}}e.Lazy=o}),define(ye[6],Ce([1,0,61,62]),function(ne,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let R=null;function I(l){R=l}if(e.setDisposableTracker=I,k){const l="__is_disposable_tracked__";I(new class{trackDisposable(n){const r=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[l]||console.log(r)},3e3)}setParent(n,r){if(n&&n!==w.None)try{n[l]=!0}catch{}}markAsDisposed(n){if(n&&n!==w.None)try{n[l]=!0}catch{}}markAsSingleton(n){}})}function A(l){return R?.trackDisposable(l),l}function S(l){R?.markAsDisposed(l)}function C(l,n){R?.setParent(l,n)}function L(l,n){if(!!R)for(const r of l)R.setParent(r,n)}function P(l){return R?.markAsSingleton(l),l}e.markAsSingleton=P;function y(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=y;function D(l){if(t.Iterable.is(l)){const n=[];for(const r of l)if(r)try{r.dispose()}catch(f){n.push(f)}if(n.length===1)throw n[0];if(n.length>1)throw new AggregateError(n,"Encountered errors while disposing of store");return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}e.dispose=D;function v(l){for(const n of l)y(n)&&n.dispose();return[]}e.disposeIfDisposable=v;function d(...l){const n=m(()=>D(l));return L(l,n),n}e.combinedDisposable=d;function m(l){const n=A({dispose:(0,o.once)(()=>{S(n),l()})});return n}e.toDisposable=m;class h{constructor(){this.c=new Set,this.f=!1,A(this)}dispose(){this.f||(S(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{D(this.c)}finally{this.c.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return C(n,this),this.f?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(n),n}}e.DisposableStore=h,h.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this.q=new h,A(this),C(this.q,this)}dispose(){S(this),this.q.dispose()}B(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(n)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class g{constructor(){this.b=!1,A(this)}get value(){return this.b?void 0:this.a}set value(n){this.b||n===this.a||(this.a?.dispose(),n&&C(n,this),this.a=n)}clear(){this.value=void 0}dispose(){this.b=!0,S(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const n=this.a;return this.a=void 0,n&&C(n,null),n}}e.MutableDisposable=g;class p{constructor(n){this.b=n,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=p;class b{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,A(this)}set(n){let r=n;return this.unset=()=>r=void 0,this.isset=()=>r!==void 0,this.dispose=()=>{r&&(r(),r=void 0,S(this))},this}}e.SafeDisposable=b;class i{constructor(){this.a=new Map}acquire(n,...r){let f=this.a.get(n);f||(f={counter:0,object:this.b(n,...r)},this.a.set(n,f));const{object:E}=f,T=(0,o.once)(()=>{--f.counter===0&&(this.c(n,f.object),this.a.delete(n))});return f.counter++,{object:E,dispose:T}}}e.ReferenceCollection=i;class s{constructor(n){this.a=n}async acquire(n,...r){const f=this.a.acquire(n,...r);try{return{object:await f.object,dispose:()=>f.dispose()}}catch(E){throw f.dispose(),E}}}e.AsyncReferenceCollection=s;class a{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=a;function u(l){const n=new h;try{l(n)}finally{n.dispose()}}e.disposeOnReturn=u;class c{constructor(){this.a=new Map,this.b=!1,A(this)}dispose(){S(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{D(this.a.values())}finally{this.a.clear()}}has(n){return this.a.has(n)}get(n){return this.a.get(n)}set(n,r,f=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),f||this.a.get(n)?.dispose(),this.a.set(n,r)}deleteAndDispose(n){this.a.get(n)?.dispose(),this.a.delete(n)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=c}),define(ye[63],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class o{constructor(R){this.element=R,this.next=o.Undefined,this.prev=o.Undefined}}o.Undefined=new o(void 0);class t{constructor(){this.a=o.Undefined,this.b=o.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===o.Undefined}clear(){let R=this.a;for(;R!==o.Undefined;){const I=R.next;R.prev=o.Undefined,R.next=o.Undefined,R=I}this.a=o.Undefined,this.b=o.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,I){const A=new o(R);if(this.a===o.Undefined)this.a=A,this.b=A;else if(I){const C=this.b;this.b=A,A.prev=C,C.next=A}else{const C=this.a;this.a=A,A.next=C,C.prev=A}this.c+=1;let S=!1;return()=>{S||(S=!0,this.e(A))}}shift(){if(this.a!==o.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==o.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==o.Undefined&&R.next!==o.Undefined){const I=R.prev;I.next=R.next,R.next.prev=I}else R.prev===o.Undefined&&R.next===o.Undefined?(this.a=o.Undefined,this.b=o.Undefined):R.next===o.Undefined?(this.b=this.b.prev,this.b.next=o.Undefined):R.prev===o.Undefined&&(this.a=this.a.next,this.a.prev=o.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==o.Undefined;)yield R.element,R=R.next}}e.LinkedList=t}),define(ye[28],Ce([1,0]),function(ne,e){"use strict";var o,t,k;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function R(v,d,m){let h=v.get(d);return h===void 0&&(h=m,v.set(d,h)),h}e.getOrSet=R;function I(v){const d=[];return v.forEach((m,h)=>{d.push(`${h} => ${m}`)}),`Map(${v.size}) {${d.join(", ")}}`}e.mapToString=I;function A(v){const d=[];return v.forEach(m=>{d.push(m)}),`Set(${v.size}) {${d.join(", ")}}`}e.setToString=A;class S{constructor(d,m){this.uri=d,this.value=m}}class C{constructor(d,m){this[o]="ResourceMap",d instanceof C?(this.b=new Map(d.b),this.c=m??C.a):(this.b=new Map,this.c=d??C.a)}set(d,m){return this.b.set(this.c(d),new S(d,m)),this}get(d){return this.b.get(this.c(d))?.value}has(d){return this.b.has(this.c(d))}get size(){return this.b.size}clear(){this.b.clear()}delete(d){return this.b.delete(this.c(d))}forEach(d,m){typeof m<"u"&&(d=d.bind(m));for(const[h,w]of this.b)d(w.value,w.uri,this)}*values(){for(const d of this.b.values())yield d.value}*keys(){for(const d of this.b.values())yield d.uri}*entries(){for(const d of this.b.values())yield[d.uri,d.value]}*[(o=Symbol.toStringTag,Symbol.iterator)](){for(const[,d]of this.b)yield[d.uri,d.value]}}e.ResourceMap=C,C.a=v=>v.toString();class L{constructor(d,m){this[t]="ResourceSet",!d||typeof d=="function"?this.a=new C(d):(this.a=new C(m),d.forEach(this.add,this))}get size(){return this.a.size}add(d){return this.a.set(d,d),this}clear(){this.a.clear()}delete(d){return this.a.delete(d)}forEach(d,m){this.a.forEach((h,w)=>d.call(m,w,w,this))}has(d){return this.a.has(d)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=L;var P;(function(v){v[v.None=0]="None",v[v.AsOld=1]="AsOld",v[v.AsNew=2]="AsNew"})(P=e.Touch||(e.Touch={}));class y{constructor(){this[k]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(d){return this.a.has(d)}get(d,m=0){const h=this.a.get(d);if(!!h)return m!==0&&this.j(h,m),h.value}set(d,m,h=0){let w=this.a.get(d);if(w)w.value=m,h!==0&&this.j(w,h);else{switch(w={key:d,value:m,next:void 0,previous:void 0},h){case 0:this.h(w);break;case 1:this.g(w);break;case 2:this.h(w);break;default:this.h(w);break}this.a.set(d,w),this.d++}return this}delete(d){return!!this.remove(d)}remove(d){const m=this.a.get(d);if(!!m)return this.a.delete(d),this.i(m),this.d--,m.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const d=this.b;return this.a.delete(d.key),this.i(d),this.d--,d.value}forEach(d,m){const h=this.e;let w=this.b;for(;w;){if(m?d.bind(m)(w.value,w.key,this):d(w.value,w.key,this),this.e!==h)throw new Error("LinkedMap got modified during iteration.");w=w.next}}keys(){const d=this,m=this.e;let h=this.b;const w={[Symbol.iterator](){return w},next(){if(d.e!==m)throw new Error("LinkedMap got modified during iteration.");if(h){const g={value:h.key,done:!1};return h=h.next,g}else return{value:void 0,done:!0}}};return w}values(){const d=this,m=this.e;let h=this.b;const w={[Symbol.iterator](){return w},next(){if(d.e!==m)throw new Error("LinkedMap got modified during iteration.");if(h){const g={value:h.value,done:!1};return h=h.next,g}else return{value:void 0,done:!0}}};return w}entries(){const d=this,m=this.e;let h=this.b;const w={[Symbol.iterator](){return w},next(){if(d.e!==m)throw new Error("LinkedMap got modified during iteration.");if(h){const g={value:[h.key,h.value],done:!1};return h=h.next,g}else return{value:void 0,done:!0}}};return w}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(d){if(d>=this.size)return;if(d===0){this.clear();return}let m=this.b,h=this.size;for(;m&&h>d;)this.a.delete(m.key),m=m.next,h--;this.b=m,this.d=h,m&&(m.previous=void 0),this.e++}g(d){if(!this.b&&!this.c)this.c=d;else if(this.b)d.next=this.b,this.b.previous=d;else throw new Error("Invalid list");this.b=d,this.e++}h(d){if(!this.b&&!this.c)this.b=d;else if(this.c)d.previous=this.c,this.c.next=d;else throw new Error("Invalid list");this.c=d,this.e++}i(d){if(d===this.b&&d===this.c)this.b=void 0,this.c=void 0;else if(d===this.b){if(!d.next)throw new Error("Invalid list");d.next.previous=void 0,this.b=d.next}else if(d===this.c){if(!d.previous)throw new Error("Invalid list");d.previous.next=void 0,this.c=d.previous}else{const m=d.next,h=d.previous;if(!m||!h)throw new Error("Invalid list");m.previous=h,h.next=m}d.next=void 0,d.previous=void 0,this.e++}j(d,m){if(!this.b||!this.c)throw new Error("Invalid list");if(!(m!==1&&m!==2)){if(m===1){if(d===this.b)return;const h=d.next,w=d.previous;d===this.c?(w.next=void 0,this.c=w):(h.previous=w,w.next=h),d.previous=void 0,d.next=this.b,this.b.previous=d,this.b=d,this.e++}else if(m===2){if(d===this.c)return;const h=d.next,w=d.previous;d===this.b?(h.previous=void 0,this.b=h):(h.previous=w,w.next=h),d.next=void 0,d.previous=this.c,this.c.next=d,this.c=d,this.e++}}}toJSON(){const d=[];return this.forEach((m,h)=>{d.push([h,m])}),d}fromJSON(d){this.clear();for(const[m,h]of d)this.set(m,h)}}e.LinkedMap=y;class D extends y{constructor(d,m=1){super(),this.k=d,this.l=Math.min(Math.max(0,m),1)}get limit(){return this.k}set limit(d){this.k=d,this.m()}get ratio(){return this.l}set ratio(d){this.l=Math.min(Math.max(0,d),1),this.m()}get(d,m=2){return super.get(d,m)}peek(d){return super.get(d,0)}set(d,m){return super.set(d,m,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=D}),function(ne,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(ye[147],Ce([0]),e):(ne=typeof globalThis<"u"?globalThis:ne||self,e(ne.marked={}))}(this,function(ne){"use strict";function e(se,le){for(var ue=0;ue<le.length;ue++){var ee=le[ue];ee.enumerable=ee.enumerable||!1,ee.configurable=!0,"value"in ee&&(ee.writable=!0),Object.defineProperty(se,ee.key,ee)}}function o(se,le,ue){return le&&e(se.prototype,le),ue&&e(se,ue),Object.defineProperty(se,"prototype",{writable:!1}),se}function t(se,le){if(!!se){if(typeof se=="string")return k(se,le);var ue=Object.prototype.toString.call(se).slice(8,-1);if(ue==="Object"&&se.constructor&&(ue=se.constructor.name),ue==="Map"||ue==="Set")return Array.from(se);if(ue==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ue))return k(se,le)}}function k(se,le){(le==null||le>se.length)&&(le=se.length);for(var ue=0,ee=new Array(le);ue<le;ue++)ee[ue]=se[ue];return ee}function R(se,le){var ue=typeof Symbol<"u"&&se[Symbol.iterator]||se["@@iterator"];if(ue)return(ue=ue.call(se)).next.bind(ue);if(Array.isArray(se)||(ue=t(se))||le&&se&&typeof se.length=="number"){ue&&(se=ue);var ee=0;return function(){return ee>=se.length?{done:!0}:{done:!1,value:se[ee++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function I(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ne.defaults=I();function A(se){ne.defaults=se}var S=/[&<>"']/,C=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,y={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},D=function(le){return y[le]};function v(se,le){if(le){if(S.test(se))return se.replace(C,D)}else if(L.test(se))return se.replace(P,D);return se}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(se){return se.replace(d,function(le,ue){return ue=ue.toLowerCase(),ue==="colon"?":":ue.charAt(0)==="#"?ue.charAt(1)==="x"?String.fromCharCode(parseInt(ue.substring(2),16)):String.fromCharCode(+ue.substring(1)):""})}var h=/(^|[^\[])\^/g;function w(se,le){se=typeof se=="string"?se:se.source,le=le||"";var ue={replace:function(ae,ie){return ie=ie.source||ie,ie=ie.replace(h,"$1"),se=se.replace(ae,ie),ue},getRegex:function(){return new RegExp(se,le)}};return ue}var g=/[^\w:]/g,p=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function b(se,le,ue){if(se){var ee;try{ee=decodeURIComponent(m(ue)).replace(g,"").toLowerCase()}catch{return null}if(ee.indexOf("javascript:")===0||ee.indexOf("vbscript:")===0||ee.indexOf("data:")===0)return null}le&&!p.test(ue)&&(ue=c(le,ue));try{ue=encodeURI(ue).replace(/%25/g,"%")}catch{return null}return ue}var i={},s=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(se,le){i[" "+se]||(s.test(se)?i[" "+se]=se+"/":i[" "+se]=f(se,"/",!0)),se=i[" "+se];var ue=se.indexOf(":")===-1;return le.substring(0,2)==="//"?ue?le:se.replace(a,"$1")+le:le.charAt(0)==="/"?ue?le:se.replace(u,"$1")+le:se+le}var l={exec:function(){}};function n(se){for(var le=1,ue,ee;le<arguments.length;le++){ue=arguments[le];for(ee in ue)Object.prototype.hasOwnProperty.call(ue,ee)&&(se[ee]=ue[ee])}return se}function r(se,le){var ue=se.replace(/\|/g,function(ie,O,H){for(var x=!1,Y=O;--Y>=0&&H[Y]==="\\";)x=!x;return x?"|":" |"}),ee=ue.split(/ \|/),ae=0;if(ee[0].trim()||ee.shift(),ee.length>0&&!ee[ee.length-1].trim()&&ee.pop(),ee.length>le)ee.splice(le);else for(;ee.length<le;)ee.push("");for(;ae<ee.length;ae++)ee[ae]=ee[ae].trim().replace(/\\\|/g,"|");return ee}function f(se,le,ue){var ee=se.length;if(ee===0)return"";for(var ae=0;ae<ee;){var ie=se.charAt(ee-ae-1);if(ie===le&&!ue)ae++;else if(ie!==le&&ue)ae++;else break}return se.slice(0,ee-ae)}function E(se,le){if(se.indexOf(le[1])===-1)return-1;for(var ue=se.length,ee=0,ae=0;ae<ue;ae++)if(se[ae]==="\\")ae++;else if(se[ae]===le[0])ee++;else if(se[ae]===le[1]&&(ee--,ee<0))return ae;return-1}function T(se){se&&se.sanitize&&!se.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function M(se,le){if(le<1)return"";for(var ue="";le>1;)le&1&&(ue+=se),le>>=1,se+=se;return ue+se}function G(se,le,ue,ee){var ae=le.href,ie=le.title?v(le.title):null,O=se[1].replace(/\\([\[\]])/g,"$1");if(se[0].charAt(0)!=="!"){ee.state.inLink=!0;var H={type:"link",raw:ue,href:ae,title:ie,text:O,tokens:ee.inlineTokens(O)};return ee.state.inLink=!1,H}return{type:"image",raw:ue,href:ae,title:ie,text:v(O)}}function V(se,le){var ue=se.match(/^(\s+)(?:```)/);if(ue===null)return le;var ee=ue[1];return le.split(`
`).map(function(ae){var ie=ae.match(/^\s+/);if(ie===null)return ae;var O=ie[0];return O.length>=ee.length?ae.slice(ee.length):ae}).join(`
`)}var N=function(){function se(ue){this.options=ue||ne.defaults}var le=se.prototype;return le.space=function(ee){var ae=this.rules.block.newline.exec(ee);if(ae&&ae[0].length>0)return{type:"space",raw:ae[0]}},le.code=function(ee){var ae=this.rules.block.code.exec(ee);if(ae){var ie=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?ie:f(ie,`
`)}}},le.fences=function(ee){var ae=this.rules.block.fences.exec(ee);if(ae){var ie=ae[0],O=V(ie,ae[3]||"");return{type:"code",raw:ie,lang:ae[2]?ae[2].trim():ae[2],text:O}}},le.heading=function(ee){var ae=this.rules.block.heading.exec(ee);if(ae){var ie=ae[2].trim();if(/#$/.test(ie)){var O=f(ie,"#");(this.options.pedantic||!O||/ $/.test(O))&&(ie=O.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:ie,tokens:this.lexer.inline(ie)}}},le.hr=function(ee){var ae=this.rules.block.hr.exec(ee);if(ae)return{type:"hr",raw:ae[0]}},le.blockquote=function(ee){var ae=this.rules.block.blockquote.exec(ee);if(ae){var ie=ae[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ae[0],tokens:this.lexer.blockTokens(ie,[]),text:ie}}},le.list=function(ee){var ae=this.rules.block.list.exec(ee);if(ae){var ie,O,H,x,Y,de,be,Pe,pe,De,ke,je,Ge=ae[1].trim(),et=Ge.length>1,_e={type:"list",raw:"",ordered:et,start:et?+Ge.slice(0,-1):"",loose:!1,items:[]};Ge=et?"\\d{1,9}\\"+Ge.slice(-1):"\\"+Ge,this.options.pedantic&&(Ge=et?Ge:"[*+-]");for(var nt=new RegExp("^( {0,3}"+Ge+")((?:[	 ][^\\n]*)?(?:\\n|$))");ee&&(je=!1,!(!(ae=nt.exec(ee))||this.rules.block.hr.test(ee)));){if(ie=ae[0],ee=ee.substring(ie.length),Pe=ae[2].split(`
`,1)[0],pe=ee.split(`
`,1)[0],this.options.pedantic?(x=2,ke=Pe.trimLeft()):(x=ae[2].search(/[^ ]/),x=x>4?1:x,ke=Pe.slice(x),x+=ae[1].length),de=!1,!Pe&&/^ *$/.test(pe)&&(ie+=pe+`
`,ee=ee.substring(pe.length+1),je=!0),!je)for(var st=new RegExp("^ {0,"+Math.min(3,x-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ht=new RegExp("^ {0,"+Math.min(3,x-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Me=new RegExp("^ {0,"+Math.min(3,x-1)+"}(?:```|~~~)"),it=new RegExp("^ {0,"+Math.min(3,x-1)+"}#");ee&&(De=ee.split(`
`,1)[0],Pe=De,this.options.pedantic&&(Pe=Pe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Me.test(Pe)||it.test(Pe)||st.test(Pe)||ht.test(ee)));){if(Pe.search(/[^ ]/)>=x||!Pe.trim())ke+=`
`+Pe.slice(x);else if(!de)ke+=`
`+Pe;else break;!de&&!Pe.trim()&&(de=!0),ie+=De+`
`,ee=ee.substring(De.length+1)}_e.loose||(be?_e.loose=!0:/\n *\n *$/.test(ie)&&(be=!0)),this.options.gfm&&(O=/^\[[ xX]\] /.exec(ke),O&&(H=O[0]!=="[ ] ",ke=ke.replace(/^\[[ xX]\] +/,""))),_e.items.push({type:"list_item",raw:ie,task:!!O,checked:H,loose:!1,text:ke}),_e.raw+=ie}_e.items[_e.items.length-1].raw=ie.trimRight(),_e.items[_e.items.length-1].text=ke.trimRight(),_e.raw=_e.raw.trimRight();var oe=_e.items.length;for(Y=0;Y<oe;Y++){this.lexer.state.top=!1,_e.items[Y].tokens=this.lexer.blockTokens(_e.items[Y].text,[]);var $=_e.items[Y].tokens.filter(function(Ie){return Ie.type==="space"}),ce=$.every(function(Ie){for(var Le=Ie.raw.split(""),Be=0,xe=R(Le),Ze;!(Ze=xe()).done;){var gt=Ze.value;if(gt===`
`&&(Be+=1),Be>1)return!0}return!1});!_e.loose&&$.length&&ce&&(_e.loose=!0,_e.items[Y].loose=!0)}return _e}},le.html=function(ee){var ae=this.rules.block.html.exec(ee);if(ae){var ie={type:"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:ae[0]};if(this.options.sanitize){var O=this.options.sanitizer?this.options.sanitizer(ae[0]):v(ae[0]);ie.type="paragraph",ie.text=O,ie.tokens=this.lexer.inline(O)}return ie}},le.def=function(ee){var ae=this.rules.block.def.exec(ee);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var ie=ae[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ie,raw:ae[0],href:ae[2],title:ae[3]}}},le.table=function(ee){var ae=this.rules.block.table.exec(ee);if(ae){var ie={type:"table",header:r(ae[1]).map(function(be){return{text:be}}),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ae[3]&&ae[3].trim()?ae[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ie.header.length===ie.align.length){ie.raw=ae[0];var O=ie.align.length,H,x,Y,de;for(H=0;H<O;H++)/^ *-+: *$/.test(ie.align[H])?ie.align[H]="right":/^ *:-+: *$/.test(ie.align[H])?ie.align[H]="center":/^ *:-+ *$/.test(ie.align[H])?ie.align[H]="left":ie.align[H]=null;for(O=ie.rows.length,H=0;H<O;H++)ie.rows[H]=r(ie.rows[H],ie.header.length).map(function(be){return{text:be}});for(O=ie.header.length,x=0;x<O;x++)ie.header[x].tokens=this.lexer.inline(ie.header[x].text);for(O=ie.rows.length,x=0;x<O;x++)for(de=ie.rows[x],Y=0;Y<de.length;Y++)de[Y].tokens=this.lexer.inline(de[Y].text);return ie}}},le.lheading=function(ee){var ae=this.rules.block.lheading.exec(ee);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1],tokens:this.lexer.inline(ae[1])}},le.paragraph=function(ee){var ae=this.rules.block.paragraph.exec(ee);if(ae){var ie=ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1];return{type:"paragraph",raw:ae[0],text:ie,tokens:this.lexer.inline(ie)}}},le.text=function(ee){var ae=this.rules.block.text.exec(ee);if(ae)return{type:"text",raw:ae[0],text:ae[0],tokens:this.lexer.inline(ae[0])}},le.escape=function(ee){var ae=this.rules.inline.escape.exec(ee);if(ae)return{type:"escape",raw:ae[0],text:v(ae[1])}},le.tag=function(ee){var ae=this.rules.inline.tag.exec(ee);if(ae)return!this.lexer.state.inLink&&/^<a /i.test(ae[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ae[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ae[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ae[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ae[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):v(ae[0]):ae[0]}},le.link=function(ee){var ae=this.rules.inline.link.exec(ee);if(ae){var ie=ae[2].trim();if(!this.options.pedantic&&/^</.test(ie)){if(!/>$/.test(ie))return;var O=f(ie.slice(0,-1),"\\");if((ie.length-O.length)%2===0)return}else{var H=E(ae[2],"()");if(H>-1){var x=ae[0].indexOf("!")===0?5:4,Y=x+ae[1].length+H;ae[2]=ae[2].substring(0,H),ae[0]=ae[0].substring(0,Y).trim(),ae[3]=""}}var de=ae[2],be="";if(this.options.pedantic){var Pe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(de);Pe&&(de=Pe[1],be=Pe[3])}else be=ae[3]?ae[3].slice(1,-1):"";return de=de.trim(),/^</.test(de)&&(this.options.pedantic&&!/>$/.test(ie)?de=de.slice(1):de=de.slice(1,-1)),G(ae,{href:de&&de.replace(this.rules.inline._escapes,"$1"),title:be&&be.replace(this.rules.inline._escapes,"$1")},ae[0],this.lexer)}},le.reflink=function(ee,ae){var ie;if((ie=this.rules.inline.reflink.exec(ee))||(ie=this.rules.inline.nolink.exec(ee))){var O=(ie[2]||ie[1]).replace(/\s+/g," ");if(O=ae[O.toLowerCase()],!O||!O.href){var H=ie[0].charAt(0);return{type:"text",raw:H,text:H}}return G(ie,O,ie[0],this.lexer)}},le.emStrong=function(ee,ae,ie){ie===void 0&&(ie="");var O=this.rules.inline.emStrong.lDelim.exec(ee);if(!!O&&!(O[3]&&ie.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var H=O[1]||O[2]||"";if(!H||H&&(ie===""||this.rules.inline.punctuation.exec(ie))){var x=O[0].length-1,Y,de,be=x,Pe=0,pe=O[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(pe.lastIndex=0,ae=ae.slice(-1*ee.length+x);(O=pe.exec(ae))!=null;)if(Y=O[1]||O[2]||O[3]||O[4]||O[5]||O[6],!!Y){if(de=Y.length,O[3]||O[4]){be+=de;continue}else if((O[5]||O[6])&&x%3&&!((x+de)%3)){Pe+=de;continue}if(be-=de,!(be>0)){if(de=Math.min(de,de+be+Pe),Math.min(x,de)%2){var De=ee.slice(1,x+O.index+de);return{type:"em",raw:ee.slice(0,x+O.index+de+1),text:De,tokens:this.lexer.inlineTokens(De)}}var ke=ee.slice(2,x+O.index+de-1);return{type:"strong",raw:ee.slice(0,x+O.index+de+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}}}}},le.codespan=function(ee){var ae=this.rules.inline.code.exec(ee);if(ae){var ie=ae[2].replace(/\n/g," "),O=/[^ ]/.test(ie),H=/^ /.test(ie)&&/ $/.test(ie);return O&&H&&(ie=ie.substring(1,ie.length-1)),ie=v(ie,!0),{type:"codespan",raw:ae[0],text:ie}}},le.br=function(ee){var ae=this.rules.inline.br.exec(ee);if(ae)return{type:"br",raw:ae[0]}},le.del=function(ee){var ae=this.rules.inline.del.exec(ee);if(ae)return{type:"del",raw:ae[0],text:ae[2],tokens:this.lexer.inlineTokens(ae[2])}},le.autolink=function(ee,ae){var ie=this.rules.inline.autolink.exec(ee);if(ie){var O,H;return ie[2]==="@"?(O=v(this.options.mangle?ae(ie[1]):ie[1]),H="mailto:"+O):(O=v(ie[1]),H=O),{type:"link",raw:ie[0],text:O,href:H,tokens:[{type:"text",raw:O,text:O}]}}},le.url=function(ee,ae){var ie;if(ie=this.rules.inline.url.exec(ee)){var O,H;if(ie[2]==="@")O=v(this.options.mangle?ae(ie[0]):ie[0]),H="mailto:"+O;else{var x;do x=ie[0],ie[0]=this.rules.inline._backpedal.exec(ie[0])[0];while(x!==ie[0]);O=v(ie[0]),ie[1]==="www."?H="http://"+O:H=O}return{type:"link",raw:ie[0],text:O,href:H,tokens:[{type:"text",raw:O,text:O}]}}},le.inlineText=function(ee,ae){var ie=this.rules.inline.text.exec(ee);if(ie){var O;return this.lexer.state.inRawBlock?O=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):v(ie[0]):ie[0]:O=v(this.options.smartypants?ae(ie[0]):ie[0]),{type:"text",raw:ie[0],text:O}}},se}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:l,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=w(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=w(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=w(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=w(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=w(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=w(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=n({},U),U.gfm=n({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=w(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=w(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=n({},U.normal,{html:w(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:l,paragraph:w(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var F={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:l,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:l,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};F._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",F.punctuation=w(F.punctuation).replace(/punctuation/g,F._punctuation).getRegex(),F.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,F.escapedEmSt=/\\\*|\\_/g,F._comment=w(U._comment).replace("(?:-->|$)","-->").getRegex(),F.emStrong.lDelim=w(F.emStrong.lDelim).replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimAst=w(F.emStrong.rDelimAst,"g").replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimUnd=w(F.emStrong.rDelimUnd,"g").replace(/punct/g,F._punctuation).getRegex(),F._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,F._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,F._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,F.autolink=w(F.autolink).replace("scheme",F._scheme).replace("email",F._email).getRegex(),F._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,F.tag=w(F.tag).replace("comment",F._comment).replace("attribute",F._attribute).getRegex(),F._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,F._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,F._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,F.link=w(F.link).replace("label",F._label).replace("href",F._href).replace("title",F._title).getRegex(),F.reflink=w(F.reflink).replace("label",F._label).replace("ref",U._label).getRegex(),F.nolink=w(F.nolink).replace("ref",U._label).getRegex(),F.reflinkSearch=w(F.reflinkSearch,"g").replace("reflink",F.reflink).replace("nolink",F.nolink).getRegex(),F.normal=n({},F),F.pedantic=n({},F.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:w(/^!?\[(label)\]\((.*?)\)/).replace("label",F._label).getRegex(),reflink:w(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",F._label).getRegex()}),F.gfm=n({},F.normal,{escape:w(F.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),F.gfm.url=w(F.gfm.url,"i").replace("email",F.gfm._extended_email).getRegex(),F.breaks=n({},F.gfm,{br:w(F.br).replace("{2,}","*").getRegex(),text:w(F.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function z(se){return se.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(se){var le="",ue,ee,ae=se.length;for(ue=0;ue<ae;ue++)ee=se.charCodeAt(ue),Math.random()>.5&&(ee="x"+ee.toString(16)),le+="&#"+ee+";";return le}var W=function(){function se(ue){this.tokens=[],this.tokens.links=Object.create(null),this.options=ue||ne.defaults,this.options.tokenizer=this.options.tokenizer||new N,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ee={block:U.normal,inline:F.normal};this.options.pedantic?(ee.block=U.pedantic,ee.inline=F.pedantic):this.options.gfm&&(ee.block=U.gfm,this.options.breaks?ee.inline=F.breaks:ee.inline=F.gfm),this.tokenizer.rules=ee}se.lex=function(ee,ae){var ie=new se(ae);return ie.lex(ee)},se.lexInline=function(ee,ae){var ie=new se(ae);return ie.inlineTokens(ee)};var le=se.prototype;return le.lex=function(ee){ee=ee.replace(/\r\n|\r/g,`
`),this.blockTokens(ee,this.tokens);for(var ae;ae=this.inlineQueue.shift();)this.inlineTokens(ae.src,ae.tokens);return this.tokens},le.blockTokens=function(ee,ae){var ie=this;ae===void 0&&(ae=[]),this.options.pedantic?ee=ee.replace(/\t/g,"    ").replace(/^ +$/gm,""):ee=ee.replace(/^( *)(\t+)/gm,function(be,Pe,pe){return Pe+"    ".repeat(pe.length)});for(var O,H,x,Y;ee;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(be){return(O=be.call({lexer:ie},ee,ae))?(ee=ee.substring(O.raw.length),ae.push(O),!0):!1}))){if(O=this.tokenizer.space(ee)){ee=ee.substring(O.raw.length),O.raw.length===1&&ae.length>0?ae[ae.length-1].raw+=`
`:ae.push(O);continue}if(O=this.tokenizer.code(ee)){ee=ee.substring(O.raw.length),H=ae[ae.length-1],H&&(H.type==="paragraph"||H.type==="text")?(H.raw+=`
`+O.raw,H.text+=`
`+O.text,this.inlineQueue[this.inlineQueue.length-1].src=H.text):ae.push(O);continue}if(O=this.tokenizer.fences(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.heading(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.hr(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.blockquote(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.list(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.html(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.def(ee)){ee=ee.substring(O.raw.length),H=ae[ae.length-1],H&&(H.type==="paragraph"||H.type==="text")?(H.raw+=`
`+O.raw,H.text+=`
`+O.raw,this.inlineQueue[this.inlineQueue.length-1].src=H.text):this.tokens.links[O.tag]||(this.tokens.links[O.tag]={href:O.href,title:O.title});continue}if(O=this.tokenizer.table(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.lheading(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(x=ee,this.options.extensions&&this.options.extensions.startBlock&&function(){var be=1/0,Pe=ee.slice(1),pe=void 0;ie.options.extensions.startBlock.forEach(function(De){pe=De.call({lexer:this},Pe),typeof pe=="number"&&pe>=0&&(be=Math.min(be,pe))}),be<1/0&&be>=0&&(x=ee.substring(0,be+1))}(),this.state.top&&(O=this.tokenizer.paragraph(x))){H=ae[ae.length-1],Y&&H.type==="paragraph"?(H.raw+=`
`+O.raw,H.text+=`
`+O.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=H.text):ae.push(O),Y=x.length!==ee.length,ee=ee.substring(O.raw.length);continue}if(O=this.tokenizer.text(ee)){ee=ee.substring(O.raw.length),H=ae[ae.length-1],H&&H.type==="text"?(H.raw+=`
`+O.raw,H.text+=`
`+O.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=H.text):ae.push(O);continue}if(ee){var de="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(de);break}else throw new Error(de)}}return this.state.top=!0,ae},le.inline=function(ee,ae){return ae===void 0&&(ae=[]),this.inlineQueue.push({src:ee,tokens:ae}),ae},le.inlineTokens=function(ee,ae){var ie=this;ae===void 0&&(ae=[]);var O,H,x,Y=ee,de,be,Pe;if(this.tokens.links){var pe=Object.keys(this.tokens.links);if(pe.length>0)for(;(de=this.tokenizer.rules.inline.reflinkSearch.exec(Y))!=null;)pe.includes(de[0].slice(de[0].lastIndexOf("[")+1,-1))&&(Y=Y.slice(0,de.index)+"["+M("a",de[0].length-2)+"]"+Y.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(de=this.tokenizer.rules.inline.blockSkip.exec(Y))!=null;)Y=Y.slice(0,de.index)+"["+M("a",de[0].length-2)+"]"+Y.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(de=this.tokenizer.rules.inline.escapedEmSt.exec(Y))!=null;)Y=Y.slice(0,de.index)+"++"+Y.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ee;)if(be||(Pe=""),be=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ke){return(O=ke.call({lexer:ie},ee,ae))?(ee=ee.substring(O.raw.length),ae.push(O),!0):!1}))){if(O=this.tokenizer.escape(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.tag(ee)){ee=ee.substring(O.raw.length),H=ae[ae.length-1],H&&O.type==="text"&&H.type==="text"?(H.raw+=O.raw,H.text+=O.text):ae.push(O);continue}if(O=this.tokenizer.link(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.reflink(ee,this.tokens.links)){ee=ee.substring(O.raw.length),H=ae[ae.length-1],H&&O.type==="text"&&H.type==="text"?(H.raw+=O.raw,H.text+=O.text):ae.push(O);continue}if(O=this.tokenizer.emStrong(ee,Y,Pe)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.codespan(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.br(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.del(ee)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(O=this.tokenizer.autolink(ee,B)){ee=ee.substring(O.raw.length),ae.push(O);continue}if(!this.state.inLink&&(O=this.tokenizer.url(ee,B))){ee=ee.substring(O.raw.length),ae.push(O);continue}if(x=ee,this.options.extensions&&this.options.extensions.startInline&&function(){var ke=1/0,je=ee.slice(1),Ge=void 0;ie.options.extensions.startInline.forEach(function(et){Ge=et.call({lexer:this},je),typeof Ge=="number"&&Ge>=0&&(ke=Math.min(ke,Ge))}),ke<1/0&&ke>=0&&(x=ee.substring(0,ke+1))}(),O=this.tokenizer.inlineText(x,z)){ee=ee.substring(O.raw.length),O.raw.slice(-1)!=="_"&&(Pe=O.raw.slice(-1)),be=!0,H=ae[ae.length-1],H&&H.type==="text"?(H.raw+=O.raw,H.text+=O.text):ae.push(O);continue}if(ee){var De="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return ae},o(se,null,[{key:"rules",get:function(){return{block:U,inline:F}}}]),se}(),X=function(){function se(ue){this.options=ue||ne.defaults}var le=se.prototype;return le.code=function(ee,ae,ie){var O=(ae||"").match(/\S*/)[0];if(this.options.highlight){var H=this.options.highlight(ee,O);H!=null&&H!==ee&&(ie=!0,ee=H)}return ee=ee.replace(/\n$/,"")+`
`,O?'<pre><code class="'+this.options.langPrefix+v(O,!0)+'">'+(ie?ee:v(ee,!0))+`</code></pre>
`:"<pre><code>"+(ie?ee:v(ee,!0))+`</code></pre>
`},le.blockquote=function(ee){return`<blockquote>
`+ee+`</blockquote>
`},le.html=function(ee){return ee},le.heading=function(ee,ae,ie,O){if(this.options.headerIds){var H=this.options.headerPrefix+O.slug(ie);return"<h"+ae+' id="'+H+'">'+ee+"</h"+ae+`>
`}return"<h"+ae+">"+ee+"</h"+ae+`>
`},le.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},le.list=function(ee,ae,ie){var O=ae?"ol":"ul",H=ae&&ie!==1?' start="'+ie+'"':"";return"<"+O+H+`>
`+ee+"</"+O+`>
`},le.listitem=function(ee){return"<li>"+ee+`</li>
`},le.checkbox=function(ee){return"<input "+(ee?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},le.paragraph=function(ee){return"<p>"+ee+`</p>
`},le.table=function(ee,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+ee+`</thead>
`+ae+`</table>
`},le.tablerow=function(ee){return`<tr>
`+ee+`</tr>
`},le.tablecell=function(ee,ae){var ie=ae.header?"th":"td",O=ae.align?"<"+ie+' align="'+ae.align+'">':"<"+ie+">";return O+ee+("</"+ie+`>
`)},le.strong=function(ee){return"<strong>"+ee+"</strong>"},le.em=function(ee){return"<em>"+ee+"</em>"},le.codespan=function(ee){return"<code>"+ee+"</code>"},le.br=function(){return this.options.xhtml?"<br/>":"<br>"},le.del=function(ee){return"<del>"+ee+"</del>"},le.link=function(ee,ae,ie){if(ee=b(this.options.sanitize,this.options.baseUrl,ee),ee===null)return ie;var O='<a href="'+v(ee)+'"';return ae&&(O+=' title="'+ae+'"'),O+=">"+ie+"</a>",O},le.image=function(ee,ae,ie){if(ee=b(this.options.sanitize,this.options.baseUrl,ee),ee===null)return ie;var O='<img src="'+ee+'" alt="'+ie+'"';return ae&&(O+=' title="'+ae+'"'),O+=this.options.xhtml?"/>":">",O},le.text=function(ee){return ee},se}(),q=function(){function se(){}var le=se.prototype;return le.strong=function(ee){return ee},le.em=function(ee){return ee},le.codespan=function(ee){return ee},le.del=function(ee){return ee},le.html=function(ee){return ee},le.text=function(ee){return ee},le.link=function(ee,ae,ie){return""+ie},le.image=function(ee,ae,ie){return""+ie},le.br=function(){return""},se}(),_=function(){function se(){this.seen={}}var le=se.prototype;return le.serialize=function(ee){return ee.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},le.getNextSafeSlug=function(ee,ae){var ie=ee,O=0;if(this.seen.hasOwnProperty(ie)){O=this.seen[ee];do O++,ie=ee+"-"+O;while(this.seen.hasOwnProperty(ie))}return ae||(this.seen[ee]=O,this.seen[ie]=0),ie},le.slug=function(ee,ae){ae===void 0&&(ae={});var ie=this.serialize(ee);return this.getNextSafeSlug(ie,ae.dryrun)},se}(),Q=function(){function se(ue){this.options=ue||ne.defaults,this.options.renderer=this.options.renderer||new X,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new q,this.slugger=new _}se.parse=function(ee,ae){var ie=new se(ae);return ie.parse(ee)},se.parseInline=function(ee,ae){var ie=new se(ae);return ie.parseInline(ee)};var le=se.prototype;return le.parse=function(ee,ae){ae===void 0&&(ae=!0);var ie="",O,H,x,Y,de,be,Pe,pe,De,ke,je,Ge,et,_e,nt,st,ht,Me,it,oe=ee.length;for(O=0;O<oe;O++){if(ke=ee[O],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&(it=this.options.extensions.renderers[ke.type].call({parser:this},ke),it!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ke.type))){ie+=it||"";continue}switch(ke.type){case"space":continue;case"hr":{ie+=this.renderer.hr();continue}case"heading":{ie+=this.renderer.heading(this.parseInline(ke.tokens),ke.depth,m(this.parseInline(ke.tokens,this.textRenderer)),this.slugger);continue}case"code":{ie+=this.renderer.code(ke.text,ke.lang,ke.escaped);continue}case"table":{for(pe="",Pe="",Y=ke.header.length,H=0;H<Y;H++)Pe+=this.renderer.tablecell(this.parseInline(ke.header[H].tokens),{header:!0,align:ke.align[H]});for(pe+=this.renderer.tablerow(Pe),De="",Y=ke.rows.length,H=0;H<Y;H++){for(be=ke.rows[H],Pe="",de=be.length,x=0;x<de;x++)Pe+=this.renderer.tablecell(this.parseInline(be[x].tokens),{header:!1,align:ke.align[x]});De+=this.renderer.tablerow(Pe)}ie+=this.renderer.table(pe,De);continue}case"blockquote":{De=this.parse(ke.tokens),ie+=this.renderer.blockquote(De);continue}case"list":{for(je=ke.ordered,Ge=ke.start,et=ke.loose,Y=ke.items.length,De="",H=0;H<Y;H++)nt=ke.items[H],st=nt.checked,ht=nt.task,_e="",nt.task&&(Me=this.renderer.checkbox(st),et?nt.tokens.length>0&&nt.tokens[0].type==="paragraph"?(nt.tokens[0].text=Me+" "+nt.tokens[0].text,nt.tokens[0].tokens&&nt.tokens[0].tokens.length>0&&nt.tokens[0].tokens[0].type==="text"&&(nt.tokens[0].tokens[0].text=Me+" "+nt.tokens[0].tokens[0].text)):nt.tokens.unshift({type:"text",text:Me}):_e+=Me),_e+=this.parse(nt.tokens,et),De+=this.renderer.listitem(_e,ht,st);ie+=this.renderer.list(De,je,Ge);continue}case"html":{ie+=this.renderer.html(ke.text);continue}case"paragraph":{ie+=this.renderer.paragraph(this.parseInline(ke.tokens));continue}case"text":{for(De=ke.tokens?this.parseInline(ke.tokens):ke.text;O+1<oe&&ee[O+1].type==="text";)ke=ee[++O],De+=`
`+(ke.tokens?this.parseInline(ke.tokens):ke.text);ie+=ae?this.renderer.paragraph(De):De;continue}default:{var $='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error($);return}else throw new Error($)}}}return ie},le.parseInline=function(ee,ae){ae=ae||this.renderer;var ie="",O,H,x,Y=ee.length;for(O=0;O<Y;O++){if(H=ee[O],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(x=this.options.extensions.renderers[H.type].call({parser:this},H),x!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(H.type))){ie+=x||"";continue}switch(H.type){case"escape":{ie+=ae.text(H.text);break}case"html":{ie+=ae.html(H.text);break}case"link":{ie+=ae.link(H.href,H.title,this.parseInline(H.tokens,ae));break}case"image":{ie+=ae.image(H.href,H.title,H.text);break}case"strong":{ie+=ae.strong(this.parseInline(H.tokens,ae));break}case"em":{ie+=ae.em(this.parseInline(H.tokens,ae));break}case"codespan":{ie+=ae.codespan(H.text);break}case"br":{ie+=ae.br();break}case"del":{ie+=ae.del(this.parseInline(H.tokens,ae));break}case"text":{ie+=ae.text(H.text);break}default:{var de='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(de);return}else throw new Error(de)}}}return ie},se}();function Z(se,le,ue){if(typeof se>"u"||se===null)throw new Error("marked(): input parameter is undefined or null");if(typeof se!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(se)+", string expected");if(typeof le=="function"&&(ue=le,le=null),le=n({},Z.defaults,le||{}),T(le),ue){var ee=le.highlight,ae;try{ae=W.lex(se,le)}catch(Y){return ue(Y)}var ie=function(de){var be;if(!de)try{le.walkTokens&&Z.walkTokens(ae,le.walkTokens),be=Q.parse(ae,le)}catch(Pe){de=Pe}return le.highlight=ee,de?ue(de):ue(null,be)};if(!ee||ee.length<3||(delete le.highlight,!ae.length))return ie();var O=0;Z.walkTokens(ae,function(Y){Y.type==="code"&&(O++,setTimeout(function(){ee(Y.text,Y.lang,function(de,be){if(de)return ie(de);be!=null&&be!==Y.text&&(Y.text=be,Y.escaped=!0),O--,O===0&&ie()})},0))}),O===0&&ie();return}function H(Y){if(Y.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+v(Y.message+"",!0)+"</pre>";throw Y}try{var x=W.lex(se,le);if(le.walkTokens){if(le.async)return Promise.all(Z.walkTokens(x,le.walkTokens)).then(function(){return Q.parse(x,le)}).catch(H);Z.walkTokens(x,le.walkTokens)}return Q.parse(x,le)}catch(Y){H(Y)}}Z.options=Z.setOptions=function(se){return n(Z.defaults,se),A(Z.defaults),Z},Z.getDefaults=I,Z.defaults=ne.defaults,Z.use=function(){for(var se=arguments.length,le=new Array(se),ue=0;ue<se;ue++)le[ue]=arguments[ue];var ee=n.apply(void 0,[{}].concat(le)),ae=Z.defaults.extensions||{renderers:{},childTokens:{}},ie;le.forEach(function(O){if(O.extensions&&(ie=!0,O.extensions.forEach(function(x){if(!x.name)throw new Error("extension name required");if(x.renderer){var Y=ae.renderers?ae.renderers[x.name]:null;Y?ae.renderers[x.name]=function(){for(var de=arguments.length,be=new Array(de),Pe=0;Pe<de;Pe++)be[Pe]=arguments[Pe];var pe=x.renderer.apply(this,be);return pe===!1&&(pe=Y.apply(this,be)),pe}:ae.renderers[x.name]=x.renderer}if(x.tokenizer){if(!x.level||x.level!=="block"&&x.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ae[x.level]?ae[x.level].unshift(x.tokenizer):ae[x.level]=[x.tokenizer],x.start&&(x.level==="block"?ae.startBlock?ae.startBlock.push(x.start):ae.startBlock=[x.start]:x.level==="inline"&&(ae.startInline?ae.startInline.push(x.start):ae.startInline=[x.start]))}x.childTokens&&(ae.childTokens[x.name]=x.childTokens)})),O.renderer&&function(){var x=Z.defaults.renderer||new X,Y=function(Pe){var pe=x[Pe];x[Pe]=function(){for(var De=arguments.length,ke=new Array(De),je=0;je<De;je++)ke[je]=arguments[je];var Ge=O.renderer[Pe].apply(x,ke);return Ge===!1&&(Ge=pe.apply(x,ke)),Ge}};for(var de in O.renderer)Y(de);ee.renderer=x}(),O.tokenizer&&function(){var x=Z.defaults.tokenizer||new N,Y=function(Pe){var pe=x[Pe];x[Pe]=function(){for(var De=arguments.length,ke=new Array(De),je=0;je<De;je++)ke[je]=arguments[je];var Ge=O.tokenizer[Pe].apply(x,ke);return Ge===!1&&(Ge=pe.apply(x,ke)),Ge}};for(var de in O.tokenizer)Y(de);ee.tokenizer=x}(),O.walkTokens){var H=Z.defaults.walkTokens;ee.walkTokens=function(x){var Y=[];return Y.push(O.walkTokens.call(this,x)),H&&(Y=Y.concat(H.call(this,x))),Y}}ie&&(ee.extensions=ae),Z.setOptions(ee)})},Z.walkTokens=function(se,le){for(var ue=[],ee=function(){var H=ie.value;switch(ue=ue.concat(le.call(Z,H)),H.type){case"table":{for(var x=R(H.header),Y;!(Y=x()).done;){var de=Y.value;ue=ue.concat(Z.walkTokens(de.tokens,le))}for(var be=R(H.rows),Pe;!(Pe=be()).done;)for(var pe=Pe.value,De=R(pe),ke;!(ke=De()).done;){var je=ke.value;ue=ue.concat(Z.walkTokens(je.tokens,le))}break}case"list":{ue=ue.concat(Z.walkTokens(H.items,le));break}default:Z.defaults.extensions&&Z.defaults.extensions.childTokens&&Z.defaults.extensions.childTokens[H.type]?Z.defaults.extensions.childTokens[H.type].forEach(function(Ge){ue=ue.concat(Z.walkTokens(H[Ge],le))}):H.tokens&&(ue=ue.concat(Z.walkTokens(H.tokens,le)))}},ae=R(se),ie;!(ie=ae()).done;)ee();return ue},Z.parseInline=function(se,le){if(typeof se>"u"||se===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof se!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(se)+", string expected");le=n({},Z.defaults,le||{}),T(le);try{var ue=W.lexInline(se,le);return le.walkTokens&&Z.walkTokens(ue,le.walkTokens),Q.parseInline(ue,le)}catch(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+v(ee.message+"",!0)+"</pre>";throw ee}},Z.Parser=Q,Z.parser=Q.parse,Z.Renderer=X,Z.TextRenderer=q,Z.Lexer=W,Z.lexer=W.lex,Z.Tokenizer=N,Z.Slugger=_,Z.parse=Z;var ge=Z.options,te=Z.setOptions,J=Z.use,fe=Z.walkTokens,ve=Z.parseInline,Ee=Z,Ae=Q.parse,Fe=W.lex;ne.Lexer=W,ne.Parser=Q,ne.Renderer=X,ne.Slugger=_,ne.TextRenderer=q,ne.Tokenizer=N,ne.getDefaults=I,ne.lexer=Fe,ne.marked=Z,ne.options=ge,ne.parse=Ee,ne.parseInline=ve,ne.parser=Ae,ne.setOptions=te,ne.use=J,ne.walkTokens=fe,Object.defineProperty(ne,"__esModule",{value:!0})}),define(ye[83],Ce([1,0,28]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new o.LRUCache(1e4);function k(C){return S(C,"NFC",t)}e.normalizeNFC=k;const R=new o.LRUCache(1e4);function I(C){return S(C,"NFD",R)}e.normalizeNFD=I;const A=/[^\u0000-\u0080]/;function S(C,L,P){if(!C)return C;const y=P.get(C);if(y)return y;let D;return A.test(C)?D=C.normalize(L):D=C,P.set(C,D),D}e.removeAccents=function(){const C=/[\u0300-\u036f]/g;return function(L){return I(L).replace(C,"")}}()}),define(ye[101],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function o(A,S,C){return Math.min(Math.max(A,S),C)}e.clamp=o;function t(A,S){return(S+A%S)%S}e.rot=t;class k{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=k;class R{constructor(){this.a=1,this.b=0}update(S){return this.b=this.b+(S-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=R;class I{constructor(S){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(S),this.c.fill(0,0,S)}update(S){const C=this.c[this.d];return this.c[this.d]=S,this.d=(this.d+1)%this.c.length,this.e-=C,this.e+=S,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=I}),function(){function ne(k){const R=[];typeof k=="number"&&R.push("code/timeOrigin",k);function I(S){R.push(S,Date.now())}function A(){const S=[];for(let C=0;C<R.length;C+=2)S.push({name:R[C],startTime:R[C+1]});return S}return{mark:I,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const I of performance.getEntriesByType("mark"))R.push({name:I.name,startTime:Math.round(k+I.startTime)});return R}};if(typeof process=="object"){const k=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function o(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return o(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=o(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=o(t))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var o=e();for(var t in o)(typeof exports=="object"?exports:ne)[t]=o[t]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function o(t){if(e[t])return e[t].exports;var k=e[t]={i:t,l:!1,exports:{}};return ne[t].call(k.exports,k,k.exports,o),k.l=!0,k.exports}return o.m=ne,o.c=e,o.d=function(t,k,R){o.o(t,k)||Object.defineProperty(t,k,{enumerable:!0,get:R})},o.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},o.t=function(t,k){if(1&k&&(t=o(t)),8&k||4&k&&typeof t=="object"&&t&&t.__esModule)return t;var R=Object.create(null);if(o.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:t}),2&k&&typeof t!="string")for(var I in t)o.d(R,I,function(A){return t[A]}.bind(null,I));return R},o.n=function(t){var k=t&&t.__esModule?function(){return t.default}:function(){return t};return o.d(k,"a",k),k},o.o=function(t,k){return Object.prototype.hasOwnProperty.call(t,k)},o.p="",o(o.s=0)}([function(ne,e,o){(function(t){var k;e=ne.exports=J,k=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var pe=Array.prototype.slice.call(arguments,0);pe.unshift("SEMVER"),console.log.apply(console,pe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,I=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],S=e.src=[],C=0,L=C++;S[L]="0|[1-9]\\d*";var P=C++;S[P]="[0-9]+";var y=C++;S[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var D=C++;S[D]="("+S[L]+")\\.("+S[L]+")\\.("+S[L]+")";var v=C++;S[v]="("+S[P]+")\\.("+S[P]+")\\.("+S[P]+")";var d=C++;S[d]="(?:"+S[L]+"|"+S[y]+")";var m=C++;S[m]="(?:"+S[P]+"|"+S[y]+")";var h=C++;S[h]="(?:-("+S[d]+"(?:\\."+S[d]+")*))";var w=C++;S[w]="(?:-?("+S[m]+"(?:\\."+S[m]+")*))";var g=C++;S[g]="[0-9A-Za-z-]+";var p=C++;S[p]="(?:\\+("+S[g]+"(?:\\."+S[g]+")*))";var b=C++,i="v?"+S[D]+S[h]+"?"+S[p]+"?";S[b]="^"+i+"$";var s="[v=\\s]*"+S[v]+S[w]+"?"+S[p]+"?",a=C++;S[a]="^"+s+"$";var u=C++;S[u]="((?:<|>)?=?)";var c=C++;S[c]=S[P]+"|x|X|\\*";var l=C++;S[l]=S[L]+"|x|X|\\*";var n=C++;S[n]="[v=\\s]*("+S[l]+")(?:\\.("+S[l]+")(?:\\.("+S[l]+")(?:"+S[h]+")?"+S[p]+"?)?)?";var r=C++;S[r]="[v=\\s]*("+S[c]+")(?:\\.("+S[c]+")(?:\\.("+S[c]+")(?:"+S[w]+")?"+S[p]+"?)?)?";var f=C++;S[f]="^"+S[u]+"\\s*"+S[n]+"$";var E=C++;S[E]="^"+S[u]+"\\s*"+S[r]+"$";var T=C++;S[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=C++;S[M]="(?:~>?)";var G=C++;S[G]="(\\s*)"+S[M]+"\\s+",A[G]=new RegExp(S[G],"g");var V=C++;S[V]="^"+S[M]+S[n]+"$";var N=C++;S[N]="^"+S[M]+S[r]+"$";var U=C++;S[U]="(?:\\^)";var F=C++;S[F]="(\\s*)"+S[U]+"\\s+",A[F]=new RegExp(S[F],"g");var z=C++;S[z]="^"+S[U]+S[n]+"$";var B=C++;S[B]="^"+S[U]+S[r]+"$";var W=C++;S[W]="^"+S[u]+"\\s*("+s+")$|^$";var X=C++;S[X]="^"+S[u]+"\\s*("+i+")$|^$";var q=C++;S[q]="(\\s*)"+S[u]+"\\s*("+s+"|"+S[n]+")",A[q]=new RegExp(S[q],"g");var _=C++;S[_]="^\\s*("+S[n]+")\\s+-\\s+("+S[n]+")\\s*$";var Q=C++;S[Q]="^\\s*("+S[r]+")\\s+-\\s+("+S[r]+")\\s*$";var Z=C++;S[Z]="(<|>)?=?\\s*\\*";for(var ge=0;ge<35;ge++)k(ge,S[ge]),A[ge]||(A[ge]=new RegExp(S[ge]));function te(pe,De){if(pe instanceof J)return pe;if(typeof pe!="string"||pe.length>R||!(De?A[a]:A[b]).test(pe))return null;try{return new J(pe,De)}catch{return null}}function J(pe,De){if(pe instanceof J){if(pe.loose===De)return pe;pe=pe.version}else if(typeof pe!="string")throw new TypeError("Invalid Version: "+pe);if(pe.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof J))return new J(pe,De);k("SemVer",pe,De),this.loose=De;var ke=pe.trim().match(De?A[a]:A[b]);if(!ke)throw new TypeError("Invalid Version: "+pe);if(this.raw=pe,this.major=+ke[1],this.minor=+ke[2],this.patch=+ke[3],this.major>I||this.major<0)throw new TypeError("Invalid major version");if(this.minor>I||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>I||this.patch<0)throw new TypeError("Invalid patch version");ke[4]?this.prerelease=ke[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var Ge=+je;if(Ge>=0&&Ge<I)return Ge}return je}):this.prerelease=[],this.build=ke[5]?ke[5].split("."):[],this.format()}e.parse=te,e.valid=function(pe,De){var ke=te(pe,De);return ke?ke.version:null},e.clean=function(pe,De){var ke=te(pe.trim().replace(/^[=v]+/,""),De);return ke?ke.version:null},e.SemVer=J,J.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},J.prototype.toString=function(){return this.version},J.prototype.compare=function(pe){return k("SemVer.compare",this.version,this.loose,pe),pe instanceof J||(pe=new J(pe,this.loose)),this.compareMain(pe)||this.comparePre(pe)},J.prototype.compareMain=function(pe){return pe instanceof J||(pe=new J(pe,this.loose)),ve(this.major,pe.major)||ve(this.minor,pe.minor)||ve(this.patch,pe.patch)},J.prototype.comparePre=function(pe){if(pe instanceof J||(pe=new J(pe,this.loose)),this.prerelease.length&&!pe.prerelease.length)return-1;if(!this.prerelease.length&&pe.prerelease.length)return 1;if(!this.prerelease.length&&!pe.prerelease.length)return 0;var De=0;do{var ke=this.prerelease[De],je=pe.prerelease[De];if(k("prerelease compare",De,ke,je),ke===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(ke===void 0)return-1;if(ke!==je)return ve(ke,je)}while(++De)},J.prototype.inc=function(pe,De){switch(pe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",De);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",De);break;case"prepatch":this.prerelease.length=0,this.inc("patch",De),this.inc("pre",De);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",De),this.inc("pre",De);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ke=this.prerelease.length;--ke>=0;)typeof this.prerelease[ke]=="number"&&(this.prerelease[ke]++,ke=-2);ke===-1&&this.prerelease.push(0)}De&&(this.prerelease[0]===De?isNaN(this.prerelease[1])&&(this.prerelease=[De,0]):this.prerelease=[De,0]);break;default:throw new Error("invalid increment argument: "+pe)}return this.format(),this.raw=this.version,this},e.inc=function(pe,De,ke,je){typeof ke=="string"&&(je=ke,ke=void 0);try{return new J(pe,ke).inc(De,je).version}catch{return null}},e.diff=function(pe,De){if(se(pe,De))return null;var ke=te(pe),je=te(De);if(ke.prerelease.length||je.prerelease.length){for(var Ge in ke)if((Ge==="major"||Ge==="minor"||Ge==="patch")&&ke[Ge]!==je[Ge])return"pre"+Ge;return"prerelease"}for(var Ge in ke)if((Ge==="major"||Ge==="minor"||Ge==="patch")&&ke[Ge]!==je[Ge])return Ge},e.compareIdentifiers=ve;var fe=/^[0-9]+$/;function ve(pe,De){var ke=fe.test(pe),je=fe.test(De);return ke&&je&&(pe=+pe,De=+De),ke&&!je?-1:je&&!ke?1:pe<De?-1:pe>De?1:0}function Ee(pe,De,ke){return new J(pe,ke).compare(new J(De,ke))}function Ae(pe,De,ke){return Ee(pe,De,ke)>0}function Fe(pe,De,ke){return Ee(pe,De,ke)<0}function se(pe,De,ke){return Ee(pe,De,ke)===0}function le(pe,De,ke){return Ee(pe,De,ke)!==0}function ue(pe,De,ke){return Ee(pe,De,ke)>=0}function ee(pe,De,ke){return Ee(pe,De,ke)<=0}function ae(pe,De,ke,je){var Ge;switch(De){case"===":typeof pe=="object"&&(pe=pe.version),typeof ke=="object"&&(ke=ke.version),Ge=pe===ke;break;case"!==":typeof pe=="object"&&(pe=pe.version),typeof ke=="object"&&(ke=ke.version),Ge=pe!==ke;break;case"":case"=":case"==":Ge=se(pe,ke,je);break;case"!=":Ge=le(pe,ke,je);break;case">":Ge=Ae(pe,ke,je);break;case">=":Ge=ue(pe,ke,je);break;case"<":Ge=Fe(pe,ke,je);break;case"<=":Ge=ee(pe,ke,je);break;default:throw new TypeError("Invalid operator: "+De)}return Ge}function ie(pe,De){if(pe instanceof ie){if(pe.loose===De)return pe;pe=pe.value}if(!(this instanceof ie))return new ie(pe,De);k("comparator",pe,De),this.loose=De,this.parse(pe),this.semver===O?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(pe,De){return ve(De,pe)},e.major=function(pe,De){return new J(pe,De).major},e.minor=function(pe,De){return new J(pe,De).minor},e.patch=function(pe,De){return new J(pe,De).patch},e.compare=Ee,e.compareLoose=function(pe,De){return Ee(pe,De,!0)},e.rcompare=function(pe,De,ke){return Ee(De,pe,ke)},e.sort=function(pe,De){return pe.sort(function(ke,je){return e.compare(ke,je,De)})},e.rsort=function(pe,De){return pe.sort(function(ke,je){return e.rcompare(ke,je,De)})},e.gt=Ae,e.lt=Fe,e.eq=se,e.neq=le,e.gte=ue,e.lte=ee,e.cmp=ae,e.Comparator=ie;var O={};function H(pe,De){if(pe instanceof H)return pe.loose===De?pe:new H(pe.raw,De);if(pe instanceof ie)return new H(pe.value,De);if(!(this instanceof H))return new H(pe,De);if(this.loose=De,this.raw=pe,this.set=pe.split(/\s*\|\|\s*/).map(function(ke){return this.parseRange(ke.trim())},this).filter(function(ke){return ke.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+pe);this.format()}function x(pe){return!pe||pe.toLowerCase()==="x"||pe==="*"}function Y(pe,De,ke,je,Ge,et,_e,nt,st,ht,Me,it,oe){return((De=x(ke)?"":x(je)?">="+ke+".0.0":x(Ge)?">="+ke+"."+je+".0":">="+De)+" "+(nt=x(st)?"":x(ht)?"<"+(+st+1)+".0.0":x(Me)?"<"+st+"."+(+ht+1)+".0":it?"<="+st+"."+ht+"."+Me+"-"+it:"<="+nt)).trim()}function de(pe,De){for(var ke=0;ke<pe.length;ke++)if(!pe[ke].test(De))return!1;if(De.prerelease.length){for(ke=0;ke<pe.length;ke++)if(k(pe[ke].semver),pe[ke].semver!==O&&pe[ke].semver.prerelease.length>0){var je=pe[ke].semver;if(je.major===De.major&&je.minor===De.minor&&je.patch===De.patch)return!0}return!1}return!0}function be(pe,De,ke){try{De=new H(De,ke)}catch{return!1}return De.test(pe)}function Pe(pe,De,ke,je){var Ge,et,_e,nt,st;switch(pe=new J(pe,je),De=new H(De,je),ke){case">":Ge=Ae,et=ee,_e=Fe,nt=">",st=">=";break;case"<":Ge=Fe,et=ue,_e=Ae,nt="<",st="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(be(pe,De,je))return!1;for(var ht=0;ht<De.set.length;++ht){var Me=De.set[ht],it=null,oe=null;if(Me.forEach(function($){$.semver===O&&($=new ie(">=0.0.0")),it=it||$,oe=oe||$,Ge($.semver,it.semver,je)?it=$:_e($.semver,oe.semver,je)&&(oe=$)}),it.operator===nt||it.operator===st||(!oe.operator||oe.operator===nt)&&et(pe,oe.semver)||oe.operator===st&&_e(pe,oe.semver))return!1}return!0}ie.prototype.parse=function(pe){var De=this.loose?A[W]:A[X],ke=pe.match(De);if(!ke)throw new TypeError("Invalid comparator: "+pe);this.operator=ke[1],this.operator==="="&&(this.operator=""),ke[2]?this.semver=new J(ke[2],this.loose):this.semver=O},ie.prototype.toString=function(){return this.value},ie.prototype.test=function(pe){return k("Comparator.test",pe,this.loose),this.semver===O||(typeof pe=="string"&&(pe=new J(pe,this.loose)),ae(pe,this.operator,this.semver,this.loose))},ie.prototype.intersects=function(pe,De){if(!(pe instanceof ie))throw new TypeError("a Comparator is required");var ke;if(this.operator==="")return ke=new H(pe.value,De),be(this.value,ke,De);if(pe.operator==="")return ke=new H(this.value,De),be(pe.semver,ke,De);var je=!(this.operator!==">="&&this.operator!==">"||pe.operator!==">="&&pe.operator!==">"),Ge=!(this.operator!=="<="&&this.operator!=="<"||pe.operator!=="<="&&pe.operator!=="<"),et=this.semver.version===pe.semver.version,_e=!(this.operator!==">="&&this.operator!=="<="||pe.operator!==">="&&pe.operator!=="<="),nt=ae(this.semver,"<",pe.semver,De)&&(this.operator===">="||this.operator===">")&&(pe.operator==="<="||pe.operator==="<"),st=ae(this.semver,">",pe.semver,De)&&(this.operator==="<="||this.operator==="<")&&(pe.operator===">="||pe.operator===">");return je||Ge||et&&_e||nt||st},e.Range=H,H.prototype.format=function(){return this.range=this.set.map(function(pe){return pe.join(" ").trim()}).join("||").trim(),this.range},H.prototype.toString=function(){return this.range},H.prototype.parseRange=function(pe){var De=this.loose;pe=pe.trim(),k("range",pe,De);var ke=De?A[Q]:A[_];pe=pe.replace(ke,Y),k("hyphen replace",pe),pe=pe.replace(A[q],"$1$2$3"),k("comparator trim",pe,A[q]),pe=(pe=(pe=pe.replace(A[G],"$1~")).replace(A[F],"$1^")).split(/\s+/).join(" ");var je=De?A[W]:A[X],Ge=pe.split(" ").map(function(et){return function(_e,nt){return k("comp",_e),_e=function(st,ht){return st.trim().split(/\s+/).map(function(Me){return function(it,oe){k("caret",it,oe);var $=oe?A[B]:A[z];return it.replace($,function(ce,Ie,Le,Be,xe){var Ze;return k("caret",it,ce,Ie,Le,Be,xe),x(Ie)?Ze="":x(Le)?Ze=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":x(Be)?Ze=Ie==="0"?">="+Ie+"."+Le+".0 <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+".0 <"+(+Ie+1)+".0.0":xe?(k("replaceCaret pr",xe),xe.charAt(0)!=="-"&&(xe="-"+xe),Ze=Ie==="0"?Le==="0"?">="+Ie+"."+Le+"."+Be+xe+" <"+Ie+"."+Le+"."+(+Be+1):">="+Ie+"."+Le+"."+Be+xe+" <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+"."+Be+xe+" <"+(+Ie+1)+".0.0"):(k("no pr"),Ze=Ie==="0"?Le==="0"?">="+Ie+"."+Le+"."+Be+" <"+Ie+"."+Le+"."+(+Be+1):">="+Ie+"."+Le+"."+Be+" <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+"."+Be+" <"+(+Ie+1)+".0.0"),k("caret return",Ze),Ze})}(Me,ht)}).join(" ")}(_e,nt),k("caret",_e),_e=function(st,ht){return st.trim().split(/\s+/).map(function(Me){return function(it,oe){var $=oe?A[N]:A[V];return it.replace($,function(ce,Ie,Le,Be,xe){var Ze;return k("tilde",it,ce,Ie,Le,Be,xe),x(Ie)?Ze="":x(Le)?Ze=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":x(Be)?Ze=">="+Ie+"."+Le+".0 <"+Ie+"."+(+Le+1)+".0":xe?(k("replaceTilde pr",xe),xe.charAt(0)!=="-"&&(xe="-"+xe),Ze=">="+Ie+"."+Le+"."+Be+xe+" <"+Ie+"."+(+Le+1)+".0"):Ze=">="+Ie+"."+Le+"."+Be+" <"+Ie+"."+(+Le+1)+".0",k("tilde return",Ze),Ze})}(Me,ht)}).join(" ")}(_e,nt),k("tildes",_e),_e=function(st,ht){return k("replaceXRanges",st,ht),st.split(/\s+/).map(function(Me){return function(it,oe){it=it.trim();var $=oe?A[E]:A[f];return it.replace($,function(ce,Ie,Le,Be,xe,Ze){k("xRange",it,ce,Ie,Le,Be,xe,Ze);var gt=x(Le),mt=gt||x(Be),lt=mt||x(xe);return Ie==="="&&lt&&(Ie=""),gt?ce=Ie===">"||Ie==="<"?"<0.0.0":"*":Ie&&lt?(mt&&(Be=0),lt&&(xe=0),Ie===">"?(Ie=">=",mt?(Le=+Le+1,Be=0,xe=0):lt&&(Be=+Be+1,xe=0)):Ie==="<="&&(Ie="<",mt?Le=+Le+1:Be=+Be+1),ce=Ie+Le+"."+Be+"."+xe):mt?ce=">="+Le+".0.0 <"+(+Le+1)+".0.0":lt&&(ce=">="+Le+"."+Be+".0 <"+Le+"."+(+Be+1)+".0"),k("xRange return",ce),ce})}(Me,ht)}).join(" ")}(_e,nt),k("xrange",_e),_e=function(st,ht){return k("replaceStars",st,ht),st.trim().replace(A[Z],"")}(_e,nt),k("stars",_e),_e}(et,De)}).join(" ").split(/\s+/);return this.loose&&(Ge=Ge.filter(function(et){return!!et.match(je)})),Ge=Ge.map(function(et){return new ie(et,De)})},H.prototype.intersects=function(pe,De){if(!(pe instanceof H))throw new TypeError("a Range is required");return this.set.some(function(ke){return ke.every(function(je){return pe.set.some(function(Ge){return Ge.every(function(et){return je.intersects(et,De)})})})})},e.toComparators=function(pe,De){return new H(pe,De).set.map(function(ke){return ke.map(function(je){return je.value}).join(" ").trim().split(" ")})},H.prototype.test=function(pe){if(!pe)return!1;typeof pe=="string"&&(pe=new J(pe,this.loose));for(var De=0;De<this.set.length;De++)if(de(this.set[De],pe))return!0;return!1},e.satisfies=be,e.maxSatisfying=function(pe,De,ke){var je=null,Ge=null;try{var et=new H(De,ke)}catch{return null}return pe.forEach(function(_e){et.test(_e)&&(je&&Ge.compare(_e)!==-1||(Ge=new J(je=_e,ke)))}),je},e.minSatisfying=function(pe,De,ke){var je=null,Ge=null;try{var et=new H(De,ke)}catch{return null}return pe.forEach(function(_e){et.test(_e)&&(je&&Ge.compare(_e)!==1||(Ge=new J(je=_e,ke)))}),je},e.validRange=function(pe,De){try{return new H(pe,De).range||"*"}catch{return null}},e.ltr=function(pe,De,ke){return Pe(pe,De,"<",ke)},e.gtr=function(pe,De,ke){return Pe(pe,De,">",ke)},e.outside=Pe,e.prerelease=function(pe,De){var ke=te(pe,De);return ke&&ke.prerelease.length?ke.prerelease:null},e.intersects=function(pe,De,ke){return pe=new H(pe,ke),De=new H(De,ke),pe.intersects(De)},e.coerce=function(pe){if(pe instanceof J)return pe;if(typeof pe!="string")return null;var De=pe.match(A[T]);return De==null?null:te((De[1]||"0")+"."+(De[2]||"0")+"."+(De[3]||"0"))}}).call(this,o(1))},function(ne,e){var o,t,k=ne.exports={};function R(){throw new Error("setTimeout has not been defined")}function I(){throw new Error("clearTimeout has not been defined")}function A(m){if(o===setTimeout)return setTimeout(m,0);if((o===R||!o)&&setTimeout)return o=setTimeout,setTimeout(m,0);try{return o(m,0)}catch{try{return o.call(null,m,0)}catch{return o.call(this,m,0)}}}(function(){try{o=typeof setTimeout=="function"?setTimeout:R}catch{o=R}try{t=typeof clearTimeout=="function"?clearTimeout:I}catch{t=I}})();var S,C=[],L=!1,P=-1;function y(){L&&S&&(L=!1,S.length?C=S.concat(C):P=-1,C.length&&D())}function D(){if(!L){var m=A(y);L=!0;for(var h=C.length;h;){for(S=C,C=[];++P<h;)S&&S[P].run();P=-1,h=C.length}S=null,L=!1,function(w){if(t===clearTimeout)return clearTimeout(w);if((t===I||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(w);try{t(w)}catch{try{return t.call(null,w)}catch{return t.call(this,w)}}}(m)}}function v(m,h){this.fun=m,this.array=h}function d(){}k.nextTick=function(m){var h=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)h[w-1]=arguments[w];C.push(new v(m,h)),C.length!==1||L||A(D)},v.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=d,k.addListener=d,k.once=d,k.off=d,k.removeListener=d,k.removeAllListeners=d,k.emit=d,k.prependListener=d,k.prependOnceListener=d,k.listeners=function(m){return[]},k.binding=function(m){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(m){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(ye[102],Ce([1,0,10,6]),function(ne,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(p){const b=p;return b?typeof b.read=="function":!1}e.isReadable=k;function R(p){const b=p;return b?[b.on,b.pause,b.resume,b.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=R;function I(p){const b=p;return b?R(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}e.isReadableBufferedStream=I;function A(p,b){return new S(p,b)}e.newWriteableStream=A;class S{constructor(b,i){this.e=b,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(b){if(!this.a.destroyed){if(this.a.flowing)this.g(b);else if(this.b.data.push(b),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(b){this.a.destroyed||(this.a.flowing?this.h(b):this.b.error.push(b))}end(b){this.a.destroyed||(typeof b<"u"&&this.write(b),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(b){this.c.data.slice(0).forEach(i=>i(b))}h(b){this.c.error.length===0?(0,o.onUnexpectedError)(b):this.c.error.slice(0).forEach(i=>i(b))}i(){this.c.end.slice(0).forEach(b=>b())}on(b,i){if(!this.a.destroyed)switch(b){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(b,i){if(this.a.destroyed)return;let s;switch(b){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const a=s.indexOf(i);a>=0&&s.splice(a,1)}}j(){if(this.b.data.length>0){const b=this.e(this.b.data);this.g(b),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const b of this.b.error)this.h(b);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function C(p,b){const i=[];let s;for(;(s=p.read())!==null;)i.push(s);return b(i)}e.consumeReadable=C;function L(p,b,i){const s=[];let a;for(;(a=p.read())!==null&&s.length<i;)s.push(a);return a===null&&s.length>0?b(s):{read:()=>{if(s.length>0)return s.shift();if(typeof a<"u"){const u=a;return a=void 0,u}return p.read()}}}e.peekReadable=L;function P(p,b){return new Promise((i,s)=>{const a=[];y(p,{onData:u=>{b&&a.push(u)},onError:u=>{b?s(u):i(void 0)},onEnd:()=>{i(b?b(a):void 0)}})})}e.consumeStream=P;function y(p,b){let i=!1;return p.on("error",s=>{i||b.onError(s)}),p.on("end",()=>{i||b.onEnd()}),p.on("data",s=>{i||b.onData(s)}),(0,t.toDisposable)(()=>i=!0)}e.listenStream=y;function D(p,b){return new Promise((i,s)=>{const a=new t.DisposableStore,u=[],c=r=>{if(u.push(r),u.length>b)return a.dispose(),p.pause(),i({stream:p,buffer:u,ended:!1})},l=r=>s(r),n=()=>i({stream:p,buffer:u,ended:!0});a.add((0,t.toDisposable)(()=>p.removeListener("error",l))),p.on("error",l),a.add((0,t.toDisposable)(()=>p.removeListener("end",n))),p.on("end",n),a.add((0,t.toDisposable)(()=>p.removeListener("data",c))),p.on("data",c)})}e.peekStream=D;function v(p,b){const i=A(b);return i.end(p),i}e.toStream=v;function d(){const p=A(()=>{throw new Error("not supported")});return p.end(),p}e.emptyStream=d;function m(p){let b=!1;return{read:()=>b?null:(b=!0,p)}}e.toReadable=m;function h(p,b,i){const s=A(i);return y(p,{onData:a=>s.write(b.data(a)),onError:a=>s.error(b.error?b.error(a):a),onEnd:()=>s.end()}),s}e.transform=h;function w(p,b,i){let s=!1;return{read:()=>{const a=b.read();return s?a:(s=!0,a!==null?i([p,a]):p)}}}e.prefixedReadable=w;function g(p,b,i){let s=!1;const a=A(i);return y(b,{onData:u=>s?a.write(u):(s=!0,a.write(i([p,u]))),onError:u=>a.error(u),onEnd:()=>{s||(s=!0,a.write(p)),a.end()}}),a}e.prefixedStream=g}),define(ye[22],Ce([1,0,102]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let k,R;class I{static alloc(r){return t?new I(Buffer.allocUnsafe(r)):new I(new Uint8Array(r))}static wrap(r){return t&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new I(r)}static fromString(r,f){return!(f?.dontUseNodeBuffer||!1)&&t?new I(Buffer.from(r)):(k||(k=new TextEncoder),new I(k.encode(r)))}static fromByteArray(r){const f=I.alloc(r.length);for(let E=0,T=r.length;E<T;E++)f.buffer[E]=r[E];return f}static concat(r,f){if(typeof f>"u"){f=0;for(let M=0,G=r.length;M<G;M++)f+=r[M].byteLength}const E=I.alloc(f);let T=0;for(let M=0,G=r.length;M<G;M++){const V=r[M];E.set(V,T),T+=V.byteLength}return E}constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}clone(){const r=I.alloc(this.byteLength);return r.set(this),r}toString(){return t?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(r,f){return new I(this.buffer.subarray(r,f))}set(r,f){if(r instanceof I)this.buffer.set(r.buffer,f);else if(r instanceof Uint8Array)this.buffer.set(r,f);else if(r instanceof ArrayBuffer)this.buffer.set(new Uint8Array(r),f);else if(ArrayBuffer.isView(r))this.buffer.set(new Uint8Array(r.buffer,r.byteOffset,r.byteLength),f);else throw new Error("Unknown argument 'array'")}readUInt32BE(r){return C(this.buffer,r)}writeUInt32BE(r,f){L(this.buffer,r,f)}readUInt32LE(r){return P(this.buffer,r)}writeUInt32LE(r,f){y(this.buffer,r,f)}readUInt8(r){return D(this.buffer,r)}writeUInt8(r,f){v(this.buffer,r,f)}}e.VSBuffer=I;function A(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0}e.readUInt16LE=A;function S(n,r,f){n[f+0]=r&255,r=r>>>8,n[f+1]=r&255}e.writeUInt16LE=S;function C(n,r){return n[r]*2**24+n[r+1]*2**16+n[r+2]*2**8+n[r+3]}e.readUInt32BE=C;function L(n,r,f){n[f+3]=r,r=r>>>8,n[f+2]=r,r=r>>>8,n[f+1]=r,r=r>>>8,n[f]=r}e.writeUInt32BE=L;function P(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0|n[r+2]<<16>>>0|n[r+3]<<24>>>0}e.readUInt32LE=P;function y(n,r,f){n[f+0]=r&255,r=r>>>8,n[f+1]=r&255,r=r>>>8,n[f+2]=r&255,r=r>>>8,n[f+3]=r&255}e.writeUInt32LE=y;function D(n,r){return n[r]}e.readUInt8=D;function v(n,r,f){n[f]=r}e.writeUInt8=v;function d(n){return o.consumeReadable(n,r=>I.concat(r))}e.readableToBuffer=d;function m(n){return o.toReadable(n)}e.bufferToReadable=m;function h(n){return o.consumeStream(n,r=>I.concat(r))}e.streamToBuffer=h;async function w(n){return n.ended?I.concat(n.buffer):I.concat([...n.buffer,await h(n.stream)])}e.bufferedStreamToBuffer=w;function g(n){return o.toStream(n,r=>I.concat(r))}e.bufferToStream=g;function p(n){return o.transform(n,{data:r=>typeof r=="string"?I.fromString(r):I.wrap(r)},r=>I.concat(r))}e.streamToBufferReadableStream=p;function b(n){return o.newWriteableStream(r=>I.concat(r),n)}e.newWriteableBufferStream=b;function i(n,r){return o.prefixedReadable(n,r,f=>I.concat(f))}e.prefixedBufferReadable=i;function s(n,r){return o.prefixedStream(n,r,f=>I.concat(f))}e.prefixedBufferStream=s;function a(n){let r=0,f=0,E=0;const T=new Uint8Array(Math.floor(n.length/4*3)),M=V=>{switch(f){case 3:T[E++]=r|V,f=0;break;case 2:T[E++]=r|V>>>2,r=V<<6,f=3;break;case 1:T[E++]=r|V>>>4,r=V<<4,f=2;break;default:r=V<<2,f=1}};for(let V=0;V<n.length;V++){const N=n.charCodeAt(V);if(N>=65&&N<=90)M(N-65);else if(N>=97&&N<=122)M(N-97+26);else if(N>=48&&N<=57)M(N-48+52);else if(N===43||N===45)M(62);else if(N===47||N===95)M(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${n[V]}`)}}const G=E;for(;f>0;)M(0);return I.wrap(T).slice(0,G)}e.decodeBase64=a;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:n},r=!0,f=!1){const E=f?c:u;let T="";const M=n.byteLength%3;let G=0;for(;G<n.byteLength-M;G+=3){const V=n[G+0],N=n[G+1],U=n[G+2];T+=E[V>>>2],T+=E[(V<<4|N>>>4)&63],T+=E[(N<<2|U>>>6)&63],T+=E[U&63]}if(M===1){const V=n[G+0];T+=E[V>>>2],T+=E[V<<4&63],r&&(T+="==")}else if(M===2){const V=n[G+0],N=n[G+1];T+=E[V>>>2],T+=E[(V<<4|N>>>4)&63],T+=E[N<<2&63],r&&(T+="=")}return T}e.encodeBase64=l}),define(ye[11],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function o(s){return typeof s=="string"}e.isString=o;function t(s){return Array.isArray(s)&&s.every(a=>o(a))}e.isStringArray=t;function k(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=k;function R(s){const a=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof a}e.isTypedArray=R;function I(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=I;function A(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=A;function S(s){return s===!0||s===!1}e.isBoolean=S;function C(s){return typeof s>"u"}e.isUndefined=C;function L(s){return!P(s)}e.isDefined=L;function P(s){return C(s)||s===null}e.isUndefinedOrNull=P;function y(s,a){if(!s)throw new Error(a?`Unexpected type, expected '${a}'`:"Unexpected type")}e.assertType=y;function D(s){if(P(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=D;function v(...s){const a=[];for(let u=0;u<s.length;u++){const c=s[u];if(P(c))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);a.push(c)}return a}e.assertAllDefined=v;const d=Object.prototype.hasOwnProperty;function m(s){if(!k(s))return!1;for(const a in s)if(d.call(s,a))return!1;return!0}e.isEmptyObject=m;function h(s){return typeof s=="function"}e.isFunction=h;function w(...s){return s.length>0&&s.every(h)}e.areFunctions=w;function g(s,a){const u=Math.min(s.length,a.length);for(let c=0;c<u;c++)p(s[c],a[c])}e.validateConstraints=g;function p(s,a){if(o(a)){if(typeof s!==a)throw new Error(`argument does not match constraint: typeof ${a}`)}else if(h(a)){try{if(s instanceof a)return}catch{}if(!P(s)&&s.constructor===a||a.length===1&&a.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=p;function b(s){return s===null?void 0:s}e.withNullAsUndefined=b;function i(s){return typeof s>"u"?null:s}e.withUndefinedAsNull=i}),define(ye[23],Ce([1,0,11]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const w=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([g,p])=>{w[g]=p&&typeof p=="object"?t(p):p}),w}e.deepClone=t;function k(h){if(!h||typeof h!="object")return h;const w=[h];for(;w.length>0;){const g=w.shift();Object.freeze(g);for(const p in g)if(R.call(g,p)){const b=g[p];typeof b=="object"&&!Object.isFrozen(b)&&!(0,o.isTypedArray)(b)&&w.push(b)}}return h}e.deepFreeze=k;const R=Object.prototype.hasOwnProperty;function I(h,w){return A(h,w,new Set)}e.cloneAndChange=I;function A(h,w,g){if((0,o.isUndefinedOrNull)(h))return h;const p=w(h);if(typeof p<"u")return p;if(Array.isArray(h)){const b=[];for(const i of h)b.push(A(i,w,g));return b}if((0,o.isObject)(h)){if(g.has(h))throw new Error("Cannot clone recursive data-structure");g.add(h);const b={};for(const i in h)R.call(h,i)&&(b[i]=A(h[i],w,g));return g.delete(h),b}return h}function S(h,w,g=!0){return(0,o.isObject)(h)?((0,o.isObject)(w)&&Object.keys(w).forEach(p=>{p in h?g&&((0,o.isObject)(h[p])&&(0,o.isObject)(w[p])?S(h[p],w[p],g):h[p]=w[p]):h[p]=w[p]}),h):w}e.mixin=S;function C(h,w){if(h===w)return!0;if(h==null||w===null||w===void 0||typeof h!=typeof w||typeof h!="object"||Array.isArray(h)!==Array.isArray(w))return!1;let g,p;if(Array.isArray(h)){if(h.length!==w.length)return!1;for(g=0;g<h.length;g++)if(!C(h[g],w[g]))return!1}else{const b=[];for(p in h)b.push(p);b.sort();const i=[];for(p in w)i.push(p);if(i.sort(),!C(b,i))return!1;for(g=0;g<b.length;g++)if(!C(h[b[g]],w[b[g]]))return!1}return!0}e.equals=C;function L(h){const w=new Set;return JSON.stringify(h,(g,p)=>{if((0,o.isObject)(p)||Array.isArray(p)){if(w.has(p))return"[Circular]";w.add(p)}return p})}e.safeStringify=L;function P(h,w){const g=Object.create(null);return!h||!w||Object.keys(w).forEach(b=>{const i=h[b],s=w[b];C(i,s)||(g[b]=s)}),g}e.distinct=P;function y(h,w){const g=w.toLowerCase(),p=Object.keys(h).find(b=>b.toLowerCase()===g);return p?h[p]:h[w]}e.getCaseInsensitive=y;function D(h,w){const g=Object.create(null);for(const[p,b]of Object.entries(h))w(p,b)&&(g[p]=b);return g}e.filter=D;function v(h){let w=[],g=Object.getPrototypeOf(h);for(;Object.prototype!==g;)w=w.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return w}e.getAllPropertyNames=v;function d(h){const w=[];for(const g of v(h))typeof h[g]=="function"&&w.push(g);return w}e.getAllMethodNames=d;function m(h,w){const g=b=>function(){const i=Array.prototype.slice.call(arguments,0);return w(b,i)},p={};for(const b of h)p[b]=g(b);return p}e.createProxyObject=m}),define(ye[103],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var o;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(o=e.Constants||(e.Constants={}));function t(R){return R<0?0:R>255?255:R|0}e.toUint8=t;function k(R){return R<0?0:R>4294967295?4294967295:R|0}e.toUint32=k}),define(ye[30],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const o=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(k){return o.test(k)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(A){for(let S=0;S<A.length;S++)A[S]=Math.floor(Math.random()*256);return A};const R=new Uint8Array(16),I=[];for(let A=0;A<256;A++)I.push(A.toString(16).padStart(2,"0"));return function(){k(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let S=0,C="";return C+=I[R[S++]],C+=I[R[S++]],C+=I[R[S++]],C+=I[R[S++]],C+="-",C+=I[R[S++]],C+=I[R[S++]],C+="-",C+=I[R[S++]],C+=I[R[S++]],C+="-",C+=I[R[S++]],C+=I[R[S++]],C+="-",C+=I[R[S++]],C+=I[R[S++]],C+=I[R[S++]],C+=I[R[S++]],C+=I[R[S++]],C+=I[R[S++]],C}}()}),define(ye[148],Ce([1,0,18,30]),function(ne,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function k(A){return{id:(0,t.generateUuid)(),asString:async()=>A,asFile:()=>{},value:typeof A=="string"?A:void 0}}e.createStringDataTransferItem=k;function R(A,S,C){return{id:(0,t.generateUuid)(),asString:async()=>"",asFile:()=>({name:A,uri:S,data:C}),value:void 0}}e.createFileDataTransferItem=R;class I{constructor(){this.a=new Map}get size(){return this.a.size}has(S){return this.a.has(this.b(S))}get(S){return this.a.get(this.b(S))?.[0]}append(S,C){const L=this.a.get(S);L?L.push(C):this.a.set(this.b(S),[C])}replace(S,C){this.a.set(this.b(S),[C])}delete(S){this.a.delete(this.b(S))}*entries(){for(const[S,C]of this.a.entries())for(const L of C)yield[S,L]}values(){return Array.from(this.a.values()).flat()}forEach(S){for(const[C,L]of this.entries())S(L,C)}b(S){return S.toLowerCase()}}e.VSDataTransfer=I,e.UriList=Object.freeze({create:A=>(0,o.distinct)(A.map(S=>S.toString())).join(`\r
`),split:A=>A.split(`\r
`),parse:A=>e.UriList.split(A).filter(S=>!S.startsWith("#"))})}),define(ye[104],Ce([1,0,103]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(A){const S=(0,o.toUint8)(A);this.c=S,this.a=t.d(S),this.b=new Map}static d(A){const S=new Uint8Array(256);return S.fill(A),S}set(A,S){const C=(0,o.toUint8)(S);A>=0&&A<256?this.a[A]=C:this.b.set(A,C)}get(A){return A>=0&&A<256?this.a[A]:this.b.get(A)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.CharacterClassifier=t;var k;(function(I){I[I.False=0]="False",I[I.True=1]="True"})(k||(k={}));class R{constructor(){this.a=new t(0)}add(A){this.a.set(A,1)}has(A){return this.a.get(A)===1}clear(){return this.a.clear()}}e.CharacterSet=R}),define(ye[50],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class o{constructor(k,R){this.lineNumber=k,this.column=R}with(k=this.lineNumber,R=this.column){return k===this.lineNumber&&R===this.column?this:new o(k,R)}delta(k=0,R=0){return this.with(this.lineNumber+k,this.column+R)}equals(k){return o.equals(this,k)}static equals(k,R){return!k&&!R?!0:!!k&&!!R&&k.lineNumber===R.lineNumber&&k.column===R.column}isBefore(k){return o.isBefore(this,k)}static isBefore(k,R){return k.lineNumber<R.lineNumber?!0:R.lineNumber<k.lineNumber?!1:k.column<R.column}isBeforeOrEqual(k){return o.isBeforeOrEqual(this,k)}static isBeforeOrEqual(k,R){return k.lineNumber<R.lineNumber?!0:R.lineNumber<k.lineNumber?!1:k.column<=R.column}static compare(k,R){const I=k.lineNumber|0,A=R.lineNumber|0;if(I===A){const S=k.column|0,C=R.column|0;return S-C}return I-A}clone(){return new o(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(k){return new o(k.lineNumber,k.column)}static isIPosition(k){return k&&typeof k.lineNumber=="number"&&typeof k.column=="number"}}e.Position=o}),define(ye[35],Ce([1,0,50]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(R,I,A,S){R>A||R===A&&I>S?(this.startLineNumber=A,this.startColumn=S,this.endLineNumber=R,this.endColumn=I):(this.startLineNumber=R,this.startColumn=I,this.endLineNumber=A,this.endColumn=S)}isEmpty(){return t.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return t.containsPosition(this,R)}static containsPosition(R,I){return!(I.lineNumber<R.startLineNumber||I.lineNumber>R.endLineNumber||I.lineNumber===R.startLineNumber&&I.column<R.startColumn||I.lineNumber===R.endLineNumber&&I.column>R.endColumn)}static strictContainsPosition(R,I){return!(I.lineNumber<R.startLineNumber||I.lineNumber>R.endLineNumber||I.lineNumber===R.startLineNumber&&I.column<=R.startColumn||I.lineNumber===R.endLineNumber&&I.column>=R.endColumn)}containsRange(R){return t.containsRange(this,R)}static containsRange(R,I){return!(I.startLineNumber<R.startLineNumber||I.endLineNumber<R.startLineNumber||I.startLineNumber>R.endLineNumber||I.endLineNumber>R.endLineNumber||I.startLineNumber===R.startLineNumber&&I.startColumn<R.startColumn||I.endLineNumber===R.endLineNumber&&I.endColumn>R.endColumn)}strictContainsRange(R){return t.strictContainsRange(this,R)}static strictContainsRange(R,I){return!(I.startLineNumber<R.startLineNumber||I.endLineNumber<R.startLineNumber||I.startLineNumber>R.endLineNumber||I.endLineNumber>R.endLineNumber||I.startLineNumber===R.startLineNumber&&I.startColumn<=R.startColumn||I.endLineNumber===R.endLineNumber&&I.endColumn>=R.endColumn)}plusRange(R){return t.plusRange(this,R)}static plusRange(R,I){let A,S,C,L;return I.startLineNumber<R.startLineNumber?(A=I.startLineNumber,S=I.startColumn):I.startLineNumber===R.startLineNumber?(A=I.startLineNumber,S=Math.min(I.startColumn,R.startColumn)):(A=R.startLineNumber,S=R.startColumn),I.endLineNumber>R.endLineNumber?(C=I.endLineNumber,L=I.endColumn):I.endLineNumber===R.endLineNumber?(C=I.endLineNumber,L=Math.max(I.endColumn,R.endColumn)):(C=R.endLineNumber,L=R.endColumn),new t(A,S,C,L)}intersectRanges(R){return t.intersectRanges(this,R)}static intersectRanges(R,I){let A=R.startLineNumber,S=R.startColumn,C=R.endLineNumber,L=R.endColumn;const P=I.startLineNumber,y=I.startColumn,D=I.endLineNumber,v=I.endColumn;return A<P?(A=P,S=y):A===P&&(S=Math.max(S,y)),C>D?(C=D,L=v):C===D&&(L=Math.min(L,v)),A>C||A===C&&S>L?null:new t(A,S,C,L)}equalsRange(R){return t.equalsRange(this,R)}static equalsRange(R,I){return!R&&!I?!0:!!R&&!!I&&R.startLineNumber===I.startLineNumber&&R.startColumn===I.startColumn&&R.endLineNumber===I.endLineNumber&&R.endColumn===I.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(R){return new o.Position(R.endLineNumber,R.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(R){return new o.Position(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,I){return new t(this.startLineNumber,this.startColumn,R,I)}setStartPosition(R,I){return new t(R,I,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}static collapseToStart(R){return new t(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return t.collapseToEnd(this)}static collapseToEnd(R){return new t(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new t(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,I=R){return new t(R.lineNumber,R.column,I.lineNumber,I.column)}static lift(R){return R?new t(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,I){return!(R.endLineNumber<I.startLineNumber||R.endLineNumber===I.startLineNumber&&R.endColumn<I.startColumn||I.endLineNumber<R.startLineNumber||I.endLineNumber===R.startLineNumber&&I.endColumn<R.startColumn)}static areIntersecting(R,I){return!(R.endLineNumber<I.startLineNumber||R.endLineNumber===I.startLineNumber&&R.endColumn<=I.startColumn||I.endLineNumber<R.startLineNumber||I.endLineNumber===R.startLineNumber&&I.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,I){if(R&&I){const C=R.startLineNumber|0,L=I.startLineNumber|0;if(C===L){const P=R.startColumn|0,y=I.startColumn|0;if(P===y){const D=R.endLineNumber|0,v=I.endLineNumber|0;if(D===v){const d=R.endColumn|0,m=I.endColumn|0;return d-m}return D-v}return P-y}return C-L}return(R?1:0)-(I?1:0)}static compareRangesUsingEnds(R,I){return R.endLineNumber===I.endLineNumber?R.endColumn===I.endColumn?R.startLineNumber===I.startLineNumber?R.startColumn-I.startColumn:R.startLineNumber-I.startLineNumber:R.endColumn-I.endColumn:R.endLineNumber-I.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.Range=t}),define(ye[149],Ce([1,0,50,35]),function(ne,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var k;(function(I){I[I.LTR=0]="LTR",I[I.RTL=1]="RTL"})(k=e.SelectionDirection||(e.SelectionDirection={}));class R extends t.Range{constructor(A,S,C,L){super(A,S,C,L),this.selectionStartLineNumber=A,this.selectionStartColumn=S,this.positionLineNumber=C,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(A){return R.selectionsEqual(this,A)}static selectionsEqual(A,S){return A.selectionStartLineNumber===S.selectionStartLineNumber&&A.selectionStartColumn===S.selectionStartColumn&&A.positionLineNumber===S.positionLineNumber&&A.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(A,S){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,A,S):new R(A,S,this.startLineNumber,this.startColumn)}getPosition(){return new o.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new o.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(A,S){return this.getDirection()===0?new R(A,S,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,A,S)}static fromPositions(A,S=A){return new R(A.lineNumber,A.column,S.lineNumber,S.column)}static fromRange(A,S){return S===0?new R(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):new R(A.endLineNumber,A.endColumn,A.startLineNumber,A.startColumn)}static liftSelection(A){return new R(A.selectionStartLineNumber,A.selectionStartColumn,A.positionLineNumber,A.positionColumn)}static selectionsArrEqual(A,S){if(A&&!S||!A&&S)return!1;if(!A&&!S)return!0;if(A.length!==S.length)return!1;for(let C=0,L=A.length;C<L;C++)if(!this.selectionsEqual(A[C],S[C]))return!1;return!0}static isISelection(A){return A&&typeof A.selectionStartLineNumber=="number"&&typeof A.selectionStartColumn=="number"&&typeof A.positionLineNumber=="number"&&typeof A.positionColumn=="number"}static createWithDirection(A,S,C,L,P){return P===0?new R(A,S,C,L):new R(C,L,A,S)}}e.Selection=R}),define(ye[150],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ye[151],Ce([1,0,104]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(I){I[I.Regular=0]="Regular",I[I.Whitespace=1]="Whitespace",I[I.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class k extends o.CharacterClassifier{constructor(A){super(0);for(let S=0,C=A.length;S<C;S++)this.set(A.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=k;function R(I){const A={};return S=>(A.hasOwnProperty(S)||(A[S]=I(S)),A[S])}e.getMapForWordSeparators=R(I=>new k(I))}),define(ye[105],Ce([1,0,62,6,63]),function(ne,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(P=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const D of e.USUAL_WORD_SEPARATORS)P.indexOf(D)>=0||(y+="\\"+D);return y+="\\s]+)",new RegExp(y,"g")}e.DEFAULT_WORD_REGEXP=R();function I(P){let y=e.DEFAULT_WORD_REGEXP;if(P&&P instanceof RegExp)if(P.global)y=P;else{let D="g";P.ignoreCase&&(D+="i"),P.multiline&&(D+="m"),P.unicode&&(D+="u"),y=new RegExp(P.source,D)}return y.lastIndex=0,y}e.ensureValidWordDefinition=I;const A=new k.LinkedList;A.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function S(P){const y=A.unshift(P);return(0,t.toDisposable)(y)}e.setDefaultGetWordAtTextConfig=S;function C(P,y,D,v,d){if(d||(d=o.Iterable.first(A)),D.length>d.maxLen){let p=P-d.maxLen/2;return p<0?p=0:v+=p,D=D.substring(p,P+d.maxLen/2),C(P,y,D,v,d)}const m=Date.now(),h=P-1-v;let w=-1,g=null;for(let p=1;!(Date.now()-m>=d.timeBudget);p++){const b=h-d.windowSize*p;y.lastIndex=Math.max(0,b);const i=L(y,D,h,w);if(!i&&g||(g=i,b<=0))break;w=b}if(g){const p={word:g[0],startColumn:v+1+g.index,endColumn:v+1+g.index+g[0].length};return y.lastIndex=0,p}return null}e.getWordAtText=C;function L(P,y,D,v){let d;for(;d=P.exec(y);){const m=d.index||0;if(m<=D&&P.lastIndex>=D)return d;if(v>0&&m>v)return null}return null}}),define(ye[152],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var o;(function(I){I[I.None=0]="None",I[I.Indent=1]="Indent",I[I.IndentOutdent=2]="IndentOutdent",I[I.Outdent=3]="Outdent"})(o=e.IndentAction||(e.IndentAction={}));class t{constructor(A){if(this.e=null,this.f=!1,this.open=A.open,this.close=A.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(A.notIn))for(let S=0,C=A.notIn.length;S<C;S++)switch(A.notIn[S]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(A,S){if(A.getTokenCount()===0)return!0;const C=A.findTokenIndexAtOffset(S-2),L=A.getStandardTokenType(C);return this.isOK(L)}g(A,S){for(let C=A;C<=S;C++){const L=String.fromCharCode(C);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=t;class k{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of A)R(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),R(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),R(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),R(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&R(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=k;function R(I,A,S){I.has(A)?I.get(A).push(S):I.set(A,[S])}}),define(ye[153],Ce([1,0,104]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var t;(function(D){D[D.Invalid=0]="Invalid",D[D.Start=1]="Start",D[D.H=2]="H",D[D.HT=3]="HT",D[D.HTT=4]="HTT",D[D.HTTP=5]="HTTP",D[D.F=6]="F",D[D.FI=7]="FI",D[D.FIL=8]="FIL",D[D.BeforeColon=9]="BeforeColon",D[D.AfterColon=10]="AfterColon",D[D.AlmostThere=11]="AlmostThere",D[D.End=12]="End",D[D.Accept=13]="Accept",D[D.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class k{constructor(v,d,m){const h=new Uint8Array(v*d);for(let w=0,g=v*d;w<g;w++)h[w]=m;this.a=h,this.rows=v,this.cols=d}get(v,d){return this.a[v*this.cols+d]}set(v,d,m){this.a[v*this.cols+d]=m}}class R{constructor(v){let d=0,m=0;for(let w=0,g=v.length;w<g;w++){const[p,b,i]=v[w];b>d&&(d=b),p>m&&(m=p),i>m&&(m=i)}d++,m++;const h=new k(m,d,0);for(let w=0,g=v.length;w<g;w++){const[p,b,i]=v[w];h.set(p,b,i)}this.a=h,this.b=d}nextState(v,d){return d<0||d>=this.b?0:this.a.get(v,d)}}e.StateMachine=R;let I=null;function A(){return I===null&&(I=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),I}var S;(function(D){D[D.None=0]="None",D[D.ForceTermination=1]="ForceTermination",D[D.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let C=null;function L(){if(C===null){C=new o.CharacterClassifier(0);const D=`, 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let d=0;d<D.length;d++)C.set(D.charCodeAt(d),1);const v=".;:";for(let d=0;d<v.length;d++)C.set(v.charCodeAt(d),2)}return C}class P{static a(v,d,m,h,w){let g=w-1;do{const p=d.charCodeAt(g);if(v.get(p)!==2)break;g--}while(g>h);if(h>0){const p=d.charCodeAt(h-1),b=d.charCodeAt(g);(p===40&&b===41||p===91&&b===93||p===123&&b===125)&&g--}return{range:{startLineNumber:m,startColumn:h+1,endLineNumber:m,endColumn:g+2},url:d.substring(h,g+1)}}static computeLinks(v,d=A()){const m=L(),h=[];for(let w=1,g=v.getLineCount();w<=g;w++){const p=v.getLineContent(w),b=p.length;let i=0,s=0,a=0,u=1,c=!1,l=!1,n=!1,r=!1;for(;i<b;){let f=!1;const E=p.charCodeAt(i);if(u===13){let T;switch(E){case 40:c=!0,T=0;break;case 41:T=c?0:1;break;case 91:n=!0,l=!0,T=0;break;case 93:n=!1,T=l?0:1;break;case 123:r=!0,T=0;break;case 125:T=r?0:1;break;case 39:case 34:case 96:a===E?T=1:a===39||a===34||a===96?T=0:T=1;break;case 42:T=a===42?1:0;break;case 124:T=a===124?1:0;break;case 32:T=n?0:1;break;default:T=m.get(E)}T===1&&(h.push(P.a(m,p,w,s,i)),f=!0)}else if(u===12){let T;E===91?(l=!0,T=0):T=m.get(E),T===1?f=!0:u=13}else u=d.nextState(u,E),u===0&&(f=!0);f&&(u=1,c=!1,l=!1,r=!1,s=i+1,a=E),i++}u===13&&h.push(P.a(m,p,w,s,b))}return h}}e.LinkComputer=P;function y(D){return!D||typeof D.getLineCount!="function"||typeof D.getLineContent!="function"?[]:P.computeLinks(D)}e.computeLinks=y}),define(ye[106],Ce([1,0,23]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(g){g[g.Left=1]="Left",g[g.Center=2]="Center",g[g.Right=4]="Right",g[g.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var k;(function(g){g[g.Inline=1]="Inline",g[g.Gutter=2]="Gutter"})(k=e.MinimapPosition||(e.MinimapPosition={}));var R;(function(g){g[g.Both=0]="Both",g[g.Right=1]="Right",g[g.Left=2]="Left",g[g.None=3]="None"})(R=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var I;(function(g){g[g.TextDefined=0]="TextDefined",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(I=e.EndOfLinePreference||(e.EndOfLinePreference={}));var A;(function(g){g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(A=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(g){g[g.LF=0]="LF",g[g.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class C{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(p){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,p.tabSize|0),p.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,p.indentSize|0),this.a=!1),this.insertSpaces=Boolean(p.insertSpaces),this.defaultEOL=p.defaultEOL|0,this.trimAutoWhitespace=Boolean(p.trimAutoWhitespace),this.bracketPairColorizationOptions=p.bracketPairColorizationOptions}equals(p){return this.tabSize===p.tabSize&&this.a===p.a&&this.indentSize===p.indentSize&&this.insertSpaces===p.insertSpaces&&this.defaultEOL===p.defaultEOL&&this.trimAutoWhitespace===p.trimAutoWhitespace&&(0,o.equals)(this.bracketPairColorizationOptions,p.bracketPairColorizationOptions)}createChangeEvent(p){return{tabSize:this.tabSize!==p.tabSize,indentSize:this.indentSize!==p.indentSize,insertSpaces:this.insertSpaces!==p.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==p.trimAutoWhitespace}}}e.TextModelResolvedOptions=C;class L{constructor(p,b){this._findMatchBrand=void 0,this.range=p,this.matches=b}}e.FindMatch=L;var P;(function(g){g[g.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",g[g.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",g[g.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",g[g.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function y(g){return g&&typeof g.read=="function"}e.isITextSnapshot=y;var D;(function(g){g[g.Left=0]="Left",g[g.Right=1]="Right",g[g.None=2]="None",g[g.LeftOfInjectedText=3]="LeftOfInjectedText",g[g.RightOfInjectedText=4]="RightOfInjectedText"})(D=e.PositionAffinity||(e.PositionAffinity={}));var v;(function(g){g[g.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(v=e.ModelConstants||(e.ModelConstants={}));class d{constructor(p,b,i,s,a,u){this.identifier=p,this.range=b,this.text=i,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=a,this._isTracked=u}}e.ValidAnnotatedEditOperation=d;class m{constructor(p,b,i){this.regex=p,this.wordSeparators=b,this.simpleSearch=i}}e.SearchData=m;class h{constructor(p,b,i){this.reverseEdits=p,this.changes=b,this.trimAutoWhitespaceLineNumbers=i}}e.ApplyEditsResult=h;function w(g){return!g.isTooLargeForSyncing()&&!g.isForSimpleWidget}e.shouldSynchronizeModel=w}),define(ye[154],Ce([1,0,18,103]),function(ne,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class k{constructor(S){this.a=S,this.b=new Uint32Array(S.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(S,C){S=(0,t.toUint32)(S);const L=this.a,P=this.b,y=C.length;return y===0?!1:(this.a=new Uint32Array(L.length+y),this.a.set(L.subarray(0,S),0),this.a.set(L.subarray(S),S+y),this.a.set(C,S),S-1<this.c[0]&&(this.c[0]=S-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}setValue(S,C){return S=(0,t.toUint32)(S),C=(0,t.toUint32)(C),this.a[S]===C?!1:(this.a[S]=C,S-1<this.c[0]&&(this.c[0]=S-1),!0)}removeValues(S,C){S=(0,t.toUint32)(S),C=(0,t.toUint32)(C);const L=this.a,P=this.b;if(S>=L.length)return!1;const y=L.length-S;return C>=y&&(C=y),C===0?!1:(this.a=new Uint32Array(L.length-C),this.a.set(L.subarray(0,S),0),this.a.set(L.subarray(S+C),S),this.b=new Uint32Array(this.a.length),S-1<this.c[0]&&(this.c[0]=S-1),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(S){return S<0?0:(S=(0,t.toUint32)(S),this.d(S))}d(S){if(S<=this.c[0])return this.b[S];let C=this.c[0]+1;C===0&&(this.b[0]=this.a[0],C++),S>=this.a.length&&(S=this.a.length-1);for(let L=C;L<=S;L++)this.b[L]=this.b[L-1]+this.a[L];return this.c[0]=Math.max(this.c[0],S),this.b[S]}getIndexOf(S){S=Math.floor(S),this.getTotalSum();let C=0,L=this.a.length-1,P=0,y=0,D=0;for(;C<=L;)if(P=C+(L-C)/2|0,y=this.b[P],D=y-this.a[P],S<D)L=P-1;else if(S>=y)C=P+1;else break;return new I(P,S-D)}}e.PrefixSumComputer=k;class R{constructor(S){this.a=S,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(S){return this.g(),S===0?0:this.d[S-1]}getIndexOf(S){this.g();const C=this.e[S],L=C>0?this.d[C-1]:0;return new I(C,S-L)}removeValues(S,C){this.a.splice(S,C),this.f(S)}insertValues(S,C){this.a=(0,o.arrayInsert)(this.a,S,C),this.f(S)}f(S){this.b=!1,this.c=Math.min(this.c,S-1)}g(){if(!this.b){for(let S=this.c+1,C=this.a.length;S<C;S++){const L=this.a[S],P=S>0?this.d[S-1]:0;this.d[S]=P+L;for(let y=0;y<L;y++)this.e[P+y]=S}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(S,C){this.a[S]!==C&&(this.a[S]=C,this.f(S))}}e.ConstantTimePrefixSumComputer=R;class I{constructor(S,C){this.index=S,this.remainder=C,this._prefixSumIndexOfResultBrand=void 0,this.index=S,this.remainder=C}}e.PrefixSumIndexOfResult=I}),define(ye[155],Ce([19,20]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(ye[156],Ce([1,0,155]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,k=t*60,R=k*24,I=R*7,A=R*30,S=R*365;function C(P,y,D){typeof P!="number"&&(P=P.getTime());const v=Math.round((new Date().getTime()-P)/1e3);if(v<-30)return(0,o.localize)(0,null,C(new Date().getTime()+v*1e3,!1));if(v<30)return(0,o.localize)(1,null);let d;return v<t?(d=v,y?d===1?D?(0,o.localize)(2,null,d):(0,o.localize)(3,null,d):D?(0,o.localize)(4,null,d):(0,o.localize)(5,null,d):d===1?D?(0,o.localize)(6,null,d):(0,o.localize)(7,null,d):D?(0,o.localize)(8,null,d):(0,o.localize)(9,null,d)):v<k?(d=Math.floor(v/t),y?d===1?D?(0,o.localize)(10,null,d):(0,o.localize)(11,null,d):D?(0,o.localize)(12,null,d):(0,o.localize)(13,null,d):d===1?D?(0,o.localize)(14,null,d):(0,o.localize)(15,null,d):D?(0,o.localize)(16,null,d):(0,o.localize)(17,null,d)):v<R?(d=Math.floor(v/k),y?d===1?D?(0,o.localize)(18,null,d):(0,o.localize)(19,null,d):D?(0,o.localize)(20,null,d):(0,o.localize)(21,null,d):d===1?D?(0,o.localize)(22,null,d):(0,o.localize)(23,null,d):D?(0,o.localize)(24,null,d):(0,o.localize)(25,null,d)):v<I?(d=Math.floor(v/R),y?d===1?(0,o.localize)(26,null,d):(0,o.localize)(27,null,d):d===1?(0,o.localize)(28,null,d):(0,o.localize)(29,null,d)):v<A?(d=Math.floor(v/I),y?d===1?D?(0,o.localize)(30,null,d):(0,o.localize)(31,null,d):D?(0,o.localize)(32,null,d):(0,o.localize)(33,null,d):d===1?D?(0,o.localize)(34,null,d):(0,o.localize)(35,null,d):D?(0,o.localize)(36,null,d):(0,o.localize)(37,null,d)):v<S?(d=Math.floor(v/A),y?d===1?D?(0,o.localize)(38,null,d):(0,o.localize)(39,null,d):D?(0,o.localize)(40,null,d):(0,o.localize)(41,null,d):d===1?D?(0,o.localize)(42,null,d):(0,o.localize)(43,null,d):D?(0,o.localize)(44,null,d):(0,o.localize)(45,null,d)):(d=Math.floor(v/S),y?d===1?D?(0,o.localize)(46,null,d):(0,o.localize)(47,null,d):D?(0,o.localize)(48,null,d):(0,o.localize)(49,null,d):d===1?D?(0,o.localize)(50,null,d):(0,o.localize)(51,null,d):D?(0,o.localize)(52,null,d):(0,o.localize)(53,null,d))}e.fromNow=C;function L(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(ye[157],Ce([19,20]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(ye[51],Ce([1,0,18,11,157]),function(ne,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(P,y){return y&&(P.stack||P.stacktrace)?k.localize(0,null,A(P),I(P.stack)||I(P.stacktrace)):A(P)}function I(P){return Array.isArray(P)?P.join(`
`):P}function A(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?k.localize(1,null,P.message):P.message||k.localize(2,null)}function S(P=null,y=!1){if(!P)return k.localize(3,null);if(Array.isArray(P)){const D=o.coalesce(P),v=S(D[0],y);return D.length>1?k.localize(4,null,v,D.length):v}if(t.isString(P))return P;if(P.detail){const D=P.detail;if(D.error)return R(D.error,y);if(D.exception)return R(D.exception,y)}return P.stack?R(P,y):P.message?P.message:k.localize(5,null)}e.toErrorMessage=S;function C(P){const y=P;return y instanceof Error&&Array.isArray(y.actions)}e.isErrorWithActions=C;function L(P,y){let D;return typeof P=="string"?D=new Error(P):D=P,D.actions=y,D}e.createErrorWithActions=L}),define(ye[158],Ce([19,20]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define(ye[12],Ce([1,0,158]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,k=!1,R=!1,I=!1,A=!1,S=!1,C=!1,L=!1,P=!1,y=!1,D,v=e.LANGUAGE_DEFAULT,d,m;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?h=e.globals.vscode.process:typeof process<"u"&&(h=process);const w=typeof h?.versions?.electron=="string",g=w&&h?.type==="renderer";if(typeof navigator=="object"&&!g)m=navigator.userAgent,t=m.indexOf("Windows")>=0,k=m.indexOf("Macintosh")>=0,L=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=m.indexOf("Linux")>=0,y=m?.indexOf("Mobi")>=0,S=!0,D=o.getConfiguredDefaultLocale(o.localize(0,null))||e.LANGUAGE_DEFAULT,v=D;else if(typeof h=="object"){t=h.platform==="win32",k=h.platform==="darwin",R=h.platform==="linux",I=R&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,C=w,P=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,D=e.LANGUAGE_DEFAULT,v=e.LANGUAGE_DEFAULT;const n=h.env.VSCODE_NLS_CONFIG;if(n)try{const r=JSON.parse(n),f=r.availableLanguages["*"];D=r.locale,v=f||e.LANGUAGE_DEFAULT,d=r._translationsConfigFile}catch{}A=!0}else console.error("Unable to resolve platform.");var p;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(p=e.Platform||(e.Platform={}));function b(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let i=0;k?i=1:t?i=3:R&&(i=2),e.isWindows=t,e.isMacintosh=k,e.isLinux=R,e.isLinuxSnap=I,e.isNative=A,e.isElectron=C,e.isWeb=S,e.isWebWorker=S&&typeof e.globals.importScripts=="function",e.isIOS=L,e.isMobile=y,e.isCI=P,e.platform=i,e.userAgent=m,e.language=v;var s;(function(n){function r(){return e.language}n.value=r;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=f;function E(){return e.language==="en"}n.isDefault=E})(s=e.Language||(e.Language={})),e.locale=D,e.translationsConfigFile=d,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const n=[];e.globals.addEventListener("message",f=>{if(f.data&&f.data.vscodeScheduleAsyncWork)for(let E=0,T=n.length;E<T;E++){const M=n[E];if(M.id===f.data.vscodeScheduleAsyncWork){n.splice(E,1),M.callback();return}}});let r=0;return f=>{const E=++r;n.push({id:E,callback:f}),e.globals.postMessage({vscodeScheduleAsyncWork:E},"*")}}return n=>setTimeout(n)})();var a;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(a=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||L?2:t?1:3;let u=!0,c=!1;function l(){if(!c){c=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,u=new Uint16Array(n.buffer)[0]===(2<<8)+1}return u}e.isLittleEndian=l,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ye[36],Ce([1,0,12]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof o.globals.vscode<"u"&&typeof o.globals.vscode.process<"u"){const k=o.globals.vscode.process;t={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return o.isWindows?"win32":o.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(ye[9],Ce([1,0,36]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,k=97,R=90,I=122,A=46,S=47,C=92,L=58,P=63;class y extends Error{constructor(s,a,u){let c;typeof a=="string"&&a.indexOf("not ")===0?(c="must not be",a=a.replace(/^not /,"")):c="must be";const l=s.indexOf(".")!==-1?"property":"argument";let n=`The "${s}" ${l} ${c} of type ${a}`;n+=`. Received type ${typeof u}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function D(i,s){if(i===null||typeof i!="object")throw new y(s,"Object",i)}function v(i,s){if(typeof i!="string")throw new y(s,"string",i)}const d=o.platform==="win32";function m(i){return i===S||i===C}function h(i){return i===S}function w(i){return i>=t&&i<=R||i>=k&&i<=I}function g(i,s,a,u){let c="",l=0,n=-1,r=0,f=0;for(let E=0;E<=i.length;++E){if(E<i.length)f=i.charCodeAt(E);else{if(u(f))break;f=S}if(u(f)){if(!(n===E-1||r===1))if(r===2){if(c.length<2||l!==2||c.charCodeAt(c.length-1)!==A||c.charCodeAt(c.length-2)!==A){if(c.length>2){const T=c.lastIndexOf(a);T===-1?(c="",l=0):(c=c.slice(0,T),l=c.length-1-c.lastIndexOf(a)),n=E,r=0;continue}else if(c.length!==0){c="",l=0,n=E,r=0;continue}}s&&(c+=c.length>0?`${a}..`:"..",l=2)}else c.length>0?c+=`${a}${i.slice(n+1,E)}`:c=i.slice(n+1,E),l=E-n-1;n=E,r=0}else f===A&&r!==-1?++r:r=-1}return c}function p(i,s){D(s,"pathObject");const a=s.dir||s.root,u=s.base||`${s.name||""}${s.ext||""}`;return a?a===s.root?`${a}${u}`:`${a}${i}${u}`:u}e.win32={resolve(...i){let s="",a="",u=!1;for(let c=i.length-1;c>=-1;c--){let l;if(c>=0){if(l=i[c],v(l,"path"),l.length===0)continue}else s.length===0?l=o.cwd():(l=o.env[`=${s}`]||o.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==s.toLowerCase()&&l.charCodeAt(2)===C)&&(l=`${s}\\`));const n=l.length;let r=0,f="",E=!1;const T=l.charCodeAt(0);if(n===1)m(T)&&(r=1,E=!0);else if(m(T))if(E=!0,m(l.charCodeAt(1))){let M=2,G=M;for(;M<n&&!m(l.charCodeAt(M));)M++;if(M<n&&M!==G){const V=l.slice(G,M);for(G=M;M<n&&m(l.charCodeAt(M));)M++;if(M<n&&M!==G){for(G=M;M<n&&!m(l.charCodeAt(M));)M++;(M===n||M!==G)&&(f=`\\\\${V}\\${l.slice(G,M)}`,r=M)}}}else r=1;else w(T)&&l.charCodeAt(1)===L&&(f=l.slice(0,2),r=2,n>2&&m(l.charCodeAt(2))&&(E=!0,r=3));if(f.length>0)if(s.length>0){if(f.toLowerCase()!==s.toLowerCase())continue}else s=f;if(u){if(s.length>0)break}else if(a=`${l.slice(r)}\\${a}`,u=E,E&&s.length>0)break}return a=g(a,!u,"\\",m),u?`${s}\\${a}`:`${s}${a}`||"."},normalize(i){v(i,"path");const s=i.length;if(s===0)return".";let a=0,u,c=!1;const l=i.charCodeAt(0);if(s===1)return h(l)?"\\":i;if(m(l))if(c=!0,m(i.charCodeAt(1))){let r=2,f=r;for(;r<s&&!m(i.charCodeAt(r));)r++;if(r<s&&r!==f){const E=i.slice(f,r);for(f=r;r<s&&m(i.charCodeAt(r));)r++;if(r<s&&r!==f){for(f=r;r<s&&!m(i.charCodeAt(r));)r++;if(r===s)return`\\\\${E}\\${i.slice(f)}\\`;r!==f&&(u=`\\\\${E}\\${i.slice(f,r)}`,a=r)}}}else a=1;else w(l)&&i.charCodeAt(1)===L&&(u=i.slice(0,2),a=2,s>2&&m(i.charCodeAt(2))&&(c=!0,a=3));let n=a<s?g(i.slice(a),!c,"\\",m):"";return n.length===0&&!c&&(n="."),n.length>0&&m(i.charCodeAt(s-1))&&(n+="\\"),u===void 0?c?`\\${n}`:n:c?`${u}\\${n}`:`${u}${n}`},isAbsolute(i){v(i,"path");const s=i.length;if(s===0)return!1;const a=i.charCodeAt(0);return m(a)||s>2&&w(a)&&i.charCodeAt(1)===L&&m(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let s,a;for(let l=0;l<i.length;++l){const n=i[l];v(n,"path"),n.length>0&&(s===void 0?s=a=n:s+=`\\${n}`)}if(s===void 0)return".";let u=!0,c=0;if(typeof a=="string"&&m(a.charCodeAt(0))){++c;const l=a.length;l>1&&m(a.charCodeAt(1))&&(++c,l>2&&(m(a.charCodeAt(2))?++c:u=!1))}if(u){for(;c<s.length&&m(s.charCodeAt(c));)c++;c>=2&&(s=`\\${s.slice(c)}`)}return e.win32.normalize(s)},relative(i,s){if(v(i,"from"),v(s,"to"),i===s)return"";const a=e.win32.resolve(i),u=e.win32.resolve(s);if(a===u||(i=a.toLowerCase(),s=u.toLowerCase(),i===s))return"";let c=0;for(;c<i.length&&i.charCodeAt(c)===C;)c++;let l=i.length;for(;l-1>c&&i.charCodeAt(l-1)===C;)l--;const n=l-c;let r=0;for(;r<s.length&&s.charCodeAt(r)===C;)r++;let f=s.length;for(;f-1>r&&s.charCodeAt(f-1)===C;)f--;const E=f-r,T=n<E?n:E;let M=-1,G=0;for(;G<T;G++){const N=i.charCodeAt(c+G);if(N!==s.charCodeAt(r+G))break;N===C&&(M=G)}if(G!==T){if(M===-1)return u}else{if(E>T){if(s.charCodeAt(r+G)===C)return u.slice(r+G+1);if(G===2)return u.slice(r+G)}n>T&&(i.charCodeAt(c+G)===C?M=G:G===2&&(M=3)),M===-1&&(M=0)}let V="";for(G=c+M+1;G<=l;++G)(G===l||i.charCodeAt(G)===C)&&(V+=V.length===0?"..":"\\..");return r+=M,V.length>0?`${V}${u.slice(r,f)}`:(u.charCodeAt(r)===C&&++r,u.slice(r,f))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const s=e.win32.resolve(i);if(s.length<=2)return i;if(s.charCodeAt(0)===C){if(s.charCodeAt(1)===C){const a=s.charCodeAt(2);if(a!==P&&a!==A)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(w(s.charCodeAt(0))&&s.charCodeAt(1)===L&&s.charCodeAt(2)===C)return`\\\\?\\${s}`;return i},dirname(i){v(i,"path");const s=i.length;if(s===0)return".";let a=-1,u=0;const c=i.charCodeAt(0);if(s===1)return m(c)?i:".";if(m(c)){if(a=u=1,m(i.charCodeAt(1))){let r=2,f=r;for(;r<s&&!m(i.charCodeAt(r));)r++;if(r<s&&r!==f){for(f=r;r<s&&m(i.charCodeAt(r));)r++;if(r<s&&r!==f){for(f=r;r<s&&!m(i.charCodeAt(r));)r++;if(r===s)return i;r!==f&&(a=u=r+1)}}}}else w(c)&&i.charCodeAt(1)===L&&(a=s>2&&m(i.charCodeAt(2))?3:2,u=a);let l=-1,n=!0;for(let r=s-1;r>=u;--r)if(m(i.charCodeAt(r))){if(!n){l=r;break}}else n=!1;if(l===-1){if(a===-1)return".";l=a}return i.slice(0,l)},basename(i,s){s!==void 0&&v(s,"ext"),v(i,"path");let a=0,u=-1,c=!0,l;if(i.length>=2&&w(i.charCodeAt(0))&&i.charCodeAt(1)===L&&(a=2),s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let n=s.length-1,r=-1;for(l=i.length-1;l>=a;--l){const f=i.charCodeAt(l);if(m(f)){if(!c){a=l+1;break}}else r===-1&&(c=!1,r=l+1),n>=0&&(f===s.charCodeAt(n)?--n===-1&&(u=l):(n=-1,u=r))}return a===u?u=r:u===-1&&(u=i.length),i.slice(a,u)}for(l=i.length-1;l>=a;--l)if(m(i.charCodeAt(l))){if(!c){a=l+1;break}}else u===-1&&(c=!1,u=l+1);return u===-1?"":i.slice(a,u)},extname(i){v(i,"path");let s=0,a=-1,u=0,c=-1,l=!0,n=0;i.length>=2&&i.charCodeAt(1)===L&&w(i.charCodeAt(0))&&(s=u=2);for(let r=i.length-1;r>=s;--r){const f=i.charCodeAt(r);if(m(f)){if(!l){u=r+1;break}continue}c===-1&&(l=!1,c=r+1),f===A?a===-1?a=r:n!==1&&(n=1):a!==-1&&(n=-1)}return a===-1||c===-1||n===0||n===1&&a===c-1&&a===u+1?"":i.slice(a,c)},format:p.bind(null,"\\"),parse(i){v(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const a=i.length;let u=0,c=i.charCodeAt(0);if(a===1)return m(c)?(s.root=s.dir=i,s):(s.base=s.name=i,s);if(m(c)){if(u=1,m(i.charCodeAt(1))){let M=2,G=M;for(;M<a&&!m(i.charCodeAt(M));)M++;if(M<a&&M!==G){for(G=M;M<a&&m(i.charCodeAt(M));)M++;if(M<a&&M!==G){for(G=M;M<a&&!m(i.charCodeAt(M));)M++;M===a?u=M:M!==G&&(u=M+1)}}}}else if(w(c)&&i.charCodeAt(1)===L){if(a<=2)return s.root=s.dir=i,s;if(u=2,m(i.charCodeAt(2))){if(a===3)return s.root=s.dir=i,s;u=3}}u>0&&(s.root=i.slice(0,u));let l=-1,n=u,r=-1,f=!0,E=i.length-1,T=0;for(;E>=u;--E){if(c=i.charCodeAt(E),m(c)){if(!f){n=E+1;break}continue}r===-1&&(f=!1,r=E+1),c===A?l===-1?l=E:T!==1&&(T=1):l!==-1&&(T=-1)}return r!==-1&&(l===-1||T===0||T===1&&l===r-1&&l===n+1?s.base=s.name=i.slice(n,r):(s.name=i.slice(n,l),s.base=i.slice(n,r),s.ext=i.slice(l,r))),n>0&&n!==u?s.dir=i.slice(0,n-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const b=(()=>{if(d){const i=/\\/g;return()=>{const s=o.cwd().replace(i,"/");return s.slice(s.indexOf("/"))}}return()=>o.cwd()})();e.posix={resolve(...i){let s="",a=!1;for(let u=i.length-1;u>=-1&&!a;u--){const c=u>=0?i[u]:b();v(c,"path"),c.length!==0&&(s=`${c}/${s}`,a=c.charCodeAt(0)===S)}return s=g(s,!a,"/",h),a?`/${s}`:s.length>0?s:"."},normalize(i){if(v(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===S,a=i.charCodeAt(i.length-1)===S;return i=g(i,!s,"/",h),i.length===0?s?"/":a?"./":".":(a&&(i+="/"),s?`/${i}`:i)},isAbsolute(i){return v(i,"path"),i.length>0&&i.charCodeAt(0)===S},join(...i){if(i.length===0)return".";let s;for(let a=0;a<i.length;++a){const u=i[a];v(u,"path"),u.length>0&&(s===void 0?s=u:s+=`/${u}`)}return s===void 0?".":e.posix.normalize(s)},relative(i,s){if(v(i,"from"),v(s,"to"),i===s||(i=e.posix.resolve(i),s=e.posix.resolve(s),i===s))return"";const a=1,u=i.length,c=u-a,l=1,n=s.length-l,r=c<n?c:n;let f=-1,E=0;for(;E<r;E++){const M=i.charCodeAt(a+E);if(M!==s.charCodeAt(l+E))break;M===S&&(f=E)}if(E===r)if(n>r){if(s.charCodeAt(l+E)===S)return s.slice(l+E+1);if(E===0)return s.slice(l+E)}else c>r&&(i.charCodeAt(a+E)===S?f=E:E===0&&(f=0));let T="";for(E=a+f+1;E<=u;++E)(E===u||i.charCodeAt(E)===S)&&(T+=T.length===0?"..":"/..");return`${T}${s.slice(l+f)}`},toNamespacedPath(i){return i},dirname(i){if(v(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===S;let a=-1,u=!0;for(let c=i.length-1;c>=1;--c)if(i.charCodeAt(c)===S){if(!u){a=c;break}}else u=!1;return a===-1?s?"/":".":s&&a===1?"//":i.slice(0,a)},basename(i,s){s!==void 0&&v(s,"ext"),v(i,"path");let a=0,u=-1,c=!0,l;if(s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let n=s.length-1,r=-1;for(l=i.length-1;l>=0;--l){const f=i.charCodeAt(l);if(f===S){if(!c){a=l+1;break}}else r===-1&&(c=!1,r=l+1),n>=0&&(f===s.charCodeAt(n)?--n===-1&&(u=l):(n=-1,u=r))}return a===u?u=r:u===-1&&(u=i.length),i.slice(a,u)}for(l=i.length-1;l>=0;--l)if(i.charCodeAt(l)===S){if(!c){a=l+1;break}}else u===-1&&(c=!1,u=l+1);return u===-1?"":i.slice(a,u)},extname(i){v(i,"path");let s=-1,a=0,u=-1,c=!0,l=0;for(let n=i.length-1;n>=0;--n){const r=i.charCodeAt(n);if(r===S){if(!c){a=n+1;break}continue}u===-1&&(c=!1,u=n+1),r===A?s===-1?s=n:l!==1&&(l=1):s!==-1&&(l=-1)}return s===-1||u===-1||l===0||l===1&&s===u-1&&s===a+1?"":i.slice(s,u)},format:p.bind(null,"/"),parse(i){v(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const a=i.charCodeAt(0)===S;let u;a?(s.root="/",u=1):u=0;let c=-1,l=0,n=-1,r=!0,f=i.length-1,E=0;for(;f>=u;--f){const T=i.charCodeAt(f);if(T===S){if(!r){l=f+1;break}continue}n===-1&&(r=!1,n=f+1),T===A?c===-1?c=f:E!==1&&(E=1):c!==-1&&(E=-1)}if(n!==-1){const T=l===0&&a?1:l;c===-1||E===0||E===1&&c===n-1&&c===l+1?s.base=s.name=i.slice(T,n):(s.name=i.slice(T,c),s.base=i.slice(T,n),s.ext=i.slice(c,n))}return l>0?s.dir=i.slice(0,l-1):a&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=d?e.win32.normalize:e.posix.normalize,e.isAbsolute=d?e.win32.isAbsolute:e.posix.isAbsolute,e.join=d?e.win32.join:e.posix.join,e.resolve=d?e.win32.resolve:e.posix.resolve,e.relative=d?e.win32.relative:e.posix.relative,e.dirname=d?e.win32.dirname:e.posix.dirname,e.basename=d?e.win32.basename:e.posix.basename,e.extname=d?e.win32.extname:e.posix.extname,e.format=d?e.win32.format:e.posix.format,e.parse=d?e.win32.parse:e.posix.parse,e.toNamespacedPath=d?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=d?e.win32.sep:e.posix.sep,e.delimiter=d?e.win32.delimiter:e.posix.delimiter}),define(ye[84],Ce([1,0,9]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},k={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(L){const P=(0,o.extname)(L),y=t[P.toLowerCase()];return y!==void 0?y:I(L)}e.getMediaOrTextMime=R;function I(L){const P=(0,o.extname)(L);return k[P.toLowerCase()]}e.getMediaMime=I;function A(L){for(const P in k)if(k[P]===L)return P}e.getExtensionForMimeType=A;const S=/^(.+)\/(.+?)(;.+)?$/;function C(L,P){const y=S.exec(L);return y?`${y[1].toLowerCase()}/${y[2].toLowerCase()}${y[3]??""}`:P?void 0:L}e.normalizeMimeType=C}),define(ye[107],Ce([1,0,12]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var k;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(A,...S){const C=S.reduce((y,D)=>(y[D]=!0,y),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(A).filter(y=>!C[y]).forEach(y=>{for(let D=0;D<L.length;D++)if(y.search(L[D])!==-1){delete A[y];break}})}e.sanitizeProcessEnvironment=R;function I(A){!A||(delete A.DEBUG,o.isMacintosh&&delete A.DYLD_LIBRARY_PATH,o.isLinux&&delete A.LD_PRELOAD)}e.removeDangerousEnvVariables=I}),define(ye[42],Ce([1,0,12]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=o.globals.performance&&typeof o.globals.performance.now=="function";class k{static create(I=!0){return new k(I)}constructor(I){this.a=t&&I,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?o.globals.performance.now():Date.now()}}e.StopWatch=k}),define(ye[4],Ce([1,0,10,61,6,63,42]),function(ne,e,o,t,k,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const A=!1,S=!1;var C;(function(l){l.None=()=>k.Disposable.None;function n(Ee){if(S){const{onDidAddListener:Ae}=Ee,Fe=v.create();let se=0;Ee.onDidAddListener=()=>{++se===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Fe.print()),Ae?.()}}}function r(Ee,Ae){return F(Ee,()=>{},0,void 0,void 0,Ae)}l.defer=r;function f(Ee){return(Ae,Fe=null,se)=>{let le=!1,ue;return ue=Ee(ee=>{if(!le)return ue?ue.dispose():le=!0,Ae.call(Fe,ee)},null,se),le&&ue.dispose(),ue}}l.once=f;function E(Ee,Ae,Fe){return U((se,le=null,ue)=>Ee(ee=>se.call(le,Ae(ee)),null,ue),Fe)}l.map=E;function T(Ee,Ae,Fe){return U((se,le=null,ue)=>Ee(ee=>{Ae(ee),se.call(le,ee)},null,ue),Fe)}l.forEach=T;function M(Ee,Ae,Fe){return U((se,le=null,ue)=>Ee(ee=>Ae(ee)&&se.call(le,ee),null,ue),Fe)}l.filter=M;function G(Ee){return Ee}l.signal=G;function V(...Ee){return(Ae,Fe=null,se)=>(0,k.combinedDisposable)(...Ee.map(le=>le(ue=>Ae.call(Fe,ue),null,se)))}l.any=V;function N(Ee,Ae,Fe,se){let le=Fe;return E(Ee,ue=>(le=Ae(le,ue),le),se)}l.reduce=N;function U(Ee,Ae){let Fe;const se={onWillAddFirstListener(){Fe=Ee(le.fire,le)},onDidRemoveLastListener(){Fe?.dispose()}};Ae||n(se);const le=new m(se);return Ae?.add(le),le.event}function F(Ee,Ae,Fe=100,se=!1,le,ue){let ee,ae,ie,O=0;const H={leakWarningThreshold:le,onWillAddFirstListener(){ee=Ee(Y=>{O++,ae=Ae(ae,Y),se&&!ie&&(x.fire(ae),ae=void 0),clearTimeout(ie),ie=setTimeout(()=>{const de=ae;ae=void 0,ie=void 0,(!se||O>1)&&x.fire(de),O=0},Fe)})},onDidRemoveLastListener(){ee.dispose()}};ue||n(H);const x=new m(H);return ue?.add(x),x.event}l.debounce=F;function z(Ee,Ae=0,Fe){return l.debounce(Ee,(se,le)=>se?(se.push(le),se):[le],Ae,void 0,void 0,Fe)}l.accumulate=z;function B(Ee,Ae=(se,le)=>se===le,Fe){let se=!0,le;return M(Ee,ue=>{const ee=se||!Ae(ue,le);return se=!1,le=ue,ee},Fe)}l.latch=B;function W(Ee,Ae,Fe){return[l.filter(Ee,Ae,Fe),l.filter(Ee,se=>!Ae(se),Fe)]}l.split=W;function X(Ee,Ae=!1,Fe=[]){let se=Fe.slice(),le=Ee(ae=>{se?se.push(ae):ee.fire(ae)});const ue=()=>{se?.forEach(ae=>ee.fire(ae)),se=null},ee=new m({onWillAddFirstListener(){le||(le=Ee(ae=>ee.fire(ae)))},onDidAddFirstListener(){se&&(Ae?setTimeout(ue):ue())},onDidRemoveLastListener(){le&&le.dispose(),le=null}});return ee.event}l.buffer=X;class q{constructor(Ae){this.event=Ae,this.c=new k.DisposableStore}map(Ae){return new q(E(this.event,Ae,this.c))}forEach(Ae){return new q(T(this.event,Ae,this.c))}filter(Ae){return new q(M(this.event,Ae,this.c))}reduce(Ae,Fe){return new q(N(this.event,Ae,Fe,this.c))}latch(){return new q(B(this.event,void 0,this.c))}debounce(Ae,Fe=100,se=!1,le){return new q(F(this.event,Ae,Fe,se,le,this.c))}on(Ae,Fe,se){return this.event(Ae,Fe,se)}once(Ae,Fe,se){return f(this.event)(Ae,Fe,se)}dispose(){this.c.dispose()}}function _(Ee){return new q(Ee)}l.chain=_;function Q(Ee,Ae,Fe=se=>se){const se=(...ae)=>ee.fire(Fe(...ae)),le=()=>Ee.on(Ae,se),ue=()=>Ee.removeListener(Ae,se),ee=new m({onWillAddFirstListener:le,onDidRemoveLastListener:ue});return ee.event}l.fromNodeEventEmitter=Q;function Z(Ee,Ae,Fe=se=>se){const se=(...ae)=>ee.fire(Fe(...ae)),le=()=>Ee.addEventListener(Ae,se),ue=()=>Ee.removeEventListener(Ae,se),ee=new m({onWillAddFirstListener:le,onDidRemoveLastListener:ue});return ee.event}l.fromDOMEventEmitter=Z;function ge(Ee){return new Promise(Ae=>f(Ee)(Ae))}l.toPromise=ge;function te(Ee,Ae){return Ae(void 0),Ee(Fe=>Ae(Fe))}l.runAndSubscribe=te;function J(Ee,Ae){let Fe=null;function se(ue){Fe?.dispose(),Fe=new k.DisposableStore,Ae(ue,Fe)}se(void 0);const le=Ee(ue=>se(ue));return(0,k.toDisposable)(()=>{le.dispose(),Fe?.dispose()})}l.runAndSubscribeWithStore=J;class fe{constructor(Ae,Fe){this.obs=Ae,this.c=0,this.d=!1;const se={onWillAddFirstListener:()=>{Ae.addObserver(this)},onDidRemoveLastListener:()=>{Ae.removeObserver(this)}};Fe||n(se),this.emitter=new m(se),Fe&&Fe.add(this.emitter)}beginUpdate(Ae){this.c++}handleChange(Ae,Fe){this.d=!0}endUpdate(Ae){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function ve(Ee,Ae){return new fe(Ee,Ae).emitter.event}l.fromObservable=ve})(C=e.Event||(e.Event={}));class L{constructor(n){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${n}_${L.c++}`,L.all.add(this)}start(n){this.d=new I.StopWatch(!0),this.listenerCount=n}stop(){if(this.d){const n=this.d.elapsed();this.durations.push(n),this.elapsedOverall+=n,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=L,L.all=new Set,L.c=0;let P=-1;function y(l){const n=P;return P=l,{dispose(){P=n}}}e.setGlobalLeakWarningThreshold=y;class D{constructor(n,r=Math.random().toString(18).slice(2,5)){this.threshold=n,this.name=r,this.d=0}dispose(){this.c?.clear()}check(n,r){const f=this.threshold;if(f<=0||r<f)return;this.c||(this.c=new Map);const E=this.c.get(n.value)||0;if(this.c.set(n.value,E+1),this.d-=1,this.d<=0){this.d=f*.5;let T,M=0;for(const[G,V]of this.c)(!T||M<V)&&(T=G,M=V);console.warn(`[${this.name}] potential listener LEAK detected, having ${r} listeners already. MOST frequent listener (${M}):`),console.warn(T)}return()=>{const T=this.c.get(n.value)||0;this.c.set(n.value,T-1)}}}class v{static create(){return new v(new Error().stack??"")}constructor(n){this.value=n}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class d{constructor(n,r,f){this.callback=n,this.callbackThis=r,this.stack=f,this.subscription=new k.SafeDisposable}invoke(n){this.callback.call(this.callbackThis,n)}}class m{constructor(n){this.j=!1,this.d=n,this.f=P>0||this.d?.leakWarningThreshold?new D(this.d?.leakWarningThreshold??P):void 0,this.g=this.d?._profName?new L(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(A){const n=Array.from(this.q);queueMicrotask(()=>{for(const r of n)r.subscription.isset()&&(r.subscription.unset(),r.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(n,r,f)=>{if(this.q||(this.q=new R.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),k.Disposable.None;const E=this.q.isEmpty();E&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let T,M;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(M=v.create(),T=this.f.check(M,this.q.size+1)),A&&(M=M??v.create());const G=new d(n,r,M),V=this.q.push(G);E&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,n,r);const N=G.subscription.set(()=>{T?.(),this.j||(V(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return f instanceof k.DisposableStore?f.add(N):Array.isArray(f)&&f.push(N),N}),this.l}fire(n){if(this.q){this.m||(this.m=new w);for(const r of this.q)this.m.push(this,r,n);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=m;class h{constructor(){this.c=new R.LinkedList}get size(){return this.c.size}push(n,r,f){this.c.push(new g(n,r,f))}clear(n){const r=new R.LinkedList;for(const f of this.c)f.emitter!==n&&r.push(f);this.c=r}deliver(){for(;this.c.size>0;){const n=this.c.shift();try{n.listener.invoke(n.event)}catch(r){(0,o.onUnexpectedError)(r)}}}}e.EventDeliveryQueue=h;class w extends h{clear(n){this.c.clear()}}class g{constructor(n,r,f){this.emitter=n,this.listener=r,this.event=f}}class p extends m{async fireAsync(n,r,f){if(!!this.q){this.c||(this.c=new R.LinkedList);for(const E of this.q)this.c.push([E,n]);for(;this.c.size>0&&!r.isCancellationRequested;){const[E,T]=this.c.shift(),M=[],G={...T,token:r,waitUntil:V=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");f&&(V=f(V,E.callback)),M.push(V)}};try{E.invoke(G)}catch(V){(0,o.onUnexpectedError)(V);continue}Object.freeze(M),await Promise.allSettled(M).then(V=>{for(const N of V)N.status==="rejected"&&(0,o.onUnexpectedError)(N.reason)})}}}}e.AsyncEmitter=p;class b extends m{constructor(n){super(n),this.h=0,this.s=new R.LinkedList,this.t=n?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const n=Array.from(this.s);this.s.clear(),super.fire(this.t(n))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(n){this.q&&(this.h!==0?this.s.push(n):super.fire(n))}}e.PauseableEmitter=b;class i extends b{constructor(n){super(n),this.c=n.delay??100}fire(n){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(n)}}e.DebounceEmitter=i;class s extends m{constructor(n){super(n),this.c=[],this.h=n?.merge}fire(n){!this.hasListeners()||(this.c.push(n),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(r=>super.fire(r)),this.c=[]}))}}e.MicrotaskEmitter=s;class a{constructor(){this.d=!1,this.f=[],this.c=new m({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(n){const r={event:n,listener:null};this.f.push(r),this.d&&this.j(r);const f=()=>{this.d&&this.k(r);const E=this.f.indexOf(r);this.f.splice(E,1)};return(0,k.toDisposable)((0,t.once)(f))}g(){this.d=!0,this.f.forEach(n=>this.j(n))}h(){this.d=!1,this.f.forEach(n=>this.k(n))}j(n){n.listener=n.event(r=>this.c.fire(r))}k(n){n.listener&&n.listener.dispose(),n.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=a;class u{constructor(){this.c=[]}wrapEvent(n){return(r,f,E)=>n(T=>{const M=this.c[this.c.length-1];M?M.push(()=>r.call(f,T)):r.call(f,T)},void 0,E)}bufferEvents(n){const r=[];this.c.push(r);const f=n();return this.c.pop(),r.forEach(E=>E()),f}}e.EventBufferer=u;class c{constructor(){this.c=!1,this.d=C.None,this.f=k.Disposable.None,this.g=new m({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(n){this.d=n,this.c&&(this.f.dispose(),this.f=n(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=c}),define(ye[21],Ce([1,0,4]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(A,S){const C=setTimeout(A.bind(S),0);return{dispose(){clearTimeout(C)}}});var k;(function(A){function S(C){return C===A.None||C===A.Cancelled||C instanceof R?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}A.isCancellationToken=S,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:o.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(k=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new o.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class I{constructor(S){this.a=void 0,this.b=void 0,this.b=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new R),this.a}cancel(){this.a?this.a instanceof R&&this.a.cancel():this.a=k.Cancelled}dispose(S=!1){S&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof R&&this.a.dispose():this.a=k.None}}e.CancellationTokenSource=I}),define(ye[159],Ce([1,0,21]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(A){this.b=A,this.a=null}get(){if(this.a)return this.a;const A=new o.CancellationTokenSource,S=this.b(A.token);return this.a={promise:S,dispose:()=>{this.a=null,A.cancel(),A.dispose()}},this.a}}e.Cache=t;class k{constructor(A){this.c=A,this.a=void 0,this.b=void 0}get(A){const S=JSON.stringify(A);return this.b!==S&&(this.b=S,this.a=this.c(A)),this.a}}e.LRUCachedFunction=k;class R{get cachedValues(){return this.a}constructor(A){this.b=A,this.a=new Map}get(A){if(this.a.has(A))return this.a.get(A);const S=this.b(A);return this.a.set(A,S),S}}e.CachedFunction=R}),define(ye[8],Ce([1,0,159,82]),function(ne,e,o,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R($){return!$||typeof $!="string"?!0:$.trim().length===0}e.isFalsyOrWhitespace=R;const I=/{(\d+)}/g;function A($,...ce){return ce.length===0?$:$.replace(I,function(Ie,Le){const Be=parseInt(Le,10);return isNaN(Be)||Be<0||Be>=ce.length?Ie:ce[Be]})}e.format=A;const S=/{([^}]+)}/g;function C($,ce){return $.replace(S,(Ie,Le)=>ce[Le]??Ie)}e.format2=C;function L($){return $.replace(/[<>&]/g,function(ce){switch(ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ce}})}e.escape=L;function P($){return $.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function y($,ce){let Ie=0;const Le=ce.charCodeAt(0);for(let Be=$.length-1;Be>=0;Be--)$.charCodeAt(Be)===Le&&Ie++;return Ie}e.count=y;function D($,ce,Ie="\u2026"){return $.length<=ce?$:`${$.substr(0,ce)}${Ie}`}e.truncate=D;function v($,ce=" "){const Ie=d($,ce);return m(Ie,ce)}e.trim=v;function d($,ce){if(!$||!ce)return $;const Ie=ce.length;if(Ie===0||$.length===0)return $;let Le=0;for(;$.indexOf(ce,Le)===Le;)Le=Le+Ie;return $.substring(Le)}e.ltrim=d;function m($,ce){if(!$||!ce)return $;const Ie=ce.length,Le=$.length;if(Ie===0||Le===0)return $;let Be=Le,xe=-1;for(;xe=$.lastIndexOf(ce,Be-1),!(xe===-1||xe+Ie!==Be);){if(xe===0)return"";Be=xe}return $.substring(0,Be)}e.rtrim=m;function h($){return $.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function w($){return $.replace(/\*/g,"")}e.stripWildcards=w;function g($,ce,Ie={}){if(!$)throw new Error("Cannot create regex from empty string");ce||($=P($)),Ie.wholeWord&&(/\B/.test($.charAt(0))||($="\\b"+$),/\B/.test($.charAt($.length-1))||($=$+"\\b"));let Le="";return Ie.global&&(Le+="g"),Ie.matchCase||(Le+="i"),Ie.multiline&&(Le+="m"),Ie.unicode&&(Le+="u"),new RegExp($,Le)}e.createRegExp=g;function p($){return $.source==="^"||$.source==="^$"||$.source==="$"||$.source==="^\\s*$"?!1:!!($.exec("")&&$.lastIndex===0)}e.regExpLeadsToEndlessLoop=p;function b($){return!!$.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=b;function i($){return($.global?"g":"")+($.ignoreCase?"i":"")+($.multiline?"m":"")+($.unicode?"u":"")}e.regExpFlags=i;function s($){return $.split(/\r\n|\r|\n/)}e.splitLines=s;function a($){for(let ce=0,Ie=$.length;ce<Ie;ce++){const Le=$.charCodeAt(ce);if(Le!==32&&Le!==9)return ce}return-1}e.firstNonWhitespaceIndex=a;function u($,ce=0,Ie=$.length){for(let Le=ce;Le<Ie;Le++){const Be=$.charCodeAt(Le);if(Be!==32&&Be!==9)return $.substring(ce,Le)}return $.substring(ce,Ie)}e.getLeadingWhitespace=u;function c($,ce=$.length-1){for(let Ie=ce;Ie>=0;Ie--){const Le=$.charCodeAt(Ie);if(Le!==32&&Le!==9)return Ie}return-1}e.lastNonWhitespaceIndex=c;function l($,ce,Ie){const Le=[];let Be=0;for(const xe of $.matchAll(ce)){if(Le.push($.slice(Be,xe.index)),xe.index===void 0)throw new Error("match.index should be defined");Be=xe.index+xe[0].length,Le.push(Ie(xe[0],...xe.slice(1),xe.index,$,xe.groups))}return Le.push($.slice(Be)),Promise.all(Le).then(xe=>xe.join(""))}e.replaceAsync=l;function n($,ce){return $<ce?-1:$>ce?1:0}e.compare=n;function r($,ce,Ie=0,Le=$.length,Be=0,xe=ce.length){for(;Ie<Le&&Be<xe;Ie++,Be++){const mt=$.charCodeAt(Ie),lt=ce.charCodeAt(Be);if(mt<lt)return-1;if(mt>lt)return 1}const Ze=Le-Ie,gt=xe-Be;return Ze<gt?-1:Ze>gt?1:0}e.compareSubstring=r;function f($,ce){return E($,ce,0,$.length,0,ce.length)}e.compareIgnoreCase=f;function E($,ce,Ie=0,Le=$.length,Be=0,xe=ce.length){for(;Ie<Le&&Be<xe;Ie++,Be++){let mt=$.charCodeAt(Ie),lt=ce.charCodeAt(Be);if(mt===lt)continue;if(mt>=128||lt>=128)return r($.toLowerCase(),ce.toLowerCase(),Ie,Le,Be,xe);M(mt)&&(mt-=32),M(lt)&&(lt-=32);const ot=mt-lt;if(ot!==0)return ot}const Ze=Le-Ie,gt=xe-Be;return Ze<gt?-1:Ze>gt?1:0}e.compareSubstringIgnoreCase=E;function T($){return $>=48&&$<=57}e.isAsciiDigit=T;function M($){return $>=97&&$<=122}e.isLowerAsciiLetter=M;function G($){return $>=65&&$<=90}e.isUpperAsciiLetter=G;function V($,ce){return $.length===ce.length&&E($,ce)===0}e.equalsIgnoreCase=V;function N($,ce){const Ie=ce.length;return ce.length>$.length?!1:E($,ce,0,Ie)===0}e.startsWithIgnoreCase=N;function U($,ce){const Ie=Math.min($.length,ce.length);let Le;for(Le=0;Le<Ie;Le++)if($.charCodeAt(Le)!==ce.charCodeAt(Le))return Le;return Ie}e.commonPrefixLength=U;function F($,ce){const Ie=Math.min($.length,ce.length);let Le;const Be=$.length-1,xe=ce.length-1;for(Le=0;Le<Ie;Le++)if($.charCodeAt(Be-Le)!==ce.charCodeAt(xe-Le))return Le;return Ie}e.commonSuffixLength=F;function z($){return 55296<=$&&$<=56319}e.isHighSurrogate=z;function B($){return 56320<=$&&$<=57343}e.isLowSurrogate=B;function W($,ce){return($-55296<<10)+(ce-56320)+65536}e.computeCodePoint=W;function X($,ce,Ie){const Le=$.charCodeAt(Ie);if(z(Le)&&Ie+1<ce){const Be=$.charCodeAt(Ie+1);if(B(Be))return W(Le,Be)}return Le}e.getNextCodePoint=X;function q($,ce){const Ie=$.charCodeAt(ce-1);if(B(Ie)&&ce>1){const Le=$.charCodeAt(ce-2);if(z(Le))return W(Le,Ie)}return Ie}class _{get offset(){return this.e}constructor(ce,Ie=0){this.c=ce,this.d=ce.length,this.e=Ie}setOffset(ce){this.e=ce}prevCodePoint(){const ce=q(this.c,this.e);return this.e-=ce>=65536?2:1,ce}nextCodePoint(){const ce=X(this.c,this.d,this.e);return this.e+=ce>=65536?2:1,ce}eol(){return this.e>=this.d}}e.CodePointIterator=_;class Q{get offset(){return this.c.offset}constructor(ce,Ie=0){this.c=new _(ce,Ie)}nextGraphemeLength(){const ce=et.getInstance(),Ie=this.c,Le=Ie.offset;let Be=ce.getGraphemeBreakType(Ie.nextCodePoint());for(;!Ie.eol();){const xe=Ie.offset,Ze=ce.getGraphemeBreakType(Ie.nextCodePoint());if(je(Be,Ze)){Ie.setOffset(xe);break}Be=Ze}return Ie.offset-Le}prevGraphemeLength(){const ce=et.getInstance(),Ie=this.c,Le=Ie.offset;let Be=ce.getGraphemeBreakType(Ie.prevCodePoint());for(;Ie.offset>0;){const xe=Ie.offset,Ze=ce.getGraphemeBreakType(Ie.prevCodePoint());if(je(Ze,Be)){Ie.setOffset(xe);break}Be=Ze}return Le-Ie.offset}eol(){return this.c.eol()}}e.GraphemeIterator=Q;function Z($,ce){return new Q($,ce).nextGraphemeLength()}e.nextCharLength=Z;function ge($,ce){return new Q($,ce).prevGraphemeLength()}e.prevCharLength=ge;function te($,ce){ce>0&&B($.charCodeAt(ce))&&ce--;const Ie=ce+Z($,ce);return[Ie-ge($,Ie),Ie]}e.getCharContainingOffset=te;function J($){const ce=new Q($);let Ie=0;for(;!ce.eol();)Ie++,ce.nextGraphemeLength();return Ie}e.charCount=J;let fe;function ve(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Ee($){return fe||(fe=ve()),fe.test($)}e.containsRTL=Ee;const Ae=/^[\t\n\r\x20-\x7E]*$/;function Fe($){return Ae.test($)}e.isBasicASCII=Fe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function se($){return e.UNUSUAL_LINE_TERMINATORS.test($)}e.containsUnusualLineTerminators=se;function le($){return $>=11904&&$<=55215||$>=63744&&$<=64255||$>=65281&&$<=65374}e.isFullWidthCharacter=le;function ue($){return $>=127462&&$<=127487||$===8986||$===8987||$===9200||$===9203||$>=9728&&$<=10175||$===11088||$===11093||$>=127744&&$<=128591||$>=128640&&$<=128764||$>=128992&&$<=129008||$>=129280&&$<=129535||$>=129648&&$<=129782}e.isEmojiImprecise=ue;function ee($,ce){if($.length<ce)return $;const Ie=/\b/g;let Le=0;for(;Ie.test($)&&!($.length-Ie.lastIndex<ce);)Le=Ie.lastIndex,Ie.lastIndex+=1;return $.substring(Le).replace(/^\s/,"")}e.lcut=ee;const ae=/\x1B\x5B[12]?K/g,ie=/\x1b\[\d+m/g,O=/\x1b\[0?m/g;function H($){return $&&($=$.replace(ae,""),$=$.replace(ie,""),$=$.replace(O,"")),$}e.removeAnsiEscapeCodes=H,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function x($){return!!($&&$.length>0&&$.charCodeAt(0)===65279)}e.startsWithUTF8BOM=x;function Y($){return x($)?$.substr(1):$}e.stripUTF8BOM=Y;function de($,ce){if(!$||!ce||$.length<ce.length)return!1;const Ie=ce.length,Le=$.toLowerCase();let Be=0,xe=-1;for(;Be<Ie;){const Ze=Le.indexOf(ce[Be],xe+1);if(Ze<0)return!1;xe=Ze,Be++}return!0}e.fuzzyContains=de;function be($,ce=!1){return $?(ce&&($=$.replace(/\\./g,"")),$.toLowerCase()!==$):!1}e.containsUppercaseCharacter=be;function Pe($){return $.charAt(0).toUpperCase()+$.slice(1)}e.uppercaseFirstLetter=Pe;function pe($,ce=1){if(ce===0)return"";let Ie=-1;do Ie=$.indexOf(`
`,Ie+1),ce--;while(ce>0&&Ie>=0);return Ie===-1?$:($[Ie-1]==="\r"&&Ie--,$.substr(0,Ie))}e.getNLines=pe;function De($){return $=$%(2*26),$<26?String.fromCharCode(97+$):String.fromCharCode(65+$-26)}e.singleLetterHash=De;function ke($){return et.getInstance().getGraphemeBreakType($)}e.getGraphemeBreakType=ke;function je($,ce){return $===0?ce!==5&&ce!==7:$===2&&ce===3?!1:$===4||$===2||$===3||ce===4||ce===2||ce===3?!0:!($===8&&(ce===8||ce===9||ce===11||ce===12)||($===11||$===9)&&(ce===9||ce===10)||($===12||$===10)&&ce===10||ce===5||ce===13||ce===7||$===1||$===13&&ce===14||$===6&&ce===6)}var Ge;(function($){$[$.Other=0]="Other",$[$.Prepend=1]="Prepend",$[$.CR=2]="CR",$[$.LF=3]="LF",$[$.Control=4]="Control",$[$.Extend=5]="Extend",$[$.Regional_Indicator=6]="Regional_Indicator",$[$.SpacingMark=7]="SpacingMark",$[$.L=8]="L",$[$.V=9]="V",$[$.T=10]="T",$[$.LV=11]="LV",$[$.LVT=12]="LVT",$[$.ZWJ=13]="ZWJ",$[$.Extended_Pictographic=14]="Extended_Pictographic"})(Ge=e.GraphemeBreakType||(e.GraphemeBreakType={}));class et{static getInstance(){return et.c||(et.c=new et),et.c}constructor(){this.d=_e()}getGraphemeBreakType(ce){if(ce<32)return ce===10?3:ce===13?2:4;if(ce<127)return 0;const Ie=this.d,Le=Ie.length/3;let Be=1;for(;Be<=Le;)if(ce<Ie[3*Be])Be=2*Be;else if(ce>Ie[3*Be+1])Be=2*Be+1;else return Ie[3*Be+2];return 0}}et.c=null;function _e(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function nt($,ce){if($===0)return 0;const Ie=st($,ce);if(Ie!==void 0)return Ie;const Le=new _(ce,$);return Le.prevCodePoint(),Le.offset}e.getLeftDeleteOffset=nt;function st($,ce){const Ie=new _(ce,$);let Le=Ie.prevCodePoint();for(;ht(Le)||Le===65039||Le===8419;){if(Ie.offset===0)return;Le=Ie.prevCodePoint()}if(!ue(Le))return;let Be=Ie.offset;return Be>0&&Ie.prevCodePoint()===8205&&(Be=Ie.offset),Be}function ht($){return 127995<=$&&$<=127999}var Me;(function($){$[$.zwj=8205]="zwj",$[$.emojiVariantSelector=65039]="emojiVariantSelector",$[$.enclosingKeyCap=8419]="enclosingKeyCap"})(Me||(Me={})),e.noBreakWhitespace="\xA0";class it{static getInstance(ce){return it.d.get(Array.from(ce))}static getLocales(){return it.e.getValue()}constructor(ce){this.f=ce}isAmbiguous(ce){return this.f.has(ce)}getPrimaryConfusable(ce){return this.f.get(ce)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=it,k=it,it.c=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),it.d=new o.LRUCachedFunction($=>{function ce(lt){const ot=new Map;for(let rt=0;rt<lt.length;rt+=2)ot.set(lt[rt],lt[rt+1]);return ot}function Ie(lt,ot){const rt=new Map(lt);for(const[kt,Tt]of ot)rt.set(kt,Tt);return rt}function Le(lt,ot){if(!lt)return ot;const rt=new Map;for(const[kt,Tt]of lt)ot.has(kt)&&rt.set(kt,Tt);return rt}const Be=k.c.getValue();let xe=$.filter(lt=>!lt.startsWith("_")&&lt in Be);xe.length===0&&(xe=["_default"]);let Ze;for(const lt of xe){const ot=ce(Be[lt]);Ze=Le(Ze,ot)}const gt=ce(Be._common),mt=Ie(gt,Ze);return new it(mt)}),it.e=new t.Lazy(()=>Object.keys(it.c.getValue()).filter($=>!$.startsWith("_")));class oe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(oe.c())),this.d}static isInvisibleCharacter(ce){return oe.e().has(ce)}static get codePoints(){return oe.e()}}e.InvisibleCharacters=oe,oe.d=void 0}),define(ye[32],Ce([1,0,9,12,8,11]),function(ne,e,o,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function I(c){return c===47||c===92}e.isPathSeparator=I;function A(c){return c.replace(/[\\/]/g,o.posix.sep)}e.toSlashes=A;function S(c){return c.indexOf("/")===-1&&(c=A(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.toPosixPath=S;function C(c,l=o.posix.sep){if(!c)return"";const n=c.length,r=c.charCodeAt(0);if(I(r)){if(I(c.charCodeAt(1))&&!I(c.charCodeAt(2))){let E=3;const T=E;for(;E<n&&!I(c.charCodeAt(E));E++);if(T!==E&&!I(c.charCodeAt(E+1))){for(E+=1;E<n;E++)if(I(c.charCodeAt(E)))return c.slice(0,E+1).replace(/[\\/]/g,l)}}return l}else if(h(r)&&c.charCodeAt(1)===58)return I(c.charCodeAt(2))?c.slice(0,2)+l:c.slice(0,2);let f=c.indexOf("://");if(f!==-1){for(f+=3;f<n;f++)if(I(c.charCodeAt(f)))return c.slice(0,f+1)}return""}e.getRoot=C;function L(c){if(!t.isWindows||!c||c.length<5)return!1;let l=c.charCodeAt(0);if(l!==92||(l=c.charCodeAt(1),l!==92))return!1;let n=2;const r=n;for(;n<c.length&&(l=c.charCodeAt(n),l!==92);n++);return!(r===n||(l=c.charCodeAt(n+1),isNaN(l)||l===92))}e.isUNC=L;const P=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,D=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(c,l=t.isWindows){const n=l?P:y;return!(!c||c.length===0||/^\s+$/.test(c)||(n.lastIndex=0,n.test(c))||l&&D.test(c)||c==="."||c===".."||l&&c[c.length-1]==="."||l&&c.length!==c.trim().length||c.length>255)}e.isValidBasename=v;function d(c,l,n){const r=c===l;return!n||r?r:!c||!l?!1:(0,k.equalsIgnoreCase)(c,l)}e.isEqual=d;function m(c,l,n,r=o.sep){if(c===l)return!0;if(!c||!l||l.length>c.length)return!1;if(n){if(!(0,k.startsWithIgnoreCase)(c,l))return!1;if(l.length===c.length)return!0;let E=l.length;return l.charAt(l.length-1)===r&&E--,c.charAt(E)===r}return l.charAt(l.length-1)!==r&&(l+=r),c.indexOf(l)===0}e.isEqualOrParent=m;function h(c){return c>=65&&c<=90||c>=97&&c<=122}e.isWindowsDriveLetter=h;function w(c,l){return t.isWindows&&c.endsWith(":")&&(c+=o.sep),(0,o.isAbsolute)(c)||(c=(0,o.join)(l,c)),c=(0,o.normalize)(c),t.isWindows?(c=(0,k.rtrim)(c,o.sep),c.endsWith(":")&&(c+=o.sep)):(c=(0,k.rtrim)(c,o.sep),c||(c=o.sep)),c}e.sanitizeFilePath=w;function g(c){const l=(0,o.normalize)(c);return t.isWindows?c.length>3?!1:p(l)&&(c.length===2||l.charCodeAt(2)===92):l===o.posix.sep}e.isRootOrDriveLetter=g;function p(c,l=t.isWindows){return l?h(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function b(c){return p(c)?c[0]:void 0}e.getDriveLetter=b;function i(c,l,n){return l.length>c.length?-1:c===l?0:(n&&(c=c.toLowerCase(),l=l.toLowerCase()),c.indexOf(l))}e.indexOfPath=i;function s(c){const l=c.split(":");let n,r,f;for(const E of l){const T=Number(E);(0,R.isNumber)(T)?r===void 0?r=T:f===void 0&&(f=T):n=n?[n,E].join(":"):E}if(!n)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:n,line:r!==void 0?r:void 0,column:f!==void 0?f:r!==void 0?1:void 0}}e.parseLineAndColumnAware=s;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function u(c,l,n=8){let r="";for(let E=0;E<n;E++)r+=a.charAt(Math.floor(Math.random()*a.length));let f;return l?f=`${l}-${r}`:f=r,c?(0,o.join)(c,f):f}e.randomPath=u}),define(ye[108],Ce([1,0,28,8]),function(ne,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function k(...ie){return function(O,H){for(let x=0,Y=ie.length;x<Y;x++){const de=ie[x](O,H);if(de)return de}return null}}e.or=k,e.matchesStrictPrefix=R.bind(void 0,!1),e.matchesPrefix=R.bind(void 0,!0);function R(ie,O,H){if(!H||H.length<O.length)return null;let x;return ie?x=t.startsWithIgnoreCase(H,O):x=H.indexOf(O)===0,x?O.length>0?[{start:0,end:O.length}]:[]:null}function I(ie,O){const H=O.toLowerCase().indexOf(ie.toLowerCase());return H===-1?null:[{start:H,end:H+ie.length}]}e.matchesContiguousSubString=I;function A(ie,O){return S(ie.toLowerCase(),O.toLowerCase(),0,0)}e.matchesSubString=A;function S(ie,O,H,x){if(H===ie.length)return[];if(x===O.length)return null;if(ie[H]===O[x]){let Y=null;return(Y=S(ie,O,H+1,x+1))?h({start:x,end:x+1},Y):null}return S(ie,O,H,x+1)}function C(ie){return 97<=ie&&ie<=122}function L(ie){return 65<=ie&&ie<=90}e.isUpper=L;function P(ie){return 48<=ie&&ie<=57}function y(ie){return ie===32||ie===9||ie===10||ie===13}const D=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ie=>D.add(ie.charCodeAt(0)));function v(ie){return y(ie)||D.has(ie)}function d(ie,O){return ie===O||v(ie)&&v(O)}function m(ie){return C(ie)||L(ie)||P(ie)}function h(ie,O){return O.length===0?O=[ie]:ie.end===O[0].start?O[0].start=ie.start:O.unshift(ie),O}function w(ie,O){for(let H=O;H<ie.length;H++){const x=ie.charCodeAt(H);if(L(x)||P(x)||H>0&&!m(ie.charCodeAt(H-1)))return H}return ie.length}function g(ie,O,H,x){if(H===ie.length)return[];if(x===O.length)return null;if(ie[H]!==O[x].toLowerCase())return null;{let Y=null,de=x+1;for(Y=g(ie,O,H+1,x+1);!Y&&(de=w(O,de))<O.length;)Y=g(ie,O,H+1,de),de++;return Y===null?null:h({start:x,end:x+1},Y)}}function p(ie){let O=0,H=0,x=0,Y=0,de=0;for(let ke=0;ke<ie.length;ke++)de=ie.charCodeAt(ke),L(de)&&O++,C(de)&&H++,m(de)&&x++,P(de)&&Y++;const be=O/ie.length,Pe=H/ie.length,pe=x/ie.length,De=Y/ie.length;return{upperPercent:be,lowerPercent:Pe,alphaPercent:pe,numericPercent:De}}function b(ie){const{upperPercent:O,lowerPercent:H}=ie;return H===0&&O>.6}function i(ie){const{upperPercent:O,lowerPercent:H,alphaPercent:x,numericPercent:Y}=ie;return H>.2&&O<.8&&x>.6&&Y<.2}function s(ie){let O=0,H=0,x=0,Y=0;for(let de=0;de<ie.length;de++)x=ie.charCodeAt(de),L(x)&&O++,C(x)&&H++,y(x)&&Y++;return(O===0||H===0)&&Y===0?ie.length<=30:O<=5}function a(ie,O){if(!O||(O=O.trim(),O.length===0)||!s(ie)||O.length>60)return null;const H=p(O);if(!i(H)){if(!b(H))return null;O=O.toLowerCase()}let x=null,Y=0;for(ie=ie.toLowerCase();Y<O.length&&(x=g(ie,O,0,Y))===null;)Y=w(O,Y+1);return x}e.matchesCamelCase=a;function u(ie,O,H=!1){if(!O||O.length===0)return null;let x=null,Y=0;for(ie=ie.toLowerCase(),O=O.toLowerCase();Y<O.length&&(x=c(ie,O,0,Y,H))===null;)Y=l(O,Y+1);return x}e.matchesWords=u;function c(ie,O,H,x,Y){if(H===ie.length)return[];if(x===O.length)return null;if(d(ie.charCodeAt(H),O.charCodeAt(x))){let de=null,be=x+1;if(de=c(ie,O,H+1,x+1,Y),!Y)for(;!de&&(be=l(O,be))<O.length;)de=c(ie,O,H+1,be,Y),be++;return de?ie.charCodeAt(H)!==O.charCodeAt(x)?de:h({start:x,end:x+1},de):null}else return null}function l(ie,O){for(let H=O;H<ie.length;H++)if(v(ie.charCodeAt(H))||H>0&&v(ie.charCodeAt(H-1)))return H;return ie.length}const n=k(e.matchesPrefix,a,I),r=k(e.matchesPrefix,a,A),f=new o.LRUCache(1e4);function E(ie,O,H=!1){if(typeof ie!="string"||typeof O!="string")return null;let x=f.get(ie);x||(x=new RegExp(t.convertSimple2RegExpPattern(ie),"i"),f.set(ie,x));const Y=x.exec(O);return Y?[{start:Y.index,end:Y.index+Y[0].length}]:H?r(ie,O):n(ie,O)}e.matchesFuzzy=E;function T(ie,O){const H=Ae(ie,ie.toLowerCase(),0,O,O.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return H?G(H):null}e.matchesFuzzy2=T;function M(ie,O,H,x,Y,de){const be=Math.min(13,ie.length);for(;H<be;H++){const Pe=Ae(ie,O,H,x,Y,de,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Pe)return Pe}return[0,de]}e.anyScore=M;function G(ie){if(typeof ie>"u")return[];const O=[],H=ie[1];for(let x=ie.length-1;x>1;x--){const Y=ie[x]+H,de=O[O.length-1];de&&de.end===Y?de.end=Y+1:O.push({start:Y,end:Y+1})}return O}e.createMatches=G;const V=128;function N(){const ie=[],O=[];for(let H=0;H<=V;H++)O[H]=0;for(let H=0;H<=V;H++)ie.push(O.slice(0));return ie}function U(ie){const O=[];for(let H=0;H<=ie;H++)O[H]=0;return O}const F=U(2*V),z=U(2*V),B=N(),W=N(),X=N(),q=!1;function _(ie,O,H,x,Y){function de(Pe,pe,De=" "){for(;Pe.length<pe;)Pe=De+Pe;return Pe}let be=` |   |${x.split("").map(Pe=>de(Pe,3)).join("|")}
`;for(let Pe=0;Pe<=H;Pe++)Pe===0?be+=" |":be+=`${O[Pe-1]}|`,be+=ie[Pe].slice(0,Y+1).map(pe=>de(pe.toString(),3)).join("|")+`
`;return be}function Q(ie,O,H,x){ie=ie.substr(O),H=H.substr(x),console.log(_(W,ie,ie.length,H,H.length)),console.log(_(X,ie,ie.length,H,H.length)),console.log(_(B,ie,ie.length,H,H.length))}function Z(ie,O){if(O<0||O>=ie.length)return!1;const H=ie.codePointAt(O);switch(H){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(H)}}function ge(ie,O){if(O<0||O>=ie.length)return!1;switch(ie.charCodeAt(O)){case 32:case 9:return!0;default:return!1}}function te(ie,O,H){return O[ie]!==H[ie]}function J(ie,O,H,x,Y,de,be=!1){for(;O<H&&Y<de;)ie[O]===x[Y]&&(be&&(F[O]=Y),O+=1),Y+=1;return O===H}e.isPatternInWord=J;var fe;(function(ie){ie[ie.Diag=1]="Diag",ie[ie.Left=2]="Left",ie[ie.LeftLeft=3]="LeftLeft"})(fe||(fe={}));var ve;(function(ie){ie.Default=[-100,0];function O(H){return!H||H.length===2&&H[0]===-100&&H[1]===0}ie.isDefault=O})(ve=e.FuzzyScore||(e.FuzzyScore={}));class Ee{constructor(O,H){this.firstMatchCanBeWeak=O,this.boostFullMatch=H}}e.FuzzyScoreOptions=Ee,Ee.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Ae(ie,O,H,x,Y,de,be=Ee.default){const Pe=ie.length>V?V:ie.length,pe=x.length>V?V:x.length;if(H>=Pe||de>=pe||Pe-H>pe-de||!J(O,H,Pe,Y,de,pe,!0))return;Fe(Pe,pe,H,de,O,Y);let De=1,ke=1,je=H,Ge=de;const et=[!1];for(De=1,je=H;je<Pe;De++,je++){const Me=F[je],it=z[je],oe=je+1<Pe?z[je+1]:pe;for(ke=Me-de+1,Ge=Me;Ge<oe;ke++,Ge++){let $=Number.MIN_SAFE_INTEGER,ce=!1;Ge<=it&&($=se(ie,O,je,H,x,Y,Ge,pe,de,B[De-1][ke-1]===0,et));let Ie=0;$!==Number.MAX_SAFE_INTEGER&&(ce=!0,Ie=$+W[De-1][ke-1]);const Le=Ge>Me,Be=Le?W[De][ke-1]+(B[De][ke-1]>0?-5:0):0,xe=Ge>Me+1&&B[De][ke-1]>0,Ze=xe?W[De][ke-2]+(B[De][ke-2]>0?-5:0):0;if(xe&&(!Le||Ze>=Be)&&(!ce||Ze>=Ie))W[De][ke]=Ze,X[De][ke]=3,B[De][ke]=0;else if(Le&&(!ce||Be>=Ie))W[De][ke]=Be,X[De][ke]=2,B[De][ke]=0;else if(ce)W[De][ke]=Ie,X[De][ke]=1,B[De][ke]=B[De-1][ke-1]+1;else throw new Error("not possible")}}if(q&&Q(ie,H,x,de),!et[0]&&!be.firstMatchCanBeWeak)return;De--,ke--;const _e=[W[De][ke],de];let nt=0,st=0;for(;De>=1;){let Me=ke;do{const it=X[De][Me];if(it===3)Me=Me-2;else if(it===2)Me=Me-1;else break}while(Me>=1);nt>1&&O[H+De-1]===Y[de+ke-1]&&!te(Me+de-1,x,Y)&&nt+1>B[De][Me]&&(Me=ke),Me===ke?nt++:nt=1,st||(st=Me),De--,ke=Me-1,_e.push(ke)}pe===Pe&&be.boostFullMatch&&(_e[0]+=2);const ht=st-Pe;return _e[0]-=ht,_e}e.fuzzyScore=Ae;function Fe(ie,O,H,x,Y,de){let be=ie-1,Pe=O-1;for(;be>=H&&Pe>=x;)Y[be]===de[Pe]&&(z[be]=Pe,be--),Pe--}function se(ie,O,H,x,Y,de,be,Pe,pe,De,ke){if(O[H]!==de[be])return Number.MIN_SAFE_INTEGER;let je=1,Ge=!1;return be===H-x?je=ie[H]===Y[be]?7:5:te(be,Y,de)&&(be===0||!te(be-1,Y,de))?(je=ie[H]===Y[be]?7:5,Ge=!0):Z(de,be)&&(be===0||!Z(de,be-1))?je=5:(Z(de,be-1)||ge(de,be-1))&&(je=5,Ge=!0),je>1&&H===x&&(ke[0]=!0),Ge||(Ge=te(be,Y,de)||Z(de,be-1)||ge(de,be-1)),H===x?be>pe&&(je-=Ge?3:5):De?je+=Ge?2:0:je+=Ge?0:1,be+1===Pe&&(je-=Ge?3:5),je}function le(ie,O,H,x,Y,de,be){return ee(ie,O,H,x,Y,de,!0,be)}e.fuzzyScoreGracefulAggressive=le;function ue(ie,O,H,x,Y,de,be){return ee(ie,O,H,x,Y,de,!1,be)}e.fuzzyScoreGraceful=ue;function ee(ie,O,H,x,Y,de,be,Pe){let pe=Ae(ie,O,H,x,Y,de,Pe);if(pe&&!be)return pe;if(ie.length>=3){const De=Math.min(7,ie.length-1);for(let ke=H+1;ke<De;ke++){const je=ae(ie,ke);if(je){const Ge=Ae(je,je.toLowerCase(),H,x,Y,de,Pe);Ge&&(Ge[0]-=3,(!pe||Ge[0]>pe[0])&&(pe=Ge))}}}return pe}function ae(ie,O){if(O+1>=ie.length)return;const H=ie[O],x=ie[O+1];if(H!==x)return ie.slice(0,O)+x+H+ie.slice(O+2)}}),define(ye[85],Ce([1,0,8]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(h){return k(h,0)}e.hash=t;function k(h,w){switch(typeof h){case"object":return h===null?R(349,w):Array.isArray(h)?S(h,w):C(h,w);case"string":return A(h,w);case"boolean":return I(h,w);case"number":return R(h,w);case"undefined":return R(937,w);default:return R(617,w)}}e.doHash=k;function R(h,w){return(w<<5)-w+h|0}e.numberHash=R;function I(h,w){return R(h?433:863,w)}function A(h,w){w=R(149417,w);for(let g=0,p=h.length;g<p;g++)w=R(h.charCodeAt(g),w);return w}e.stringHash=A;function S(h,w){return w=R(104579,w),h.reduce((g,p)=>k(p,g),w)}function C(h,w){return w=R(181387,w),Object.keys(h).sort().reduce((g,p)=>(g=A(p,g),k(h[p],g)),w)}class L{constructor(){this.g=0}get value(){return this.g}hash(w){return this.g=k(w,this.g),this.g}}e.Hasher=L;var P;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function y(h,w,g=32){const p=g-w,b=~((1<<p)-1);return(h<<w|(b&h)>>>p)>>>0}function D(h,w=0,g=h.byteLength,p=0){for(let b=0;b<g;b++)h[w+b]=p}function v(h,w,g="0"){for(;h.length<w;)h=g+h;return h}function d(h,w=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(g=>g.toString(16).padStart(2,"0")).join(""):v((h>>>0).toString(16),w/4)}e.toHexString=d;class m{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(w){const g=w.length;if(g===0)return;const p=this.p;let b=this.r,i=this.u,s,a;for(i!==0?(s=i,a=-1,i=0):(s=w.charCodeAt(0),a=0);;){let u=s;if(o.isHighSurrogate(s))if(a+1<g){const c=w.charCodeAt(a+1);o.isLowSurrogate(c)?(a++,u=o.computeCodePoint(s,c)):u=65533}else{i=s;break}else o.isLowSurrogate(s)&&(u=65533);if(b=this.w(p,b,u),a++,a<g)s=w.charCodeAt(a);else break}this.r=b,this.u=i}w(w,g,p){return p<128?w[g++]=p:p<2048?(w[g++]=192|(p&1984)>>>6,w[g++]=128|(p&63)>>>0):p<65536?(w[g++]=224|(p&61440)>>>12,w[g++]=128|(p&4032)>>>6,w[g++]=128|(p&63)>>>0):(w[g++]=240|(p&1835008)>>>18,w[g++]=128|(p&258048)>>>12,w[g++]=128|(p&4032)>>>6,w[g++]=128|(p&63)>>>0),g>=64&&(this.y(),g-=64,this.t+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),g}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),d(this.h)+d(this.l)+d(this.m)+d(this.n)+d(this.o)}x(){this.p[this.r++]=128,D(this.p,this.r),this.r>56&&(this.y(),D(this.p));const w=8*this.t;this.q.setUint32(56,Math.floor(w/4294967296),!1),this.q.setUint32(60,w%4294967296,!1),this.y()}y(){const w=m.g,g=this.q;for(let n=0;n<64;n+=4)w.setUint32(n,g.getUint32(n,!1),!1);for(let n=64;n<320;n+=4)w.setUint32(n,y(w.getUint32(n-12,!1)^w.getUint32(n-32,!1)^w.getUint32(n-56,!1)^w.getUint32(n-64,!1),1),!1);let p=this.h,b=this.l,i=this.m,s=this.n,a=this.o,u,c,l;for(let n=0;n<80;n++)n<20?(u=b&i|~b&s,c=1518500249):n<40?(u=b^i^s,c=1859775393):n<60?(u=b&i|b&s|i&s,c=2400959708):(u=b^i^s,c=3395469782),l=y(p,5)+u+a+c+w.getUint32(n*4,!1)&4294967295,a=s,s=i,i=y(b,30),b=p,p=l;this.h=this.h+p&4294967295,this.l=this.l+b&4294967295,this.m=this.m+i&4294967295,this.n=this.n+s&4294967295,this.o=this.o+a&4294967295}}e.StringSHA1=m,m.g=new DataView(new ArrayBuffer(320))}),define(ye[160],Ce([1,0,80,108,8]),function(ne,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const R="$(",I=new RegExp(`\\$\\(${o.CSSIcon.iconNameExpression}(?:${o.CSSIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${I.source}`,"g");function S(m){return m.replace(A,(h,w)=>w?h:`\\${h}`)}e.escapeIcons=S;const C=new RegExp(`\\\\${I.source}`,"g");function L(m){return m.replace(C,h=>`\\${h}`)}e.markdownEscapeEscapedIcons=L;const P=new RegExp(`(\\s)?(\\\\)?${I.source}(\\s)?`,"g");function y(m){return m.indexOf(R)===-1?m:m.replace(P,(h,w,g,p)=>g?h:w||p||"")}e.stripIcons=y;const D=new RegExp(`\\$\\(${o.CSSIcon.iconNameCharacter}+\\)`,"g");function v(m){D.lastIndex=0;let h="";const w=[];let g=0;for(;;){const p=D.lastIndex,b=D.exec(m),i=m.substring(p,b?.index);if(i.length>0){h+=i;for(let s=0;s<i.length;s++)w.push(g)}if(!b)break;g+=b[0].length}return{text:h,iconOffsets:w}}e.parseLabelWithIcons=v;function d(m,h,w=!1){const{text:g,iconOffsets:p}=h;if(!p||p.length===0)return(0,t.matchesFuzzy)(m,g,w);const b=(0,k.ltrim)(g," "),i=g.length-b.length,s=(0,t.matchesFuzzy)(m,b,w);if(s)for(const a of s){const u=p[a.start+i]+i;a.start+=u,a.end+=u}return s}e.matchesFuzzyIconAware=d}),define(ye[43],Ce([1,0,8]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(t||(t={})),function(k){const R="error",I="warning",A="warn",S="info",C="ignore";function L(y){return y?o.equalsIgnoreCase(R,y)?k.Error:o.equalsIgnoreCase(I,y)||o.equalsIgnoreCase(A,y)?k.Warning:o.equalsIgnoreCase(S,y)?k.Info:k.Ignore:k.Ignore}k.fromValue=L;function P(y){switch(y){case k.Error:return R;case k.Warning:return I;case k.Info:return S;default:return C}}k.toString=P}(t||(t={})),e.default=t}),define(ye[64],Ce([1,0,18,8]),function(ne,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class k{constructor(){this.b="",this.c=0}reset(D){return this.b=D,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(D){const v=D.charCodeAt(0),d=this.b.charCodeAt(this.c);return v-d}value(){return this.b[this.c]}}e.StringIterator=k;class R{constructor(D=!0){this.e=D}reset(D){return this.b=D,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let D=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(D)this.c++;else break;else D=!1;return this}cmp(D){return this.e?(0,t.compareSubstring)(D,this.b,0,D.length,this.c,this.d):(0,t.compareSubstringIgnoreCase)(D,this.b,0,D.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=R;class I{constructor(D=!0,v=!0){this.f=D,this.g=v}reset(D){this.d=0,this.e=0,this.b=D,this.c=D.length;for(let v=D.length-1;v>=0;v--,this.c--){const d=this.b.charCodeAt(v);if(!(d===47||this.f&&d===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let D=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(D)this.d++;else break;else D=!1}return this}cmp(D){return this.g?(0,t.compareSubstring)(D,this.b,0,D.length,this.d,this.e):(0,t.compareSubstringIgnoreCase)(D,this.b,0,D.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=I;var A;(function(y){y[y.Scheme=1]="Scheme",y[y.Authority=2]="Authority",y[y.Path=3]="Path",y[y.Query=4]="Query",y[y.Fragment=5]="Fragment"})(A||(A={}));class S{constructor(D,v){this.f=D,this.g=v,this.d=[],this.e=0}reset(D){return this.c=D,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new I(!1,!this.f(D)),this.b.reset(D.path),this.b.value()&&this.d.push(3)),this.g(D)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(D){if(this.d[this.e]===1)return(0,t.compareIgnoreCase)(D,this.c.scheme);if(this.d[this.e]===2)return(0,t.compareIgnoreCase)(D,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(D);if(this.d[this.e]===4)return(0,t.compare)(D,this.c.query);if(this.d[this.e]===5)return(0,t.compare)(D,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=S;class C{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const D=this.right;return this.right=D.left,D.left=this,this.updateHeight(),D.updateHeight(),D}rotateRight(){const D=this.left;return this.left=D.right,D.right=this,this.updateHeight(),D.updateHeight(),D}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var L;(function(y){y[y.Left=-1]="Left",y[y.Mid=0]="Mid",y[y.Right=1]="Right"})(L||(L={}));class P{static forUris(D=()=>!1,v=()=>!1){return new P(new S(D,v))}static forPaths(D=!1){return new P(new I(void 0,!D))}static forStrings(){return new P(new k)}static forConfigKeys(){return new P(new R)}constructor(D){this.b=D}clear(){this.c=void 0}fill(D,v){if(v){const d=v.slice(0);(0,o.shuffle)(d);for(const m of d)this.set(m,D)}else{const d=D.slice(0);(0,o.shuffle)(d);for(const m of d)this.set(m[0],m[1])}}set(D,v){const d=this.b.reset(D);let m;this.c||(this.c=new C,this.c.segment=d.value());const h=[];for(m=this.c;;){const g=d.cmp(m.segment);if(g>0)m.left||(m.left=new C,m.left.segment=d.value()),h.push([-1,m]),m=m.left;else if(g<0)m.right||(m.right=new C,m.right.segment=d.value()),h.push([1,m]),m=m.right;else if(d.hasNext())d.next(),m.mid||(m.mid=new C,m.mid.segment=d.value()),h.push([0,m]),m=m.mid;else break}const w=m.value;m.value=v,m.key=D;for(let g=h.length-1;g>=0;g--){const p=h[g][1];p.updateHeight();const b=p.balanceFactor();if(b<-1||b>1){const i=h[g][0],s=h[g+1][0];if(i===1&&s===1)h[g][1]=p.rotateLeft();else if(i===-1&&s===-1)h[g][1]=p.rotateRight();else if(i===1&&s===-1)p.right=h[g+1][1]=h[g+1][1].rotateRight(),h[g][1]=p.rotateLeft();else if(i===-1&&s===1)p.left=h[g+1][1]=h[g+1][1].rotateLeft(),h[g][1]=p.rotateRight();else throw new Error;if(g>0)switch(h[g-1][0]){case-1:h[g-1][1].left=h[g][1];break;case 1:h[g-1][1].right=h[g][1];break;case 0:h[g-1][1].mid=h[g][1];break}else this.c=h[0][1]}}return w}get(D){return this.d(D)?.value}d(D){const v=this.b.reset(D);let d=this.c;for(;d;){const m=v.cmp(d.segment);if(m>0)d=d.left;else if(m<0)d=d.right;else if(v.hasNext())v.next(),d=d.mid;else break}return d}has(D){const v=this.d(D);return!(v?.value===void 0&&v?.mid===void 0)}delete(D){return this.e(D,!1)}deleteSuperstr(D){return this.e(D,!0)}e(D,v){const d=this.b.reset(D),m=[];let h=this.c;for(;h;){const w=d.cmp(h.segment);if(w>0)m.push([-1,h]),h=h.left;else if(w<0)m.push([1,h]),h=h.right;else if(d.hasNext())d.next(),m.push([0,h]),h=h.mid;else break}if(!!h){if(v?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const w=this.f(h.right);if(w.key){const{key:g,value:p,segment:b}=w;this.e(w.key,!1),h.key=g,h.value=p,h.segment=b}}else{const w=h.left??h.right;if(m.length>0){const[g,p]=m[m.length-1];switch(g){case-1:p.left=w;break;case 0:p.mid=w;break;case 1:p.right=w;break}}else this.c=w}for(let w=m.length-1;w>=0;w--){const g=m[w][1];g.updateHeight();const p=g.balanceFactor();if(p>1?(g.right.balanceFactor()>=0||(g.right=g.right.rotateRight()),m[w][1]=g.rotateLeft()):p<-1&&(g.left.balanceFactor()<=0||(g.left=g.left.rotateLeft()),m[w][1]=g.rotateRight()),w>0)switch(m[w-1][0]){case-1:m[w-1][1].left=m[w][1];break;case 1:m[w-1][1].right=m[w][1];break;case 0:m[w-1][1].mid=m[w][1];break}else this.c=m[0][1]}}}f(D){for(;D.left;)D=D.left;return D}findSubstr(D){const v=this.b.reset(D);let d=this.c,m;for(;d;){const h=v.cmp(d.segment);if(h>0)d=d.left;else if(h<0)d=d.right;else if(v.hasNext())v.next(),m=d.value||m,d=d.mid;else break}return d&&d.value||m}findSuperstr(D){const v=this.b.reset(D);let d=this.c;for(;d;){const m=v.cmp(d.segment);if(m>0)d=d.left;else if(m<0)d=d.right;else if(v.hasNext())v.next(),d=d.mid;else return d.mid?this.g(d.mid):void 0}}forEach(D){for(const[v,d]of this)D(d,v)}*[Symbol.iterator](){yield*this.g(this.c)}g(D){const v=[];return this.h(D,v),v[Symbol.iterator]()}h(D,v){!D||(D.left&&this.h(D.left,v),D.value&&v.push([D.key,D.value]),D.mid&&this.h(D.mid,v),D.right&&this.h(D.right,v))}_isBalanced(){const D=v=>{if(!v)return!0;const d=v.balanceFactor();return d<-1||d>1?!1:D(v.left)&&D(v.right)};return D(this.c)}}e.TernarySearchTree=P}),define(ye[2],Ce([1,0,9,12]),function(ne,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,R=/^\//,I=/^\/\//;function A(a,u){if(!a.scheme&&u)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${a.authority}", path: "${a.path}", query: "${a.query}", fragment: "${a.fragment}"}`);if(a.scheme&&!k.test(a.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(a.path){if(a.authority){if(!R.test(a.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(I.test(a.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(a,u){return!a&&!u?"file":a}function C(a,u){switch(a){case"https":case"http":case"file":u?u[0]!==P&&(u=P+u):u=P;break}return u}const L="",P="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class D{static isUri(u){return u instanceof D?!0:u?typeof u.authority=="string"&&typeof u.fragment=="string"&&typeof u.path=="string"&&typeof u.query=="string"&&typeof u.scheme=="string"&&typeof u.fsPath=="string"&&typeof u.with=="function"&&typeof u.toString=="function":!1}constructor(u,c,l,n,r,f=!1){typeof u=="object"?(this.scheme=u.scheme||L,this.authority=u.authority||L,this.path=u.path||L,this.query=u.query||L,this.fragment=u.fragment||L):(this.scheme=S(u,f),this.authority=c||L,this.path=C(this.scheme,l||L),this.query=n||L,this.fragment=r||L,A(this,f))}get fsPath(){return g(this,!1)}with(u){if(!u)return this;let{scheme:c,authority:l,path:n,query:r,fragment:f}=u;return c===void 0?c=this.scheme:c===null&&(c=L),l===void 0?l=this.authority:l===null&&(l=L),n===void 0?n=this.path:n===null&&(n=L),r===void 0?r=this.query:r===null&&(r=L),f===void 0?f=this.fragment:f===null&&(f=L),c===this.scheme&&l===this.authority&&n===this.path&&r===this.query&&f===this.fragment?this:new d(c,l,n,r,f)}static parse(u,c=!1){const l=y.exec(u);return l?new d(l[2]||L,s(l[4]||L),s(l[5]||L),s(l[7]||L),s(l[9]||L),c):new d(L,L,L,L,L)}static file(u){let c=L;if(t.isWindows&&(u=u.replace(/\\/g,P)),u[0]===P&&u[1]===P){const l=u.indexOf(P,2);l===-1?(c=u.substring(2),u=P):(c=u.substring(2,l),u=u.substring(l)||P)}return new d("file",c,u,L,L)}static from(u){const c=new d(u.scheme,u.authority,u.path,u.query,u.fragment);return A(c,!0),c}static joinPath(u,...c){if(!u.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return t.isWindows&&u.scheme==="file"?l=D.file(o.win32.join(g(u,!0),...c)).path:l=o.posix.join(u.path,...c),u.with({path:l})}toString(u=!1){return p(this,u)}toJSON(){return this}static revive(u){if(u){if(u instanceof D)return u;{const c=new d(u);return c._formatted=u.external,c._fsPath=u._sep===v?u.fsPath:null,c}}else return u}}e.URI=D;const v=t.isWindows?1:void 0;class d extends D{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(u=!1){return u?p(this,!0):(this._formatted||(this._formatted=p(this,!1)),this._formatted)}toJSON(){const u={$mid:1};return this._fsPath&&(u.fsPath=this._fsPath,u._sep=v),this._formatted&&(u.external=this._formatted),this.path&&(u.path=this.path),this.scheme&&(u.scheme=this.scheme),this.authority&&(u.authority=this.authority),this.query&&(u.query=this.query),this.fragment&&(u.fragment=this.fragment),u}}const m={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(a,u,c){let l,n=-1;for(let r=0;r<a.length;r++){const f=a.charCodeAt(r);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||u&&f===47||c&&f===91||c&&f===93||c&&f===58)n!==-1&&(l+=encodeURIComponent(a.substring(n,r)),n=-1),l!==void 0&&(l+=a.charAt(r));else{l===void 0&&(l=a.substr(0,r));const E=m[f];E!==void 0?(n!==-1&&(l+=encodeURIComponent(a.substring(n,r)),n=-1),l+=E):n===-1&&(n=r)}}return n!==-1&&(l+=encodeURIComponent(a.substring(n))),l!==void 0?l:a}function w(a){let u;for(let c=0;c<a.length;c++){const l=a.charCodeAt(c);l===35||l===63?(u===void 0&&(u=a.substr(0,c)),u+=m[l]):u!==void 0&&(u+=a[c])}return u!==void 0?u:a}function g(a,u){let c;return a.authority&&a.path.length>1&&a.scheme==="file"?c=`//${a.authority}${a.path}`:a.path.charCodeAt(0)===47&&(a.path.charCodeAt(1)>=65&&a.path.charCodeAt(1)<=90||a.path.charCodeAt(1)>=97&&a.path.charCodeAt(1)<=122)&&a.path.charCodeAt(2)===58?u?c=a.path.substr(1):c=a.path[1].toLowerCase()+a.path.substr(2):c=a.path,t.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=g;function p(a,u){const c=u?w:h;let l="",{scheme:n,authority:r,path:f,query:E,fragment:T}=a;if(n&&(l+=n,l+=":"),(r||n==="file")&&(l+=P,l+=P),r){let M=r.indexOf("@");if(M!==-1){const G=r.substr(0,M);r=r.substr(M+1),M=G.lastIndexOf(":"),M===-1?l+=c(G,!1,!1):(l+=c(G.substr(0,M),!1,!1),l+=":",l+=c(G.substr(M+1),!1,!0)),l+="@"}r=r.toLowerCase(),M=r.lastIndexOf(":"),M===-1?l+=c(r,!1,!0):(l+=c(r.substr(0,M),!1,!0),l+=r.substr(M))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const M=f.charCodeAt(1);M>=65&&M<=90&&(f=`/${String.fromCharCode(M+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const M=f.charCodeAt(0);M>=65&&M<=90&&(f=`${String.fromCharCode(M+32)}:${f.substr(2)}`)}l+=c(f,!0,!1)}return E&&(l+="?",l+=c(E,!1,!1)),T&&(l+="#",l+=u?T:h(T,!1,!1)),l}function b(a){try{return decodeURIComponent(a)}catch{return a.length>3?a.substr(0,3)+b(a.substr(3)):a}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(a){return a.match(i)?a.replace(i,u=>b(u)):a}}),define(ye[86],Ce([1,0,22,8,2]),function(ne,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(C){return JSON.stringify(C,A)}e.stringify=R;function I(C){let L=JSON.parse(C);return L=S(L),L}e.parse=I;function A(C,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,t.regExpFlags)(L)}:L}function S(C,L=0){if(!C||L>200)return C;if(typeof C=="object"){switch(C.$mid){case 1:return k.URI.revive(C);case 2:return new RegExp(C.source,C.flags);case 16:return new Date(C.source)}if(C instanceof o.VSBuffer||C instanceof Uint8Array)return C;if(Array.isArray(C))for(let P=0;P<C.length;++P)C[P]=S(C[P],L+1);else for(const P in C)Object.hasOwnProperty.call(C,P)&&(C[P]=S(C[P],L+1))}return C}e.revive=S}),define(ye[15],Ce([1,0,12,2]),function(ne,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls",S.vscodeSourceControl="vscode-scm"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(C){this.d=C}setDelegate(C){this.e=C}setServerRootPath(C){this.f=`${C}/${k.vscodeRemoteResource}`}set(C,L,P){this.a[C]=L,this.b[C]=P}setConnectionToken(C,L){this.c[C]=L}getPreferredWebSchema(){return this.d}rewrite(C){if(this.e)return this.e(C);const L=C.authority;let P=this.a[L];P&&P.indexOf(":")!==-1&&P.indexOf("[")===-1&&(P=`[${P}]`);const y=this.b[L],D=this.c[L];let v=`path=${encodeURIComponent(C.path)}`;return typeof D=="string"&&(v+=`&${e.connectionTokenQueryName}=${encodeURIComponent(D)}`),t.URI.from({scheme:o.isWeb?this.d:k.vscodeRemoteResource,authority:`${P}:${y}`,path:this.f,query:v})}}e.RemoteAuthorities=new R,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class I{asBrowserUri(C){const L=this.b(C,ne);return this.uriToBrowserUri(L)}uriToBrowserUri(C){return C.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(C):C.scheme===k.file&&(o.isNative||o.isWebWorker&&o.globals.origin===`${k.vscodeFileResource}://${I.a}`)?C.with({scheme:k.vscodeFileResource,authority:C.authority||I.a,query:null,fragment:null}):C}asFileUri(C){const L=this.b(C,ne);return this.uriToFileUri(L)}uriToFileUri(C){return C.scheme===k.vscodeFileResource?C.with({scheme:k.file,authority:C.authority!==I.a?C.authority:null,query:null,fragment:null}):C}b(C,L){return t.URI.isUri(C)?C:t.URI.parse(L.toUrl(C))}}I.a="vscode-app",e.FileAccess=new I;var A;(function(S){const C=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);S.CoopAndCoep=Object.freeze(C.get("3"));const L="vscode-coi";function P(D){let v;typeof D=="string"?v=new URL(D).searchParams:D instanceof URL?v=D.searchParams:t.URI.isUri(D)&&(v=new URL(D.toString(!0)).searchParams);const d=v?.get(L);if(!!d)return C.get(d)}S.getHeadersFromQuery=P;function y(D,v,d){if(!globalThis.crossOriginIsolated)return;const m=v&&d?"3":d?"2":"1";D instanceof URLSearchParams?D.set(L,m):D[L]=m}S.addSearchParam=y})(A=e.COI||(e.COI={}))}),define(ye[24],Ce([1,0,32,15,9,12,8,2]),function(ne,e,o,t,k,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(D){return(0,A.uriToFsPath)(D,!0)}e.originalFSPath=S;class C{constructor(v){this.a=v}compare(v,d,m=!1){return v===d?0:(0,I.compare)(this.getComparisonKey(v,m),this.getComparisonKey(d,m))}isEqual(v,d,m=!1){return v===d?!0:!v||!d?!1:this.getComparisonKey(v,m)===this.getComparisonKey(d,m)}getComparisonKey(v,d=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,d,m=!1){if(v.scheme===d.scheme){if(v.scheme===t.Schemas.file)return o.isEqualOrParent(S(v),S(d),this.a(v))&&v.query===d.query&&(m||v.fragment===d.fragment);if((0,e.isEqualAuthority)(v.authority,d.authority))return o.isEqualOrParent(v.path,d.path,this.a(v),"/")&&v.query===d.query&&(m||v.fragment===d.fragment)}return!1}joinPath(v,...d){return A.URI.joinPath(v,...d)}basenameOrAuthority(v){return(0,e.basename)(v)||v.authority}basename(v){return k.posix.basename(v.path)}extname(v){return k.posix.extname(v.path)}dirname(v){if(v.path.length===0)return v;let d;return v.scheme===t.Schemas.file?d=A.URI.file(k.dirname(S(v))).path:(d=k.posix.dirname(v.path),v.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),d="/")),v.with({path:d})}normalizePath(v){if(!v.path.length)return v;let d;return v.scheme===t.Schemas.file?d=A.URI.file(k.normalize(S(v))).path:d=k.posix.normalize(v.path),v.with({path:d})}relativePath(v,d){if(v.scheme!==d.scheme||!(0,e.isEqualAuthority)(v.authority,d.authority))return;if(v.scheme===t.Schemas.file){const w=k.relative(S(v),S(d));return R.isWindows?o.toSlashes(w):w}let m=v.path||"/";const h=d.path||"/";if(this.a(v)){let w=0;for(const g=Math.min(m.length,h.length);w<g&&!(m.charCodeAt(w)!==h.charCodeAt(w)&&m.charAt(w).toLowerCase()!==h.charAt(w).toLowerCase());w++);m=h.substr(0,w)+m.substr(w)}return k.posix.relative(m,h)}resolvePath(v,d){if(v.scheme===t.Schemas.file){const m=A.URI.file(k.resolve(S(v),d));return v.with({authority:m.authority,path:m.path})}return d=o.toPosixPath(d),v.with({path:k.posix.resolve(v.path,d)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,d){return v===d||v!==void 0&&d!==void 0&&(0,I.equalsIgnoreCase)(v,d)}hasTrailingPathSeparator(v,d=k.sep){if(v.scheme===t.Schemas.file){const m=S(v);return m.length>o.getRoot(m).length&&m[m.length-1]===d}else{const m=v.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,d=k.sep){return(0,e.hasTrailingPathSeparator)(v,d)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,d=k.sep){let m=!1;if(v.scheme===t.Schemas.file){const h=S(v);m=h!==void 0&&h.length===o.getRoot(h).length&&h[h.length-1]===d}else{d="/";const h=v.path;m=h.length===1&&h.charCodeAt(h.length-1)===47}return!m&&!(0,e.hasTrailingPathSeparator)(v,d)?v.with({path:v.path+"/"}):v}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(D=>D.scheme===t.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new C(D=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(D,v){const d=[];for(let m=0;m<D.length;m++){const h=v(D[m]);D.some((w,g)=>g===m?!1:(0,e.isEqualOrParent)(h,v(w)))||d.push(D[m])}return d}e.distinctParents=L;var P;(function(D){D.META_DATA_LABEL="label",D.META_DATA_DESCRIPTION="description",D.META_DATA_SIZE="size",D.META_DATA_MIME="mime";function v(d){const m=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(g=>{const[p,b]=g.split(":");p&&b&&m.set(p,b)});const w=d.path.substring(0,d.path.indexOf(";"));return w&&m.set(D.META_DATA_MIME,w),m}D.parseMetaData=v})(P=e.DataUri||(e.DataUri={}));function y(D,v,d){if(v){let m=D.path;return m&&m[0]!==k.posix.sep&&(m=k.posix.sep+m),D.with({scheme:d,authority:v,path:m})}return D.with({scheme:d})}e.toLocalResource=y}),define(ye[16],Ce([1,0,21,10,4,6,24,12]),function(ne,e,o,t,k,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(te){return!!te&&typeof te.then=="function"}e.isThenable=S;function C(te){const J=new o.CancellationTokenSource,fe=te(J.token),ve=new Promise((Ee,Ae)=>{const Fe=J.token.onCancellationRequested(()=>{Fe.dispose(),J.dispose(),Ae(new t.CancellationError)});Promise.resolve(fe).then(se=>{Fe.dispose(),J.dispose(),Ee(se)},se=>{Fe.dispose(),J.dispose(),Ae(se)})});return new class{cancel(){J.cancel()}then(Ee,Ae){return ve.then(Ee,Ae)}catch(Ee){return this.then(void 0,Ee)}finally(Ee){return ve.finally(Ee)}}}e.createCancelablePromise=C;function L(te,J,fe){return new Promise((ve,Ee)=>{const Ae=J.onCancellationRequested(()=>{Ae.dispose(),ve(fe)});te.then(ve,Ee).finally(()=>Ae.dispose())})}e.raceCancellation=L;function P(te,J){return new Promise((fe,ve)=>{const Ee=J.onCancellationRequested(()=>{Ee.dispose(),ve(new t.CancellationError)});te.then(fe,ve).finally(()=>Ee.dispose())})}e.raceCancellationError=P;async function y(te){let J=-1;const fe=te.map((Ee,Ae)=>Ee.then(Fe=>(J=Ae,Fe))),ve=await Promise.race(fe);return te.forEach((Ee,Ae)=>{Ae!==J&&Ee.cancel()}),ve}e.raceCancellablePromises=y;function D(te,J,fe){let ve;const Ee=setTimeout(()=>{ve?.(void 0),fe?.()},J);return Promise.race([te.finally(()=>clearTimeout(Ee)),new Promise(Ae=>ve=Ae)])}e.raceTimeout=D;function v(te){return new Promise((J,fe)=>{const ve=te();S(ve)?ve.then(J,fe):J(ve)})}e.asPromise=v;class d{constructor(){this.a=null,this.b=null,this.d=null}queue(J){if(this.a){if(this.d=J,!this.b){const fe=()=>{this.b=null;const ve=this.queue(this.d);return this.d=null,ve};this.b=new Promise(ve=>{this.a.then(fe,fe).then(ve)})}return new Promise((fe,ve)=>{this.b.then(fe,ve)})}return this.a=J(),new Promise((fe,ve)=>{this.a.then(Ee=>{this.a=null,fe(Ee)},Ee=>{this.a=null,ve(Ee)})})}}e.Throttler=d;class m{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.Sequencer=m;class h{constructor(){this.a=new Map}queue(J,fe){const Ee=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(fe).finally(()=>{this.a.get(J)===Ee&&this.a.delete(J)});return this.a.set(J,Ee),Ee}}e.SequencerByKey=h;const w=(te,J)=>{let fe=!0;const ve=setTimeout(()=>{fe=!1,J()},te);return{isTriggered:()=>fe,dispose:()=>{clearTimeout(ve),fe=!1}}},g=te=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,te())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class p{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,fe=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((Ee,Ae)=>{this.d=Ee,this.f=Ae}).then(()=>{if(this.b=null,this.d=null,this.g){const Ee=this.g;return this.g=null,Ee()}}));const ve=()=>{this.a=null,this.d?.(null)};return this.a=fe===e.MicrotaskDelay?g(ve):w(fe,ve),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=p;class b{constructor(J){this.a=new p(J),this.b=new d}trigger(J,fe){return this.a.trigger(()=>this.b.queue(J),fe)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=b;class i{constructor(){this.a=!1,this.b=new Promise((J,fe)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=i;class s extends i{constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=s;function a(te,J){return J?new Promise((fe,ve)=>{const Ee=setTimeout(()=>{Ae.dispose(),fe()},te),Ae=J.onCancellationRequested(()=>{clearTimeout(Ee),Ae.dispose(),ve(new t.CancellationError)})}):C(fe=>a(te,fe))}e.timeout=a;function u(te,J=0){const fe=setTimeout(te,J);return(0,R.toDisposable)(()=>clearTimeout(fe))}e.disposableTimeout=u;function c(te){const J=[];let fe=0;const ve=te.length;function Ee(){return fe<ve?te[fe++]():null}function Ae(Fe){Fe!=null&&J.push(Fe);const se=Ee();return se?se.then(Ae):Promise.resolve(J)}return Promise.resolve(null).then(Ae)}e.sequence=c;function l(te,J=ve=>!!ve,fe=null){let ve=0;const Ee=te.length,Ae=()=>{if(ve>=Ee)return Promise.resolve(fe);const Fe=te[ve++];return Promise.resolve(Fe()).then(le=>J(le)?Promise.resolve(le):Ae())};return Ae()}e.first=l;function n(te,J=ve=>!!ve,fe=null){if(te.length===0)return Promise.resolve(fe);let ve=te.length;const Ee=()=>{ve=-1;for(const Ae of te)Ae.cancel?.()};return new Promise((Ae,Fe)=>{for(const se of te)se.then(le=>{--ve>=0&&J(le)?(Ee(),Ae(le)):ve===0&&Ae(fe)}).catch(le=>{--ve>=0&&(Ee(),Fe(le))})})}e.firstParallel=n;class r{constructor(J){this.a=0,this.d=J,this.f=[],this.b=0,this.g=new k.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(J){return this.a++,new Promise((fe,ve)=>{this.f.push({factory:J,c:fe,e:ve}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const J=this.f.shift();this.b++;const fe=J.factory();fe.then(J.c,J.e),fe.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=r;class f extends r{constructor(){super(1)}}e.Queue=f;class E{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const J=new X;return this.b.add(J),J.p}d(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueFor(J,fe=I.extUri){const ve=fe.getComparisonKey(J);let Ee=this.a.get(ve);return Ee||(Ee=new f,k.Event.once(Ee.onDrained)(()=>{Ee?.dispose(),this.a.delete(ve),this.f()}),this.a.set(ve,Ee)),Ee}f(){!this.d()||this.g()}g(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.g()}}e.ResourceQueue=E;class T{constructor(J,fe){this.a=-1,typeof J=="function"&&typeof fe=="number"&&this.setIfNotSet(J,fe)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,fe){this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},fe)}setIfNotSet(J,fe){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},fe))}}e.TimeoutTimer=T;class M{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(J,fe){this.cancel(),this.a=setInterval(()=>{J()},fe)}}e.IntervalTimer=M;class G{constructor(J,fe){this.b=-1,this.a=J,this.d=fe,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=G;class V{constructor(J,fe){fe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${fe}ms is not a multiple of 1000ms.`),this.a=J,this.b=fe,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=V;class N extends G{constructor(J,fe){super(J,fe),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=N;class U extends R.Disposable{constructor(J,fe){super(),this.g=J,this.h=fe,this.a=[],this.b=this.B(new R.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const fe of J)this.a.push(fe);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new G(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=te=>{(0,A.setTimeout0)(()=>{if(J)return;const fe=Date.now()+15;te(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,fe-Date.now())}}))});let J=!1;return{dispose(){J||(J=!0)}}}:e.runWhenIdle=(te,J)=>{const fe=requestIdleCallback(te,typeof J=="number"?{timeout:J}:void 0);let ve=!1;return{dispose(){ve||(ve=!0,cancelIdleCallback(fe))}}}}();class F{constructor(J){this.d=!1,this.a=()=>{try{this.f=J()}catch(fe){this.g=fe}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=F;async function z(te,J,fe){let ve;for(let Ee=0;Ee<fe;Ee++)try{return await te()}catch(Ae){ve=Ae,await a(J)}throw ve}e.retry=z;class B{hasPending(J){return this.a?typeof J=="number"?this.a.taskId===J:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(J,fe,ve){return this.a={taskId:J,cancel:()=>ve?.(),promise:fe},fe.then(()=>this.d(J),()=>this.d(J)),fe}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}setNext(J){if(this.b)this.b.run=J;else{let fe,ve;const Ee=new Promise((Ae,Fe)=>{fe=Ae,ve=Fe});this.b={run:J,promise:Ee,promiseResolve:fe,promiseReject:ve}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=B;class W{constructor(J,fe=()=>Date.now()){this.d=J,this.f=fe,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.IntervalCounter=W;class X{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((J,fe)=>{this.a=J,this.b=fe})}complete(J){return new Promise(fe=>{this.a(J),this.f=!0,fe()})}error(J){return new Promise(fe=>{this.b(J),this.d=!0,fe()})}cancel(){new Promise(J=>{this.b(new t.CancellationError),this.d=!0,J()})}}e.DeferredPromise=X;var q;(function(te){async function J(ve){let Ee;const Ae=await Promise.all(ve.map(Fe=>Fe.then(se=>se,se=>{Ee||(Ee=se)})));if(typeof Ee<"u")throw Ee;return Ae}te.settled=J;function fe(ve){return new Promise(async(Ee,Ae)=>{try{await ve(Ee,Ae)}catch(Fe){Ae(Fe)}})}te.withAsyncBody=fe})(q=e.Promises||(e.Promises={}));var _;(function(te){te[te.Initial=0]="Initial",te[te.DoneOK=1]="DoneOK",te[te.DoneError=2]="DoneError"})(_||(_={}));class Q{static fromArray(J){return new Q(fe=>{fe.emitMany(J)})}static fromPromise(J){return new Q(async fe=>{fe.emitMany(await J)})}static fromPromises(J){return new Q(async fe=>{await Promise.all(J.map(async ve=>fe.emitOne(await ve)))})}static merge(J){return new Q(async fe=>{await Promise.all(J.map(async ve=>{for await(const Ee of ve)fe.emitOne(Ee)}))})}constructor(J){this.a=0,this.b=[],this.d=null,this.f=new k.Emitter,queueMicrotask(async()=>{const fe={emitOne:ve=>this.g(ve),emitMany:ve=>this.h(ve),reject:ve=>this.k(ve)};try{await Promise.resolve(J(fe)),this.j()}catch(ve){this.k(ve)}finally{fe.emitOne=void 0,fe.emitMany=void 0,fe.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===1)return{done:!0,value:void 0};await k.Event.toPromise(this.f.event)}while(!0)}}}static map(J,fe){return new Q(async ve=>{for await(const Ee of J)ve.emitOne(fe(Ee))})}map(J){return Q.map(this,J)}static filter(J,fe){return new Q(async ve=>{for await(const Ee of J)fe(Ee)&&ve.emitOne(Ee)})}filter(J){return Q.filter(this,J)}static coalesce(J){return Q.filter(J,fe=>!!fe)}coalesce(){return Q.coalesce(this)}static async toPromise(J){const fe=[];for await(const ve of J)fe.push(ve);return fe}toPromise(){return Q.toPromise(this)}g(J){this.a===0&&(this.b.push(J),this.f.fire())}h(J){this.a===0&&(this.b=this.b.concat(J),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(J){this.a===0&&(this.a=2,this.d=J,this.f.fire())}}e.AsyncIterableObject=Q,Q.EMPTY=Q.fromArray([]);class Z extends Q{constructor(J,fe){super(fe),this.l=J}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=Z;function ge(te){const J=new o.CancellationTokenSource,fe=te(J.token);return new Z(J,async ve=>{const Ee=J.token.onCancellationRequested(()=>{Ee.dispose(),J.dispose(),ve.reject(new t.CancellationError)});try{for await(const Ae of fe){if(J.token.isCancellationRequested)return;ve.emitOne(Ae)}Ee.dispose(),J.dispose()}catch(Ae){Ee.dispose(),J.dispose(),ve.reject(Ae)}})}e.createCancelableAsyncIterable=ge}),define(ye[109],Ce([1,0,16,9]),function(ne,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const k=new o.IdleValue(()=>{const r=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:r,collatorIsNumeric:r.resolvedOptions().numeric}}),R=new o.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),I=new o.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(r,f,E=!1){const T=r||"",M=f||"",G=k.value.collator.compare(T,M);return k.value.collatorIsNumeric&&G===0&&T!==M?T<M?-1:1:G}e.compareFileNames=A;function S(r,f){const E=R.value.collator;return r=r||"",f=f||"",p(E,r,f)}e.compareFileNamesDefault=S;function C(r,f){const E=R.value.collator;return r=r||"",f=f||"",a(r,f)||p(E,r,f)}e.compareFileNamesUpper=C;function L(r,f){const E=R.value.collator;return r=r||"",f=f||"",s(r,f)||p(E,r,f)}e.compareFileNamesLower=L;function P(r,f){return r=r||"",f=f||"",r===f?0:r<f?-1:1}e.compareFileNamesUnicode=P;function y(r,f){const[E,T]=w(r),[M,G]=w(f);let V=k.value.collator.compare(T,G);if(V===0){if(k.value.collatorIsNumeric&&T!==G)return T<G?-1:1;if(V=k.value.collator.compare(E,M),k.value.collatorIsNumeric&&V===0&&E!==M)return E<M?-1:1}return V}e.compareFileExtensions=y;function D(r,f){r=r||"",f=f||"";const E=g(r),T=g(f),M=R.value.collator,G=I.value.collator;return p(G,E,T)||p(M,r,f)}e.compareFileExtensionsDefault=D;function v(r,f){r=r||"",f=f||"";const E=g(r),T=g(f),M=R.value.collator,G=I.value.collator;return p(G,E,T)||a(r,f)||p(M,r,f)}e.compareFileExtensionsUpper=v;function d(r,f){r=r||"",f=f||"";const E=g(r),T=g(f),M=R.value.collator,G=I.value.collator;return p(G,E,T)||s(r,f)||p(M,r,f)}e.compareFileExtensionsLower=d;function m(r,f){r=r||"",f=f||"";const E=g(r).toLowerCase(),T=g(f).toLowerCase();return E!==T?E<T?-1:1:r!==f?r<f?-1:1:0}e.compareFileExtensionsUnicode=m;const h=/^(.*?)(\.([^.]*))?$/;function w(r,f=!1){const E=r?h.exec(r):[];let T=[E&&E[1]||"",E&&E[3]||""];return f&&(!T[0]&&T[1]||T[0]&&T[0].charAt(0)===".")&&(T=[T[0]+"."+T[1],""]),T}function g(r){const f=r?h.exec(r):[];return f&&f[1]&&f[1].charAt(0)!=="."&&f[3]||""}function p(r,f,E){const T=r.compare(f,E);return T!==0?T:f.length!==E.length?f.length<E.length?-1:1:0}function b(r){const f=r.charAt(0);return f.toLocaleUpperCase()!==f}function i(r){const f=r.charAt(0);return f.toLocaleLowerCase()!==f}function s(r,f){return b(r)&&i(f)?-1:i(r)&&b(f)?1:0}function a(r,f){return i(r)&&b(f)?-1:b(r)&&i(f)?1:0}function u(r,f,E=!1){return E||(r=r&&r.toLowerCase(),f=f&&f.toLowerCase()),r===f?0:r<f?-1:1}function c(r,f,E=!1){const T=r.split(t.sep),M=f.split(t.sep),G=T.length-1,V=M.length-1;let N,U;for(let F=0;;F++){if(N=G===F,U=V===F,N&&U)return A(T[F],M[F],E);if(N)return-1;if(U)return 1;const z=u(T[F],M[F],E);if(z!==0)return z}}e.comparePaths=c;function l(r,f,E){const T=r.toLowerCase(),M=f.toLowerCase(),G=n(r,f,E);if(G)return G;const V=T.endsWith(E),N=M.endsWith(E);if(V!==N)return V?-1:1;const U=A(T,M);return U!==0?U:T.localeCompare(M)}e.compareAnything=l;function n(r,f,E){const T=r.toLowerCase(),M=f.toLowerCase(),G=T.startsWith(E),V=M.startsWith(E);if(G!==V)return G?-1:1;if(G&&V){if(T.length<M.length)return-1;if(T.length>M.length)return 1}return 0}e.compareByPrefix=n}),define(ye[110],Ce([1,0,109,108,85,9,12,8]),function(ne,e,o,t,k,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const S=0,C=[S,[]];function L(B,W,X,q){if(!B||!W)return C;const _=B.length,Q=W.length;if(_<Q)return C;const Z=B.toLowerCase();return P(W,X,Q,B,Z,_,q)}e.scoreFuzzy=L;function P(B,W,X,q,_,Q,Z){const ge=[],te=[];for(let Ee=0;Ee<X;Ee++){const Ae=Ee*Q,Fe=Ae-Q,se=Ee>0,le=B[Ee],ue=W[Ee];for(let ee=0;ee<Q;ee++){const ae=ee>0,ie=Ae+ee,O=ie-1,H=Fe+ee-1,x=ae?ge[O]:0,Y=se&&ae?ge[H]:0,de=se&&ae?te[H]:0;let be;!Y&&se?be=0:be=y(le,ue,q,_,ee,de),be&&Y+be>=x&&(Z||se||_.startsWith(W,ee))?(te[ie]=de+1,ge[ie]=Y+be):(te[ie]=S,ge[ie]=x)}}const J=[];let fe=X-1,ve=Q-1;for(;fe>=0&&ve>=0;){const Ee=fe*Q+ve;te[Ee]===S||(J.push(ve),fe--),ve--}return[ge[X*Q-1],J.reverse()]}function y(B,W,X,q,_,Q){let Z=0;if(!D(W,q[_]))return Z;if(Z+=1,Q>0&&(Z+=Q*5),B===X[_]&&(Z+=1),_===0)Z+=8;else{const ge=v(X.charCodeAt(_-1));ge?Z+=ge:(0,t.isUpper)(X.charCodeAt(_))&&Q===0&&(Z+=2)}return Z}function D(B,W){return B===W?!0:B==="/"||B==="\\"?W==="/"||W==="\\":!1}function v(B){switch(B){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const d=[void 0,[]];function m(B,W,X=0,q=0){const _=W;return _.values&&_.values.length>1?h(B,_.values,X,q):w(B,W,X,q)}e.scoreFuzzy2=m;function h(B,W,X,q){let _=0;const Q=[];for(const Z of W){const[ge,te]=w(B,Z,X,q);if(typeof ge!="number")return d;_+=ge,Q.push(...te)}return[_,r(Q)]}function w(B,W,X,q){const _=(0,t.fuzzyScore)(W.original,W.originalLowercase,X,B,B.toLowerCase(),q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return _?[_[0],(0,t.createMatches)(_)]:d}const g=Object.freeze({score:0}),p=1<<18,b=1<<17,i=1<<16;function s(B,W,X,q){const _=q.values?q.values:[q];return(0,k.hash)({[q.normalized]:{values:_.map(Z=>({value:Z.normalized,expectContiguousMatch:Z.expectContiguousMatch})),label:B,description:W,allowNonContiguousMatches:X}})}function a(B,W,X,q,_){if(!B||!W.normalized)return g;const Q=q.getItemLabel(B);if(!Q)return g;const Z=q.getItemDescription(B),ge=s(Q,Z,X,W),te=_[ge];if(te)return te;const J=u(Q,Z,q.getItemPath(B),W,X);return _[ge]=J,J}e.scoreItemFuzzy=a;function u(B,W,X,q,_){const Q=!X||!q.containsPathSeparator;return X&&(I.isLinux?q.pathNormalized===X:(0,A.equalsIgnoreCase)(q.pathNormalized,X))?{score:p,labelMatch:[{start:0,end:B.length}],descriptionMatch:W?[{start:0,end:W.length}]:void 0}:q.values&&q.values.length>1?c(B,W,X,q.values,Q,_):l(B,W,X,q,Q,_)}function c(B,W,X,q,_,Q){let Z=0;const ge=[],te=[];for(const J of q){const{score:fe,labelMatch:ve,descriptionMatch:Ee}=l(B,W,X,J,_,Q);if(fe===S)return g;Z+=fe,ve&&ge.push(...ve),Ee&&te.push(...Ee)}return{score:Z,labelMatch:r(ge),descriptionMatch:r(te)}}function l(B,W,X,q,_,Q){if(_||!W){const[Z,ge]=L(B,q.normalized,q.normalizedLowercase,Q&&!q.expectContiguousMatch);if(Z){const te=(0,t.matchesPrefix)(q.normalized,B);let J;return te?(J=b,J+=Math.round(q.normalized.length/B.length*100)):J=i,{score:J+Z,labelMatch:te||n(ge)}}}if(W){let Z=W;X&&(Z=`${W}${R.sep}`);const ge=Z.length,te=`${Z}${B}`,[J,fe]=L(te,q.normalized,q.normalizedLowercase,Q&&!q.expectContiguousMatch);if(J){const ve=n(fe),Ee=[],Ae=[];return ve.forEach(Fe=>{Fe.start<ge&&Fe.end>ge?(Ee.push({start:0,end:Fe.end-ge}),Ae.push({start:Fe.start,end:ge})):Fe.start>=ge?Ee.push({start:Fe.start-ge,end:Fe.end-ge}):Ae.push(Fe)}),{score:J,labelMatch:Ee,descriptionMatch:Ae}}}return g}function n(B){const W=[];if(!B)return W;let X;for(const q of B)X&&X.end===q?X.end+=1:(X={start:q,end:q+1},W.push(X));return W}function r(B){const W=B.sort((_,Q)=>_.start-Q.start),X=[];let q;for(const _ of W)!q||!f(q,_)?(q=_,X.push(_)):(q.start=Math.min(q.start,_.start),q.end=Math.max(q.end,_.end));return X}function f(B,W){return!(B.end<W.start||W.end<B.start)}function E(B,W,X,q,_,Q){const Z=a(B,X,q,_,Q),ge=a(W,X,q,_,Q),te=Z.score,J=ge.score;if((te===p||J===p)&&te!==J)return te===p?-1:1;if(te>i||J>i){if(te!==J)return te>J?-1:1;if(te<b&&J<b){const le=M(Z.labelMatch,ge.labelMatch);if(le!==0)return le}const Fe=_.getItemLabel(B)||"",se=_.getItemLabel(W)||"";if(Fe.length!==se.length)return Fe.length-se.length}if(te!==J)return te>J?-1:1;const fe=Array.isArray(Z.labelMatch)&&Z.labelMatch.length>0,ve=Array.isArray(ge.labelMatch)&&ge.labelMatch.length>0;if(fe&&!ve)return-1;if(ve&&!fe)return 1;const Ee=T(B,Z,_),Ae=T(W,ge,_);return Ee&&Ae&&Ee!==Ae?Ae>Ee?-1:1:G(B,W,X,_)}e.compareItemsByFuzzyScore=E;function T(B,W,X){let q=-1,_=-1;if(W.descriptionMatch&&W.descriptionMatch.length?q=W.descriptionMatch[0].start:W.labelMatch&&W.labelMatch.length&&(q=W.labelMatch[0].start),W.labelMatch&&W.labelMatch.length){if(_=W.labelMatch[W.labelMatch.length-1].end,W.descriptionMatch&&W.descriptionMatch.length){const Q=X.getItemDescription(B);Q&&(_+=Q.length)}}else W.descriptionMatch&&W.descriptionMatch.length&&(_=W.descriptionMatch[W.descriptionMatch.length-1].end);return _-q}function M(B,W){if(!B&&!W||(!B||!B.length)&&(!W||!W.length))return 0;if(!W||!W.length)return-1;if(!B||!B.length)return 1;const X=B[0].start,_=B[B.length-1].end-X,Q=W[0].start,ge=W[W.length-1].end-Q;return _===ge?0:ge<_?1:-1}function G(B,W,X,q){const _=q.getItemLabel(B)||"",Q=q.getItemLabel(W)||"",Z=q.getItemDescription(B),ge=q.getItemDescription(W),te=_.length+(Z?Z.length:0),J=Q.length+(ge?ge.length:0);if(te!==J)return te-J;const fe=q.getItemPath(B),ve=q.getItemPath(W);return fe&&ve&&fe.length!==ve.length?fe.length-ve.length:_!==Q?(0,o.compareAnything)(_,Q,X.normalized):Z&&ge&&Z!==ge?(0,o.compareAnything)(Z,ge,X.normalized):fe&&ve&&fe!==ve?(0,o.compareAnything)(fe,ve,X.normalized):0}function V(B){return B.startsWith('"')&&B.endsWith('"')}const N=" ";function U(B){typeof B!="string"&&(B="");const W=B.toLowerCase(),{pathNormalized:X,normalized:q,normalizedLowercase:_}=F(B),Q=X.indexOf(R.sep)>=0,Z=V(B);let ge;const te=B.split(N);if(te.length>1)for(const J of te){const fe=V(J),{pathNormalized:ve,normalized:Ee,normalizedLowercase:Ae}=F(J);Ee&&(ge||(ge=[]),ge.push({original:J,originalLowercase:J.toLowerCase(),pathNormalized:ve,normalized:Ee,normalizedLowercase:Ae,expectContiguousMatch:fe}))}return{original:B,originalLowercase:W,pathNormalized:X,normalized:q,normalizedLowercase:_,values:ge,containsPathSeparator:Q,expectContiguousMatch:Z}}e.prepareQuery=U;function F(B){let W;I.isWindows?W=B.replace(/\//g,R.sep):W=B.replace(/\\/g,R.sep);const X=(0,A.stripWildcards)(W).replace(/\s|"/g,"");return{pathNormalized:W,normalized:X,normalizedLowercase:X.toLowerCase()}}function z(B){return Array.isArray(B)?U(B.map(W=>W.original).join(N)):U(B.original)}e.pieceToQuery=z}),define(ye[37],Ce([1,0,18,16,32,28,9,12,8]),function(ne,e,o,t,k,R,I,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const L="[/\\\\]",P="[^/\\\\]",y=/\//g;function D(X,q){switch(X){case 0:return"";case 1:return`${P}*?`;default:return`(?:${L}|${P}+${L}${q?`|${L}${P}+`:""})*?`}}function v(X,q){if(!X)return[];const _=[];let Q=!1,Z=!1,ge="";for(const te of X){switch(te){case q:if(!Q&&!Z){_.push(ge),ge="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":Z=!0;break;case"]":Z=!1;break}ge+=te}return ge&&_.push(ge),_}e.splitGlobAware=v;function d(X){if(!X)return"";let q="";const _=v(X,e.GLOB_SPLIT);if(_.every(Q=>Q===e.GLOBSTAR))q=".*";else{let Q=!1;_.forEach((Z,ge)=>{if(Z===e.GLOBSTAR){if(Q)return;q+=D(2,ge===_.length-1)}else{let te=!1,J="",fe=!1,ve="";for(const Ee of Z){if(Ee!=="}"&&te){J+=Ee;continue}if(fe&&(Ee!=="]"||!ve)){let Ae;Ee==="-"?Ae=Ee:(Ee==="^"||Ee==="!")&&!ve?Ae="^":Ee===e.GLOB_SPLIT?Ae="":Ae=(0,S.escapeRegExpCharacters)(Ee),ve+=Ae;continue}switch(Ee){case"{":te=!0;continue;case"[":fe=!0;continue;case"}":{q+=`(?:${v(J,",").map(se=>d(se)).join("|")})`,te=!1,J="";break}case"]":{q+="["+ve+"]",fe=!1,ve="";break}case"?":q+=P;continue;case"*":q+=D(1);continue;default:q+=(0,S.escapeRegExpCharacters)(Ee)}}ge<_.length-1&&(_[ge+1]!==e.GLOBSTAR||ge+2<_.length)&&(q+=L)}Q=Z===e.GLOBSTAR})}return q}const m=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,p=/^\*\*((\/[\w\.-]+)+)\/?$/,b=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new R.LRUCache(1e4),s=function(){return!1},a=function(){return null};function u(X,q){if(!X)return a;let _;typeof X!="string"?_=X.pattern:_=X,_=_.trim();const Q=`${_}_${!!q.trimForExclusions}`;let Z=i.get(Q);if(Z)return c(Z,X);let ge;return m.test(_)?Z=n(_.substr(4),_):(ge=h.exec(l(_,q)))?Z=r(ge[1],_):(q.trimForExclusions?g:w).test(_)?Z=f(_,q):(ge=p.exec(l(_,q)))?Z=E(ge[1].substr(1),_,!0):(ge=b.exec(l(_,q)))?Z=E(ge[1],_,!1):Z=T(_),i.set(Q,Z),c(Z,X)}function c(X,q){if(typeof q=="string")return X;const _=function(Q,Z){return(0,k.isEqualOrParent)(Q,q.base,!A.isLinux)?X((0,S.ltrim)(Q.substr(q.base.length),I.sep),Z):null};return _.allBasenames=X.allBasenames,_.allPaths=X.allPaths,_.basenames=X.basenames,_.patterns=X.patterns,_}function l(X,q){return q.trimForExclusions&&X.endsWith("/**")?X.substr(0,X.length-2):X}function n(X,q){return function(_,Q){return typeof _=="string"&&_.endsWith(X)?q:null}}function r(X,q){const _=`/${X}`,Q=`\\${X}`,Z=function(te,J){return typeof te!="string"?null:J?J===X?q:null:te===X||te.endsWith(_)||te.endsWith(Q)?q:null},ge=[X];return Z.basenames=ge,Z.patterns=[q],Z.allBasenames=ge,Z}function f(X,q){const _=B(X.slice(1,-1).split(",").map(J=>u(J,q)).filter(J=>J!==a),X),Q=_.length;if(!Q)return a;if(Q===1)return _[0];const Z=function(J,fe){for(let ve=0,Ee=_.length;ve<Ee;ve++)if(_[ve](J,fe))return X;return null},ge=_.find(J=>!!J.allBasenames);ge&&(Z.allBasenames=ge.allBasenames);const te=_.reduce((J,fe)=>fe.allPaths?J.concat(fe.allPaths):J,[]);return te.length&&(Z.allPaths=te),Z}function E(X,q,_){const Q=I.sep===I.posix.sep,Z=Q?X:X.replace(y,I.sep),ge=I.sep+Z,te=I.posix.sep+X;let J;return _?J=function(fe,ve){return typeof fe=="string"&&(fe===Z||fe.endsWith(ge)||!Q&&(fe===X||fe.endsWith(te)))?q:null}:J=function(fe,ve){return typeof fe=="string"&&(fe===Z||!Q&&fe===X)?q:null},J.allPaths=[(_?"*/":"./")+X],J}function T(X){try{const q=new RegExp(`^${d(X)}$`);return function(_){return q.lastIndex=0,typeof _=="string"&&q.test(_)?X:null}}catch{return a}}function M(X,q,_){return!X||typeof q!="string"?!1:G(X)(q,void 0,_)}e.match=M;function G(X,q={}){if(!X)return s;if(typeof X=="string"||V(X)){const _=u(X,q);if(_===a)return s;const Q=function(Z,ge){return!!_(Z,ge)};return _.allBasenames&&(Q.allBasenames=_.allBasenames),_.allPaths&&(Q.allPaths=_.allPaths),Q}return F(X,q)}e.parse=G;function V(X){const q=X;return q?typeof q.base=="string"&&typeof q.pattern=="string":!1}e.isRelativePattern=V;function N(X){return X.allBasenames||[]}e.getBasenameTerms=N;function U(X){return X.allPaths||[]}e.getPathTerms=U;function F(X,q){const _=B(Object.getOwnPropertyNames(X).map(J=>z(J,X[J],q)).filter(J=>J!==a)),Q=_.length;if(!Q)return a;if(!_.some(J=>!!J.requiresSiblings)){if(Q===1)return _[0];const J=function(Ee,Ae){let Fe;for(let se=0,le=_.length;se<le;se++){const ue=_[se](Ee,Ae);if(typeof ue=="string")return ue;(0,t.isThenable)(ue)&&(Fe||(Fe=[]),Fe.push(ue))}return Fe?(async()=>{for(const se of Fe){const le=await se;if(typeof le=="string")return le}return null})():null},fe=_.find(Ee=>!!Ee.allBasenames);fe&&(J.allBasenames=fe.allBasenames);const ve=_.reduce((Ee,Ae)=>Ae.allPaths?Ee.concat(Ae.allPaths):Ee,[]);return ve.length&&(J.allPaths=ve),J}const Z=function(J,fe,ve){let Ee,Ae;for(let Fe=0,se=_.length;Fe<se;Fe++){const le=_[Fe];le.requiresSiblings&&ve&&(fe||(fe=(0,I.basename)(J)),Ee||(Ee=fe.substr(0,fe.length-(0,I.extname)(J).length)));const ue=le(J,fe,Ee,ve);if(typeof ue=="string")return ue;(0,t.isThenable)(ue)&&(Ae||(Ae=[]),Ae.push(ue))}return Ae?(async()=>{for(const Fe of Ae){const se=await Fe;if(typeof se=="string")return se}return null})():null},ge=_.find(J=>!!J.allBasenames);ge&&(Z.allBasenames=ge.allBasenames);const te=_.reduce((J,fe)=>fe.allPaths?J.concat(fe.allPaths):J,[]);return te.length&&(Z.allPaths=te),Z}function z(X,q,_){if(q===!1)return a;const Q=u(X,_);if(Q===a)return a;if(typeof q=="boolean")return Q;if(q){const Z=q.when;if(typeof Z=="string"){const ge=(te,J,fe,ve)=>{if(!ve||!Q(te,J))return null;const Ee=Z.replace("$(basename)",()=>fe),Ae=ve(Ee);return(0,t.isThenable)(Ae)?Ae.then(Fe=>Fe?X:null):Ae?X:null};return ge.requiresSiblings=!0,ge}}return Q}function B(X,q){const _=X.filter(J=>!!J.basenames);if(_.length<2)return X;const Q=_.reduce((J,fe)=>{const ve=fe.basenames;return ve?J.concat(ve):J},[]);let Z;if(q){Z=[];for(let J=0,fe=Q.length;J<fe;J++)Z.push(q)}else Z=_.reduce((J,fe)=>{const ve=fe.patterns;return ve?J.concat(ve):J},[]);const ge=function(J,fe){if(typeof J!="string")return null;if(!fe){let Ee;for(Ee=J.length;Ee>0;Ee--){const Ae=J.charCodeAt(Ee-1);if(Ae===47||Ae===92)break}fe=J.substr(Ee)}const ve=Q.indexOf(fe);return ve!==-1?Z[ve]:null};ge.basenames=Q,ge.patterns=Z,ge.allBasenames=Q;const te=X.filter(J=>!J.basenames);return te.push(ge),te}function W(X,q){return(0,o.equals)(X,q,(_,Q)=>typeof _=="string"&&typeof Q=="string"?_===Q:typeof _!="string"&&typeof Q!="string"?_.base===Q.base&&_.pattern===Q.pattern:!1)}e.patternsEquals=W}),define(ye[111],Ce([1,0,10,160,24,8,2]),function(ne,e,o,t,k,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(m){m[m.Paragraph=0]="Paragraph",m[m.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(h="",w=!1){if(this.value=h,typeof this.value!="string")throw(0,o.illegalArgument)("value");typeof w=="boolean"?(this.isTrusted=w,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=w.isTrusted??void 0,this.supportThemeIcons=w.supportThemeIcons??!1,this.supportHtml=w.supportHtml??!1)}appendText(h,w=0){return this.value+=y(this.supportThemeIcons?(0,t.escapeIcons)(h):h).replace(/([ \t]+)/g,(g,p)=>"&nbsp;".repeat(p.length)).replace(/\>/gm,"\\>").replace(/\n/g,w===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,w){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=w,this.value+="\n```\n",this}appendLink(h,w,g){return this.value+="[",this.value+=this.c(w,"]"),this.value+="](",this.value+=this.c(String(h),")"),g&&(this.value+=` "${this.c(this.c(g,'"'),")")}"`),this.value+=")",this}c(h,w){const g=new RegExp((0,R.escapeRegExpCharacters)(w),"g");return h.replace(g,(p,b)=>h.charAt(b-1)!=="\\"?`\\${p}`:p)}}e.MarkdownString=S;function C(m){return L(m)?!m.value:Array.isArray(m)?m.every(C):!0}e.isEmptyMarkdownString=C;function L(m){return m instanceof S?!0:m&&typeof m=="object"?typeof m.value=="string"&&(typeof m.isTrusted=="boolean"||m.isTrusted===void 0)&&(typeof m.supportThemeIcons=="boolean"||m.supportThemeIcons===void 0):!1}e.isMarkdownString=L;function P(m,h){return m===h?!0:!m||!h?!1:m.value===h.value&&m.isTrusted===h.isTrusted&&m.supportThemeIcons===h.supportThemeIcons&&m.supportHtml===h.supportHtml&&(m.baseUri===h.baseUri||!!m.baseUri&&!!h.baseUri&&(0,k.isEqual)(I.URI.from(m.baseUri),I.URI.from(h.baseUri)))}e.markdownStringEqual=P;function y(m){return m.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=y;function D(m){return m.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=D;function v(m){return m&&m.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=v;function d(m){const h=[],w=m.split("|").map(p=>p.trim());m=w[0];const g=w[1];if(g){const p=/height=(\d+)/.exec(g),b=/width=(\d+)/.exec(g),i=p?p[1]:"",s=b?b[1]:"",a=isFinite(parseInt(s)),u=isFinite(parseInt(i));a&&h.push(`width="${s}"`),u&&h.push(`height="${i}"`)}return{href:m,dimensions:h}}e.parseHrefAndDimensions=d}),define(ye[112],Ce([1,0,18,32,9,12,24,8]),function(ne,e,o,t,k,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function S(a,u){const{os:c,tildify:l,relative:n}=u;if(n){const E=C(a,n,c);if(typeof E=="string")return E}let r=a.fsPath;if(c===1&&!R.isWindows?r=r.replace(/\//g,"\\"):c!==1&&R.isWindows&&(r=r.replace(/\\/g,"/")),c!==1&&l?.userHome){const E=l.userHome.fsPath;let T;a.scheme!==l.userHome.scheme&&a.path.startsWith(k.posix.sep)?T=l.userHome.with({path:a.path}).fsPath:T=a.fsPath,r=y(T,E,c)}return(c===1?k.win32:k.posix).normalize(L(r,c===1))}e.getPathLabel=S;function C(a,u,c){const l=c===1?k.win32:k.posix,n=c===3?I.extUri:I.extUriIgnorePathCase,r=u.getWorkspace(),f=(0,o.firstOrDefault)(r.folders);if(!f)return;a.scheme!==f.uri.scheme&&a.path.startsWith(k.posix.sep)&&(a=f.uri.with({path:a.path}));const E=u.getWorkspaceFolder(a);if(!E)return;let T;if(n.isEqual(E.uri,a)?T="":T=n.relativePath(E.uri,a)??"",T&&(T=l.normalize(T)),r.folders.length>1&&!u.noPrefix){const M=E.name?E.name:n.basenameOrAuthority(E.uri);T=T?`${M} \u2022 ${T}`:M}return T}function L(a,u=R.isWindows){return(0,t.hasDriveLetter)(a,u)?a.charAt(0).toUpperCase()+a.slice(1):a}e.normalizeDriveLetter=L;let P=Object.create(null);function y(a,u,c=R.OS){if(c===1||!a||!u)return a;let l=P.original===u?P.normalized:void 0;l||(l=u,R.isWindows&&(l=(0,t.toSlashes)(l)),l=`${(0,A.rtrim)(l,k.posix.sep)}${k.posix.sep}`,P={original:u,normalized:l});let n=a;return R.isWindows&&(n=(0,t.toSlashes)(n)),(c===3?n.startsWith(l):(0,A.startsWithIgnoreCase)(n,l))?`~/${n.substr(l.length)}`:a}e.tildify=y;function D(a,u){return a.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=D;const v="\u2026",d="\\\\",m="~";function h(a,u=k.sep){const c=new Array(a.length);let l=!1;for(let n=0;n<a.length;n++){const r=a[n];if(r===""){c[n]=`.${u}`;continue}if(!r){c[n]=r;continue}l=!0;let f="",E=r;E.indexOf(d)===0?(f=E.substr(0,E.indexOf(d)+d.length),E=E.substr(E.indexOf(d)+d.length)):E.indexOf(u)===0?(f=E.substr(0,E.indexOf(u)+u.length),E=E.substr(E.indexOf(u)+u.length)):E.indexOf(m)===0&&(f=E.substr(0,E.indexOf(m)+m.length),E=E.substr(E.indexOf(m)+m.length));const T=E.split(u);for(let M=1;l&&M<=T.length;M++)for(let G=T.length-M;l&&G>=0;G--){l=!1;let V=T.slice(G,G+M).join(u);for(let N=0;!l&&N<a.length;N++)if(N!==n&&a[N]&&a[N].indexOf(V)>-1){const U=G+M===T.length,F=G>0&&a[N].indexOf(u)>-1?u+V:V,z=a[N].endsWith(F);l=!U||z}if(!l){let N="";(T[0].endsWith(":")||f!=="")&&(G===1&&(G=0,M++,V=T[0]+u+V),G>0&&(N=T[0]+u),N=f+N),G>0&&(N=N+v+u),N=N+V,G+M<T.length&&(N=N+u+v),c[n]=N}}l&&(c[n]=r)}return c}e.shorten=h;var w;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(w||(w={}));function g(a,u=Object.create(null)){const c=[];let l=!1,n="";for(const r of a)if(r==="$"||l&&r==="{")n&&c.push({value:n,type:w.TEXT}),n="",l=!0;else if(r==="}"&&l){const f=u[n];if(typeof f=="string")f.length&&c.push({value:f,type:w.VARIABLE});else if(f){const E=c[c.length-1];(!E||E.type!==w.SEPARATOR)&&c.push({value:f.label,type:w.SEPARATOR})}n="",l=!1}else n+=r;return n&&!l&&c.push({value:n,type:w.TEXT}),c.filter((r,f)=>{if(r.type===w.SEPARATOR){const E=c[f-1],T=c[f+1];return[E,T].every(M=>M&&(M.type===w.VARIABLE||M.type===w.TEXT)&&M.value.length>0)}return!0}).map(r=>r.value).join("")}e.template=g;function p(a,u){return R.isMacintosh||u?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):a.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=p;function b(a,u){return R.isMacintosh||u?a.replace(/\(&&\w\)|&&/g,""):R.isWindows?a.replace(/&&|&/g,c=>c==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.mnemonicButtonLabel=b;function i(a){return a.replace(/&/g,"&&")}e.unmnemonicLabel=i;function s(a){const u=a.indexOf("/")!==-1?k.posix:k.win32,c=u.basename(a),l=u.dirname(a);return c.length?{name:c,parentPath:l}:{name:l,parentPath:""}}e.splitName=s}),define(ye[113],Ce([1,0,2]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(L){return L.toJSON()}class k{constructor(P){this.a=P}transformIncoming(P){const y=this.a.transformIncoming(P);return y===P?P:t(o.URI.from(y))}transformOutgoing(P){const y=this.a.transformOutgoing(P);return y===P?P:t(o.URI.from(y))}transformOutgoingURI(P){const y=this.a.transformOutgoing(P);return y===P?P:o.URI.from(y)}transformOutgoingScheme(P){return this.a.transformOutgoingScheme(P)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(L){return L}transformOutgoing(L){return L}transformOutgoingURI(L){return L}transformOutgoingScheme(L){return L}};function R(L,P,y){if(!L||y>200)return null;if(typeof L=="object"){if(L instanceof o.URI)return P.transformOutgoing(L);for(const D in L)if(Object.hasOwnProperty.call(L,D)){const v=R(L[D],P,y+1);v!==null&&(L[D]=v)}}return null}function I(L,P){const y=R(L,P,0);return y===null?L:y}e.transformOutgoingURIs=I;function A(L,P,y,D){if(!L||D>200)return null;if(typeof L=="object"){if(L.$mid===1)return y?o.URI.revive(P.transformIncoming(L)):P.transformIncoming(L);for(const v in L)if(Object.hasOwnProperty.call(L,v)){const d=A(L[v],P,y,D+1);d!==null&&(L[v]=d)}}return null}function S(L,P){const y=A(L,P,!1,0);return y===null?L:y}e.transformIncomingURIs=S;function C(L,P){const y=A(L,P,!0,0);return y===null?L:y}e.transformAndReviveIncomingURIs=C}),define(ye[29],Ce([1,0,65,87,309,16,32,83,9,12,24,2]),function(ne,e,o,t,k,R,I,A,S,C,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function D(F,z=y.UNLINK){if((0,I.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");return z===y.UNLINK?d(F):v(F)}async function v(F){try{const z=(0,I.randomPath)((0,t.tmpdir)());try{await o.promises.rename(F,z)}catch(B){return B.code==="ENOENT"?void 0:d(F)}d(z).catch(B=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function d(F){return(0,k.promisify)(o.rm)(F,{recursive:!0,force:!0,maxRetries:3})}function m(F){if((0,I.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");o.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=m;async function h(F,z){return p(await(z?w(F):(0,k.promisify)(o.readdir)(F)))}async function w(F){try{return await(0,k.promisify)(o.readdir)(F,{withFileTypes:!0})}catch(W){console.warn("[node.js fs] readdir with filetypes failed with error: ",W)}const z=[],B=await h(F);for(const W of B){let X=!1,q=!1,_=!1;try{const Q=await e.Promises.lstat((0,S.join)(F,W));X=Q.isFile(),q=Q.isDirectory(),_=Q.isSymbolicLink()}catch(Q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Q)}z.push({name:W,isFile:()=>X,isDirectory:()=>q,isSymbolicLink:()=>_})}return z}function g(F){return p(o.readdirSync(F))}e.readdirSync=g;function p(F){return F.map(z=>typeof z=="string"?C.isMacintosh?(0,A.normalizeNFC)(z):z:(z.name=C.isMacintosh?(0,A.normalizeNFC)(z.name):z.name,z))}async function b(F){const z=await h(F),B=[];for(const W of z)await s.existsDirectory((0,S.join)(F,W))&&B.push(W);return B}function i(F,z=1e3){return new Promise(B=>{let W=!1;const X=setInterval(()=>{W||(W=!0,o.access(F,q=>{W=!1,q&&(clearInterval(X),B(void 0))}))},z)})}e.whenDeleted=i;var s;(function(F){async function z(X){let q;try{if(q=await e.Promises.lstat(X),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(X),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(_){if(_.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(C.isWindows&&_.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(X)),symbolicLink:{dangling:!1}}}catch(Q){if(Q.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw Q}throw _}}F.stat=z;async function B(X){try{const{stat:q,symbolicLink:_}=await F.stat(X);return q.isFile()&&_?.dangling!==!0}catch{}return!1}F.existsFile=B;async function W(X){try{const{stat:q,symbolicLink:_}=await F.stat(X);return q.isDirectory()&&_?.dangling!==!0}catch{}return!1}F.existsDirectory=W})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const a=new R.ResourceQueue;function u(F,z,B){return a.queueFor(P.URI.file(F),L.extUriBiasedIgnorePathCase).queue(()=>{const W=f(B);return new Promise((X,q)=>n(F,z,W,_=>_?q(_):X()))})}let c=!0;function l(F){c=F}e.configureFlushOnWrite=l;function n(F,z,B,W){if(!c)return o.writeFile(F,z,{mode:B.mode,flag:B.flag},W);o.open(F,B.flag,B.mode,(X,q)=>{if(X)return W(X);o.writeFile(q,z,_=>{if(_)return o.close(q,()=>W(_));o.fdatasync(q,Q=>(Q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Q),l(!1)),o.close(q,Z=>W(Z))))})})}function r(F,z,B){const W=f(B);if(!c)return o.writeFileSync(F,z,{mode:W.mode,flag:W.flag});const X=o.openSync(F,W.flag,W.mode);try{o.writeFileSync(X,z);try{o.fdatasyncSync(X)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),l(!1)}}finally{o.closeSync(X)}}e.writeFileSync=r;function f(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function E(F,z){if(F!==z)try{await e.Promises.rename(F,z)}catch(B){if(F.toLowerCase()!==z.toLowerCase()&&B.code==="EXDEV"||F.endsWith("."))await T(F,z,{preserveSymlinks:!1}),await D(F,y.MOVE);else throw B}}async function T(F,z,B){return G(F,z,{root:{source:F,target:z},options:B,handledSourcePaths:new Set})}const M=511;async function G(F,z,B){if(B.handledSourcePaths.has(F))return;B.handledSourcePaths.add(F);const{stat:W,symbolicLink:X}=await s.stat(F);if(X){if(B.options.preserveSymlinks)try{return await U(F,z,B)}catch(q){console.warn("[node.js fs] copy of symlink failed: ",q)}if(X.dangling)return}return W.isDirectory()?V(F,z,W.mode&M,B):N(F,z,W.mode&M)}async function V(F,z,B,W){await e.Promises.mkdir(z,{recursive:!0,mode:B});const X=await h(F);for(const q of X)await G((0,S.join)(F,q),(0,S.join)(z,q),W)}async function N(F,z,B){await e.Promises.copyFile(F,z),await e.Promises.chmod(z,B)}async function U(F,z,B){let W=await e.Promises.readlink(F);(0,I.isEqualOrParent)(W,B.root.source,!C.isLinux)&&(W=(0,S.join)(B.root.target,W.substr(B.root.source.length+1))),await e.Promises.symlink(W,z)}e.Promises=new class{get access(){return(0,k.promisify)(o.access)}get stat(){return(0,k.promisify)(o.stat)}get lstat(){return(0,k.promisify)(o.lstat)}get utimes(){return(0,k.promisify)(o.utimes)}get read(){return(F,z,B,W,X)=>new Promise((q,_)=>{o.read(F,z,B,W,X,(Q,Z,ge)=>Q?_(Q):q({bytesRead:Z,buffer:ge}))})}get readFile(){return(0,k.promisify)(o.readFile)}get write(){return(F,z,B,W,X)=>new Promise((q,_)=>{o.write(F,z,B,W,X,(Q,Z,ge)=>Q?_(Q):q({bytesWritten:Z,buffer:ge}))})}get appendFile(){return(0,k.promisify)(o.appendFile)}get fdatasync(){return(0,k.promisify)(o.fdatasync)}get truncate(){return(0,k.promisify)(o.truncate)}get rename(){return(0,k.promisify)(o.rename)}get copyFile(){return(0,k.promisify)(o.copyFile)}get open(){return(0,k.promisify)(o.open)}get close(){return(0,k.promisify)(o.close)}get symlink(){return(0,k.promisify)(o.symlink)}get readlink(){return(0,k.promisify)(o.readlink)}get chmod(){return(0,k.promisify)(o.chmod)}get mkdir(){return(0,k.promisify)(o.mkdir)}get unlink(){return(0,k.promisify)(o.unlink)}get rmdir(){return(0,k.promisify)(o.rmdir)}get realpath(){return(0,k.promisify)(o.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return b}get writeFile(){return u}get rm(){return D}get move(){return E}get copy(){return T}}}),define(ye[114],Ce([1,0,65,9,12,8,29]),function(ne,e,o,t,k,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function A(y){if(k.isLinux)return y;const D=(0,t.dirname)(y);if(y===D)return y;const v=((0,t.basename)(y)||y).toLowerCase();try{const m=(0,I.readdirSync)(D).filter(h=>h.toLowerCase()===v);if(m.length===1){const h=A(D);if(h)return(0,t.join)(h,m[0])}else if(m.length>1){const h=m.indexOf(v);if(h>=0){const w=A(D);if(w)return(0,t.join)(w,m[h])}}}catch{}return null}e.realcaseSync=A;async function S(y){if(k.isLinux)return y;const D=(0,t.dirname)(y);if(y===D)return y;const v=((0,t.basename)(y)||y).toLowerCase();try{const m=(await I.Promises.readdir(D)).filter(h=>h.toLowerCase()===v);if(m.length===1){const h=await S(D);if(h)return(0,t.join)(h,m[0])}else if(m.length>1){const h=m.indexOf(v);if(h>=0){const w=await S(D);if(w)return(0,t.join)(w,m[h])}}}catch{}return null}e.realcase=S;async function C(y){try{return await I.Promises.realpath(y)}catch{const v=P(y);return await I.Promises.access(v,o.constants.R_OK),v}}e.realpath=C;function L(y){try{return o.realpathSync(y)}catch{const v=P(y);return o.accessSync(v,o.constants.R_OK),v}}e.realpathSync=L;function P(y){return(0,R.rtrim)((0,t.normalize)(y),t.sep)}}),define(ye[115],Ce([1,0,9,12,36,107,11,29]),function(ne,e,o,t,k,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function S(P=k.env){return P.comspec||"cmd.exe"}e.getWindowsShell=S;function C(P){let y=[],D=!1;const v=function(d){if(D){y.push(d);return}(!P.send(d,h=>{if(h&&console.error(h),D=!1,y.length>0){const w=y.slice(0);y=[],w.forEach(g=>v(g))}})||t.isWindows)&&(D=!0)};return{send:v}}e.createQueuedSender=C;var L;(function(P){async function y(D,v,d){if(o.isAbsolute(D))return D;if(v===void 0&&(v=k.cwd()),o.dirname(D)!=="."||(d===void 0&&I.isString(k.env.PATH)&&(d=k.env.PATH.split(o.delimiter)),d===void 0||d.length===0))return o.join(v,D);async function h(w){if(await A.Promises.exists(w)){let g;try{g=await A.Promises.stat(w)}catch(p){p.message.startsWith("EACCES")&&(g=await A.Promises.lstat(w))}return g?!g.isDirectory():!1}return!1}for(const w of d){let g;if(o.isAbsolute(w)?g=o.join(w,D):g=o.join(v,w,D),await h(g))return g;let p=g+".com";if(await h(p)||(p=g+".exe",await h(p)))return p}return o.join(v,D)}P.findExecutable=y})(L=e.win32||(e.win32={}))});var qe=this&&this.__decorate||function(ne,e,o,t){var k=arguments.length,R=k<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,o):t,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(ne,e,o,t);else for(var A=ne.length-1;A>=0;A--)(I=ne[A])&&(R=(k<3?I(R):k>3?I(e,o,R):I(e,o))||R);return k>3&&R&&Object.defineProperty(e,o,R),R};define(ye[116],Ce([1,0,18,16,22,21,60,10,4,6,86,8,11]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var D;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(D||(D={}));function v(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(d||(d={}));function m(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(h||(h={}));function w(q){let _=0;for(let Q=0;;Q+=7){const Z=q.read(1);if(_|=(Z.buffer[0]&127)<<Q,!(Z.buffer[0]&128))return _}}const g=a(0);function p(q,_){if(_===0){q.write(g);return}let Q=0;for(let ge=_;ge!==0;ge=ge>>>7)Q++;const Z=k.VSBuffer.alloc(Q);for(let ge=0;_!==0;ge++)Z.buffer[ge]=_&127,_=_>>>7,_>0&&(Z.buffer[ge]|=128);q.write(Z)}class b{constructor(_){this.b=_,this.a=0}read(_){const Q=this.b.slice(this.a,this.a+_);return this.a+=Q.byteLength,Q}}e.BufferReader=b;class i{constructor(){this.a=[]}get buffer(){return k.VSBuffer.concat(this.a)}write(_){this.a.push(_)}}e.BufferWriter=i;var s;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object",q[q.Int=6]="Int"})(s||(s={}));function a(q){const _=k.VSBuffer.alloc(1);return _.writeUInt8(q,0),_}const u={Undefined:a(s.Undefined),String:a(s.String),Buffer:a(s.Buffer),VSBuffer:a(s.VSBuffer),Array:a(s.Array),Object:a(s.Object),Uint:a(s.Int)},c=typeof Buffer<"u";function l(q,_){if(typeof _>"u")q.write(u.Undefined);else if(typeof _=="string"){const Q=k.VSBuffer.fromString(_);q.write(u.String),p(q,Q.byteLength),q.write(Q)}else if(c&&Buffer.isBuffer(_)){const Q=k.VSBuffer.wrap(_);q.write(u.Buffer),p(q,Q.byteLength),q.write(Q)}else if(_ instanceof k.VSBuffer)q.write(u.VSBuffer),p(q,_.byteLength),q.write(_);else if(Array.isArray(_)){q.write(u.Array),p(q,_.length);for(const Q of _)l(q,Q)}else if(typeof _=="number"&&(_|0)===_)q.write(u.Uint),p(q,_);else{const Q=k.VSBuffer.fromString(JSON.stringify(_));q.write(u.Object),p(q,Q.byteLength),q.write(Q)}}e.serialize=l;function n(q){switch(q.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return q.read(w(q)).toString();case s.Buffer:return q.read(w(q)).buffer;case s.VSBuffer:return q.read(w(q));case s.Array:{const Q=w(q),Z=[];for(let ge=0;ge<Q;ge++)Z.push(n(q));return Z}case s.Object:return JSON.parse(q.read(w(q)).toString());case s.Int:return w(q)}}e.deserialize=n;class r{constructor(_,Q,Z=null,ge=1e3){this.h=_,this.j=Q,this.k=Z,this.l=ge,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(te=>this.q(te)),this.m({type:200})}registerChannel(_,Q){this.b.set(_,Q),setTimeout(()=>this.w(_),0)}m(_){switch(_.type){case 200:{const Q=this.o([_.type]);this.k?.logOutgoing(Q,0,1,m(_.type));return}case 201:case 202:case 204:case 203:{const Q=this.o([_.type,_.id],_.data);this.k?.logOutgoing(Q,_.id,1,m(_.type),_.data);return}}}o(_,Q=void 0){const Z=new i;return l(Z,_),l(Z,Q),this.p(Z.buffer)}p(_){try{return this.h.send(_),_.byteLength}catch{return 0}}q(_){const Q=new b(_),Z=n(Q),ge=n(Q),te=Z[0];switch(te){case 100:return this.k?.logIncoming(_.byteLength,Z[1],1,`${v(te)}: ${Z[2]}.${Z[3]}`,ge),this.s({type:te,id:Z[1],channelName:Z[2],name:Z[3],arg:ge});case 102:return this.k?.logIncoming(_.byteLength,Z[1],1,`${v(te)}: ${Z[2]}.${Z[3]}`,ge),this.t({type:te,id:Z[1],channelName:Z[2],name:Z[3],arg:ge});case 101:return this.k?.logIncoming(_.byteLength,Z[1],1,`${v(te)}`),this.u({type:te,id:Z[1]});case 103:return this.k?.logIncoming(_.byteLength,Z[1],1,`${v(te)}`),this.u({type:te,id:Z[1]})}}s(_){const Q=this.b.get(_.channelName);if(!Q){this.v(_);return}const Z=new R.CancellationTokenSource;let ge;try{ge=Q.call(this.j,_.name,_.arg,Z.token)}catch(fe){ge=Promise.reject(fe)}const te=_.id;ge.then(fe=>{this.m({id:te,data:fe,type:201}),this.d.delete(_.id)},fe=>{fe instanceof Error?this.m({id:te,data:{message:fe.message,name:fe.name,stack:fe.stack?fe.stack.split?fe.stack.split(`
`):fe.stack:void 0},type:202}):this.m({id:te,data:fe,type:203}),this.d.delete(_.id)});const J=(0,C.toDisposable)(()=>Z.cancel());this.d.set(_.id,J)}t(_){const Q=this.b.get(_.channelName);if(!Q){this.v(_);return}const Z=_.id,te=Q.listen(this.j,_.name,_.arg)(J=>this.m({id:Z,data:J,type:204}));this.d.set(_.id,te)}u(_){const Q=this.d.get(_.id);Q&&(Q.dispose(),this.d.delete(_.id))}v(_){let Q=this.g.get(_.channelName);Q||(Q=[],this.g.set(_.channelName,Q));const Z=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.m({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Q.push({request:_,timeoutTimer:Z})}w(_){const Q=this.g.get(_);if(Q){for(const Z of Q)switch(clearTimeout(Z.timeoutTimer),Z.request.type){case 100:this.s(Z.request);break;case 102:this.t(Z.request);break}this.g.delete(_)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,C.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=r;var f;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(_,Q=null){this.l=_,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new S.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Z=>this.s(Z)),this.j=Q}getChannel(_){const Q=this;return{call(Z,ge,te){return Q.a?Promise.reject(new A.CancellationError):Q.m(_,Z,ge,te)},listen(Z,ge){return Q.a?S.Event.None:Q.o(_,Z,ge)}}}m(_,Q,Z,ge=R.CancellationToken.None){const te=this.g++,fe={id:te,type:100,channelName:_,name:Q,arg:Z};if(ge.isCancellationRequested)return Promise.reject(new A.CancellationError);let ve;return new Promise((Ae,Fe)=>{if(ge.isCancellationRequested)return Fe(new A.CancellationError);const se=()=>{const ae=ie=>{switch(ie.type){case 201:this.f.delete(te),Ae(ie.data);break;case 202:{this.f.delete(te);const O=new Error(ie.data.message);O.stack=Array.isArray(ie.data.stack)?ie.data.stack.join(`
`):ie.data.stack,O.name=ie.data.name,Fe(O);break}case 203:this.f.delete(te),Fe(ie.data);break}};this.f.set(te,ae),this.p(fe)};let le=null;this.b===h.Idle?se():(le=(0,t.createCancelablePromise)(ae=>this.u()),le.then(()=>{le=null,se()}));const ue=()=>{le?(le.cancel(),le=null):this.p({id:te,type:101}),Fe(new A.CancellationError)},ee=ge.onCancellationRequested(ue);ve=(0,C.combinedDisposable)((0,C.toDisposable)(ue),ee),this.d.add(ve)}).finally(()=>{this.d.delete(ve)})}o(_,Q,Z){const ge=this.g++,J={id:ge,type:102,channelName:_,name:Q,arg:Z};let fe=null;const ve=new S.Emitter({onWillAddFirstListener:()=>{fe=(0,t.createCancelablePromise)(Ae=>this.u()),fe.then(()=>{fe=null,this.d.add(ve),this.p(J)})},onDidRemoveLastListener:()=>{fe?(fe.cancel(),fe=null):(this.d.delete(ve),this.p({id:ge,type:103}))}}),Ee=Ae=>ve.fire(Ae.data);return this.f.set(ge,Ee),ve.event}p(_){switch(_.type){case 100:case 102:{const Q=this.q([_.type,_.id,_.channelName,_.name],_.arg);this.j?.logOutgoing(Q,_.id,0,`${v(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const Q=this.q([_.type,_.id]);this.j?.logOutgoing(Q,_.id,0,v(_.type));return}}}q(_,Q=void 0){const Z=new i;return l(Z,_),l(Z,Q),this.r(Z.buffer)}r(_){try{return this.l.send(_),_.byteLength}catch{return 0}}s(_){const Q=new b(_),Z=n(Q),ge=n(Q),te=Z[0];switch(te){case 200:return this.j?.logIncoming(_.byteLength,0,0,m(te)),this.t({type:Z[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(_.byteLength,Z[1],0,m(te),ge),this.t({type:Z[0],id:Z[1],data:ge})}}t(_){if(_.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(_.id)?.(_)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,C.dispose)(this.d.values()),this.d.clear()}}qe([I.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class T{get connections(){const _=[];return this.f.forEach(Q=>_.push(Q)),_}constructor(_){this.a=new Map,this.f=new Set,this.g=new S.Emitter,this.onDidAddConnection=this.g.event,this.h=new S.Emitter,this.onDidRemoveConnection=this.h.event,_(({protocol:Q,onDidClientDisconnect:Z})=>{S.Event.once(Q.onMessage)(te=>{const J=new b(te),fe=n(J),ve=new r(Q,fe),Ee=new E(Q);this.a.forEach((Fe,se)=>ve.registerChannel(se,Fe));const Ae={channelServer:ve,channelClient:Ee,ctx:fe};this.f.add(Ae),this.g.fire(Ae),Z(()=>{ve.dispose(),Ee.dispose(),this.f.delete(Ae),this.h.fire(Ae)})})})}getChannel(_,Q){const Z=this;return{call(ge,te,J){let fe;if((0,y.isFunction)(Q)){const Ee=(0,o.getRandomElement)(Z.connections.filter(Q));fe=Ee?Promise.resolve(Ee):S.Event.toPromise(S.Event.filter(Z.onDidAddConnection,Q))}else fe=Q.routeCall(Z,ge,te);const ve=fe.then(Ee=>Ee.channelClient.getChannel(_));return G(ve).call(ge,te,J)},listen(ge,te){if((0,y.isFunction)(Q))return Z.j(_,Q,ge,te);const J=Q.routeEvent(Z,ge,te).then(fe=>fe.channelClient.getChannel(_));return G(J).listen(ge,te)}}}j(_,Q,Z,ge){const te=this;let J=new C.DisposableStore;const fe=new S.Emitter({onWillAddFirstListener:()=>{J=new C.DisposableStore;const ve=new S.EventMultiplexer,Ee=new Map,Ae=se=>{const ue=se.channelClient.getChannel(_).listen(Z,ge),ee=ve.add(ue);Ee.set(se,ee)},Fe=se=>{const le=Ee.get(se);!le||(le.dispose(),Ee.delete(se))};te.connections.filter(Q).forEach(Ae),S.Event.filter(te.onDidAddConnection,Q)(Ae,void 0,J),te.onDidRemoveConnection(Fe,void 0,J),ve.event(fe.fire,fe,J),J.add(ve)},onDidRemoveLastListener:()=>{J.dispose()}});return fe.event}registerChannel(_,Q){this.a.set(_,Q),this.f.forEach(Z=>{Z.channelServer.registerChannel(_,Q)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=T;class M{constructor(_,Q,Z=null){const ge=new i;l(ge,Q),_.send(ge.buffer),this.a=new E(_,Z),this.d=new r(_,Q,Z)}getChannel(_){return this.a.getChannel(_)}registerChannel(_,Q){this.d.registerChannel(_,Q)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=M;function G(q){return{call(_,Q,Z){return q.then(ge=>ge.call(_,Q,Z))},listen(_,Q){const Z=new S.Relay;return q.then(ge=>Z.input=ge.listen(_,Q)),Z.event}}}e.getDelayedChannel=G;function V(q){let _=!1;return{call(Q,Z,ge){return _?q.call(Q,Z,ge):(0,t.timeout)(0).then(()=>_=!0).then(()=>q.call(Q,Z,ge))},listen(Q,Z){if(_)return q.listen(Q,Z);const ge=new S.Relay;return(0,t.timeout)(0).then(()=>_=!0).then(()=>ge.input=q.listen(Q,Z)),ge.event}}}e.getNextTickChannel=V;class N{constructor(_){this.a=_}routeCall(_){return this.b(_)}routeEvent(_){return this.b(_)}async b(_){for(const Q of _.connections)if(await Promise.resolve(this.a(Q.ctx)))return Promise.resolve(Q);return await S.Event.toPromise(_.onDidAddConnection),await this.b(_)}}e.StaticRouter=N;var U;(function(q){function _(te,J){const fe=te,ve=J&&J.disableMarshalling,Ee=new Map;for(const Ae in fe)Z(Ae)&&Ee.set(Ae,S.Event.buffer(fe[Ae],!0));return new class{listen(Ae,Fe,se){const le=Ee.get(Fe);if(le)return le;if(ge(Fe)){const ue=fe[Fe];if(typeof ue=="function")return ue.call(fe,se)}throw new Error(`Event not found: ${Fe}`)}call(Ae,Fe,se){const le=fe[Fe];if(typeof le=="function"){if(!ve&&Array.isArray(se))for(let ue=0;ue<se.length;ue++)se[ue]=(0,L.revive)(se[ue]);return le.apply(fe,se)}throw new Error(`Method not found: ${Fe}`)}}}q.fromService=_;function Q(te,J){const fe=J&&J.disableMarshalling;return new Proxy({},{get(ve,Ee){if(typeof Ee=="string")return J?.properties?.has(Ee)?J.properties.get(Ee):ge(Ee)?function(Ae){return te.listen(Ee,Ae)}:Z(Ee)?te.listen(Ee):async function(...Ae){let Fe;J&&!(0,y.isUndefinedOrNull)(J.context)?Fe=[J.context,...Ae]:Fe=Ae;const se=await te.call(Ee,Fe);return fe?se:(0,L.revive)(se)};throw new Error(`Property not found: ${String(Ee)}`)}})}q.toService=Q;function Z(te){return te[0]==="o"&&te[1]==="n"&&P.isUpperAsciiLetter(te.charCodeAt(2))}function ge(te){return/^onDynamic/.test(te)&&P.isUpperAsciiLetter(te.charCodeAt(9))}})(U=e.ProxyChannel||(e.ProxyChannel={}));const F=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function z(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const _=q.toString();if(_!=="[object Object]")return _}return q}function B(q){return Array.isArray(q)?q.map(z):z(q)}function W(q,_,Q,Z,ge,te,J){J=B(J);const fe=F[ge],ve=fe[Z%fe.length];let Ee=[`%c[${q}]%c[${String(_).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(Z).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${ve}`];/\($/.test(te)?(Ee=Ee.concat(J),Ee.push(")")):Ee.push(J),console.log.apply(console,Ee)}class X{constructor(_,Q){this.d=_,this.f=Q,this.a=0,this.b=0}logOutgoing(_,Q,Z,ge,te){this.b+=_,W(this.d,this.b,_,Q,Z,ge,te)}logIncoming(_,Q,Z,ge,te){this.a+=_,W(this.f,this.a,_,Q,Z,ge,te)}}e.IPCLogger=X}),define(ye[117],Ce([1,0,16,22,4,6,116]),function(ne,e,o,t,k,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(E){E.Created="created",E.Read="read",E.Write="write",E.Open="open",E.Error="error",E.Close="close",E.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",E.NodeEndReceived="nodeEndReceived",E.NodeEndSent="nodeEndSent",E.NodeDrainBegin="nodeDrainBegin",E.NodeDrainEnd="nodeDrainEnd",E.zlibInflateError="zlibInflateError",E.zlibInflateData="zlibInflateData",E.zlibInflateInitialWrite="zlibInflateInitialWrite",E.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",E.zlibInflateWrite="zlibInflateWrite",E.zlibInflateFlushFired="zlibInflateFlushFired",E.zlibDeflateError="zlibDeflateError",E.zlibDeflateData="zlibDeflateData",E.zlibDeflateWrite="zlibDeflateWrite",E.zlibDeflateFlushFired="zlibDeflateFlushFired",E.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",E.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",E.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",E.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",E.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",E.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",E.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",E.ProtocolHeaderRead="protocolHeaderRead",E.ProtocolMessageRead="protocolMessageRead",E.ProtocolHeaderWrite="protocolHeaderWrite",E.ProtocolMessageWrite="protocolMessageWrite",E.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var S;(function(E){E.enableDiagnostics=!1,E.records=[];const T=new WeakMap;let M=0;function G(N,U){if(!T.has(N)){const F=String(++M);T.set(N,F)}return T.get(N)}function V(N,U,F,z){if(!E.enableDiagnostics)return;const B=G(N,U);if(z instanceof t.VSBuffer||z instanceof Uint8Array||z instanceof ArrayBuffer||ArrayBuffer.isView(z)){const W=t.VSBuffer.alloc(z.byteLength);W.set(z),E.records.push({timestamp:Date.now(),id:B,label:U,type:F,buff:W})}else E.records.push({timestamp:Date.now(),id:B,label:U,type:F,data:z})}E.traceSocketEvent=V})(S=e.SocketDiagnostics||(e.SocketDiagnostics={}));var C;(function(E){E[E.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",E[E.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(C=e.SocketCloseEventType||(e.SocketCloseEventType={}));let L=null;function P(){return L||(L=t.VSBuffer.alloc(0)),L}class y{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(T){this.a.push(T),this.b+=T.byteLength}read(T){return this.c(T,!0)}peek(T){return this.c(T,!1)}c(T,M){if(T===0)return P();if(T>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===T){const U=this.a[0];return M&&(this.a.shift(),this.b-=T),U}if(this.a[0].byteLength>T){const U=this.a[0].slice(0,T);return M&&(this.a[0]=this.a[0].slice(T),this.b-=T),U}const G=t.VSBuffer.alloc(T);let V=0,N=0;for(;T>0;){const U=this.a[N];if(U.byteLength>T){const F=U.slice(0,T);G.set(F,V),V+=T,M&&(this.a[N]=U.slice(T),this.b-=T),T-=T}else G.set(U,V),V+=U.byteLength,M?(this.a.shift(),this.b-=U.byteLength):N++,T-=U.byteLength}return G}}e.ChunkStream=y;var D;(function(E){E[E.None=0]="None",E[E.Regular=1]="Regular",E[E.Control=2]="Control",E[E.Ack=3]="Ack",E[E.Disconnect=5]="Disconnect",E[E.ReplayRequest=6]="ReplayRequest",E[E.Pause=7]="Pause",E[E.Resume=8]="Resume",E[E.KeepAlive=9]="KeepAlive",E[E.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",E[E.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(D||(D={}));function v(E){switch(E){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var d;(function(E){E[E.HeaderLength=13]="HeaderLength",E[E.AcknowledgeTime=2e3]="AcknowledgeTime",E[E.TimeoutTime=2e4]="TimeoutTime",E[E.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",E[E.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",E[E.KeepAliveSendTime=5e3]="KeepAliveSendTime",E[E.LatencySampleTime=6e4]="LatencySampleTime",E[E.LatencySampleCount=5]="LatencySampleCount",E[E.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",E[E.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(d=e.ProtocolConstants||(e.ProtocolConstants={}));class m{constructor(T,M,G,V){this.type=T,this.id=M,this.ack=G,this.data=V,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends R.Disposable{constructor(T){super(),this.f=this.B(new k.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=T,this.b=!1,this.c=new y,this.B(this.a.onData(M=>this.acceptChunk(M))),this.lastReadTime=Date.now()}acceptChunk(T){if(!(!T||T.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(T);this.c.byteLength>=this.g.readLen;){const M=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=M.readUInt32BE(9),this.g.messageType=M.readUInt8(0),this.g.id=M.readUInt32BE(1),this.g.ack=M.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:v(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const G=this.g.messageType,V=this.g.id,N=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",M),this.f.fire(new m(G,V,N,M)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class w{constructor(T){this.k=null,this.a=!1,this.b=!1,this.c=T,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(T){if(this.a)return;T.writtenTime=Date.now(),this.lastWriteTime=Date.now();const M=t.VSBuffer.alloc(13);M.writeUInt8(T.type,0),M.writeUInt32BE(T.id,1),M.writeUInt32BE(T.ack,5),M.writeUInt32BE(T.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:v(T.type),id:T.id,ack:T.ack,messageSize:T.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",T.data),this.j(M,T.data)}g(T,M){const G=this.f===0;return this.d.push(T,M),this.f+=T.byteLength+M.byteLength,G}h(){const T=t.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,T}j(T,M){this.g(T,M)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const T=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:T.byteLength}),this.c.write(T)}}class g extends R.Disposable{constructor(T){super(),this.f=new k.Emitter,this.onMessage=this.f.event,this.g=new k.Emitter,this.onDidDispose=this.g.event,this.a=T,this.b=this.B(new w(this.a)),this.c=this.B(new h(this.a)),this.B(this.c.onMessage(M=>{M.type===1&&this.f.fire(M.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(T){this.b.write(new m(1,0,0,T))}}e.Protocol=g;class p extends I.IPCClient{static fromSocket(T,M){return new p(new g(T),M)}get onDidDispose(){return this.b.onDidDispose}constructor(T,M,G=null){super(T,M,G),this.b=T}dispose(){super.dispose();const T=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),T.end()}}e.Client=p;class b{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new k.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(T){this.b?this.d.length>0?this.d.push(T):this.a.fire(T):this.d.push(T)}flushBuffer(){this.d=[]}}e.BufferedEmitter=b;class i{constructor(T){this.data=T,this.next=null}}class s{constructor(){this.a=null,this.b=null}length(){let T=0,M=this.a;for(;M;)M=M.next,T++;return T}peek(){return this.a?this.a.data:null}toArray(){const T=[];let M=0,G=this.a;for(;G;)T[M++]=G.data,G=G.next;return T}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(T){const M=new i(T);if(!this.a){this.a=M,this.b=M;return}this.b.next=M,this.b=M}}class a{static getInstance(){return a.b||(a.b=new a),a.b}constructor(){this.c=[];const T=Date.now();for(let M=0;M<a.a;M++)this.c[M]=T-1e3*M;setInterval(()=>{for(let M=a.a;M>=1;M--)this.c[M]=this.c[M-1];this.c[0]=Date.now()},1e3)}d(){const T=Date.now(),M=(1+a.a)*1e3;let G=0;for(let V=0;V<a.a;V++)T-this.c[V]<=M&&G++;return 1-G/a.a}hasHighLoad(){return this.d()>=.5}}a.a=10,a.b=null;var u;(function(E){E[E.Good=0]="Good",E[E.Poor=1]="Poor"})(u=e.ConnectionHealth||(e.ConnectionHealth={}));function c(E){switch(E){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=c;class l{constructor(T){this.connectionHealth=T}}e.ConnectionHealthChangedEvent=l;class n{constructor(T,M){this.roundTripTime=T,this.recentHighRoundTripCount=M}}e.HighRoundTripTimeEvent=n;class r{get unacknowledgedCount(){return this.c-this.d}constructor(T){this.x=new b,this.onControlMessage=this.x.event,this.y=new b,this.onMessage=this.y.event,this.z=new b,this.onDidDispose=this.z.event,this.A=new b,this.onSocketClose=this.A.event,this.B=new b,this.onSocketTimeout=this.B.event,this.C=new b,this.onHighRoundTripTime=this.C.event,this.D=new b,this.onDidChangeConnectionHealth=this.D.event,this.u=T.loadEstimator??a.getInstance(),this.v=T.measureRoundTripTime??!1,this.w=T.sendKeepAlive??!0,this.a=!1,this.b=new s,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new R.DisposableStore,this.o=T.socket,this.p=this.t.add(new w(this.o)),this.q=this.t.add(new h(this.o)),this.t.add(this.q.onMessage(M=>this.E(M))),this.t.add(this.o.onClose(M=>this.A.fire(M))),this.r=this.t.add(new f),this.t.add(this.r.onSendLatencyRequest(M=>this.J(M))),this.t.add(this.r.onHighRoundTripTime(M=>this.C.fire(M))),this.t.add(this.r.onDidChangeConnectionHealth(M=>this.D.fire(M))),this.v&&this.r.start(),T.initialChunk&&this.q.acceptChunk(T.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const T=new m(5,0,0,P());this.p.write(T),this.p.flush()}sendPause(){const T=new m(7,0,0,P());this.p.write(T)}sendResume(){const T=new m(8,0,0,P());this.p.write(T)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(T,M){this.a=!0,this.t.dispose(),this.t=new R.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=T,this.p=this.t.add(new w(this.o)),this.q=this.t.add(new h(this.o)),this.t.add(this.q.onMessage(G=>this.E(G))),this.t.add(this.o.onClose(G=>this.A.fire(G))),this.r=this.t.add(new f),this.t.add(this.r.onSendLatencyRequest(G=>this.J(G))),this.t.add(this.r.onHighRoundTripTime(G=>this.C.fire(G))),this.t.add(this.r.onDidChangeConnectionHealth(G=>this.D.fire(G))),this.q.acceptChunk(M)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const T=new m(3,0,this.h,P());this.p.write(T);const M=this.b.toArray();for(let G=0,V=M.length;G<V;G++)this.p.write(M[G]);this.G()}acceptDisconnect(){this.z.fire()}E(T){if(T.ack>this.d){this.d=T.ack;do{const M=this.b.peek();if(M&&M.id<=T.ack)this.b.pop();else break}while(!0)}switch(T.type){case 0:break;case 1:{if(T.id>this.g)if(T.id!==this.g+1){const M=Date.now();M-this.m>1e4&&(this.m=M,this.p.write(new m(6,0,0,P())))}else this.g=T.id,this.j=Date.now(),this.F(),this.y.fire(T.data);break}case 2:{this.x.fire(T.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const M=this.b.toArray();for(let G=0,V=M.length;G<V;G++)this.p.write(M[G]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(T.data);break}case 11:{this.r.handleResponse(T.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(T){const M=++this.c;this.h=this.g;const G=new m(1,M,this.h,T);this.b.push(G),this.a||(this.p.write(G),this.G())}sendControl(T){const M=new m(2,0,0,T);this.p.write(M)}F(){if(this.g<=this.h||this.k)return;const T=Date.now()-this.j;if(T>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-T+5)}G(){if(this.c<=this.d||this.f||this.a)return;const T=this.b.peek(),M=Date.now()-T.writtenTime,G=Date.now()-this.q.lastReadTime,V=Date.now()-this.n;if(M>=2e4&&G>=2e4&&V>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:M,timeSinceLastReceivedSomeData:G});return}const N=Math.max(2e4-M,2e4-G,2e4-V,500);this.f=setTimeout(()=>{this.f=null,this.G()},N)}H(){if(this.g<=this.h)return;this.h=this.g;const T=new m(3,0,this.h,P());this.p.write(T)}I(){this.h=this.g;const T=new m(9,0,this.h,P());this.p.write(T)}J(T){this.h=this.g;const M=new m(10,0,this.h,T);this.p.write(M)}K(T){this.h=this.g;const M=new m(11,0,this.h,T);this.p.write(M)}}e.PersistentProtocol=r;class f extends R.Disposable{constructor(){super(),this.a=this.B(new k.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new k.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new k.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new o.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},T=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const T=++this.h,M=t.VSBuffer.alloc(4);M.writeUInt32BE(T,0),this.a.fire(M)},6e4)}handleResponse(T){if(T.byteLength!==4)return;const M=T.readUInt32BE(0);if(this.g<=0||M!==this.h)return;const G=Date.now()-this.g,V=this.k++;this.j[V%this.j.length]=G;const N=this.l,U=this.j.filter(F=>F>=1e3).length;this.l=U>=3?1:0,G>1e3&&this.b.fire(new n(G,U)),N!==this.l&&this.c.fire(this.l)}}}),define(ye[118],Ce([1,0,22,10,4,6,9,12,30,116,117]),function(ne,e,o,t,k,R,I,A,S,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function P(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class y{traceSocketEvent(n,r){L.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,n,r)}constructor(n,r=""){this.f=!0,this.debugLabel=r,this.socket=n,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=f=>{if(this.traceSocketEvent("error",{code:f?.code,message:f?.message}),f){if(f.code==="EPIPE")return;(0,t.onUnexpectedError)(f)}},this.socket.on("error",this.a),this.b=f=>{this.traceSocketEvent("close",{hadError:f}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(n){const r=f=>{this.traceSocketEvent("read",f),n(o.VSBuffer.wrap(f))};return this.socket.on("data",r),{dispose:()=>this.socket.off("data",r)}}onClose(n){const r=f=>{n({type:0,hadError:f,error:void 0})};return this.socket.on("close",r),{dispose:()=>this.socket.off("close",r)}}onEnd(n){const r=()=>{n()};return this.socket.on("end",r),{dispose:()=>this.socket.off("end",r)}}write(n){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",n),this.socket.write(n.buffer,r=>{if(r){if(r.code==="EPIPE")return;(0,t.onUnexpectedError)(r)}})}catch(r){if(r.code==="EPIPE")return;(0,t.onUnexpectedError)(r)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((n,r)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),n();return}const f=()=>{this.socket.off("close",f),this.socket.off("end",f),this.socket.off("error",f),this.socket.off("timeout",f),this.socket.off("drain",f),this.traceSocketEvent("nodeDrainEnd"),n()};this.socket.on("close",f),this.socket.on("end",f),this.socket.on("error",f),this.socket.on("timeout",f),this.socket.on("drain",f)})}}e.NodeSocket=y;var D;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(D||(D={}));var v;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(v||(v={}));class d extends R.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(n,r){this.socket.traceSocketEvent(n,r)}constructor(n,r,f,E){super(),this.f=this.B(new k.Emitter),this.g=this.B(new k.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=n,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:r,inflateBytesLength:f?.byteLength||0,recordInflateBytes:E}),this.a=this.B(new m(this,r,f,E,this.f,(T,M)=>this.k(T,M))),this.B(this.a.onError(T=>{console.error(T),(0,t.onUnexpectedError)(T),this.g.fire({type:0,hadError:!0,error:T})})),this.b=new L.ChunkStream,this.B(this.socket.onData(T=>this.l(T))),this.B(this.socket.onClose(T=>this.g.fire(T)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(n){return this.f.event(n)}onClose(n){return this.g.event(n)}onEnd(n){return this.socket.onEnd(n)}write(n){this.a.writeMessage(n)}k(n,r){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",n);let f=2;n.byteLength<126?f+=0:n.byteLength<2**16?f+=2:f+=8;const E=o.VSBuffer.alloc(f);if(r?E.writeUInt8(194,0):E.writeUInt8(130,0),n.byteLength<126)E.writeUInt8(n.byteLength,1);else if(n.byteLength<2**16){E.writeUInt8(126,1);let T=1;E.writeUInt8(n.byteLength>>>8&255,++T),E.writeUInt8(n.byteLength>>>0&255,++T)}else{E.writeUInt8(127,1);let T=1;E.writeUInt8(0,++T),E.writeUInt8(0,++T),E.writeUInt8(0,++T),E.writeUInt8(0,++T),E.writeUInt8(n.byteLength>>>24&255,++T),E.writeUInt8(n.byteLength>>>16&255,++T),E.writeUInt8(n.byteLength>>>8&255,++T),E.writeUInt8(n.byteLength>>>0&255,++T)}this.socket.write(o.VSBuffer.concat([E,n]))}end(){this.h=!0,this.socket.end()}l(n){if(n.byteLength!==0){for(this.b.acceptChunk(n);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const r=this.b.peek(this.j.readLen),f=r.readUInt8(0),E=(f&128)>>>7,T=(f&64)>>>6,M=r.readUInt8(1),G=(M&128)>>>7,V=M&127;this.j.state=2,this.j.readLen=2+(G?4:0)+(V===126?2:0)+(V===127?8:0),this.j.fin=E,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(T)),this.j.firstFrameOfMessage=Boolean(E),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const r=this.b.read(this.j.readLen),f=r.readUInt8(1),E=(f&128)>>>7;let T=f&127,M=1;T===126?T=r.readUInt8(++M)*2**8+r.readUInt8(++M):T===127&&(T=r.readUInt8(++M)*0+r.readUInt8(++M)*0+r.readUInt8(++M)*0+r.readUInt8(++M)*0+r.readUInt8(++M)*2**24+r.readUInt8(++M)*2**16+r.readUInt8(++M)*2**8+r.readUInt8(++M));let G=0;E&&(G=r.readUInt8(++M)*2**24+r.readUInt8(++M)*2**16+r.readUInt8(++M)*2**8+r.readUInt8(++M)),this.j.state=3,this.j.readLen=T,this.j.mask=G,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const r=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",r),g(r,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",r),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(r,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=d;class m extends R.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:o.VSBuffer.alloc(0)}constructor(n,r,f,E,T,M){super(),this.k=n,this.l=T,this.m=M,this.a=this.B(new k.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new k.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,r?(this.b=this.B(new h(this.k,E,f,{windowBits:15})),this.f=this.B(new w(this.k,{windowBits:15})),this.B(this.b.onError(G=>this.a.fire(G))),this.B(this.f.onError(G=>this.a.fire(G)))):(this.b=null,this.f=null)}writeMessage(n){this.g.push(n),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const n=this.g.shift();if(this.f){const r=await this.r(this.f,n);this.m(r,!0)}else this.m(n,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(n,r){return new Promise((f,E)=>{n.write(r),n.flush(T=>f(T))})}acceptFrame(n,r,f){this.h.push({data:n,isCompressed:r,isLastFrameOfMessage:f}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const n=this.h.shift();if(this.b&&n.isCompressed){const r=await this.u(this.b,n.data,n.isLastFrameOfMessage);this.l.fire(r)}else this.l.fire(n.data)}this.s=!1}}u(n,r,f){return new Promise((E,T)=>{n.write(r),f&&n.write(o.VSBuffer.fromByteArray([0,0,255,255])),n.flush(M=>E(M))})}}class h extends R.Disposable{get recordedInflateBytes(){return this.j?o.VSBuffer.concat(this.f):o.VSBuffer.alloc(0)}constructor(n,r,f,E){super(),this.h=n,this.j=r,this.a=this.B(new k.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=P().zlib.createInflateRaw(E),this.b.on("error",T=>{this.h.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.h.traceSocketEvent("zlibInflateData",T),this.g.push(o.VSBuffer.wrap(T))}),f&&(this.h.traceSocketEvent("zlibInflateInitialWrite",f.buffer),this.b.write(f.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(n){this.j&&this.f.push(n.clone()),this.h.traceSocketEvent("zlibInflateWrite",n),this.b.write(n.buffer)}flush(n){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const r=o.VSBuffer.concat(this.g);this.g.length=0,n(r)})}}class w extends R.Disposable{constructor(n,r){super(),this.g=n,this.a=this.B(new k.Emitter),this.onError=this.a.event,this.f=[],this.b=P().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",f=>{this.g.traceSocketEvent("zlibDeflateError",{message:f?.message,code:f?.code}),this.a.fire(f)}),this.b.on("data",f=>{this.g.traceSocketEvent("zlibDeflateData",f),this.f.push(o.VSBuffer.wrap(f))})}write(n){this.g.traceSocketEvent("zlibDeflateWrite",n.buffer),this.b.write(n.buffer)}flush(n){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let r=o.VSBuffer.concat(this.f);this.f.length=0,r=r.slice(0,r.byteLength-4),n(r)})}}function g(l,n){if(n===0)return;const r=l.byteLength>>>2;for(let V=0;V<r;V++){const N=l.readUInt32BE(V*4);l.writeUInt32BE(N^n,V*4)}const f=r*4,E=l.byteLength-f,T=n>>>24&255,M=n>>>16&255,G=n>>>8&255;E>=1&&l.writeUInt8(l.readUInt8(f)^T,f),E>=2&&l.writeUInt8(l.readUInt8(f+1)^M,f+1),E>=3&&l.writeUInt8(l.readUInt8(f+2)^G,f+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const p={[2]:107,[1]:103};function b(){const l=(0,S.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let n;return e.XDG_RUNTIME_DIR?n=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):n=(0,I.join)(P().os.tmpdir(),`vscode-ipc-${l}.sock`),s(n),n}e.createRandomIPCHandle=b;function i(l,n,r){const f=P().crypto.createHash("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${f}-${r}-${n}-sock`;let E;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?E=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-${f.substr(0,8)}-${r}-${n}.sock`):E=(0,I.join)(l,`${r}-${n}.sock`),s(E),E}e.createStaticIPCHandle=i;function s(l){const n=p[A.platform];typeof n=="number"&&l.length>=n&&console.warn(`WARNING: IPC handle "${l}" is longer than ${n} chars, try a shorter --user-data-dir`)}class a extends C.IPCServer{static b(n){const r=k.Event.fromNodeEventEmitter(n,"connection");return k.Event.map(r,f=>({protocol:new L.Protocol(new y(f,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(f,"close"))}))}constructor(n){super(a.b(n)),this.d=n}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=a;function u(l){return new Promise((n,r)=>{const f=P().net.createServer();f.on("error",r),f.listen(l,()=>{f.removeListener("error",r),n(new a(f))})})}e.serve=u;function c(l,n){return new Promise((r,f)=>{const E=P().net.createConnection(l,()=>{E.removeListener("error",f),r(L.Client.fromSocket(new y(E,`ipc-client${n}`),n))});E.once("error",f)})}e.connect=c}),define(ye[161],Ce([1,0,37,9]),function(ne,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function k(R,I,A,S,C,L){if(Array.isArray(R)){let P=0;for(const y of R){const D=k(y,I,A,S,C,L);if(D===10)return D;D>P&&(P=D)}return P}else{if(typeof R=="string")return S?R==="*"?5:R===A?10:0:0;if(R){const{language:P,pattern:y,scheme:D,hasAccessToAllModels:v,notebookType:d}=R;if(!S&&!v)return 0;d&&C&&(I=C);let m=0;if(D)if(D===I.scheme)m=10;else if(D==="*")m=5;else return 0;if(P)if(P===A)m=10;else if(P==="*")m=Math.max(m,5);else return 0;if(d)if(d===L)m=10;else if(d==="*"&&L!==void 0)m=Math.max(m,5);else return 0;if(y){let h;if(typeof y=="string"?h=y:h={...y,base:(0,t.normalize)(y.base)},h===I.fsPath||(0,o.match)(h,I.fsPath))m=10;else return 0}return m}else return 0}}e.score=k}),define(ye[162],Ce([1,0,8,50,154]),function(ne,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class R{constructor(A,S,C,L){this.c=A,this.d=S,this.f=C,this.g=L,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return this.j===null&&(this.j=this.d.join(this.f)),this.j}onEvents(A){A.eol&&A.eol!==this.f&&(this.f=A.eol,this.h=null);const S=A.changes;for(const C of S)this.n(C.range),this.o(new t.Position(C.range.startLineNumber,C.range.startColumn),C.text);this.g=A.versionId,this.j=null}k(){if(!this.h){const A=this.f.length,S=this.d.length,C=new Uint32Array(S);for(let L=0;L<S;L++)C[L]=this.d[L].length+A;this.h=new k.PrefixSumComputer(C)}}l(A,S){this.d[A]=S,this.h&&this.h.setValue(A,this.d[A].length+this.f.length)}n(A){if(A.startLineNumber===A.endLineNumber){if(A.startColumn===A.endColumn)return;this.l(A.startLineNumber-1,this.d[A.startLineNumber-1].substring(0,A.startColumn-1)+this.d[A.startLineNumber-1].substring(A.endColumn-1));return}this.l(A.startLineNumber-1,this.d[A.startLineNumber-1].substring(0,A.startColumn-1)+this.d[A.endLineNumber-1].substring(A.endColumn-1)),this.d.splice(A.startLineNumber,A.endLineNumber-A.startLineNumber),this.h&&this.h.removeValues(A.startLineNumber,A.endLineNumber-A.startLineNumber)}o(A,S){if(S.length===0)return;const C=(0,o.splitLines)(S);if(C.length===1){this.l(A.lineNumber-1,this.d[A.lineNumber-1].substring(0,A.column-1)+C[0]+this.d[A.lineNumber-1].substring(A.column-1));return}C[C.length-1]+=this.d[A.lineNumber-1].substring(A.column-1),this.l(A.lineNumber-1,this.d[A.lineNumber-1].substring(0,A.column-1)+C[0]);const L=new Uint32Array(C.length-1);for(let P=1;P<C.length;P++)this.d.splice(A.lineNumber+P-1,0,C[P]),L[P-1]=C[P].length+this.f.length;this.h&&this.h.insertValues(A.lineNumber,L)}}e.MirrorTextModel=R}),define(ye[163],Ce([1,0,8,151,50,35,106]),function(ne,e,o,t,k,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const A=999;class S{constructor(w,g,p,b){this.searchString=w,this.isRegex=g,this.matchCase=p,this.wordSeparators=b}parseSearchRequest(){if(this.searchString==="")return null;let w;this.isRegex?w=C(this.searchString):w=this.searchString.indexOf(`
`)>=0;let g=null;try{g=o.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:w,global:!0,unicode:!0})}catch{return null}if(!g)return null;let p=!this.isRegex&&!w;return p&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(p=this.matchCase),new I.SearchData(g,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,p?this.searchString:null)}}e.SearchParams=S;function C(h){if(!h||h.length===0)return!1;for(let w=0,g=h.length;w<g;w++){const p=h.charCodeAt(w);if(p===10)return!0;if(p===92){if(w++,w>=g)break;const b=h.charCodeAt(w);if(b===110||b===114||b===87)return!0}}return!1}e.isMultilineRegexSource=C;function L(h,w,g){if(!g)return new I.FindMatch(h,null);const p=[];for(let b=0,i=w.length;b<i;b++)p[b]=w[b];return new I.FindMatch(h,p)}e.createFindMatch=L;class P{constructor(w){const g=[];let p=0;for(let b=0,i=w.length;b<i;b++)w.charCodeAt(b)===10&&(g[p++]=b);this.a=g}findLineFeedCountBeforeOffset(w){const g=this.a;let p=0,b=g.length-1;if(b===-1||w<=g[0])return 0;for(;p<b;){const i=p+((b-p)/2>>0);g[i]>=w?b=i-1:g[i+1]>=w?(p=i,b=i):p=i+1}return p+1}}class y{static findMatches(w,g,p,b,i){const s=g.parseSearchRequest();return s?s.regex.multiline?this.b(w,p,new m(s.wordSeparators,s.regex),b,i):this.c(w,p,s,b,i):[]}static a(w,g,p,b,i,s){let a,u=0;b?(u=b.findLineFeedCountBeforeOffset(i),a=g+i+u):a=g+i;let c;if(b){const f=b.findLineFeedCountBeforeOffset(i+s.length)-u;c=a+s.length+f}else c=a+s.length;const l=w.getPositionAt(a),n=w.getPositionAt(c);return new R.Range(l.lineNumber,l.column,n.lineNumber,n.column)}static b(w,g,p,b,i){const s=w.getOffsetAt(g.getStartPosition()),a=w.getValueInRange(g,1),u=w.getEOL()===`\r
`?new P(a):null,c=[];let l=0,n;for(p.reset(0);n=p.next(a);)if(c[l++]=L(this.a(w,s,a,u,n.index,n[0]),n,b),l>=i)return c;return c}static c(w,g,p,b,i){const s=[];let a=0;if(g.startLineNumber===g.endLineNumber){const c=w.getLineContent(g.startLineNumber).substring(g.startColumn-1,g.endColumn-1);return a=this.d(p,c,g.startLineNumber,g.startColumn-1,a,s,b,i),s}const u=w.getLineContent(g.startLineNumber).substring(g.startColumn-1);a=this.d(p,u,g.startLineNumber,g.startColumn-1,a,s,b,i);for(let c=g.startLineNumber+1;c<g.endLineNumber&&a<i;c++)a=this.d(p,w.getLineContent(c),c,0,a,s,b,i);if(a<i){const c=w.getLineContent(g.endLineNumber).substring(0,g.endColumn-1);a=this.d(p,c,g.endLineNumber,0,a,s,b,i)}return s}static d(w,g,p,b,i,s,a,u){const c=w.wordSeparators;if(!a&&w.simpleSearch){const r=w.simpleSearch,f=r.length,E=g.length;let T=-f;for(;(T=g.indexOf(r,T+f))!==-1;)if((!c||d(c,g,E,T,f))&&(s[i++]=new I.FindMatch(new R.Range(p,T+1+b,p,T+1+f+b),null),i>=u))return i;return i}const l=new m(w.wordSeparators,w.regex);let n;l.reset(0);do if(n=l.next(g),n&&(s[i++]=L(new R.Range(p,n.index+1+b,p,n.index+1+n[0].length+b),n,a),i>=u))return i;while(n);return i}static findNextMatch(w,g,p,b){const i=g.parseSearchRequest();if(!i)return null;const s=new m(i.wordSeparators,i.regex);return i.regex.multiline?this.e(w,p,s,b):this.f(w,p,s,b)}static e(w,g,p,b){const i=new k.Position(g.lineNumber,1),s=w.getOffsetAt(i),a=w.getLineCount(),u=w.getValueInRange(new R.Range(i.lineNumber,i.column,a,w.getLineMaxColumn(a)),1),c=w.getEOL()===`\r
`?new P(u):null;p.reset(g.column-1);const l=p.next(u);return l?L(this.a(w,s,u,c,l.index,l[0]),l,b):g.lineNumber!==1||g.column!==1?this.e(w,new k.Position(1,1),p,b):null}static f(w,g,p,b){const i=w.getLineCount(),s=g.lineNumber,a=w.getLineContent(s),u=this.g(p,a,s,g.column,b);if(u)return u;for(let c=1;c<=i;c++){const l=(s+c-1)%i,n=w.getLineContent(l+1),r=this.g(p,n,l+1,1,b);if(r)return r}return null}static g(w,g,p,b,i){w.reset(b-1);const s=w.next(g);return s?L(new R.Range(p,s.index+1,p,s.index+1+s[0].length),s,i):null}static findPreviousMatch(w,g,p,b){const i=g.parseSearchRequest();if(!i)return null;const s=new m(i.wordSeparators,i.regex);return i.regex.multiline?this.h(w,p,s,b):this.j(w,p,s,b)}static h(w,g,p,b){const i=this.b(w,new R.Range(1,1,g.lineNumber,g.column),p,b,10*A);if(i.length>0)return i[i.length-1];const s=w.getLineCount();return g.lineNumber!==s||g.column!==w.getLineMaxColumn(s)?this.h(w,new k.Position(s,w.getLineMaxColumn(s)),p,b):null}static j(w,g,p,b){const i=w.getLineCount(),s=g.lineNumber,a=w.getLineContent(s).substring(0,g.column-1),u=this.k(p,a,s,b);if(u)return u;for(let c=1;c<=i;c++){const l=(i+s-c-1)%i,n=w.getLineContent(l+1),r=this.k(p,n,l+1,b);if(r)return r}return null}static k(w,g,p,b){let i=null,s;for(w.reset(0);s=w.next(g);)i=L(new R.Range(p,s.index+1,p,s.index+1+s[0].length),s,b);return i}}e.TextModelSearch=y;function D(h,w,g,p,b){if(p===0)return!0;const i=w.charCodeAt(p-1);if(h.get(i)!==0||i===13||i===10)return!0;if(b>0){const s=w.charCodeAt(p);if(h.get(s)!==0)return!0}return!1}function v(h,w,g,p,b){if(p+b===g)return!0;const i=w.charCodeAt(p+b);if(h.get(i)!==0||i===13||i===10)return!0;if(b>0){const s=w.charCodeAt(p+b-1);if(h.get(s)!==0)return!0}return!1}function d(h,w,g,p,b){return D(h,w,g,p,b)&&v(h,w,g,p,b)}e.isValidMatch=d;class m{constructor(w,g){this._wordSeparators=w,this.a=g,this.b=-1,this.c=0}reset(w){this.a.lastIndex=w,this.b=-1,this.c=0}next(w){const g=w.length;let p;do{if(this.b+this.c===g||(p=this.a.exec(w),!p))return null;const b=p.index,i=p[0].length;if(b===this.b&&i===this.c){if(i===0){o.getNextCodePoint(w,g,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=b,this.c=i,!this._wordSeparators||d(this._wordSeparators,w,g,b,i))return p}while(p);return null}}e.Searcher=m}),define(ye[119],Ce([1,0,22,12]),function(ne,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var k;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(k||(k={}));function R(P){for(let y=0,D=P.length;y<D;y+=4){const v=P[y+0],d=P[y+1],m=P[y+2],h=P[y+3];P[y+0]=h,P[y+1]=m,P[y+2]=d,P[y+3]=v}}function I(P){const y=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return t.isLittleEndian()||R(y),o.VSBuffer.wrap(y)}function A(P){const y=P.buffer;if(t.isLittleEndian()||R(y),y.byteOffset%4===0)return new Uint32Array(y.buffer,y.byteOffset,y.length/4);{const D=new Uint8Array(y.byteLength);return D.set(y),new Uint32Array(D.buffer,D.byteOffset,D.length/4)}}function S(P){const y=new Uint32Array(C(P));let D=0;if(y[D++]=P.id,P.type==="full")y[D++]=1,y[D++]=P.data.length,y.set(P.data,D),D+=P.data.length;else{y[D++]=2,y[D++]=P.deltas.length;for(const v of P.deltas)y[D++]=v.start,y[D++]=v.deleteCount,v.data?(y[D++]=v.data.length,y.set(v.data,D),D+=v.data.length):y[D++]=0}return I(y)}e.encodeSemanticTokensDto=S;function C(P){let y=0;if(y+=1+1,P.type==="full")y+=1+P.data.length;else{y+=1,y+=(1+1+1)*P.deltas.length;for(const D of P.deltas)D.data&&(y+=D.data.length)}return y}function L(P){const y=A(P);let D=0;const v=y[D++];if(y[D++]===1){const w=y[D++],g=y.subarray(D,D+w);return D+=w,{id:v,type:"full",data:g}}const m=y[D++],h=[];for(let w=0;w<m;w++){const g=y[D++],p=y[D++],b=y[D++];let i;b>0&&(i=y.subarray(D,D+b),D+=b),h[w]={start:g,deleteCount:p,data:i}}return{id:v,type:"delta",deltas:h}}e.decodeSemanticTokensDto=L}),define(ye[164],Ce([1,0,4,6]),function(ne,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class k{constructor(){this.a=new Map,this.b=new Map,this.c=new o.Emitter,this.onDidChange=this.c.event,this.d=null}fire(A){this.c.fire({changedLanguages:A,changedColorMap:!1})}register(A,S){return this.a.set(A,S),this.fire([A]),(0,t.toDisposable)(()=>{this.a.get(A)===S&&(this.a.delete(A),this.fire([A]))})}registerFactory(A,S){this.b.get(A)?.dispose();const C=new R(this,A,S);return this.b.set(A,C),(0,t.toDisposable)(()=>{const L=this.b.get(A);!L||L!==C||(this.b.delete(A),L.dispose())})}async getOrCreate(A){const S=this.get(A);if(S)return S;const C=this.b.get(A);return!C||C.isResolved?null:(await C.resolve(),this.get(A))}get(A){return this.a.get(A)||null}isResolved(A){if(this.get(A))return!0;const C=this.b.get(A);return!!(!C||C.isResolved)}setColorMap(A){this.d=A,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=k;class R extends t.Disposable{get isResolved(){return this.c}constructor(A,S,C){super(),this.f=A,this.g=S,this.h=C,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const A=await Promise.resolve(this.h.createTokenizationSupport());this.c=!0,A&&!this.a&&this.B(this.f.register(this.g,A))}}}),define(ye[66],Ce([1,0,80,2,35,164]),function(ne,e,o,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class I{constructor(f,E,T){this._tokenBrand=void 0,this.offset=f,this.type=E,this.language=T}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=I;class A{constructor(f,E){this._tokenizationResultBrand=void 0,this.tokens=f,this.endState=E}}e.TokenizationResult=A;class S{constructor(f,E){this._encodedTokenizationResultBrand=void 0,this.tokens=f,this.endState=E}}e.EncodedTokenizationResult=S;var C;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(C=e.CompletionItemKind||(e.CompletionItemKind={}));var L;(function(r){const f=new Map;f.set(0,o.Codicon.symbolMethod),f.set(1,o.Codicon.symbolFunction),f.set(2,o.Codicon.symbolConstructor),f.set(3,o.Codicon.symbolField),f.set(4,o.Codicon.symbolVariable),f.set(5,o.Codicon.symbolClass),f.set(6,o.Codicon.symbolStruct),f.set(7,o.Codicon.symbolInterface),f.set(8,o.Codicon.symbolModule),f.set(9,o.Codicon.symbolProperty),f.set(10,o.Codicon.symbolEvent),f.set(11,o.Codicon.symbolOperator),f.set(12,o.Codicon.symbolUnit),f.set(13,o.Codicon.symbolValue),f.set(15,o.Codicon.symbolEnum),f.set(14,o.Codicon.symbolConstant),f.set(15,o.Codicon.symbolEnum),f.set(16,o.Codicon.symbolEnumMember),f.set(17,o.Codicon.symbolKeyword),f.set(27,o.Codicon.symbolSnippet),f.set(18,o.Codicon.symbolText),f.set(19,o.Codicon.symbolColor),f.set(20,o.Codicon.symbolFile),f.set(21,o.Codicon.symbolReference),f.set(22,o.Codicon.symbolCustomColor),f.set(23,o.Codicon.symbolFolder),f.set(24,o.Codicon.symbolTypeParameter),f.set(25,o.Codicon.account),f.set(26,o.Codicon.issues);function E(G){let V=f.get(G);return V||(console.info("No codicon found for CompletionItemKind "+G),V=o.Codicon.symbolProperty),V}r.toIcon=E;const T=new Map;T.set("method",0),T.set("function",1),T.set("constructor",2),T.set("field",3),T.set("variable",4),T.set("class",5),T.set("struct",6),T.set("interface",7),T.set("module",8),T.set("property",9),T.set("event",10),T.set("operator",11),T.set("unit",12),T.set("value",13),T.set("constant",14),T.set("enum",15),T.set("enum-member",16),T.set("enumMember",16),T.set("keyword",17),T.set("snippet",27),T.set("text",18),T.set("color",19),T.set("file",20),T.set("reference",21),T.set("customcolor",22),T.set("folder",23),T.set("type-parameter",24),T.set("typeParameter",24),T.set("account",25),T.set("issue",26);function M(G,V){let N=T.get(G);return typeof N>"u"&&!V&&(N=9),N}r.fromString=M})(L=e.CompletionItemKinds||(e.CompletionItemKinds={}));var P;(function(r){r[r.Deprecated=1]="Deprecated"})(P=e.CompletionItemTag||(e.CompletionItemTag={}));var y;(function(r){r[r.None=0]="None",r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(y=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var D;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(D=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var v;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(v=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var d;(function(r){r[r.Invoke=1]="Invoke",r[r.Auto=2]="Auto"})(d=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var m;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(m=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var h;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(h=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function w(r){return r&&t.URI.isUri(r.uri)&&k.Range.isIRange(r.range)&&(k.Range.isIRange(r.originSelectionRange)||k.Range.isIRange(r.targetSelectionRange))}e.isLocationLink=w;var g;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})(g=e.SymbolKind||(e.SymbolKind={}));var p;(function(r){r[r.Deprecated=1]="Deprecated"})(p=e.SymbolTag||(e.SymbolTag={}));var b;(function(r){const f=new Map;f.set(0,o.Codicon.symbolFile),f.set(1,o.Codicon.symbolModule),f.set(2,o.Codicon.symbolNamespace),f.set(3,o.Codicon.symbolPackage),f.set(4,o.Codicon.symbolClass),f.set(5,o.Codicon.symbolMethod),f.set(6,o.Codicon.symbolProperty),f.set(7,o.Codicon.symbolField),f.set(8,o.Codicon.symbolConstructor),f.set(9,o.Codicon.symbolEnum),f.set(10,o.Codicon.symbolInterface),f.set(11,o.Codicon.symbolFunction),f.set(12,o.Codicon.symbolVariable),f.set(13,o.Codicon.symbolConstant),f.set(14,o.Codicon.symbolString),f.set(15,o.Codicon.symbolNumber),f.set(16,o.Codicon.symbolBoolean),f.set(17,o.Codicon.symbolArray),f.set(18,o.Codicon.symbolObject),f.set(19,o.Codicon.symbolKey),f.set(20,o.Codicon.symbolNull),f.set(21,o.Codicon.symbolEnumMember),f.set(22,o.Codicon.symbolStruct),f.set(23,o.Codicon.symbolEvent),f.set(24,o.Codicon.symbolOperator),f.set(25,o.Codicon.symbolTypeParameter);function E(T){let M=f.get(T);return M||(console.info("No codicon found for SymbolKind "+T),M=o.Codicon.symbolProperty),M}r.toIcon=E})(b=e.SymbolKinds||(e.SymbolKinds={}));class i{constructor(f){this.value=f}}e.FoldingRangeKind=i,i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region");var s;(function(r){function f(E){return!E||typeof E!="object"?!1:typeof E.id=="string"&&typeof E.title=="string"}r.is=f})(s=e.Command||(e.Command={}));var a;(function(r){r[r.Collapsed=0]="Collapsed",r[r.Expanded=1]="Expanded"})(a=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var u;(function(r){r[r.Unresolved=0]="Unresolved",r[r.Resolved=1]="Resolved"})(u=e.CommentThreadState||(e.CommentThreadState={}));var c;(function(r){r[r.Editing=0]="Editing",r[r.Preview=1]="Preview"})(c=e.CommentMode||(e.CommentMode={}));var l;(function(r){r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(l=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new R.TokenizationRegistry;var n;(function(r){r[r.None=0]="None",r[r.Option=1]="Option",r[r.Default=2]="Default",r[r.Preferred=3]="Preferred"})(n=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ye[165],Ce([19,20]),function(ne,e){return ne.create("vs/editor/common/config/editorOptions",e)}),define(ye[120],Ce([1,0,165,12,105,18,23,150]),function(ne,e,o,t,k,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(oe){oe[oe.None=0]="None",oe[oe.Keep=1]="Keep",oe[oe.Brackets=2]="Brackets",oe[oe.Advanced=3]="Advanced",oe[oe.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class C{constructor($){this.c=$}hasChanged($){return this.c[$]}}e.ConfigurationChangedEvent=C;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class P{constructor($,ce,Ie,Le){this.id=$,this.name=ce,this.defaultValue=Ie,this.schema=Le}applyUpdate($,ce){return D($,ce)}compute($,ce,Ie){return Ie}}class y{constructor($,ce){this.newValue=$,this.didChange=ce}}e.ApplyUpdateResult=y;function D(oe,$){if(typeof oe!="object"||typeof $!="object"||!oe||!$)return new y($,oe!==$);if(Array.isArray(oe)||Array.isArray($)){const Ie=Array.isArray(oe)&&Array.isArray($)&&R.equals(oe,$);return new y($,!Ie)}let ce=!1;for(const Ie in $)if($.hasOwnProperty(Ie)){const Le=D(oe[Ie],$[Ie]);Le.didChange&&(oe[Ie]=Le.newValue,ce=!0)}return new y(oe,ce)}class v{constructor($){this.schema=void 0,this.id=$,this.name="_never_",this.defaultValue=void 0}applyUpdate($,ce){return D($,ce)}validate($){return this.defaultValue}}class d{constructor($,ce,Ie,Le){this.id=$,this.name=ce,this.defaultValue=Ie,this.schema=Le}applyUpdate($,ce){return D($,ce)}validate($){return typeof $>"u"?this.defaultValue:$}compute($,ce,Ie){return Ie}}function m(oe,$){return typeof oe>"u"?$:oe==="false"?!1:Boolean(oe)}e.boolean=m;class h extends d{constructor($,ce,Ie,Le=void 0){typeof Le<"u"&&(Le.type="boolean",Le.default=Ie),super($,ce,Ie,Le)}validate($){return m($,this.defaultValue)}}function w(oe,$,ce,Ie){if(typeof oe>"u")return $;let Le=parseInt(oe,10);return isNaN(Le)?$:(Le=Math.max(ce,Le),Le=Math.min(Ie,Le),Le|0)}e.clampedInt=w;class g extends d{static clampedInt($,ce,Ie,Le){return w($,ce,Ie,Le)}constructor($,ce,Ie,Le,Be,xe=void 0){typeof xe<"u"&&(xe.type="integer",xe.default=Ie,xe.minimum=Le,xe.maximum=Be),super($,ce,Ie,xe),this.minimum=Le,this.maximum=Be}validate($){return g.clampedInt($,this.defaultValue,this.minimum,this.maximum)}}class p extends d{static clamp($,ce,Ie){return $<ce?ce:$>Ie?Ie:$}static float($,ce){if(typeof $=="number")return $;if(typeof $>"u")return ce;const Ie=parseFloat($);return isNaN(Ie)?ce:Ie}constructor($,ce,Ie,Le,Be){typeof Be<"u"&&(Be.type="number",Be.default=Ie),super($,ce,Ie,Be),this.validationFn=Le}validate($){return this.validationFn(p.float($,this.defaultValue))}}class b extends d{static string($,ce){return typeof $!="string"?ce:$}constructor($,ce,Ie,Le=void 0){typeof Le<"u"&&(Le.type="string",Le.default=Ie),super($,ce,Ie,Le)}validate($){return b.string($,this.defaultValue)}}function i(oe,$,ce){return typeof oe!="string"||ce.indexOf(oe)===-1?$:oe}e.stringSet=i;class s extends d{constructor($,ce,Ie,Le,Be=void 0){typeof Be<"u"&&(Be.type="string",Be.enum=Le,Be.default=Ie),super($,ce,Ie,Be),this.c=Le}validate($){return i($,this.defaultValue,this.c)}}class a extends P{constructor($,ce,Ie,Le,Be,xe,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=Be,Ze.default=Le),super($,ce,Ie,Ze),this.c=Be,this.d=xe}validate($){return typeof $!="string"?this.defaultValue:this.c.indexOf($)===-1?this.defaultValue:this.d($)}}function u(oe){switch(oe){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class c extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[o.localize(0,null),o.localize(1,null),o.localize(2,null)],default:"auto",tags:["accessibility"],description:o.localize(3,null)})}validate($){switch($){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute($,ce,Ie){return Ie===0?$.accessibilitySupport:Ie}}class l extends P{constructor(){const $={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",$,{"editor.comments.insertSpace":{type:"boolean",default:$.insertSpace,description:o.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:$.ignoreEmptyLines,description:o.localize(5,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{insertSpace:m(ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:m(ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(oe){oe[oe.Hidden=0]="Hidden",oe[oe.Blink=1]="Blink",oe[oe.Smooth=2]="Smooth",oe[oe.Phase=3]="Phase",oe[oe.Expand=4]="Expand",oe[oe.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function r(oe){switch(oe){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var f;(function(oe){oe[oe.Line=1]="Line",oe[oe.Block=2]="Block",oe[oe.Underline=3]="Underline",oe[oe.LineThin=4]="LineThin",oe[oe.BlockOutline=5]="BlockOutline",oe[oe.UnderlineThin=6]="UnderlineThin"})(f=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function E(oe){switch(oe){case f.Line:return"line";case f.Block:return"block";case f.Underline:return"underline";case f.LineThin:return"line-thin";case f.BlockOutline:return"block-outline";case f.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=E;function T(oe){switch(oe){case"line":return f.Line;case"block":return f.Block;case"underline":return f.Underline;case"line-thin":return f.LineThin;case"block-outline":return f.BlockOutline;case"underline-thin":return f.UnderlineThin}}class M extends v{constructor(){super(135)}compute($,ce,Ie){const Le=["monaco-editor"];return ce.get(36)&&Le.push(ce.get(36)),$.extraEditorClassName&&Le.push($.extraEditorClassName),ce.get(70)==="default"?Le.push("mouse-default"):ce.get(70)==="copy"&&Le.push("mouse-copy"),ce.get(105)&&Le.push("showUnused"),ce.get(133)&&Le.push("showDeprecated"),Le.join(" ")}}class G extends h{constructor(){super(34,"emptySelectionClipboard",!0,{description:o.localize(6,null)})}compute($,ce,Ie){return Ie&&$.emptySelectionClipboard}}class V extends P{constructor(){const $={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",$,{"editor.find.cursorMoveOnType":{type:"boolean",default:$.cursorMoveOnType,description:o.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:$.seedSearchStringFromSelection,enumDescriptions:[o.localize(8,null),o.localize(9,null),o.localize(10,null)],description:o.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:$.autoFindInSelection,enumDescriptions:[o.localize(12,null),o.localize(13,null),o.localize(14,null)],description:o.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:$.globalFindClipboard,description:o.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:$.addExtraSpaceOnTop,description:o.localize(17,null)},"editor.find.loop":{type:"boolean",default:$.loop,description:o.localize(18,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{cursorMoveOnType:m(ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof $.seedSearchStringFromSelection=="boolean"?$.seedSearchStringFromSelection?"always":"never":i(ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof $.autoFindInSelection=="boolean"?$.autoFindInSelection?"always":"never":i(ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:m(ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:m(ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:m(ce.loop,this.defaultValue.loop)}}}class N extends P{constructor(){super(48,"fontLigatures",N.OFF,{anyOf:[{type:"boolean",description:o.localize(19,null)},{type:"string",description:o.localize(20,null)}],description:o.localize(21,null),default:!1})}validate($){return typeof $>"u"?this.defaultValue:typeof $=="string"?$==="false"?N.OFF:$==="true"?N.ON:$:Boolean($)?N.ON:N.OFF}}e.EditorFontLigatures=N,N.OFF='"liga" off, "calt" off',N.ON='"liga" on, "calt" on';class U extends P{constructor(){super(51,"fontVariations",U.OFF,{anyOf:[{type:"boolean",description:o.localize(22,null)},{type:"string",description:o.localize(23,null)}],description:o.localize(24,null),default:!1})}validate($){return typeof $>"u"?this.defaultValue:typeof $=="string"?$==="false"?U.OFF:$==="true"?U.TRANSLATE:$:Boolean($)?U.TRANSLATE:U.OFF}compute($,ce,Ie){return $.fontInfo.fontVariationSettings}}e.EditorFontVariations=U,U.OFF="normal",U.TRANSLATE="translate";class F extends v{constructor(){super(47)}compute($,ce,Ie){return $.fontInfo}}class z extends d{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:o.localize(25,null)})}validate($){const ce=p.float($,this.defaultValue);return ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:p.clamp(ce,6,100)}compute($,ce,Ie){return $.fontInfo.fontSize}}class B extends P{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:B.d,maximum:B.e,errorMessage:o.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:B.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:o.localize(27,null)})}validate($){return $==="normal"||$==="bold"?$:String(g.clampedInt($,e.EDITOR_FONT_DEFAULTS.fontWeight,B.d,B.e))}}B.c=["normal","bold","100","200","300","400","500","600","700","800","900"],B.d=1,B.e=1e3;class W extends P{constructor(){const $={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:$.multiple,enumDescriptions:[o.localize(28,null),o.localize(29,null),o.localize(30,null)]},Ie=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",$,{"editor.gotoLocation.multiple":{deprecationMessage:o.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:o.localize(32,null),...ce},"editor.gotoLocation.multipleTypeDefinitions":{description:o.localize(33,null),...ce},"editor.gotoLocation.multipleDeclarations":{description:o.localize(34,null),...ce},"editor.gotoLocation.multipleImplementations":{description:o.localize(35,null),...ce},"editor.gotoLocation.multipleReferences":{description:o.localize(36,null),...ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:$.alternativeDefinitionCommand,enum:Ie,description:o.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:$.alternativeTypeDefinitionCommand,enum:Ie,description:o.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:$.alternativeDeclarationCommand,enum:Ie,description:o.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:$.alternativeImplementationCommand,enum:Ie,description:o.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:$.alternativeReferenceCommand,enum:Ie,description:o.localize(41,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{multiple:i(ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ce.multipleDefinitions??i(ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ce.multipleTypeDefinitions??i(ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ce.multipleDeclarations??i(ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ce.multipleImplementations??i(ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ce.multipleReferences??i(ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:b.string(ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:b.string(ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:b.string(ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:b.string(ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:b.string(ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class X extends P{constructor(){const $={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",$,{"editor.hover.enabled":{type:"boolean",default:$.enabled,description:o.localize(42,null)},"editor.hover.delay":{type:"number",default:$.delay,minimum:0,maximum:1e4,description:o.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:$.sticky,description:o.localize(44,null)},"editor.hover.above":{type:"boolean",default:$.above,description:o.localize(45,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{enabled:m(ce.enabled,this.defaultValue.enabled),delay:g.clampedInt(ce.delay,this.defaultValue.delay,0,1e4),sticky:m(ce.sticky,this.defaultValue.sticky),above:m(ce.above,this.defaultValue.above)}}}var q;(function(oe){oe[oe.None=0]="None",oe[oe.Text=1]="Text",oe[oe.Blocks=2]="Blocks"})(q=e.RenderMinimap||(e.RenderMinimap={}));class _ extends v{constructor(){super(138)}compute($,ce,Ie){return _.computeLayout(ce,{memory:$.memory,outerWidth:$.outerWidth,outerHeight:$.outerHeight,isDominatedByLongLines:$.isDominatedByLongLines,lineHeight:$.fontInfo.lineHeight,viewLineCount:$.viewLineCount,lineNumbersDigitCount:$.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:$.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:$.fontInfo.maxDigitWidth,pixelRatio:$.pixelRatio})}static computeContainedMinimapLineCount($){const ce=$.height/$.lineHeight,Ie=Math.floor($.paddingTop/$.lineHeight);let Le=Math.floor($.paddingBottom/$.lineHeight);$.scrollBeyondLastLine&&(Le=Math.max(Le,ce-1));const Be=(Ie+$.viewLineCount+Le)/($.pixelRatio*$.height),xe=Math.floor($.viewLineCount/Be);return{typicalViewportLineCount:ce,extraLinesBeforeFirstLine:Ie,extraLinesBeyondLastLine:Le,desiredRatio:Be,minimapLineCount:xe}}static c($,ce){const Ie=$.outerWidth,Le=$.outerHeight,Be=$.pixelRatio;if(!$.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Be*Le),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Le};const xe=ce.stableMinimapLayoutInput,Ze=xe&&$.outerHeight===xe.outerHeight&&$.lineHeight===xe.lineHeight&&$.typicalHalfwidthCharacterWidth===xe.typicalHalfwidthCharacterWidth&&$.pixelRatio===xe.pixelRatio&&$.scrollBeyondLastLine===xe.scrollBeyondLastLine&&$.paddingTop===xe.paddingTop&&$.paddingBottom===xe.paddingBottom&&$.minimap.enabled===xe.minimap.enabled&&$.minimap.side===xe.minimap.side&&$.minimap.size===xe.minimap.size&&$.minimap.showSlider===xe.minimap.showSlider&&$.minimap.renderCharacters===xe.minimap.renderCharacters&&$.minimap.maxColumn===xe.minimap.maxColumn&&$.minimap.scale===xe.minimap.scale&&$.verticalScrollbarWidth===xe.verticalScrollbarWidth&&$.isViewportWrapping===xe.isViewportWrapping,gt=$.lineHeight,mt=$.typicalHalfwidthCharacterWidth,lt=$.scrollBeyondLastLine,ot=$.minimap.renderCharacters;let rt=Be>=2?Math.round($.minimap.scale*2):$.minimap.scale;const kt=$.minimap.maxColumn,Tt=$.minimap.size,Nt=$.minimap.side,pt=$.verticalScrollbarWidth,Dt=$.viewLineCount,zt=$.remainingWidth,Ft=$.isViewportWrapping,Xe=ot?2:3;let Mt=Math.floor(Be*Le);const Ut=Mt/Be;let Bt=!1,bt=!1,Pt=Xe*rt,Re=rt/Be,Oe=1;if(Tt==="fill"||Tt==="fit"){const{typicalViewportLineCount:tt,extraLinesBeforeFirstLine:St,extraLinesBeyondLastLine:Et,desiredRatio:Lt,minimapLineCount:vt}=_.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:lt,paddingTop:$.paddingTop,paddingBottom:$.paddingBottom,height:Le,lineHeight:gt,pixelRatio:Be});if(Dt/vt>1)Bt=!0,bt=!0,rt=1,Pt=1,Re=rt/Be;else{let ft=!1,xt=rt+1;if(Tt==="fit"){const jt=Math.ceil((St+Dt+Et)*Pt);Ft&&Ze&&zt<=ce.stableFitRemainingWidth?(ft=!0,xt=ce.stableFitMaxMinimapScale):ft=jt>Mt}if(Tt==="fill"||ft){Bt=!0;const jt=rt;Pt=Math.min(gt*Be,Math.max(1,Math.floor(1/Lt))),Ft&&Ze&&zt<=ce.stableFitRemainingWidth&&(xt=ce.stableFitMaxMinimapScale),rt=Math.min(xt,Math.max(1,Math.floor(Pt/Xe))),rt>jt&&(Oe=Math.min(2,rt/jt)),Re=rt/Be/Oe,Mt=Math.ceil(Math.max(tt,St+Dt+Et)*Pt),Ft?(ce.stableMinimapLayoutInput=$,ce.stableFitRemainingWidth=zt,ce.stableFitMaxMinimapScale=rt):(ce.stableMinimapLayoutInput=null,ce.stableFitRemainingWidth=0)}}}const Se=Math.floor(kt*Re),re=Math.min(Se,Math.max(0,Math.floor((zt-pt-2)*Re/(mt+Re)))+e.MINIMAP_GUTTER_WIDTH);let Ne=Math.floor(Be*re);const $e=Ne/Be;Ne=Math.floor(Ne*Oe);const Qe=ot?1:2,Ve=Nt==="left"?0:Ie-re-pt;return{renderMinimap:Qe,minimapLeft:Ve,minimapWidth:re,minimapHeightIsEditorHeight:Bt,minimapIsSampling:bt,minimapScale:rt,minimapLineHeight:Pt,minimapCanvasInnerWidth:Ne,minimapCanvasInnerHeight:Mt,minimapCanvasOuterWidth:$e,minimapCanvasOuterHeight:Ut}}static computeLayout($,ce){const Ie=ce.outerWidth|0,Le=ce.outerHeight|0,Be=ce.lineHeight|0,xe=ce.lineNumbersDigitCount|0,Ze=ce.typicalHalfwidthCharacterWidth,gt=ce.maxDigitWidth,mt=ce.pixelRatio,lt=ce.viewLineCount,ot=$.get(130),rt=ot==="inherit"?$.get(129):ot,kt=rt==="inherit"?$.get(125):rt,Tt=$.get(128),Nt=ce.isDominatedByLongLines,pt=$.get(54),Dt=$.get(64).renderType!==0,zt=$.get(65),Ft=$.get(99),Xe=$.get(80),Mt=$.get(69),Ut=$.get(97),Bt=Ut.verticalScrollbarSize,bt=Ut.verticalHasArrows,Pt=Ut.arrowSize,Re=Ut.horizontalScrollbarSize,Oe=$.get(40),Se=$.get(104)!=="never";let re=$.get(62);Oe&&Se&&(re+=16);let Ne=0;if(Dt){const _t=Math.max(xe,zt);Ne=Math.round(_t*gt)}let $e=0;pt&&($e=Be);let Qe=0,Ve=Qe+$e,tt=Ve+Ne,St=tt+re;const Et=Ie-$e-Ne-re;let Lt=!1,vt=!1,It=-1;rt==="inherit"&&Nt?(Lt=!0,vt=!0):kt==="on"||kt==="bounded"?vt=!0:kt==="wordWrapColumn"&&(It=Tt);const ft=_.c({outerWidth:Ie,outerHeight:Le,lineHeight:Be,typicalHalfwidthCharacterWidth:Ze,pixelRatio:mt,scrollBeyondLastLine:Ft,paddingTop:Xe.top,paddingBottom:Xe.bottom,minimap:Mt,verticalScrollbarWidth:Bt,viewLineCount:lt,remainingWidth:Et,isViewportWrapping:vt},ce.memory||new L);ft.renderMinimap!==0&&ft.minimapLeft===0&&(Qe+=ft.minimapWidth,Ve+=ft.minimapWidth,tt+=ft.minimapWidth,St+=ft.minimapWidth);const xt=Et-ft.minimapWidth,jt=Math.max(1,Math.floor((xt-Bt-2)/Ze)),yt=bt?Pt:0;return vt&&(It=Math.max(1,jt),kt==="bounded"&&(It=Math.min(It,Tt))),{width:Ie,height:Le,glyphMarginLeft:Qe,glyphMarginWidth:$e,lineNumbersLeft:Ve,lineNumbersWidth:Ne,decorationsLeft:tt,decorationsWidth:re,contentLeft:St,contentWidth:xt,minimap:ft,viewportColumn:jt,isWordWrapMinified:Lt,isViewportWrapping:vt,wrappingColumn:It,verticalScrollbarWidth:Bt,horizontalScrollbarHeight:Re,overviewRuler:{top:yt,width:Bt,height:Le-2*yt,right:0}}}}e.EditorLayoutInfoComputer=_;class Q extends P{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[o.localize(46,null),o.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:o.localize(48,null)}})}validate($){return i($,"simple",["simple","advanced"])}compute($,ce,Ie){return ce.get(2)===2?"advanced":Ie}}class Z extends P{constructor(){const $={enabled:!0};super(61,"lightbulb",$,{"editor.lightbulb.enabled":{type:"boolean",default:$.enabled,description:o.localize(49,null)}})}validate($){return!$||typeof $!="object"?this.defaultValue:{enabled:m($.enabled,this.defaultValue.enabled)}}}class ge extends P{constructor(){const $={enabled:!1,maxLineCount:5};super(109,"stickyScroll",$,{"editor.stickyScroll.enabled":{type:"boolean",default:$.enabled,description:o.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:$.maxLineCount,minimum:1,maximum:10,description:o.localize(51,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{enabled:m(ce.enabled,this.defaultValue.enabled),maxLineCount:g.clampedInt(ce.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class te extends P{constructor(){const $={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",$,{"editor.inlayHints.enabled":{type:"string",default:$.enabled,description:o.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[o.localize(53,null),o.localize(54,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),o.localize(55,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),o.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:$.fontSize,markdownDescription:o.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:$.fontFamily,markdownDescription:o.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:$.padding,description:o.localize(59,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return typeof ce.enabled=="boolean"&&(ce.enabled=ce.enabled?"on":"off"),{enabled:i(ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:g.clampedInt(ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:b.string(ce.fontFamily,this.defaultValue.fontFamily),padding:m(ce.padding,this.defaultValue.padding)}}}class J extends P{constructor(){super(62,"lineDecorationsWidth",10)}validate($){return typeof $=="string"&&/^\d+(\.\d+)?ch$/.test($)?-parseFloat($.substring(0,$.length-2)):g.clampedInt($,this.defaultValue,0,1e3)}compute($,ce,Ie){return Ie<0?g.clampedInt(-Ie*$.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ie}}class fe extends p{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,$=>p.clamp($,0,150),{markdownDescription:o.localize(60,null)})}compute($,ce,Ie){return $.fontInfo.lineHeight}}class ve extends P{constructor(){const $={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",$,{"editor.minimap.enabled":{type:"boolean",default:$.enabled,description:o.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:$.autohide,description:o.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[o.localize(63,null),o.localize(64,null),o.localize(65,null)],default:$.size,description:o.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:$.side,description:o.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:$.showSlider,description:o.localize(68,null)},"editor.minimap.scale":{type:"number",default:$.scale,minimum:1,maximum:3,enum:[1,2,3],description:o.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:$.renderCharacters,description:o.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:$.maxColumn,description:o.localize(71,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{enabled:m(ce.enabled,this.defaultValue.enabled),autohide:m(ce.autohide,this.defaultValue.autohide),size:i(ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:i(ce.side,this.defaultValue.side,["right","left"]),showSlider:i(ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:m(ce.renderCharacters,this.defaultValue.renderCharacters),scale:g.clampedInt(ce.scale,1,1,3),maxColumn:g.clampedInt(ce.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Ee(oe){return oe==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Ae extends P{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(73,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{top:g.clampedInt(ce.top,0,0,1e3),bottom:g.clampedInt(ce.bottom,0,0,1e3)}}}class Fe extends P{constructor(){const $={enabled:!0,cycle:!1};super(81,"parameterHints",$,{"editor.parameterHints.enabled":{type:"boolean",default:$.enabled,description:o.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:$.cycle,description:o.localize(75,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{enabled:m(ce.enabled,this.defaultValue.enabled),cycle:m(ce.cycle,this.defaultValue.cycle)}}}class se extends v{constructor(){super(136)}compute($,ce,Ie){return $.pixelRatio}}class le extends P{constructor(){const $={other:"on",comments:"off",strings:"off"},ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[o.localize(76,null),o.localize(77,null),o.localize(78,null)]}];super(84,"quickSuggestions",$,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ce,default:$.strings,description:o.localize(79,null)},comments:{anyOf:ce,default:$.comments,description:o.localize(80,null)},other:{anyOf:ce,default:$.other,description:o.localize(81,null)}},default:$,markdownDescription:o.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=$}validate($){if(typeof $=="boolean"){const mt=$?"on":"off";return{comments:mt,strings:mt,other:mt}}if(!$||typeof $!="object")return this.defaultValue;const{other:ce,comments:Ie,strings:Le}=$,Be=["on","inline","off"];let xe,Ze,gt;return typeof ce=="boolean"?xe=ce?"on":"off":xe=i(ce,this.defaultValue.other,Be),typeof Ie=="boolean"?Ze=Ie?"on":"off":Ze=i(Ie,this.defaultValue.comments,Be),typeof Le=="boolean"?gt=Le?"on":"off":gt=i(Le,this.defaultValue.strings,Be),{other:xe,comments:Ze,strings:gt}}}var ue;(function(oe){oe[oe.Off=0]="Off",oe[oe.On=1]="On",oe[oe.Relative=2]="Relative",oe[oe.Interval=3]="Interval",oe[oe.Custom=4]="Custom"})(ue=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ee extends P{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[o.localize(83,null),o.localize(84,null),o.localize(85,null),o.localize(86,null)],default:"on",description:o.localize(87,null)})}validate($){let ce=this.defaultValue.renderType,Ie=this.defaultValue.renderFn;return typeof $<"u"&&(typeof $=="function"?(ce=4,Ie=$):$==="interval"?ce=3:$==="relative"?ce=2:$==="on"?ce=1:ce=0),{renderType:ce,renderFn:Ie}}}function ae(oe){const $=oe.get(92);return $==="editable"?oe.get(86):$!=="on"}e.filterValidationDecorations=ae;class ie extends P{constructor(){const $=[],ce={type:"number",description:o.localize(88,null)};super(96,"rulers",$,{type:"array",items:{anyOf:[ce,{type:["object"],properties:{column:ce,color:{type:"string",description:o.localize(89,null),format:"color-hex"}}}]},default:$,description:o.localize(90,null)})}validate($){if(Array.isArray($)){const ce=[];for(const Ie of $)if(typeof Ie=="number")ce.push({column:g.clampedInt(Ie,0,0,1e4),color:null});else if(Ie&&typeof Ie=="object"){const Le=Ie;ce.push({column:g.clampedInt(Le.column,0,0,1e4),color:Le.color})}return ce.sort((Ie,Le)=>Ie.column-Le.column),ce}return this.defaultValue}}function O(oe,$){if(typeof oe!="string")return $;switch(oe){case"hidden":return 2;case"visible":return 3;default:return 1}}class H extends P{constructor(){const $={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",$,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(91,null),o.localize(92,null),o.localize(93,null)],default:"auto",description:o.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(95,null),o.localize(96,null),o.localize(97,null)],default:"auto",description:o.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:$.verticalScrollbarSize,description:o.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:$.horizontalScrollbarSize,description:o.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:$.scrollByPage,description:o.localize(101,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$,Ie=g.clampedInt(ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Le=g.clampedInt(ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:g.clampedInt(ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:O(ce.vertical,this.defaultValue.vertical),horizontal:O(ce.horizontal,this.defaultValue.horizontal),useShadows:m(ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:m(ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:m(ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:m(ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:m(ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ie,horizontalSliderSize:g.clampedInt(ce.horizontalSliderSize,Ie,0,1e3),verticalScrollbarSize:Le,verticalSliderSize:g.clampedInt(ce.verticalSliderSize,Le,0,1e3),scrollByPage:m(ce.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class x extends P{constructor(){const $={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",$,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:$.nonBasicASCII,description:o.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:$.invisibleCharacters,description:o.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:$.ambiguousCharacters,description:o.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:$.includeComments,description:o.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:$.includeStrings,description:o.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:$.allowedCharacters,description:o.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:$.allowedLocales,description:o.localize(108,null)}})}applyUpdate($,ce){let Ie=!1;ce.allowedCharacters&&$&&(I.equals($.allowedCharacters,ce.allowedCharacters)||($={...$,allowedCharacters:ce.allowedCharacters},Ie=!0)),ce.allowedLocales&&$&&(I.equals($.allowedLocales,ce.allowedLocales)||($={...$,allowedLocales:ce.allowedLocales},Ie=!0));const Le=super.applyUpdate($,ce);return Ie?new y(Le.newValue,!0):Le}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{nonBasicASCII:Pe(ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:m(ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:m(ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Pe(ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Pe(ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c($.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c($.allowedLocales,this.defaultValue.allowedLocales)}}c($,ce){if(typeof $!="object"||!$)return ce;const Ie={};for(const[Le,Be]of Object.entries($))Be===!0&&(Ie[Le]=!0);return Ie}}class Y extends P{constructor(){const $={enabled:!0,mode:"subwordSmart"};super(59,"inlineSuggest",$,{"editor.inlineSuggest.enabled":{type:"boolean",default:$.enabled,description:o.localize(109,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{enabled:m(ce.enabled,this.defaultValue.enabled),mode:i(ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class de extends P{constructor(){const $={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",$,{"editor.bracketPairColorization.enabled":{type:"boolean",default:$.enabled,markdownDescription:o.localize(110,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:$.independentColorPoolPerBracketType,description:o.localize(111,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{enabled:m(ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:m(ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class be extends P{constructor(){const $={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",$,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(112,null),o.localize(113,null),o.localize(114,null)],default:$.bracketPairs,description:o.localize(115,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(116,null),o.localize(117,null),o.localize(118,null)],default:$.bracketPairsHorizontal,description:o.localize(119,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:$.highlightActiveBracketPair,description:o.localize(120,null)},"editor.guides.indentation":{type:"boolean",default:$.indentation,description:o.localize(121,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[o.localize(122,null),o.localize(123,null),o.localize(124,null)],default:$.highlightActiveIndentation,description:o.localize(125,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{bracketPairs:Pe(ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Pe(ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:m(ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:m(ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:Pe(ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Pe(oe,$,ce){const Ie=ce.indexOf(oe);return Ie===-1?$:ce[Ie]}class pe extends P{constructor(){const $={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectQuickSuggestions:!0,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",$,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[o.localize(126,null),o.localize(127,null)],default:$.insertMode,description:o.localize(128,null)},"editor.suggest.filterGraceful":{type:"boolean",default:$.filterGraceful,description:o.localize(129,null)},"editor.suggest.localityBonus":{type:"boolean",default:$.localityBonus,description:o.localize(130,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:$.shareSuggestSelections,markdownDescription:o.localize(131,null)},"editor.suggest.selectQuickSuggestions":{type:"boolean",default:$.selectQuickSuggestions,markdownDescription:o.localize(132,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:$.snippetsPreventQuickSuggestions,description:o.localize(133,null)},"editor.suggest.showIcons":{type:"boolean",default:$.showIcons,description:o.localize(134,null)},"editor.suggest.showStatusBar":{type:"boolean",default:$.showStatusBar,description:o.localize(135,null)},"editor.suggest.preview":{type:"boolean",default:$.preview,description:o.localize(136,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:$.showInlineDetails,description:o.localize(137,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:o.localize(138,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:o.localize(139,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:o.localize(140,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:o.localize(141,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:o.localize(142,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:o.localize(143,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:o.localize(144,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:o.localize(145,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:o.localize(146,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:o.localize(147,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:o.localize(148,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:o.localize(149,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:o.localize(150,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:o.localize(151,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:o.localize(152,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:o.localize(153,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:o.localize(154,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:o.localize(155,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:o.localize(156,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:o.localize(157,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:o.localize(158,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:o.localize(159,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:o.localize(160,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:o.localize(161,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:o.localize(162,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:o.localize(163,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:o.localize(164,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:o.localize(165,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:o.localize(166,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:o.localize(167,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:o.localize(168,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:o.localize(169,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{insertMode:i(ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:m(ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:m(ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:m(ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:m(ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectQuickSuggestions:m(ce.selectQuickSuggestions,this.defaultValue.selectQuickSuggestions),showIcons:m(ce.showIcons,this.defaultValue.showIcons),showStatusBar:m(ce.showStatusBar,this.defaultValue.showStatusBar),preview:m(ce.preview,this.defaultValue.preview),previewMode:i(ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:m(ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:m(ce.showMethods,this.defaultValue.showMethods),showFunctions:m(ce.showFunctions,this.defaultValue.showFunctions),showConstructors:m(ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:m(ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:m(ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:m(ce.showFields,this.defaultValue.showFields),showVariables:m(ce.showVariables,this.defaultValue.showVariables),showClasses:m(ce.showClasses,this.defaultValue.showClasses),showStructs:m(ce.showStructs,this.defaultValue.showStructs),showInterfaces:m(ce.showInterfaces,this.defaultValue.showInterfaces),showModules:m(ce.showModules,this.defaultValue.showModules),showProperties:m(ce.showProperties,this.defaultValue.showProperties),showEvents:m(ce.showEvents,this.defaultValue.showEvents),showOperators:m(ce.showOperators,this.defaultValue.showOperators),showUnits:m(ce.showUnits,this.defaultValue.showUnits),showValues:m(ce.showValues,this.defaultValue.showValues),showConstants:m(ce.showConstants,this.defaultValue.showConstants),showEnums:m(ce.showEnums,this.defaultValue.showEnums),showEnumMembers:m(ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:m(ce.showKeywords,this.defaultValue.showKeywords),showWords:m(ce.showWords,this.defaultValue.showWords),showColors:m(ce.showColors,this.defaultValue.showColors),showFiles:m(ce.showFiles,this.defaultValue.showFiles),showReferences:m(ce.showReferences,this.defaultValue.showReferences),showFolders:m(ce.showFolders,this.defaultValue.showFolders),showTypeParameters:m(ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:m(ce.showSnippets,this.defaultValue.showSnippets),showUsers:m(ce.showUsers,this.defaultValue.showUsers),showIssues:m(ce.showIssues,this.defaultValue.showIssues)}}}class De extends P{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:o.localize(170,null),default:!0,type:"boolean"}})}validate($){return!$||typeof $!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:m($.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ke extends v{constructor(){super(137)}compute($,ce,Ie){return ce.get(86)?!0:$.tabFocusMode}}var je;(function(oe){oe[oe.None=0]="None",oe[oe.Same=1]="Same",oe[oe.Indent=2]="Indent",oe[oe.DeepIndent=3]="DeepIndent"})(je=e.WrappingIndent||(e.WrappingIndent={}));class Ge extends P{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[o.localize(171,null),o.localize(172,null),o.localize(173,null),o.localize(174,null)],description:o.localize(175,null),default:"same"}})}validate($){switch($){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute($,ce,Ie){return ce.get(2)===2?0:Ie}}class et extends v{constructor(){super(139)}compute($,ce,Ie){const Le=ce.get(138);return{isDominatedByLongLines:$.isDominatedByLongLines,isWordWrapMinified:Le.isWordWrapMinified,isViewportWrapping:Le.isViewportWrapping,wrappingColumn:Le.wrappingColumn}}}class _e extends P{constructor(){const $={enabled:!0};super(33,"dropIntoEditor",$,{"editor.dropIntoEditor.enabled":{type:"boolean",default:$.enabled,markdownDescription:o.localize(176,null)}})}validate($){return!$||typeof $!="object"?this.defaultValue:{enabled:m($.enabled,this.defaultValue.enabled)}}}const nt="Consolas, 'Courier New', monospace",st="Menlo, Monaco, 'Courier New', monospace",ht="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?st:t.isLinux?ht:nt,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Me(oe){return e.editorOptionsRegistry[oe.id]=oe,oe}var it;(function(oe){oe[oe.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",oe[oe.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",oe[oe.accessibilitySupport=2]="accessibilitySupport",oe[oe.accessibilityPageSize=3]="accessibilityPageSize",oe[oe.ariaLabel=4]="ariaLabel",oe[oe.autoClosingBrackets=5]="autoClosingBrackets",oe[oe.autoClosingDelete=6]="autoClosingDelete",oe[oe.autoClosingOvertype=7]="autoClosingOvertype",oe[oe.autoClosingQuotes=8]="autoClosingQuotes",oe[oe.autoIndent=9]="autoIndent",oe[oe.automaticLayout=10]="automaticLayout",oe[oe.autoSurround=11]="autoSurround",oe[oe.bracketPairColorization=12]="bracketPairColorization",oe[oe.guides=13]="guides",oe[oe.codeLens=14]="codeLens",oe[oe.codeLensFontFamily=15]="codeLensFontFamily",oe[oe.codeLensFontSize=16]="codeLensFontSize",oe[oe.colorDecorators=17]="colorDecorators",oe[oe.colorDecoratorsLimit=18]="colorDecoratorsLimit",oe[oe.columnSelection=19]="columnSelection",oe[oe.comments=20]="comments",oe[oe.contextmenu=21]="contextmenu",oe[oe.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",oe[oe.cursorBlinking=23]="cursorBlinking",oe[oe.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",oe[oe.cursorStyle=25]="cursorStyle",oe[oe.cursorSurroundingLines=26]="cursorSurroundingLines",oe[oe.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",oe[oe.cursorWidth=28]="cursorWidth",oe[oe.disableLayerHinting=29]="disableLayerHinting",oe[oe.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",oe[oe.domReadOnly=31]="domReadOnly",oe[oe.dragAndDrop=32]="dragAndDrop",oe[oe.dropIntoEditor=33]="dropIntoEditor",oe[oe.emptySelectionClipboard=34]="emptySelectionClipboard",oe[oe.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",oe[oe.extraEditorClassName=36]="extraEditorClassName",oe[oe.fastScrollSensitivity=37]="fastScrollSensitivity",oe[oe.find=38]="find",oe[oe.fixedOverflowWidgets=39]="fixedOverflowWidgets",oe[oe.folding=40]="folding",oe[oe.foldingStrategy=41]="foldingStrategy",oe[oe.foldingHighlight=42]="foldingHighlight",oe[oe.foldingImportsByDefault=43]="foldingImportsByDefault",oe[oe.foldingMaximumRegions=44]="foldingMaximumRegions",oe[oe.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",oe[oe.fontFamily=46]="fontFamily",oe[oe.fontInfo=47]="fontInfo",oe[oe.fontLigatures=48]="fontLigatures",oe[oe.fontSize=49]="fontSize",oe[oe.fontWeight=50]="fontWeight",oe[oe.fontVariations=51]="fontVariations",oe[oe.formatOnPaste=52]="formatOnPaste",oe[oe.formatOnType=53]="formatOnType",oe[oe.glyphMargin=54]="glyphMargin",oe[oe.gotoLocation=55]="gotoLocation",oe[oe.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",oe[oe.hover=57]="hover",oe[oe.inDiffEditor=58]="inDiffEditor",oe[oe.inlineSuggest=59]="inlineSuggest",oe[oe.letterSpacing=60]="letterSpacing",oe[oe.lightbulb=61]="lightbulb",oe[oe.lineDecorationsWidth=62]="lineDecorationsWidth",oe[oe.lineHeight=63]="lineHeight",oe[oe.lineNumbers=64]="lineNumbers",oe[oe.lineNumbersMinChars=65]="lineNumbersMinChars",oe[oe.linkedEditing=66]="linkedEditing",oe[oe.links=67]="links",oe[oe.matchBrackets=68]="matchBrackets",oe[oe.minimap=69]="minimap",oe[oe.mouseStyle=70]="mouseStyle",oe[oe.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",oe[oe.mouseWheelZoom=72]="mouseWheelZoom",oe[oe.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",oe[oe.multiCursorModifier=74]="multiCursorModifier",oe[oe.multiCursorPaste=75]="multiCursorPaste",oe[oe.multiCursorLimit=76]="multiCursorLimit",oe[oe.occurrencesHighlight=77]="occurrencesHighlight",oe[oe.overviewRulerBorder=78]="overviewRulerBorder",oe[oe.overviewRulerLanes=79]="overviewRulerLanes",oe[oe.padding=80]="padding",oe[oe.parameterHints=81]="parameterHints",oe[oe.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",oe[oe.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",oe[oe.quickSuggestions=84]="quickSuggestions",oe[oe.quickSuggestionsDelay=85]="quickSuggestionsDelay",oe[oe.readOnly=86]="readOnly",oe[oe.renameOnType=87]="renameOnType",oe[oe.renderControlCharacters=88]="renderControlCharacters",oe[oe.renderFinalNewline=89]="renderFinalNewline",oe[oe.renderLineHighlight=90]="renderLineHighlight",oe[oe.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",oe[oe.renderValidationDecorations=92]="renderValidationDecorations",oe[oe.renderWhitespace=93]="renderWhitespace",oe[oe.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",oe[oe.roundedSelection=95]="roundedSelection",oe[oe.rulers=96]="rulers",oe[oe.scrollbar=97]="scrollbar",oe[oe.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",oe[oe.scrollBeyondLastLine=99]="scrollBeyondLastLine",oe[oe.scrollPredominantAxis=100]="scrollPredominantAxis",oe[oe.selectionClipboard=101]="selectionClipboard",oe[oe.selectionHighlight=102]="selectionHighlight",oe[oe.selectOnLineNumbers=103]="selectOnLineNumbers",oe[oe.showFoldingControls=104]="showFoldingControls",oe[oe.showUnused=105]="showUnused",oe[oe.snippetSuggestions=106]="snippetSuggestions",oe[oe.smartSelect=107]="smartSelect",oe[oe.smoothScrolling=108]="smoothScrolling",oe[oe.stickyScroll=109]="stickyScroll",oe[oe.stickyTabStops=110]="stickyTabStops",oe[oe.stopRenderingLineAfter=111]="stopRenderingLineAfter",oe[oe.suggest=112]="suggest",oe[oe.suggestFontSize=113]="suggestFontSize",oe[oe.suggestLineHeight=114]="suggestLineHeight",oe[oe.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",oe[oe.suggestSelection=116]="suggestSelection",oe[oe.tabCompletion=117]="tabCompletion",oe[oe.tabIndex=118]="tabIndex",oe[oe.unicodeHighlighting=119]="unicodeHighlighting",oe[oe.unusualLineTerminators=120]="unusualLineTerminators",oe[oe.useShadowDOM=121]="useShadowDOM",oe[oe.useTabStops=122]="useTabStops",oe[oe.wordBreak=123]="wordBreak",oe[oe.wordSeparators=124]="wordSeparators",oe[oe.wordWrap=125]="wordWrap",oe[oe.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",oe[oe.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",oe[oe.wordWrapColumn=128]="wordWrapColumn",oe[oe.wordWrapOverride1=129]="wordWrapOverride1",oe[oe.wordWrapOverride2=130]="wordWrapOverride2",oe[oe.wrappingIndent=131]="wrappingIndent",oe[oe.wrappingStrategy=132]="wrappingStrategy",oe[oe.showDeprecated=133]="showDeprecated",oe[oe.inlayHints=134]="inlayHints",oe[oe.editorClassName=135]="editorClassName",oe[oe.pixelRatio=136]="pixelRatio",oe[oe.tabFocusMode=137]="tabFocusMode",oe[oe.layoutInfo=138]="layoutInfo",oe[oe.wrappingInfo=139]="wrappingInfo"})(it=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Me(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:o.localize(177,null)})),acceptSuggestionOnEnter:Me(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",o.localize(178,null),""],markdownDescription:o.localize(179,null)})),accessibilitySupport:Me(new c),accessibilityPageSize:Me(new g(3,"accessibilityPageSize",10,1,1073741824,{description:o.localize(180,null),tags:["accessibility"]})),ariaLabel:Me(new b(4,"ariaLabel",o.localize(181,null))),autoClosingBrackets:Me(new s(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(182,null),o.localize(183,null),""],description:o.localize(184,null)})),autoClosingDelete:Me(new s(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",o.localize(185,null),""],description:o.localize(186,null)})),autoClosingOvertype:Me(new s(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",o.localize(187,null),""],description:o.localize(188,null)})),autoClosingQuotes:Me(new s(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(189,null),o.localize(190,null),""],description:o.localize(191,null)})),autoIndent:Me(new a(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[o.localize(192,null),o.localize(193,null),o.localize(194,null),o.localize(195,null),o.localize(196,null)],description:o.localize(197,null)})),automaticLayout:Me(new h(10,"automaticLayout",!1)),autoSurround:Me(new s(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[o.localize(198,null),o.localize(199,null),o.localize(200,null),""],description:o.localize(201,null)})),bracketPairColorization:Me(new de),bracketPairGuides:Me(new be),stickyTabStops:Me(new h(110,"stickyTabStops",!1,{description:o.localize(202,null)})),codeLens:Me(new h(14,"codeLens",!0,{description:o.localize(203,null)})),codeLensFontFamily:Me(new b(15,"codeLensFontFamily","",{description:o.localize(204,null)})),codeLensFontSize:Me(new g(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:o.localize(205,null)})),colorDecorators:Me(new h(17,"colorDecorators",!0,{description:o.localize(206,null)})),colorDecoratorsLimit:Me(new g(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:o.localize(207,null)})),columnSelection:Me(new h(19,"columnSelection",!1,{description:o.localize(208,null)})),comments:Me(new l),contextmenu:Me(new h(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Me(new h(22,"copyWithSyntaxHighlighting",!0,{description:o.localize(209,null)})),cursorBlinking:Me(new a(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],r,{description:o.localize(210,null)})),cursorSmoothCaretAnimation:Me(new s(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[o.localize(211,null),o.localize(212,null),o.localize(213,null)],description:o.localize(214,null)})),cursorStyle:Me(new a(25,"cursorStyle",f.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],T,{description:o.localize(215,null)})),cursorSurroundingLines:Me(new g(26,"cursorSurroundingLines",0,0,1073741824,{description:o.localize(216,null)})),cursorSurroundingLinesStyle:Me(new s(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[o.localize(217,null),o.localize(218,null)],description:o.localize(219,null)})),cursorWidth:Me(new g(28,"cursorWidth",0,0,1073741824,{markdownDescription:o.localize(220,null)})),disableLayerHinting:Me(new h(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Me(new h(30,"disableMonospaceOptimizations",!1)),domReadOnly:Me(new h(31,"domReadOnly",!1)),dragAndDrop:Me(new h(32,"dragAndDrop",!0,{description:o.localize(221,null)})),emptySelectionClipboard:Me(new G),dropIntoEditor:Me(new _e),stickyScroll:Me(new ge),experimentalWhitespaceRendering:Me(new s(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[o.localize(222,null),o.localize(223,null),o.localize(224,null)],description:o.localize(225,null)})),extraEditorClassName:Me(new b(36,"extraEditorClassName","")),fastScrollSensitivity:Me(new p(37,"fastScrollSensitivity",5,oe=>oe<=0?5:oe,{markdownDescription:o.localize(226,null)})),find:Me(new V),fixedOverflowWidgets:Me(new h(39,"fixedOverflowWidgets",!1)),folding:Me(new h(40,"folding",!0,{description:o.localize(227,null)})),foldingStrategy:Me(new s(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[o.localize(228,null),o.localize(229,null)],description:o.localize(230,null)})),foldingHighlight:Me(new h(42,"foldingHighlight",!0,{description:o.localize(231,null)})),foldingImportsByDefault:Me(new h(43,"foldingImportsByDefault",!1,{description:o.localize(232,null)})),foldingMaximumRegions:Me(new g(44,"foldingMaximumRegions",5e3,10,65e3,{description:o.localize(233,null)})),unfoldOnClickAfterEndOfLine:Me(new h(45,"unfoldOnClickAfterEndOfLine",!1,{description:o.localize(234,null)})),fontFamily:Me(new b(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:o.localize(235,null)})),fontInfo:Me(new F),fontLigatures2:Me(new N),fontSize:Me(new z),fontWeight:Me(new B),fontVariations:Me(new U),formatOnPaste:Me(new h(52,"formatOnPaste",!1,{description:o.localize(236,null)})),formatOnType:Me(new h(53,"formatOnType",!1,{description:o.localize(237,null)})),glyphMargin:Me(new h(54,"glyphMargin",!0,{description:o.localize(238,null)})),gotoLocation:Me(new W),hideCursorInOverviewRuler:Me(new h(56,"hideCursorInOverviewRuler",!1,{description:o.localize(239,null)})),hover:Me(new X),inDiffEditor:Me(new h(58,"inDiffEditor",!1)),letterSpacing:Me(new p(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,oe=>p.clamp(oe,-5,20),{description:o.localize(240,null)})),lightbulb:Me(new Z),lineDecorationsWidth:Me(new J),lineHeight:Me(new fe),lineNumbers:Me(new ee),lineNumbersMinChars:Me(new g(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Me(new h(66,"linkedEditing",!1,{description:o.localize(241,null)})),links:Me(new h(67,"links",!0,{description:o.localize(242,null)})),matchBrackets:Me(new s(68,"matchBrackets","always",["always","near","never"],{description:o.localize(243,null)})),minimap:Me(new ve),mouseStyle:Me(new s(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Me(new p(71,"mouseWheelScrollSensitivity",1,oe=>oe===0?1:oe,{markdownDescription:o.localize(244,null)})),mouseWheelZoom:Me(new h(72,"mouseWheelZoom",!1,{markdownDescription:o.localize(245,null)})),multiCursorMergeOverlapping:Me(new h(73,"multiCursorMergeOverlapping",!0,{description:o.localize(246,null)})),multiCursorModifier:Me(new a(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ee,{markdownEnumDescriptions:[o.localize(247,null),o.localize(248,null)],markdownDescription:o.localize(249,null)})),multiCursorPaste:Me(new s(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[o.localize(250,null),o.localize(251,null)],markdownDescription:o.localize(252,null)})),multiCursorLimit:Me(new g(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:o.localize(253,null)})),occurrencesHighlight:Me(new h(77,"occurrencesHighlight",!0,{description:o.localize(254,null)})),overviewRulerBorder:Me(new h(78,"overviewRulerBorder",!0,{description:o.localize(255,null)})),overviewRulerLanes:Me(new g(79,"overviewRulerLanes",3,0,3)),padding:Me(new Ae),parameterHints:Me(new Fe),peekWidgetDefaultFocus:Me(new s(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[o.localize(256,null),o.localize(257,null)],description:o.localize(258,null)})),definitionLinkOpensInPeek:Me(new h(83,"definitionLinkOpensInPeek",!1,{description:o.localize(259,null)})),quickSuggestions:Me(new le),quickSuggestionsDelay:Me(new g(85,"quickSuggestionsDelay",10,0,1073741824,{description:o.localize(260,null)})),readOnly:Me(new h(86,"readOnly",!1)),renameOnType:Me(new h(87,"renameOnType",!1,{description:o.localize(261,null),markdownDeprecationMessage:o.localize(262,null)})),renderControlCharacters:Me(new h(88,"renderControlCharacters",!0,{description:o.localize(263,null),restricted:!0})),renderFinalNewline:Me(new s(89,"renderFinalNewline",t.isLinux?"dimmed":"on",["off","on","dimmed"],{description:o.localize(264,null)})),renderLineHighlight:Me(new s(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",o.localize(265,null)],description:o.localize(266,null)})),renderLineHighlightOnlyWhenFocus:Me(new h(91,"renderLineHighlightOnlyWhenFocus",!1,{description:o.localize(267,null)})),renderValidationDecorations:Me(new s(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Me(new s(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",o.localize(268,null),o.localize(269,null),o.localize(270,null),""],description:o.localize(271,null)})),revealHorizontalRightPadding:Me(new g(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Me(new h(95,"roundedSelection",!0,{description:o.localize(272,null)})),rulers:Me(new ie),scrollbar:Me(new H),scrollBeyondLastColumn:Me(new g(98,"scrollBeyondLastColumn",4,0,1073741824,{description:o.localize(273,null)})),scrollBeyondLastLine:Me(new h(99,"scrollBeyondLastLine",!0,{description:o.localize(274,null)})),scrollPredominantAxis:Me(new h(100,"scrollPredominantAxis",!0,{description:o.localize(275,null)})),selectionClipboard:Me(new h(101,"selectionClipboard",!0,{description:o.localize(276,null),included:t.isLinux})),selectionHighlight:Me(new h(102,"selectionHighlight",!0,{description:o.localize(277,null)})),selectOnLineNumbers:Me(new h(103,"selectOnLineNumbers",!0)),showFoldingControls:Me(new s(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[o.localize(278,null),o.localize(279,null),o.localize(280,null)],description:o.localize(281,null)})),showUnused:Me(new h(105,"showUnused",!0,{description:o.localize(282,null)})),showDeprecated:Me(new h(133,"showDeprecated",!0,{description:o.localize(283,null)})),inlayHints:Me(new te),snippetSuggestions:Me(new s(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[o.localize(284,null),o.localize(285,null),o.localize(286,null),o.localize(287,null)],description:o.localize(288,null)})),smartSelect:Me(new De),smoothScrolling:Me(new h(108,"smoothScrolling",!1,{description:o.localize(289,null)})),stopRenderingLineAfter:Me(new g(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Me(new pe),inlineSuggest:Me(new Y),suggestFontSize:Me(new g(113,"suggestFontSize",0,0,1e3,{markdownDescription:o.localize(290,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Me(new g(114,"suggestLineHeight",0,0,1e3,{markdownDescription:o.localize(291,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Me(new h(115,"suggestOnTriggerCharacters",!0,{description:o.localize(292,null)})),suggestSelection:Me(new s(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[o.localize(293,null),o.localize(294,null),o.localize(295,null)],description:o.localize(296,null)})),tabCompletion:Me(new s(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[o.localize(297,null),o.localize(298,null),o.localize(299,null)],description:o.localize(300,null)})),tabIndex:Me(new g(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Me(new x),unusualLineTerminators:Me(new s(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[o.localize(301,null),o.localize(302,null),o.localize(303,null)],description:o.localize(304,null)})),useShadowDOM:Me(new h(121,"useShadowDOM",!0)),useTabStops:Me(new h(122,"useTabStops",!0,{description:o.localize(305,null)})),wordBreak:Me(new s(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[o.localize(306,null),o.localize(307,null)],description:o.localize(308,null)})),wordSeparators:Me(new b(124,"wordSeparators",k.USUAL_WORD_SEPARATORS,{description:o.localize(309,null)})),wordWrap:Me(new s(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[o.localize(310,null),o.localize(311,null),o.localize(312,null),o.localize(313,null)],description:o.localize(314,null)})),wordWrapBreakAfterCharacters:Me(new b(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Me(new b(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Me(new g(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:o.localize(315,null)})),wordWrapOverride1:Me(new s(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Me(new s(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Me(new M),pixelRatio:Me(new se),tabFocusMode:Me(new ke),layoutInfo:Me(new _),wrappingInfo:Me(new et),wrappingIndent:Me(new Ge),wrappingStrategy:Me(new Q)}}),define(ye[166],Ce([19,20]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ye[167],Ce([19,20]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ye[168],Ce([19,20]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(ye[169],Ce([19,20]),function(ne,e){return ne.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ye[170],Ce([19,20]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(ye[171],Ce([19,20]),function(ne,e){return ne.create("vs/platform/markers/common/markers",e)}),define(ye[172],Ce([19,20]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(ye[173],Ce([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ye[174],Ce([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ye[175],Ce([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostProgress",e)}),define(ye[176],Ce([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ye[177],Ce([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ye[178],Ce([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ye[179],Ce([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ye[180],Ce([19,20]),function(ne,e){return ne.create("vs/workbench/api/node/extHostDebugService",e)}),define(ye[181],Ce([19,20]),function(ne,e){return ne.create("vs/workbench/api/node/extHostTunnelService",e)}),define(ye[182],Ce([19,20]),function(ne,e){return ne.create("vs/workbench/common/editor",e)}),define(ye[183],Ce([19,20]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ye[184],Ce([19,20]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/debug",e)}),define(ye[185],Ce([19,20]),function(ne,e){return ne.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ye[186],Ce([19,20]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ye[187],Ce([19,20]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ye[188],Ce([19,20]),function(ne,e){return ne.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ye[189],Ce([19,20]),function(ne,e){return ne.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ye[190],Ce([19,20]),function(ne,e){return ne.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ye[191],Ce([1,0,10]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class t{constructor(){this.a=new Map}register(R,I){this.a.set(R,I)}updateManifest(R){if(!(typeof R.main>"u"&&typeof R.browser>"u")&&(R.activationEvents===void 0&&Object.assign(R,{activationEvents:[]}),!(!Array.isArray(R.activationEvents)||!R.contributes)))for(const I in R.contributes){const A=this.a.get(I);if(!A)continue;const S=R.contributes[I],C=Array.isArray(S)?S:[S];try{A(C,R.activationEvents)}catch(L){(0,o.onUnexpectedError)(L)}}}}e.ImplicitActivationEventsImpl=t,e.ImplicitActivationEvents=new t}),define(ye[192],Ce([1,0,24,43,168,310]),function(ne,e,o,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function S(h){return h=h.trim(),h==="*"||I.test(h)}e.isValidVersionStr=S;function C(h){if(!S(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const w=h.match(I);return w?{hasCaret:w[1]==="^",hasGreaterEquals:w[1]===">=",majorBase:w[2]==="x"?0:parseInt(w[2],10),majorMustEqual:w[2]!=="x",minorBase:w[4]==="x"?0:parseInt(w[4],10),minorMustEqual:w[4]!=="x",patchBase:w[6]==="x"?0:parseInt(w[6],10),patchMustEqual:w[6]!=="x",preRelease:w[8]||null}:null}e.parseVersion=C;function L(h){if(!h)return null;const w=h.majorBase,g=h.majorMustEqual,p=h.minorBase;let b=h.minorMustEqual;const i=h.patchBase;let s=h.patchMustEqual;h.hasCaret&&(w===0||(b=!1),s=!1);let a=0;if(h.preRelease){const u=A.exec(h.preRelease);if(u){const[,c,l,n]=u;a=Date.UTC(Number(c),Number(l)-1,Number(n))}}return{majorBase:w,majorMustEqual:g,minorBase:p,minorMustEqual:b,patchBase:i,patchMustEqual:s,isMinimum:h.hasGreaterEquals,notBefore:a}}e.normalizeVersion=L;function P(h,w,g){let p;typeof h=="string"?p=L(C(h)):p=h;let b;w instanceof Date?b=w.getTime():typeof w=="string"&&(b=new Date(w).getTime());let i;if(typeof g=="string"?i=L(C(g)):i=g,!p||!i)return!1;const s=p.majorBase,a=p.minorBase,u=p.patchBase;let c=i.majorBase,l=i.minorBase,n=i.patchBase;const r=i.notBefore;let f=i.majorMustEqual,E=i.minorMustEqual,T=i.patchMustEqual;return i.isMinimum?s>c?!0:s<c?!1:a>l?!0:a<l||b&&b<r?!1:u>=n:(s===1&&c===0&&(!f||!E||!T)&&(c=1,l=0,n=0,f=!0,E=!1,T=!1),s<c?!1:s>c?!f:a<l?!1:a>l?!E:u<n?!1:u>n?!T:!(b&&b<r))}e.isValidVersion=P;function y(h,w,g,p,b){const i=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return i.push([t.default.Error,k.localize(0,null)]),i;if(typeof p.name!="string")return i.push([t.default.Error,k.localize(1,null,"name")]),i;if(typeof p.version!="string")return i.push([t.default.Error,k.localize(2,null,"version")]),i;if(!p.engines)return i.push([t.default.Error,k.localize(3,null,"engines")]),i;if(typeof p.engines.vscode!="string")return i.push([t.default.Error,k.localize(4,null,"engines.vscode")]),i;if(typeof p.extensionDependencies<"u"&&!m(p.extensionDependencies))return i.push([t.default.Error,k.localize(5,null,"extensionDependencies")]),i;if(typeof p.activationEvents<"u"){if(!m(p.activationEvents))return i.push([t.default.Error,k.localize(6,null,"activationEvents")]),i;if(typeof p.main>"u"&&typeof p.browser>"u")return i.push([t.default.Error,k.localize(7,null,"activationEvents","main")]),i}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&i.push([t.default.Warning,k.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return i.push([t.default.Error,k.localize(9,null,"main")]),i;{const u=(0,o.joinPath)(g,p.main);(0,o.isEqualOrParent)(u,g)||i.push([t.default.Warning,k.localize(10,null,u.path,g.path)])}if(typeof p.activationEvents>"u")return i.push([t.default.Error,k.localize(11,null,"activationEvents","main")]),i}if(typeof p.browser<"u"){if(typeof p.browser!="string")return i.push([t.default.Error,k.localize(12,null,"browser")]),i;{const u=(0,o.joinPath)(g,p.browser);(0,o.isEqualOrParent)(u,g)||i.push([t.default.Warning,k.localize(13,null,u.path,g.path)])}if(typeof p.activationEvents>"u")return i.push([t.default.Error,k.localize(14,null,"activationEvents","browser")]),i}if(!R.valid(p.version))return i.push([t.default.Error,k.localize(15,null)]),i;const s=[];if(!D(h,w,p,b,s))for(const u of s)i.push([t.default.Error,u]);return i}e.validateExtensionManifest=y;function D(h,w,g,p,b){return p||typeof g.main>"u"&&typeof g.browser>"u"?!0:d(h,w,g.engines.vscode,b)}e.isValidExtensionVersion=D;function v(h,w,g){return h==="*"||d(w,g,h)}e.isEngineValid=v;function d(h,w,g,p=[]){const b=L(C(g));if(!b)return p.push(k.localize(16,null,g)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return p.push(k.localize(17,null,g)),!1}else if(!b.majorMustEqual)return p.push(k.localize(18,null,g)),!1;return P(h,w,b)?!0:(p.push(k.localize(19,null,h,g)),!1)}function m(h){if(!Array.isArray(h))return!1;for(let w=0,g=h.length;w<g;w++)if(typeof h[w]!="string")return!1;return!0}}),define(ye[121],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class o{constructor(k,R=[],I=!1){this.ctor=k,this.staticArguments=R,this.supportsDelayedInstantiation=I}}e.SyncDescriptor=o}),define(ye[88],Ce([1,0,121]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var k;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(k=e.InstantiationType||(e.InstantiationType={}));function R(A,S,C){S instanceof o.SyncDescriptor||(S=new o.SyncDescriptor(S,[],Boolean(C))),t.push([A,S])}e.registerSingleton=R;function I(){return t}e.getSingletonServiceDescriptors=I}),define(ye[193],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class o{constructor(R,I){this.key=R,this.data=I,this.incoming=new Map,this.outgoing=new Map}}e.Node=o;class t{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const I of this.a.values())I.outgoing.size===0&&R.push(I);return R}insertEdge(R,I){const A=this.lookupOrInsertNode(R),S=this.lookupOrInsertNode(I);A.outgoing.set(S.key,S),S.incoming.set(A.key,A)}removeNode(R){const I=this.b(R);this.a.delete(I);for(const A of this.a.values())A.outgoing.delete(I),A.incoming.delete(I)}lookupOrInsertNode(R){const I=this.b(R);let A=this.a.get(I);return A||(A=new o(I,R),this.a.set(I,A)),A}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[I,A]of this.a)R.push(`${I}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,I]of this.a){const A=new Set([R]),S=this.c(I,A);if(S)return S}}c(R,I){for(const[A,S]of R.outgoing){if(I.has(A))return[...I,A].join(" -> ");I.add(A);const C=this.c(S,I);if(C)return C;I.delete(A)}}}e.Graph=t}),define(ye[3],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var o;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function A(S){return S[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=A})(o=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function t(I,A,S){A[o.DI_TARGET]===A?A[o.DI_DEPENDENCIES].push({id:I,index:S}):(A[o.DI_DEPENDENCIES]=[{id:I,index:S}],A[o.DI_TARGET]=A)}function k(I){if(o.serviceIds.has(I))return o.serviceIds.get(I);const A=function(S,C,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(A,S,L)};return A.toString=()=>I,o.serviceIds.set(I,A),A}e.createDecorator=k;function R(I){return I}e.refineServiceDecorator=R}),define(ye[52],Ce([1,0,11,2,3]),function(ne,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function R(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof t.URI)}e.isConfigurationOverrides=R;function I(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=I;var A;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=S;function C(h,w){const g=Object.create(null);for(const p in h)L(g,p,h[p],w);return g}e.toValuesTree=C;function L(h,w,g,p){const b=w.split("."),i=b.pop();let s=h;for(let a=0;a<b.length;a++){const u=b[a];let c=s[u];switch(typeof c){case"undefined":c=s[u]=Object.create(null);break;case"object":break;default:p(`Ignoring ${w} as ${b.slice(0,a+1).join(".")} is ${JSON.stringify(c)}`);return}s=c}if(typeof s=="object"&&s!==null)try{s[i]=g}catch{p(`Ignoring ${w} as ${b.join(".")} is ${JSON.stringify(s)}`)}else p(`Ignoring ${w} as ${b.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=L;function P(h,w){const g=w.split(".");y(h,g)}e.removeFromValueTree=P;function y(h,w){const g=w.shift();if(w.length===0){delete h[g];return}if(Object.keys(h).indexOf(g)!==-1){const p=h[g];typeof p=="object"&&!Array.isArray(p)&&(y(p,w),Object.keys(p).length===0&&delete h[g])}}function D(h,w,g){function p(s,a){let u=s;for(const c of a){if(typeof u!="object"||u===null)return;u=u[c]}return u}const b=w.split("."),i=p(h,b);return typeof i>"u"?g:i}e.getConfigurationValue=D;function v(h,w,g){Object.keys(w).forEach(p=>{p!=="__proto__"&&(p in h?o.isObject(h[p])&&o.isObject(w[p])?v(h[p],w[p],g):g&&(h[p]=w[p]):h[p]=w[p])})}e.merge=v;function d(h,w,g){const p=h.inspect(w),b=h.inspect(g);return typeof p.userValue<"u"||typeof p.workspaceValue<"u"||typeof p.workspaceFolderValue<"u"?p.value:typeof b.userValue<"u"||typeof b.workspaceValue<"u"||typeof b.workspaceFolderValue<"u"?b.value:p.defaultValue}e.getMigratedSettingValue=d;function m(h){return h.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=m}),define(ye[53],Ce([1,0,12,8,3]),function(ne,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const R=new Map;R.set("false",!1),R.set("true",!0),R.set("isMac",o.isMacintosh),R.set("isLinux",o.isLinux),R.set("isWindows",o.isWindows),R.set("isWeb",o.isWeb),R.set("isMacNative",o.isMacintosh&&!o.isWeb),R.set("isEdge",o.isEdge),R.set("isFirefox",o.isFirefox),R.set("isChrome",o.isChrome),R.set("isSafari",o.isSafari);const I=Object.prototype.hasOwnProperty;var A;(function(V){V[V.False=0]="False",V[V.True=1]="True",V[V.Defined=2]="Defined",V[V.Not=3]="Not",V[V.Equals=4]="Equals",V[V.NotEquals=5]="NotEquals",V[V.And=6]="And",V[V.Regex=7]="Regex",V[V.NotRegex=8]="NotRegex",V[V.Or=9]="Or",V[V.In=10]="In",V[V.NotIn=11]="NotIn",V[V.Greater=12]="Greater",V[V.GreaterEquals=13]="GreaterEquals",V[V.Smaller=14]="Smaller",V[V.SmallerEquals=15]="SmallerEquals"})(A=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return P.INSTANCE}static true(){return y.INSTANCE}static has(N){return D.create(N)}static equals(N,U){return v.create(N,U)}static notEquals(N,U){return h.create(N,U)}static regex(N,U){return a.create(N,U)}static in(N,U){return d.create(N,U)}static notIn(N,U){return m.create(N,U)}static not(N){return w.create(N)}static and(...N){return l.create(N,null,!0)}static or(...N){return n.create(N,null,!0)}static greater(N,U){return p.create(N,U)}static greaterEquals(N,U){return b.create(N,U)}static smaller(N,U){return i.create(N,U)}static smallerEquals(N,U){return s.create(N,U)}static deserialize(N,U=!1){if(!!N)return this.c(N,U)}static c(N,U){const F=N.split("||");return n.create(F.map(z=>this.d(z,U)),null,!0)}static d(N,U){const F=N.split("&&");return l.create(F.map(z=>this.f(z,U)),null,!0)}static f(N,U){if(N=N.trim(),N.indexOf("!=")>=0){const F=N.split("!=");return h.create(F[0].trim(),this.g(F[1],U))}if(N.indexOf("==")>=0){const F=N.split("==");return v.create(F[0].trim(),this.g(F[1],U))}if(N.indexOf("=~")>=0){const F=N.split("=~");return a.create(F[0].trim(),this.h(F[1],U))}if(N.indexOf(" not in ")>=0){const F=N.split(" not in ");return m.create(F[0].trim(),this.g(F[1],U))}if(N.indexOf(" in ")>=0){const F=N.split(" in ");return d.create(F[0].trim(),this.g(F[1],U))}if(/^[^<=>]+>=[^<=>]+$/.test(N)){const F=N.split(">=");return b.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(N)){const F=N.split(">");return p.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(N)){const F=N.split("<=");return s.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(N)){const F=N.split("<");return i.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(N)?w.create(N.substr(1).trim()):D.create(N)}static g(N,U){if(N=N.trim(),N==="true")return!0;if(N==="false")return!1;const F=/^'([^']*)'$/.exec(N);return F?F[1].trim():N}static h(N,U){if((0,t.isFalsyOrWhitespace)(N)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const F=N.indexOf("/"),z=N.lastIndexOf("/");if(F===z||F<0){if(U)throw new Error(`bad regexp-value '${N}', missing /-enclosure`);return console.warn(`bad regexp-value '${N}', missing /-enclosure`),null}const B=N.slice(F+1,z),W=N[z+1]==="i"?"i":"";try{return new RegExp(B,W)}catch(X){if(U)throw new Error(`bad regexp-value '${N}', parse error: ${X}`);return console.warn(`bad regexp-value '${N}', parse error: ${X}`),null}}}e.ContextKeyExpr=S;function C(V,N){const U=V?V.substituteConstants():void 0,F=N?N.substituteConstants():void 0;return!U&&!F?!0:!U||!F?!1:U.equals(F)}e.expressionsAreEqualWithConstantSubstitution=C;function L(V,N){return V.cmp(N)}class P{constructor(){this.type=0}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!1}serialize(){return"false"}keys(){return[]}map(N){return this}negate(){return y.INSTANCE}}e.ContextKeyFalseExpr=P,P.INSTANCE=new P;class y{constructor(){this.type=1}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!0}serialize(){return"true"}keys(){return[]}map(N){return this}negate(){return P.INSTANCE}}e.ContextKeyTrueExpr=y,y.INSTANCE=new y;class D{static create(N,U=null){const F=R.get(N);return typeof F=="boolean"?F?y.INSTANCE:P.INSTANCE:new D(N,U)}constructor(N,U){this.key=N,this.c=U,this.type=2}cmp(N){return N.type!==this.type?this.type-N.type:f(this.key,N.key)}equals(N){return N.type===this.type?this.key===N.key:!1}substituteConstants(){const N=R.get(this.key);return typeof N=="boolean"?N?y.INSTANCE:P.INSTANCE:this}evaluate(N){return!!N.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(N){return N.mapDefined(this.key)}negate(){return this.c||(this.c=w.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=D;class v{static create(N,U,F=null){if(typeof U=="boolean")return U?D.create(N,F):w.create(N,F);const z=R.get(N);return typeof z=="boolean"?U===(z?"true":"false")?y.INSTANCE:P.INSTANCE:new v(N,U,F)}constructor(N,U,F){this.c=N,this.d=U,this.f=F,this.type=4}cmp(N){return N.type!==this.type?this.type-N.type:E(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=R.get(this.c);if(typeof N=="boolean"){const U=N?"true":"false";return this.d===U?y.INSTANCE:P.INSTANCE}return this}evaluate(N){return N.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(N){return N.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=v;class d{static create(N,U){return new d(N,U)}constructor(N,U){this.d=N,this.f=U,this.type=10,this.c=null}cmp(N){return N.type!==this.type?this.type-N.type:E(this.d,this.f,N.d,N.f)}equals(N){return N.type===this.type?this.d===N.d&&this.f===N.f:!1}substituteConstants(){return this}evaluate(N){const U=N.getValue(this.f),F=N.getValue(this.d);return Array.isArray(U)?U.includes(F):typeof F=="string"&&typeof U=="object"&&U!==null?I.call(U,F):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(N){return N.mapIn(this.d,this.f)}negate(){return this.c||(this.c=m.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=d;class m{static create(N,U){return new m(N,U)}constructor(N,U){this.d=N,this.f=U,this.type=11,this.c=d.create(N,U)}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(N){return N.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=m;class h{static create(N,U,F=null){if(typeof U=="boolean")return U?w.create(N,F):D.create(N,F);const z=R.get(N);return typeof z=="boolean"?U===(z?"true":"false")?P.INSTANCE:y.INSTANCE:new h(N,U,F)}constructor(N,U,F){this.c=N,this.d=U,this.f=F,this.type=5}cmp(N){return N.type!==this.type?this.type-N.type:E(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=R.get(this.c);if(typeof N=="boolean"){const U=N?"true":"false";return this.d===U?P.INSTANCE:y.INSTANCE}return this}evaluate(N){return N.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(N){return N.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=h;class w{static create(N,U=null){const F=R.get(N);return typeof F=="boolean"?F?P.INSTANCE:y.INSTANCE:new w(N,U)}constructor(N,U){this.c=N,this.d=U,this.type=3}cmp(N){return N.type!==this.type?this.type-N.type:f(this.c,N.c)}equals(N){return N.type===this.type?this.c===N.c:!1}substituteConstants(){const N=R.get(this.c);return typeof N=="boolean"?N?P.INSTANCE:y.INSTANCE:this}evaluate(N){return!N.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(N){return N.mapNot(this.c)}negate(){return this.d||(this.d=D.create(this.c,this)),this.d}}e.ContextKeyNotExpr=w;function g(V,N){if(typeof V=="string"){const U=parseFloat(V);isNaN(U)||(V=U)}return typeof V=="string"||typeof V=="number"?N(V):P.INSTANCE}class p{static create(N,U,F=null){return g(U,z=>new p(N,z,F))}constructor(N,U,F){this.c=N,this.d=U,this.f=F,this.type=12}cmp(N){return N.type!==this.type?this.type-N.type:E(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=s.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=p;class b{static create(N,U,F=null){return g(U,z=>new b(N,z,F))}constructor(N,U,F){this.c=N,this.d=U,this.f=F,this.type=13}cmp(N){return N.type!==this.type?this.type-N.type:E(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=i.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=b;class i{static create(N,U,F=null){return g(U,z=>new i(N,z,F))}constructor(N,U,F){this.c=N,this.d=U,this.f=F,this.type=14}cmp(N){return N.type!==this.type?this.type-N.type:E(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=i;class s{static create(N,U,F=null){return g(U,z=>new s(N,z,F))}constructor(N,U,F){this.c=N,this.d=U,this.f=F,this.type=15}cmp(N){return N.type!==this.type?this.type-N.type:E(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=p.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=s;class a{static create(N,U){return new a(N,U)}constructor(N,U){this.d=N,this.f=U,this.type=7,this.c=null}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.d<N.d)return-1;if(this.d>N.d)return 1;const U=this.f?this.f.source:"",F=N.f?N.f.source:"";return U<F?-1:U>F?1:0}equals(N){if(N.type===this.type){const U=this.f?this.f.source:"",F=N.f?N.f.source:"";return this.d===N.d&&U===F}return!1}substituteConstants(){return this}evaluate(N){const U=N.getValue(this.d);return this.f?this.f.test(U):!1}serialize(){const N=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${N}`}keys(){return[this.d]}map(N){return N.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=u.create(this)),this.c}}e.ContextKeyRegexExpr=a;class u{static create(N){return new u(N)}constructor(N){this.c=N,this.type=8}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(N){return new u(this.c.map(N))}negate(){return this.c}}e.ContextKeyNotRegexExpr=u;function c(V){let N=null;for(let U=0,F=V.length;U<F;U++){const z=V[U].substituteConstants();if(V[U]!==z&&N===null){N=[];for(let B=0;B<U;B++)N[B]=V[B]}N!==null&&(N[U]=z)}return N===null?V:N}class l{static create(N,U,F){return l.d(N,U,F)}constructor(N,U){this.expr=N,this.c=U,this.type=6}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let U=0,F=this.expr.length;U<F;U++){const z=L(this.expr[U],N.expr[U]);if(z!==0)return z}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].equals(N.expr[U]))return!1;return!0}return!1}substituteConstants(){const N=c(this.expr);return N===this.expr?this:l.create(N,this.c,!1)}evaluate(N){for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].evaluate(N))return!1;return!0}static d(N,U,F){const z=[];let B=!1;for(const W of N)if(!!W){if(W.type===1){B=!0;continue}if(W.type===0)return P.INSTANCE;if(W.type===6){z.push(...W.expr);continue}z.push(W)}if(z.length===0&&B)return y.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(L);for(let W=1;W<z.length;W++)z[W-1].equals(z[W])&&(z.splice(W,1),W--);if(z.length===1)return z[0];for(;z.length>1;){const W=z[z.length-1];if(W.type!==9)break;z.pop();const X=z.pop(),q=z.length===0,_=n.create(W.expr.map(Q=>l.create([Q,X],null,F)),null,q);_&&(z.push(_),z.sort(L))}if(z.length===1)return z[0];if(F){for(let W=0;W<z.length;W++)for(let X=W+1;X<z.length;X++)if(z[W].negate().equals(z[X]))return P.INSTANCE;if(z.length===1)return z[0]}return new l(z,U)}}serialize(){return this.expr.map(N=>N.serialize()).join(" && ")}keys(){const N=[];for(const U of this.expr)N.push(...U.keys());return N}map(N){return new l(this.expr.map(U=>U.map(N)),null)}negate(){if(!this.c){const N=[];for(const U of this.expr)N.push(U.negate());this.c=n.create(N,this,!0)}return this.c}}class n{static create(N,U,F){return n.d(N,U,F)}constructor(N,U){this.expr=N,this.c=U,this.type=9}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let U=0,F=this.expr.length;U<F;U++){const z=L(this.expr[U],N.expr[U]);if(z!==0)return z}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].equals(N.expr[U]))return!1;return!0}return!1}substituteConstants(){const N=c(this.expr);return N===this.expr?this:n.create(N,this.c,!1)}evaluate(N){for(let U=0,F=this.expr.length;U<F;U++)if(this.expr[U].evaluate(N))return!0;return!1}static d(N,U,F){let z=[],B=!1;if(N){for(let W=0,X=N.length;W<X;W++){const q=N[W];if(!!q){if(q.type===0){B=!0;continue}if(q.type===1)return y.INSTANCE;if(q.type===9){z=z.concat(q.expr);continue}z.push(q)}}if(z.length===0&&B)return P.INSTANCE;z.sort(L)}if(z.length!==0){if(z.length===1)return z[0];for(let W=1;W<z.length;W++)z[W-1].equals(z[W])&&(z.splice(W,1),W--);if(z.length===1)return z[0];if(F){for(let W=0;W<z.length;W++)for(let X=W+1;X<z.length;X++)if(z[W].negate().equals(z[X]))return y.INSTANCE;if(z.length===1)return z[0]}return new n(z,U)}}serialize(){return this.expr.map(N=>N.serialize()).join(" || ")}keys(){const N=[];for(const U of this.expr)N.push(...U.keys());return N}map(N){return new n(this.expr.map(U=>U.map(N)),null)}negate(){if(!this.c){const N=[];for(const U of this.expr)N.push(U.negate());for(;N.length>1;){const U=N.shift(),F=N.shift(),z=[];for(const B of G(U))for(const W of G(F))z.push(l.create([B,W],null,!1));N.unshift(n.create(z,null,!1))}this.c=n.create(N,this,!0)}return this.c}}class r extends D{static all(){return r.d.values()}constructor(N,U,F){super(N,null),this.f=U,typeof F=="object"?r.d.push({...F,key:N}):F!==!0&&r.d.push({key:N,description:F,type:U!=null?typeof U:void 0})}bindTo(N){return N.createKey(this.key,this.f)}getValue(N){return N.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(N){return v.create(this.key,N)}notEqualsTo(N){return h.create(this.key,N)}}e.RawContextKey=r,r.d=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService");function f(V,N){return V<N?-1:V>N?1:0}function E(V,N,U,F){return V<U?-1:V>U?1:N<F?-1:N>F?1:0}function T(V,N){if(V.type===0||N.type===1)return!0;if(V.type===9)return N.type===9?M(V.expr,N.expr):!1;if(N.type===9){for(const U of N.expr)if(T(V,U))return!0;return!1}if(V.type===6){if(N.type===6)return M(N.expr,V.expr);for(const U of V.expr)if(T(U,N))return!0;return!1}return V.equals(N)}e.implies=T;function M(V,N){let U=0,F=0;for(;U<V.length&&F<N.length;){const z=V[U].cmp(N[F]);if(z<0)return!1;z===0&&U++,F++}return U===V.length}function G(V){return V.type===9?V.expr:[V]}}),define(ye[194],Ce([1,0,3]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,o.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,o.refineServiceDecorator)(e.IEnvironmentService)}),define(ye[122],Ce([1,0,167,3]),function(ne,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function R(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function I(h,w){switch(h){case 3:return w==="x64"?"win32-x64":w==="ia32"?"win32-ia32":w==="arm64"?"win32-arm64":"unknown";case 2:return w==="x64"?"linux-x64":w==="arm64"?"linux-arm64":w==="arm"?"linux-armhf":"unknown";case"alpine":return w==="x64"?"alpine-x64":w==="arm64"?"alpine-arm64":"unknown";case 1:return w==="x64"?"darwin-x64":w==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=I;function A(h,w){return w==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function S(h,w,g){return A(w,g)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===g?!0:C(g).includes(h)}e.isTargetPlatformCompatible=S;function C(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=C;function L(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=L;var P;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(P=e.SortBy||(e.SortBy={}));var y;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(y=e.SortOrder||(e.SortOrder={}));var D;(function(h){h.Install="install",h.Uninstall="uninstall"})(D=e.StatisticType||(e.StatisticType={}));var v;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var d;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Internal="Internal",h.Signature="Signature"})(d=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class m extends Error{constructor(w,g){super(w),this.code=g,this.name=g}}e.ExtensionManagementError=m,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,o.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,o.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ye[195],Ce([1,0,3]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,o.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,o.createDecorator)("externalTerminal")}),define(ye[196],Ce([1,0,45,15,9,12,107,29,115,169,195]),function(ne,e,o,t,k,R,I,A,S,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=C.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:D.getDefaultTerminalWindows(),linux:await d.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class D extends y{openTerminal(p,b){return this.spawnTerminal(o,p,S.getWindowsShell(),b)}spawnTerminal(p,b,i,s){const a=b.windowsExec||D.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const u=k.basename(a).toLowerCase();if(u==="cmder"||u==="cmder.exe")return p.spawn(a,s?[s]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return a.indexOf(" ")>=0&&c.push('""'),c.push(a),(u==="wt"||u==="wt.exe")&&c.push("-d ."),new Promise((l,n)=>{const r=m(process),f=p.spawn(i,c,{cwd:s,env:r});f.on("error",n),f.on("exit",()=>l())})}runInTerminal(p,b,i,s,a){const u="windowsExec"in a&&a.windowsExec?a.windowsExec:D.getDefaultTerminalWindows();return new Promise((c,l)=>{const n=`"${b} - ${P}"`,r=`""${i.join('" "')}" & pause"`,f=["/c","start",n,"/wait",u,"/c",r],E=Object.assign({},m(process),s);Object.keys(E).filter(G=>E[G]===null).forEach(G=>delete E[G]);const T={cwd:b,env:E,windowsVerbatimArguments:!0};o.spawn(D.b,f,T).on("error",G=>{l(h(G))}),c(void 0)})}static getDefaultTerminalWindows(){if(!D.d){const p=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");D.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${p?"Sysnative":"System32"}\\cmd.exe`}return D.d}}e.WindowsExternalTerminalService=D,D.b="cmd.exe";class v extends y{openTerminal(p,b){return this.spawnTerminal(o,p,b)}runInTerminal(p,b,i,s,a){const u=a.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((c,l)=>{if(u===L.DEFAULT_TERMINAL_OSX||u==="iTerm.app"){const n=u===L.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",f=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${n}.scpt`).fsPath,"-t",p||P,"-w",b];for(const M of i)f.push("-a"),f.push(M);if(s){const M=Object.assign({},m(process),s);for(const G in M){const V=M[G];V===null?(f.push("-u"),f.push(G)):(f.push("-e"),f.push(`${G}=${V}`))}}let E="";const T=o.spawn(v.b,f);T.on("error",M=>{l(h(M))}),T.stderr.on("data",M=>{E+=M.toString()}),T.on("exit",M=>{if(M===0)c(void 0);else if(E){const G=E.split(`
`,1);l(new Error(G[0]))}else l(new Error(C.localize(1,null,n,M)))})}else l(new Error(C.localize(2,null,u)))})}spawnTerminal(p,b,i){const s=b.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((a,u)=>{const c=["-a",s];i&&c.push(i);const l=m(process),n=p.spawn("/usr/bin/open",c,{cwd:i,env:l});n.on("error",u),n.on("exit",()=>a())})}}e.MacExternalTerminalService=v,v.b="/usr/bin/osascript";class d extends y{openTerminal(p,b){return this.spawnTerminal(o,p,b)}runInTerminal(p,b,i,s,a){const u=a.linuxExec?Promise.resolve(a.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((c,l)=>{const n=[];u.then(r=>{r.indexOf("gnome-terminal")>=0?n.push("-x"):n.push("-e"),n.push("bash"),n.push("-c");const f=`${w(i)}; echo; read -p "${d.b}" -n1;`;n.push(`''${f}''`);const E=Object.assign({},m(process),s);Object.keys(E).filter(V=>E[V]===null).forEach(V=>delete E[V]);const T={cwd:b,env:E};let M="";const G=o.spawn(r,n,T);G.on("error",V=>{l(h(V))}),G.stderr.on("data",V=>{M+=V.toString()}),G.on("exit",V=>{if(V===0)c(void 0);else if(M){const N=M.split(`
`,1);l(new Error(N[0]))}else l(new Error(C.localize(4,null,r,V)))})})})}static async getDefaultTerminalLinuxReady(){if(!d.d)if(!R.isLinux)d.d=Promise.resolve("xterm");else{const p=await A.Promises.exists("/etc/debian_version");d.d=new Promise(b=>{p?b("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?b("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?b("konsole"):process.env.COLORTERM?b(process.env.COLORTERM):process.env.TERM?b(process.env.TERM):b("xterm")})}return d.d}spawnTerminal(p,b,i){const s=b.linuxExec?Promise.resolve(b.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((a,u)=>{s.then(c=>{const l=m(process),n=p.spawn(c,[],{cwd:i,env:l});n.on("error",u),n.on("exit",()=>a())})})}}e.LinuxExternalTerminalService=d,d.b=C.localize(3,null);function m(g){const p={...g.env};return(0,I.sanitizeProcessEnvironment)(p),p}function h(g){return"errno"in g&&g.errno==="ENOENT"&&"path"in g&&typeof g.path=="string"?new Error(C.localize(5,null,g.path)):g}function w(g){let p="";for(const b of g)b.indexOf(" ")>=0?p+='"'+b+'"':p+=b,p+=" ";return p}}),define(ye[38],Ce([1,0,64,9,8,11,2,170,3]),function(ne,e,o,t,k,R,I,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function C(B){return B.create===!0}e.isFileOpenForWriteOptions=C;var L;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(L=e.FileType||(e.FileType={}));var P;(function(B){B[B.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var y;(function(B){B[B.None=0]="None",B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock",B[B.FileAtomicRead=16384]="FileAtomicRead",B[B.FileClone=32768]="FileClone"})(y=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function D(B){return!!(B.capabilities&2)}e.hasReadWriteCapability=D;function v(B){return!!(B.capabilities&8)}e.hasFileFolderCopyCapability=v;function d(B){return!!(B.capabilities&32768)}e.hasFileCloneCapability=d;function m(B){return!!(B.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function h(B){return!!(B.capabilities&16)}e.hasFileReadStreamCapability=h;function w(B){return D(B)?!!(B.capabilities&16384):!1}e.hasFileAtomicReadCapability=w;var g;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(g=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class p extends Error{constructor(W,X){super(W),this.code=X}}e.FileSystemProviderError=p;function b(B,W){const X=new p(B.toString(),W);return s(X,W),X}e.createFileSystemProviderError=b;function i(B){return B||b((0,A.localize)(0,null),g.Unknown)}e.ensureFileSystemProviderError=i;function s(B,W){return B.name=W?`${W} (FileSystemError)`:"FileSystemError",B}e.markAsFileSystemProviderError=s;function a(B){if(!B)return g.Unknown;if(B instanceof p)return B.code;const W=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!W)return g.Unknown;switch(W[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileExceedsMemoryLimit:return g.FileExceedsMemoryLimit;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}e.toFileSystemProviderErrorCode=a;function u(B){if(B instanceof E)return B.fileOperationResult;switch(a(B)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 10;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileExceedsMemoryLimit:return 9;case g.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=u;var c;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY",B[B.WRITE=4]="WRITE"})(c=e.FileOperation||(e.FileOperation={}));class l{constructor(W,X,q){this.resource=W,this.operation=X,this.target=q}isOperation(W){return this.operation===W}}e.FileOperationEvent=l;var n;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(n=e.FileChangeType||(e.FileChangeType={}));class r{constructor(W,X){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const q=new Map;for(const _ of W){const Q=q.get(_.type);switch(Q?Q.push([_.resource,_]):q.set(_.type,[[_.resource,_]]),_.type){case 1:this.rawAdded.push(_.resource);break;case 0:this.rawUpdated.push(_.resource);break;case 2:this.rawDeleted.push(_.resource);break}}for(const[_,Q]of q)switch(_){case 1:this.a=o.TernarySearchTree.forUris(()=>X),this.a.fill(Q);break;case 0:this.b=o.TernarySearchTree.forUris(()=>X),this.b.fill(Q);break;case 2:this.c=o.TernarySearchTree.forUris(()=>X),this.c.fill(Q);break}}contains(W,...X){return this.d(W,{includeChildren:!1},...X)}affects(W,...X){return this.d(W,{includeChildren:!0},...X)}d(W,X,...q){if(!W)return!1;const _=q.length>0;return!!((!_||q.includes(1))&&(this.a?.get(W)||X.includeChildren&&this.a?.findSuperstr(W))||(!_||q.includes(0))&&(this.b?.get(W)||X.includeChildren&&this.b?.findSuperstr(W))||(!_||q.includes(2))&&(this.c?.findSubstr(W)||X.includeChildren&&this.c?.findSuperstr(W)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=r;function f(B,W,X){return!B||!W||B===W||W.length>B.length?!1:(W.charAt(W.length-1)!==t.sep&&(W+=t.sep),X?(0,k.startsWithIgnoreCase)(B,W):B.indexOf(W)===0)}e.isParent=f;class E extends Error{constructor(W,X,q){super(W),this.fileOperationResult=X,this.options=q}}e.FileOperationError=E;class T extends E{constructor(W,X,q){super(W,2,q),this.stat=X}}e.NotModifiedSinceFileOperationError=T;var M;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",B[B.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(M=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var G;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(G=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function V(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}e.etag=V;async function N(B,W){if(!W.hasProvider(I.URI.from({scheme:B.scheme})))return new Promise(X=>{const q=W.onDidChangeFileSystemProviderRegistrations(_=>{_.scheme===B.scheme&&_.added&&(q.dispose(),X())})})}e.whenProviderRegistered=N,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class U{static formatSize(W){return(0,R.isNumber)(W)||(W=0),W<U.KB?(0,A.localize)(1,null,W.toFixed(0)):W<U.MB?(0,A.localize)(2,null,(W/U.KB).toFixed(2)):W<U.GB?(0,A.localize)(3,null,(W/U.MB).toFixed(2)):W<U.TB?(0,A.localize)(4,null,(W/U.GB).toFixed(2)):(0,A.localize)(5,null,(W/U.TB).toFixed(2))}}e.ByteSize=U,U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB;var F;(function(B){B[B.IA32=0]="IA32",B[B.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function z(B){return{maxFileSize:B===0?300*U.MB:16*U.GB,maxHeapSize:B===0?700*U.MB:2*700*U.MB}}e.getPlatformLimits=z}),define(ye[89],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class o{constructor(...k){this.a=new Map;for(const[R,I]of k)this.set(R,I)}set(k,R){const I=this.a.get(k);return this.a.set(k,R),I}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.ServiceCollection=o}),define(ye[197],Ce([1,0,16,10,6,121,193,3,89,63]),function(ne,e,o,t,k,R,I,A,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const L=!1;class P extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class y{constructor(m=new S.ServiceCollection,h=!1,w,g=L){this.f=m,this.g=h,this.h=w,this.i=g,this.o=new Set,this.f.set(A.IInstantiationService,this),this._globalGraph=g?w?._globalGraph??new I.Graph(p=>p):void 0}createChild(m){return new y(m,this.g,this,this.i)}invokeFunction(m,...h){const w=v.traceInvocation(this.i,m);let g=!1;try{return m({get:b=>{if(g)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(b,w);if(!i)throw new Error(`[invokeFunction] unknown service '${b}'`);return i}},...h)}finally{g=!0,w.stop()}}createInstance(m,...h){let w,g;return m instanceof R.SyncDescriptor?(w=v.traceCreation(this.i,m.ctor),g=this.j(m.ctor,m.staticArguments.concat(h),w)):(w=v.traceCreation(this.i,m),g=this.j(m,h,w)),w.stop(),g}j(m,h=[],w){const g=A._util.getServiceDependencies(m).sort((i,s)=>i.index-s.index),p=[];for(const i of g){const s=this.m(i.id,w);s||this.u(`[createInstance] ${m.name} depends on UNKNOWN service ${i.id}.`,!1),p.push(s)}const b=g.length>0?g[0].index:h.length;if(h.length!==b){console.trace(`[createInstance] First service dependency of ${m.name} at position ${b+1} conflicts with ${h.length} static arguments`);const i=b-h.length;i>0?h=h.concat(new Array(i)):h=h.slice(0,b)}return Reflect.construct(m,h.concat(p))}k(m,h){if(this.f.get(m)instanceof R.SyncDescriptor)this.f.set(m,h);else if(this.h)this.h.k(m,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l(m){const h=this.f.get(m);return!h&&this.h?this.h.l(m):h}m(m,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const w=this.l(m);return w instanceof R.SyncDescriptor?this.q(m,w,h.branch(m,!0)):(h.branch(m,!1),w)}q(m,h,w){if(this.o.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.o.add(m);try{return this.r(m,h,w)}finally{this.o.delete(m)}}r(m,h,w){const g=new I.Graph(i=>i.id.toString());let p=0;const b=[{id:m,desc:h,_trace:w}];for(;b.length;){const i=b.pop();if(g.lookupOrInsertNode(i),p++>1e3)throw new P(g);for(const s of A._util.getServiceDependencies(i.desc.ctor)){const a=this.l(s.id);if(a||this.u(`[createInstance] ${m} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(s.id)),a instanceof R.SyncDescriptor){const u={id:s.id,desc:a,_trace:i._trace.branch(s.id,!0)};g.insertEdge(i,u),b.push(u)}}}for(;;){const i=g.roots();if(i.length===0){if(!g.isEmpty())throw new P(g);break}for(const{data:s}of i){if(this.l(s.id)instanceof R.SyncDescriptor){const u=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,u)}g.removeNode(s)}}return this.l(m)}s(m,h,w=[],g,p){if(this.f.get(m)instanceof R.SyncDescriptor)return this.t(m,h,w,g,p);if(this.h)return this.h.s(m,h,w,g,p);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t(m,h,w=[],g,p){if(g){const b=new y(void 0,this.g,this,this.i);b.c=String(m);const i=new Map,s=new o.IdleValue(()=>{const a=b.j(h,w,p);for(const[u,c]of i){const l=a[u];if(typeof l=="function")for(const n of c)l.apply(a,n)}return i.clear(),a});return new Proxy(Object.create(null),{get(a,u){if(!s.isInitialized&&typeof u=="string"&&(u.startsWith("onDid")||u.startsWith("onWill"))){let n=i.get(u);return n||(n=new C.LinkedList,i.set(u,n)),(f,E,T)=>{const M=n.push([f,E,T]);return(0,k.toDisposable)(M)}}if(u in a)return a[u];const c=s.value;let l=c[u];return typeof l!="function"||(l=l.bind(c),a[u]=l),l},set(a,u,c){return s.value[u]=c,!0},getPrototypeOf(a){return h.prototype}})}else return this.j(h,w,p)}u(m,h){if(h&&console.warn(m),this.g)throw new Error(m)}}e.InstantiationService=y;var D;(function(d){d[d.None=0]="None",d[d.Creation=1]="Creation",d[d.Invocation=2]="Invocation",d[d.Branch=3]="Branch"})(D||(D={}));class v{static traceInvocation(m,h){return m?new v(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(m,h){return m?new v(1,h.name):v.c}constructor(m,h){this.type=m,this.name=h,this.g=Date.now(),this.h=[]}branch(m,h){const w=new v(3,m.toString());return this.h.push([m,h,w]),w}stop(){const m=Date.now()-this.g;v.f+=m;let h=!1;function w(p,b){const i=[],s=new Array(p+1).join("	");for(const[a,u,c]of b.h)if(u&&c){h=!0,i.push(`${s}CREATES -> ${a}`);const l=w(p+1,c);l&&i.push(l)}else i.push(`${s}uses -> ${a}`);return i.join(`
`)}const g=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(m>2||h)&&v.all.add(g.join(`
`))}}e.Trace=v,v.all=new Set,v.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}},v.f=0}),define(ye[13],Ce([1,0,51,4,6,28,12,2,3]),function(ne,e,o,t,k,R,I,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function C(){return new Date().toISOString()}var L;(function(l){l[l.Off=0]="Off",l[l.Trace=1]="Trace",l[l.Debug=2]="Debug",l[l.Info=3]="Info",l[l.Warning=4]="Warning",l[l.Error=5]="Error"})(L=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=L.Info;function P(l,n,r){switch(n){case L.Trace:l.trace(r);break;case L.Debug:l.debug(r);break;case L.Info:l.info(r);break;case L.Warning:l.warn(r);break;case L.Error:l.error(r);break;case L.Off:break;default:throw new Error(`Invalid log level ${n}`)}}e.log=P;function y(l){let n="";for(let r=0;r<l.length;r++){let f=l[r];if(typeof f=="object")try{f=JSON.stringify(f)}catch{}n+=(r>0?" ":"")+f}return n}e.format=y;class D extends k.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new t.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(n){this.b!==n&&(this.b=n,this.c.fire(this.b))}getLevel(){return this.b}f(n){return this.b!==L.Off&&this.b<=n}}e.AbstractLogger=D;class v extends D{constructor(n){super(),this.h=n}f(n){return this.h||super.f(n)}trace(n,...r){this.f(L.Trace)&&this.g(L.Trace,y([n,...r]))}debug(n,...r){this.f(L.Debug)&&this.g(L.Debug,y([n,...r]))}info(n,...r){this.f(L.Info)&&this.g(L.Info,y([n,...r]))}warn(n,...r){this.f(L.Warning)&&this.g(L.Warning,y([n,...r]))}error(n,...r){if(this.f(L.Error))if(n instanceof Error){const f=Array.prototype.slice.call(arguments);f[0]=n.stack,this.g(L.Error,y(f))}else this.g(L.Error,y([n,...r]))}flush(){}}e.AbstractMessageLogger=v;class d extends D{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n),this.g=!I.isWindows}trace(n,...r){this.f(L.Trace)&&(this.g?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,n,...r):console.log(`[main ${C()}]`,n,...r))}debug(n,...r){this.f(L.Debug)&&(this.g?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,n,...r):console.log(`[main ${C()}]`,n,...r))}info(n,...r){this.f(L.Info)&&(this.g?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,n,...r):console.log(`[main ${C()}]`,n,...r))}warn(n,...r){this.f(L.Warning)&&(this.g?console.warn(`\x1B[93m[main ${C()}]\x1B[0m`,n,...r):console.warn(`[main ${C()}]`,n,...r))}error(n,...r){this.f(L.Error)&&(this.g?console.error(`\x1B[91m[main ${C()}]\x1B[0m`,n,...r):console.error(`[main ${C()}]`,n,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=d;class m extends D{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n)}trace(n,...r){this.f(L.Trace)&&console.log("%cTRACE","color: #888",n,...r)}debug(n,...r){this.f(L.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",n,...r)}info(n,...r){this.f(L.Info)&&console.log("%c INFO","color: #33f",n,...r)}warn(n,...r){this.f(L.Warning)&&console.log("%c WARN","color: #993",n,...r)}error(n,...r){this.f(L.Error)&&console.log("%c  ERR","color: #f33",n,...r)}dispose(){}flush(){}}e.ConsoleLogger=m;class h extends D{constructor(n,r=e.DEFAULT_LOG_LEVEL){super(),this.g=n,this.setLevel(r)}trace(n,...r){this.f(L.Trace)&&this.g.log(L.Trace,[this.h(n),...r])}debug(n,...r){this.f(L.Debug)&&this.g.log(L.Debug,[this.h(n),...r])}info(n,...r){this.f(L.Info)&&this.g.log(L.Info,[this.h(n),...r])}warn(n,...r){this.f(L.Warning)&&this.g.log(L.Warning,[this.h(n),...r])}error(n,...r){this.f(L.Error)&&this.g.log(L.Error,[this.h(n),...r])}h(n){return typeof n=="string"?n:(0,o.toErrorMessage)(n,this.f(L.Trace))}dispose(){}flush(){}}e.AdapterLogger=h;class w extends D{constructor(n){super(),this.g=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const r of this.g)r.setLevel(n);super.setLevel(n)}trace(n,...r){for(const f of this.g)f.trace(n,...r)}debug(n,...r){for(const f of this.g)f.debug(n,...r)}info(n,...r){for(const f of this.g)f.info(n,...r)}warn(n,...r){for(const f of this.g)f.warn(n,...r)}error(n,...r){for(const f of this.g)f.error(n,...r)}flush(){for(const n of this.g)n.flush()}dispose(){for(const n of this.g)n.dispose()}}e.MultiplexLogService=w;class g extends k.Disposable{constructor(n){super(),this.b=n,this.B(n)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(n){this.b.setLevel(n)}getLevel(){return this.b.getLevel()}trace(n,...r){this.b.trace(n,...r)}debug(n,...r){this.b.debug(n,...r)}info(n,...r){this.b.info(n,...r)}warn(n,...r){this.b.warn(n,...r)}error(n,...r){this.b.error(n,...r)}flush(){this.b.flush()}}e.LogService=g;class p extends k.Disposable{constructor(n,r){super(),this.c=n,this.b=new R.ResourceMap,this.B(r(f=>this.setLevel(f)))}getLoggers(){return[...this.b.values()].map(({logger:n})=>n)}getLogger(n){return this.b.get(n)?.logger}createLogger(n,r,f){let E=this.b.get(n)?.logger;return E||(f=r?.always?L.Trace:f,E=this.f(n,f??this.c,r),this.b.set(n,{logger:E,logLevel:f})),E}setLevel(n,r){const f=A.URI.isUri(n)?n:void 0,E=f?r:n;if(f){const T=this.b.get(f);T&&T.logLevel!==E&&(T.logLevel=E,T.logger.setLevel(E))}else this.c=E,this.b.forEach(({logLevel:T,logger:M})=>{T===void 0&&M.setLevel(this.c)})}getLogLevel(n){return this.b.get(n)?.logLevel}dispose(){this.b.forEach(({logger:n})=>n.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=p;class b{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(n){}getLevel(){return L.Info}trace(n,...r){}debug(n,...r){}info(n,...r){}warn(n,...r){}error(n,...r){}critical(n,...r){}dispose(){}flush(){}}e.NullLogger=b;class i extends b{}e.NullLogService=i;class s extends p{constructor(){super(L.Info,t.Event.None)}f(n,r,f){return new b}}e.NullLoggerService=s;function a(l){if(l.verbose)return L.Trace;if(typeof l.logLevel=="string"){const n=c(l.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function u(l){switch(l){case L.Trace:return"trace";case L.Debug:return"debug";case L.Info:return"info";case L.Warning:return"warn";case L.Error:return"error";case L.Off:return"off"}}e.LogLevelToString=u;function c(l){switch(l){case"trace":return L.Trace;case"debug":return L.Debug;case"info":return L.Info;case"warn":return L.Warning;case"error":return L.Error;case"critical":return L.Error;case"off":return L.Off}}e.parseLogLevel=c}),define(ye[198],Ce([1,0,38,13]),function(ne,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var k;(function(C){C[C.Trace=0]="Trace",C[C.Debug=1]="Debug",C[C.Info=2]="Info",C[C.Warning=3]="Warning",C[C.Error=4]="Error",C[C.Critical=5]="Critical",C[C.Off=6]="Off"})(k||(k={}));async function R(C,L,P,y,D){try{const v=await new Promise((m,h)=>{ne(["spdlog"],m,h)});v.setFlushOn(k.Trace);const d=await v.createAsyncRotatingLogger(C,L,P,y);return D?d.clearFormatters():d.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),d}catch(v){console.error(v)}return null}function I(C,L,P){switch(L){case t.LogLevel.Trace:C.trace(P);break;case t.LogLevel.Debug:C.debug(P);break;case t.LogLevel.Info:C.info(P);break;case t.LogLevel.Warning:C.warn(P);break;case t.LogLevel.Error:C.error(P);break;case t.LogLevel.Off:break;default:throw new Error(`Invalid log level ${L}`)}}function A(C,L){switch(L){case t.LogLevel.Trace:C.setLevel(k.Trace);break;case t.LogLevel.Debug:C.setLevel(k.Debug);break;case t.LogLevel.Info:C.setLevel(k.Info);break;case t.LogLevel.Warning:C.setLevel(k.Warning);break;case t.LogLevel.Error:C.setLevel(k.Error);break;case t.LogLevel.Off:C.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${L}`)}}class S extends t.AbstractMessageLogger{constructor(L,P,y,D,v){super(),this.k=[],this.setLevel(v),this.l=this.n(L,P,y,D),this.B(this.onDidChangeLogLevel(d=>{this.m&&A(this.m,d)}))}async n(L,P,y,D){const v=y?6:1,d=30/v*o.ByteSize.MB,m=await R(L,P,d,v,D);if(m){this.m=m,A(this.m,this.getLevel());for(const{level:h,message:w}of this.k)I(this.m,h,w);this.k=[]}}g(L,P){this.m?I(this.m,L,P):this.getLevel()<=L&&this.k.push({level:L,message:P})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=S}),define(ye[123],Ce([1,0,43,171,3]),function(ne,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(R=e.MarkerTag||(e.MarkerTag={}));var I;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(I=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function C(v,d){return d-v}S.compare=C;const L=Object.create(null);L[S.Error]=(0,t.localize)(0,null),L[S.Warning]=(0,t.localize)(1,null),L[S.Info]=(0,t.localize)(2,null);function P(v){return L[v]||""}S.toString=P;function y(v){switch(v){case o.default.Error:return S.Error;case o.default.Warning:return S.Warning;case o.default.Info:return S.Info;case o.default.Ignore:return S.Hint}}S.fromSeverity=y;function D(v){switch(v){case S.Error:return o.default.Error;case S.Warning:return o.default.Warning;case S.Info:return o.default.Info;case S.Hint:return o.default.Ignore}}S.toSeverity=D}(I=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(S){const C="";function L(y){return P(y,!0)}S.makeKey=L;function P(y,D){const v=[C];return y.source?v.push(y.source.replace("\xA6","\\\xA6")):v.push(C),y.code?typeof y.code=="string"?v.push(y.code.replace("\xA6","\\\xA6")):v.push(y.code.value.replace("\xA6","\\\xA6")):v.push(C),y.severity!==void 0&&y.severity!==null?v.push(I.toString(y.severity)):v.push(C),y.message&&D?v.push(y.message.replace("\xA6","\\\xA6")):v.push(C),y.startLineNumber!==void 0&&y.startLineNumber!==null?v.push(y.startLineNumber.toString()):v.push(C),y.startColumn!==void 0&&y.startColumn!==null?v.push(y.startColumn.toString()):v.push(C),y.endLineNumber!==void 0&&y.endLineNumber!==null?v.push(y.endLineNumber.toString()):v.push(C),y.endColumn!==void 0&&y.endColumn!==null?v.push(y.endColumn.toString()):v.push(C),v.push(C),v.join("\xA6")}S.makeKeyOptionalMessage=P})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,k.createDecorator)("markerService")}),define(ye[199],Ce([1,0,4,43,3]),function(ne,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,k.createDecorator)("notificationService");var R;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.PROFILE=1]="PROFILE",C[C.APPLICATION=2]="APPLICATION"})(R=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var I;(function(C){C[C.OFF=0]="OFF",C[C.SILENT=1]="SILENT",C[C.ERROR=2]="ERROR"})(I=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new S,this.onDidClose=o.Event.None,this.onDidChangeVisibility=o.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=A;class S{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=S}),define(ye[124],Ce([1,0,8,2,3]),function(ne,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,k.createDecorator)("openerService");function R(C,L){return t.URI.isUri(C)?(0,o.equalsIgnoreCase)(C.scheme,L):(0,o.startsWithIgnoreCase)(C,L+":")}e.matchesScheme=R;function I(C,...L){return L.some(P=>R(C,P))}e.matchesSomeScheme=I;function A(C,L){return C.with({fragment:`${L.startLineNumber},${L.startColumn}${L.endLineNumber?`-${L.endLineNumber}${L.endColumn?`,${L.endColumn}`:""}`:""}`})}e.withSelection=A;function S(C){let L;const P=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(C.fragment);return P&&(L={startLineNumber:parseInt(P[1]),startColumn:P[2]?parseInt(P[2]):1,endLineNumber:P[4]?parseInt(P[4]):void 0,endColumn:P[4]?P[5]?parseInt(P[5]):1:void 0},C=C.with({fragment:""})),{selection:L,uri:C}}e.extractSelection=S}),define(ye[200],Ce([1,0,12,36]),function(ne,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof o.globals.vscode<"u"&&typeof o.globals.vscode.context<"u"){const R=o.globals.vscode.context.configuration();if(R)k=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(k=globalThis._VSCODE_PRODUCT_JSON,t.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`,serverDataFolderName:k.serverDataFolderName?`${k.serverDataFolderName}-dev`:void 0}),!k.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(k,{version:R.version})}}else k={},Object.keys(k).length===0&&Object.assign(k,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=k}),define(ye[201],Ce([1,0,3]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,o.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var He=this&&this.__param||function(ne,e){return function(o,t){e(o,t,ne)}};define(ye[125],Ce([1,0,16,21,6,3]),function(ne,e,o,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,R.createDecorator)("progressService");var I;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(I=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{get value(){return this.a}constructor(P){this.b=P}report(P){this.a=P,this.b(this.a)}}e.Progress=A,A.None=Object.freeze({report(){}});let S=class extends k.Disposable{constructor(P,y){super(),this.a=new o.DeferredPromise,y.withProgress(P,D=>(this.b=D,this.c&&D.report(this.c),this.a.p)),this.B((0,k.toDisposable)(()=>this.a.complete()))}report(P){this.b?this.b.report(P):this.c=P}};S=qe([He(1,e.IProgressService)],S),e.UnmanagedProgress=S;class C extends k.Disposable{constructor(P){super(),this.g=P,this.a=0,this.b=this.B(new k.DisposableStore)}start(P){this.stop();const y=++this.a,D=new t.CancellationTokenSource;return this.f=setTimeout(()=>{y===this.a&&(this.c=this.g.show(!0))},P),this.b.add((0,k.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,k.toDisposable)(()=>D.cancel())),this.b.add((0,k.toDisposable)(()=>this.c?this.c.done():void 0)),{id:y,token:D.token,stop:()=>this.h(y),isCurrent:()=>this.a===y}}stop(){this.h(this.a)}h(P){this.a===P&&this.b.clear()}}e.LongRunningOperation=C,e.IEditorProgressService=(0,R.createDecorator)("editorProgressService")}),define(ye[44],Ce([1,0,49,11]),function(ne,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.a=new Map}add(I,A){o.ok(t.isString(I)),o.ok(t.isObject(A)),o.ok(!this.a.has(I),"There is already an extension with this id"),this.a.set(I,A)}knows(I){return this.a.has(I)}as(I){return this.a.get(I)||null}}e.Registry=new k}),define(ye[126],Ce([1,0,4,44]),function(ne,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class R{constructor(){this.b=new o.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,C){this.a[k(S)]=C,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const I=new R;t.Registry.add(e.Extensions.JSONContribution,I)}),define(ye[127],Ce([1,0,18,4,11,166,52,126,44]),function(ne,e,o,t,k,R,I,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=S.Registry.as(A.Extensions.JSONContribution);class y{constructor(){this.h=new Set,this.i=new t.Emitter,this.onDidSchemaChange=this.i.event,this.j=new t.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.r()}registerConfiguration(i,s=!0){this.registerConfigurations([i],s)}registerConfigurations(i,s=!0){const a=this.k(i,s);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(i){const s=this.l(i);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:i,remove:s}){const a=[];a.push(...this.l(s)),a.push(...this.k(i,!1)),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:(0,o.distinct)(a)})}registerDefaultConfigurations(i){const s=[],a=[];for(const{overrides:u,source:c}of i)for(const l in u)if(s.push(l),e.OVERRIDE_PROPERTY_REGEX.test(l)){const n=this.a.get(l),r=n?.valuesSources??new Map;if(c)for(const M of Object.keys(u[l]))r.set(M,c);const f={...n?.value||{},...u[l]};this.a.set(l,{source:c,value:f,valuesSources:r});const E=(0,I.getLanguageTagSettingPlainKey)(l),T={type:"object",default:f,description:R.localize(1,null,E),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:f,source:k.isString(c)?void 0:c,defaultValueSource:c};a.push(...d(l)),this.d[l]=T,this.b.properties[l]=T}else{this.a.set(l,{value:u[l],source:c});const n=this.d[l];n&&(this.s(l,n),this.o(l,n))}this.registerOverrideIdentifiers(a),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const s=[];for(const{overrides:a,source:u}of i)for(const c in a){const l=this.a.get(c),n=k.isString(u)?u:u?.id,r=k.isString(l?.source)?l?.source:l?.source?.id;if(n===r)if(s.push(c),this.a.delete(c),e.OVERRIDE_PROPERTY_REGEX.test(c))delete this.d[c],delete this.b.properties[c];else{const f=this.d[c];f&&(this.s(c,f),this.o(c,f))}}this.q(),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){for(const s of i)this.h.add(s);this.q()}k(i,s){const a=[];return i.forEach(u=>{a.push(...this.m(u,s,u.extensionInfo,u.restrictedProperties)),this.c.push(u),this.n(u)}),a}l(i){const s=[],a=u=>{if(u.properties)for(const c in u.properties){s.push(c);const l=this.d[c];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[c],this.p(c,u.properties[c])}u.allOf?.forEach(c=>a(c))};for(const u of i){a(u);const c=this.c.indexOf(u);c!==-1&&this.c.splice(c,1)}return s}m(i,s=!0,a,u,c=3){c=k.isUndefinedOrNull(i.scope)?c:i.scope;const l=[],n=i.properties;if(n)for(const f in n){const E=n[f];if(s&&g(f,E)){delete n[f];continue}if(E.source=a,E.defaultDefaultValue=n[f].default,this.s(f,E),e.OVERRIDE_PROPERTY_REGEX.test(f)?E.scope=void 0:(E.scope=k.isUndefinedOrNull(E.scope)?c:E.scope,E.restricted=k.isUndefinedOrNull(E.restricted)?!!u?.includes(f):E.restricted),n[f].hasOwnProperty("included")&&!n[f].included){this.f[f]=n[f],delete n[f];continue}else this.d[f]=n[f],n[f].policy?.name&&this.e.set(n[f].policy.name,f);!n[f].deprecationMessage&&n[f].markdownDeprecationMessage&&(n[f].deprecationMessage=n[f].markdownDeprecationMessage),l.push(f)}const r=i.allOf;if(r)for(const f of r)l.push(...this.m(f,s,a,u,c));return l}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}n(i){const s=a=>{const u=a.properties;if(u)for(const l in u)this.o(l,u[l]);a.allOf?.forEach(s)};s(i)}o(i,s){switch(e.allSettings.properties[i]=s,s.scope){case 1:e.applicationSettings.properties[i]=s;break;case 2:e.machineSettings.properties[i]=s;break;case 6:e.machineOverridableSettings.properties[i]=s;break;case 3:e.windowSettings.properties[i]=s;break;case 4:e.resourceSettings.properties[i]=s;break;case 5:e.resourceSettings.properties[i]=s,this.g.properties[i]=s;break}}p(i,s){switch(delete e.allSettings.properties[i],s.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}q(){for(const i of this.h.values()){const s=`[${i}]`,a={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.s(s,a),e.allSettings.properties[s]=a,e.applicationSettings.properties[s]=a,e.machineSettings.properties[s]=a,e.machineOverridableSettings.properties[s]=a,e.windowSettings.properties[s]=a,e.resourceSettings.properties[s]=a}this.i.fire()}r(){const i={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}s(i,s){const a=this.a.get(i);let u=a?.value,c=a?.source;k.isUndefined(u)&&(u=s.defaultDefaultValue,c=void 0),k.isUndefined(u)&&(u=h(s.type)),s.default=u,s.defaultValueSource=c}}const D="\\[([^\\]]+)\\]",v=new RegExp(D,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${D})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function d(b){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(b)){let s=v.exec(b);for(;s?.length;){const a=s[1].trim();a&&i.push(a),s=v.exec(b)}}return(0,o.distinct)(i)}e.overrideIdentifiersFromKey=d;function m(b){return b.reduce((i,s)=>`${i}[${s}]`,"")}e.keyFromOverrideIdentifiers=m;function h(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const w=new y;S.Registry.add(e.Extensions.Configuration,w);function g(b,i){return b.trim()?e.OVERRIDE_PROPERTY_REGEX.test(b)?R.localize(7,null,b):w.getConfigurationProperties()[b]!==void 0?R.localize(8,null,b):i.policy?.name&&w.getPolicyConfigurations().get(i.policy?.name)!==void 0?R.localize(9,null,b,i.policy?.name,w.getPolicyConfigurations().get(i.policy?.name)):null:R.localize(6,null)}e.validateProperty=g;function p(){const b=[],i=w.getConfigurationProperties();for(const s of Object.keys(i))b.push([s,i[s].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=p}),define(ye[202],Ce([1,0,18,4,146,6,28,23,11,2,52,127,44]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class D{constructor(s={},a=[],u=[],c){this.c=s,this.d=a,this.f=u,this.raw=c,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const s=this.raw.map(a=>{if(a instanceof D)return a;const u=new v("");return u.parseRaw(a),u.configurationModel});this.g=s.reduce((a,u)=>u===a?u:a.merge(u),s[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(s){return s?(0,L.getConfigurationValue)(this.contents,s):this.contents}inspect(s,a){const u=this.rawConfiguration.getValue(s),c=a?this.rawConfiguration.getOverrideValue(s,a):void 0,l=a?this.rawConfiguration.override(a).getValue(s):u;return{value:u,override:c,merged:l}}getOverrideValue(s,a){const u=this.l(a);return u?s?(0,L.getConfigurationValue)(u,s):u:void 0}getKeysForOverrideIdentifier(s){const a=[];for(const u of this.overrides)u.identifiers.includes(s)&&a.push(...u.keys);return o.distinct(a)}getAllOverrideIdentifiers(){const s=[];for(const a of this.overrides)s.push(...a.identifiers);return o.distinct(s)}override(s){let a=this.b.get(s);return a||(a=this.h(s),this.b.set(s,a)),a}merge(...s){const a=A.deepClone(this.contents),u=A.deepClone(this.overrides),c=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const n of s)if(l.push(...n.raw?.length?n.raw:[n]),!n.isEmpty()){this.j(a,n.contents);for(const r of n.overrides){const[f]=u.filter(E=>o.equals(E.identifiers,r.identifiers));f?(this.j(f.contents,r.contents),f.keys.push(...r.keys),f.keys=o.distinct(f.keys)):u.push(A.deepClone(r))}for(const r of n.keys)c.indexOf(r)===-1&&c.push(r)}return new D(a,c,u,l.every(n=>n instanceof D)?void 0:l)}freeze(){return this.a=!0,this}clone(){return new D(A.deepClone(this.contents),[...this.keys],A.deepClone(this.overrides))}h(s){const a=this.l(s);if(!a||typeof a!="object"||!Object.keys(a).length)return this;const u={};for(const c of o.distinct([...Object.keys(this.contents),...Object.keys(a)])){let l=this.contents[c];const n=a[c];n&&(typeof l=="object"&&typeof n=="object"?(l=A.deepClone(l),this.j(l,n)):l=n),u[c]=l}return new D(u,this.keys,this.overrides)}j(s,a){for(const u of Object.keys(a)){if(u in s&&S.isObject(s[u])&&S.isObject(a[u])){this.j(s[u],a[u]);continue}s[u]=A.deepClone(a[u])}}k(s){return this.a&&!Object.isFrozen(s)?A.deepFreeze(s):s}l(s){let a=null,u=null;const c=l=>{l&&(u?this.j(u,l):u=A.deepClone(l))};for(const l of this.overrides)o.equals(l.identifiers,[s])?a=l.contents:l.identifiers.includes(s)&&c(l.contents);return c(a),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(s,a){this.m(s),(0,L.addToValueTree)(this.contents,s,a,u=>{throw new Error(u)})}removeValue(s){this.n(s)&&(0,L.removeFromValueTree)(this.contents,s)}m(s){let a=this.keys.length;for(let u=0;u<a;u++)s.indexOf(this.keys[u])===0&&(a=u);this.keys.splice(a,1,s)}n(s){const a=this.keys.indexOf(s);return a!==-1?(this.keys.splice(a,1),!0):!1}}e.ConfigurationModel=D;class v{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new D}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,a){if(!S.isUndefinedOrNull(s)){const u=this.g(s);this.parseRaw(u,a)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,a){this.a=s;const{contents:u,keys:c,overrides:l,restricted:n,hasExcludedProperties:r}=this.h(s,a);this.b=new D(u,c,l,r?[s]:void 0),this.c=n||[]}g(s){let a={},u=null,c=[];const l=[],n=[];function r(E){Array.isArray(c)?c.push(E):u!==null&&(c[u]=E)}const f={onObjectBegin:()=>{const E={};r(E),l.push(c),c=E,u=null},onObjectProperty:E=>{u=E},onObjectEnd:()=>{c=l.pop()},onArrayBegin:()=>{const E=[];r(E),l.push(c),c=E,u=null},onArrayEnd:()=>{c=l.pop()},onLiteralValue:r,onError:(E,T,M)=>{n.push({error:E,offset:T,length:M})}};if(s)try{k.visit(s,f),a=c[0]||{}}catch(E){console.error(`Error while parsing settings file ${this.f}: ${E}`),this.d=[E]}return a}h(s,a){const u=y.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),c=this.j(s,u,!0,a);s=c.raw;const l=(0,L.toValuesTree)(s,f=>console.error(`Conflict in settings file ${this.f}: ${f}`)),n=Object.keys(s),r=this.l(s,f=>console.error(`Conflict in settings file ${this.f}: ${f}`));return{contents:l,keys:n,overrides:r,restricted:c.restricted,hasExcludedProperties:c.hasExcludedProperties}}j(s,a,u,c){let l=!1;if(!c?.scopes&&!c?.skipRestricted)return{raw:s,restricted:[],hasExcludedProperties:l};const n={},r=[];for(const f in s)if(P.OVERRIDE_PROPERTY_REGEX.test(f)&&u){const E=this.j(s[f],a,!1,c);n[f]=E.raw,l=l||E.hasExcludedProperties,r.push(...E.restricted)}else{const E=a[f],T=E?typeof E.scope<"u"?E.scope:3:void 0;E?.restricted&&r.push(f),(T===void 0||c.scopes===void 0||c.scopes.includes(T))&&!(c.skipRestricted&&E?.restricted)?n[f]=s[f]:l=!0}return{raw:n,restricted:r,hasExcludedProperties:l}}l(s,a){const u=[];for(const c of Object.keys(s))if(P.OVERRIDE_PROPERTY_REGEX.test(c)){const l={};for(const n in s[c])l[n]=s[c][n];u.push({identifiers:(0,P.overrideIdentifiersFromKey)(c),keys:Object.keys(l),contents:(0,L.toValuesTree)(l,a)})}return u}}e.ConfigurationModelParser=v;class d extends R.Disposable{constructor(s,a,u,c){super(),this.f=s,this.g=a,this.h=c,this.c=this.B(new t.Emitter),this.onDidChange=this.c.event,this.a=new v(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(u.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(t.Event.any(t.Event.filter(this.h.onDidFilesChange,l=>l.contains(this.f)),t.Event.filter(this.h.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&u.isEqual(l.resource,s)))(()=>this.c.fire()))}async loadConfiguration(){try{const s=await this.h.readFile(this.f);return this.a.parse(s.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new D}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=d;class m{constructor(s,a,u,c,l,n,r,f,E,T,M,G,V){this.a=s,this.b=a,this.value=u,this.overrideIdentifiers=c,this.c=l,this.d=n,this.f=r,this.g=f,this.h=E,this.j=T,this.k=M,this.l=G,this.m=V}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class h{constructor(s,a,u,c,l=new D,n=new D,r=new I.ResourceMap,f=new D,E=new I.ResourceMap,T=!0){this.c=s,this.d=a,this.f=u,this.g=c,this.h=l,this.j=n,this.l=r,this.m=f,this.n=E,this.p=T,this.a=null,this.b=new I.ResourceMap,this.q=null}getValue(s,a,u){return this.s(s,a,u).getValue(s)}updateValue(s,a,u={}){let c;u.resource?(c=this.n.get(u.resource),c||(c=new D,this.n.set(u.resource,c))):c=this.m,a===void 0?c.removeValue(s):c.setValue(s,a),u.resource||(this.a=null)}inspect(s,a,u){const c=this.s(s,a,u),l=this.w(a.resource,u),n=a.resource?this.n.get(a.resource)||this.m:this.m,r=new Set;for(const f of c.overrides)for(const E of f.identifiers)c.getOverrideValue(s,E)!==void 0&&r.add(E);return new m(s,a,c.getValue(s),r.size?[...r]:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),u?this.j.freeze():void 0,l?l.freeze():void 0,n.inspect(s,a.overrideIdentifier))}keys(s){const a=this.w(void 0,s);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:a?a.freeze().keys:[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.j=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,a){this.l.set(s,a),this.b.delete(s)}deleteFolderConfiguration(s){this.r.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,a){const u=[];if(!a){const{added:c,updated:l,removed:n}=p(this.c,s);a=[...c,...l,...n]}for(const c of a)for(const l of(0,P.overrideIdentifiersFromKey)(c)){const n=this.c.getKeysForOverrideIdentifier(l),r=s.getKeysForOverrideIdentifier(l),f=[...r.filter(E=>n.indexOf(E)===-1),...n.filter(E=>r.indexOf(E)===-1),...n.filter(E=>!A.equals(this.c.override(l).getValue(E),s.override(l).getValue(E)))];u.push([l,f])}return this.updateDefaultConfiguration(s),{keys:a,overrides:u}}compareAndUpdatePolicyConfiguration(s){const{added:a,updated:u,removed:c}=p(this.d,s),l=[...a,...u,...c];return l.length&&this.updatePolicyConfiguration(s),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:a,updated:u,removed:c,overrides:l}=p(this.applicationConfiguration,s),n=[...a,...u,...c];return n.length&&this.updateApplicationConfiguration(s),{keys:n,overrides:l}}compareAndUpdateLocalUserConfiguration(s){const{added:a,updated:u,removed:c,overrides:l}=p(this.localUserConfiguration,s),n=[...a,...u,...c];return n.length&&this.updateLocalUserConfiguration(s),{keys:n,overrides:l}}compareAndUpdateRemoteUserConfiguration(s){const{added:a,updated:u,removed:c,overrides:l}=p(this.remoteUserConfiguration,s),n=[...a,...u,...c];return n.length&&this.updateRemoteUserConfiguration(s),{keys:n,overrides:l}}compareAndUpdateWorkspaceConfiguration(s){const{added:a,updated:u,removed:c,overrides:l}=p(this.workspaceConfiguration,s),n=[...a,...u,...c];return n.length&&this.updateWorkspaceConfiguration(s),{keys:n,overrides:l}}compareAndUpdateFolderConfiguration(s,a){const u=this.r.get(s),{added:c,updated:l,removed:n,overrides:r}=p(u,a),f=[...c,...l,...n];return(f.length||!u)&&this.updateFolderConfiguration(s,a),{keys:f,overrides:r}}compareAndDeleteFolderConfiguration(s){const a=this.r.get(s);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:u,updated:c,removed:l,overrides:n}=p(a,void 0);return{keys:[...u,...c,...l],overrides:n}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(s,a,u){let c=this.t(a,u);return a.overrideIdentifier&&(c=c.override(a.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(c=c.merge(this.d)),c}t({resource:s},a){let u=this.u();if(a&&s){const c=a.getFolder(s);c&&(u=this.v(c.uri)||u);const l=this.n.get(s);l&&(u=u.merge(l))}return u}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(s){let a=this.b.get(s);if(!a){const u=this.u(),c=this.l.get(s);c?(a=u.merge(c),this.p&&(a=a.freeze()),this.b.set(s,a)):a=u}return a}w(s,a){if(a&&s){const u=a.getFolder(s);if(u)return this.l.get(u.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((s,a)=>{const{contents:u,overrides:c,keys:l}=this.l.get(a);return s.push([a,{contents:u,overrides:c,keys:l}]),s},[])}}allKeys(){const s=new Set;return this.c.freeze().keys.forEach(a=>s.add(a)),this.userConfiguration.freeze().keys.forEach(a=>s.add(a)),this.j.freeze().keys.forEach(a=>s.add(a)),this.l.forEach(a=>a.freeze().keys.forEach(u=>s.add(u))),[...s.values()]}x(){const s=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.j.freeze().getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.l.forEach(a=>a.freeze().getAllOverrideIdentifiers().forEach(u=>s.add(u))),[...s.values()]}y(s){const a=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(u=>a.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(u=>a.add(u)),this.j.getKeysForOverrideIdentifier(s).forEach(u=>a.add(u)),this.l.forEach(u=>u.getKeysForOverrideIdentifier(s).forEach(c=>a.add(c))),[...a.values()]}static parse(s){const a=this.z(s.defaults),u=this.z(s.policy),c=this.z(s.application),l=this.z(s.user),n=this.z(s.workspace),r=s.folders.reduce((f,E)=>(f.set(C.URI.revive(E[0]),this.z(E[1])),f),new I.ResourceMap);return new h(a,u,c,l,new D,n,r,new D,new I.ResourceMap,!1)}static z(s){return new D(s.contents,s.keys,s.overrides).freeze()}}e.Configuration=h;function w(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const s=new Set,a=new Map;for(const c of i)c.keys.forEach(l=>s.add(l)),c.overrides.forEach(([l,n])=>{const r=(0,I.getOrSet)(a,l,new Set);n.forEach(f=>r.add(f))});const u=[];return a.forEach((c,l)=>u.push([l,[...c.values()]])),{keys:[...s.values()],overrides:u}}e.mergeChanges=w;class g{constructor(s,a,u,c){this.change=s,this.b=a,this.c=u,this.d=c,this.f=void 0;const l=new Set;s.keys.forEach(r=>l.add(r)),s.overrides.forEach(([,r])=>r.forEach(f=>l.add(f))),this.affectedKeys=[...l.values()];const n=new D;this.affectedKeys.forEach(r=>n.setValue(r,{})),this.a=n.contents}get previousConfiguration(){return!this.f&&this.b&&(this.f=h.parse(this.b.data)),this.f}affectsConfiguration(s,a){if(this.g(this.a,s)){if(a){const u=this.previousConfiguration?this.previousConfiguration.getValue(s,a,this.b?.workspace):void 0,c=this.c.getValue(s,a,this.d);return!A.equals(u,c)}return!0}return!1}g(s,a){let u=(0,L.toValuesTree)({[a]:!0},()=>{}),c;for(;typeof u=="object"&&(c=Object.keys(u)[0]);){if(s=s[c],!s)return!1;u=u[c]}return!0}}e.ConfigurationChangeEvent=g;function p(i,s){const{added:a,removed:u,updated:c}=b(s?.rawConfiguration,i?.rawConfiguration),l=[],n=i?.getAllOverrideIdentifiers()||[],r=s?.getAllOverrideIdentifiers()||[];if(s){const f=r.filter(E=>!n.includes(E));for(const E of f)l.push([E,s.getKeysForOverrideIdentifier(E)])}if(i){const f=n.filter(E=>!r.includes(E));for(const E of f)l.push([E,i.getKeysForOverrideIdentifier(E)])}if(s&&i){for(const f of n)if(r.includes(f)){const E=b({contents:i.getOverrideValue(void 0,f)||{},keys:i.getKeysForOverrideIdentifier(f)},{contents:s.getOverrideValue(void 0,f)||{},keys:s.getKeysForOverrideIdentifier(f)});l.push([f,[...E.added,...E.removed,...E.updated]])}}return{added:a,removed:u,updated:c,overrides:l}}function b(i,s){const a=i?s?i.keys.filter(l=>s.keys.indexOf(l)===-1):[...i.keys]:[],u=s?i?s.keys.filter(l=>i.keys.indexOf(l)===-1):[...s.keys]:[],c=[];if(i&&s){for(const l of s.keys)if(i.keys.indexOf(l)!==-1){const n=(0,L.getConfigurationValue)(s.contents,l),r=(0,L.getConfigurationValue)(i.contents,l);A.equals(n,r)||c.push(l)}}return{added:a,removed:u,updated:c}}}),define(ye[128],Ce([1,0,10,3]),function(ne,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var k;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends o.ErrorNoTelemetry{static isNotAvailable(A){return A instanceof R&&A._code===k.NotAvailable}static isTemporarilyNotAvailable(A){return A instanceof R&&A._code===k.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof R&&A._code===k.NoResolverFound}static isHandled(A){return A instanceof R&&A.isHandled}constructor(A,S=k.Unknown,C){super(A),this._message=A,this._code=S,this._detail=C,this.isHandled=S===k.NotAvailable&&C===!0,Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R}),define(ye[67],Ce([1,0,15]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(C){return C.scheme===o.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=t;function k(C){if(!C)return;const L=C.indexOf("+");return L<0?C:C.substr(0,L)}e.getRemoteName=k;function R(C){return`/${C.quality??"oss"}-${C.commit??"dev"}`}e.getRemoteServerRootPath=R;function I(C){const{host:L,port:P}=S(C);if(typeof P>"u")throw new Error("Remote authority doesn't contain a port!");return{host:L,port:P}}e.parseAuthorityWithPort=I;function A(C,L){let{host:P,port:y}=S(C);return typeof y>"u"&&(y=L),{host:P,port:y}}e.parseAuthorityWithOptionalPort=A;function S(C){const L=C.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const P=C.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const y=C.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:C,port:void 0}}}),define(ye[26],Ce([1,0,8,3,67]),function(ne,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.getWorkspaceSupportTypeMessage=R;function I(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}e.isIExtensionIdentifier=I,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));var S;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(S=e.TargetPlatform||(e.TargetPlatform={}));class C{constructor(d){this.value=d,this.c=d.toLowerCase()}static equals(d,m){if(typeof d>"u"||d===null)return typeof m>"u"||m===null;if(typeof m>"u"||m===null)return!1;if(typeof d=="string"||typeof m=="string"){const h=typeof d=="string"?d:d.value,w=typeof m=="string"?m:m.value;return o.equalsIgnoreCase(h,w)}return d.c===m.c}static toKey(d){return typeof d=="string"?d.toLowerCase():d.c}}e.ExtensionIdentifier=C;function L(v){return P(v)}e.isApplicationScopedExtension=L;function P(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function y(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=y;function D(v,d){if(d){const m=`onResolveRemoteAuthority:${(0,k.getRemoteName)(d)}`;return v.activationEvents?.indexOf(m)!==-1}return!1}e.isResolverExtension=D,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ye[203],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class o{constructor(){this.b=new Map}c(){return new Promise((k,R)=>ne(["vsda"],k,R))}async createNewMessage(k){try{const R=await this.c(),I=new R.validator;if(I){const A=String(o.a++);return this.b.set(A,I),{id:A,data:I.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,R){if(!k.id)return!0;const I=this.b.get(k.id);if(!I)return!1;this.b.delete(k.id);try{return I.validate(R)==="ok"}catch{return!1}}async sign(k){try{const R=await this.c(),I=new R.signer;if(I)return I.sign(k)}catch{}return k}}e.SignService=o,o.a=1}),define(ye[204],Ce([1,0,12,36,2,30]),function(ne,e,o,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function I(C){if(o.platform===2&&/^penguin(\.|$)/i.test(C))return"chromebook"}async function A(C,L,P,y,D,v,d,m,h,w){const g=Object.create(null);g["common.machineId"]=d,g.sessionID=(0,R.generateUuid)()+Date.now(),g.commitHash=D,g.version=v,g["common.platformVersion"]=(L||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,o.PlatformToString)(o.platform),g["common.nodePlatform"]=t.platform,g["common.nodeArch"]=y,g["common.product"]=w||"desktop",m&&(g["common.msftInternal"]=m);let p=0;const b=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-b,enumerable:!0},"common.sequence":{get:()=>p++,enumerable:!0}}),o.isLinuxSnap&&(g["common.snap"]="true");const i=I(P);i&&(g["common.platformDetail"]=i);try{const s=await C.readFile(k.URI.file(h));g["common.source"]=s.value.toString().slice(0,30)}catch{}return g}e.resolveCommonProperties=A;function S(C){const L=t.env.USERDNSDOMAIN;if(!L)return!1;const P=L.toLowerCase();return C.some(y=>P===y)}e.verifyMicrosoftInternalDomain=S}),define(ye[205],Ce([1,0,3]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,o.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,o.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ye[68],Ce([1,0,23,11,52,67,204,205]),function(ne,e,o,t,k,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class S{constructor(l){this.value=l}}e.TrustedTelemetryValue=S;class C{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(l,n){return Promise.resolve(void 0)}publicLog2(l,n){return this.publicLog(l,n)}publicLogError(l,n){return Promise.resolve(void 0)}publicLogError2(l,n){return this.publicLogError(l,n)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=C,e.NullTelemetryService=new C;class L{async publicLog(l,n,r){}async publicLogError(l,n,r){}}e.NullEndpointTelemetryService=L,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function P(c,l){return l.onDidChangeConfiguration(n=>{n.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(n.source),configurationKeys:g(n.sourceConfig)})})}e.configurationTelemetry=P;function y(c,l){return!l.isBuilt&&!l.disableTelemetry?!0:!(l.disableTelemetry||!c.enableTelemetry||l.extensionTestsLocationURI)}e.supportsTelemetry=y;function D(c,l){return!(l.isBuilt||l.disableTelemetry||c.enableTelemetry&&c.aiConfig?.ariaKey)}e.isLoggingOnly=D;function v(c){const l=c.getValue(A.TELEMETRY_SETTING_ID),n=c.getValue("telemetry.enableCrashReporter");if(c.getValue(A.TELEMETRY_OLD_SETTING_ID)===!1||n===!1)return 0;switch(l??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=v;function d(c){const l={},n={},r={};w(c,r);for(let f in r){f=f.length>150?f.substr(f.length-149):f;const E=r[f];typeof E=="number"?n[f]=E:typeof E=="boolean"?n[f]=E?1:0:typeof E=="string"?(E.length>8192&&console.warn(`Telemetry property: ${f} has been trimmed to 8192, the original length is ${E.length}`),l[f]=E.substring(0,8191)):typeof E<"u"&&E!==null&&(l[f]=E)}return{properties:l,measurements:n}}e.validateTelemetryData=d;const m=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function h(c){if(!c)return"none";const l=(0,R.getRemoteName)(c);return m.has(l)?l:"other"}e.cleanRemoteAuthority=h;function w(c,l,n=0,r){if(!!c)for(const f of Object.getOwnPropertyNames(c)){const E=c[f],T=r?r+f:f;Array.isArray(E)?l[T]=(0,o.safeStringify)(E):E instanceof Date?l[T]=E.toISOString():(0,t.isObject)(E)?n<2?w(E,l,n+1,T+"."):l[T]=(0,o.safeStringify)(E):l[T]=E}}function g(c){if(!c)return[];const l=[];return p(l,"",c),l}function p(c,l,n){n&&typeof n=="object"&&!Array.isArray(n)?Object.keys(n).forEach(r=>p(c,l?`${l}.${r}`:r,n[r])):c.push(l)}function b(c,l){const n=c.msftInternalDomains||[],r=l.getValue("telemetry.internalTesting");return(0,I.verifyMicrosoftInternalDomain)(n)||r}e.isInternalTelemetry=b;function i(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.getPiiPathsFromEnvironment=i;function s(c,l){if(!c||!c.includes("/")&&!c.includes("\\"))return c;let n=c;const r=[];for(const M of l)for(;;){const G=M.exec(c);if(!G)break;r.push([G.index,M.lastIndex])}const f=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,E=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let T=0;for(n="";;){const M=E.exec(c);if(!M)break;const G=r.some(([V,N])=>M.index<N&&V<E.lastIndex);!f.test(M[0])&&!G&&(n+=c.substring(T,M.index)+"<REDACTED: user-file-path>",T=E.lastIndex)}return T<c.length&&(n+=c.substr(T)),n}function a(c){if(!c)return c;const l=c.toLowerCase(),n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of n)if(r.regex.test(l))return`<REDACTED: ${r.label}>`;return c}function u(c,l){return(0,o.cloneAndChange)(c,n=>{if(n instanceof S)return n.value;if(typeof n=="string"){let r=n.replaceAll("%20"," ");r=s(r,l);for(const f of l)r=r.replace(f,"");return r=a(r),r}})}e.cleanData=u}),define(ye[206],Ce([1,0,8,122,26,12,2,10,36,68]),function(ne,e,o,t,k,R,I,A,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function L(a,u){return a.uuid&&u.uuid?a.uuid===u.uuid:a.id===u.id?!0:(0,o.compareIgnoreCase)(a.id,u.id)===0}e.areSameExtensions=L;const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(u){const c=u.manifest?u.manifest.version:u.version,l=u.manifest?u.targetPlatform:u.properties.targetPlatform;return new y(u.identifier,c,l)}static parse(u){const c=P.exec(u);return c&&c[1]&&c[2]?new y({id:c[1]},c[2],c[4]||void 0):null}constructor(u,c,l="undefined"){this.version=c,this.targetPlatform=l,this.id=u.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(u){return u instanceof y?L(this,u)&&this.version===u.version&&this.targetPlatform===u.targetPlatform:!1}}e.ExtensionKey=y;const D=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(a){const u=D.exec(a);return u&&u[1]?[m(u[1]),u[2]]:[m(a),void 0]}e.getIdAndVersion=v;function d(a,u){return`${a}.${u}`}e.getExtensionId=d;function m(a){return a.toLocaleLowerCase()}e.adoptToGalleryExtensionId=m;function h(a,u){return m(d(a,u))}e.getGalleryExtensionId=h;function w(a,u){const c=[],l=n=>{for(const r of c)if(r.some(f=>L(u(f),u(n))))return r;return null};for(const n of a){const r=l(n);r?r.push(n):c.push([n])}return c}e.groupByExtension=w;function g(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function p(a){return{id:new C.TrustedTelemetryValue(a.identifier.id),name:new C.TrustedTelemetryValue(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.getGalleryExtensionTelemetryData=p,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function b(a,u){const c=[],l=u.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const n=l.shift();if(n&&c.every(r=>!L(r.identifier,{id:n}))){const r=a.filter(f=>L(f.identifier,{id:n}));r.length===1&&(c.push(r[0]),l.push(...r[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}e.getExtensionDependencies=b;async function i(a,u){if(!R.isLinux)return!1;let c;try{c=(await a.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await a.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(n){u.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(n))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=i;async function s(a,u){const c=await i(a,u),l=(0,t.getTargetPlatform)(c?"alpine":R.platform,S.arch);return u.debug("ComputeTargetPlatform:",l),l}e.computeTargetPlatform=s}),define(ye[207],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class o{constructor(k){this.b=k,this.a=new Map}dispose(){for(const k of this.a.values())k.dispose()}startBuffering(k,R,I=5){const A=R(S=>{const C=typeof S=="string"?S:S.data;let L=this.a.get(k);if(L){L.data.push(C);return}const P=setTimeout(()=>this.flushBuffer(k),I);L={data:[C],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(k),A.dispose()}},this.a.set(k,L)});return A}stopBuffering(k){this.a.get(k)?.dispose()}flushBuffer(k){const R=this.a.get(k);R&&(this.a.delete(k),this.b(k,R.data.join("")))}}e.TerminalDataBufferer=o}),define(ye[208],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var o;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST_DARK="hcDark",R.HIGH_CONTRAST_LIGHT="hcLight"})(o=e.ColorScheme||(e.ColorScheme={}));function t(R){return R===o.HIGH_CONTRAST_DARK||R===o.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function k(R){return R===o.DARK||R===o.HIGH_CONTRAST_DARK}e.isDark=k}),define(ye[90],Ce([1,0,80,4,6,3,44,208]),function(ne,e,o,t,k,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var S;(function(m){function h(w){return w&&typeof w=="object"&&typeof w.id=="string"}m.isThemeColor=h})(S=e.ThemeColor||(e.ThemeColor={}));function C(m){return{id:m}}e.themeColorFromId=C;var L;(function(m){function h(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||S.isThemeColor(u.color))}m.isThemeIcon=h;const w=new RegExp(`^\\$\\((${o.CSSIcon.iconNameExpression}(?:${o.CSSIcon.iconModifierExpression})?)\\)$`);function g(u){const c=w.exec(u);if(!c)return;const[,l]=c;return{id:l}}m.fromString=g;function p(u){return{id:u}}m.fromId=p;function b(u,c){let l=u.id;const n=l.lastIndexOf("~");return n!==-1&&(l=l.substring(0,n)),c&&(l=`${l}~${c}`),{id:l}}m.modify=b;function i(u){const c=u.id.lastIndexOf("~");if(c!==-1)return u.id.substring(c+1)}m.getModifier=i;function s(u,c){return u.id===c.id&&u.color?.id===c.color?.id}m.isEqual=s;function a(u,c){return{id:u.id,color:c?C(c):void 0}}m.asThemeIcon=a,m.asClassNameArray=o.CSSIcon.asClassNameArray,m.asClassName=o.CSSIcon.asClassName,m.asCSSSelector=o.CSSIcon.asCSSSelector})(L=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=o.Codicon.file,e.FolderThemeIcon=o.Codicon.folder;function P(m){switch(m){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case A.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class y{constructor(){this.a=[],this.a=[],this.b=new t.Emitter}onColorThemeChange(h){return this.a.push(h),this.b.fire(h),(0,k.toDisposable)(()=>{const w=this.a.indexOf(h);this.a.splice(w,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const D=new y;I.Registry.add(e.Extensions.ThemingContribution,D);function v(m){return D.onColorThemeChange(m)}e.registerThemingParticipant=v;class d extends k.Disposable{constructor(h){super(),this.k=h,this.h=h.getColorTheme(),this.B(this.k.onDidColorThemeChange(w=>this.n(w)))}n(h){this.h=h,this.updateStyles()}updateStyles(){}w(h,w){let g=this.h.getColor(h);return g&&w&&(g=w(g,this.h)),g?g.toString():null}}e.Themable=d}),define(ye[129],Ce([1,0,4,52,3,13]),function(ne,e,o,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var I;(function(d){d.Http="http",d.Https="https"})(I=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function C(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const m=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(!!m)return{address:m[1],port:+m[2]}}e.extractLocalHostUriMetaDataForPortMapping=C,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(d){return e.LOCALHOST_ADDRESSES.indexOf(d)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function P(d){return e.ALL_INTERFACES_ADDRESSES.indexOf(d)>=0}e.isAllInterfaces=P;function y(d,m,h,w){if(h===1)return!1;if(h===2&&P(m)){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(w);if(g?.length===4&&parseInt(g[1])>=18)return!1}return d<1024}e.isPortPrivileged=y;class D{constructor(m,h,w){this.remoteAddress=m,this.localAddress=h,this.b=w,this.a=new o.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=D;let v=class{constructor(m,h){this.i=m,this.j=h,this.a=new o.Emitter,this.onTunnelOpened=this.a.event,this.b=new o.Emitter,this.onTunnelClosed=this.b.event,this.c=new o.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const m=this.j.getValue("remote.localPortHost");return!m||m==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(m){return this.e=m,m?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(m){this.f=m.elevation,this.g=m.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const m=[],h=Array.from(this.d.values());for(const w of h){const g=Array.from(w.values());for(const p of g){const b=await p.value;b&&m.push(b)}}return m}async dispose(){for(const m of this.d.values()){for(const{value:h}of m.values())await h.then(w=>w?.dispose());m.clear()}this.d.clear()}setEnvironmentTunnel(m,h,w,g,p){this.o(m,h,Promise.resolve({tunnelRemoteHost:m,tunnelRemotePort:h,localAddress:w,privacy:g,protocol:p,dispose:()=>Promise.resolve()}))}async getExistingTunnel(m,h){(P(m)||L(m))&&(m=e.LOCALHOST_ADDRESSES[0]);const w=this.q(m,h);if(w)return++w.refcount,w.value}openTunnel(m,h,w,g,p=!1,b,i){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${w} on local port ${g}.`),!m)return;if(h||(h="localhost"),this.e&&this.h.has(w)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.r(m,h,w,g,p,b,i);return s?s.then(a=>{if(!a){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(h,w);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const u=this.m(a);return(a.tunnelRemoteHost!==h||a.tunnelRemotePort!==w)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(u),u}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}m(m){return{tunnelRemotePort:m.tunnelRemotePort,tunnelRemoteHost:m.tunnelRemoteHost,tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress,privacy:m.privacy,protocol:m.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${m.tunnelRemoteHost}:${m.tunnelRemotePort} `);const h=this.d.get(m.tunnelRemoteHost);if(h){const w=h.get(m.tunnelRemotePort);w&&(w.refcount--,await this.n(m.tunnelRemoteHost,m.tunnelRemotePort,w))}}}}async n(m,h,w){if(w.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${m}:${h}.`);const g=w.value.then(async p=>{p&&(await p.dispose(!0),this.b.fire({host:p.tunnelRemoteHost,port:p.tunnelRemotePort}))});return this.d.has(m)&&this.d.get(m).delete(h),g}}async closeTunnel(m,h){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${m}:${h} `);const w=this.d.get(m);if(w&&w.has(h)){const g=w.get(h);g.refcount=0,await this.n(m,h,g)}}o(m,h,w){this.d.has(m)||this.d.set(m,new Map),this.d.get(m).set(h,{refcount:1,value:w})}async p(m,h){const w=this.d.get(m);w&&(await w.get(h)||w.delete(h),w.size===0&&this.d.delete(m))}q(m,h){const w=[m];L(m)?(w.push(...e.LOCALHOST_ADDRESSES),w.push(...e.ALL_INTERFACES_ADDRESSES)):P(m)&&w.push(...e.ALL_INTERFACES_ADDRESSES);const g=w.map(p=>this.d.get(p));for(const p of g){const b=p?.get(h);if(b)return b}}canTunnel(m){return!!C(m)}s(m,h,w,g,p,b,i){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${w} on local port ${g}.`);const s=w;this.h.add(s);const a=g===void 0?w:g,u={elevationRequired:p?this.isPortPrivileged(a):!1},c={remoteAddress:{host:h,port:w},localAddressPort:g,privacy:b,public:b?b!==A.Private:void 0,protocol:i},l=m.forwardPort(c,u);return l?(this.o(h,w,l),l.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(s)})):this.h.delete(s),l}};v=qe([He(0,R.ILogService),He(1,t.IConfigurationService)],v),e.AbstractTunnelService=v}),define(ye[209],Ce([1,0,3]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,o.createDecorator)("editSessionIdentityService");var t;(function(k){k[k.Complete=100]="Complete",k[k.Partial=50]="Partial",k[k.None=0]="None"})(t=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(ye[210],Ce([1,0,15]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function t(S){return S.scheme!==o.Schemas.file&&S.scheme!==o.Schemas.vscodeRemote}e.isVirtualResource=t;function k(S){if(S.folders.length)return S.folders.every(C=>t(C.uri))?S.folders[0].uri:void 0;if(S.configuration&&t(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=k;function R(S){return k(S)?.scheme}e.getVirtualWorkspaceScheme=R;function I(S){return k(S)?.authority}e.getVirtualWorkspaceAuthority=I;function A(S){return k(S)!==void 0}e.isVirtualWorkspace=A}),define(ye[46],Ce([1,0,172,9,64,24,2,3,15]),function(ne,e,o,t,k,R,I,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function C(a){const u=a;return typeof u?.id=="string"&&I.URI.isUri(u.uri)}e.isSingleFolderWorkspaceIdentifier=C;function L(a){return typeof a?.id=="string"&&!C(a)&&!y(a)}e.isEmptyWorkspaceIdentifier=L,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function P(a,u){if(typeof a=="string"||typeof a>"u")return typeof a=="string"?{id:(0,t.basename)(a)}:u?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const c=a;return c.configuration?{id:c.id,configPath:c.configuration}:c.folders.length===1?{id:c.id,uri:c.folders[0].uri}:{id:c.id}}e.toWorkspaceIdentifier=P;function y(a){const u=a;return typeof u?.id=="string"&&I.URI.isUri(u.configPath)}e.isWorkspaceIdentifier=y;function D(a){const u=a;if(u?.uri)return{id:u.id,uri:I.URI.revive(u.uri)};const c=a;if(c?.configPath)return{id:c.id,configPath:I.URI.revive(c.configPath)};if(a?.id)return{id:a.id}}e.reviveIdentifier=D;var v;(function(a){a[a.EMPTY=1]="EMPTY",a[a.FOLDER=2]="FOLDER",a[a.WORKSPACE=3]="WORKSPACE"})(v=e.WorkbenchState||(e.WorkbenchState={}));function d(a){const u=a;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&Array.isArray(u.folders))}e.isWorkspace=d;function m(a){const u=a;return!!(u&&typeof u=="object"&&I.URI.isUri(u.uri)&&typeof u.name=="string"&&typeof u.toResource=="function")}e.isWorkspaceFolder=m;class h{constructor(u,c,l,n,r){this.h=u,this.j=l,this.k=n,this.l=r,this.c=k.TernarySearchTree.forUris(this.l,()=>!0),this.folders=c}update(u){this.h=u.id,this.k=u.configuration,this.j=u.transient,this.l=u.l,this.folders=u.folders}get folders(){return this.g}set folders(u){this.g=u,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(u){this.k=u}getFolder(u){return u&&this.c.findSubstr(u)||null}n(){this.c=k.TernarySearchTree.forUris(this.l,()=>!0);for(const u of this.folders)this.c.set(u.uri,u)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class w{constructor(u,c){this.raw=c,this.uri=u.uri,this.index=u.index,this.name=u.name}toResource(u){return(0,R.joinPath)(this.uri,u)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=w;function g(a){return new w({uri:a,index:0,name:(0,R.basenameOrAuthority)(a)},{uri:a.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,o.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function p(a,u){return R.extUriBiasedIgnorePathCase.isEqualOrParent(a,u.untitledWorkspacesHome)}e.isUntitledWorkspace=p;function b(a){let u;return I.URI.isUri(a)?u=a:u=a.configuration,u?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=b;function i(a,u){return!p(a,u)&&!b(a)}e.isSavedWorkspace=i;function s(a){return(typeof a=="string"?(0,t.extname)(a):(0,R.extname)(a))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(ye[69],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class o{constructor(k){this.d=k,this.b=new Map,this.c=1}add(k){const R=this.c++;return this.b.set(R,k),this.e(),R}get(k,R){return this.b.has(k)?this.b.get(k)[R]:void 0}delete(k){this.b.delete(k),this.e()}e(){!o.a||console.log(`${this.d} cache size - ${this.b.size}`)}}e.Cache=o,o.a=!1}),define(ye[47],Ce([1,0,15,24,3]),function(ne,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class R{constructor(){this.a=new Set(Object.keys(o.Schemas)),this.b=new Map,this.extUri=new t.ExtUri(A=>{const S=this.b.get(A.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(A,S){S===null?this.b.delete(A.scheme):this.b.set(A.scheme,S)}isFreeScheme(A){return!this.b.has(A)&&!this.a.has(A)}getCapabilities(A){return this.b.get(A)}}e.ExtHostFileSystemInfo=R,e.IExtHostFileSystemInfo=(0,k.createDecorator)("IExtHostFileSystemInfo")}),define(ye[25],Ce([1,0,3]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,o.createDecorator)("IExtHostInitDataService")}),define(ye[211],Ce([1,0,16]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(I,A,S){this.h=new Map,this.a=I,this.b=A,this.c=S,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(C=>(this.f=C,this)),this.g=this.c.onDidChangeStorage(C=>{C.shared===this.b&&C.key===this.a&&(this.f=C.value)}),this.i=new o.RunOnceScheduler(()=>{const C=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const L of C.values())L.complete()}catch(L){for(const P of C.values())P.error(L)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,I])=>I!==void 0).map(([I])=>I)}get whenReady(){return this.d}get(I,A){let S=this.f[I];return typeof S>"u"&&(S=A),S}update(I,A){this.f[I]=A;const S=this.h.get(I);if(S!==void 0)return S.p;const C=new o.DeferredPromise;return this.h.set(I,C),this.i.isScheduled()||this.i.schedule(),C.p}dispose(){this.g.dispose()}}e.ExtensionMemento=t;class k extends t{setKeysForSync(I){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},I)}constructor(I,A){super(I.identifier.value,!0,A),this.j=I}}e.ExtensionGlobalMemento=k}),define(ye[212],Ce([1,0,4,2]),function(ne,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class k{constructor(I){this.c=I,this.a=new o.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new o.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(I,A,S,C){const P=this.c.getNotebookDocument(t.URI.revive(I)).acceptModelChanged(A.value,S,C);this.b.fire(P)}$acceptDirtyStateChanged(I,A){this.c.getNotebookDocument(t.URI.revive(I)).acceptDirty(A)}$acceptModelSaved(I){const A=this.c.getNotebookDocument(t.URI.revive(I));this.a.fire(A.apiNotebook)}}e.ExtHostNotebookDocuments=k}),define(ye[17],Ce([1,0,3]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,o.createDecorator)("IExtHostRpcService");class t{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.ExtHostRpcService=t});var Je=this&&this.__classPrivateFieldSet||function(ne,e,o,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ne,o):k?k.value=o:e.set(ne,o),o},Ue=this&&this.__classPrivateFieldGet||function(ne,e,o,t){if(o==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?t:o==="a"?t.call(ne):t?t.value:e.get(ne)};define(ye[213],Ce([1,0,26,4]),function(ne,e,o,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class R{constructor(A,S){k.set(this,void 0),this.b=new t.Emitter,this.onDidChange=this.b.event,this.a=o.ExtensionIdentifier.toKey(A.identifier),Je(this,k,S,"f"),Ue(this,k,"f").onDidChangePassword(C=>{C.extensionId===this.a&&this.b.fire({key:C.key})})}get(A){return Ue(this,k,"f").get(this.a,A)}store(A,S){return Ue(this,k,"f").store(this.a,A,S)}delete(A){return Ue(this,k,"f").delete(this.a,A)}}e.ExtensionSecrets=R,k=new WeakMap}),define(ye[54],Ce([1,0,3,129,4,17]),function(ne,e,o,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var I;(function(S){function C(P){return{remoteAddress:P.remoteAddress,localAddress:P.localAddress,public:!!P.public,privacy:P.privacy??(P.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:P.protocol}}S.fromApiTunnel=C;function L(P){return{remoteAddress:{host:P.tunnelRemoteHost,port:P.tunnelRemotePort},localAddress:P.localAddress,public:P.privacy!==t.TunnelPrivacyId.ConstantPrivate&&P.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:P.privacy,protocol:P.protocol}}S.fromServiceTunnel=L})(I=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,o.createDecorator)("IExtHostTunnelService");let A=class{constructor(C){this.onDidChangeTunnels=new k.Emitter().event}async $applyCandidateFilter(C){return C}async openTunnel(C,L){}async getTunnels(){return[]}async setTunnelFactory(C){return{dispose:()=>{}}}registerPortsAttributesProvider(C,L){return{dispose:()=>{}}}async $providePortAttributes(C,L,P,y,D){return[]}async $forwardPort(C,L){}async $closeTunnel(C){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=qe([He(0,R.IExtHostRpcService)],A),e.ExtHostTunnelService=A}),define(ye[55],Ce([1,0,3]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,o.createDecorator)("IURITransformerService");class t{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=I=>I,this.transformOutgoing=I=>I,this.transformOutgoingURI=I=>I,this.transformOutgoingScheme=I=>I)}}e.URITransformerService=t}),define(ye[214],Ce([1,0,22]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(S){let C=this.buffers.indexOf(S);return C<0&&(C=this.buffers.length,this.buffers.push(S)),C}}function k(A,S){if(S.serializeBuffersForPostMessage){const C=new t,L=(D,v)=>{if(v instanceof ArrayBuffer){const d=C.add(v);return{$$vscode_array_buffer_reference$$:!0,index:d}}else if(ArrayBuffer.isView(v)){const d=R(v);if(d){const m=C.add(v.buffer);return{$$vscode_array_buffer_reference$$:!0,index:m,view:{type:d,byteLength:v.byteLength,byteOffset:v.byteOffset}}}}return v},P=JSON.stringify(A,L),y=C.buffers.map(D=>{const v=new Uint8Array(D);return o.VSBuffer.wrap(v)});return{message:P,buffers:y}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=k;function R(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function I(A,S){const C=S.map(y=>{const D=new ArrayBuffer(y.byteLength);return new Uint8Array(D).set(y.buffer),D}),L=S.length?(y,D)=>{if(D&&typeof D=="object"&&D.$$vscode_array_buffer_reference$$){const v=D,{index:d}=v,m=C[d];if(v.view)switch(v.view.type){case 1:return new Int8Array(m,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(m,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(m,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(m,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(m,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(m,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(m,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(m,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(m,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(m,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(m,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return m}return D}:void 0;return{message:JSON.parse(A,L),arrayBuffers:C}}e.deserializeWebviewMessage=I}),define(ye[215],Ce([1,0,113]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(R){return{transformIncoming:I=>I.scheme==="vscode-remote"?{scheme:"file",path:I.path,query:I.query,fragment:I.fragment}:I.scheme==="file"?{scheme:"vscode-local",path:I.path,query:I.query,fragment:I.fragment}:I,transformOutgoing:I=>I.scheme==="file"?{scheme:"vscode-remote",authority:R,path:I.path,query:I.query,fragment:I.fragment}:I.scheme==="vscode-local"?{scheme:"file",path:I.path,query:I.query,fragment:I.fragment}:I,transformOutgoingScheme:I=>I==="file"?"vscode-remote":I==="vscode-local"?"file":I}}function k(R){return new o.URITransformer(t(R))}e.createURITransformer=k}),define(ye[130],Ce([1,0,182,11,2,6,3,44,38,15]),function(ne,e,o,t,k,R,I,A,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,o.localize)(0,null),providerDisplayName:(0,o.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var L;(function(X){X[X.PROGRAMMATIC=1]="PROGRAMMATIC",X[X.USER=2]="USER",X[X.EDIT=3]="EDIT",X[X.NAVIGATION=4]="NAVIGATION",X[X.JUMP=5]="JUMP"})(L=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var P;(function(X){X[X.IDENTICAL=1]="IDENTICAL",X[X.SIMILAR=2]="SIMILAR",X[X.DIFFERENT=3]="DIFFERENT"})(P=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function y(X){const q=X;return!!q&&typeof q.getSelection=="function"&&!!q.onDidChangeSelection}e.isEditorPaneWithSelection=y;function D(X,q,_){for(const Q of _.visibleEditorPanes)if(Q.group.id===q&&X.matches(Q.input))return Q.getViewState()}e.findViewStateForEditor=D;function v(X){if(c(X))return!1;const q=X;return k.URI.isUri(q?.resource)}e.isResourceEditorInput=v;function d(X){if(c(X))return!1;const q=X;return q?.original!==void 0&&q.modified!==void 0}e.isResourceDiffEditorInput=d;function m(X){if(c(X)||d(X))return!1;const q=X;return q?.primary!==void 0&&q.secondary!==void 0}e.isResourceSideBySideEditorInput=m;function h(X){if(c(X))return!1;const q=X;return q?q.resource===void 0||q.resource.scheme===C.Schemas.untitled||q.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=h;const w=/Untitled-\d+/;function g(X){return X.scheme===C.Schemas.untitled&&X.path.length>1&&!w.test(X.path)}e.isUntitledWithAssociatedResource=g;function p(X){if(c(X))return!1;const q=X;return k.URI.isUri(q?.base?.resource)&&k.URI.isUri(q?.input1?.resource)&&k.URI.isUri(q?.input2?.resource)&&k.URI.isUri(q?.result?.resource)}e.isResourceMergeEditorInput=p;var b;(function(X){X[X.SHORT=0]="SHORT",X[X.MEDIUM=1]="MEDIUM",X[X.LONG=2]="LONG"})(b=e.Verbosity||(e.Verbosity={}));var i;(function(X){X[X.EXPLICIT=1]="EXPLICIT",X[X.AUTO=2]="AUTO",X[X.FOCUS_CHANGE=3]="FOCUS_CHANGE",X[X.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(i=e.SaveReason||(e.SaveReason={}));class s{constructor(){this.a=new Map}registerSource(q,_){let Q=this.a.get(q);return Q||(Q={source:q,label:_},this.a.set(q,Q)),Q.source}getSourceLabel(q){return this.a.get(q)?.label??q}}e.SaveSourceRegistry=new s;var a;(function(X){X[X.None=0]="None",X[X.Readonly=2]="Readonly",X[X.Untitled=4]="Untitled",X[X.Singleton=8]="Singleton",X[X.RequiresTrust=16]="RequiresTrust",X[X.CanSplitInGroup=32]="CanSplitInGroup",X[X.ForceDescription=64]="ForceDescription",X[X.CanDropIntoEditor=128]="CanDropIntoEditor",X[X.MultipleEditors=256]="MultipleEditors"})(a=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class u extends R.Disposable{}e.AbstractEditorInput=u;function c(X){return X instanceof u}e.isEditorInput=c;function l(X){const q=X;return k.URI.isUri(q?.preferredResource)}function n(X){const q=X;return c(q?.primary)&&c(q?.secondary)}e.isSideBySideEditorInput=n;function r(X){const q=X;return c(q?.modified)&&c(q?.original)}e.isDiffEditorInput=r;function f(X){return c(X?.editor)}e.isEditorInputWithOptions=f;function E(X){const q=X;return f(X)&&q?.group!==void 0}e.isEditorInputWithOptionsAndGroup=E;function T(X){const q=X;return typeof q?.groupId=="number"&&c(q.editor)}e.isEditorIdentifier=T;var M;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.REPLACE=1]="REPLACE",X[X.MOVE=2]="MOVE",X[X.UNPIN=3]="UNPIN"})(M=e.EditorCloseContext||(e.EditorCloseContext={}));var G;(function(X){X[X.GROUP_ACTIVE=0]="GROUP_ACTIVE",X[X.GROUP_INDEX=1]="GROUP_INDEX",X[X.GROUP_LOCKED=2]="GROUP_LOCKED",X[X.EDITOR_OPEN=3]="EDITOR_OPEN",X[X.EDITOR_CLOSE=4]="EDITOR_CLOSE",X[X.EDITOR_MOVE=5]="EDITOR_MOVE",X[X.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",X[X.EDITOR_LABEL=7]="EDITOR_LABEL",X[X.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",X[X.EDITOR_PIN=9]="EDITOR_PIN",X[X.EDITOR_STICKY=10]="EDITOR_STICKY",X[X.EDITOR_DIRTY=11]="EDITOR_DIRTY",X[X.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(G=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var V;(function(X){X[X.PRIMARY=1]="PRIMARY",X[X.SECONDARY=2]="SECONDARY",X[X.BOTH=3]="BOTH",X[X.ANY=4]="ANY"})(V=e.SideBySideEditor||(e.SideBySideEditor={}));class N{getOriginalUri(q,_){if(!q)return;if(p(q))return e.EditorResourceAccessor.getOriginalUri(q.result,_);if(_?.supportSideBySide){const{primary:Z,secondary:ge}=this.a(q);if(Z&&ge){if(_?.supportSideBySide===V.BOTH)return{primary:this.getOriginalUri(Z,{filterByScheme:_.filterByScheme}),secondary:this.getOriginalUri(ge,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===V.ANY)return this.getOriginalUri(Z,{filterByScheme:_.filterByScheme})??this.getOriginalUri(ge,{filterByScheme:_.filterByScheme});q=_.supportSideBySide===V.PRIMARY?Z:ge}}if(d(q)||m(q)||p(q))return;const Q=l(q)?q.preferredResource:q.resource;return!Q||!_||!_.filterByScheme?Q:this.b(Q,_.filterByScheme)}a(q){return n(q)||m(q)?{primary:q.primary,secondary:q.secondary}:r(q)||d(q)?{primary:q.modified,secondary:q.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(q,_){if(!q)return;if(p(q))return e.EditorResourceAccessor.getCanonicalUri(q.result,_);if(_?.supportSideBySide){const{primary:Z,secondary:ge}=this.a(q);if(Z&&ge){if(_?.supportSideBySide===V.BOTH)return{primary:this.getCanonicalUri(Z,{filterByScheme:_.filterByScheme}),secondary:this.getCanonicalUri(ge,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===V.ANY)return this.getCanonicalUri(Z,{filterByScheme:_.filterByScheme})??this.getCanonicalUri(ge,{filterByScheme:_.filterByScheme});q=_.supportSideBySide===V.PRIMARY?Z:ge}}if(d(q)||m(q)||p(q))return;const Q=q.resource;return!Q||!_||!_.filterByScheme?Q:this.b(Q,_.filterByScheme)}b(q,_){if(Array.isArray(_)){if(_.some(Q=>q.scheme===Q))return q}else if(_===q.scheme)return q}}e.EditorResourceAccessor=new N;var U;(function(X){X[X.LEFT=0]="LEFT",X[X.RIGHT=1]="RIGHT"})(U=e.CloseDirection||(e.CloseDirection={}));class F{constructor(){this.c=new Map,this.d=new Map}start(q){const _=this.a=q.get(I.IInstantiationService);for(const[Q,Z]of this.c)this.e(Q,Z,_);this.c.clear()}e(q,_,Q){const Z=Q.createInstance(_);this.d.set(q,Z)}registerFileEditorFactory(q){if(this.b)throw new Error("Can only register one file editor factory.");this.b=q}getFileEditorFactory(){return(0,t.assertIsDefined)(this.b)}registerEditorSerializer(q,_){if(this.c.has(q)||this.d.has(q))throw new Error(`A editor serializer with type ID '${q}' was already registered.`);return this.a?this.e(q,_,this.a):this.c.set(q,_),(0,R.toDisposable)(()=>{this.c.delete(q),this.d.delete(q)})}getEditorSerializer(q){return this.d.get(typeof q=="string"?q:q.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new F);async function z(X,q,_){return!X||!X.length?[]:await Promise.all(X.map(async Q=>{const Z=k.URI.revive(Q.fileUri);if(!Z){_.info("Cannot resolve the path because it is not valid.",Q);return}if(!await q.canHandleResource(Z)){_.info("Cannot resolve the path because it cannot be handled",Q);return}let te=Q.exists,J=Q.type;if(typeof te!="boolean"||typeof J!="number")try{J=(await q.stat(Z)).isDirectory?S.FileType.Directory:S.FileType.Unknown,te=!0}catch(ve){_.error(ve),te=!1}if(!te&&Q.openOnlyIfExists){_.info("Cannot resolve the path because it does not exist",Q);return}if(J===S.FileType.Directory){_.info("Cannot resolve the path because it is a directory",Q);return}const fe={...Q.options,pinned:!0};return te?{resource:Z,options:fe}:{resource:Z,options:fe,forceUntitled:!0}}))}e.pathsToEditors=z;var B;(function(X){X[X.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",X[X.SEQUENTIAL=1]="SEQUENTIAL"})(B=e.EditorsOrder||(e.EditorsOrder={}));function W(X){const q=X;if(!q)return!1;const _=q;if(_.modified)return W(_.modified);const Q=q;return!!(Q.contributionsState&&Q.viewState&&Array.isArray(Q.cursorState))}e.isTextEditorViewState=W}),define(ye[131],Ce([1,0,4,16,183]),function(ne,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class R{constructor(){this.f=new Map,this.k=[],this.m=new o.Emitter,this.n=new o.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(A){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=A}onEvent(A){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=A}onRequest(A){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=A}sendResponse(A){A.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.s("response",A)}sendRequest(A,S,C,L){const P={command:A};if(S&&Object.keys(S).length>0&&(P.arguments=S),this.s("request",P),typeof L=="number"){const y=setTimeout(()=>{clearTimeout(y);const D=this.f.get(P.seq);if(D){this.f.delete(P.seq);const v={type:"response",seq:0,request_seq:P.seq,success:!1,command:A,message:(0,k.localize)(0,null,L,A)};D(v)}},L)}return C&&this.f.set(P.seq,C),P.seq}acceptMessage(A){this.j?this.j(A):(this.k.push(A),this.k.length===1&&this.q())}o(A,S){return A.type!=="event"||S.type!=="event"}async q(){let A;for(;this.k.length;){if((!A||this.o(this.k[0],A))&&await(0,t.timeout)(0),A=this.k.shift(),!A)return;switch(A.type){case"event":this.i?.(A);break;case"request":this.g?.(A);break;case"response":{const S=A,C=this.f.get(S.request_seq);C&&(this.f.delete(S.request_seq),C(S));break}}}}s(A,S){S.type=A,S.seq=this.d++,this.sendMessage(S)}async u(){if(this.f.size===0)return Promise.resolve();const A=new Map;this.f.forEach((S,C)=>A.set(C,S)),await(0,t.timeout)(500),A.forEach((S,C)=>{S({type:"response",seq:0,request_seq:C,success:!1,command:"canceled",message:"canceled"}),this.f.delete(C)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=R}),define(ye[216],Ce([1,0,184,53,3]),function(ne,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new t.RawContextKey("debugType",void 0,{type:"string",description:o.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new t.RawContextKey("debugConfigurationType",void 0,{type:"string",description:o.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new t.RawContextKey("debugState","inactive",{type:"string",description:o.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new t.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:o.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new t.RawContextKey("hasDebugged",!1,{type:"boolean",description:o.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new t.RawContextKey("inDebugMode",!1,{type:"boolean",description:o.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new t.RawContextKey("inDebugRepl",!1,{type:"boolean",description:o.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new t.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:o.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new t.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:o.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new t.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:o.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new t.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:o.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new t.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:o.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new t.RawContextKey("variablesFocused",!0,{type:"boolean",description:o.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new t.RawContextKey("expressionSelected",!1,{type:"boolean",description:o.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new t.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:o.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new t.RawContextKey("callStackItemType",void 0,{type:"string",description:o.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new t.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:o.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new t.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:o.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new t.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:o.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new t.RawContextKey("watchItemType",void 0,{type:"string",description:o.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new t.RawContextKey("canViewMemory",void 0,{type:"boolean",description:o.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new t.RawContextKey("breakpointItemType",void 0,{type:"string",description:o.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new t.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:o.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new t.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:o.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new t.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:o.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new t.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:o.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new t.RawContextKey("stepBackSupported",!1,{type:"boolean",description:o.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new t.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:o.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new t.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:o.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new t.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:o.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new t.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:o.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new t.RawContextKey("breakpointsExist",!1,{type:"boolean",description:o.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new t.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:o.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new t.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:o.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new t.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:o.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new t.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:o.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new t.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:o.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new t.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:o.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new t.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:o.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new t.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:o.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new t.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:o.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new t.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:o.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new t.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:o.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new t.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:o.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new t.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:o.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new t.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:o.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new t.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:o.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new t.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:o.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new t.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:o.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new t.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:o.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new t.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:o.localize(50,null)});const R=y=>o.localize(51,null,y);e.debuggerDisabledMessage=R,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:o.localize(52,null)};var I;(function(y){y[y.Inactive=0]="Inactive",y[y.Initializing=1]="Initializing",y[y.Stopped=2]="Stopped",y[y.Running=3]="Running"})(I=e.State||(e.State={}));function A(y){switch(y){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var S;(function(y){y[y.Valid=0]="Valid",y[y.Unreadable=1]="Unreadable",y[y.Error=2]="Error"})(S=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var C;(function(y){y[y.Initial=1]="Initial",y[y.Dynamic=2]="Dynamic"})(C=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var L;(function(y){y.UnverifiedBreakpoints="unverifiedBreakpoints"})(L=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,k.createDecorator)("debugService");var P;(function(y){y[y.CONDITION=0]="CONDITION",y[y.HIT_COUNT=1]="HIT_COUNT",y[y.LOG_MESSAGE=2]="LOG_MESSAGE"})(P=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(ye[217],Ce([1,0,8,2,9,23,15]),function(ne,e,o,t,k,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function S(a,u,c){return a.replace(A,function(l,n){return u&&n.length>0&&n[0]!=="_"?l:c&&c.hasOwnProperty(n)?c[n]:l})}e.formatPII=S;function C(a){const u={};for(const c of Object.keys(a))c.startsWith("!")||(u[c]=a[c]);return u}e.filterExceptionsFromTelemetry=C;function L(a){return a.configuration.request==="attach"&&!P(a)&&(!a.parentSession||L(a.parentSession))}e.isSessionAttach=L;function P(a){let u=a.configuration.type;if(!!u)return u==="vslsShare"&&(u=a.configuration.adapterProxy.configuration.type),(0,o.equalsIgnoreCase)(u,"extensionhost")||(0,o.equalsIgnoreCase)(u,"pwa-extensionhost")?a:a.parentSession?P(a.parentSession):void 0}e.getExtensionHostDebugSession=P;function y(a){return a.type&&(a.label||a.program||a.runtime)}e.isDebuggerMainContribution=y;function D(a,u,c){let l,n=0;const r=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let f=null;for(;f=r.exec(a);){const E=f.index+1,T=E+f[0].length;if(E<=u&&T>=c){l=f[0],n=E;break}}if(l){const E=/\w+/g;let T=null;for(;(T=E.exec(l))&&!(T.index+1+n+T[0].length>=c););T&&(l=l.substring(0,E.lastIndex))}return l?{start:n,end:n+l.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=D;const v=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function d(a){return!!(a&&a.match(v))}e.isUri=d;function m(a){if(typeof a.path=="string"&&!(typeof a.sourceReference=="number"&&a.sourceReference>0)){if(d(a.path))return t.URI.parse(a.path);if((0,k.isAbsolute)(a.path))return t.URI.file(a.path)}return a.path}function h(a){if(typeof a.path=="object"){const u=t.URI.revive(a.path);if(u)return u.scheme===I.Schemas.file?u.fsPath:u.toString()}return a.path}function w(a,u){const c=u?m:h,l=(0,R.deepClone)(a);return p(l,(n,r)=>{n&&r&&(r.path=c(r))}),l}e.convertToDAPaths=w;function g(a,u){const c=u?m:h,l=(0,R.deepClone)(a);return p(l,(n,r)=>{!n&&r&&(r.path=c(r))}),l}e.convertToVSCPaths=g;function p(a,u){switch(a.type){case"event":{const c=a;switch(c.event){case"output":u(!1,c.body.source);break;case"loadedSource":u(!1,c.body.source);break;case"breakpoint":u(!1,c.body.breakpoint.source);break;default:break}break}case"request":{const c=a;switch(c.command){case"setBreakpoints":u(!0,c.arguments.source);break;case"breakpointLocations":u(!0,c.arguments.source);break;case"source":u(!0,c.arguments.source);break;case"gotoTargets":u(!0,c.arguments.source);break;case"launchVSCode":c.arguments.args.forEach(l=>u(!1,l));break;default:break}break}case"response":{const c=a;if(c.success&&c.body)switch(c.command){case"stackTrace":c.body.stackFrames.forEach(l=>u(!1,l.source));break;case"loadedSources":c.body.sources.forEach(l=>u(!1,l));break;case"scopes":c.body.scopes.forEach(l=>u(!1,l.source));break;case"setFunctionBreakpoints":c.body.breakpoints.forEach(l=>u(!1,l.source));break;case"setBreakpoints":c.body.breakpoints.forEach(l=>u(!1,l.source));break;case"disassemble":c.body?.instructions.forEach(n=>u(!1,n.location));break;default:break}break}}}function b(a){return a.filter(u=>!u.presentation?.hidden).sort((u,c)=>u.presentation?c.presentation?u.presentation.group?c.presentation.group?u.presentation.group!==c.presentation.group?u.presentation.group.localeCompare(c.presentation.group):i(u.presentation.order,c.presentation.order):-1:c.presentation.group?1:i(u.presentation.order,c.presentation.order):-1:c.presentation?1:0)}e.getVisibleAndSorted=b;function i(a,u){return typeof a!="number"?typeof u!="number"?0:1:typeof u!="number"?-1:a-u}async function s(a,u){const c=a.getValue("debug.saveBeforeStart",{overrideIdentifier:u.activeTextEditorLanguageId});if(c!=="none"&&(await u.saveAll(),c==="allEditorsInActiveGroup")){const l=u.activeEditorPane;l&&l.input.resource?.scheme===I.Schemas.untitled&&await u.save({editor:l.input,groupId:l.group.id})}await a.reloadConfiguration()}e.saveAllBeforeDebugStart=s}),define(ye[218],Ce([1,0,45,219,23,9,12,8,29,185,131]),function(ne,e,o,t,k,R,I,A,S,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class P extends L.AbstractDebugAdapter{constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(h,w){this.p=w,this.r=Buffer.allocUnsafe(0),this.t=-1,h.on("data",g=>this.w(g))}sendMessage(h){if(this.p){const w=JSON.stringify(h);this.p.write(`Content-Length: ${Buffer.byteLength(w,"utf8")}${P.a}${w}`,"utf8")}}w(h){for(this.r=Buffer.concat([this.r,h]);;){if(this.t>=0){if(this.r.length>=this.t){const w=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,w.length>0)try{this.acceptMessage(JSON.parse(w))}catch(g){this.m.fire(new Error((g.message||g)+`
`+w))}continue}}else{const w=this.r.indexOf(P.a);if(w!==-1){const p=this.r.toString("utf8",0,w).split(P.b);for(const b of p){const i=b.split(P.l);i[0]==="Content-Length"&&(this.t=Number(i[1]))}this.r=this.r.slice(w+P.a.length);continue}}break}}}e.StreamDebugAdapter=P,P.a=`\r
\r
`,P.b=/\r?\n/,P.l=/: */;class y extends P{startSession(){return new Promise((h,w)=>{let g=!1;this.x=this.y(()=>{this.v(this.x,this.x),h(),g=!0}),this.x.on("close",()=>{g?this.m.fire(new Error("connection closed")):w(new Error("connection closed"))}),this.x.on("error",p=>{g?this.m.fire(p):w(p)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.NetworkDebugAdapter=y;class D extends y{constructor(h){super(),this.z=h}y(h){return t.createConnection(this.z.port,this.z.host||"127.0.0.1",h)}}e.SocketDebugAdapter=D;class v extends y{constructor(h){super(),this.z=h}y(h){return t.createConnection(this.z.path,h)}}e.NamedPipeDebugAdapter=v;class d extends P{constructor(h,w){super(),this.y=h,this.z=w}async startSession(){const h=this.y.command,w=this.y.args,g=this.y.options||{};try{if(h)if(R.isAbsolute(h)){if(!await S.Promises.exists(h))throw new Error(C.localize(0,null,h))}else h.indexOf("/")<0&&h.indexOf("\\")<0;else throw new Error(C.localize(1,null,this.z));let p=process.env;if(g.env&&Object.keys(g.env).length>0&&(p=k.mixin(k.deepClone(process.env),g.env)),h==="node")if(Array.isArray(w)&&w.length>0){const b=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,i={env:p,execArgv:b?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};g.cwd&&(i.cwd=g.cwd);const s=o.fork(w[0],w.slice(1),i);if(!s.pid)throw new Error(C.localize(2,null,w[0]));this.x=s}else throw new Error(C.localize(3,null));else{const b={env:p};g.cwd&&(b.cwd=g.cwd),this.x=o.spawn(h,w,b)}this.x.on("error",b=>{this.m.fire(b)}),this.x.on("exit",(b,i)=>{this.n.fire(b)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",b=>{this.m.fire(b)}),this.x.stdin.on("error",b=>{this.m.fire(b)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(p){this.m.fire(p)}}async stopSession(){return this.x?(await this.u(),I.isWindows?new Promise((h,w)=>{const g=o.exec(`taskkill /F /T /PID ${this.x.pid}`,function(p,b,i){if(p)return w(p)});g.on("exit",h),g.on("error",w)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(h,w){if(!h)return;const g=Object.create(null);h.runtime&&(h.runtime.indexOf("./")===0?g.runtime=R.join(w,h.runtime):g.runtime=h.runtime),h.runtimeArgs&&(g.runtimeArgs=h.runtimeArgs),h.program&&(R.isAbsolute(h.program)?g.program=h.program:g.program=R.join(w,h.program)),h.args&&(g.args=h.args);const p=h;return p.win&&(g.win=d.A(p.win,w)),p.winx86&&(g.winx86=d.A(p.winx86,w)),p.windows&&(g.windows=d.A(p.windows,w)),p.osx&&(g.osx=d.A(p.osx,w)),p.linux&&(g.linux=d.A(p.linux,w)),g}static platformAdapterExecutable(h,w){let g=Object.create(null);w=w.toLowerCase();for(const u of h)if(u.contributes){const c=u.contributes.debuggers;c&&c.length>0&&c.filter(l=>typeof l.type=="string"&&A.equalsIgnoreCase(l.type,w)).forEach(l=>{const n=d.A(l,u.extensionLocation.fsPath);g=k.mixin(g,n,u.isBuiltin)})}let p;I.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?p=g.winx86||g.win||g.windows:I.isWindows?p=g.win||g.windows:I.isMacintosh?p=g.osx:I.isLinux&&(p=g.linux),p=p||g;const b=p.program||g.program,i=p.args||g.args,s=p.runtime||g.runtime,a=p.runtimeArgs||g.runtimeArgs;if(s)return{type:"executable",command:s,args:(a||[]).concat(typeof b=="string"?[b]:[]).concat(i||[])};if(b)return{type:"executable",command:b,args:i||[]}}}e.ExecutableDebugAdapter=d}),define(ye[220],Ce([1,0,45,32,12]),function(ne,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function R(C,L){return new Promise((P,y)=>{let D="";const v=o.spawn(C,L);v.pid&&v.stdout.on("data",d=>{D+=d.toString()}),v.on("error",d=>{y(d)}),v.on("close",d=>{P(D)})})}async function I(C){if(C)if(k.isWindows){const L=await new Promise((P,y)=>{ne(["windows-process-tree"],P,y)});return new Promise(P=>{L.getProcessTree(C,y=>{P(!!y&&y.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(C)]).then(L=>{const P=L.trim();return!(P.length===0||P.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.hasChildProcesses=I;var A;(function(C){C[C.cmd=0]="cmd",C[C.powershell=1]="powershell",C[C.bash=2]="bash"})(A||(A={}));function S(C,L,P,y,D){C=C.trim().toLowerCase();let v;C.indexOf("powershell")>=0||C.indexOf("pwsh")>=0?v=1:C.indexOf("cmd.exe")>=0?v=0:C.indexOf("bash")>=0?v=2:k.isWindows?v=0:v=2;let d,m=" ";switch(v){case 1:if(d=h=>(h=h.replace(/\'/g,"''"),h.length>0&&h.charAt(h.length-1)==="\\"?`'${h}\\'`:`'${h}'`),y){const h=(0,t.getDriveLetter)(y);h&&(m+=`${h}:; `),m+=`cd ${d(y)}; `}if(D)for(const h in D){const w=D[h];w===null?m+=`Remove-Item env:${h}; `:m+=`\${env:${h}}='${w}'; `}if(L.length>0){const h=L.shift(),w=P?h:d(h);m+=w[0]==="'"?`& ${w} `:`${w} `;for(const g of L)m+=g==="<"||g===">"||P?g:d(g),m+=" "}break;case 0:if(d=h=>(h=h.replace(/\"/g,'""'),h=h.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(w=>h.includes(w))||h.length===0?`"${h}"`:h),y){const h=(0,t.getDriveLetter)(y);h&&(m+=`${h}: && `),m+=`cd ${d(y)} && `}if(D){m+='cmd /C "';for(const h in D){let w=D[h];w===null?m+=`set "${h}=" && `:(w=w.replace(/[&^|<>]/g,g=>`^${g}`),m+=`set "${h}=${w}" && `)}}for(const h of L)m+=h==="<"||h===">"||P?h:d(h),m+=" ";D&&(m+='"');break;case 2:{d=w=>(w=w.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),w.length===0?'""':w);const h=w=>/[^\w@%\/+=,.:^-]/.test(w)?`'${w.replace(/'/g,"'\\''")}'`:w;if(y&&(m+=`cd ${d(y)} ; `),D){m+="/usr/bin/env";for(const w in D){const g=D[w];g===null?m+=` -u ${h(w)}`:m+=` ${h(`${w}=${g}`)}`}m+=" "}for(const w of L)m+=w==="<"||w===">"||P?w:d(w),m+=" ";break}}return m}e.prepareCommand=S}),define(ye[91],Ce([1,0,22,37,62,84,15,9,12,53]),function(ne,e,o,t,k,R,I,A,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var L;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(L=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.latex,R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.latex,R.Mimes.markdown,"application/json",R.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var P;(function(z){z[z.Running=1]="Running",z[z.Idle=2]="Idle"})(P=e.NotebookRunState||(e.NotebookRunState={}));var y;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(y=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var D;(function(z){z[z.WithHardKernelDependency=0]="WithHardKernelDependency",z[z.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",z[z.Pure=2]="Pure",z[z.Never=3]="Never"})(D=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var v;(function(z){z.Always="always",z.Never="never",z.Optional="optional"})(v=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var d;(function(z){z[z.ModelChange=1]="ModelChange",z[z.Move=2]="Move",z[z.ChangeCellLanguage=5]="ChangeCellLanguage",z[z.Initialize=6]="Initialize",z[z.ChangeCellMetadata=7]="ChangeCellMetadata",z[z.Output=8]="Output",z[z.OutputItem=9]="OutputItem",z[z.ChangeCellContent=10]="ChangeCellContent",z[z.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",z[z.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",z[z.ChangeCellMime=13]="ChangeCellMime",z[z.Unknown=100]="Unknown"})(d=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var m;(function(z){z[z.Handle=0]="Handle",z[z.Index=1]="Index"})(m=e.SelectionStateType||(e.SelectionStateType={}));var h;(function(z){z[z.Replace=1]="Replace",z[z.Output=2]="Output",z[z.Metadata=3]="Metadata",z[z.CellLanguage=4]="CellLanguage",z[z.DocumentMetadata=5]="DocumentMetadata",z[z.Move=6]="Move",z[z.OutputItems=7]="OutputItems",z[z.PartialMetadata=8]="PartialMetadata",z[z.PartialInternalMetadata=9]="PartialInternalMetadata"})(h=e.CellEditType||(e.CellEditType={}));var w;(function(z){z.scheme=I.Schemas.vscodeNotebookCell;const B=["W","X","Y","Z","a","b","c","d","e","f"],W=new RegExp(`^[${B.join("")}]+`),X=7;function q(J,fe){const ve=fe.toString(X),Ae=`${ve.length<B.length?B[ve.length-1]:"z"}${ve}s${(0,o.encodeBase64)(o.VSBuffer.fromString(J.scheme),!0,!0)}`;return J.with({scheme:z.scheme,fragment:Ae})}z.generate=q;function _(J){if(J.scheme!==z.scheme)return;const fe=J.fragment.indexOf("s");if(fe<0)return;const ve=parseInt(J.fragment.substring(0,fe).replace(W,""),X),Ee=(0,o.decodeBase64)(J.fragment.substring(fe+1)).toString();if(!isNaN(ve))return{handle:ve,notebook:J.with({scheme:Ee,fragment:null})}}z.parse=_;function Q(J,fe){return J.with({scheme:I.Schemas.vscodeNotebookCellOutput,fragment:`op${fe??""},${J.scheme!==I.Schemas.file?J.scheme:""}`})}z.generateCellOutputUri=Q;function Z(J){if(J.scheme!==I.Schemas.vscodeNotebookCellOutput)return;const fe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(J.fragment);if(!fe)return;const ve=fe[1]&&fe[1]!==""?fe[1]:void 0,Ee=fe[2];return{outputId:ve,notebook:J.with({scheme:Ee||I.Schemas.file,fragment:null})}}z.parseCellOutputUri=Z;function ge(J,fe,ve){return z.generate(J,fe).with({scheme:ve})}z.generateCellPropertyUri=ge;function te(J,fe){if(J.scheme===fe)return z.parse(J.with({scheme:z.scheme}))}z.parseCellPropertyUri=te})(w=e.CellUri||(e.CellUri={}));const g=z=>S.isWindows?z.replace(/\//g,"\\"):z;class p{constructor(B=[],W=e.NOTEBOOK_DISPLAY_ORDER){this.e=W,this.d=[...new Set(B)].map(X=>({pattern:X,matches:t.parse(g(X))}))}sort(B){const W=new Map(k.Iterable.map(B,q=>[q,g(q)]));let X=[];for(const{matches:q}of this.d)for(const[_,Q]of W)if(q(Q)){X.push(_),W.delete(_);break}return W.size&&(X=X.concat([...W.keys()].sort((q,_)=>this.e.indexOf(q)-this.e.indexOf(_)))),X}prioritize(B,W){const X=this.f(B);if(X===-1){this.d.unshift({pattern:B,matches:t.parse(g(B))});return}const q=new Set(W.map(Q=>this.f(Q,X)));q.delete(-1);const _=Array.from(q).sort();this.d.splice(X+1,0,..._.map(Q=>this.d[Q]));for(let Q=_.length-1;Q>=0;Q--)this.d.splice(_[Q],1)}toArray(){return this.d.map(B=>B.pattern)}f(B,W=this.d.length){const X=g(B);for(let q=0;q<W;q++)if(this.d[q].matches(X))return q;return-1}}e.MimeTypeDisplayOrder=p;function b(z,B,W,X=(q,_)=>q===_){const q=[];function _(ge,te,J){if(te===0&&J.length===0)return;const fe=q[q.length-1];fe&&fe.start+fe.deleteCount===ge?(fe.deleteCount+=te,fe.toInsert.push(...J)):q.push({start:ge,deleteCount:te,toInsert:J})}let Q=0,Z=0;for(;;){if(Q===z.length){_(Q,0,B.slice(Z));break}if(Z===B.length){_(Q,z.length-Q,[]);break}const ge=z[Q],te=B[Z];if(X(ge,te)){Q+=1,Z+=1;continue}W(te)?(_(Q,1,[]),Q+=1):(_(Q,0,[te]),Z+=1)}return q}e.diff=b,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(z){z.default="default",z.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function s(z){const B=z;return!!((typeof B.include=="string"||t.isRelativePattern(B.include))&&(typeof B.exclude=="string"||t.isRelativePattern(B.exclude)))}e.isDocumentExcludePattern=s;function a(z,B,W){if(Array.isArray(z.viewType)&&z.viewType.indexOf(B)>=0||z.viewType===B)return!0;if(z.filenamePattern){const X=s(z.filenamePattern)?z.filenamePattern.include:z.filenamePattern,q=s(z.filenamePattern)?z.filenamePattern.exclude:void 0;if(t.match(X,(0,A.basename)(W.fsPath).toLowerCase()))return!(q&&t.match(q,(0,A.basename)(W.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=a,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling"};var u;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(u=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class c{static create(B){return`${c.d}${B}`}static parse(B){if(B.startsWith(c.d))return B.substring(c.d.length)}}e.NotebookWorkingCopyTypeIdentifier=c,c.d="notebook/";function l(z){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(z)}e.isTextStreamMime=l;const n=new TextDecoder;function r(z){const B=[];let W=!1;for(const X of z)(B.length===0||W)&&(B.push(X),W=!0);return M(B),F(o.VSBuffer.concat(B.map(X=>o.VSBuffer.wrap(X))))}e.compressOutputItemStreams=r;const f=`${String.fromCharCode(27)}[A`,E=f.split("").map(z=>z.charCodeAt(0)),T=10;function M(z){z.forEach((B,W)=>{if(W===0||B.length<f.length)return;const X=z[W-1],q=B.subarray(0,f.length);if(q[0]===E[0]&&q[1]===E[1]&&q[2]===E[2]){const _=X.lastIndexOf(T);if(_===-1)return;z[W-1]=X.subarray(0,_),z[W]=B.subarray(f.length)}})}function G(z){let B=z;do z=B,B=z.replace(/[^\n]\x08/gm,"");while(B.length<z.length);return z}function V(z){for(z=z.replace(/\r+\n/gm,`
`);z.search(/\r[^$]/g)>-1;){const B=z.match(/^(.*)\r+/m)[1];let W=z.match(/\r+(.*)$/m)[1];W=W+B.slice(W.length,B.length),z=z.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,W)}return z}const N="\b".charCodeAt(0),U="\r".charCodeAt(0);function F(z){return!z.buffer.includes(N)&&!z.buffer.includes(U)?z:o.VSBuffer.fromString(V(G(n.decode(z.buffer))))}}),define(ye[221],Ce([1,0,3]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(k){k[k.Output=1]="Output",k[k.OutputItems=2]="OutputItems",k[k.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,o.createDecorator)("INotebookExecutionService")}),define(ye[222],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function o(I){return[...I.entries()]}e.serializeEnvironmentVariableCollection=o;function t(I){return new Map(I)}e.deserializeEnvironmentVariableCollection=t;function k(I){return Array.from(I.entries()).map(A=>[A[0],o(A[1].map)])}e.serializeEnvironmentVariableCollections=k;function R(I){return new Map(I.map(A=>[A[0],{map:t(A[1])}]))}e.deserializeEnvironmentVariableCollections=R}),define(ye[56],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var o;(function(R){R.Delimiter="\0"})(o=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class k{static fromExtHostTestItem(I,A,S=I.parent){if(I._isRoot)return new k([A]);const C=[I.id];for(let L=S;L&&L.id!==A;L=L.parent)C.push(L.id);return C.push(A),new k(C.reverse())}static isRoot(I){return!I.includes("\0")}static root(I){const A=I.indexOf("\0");return A===-1?I:I.slice(0,A)}static fromString(I){return new k(I.split("\0"))}static join(I,A){return new k([...I.path,A])}static joinToString(I,A){return I.toString()+"\0"+A}static parentId(I){const A=I.lastIndexOf("\0");return A===-1?void 0:I.slice(0,A)}static compare(I,A){return I===A?0:A.startsWith(I+"\0")?2:I.startsWith(A+"\0")?3:1}constructor(I,A=I.length){if(this.path=I,this.d=A,I.length===0||A<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new k(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let I=1;I<=this.d;I++)yield new k(this.path,I)}*idsToRoot(){for(let I=this.d;I>0;I--)yield new k(this.path,I)}compare(I){if(typeof I=="string")return k.compare(this.toString(),I);for(let A=0;A<I.d&&A<this.d;A++)if(I.path[A]!==this.path[A])return 1;return I.d>this.d?2:I.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let I=1;I<this.d;I++)this.c+="\0",this.c+=this.path[I]}return this.c}}e.TestId=k}),define(ye[70],Ce([1,0,2,35,56]),function(ne,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var R;(function(l){l[l.Unset=0]="Unset",l[l.Queued=1]="Queued",l[l.Running=2]="Running",l[l.Passed=3]="Passed",l[l.Failed=4]="Failed",l[l.Skipped=5]="Skipped",l[l.Errored=6]="Errored"})(R=e.TestResultState||(e.TestResultState={}));var I;(function(l){l[l.Run=2]="Run",l[l.Debug=4]="Debug",l[l.Coverage=8]="Coverage",l[l.HasNonDefaultProfile=16]="HasNonDefaultProfile",l[l.HasConfigurable=32]="HasConfigurable"})(I=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var A;(function(l){l.serialize=n=>({range:n.range.toJSON(),uri:n.uri.toJSON()}),l.deserialize=n=>({range:t.Range.lift(n.range),uri:o.URI.revive(n.uri)})})(A=e.IRichLocation||(e.IRichLocation={}));var S;(function(l){l[l.Error=0]="Error",l[l.Output=1]="Output"})(S=e.TestMessageType||(e.TestMessageType={}));var C;(function(l){l.serialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&A.serialize(n.location)}),l.deserialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&A.deserialize(n.location)})})(C=e.ITestErrorMessage||(e.ITestErrorMessage={}));const L=(l,n)=>`${n?"s":"e"}${l}`;e.getMarkId=L;var P;(function(l){l.serialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&A.serialize(n.location)}),l.deserialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&A.deserialize(n.location)})})(P=e.ITestOutputMessage||(e.ITestOutputMessage={}));var y;(function(l){l.serialize=n=>n.type===0?C.serialize(n):P.serialize(n),l.deserialize=n=>n.type===0?C.deserialize(n):P.deserialize(n)})(y=e.ITestMessage||(e.ITestMessage={}));var D;(function(l){l.serializeWithoutMessages=n=>({state:n.state,duration:n.duration,messages:[]}),l.serialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(y.serialize)}),l.deserialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(y.deserialize)})})(D=e.ITestTaskState||(e.ITestTaskState={}));const v="\0",d=(l,n)=>l+v+n;e.namespaceTestTag=d;const m=l=>{const n=l.indexOf(v);return{ctrlId:l.slice(0,n),tagId:l.slice(n+1)}};e.denamespaceTestTag=m;var h;(function(l){l.serialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?.toJSON(),range:n.range?.toJSON()||null,description:n.description,error:n.error,sortText:n.sortText}),l.deserialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?o.URI.revive(n.uri):void 0,range:n.range?t.Range.lift(n.range):null,description:n.description,error:n.error,sortText:n.sortText})})(h=e.ITestItem||(e.ITestItem={}));var w;(function(l){l[l.NotExpandable=0]="NotExpandable",l[l.Expandable=1]="Expandable",l[l.BusyExpanding=2]="BusyExpanding",l[l.Expanded=3]="Expanded"})(w=e.TestItemExpandState||(e.TestItemExpandState={}));var g;(function(l){l.serialize=n=>({expand:n.expand,item:h.serialize(n.item)}),l.deserialize=n=>({controllerId:k.TestId.root(n.item.extId),expand:n.expand,item:h.deserialize(n.item)})})(g=e.InternalTestItem||(e.InternalTestItem={}));var p;(function(l){l.serialize=n=>{let r;return n.item&&(r={},n.item.label!==void 0&&(r.label=n.item.label),n.item.tags!==void 0&&(r.tags=n.item.tags),n.item.busy!==void 0&&(r.busy=n.item.busy),n.item.uri!==void 0&&(r.uri=n.item.uri?.toJSON()),n.item.range!==void 0&&(r.range=n.item.range?.toJSON()),n.item.description!==void 0&&(r.description=n.item.description),n.item.error!==void 0&&(r.error=n.item.error),n.item.sortText!==void 0&&(r.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:r}},l.deserialize=n=>{let r;return n.item&&(r={},n.item.label!==void 0&&(r.label=n.item.label),n.item.tags!==void 0&&(r.tags=n.item.tags),n.item.busy!==void 0&&(r.busy=n.item.busy),n.item.range!==void 0&&(r.range=n.item.range?t.Range.lift(n.item.range):null),n.item.description!==void 0&&(r.description=n.item.description),n.item.error!==void 0&&(r.error=n.item.error),n.item.sortText!==void 0&&(r.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:r}}})(p=e.ITestItemUpdate||(e.ITestItemUpdate={}));const b=(l,n)=>{n.expand!==void 0&&(l.expand=n.expand),n.item!==void 0&&(l.item=l.item?Object.assign(l.item,n.item):n.item)};e.applyTestItemUpdate=b;var i;(function(l){l.serializeWithoutMessages=n=>({...g.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(D.serializeWithoutMessages),retired:n.retired}),l.serialize=n=>({...g.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(D.serialize),retired:n.retired}),l.deserialize=n=>({...g.deserialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(D.deserialize),retired:!0})})(i=e.TestResultItem||(e.TestResultItem={}));var s;(function(l){l[l.Function=0]="Function",l[l.Statement=1]="Statement"})(s=e.DetailType||(e.DetailType={}));var a;(function(l){l[l.Add=0]="Add",l[l.Update=1]="Update",l[l.DocumentSynced=2]="DocumentSynced",l[l.Remove=3]="Remove",l[l.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",l[l.Retire=5]="Retire",l[l.AddTag=6]="AddTag",l[l.RemoveTag=7]="RemoveTag"})(a=e.TestDiffOpType||(e.TestDiffOpType={}));var u;(function(l){l.deserialize=n=>n.op===0?{op:n.op,item:g.deserialize(n.item)}:n.op===1?{op:n.op,item:p.deserialize(n.item)}:n.op===2?{op:n.op,uri:o.URI.revive(n.uri),docv:n.docv}:n,l.serialize=n=>n.op===0?{op:n.op,item:g.serialize(n.item)}:n.op===1?{op:n.op,item:p.serialize(n.item)}:n})(u=e.TestsDiffOp||(e.TestsDiffOp={}));class c{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(n){const r=this.o();for(const f of n)switch(f.op){case 0:this.j(g.deserialize(f.item),r);break;case 1:this.k(p.deserialize(f.item),r);break;case 3:this.l(f.itemId,r);break;case 5:this.m(f.itemId);break;case 4:this.updatePendingRoots(f.amount);break;case 6:this.c.set(f.tag.id,f.tag);break;case 7:this.c.delete(f.id);break}r.complete?.()}j(n,r){const f=k.TestId.parentId(n.item.extId)?.toString();let E;if(!f)E=this.p(n),this.f.add(E),this.d.set(n.item.extId,E);else if(this.d.has(f)){const T=this.d.get(f);T.children.add(n.item.extId),E=this.p(n,T),this.d.set(n.item.extId,E)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(n)}`);return}return r.add?.(E),n.expand===2&&this.g++,E}k(n,r){const f=this.d.get(n.extId);if(!!f)return n.expand!==void 0&&(f.expand===2&&this.g--,n.expand===2&&this.g++),(0,e.applyTestItemUpdate)(f,n),r.update?.(f),f}l(n,r){const f=this.d.get(n);if(!f)return;const E=k.TestId.parentId(f.item.extId)?.toString();E?this.d.get(E).children.delete(f.item.extId):this.f.delete(f);const T=[[n]];for(;T.length;)for(const M of T.pop()){const G=this.d.get(M);G&&(T.push(G.children),this.d.delete(M),r.remove?.(G,G!==f),G.expand===2&&this.g--)}}m(n){}updatePendingRoots(n){this.h+=n}o(){return{}}}e.AbstractIncrementalTestCollection=c}),define(ye[92],Ce([1,0,16,4,6,49,70,56]),function(ne,e,o,t,k,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var S;(function(w){w[w.Upsert=0]="Upsert",w[w.SetTags=1]="SetTags",w[w.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",w[w.RemoveChild=3]="RemoveChild",w[w.SetProp=4]="SetProp",w[w.Bulk=5]="Bulk",w[w.DocumentSynced=6]="DocumentSynced"})(S=e.TestItemEventOp||(e.TestItemEventOp={}));const C=(w,g)=>w===g,P=Object.entries({range:(w,g)=>w===g?!0:!w||!g?!1:w.equalsRange(g),busy:C,label:C,description:C,error:C,sortText:C,tags:(w,g)=>!(w.length!==g.length||w.some(p=>!g.includes(p)))}),y=(w,g)=>{let p;for(const[b,i]of P)i(w[b],g[b])||(p?p[b]=g[b]:p={[b]:g[b]});return p};class D extends k.Disposable{get root(){return this.m.root}constructor(g){super(),this.m=g,this.f=this.B(new o.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new t.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(g){this.h=g;for(const p of this.tree.values())this.G(p)}collectDiff(){const g=this.k;return this.k=[],g}pushDiff(g){switch(g.op){case 2:{for(const p of this.k)if(p.op===2&&p.uri===g.uri){p.docv=g.docv;return}break}case 1:{const p=this.k[this.k.length-1];if(p){if(p.op===1&&p.item.extId===g.item.extId){(0,I.applyTestItemUpdate)(p.item,g.item);return}if(p.op===0&&p.item.item.extId===g.item.extId){(0,I.applyTestItemUpdate)(p.item,g.item);return}}break}}this.k.push(g),this.f.isScheduled()||this.f.schedule()}expand(g,p){const b=this.tree.get(g);if(!!b){if((b.expandLevels===void 0||p>b.expandLevels)&&(b.expandLevels=p),b.expand===1){const i=this.I(b);return i.isOpen()?this.H(b,p-1):i.wait().then(()=>this.H(b,p-1))}else if(b.expand===3)return b.resolveBarrier?.isOpen()===!1?b.resolveBarrier.wait().then(()=>this.H(b,p-1)):this.H(b,p-1)}}dispose(){for(const g of this.tree.values())this.m.getApiFor(g.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(g,p){switch(p.op){case 3:this.L(A.TestId.joinToString(g.fullId,p.id));break;case 0:this.u(p.item,g);break;case 5:for(const b of p.ops)this.p(g,b);break;case 1:this.w(p.new,p.old,g.fullId.toString());break;case 2:this.G(g);break;case 4:this.pushDiff({op:1,item:{extId:g.fullId.toString(),item:p.update}});break;case 6:this.s(g.actual.uri);break;default:(0,R.assertNever)(p)}}s(g){g&&this.pushDiff({op:2,uri:g,docv:this.m.getDocumentVersion(g)})}u(g,p){const b=A.TestId.fromExtHostTestItem(g,this.root.id,p?.actual),i=this.m.getApiFor(g);i.parent&&i.parent!==p?.actual&&this.m.getChildren(i.parent).delete(g.id);let s=this.tree.get(b.toString());if(!s){s={fullId:b,actual:g,expandLevels:p?.expandLevels?p.expandLevels-1:void 0,expand:0},g.tags.forEach(this.y,this),this.tree.set(s.fullId.toString(),s),this.C(g,p),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:s.expand,item:this.m.toITestItem(g)}}),this.F(g,s,p);return}if(s.actual===g){this.D(g,s,p);return}if(s.actual.uri?.toString()!==g.uri?.toString())return this.L(b.toString()),this.u(g,p);const a=this.m.getChildren(s.actual),u=s.actual,c=y(this.m.toITestItem(u),this.m.toITestItem(g));this.m.getApiFor(u).listener=void 0,s.actual=g,s.expand=0,c&&(c.hasOwnProperty("tags")&&(this.w(g.tags,u.tags,b.toString()),delete c.tags),this.p(s,{op:4,update:c})),this.F(g,s,p);for(const[l,n]of a)this.m.getChildren(g).get(n.id)||this.L(A.TestId.joinToString(b,n.id));this.s(s.actual.uri)}w(g,p,b){const i=new Set(p.map(s=>s.id));for(const s of g)i.delete(s.id)||this.y(s);this.pushDiff({op:1,item:{extId:b,item:{tags:g.map(s=>(0,I.namespaceTestTag)(this.m.controllerId,s.id))}}}),i.forEach(this.z,this)}y(g){const p=this.j.get(g.id);p?p.refCount++:(this.j.set(g.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,I.namespaceTestTag)(this.m.controllerId,g.id)}}))}z(g){const p=this.j.get(g);p&&!--p.refCount&&(this.j.delete(g),this.pushDiff({op:7,id:(0,I.namespaceTestTag)(this.m.controllerId,g)}))}C(g,p){this.m.getApiFor(g).parent=p&&p.actual!==this.root?p.actual:void 0}D(g,p,b){this.C(g,b);const i=this.m.getApiFor(g);i.parent=b?.actual,i.listener=s=>this.p(p,s),this.G(p)}F(g,p,b){this.D(g,p,b);for(const[i,s]of this.m.getChildren(g))this.u(s,p)}G(g){let p;this.h?g.resolveBarrier?p=g.resolveBarrier.isOpen()?3:2:p=g.actual.canResolveChildren?1:0:p=0,p!==g.expand&&(g.expand=p,this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:p}}),p===1&&g.expandLevels!==void 0&&this.I(g))}H(g,p){if(p<0)return;const b=[];for(const[i,s]of this.m.getChildren(g.actual)){const a=this.expand(A.TestId.joinToString(g.fullId,s.id),p);(0,o.isThenable)(a)&&b.push(a)}if(b.length)return Promise.all(b).then(()=>{})}I(g){if(g.resolveBarrier)return g.resolveBarrier;if(!this.h){const s=new o.Barrier;return s.open(),s}g.expand=2,this.J(g);const p=g.resolveBarrier=new o.Barrier,b=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,s)};let i;try{i=this.h(g.actual===this.root?void 0:g.actual)}catch(s){b(s)}return(0,o.isThenable)(i)?i.catch(b).then(()=>{p.open(),this.G(g)}):(p.open(),this.G(g)),g.resolveBarrier}J(g){this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:g.expand}})}L(g){const p=this.tree.get(g);if(!p)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:g});const b=[p];for(;b.length;){const i=b.pop();if(!!i){this.m.getApiFor(i.actual).listener=void 0;for(const s of i.actual.tags)this.z(s.id);this.tree.delete(i.fullId.toString());for(const[s,a]of this.m.getChildren(i.actual))b.push(this.tree.get(A.TestId.joinToString(i.fullId,a.id)))}}}flushDiff(){const g=this.collectDiff();g.length&&this.g.fire(g)}}e.TestItemCollection=D;class v extends Error{constructor(g){super(`Attempted to insert a duplicate test item ID ${g}`)}}e.DuplicateTestItemError=v;class d extends Error{constructor(g){super(`TestItem with ID "${g}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=d;class m extends Error{constructor(g,p,b){super(`TestItem with ID "${g}" is from controller "${p}" and cannot be added as a child of an item from controller "${b}".`)}}e.MixedTestItemController=m;const h=(w,g,p)=>{let b=new Map;return{get size(){return b.size},forEach(i,s){for(const a of b.values())i.call(s,a,this)},[Symbol.iterator](){return b.entries()},replace(i){const s=new Map,a=new Set(b.keys()),u={op:5,ops:[]};for(const c of i){if(!(c instanceof p))throw new d(c.id);const l=g(c).controllerId;if(l!==w.controllerId)throw new m(c.id,l,w.controllerId);if(s.has(c.id))throw new v(c.id);s.set(c.id,c),a.delete(c.id),u.ops.push({op:0,item:c})}for(const c of a.keys())u.ops.push({op:3,id:c});w.listener?.(u),b=s},add(i){if(!(i instanceof p))throw new d(i.id);b.set(i.id,i),w.listener?.({op:0,item:i})},delete(i){b.delete(i)&&w.listener?.({op:3,id:i})},get(i){return b.get(i)},toJSON(){return Array.from(b.values())}}};e.createTestItemChildren=h}),define(ye[132],Ce([1,0,92]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,k=(I,A)=>{const S={controllerId:A};return t.set(I,S),S};e.createPrivateApiFor=k;const R=I=>{const A=t.get(I);if(!A)throw new o.InvalidTestItemError(I?.id||"<unknown>");return A};e.getPrivateApiFor=R}),define(ye[93],Ce([1,0,15,2]),function(ne,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function k(A,S){return A.scheme===o.Schemas.http||A.scheme===o.Schemas.https?A:(S&&S.authority&&S.isRemote&&A.scheme===o.Schemas.file&&(A=t.URI.from({scheme:o.Schemas.vscodeRemote,authority:S.authority,path:A.path})),t.URI.from({scheme:o.Schemas.https,authority:`${A.scheme}+${R(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=k;function R(A){return A.replace(/./g,S=>{const C=S.charCodeAt(0);return C>=97&&C<=122||C>=65&&C<=90||C>=48&&C<=57?S:"-"+C.toString(16).padStart(4,"0")})}function I(A){return A.replace(/-([0-9a-f]{4})/g,(S,C)=>String.fromCharCode(parseInt(C,16)))}e.decodeAuthority=I}),define(ye[223],Ce([1,0,4,6,93]),function(ne,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class R{constructor(A,S,C){this.d=A,this.e=S,this.f=C,this.a=0,this.b=new t.DisposableStore,this.c=new Map,this.b.add(S.onDidChangeVisibleTextEditors(()=>{const L=S.getVisibleTextEditors();for(const P of this.c.values())L.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this.c.forEach(A=>A.inset.dispose()),this.b.dispose()}createWebviewEditorInset(A,S,C,L,P){let y;for(const g of this.e.getVisibleTextEditors(!0))if(g.value===A){y=g;break}if(!y)throw new Error("not a visible editor");const D=this,v=this.a++,d=new o.Emitter,m=new o.Emitter,h=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(g){return(0,k.asWebviewUri)(g,D.f)}get cspSource(){return k.webviewGenericCspSource}set options(g){this.b=g,D.d.$setOptions(v,g)}get options(){return this.b}set html(g){this.a=g,D.d.$setHtml(v,g)}get html(){return this.a}get onDidReceiveMessage(){return d.event}postMessage(g){return D.d.$postMessage(v,g)}},w=new class{constructor(){this.editor=A,this.line=S,this.height=C,this.webview=h,this.onDidDispose=m.event}dispose(){D.c.has(v)&&(D.c.delete(v),D.d.$disposeEditorInset(v),m.fire(),m.dispose(),d.dispose())}};return this.d.$createEditorInset(v,y.id,y.value.document.uri,S+1,C,L||{},P.identifier,P.extensionLocation),this.c.set(v,{editor:A,inset:w,onDidReceiveMessage:d}),w}$onDidDispose(A){const S=this.c.get(A);S&&S.inset.dispose()}$onDidReceiveMessage(A,S){this.c.get(A)?.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=R}),define(ye[224],Ce([1,0,3]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,o.createDecorator)("configurationResolverService");var t;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator"})(t=e.VariableKind||(e.VariableKind={}));class k extends Error{constructor(I,A){super(A),this.variable=I}}e.VariableError=k}),define(ye[225],Ce([1,0,9,36,11,23,12,112,188,224,8]),function(ne,e,o,t,k,R,I,A,S,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(D,v,d,m){this.g=new Map,this.a=D,this.b=v,this.d=d,m&&(this.c=m.then(h=>this.h(h)))}h(D){if(I.isWindows){const v=Object.create(null);return Object.keys(D).forEach(d=>{v[d.toLowerCase()]=D[d]}),v}return D}resolveWithEnvironment(D,v,d){return this.j({env:this.h(D),userHome:void 0},v?v.uri:void 0,d)}async resolveAsync(D,v){const d={env:await this.c,userHome:await this.d};return this.j(d,D?D.uri:void 0,v)}async i(D,v,d,m){const h=R.deepClone(v);I.isWindows&&h.windows?Object.keys(h.windows).forEach(g=>h[g]=h.windows[g]):I.isMacintosh&&h.osx?Object.keys(h.osx).forEach(g=>h[g]=h.osx[g]):I.isLinux&&h.linux&&Object.keys(h.linux).forEach(g=>h[g]=h.linux[g]),delete h.windows,delete h.osx,delete h.linux;const w={env:await this.c,userHome:await this.d};return this.j(w,D?D.uri:void 0,h,d,m)}async resolveAnyAsync(D,v,d){return this.i(D,v,d)}async resolveAnyMap(D,v,d){const m=new Map;return{newConfig:await this.i(D,v,d,m),resolvedVariables:m}}resolveWithInteractionReplace(D,v,d,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(D,v,d,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(D,v){if(this.g.has(D))throw new Error("Variable "+D+" is contributed twice.");this.g.set(D,v)}async j(D,v,d,m,h){if(k.isString(d))return this.l(D,v,d,m,h);if(Array.isArray(d))return Promise.all(d.map(w=>this.j(D,v,w,m,h)));if(k.isObject(d)){const w=Object.create(null),g=await Promise.all(Object.keys(d).map(async p=>[await this.l(D,v,p,m,h),await this.j(D,v,d[p],m,h)]));for(const[p,b]of g)w[p]=b;return w}return d}l(D,v,d,m,h){return(0,L.replaceAsync)(d,P.VARIABLE_REGEXP,async(w,g)=>{if(g.includes(P.VARIABLE_LHS))return w;let p=await this.n(D,w,g,v,m);return h?.set(g,p),p!==w&&k.isString(p)&&p.match(P.VARIABLE_REGEXP)&&(p=await this.l(D,v,p,m,h)),p})}m(D){return this.b?this.b.getUriLabel(D,{noPrefix:!0}):D.fsPath}async n(D,v,d,m,h){let w;const g=d.split(":");g.length>1&&(d=g[0],w=g[1]);const p=s=>{const a=this.a.getFilePath();if(a)return(0,A.normalizeDriveLetter)(a);throw new C.VariableError(s,(0,S.localize)(0,null,v))},b=s=>{const a=p(s);if(this.a.getWorkspaceFolderPathForFile){const u=this.a.getWorkspaceFolderPathForFile();if(u)return(0,A.normalizeDriveLetter)(u)}throw new C.VariableError(s,(0,S.localize)(1,null,v,o.basename(a)))},i=s=>{if(w){const a=this.a.getFolderUri(w);if(a)return a;throw new C.VariableError(s,(0,S.localize)(2,null,v,w))}if(m)return m;throw this.a.getWorkspaceFolderCount()>1?new C.VariableError(s,(0,S.localize)(3,null,v)):new C.VariableError(s,(0,S.localize)(4,null,v))};switch(d){case"env":if(w){if(D.env){const s=D.env[I.isWindows?w.toLowerCase():w];if(k.isString(s))return s}return""}throw new C.VariableError(C.VariableKind.Env,(0,S.localize)(5,null,v));case"config":if(w){const s=this.a.getConfigurationValue(m,w);if(k.isUndefinedOrNull(s))throw new C.VariableError(C.VariableKind.Config,(0,S.localize)(6,null,v,w));if(k.isObject(s))throw new C.VariableError(C.VariableKind.Config,(0,S.localize)(7,null,v,w));return s}throw new C.VariableError(C.VariableKind.Config,(0,S.localize)(8,null,v));case"command":return this.o(C.VariableKind.Command,v,w,h,"command");case"input":return this.o(C.VariableKind.Input,v,w,h,"input");case"extensionInstallFolder":if(w){const s=await this.a.getExtension(w);if(!s)throw new C.VariableError(C.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,v,w));return this.m(s.extensionLocation)}throw new C.VariableError(C.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,v));default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.m(i(C.VariableKind.WorkspaceFolder)));case"cwd":return m||w?(0,A.normalizeDriveLetter)(this.m(i(C.VariableKind.Cwd))):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,A.normalizeDriveLetter)(o.basename(this.m(i(C.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(D.userHome)return D.userHome;throw new C.VariableError(C.VariableKind.UserHome,(0,S.localize)(11,null,v))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new C.VariableError(C.VariableKind.LineNumber,(0,S.localize)(12,null,v))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new C.VariableError(C.VariableKind.SelectedText,(0,S.localize)(13,null,v))}case"file":return p(C.VariableKind.File);case"fileWorkspaceFolder":return b(C.VariableKind.FileWorkspaceFolder);case"relativeFile":return m||w?o.relative(this.m(i(C.VariableKind.RelativeFile)),p(C.VariableKind.RelativeFile)):p(C.VariableKind.RelativeFile);case"relativeFileDirname":{const s=o.dirname(p(C.VariableKind.RelativeFileDirname));if(m||w){const a=o.relative(this.m(i(C.VariableKind.RelativeFileDirname)),s);return a.length===0?".":a}return s}case"fileDirname":return o.dirname(p(C.VariableKind.FileDirname));case"fileExtname":return o.extname(p(C.VariableKind.FileExtname));case"fileBasename":return o.basename(p(C.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=o.basename(p(C.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-o.extname(s).length)}case"fileDirnameBasename":return o.basename(o.dirname(p(C.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||v}case"execInstallFolder":{const s=this.a.getAppRoot();return s||v}case"pathSeparator":return o.sep;default:try{const s=w?`${d}:${w}`:d;return this.o(C.VariableKind.Unknown,v,s,h,void 0)}catch{return v}}}}o(D,v,d,m,h){if(d&&m){const w=h===void 0?m[d]:m[h+":"+d];if(typeof w=="string")return w;throw new C.VariableError(D,(0,S.localize)(14,null,v))}return v}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ye[133],Ce([1,0,3,130]),function(ne,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,o.createDecorator)("editorGroupsService");var k;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(k=e.GroupDirection||(e.GroupDirection={}));var R;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(R=e.GroupOrientation||(e.GroupOrientation={}));var I;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(I=e.GroupLocation||(e.GroupLocation={}));var A;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EVEN=1]="EVEN",v[v.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function C(v){const d=v;return(0,t.isEditorInput)(d?.editor)&&(0,t.isEditorInput)(d?.replacement)}e.isEditorReplacement=C;var L;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L=e.GroupsOrder||(e.GroupsOrder={}));var P;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(P=e.OpenEditorContext||(e.OpenEditorContext={}));function y(v){const d=v;return!!d&&typeof d.id=="number"&&Array.isArray(d.editors)}e.isEditorGroup=y;function D(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=D}),define(ye[226],Ce([1,0,3,133]),function(ne,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,o.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function k(R){const I=R;return typeof R=="number"||(0,t.isEditorGroup)(I)}e.isPreferredGroup=k}),define(ye[227],Ce([1,0,3,194]),function(ne,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,o.refineServiceDecorator)(t.IEnvironmentService)}),define(ye[134],Ce([1,0,26,4,9]),function(ne,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class R{constructor(P){this.removedDueToLooping=P}}e.DeltaExtensionsResult=R;class I{static isHostExtension(P,y,D){if(y.getExtensionDescription(P))return!1;const v=D.getExtensionDescription(P);return v?!!((v.main||v.browser)&&v.api==="none"):!1}constructor(P){this.c=new t.Emitter,this.onDidChange=this.c.event,this.d=P,this.h()}h(){this.d.sort(S),this.e=new Map,this.f=[],this.g=new Map;for(const P of this.d){if(this.e.has(o.ExtensionIdentifier.toKey(P.identifier))){console.error("Extension `"+P.identifier.value+"` is already registered");continue}if(this.e.set(o.ExtensionIdentifier.toKey(P.identifier),P),this.f.push(P),Array.isArray(P.activationEvents))for(let y of P.activationEvents)y==="onUri"&&(y=`onUri:${o.ExtensionIdentifier.toKey(P.identifier)}`),this.g.has(y)||this.g.set(y,[]),this.g.get(y).push(P)}}set(P){this.d=P,this.h(),this.c.fire(void 0)}deltaExtensions(P,y){this.d=C(this.d,y),this.d=this.d.concat(P);const D=I.j(this.d);return this.d=C(this.d,D.map(v=>v.identifier)),this.h(),this.c.fire(void 0),new R(D)}static j(P){const y=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(h){this.d.has(h)||(this.d.add(h),this.e.push(h))}addArc(h,w){this.addNode(h),this.addNode(w),this.c.has(h)?this.c.get(h).push(w):this.c.set(h,[w])}getArcs(h){return this.c.has(h)?this.c.get(h):[]}hasOnlyGoodArcs(h,w){const g=y.getArcs(h);for(let p=0;p<g.length;p++)if(!w.has(g[p]))return!1;return!0}getNodes(){return this.e}},D=new Map;for(const h of P){const w=o.ExtensionIdentifier.toKey(h.identifier);if(D.set(w,h),h.extensionDependencies)for(const g of h.extensionDependencies){const p=o.ExtensionIdentifier.toKey(g);y.addArc(w,p)}}const v=new Set;y.getNodes().filter(h=>y.getArcs(h).length===0).forEach(h=>v.add(h));const d=y.getNodes().filter(h=>!v.has(h));let m;do{m=!1;for(let h=0;h<d.length;h++){const w=d[h];y.hasOnlyGoodArcs(w,v)&&(d.splice(h,1),h--,v.add(w),m=!0)}}while(m);return d.map(h=>D.get(h))}containsActivationEvent(P){return this.g.has(P)}containsExtension(P){return this.e.has(o.ExtensionIdentifier.toKey(P))}getExtensionDescriptionsForActivationEvent(P){const y=this.g.get(P);return y?y.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(P){const y=this.e.get(o.ExtensionIdentifier.toKey(P));return y||void 0}getExtensionDescriptionByUUID(P){for(const y of this.f)if(y.uuid===P)return y}getExtensionDescriptionByIdOrUUID(P,y){return this.getExtensionDescription(P)??(y?this.getExtensionDescriptionByUUID(y):void 0)}}e.ExtensionDescriptionRegistry=I;var A;(function(L){L[L.Builtin=0]="Builtin",L[L.User=1]="User",L[L.Dev=2]="Dev"})(A||(A={}));function S(L,P){const y=L.isBuiltin?0:L.isUnderDevelopment?2:1,D=P.isBuiltin?0:P.isUnderDevelopment?2:1;if(y!==D)return y-D;const v=k.posix.basename(L.extensionLocation.path),d=k.posix.basename(P.extensionLocation.path);return v<d?-1:v>d?1:0}function C(L,P){const y=new Set;return P.forEach(D=>y.add(o.ExtensionIdentifier.toKey(D))),L.filter(D=>!y.has(o.ExtensionIdentifier.toKey(D.identifier)))}}),define(ye[228],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var o;(function(L){L[L.IPC=1]="IPC",L[L.Socket=2]="Socket",L[L.MessagePort=3]="MessagePort"})(o=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class t{constructor(P){this.pipeName=P,this.type=1}serialize(P){P[t.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=t,t.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class k{constructor(){this.type=2}serialize(P){P[k.ENV_KEY]="1"}}e.SocketExtHostConnection=k,k.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class R{constructor(){this.type=3}serialize(P){P[R.ENV_KEY]="1"}}e.MessagePortExtHostConnection=R,R.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function I(L){delete L[t.ENV_KEY],delete L[k.ENV_KEY],delete L[R.ENV_KEY]}function A(L,P){I(P),L.serialize(P)}e.writeExtHostConnection=A;function S(L){if(L[t.ENV_KEY])return C(L,new t(L[t.ENV_KEY]));if(L[k.ENV_KEY])return C(L,new k);if(L[R.ENV_KEY])return C(L,new R);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=S;function C(L,P){return I(L),P}}),define(ye[94],Ce([1,0,22]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var t;(function(C){C[C.Desktop=1]="Desktop",C[C.Web=2]="Web"})(t=e.UIKind||(e.UIKind={}));var k;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(k=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var R;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(R=e.MessageType||(e.MessageType={}));function I(C){const L=o.VSBuffer.alloc(1);switch(C){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.createMessageOfType=I;function A(C,L){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.isMessageOfType=A;var S;(function(C){C.Start="START_NATIVE_LOG",C.End="END_NATIVE_LOG"})(S=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(ye[95],Ce([1,0,3,4,13,25,94,67,68,23,2]),function(ne,e,o,t,k,R,I,A,S,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let P=class{constructor(d,m){this.i=d,this.a=new t.Emitter,this.onDidChangeTelemetryEnabled=this.a.event,this.b=new t.Emitter,this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.d=0,this.f=!1,this.h=new Map,this.g=m.createLogger(L.URI.revive(this.i.environment.extensionTelemetryLogResource)),this.g.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.g.info("===========================================================")}getTelemetryConfiguration(){return this.d===3}getTelemetryDetails(){return{isCrashEnabled:this.d>=1,isErrorsEnabled:this.c.error?this.d>=2:!1,isUsageEnabled:this.c.usage?this.d>=3:!1}}instantiateLogger(d,m,h){const w=this.getTelemetryDetails(),g=new y(m,h,d,this.g,this.f,this.getBuiltInCommonProperties(d),{isUsageEnabled:w.isUsageEnabled,isErrorsEnabled:w.isErrorsEnabled});return this.h.set(d.identifier.value,g),g.apiTelemetryLogger}$initializeTelemetryLevel(d,m,h){this.d=d,this.f=m,this.c=h??{usage:!0,error:!0}}getBuiltInCommonProperties(d){const m={};switch(m["common.extname"]=d.name,m["common.extversion"]=d.version,m["common.vscodemachineid"]=this.i.telemetryInfo.machineId,m["common.vscodesessionid"]=this.i.telemetryInfo.sessionId,m["common.vscodeversion"]=this.i.version,m["common.isnewappinstall"]=D(this.i.telemetryInfo.firstSessionDate),m["common.product"]=this.i.environment.appHost,this.i.uiKind){case I.UIKind.Web:m["common.uikind"]="web";break;case I.UIKind.Desktop:m["common.uikind"]="desktop";break;default:m["common.uikind"]="unknown"}return m["common.remotename"]=(0,A.getRemoteName)((0,S.cleanRemoteAuthority)(this.i.remote.authority)),m}$onDidChangeTelemetryLevel(d){this.e=this.getTelemetryConfiguration(),this.d=d;const m=this.getTelemetryDetails();this.h.forEach(h=>{h.updateTelemetryEnablements(m.isUsageEnabled,m.isErrorsEnabled)}),this.e!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails())}onExtensionError(d,m){const h=this.h.get(d.value);return!h||h.ignoreUnhandledExtHostErrors?!1:(h.logError(m),!0)}};P=qe([He(0,R.IExtHostInitDataService),He(1,k.ILoggerService)],P),e.ExtHostTelemetry=P;class y{constructor(d,m,h,w,g,p,b){this.g=h,this.h=w,this.i=g,this.j=p,this.b=new t.Emitter,this.ignoreUnhandledExtHostErrors=m?.ignoreUnhandledErrors??!1,this.e=m?.ignoreBuiltInCommonProperties??!1,this.f=m?.additionalCommonProperties,this.a=d,this.c={isUsageEnabled:b.isUsageEnabled,isErrorsEnabled:b.isErrorsEnabled}}updateTelemetryEnablements(d,m){this.d&&(this.c={isUsageEnabled:d,isErrorsEnabled:m},this.b.fire(this.d))}mixInCommonPropsAndCleanData(d){let m=d.properties??d;return m=(0,S.cleanData)(m,[]),this.f&&(m=(0,C.mixin)(m,this.f)),this.e||(m=(0,C.mixin)(m,this.j)),d.properties?d.properties=m:d=m,d}k(d,m){this.g.publisher==="vscode"?d=this.g.name+"/"+d:d=this.g.identifier.value+"/"+d,m=this.mixInCommonPropsAndCleanData(m||{}),this.i||this.a.logEvent(d,m),this.h.trace(d,m)}logUsage(d,m){!this.c.isUsageEnabled||this.k(d,m)}logError(d,m){!this.c.isErrorsEnabled||(typeof d=="string"?this.k(d,m):this.a.logError(d,m))}get apiTelemetryLogger(){if(!this.d){const d=this,m={logUsage:d.logUsage.bind(d),get isUsageEnabled(){return d.c.isUsageEnabled},get isErrorsEnabled(){return d.c.isErrorsEnabled},logError:d.logError.bind(d),dispose:d.dispose.bind(d),onDidChangeEnableStates:d.b.event.bind(d)};this.d=Object.freeze(m)}return this.d}dispose(){this.a?.flush&&this.a.flush()}}e.ExtHostTelemetryLogger=y;function D(v){const d=Date.now()-new Date(v).getTime();return isNaN(d)?!1:d<1e3*60*60*24}e.isNewAppInstall=D,e.IExtHostTelemetry=(0,o.createDecorator)("IExtHostTelemetry")}),define(ye[27],Ce([1,0,4,2,3,26,206]),function(ne,e,o,t,k,R,I){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new R.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,k.createDecorator)("extensionService");class S{constructor(l){this.affinity=l,this.kind=1}equals(l){return this.kind===l.kind&&this.affinity===l.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=S;class C{constructor(l){this.affinity=l,this.kind=2}equals(l){return this.kind===l.kind&&this.affinity===l.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=C;class L{constructor(){this.kind=3,this.affinity=0}equals(l){return this.kind===l.kind}asString(){return"Remote"}}e.RemoteRunningLocation=L;class P{constructor(l){this.dependency=l}}e.MissingExtensionDependency=P;var y;(function(c){c[c.LocalProcess=1]="LocalProcess",c[c.LocalWebWorker=2]="LocalWebWorker",c[c.Remote=3]="Remote"})(y=e.ExtensionHostKind||(e.ExtensionHostKind={}));function D(c){if(c===null)return"None";switch(c){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=D;class v{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(l,n){const r=[],f=[],E=[],T=[],M=h(this.c),G=h(l),V=(z,B)=>z.extensionLocation.toString()===B.extensionLocation.toString()||z.isBuiltin===B.isBuiltin||z.isUserBuiltin===B.isUserBuiltin||z.isUnderDevelopment===B.isUnderDevelopment;for(const z of this.c){const B=G.get(R.ExtensionIdentifier.toKey(z.identifier));if(!B){r.push(z.identifier),M.delete(R.ExtensionIdentifier.toKey(z.identifier));continue}if(!V(z,B)){r.push(z.identifier),M.delete(R.ExtensionIdentifier.toKey(z.identifier));continue}}for(const z of l){const B=M.get(R.ExtensionIdentifier.toKey(z.identifier));if(!B){f.push(z);continue}if(!V(B,z)){r.push(B.identifier),M.delete(R.ExtensionIdentifier.toKey(B.identifier));continue}}const N=m(this.d),U=m(n);for(const z of this.d)U.has(R.ExtensionIdentifier.toKey(z))||E.push(z);for(const z of n)N.has(R.ExtensionIdentifier.toKey(z))||T.push(z);const F={toRemove:r,toAdd:f,myToRemove:E,myToAdd:T};return this.delta(F),F}delta(l){const{toRemove:n,toAdd:r,myToRemove:f,myToAdd:E}=l,T=m(n),M=m(f);for(let G=0;G<this.c.length;G++)T.has(R.ExtensionIdentifier.toKey(this.c[G].identifier))&&(this.c.splice(G,1),G--);for(let G=0;G<this.d.length;G++)M.has(R.ExtensionIdentifier.toKey(this.d[G]))&&(this.d.splice(G,1),G--);for(const G of r)this.c.push(G);for(const G of E)this.d.push(G)}containsExtension(l){for(const n of this.d)if(R.ExtensionIdentifier.equals(n,l))return!0;return!1}}e.ExtensionHostExtensions=v;class d{constructor(l){if(this[A]="ExtensionIdentifierSet",this.c=new Map,this.d=R.ExtensionIdentifier.toKey,l)for(const n of l)this.add(n)}get size(){return this.c.size}add(l){return this.c.set(this.d(l),l),this}clear(){this.c.clear()}delete(l){return this.c.delete(this.d(l))}has(l){return this.c.has(this.d(l))}forEach(l,n){this.c.forEach(r=>l.call(n,r,r,this))}*entries(){for(const[l,n]of this.c)yield[n,n]}keys(){return this.c.values()}values(){return this.c.values()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=d;function m(c){const l=new Set;for(const n of c)l.add(R.ExtensionIdentifier.toKey(n));return l}e.extensionIdentifiersArrayToSet=m;function h(c){const l=new Map;for(const n of c)l.set(R.ExtensionIdentifier.toKey(n.identifier),n);return l}function w(c,l){return c.enabledApiProposals?c.enabledApiProposals.includes(l):!1}e.isProposedApiEnabled=w;function g(c,l){if(!w(c,l))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${l}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${l}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.checkProposedApiEnabled=g;class p{constructor(l,n,r,f){this.codeLoadingTime=l,this.activateCallTime=n,this.activateResolvedTime=r,this.activationReason=f}}e.ActivationTimes=p;class b{constructor(l,n){this.description=l,this.value=n}}e.ExtensionPointContribution=b,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var i;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(i=e.ActivationKind||(e.ActivationKind={}));function s(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,I.getGalleryExtensionId)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}e.toExtension=s;function a(c,l){return{identifier:new R.ExtensionIdentifier((0,I.getExtensionId)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!l,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform,browserNlsBundleUris:c.browserNlsBundleUris}}e.toExtensionDescription=a;class u{constructor(){this.onDidRegisterExtensions=o.Event.None,this.onDidChangeExtensionsStatus=o.Event.None,this.onDidChangeExtensions=o.Event.None,this.onWillActivateByEvent=o.Event.None,this.onDidChangeResponsiveChange=o.Event.None,this.extensions=[]}activateByEvent(l){return Promise.resolve(void 0)}activationEventIsDone(l){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(l){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(l,n){return Promise.resolve(0)}getInspectPorts(l,n){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(l){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=u}),define(ye[229],Ce([1,0,10,134,26,27,13,16]),function(ne,e,o,t,k,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class S{constructor(h,w,g,p){this.startup=h,this.codeLoadingTime=w,this.activateCallTime=g,this.activateResolvedTime=p}}e.ExtensionActivationTimes=S,S.NONE=new S(!1,-1,-1,-1);class C{constructor(h){this.a=h,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(h,w){return h===-1||w===-1?-1:w-h}build(){return new S(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=C;class L{constructor(h,w,g,p,b,i){this.activationFailed=h,this.activationFailedError=w,this.activationTimes=g,this.module=p,this.exports=b,this.subscriptions=i}}e.ActivatedExtension=L;class P extends L{constructor(h){super(!1,null,h,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=P;class y extends L{constructor(){super(!1,null,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=y;class D extends L{constructor(h){super(!0,h,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let v=class{constructor(h,w,g,p){this.g=p,this.a=h,this.b=w,this.c=g,this.d=new Map,this.f=Object.create(null)}dispose(){for(const[h,w]of this.d)w.dispose()}isActivated(h){const w=this.d.get(k.ExtensionIdentifier.toKey(h));return Boolean(w&&w.value)}getActivatedExtension(h){const w=this.d.get(k.ExtensionIdentifier.toKey(h));if(!w||!w.value)throw new Error(`Extension '${h.value}' is not known or not activated`);return w.value}async activateByEvent(h,w){if(this.f[h])return;const g=this.a.getExtensionDescriptionsForActivationEvent(h);await this.h(g.map(p=>({id:p.identifier,reason:{startup:w,extensionId:p.identifier,activationEvent:h}}))),this.f[h]=!0}activateById(h,w){const g=this.a.getExtensionDescription(h);if(!g)throw new Error(`Extension '${h}' is not known`);return this.h([{id:g.identifier,reason:w}])}async h(h){const w=h.filter(g=>!this.isActivated(g.id)).map(g=>this.j(g));await Promise.all(w.map(g=>g.wait()))}j(h){if(this.d.has(k.ExtensionIdentifier.toKey(h.id)))return this.d.get(k.ExtensionIdentifier.toKey(h.id));if(this.l(h.id))return this.k(h,null,[],null);const w=this.a.getExtensionDescription(h.id);if(!w){const b=new Error(`Cannot activate unknown extension '${h.id.value}'`),i=this.k(h,null,[],new D(b));return this.c.onExtensionActivationError(h.id,b,new R.MissingExtensionDependency(h.id.value)),i}const g=[],p=typeof w.extensionDependencies>"u"?[]:w.extensionDependencies;for(const b of p){if(this.m(b))continue;const i=this.d.get(k.ExtensionIdentifier.toKey(b));if(i){g.push(i);continue}if(this.l(b)){g.push(this.j({id:this.b.getExtensionDescription(b).identifier,reason:h.reason}));continue}const s=this.a.getExtensionDescription(b);if(s){if(!s.main&&!s.browser)continue;g.push(this.j({id:s.identifier,reason:h.reason}));continue}const a=w.displayName||w.identifier.value,u=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${b}'`),c=this.k(h,w.displayName,[],new D(u));return this.c.onExtensionActivationError(w.identifier,u,new R.MissingExtensionDependency(b)),c}return this.k(h,w.displayName,g,null)}k(h,w,g,p){const b=new d(h.id,w,h.reason,g,p,this.c,this.g);return this.d.set(k.ExtensionIdentifier.toKey(h.id),b),b}l(h){return t.ExtensionDescriptionRegistry.isHostExtension(h,this.a,this.b)}m(h){const w=this.b.getExtensionDescription(h);return w?!w.main&&!w.browser:!1}};v=qe([He(3,I.ILogService)],v),e.ExtensionsActivator=v;let d=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(h,w,g,p,b,i,s){this.c=h,this.d=w,this.f=g,this.g=p,this.h=b,this.j=i,this.k=s,this.a=new A.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let h=0;h<this.g.length;h++){const w=this.g[h];if(w.value&&!w.value.activationFailed){this.g.splice(h,1),h--;continue}if(w.value&&w.value.activationFailed){const g=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${w.friendlyName}' failed to activate`);g.detail=w.value.activationFailedError,this.h=new D(g),this.j.onExtensionActivationError(this.c,g,null);return}}this.g.length>0&&await Promise.race(this.g.map(h=>h.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(h){const w=new Error;if(h&&h.name&&(w.name=h.name),h&&h.message?w.message=`Activating extension '${this.c.value}' failed: ${h.message}.`:w.message=`Activating extension '${this.c.value}' failed: ${h}.`,h&&h.stack&&(w.stack=h.stack),this.h=new D(w),this.b&&o.isCancellationError(h))return;this.j.onExtensionActivationError(this.c,w,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(h)}}};d=qe([He(6,I.ILogService)],d)}),define(ye[230],Ce([1,0,13,25,27]),function(ne,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let R=class extends o.LogService{constructor(A,S){super(A.createLogger(S.logFile,{name:k.ExtensionHostLogFileName}))}};R=qe([He(0,o.ILoggerService),He(1,t.IExtHostInitDataService)],R),e.ExtHostLogService=R});var Je=this&&this.__classPrivateFieldSet||function(ne,e,o,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ne,o):k?k.value=o:e.set(ne,o),o},Ue=this&&this.__classPrivateFieldGet||function(ne,e,o,t){if(o==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?t:o==="a"?t.call(ne):t?t.value:e.get(ne)};define(ye[7],Ce([1,0,18,10,111,28,84,8,11,2,30,38,128,91,27]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y,D,v){"use strict";var d,m,h,w,g,p,b,i,s,a,u,c,l,n,r,f,E,T,M,G,V,N,U;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function F(K){return Object.assign(K,{apply:function(){const he=arguments.length===1?[]:arguments[1];return Reflect.construct(K,he,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(K,[]);{const[he,...Te]=arguments;return Reflect.construct(K,Te,he.constructor)}}})}var z;(function(K){K[K.Top=0]="Top",K[K.Bottom=1]="Bottom"})(z=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var B;(function(K){K[K.Command=0]="Command",K[K.Opener=1]="Opener"})(B=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let W=p=class{static from(...j){let he=j;return new p(function(){if(he){for(const Te of he)Te&&typeof Te.dispose=="function"&&Te.dispose();he=void 0}})}constructor(j){d.set(this,void 0),Je(this,d,j,"f")}dispose(){typeof Ue(this,d,"f")=="function"&&(Ue(this,d,"f").call(this),Je(this,d,void 0,"f"))}};d=new WeakMap,W=p=qe([F],W),e.Disposable=W;let X=b=class{static Min(...j){if(j.length===0)throw new TypeError;let he=j[0];for(let Te=1;Te<j.length;Te++){const Ke=j[Te];Ke.isBefore(he)&&(he=Ke)}return he}static Max(...j){if(j.length===0)throw new TypeError;let he=j[0];for(let Te=1;Te<j.length;Te++){const Ke=j[Te];Ke.isAfter(he)&&(he=Ke)}return he}static isPosition(j){if(!j)return!1;if(j instanceof b)return!0;const{line:he,character:Te}=j;return typeof he=="number"&&typeof Te=="number"}static of(j){if(j instanceof b)return j;if(this.isPosition(j))return new b(j.line,j.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(j,he){if(j<0)throw(0,t.illegalArgument)("line must be non-negative");if(he<0)throw(0,t.illegalArgument)("character must be non-negative");this.c=j,this.e=he}isBefore(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<j.e}isBeforeOrEqual(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<=j.e}isAfter(j){return!this.isBeforeOrEqual(j)}isAfterOrEqual(j){return!this.isBefore(j)}isEqual(j){return this.c===j.c&&this.e===j.e}compareTo(j){return this.c<j.c?-1:this.c>j.line?1:this.e<j.e?-1:this.e>j.e?1:0}translate(j,he=0){if(j===null||he===null)throw(0,t.illegalArgument)();let Te;return typeof j>"u"?Te=0:typeof j=="number"?Te=j:(Te=typeof j.lineDelta=="number"?j.lineDelta:0,he=typeof j.characterDelta=="number"?j.characterDelta:0),Te===0&&he===0?this:new b(this.line+Te,this.character+he)}with(j,he=this.character){if(j===null||he===null)throw(0,t.illegalArgument)();let Te;return typeof j>"u"?Te=this.line:typeof j=="number"?Te=j:(Te=typeof j.line=="number"?j.line:this.line,he=typeof j.character=="number"?j.character:this.character),Te===this.line&&he===this.character?this:new b(Te,he)}toJSON(){return{line:this.line,character:this.character}}};X=b=qe([F],X),e.Position=X;let q=i=class{static isRange(j){return j instanceof i?!0:j?X.isPosition(j.start)&&X.isPosition(j.end):!1}static of(j){if(j instanceof i)return j;if(this.isRange(j))return new i(j.start,j.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(j,he,Te,Ke){let Ye,ct;if(typeof j=="number"&&typeof he=="number"&&typeof Te=="number"&&typeof Ke=="number"?(Ye=new X(j,he),ct=new X(Te,Ke)):X.isPosition(j)&&X.isPosition(he)&&(Ye=X.of(j),ct=X.of(he)),!Ye||!ct)throw new Error("Invalid arguments");Ye.isBefore(ct)?(this.c=Ye,this.e=ct):(this.c=ct,this.e=Ye)}contains(j){return i.isRange(j)?this.contains(j.start)&&this.contains(j.end):X.isPosition(j)?!(X.of(j).isBefore(this.c)||this.e.isBefore(j)):!1}isEqual(j){return this.c.isEqual(j.c)&&this.e.isEqual(j.e)}intersection(j){const he=X.Max(j.start,this.c),Te=X.Min(j.end,this.e);if(!he.isAfter(Te))return new i(he,Te)}union(j){if(this.contains(j))return this;if(j.contains(this))return j;const he=X.Min(j.start,this.c),Te=X.Max(j.end,this.end);return new i(he,Te)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(j,he=this.end){if(j===null||he===null)throw(0,t.illegalArgument)();let Te;return j?X.isPosition(j)?Te=j:(Te=j.start||this.start,he=j.end||this.end):Te=this.start,Te.isEqual(this.c)&&he.isEqual(this.end)?this:new i(Te,he)}toJSON(){return[this.start,this.end]}};q=i=qe([F],q),e.Range=q;let _=s=class extends q{static isSelection(j){return j instanceof s?!0:j?q.isRange(j)&&X.isPosition(j.anchor)&&X.isPosition(j.active)&&typeof j.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(j,he,Te,Ke){let Ye,ct;if(typeof j=="number"&&typeof he=="number"&&typeof Te=="number"&&typeof Ke=="number"?(Ye=new X(j,he),ct=new X(Te,Ke)):X.isPosition(j)&&X.isPosition(he)&&(Ye=X.of(j),ct=X.of(he)),!Ye||!ct)throw new Error("Invalid arguments");super(Ye,ct),this.f=Ye,this.g=ct}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};_=s=qe([F],_),e.Selection=_;class Q{constructor(j,he,Te){if(typeof j!="string"||j.length===0)throw(0,t.illegalArgument)("host");if(typeof he!="number"||he===0||Math.round(he)!==he)throw(0,t.illegalArgument)("port");if(typeof Te<"u"&&(typeof Te!="string"||Te.length===0||!/^[0-9A-Za-z_\-]+$/.test(Te)))throw(0,t.illegalArgument)("connectionToken");this.host=j,this.port=Math.round(he),this.connectionToken=Te}}e.ResolvedAuthority=Q;class Z extends Error{static NotAvailable(j,he){return new Z(j,y.RemoteAuthorityResolverErrorCode.NotAvailable,he)}static TemporarilyNotAvailable(j){return new Z(j,y.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(j,he=y.RemoteAuthorityResolverErrorCode.Unknown,Te){super(j),this._message=j,this._code=he,this._detail=Te,Object.setPrototypeOf(this,Z.prototype)}}e.RemoteAuthorityResolverError=Z;var ge;(function(K){K[K.LF=1]="LF",K[K.CRLF=2]="CRLF"})(ge=e.EndOfLine||(e.EndOfLine={}));var te;(function(K){K[K.Replace=1]="Replace",K[K.Append=2]="Append",K[K.Prepend=3]="Prepend"})(te=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let J=a=class{static isTextEdit(j){return j instanceof a?!0:j?q.isRange(j)&&typeof j.newText=="string":!1}static replace(j,he){return new a(j,he)}static insert(j,he){return a.replace(new q(j,j),he)}static delete(j){return a.replace(j,"")}static setEndOfLine(j){const he=new a(new q(new X(0,0),new X(0,0)),"");return he.newEol=j,he}get range(){return this.c}set range(j){if(j&&!q.isRange(j))throw(0,t.illegalArgument)("range");this.c=j}get newText(){return this.e||""}set newText(j){if(j&&typeof j!="string")throw(0,t.illegalArgument)("newText");this.e=j}get newEol(){return this.f}set newEol(j){if(j&&typeof j!="number")throw(0,t.illegalArgument)("newEol");this.f=j}constructor(j,he){this.c=j,this.e=he}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};J=a=qe([F],J),e.TextEdit=J;let fe=u=class{static isNotebookCellEdit(j){return j instanceof u?!0:j?Gt.isNotebookRange(j)&&Array.isArray(j.newCells):!1}static replaceCells(j,he){return new u(j,he)}static insertCells(j,he){return new u(new Gt(j,j),he)}static deleteCells(j){return new u(j,[])}static updateCellMetadata(j,he){const Te=new u(new Gt(j,j),[]);return Te.newCellMetadata=he,Te}static updateNotebookMetadata(j){const he=new u(new Gt(0,0),[]);return he.newNotebookMetadata=j,he}constructor(j,he){this.range=j,this.newCells=he}};fe=u=qe([F],fe),e.NotebookEdit=fe;class ve{static isSnippetTextEdit(j){return j instanceof ve?!0:j?q.isRange(j.range)&&Fe.isSnippetString(j.snippet):!1}static replace(j,he){return new ve(j,he)}static insert(j,he){return ve.replace(new q(j,j),he)}constructor(j,he){this.range=j,this.snippet=he}}e.SnippetTextEdit=ve;var Ee;(function(K){K[K.File=1]="File",K[K.Text=2]="Text",K[K.Cell=3]="Cell",K[K.CellReplace=5]="CellReplace",K[K.Snippet=6]="Snippet"})(Ee=e.FileEditType||(e.FileEditType={}));let Ae=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(j,he,Te,Ke){this.c.push({_type:1,from:j,to:he,options:Te,metadata:Ke})}createFile(j,he,Te){this.c.push({_type:1,from:void 0,to:j,options:he,metadata:Te})}deleteFile(j,he,Te){this.c.push({_type:1,from:j,to:void 0,options:he,metadata:Te})}e(j,he,Te){this.c.push({_type:3,metadata:Te,uri:j,edit:{editType:5,metadata:he},notebookMetadata:he})}f(j,he,Te,Ke){const Ye=he.start,ct=he.end;(Ye!==ct||Te.length>0)&&this.c.push({_type:5,uri:j,index:Ye,count:ct-Ye,cells:Te,metadata:Ke})}g(j,he,Te,Ke){this.c.push({_type:3,metadata:Ke,uri:j,edit:{editType:8,index:he,metadata:Te}})}replace(j,he,Te,Ke){this.c.push({_type:2,uri:j,edit:new J(he,Te),metadata:Ke})}insert(j,he,Te,Ke){this.replace(j,new q(he,he),Te,Ke)}delete(j,he,Te){this.replace(j,he,"",Te)}has(j){return this.c.some(he=>he._type===2&&he.uri.toString()===j.toString())}set(j,he){if(he)for(const Te of he){if(!Te)continue;let Ke,Ye;if(Array.isArray(Te)?(Ke=Te[0],Ye=Te[1]):Ke=Te,fe.isNotebookCellEdit(Ke)){if(j.scheme===D.CellUri.scheme)throw new Error("set must be called with a notebook document URI, not a cell URI.");Ke.newCellMetadata?this.g(j,Ke.range.start,Ke.newCellMetadata,Ye):Ke.newNotebookMetadata?this.e(j,Ke.newNotebookMetadata,Ye):this.f(j,Ke.range,Ke.newCells,Ye)}else ve.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:j,range:Ke.range,edit:Ke.snippet,metadata:Ye}):this.c.push({_type:2,uri:j,edit:Ke,metadata:Ye})}else{for(let Te=0;Te<this.c.length;Te++){const Ke=this.c[Te];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===j.toString()&&(this.c[Te]=void 0);break}}(0,o.coalesceInPlace)(this.c)}}get(j){const he=[];for(const Te of this.c)Te._type===2&&Te.uri.toString()===j.toString()&&he.push(Te.edit);return he}entries(){const j=new R.ResourceMap;for(const he of this.c)if(he._type===2){let Te=j.get(he.uri);Te||(Te=[he.uri,[]],j.set(he.uri,Te)),Te[1].push(he.edit)}return[...j.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Ae=qe([F],Ae),e.WorkspaceEdit=Ae;let Fe=c=class{static isSnippetString(j){return j instanceof c?!0:j?typeof j.value=="string":!1}static c(j){return j.replace(/\$|}|\\/g,"\\$&")}constructor(j){this.e=1,this.value=j||""}appendText(j){return this.value+=c.c(j),this}appendTabstop(j=this.e++){return this.value+="$",this.value+=j,this}appendPlaceholder(j,he=this.e++){if(typeof j=="function"){const Te=new c;Te.e=this.e,j(Te),this.e=Te.e,j=Te.value}else j=c.c(j);return this.value+="${",this.value+=he,this.value+=":",this.value+=j,this.value+="}",this}appendChoice(j,he=this.e++){const Te=j.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=he,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(j,he){if(typeof he=="function"){const Te=new c;Te.e=this.e,he(Te),this.e=Te.e,he=Te.value}else typeof he=="string"&&(he=he.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=j,he&&(this.value+=":",this.value+=he),this.value+="}",this}};Fe=c=qe([F],Fe),e.SnippetString=Fe;var se;(function(K){K[K.Unnecessary=1]="Unnecessary",K[K.Deprecated=2]="Deprecated"})(se=e.DiagnosticTag||(e.DiagnosticTag={}));var le;(function(K){K[K.Hint=3]="Hint",K[K.Information=2]="Information",K[K.Warning=1]="Warning",K[K.Error=0]="Error"})(le=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ue=l=class{static isLocation(j){return j instanceof l?!0:j?q.isRange(j.range)&&C.URI.isUri(j.uri):!1}constructor(j,he){if(this.uri=j,he)if(q.isRange(he))this.range=q.of(he);else if(X.isPosition(he))this.range=new q(he,he);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ue=l=qe([F],ue),e.Location=ue;let ee=class{static is(j){return j?typeof j.message=="string"&&j.location&&q.isRange(j.location.range)&&C.URI.isUri(j.location.uri):!1}constructor(j,he){this.location=j,this.message=he}static isEqual(j,he){return j===he?!0:!j||!he?!1:j.message===he.message&&j.location.range.isEqual(he.location.range)&&j.location.uri.toString()===he.location.uri.toString()}};ee=qe([F],ee),e.DiagnosticRelatedInformation=ee;let ae=class{constructor(j,he,Te=le.Error){if(!q.isRange(j))throw new TypeError("range must be set");if(!he)throw new TypeError("message must be set");this.range=j,this.message=he,this.severity=Te}toJSON(){return{severity:le[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(j,he){return j===he?!0:!j||!he?!1:j.message===he.message&&j.severity===he.severity&&j.code===he.code&&j.severity===he.severity&&j.source===he.source&&j.range.isEqual(he.range)&&(0,o.equals)(j.tags,he.tags)&&(0,o.equals)(j.relatedInformation,he.relatedInformation,ee.isEqual)}};ae=qe([F],ae),e.Diagnostic=ae;let ie=class{constructor(j,he){if(!j)throw new Error("Illegal argument, contents must be defined");Array.isArray(j)?this.contents=j:this.contents=[j],this.range=he}};ie=qe([F],ie),e.Hover=ie;var O;(function(K){K[K.Text=0]="Text",K[K.Read=1]="Read",K[K.Write=2]="Write"})(O=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let H=class{constructor(j,he=O.Text){this.range=j,this.kind=he}toJSON(){return{range:this.range,kind:O[this.kind]}}};H=qe([F],H),e.DocumentHighlight=H;var x;(function(K){K[K.File=0]="File",K[K.Module=1]="Module",K[K.Namespace=2]="Namespace",K[K.Package=3]="Package",K[K.Class=4]="Class",K[K.Method=5]="Method",K[K.Property=6]="Property",K[K.Field=7]="Field",K[K.Constructor=8]="Constructor",K[K.Enum=9]="Enum",K[K.Interface=10]="Interface",K[K.Function=11]="Function",K[K.Variable=12]="Variable",K[K.Constant=13]="Constant",K[K.String=14]="String",K[K.Number=15]="Number",K[K.Boolean=16]="Boolean",K[K.Array=17]="Array",K[K.Object=18]="Object",K[K.Key=19]="Key",K[K.Null=20]="Null",K[K.EnumMember=21]="EnumMember",K[K.Struct=22]="Struct",K[K.Event=23]="Event",K[K.Operator=24]="Operator",K[K.TypeParameter=25]="TypeParameter"})(x=e.SymbolKind||(e.SymbolKind={}));var Y;(function(K){K[K.Deprecated=1]="Deprecated"})(Y=e.SymbolTag||(e.SymbolTag={}));let de=n=class{static validate(j){if(!j.name)throw new Error("name must not be falsy")}constructor(j,he,Te,Ke,Ye){this.name=j,this.kind=he,this.containerName=Ye,typeof Te=="string"&&(this.containerName=Te),Ke instanceof ue?this.location=Ke:Te instanceof q&&(this.location=new ue(Ke,Te)),n.validate(this)}toJSON(){return{name:this.name,kind:x[this.kind],location:this.location,containerName:this.containerName}}};de=n=qe([F],de),e.SymbolInformation=de;let be=r=class{static validate(j){if(!j.name)throw new Error("name must not be falsy");if(!j.range.contains(j.selectionRange))throw new Error("selectionRange must be contained in fullRange");j.children?.forEach(r.validate)}constructor(j,he,Te,Ke,Ye){this.name=j,this.detail=he,this.kind=Te,this.range=Ke,this.selectionRange=Ye,this.children=[],r.validate(this)}};be=r=qe([F],be),e.DocumentSymbol=be;var Pe;(function(K){K[K.Invoke=1]="Invoke",K[K.Automatic=2]="Automatic"})(Pe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let pe=class{constructor(j,he){this.title=j,this.kind=he}};pe=qe([F],pe),e.CodeAction=pe;let De=f=class{constructor(j){this.value=j}append(j){return new f(this.value?this.value+f.c+j:j)}intersects(j){return this.contains(j)||j.contains(this)}contains(j){return this.value===j.value||j.value.startsWith(this.value+f.c)}};De.c=".",De=f=qe([F],De),e.CodeActionKind=De,De.Empty=new De(""),De.QuickFix=De.Empty.append("quickfix"),De.Refactor=De.Empty.append("refactor"),De.RefactorExtract=De.Refactor.append("extract"),De.RefactorInline=De.Refactor.append("inline"),De.RefactorMove=De.Refactor.append("move"),De.RefactorRewrite=De.Refactor.append("rewrite"),De.Source=De.Empty.append("source"),De.SourceOrganizeImports=De.Source.append("organizeImports"),De.SourceFixAll=De.Source.append("fixAll");let ke=class{constructor(j,he){if(this.range=j,this.parent=he,he&&!he.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ke=qe([F],ke),e.SelectionRange=ke;class je{constructor(j,he,Te,Ke,Ye,ct){this.kind=j,this.name=he,this.detail=Te,this.uri=Ke,this.range=Ye,this.selectionRange=ct}}e.CallHierarchyItem=je;class Ge{constructor(j,he){this.fromRanges=he,this.from=j}}e.CallHierarchyIncomingCall=Ge;class et{constructor(j,he){this.fromRanges=he,this.to=j}}e.CallHierarchyOutgoingCall=et;var _e;(function(K){K[K.Information=0]="Information",K[K.Warning=1]="Warning",K[K.Error=2]="Error"})(_e=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let nt=class{constructor(j,he){this.range=j,this.command=he}get isResolved(){return!!this.command}};nt=qe([F],nt),e.CodeLens=nt;let st=E=class{static isMarkdownString(j){return j instanceof E?!0:j&&j.appendCodeblock&&j.appendMarkdown&&j.appendText&&j.value!==void 0}constructor(j,he=!1){m.set(this,void 0),Je(this,m,new k.MarkdownString(j,{supportThemeIcons:he}),"f")}get value(){return Ue(this,m,"f").value}set value(j){Ue(this,m,"f").value=j}get isTrusted(){return Ue(this,m,"f").isTrusted}set isTrusted(j){Ue(this,m,"f").isTrusted=j}get supportThemeIcons(){return Ue(this,m,"f").supportThemeIcons}set supportThemeIcons(j){Ue(this,m,"f").supportThemeIcons=j}get supportHtml(){return Ue(this,m,"f").supportHtml}set supportHtml(j){Ue(this,m,"f").supportHtml=j}get baseUri(){return Ue(this,m,"f").baseUri}set baseUri(j){Ue(this,m,"f").baseUri=j}appendText(j){return Ue(this,m,"f").appendText(j),this}appendMarkdown(j){return Ue(this,m,"f").appendMarkdown(j),this}appendCodeblock(j,he){return Ue(this,m,"f").appendCodeblock(he??"",j),this}};m=new WeakMap,st=E=qe([F],st),e.MarkdownString=st;let ht=class{constructor(j,he){this.label=j,this.documentation=he}};ht=qe([F],ht),e.ParameterInformation=ht;let Me=class{constructor(j,he){this.label=j,this.documentation=he,this.parameters=[]}};Me=qe([F],Me),e.SignatureInformation=Me;let it=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};it=qe([F],it),e.SignatureHelp=it;var oe;(function(K){K[K.Invoke=1]="Invoke",K[K.TriggerCharacter=2]="TriggerCharacter",K[K.ContentChange=3]="ContentChange"})(oe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var $;(function(K){K[K.Type=1]="Type",K[K.Parameter=2]="Parameter"})($=e.InlayHintKind||(e.InlayHintKind={}));let ce=class{constructor(j){this.value=j}};ce=qe([F],ce),e.InlayHintLabelPart=ce;let Ie=class{constructor(j,he,Te){this.position=j,this.label=he,this.kind=Te}};Ie=qe([F],Ie),e.InlayHint=Ie;var Le;(function(K){K[K.Invoke=0]="Invoke",K[K.TriggerCharacter=1]="TriggerCharacter",K[K.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Le=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Be;(function(K){K[K.Text=0]="Text",K[K.Method=1]="Method",K[K.Function=2]="Function",K[K.Constructor=3]="Constructor",K[K.Field=4]="Field",K[K.Variable=5]="Variable",K[K.Class=6]="Class",K[K.Interface=7]="Interface",K[K.Module=8]="Module",K[K.Property=9]="Property",K[K.Unit=10]="Unit",K[K.Value=11]="Value",K[K.Enum=12]="Enum",K[K.Keyword=13]="Keyword",K[K.Snippet=14]="Snippet",K[K.Color=15]="Color",K[K.File=16]="File",K[K.Reference=17]="Reference",K[K.Folder=18]="Folder",K[K.EnumMember=19]="EnumMember",K[K.Constant=20]="Constant",K[K.Struct=21]="Struct",K[K.Event=22]="Event",K[K.Operator=23]="Operator",K[K.TypeParameter=24]="TypeParameter",K[K.User=25]="User",K[K.Issue=26]="Issue"})(Be=e.CompletionItemKind||(e.CompletionItemKind={}));var xe;(function(K){K[K.Deprecated=1]="Deprecated"})(xe=e.CompletionItemTag||(e.CompletionItemTag={}));let Ze=class{constructor(j,he){this.label=j,this.kind=he}toJSON(){return{label:this.label,kind:this.kind&&Be[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ze=qe([F],Ze),e.CompletionItem=Ze;let gt=class{constructor(j=[],he=!1){this.items=j,this.isIncomplete=he}};gt=qe([F],gt),e.CompletionList=gt;let mt=class{constructor(j,he,Te){this.insertText=j,this.range=he,this.command=Te}};mt=qe([F],mt),e.InlineSuggestion=mt;let lt=class{constructor(j){this.commands=void 0,this.items=j}};lt=qe([F],lt),e.InlineSuggestionList=lt;var ot;(function(K){K[K.Active=-1]="Active",K[K.Beside=-2]="Beside",K[K.One=1]="One",K[K.Two=2]="Two",K[K.Three=3]="Three",K[K.Four=4]="Four",K[K.Five=5]="Five",K[K.Six=6]="Six",K[K.Seven=7]="Seven",K[K.Eight=8]="Eight",K[K.Nine=9]="Nine"})(ot=e.ViewColumn||(e.ViewColumn={}));var rt;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(rt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var kt;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative"})(kt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Tt;(function(K){K[K.Manual=1]="Manual",K[K.AfterDelay=2]="AfterDelay",K[K.FocusOut=3]="FocusOut"})(Tt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Nt;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(Nt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var pt;(function(K){K[K.Keyboard=1]="Keyboard",K[K.Mouse=2]="Mouse",K[K.Command=3]="Command"})(pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Dt;(function(K){K[K.Undo=1]="Undo",K[K.Redo=2]="Redo"})(Dt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var zt;(function(K){K[K.OpenOpen=0]="OpenOpen",K[K.ClosedClosed=1]="ClosedClosed",K[K.OpenClosed=2]="OpenClosed",K[K.ClosedOpen=3]="ClosedOpen"})(zt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(K){function j(he){switch(he){case"keyboard":return K.Keyboard;case"mouse":return K.Mouse;case"api":return K.Command}}K.fromValue=j}(pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ft=class{constructor(j,he){if(he&&!C.URI.isUri(he))throw(0,t.illegalArgument)("target");if(!q.isRange(j)||j.isEmpty)throw(0,t.illegalArgument)("range");this.range=j,this.target=he}};Ft=qe([F],Ft),e.DocumentLink=Ft;let Xe=class{constructor(j,he,Te,Ke){this.red=j,this.green=he,this.blue=Te,this.alpha=Ke}};Xe=qe([F],Xe),e.Color=Xe;let Mt=class{constructor(j,he){if(he&&!(he instanceof Xe))throw(0,t.illegalArgument)("color");if(!q.isRange(j)||j.isEmpty)throw(0,t.illegalArgument)("range");this.range=j,this.color=he}};Mt=qe([F],Mt),e.ColorInformation=Mt;let Ut=class{constructor(j){if(!j||typeof j!="string")throw(0,t.illegalArgument)("label");this.label=j}};Ut=qe([F],Ut),e.ColorPresentation=Ut;var Bt;(function(K){K[K.RGB=0]="RGB",K[K.HEX=1]="HEX",K[K.HSL=2]="HSL"})(Bt=e.ColorFormat||(e.ColorFormat={}));var bt;(function(K){K[K.Error=0]="Error",K[K.Warning=1]="Warning",K[K.Information=2]="Information"})(bt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Pt;(function(K){K[K.Unknown=0]="Unknown",K[K.Shutdown=1]="Shutdown",K[K.Process=2]="Process",K[K.User=3]="User",K[K.Extension=4]="Extension"})(Pt=e.TerminalExitReason||(e.TerminalExitReason={}));class Re{constructor(j,he,Te){if(this.startIndex=j,this.length=he,this.tooltip=Te,typeof j!="number"||j<0)throw(0,t.illegalArgument)("startIndex");if(typeof he!="number"||he<1)throw(0,t.illegalArgument)("length");if(Te!==void 0&&typeof Te!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Re;class Oe{constructor(j){this.uri=j}}e.TerminalQuickFixOpener=Oe;class Se{constructor(j){this.terminalCommand=j}}e.TerminalQuickFixCommand=Se;var re;(function(K){K[K.Panel=1]="Panel",K[K.Editor=2]="Editor"})(re=e.TerminalLocation||(e.TerminalLocation={}));class Ne{constructor(j){if(this.options=j,typeof j!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=Ne;var $e;(function(K){K[K.Always=1]="Always",K[K.Silent=2]="Silent",K[K.Never=3]="Never"})($e=e.TaskRevealKind||(e.TaskRevealKind={}));var Qe;(function(K){K[K.Shared=1]="Shared",K[K.Dedicated=2]="Dedicated",K[K.New=3]="New"})(Qe=e.TaskPanelKind||(e.TaskPanelKind={}));let Ve=T=class{static from(j){switch(j){case"clean":return T.Clean;case"build":return T.Build;case"rebuild":return T.Rebuild;case"test":return T.Test;default:return}}constructor(j,he){if(this.label=he,typeof j!="string"||typeof he!="string")throw(0,t.illegalArgument)("name");this.c=j}get id(){return this.c}};Ve.Clean=new T("clean","Clean"),Ve.Build=new T("build","Build"),Ve.Rebuild=new T("rebuild","Rebuild"),Ve.Test=new T("test","Test"),Ve=T=qe([F],Ve),e.TaskGroup=Ve;function tt(K){let j="";for(let he=0;he<K.length;he++)j+=K[he].replace(/,/g,",,")+",";return j}let St=class{constructor(j,he,Te){if(typeof j!="string")throw(0,t.illegalArgument)("process");this.e=[],this.c=j,he!==void 0&&(Array.isArray(he)?(this.e=he,this.f=Te):this.f=he)}get process(){return this.c}set process(j){if(typeof j!="string")throw(0,t.illegalArgument)("process");this.c=j}get args(){return this.e}set args(j){Array.isArray(j)||(j=[]),this.e=j}get options(){return this.f}set options(j){this.f=j}computeId(){const j=[];if(j.push("process"),this.c!==void 0&&j.push(this.c),this.e&&this.e.length>0)for(const he of this.e)j.push(he);return tt(j)}};St=qe([F],St),e.ProcessExecution=St;let Et=class{constructor(j,he,Te){if(this.f=[],Array.isArray(he)){if(!j)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof j!="string"&&typeof j.value!="string")throw(0,t.illegalArgument)("command");this.e=j,this.f=he,this.g=Te}else{if(typeof j!="string")throw(0,t.illegalArgument)("commandLine");this.c=j,this.g=he}}get commandLine(){return this.c}set commandLine(j){if(typeof j!="string")throw(0,t.illegalArgument)("commandLine");this.c=j}get command(){return this.e?this.e:""}set command(j){if(typeof j!="string"&&typeof j.value!="string")throw(0,t.illegalArgument)("command");this.e=j}get args(){return this.f}set args(j){this.f=j||[]}get options(){return this.g}set options(j){this.g=j}computeId(){const j=[];if(j.push("shell"),this.c!==void 0&&j.push(this.c),this.e!==void 0&&j.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const he of this.f)j.push(typeof he=="string"?he:he.value);return tt(j)}};Et=qe([F],Et),e.ShellExecution=Et;var Lt;(function(K){K[K.Escape=1]="Escape",K[K.Strong=2]="Strong",K[K.Weak=3]="Weak"})(Lt=e.ShellQuoting||(e.ShellQuoting={}));var vt;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace"})(vt=e.TaskScope||(e.TaskScope={}));class It{constructor(j){this.c=j}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback(j){this.c=j}get callback(){return this.c}}e.CustomExecution=It;let ft=M=class{constructor(j,he,Te,Ke,Ye,ct){this.j=!1,this.k=this.definition=j;let dt;typeof he=="string"?(this.m=this.name=he,this.t=this.source=Te,this.execution=Ke,dt=Ye,this.j=!0):he===vt.Global||he===vt.Workspace?(this.target=he,this.m=this.name=Te,this.t=this.source=Ke,this.execution=Ye,dt=ct):(this.target=he,this.m=this.name=Te,this.t=this.source=Ke,this.execution=Ye,dt=ct),typeof dt=="string"?(this.o=[dt],this.q=!0):Array.isArray(dt)?(this.o=dt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(j){this.h=j}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof St?this.k={type:M.e,id:this.n.computeId()}:this.n instanceof Et?this.k={type:M.f,id:this.n.computeId()}:this.n instanceof It?this.k={type:M.c,id:this.n.computeId()}:this.k={type:M.g,id:(0,L.generateUuid)()}}get definition(){return this.k}set definition(j){if(j==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=j}get scope(){return this.l}set target(j){this.y(),this.l=j}get name(){return this.m}set name(j){if(typeof j!="string")throw(0,t.illegalArgument)("name");this.y(),this.m=j}get execution(){return this.n}set execution(j){j===null&&(j=void 0),this.y(),this.n=j;const he=this.k.type;(M.g===he||M.e===he||M.f===he||M.c===he)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(j){if(Array.isArray(j))this.y(),this.o=j,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(j){j!==!0&&j!==!1&&(j=!1),this.y(),this.r=j}get source(){return this.t}set source(j){if(typeof j!="string"||j.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.y(),this.t=j}get group(){return this.u}set group(j){j===null&&(j=void 0),this.y(),this.u=j}get detail(){return this.x}set detail(j){j===null&&(j=void 0),this.x=j}get presentationOptions(){return this.v}set presentationOptions(j){j==null&&(j=Object.create(null)),this.y(),this.v=j}get runOptions(){return this.w}set runOptions(j){j==null&&(j=Object.create(null)),this.y(),this.w=j}};ft.c="customExecution",ft.e="process",ft.f="shell",ft.g="$empty",ft=M=qe([F],ft),e.Task=ft;var xt;(function(K){K[K.SourceControl=1]="SourceControl",K[K.Window=10]="Window",K[K.Notification=15]="Notification"})(xt=e.ProgressLocation||(e.ProgressLocation={}));var jt;(function(K){function j(he){const Te=he;return(0,S.isNumber)(Te.value)?Te.tooltip&&!(0,S.isString)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}K.isViewBadge=j})(jt=e.ViewBadge||(e.ViewBadge={}));let yt=G=class{static isTreeItem(j,he){if(j instanceof G)return!0;const Te=j;if(Te.label!==void 0&&!(0,S.isString)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,S.isString)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,S.isString)(Te.iconPath)&&!C.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,S.isString)(Te.iconPath.id))){const Ke=Te.iconPath;if(!Ke||!(0,S.isString)(Ke.light)&&!C.URI.isUri(Ke.light)&&!(0,S.isString)(Ke.dark)&&!C.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}if(Te.description!==void 0&&!(0,S.isString)(Te.description)&&typeof Te.description!="boolean")return console.log("INVALID tree item, invalid description",Te.description),!1;if(Te.resourceUri!==void 0&&!C.URI.isUri(Te.resourceUri))return console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1;if(Te.tooltip!==void 0&&!(0,S.isString)(Te.tooltip)&&!(Te.tooltip instanceof st))return console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1;if(Te.command!==void 0&&!Te.command.command)return console.log("INVALID tree item, invalid command",Te.command),!1;if(Te.collapsibleState!==void 0&&Te.collapsibleState<_t.None&&Te.collapsibleState>_t.Expanded)return console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1;if(Te.contextValue!==void 0&&!(0,S.isString)(Te.contextValue))return console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1;if(Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1;if(Te.checkboxState!==void 0){(0,v.checkProposedApiEnabled)(he,"treeItemCheckbox");const Ke=(0,S.isNumber)(Te.checkboxState)?Te.checkboxState:(0,S.isObject)(Te.checkboxState)&&(0,S.isNumber)(Te.checkboxState.state)?Te.checkboxState.state:void 0,Ye=!(0,S.isNumber)(Te.checkboxState)&&(0,S.isObject)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==an.Checked&&Ke!==an.Unchecked||Ye!==void 0&&!(0,S.isString)(Ye))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}return!0}constructor(j,he=_t.None){this.collapsibleState=he,C.URI.isUri(j)?this.resourceUri=j:this.label=j}};yt=G=qe([F],yt),e.TreeItem=yt;var _t;(function(K){K[K.None=0]="None",K[K.Collapsed=1]="Collapsed",K[K.Expanded=2]="Expanded"})(_t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var an;(function(K){K[K.Unchecked=0]="Unchecked",K[K.Checked=1]="Checked"})(an=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let Zt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(j,he){this.value=j,this.id=he??(0,L.generateUuid)()}};Zt=qe([F],Zt),e.DataTransferItem=Zt;let vn=class{constructor(j){h.set(this,new Map);for(const[he,Te]of j??[]){const Ke=Ue(this,h,"f").get(he);Ke?Ke.push(Te):Ue(this,h,"f").set(he,[Te])}}get(j){return Ue(this,h,"f").get(j)?.[0]}set(j,he){Ue(this,h,"f").set(j,[he])}forEach(j,he){for(const[Te,Ke]of Ue(this,h,"f"))for(const Ye of Ke)j.call(he,Ye,Te,this)}*[(h=new WeakMap,Symbol.iterator)](){for(const[j,he]of Ue(this,h,"f"))for(const Te of he)yield[j,Te]}};vn=qe([F],vn),e.DataTransfer=vn;let At=class{constructor(j){this.insertText=j}};At=qe([F],At),e.DocumentDropEdit=At;let cn=class{constructor(j){this.insertText=j}};cn=qe([F],cn),e.DocumentPasteEdit=cn;let Vt=class{constructor(j,he){this.id=j,this.color=he}static isThemeIcon(j){return typeof j.id!="string"?(console.log("INVALID ThemeIcon, invalid id",j.id),!1):!0}};Vt=qe([F],Vt),e.ThemeIcon=Vt,Vt.File=new Vt("file"),Vt.Folder=new Vt("folder");let en=class{constructor(j){this.id=j}};en=qe([F],en),e.ThemeColor=en;var ln;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace",K[K.WorkspaceFolder=3]="WorkspaceFolder"})(ln=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ut=class{get base(){return this.c}set base(j){this.c=j,this.e=C.URI.file(j)}get baseUri(){return this.e}set baseUri(j){this.e=j,this.c=j.fsPath}constructor(j,he){if(typeof j!="string"&&(!j||!C.URI.isUri(j)&&!C.URI.isUri(j.uri)))throw(0,t.illegalArgument)("base");if(typeof he!="string")throw(0,t.illegalArgument)("pattern");typeof j=="string"?this.baseUri=C.URI.file(j):C.URI.isUri(j)?this.baseUri=j:this.baseUri=j.uri,this.pattern=he}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ut=qe([F],ut),e.RelativePattern=ut;let tn=class{constructor(j,he,Te,Ke){this.enabled=typeof j=="boolean"?j:!0,typeof he=="string"&&(this.condition=he),typeof Te=="string"&&(this.hitCondition=Te),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this.c||(this.c=(0,L.generateUuid)()),this.c}};tn=qe([F],tn),e.Breakpoint=tn;let qt=class extends tn{constructor(j,he,Te,Ke,Ye){if(super(he,Te,Ke,Ye),j===null)throw(0,t.illegalArgument)("location");this.location=j}};qt=qe([F],qt),e.SourceBreakpoint=qt;let Qt=class extends tn{constructor(j,he,Te,Ke,Ye){super(he,Te,Ke,Ye),this.functionName=j}};Qt=qe([F],Qt),e.FunctionBreakpoint=Qt;let un=class extends tn{constructor(j,he,Te,Ke,Ye,ct,dt){if(super(Ke,Ye,ct,dt),!he)throw(0,t.illegalArgument)("dataId");this.label=j,this.dataId=he,this.canPersist=Te}};un=qe([F],un),e.DataBreakpoint=un;let En=class{constructor(j,he,Te){this.command=j,this.args=he||[],this.options=Te}};En=qe([F],En),e.DebugAdapterExecutable=En;let dn=class{constructor(j,he){this.port=j,this.host=he}};dn=qe([F],dn),e.DebugAdapterServer=dn;let Sn=class{constructor(j){this.path=j}};Sn=qe([F],Sn),e.DebugAdapterNamedPipeServer=Sn;let hn=class{constructor(j){this.implementation=j}};hn=qe([F],hn),e.DebugAdapterInlineImplementation=hn;let nn=class{constructor(j,he){this.range=j,this.expression=he}};nn=qe([F],nn),e.EvaluatableExpression=nn;var Un;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(Un=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let rn=class{constructor(j,he){this.range=j,this.text=he}};rn=qe([F],rn),e.InlineValueText=rn;let sn=class{constructor(j,he,Te=!0){this.range=j,this.variableName=he,this.caseSensitiveLookup=Te}};sn=qe([F],sn),e.InlineValueVariableLookup=sn;let yn=class{constructor(j,he){this.range=j,this.expression=he}};yn=qe([F],yn),e.InlineValueEvaluatableExpression=yn;let Cn=class{constructor(j,he){this.frameId=j,this.stoppedLocation=he}};Cn=qe([F],Cn),e.InlineValueContext=Cn;var on;(function(K){K[K.Changed=1]="Changed",K[K.Created=2]="Created",K[K.Deleted=3]="Deleted"})(on=e.FileChangeType||(e.FileChangeType={}));let Dn=V=class extends Error{static FileExists(j){return new V(j,P.FileSystemProviderErrorCode.FileExists,V.FileExists)}static FileNotFound(j){return new V(j,P.FileSystemProviderErrorCode.FileNotFound,V.FileNotFound)}static FileNotADirectory(j){return new V(j,P.FileSystemProviderErrorCode.FileNotADirectory,V.FileNotADirectory)}static FileIsADirectory(j){return new V(j,P.FileSystemProviderErrorCode.FileIsADirectory,V.FileIsADirectory)}static NoPermissions(j){return new V(j,P.FileSystemProviderErrorCode.NoPermissions,V.NoPermissions)}static Unavailable(j){return new V(j,P.FileSystemProviderErrorCode.Unavailable,V.Unavailable)}constructor(j,he=P.FileSystemProviderErrorCode.Unknown,Te){super(C.URI.isUri(j)?j.toString(!0):j),this.code=Te?.name??"Unknown",(0,P.markAsFileSystemProviderError)(this,he),Object.setPrototypeOf(this,V.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};Dn=V=qe([F],Dn),e.FileSystemError=Dn;let In=class{constructor(j,he,Te){this.start=j,this.end=he,this.kind=Te}};In=qe([F],In),e.FoldingRange=In;var Bn;(function(K){K[K.Comment=1]="Comment",K[K.Imports=2]="Imports",K[K.Region=3]="Region"})(Bn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var zn;(function(K){K[K.Collapsed=0]="Collapsed",K[K.Expanded=1]="Expanded"})(zn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var $n;(function(K){K[K.Editing=0]="Editing",K[K.Preview=1]="Preview"})($n=e.CommentMode||(e.CommentMode={}));var kn;(function(K){K[K.Unresolved=0]="Unresolved",K[K.Resolved=1]="Resolved"})(kn=e.CommentThreadState||(e.CommentThreadState={}));class Rn{constructor(j,he=[]){this.tokenTypes=j,this.tokenModifiers=he}}e.SemanticTokensLegend=Rn;function Ln(K){return typeof K>"u"||(0,S.isStringArray)(K)}class We{constructor(j){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,j){this.l=!0;for(let he=0,Te=j.tokenTypes.length;he<Te;he++)this.j.set(j.tokenTypes[he],he);for(let he=0,Te=j.tokenModifiers.length;he<Te;he++)this.k.set(j.tokenModifiers[he],he)}}push(j,he,Te,Ke,Ye){if(typeof j=="number"&&typeof he=="number"&&typeof Te=="number"&&typeof Ke=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.n(j,he,Te,Ke,Ye);if(q.isRange(j)&&typeof he=="string"&&Ln(Te))return this.m(j,he,Te);throw(0,t.illegalArgument)()}m(j,he,Te){if(!this.l)throw new Error("Legend must be provided in constructor");if(j.start.line!==j.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(he))throw new Error("`tokenType` is not in the provided legend");const Ke=j.start.line,Ye=j.start.character,ct=j.end.character-j.start.character,dt=this.j.get(he);let Ot=0;if(Te)for(const Ht of Te){if(!this.k.has(Ht))throw new Error("`tokenModifier` is not in the provided legend");const Kt=this.k.get(Ht);Ot|=1<<Kt>>>0}this.n(Ke,Ye,ct,dt,Ot)}n(j,he,Te,Ke,Ye){if(this.f&&(j<this.c||j===this.c&&he<this.e)){this.f=!1;const Ot=this.g.length/5|0;let Ht=0,Kt=0;for(let Xt=0;Xt<Ot;Xt++){let Yt=this.g[5*Xt],Pn=this.g[5*Xt+1];Yt===0?(Yt=Ht,Pn+=Kt):Yt+=Ht,this.g[5*Xt]=Yt,this.g[5*Xt+1]=Pn,Ht=Yt,Kt=Pn}}let ct=j,dt=he;this.f&&this.h>0&&(ct-=this.c,ct===0&&(dt-=this.e)),this.g[this.h++]=ct,this.g[this.h++]=dt,this.g[this.h++]=Te,this.g[this.h++]=Ke,this.g[this.h++]=Ye,this.c=j,this.e=he}static o(j){const he=[],Te=j.length/5|0;for(let dt=0;dt<Te;dt++)he[dt]=dt;he.sort((dt,Ot)=>{const Ht=j[5*dt],Kt=j[5*Ot];if(Ht===Kt){const Xt=j[5*dt+1],Yt=j[5*Ot+1];return Xt-Yt}return Ht-Kt});const Ke=new Uint32Array(j.length);let Ye=0,ct=0;for(let dt=0;dt<Te;dt++){const Ot=5*he[dt],Ht=j[Ot+0],Kt=j[Ot+1],Xt=j[Ot+2],Yt=j[Ot+3],Pn=j[Ot+4],ni=Ht-Ye,Ti=ni===0?Kt-ct:Kt,An=5*dt;Ke[An+0]=ni,Ke[An+1]=Ti,Ke[An+2]=Xt,Ke[An+3]=Yt,Ke[An+4]=Pn,Ye=Ht,ct=Kt}return Ke}build(j){return this.f?new Wt(new Uint32Array(this.g),j):new Wt(We.o(this.g),j)}}e.SemanticTokensBuilder=We;class Wt{constructor(j,he){this.resultId=he,this.data=j}}e.SemanticTokens=Wt;class On{constructor(j,he,Te){this.start=j,this.deleteCount=he,this.data=Te}}e.SemanticTokensEdit=On;class wt{constructor(j,he){this.resultId=he,this.edits=j}}e.SemanticTokensEdits=wt;var Wn;(function(K){K[K.Separate=0]="Separate",K[K.MergeWithParent=1]="MergeWithParent"})(Wn=e.DebugConsoleMode||(e.DebugConsoleMode={}));let fn=class{constructor(){}};fn.Back={iconPath:new Vt("arrow-left")},fn=qe([F],fn),e.QuickInputButtons=fn;var Nn;(function(K){K[K.Separator=-1]="Separator",K[K.Default=0]="Default"})(Nn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Hn;(function(K){K[K.Info=1]="Info",K[K.Warning=2]="Warning",K[K.Error=3]="Error"})(Hn=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var mn;(function(K){K[K.UI=1]="UI",K[K.Workspace=2]="Workspace"})(mn=e.ExtensionKind||(e.ExtensionKind={}));class jn{static validate(j){if(typeof j.badge=="string"){let he=(0,A.nextCharLength)(j.badge,0);if(he<j.badge.length&&(he+=(0,A.nextCharLength)(j.badge,he)),j.badge.length>he)throw new Error("The 'badge'-property must be undefined or a short character")}else if(j.badge&&!Vt.isThemeIcon(j.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!j.color&&!j.badge&&!j.tooltip)throw new Error("The decoration is empty");return!0}constructor(j,he,Te){this.badge=j,this.tooltip=he,this.color=Te}}e.FileDecoration=jn;let Tn=class{constructor(j){this.kind=j}};Tn=qe([F],Tn),e.ColorTheme=Tn;var Vn;(function(K){K[K.Light=1]="Light",K[K.Dark=2]="Dark",K[K.HighContrast=3]="HighContrast",K[K.HighContrastLight=4]="HighContrastLight"})(Vn=e.ColorThemeKind||(e.ColorThemeKind={}));class Gt{static isNotebookRange(j){return j instanceof Gt?!0:j?typeof j.start=="number"&&typeof j.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(j,he){if(j<0)throw(0,t.illegalArgument)("start must be positive");if(he<0)throw(0,t.illegalArgument)("end must be positive");j<=he?(this.c=j,this.e=he):(this.c=he,this.e=j)}with(j){let he=this.c,Te=this.e;return j.start!==void 0&&(he=j.start),j.end!==void 0&&(Te=j.end),he===this.c&&Te===this.e?this:new Gt(he,Te)}}e.NotebookRange=Gt;class gn{static validate(j){if(typeof j.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof j.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof j.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(j){return Array.isArray(j)&&j.every(he=>gn.isNotebookCellData(he))}static isNotebookCellData(j){return!0}constructor(j,he,Te,Ke,Ye,ct,dt){this.kind=j,this.value=he,this.languageId=Te,this.mime=Ke,this.outputs=Ye??[],this.metadata=ct,this.executionSummary=dt,gn.validate(this)}}e.NotebookCellData=gn;class qn{constructor(j){this.cells=j}}e.NotebookData=qn;class $t{static isNotebookCellOutputItem(j){return j instanceof $t?!0:j?typeof j.mime=="string"&&j.data instanceof Uint8Array:!1}static error(j){const he={name:j.name,message:j.message,stack:j.stack};return $t.json(he,"application/vnd.code.notebook.error")}static stdout(j){return $t.text(j,"application/vnd.code.notebook.stdout")}static stderr(j){return $t.text(j,"application/vnd.code.notebook.stderr")}static bytes(j,he="application/octet-stream"){return new $t(j,he)}static text(j,he=I.Mimes.text){const Te=Ue($t,w,"f",g).encode(String(j));return new $t(Te,he)}static json(j,he="text/x-json"){const Te=JSON.stringify(j,void 0,"	");return $t.text(Te,he)}constructor(j,he){this.data=j,this.mime=he;const Te=(0,I.normalizeMimeType)(he,!0);if(!Te)throw new Error(`INVALID mime type: ${he}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}e.NotebookCellOutputItem=$t,w=$t,g={value:new TextEncoder};class pn{static isNotebookCellOutput(j){return j instanceof pn?!0:!j||typeof j!="object"?!1:typeof j.id=="string"&&Array.isArray(j.items)}static ensureUniqueMimeTypes(j,he=!1){const Te=new Set,Ke=new Set;for(let Ye=0;Ye<j.length;Ye++){const ct=j[Ye],dt=(0,I.normalizeMimeType)(ct.mime);if(!Te.has(dt)||(0,D.isTextStreamMime)(dt)){Te.add(dt);continue}Ke.add(Ye),he&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ke.size===0?j:j.filter((Ye,ct)=>!Ke.has(ct))}constructor(j,he,Te){this.items=pn.ensureUniqueMimeTypes(j,!0),typeof he=="string"?(this.id=he,this.metadata=Te):(this.id=(0,L.generateUuid)(),this.metadata=he??Te)}}e.NotebookCellOutput=pn;var Gn;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(Gn=e.NotebookCellKind||(e.NotebookCellKind={}));var Kn;(function(K){K[K.Idle=1]="Idle",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(Kn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var me;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(me=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var we;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(we=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class ze{constructor(j,he){this.text=j,this.alignment=he}}e.NotebookCellStatusBarItem=ze;var at;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred"})(at=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var Ct;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred",K[K.Hidden=-1]="Hidden"})(Ct=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class Rt{constructor(j,he=[]){this.uri=j,this.provides=(0,o.asArray)(he)}}e.NotebookRendererScript=Rt;class oi{constructor(j){this.label=j}}e.NotebookKernelSourceAction=oi;let xn=class{constructor(j,he){this.label=j,this.timestamp=he}};xn=qe([F],xn),e.TimelineItem=xn;var ai;(function(K){K[K.Production=1]="Production",K[K.Development=2]="Development",K[K.Test=3]="Test"})(ai=e.ExtensionMode||(e.ExtensionMode={}));var ci;(function(K){K[K.Node=1]="Node",K[K.Webworker=2]="Webworker"})(ci=e.ExtensionRuntime||(e.ExtensionRuntime={}));var li;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(li=e.StandardTokenType||(e.StandardTokenType={}));class ui{constructor(j,he){this.ranges=j,this.wordPattern=he}}e.LinkedEditingRanges=ui;class di{constructor(j,he){this.c=j,this.e=he}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=di;var hi;(function(K){K[K.Queued=1]="Queued",K[K.Running=2]="Running",K[K.Passed=3]="Passed",K[K.Failed=4]="Failed",K[K.Skipped=5]="Skipped",K[K.Errored=6]="Errored"})(hi=e.TestResultState||(e.TestResultState={}));var fi;(function(K){K[K.Run=1]="Run",K[K.Debug=2]="Debug",K[K.Coverage=3]="Coverage"})(fi=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Xn=class{constructor(j=void 0,he=void 0,Te=void 0){this.include=j,this.exclude=he,this.profile=Te}};Xn=qe([F],Xn),e.TestRunRequest=Xn;let _n=N=class{static diff(j,he,Te){const Ke=new N(j);return Ke.expectedOutput=he,Ke.actualOutput=Te,Ke}constructor(j){this.message=j}};_n=N=qe([F],_n),e.TestMessage=_n;let Qn=class{constructor(j){this.id=j}};Qn=qe([F],Qn),e.TestTag=Qn;let bn=class{constructor(j,he){this.covered=j,this.total=he}};bn=qe([F],bn),e.CoveredCount=bn;let Yn=U=class{static fromDetails(j,he){const Te=new bn(0,0),Ke=new bn(0,0),Ye=new bn(0,0);for(const dt of he)if("branches"in dt){Te.total+=1,Te.covered+=dt.executionCount>0?1:0;for(const Ot of dt.branches)Ke.total+=1,Ke.covered+=Ot.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=dt.executionCount>0?1:0;const ct=new U(j,Te,Ke.total>0?Ke:void 0,Ye.total>0?Ye:void 0);return ct.detailedCoverage=he,ct}constructor(j,he,Te,Ke){this.uri=j,this.statementCoverage=he,this.branchCoverage=Te,this.functionCoverage=Ke}};Yn=U=qe([F],Yn),e.FileCoverage=Yn;let Jn=class{constructor(j,he,Te=[]){this.executionCount=j,this.location=he,this.branches=Te}};Jn=qe([F],Jn),e.StatementCoverage=Jn;let Zn=class{constructor(j,he){this.executionCount=j,this.location=he}};Zn=qe([F],Zn),e.BranchCoverage=Zn;let ei=class{constructor(j,he){this.executionCount=j,this.location=he}};ei=qe([F],ei),e.FunctionCoverage=ei;var mi;(function(K){K[K.None=0]="None",K[K.Option=1]="Option",K[K.Default=2]="Default",K[K.Preferred=3]="Preferred"})(mi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var gi;(function(K){K[K.Untrusted=0]="Untrusted",K[K.Trusted=1]="Trusted",K[K.Unspecified=2]="Unspecified"})(gi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var pi;(function(K){K[K.Notify=1]="Notify",K[K.OpenBrowser=2]="OpenBrowser",K[K.OpenPreview=3]="OpenPreview",K[K.Silent=4]="Silent",K[K.Ignore=5]="Ignore",K[K.OpenBrowserOnce=6]="OpenBrowserOnce"})(pi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class bi{constructor(j,he,Te,Ke,Ye,ct){this.kind=j,this.name=he,this.detail=Te,this.uri=Ke,this.range=Ye,this.selectionRange=ct}}e.TypeHierarchyItem=bi;class wi{constructor(j){this.uri=j}}e.TextTabInput=wi;class vi{constructor(j,he){this.original=j,this.modified=he}}e.TextDiffTabInput=vi;class Ei{constructor(j,he,Te,Ke){this.base=j,this.input1=he,this.input2=Te,this.result=Ke}}e.TextMergeTabInput=Ei;class Si{constructor(j,he){this.uri=j,this.viewType=he}}e.CustomEditorTabInput=Si;class yi{constructor(j){this.viewType=j}}e.WebviewEditorTabInput=yi;class Ci{constructor(j,he){this.uri=j,this.notebookType=he}}e.NotebookEditorTabInput=Ci;class Di{constructor(j,he,Te){this.original=j,this.modified=he,this.notebookType=Te}}e.NotebookDiffEditorTabInput=Di;class Ii{constructor(){}}e.TerminalEditorTabInput=Ii;class ki{constructor(j,he){this.uri=j,this.inputBoxUri=he}}e.InteractiveWindowInput=ki}),define(ye[135],Ce([1,0,49,15,8,162,105,7,18]),function(ne,e,o,t,k,R,I,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const C=new Map;function L(v,d){d?C.set(v,d):C.delete(v)}e.setWordDefinitionFor=L;function P(v){return C.get(v)}class y extends R.MirrorTextModel{constructor(d,m,h,w,g,p,b,i){super(m,h,w,g),this.m=d,this.p=p,this.q=b,this.notebook=i,this.b=!1}dispose(){(0,o.ok)(!this.b),this.b=!0,this.q=!1}equalLines(d){return(0,S.equals)(this.d,d)}get document(){if(!this.a){const d=this;this.a={get uri(){return d.c},get fileName(){return d.c.fsPath},get isUntitled(){return d.c.scheme===t.Schemas.untitled},get languageId(){return d.p},get version(){return d.g},get isClosed(){return d.b},get isDirty(){return d.q},save(){return d.r()},getText(m){return m?d.s(m):d.getText()},get eol(){return d.f===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return d.d.length},lineAt(m){return d.t(m)},offsetAt(m){return d.u(m)},positionAt(m){return d.v(m)},validateRange(m){return d.w(m)},validatePosition(m){return d.x(m)},getWordRangeAtPosition(m,h){return d.y(m,h)}}}return Object.freeze(this.a)}_acceptLanguageId(d){(0,o.ok)(!this.b),this.p=d}_acceptIsDirty(d){(0,o.ok)(!this.b),this.q=d}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(d){const m=this.w(d);if(m.isEmpty)return"";if(m.isSingleLine)return this.d[m.start.line].substring(m.start.character,m.end.character);const h=this.f,w=m.start.line,g=m.end.line,p=[];p.push(this.d[w].substring(m.start.character));for(let b=w+1;b<g;b++)p.push(this.d[b]);return p.push(this.d[g].substring(0,m.end.character)),p.join(h)}t(d){let m;if(d instanceof A.Position?m=d.line:typeof d=="number"&&(m=d),typeof m!="number"||m<0||m>=this.d.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new D(m,this.d[m],m===this.d.length-1)}u(d){return d=this.x(d),this.k(),this.h.getPrefixSum(d.line-1)+d.character}v(d){d=Math.floor(d),d=Math.max(0,d),this.k();const m=this.h.getIndexOf(d),h=this.d[m.index].length;return new A.Position(m.index,Math.min(m.remainder,h))}w(d){if(!(d instanceof A.Range))throw new Error("Invalid argument");const m=this.x(d.start),h=this.x(d.end);return m===d.start&&h===d.end?d:new A.Range(m.line,m.character,h.line,h.character)}x(d){if(!(d instanceof A.Position))throw new Error("Invalid argument");if(this.d.length===0)return d.with(0,0);let{line:m,character:h}=d,w=!1;if(m<0)m=0,h=0,w=!0;else if(m>=this.d.length)m=this.d.length-1,h=this.d[m].length,w=!0;else{const g=this.d[m].length;h<0?(h=0,w=!0):h>g&&(h=g,w=!0)}return w?new A.Position(m,h):d}y(d,m){const h=this.x(d);if(!m)m=P(this.p);else if((0,k.regExpLeadsToEndlessLoop)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const w=(0,I.getWordAtText)(h.character+1,(0,I.ensureValidWordDefinition)(m),this.d[h.line],0);if(w)return new A.Range(h.line,w.startColumn-1,h.line,w.endColumn-1)}}e.ExtHostDocumentData=y;class D{constructor(d,m,h){this.a=d,this.b=m,this.c=h}get lineNumber(){return this.a}get text(){return this.b}get range(){return new A.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new A.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=D}),define(ye[231],Ce([1,0,7,17,4]),function(ne,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let R=class{constructor(A){this.a=new o.ColorTheme(o.ColorThemeKind.Dark),this.b=new k.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(A){let S;switch(A){case"light":S=o.ColorThemeKind.Light;break;case"hcDark":S=o.ColorThemeKind.HighContrast;break;case"hcLight":S=o.ColorThemeKind.HighContrastLight;break;default:S=o.ColorThemeKind.Dark}this.a=new o.ColorTheme(S),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};R=qe([He(0,t.IExtHostRpcService)],R),e.ExtHostTheming=R}),define(ye[14],Ce([1,0,18,22,148,61,111,28,147,86,84,23,11,2,35,66,123,132,130,91,56,70,226,7]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y,D,v,d,m,h,w,g,p,b,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var a;(function(Re){function Oe(re){const{selectionStartLineNumber:Ne,selectionStartColumn:$e,positionLineNumber:Qe,positionColumn:Ve}=re,tt=new s.Position(Ne-1,$e-1),St=new s.Position(Qe-1,Ve-1);return new s.Selection(tt,St)}Re.to=Oe;function Se(re){const{anchor:Ne,active:$e}=re;return{selectionStartLineNumber:Ne.line+1,selectionStartColumn:Ne.character+1,positionLineNumber:$e.line+1,positionColumn:$e.character+1}}Re.from=Se})(a=e.Selection||(e.Selection={}));var u;(function(Re){function Oe(re){if(!re)return;const{start:Ne,end:$e}=re;return{startLineNumber:Ne.line+1,startColumn:Ne.character+1,endLineNumber:$e.line+1,endColumn:$e.character+1}}Re.from=Oe;function Se(re){if(!re)return;const{startLineNumber:Ne,startColumn:$e,endLineNumber:Qe,endColumn:Ve}=re;return new s.Range(Ne-1,$e-1,Qe-1,Ve-1)}Re.to=Se})(u=e.Range||(e.Range={}));var c;(function(Re){function Oe(Se){switch(Se){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Re.to=Oe})(c=e.TokenType||(e.TokenType={}));var l;(function(Re){function Oe(re){return new s.Position(re.lineNumber-1,re.column-1)}Re.to=Oe;function Se(re){return{lineNumber:re.line+1,column:re.character+1}}Re.from=Se})(l=e.Position||(e.Position={}));var n;(function(Re){function Oe(Ne,$e){return(0,o.coalesce)((0,o.asArray)(Ne).map(Qe=>Se(Qe,$e)))}Re.from=Oe;function Se(Ne,$e){if(typeof Ne=="string")return{$serialized:!0,language:Ne};if(Ne)return{$serialized:!0,language:Ne.language,scheme:re(Ne.scheme,$e),pattern:$.from(Ne.pattern)??void 0,exclusive:Ne.exclusive,notebookType:Ne.notebookType}}function re(Ne,$e){return $e&&typeof Ne=="string"?$e.transformOutgoingScheme(Ne):Ne}})(n=e.DocumentSelector||(e.DocumentSelector={}));var r;(function(Re){function Oe(re){switch(re){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Re.from=Oe;function Se(re){switch(re){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Re.to=Se})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var f;(function(Re){function Oe(re){let Ne;return re.code&&((0,y.isString)(re.code)||(0,y.isNumber)(re.code)?Ne=String(re.code):Ne={value:String(re.code.value),target:re.code.target}),{...u.from(re.range),message:re.message,source:re.source,code:Ne,severity:T.from(re.severity),relatedInformation:re.relatedInformation&&re.relatedInformation.map(E.from),tags:Array.isArray(re.tags)?(0,o.coalesce)(re.tags.map(r.from)):void 0}}Re.from=Oe;function Se(re){const Ne=new s.Diagnostic(u.to(re),re.message,T.to(re.severity));return Ne.source=re.source,Ne.code=(0,y.isString)(re.code)?re.code:re.code?.value,Ne.relatedInformation=re.relatedInformation&&re.relatedInformation.map(E.to),Ne.tags=re.tags&&(0,o.coalesce)(re.tags.map(r.to)),Ne}Re.to=Se})(f=e.Diagnostic||(e.Diagnostic={}));var E;(function(Re){function Oe(re){return{...u.from(re.location.range),message:re.message,resource:re.location.uri}}Re.from=Oe;function Se(re){return new s.DiagnosticRelatedInformation(new s.Location(re.resource,u.to(re)),re.message)}Re.to=Se})(E=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var T;(function(Re){function Oe(re){switch(re){case s.DiagnosticSeverity.Error:return m.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return m.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return m.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return m.MarkerSeverity.Hint}return m.MarkerSeverity.Error}Re.from=Oe;function Se(re){switch(re){case m.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case m.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case m.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case m.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Re.to=Se})(T=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var M;(function(Re){function Oe(re){return typeof re=="number"&&re>=s.ViewColumn.One?re-1:re===s.ViewColumn.Beside?i.SIDE_GROUP:i.ACTIVE_GROUP}Re.from=Oe;function Se(re){if(typeof re=="number"&&re>=0)return re+1;throw new Error("invalid 'EditorGroupColumn'")}Re.to=Se})(M=e.ViewColumn||(e.ViewColumn={}));function G(Re){return typeof Re.range<"u"}function V(Re){return Re.length===0?!0:!!G(Re[0])}e.isDecorationOptionsArr=V;var N;(function(Re){function Oe(Ve){return Ve.map(Re.from)}Re.fromMany=Oe;function Se(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function re(Ve){let tt;if(Se(Ve)){const{language:vt,value:It}=Ve;tt={value:"```"+vt+`
`+It+"\n```\n"}}else s.MarkdownString.isMarkdownString(Ve)?tt={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?tt={value:Ve}:tt={value:""};const St=Object.create(null);tt.uris=St;const Et=vt=>{try{let It=D.URI.parse(vt,!0);It=It.with({query:Ne(It.query,St)}),St[vt]=It}catch{}return""},Lt=new S.marked.Renderer;return Lt.link=Et,Lt.image=vt=>typeof vt=="string"?Et(I.parseHrefAndDimensions(vt).href):"",(0,S.marked)(tt.value,{renderer:Lt}),tt}Re.from=re;function Ne(Ve,tt){if(!Ve)return Ve;let St;try{St=(0,C.parse)(Ve)}catch{}if(!St)return Ve;let Et=!1;return St=(0,P.cloneAndChange)(St,Lt=>{if(D.URI.isUri(Lt)){const vt=`__uri_${Math.random().toString(16).slice(2,8)}`;return tt[vt]=Lt,Et=!0,vt}else return}),Et?JSON.stringify(St):Ve}function $e(Ve){const tt=new s.MarkdownString(Ve.value,Ve.supportThemeIcons);return tt.isTrusted=Ve.isTrusted,tt.supportHtml=Ve.supportHtml,tt.baseUri=Ve.baseUri?D.URI.from(Ve.baseUri):void 0,tt}Re.to=$e;function Qe(Ve){if(!!Ve)return typeof Ve=="string"?Ve:Re.from(Ve)}Re.fromStrict=Qe})(N=e.MarkdownString||(e.MarkdownString={}));function U(Re){return V(Re)?Re.map(Oe=>({range:u.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?N.fromMany(Oe.hoverMessage):Oe.hoverMessage?N.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Re.map(Oe=>({range:u.from(Oe)}))}e.fromRangeOrRangeWithMessage=U;function F(Re){return typeof Re>"u"?Re:typeof Re=="string"?D.URI.file(Re):Re}e.pathOrURIToURI=F;var z;(function(Re){function Oe(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?F(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Re.from=Oe})(z=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var B;(function(Re){function Oe(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?F(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?z.from(Se.before):void 0,after:Se.after?z.from(Se.after):void 0}}Re.from=Oe})(B=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var W;(function(Re){function Oe(Se){if(typeof Se>"u")return Se;switch(Se){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Re.from=Oe})(W=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var X;(function(Re){function Oe(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?W.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?B.from(Se.light):void 0,dark:Se.dark?B.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?F(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?z.from(Se.before):void 0,after:Se.after?z.from(Se.after):void 0}}Re.from=Oe})(X=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var q;(function(Re){function Oe(re){return{text:re.newText,eol:re.newEol&&st.from(re.newEol),range:u.from(re.range)}}Re.from=Oe;function Se(re){const Ne=new s.TextEdit(u.to(re.range),re.text);return Ne.newEol=typeof re.eol>"u"?void 0:st.to(re.eol),Ne}Re.to=Se})(q=e.TextEdit||(e.TextEdit={}));var _;(function(Re){function Oe(re,Ne){const $e={edits:[]};if(re instanceof s.WorkspaceEdit){const Qe=new A.ResourceSet;for(const Ve of re._allEntries())Ve._type===1&&D.URI.isUri(Ve.to)&&Ve.from===void 0&&Qe.add(Ve.to);for(const Ve of re._allEntries())Ve._type===1?$e.edits.push({oldResource:Ve.from,newResource:Ve.to,options:{...Ve.options,contentsBase64:Ve.options?.contents&&(0,t.encodeBase64)(t.VSBuffer.wrap(Ve.options.contents))},metadata:Ve.metadata}):Ve._type===2?$e.edits.push({resource:Ve.uri,textEdit:q.from(Ve.edit),versionId:Qe.has(Ve.uri)?void 0:Ne?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===6?$e.edits.push({resource:Ve.uri,textEdit:{range:u.from(Ve.range),text:Ve.edit.value,insertAsSnippet:!0},versionId:Qe.has(Ve.uri)?void 0:Ne?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?$e.edits.push({metadata:Ve.metadata,resource:Ve.uri,cellEdit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Ne?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&$e.edits.push({metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Ne?.getNotebookDocumentVersion(Ve.uri),cellEdit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(gt.from)}})}return $e}Re.from=Oe;function Se(re){const Ne=new s.WorkspaceEdit;for(const $e of re.edits)$e.textEdit?Ne.replace(D.URI.revive($e.resource),u.to($e.textEdit.range),$e.textEdit.text):Ne.renameFile(D.URI.revive($e.oldResource),D.URI.revive($e.newResource),$e.options);return Ne}Re.to=Se})(_=e.WorkspaceEdit||(e.WorkspaceEdit={}));var Q;(function(Re){const Oe=Object.create(null);Oe[s.SymbolKind.File]=0,Oe[s.SymbolKind.Module]=1,Oe[s.SymbolKind.Namespace]=2,Oe[s.SymbolKind.Package]=3,Oe[s.SymbolKind.Class]=4,Oe[s.SymbolKind.Method]=5,Oe[s.SymbolKind.Property]=6,Oe[s.SymbolKind.Field]=7,Oe[s.SymbolKind.Constructor]=8,Oe[s.SymbolKind.Enum]=9,Oe[s.SymbolKind.Interface]=10,Oe[s.SymbolKind.Function]=11,Oe[s.SymbolKind.Variable]=12,Oe[s.SymbolKind.Constant]=13,Oe[s.SymbolKind.String]=14,Oe[s.SymbolKind.Number]=15,Oe[s.SymbolKind.Boolean]=16,Oe[s.SymbolKind.Array]=17,Oe[s.SymbolKind.Object]=18,Oe[s.SymbolKind.Key]=19,Oe[s.SymbolKind.Null]=20,Oe[s.SymbolKind.EnumMember]=21,Oe[s.SymbolKind.Struct]=22,Oe[s.SymbolKind.Event]=23,Oe[s.SymbolKind.Operator]=24,Oe[s.SymbolKind.TypeParameter]=25;function Se(Ne){return typeof Oe[Ne]=="number"?Oe[Ne]:6}Re.from=Se;function re(Ne){for(const $e in Oe)if(Oe[$e]===Ne)return Number($e);return s.SymbolKind.Property}Re.to=re})(Q=e.SymbolKind||(e.SymbolKind={}));var Z;(function(Re){function Oe(re){switch(re){case s.SymbolTag.Deprecated:return 1}}Re.from=Oe;function Se(re){switch(re){case 1:return s.SymbolTag.Deprecated}}Re.to=Se})(Z=e.SymbolTag||(e.SymbolTag={}));var ge;(function(Re){function Oe(re){return{name:re.name,kind:Q.from(re.kind),tags:re.tags&&re.tags.map(Z.from),containerName:re.containerName,location:Ee.from(re.location)}}Re.from=Oe;function Se(re){const Ne=new s.SymbolInformation(re.name,Q.to(re.kind),re.containerName,Ee.to(re.location));return Ne.tags=re.tags&&re.tags.map(Z.to),Ne}Re.to=Se})(ge=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var te;(function(Re){function Oe(re){const Ne={name:re.name||"!!MISSING: name!!",detail:re.detail,range:u.from(re.range),selectionRange:u.from(re.selectionRange),kind:Q.from(re.kind),tags:re.tags?.map(Z.from)??[]};return re.children&&(Ne.children=re.children.map(Oe)),Ne}Re.from=Oe;function Se(re){const Ne=new s.DocumentSymbol(re.name,re.detail,Q.to(re.kind),u.to(re.range),u.to(re.selectionRange));return(0,o.isNonEmptyArray)(re.tags)&&(Ne.tags=re.tags.map(Z.to)),re.children&&(Ne.children=re.children.map(Se)),Ne}Re.to=Se})(te=e.DocumentSymbol||(e.DocumentSymbol={}));var J;(function(Re){function Oe(re){const Ne=new s.CallHierarchyItem(Q.to(re.kind),re.name,re.detail||"",D.URI.revive(re.uri),u.to(re.range),u.to(re.selectionRange));return Ne._sessionId=re._sessionId,Ne._itemId=re._itemId,Ne}Re.to=Oe;function Se(re,Ne,$e){if(Ne=Ne??re._sessionId,$e=$e??re._itemId,Ne===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:$e,name:re.name,detail:re.detail,kind:Q.from(re.kind),uri:re.uri,range:u.from(re.range),selectionRange:u.from(re.selectionRange),tags:re.tags?.map(Z.from)}}Re.from=Se})(J=e.CallHierarchyItem||(e.CallHierarchyItem={}));var fe;(function(Re){function Oe(Se){return new s.CallHierarchyIncomingCall(J.to(Se.from),Se.fromRanges.map(re=>u.to(re)))}Re.to=Oe})(fe=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ve;(function(Re){function Oe(Se){return new s.CallHierarchyOutgoingCall(J.to(Se.to),Se.fromRanges.map(re=>u.to(re)))}Re.to=Oe})(ve=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Ee;(function(Re){function Oe(re){return{range:re.range&&u.from(re.range),uri:re.uri}}Re.from=Oe;function Se(re){return new s.Location(D.URI.revive(re.uri),u.to(re.range))}Re.to=Se})(Ee=e.location||(e.location={}));var Ae;(function(Re){function Oe(re){const Ne=re,$e=re;return{originSelectionRange:Ne.originSelectionRange?u.from(Ne.originSelectionRange):void 0,uri:Ne.targetUri?Ne.targetUri:$e.uri,range:u.from(Ne.targetRange?Ne.targetRange:$e.range),targetSelectionRange:Ne.targetSelectionRange?u.from(Ne.targetSelectionRange):void 0}}Re.from=Oe;function Se(re){return{targetUri:D.URI.revive(re.uri),targetRange:u.to(re.range),targetSelectionRange:re.targetSelectionRange?u.to(re.targetSelectionRange):void 0,originSelectionRange:re.originSelectionRange?u.to(re.originSelectionRange):void 0}}Re.to=Se})(Ae=e.DefinitionLink||(e.DefinitionLink={}));var Fe;(function(Re){function Oe(re){return{range:u.from(re.range),contents:N.fromMany(re.contents)}}Re.from=Oe;function Se(re){return new s.Hover(re.contents.map(N.to),u.to(re.range))}Re.to=Se})(Fe=e.Hover||(e.Hover={}));var se;(function(Re){function Oe(re){return{range:u.from(re.range),expression:re.expression}}Re.from=Oe;function Se(re){return new s.EvaluatableExpression(u.to(re.range),re.expression)}Re.to=Se})(se=e.EvaluatableExpression||(e.EvaluatableExpression={}));var le;(function(Re){function Oe(re){if(re instanceof s.InlineValueText)return{type:"text",range:u.from(re.range),text:re.text};if(re instanceof s.InlineValueVariableLookup)return{type:"variable",range:u.from(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};if(re instanceof s.InlineValueEvaluatableExpression)return{type:"expression",range:u.from(re.range),expression:re.expression};throw new Error("Unknown 'InlineValue' type")}Re.from=Oe;function Se(re){switch(re.type){case"text":return{range:u.to(re.range),text:re.text};case"variable":return{range:u.to(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};case"expression":return{range:u.to(re.range),expression:re.expression}}}Re.to=Se})(le=e.InlineValue||(e.InlineValue={}));var ue;(function(Re){function Oe(re){return{frameId:re.frameId,stoppedLocation:u.from(re.stoppedLocation)}}Re.from=Oe;function Se(re){return new s.InlineValueContext(re.frameId,u.to(re.stoppedLocation))}Re.to=Se})(ue=e.InlineValueContext||(e.InlineValueContext={}));var ee;(function(Re){function Oe(re){return{range:u.from(re.range),kind:re.kind}}Re.from=Oe;function Se(re){return new s.DocumentHighlight(u.to(re.range),re.kind)}Re.to=Se})(ee=e.DocumentHighlight||(e.DocumentHighlight={}));var ae;(function(Re){function Oe(Se){switch(Se){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Re.to=Oe})(ae=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ie;(function(Re){function Oe(Se){return{triggerKind:ae.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Re.to=Oe})(ie=e.CompletionContext||(e.CompletionContext={}));var O;(function(Re){function Oe(re){switch(re){case s.CompletionItemTag.Deprecated:return 1}}Re.from=Oe;function Se(re){switch(re){case 1:return s.CompletionItemTag.Deprecated}}Re.to=Se})(O=e.CompletionItemTag||(e.CompletionItemTag={}));var H;(function(Re){const Oe=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function Se($e){return Oe.get($e)??9}Re.from=Se;const re=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Ne($e){return re.get($e)??s.CompletionItemKind.Property}Re.to=Ne})(H=e.CompletionItemKind||(e.CompletionItemKind={}));var x;(function(Re){function Oe(Se,re){const Ne=new s.CompletionItem(Se.label);return Ne.insertText=Se.insertText,Ne.kind=H.to(Se.kind),Ne.tags=Se.tags?.map(O.to),Ne.detail=Se.detail,Ne.documentation=I.isMarkdownString(Se.documentation)?N.to(Se.documentation):Se.documentation,Ne.sortText=Se.sortText,Ne.filterText=Se.filterText,Ne.preselect=Se.preselect,Ne.commitCharacters=Se.commitCharacters,v.Range.isIRange(Se.range)?Ne.range=u.to(Se.range):typeof Se.range=="object"&&(Ne.range={inserting:u.to(Se.range.insert),replacing:u.to(Se.range.replace)}),Ne.keepWhitespace=typeof Se.insertTextRules>"u"?!1:Boolean(Se.insertTextRules&1),typeof Se.insertTextRules<"u"&&Se.insertTextRules&4?Ne.insertText=new s.SnippetString(Se.insertText):(Ne.insertText=Se.insertText,Ne.textEdit=Ne.range instanceof s.Range?new s.TextEdit(Ne.range,Ne.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Ne.additionalTextEdits=Se.additionalTextEdits.map($e=>q.to($e))),Ne.command=re&&Se.command?re.fromInternal(Se.command):void 0,Ne}Re.to=Oe})(x=e.CompletionItem||(e.CompletionItem={}));var Y;(function(Re){function Oe(re){if(typeof re.label!="string"&&!Array.isArray(re.label))throw new TypeError("Invalid label");return{label:re.label,documentation:N.fromStrict(re.documentation)}}Re.from=Oe;function Se(re){return{label:re.label,documentation:I.isMarkdownString(re.documentation)?N.to(re.documentation):re.documentation}}Re.to=Se})(Y=e.ParameterInformation||(e.ParameterInformation={}));var de;(function(Re){function Oe(re){return{label:re.label,documentation:N.fromStrict(re.documentation),parameters:Array.isArray(re.parameters)?re.parameters.map(Y.from):[],activeParameter:re.activeParameter}}Re.from=Oe;function Se(re){return{label:re.label,documentation:I.isMarkdownString(re.documentation)?N.to(re.documentation):re.documentation,parameters:Array.isArray(re.parameters)?re.parameters.map(Y.to):[],activeParameter:re.activeParameter}}Re.to=Se})(de=e.SignatureInformation||(e.SignatureInformation={}));var be;(function(Re){function Oe(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(de.from):[]}}Re.from=Oe;function Se(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(de.to):[]}}Re.to=Se})(be=e.SignatureHelp||(e.SignatureHelp={}));var Pe;(function(Re){function Oe(Se,re){const Ne=new s.InlayHint(l.to(re.position),typeof re.label=="string"?re.label:re.label.map(pe.to.bind(void 0,Se)),re.kind&&De.to(re.kind));return Ne.textEdits=re.textEdits&&re.textEdits.map(q.to),Ne.tooltip=I.isMarkdownString(re.tooltip)?N.to(re.tooltip):re.tooltip,Ne.paddingLeft=re.paddingLeft,Ne.paddingRight=re.paddingRight,Ne}Re.to=Oe})(Pe=e.InlayHint||(e.InlayHint={}));var pe;(function(Re){function Oe(Se,re){const Ne=new s.InlayHintLabelPart(re.label);return Ne.tooltip=I.isMarkdownString(re.tooltip)?N.to(re.tooltip):re.tooltip,d.Command.is(re.command)&&(Ne.command=Se.fromInternal(re.command)),re.location&&(Ne.location=Ee.to(re.location)),Ne}Re.to=Oe})(pe=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var De;(function(Re){function Oe(re){return re}Re.from=Oe;function Se(re){return re}Re.to=Se})(De=e.InlayHintKind||(e.InlayHintKind={}));var ke;(function(Re){function Oe(re){return{range:u.from(re.range),url:re.target,tooltip:re.tooltip}}Re.from=Oe;function Se(re){let Ne;if(re.url)try{Ne=typeof re.url=="string"?D.URI.parse(re.url,!0):D.URI.revive(re.url)}catch{}return new s.DocumentLink(u.to(re.range),Ne)}Re.to=Se})(ke=e.DocumentLink||(e.DocumentLink={}));var je;(function(Re){function Oe(re){const Ne=new s.ColorPresentation(re.label);return re.textEdit&&(Ne.textEdit=q.to(re.textEdit)),re.additionalTextEdits&&(Ne.additionalTextEdits=re.additionalTextEdits.map($e=>q.to($e))),Ne}Re.to=Oe;function Se(re){return{label:re.label,textEdit:re.textEdit?q.from(re.textEdit):void 0,additionalTextEdits:re.additionalTextEdits?re.additionalTextEdits.map(Ne=>q.from(Ne)):void 0}}Re.from=Se})(je=e.ColorPresentation||(e.ColorPresentation={}));var Ge;(function(Re){function Oe(re){return new s.Color(re[0],re[1],re[2],re[3])}Re.to=Oe;function Se(re){return[re.red,re.green,re.blue,re.alpha]}Re.from=Se})(Ge=e.Color||(e.Color={}));var et;(function(Re){function Oe(re){return{range:u.from(re.range)}}Re.from=Oe;function Se(re){return new s.SelectionRange(u.to(re.range))}Re.to=Se})(et=e.SelectionRange||(e.SelectionRange={}));var _e;(function(Re){function Oe(Se){switch(Se){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Re.to=Oe})(_e=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(Re){function Oe(re){switch(re){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Re.from=Oe;function Se(re){switch(re){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Re.to=Se})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var st;(function(Re){function Oe(re){if(re===s.EndOfLine.CRLF)return 1;if(re===s.EndOfLine.LF)return 0}Re.from=Oe;function Se(re){if(re===1)return s.EndOfLine.CRLF;if(re===0)return s.EndOfLine.LF}Re.to=Se})(st=e.EndOfLine||(e.EndOfLine={}));var ht;(function(Re){function Oe(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Re.from=Oe})(ht=e.ProgressLocation||(e.ProgressLocation={}));var Me;(function(Re){function Oe(Se){const re={start:Se.start+1,end:Se.end+1};return Se.kind&&(re.kind=it.from(Se.kind)),re}Re.from=Oe})(Me=e.FoldingRange||(e.FoldingRange={}));var it;(function(Re){function Oe(Se){if(Se)switch(Se){case s.FoldingRangeKind.Comment:return d.FoldingRangeKind.Comment;case s.FoldingRangeKind.Imports:return d.FoldingRangeKind.Imports;case s.FoldingRangeKind.Region:return d.FoldingRangeKind.Region}}Re.from=Oe})(it=e.FoldingRangeKind||(e.FoldingRangeKind={}));var oe;(function(Re){function Oe(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?u.from(Se.selection):void 0,override:typeof Se.override=="boolean"?w.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Re.from=Oe})(oe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var $;(function(Re){function Oe($e){return $e instanceof s.RelativePattern?$e.toJSON():typeof $e=="string"?$e:Se($e)||re($e)?new s.RelativePattern($e.baseUri??$e.base,$e.pattern).toJSON():$e}Re.from=Oe;function Se($e){const Qe=$e;return Qe?D.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function re($e){const Qe=$e;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Ne($e){return typeof $e=="string"?$e:new s.RelativePattern(D.URI.revive($e.baseUri),$e.pattern)}Re.to=Ne})($=e.GlobPattern||(e.GlobPattern={}));var ce;(function(Re){function Oe(Se){if(Se){if(Array.isArray(Se))return Se.map(Oe);if(typeof Se=="string")return Se;{const re=Se;return{language:re.language,scheme:re.scheme,pattern:$.from(re.pattern),exclusive:re.exclusive,notebookType:re.notebookType}}}else return}Re.from=Oe})(ce=e.LanguageSelector||(e.LanguageSelector={}));var Ie;(function(Re){function Oe(re){return{start:re.start,end:re.end}}Re.from=Oe;function Se(re){return new s.NotebookRange(re.start,re.end)}Re.to=Se})(Ie=e.NotebookRange||(e.NotebookRange={}));var Le;(function(Re){function Oe(re){return{timing:typeof re.runStartTime=="number"&&typeof re.runEndTime=="number"?{startTime:re.runStartTime,endTime:re.runEndTime}:void 0,executionOrder:re.executionOrder,success:re.lastRunSuccess}}Re.to=Oe;function Se(re){return{lastRunSuccess:re.success,runStartTime:re.timing?.startTime,runEndTime:re.timing?.endTime,executionOrder:re.executionOrder}}Re.from=Se})(Le=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Be;(function(Re){function Oe(Se){if(Se===g.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(Se===g.NotebookCellExecutionState.Pending)return;if(Se===g.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Re.to=Oe})(Be=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var xe;(function(Re){function Oe(re){switch(re){case s.NotebookCellKind.Markup:return g.CellKind.Markup;case s.NotebookCellKind.Code:default:return g.CellKind.Code}}Re.from=Oe;function Se(re){switch(re){case g.CellKind.Markup:return s.NotebookCellKind.Markup;case g.CellKind.Code:default:return s.NotebookCellKind.Code}}Re.to=Se})(xe=e.NotebookCellKind||(e.NotebookCellKind={}));var Ze;(function(Re){function Oe(re){const Ne={metadata:re.metadata??Object.create(null),cells:[]};for(const $e of re.cells)s.NotebookCellData.validate($e),Ne.cells.push(gt.from($e));return Ne}Re.from=Oe;function Se(re){const Ne=new s.NotebookData(re.cells.map(gt.to));return(0,y.isEmptyObject)(re.metadata)||(Ne.metadata=re.metadata),Ne}Re.to=Se})(Ze=e.NotebookData||(e.NotebookData={}));var gt;(function(Re){function Oe(re){return{cellKind:xe.from(re.kind),language:re.languageId,mime:re.mime,source:re.value,metadata:re.metadata,internalMetadata:Le.from(re.executionSummary??{}),outputs:re.outputs?re.outputs.map(lt.from):[]}}Re.from=Oe;function Se(re){return new s.NotebookCellData(xe.to(re.cellKind),re.source,re.language,re.mime,re.outputs?re.outputs.map(lt.to):void 0,re.metadata,re.internalMetadata?Le.to(re.internalMetadata):void 0)}Re.to=Se})(gt=e.NotebookCellData||(e.NotebookCellData={}));var mt;(function(Re){function Oe(re){return{mime:re.mime,valueBytes:t.VSBuffer.wrap(re.data)}}Re.from=Oe;function Se(re){return new s.NotebookCellOutputItem(re.valueBytes.buffer,re.mime)}Re.to=Se})(mt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var lt;(function(Re){function Oe(re){return{outputId:re.id,items:re.items.map(mt.from),metadata:re.metadata}}Re.from=Oe;function Se(re){const Ne=re.items.map(mt.to);return new s.NotebookCellOutput(Ne,re.outputId,re.metadata)}Re.to=Se})(lt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ot;(function(Re){function Oe(Ne){return re(Ne)?{include:(0,y.withNullAsUndefined)($.from(Ne.include)),exclude:(0,y.withNullAsUndefined)($.from(Ne.exclude))}:(0,y.withNullAsUndefined)($.from(Ne))}Re.from=Oe;function Se(Ne){return re(Ne)?{include:$.to(Ne.include),exclude:$.to(Ne.exclude)}:$.to(Ne)}Re.to=Se;function re(Ne){const $e=Ne;return $e?!(0,y.isUndefinedOrNull)($e.include)&&!(0,y.isUndefinedOrNull)($e.exclude):!1}})(ot=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var rt;(function(Re){function Oe(Se,re,Ne){const $e=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:re.toInternal($e,Ne),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Re.from=Oe})(rt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var kt;(function(Re){function Oe(Se,re,Ne){const $e=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:re.toInternal($e,Ne),label:Se.label,description:Se.description,detail:Se.detail}}Re.from=Oe})(kt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Tt;(function(Re){function Oe(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Re.from=Oe})(Tt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Nt;(function(Re){function Oe(re){return{uri:re.uri,provides:re.provides}}Re.from=Oe;function Se(re){return new s.NotebookRendererScript(D.URI.revive(re.uri),re.provides)}Re.to=Se})(Nt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var pt;(function(Re){function Oe(re){return{message:N.fromStrict(re.message)||"",type:0,expected:re.expectedOutput,actual:re.actualOutput,location:re.location&&{range:u.from(re.location.range),uri:re.location.uri}}}Re.from=Oe;function Se(re){const Ne=new s.TestMessage(typeof re.message=="string"?re.message:N.to(re.message));return Ne.actualOutput=re.actual,Ne.expectedOutput=re.expected,Ne.location=re.location?Ee.to(re.location):void 0,Ne}Re.to=Se})(pt=e.TestMessage||(e.TestMessage={}));var Dt;(function(Re){Re.namespace=b.namespaceTestTag,Re.denamespace=b.denamespaceTestTag})(Dt=e.TestTag||(e.TestTag={}));var zt;(function(Re){function Oe(re){const Ne=(0,h.getPrivateApiFor)(re).controllerId;return{extId:p.TestId.fromExtHostTestItem(re,Ne).toString(),label:re.label,uri:D.URI.revive(re.uri),busy:re.busy,tags:re.tags.map($e=>Dt.namespace(Ne,$e.id)),range:v.Range.lift(u.from(re.range)),description:re.description||null,sortText:re.sortText||null,error:re.error&&N.fromStrict(re.error)||null}}Re.from=Oe;function Se(re){return{parent:void 0,error:void 0,id:p.TestId.fromString(re.extId).localId,label:re.label,uri:D.URI.revive(re.uri),tags:(re.tags||[]).map(Ne=>{const{tagId:$e}=Dt.denamespace(Ne);return new s.TestTag($e)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:u.to(re.range||void 0),canResolveChildren:!1,busy:re.busy,description:re.description||void 0,sortText:re.sortText||void 0}}Re.toPlain=Se})(zt=e.TestItem||(e.TestItem={})),function(Re){function Oe(re){return{id:re.id}}Re.from=Oe;function Se(re){return new s.TestTag(re.id)}Re.to=Se}(Dt=e.TestTag||(e.TestTag={}));var Ft;(function(Re){const Oe=(re,Ne)=>{const $e=[];for(const[Ve,tt]of Ne)p.TestId.compare(tt.item.extId,Ve)===2&&(Ne.delete(Ve),$e.push(tt));const Qe={...zt.toPlain(re.item),parent:void 0,taskStates:re.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(tt=>tt.type===0).map(pt.to)})),children:$e.map(Ve=>Oe(Ve,Ne))};for(const Ve of Qe.children)Ve.parent=Qe;return Qe};function Se(re){const Ne=[],$e=new Map;for(const Qe of re.items){$e.set(Qe.item.extId,Qe);const Ve=p.TestId.root(Qe.item.extId);re.request.targets.some(tt=>tt.controllerId===Ve&&tt.testIds.includes(Qe.item.extId))&&Ne.push(Qe)}return{completedAt:re.completedAt,results:Ne.map(Qe=>Oe(Qe,$e))}}Re.to=Se})(Ft=e.TestResults||(e.TestResults={}));var Xe;(function(Re){function Oe($e){return{covered:$e.covered,total:$e.covered}}function Se($e){return"line"in $e?l.from($e):u.from($e)}function re($e){return"branches"in $e?{count:$e.executionCount,location:Se($e.location),type:1,branches:$e.branches.length?$e.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&Se(Qe.location)})):void 0}:{type:0,count:$e.executionCount,location:Se($e.location)}}Re.fromDetailed=re;function Ne($e){return{uri:$e.uri,statement:Oe($e.statementCoverage),branch:$e.branchCoverage&&Oe($e.branchCoverage),function:$e.functionCoverage&&Oe($e.functionCoverage),details:$e.detailedCoverage?.map(re)}}Re.fromFile=Ne})(Xe=e.TestCoverage||(e.TestCoverage={}));var Mt;(function(Re){function Oe(Se){switch(Se){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Re.to=Oe})(Mt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ut;(function(Re){function Oe(re){const Ne=new s.TypeHierarchyItem(Q.to(re.kind),re.name,re.detail||"",D.URI.revive(re.uri),u.to(re.range),u.to(re.selectionRange));return Ne._sessionId=re._sessionId,Ne._itemId=re._itemId,Ne}Re.to=Oe;function Se(re,Ne,$e){if(Ne=Ne??re._sessionId,$e=$e??re._itemId,Ne===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:$e,kind:Q.from(re.kind),name:re.name,detail:re.detail??"",uri:re.uri,range:u.from(re.range),selectionRange:u.from(re.selectionRange),tags:re.tags?.map(Z.from)}}Re.from=Se})(Ut=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Bt;(function(Re){function Oe(Se){if(!!Se)return{value:Se.value,tooltip:Se.tooltip}}Re.from=Oe})(Bt=e.ViewBadge||(e.ViewBadge={}));var bt;(function(Re){function Oe($e,Qe,Ve){const tt=Qe.fileData;return tt?new class extends s.DataTransferItem{asFile(){return{name:tt.name,uri:D.URI.revive(tt.uri),data:(0,R.once)(()=>Ve())}}}("",Qe.id):$e===L.Mimes.uriList&&Qe.uriListData?new s.DataTransferItem(Ne(Qe.uriListData)):new s.DataTransferItem(Qe.asString)}Re.to=Oe;async function Se($e,Qe){const Ve=await Qe.asString();if($e===L.Mimes.uriList)return{id:Qe.id,asString:"",fileData:void 0,uriListData:re(Ve)};const tt=Qe.asFile();return{id:Qe.id,asString:Ve,fileData:tt?{name:tt.name,uri:tt.uri}:void 0}}Re.from=Se;function re($e){return k.UriList.split($e).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return D.URI.parse(Qe)}catch{}return Qe})}function Ne($e){return k.UriList.create($e.map(Qe=>typeof Qe=="string"?Qe:D.URI.revive(Qe)))}})(bt=e.DataTransferItem||(e.DataTransferItem={}));var Pt;(function(Re){function Oe(re,Ne){const $e=re.items.map(([Qe,Ve])=>[Qe,bt.to(Qe,Ve,()=>Ne(Ve.id))]);return new s.DataTransfer($e)}Re.toDataTransfer=Oe;async function Se(re){const Ne={items:[]},$e=[];return re.forEach((Qe,Ve)=>{$e.push((async()=>{Ne.items.push([Ve,await bt.from(Ve,Qe)])})())}),await Promise.all($e),Ne}Re.toDataTransferDTO=Se})(Pt=e.DataTransfer||(e.DataTransfer={}))}),define(ye[232],Ce([1,0,2,10,7,14,63]),function(ne,e,o,t,k,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(C,L,P,y={timeout:1500,errors:3}){this.c=C,this.d=L,this.f=P,this.g=y,this.a=new I.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(C){return(L,P,y)=>{const v={dispose:this.a.push([L,P,C])};return Array.isArray(y)&&y.push(v),v}}async $participateInSave(C,L){const P=o.URI.revive(C);let y=!1;const D=setTimeout(()=>y=!0,this.g.timeout),v=[];try{for(const d of[...this.a]){if(y)break;const m=this.d.getDocument(P),h=await this.h(d,{document:m,reason:R.TextDocumentSaveReason.to(L)});v.push(h)}}finally{clearTimeout(D)}return v}h([C,L,P],y){const D=this.b.get(C);return typeof D=="number"&&D>this.g.errors?Promise.resolve(!1):this.i(P,C,L,y).then(()=>!0,v=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this.c.error(v),!(v instanceof Error)||v.message!=="concurrent_edits"){const d=this.b.get(C);this.b.set(C,d?d+1:1),typeof d=="number"&&d>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(C,L,P,y){const D=[],v=Date.now(),{document:d,reason:m}=y,{version:h}=d,w=Object.freeze({document:d,reason:m,waitUntil(g){if(Object.isFrozen(D))throw(0,t.illegalState)("waitUntil can not be called async");D.push(Promise.resolve(g))}});try{L.apply(P,[w])}catch(g){return Promise.reject(g)}return Object.freeze(D),new Promise((g,p)=>{const b=setTimeout(()=>p(new Error("timeout")),this.g.timeout);return Promise.all(D).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-v}ms`),clearTimeout(b),g(i)}).catch(i=>{clearTimeout(b),p(i)})}).then(g=>{const p={edits:[]};for(const b of g)if(Array.isArray(b)&&b.every(i=>i instanceof k.TextEdit))for(const{newText:i,newEol:s,range:a}of b)p.edits.push({resource:d.uri,versionId:void 0,textEdit:{range:a&&R.Range.from(a),text:i,eol:s&&R.EndOfLine.from(s)}});if(p.edits.length!==0)return h===d.version?this.f.$tryApplyWorkspaceEdit(p):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(ye[233],Ce([1,0,15,2,14,7,91]),function(ne,e,o,t,k,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(P,y,D,v){this.start=P,this.deletedCount=y,this.deletedItems=D,this.items=v}asApiEvent(){return{range:new R.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(P=>P.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(P,y){return{EOL:y.eol,lines:y.source,languageId:y.language,uri:y.uri,isDirty:!1,versionId:1,notebook:P}}constructor(P,y,D){this.notebook=P,this.h=y,this.j=D,this.handle=D.handle,this.uri=t.URI.revive(D.uri),this.cellKind=D.cellKind,this.a=D.outputs.map(k.NotebookCellOutput.to),this.e=D.internalMetadata??{},this.b=Object.freeze(D.metadata??{}),this.d=Object.freeze(k.NotebookCellExecutionSummary.to(D.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const P=this,y=this.h.getDocument(this.uri);if(!y)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const D={get index(){return P.notebook.getCellIndex(P)},notebook:P.notebook.apiNotebook,kind:k.NotebookCellKind.to(this.j.cellKind),document:y.document,get mime(){return P.g},set mime(v){P.g=v},get outputs(){return P.a.slice(0)},get metadata(){return P.b},get executionSummary(){return P.d}};this.f=Object.freeze(D)}return this.f}setOutputs(P){this.a=P.map(k.NotebookCellOutput.to)}setOutputItems(P,y,D){const v=D.map(k.NotebookCellOutputItem.to),d=this.a.find(m=>m.id===P);if(d&&(y||(d.items.length=0),d.items.push(...v),d.items.length>1&&d.items.every(m=>I.isTextStreamMime(m.mime)))){const m=new Map,h=[];d.items.forEach(w=>{let g;m.has(w.mime)?g=m.get(w.mime):(g=[],m.set(w.mime,g),h.push(w.mime)),g.push(w.data)}),d.items.length=0,h.forEach(w=>{const g=I.compressOutputItemStreams(m.get(w));d.items.push({mime:w,data:g.buffer})})}}setMetadata(P){this.b=Object.freeze(P)}setInternalMetadata(P){this.e=P,this.d=Object.freeze(k.NotebookCellExecutionSummary.to(P))}setMime(P){}}e.ExtHostCell=S;class C{constructor(P,y,D,v,d){this.k=P,this.l=y,this.m=D,this.uri=v,this.handle=C.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=d.viewType,this.f=Object.freeze(d.metadata??Object.create(null)),this.r([[0,0,d.cells]],!0,void 0),this.g=d.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const P=this,y={get uri(){return P.uri},get version(){return P.g},get notebookType(){return P.d},get isDirty(){return P.h},get isUntitled(){return P.uri.scheme===o.Schemas.untitled},get isClosed(){return P.j},get metadata(){return P.f},get cellCount(){return P.b.length},cellAt(D){return D=P.n(D),P.b[D].apiCell},getCells(D){return(D?P.p(D):P.b).map(d=>d.apiCell)},save(){return P.q()}};this.e=Object.freeze(y)}return this.e}acceptDocumentPropertiesChanged(P){P.metadata&&(this.f=Object.freeze({...this.f,...P.metadata}))}acceptDirty(P){this.h=P}acceptModelChanged(P,y,D){this.g=P.versionId,this.h=y,this.acceptDocumentPropertiesChanged({metadata:D});const v={notebook:this.apiNotebook,metadata:D,cellChanges:[],contentChanges:[]},d=[];for(const h of P.rawEvents)h.kind===I.NotebookCellsChangeType.ModelChange?this.r(h.changes,!1,v.contentChanges):h.kind===I.NotebookCellsChangeType.Move?this.s(h.index,h.length,h.newIdx,v.contentChanges):h.kind===I.NotebookCellsChangeType.Output?(this.t(h.index,h.outputs),d.push({cell:this.b[h.index].apiCell,outputs:this.b[h.index].apiCell.outputs})):h.kind===I.NotebookCellsChangeType.OutputItem?(this.u(h.index,h.outputId,h.append,h.outputItems),d.push({cell:this.b[h.index].apiCell,outputs:this.b[h.index].apiCell.outputs})):h.kind===I.NotebookCellsChangeType.ChangeCellLanguage?(this.v(h.index,h.language),d.push({cell:this.b[h.index].apiCell,document:this.b[h.index].apiCell.document})):h.kind===I.NotebookCellsChangeType.ChangeCellContent?d.push({cell:this.b[h.index].apiCell,document:this.b[h.index].apiCell.document}):h.kind===I.NotebookCellsChangeType.ChangeCellMime?this.w(h.index,h.mime):h.kind===I.NotebookCellsChangeType.ChangeCellMetadata?(this.x(h.index,h.metadata),d.push({cell:this.b[h.index].apiCell,metadata:this.b[h.index].apiCell.metadata})):h.kind===I.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(h.index,h.internalMetadata),d.push({cell:this.b[h.index].apiCell,executionSummary:this.b[h.index].apiCell.executionSummary}));const m=new Map;for(let h=0;h<d.length;h++){const w=d[h],g=m.get(w.cell);if(g===void 0){const p=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...w});m.set(w.cell,p-1)}else v.cellChanges[g]={...v.cellChanges[g],...w}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}n(P){return P=P|0,P<0?0:P>=this.b.length?this.b.length-1:P}o(P){let y=P.start|0,D=P.end|0;return y<0&&(y=0),D>this.b.length&&(D=this.b.length),P.with({start:y,end:D})}p(P){P=this.o(P);const y=[];for(let D=P.start;D<P.end;D++)y.push(this.b[D]);return y}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(P,y,D){if(this.j)return;const v=[],d=[],m=[];if(P.reverse().forEach(h=>{const g=h[2].map(i=>{const s=new S(this,this.l,i);return y||d.push(S.asModelAddData(this.apiNotebook,i)),s}),p=new A(h[0],h[1],[],g),b=this.b.splice(h[0],h[1],...g);for(const i of b)m.push(i.uri),p.deletedItems.push(i.apiCell);v.push(p)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:m}),D)for(const h of v)D.push(h.asApiEvent())}s(P,y,D,v){const d=this.b.splice(P,y);this.b.splice(D,0,...d);const m=[new A(P,y,d.map(h=>h.apiCell),[]),new A(D,0,[],d)];for(const h of m)v.push(h.asApiEvent())}t(P,y){this.b[P].setOutputs(y)}u(P,y,D,v){this.b[P].setOutputItems(y,D,v)}v(P,y){const D=this.b[P];D.apiCell.document.languageId!==y&&this.m.$acceptModelLanguageChanged(D.uri,y)}w(P,y){const D=this.b[P];D.apiCell.mime=y}x(P,y){this.b[P].setMetadata(y)}y(P,y){this.b[P].setInternalMetadata(y)}getCellFromApiCell(P){return this.b.find(y=>y.apiCell===P)}getCellFromIndex(P){return this.b[P]}getCell(P){return this.b.find(y=>y.handle===P)}getCellIndex(P){return this.b.indexOf(P)}}e.ExtHostNotebookDocument=C,C.a=0}),define(ye[136],Ce([1,0,10,14,7]),function(ne,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class R{constructor(A,S,C,L,P,y){this.id=A,this.f=S,this.notebookData=C,this.a=[],this.b=[],this.d=!1,this.a=P,this.b=L,this.c=y}get apiEditor(){if(!this.e){const A=this;this.e={get notebook(){return A.notebookData.apiNotebook},get selection(){return A.a[0]},set selection(S){this.selections=[S]},get selections(){return A.a},set selections(S){if(!Array.isArray(S)||!S.every(k.NotebookRange.isNotebookRange))throw(0,o.illegalArgument)("selections");A.a=S,A.g(S)},get visibleRanges(){return A.b},revealRange(S,C){A.f.$tryRevealRange(A.id,t.NotebookRange.from(S),C??k.NotebookEditorRevealType.Default)},get viewColumn(){return A.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(A){this.d=A}_acceptVisibleRanges(A){this.b=A}_acceptSelections(A){this.a=A}g(A){this.f.$trySetSelections(this.id,A.map(t.NotebookRange.from))}_acceptViewColumn(A){this.c=A}}e.ExtHostNotebookEditor=R,R.apiEditorsToExtHost=new WeakMap}),define(ye[234],Ce([1,0,4,13,14]),function(ne,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let R=class{constructor(A,S){this.c=A,this.d=S,this.a=new o.Emitter,this.b=new o.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(A,S){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",A,S);const C=this.d.getEditorById(A);S.visibleRanges&&C._acceptVisibleRanges(S.visibleRanges.ranges.map(k.NotebookRange.to)),S.selections&&C._acceptSelections(S.selections.selections.map(k.NotebookRange.to)),S.visibleRanges&&this.b.fire({notebookEditor:C.apiEditor,visibleRanges:C.apiEditor.visibleRanges}),S.selections&&this.a.fire(Object.freeze({notebookEditor:C.apiEditor,selections:C.apiEditor.selections}))}$acceptEditorViewColumns(A){for(const S in A)this.d.getEditorById(S)._acceptViewColumn(k.ViewColumn.to(A[S]))}};R=qe([He(0,t.ILogService)],R),e.ExtHostNotebookEditors=R}),define(ye[235],Ce([1,0,14,125,175,21,60,10]),function(ne,e,o,t,k,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(y){this.b=0,this.c=new Map,this.a=y}async withProgress(y,D,v){const d=this.b++,{title:m,location:h,cancellable:w}=D,g={label:(0,k.localize)(0,null,y.displayName||y.name),id:y.identifier.value};return this.a.$startProgress(d,{location:o.ProgressLocation.from(h),title:m,source:g,cancellable:w},y.isUnderDevelopment?void 0:y.identifier.value).catch(A.onUnexpectedExternalError),this.d(d,v,!!w)}d(y,D,v){let d;v&&(d=new R.CancellationTokenSource,this.c.set(y,d));const m=w=>{this.a.$progressEnd(w),this.c.delete(w),d?.dispose()};let h;try{h=D(new L(this.a,y),v&&d?d.token:R.CancellationToken.None)}catch(w){throw m(y),w}return h.then(w=>m(y),w=>m(y)),h}$acceptProgressCanceled(y){const D=this.c.get(y);D&&(D.cancel(),this.c.delete(y))}}e.ExtHostProgress=S;function C(P,y){return P.message=y.message,typeof y.increment=="number"&&(typeof P.increment=="number"?P.increment+=y.increment:P.increment=y.increment),P}class L extends t.Progress{constructor(y,D){super(v=>this.throttledReport(v)),this.c=y,this.d=D}throttledReport(y){this.c.$progressReport(this.d,y)}}qe([(0,I.throttle)(100,(P,y)=>C(P,y),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(ye[137],Ce([1,0,35,132,56,92,70,14,2]),function(ne,e,o,t,k,R,I,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const C=(g,p,b,i)=>{let s=p;return{enumerable:!0,configurable:!1,get(){return s},set(a){if(!b(s,a)){const u=s;s=a,g.listener?.(i(a,u))}}}},L=(g,p)=>g===p,P={range:(g,p)=>g===p?!0:!g||!p?!1:g.isEqual(p),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(g,p)=>!(g.length!==p.length||g.some(b=>!p.find(i=>b.id===i.id)))},y=g=>p=>({op:4,update:g(p)}),D=(g,p)=>({range:(()=>{let b;const i=y(s=>({range:o.Range.lift(A.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return b},set(s){g.listener?.({op:6}),P.range(b,s)||(b=s,g.listener?.(i(s)))}}})(),label:C(g,p,P.label,y(b=>({label:b}))),description:C(g,void 0,P.description,y(b=>({description:b}))),sortText:C(g,void 0,P.sortText,y(b=>({sortText:b}))),canResolveChildren:C(g,!1,P.canResolveChildren,b=>({op:2,state:b})),busy:C(g,!1,P.busy,y(b=>({busy:b}))),error:C(g,void 0,P.error,y(b=>({error:A.MarkdownString.fromStrict(b)||null}))),tags:C(g,[],P.tags,(b,i)=>({op:1,new:b.map(A.TestTag.from),old:i.map(A.TestTag.from)}))}),v=g=>{const p=k.TestId.fromString(g.extId),b=new m(p.controllerId,p.localId,g.label,S.URI.revive(g.uri)||void 0);return b.range=A.Range.to(g.range||void 0),b.description=g.description||void 0,b.sortText=g.sortText||void 0,b.tags=g.tags.map(i=>A.TestTag.to({id:(0,I.denamespaceTestTag)(i).tagId})),b},d=g=>{let p;for(const b of g.tests){const i=v(b.item);(0,t.getPrivateApiFor)(i).parent=p,p=i}return p};e.toItemFromContext=d;class m{constructor(p,b,i,s){if(b.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(b)} symbol`);const a=(0,t.createPrivateApiFor)(this,p);Object.defineProperties(this,{id:{value:b,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof h?void 0:a.parent}},children:{value:(0,R.createTestItemChildren)(a,t.getPrivateApiFor,m),enumerable:!0,writable:!1},...D(a,i)})}}e.TestItemImpl=m;class h extends m{constructor(p,b){super(p,p,b,void 0),this._isRoot=!0}}e.TestItemRootImpl=h;class w extends R.TestItemCollection{constructor(p,b,i){super({controllerId:p,getDocumentVersion:s=>s&&i.getDocument(s)?.version,getApiFor:t.getPrivateApiFor,getChildren:s=>s.children,root:new h(p,b),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=w}),define(ye[138],Ce([1,0,49,10,100,14,7]),function(ne,e,o,t,k,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class A{constructor(y,D,v){const d=A.c.nextId();y.$registerTextEditorDecorationType(D.identifier,d,R.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:d,dispose(){y.$removeTextEditorDecorationType(d)}})}}e.TextEditorDecorationType=A,A.c=new k.IdGenerator("TextEditorDecorationType");class S{constructor(y,D){this.g=[],this.h=void 0,this.j=!1,this.c=y,this.d=y.version,this.e=D.undoStopBefore,this.f=D.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(y,D){this.k();let v=null;if(y instanceof I.Position)v=new I.Range(y,y);else if(y instanceof I.Range)v=y;else throw new Error("Unrecognized location");this.l(v,D,!1)}insert(y,D){this.k(),this.l(new I.Range(y,y),D,!0)}delete(y){this.k();let D=null;if(y instanceof I.Range)D=y;else throw new Error("Unrecognized location");this.l(D,null,!0)}l(y,D,v){const d=this.c.validateRange(y);this.g.push({range:d,text:D,forceMoveMarkers:v})}setEndOfLine(y){if(this.k(),y!==I.EndOfLine.LF&&y!==I.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this.h=y}}class C{constructor(y,D,v,d){this.c=y,this.d=D,this._accept(v),this.e=d;const m=this;this.value={get tabSize(){return m.f},set tabSize(h){m.m(h)},get indentSize(){return m.g},set indentSize(h){m.o(h)},get insertSpaces(){return m.h},set insertSpaces(h){m.q(h)},get cursorStyle(){return m.j},set cursorStyle(h){m.s(h)},get lineNumbers(){return m.k},set lineNumbers(h){m.t(h)}}}_accept(y){this.f=y.tabSize,this.g=y.indentSize,this.h=y.insertSpaces,this.j=y.cursorStyle,this.k=R.TextEditorLineNumbersStyle.to(y.lineNumbers)}l(y){if(y==="auto")return"auto";if(typeof y=="number"){const D=Math.floor(y);return D>0?D:null}if(typeof y=="string"){const D=parseInt(y,10);return isNaN(D)?null:D>0?D:null}return null}m(y){const D=this.l(y);if(D!==null){if(typeof D=="number"){if(this.f===D)return;this.f=D}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:D}))}}n(y){if(y==="tabSize")return"tabSize";if(typeof y=="number"){const D=Math.floor(y);return D>0?D:null}if(typeof y=="string"){const D=parseInt(y,10);return isNaN(D)?null:D>0?D:null}return null}o(y){const D=this.n(y);if(D!==null){if(typeof D=="number"){if(this.g===D)return;this.g=D}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:D}))}}p(y){return y==="auto"?"auto":y==="false"?!1:Boolean(y)}q(y){const D=this.p(y);if(typeof D=="boolean"){if(this.h===D)return;this.h=D}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:D}))}s(y){this.j!==y&&(this.j=y,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:y})))}t(y){this.k!==y&&(this.k=y,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(y)})))}assign(y){const D={};let v=!1;if(typeof y.tabSize<"u"){const d=this.l(y.tabSize);d==="auto"?(v=!0,D.tabSize=d):typeof d=="number"&&this.f!==d&&(this.f=d,v=!0,D.tabSize=d)}if(typeof y.indentSize<"u"){const d=this.n(y.indentSize);d==="tabSize"?(v=!0,D.indentSize=d):typeof d=="number"&&this.g!==d&&(this.g=d,v=!0,D.indentSize=d)}if(typeof y.insertSpaces<"u"){const d=this.p(y.insertSpaces);d==="auto"?(v=!0,D.insertSpaces=d):this.h!==d&&(this.h=d,v=!0,D.insertSpaces=d)}typeof y.cursorStyle<"u"&&this.j!==y.cursorStyle&&(this.j=y.cursorStyle,v=!0,D.cursorStyle=y.cursorStyle),typeof y.lineNumbers<"u"&&this.k!==y.lineNumbers&&(this.k=y.lineNumbers,v=!0,D.lineNumbers=R.TextEditorLineNumbersStyle.from(y.lineNumbers)),v&&this.u("setOptions",this.c.$trySetOptions(this.d,D))}u(y,D){D.catch(v=>{this.e.warn(`ExtHostTextEditorOptions '${y}' failed:'`),this.e.warn(v)})}}e.ExtHostTextEditorOptions=C;class L{constructor(y,D,v,d,m,h,w,g){this.id=y,this.j=D,this.k=v,this.g=!1,this.h=new Set,this.c=m,this.d=new C(this.j,this.id,h,v),this.e=w,this.f=g;const p=this;this.value=Object.freeze({get document(){return d.getValue()},set document(b){throw(0,t.readonly)("document")},get selection(){return p.c&&p.c[0]},set selection(b){if(!(b instanceof I.Selection))throw(0,t.illegalArgument)("selection");p.c=[b],p.l()},get selections(){return p.c},set selections(b){if(!Array.isArray(b)||b.some(i=>!(i instanceof I.Selection)))throw(0,t.illegalArgument)("selections");p.c=b,p.l()},get visibleRanges(){return p.e},set visibleRanges(b){throw(0,t.readonly)("visibleRanges")},get options(){return p.d.value},set options(b){p.g||p.d.assign(b)},get viewColumn(){return p.f},set viewColumn(b){throw(0,t.readonly)("viewColumn")},edit(b,i={undoStopBefore:!0,undoStopAfter:!0}){if(p.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new S(d.getValue(),i);return b(s),p.m(s)},insertSnippet(b,i,s={undoStopBefore:!0,undoStopAfter:!0}){if(p.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!i||Array.isArray(i)&&i.length===0)a=p.c.map(u=>R.Range.from(u));else if(i instanceof I.Position){const{lineNumber:u,column:c}=R.Position.from(i);a=[{startLineNumber:u,startColumn:c,endLineNumber:u,endColumn:c}]}else if(i instanceof I.Range)a=[R.Range.from(i)];else{a=[];for(const u of i)if(u instanceof I.Range)a.push(R.Range.from(u));else{const{lineNumber:c,column:l}=R.Position.from(u);a.push({startLineNumber:c,startColumn:l,endLineNumber:c,endColumn:l})}}return D.$tryInsertSnippet(y,d.getValue().version,b.value,a,s)},setDecorations(b,i){const s=i.length===0;s&&!p.h.has(b.key)||(s?p.h.delete(b.key):p.h.add(b.key),p.n(()=>{if(R.isDecorationOptionsArr(i))return D.$trySetDecorations(y,b.key,R.fromRangeOrRangeWithMessage(i));{const a=new Array(4*i.length);for(let u=0,c=i.length;u<c;u++){const l=i[u];a[4*u]=l.start.line+1,a[4*u+1]=l.start.character+1,a[4*u+2]=l.end.line+1,a[4*u+3]=l.end.character+1}return D.$trySetDecorationsFast(y,b.key,a)}}))},revealRange(b,i){p.n(()=>D.$tryRevealRange(y,R.Range.from(b),i||I.TextEditorRevealType.Default))},show(b){D.$tryShowEditor(y,R.ViewColumn.from(b))},hide(){D.$tryHideEditor(y)}})}dispose(){(0,o.ok)(!this.g),this.g=!0}_acceptOptions(y){(0,o.ok)(!this.g),this.d._accept(y)}_acceptVisibleRanges(y){(0,o.ok)(!this.g),this.e=y}_acceptViewColumn(y){(0,o.ok)(!this.g),this.f=y}_acceptSelections(y){(0,o.ok)(!this.g),this.c=y}async l(){const y=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,y)),this.value}m(y){const D=y.finalize();if(D.edits.length===0&&!D.setEndOfLine)return Promise.resolve(!0);const v=D.edits.map(m=>m.range);v.sort((m,h)=>m.end.line===h.end.line?m.end.character===h.end.character?m.start.line===h.start.line?m.start.character-h.start.character:m.start.line-h.start.line:m.end.character-h.end.character:m.end.line-h.end.line);for(let m=0,h=v.length-1;m<h;m++){const w=v[m].end;if(v[m+1].start.isBefore(w))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=D.edits.map(m=>({range:R.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,D.documentVersionId,d,{setEndOfLine:typeof D.setEndOfLine=="number"?R.EndOfLine.from(D.setEndOfLine):void 0,undoStopBefore:D.undoStopBefore,undoStopAfter:D.undoStopAfter})}n(y){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):y().then(()=>this,D=>(D instanceof Error&&D.name==="DISPOSED"||this.k.warn(D),null))}}e.ExtHostTextEditor=L}),define(ye[236],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ye[237],Ce([1,0,189,10,43,122,126,44,26,236,201,191]),function(ne,e,o,t,k,R,I,A,S,C,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const y=A.Registry.as(I.Extensions.JSONContribution);class D{constructor(b,i,s){this.a=b,this.b=i,this.c=s}d(b,i){this.a({type:b,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(b){this.d(k.default.Error,b)}warn(b){this.d(k.default.Warning,b)}info(b){this.d(k.default.Info,b)}}e.ExtensionMessageCollector=D;class v{static a(b){const i=new Set;for(let s=0,a=b.length;s<a;s++)i.add(S.ExtensionIdentifier.toKey(b[s].description.identifier));return i}static compute(b,i){if(!b||!b.length)return new v(i,[]);if(!i||!i.length)return new v([],b);const s=this.a(b),a=this.a(i),u=i.filter(l=>!s.has(S.ExtensionIdentifier.toKey(l.description.identifier))),c=b.filter(l=>!a.has(S.ExtensionIdentifier.toKey(l.description.identifier)));return new v(u,c)}constructor(b,i){this.added=b,this.removed=i}}e.ExtensionPointUserDelta=v;class d{constructor(b,i){this.name=b,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(b){if(this.a!==null)throw new Error("Handler already set!");this.a=b,this.d()}acceptUsers(b){this.c=v.compute(this.b,b),this.b=b,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(b){(0,t.onUnexpectedError)(b)}}}e.ExtensionPoint=d;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[o.localize(0,null),o.localize(1,null)]},h="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:o.localize(2,null),properties:{vscode:{type:"string",description:o.localize(3,null),default:"^1.22.0"}}},publisher:{description:o.localize(4,null),type:"string"},displayName:{description:o.localize(5,null),type:"string"},categories:{description:o.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:o.localize(7,null)}]}},galleryBanner:{type:"object",description:o.localize(8,null),properties:{color:{description:o.localize(9,null),type:"string"},theme:{description:o.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:o.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:o.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:o.localize(13,null)},enabledApiProposals:{markdownDescription:o.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(C.allApiProposals),markdownEnumDescriptions:Object.values(C.allApiProposals)}},api:{markdownDescription:o.localize(15,null),type:"string",enum:["none"],enumDescriptions:[o.localize(16,null)]},activationEvents:{description:o.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:o.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:o.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:o.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:o.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:o.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:o.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:o.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:o.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:o.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:o.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:o.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:o.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:o.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:o.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:o.localize(32,null)},{label:"onUri",body:"onUri",description:o.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:o.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:o.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:o.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:o.localize(37,null)},{label:"onRenderer",description:o.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:o.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:o.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:o.localize(41,null)},{label:"*",description:o.localize(42,null),body:"*"}]}},badges:{type:"array",description:o.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:o.localize(44,null)},href:{type:"string",description:o.localize(45,null)},description:{type:"string",description:o.localize(46,null)}}}},markdown:{type:"string",description:o.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:o.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:o.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:o.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:o.localize(51,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:o.localize(52,null)},{body:["workspace"],description:o.localize(53,null)},{body:["ui","workspace"],description:o.localize(54,null)},{body:["workspace","ui"],description:o.localize(55,null)},{body:[],description:o.localize(56,null)}]},capabilities:{description:o.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:o.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:o.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[o.localize(60,null),o.localize(61,null),o.localize(62,null)]},description:{type:"string",markdownDescription:o.localize(63,null)}}},untrustedWorkspaces:{description:o.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:o.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[o.localize(66,null),o.localize(67,null),o.localize(68,null)]},restrictedConfigurations:{description:o.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:o.localize(70,null)}}}}},sponsor:{description:o.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:o.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:o.localize(73,null),type:"string"},"vscode:uninstall":{description:o.localize(74,null),type:"string"}}},icon:{type:"string",description:o.localize(75,null)},l10n:{type:"string",description:o.localize(76,null)}}};class w{constructor(){this.a=new Map}registerExtensionPoint(b){if(this.a.has(b.extensionPoint))throw new Error("Duplicate extension point: "+b.extensionPoint);const i=new d(b.extensionPoint,b.defaultExtensionKind);return this.a.set(b.extensionPoint,i),b.activationEventsGenerator&&P.ImplicitActivationEvents.register(b.extensionPoint,b.activationEventsGenerator),e.schema.properties.contributes.properties[b.extensionPoint]=b.jsonSchema,y.registerSchema(h,e.schema),i}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=w;const g={ExtensionsRegistry:"ExtensionsRegistry"};A.Registry.add(g.ExtensionsRegistry,new w),e.ExtensionsRegistry=A.Registry.as(g.ExtensionsRegistry),y.registerSchema(h,e.schema),y.registerSchema(L.productSchemaId,{properties:{extensionEnabledApiProposals:{description:o.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(C.allApiProposals),markdownEnumDescriptions:Object.values(C.allApiProposals)}}]}}}})}),define(ye[238],Ce([1,0,186,11,23,237,53,4]),function(ne,e,o,t,k,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:o.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:o.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:o.localize(2,null),default:""}}};var C;(function(y){function D(v,d,m){if(!v)return;const h=t.isString(v.type)?v.type:void 0;if(!h||h.length===0){m.error(o.localize(3,null));return}const w=[];if(Array.isArray(v.required))for(const g of v.required)t.isString(g)&&w.push(g);return{extensionId:d.value,taskType:h,required:w,properties:v.properties?k.deepClone(v.properties):{},when:v.when?I.ContextKeyExpr.deserialize(v.when):void 0}}y.from=D})(C||(C={}));const L=R.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:o.localize(4,null),type:"array",items:S}});class P{constructor(){this.d=new A.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((D,v)=>{L.setHandler((d,m)=>{this.c=void 0;try{for(const h of m.removed){const w=h.value;for(const g of w)this.a&&g.type&&this.a[g.type]&&delete this.a[g.type]}for(const h of m.added){const w=h.value;for(const g of w){const p=C.from(g,h.description.identifier,h.collector);p&&(this.a[p.taskType]=p)}}(m.removed.length>0||m.added.length>0)&&this.d.fire()}catch{}D(void 0)})})}onReady(){return this.b}get(D){return this.a[D]}all(){return Object.keys(this.a).map(D=>this.a[D])}getJsonSchema(){if(this.c===void 0){const D=[];for(const v of this.all()){const d={type:"object",additionalProperties:!1};v.required.length>0&&(d.required=v.required.slice(0)),v.properties!==void 0?d.properties=k.deepClone(v.properties):d.properties=Object.create(null),d.properties.type={type:"string",enum:[v.taskType]},D.push(d)}this.c={oneOf:D}}return this.c}}e.TaskDefinitionRegistry=new P}),define(ye[239],Ce([1,0,187,11,24,23,53,238]),function(ne,e,o,t,k,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new I.RawContextKey("taskRunning",!1,o.localize(0,null)),e.TASKS_CATEGORY={value:o.localize(1,null),original:"Tasks"};var S;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(S=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(F){function z(B){if(!B)return F.Strong;switch(B.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=z}(S=e.ShellQuoting||(e.ShellQuoting={}));var C;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(C=e.CommandOptions||(e.CommandOptions={}));var L;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(L=e.RevealKind||(e.RevealKind={})),function(F){function z(B){switch(B.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=z}(L=e.RevealKind||(e.RevealKind={}));var P;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(P=e.RevealProblemKind||(e.RevealProblemKind={})),function(F){function z(B){switch(B.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=z}(P=e.RevealProblemKind||(e.RevealProblemKind={}));var y;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(y=e.PanelKind||(e.PanelKind={})),function(F){function z(B){switch(B.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=z}(y=e.PanelKind||(e.PanelKind={}));var D;(function(F){F.defaults={echo:!0,reveal:L.Always,revealProblems:P.Never,focus:!1,panel:y.Shared,showReuseMessage:!0,clear:!1}})(D=e.PresentationOptions||(e.PresentationOptions={}));var v;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(v=e.RuntimeType||(e.RuntimeType={})),function(F){function z(W){switch(W.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=z;function B(W){switch(W){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=B}(v=e.RuntimeType||(e.RuntimeType={}));var d;(function(F){function z(B){return t.isString(B)?B:B.value}F.value=z})(d=e.CommandString||(e.CommandString={}));var m;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function z(W){return W===F.Clean._id||W===F.Build._id||W===F.Rebuild._id||W===F.Test._id}F.is=z;function B(W){if(W!==void 0)return t.isString(W)?z(W)?{_id:W,isDefault:!1}:void 0:W}F.from=B})(m=e.TaskGroup||(e.TaskGroup={}));var h;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(h=e.TaskScope||(e.TaskScope={}));var w;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function z(B){switch(B){case F.User:return 2;case F.WorkspaceFile:return 5;default:return 6}}F.toConfigurationTarget=z})(w=e.TaskSourceKind||(e.TaskSourceKind={}));var g;(function(F){F.parallel="parallel",F.sequence="sequence"})(g=e.DependsOrder||(e.DependsOrder={}));var p;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(p=e.RunOnOptions||(e.RunOnOptions={}));var b;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:p.default,instanceLimit:1}})(b=e.RunOptions||(e.RunOptions={}));class i{constructor(z,B,W,X,q,_){this._label="",this._id=z,B&&(this._label=B),W&&(this.type=W),this.runOptions=X,this.configurationProperties=q,this._source=_}getDefinition(z){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const z={folder:this.d(),id:this._id};return JSON.stringify(z)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(z,B=!1){if(z===void 0)return!1;if(t.isString(z))return z===this._label||z===this.configurationProperties.identifier||B&&z===this._id;const W=this.getDefinition(!0);return W!==void 0&&W._key===z._key}getQualifiedLabel(){const z=this.getWorkspaceFolder();return z?`${this._label} (${z.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(z){this.c===void 0&&(this.c=[]),z&&(this.c=this.c.concat(z))}get taskLoadMessages(){return this.c}}e.CommonTask=i;class s extends i{constructor(z,B,W,X,q,_,Q,Z){super(z,W,void 0,Q,Z,B),this.command={},this._source=B,this.hasDefinedMatchers=_,q&&(this.command=q)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(z=!1){if(z&&this._source.customizes!==void 0)return this._source.customizes;{let B;switch(this.command?this.command.runtime:void 0){case v.Shell:B="shell";break;case v.Process:B="process";break;case v.CustomExecution:B="customExecution";break;case void 0:B="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:B,_key:this._id,id:this._id}}}static is(z){return z instanceof s}getMapKey(){const z=this._source.config.workspaceFolder;return z?`${z.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===w.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const z=this.d();if(!z)return;let B=this.configurationProperties.identifier;this._source.kind!==w.Workspace&&(B+=this._source.kind);const W={type:e.CUSTOMIZED_TASK_TYPE,folder:z,id:B};return JSON.stringify(W)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?k.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(z){return new s(z._id,z._source,z._label,z.type,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.CustomTask=s;class a extends i{constructor(z,B,W,X,q,_,Q){super(z,W,X,_,Q,B),this._source=B,this.configures=q}static is(z){return z instanceof a}f(z){return z}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?k.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===w.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const z=this.d();if(!z)return;let B=this.configurationProperties.identifier;this._source.kind!==w.Workspace&&(B+=this._source.kind);const W={type:e.CUSTOMIZED_TASK_TYPE,folder:z,id:B};return JSON.stringify(W)}}e.ConfiguringTask=a;class u extends i{constructor(z,B,W,X,q,_,Q,Z,ge){super(z,W,X,Z,ge,B),this.defines=q,this.hasDefinedMatchers=Q,this.command=_,this.icon=ge.icon,this.hide=ge.hide}clone(){return new u(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(z){return z instanceof u}getMapKey(){const z=this._source.workspaceFolder;return z?`${this._source.scope.toString()}|${z.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const z={type:"contributed",scope:this._source.scope,id:this._id};return z.folder=this.d(),JSON.stringify(z)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(z){return new u(z._id,z._source,z._label,z.type,z.defines,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.ContributedTask=u;class c extends i{constructor(z,B,W,X,q,_){super(z,W,X,q,_,B),this._source=B}clone(){return new c(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(z){return z instanceof c}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(z){return new c(z._id,z._source,z._label,z.type,z.runOptions,z.configurationProperties)}}e.InMemoryTask=c;var l;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(l=e.ExecutionEngine||(e.ExecutionEngine={})),function(F){F._default=F.Terminal}(l=e.ExecutionEngine||(e.ExecutionEngine={}));var n;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(n=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class r{constructor(z){this.c=new Map;for(let B=0;B<z.length;B++)this.c.set(z[B].uri.toString(),B)}compare(z,B){const W=z.getWorkspaceFolder(),X=B.getWorkspaceFolder();if(W&&X){let q=this.c.get(W.uri.toString());q=q===void 0?0:q+1;let _=this.c.get(X.uri.toString());return _=_===void 0?0:_+1,q===_?z._label.localeCompare(B._label):q-_}else return!W&&X?-1:W&&!X?1:0}}e.TaskSorter=r;var f;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(f=e.TaskEventKind||(e.TaskEventKind={}));var E;(function(F){F.SingleRun="singleRun",F.Background="background"})(E=e.TaskRunType||(e.TaskRunType={}));var T;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(T=e.TaskRunSource||(e.TaskRunSource={}));var M;(function(F){function z(B,W,X,q){if(W){const _={kind:B,taskId:W._id,taskName:W.configurationProperties.name,runType:W.configurationProperties.isBackground?"background":"singleRun",group:W.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:X,__task:W};return B==="start"?_.resolvedVariables=q:B==="processStarted"?_.processId=q:B==="processEnded"&&(_.exitCode=q),Object.freeze(_)}else return Object.freeze({kind:"changed"})}F.create=z})(M=e.TaskEvent||(e.TaskEvent={}));var G;(function(F){function z(W){const X=Object.keys(W).sort();let q="";for(const _ of X){let Q=W[_];Q instanceof Object?Q=z(Q):typeof Q=="string"&&(Q=Q.replace(/,/g,",,")),q+=_+","+Q+","}return q}function B(W){const q={_key:z(W),type:W.taskType};return Object.assign(q,W),q}F.create=B})(G=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var V;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection"})(V=e.TaskSettingId||(e.TaskSettingId={}));var N;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(N=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var U;(function(F){function z(B,W){const X=A.TaskDefinitionRegistry.get(B.type);if(X===void 0){const Z=R.deepClone(B);return delete Z._key,G.create(Z)}const q=Object.create(null);q.type=X.taskType;const _=new Set;X.required.forEach(Z=>_.add(Z));const Q=X.properties;for(const Z of Object.keys(Q)){const ge=B[Z];if(ge!=null)q[Z]=ge;else if(_.has(Z)){const te=Q[Z];if(te.default!==void 0)q[Z]=R.deepClone(te.default);else switch(te.type){case"boolean":q[Z]=!1;break;case"number":case"integer":q[Z]=0;break;case"string":q[Z]="";break;default:W.error(o.localize(2,null,JSON.stringify(B,void 0,0),Z));return}}}return G.create(q)}F.createTaskIdentifier=z})(U=e.TaskDefinition||(e.TaskDefinition={}))}),define(ye[240],Ce([1,0,10]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class t{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((I,A)=>{this.b=I,this.d=A,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(I){this.f||this.h||(this.f=!0,this.g=I,this.a&&this.b(I))}resolveErr(I){this.f||this.h||(this.h=!0,this.i=I,this.a?this.d(I):(0,o.onUnexpectedError)(I))}then(I,A){return this.j().then(I,A)}catch(I){return this.j().then(void 0,I)}finally(I){return this.j().finally(I)}}e.LazyPromise=t;class k extends t{constructor(){super(),this.h=!0,this.i=new o.CancellationError}}e.CanceledLazyPromise=k}),define(ye[57],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class o{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++o.count}}e.ProxyIdentifier=o,o.count=0;const t=[];function k(A){const S=new o(A);return t[S.nid]=S,S}e.createProxyIdentifier=k;function R(A){return t[A].sid}e.getStringIdentifierForProxy=R;class I{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=I}),define(ye[5],Ce([1,0,57]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var t;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(d){d[d.UnknownInput=0]="UnknownInput",d[d.TextInput=1]="TextInput",d[d.TextDiffInput=2]="TextDiffInput",d[d.TextMergeInput=3]="TextMergeInput",d[d.NotebookInput=4]="NotebookInput",d[d.NotebookDiffInput=5]="NotebookDiffInput",d[d.CustomEditorInput=6]="CustomEditorInput",d[d.WebviewEditorInput=7]="WebviewEditorInput",d[d.TerminalEditorInput=8]="TerminalEditorInput",d[d.InteractiveEditorInput=9]="InteractiveEditorInput"})(k=e.TabInputKind||(e.TabInputKind={}));var R;(function(d){d[d.TAB_OPEN=0]="TAB_OPEN",d[d.TAB_CLOSE=1]="TAB_CLOSE",d[d.TAB_UPDATE=2]="TAB_UPDATE",d[d.TAB_MOVE=3]="TAB_MOVE"})(R=e.TabModelOperationKind||(e.TabModelOperationKind={}));var I;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(I=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var A;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(A=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var S;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(S=e.CellOutputKind||(e.CellOutputKind={}));var C;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(C=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var L;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(L=e.CandidatePortSource||(e.CandidatePortSource={}));class P{static mixin(m){return m._id=P.a++,m}}e.IdObject=P,P.a=0;var y;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.kindModifier="m",d.commandIdent="n",d.commandId="o",d.commandArguments="p"})(y=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var D;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(D=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var v;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(v=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,o.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,o.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,o.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,o.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,o.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,o.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,o.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,o.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,o.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,o.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,o.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,o.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,o.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,o.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,o.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,o.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,o.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,o.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,o.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,o.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,o.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,o.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,o.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,o.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,o.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,o.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,o.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,o.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,o.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,o.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,o.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,o.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,o.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,o.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,o.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,o.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,o.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,o.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,o.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,o.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,o.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,o.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,o.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,o.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,o.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,o.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,o.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,o.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,o.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,o.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,o.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,o.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,o.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,o.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,o.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,o.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,o.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,o.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,o.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,o.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,o.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,o.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,o.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,o.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,o.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,o.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,o.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,o.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,o.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,o.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,o.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,o.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,o.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,o.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,o.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,o.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,o.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,o.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,o.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,o.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,o.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,o.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,o.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,o.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,o.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,o.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,o.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,o.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,o.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,o.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,o.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,o.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,o.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,o.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,o.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,o.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,o.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,o.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,o.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,o.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,o.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,o.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,o.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,o.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,o.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,o.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,o.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,o.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,o.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,o.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,o.createProxyIdentifier)("ExtHostLocalization")}}),define(ye[71],Ce([1,0,3,13,5,17]),function(ne,e,o,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,o.createDecorator)("IExtHostApiDeprecationService");let I=class{constructor(S,C){this.c=C,this.a=new Set,this.b=S.getProxy(k.MainContext.MainThreadTelemetry)}report(S,C,L){const P=this.d(S,C);this.a.has(P)||(this.a.add(P),C.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${S}' is deprecated. ${L}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:C.identifier.value,apiId:S}))}d(S,C){return`${S}-${C.identifier.value}`}};I=qe([He(0,R.IExtHostRpcService),He(1,t.ILogService)],I),e.ExtHostApiDeprecationService=I,e.NullApiDeprecationService=Object.freeze(new class{report(A,S,C){}})}),define(ye[241],Ce([1,0,4,5,7,26]),function(ne,e,o,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class I{constructor(S){this.b=new Map,this.c=[],this.d=new o.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=S.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(S){return this.c=S,Promise.resolve()}async getSession(S,C,L,P={}){const y=R.ExtensionIdentifier.toKey(S.identifier),D=this.f.get(y)||[],v=[...L].sort().join(" ");let d=D.find(m=>m.providerId===C&&m.scopes===v);if(d)return d.result;{const m=this.g(S,y,C,L,P);d={providerId:C,scopes:v,result:m},D.push(d),this.f.set(y,D);try{await m}finally{const h=D.findIndex(w=>w.providerId===C&&w.scopes===v);h>-1&&(D.splice(h),this.f.set(y,D))}return m}}async g(S,C,L,P,y={}){await this.a.$ensureProvider(L);const D=S.displayName||S.name;return this.a.$getSession(L,P,C,D,y)}async removeSession(S,C){const L=this.b.get(S);return L?L.provider.removeSession(C):this.a.$removeSession(S,C)}registerAuthenticationProvider(S,C,L,P){if(this.b.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this.b.set(S,{label:C,provider:L,options:P??{supportsMultipleAccounts:!1}}),this.c.find(D=>D.id===S)||this.c.push({id:S,label:C});const y=L.onDidChangeSessions(D=>{this.a.$sendDidChangeSessions(S,{added:D.added??[],changed:D.changed??[],removed:D.removed??[]})});return this.a.$registerAuthenticationProvider(S,C,P?.supportsMultipleAccounts??!1),new k.Disposable(()=>{y.dispose(),this.b.delete(S);const D=this.c.findIndex(v=>v.id===S);D>-1&&this.c.splice(D),this.a.$unregisterAuthenticationProvider(S)})}$createSession(S,C){const L=this.b.get(S);if(L)return Promise.resolve(L.provider.createSession(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,C){const L=this.b.get(S);if(L)return Promise.resolve(L.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,C){const L=this.b.get(S);if(L)return Promise.resolve(L.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,C){return this.d.fire({provider:{id:S,label:C}}),Promise.resolve()}}e.ExtHostAuthentication=I}),define(ye[242],Ce([1,0,5,17,14]),function(ne,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let R=class{constructor(A,S){this.a=A.getProxy(o.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:C=>S.getDocument(C)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(A,S,C){const L=k.WorkspaceEdit.from(A,this.b);return this.a.$tryApplyWorkspaceEdit(L,void 0,C?.isRefactoring??!1)}};R=qe([He(0,t.IExtHostRpcService)],R),e.ExtHostBulkEdits=R}),define(ye[243],Ce([1,0,5]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(R){const I=R.getProxy(o.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return I.$readText()},writeText(A){return I.$writeText(A)}})}}e.ExtHostClipboard=t});var Je=this&&this.__classPrivateFieldSet||function(ne,e,o,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ne,o):k?k.value=o:e.set(ne,o),o},Ue=this&&this.__classPrivateFieldGet||function(ne,e,o,t){if(o==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?t:o==="a"?t.call(ne):t?t.value:e.get(ne)};define(ye[39],Ce([1,0,11,7,14,23,5,18,13,86,35,50,2,6,3,17,137,22,57,51,42,68]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y,D,v,d,m,h,w,g,p,b){"use strict";var i,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let a=class{constructor(f,E){i.set(this,void 0),this.b=new Map,this.c=new Map,s.set(this,void 0),Je(this,i,f.getProxy(I.MainContext.MainThreadCommands),"f"),this.d=E,Je(this,s,f.getProxy(I.MainContext.MainThreadTelemetry),"f"),this.converter=new u(this,T=>{const M=this.c.get(T);return M?.result===l.Void?M:void 0},E),this.f=[{processArgument(T){return(0,C.revive)(T)}},{processArgument(T){return(0,R.cloneAndChange)(T,function(M){if(L.Range.isIRange(M))return k.Range.to(M);if(P.Position.isIPosition(M))return k.Position.to(M);if(L.Range.isIRange(M.range)&&y.URI.isUri(M.uri))return k.location.to(M);if(M instanceof h.VSBuffer)return M.buffer.buffer;if(!Array.isArray(M))return M})}}]}registerArgumentProcessor(f){this.f.push(f)}registerApiCommand(f){const E=this.registerCommand(!1,f.id,async(...T)=>{const M=f.args.map((V,N)=>{if(!V.validate(T[N]))throw new Error(`Invalid argument '${V.name}' when running '${f.id}', received: ${T[N]}`);return V.convert(T[N])}),G=await this.executeCommand(f.internalId,...M);return f.result.convert(G,T,this.converter)},void 0,{description:f.description,args:f.args,returns:f.result.description});return this.c.set(f.id,f),new t.Disposable(()=>{E.dispose(),this.c.delete(f.id)})}registerCommand(f,E,T,M,G,V){if(this.d.trace("ExtHostCommands#registerCommand",E),!E.trim().length)throw new Error("invalid id");if(this.b.has(E))throw new Error(`command '${E}' already exists`);return this.b.set(E,{callback:T,thisArg:M,description:G,extension:V}),f&&Ue(this,i,"f").$registerCommand(E),new t.Disposable(()=>{this.b.delete(E)&&f&&Ue(this,i,"f").$unregisterCommand(E)})}executeCommand(f,...E){return this.d.trace("ExtHostCommands#executeCommand",f),this.g(f,E,!0)}async g(f,E,T){if(this.b.has(f))return Ue(this,i,"f").$fireCommandActivationEvent(f),this.h(f,E,!1);{let M=!1;const G=(0,R.cloneAndChange)(E,function(V){if(V instanceof t.Position)return k.Position.from(V);if(V instanceof t.Range)return k.Range.from(V);if(V instanceof t.Location)return k.location.from(V);if(t.NotebookRange.isNotebookRange(V))return k.NotebookRange.from(V);if(V instanceof ArrayBuffer)return M=!0,h.VSBuffer.wrap(new Uint8Array(V));if(V instanceof Uint8Array)return M=!0,h.VSBuffer.wrap(V);if(V instanceof h.VSBuffer)return M=!0,V;if(!Array.isArray(V))return V});try{const V=await Ue(this,i,"f").$executeCommand(f,M?new w.SerializableObjectWithBuffers(G):G,T);return(0,C.revive)(V)}catch(V){if(V instanceof Error&&V.message==="$executeCommand:retry")return this.g(f,E,!1);throw V}}}async h(f,E,T){const M=this.b.get(f);if(!M)throw new Error("Unknown command");const{callback:G,thisArg:V,description:N}=M;if(N)for(let F=0;F<N.args.length;F++)try{(0,o.validateConstraint)(E[F],N.args[F].constraint)}catch{throw new Error(`Running the contributed command: '${f}' failed. Illegal argument '${N.args[F].name}' - ${N.args[F].description}`)}const U=p.StopWatch.create();try{return await G.apply(V,E)}catch(F){if(f===this.converter.delegatingCommandId){const z=this.converter.getActualCommand(...E);z&&(f=z.command)}throw this.d.error(F,f,M.extension?.identifier),T?new class extends Error{constructor(){super((0,g.toErrorMessage)(F)),this.id=f,this.source=M.extension?.displayName??M.extension?.name}}:F}finally{this.j(M,f,U.elapsed())}}j(f,E,T){!f.extension||Ue(this,s,"f").$publicLog2("Extension:ActionExecuted",{extensionId:f.extension.identifier.value,id:new b.TrustedTelemetryValue(E),duration:T})}$executeContributedCommand(f,...E){this.d.trace("ExtHostCommands#$executeContributedCommand",f);const T=this.b.get(f);return T?(E=E.map(M=>this.f.reduce((G,V)=>V.processArgument(G,T.extension?.identifier),M)),this.h(f,E,!0)):Promise.reject(new Error(`Contributed command '${f}' does not exist.`))}getCommands(f=!1){return this.d.trace("ExtHostCommands#getCommands",f),Ue(this,i,"f").$getCommands().then(E=>(f&&(E=E.filter(T=>T[0]!=="_")),E))}$getContributedCommandHandlerDescriptions(){const f=Object.create(null);for(const[E,T]of this.b){const{description:M}=T;M&&(f[E]=M)}return Promise.resolve(f)}};i=new WeakMap,s=new WeakMap,a=qe([He(0,d.IExtHostRpcService),He(1,S.ILogService)],a),e.ExtHostCommands=a,e.IExtHostCommands=(0,v.createDecorator)("IExtHostCommands");class u{constructor(f,E,T){this.d=f,this.f=E,this.g=T,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(f,E){if(!f)return;const T={$ident:void 0,id:f.command,title:f.title,tooltip:f.tooltip};if(!f.command)return T;const M=this.f(f.command);if(M)T.id=M.internalId,T.arguments=M.args.map((G,V)=>G.convert(f.arguments&&f.arguments[V]));else if((0,A.isNonEmptyArray)(f.arguments)){const G=`${f.command}/${++this.c}`;this.b.set(G,f),E.add((0,D.toDisposable)(()=>{this.b.delete(G),this.g.trace("CommandsConverter#DISPOSE",G)})),T.$ident=G,T.id=this.delegatingCommandId,T.arguments=[G],this.g.trace("CommandsConverter#CREATE",f.command,G)}return T}fromInternal(f){return typeof f.$ident=="string"?this.b.get(f.$ident):{command:f.id,title:f.title,arguments:f.arguments}}getActualCommand(...f){return this.b.get(f[0])}h(...f){const E=this.getActualCommand(...f);return this.g.trace("CommandsConverter#EXECUTE",f[0],E?E.command:"MISSING"),E?this.d.executeCommand(E.command,...E.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${f[0]}`)}}e.CommandsConverter=u;class c{constructor(f,E,T,M){this.name=f,this.description=E,this.validate=T,this.convert=M}optional(){return new c(this.name,`(optional) ${this.description}`,f=>f==null||this.validate(f),f=>f===void 0?void 0:f===null?null:this.convert(f))}with(f,E){return new c(f??this.name,E??this.description,this.validate,this.convert)}}e.ApiCommandArgument=c,c.Uri=new c("uri","Uri of a text document",r=>y.URI.isUri(r),r=>r),c.Position=new c("position","A position in a text document",r=>t.Position.isPosition(r),k.Position.from),c.Range=new c("range","A range in a text document",r=>t.Range.isRange(r),k.Range.from),c.Selection=new c("selection","A selection in a text document",r=>t.Selection.isSelection(r),k.Selection.from),c.Number=new c("number","",r=>typeof r=="number",r=>r),c.String=new c("string","",r=>typeof r=="string",r=>r),c.CallHierarchyItem=new c("item","A call hierarchy item",r=>r instanceof t.CallHierarchyItem,k.CallHierarchyItem.from),c.TypeHierarchyItem=new c("item","A type hierarchy item",r=>r instanceof t.TypeHierarchyItem,k.TypeHierarchyItem.from),c.TestItem=new c("testItem","A VS Code TestItem",r=>r instanceof m.TestItemImpl,k.TestItem.from);class l{constructor(f,E){this.description=f,this.convert=E}}e.ApiCommandResult=l,l.Void=new l("no result",r=>r);class n{constructor(f,E,T,M,G){this.id=f,this.internalId=E,this.description=T,this.args=M,this.result=G}}e.ApiCommand=n}),define(ye[244],Ce([1,0,2,14,7,66,39,18,119,124,15]),function(ne,e,o,t,k,R,I,A,S,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const P=[new I.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",D(t.DocumentHighlight.to))),new I.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(d,m)=>{if((0,A.isFalsyOrEmpty)(d))return;class h extends k.SymbolInformation{static to(g){const p=new h(g.name,t.SymbolKind.to(g.kind),g.containerName||"",new k.Location(m[0],t.Range.to(g.range)));return p.detail=g.detail,p.range=p.location.range,p.selectionRange=t.Range.to(g.selectionRange),p.children=g.children?g.children.map(h.to):[],p}}return d.map(h.to)})),new I.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",D(t.TextEdit.to))),new I.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range,new I.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",D(t.TextEdit.to))),new I.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,new I.ApiCommandArgument("ch","Trigger character",d=>typeof d=="string",d=>d),new I.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",D(t.TextEdit.to))),new I.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new I.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new I.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new I.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new I.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location-instances.",D(t.location.to))),new I.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Hover-instances.",D(t.Hover.to))),new I.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("position","A position in a text document",d=>Array.isArray(d)&&d.every(m=>k.Position.isPosition(m)),d=>d.map(t.Position.from))],new I.ApiCommandResult("A promise that resolves to an array of ranges.",d=>d.map(m=>{let h;for(const w of m.reverse())h=new k.SelectionRange(t.Range.to(w),h);return h}))),new I.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[I.ApiCommandArgument.String.with("query","Search string")],new I.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",d=>d.map(t.WorkspaceSymbol.to))),new I.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",d=>d.map(t.CallHierarchyItem.to))),new I.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[I.ApiCommandArgument.CallHierarchyItem],new I.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",d=>d.map(t.CallHierarchyIncomingCall.to))),new I.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[I.ApiCommandArgument.CallHierarchyItem],new I.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",d=>d.map(t.CallHierarchyOutgoingCall.to))),new I.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to a range and placeholder text.",d=>{if(!!d)return{range:t.Range.to(d.range),placeholder:d.text}})),new I.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("newName","The new symbol name")],new I.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",d=>{if(!!d){if(d.rejectReason)throw new Error(d.rejectReason);return t.WorkspaceEdit.to(d)}})),new I.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new I.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",d=>d.map(t.DocumentLink.to))),new I.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(!!d)return new k.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new I.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const m=(0,S.decodeSemanticTokensDto)(d);if(m.type==="full")return new k.SemanticTokens(m.data,void 0)})),new I.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range.optional()],new I.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(!!d)return new k.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new I.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const m=(0,S.decodeSemanticTokensDto)(d);if(m.type==="full")return new k.SemanticTokens(m.data,void 0)})),new I.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),I.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new I.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(d,m,h)=>{if(!d)return new k.CompletionList([]);const w=d.suggestions.map(g=>t.CompletionItem.to(g,h));return new k.CompletionList(w,d.incomplete)})),new I.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new I.ApiCommandResult("A promise that resolves to SignatureHelp.",d=>{if(d)return t.SignatureHelp.to(d)})),new I.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new I.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(d,m,h)=>D(w=>new k.CodeLens(t.Range.to(w.range),w.command&&h.fromInternal(w.command)))(d))),new I.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",d=>k.Range.isRange(d),d=>k.Selection.isSelection(d)?t.Selection.from(d):t.Range.from(d)),I.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),I.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new I.ApiCommandResult("A promise that resolves to an array of Command-instances.",(d,m,h)=>D(w=>{if(w._isSynthetic){if(!w.command)throw new Error("Synthetic code actions must have a command");return h.fromInternal(w.command)}else{const g=new k.CodeAction(w.title,w.kind?new k.CodeActionKind(w.kind):void 0);return w.edit&&(g.edit=t.WorkspaceEdit.to(w.edit)),w.command&&(g.command=h.fromInternal(w.command)),g.isPreferred=w.isPreferred,g}})(d))),new I.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",d=>d?d.map(m=>new k.ColorInformation(t.Range.to(m.range),t.Color.to(m.color))):[])),new I.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new I.ApiCommandArgument("color","The color to show and insert",d=>d instanceof k.Color,t.Color.from),new I.ApiCommandArgument("context","Context object with uri and range",d=>!0,d=>({uri:d.uri,range:t.Range.from(d.range)}))],new I.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",d=>d?d.map(t.ColorPresentation.to):[])),new I.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to an array of Inlay objects",(d,m,h)=>d.map(t.InlayHint.to.bind(void 0,h)))),new I.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new I.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",D(d=>({viewType:d.viewType,displayName:d.displayName,options:{transientOutputs:d.options.transientOutputs,transientCellMetadata:d.options.transientCellMetadata,transientDocumentMetadata:d.options.transientDocumentMetadata},filenamePattern:d.filenamePattern.map(m=>t.NotebookExclusiveDocumentPattern.to(m))})))),new I.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to an array of InlineValue objects",d=>d.map(t.InlineValue.to))),new I.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new I.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",d=>o.URI.isUri(d)||typeof d=="string"&&(0,C.matchesSomeScheme)(d,L.Schemas.http,L.Schemas.https),d=>d),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[t.ViewColumn.from(d),void 0]:[t.ViewColumn.from(d.viewColumn),t.TextEditorOpenOptions.from(d)])).optional(),I.ApiCommandArgument.String.with("label","").optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[I.ApiCommandArgument.Uri.with("resource","Resource to open"),I.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[t.ViewColumn.from(d),void 0]:[t.ViewColumn.from(d.viewColumn),t.TextEditorOpenOptions.from(d)])).optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[I.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),I.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),I.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="object",d=>d&&[t.ViewColumn.from(d.viewColumn),t.TextEditorOpenOptions.from(d)]).optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",d=>d.map(t.TypeHierarchyItem.to))),new I.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[I.ApiCommandArgument.TypeHierarchyItem],new I.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",d=>d.map(t.TypeHierarchyItem.to))),new I.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[I.ApiCommandArgument.TypeHierarchyItem],new I.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",d=>d.map(t.TypeHierarchyItem.to))),new I.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[I.ApiCommandArgument.TestItem],I.ApiCommandResult.Void),new I.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[I.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],I.ApiCommandResult.Void),new I.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[I.ApiCommandArgument.String.with("name","The context key name"),new I.ApiCommandArgument("value","The context key value",()=>!0,d=>d)],I.ApiCommandResult.Void)];class y{static register(m){P.forEach(m.registerApiCommand,m)}}e.ExtHostApiCommands=y;function D(d){return m=>{if(Array.isArray(m))return m.map(d)}}function v(d){if(!Array.isArray(d))return;const m=[];for(const h of d)R.isLocationLink(h)?m.push(t.DefinitionLink.to(h)):m.push(t.location.to(h));return m}}),define(ye[245],Ce([1,0,16,60,4,6,2,66,26,14,7,27,5]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function D(v,d,m){const h=v.getProxy(y.MainContext.MainThreadComments);class w{constructor(){this.b=new Map,this.c=new Map,d.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===6){const n=this.b.get(l.handle);return n?n.value:l}else if(l&&l.$mid===7){const n=this.b.get(l.commentControlHandle);if(!n)return l;const r=n.getCommentThread(l.commentThreadHandle);return r?r.value:l}else if(l&&(l.$mid===9||l.$mid===8)){const n=this.b.get(l.thread.commentControlHandle);if(!n)return l;const r=n.getCommentThread(l.thread.commentThreadHandle);return r?l.$mid===8?r.value:{thread:r.value,text:l.text}:l}else if(l&&l.$mid===10){const n=this.b.get(l.thread.commentControlHandle);if(!n)return l;const r=n.getCommentThread(l.thread.commentThreadHandle);if(!r)return l;const f=l.commentUniqueId,E=r.getCommentByUniqueId(f);return E||l}else if(l&&l.$mid===11){const n=this.b.get(l.thread.commentControlHandle);if(!n)return l;const r=n.getCommentThread(l.thread.commentThreadHandle);if(!r)return l;const f=l.text,E=l.commentUniqueId,T=r.getCommentByUniqueId(E);return T?(typeof T.body=="string"?T.body=f:T.body=new L.MarkdownString(f),T):l}return l}})}createCommentController(l,n,r){const f=w.a++,E=new p(l,f,n,r);this.b.set(E.handle,E);const T=this.c.get(S.ExtensionIdentifier.toKey(l.identifier))||[];return T.push(E),this.c.set(S.ExtensionIdentifier.toKey(l.identifier),T),E.value}$createCommentThreadTemplate(l,n,r){const f=this.b.get(l);!f||f.$createCommentThreadTemplate(n,r)}async $updateCommentThreadTemplate(l,n,r){const f=this.b.get(l);!f||f.$updateCommentThreadTemplate(n,r)}$deleteCommentThread(l,n){this.b.get(l)?.$deleteCommentThread(n)}$provideCommentingRanges(l,n,r){const f=this.b.get(l);if(!f||!f.commentingRangeProvider)return Promise.resolve(void 0);const E=m.getDocument(I.URI.revive(n));return(0,o.asPromise)(()=>f.commentingRangeProvider.provideCommentingRanges(E,r)).then(T=>T?T.map(M=>C.Range.from(M)):void 0)}$toggleReaction(l,n,r,f,E){const T=this.b.get(l);return!T||!T.reactionHandler?Promise.resolve(void 0):(0,o.asPromise)(()=>{const M=T.getCommentThread(n);if(M){const G=M.getCommentByUniqueId(f.uniqueIdInThread);if(T!==void 0&&G&&T.reactionHandler)return T.reactionHandler(G,s(E))}return Promise.resolve(void 0)})}dispose(){}}w.a=0;class g{set threadId(l){this.n=l}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(l){l.isEqual(this.p)||(this.p=l,this.b.range=l,this.c.fire())}get range(){return this.p}set canReply(l){this.d!==l&&(this.d=l,this.b.canReply=l,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(l){this.e=l,this.b.label=l,this.c.fire()}get contextValue(){return this.f}set contextValue(l){this.f=l,this.b.contextValue=l,this.c.fire()}get comments(){return this.q}set comments(l){this.q=l,this.b.comments=l,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(l){this.g=l,this.b.collapsibleState=l,this.c.fire()}get state(){return(0,P.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h}set state(l){(0,P.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h=l,this.b.state=l,this.c.fire()}get isDisposed(){return this.j}constructor(l,n,r,f,E,T,M,G){this.m=n,this.n=r,this.o=f,this.p=E,this.q=T,this.extensionDescription=M,this.r=G,this.handle=g.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new k.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.MutableDisposable,this.l.value=new R.DisposableStore,this.n===void 0&&(this.n=`${l}.${this.handle}`),h.$createCommentThread(n,this.handle,this.n,this.o,C.Range.from(this.p),M.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=T,this.i.push({dispose:()=>{h.$deleteCommentThread(n,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(N){V.range=N},get comments(){return V.comments},set comments(N){V.comments=N},get collapsibleState(){return V.collapsibleState},set collapsibleState(N){V.collapsibleState=N},get canReply(){return V.canReply},set canReply(N){V.canReply=N},get contextValue(){return V.contextValue},set contextValue(N){V.contextValue=N},get label(){return V.label},set label(N){V.label=N},get state(){return V.state},set state(N){V.state=N},dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.DisposableStore);const l=r=>Object.prototype.hasOwnProperty.call(this.b,r),n={};l("range")&&(n.range=C.Range.from(this.p)),l("label")&&(n.label=this.label),l("contextValue")&&(n.contextValue=this.contextValue??null),l("comments")&&(n.comments=this.q.map(r=>b(this,r,this.k))),l("collapsibleState")&&(n.collapseState=a(this.g)),l("canReply")&&(n.canReply=this.canReply),l("state")&&(n.state=u(this.h)),l("isTemplate")&&(n.isTemplate=this.r),this.b={},h.$updateCommentThread(this.m,this.handle,this.n,this.o,n)}getCommentByUniqueId(l){for(const n of this.k){const r=n[0],f=n[1];if(l===f)return r}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(l=>l.dispose())}}g.a=0,qe([(0,t.debounce)(100)],g.prototype,"eventuallyUpdateCommentThread",null);class p{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(l){this.b=l,h.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(l){this.c=l,h.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this.d}set options(l){this.d=l,h.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(l,n,r,f){this.f=l,this.g=n,this.h=r,this.i=f,this.a=new Map,h.$registerCommentController(this.handle,r,f);const E=this;this.value=Object.freeze({id:E.id,label:E.label,get options(){return E.options},set options(T){E.options=T},get commentingRangeProvider(){return E.commentingRangeProvider},set commentingRangeProvider(T){E.commentingRangeProvider=T},get reactionHandler(){return E.reactionHandler},set reactionHandler(T){E.reactionHandler=T},createCommentThread(T,M,G){return E.createCommentThread(T,M,G).value},dispose:()=>{E.dispose()}}),this.e=[],this.e.push({dispose:()=>{h.$unregisterCommentController(this.handle)}})}createCommentThread(l,n,r,f){if(typeof l=="string"){const E=new g(this.id,this.handle,l,n,r,f,this.f,!1);return this.a.set(E.handle,E),E}else{const E=new g(this.id,this.handle,void 0,l,n,r,this.f,!1);return this.a.set(E.handle,E),E}}$createCommentThreadTemplate(l,n){const r=new g(this.id,this.handle,void 0,I.URI.revive(l),C.Range.to(n),[],this.f,!0);return r.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this.a.set(r.handle,r),r}$updateCommentThreadTemplate(l,n){const r=this.a.get(l);r&&(r.range=C.Range.to(n))}$deleteCommentThread(l){this.a.get(l)?.dispose(),this.a.delete(l)}getCommentThread(l){return this.a.get(l)}dispose(){this.a.forEach(l=>{l.dispose()}),this.e.forEach(l=>l.dispose())}}function b(c,l,n){let r=n.get(l);r||(r=++c.commentHandle,n.set(l,r));const f=l.author&&l.author.iconPath?l.author.iconPath.toString():void 0;return{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:r,body:typeof l.body=="string"?l.body:C.MarkdownString.from(l.body),userName:l.author.name,userIconPath:f,label:l.label,commentReactions:l.reactions?l.reactions.map(E=>i(E)):void 0,timestamp:l.timestamp?.toJSON()}}function i(c){return{label:c.label,iconPath:c.iconPath?C.pathOrURIToURI(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function s(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?I.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function a(c){if(c!==void 0)switch(c){case L.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}function u(c){if(c!==void 0)switch(c){case L.CommentThreadState.Unresolved:return A.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return A.CommentThreadState.Resolved}return A.CommentThreadState.Unresolved}return new w}e.createExtHostComments=D}),define(ye[246],Ce([1,0,23,5,25,17]),function(ne,e,o,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let I=class{constructor(L,P){this.a=L.getProxy(t.MainContext.MainThreadConsole),this.b=P.consoleForward.includeStack,this.c=P.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(L,P){const y=this,D=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){y.e(L,P,D,arguments)}})}e(L,P,y,D){this.a.$logExtensionHostMessage({type:"__$console",severity:P,arguments:S(D,this.b)}),this.c&&this.f(L,y,D)}};I=qe([He(0,R.IExtHostRpcService),He(1,k.IExtHostInitDataService)],I),e.AbstractExtHostConsoleForwarder=I;const A=1e5;function S(C,L){const P=[];if(C.length)for(let y=0;y<C.length;y++){let D=C[y];if(typeof D>"u")D="undefined";else if(D instanceof Error){const v=D;v.stack?D=v.stack:D=v.toString()}P.push(D)}if(L){const y=new Error().stack;y&&P.push({__$stack:y.split(`
`).slice(3).join(`
`)})}try{const y=(0,o.safeStringify)(P);return y.length>A?"Output omitted for a large object that exceeds the limits":y}catch(y){return`Output omitted for an object that cannot be inspected ('${y.toString()}')`}}}),define(ye[139],Ce([1,0,2,5,7,3,17,13,18,8,9,27]),function(ne,e,o,t,k,R,I,A,S,C,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let y=class Fn{constructor(v,d){this.h=d,this.f=new Map,this.g=v.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(v,d){const m=Fn.c++;this.f.set(m,{provider:v,extensionDescription:d}),this.g.$registerDecorationProvider(m,d.identifier.value);const h=v.onDidChangeFileDecorations&&v.onDidChangeFileDecorations(w=>{if(!w){this.g.$onDidChange(m,null);return}const g=(0,S.asArray)(w);if(g.length<=Fn.d){this.g.$onDidChange(m,g);return}this.h.warn("[Decorations] CAPPING events from decorations provider",d.identifier.value,g.length);const p=g.map(s=>({uri:s,rank:(0,C.count)(s.path,"/")})),b=(0,S.groupBy)(p,(s,a)=>s.rank-a.rank||(0,C.compare)(s.uri.path,a.uri.path)),i=[];e:for(const s of b){let a;for(const u of s){const c=(0,L.dirname)(u.uri.path);if(a!==c&&(a=c,i.push(u.uri)>=Fn.d))break e}}this.g.$onDidChange(m,i)});return new k.Disposable(()=>{h?.dispose(),this.g.$unregisterDecorationProvider(m),this.f.delete(m)})}async $provideDecorations(v,d,m){if(!this.f.has(v))return Object.create(null);const h=Object.create(null),{provider:w,extensionDescription:g}=this.f.get(v);return await Promise.all(d.map(async p=>{try{const{uri:b,id:i}=p,s=await Promise.resolve(w.provideFileDecoration(o.URI.revive(b),m));if(!s)return;try{k.FileDecoration.validate(s),s.badge&&typeof s.badge!="string"&&(0,P.checkProposedApiEnabled)(g,"codiconDecoration"),h[i]=[s.propagate,s.tooltip,s.badge,s.color]}catch(a){this.h.warn(`INVALID decoration from extension '${g}': ${a}`)}}catch(b){this.h.error(b)}})),h}};y.c=0,y.d=250,y=qe([He(0,I.IExtHostRpcService),He(1,A.ILogService)],y),e.ExtHostDecorations=y,e.IExtHostDecorations=(0,R.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(ne,e,o,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ne,o):k?k.value=o:e.set(ne,o),o},Ue=this&&this.__classPrivateFieldGet||function(ne,e,o,t){if(o==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?t:o==="a"?t.call(ne):t?t.value:e.get(ne)};define(ye[247],Ce([1,0,173,123,2,5,7,14,4,13,28,47]),function(ne,e,o,t,k,R,I,A,S,C,L,P){"use strict";var y,D,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class d{constructor(w,g,p,b,i,s,a){this.d=w,this.e=g,this.f=p,this.g=b,y.set(this,void 0),D.set(this,void 0),v.set(this,void 0),this.c=!1,Je(this,v,new L.ResourceMap(u=>i.getComparisonKey(u)),"f"),Je(this,y,s,"f"),Je(this,D,a,"f")}dispose(){this.c||(Ue(this,D,"f").fire([...Ue(this,v,"f").keys()]),Ue(this,y,"f")?.$clear(this.e),Ue(this,v,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(w,g){if(!w){this.clear();return}this.h();let p=[];if(k.URI.isUri(w)){if(!g){this.delete(w);return}Ue(this,v,"f").set(w,g.slice()),p=[w]}else if(Array.isArray(w)){p=[];let i;w=[...w].sort(d.j);for(const s of w){const[a,u]=s;if((!i||a.toString()!==i.toString())&&(i&&Ue(this,v,"f").get(i).length===0&&Ue(this,v,"f").delete(i),i=a,p.push(a),Ue(this,v,"f").set(a,[])),u)Ue(this,v,"f").get(a)?.push(...u);else{const c=Ue(this,v,"f").get(a);c&&(c.length=0)}}}if(Ue(this,D,"f").fire(p),!Ue(this,y,"f"))return;const b=[];for(const i of p){let s=[];const a=Ue(this,v,"f").get(i);if(a)if(a.length>this.f){s=[];const u=[I.DiagnosticSeverity.Error,I.DiagnosticSeverity.Warning,I.DiagnosticSeverity.Information,I.DiagnosticSeverity.Hint];e:for(let c=0;c<4;c++)for(const l of a)if(l.severity===u[c]&&s.push({...A.Diagnostic.from(l),modelVersionId:this.g(i)})===this.f)break e;s.push({severity:t.MarkerSeverity.Info,message:(0,o.localize)(0,null,a.length-this.f),startLineNumber:s[s.length-1].startLineNumber,startColumn:s[s.length-1].startColumn,endLineNumber:s[s.length-1].endLineNumber,endColumn:s[s.length-1].endColumn})}else s=a.map(u=>({...A.Diagnostic.from(u),modelVersionId:this.g(i)}));b.push([i,s])}Ue(this,y,"f").$changeMany(this.e,b)}delete(w){this.h(),Ue(this,D,"f").fire([w]),Ue(this,v,"f").delete(w),Ue(this,y,"f")?.$changeMany(this.e,[[w,void 0]])}clear(){this.h(),Ue(this,D,"f").fire([...Ue(this,v,"f").keys()]),Ue(this,v,"f").clear(),Ue(this,y,"f")?.$clear(this.e)}forEach(w,g){this.h();for(const[p,b]of this)w.call(g,p,b,this)}*[(y=new WeakMap,D=new WeakMap,v=new WeakMap,Symbol.iterator)](){this.h();for(const w of Ue(this,v,"f").keys())yield[w,this.get(w)]}get(w){this.h();const g=Ue(this,v,"f").get(w);return Array.isArray(g)?Object.freeze(g.slice(0)):[]}has(w){return this.h(),Array.isArray(Ue(this,v,"f").get(w))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(w,g){return w[0].toString()<g[0].toString()?-1:w[0].toString()>g[0].toString()?1:0}}e.DiagnosticCollection=d;let m=class wn{static _mapper(w){const g=new L.ResourceMap;for(const p of w)g.set(p,p);return{uris:Object.freeze(Array.from(g.values()))}}constructor(w,g,p,b){this.h=g,this.j=p,this.k=b,this.f=new Map,this.g=new S.DebounceEmitter({merge:i=>i.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this.g.event,wn._mapper),this.e=w.getProxy(R.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(w,g){const{f:p,e:b,g:i,h:s,j:a,k:u}=this,c=new class{$changeMany(r,f){b.$changeMany(r,f),s.trace("[DiagnosticCollection] change many (extension, owner, uris)",w.value,r,f.length===0?"CLEARING":f)}$clear(r){b.$clear(r),s.trace("[DiagnosticCollection] remove all (extension, owner)",w.value,r)}dispose(){b.dispose()}};let l;if(!g)g="_generated_diagnostic_collection_name_#"+wn.c++,l=g;else if(!p.has(g))l=g;else{this.h.warn(`DiagnosticCollection with name '${g}' does already exist.`);do l=g+wn.c++;while(p.has(l))}return new class extends d{constructor(){super(g,l,wn.d,r=>u.getDocument(r)?.version,a.extUri,c,i),p.set(l,this)}dispose(){super.dispose(),p.delete(l)}}}getDiagnostics(w){if(w)return this.l(w);{const g=new Map,p=[];for(const b of this.f.values())b.forEach((i,s)=>{let a=g.get(i.toString());typeof a>"u"&&(a=p.length,g.set(i.toString(),a),p.push([i,[]])),p[a][1]=p[a][1].concat(...s)});return p}}l(w){let g=[];for(const p of this.f.values())p.has(w)&&(g=g.concat(p.get(w)));return g}$acceptMarkersChange(w){if(!this.m){const g="_generated_mirror",p=new d(g,g,wn.d,b=>{},this.j.extUri,void 0,this.g);this.f.set(g,p),this.m=p}for(const[g,p]of w)this.m.set(k.URI.revive(g),p.map(A.Diagnostic.to))}};m.c=0,m.d=1e3,m=qe([He(1,C.ILogService),He(2,P.IExtHostFileSystemInfo)],m),e.ExtHostDiagnostics=m}),define(ye[248],Ce([1,0,2,5]),function(ne,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class k{constructor(I){this.a=I.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(I){return this.a.$showOpenDialog(I).then(A=>A?A.map(S=>o.URI.revive(S)):void 0)}showSaveDialog(I){return this.a.$showSaveDialog(I).then(A=>A?o.URI.revive(A):void 0)}}e.ExtHostDialogs=k}),define(ye[249],Ce([1,0,10,2,7,5,15,21,8]),function(ne,e,o,t,k,R,I,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class C{constructor(P,y,D){this.d=y,this.e=D,this.b=new Map,this.c=P.getProxy(R.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,y){if(Object.keys(I.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const D=C.a++;this.b.set(D,y),this.c.$registerTextContentProvider(D,P);let v;return typeof y.onDidChange=="function"&&(v=y.onDidChange(d=>{if(d.scheme!==P){this.e.warn(`Provider for scheme '${P}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this.d.getDocument(d)&&this.$provideTextDocumentContent(D,d).then(m=>{if(!m&&typeof m!="string")return;const h=this.d.getDocument(d);if(!h)return;const w=(0,S.splitLines)(m);if(!h.equalLines(w))return this.c.$onVirtualDocumentChange(d,m)},o.onUnexpectedError)})),new k.Disposable(()=>{this.b.delete(D)&&this.c.$unregisterTextContentProvider(D),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(P,y){const D=this.b.get(P);return D?Promise.resolve(D.provideTextDocumentContent(t.URI.revive(y),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${y.scheme}`))}}e.ExtHostDocumentContentProvider=C,C.a=0}),define(ye[250],Ce([1,0,4,6,2,5,135,14,11,23,7]),function(ne,e,o,t,k,R,I,A,S,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class P{constructor(D,v){this.a=new o.Emitter,this.b=new o.Emitter,this.c=new o.Emitter,this.d=new o.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new t.DisposableStore,this.h=new Map,this.f=D.getProxy(R.MainContext.MainThreadDocuments),this.g=v,this.g.onDidRemoveDocuments(d=>{for(const m of d)this.b.fire(m.document)},void 0,this.e),this.g.onDidAddDocuments(d=>{for(const m of d)this.a.fire(m.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(D){if(!D)return;const v=this.g.getDocument(D);if(v)return v}getDocument(D){const v=this.getDocumentData(D);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${D}'`);return v.document}ensureDocumentData(D){const v=this.g.getDocument(D);if(v)return Promise.resolve(v);let d=this.h.get(D.toString());return d||(d=this.f.$tryOpenDocument(D).then(m=>{this.h.delete(D.toString());const h=k.URI.revive(m);return(0,S.assertIsDefined)(this.g.getDocument(h))},m=>(this.h.delete(D.toString()),Promise.reject(m))),this.h.set(D.toString(),d)),d}createDocumentData(D){return this.f.$tryCreateDocument(D).then(v=>k.URI.revive(v))}$acceptModelLanguageChanged(D,v){const d=k.URI.revive(D),m=this.g.getDocument(d);if(!m)throw new Error("unknown document");this.b.fire(m.document),m._acceptLanguageId(v),this.a.fire(m.document)}$acceptModelSaved(D){const v=k.URI.revive(D),d=this.g.getDocument(v);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(D,!1),this.d.fire(d.document)}$acceptDirtyStateChanged(D,v){const d=k.URI.revive(D),m=this.g.getDocument(d);if(!m)throw new Error("unknown document");m._acceptIsDirty(v),this.c.fire({document:m.document,contentChanges:[],reason:void 0})}$acceptModelChanged(D,v,d){const m=k.URI.revive(D),h=this.g.getDocument(m);if(!h)throw new Error("unknown document");h._acceptIsDirty(d),h.onEvents(v);let w;v.isUndoing?w=L.TextDocumentChangeReason.Undo:v.isRedoing&&(w=L.TextDocumentChangeReason.Redo),this.c.fire((0,C.deepFreeze)({document:h.document,contentChanges:v.changes.map(g=>({range:A.Range.to(g.range),rangeOffset:g.rangeOffset,rangeLength:g.rangeLength,text:g.text})),reason:w}))}setWordDefinitionFor(D,v){(0,I.setWordDefinitionFor)(D,v)}}e.ExtHostDocuments=P}),define(ye[58],Ce([1,0,49,4,6,2,3,5,135,17,138,14,13,28,15,62,82]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y,D,v,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class h{constructor(p){this.value=p,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let w=class{constructor(p,b){this.h=p,this.i=b,this.a=null,this.b=new Map,this.c=new D.ResourceMap,this.d=new t.Emitter,this.e=new t.Emitter,this.f=new t.Emitter,this.g=new t.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(p){this.acceptDocumentsAndEditorsDelta(p)}acceptDocumentsAndEditorsDelta(p){const b=[],i=[],s=[];if(p.removedDocuments)for(const a of p.removedDocuments){const u=R.URI.revive(a),c=this.c.get(u);c?.unref()&&(this.c.delete(u),b.push(c.value))}if(p.addedDocuments)for(const a of p.addedDocuments){const u=R.URI.revive(a.uri);let c=this.c.get(u);if(c&&u.scheme!==v.Schemas.vscodeNotebookCell&&u.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${u} already exists!'`);c||(c=new h(new S.ExtHostDocumentData(this.h.getProxy(A.MainContext.MainThreadDocuments),u,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty,a.notebook)),this.c.set(u,c),i.push(c.value)),c.ref()}if(p.removedEditors)for(const a of p.removedEditors){const u=this.b.get(a);this.b.delete(a),u&&s.push(u)}if(p.addedEditors)for(const a of p.addedEditors){const u=R.URI.revive(a.documentUri);o.ok(this.c.has(u),`document '${u}' does not exist`),o.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const c=this.c.get(u).value,l=new L.ExtHostTextEditor(a.id,this.h.getProxy(A.MainContext.MainThreadTextEditors),this.i,new m.Lazy(()=>c.document),a.selections.map(P.Selection.to),a.options,a.visibleRanges.map(n=>P.Range.to(n)),typeof a.editorPosition=="number"?P.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,l)}p.newActiveEditor!==void 0&&(o.ok(p.newActiveEditor===null||this.b.has(p.newActiveEditor),`active editor '${p.newActiveEditor}' does not exist`),this.a=p.newActiveEditor),(0,k.dispose)(b),(0,k.dispose)(s),p.removedDocuments&&this.e.fire(b),p.addedDocuments&&this.d.fire(i),(p.removedEditors||p.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),p.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(p){return this.c.get(p)?.value}allDocuments(){return d.Iterable.map(this.c.values(),p=>p.value)}getEditor(p){return this.b.get(p)}activeEditor(p){if(!this.a)return;const b=this.b.get(this.a);return p?b:b?.value}allEditors(){return[...this.b.values()]}};w=qe([He(0,C.IExtHostRpcService),He(1,y.ILogService)],w),e.ExtHostDocumentsAndEditors=w,e.IExtHostDocumentsAndEditors=(0,I.createDecorator)("IExtHostDocumentsAndEditors")}),define(ye[59],Ce([1,0,14,5,2,4,3,7,17,11,81]),function(ne,e,o,t,k,R,I,A,S,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,I.createDecorator)("IExtHostEditorTabs");class P{constructor(m,h,w){this.e=w,this.d=h,this.acceptDtoUpdate(m)}get apiObject(){if(!this.a){const m=this,h={get isActive(){return m.b.id===m.e()},get label(){return m.b.label},get input(){return m.c},get isDirty(){return m.b.isDirty},get isPinned(){return m.b.isPinned},get isPreview(){return m.b.isPreview},get group(){return m.d.apiObject}};this.a=Object.freeze(h)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(m){this.b=m,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.TextTabInput(k.URI.revive(this.b.input.uri));case 2:return new A.TextDiffTabInput(k.URI.revive(this.b.input.original),k.URI.revive(this.b.input.modified));case 3:return new A.TextMergeTabInput(k.URI.revive(this.b.input.base),k.URI.revive(this.b.input.input1),k.URI.revive(this.b.input.input2),k.URI.revive(this.b.input.result));case 6:return new A.CustomEditorTabInput(k.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.WebviewEditorTabInput(this.b.input.viewType);case 4:return new A.NotebookEditorTabInput(k.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.NotebookDiffEditorTabInput(k.URI.revive(this.b.input.original),k.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.TerminalEditorTabInput;case 9:return new A.InteractiveWindowInput(k.URI.revive(this.b.input.uri),k.URI.revive(this.b.input.inputBoxUri));default:return}}}class y{constructor(m,h){this.c=[],this.d="",this.b=m,this.e=h;for(const w of m.tabs)w.isActive&&(this.d=w.id),this.c.push(new P(w,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const m=this,h={get isActive(){return m.b.groupId===m.e()},get viewColumn(){return o.ViewColumn.to(m.b.viewColumn)},get activeTab(){return m.c.find(w=>w.tabId===m.d)?.apiObject},get tabs(){return Object.freeze(m.c.map(w=>w.apiObject))}};this.a=Object.freeze(h)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(m){this.b=m}acceptTabOperation(m){if(m.kind===0){const w=new P(m.tabDto,this,()=>this.activeTabId());return this.c.splice(m.index,0,w),m.tabDto.isActive&&(this.d=w.tabId),w}else if(m.kind===1){const w=this.c.splice(m.index,1)[0];if(!w)throw new Error(`Tab close updated received for index ${m.index} which does not exist`);return w.tabId===this.d&&(this.d=""),w}else if(m.kind===3){if(m.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const w=this.c.splice(m.oldIndex,1)[0];if(!w)throw new Error(`Tab move updated received for index ${m.oldIndex} which does not exist`);return this.c.splice(m.index,0,w),w}const h=this.c.find(w=>w.tabId===m.tabDto.id);if(!h)throw new Error("INVALID tab");return m.tabDto.isActive?this.d=m.tabDto.id:this.d===m.tabDto.id&&!m.tabDto.isActive&&(this.d=""),h.acceptDtoUpdate(m.tabDto),h}activeTabId(){return this.d}}let D=class{constructor(m){this.b=new R.Emitter,this.c=new R.Emitter,this.e=[],this.a=m.getProxy(t.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const m=this,h={onDidChangeTabGroups:m.c.event,onDidChangeTabs:m.b.event,get all(){return Object.freeze(m.e.map(w=>w.apiObject))},get activeTabGroup(){const w=m.d;return(0,C.assertIsDefined)(m.e.find(p=>p.groupId===w)?.apiObject)},close:async(w,g)=>{const p=Array.isArray(w)?w:[w];return p.length?v(p[0])?this.j(p,g):this.i(p,g):!0}};this.f=Object.freeze(h)}return this.f}$acceptEditorTabModel(m){const h=new Set(this.e.map(a=>a.groupId)),w=new Set(m.map(a=>a.groupId)),g=(0,L.diffSets)(h,w),p=this.e.filter(a=>g.removed.includes(a.groupId)).map(a=>a.apiObject),b=[],i=[];this.e=m.map(a=>{const u=new y(a,()=>this.d);return g.added.includes(u.groupId)?b.push(u.apiObject):i.push(u.apiObject),u});const s=(0,C.assertIsDefined)(m.find(a=>a.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:b,closed:p,changed:i}))}$acceptTabGroupUpdate(m){const h=this.e.find(w=>w.groupId===m.groupId);if(!h)throw new Error("Update Group IPC call received before group creation.");h.acceptGroupDtoUpdate(m),m.isActive&&(this.d=m.groupId),this.c.fire(Object.freeze({changed:[h.apiObject],opened:[],closed:[]}))}$acceptTabOperation(m){const h=this.e.find(g=>g.groupId===m.groupId);if(!h)throw new Error("Update Tabs IPC call received before group creation.");const w=h.acceptTabOperation(m);switch(m.kind){case 0:this.b.fire(Object.freeze({opened:[w.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[w.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[w.apiObject]}));return}}g(m){for(const h of this.e)for(const w of h.tabs)if(w.apiObject===m)return w}h(m){return this.e.find(h=>h.apiObject===m)}async i(m,h){const w=[];for(const g of m){const p=this.g(g);if(!p)throw new Error("Tab close: Invalid tab not found!");w.push(p.tabId)}return this.a.$closeTab(w,h)}async j(m,h){const w=[];for(const g of m){const p=this.h(g);if(!p)throw new Error("Group close: Invalid group not found!");w.push(p.groupId)}return this.a.$closeGroup(w,h)}};D=qe([He(0,S.IExtHostRpcService)],D),e.ExtHostEditorTabs=D;function v(d){return d.tabs!==void 0}}),define(ye[251],Ce([1,0,2,5,6,7,14,153,8,22,27]),function(ne,e,o,t,k,R,I,A,S,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class P{constructor(){this.a=[]}add(v){this.b=void 0,this.a.push(v)}delete(v){const d=this.a.indexOf(v);d>=0&&(this.a.splice(d,1),this.b=void 0)}c(){if(!this.b){const v=this.a.sort(),d=[];let m,h,w=14,g=14;for(const p of v){let b=m?(0,S.commonPrefixLength)(m,p):0;for(b===0?h=1:h=g;b<p.length;b++)b+1===p.length?(w=g,g=9):g+=1,d.push([h,p.toUpperCase().charCodeAt(b),g]),d.push([h,p.toLowerCase().charCodeAt(b),g]),h=g;m=p,g=w}d.push([9,58,10]),d.push([10,47,12]),this.b=new A.StateMachine(d)}}provideDocumentLinks(v){this.c();const d=[],m=A.LinkComputer.computeLinks({getLineContent(h){return v.lineAt(h-1).text},getLineCount(){return v.lineCount}},this.b);for(const h of m){const w=I.DocumentLink.to(h);w.target&&d.push(w)}return d}}class y{constructor(v,d){this.i=d,this.b=new P,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=v.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(v,d,m,h={}){if(this.d.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(v,"*",this.b));const w=this.h++;this.b.add(d),this.d.add(d),this.c.set(w,m);let g=2;h.isCaseSensitive&&(g+=1024),h.isReadonly&&(g+=2048),typeof m.copy=="function"&&(g+=8),typeof m.open=="function"&&typeof m.close=="function"&&typeof m.read=="function"&&typeof m.write=="function"&&((0,L.checkProposedApiEnabled)(v,"fsChunks"),g+=4),this.a.$registerFileSystemProvider(w,d,g).catch(b=>{console.error(`FAILED to register filesystem provider of ${v.identifier.value}-extension for the scheme ${d}`),console.error(b)});const p=m.onDidChangeFile(b=>{const i=[];for(const s of b){const{uri:a,type:u}=s;if(a.scheme!==d)continue;let c;switch(u){case R.FileChangeType.Changed:c=0;break;case R.FileChangeType.Created:c=1;break;case R.FileChangeType.Deleted:c=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:a,type:c})}this.a.$onFileSystemChange(w,i)});return(0,k.toDisposable)(()=>{p.dispose(),this.b.delete(d),this.d.delete(d),this.c.delete(w),this.a.$unregisterProvider(w)})}static j(v){const{type:d,ctime:m,mtime:h,size:w,permissions:g}=v;return{type:d,ctime:m,mtime:h,size:w,permissions:g}}$stat(v,d){return Promise.resolve(this.k(v).stat(o.URI.revive(d))).then(m=>y.j(m))}$readdir(v,d){return Promise.resolve(this.k(v).readDirectory(o.URI.revive(d)))}$readFile(v,d){return Promise.resolve(this.k(v).readFile(o.URI.revive(d))).then(m=>C.VSBuffer.wrap(m))}$writeFile(v,d,m,h){return Promise.resolve(this.k(v).writeFile(o.URI.revive(d),m.buffer,h))}$delete(v,d,m){return Promise.resolve(this.k(v).delete(o.URI.revive(d),m))}$rename(v,d,m,h){return Promise.resolve(this.k(v).rename(o.URI.revive(d),o.URI.revive(m),h))}$copy(v,d,m,h){const w=this.k(v);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(o.URI.revive(d),o.URI.revive(m),h))}$mkdir(v,d){return Promise.resolve(this.k(v).createDirectory(o.URI.revive(d)))}$watch(v,d,m,h){const w=this.k(v).watch(o.URI.revive(m),h);this.f.set(d,w)}$unwatch(v,d){const m=this.f.get(d);m&&(m.dispose(),this.f.delete(d))}$open(v,d,m){const h=this.k(v);if(!h.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(h.open(o.URI.revive(d),m))}$close(v,d){const m=this.k(v);if(!m.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(m.close(d))}$read(v,d,m,h){const w=this.k(v);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const g=C.VSBuffer.alloc(h);return Promise.resolve(w.read(d,m,g.buffer,0,h)).then(p=>g.slice(0,p))}$write(v,d,m,h){const w=this.k(v);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(d,m,h.buffer,0,h.byteLength))}k(v){const d=this.c.get(v);if(!d){const m=new Error;throw m.name="ENOPRO",m.message="no provider",m}return d}}e.ExtHostFileSystem=y}),define(ye[72],Ce([1,0,5,38,7,22,3,17,47,6]),function(ne,e,o,t,k,R,I,A,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=class Jt{constructor(y,D){this.b=new Map,this.a=y.getProxy(o.MainContext.MainThreadFileSystem);const v=this;this.value=Object.freeze({async stat(d){try{const m=v.b.get(d.scheme);if(!m)return await v.a.$stat(d);await v.a.$ensureActivation(d.scheme);const h=await m.stat(d);return{type:h.type,ctime:h.ctime,mtime:h.mtime,size:h.size,permissions:h.permissions}}catch(m){Jt.c(m)}},async readDirectory(d){try{const m=v.b.get(d.scheme);return m?(await v.a.$ensureActivation(d.scheme),(await m.readDirectory(d)).slice()):await v.a.$readdir(d)}catch(m){return Jt.c(m)}},async createDirectory(d){try{return await v.a.$mkdir(d)}catch(m){return Jt.c(m)}},async readFile(d){try{const m=v.b.get(d.scheme);return m?(await v.a.$ensureActivation(d.scheme),(await m.readFile(d)).slice()):(await v.a.$readFile(d)).buffer}catch(m){return Jt.c(m)}},async writeFile(d,m){try{return await v.a.$writeFile(d,R.VSBuffer.wrap(m))}catch(h){return Jt.c(h)}},async delete(d,m){try{const h=v.b.get(d.scheme);return h?(await v.a.$ensureActivation(d.scheme),await h.delete(d,{recursive:!1,...m})):await v.a.$delete(d,{recursive:!1,useTrash:!1,...m})}catch(h){return Jt.c(h)}},async rename(d,m,h){try{return await v.a.$rename(d,m,{overwrite:!1,...h})}catch(w){return Jt.c(w)}},async copy(d,m,h){try{return await v.a.$copy(d,m,{overwrite:!1,...h})}catch(w){return Jt.c(w)}},isWritableFileSystem(d){const m=D.getCapabilities(d);if(typeof m=="number")return!(m&2048)}})}static c(y){if(y instanceof k.FileSystemError)throw y;if(!(y instanceof Error))throw new k.FileSystemError(String(y));if(y.name==="ENOPRO")throw k.FileSystemError.Unavailable(y.message);switch(y.name){case t.FileSystemProviderErrorCode.FileExists:throw k.FileSystemError.FileExists(y.message);case t.FileSystemProviderErrorCode.FileNotFound:throw k.FileSystemError.FileNotFound(y.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw k.FileSystemError.FileNotADirectory(y.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw k.FileSystemError.FileIsADirectory(y.message);case t.FileSystemProviderErrorCode.NoPermissions:throw k.FileSystemError.NoPermissions(y.message);case t.FileSystemProviderErrorCode.Unavailable:throw k.FileSystemError.Unavailable(y.message);default:throw new k.FileSystemError(y.message,y.name)}}addFileSystemProvider(y,D){return this.b.set(y,D),(0,C.toDisposable)(()=>this.b.delete(y))}};L=qe([He(0,A.IExtHostRpcService),He(1,S.IExtHostFileSystemInfo)],L),e.ExtHostConsumerFileSystem=L,e.IExtHostConsumerFileSystem=(0,I.createDecorator)("IExtHostConsumerFileSystem")}),define(ye[252],Ce([1,0,4,37,2,5,14,7]),function(ne,e,o,t,k,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(P,y,D,v,d,m,h,w){this.a=new o.Emitter,this.b=new o.Emitter,this.c=new o.Emitter;const g=this.h(P,D,d);this.g=0,m&&(this.g+=1),h&&(this.g+=2),w&&(this.g+=4);const p=(0,t.parse)(d),b=typeof d=="string",i=v(s=>{if(!m)for(const a of s.created){const u=k.URI.revive(a);p(u.fsPath)&&(!b||y.getWorkspaceFolder(u))&&this.a.fire(u)}if(!h)for(const a of s.changed){const u=k.URI.revive(a);p(u.fsPath)&&(!b||y.getWorkspaceFolder(u))&&this.b.fire(u)}if(!w)for(const a of s.deleted){const u=k.URI.revive(a);p(u.fsPath)&&(!b||y.getWorkspaceFolder(u))&&this.c.fire(u)}});this.d=A.Disposable.from(g,this.a,this.b,this.c,i)}h(P,y,D){const v=A.Disposable.from();if(typeof D=="string")return v;const d=P.getProxy(R.MainContext.MainThreadFileSystem);let m=!1;(D.pattern.includes(t.GLOBSTAR)||D.pattern.includes(t.GLOB_SPLIT))&&(m=!0);const h=Math.random();return d.$watch(y.identifier.value,h,D.baseUri,{recursive:m,excludes:[]}),A.Disposable.from({dispose:()=>d.$unwatch(h)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class C{constructor(P,y,D){this.j=P,this.k=y,this.l=D,this.a=new o.Emitter,this.b=new o.Emitter,this.c=new o.Emitter,this.d=new o.Emitter,this.g=new o.AsyncEmitter,this.h=new o.AsyncEmitter,this.i=new o.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(P,y,D,v,d,m){return new S(this.j,P,y,this.a.event,I.GlobPattern.from(D),v,d,m)}$onFileEvent(P){this.a.fire(P)}$onDidRunFileOperation(P,y){switch(P){case 2:this.b.fire(Object.freeze({files:y.map(D=>({oldUri:k.URI.revive(D.source),newUri:k.URI.revive(D.target)}))}));break;case 1:this.d.fire(Object.freeze({files:y.map(D=>k.URI.revive(D.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:y.map(D=>k.URI.revive(D.target))}));break;default:}}getOnWillRenameFileEvent(P){return this.m(P,this.g)}getOnWillCreateFileEvent(P){return this.m(P,this.h)}getOnWillDeleteFileEvent(P){return this.m(P,this.i)}m(P,y){return(D,v,d)=>{const m=function(w){D.call(v,w)};return m.extension=P,y.event(m,void 0,d)}}async $onWillRunFileOperation(P,y,D,v){switch(P){case 2:return await this.n(this.g,{files:y.map(d=>({oldUri:k.URI.revive(d.source),newUri:k.URI.revive(d.target)}))},D,v);case 1:return await this.n(this.i,{files:y.map(d=>k.URI.revive(d.target))},D,v);case 0:case 3:return await this.n(this.h,{files:y.map(d=>k.URI.revive(d.target))},D,v)}}async n(P,y,D,v){const d=new Set,m=[];if(await P.fireAsync(y,v,async(w,g)=>{const p=Date.now(),b=await Promise.resolve(w);b instanceof A.WorkspaceEdit&&(m.push([g.extension,b]),d.add(g.extension.displayName??g.extension.identifier.value)),Date.now()-p>D&&this.k.warn("SLOW file-participant",g.extension.identifier)}),v.isCancellationRequested||m.length===0)return;const h={edits:[]};for(const[,w]of m){const{edits:g}=I.WorkspaceEdit.from(w,{getTextDocumentVersion:p=>this.l.getDocument(p)?.version,getNotebookDocumentVersion:()=>{}});h.edits=h.edits.concat(g)}return{edit:h,extensionNames:Array.from(d)}}}e.ExtHostFileSystemEventService=C}),define(ye[253],Ce([1,0,2,39]),function(ne,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class k{constructor(I,A,S,C,L){this.a=A,this.b=S,this.c=C;const P=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",y=>!0,y=>y),new t.ApiCommandArgument("resource","Interactive resource Uri",y=>!0,y=>y),new t.ApiCommandArgument("controllerId","Notebook controller Id",y=>!0,y=>y),new t.ApiCommandArgument("title","Interactive editor title",y=>!0,y=>y)],new t.ApiCommandResult("Notebook and input URI",y=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",y.notebookEditorId),y.notebookEditorId!==void 0){const D=this.a.getEditorById(y.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",D.id),{notebookUri:o.URI.revive(y.notebookUri),inputUri:o.URI.revive(y.inputUri),notebookEditor:D.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",y.notebookUri,y.inputUri),{notebookUri:o.URI.revive(y.notebookUri),inputUri:o.URI.revive(y.inputUri)}}));this.c.registerApiCommand(P)}$willAddInteractiveDocument(I,A,S,C){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:S,uri:I,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(o.URI.revive(C))?.apiNotebook}]})}$willRemoveInteractiveDocument(I,A){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[I]})}}e.ExtHostInteractive=k}),define(ye[254],Ce([1,0,6,5]),function(ne,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class k{constructor(I){this.b=0,this.a=I.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(I){const A=this.b++;return this.a.$registerResourceLabelFormatter(A,I),(0,o.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=k}),define(ye[255],Ce([1,0,2,23,14,7,66,5,8,35,18,11,149,21,6,119,100,69,42,10,16,27]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y,D,v,d,m,h,w,g,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class i{constructor(O,H){this.d=O,this.e=H}async provideDocumentSymbols(O,H){const x=this.d.getDocument(O),Y=await this.e.provideDocumentSymbols(x,H);if(!(0,L.isFalsyOrEmpty)(Y))return Y[0]instanceof R.DocumentSymbol?Y.map(k.DocumentSymbol.from):i.f(Y)}static f(O){O=O.slice(0).sort((Y,de)=>{let be=Y.location.range.start.compareTo(de.location.range.start);return be===0&&(be=de.location.range.end.compareTo(Y.location.range.end)),be});const H=[],x=[];for(const Y of O){const de={name:Y.name||"!!MISSING: name!!",kind:k.SymbolKind.from(Y.kind),tags:Y.tags?.map(k.SymbolTag.from)||[],detail:"",containerName:Y.containerName,range:k.Range.from(Y.location.range),selectionRange:k.Range.from(Y.location.range),children:[]};for(;;){if(x.length===0){x.push(de),H.push(de);break}const be=x[x.length-1];if(C.Range.containsRange(be.range,de.range)&&!C.Range.equalsRange(be.range,de.range)){be.children?.push(de),x.push(de);break}x.pop()}}return H}}class s{constructor(O,H,x){this.g=O,this.h=H,this.j=x,this.e=new h.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(O,H){const x=this.g.getDocument(O),Y=await this.j.provideCodeLenses(x,H);if(!Y||H.isCancellationRequested)return;const de=this.e.add(Y),be=new v.DisposableStore;this.f.set(de,be);const Pe={cacheId:de,lenses:[]};for(let pe=0;pe<Y.length;pe++)Pe.lenses.push({cacheId:[de,pe],range:k.Range.from(Y[pe].range),command:this.h.toInternal(Y[pe].command,be)});return Pe}async resolveCodeLens(O,H){const x=O.cacheId&&this.e.get(...O.cacheId);if(!x)return;let Y;if(typeof this.j.resolveCodeLens!="function"||x.isResolved?Y=x:Y=await this.j.resolveCodeLens(x,H),Y||(Y=x),H.isCancellationRequested)return;const de=O.cacheId&&this.f.get(O.cacheId[0]);if(!!de)return O.command=this.h.toInternal(Y.command??s.d,de),O}releaseCodeLenses(O){this.f.get(O)?.dispose(),this.f.delete(O),this.e.delete(O)}}s.d={command:"missing",title:"!!MISSING: command!!"};function a(ie){return Array.isArray(ie)?ie.map(k.DefinitionLink.from):ie?[k.DefinitionLink.from(ie)]:[]}class u{constructor(O,H){this.d=O,this.e=H}async provideDefinition(O,H,x){const Y=this.d.getDocument(O),de=k.Position.to(H),be=await this.e.provideDefinition(Y,de,x);return a(be)}}class c{constructor(O,H){this.d=O,this.e=H}async provideDeclaration(O,H,x){const Y=this.d.getDocument(O),de=k.Position.to(H),be=await this.e.provideDeclaration(Y,de,x);return a(be)}}class l{constructor(O,H){this.d=O,this.e=H}async provideImplementation(O,H,x){const Y=this.d.getDocument(O),de=k.Position.to(H),be=await this.e.provideImplementation(Y,de,x);return a(be)}}class n{constructor(O,H){this.d=O,this.e=H}async provideTypeDefinition(O,H,x){const Y=this.d.getDocument(O),de=k.Position.to(H),be=await this.e.provideTypeDefinition(Y,de,x);return a(be)}}class r{constructor(O,H){this.d=O,this.e=H}async provideHover(O,H,x){const Y=this.d.getDocument(O),de=k.Position.to(H),be=await this.e.provideHover(Y,de,x);if(!(!be||(0,L.isFalsyOrEmpty)(be.contents)))return be.range||(be.range=Y.getWordRangeAtPosition(de)),be.range||(be.range=new R.Range(de,de)),k.Hover.from(be)}}class f{constructor(O,H){this.d=O,this.e=H}async provideEvaluatableExpression(O,H,x){const Y=this.d.getDocument(O),de=k.Position.to(H),be=await this.e.provideEvaluatableExpression(Y,de,x);if(be)return k.EvaluatableExpression.from(be)}}class E{constructor(O,H){this.d=O,this.e=H}async provideInlineValues(O,H,x,Y){const de=this.d.getDocument(O),be=await this.e.provideInlineValues(de,k.Range.to(H),k.InlineValueContext.to(x),Y);if(Array.isArray(be))return be.map(Pe=>k.InlineValue.from(Pe))}}class T{constructor(O,H){this.d=O,this.e=H}async provideDocumentHighlights(O,H,x){const Y=this.d.getDocument(O),de=k.Position.to(H),be=await this.e.provideDocumentHighlights(Y,de,x);if(Array.isArray(be))return be.map(k.DocumentHighlight.from)}}class M{constructor(O,H){this.d=O,this.e=H}async provideLinkedEditingRanges(O,H,x){const Y=this.d.getDocument(O),de=k.Position.to(H),be=await this.e.provideLinkedEditingRanges(Y,de,x);if(be&&Array.isArray(be.ranges))return{ranges:(0,L.coalesce)(be.ranges.map(k.Range.from)),wordPattern:be.wordPattern}}}class G{constructor(O,H){this.d=O,this.e=H}async provideReferences(O,H,x,Y){const de=this.d.getDocument(O),be=k.Position.to(H),Pe=await this.e.provideReferences(de,be,x,Y);if(Array.isArray(Pe))return Pe.map(k.location.from)}}class V{constructor(O,H,x,Y,de,be,Pe){this.g=O,this.h=H,this.j=x,this.k=Y,this.l=de,this.m=be,this.n=Pe,this.e=new h.Cache("CodeAction"),this.f=new Map}async provideCodeActions(O,H,x,Y){const de=this.g.getDocument(O),be=y.Selection.isISelection(H)?k.Selection.to(H):k.Range.to(H),Pe=[];for(const et of this.j.getDiagnostics(O))if(be.intersection(et.range)&&Pe.push(et)>V.d)break;const pe={diagnostics:Pe,only:x.only?new R.CodeActionKind(x.only):void 0,triggerKind:k.CodeActionTriggerKind.to(x.trigger)},De=await this.k.provideCodeActions(de,be,pe,Y);if(!(0,L.isNonEmptyArray)(De)||Y.isCancellationRequested)return;const ke=this.e.add(De),je=new v.DisposableStore;this.f.set(ke,je);const Ge=[];for(let et=0;et<De.length;et++){const _e=De[et];!_e||(V.o(_e)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),Ge.push({_isSynthetic:!0,title:_e.title,command:this.h.toInternal(_e,je)})):(pe.only&&(_e.kind?pe.only.contains(_e.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action is of kind '${_e.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ge.push({cacheId:[ke,et],title:_e.title,command:_e.command&&this.h.toInternal(_e.command,je),diagnostics:_e.diagnostics&&_e.diagnostics.map(k.Diagnostic.from),edit:_e.edit&&k.WorkspaceEdit.from(_e.edit,void 0),kind:_e.kind&&_e.kind.value,isPreferred:_e.isPreferred,disabled:_e.disabled?.reason})))}return{cacheId:ke,actions:Ge}}async resolveCodeAction(O,H){const[x,Y]=O,de=this.e.get(x,Y);if(!de||V.o(de)||!this.k.resolveCodeAction)return;const be=await this.k.resolveCodeAction(de,H)??de;return be?.edit?k.WorkspaceEdit.from(be.edit,void 0):void 0}releaseCodeActions(O){this.f.get(O)?.dispose(),this.f.delete(O),this.e.delete(O)}static o(O){return typeof O.command=="string"&&typeof O.title=="string"}}V.d=1e3;class N{constructor(O,H,x,Y){this.d=O,this.e=H,this.f=x,this.g=Y}async prepareDocumentPaste(O,H,x,Y){if(!this.f.prepareDocumentPaste)return;const de=this.e.getDocument(O),be=H.map(pe=>k.Range.to(pe)),Pe=k.DataTransfer.toDataTransfer(x,()=>{throw new g.NotImplementedError});return await this.f.prepareDocumentPaste(de,be,Pe,Y),k.DataTransfer.toDataTransferDTO(Pe)}async providePasteEdits(O,H,x,Y,de){const be=this.e.getDocument(H),Pe=x.map(ke=>k.Range.to(ke)),pe=k.DataTransfer.toDataTransfer(Y,async ke=>(await this.d.$resolvePasteFileData(this.g,O,ke)).buffer),De=await this.f.provideDocumentPasteEdits(be,Pe,pe,de);if(!!De)return{insertText:typeof De.insertText=="string"?De.insertText:{snippet:De.insertText.value},additionalEdit:De.additionalEdit?k.WorkspaceEdit.from(De.additionalEdit,void 0):void 0}}}class U{constructor(O,H){this.d=O,this.e=H}async provideDocumentFormattingEdits(O,H,x){const Y=this.d.getDocument(O),de=await this.e.provideDocumentFormattingEdits(Y,H,x);if(Array.isArray(de))return de.map(k.TextEdit.from)}}class F{constructor(O,H){this.d=O,this.e=H}async provideDocumentRangeFormattingEdits(O,H,x,Y){const de=this.d.getDocument(O),be=k.Range.to(H),Pe=await this.e.provideDocumentRangeFormattingEdits(de,be,x,Y);if(Array.isArray(Pe))return Pe.map(k.TextEdit.from)}}class z{constructor(O,H){this.d=O,this.e=H,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,H,x,Y,de){const be=this.d.getDocument(O),Pe=k.Position.to(H),pe=await this.e.provideOnTypeFormattingEdits(be,Pe,x,Y,de);if(Array.isArray(pe))return pe.map(k.TextEdit.from)}}class B{constructor(O,H){this.e=O,this.f=H,this.d=new h.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(O,H){const x=await this.e.provideWorkspaceSymbols(O,H);if(!(0,L.isNonEmptyArray)(x))return{symbols:[]};const Y=this.d.add(x),de={cacheId:Y,symbols:[]};for(let be=0;be<x.length;be++){const Pe=x[be];if(!Pe||!Pe.name){this.f.warn("INVALID SymbolInformation",Pe);continue}de.symbols.push({...k.WorkspaceSymbol.from(Pe),cacheId:[Y,be]})}return de}async resolveWorkspaceSymbol(O,H){if(typeof this.e.resolveWorkspaceSymbol!="function"||!O.cacheId)return O;const x=this.d.get(...O.cacheId);if(x){const Y=await this.e.resolveWorkspaceSymbol(x,H);return Y&&(0,t.mixin)(O,k.WorkspaceSymbol.from(Y),!0)}}releaseWorkspaceSymbols(O){this.d.delete(O)}}class W{static supportsResolving(O){return typeof O.prepareRename=="function"}constructor(O,H,x){this.d=O,this.e=H,this.f=x}async provideRenameEdits(O,H,x,Y){const de=this.d.getDocument(O),be=k.Position.to(H);try{const Pe=await this.e.provideRenameEdits(de,be,x,Y);return Pe?k.WorkspaceEdit.from(Pe):void 0}catch(Pe){const pe=W.g(Pe);return pe?{rejectReason:pe,edits:void 0}:Promise.reject(Pe)}}async resolveRenameLocation(O,H,x){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Y=this.d.getDocument(O),de=k.Position.to(H);try{const be=await this.e.prepareRename(Y,de,x);let Pe,pe;if(R.Range.isRange(be)?(Pe=be,pe=Y.getText(be)):(0,P.isObject)(be)&&(Pe=be.range,pe=be.placeholder),!Pe||!pe)return;if(Pe.start.line>de.line||Pe.end.line<de.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:k.Range.from(Pe),text:pe}}catch(be){const Pe=W.g(be);return Pe?{rejectReason:Pe,range:void 0,text:void 0}:Promise.reject(be)}}static g(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class X{constructor(O,H){this.resultId=O,this.tokens=H}}class q{constructor(O,H){this.f=O,this.g=H,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(O,H,x){const Y=this.f.getDocument(O),de=H!==0?this.d.get(H):null;let be=typeof de?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Y,de.resultId,x):await this.g.provideDocumentSemanticTokens(Y,x);return de&&this.d.delete(H),be?(be=q.h(be),this.o(q.n(de,be),be)):null}async releaseDocumentSemanticColoring(O){this.d.delete(O)}static h(O){return q.j(O)?q.k(O)?O:new R.SemanticTokens(new Uint32Array(O.data),O.resultId):q.l(O)?q.m(O)?O:new R.SemanticTokensEdits(O.edits.map(H=>new R.SemanticTokensEdit(H.start,H.deleteCount,H.data?new Uint32Array(H.data):H.data)),O.resultId):O}static j(O){return O&&!!O.data}static k(O){return O.data instanceof Uint32Array}static l(O){return O&&Array.isArray(O.edits)}static m(O){for(const H of O.edits)if(!(H.data instanceof Uint32Array))return!1;return!0}static n(O,H){if(!q.j(H)||!O||!O.tokens)return H;const x=O.tokens,Y=x.length,de=H.data,be=de.length;let Pe=0;const pe=Math.min(Y,be);for(;Pe<pe&&x[Pe]===de[Pe];)Pe++;if(Pe===Y&&Pe===be)return new R.SemanticTokensEdits([],H.resultId);let De=0;const ke=pe-Pe;for(;De<ke&&x[Y-De-1]===de[be-De-1];)De++;return new R.SemanticTokensEdits([{start:Pe,deleteCount:Y-Pe-De,data:de.subarray(Pe,be-De)}],H.resultId)}o(O,H){if(q.j(O)){const x=this.e++;return this.d.set(x,new X(O.resultId,O.data)),(0,d.encodeSemanticTokensDto)({id:x,type:"full",data:O.data})}if(q.l(O)){const x=this.e++;return q.j(H)?this.d.set(x,new X(H.resultId,H.data)):this.d.set(x,new X(O.resultId)),(0,d.encodeSemanticTokensDto)({id:x,type:"delta",deltas:(O.edits||[]).map(Y=>({start:Y.start,deleteCount:Y.deleteCount,data:Y.data}))})}return null}}class _{constructor(O,H){this.d=O,this.e=H}async provideDocumentRangeSemanticTokens(O,H,x){const Y=this.d.getDocument(O),de=await this.e.provideDocumentRangeSemanticTokens(Y,k.Range.to(H),x);return de?this.f(de):null}f(O){return(0,d.encodeSemanticTokensDto)({id:0,type:"full",data:O.data})}}class Q{static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}constructor(O,H,x,Y,de){this.f=O,this.g=H,this.h=x,this.j=Y,this.k=de,this.d=new h.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(O,H,x,Y){const de=this.f.getDocument(O),be=k.Position.to(H),Pe=de.getWordRangeAtPosition(be)||new R.Range(be,be),pe=Pe.with({end:be}),De=new w.StopWatch(!0),ke=await this.h.provideCompletionItems(de,be,Y,k.CompletionContext.to(x));if(!ke||Y.isCancellationRequested)return;const je=Array.isArray(ke)?new R.CompletionList(ke):ke,Ge=Q.supportsResolving(this.h)?this.d.add(je.items):this.d.add([]),et=new v.DisposableStore;this.e.set(Ge,et);const _e=[],nt={x:Ge,b:_e,a:{replace:k.Range.from(Pe),insert:k.Range.from(pe)},c:je.isIncomplete||void 0,d:De.elapsed()};for(let st=0;st<je.items.length;st++){const ht=je.items[st],Me=this.l(ht,[Ge,st],pe,Pe);_e.push(Me)}return nt}async resolveCompletionItem(O,H){if(typeof this.h.resolveCompletionItem!="function")return;const x=this.d.get(...O);if(!x)return;const Y=await this.h.resolveCompletionItem(x,H);if(!!Y)return this.l(Y,O)}releaseCompletionItems(O){this.e.get(O)?.dispose(),this.e.delete(O),this.d.delete(O)}l(O,H,x,Y){const de=this.e.get(H[0]);if(!de)throw Error("DisposableStore is missing...");const be=this.g.toInternal(O.command,de),Pe={x:H,a:O.label,b:O.kind!==void 0?k.CompletionItemKind.from(O.kind):void 0,m:O.tags&&O.tags.map(k.CompletionItemTag.from),c:O.detail,d:typeof O.documentation>"u"?void 0:k.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters?.join(""),l:O.additionalTextEdits&&O.additionalTextEdits.map(k.TextEdit.from),n:be?.$ident,o:be?.id,p:be?.$ident?void 0:be?.arguments};O.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Pe.h=O.textEdit.newText):typeof O.insertText=="string"?Pe.h=O.insertText:O.insertText instanceof R.SnippetString&&(Pe.h=O.insertText.value,Pe.i|=4);let pe;return O.textEdit?pe=O.textEdit.range:O.range&&(pe=O.range),R.Range.isRange(pe)?Pe.j=k.Range.from(pe):pe&&(!x?.isEqual(pe.inserting)||!Y?.isEqual(pe.replacing))&&(Pe.j={insert:k.Range.from(pe.inserting),replace:k.Range.from(pe.replacing)}),Pe}}class Z{async provideInlineCompletions(O,H,x,Y){}disposeCompletions(O){}handleDidShowCompletionItem(O,H){}}class ge extends Z{constructor(O,H,x,Y){super(),this.f=O,this.g=H,this.h=x,this.j=Y,this.d=new te,this.e=(0,b.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[I.InlineCompletionTriggerKind.Automatic]:R.InlineCompletionTriggerKind.Automatic,[I.InlineCompletionTriggerKind.Explicit]:R.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,b.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&typeof this.h.handleDidShowCompletionItem=="function"}async provideInlineCompletions(O,H,x,Y){const de=this.g.getDocument(O),be=k.Position.to(H),Pe=await this.h.provideInlineCompletionItems(de,be,{selectedCompletionInfo:x.selectedSuggestionInfo?{range:k.Range.to(x.selectedSuggestionInfo.range),text:x.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[x.triggerKind]},Y);if(!Pe||Y.isCancellationRequested)return;const pe=Array.isArray(Pe)?Pe:Pe.items,De=this.e?Array.isArray(Pe)?[]:Pe.commands||[]:[];let ke;return{pid:this.d.createReferenceId({dispose(){ke?.dispose()},items:pe}),items:pe.map((Ge,et)=>{let _e;Ge.command&&(ke||(ke=new v.DisposableStore),_e=this.j.toInternal(Ge.command,ke));const nt=Ge.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:Ge.filterText,range:Ge.range?k.Range.from(Ge.range):void 0,command:_e,idx:et,completeBracketPairs:this.e?Ge.completeBracketPairs:!1}}),commands:De.map(Ge=>(ke||(ke=new v.DisposableStore),this.j.toInternal(Ge,ke)))}}disposeCompletions(O){this.d.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,H){const x=this.d.get(O)?.items[H];x&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(x)}}class te{constructor(){this.d=new Map,this.e=1}createReferenceId(O){const H=this.e++;return this.d.set(H,O),H}disposeReferenceId(O){const H=this.d.get(O);return this.d.delete(O),H}get(O){return this.d.get(O)}}class J{constructor(O,H){this.e=O,this.f=H,this.d=new h.Cache("SignatureHelp")}async provideSignatureHelp(O,H,x,Y){const de=this.e.getDocument(O),be=k.Position.to(H),Pe=this.g(x),pe=await this.f.provideSignatureHelp(de,be,Y,Pe);if(pe){const De=this.d.add([pe]);return{...k.SignatureHelp.from(pe),id:De}}}g(O){let H;if(O.activeSignatureHelp){const x=k.SignatureHelp.to(O.activeSignatureHelp),Y=this.d.get(O.activeSignatureHelp.id,0);Y?(H=Y,H.activeSignature=x.activeSignature,H.activeParameter=x.activeParameter):H=x}return{...O,activeSignatureHelp:H}}releaseSignatureHelp(O){this.d.delete(O)}}class fe{constructor(O,H,x,Y,de){this.f=O,this.g=H,this.h=x,this.j=Y,this.k=de,this.d=new h.Cache("InlayHints"),this.e=new Map}async provideInlayHints(O,H,x){const Y=this.f.getDocument(O),de=k.Range.to(H),be=await this.h.provideInlayHints(Y,de,x);if(!Array.isArray(be)||be.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${H}`);return}if(x.isCancellationRequested)return;const Pe=this.d.add(be);this.e.set(Pe,new v.DisposableStore);const pe={hints:[],cacheId:Pe};for(let De=0;De<be.length;De++)this.l(be[De],de)&&pe.hints.push(this.m(be[De],[Pe,De]));return this.j.trace(`[InlayHints] ${pe.hints.length} inlay hints from '${this.k.identifier.value}' for ${H}`),pe}async resolveInlayHint(O,H){if(typeof this.h.resolveInlayHint!="function")return;const x=this.d.get(...O);if(!x)return;const Y=await this.h.resolveInlayHint(x,H);if(!!Y&&!!this.l(Y))return this.m(Y,O)}releaseHints(O){this.e.get(O)?.dispose(),this.e.delete(O),this.d.delete(O)}l(O,H){return O.label.length===0||Array.isArray(O.label)&&O.label.every(x=>x.value.length===0)?(console.log("INVALID inlay hint, empty label",O),!1):!(H&&!H.contains(O.position))}m(O,H){const x=this.e.get(H[0]);if(!x)throw Error("DisposableStore is missing...");const Y={label:"",cacheId:H,tooltip:k.MarkdownString.fromStrict(O.tooltip),position:k.Position.from(O.position),textEdits:O.textEdits&&O.textEdits.map(k.TextEdit.from),kind:O.kind&&k.InlayHintKind.from(O.kind),paddingLeft:O.paddingLeft,paddingRight:O.paddingRight};return typeof O.label=="string"?Y.label=O.label:Y.label=O.label.map(de=>{const be={label:de.value};return be.tooltip=k.MarkdownString.fromStrict(de.tooltip),R.Location.isLocation(de.location)&&(be.location=k.location.from(de.location)),de.command&&(be.command=this.g.toInternal(de.command,x)),be}),Y}}class ve{constructor(O,H){this.e=O,this.f=H,this.d=new h.Cache("DocumentLink")}async provideLinks(O,H){const x=this.e.getDocument(O),Y=await this.f.provideDocumentLinks(x,H);if(!(!Array.isArray(Y)||Y.length===0)&&!H.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Y.filter(ve.g).map(k.DocumentLink.from)};{const de=this.d.add(Y),be={links:[],cacheId:de};for(let Pe=0;Pe<Y.length;Pe++){if(!ve.g(Y[Pe]))continue;const pe=k.DocumentLink.from(Y[Pe]);pe.cacheId=[de,Pe],be.links.push(pe)}return be}}}static g(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,H){if(typeof this.f.resolveDocumentLink!="function")return;const x=this.d.get(...O);if(!x)return;const Y=await this.f.resolveDocumentLink(x,H);if(!(!Y||!ve.g(Y)))return k.DocumentLink.from(Y)}releaseLinks(O){this.d.delete(O)}}class Ee{constructor(O,H){this.d=O,this.e=H}async provideColors(O,H){const x=this.d.getDocument(O),Y=await this.e.provideDocumentColors(x,H);return Array.isArray(Y)?Y.map(be=>({color:k.Color.from(be.color),range:k.Range.from(be.range)})):[]}async provideColorPresentations(O,H,x){const Y=this.d.getDocument(O),de=k.Range.to(H.range),be=k.Color.to(H.color),Pe=await this.e.provideColorPresentations(be,{document:Y,range:de},x);if(!!Array.isArray(Pe))return Pe.map(k.ColorPresentation.from)}}class Ae{constructor(O,H){this.d=O,this.e=H}async provideFoldingRanges(O,H,x){const Y=this.d.getDocument(O),de=await this.e.provideFoldingRanges(Y,H,x);if(!!Array.isArray(de))return de.map(k.FoldingRange.from)}}class Fe{constructor(O,H,x){this.d=O,this.e=H,this.f=x}async provideSelectionRanges(O,H,x){const Y=this.d.getDocument(O),de=H.map(k.Position.to),be=await this.e.provideSelectionRanges(Y,de,x);if(!(0,L.isNonEmptyArray)(be))return[];if(be.length!==de.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Pe=[];for(let pe=0;pe<de.length;pe++){const De=[];Pe.push(De);let ke=de[pe],je=be[pe];for(;;){if(!je.range.contains(ke))throw new Error("INVALID selection range, must contain the previous range");if(De.push(k.SelectionRange.from(je)),!je.parent)break;ke=je.range,je=je.parent}}return Pe}}class se{constructor(O,H){this.f=O,this.g=H,this.d=new m.IdGenerator(""),this.e=new Map}async prepareSession(O,H,x){const Y=this.f.getDocument(O),de=k.Position.to(H),be=await this.g.prepareCallHierarchy(Y,de,x);if(!be)return;const Pe=this.d.nextId();return this.e.set(Pe,new Map),Array.isArray(be)?be.map(pe=>this.h(Pe,pe)):[this.h(Pe,be)]}async provideCallsTo(O,H,x){const Y=this.j(O,H);if(!Y)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyIncomingCalls(Y,x);if(!!de)return de.map(be=>({from:this.h(O,be.from),fromRanges:be.fromRanges.map(Pe=>k.Range.from(Pe))}))}async provideCallsFrom(O,H,x){const Y=this.j(O,H);if(!Y)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyOutgoingCalls(Y,x);if(!!de)return de.map(be=>({to:this.h(O,be.to),fromRanges:be.fromRanges.map(Pe=>k.Range.from(Pe))}))}releaseSession(O){this.e.delete(O)}h(O,H){const x=this.e.get(O),Y=k.CallHierarchyItem.from(H,O,x.size.toString(36));return x.set(Y._itemId,H),Y}j(O,H){return this.e.get(O)?.get(H)}}class le{constructor(O,H){this.f=O,this.g=H,this.d=new m.IdGenerator(""),this.e=new Map}async prepareSession(O,H,x){const Y=this.f.getDocument(O),de=k.Position.to(H),be=await this.g.prepareTypeHierarchy(Y,de,x);if(!be)return;const Pe=this.d.nextId();return this.e.set(Pe,new Map),Array.isArray(be)?be.map(pe=>this.h(Pe,pe)):[this.h(Pe,be)]}async provideSupertypes(O,H,x){const Y=this.j(O,H);if(!Y)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySupertypes(Y,x);if(!!de)return de.map(be=>this.h(O,be))}async provideSubtypes(O,H,x){const Y=this.j(O,H);if(!Y)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySubtypes(Y,x);if(!!de)return de.map(be=>this.h(O,be))}releaseSession(O){this.e.delete(O)}h(O,H){const x=this.e.get(O),Y=k.TypeHierarchyItem.from(H,O,x.size.toString(36));return x.set(Y._itemId,H),Y}j(O,H){return this.e.get(O)?.get(H)}}class ue{constructor(O,H,x,Y){this.d=O,this.e=H,this.f=x,this.g=Y}async provideDocumentOnDropEdits(O,H,x,Y,de){const be=this.e.getDocument(H),Pe=k.Position.to(x),pe=k.DataTransfer.toDataTransfer(Y,async ke=>(await this.d.$resolveDocumentOnDropFileData(this.g,O,ke)).buffer),De=await this.f.provideDocumentDropEdits(be,Pe,pe,de);if(!!De)return{insertText:typeof De.insertText=="string"?De.insertText:{snippet:De.insertText.value},additionalEdit:De.additionalEdit?k.WorkspaceEdit.from(De.additionalEdit,void 0):void 0}}}class ee{constructor(O,H){this.adapter=O,this.extension=H}}class ae{constructor(O,H,x,Y,de,be,Pe,pe){this.g=H,this.h=x,this.j=Y,this.k=de,this.l=be,this.m=Pe,this.n=pe,this.f=new Map,this.e=O.getProxy(A.MainContext.MainThreadLanguageFeatures)}o(O){return k.DocumentSelector.from(O,this.g)}p(O){return new R.Disposable(()=>{this.f.delete(O),this.e.$unregister(O)})}q(){return ae.d++}async s(O,H,x,Y,de,be=!1){const Pe=this.f.get(O);if(!Pe||!(Pe.adapter instanceof H))return Y;const pe=Date.now();be||this.l.trace(`[${Pe.extension.identifier.value}] INVOKE provider '${x.toString().replace(/[\r\n]/g,"")}'`);const De=x(Pe.adapter,Pe.extension);return Promise.resolve(De).catch(ke=>{(0,g.isCancellationError)(ke)||(this.l.error(`[${Pe.extension.identifier.value}] provider FAILED`),this.l.error(ke),this.n.onExtensionError(Pe.extension.identifier,ke))}).finally(()=>{be||this.l.trace(`[${Pe.extension.identifier.value}] provider DONE after ${Date.now()-pe}ms`)}),D.CancellationToken.isCancellationToken(de)?(0,p.raceCancellationError)(De,de):De}t(O,H){const x=this.q();return this.f.set(x,new ee(O,H)),x}static u(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,H,x,Y){const de=this.t(new i(this.h,x),O),be=Y&&Y.label||ae.u(O);return this.e.$registerDocumentSymbolProvider(de,this.o(H),be),this.p(de)}$provideDocumentSymbols(O,H,x){return this.s(O,i,Y=>Y.provideDocumentSymbols(o.URI.revive(H),x),void 0,x)}registerCodeLensProvider(O,H,x){const Y=this.q(),de=typeof x.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Y,new ee(new s(this.h,this.j.converter,x),O)),this.e.$registerCodeLensSupport(Y,this.o(H),de);let be=this.p(Y);if(de!==void 0){const Pe=x.onDidChangeCodeLenses(pe=>this.e.$emitCodeLensEvent(de));be=R.Disposable.from(be,Pe)}return be}$provideCodeLenses(O,H,x){return this.s(O,s,Y=>Y.provideCodeLenses(o.URI.revive(H),x),void 0,x)}$resolveCodeLens(O,H,x){return this.s(O,s,Y=>Y.resolveCodeLens(H,x),void 0,void 0)}$releaseCodeLenses(O,H){this.s(O,s,x=>Promise.resolve(x.releaseCodeLenses(H)),void 0,void 0)}registerDefinitionProvider(O,H,x){const Y=this.t(new u(this.h,x),O);return this.e.$registerDefinitionSupport(Y,this.o(H)),this.p(Y)}$provideDefinition(O,H,x,Y){return this.s(O,u,de=>de.provideDefinition(o.URI.revive(H),x,Y),[],Y)}registerDeclarationProvider(O,H,x){const Y=this.t(new c(this.h,x),O);return this.e.$registerDeclarationSupport(Y,this.o(H)),this.p(Y)}$provideDeclaration(O,H,x,Y){return this.s(O,c,de=>de.provideDeclaration(o.URI.revive(H),x,Y),[],Y)}registerImplementationProvider(O,H,x){const Y=this.t(new l(this.h,x),O);return this.e.$registerImplementationSupport(Y,this.o(H)),this.p(Y)}$provideImplementation(O,H,x,Y){return this.s(O,l,de=>de.provideImplementation(o.URI.revive(H),x,Y),[],Y)}registerTypeDefinitionProvider(O,H,x){const Y=this.t(new n(this.h,x),O);return this.e.$registerTypeDefinitionSupport(Y,this.o(H)),this.p(Y)}$provideTypeDefinition(O,H,x,Y){return this.s(O,n,de=>de.provideTypeDefinition(o.URI.revive(H),x,Y),[],Y)}registerHoverProvider(O,H,x,Y){const de=this.t(new r(this.h,x),O);return this.e.$registerHoverProvider(de,this.o(H)),this.p(de)}$provideHover(O,H,x,Y){return this.s(O,r,de=>de.provideHover(o.URI.revive(H),x,Y),void 0,Y)}registerEvaluatableExpressionProvider(O,H,x,Y){const de=this.t(new f(this.h,x),O);return this.e.$registerEvaluatableExpressionProvider(de,this.o(H)),this.p(de)}$provideEvaluatableExpression(O,H,x,Y){return this.s(O,f,de=>de.provideEvaluatableExpression(o.URI.revive(H),x,Y),void 0,Y)}registerInlineValuesProvider(O,H,x,Y){const de=typeof x.onDidChangeInlineValues=="function"?this.q():void 0,be=this.t(new E(this.h,x),O);this.e.$registerInlineValuesProvider(be,this.o(H),de);let Pe=this.p(be);if(de!==void 0){const pe=x.onDidChangeInlineValues(De=>this.e.$emitInlineValuesEvent(de));Pe=R.Disposable.from(Pe,pe)}return Pe}$provideInlineValues(O,H,x,Y,de){return this.s(O,E,be=>be.provideInlineValues(o.URI.revive(H),x,Y,de),void 0,de)}registerDocumentHighlightProvider(O,H,x){const Y=this.t(new T(this.h,x),O);return this.e.$registerDocumentHighlightProvider(Y,this.o(H)),this.p(Y)}$provideDocumentHighlights(O,H,x,Y){return this.s(O,T,de=>de.provideDocumentHighlights(o.URI.revive(H),x,Y),void 0,Y)}registerLinkedEditingRangeProvider(O,H,x){const Y=this.t(new M(this.h,x),O);return this.e.$registerLinkedEditingRangeProvider(Y,this.o(H)),this.p(Y)}$provideLinkedEditingRanges(O,H,x,Y){return this.s(O,M,async de=>{const be=await de.provideLinkedEditingRanges(o.URI.revive(H),x,Y);if(be)return{ranges:be.ranges,wordPattern:be.wordPattern?ae.w(be.wordPattern):void 0}},void 0,Y)}registerReferenceProvider(O,H,x){const Y=this.t(new G(this.h,x),O);return this.e.$registerReferenceSupport(Y,this.o(H)),this.p(Y)}$provideReferences(O,H,x,Y,de){return this.s(O,G,be=>be.provideReferences(o.URI.revive(H),x,Y,de),void 0,de)}registerCodeActionProvider(O,H,x,Y){const de=new v.DisposableStore,be=this.t(new V(this.h,this.j.converter,this.k,x,this.l,O,this.m),O);return this.e.$registerQuickFixSupport(be,this.o(H),{providedKinds:Y?.providedCodeActionKinds?.map(Pe=>Pe.value),documentation:Y?.documentation?.map(Pe=>({kind:Pe.kind.value,command:this.j.converter.toInternal(Pe.command,de)}))},ae.u(O),Boolean(x.resolveCodeAction)),de.add(this.p(be)),de}$provideCodeActions(O,H,x,Y,de){return this.s(O,V,be=>be.provideCodeActions(o.URI.revive(H),x,Y,de),void 0,de)}$resolveCodeAction(O,H,x){return this.s(O,V,Y=>Y.resolveCodeAction(H,x),void 0,void 0)}$releaseCodeActions(O,H){this.s(O,V,x=>Promise.resolve(x.releaseCodeActions(H)),void 0,void 0)}registerDocumentFormattingEditProvider(O,H,x){const Y=this.t(new U(this.h,x),O);return this.e.$registerDocumentFormattingSupport(Y,this.o(H),O.identifier,O.displayName||O.name),this.p(Y)}$provideDocumentFormattingEdits(O,H,x,Y){return this.s(O,U,de=>de.provideDocumentFormattingEdits(o.URI.revive(H),x,Y),void 0,Y)}registerDocumentRangeFormattingEditProvider(O,H,x){const Y=this.t(new F(this.h,x),O);return this.e.$registerRangeFormattingSupport(Y,this.o(H),O.identifier,O.displayName||O.name),this.p(Y)}$provideDocumentRangeFormattingEdits(O,H,x,Y,de){return this.s(O,F,be=>be.provideDocumentRangeFormattingEdits(o.URI.revive(H),x,Y,de),void 0,de)}registerOnTypeFormattingEditProvider(O,H,x,Y){const de=this.t(new z(this.h,x),O);return this.e.$registerOnTypeFormattingSupport(de,this.o(H),Y,O.identifier),this.p(de)}$provideOnTypeFormattingEdits(O,H,x,Y,de,be){return this.s(O,z,Pe=>Pe.provideOnTypeFormattingEdits(o.URI.revive(H),x,Y,de,be),void 0,be)}registerWorkspaceSymbolProvider(O,H){const x=this.t(new B(H,this.l),O);return this.e.$registerNavigateTypeSupport(x,typeof H.resolveWorkspaceSymbol=="function"),this.p(x)}$provideWorkspaceSymbols(O,H,x){return this.s(O,B,Y=>Y.provideWorkspaceSymbols(H,x),{symbols:[]},x)}$resolveWorkspaceSymbol(O,H,x){return this.s(O,B,Y=>Y.resolveWorkspaceSymbol(H,x),void 0,void 0)}$releaseWorkspaceSymbols(O,H){this.s(O,B,x=>x.releaseWorkspaceSymbols(H),void 0,void 0)}registerRenameProvider(O,H,x){const Y=this.t(new W(this.h,x,this.l),O);return this.e.$registerRenameSupport(Y,this.o(H),W.supportsResolving(x)),this.p(Y)}$provideRenameEdits(O,H,x,Y,de){return this.s(O,W,be=>be.provideRenameEdits(o.URI.revive(H),x,Y,de),void 0,de)}$resolveRenameLocation(O,H,x,Y){return this.s(O,W,de=>de.resolveRenameLocation(o.URI.revive(H),x,Y),void 0,Y)}registerDocumentSemanticTokensProvider(O,H,x,Y){const de=this.t(new q(this.h,x),O),be=typeof x.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(de,this.o(H),Y,be);let Pe=this.p(de);if(be){const pe=x.onDidChangeSemanticTokens(De=>this.e.$emitDocumentSemanticTokensEvent(be));Pe=R.Disposable.from(Pe,pe)}return Pe}$provideDocumentSemanticTokens(O,H,x,Y){return this.s(O,q,de=>de.provideDocumentSemanticTokens(o.URI.revive(H),x,Y),null,Y)}$releaseDocumentSemanticTokens(O,H){this.s(O,q,x=>x.releaseDocumentSemanticColoring(H),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(O,H,x,Y){const de=this.t(new _(this.h,x),O);return this.e.$registerDocumentRangeSemanticTokensProvider(de,this.o(H),Y),this.p(de)}$provideDocumentRangeSemanticTokens(O,H,x,Y){return this.s(O,_,de=>de.provideDocumentRangeSemanticTokens(o.URI.revive(H),x,Y),null,Y)}registerCompletionItemProvider(O,H,x,Y){const de=this.t(new Q(this.h,this.j.converter,x,this.m,O),O);return this.e.$registerCompletionsProvider(de,this.o(H),Y,Q.supportsResolving(x),`${O.identifier.value}(${Y.join("")})`),this.p(de)}$provideCompletionItems(O,H,x,Y,de){return this.s(O,Q,be=>be.provideCompletionItems(o.URI.revive(H),x,Y,de),void 0,de)}$resolveCompletionItem(O,H,x){return this.s(O,Q,Y=>Y.resolveCompletionItem(H,x),void 0,x)}$releaseCompletionItems(O,H){this.s(O,Q,x=>x.releaseCompletionItems(H),void 0,void 0)}registerInlineCompletionsProvider(O,H,x){const Y=new ge(O,this.h,x,this.j.converter),de=this.t(Y,O);return this.e.$registerInlineCompletionsSupport(de,this.o(H),Y.supportsHandleDidShowCompletionItem),this.p(de)}$provideInlineCompletions(O,H,x,Y,de){return this.s(O,Z,be=>be.provideInlineCompletions(o.URI.revive(H),x,Y,de),void 0,de)}$handleInlineCompletionDidShow(O,H,x){this.s(O,Z,async Y=>{Y.handleDidShowCompletionItem(H,x)},void 0,void 0)}$freeInlineCompletionsList(O,H){this.s(O,Z,async x=>{x.disposeCompletions(H)},void 0,void 0)}registerSignatureHelpProvider(O,H,x,Y){const de=Array.isArray(Y)?{triggerCharacters:Y,retriggerCharacters:[]}:Y,be=this.t(new J(this.h,x),O);return this.e.$registerSignatureHelpProvider(be,this.o(H),de),this.p(be)}$provideSignatureHelp(O,H,x,Y,de){return this.s(O,J,be=>be.provideSignatureHelp(o.URI.revive(H),x,Y,de),void 0,de)}$releaseSignatureHelp(O,H){this.s(O,J,x=>x.releaseSignatureHelp(H),void 0,void 0)}registerInlayHintsProvider(O,H,x){const Y=typeof x.onDidChangeInlayHints=="function"?this.q():void 0,de=this.t(new fe(this.h,this.j.converter,x,this.l,O),O);this.e.$registerInlayHintsProvider(de,this.o(H),typeof x.resolveInlayHint=="function",Y,ae.u(O));let be=this.p(de);if(Y!==void 0){const Pe=x.onDidChangeInlayHints(pe=>this.e.$emitInlayHintsEvent(Y));be=R.Disposable.from(be,Pe)}return be}$provideInlayHints(O,H,x,Y){return this.s(O,fe,de=>de.provideInlayHints(o.URI.revive(H),x,Y),void 0,Y)}$resolveInlayHint(O,H,x){return this.s(O,fe,Y=>Y.resolveInlayHint(H,x),void 0,x)}$releaseInlayHints(O,H){this.s(O,fe,x=>x.releaseHints(H),void 0,void 0)}registerDocumentLinkProvider(O,H,x){const Y=this.t(new ve(this.h,x),O);return this.e.$registerDocumentLinkProvider(Y,this.o(H),typeof x.resolveDocumentLink=="function"),this.p(Y)}$provideDocumentLinks(O,H,x){return this.s(O,ve,Y=>Y.provideLinks(o.URI.revive(H),x),void 0,x,H.scheme==="output")}$resolveDocumentLink(O,H,x){return this.s(O,ve,Y=>Y.resolveLink(H,x),void 0,void 0,!0)}$releaseDocumentLinks(O,H){this.s(O,ve,x=>x.releaseLinks(H),void 0,void 0,!0)}registerColorProvider(O,H,x){const Y=this.t(new Ee(this.h,x),O);return this.e.$registerDocumentColorProvider(Y,this.o(H)),this.p(Y)}$provideDocumentColors(O,H,x){return this.s(O,Ee,Y=>Y.provideColors(o.URI.revive(H),x),[],x)}$provideColorPresentations(O,H,x,Y){return this.s(O,Ee,de=>de.provideColorPresentations(o.URI.revive(H),x,Y),void 0,Y)}registerFoldingRangeProvider(O,H,x){const Y=this.q(),de=typeof x.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Y,new ee(new Ae(this.h,x),O)),this.e.$registerFoldingRangeProvider(Y,this.o(H),O.identifier,de);let be=this.p(Y);if(de!==void 0){const Pe=x.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(de));be=R.Disposable.from(be,Pe)}return be}$provideFoldingRanges(O,H,x,Y){return this.s(O,Ae,de=>de.provideFoldingRanges(o.URI.revive(H),x,Y),void 0,Y)}registerSelectionRangeProvider(O,H,x){const Y=this.t(new Fe(this.h,x,this.l),O);return this.e.$registerSelectionRangeProvider(Y,this.o(H)),this.p(Y)}$provideSelectionRanges(O,H,x,Y){return this.s(O,Fe,de=>de.provideSelectionRanges(o.URI.revive(H),x,Y),[],Y)}registerCallHierarchyProvider(O,H,x){const Y=this.t(new se(this.h,x),O);return this.e.$registerCallHierarchyProvider(Y,this.o(H)),this.p(Y)}$prepareCallHierarchy(O,H,x,Y){return this.s(O,se,de=>Promise.resolve(de.prepareSession(o.URI.revive(H),x,Y)),void 0,Y)}$provideCallHierarchyIncomingCalls(O,H,x,Y){return this.s(O,se,de=>de.provideCallsTo(H,x,Y),void 0,Y)}$provideCallHierarchyOutgoingCalls(O,H,x,Y){return this.s(O,se,de=>de.provideCallsFrom(H,x,Y),void 0,Y)}$releaseCallHierarchy(O,H){this.s(O,se,x=>Promise.resolve(x.releaseSession(H)),void 0,void 0)}registerTypeHierarchyProvider(O,H,x){const Y=this.t(new le(this.h,x),O);return this.e.$registerTypeHierarchyProvider(Y,this.o(H)),this.p(Y)}$prepareTypeHierarchy(O,H,x,Y){return this.s(O,le,de=>Promise.resolve(de.prepareSession(o.URI.revive(H),x,Y)),void 0,Y)}$provideTypeHierarchySupertypes(O,H,x,Y){return this.s(O,le,de=>de.provideSupertypes(H,x,Y),void 0,Y)}$provideTypeHierarchySubtypes(O,H,x,Y){return this.s(O,le,de=>de.provideSubtypes(H,x,Y),void 0,Y)}$releaseTypeHierarchy(O,H){this.s(O,le,x=>Promise.resolve(x.releaseSession(H)),void 0,void 0)}registerDocumentOnDropEditProvider(O,H,x){const Y=this.q();return this.f.set(Y,new ee(new ue(this.e,this.h,x,Y),O)),this.e.$registerDocumentOnDropEditProvider(Y,this.o(H)),this.p(Y)}$provideDocumentOnDropEdits(O,H,x,Y,de,be){return this.s(O,ue,Pe=>Promise.resolve(Pe.provideDocumentOnDropEdits(H,o.URI.revive(x),Y,de,be)),void 0,void 0)}registerDocumentPasteEditProvider(O,H,x,Y){const de=this.q();return this.f.set(de,new ee(new N(this.e,this.h,x,de),O)),this.e.$registerPasteEditProvider(de,this.o(H),!!x.prepareDocumentPaste,Y.pasteMimeTypes),this.p(de)}$prepareDocumentPaste(O,H,x,Y,de){return this.s(O,N,be=>be.prepareDocumentPaste(o.URI.revive(H),x,Y,de),void 0,de)}$providePasteEdits(O,H,x,Y,de,be){return this.s(O,N,Pe=>Pe.providePasteEdits(H,o.URI.revive(x),Y,de,be),void 0,be)}static w(O){return{pattern:O.source,flags:(0,S.regExpFlags)(O)}}static y(O){return{decreaseIndentPattern:ae.w(O.decreaseIndentPattern),increaseIndentPattern:ae.w(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?ae.w(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?ae.w(O.unIndentedLinePattern):void 0}}static z(O){return{beforeText:ae.w(O.beforeText),afterText:O.afterText?ae.w(O.afterText):void 0,previousLineText:O.previousLineText?ae.w(O.previousLineText):void 0,action:O.action}}static B(O){return O.map(ae.z)}setLanguageConfiguration(O,H,x){const{wordPattern:Y}=x;if(Y&&(0,S.regExpLeadsToEndlessLoop)(Y))throw new Error(`Invalid language configuration: wordPattern '${Y}' is not allowed to match the empty string.`);Y?this.h.setWordDefinitionFor(H,Y):this.h.setWordDefinitionFor(H,void 0),x.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),x.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",O,"Do not use.");const de=this.q(),be={comments:x.comments,brackets:x.brackets,wordPattern:x.wordPattern?ae.w(x.wordPattern):void 0,indentationRules:x.indentationRules?ae.y(x.indentationRules):void 0,onEnterRules:x.onEnterRules?ae.B(x.onEnterRules):void 0,__electricCharacterSupport:x.__electricCharacterSupport,__characterPairSupport:x.__characterPairSupport};return this.e.$setLanguageConfiguration(de,H,be),this.p(de)}$setWordDefinitions(O){for(const H of O)this.h.setWordDefinitionFor(H.languageId,new RegExp(H.regexSource,H.regexFlags))}}e.ExtHostLanguageFeatures=ae,ae.d=0}),define(ye[256],Ce([1,0,5,14,7,43,16,6]),function(ne,e,o,t,k,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(L,P,y,D){this.c=P,this.d=y,this.e=D,this.b=[],this.f=0,this.g=new Set,this.a=L.getProxy(o.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this.b=L}async getLanguages(){return this.b.slice(0)}async changeLanguage(L,P){await this.a.$changeLanguage(L,P);const y=this.c.getDocumentData(L);if(!y)throw new Error(`document '${L.toString()}' NOT found`);return y.document}async tokenAtPosition(L,P){const y=L.version,D=t.Position.from(P),v=await this.a.$tokensAtPosition(L.uri,D),d={type:k.StandardTokenType.Other,range:L.getWordRangeAtPosition(P)??new k.Range(P.line,P.character,P.line,P.character)};if(!v)return d;const m={range:t.Range.to(v.range),type:t.TokenType.to(v.type)};return!m.range.contains(P)||y!==L.version?d:m}createLanguageStatusItem(L,P,y){const D=this.f++,v=this.a,d=this.g,m=`${L.identifier.value}/${P}`;if(d.has(m))throw new Error(`LanguageStatusItem with id '${P}' ALREADY exists`);d.add(m);const h={selector:y,id:P,name:L.displayName??L.name,severity:k.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let w;const g=new A.DisposableStore,p=()=>{w?.dispose(),w=(0,I.disposableTimeout)(()=>{g.clear(),this.a.$setLanguageStatus(D,{id:m,name:h.name??L.displayName??L.name,source:L.displayName??L.name,selector:t.DocumentSelector.from(h.selector,this.e),label:h.text,detail:h.detail??"",severity:h.severity===k.LanguageStatusSeverity.Error?R.default.Error:h.severity===k.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:h.command&&this.d.toInternal(h.command,g),accessibilityInfo:h.accessibilityInformation,busy:h.busy})},0)},b={dispose(){g.dispose(),w?.dispose(),v.$removeLanguageStatus(D),d.delete(m)},get id(){return h.id},get name(){return h.name},set name(i){h.name=i,p()},get selector(){return h.selector},set selector(i){h.selector=i,p()},get text(){return h.text},set text(i){h.text=i,p()},get detail(){return h.detail},set detail(i){h.detail=i,p()},get severity(){return h.severity},set severity(i){h.severity=i,p()},get accessibilityInformation(){return h.accessibilityInformation},set accessibilityInformation(i){h.accessibilityInformation=i,p()},get command(){return h.command},set command(i){h.command=i,p()},get busy(){return h.busy},set busy(i){h.busy=i,p()}};return p(),b}}e.ExtHostLanguages=S}),define(ye[96],Ce([1,0,12,8,2,3,13,5,25,17]),function(ne,e,o,t,k,R,I,A,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let L=class{constructor(y,D,v){this.f=v,this.d=new Map,this.a=D.getProxy(A.MainContext.MainThreadLocalization),this.b=y.environment.appLanguage,this.c=this.b===o.LANGUAGE_DEFAULT}getMessage(y,D){const{message:v,args:d,comment:m}=D;if(this.c)return(0,t.format2)(v,d??{});let h=v;m&&m.length>0&&(h+=`/${Array.isArray(m)?m.join():m}`);const w=this.d.get(y)?.contents[h];return w||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${h}`),(0,t.format2)(w??v,d??{})}getBundle(y){return this.d.get(y)?.contents}getBundleUri(y){return this.d.get(y)?.uri}async initializeLocalizedMessages(y){if(this.c||!y.l10n&&!y.isBuiltin||this.d.has(y.identifier.value))return;let D;const v=await this.g(y);if(!v){this.f.error(`No bundle location found for extension ${y.identifier.value}`);return}try{const d=await this.a.$fetchBundleContents(v),m=JSON.parse(d);D=y.isBuiltin?m.contents?.bundle:m}catch(d){this.f.error(`Failed to load translations for ${y.identifier.value} from ${v}: ${d.message}`);return}D&&this.d.set(y.identifier.value,{contents:D,uri:v})}async g(y){if(y.isBuiltin){const D=await this.a.$fetchBuiltInBundleUri(y.identifier.value);return k.URI.revive(D)}return y.l10n?k.URI.joinPath(y.extensionLocation,y.l10n,`bundle.l10n.${this.b}.json`):void 0}};L=qe([He(0,S.IExtHostInitDataService),He(1,C.IExtHostRpcService),He(2,I.ILogService)],L),e.ExtHostLocalizationService=L,e.IExtHostLocalizationService=(0,R.createDecorator)("IExtHostLocalizationService")}),define(ye[140],Ce([1,0,13,5,25,17,2,4,11]),function(ne,e,o,t,k,R,I,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let C=class extends o.AbstractLoggerService{constructor(y,D){super(D.logLevel,A.Event.None),this.g=y.getProxy(t.MainContext.MainThreadLogger)}$setLevel(y,D){D?this.setLevel(I.URI.revive(D),y):(0,S.isUndefined)(y)||this.setLevel(y)}f(y,D,v){return new L(this.g,y,D,v)}};C=qe([He(0,R.IExtHostRpcService),He(1,k.IExtHostInitDataService)],C),e.ExtHostLoggerService=C;class L extends o.AbstractMessageLogger{constructor(y,D,v,d){super(d?.always),this.m=y,this.n=D,this.k=!1,this.l=[],this.setLevel(v),this.m.$createLogger(D,d).then(()=>{this.r(this.l),this.k=!0})}g(y,D){const v=[[y,D]];this.k?this.r(v):this.l.push(...v)}r(y){this.m.$log(this.n,y)}}}),define(ye[257],Ce([1,0,5,13,27]),function(ne,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function R(A){return A&&A.title}let I=class{constructor(S,C){this.b=C,this.a=S.getProxy(o.MainContext.MainThreadMessageService)}showMessage(S,C,L,P,y){const D={source:{identifier:S.identifier,label:S.displayName||S.name}};let v;typeof P=="string"||R(P)?v=[P,...y]:(D.modal=P?.modal,D.useCustom=P?.useCustom,D.detail=P?.detail,v=y),D.useCustom&&(0,k.checkProposedApiEnabled)(S,"resolvers");const d=[];for(let m=0;m<v.length;m++){const h=v[m];if(typeof h=="string")d.push({title:h,handle:m,isCloseAffordance:!1});else if(typeof h=="object"){const{title:w,isCloseAffordance:g}=h;d.push({title:w,isCloseAffordance:!!g,handle:m})}else this.b.warn("Invalid message item:",h)}return this.a.$showMessage(C,L,D,d).then(m=>{if(typeof m=="number")return v[m]})}};I=qe([He(1,t.ILogService)],I),e.ExtHostMessageService=I}),define(ye[258],Ce([1,0,22,4,6,28,8,11,2,69,5,39,14,7,57,233,136]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y,D,v,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class h{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(g=>g.apiEditor)}constructor(g,p,b,i){this.q=b,this.r=i,this.f=new Map,this.g=new R.ResourceMap,this.h=new Map,this.j=new t.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new t.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new t.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new C.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=g.getProxy(L.MainContext.MainThreadNotebook),this.c=g.getProxy(L.MainContext.MainThreadNotebookDocuments),this.d=g.getProxy(L.MainContext.MainThreadNotebookEditors),this.i=p.converter,p.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===13){const a=s.notebookEditor?.notebookUri,u=s.cell.handle,l=this.g.get(a)?.getCell(u);if(l)return l.apiCell}if(s&&s.$mid===14){const a=s.uri,u=this.g.get(a);if(u)return u.apiNotebook}return s}}),h.x(p)}getEditorById(g){const p=this.h.get(g);if(!p)throw new Error(`unknown text editor: ${g}. known editors: ${[...this.h.keys()]} `);return p}getIdByEditor(g){for(const[p,b]of this.h)if(b.apiEditor===g)return p}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(g,p){const b=this.g.get(g);if(!b&&!p)throw new Error(`NO notebook document for '${g}'`);return b}static s(g,p){if(!p)return;const b=p.filenamePattern.map(i=>y.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(p.filenamePattern&&!b){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:g.identifier,providerDisplayName:g.displayName||g.name,displayName:p.displayName,filenamePattern:b,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider(g,p,b){const i=h.a++,s=typeof b.onDidChangeCellStatusBarItems=="function"?h.a++:void 0;this.f.set(i,b),this.b.$registerNotebookCellStatusBarItemProvider(i,s,p);let a;return s!==void 0&&(a=b.onDidChangeCellStatusBarItems(u=>this.b.$emitCellStatusBarEvent(s))),new D.Disposable(()=>{this.f.delete(i),this.b.$unregisterNotebookCellStatusBarItemProvider(i,s),a?.dispose()})}async createNotebookDocument(g){const p=await this.c.$tryCreateNotebook({viewType:g.viewType,content:g.content&&y.NotebookData.from(g.content)});return S.URI.revive(p)}async openNotebookDocument(g){const p=this.g.get(g);if(p)return p.apiNotebook;const b=await this.c.$tryOpenNotebook(g),i=this.g.get(S.URI.revive(b));return(0,A.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(g,p){S.URI.isUri(g)&&(g=await this.openNotebookDocument(g));let b;typeof p=="object"?b={position:y.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(y.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:b={preserveFocus:!1};const i=await this.d.$tryShowNotebookDocument(g.uri,g.notebookType,b),s=i&&this.h.get(i)?.apiEditor;if(s)return s;throw i?new Error(`Could NOT open editor for "${g.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${g.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(g,p,b,i){const s=this.f.get(g),a=S.URI.revive(p),u=this.g.get(a);if(!u||!s)return;const c=u.getCellFromIndex(b);if(!c)return;const l=await s.provideCellStatusBarItems(c.apiCell,i);if(!l)return;const n=new k.DisposableStore,r=this.p.add([n]),E=(Array.isArray(l)?l:[l]).map(T=>y.NotebookStatusBarItem.from(T,this.i,n));return{cacheId:r,items:E}}$releaseNotebookCellStatusBarItems(g){this.p.delete(g)}registerNotebookSerializer(g,p,b,i,s){if((0,I.isFalsyOrWhitespace)(p))throw new Error("viewType cannot be empty or just whitespace");const a=this.t++;return this.u.set(a,b),this.b.$registerNotebookSerializer(a,{id:g.identifier,location:g.extensionLocation},p,y.NotebookDocumentContentOptions.from(i),h.s(g,s)),(0,k.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(a)})}async $dataToNotebook(g,p,b){const i=this.u.get(g);if(!i)throw new Error("NO serializer found");const s=await i.deserializeNotebook(p.buffer,b);return new v.SerializableObjectWithBuffers(y.NotebookData.from(s))}async $notebookToData(g,p,b){const i=this.u.get(g);if(!i)throw new Error("NO serializer found");const s=await i.serializeNotebook(y.NotebookData.to(p.value),b);return o.VSBuffer.wrap(s)}w(g,p,b){if(this.h.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const i=new m.ExtHostNotebookEditor(p,this.d,g,b.visibleRanges.map(y.NotebookRange.to),b.selections.map(y.NotebookRange.to),typeof b.viewColumn=="number"?y.ViewColumn.to(b.viewColumn):void 0);this.h.set(p,i)}$acceptDocumentAndEditorsDelta(g){if(g.value.removedDocuments)for(const b of g.value.removedDocuments){const i=S.URI.revive(b),s=this.g.get(i);s&&(s.dispose(),this.g.delete(i),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:s.apiNotebook.getCells().map(a=>a.document.uri)}),this.n.fire(s.apiNotebook));for(const a of this.h.values())a.notebookData.uri.toString()===i.toString()&&this.h.delete(a.id)}if(g.value.addedDocuments){const b=[];for(const i of g.value.addedDocuments){const s=S.URI.revive(i.uri);if(this.g.has(s))throw new Error(`adding EXISTING notebook ${s} `);const a=new d.ExtHostNotebookDocument(this.c,this.q,this.r,s,i);b.push(...i.cells.map(u=>d.ExtHostCell.asModelAddData(a.apiNotebook,u))),this.g.get(s)?.dispose(),this.g.set(s,a),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:b}),this.m.fire(a.apiNotebook)}}if(g.value.addedEditors)for(const b of g.value.addedEditors){if(this.h.has(b.id))return;const i=S.URI.revive(b.documentUri),s=this.g.get(i);s&&this.w(s,b.id,b)}const p=[];if(g.value.removedEditors)for(const b of g.value.removedEditors){const i=this.h.get(b);i&&(this.h.delete(b),this.k?.id===i.id&&(this.k=void 0),p.push(i))}if(g.value.visibleEditors){this.l=g.value.visibleEditors.map(i=>this.h.get(i)).filter(i=>!!i);const b=new Set;this.l.forEach(i=>b.add(i.id));for(const i of this.h.values()){const s=b.has(i.id);i._acceptVisibility(s)}this.l=[...this.h.values()].map(i=>i).filter(i=>i.visible),this.o.fire(this.visibleNotebookEditors)}g.value.newActiveEditor===null?this.k=void 0:g.value.newActiveEditor&&(this.k=this.h.get(g.value.newActiveEditor)),g.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(g){const p=P.ApiCommandArgument.String.with("notebookType","A notebook type"),b=new P.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[p,new P.ApiCommandArgument("data","Bytes to convert to data",s=>s instanceof Uint8Array,s=>o.VSBuffer.wrap(s))],new P.ApiCommandResult("Notebook Data",s=>y.NotebookData.to(s.value))),i=new P.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[p,new P.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",s=>!0,s=>new v.SerializableObjectWithBuffers(y.NotebookData.from(s)))],new P.ApiCommandResult("Bytes",s=>s.buffer));g.registerApiCommand(b),g.registerApiCommand(i)}}e.ExtHostNotebookController=h,h.a=0}),define(ye[259],Ce([1,0,18,16,21,4,6,28,2,26,13,69,5,39,14,7,93,221,27,57]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y,D,v,d,m,h,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let p=class{constructor(c,l,n,r,f){this.k=l,this.l=n,this.m=r,this.n=f,this.b=new A.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new P.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=c.getProxy(y.MainContext.MainThreadNotebookKernels);const E=new D.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new D.ApiCommandArgument("options","Select kernel options",T=>!0,T=>{if(T&&"notebookEditor"in T&&"id"in T){const M=this.l.getIdByEditor(T.notebookEditor);return{id:T.id,extension:T.extension,notebookEditorId:M}}else if(T&&"notebookEditor"in T){const M=this.l.getIdByEditor(T.notebookEditor);if(M===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${T.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:M}}return T})],D.ApiCommandResult.Void);this.m.registerApiCommand(E)}createNotebookController(c,l,n,r,f,E){for(const Z of this.h.values())if(Z.controller.id===l&&C.ExtensionIdentifier.equals(c.identifier,Z.extensionId))throw new Error(`notebook controller with id '${l}' ALREADY exist`);const T=this.i++,M=this;this.n.trace(`NotebookController[${T}], CREATED by ${c.identifier.value}, ${l}`);const G=()=>console.warn(`NO execute handler from notebook controller '${z.id}' of extension: '${c.identifier}'`);let V=!1;const N=new I.DisposableStore,U=new R.Emitter,F=new R.Emitter,z={id:a(c.identifier,l),notebookType:n,extensionId:c.identifier,extensionLocation:c.extensionLocation,label:r||c.identifier.value,preloads:E?E.map(v.NotebookRendererScript.from):[]};let B=f??G,W;this.a.$addKernel(T,z).catch(Z=>{console.log(Z),V=!0});let X=0;const q=()=>{if(V)return;const Z=++X;Promise.resolve().then(()=>{Z===X&&this.a.$updateKernel(T,z)})},_=new A.ResourceMap,Q={get id(){return l},get notebookType(){return z.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return z.label},set label(Z){z.label=Z??c.displayName??c.name,q()},get detail(){return z.detail??""},set detail(Z){z.detail=Z,q()},get description(){return z.description??""},set description(Z){z.description=Z,q()},get kind(){return(0,w.checkProposedApiEnabled)(c,"notebookControllerKind"),z.kind??""},set kind(Z){(0,w.checkProposedApiEnabled)(c,"notebookControllerKind"),z.kind=Z,q()},get supportedLanguages(){return z.supportedLanguages},set supportedLanguages(Z){z.supportedLanguages=Z,q()},get supportsExecutionOrder(){return z.supportsExecutionOrder??!1},set supportsExecutionOrder(Z){z.supportsExecutionOrder=Z,q()},get rendererScripts(){return z.preloads?z.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return B},set executeHandler(Z){B=Z??G},get interruptHandler(){return W},set interruptHandler(Z){W=Z,z.supportsInterrupt=Boolean(Z),q()},createNotebookCellExecution(Z){if(V)throw new Error("notebook controller is DISPOSED");if(!_.has(Z.notebook.uri))throw M.n.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(_.keys()).map(ge=>ge.toString())),new Error(`notebook controller is NOT associated to notebook: ${Z.notebook.uri.toString()}`);return M._createNotebookCellExecution(Z,a(c.identifier,this.id))},dispose:()=>{V||(this.n.trace(`NotebookController[${T}], DISPOSED`),V=!0,this.h.delete(T),N.dispose(),U.dispose(),F.dispose(),this.a.$removeKernel(T))},updateNotebookAffinity(Z,ge){ge===d.NotebookControllerAffinity2.Hidden&&(0,w.checkProposedApiEnabled)(c,"notebookControllerAffinityHidden"),M.a.$updateNotebookPriority(T,Z.uri,ge)},onDidReceiveMessage:F.event,postMessage(Z,ge){return(0,w.checkProposedApiEnabled)(c,"notebookMessaging"),M.a.$postMessage(T,ge&&M.l.getIdByEditor(ge),Z)},asWebviewUri(Z){return(0,w.checkProposedApiEnabled)(c,"notebookMessaging"),(0,m.asWebviewUri)(Z,M.k.remote)}};return this.h.set(T,{extensionId:c.identifier,controller:Q,onDidReceiveMessage:F,onDidChangeSelection:U,associatedNotebooks:_}),Q}getIdByController(c){for(const[l,n]of this.h)if(n.controller===c)return a(n.extensionId,c.id);return null}createNotebookControllerDetectionTask(c,l){const n=this.d++,r=this;this.n.trace(`NotebookControllerDetectionTask[${n}], CREATED by ${c.identifier.value}`),this.a.$addKernelDetectionTask(n,l);const f={dispose:()=>{this.c.delete(n),r.a.$removeKernelDetectionTask(n)}};return this.c.set(n,f),f}registerKernelSourceActionProvider(c,l,n){const r=this.f++,f=this;return this.e.set(r,n),this.n.trace(`NotebookKernelSourceActionProvider[${r}], CREATED by ${c.identifier.value}`),this.a.$addKernelSourceActionProvider(r,l),{dispose:()=>{this.e.delete(r),f.a.$removeKernelSourceActionProvider(r)}}}async $provideKernelSourceActions(c,l){const n=this.e.get(c);if(n){const r=new I.DisposableStore;return this.g.add([r]),(await n.provideNotebookKernelSourceActions(l)??[]).map(E=>v.NotebookKernelSourceAction.from(E,this.m.converter,r))}return[]}$acceptNotebookAssociation(c,l,n){const r=this.h.get(c);if(r){const f=this.l.getNotebookDocument(S.URI.revive(l));n?r.associatedNotebooks.set(f.uri,!0):r.associatedNotebooks.delete(f.uri),this.n.trace(`NotebookController[${c}] ASSOCIATE notebook`,f.uri.toString(),n),r.onDidChangeSelection.fire({selected:n,notebook:f.apiNotebook})}}async $executeCells(c,l,n){const r=this.h.get(c);if(!r)return;const f=this.l.getNotebookDocument(S.URI.revive(l)),E=[];for(const T of n){const M=f.getCell(T);M&&E.push(M.apiCell)}try{this.n.trace(`NotebookController[${c}] EXECUTE cells`,f.uri.toString(),E.length),await r.controller.executeHandler.call(r.controller,E,f.apiNotebook,r.controller)}catch(T){this.n.error(`NotebookController[${c}] execute cells FAILED`,T),console.error(T)}}async $cancelCells(c,l,n){const r=this.h.get(c);if(!r)return;const f=this.l.getNotebookDocument(S.URI.revive(l));if(r.controller.interruptHandler)await r.controller.interruptHandler.call(r.controller,f.apiNotebook);else for(const E of n){const T=f.getCell(E);T&&this.b.get(T.uri)?.cancel()}}$acceptKernelMessageFromRenderer(c,l,n){const r=this.h.get(c);if(!r)return;const f=this.l.getEditorById(l);r.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:n}))}$cellExecutionChanged(c,l,n){const f=this.l.getNotebookDocument(S.URI.revive(c)).getCell(l);if(f){const E=n?v.NotebookCellExecutionState.to(n):d.NotebookCellExecutionState.Idle;E!==void 0&&this.j.fire({cell:f.apiCell,state:E})}}_createNotebookCellExecution(c,l){if(c.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const r=this.l.getNotebookDocument(c.notebook.uri).getCellFromApiCell(c);if(!r)throw new Error("invalid cell");if(this.b.has(r.uri))throw new Error(`duplicate execution for ${r.uri}`);const f=new i(l,r,this.a);this.b.set(r.uri,f);const E=f.onDidChangeState(()=>{f.state===b.Resolved&&(f.dispose(),E.dispose(),this.b.delete(r.uri))});return f.asApiObject()}};p=qe([He(4,L.ILogService)],p),e.ExtHostNotebookKernels=p;var b;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(b||(b={}));class i extends I.Disposable{get state(){return this.f}constructor(c,l,n){super(),this.j=l,this.k=n,this.b=i.a++,this.c=new R.Emitter,this.onDidChangeState=this.c.event,this.f=b.Init,this.g=this.B(new k.CancellationTokenSource),this.h=new s(10,r=>this.m(r)),this.i=l.internalMetadata.executionOrder,this.k.$createExecution(this.b,c,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(c){await this.h.addItem(c)}async m(c){const l=Array.isArray(c)?c:[c];return this.k.$updateExecution(this.b,new g.SerializableObjectWithBuffers(l))}n(){if(this.f===b.Init)throw new Error("Must call start before modifying cell output");if(this.f===b.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(c){let l=this.j;if(c&&(l=this.j.notebook.getCellFromApiCell(c)),!l)throw new Error("INVALID cell");return l.handle}s(c){return c.map(l=>{const n=d.NotebookCellOutput.ensureUniqueMimeTypes(l.items,!0);return n===l.items?v.NotebookCellOutput.from(l):v.NotebookCellOutput.from({items:n,id:l.id,metadata:l.metadata})})}async t(c,l,n){const r=this.r(l),f=this.s((0,o.asArray)(c));return this.l({editType:h.CellExecutionUpdateType.Output,cellHandle:r,append:n,outputs:f})}async w(c,l,n){return c=d.NotebookCellOutput.ensureUniqueMimeTypes((0,o.asArray)(c),!0),this.l({editType:h.CellExecutionUpdateType.OutputItems,items:c.map(v.NotebookCellOutputItem.from),outputId:l.id,append:n})}asApiObject(){const c=this;return Object.freeze({get token(){return c.g.token},get cell(){return c.j.apiCell},get executionOrder(){return c.i},set executionOrder(n){c.i=n,c.m([{editType:h.CellExecutionUpdateType.ExecutionState,executionOrder:c.i}])},start(n){if(c.f===b.Resolved||c.f===b.Started)throw new Error("Cannot call start again");c.f=b.Started,c.c.fire(),c.m({editType:h.CellExecutionUpdateType.ExecutionState,runStartTime:n})},end(n,r){if(c.f===b.Resolved)throw new Error("Cannot call resolve twice");c.f=b.Resolved,c.c.fire(),c.h.flush(),c.k.$completeExecution(c.b,new g.SerializableObjectWithBuffers({runEndTime:r,lastRunSuccess:n}))},clearOutput(n){return c.n(),c.t([],n,!1)},appendOutput(n,r){return c.n(),c.t(n,r,!0)},replaceOutput(n,r){return c.n(),c.t(n,r,!1)},appendOutputItems(n,r){return c.n(),c.w(n,r,!0)},replaceOutputItems(n,r){return c.n(),c.w(n,r,!1)}})}}i.a=0;class s{constructor(c,l){this.d=c,this.e=l,this.a=[],this.b=Date.now()}addItem(c){return this.a.push(c),this.c||(this.c=new t.DeferredPromise,this.b=Date.now(),(0,t.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const c=this.c;this.c=void 0;const l=this.a;return this.a=[],this.e(l).finally(()=>c.complete())}}function a(u,c){return`${u.value}/${c}`}e.createKernelId=a}),define(ye[260],Ce([1,0,4,5,136]),function(ne,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class R{constructor(A,S){this.c=S,this.a=new Map,this.b=A.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(A,S,C){const L=this.c.getEditorById(A);this.a.get(S)?.fire({editor:L.apiEditor,message:C})}createRendererMessaging(A,S){if(!A.contributes?.notebookRenderer?.some(L=>L.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(L,P,y)=>this.d(S).event(L,P,y),postMessage:(L,P)=>{k.ExtHostNotebookEditor.apiEditorsToExtHost.has(L)&&([L,P]=[P,L]);const y=P&&k.ExtHostNotebookEditor.apiEditorsToExtHost.get(P);return this.b.$postMessage(y?.id,S,L)}}}d(A){let S=this.a.get(A);return S||(S=new o.Emitter({onDidRemoveLastListener:()=>{S?.dispose(),this.a.delete(A)}}),this.a.set(A,S),S)}}e.ExtHostNotebookRenderers=R}),define(ye[261],Ce([1,0,6,2,27,5]),function(ne,e,o,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class I{constructor(S){this.b=new Map,this.a=S.getProxy(R.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(S,C,L){if((0,k.checkProposedApiEnabled)(S,"profileContentHandlers"),this.b.has(C))throw new Error(`Handler with id '${C}' already registered`);return this.b.set(C,L),this.a.$registerProfileContentHandler(C,L.name,S.identifier.value),(0,o.toDisposable)(()=>{this.b.delete(C),this.a.$unregisterProfileContentHandler(C)})}async $saveProfile(S,C,L,P){const y=this.b.get(S);if(!y)throw new Error(`Unknown handler with id: ${S}`);return y.saveProfile(C,L,P)}async $readProfile(S,C,L){const P=this.b.get(S);if(!P)throw new Error(`Unknown handler with id: ${S}`);return P.readProfile(t.URI.revive(C),L)}}e.ExtHostProfileContentHandlers=I}),define(ye[262],Ce([1,0,21,4,6,5,2,7,10,18,43,90]),function(ne,e,o,t,k,R,I,A,S,C,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function y(D,v,d){const m=D.getProxy(R.MainContext.MainThreadQuickOpen);class h{constructor(c,l){this.e=new Map,this.f=0,this.a=c,this.b=l}showQuickPick(c,l,n=o.CancellationToken.None){this.c=void 0;const r=Promise.resolve(c),f=++this.f,E=m.$show(f,{title:l?.title,placeHolder:l?.placeHolder,matchOnDescription:l?.matchOnDescription,matchOnDetail:l?.matchOnDetail,ignoreFocusLost:l?.ignoreFocusOut,canPickMany:l?.canPickMany},n),T={},M=E.then(()=>T);return Promise.race([M,r]).then(G=>{if(G!==T)return r.then(V=>{const N=[];for(let U=0;U<V.length;U++){const F=V[U];typeof F=="string"?N.push({label:F,handle:U}):F.kind===A.QuickPickItemKind.Separator?N.push({type:"separator",label:F.label}):N.push({label:F.label,description:F.description,detail:F.detail,picked:F.picked,alwaysShow:F.alwaysShow,handle:U})}return l&&typeof l.onDidSelectItem=="function"&&(this.c=U=>{l.onDidSelectItem(V[U])}),m.$setItems(f,N),E.then(U=>{if(typeof U=="number")return V[U];if(Array.isArray(U))return U.map(F=>V[F])})})}).then(void 0,G=>{if(!(0,S.isCancellationError)(G))return m.$setError(f,G),Promise.reject(G)})}$onItemSelected(c){this.c?.(c)}showInput(c,l=o.CancellationToken.None){return this.d=c?.validateInput,m.$input(c,typeof this.d=="function",l).then(void 0,n=>{if(!(0,S.isCancellationError)(n))return Promise.reject(n)})}async $validateInput(c){if(!this.d)return;const l=await this.d(c);if(!l||typeof l=="string")return l;let n;switch(l.severity){case A.InputBoxValidationSeverity.Info:n=L.default.Info;break;case A.InputBoxValidationSeverity.Warning:n=L.default.Warning;break;case A.InputBoxValidationSeverity.Error:n=L.default.Error;break;default:n=l.message?L.default.Error:L.default.Ignore;break}return{content:l.message,severity:n}}async showWorkspaceFolderPick(c,l=o.CancellationToken.None){const n=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[c]);if(!n)return;const r=await this.a.getWorkspaceFolders2();if(!!r)return r.find(f=>f.uri.toString()===n.uri.toString())}createQuickPick(c){const l=new s(c,()=>this.e.delete(l._id));return this.e.set(l._id,l),l}createInputBox(c){const l=new a(c,()=>this.e.delete(l._id));return this.e.set(l._id,l),l}$onDidChangeValue(c,l){this.e.get(c)?._fireDidChangeValue(l)}$onDidAccept(c){this.e.get(c)?._fireDidAccept()}$onDidChangeActive(c,l){const n=this.e.get(c);n instanceof s&&n._fireDidChangeActive(l)}$onDidChangeSelection(c,l){const n=this.e.get(c);n instanceof s&&n._fireDidChangeSelection(l)}$onDidTriggerButton(c,l){this.e.get(c)?._fireDidTriggerButton(l)}$onDidTriggerItemButton(c,l,n){const r=this.e.get(c);r instanceof s&&r._fireDidTriggerItemButton(l,n)}$onDidHide(c){this.e.get(c)?._fireDidHide()}}class w{constructor(c,l){this.x=c,this.y=l,this._id=s.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new t.Emitter,this.q=new t.Emitter,this.r=new t.Emitter,this.s=new t.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(c){this.b=c,this.z({title:c})}get step(){return this.c}set step(c){this.c=c,this.z({step:c})}get totalSteps(){return this.d}set totalSteps(c){this.d=c,this.z({totalSteps:c})}get enabled(){return this.g}set enabled(c){this.g=c,this.z({enabled:c})}get busy(){return this.j}set busy(c){this.j=c,this.z({busy:c})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(c){this.k=c,this.z({ignoreFocusOut:c})}get value(){return this.l}set value(c){this.l=c,this.z({value:c})}get placeholder(){return this.m}set placeholder(c){this.m=c,this.z({placeholder:c})}get buttons(){return this.n}set buttons(c){this.n=c.slice(),this.o.clear(),c.forEach((l,n)=>{const r=l===A.QuickInputButtons.Back?-1:n;this.o.set(r,l)}),this.z({buttons:c.map((l,n)=>({...i(l),tooltip:l.tooltip,handle:l===A.QuickInputButtons.Back?-1:n}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(c){this.l=c,this.q.fire(c)}_fireDidTriggerButton(c){const l=this.o.get(c);l&&this.r.fire(l)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,k.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),m.$dispose(this._id))}z(c){if(!this.v){for(const l of Object.keys(c)){const n=c[l];this.u[l]=n===void 0?null:n}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){m.$createOrUpdate(this.u),this.u={id:this._id}}}w.a=1;function g(u){if(u instanceof A.ThemeIcon)return{id:u.id};const c=b(u),l=p(u);return{dark:typeof c=="string"?I.URI.file(c):c,light:typeof l=="string"?I.URI.file(l):l}}function p(u){return typeof u=="object"&&"light"in u?u.light:u}function b(u){return typeof u=="object"&&"dark"in u?u.dark:u}function i(u){const c=g(u.iconPath);let l,n;return"id"in c?n=P.ThemeIcon.asClassName(c):l=c,{iconPath:l,iconClass:n}}class s extends w{constructor(c,l){super(c.identifier,l),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new t.Emitter,this.L=[],this.M=new t.Emitter,this.N=new t.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(c){this.B=c.slice(),this.C.clear(),this.D.clear(),c.forEach((n,r)=>{this.C.set(r,n),this.D.set(n,r)});const l=[];for(let n=0;n<c.length;n++){const r=c[n];r.kind===A.QuickPickItemKind.Separator?l.push({type:"separator",label:r.label}):l.push({handle:n,label:r.label,description:r.description,detail:r.detail,picked:r.picked,alwaysShow:r.alwaysShow,buttons:r.buttons?.map((f,E)=>({...i(f),tooltip:f.tooltip,handle:E}))})}this.z({items:l})}get canSelectMany(){return this.E}set canSelectMany(c){this.E=c,this.z({canSelectMany:c})}get matchOnDescription(){return this.F}set matchOnDescription(c){this.F=c,this.z({matchOnDescription:c})}get matchOnDetail(){return this.G}set matchOnDetail(c){this.G=c,this.z({matchOnDetail:c})}get sortByLabel(){return this.H}set sortByLabel(c){this.H=c,this.z({sortByLabel:c})}get keepScrollPosition(){return this.I}set keepScrollPosition(c){this.I=c,this.z({keepScrollPosition:c})}get activeItems(){return this.J}set activeItems(c){this.J=c.filter(l=>this.D.has(l)),this.z({activeItems:this.J.map(l=>this.D.get(l))})}get selectedItems(){return this.L}set selectedItems(c){this.L=c.filter(l=>this.D.has(l)),this.z({selectedItems:this.L.map(l=>this.D.get(l))})}_fireDidChangeActive(c){const l=(0,C.coalesce)(c.map(n=>this.C.get(n)));this.J=l,this.K.fire(l)}_fireDidChangeSelection(c){const l=(0,C.coalesce)(c.map(n=>this.C.get(n)));this.L=l,this.M.fire(l)}_fireDidTriggerItemButton(c,l){const n=this.C.get(c);if(!n||!n.buttons||!n.buttons.length)return;const r=n.buttons[l];r&&this.N.fire({button:r,item:n})}}class a extends w{constructor(c,l){super(c.identifier,l),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(c){this.B=c,this.z({password:c})}get prompt(){return this.C}set prompt(c){this.C=c,this.z({prompt:c})}get valueSelection(){return this.D}set valueSelection(c){this.D=c,this.z({valueSelection:c})}get validationMessage(){return this.E}set validationMessage(c){this.E=c,c?typeof c=="string"?this.z({validationMessage:c,severity:L.default.Error}):this.z({validationMessage:c.message,severity:c.severity??L.default.Error}):this.z({validationMessage:void 0,severity:L.default.Ignore})}}return new h(v,d)}e.createExtHostQuickOpen=y});var Ue=this&&this.__classPrivateFieldGet||function(ne,e,o,t){if(o==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?t:o==="a"?t.call(ne):t?t.value:e.get(ne)},Je=this&&this.__classPrivateFieldSet||function(ne,e,o,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ne,o):k?k.value=o:e.set(ne,o),o};define(ye[263],Ce([1,0,2,4,60,6,16,5,18,109,13,26,90,14,27]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y,D,v){"use strict";var d,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function h(r){if(r)return typeof r.iconPath=="string"?o.URI.file(r.iconPath):o.URI.isUri(r.iconPath)||y.ThemeIcon.isThemeIcon(r.iconPath)?r.iconPath:void 0}function w(r,f){if(!r.iconPath&&!f.iconPath)return 0;if(r.iconPath){if(!f.iconPath)return 1}else return-1;const E=typeof r.iconPath=="string"?r.iconPath:o.URI.isUri(r.iconPath)?r.iconPath.fsPath:r.iconPath.id,T=typeof f.iconPath=="string"?f.iconPath:o.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id;return(0,C.comparePaths)(E,T)}function g(r,f){let E=0;if(r.strikeThrough!==f.strikeThrough)return r.strikeThrough?1:-1;if(r.faded!==f.faded)return r.faded?1:-1;if(r.tooltip!==f.tooltip)return(r.tooltip||"").localeCompare(f.tooltip||"");if(E=w(r,f),E!==0)return E;if(r.light&&f.light)E=w(r.light,f.light);else{if(r.light)return 1;if(f.light)return-1}if(E!==0)return E;if(r.dark&&f.dark)E=w(r.dark,f.dark);else{if(r.dark)return 1;if(f.dark)return-1}return E}function p(r,f){if(r.command!==f.command)return r.command<f.command?-1:1;if(r.title!==f.title)return r.title<f.title?-1:1;if(r.tooltip!==f.tooltip){if(r.tooltip!==void 0&&f.tooltip!==void 0)return r.tooltip<f.tooltip?-1:1;if(r.tooltip!==void 0)return 1;if(f.tooltip!==void 0)return-1}if(r.arguments===f.arguments)return 0;if(r.arguments)if(f.arguments){if(r.arguments.length!==f.arguments.length)return r.arguments.length-f.arguments.length}else return 1;else return-1;for(let E=0;E<r.arguments.length;E++){const T=r.arguments[E],M=f.arguments[E];if(T!==M)return T<M?-1:1}return 0}function b(r,f){let E=(0,C.comparePaths)(r.resourceUri.fsPath,f.resourceUri.fsPath,!0);if(E!==0)return E;if(r.command&&f.command)E=p(r.command,f.command);else{if(r.command)return 1;if(f.command)return-1}if(E!==0)return E;if(r.decorations&&f.decorations)E=g(r.decorations,f.decorations);else{if(r.decorations)return 1;if(f.decorations)return-1}return E}function i(r,f){for(let E=0;E<r.length;E++)if(r[E]!==f[E])return!1;return!0}function s(r,f){return r.command===f.command&&r.title===f.title&&r.tooltip===f.tooltip&&(r.arguments&&f.arguments?i(r.arguments,f.arguments):r.arguments===f.arguments)}function a(r,f){return(0,S.equals)(r,f,s)}class u{get value(){return this.d}set value(f){f=f??"",Ue(this,d,"f").$setInputBoxValue(this.l,f),this.m(f)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(f){Ue(this,d,"f").$setInputBoxPlaceholder(this.l,f),this.f=f}get validateInput(){return(0,v.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(f){if((0,v.checkProposedApiEnabled)(this.k,"scmValidation"),f&&typeof f!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=f,Ue(this,d,"f").$setValidationProviderIsEnabled(this.l,!!f)}get enabled(){return this.h}set enabled(f){f=!!f,this.h!==f&&(this.h=f,Ue(this,d,"f").$setInputBoxEnablement(this.l,f))}get visible(){return this.j}set visible(f){f=!!f,this.j!==f&&(this.j=f,Ue(this,d,"f").$setInputBoxVisibility(this.l,f))}constructor(f,E,T){this.k=f,this.l=T,d.set(this,void 0),this.d="",this.e=new t.Emitter,this.f="",this.h=!0,this.j=!0,Je(this,d,E,"f")}showValidationMessage(f,E){(0,v.checkProposedApiEnabled)(this.k,"scmValidation"),Ue(this,d,"f").$showValidationMessage(this.l,f,E)}$onInputBoxValueChange(f){this.m(f)}m(f){this.d=f,this.e.fire(f)}}e.ExtHostSCMInputBox=u,d=new WeakMap;class c{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(f){this.v=f,this.q.$updateGroupLabel(this.t,this.handle,f)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(f){this.p=f,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(f){this.f=[...f],this.k.fire()}constructor(f,E,T,M,G){this.q=f,this.s=E,this.t=T,this.u=M,this.v=G,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new t.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new t.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=c.d++}getResourceState(f){return this.g.get(f)}$executeResourceCommand(f,E){const T=this.h.get(f);return T?(0,I.asPromise)(()=>this.s.executeCommand(T.command,...T.arguments||[],E)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const f=[...this.f].sort(b),T=(0,S.sortedDiff)(this.o,f,b).map(V=>{const N=V.toInsert.map(U=>{const F=this.e++;this.g.set(F,U);const z=U.resourceUri;let B;if(U.command)if(U.command.command==="vscode.open"||U.command.command==="vscode.diff"){const fe=new R.DisposableStore;B=this.s.converter.toInternal(U.command,fe),this.j.set(F,fe)}else this.h.set(F,U.command);const W=h(U.decorations),X=U.decorations&&h(U.decorations.light)||W,q=U.decorations&&h(U.decorations.dark)||W,_=[X,q],Q=U.decorations&&U.decorations.tooltip||"",Z=U.decorations&&!!U.decorations.strikeThrough,ge=U.decorations&&!!U.decorations.faded,te=U.contextValue||"";return{rawResource:[F,z,_,Q,Z,ge,te,B],handle:F}});return{start:V.start,deleteCount:V.deleteCount,toInsert:N}}),M=T.map(({start:V,deleteCount:N,toInsert:U})=>[V,N,U.map(F=>F.rawResource)]),G=T.reverse();for(const{start:V,deleteCount:N,toInsert:U}of G){const F=U.map(B=>B.handle),z=this.n.splice(V,N,...F);for(const B of z)this.g.delete(B),this.h.delete(B),this.j.get(B)?.dispose(),this.j.delete(B)}return this.o=f,M}dispose(){this.l=!0,this.m.fire()}}c.d=0;class l{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(f){this.g!==f&&(this.g=f,Ue(this,m,"f").$updateSourceControl(this.t,{count:f}))}get quickDiffProvider(){return this.h}set quickDiffProvider(f){this.h=f,Ue(this,m,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!f})}get commitTemplate(){return this.j}set commitTemplate(f){f!==this.j&&(this.j=f,Ue(this,m,"f").$updateSourceControl(this.t,{commitTemplate:f}))}get acceptInputCommand(){return this.l}set acceptInputCommand(f){this.k.value=new R.DisposableStore,this.l=f;const E=this.v.converter.toInternal(f,this.k.value);Ue(this,m,"f").$updateSourceControl(this.t,{acceptInputCommand:E})}get actionButton(){return(0,v.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(f){(0,v.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new R.DisposableStore,this.n=f;const E=f!==void 0?{command:this.v.converter.toInternal(f.command,this.m.value),secondaryCommands:f.secondaryCommands?.map(T=>T.map(M=>this.v.converter.toInternal(M,this.m.value))),description:f.description,enabled:f.enabled}:void 0;Ue(this,m,"f").$updateSourceControl(this.t,{actionButton:E??null})}get statusBarCommands(){return this.p}set statusBarCommands(f){if(this.p&&f&&a(this.p,f))return;this.o.value=new R.DisposableStore,this.p=f;const E=(f||[]).map(T=>this.v.converter.toInternal(T,this.o.value));Ue(this,m,"f").$updateSourceControl(this.t,{statusBarCommands:E})}get selected(){return this.q}constructor(f,E,T,M,G,V){this.u=f,this.v=T,this.w=M,this.x=G,this.y=V,m.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new R.MutableDisposable,this.l=void 0,this.m=new R.MutableDisposable,this.o=new R.MutableDisposable,this.p=void 0,this.q=!1,this.s=new t.Emitter,this.onDidChangeSelection=this.s.event,this.t=l.d++,this.z=new Map,this.A=new Set,Je(this,m,E,"f"),this.f=new u(f,Ue(this,m,"f"),this.t),Ue(this,m,"f").$registerSourceControl(this.t,M,G,V)}createResourceGroup(f,E){const T=new c(Ue(this,m,"f"),this.v,this.t,f,E),M=t.Event.once(T.onDidDispose)(()=>this.z.delete(T));return this.z.set(T,M),this.eventuallyAddResourceGroups(),T}eventuallyAddResourceGroups(){const f=[],E=[];for(const[T,M]of this.z){M.dispose();const G=T.onDidUpdateResourceStates(()=>{this.A.add(T),this.eventuallyUpdateResourceStates()});t.Event.once(T.onDidDispose)(()=>{this.A.delete(T),G.dispose(),this.e.delete(T.handle),Ue(this,m,"f").$unregisterGroup(this.t,T.handle)}),f.push([T.handle,T.id,T.label,T.features]);const V=T._takeResourceStateSnapshot();V.length>0&&E.push([T.handle,V]),this.e.set(T.handle,T)}Ue(this,m,"f").$registerGroups(this.t,f,E),this.z.clear()}eventuallyUpdateResourceStates(){const f=[];this.A.forEach(E=>{const T=E._takeResourceStateSnapshot();T.length!==0&&f.push([E.handle,T])}),f.length>0&&Ue(this,m,"f").$spliceResourceStates(this.t,f),this.A.clear()}getResourceGroup(f){return this.e.get(f)}setSelectionState(f){this.q=f,this.s.fire(f)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(f=>f.dispose()),Ue(this,m,"f").$unregisterSourceControl(this.t)}}m=new WeakMap,l.d=0,qe([(0,k.debounce)(100)],l.prototype,"eventuallyAddResourceGroups",null),qe([(0,k.debounce)(100)],l.prototype,"eventuallyUpdateResourceStates",null);let n=class ii{get onDidChangeActiveProvider(){return this.j.event}constructor(f,E,T){this.l=E,this.m=T,this.g=new Map,this.h=new Map,this.j=new t.Emitter,this.e=f.getProxy(A.MainContext.MainThreadSCM),this.f=f.getProxy(A.MainContext.MainThreadTelemetry),E.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===3){const G=this.g.get(M.sourceControlHandle);if(!G)return M;const V=G.getResourceGroup(M.groupHandle);return V?V.getResourceState(M.handle):M}else if(M&&M.$mid===4){const G=this.g.get(M.sourceControlHandle);return G?G.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===5){const G=this.g.get(M.handle);return G||M}return M}})}createSourceControl(f,E,T,M){this.m.trace("ExtHostSCM#createSourceControl",f.identifier.value,E,T,M),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:f.identifier.value});const G=ii.d++,V=new l(f,this.e,this.l,E,T,M);this.g.set(G,V);const N=this.h.get(P.ExtensionIdentifier.toKey(f.identifier))||[];return N.push(V),this.h.set(P.ExtensionIdentifier.toKey(f.identifier),N),V}getLastInputBox(f){this.m.trace("ExtHostSCM#getLastInputBox",f.identifier.value);const E=this.h.get(P.ExtensionIdentifier.toKey(f.identifier)),T=E&&E[E.length-1];return T&&T.inputBox}$provideOriginalResource(f,E,T){const M=o.URI.revive(E);this.m.trace("ExtHostSCM#$provideOriginalResource",f,M.toString());const G=this.g.get(f);return!G||!G.quickDiffProvider||!G.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,I.asPromise)(()=>G.quickDiffProvider.provideOriginalResource(M,T)).then(V=>V||null)}$onInputBoxValueChange(f,E){this.m.trace("ExtHostSCM#$onInputBoxValueChange",f);const T=this.g.get(f);return T&&T.inputBox.$onInputBoxValueChange(E),Promise.resolve(void 0)}$executeResourceCommand(f,E,T,M){this.m.trace("ExtHostSCM#$executeResourceCommand",f,E,T);const G=this.g.get(f);if(!G)return Promise.resolve(void 0);const V=G.getResourceGroup(E);return V?V.$executeResourceCommand(T,M):Promise.resolve(void 0)}$validateInput(f,E,T){this.m.trace("ExtHostSCM#$validateInput",f);const M=this.g.get(f);return!M||!M.inputBox.validateInput?Promise.resolve(void 0):(0,I.asPromise)(()=>M.inputBox.validateInput(E,T)).then(G=>{if(!G)return Promise.resolve(void 0);const V=D.MarkdownString.fromStrict(G.message);return V?Promise.resolve([V,G.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(f){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",f),f!==void 0&&this.g.get(f)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=f,Promise.resolve(void 0)}};n.d=0,n=qe([He(2,L.ILogService)],n),e.ExtHostSCM=n}),define(ye[97],Ce([1,0,5,4,3]),function(ne,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class R{constructor(A){this.b=new t.Emitter,this.onDidChangePassword=this.b.event,this.a=A.getProxy(o.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this.b.fire(A)}get(A,S){return this.a.$getPassword(A,S)}store(A,S,C){return this.a.$setPassword(A,S,C)}delete(A,S){return this.a.$deletePassword(A,S)}}e.ExtHostSecretState=R,e.IExtHostSecretState=(0,k.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(ne,e,o,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ne,o):k?k.value=o:e.set(ne,o),o},Ue=this&&this.__classPrivateFieldGet||function(ne,e,o,t){if(o==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?t:o==="a"?t.call(ne):t?t.value:e.get(ne)};define(ye[264],Ce([1,0,7,5,176,6,14,11]),function(ne,e,o,t,k,R,I,A){"use strict";var S,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(v,d,m,h,w=o.StatusBarAlignment.Left,g){S.set(this,void 0),C.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.p=new R.DisposableStore,Je(this,S,v,"f"),Je(this,C,d,"f"),this.c=L.a++,this.e=m,this.f=h,this.g=w,this.h=this.t(g)}t(v){if(!!(0,A.isNumber)(v))return v===Number.POSITIVE_INFINITY?Number.MAX_VALUE:v===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:v}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.q?.fromApi}get accessibilityInformation(){return this.s}set text(v){this.k=v,this.u()}set name(v){this.m=v,this.u()}set tooltip(v){this.l=v,this.u()}set color(v){this.n=v,this.u()}set backgroundColor(v){v&&!L.b.has(v.id)&&(v=void 0),this.o=v,this.u()}set command(v){this.q?.fromApi!==v&&(this.p.clear(),typeof v=="string"?this.q={fromApi:v,internal:Ue(this,C,"f").toInternal({title:"",command:v},this.p)}:v?this.q={fromApi:v,internal:Ue(this,C,"f").toInternal(v,this.p)}:this.q=void 0,this.u())}set accessibilityInformation(v){this.s=v,this.u()}show(){this.j=!0,this.u()}hide(){clearTimeout(this.r),this.j=!1,Ue(this,S,"f").$dispose(this.c)}u(){this.i||!this.j||(clearTimeout(this.r),this.r=setTimeout(()=>{this.r=void 0;let v;this.e?this.f?v=`${this.e.identifier.value}.${this.f}`:v=this.e.identifier.value:v=this.f;let d;this.m?d=this.m:d=(0,k.localize)(0,null,this.e.displayName||this.e.name);let m=this.n;this.o&&(m=L.b.get(this.o.id));const h=I.MarkdownString.fromStrict(this.l);Ue(this,S,"f").$setEntry(this.c,v,d,this.k,h,this.q?.internal,m,this.o,this.g===o.StatusBarAlignment.Left,this.h,this.s)},0))}dispose(){this.hide(),this.i=!0}}e.ExtHostStatusBarEntry=L,S=new WeakMap,C=new WeakMap,L.a=0,L.b=new Map([["statusBarItem.errorBackground",new o.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new o.ThemeColor("statusBarItem.warningForeground")]]);class P{constructor(v){this.b=[],this.a=v.createStatusBarEntry(void 0,"status.extensionMessage",o.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,k.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(v){const d={message:v};return this.b.unshift(d),this.c(),new o.Disposable(()=>{const m=this.b.indexOf(d);m>=0&&(this.b.splice(m,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class y{constructor(v,d){this.a=v.getProxy(t.MainContext.MainThreadStatusBar),this.b=d,this.c=new P(this)}createStatusBarEntry(v,d,m,h){return new L(this.a,this.b,v,d,m,h)}setStatusBarMessage(v,d){const m=this.c.setMessage(v);let h;return typeof d=="number"?h=setTimeout(()=>m.dispose(),d):typeof d<"u"&&d.then(()=>m.dispose(),()=>m.dispose()),new o.Disposable(()=>{m.dispose(),clearTimeout(h)})}}e.ExtHostStatusBar=y}),define(ye[98],Ce([1,0,5,4,3]),function(ne,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class R{constructor(A,S){this.c=S,this.b=new t.Emitter,this.onDidChangeStorage=this.b.event,this.a=A.getProxy(o.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,S){this.a.$registerExtensionStorageKeysToSync(A,S)}async initializeExtensionStorage(A,S,C){const L=await this.a.$initializeExtensionStorage(A,S);let P;return L&&(P=this.d(A,S,L)),P||C}setValue(A,S,C){return this.a.$setValue(A,S,C)}$acceptValue(A,S,C){const L=this.d(A,S,C);L&&this.b.fire({shared:A,key:S,value:L})}d(A,S,C){try{return JSON.parse(C)}catch(L){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${S}, global: ${A}): ${L}`)}}}e.ExtHostStorage=R,e.IExtHostStorage=(0,k.createDecorator)("IExtHostStorage")}),define(ye[73],Ce([1,0,3,25,13,72,2]),function(ne,e,o,t,k,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,o.createDecorator)("IExtensionStoragePaths");let A=class{constructor(C,L,P){this.d=L,this.f=P,this.a=C.workspace??void 0,this.b=C.environment,this.whenReady=this.h().then(y=>this.c=y)}async g(C){return I.URI.joinPath(this.b.workspaceStorageHome,C)}async h(){if(!this.a)return Promise.resolve(void 0);const C=this.a.id,L=await this.g(C);try{return await this.f.value.stat(L),this.d.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",L),await this.f.value.createDirectory(L),await this.f.value.writeFile(I.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:I.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),L}catch(P){this.d.error("[ExtHostStorage]",P);return}}workspaceValue(C){if(this.c)return I.URI.joinPath(this.c,C.identifier.value)}globalValue(C){return I.URI.joinPath(this.b.globalStorageHome,C.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=qe([He(0,t.IExtHostInitDataService),He(1,k.ILogService),He(2,R.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(ye[40],Ce([1,0,4,5,3,2,17,6,7,177,10,222,21,30,207,90,11,16,14]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y,D,v,d,m,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,k.createDecorator)("IExtHostTerminalService");class g{constructor(n,r,f,E){this.k=n,this._id=r,this.l=f,this.m=E,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(M=>this.f=M);const T=this;this.value={get name(){return T.m||""},get processId(){return T.b},get creationOptions(){return T.l},get exitStatus(){return T.h},get state(){return T.j},sendText(M,G=!0){T.o(),T.k.$sendText(T._id,M,G)},show(M){T.o(),T.k.$show(T._id,M)},hide(){T.o(),T.k.$hide(T._id)},dispose(){T.a||(T.a=!0,T.k.$dispose(T._id))},get dimensions(){if(!(T.d===void 0||T.g===void 0))return{columns:T.d,rows:T.g}}}}async create(n,r){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:n.name,shellPath:(0,m.withNullAsUndefined)(n.shellPath),shellArgs:(0,m.withNullAsUndefined)(n.shellArgs),cwd:(0,m.withNullAsUndefined)(n.cwd),env:(0,m.withNullAsUndefined)(n.env),icon:(0,m.withNullAsUndefined)(u(n.iconPath)),color:d.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,m.withNullAsUndefined)(n.message),strictEnv:(0,m.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,m.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,m.withNullAsUndefined)(r?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,m.withNullAsUndefined)(r?.useShellEnvironment),location:r?.location||this.n(n.location,r?.resolvedExtHostIdentifier),isTransient:(0,m.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,r,f,E){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:f,color:d.ThemeColor.isThemeColor(E)?E.id:void 0,location:this.n(n,r),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(n,r){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&r?{parentTerminal:r}:"viewColumn"in n?{viewColumn:w.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus}:void 0:n}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(n){this.m=n}setExitStatus(n,r){this.h=Object.freeze({code:n,reason:r})}setDimensions(n,r){return n===this.d&&r===this.g||n===0||r===0?!1:(this.d=n,this.g=r,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(n){this.f?(this.f(n),this.f=void 0):this.b.then(r=>{r!==n&&(this.b=Promise.resolve(n))})}}e.ExtHostTerminal=g;class p{get onProcessReady(){return this.b.event}constructor(n){this.g=n,this.id=0,this.shouldPersist=!1,this.a=new o.Emitter,this.onProcessData=this.a.event,this.b=new o.Emitter,this.d=new o.Emitter,this.onDidChangeProperty=this.d.event,this.f=new o.Emitter,this.onProcessExit=this.f.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,r){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${r}`)}async start(){}shutdown(){this.g.close()}input(n){this.g.handleInput?.(n)}resize(n,r){this.g.setDimensions?.({columns:n,rows:r})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this.g.onDidWrite(r=>this.a.fire(r)),this.g.onDidClose?.((r=void 0)=>{this.f.fire(r===void 0?void 0:r)}),this.g.onDidOverrideDimensions?.(r=>{r&&this.d.fire({type:"overrideDimensions",value:{cols:r.columns,rows:r.rows}})}),this.g.onDidChangeName?.(r=>{this.d.fire({type:"title",value:r})}),this.g.open(n||void 0),n&&this.g.setDimensions?.(n),this.b.fire({pid:-1,cwd:""})}}let b=1,i=class extends A.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(n=>n.value)}get onDidWriteTerminalData(){return this.I.event}constructor(n,r){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new o.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new o.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new o.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new o.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new o.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new o.Emitter,this.onDidChangeShell=this.J.event,this.a=r.getProxy(t.MainContext.MainThreadTerminalService),this.s=new v.TerminalDataBufferer(this.a.$sendProcessData),this.I=new o.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(n),this.B({dispose:()=>{for(const[f,E]of this.g)E.shutdown(!0)}})}getDefaultShell(n){return(n?this.n:this.m)?.path||""}getDefaultShellArgs(n){return(n?this.n:this.m)?.args||[]}createExtensionTerminal(n,r){const f=new g(this.a,(0,D.generateUuid)(),n,n.name),E=new p(n.pty);return f.createExtensionTerminal(n.location,this.L(n,r).resolvedExtHostIdentifier,u(n.iconPath),c(n.color)).then(T=>{const M=this.M(T,E);this.h[T]=M}),this.f.push(f),f.value}L(n,r){if(r=r||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const f=n.location.parentTerminal;if(f){const E=this.f.find(T=>T.value===f);E&&(r.resolvedExtHostIdentifier=E._id)}}else n.location&&typeof n.location!="object"?r.location=n.location:r.location&&typeof r.location=="object"&&"splitActiveTerminal"in r.location&&(r.location={splitActiveTerminal:!0});return r}attachPtyToTerminal(n,r){if(!this.O(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const E=new p(r),T=this.M(n,E);this.h[n]=T}async $acceptActiveTerminalChanged(n){const r=this.b;if(n===null){this.b=void 0,r!==this.b&&this.F.fire(this.b);return}const f=this.O(n);f&&(this.b=f,r!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(n,r){const f=this.O(n);f&&this.I.fire({terminal:f.value,data:r})}async $acceptTerminalDimensions(n,r,f){const E=this.O(n);E&&E.setDimensions(r,f)&&this.G.fire({terminal:E.value,dimensions:E.value.dimensions})}async $acceptTerminalMaximumDimensions(n,r,f){this.g.get(n)?.resize(r,f)}async $acceptTerminalTitleChange(n,r){const f=this.O(n);f&&(f.name=r)}async $acceptTerminalClosed(n,r,f){const E=this.Q(this.f,n);if(E!==null){const T=this.f.splice(E,1)[0];T.setExitStatus(r,f),this.C.fire(T.value)}}$acceptTerminalOpened(n,r,f,E){if(r){const G=this.Q(this.f,r);if(G!==null){this.f[G]._id=n,this.D.fire(this.terminals[G]),this.f[G].isOpen=!0;return}}const T={name:E.name,shellPath:E.executable,shellArgs:E.args,cwd:typeof E.cwd=="string"?E.cwd:R.URI.revive(E.cwd),env:E.env,hideFromUser:E.hideFromUser},M=new g(this.a,n,T,f);this.f.push(M),this.D.fire(M.value),M.isOpen=!0}async $acceptTerminalProcessId(n,r){this.O(n)?._setProcessId(r)}async $startExtensionTerminal(n,r){const f=this.O(n);if(!f)return{message:(0,C.localize)(0,null,n)};f.isOpen||await new Promise(T=>{const M=this.onDidOpenTerminal(async G=>{G===f.value&&(M.dispose(),T())})});const E=this.g.get(n);E?E.startSendingEvents(r):this.j[n]={initialDimensions:r}}M(n,r){const f=new A.DisposableStore;f.add(r.onProcessReady(T=>this.a.$sendProcessReady(n,T.pid,T.cwd))),f.add(r.onDidChangeProperty(T=>this.a.$sendProcessProperty(n,T))),this.s.startBuffering(n,r.onProcessData),f.add(r.onProcessExit(T=>this.N(n,T))),this.g.set(n,r);const E=this.j[n];return E&&r instanceof p&&(r.startSendingEvents(E.initialDimensions),delete this.j[n]),f}$acceptProcessAckDataEvent(n,r){this.g.get(n)?.acknowledgeDataEvent(r)}$acceptProcessInput(n,r){this.g.get(n)?.input(r)}$acceptTerminalInteraction(n){const r=this.O(n);r?.setInteractedWith()&&this.H.fire(r.value)}$acceptProcessResize(n,r,f){try{this.g.get(n)?.resize(r,f)}catch(E){if(E.code!=="EPIPE"&&E.code!=="ERR_IPC_CHANNEL_CLOSED")throw E}}$acceptProcessShutdown(n,r){this.g.get(n)?.shutdown(r)}$acceptProcessRequestInitialCwd(n){this.g.get(n)?.getInitialCwd().then(r=>this.a.$sendProcessProperty(n,{type:"initialCwd",value:r}))}$acceptProcessRequestCwd(n){this.g.get(n)?.getCwd().then(r=>this.a.$sendProcessProperty(n,{type:"cwd",value:r}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this.u.add(n),this.u.size===1&&this.a.$startLinkProvider(),new S.Disposable(()=>{this.u.delete(n),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(n,r,f){if(this.v.has(r))throw new Error(`Terminal profile provider "${r}" already registered`);return this.v.set(r,f),this.a.$registerProfileProvider(r,n.identifier.value),new S.Disposable(()=>{this.v.delete(r),this.a.$unregisterProfileProvider(r)})}registerTerminalQuickFixProvider(n,r,f){if(this.w.has(n))throw new Error(`Terminal quick fix provider "${n}" is already registered`);return this.w.set(n,f),this.a.$registerQuickFixProvider(n,r),new S.Disposable(()=>{this.w.delete(n),this.a.$unregisterQuickFixProvider(n)})}async $provideTerminalQuickFixes(n,r){const f=new y.CancellationTokenSource().token;if(f.isCancellationRequested)return;const E=this.w.get(n);if(!E)return;const T=await E.provideTerminalQuickFixes(r,f);if(T!==null)return T}async $createContributedProfileTerminal(n,r){const f=new y.CancellationTokenSource().token;let E=await this.v.get(n)?.provideTerminalProfile(f);if(!f.isCancellationRequested){if(E&&!("options"in E)&&(E={options:E}),!E||!("options"in E))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in E.options){this.createExtensionTerminal(E.options,r);return}this.createTerminalFromOptions(E.options,r)}}async $provideLinks(n,r){const f=this.O(n);if(!f)return[];this.y.delete(n),this.z.get(n)?.dispose(!0);const T=new y.CancellationTokenSource;this.z.set(n,T);const M=[],G={terminal:f.value,line:r},V=[];for(const F of this.u)V.push(h.Promises.withAsyncBody(async z=>{T.token.onCancellationRequested(()=>z({provider:F,links:[]}));const B=await F.provideTerminalLinks(G,T.token)||[];T.token.isCancellationRequested||z({provider:F,links:B})}));const N=await Promise.all(V);if(T.token.isCancellationRequested)return[];const U=new Map;for(const F of N)F&&F.links.length>0&&M.push(...F.links.map(z=>{const B={id:b++,startIndex:z.startIndex,length:z.length,label:z.tooltip};return U.set(B.id,{provider:F.provider,link:z}),B}));return this.y.set(n,U),M}$activateLink(n,r){const f=this.y.get(n)?.get(r);!f||f.provider.handleTerminalLink(f.link)}N(n,r){this.s.stopBuffering(n),this.g.delete(n),delete this.j[n];const f=this.h[n];f&&(f.dispose(),delete this.h[n]),this.a.$sendProcessExit(n,r)}O(n){return this.P(this.f,n)}P(n,r){const f=this.Q(n,r);return f!==null?n[f]:null}Q(n,r){let f=null;return n.some((E,T)=>E._id===r?(f=T,!0):!1),f}getEnvironmentVariableCollection(n){let r=this.l.get(n.identifier.value);return r||(r=new s,this.S(n.identifier.value,r)),r}R(n,r){const f=(0,P.serializeEnvironmentVariableCollection)(r.map);this.a.$setEnvironmentVariableCollection(n,r.persistent,f.length===0?void 0:f)}$initEnvironmentVariableCollections(n){n.forEach(r=>{const f=r[0],E=new s(r[1]);this.S(f,E)})}$acceptDefaultProfile(n,r){const f=this.m;this.m=n,this.n=r,f?.path!==n.path&&this.J.fire(n.path)}S(n,r){this.l.set(n,r),r.onDidChangeCollection(()=>{this.R(n,r)})}};i=qe([He(1,I.IExtHostRpcService)],i),e.BaseExtHostTerminalService=i;class s{get persistent(){return this.a}set persistent(n){this.a=n,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(n){this.map=new Map,this.a=!0,this.b=new o.Emitter,this.map=new Map(n)}get size(){return this.map.size}replace(n,r){this.d(n,{value:r,type:S.EnvironmentVariableMutatorType.Replace})}append(n,r){this.d(n,{value:r,type:S.EnvironmentVariableMutatorType.Append})}prepend(n,r){this.d(n,{value:r,type:S.EnvironmentVariableMutatorType.Prepend})}d(n,r){const f=this.map.get(n);(!f||f.value!==r.value||f.type!==r.type)&&(this.map.set(n,r),this.b.fire())}get(n){return this.map.get(n)}forEach(n,r){this.map.forEach((f,E)=>n.call(r,E,f,this))}[Symbol.iterator](){return this.map.entries()}delete(n){this.map.delete(n),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let a=class extends i{constructor(n){super(!1,n)}createTerminal(n,r,f){throw new L.NotSupportedError}createTerminalFromOptions(n,r){throw new L.NotSupportedError}};a=qe([He(0,I.IExtHostRpcService)],a),e.WorkerExtHostTerminalService=a;function u(l){if(!(!l||typeof l=="string"))return"id"in l?{id:l.id,color:l.color}:l}function c(l){return d.ThemeColor.isThemeColor(l)?l:void 0}});var Ue=this&&this.__classPrivateFieldGet||function(ne,e,o,t){if(o==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?t:o==="a"?t.call(ne):t?t.value:e.get(ne)},Je=this&&this.__classPrivateFieldSet||function(ne,e,o,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ne,o):k?k.value=o:e.set(ne,o),o};define(ye[265],Ce([1,0,18,16,22,21,4,61,85,6,23,11,30,5,17,137,14,7,56,92,70]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y,D,v,d,m,h,w,g,p){"use strict";var b,i;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let s=class{constructor(U,F,z){this.j=z,this.c=new I.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=U.getProxy(D.MainContext.MainThreadTesting),this.h=new M(this.f),this.g=new l(this.f),F.registerArgumentProcessor({processArgument:B=>{if(B?.$mid!==15)return B;const W=B,X=W.tests[W.tests.length-1].item.extId;return this.d.get(w.TestId.root(X))?.collection.tree.get(X)?.actual??(0,d.toItemFromContext)(B)}})}createTestController(U,F,z){if(this.d.has(U))throw new Error(`Attempt to insert a duplicate controller with ID "${U}"`);const B=new C.DisposableStore,W=B.add(new d.ExtHostTestItemCollection(U,F,this.j));W.root.label=F;const X=new Map,q=this.f,_={items:W.root.children,get label(){return F},set label(Z){F=Z,W.root.label=Z,q.$updateController(U,{label:F})},get refreshHandler(){return z},set refreshHandler(Z){z=Z,q.$updateController(U,{canRefresh:!!Z})},get id(){return U},createRunProfile:(Z,ge,te,J,fe)=>{let ve=(0,S.hash)(Z);for(;X.has(ve);)ve++;return new G(this.f,X,U,ve,Z,ge,te,J,fe)},createTestItem(Z,ge,te){return new d.TestItemImpl(U,Z,ge,te)},createTestRun:(Z,ge,te=!0)=>this.g.createTestRun(U,W,Z,ge,te),set resolveHandler(Z){W.resolveHandler=Z},get resolveHandler(){return W.resolveHandler},dispose:()=>{B.dispose()}};q.$registerTestController(U,F,!!z),B.add((0,C.toDisposable)(()=>q.$unregisterTestController(U)));const Q={controller:_,collection:W,profiles:X};return this.d.set(U,Q),B.add((0,C.toDisposable)(()=>this.d.delete(U))),B.add(W.onDidGenerateDiff(Z=>q.$publishDiff(U,Z.map(p.TestsDiffOp.serialize)))),_}createTestObserver(){return this.h.checkout()}async runTests(U,F=R.CancellationToken.None){const z=n(U);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const B=this.d.get(z.controllerId);if(!B)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(W=>w.TestId.fromExtHostTestItem(W,B.collection.root.id).toString())??[B.collection.root.id],profileGroup:V[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:U.exclude?.map(W=>W.id)},F)}$syncTests(){for(const{collection:U}of this.d.values())U.flushDiff();return Promise.resolve()}$provideFileCoverage(U,F,z){return(0,o.mapFind)(this.g.trackers,W=>W.id===U?W.getCoverage(F):void 0)?.provideFileCoverage(z)??Promise.resolve([])}$resolveFileCoverage(U,F,z,B){return(0,o.mapFind)(this.g.trackers,X=>X.id===U?X.getCoverage(F):void 0)?.resolveFileCoverage(z,B)??Promise.resolve([])}$configureRunProfile(U,F){this.d.get(U)?.profiles.get(F)?.configureHandler?.()}async $refreshTests(U,F){await this.d.get(U)?.controller.refreshHandler?.(F)}$publishTestResults(U){this.results=Object.freeze(U.map(F=>(0,L.deepFreeze)(m.TestResults.to(F))).concat(this.results).sort((F,z)=>z.completedAt-F.completedAt).slice(0,32)),this.c.fire()}async $expandTest(U,F){const z=this.d.get(w.TestId.fromString(U).controllerId)?.collection;z&&(await z.expand(U,F<0?1/0:F),z.flushDiff())}$acceptDiff(U){this.h.applyDiff(U.map(p.TestsDiffOp.deserialize))}async $runControllerTests(U,F){return Promise.all(U.map(z=>this.runControllerTestRequest(z,F)))}async runControllerTestRequest(U,F){const z=this.d.get(U.controllerId);if(!z)return{};const{collection:B,profiles:W}=z,X=W.get(U.profileId);if(!X)return{};const q=U.testIds.map(ge=>B.tree.get(ge)).filter(P.isDefined),_=U.excludeExtIds.map(ge=>z.collection.tree.get(ge)).filter(P.isDefined).filter(ge=>q.some(te=>te.fullId.compare(ge.fullId)===2));if(!q.length)return{};const Q=new h.TestRunRequest(q.some(ge=>ge.actual instanceof d.TestItemRootImpl)?void 0:q.map(ge=>ge.actual),_.map(ge=>ge.actual),X),Z=this.g.prepareForMainThreadTestRun(Q,r.fromInternal(U,z.collection),F);try{return await X.runHandler(Q,F),{}}catch(ge){return{error:String(ge)}}finally{Z.hasRunningTasks&&!F.isCancellationRequested&&await I.Event.toPromise(Z.onEnd),Z.dispose()}}$cancelExtensionTestRun(U){U===void 0?this.g.cancelAllRuns():this.g.cancelRunById(U)}};s=qe([He(0,v.IExtHostRpcService)],s),e.ExtHostTesting=s;const a=1e4;var u;(function(N){N[N.Running=0]="Running",N[N.Cancelling=1]="Cancelling",N[N.Ended=2]="Ended"})(u||(u={}));class c extends C.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(U,F,z){super(),this.k=U,this.l=F,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new I.Emitter),this.onEnd=this.j.event,this.h=this.B(new R.CancellationTokenSource(z));const B=this.B(new t.RunOnceScheduler(()=>this.m(),a));this.B(this.h.token.onCancellationRequested(()=>B.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(U){return this.f.get(U)?.coverage}createRun(U){const F=this.k.id,z=this.k.controllerId,B=(0,y.generateUuid)(),W=new f(this.l,F,B),X=Z=>(ge,...te)=>{if(_){console.warn(`Setting the state of test "${ge.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(ge)||(this.s(ge),Z(ge,...te))},q=(Z,ge)=>{const te=ge instanceof Array?ge.map(m.TestMessage.from):[m.TestMessage.from(ge)];if(Z.uri&&Z.range){const J={range:m.Range.from(Z.range),uri:Z.uri};for(const fe of te)fe.location=fe.location||J}this.l.$appendTestMessagesInRun(F,B,w.TestId.fromExtHostTestItem(Z,z).toString(),te)};let _=!1;const Q={isPersisted:this.k.isPersisted,token:this.h.token,name:U,get coverageProvider(){return W.coverageProvider},set coverageProvider(Z){W.coverageProvider=Z},enqueued:X(Z=>{this.l.$updateTestStateInRun(F,B,w.TestId.fromExtHostTestItem(Z,z).toString(),1)}),skipped:X(Z=>{this.l.$updateTestStateInRun(F,B,w.TestId.fromExtHostTestItem(Z,z).toString(),5)}),started:X(Z=>{this.l.$updateTestStateInRun(F,B,w.TestId.fromExtHostTestItem(Z,z).toString(),2)}),errored:X((Z,ge,te)=>{q(Z,ge),this.l.$updateTestStateInRun(F,B,w.TestId.fromExtHostTestItem(Z,z).toString(),6,te)}),failed:X((Z,ge,te)=>{q(Z,ge),this.l.$updateTestStateInRun(F,B,w.TestId.fromExtHostTestItem(Z,z).toString(),4,te)}),passed:X((Z,ge)=>{this.l.$updateTestStateInRun(F,B,w.TestId.fromExtHostTestItem(Z,this.k.controllerId).toString(),3,ge)}),appendOutput:(Z,ge,te)=>{_||(te&&(this.k.isIncluded(te)?this.s(te):te=void 0),this.l.$appendOutputToRun(F,B,k.VSBuffer.fromString(Z),ge&&m.location.from(ge),te&&w.TestId.fromExtHostTestItem(te,z).toString()))},end:()=>{_||(_=!0,this.l.$finishedTestRunTask(F,B),this.f.delete(B),this.f.size||this.p())}};return this.f.set(B,{run:Q,coverage:W}),this.l.$startedTestRunTask(F,{id:B,name:U,running:!0}),Q}m(){for(const{run:U}of this.f.values())U.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(U){if(!(U instanceof d.TestItemImpl))throw new g.InvalidTestItemError(U.id);if(this.g.has(w.TestId.fromExtHostTestItem(U,this.k.controllerId).toString()))return;const F=[],z=this.k.colllection.root;for(;;){const B=m.TestItem.from(U);if(F.unshift(B),this.g.has(B.extId)||(this.g.add(B.extId),U===z))break;U=U.parent||z}this.l.$addTestsToRun(this.k.controllerId,this.k.id,F)}}class l{get trackers(){return this.c.values()}constructor(U){this.d=U,this.c=new Map}prepareForMainThreadTestRun(U,F,z){return this.f(U,F,z)}cancelRunById(U){for(const F of this.c.values())if(F.id===U){F.cancel();return}}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,F,z,B,W){const X=this.c.get(z);if(X)return X.createRun(B);const q=r.fromPublic(U,F,z,W),_=n(z);this.d.$startedExtensionTestRun({controllerId:U,profile:_&&{group:V[_.kind],id:_.profileId},exclude:z.exclude?.map(Z=>w.TestId.fromExtHostTestItem(Z,F.root.id).toString())??[],id:q.id,include:z.include?.map(Z=>w.TestId.fromExtHostTestItem(Z,F.root.id).toString())??[F.root.id],persist:W});const Q=this.f(z,q);return Q.onEnd(()=>{this.d.$finishedExtensionTestRun(q.id),Q.dispose()}),Q.createRun(B)}f(U,F,z){const B=new c(F,this.d,z);return this.c.set(U,B),B.onEnd(()=>this.c.delete(U)),B}}e.TestRunCoordinator=l;const n=N=>{if(!!N.profile){if(!(N.profile instanceof G))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return N.profile}};class r{static fromPublic(U,F,z,B){return new r(U,(0,y.generateUuid)(),z.include?.map(W=>w.TestId.fromExtHostTestItem(W,U).toString())??[U],z.exclude?.map(W=>w.TestId.fromExtHostTestItem(W,U).toString())??[],B,F)}static fromInternal(U,F){return new r(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,F)}constructor(U,F,z,B,W,X){this.controllerId=U,this.id=F,this.isPersisted=W,this.colllection=X,this.c=z.map(q=>q+"\0"),this.d=B.map(q=>q+"\0")}isIncluded(U){const F=w.TestId.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const z of this.d)if(F===z||F.startsWith(z))return!1;for(const z of this.c)if(F===z||F.startsWith(z))return!0;return!1}}e.TestRunDto=r;class f{set coverageProvider(U){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!U||(this.c=U,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(U,F,z){this.f=U,this.g=F,this.h=z}async provideFileCoverage(U){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(U))());try{return(await this.d)?.map(m.TestCoverage.fromFile)??[]}catch(F){throw this.d=void 0,F}}async resolveFileCoverage(U,F){const z=await this.d;let B=z?.[U];return!this.c||!z||!B?[]:(B.detailedCoverage||(B=z[U]=await this.c.resolveFileCoverage?.(B,F)??B),B.detailedCoverage?.map(m.TestCoverage.fromDetailed)??[])}}class E{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(U){this.h=U,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,m.TestItem.toPlain(U.item)),this.c.has(U)||this.d.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.d.delete(U);const F=w.TestId.parentId(U.item.extId);if(F&&this.g.has(F.toString())){this.g.add(U.item.extId);return}this.f.add(U)}getChangeEvent(){const{c:U,d:F,f:z}=this;return{get added(){return[...U].map(B=>B.revived)},get updated(){return[...F].map(B=>B.revived)},get removed(){return[...z].map(B=>B.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class T extends p.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new I.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(U){return this.d.get(U)}getMirroredTestDataByReference(U){return this.d.get(U.id)}p(U,F){return{...U,revived:m.TestItem.toPlain(U.item),depth:F?F.depth+1:0,children:new Set}}o(){return new E(this.q)}}e.MirroredTestCollection=T;class M{constructor(U){this.d=U}checkout(){this.c||(this.c=this.f());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(F=>F.revived)},dispose:(0,A.once)(()=>{--U.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}f(){const U=new T;return this.d.$subscribeToDiffs(),{observers:0,tests:U}}}class G{get label(){return this.d}set label(U){U!==this.d&&(this.d=U,Ue(this,b,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get isDefault(){return this.f}set isDefault(U){U!==this.f&&(this.f=U,Ue(this,b,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,Ue(this,b,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?m.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,Ue(this,b,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}constructor(U,F,z,B,W,X,q,_=!1,Q=void 0){this.controllerId=z,this.profileId=B,this.d=W,this.kind=X,this.runHandler=q,this.f=_,this._tag=Q,b.set(this,void 0),i.set(this,void 0),Je(this,b,U,"f"),Je(this,i,F,"f"),F.set(B,this);const Z=V[X];if(typeof Z!="number")throw new Error(`Unknown TestRunProfile.group ${X}`);Ue(this,b,"f").$publishTestRunProfile({profileId:B,controllerId:z,tag:Q?m.TestTag.namespace(this.controllerId,Q.id):null,label:W,group:Z,isDefault:_,hasConfigurationHandler:!1})}dispose(){Ue(this,i,"f")?.delete(this.profileId)&&(Je(this,i,void 0,"f"),Ue(this,b,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=G,b=new WeakMap,i=new WeakMap;const V={[h.TestRunProfileKind.Coverage]:8,[h.TestRunProfileKind.Debug]:4,[h.TestRunProfileKind.Run]:2}}),define(ye[266],Ce([1,0,18,4,5,138,14,7]),function(ne,e,o,t,k,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(L,P){this.i=P,this.a=new t.Emitter,this.b=new t.Emitter,this.c=new t.Emitter,this.d=new t.Emitter,this.f=new t.Emitter,this.g=new t.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=L.getProxy(k.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(y=>this.g.fire(y)),this.i.onDidChangeActiveTextEditor(y=>this.f.fire(y))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(L){const P=this.i.allEditors();return L?P:P.map(y=>y.value)}async showTextDocument(L,P,y){let D;typeof P=="number"?D={position:I.ViewColumn.from(P),preserveFocus:y}:typeof P=="object"?D={position:I.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?I.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:D={preserveFocus:!1};const v=await this.h.$tryShowTextDocument(L.uri,D),d=v&&this.i.getEditor(v);if(d)return d.value;throw v?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,P){return new R.TextEditorDecorationType(this.h,L,P).value}$acceptEditorPropertiesChanged(L,P){const y=this.i.getEditor(L);if(!y)throw new Error("unknown text editor");if(P.options&&y._acceptOptions(P.options),P.selections){const D=P.selections.selections.map(I.Selection.to);y._acceptSelections(D)}if(P.visibleRanges){const D=o.coalesce(P.visibleRanges.map(I.Range.to));y._acceptVisibleRanges(D)}if(P.options&&this.b.fire({textEditor:y.value,options:{...P.options,lineNumbers:I.TextEditorLineNumbersStyle.to(P.options.lineNumbers)}}),P.selections){const D=A.TextEditorSelectionChangeKind.fromValue(P.selections.source),v=P.selections.selections.map(I.Selection.to);this.a.fire({textEditor:y.value,selections:v,kind:D})}if(P.visibleRanges){const D=o.coalesce(P.visibleRanges.map(I.Range.to));this.c.fire({textEditor:y.value,visibleRanges:D})}}$acceptEditorPositionData(L){for(const P in L){const y=this.i.getEditor(P);if(!y)throw new Error("Unknown text editor");const D=I.ViewColumn.to(L[P]);y.value.viewColumn!==D&&(y._acceptViewColumn(D),this.d.fire({textEditor:y.value,viewColumn:D}))}}getDiffInformation(L){return Promise.resolve(this.h.$getDiffInformation(L))}}e.ExtHostEditors=S}),define(ye[267],Ce([1,0,2,3,5,6,7,14,26,11]),function(ne,e,o,t,k,R,I,A,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class L{constructor(D,v){this.b=new Map,this.c=new Map,this.a=D.getProxy(k.MainContext.MainThreadTimeline),v.registerArgumentProcessor({processArgument:(d,m)=>{if(d&&d.$mid===12)if(this.b.get(d.source)&&S.ExtensionIdentifier.equals(m,this.b.get(d.source)?.extension)){const h=d.uri===void 0?void 0:o.URI.revive(d.uri);return this.c.get(d.source)?.get(P(h))?.get(d.handle)}else return;return d}})}async $getTimeline(D,v,d,m){return this.b.get(D)?.provider.provideTimeline(o.URI.revive(v),d,m)}registerTimelineProvider(D,v,d,m){const h=new R.DisposableStore,w=this.d(v.id,m,h).bind(this);let g;v.onDidChange&&(g=v.onDidChange(b=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...b,id:v.id}),this));const p=this.c;return this.f({...v,scheme:D,onDidChange:void 0,async provideTimeline(b,i,s){i?.resetCache&&(h.clear(),p.get(v.id)?.clear());const a=await v.provideTimeline(b,i,s);if(a==null)return;const u=w(b,i);return{...a,source:v.id,items:a.items.map(u)}},dispose(){for(const b of p.values())b.get(v.id)?.clear();g?.dispose(),h.dispose()}},d)}d(D,v,d){return(m,h)=>{let w;if(h?.cacheResults){let g=this.c.get(D);g===void 0&&(g=new Map,this.c.set(D,g));const p=P(m);w=g.get(p),w===void 0&&(w=new Map,g.set(p,w))}return g=>{const{iconPath:p,...b}=g,i=`${D}|${g.id??g.timestamp}`;w?.set(i,g);let s,a,u;g.iconPath&&(p instanceof I.ThemeIcon?u={id:p.id,color:p.color}:o.URI.isUri(p)?(s=p,a=p):{light:s,dark:a}=p);let c;return I.MarkdownString.isMarkdownString(b.tooltip)?c=A.MarkdownString.from(b.tooltip):(0,C.isString)(b.tooltip)?c=b.tooltip:I.MarkdownString.isMarkdownString(b.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=A.MarkdownString.from(b.detail)):(0,C.isString)(b.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=b.detail),{...b,id:b.id??void 0,handle:i,source:D,command:g.command?v.toInternal(g.command,d):void 0,icon:s,iconDark:a,themeIcon:u,tooltip:c,accessibilityInformation:g.accessibilityInformation}}}}f(D,v){if(this.b.get(D.id))throw new Error(`Timeline Provider ${D.id} already exists.`);return this.a.$registerTimelineProvider({id:D.id,label:D.label,scheme:D.scheme}),this.b.set(D.id,{provider:D,extension:v}),(0,R.toDisposable)(()=>{for(const m of this.c.values())m.get(D.id)?.clear();this.b.delete(D.id),this.a.$unregisterTimelineProvider(D.id),D.dispose()})}}e.ExtHostTimeline=L;function P(y){return y?.toString()}}),define(ye[268],Ce([1,0,6,15,2,5]),function(ne,e,o,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class I{constructor(S){this.c=new Map,this.b=S.getProxy(R.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,C,L,P){if(this.c.has(C))throw new Error(`Opener with id '${C}' already registered`);const y=P.schemes.find(D=>!I.a.has(D));if(y)throw new Error(`Scheme '${y}' is not supported. Only http and https are currently supported.`);return this.c.set(C,L),this.b.$registerUriOpener(C,P.schemes,S,P.label),(0,o.toDisposable)(()=>{this.c.delete(C),this.b.$unregisterUriOpener(C)})}async $canOpenUri(S,C,L){const P=this.c.get(S);if(!P)throw new Error(`Unknown opener with id: ${S}`);const y=k.URI.revive(C);return P.canOpenExternalUri(y,L)}async $openUri(S,C,L){const P=this.c.get(S);if(!P)throw new Error(`Unknown opener id: '${S}'`);return P.openExternalUri(k.URI.revive(C.resolvedUri),{sourceUri:k.URI.revive(C.sourceUri)},L)}}e.ExtHostUriOpeners=I,I.a=new Set([t.Schemas.http,t.Schemas.https])}),define(ye[269],Ce([1,0,5,2,6,10,26]),function(ne,e,o,t,k,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(C){this.c=new Set,this.d=new Map,this.b=C.getProxy(o.MainContext.MainThreadUrls)}registerUriHandler(C,L){if(this.c.has(I.ExtensionIdentifier.toKey(C)))throw new Error(`Protocol handler already registered for extension ${C}`);const P=A.a++;return this.c.add(I.ExtensionIdentifier.toKey(C)),this.d.set(P,L),this.b.$registerUriHandler(P,C),(0,k.toDisposable)(()=>{this.c.delete(I.ExtensionIdentifier.toKey(C)),this.d.delete(P),this.b.$unregisterUriHandler(P)})}$handleExternalUri(C,L){const P=this.d.get(C);if(!P)return Promise.resolve(void 0);try{P.handleUri(t.URI.revive(L))}catch(y){(0,R.onUnexpectedError)(y)}return Promise.resolve(void 0)}async createAppUri(C){return t.URI.revive(await this.b.$createAppUri(C))}}e.ExtHostUrls=A,A.a=0});var Je=this&&this.__classPrivateFieldSet||function(ne,e,o,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ne,o):k?k.value=o:e.set(ne,o),o},Ue=this&&this.__classPrivateFieldGet||function(ne,e,o,t){if(o==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?t:o==="a"?t.call(ne):t?t.value:e.get(ne)};define(ye[74],Ce([1,0,4,15,23,2,192,214,93,5]),function(ne,e,o,t,k,R,I,A,S,C){"use strict";var L,P,y,D,v,d,m,h,w,g,p,b,i;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class s{constructor(T,M,G,V,N,U,F){L.set(this,void 0),P.set(this,void 0),y.set(this,void 0),D.set(this,void 0),v.set(this,void 0),d.set(this,void 0),m.set(this,""),h.set(this,void 0),w.set(this,!1),g.set(this,!1),p.set(this,void 0),b.set(this,void 0),this._onMessageEmitter=new o.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,i.set(this,new o.Emitter),this._onDidDispose=Ue(this,i,"f").event,Je(this,L,T,"f"),Je(this,P,M,"f"),Je(this,h,G,"f"),Je(this,D,V,"f"),Je(this,v,N,"f"),Je(this,d,U,"f"),Je(this,p,a(U),"f"),Je(this,b,u(U),"f"),Je(this,y,F,"f")}dispose(){Je(this,w,!0,"f"),Ue(this,i,"f").fire(),Ue(this,i,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(T){return Je(this,g,!0,"f"),(0,S.asWebviewUri)(T,Ue(this,D,"f"))}get cspSource(){const T=Ue(this,d,"f").extensionLocation;if(T.scheme===t.Schemas.https||T.scheme===t.Schemas.http){let M=T.toString();return M.endsWith("/")||(M+="/"),M+" "+S.webviewGenericCspSource}return S.webviewGenericCspSource}get html(){return this.a(),Ue(this,m,"f")}set html(T){this.a(),Ue(this,m,"f")!==T&&(Je(this,m,T,"f"),Ue(this,b,"f")&&!Ue(this,g,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(T)&&(Je(this,g,!0,"f"),Ue(this,y,"f").report("Webview vscode-resource: uris",Ue(this,d,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,P,"f").$setHtml(Ue(this,L,"f"),this.b(T)))}get options(){return this.a(),Ue(this,h,"f")}set options(T){this.a(),k.equals(Ue(this,h,"f"),T)||Ue(this,P,"f").$setOptions(Ue(this,L,"f"),n(Ue(this,d,"f"),Ue(this,v,"f"),T)),Je(this,h,T,"f")}async postMessage(T){if(Ue(this,w,"f"))return!1;const M=(0,A.serializeWebviewMessage)(T,{serializeBuffersForPostMessage:Ue(this,p,"f")});return Ue(this,P,"f").$postMessage(Ue(this,L,"f"),M.message,...M.buffers)}a(){if(Ue(this,w,"f"))throw new Error("Webview is disposed")}b(T){if(!Ue(this,b,"f"))return T;const M=Ue(this,d,"f").extensionLocation?.scheme===t.Schemas.vscodeRemote,G=Ue(this,d,"f").extensionLocation.scheme===t.Schemas.vscodeRemote?Ue(this,d,"f").extensionLocation.authority:void 0;return T.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(V,N,U,F,z,B)=>{const W=R.URI.from({scheme:F||"file",path:decodeURIComponent(z)}),X=(0,S.asWebviewUri)(W,{isRemote:M,authority:G}).toString();return`${N}${X}${B}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(V,N,U,F,z,B)=>{const W=R.URI.from({scheme:F||"file",path:decodeURIComponent(z)}),X=(0,S.asWebviewUri)(W,{isRemote:M,authority:G}).toString();return`${N}${X}${B}`})}}e.ExtHostWebview=s,L=new WeakMap,P=new WeakMap,y=new WeakMap,D=new WeakMap,v=new WeakMap,d=new WeakMap,m=new WeakMap,h=new WeakMap,w=new WeakMap,g=new WeakMap,p=new WeakMap,b=new WeakMap,i=new WeakMap;function a(E){try{const T=(0,I.normalizeVersion)((0,I.parseVersion)(E.engines.vscode));return!!T&&T.majorBase>=1&&T.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=a;function u(E){try{const T=(0,I.normalizeVersion)((0,I.parseVersion)(E.engines.vscode));return T?T.majorBase<1||T.majorBase===1&&T.minorBase<60:!1}catch{return!1}}class c{constructor(T,M,G,V,N){this.c=M,this.d=G,this.e=V,this.f=N,this.b=new Map,this.a=T.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(T,M,G){const V=this.g(T);if(V){const{message:N}=(0,A.deserializeWebviewMessage)(M,G.value);V._onMessageEmitter.fire(N)}}$onMissingCsp(T,M){this.e.warn(`${M} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(T,M,G){const V=new s(T,this.a,r(M),this.c,this.d,G,this.f);return this.b.set(T,V),V._onDidDispose(()=>{this.b.delete(T)}),V}deleteWebview(T){this.b.delete(T)}g(T){return this.b.get(T)}}e.ExtHostWebviews=c;function l(E){return{id:E.identifier,location:E.extensionLocation}}e.toExtensionData=l;function n(E,T,M){return{enableCommandUris:M.enableCommandUris,enableScripts:M.enableScripts,enableForms:M.enableForms,portMapping:M.portMapping,localResourceRoots:M.localResourceRoots||f(E,T)}}e.serializeWebviewOptions=n;function r(E){return{enableCommandUris:E.enableCommandUris,enableScripts:E.enableScripts,enableForms:E.enableForms,portMapping:E.portMapping,localResourceRoots:E.localResourceRoots?.map(T=>R.URI.from(T))}}function f(E,T){return[...(T?.getWorkspaceFolders()||[]).map(M=>M.uri),E.extensionLocation]}}),define(ye[270],Ce([1,0,21,85,6,15,24,2,14,74,69,5,7]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class D{constructor(s,a){this.document=s,this.b=a,this.a=1,this.c=new L.Cache("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,a){await this.f(s).undo(),a||this.disposeBackup()}async redo(s,a){await this.f(s).redo(),a||this.disposeBackup()}disposeEdits(s){for(const a of s)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=b(this.document.uri)+this.a++;return(0,I.joinPath)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const a=this.c.get(s,0);if(!a)throw new Error("No edit found");return a}}class v{constructor(){this.a=new Map}get(s,a){return this.a.get(this.b(s,a))}add(s,a,u){const c=this.b(s,a.uri);if(this.a.has(c))throw new Error(`Document already exists for viewType:${s} resource:${a.uri}`);const l=new D(a,u);return this.a.set(c,l),l}delete(s,a){const u=this.b(s,a.uri);this.a.delete(u)}b(s,a){return`${s}@@@${a}`}}var d;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(d||(d={}));class m{constructor(){this.a=new Map}addTextProvider(s,a,u){return this.b(0,s,a,u)}addCustomProvider(s,a,u){return this.b(1,s,a,u)}get(s){return this.a.get(s)}b(s,a,u,c){if(this.a.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this.a.set(a,{type:s,extension:u,provider:c}),new y.Disposable(()=>this.a.delete(a))}}class h{constructor(s,a,u,c,l){this.d=a,this.f=u,this.g=c,this.h=l,this.b=new m,this.c=new v,this.a=s.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(s,a,u,c){const l=new k.DisposableStore;return g(u)?(l.add(this.b.addTextProvider(a,s,u)),this.a.$registerTextEditorProvider((0,C.toExtensionData)(s),a,c.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,C.shouldSerializeBuffersForPostMessage)(s))):(l.add(this.b.addCustomProvider(a,s,u)),w(u)&&l.add(u.onDidChangeCustomDocument(n=>{const r=this.i(a,n.document.uri);if(p(n)){const f=r.addEdit(n);this.a.$onDidEdit(n.document.uri,a,f,n.label)}else this.a.$onContentChange(n.document.uri,a)})),this.a.$registerCustomEditorProvider((0,C.toExtensionData)(s),a,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,C.shouldSerializeBuffersForPostMessage)(s))),y.Disposable.from(l,new y.Disposable(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument(s,a,u,c,l){const n=this.b.get(a);if(!n)throw new Error(`No provider found for '${a}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${a}'`);const r=A.URI.revive(s),f=await n.provider.openCustomDocument(r,{backupId:u,untitledDocumentData:c?.buffer},l);let E;return w(n.provider)&&this.f&&(E=this.f.workspaceValue(n.extension)??this.f.globalValue(n.extension)),this.c.add(a,f,E),{editable:w(n.provider)}}async $disposeCustomDocument(s,a){const u=this.b.get(a);if(!u)throw new Error(`No provider found for '${a}'`);if(u.type!==1)throw new Error(`Invalid provider type for '${a}'`);const c=A.URI.revive(s),{document:l}=this.i(a,c);this.c.delete(a,l),l.dispose()}async $resolveCustomEditor(s,a,u,c,l,n){console.log("xxxx");const r=this.b.get(u);if(!r)throw new Error(`No provider found for '${u}'`);const f=S.ViewColumn.to(l),E=this.g.createNewWebview(a,c.contentOptions,r.extension),T=this.h.createNewWebviewPanel(a,u,c.title,f,c.options,E,!0),M=A.URI.revive(s);switch(r.type){case 1:{const{document:G}=this.i(u,M);return r.provider.resolveCustomEditor(G,T,n)}case 0:{const G=this.d.getDocument(M);return r.provider.resolveCustomTextEditor(G,T,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,a,u){this.i(a,s).disposeEdits(u)}async $onMoveCustomEditor(s,a,u){const c=this.b.get(u);if(!c)throw new Error(`No provider found for '${u}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const l=this.h.getWebviewPanel(s);if(!l)throw new Error("No webview found");const n=A.URI.revive(a),r=this.d.getDocument(n);await c.provider.moveCustomTextEditor(r,l,o.CancellationToken.None)}async $undo(s,a,u,c){return this.i(a,s).undo(u,c)}async $redo(s,a,u,c){return this.i(a,s).redo(u,c)}async $revert(s,a,u){const c=this.i(a,s);await this.j(a).revertCustomDocument(c.document,u),c.disposeBackup()}async $onSave(s,a,u){const c=this.i(a,s);await this.j(a).saveCustomDocument(c.document,u),c.disposeBackup()}async $onSaveAs(s,a,u,c){const l=this.i(a,s);return this.j(a).saveCustomDocumentAs(l.document,A.URI.revive(u),c)}async $backup(s,a,u){const c=this.i(a,s),n=await this.j(a).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},u);return c.updateBackup(n),n.id}i(s,a){const u=this.c.get(s,A.URI.revive(a));if(!u)throw new Error("No custom document found");return u}j(s){const u=this.b.get(s)?.provider;if(!u||!w(u))throw new Error("Custom document is not editable");return u}}e.ExtHostCustomEditors=h;function w(i){return!!i.onDidChangeCustomDocument}function g(i){return typeof i.resolveCustomTextEditor=="function"}function p(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function b(i){const s=i.scheme===R.Schemas.file||i.scheme===R.Schemas.untitled?i.fsPath:i.toString();return(0,t.hash)(s)+""}});var Je=this&&this.__classPrivateFieldSet||function(ne,e,o,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ne,o):k?k.value=o:e.set(ne,o),o},Ue=this&&this.__classPrivateFieldGet||function(ne,e,o,t){if(o==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?t:o==="a"?t.call(ne):t?t.value:e.get(ne)};define(ye[271],Ce([1,0,4,6,2,30,14,74,5,7]),function(ne,e,o,t,k,R,I,A,S,C){"use strict";var L,P,y,D,v,d,m,h,w,g,p,b,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class s extends t.Disposable{constructor(l,n,r,f){super(),L.set(this,void 0),P.set(this,void 0),y.set(this,void 0),D.set(this,void 0),v.set(this,void 0),d.set(this,void 0),m.set(this,void 0),h.set(this,void 0),w.set(this,!0),g.set(this,void 0),p.set(this,!1),b.set(this,this.B(new o.Emitter)),this.onDidDispose=Ue(this,b,"f").event,i.set(this,this.B(new o.Emitter)),this.onDidChangeViewState=Ue(this,i,"f").event,Je(this,L,l,"f"),Je(this,P,n,"f"),Je(this,D,r,"f"),Je(this,y,f.viewType,"f"),Je(this,v,f.panelOptions,"f"),Je(this,h,f.viewColumn,"f"),Je(this,d,f.title,"f"),Je(this,g,f.active,"f")}dispose(){Ue(this,p,"f")||(Je(this,p,!0,"f"),Ue(this,b,"f").fire(),Ue(this,P,"f").$disposeWebview(Ue(this,L,"f")),Ue(this,D,"f").dispose(),super.dispose())}get webview(){return this.c(),Ue(this,D,"f")}get viewType(){return this.c(),Ue(this,y,"f")}get title(){return this.c(),Ue(this,d,"f")}set title(l){this.c(),Ue(this,d,"f")!==l&&(Je(this,d,l,"f"),Ue(this,P,"f").$setTitle(Ue(this,L,"f"),l))}get iconPath(){return this.c(),Ue(this,m,"f")}set iconPath(l){this.c(),Ue(this,m,"f")!==l&&(Je(this,m,l,"f"),Ue(this,P,"f").$setIconPath(Ue(this,L,"f"),k.URI.isUri(l)?{light:l,dark:l}:l))}get options(){return Ue(this,v,"f")}get viewColumn(){if(this.c(),!(typeof Ue(this,h,"f")=="number"&&Ue(this,h,"f")<0))return Ue(this,h,"f")}get active(){return this.c(),Ue(this,g,"f")}get visible(){return this.c(),Ue(this,w,"f")}_updateViewState(l){Ue(this,p,"f")||(this.active!==l.active||this.visible!==l.visible||this.viewColumn!==l.viewColumn)&&(Je(this,g,l.active,"f"),Je(this,w,l.visible,"f"),Je(this,h,l.viewColumn,"f"),Ue(this,i,"f").fire({webviewPanel:this}))}reveal(l,n){this.c(),Ue(this,P,"f").$reveal(Ue(this,L,"f"),{viewColumn:typeof l>"u"?void 0:I.ViewColumn.from(l),preserveFocus:!!n})}c(){if(Ue(this,p,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,P=new WeakMap,y=new WeakMap,D=new WeakMap,v=new WeakMap,d=new WeakMap,m=new WeakMap,h=new WeakMap,w=new WeakMap,g=new WeakMap,p=new WeakMap,b=new WeakMap,i=new WeakMap;class a{static c(){return(0,R.generateUuid)()}constructor(l,n,r){this.g=n,this.h=r,this.e=new Map,this.f=new Map,this.d=l.getProxy(S.MainContext.MainThreadWebviewPanels)}createWebviewPanel(l,n,r,f,E={}){const T=typeof f=="object"?f.viewColumn:f,M={viewColumn:I.ViewColumn.from(T),preserveFocus:typeof f=="object"&&!!f.preserveFocus},G=(0,A.shouldSerializeBuffersForPostMessage)(l),V=a.c();this.d.$createWebviewPanel((0,A.toExtensionData)(l),V,n,{title:r,panelOptions:u(E),webviewOptions:(0,A.serializeWebviewOptions)(l,this.h,E),serializeBuffersForPostMessage:G},M);const N=this.g.createNewWebview(V,E,l);return this.createNewWebviewPanel(V,n,r,T,E,N,!0)}$onDidChangeWebviewPanelViewStates(l){const n=Object.keys(l);n.sort((r,f)=>{const E=l[r],T=l[f];return E.active?1:T.active?-1:+E.visible-+T.visible});for(const r of n){const f=this.getWebviewPanel(r);if(!f)continue;const E=l[r];f._updateViewState({active:E.active,visible:E.visible,viewColumn:I.ViewColumn.to(E.position)})}}async $onDidDisposeWebviewPanel(l){this.getWebviewPanel(l)?.dispose(),this.e.delete(l),this.g.deleteWebview(l)}registerWebviewPanelSerializer(l,n,r){if(this.f.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.f.set(n,{serializer:r,extension:l}),this.d.$registerSerializer(n,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(l)}),new C.Disposable(()=>{this.f.delete(n),this.d.$unregisterSerializer(n)})}async $deserializeWebviewPanel(l,n,r,f){const E=this.f.get(n);if(!E)throw new Error(`No serializer found for '${n}'`);const{serializer:T,extension:M}=E,G=this.g.createNewWebview(l,r.webviewOptions,M),V=this.createNewWebviewPanel(l,n,r.title,f,r.panelOptions,G,r.active);await T.deserializeWebviewPanel(V,r.state)}createNewWebviewPanel(l,n,r,f,E,T,M){const G=new s(l,this.d,T,{viewType:n,title:r,viewColumn:f,panelOptions:E,active:M});return this.e.set(l,G),G}getWebviewPanel(l){return this.e.get(l)}}e.ExtHostWebviewPanels=a;function u(c){return{enableFindWidget:c.enableFindWidget,retainContextWhenHidden:c.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(ne,e,o,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ne,o):k?k.value=o:e.set(ne,o),o},Ue=this&&this.__classPrivateFieldGet||function(ne,e,o,t){if(o==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?t:o==="a"?t.call(ne):t?t.value:e.get(ne)};define(ye[272],Ce([1,0,4,6,74,14,5,7]),function(ne,e,o,t,k,R,I,A){"use strict";var S,C,L,P,y,D,v,d,m,h,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class g extends t.Disposable{constructor(i,s,a,u,c,l){super(),S.set(this,void 0),C.set(this,void 0),L.set(this,void 0),P.set(this,void 0),y.set(this,!1),D.set(this,void 0),v.set(this,void 0),d.set(this,void 0),m.set(this,void 0),h.set(this,this.B(new o.Emitter)),this.onDidChangeVisibility=Ue(this,h,"f").event,w.set(this,this.B(new o.Emitter)),this.onDidDispose=Ue(this,w,"f").event,Je(this,L,a,"f"),Je(this,v,u,"f"),Je(this,S,i,"f"),Je(this,C,s,"f"),Je(this,P,c,"f"),Je(this,D,l,"f")}dispose(){Ue(this,y,"f")||(Je(this,y,!0,"f"),Ue(this,w,"f").fire(),Ue(this,P,"f").dispose(),super.dispose())}get title(){return this.a(),Ue(this,v,"f")}set title(i){this.a(),Ue(this,v,"f")!==i&&(Je(this,v,i,"f"),Ue(this,C,"f").$setWebviewViewTitle(Ue(this,S,"f"),i))}get description(){return this.a(),Ue(this,d,"f")}set description(i){this.a(),Ue(this,d,"f")!==i&&(Je(this,d,i,"f"),Ue(this,C,"f").$setWebviewViewDescription(Ue(this,S,"f"),i))}get visible(){return Ue(this,D,"f")}get webview(){return Ue(this,P,"f")}get viewType(){return Ue(this,L,"f")}_setVisible(i){i===Ue(this,D,"f")||Ue(this,y,"f")||(Je(this,D,i,"f"),Ue(this,h,"f").fire())}get badge(){return this.a(),Ue(this,m,"f")}set badge(i){this.a(),!(i?.value===Ue(this,m,"f")?.value&&i?.tooltip===Ue(this,m,"f")?.tooltip)&&(Je(this,m,R.ViewBadge.from(i),"f"),Ue(this,C,"f").$setWebviewViewBadge(Ue(this,S,"f"),i))}show(i){this.a(),Ue(this,C,"f").$show(Ue(this,S,"f"),!!i)}a(){if(Ue(this,y,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,C=new WeakMap,L=new WeakMap,P=new WeakMap,y=new WeakMap,D=new WeakMap,v=new WeakMap,d=new WeakMap,m=new WeakMap,h=new WeakMap,w=new WeakMap;class p{constructor(i,s){this.d=s,this.b=new Map,this.c=new Map,this.a=i.getProxy(I.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(i,s,a,u){if(this.b.has(s))throw new Error(`View provider for '${s}' already registered`);return this.b.set(s,{provider:a,extension:i}),this.a.$registerWebviewViewProvider((0,k.toExtensionData)(i),s,{retainContextWhenHidden:u?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(i)}),new A.Disposable(()=>{this.b.delete(s),this.a.$unregisterWebviewViewProvider(s)})}async $resolveWebviewView(i,s,a,u,c){const l=this.b.get(s);if(!l)throw new Error(`No view provider found for '${s}'`);const{provider:n,extension:r}=l,f=this.d.createNewWebview(i,{},r),E=new g(i,this.a,s,a,f,!0);this.c.set(i,E),await n.resolveWebviewView(E,{state:u},c)}async $onDidChangeWebviewViewVisibility(i,s){this.e(i)._setVisible(s)}async $disposeWebviewView(i){const s=this.e(i);this.c.delete(i),s.dispose(),this.d.deleteWebview(i)}e(i){const s=this.c.get(i);if(!s)throw new Error("No webview found");return s}}e.ExtHostWebviewViews=p}),define(ye[141],Ce([1,0,4,5,2,15,8,3,17]),function(ne,e,o,t,k,R,I,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let C=class ri{get state(){return this.d}constructor(P){this.c=new o.Emitter,this.onDidChangeWindowState=this.c.event,this.d=ri.a,this.b=P.getProxy(t.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(y=>this.$onDidChangeWindowFocus(y))}$onDidChangeWindowFocus(P){P!==this.d.focused&&(this.d={...this.d,focused:P},this.c.fire(this.d))}openUri(P,y){let D;if(typeof P=="string"){D=P;try{P=k.URI.parse(P)}catch{return Promise.reject(`Invalid uri - '${P}'`)}}return(0,I.isFalsyOrWhitespace)(P.scheme)?Promise.reject("Invalid scheme - cannot be empty"):P.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${P.scheme}'`):this.b.$openUri(P,D,y)}async asExternalUri(P,y){if((0,I.isFalsyOrWhitespace)(P.scheme))return Promise.reject("Invalid scheme - cannot be empty");const D=await this.b.$asExternalUri(P,y);return k.URI.from(D)}};C.a={focused:!0},C=qe([He(0,S.IExtHostRpcService)],C),e.ExtHostWindow=C,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(ye[273],Ce([1,0,118,274,65,39,2,13,46]),function(ne,e,o,t,k,R,I,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class C{constructor(y,D,v){this.b=y,this.c=D,this.f=v,this.a=t.createServer((d,m)=>this.h(d,m)),this.g().catch(d=>(D.error(d),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",y=>this.c.error(y))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(y,D){const v=(m,h)=>{D.writeHead(m,{"content-type":"application/json"}),D.end(JSON.stringify(h||null),w=>w&&this.c.error(w))},d=[];y.setEncoding("utf8"),y.on("data",m=>d.push(m)),y.on("end",async()=>{try{const m=JSON.parse(d.join(""));let h;switch(m.type){case"open":h=await this.i(m);break;case"openExternal":h=await this.j(m);break;case"status":h=await this.l(m);break;case"extensionManagement":h=await this.k(m);break;default:v(404,`Unknown message type: ${m.type}`);break}v(200,h)}catch(m){const h=m instanceof Error?m.message:JSON.stringify(m);v(500,h),this.c.error("Error while processing pipe request",m)}})}async i(y){const{fileURIs:D,folderURIs:v,forceNewWindow:d,diffMode:m,mergeMode:h,addMode:w,forceReuseWindow:g,gotoLineMode:p,waitMarkerFilePath:b,remoteAuthority:i}=y,s=[];if(Array.isArray(v))for(const l of v)try{s.push({folderUri:I.URI.parse(l)})}catch{}if(Array.isArray(D))for(const l of D)try{(0,S.hasWorkspaceFileExtension)(l)?s.push({workspaceUri:I.URI.parse(l)}):s.push({fileUri:I.URI.parse(l)})}catch{}const a=b?I.URI.file(b):void 0,c={forceNewWindow:d,diffMode:m,mergeMode:h,addMode:w,gotoLineMode:p,forceReuseWindow:g,preferNewWindow:!g&&!a&&!w,waitMarkerFileURI:a,remoteAuthority:i};return this.b.executeCommand("_remoteCLI.windowOpen",s,c),""}async j(y){for(const D of y.uris){const v=I.URI.parse(D),d=v.scheme==="file"?v:D;await this.b.executeCommand("_remoteCLI.openExternal",d)}}async k(y){const D=d=>d?.map(m=>/\.vsix$/i.test(m)?I.URI.parse(m):m),v={list:y.list,install:D(y.install),uninstall:D(y.uninstall),force:y.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",v)}async l(y){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&k.existsSync(this.f)&&k.unlinkSync(this.f)}}e.CLIServerBase=C;let L=class extends C{constructor(y,D){super(y,D,(0,o.createRandomIPCHandle)())}};L=qe([He(0,R.IExtHostCommands),He(1,A.ILogService)],L),e.CLIServer=L}),define(ye[275],Ce([1,0,246,25,17]),function(ne,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const R=1024*1024;let I=class extends o.AbstractExtHostConsoleForwarder{constructor(S,C){super(S,C),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(S,C,L){const P=S==="error"||S==="warn"?process.stderr:process.stdout;this.g=!0,P.write(`
START_NATIVE_LOG
`),C.apply(console,L),P.write(`
END_NATIVE_LOG
`),this.g=!1}j(S,C){const L=process[S],P=L.write;let y="";Object.defineProperty(L,"write",{set:()=>{},get:()=>(D,v,d)=>{if(!this.g){y+=D.toString(v);const m=y.length>R?y.length:y.lastIndexOf(`
`);m!==-1&&(console[C](y.slice(0,m)),y=y.slice(m+1))}P.call(L,D,v,d)}})}};I=qe([He(0,k.IExtHostRpcService),He(1,t.IExtHostInitDataService)],I),e.ExtHostConsoleForwarder=I}),define(ye[276],Ce([1,0,9,87,30,39,6,5,2,17]),function(ne,e,o,t,k,R,I,A,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let L=class extends I.Disposable{constructor(y,D){super();const v=y.getProxy(A.MainContext.MainThreadDownloadService);D.registerCommand(!1,"_workbench.downloadResource",async d=>{const m=S.URI.file((0,o.join)((0,t.tmpdir)(),(0,k.generateUuid)()));return await v.$download(d,m),m})}};L=qe([He(0,C.IExtHostRpcService),He(1,R.IExtHostCommands)],L),e.ExtHostDownloadService=L}),define(ye[277],Ce([1,0,140,15,198,30]),function(ne,e,o,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class I extends o.ExtHostLoggerService{f(S,C,L){return S.scheme===t.Schemas.file?new k.SpdLogLogger(L?.name||(0,R.generateUuid)(),S.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,C):super.f(S,C,L)}}e.ExtHostLoggerService=I}),define(ye[278],Ce([1,0,65,9,2,73,6,15,16,29]),function(ne,e,o,t,k,R,I,A,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class L extends R.ExtensionStoragePaths{constructor(){super(...arguments),this.i=null}async g(i){const s=await super.g(i);if(s.scheme!==A.Schemas.file)return s;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${s.fsPath}.`),s;const a=s.fsPath;let u=0;do{let c;u===0?c=a:c=/[/\\]$/.test(a)?`${a.substr(0,a.length-1)}-${u}`:`${a}-${u}`,await P(c);const l=t.join(c,"vscode.lock"),n=await d(this.d,l,!1);if(n)return this.i=n,process.on("exit",()=>{n.dispose()}),k.URI.file(c);u++}while(u<10);return s}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.ExtensionStoragePaths=L;async function P(b){try{await C.Promises.stat(b);return}catch{}try{await C.Promises.mkdir(b,{recursive:!0})}catch{}}const y=1e3,D=10*60*1e3;class v extends I.Disposable{constructor(i,s){super(),this.b=i,this.c=s,this.a=this.B(new S.IntervalTimer),this.a.cancelAndSet(async()=>{const a=await m(i,s);(!a||a.pid!==process.pid)&&(i.info(`Lock '${s}': The lock was lost unexpectedly.`),this.a.cancel());try{await C.Promises.utimes(s,new Date,new Date)}catch(u){i.error(u),i.info(`Lock '${s}': Could not update mtime.`)}},y)}dispose(){super.dispose();try{o.unlinkSync(this.c)}catch{}}async setWillRelease(i){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${i} ms.`);try{const s={pid:process.pid,willReleaseAt:Date.now()+i};await C.Promises.writeFile(this.c,JSON.stringify(s),{flag:"w"})}catch(s){this.b.error(s)}}}async function d(b,i,s){try{const u={pid:process.pid,willReleaseAt:0};await C.Promises.writeFile(i,JSON.stringify(u),{flag:"wx"})}catch(u){b.error(u)}const a=await m(b,i);return!a||a.pid!==process.pid?s?(b.info(`Lock '${i}': Could not acquire lock, giving up.`),null):(b.info(`Lock '${i}': Could not acquire lock, checking if the file is stale.`),g(b,i)):(b.info(`Lock '${i}': Lock acquired.`),new v(b,i))}async function m(b,i){let s;try{s=await C.Promises.readFile(i)}catch(a){return b.error(a),null}try{return JSON.parse(String(s))}catch(a){return b.error(a),null}}async function h(b,i){let s;try{s=await C.Promises.stat(i)}catch(a){return b.error(a),0}return s.mtime.getTime()}function w(b){try{return process.kill(b,0),!0}catch{return!1}}async function g(b,i){const s=await m(b,i);if(!s)return b.info(`Lock '${i}': Could not read pid of lock holder.`),p(b,i);if(s.willReleaseAt){let n=s.willReleaseAt-Date.now();if(n<5e3){for(n>0?b.info(`Lock '${i}': The lockfile is scheduled to be released in ${n} ms.`):b.info(`Lock '${i}': The lockfile is scheduled to have been released.`);n>0;){if(await(0,S.timeout)(Math.min(100,n)),await h(b,i)===0)return p(b,i);n=s.willReleaseAt-Date.now()}return p(b,i)}}if(!w(s.pid))return b.info(`Lock '${i}': The pid ${s.pid} appears to be gone.`),p(b,i);const a=await h(b,i),u=Date.now()-a;if(u<=D)return b.info(`Lock '${i}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null;b.info(`Lock '${i}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const c=await h(b,i),l=Date.now()-c;return l<=D?(b.info(`Lock '${i}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null):(b.info(`Lock '${i}': The lock looks stale even after waiting for 2s.`),p(b,i))}async function p(b,i){b.info(`Lock '${i}': Deleting a stale lock.`);try{await C.Promises.unlink(i)}catch{}return d(b,i,!0)}}),define(ye[279],Ce([1,0,30,17,40]),function(ne,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let R=class extends k.BaseExtHostTerminalService{constructor(A){super(!0,A)}createTerminal(A,S,C){return this.createTerminalFromOptions({name:A,shellPath:S,shellArgs:C})}createTerminalFromOptions(A,S){const C=new k.ExtHostTerminal(this.a,(0,o.generateUuid)(),A,A.name);return this.f.push(C),C.create(A,this.L(A,S)),C.value}};R=qe([He(0,t.IExtHostRpcService)],R),e.ExtHostTerminalService=R}),define(ye[280],Ce([1,0,5,17,181,6,25,2,45,24,29,7,12,54,4,129,101,13]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y,D,v,d,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.loadListeningPorts=e.getSockets=void 0;class w extends d.DisposableTunnel{}function g(n){const r=n.trim().split(`
`),f=[];return r.forEach(T=>{const M=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(T);M&&M.length>=3&&f.push({pid:parseInt(M[1],10),socket:parseInt(M[2],10)})}),f.reduce((T,M)=>(T[M.socket]=M,T),{})}e.getSockets=g;function p(...n){const r=[].concat(...n.map(i));return[...new Map(r.filter(f=>f.st==="0A").map(f=>{const E=f.local_address.split(":");return{socket:parseInt(f.inode,10),ip:b(E[0]),port:parseInt(E[1],16)}}).map(f=>[f.ip+":"+f.port,f])).values()]}e.loadListeningPorts=p;function b(n){let r="";if(n.length===8)for(let f=n.length-2;f>=0;f-=2)r+=parseInt(n.substr(f,2),16),f!==0&&(r+=".");else for(let f=n.length-4;f>=0;f-=4)r+=parseInt(n.substr(f,4),16).toString(16),f!==0&&(r+=":");return r}function i(n){const r=n.trim().split(`
`),f=r.shift().trim().split(/\s+/).filter(T=>T!=="rx_queue"&&T!=="tm->when");return r.map(T=>T.trim().split(/\s+/).reduce((M,G,V)=>(M[f[V]||V]=G,M),{}))}e.loadConnectionTable=i;function s(n){return!!n.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||n.indexOf("out/server-main.js")!==-1||n.indexOf("_productName=VSCode")!==-1}function a(n){const r=n.trim().split(`
`),f=[];return r.forEach(E=>{const T=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(E);T&&T.length>=4&&f.push({pid:parseInt(T[1],10),ppid:parseInt(T[2]),cmd:T[3]})}),f}e.getRootProcesses=a;async function u(n,r,f){const E=f.reduce((M,G)=>(M[G.pid]=G,M),{}),T=[];return n.forEach(({socket:M,ip:G,port:V})=>{const N=r[M]?r[M].pid:void 0,U=N?E[N]?.cmd:void 0;N&&U&&!s(U)&&T.push({host:G,port:V,detail:U,pid:N})}),T}e.findPorts=u;function c(n,r,f){const E=new Map,T=a(r);for(const M of n){const G=f.get(M.port);if(G){E.set(M.port,G);continue}const V=T.find(N=>N.cmd.includes(`${M.port}`));if(V){let N=V,U;do U=T.find(F=>F.ppid===N.pid),U&&(N=U);while(U);E.set(M.port,{host:M.ip,port:M.port,pid:N.pid,detail:N.cmd,ppid:N.ppid})}else E.set(M.port,{host:M.ip,port:M.port,ppid:Number.MAX_VALUE})}return E}e.tryFindRootPorts=c;let l=class extends R.Disposable{constructor(r,f,E){super(),this.n=E,this.c=()=>Promise.resolve(!0),this.f=new Map,this.g=new v.Emitter,this.onDidChangeTunnels=this.g.event,this.h=!1,this.j=new Map,this.k=0,this.l=new Map,this.a=r.getProxy(o.MainContext.MainThreadTunnelService),y.isLinux&&f.remote.isRemote&&f.remote.authority&&this.a.$setRemoteTunnelService(process.pid)}async openTunnel(r,f){this.n.trace(`ForwardedPorts: (ExtHostTunnelService) ${r.identifier.value} called openTunnel API for ${f.remoteAddress.host}:${f.remoteAddress.port}.`);const E=await this.a.$openTunnel(f,r.displayName);if(E){const T=new w(E.remoteAddress,E.localAddress,()=>this.a.$closeTunnel(E.remoteAddress));return this.B(T),T}}async getTunnels(){return this.a.$getTunnels()}p(r){return Math.max(r*20,2e3)}r(){return this.k++}registerPortsAttributesProvider(r,f){const E=this.r();return this.l.set(E,{selector:r,provider:f}),this.a.$registerPortsAttributesProvider(r,E),new P.Disposable(()=>{this.l.delete(E),this.a.$unregisterPortsAttributesProvider(E)})}async $providePortAttributes(r,f,E,T,M){const G=[];for(const N of r){const U=this.l.get(N);if(!U)return[];G.push(...await Promise.all(f.map(async F=>U.provider.providePortAttributes(F,E,T,M))))}const V=G.filter(N=>!!N);return V.length>0?V.map(N=>({autoForwardAction:N.autoForwardAction,port:N.port})):[]}async $registerCandidateFinder(r){if(r&&this.h)return;this.h=r;const f=new m.MovingAverage;let E;for(;this.h;){const T=new Date().getTime(),M=(await this.findCandidatePorts()).filter(V=>(0,d.isLocalhost)(V.host)||(0,d.isAllInterfaces)(V.host));this.n.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${M.map(V=>V.port).join(", ")}`);const G=new Date().getTime()-T;f.update(G),(!E||JSON.stringify(E)!==JSON.stringify(M))&&(E=M,await this.a.$onFoundNewCandidates(E)),await new Promise(V=>setTimeout(()=>V(),this.p(f.value)))}}async setTunnelFactory(r){if(r){if(r.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(r.candidatePortSource),r.showCandidatePort&&(this.c=r.showCandidatePort,this.a.$setCandidateFilter()),r.tunnelFactory){this.b=r.tunnelFactory;let f=r.tunnelFeatures?.privacyOptions??[];r.tunnelFeatures?.public&&f.length===0&&(f=[{id:"private",label:k.localize(0,null),themeIcon:"lock"},{id:"public",label:k.localize(1,null),themeIcon:"eye"}]);const E=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,public:!!r.tunnelFeatures?.public,privacyOptions:f}:void 0;this.a.$setTunnelProvider(E)}}else this.b=void 0;return(0,R.toDisposable)(()=>{this.b=void 0})}async $closeTunnel(r,f){if(this.f.has(r.host)){const E=this.f.get(r.host);E.has(r.port)&&(f&&E.get(r.port).disposeListener.dispose(),await E.get(r.port).tunnel.dispose(),E.delete(r.port))}}async $onDidTunnelsChange(){this.g.fire()}async $forwardPort(r,f){if(this.b)try{this.n.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const E=this.b(r,f);if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),E!==void 0){const T=await E;this.n.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this.f.has(r.remoteAddress.host)||this.f.set(r.remoteAddress.host,new Map);const M=this.B(T.onDidDispose(()=>(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(T.remoteAddress))));return this.f.get(r.remoteAddress.host).set(r.remoteAddress.port,{tunnel:T,disposeListener:M}),D.TunnelDtoConverter.fromApiTunnel(T)}else this.n.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.n.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(r){const f=await Promise.all(r.map(T=>this.c(T.host,T.port,T.detail??""))),E=r.filter((T,M)=>f[M]);return this.n.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${r.map(T=>T.port).join(", ")} to ${E.map(T=>T.port).join(", ")}`),E}async findCandidatePorts(){let r="",f="";try{r=await L.Promises.readFile("/proc/net/tcp","utf8"),f=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const E=p(r,f),T=await new Promise(B=>{(0,S.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(W,X,q)=>{B(X)})}),M=g(T),G=await L.Promises.readdir("/proc"),V=[];for(const B of G)try{const W=Number(B),X=C.joinPath(A.URI.file("/proc"),B);if((await L.Promises.stat(X.fsPath)).isDirectory()&&!isNaN(W)){const _=await L.Promises.readlink(C.joinPath(X,"cwd").fsPath),Q=await L.Promises.readFile(C.joinPath(X,"cmdline").fsPath,"utf8");V.push({pid:W,cwd:_,cmd:Q})}}catch{}const N=[],U=E.filter(B=>{const W=M[B.socket];return W||N.push(B),W}),F=u(U,M,V);let z;if(this.n.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${N.length}`),N.length>0){const B=await new Promise(W=>{(0,S.exec)("ps -F -A -l | grep root",(X,q,_)=>{W(q)})});this.j=c(N,B,this.j),z=Array.from(this.j.values()),this.n.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${z.map(W=>W.port).join(", ")}`)}return F.then(B=>z?B.concat(z):B)}};l=qe([He(0,t.IExtHostRpcService),He(1,I.IExtHostInitDataService),He(2,h.ILogService)],l),e.ExtHostTunnelService=l}),define(ye[281],Ce([1,0,16,22,21,10,4,6,113,240,57]),function(ne,e,o,t,k,R,I,A,S,C,L){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function y(E,T){try{return JSON.stringify(E,T)}catch{return"null"}}const D="$$ref$$",v={[D]:-1};class d{constructor(T,M){this.jsonString=T,this.referencedBuffers=M}}function m(E,T=null,M=!1){const G=[];return{jsonString:(M?y:JSON.stringify)(E,(N,U)=>{if(typeof U>"u")return v;if(typeof U=="object"){if(U instanceof t.VSBuffer){const F=G.push(U)-1;return{[D]:F}}if(T)return T(N,U)}return U}),referencedBuffers:G}}e.stringifyJsonWithBufferRefs=m;function h(E,T,M){return JSON.parse(E,(G,V)=>{if(V){const N=V[D];if(typeof N=="number")return T[N];if(M&&V.$mid===1)return M.transformIncoming(V)}return V})}e.parseJsonAndRestoreBufferRefs=h;function w(E,T){return JSON.stringify(E,T)}function g(E){return E?(T,M)=>M&&M.$mid===1?E.transformOutgoing(M):M:null}var p;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(p=e.RequestInitiator||(e.RequestInitiator={}));var b;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(b=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},s=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class u extends A.Disposable{constructor(T,M=null,G=null){super(),this[P]=!0,this.b=this.B(new I.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=T,this.f=M,this.g=G,this.h=g(this.g),this.j=!1,this.k=[],this.l=[];for(let V=0,N=L.ProxyIdentifier.count;V<N;V++)this.k[V]=null,this.l[V]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new o.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(V=>this.G(V))}dispose(){this.j=!0,Object.keys(this.s).forEach(T=>{this.s[T].resolveErr(R.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(T){this.u===0&&(this.v=Date.now()+u.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(T){this.v=Date.now()+u.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(T){this.t!==T&&(this.t=T,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(T){return this.g?(0,S.transformIncomingURIs)(T,this.g):T}getProxy(T){const{nid:M,sid:G}=T;return this.l[M]||(this.l[M]=this.F(M,G)),this.l[M]}F(T,M){const G={get:(V,N)=>(typeof N=="string"&&!V[N]&&N.charCodeAt(0)===36&&(V[N]=(...U)=>this.O(T,N,U)),N===a?M:V[N])};return new Proxy(Object.create(null),G)}set(T,M){return this.k[T.nid]=M,M}assertRegistered(T){for(let M=0,G=T.length;M<G;M++){const V=T[M];if(!this.k[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}G(T){if(this.j)return;const M=T.byteLength,G=c.read(T,0),V=G.readUInt8(),N=G.readUInt32();switch(V){case 1:case 2:{let{rpcId:U,method:F,args:z}=n.deserializeRequestJSONArgs(G);this.g&&(z=(0,S.transformIncomingURIs)(z,this.g)),this.H(M,N,U,F,z,V===2);break}case 3:case 4:{let{rpcId:U,method:F,args:z}=n.deserializeRequestMixedArgs(G);this.g&&(z=(0,S.transformIncomingURIs)(z,this.g)),this.H(M,N,U,F,z,V===4);break}case 5:{this.f?.logIncoming(M,N,0,"ack"),this.z(N);break}case 6:{this.I(M,N);break}case 7:{this.J(M,N,void 0);break}case 9:{let U=n.deserializeReplyOKJSON(G);this.g&&(U=(0,S.transformIncomingURIs)(U,this.g)),this.J(M,N,U);break}case 10:{const U=n.deserializeReplyOKJSONWithBuffers(G,this.g);this.J(M,N,U);break}case 8:{const U=n.deserializeReplyOKVSBuffer(G);this.J(M,N,U);break}case 11:{let U=n.deserializeReplyErrError(G);this.g&&(U=(0,S.transformIncomingURIs)(U,this.g)),this.L(M,N,U);break}case 12:{this.L(M,N,void 0);break}default:console.error("received unexpected message"),console.error(T)}}H(T,M,G,V,N,U){this.f?.logIncoming(T,M,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(G)}.${V}(`,N);const F=String(M);let z,B;if(U){const X=new k.CancellationTokenSource;N.push(X.token),z=this.M(G,V,N),B=()=>X.cancel()}else z=this.M(G,V,N),B=i;this.p[F]=B;const W=n.serializeAcknowledged(M);this.f?.logOutgoing(W.byteLength,M,1,"ack"),this.c.send(W),z.then(X=>{delete this.p[F];const q=n.serializeReplyOK(M,X,this.h);this.f?.logOutgoing(q.byteLength,M,1,"reply:",X),this.c.send(q)},X=>{delete this.p[F];const q=n.serializeReplyErr(M,X);this.f?.logOutgoing(q.byteLength,M,1,"replyErr:",X),this.c.send(q)})}I(T,M){this.f?.logIncoming(T,M,1,"receiveCancel");const G=String(M);this.p[G]?.()}J(T,M,G){this.f?.logIncoming(T,M,0,"receiveReply:",G);const V=String(M);if(!this.s.hasOwnProperty(V))return;const N=this.s[V];delete this.s[V],N.resolveOk(G)}L(T,M,G){this.f?.logIncoming(T,M,0,"receiveReplyErr:",G);const V=String(M);if(!this.s.hasOwnProperty(V))return;const N=this.s[V];delete this.s[V];let U;G&&(G.$isError?(U=new Error,U.name=G.name,U.message=G.message,U.stack=G.stack):U=G),N.resolveErr(U)}M(T,M,G){try{return Promise.resolve(this.N(T,M,G))}catch(V){return Promise.reject(V)}}N(T,M,G){const V=this.k[T];if(!V)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(T));const N=V[M];if(typeof N!="function")throw new Error("Unknown method "+M+" on actor "+(0,L.getStringIdentifierForProxy)(T));return N.apply(V,G)}O(T,M,G){if(this.j)return new C.CanceledLazyPromise;let V=null;if(G.length>0&&k.CancellationToken.isCancellationToken(G[G.length-1])&&(V=G.pop()),V&&V.isCancellationRequested)return Promise.reject(R.canceled());const N=n.serializeRequestArguments(G,this.h),U=++this.m,F=String(U),z=new C.LazyPromise;V&&V.onCancellationRequested(()=>{const W=n.serializeCancel(U);this.f?.logOutgoing(W.byteLength,U,0,"cancel"),this.c.send(n.serializeCancel(U))}),this.s[F]=z,this.y(U);const B=n.serializeRequest(U,T,M,N,!!V);return this.f?.logOutgoing(B.byteLength,U,0,`request: ${(0,L.getStringIdentifierForProxy)(T)}.${M}(`,G),this.c.send(B),z}}e.RPCProtocol=u,P=s,u.a=3*1e3;class c{static alloc(T,M,G){const V=new c(t.VSBuffer.alloc(G+1+4),0);return V.writeUInt8(T),V.writeUInt32(M),V}static read(T,M){return new c(T,M)}get buffer(){return this.a}constructor(T,M){this.a=T,this.b=M}static sizeUInt8(){return 1}writeUInt8(T){this.a.writeUInt8(T,this.b),this.b+=1}readUInt8(){const T=this.a.readUInt8(this.b);return this.b+=1,T}writeUInt32(T){this.a.writeUInt32BE(T,this.b),this.b+=4}readUInt32(){const T=this.a.readUInt32BE(this.b);return this.b+=4,T}static sizeShortString(T){return 1+T.byteLength}writeShortString(T){this.a.writeUInt8(T.byteLength,this.b),this.b+=1,this.a.set(T,this.b),this.b+=T.byteLength}readShortString(){const T=this.a.readUInt8(this.b);this.b+=1;const G=this.a.slice(this.b,this.b+T).toString();return this.b+=T,G}static sizeLongString(T){return 4+T.byteLength}writeLongString(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}readLongString(){const T=this.a.readUInt32BE(this.b);this.b+=4;const G=this.a.slice(this.b,this.b+T).toString();return this.b+=T,G}writeBuffer(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}static sizeVSBuffer(T){return 4+T.byteLength}writeVSBuffer(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}readVSBuffer(){const T=this.a.readUInt32BE(this.b);this.b+=4;const M=this.a.slice(this.b,this.b+T);return this.b+=T,M}static sizeMixedArray(T){let M=0;M+=1;for(let G=0,V=T.length;G<V;G++){const N=T[G];switch(M+=1,N.type){case 1:M+=this.sizeLongString(N.value);break;case 2:M+=this.sizeVSBuffer(N.value);break;case 3:M+=this.sizeUInt32,M+=this.sizeLongString(N.value);for(let U=0;U<N.buffers.length;++U)M+=this.sizeVSBuffer(N.buffers[U]);break;case 4:break}}return M}writeMixedArray(T){this.a.writeUInt8(T.length,this.b),this.b+=1;for(let M=0,G=T.length;M<G;M++){const V=T[M];switch(V.type){case 1:this.writeUInt8(1),this.writeLongString(V.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(V.value);break;case 3:this.writeUInt8(3),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let N=0;N<V.buffers.length;++N)this.writeBuffer(V.buffers[N]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const T=this.a.readUInt8(this.b);this.b+=1;const M=new Array(T);for(let G=0;G<T;G++)switch(this.readUInt8()){case 1:M[G]=this.readLongString();break;case 2:M[G]=this.readVSBuffer();break;case 3:{const N=this.readUInt32(),U=this.readLongString(),F=[];for(let z=0;z<N;++z)F.push(this.readVSBuffer());M[G]=new L.SerializableObjectWithBuffers(h(U,F,null));break}case 4:M[G]=void 0;break}return M}}c.sizeUInt32=4;var l;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(l||(l={}));class n{static a(T){for(let M=0,G=T.length;M<G;M++)if(T[M]instanceof t.VSBuffer||T[M]instanceof L.SerializableObjectWithBuffers||typeof T[M]>"u")return!0;return!1}static serializeRequestArguments(T,M){if(this.a(T)){const G=[];for(let V=0,N=T.length;V<N;V++){const U=T[V];if(U instanceof t.VSBuffer)G[V]={type:2,value:U};else if(typeof U>"u")G[V]={type:4};else if(U instanceof L.SerializableObjectWithBuffers){const{jsonString:F,referencedBuffers:z}=m(U.value,M);G[V]={type:3,value:t.VSBuffer.fromString(F),buffers:z}}else G[V]={type:1,value:t.VSBuffer.fromString(w(U,M))}}return{type:1,args:G}}return{type:0,args:w(T,M)}}static serializeRequest(T,M,G,V,N){switch(V.type){case 0:return this.b(T,M,G,V.args,N);case 1:return this.c(T,M,G,V.args,N)}}static b(T,M,G,V,N){const U=t.VSBuffer.fromString(G),F=t.VSBuffer.fromString(V);let z=0;z+=c.sizeUInt8(),z+=c.sizeShortString(U),z+=c.sizeLongString(F);const B=c.alloc(N?2:1,T,z);return B.writeUInt8(M),B.writeShortString(U),B.writeLongString(F),B.buffer}static deserializeRequestJSONArgs(T){const M=T.readUInt8(),G=T.readShortString(),V=T.readLongString();return{rpcId:M,method:G,args:JSON.parse(V)}}static c(T,M,G,V,N){const U=t.VSBuffer.fromString(G);let F=0;F+=c.sizeUInt8(),F+=c.sizeShortString(U),F+=c.sizeMixedArray(V);const z=c.alloc(N?4:3,T,F);return z.writeUInt8(M),z.writeShortString(U),z.writeMixedArray(V),z.buffer}static deserializeRequestMixedArgs(T){const M=T.readUInt8(),G=T.readShortString(),V=T.readMixedArray(),N=new Array(V.length);for(let U=0,F=V.length;U<F;U++){const z=V[U];typeof z=="string"?N[U]=JSON.parse(z):N[U]=z}return{rpcId:M,method:G,args:N}}static serializeAcknowledged(T){return c.alloc(5,T,0).buffer}static serializeCancel(T){return c.alloc(6,T,0).buffer}static serializeReplyOK(T,M,G){if(typeof M>"u")return this.d(T);if(M instanceof t.VSBuffer)return this.e(T,M);if(M instanceof L.SerializableObjectWithBuffers){const{jsonString:V,referencedBuffers:N}=m(M.value,G,!0);return this.g(T,V,N)}else return this.f(T,y(M,G))}static d(T){return c.alloc(7,T,0).buffer}static e(T,M){let G=0;G+=c.sizeVSBuffer(M);const V=c.alloc(8,T,G);return V.writeVSBuffer(M),V.buffer}static deserializeReplyOKVSBuffer(T){return T.readVSBuffer()}static f(T,M){const G=t.VSBuffer.fromString(M);let V=0;V+=c.sizeLongString(G);const N=c.alloc(9,T,V);return N.writeLongString(G),N.buffer}static g(T,M,G){const V=t.VSBuffer.fromString(M);let N=0;N+=c.sizeUInt32,N+=c.sizeLongString(V);for(const F of G)N+=c.sizeVSBuffer(F);const U=c.alloc(10,T,N);U.writeUInt32(G.length),U.writeLongString(V);for(const F of G)U.writeBuffer(F);return U.buffer}static deserializeReplyOKJSON(T){const M=T.readLongString();return JSON.parse(M)}static deserializeReplyOKJSONWithBuffers(T,M){const G=T.readUInt32(),V=T.readLongString(),N=[];for(let U=0;U<G;++U)N.push(T.readVSBuffer());return new L.SerializableObjectWithBuffers(h(V,N,M))}static serializeReplyErr(T,M){const G=M?y(R.transformErrorForSerialization(M),null):void 0;if(typeof G!="string")return this.h(T);const V=t.VSBuffer.fromString(G);let N=0;N+=c.sizeLongString(V);const U=c.alloc(11,T,N);return U.writeLongString(V),U.buffer}static deserializeReplyErrError(T){const M=T.readLongString();return JSON.parse(M)}static h(T){return c.alloc(12,T,0).buffer}}var r;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(r||(r={}));var f;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(f||(f={}))}),define(ye[282],Ce([1,0,4,44,53,3,38,10,16]),function(ne,e,o,t,k,R,I,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new k.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new k.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new k.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,R.createDecorator)(e.OUTPUT_SERVICE_ID);var C;(function(D){D[D.Append=1]="Append",D[D.Replace=2]="Replace",D[D.Clear=3]="Clear"})(C=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class L{constructor(){this.a=new Map,this.b=new o.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new o.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(v){this.a.has(v.id)||(this.a.set(v.id,v),this.b.fire(v.id))}getChannels(){const v=[];return this.a.forEach(d=>v.push(d)),v}getChannel(v){return this.a.get(v)}removeChannel(v){this.a.delete(v),this.c.fire(v)}}t.Registry.add(e.Extensions.OutputChannels,new L);function P(D,v,d,m,h){return(0,S.createCancelablePromise)(async w=>{await(0,I.whenProviderRegistered)(d,m);const g=t.Registry.as(e.Extensions.OutputChannels);try{await y(d,1,m,h,w),g.registerChannel({id:D,label:v,file:d,log:!0})}catch(p){(0,A.isCancellationError)(p)||h.error("Error while registering log channel",d.toString(),(0,A.getErrorMessage)(p))}})}e.registerLogChannel=P;async function y(D,v,d,m,h){if(!await d.exists(D)){if(h.isCancellationRequested)throw new A.CancellationError;if(v>10)throw new Error("Timed out while waiting for file to be created");m.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",D.toString()),await(0,S.timeout)(1e3,h),await y(D,v+1,d,m,h)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new k.RawContextKey("activeOutputChannel","")}),define(ye[142],Ce([1,0,5,3,17,26,13,282,72,25,47,156,22,11,38,4,6]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y,D,v,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class h extends I.AbstractMessageLogger{get disposed(){return this.l}constructor(b,i,s,a,u){super(),this.id=b,this.name=i,this.m=s,this.n=a,this.extension=u,this.k=0,this.l=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(c=>this.setLevel(c)))}get logLevel(){return this.getLevel()}appendLine(b){this.append(b+`
`)}append(b){this.info(b)}clear(){const b=this.k;this.m.flush(),this.n.$update(this.id,A.OutputChannelUpdateMode.Clear,b)}replace(b){const i=this.k;this.info(b),this.n.$update(this.id,A.OutputChannelUpdateMode.Replace,i),this.visible&&this.m.flush()}show(b,i){this.m.flush(),this.n.$reveal(this.id,!!(typeof b=="boolean"?b:i))}hide(){this.n.$close(this.id)}g(b,i){this.k+=y.VSBuffer.fromString(i).byteLength,(0,I.log)(this.m,b,i),this.visible&&(this.m.flush(),this.n.$update(this.id,A.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class w extends h{appendLine(b){this.append(b)}}let g=class{constructor(b,i,s,a,u,c){this.i=i,this.j=s,this.k=a,this.l=u,this.m=c,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=b.getProxy(o.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,P.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(b){this.h=b;for(const[i,s]of this.g)s.visible=i===this.h}createOutputChannel(b,i,s){if(b=b.trim(),!b)throw new Error("illegal argument `name`. must not be falsy");const a=typeof i=="object"&&i.log,u=(0,D.isString)(i)?i:void 0;if((0,D.isString)(u)&&!u.trim())throw new Error("illegal argument `languageId`. must not be empty");let c;const l=this.i.environment.extensionLogLevel?.find(([r])=>R.ExtensionIdentifier.equals(s.identifier,r))?.[1];l&&(c=(0,I.parseLogLevel)(l));const n=a?this.o(b,c,s):this.n(b,u,s);return n.then(r=>{this.g.set(r.id,r),r.visible=r.id===this.h}),a?this.r(b,c??this.m.getLevel(),n):this.q(b,n)}async n(b,i,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,u=this.k.extUri.joinPath(a,`${this.f++}-${b.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(u,{always:!0,donotRotate:!0,donotUseFormatters:!0}),l=await this.a.$register(b,u,!1,i,s.identifier.value);return new h(l,b,c,this.a,s)}async o(b,i,s){const a=await this.p(s),u=this.k.extUri.joinPath(a,`${b.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(u,{name:b},i),l=await this.a.$register(b,u,!0,void 0,s.identifier.value);return new w(l,b,c,this.a,s)}p(b){let i=this.d.get(b.identifier.value);if(!i){const s=this.k.extUri.joinPath(this.i.logsLocation,b.identifier.value);this.d.set(b.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(s)}catch(a){if((0,v.toFileSystemProviderErrorCode)(a)!==v.FileSystemProviderErrorCode.FileExists)throw a}return s})())}return i}q(b,i){let s=!1;const a=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return b},append(u){a(),i.then(c=>c.append(u))},appendLine(u){a(),i.then(c=>c.appendLine(u))},clear(){a(),i.then(u=>u.clear())},replace(u){a(),i.then(c=>c.replace(u))},show(u,c){a(),i.then(l=>l.show(u,c))},hide(){a(),i.then(u=>u.hide())},dispose(){s=!0,i.then(u=>u.dispose())}}}r(b,i,s){const a=new m.DisposableStore,u=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},c=a.add(new d.Emitter);return s.then(l=>{a.add(l),a.add(l.onDidChangeLogLevel(n=>{i=n,c.fire(n)}))}),{...this.q(b,s),get logLevel(){return i},onDidChangeLogLevel:c.event,trace(l,...n){u(),s.then(r=>r.trace(l,...n))},debug(l,...n){u(),s.then(r=>r.debug(l,...n))},info(l,...n){u(),s.then(r=>r.info(l,...n))},warn(l,...n){u(),s.then(r=>r.warn(l,...n))},error(l,...n){u(),s.then(r=>r.error(l,...n))},dispose(){a.dispose()}}}};g=qe([He(0,k.IExtHostRpcService),He(1,C.IExtHostInitDataService),He(2,S.IExtHostConsumerFileSystem),He(3,L.IExtHostFileSystemInfo),He(4,I.ILoggerService),He(5,I.ILogService)],g),e.ExtHostOutputService=g,e.IExtHostOutputService=(0,t.createDecorator)("IExtHostOutputService")}),define(ye[283],Ce([1,0,3]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,o.createDecorator)("remoteAgentService")}),define(ye[284],Ce([1,0,32,15,9,12,24,2,3,210,46,227,283]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let D=class si{constructor(d,m,h,w){this.d=d,this.e=m,this.f=h,this.g=w,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const g=await this.e.getEnvironment();return this.c=g?.userHome??d})()}hasValidBasename(d,m,h){return typeof m=="string"||typeof m>"u"?this.a.then(w=>this.h(d,w,m)):this.h(d,m,h)}h(d,m,h){return d.scheme===t.Schemas.file||d.scheme===t.Schemas.vscodeRemote?(0,o.isValidBasename)(h??(0,I.basename)(d),m===1):!0}get defaultUriScheme(){return si.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(d,m){if(d.remoteAuthority)return t.Schemas.vscodeRemote;const h=(0,C.getVirtualWorkspaceScheme)(m.getWorkspace());if(h)return h;const w=m.getWorkspace().folders[0];if(w)return w.uri.scheme;const g=m.getWorkspace().configuration;return g?g.scheme:t.Schemas.file}userHome(d){return d?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(d=>d===1?k.win32:k.posix)}async fileURI(d){let m="";if(await this.a===1&&(d=d.replace(/\\/g,"/")),d[0]==="/"&&d[1]==="/"){const w=d.indexOf("/",2);w===-1?(m=d.substring(2),d="/"):(m=d.substring(2,w),d=d.substring(w)||"/")}return A.URI.from({scheme:t.Schemas.file,authority:m,path:d,query:"",fragment:""})}};D=qe([He(1,y.IRemoteAgentService),He(2,P.IWorkbenchEnvironmentService),He(3,L.IWorkspaceContextService)],D),e.AbstractPathService=D}),define(ye[75],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class o{constructor(I,A){this.line=I,this.character=A}isBefore(I){return!1}isBeforeOrEqual(I){return!1}isAfter(I){return!1}isAfterOrEqual(I){return!1}isEqual(I){return!1}compareTo(I){return 0}translate(I,A){return new o(0,0)}with(I){return new o(0,0)}}e.Position=o;class t{constructor(I,A,S,C){this.isEmpty=!1,this.isSingleLine=!1,this.start=new o(I,A),this.end=new o(S,C)}contains(I){return!1}isEqual(I){return!1}intersection(I){}union(I){return new t(0,0,0,0)}with(I){return new t(0,0,0,0)}}e.Range=t;var k;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(k=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ye[31],Ce([1,0,18,37,23,32,8,3,9,10,75,16]),function(ne,e,o,t,k,R,I,A,S,C,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const y="\u27EA ",D=" characters skipped \u27EB",v=(y.length+D.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var d;(function(Q){Q[Q.file=0]="file",Q[Q.text=1]="text"})(d=e.SearchProviderType||(e.SearchProviderType={}));var m;(function(Q){Q[Q.File=1]="File",Q[Q.Text=2]="Text"})(m=e.QueryType||(e.QueryType={}));function h(Q){return!!Q.preview}e.resultIsMatch=h;function w(Q){return!!Q.resource}e.isFileMatch=w;function g(Q){return!!Q.message}e.isProgressMessage=g;var p;(function(Q){Q[Q.Normal=0]="Normal",Q[Q.NewSearchStarted=1]="NewSearchStarted"})(p=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class b{constructor(Z){this.resource=Z,this.results=[]}}e.FileMatch=b;class i{constructor(Z,ge,te){this.ranges=ge;const J=Array.isArray(ge)?ge:[ge];if(te&&te.matchLines===1&&s(J)){Z=(0,I.getNLines)(Z,te.matchLines);let fe="",ve=0,Ee=0;const Ae=Math.floor(te.charsPerLine/5),Fe=[];for(const se of J){const le=Math.max(se.startColumn-Ae,0),ue=se.startColumn+te.charsPerLine;if(le>Ee+Ae+v){const ee=y+(le-Ee)+D;fe+=ee+Z.slice(le,ue),ve+=le-(Ee+ee.length)}else fe+=Z.slice(Ee,ue);Fe.push(new u(0,se.startColumn-ve,se.endColumn-ve)),Ee=ue}this.preview={text:fe,matches:Array.isArray(this.ranges)?Fe:Fe[0]}}else{const fe=Array.isArray(ge)?ge[0].startLineNumber:ge.startLineNumber;this.preview={text:Z,matches:(0,o.mapArrayOrNot)(ge,ve=>new a(ve.startLineNumber-fe,ve.startColumn,ve.endLineNumber-fe,ve.endColumn))}}}}e.TextSearchMatch=i;function s(Q){const Z=Q[0].startLineNumber;for(const ge of Q)if(ge.startLineNumber!==Z||ge.endLineNumber!==Z)return!1;return!0}class a{constructor(Z,ge,te,J){this.startLineNumber=Z,this.startColumn=ge,this.endLineNumber=te,this.endColumn=J}}e.SearchRange=a;class u extends a{constructor(Z,ge,te){super(Z,ge,Z,te)}}e.OneLineRange=u;var c;(function(Q){Q.List="list",Q.Tree="tree"})(c=e.ViewMode||(e.ViewMode={}));var l;(function(Q){Q.Default="default",Q.FileNames="fileNames",Q.Type="type",Q.Modified="modified",Q.CountDescending="countDescending",Q.CountAscending="countAscending"})(l=e.SearchSortOrder||(e.SearchSortOrder={}));function n(Q,Z=!0){const ge=Q&&Q.files&&Q.files.exclude,te=Z&&Q&&Q.search&&Q.search.exclude;if(!ge&&!te)return;if(!ge||!te)return ge||te;let J=Object.create(null);return J=k.mixin(J,k.deepClone(ge)),J=k.mixin(J,k.deepClone(te),!0),J}e.getExcludes=n;function r(Q,Z){return Q.excludePattern&&t.match(Q.excludePattern,Z)?!1:Q.includePattern||Q.usingSearchPaths?Q.includePattern&&t.match(Q.includePattern,Z)?!0:Q.usingSearchPaths?!!Q.folderQueries&&Q.folderQueries.some(ge=>{const te=ge.folder.fsPath;if(R.isEqualOrParent(Z,te)){const J=S.relative(te,Z);return!ge.includePattern||!!t.match(ge.includePattern,J)}else return!1}):!1:!0}e.pathIncludedInQuery=r;var f;(function(Q){Q[Q.unknownEncoding=1]="unknownEncoding",Q[Q.regexParseError=2]="regexParseError",Q[Q.globParseError=3]="globParseError",Q[Q.invalidLiteral=4]="invalidLiteral",Q[Q.rgProcessError=5]="rgProcessError",Q[Q.other=6]="other",Q[Q.canceled=7]="canceled"})(f=e.SearchErrorCode||(e.SearchErrorCode={}));class E extends Error{constructor(Z,ge){super(Z),this.code=ge}}e.SearchError=E;function T(Q){const Z=Q.message;if((0,C.isCancellationError)(Q))return new E(Z,f.canceled);try{const ge=JSON.parse(Z);return new E(ge.message,ge.code)}catch{return new E(Z,f.other)}}e.deserializeSearchError=T;function M(Q){const Z={message:Q.message,code:Q.code};return new Error(JSON.stringify(Z))}e.serializeSearchError=M;function G(Q){return Q.type==="error"?!0:Q.type==="success"}e.isSerializedSearchComplete=G;function V(Q){return Q.type==="success"}e.isSerializedSearchSuccess=V;function N(Q){return!!Q.path}e.isSerializedFileMatch=N;function U(Q,Z){const ge=Q.searchPath?Q.searchPath:Q.relativePath;return(0,I.fuzzyContains)(ge,Z)}e.isFilePatternMatch=U;class F{constructor(Z){this.path=Z,this.results=[]}addMatch(Z){this.results.push(Z)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=F;function z(Q,Z){const ge={...Q||{},...Z||{}};return Object.keys(ge).filter(te=>{const J=ge[te];return typeof J=="boolean"&&J})}e.resolvePatternsForProvider=z;class B{constructor(Z,ge){this.c=null,this.a={...Z.excludePattern||{},...ge.excludePattern||{}},this.b=t.parse(this.a);let te=Z.includePattern;ge.includePattern&&(te?te={...te,...ge.includePattern}:te=ge.includePattern),te&&(this.c=t.parse(te))}matchesExcludesSync(Z,ge,te){return!!(this.b&&this.b(Z,ge,te))}includedInQuerySync(Z,ge,te){return!(this.b&&this.b(Z,ge,te)||this.c&&!this.c(Z,ge,te))}includedInQuery(Z,ge,te){const J=this.b(Z,ge,te),fe=()=>this.c?!!this.c(Z,ge,te):!0;return(0,P.isThenable)(J)?J.then(ve=>ve?!1:fe()):fe()}hasSiblingExcludeClauses(){return W(this.a)}}e.QueryGlobTester=B;function W(Q){for(const Z in Q)if(typeof Q[Z]!="boolean")return!0;return!1}function X(Q){if(!Q)return;let Z;return ge=>(Z||(Z=(Q()||Promise.resolve([])).then(te=>te?_(te):{})),Z.then(te=>!!te[ge]))}e.hasSiblingPromiseFn=X;function q(Q){if(!Q)return;let Z;return ge=>{if(!Z){const te=Q();Z=te?_(te):{}}return!!Z[ge]}}e.hasSiblingFn=q;function _(Q){const Z={};for(const ge of Q)Z[ge]=!0;return Z}}),define(ye[33],Ce([1,0,18,16,21,4,6,64,15,101,24,8,11,2,179,3,13,199,46,47,25,17,14,7,55,31,5]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y,D,v,d,m,h,w,g,p,b,i,s,a,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function l(V,N,U){return new L.ExtUri(F=>E(F,U)).isEqual(V,N)}function n(V,N,U){return l(V.uri,N.uri,U)?0:(0,P.compare)(V.uri.toString(),N.uri.toString())}function r(V,N,U){return V.index!==N.index?V.index<N.index?-1:1:l(V.uri,N.uri,U)?(0,P.compare)(V.name,N.name):(0,P.compare)(V.uri.toString(),N.uri.toString())}function f(V,N,U,F){const z=V.slice(0).sort((W,X)=>U(W,X,F)),B=N.slice(0).sort((W,X)=>U(W,X,F));return(0,o.delta)(z,B,(W,X)=>U(W,X,F))}function E(V,N){const U=N.getCapabilities(V.scheme);return!(U&&U&1024)}class T extends w.Workspace{static toExtHostWorkspace(N,U,F,z){if(!N)return{workspace:null,added:[],removed:[]};const{id:B,name:W,folders:X,configuration:q,transient:_,isUntitled:Q}=N,Z=[],ge=U;U?X.forEach((ve,Ee)=>{const Ae=D.URI.revive(ve.uri),Fe=T.e(F||U,Ae,z);Fe?(Fe.name=ve.name,Fe.index=ve.index,Z.push(Fe)):Z.push({uri:Ae,name:ve.name,index:Ee})}):Z.push(...X.map(({uri:ve,name:Ee,index:Ae})=>({uri:D.URI.revive(ve),name:Ee,index:Ae}))),Z.sort((ve,Ee)=>ve.index<Ee.index?-1:1);const te=new T(B,W,Z,!!_,q?D.URI.revive(q):null,!!Q,ve=>E(ve,z)),{added:J,removed:fe}=f(ge?ge.workspaceFolders:[],te.workspaceFolders,n,z);return{workspace:te,added:J,removed:fe}}static e(N,U,F){for(let z=0;z<N.folders.length;z++){const B=N.workspaceFolders[z];if(l(B.uri,U,F))return B}}constructor(N,U,F,z,B,W,X){super(N,F.map(q=>new w.WorkspaceFolder(q)),z,B,X),this.s=U,this.t=W,this.o=[],this.q=A.TernarySearchTree.forUris(X),F.forEach(q=>{this.o.push(q),this.q.set(q.uri,q)})}get name(){return this.s}get isUntitled(){return this.t}get workspaceFolders(){return this.o.slice(0)}getWorkspaceFolder(N,U){return U&&this.q.get(N)&&(N=(0,L.dirname)(N)),this.q.findSubstr(N)}resolveWorkspaceFolder(N){return this.q.get(N)}}let M=class{constructor(N,U,F,z,B){this.c=new R.Emitter,this.onDidChangeWorkspace=this.c.event,this.e=new R.Emitter,this.onDidGrantWorkspaceTrust=this.e.event,this.t=[],this.u=!1,this.v=new Map,this.y=0,this.g=z,this.q=F,this.s=B,this.h=new C.Counter,this.j=new t.Barrier,this.n=N.getProxy(c.MainContext.MainThreadWorkspace),this.o=N.getProxy(c.MainContext.MainThreadMessageService);const W=U.workspace;this.k=W?new T(W.id,W.name,[],!!W.transient,W.configuration?D.URI.revive(W.configuration):null,!!W.isUntitled,X=>E(X,F)):void 0}$initializeWorkspace(N,U){this.u=U,this.$acceptWorkspaceData(N),this.j.open()}waitForInitializeCall(){return this.j.wait()}get workspace(){return this.w}get name(){return this.w?this.w.name:void 0}get workspaceFile(){if(this.w&&this.w.configuration)return this.w.isUntitled?D.URI.from({scheme:S.Schemas.untitled,path:(0,L.basename)((0,L.dirname)(this.w.configuration))}):this.w.configuration}get w(){return this.l||this.k}getWorkspaceFolders(){if(!!this.w)return this.w.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.j.wait(),!!this.w)return this.w.workspaceFolders.slice(0)}updateWorkspaceFolders(N,U,F,...z){const B=[];if(Array.isArray(z)&&z.forEach(Q=>{D.URI.isUri(Q.uri)&&!B.some(Z=>l(Z.uri,Q.uri,this.q))&&B.push({uri:Q.uri,name:Q.name||(0,L.basenameOrAuthority)(Q.uri)})}),this.l||[U,F].some(Q=>typeof Q!="number"||Q<0)||F===0&&B.length===0)return!1;const W=this.w?this.w.workspaceFolders:[];if(U+F>W.length)return!1;const X=W.slice(0);X.splice(U,F,...B.map(Q=>({uri:Q.uri,name:Q.name||(0,L.basenameOrAuthority)(Q.uri),index:void 0})));for(let Q=0;Q<X.length;Q++){const Z=X[Q];if(X.some((ge,te)=>te!==Q&&l(Z.uri,ge.uri,this.q)))return!1}X.forEach((Q,Z)=>Q.index=Z);const{added:q,removed:_}=f(W,X,r,this.q);if(q.length===0&&_.length===0)return!1;if(this.n){const Q=N.displayName||N.name;this.n.$updateWorkspaceFolders(Q,U,F,B).then(void 0,Z=>{this.l=void 0;const ge={source:{identifier:N.identifier,label:N.displayName||N.name}};this.o.$showMessage(h.Severity.Error,(0,v.localize)(0,null,Q,Z.toString()),ge,[])})}return this.x(X),!0}getWorkspaceFolder(N,U){if(!!this.w)return this.w.getWorkspaceFolder(N,U)}async getWorkspaceFolder2(N,U){if(await this.j.wait(),!!this.w)return this.w.getWorkspaceFolder(N,U)}async resolveWorkspaceFolder(N){if(await this.j.wait(),!!this.w)return this.w.resolveWorkspaceFolder(N)}getPath(){if(!this.w)return;const{folders:N}=this.w;if(N.length!==0)return N[0].uri.fsPath}getRelativePath(N,U){let F,z="";if(typeof N=="string"?(F=D.URI.file(N),z=N):typeof N<"u"&&(F=N,z=N.fsPath),!F)return z;const B=this.getWorkspaceFolder(F,!0);if(!B)return z;typeof U>"u"&&this.w&&(U=this.w.folders.length>1);let W=(0,L.relativePath)(B.uri,F);return U&&B.name&&(W=`${B.name}/${W}`),W}x(N){this.w&&(this.l=T.toExtHostWorkspace({id:this.w.id,name:this.w.name,configuration:this.w.configuration,folders:N,isUntitled:this.w.isUntitled},this.w,void 0,this.q).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:U,added:F,removed:z}=T.toExtHostWorkspace(N,this.k,this.l,this.q);this.k=U||void 0,this.l=void 0,this.c.fire(Object.freeze({added:F,removed:z}))}findFiles(N,U,F,z,B=k.CancellationToken.None){this.g.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${z.value}, entryPoint: findFiles`);let W;if(U===null?W=!1:U&&(typeof U=="string"?W=U:W=U.pattern),B&&B.isCancellationRequested)return Promise.resolve([]);const{includePattern:X,folder:q}=G(i.GlobPattern.from(N));return this.n.$startFileSearch((0,y.withUndefinedAsNull)(X),(0,y.withUndefinedAsNull)(q),(0,y.withUndefinedAsNull)(W),(0,y.withUndefinedAsNull)(F),B).then(_=>Array.isArray(_)?_.map(Q=>D.URI.revive(Q)):[])}async findTextInFiles(N,U,F,z,B=k.CancellationToken.None){this.g.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${z.value}, entryPoint: findTextInFiles`);const W=this.h.getNext(),X=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:q,folder:_}=G(i.GlobPattern.from(U.include)),Q=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,Z={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:X,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:q,excludePattern:Q},ge=!1;if(this.t[W]=te=>{if(ge)return;const J=D.URI.revive(te.resource);te.results.forEach(fe=>{(0,u.resultIsMatch)(fe)?F({uri:J,preview:{text:fe.preview.text,matches:(0,o.mapArrayOrNot)(fe.preview.matches,ve=>new s.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,o.mapArrayOrNot)(fe.ranges,ve=>new s.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):F({uri:J,text:fe.text,lineNumber:fe.lineNumber})})},B.isCancellationRequested)return{};try{const te=await this.n.$startTextSearch(N,(0,y.withUndefinedAsNull)(_),Z,W,B);return delete this.t[W],te||{}}catch(te){throw delete this.t[W],te}}$handleTextSearchResult(N,U){this.t[U]?.(N)}saveAll(N){return this.n.$saveAll(N)}resolveProxy(N){return this.n.$resolveProxy(N)}get trusted(){return this.u}requestWorkspaceTrust(N){return this.n.$requestWorkspaceTrust(N)}$onDidGrantWorkspaceTrust(){this.u||(this.u=!0,this.e.fire())}registerEditSessionIdentityProvider(N,U){if(this.v.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this.v.set(N,U);const F=this.s.transformOutgoingScheme(N),z=this.y++;return this.n.$registerEditSessionIdentityProvider(z,F),(0,I.toDisposable)(()=>{this.v.delete(N),this.n.$unregisterEditSessionIdentityProvider(z)})}async $getEditSessionIdentifier(N,U){this.g.info("Getting edit session identifier for workspaceFolder",N);const F=await this.resolveWorkspaceFolder(D.URI.revive(N));if(!F){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const z=this.v.get(F.uri.scheme);if(this.g.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!z),!z)return;const B=await z.provideEditSessionIdentity(F,U);if(this.g.info("Provider returned edit session identifier: ",B),!!B)return B}async $provideEditSessionIdentityMatch(N,U,F,z){this.g.info("Getting edit session identifier for workspaceFolder",N);const B=await this.resolveWorkspaceFolder(D.URI.revive(N));if(!B){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const W=this.v.get(B.uri.scheme);if(this.g.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!W),!W)return;const X=await W.provideEditSessionIdentityMatch?.(U,F,z);if(this.g.info("Provider returned edit session identifier match result: ",X),!!X)return X}};M=qe([He(0,b.IExtHostRpcService),He(1,p.IExtHostInitDataService),He(2,g.IExtHostFileSystemInfo),He(3,m.ILogService),He(4,a.IURITransformerService)],M),e.ExtHostWorkspace=M,e.IExtHostWorkspace=(0,d.createDecorator)("IExtHostWorkspace");function G(V){let N,U;return V&&(typeof V=="string"?N=V:(N=V.pattern,U=D.URI.revive(V.baseUri))),{includePattern:N,folder:U}}}),define(ye[34],Ce([1,0,23,4,33,5,7,202,127,11,16,3,17,13,2]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(s,a){if(a){const u=a.split(".");let c=s;for(let l=0;c&&l<u.length;l++)c=c[u[l]];return c}}function m(s){return s instanceof v.URI}function h(s){return s&&s.uri instanceof v.URI&&s.languageId&&typeof s.languageId=="string"}function w(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function g(s){return s&&s.uri instanceof v.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function p(s){if(m(s))return{resource:s};if(h(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(w(s))return{overrideIdentifier:s.languageId};if(g(s))return{resource:s.uri};if(s===null)return{resource:null}}let b=class{constructor(a,u,c){this.a=a.getProxy(R.MainContext.MainThreadConfiguration),this.c=u,this.b=c,this.d=new L.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new i(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,u){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(a,u))}};b=qe([He(0,y.IExtHostRpcService),He(1,k.IExtHostWorkspace),He(2,D.ILogService)],b),e.ExtHostConfiguration=b;class i{constructor(a,u,c,l){this.a=new t.Emitter,this.b=a,this.f=l,this.c=u,this.e=A.Configuration.parse(c),this.d=this.k(c.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,u){const c={data:this.e.toData(),workspace:this.c.workspace};this.e=A.Configuration.parse(a),this.d=this.k(a.configurationScopes),this.a.fire(this.j(u,c))}getConfiguration(a,u,c){const l=p(u)||{},n=this.g(a?d(this.e.getValue(void 0,l,this.c.workspace),a):this.e.getValue(void 0,l,this.c.workspace));a&&this.h(a,l,c?.identifier);function r(E){if(E==null)return null;if(typeof E=="boolean")return E?2:5;switch(E){case I.ConfigurationTarget.Global:return 2;case I.ConfigurationTarget.Workspace:return 5;case I.ConfigurationTarget.WorkspaceFolder:return 6}}const f={has(E){return typeof d(n,E)<"u"},get:(E,T)=>{this.h(a?`${a}.${E}`:E,l,c?.identifier);let M=d(n,E);if(typeof M>"u")M=T;else{let G;const V=(N,U)=>{let F;const z=()=>{G=G||(0,o.deepClone)(n),F=F||d(G,U)};return(0,C.isObject)(N)?new Proxy(N,{get:(B,W)=>{if(typeof W=="string"&&W.toLowerCase()==="tojson")return z(),()=>F;if(G)return F=F||d(G,U),F[W];const X=B[W];return typeof W=="string"?V(X,`${U}.${W}`):X},set:(B,W,X)=>(z(),F&&(F[W]=X),!0),deleteProperty:(B,W)=>(z(),F&&delete F[W],!0),defineProperty:(B,W,X)=>(z(),F&&Object.defineProperty(F,W,X),!0)}):N};M=V(M,E)}return M},update:(E,T,M,G)=>{E=a?`${a}.${E}`:E;const V=r(M);return T!==void 0?this.b.$updateConfigurationOption(V,E,T,l,G):this.b.$removeConfigurationOption(V,E,l,G)},inspect:E=>{E=a?`${a}.${E}`:E;const T=this.e.inspect(E,l,this.c.workspace);if(T)return{key:E,defaultValue:(0,o.deepClone)(T.policy?.value??T.default?.value),globalValue:(0,o.deepClone)(T.user?.value??T.application?.value),workspaceValue:(0,o.deepClone)(T.workspace?.value),workspaceFolderValue:(0,o.deepClone)(T.workspaceFolder?.value),defaultLanguageValue:(0,o.deepClone)(T.default?.override),globalLanguageValue:(0,o.deepClone)(T.user?.override??T.application?.override),workspaceLanguageValue:(0,o.deepClone)(T.workspace?.override),workspaceFolderLanguageValue:(0,o.deepClone)(T.workspaceFolder?.override),languageIds:(0,o.deepClone)(T.overrideIdentifiers)}}};return typeof n=="object"&&(0,o.mixin)(f,n,!1),Object.freeze(f)}g(a){const u=c=>(0,C.isObject)(c)?new Proxy(c,{get:(l,n)=>u(l[n]),set:(l,n,r)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(n)}' of object`)},deleteProperty:(l,n)=>{throw new Error(`TypeError: Cannot delete read only property '${String(n)}' of object`)},defineProperty:(l,n)=>{throw new Error(`TypeError: Cannot define property '${String(n)}' for a readonly object`)},setPrototypeOf:l=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return u(a)}h(a,u,c){const l=S.OVERRIDE_PROPERTY_REGEX.test(a)?4:this.d.get(a),n=c?`[${c.value}] `:"";if(l===4){typeof u?.resource>"u"&&this.f.warn(`${n}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(l===3){u?.resource&&this.f.warn(`${n}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,u){const c=new A.ConfigurationChangeEvent(a,u,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(l,n)=>c.affectsConfiguration(l,p(n))})}k(a){return a.reduce((u,c)=>(u.set(c[0],c[1]),u),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,P.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(ne,e,o,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ne,o):k?k.value=o:e.set(ne,o),o},Ue=this&&this.__classPrivateFieldGet||function(ne,e,o,t){if(o==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?t:o==="a"?t.call(ne):t?t.value:e.get(ne)};define(ye[76],Ce([1,0,2,16,4,5,7,33,58,34,21,40,17,25,3,15,12,13,71,239,10]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y,D,v,d,m,h,w,g,p){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var i;(function(N){function U(z){if(z!=null)return z}N.from=U;function F(z){if(z!=null)return z}N.to=F})(i||(i={}));var s;(function(N){function U(z){if(z!=null)return z}N.from=U;function F(z){if(z!=null)return z}N.to=F})(s||(s={}));var a;(function(N){function U(z){if(z!=null)return z}N.from=U;function F(z){if(z!=null)return z}N.to=F})(a||(a={}));var u;(function(N){function U(B){if(B){const W=B;return W&&!!W.process}else return!1}N.is=U;function F(B){if(B==null)return;const W={process:B.process,args:B.args};return B.options&&(W.options=a.from(B.options)),W}N.from=F;function z(B){if(B!=null)return new I.ProcessExecution(B.process,B.args,B.options)}N.to=z})(u||(u={}));var c;(function(N){function U(z){if(z!=null)return z}N.from=U;function F(z){if(z!=null)return z}N.to=F})(c||(c={}));var l;(function(N){function U(B){if(B){const W=B;return W&&(!!W.commandLine||!!W.command)}else return!1}N.is=U;function F(B){if(B==null)return;const W={};return B.commandLine!==void 0?W.commandLine=B.commandLine:(W.command=B.command,W.args=B.args),B.options&&(W.options=c.from(B.options)),W}N.from=F;function z(B){if(!(B==null||B.command===void 0&&B.commandLine===void 0))return B.commandLine?new I.ShellExecution(B.commandLine,B.options):new I.ShellExecution(B.command,B.args?B.args:[],B.options)}N.to=z})(l||(l={}));var n;(function(N){function U(B){if(B){const W=B;return W&&W.customExecution==="customExecution"}else return!1}N.is=U;function F(B){return{customExecution:"customExecution"}}N.from=F;function z(B,W){return W.get(B)}N.to=z})(n=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var r;(function(N){function U(F,z){let B;return F.scope!==void 0&&typeof F.scope!="number"?B=F.scope.uri:F.scope!==void 0&&typeof F.scope=="number"&&(F.scope===I.TaskScope.Workspace&&z&&z.workspaceFile?B=z.workspaceFile:B=g.USER_TASKS_GROUP_KEY),{id:F._id,workspaceFolder:B}}N.from=U})(r=e.TaskHandleDTO||(e.TaskHandleDTO={}));var f;(function(N){function U(F){if(F!=null)return{_id:F.id,isDefault:F.isDefault}}N.from=U})(f||(f={}));var E;(function(N){function U(B,W){if(B==null)return[];const X=[];for(const q of B){const _=F(q,W);_&&X.push(_)}return X}N.fromMany=U;function F(B,W){if(B==null)return;let X;B.execution instanceof I.ProcessExecution?X=u.from(B.execution):B.execution instanceof I.ShellExecution?X=l.from(B.execution):B.execution&&B.execution instanceof I.CustomExecution&&(X=n.from(B.execution));const q=i.from(B.definition);let _;return B.scope?typeof B.scope=="number"?_=B.scope:_=B.scope.uri:_=I.TaskScope.Workspace,!q||!_?void 0:{_id:B._id,definition:q,name:B.name,source:{extensionId:W.identifier.value,label:B.source,scope:_},execution:X,isBackground:B.isBackground,group:f.from(B.group),presentationOptions:s.from(B.presentationOptions),problemMatchers:B.problemMatchers,hasDefinedMatchers:B.hasDefinedMatchers,runOptions:B.runOptions?B.runOptions:{reevaluateOnRerun:!0},detail:B.detail}}N.from=F;async function z(B,W,X){if(B==null)return;let q;u.is(B.execution)?q=u.to(B.execution):l.is(B.execution)?q=l.to(B.execution):n.is(B.execution)&&(q=n.to(B._id,X));const _=i.to(B.definition);let Q;if(B.source&&(B.source.scope!==void 0?typeof B.source.scope=="number"?Q=B.source.scope:Q=await W.resolveWorkspaceFolder(o.URI.revive(B.source.scope)):Q=I.TaskScope.Workspace),!_||!Q)return;const Z=new I.Task(_,Q,B.name,B.source.label,q,B.problemMatchers);return B.isBackground!==void 0&&(Z.isBackground=B.isBackground),B.group!==void 0&&(Z.group=I.TaskGroup.from(B.group._id),Z.group&&B.group.isDefault&&(Z.group=new I.TaskGroup(Z.group.id,Z.group.label),B.group.isDefault===!0&&(Z.group.isDefault=B.group.isDefault))),B.presentationOptions&&(Z.presentationOptions=s.to(B.presentationOptions)),B._id&&(Z._id=B._id),B.detail&&(Z.detail=B.detail),Z}N.to=z})(E=e.TaskDTO||(e.TaskDTO={}));var T;(function(N){function U(z){return z}N.from=U;function F(z){if(!!z)return Object.assign(Object.create(null),z)}N.to=F})(T||(T={}));class M{constructor(U,F,z){this._id=F,this.a=z,b.set(this,void 0),Je(this,b,U,"f")}get task(){return this.a}terminate(){Ue(this,b,"f").terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}b=new WeakMap;let G=class{constructor(U,F,z,B,W,X,q,_){this.q=new k.Emitter,this.r=new k.Emitter,this.s=new k.Emitter,this.t=new k.Emitter,this.a=U.getProxy(R.MainContext.MainThreadTask),this.b=z,this.c=B,this.d=W,this.e=X,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=q,this.g=_,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(U,F,z){if(!z)return new I.Disposable(()=>{});const B=this.w();return this.j.set(B,{type:F,provider:z,extension:U}),this.a.$registerTaskProvider(B,F),new I.Disposable(()=>{this.j.delete(B),this.a.$unregisterTaskProvider(B)})}registerTaskSystem(U,F){this.a.$registerTaskSystem(U,F)}fetchTasks(U){return this.a.$fetchTasks(T.from(U)).then(async F=>{const z=[];for(const B of F){const W=await E.to(B,this.b,this.m);W&&z.push(W)}return z})}get taskExecutions(){const U=[];return this.k.forEach(F=>U.push(F)),U}terminateTask(U){if(!(U instanceof M))throw new Error("No valid task execution provided");return this.a.$terminateTask(U._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(U,F,z){const B=this.m.get(U.id);B&&(this.o.set(U.id,B),this.e.attachPtyToTerminal(F,await B.callback(z))),this.p=U.id,this.q.fire({execution:await this.y(U)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(U){const F=await this.y(U);this.l.delete(U.id),this.k.delete(U.id),this.A(U),this.r.fire({execution:F})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(U){const F=await this.y(U.id);this.s.fire({execution:F,processId:U.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(U){const F=await this.y(U.id);this.t.fire({execution:F,exitCode:U.exitCode})}$provideTasks(U,F){const z=this.j.get(U);if(!z)return Promise.reject(new Error("no handler found"));const B=[],W=(0,t.asPromise)(()=>z.provider.provideTasks(L.CancellationToken.None)).then(X=>this.u(F,B,z,X));return new Promise(X=>{W.then(q=>{Promise.all(B).then(()=>{X(q)})})})}async $resolveTask(U,F){const z=this.j.get(U);if(!z)return Promise.reject(new Error("no handler found"));if(F.definition.type!==z.type)throw new Error(`Unexpected: Task of type [${F.definition.type}] cannot be resolved by provider of type [${z.type}].`);const B=await E.to(F,this.b,this.m);if(!B)throw new Error("Unexpected: Task cannot be resolved.");const W=await z.provider.resolveTask(B,L.CancellationToken.None);if(!W)return;this.z(W,z);const X=E.from(W,z.extension);if(!X)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==B.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return n.is(X.execution)&&await this.x(X,W,!0),await this.v(X)}w(){return this.h++}async x(U,F,z){const B=await this.a.$createTaskId(U);!z&&!this.m.has(B)&&(this.n.add(B),this.o.set(B,F.execution)),this.m.set(B,F.execution)}async y(U,F){if(typeof U=="string"){const W=this.l.get(U);if(!W)throw new p.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return W}const z=this.l.get(U.id);if(z)return z;const B=new Promise((W,X)=>{function q(_,Q,Z){Z?W(new M(_,Q.id,Z)):X("Unexpected: Task does not exist.")}F?q(this,U,F):E.to(U.task,this.b,this.m).then(_=>q(this,U,_))});return this.l.set(U.id,B),B.then(W=>(this.k.set(U.id,W),W),W=>Promise.reject(W))}z(U,F){U._deprecated&&this.g.report("Task.constructor",F.extension,"Use the Task constructor that takes a `scope` instead.")}A(U){this.o.get(U.id)&&this.o.delete(U.id),this.n.has(U.id)&&this.p!==U.id&&(this.m.delete(U.id),this.n.delete(U.id));const z=this.n.values();let B=z.next();for(;!B.done;)!this.o.has(B.value)&&this.p!==B.value&&(this.m.delete(B.value),this.n.delete(B.value)),B=z.next()}};G=qe([He(0,y.IExtHostRpcService),He(1,D.IExtHostInitDataService),He(2,A.IExtHostWorkspace),He(3,S.IExtHostDocumentsAndEditors),He(4,C.IExtHostConfiguration),He(5,P.IExtHostTerminalService),He(6,h.ILogService),He(7,w.IExtHostApiDeprecationService)],G),e.ExtHostTaskBase=G;let V=class extends G{constructor(U,F,z,B,W,X,q,_){super(U,F,z,B,W,X,q,_),this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:m.PlatformToString(0)})}async executeTask(U,F){if(!F.execution)throw new Error("Tasks to execute must include an execution");const z=E.from(F,U);if(z===void 0)throw new Error("Task is not valid");if(n.is(z.execution))await this.x(z,F,!1);else throw new p.NotSupportedError;const B=await this.y(await this.a.$getTaskExecution(z),F);return this.a.$executeTask(z).catch(W=>{throw new Error(W)}),B}u(U,F,z,B){const W=[];if(B)for(const X of B){this.z(X,z),(!X.definition||!U[X.definition.type])&&this.f.warn(`The task [${X.source}, ${X.name}] uses an undefined task type. The task will be ignored in the future.`);const q=E.from(X,z.extension);q&&n.is(q.execution)?(W.push(q),F.push(this.x(q,X,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:W,extension:z.extension}}async v(U){if(n.is(U.execution))return U;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(U,F){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,F,z){}};V=qe([He(0,y.IExtHostRpcService),He(1,D.IExtHostInitDataService),He(2,A.IExtHostWorkspace),He(3,S.IExtHostDocumentsAndEditors),He(4,C.IExtHostConfiguration),He(5,P.IExtHostTerminalService),He(6,h.ILogService),He(7,w.IExtHostApiDeprecationService)],V),e.WorkerExtHostTask=V,e.IExtHostTask=(0,v.createDecorator)("IExtHostTask")}),define(ye[285],Ce([1,0,9,21,51,37,24,42,31]),function(ne,e,o,t,k,R,I,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class C{constructor(y,D,v){this.k=y,this.l=D,this.o=v,this.e=!1,this.f=0,this.g=!1,this.a=y.filePattern,this.b=y.includePattern&&R.parse(y.includePattern),this.c=y.maxResults||void 0,this.d=y.exists,this.h=new Set,this.j=y.excludePattern&&R.parse(y.excludePattern)}cancel(){this.g=!0,this.h.forEach(y=>y.cancel()),this.h=new Set}search(y){const D=this.k.folderQueries||[];return new Promise((v,d)=>{const m=h=>{this.f++,y(h)};if(this.g)return v({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(h=>{const w=h.toString(),g=o.basename(w);this.j&&this.j(w,g)||this.v(m,{base:h,basename:g})}),Promise.all(D.map(h=>this.p(h,m))).then(h=>{v({limitHit:this.e,stats:h[0]||void 0})},h=>{d(new Error((0,k.toErrorMessage)(h)))})})}async p(y,D){const v=new t.CancellationTokenSource,d=this.q(y),m=this.r(),h=new S.QueryGlobTester(this.k,y),w=!h.hasSiblingExcludeClauses();let g;try{this.h.add(v),g=A.StopWatch.create();const p=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},d,v.token),b=g.elapsed(),i=A.StopWatch.create();return this.g&&!this.e||(p&&p.forEach(s=>{const a=o.posix.relative(y.folder.path,s.path);if(w){const u=o.basename(s.path);this.v(D,{base:y.folder,relativePath:a,basename:u});return}this.s(m,y.folder,a,D)}),this.g&&!this.e)?null:(this.u(m,h,D),{providerTime:b,postProcessTime:i.elapsed()})}finally{v.dispose(),this.h.delete(v)}}q(y){const D=(0,S.resolvePatternsForProvider)(this.k.includePattern,y.includePattern),v=(0,S.resolvePatternsForProvider)(this.k.excludePattern,y.excludePattern);return{folder:y.folder,excludes:v,includes:D,useIgnoreFiles:!y.disregardIgnoreFiles,useGlobalIgnoreFiles:!y.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!y.disregardParentIgnoreFiles,followSymlinks:!y.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const y={rootEntries:[],pathToEntries:Object.create(null)};return y.pathToEntries["."]=y.rootEntries,y}s({pathToEntries:y},D,v,d){if(v===this.a){const h=o.basename(this.a);this.v(d,{base:D,relativePath:this.a,basename:h})}function m(h){const w=o.basename(h),g=o.dirname(h);let p=y[g];p||(p=y[g]=[],m(g)),p.push({base:D,relativePath:h,basename:w})}m(v)}u({rootEntries:y,pathToEntries:D},v,d){const m=this,h=this.a;function w(g){const p=(0,S.hasSiblingFn)(()=>g.map(b=>b.basename));for(let b=0,i=g.length;b<i;b++){const s=g[b],{relativePath:a,basename:u}=s;if(v.matchesExcludesSync(a,u,h!==u?p:void 0))continue;const c=D[a];if(c)w(c);else{if(a===h)continue;m.v(d,s)}if(m.e)break}}w(y)}v(y,D){(!this.b||D.relativePath&&this.b(D.relativePath,D.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||y(D))}}class L{constructor(){this.b=new Map}fileSearch(y,D,v,d){const m=this.c(y.cacheKey),h=new C(y,D,m&&m.token);let w=0;const g=p=>{w+=p.length,v(p.map(b=>this.d(b)))};return this.e(h,L.a,g,d).then(p=>({limitHit:p.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:w,detailStats:p.stats}}))}clearCache(y){this.c(y)?.cancel()}c(y){if(!!y)return this.b.has(y)||this.b.set(y,new t.CancellationTokenSource),this.b.get(y)}d(y){return y.relativePath?{resource:I.joinPath(y.base,y.relativePath)}:{resource:y.base}}e(y,D,v,d){d.onCancellationRequested(()=>{y.cancel()});const m=w=>{w&&(h.push(w),D>0&&h.length>=D&&(v(h),h=[]))};let h=[];return y.search(m).then(w=>(h.length&&v(h),w),w=>(h.length&&v(h),Promise.reject(w)))}}e.FileSearchManager=L,L.a=512}),define(ye[286],Ce([1,0,18,81,37,112,28,15,9,24,8,11,2,163,190,52,13,46,133,284,31]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y,D,v,d,m,h,w,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let b=class{constructor(f,E,T,M,G){this.a=f,this.b=E,this.c=T,this.d=M,this.e=G}text(f,E,T={}){f=this.f(f,T);const M=this.a.getValue(),G=E&&E.some(N=>!this.a.getValue({resource:N}).search.useRipgrep);return{...this.h(E?.map(h.toWorkspaceFolder),T),type:2,contentPattern:f,previewOptions:T.previewOptions,maxFileSize:T.maxFileSize,usePCRE2:M.search.usePCRE2||G||!1,beforeContext:T.beforeContext,afterContext:T.afterContext,userDisabledExcludesAndIgnoreFiles:T.disregardExcludeSettings&&T.disregardIgnoreFiles}}f(f,E){const T=this.a.getValue();f.isRegExp&&(f.pattern=f.pattern.replace(/\r?\n/g,"\\n"));const M={...f,wordSeparators:T.editor.wordSeparators};return this.j(f,E)&&(M.isCaseSensitive=!0),this.k(f)&&(M.isMultiline=!0),M}file(f,E={}){return{...this.h(f,E),type:1,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey}}g(f,E){return f?(f=Array.isArray(f)?f.map(c):c(f),E?this.parseSearchPaths(f):{pattern:s(...Array.isArray(f)?f:[f])}):{}}h(f=[],E={}){const T=this.g(E.includePattern,E.expandPatterns),M=this.g(E.excludePattern,E.expandPatterns),G=f.length>1,V=(T.searchPaths&&T.searchPaths.length?T.searchPaths.map(F=>this.q(F,E,M)):f.map(F=>this.r(F,E,M,G))).filter(F=>!!F),N={_reason:E._reason,folderQueries:V,usingSearchPaths:!!(T.searchPaths&&T.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:M.pattern,includePattern:T.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const F=o.coalesce(o.flatten(this.c.groups.map(W=>W.editors.map(X=>X.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const z=F.filter(W=>(0,p.pathIncludedInQuery)(N,W.fsPath)),B=this.i(z);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(B)),{...N,...B}}const U=E.extraFileResources&&E.extraFileResources.filter(F=>(0,p.pathIncludedInQuery)(N,F.fsPath));return N.extraFileResources=U&&U.length?U:void 0,N}i(f){const E=[],T=new I.ResourceMap,M={};let G=!1;return f.forEach(V=>{if(V.scheme===A.Schemas.walkThrough)return;if((0,C.isAbsolutePath)(V)){const U=this.b.getWorkspaceFolder(V)?.uri??V.with({path:S.dirname(V.fsPath)});let F=T.get(U);F||(G=!0,F={folder:U,includePattern:{}},E.push(F),T.set(U,F));const z=S.relative(U.fsPath,V.fsPath);(0,P.assertIsDefined)(F.includePattern)[z.replace(/\\/g,"/")]=!0}else V.fsPath&&(G=!0,M[V.fsPath]=!0)}),{folderQueries:E,includePattern:M,usingSearchPaths:!0,excludePattern:G?void 0:{"**/*":!0}}}j(f,E){if(E.isSmartCase){if(f.isRegExp){if(L.containsUppercaseCharacter(f.pattern,!0))return!0}else if(L.containsUppercaseCharacter(f.pattern))return!0}return!!f.isCaseSensitive}k(f){return f.isMultiline||f.isRegExp&&(0,D.isMultilineRegexSource)(f.pattern)||f.pattern.indexOf(`
`)>=0?!0:!!f.isMultiline}parseSearchPaths(f){const E=B=>S.isAbsolute(B)||/^\.\.?([\/\\]|$)/.test(B),M=(Array.isArray(f)?f:a(f)).map(B=>{const W=this.e.resolvedUserHome;return W?(0,R.untildify)(B,W.scheme===A.Schemas.file?W.fsPath:W.path):B}),G=t.groupBy(M,B=>E(B)?"searchPaths":"exprSegments"),V=(G.exprSegments||[]).map(B=>L.rtrim(B,"/")).map(B=>L.rtrim(B,"\\")).map(B=>(B[0]==="."&&(B="*"+B),u(B))),N={},U=this.m(G.searchPaths||[]);U&&U.length&&(N.searchPaths=U);const F=o.flatten(V),z=s(...F);return z&&(N.pattern=z),N}l(f,E){return E.disregardExcludeSettings?void 0:(0,p.getExcludes)(f,!E.disregardSearchExcludeSettings)}m(f){if(!f||!f.length)return[];const E=f.flatMap(M=>{let{pathPortion:G,globPortion:V}=i(M);return V&&(V=l(V)),this.n(G).flatMap(U=>this.o(U,V))}),T=new Map;return E.forEach(M=>{const G=M.searchPath.toString(),V=T.get(G);V?M.pattern&&(V.pattern=V.pattern||{},V.pattern[M.pattern]=!0):T.set(G,{searchPath:M.searchPath,pattern:M.pattern?s(M.pattern):void 0})}),Array.from(T.values())}n(f){if(S.isAbsolute(f)){const E=this.b.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==A.Schemas.file?[{searchPath:E[0].uri.with({path:f})}]:[{searchPath:y.URI.file(S.normalize(f))}]}if(this.b.getWorkbenchState()===2){const E=this.b.getWorkspace().folders[0].uri;if(f=c(f),f.startsWith("../")||f===".."){const M=S.posix.resolve(E.path,f);return[{searchPath:E.with({path:M})}]}const T=l(f);return[{searchPath:E,pattern:T}]}else{if(f==="./"||f===".\\")return[];{const E=f.replace(/^\.[\/\\]/,""),M=this.b.getWorkspace().folders.map(G=>{const V=E.match(new RegExp(`^${L.escapeRegExpCharacters(G.name)}(?:/(.*)|$)`));return V?{match:V,folder:G}:null}).filter(P.isDefined);if(M.length)return M.map(G=>{const V=G.match[1];return{searchPath:G.folder.uri,pattern:V&&l(V)}});{const G=f.match(/\.[\/\\](.+)[\/\\]?/),V=G?G[1]:f,N=v.localize(0,null,V);throw new Error(N)}}}}o(f,E){const T=f.pattern&&E?`${f.pattern}/${E}`:f.pattern||E,M=[{searchPath:f.searchPath,pattern:T}];return T&&!T.endsWith("**")&&M.push({searchPath:f.searchPath,pattern:T+"/**"}),M}q(f,E,T){const M=this.r((0,h.toWorkspaceFolder)(f.searchPath),E,T,!1);return M?{...M,includePattern:f.pattern}:null}r(f,E,T,M){let G;const V=y.URI.isUri(f)?f:f.uri;if(T.searchPaths){const B=T.searchPaths.filter(W=>(0,C.isEqual)(W.searchPath,V))[0];if(B&&!B.pattern)return null;B&&(G=B.pattern)}const N=this.a.getValue({resource:V}),F={...this.l(N,E)||{},...G||{}},z=y.URI.isUri(f)?(0,C.basename)(f):f.name;return{folder:V,folderName:M?z:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:N.files&&N.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!N.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!N.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof E.disregardParentIgnoreFiles=="boolean"?E.disregardParentIgnoreFiles:!N.search.useParentIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!N.search.followSymlinks}}};b=qe([He(0,d.IConfigurationService),He(1,h.IWorkspaceContextService),He(2,w.IEditorGroupsService),He(3,m.ILogService),He(4,g.IPathService)],b),e.QueryBuilder=b;function i(r){const f=r.match(/[\*\{\}\(\)\[\]\?]/);if(f){const E=f.index,T=r.substr(0,E).match(/[/|\\][^/\\]*$/);if(T){let M=r.substr(0,T.index);return M.match(/[/\\]/)||(M+="/"),{pathPortion:M,globPortion:r.substr((T.index||0)+1)}}}return{pathPortion:r}}function s(...r){return r.length?r.reduce((f,E)=>(f[E]=!0,f),Object.create(null)):void 0}function a(r){return k.splitGlobAware(r,",").map(f=>f.trim()).filter(f=>!!f.length)}function u(r){return[`**/${r}/**`,`**/${r}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function c(r){return r.replace(/\\/g,"/")}function l(r){return c(r).replace(/^\.\//,"").replace(/\/+$/g,"")}function n(r,f){r=o.distinct(r,M=>M.toString());const E=[],T=f.getWorkspace();return r&&r.forEach(M=>{let G;if(f.getWorkbenchState()===2)G=(0,C.relativePath)(T.folders[0].uri,M),G&&G!=="."&&(G="./"+G);else{const V=f.getWorkspaceFolder(M);if(V){const N=V.name;if(T.folders.filter(F=>F.name===N).length===1){const F=(0,C.relativePath)(V.uri,M);F===""?G=`./${V.name}`:G=`./${V.name}/${F}`}else G=M.fsPath}}G&&E.push(G)}),E}e.resolveResourcesForSearchIncludes=n}),define(ye[287],Ce([1,0,24,2,21,10,3,286,31,46]),function(ne,e,o,t,k,R,I,A,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function P(d,m){const h=m.activationEvents;if(!h)return Promise.resolve(void 0);const w=[],g=[];for(const u of h)if(/^workspaceContains:/.test(u)){const c=u.substr(18);c.indexOf("*")>=0||c.indexOf("?")>=0||d.forceUsingSearch?g.push(c):w.push(c)}if(w.length===0&&g.length===0)return Promise.resolve(void 0);let p;const b=new Promise((u,c)=>{p=u}),i=u=>p({activationEvent:u}),s=Promise.all(w.map(u=>y(d,u,i))).then(()=>{}),a=D(d,m.identifier,g,i);return Promise.all([s,a]).then(()=>{p(void 0)}),b}e.checkActivateWorkspaceContainsExtension=P;async function y(d,m,h){for(const w of d.folders)if(await d.exists(o.joinPath(t.URI.revive(w),m))){h(`workspaceContains:${m}`);return}}async function D(d,m,h,w){if(h.length===0)return Promise.resolve(void 0);const g=new k.CancellationTokenSource,p=d.checkExists(d.folders,h,g.token),b=setTimeout(async()=>{g.cancel(),d.logService.info(`Not activating extension '${m.value}': Timed out while searching for 'workspaceContains' pattern ${h.join(",")}`)},L);let i=!1;try{i=await p}catch(s){R.isCancellationError(s)||R.onUnexpectedError(s)}g.dispose(),clearTimeout(b),i&&w(`workspaceContains:${h.join(",")}`)}function v(d,m,h,w){const g=d.get(I.IInstantiationService),p=d.get(S.ISearchService),i=g.createInstance(A.QueryBuilder).file(m.map(s=>(0,C.toWorkspaceFolder)(t.URI.revive(s))),{_reason:"checkExists",includePattern:h,exists:!0});return p.fileSearch(i,w).then(s=>!!s.limitHit,s=>R.isCancellationError(s)?!1:Promise.reject(s))}e.checkGlobFileExists=v});var Je=this&&this.__classPrivateFieldSet||function(ne,e,o,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!k:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ne,o):k?k.value=o:e.set(ne,o),o},Ue=this&&this.__classPrivateFieldGet||function(ne,e,o,t){if(o==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?t:o==="a"?t.call(ne):t?t.value:e.get(ne)};define(ye[41],Ce([1,0,174,9,77,24,16,6,64,2,13,5,34,229,98,33,27,134,10,26,22,211,7,128,3,25,73,17,89,54,40,4,287,97,213,15,96,42]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y,D,v,d,m,h,w,g,p,b,i,s,a,u,c,l,n,r,f,E,T,M,G,V,N,U){"use strict";var F,z,B;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,a.createDecorator)("IHostUtils");let W=class Mn extends A.Disposable{constructor(te,J,fe,ve,Ee,Ae,Fe,se,le,ue,ee){super(),this.a=this.B(new E.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=J,this.g=fe,this.f=Fe,this.j=ve,this.k=Ee,this.l=Ae,this.m=le,this.p=ue,this.s=ee,this.t=this.g.getProxy(P.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(P.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(P.MainContext.MainThreadExtensionService),this.w=new I.Barrier,this.y=new I.Barrier,this.z=new I.Barrier,this.C=new I.Barrier,this.F=new h.ExtensionDescriptionRegistry(this.f.allExtensions);const ae=(0,m.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new h.ExtensionDescriptionRegistry(_(this.F,ae)),this.G=new v.ExtHostStorage(this.g,this.l),this.H=new M.ExtHostSecretState(this.g),this.I=se,this.h=te.createChild(new n.ServiceCollection([v.IExtHostStorage,this.G],[M.IExtHostSecretState,this.H])),this.J=this.B(new D.ExtensionsActivator(this.D,this.F,{onExtensionActivationError:(ie,O,H)=>{this.v.$onExtensionActivationError(ie,w.transformErrorForSerialization(O),H)},actualActivateExtension:async(ie,O)=>{if(h.ExtensionDescriptionRegistry.isHostExtension(ie,this.D,this.F))return await this.v.$activateExtension(ie,O),new D.HostExtension;const H=this.D.getExtensionDescription(ie);return this.Y(H,O)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.nb(),this.w.open(),await this.j.waitForInitializeCall(),k.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.kb()}catch(te){w.onUnexpectedError(te)}}async Q(){this.I.onWillDeactivateAll();let te=[];try{te=this.D.getAllExtensionDescriptions().map(Ee=>Ee.identifier).filter(Ee=>this.isActivated(Ee)).map(Ee=>this.X(Ee))}catch{}await Promise.all(te)}terminate(te,J=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${te}`),this.l.flush(),this.p.dispose(),this.J.dispose(),w.setUnexpectedErrorHandler(ve=>{this.l.error(ve)}),this.g.dispose();const fe=this.Q();Promise.race([(0,I.timeout)(5e3),fe]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${J}`):this.l.info(`Extension host exiting with code ${J}`),this.l.flush(),this.l.dispose(),this.c.exit(J)})}isActivated(te){return this.z.isOpen()?this.J.isActivated(te):!1}async getExtension(te){const J=await this.v.$getExtension(te);let fe;if(J?.browserNlsBundleUris){fe={};for(const ve of Object.keys(J.browserNlsBundleUris))fe[ve]=C.URI.revive(J.browserNlsBundleUris[ve])}return J&&{...J,identifier:new g.ExtensionIdentifier(J.identifier.value),extensionLocation:C.URI.revive(J.extensionLocation),browserNlsBundleUris:fe}}R(te,J){return this.J.activateByEvent(te,J)}S(te,J){return this.J.activateById(te,J)}activateByIdWithErrors(te,J){return this.S(te,J).then(()=>{const fe=this.J.getActivatedExtension(te);if(fe.activationFailed)return Promise.reject(fe.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(te=>this.D)}getExtensionExports(te){return this.z.isOpen()?this.J.getActivatedExtension(te).exports:null}async U(te){if(te.scheme!==V.Schemas.file)return te;const J=await this.c.realpath(te.fsPath);return C.URI.file(J)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(te=>new Z(te))),this.L}async W(te){const J=S.TernarySearchTree.forUris(fe=>R.extUriBiasedIgnorePathCase.ignorePathCasing(fe));return await Promise.all(te.map(async fe=>{if(this.ob(fe)){const ve=await this.U(fe.extensionLocation);J.set(ve,fe)}})),J}X(te){let J=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(te))return J;const fe=this.J.getActivatedExtension(te);if(!fe)return J;try{typeof fe.module.deactivate=="function"&&(J=Promise.resolve(fe.module.deactivate()).then(void 0,ve=>(this.l.error(ve),Promise.resolve(void 0))))}catch(ve){this.l.error(`An error occurred when deactivating the extension '${te.value}':`),this.l.error(ve)}try{(0,A.dispose)(fe.subscriptions)}catch(ve){this.l.error(`An error occurred when deactivating the subscriptions for extension '${te.value}':`),this.l.error(ve)}return J}async Y(te,J){return this.f.remote.isRemote?this.v.$onWillActivateExtension(te.identifier):await this.v.$onWillActivateExtension(te.identifier),this.ab(te,J).then(fe=>{const ve=fe.activationTimes;return this.v.$onDidActivateExtension(te.identifier,ve.codeLoadingTime,ve.activateCallTime,ve.activateResolvedTime,J),this.Z(te,J,"success",ve),fe},fe=>{throw this.Z(te,J,"failure"),fe})}Z(te,J,fe,ve){const Ee=X(te,J);this.u.$publicLog2("extensionActivationTimes",{...Ee,...ve||{},outcome:fe})}ab(te,J){const fe=X(te,J);this.u.$publicLog2("activatePlugin",fe);const ve=this.ob(te);if(!ve)return Promise.resolve(new D.EmptyExtension(D.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${te.identifier.value}, startup: ${J.startup}, activationEvent: '${J.activationEvent}'${te.identifier.value!==J.extensionId.value?`, root cause: ${J.extensionId.value}`:""}`),this.l.flush();const Ee=new D.ExtensionActivationTimesBuilder(J.startup);return Promise.all([this.pb(te,(0,R.joinPath)(te.extensionLocation,ve),Ee),this.bb(te)]).then(Ae=>(k.mark(`code/extHost/willActivateExtension/${te.identifier.value}`),Mn.cb(this.l,te.identifier,Ae[0],Ae[1],Ee))).then(Ae=>(k.mark(`code/extHost/didActivateExtension/${te.identifier.value}`),Ae))}bb(te){const J=new b.ExtensionGlobalMemento(te,this.G),fe=new b.ExtensionMemento(te.identifier.value,!1,this.G),ve=new G.ExtensionSecrets(te,this.H),Ee=te.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Ae=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${te.identifier.value}`),Promise.all([J.whenReady,fe.whenReady,this.I.whenReady]).then(()=>{const Fe=this;let se,le;const ue=(0,m.isProposedApiEnabled)(te,"ipc")?this.f.messagePorts?.get(g.ExtensionIdentifier.toKey(te.identifier)):void 0;return Object.freeze({globalState:J,workspaceState:fe,secrets:ve,subscriptions:[],get extensionUri(){return te.extensionLocation},get extensionPath(){return te.extensionLocation.fsPath},asAbsolutePath(ee){return t.join(te.extensionLocation.fsPath,ee)},get storagePath(){return Fe.I.workspaceValue(te)?.fsPath},get globalStoragePath(){return Fe.I.globalValue(te).fsPath},get logPath(){return t.join(Fe.f.logsLocation.fsPath,te.identifier.value)},get logUri(){return C.URI.joinPath(Fe.f.logsLocation,te.identifier.value)},get storageUri(){return Fe.I.workspaceValue(te)},get globalStorageUri(){return Fe.I.globalValue(te)},get extensionMode(){return Ee},get extension(){return se===void 0&&(se=new q(Fe,te.identifier,te,Ae,!1)),se},get extensionRuntime(){return(0,m.checkProposedApiEnabled)(te,"extensionRuntime"),Fe.extensionRuntime},get environmentVariableCollection(){return Fe.p.getEnvironmentVariableCollection(te)},get messagePassingProtocol(){if(!le){if(!ue)return;const ee=E.Event.buffer(E.Event.fromDOMEventEmitter(ue,"message",ae=>ae.data));ue.start(),le={onDidReceiveMessage:ee,postMessage:ue.postMessage.bind(ue)}}return le}})})}static cb(te,J,fe,ve,Ee){return fe=fe||{activate:void 0,deactivate:void 0},this.db(te,J,fe,ve,Ee).then(Ae=>new D.ActivatedExtension(!1,null,Ee.build(),fe,Ae,ve.subscriptions))}static db(te,J,fe,ve,Ee){if(typeof fe.activate=="function")try{Ee.activateCallStart(),te.trace(`ExtensionService#_callActivateOptional ${J.value}`);const Ae=typeof global=="object"?global:self,Fe=fe.activate.apply(Ae,[ve]);return Ee.activateCallStop(),Ee.activateResolveStart(),Promise.resolve(Fe).then(se=>(Ee.activateResolveStop(),se))}catch(Ae){return Promise.reject(Ae)}else return Promise.resolve(fe)}eb(te,J){this.S(te.identifier,{startup:!1,extensionId:te.identifier,activationEvent:J}).then(void 0,fe=>{this.l.error(fe)})}fb(){this.v.$setPerformanceMarks(k.getMarks());for(const te of this.D.getAllExtensionDescriptions())if(te.activationEvents)for(const J of te.activationEvents)J==="onStartupFinished"&&this.eb(te,J)}gb(){const te=this.R("*",!0).then(void 0,Ee=>{this.l.error(Ee)});this.B(this.j.onDidChangeWorkspace(Ee=>this.hb(Ee.added)));const J=this.j.workspace?this.j.workspace.folders:[],fe=this.hb(J),ve=Promise.all([te,fe]).then(()=>{});return Promise.race([ve,(0,I.timeout)(1e4)]).then(()=>{this.fb()}),ve}hb(te){return te.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(J=>this.ib(te,J))).then(()=>{})}async ib(te,J){if(this.isActivated(J.identifier))return;const fe=!this.f.remote.isRemote&&!!this.f.remote.authority,ve={logService:this.l,folders:te.map(Ae=>Ae.uri),forceUsingSearch:fe,exists:Ae=>this.c.exists(Ae.fsPath),checkExists:(Ae,Fe,se)=>this.t.$checkExists(Ae,Fe,se)},Ee=await(0,T.checkActivateWorkspaceContainsExtension)(ve,J);if(!!Ee)return this.S(J.identifier,{startup:!0,extensionId:J.identifier,activationEvent:Ee.activationEvent}).then(void 0,Ae=>this.l.error(Ae))}async $extensionTestsExecute(){await this.C.wait();try{return await this.jb()}catch(te){throw console.error(te),te}}async jb(){const{extensionDevelopmentLocationURI:te,extensionTestsLocationURI:J}=this.f.environment;if(!te||!J)throw new Error(o.localize(0,null));const fe=await this.pb(null,J,new D.ExtensionActivationTimesBuilder(!1));if(!fe||typeof fe.run!="function")throw new Error(o.localize(1,null,J.toString()));return new Promise((ve,Ee)=>{const Ae=(le,ue)=>{le?Ee(le):ve(typeof ue=="number"&&ue>0?1:0)},Fe=(0,R.originalFSPath)(J),se=fe.run(Fe,Ae);se&&se.then&&se.then(()=>{ve(0)}).catch(le=>{Ee(le instanceof Error&&le.stack?le.stack:String(le))})})}kb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.gb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(te,J){return this.M[te]=J,(0,A.toDisposable)(()=>{delete this.M[te]})}async lb(te){const J=te.indexOf("+");if(J===-1)throw new Error("Not an authority that can be resolved!");const fe=te.substr(0,J);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${fe}`,!1),{authorityPrefix:fe,resolver:this.M[fe]}}async $resolveAuthority(te,J){const fe=U.StopWatch.create(!1),ve=()=>`[resolveAuthority(${Q(te)},${J})][${fe.elapsed()}ms] `,Ee=ue=>this.l.info(`${ve()}${ue}`),Ae=(ue,ee=void 0)=>this.l.error(`${ve()}${ue}`,ee);Ee("activating resolver...");const{authorityPrefix:Fe,resolver:se}=await this.lb(te);if(!se)return Ae("no resolver"),{type:"error",error:{code:s.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Fe}.`,detail:void 0}};const le=new I.IntervalTimer;try{Ee("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(se)),le.cancelAndSet(()=>Ee("waiting..."),1e3),Ee("invoking resolve()..."),k.mark(`code/extHost/willResolveAuthority/${Fe}`);const ue=await se.resolve(te,{resolveAttempt:J});k.mark(`code/extHost/didResolveAuthorityOK/${Fe}`),le.dispose(),Ee(`returned ${ue.host}:${ue.port}`);const ee={authority:te,host:ue.host,port:ue.port,connectionToken:ue.connectionToken},ae={extensionHostEnv:ue.extensionHostEnv,isTrusted:ue.isTrusted,authenticationSession:ue.authenticationSessionForInitializingExtensions?{id:ue.authenticationSessionForInitializingExtensions.id,providerId:ue.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:ee,options:ae,tunnelInformation:{environmentTunnels:ue.environmentTunnels,features:ue.tunnelFeatures}}}}catch(ue){if(k.mark(`code/extHost/didResolveAuthorityError/${Fe}`),le.dispose(),Ae("returned an error",ue),ue instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:ue._code,message:ue._message,detail:ue._detail}};throw ue}}async $getCanonicalURI(te,J){this.l.info(`$getCanonicalURI invoked for authority (${Q(te)})`);const{resolver:fe}=await this.lb(te);if(!fe)return null;const ve=C.URI.revive(J);if(typeof fe.getCanonicalURI>"u")return ve;const Ee=await(0,I.asPromise)(()=>fe.getCanonicalURI(ve));return Ee||ve}static mb(te,J,fe){const ve=new h.ExtensionDescriptionRegistry(te.getAllExtensionDescriptions());ve.deltaExtensions(fe.toAdd,fe.toRemove);const Ee=(0,m.extensionIdentifiersArrayToSet)(J.getAllExtensionDescriptions().map(Fe=>Fe.identifier));for(const Fe of fe.myToRemove)Ee.delete(g.ExtensionIdentifier.toKey(Fe));for(const Fe of fe.myToAdd)Ee.add(g.ExtensionIdentifier.toKey(Fe));const Ae=_(ve,Ee);return{globalRegistry:ve,myExtensions:Ae}}$startExtensionHost(te){te.toAdd.forEach(ve=>ve.extensionLocation=C.URI.revive(ve.extensionLocation));const{globalRegistry:J,myExtensions:fe}=Mn.mb(this.F,this.D,te);return this.F.set(J.getAllExtensionDescriptions()),this.D.set(fe),this.kb()}$activateByEvent(te,J){return J===1?this.R(te,!1):this.z.wait().then(fe=>this.R(te,!1))}async $activate(te,J){return await this.z.wait(),this.D.getExtensionDescription(te)?(await this.S(te,J),!0):!1}async $deltaExtensions(te){te.toAdd.forEach(Ae=>Ae.extensionLocation=C.URI.revive(Ae.extensionLocation));const{globalRegistry:J,myExtensions:fe}=Mn.mb(this.F,this.D,te),ve=await this.W(fe);return(await this.getExtensionPathIndex()).setSearchTree(ve),this.F.set(J.getAllExtensionDescriptions()),this.D.set(fe),Promise.resolve(void 0)}async $test_latency(te){return te}async $test_up(te){return te.byteLength}async $test_down(te){const J=p.VSBuffer.alloc(te),fe=Math.random()%256;for(let ve=0;ve<te;ve++)J.writeUInt8(fe,ve);return J}async $updateRemoteConnectionData(te){this.P=te,this.a.fire()}};W=qe([He(0,a.IInstantiationService),He(1,e.IHostUtils),He(2,l.IExtHostRpcService),He(3,d.IExtHostWorkspace),He(4,y.IExtHostConfiguration),He(5,L.ILogService),He(6,u.IExtHostInitDataService),He(7,c.IExtensionStoragePaths),He(8,r.IExtHostTunnelService),He(9,f.IExtHostTerminalService),He(10,N.IExtHostLocalizationService)],W),e.AbstractExtHostExtensionService=W;function X(ge,te){return{id:ge.identifier.value,name:ge.name,extensionVersion:ge.version,publisherDisplayName:ge.publisher,activationEvents:ge.activationEvents?ge.activationEvents.join(","):null,isBuiltin:ge.isBuiltin,reason:te.activationEvent,reasonId:te.extensionId.value}}e.IExtHostExtensionService=(0,a.createDecorator)("IExtHostExtensionService");class q{constructor(te,J,fe,ve,Ee){F.set(this,void 0),z.set(this,void 0),B.set(this,void 0),Je(this,F,te,"f"),Je(this,z,J,"f"),Je(this,B,fe.identifier,"f"),this.id=fe.identifier.value,this.extensionUri=fe.extensionLocation,this.extensionPath=t.normalize((0,R.originalFSPath)(fe.extensionLocation)),this.packageJSON=fe,this.extensionKind=ve,this.isFromDifferentExtensionHost=Ee}get isActive(){return Ue(this,F,"f").isActivated(Ue(this,B,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ue(this,F,"f").getExtensionExports(Ue(this,B,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ue(this,F,"f").activateByIdWithErrors(Ue(this,B,"f"),{startup:!1,extensionId:Ue(this,z,"f"),activationEvent:"api"}),this.exports}}e.Extension=q,F=new WeakMap,z=new WeakMap,B=new WeakMap;function _(ge,te){return ge.getAllExtensionDescriptions().filter(J=>te.has(g.ExtensionIdentifier.toKey(J.identifier)))}function Q(ge){const te=ge.indexOf("+");return te===-1?ge:ge.substring(0,te)}class Z{constructor(te){this.a=te}setSearchTree(te){this.a=te}findSubstr(te){return this.a.findSubstr(te)}forEach(te){return this.a.forEach(te)}}e.ExtensionPaths=Z}),define(ye[288],Ce([1,0,77,2,5,34,27,26,17,25,3,41,36,13,8]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y,D,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let d=class{constructor(b,i,s,a,u,c,l){this.c=b,this.d=i,this.e=s,this.f=a,this.g=u,this.h=c,this.i=l,this.a=new Map,this.b=[]}async install(){this.j(),o.mark("code/extHost/willWaitForConfig");const b=await this.f.getConfigProvider();o.mark("code/extHost/didWaitForConfig");const i=await this.g.getExtensionPathIndex();this.register(new h(this.c,i,this.d,b,this.i)),this.register(this.e.createInstance(w,i)),this.register(this.e.createInstance(m)),this.h.remote.isRemote&&this.register(this.e.createInstance(g,i,this.h.environment.appUriScheme))}register(b){if("nodeModuleName"in b)if(Array.isArray(b.nodeModuleName))for(const i of b.nodeModuleName)this.a.set(i,b);else this.a.set(b.nodeModuleName,b);typeof b.alternativeModuleName=="function"&&this.b.push(i=>b.alternativeModuleName(i))}};d=qe([He(2,L.IInstantiationService),He(3,R.IExtHostConfiguration),He(4,P.IExtHostExtensionService),He(5,C.IExtHostInitDataService),He(6,D.ILogService)],d),e.RequireInterceptor=d;let m=class ti{constructor(b){if(b.environment.appRoot&&ti.a.size){const i=(0,v.escapeRegExpCharacters)(this.c(b.environment.appRoot.fsPath)),s="[a-z0-9_.-]",a=`@${s}+\\/${s}+|${s}+`,u="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${i}/${u}\\/)(${a})(.*)$`,"i")}}alternativeModuleName(b){if(!this.b)return;const i=this.b.exec(this.c(b));if(!i)return;const[,s,a,u]=i,c=ti.a.get(a);if(c!==void 0)return console.warn(`${a} as been renamed to ${c}, please update your imports`),s+c+u}c(b){return b.replace(/\\/g,"/")}};m.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),m=qe([He(0,C.IExtHostInitDataService)],m);class h{constructor(b,i,s,a,u){this.c=b,this.d=i,this.e=s,this.f=a,this.g=u,this.nodeModuleName="vscode",this.a=new Map}load(b,i){const s=this.d.findSubstr(i);if(s){let a=this.a.get(A.ExtensionIdentifier.toKey(s.identifier));return a||(a=this.c(s,this.e,this.f),this.a.set(A.ExtensionIdentifier.toKey(s.identifier),a)),a}if(!this.b){let a="";this.d.forEach((u,c)=>a+=`	${c} -> ${u.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${a}`),this.b=this.c(I.nullExtensionDescription,this.e,this.f)}return this.b}}let w=class{constructor(b,i,s){this.d=b,this.nodeModuleName="keytar",this.a=i.getProxy(k.MainContext.MainThreadTelemetry);const{environment:a}=s,u=i.getProxy(k.MainContext.MainThreadKeytar);if(a.appRoot){let c=a.appRoot.fsPath;y.platform==="win32"&&(c=c.replace(/\\/g,"/")),c[c.length-1]==="/"&&(c=c.substr(0,c.length-1)),this.b=new Set,this.b.add(`${c}/node_modules.asar/keytar`),this.b.add(`${c}/node_modules/keytar`)}this.c={getPassword:(c,l)=>u.$getPassword(c,l),setPassword:(c,l,n)=>u.$setPassword(c,l,n),deletePassword:(c,l)=>u.$deletePassword(c,l),findPassword:c=>u.$findPassword(c),findCredentials(c){return u.$findCredentials(c)}}}load(b,i){const s=this.d.findSubstr(i);return this.a.$publicLog2("shimming.keytar",{extension:s?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(b){const i=b.length;if(i<=7||!this.b)return;const s=i-7;if((b.charAt(s)==="/"||b.charAt(s)==="\\")&&b.endsWith("keytar")&&(b=b.replace(/\\/g,"/"),this.b.has(b)))return"keytar"}};w=qe([He(1,S.IExtHostRpcService),He(2,C.IExtHostInitDataService)],w);let g=class{constructor(b,i,s){this.e=b,this.f=i,this.nodeModuleName=["open","opn"],this.d=s.getProxy(k.MainContext.MainThreadTelemetry);const a=s.getProxy(k.MainContext.MainThreadWindow);this.c=(u,c)=>{const l=t.URI.parse(u);return c?this.g(u,c):l.scheme==="http"||l.scheme==="https"?a.$openUri(l,u,{allowTunneling:!0}):l.scheme==="mailto"||l.scheme===this.f?a.$openUri(l,u,{}):this.g(u,c)}}load(b,i,s){const a=this.e.findSubstr(i);return a&&(this.a=a.identifier.value,this.h()),this.b=s(b),this.c}g(b,i){return this.i(),this.b(b,i)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};g=qe([He(2,S.IExtHostRpcService)],g)}),define(ye[48],Ce([1,0,82,6,9,36,3,58,59,41,7,33,225,34]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,I.createDecorator)("IExtHostVariableResolverProvider");class v extends y.AbstractVariableResolverService{constructor(h,w,g,p,b,i,s){function a(){if(g){const u=g.activeEditor();if(u)return u.document.uri;const c=p.tabGroups.all.find(l=>l.isActive)?.activeTab;if(c!==void 0){if(c.input instanceof L.TextDiffTabInput||c.input instanceof L.NotebookDiffEditorTabInput)return c.input.modified;if(c.input instanceof L.TextTabInput||c.input instanceof L.NotebookEditorTabInput||c.input instanceof L.CustomEditorTabInput)return c.input.uri}}}super({getFolderUri:u=>{const c=i.folders.filter(l=>l.name===u);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(u,c)=>b.getConfiguration(void 0,u).get(c),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const u=a();if(u)return k.normalize(u.fsPath)},getWorkspaceFolderPathForFile:()=>{if(w){const u=a();if(u){const c=w.getWorkspaceFolder(u);if(c)return k.normalize(c.uri.fsPath)}}},getSelectedText:()=>{if(g){const u=g.activeEditor();if(u&&!u.selection.isEmpty)return u.document.getText(u.selection)}},getLineNumber:()=>{if(g){const u=g.activeEditor();if(u)return String(u.selection.end.line+1)}},getExtension:u=>h.getExtension(u)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(R.env))}}let d=class extends t.Disposable{constructor(h,w,g,p,b){super(),this.b=h,this.c=w,this.g=g,this.h=p,this.i=b,this.a=new o.Lazy(async()=>{const i=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async u=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new v(this.b,this.c,this.g,this.i,i,a,this.j())})}getResolver(){return this.a.getValue()}j(){}};d=qe([He(0,C.IExtHostExtensionService),He(1,P.IExtHostWorkspace),He(2,A.IExtHostDocumentsAndEditors),He(3,D.IExtHostConfiguration),He(4,S.IExtHostEditorTabs)],d),e.ExtHostVariableResolverProviderService=d}),define(ye[78],Ce([1,0,16,4,11,2,3,5,59,41,17,7,33,131,217,34,48]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y,D,v,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,I.createDecorator)("IExtHostDebugService");let h=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(a,u,c,l,n,r){this.D=u,this.E=c,this.F=l,this.G=n,this.H=r,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new t.Emitter,this.n=new t.Emitter,this.o=new t.Emitter,this.u=new t.Emitter,this.k=a.getProxy(A.MainContext.MainThreadDebugService),this.z=new t.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new g(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(f=>{f.onDidChange(E=>{this.I(f)}),this.I(f)})}asDebugSourceUri(a,u){const c=a;if(typeof c.sourceReference=="number"&&c.sourceReference>0){let l=`debug:${encodeURIComponent(c.path||"")}`,n="?";return u&&(l+=`${n}session=${encodeURIComponent(u.id)}`,n="&"),l+=`${n}ref=${c.sourceReference}`,R.URI.parse(l)}else{if(c.path)return R.URI.file(c.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(a){const u=[];for(const c of a.getAllExtensionDescriptions())if(c.contributes){const l=c.contributes.debuggers;if(l&&l.length>0)for(const n of l)(0,v.isDebuggerMainContribution)(n)&&u.push(n.type)}this.k.$registerDebugTypes(u)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const a=[];return this.w.forEach(u=>a.push(u)),a}addBreakpoints(a){this.T();const u=a.filter(n=>{const r=n.id;return this.w.has(r)?!1:(this.w.set(r,n),!0)});this.U(u,[],[]);const c=[],l=new Map;for(const n of u)if(n instanceof P.SourceBreakpoint){let r=l.get(n.location.uri.toString());r||(r={type:"sourceMulti",uri:n.location.uri,lines:[]},l.set(n.location.uri.toString(),r),c.push(r)),r.lines.push({id:n.id,enabled:n.enabled,condition:n.condition,hitCondition:n.hitCondition,logMessage:n.logMessage,line:n.location.range.start.line,character:n.location.range.start.character})}else n instanceof P.FunctionBreakpoint&&c.push({type:"function",id:n.id,enabled:n.enabled,hitCondition:n.hitCondition,logMessage:n.logMessage,condition:n.condition,functionName:n.functionName});return this.k.$registerBreakpoints(c)}removeBreakpoints(a){this.T();const u=a.filter(r=>this.w.delete(r.id));this.U([],u,[]);const c=u.filter(r=>r instanceof P.SourceBreakpoint).map(r=>r.id),l=u.filter(r=>r instanceof P.FunctionBreakpoint).map(r=>r.id),n=u.filter(r=>r instanceof P.DataBreakpoint).map(r=>r.id);return this.k.$unregisterBreakpoints(c,l,n)}startDebugging(a,u,c){return this.k.$startDebugging(a?a.uri:void 0,u,{parentSessionID:c.parentSession?c.parentSession.id:void 0,lifecycleManagedByParent:c.lifecycleManagedByParent,repl:c.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:c.noDebug,compact:c.compact,suppressSaveBeforeStart:c.suppressSaveBeforeStart,suppressDebugStatusbar:c.suppressDebugStatusbar??c.debugUI?.simple,suppressDebugToolbar:c.suppressDebugToolbar??c.debugUI?.simple,suppressDebugView:c.suppressDebugView??c.debugUI?.simple})}stopDebugging(a){return this.k.$stopDebugging(a?a.id:void 0)}registerDebugConfigurationProvider(a,u,c){if(!u)return new P.Disposable(()=>{});const l=this.d++;return this.f.push({type:a,handle:l,provider:u}),this.k.$registerDebugConfigurationProvider(a,c,!!u.provideDebugConfigurations,!!u.resolveDebugConfiguration,!!u.resolveDebugConfigurationWithSubstitutedVariables,l),new P.Disposable(()=>{this.f=this.f.filter(n=>n.provider!==u),this.k.$unregisterDebugConfigurationProvider(l)})}registerDebugAdapterDescriptorFactory(a,u,c){if(!c)return new P.Disposable(()=>{});if(!this.P(a,u))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${u}' debugger.`);if(this.M(u))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const l=this.g++;return this.h.push({type:u,handle:l,factory:c}),this.k.$registerDebugAdapterDescriptorFactory(u,l),new P.Disposable(()=>{this.h=this.h.filter(n=>n.factory!==c),this.k.$unregisterDebugAdapterDescriptorFactory(l)})}registerDebugAdapterTrackerFactory(a,u){if(!u)return new P.Disposable(()=>{});const c=this.i++;return this.j.push({type:a,handle:c,factory:u}),new P.Disposable(()=>{this.j=this.j.filter(l=>l.factory!==u)})}async $runInTerminal(a,u){return Promise.resolve(void 0)}async $substituteVariables(a,u){let c;const l=await this.W(a);return l&&(c={uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(c,u)}J(a,u){if(a.type==="implementation")return new b(a.implementation)}K(){}async $startDASession(a,u){const c=this,l=await this.V(u);return this.R(this.M(l.type),l).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${l.type}' (extension might have failed to activate)`);const r=this.L(n),f=this.J(r,l);if(!f)throw new Error(`Couldn't create a debug adapter for type '${l.type}'.`);const E=f;return this.A.set(a,E),this.Q(l).then(T=>(T&&this.B.set(a,T),E.onMessage(async M=>{if(M.type==="request"&&M.command==="handshake"){const G=M,V={type:"response",seq:0,command:G.command,request_seq:G.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const N=await this.C.sign(G.arguments.value);V.body={signature:N},E.sendResponse(V)}else throw new Error("no signer")}catch(N){V.success=!1,V.message=N.message,E.sendResponse(V)}}else T&&T.onDidSendMessage&&T.onDidSendMessage(M),M=(0,v.convertToVSCPaths)(M,!0),c.k.$acceptDAMessage(a,M)}),E.onError(M=>{T&&T.onError&&T.onError(M),this.k.$acceptDAError(a,M.name,M.message,M.stack)}),E.onExit(M=>{T&&T.onExit&&T.onExit((0,k.withNullAsUndefined)(M),void 0),this.k.$acceptDAExit(a,(0,k.withNullAsUndefined)(M),void 0)}),T&&T.onWillStartSession&&T.onWillStartSession(),E.startSession()))})}$sendDAMessage(a,u){u=(0,v.convertToDAPaths)(u,!1);const c=this.B.get(a);c&&c.onWillReceiveMessage&&c.onWillReceiveMessage(u),this.A.get(a)?.sendMessage(u)}$stopDASession(a){const u=this.B.get(a);this.B.delete(a),u&&u.onWillStopSession&&u.onWillStopSession();const c=this.A.get(a);return this.A.delete(a),c?c.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(a){const u=[],c=[],l=[];if(a.added)for(const n of a.added){const r=n.id;if(r&&!this.w.has(r)){let f;if(n.type==="function")f=new P.FunctionBreakpoint(n.functionName,n.enabled,n.condition,n.hitCondition,n.logMessage);else if(n.type==="data")f=new P.DataBreakpoint(n.label,n.dataId,n.canPersist,n.enabled,n.hitCondition,n.condition,n.logMessage);else{const E=R.URI.revive(n.uri);f=new P.SourceBreakpoint(new P.Location(E,new P.Position(n.line,n.character)),n.enabled,n.condition,n.hitCondition,n.logMessage)}f._id=r,this.w.set(r,f),u.push(f)}}if(a.removed)for(const n of a.removed){const r=this.w.get(n);r&&(this.w.delete(n),c.push(r))}if(a.changed){for(const n of a.changed)if(n.id){const r=this.w.get(n.id);if(r){if(r instanceof P.FunctionBreakpoint&&n.type==="function"){const f=r;f.enabled=n.enabled,f.condition=n.condition,f.hitCondition=n.hitCondition,f.logMessage=n.logMessage,f.functionName=n.functionName}else if(r instanceof P.SourceBreakpoint&&n.type==="source"){const f=r;f.enabled=n.enabled,f.condition=n.condition,f.hitCondition=n.hitCondition,f.logMessage=n.logMessage,f.location=new P.Location(R.URI.revive(n.uri),new P.Position(n.line,n.character))}l.push(r)}}}this.U(u,c,l)}$provideDebugConfigurations(a,u,c){return(0,o.asPromise)(async()=>{const l=this.O(a);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const n=await this.W(u);return l.provideDebugConfigurations(n,c)}).then(l=>{if(!l)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return l})}$resolveDebugConfiguration(a,u,c,l){return(0,o.asPromise)(async()=>{const n=this.O(a);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const r=await this.W(u);return n.resolveDebugConfiguration(r,c,l)})}$resolveDebugConfigurationWithSubstitutedVariables(a,u,c,l){return(0,o.asPromise)(async()=>{const n=this.O(a);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const r=await this.W(u);return n.resolveDebugConfigurationWithSubstitutedVariables(r,c,l)})}async $provideDebugAdapter(a,u){const c=this.N(a);if(!c)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const l=await this.V(u);return this.R(c,l).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${l.type}'`);return this.L(n)})}async $acceptDebugSessionStarted(a){const u=await this.V(a);this.m.fire(u)}async $acceptDebugSessionTerminated(a){const u=await this.V(a);u&&(this.n.fire(u),this.l.delete(u.id))}async $acceptDebugSessionActiveChanged(a){this.q=a?await this.V(a):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(a,u){(await this.V(a))?._acceptNameChanged(u)}async $acceptDebugSessionCustomEvent(a,u){const l={session:await this.V(a),event:u.event,body:u.body};this.u.fire(l)}L(a){if(a instanceof P.DebugAdapterExecutable)return{type:"executable",command:a.command,args:a.args,options:a.options};if(a instanceof P.DebugAdapterServer)return{type:"server",port:a.port,host:a.host};if(a instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:a.path};if(a instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:a.implementation};throw new Error("convertToDto unexpected type")}M(a){const u=this.h.filter(c=>c.type===a);if(u.length>0)return u[0].factory}N(a){const u=this.h.filter(c=>c.handle===a);if(u.length>0)return u[0].factory}O(a){const u=this.f.filter(c=>c.handle===a);if(u.length>0)return u[0].provider}P(a,u){if(a.contributes){const c=a.contributes.debuggers;if(c&&c.length>0){for(const l of c)if(l.label&&l.type&&l.type===u)return!0}}return!1}Q(a){const c=a.configuration.type,l=this.j.filter(n=>n.type===c||n.type==="*").map(n=>(0,o.asPromise)(()=>n.factory.createDebugAdapterTracker(a)).then(r=>r,r=>null));return Promise.race([Promise.all(l).then(n=>{const r=n.filter(f=>!!f);if(r.length>0)return new p(r)}),new Promise(n=>setTimeout(()=>n(void 0),1e3))]).catch(n=>{})}async R(a,u){const c=u.configuration.debugServer;if(typeof c=="number")return Promise.resolve(new P.DebugAdapterServer(c));if(a){const n=await this.E.getExtensionRegistry();return(0,o.asPromise)(()=>a.createDebugAdapterDescriptor(u,this.S(u,n))).then(r=>{if(r)return r})}const l=await this.E.getExtensionRegistry();return Promise.resolve(this.S(u,l))}S(a,u){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(a,u,c){(a.length>0||u.length>0||c.length>0)&&this.z.fire(Object.freeze({added:a,removed:u,changed:c}))}async V(a){if(a)if(typeof a=="string"){const u=this.l.get(a);if(u)return u}else{let u=this.l.get(a.id);if(!u){const c=await this.W(a.folderUri),l=a.parent?this.l.get(a.parent):void 0;u=new w(this.k,a.id,a.type,a.name,c,a.configuration,l),this.l.set(u.id,u),this.k.$sessionCached(u.id)}return u}throw new Error("cannot find session")}W(a){if(a){const u=R.URI.revive(a);return this.D.resolveWorkspaceFolder(u)}return Promise.resolve(void 0)}};h=qe([He(0,L.IExtHostRpcService),He(1,y.IExtHostWorkspace),He(2,C.IExtHostExtensionService),He(3,d.IExtHostConfiguration),He(4,S.IExtHostEditorTabs),He(5,m.IExtHostVariableResolverProvider)],h),e.ExtHostDebugServiceBase=h;class w{constructor(a,u,c,l,n,r,f){this.d=a,this.f=u,this.g=c,this.h=l,this.i=n,this.j=r,this.k=f}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(a){this.h=a,this.d.$setDebugSessionName(this.f,a)}get parentSession(){return this.k}_acceptNameChanged(a){this.h=a}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(a,u){return this.d.$customDebugAdapterRequest(this.f,a,u)}getDebugProtocolBreakpoint(a){return this.d.$getDebugProtocolBreakpoint(this.f,a.id)}}e.ExtHostDebugSession=w;class g{constructor(a){this.value=Object.freeze({append(u){a.$appendDebugConsole(u)},appendLine(u){this.append(u+`
`)}})}}e.ExtHostDebugConsole=g;class p{constructor(a){this.d=a}onWillStartSession(){this.d.forEach(a=>a.onWillStartSession?a.onWillStartSession():void 0)}onWillReceiveMessage(a){this.d.forEach(u=>u.onWillReceiveMessage?u.onWillReceiveMessage(a):void 0)}onDidSendMessage(a){this.d.forEach(u=>u.onDidSendMessage?u.onDidSendMessage(a):void 0)}onWillStopSession(){this.d.forEach(a=>a.onWillStopSession?a.onWillStopSession():void 0)}onError(a){this.d.forEach(u=>u.onError?u.onError(a):void 0)}onExit(a,u){this.d.forEach(c=>c.onExit?c.onExit(a,u):void 0)}}class b extends D.AbstractDebugAdapter{constructor(a){super(),this.h=a,a.onDidSendMessage(u=>{this.acceptMessage(u)})}startSession(){return Promise.resolve(void 0)}sendMessage(a){this.h.handleMessage(a)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let i=class extends h{constructor(a,u,c,l,n,r){super(a,u,c,l,n,r)}};i=qe([He(0,L.IExtHostRpcService),He(1,y.IExtHostWorkspace),He(2,C.IExtHostExtensionService),He(3,d.IExtHostConfiguration),He(4,S.IExtHostEditorTabs),He(5,m.IExtHostVariableResolverProvider)],i),e.WorkerExtHostDebugService=i}),define(ye[289],Ce([1,0,10,77,2,5,281,13,88,89,25,197,17,55,41,95]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y,D,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class m{static async installEarlyHandler(g){const p=g.get(A.ILogService),i=g.get(y.IExtHostRpcService).getProxy(R.MainContext.MainThreadErrors);o.setUnexpectedErrorHandler(s=>{p.error(s);const a=o.transformErrorForSerialization(s);i.$onUnexpectedError(a)})}static async installFullHandler(g){const p=g.get(A.ILogService),b=g.get(y.IExtHostRpcService),i=g.get(v.IExtHostExtensionService),s=g.get(d.IExtHostTelemetry),a=b.getProxy(R.MainContext.MainThreadExtensionService),u=b.getProxy(R.MainContext.MainThreadErrors),c=await i.getExtensionPathIndex(),l=new WeakMap;Error.prepareStackTrace=(n,r)=>{let f="",E,T;for(const M of r)f+=`
	at ${M.toString()}`,T=M.getFileName(),!E&&T&&(E=c.findSubstr(k.URI.file(T)));return l.set(n,E?.identifier),`${n.name||"Error"}: ${n.message||""}${f}`},o.setUnexpectedErrorHandler(n=>{p.error(n);const r=o.transformErrorForSerialization(n),f=l.get(n);if(!f){u.$onUnexpectedError(r);return}a.$onExtensionRuntimeError(f,r);const E=s.onExtensionError(f,n);p.trace("forwarded error to extension?",E,f)})}}Error.stackTraceLimit=100;class h{constructor(g,p,b,i,s){this.a=b,this.b=new I.RPCProtocol(g,null,i),p=h.e(p,this.b);const a=new C.ServiceCollection(...(0,S.getSingletonServiceDescriptors)());a.set(L.IExtHostInitDataService,{_serviceBrand:void 0,...p,messagePorts:s}),a.set(y.IExtHostRpcService,new y.ExtHostRpcService(this.b)),a.set(D.IURITransformerService,new D.URITransformerService(i)),a.set(v.IHostUtils,b);const u=new P.InstantiationService(a,!0);u.invokeFunction(m.installEarlyHandler),this.d=u.invokeFunction(c=>c.get(A.ILogService)),t.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",p),this.c=u.invokeFunction(c=>c.get(v.IExtHostExtensionService)),this.c.initialize(),u.invokeFunction(m.installFullHandler)}async asBrowserUri(g){const p=this.b.getProxy(R.MainContext.MainThreadExtensionService);return k.URI.revive(await p.$asBrowserUri(g))}terminate(g){this.c.terminate(g)}static e(g,p){g.allExtensions.forEach(i=>{i.extensionLocation=k.URI.revive(p.transformIncomingURIs(i.extensionLocation));const s={};i.browserNlsBundleUris&&(Object.keys(i.browserNlsBundleUris).forEach(a=>s[a]=k.URI.revive(p.transformIncomingURIs(i.browserNlsBundleUris[a]))),i.browserNlsBundleUris=s)}),g.environment.appRoot=k.URI.revive(p.transformIncomingURIs(g.environment.appRoot));const b=g.environment.extensionDevelopmentLocationURI;return b&&(g.environment.extensionDevelopmentLocationURI=b.map(i=>k.URI.revive(p.transformIncomingURIs(i)))),g.environment.extensionTestsLocationURI=k.URI.revive(p.transformIncomingURIs(g.environment.extensionTestsLocationURI)),g.environment.globalStorageHome=k.URI.revive(p.transformIncomingURIs(g.environment.globalStorageHome)),g.environment.workspaceStorageHome=k.URI.revive(p.transformIncomingURIs(g.environment.workspaceStorageHome)),g.environment.extensionTelemetryLogResource=k.URI.revive(p.transformIncomingURIs(g.environment.extensionTelemetryLogResource)),g.nlsBaseUrl=k.URI.revive(p.transformIncomingURIs(g.nlsBaseUrl)),g.logsLocation=k.URI.revive(p.transformIncomingURIs(g.logsLocation)),g.logFile=k.URI.revive(p.transformIncomingURIs(g.logFile)),g.workspace=p.transformIncomingURIs(g.workspace),g}}e.ExtensionHostMain=h}),define(ye[290],Ce([1,0,16,12,180,196,203,78,59,41,17,40,7,48,33,218,220,34]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y,D,v,d,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let w=class extends A.ExtHostDebugServiceBase{constructor(s,a,u,c,l,n,r){super(s,a,u,c,n,r),this.Z=l,this.X=new b}J(s,a){switch(s.type){case"server":return new d.SocketDebugAdapter(s);case"pipeServer":return new d.NamedPipeDebugAdapter(s);case"executable":return new d.ExecutableDebugAdapter(s,a.type)}return super.J(s,a)}S(s,a){const u=d.ExecutableDebugAdapter.platformAdapterExecutable(a.getAllExtensionDescriptions(),s.type);if(u)return new y.DebugAdapterExecutable(u.command,u.args,u.options)}K(){return new I.SignService}async $runInTerminal(s,a){if(s.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(N=>{this.X.onTerminalClosed(N)}));const u=await this.F.getConfigProvider(),c=this.Z.getDefaultShell(!0),l=this.Z.getDefaultShellArgs(!0),n=s.title||k.localize(0,null),r=JSON.stringify({shell:c,shellArgs:l});let f=await this.X.checkout(r,n),E,T=!1;if(f)E=s.cwd;else{const N={shellPath:c,shellArgs:l,cwd:s.cwd,name:n,iconPath:new y.ThemeIcon("debug")};T=!0,f=this.Z.createTerminalFromOptions(N,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(f,r)}f.show(!0);const M=await f.processId;T?await new Promise(N=>setTimeout(N,1e3)):u.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0||c.indexOf("cmd.exe")>=0?f.sendText("cls"):c.indexOf("bash")>=0?f.sendText("clear"):t.isWindows?f.sendText("cls"):f.sendText("clear"));const G=(0,m.prepareCommand)(c,s.args,!!s.argsCanBeInterpretedByShell,E,s.env);f.sendText(G);const V=this.onDidTerminateDebugSession(N=>{N.id===a&&(this.X.free(f),V.dispose())});return M}else if(s.kind==="external")return p(s,await this.F.getConfigProvider());return super.$runInTerminal(s,a)}};w=qe([He(0,L.IExtHostRpcService),He(1,v.IExtHostWorkspace),He(2,C.IExtHostExtensionService),He(3,h.IExtHostConfiguration),He(4,P.IExtHostTerminalService),He(5,S.IExtHostEditorTabs),He(6,D.IExtHostVariableResolverProvider)],w),e.ExtHostDebugService=w;let g;function p(i,s){if(!g)if(t.isWindows)g=new R.WindowsExternalTerminalService;else if(t.isMacintosh)g=new R.MacExternalTerminalService;else if(t.isLinux)g=new R.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const a=s.getConfiguration("terminal");return g.runInTerminal(i.title,i.cwd,i.args,i.env||{},a.external||{})}class b{constructor(){this.b=new Map}async checkout(s,a){const c=[...this.b.entries()].map(([l,n])=>(0,o.createCancelablePromise)(async r=>{if(l.name!==a||n.lastUsedAt!==-1&&await(0,m.hasChildProcesses)(await l.processId))return null;const f=Date.now();return n.lastUsedAt+b.a>f||r.isCancellationRequested||n.config!==s?null:(n.lastUsedAt=f,l)}));return await(0,o.firstParallel)(c,l=>!!l)}insert(s,a){this.b.set(s,{lastUsedAt:Date.now(),config:a})}free(s){const a=this.b.get(s);a&&(a.lastUsedAt=-1)}onTerminalClosed(s){this.b.delete(s)}}b.a=1e3}),define(ye[291],Ce([1,0,9,2,115,33,58,34,46,40,17,25,76,15,13,71,24,87,48]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y,D,v,d,m,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let g=class extends y.ExtHostTaskBase{constructor(b,i,s,a,u,c,l,n,r){super(b,i,s,a,u,c,l,n),this.B=s,this.C=r,i.remote.isRemote&&i.remote.authority?this.registerTaskSystem(D.Schemas.vscodeRemote,{scheme:D.Schemas.vscodeRemote,authority:i.remote.authority,platform:process.platform}):this.registerTaskSystem(D.Schemas.file,{scheme:D.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(b,i){const s=i;if(!i.execution&&s._id===void 0)throw new Error("Tasks to execute must include an execution");if(s._id!==void 0){const a=y.TaskHandleDTO.from(s,this.B),u=await this.a.$getTaskExecution(a);if(u.task===void 0)throw new Error("Task from execution DTO is undefined");const c=await this.y(u,i);return this.a.$executeTask(a).catch(()=>{}),c}else{const a=y.TaskDTO.from(i,b);if(a===void 0)return Promise.reject(new Error("Task is not valid"));y.CustomExecutionDTO.is(a.execution)&&await this.x(a,i,!1);const u=await this.y(await this.a.$getTaskExecution(a),i);return this.a.$executeTask(a).catch(()=>{}),u}}u(b,i,s,a){const u=[];if(a)for(const c of a){this.z(c,s),(!c.definition||!b[c.definition.type])&&this.f.warn(`The task [${c.source}, ${c.name}] uses an undefined task type. The task will be ignored in the future.`);const l=y.TaskDTO.from(c,s.extension);l&&(u.push(l),y.CustomExecutionDTO.is(l.execution)&&i.push(this.x(l,c,!0)))}return{tasks:u,extension:s.extension}}async v(b){return b}async F(b){let i=b&&b.length>0?b[0]:void 0;if(!i){const s=t.URI.file((0,h.homedir)());i=new S.WorkspaceFolder({uri:s,name:m.basename(s),index:0})}return{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(b,i){const s=t.URI.revive(b),a={process:void 0,variables:Object.create(null)},u=await this.b.resolveWorkspaceFolder(s),c=await this.b.getWorkspaceFolders2()??[],l=await this.C.getResolver(),n=u?{uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(c);for(const r of i.variables)a.variables[r]=await l.resolveAsync(n,r);if(i.process!==void 0){let r;if(i.process.path!==void 0){r=i.process.path.split(o.delimiter);for(let f=0;f<r.length;f++)r[f]=await l.resolveAsync(n,r[f])}a.process=await k.win32.findExecutable(await l.resolveAsync(n,i.process.name),i.process.cwd!==void 0?await l.resolveAsync(n,i.process.cwd):void 0,r)}return a}async $jsonTasksSupported(){return!0}async $findExecutable(b,i,s){return k.win32.findExecutable(b,i,s)}};g=qe([He(0,L.IExtHostRpcService),He(1,P.IExtHostInitDataService),He(2,R.IExtHostWorkspace),He(3,I.IExtHostDocumentsAndEditors),He(4,A.IExtHostConfiguration),He(5,C.IExtHostTerminalService),He(6,v.ILogService),He(7,d.IExtHostApiDeprecationService),He(8,w.IExtHostVariableResolverProvider)],g),e.ExtHostTask=g}),define(ye[292],Ce([1,0,87,48]),function(ne,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class k extends t.ExtHostVariableResolverProviderService{j(){return(0,o.homedir)()}}e.NodeExtHostVariableResolverProviderService=k}),define(ye[143],Ce([1,0,18,16,21,51,15,9,24,2,31]),function(ne,e,o,t,k,R,I,A,S,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class P{constructor(w,g,p,b){this.d=w,this.e=g,this.f=p,this.g=b,this.a=null,this.b=!1,this.c=0}search(w,g){const p=this.d.folderQueries||[],b=new k.CancellationTokenSource;return g.onCancellationRequested(()=>b.cancel()),new Promise((i,s)=>{this.a=new D(w);let a=!1;const u=(c,l)=>{if(!a&&!this.b){const n=this.h(c);d(c)&&typeof this.d.maxResults=="number"&&this.c+n>this.d.maxResults&&(this.b=!0,a=!0,b.cancel(),c=this.j(c,this.d.maxResults-this.c));const r=this.h(c);this.c+=r,(r>0||!d(c))&&this.a.add(c,l)}};Promise.all(p.map((c,l)=>this.k(c,n=>u(n,l),b.token))).then(c=>{b.dispose(),this.a.flush();const l=c.some(n=>!!n&&!!n.limitHit);i({limitHit:this.b||l,messages:(0,o.flatten)(c.map(n=>n?.message?Array.isArray(n.message)?n.message:[n.message]:[])),stats:{type:this.g}})},c=>{b.dispose();const l=(0,R.toErrorMessage)(c);s(new Error(l))})})}h(w){return d(w)?Array.isArray(w.ranges)?w.ranges.length:1:0}j(w,g){const p=Array.isArray(w.ranges)?w.ranges:[w.ranges],b=Array.isArray(w.preview.matches)?w.preview.matches:[w.preview.matches];return{ranges:p.slice(0,g),preview:{matches:b.slice(0,g),text:w.preview.text},uri:w.uri}}async k(w,g,p){const b=new L.QueryGlobTester(this.d,w),i=[],s={report:c=>{if(!this.l(c))return;const l=w.folder.scheme===I.Schemas.file?(0,L.hasSiblingPromiseFn)(()=>this.f.readdir(S.dirname(c.uri))):void 0,n=S.relativePath(w.folder,c.uri);if(n){const r=b.includedInQuery(n,A.basename(n),l);(0,t.isThenable)(r)?i.push(r.then(f=>{f&&g(c)})):r&&g(c)}}},a=this.n(w),u=await this.e.provideTextSearchResults(y(this.d.contentPattern),a,s,p);return i.length&&await Promise.all(i),u}l(w){if(d(w)){if(Array.isArray(w.ranges)){if(!Array.isArray(w.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(w.preview.matches.length!==w.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(w.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(w){const g=(0,L.resolvePatternsForProvider)(this.d.includePattern,w.includePattern),p=(0,L.resolvePatternsForProvider)(this.d.excludePattern,w.excludePattern),b={folder:C.URI.from(w.folder),excludes:p,includes:g,useIgnoreFiles:!w.disregardIgnoreFiles,useGlobalIgnoreFiles:!w.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!w.disregardParentIgnoreFiles,followSymlinks:!w.ignoreSymlinks,encoding:w.fileEncoding&&this.f.toCanonicalName(w.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return b.usePCRE2=this.d.usePCRE2,b}}e.TextSearchManager=P;function y(h){return{isCaseSensitive:h.isCaseSensitive||!1,isRegExp:h.isRegExp||!1,isWordMatch:h.isWordMatch||!1,isMultiline:h.isMultiline||!1,pattern:h.pattern}}class D{constructor(w){this.e=w,this.b=-1,this.d=null,this.a=new m(512,g=>this.g(g))}add(w,g){this.d&&(this.b!==g||!S.isEqual(this.c,w.uri))&&(this.f(),this.d=null),this.d||(this.b=g,this.d={resource:w.uri,results:[]}),this.d.results.push(v(w))}f(){const w=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,w)}flush(){this.f(),this.a.flush()}g(w){this.e(w)}}e.TextSearchResultsCollector=D;function v(h){return d(h)?{preview:{matches:(0,o.mapArrayOrNot)(h.preview.matches,w=>({startLineNumber:w.start.line,startColumn:w.start.character,endLineNumber:w.end.line,endColumn:w.end.character})),text:h.preview.text},ranges:(0,o.mapArrayOrNot)(h.ranges,w=>({startLineNumber:w.start.line,startColumn:w.start.character,endLineNumber:w.end.line,endColumn:w.end.character}))}:{text:h.text,lineNumber:h.lineNumber}}function d(h){return!!h.preview}e.extensionResultIsMatch=d;class m{constructor(w,g){this.g=w,this.h=g,this.c=0,this.d=[],this.e=0}addItem(w,g){!w||this.j(w,g)}addItems(w,g){!w||this.k(w,g)}j(w,g){this.d.push(w),this.e+=g,this.l()}k(w,g){this.d=this.d.concat(w),this.e+=g,this.l()}l(){this.c<m.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},m.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.BatchedCollector=m,m.a=4e3,m.b=50}),define(ye[79],Ce([1,0,6,5,3,285,17,55,13,2,143]),function(ne,e,o,t,k,R,I,A,S,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,k.createDecorator)("IExtHostSearch");let P=class{constructor(d,m,h){this.k=d,this.l=m,this.n=h,this.c=this.k.getProxy(t.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new R.FileSearchManager}o(d){return this.l.transformOutgoingScheme(d)}registerTextSearchProvider(d,m){if(this.g.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this.g.add(d);const h=this.d++;return this.e.set(h,m),this.c.$registerTextSearchProvider(h,this.o(d)),(0,o.toDisposable)(()=>{this.g.delete(d),this.e.delete(h),this.c.$unregisterProvider(h)})}registerFileSearchProvider(d,m){if(this.i.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this.i.add(d);const h=this.d++;return this.h.set(h,m),this.c.$registerFileSearchProvider(h,this.o(d)),(0,o.toDisposable)(()=>{this.i.delete(d),this.h.delete(h),this.c.$unregisterProvider(h)})}$provideFileSearchResults(d,m,h,w){const g=y(h),p=this.h.get(d);if(p)return this.j.fileSearch(g,p,b=>{this.c.$handleFileMatch(d,m,b.map(i=>i.resource))},w);throw new Error("unknown provider: "+d)}$clearCache(d){return this.j.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,m,h,w){const g=this.e.get(d);if(!g||!g.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const p=y(h);return this.q(p,g).search(i=>this.c.$handleTextMatch(d,m,i),w)}$enableExtensionHostSearch(){}q(d,m){return new L.TextSearchManager(d,m,{readdir:h=>Promise.resolve([]),toCanonicalName:h=>h},"textSearchProvider")}};P=qe([He(0,I.IExtHostRpcService),He(1,A.IURITransformerService),He(2,S.ILogService)],P),e.ExtHostSearch=P;function y(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(D),extraFileResources:v.extraFileResources&&v.extraFileResources.map(d=>C.URI.revive(d))}}e.reviveQuery=y;function D(v){return{...v,folder:C.URI.revive(v.folder)}}}),define(ye[293],Ce([1,0,88,142,33,139,34,39,58,40,76,78,79,98,54,71,141,72,47,97,95,59,140,13,230,48,96]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y,D,v,d,m,h,w,g,p,b,i,s,a,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,o.registerSingleton)(c.IExtHostLocalizationService,c.ExtHostLocalizationService,1),(0,o.registerSingleton)(s.ILoggerService,i.ExtHostLoggerService,1),(0,o.registerSingleton)(s.ILogService,a.ExtHostLogService,1),(0,o.registerSingleton)(d.IExtHostApiDeprecationService,d.ExtHostApiDeprecationService,1),(0,o.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands,0),(0,o.registerSingleton)(I.IExtHostConfiguration,I.ExtHostConfiguration,0),(0,o.registerSingleton)(h.IExtHostConsumerFileSystem,h.ExtHostConsumerFileSystem,0),(0,o.registerSingleton)(P.IExtHostDebugService,P.WorkerExtHostDebugService,0),(0,o.registerSingleton)(R.IExtHostDecorations,R.ExtHostDecorations,0),(0,o.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors,0),(0,o.registerSingleton)(w.IExtHostFileSystemInfo,w.ExtHostFileSystemInfo,0),(0,o.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService,1),(0,o.registerSingleton)(y.IExtHostSearch,y.ExtHostSearch,0),(0,o.registerSingleton)(D.IExtHostStorage,D.ExtHostStorage,0),(0,o.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask,0),(0,o.registerSingleton)(C.IExtHostTerminalService,C.WorkerExtHostTerminalService,0),(0,o.registerSingleton)(v.IExtHostTunnelService,v.ExtHostTunnelService,0),(0,o.registerSingleton)(m.IExtHostWindow,m.ExtHostWindow,0),(0,o.registerSingleton)(k.IExtHostWorkspace,k.ExtHostWorkspace,0),(0,o.registerSingleton)(g.IExtHostSecretState,g.ExtHostSecretState,0),(0,o.registerSingleton)(p.IExtHostTelemetry,p.ExtHostTelemetry,0),(0,o.registerSingleton)(b.IExtHostEditorTabs,b.ExtHostEditorTabs,0),(0,o.registerSingleton)(u.IExtHostVariableResolverProvider,u.ExtHostVariableResolverProviderService,0)}),define(ye[99],Ce([1,0,18,13,31,75]),function(ne,e,o,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function I(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.anchorGlob=I;function A(P,y,D,v){const d=(0,o.mapArrayOrNot)(D,S),m=new k.TextSearchMatch(y,d,v),h=m.preview.matches;return{ranges:(0,o.mapArrayOrNot)(d,C),uri:P,preview:{text:m.preview.text,matches:(0,o.mapArrayOrNot)(h,C)}}}e.createTextSearchResult=A;function S(P){return new k.SearchRange(P.start.line,P.start.character,P.end.line,P.end.character)}function C(P){return new R.Range(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let L=class{constructor(y,D){this.a=y,this.b=D}appendLine(y){this.b.debug(`${this.a}#search`,y)}};L=qe([He(1,t.ILogService)],L),e.OutputChannel=L}),define(ye[294],Ce([1,0,45,9,83,32,12,8,99,295]),function(ne,e,o,t,k,R,I,A,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const L=C.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(g,p,b,i){const s=y(g,p,b,i),a=p.folder.fsPath;return{cmd:o.spawn(L,s.args,{cwd:a}),rgDiskPath:L,siblingClauses:s.siblingClauses,rgArgs:s,cwd:a}}e.spawnRipgrepCmd=P;function y(g,p,b,i){const s=["--files","--hidden","--case-sensitive"];v([p],b,!1).forEach(u=>{const c=(0,S.anchorGlob)(u);if(s.push("-g",c),I.isMacintosh){const l=(0,k.normalizeNFD)(c);l!==c&&s.push("-g",l)}});const a=D([p],i,void 0,!1);return a.globArgs.forEach(u=>{const c=`!${(0,S.anchorGlob)(u)}`;if(s.push("-g",c),I.isMacintosh){const l=(0,k.normalizeNFD)(c);l!==c&&s.push("-g",l)}}),p.disregardIgnoreFiles!==!1?s.push("--no-ignore"):p.disregardParentIgnoreFiles!==!1&&s.push("--no-ignore-parent"),p.ignoreSymlinks||s.push("--follow"),g.exists&&s.push("--quiet"),s.push("--no-config"),p.disregardGlobalIgnoreFiles&&s.push("--no-ignore-global"),{args:s,siblingClauses:a.siblingClauses}}function D(g,p,b,i=!0){const s=[];let a={};return g.forEach(u=>{const c=Object.assign({},u.excludePattern||{},p||{}),l=d(c,i?u.folder.fsPath:void 0,b);s.push(...l.globArgs),l.siblingClauses&&(a=Object.assign(a,l.siblingClauses))}),{globArgs:s,siblingClauses:a}}function v(g,p,b=!0){const i=[];return g.forEach(s=>{const a=Object.assign({},p||{},s.includePattern||{}),u=d(a,b?s.folder.fsPath:void 0);i.push(...u.globArgs)}),i}function d(g,p,b){const i=[],s={};return Object.keys(g).forEach(a=>{if(b&&b.has(a)||!a)return;const u=g[a];a=h(p?m(p,a):a),a.startsWith("\\\\")?a="\\\\"+a.substr(2).replace(/\\/g,"/"):a=a.replace(/\\/g,"/"),typeof u=="boolean"&&u?(a.startsWith("\\\\")&&(a+="**"),i.push(w(a))):u&&u.when&&(s[a]=u)}),{globArgs:i,siblingClauses:s}}function m(g,p){return t.isAbsolute(p)?p:t.join(g,p)}e.getAbsoluteGlob=m;function h(g){return g=A.rtrim(g,"\\"),A.rtrim(g,"/")}function w(g){return R.getRoot(g).toLowerCase()==="c:/"?g.replace(/^c:[/\\]/i,"/"):g}e.fixDriveC=w}),define(ye[296],Ce([1,0,45,65,9,297,18,51,37,83,32,12,42,8,11,29,31,294,110]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y,D,v,d,m,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const g=new Set;process.on("exit",()=>{g.forEach(a=>a())});class p{constructor(u){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=u,this.b=u.filePattern||"",this.d=u.includePattern&&S.parse(u.includePattern),this.f=u.maxResults||null,this.g=!!u.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,w.prepareQuery)(this.b).normalizedLowercase),this.u=u.excludePattern&&S.parse(u.excludePattern),this.t=new Map,u.folderQueries.forEach(c=>{const l=Object.assign({},c.excludePattern||{},this.a.excludePattern||{}),n=c.folder.fsPath;u.folderQueries.map(r=>r.folder.fsPath).filter(r=>r!==n).forEach(r=>{(0,L.isEqualOrParent)(r,n)&&(l[k.relative(n,r)]=!0)}),this.t.set(n,new i(l,n))})}cancel(){this.l=!0,g.forEach(u=>u())}walk(u,c,l,n,r){if(this.m=y.StopWatch.create(!1),this.l)return r(null,this.j);c.forEach(f=>{const E=k.basename(f.fsPath);this.u&&this.u(f.fsPath,E)||this.J(l,{relativePath:f.fsPath,searchPath:void 0})}),this.r=y.StopWatch.create(!1),this.w(u,(f,E)=>{this.x(this.y,this,f,l,n,T=>{if(T){const M=(0,A.toErrorMessage)(T);console.error(M),this.q.push(M),E(T,void 0)}else E(null,void 0)})},(f,E)=>{this.m.stop();const T=f?I.coalesce(f)[0]:null;r(T,this.j)})}w(u,c,l){const n=new Array(u.length),r=new Array(u.length);let f=!1,E=0;if(u.length===0)return l(null,[]);u.forEach((T,M)=>{c(T,(G,V)=>{if(G?(f=!0,n[M]=null,r[M]=G):(n[M]=V,r[M]=null),++E===u.length)return l(f?r:null,n)})})}x(u,c,...l){try{u.apply(c,l)}catch(n){l[l.length-1](n)}}y(u,c,l,n){const r=u.folder.fsPath,f=P.isMacintosh,E=()=>N&&N.kill();g.add(E);let T=B=>{g.delete(E),T=()=>{},n(B)},M="";const G=this.D(),V=(0,h.spawnRipgrepCmd)(this.a,u,this.a.includePattern,this.t.get(u.folder.fsPath).expression),N=V.cmd,U=!Object.keys(V.siblingClauses).length,F=V.rgArgs.args.map(B=>B.match(/^-/)?B:`'${B}'`).join(" ");let z=`${V.rgDiskPath} ${F}
 - cwd: ${V.cwd}`;V.rgArgs.siblingClauses&&(z+=`
 - Sibling clauses: ${JSON.stringify(V.rgArgs.siblingClauses)}`),l({message:z}),this.s=0,this.z(N,"utf8",l,(B,W,X)=>{if(B){T(B);return}if(this.j){T();return}const _=(M+(f?C.normalizeNFC(W||""):W)).split(`
`);if(X){const Q=_.length;_[Q-1]=_[Q-1].trim(),_[Q-1]||_.pop()}else M=_.pop()||"";if(_.length&&_[0].indexOf(`
`)!==-1){T(new Error("Splitting up files failed"));return}if(this.s+=_.length,U){for(const Q of _)if(this.J(c,{base:r,relativePath:Q,searchPath:this.N(u,Q)}),this.j){E();break}(X||this.j)&&T();return}this.G(u,G,r,_,c),X&&(this.H(G,r,c),T())})}spawnFindCmd(u){const c=this.t.get(u.folder.fsPath),l=c.getBasenameTerms(),n=c.getPathTerms(),r=["-L","."];if(l.length||n.length){r.push("-not","(","(");for(const f of l)r.push("-name",f),r.push("-o");for(const f of n)r.push("-path",f),r.push("-o");r.pop(),r.push(")","-prune",")")}return r.push("-type","f"),o.spawn("find",r,{cwd:u.folder.fsPath})}readStdout(u,c,l){let n="";this.z(u,c,()=>{},(r,f,E)=>{if(r){l(r);return}n+=f,E&&l(null,n)})}z(u,c,l,n){let r=(T,M,G)=>{(T||G)&&(r=()=>{},this.r?.stop()),n(T,M,G)},f=!1;u.stdout?(this.A(u.stdout,c,r),u.stdout.once("data",()=>f=!0)):l({message:"stdout is null"});let E;u.stderr?E=this.B(u.stderr):l({message:"stderr is null"}),u.on("error",T=>{r(T)}),u.on("close",T=>{let M;!f&&(M=this.C(E,c))&&s(M)?r(new Error(`command failed with error code ${T}: ${this.C(E,c)}`)):(this.g&&T===0&&(this.j=!0),r(null,"",!0))})}A(u,c,l){const n=new R.StringDecoder(c);return u.on("data",r=>{l(null,n.write(r))}),n}B(u){const c=[];return u.on("data",l=>{c.push(l)}),c}C(u,c){const l=new R.StringDecoder(c);return u.map(n=>l.write(n)).join("")}D(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}G(u,{pathToEntries:c},l,n,r){n.indexOf(this.b)!==-1&&this.J(r,{base:l,relativePath:this.b,searchPath:this.N(u,this.b)});const f=E=>{const T=k.basename(E),M=k.dirname(E);let G=c[M];G||(G=c[M]=[],f(M)),G.push({base:l,relativePath:E,basename:T,searchPath:this.N(u,E)})};n.forEach(f)}H({rootEntries:u,pathToEntries:c},l,n){const r=this,f=this.t.get(l),E=this.b;function T(M){r.o++;const G=(0,m.hasSiblingFn)(()=>M.map(V=>V.basename));for(let V=0,N=M.length;V<N;V++){const U=M[V],{relativePath:F,basename:z}=U;if(f.test(F,z,E!==z?G:void 0))continue;const B=c[F];if(B)T(B);else{if(r.p++,F===E)continue;r.J(n,U)}if(r.j)break}}T(u)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(u,c,l,n,r){const f=u.folder,E=(0,m.hasSiblingFn)(()=>l);this.w(l,(T,M)=>{if(this.l||this.j)return M(null);const G=c?[c,T].join(k.sep):T;if(this.t.get(u.folder.fsPath).test(G,T,this.a.filePattern!==T?E:void 0))return M(null);const V=[f.fsPath,G].join(k.sep);t.lstat(V,(N,U)=>{if(N||this.l||this.j)return M(null);this.L(V,U,(F,z)=>F||this.l||this.j?M(null):z.isDirectory()?(this.o++,this.M(V,U,(B,W)=>B||this.l||this.j||(W=W||"",this.v[W])?M(null):(this.v[W]=!0,d.Promises.readdir(V).then(X=>{if(this.l||this.j)return M(null);this.I(u,G,X,n,q=>M(q||null))},X=>{M(null)})))):(this.p++,G===this.b||this.h&&v.isNumber(z.size)&&z.size>this.h||this.J(n,{base:f.fsPath,relativePath:G,searchPath:this.N(u,G)}),M(null,void 0)))})},T=>{const M=T&&I.coalesce(T);return r(M&&M.length>0?M[0]:void 0)})}J(u,c){this.K(c)&&(!this.d||this.d(c.relativePath,k.basename(c.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||u(c))}K(u){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,m.isFilePatternMatch)(u,this.c)}return!0}L(u,c,l){return c.isSymbolicLink()?t.stat(u,l):l(null,c)}M(u,c,l){return c.isSymbolicLink()?t.realpath(u,(n,r)=>n?l(n):l(null,r)):l(null,u)}N(u,c){return u.folderName?k.join(u.folderName,c):c}}e.FileWalker=p;class b{constructor(u){this.a=u.folderQueries,this.b=u.extraFileResources||[],this.c=new p(u)}search(u,c,l){this.c.walk(this.a,this.b,u,c,(n,r)=>{l(n,{limitHit:r,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.Engine=b;class i{constructor(u,c){this.expression=u,this.c=c,this.d(u)}d(u){let c,l;Object.keys(u).filter(n=>u[n]).forEach(n=>{k.isAbsolute(n)?(c=c||S.getEmptyExpression(),c[n]=u[n]):(l=l||S.getEmptyExpression(),l[n]=u[n])}),this.a=c&&S.parse(c,{trimForExclusions:!0}),this.b=l&&S.parse(l,{trimForExclusions:!0})}test(u,c,l){return this.b&&this.b(u,c,l)||this.a&&this.a(k.join(this.c,u),c,l)}getBasenameTerms(){const u=[];return this.a&&u.push(...S.getBasenameTerms(this.a)),this.b&&u.push(...S.getBasenameTerms(this.b)),u}getPathTerms(){const u=[];return this.a&&u.push(...S.getPathTerms(this.a)),this.b&&u.push(...S.getPathTerms(this.b)),u}}function s(a){const u=a.trim().split(`
`),c=u[0].trim();if(c.startsWith("Error parsing regex"))return c;if(c.startsWith("regex parse error"))return D.uppercaseFirstLetter(u[u.length-1].trim());if(c.startsWith("error parsing glob")||c.startsWith("unsupported encoding"))return c.charAt(0).toUpperCase()+c.substr(1);if(c==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(c.startsWith("Literal "))return c}}),define(ye[298],Ce([1,0,102,22]),function(ne,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function k(a){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(u=>u===a)}e.isUTFEncoding=k,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const R=512,I=512,A=512*8,S=512*128;var C;(function(a){a[a.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(C=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class L extends Error{constructor(u,c){super(u),this.decodeStreamErrorKind=c}}e.DecodeStreamError=L;class P{static async create(u){let c;if(u!==e.UTF8)c=(await new Promise((n,r)=>{ne(["@vscode/iconv-lite-umd"],n,r)})).getDecoder(d(u));else{const l=new TextDecoder;c={write(n){return l.decode(n,{stream:!0})},end(){return l.decode()}}}return new P(c)}constructor(u){this.a=u}write(u){return this.a.write(u)}end(){return this.a.end()}}function y(a,u){const c=u.minBytesRequiredForDetection??u.guessEncoding?A:I;return new Promise((l,n)=>{const r=(0,o.newWriteableStream)(V=>V.join("")),f=[];let E=0,T,M;const G=async()=>{try{const V=await s({buffer:t.VSBuffer.concat(f),bytesRead:E},u.guessEncoding);if(V.seemsBinary&&u.acceptTextOnly)throw new L("Stream is binary but only text is accepted for decoding",1);V.encoding=await u.overwriteEncoding(V.encoding),T=await P.create(V.encoding);const N=T.write(t.VSBuffer.concat(f).buffer);r.write(N),f.length=0,E=0,l({stream:r,detected:V})}catch(V){M?.dispose(),r.destroy(),n(V)}};M=(0,o.listenStream)(a,{onData:async V=>{T?r.write(T.write(V.buffer)):(f.push(V),E+=V.byteLength,E>=c&&(a.pause(),await G(),setTimeout(()=>a.resume())))},onError:V=>r.error(V),onEnd:async()=>{T||await G(),r.end(T?.end())}})})}e.toDecodeStream=y;async function D(a,u,c){const n=(await new Promise((E,T)=>{ne(["@vscode/iconv-lite-umd"],E,T)})).getEncoder(d(u),c);let r=!1,f=!1;return{read(){if(f)return null;const E=a.read();if(typeof E!="string"){if(f=!0,!r&&c?.addBOM)switch(u){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const T=n.end();return T&&T.length>0?(r=!0,t.VSBuffer.wrap(T)):null}return r=!0,t.VSBuffer.wrap(n.write(E))}}}e.toEncodeReadable=D;async function v(a){return(await new Promise((c,l)=>{ne(["@vscode/iconv-lite-umd"],c,l)})).encodingExists(d(a))}e.encodingExists=v;function d(a){return a===e.UTF8_with_bom||a===null?e.UTF8:a}e.toNodeEncoding=d;function m(a,u){if(!a||u<e.UTF16be_BOM.length)return null;const c=a.readUInt8(0),l=a.readUInt8(1);if(c===e.UTF16be_BOM[0]&&l===e.UTF16be_BOM[1])return e.UTF16be;if(c===e.UTF16le_BOM[0]&&l===e.UTF16le_BOM[1])return e.UTF16le;if(u<e.UTF8_BOM.length)return null;const n=a.readUInt8(2);return c===e.UTF8_BOM[0]&&l===e.UTF8_BOM[1]&&n===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=m;const h=["ascii","utf-16","utf-32"];async function w(a){const u=await new Promise((f,E)=>{ne(["jschardet"],f,E)}),c=a.slice(0,S),l=b(c.buffer),n=u.detect(l);if(!n||!n.encoding)return null;const r=n.encoding.toLowerCase();return 0<=h.indexOf(r)?null:p(n.encoding)}const g={ibm866:"cp866",big5:"cp950"};function p(a){const u=a.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return g[u]||u}function b(a){let u="";for(let c=0;c<a.length;c++)u+=String.fromCharCode(a[c]);return u}function i(a){switch(a){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const u=a.match(/windows(\d+)/);return u?"windows-"+u[1]:a}}}e.toCanonicalName=i;function s({buffer:a,bytesRead:u},c){let l=m(a,u),n=!1;if(l!==e.UTF16be&&l!==e.UTF16le&&a){let r=!0,f=!0,E=!1;for(let T=0;T<u&&T<R;T++){const M=T%2===1,G=a.readUInt8(T)===0;if(G&&(E=!0),r&&(M&&!G||!M&&G)&&(r=!1),f&&(M&&G||!M&&!G)&&(f=!1),G&&!r&&!f)break}E&&(r?l=e.UTF16le:f?l=e.UTF16be:n=!0)}return c&&!n&&!l&&a?w(a.slice(0,u)).then(r=>({seemsBinary:!1,encoding:r})):{seemsBinary:n,encoding:l}}e.detectEncodingFromBuffer=s,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ye[144],Ce([1,0,298,29,143]),function(ne,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class R extends k.TextSearchManager{constructor(A,S,C=t,L="searchProcess"){super(A,S,{readdir:P=>C.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,o.toCanonicalName)(P)},L)}}e.NativeTextSearchManager=R}),define(ye[299],Ce([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class o{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(k){if(k&&this.a.has(k)){const R=this.a.get(k);return this.a.delete(k),R}}addDragOperationTransfer(k,R){this.a.set(k,R)}getRenderedTreeElement(k){if(this.b.has(k))return this.b.get(k)}addRenderedTreeItemElement(k,R){this.b.set(k,R)}removeRenderedTreeItemElement(k){this.b.has(k)&&this.b.delete(k)}}e.TreeviewsService=o}),define(ye[300],Ce([1,0,178,7,24,2,4,6,16,7,11,18,14,21,299,27]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y,D,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function m(g,p){if((0,L.isString)(g))return{label:g};if(g&&typeof g=="object"&&typeof g.label=="string"){let b;return Array.isArray(g.highlights)&&(b=g.highlights.filter(i=>i.length===2&&typeof i[0]=="number"&&typeof i[1]=="number"),b=b.length?b:void 0),{label:g.label,highlights:b}}}class h{constructor(p,b,i){this.d=p,this.e=b,this.f=i,this.a=new Map,this.b=new v.TreeviewsService;function s(a){return a&&a.$treeViewId&&(a.$treeItemHandle||a.$selectedTreeItems||a.$focusedTreeItem)}b.registerArgumentProcessor({processArgument:a=>s(a)?this.i(a):Array.isArray(a)&&a.length>0?a.map(u=>s(u)?this.i(u):u):a})}registerTreeDataProvider(p,b,i){const s=this.createTreeView(p,{treeDataProvider:b},i);return{dispose:()=>s.dispose()}}createTreeView(p,b,i){if(!b||!b.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=b.dragAndDropController?.dropMimeTypes??[],a=b.dragAndDropController?.dragMimeTypes??[],u=!!b.dragAndDropController?.handleDrag,c=!!b.dragAndDropController?.handleDrop,l=this.h(p,b,i),n=this.d.$registerTreeViewDataProvider(p,{showCollapseAll:!!b.showCollapseAll,canSelectMany:!!b.canSelectMany,dropMimeTypes:s,dragMimeTypes:a,hasHandleDrag:u,hasHandleDrop:c});return{get onDidCollapseElement(){return l.onDidCollapseElement},get onDidExpandElement(){return l.onDidExpandElement},get selection(){return l.selectedElements},get onDidChangeSelection(){return l.onDidChangeSelection},get visible(){return l.visible},get onDidChangeVisibility(){return l.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,d.checkProposedApiEnabled)(i,"treeItemCheckbox"),l.onDidChangeCheckboxState},get message(){return l.message},set message(r){l.message=r},get title(){return l.title},set title(r){l.title=r},get description(){return l.description},set description(r){l.description=r},get badge(){return l.badge},set badge(r){r!==void 0&&C.ViewBadge.isViewBadge(r)?l.badge={value:Math.floor(Math.abs(r.value)),tooltip:r.tooltip}:r===void 0&&(l.badge=void 0)},reveal:(r,f)=>l.reveal(r,f),dispose:async()=>{await n,this.a.delete(p),l.dispose()}}}$getChildren(p,b){const i=this.a.get(p);return i?i.getChildren(b):Promise.reject(new Error((0,o.localize)(0,null,p)))}async $handleDrop(p,b,i,s,a,u,c,l){const n=this.a.get(p);if(!n)return Promise.reject(new Error((0,o.localize)(1,null,p)));const r=y.DataTransfer.toDataTransfer(i,async f=>(await this.d.$resolveDropFileData(p,b,f)).buffer);return c===p&&l&&await this.g(r,n,l,a,u),n.onDrop(r,s,a)}async g(p,b,i,s,a){const u=this.b.removeDragOperationTransfer(a);if(u)(await u)?.forEach((c,l)=>{c&&p.set(l,c)});else if(a&&b.handleDrag){const c=b.handleDrag(i,p,s);this.b.addDragOperationTransfer(a,c),await c}return p}async $handleDrag(p,b,i,s){const a=this.a.get(p);if(!a)return Promise.reject(new Error((0,o.localize)(2,null,p)));const u=await this.g(new t.DataTransfer,a,b,s,i);if(!!u)return y.DataTransfer.toDataTransferDTO(u)}async $hasResolve(p){const b=this.a.get(p);if(!b)throw new Error((0,o.localize)(3,null,p));return b.hasResolve}$resolve(p,b,i){const s=this.a.get(p);if(!s)throw new Error((0,o.localize)(4,null,p));return s.resolveTreeItem(b,i)}$setExpanded(p,b,i){const s=this.a.get(p);if(!s)throw new Error((0,o.localize)(5,null,p));s.setExpanded(b,i)}$setSelection(p,b){const i=this.a.get(p);if(!i)throw new Error((0,o.localize)(6,null,p));i.setSelection(b)}$setFocus(p,b){const i=this.a.get(p);if(!i)throw new Error((0,o.localize)(7,null,p));i.setFocus(b)}$setVisible(p,b){const i=this.a.get(p);if(!i)throw new Error((0,o.localize)(8,null,p));i.setVisible(b)}$changeCheckboxState(p,b){const i=this.a.get(p);if(!i)throw new Error((0,o.localize)(9,null,p));i.setCheckboxState(b)}h(p,b,i){const s=new w(p,b,this.d,this.e.converter,this.f,i);return this.a.set(p,s),s}i(p){const b=this.a.get(p.$treeViewId);return b&&"$treeItemHandle"in p?b.getExtensionElement(p.$treeItemHandle):b&&"$focusedTreeItem"in p&&p.$focusedTreeItem?b.focusedElement:null}}e.ExtHostTreeViews=h;class w extends A.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(p=>this.getExtensionElement(p)).filter(p=>!(0,L.isUndefinedOrNull)(p))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(p,b,i,s,a,u){if(super(),this.C=p,this.D=i,this.F=s,this.G=a,this.H=u,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new I.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new I.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new I.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new I.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new I.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new I.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new D.CancellationTokenSource,u.contributes&&u.contributes.views)for(const n in u.contributes.views)for(const r of u.contributes.views[n])r.id===p&&(this.J=r.name);this.f=b.treeDataProvider,this.g=b.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(n=>this.w.fire({message:!1,element:n})));let c,l;this.B(I.Event.debounce(this.w.event,(n,r)=>(n||(n={message:!1,elements:[]}),r.element!==!1&&(c||(c=new Promise(f=>l=f),this.y=this.y.then(()=>c)),Array.isArray(r.element)?n.elements.push(...r.element):n.elements.push(r.element)),r.message&&(n.message=!0),n),200,!0)(({message:n,elements:r})=>{r.length&&(this.z=this.z.then(()=>{const f=l;return c=null,this.U(r).then(()=>f())})),n&&this.D.$setMessage(this.C,this.I)}))}async getChildren(p){const b=p?this.getExtensionElement(p):void 0;if(p&&!b)return this.G.error(`No tree item with id '${p}' found.`),Promise.resolve([]);let i=this.Q(p);return i||(i=await this.R(b)),i?i.map(s=>s.item):void 0}getExtensionElement(p){return this.i.get(p)}reveal(p,b){b=b||{select:!0,focus:!1};const i=(0,L.isUndefinedOrNull)(b.select)?!0:b.select,s=(0,L.isUndefinedOrNull)(b.focus)?!1:b.focus,a=(0,L.isUndefinedOrNull)(b.expand)?!1:b.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.y.then(()=>this.N(p)).then(u=>this.P(p,u[u.length-1]).then(c=>this.D.$reveal(this.C,{item:c.item,parentChain:u.map(l=>l.item)},{select:i,focus:s,expand:a})),u=>this.G.error(u)):this.D.$reveal(this.C,void 0,{select:i,focus:s,expand:a})}get message(){return this.I}set message(p){this.I=p,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(p){this.J=p,this.D.$setTitle(this.C,p,this.L)}get description(){return this.L}set description(p){this.L=p,this.D.$setTitle(this.C,this.J,p)}get badge(){return this.M}set badge(p){this.M?.value===p?.value&&this.M?.tooltip===p?.tooltip||(this.M=y.ViewBadge.from(p),this.D.$setBadge(this.C,p))}setExpanded(p,b){const i=this.getExtensionElement(p);i&&(b?this.r.fire(Object.freeze({element:i})):this.s.fire(Object.freeze({element:i})))}setSelection(p){(0,P.equals)(this.l,p)||(this.l=p,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(p){this.m=p}setVisible(p){p!==this.k&&(this.k=p,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(p){const b=(await Promise.all(p.map(async i=>{const s=this.getExtensionElement(i.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:i.newState?C.TreeItemCheckboxState.Checked:C.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(i=>i!==void 0);b.forEach(i=>{i.treeItem.checkboxState=i.newState?C.TreeItemCheckboxState.Checked:C.TreeItemCheckboxState.Unchecked}),this.v.fire({items:b.map(i=>[i.extensionItem,i.newState])})}async handleDrag(p,b,i){const s=[];for(const a of p){const u=this.getExtensionElement(a);u&&s.push(u)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,b,i),b}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(p,b,i){const s=b?this.getExtensionElement(b):void 0;if(!(!s&&b||!this.g?.handleDrop))return(0,S.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(s,p,i):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(p,b){if(!this.f.resolveTreeItem)return;const i=this.i.get(p);if(i){const s=this.j.get(i);if(s){const a=await this.f.resolveTreeItem(s.extensionItem,i,b)??s.extensionItem;return this.db(a),s.item.tooltip=this.ab(a.tooltip),s.item.command=this.bb(s.disposableStore,a.command),s.item}}}N(p){return this.O(p).then(b=>b?this.N(b).then(i=>this.P(b,i[i.length-1]).then(s=>(i.push(s),i))):Promise.resolve([]))}O(p){const b=this.j.get(p);return b?Promise.resolve(b.parent?this.i.get(b.parent.item.handle):void 0):(0,S.asPromise)(()=>this.f.getParent(p))}P(p,b){const i=this.j.get(p);return i?Promise.resolve(i):(0,S.asPromise)(()=>this.f.getTreeItem(p)).then(s=>this.gb(p,s,b,!0)).then(s=>this.getChildren(b?b.item.handle:void 0).then(()=>{const a=this.getExtensionElement(s);if(a){const u=this.j.get(a);if(u)return Promise.resolve(u)}throw new Error(`Cannot resolve tree item for element ${s}`)}))}Q(p){if(p){let b;if(typeof p=="string"){const i=this.getExtensionElement(p);b=i?this.j.get(i):void 0}else b=p;return b&&b.children||void 0}return this.h}async R(p){this.nb(p);const b=new D.CancellationTokenSource(this.S.token);try{const i=p?this.j.get(p):void 0,s=await this.f.getChildren(p);if(b.token.isCancellationRequested)return;const a=await Promise.all((0,P.coalesce)(s||[]).map(async u=>{const c=await this.f.getTreeItem(u);return c&&!b.token.isCancellationRequested?this.Z(u,c,i):null}));return b.token.isCancellationRequested?void 0:(0,P.coalesce)(a)}finally{b.dispose()}}U(p){if(p.some(i=>!i))return this.S.dispose(!0),this.S=new D.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const i=this.W(p);if(i.length)return this.X(i)}return Promise.resolve(void 0)}W(p){const b=new Set,i=p.map(a=>this.j.get(a));for(const a of i)if(a&&!b.has(a.item.handle)){let u=a;for(;u&&u.parent&&i.findIndex(c=>u&&u.parent&&c&&c.item.handle===u.parent.item.handle)===-1;){const c=this.i.get(u.parent.item.handle);u=c?this.j.get(c):void 0}u&&!u.parent&&b.add(a.item.handle)}const s=[];return b.forEach(a=>{const u=this.i.get(a);if(u){const c=this.j.get(u);c&&(!c.parent||!b.has(c.parent.item.handle))&&s.push(a)}}),s}X(p){const b={};return Promise.all(p.map(i=>this.Y(i).then(s=>{s&&(b[i]=s.item)}))).then(()=>Object.keys(b).length?this.D.$refresh(this.C,b):void 0)}Y(p){const b=this.getExtensionElement(p);if(b){const i=this.j.get(b);if(i)return this.nb(b),(0,S.asPromise)(()=>this.f.getTreeItem(b)).then(s=>{if(s){const a=this.eb(b,s,i.parent);return this.lb(b,a,i,i.parent),i.dispose(),a}return null})}return Promise.resolve(null)}Z(p,b,i){const s=this.eb(p,b,i);if(b.id&&this.i.has(s.item.handle))throw new Error((0,o.localize)(10,null,b.id));return this.kb(p,s),this.mb(s,i),s}ab(p){return C.MarkdownString.isMarkdownString(p)?y.MarkdownString.from(p):p}bb(p,b){return b?{...this.F.toInternal(b,p),originalId:b.command}:void 0}cb(p){if(!p.checkboxState)return;let b,i;return typeof p.checkboxState=="number"?b=p.checkboxState:(b=p.checkboxState.state,i=p.checkboxState.tooltip),{isChecked:b===C.TreeItemCheckboxState.Checked,tooltip:i}}db(p){if(!C.TreeItem.isTreeItem(p,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(p,b,i){this.db(b);const s=new A.DisposableStore,a=this.gb(p,b,i),u=this.hb(b);return{item:{handle:a,parentHandle:i?i.item.handle:void 0,label:m(b.label,this.H),description:b.description,resourceUri:b.resourceUri,tooltip:this.ab(b.tooltip),command:this.bb(s,b.command),contextValue:b.contextValue,icon:u,iconDark:this.ib(b)||u,themeIcon:this.fb(b),collapsibleState:(0,L.isUndefinedOrNull)(b.collapsibleState)?C.TreeItemCollapsibleState.None:b.collapsibleState,accessibilityInformation:b.accessibilityInformation,checkbox:this.cb(b)},extensionItem:b,parent:i,children:void 0,disposableStore:s,dispose(){s.dispose()}}}fb(p){return p.iconPath instanceof C.ThemeIcon?p.iconPath:void 0}gb(p,{id:b,label:i,resourceUri:s},a,u){if(b)return`${w.b}/${b}`;const c=m(i,this.H),l=a?a.item.handle:w.a;let n=c?c.label:s?(0,k.basename)(s):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const r=this.j.has(p)?this.j.get(p).item.handle:void 0,f=this.Q(a)||[];let E,T=0;do{if(E=`${l}/${T}:${n}`,u||!this.i.has(E)||r===E)break;T++}while(T<=f.length);return E}hb(p){if(p.iconPath&&!(p.iconPath instanceof C.ThemeIcon))return typeof p.iconPath=="string"||R.URI.isUri(p.iconPath)?this.jb(p.iconPath):this.jb(p.iconPath.light)}ib(p){if(p.iconPath&&!(p.iconPath instanceof C.ThemeIcon)&&p.iconPath.dark)return this.jb(p.iconPath.dark)}jb(p){return R.URI.isUri(p)?p:R.URI.file(p)}kb(p,b){this.i.set(b.item.handle,p),this.j.set(p,b)}lb(p,b,i,s){this.i.delete(b.item.handle),this.j.delete(p),b.item.handle!==i.item.handle&&this.i.delete(i.item.handle),this.kb(p,b);const a=this.Q(s)||[],u=a.filter(c=>c.item.handle===i.item.handle)[0];u&&a.splice(a.indexOf(u),1,b)}mb(p,b){b?(b.children||(b.children=[]),b.children.push(p)):(this.h||(this.h=[]),this.h.push(p))}nb(p){if(p){const b=this.j.get(p);if(b){if(b.children)for(const i of b.children){const s=this.i.get(i.item.handle);s&&this.ob(s)}b.children=void 0}}else this.pb()}ob(p){const b=this.j.get(p);if(b){if(b.children)for(const i of b.children){const s=this.i.get(i.item.handle);s&&this.ob(s)}this.j.delete(p),this.i.delete(b.item.handle),b.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(p=>p.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}w.a="0",w.b="1"}),define(ye[301],Ce([1,0,21,10,4,43,2,120,106,152,161,38,5,94,244,243,39,245,34,247,248,249,232,250,58,41,251,252,255,256,257,142,235,262,263,264,98,40,266,300,14,7,68,269,74,141,33,223,254,67,139,76,78,79,13,55,17,25,258,231,54,71,241,267,73,72,272,270,271,242,47,265,268,97,59,95,259,75,260,15,124,234,212,253,6,27,216,96,209,261]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y,D,v,d,m,h,w,g,p,b,i,s,a,u,c,l,n,r,f,E,T,M,G,V,N,U,F,z,B,W,X,q,_,Q,Z,ge,te,J,fe,ve,Ee,Ae,Fe,se,le,ue,ee,ae,ie,O,H,x,Y,de,be,Pe,pe,De,ke,je,Ge,et,_e,nt,st,ht,Me,it,oe,$,ce,Ie,Le,Be,xe,Ze,gt,mt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function lt(ot){const rt=ot.get(ue.IExtHostInitDataService),kt=ot.get(ke.IExtHostFileSystemInfo),Tt=ot.get(de.IExtHostConsumerFileSystem),Nt=ot.get(u.IExtHostExtensionService),pt=ot.get(Z.IExtHostWorkspace),Dt=ot.get(nt.IExtHostTelemetry),zt=ot.get(w.IExtHostConfiguration),Ft=ot.get(se.IURITransformerService),Xe=ot.get(le.IExtHostRpcService),Mt=ot.get(N.IExtHostStorage),Ut=ot.get(Y.IExtensionStoragePaths),Bt=ot.get(Fe.ILoggerService),bt=ot.get(Fe.ILogService),Pt=ot.get(ie.IExtHostTunnelService),Re=ot.get(O.IExtHostApiDeprecationService),Oe=ot.get(Q.IExtHostWindow),Se=ot.get(et.IExtHostSecretState),re=ot.get(_e.IExtHostEditorTabs);Xe.set(y.ExtHostContext.ExtHostFileSystemInfo,kt),Xe.set(y.ExtHostContext.ExtHostLogLevelServiceShape,Bt),Xe.set(y.ExtHostContext.ExtHostWorkspace,pt),Xe.set(y.ExtHostContext.ExtHostConfiguration,zt),Xe.set(y.ExtHostContext.ExtHostExtensionService,Nt),Xe.set(y.ExtHostContext.ExtHostStorage,Mt),Xe.set(y.ExtHostContext.ExtHostTunnelService,Pt),Xe.set(y.ExtHostContext.ExtHostWindow,Oe),Xe.set(y.ExtHostContext.ExtHostSecretState,Se),Xe.set(y.ExtHostContext.ExtHostTelemetry,Dt),Xe.set(y.ExtHostContext.ExtHostEditorTabs,re);const Ne=Xe.set(y.ExtHostContext.ExtHostDecorations,ot.get(fe.IExtHostDecorations)),$e=Xe.set(y.ExtHostContext.ExtHostDocumentsAndEditors,ot.get(a.IExtHostDocumentsAndEditors)),Qe=Xe.set(y.ExtHostContext.ExtHostCommands,ot.get(m.IExtHostCommands)),Ve=Xe.set(y.ExtHostContext.ExtHostTerminalService,ot.get(U.IExtHostTerminalService)),tt=Xe.set(y.ExtHostContext.ExtHostDebugService,ot.get(Ee.IExtHostDebugService)),St=Xe.set(y.ExtHostContext.ExtHostSearch,ot.get(Ae.IExtHostSearch)),Et=Xe.set(y.ExtHostContext.ExtHostTask,ot.get(ve.IExtHostTask)),Lt=Xe.set(y.ExtHostContext.ExtHostOutputService,ot.get(E.IExtHostOutputService)),vt=Xe.set(y.ExtHostContext.ExtHostLocalization,ot.get(Ze.IExtHostLocalizationService)),It=Xe.set(y.ExtHostContext.ExtHostUrls,new q.ExtHostUrls(Xe)),ft=Xe.set(y.ExtHostContext.ExtHostDocuments,new s.ExtHostDocuments(Xe,$e)),xt=Xe.set(y.ExtHostContext.ExtHostDocumentContentProviders,new b.ExtHostDocumentContentProvider(Xe,$e,bt)),jt=Xe.set(y.ExtHostContext.ExtHostDocumentSaveParticipant,new i.ExtHostDocumentSaveParticipant(bt,ft,Xe.getProxy(y.MainContext.MainThreadBulkEdits))),yt=Xe.set(y.ExtHostContext.ExtHostNotebook,new ee.ExtHostNotebookController(Xe,Qe,$e,ft)),_t=Xe.set(y.ExtHostContext.ExtHostNotebookDocuments,new ce.ExtHostNotebookDocuments(yt)),an=Xe.set(y.ExtHostContext.ExtHostNotebookEditors,new $.ExtHostNotebookEditors(bt,yt)),Zt=Xe.set(y.ExtHostContext.ExtHostNotebookKernels,new st.ExtHostNotebookKernels(Xe,rt,yt,Qe,bt)),vn=Xe.set(y.ExtHostContext.ExtHostNotebookRenderers,new Me.ExtHostNotebookRenderers(Xe,yt)),At=Xe.set(y.ExtHostContext.ExtHostEditors,new F.ExtHostEditors(Xe,$e)),cn=Xe.set(y.ExtHostContext.ExtHostTreeViews,new z.ExtHostTreeViews(Xe.getProxy(y.MainContext.MainThreadTreeViews),Qe,bt)),Vt=Xe.set(y.ExtHostContext.ExtHostEditorInsets,new ge.ExtHostEditorInsets(Xe.getProxy(y.MainContext.MainThreadEditorInsets),At,rt.remote)),en=Xe.set(y.ExtHostContext.ExtHostDiagnostics,new g.ExtHostDiagnostics(Xe,bt,kt,$e)),ln=Xe.set(y.ExtHostContext.ExtHostLanguages,new r.ExtHostLanguages(Xe,ft,Qe.converter,Ft)),ut=Xe.set(y.ExtHostContext.ExtHostLanguageFeatures,new n.ExtHostLanguageFeatures(Xe,Ft,ft,Qe,en,bt,Re,Dt)),tn=Xe.set(y.ExtHostContext.ExtHostFileSystem,new c.ExtHostFileSystem(Xe,ut)),qt=Xe.set(y.ExtHostContext.ExtHostFileSystemEventService,new l.ExtHostFileSystemEventService(Xe,bt,$e)),Qt=Xe.set(y.ExtHostContext.ExtHostQuickOpen,(0,M.createExtHostQuickOpen)(Xe,pt,Qe)),un=Xe.set(y.ExtHostContext.ExtHostSCM,new G.ExtHostSCM(Xe,Qe,bt)),En=Xe.set(y.ExtHostContext.ExtHostComments,(0,h.createExtHostComments)(Xe,Qe,ft)),dn=Xe.set(y.ExtHostContext.ExtHostProgress,new T.ExtHostProgress(Xe.getProxy(y.MainContext.MainThreadProgress))),Sn=Xe.set(y.ExtHostContext.ExtHosLabelService,new te.ExtHostLabelService(Xe)),hn=Xe.set(y.ExtHostContext.ExtHostTheming,new ae.ExtHostTheming(Xe)),nn=Xe.set(y.ExtHostContext.ExtHostAuthentication,new H.ExtHostAuthentication(Xe)),Un=Xe.set(y.ExtHostContext.ExtHostTimeline,new x.ExtHostTimeline(Xe,Qe)),rn=Xe.set(y.ExtHostContext.ExtHostWebviews,new _.ExtHostWebviews(Xe,rt.remote,pt,bt,Re)),sn=Xe.set(y.ExtHostContext.ExtHostWebviewPanels,new pe.ExtHostWebviewPanels(Xe,rn,pt)),yn=Xe.set(y.ExtHostContext.ExtHostCustomEditors,new Pe.ExtHostCustomEditors(Xe,ft,Ut,rn,sn)),Cn=Xe.set(y.ExtHostContext.ExtHostWebviewViews,new be.ExtHostWebviewViews(Xe,rn)),on=Xe.set(y.ExtHostContext.ExtHostTesting,new je.ExtHostTesting(Xe,Qe,$e)),Dn=Xe.set(y.ExtHostContext.ExtHostUriOpeners,new Ge.ExtHostUriOpeners(Xe)),In=Xe.set(y.ExtHostContext.ExtHostProfileContentHandlers,new mt.ExtHostProfileContentHandlers(Xe));Xe.set(y.ExtHostContext.ExtHostInteractive,new Ie.ExtHostInteractive(Xe,yt,$e,Qe,bt));const Bn=Object.values(y.ExtHostContext);Xe.assertRegistered(Bn);const zn=new De.ExtHostBulkEdits(Xe,$e),$n=new d.ExtHostClipboard(Xe),kn=new f.ExtHostMessageService(Xe,bt),Rn=new p.ExtHostDialogs(Xe),Ln=new V.ExtHostStatusBar(Xe,Qe.converter);return v.ExtHostApiCommands.register(Qe),function(We,Wt,On){const wt=function(){let me=!We.isUnderDevelopment;function we(){me||(bt.info(`Extension '${We.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),me=!0)}return function ze(at){if(Array.isArray(at))at.forEach(ze);else if(typeof at=="string")we();else{const Ct=at;typeof Ct.scheme>"u"&&we(),typeof Ct.exclusive=="boolean"&&(0,Be.checkProposedApiEnabled)(We,"documentFiltersExclusive")}return at}}(),Wn={getSession(me,we,ze){return nn.getSession(We,me,we,ze)},async hasSession(me,we){return(0,Be.checkProposedApiEnabled)(We,"authSession"),!!await nn.getSession(We,me,we,{silent:!0})},get onDidChangeSessions(){return nn.onDidChangeSessions},registerAuthenticationProvider(me,we,ze,at){return nn.registerAuthenticationProvider(me,we,ze,at)}},fn={registerCommand(me,we,ze){return Qe.registerCommand(!0,me,we,ze,void 0,We)},registerTextEditorCommand(me,we,ze){return Qe.registerCommand(!0,me,(...at)=>{const Ct=At.getActiveTextEditor();if(!Ct){bt.warn("Cannot execute "+me+" because there is no active text editor.");return}return Ct.edit(Rt=>{we.apply(ze,[Ct,Rt,...at])}).then(Rt=>{Rt||bt.warn("Edits from command "+me+" were not applied.")},Rt=>{bt.warn("An error occurred while running command "+me,Rt)})},void 0,void 0,We)},registerDiffInformationCommand:(me,we,ze)=>((0,Be.checkProposedApiEnabled)(We,"diffCommand"),Qe.registerCommand(!0,me,async(...at)=>{const Ct=$e.activeEditor(!0);if(!Ct){bt.warn("Cannot execute "+me+" because there is no active text editor.");return}const Rt=await At.getDiffInformation(Ct.id);we.apply(ze,[Rt,...at])},void 0,void 0,We)),executeCommand(me,...we){return Qe.executeCommand(me,...we)},getCommands(me=!1){return Qe.getCommands(me)}},Nn={get machineId(){return rt.telemetryInfo.machineId},get sessionId(){return rt.telemetryInfo.sessionId},get language(){return rt.environment.appLanguage},get appName(){return rt.environment.appName},get appRoot(){return rt.environment.appRoot?.fsPath??""},get appHost(){return rt.environment.appHost},get uriScheme(){return rt.environment.appUriScheme},get clipboard(){return $n.value},get shell(){return Ve.getDefaultShell(!1)},get onDidChangeShell(){return(0,Be.checkProposedApiEnabled)(We,"envShellEvent"),Ve.onDidChangeShell},get isTelemetryEnabled(){return Dt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Dt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Be.checkProposedApiEnabled)(We,"telemetry"),Dt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Be.checkProposedApiEnabled)(We,"telemetry"),Dt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,nt.isNewAppInstall)(rt.telemetryInfo.firstSessionDate)},createTelemetryLogger(me){return(0,Be.checkProposedApiEnabled)(We,"telemetryLogger"),Dt.instantiateLogger(We,me)},openExternal(me,we){return Oe.openUri(me,{allowTunneling:!!rt.remote.authority,allowContributedOpeners:we?.allowContributedOpeners})},async asExternalUri(me){if(me.scheme===rt.environment.appUriScheme)return It.createAppUri(me);try{return await Oe.asExternalUri(me,{allowTunneling:!!rt.remote.authority})}catch(we){if((0,oe.matchesScheme)(me,it.Schemas.http)||(0,oe.matchesScheme)(me,it.Schemas.https))return me;throw we}},get remoteName(){return(0,J.getRemoteName)(rt.remote.authority)},get remoteAuthority(){return(0,Be.checkProposedApiEnabled)(We,"resolvers"),rt.remote.authority},get uiKind(){return rt.uiKind},get logLevel(){return bt.getLevel()},get onDidChangeLogLevel(){return bt.onDidChangeLogLevel}};rt.environment.extensionTestsLocationURI||Object.freeze(Nn);const Hn={createTestController(me,we,ze){return on.createTestController(me,we,ze)},createTestObserver(){return(0,Be.checkProposedApiEnabled)(We,"testObserver"),on.createTestObserver()},runTests(me){return(0,Be.checkProposedApiEnabled)(We,"testObserver"),on.runTests(me)},get onDidChangeTestResults(){return(0,Be.checkProposedApiEnabled)(We,"testObserver"),on.onResultsChanged},get testResults(){return(0,Be.checkProposedApiEnabled)(We,"testObserver"),on.results}},mn=rt.remote.isRemote?W.ExtensionKind.Workspace:W.ExtensionKind.UI,jn={getExtension(me,we){(0,Be.isProposedApiEnabled)(We,"extensionsAny")||(we=!1);const ze=Wt.mine.getExtensionDescription(me);if(ze)return new u.Extension(Nt,We.identifier,ze,mn,!1);if(we){const at=Wt.all.getExtensionDescription(me);if(at)return new u.Extension(Nt,We.identifier,at,mn,!0)}},get all(){const me=[];for(const we of Wt.mine.getAllExtensionDescriptions())me.push(new u.Extension(Nt,We.identifier,we,mn,!1));return me},get allAcrossExtensionHosts(){(0,Be.checkProposedApiEnabled)(We,"extensionsAny");const me=new Be.ExtensionIdentifierSet(Wt.mine.getAllExtensionDescriptions().map(ze=>ze.identifier)),we=[];for(const ze of Wt.all.getAllExtensionDescriptions()){const at=!me.has(ze.identifier);we.push(new u.Extension(Nt,We.identifier,ze,mn,at))}return we},get onDidChange(){return(0,Be.isProposedApiEnabled)(We,"extensionsAny")?k.Event.any(Wt.mine.onDidChange,Wt.all.onDidChange):Wt.mine.onDidChange}},Tn={createDiagnosticCollection(me){return en.createDiagnosticCollection(We.identifier,me)},get onDidChangeDiagnostics(){return en.onDidChangeDiagnostics},getDiagnostics:me=>en.getDiagnostics(me),getLanguages(){return ln.getLanguages()},setTextDocumentLanguage(me,we){return ln.changeLanguage(me.uri,we)},match(me,we){const ze=ft.getDocumentData(we.uri)?.notebook;return(0,L.score)(B.LanguageSelector.from(me),we.uri,we.languageId,!0,ze?.uri,ze?.notebookType)},registerCodeActionsProvider(me,we,ze){return ut.registerCodeActionProvider(We,wt(me),we,ze)},registerDocumentPasteEditProvider(me,we,ze){return(0,Be.checkProposedApiEnabled)(We,"documentPaste"),ut.registerDocumentPasteEditProvider(We,wt(me),we,ze)},registerCodeLensProvider(me,we){return ut.registerCodeLensProvider(We,wt(me),we)},registerDefinitionProvider(me,we){return ut.registerDefinitionProvider(We,wt(me),we)},registerDeclarationProvider(me,we){return ut.registerDeclarationProvider(We,wt(me),we)},registerImplementationProvider(me,we){return ut.registerImplementationProvider(We,wt(me),we)},registerTypeDefinitionProvider(me,we){return ut.registerTypeDefinitionProvider(We,wt(me),we)},registerHoverProvider(me,we){return ut.registerHoverProvider(We,wt(me),we,We.identifier)},registerEvaluatableExpressionProvider(me,we){return ut.registerEvaluatableExpressionProvider(We,wt(me),we,We.identifier)},registerInlineValuesProvider(me,we){return ut.registerInlineValuesProvider(We,wt(me),we,We.identifier)},registerDocumentHighlightProvider(me,we){return ut.registerDocumentHighlightProvider(We,wt(me),we)},registerLinkedEditingRangeProvider(me,we){return ut.registerLinkedEditingRangeProvider(We,wt(me),we)},registerReferenceProvider(me,we){return ut.registerReferenceProvider(We,wt(me),we)},registerRenameProvider(me,we){return ut.registerRenameProvider(We,wt(me),we)},registerDocumentSymbolProvider(me,we,ze){return ut.registerDocumentSymbolProvider(We,wt(me),we,ze)},registerWorkspaceSymbolProvider(me){return ut.registerWorkspaceSymbolProvider(We,me)},registerDocumentFormattingEditProvider(me,we){return ut.registerDocumentFormattingEditProvider(We,wt(me),we)},registerDocumentRangeFormattingEditProvider(me,we){return ut.registerDocumentRangeFormattingEditProvider(We,wt(me),we)},registerOnTypeFormattingEditProvider(me,we,ze,...at){return ut.registerOnTypeFormattingEditProvider(We,wt(me),we,[ze].concat(at))},registerDocumentSemanticTokensProvider(me,we,ze){return ut.registerDocumentSemanticTokensProvider(We,wt(me),we,ze)},registerDocumentRangeSemanticTokensProvider(me,we,ze){return ut.registerDocumentRangeSemanticTokensProvider(We,wt(me),we,ze)},registerSignatureHelpProvider(me,we,ze,...at){return typeof ze=="object"?ut.registerSignatureHelpProvider(We,wt(me),we,ze):ut.registerSignatureHelpProvider(We,wt(me),we,typeof ze>"u"?[]:[ze,...at])},registerCompletionItemProvider(me,we,...ze){return ut.registerCompletionItemProvider(We,wt(me),we,ze)},registerInlineCompletionItemProvider(me,we){return we.handleDidShowCompletionItem&&(0,Be.checkProposedApiEnabled)(We,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(We,wt(me),we)},registerDocumentLinkProvider(me,we){return ut.registerDocumentLinkProvider(We,wt(me),we)},registerColorProvider(me,we){return ut.registerColorProvider(We,wt(me),we)},registerFoldingRangeProvider(me,we){return ut.registerFoldingRangeProvider(We,wt(me),we)},registerSelectionRangeProvider(me,we){return ut.registerSelectionRangeProvider(We,me,we)},registerCallHierarchyProvider(me,we){return ut.registerCallHierarchyProvider(We,me,we)},registerTypeHierarchyProvider(me,we){return ut.registerTypeHierarchyProvider(We,me,we)},setLanguageConfiguration:(me,we)=>ut.setLanguageConfiguration(We,me,we),getTokenInformationAtPosition(me,we){return(0,Be.checkProposedApiEnabled)(We,"tokenInformation"),ln.tokenAtPosition(me,we)},registerInlayHintsProvider(me,we){return ut.registerInlayHintsProvider(We,me,we)},createLanguageStatusItem(me,we){return ln.createLanguageStatusItem(We,me,we)},registerDocumentDropEditProvider(me,we){return ut.registerDocumentOnDropEditProvider(We,me,we)}},Vn={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return Ve.activeTerminal},get terminals(){return Ve.terminals},async showTextDocument(me,we,ze){const at=await(I.URI.isUri(me)?Promise.resolve(Gt.openTextDocument(me)):Promise.resolve(me));return At.showTextDocument(at,we,ze)},createTextEditorDecorationType(me){return At.createTextEditorDecorationType(We,me)},onDidChangeActiveTextEditor(me,we,ze){return At.onDidChangeActiveTextEditor(me,we,ze)},onDidChangeVisibleTextEditors(me,we,ze){return At.onDidChangeVisibleTextEditors(me,we,ze)},onDidChangeTextEditorSelection(me,we,ze){return At.onDidChangeTextEditorSelection(me,we,ze)},onDidChangeTextEditorOptions(me,we,ze){return At.onDidChangeTextEditorOptions(me,we,ze)},onDidChangeTextEditorVisibleRanges(me,we,ze){return At.onDidChangeTextEditorVisibleRanges(me,we,ze)},onDidChangeTextEditorViewColumn(me,we,ze){return At.onDidChangeTextEditorViewColumn(me,we,ze)},onDidCloseTerminal(me,we,ze){return Ve.onDidCloseTerminal(me,we,ze)},onDidOpenTerminal(me,we,ze){return Ve.onDidOpenTerminal(me,we,ze)},onDidChangeActiveTerminal(me,we,ze){return Ve.onDidChangeActiveTerminal(me,we,ze)},onDidChangeTerminalDimensions(me,we,ze){return(0,Be.checkProposedApiEnabled)(We,"terminalDimensions"),Ve.onDidChangeTerminalDimensions(me,we,ze)},onDidChangeTerminalState(me,we,ze){return Ve.onDidChangeTerminalState(me,we,ze)},onDidWriteTerminalData(me,we,ze){return(0,Be.checkProposedApiEnabled)(We,"terminalDataWriteEvent"),Ve.onDidWriteTerminalData(me,we,ze)},get state(){return Oe.state},onDidChangeWindowState(me,we,ze){return Oe.onDidChangeWindowState(me,we,ze)},showInformationMessage(me,...we){return kn.showMessage(We,R.default.Info,me,we[0],we.slice(1))},showWarningMessage(me,...we){return kn.showMessage(We,R.default.Warning,me,we[0],we.slice(1))},showErrorMessage(me,...we){return kn.showMessage(We,R.default.Error,me,we[0],we.slice(1))},showQuickPick(me,we,ze){return Qt.showQuickPick(me,we,ze)},showWorkspaceFolderPick(me){return Qt.showWorkspaceFolderPick(me)},showInputBox(me,we){return Qt.showInput(me,we)},showOpenDialog(me){return Rn.showOpenDialog(me)},showSaveDialog(me){return Rn.showSaveDialog(me)},createStatusBarItem(me,we,ze){let at,Ct,Rt;return typeof me=="string"?(at=me,Ct=we,Rt=ze):(Ct=me,Rt=we),Ln.createStatusBarEntry(We,at,Ct,Rt)},setStatusBarMessage(me,we){return Ln.setStatusBarMessage(me,we)},withScmProgress(me){return Re.report("window.withScmProgress",We,"Use 'withProgress' instead."),dn.withProgress(We,{location:W.ProgressLocation.SourceControl},(we,ze)=>me({report(at){}}))},withProgress(me,we){return dn.withProgress(We,me,we)},createOutputChannel(me,we){return Lt.createOutputChannel(me,we,We)},createWebviewPanel(me,we,ze,at){return sn.createWebviewPanel(We,me,we,ze,at)},createWebviewTextEditorInset(me,we,ze,at){return(0,Be.checkProposedApiEnabled)(We,"editorInsets"),Vt.createWebviewEditorInset(me,we,ze,at,We)},createTerminal(me,we,ze){return typeof me=="object"?"pty"in me?Ve.createExtensionTerminal(me):Ve.createTerminalFromOptions(me):Ve.createTerminal(me,we,ze)},registerTerminalLinkProvider(me){return Ve.registerLinkProvider(me)},registerTerminalProfileProvider(me,we){return Ve.registerProfileProvider(We,me,we)},registerTerminalQuickFixProvider(me,we){return(0,Be.checkProposedApiEnabled)(We,"terminalQuickFixProvider"),Ve.registerTerminalQuickFixProvider(me,We.identifier.value,we)},registerTreeDataProvider(me,we){return cn.registerTreeDataProvider(me,we,We)},createTreeView(me,we){return cn.createTreeView(me,we,We)},registerWebviewPanelSerializer:(me,we)=>sn.registerWebviewPanelSerializer(We,me,we),registerCustomEditorProvider:(me,we,ze={})=>yn.registerCustomEditorProvider(We,me,we,ze),registerFileDecorationProvider(me){return Ne.registerFileDecorationProvider(me,We)},registerUriHandler(me){return It.registerUriHandler(We.identifier,me)},createQuickPick(){return Qt.createQuickPick(We)},createInputBox(){return Qt.createInputBox(We)},get activeColorTheme(){return hn.activeColorTheme},onDidChangeActiveColorTheme(me,we,ze){return hn.onDidChangeActiveColorTheme(me,we,ze)},registerWebviewViewProvider(me,we,ze){return Cn.registerWebviewViewProvider(We,me,we,ze?.webviewOptions)},get activeNotebookEditor(){return yt.activeNotebookEditor},onDidChangeActiveNotebookEditor(me,we,ze){return yt.onDidChangeActiveNotebookEditor(me,we,ze)},get visibleNotebookEditors(){return yt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return yt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(me,we,ze){return an.onDidChangeNotebookEditorSelection(me,we,ze)},onDidChangeNotebookEditorVisibleRanges(me,we,ze){return an.onDidChangeNotebookEditorVisibleRanges(me,we,ze)},showNotebookDocument(me,we){return yt.showNotebookDocument(me,we)},registerExternalUriOpener(me,we,ze){return(0,Be.checkProposedApiEnabled)(We,"externalUriOpener"),Dn.registerExternalUriOpener(We.identifier,me,we,ze)},registerProfileContentHandler(me,we){return(0,Be.checkProposedApiEnabled)(We,"profileContentHandlers"),In.registrProfileContentHandler(We,me,we)},get tabGroups(){return re.tabGroups}},Gt={get rootPath(){return Re.report("workspace.rootPath",We,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),pt.getPath()},set rootPath(me){throw t.readonly()},getWorkspaceFolder(me){return pt.getWorkspaceFolder(me)},get workspaceFolders(){return pt.getWorkspaceFolders()},get name(){return pt.name},set name(me){throw t.readonly()},get workspaceFile(){return pt.workspaceFile},set workspaceFile(me){throw t.readonly()},updateWorkspaceFolders:(me,we,...ze)=>pt.updateWorkspaceFolders(We,me,we||0,...ze),onDidChangeWorkspaceFolders:function(me,we,ze){return pt.onDidChangeWorkspace(me,we,ze)},asRelativePath:(me,we)=>pt.getRelativePath(me,we),findFiles:(me,we,ze,at)=>pt.findFiles(me,we,ze,We.identifier,at),findTextInFiles:(me,we,ze,at)=>{(0,Be.checkProposedApiEnabled)(We,"findTextInFiles");let Ct,Rt;return typeof we=="object"?(Ct=we,Rt=ze):(Ct={},Rt=we,at=ze),pt.findTextInFiles(me,Ct||{},Rt,We.identifier,at)},saveAll:me=>pt.saveAll(me),applyEdit(me,we){return zn.applyWorkspaceEdit(me,We,we)},createFileSystemWatcher:(me,we,ze,at)=>qt.createFileSystemWatcher(pt,We,me,we,ze,at),get textDocuments(){return ft.getAllDocumentData().map(me=>me.document)},set textDocuments(me){throw t.readonly()},openTextDocument(me){let we;const ze=me;if(typeof me=="string")we=Promise.resolve(I.URI.file(me));else if(I.URI.isUri(me))we=Promise.resolve(me);else if(!ze||typeof ze=="object")we=ft.createDocumentData(ze);else throw new Error("illegal argument - uriOrFileNameOrOptions");return we.then(at=>ft.ensureDocumentData(at).then(Ct=>Ct.document))},onDidOpenTextDocument:(me,we,ze)=>ft.onDidAddDocument(me,we,ze),onDidCloseTextDocument:(me,we,ze)=>ft.onDidRemoveDocument(me,we,ze),onDidChangeTextDocument:(me,we,ze)=>ft.onDidChangeDocument(me,we,ze),onDidSaveTextDocument:(me,we,ze)=>ft.onDidSaveDocument(me,we,ze),onWillSaveTextDocument:(me,we,ze)=>jt.getOnWillSaveTextDocumentEvent(We)(me,we,ze),get notebookDocuments(){return yt.notebookDocuments.map(me=>me.apiNotebook)},async openNotebookDocument(me,we){let ze;if(I.URI.isUri(me))ze=me,await yt.openNotebookDocument(me);else if(typeof me=="string")ze=I.URI.revive(await yt.createNotebookDocument({viewType:me,content:we}));else throw new Error("Invalid arguments");return yt.getNotebookDocument(ze).apiNotebook},onDidSaveNotebookDocument(me,we,ze){return _t.onDidSaveNotebookDocument(me,we,ze)},onDidChangeNotebookDocument(me,we,ze){return _t.onDidChangeNotebookDocument(me,we,ze)},get onDidOpenNotebookDocument(){return yt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return yt.onDidCloseNotebookDocument},registerNotebookSerializer(me,we,ze,at){return yt.registerNotebookSerializer(We,me,we,ze,(0,Be.isProposedApiEnabled)(We,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(me,we,ze)=>On.onDidChangeConfiguration(me,we,ze),getConfiguration(me,we){return we=arguments.length===1?void 0:we,On.getConfiguration(me,we,We)},registerTextDocumentContentProvider(me,we){return xt.registerTextDocumentContentProvider(me,we)},registerTaskProvider:(me,we)=>(Re.report("window.registerTaskProvider",We,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(We,me,we)),registerFileSystemProvider(me,we,ze){return(0,Le.combinedDisposable)(tn.registerFileSystemProvider(We,me,we,ze),Tt.addFileSystemProvider(me,we))},get fs(){return Tt.value},registerFileSearchProvider:(me,we)=>((0,Be.checkProposedApiEnabled)(We,"fileSearchProvider"),St.registerFileSearchProvider(me,we)),registerTextSearchProvider:(me,we)=>((0,Be.checkProposedApiEnabled)(We,"textSearchProvider"),St.registerTextSearchProvider(me,we)),registerRemoteAuthorityResolver:(me,we)=>((0,Be.checkProposedApiEnabled)(We,"resolvers"),Nt.registerRemoteAuthorityResolver(me,we)),registerResourceLabelFormatter:me=>((0,Be.checkProposedApiEnabled)(We,"resolvers"),Sn.$registerResourceLabelFormatter(me)),onDidCreateFiles:(me,we,ze)=>qt.onDidCreateFile(me,we,ze),onDidDeleteFiles:(me,we,ze)=>qt.onDidDeleteFile(me,we,ze),onDidRenameFiles:(me,we,ze)=>qt.onDidRenameFile(me,we,ze),onWillCreateFiles:(me,we,ze)=>qt.getOnWillCreateFileEvent(We)(me,we,ze),onWillDeleteFiles:(me,we,ze)=>qt.getOnWillDeleteFileEvent(We)(me,we,ze),onWillRenameFiles:(me,we,ze)=>qt.getOnWillRenameFileEvent(We)(me,we,ze),openTunnel:me=>((0,Be.checkProposedApiEnabled)(We,"tunnels"),Pt.openTunnel(We,me).then(we=>{if(!we)throw new Error("cannot open tunnel");return we})),get tunnels(){return(0,Be.checkProposedApiEnabled)(We,"tunnels"),Pt.getTunnels()},onDidChangeTunnels:(me,we,ze)=>((0,Be.checkProposedApiEnabled)(We,"tunnels"),Pt.onDidChangeTunnels(me,we,ze)),registerPortAttributesProvider:(me,we)=>((0,Be.checkProposedApiEnabled)(We,"portsAttributes"),Pt.registerPortsAttributesProvider(me,we)),registerTimelineProvider:(me,we)=>((0,Be.checkProposedApiEnabled)(We,"timeline"),Un.registerTimelineProvider(me,we,We.identifier,Qe.converter)),get isTrusted(){return pt.trusted},requestWorkspaceTrust:me=>((0,Be.checkProposedApiEnabled)(We,"workspaceTrust"),pt.requestWorkspaceTrust(me)),onDidGrantWorkspaceTrust:(me,we,ze)=>pt.onDidGrantWorkspaceTrust(me,we,ze),registerEditSessionIdentityProvider:(me,we)=>((0,Be.checkProposedApiEnabled)(We,"editSessionIdentityProvider"),pt.registerEditSessionIdentityProvider(me,we))},gn={get inputBox(){return Re.report("scm.inputBox",We,"Use 'SourceControl.inputBox' instead"),un.getLastInputBox(We)},createSourceControl(me,we,ze){return un.createSourceControl(We,me,we,ze)}},qn={createCommentController(me,we){return En.createCommentController(We,me,we)}},$t={get activeDebugSession(){return tt.activeDebugSession},get activeDebugConsole(){return tt.activeDebugConsole},get breakpoints(){return tt.breakpoints},onDidStartDebugSession(me,we,ze){return tt.onDidStartDebugSession(me,we,ze)},onDidTerminateDebugSession(me,we,ze){return tt.onDidTerminateDebugSession(me,we,ze)},onDidChangeActiveDebugSession(me,we,ze){return tt.onDidChangeActiveDebugSession(me,we,ze)},onDidReceiveDebugSessionCustomEvent(me,we,ze){return tt.onDidReceiveDebugSessionCustomEvent(me,we,ze)},onDidChangeBreakpoints(me,we,ze){return tt.onDidChangeBreakpoints(me,we,ze)},registerDebugConfigurationProvider(me,we,ze){return tt.registerDebugConfigurationProvider(me,we,ze||xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(me,we){return tt.registerDebugAdapterDescriptorFactory(We,me,we)},registerDebugAdapterTrackerFactory(me,we){return tt.registerDebugAdapterTrackerFactory(me,we)},startDebugging(me,we,ze){return!ze||typeof ze=="object"&&"configuration"in ze?tt.startDebugging(me,we,{parentSession:ze}):tt.startDebugging(me,we,ze||{})},stopDebugging(me){return tt.stopDebugging(me)},addBreakpoints(me){return tt.addBreakpoints(me)},removeBreakpoints(me){return tt.removeBreakpoints(me)},asDebugSourceUri(me,we){return tt.asDebugSourceUri(me,we)}},pn={registerTaskProvider:(me,we)=>Et.registerTaskProvider(We,me,we),fetchTasks:me=>Et.fetchTasks(me),executeTask:me=>Et.executeTask(We,me),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(me,we,ze)=>Et.onDidStartTask(me,we,ze),onDidEndTask:(me,we,ze)=>Et.onDidEndTask(me,we,ze),onDidStartTaskProcess:(me,we,ze)=>Et.onDidStartTaskProcess(me,we,ze),onDidEndTaskProcess:(me,we,ze)=>Et.onDidEndTaskProcess(me,we,ze)},Gn={createNotebookController(me,we,ze,at,Ct){return Zt.createNotebookController(We,me,we,ze,at,(0,Be.isProposedApiEnabled)(We,"notebookMessaging")?Ct:void 0)},registerNotebookCellStatusBarItemProvider:(me,we)=>yt.registerNotebookCellStatusBarItemProvider(We,me,we),createRendererMessaging(me){return vn.createRendererMessaging(We,me)},createNotebookControllerDetectionTask(me){return(0,Be.checkProposedApiEnabled)(We,"notebookKernelSource"),Zt.createNotebookControllerDetectionTask(We,me)},registerKernelSourceActionProvider(me,we){return(0,Be.checkProposedApiEnabled)(We,"notebookKernelSource"),Zt.registerKernelSourceActionProvider(We,me,we)},onDidChangeNotebookCellExecutionState(me,we,ze){return(0,Be.checkProposedApiEnabled)(We,"notebookCellExecutionState"),Zt.onDidChangeNotebookCellExecutionState(me,we,ze)}},Kn={t(...me){if(typeof me[0]=="string"){const we=me.shift(),ze=!me||typeof me[0]!="object"?me:me[0];return vt.getMessage(We.identifier.value,{message:we,args:ze})}return vt.getMessage(We.identifier.value,me[0])},get bundle(){return vt.getBundle(We.identifier.value)},get uri(){return vt.getBundleUri(We.identifier.value)}};return{version:rt.version,authentication:Wn,commands:fn,comments:qn,debug:$t,env:Nn,extensions:jn,l10n:Kn,languages:Tn,notebooks:Gn,scm:gn,tasks:pn,tests:Hn,window:Vn,workspace:Gt,Breakpoint:W.Breakpoint,TerminalOutputAnchor:W.TerminalOutputAnchor,CallHierarchyIncomingCall:W.CallHierarchyIncomingCall,CallHierarchyItem:W.CallHierarchyItem,CallHierarchyOutgoingCall:W.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:o.CancellationTokenSource,CandidatePortSource:y.CandidatePortSource,CodeAction:W.CodeAction,CodeActionKind:W.CodeActionKind,CodeActionTriggerKind:W.CodeActionTriggerKind,CodeLens:W.CodeLens,Color:W.Color,ColorInformation:W.ColorInformation,ColorPresentation:W.ColorPresentation,ColorThemeKind:W.ColorThemeKind,CommentMode:W.CommentMode,CommentThreadCollapsibleState:W.CommentThreadCollapsibleState,CommentThreadState:W.CommentThreadState,CompletionItem:W.CompletionItem,CompletionItemKind:W.CompletionItemKind,CompletionItemTag:W.CompletionItemTag,CompletionList:W.CompletionList,CompletionTriggerKind:W.CompletionTriggerKind,ConfigurationTarget:W.ConfigurationTarget,CustomExecution:W.CustomExecution,DebugAdapterExecutable:W.DebugAdapterExecutable,DebugAdapterInlineImplementation:W.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:W.DebugAdapterNamedPipeServer,DebugAdapterServer:W.DebugAdapterServer,DebugConfigurationProviderTriggerKind:xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:W.DebugConsoleMode,DecorationRangeBehavior:W.DecorationRangeBehavior,Diagnostic:W.Diagnostic,DiagnosticRelatedInformation:W.DiagnosticRelatedInformation,DiagnosticSeverity:W.DiagnosticSeverity,DiagnosticTag:W.DiagnosticTag,Disposable:W.Disposable,DocumentHighlight:W.DocumentHighlight,DocumentHighlightKind:W.DocumentHighlightKind,DocumentLink:W.DocumentLink,DocumentSymbol:W.DocumentSymbol,EndOfLine:W.EndOfLine,EnvironmentVariableMutatorType:W.EnvironmentVariableMutatorType,EvaluatableExpression:W.EvaluatableExpression,InlineValueText:W.InlineValueText,InlineValueVariableLookup:W.InlineValueVariableLookup,InlineValueEvaluatableExpression:W.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:W.InlineCompletionTriggerKind,EventEmitter:k.Emitter,ExtensionKind:W.ExtensionKind,ExtensionMode:W.ExtensionMode,ExternalUriOpenerPriority:W.ExternalUriOpenerPriority,FileChangeType:W.FileChangeType,FileDecoration:W.FileDecoration,FileDecoration2:W.FileDecoration,FileSystemError:W.FileSystemError,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:W.FoldingRange,FoldingRangeKind:W.FoldingRangeKind,FunctionBreakpoint:W.FunctionBreakpoint,InlineCompletionItem:W.InlineSuggestion,InlineCompletionList:W.InlineSuggestionList,Hover:W.Hover,IndentAction:C.IndentAction,Location:W.Location,MarkdownString:W.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:W.ParameterInformation,PortAutoForwardAction:W.PortAutoForwardAction,Position:W.Position,ProcessExecution:W.ProcessExecution,ProgressLocation:W.ProgressLocation,QuickInputButtons:W.QuickInputButtons,Range:W.Range,RelativePattern:W.RelativePattern,Selection:W.Selection,SelectionRange:W.SelectionRange,SemanticTokens:W.SemanticTokens,SemanticTokensBuilder:W.SemanticTokensBuilder,SemanticTokensEdit:W.SemanticTokensEdit,SemanticTokensEdits:W.SemanticTokensEdits,SemanticTokensLegend:W.SemanticTokensLegend,ShellExecution:W.ShellExecution,ShellQuoting:W.ShellQuoting,SignatureHelp:W.SignatureHelp,SignatureHelpTriggerKind:W.SignatureHelpTriggerKind,SignatureInformation:W.SignatureInformation,SnippetString:W.SnippetString,SourceBreakpoint:W.SourceBreakpoint,StandardTokenType:W.StandardTokenType,StatusBarAlignment:W.StatusBarAlignment,SymbolInformation:W.SymbolInformation,SymbolKind:W.SymbolKind,SymbolTag:W.SymbolTag,Task:W.Task,TaskGroup:W.TaskGroup,TaskPanelKind:W.TaskPanelKind,TaskRevealKind:W.TaskRevealKind,TaskScope:W.TaskScope,TerminalLink:W.TerminalLink,TerminalQuickFixCommand:W.TerminalQuickFixCommand,TerminalQuickFixOpener:W.TerminalQuickFixOpener,TerminalLocation:W.TerminalLocation,TerminalProfile:W.TerminalProfile,TerminalExitReason:W.TerminalExitReason,TerminalQuickFixType:W.TerminalQuickFixType,TextDocumentSaveReason:W.TextDocumentSaveReason,TextEdit:W.TextEdit,SnippetTextEdit:W.SnippetTextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:W.TextEditorLineNumbersStyle,TextEditorRevealType:W.TextEditorRevealType,TextEditorSelectionChangeKind:W.TextEditorSelectionChangeKind,TextDocumentChangeReason:W.TextDocumentChangeReason,ThemeColor:W.ThemeColor,ThemeIcon:W.ThemeIcon,TreeItem:W.TreeItem,TreeItem2:W.TreeItem,TreeItemCheckboxState:W.TreeItemCheckboxState,TreeItemCollapsibleState:W.TreeItemCollapsibleState,TypeHierarchyItem:W.TypeHierarchyItem,UIKind:D.UIKind,Uri:I.URI,ViewColumn:W.ViewColumn,WorkspaceEdit:W.WorkspaceEdit,DocumentDropEdit:W.DocumentDropEdit,DocumentPasteEdit:W.DocumentPasteEdit,InlayHint:W.InlayHint,InlayHintLabelPart:W.InlayHintLabelPart,InlayHintKind:W.InlayHintKind,RemoteAuthorityResolverError:W.RemoteAuthorityResolverError,ResolvedAuthority:W.ResolvedAuthority,SourceControlInputBoxValidationType:W.SourceControlInputBoxValidationType,ExtensionRuntime:W.ExtensionRuntime,TimelineItem:W.TimelineItem,NotebookRange:W.NotebookRange,NotebookCellKind:W.NotebookCellKind,NotebookCellExecutionState:W.NotebookCellExecutionState,NotebookCellData:W.NotebookCellData,NotebookData:W.NotebookData,NotebookRendererScript:W.NotebookRendererScript,NotebookCellStatusBarAlignment:W.NotebookCellStatusBarAlignment,NotebookEditorRevealType:W.NotebookEditorRevealType,NotebookCellOutput:W.NotebookCellOutput,NotebookCellOutputItem:W.NotebookCellOutputItem,NotebookCellStatusBarItem:W.NotebookCellStatusBarItem,NotebookControllerAffinity:W.NotebookControllerAffinity,NotebookControllerAffinity2:W.NotebookControllerAffinity2,NotebookEdit:W.NotebookEdit,NotebookKernelSourceAction:W.NotebookKernelSourceAction,PortAttributes:W.PortAttributes,LinkedEditingRanges:W.LinkedEditingRanges,TestResultState:W.TestResultState,TestRunRequest:W.TestRunRequest,TestMessage:W.TestMessage,TestTag:W.TestTag,TestRunProfileKind:W.TestRunProfileKind,TextSearchCompleteMessageType:ht.TextSearchCompleteMessageType,DataTransfer:W.DataTransfer,DataTransferItem:W.DataTransferItem,CoveredCount:W.CoveredCount,FileCoverage:W.FileCoverage,StatementCoverage:W.StatementCoverage,BranchCoverage:W.BranchCoverage,FunctionCoverage:W.FunctionCoverage,WorkspaceTrustState:W.WorkspaceTrustState,LanguageStatusSeverity:W.LanguageStatusSeverity,QuickPickItemKind:W.QuickPickItemKind,InputBoxValidationSeverity:W.InputBoxValidationSeverity,TabInputText:W.TextTabInput,TabInputTextDiff:W.TextDiffTabInput,TabInputTextMerge:W.TextMergeTabInput,TabInputCustom:W.CustomEditorTabInput,TabInputNotebook:W.NotebookEditorTabInput,TabInputNotebookDiff:W.NotebookDiffEditorTabInput,TabInputWebview:W.WebviewEditorTabInput,TabInputTerminal:W.TerminalEditorTabInput,TabInputInteractiveWindow:W.InteractiveWindowInput,TrustedTelemetryValue:X.TrustedTelemetryValue,LogLevel:Fe.LogLevel,EditSessionIdentityMatch:gt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=lt}),define(ye[302],Ce([1,0,274,311,312,2,313]),function(ne,e,o,t,k,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function A(P,y,D,v,d,m){const h=m.environment.useHostProxy,w=typeof h=="boolean"?h:!m.remote.isRemote,g=(0,I.createProxyResolver)({resolveProxy:b=>P.resolveProxy(b),getHttpProxySetting:()=>y.getConfiguration("http").get("proxy"),log:(b,i,...s)=>{switch(b){case I.LogLevel.Trace:v.trace(i,...s);break;case I.LogLevel.Debug:v.debug(i,...s);break;case I.LogLevel.Info:v.info(i,...s);break;case I.LogLevel.Warning:v.warn(i,...s);break;case I.LogLevel.Error:v.error(i,...s);break;case I.LogLevel.Critical:v.error(i,...s);break;case I.LogLevel.Off:break;default:a(b,i,s);break}function a(u,c,...l){v.error("Unknown log level",u),v.error(c,...l)}},getLogLevel:()=>v.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:w,env:process.env}),p=S(y,g);return L(D,p)}e.connectProxyResolver=A;function S(P,y){const D={config:P.getConfiguration("http").get("proxySupport")||"off"};P.onDidChangeConfiguration(d=>{D.config=P.getConfiguration("http").get("proxySupport")||"off"});const v={config:!!P.getConfiguration("http").get("systemCertificates")};return P.onDidChangeConfiguration(d=>{v.config=!!P.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},o,(0,I.createHttpPatch)(o,y,{config:"off"},v,!0)),on:Object.assign({},o,(0,I.createHttpPatch)(o,y,{config:"on"},v,!0)),override:Object.assign({},o,(0,I.createHttpPatch)(o,y,{config:"override"},v,!0)),onRequest:Object.assign({},o,(0,I.createHttpPatch)(o,y,D,v,!0)),default:Object.assign(o,(0,I.createHttpPatch)(o,y,D,v,!1))},https:{off:Object.assign({},t,(0,I.createHttpPatch)(t,y,{config:"off"},v,!0)),on:Object.assign({},t,(0,I.createHttpPatch)(t,y,{config:"on"},v,!0)),override:Object.assign({},t,(0,I.createHttpPatch)(t,y,{config:"override"},v,!0)),onRequest:Object.assign({},t,(0,I.createHttpPatch)(t,y,D,v,!0)),default:Object.assign(t,(0,I.createHttpPatch)(t,y,D,v,!1))},tls:Object.assign(k,(0,I.createTlsPatch)(k))}}const C=new Map;function L(P,y){return P.getExtensionPathIndex().then(D=>{const v=globalThis._VSCODE_NODE_MODULES.module,d=v._load;v._load=function(h,w,g){if(h==="tls")return y.tls;if(h!=="http"&&h!=="https")return d.apply(this,arguments);const p=y[h],b=D.findSubstr(R.URI.file(w.filename));let i=C.get(b);if(i||C.set(b,i={}),!i[h]){const s=p.default;i[h]={...s}}return i[h]}})}}),define(ye[303],Ce([1,0,77,301,288,302,41,276,2,15,7,273,114,275]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class v extends k.RequireInterceptor{j(){const h=this,w=globalThis._VSCODE_NODE_MODULES.module,g=w._load;w._load=function(s,a,u){return s=b(s),h.a.has(s)?h.a.get(s).load(s,S.URI.file((0,y.realpathSync)(a.filename)),c=>g.apply(this,[c,a,u])):g.apply(this,arguments)};const p=w._resolveLookupPaths;w._resolveLookupPaths=(i,s)=>p.call(this,b(i),s);const b=i=>{for(const s of h.b){const a=s(i);if(a){i=a;break}}return i}}}class d extends I.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=L.ExtensionRuntime.Node}async nb(){this.h.createInstance(D.ExtHostConsoleForwarder);const h=this.h.invokeFunction(t.createApiFactoryAndRegisterActors);if(this.h.createInstance(A.ExtHostDownloadService),this.f.remote.isRemote&&this.f.remote.authority){const p=this.h.createInstance(P.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=p.ipcHandlePath}await this.h.createInstance(v,h,{mine:this.D,all:this.F}).install(),o.mark("code/extHost/didInitAPI");const g=await this.k.getConfigProvider();await(0,R.connectProxyResolver)(this.j,g,this,this.l,this.u,this.f),o.mark("code/extHost/didInitProxyResolver")}ob(h){return h.main}async pb(h,w,g){if(w.scheme!==C.Schemas.file)throw new Error(`Cannot load URI: '${w}', must be of file-scheme`);let p=null;g.codeLoadingStart(),this.l.trace(`ExtensionService#loadCommonJSModule ${w.toString(!0)}`),this.l.flush();const b=h?.identifier.value;h&&await this.s.initializeLocalizedMessages(h);try{b&&o.mark(`code/extHost/willLoadExtensionCode/${b}`),p=ne.__$__nodeRequire(w.fsPath)}finally{b&&o.mark(`code/extHost/didLoadExtensionCode/${b}`),g.codeLoadingStop()}return p}async $setRemoteEnvironment(h){if(!!this.f.remote.isRemote)for(const w in h){const g=h[w];g===null?delete process.env[w]:process.env[w]=g}}}e.ExtHostExtensionService=d}),define(ye[145],Ce([1,0,45,314,297,18,81,37,9,8,2,31,75,315,295,99]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y,D,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const m=v.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class h{constructor(f){this.a=f}provideTextSearchResults(f,E,T,M){return this.a.appendLine(`provideTextSearchResults ${f.pattern}, ${JSON.stringify({...E,folder:E.folder.toString()})}`),new Promise((G,V)=>{M.onCancellationRequested(()=>q());const N=s(f,E),U=E.folder.fsPath,F=N.map(te=>te.match(/^-/)?te:`'${te}'`).join(" ");this.a.appendLine(`${m} ${F}
 - cwd: ${U}`);let z=o.spawn(m,N,{cwd:U});z.on("error",te=>{console.error(te),this.a.appendLine("Error: "+(te&&te.message)),V((0,P.serializeSearchError)(new P.SearchError(te&&te.message,P.SearchErrorCode.rgProcessError)))});let B=!1;const W=new p(E.maxResults,U,E.previewOptions);W.on("result",te=>{B=!0,Q="",T.report(te)});let X=!1;const q=()=>{X=!0,z?.kill(),W?.cancel()};let _=!1;W.on("hitLimit",()=>{_=!0,q()});let Q="";z.stdout.on("data",te=>{W.handleData(te),B||(Q+=te)});let Z=!1;z.stdout.once("data",()=>Z=!0);let ge="";z.stderr.on("data",te=>{const J=te.toString();this.a.appendLine(J),ge.length+J.length<1e6&&(ge+=J)}),z.on("close",()=>{if(this.a.appendLine(Z?"Got data from stdout":"No data from stdout"),this.a.appendLine(B?"Got result from parser":"No result from parser"),Q&&this.a.appendLine(`Got data without result: ${Q}`),this.a.appendLine(""),X)G({limitHit:_});else{W.flush(),z=null;let te;ge&&!Z&&(te=w(ge))?V((0,P.serializeSearchError)(new P.SearchError(te.message,te.code))):G({limitHit:_})}})})}}e.RipgrepTextSearchEngine=h;function w(r){const f=r.split(`
`),E=f[0].trim();if(f.some(M=>M.startsWith("regex parse error")))return new P.SearchError(g(f),P.SearchErrorCode.regexParseError);const T=E.match(/grep config error: unknown encoding: (.*)/);if(T)return new P.SearchError(`Unknown encoding: ${T[1]}`,P.SearchErrorCode.unknownEncoding);if(E.startsWith("error parsing glob"))return new P.SearchError(E.charAt(0).toUpperCase()+E.substr(1),P.SearchErrorCode.globParseError);if(E.startsWith("the literal"))return new P.SearchError(E.charAt(0).toUpperCase()+E.substr(1),P.SearchErrorCode.invalidLiteral);if(E.startsWith("PCRE2: error compiling pattern"))return new P.SearchError(E,P.SearchErrorCode.regexParseError)}function g(r){const f=["Regex parse error"],E=r.filter(T=>T.startsWith("PCRE2:"));if(E.length>=1){const T=E[0].replace("PCRE2:","");if(T.indexOf(":")!==-1&&T.split(":").length>=2){const M=T.split(":")[1];f.push(":"+M)}}return f.join("")}class p extends t.EventEmitter{constructor(f,E,T){super(),this.g=f,this.h=E,this.j=T,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new k.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(f,E){return super.on(f,E),this}handleData(f){if(this.b)return;const E=typeof f=="string"?f:this.d.write(f);this.k(E)}k(f){let E=f.indexOf(`
`);const T=this.a+f;if(E>=0)E+=this.a.length;else{this.a=T;return}let M=0;for(;E>=0;)this.m(T.substring(M,E).trim()),M=E+1,E=T.indexOf(`
`,M);this.a=T.substring(M)}m(f){if(this.b||!f)return;let E;try{E=JSON.parse(f)}catch{throw new Error(`malformed line from rg: ${f}`)}if(E.type==="match"){const T=b(E.data.path),M=L.URI.file(S.join(this.h,T)),G=this.n(E.data,M);this.p(G),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(E.type==="context"){const T=b(E.data.path),M=L.URI.file(S.join(this.h,T));this.o(E.data,M).forEach(V=>this.p(V))}}n(f,E){const T=f.line_number-1,M=b(f.lines),G=Buffer.from(M);let V=0,N=0,U=T;f.submatches.length===0&&f.submatches.push(M.length?{start:0,end:1,match:{text:M[0]}}:{start:0,end:0,match:{text:""}});const F=(0,R.coalesce)(f.submatches.map((z,B)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const W=b(z.match),X=G.slice(V,z.start).toString(),q=i(X),_=q.numLines>0?q.lastLineLength:q.lastLineLength+N,Q=i(W),Z=q.numLines+U,ge=Q.numLines+Z,te=Q.numLines>0?Q.lastLineLength:Q.lastLineLength+_;return V=z.end,N=te,U=ge,new y.Range(Z,_,ge,te)}));return(0,d.createTextSearchResult)(E,M,F,this.j)}o(f,E){const T=b(f.lines),M=f.line_number;return T.replace(/\r?\n$/,"").split(`
`).map((G,V)=>({text:G,uri:E,lineNumber:M+V}))}p(f){this.emit("result",f)}}e.RipgrepParser=p;function b(r){return r.bytes?Buffer.from(r.bytes,"base64").toString():r.text}function i(r){const f=/\n/g;let E=0,T=-1,M;for(;M=f.exec(r);)E++,T=M.index;const G=T>=0?r.length-T-1:r.length;return{numLines:E,lastLineLength:G}}function s(r,f){const E=["--hidden"];E.push(r.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:T,otherIncludes:M}=(0,I.groupBy)(f.includes,V=>V.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(M&&M.length){const V=new Set;M.forEach(N=>{V.add(N)}),E.push("-g","!*"),V.forEach(N=>{a(N).map(d.anchorGlob).forEach(U=>{E.push("-g",U)})})}T&&T.length&&T.forEach(V=>{E.push("-g",V)}),f.excludes.map(d.anchorGlob).forEach(V=>E.push("-g",`!${V}`)),f.maxFileSize&&E.push("--max-filesize",f.maxFileSize+""),f.useIgnoreFiles?f.useParentIgnoreFiles||E.push("--no-ignore-parent"):E.push("--no-ignore"),f.followSymlinks&&E.push("--follow"),f.encoding&&f.encoding!=="utf8"&&E.push("--encoding",f.encoding),r.pattern==="--"&&(r.isRegExp=!0,r.pattern="\\-\\-"),r.isMultiline&&!r.isRegExp&&(r.pattern=(0,C.escapeRegExpCharacters)(r.pattern),r.isRegExp=!0),f.usePCRE2&&E.push("--pcre2"),E.push("--crlf"),r.isRegExp&&(r.pattern=u(r.pattern),E.push("--engine","auto"));let G;if(r.isWordMatch){const N=(0,C.createRegExp)(r.pattern,!!r.isRegExp,{wholeWord:r.isWordMatch}).source.replace(/\\\//g,"/");E.push("--regexp",N)}else if(r.isRegExp){let V=l(r.pattern);V=n(V),E.push("--regexp",V)}else G=r.pattern,E.push("--fixed-strings");return E.push("--no-config"),f.useGlobalIgnoreFiles||E.push("--no-ignore-global"),E.push("--json"),r.isMultiline&&E.push("--multiline"),f.beforeContext&&E.push("--before-context",f.beforeContext+""),f.afterContext&&E.push("--after-context",f.afterContext+""),E.push("--"),G&&E.push(G),E.push("."),E}function a(r){const f=(0,A.splitGlobAware)(r,"/");return f.map((E,T)=>f.slice(0,T+1).join("/"))}function u(r){const f=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;r.match(f);)r=r.replace(f,"$1\\x{$2}");const E=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;r.match(E);)r=r.replace(E,"$1\\x{$2}");return r}e.unicodeEscapesToPCRE2=u;const c=r=>r.type==="Assertion"&&r.kind==="lookbehind";function l(r){let f;try{f=new D.RegExpParser().parsePattern(r)}catch{return r}let E="",T=0;const M=(N,U,F)=>{E+=r.slice(T,N)+F,T=U},G=[];return new D.RegExpVisitor({onCharacterEnter(N){if(N.raw!=="\\n")return;const U=G[0];if(!U)M(N.start,N.end,"\\r?\\n");else if(!G.some(c))if(U.type==="CharacterClass")if(U.negate){const F=r.slice(U.start+2,N.start)+r.slice(N.end,U.end-1);U.parent?.type==="Quantifier"?M(U.start,U.end,F?`[^${F}]`:"."):M(U.start,U.end,"(?!\\r?\\n"+(F?`|[${F}]`:"")+")")}else{const F=r.slice(U.start+1,N.start)+r.slice(N.end,U.end-1);M(U.start,U.end,F===""?"\\r?\\n":`(?:[${F}]|\\r?\\n)`)}else U.type==="Quantifier"&&M(N.start,N.end,"(?:\\r?\\n)")},onQuantifierEnter(N){G.unshift(N)},onQuantifierLeave(){G.shift()},onCharacterClassRangeEnter(N){G.unshift(N)},onCharacterClassRangeLeave(){G.shift()},onCharacterClassEnter(N){G.unshift(N)},onCharacterClassLeave(){G.shift()},onAssertionEnter(N){c(N)&&G.push(N)},onAssertionLeave(N){G[0]===N&&G.shift()}}).visit(f),E+=r.slice(T),E}e.fixRegexNewline=l;function n(r){return r.replace(/\n/g,"\\r?\\n")}e.fixNewline=n}),define(ye[304],Ce([1,0,21,145,125,15]),function(ne,e,o,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class I{constructor(C){this.b=C,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(C,L,P,y){const D=new t.RipgrepTextSearchEngine(this.b);if(L.folder.scheme===R.Schemas.vscodeUserData){const v={...L,folder:L.folder.with({scheme:R.Schemas.file})},d=new k.Progress(m=>P.report({...m,uri:m.uri.with({scheme:L.folder.scheme})}));return this.c(y,m=>D.provideTextSearchResults(C,v,d,m))}else return this.c(y,v=>D.provideTextSearchResults(C,L,P,v))}async c(C,L){const P=A(C);this.a.add(P);const y=await L(P.token);return this.a.delete(P),y}d(){this.a.forEach(C=>C.cancel())}}e.RipgrepSearchProvider=I;function A(S){const C=new o.CancellationTokenSource;return S.onCancellationRequested(()=>C.cancel()),C}}),define(ye[305],Ce([1,0,29,145,144]),function(ne,e,o,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class R{constructor(S){this.a=S}search(S,C,L){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(D){L({message:D})}},y=new k.NativeTextSearchManager(this.a,new t.RipgrepTextSearchEngine(P),o);return new Promise((D,v)=>y.search(d=>{C(d.map(I))},S).then(d=>D({limitHit:d.limitHit,type:"success",stats:d.stats}),v))}}e.TextSearchEngineAdapter=R;function I(A){return{path:A.resource&&A.resource.fsPath,results:A.results,numMatches:(A.results||[]).reduce((S,C)=>{if(C.ranges){const L=C;return S+(Array.isArray(L.ranges)?L.ranges.length:1)}else return S+1},0)}}}),define(ye[306],Ce([1,0,18,16,10,4,110,9,42,2,38,31,296,305]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class v{constructor(p="searchProcess"){this.d=p,this.b=Object.create(null)}fileSearch(p){let b;const i=h(p),s=new R.Emitter({onDidAddFirstListener:()=>{b=(0,t.createCancelablePromise)(a=>this.doFileSearchWithEngine(y.Engine,i,u=>s.fire(u),a)),b.then(a=>s.fire(a),a=>s.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onDidRemoveLastListener:()=>{b.cancel()}});return s.event}textSearch(p){let b;const i=h(p),s=new R.Emitter({onDidAddFirstListener:()=>{b=(0,t.createCancelablePromise)(a=>this.f(i,u=>s.fire(u),a)),b.then(a=>s.fire(a),a=>s.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onDidRemoveLastListener:()=>{b.cancel()}});return s.event}f(p,b,i){return p.maxFileSize=(0,L.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new D.TextSearchEngineAdapter(p).search(i,b,b)}doFileSearch(p,b,i){return this.doFileSearchWithEngine(y.Engine,p,b,i)}doFileSearchWithEngine(p,b,i,s,a=v.a){let u=0;const c=n=>{Array.isArray(n)?(u+=n.length,i(n.map(r=>this.g(r)))):n.relativePath?(u++,i(this.g(n))):i(n)};if(b.sortByScore){let n=this.k(b,c,s);if(!n){const r=b.maxResults?Object.assign({},b,{maxResults:null}):b,f=new p(r);n=this.h(f,b,i,c,s)}return new Promise((r,f)=>{n.then(([E,T])=>{const M=T.map(G=>this.g(G));this.n(M,i,a),r(E)},f)})}const l=new p(b);return this.q(l,c,a,s).then(n=>({limitHit:n.limitHit,type:"success",stats:{detailStats:n.stats,type:this.d,fromCache:!1,resultCount:u,sortingTime:void 0}}))}g(p){return{path:p.base?(0,A.join)(p.base,p.relativePath):p.relativePath}}h(p,b,i,s,a){const u=new R.Emitter;let c=(0,t.createCancelablePromise)(n=>{let r=[];const f=E=>{Array.isArray(E)?r=E:(s(E),u.fire(E))};return this.q(p,f,-1,n).then(E=>[E,r])}),l;if(b.cacheKey){l=this.j(b.cacheKey);const n={promise:c,event:u.event,resolved:!1};l.resultsToSearchCache[b.filePattern||""]=n,c.then(()=>{n.resolved=!0},r=>{delete l.resultsToSearchCache[b.filePattern||""]}),c=this.r(c)}return c.then(([n,r])=>{const f=l?l.scorerCache:Object.create(null),E=(typeof b.maxResults!="number"||b.maxResults>0)&&S.StopWatch.create(!1);return this.l(b,r,f,a).then(T=>{const M=E?E.elapsed():-1;return[{type:"success",stats:{detailStats:n.stats,sortingTime:M,fromCache:!1,type:this.d,workspaceFolderCount:b.folderQueries.length,resultCount:T.length},messages:n.messages,limitHit:n.limitHit||typeof b.maxResults=="number"&&r.length>b.maxResults},T]})})}j(p){const b=this.b[p];return b||(this.b[p]=new d)}k(p,b,i){const s=p.cacheKey&&this.b[p.cacheKey];if(!s)return;const a=this.o(s,p.filePattern||"",b,i);if(a)return a.then(([u,c,l])=>{const n=S.StopWatch.create(!1);return this.l(p,c,s.scorerCache,i).then(r=>{const f=n.elapsed(),E={fromCache:!0,detailStats:l,type:this.d,resultCount:c.length,sortingTime:f};return[{type:"success",limitHit:u.limitHit||typeof p.maxResults=="number"&&c.length>p.maxResults,stats:E},r]})})}l(p,b,i,s){const a=(0,I.prepareQuery)(p.filePattern||""),u=(l,n)=>(0,I.compareItemsByFuzzyScore)(l,n,a,!0,m,i),c=typeof p.maxResults=="number"?p.maxResults:Number.MAX_VALUE;return o.topAsync(b,u,c,1e4,s)}n(p,b,i){if(i&&i>0)for(let s=0;s<p.length;s+=i)b(p.slice(s,s+i));else b(p)}o(p,b,i,s){const a=S.StopWatch.create(!1),u=b.indexOf(A.sep)>=0;let c;for(const f in p.resultsToSearchCache)if(b.startsWith(f)){if(u&&f.indexOf(A.sep)<0&&f!=="")continue;const E=p.resultsToSearchCache[f];c={promise:this.r(E.promise),event:E.event,resolved:E.resolved};break}if(!c)return null;const l=a.elapsed(),n=S.StopWatch.create(!1),r=c.event(i);return s&&s.onCancellationRequested(()=>{r.dispose()}),c.promise.then(([f,E])=>{if(s&&s.isCancellationRequested)throw(0,k.canceled)();const T=[],M=(0,I.prepareQuery)(b).normalizedLowercase;for(const G of E)!(0,P.isFilePatternMatch)(G,M)||T.push(G);return[f,T,{cacheWasResolved:c.resolved,cacheLookupTime:l,cacheFilterTime:n.elapsed(),cacheEntryCount:E.length}]})}q(p,b,i,s){return new Promise((a,u)=>{let c=[];s?.onCancellationRequested(()=>p.cancel()),p.search(l=>{l&&(i?(c.push(l),i>0&&c.length>=i&&(b(c),c=[])):b(l))},l=>{b(l)},(l,n)=>{c.length&&b(c),l?u(l):a(n)})})}clearCache(p){return delete this.b[p],Promise.resolve(void 0)}r(p){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(b,i){return p.then(b,i)}catch(b){return this.then(void 0,b)}finally(b){return p.finally(b)}}}}e.SearchService=v,v.a=512;class d{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const m=new class{getItemLabel(g){return(0,A.basename)(g.relativePath)}getItemDescription(g){return(0,A.dirname)(g.relativePath)}getItemPath(g){return g.relativePath}};function h(g){return{...g,folderQueries:g.folderQueries&&g.folderQueries.map(w),extraFileResources:g.extraFileResources&&g.extraFileResources.map(p=>C.URI.revive(p))}}function w(g){return{...g,folder:C.URI.revive(g.folder)}}}),define(ye[307],Ce([1,0,6,15,2,29,13,25,17,79,55,31,306,304,99,144]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y,D,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let m=class extends C.ExtHostSearch{constructor(w,g,p,b){super(w,p,b),this.s=R,this.t=-1,this.v=null,this.w=!1;const i=new v.OutputChannel("RipgrepSearchUD",this.n);this.registerTextSearchProvider(t.Schemas.vscodeUserData,new D.RipgrepSearchProvider(i)),g.remote.isRemote&&g.remote.authority&&this.x()}$enableExtensionHostSearch(){this.x()}x(){if(this.w)return;this.w=!0;const w=new v.OutputChannel("RipgrepSearchEH",this.n);this.registerTextSearchProvider(t.Schemas.file,new D.RipgrepSearchProvider(w)),this.y(t.Schemas.file,new y.SearchService("fileSearchProvider"))}y(w,g){const p=this.d++;return this.v=g,this.t=p,this.c.$registerFileSearchProvider(p,this.o(w)),(0,o.toDisposable)(()=>{this.v=null,this.c.$unregisterProvider(p)})}$provideFileSearchResults(w,g,p,b){const i=(0,C.reviveQuery)(p);return w===this.t?this.z(w,g,i,b):super.$provideFileSearchResults(w,g,p,b)}z(w,g,p,b){const i=s=>{if((0,P.isSerializedFileMatch)(s)&&(s=[s]),Array.isArray(s)){this.c.$handleFileMatch(w,g,s.map(a=>k.URI.file(a.path)));return}s.message&&this.n.debug("ExtHostSearch",s.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(p,i,b)}$clearCache(w){return this.v?.clearCache(w),super.$clearCache(w)}q(w,g){return new d.NativeTextSearchManager(w,g,void 0,"textSearchProvider")}};m=qe([He(0,S.IExtHostRpcService),He(1,A.IExtHostInitDataService),He(2,L.IURITransformerService),He(3,I.ILogService)],m),e.NativeExtHostSearch=m}),define(ye[308],Ce([1,0,88,279,291,290,307,303,280,78,41,79,76,40,54,73,278,277,13,292,48]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y,D,v,d,m,h,w,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,o.registerSingleton)(L.IExtHostExtensionService,A.ExtHostExtensionService,0),(0,o.registerSingleton)(w.ILoggerService,h.ExtHostLoggerService,1),(0,o.registerSingleton)(d.IExtensionStoragePaths,m.ExtensionStoragePaths,0),(0,o.registerSingleton)(C.IExtHostDebugService,R.ExtHostDebugService,0),(0,o.registerSingleton)(P.IExtHostSearch,I.NativeExtHostSearch,0),(0,o.registerSingleton)(y.IExtHostTask,k.ExtHostTask,0),(0,o.registerSingleton)(D.IExtHostTerminalService,t.ExtHostTerminalService,0),(0,o.registerSingleton)(v.IExtHostTunnelService,S.ExtHostTunnelService,0),(0,o.registerSingleton)(p.IExtHostVariableResolverProvider,g.NodeExtHostVariableResolverProviderService,0)}),define(ye[316],Ce([1,0,219,317,77,10,117,118,200,94,289,22,29,114,16,120,215,228,293,308]),function(ne,e,o,t,k,R,I,A,S,C,L,P,y,D,v,d,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let l=0;l<process.execArgv.length;l++)process.execArgv[l]==="--inspect-port=0"&&(process.execArgv.splice(l,1),l--)}();const w=t(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const c=globalThis._VSCODE_NODE_MODULES.module,l=c._load;c._load=function(n){if(n==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return l.apply(this,arguments)}})();const g=process.exit.bind(process);function p(c){process.exit=function(l){if(c)g(l);else{const n=new Error("An extension called process.exit() and this was prevented.");console.warn(n.stack)}},process.crash=function(){const l=new Error("An extension called process.crash() and this was prevented.");console.warn(l.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let b=function(c){g()};function i(){const c=(0,h.readExtHostConnection)(process.env);if(c.type===3)return new Promise((l,n)=>{const r=f=>{const E=f[0],T=new I.BufferedEmitter;E.on("message",M=>T.fire(P.VSBuffer.wrap(M.data))),E.on("close",()=>{b("renderer closed the MessagePort")}),E.start(),l({onMessage:T.event,send:M=>E.postMessage(M.buffer)})};process?.parentPort.on("message",f=>r(f.ports))});if(c.type===2)return new Promise((l,n)=>{let r=null;const f=setTimeout(()=>{b("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),E=108e5,T=3e5,M=new v.ProcessTimeRunOnceScheduler(()=>b("renderer disconnected for too long (1)"),E),G=new v.ProcessTimeRunOnceScheduler(()=>b("renderer disconnected for too long (2)"),T);process.on("message",(N,U)=>{if(N&&N.type==="VSCODE_EXTHOST_IPC_SOCKET"){U.setNoDelay(!0);const F=P.VSBuffer.wrap(Buffer.from(N.initialDataChunk,"base64"));let z;if(N.skipWebSocketFrames)z=new A.NodeSocket(U,"extHost-socket");else{const B=P.VSBuffer.wrap(Buffer.from(N.inflateBytes,"base64"));z=new A.WebSocketNodeSocket(new A.NodeSocket(U,"extHost-socket"),N.permessageDeflate,B,!1)}r?(M.cancel(),G.cancel(),r.beginAcceptReconnection(z,F),r.endAcceptReconnection(),r.sendResume()):(clearTimeout(f),r=new I.PersistentProtocol({socket:z,initialChunk:F}),r.sendResume(),r.onDidDispose(()=>b("renderer disconnected")),l(r),r.onSocketClose(()=>{M.schedule()}))}if(N&&N.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(G.isScheduled())return;M.isScheduled()&&G.schedule()}});const V={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(V)});{const l=c.pipeName;return new Promise((n,r)=>{const f=o.createConnection(l,()=>{f.removeListener("error",r);const E=new I.PersistentProtocol({socket:new A.NodeSocket(f,"extHost-renderer")});E.sendResume(),n(E)});f.once("error",r),f.on("close",()=>{b("renderer closed the socket")})})}}async function s(){const c=await i();return new class{constructor(){this.a=new I.BufferedEmitter,this.onMessage=this.a.event,this.b=!1,c.onMessage(l=>{(0,C.isMessageOfType)(l,2)?(this.b=!0,b("received terminate message from renderer")):this.a.fire(l)})}send(l){this.b||c.send(l)}async drain(){if(c.drain)return c.drain()}}}function a(c){return new Promise(l=>{const n=c.onMessage(r=>{n.dispose();const f=JSON.parse(r.toString()),E=f.commit,T=S.default.commit;if(E&&T&&E!==T&&g(55),f.parentPid){let M=0;setInterval(function(){try{process.kill(f.parentPid,0),M=0}catch(V){V&&V.code==="EPERM"?(M++,M>=3&&b(`parent process ${f.parentPid} does not exist anymore (3 x EPERM): ${V.message} (code: ${V.code}) (errno: ${V.errno})`)):b(`parent process ${f.parentPid} does not exist anymore: ${V.message} (code: ${V.code}) (errno: ${V.errno})`)}},1e3);let G;try{G=globalThis._VSCODE_NODE_MODULES["native-watchdog"],G.start(f.parentPid)}catch(V){(0,R.onUnexpectedError)(V)}}c.send((0,C.createMessageOfType)(0)),l({protocol:c,initData:f})});c.send((0,C.createMessageOfType)(1))})}async function u(){const c=[];process.on("unhandledRejection",(M,G)=>{c.push(G),setTimeout(()=>{const V=c.indexOf(G);V>=0&&G.catch(N=>{c.splice(V,1),(0,R.isCancellationError)(N)||(console.warn(`rejected promise not handled within 1 second: ${N}`),N&&N.stack&&console.warn(`stack trace: ${N.stack}`),M&&(0,R.onUnexpectedError)(M))})},1e3)}),process.on("rejectionHandled",M=>{const G=c.indexOf(M);G>=0&&c.splice(G,1)}),process.on("uncaughtException",function(M){(0,R.onUnexpectedError)(M)}),k.mark("code/extHost/willConnectToRenderer");const l=await s();k.mark("code/extHost/didConnectToRenderer");const n=await a(l);k.mark("code/extHost/didWaitForInitData");const{initData:r}=n;p(!!r.environment.extensionTestsLocationURI),r.environment.useHostProxy=w.useHostProxy!==void 0?w.useHostProxy!=="false":void 0,r.environment.skipWorkspaceStorageLock=(0,d.boolean)(w.skipWorkspaceStorageLock,!1);const f=new class{constructor(){this.pid=process.pid}exit(G){g(G)}exists(G){return y.Promises.exists(G)}realpath(G){return(0,D.realpath)(G)}};let E=null;r.remote.authority&&w.transformURIs&&(E=(0,m.createURITransformer)(r.remote.authority));const T=new L.ExtensionHostMain(n.protocol,r,f,E);b=M=>T.terminate(M)}u().catch(c=>console.log(c))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/42814d18a7d46adfb1c24e1349b7ab18833ec6ac/core/vs/workbench/api/node/extensionHostProcess.js.map
