/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/strings","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/network","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/base/common/buffer","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/errorMessage","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/extHostTunnelService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/base/common/stopwatch","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/idGenerator","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/lazy","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/base/common/hash","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ce=function(ee){for(var e=[],i=0,T=ee.length;i<T;i++)e[i]=ke[ee[i]];return e};define(ke[80],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function i(k,O){const S=Object.create(null);for(const C of k){const N=O(C);let D=S[N];D||(D=S[N]=[]),D.push(C)}return S}e.groupBy=i;function T(k,O){const S=[],C=[];for(const N of k)O.has(N)||S.push(N);for(const N of O)k.has(N)||C.push(N);return{removed:S,added:C}}e.diffSets=T;function y(k,O){const S=[],C=[];for(const[N,D]of k)O.has(N)||S.push(D);for(const[N,D]of O)k.has(N)||C.push(D);return{removed:S,added:C}}e.diffMaps=y;class L{constructor(){this.a=new Map}add(O,S){let C=this.a.get(O);C||(C=new Set,this.a.set(O,C)),C.add(S)}delete(O,S){const C=this.a.get(O);!C||(C.delete(S),C.size===0&&this.a.delete(O))}forEach(O,S){const C=this.a.get(O);!C||C.forEach(S)}}e.SetMap=L}),define(ke[61],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function i(k){return(O,S,C)=>{let N=null,D=null;if(typeof C.value=="function"?(N="value",D=C.value):typeof C.get=="function"&&(N="get",D=C.get),!D)throw new Error("not supported");C[N]=k(D,S)}}function T(k,O,S){let C=null,N=null;if(typeof S.value=="function"?(C="value",N=S.value,N.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(C="get",N=S.get),!N)throw new Error("not supported");const D=`$memoize$${O}`;S[C]=function(...m){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:N.apply(this,m)}),this[D]}}e.memoize=T;function y(k,O,S){return i((C,N)=>{const D=`$debounce$${N}`,m=`$debounce$result$${N}`;return function(...p){this[m]||(this[m]=S?S():void 0),clearTimeout(this[D]),O&&(this[m]=O(this[m],...p),p=[this[m]]),this[D]=setTimeout(()=>{C.apply(this,p),this[m]=S?S():void 0},k)}})}e.debounce=y;function L(k,O,S){return i((C,N)=>{const D=`$throttle$timer$${N}`,m=`$throttle$result$${N}`,p=`$throttle$lastRun$${N}`,f=`$throttle$pending$${N}`;return function(...t){if(this[m]||(this[m]=S?S():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),O&&(this[m]=O(this[m],...t)),this[f])return;const c=this[p]+k;c<=Date.now()?(this[p]=Date.now(),C.apply(this,[this[m]]),this[m]=S?S():void 0):(this[f]=!0,this[D]=setTimeout(()=>{this[f]=!1,this[p]=Date.now(),C.apply(this,[this[m]]),this[m]=S?S():void 0},c-Date.now()))}})}e.throttle=L}),define(ke[81],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class i{constructor(y){this.a=y,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=i,e.defaultGenerator=new i("id#")}),define(ke[109],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var i;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(i=e.ScanError||(e.ScanError={}));var T;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(T=e.SyntaxKind||(e.SyntaxKind={}));var y;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(y=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(r){r.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function k(r,a=!1){let o=0;const d=r.length;let s="",u=0,n=16,h=0;function g(R){let F=0,B=0;for(;F<R;){const z=r.charCodeAt(o);if(z>=48&&z<=57)B=B*16+z-48;else if(z>=65&&z<=70)B=B*16+z-65+10;else if(z>=97&&z<=102)B=B*16+z-97+10;else break;o++,F++}return F<R&&(B=-1),B}function P(R){o=R,s="",u=0,n=16,h=0}function M(){const R=o;if(r.charCodeAt(o)===48)o++;else for(o++;o<r.length&&C(r.charCodeAt(o));)o++;if(o<r.length&&r.charCodeAt(o)===46)if(o++,o<r.length&&C(r.charCodeAt(o)))for(o++;o<r.length&&C(r.charCodeAt(o));)o++;else return h=3,r.substring(R,o);let F=o;if(o<r.length&&(r.charCodeAt(o)===69||r.charCodeAt(o)===101))if(o++,(o<r.length&&r.charCodeAt(o)===43||r.charCodeAt(o)===45)&&o++,o<r.length&&C(r.charCodeAt(o))){for(o++;o<r.length&&C(r.charCodeAt(o));)o++;F=o}else h=3;return r.substring(R,F)}function j(){let R="",F=o;for(;;){if(o>=d){R+=r.substring(F,o),h=2;break}const B=r.charCodeAt(o);if(B===34){R+=r.substring(F,o),o++;break}if(B===92){if(R+=r.substring(F,o),o++,o>=d){h=2;break}switch(r.charCodeAt(o++)){case 34:R+='"';break;case 92:R+="\\";break;case 47:R+="/";break;case 98:R+="\b";break;case 102:R+="\f";break;case 110:R+=`
`;break;case 114:R+="\r";break;case 116:R+="	";break;case 117:{const V=g(4);V>=0?R+=String.fromCharCode(V):h=4;break}default:h=5}F=o;continue}if(B>=0&&B<=31)if(S(B)){R+=r.substring(F,o),h=2;break}else h=6;o++}return R}function Z(){if(s="",h=0,u=o,o>=d)return u=d,n=17;let R=r.charCodeAt(o);if(O(R)){do o++,s+=String.fromCharCode(R),R=r.charCodeAt(o);while(O(R));return n=15}if(S(R))return o++,s+=String.fromCharCode(R),R===13&&r.charCodeAt(o)===10&&(o++,s+=`
`),n=14;switch(R){case 123:return o++,n=1;case 125:return o++,n=2;case 91:return o++,n=3;case 93:return o++,n=4;case 58:return o++,n=6;case 44:return o++,n=5;case 34:return o++,s=j(),n=10;case 47:{const F=o-1;if(r.charCodeAt(o+1)===47){for(o+=2;o<d&&!S(r.charCodeAt(o));)o++;return s=r.substring(F,o),n=12}if(r.charCodeAt(o+1)===42){o+=2;const B=d-1;let z=!1;for(;o<B;){if(r.charCodeAt(o)===42&&r.charCodeAt(o+1)===47){o+=2,z=!0;break}o++}return z||(o++,h=1),s=r.substring(F,o),n=13}return s+=String.fromCharCode(R),o++,n=16}case 45:if(s+=String.fromCharCode(R),o++,o===d||!C(r.charCodeAt(o)))return n=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=M(),n=11;default:for(;o<d&&G(R);)o++,R=r.charCodeAt(o);if(u!==o){switch(s=r.substring(u,o),s){case"true":return n=8;case"false":return n=9;case"null":return n=7}return n=16}return s+=String.fromCharCode(R),o++,n=16}}function G(R){if(O(R)||S(R))return!1;switch(R){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function A(){let R;do R=Z();while(R>=12&&R<=15);return R}return{setPosition:P,getPosition:()=>o,scan:a?A:Z,getToken:()=>n,getTokenValue:()=>s,getTokenOffset:()=>u,getTokenLength:()=>o-u,getTokenError:()=>h}}e.createScanner=k;function O(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function S(r){return r===10||r===13||r===8232||r===8233}function C(r){return r>=48&&r<=57}var N;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(N||(N={}));function D(r,a){const o=[],d=new Object;let s;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let n=!1;function h(g,P,M,j){u.value=g,u.offset=P,u.length=M,u.type=j,u.colonOffset=void 0,s=u}try{b(r,{onObjectBegin:(g,P)=>{if(a<=g)throw d;s=void 0,n=a>g,o.push("")},onObjectProperty:(g,P,M)=>{if(a<P||(h(g,P,M,"property"),o[o.length-1]=g,a<=P+M))throw d},onObjectEnd:(g,P)=>{if(a<=g)throw d;s=void 0,o.pop()},onArrayBegin:(g,P)=>{if(a<=g)throw d;s=void 0,o.push(0)},onArrayEnd:(g,P)=>{if(a<=g)throw d;s=void 0,o.pop()},onLiteralValue:(g,P,M)=>{if(a<P||(h(g,P,M,w(g)),a<=P+M))throw d},onSeparator:(g,P,M)=>{if(a<=P)throw d;if(g===":"&&s&&s.type==="property")s.colonOffset=P,n=!1,s=void 0;else if(g===","){const j=o[o.length-1];typeof j=="number"?o[o.length-1]=j+1:(n=!0,o[o.length-1]=""),s=void 0}}})}catch(g){if(g!==d)throw g}return{path:o,previousNode:s,isAtPropertyKey:n,matches:g=>{let P=0;for(let M=0;P<g.length&&M<o.length;M++)if(g[P]===o[M]||g[P]==="*")P++;else if(g[P]!=="**")return!1;return P===g.length}}}e.getLocation=D;function m(r,a=[],o=L.DEFAULT){let d=null,s=[];const u=[];function n(g){Array.isArray(s)?s.push(g):d!==null&&(s[d]=g)}return b(r,{onObjectBegin:()=>{const g={};n(g),u.push(s),s=g,d=null},onObjectProperty:g=>{d=g},onObjectEnd:()=>{s=u.pop()},onArrayBegin:()=>{const g=[];n(g),u.push(s),s=g,d=null},onArrayEnd:()=>{s=u.pop()},onLiteralValue:n,onError:(g,P,M)=>{a.push({error:g,offset:P,length:M})}},o),s[0]}e.parse=m;function p(r,a=[],o=L.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(g){d.type==="property"&&(d.length=g-d.offset,d=d.parent)}function u(g){return d.children.push(g),g}b(r,{onObjectBegin:g=>{d=u({type:"object",offset:g,length:-1,parent:d,children:[]})},onObjectProperty:(g,P,M)=>{d=u({type:"property",offset:P,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:g,offset:P,length:M,parent:d})},onObjectEnd:(g,P)=>{d.length=g+P-d.offset,d=d.parent,s(g+P)},onArrayBegin:(g,P)=>{d=u({type:"array",offset:g,length:-1,parent:d,children:[]})},onArrayEnd:(g,P)=>{d.length=g+P-d.offset,d=d.parent,s(g+P)},onLiteralValue:(g,P,M)=>{u({type:w(g),offset:P,length:M,parent:d,value:g}),s(P+M)},onSeparator:(g,P,M)=>{d.type==="property"&&(g===":"?d.colonOffset=P:g===","&&s(P))},onError:(g,P,M)=>{a.push({error:g,offset:P,length:M})}},o);const h=d.children[0];return h&&delete h.parent,h}e.parseTree=p;function f(r,a){if(!r)return;let o=r;for(const d of a)if(typeof d=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let s=!1;for(const u of o.children)if(Array.isArray(u.children)&&u.children[0].value===d){o=u.children[1],s=!0;break}if(!s)return}else{const s=d;if(o.type!=="array"||s<0||!Array.isArray(o.children)||s>=o.children.length)return;o=o.children[s]}return o}e.findNodeAtLocation=f;function t(r){if(!r.parent||!r.parent.children)return[];const a=t(r.parent);if(r.parent.type==="property"){const o=r.parent.children[0].value;a.push(o)}else if(r.parent.type==="array"){const o=r.parent.children.indexOf(r);o!==-1&&a.push(o)}return a}e.getNodePath=t;function c(r){switch(r.type){case"array":return r.children.map(c);case"object":{const a=Object.create(null);for(const o of r.children){const d=o.children[1];d&&(a[o.children[0].value]=c(d))}return a}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=c;function l(r,a,o=!1){return a>=r.offset&&a<r.offset+r.length||o&&a===r.offset+r.length}e.contains=l;function v(r,a,o=!1){if(l(r,a,o)){const d=r.children;if(Array.isArray(d))for(let s=0;s<d.length&&d[s].offset<=a;s++){const u=v(d[s],a,o);if(u)return u}return r}}e.findNodeAtOffset=v;function b(r,a,o=L.DEFAULT){const d=k(r,!1);function s(De){return De?()=>De(d.getTokenOffset(),d.getTokenLength()):()=>!0}function u(De){return De?re=>De(re,d.getTokenOffset(),d.getTokenLength()):()=>!0}const n=s(a.onObjectBegin),h=u(a.onObjectProperty),g=s(a.onObjectEnd),P=s(a.onArrayBegin),M=s(a.onArrayEnd),j=u(a.onLiteralValue),Z=u(a.onSeparator),G=s(a.onComment),A=u(a.onError),R=o&&o.disallowComments,F=o&&o.allowTrailingComma;function B(){for(;;){const De=d.scan();switch(d.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:R||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(De){case 12:case 13:R?z(10):G();break;case 16:z(1);break;case 15:case 14:break;default:return De}}}function z(De,re=[],Q=[]){if(A(De),re.length+Q.length>0){let le=d.getToken();for(;le!==17;){if(re.indexOf(le)!==-1){B();break}else if(Q.indexOf(le)!==-1)break;le=B()}}}function V(De){const re=d.getTokenValue();return De?j(re):h(re),B(),!0}function K(){switch(d.getToken()){case 11:{let De=0;try{De=JSON.parse(d.getTokenValue()),typeof De!="number"&&(z(2),De=0)}catch{z(2)}j(De);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return B(),!0}function ie(){return d.getToken()!==10?(z(3,[],[2,5]),!1):(V(!1),d.getToken()===6?(Z(":"),B(),oe()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function me(){n(),B();let De=!1;for(;d.getToken()!==2&&d.getToken()!==17;){if(d.getToken()===5){if(De||z(4,[],[]),Z(","),B(),d.getToken()===2&&F)break}else De&&z(6,[],[]);ie()||z(4,[],[2,5]),De=!0}return g(),d.getToken()!==2?z(7,[2],[]):B(),!0}function ue(){P(),B();let De=!1;for(;d.getToken()!==4&&d.getToken()!==17;){if(d.getToken()===5){if(De||z(4,[],[]),Z(","),B(),d.getToken()===4&&F)break}else De&&z(6,[],[]);oe()||z(4,[],[4,5]),De=!0}return M(),d.getToken()!==4?z(8,[4],[]):B(),!0}function oe(){switch(d.getToken()){case 3:return ue();case 1:return me();case 10:return V(!0);default:return K()}}return B(),d.getToken()===17?o.allowEmptyContent?!0:(z(4,[],[]),!1):oe()?(d.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=b;function E(r,a){const o=k(r),d=[];let s,u=0,n;do switch(n=o.getPosition(),s=o.scan(),s){case 12:case 13:case 17:u!==n&&d.push(r.substring(u,n)),a!==void 0&&d.push(o.getTokenValue().replace(/[^\r\n]/g,a)),u=o.getPosition();break}while(s!==17);return d.join("")}e.stripComments=E;function w(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=w}),define(ke[28],Ce([1,0]),function(ee,e){"use strict";var i,T,y;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function L(f,t,c){let l=f.get(t);return l===void 0&&(l=c,f.set(t,l)),l}e.getOrSet=L;function k(f){const t=[];return f.forEach((c,l)=>{t.push(`${l} => ${c}`)}),`Map(${f.size}) {${t.join(", ")}}`}e.mapToString=k;function O(f){const t=[];return f.forEach(c=>{t.push(c)}),`Set(${f.size}) {${t.join(", ")}}`}e.setToString=O;class S{constructor(t,c){this.uri=t,this.value=c}}class C{constructor(t,c){this[i]="ResourceMap",t instanceof C?(this.b=new Map(t.b),this.c=c??C.a):(this.b=new Map,this.c=t??C.a)}set(t,c){return this.b.set(this.c(t),new S(t,c)),this}get(t){return this.b.get(this.c(t))?.value}has(t){return this.b.has(this.c(t))}get size(){return this.b.size}clear(){this.b.clear()}delete(t){return this.b.delete(this.c(t))}forEach(t,c){typeof c<"u"&&(t=t.bind(c));for(const[l,v]of this.b)t(v.value,v.uri,this)}*values(){for(const t of this.b.values())yield t.value}*keys(){for(const t of this.b.values())yield t.uri}*entries(){for(const t of this.b.values())yield[t.uri,t.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.b)yield[t.uri,t.value]}}e.ResourceMap=C,C.a=f=>f.toString();class N{constructor(t,c){this[T]="ResourceSet",!t||typeof t=="function"?this.a=new C(t):(this.a=new C(c),t.forEach(this.add,this))}get size(){return this.a.size}add(t){return this.a.set(t,t),this}clear(){this.a.clear()}delete(t){return this.a.delete(t)}forEach(t,c){this.a.forEach((l,v)=>t.call(c,v,v,this))}has(t){return this.a.has(t)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=N;var D;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(D=e.Touch||(e.Touch={}));class m{constructor(){this[y]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(t){return this.a.has(t)}get(t,c=0){const l=this.a.get(t);if(!!l)return c!==0&&this.j(l,c),l.value}set(t,c,l=0){let v=this.a.get(t);if(v)v.value=c,l!==0&&this.j(v,l);else{switch(v={key:t,value:c,next:void 0,previous:void 0},l){case 0:this.h(v);break;case 1:this.g(v);break;case 2:this.h(v);break;default:this.h(v);break}this.a.set(t,v),this.d++}return this}delete(t){return!!this.remove(t)}remove(t){const c=this.a.get(t);if(!!c)return this.a.delete(t),this.i(c),this.d--,c.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const t=this.b;return this.a.delete(t.key),this.i(t),this.d--,t.value}forEach(t,c){const l=this.e;let v=this.b;for(;v;){if(c?t.bind(c)(v.value,v.key,this):t(v.value,v.key,this),this.e!==l)throw new Error("LinkedMap got modified during iteration.");v=v.next}}keys(){const t=this,c=this.e;let l=this.b;const v={[Symbol.iterator](){return v},next(){if(t.e!==c)throw new Error("LinkedMap got modified during iteration.");if(l){const b={value:l.key,done:!1};return l=l.next,b}else return{value:void 0,done:!0}}};return v}values(){const t=this,c=this.e;let l=this.b;const v={[Symbol.iterator](){return v},next(){if(t.e!==c)throw new Error("LinkedMap got modified during iteration.");if(l){const b={value:l.value,done:!1};return l=l.next,b}else return{value:void 0,done:!0}}};return v}entries(){const t=this,c=this.e;let l=this.b;const v={[Symbol.iterator](){return v},next(){if(t.e!==c)throw new Error("LinkedMap got modified during iteration.");if(l){const b={value:[l.key,l.value],done:!1};return l=l.next,b}else return{value:void 0,done:!0}}};return v}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(t){if(t>=this.size)return;if(t===0){this.clear();return}let c=this.b,l=this.size;for(;c&&l>t;)this.a.delete(c.key),c=c.next,l--;this.b=c,this.d=l,c&&(c.previous=void 0),this.e++}g(t){if(!this.b&&!this.c)this.c=t;else if(this.b)t.next=this.b,this.b.previous=t;else throw new Error("Invalid list");this.b=t,this.e++}h(t){if(!this.b&&!this.c)this.b=t;else if(this.c)t.previous=this.c,this.c.next=t;else throw new Error("Invalid list");this.c=t,this.e++}i(t){if(t===this.b&&t===this.c)this.b=void 0,this.c=void 0;else if(t===this.b){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.b=t.next}else if(t===this.c){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.c=t.previous}else{const c=t.next,l=t.previous;if(!c||!l)throw new Error("Invalid list");c.previous=l,l.next=c}t.next=void 0,t.previous=void 0,this.e++}j(t,c){if(!this.b||!this.c)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(t===this.b)return;const l=t.next,v=t.previous;t===this.c?(v.next=void 0,this.c=v):(l.previous=v,v.next=l),t.previous=void 0,t.next=this.b,this.b.previous=t,this.b=t,this.e++}else if(c===2){if(t===this.c)return;const l=t.next,v=t.previous;t===this.b?(l.previous=void 0,this.b=l):(l.previous=v,v.next=l),t.next=void 0,t.previous=this.c,this.c.next=t,this.c=t,this.e++}}}toJSON(){const t=[];return this.forEach((c,l)=>{t.push([l,c])}),t}fromJSON(t){this.clear();for(const[c,l]of t)this.set(c,l)}}e.LinkedMap=m;class p extends m{constructor(t,c=1){super(),this.k=t,this.l=Math.min(Math.max(0,c),1)}get limit(){return this.k}set limit(t){this.k=t,this.m()}get ratio(){return this.l}set ratio(t){this.l=Math.min(Math.max(0,t),1),this.m()}get(t,c=2){return super.get(t,c)}peek(t){return super.get(t,0)}set(t,c){return super.set(t,c,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=p}),function(ee,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(ke[110],Ce([0]),e):(ee=typeof globalThis<"u"?globalThis:ee||self,e(ee.marked={}))}(this,function(ee){"use strict";function e(Te,Ie){for(var Se=0;Se<Ie.length;Se++){var se=Ie[Se];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(Te,se.key,se)}}function i(Te,Ie,Se){return Ie&&e(Te.prototype,Ie),Se&&e(Te,Se),Object.defineProperty(Te,"prototype",{writable:!1}),Te}function T(Te,Ie){if(!!Te){if(typeof Te=="string")return y(Te,Ie);var Se=Object.prototype.toString.call(Te).slice(8,-1);if(Se==="Object"&&Te.constructor&&(Se=Te.constructor.name),Se==="Map"||Se==="Set")return Array.from(Te);if(Se==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Se))return y(Te,Ie)}}function y(Te,Ie){(Ie==null||Ie>Te.length)&&(Ie=Te.length);for(var Se=0,se=new Array(Ie);Se<Ie;Se++)se[Se]=Te[Se];return se}function L(Te,Ie){var Se=typeof Symbol<"u"&&Te[Symbol.iterator]||Te["@@iterator"];if(Se)return(Se=Se.call(Te)).next.bind(Se);if(Array.isArray(Te)||(Se=T(Te))||Ie&&Te&&typeof Te.length=="number"){Se&&(Te=Se);var se=0;return function(){return se>=Te.length?{done:!0}:{done:!1,value:Te[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function k(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ee.defaults=k();function O(Te){ee.defaults=Te}var S=/[&<>"']/,C=/[&<>"']/g,N=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(Ie){return m[Ie]};function f(Te,Ie){if(Ie){if(S.test(Te))return Te.replace(C,p)}else if(N.test(Te))return Te.replace(D,p);return Te}var t=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function c(Te){return Te.replace(t,function(Ie,Se){return Se=Se.toLowerCase(),Se==="colon"?":":Se.charAt(0)==="#"?Se.charAt(1)==="x"?String.fromCharCode(parseInt(Se.substring(2),16)):String.fromCharCode(+Se.substring(1)):""})}var l=/(^|[^\[])\^/g;function v(Te,Ie){Te=typeof Te=="string"?Te:Te.source,Ie=Ie||"";var Se={replace:function(ce,Y){return Y=Y.source||Y,Y=Y.replace(l,"$1"),Te=Te.replace(ce,Y),Se},getRegex:function(){return new RegExp(Te,Ie)}};return Se}var b=/[^\w:]/g,E=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function w(Te,Ie,Se){if(Te){var se;try{se=decodeURIComponent(c(Se)).replace(b,"").toLowerCase()}catch{return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}Ie&&!E.test(Se)&&(Se=s(Ie,Se));try{Se=encodeURI(Se).replace(/%25/g,"%")}catch{return null}return Se}var r={},a=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,d=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(Te,Ie){r[" "+Te]||(a.test(Te)?r[" "+Te]=Te+"/":r[" "+Te]=g(Te,"/",!0)),Te=r[" "+Te];var Se=Te.indexOf(":")===-1;return Ie.substring(0,2)==="//"?Se?Ie:Te.replace(o,"$1")+Ie:Ie.charAt(0)==="/"?Se?Ie:Te.replace(d,"$1")+Ie:Te+Ie}var u={exec:function(){}};function n(Te){for(var Ie=1,Se,se;Ie<arguments.length;Ie++){Se=arguments[Ie];for(se in Se)Object.prototype.hasOwnProperty.call(Se,se)&&(Te[se]=Se[se])}return Te}function h(Te,Ie){var Se=Te.replace(/\|/g,function(Y,I,$){for(var H=!1,q=I;--q>=0&&$[q]==="\\";)H=!H;return H?"|":" |"}),se=Se.split(/ \|/),ce=0;if(se[0].trim()||se.shift(),se.length>0&&!se[se.length-1].trim()&&se.pop(),se.length>Ie)se.splice(Ie);else for(;se.length<Ie;)se.push("");for(;ce<se.length;ce++)se[ce]=se[ce].trim().replace(/\\\|/g,"|");return se}function g(Te,Ie,Se){var se=Te.length;if(se===0)return"";for(var ce=0;ce<se;){var Y=Te.charAt(se-ce-1);if(Y===Ie&&!Se)ce++;else if(Y!==Ie&&Se)ce++;else break}return Te.slice(0,se-ce)}function P(Te,Ie){if(Te.indexOf(Ie[1])===-1)return-1;for(var Se=Te.length,se=0,ce=0;ce<Se;ce++)if(Te[ce]==="\\")ce++;else if(Te[ce]===Ie[0])se++;else if(Te[ce]===Ie[1]&&(se--,se<0))return ce;return-1}function M(Te){Te&&Te.sanitize&&!Te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function j(Te,Ie){if(Ie<1)return"";for(var Se="";Ie>1;)Ie&1&&(Se+=Te),Ie>>=1,Te+=Te;return Se+Te}function Z(Te,Ie,Se,se){var ce=Ie.href,Y=Ie.title?f(Ie.title):null,I=Te[1].replace(/\\([\[\]])/g,"$1");if(Te[0].charAt(0)!=="!"){se.state.inLink=!0;var $={type:"link",raw:Se,href:ce,title:Y,text:I,tokens:se.inlineTokens(I)};return se.state.inLink=!1,$}return{type:"image",raw:Se,href:ce,title:Y,text:f(I)}}function G(Te,Ie){var Se=Te.match(/^(\s+)(?:```)/);if(Se===null)return Ie;var se=Se[1];return Ie.split(`
`).map(function(ce){var Y=ce.match(/^\s+/);if(Y===null)return ce;var I=Y[0];return I.length>=se.length?ce.slice(se.length):ce}).join(`
`)}var A=function(){function Te(Se){this.options=Se||ee.defaults}var Ie=Te.prototype;return Ie.space=function(se){var ce=this.rules.block.newline.exec(se);if(ce&&ce[0].length>0)return{type:"space",raw:ce[0]}},Ie.code=function(se){var ce=this.rules.block.code.exec(se);if(ce){var Y=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?Y:g(Y,`
`)}}},Ie.fences=function(se){var ce=this.rules.block.fences.exec(se);if(ce){var Y=ce[0],I=G(Y,ce[3]||"");return{type:"code",raw:Y,lang:ce[2]?ce[2].trim():ce[2],text:I}}},Ie.heading=function(se){var ce=this.rules.block.heading.exec(se);if(ce){var Y=ce[2].trim();if(/#$/.test(Y)){var I=g(Y,"#");(this.options.pedantic||!I||/ $/.test(I))&&(Y=I.trim())}return{type:"heading",raw:ce[0],depth:ce[1].length,text:Y,tokens:this.lexer.inline(Y)}}},Ie.hr=function(se){var ce=this.rules.block.hr.exec(se);if(ce)return{type:"hr",raw:ce[0]}},Ie.blockquote=function(se){var ce=this.rules.block.blockquote.exec(se);if(ce){var Y=ce[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(Y,[]),text:Y}}},Ie.list=function(se){var ce=this.rules.block.list.exec(se);if(ce){var Y,I,$,H,q,J,de,we,ae,pe,ve,We,He=ce[1].trim(),tt=He.length>1,Xe={type:"list",raw:"",ordered:tt,start:tt?+He.slice(0,-1):"",loose:!1,items:[]};He=tt?"\\d{1,9}\\"+He.slice(-1):"\\"+He,this.options.pedantic&&(He=tt?He:"[*+-]");for(var et=new RegExp("^( {0,3}"+He+")((?:[	 ][^\\n]*)?(?:\\n|$))");se&&(We=!1,!(!(ce=et.exec(se))||this.rules.block.hr.test(se)));){if(Y=ce[0],se=se.substring(Y.length),we=ce[2].split(`
`,1)[0],ae=se.split(`
`,1)[0],this.options.pedantic?(H=2,ve=we.trimLeft()):(H=ce[2].search(/[^ ]/),H=H>4?1:H,ve=we.slice(H),H+=ce[1].length),J=!1,!we&&/^ *$/.test(ae)&&(Y+=ae+`
`,se=se.substring(ae.length+1),We=!0),!We)for(var it=new RegExp("^ {0,"+Math.min(3,H-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),dt=new RegExp("^ {0,"+Math.min(3,H-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Fe=new RegExp("^ {0,"+Math.min(3,H-1)+"}(?:```|~~~)"),st=new RegExp("^ {0,"+Math.min(3,H-1)+"}#");se&&(pe=se.split(`
`,1)[0],we=pe,this.options.pedantic&&(we=we.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Fe.test(we)||st.test(we)||it.test(we)||dt.test(se)));){if(we.search(/[^ ]/)>=H||!we.trim())ve+=`
`+we.slice(H);else if(!J)ve+=`
`+we;else break;!J&&!we.trim()&&(J=!0),Y+=pe+`
`,se=se.substring(pe.length+1)}Xe.loose||(de?Xe.loose=!0:/\n *\n *$/.test(Y)&&(de=!0)),this.options.gfm&&(I=/^\[[ xX]\] /.exec(ve),I&&($=I[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),Xe.items.push({type:"list_item",raw:Y,task:!!I,checked:$,loose:!1,text:ve}),Xe.raw+=Y}Xe.items[Xe.items.length-1].raw=Y.trimRight(),Xe.items[Xe.items.length-1].text=ve.trimRight(),Xe.raw=Xe.raw.trimRight();var _=Xe.items.length;for(q=0;q<_;q++){this.lexer.state.top=!1,Xe.items[q].tokens=this.lexer.blockTokens(Xe.items[q].text,[]);var X=Xe.items[q].tokens.filter(function(Me){return Me.type==="space"}),ge=X.every(function(Me){for(var $e=Me.raw.split(""),je=0,_e=L($e),nt;!(nt=_e()).done;){var wt=nt.value;if(wt===`
`&&(je+=1),je>1)return!0}return!1});!Xe.loose&&X.length&&ge&&(Xe.loose=!0,Xe.items[q].loose=!0)}return Xe}},Ie.html=function(se){var ce=this.rules.block.html.exec(se);if(ce){var Y={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};if(this.options.sanitize){var I=this.options.sanitizer?this.options.sanitizer(ce[0]):f(ce[0]);Y.type="paragraph",Y.text=I,Y.tokens=this.lexer.inline(I)}return Y}},Ie.def=function(se){var ce=this.rules.block.def.exec(se);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var Y=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Y,raw:ce[0],href:ce[2],title:ce[3]}}},Ie.table=function(se){var ce=this.rules.block.table.exec(se);if(ce){var Y={type:"table",header:h(ce[1]).map(function(de){return{text:de}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]&&ce[3].trim()?ce[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(Y.header.length===Y.align.length){Y.raw=ce[0];var I=Y.align.length,$,H,q,J;for($=0;$<I;$++)/^ *-+: *$/.test(Y.align[$])?Y.align[$]="right":/^ *:-+: *$/.test(Y.align[$])?Y.align[$]="center":/^ *:-+ *$/.test(Y.align[$])?Y.align[$]="left":Y.align[$]=null;for(I=Y.rows.length,$=0;$<I;$++)Y.rows[$]=h(Y.rows[$],Y.header.length).map(function(de){return{text:de}});for(I=Y.header.length,H=0;H<I;H++)Y.header[H].tokens=this.lexer.inline(Y.header[H].text);for(I=Y.rows.length,H=0;H<I;H++)for(J=Y.rows[H],q=0;q<J.length;q++)J[q].tokens=this.lexer.inline(J[q].text);return Y}}},Ie.lheading=function(se){var ce=this.rules.block.lheading.exec(se);if(ce)return{type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:this.lexer.inline(ce[1])}},Ie.paragraph=function(se){var ce=this.rules.block.paragraph.exec(se);if(ce){var Y=ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1];return{type:"paragraph",raw:ce[0],text:Y,tokens:this.lexer.inline(Y)}}},Ie.text=function(se){var ce=this.rules.block.text.exec(se);if(ce)return{type:"text",raw:ce[0],text:ce[0],tokens:this.lexer.inline(ce[0])}},Ie.escape=function(se){var ce=this.rules.inline.escape.exec(se);if(ce)return{type:"escape",raw:ce[0],text:f(ce[1])}},Ie.tag=function(se){var ce=this.rules.inline.tag.exec(se);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):f(ce[0]):ce[0]}},Ie.link=function(se){var ce=this.rules.inline.link.exec(se);if(ce){var Y=ce[2].trim();if(!this.options.pedantic&&/^</.test(Y)){if(!/>$/.test(Y))return;var I=g(Y.slice(0,-1),"\\");if((Y.length-I.length)%2===0)return}else{var $=P(ce[2],"()");if($>-1){var H=ce[0].indexOf("!")===0?5:4,q=H+ce[1].length+$;ce[2]=ce[2].substring(0,$),ce[0]=ce[0].substring(0,q).trim(),ce[3]=""}}var J=ce[2],de="";if(this.options.pedantic){var we=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(J);we&&(J=we[1],de=we[3])}else de=ce[3]?ce[3].slice(1,-1):"";return J=J.trim(),/^</.test(J)&&(this.options.pedantic&&!/>$/.test(Y)?J=J.slice(1):J=J.slice(1,-1)),Z(ce,{href:J&&J.replace(this.rules.inline._escapes,"$1"),title:de&&de.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},Ie.reflink=function(se,ce){var Y;if((Y=this.rules.inline.reflink.exec(se))||(Y=this.rules.inline.nolink.exec(se))){var I=(Y[2]||Y[1]).replace(/\s+/g," ");if(I=ce[I.toLowerCase()],!I||!I.href){var $=Y[0].charAt(0);return{type:"text",raw:$,text:$}}return Z(Y,I,Y[0],this.lexer)}},Ie.emStrong=function(se,ce,Y){Y===void 0&&(Y="");var I=this.rules.inline.emStrong.lDelim.exec(se);if(!!I&&!(I[3]&&Y.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var $=I[1]||I[2]||"";if(!$||$&&(Y===""||this.rules.inline.punctuation.exec(Y))){var H=I[0].length-1,q,J,de=H,we=0,ae=I[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ae.lastIndex=0,ce=ce.slice(-1*se.length+H);(I=ae.exec(ce))!=null;)if(q=I[1]||I[2]||I[3]||I[4]||I[5]||I[6],!!q){if(J=q.length,I[3]||I[4]){de+=J;continue}else if((I[5]||I[6])&&H%3&&!((H+J)%3)){we+=J;continue}if(de-=J,!(de>0)){if(J=Math.min(J,J+de+we),Math.min(H,J)%2){var pe=se.slice(1,H+I.index+J);return{type:"em",raw:se.slice(0,H+I.index+J+1),text:pe,tokens:this.lexer.inlineTokens(pe)}}var ve=se.slice(2,H+I.index+J-1);return{type:"strong",raw:se.slice(0,H+I.index+J+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},Ie.codespan=function(se){var ce=this.rules.inline.code.exec(se);if(ce){var Y=ce[2].replace(/\n/g," "),I=/[^ ]/.test(Y),$=/^ /.test(Y)&&/ $/.test(Y);return I&&$&&(Y=Y.substring(1,Y.length-1)),Y=f(Y,!0),{type:"codespan",raw:ce[0],text:Y}}},Ie.br=function(se){var ce=this.rules.inline.br.exec(se);if(ce)return{type:"br",raw:ce[0]}},Ie.del=function(se){var ce=this.rules.inline.del.exec(se);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2])}},Ie.autolink=function(se,ce){var Y=this.rules.inline.autolink.exec(se);if(Y){var I,$;return Y[2]==="@"?(I=f(this.options.mangle?ce(Y[1]):Y[1]),$="mailto:"+I):(I=f(Y[1]),$=I),{type:"link",raw:Y[0],text:I,href:$,tokens:[{type:"text",raw:I,text:I}]}}},Ie.url=function(se,ce){var Y;if(Y=this.rules.inline.url.exec(se)){var I,$;if(Y[2]==="@")I=f(this.options.mangle?ce(Y[0]):Y[0]),$="mailto:"+I;else{var H;do H=Y[0],Y[0]=this.rules.inline._backpedal.exec(Y[0])[0];while(H!==Y[0]);I=f(Y[0]),Y[1]==="www."?$="http://"+I:$=I}return{type:"link",raw:Y[0],text:I,href:$,tokens:[{type:"text",raw:I,text:I}]}}},Ie.inlineText=function(se,ce){var Y=this.rules.inline.text.exec(se);if(Y){var I;return this.lexer.state.inRawBlock?I=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):f(Y[0]):Y[0]:I=f(this.options.smartypants?ce(Y[0]):Y[0]),{type:"text",raw:Y[0],text:I}}},Te}(),R={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:u,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};R._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,R._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,R.def=v(R.def).replace("label",R._label).replace("title",R._title).getRegex(),R.bullet=/(?:[*+-]|\d{1,9}[.)])/,R.listItemStart=v(/^( *)(bull) */).replace("bull",R.bullet).getRegex(),R.list=v(R.list).replace(/bull/g,R.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+R.def.source+")").getRegex(),R._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",R._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,R.html=v(R.html,"i").replace("comment",R._comment).replace("tag",R._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),R.paragraph=v(R._paragraph).replace("hr",R.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",R._tag).getRegex(),R.blockquote=v(R.blockquote).replace("paragraph",R.paragraph).getRegex(),R.normal=n({},R),R.gfm=n({},R.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),R.gfm.table=v(R.gfm.table).replace("hr",R.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",R._tag).getRegex(),R.gfm.paragraph=v(R._paragraph).replace("hr",R.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",R.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",R._tag).getRegex(),R.pedantic=n({},R.normal,{html:v(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",R._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:u,paragraph:v(R.normal._paragraph).replace("hr",R.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",R.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var F={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:u,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:u,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};F._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",F.punctuation=v(F.punctuation).replace(/punctuation/g,F._punctuation).getRegex(),F.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,F.escapedEmSt=/\\\*|\\_/g,F._comment=v(R._comment).replace("(?:-->|$)","-->").getRegex(),F.emStrong.lDelim=v(F.emStrong.lDelim).replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimAst=v(F.emStrong.rDelimAst,"g").replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimUnd=v(F.emStrong.rDelimUnd,"g").replace(/punct/g,F._punctuation).getRegex(),F._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,F._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,F._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,F.autolink=v(F.autolink).replace("scheme",F._scheme).replace("email",F._email).getRegex(),F._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,F.tag=v(F.tag).replace("comment",F._comment).replace("attribute",F._attribute).getRegex(),F._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,F._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,F._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,F.link=v(F.link).replace("label",F._label).replace("href",F._href).replace("title",F._title).getRegex(),F.reflink=v(F.reflink).replace("label",F._label).replace("ref",R._label).getRegex(),F.nolink=v(F.nolink).replace("ref",R._label).getRegex(),F.reflinkSearch=v(F.reflinkSearch,"g").replace("reflink",F.reflink).replace("nolink",F.nolink).getRegex(),F.normal=n({},F),F.pedantic=n({},F.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:v(/^!?\[(label)\]\((.*?)\)/).replace("label",F._label).getRegex(),reflink:v(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",F._label).getRegex()}),F.gfm=n({},F.normal,{escape:v(F.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),F.gfm.url=v(F.gfm.url,"i").replace("email",F.gfm._extended_email).getRegex(),F.breaks=n({},F.gfm,{br:v(F.br).replace("{2,}","*").getRegex(),text:v(F.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function B(Te){return Te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(Te){var Ie="",Se,se,ce=Te.length;for(Se=0;Se<ce;Se++)se=Te.charCodeAt(Se),Math.random()>.5&&(se="x"+se.toString(16)),Ie+="&#"+se+";";return Ie}var V=function(){function Te(Se){this.tokens=[],this.tokens.links=Object.create(null),this.options=Se||ee.defaults,this.options.tokenizer=this.options.tokenizer||new A,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var se={block:R.normal,inline:F.normal};this.options.pedantic?(se.block=R.pedantic,se.inline=F.pedantic):this.options.gfm&&(se.block=R.gfm,this.options.breaks?se.inline=F.breaks:se.inline=F.gfm),this.tokenizer.rules=se}Te.lex=function(se,ce){var Y=new Te(ce);return Y.lex(se)},Te.lexInline=function(se,ce){var Y=new Te(ce);return Y.inlineTokens(se)};var Ie=Te.prototype;return Ie.lex=function(se){se=se.replace(/\r\n|\r/g,`
`),this.blockTokens(se,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},Ie.blockTokens=function(se,ce){var Y=this;ce===void 0&&(ce=[]),this.options.pedantic?se=se.replace(/\t/g,"    ").replace(/^ +$/gm,""):se=se.replace(/^( *)(\t+)/gm,function(de,we,ae){return we+"    ".repeat(ae.length)});for(var I,$,H,q;se;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(de){return(I=de.call({lexer:Y},se,ce))?(se=se.substring(I.raw.length),ce.push(I),!0):!1}))){if(I=this.tokenizer.space(se)){se=se.substring(I.raw.length),I.raw.length===1&&ce.length>0?ce[ce.length-1].raw+=`
`:ce.push(I);continue}if(I=this.tokenizer.code(se)){se=se.substring(I.raw.length),$=ce[ce.length-1],$&&($.type==="paragraph"||$.type==="text")?($.raw+=`
`+I.raw,$.text+=`
`+I.text,this.inlineQueue[this.inlineQueue.length-1].src=$.text):ce.push(I);continue}if(I=this.tokenizer.fences(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.heading(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.hr(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.blockquote(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.list(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.html(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.def(se)){se=se.substring(I.raw.length),$=ce[ce.length-1],$&&($.type==="paragraph"||$.type==="text")?($.raw+=`
`+I.raw,$.text+=`
`+I.raw,this.inlineQueue[this.inlineQueue.length-1].src=$.text):this.tokens.links[I.tag]||(this.tokens.links[I.tag]={href:I.href,title:I.title});continue}if(I=this.tokenizer.table(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.lheading(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(H=se,this.options.extensions&&this.options.extensions.startBlock&&function(){var de=1/0,we=se.slice(1),ae=void 0;Y.options.extensions.startBlock.forEach(function(pe){ae=pe.call({lexer:this},we),typeof ae=="number"&&ae>=0&&(de=Math.min(de,ae))}),de<1/0&&de>=0&&(H=se.substring(0,de+1))}(),this.state.top&&(I=this.tokenizer.paragraph(H))){$=ce[ce.length-1],q&&$.type==="paragraph"?($.raw+=`
`+I.raw,$.text+=`
`+I.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$.text):ce.push(I),q=H.length!==se.length,se=se.substring(I.raw.length);continue}if(I=this.tokenizer.text(se)){se=se.substring(I.raw.length),$=ce[ce.length-1],$&&$.type==="text"?($.raw+=`
`+I.raw,$.text+=`
`+I.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$.text):ce.push(I);continue}if(se){var J="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(J);break}else throw new Error(J)}}return this.state.top=!0,ce},Ie.inline=function(se,ce){return ce===void 0&&(ce=[]),this.inlineQueue.push({src:se,tokens:ce}),ce},Ie.inlineTokens=function(se,ce){var Y=this;ce===void 0&&(ce=[]);var I,$,H,q=se,J,de,we;if(this.tokens.links){var ae=Object.keys(this.tokens.links);if(ae.length>0)for(;(J=this.tokenizer.rules.inline.reflinkSearch.exec(q))!=null;)ae.includes(J[0].slice(J[0].lastIndexOf("[")+1,-1))&&(q=q.slice(0,J.index)+"["+j("a",J[0].length-2)+"]"+q.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(J=this.tokenizer.rules.inline.blockSkip.exec(q))!=null;)q=q.slice(0,J.index)+"["+j("a",J[0].length-2)+"]"+q.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(J=this.tokenizer.rules.inline.escapedEmSt.exec(q))!=null;)q=q.slice(0,J.index)+"++"+q.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;)if(de||(we=""),de=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(I=ve.call({lexer:Y},se,ce))?(se=se.substring(I.raw.length),ce.push(I),!0):!1}))){if(I=this.tokenizer.escape(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.tag(se)){se=se.substring(I.raw.length),$=ce[ce.length-1],$&&I.type==="text"&&$.type==="text"?($.raw+=I.raw,$.text+=I.text):ce.push(I);continue}if(I=this.tokenizer.link(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(I.raw.length),$=ce[ce.length-1],$&&I.type==="text"&&$.type==="text"?($.raw+=I.raw,$.text+=I.text):ce.push(I);continue}if(I=this.tokenizer.emStrong(se,q,we)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.codespan(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.br(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.del(se)){se=se.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.autolink(se,z)){se=se.substring(I.raw.length),ce.push(I);continue}if(!this.state.inLink&&(I=this.tokenizer.url(se,z))){se=se.substring(I.raw.length),ce.push(I);continue}if(H=se,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,We=se.slice(1),He=void 0;Y.options.extensions.startInline.forEach(function(tt){He=tt.call({lexer:this},We),typeof He=="number"&&He>=0&&(ve=Math.min(ve,He))}),ve<1/0&&ve>=0&&(H=se.substring(0,ve+1))}(),I=this.tokenizer.inlineText(H,B)){se=se.substring(I.raw.length),I.raw.slice(-1)!=="_"&&(we=I.raw.slice(-1)),de=!0,$=ce[ce.length-1],$&&$.type==="text"?($.raw+=I.raw,$.text+=I.text):ce.push(I);continue}if(se){var pe="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(pe);break}else throw new Error(pe)}}return ce},i(Te,null,[{key:"rules",get:function(){return{block:R,inline:F}}}]),Te}(),K=function(){function Te(Se){this.options=Se||ee.defaults}var Ie=Te.prototype;return Ie.code=function(se,ce,Y){var I=(ce||"").match(/\S*/)[0];if(this.options.highlight){var $=this.options.highlight(se,I);$!=null&&$!==se&&(Y=!0,se=$)}return se=se.replace(/\n$/,"")+`
`,I?'<pre><code class="'+this.options.langPrefix+f(I,!0)+'">'+(Y?se:f(se,!0))+`</code></pre>
`:"<pre><code>"+(Y?se:f(se,!0))+`</code></pre>
`},Ie.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},Ie.html=function(se){return se},Ie.heading=function(se,ce,Y,I){if(this.options.headerIds){var $=this.options.headerPrefix+I.slug(Y);return"<h"+ce+' id="'+$+'">'+se+"</h"+ce+`>
`}return"<h"+ce+">"+se+"</h"+ce+`>
`},Ie.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ie.list=function(se,ce,Y){var I=ce?"ol":"ul",$=ce&&Y!==1?' start="'+Y+'"':"";return"<"+I+$+`>
`+se+"</"+I+`>
`},Ie.listitem=function(se){return"<li>"+se+`</li>
`},Ie.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ie.paragraph=function(se){return"<p>"+se+`</p>
`},Ie.table=function(se,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+ce+`</table>
`},Ie.tablerow=function(se){return`<tr>
`+se+`</tr>
`},Ie.tablecell=function(se,ce){var Y=ce.header?"th":"td",I=ce.align?"<"+Y+' align="'+ce.align+'">':"<"+Y+">";return I+se+("</"+Y+`>
`)},Ie.strong=function(se){return"<strong>"+se+"</strong>"},Ie.em=function(se){return"<em>"+se+"</em>"},Ie.codespan=function(se){return"<code>"+se+"</code>"},Ie.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ie.del=function(se){return"<del>"+se+"</del>"},Ie.link=function(se,ce,Y){if(se=w(this.options.sanitize,this.options.baseUrl,se),se===null)return Y;var I='<a href="'+f(se)+'"';return ce&&(I+=' title="'+ce+'"'),I+=">"+Y+"</a>",I},Ie.image=function(se,ce,Y){if(se=w(this.options.sanitize,this.options.baseUrl,se),se===null)return Y;var I='<img src="'+se+'" alt="'+Y+'"';return ce&&(I+=' title="'+ce+'"'),I+=this.options.xhtml?"/>":">",I},Ie.text=function(se){return se},Te}(),ie=function(){function Te(){}var Ie=Te.prototype;return Ie.strong=function(se){return se},Ie.em=function(se){return se},Ie.codespan=function(se){return se},Ie.del=function(se){return se},Ie.html=function(se){return se},Ie.text=function(se){return se},Ie.link=function(se,ce,Y){return""+Y},Ie.image=function(se,ce,Y){return""+Y},Ie.br=function(){return""},Te}(),me=function(){function Te(){this.seen={}}var Ie=Te.prototype;return Ie.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ie.getNextSafeSlug=function(se,ce){var Y=se,I=0;if(this.seen.hasOwnProperty(Y)){I=this.seen[se];do I++,Y=se+"-"+I;while(this.seen.hasOwnProperty(Y))}return ce||(this.seen[se]=I,this.seen[Y]=0),Y},Ie.slug=function(se,ce){ce===void 0&&(ce={});var Y=this.serialize(se);return this.getNextSafeSlug(Y,ce.dryrun)},Te}(),ue=function(){function Te(Se){this.options=Se||ee.defaults,this.options.renderer=this.options.renderer||new K,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ie,this.slugger=new me}Te.parse=function(se,ce){var Y=new Te(ce);return Y.parse(se)},Te.parseInline=function(se,ce){var Y=new Te(ce);return Y.parseInline(se)};var Ie=Te.prototype;return Ie.parse=function(se,ce){ce===void 0&&(ce=!0);var Y="",I,$,H,q,J,de,we,ae,pe,ve,We,He,tt,Xe,et,it,dt,Fe,st,_=se.length;for(I=0;I<_;I++){if(ve=se[I],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(st=this.options.extensions.renderers[ve.type].call({parser:this},ve),st!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){Y+=st||"";continue}switch(ve.type){case"space":continue;case"hr":{Y+=this.renderer.hr();continue}case"heading":{Y+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,c(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{Y+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(ae="",we="",q=ve.header.length,$=0;$<q;$++)we+=this.renderer.tablecell(this.parseInline(ve.header[$].tokens),{header:!0,align:ve.align[$]});for(ae+=this.renderer.tablerow(we),pe="",q=ve.rows.length,$=0;$<q;$++){for(de=ve.rows[$],we="",J=de.length,H=0;H<J;H++)we+=this.renderer.tablecell(this.parseInline(de[H].tokens),{header:!1,align:ve.align[H]});pe+=this.renderer.tablerow(we)}Y+=this.renderer.table(ae,pe);continue}case"blockquote":{pe=this.parse(ve.tokens),Y+=this.renderer.blockquote(pe);continue}case"list":{for(We=ve.ordered,He=ve.start,tt=ve.loose,q=ve.items.length,pe="",$=0;$<q;$++)et=ve.items[$],it=et.checked,dt=et.task,Xe="",et.task&&(Fe=this.renderer.checkbox(it),tt?et.tokens.length>0&&et.tokens[0].type==="paragraph"?(et.tokens[0].text=Fe+" "+et.tokens[0].text,et.tokens[0].tokens&&et.tokens[0].tokens.length>0&&et.tokens[0].tokens[0].type==="text"&&(et.tokens[0].tokens[0].text=Fe+" "+et.tokens[0].tokens[0].text)):et.tokens.unshift({type:"text",text:Fe}):Xe+=Fe),Xe+=this.parse(et.tokens,tt),pe+=this.renderer.listitem(Xe,dt,it);Y+=this.renderer.list(pe,We,He);continue}case"html":{Y+=this.renderer.html(ve.text);continue}case"paragraph":{Y+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(pe=ve.tokens?this.parseInline(ve.tokens):ve.text;I+1<_&&se[I+1].type==="text";)ve=se[++I],pe+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);Y+=ce?this.renderer.paragraph(pe):pe;continue}default:{var X='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(X);return}else throw new Error(X)}}}return Y},Ie.parseInline=function(se,ce){ce=ce||this.renderer;var Y="",I,$,H,q=se.length;for(I=0;I<q;I++){if($=se[I],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[$.type]&&(H=this.options.extensions.renderers[$.type].call({parser:this},$),H!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes($.type))){Y+=H||"";continue}switch($.type){case"escape":{Y+=ce.text($.text);break}case"html":{Y+=ce.html($.text);break}case"link":{Y+=ce.link($.href,$.title,this.parseInline($.tokens,ce));break}case"image":{Y+=ce.image($.href,$.title,$.text);break}case"strong":{Y+=ce.strong(this.parseInline($.tokens,ce));break}case"em":{Y+=ce.em(this.parseInline($.tokens,ce));break}case"codespan":{Y+=ce.codespan($.text);break}case"br":{Y+=ce.br();break}case"del":{Y+=ce.del(this.parseInline($.tokens,ce));break}case"text":{Y+=ce.text($.text);break}default:{var J='Token with "'+$.type+'" type was not found.';if(this.options.silent){console.error(J);return}else throw new Error(J)}}}return Y},Te}();function oe(Te,Ie,Se){if(typeof Te>"u"||Te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");if(typeof Ie=="function"&&(Se=Ie,Ie=null),Ie=n({},oe.defaults,Ie||{}),M(Ie),Se){var se=Ie.highlight,ce;try{ce=V.lex(Te,Ie)}catch(q){return Se(q)}var Y=function(J){var de;if(!J)try{Ie.walkTokens&&oe.walkTokens(ce,Ie.walkTokens),de=ue.parse(ce,Ie)}catch(we){J=we}return Ie.highlight=se,J?Se(J):Se(null,de)};if(!se||se.length<3||(delete Ie.highlight,!ce.length))return Y();var I=0;oe.walkTokens(ce,function(q){q.type==="code"&&(I++,setTimeout(function(){se(q.text,q.lang,function(J,de){if(J)return Y(J);de!=null&&de!==q.text&&(q.text=de,q.escaped=!0),I--,I===0&&Y()})},0))}),I===0&&Y();return}function $(q){if(q.message+=`
Please report this to https://github.com/markedjs/marked.`,Ie.silent)return"<p>An error occurred:</p><pre>"+f(q.message+"",!0)+"</pre>";throw q}try{var H=V.lex(Te,Ie);if(Ie.walkTokens){if(Ie.async)return Promise.all(oe.walkTokens(H,Ie.walkTokens)).then(function(){return ue.parse(H,Ie)}).catch($);oe.walkTokens(H,Ie.walkTokens)}return ue.parse(H,Ie)}catch(q){$(q)}}oe.options=oe.setOptions=function(Te){return n(oe.defaults,Te),O(oe.defaults),oe},oe.getDefaults=k,oe.defaults=ee.defaults,oe.use=function(){for(var Te=arguments.length,Ie=new Array(Te),Se=0;Se<Te;Se++)Ie[Se]=arguments[Se];var se=n.apply(void 0,[{}].concat(Ie)),ce=oe.defaults.extensions||{renderers:{},childTokens:{}},Y;Ie.forEach(function(I){if(I.extensions&&(Y=!0,I.extensions.forEach(function(H){if(!H.name)throw new Error("extension name required");if(H.renderer){var q=ce.renderers?ce.renderers[H.name]:null;q?ce.renderers[H.name]=function(){for(var J=arguments.length,de=new Array(J),we=0;we<J;we++)de[we]=arguments[we];var ae=H.renderer.apply(this,de);return ae===!1&&(ae=q.apply(this,de)),ae}:ce.renderers[H.name]=H.renderer}if(H.tokenizer){if(!H.level||H.level!=="block"&&H.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ce[H.level]?ce[H.level].unshift(H.tokenizer):ce[H.level]=[H.tokenizer],H.start&&(H.level==="block"?ce.startBlock?ce.startBlock.push(H.start):ce.startBlock=[H.start]:H.level==="inline"&&(ce.startInline?ce.startInline.push(H.start):ce.startInline=[H.start]))}H.childTokens&&(ce.childTokens[H.name]=H.childTokens)})),I.renderer&&function(){var H=oe.defaults.renderer||new K,q=function(we){var ae=H[we];H[we]=function(){for(var pe=arguments.length,ve=new Array(pe),We=0;We<pe;We++)ve[We]=arguments[We];var He=I.renderer[we].apply(H,ve);return He===!1&&(He=ae.apply(H,ve)),He}};for(var J in I.renderer)q(J);se.renderer=H}(),I.tokenizer&&function(){var H=oe.defaults.tokenizer||new A,q=function(we){var ae=H[we];H[we]=function(){for(var pe=arguments.length,ve=new Array(pe),We=0;We<pe;We++)ve[We]=arguments[We];var He=I.tokenizer[we].apply(H,ve);return He===!1&&(He=ae.apply(H,ve)),He}};for(var J in I.tokenizer)q(J);se.tokenizer=H}(),I.walkTokens){var $=oe.defaults.walkTokens;se.walkTokens=function(H){var q=[];return q.push(I.walkTokens.call(this,H)),$&&(q=q.concat($.call(this,H))),q}}Y&&(se.extensions=ce),oe.setOptions(se)})},oe.walkTokens=function(Te,Ie){for(var Se=[],se=function(){var $=Y.value;switch(Se=Se.concat(Ie.call(oe,$)),$.type){case"table":{for(var H=L($.header),q;!(q=H()).done;){var J=q.value;Se=Se.concat(oe.walkTokens(J.tokens,Ie))}for(var de=L($.rows),we;!(we=de()).done;)for(var ae=we.value,pe=L(ae),ve;!(ve=pe()).done;){var We=ve.value;Se=Se.concat(oe.walkTokens(We.tokens,Ie))}break}case"list":{Se=Se.concat(oe.walkTokens($.items,Ie));break}default:oe.defaults.extensions&&oe.defaults.extensions.childTokens&&oe.defaults.extensions.childTokens[$.type]?oe.defaults.extensions.childTokens[$.type].forEach(function(He){Se=Se.concat(oe.walkTokens($[He],Ie))}):$.tokens&&(Se=Se.concat(oe.walkTokens($.tokens,Ie)))}},ce=L(Te),Y;!(Y=ce()).done;)se();return Se},oe.parseInline=function(Te,Ie){if(typeof Te>"u"||Te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");Ie=n({},oe.defaults,Ie||{}),M(Ie);try{var Se=V.lexInline(Te,Ie);return Ie.walkTokens&&oe.walkTokens(Se,Ie.walkTokens),ue.parseInline(Se,Ie)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,Ie.silent)return"<p>An error occurred:</p><pre>"+f(se.message+"",!0)+"</pre>";throw se}},oe.Parser=ue,oe.parser=ue.parse,oe.Renderer=K,oe.TextRenderer=ie,oe.Lexer=V,oe.lexer=V.lex,oe.Tokenizer=A,oe.Slugger=me,oe.parse=oe;var De=oe.options,re=oe.setOptions,Q=oe.use,le=oe.walkTokens,Ee=oe.parseInline,Ae=oe,Be=ue.parse,xe=V.lex;ee.Lexer=V,ee.Parser=ue,ee.Renderer=K,ee.Slugger=me,ee.TextRenderer=ie,ee.Tokenizer=A,ee.getDefaults=k,ee.lexer=xe,ee.marked=oe,ee.options=De,ee.parse=Ae,ee.parseInline=Ee,ee.parser=Be,ee.setOptions=re,ee.use=Q,ee.walkTokens=le,Object.defineProperty(ee,"__esModule",{value:!0})}),define(ke[111],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function i(O,S,C){return Math.min(Math.max(O,S),C)}e.clamp=i;function T(O,S){return(S+O%S)%S}e.rot=T;class y{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=y;class L{constructor(){this.a=1,this.b=0}update(S){return this.b=this.b+(S-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=L;class k{constructor(S){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(S),this.c.fill(0,0,S)}update(S){const C=this.c[this.d];return this.c[this.d]=S,this.d=(this.d+1)%this.c.length,this.e-=C,this.e+=S,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=k}),function(){function ee(y){const L=[];typeof y=="number"&&L.push("code/timeOrigin",y);function k(S){L.push(S,Date.now())}function O(){const S=[];for(let C=0;C<L.length;C+=2)S.push({name:L[C],startTime:L[C+1]});return S}return{mark:k,getMarks:O}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(y){performance.mark(y)},getMarks(){let y=performance.timeOrigin;typeof y!="number"&&(y=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(y)}];for(const k of performance.getEntriesByType("mark"))L.push({name:k.name,startTime:Math.round(y+k.startTime)});return L}};if(typeof process=="object"){const y=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(y)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function i(y){return y.MonacoPerformanceMarks||(y.MonacoPerformanceMarks=e()),y.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return i(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=i(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=i(T))}(),function(ee,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var i=e();for(var T in i)(typeof exports=="object"?exports:ee)[T]=i[T]}}(typeof self<"u"?self:this,function(){return function(ee){var e={};function i(T){if(e[T])return e[T].exports;var y=e[T]={i:T,l:!1,exports:{}};return ee[T].call(y.exports,y,y.exports,i),y.l=!0,y.exports}return i.m=ee,i.c=e,i.d=function(T,y,L){i.o(T,y)||Object.defineProperty(T,y,{enumerable:!0,get:L})},i.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},i.t=function(T,y){if(1&y&&(T=i(T)),8&y||4&y&&typeof T=="object"&&T&&T.__esModule)return T;var L=Object.create(null);if(i.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:T}),2&y&&typeof T!="string")for(var k in T)i.d(L,k,function(O){return T[O]}.bind(null,k));return L},i.n=function(T){var y=T&&T.__esModule?function(){return T.default}:function(){return T};return i.d(y,"a",y),y},i.o=function(T,y){return Object.prototype.hasOwnProperty.call(T,y)},i.p="",i(i.s=0)}([function(ee,e,i){(function(T){var y;e=ee.exports=Q,y=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,O=e.re=[],S=e.src=[],C=0,N=C++;S[N]="0|[1-9]\\d*";var D=C++;S[D]="[0-9]+";var m=C++;S[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=C++;S[p]="("+S[N]+")\\.("+S[N]+")\\.("+S[N]+")";var f=C++;S[f]="("+S[D]+")\\.("+S[D]+")\\.("+S[D]+")";var t=C++;S[t]="(?:"+S[N]+"|"+S[m]+")";var c=C++;S[c]="(?:"+S[D]+"|"+S[m]+")";var l=C++;S[l]="(?:-("+S[t]+"(?:\\."+S[t]+")*))";var v=C++;S[v]="(?:-?("+S[c]+"(?:\\."+S[c]+")*))";var b=C++;S[b]="[0-9A-Za-z-]+";var E=C++;S[E]="(?:\\+("+S[b]+"(?:\\."+S[b]+")*))";var w=C++,r="v?"+S[p]+S[l]+"?"+S[E]+"?";S[w]="^"+r+"$";var a="[v=\\s]*"+S[f]+S[v]+"?"+S[E]+"?",o=C++;S[o]="^"+a+"$";var d=C++;S[d]="((?:<|>)?=?)";var s=C++;S[s]=S[D]+"|x|X|\\*";var u=C++;S[u]=S[N]+"|x|X|\\*";var n=C++;S[n]="[v=\\s]*("+S[u]+")(?:\\.("+S[u]+")(?:\\.("+S[u]+")(?:"+S[l]+")?"+S[E]+"?)?)?";var h=C++;S[h]="[v=\\s]*("+S[s]+")(?:\\.("+S[s]+")(?:\\.("+S[s]+")(?:"+S[v]+")?"+S[E]+"?)?)?";var g=C++;S[g]="^"+S[d]+"\\s*"+S[n]+"$";var P=C++;S[P]="^"+S[d]+"\\s*"+S[h]+"$";var M=C++;S[M]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=C++;S[j]="(?:~>?)";var Z=C++;S[Z]="(\\s*)"+S[j]+"\\s+",O[Z]=new RegExp(S[Z],"g");var G=C++;S[G]="^"+S[j]+S[n]+"$";var A=C++;S[A]="^"+S[j]+S[h]+"$";var R=C++;S[R]="(?:\\^)";var F=C++;S[F]="(\\s*)"+S[R]+"\\s+",O[F]=new RegExp(S[F],"g");var B=C++;S[B]="^"+S[R]+S[n]+"$";var z=C++;S[z]="^"+S[R]+S[h]+"$";var V=C++;S[V]="^"+S[d]+"\\s*("+a+")$|^$";var K=C++;S[K]="^"+S[d]+"\\s*("+r+")$|^$";var ie=C++;S[ie]="(\\s*)"+S[d]+"\\s*("+a+"|"+S[n]+")",O[ie]=new RegExp(S[ie],"g");var me=C++;S[me]="^\\s*("+S[n]+")\\s+-\\s+("+S[n]+")\\s*$";var ue=C++;S[ue]="^\\s*("+S[h]+")\\s+-\\s+("+S[h]+")\\s*$";var oe=C++;S[oe]="(<|>)?=?\\s*\\*";for(var De=0;De<35;De++)y(De,S[De]),O[De]||(O[De]=new RegExp(S[De]));function re(ae,pe){if(ae instanceof Q)return ae;if(typeof ae!="string"||ae.length>L||!(pe?O[o]:O[w]).test(ae))return null;try{return new Q(ae,pe)}catch{return null}}function Q(ae,pe){if(ae instanceof Q){if(ae.loose===pe)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof Q))return new Q(ae,pe);y("SemVer",ae,pe),this.loose=pe;var ve=ae.trim().match(pe?O[o]:O[w]);if(!ve)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+ve[1],this.minor=+ve[2],this.patch=+ve[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");ve[4]?this.prerelease=ve[4].split(".").map(function(We){if(/^[0-9]+$/.test(We)){var He=+We;if(He>=0&&He<k)return He}return We}):this.prerelease=[],this.build=ve[5]?ve[5].split("."):[],this.format()}e.parse=re,e.valid=function(ae,pe){var ve=re(ae,pe);return ve?ve.version:null},e.clean=function(ae,pe){var ve=re(ae.trim().replace(/^[=v]+/,""),pe);return ve?ve.version:null},e.SemVer=Q,Q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Q.prototype.toString=function(){return this.version},Q.prototype.compare=function(ae){return y("SemVer.compare",this.version,this.loose,ae),ae instanceof Q||(ae=new Q(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},Q.prototype.compareMain=function(ae){return ae instanceof Q||(ae=new Q(ae,this.loose)),Ee(this.major,ae.major)||Ee(this.minor,ae.minor)||Ee(this.patch,ae.patch)},Q.prototype.comparePre=function(ae){if(ae instanceof Q||(ae=new Q(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var pe=0;do{var ve=this.prerelease[pe],We=ae.prerelease[pe];if(y("prerelease compare",pe,ve,We),ve===void 0&&We===void 0)return 0;if(We===void 0)return 1;if(ve===void 0)return-1;if(ve!==We)return Ee(ve,We)}while(++pe)},Q.prototype.inc=function(ae,pe){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",pe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",pe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",pe),this.inc("pre",pe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",pe),this.inc("pre",pe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ve=this.prerelease.length;--ve>=0;)typeof this.prerelease[ve]=="number"&&(this.prerelease[ve]++,ve=-2);ve===-1&&this.prerelease.push(0)}pe&&(this.prerelease[0]===pe?isNaN(this.prerelease[1])&&(this.prerelease=[pe,0]):this.prerelease=[pe,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,pe,ve,We){typeof ve=="string"&&(We=ve,ve=void 0);try{return new Q(ae,ve).inc(pe,We).version}catch{return null}},e.diff=function(ae,pe){if(Te(ae,pe))return null;var ve=re(ae),We=re(pe);if(ve.prerelease.length||We.prerelease.length){for(var He in ve)if((He==="major"||He==="minor"||He==="patch")&&ve[He]!==We[He])return"pre"+He;return"prerelease"}for(var He in ve)if((He==="major"||He==="minor"||He==="patch")&&ve[He]!==We[He])return He},e.compareIdentifiers=Ee;var le=/^[0-9]+$/;function Ee(ae,pe){var ve=le.test(ae),We=le.test(pe);return ve&&We&&(ae=+ae,pe=+pe),ve&&!We?-1:We&&!ve?1:ae<pe?-1:ae>pe?1:0}function Ae(ae,pe,ve){return new Q(ae,ve).compare(new Q(pe,ve))}function Be(ae,pe,ve){return Ae(ae,pe,ve)>0}function xe(ae,pe,ve){return Ae(ae,pe,ve)<0}function Te(ae,pe,ve){return Ae(ae,pe,ve)===0}function Ie(ae,pe,ve){return Ae(ae,pe,ve)!==0}function Se(ae,pe,ve){return Ae(ae,pe,ve)>=0}function se(ae,pe,ve){return Ae(ae,pe,ve)<=0}function ce(ae,pe,ve,We){var He;switch(pe){case"===":typeof ae=="object"&&(ae=ae.version),typeof ve=="object"&&(ve=ve.version),He=ae===ve;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof ve=="object"&&(ve=ve.version),He=ae!==ve;break;case"":case"=":case"==":He=Te(ae,ve,We);break;case"!=":He=Ie(ae,ve,We);break;case">":He=Be(ae,ve,We);break;case">=":He=Se(ae,ve,We);break;case"<":He=xe(ae,ve,We);break;case"<=":He=se(ae,ve,We);break;default:throw new TypeError("Invalid operator: "+pe)}return He}function Y(ae,pe){if(ae instanceof Y){if(ae.loose===pe)return ae;ae=ae.value}if(!(this instanceof Y))return new Y(ae,pe);y("comparator",ae,pe),this.loose=pe,this.parse(ae),this.semver===I?this.value="":this.value=this.operator+this.semver.version,y("comp",this)}e.rcompareIdentifiers=function(ae,pe){return Ee(pe,ae)},e.major=function(ae,pe){return new Q(ae,pe).major},e.minor=function(ae,pe){return new Q(ae,pe).minor},e.patch=function(ae,pe){return new Q(ae,pe).patch},e.compare=Ae,e.compareLoose=function(ae,pe){return Ae(ae,pe,!0)},e.rcompare=function(ae,pe,ve){return Ae(pe,ae,ve)},e.sort=function(ae,pe){return ae.sort(function(ve,We){return e.compare(ve,We,pe)})},e.rsort=function(ae,pe){return ae.sort(function(ve,We){return e.rcompare(ve,We,pe)})},e.gt=Be,e.lt=xe,e.eq=Te,e.neq=Ie,e.gte=Se,e.lte=se,e.cmp=ce,e.Comparator=Y;var I={};function $(ae,pe){if(ae instanceof $)return ae.loose===pe?ae:new $(ae.raw,pe);if(ae instanceof Y)return new $(ae.value,pe);if(!(this instanceof $))return new $(ae,pe);if(this.loose=pe,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(ve){return this.parseRange(ve.trim())},this).filter(function(ve){return ve.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function H(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function q(ae,pe,ve,We,He,tt,Xe,et,it,dt,Fe,st,_){return((pe=H(ve)?"":H(We)?">="+ve+".0.0":H(He)?">="+ve+"."+We+".0":">="+pe)+" "+(et=H(it)?"":H(dt)?"<"+(+it+1)+".0.0":H(Fe)?"<"+it+"."+(+dt+1)+".0":st?"<="+it+"."+dt+"."+Fe+"-"+st:"<="+et)).trim()}function J(ae,pe){for(var ve=0;ve<ae.length;ve++)if(!ae[ve].test(pe))return!1;if(pe.prerelease.length){for(ve=0;ve<ae.length;ve++)if(y(ae[ve].semver),ae[ve].semver!==I&&ae[ve].semver.prerelease.length>0){var We=ae[ve].semver;if(We.major===pe.major&&We.minor===pe.minor&&We.patch===pe.patch)return!0}return!1}return!0}function de(ae,pe,ve){try{pe=new $(pe,ve)}catch{return!1}return pe.test(ae)}function we(ae,pe,ve,We){var He,tt,Xe,et,it;switch(ae=new Q(ae,We),pe=new $(pe,We),ve){case">":He=Be,tt=se,Xe=xe,et=">",it=">=";break;case"<":He=xe,tt=Se,Xe=Be,et="<",it="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(de(ae,pe,We))return!1;for(var dt=0;dt<pe.set.length;++dt){var Fe=pe.set[dt],st=null,_=null;if(Fe.forEach(function(X){X.semver===I&&(X=new Y(">=0.0.0")),st=st||X,_=_||X,He(X.semver,st.semver,We)?st=X:Xe(X.semver,_.semver,We)&&(_=X)}),st.operator===et||st.operator===it||(!_.operator||_.operator===et)&&tt(ae,_.semver)||_.operator===it&&Xe(ae,_.semver))return!1}return!0}Y.prototype.parse=function(ae){var pe=this.loose?O[V]:O[K],ve=ae.match(pe);if(!ve)throw new TypeError("Invalid comparator: "+ae);this.operator=ve[1],this.operator==="="&&(this.operator=""),ve[2]?this.semver=new Q(ve[2],this.loose):this.semver=I},Y.prototype.toString=function(){return this.value},Y.prototype.test=function(ae){return y("Comparator.test",ae,this.loose),this.semver===I||(typeof ae=="string"&&(ae=new Q(ae,this.loose)),ce(ae,this.operator,this.semver,this.loose))},Y.prototype.intersects=function(ae,pe){if(!(ae instanceof Y))throw new TypeError("a Comparator is required");var ve;if(this.operator==="")return ve=new $(ae.value,pe),de(this.value,ve,pe);if(ae.operator==="")return ve=new $(this.value,pe),de(ae.semver,ve,pe);var We=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),He=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),tt=this.semver.version===ae.semver.version,Xe=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),et=ce(this.semver,"<",ae.semver,pe)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),it=ce(this.semver,">",ae.semver,pe)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return We||He||tt&&Xe||et||it},e.Range=$,$.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},$.prototype.toString=function(){return this.range},$.prototype.parseRange=function(ae){var pe=this.loose;ae=ae.trim(),y("range",ae,pe);var ve=pe?O[ue]:O[me];ae=ae.replace(ve,q),y("hyphen replace",ae),ae=ae.replace(O[ie],"$1$2$3"),y("comparator trim",ae,O[ie]),ae=(ae=(ae=ae.replace(O[Z],"$1~")).replace(O[F],"$1^")).split(/\s+/).join(" ");var We=pe?O[V]:O[K],He=ae.split(" ").map(function(tt){return function(Xe,et){return y("comp",Xe),Xe=function(it,dt){return it.trim().split(/\s+/).map(function(Fe){return function(st,_){y("caret",st,_);var X=_?O[z]:O[B];return st.replace(X,function(ge,Me,$e,je,_e){var nt;return y("caret",st,ge,Me,$e,je,_e),H(Me)?nt="":H($e)?nt=">="+Me+".0.0 <"+(+Me+1)+".0.0":H(je)?nt=Me==="0"?">="+Me+"."+$e+".0 <"+Me+"."+(+$e+1)+".0":">="+Me+"."+$e+".0 <"+(+Me+1)+".0.0":_e?(y("replaceCaret pr",_e),_e.charAt(0)!=="-"&&(_e="-"+_e),nt=Me==="0"?$e==="0"?">="+Me+"."+$e+"."+je+_e+" <"+Me+"."+$e+"."+(+je+1):">="+Me+"."+$e+"."+je+_e+" <"+Me+"."+(+$e+1)+".0":">="+Me+"."+$e+"."+je+_e+" <"+(+Me+1)+".0.0"):(y("no pr"),nt=Me==="0"?$e==="0"?">="+Me+"."+$e+"."+je+" <"+Me+"."+$e+"."+(+je+1):">="+Me+"."+$e+"."+je+" <"+Me+"."+(+$e+1)+".0":">="+Me+"."+$e+"."+je+" <"+(+Me+1)+".0.0"),y("caret return",nt),nt})}(Fe,dt)}).join(" ")}(Xe,et),y("caret",Xe),Xe=function(it,dt){return it.trim().split(/\s+/).map(function(Fe){return function(st,_){var X=_?O[A]:O[G];return st.replace(X,function(ge,Me,$e,je,_e){var nt;return y("tilde",st,ge,Me,$e,je,_e),H(Me)?nt="":H($e)?nt=">="+Me+".0.0 <"+(+Me+1)+".0.0":H(je)?nt=">="+Me+"."+$e+".0 <"+Me+"."+(+$e+1)+".0":_e?(y("replaceTilde pr",_e),_e.charAt(0)!=="-"&&(_e="-"+_e),nt=">="+Me+"."+$e+"."+je+_e+" <"+Me+"."+(+$e+1)+".0"):nt=">="+Me+"."+$e+"."+je+" <"+Me+"."+(+$e+1)+".0",y("tilde return",nt),nt})}(Fe,dt)}).join(" ")}(Xe,et),y("tildes",Xe),Xe=function(it,dt){return y("replaceXRanges",it,dt),it.split(/\s+/).map(function(Fe){return function(st,_){st=st.trim();var X=_?O[P]:O[g];return st.replace(X,function(ge,Me,$e,je,_e,nt){y("xRange",st,ge,Me,$e,je,_e,nt);var wt=H($e),St=wt||H(je),kt=St||H(_e);return Me==="="&&kt&&(Me=""),wt?ge=Me===">"||Me==="<"?"<0.0.0":"*":Me&&kt?(St&&(je=0),kt&&(_e=0),Me===">"?(Me=">=",St?($e=+$e+1,je=0,_e=0):kt&&(je=+je+1,_e=0)):Me==="<="&&(Me="<",St?$e=+$e+1:je=+je+1),ge=Me+$e+"."+je+"."+_e):St?ge=">="+$e+".0.0 <"+(+$e+1)+".0.0":kt&&(ge=">="+$e+"."+je+".0 <"+$e+"."+(+je+1)+".0"),y("xRange return",ge),ge})}(Fe,dt)}).join(" ")}(Xe,et),y("xrange",Xe),Xe=function(it,dt){return y("replaceStars",it,dt),it.trim().replace(O[oe],"")}(Xe,et),y("stars",Xe),Xe}(tt,pe)}).join(" ").split(/\s+/);return this.loose&&(He=He.filter(function(tt){return!!tt.match(We)})),He=He.map(function(tt){return new Y(tt,pe)})},$.prototype.intersects=function(ae,pe){if(!(ae instanceof $))throw new TypeError("a Range is required");return this.set.some(function(ve){return ve.every(function(We){return ae.set.some(function(He){return He.every(function(tt){return We.intersects(tt,pe)})})})})},e.toComparators=function(ae,pe){return new $(ae,pe).set.map(function(ve){return ve.map(function(We){return We.value}).join(" ").trim().split(" ")})},$.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new Q(ae,this.loose));for(var pe=0;pe<this.set.length;pe++)if(J(this.set[pe],ae))return!0;return!1},e.satisfies=de,e.maxSatisfying=function(ae,pe,ve){var We=null,He=null;try{var tt=new $(pe,ve)}catch{return null}return ae.forEach(function(Xe){tt.test(Xe)&&(We&&He.compare(Xe)!==-1||(He=new Q(We=Xe,ve)))}),We},e.minSatisfying=function(ae,pe,ve){var We=null,He=null;try{var tt=new $(pe,ve)}catch{return null}return ae.forEach(function(Xe){tt.test(Xe)&&(We&&He.compare(Xe)!==1||(He=new Q(We=Xe,ve)))}),We},e.validRange=function(ae,pe){try{return new $(ae,pe).range||"*"}catch{return null}},e.ltr=function(ae,pe,ve){return we(ae,pe,"<",ve)},e.gtr=function(ae,pe,ve){return we(ae,pe,">",ve)},e.outside=we,e.prerelease=function(ae,pe){var ve=re(ae,pe);return ve&&ve.prerelease.length?ve.prerelease:null},e.intersects=function(ae,pe,ve){return ae=new $(ae,ve),pe=new $(pe,ve),ae.intersects(pe)},e.coerce=function(ae){if(ae instanceof Q)return ae;if(typeof ae!="string")return null;var pe=ae.match(O[M]);return pe==null?null:re((pe[1]||"0")+"."+(pe[2]||"0")+"."+(pe[3]||"0"))}}).call(this,i(1))},function(ee,e){var i,T,y=ee.exports={};function L(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function O(c){if(i===setTimeout)return setTimeout(c,0);if((i===L||!i)&&setTimeout)return i=setTimeout,setTimeout(c,0);try{return i(c,0)}catch{try{return i.call(null,c,0)}catch{return i.call(this,c,0)}}}(function(){try{i=typeof setTimeout=="function"?setTimeout:L}catch{i=L}try{T=typeof clearTimeout=="function"?clearTimeout:k}catch{T=k}})();var S,C=[],N=!1,D=-1;function m(){N&&S&&(N=!1,S.length?C=S.concat(C):D=-1,C.length&&p())}function p(){if(!N){var c=O(m);N=!0;for(var l=C.length;l;){for(S=C,C=[];++D<l;)S&&S[D].run();D=-1,l=C.length}S=null,N=!1,function(v){if(T===clearTimeout)return clearTimeout(v);if((T===k||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(v);try{T(v)}catch{try{return T.call(null,v)}catch{return T.call(this,v)}}}(c)}}function f(c,l){this.fun=c,this.array=l}function t(){}y.nextTick=function(c){var l=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)l[v-1]=arguments[v];C.push(new f(c,l)),C.length!==1||N||O(p)},f.prototype.run=function(){this.fun.apply(null,this.array)},y.title="browser",y.browser=!0,y.env={},y.argv=[],y.version="",y.versions={},y.on=t,y.addListener=t,y.once=t,y.off=t,y.removeListener=t,y.removeAllListeners=t,y.emit=t,y.prependListener=t,y.prependOnceListener=t,y.listeners=function(c){return[]},y.binding=function(c){throw new Error("process.binding is not supported")},y.cwd=function(){return"/"},y.chdir=function(c){throw new Error("process.chdir is not supported")},y.umask=function(){return 0}}])}),define(ke[112],Ce([1,0,11,7]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function y(E){const w=E;return w?typeof w.read=="function":!1}e.isReadable=y;function L(E){const w=E;return w?[w.on,w.pause,w.resume,w.destroy].every(r=>typeof r=="function"):!1}e.isReadableStream=L;function k(E){const w=E;return w?L(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.isReadableBufferedStream=k;function O(E,w){return new S(E,w)}e.newWriteableStream=O;class S{constructor(w,r){this.e=w,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(w){if(!this.a.destroyed){if(this.a.flowing)this.g(w);else if(this.b.data.push(w),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(w){this.a.destroyed||(this.a.flowing?this.h(w):this.b.error.push(w))}end(w){this.a.destroyed||(typeof w<"u"&&this.write(w),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(w){this.c.data.slice(0).forEach(r=>r(w))}h(w){this.c.error.length===0?(0,i.onUnexpectedError)(w):this.c.error.slice(0).forEach(r=>r(w))}i(){this.c.end.slice(0).forEach(w=>w())}on(w,r){if(!this.a.destroyed)switch(w){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(w,r){if(this.a.destroyed)return;let a;switch(w){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const o=a.indexOf(r);o>=0&&a.splice(o,1)}}j(){if(this.b.data.length>0){const w=this.e(this.b.data);this.g(w),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const w of this.b.error)this.h(w);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function C(E,w){const r=[];let a;for(;(a=E.read())!==null;)r.push(a);return w(r)}e.consumeReadable=C;function N(E,w,r){const a=[];let o;for(;(o=E.read())!==null&&a.length<r;)a.push(o);return o===null&&a.length>0?w(a):{read:()=>{if(a.length>0)return a.shift();if(typeof o<"u"){const d=o;return o=void 0,d}return E.read()}}}e.peekReadable=N;function D(E,w){return new Promise((r,a)=>{const o=[];m(E,{onData:d=>{w&&o.push(d)},onError:d=>{w?a(d):r(void 0)},onEnd:()=>{r(w?w(o):void 0)}})})}e.consumeStream=D;function m(E,w){let r=!1;return E.on("error",a=>{r||w.onError(a)}),E.on("end",()=>{r||w.onEnd()}),E.on("data",a=>{r||w.onData(a)}),(0,T.toDisposable)(()=>r=!0)}e.listenStream=m;function p(E,w){return new Promise((r,a)=>{const o=new T.DisposableStore,d=[],s=h=>{if(d.push(h),d.length>w)return o.dispose(),E.pause(),r({stream:E,buffer:d,ended:!1})},u=h=>a(h),n=()=>r({stream:E,buffer:d,ended:!0});o.add((0,T.toDisposable)(()=>E.removeListener("error",u))),E.on("error",u),o.add((0,T.toDisposable)(()=>E.removeListener("end",n))),E.on("end",n),o.add((0,T.toDisposable)(()=>E.removeListener("data",s))),E.on("data",s)})}e.peekStream=p;function f(E,w){const r=O(w);return r.end(E),r}e.toStream=f;function t(){const E=O(()=>{throw new Error("not supported")});return E.end(),E}e.emptyStream=t;function c(E){let w=!1;return{read:()=>w?null:(w=!0,E)}}e.toReadable=c;function l(E,w,r){const a=O(r);return m(E,{onData:o=>a.write(w.data(o)),onError:o=>a.error(w.error?w.error(o):o),onEnd:()=>a.end()}),a}e.transform=l;function v(E,w,r){let a=!1;return{read:()=>{const o=w.read();return a?o:(a=!0,o!==null?r([E,o]):E)}}}e.prefixedReadable=v;function b(E,w,r){let a=!1;const o=O(r);return m(w,{onData:d=>a?o.write(d):(a=!0,o.write(r([E,d]))),onError:d=>o.error(d),onEnd:()=>{a||(a=!0,o.write(E)),o.end()}}),o}e.prefixedStream=b}),define(ke[24],Ce([1,0,112]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer<"u";let y,L;class k{static alloc(h){return T?new k(Buffer.allocUnsafe(h)):new k(new Uint8Array(h))}static wrap(h){return T&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new k(h)}static fromString(h,g){return!(g?.dontUseNodeBuffer||!1)&&T?new k(Buffer.from(h)):(y||(y=new TextEncoder),new k(y.encode(h)))}static fromByteArray(h){const g=k.alloc(h.length);for(let P=0,M=h.length;P<M;P++)g.buffer[P]=h[P];return g}static concat(h,g){if(typeof g>"u"){g=0;for(let j=0,Z=h.length;j<Z;j++)g+=h[j].byteLength}const P=k.alloc(g);let M=0;for(let j=0,Z=h.length;j<Z;j++){const G=h[j];P.set(G,M),M+=G.byteLength}return P}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=k.alloc(this.byteLength);return h.set(this),h}toString(){return T?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(h,g){return new k(this.buffer.subarray(h,g))}set(h,g){if(h instanceof k)this.buffer.set(h.buffer,g);else if(h instanceof Uint8Array)this.buffer.set(h,g);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),g);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),g);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return C(this.buffer,h)}writeUInt32BE(h,g){N(this.buffer,h,g)}readUInt32LE(h){return D(this.buffer,h)}writeUInt32LE(h,g){m(this.buffer,h,g)}readUInt8(h){return p(this.buffer,h)}writeUInt8(h,g){f(this.buffer,h,g)}}e.VSBuffer=k;function O(n,h){return n[h+0]<<0>>>0|n[h+1]<<8>>>0}e.readUInt16LE=O;function S(n,h,g){n[g+0]=h&255,h=h>>>8,n[g+1]=h&255}e.writeUInt16LE=S;function C(n,h){return n[h]*2**24+n[h+1]*2**16+n[h+2]*2**8+n[h+3]}e.readUInt32BE=C;function N(n,h,g){n[g+3]=h,h=h>>>8,n[g+2]=h,h=h>>>8,n[g+1]=h,h=h>>>8,n[g]=h}e.writeUInt32BE=N;function D(n,h){return n[h+0]<<0>>>0|n[h+1]<<8>>>0|n[h+2]<<16>>>0|n[h+3]<<24>>>0}e.readUInt32LE=D;function m(n,h,g){n[g+0]=h&255,h=h>>>8,n[g+1]=h&255,h=h>>>8,n[g+2]=h&255,h=h>>>8,n[g+3]=h&255}e.writeUInt32LE=m;function p(n,h){return n[h]}e.readUInt8=p;function f(n,h,g){n[g]=h}e.writeUInt8=f;function t(n){return i.consumeReadable(n,h=>k.concat(h))}e.readableToBuffer=t;function c(n){return i.toReadable(n)}e.bufferToReadable=c;function l(n){return i.consumeStream(n,h=>k.concat(h))}e.streamToBuffer=l;async function v(n){return n.ended?k.concat(n.buffer):k.concat([...n.buffer,await l(n.stream)])}e.bufferedStreamToBuffer=v;function b(n){return i.toStream(n,h=>k.concat(h))}e.bufferToStream=b;function E(n){return i.transform(n,{data:h=>typeof h=="string"?k.fromString(h):k.wrap(h)},h=>k.concat(h))}e.streamToBufferReadableStream=E;function w(n){return i.newWriteableStream(h=>k.concat(h),n)}e.newWriteableBufferStream=w;function r(n,h){return i.prefixedReadable(n,h,g=>k.concat(g))}e.prefixedBufferReadable=r;function a(n,h){return i.prefixedStream(n,h,g=>k.concat(g))}e.prefixedBufferStream=a;function o(n){let h=0,g=0,P=0;const M=new Uint8Array(Math.floor(n.length/4*3)),j=G=>{switch(g){case 3:M[P++]=h|G,g=0;break;case 2:M[P++]=h|G>>>2,h=G<<6,g=3;break;case 1:M[P++]=h|G>>>4,h=G<<4,g=2;break;default:h=G<<2,g=1}};for(let G=0;G<n.length;G++){const A=n.charCodeAt(G);if(A>=65&&A<=90)j(A-65);else if(A>=97&&A<=122)j(A-97+26);else if(A>=48&&A<=57)j(A-48+52);else if(A===43||A===45)j(62);else if(A===47||A===95)j(63);else{if(A===61)break;throw new SyntaxError(`Unexpected base64 character ${n[G]}`)}}const Z=P;for(;g>0;)j(0);return k.wrap(M).slice(0,Z)}e.decodeBase64=o;const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:n},h=!0,g=!1){const P=g?s:d;let M="";const j=n.byteLength%3;let Z=0;for(;Z<n.byteLength-j;Z+=3){const G=n[Z+0],A=n[Z+1],R=n[Z+2];M+=P[G>>>2],M+=P[(G<<4|A>>>4)&63],M+=P[(A<<2|R>>>6)&63],M+=P[R&63]}if(j===1){const G=n[Z+0];M+=P[G>>>2],M+=P[G<<4&63],h&&(M+="==")}else if(j===2){const G=n[Z+0],A=n[Z+1];M+=P[G>>>2],M+=P[(G<<4|A>>>4)&63],M+=P[A<<2&63],h&&(M+="=")}return M}e.encodeBase64=u}),define(ke[34],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const i=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(y){return i.test(y)}e.isUUID=T,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(O){for(let S=0;S<O.length;S++)O[S]=Math.floor(Math.random()*256);return O};const L=new Uint8Array(16),k=[];for(let O=0;O<256;O++)k.push(O.toString(16).padStart(2,"0"));return function(){y(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let S=0,C="";return C+=k[L[S++]],C+=k[L[S++]],C+=k[L[S++]],C+=k[L[S++]],C+="-",C+=k[L[S++]],C+=k[L[S++]],C+="-",C+=k[L[S++]],C+=k[L[S++]],C+="-",C+=k[L[S++]],C+=k[L[S++]],C+="-",C+=k[L[S++]],C+=k[L[S++]],C+=k[L[S++]],C+=k[L[S++]],C+=k[L[S++]],C+=k[L[S++]],C}}()}),define(ke[113],Ce([1,0,16,34]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function y(O){return{id:(0,T.generateUuid)(),asString:async()=>O,asFile:()=>{},value:typeof O=="string"?O:void 0}}e.createStringDataTransferItem=y;function L(O,S,C){return{id:(0,T.generateUuid)(),asString:async()=>"",asFile:()=>({name:O,uri:S,data:C}),value:void 0}}e.createFileDataTransferItem=L;class k{constructor(){this.a=new Map}get size(){return this.a.size}has(S){return this.a.has(this.b(S))}get(S){return this.a.get(this.b(S))?.[0]}append(S,C){const N=this.a.get(S);N?N.push(C):this.a.set(this.b(S),[C])}replace(S,C){this.a.set(this.b(S),[C])}delete(S){this.a.delete(this.b(S))}*entries(){for(const[S,C]of this.a.entries())for(const N of C)yield[S,N]}values(){return Array.from(this.a.values()).flat()}forEach(S){for(const[C,N]of this.entries())S(N,C)}b(S){return S.toLowerCase()}}e.VSDataTransfer=k,e.UriList=Object.freeze({create:O=>(0,i.distinct)(O.map(S=>S.toString())).join(`\r
`),split:O=>O.split(`\r
`),parse:O=>e.UriList.split(O).filter(S=>!S.startsWith("#"))})}),define(ke[114],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[115],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var i;(function(k){k[k.None=0]="None",k[k.Indent=1]="Indent",k[k.IndentOutdent=2]="IndentOutdent",k[k.Outdent=3]="Outdent"})(i=e.IndentAction||(e.IndentAction={}));class T{constructor(O){if(this.e=null,this.f=!1,this.open=O.open,this.close=O.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(O.notIn))for(let S=0,C=O.notIn.length;S<C;S++)switch(O.notIn[S]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(O){switch(O){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(O,S){if(O.getTokenCount()===0)return!0;const C=O.findTokenIndexAtOffset(S-2),N=O.getStandardTokenType(C);return this.isOK(N)}g(O,S){for(let C=O;C<=S;C++){const N=String.fromCharCode(C);if(!this.open.includes(N)&&!this.close.includes(N))return N}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=T;class y{constructor(O){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of O)L(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),L(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),L(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),L(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&L(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=y;function L(k,O,S){k.has(O)?k.get(O).push(S):k.set(O,[S])}}),define(ke[116],Ce([17,18]),function(ee,e){return ee.create("vs/base/common/date",e)}),define(ke[117],Ce([1,0,116]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const T=60,y=T*60,L=y*24,k=L*7,O=L*30,S=L*365;function C(D,m,p){typeof D!="number"&&(D=D.getTime());const f=Math.round((new Date().getTime()-D)/1e3);if(f<-30)return(0,i.localize)(0,null,C(new Date().getTime()+f*1e3,!1));if(f<30)return(0,i.localize)(1,null);let t;return f<T?(t=f,m?t===1?p?(0,i.localize)(2,null,t):(0,i.localize)(3,null,t):p?(0,i.localize)(4,null,t):(0,i.localize)(5,null,t):t===1?p?(0,i.localize)(6,null,t):(0,i.localize)(7,null,t):p?(0,i.localize)(8,null,t):(0,i.localize)(9,null,t)):f<y?(t=Math.floor(f/T),m?t===1?p?(0,i.localize)(10,null,t):(0,i.localize)(11,null,t):p?(0,i.localize)(12,null,t):(0,i.localize)(13,null,t):t===1?p?(0,i.localize)(14,null,t):(0,i.localize)(15,null,t):p?(0,i.localize)(16,null,t):(0,i.localize)(17,null,t)):f<L?(t=Math.floor(f/y),m?t===1?p?(0,i.localize)(18,null,t):(0,i.localize)(19,null,t):p?(0,i.localize)(20,null,t):(0,i.localize)(21,null,t):t===1?p?(0,i.localize)(22,null,t):(0,i.localize)(23,null,t):p?(0,i.localize)(24,null,t):(0,i.localize)(25,null,t)):f<k?(t=Math.floor(f/L),m?t===1?(0,i.localize)(26,null,t):(0,i.localize)(27,null,t):t===1?(0,i.localize)(28,null,t):(0,i.localize)(29,null,t)):f<O?(t=Math.floor(f/k),m?t===1?p?(0,i.localize)(30,null,t):(0,i.localize)(31,null,t):p?(0,i.localize)(32,null,t):(0,i.localize)(33,null,t):t===1?p?(0,i.localize)(34,null,t):(0,i.localize)(35,null,t):p?(0,i.localize)(36,null,t):(0,i.localize)(37,null,t)):f<S?(t=Math.floor(f/O),m?t===1?p?(0,i.localize)(38,null,t):(0,i.localize)(39,null,t):p?(0,i.localize)(40,null,t):(0,i.localize)(41,null,t):t===1?p?(0,i.localize)(42,null,t):(0,i.localize)(43,null,t):p?(0,i.localize)(44,null,t):(0,i.localize)(45,null,t)):(t=Math.floor(f/S),m?t===1?p?(0,i.localize)(46,null,t):(0,i.localize)(47,null,t):p?(0,i.localize)(48,null,t):(0,i.localize)(49,null,t):t===1?p?(0,i.localize)(50,null,t):(0,i.localize)(51,null,t):p?(0,i.localize)(52,null,t):(0,i.localize)(53,null,t))}e.fromNow=C;function N(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=N}),define(ke[118],Ce([17,18]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(ke[45],Ce([1,0,16,9,118]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(D,m){return m&&(D.stack||D.stacktrace)?y.localize(0,null,O(D),k(D.stack)||k(D.stacktrace)):O(D)}function k(D){return Array.isArray(D)?D.join(`
`):D}function O(D){return typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?y.localize(1,null,D.message):D.message||y.localize(2,null)}function S(D=null,m=!1){if(!D)return y.localize(3,null);if(Array.isArray(D)){const p=i.coalesce(D),f=S(p[0],m);return p.length>1?y.localize(4,null,f,p.length):f}if(T.isString(D))return D;if(D.detail){const p=D.detail;if(p.error)return L(p.error,m);if(p.exception)return L(p.exception,m)}return D.stack?L(D,m):D.message?D.message:y.localize(5,null)}e.toErrorMessage=S;function C(D){const m=D;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=C;function N(D,m){let p;return typeof D=="string"?p=new Error(D):p=D,p.actions=m,p}e.createErrorWithActions=N}),define(ke[62],Ce([1,0,19]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},y={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(N){const D=(0,i.extname)(N),m=T[D.toLowerCase()];return m!==void 0?m:k(N)}e.getMediaOrTextMime=L;function k(N){const D=(0,i.extname)(N);return y[D.toLowerCase()]}e.getMediaMime=k;function O(N){for(const D in y)if(y[D]===N)return D}e.getExtensionForMimeType=O;const S=/^(.+)\/(.+?)(;.+)?$/;function C(N,D){const m=S.exec(N);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:D?void 0:N}e.normalizeMimeType=C}),define(ke[39],Ce([1,0,19,21,10,9]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(s){return s===47||s===92}e.isPathSeparator=k;function O(s){return s.replace(/[\\/]/g,i.posix.sep)}e.toSlashes=O;function S(s){return s.indexOf("/")===-1&&(s=O(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=S;function C(s,u=i.posix.sep){if(!s)return"";const n=s.length,h=s.charCodeAt(0);if(k(h)){if(k(s.charCodeAt(1))&&!k(s.charCodeAt(2))){let P=3;const M=P;for(;P<n&&!k(s.charCodeAt(P));P++);if(M!==P&&!k(s.charCodeAt(P+1))){for(P+=1;P<n;P++)if(k(s.charCodeAt(P)))return s.slice(0,P+1).replace(/[\\/]/g,u)}}return u}else if(l(h)&&s.charCodeAt(1)===58)return k(s.charCodeAt(2))?s.slice(0,2)+u:s.slice(0,2);let g=s.indexOf("://");if(g!==-1){for(g+=3;g<n;g++)if(k(s.charCodeAt(g)))return s.slice(0,g+1)}return""}e.getRoot=C;function N(s){if(!T.isWindows||!s||s.length<5)return!1;let u=s.charCodeAt(0);if(u!==92||(u=s.charCodeAt(1),u!==92))return!1;let n=2;const h=n;for(;n<s.length&&(u=s.charCodeAt(n),u!==92);n++);return!(h===n||(u=s.charCodeAt(n+1),isNaN(u)||u===92))}e.isUNC=N;const D=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(s,u=T.isWindows){const n=u?D:m;return!(!s||s.length===0||/^\s+$/.test(s)||(n.lastIndex=0,n.test(s))||u&&p.test(s)||s==="."||s===".."||u&&s[s.length-1]==="."||u&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=f;function t(s,u,n){const h=s===u;return!n||h?h:!s||!u?!1:(0,y.equalsIgnoreCase)(s,u)}e.isEqual=t;function c(s,u,n,h=i.sep){if(s===u)return!0;if(!s||!u||u.length>s.length)return!1;if(n){if(!(0,y.startsWithIgnoreCase)(s,u))return!1;if(u.length===s.length)return!0;let P=u.length;return u.charAt(u.length-1)===h&&P--,s.charAt(P)===h}return u.charAt(u.length-1)!==h&&(u+=h),s.indexOf(u)===0}e.isEqualOrParent=c;function l(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=l;function v(s,u){return T.isWindows&&s.endsWith(":")&&(s+=i.sep),(0,i.isAbsolute)(s)||(s=(0,i.join)(u,s)),s=(0,i.normalize)(s),T.isWindows?(s=(0,y.rtrim)(s,i.sep),s.endsWith(":")&&(s+=i.sep)):(s=(0,y.rtrim)(s,i.sep),s||(s=i.sep)),s}e.sanitizeFilePath=v;function b(s){const u=(0,i.normalize)(s);return T.isWindows?s.length>3?!1:E(u)&&(s.length===2||u.charCodeAt(2)===92):u===i.posix.sep}e.isRootOrDriveLetter=b;function E(s,u=T.isWindows){return u?l(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=E;function w(s){return E(s)?s[0]:void 0}e.getDriveLetter=w;function r(s,u,n){return u.length>s.length?-1:s===u?0:(n&&(s=s.toLowerCase(),u=u.toLowerCase()),s.indexOf(u))}e.indexOfPath=r;function a(s){const u=s.split(":");let n,h,g;for(const P of u){const M=Number(P);(0,L.isNumber)(M)?h===void 0?h=M:g===void 0&&(g=M):n=n?[n,P].join(":"):P}if(!n)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:n,line:h!==void 0?h:void 0,column:g!==void 0?g:h!==void 0?1:void 0}}e.parseLineAndColumnAware=a;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function d(s,u,n=8){let h="";for(let P=0;P<n;P++)h+=o.charAt(Math.floor(Math.random()*o.length));let g;return u?g=`${u}-${h}`:g=h,s?(0,i.join)(s,g):g}e.randomPath=d}),define(ke[119],Ce([1,0,28,10]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function y(...Y){return function(I,$){for(let H=0,q=Y.length;H<q;H++){const J=Y[H](I,$);if(J)return J}return null}}e.or=y,e.matchesStrictPrefix=L.bind(void 0,!1),e.matchesPrefix=L.bind(void 0,!0);function L(Y,I,$){if(!$||$.length<I.length)return null;let H;return Y?H=T.startsWithIgnoreCase($,I):H=$.indexOf(I)===0,H?I.length>0?[{start:0,end:I.length}]:[]:null}function k(Y,I){const $=I.toLowerCase().indexOf(Y.toLowerCase());return $===-1?null:[{start:$,end:$+Y.length}]}e.matchesContiguousSubString=k;function O(Y,I){return S(Y.toLowerCase(),I.toLowerCase(),0,0)}e.matchesSubString=O;function S(Y,I,$,H){if($===Y.length)return[];if(H===I.length)return null;if(Y[$]===I[H]){let q=null;return(q=S(Y,I,$+1,H+1))?l({start:H,end:H+1},q):null}return S(Y,I,$,H+1)}function C(Y){return 97<=Y&&Y<=122}function N(Y){return 65<=Y&&Y<=90}e.isUpper=N;function D(Y){return 48<=Y&&Y<=57}function m(Y){return Y===32||Y===9||Y===10||Y===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Y=>p.add(Y.charCodeAt(0)));function f(Y){return m(Y)||p.has(Y)}function t(Y,I){return Y===I||f(Y)&&f(I)}function c(Y){return C(Y)||N(Y)||D(Y)}function l(Y,I){return I.length===0?I=[Y]:Y.end===I[0].start?I[0].start=Y.start:I.unshift(Y),I}function v(Y,I){for(let $=I;$<Y.length;$++){const H=Y.charCodeAt($);if(N(H)||D(H)||$>0&&!c(Y.charCodeAt($-1)))return $}return Y.length}function b(Y,I,$,H){if($===Y.length)return[];if(H===I.length)return null;if(Y[$]!==I[H].toLowerCase())return null;{let q=null,J=H+1;for(q=b(Y,I,$+1,H+1);!q&&(J=v(I,J))<I.length;)q=b(Y,I,$+1,J),J++;return q===null?null:l({start:H,end:H+1},q)}}function E(Y){let I=0,$=0,H=0,q=0,J=0;for(let ve=0;ve<Y.length;ve++)J=Y.charCodeAt(ve),N(J)&&I++,C(J)&&$++,c(J)&&H++,D(J)&&q++;const de=I/Y.length,we=$/Y.length,ae=H/Y.length,pe=q/Y.length;return{upperPercent:de,lowerPercent:we,alphaPercent:ae,numericPercent:pe}}function w(Y){const{upperPercent:I,lowerPercent:$}=Y;return $===0&&I>.6}function r(Y){const{upperPercent:I,lowerPercent:$,alphaPercent:H,numericPercent:q}=Y;return $>.2&&I<.8&&H>.6&&q<.2}function a(Y){let I=0,$=0,H=0,q=0;for(let J=0;J<Y.length;J++)H=Y.charCodeAt(J),N(H)&&I++,C(H)&&$++,m(H)&&q++;return(I===0||$===0)&&q===0?Y.length<=30:I<=5}function o(Y,I){if(!I||(I=I.trim(),I.length===0)||!a(Y)||I.length>60)return null;const $=E(I);if(!r($)){if(!w($))return null;I=I.toLowerCase()}let H=null,q=0;for(Y=Y.toLowerCase();q<I.length&&(H=b(Y,I,0,q))===null;)q=v(I,q+1);return H}e.matchesCamelCase=o;function d(Y,I,$=!1){if(!I||I.length===0)return null;let H=null,q=0;for(Y=Y.toLowerCase(),I=I.toLowerCase();q<I.length&&(H=s(Y,I,0,q,$))===null;)q=u(I,q+1);return H}e.matchesWords=d;function s(Y,I,$,H,q){if($===Y.length)return[];if(H===I.length)return null;if(t(Y.charCodeAt($),I.charCodeAt(H))){let J=null,de=H+1;if(J=s(Y,I,$+1,H+1,q),!q)for(;!J&&(de=u(I,de))<I.length;)J=s(Y,I,$+1,de,q),de++;return J?Y.charCodeAt($)!==I.charCodeAt(H)?J:l({start:H,end:H+1},J):null}else return null}function u(Y,I){for(let $=I;$<Y.length;$++)if(f(Y.charCodeAt($))||$>0&&f(Y.charCodeAt($-1)))return $;return Y.length}const n=y(e.matchesPrefix,o,k),h=y(e.matchesPrefix,o,O),g=new i.LRUCache(1e4);function P(Y,I,$=!1){if(typeof Y!="string"||typeof I!="string")return null;let H=g.get(Y);H||(H=new RegExp(T.convertSimple2RegExpPattern(Y),"i"),g.set(Y,H));const q=H.exec(I);return q?[{start:q.index,end:q.index+q[0].length}]:$?h(Y,I):n(Y,I)}e.matchesFuzzy=P;function M(Y,I){const $=Be(Y,Y.toLowerCase(),0,I,I.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return $?Z($):null}e.matchesFuzzy2=M;function j(Y,I,$,H,q,J){const de=Math.min(13,Y.length);for(;$<de;$++){const we=Be(Y,I,$,H,q,J,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(we)return we}return[0,J]}e.anyScore=j;function Z(Y){if(typeof Y>"u")return[];const I=[],$=Y[1];for(let H=Y.length-1;H>1;H--){const q=Y[H]+$,J=I[I.length-1];J&&J.end===q?J.end=q+1:I.push({start:q,end:q+1})}return I}e.createMatches=Z;const G=128;function A(){const Y=[],I=[];for(let $=0;$<=G;$++)I[$]=0;for(let $=0;$<=G;$++)Y.push(I.slice(0));return Y}function R(Y){const I=[];for(let $=0;$<=Y;$++)I[$]=0;return I}const F=R(2*G),B=R(2*G),z=A(),V=A(),K=A(),ie=!1;function me(Y,I,$,H,q){function J(we,ae,pe=" "){for(;we.length<ae;)we=pe+we;return we}let de=` |   |${H.split("").map(we=>J(we,3)).join("|")}
`;for(let we=0;we<=$;we++)we===0?de+=" |":de+=`${I[we-1]}|`,de+=Y[we].slice(0,q+1).map(ae=>J(ae.toString(),3)).join("|")+`
`;return de}function ue(Y,I,$,H){Y=Y.substr(I),$=$.substr(H),console.log(me(V,Y,Y.length,$,$.length)),console.log(me(K,Y,Y.length,$,$.length)),console.log(me(z,Y,Y.length,$,$.length))}function oe(Y,I){if(I<0||I>=Y.length)return!1;const $=Y.codePointAt(I);switch($){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!T.isEmojiImprecise($)}}function De(Y,I){if(I<0||I>=Y.length)return!1;switch(Y.charCodeAt(I)){case 32:case 9:return!0;default:return!1}}function re(Y,I,$){return I[Y]!==$[Y]}function Q(Y,I,$,H,q,J,de=!1){for(;I<$&&q<J;)Y[I]===H[q]&&(de&&(F[I]=q),I+=1),q+=1;return I===$}e.isPatternInWord=Q;var le;(function(Y){Y[Y.Diag=1]="Diag",Y[Y.Left=2]="Left",Y[Y.LeftLeft=3]="LeftLeft"})(le||(le={}));var Ee;(function(Y){Y.Default=[-100,0];function I($){return!$||$.length===2&&$[0]===-100&&$[1]===0}Y.isDefault=I})(Ee=e.FuzzyScore||(e.FuzzyScore={}));class Ae{constructor(I,$){this.firstMatchCanBeWeak=I,this.boostFullMatch=$}}e.FuzzyScoreOptions=Ae,Ae.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Be(Y,I,$,H,q,J,de=Ae.default){const we=Y.length>G?G:Y.length,ae=H.length>G?G:H.length;if($>=we||J>=ae||we-$>ae-J||!Q(I,$,we,q,J,ae,!0))return;xe(we,ae,$,J,I,q);let pe=1,ve=1,We=$,He=J;const tt=[!1];for(pe=1,We=$;We<we;pe++,We++){const Fe=F[We],st=B[We],_=We+1<we?B[We+1]:ae;for(ve=Fe-J+1,He=Fe;He<_;ve++,He++){let X=Number.MIN_SAFE_INTEGER,ge=!1;He<=st&&(X=Te(Y,I,We,$,H,q,He,ae,J,z[pe-1][ve-1]===0,tt));let Me=0;X!==Number.MAX_SAFE_INTEGER&&(ge=!0,Me=X+V[pe-1][ve-1]);const $e=He>Fe,je=$e?V[pe][ve-1]+(z[pe][ve-1]>0?-5:0):0,_e=He>Fe+1&&z[pe][ve-1]>0,nt=_e?V[pe][ve-2]+(z[pe][ve-2]>0?-5:0):0;if(_e&&(!$e||nt>=je)&&(!ge||nt>=Me))V[pe][ve]=nt,K[pe][ve]=3,z[pe][ve]=0;else if($e&&(!ge||je>=Me))V[pe][ve]=je,K[pe][ve]=2,z[pe][ve]=0;else if(ge)V[pe][ve]=Me,K[pe][ve]=1,z[pe][ve]=z[pe-1][ve-1]+1;else throw new Error("not possible")}}if(ie&&ue(Y,$,H,J),!tt[0]&&!de.firstMatchCanBeWeak)return;pe--,ve--;const Xe=[V[pe][ve],J];let et=0,it=0;for(;pe>=1;){let Fe=ve;do{const st=K[pe][Fe];if(st===3)Fe=Fe-2;else if(st===2)Fe=Fe-1;else break}while(Fe>=1);et>1&&I[$+pe-1]===q[J+ve-1]&&!re(Fe+J-1,H,q)&&et+1>z[pe][Fe]&&(Fe=ve),Fe===ve?et++:et=1,it||(it=Fe),pe--,ve=Fe-1,Xe.push(ve)}ae===we&&de.boostFullMatch&&(Xe[0]+=2);const dt=it-we;return Xe[0]-=dt,Xe}e.fuzzyScore=Be;function xe(Y,I,$,H,q,J){let de=Y-1,we=I-1;for(;de>=$&&we>=H;)q[de]===J[we]&&(B[de]=we,de--),we--}function Te(Y,I,$,H,q,J,de,we,ae,pe,ve){if(I[$]!==J[de])return Number.MIN_SAFE_INTEGER;let We=1,He=!1;return de===$-H?We=Y[$]===q[de]?7:5:re(de,q,J)&&(de===0||!re(de-1,q,J))?(We=Y[$]===q[de]?7:5,He=!0):oe(J,de)&&(de===0||!oe(J,de-1))?We=5:(oe(J,de-1)||De(J,de-1))&&(We=5,He=!0),We>1&&$===H&&(ve[0]=!0),He||(He=re(de,q,J)||oe(J,de-1)||De(J,de-1)),$===H?de>ae&&(We-=He?3:5):pe?We+=He?2:0:We+=He?0:1,de+1===we&&(We-=He?3:5),We}function Ie(Y,I,$,H,q,J,de){return se(Y,I,$,H,q,J,!0,de)}e.fuzzyScoreGracefulAggressive=Ie;function Se(Y,I,$,H,q,J,de){return se(Y,I,$,H,q,J,!1,de)}e.fuzzyScoreGraceful=Se;function se(Y,I,$,H,q,J,de,we){let ae=Be(Y,I,$,H,q,J,we);if(ae&&!de)return ae;if(Y.length>=3){const pe=Math.min(7,Y.length-1);for(let ve=$+1;ve<pe;ve++){const We=ce(Y,ve);if(We){const He=Be(We,We.toLowerCase(),$,H,q,J,we);He&&(He[0]-=3,(!ae||He[0]>ae[0])&&(ae=He))}}}return ae}function ce(Y,I){if(I+1>=Y.length)return;const $=Y[I],H=Y[I+1];if($!==H)return Y.slice(0,I)+H+$+Y.slice(I+2)}}),define(ke[120],Ce([1,0,121,119,10]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const L="$(",k=new RegExp(`\\$\\(${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?\\)`,"g"),O=new RegExp(`(\\\\)?${k.source}`,"g");function S(c){return c.replace(O,(l,v)=>v?l:`\\${l}`)}e.escapeIcons=S;const C=new RegExp(`\\\\${k.source}`,"g");function N(c){return c.replace(C,l=>`\\${l}`)}e.markdownEscapeEscapedIcons=N;const D=new RegExp(`(\\s)?(\\\\)?${k.source}(\\s)?`,"g");function m(c){return c.indexOf(L)===-1?c:c.replace(D,(l,v,b,E)=>b?l:v||E||"")}e.stripIcons=m;const p=new RegExp(`\\$\\(${i.CSSIcon.iconNameCharacter}+\\)`,"g");function f(c){p.lastIndex=0;let l="";const v=[];let b=0;for(;;){const E=p.lastIndex,w=p.exec(c),r=c.substring(E,w?.index);if(r.length>0){l+=r;for(let a=0;a<r.length;a++)v.push(b)}if(!w)break;b+=w[0].length}return{text:l,iconOffsets:v}}e.parseLabelWithIcons=f;function t(c,l,v=!1){const{text:b,iconOffsets:E}=l;if(!E||E.length===0)return(0,T.matchesFuzzy)(c,b,v);const w=(0,y.ltrim)(b," "),r=b.length-w.length,a=(0,T.matchesFuzzy)(c,w,v);if(a)for(const o of a){const d=E[o.start+r]+r;o.start+=d,o.end+=d}return a}e.matchesFuzzyIconAware=t}),define(ke[29],Ce([1,0,10]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(y){y[y.Ignore=0]="Ignore",y[y.Info=1]="Info",y[y.Warning=2]="Warning",y[y.Error=3]="Error"})(T||(T={})),function(y){const L="error",k="warning",O="warn",S="info",C="ignore";function N(m){return m?i.equalsIgnoreCase(L,m)?y.Error:i.equalsIgnoreCase(k,m)||i.equalsIgnoreCase(O,m)?y.Warning:i.equalsIgnoreCase(S,m)?y.Info:y.Ignore:y.Ignore}y.fromValue=N;function D(m){switch(m){case y.Error:return L;case y.Warning:return k;case y.Info:return S;default:return C}}y.toString=D}(T||(T={})),e.default=T}),define(ke[46],Ce([1,0,16,10]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class y{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const f=p.charCodeAt(0),t=this.b.charCodeAt(this.c);return f-t}value(){return this.b[this.c]}}e.StringIterator=y;class L{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,T.compareSubstring)(p,this.b,0,p.length,this.c,this.d):(0,T.compareSubstringIgnoreCase)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=L;class k{constructor(p=!0,f=!0){this.f=p,this.g=f}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let f=p.length-1;f>=0;f--,this.c--){const t=this.b.charCodeAt(f);if(!(t===47||this.f&&t===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===47||this.f&&f===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,T.compareSubstring)(p,this.b,0,p.length,this.d,this.e):(0,T.compareSubstringIgnoreCase)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=k;var O;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(O||(O={}));class S{constructor(p,f){this.f=p,this.g=f,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new k(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,T.compareIgnoreCase)(p,this.c.scheme);if(this.d[this.e]===2)return(0,T.compareIgnoreCase)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,T.compare)(p,this.c.query);if(this.d[this.e]===5)return(0,T.compare)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=S;class C{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var N;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(N||(N={}));class D{static forUris(p=()=>!1,f=()=>!1){return new D(new S(p,f))}static forPaths(p=!1){return new D(new k(void 0,!p))}static forStrings(){return new D(new y)}static forConfigKeys(){return new D(new L)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,f){if(f){const t=f.slice(0);(0,i.shuffle)(t);for(const c of t)this.set(c,p)}else{const t=p.slice(0);(0,i.shuffle)(t);for(const c of t)this.set(c[0],c[1])}}set(p,f){const t=this.b.reset(p);let c;this.c||(this.c=new C,this.c.segment=t.value());const l=[];for(c=this.c;;){const b=t.cmp(c.segment);if(b>0)c.left||(c.left=new C,c.left.segment=t.value()),l.push([-1,c]),c=c.left;else if(b<0)c.right||(c.right=new C,c.right.segment=t.value()),l.push([1,c]),c=c.right;else if(t.hasNext())t.next(),c.mid||(c.mid=new C,c.mid.segment=t.value()),l.push([0,c]),c=c.mid;else break}const v=c.value;c.value=f,c.key=p;for(let b=l.length-1;b>=0;b--){const E=l[b][1];E.updateHeight();const w=E.balanceFactor();if(w<-1||w>1){const r=l[b][0],a=l[b+1][0];if(r===1&&a===1)l[b][1]=E.rotateLeft();else if(r===-1&&a===-1)l[b][1]=E.rotateRight();else if(r===1&&a===-1)E.right=l[b+1][1]=l[b+1][1].rotateRight(),l[b][1]=E.rotateLeft();else if(r===-1&&a===1)E.left=l[b+1][1]=l[b+1][1].rotateLeft(),l[b][1]=E.rotateRight();else throw new Error;if(b>0)switch(l[b-1][0]){case-1:l[b-1][1].left=l[b][1];break;case 1:l[b-1][1].right=l[b][1];break;case 0:l[b-1][1].mid=l[b][1];break}else this.c=l[0][1]}}return v}get(p){return this.d(p)?.value}d(p){const f=this.b.reset(p);let t=this.c;for(;t;){const c=f.cmp(t.segment);if(c>0)t=t.left;else if(c<0)t=t.right;else if(f.hasNext())f.next(),t=t.mid;else break}return t}has(p){const f=this.d(p);return!(f?.value===void 0&&f?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,f){const t=this.b.reset(p),c=[];let l=this.c;for(;l;){const v=t.cmp(l.segment);if(v>0)c.push([-1,l]),l=l.left;else if(v<0)c.push([1,l]),l=l.right;else if(t.hasNext())t.next(),c.push([0,l]),l=l.mid;else break}if(!!l){if(f?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const v=this.f(l.right);if(v.key){const{key:b,value:E,segment:w}=v;this.e(v.key,!1),l.key=b,l.value=E,l.segment=w}}else{const v=l.left??l.right;if(c.length>0){const[b,E]=c[c.length-1];switch(b){case-1:E.left=v;break;case 0:E.mid=v;break;case 1:E.right=v;break}}else this.c=v}for(let v=c.length-1;v>=0;v--){const b=c[v][1];b.updateHeight();const E=b.balanceFactor();if(E>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),c[v][1]=b.rotateLeft()):E<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),c[v][1]=b.rotateRight()),v>0)switch(c[v-1][0]){case-1:c[v-1][1].left=c[v][1];break;case 1:c[v-1][1].right=c[v][1];break;case 0:c[v-1][1].mid=c[v][1];break}else this.c=c[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const f=this.b.reset(p);let t=this.c,c;for(;t;){const l=f.cmp(t.segment);if(l>0)t=t.left;else if(l<0)t=t.right;else if(f.hasNext())f.next(),c=t.value||c,t=t.mid;else break}return t&&t.value||c}findSuperstr(p){const f=this.b.reset(p);let t=this.c;for(;t;){const c=f.cmp(t.segment);if(c>0)t=t.left;else if(c<0)t=t.right;else if(f.hasNext())f.next(),t=t.mid;else return t.mid?this.g(t.mid):void 0}}forEach(p){for(const[f,t]of this)p(t,f)}*[Symbol.iterator](){yield*this.g(this.c)}g(p){const f=[];return this.h(p,f),f[Symbol.iterator]()}h(p,f){!p||(p.left&&this.h(p.left,f),p.value&&f.push([p.key,p.value]),p.mid&&this.h(p.mid,f),p.right&&this.h(p.right,f))}_isBalanced(){const p=f=>{if(!f)return!0;const t=f.balanceFactor();return t<-1||t>1?!1:p(f.left)&&p(f.right)};return p(this.c)}}e.TernarySearchTree=D}),define(ke[82],Ce([1,0,24,10,2]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(C){return JSON.stringify(C,O)}e.stringify=L;function k(C){let N=JSON.parse(C);return N=S(N),N}e.parse=k;function O(C,N){return N instanceof RegExp?{$mid:2,source:N.source,flags:(0,T.regExpFlags)(N)}:N}function S(C,N=0){if(!C||N>200)return C;if(typeof C=="object"){switch(C.$mid){case 1:return y.URI.revive(C);case 2:return new RegExp(C.source,C.flags);case 16:return new Date(C.source)}if(C instanceof i.VSBuffer||C instanceof Uint8Array)return C;if(Array.isArray(C))for(let D=0;D<C.length;++D)C[D]=S(C[D],N+1);else for(const D in C)Object.hasOwnProperty.call(C,D)&&(C[D]=S(C[D],N+1))}return C}e.revive=S}),define(ke[13],Ce([1,0,21,2]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var y;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls",S.vscodeSourceControl="vscode-scm"})(y=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class L{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${y.vscodeRemoteResource}`}setPreferredWebSchema(C){this.d=C}setDelegate(C){this.e=C}setServerRootPath(C){this.f=`${C}/${y.vscodeRemoteResource}`}set(C,N,D){this.a[C]=N,this.b[C]=D}setConnectionToken(C,N){this.c[C]=N}getPreferredWebSchema(){return this.d}rewrite(C){if(this.e)return this.e(C);const N=C.authority;let D=this.a[N];D&&D.indexOf(":")!==-1&&D.indexOf("[")===-1&&(D=`[${D}]`);const m=this.b[N],p=this.c[N];let f=`path=${encodeURIComponent(C.path)}`;return typeof p=="string"&&(f+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),T.URI.from({scheme:i.isWeb?this.d:y.vscodeRemoteResource,authority:`${D}:${m}`,path:this.f,query:f})}}e.RemoteAuthorities=new L,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class k{asBrowserUri(C){const N=this.b(C,ee);return this.uriToBrowserUri(N)}uriToBrowserUri(C){return C.scheme===y.vscodeRemote?e.RemoteAuthorities.rewrite(C):C.scheme===y.file&&(i.isNative||i.isWebWorker&&i.globals.origin===`${y.vscodeFileResource}://${k.a}`)?C.with({scheme:y.vscodeFileResource,authority:C.authority||k.a,query:null,fragment:null}):C}asFileUri(C){const N=this.b(C,ee);return this.uriToFileUri(N)}uriToFileUri(C){return C.scheme===y.vscodeFileResource?C.with({scheme:y.file,authority:C.authority!==k.a?C.authority:null,query:null,fragment:null}):C}b(C,N){return T.URI.isUri(C)?C:T.URI.parse(N.toUrl(C))}}k.a="vscode-app",e.FileAccess=new k;var O;(function(S){const C=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);S.CoopAndCoep=Object.freeze(C.get("3"));const N="vscode-coi";function D(p){let f;typeof p=="string"?f=new URL(p).searchParams:p instanceof URL?f=p.searchParams:T.URI.isUri(p)&&(f=new URL(p.toString(!0)).searchParams);const t=f?.get(N);if(!!t)return C.get(t)}S.getHeadersFromQuery=D;function m(p,f,t){if(!globalThis.crossOriginIsolated)return;const c=f&&t?"3":t?"2":"1";p instanceof URLSearchParams?p.set(N,c):p[N]=c}S.addSearchParam=m})(O=e.COI||(e.COI={}))}),define(ke[22],Ce([1,0,39,13,19,21,10,2]),function(ee,e,i,T,y,L,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(p){return(0,O.uriToFsPath)(p,!0)}e.originalFSPath=S;class C{constructor(f){this.a=f}compare(f,t,c=!1){return f===t?0:(0,k.compare)(this.getComparisonKey(f,c),this.getComparisonKey(t,c))}isEqual(f,t,c=!1){return f===t?!0:!f||!t?!1:this.getComparisonKey(f,c)===this.getComparisonKey(t,c)}getComparisonKey(f,t=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:t?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,t,c=!1){if(f.scheme===t.scheme){if(f.scheme===T.Schemas.file)return i.isEqualOrParent(S(f),S(t),this.a(f))&&f.query===t.query&&(c||f.fragment===t.fragment);if((0,e.isEqualAuthority)(f.authority,t.authority))return i.isEqualOrParent(f.path,t.path,this.a(f),"/")&&f.query===t.query&&(c||f.fragment===t.fragment)}return!1}joinPath(f,...t){return O.URI.joinPath(f,...t)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return y.posix.basename(f.path)}extname(f){return y.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let t;return f.scheme===T.Schemas.file?t=O.URI.file(y.dirname(S(f))).path:(t=y.posix.dirname(f.path),f.authority&&t.length&&t.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),t="/")),f.with({path:t})}normalizePath(f){if(!f.path.length)return f;let t;return f.scheme===T.Schemas.file?t=O.URI.file(y.normalize(S(f))).path:t=y.posix.normalize(f.path),f.with({path:t})}relativePath(f,t){if(f.scheme!==t.scheme||!(0,e.isEqualAuthority)(f.authority,t.authority))return;if(f.scheme===T.Schemas.file){const v=y.relative(S(f),S(t));return L.isWindows?i.toSlashes(v):v}let c=f.path||"/";const l=t.path||"/";if(this.a(f)){let v=0;for(const b=Math.min(c.length,l.length);v<b&&!(c.charCodeAt(v)!==l.charCodeAt(v)&&c.charAt(v).toLowerCase()!==l.charAt(v).toLowerCase());v++);c=l.substr(0,v)+c.substr(v)}return y.posix.relative(c,l)}resolvePath(f,t){if(f.scheme===T.Schemas.file){const c=O.URI.file(y.resolve(S(f),t));return f.with({authority:c.authority,path:c.path})}return t=i.toPosixPath(t),f.with({path:y.posix.resolve(f.path,t)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,t){return f===t||f!==void 0&&t!==void 0&&(0,k.equalsIgnoreCase)(f,t)}hasTrailingPathSeparator(f,t=y.sep){if(f.scheme===T.Schemas.file){const c=S(f);return c.length>i.getRoot(c).length&&c[c.length-1]===t}else{const c=f.path;return c.length>1&&c.charCodeAt(c.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,t=y.sep){return(0,e.hasTrailingPathSeparator)(f,t)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,t=y.sep){let c=!1;if(f.scheme===T.Schemas.file){const l=S(f);c=l!==void 0&&l.length===i.getRoot(l).length&&l[l.length-1]===t}else{t="/";const l=f.path;c=l.length===1&&l.charCodeAt(l.length-1)===47}return!c&&!(0,e.hasTrailingPathSeparator)(f,t)?f.with({path:f.path+"/"}):f}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(p=>p.scheme===T.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new C(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function N(p,f){const t=[];for(let c=0;c<p.length;c++){const l=f(p[c]);p.some((v,b)=>b===c?!1:(0,e.isEqualOrParent)(l,f(v)))||t.push(p[c])}return t}e.distinctParents=N;var D;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function f(t){const c=new Map;t.path.substring(t.path.indexOf(";")+1,t.path.lastIndexOf(";")).split(";").forEach(b=>{const[E,w]=b.split(":");E&&w&&c.set(E,w)});const v=t.path.substring(0,t.path.indexOf(";"));return v&&c.set(p.META_DATA_MIME,v),c}p.parseMetaData=f})(D=e.DataUri||(e.DataUri={}));function m(p,f,t){if(f){let c=p.path;return c&&c[0]!==y.posix.sep&&(c=y.posix.sep+c),p.with({scheme:t,authority:f,path:c})}return p.with({scheme:t})}e.toLocalResource=m}),define(ke[14],Ce([1,0,20,11,5,7,22,21]),function(ee,e,i,T,y,L,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(re){return!!re&&typeof re.then=="function"}e.isThenable=S;function C(re){const Q=new i.CancellationTokenSource,le=re(Q.token),Ee=new Promise((Ae,Be)=>{const xe=Q.token.onCancellationRequested(()=>{xe.dispose(),Q.dispose(),Be(new T.CancellationError)});Promise.resolve(le).then(Te=>{xe.dispose(),Q.dispose(),Ae(Te)},Te=>{xe.dispose(),Q.dispose(),Be(Te)})});return new class{cancel(){Q.cancel()}then(Ae,Be){return Ee.then(Ae,Be)}catch(Ae){return this.then(void 0,Ae)}finally(Ae){return Ee.finally(Ae)}}}e.createCancelablePromise=C;function N(re,Q,le){return new Promise((Ee,Ae)=>{const Be=Q.onCancellationRequested(()=>{Be.dispose(),Ee(le)});re.then(Ee,Ae).finally(()=>Be.dispose())})}e.raceCancellation=N;function D(re,Q){return new Promise((le,Ee)=>{const Ae=Q.onCancellationRequested(()=>{Ae.dispose(),Ee(new T.CancellationError)});re.then(le,Ee).finally(()=>Ae.dispose())})}e.raceCancellationError=D;async function m(re){let Q=-1;const le=re.map((Ae,Be)=>Ae.then(xe=>(Q=Be,xe))),Ee=await Promise.race(le);return re.forEach((Ae,Be)=>{Be!==Q&&Ae.cancel()}),Ee}e.raceCancellablePromises=m;function p(re,Q,le){let Ee;const Ae=setTimeout(()=>{Ee?.(void 0),le?.()},Q);return Promise.race([re.finally(()=>clearTimeout(Ae)),new Promise(Be=>Ee=Be)])}e.raceTimeout=p;function f(re){return new Promise((Q,le)=>{const Ee=re();S(Ee)?Ee.then(Q,le):Q(Ee)})}e.asPromise=f;class t{constructor(){this.a=null,this.b=null,this.d=null}queue(Q){if(this.a){if(this.d=Q,!this.b){const le=()=>{this.b=null;const Ee=this.queue(this.d);return this.d=null,Ee};this.b=new Promise(Ee=>{this.a.then(le,le).then(Ee)})}return new Promise((le,Ee)=>{this.b.then(le,Ee)})}return this.a=Q(),new Promise((le,Ee)=>{this.a.then(Ae=>{this.a=null,le(Ae)},Ae=>{this.a=null,Ee(Ae)})})}}e.Throttler=t;class c{constructor(){this.a=Promise.resolve(null)}queue(Q){return this.a=this.a.then(()=>Q(),()=>Q())}}e.Sequencer=c;class l{constructor(){this.a=new Map}queue(Q,le){const Ae=(this.a.get(Q)??Promise.resolve()).catch(()=>{}).then(le).finally(()=>{this.a.get(Q)===Ae&&this.a.delete(Q)});return this.a.set(Q,Ae),Ae}}e.SequencerByKey=l;const v=(re,Q)=>{let le=!0;const Ee=setTimeout(()=>{le=!1,Q()},re);return{isTriggered:()=>le,dispose:()=>{clearTimeout(Ee),le=!1}}},b=re=>{let Q=!0;return queueMicrotask(()=>{Q&&(Q=!1,re())}),{isTriggered:()=>Q,dispose:()=>{Q=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class E{constructor(Q){this.defaultDelay=Q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Q,le=this.defaultDelay){this.g=Q,this.h(),this.b||(this.b=new Promise((Ae,Be)=>{this.d=Ae,this.f=Be}).then(()=>{if(this.b=null,this.d=null,this.g){const Ae=this.g;return this.g=null,Ae()}}));const Ee=()=>{this.a=null,this.d?.(null)};return this.a=le===e.MicrotaskDelay?b(Ee):v(le,Ee),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=E;class w{constructor(Q){this.a=new E(Q),this.b=new t}trigger(Q,le){return this.a.trigger(()=>this.b.queue(Q),le)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=w;class r{constructor(){this.a=!1,this.b=new Promise((Q,le)=>{this.d=Q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=r;class a extends r{constructor(Q){super(),this.f=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=a;function o(re,Q){return Q?new Promise((le,Ee)=>{const Ae=setTimeout(()=>{Be.dispose(),le()},re),Be=Q.onCancellationRequested(()=>{clearTimeout(Ae),Be.dispose(),Ee(new T.CancellationError)})}):C(le=>o(re,le))}e.timeout=o;function d(re,Q=0){const le=setTimeout(re,Q);return(0,L.toDisposable)(()=>clearTimeout(le))}e.disposableTimeout=d;function s(re){const Q=[];let le=0;const Ee=re.length;function Ae(){return le<Ee?re[le++]():null}function Be(xe){xe!=null&&Q.push(xe);const Te=Ae();return Te?Te.then(Be):Promise.resolve(Q)}return Promise.resolve(null).then(Be)}e.sequence=s;function u(re,Q=Ee=>!!Ee,le=null){let Ee=0;const Ae=re.length,Be=()=>{if(Ee>=Ae)return Promise.resolve(le);const xe=re[Ee++];return Promise.resolve(xe()).then(Ie=>Q(Ie)?Promise.resolve(Ie):Be())};return Be()}e.first=u;function n(re,Q=Ee=>!!Ee,le=null){if(re.length===0)return Promise.resolve(le);let Ee=re.length;const Ae=()=>{Ee=-1;for(const Be of re)Be.cancel?.()};return new Promise((Be,xe)=>{for(const Te of re)Te.then(Ie=>{--Ee>=0&&Q(Ie)?(Ae(),Be(Ie)):Ee===0&&Be(le)}).catch(Ie=>{--Ee>=0&&(Ae(),xe(Ie))})})}e.firstParallel=n;class h{constructor(Q){this.a=0,this.d=Q,this.f=[],this.b=0,this.g=new y.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(Q){return this.a++,new Promise((le,Ee)=>{this.f.push({factory:Q,c:le,e:Ee}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const Q=this.f.shift();this.b++;const le=Q.factory();le.then(Q.c,Q.e),le.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=h;class g extends h{constructor(){super(1)}}e.Queue=g;class P{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const Q=new K;return this.b.add(Q),Q.p}d(){for(const[,Q]of this.a)if(Q.size>0)return!1;return!0}queueFor(Q,le=k.extUri){const Ee=le.getComparisonKey(Q);let Ae=this.a.get(Ee);return Ae||(Ae=new g,y.Event.once(Ae.onDrained)(()=>{Ae?.dispose(),this.a.delete(Ee),this.f()}),this.a.set(Ee,Ae)),Ae}f(){!this.d()||this.g()}g(){for(const Q of this.b)Q.complete();this.b.clear()}dispose(){for(const[,Q]of this.a)Q.dispose();this.a.clear(),this.g()}}e.ResourceQueue=P;class M{constructor(Q,le){this.a=-1,typeof Q=="function"&&typeof le=="number"&&this.setIfNotSet(Q,le)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Q,le){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Q()},le)}setIfNotSet(Q,le){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Q()},le))}}e.TimeoutTimer=M;class j{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(Q,le){this.cancel(),this.a=setInterval(()=>{Q()},le)}}e.IntervalTimer=j;class Z{constructor(Q,le){this.b=-1,this.a=Q,this.d=le,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Q=this.d){this.cancel(),this.b=setTimeout(this.f,Q)}get delay(){return this.d}set delay(Q){this.d=Q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=Z;class G{constructor(Q,le){le%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${le}ms is not a multiple of 1000ms.`),this.a=Q,this.b=le,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Q=this.b){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=G;class A extends Z{constructor(Q,le){super(Q,le),this.j=[]}work(Q){this.j.push(Q),this.isScheduled()||this.schedule()}h(){const Q=this.j;this.j=[],this.a?.(Q)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=A;class R extends L.Disposable{constructor(Q,le){super(),this.g=Q,this.h=le,this.a=[],this.b=this.B(new L.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(Q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Q.length>this.g.maxBufferedWork)return!1}else if(this.pending+Q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const le of Q)this.a.push(le);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=R,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=re=>{(0,O.setTimeout0)(()=>{if(Q)return;const le=Date.now()+15;re(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,le-Date.now())}}))});let Q=!1;return{dispose(){Q||(Q=!0)}}}:e.runWhenIdle=(re,Q)=>{const le=requestIdleCallback(re,typeof Q=="number"?{timeout:Q}:void 0);let Ee=!1;return{dispose(){Ee||(Ee=!0,cancelIdleCallback(le))}}}}();class F{constructor(Q){this.d=!1,this.a=()=>{try{this.f=Q()}catch(le){this.g=le}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=F;async function B(re,Q,le){let Ee;for(let Ae=0;Ae<le;Ae++)try{return await re()}catch(Be){Ee=Be,await o(Q)}throw Ee}e.retry=B;class z{hasPending(Q){return this.a?typeof Q=="number"?this.a.taskId===Q:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(Q,le,Ee){return this.a={taskId:Q,cancel:()=>Ee?.(),promise:le},le.then(()=>this.d(Q),()=>this.d(Q)),le}d(Q){this.a&&Q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Q=this.b;this.b=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}setNext(Q){if(this.b)this.b.run=Q;else{let le,Ee;const Ae=new Promise((Be,xe)=>{le=Be,Ee=xe});this.b={run:Q,promise:Ae,promiseResolve:le,promiseReject:Ee}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=z;class V{constructor(Q,le=()=>Date.now()){this.d=Q,this.f=le,this.a=0,this.b=0}increment(){const Q=this.f();return Q-this.a>this.d&&(this.a=Q,this.b=0),this.b++,this.b}}e.IntervalCounter=V;class K{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((Q,le)=>{this.a=Q,this.b=le})}complete(Q){return new Promise(le=>{this.a(Q),this.f=!0,le()})}error(Q){return new Promise(le=>{this.b(Q),this.d=!0,le()})}cancel(){new Promise(Q=>{this.b(new T.CancellationError),this.d=!0,Q()})}}e.DeferredPromise=K;var ie;(function(re){async function Q(Ee){let Ae;const Be=await Promise.all(Ee.map(xe=>xe.then(Te=>Te,Te=>{Ae||(Ae=Te)})));if(typeof Ae<"u")throw Ae;return Be}re.settled=Q;function le(Ee){return new Promise(async(Ae,Be)=>{try{await Ee(Ae,Be)}catch(xe){Be(xe)}})}re.withAsyncBody=le})(ie=e.Promises||(e.Promises={}));var me;(function(re){re[re.Initial=0]="Initial",re[re.DoneOK=1]="DoneOK",re[re.DoneError=2]="DoneError"})(me||(me={}));class ue{static fromArray(Q){return new ue(le=>{le.emitMany(Q)})}static fromPromise(Q){return new ue(async le=>{le.emitMany(await Q)})}static fromPromises(Q){return new ue(async le=>{await Promise.all(Q.map(async Ee=>le.emitOne(await Ee)))})}static merge(Q){return new ue(async le=>{await Promise.all(Q.map(async Ee=>{for await(const Ae of Ee)le.emitOne(Ae)}))})}constructor(Q){this.a=0,this.b=[],this.d=null,this.f=new y.Emitter,queueMicrotask(async()=>{const le={emitOne:Ee=>this.g(Ee),emitMany:Ee=>this.h(Ee),reject:Ee=>this.k(Ee)};try{await Promise.resolve(Q(le)),this.j()}catch(Ee){this.k(Ee)}finally{le.emitOne=void 0,le.emitMany=void 0,le.reject=void 0}})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Q<this.b.length)return{done:!1,value:this.b[Q++]};if(this.a===1)return{done:!0,value:void 0};await y.Event.toPromise(this.f.event)}while(!0)}}}static map(Q,le){return new ue(async Ee=>{for await(const Ae of Q)Ee.emitOne(le(Ae))})}map(Q){return ue.map(this,Q)}static filter(Q,le){return new ue(async Ee=>{for await(const Ae of Q)le(Ae)&&Ee.emitOne(Ae)})}filter(Q){return ue.filter(this,Q)}static coalesce(Q){return ue.filter(Q,le=>!!le)}coalesce(){return ue.coalesce(this)}static async toPromise(Q){const le=[];for await(const Ee of Q)le.push(Ee);return le}toPromise(){return ue.toPromise(this)}g(Q){this.a===0&&(this.b.push(Q),this.f.fire())}h(Q){this.a===0&&(this.b=this.b.concat(Q),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(Q){this.a===0&&(this.a=2,this.d=Q,this.f.fire())}}e.AsyncIterableObject=ue,ue.EMPTY=ue.fromArray([]);class oe extends ue{constructor(Q,le){super(le),this.l=Q}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=oe;function De(re){const Q=new i.CancellationTokenSource,le=re(Q.token);return new oe(Q,async Ee=>{const Ae=Q.token.onCancellationRequested(()=>{Ae.dispose(),Q.dispose(),Ee.reject(new T.CancellationError)});try{for await(const Be of le){if(Q.token.isCancellationRequested)return;Ee.emitOne(Be)}Ae.dispose(),Q.dispose()}catch(Be){Ae.dispose(),Q.dispose(),Ee.reject(Be)}})}e.createCancelableAsyncIterable=De}),define(ke[122],Ce([1,0,14,19]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const y=new i.IdleValue(()=>{const h=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:h,collatorIsNumeric:h.resolvedOptions().numeric}}),L=new i.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),k=new i.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function O(h,g,P=!1){const M=h||"",j=g||"",Z=y.value.collator.compare(M,j);return y.value.collatorIsNumeric&&Z===0&&M!==j?M<j?-1:1:Z}e.compareFileNames=O;function S(h,g){const P=L.value.collator;return h=h||"",g=g||"",E(P,h,g)}e.compareFileNamesDefault=S;function C(h,g){const P=L.value.collator;return h=h||"",g=g||"",o(h,g)||E(P,h,g)}e.compareFileNamesUpper=C;function N(h,g){const P=L.value.collator;return h=h||"",g=g||"",a(h,g)||E(P,h,g)}e.compareFileNamesLower=N;function D(h,g){return h=h||"",g=g||"",h===g?0:h<g?-1:1}e.compareFileNamesUnicode=D;function m(h,g){const[P,M]=v(h),[j,Z]=v(g);let G=y.value.collator.compare(M,Z);if(G===0){if(y.value.collatorIsNumeric&&M!==Z)return M<Z?-1:1;if(G=y.value.collator.compare(P,j),y.value.collatorIsNumeric&&G===0&&P!==j)return P<j?-1:1}return G}e.compareFileExtensions=m;function p(h,g){h=h||"",g=g||"";const P=b(h),M=b(g),j=L.value.collator,Z=k.value.collator;return E(Z,P,M)||E(j,h,g)}e.compareFileExtensionsDefault=p;function f(h,g){h=h||"",g=g||"";const P=b(h),M=b(g),j=L.value.collator,Z=k.value.collator;return E(Z,P,M)||o(h,g)||E(j,h,g)}e.compareFileExtensionsUpper=f;function t(h,g){h=h||"",g=g||"";const P=b(h),M=b(g),j=L.value.collator,Z=k.value.collator;return E(Z,P,M)||a(h,g)||E(j,h,g)}e.compareFileExtensionsLower=t;function c(h,g){h=h||"",g=g||"";const P=b(h).toLowerCase(),M=b(g).toLowerCase();return P!==M?P<M?-1:1:h!==g?h<g?-1:1:0}e.compareFileExtensionsUnicode=c;const l=/^(.*?)(\.([^.]*))?$/;function v(h,g=!1){const P=h?l.exec(h):[];let M=[P&&P[1]||"",P&&P[3]||""];return g&&(!M[0]&&M[1]||M[0]&&M[0].charAt(0)===".")&&(M=[M[0]+"."+M[1],""]),M}function b(h){const g=h?l.exec(h):[];return g&&g[1]&&g[1].charAt(0)!=="."&&g[3]||""}function E(h,g,P){const M=h.compare(g,P);return M!==0?M:g.length!==P.length?g.length<P.length?-1:1:0}function w(h){const g=h.charAt(0);return g.toLocaleUpperCase()!==g}function r(h){const g=h.charAt(0);return g.toLocaleLowerCase()!==g}function a(h,g){return w(h)&&r(g)?-1:r(h)&&w(g)?1:0}function o(h,g){return r(h)&&w(g)?-1:w(h)&&r(g)?1:0}function d(h,g,P=!1){return P||(h=h&&h.toLowerCase(),g=g&&g.toLowerCase()),h===g?0:h<g?-1:1}function s(h,g,P=!1){const M=h.split(T.sep),j=g.split(T.sep),Z=M.length-1,G=j.length-1;let A,R;for(let F=0;;F++){if(A=Z===F,R=G===F,A&&R)return O(M[F],j[F],P);if(A)return-1;if(R)return 1;const B=d(M[F],j[F],P);if(B!==0)return B}}e.comparePaths=s;function u(h,g,P){const M=h.toLowerCase(),j=g.toLowerCase(),Z=n(h,g,P);if(Z)return Z;const G=M.endsWith(P),A=j.endsWith(P);if(G!==A)return G?-1:1;const R=O(M,j);return R!==0?R:M.localeCompare(j)}e.compareAnything=u;function n(h,g,P){const M=h.toLowerCase(),j=g.toLowerCase(),Z=M.startsWith(P),G=j.startsWith(P);if(Z!==G)return Z?-1:1;if(Z&&G){if(M.length<j.length)return-1;if(M.length>j.length)return 1}return 0}e.compareByPrefix=n}),define(ke[35],Ce([1,0,16,14,39,28,19,21,10]),function(ee,e,i,T,y,L,k,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const N="[/\\\\]",D="[^/\\\\]",m=/\//g;function p(K,ie){switch(K){case 0:return"";case 1:return`${D}*?`;default:return`(?:${N}|${D}+${N}${ie?`|${N}${D}+`:""})*?`}}function f(K,ie){if(!K)return[];const me=[];let ue=!1,oe=!1,De="";for(const re of K){switch(re){case ie:if(!ue&&!oe){me.push(De),De="";continue}break;case"{":ue=!0;break;case"}":ue=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}De+=re}return De&&me.push(De),me}e.splitGlobAware=f;function t(K){if(!K)return"";let ie="";const me=f(K,e.GLOB_SPLIT);if(me.every(ue=>ue===e.GLOBSTAR))ie=".*";else{let ue=!1;me.forEach((oe,De)=>{if(oe===e.GLOBSTAR){if(ue)return;ie+=p(2,De===me.length-1)}else{let re=!1,Q="",le=!1,Ee="";for(const Ae of oe){if(Ae!=="}"&&re){Q+=Ae;continue}if(le&&(Ae!=="]"||!Ee)){let Be;Ae==="-"?Be=Ae:(Ae==="^"||Ae==="!")&&!Ee?Be="^":Ae===e.GLOB_SPLIT?Be="":Be=(0,S.escapeRegExpCharacters)(Ae),Ee+=Be;continue}switch(Ae){case"{":re=!0;continue;case"[":le=!0;continue;case"}":{ie+=`(?:${f(Q,",").map(Te=>t(Te)).join("|")})`,re=!1,Q="";break}case"]":{ie+="["+Ee+"]",le=!1,Ee="";break}case"?":ie+=D;continue;case"*":ie+=p(1);continue;default:ie+=(0,S.escapeRegExpCharacters)(Ae)}}De<me.length-1&&(me[De+1]!==e.GLOBSTAR||De+2<me.length)&&(ie+=N)}ue=oe===e.GLOBSTAR})}return ie}const c=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,w=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new L.LRUCache(1e4),a=function(){return!1},o=function(){return null};function d(K,ie){if(!K)return o;let me;typeof K!="string"?me=K.pattern:me=K,me=me.trim();const ue=`${me}_${!!ie.trimForExclusions}`;let oe=r.get(ue);if(oe)return s(oe,K);let De;return c.test(me)?oe=n(me.substr(4),me):(De=l.exec(u(me,ie)))?oe=h(De[1],me):(ie.trimForExclusions?b:v).test(me)?oe=g(me,ie):(De=E.exec(u(me,ie)))?oe=P(De[1].substr(1),me,!0):(De=w.exec(u(me,ie)))?oe=P(De[1],me,!1):oe=M(me),r.set(ue,oe),s(oe,K)}function s(K,ie){if(typeof ie=="string")return K;const me=function(ue,oe){return(0,y.isEqualOrParent)(ue,ie.base,!O.isLinux)?K((0,S.ltrim)(ue.substr(ie.base.length),k.sep),oe):null};return me.allBasenames=K.allBasenames,me.allPaths=K.allPaths,me.basenames=K.basenames,me.patterns=K.patterns,me}function u(K,ie){return ie.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function n(K,ie){return function(me,ue){return typeof me=="string"&&me.endsWith(K)?ie:null}}function h(K,ie){const me=`/${K}`,ue=`\\${K}`,oe=function(re,Q){return typeof re!="string"?null:Q?Q===K?ie:null:re===K||re.endsWith(me)||re.endsWith(ue)?ie:null},De=[K];return oe.basenames=De,oe.patterns=[ie],oe.allBasenames=De,oe}function g(K,ie){const me=z(K.slice(1,-1).split(",").map(Q=>d(Q,ie)).filter(Q=>Q!==o),K),ue=me.length;if(!ue)return o;if(ue===1)return me[0];const oe=function(Q,le){for(let Ee=0,Ae=me.length;Ee<Ae;Ee++)if(me[Ee](Q,le))return K;return null},De=me.find(Q=>!!Q.allBasenames);De&&(oe.allBasenames=De.allBasenames);const re=me.reduce((Q,le)=>le.allPaths?Q.concat(le.allPaths):Q,[]);return re.length&&(oe.allPaths=re),oe}function P(K,ie,me){const ue=k.sep===k.posix.sep,oe=ue?K:K.replace(m,k.sep),De=k.sep+oe,re=k.posix.sep+K;let Q;return me?Q=function(le,Ee){return typeof le=="string"&&(le===oe||le.endsWith(De)||!ue&&(le===K||le.endsWith(re)))?ie:null}:Q=function(le,Ee){return typeof le=="string"&&(le===oe||!ue&&le===K)?ie:null},Q.allPaths=[(me?"*/":"./")+K],Q}function M(K){try{const ie=new RegExp(`^${t(K)}$`);return function(me){return ie.lastIndex=0,typeof me=="string"&&ie.test(me)?K:null}}catch{return o}}function j(K,ie,me){return!K||typeof ie!="string"?!1:Z(K)(ie,void 0,me)}e.match=j;function Z(K,ie={}){if(!K)return a;if(typeof K=="string"||G(K)){const me=d(K,ie);if(me===o)return a;const ue=function(oe,De){return!!me(oe,De)};return me.allBasenames&&(ue.allBasenames=me.allBasenames),me.allPaths&&(ue.allPaths=me.allPaths),ue}return F(K,ie)}e.parse=Z;function G(K){const ie=K;return ie?typeof ie.base=="string"&&typeof ie.pattern=="string":!1}e.isRelativePattern=G;function A(K){return K.allBasenames||[]}e.getBasenameTerms=A;function R(K){return K.allPaths||[]}e.getPathTerms=R;function F(K,ie){const me=z(Object.getOwnPropertyNames(K).map(Q=>B(Q,K[Q],ie)).filter(Q=>Q!==o)),ue=me.length;if(!ue)return o;if(!me.some(Q=>!!Q.requiresSiblings)){if(ue===1)return me[0];const Q=function(Ae,Be){let xe;for(let Te=0,Ie=me.length;Te<Ie;Te++){const Se=me[Te](Ae,Be);if(typeof Se=="string")return Se;(0,T.isThenable)(Se)&&(xe||(xe=[]),xe.push(Se))}return xe?(async()=>{for(const Te of xe){const Ie=await Te;if(typeof Ie=="string")return Ie}return null})():null},le=me.find(Ae=>!!Ae.allBasenames);le&&(Q.allBasenames=le.allBasenames);const Ee=me.reduce((Ae,Be)=>Be.allPaths?Ae.concat(Be.allPaths):Ae,[]);return Ee.length&&(Q.allPaths=Ee),Q}const oe=function(Q,le,Ee){let Ae,Be;for(let xe=0,Te=me.length;xe<Te;xe++){const Ie=me[xe];Ie.requiresSiblings&&Ee&&(le||(le=(0,k.basename)(Q)),Ae||(Ae=le.substr(0,le.length-(0,k.extname)(Q).length)));const Se=Ie(Q,le,Ae,Ee);if(typeof Se=="string")return Se;(0,T.isThenable)(Se)&&(Be||(Be=[]),Be.push(Se))}return Be?(async()=>{for(const xe of Be){const Te=await xe;if(typeof Te=="string")return Te}return null})():null},De=me.find(Q=>!!Q.allBasenames);De&&(oe.allBasenames=De.allBasenames);const re=me.reduce((Q,le)=>le.allPaths?Q.concat(le.allPaths):Q,[]);return re.length&&(oe.allPaths=re),oe}function B(K,ie,me){if(ie===!1)return o;const ue=d(K,me);if(ue===o)return o;if(typeof ie=="boolean")return ue;if(ie){const oe=ie.when;if(typeof oe=="string"){const De=(re,Q,le,Ee)=>{if(!Ee||!ue(re,Q))return null;const Ae=oe.replace("$(basename)",()=>le),Be=Ee(Ae);return(0,T.isThenable)(Be)?Be.then(xe=>xe?K:null):Be?K:null};return De.requiresSiblings=!0,De}}return ue}function z(K,ie){const me=K.filter(Q=>!!Q.basenames);if(me.length<2)return K;const ue=me.reduce((Q,le)=>{const Ee=le.basenames;return Ee?Q.concat(Ee):Q},[]);let oe;if(ie){oe=[];for(let Q=0,le=ue.length;Q<le;Q++)oe.push(ie)}else oe=me.reduce((Q,le)=>{const Ee=le.patterns;return Ee?Q.concat(Ee):Q},[]);const De=function(Q,le){if(typeof Q!="string")return null;if(!le){let Ae;for(Ae=Q.length;Ae>0;Ae--){const Be=Q.charCodeAt(Ae-1);if(Be===47||Be===92)break}le=Q.substr(Ae)}const Ee=ue.indexOf(le);return Ee!==-1?oe[Ee]:null};De.basenames=ue,De.patterns=oe,De.allBasenames=ue;const re=K.filter(Q=>!Q.basenames);return re.push(De),re}function V(K,ie){return(0,i.equals)(K,ie,(me,ue)=>typeof me=="string"&&typeof ue=="string"?me===ue:typeof me!="string"&&typeof ue!="string"?me.base===ue.base&&me.pattern===ue.pattern:!1)}e.patternsEquals=V}),define(ke[83],Ce([1,0,11,120,22,10,2]),function(ee,e,i,T,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var O;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(O=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(l="",v=!1){if(this.value=l,typeof this.value!="string")throw(0,i.illegalArgument)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(l,v=0){return this.value+=m(this.supportThemeIcons?(0,T.escapeIcons)(l):l).replace(/([ \t]+)/g,(b,E)=>"&nbsp;".repeat(E.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(l){return this.value+=l,this}appendCodeblock(l,v){return this.value+="\n```",this.value+=l,this.value+=`
`,this.value+=v,this.value+="\n```\n",this}appendLink(l,v,b){return this.value+="[",this.value+=this.c(v,"]"),this.value+="](",this.value+=this.c(String(l),")"),b&&(this.value+=` "${this.c(this.c(b,'"'),")")}"`),this.value+=")",this}c(l,v){const b=new RegExp((0,L.escapeRegExpCharacters)(v),"g");return l.replace(b,(E,w)=>l.charAt(w-1)!=="\\"?`\\${E}`:E)}}e.MarkdownString=S;function C(c){return N(c)?!c.value:Array.isArray(c)?c.every(C):!0}e.isEmptyMarkdownString=C;function N(c){return c instanceof S?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}e.isMarkdownString=N;function D(c,l){return c===l?!0:!c||!l?!1:c.value===l.value&&c.isTrusted===l.isTrusted&&c.supportThemeIcons===l.supportThemeIcons&&c.supportHtml===l.supportHtml&&(c.baseUri===l.baseUri||!!c.baseUri&&!!l.baseUri&&(0,y.isEqual)(k.URI.from(c.baseUri),k.URI.from(l.baseUri)))}e.markdownStringEqual=D;function m(c){return c.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=m;function p(c){return c.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=p;function f(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=f;function t(c){const l=[],v=c.split("|").map(E=>E.trim());c=v[0];const b=v[1];if(b){const E=/height=(\d+)/.exec(b),w=/width=(\d+)/.exec(b),r=E?E[1]:"",a=w?w[1]:"",o=isFinite(parseInt(a)),d=isFinite(parseInt(r));o&&l.push(`width="${a}"`),d&&l.push(`height="${r}"`)}return{href:c,dimensions:l}}e.parseHrefAndDimensions=t}),define(ke[84],Ce([1,0,16,39,19,21,22,10]),function(ee,e,i,T,y,L,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function S(o,d){const{os:s,tildify:u,relative:n}=d;if(n){const P=C(o,n,s);if(typeof P=="string")return P}let h=o.fsPath;if(s===1&&!L.isWindows?h=h.replace(/\//g,"\\"):s!==1&&L.isWindows&&(h=h.replace(/\\/g,"/")),s!==1&&u?.userHome){const P=u.userHome.fsPath;let M;o.scheme!==u.userHome.scheme&&o.path.startsWith(y.posix.sep)?M=u.userHome.with({path:o.path}).fsPath:M=o.fsPath,h=m(M,P,s)}return(s===1?y.win32:y.posix).normalize(N(h,s===1))}e.getPathLabel=S;function C(o,d,s){const u=s===1?y.win32:y.posix,n=s===3?k.extUri:k.extUriIgnorePathCase,h=d.getWorkspace(),g=(0,i.firstOrDefault)(h.folders);if(!g)return;o.scheme!==g.uri.scheme&&o.path.startsWith(y.posix.sep)&&(o=g.uri.with({path:o.path}));const P=d.getWorkspaceFolder(o);if(!P)return;let M;if(n.isEqual(P.uri,o)?M="":M=n.relativePath(P.uri,o)??"",M&&(M=u.normalize(M)),h.folders.length>1&&!d.noPrefix){const j=P.name?P.name:n.basenameOrAuthority(P.uri);M=M?`${j} \u2022 ${M}`:j}return M}function N(o,d=L.isWindows){return(0,T.hasDriveLetter)(o,d)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=N;let D=Object.create(null);function m(o,d,s=L.OS){if(s===1||!o||!d)return o;let u=D.original===d?D.normalized:void 0;u||(u=d,L.isWindows&&(u=(0,T.toSlashes)(u)),u=`${(0,O.rtrim)(u,y.posix.sep)}${y.posix.sep}`,D={original:d,normalized:u});let n=o;return L.isWindows&&(n=(0,T.toSlashes)(n)),(s===3?n.startsWith(u):(0,O.startsWithIgnoreCase)(n,u))?`~/${n.substr(u.length)}`:o}e.tildify=m;function p(o,d){return o.replace(/^~($|\/|\\)/,`${d}$1`)}e.untildify=p;const f="\u2026",t="\\\\",c="~";function l(o,d=y.sep){const s=new Array(o.length);let u=!1;for(let n=0;n<o.length;n++){const h=o[n];if(h===""){s[n]=`.${d}`;continue}if(!h){s[n]=h;continue}u=!0;let g="",P=h;P.indexOf(t)===0?(g=P.substr(0,P.indexOf(t)+t.length),P=P.substr(P.indexOf(t)+t.length)):P.indexOf(d)===0?(g=P.substr(0,P.indexOf(d)+d.length),P=P.substr(P.indexOf(d)+d.length)):P.indexOf(c)===0&&(g=P.substr(0,P.indexOf(c)+c.length),P=P.substr(P.indexOf(c)+c.length));const M=P.split(d);for(let j=1;u&&j<=M.length;j++)for(let Z=M.length-j;u&&Z>=0;Z--){u=!1;let G=M.slice(Z,Z+j).join(d);for(let A=0;!u&&A<o.length;A++)if(A!==n&&o[A]&&o[A].indexOf(G)>-1){const R=Z+j===M.length,F=Z>0&&o[A].indexOf(d)>-1?d+G:G,B=o[A].endsWith(F);u=!R||B}if(!u){let A="";(M[0].endsWith(":")||g!=="")&&(Z===1&&(Z=0,j++,G=M[0]+d+G),Z>0&&(A=M[0]+d),A=g+A),Z>0&&(A=A+f+d),A=A+G,Z+j<M.length&&(A=A+d+f),s[n]=A}}u&&(s[n]=h)}return s}e.shorten=l;var v;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function b(o,d=Object.create(null)){const s=[];let u=!1,n="";for(const h of o)if(h==="$"||u&&h==="{")n&&s.push({value:n,type:v.TEXT}),n="",u=!0;else if(h==="}"&&u){const g=d[n];if(typeof g=="string")g.length&&s.push({value:g,type:v.VARIABLE});else if(g){const P=s[s.length-1];(!P||P.type!==v.SEPARATOR)&&s.push({value:g.label,type:v.SEPARATOR})}n="",u=!1}else n+=h;return n&&!u&&s.push({value:n,type:v.TEXT}),s.filter((h,g)=>{if(h.type===v.SEPARATOR){const P=s[g-1],M=s[g+1];return[P,M].every(j=>j&&(j.type===v.VARIABLE||j.type===v.TEXT)&&j.value.length>0)}return!0}).map(h=>h.value).join("")}e.template=b;function E(o,d){return L.isMacintosh||d?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.isMacintosh?"&":"&&"):o.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=E;function w(o,d){return L.isMacintosh||d?o.replace(/\(&&\w\)|&&/g,""):L.isWindows?o.replace(/&&|&/g,s=>s==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=w;function r(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=r;function a(o){const d=o.indexOf("/")!==-1?y.posix:y.win32,s=d.basename(o),u=d.dirname(o);return s.length?{name:s,parentPath:u}:{name:u,parentPath:""}}e.splitName=a}),define(ke[123],Ce([1,0,2]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function T(N){return N.toJSON()}class y{constructor(D){this.a=D}transformIncoming(D){const m=this.a.transformIncoming(D);return m===D?D:T(i.URI.from(m))}transformOutgoing(D){const m=this.a.transformOutgoing(D);return m===D?D:T(i.URI.from(m))}transformOutgoingURI(D){const m=this.a.transformOutgoing(D);return m===D?D:i.URI.from(m)}transformOutgoingScheme(D){return this.a.transformOutgoingScheme(D)}}e.URITransformer=y,e.DefaultURITransformer=new class{transformIncoming(N){return N}transformOutgoing(N){return N}transformOutgoingURI(N){return N}transformOutgoingScheme(N){return N}};function L(N,D,m){if(!N||m>200)return null;if(typeof N=="object"){if(N instanceof i.URI)return D.transformOutgoing(N);for(const p in N)if(Object.hasOwnProperty.call(N,p)){const f=L(N[p],D,m+1);f!==null&&(N[p]=f)}}return null}function k(N,D){const m=L(N,D,0);return m===null?N:m}e.transformOutgoingURIs=k;function O(N,D,m,p){if(!N||p>200)return null;if(typeof N=="object"){if(N.$mid===1)return m?i.URI.revive(D.transformIncoming(N)):D.transformIncoming(N);for(const f in N)if(Object.hasOwnProperty.call(N,f)){const t=O(N[f],D,m,p+1);t!==null&&(N[f]=t)}}return null}function S(N,D){const m=O(N,D,!1,0);return m===null?N:m}e.transformIncomingURIs=S;function C(N,D){const m=O(N,D,!0,0);return m===null?N:m}e.transformAndReviveIncomingURIs=C}),define(ke[124],Ce([1,0,35,19]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function y(L,k,O,S,C,N){if(Array.isArray(L)){let D=0;for(const m of L){const p=y(m,k,O,S,C,N);if(p===10)return p;p>D&&(D=p)}return D}else{if(typeof L=="string")return S?L==="*"?5:L===O?10:0:0;if(L){const{language:D,pattern:m,scheme:p,hasAccessToAllModels:f,notebookType:t}=L;if(!S&&!f)return 0;t&&C&&(k=C);let c=0;if(p)if(p===k.scheme)c=10;else if(p==="*")c=5;else return 0;if(D)if(D===O)c=10;else if(D==="*")c=Math.max(c,5);else return 0;if(t)if(t===N)c=10;else if(t==="*"&&N!==void 0)c=Math.max(c,5);else return 0;if(m){let l;if(typeof m=="string"?l=m:l={...m,base:(0,T.normalize)(m.base)},l===k.fsPath||(0,i.match)(l,k.fsPath))c=10;else return 0}return c}else return 0}}e.score=y}),define(ke[85],Ce([1,0,24,21]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var y;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(y||(y={}));function L(D){for(let m=0,p=D.length;m<p;m+=4){const f=D[m+0],t=D[m+1],c=D[m+2],l=D[m+3];D[m+0]=l,D[m+1]=c,D[m+2]=t,D[m+3]=f}}function k(D){const m=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return T.isLittleEndian()||L(m),i.VSBuffer.wrap(m)}function O(D){const m=D.buffer;if(T.isLittleEndian()||L(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const p=new Uint8Array(m.byteLength);return p.set(m),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function S(D){const m=new Uint32Array(C(D));let p=0;if(m[p++]=D.id,D.type==="full")m[p++]=1,m[p++]=D.data.length,m.set(D.data,p),p+=D.data.length;else{m[p++]=2,m[p++]=D.deltas.length;for(const f of D.deltas)m[p++]=f.start,m[p++]=f.deleteCount,f.data?(m[p++]=f.data.length,m.set(f.data,p),p+=f.data.length):m[p++]=0}return k(m)}e.encodeSemanticTokensDto=S;function C(D){let m=0;if(m+=1+1,D.type==="full")m+=1+D.data.length;else{m+=1,m+=(1+1+1)*D.deltas.length;for(const p of D.deltas)p.data&&(m+=p.data.length)}return m}function N(D){const m=O(D);let p=0;const f=m[p++];if(m[p++]===1){const v=m[p++],b=m.subarray(p,p+v);return p+=v,{id:f,type:"full",data:b}}const c=m[p++],l=[];for(let v=0;v<c;v++){const b=m[p++],E=m[p++],w=m[p++];let r;w>0&&(r=m.subarray(p,p+w),p+=w),l[v]={start:b,deleteCount:E,data:r}}return{id:f,type:"delta",deltas:l}}e.decodeSemanticTokensDto=N}),define(ke[125],Ce([17,18]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(ke[126],Ce([1,0,125,21,127,16,23,114]),function(ee,e,i,T,y,L,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(_){_[_.None=0]="None",_[_.Keep=1]="Keep",_[_.Brackets=2]="Brackets",_[_.Advanced=3]="Advanced",_[_.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class C{constructor(X){this.c=X}hasChanged(X){return this.c[X]}}e.ConfigurationChangedEvent=C;class N{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=N;class D{constructor(X,ge,Me,$e){this.id=X,this.name=ge,this.defaultValue=Me,this.schema=$e}applyUpdate(X,ge){return p(X,ge)}compute(X,ge,Me){return Me}}class m{constructor(X,ge){this.newValue=X,this.didChange=ge}}e.ApplyUpdateResult=m;function p(_,X){if(typeof _!="object"||typeof X!="object"||!_||!X)return new m(X,_!==X);if(Array.isArray(_)||Array.isArray(X)){const Me=Array.isArray(_)&&Array.isArray(X)&&L.equals(_,X);return new m(X,!Me)}let ge=!1;for(const Me in X)if(X.hasOwnProperty(Me)){const $e=p(_[Me],X[Me]);$e.didChange&&(_[Me]=$e.newValue,ge=!0)}return new m(_,ge)}class f{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,ge){return p(X,ge)}validate(X){return this.defaultValue}}class t{constructor(X,ge,Me,$e){this.id=X,this.name=ge,this.defaultValue=Me,this.schema=$e}applyUpdate(X,ge){return p(X,ge)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,ge,Me){return Me}}function c(_,X){return typeof _>"u"?X:_==="false"?!1:Boolean(_)}e.boolean=c;class l extends t{constructor(X,ge,Me,$e=void 0){typeof $e<"u"&&($e.type="boolean",$e.default=Me),super(X,ge,Me,$e)}validate(X){return c(X,this.defaultValue)}}function v(_,X,ge,Me){if(typeof _>"u")return X;let $e=parseInt(_,10);return isNaN($e)?X:($e=Math.max(ge,$e),$e=Math.min(Me,$e),$e|0)}e.clampedInt=v;class b extends t{static clampedInt(X,ge,Me,$e){return v(X,ge,Me,$e)}constructor(X,ge,Me,$e,je,_e=void 0){typeof _e<"u"&&(_e.type="integer",_e.default=Me,_e.minimum=$e,_e.maximum=je),super(X,ge,Me,_e),this.minimum=$e,this.maximum=je}validate(X){return b.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}class E extends t{static clamp(X,ge,Me){return X<ge?ge:X>Me?Me:X}static float(X,ge){if(typeof X=="number")return X;if(typeof X>"u")return ge;const Me=parseFloat(X);return isNaN(Me)?ge:Me}constructor(X,ge,Me,$e,je){typeof je<"u"&&(je.type="number",je.default=Me),super(X,ge,Me,je),this.validationFn=$e}validate(X){return this.validationFn(E.float(X,this.defaultValue))}}class w extends t{static string(X,ge){return typeof X!="string"?ge:X}constructor(X,ge,Me,$e=void 0){typeof $e<"u"&&($e.type="string",$e.default=Me),super(X,ge,Me,$e)}validate(X){return w.string(X,this.defaultValue)}}function r(_,X,ge){return typeof _!="string"||ge.indexOf(_)===-1?X:_}e.stringSet=r;class a extends t{constructor(X,ge,Me,$e,je=void 0){typeof je<"u"&&(je.type="string",je.enum=$e,je.default=Me),super(X,ge,Me,je),this.c=$e}validate(X){return r(X,this.defaultValue,this.c)}}class o extends D{constructor(X,ge,Me,$e,je,_e,nt=void 0){typeof nt<"u"&&(nt.type="string",nt.enum=je,nt.default=$e),super(X,ge,Me,nt),this.c=je,this.d=_e}validate(X){return typeof X!="string"?this.defaultValue:this.c.indexOf(X)===-1?this.defaultValue:this.d(X)}}function d(_){switch(_){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class s extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[i.localize(0,null),i.localize(1,null),i.localize(2,null)],default:"auto",tags:["accessibility"],description:i.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,ge,Me){return Me===0?X.accessibilitySupport:Me}}class u extends D{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:i.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:i.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{insertSpace:c(ge.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:c(ge.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(_){_[_.Hidden=0]="Hidden",_[_.Blink=1]="Blink",_[_.Smooth=2]="Smooth",_[_.Phase=3]="Phase",_[_.Expand=4]="Expand",_[_.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function h(_){switch(_){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var g;(function(_){_[_.Line=1]="Line",_[_.Block=2]="Block",_[_.Underline=3]="Underline",_[_.LineThin=4]="LineThin",_[_.BlockOutline=5]="BlockOutline",_[_.UnderlineThin=6]="UnderlineThin"})(g=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function P(_){switch(_){case g.Line:return"line";case g.Block:return"block";case g.Underline:return"underline";case g.LineThin:return"line-thin";case g.BlockOutline:return"block-outline";case g.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=P;function M(_){switch(_){case"line":return g.Line;case"block":return g.Block;case"underline":return g.Underline;case"line-thin":return g.LineThin;case"block-outline":return g.BlockOutline;case"underline-thin":return g.UnderlineThin}}class j extends f{constructor(){super(135)}compute(X,ge,Me){const $e=["monaco-editor"];return ge.get(36)&&$e.push(ge.get(36)),X.extraEditorClassName&&$e.push(X.extraEditorClassName),ge.get(70)==="default"?$e.push("mouse-default"):ge.get(70)==="copy"&&$e.push("mouse-copy"),ge.get(105)&&$e.push("showUnused"),ge.get(133)&&$e.push("showDeprecated"),$e.join(" ")}}class Z extends l{constructor(){super(34,"emptySelectionClipboard",!0,{description:i.localize(6,null)})}compute(X,ge,Me){return Me&&X.emptySelectionClipboard}}class G extends D{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:i.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[i.localize(8,null),i.localize(9,null),i.localize(10,null)],description:i.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[i.localize(12,null),i.localize(13,null),i.localize(14,null)],description:i.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:i.localize(16,null),included:T.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:i.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:i.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{cursorMoveOnType:c(ge.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":r(ge.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":r(ge.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:c(ge.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:c(ge.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:c(ge.loop,this.defaultValue.loop)}}}class A extends D{constructor(){super(48,"fontLigatures",A.OFF,{anyOf:[{type:"boolean",description:i.localize(19,null)},{type:"string",description:i.localize(20,null)}],description:i.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?A.OFF:X==="true"?A.ON:X:Boolean(X)?A.ON:A.OFF}}e.EditorFontLigatures=A,A.OFF='"liga" off, "calt" off',A.ON='"liga" on, "calt" on';class R extends D{constructor(){super(51,"fontVariations",R.OFF,{anyOf:[{type:"boolean",description:i.localize(22,null)},{type:"string",description:i.localize(23,null)}],description:i.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?R.OFF:X==="true"?R.TRANSLATE:X:Boolean(X)?R.TRANSLATE:R.OFF}compute(X,ge,Me){return X.fontInfo.fontVariationSettings}}e.EditorFontVariations=R,R.OFF="normal",R.TRANSLATE="translate";class F extends f{constructor(){super(47)}compute(X,ge,Me){return X.fontInfo}}class B extends t{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:i.localize(25,null)})}validate(X){const ge=E.float(X,this.defaultValue);return ge===0?e.EDITOR_FONT_DEFAULTS.fontSize:E.clamp(ge,6,100)}compute(X,ge,Me){return X.fontInfo.fontSize}}class z extends D{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.d,maximum:z.e,errorMessage:i.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:i.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(b.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,z.d,z.e))}}z.c=["normal","bold","100","200","300","400","500","600","700","800","900"],z.d=1,z.e=1e3;class V extends D{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ge={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[i.localize(28,null),i.localize(29,null),i.localize(30,null)]},Me=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:i.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:i.localize(32,null),...ge},"editor.gotoLocation.multipleTypeDefinitions":{description:i.localize(33,null),...ge},"editor.gotoLocation.multipleDeclarations":{description:i.localize(34,null),...ge},"editor.gotoLocation.multipleImplementations":{description:i.localize(35,null),...ge},"editor.gotoLocation.multipleReferences":{description:i.localize(36,null),...ge},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:Me,description:i.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:Me,description:i.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:Me,description:i.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:Me,description:i.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:Me,description:i.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{multiple:r(ge.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ge.multipleDefinitions??r(ge.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ge.multipleTypeDefinitions??r(ge.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ge.multipleDeclarations??r(ge.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ge.multipleImplementations??r(ge.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ge.multipleReferences??r(ge.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:w.string(ge.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:w.string(ge.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:w.string(ge.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:w.string(ge.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:w.string(ge.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class K extends D{constructor(){const X={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:i.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:i.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:i.localize(44,null)},"editor.hover.above":{type:"boolean",default:X.above,description:i.localize(45,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:c(ge.enabled,this.defaultValue.enabled),delay:b.clampedInt(ge.delay,this.defaultValue.delay,0,1e4),sticky:c(ge.sticky,this.defaultValue.sticky),above:c(ge.above,this.defaultValue.above)}}}var ie;(function(_){_[_.None=0]="None",_[_.Text=1]="Text",_[_.Blocks=2]="Blocks"})(ie=e.RenderMinimap||(e.RenderMinimap={}));class me extends f{constructor(){super(138)}compute(X,ge,Me){return me.computeLayout(ge,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio})}static computeContainedMinimapLineCount(X){const ge=X.height/X.lineHeight,Me=Math.floor(X.paddingTop/X.lineHeight);let $e=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&($e=Math.max($e,ge-1));const je=(Me+X.viewLineCount+$e)/(X.pixelRatio*X.height),_e=Math.floor(X.viewLineCount/je);return{typicalViewportLineCount:ge,extraLinesBeforeFirstLine:Me,extraLinesBeyondLastLine:$e,desiredRatio:je,minimapLineCount:_e}}static c(X,ge){const Me=X.outerWidth,$e=X.outerHeight,je=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(je*$e),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:$e};const _e=ge.stableMinimapLayoutInput,nt=_e&&X.outerHeight===_e.outerHeight&&X.lineHeight===_e.lineHeight&&X.typicalHalfwidthCharacterWidth===_e.typicalHalfwidthCharacterWidth&&X.pixelRatio===_e.pixelRatio&&X.scrollBeyondLastLine===_e.scrollBeyondLastLine&&X.paddingTop===_e.paddingTop&&X.paddingBottom===_e.paddingBottom&&X.minimap.enabled===_e.minimap.enabled&&X.minimap.side===_e.minimap.side&&X.minimap.size===_e.minimap.size&&X.minimap.showSlider===_e.minimap.showSlider&&X.minimap.renderCharacters===_e.minimap.renderCharacters&&X.minimap.maxColumn===_e.minimap.maxColumn&&X.minimap.scale===_e.minimap.scale&&X.verticalScrollbarWidth===_e.verticalScrollbarWidth&&X.isViewportWrapping===_e.isViewportWrapping,wt=X.lineHeight,St=X.typicalHalfwidthCharacterWidth,kt=X.scrollBeyondLastLine,lt=X.minimap.renderCharacters;let at=je>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const Bt=X.minimap.maxColumn,Ot=X.minimap.size,Ft=X.minimap.side,ft=X.verticalScrollbarWidth,Dt=X.viewLineCount,$t=X.remainingWidth,Nt=X.isViewportWrapping,Ge=lt?2:3;let Mt=Math.floor(je*$e);const Lt=Mt/je;let Ut=!1,mt=!1,Ct=Ge*at,ye=at/je,Pe=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:Ze,extraLinesBeforeFirstLine:bt,extraLinesBeyondLastLine:vt,desiredRatio:At,minimapLineCount:pt}=me.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:kt,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:$e,lineHeight:wt,pixelRatio:je});if(Dt/pt>1)Ut=!0,mt=!0,at=1,Ct=1,ye=at/je;else{let ht=!1,xt=at+1;if(Ot==="fit"){const Vt=Math.ceil((bt+Dt+vt)*Ct);Nt&&nt&&$t<=ge.stableFitRemainingWidth?(ht=!0,xt=ge.stableFitMaxMinimapScale):ht=Vt>Mt}if(Ot==="fill"||ht){Ut=!0;const Vt=at;Ct=Math.min(wt*je,Math.max(1,Math.floor(1/At))),Nt&&nt&&$t<=ge.stableFitRemainingWidth&&(xt=ge.stableFitMaxMinimapScale),at=Math.min(xt,Math.max(1,Math.floor(Ct/Ge))),at>Vt&&(Pe=Math.min(2,at/Vt)),ye=at/je/Pe,Mt=Math.ceil(Math.max(Ze,bt+Dt+vt)*Ct),Nt?(ge.stableMinimapLayoutInput=X,ge.stableFitRemainingWidth=$t,ge.stableFitMaxMinimapScale=at):(ge.stableMinimapLayoutInput=null,ge.stableFitRemainingWidth=0)}}}const fe=Math.floor(Bt*ye),x=Math.min(fe,Math.max(0,Math.floor(($t-ft-2)*ye/(St+ye)))+e.MINIMAP_GUTTER_WIDTH);let Re=Math.floor(je*x);const Le=Re/je;Re=Math.floor(Re*Pe);const Qe=lt?1:2,ze=Ft==="left"?0:Me-x-ft;return{renderMinimap:Qe,minimapLeft:ze,minimapWidth:x,minimapHeightIsEditorHeight:Ut,minimapIsSampling:mt,minimapScale:at,minimapLineHeight:Ct,minimapCanvasInnerWidth:Re,minimapCanvasInnerHeight:Mt,minimapCanvasOuterWidth:Le,minimapCanvasOuterHeight:Lt}}static computeLayout(X,ge){const Me=ge.outerWidth|0,$e=ge.outerHeight|0,je=ge.lineHeight|0,_e=ge.lineNumbersDigitCount|0,nt=ge.typicalHalfwidthCharacterWidth,wt=ge.maxDigitWidth,St=ge.pixelRatio,kt=ge.viewLineCount,lt=X.get(130),at=lt==="inherit"?X.get(129):lt,Bt=at==="inherit"?X.get(125):at,Ot=X.get(128),Ft=ge.isDominatedByLongLines,ft=X.get(54),Dt=X.get(64).renderType!==0,$t=X.get(65),Nt=X.get(99),Ge=X.get(80),Mt=X.get(69),Lt=X.get(97),Ut=Lt.verticalScrollbarSize,mt=Lt.verticalHasArrows,Ct=Lt.arrowSize,ye=Lt.horizontalScrollbarSize,Pe=X.get(40),fe=X.get(104)!=="never";let x=X.get(62);Pe&&fe&&(x+=16);let Re=0;if(Dt){const Qt=Math.max(_e,$t);Re=Math.round(Qt*wt)}let Le=0;ft&&(Le=je);let Qe=0,ze=Qe+Le,Ze=ze+Re,bt=Ze+x;const vt=Me-Le-Re-x;let At=!1,pt=!1,It=-1;at==="inherit"&&Ft?(At=!0,pt=!0):Bt==="on"||Bt==="bounded"?pt=!0:Bt==="wordWrapColumn"&&(It=Ot);const ht=me.c({outerWidth:Me,outerHeight:$e,lineHeight:je,typicalHalfwidthCharacterWidth:nt,pixelRatio:St,scrollBeyondLastLine:Nt,paddingTop:Ge.top,paddingBottom:Ge.bottom,minimap:Mt,verticalScrollbarWidth:Ut,viewLineCount:kt,remainingWidth:vt,isViewportWrapping:pt},ge.memory||new N);ht.renderMinimap!==0&&ht.minimapLeft===0&&(Qe+=ht.minimapWidth,ze+=ht.minimapWidth,Ze+=ht.minimapWidth,bt+=ht.minimapWidth);const xt=vt-ht.minimapWidth,Vt=Math.max(1,Math.floor((xt-Ut-2)/nt)),Et=mt?Ct:0;return pt&&(It=Math.max(1,Vt),Bt==="bounded"&&(It=Math.min(It,Ot))),{width:Me,height:$e,glyphMarginLeft:Qe,glyphMarginWidth:Le,lineNumbersLeft:ze,lineNumbersWidth:Re,decorationsLeft:Ze,decorationsWidth:x,contentLeft:bt,contentWidth:xt,minimap:ht,viewportColumn:Vt,isWordWrapMinified:At,isViewportWrapping:pt,wrappingColumn:It,verticalScrollbarWidth:Ut,horizontalScrollbarHeight:ye,overviewRuler:{top:Et,width:Ut,height:$e-2*Et,right:0}}}}e.EditorLayoutInfoComputer=me;class ue extends D{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[i.localize(46,null),i.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:i.localize(48,null)}})}validate(X){return r(X,"simple",["simple","advanced"])}compute(X,ge,Me){return ge.get(2)===2?"advanced":Me}}class oe extends D{constructor(){const X={enabled:!0};super(61,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:i.localize(49,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:c(X.enabled,this.defaultValue.enabled)}}}class De extends D{constructor(){const X={enabled:!1,maxLineCount:5};super(109,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:i.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:10,description:i.localize(51,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:c(ge.enabled,this.defaultValue.enabled),maxLineCount:b.clampedInt(ge.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class re extends D{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:i.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[i.localize(53,null),i.localize(54,null,T.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),i.localize(55,null,T.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),i.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:i.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:i.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:i.localize(59,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return typeof ge.enabled=="boolean"&&(ge.enabled=ge.enabled?"on":"off"),{enabled:r(ge.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:b.clampedInt(ge.fontSize,this.defaultValue.fontSize,0,100),fontFamily:w.string(ge.fontFamily,this.defaultValue.fontFamily),padding:c(ge.padding,this.defaultValue.padding)}}}class Q extends D{constructor(){super(62,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):b.clampedInt(X,this.defaultValue,0,1e3)}compute(X,ge,Me){return Me<0?b.clampedInt(-Me*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Me}}class le extends E{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>E.clamp(X,0,150),{markdownDescription:i.localize(60,null)})}compute(X,ge,Me){return X.fontInfo.lineHeight}}class Ee extends D{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:i.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:i.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[i.localize(63,null),i.localize(64,null),i.localize(65,null)],default:X.size,description:i.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:i.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:i.localize(68,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:i.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:i.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:i.localize(71,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:c(ge.enabled,this.defaultValue.enabled),autohide:c(ge.autohide,this.defaultValue.autohide),size:r(ge.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(ge.side,this.defaultValue.side,["right","left"]),showSlider:r(ge.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:c(ge.renderCharacters,this.defaultValue.renderCharacters),scale:b.clampedInt(ge.scale,1,1,3),maxColumn:b.clampedInt(ge.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Ae(_){return _==="ctrlCmd"?T.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Be extends D{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(73,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{top:b.clampedInt(ge.top,0,0,1e3),bottom:b.clampedInt(ge.bottom,0,0,1e3)}}}class xe extends D{constructor(){const X={enabled:!0,cycle:!1};super(81,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:i.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:i.localize(75,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:c(ge.enabled,this.defaultValue.enabled),cycle:c(ge.cycle,this.defaultValue.cycle)}}}class Te extends f{constructor(){super(136)}compute(X,ge,Me){return X.pixelRatio}}class Ie extends D{constructor(){const X={other:"on",comments:"off",strings:"off"},ge=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[i.localize(76,null),i.localize(77,null),i.localize(78,null)]}];super(84,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ge,default:X.strings,description:i.localize(79,null)},comments:{anyOf:ge,default:X.comments,description:i.localize(80,null)},other:{anyOf:ge,default:X.other,description:i.localize(81,null)}},default:X,markdownDescription:i.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const St=X?"on":"off";return{comments:St,strings:St,other:St}}if(!X||typeof X!="object")return this.defaultValue;const{other:ge,comments:Me,strings:$e}=X,je=["on","inline","off"];let _e,nt,wt;return typeof ge=="boolean"?_e=ge?"on":"off":_e=r(ge,this.defaultValue.other,je),typeof Me=="boolean"?nt=Me?"on":"off":nt=r(Me,this.defaultValue.comments,je),typeof $e=="boolean"?wt=$e?"on":"off":wt=r($e,this.defaultValue.strings,je),{other:_e,comments:nt,strings:wt}}}var Se;(function(_){_[_.Off=0]="Off",_[_.On=1]="On",_[_.Relative=2]="Relative",_[_.Interval=3]="Interval",_[_.Custom=4]="Custom"})(Se=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class se extends D{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[i.localize(83,null),i.localize(84,null),i.localize(85,null),i.localize(86,null)],default:"on",description:i.localize(87,null)})}validate(X){let ge=this.defaultValue.renderType,Me=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(ge=4,Me=X):X==="interval"?ge=3:X==="relative"?ge=2:X==="on"?ge=1:ge=0),{renderType:ge,renderFn:Me}}}function ce(_){const X=_.get(92);return X==="editable"?_.get(86):X!=="on"}e.filterValidationDecorations=ce;class Y extends D{constructor(){const X=[],ge={type:"number",description:i.localize(88,null)};super(96,"rulers",X,{type:"array",items:{anyOf:[ge,{type:["object"],properties:{column:ge,color:{type:"string",description:i.localize(89,null),format:"color-hex"}}}]},default:X,description:i.localize(90,null)})}validate(X){if(Array.isArray(X)){const ge=[];for(const Me of X)if(typeof Me=="number")ge.push({column:b.clampedInt(Me,0,0,1e4),color:null});else if(Me&&typeof Me=="object"){const $e=Me;ge.push({column:b.clampedInt($e.column,0,0,1e4),color:$e.color})}return ge.sort((Me,$e)=>Me.column-$e.column),ge}return this.defaultValue}}function I(_,X){if(typeof _!="string")return X;switch(_){case"hidden":return 2;case"visible":return 3;default:return 1}}class $ extends D{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[i.localize(91,null),i.localize(92,null),i.localize(93,null)],default:"auto",description:i.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[i.localize(95,null),i.localize(96,null),i.localize(97,null)],default:"auto",description:i.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:i.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:i.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:i.localize(101,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X,Me=b.clampedInt(ge.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),$e=b.clampedInt(ge.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:b.clampedInt(ge.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:I(ge.vertical,this.defaultValue.vertical),horizontal:I(ge.horizontal,this.defaultValue.horizontal),useShadows:c(ge.useShadows,this.defaultValue.useShadows),verticalHasArrows:c(ge.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:c(ge.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:c(ge.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:c(ge.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Me,horizontalSliderSize:b.clampedInt(ge.horizontalSliderSize,Me,0,1e3),verticalScrollbarSize:$e,verticalSliderSize:b.clampedInt(ge.verticalSliderSize,$e,0,1e3),scrollByPage:c(ge.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class H extends D{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:i.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:i.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:i.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:i.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:i.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:i.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:i.localize(108,null)}})}applyUpdate(X,ge){let Me=!1;ge.allowedCharacters&&X&&(k.equals(X.allowedCharacters,ge.allowedCharacters)||(X={...X,allowedCharacters:ge.allowedCharacters},Me=!0)),ge.allowedLocales&&X&&(k.equals(X.allowedLocales,ge.allowedLocales)||(X={...X,allowedLocales:ge.allowedLocales},Me=!0));const $e=super.applyUpdate(X,ge);return Me?new m($e.newValue,!0):$e}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{nonBasicASCII:we(ge.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:c(ge.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:c(ge.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:we(ge.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:we(ge.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(X.allowedLocales,this.defaultValue.allowedLocales)}}c(X,ge){if(typeof X!="object"||!X)return ge;const Me={};for(const[$e,je]of Object.entries(X))je===!0&&(Me[$e]=!0);return Me}}class q extends D{constructor(){const X={enabled:!0,mode:"subwordSmart"};super(59,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:i.localize(109,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:c(ge.enabled,this.defaultValue.enabled),mode:r(ge.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class J extends D{constructor(){const X={enabled:O.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:O.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:i.localize(110,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:i.localize(111,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:c(ge.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:c(ge.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class de extends D{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[i.localize(112,null),i.localize(113,null),i.localize(114,null)],default:X.bracketPairs,description:i.localize(115,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[i.localize(116,null),i.localize(117,null),i.localize(118,null)],default:X.bracketPairsHorizontal,description:i.localize(119,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:i.localize(120,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:i.localize(121,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[i.localize(122,null),i.localize(123,null),i.localize(124,null)],default:X.highlightActiveIndentation,description:i.localize(125,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{bracketPairs:we(ge.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:we(ge.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:c(ge.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:c(ge.indentation,this.defaultValue.indentation),highlightActiveIndentation:we(ge.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function we(_,X,ge){const Me=ge.indexOf(_);return Me===-1?X:ge[Me]}class ae extends D{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectQuickSuggestions:!0,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[i.localize(126,null),i.localize(127,null)],default:X.insertMode,description:i.localize(128,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:i.localize(129,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:i.localize(130,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:i.localize(131,null)},"editor.suggest.selectQuickSuggestions":{type:"boolean",default:X.selectQuickSuggestions,markdownDescription:i.localize(132,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:i.localize(133,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:i.localize(134,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:i.localize(135,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:i.localize(136,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:i.localize(137,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:i.localize(138,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:i.localize(139,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:i.localize(140,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:i.localize(141,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:i.localize(142,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:i.localize(143,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:i.localize(144,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:i.localize(145,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:i.localize(146,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:i.localize(147,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:i.localize(148,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:i.localize(149,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:i.localize(150,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:i.localize(151,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:i.localize(152,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:i.localize(153,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:i.localize(154,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:i.localize(155,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:i.localize(156,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:i.localize(157,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:i.localize(158,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:i.localize(159,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:i.localize(160,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:i.localize(161,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:i.localize(162,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:i.localize(163,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:i.localize(164,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:i.localize(165,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:i.localize(166,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:i.localize(167,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:i.localize(168,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:i.localize(169,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{insertMode:r(ge.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:c(ge.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:c(ge.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:c(ge.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:c(ge.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectQuickSuggestions:c(ge.selectQuickSuggestions,this.defaultValue.selectQuickSuggestions),showIcons:c(ge.showIcons,this.defaultValue.showIcons),showStatusBar:c(ge.showStatusBar,this.defaultValue.showStatusBar),preview:c(ge.preview,this.defaultValue.preview),previewMode:r(ge.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:c(ge.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:c(ge.showMethods,this.defaultValue.showMethods),showFunctions:c(ge.showFunctions,this.defaultValue.showFunctions),showConstructors:c(ge.showConstructors,this.defaultValue.showConstructors),showDeprecated:c(ge.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:c(ge.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:c(ge.showFields,this.defaultValue.showFields),showVariables:c(ge.showVariables,this.defaultValue.showVariables),showClasses:c(ge.showClasses,this.defaultValue.showClasses),showStructs:c(ge.showStructs,this.defaultValue.showStructs),showInterfaces:c(ge.showInterfaces,this.defaultValue.showInterfaces),showModules:c(ge.showModules,this.defaultValue.showModules),showProperties:c(ge.showProperties,this.defaultValue.showProperties),showEvents:c(ge.showEvents,this.defaultValue.showEvents),showOperators:c(ge.showOperators,this.defaultValue.showOperators),showUnits:c(ge.showUnits,this.defaultValue.showUnits),showValues:c(ge.showValues,this.defaultValue.showValues),showConstants:c(ge.showConstants,this.defaultValue.showConstants),showEnums:c(ge.showEnums,this.defaultValue.showEnums),showEnumMembers:c(ge.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:c(ge.showKeywords,this.defaultValue.showKeywords),showWords:c(ge.showWords,this.defaultValue.showWords),showColors:c(ge.showColors,this.defaultValue.showColors),showFiles:c(ge.showFiles,this.defaultValue.showFiles),showReferences:c(ge.showReferences,this.defaultValue.showReferences),showFolders:c(ge.showFolders,this.defaultValue.showFolders),showTypeParameters:c(ge.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:c(ge.showSnippets,this.defaultValue.showSnippets),showUsers:c(ge.showUsers,this.defaultValue.showUsers),showIssues:c(ge.showIssues,this.defaultValue.showIssues)}}}class pe extends D{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:i.localize(170,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:c(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ve extends f{constructor(){super(137)}compute(X,ge,Me){return ge.get(86)?!0:X.tabFocusMode}}var We;(function(_){_[_.None=0]="None",_[_.Same=1]="Same",_[_.Indent=2]="Indent",_[_.DeepIndent=3]="DeepIndent"})(We=e.WrappingIndent||(e.WrappingIndent={}));class He extends D{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[i.localize(171,null),i.localize(172,null),i.localize(173,null),i.localize(174,null)],description:i.localize(175,null),default:"same"}})}validate(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(X,ge,Me){return ge.get(2)===2?0:Me}}class tt extends f{constructor(){super(139)}compute(X,ge,Me){const $e=ge.get(138);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:$e.isWordWrapMinified,isViewportWrapping:$e.isViewportWrapping,wrappingColumn:$e.wrappingColumn}}}class Xe extends D{constructor(){const X={enabled:!0};super(33,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:i.localize(176,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:c(X.enabled,this.defaultValue.enabled)}}}const et="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",dt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:T.isMacintosh?it:T.isLinux?dt:et,fontWeight:"normal",fontSize:T.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Fe(_){return e.editorOptionsRegistry[_.id]=_,_}var st;(function(_){_[_.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",_[_.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",_[_.accessibilitySupport=2]="accessibilitySupport",_[_.accessibilityPageSize=3]="accessibilityPageSize",_[_.ariaLabel=4]="ariaLabel",_[_.autoClosingBrackets=5]="autoClosingBrackets",_[_.autoClosingDelete=6]="autoClosingDelete",_[_.autoClosingOvertype=7]="autoClosingOvertype",_[_.autoClosingQuotes=8]="autoClosingQuotes",_[_.autoIndent=9]="autoIndent",_[_.automaticLayout=10]="automaticLayout",_[_.autoSurround=11]="autoSurround",_[_.bracketPairColorization=12]="bracketPairColorization",_[_.guides=13]="guides",_[_.codeLens=14]="codeLens",_[_.codeLensFontFamily=15]="codeLensFontFamily",_[_.codeLensFontSize=16]="codeLensFontSize",_[_.colorDecorators=17]="colorDecorators",_[_.colorDecoratorsLimit=18]="colorDecoratorsLimit",_[_.columnSelection=19]="columnSelection",_[_.comments=20]="comments",_[_.contextmenu=21]="contextmenu",_[_.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",_[_.cursorBlinking=23]="cursorBlinking",_[_.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",_[_.cursorStyle=25]="cursorStyle",_[_.cursorSurroundingLines=26]="cursorSurroundingLines",_[_.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",_[_.cursorWidth=28]="cursorWidth",_[_.disableLayerHinting=29]="disableLayerHinting",_[_.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",_[_.domReadOnly=31]="domReadOnly",_[_.dragAndDrop=32]="dragAndDrop",_[_.dropIntoEditor=33]="dropIntoEditor",_[_.emptySelectionClipboard=34]="emptySelectionClipboard",_[_.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",_[_.extraEditorClassName=36]="extraEditorClassName",_[_.fastScrollSensitivity=37]="fastScrollSensitivity",_[_.find=38]="find",_[_.fixedOverflowWidgets=39]="fixedOverflowWidgets",_[_.folding=40]="folding",_[_.foldingStrategy=41]="foldingStrategy",_[_.foldingHighlight=42]="foldingHighlight",_[_.foldingImportsByDefault=43]="foldingImportsByDefault",_[_.foldingMaximumRegions=44]="foldingMaximumRegions",_[_.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",_[_.fontFamily=46]="fontFamily",_[_.fontInfo=47]="fontInfo",_[_.fontLigatures=48]="fontLigatures",_[_.fontSize=49]="fontSize",_[_.fontWeight=50]="fontWeight",_[_.fontVariations=51]="fontVariations",_[_.formatOnPaste=52]="formatOnPaste",_[_.formatOnType=53]="formatOnType",_[_.glyphMargin=54]="glyphMargin",_[_.gotoLocation=55]="gotoLocation",_[_.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",_[_.hover=57]="hover",_[_.inDiffEditor=58]="inDiffEditor",_[_.inlineSuggest=59]="inlineSuggest",_[_.letterSpacing=60]="letterSpacing",_[_.lightbulb=61]="lightbulb",_[_.lineDecorationsWidth=62]="lineDecorationsWidth",_[_.lineHeight=63]="lineHeight",_[_.lineNumbers=64]="lineNumbers",_[_.lineNumbersMinChars=65]="lineNumbersMinChars",_[_.linkedEditing=66]="linkedEditing",_[_.links=67]="links",_[_.matchBrackets=68]="matchBrackets",_[_.minimap=69]="minimap",_[_.mouseStyle=70]="mouseStyle",_[_.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",_[_.mouseWheelZoom=72]="mouseWheelZoom",_[_.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",_[_.multiCursorModifier=74]="multiCursorModifier",_[_.multiCursorPaste=75]="multiCursorPaste",_[_.multiCursorLimit=76]="multiCursorLimit",_[_.occurrencesHighlight=77]="occurrencesHighlight",_[_.overviewRulerBorder=78]="overviewRulerBorder",_[_.overviewRulerLanes=79]="overviewRulerLanes",_[_.padding=80]="padding",_[_.parameterHints=81]="parameterHints",_[_.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",_[_.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",_[_.quickSuggestions=84]="quickSuggestions",_[_.quickSuggestionsDelay=85]="quickSuggestionsDelay",_[_.readOnly=86]="readOnly",_[_.renameOnType=87]="renameOnType",_[_.renderControlCharacters=88]="renderControlCharacters",_[_.renderFinalNewline=89]="renderFinalNewline",_[_.renderLineHighlight=90]="renderLineHighlight",_[_.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",_[_.renderValidationDecorations=92]="renderValidationDecorations",_[_.renderWhitespace=93]="renderWhitespace",_[_.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",_[_.roundedSelection=95]="roundedSelection",_[_.rulers=96]="rulers",_[_.scrollbar=97]="scrollbar",_[_.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",_[_.scrollBeyondLastLine=99]="scrollBeyondLastLine",_[_.scrollPredominantAxis=100]="scrollPredominantAxis",_[_.selectionClipboard=101]="selectionClipboard",_[_.selectionHighlight=102]="selectionHighlight",_[_.selectOnLineNumbers=103]="selectOnLineNumbers",_[_.showFoldingControls=104]="showFoldingControls",_[_.showUnused=105]="showUnused",_[_.snippetSuggestions=106]="snippetSuggestions",_[_.smartSelect=107]="smartSelect",_[_.smoothScrolling=108]="smoothScrolling",_[_.stickyScroll=109]="stickyScroll",_[_.stickyTabStops=110]="stickyTabStops",_[_.stopRenderingLineAfter=111]="stopRenderingLineAfter",_[_.suggest=112]="suggest",_[_.suggestFontSize=113]="suggestFontSize",_[_.suggestLineHeight=114]="suggestLineHeight",_[_.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",_[_.suggestSelection=116]="suggestSelection",_[_.tabCompletion=117]="tabCompletion",_[_.tabIndex=118]="tabIndex",_[_.unicodeHighlighting=119]="unicodeHighlighting",_[_.unusualLineTerminators=120]="unusualLineTerminators",_[_.useShadowDOM=121]="useShadowDOM",_[_.useTabStops=122]="useTabStops",_[_.wordBreak=123]="wordBreak",_[_.wordSeparators=124]="wordSeparators",_[_.wordWrap=125]="wordWrap",_[_.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",_[_.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",_[_.wordWrapColumn=128]="wordWrapColumn",_[_.wordWrapOverride1=129]="wordWrapOverride1",_[_.wordWrapOverride2=130]="wordWrapOverride2",_[_.wrappingIndent=131]="wrappingIndent",_[_.wrappingStrategy=132]="wrappingStrategy",_[_.showDeprecated=133]="showDeprecated",_[_.inlayHints=134]="inlayHints",_[_.editorClassName=135]="editorClassName",_[_.pixelRatio=136]="pixelRatio",_[_.tabFocusMode=137]="tabFocusMode",_[_.layoutInfo=138]="layoutInfo",_[_.wrappingInfo=139]="wrappingInfo"})(st=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Fe(new l(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:i.localize(177,null)})),acceptSuggestionOnEnter:Fe(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",i.localize(178,null),""],markdownDescription:i.localize(179,null)})),accessibilitySupport:Fe(new s),accessibilityPageSize:Fe(new b(3,"accessibilityPageSize",10,1,1073741824,{description:i.localize(180,null),tags:["accessibility"]})),ariaLabel:Fe(new w(4,"ariaLabel",i.localize(181,null))),autoClosingBrackets:Fe(new a(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(182,null),i.localize(183,null),""],description:i.localize(184,null)})),autoClosingDelete:Fe(new a(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",i.localize(185,null),""],description:i.localize(186,null)})),autoClosingOvertype:Fe(new a(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",i.localize(187,null),""],description:i.localize(188,null)})),autoClosingQuotes:Fe(new a(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(189,null),i.localize(190,null),""],description:i.localize(191,null)})),autoIndent:Fe(new o(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],d,{enumDescriptions:[i.localize(192,null),i.localize(193,null),i.localize(194,null),i.localize(195,null),i.localize(196,null)],description:i.localize(197,null)})),automaticLayout:Fe(new l(10,"automaticLayout",!1)),autoSurround:Fe(new a(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[i.localize(198,null),i.localize(199,null),i.localize(200,null),""],description:i.localize(201,null)})),bracketPairColorization:Fe(new J),bracketPairGuides:Fe(new de),stickyTabStops:Fe(new l(110,"stickyTabStops",!1,{description:i.localize(202,null)})),codeLens:Fe(new l(14,"codeLens",!0,{description:i.localize(203,null)})),codeLensFontFamily:Fe(new w(15,"codeLensFontFamily","",{description:i.localize(204,null)})),codeLensFontSize:Fe(new b(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:i.localize(205,null)})),colorDecorators:Fe(new l(17,"colorDecorators",!0,{description:i.localize(206,null)})),colorDecoratorsLimit:Fe(new b(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:i.localize(207,null)})),columnSelection:Fe(new l(19,"columnSelection",!1,{description:i.localize(208,null)})),comments:Fe(new u),contextmenu:Fe(new l(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Fe(new l(22,"copyWithSyntaxHighlighting",!0,{description:i.localize(209,null)})),cursorBlinking:Fe(new o(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],h,{description:i.localize(210,null)})),cursorSmoothCaretAnimation:Fe(new a(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[i.localize(211,null),i.localize(212,null),i.localize(213,null)],description:i.localize(214,null)})),cursorStyle:Fe(new o(25,"cursorStyle",g.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],M,{description:i.localize(215,null)})),cursorSurroundingLines:Fe(new b(26,"cursorSurroundingLines",0,0,1073741824,{description:i.localize(216,null)})),cursorSurroundingLinesStyle:Fe(new a(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[i.localize(217,null),i.localize(218,null)],description:i.localize(219,null)})),cursorWidth:Fe(new b(28,"cursorWidth",0,0,1073741824,{markdownDescription:i.localize(220,null)})),disableLayerHinting:Fe(new l(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Fe(new l(30,"disableMonospaceOptimizations",!1)),domReadOnly:Fe(new l(31,"domReadOnly",!1)),dragAndDrop:Fe(new l(32,"dragAndDrop",!0,{description:i.localize(221,null)})),emptySelectionClipboard:Fe(new Z),dropIntoEditor:Fe(new Xe),stickyScroll:Fe(new De),experimentalWhitespaceRendering:Fe(new a(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[i.localize(222,null),i.localize(223,null),i.localize(224,null)],description:i.localize(225,null)})),extraEditorClassName:Fe(new w(36,"extraEditorClassName","")),fastScrollSensitivity:Fe(new E(37,"fastScrollSensitivity",5,_=>_<=0?5:_,{markdownDescription:i.localize(226,null)})),find:Fe(new G),fixedOverflowWidgets:Fe(new l(39,"fixedOverflowWidgets",!1)),folding:Fe(new l(40,"folding",!0,{description:i.localize(227,null)})),foldingStrategy:Fe(new a(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[i.localize(228,null),i.localize(229,null)],description:i.localize(230,null)})),foldingHighlight:Fe(new l(42,"foldingHighlight",!0,{description:i.localize(231,null)})),foldingImportsByDefault:Fe(new l(43,"foldingImportsByDefault",!1,{description:i.localize(232,null)})),foldingMaximumRegions:Fe(new b(44,"foldingMaximumRegions",5e3,10,65e3,{description:i.localize(233,null)})),unfoldOnClickAfterEndOfLine:Fe(new l(45,"unfoldOnClickAfterEndOfLine",!1,{description:i.localize(234,null)})),fontFamily:Fe(new w(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:i.localize(235,null)})),fontInfo:Fe(new F),fontLigatures2:Fe(new A),fontSize:Fe(new B),fontWeight:Fe(new z),fontVariations:Fe(new R),formatOnPaste:Fe(new l(52,"formatOnPaste",!1,{description:i.localize(236,null)})),formatOnType:Fe(new l(53,"formatOnType",!1,{description:i.localize(237,null)})),glyphMargin:Fe(new l(54,"glyphMargin",!0,{description:i.localize(238,null)})),gotoLocation:Fe(new V),hideCursorInOverviewRuler:Fe(new l(56,"hideCursorInOverviewRuler",!1,{description:i.localize(239,null)})),hover:Fe(new K),inDiffEditor:Fe(new l(58,"inDiffEditor",!1)),letterSpacing:Fe(new E(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,_=>E.clamp(_,-5,20),{description:i.localize(240,null)})),lightbulb:Fe(new oe),lineDecorationsWidth:Fe(new Q),lineHeight:Fe(new le),lineNumbers:Fe(new se),lineNumbersMinChars:Fe(new b(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Fe(new l(66,"linkedEditing",!1,{description:i.localize(241,null)})),links:Fe(new l(67,"links",!0,{description:i.localize(242,null)})),matchBrackets:Fe(new a(68,"matchBrackets","always",["always","near","never"],{description:i.localize(243,null)})),minimap:Fe(new Ee),mouseStyle:Fe(new a(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Fe(new E(71,"mouseWheelScrollSensitivity",1,_=>_===0?1:_,{markdownDescription:i.localize(244,null)})),mouseWheelZoom:Fe(new l(72,"mouseWheelZoom",!1,{markdownDescription:i.localize(245,null)})),multiCursorMergeOverlapping:Fe(new l(73,"multiCursorMergeOverlapping",!0,{description:i.localize(246,null)})),multiCursorModifier:Fe(new o(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ae,{markdownEnumDescriptions:[i.localize(247,null),i.localize(248,null)],markdownDescription:i.localize(249,null)})),multiCursorPaste:Fe(new a(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[i.localize(250,null),i.localize(251,null)],markdownDescription:i.localize(252,null)})),multiCursorLimit:Fe(new b(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:i.localize(253,null)})),occurrencesHighlight:Fe(new l(77,"occurrencesHighlight",!0,{description:i.localize(254,null)})),overviewRulerBorder:Fe(new l(78,"overviewRulerBorder",!0,{description:i.localize(255,null)})),overviewRulerLanes:Fe(new b(79,"overviewRulerLanes",3,0,3)),padding:Fe(new Be),parameterHints:Fe(new xe),peekWidgetDefaultFocus:Fe(new a(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[i.localize(256,null),i.localize(257,null)],description:i.localize(258,null)})),definitionLinkOpensInPeek:Fe(new l(83,"definitionLinkOpensInPeek",!1,{description:i.localize(259,null)})),quickSuggestions:Fe(new Ie),quickSuggestionsDelay:Fe(new b(85,"quickSuggestionsDelay",10,0,1073741824,{description:i.localize(260,null)})),readOnly:Fe(new l(86,"readOnly",!1)),renameOnType:Fe(new l(87,"renameOnType",!1,{description:i.localize(261,null),markdownDeprecationMessage:i.localize(262,null)})),renderControlCharacters:Fe(new l(88,"renderControlCharacters",!0,{description:i.localize(263,null),restricted:!0})),renderFinalNewline:Fe(new a(89,"renderFinalNewline",T.isLinux?"dimmed":"on",["off","on","dimmed"],{description:i.localize(264,null)})),renderLineHighlight:Fe(new a(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",i.localize(265,null)],description:i.localize(266,null)})),renderLineHighlightOnlyWhenFocus:Fe(new l(91,"renderLineHighlightOnlyWhenFocus",!1,{description:i.localize(267,null)})),renderValidationDecorations:Fe(new a(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Fe(new a(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",i.localize(268,null),i.localize(269,null),i.localize(270,null),""],description:i.localize(271,null)})),revealHorizontalRightPadding:Fe(new b(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Fe(new l(95,"roundedSelection",!0,{description:i.localize(272,null)})),rulers:Fe(new Y),scrollbar:Fe(new $),scrollBeyondLastColumn:Fe(new b(98,"scrollBeyondLastColumn",4,0,1073741824,{description:i.localize(273,null)})),scrollBeyondLastLine:Fe(new l(99,"scrollBeyondLastLine",!0,{description:i.localize(274,null)})),scrollPredominantAxis:Fe(new l(100,"scrollPredominantAxis",!0,{description:i.localize(275,null)})),selectionClipboard:Fe(new l(101,"selectionClipboard",!0,{description:i.localize(276,null),included:T.isLinux})),selectionHighlight:Fe(new l(102,"selectionHighlight",!0,{description:i.localize(277,null)})),selectOnLineNumbers:Fe(new l(103,"selectOnLineNumbers",!0)),showFoldingControls:Fe(new a(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[i.localize(278,null),i.localize(279,null),i.localize(280,null)],description:i.localize(281,null)})),showUnused:Fe(new l(105,"showUnused",!0,{description:i.localize(282,null)})),showDeprecated:Fe(new l(133,"showDeprecated",!0,{description:i.localize(283,null)})),inlayHints:Fe(new re),snippetSuggestions:Fe(new a(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[i.localize(284,null),i.localize(285,null),i.localize(286,null),i.localize(287,null)],description:i.localize(288,null)})),smartSelect:Fe(new pe),smoothScrolling:Fe(new l(108,"smoothScrolling",!1,{description:i.localize(289,null)})),stopRenderingLineAfter:Fe(new b(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Fe(new ae),inlineSuggest:Fe(new q),suggestFontSize:Fe(new b(113,"suggestFontSize",0,0,1e3,{markdownDescription:i.localize(290,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Fe(new b(114,"suggestLineHeight",0,0,1e3,{markdownDescription:i.localize(291,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Fe(new l(115,"suggestOnTriggerCharacters",!0,{description:i.localize(292,null)})),suggestSelection:Fe(new a(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[i.localize(293,null),i.localize(294,null),i.localize(295,null)],description:i.localize(296,null)})),tabCompletion:Fe(new a(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[i.localize(297,null),i.localize(298,null),i.localize(299,null)],description:i.localize(300,null)})),tabIndex:Fe(new b(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Fe(new H),unusualLineTerminators:Fe(new a(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[i.localize(301,null),i.localize(302,null),i.localize(303,null)],description:i.localize(304,null)})),useShadowDOM:Fe(new l(121,"useShadowDOM",!0)),useTabStops:Fe(new l(122,"useTabStops",!0,{description:i.localize(305,null)})),wordBreak:Fe(new a(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[i.localize(306,null),i.localize(307,null)],description:i.localize(308,null)})),wordSeparators:Fe(new w(124,"wordSeparators",y.USUAL_WORD_SEPARATORS,{description:i.localize(309,null)})),wordWrap:Fe(new a(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[i.localize(310,null),i.localize(311,null),i.localize(312,null),i.localize(313,null)],description:i.localize(314,null)})),wordWrapBreakAfterCharacters:Fe(new w(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Fe(new w(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Fe(new b(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:i.localize(315,null)})),wordWrapOverride1:Fe(new a(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Fe(new a(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Fe(new j),pixelRatio:Fe(new Te),tabFocusMode:Fe(new ve),layoutInfo:Fe(new me),wrappingInfo:Fe(new tt),wrappingIndent:Fe(new He),wrappingStrategy:Fe(new ue)}}),define(ke[128],Ce([17,18]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[129],Ce([17,18]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[130],Ce([17,18]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[131],Ce([17,18]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(ke[132],Ce([17,18]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(ke[133],Ce([17,18]),function(ee,e){return ee.create("vs/platform/workspace/common/workspace",e)}),define(ke[134],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[135],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[136],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostProgress",e)}),define(ke[137],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[138],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[139],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[140],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[141],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/common/editor",e)}),define(ke[142],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[143],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[144],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[145],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[146],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[147],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[148],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[149],Ce([1,0,11]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class T{constructor(){this.a=new Map}register(L,k){this.a.set(L,k)}updateManifest(L){if(!(typeof L.main>"u"&&typeof L.browser>"u")&&(L.activationEvents===void 0&&Object.assign(L,{activationEvents:[]}),!(!Array.isArray(L.activationEvents)||!L.contributes)))for(const k in L.contributes){const O=this.a.get(k);if(!O)continue;const S=L.contributes[k],C=Array.isArray(S)?S:[S];try{O(C,L.activationEvents)}catch(N){(0,i.onUnexpectedError)(N)}}}}e.ImplicitActivationEventsImpl=T,e.ImplicitActivationEvents=new T}),define(ke[150],Ce([1,0,22,29,130,248]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,O=/^-(\d{4})(\d{2})(\d{2})$/;function S(l){return l=l.trim(),l==="*"||k.test(l)}e.isValidVersionStr=S;function C(l){if(!S(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=l.match(k);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=C;function N(l){if(!l)return null;const v=l.majorBase,b=l.majorMustEqual,E=l.minorBase;let w=l.minorMustEqual;const r=l.patchBase;let a=l.patchMustEqual;l.hasCaret&&(v===0||(w=!1),a=!1);let o=0;if(l.preRelease){const d=O.exec(l.preRelease);if(d){const[,s,u,n]=d;o=Date.UTC(Number(s),Number(u)-1,Number(n))}}return{majorBase:v,majorMustEqual:b,minorBase:E,minorMustEqual:w,patchBase:r,patchMustEqual:a,isMinimum:l.hasGreaterEquals,notBefore:o}}e.normalizeVersion=N;function D(l,v,b){let E;typeof l=="string"?E=N(C(l)):E=l;let w;v instanceof Date?w=v.getTime():typeof v=="string"&&(w=new Date(v).getTime());let r;if(typeof b=="string"?r=N(C(b)):r=b,!E||!r)return!1;const a=E.majorBase,o=E.minorBase,d=E.patchBase;let s=r.majorBase,u=r.minorBase,n=r.patchBase;const h=r.notBefore;let g=r.majorMustEqual,P=r.minorMustEqual,M=r.patchMustEqual;return r.isMinimum?a>s?!0:a<s?!1:o>u?!0:o<u||w&&w<h?!1:d>=n:(a===1&&s===0&&(!g||!P||!M)&&(s=1,u=0,n=0,g=!0,P=!1,M=!1),a<s?!1:a>s?!g:o<u?!1:o>u?!P:d<n?!1:d>n?!M:!(w&&w<h))}e.isValidVersion=D;function m(l,v,b,E,w){const r=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return r.push([T.default.Error,y.localize(0,null)]),r;if(typeof E.name!="string")return r.push([T.default.Error,y.localize(1,null,"name")]),r;if(typeof E.version!="string")return r.push([T.default.Error,y.localize(2,null,"version")]),r;if(!E.engines)return r.push([T.default.Error,y.localize(3,null,"engines")]),r;if(typeof E.engines.vscode!="string")return r.push([T.default.Error,y.localize(4,null,"engines.vscode")]),r;if(typeof E.extensionDependencies<"u"&&!c(E.extensionDependencies))return r.push([T.default.Error,y.localize(5,null,"extensionDependencies")]),r;if(typeof E.activationEvents<"u"){if(!c(E.activationEvents))return r.push([T.default.Error,y.localize(6,null,"activationEvents")]),r;if(typeof E.main>"u"&&typeof E.browser>"u")return r.push([T.default.Error,y.localize(7,null,"activationEvents","main")]),r}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&r.push([T.default.Warning,y.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return r.push([T.default.Error,y.localize(9,null,"main")]),r;{const d=(0,i.joinPath)(b,E.main);(0,i.isEqualOrParent)(d,b)||r.push([T.default.Warning,y.localize(10,null,d.path,b.path)])}if(typeof E.activationEvents>"u")return r.push([T.default.Error,y.localize(11,null,"activationEvents","main")]),r}if(typeof E.browser<"u"){if(typeof E.browser!="string")return r.push([T.default.Error,y.localize(12,null,"browser")]),r;{const d=(0,i.joinPath)(b,E.browser);(0,i.isEqualOrParent)(d,b)||r.push([T.default.Warning,y.localize(13,null,d.path,b.path)])}if(typeof E.activationEvents>"u")return r.push([T.default.Error,y.localize(14,null,"activationEvents","browser")]),r}if(!L.valid(E.version))return r.push([T.default.Error,y.localize(15,null)]),r;const a=[];if(!p(l,v,E,w,a))for(const d of a)r.push([T.default.Error,d]);return r}e.validateExtensionManifest=m;function p(l,v,b,E,w){return E||typeof b.main>"u"&&typeof b.browser>"u"?!0:t(l,v,b.engines.vscode,w)}e.isValidExtensionVersion=p;function f(l,v,b){return l==="*"||t(v,b,l)}e.isEngineValid=f;function t(l,v,b,E=[]){const w=N(C(b));if(!w)return E.push(y.localize(16,null,b)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return E.push(y.localize(17,null,b)),!1}else if(!w.majorMustEqual)return E.push(y.localize(18,null,b)),!1;return D(l,v,w)?!0:(E.push(y.localize(19,null,l,b)),!1)}function c(l){if(!Array.isArray(l))return!1;for(let v=0,b=l.length;v<b;v++)if(typeof l[v]!="string")return!1;return!0}}),define(ke[86],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class i{constructor(y,L=[],k=!1){this.ctor=y,this.staticArguments=L,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=i}),define(ke[63],Ce([1,0,86]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const T=[];var y;(function(O){O[O.Eager=0]="Eager",O[O.Delayed=1]="Delayed"})(y=e.InstantiationType||(e.InstantiationType={}));function L(O,S,C){S instanceof i.SyncDescriptor||(S=new i.SyncDescriptor(S,[],Boolean(C))),T.push([O,S])}e.registerSingleton=L;function k(){return T}e.getSingletonServiceDescriptors=k}),define(ke[151],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class i{constructor(L,k){this.key=L,this.data=k,this.incoming=new Map,this.outgoing=new Map}}e.Node=i;class T{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const k of this.a.values())k.outgoing.size===0&&L.push(k);return L}insertEdge(L,k){const O=this.lookupOrInsertNode(L),S=this.lookupOrInsertNode(k);O.outgoing.set(S.key,S),S.incoming.set(O.key,O)}removeNode(L){const k=this.b(L);this.a.delete(k);for(const O of this.a.values())O.outgoing.delete(k),O.incoming.delete(k)}lookupOrInsertNode(L){const k=this.b(L);let O=this.a.get(k);return O||(O=new i(k,L),this.a.set(k,O)),O}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[k,O]of this.a)L.push(`${k}
	(-> incoming)[${[...O.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...O.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,k]of this.a){const O=new Set([L]),S=this.c(k,O);if(S)return S}}c(L,k){for(const[O,S]of L.outgoing){if(k.has(O))return[...k,O].join(" -> ");k.add(O);const C=this.c(S,k);if(C)return C;k.delete(O)}}}e.Graph=T}),define(ke[3],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var i;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function O(S){return S[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=O})(i=e._util||(e._util={})),e.IInstantiationService=y("instantiationService");function T(k,O,S){O[i.DI_TARGET]===O?O[i.DI_DEPENDENCIES].push({id:k,index:S}):(O[i.DI_DEPENDENCIES]=[{id:k,index:S}],O[i.DI_TARGET]=O)}function y(k){if(i.serviceIds.has(k))return i.serviceIds.get(k);const O=function(S,C,N){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(O,S,N)};return O.toString=()=>k,i.serviceIds.set(k,O),O}e.createDecorator=y;function L(k){return k}e.refineServiceDecorator=L}),define(ke[40],Ce([1,0,9,2,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function L(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof T.URI)}e.isConfigurationOverrides=L;function k(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof T.URI)}e.isConfigurationUpdateOverrides=k;var O;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(O=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=S;function C(l,v){const b=Object.create(null);for(const E in l)N(b,E,l[E],v);return b}e.toValuesTree=C;function N(l,v,b,E){const w=v.split("."),r=w.pop();let a=l;for(let o=0;o<w.length;o++){const d=w[o];let s=a[d];switch(typeof s){case"undefined":s=a[d]=Object.create(null);break;case"object":break;default:E(`Ignoring ${v} as ${w.slice(0,o+1).join(".")} is ${JSON.stringify(s)}`);return}a=s}if(typeof a=="object"&&a!==null)try{a[r]=b}catch{E(`Ignoring ${v} as ${w.join(".")} is ${JSON.stringify(a)}`)}else E(`Ignoring ${v} as ${w.join(".")} is ${JSON.stringify(a)}`)}e.addToValueTree=N;function D(l,v){const b=v.split(".");m(l,b)}e.removeFromValueTree=D;function m(l,v){const b=v.shift();if(v.length===0){delete l[b];return}if(Object.keys(l).indexOf(b)!==-1){const E=l[b];typeof E=="object"&&!Array.isArray(E)&&(m(E,v),Object.keys(E).length===0&&delete l[b])}}function p(l,v,b){function E(a,o){let d=a;for(const s of o){if(typeof d!="object"||d===null)return;d=d[s]}return d}const w=v.split("."),r=E(l,w);return typeof r>"u"?b:r}e.getConfigurationValue=p;function f(l,v,b){Object.keys(v).forEach(E=>{E!=="__proto__"&&(E in l?i.isObject(l[E])&&i.isObject(v[E])?f(l[E],v[E],b):b&&(l[E]=v[E]):l[E]=v[E])})}e.merge=f;function t(l,v,b){const E=l.inspect(v),w=l.inspect(b);return typeof E.userValue<"u"||typeof E.workspaceValue<"u"||typeof E.workspaceFolderValue<"u"?E.value:typeof w.userValue<"u"||typeof w.workspaceValue<"u"||typeof w.workspaceFolderValue<"u"?w.value:E.defaultValue}e.getMigratedSettingValue=t;function c(l){return l.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=c}),define(ke[41],Ce([1,0,21,10,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const L=new Map;L.set("false",!1),L.set("true",!0),L.set("isMac",i.isMacintosh),L.set("isLinux",i.isLinux),L.set("isWindows",i.isWindows),L.set("isWeb",i.isWeb),L.set("isMacNative",i.isMacintosh&&!i.isWeb),L.set("isEdge",i.isEdge),L.set("isFirefox",i.isFirefox),L.set("isChrome",i.isChrome),L.set("isSafari",i.isSafari);const k=Object.prototype.hasOwnProperty;var O;(function(G){G[G.False=0]="False",G[G.True=1]="True",G[G.Defined=2]="Defined",G[G.Not=3]="Not",G[G.Equals=4]="Equals",G[G.NotEquals=5]="NotEquals",G[G.And=6]="And",G[G.Regex=7]="Regex",G[G.NotRegex=8]="NotRegex",G[G.Or=9]="Or",G[G.In=10]="In",G[G.NotIn=11]="NotIn",G[G.Greater=12]="Greater",G[G.GreaterEquals=13]="GreaterEquals",G[G.Smaller=14]="Smaller",G[G.SmallerEquals=15]="SmallerEquals"})(O=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return D.INSTANCE}static true(){return m.INSTANCE}static has(A){return p.create(A)}static equals(A,R){return f.create(A,R)}static notEquals(A,R){return l.create(A,R)}static regex(A,R){return o.create(A,R)}static in(A,R){return t.create(A,R)}static notIn(A,R){return c.create(A,R)}static not(A){return v.create(A)}static and(...A){return u.create(A,null,!0)}static or(...A){return n.create(A,null,!0)}static greater(A,R){return E.create(A,R)}static greaterEquals(A,R){return w.create(A,R)}static smaller(A,R){return r.create(A,R)}static smallerEquals(A,R){return a.create(A,R)}static deserialize(A,R=!1){if(!!A)return this.c(A,R)}static c(A,R){const F=A.split("||");return n.create(F.map(B=>this.d(B,R)),null,!0)}static d(A,R){const F=A.split("&&");return u.create(F.map(B=>this.f(B,R)),null,!0)}static f(A,R){if(A=A.trim(),A.indexOf("!=")>=0){const F=A.split("!=");return l.create(F[0].trim(),this.g(F[1],R))}if(A.indexOf("==")>=0){const F=A.split("==");return f.create(F[0].trim(),this.g(F[1],R))}if(A.indexOf("=~")>=0){const F=A.split("=~");return o.create(F[0].trim(),this.h(F[1],R))}if(A.indexOf(" not in ")>=0){const F=A.split(" not in ");return c.create(F[0].trim(),this.g(F[1],R))}if(A.indexOf(" in ")>=0){const F=A.split(" in ");return t.create(F[0].trim(),this.g(F[1],R))}if(/^[^<=>]+>=[^<=>]+$/.test(A)){const F=A.split(">=");return w.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(A)){const F=A.split(">");return E.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(A)){const F=A.split("<=");return a.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(A)){const F=A.split("<");return r.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(A)?v.create(A.substr(1).trim()):p.create(A)}static g(A,R){if(A=A.trim(),A==="true")return!0;if(A==="false")return!1;const F=/^'([^']*)'$/.exec(A);return F?F[1].trim():A}static h(A,R){if((0,T.isFalsyOrWhitespace)(A)){if(R)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const F=A.indexOf("/"),B=A.lastIndexOf("/");if(F===B||F<0){if(R)throw new Error(`bad regexp-value '${A}', missing /-enclosure`);return console.warn(`bad regexp-value '${A}', missing /-enclosure`),null}const z=A.slice(F+1,B),V=A[B+1]==="i"?"i":"";try{return new RegExp(z,V)}catch(K){if(R)throw new Error(`bad regexp-value '${A}', parse error: ${K}`);return console.warn(`bad regexp-value '${A}', parse error: ${K}`),null}}}e.ContextKeyExpr=S;function C(G,A){const R=G?G.substituteConstants():void 0,F=A?A.substituteConstants():void 0;return!R&&!F?!0:!R||!F?!1:R.equals(F)}e.expressionsAreEqualWithConstantSubstitution=C;function N(G,A){return G.cmp(A)}class D{constructor(){this.type=0}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=D,D.INSTANCE=new D;class m{constructor(){this.type=1}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return D.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class p{static create(A,R=null){const F=L.get(A);return typeof F=="boolean"?F?m.INSTANCE:D.INSTANCE:new p(A,R)}constructor(A,R){this.key=A,this.c=R,this.type=2}cmp(A){return A.type!==this.type?this.type-A.type:g(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=L.get(this.key);return typeof A=="boolean"?A?m.INSTANCE:D.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.c||(this.c=v.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=p;class f{static create(A,R,F=null){if(typeof R=="boolean")return R?p.create(A,F):v.create(A,F);const B=L.get(A);return typeof B=="boolean"?R===(B?"true":"false")?m.INSTANCE:D.INSTANCE:new f(A,R,F)}constructor(A,R,F){this.c=A,this.d=R,this.f=F,this.type=4}cmp(A){return A.type!==this.type?this.type-A.type:P(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=L.get(this.c);if(typeof A=="boolean"){const R=A?"true":"false";return this.d===R?m.INSTANCE:D.INSTANCE}return this}evaluate(A){return A.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(A){return A.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=l.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=f;class t{static create(A,R){return new t(A,R)}constructor(A,R){this.d=A,this.f=R,this.type=10,this.c=null}cmp(A){return A.type!==this.type?this.type-A.type:P(this.d,this.f,A.d,A.f)}equals(A){return A.type===this.type?this.d===A.d&&this.f===A.f:!1}substituteConstants(){return this}evaluate(A){const R=A.getValue(this.f),F=A.getValue(this.d);return Array.isArray(R)?R.includes(F):typeof F=="string"&&typeof R=="object"&&R!==null?k.call(R,F):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(A){return A.mapIn(this.d,this.f)}negate(){return this.c||(this.c=c.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=t;class c{static create(A,R){return new c(A,R)}constructor(A,R){this.d=A,this.f=R,this.type=11,this.c=t.create(A,R)}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(A){return A.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=c;class l{static create(A,R,F=null){if(typeof R=="boolean")return R?v.create(A,F):p.create(A,F);const B=L.get(A);return typeof B=="boolean"?R===(B?"true":"false")?D.INSTANCE:m.INSTANCE:new l(A,R,F)}constructor(A,R,F){this.c=A,this.d=R,this.f=F,this.type=5}cmp(A){return A.type!==this.type?this.type-A.type:P(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=L.get(this.c);if(typeof A=="boolean"){const R=A?"true":"false";return this.d===R?D.INSTANCE:m.INSTANCE}return this}evaluate(A){return A.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(A){return A.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=f.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=l;class v{static create(A,R=null){const F=L.get(A);return typeof F=="boolean"?F?D.INSTANCE:m.INSTANCE:new v(A,R)}constructor(A,R){this.c=A,this.d=R,this.type=3}cmp(A){return A.type!==this.type?this.type-A.type:g(this.c,A.c)}equals(A){return A.type===this.type?this.c===A.c:!1}substituteConstants(){const A=L.get(this.c);return typeof A=="boolean"?A?D.INSTANCE:m.INSTANCE:this}evaluate(A){return!A.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(A){return A.mapNot(this.c)}negate(){return this.d||(this.d=p.create(this.c,this)),this.d}}e.ContextKeyNotExpr=v;function b(G,A){if(typeof G=="string"){const R=parseFloat(G);isNaN(R)||(G=R)}return typeof G=="string"||typeof G=="number"?A(G):D.INSTANCE}class E{static create(A,R,F=null){return b(R,B=>new E(A,B,F))}constructor(A,R,F){this.c=A,this.d=R,this.f=F,this.type=12}cmp(A){return A.type!==this.type?this.type-A.type:P(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=a.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=E;class w{static create(A,R,F=null){return b(R,B=>new w(A,B,F))}constructor(A,R,F){this.c=A,this.d=R,this.f=F,this.type=13}cmp(A){return A.type!==this.type?this.type-A.type:P(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=r.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=w;class r{static create(A,R,F=null){return b(R,B=>new r(A,B,F))}constructor(A,R,F){this.c=A,this.d=R,this.f=F,this.type=14}cmp(A){return A.type!==this.type?this.type-A.type:P(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=r;class a{static create(A,R,F=null){return b(R,B=>new a(A,B,F))}constructor(A,R,F){this.c=A,this.d=R,this.f=F,this.type=15}cmp(A){return A.type!==this.type?this.type-A.type:P(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=a;class o{static create(A,R){return new o(A,R)}constructor(A,R){this.d=A,this.f=R,this.type=7,this.c=null}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.d<A.d)return-1;if(this.d>A.d)return 1;const R=this.f?this.f.source:"",F=A.f?A.f.source:"";return R<F?-1:R>F?1:0}equals(A){if(A.type===this.type){const R=this.f?this.f.source:"",F=A.f?A.f.source:"";return this.d===A.d&&R===F}return!1}substituteConstants(){return this}evaluate(A){const R=A.getValue(this.d);return this.f?this.f.test(R):!1}serialize(){const A=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${A}`}keys(){return[this.d]}map(A){return A.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=d.create(this)),this.c}}e.ContextKeyRegexExpr=o;class d{static create(A){return new d(A)}constructor(A){this.c=A,this.type=8}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(A){return new d(this.c.map(A))}negate(){return this.c}}e.ContextKeyNotRegexExpr=d;function s(G){let A=null;for(let R=0,F=G.length;R<F;R++){const B=G[R].substituteConstants();if(G[R]!==B&&A===null){A=[];for(let z=0;z<R;z++)A[z]=G[z]}A!==null&&(A[R]=B)}return A===null?G:A}class u{static create(A,R,F){return u.d(A,R,F)}constructor(A,R){this.expr=A,this.c=R,this.type=6}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let R=0,F=this.expr.length;R<F;R++){const B=N(this.expr[R],A.expr[R]);if(B!==0)return B}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let R=0,F=this.expr.length;R<F;R++)if(!this.expr[R].equals(A.expr[R]))return!1;return!0}return!1}substituteConstants(){const A=s(this.expr);return A===this.expr?this:u.create(A,this.c,!1)}evaluate(A){for(let R=0,F=this.expr.length;R<F;R++)if(!this.expr[R].evaluate(A))return!1;return!0}static d(A,R,F){const B=[];let z=!1;for(const V of A)if(!!V){if(V.type===1){z=!0;continue}if(V.type===0)return D.INSTANCE;if(V.type===6){B.push(...V.expr);continue}B.push(V)}if(B.length===0&&z)return m.INSTANCE;if(B.length!==0){if(B.length===1)return B[0];B.sort(N);for(let V=1;V<B.length;V++)B[V-1].equals(B[V])&&(B.splice(V,1),V--);if(B.length===1)return B[0];for(;B.length>1;){const V=B[B.length-1];if(V.type!==9)break;B.pop();const K=B.pop(),ie=B.length===0,me=n.create(V.expr.map(ue=>u.create([ue,K],null,F)),null,ie);me&&(B.push(me),B.sort(N))}if(B.length===1)return B[0];if(F){for(let V=0;V<B.length;V++)for(let K=V+1;K<B.length;K++)if(B[V].negate().equals(B[K]))return D.INSTANCE;if(B.length===1)return B[0]}return new u(B,R)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(const R of this.expr)A.push(...R.keys());return A}map(A){return new u(this.expr.map(R=>R.map(A)),null)}negate(){if(!this.c){const A=[];for(const R of this.expr)A.push(R.negate());this.c=n.create(A,this,!0)}return this.c}}class n{static create(A,R,F){return n.d(A,R,F)}constructor(A,R){this.expr=A,this.c=R,this.type=9}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let R=0,F=this.expr.length;R<F;R++){const B=N(this.expr[R],A.expr[R]);if(B!==0)return B}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let R=0,F=this.expr.length;R<F;R++)if(!this.expr[R].equals(A.expr[R]))return!1;return!0}return!1}substituteConstants(){const A=s(this.expr);return A===this.expr?this:n.create(A,this.c,!1)}evaluate(A){for(let R=0,F=this.expr.length;R<F;R++)if(this.expr[R].evaluate(A))return!0;return!1}static d(A,R,F){let B=[],z=!1;if(A){for(let V=0,K=A.length;V<K;V++){const ie=A[V];if(!!ie){if(ie.type===0){z=!0;continue}if(ie.type===1)return m.INSTANCE;if(ie.type===9){B=B.concat(ie.expr);continue}B.push(ie)}}if(B.length===0&&z)return D.INSTANCE;B.sort(N)}if(B.length!==0){if(B.length===1)return B[0];for(let V=1;V<B.length;V++)B[V-1].equals(B[V])&&(B.splice(V,1),V--);if(B.length===1)return B[0];if(F){for(let V=0;V<B.length;V++)for(let K=V+1;K<B.length;K++)if(B[V].negate().equals(B[K]))return m.INSTANCE;if(B.length===1)return B[0]}return new n(B,R)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(const R of this.expr)A.push(...R.keys());return A}map(A){return new n(this.expr.map(R=>R.map(A)),null)}negate(){if(!this.c){const A=[];for(const R of this.expr)A.push(R.negate());for(;A.length>1;){const R=A.shift(),F=A.shift(),B=[];for(const z of Z(R))for(const V of Z(F))B.push(u.create([z,V],null,!1));A.unshift(n.create(B,null,!1))}this.c=n.create(A,this,!0)}return this.c}}class h extends p{static all(){return h.d.values()}constructor(A,R,F){super(A,null),this.f=R,typeof F=="object"?h.d.push({...F,key:A}):F!==!0&&h.d.push({key:A,description:F,type:R!=null?typeof R:void 0})}bindTo(A){return A.createKey(this.key,this.f)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return f.create(this.key,A)}notEqualsTo(A){return l.create(this.key,A)}}e.RawContextKey=h,h.d=[],e.IContextKeyService=(0,y.createDecorator)("contextKeyService");function g(G,A){return G<A?-1:G>A?1:0}function P(G,A,R,F){return G<R?-1:G>R?1:A<F?-1:A>F?1:0}function M(G,A){if(G.type===0||A.type===1)return!0;if(G.type===9)return A.type===9?j(G.expr,A.expr):!1;if(A.type===9){for(const R of A.expr)if(M(G,R))return!0;return!1}if(G.type===6){if(A.type===6)return j(A.expr,G.expr);for(const R of G.expr)if(M(R,A))return!0;return!1}return G.equals(A)}e.implies=M;function j(G,A){let R=0,F=0;for(;R<G.length&&F<A.length;){const B=G[R].cmp(A[F]);if(B<0)return!1;B===0&&R++,F++}return R===G.length}function Z(G){return G.type===9?G.expr:[G]}}),define(ke[152],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,i.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,i.refineServiceDecorator)(e.IEnvironmentService)}),define(ke[87],Ce([1,0,129,3]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function y(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=y;function L(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function k(l,v){switch(l){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=k;function O(l,v){return v==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=O;function S(l,v,b){return O(v,b)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===b?!0:C(b).includes(l)}e.isTargetPlatformCompatible=S;function C(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=C;function N(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=N;var D;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(D=e.SortBy||(e.SortBy={}));var m;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var p;(function(l){l.Install="install",l.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var f;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,T.createDecorator)("extensionGalleryService");var t;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal",l.Signature="Signature"})(t=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class c extends Error{constructor(v,b){super(v),this.code=b,this.name=b}}e.ExtensionManagementError=c,e.IExtensionManagementService=(0,T.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,T.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,T.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,i.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,i.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ke[36],Ce([1,0,46,19,10,9,2,131,3]),function(ee,e,i,T,y,L,k,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function C(z){return z.create===!0}e.isFileOpenForWriteOptions=C;var N;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(N=e.FileType||(e.FileType={}));var D;(function(z){z[z.Readonly=1]="Readonly"})(D=e.FilePermission||(e.FilePermission={}));var m;(function(z){z[z.None=0]="None",z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock",z[z.FileAtomicRead=16384]="FileAtomicRead",z[z.FileClone=32768]="FileClone"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=p;function f(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=f;function t(z){return!!(z.capabilities&32768)}e.hasFileCloneCapability=t;function c(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=c;function l(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=l;function v(z){return p(z)?!!(z.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var b;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class E extends Error{constructor(V,K){super(V),this.code=K}}e.FileSystemProviderError=E;function w(z,V){const K=new E(z.toString(),V);return a(K,V),K}e.createFileSystemProviderError=w;function r(z){return z||w((0,O.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=r;function a(z,V){return z.name=V?`${V} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=a;function o(z){if(!z)return b.Unknown;if(z instanceof E)return z.code;const V=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!V)return b.Unknown;switch(V[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=o;function d(z){if(z instanceof P)return z.fileOperationResult;switch(o(z)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=d;var s;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY",z[z.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class u{constructor(V,K,ie){this.resource=V,this.operation=K,this.target=ie}isOperation(V){return this.operation===V}}e.FileOperationEvent=u;var n;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(n=e.FileChangeType||(e.FileChangeType={}));class h{constructor(V,K){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ie=new Map;for(const me of V){const ue=ie.get(me.type);switch(ue?ue.push([me.resource,me]):ie.set(me.type,[[me.resource,me]]),me.type){case 1:this.rawAdded.push(me.resource);break;case 0:this.rawUpdated.push(me.resource);break;case 2:this.rawDeleted.push(me.resource);break}}for(const[me,ue]of ie)switch(me){case 1:this.a=i.TernarySearchTree.forUris(()=>K),this.a.fill(ue);break;case 0:this.b=i.TernarySearchTree.forUris(()=>K),this.b.fill(ue);break;case 2:this.c=i.TernarySearchTree.forUris(()=>K),this.c.fill(ue);break}}contains(V,...K){return this.d(V,{includeChildren:!1},...K)}affects(V,...K){return this.d(V,{includeChildren:!0},...K)}d(V,K,...ie){if(!V)return!1;const me=ie.length>0;return!!((!me||ie.includes(1))&&(this.a?.get(V)||K.includeChildren&&this.a?.findSuperstr(V))||(!me||ie.includes(0))&&(this.b?.get(V)||K.includeChildren&&this.b?.findSuperstr(V))||(!me||ie.includes(2))&&(this.c?.findSubstr(V)||K.includeChildren&&this.c?.findSuperstr(V)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=h;function g(z,V,K){return!z||!V||z===V||V.length>z.length?!1:(V.charAt(V.length-1)!==T.sep&&(V+=T.sep),K?(0,y.startsWithIgnoreCase)(z,V):z.indexOf(V)===0)}e.isParent=g;class P extends Error{constructor(V,K,ie){super(V),this.fileOperationResult=K,this.options=ie}}e.FileOperationError=P;class M extends P{constructor(V,K,ie){super(V,2,ie),this.stat=K}}e.NotModifiedSinceFileOperationError=M;var j;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(j=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var Z;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(Z=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function G(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=G;async function A(z,V){if(!V.hasProvider(k.URI.from({scheme:z.scheme})))return new Promise(K=>{const ie=V.onDidChangeFileSystemProviderRegistrations(me=>{me.scheme===z.scheme&&me.added&&(ie.dispose(),K())})})}e.whenProviderRegistered=A,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class R{static formatSize(V){return(0,L.isNumber)(V)||(V=0),V<R.KB?(0,O.localize)(1,null,V.toFixed(0)):V<R.MB?(0,O.localize)(2,null,(V/R.KB).toFixed(2)):V<R.GB?(0,O.localize)(3,null,(V/R.MB).toFixed(2)):V<R.TB?(0,O.localize)(4,null,(V/R.GB).toFixed(2)):(0,O.localize)(5,null,(V/R.TB).toFixed(2))}}e.ByteSize=R,R.KB=1024,R.MB=R.KB*R.KB,R.GB=R.MB*R.KB,R.TB=R.GB*R.KB;var F;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function B(z){return{maxFileSize:z===0?300*R.MB:16*R.GB,maxHeapSize:z===0?700*R.MB:2*700*R.MB}}e.getPlatformLimits=B}),define(ke[64],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class i{constructor(...y){this.a=new Map;for(const[L,k]of y)this.set(L,k)}set(y,L){const k=this.a.get(y);return this.a.set(y,L),k}has(y){return this.a.has(y)}get(y){return this.a.get(y)}}e.ServiceCollection=i}),define(ke[153],Ce([1,0,14,11,7,86,151,3,64,154]),function(ee,e,i,T,y,L,k,O,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const N=!1;class D extends Error{constructor(c){super("cyclic dependency between services"),this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class m{constructor(c=new S.ServiceCollection,l=!1,v,b=N){this.f=c,this.g=l,this.h=v,this.i=b,this.o=new Set,this.f.set(O.IInstantiationService,this),this._globalGraph=b?v?._globalGraph??new k.Graph(E=>E):void 0}createChild(c){return new m(c,this.g,this,this.i)}invokeFunction(c,...l){const v=f.traceInvocation(this.i,c);let b=!1;try{return c({get:w=>{if(b)throw(0,T.illegalState)("service accessor is only valid during the invocation of its target method");const r=this.m(w,v);if(!r)throw new Error(`[invokeFunction] unknown service '${w}'`);return r}},...l)}finally{b=!0,v.stop()}}createInstance(c,...l){let v,b;return c instanceof L.SyncDescriptor?(v=f.traceCreation(this.i,c.ctor),b=this.j(c.ctor,c.staticArguments.concat(l),v)):(v=f.traceCreation(this.i,c),b=this.j(c,l,v)),v.stop(),b}j(c,l=[],v){const b=O._util.getServiceDependencies(c).sort((r,a)=>r.index-a.index),E=[];for(const r of b){const a=this.m(r.id,v);a||this.u(`[createInstance] ${c.name} depends on UNKNOWN service ${r.id}.`,!1),E.push(a)}const w=b.length>0?b[0].index:l.length;if(l.length!==w){console.trace(`[createInstance] First service dependency of ${c.name} at position ${w+1} conflicts with ${l.length} static arguments`);const r=w-l.length;r>0?l=l.concat(new Array(r)):l=l.slice(0,w)}return Reflect.construct(c,l.concat(E))}k(c,l){if(this.f.get(c)instanceof L.SyncDescriptor)this.f.set(c,l);else if(this.h)this.h.k(c,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(c){const l=this.f.get(c);return!l&&this.h?this.h.l(c):l}m(c,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(c));const v=this.l(c);return v instanceof L.SyncDescriptor?this.q(c,v,l.branch(c,!0)):(l.branch(c,!1),v)}q(c,l,v){if(this.o.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this.o.add(c);try{return this.r(c,l,v)}finally{this.o.delete(c)}}r(c,l,v){const b=new k.Graph(r=>r.id.toString());let E=0;const w=[{id:c,desc:l,_trace:v}];for(;w.length;){const r=w.pop();if(b.lookupOrInsertNode(r),E++>1e3)throw new D(b);for(const a of O._util.getServiceDependencies(r.desc.ctor)){const o=this.l(a.id);if(o||this.u(`[createInstance] ${c} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(a.id)),o instanceof L.SyncDescriptor){const d={id:a.id,desc:o,_trace:r._trace.branch(a.id,!0)};b.insertEdge(r,d),w.push(d)}}}for(;;){const r=b.roots();if(r.length===0){if(!b.isEmpty())throw new D(b);break}for(const{data:a}of r){if(this.l(a.id)instanceof L.SyncDescriptor){const d=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,d)}b.removeNode(a)}}return this.l(c)}s(c,l,v=[],b,E){if(this.f.get(c)instanceof L.SyncDescriptor)return this.t(c,l,v,b,E);if(this.h)return this.h.s(c,l,v,b,E);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(c,l,v=[],b,E){if(b){const w=new m(void 0,this.g,this,this.i);w.c=String(c);const r=new Map,a=new i.IdleValue(()=>{const o=w.j(l,v,E);for(const[d,s]of r){const u=o[d];if(typeof u=="function")for(const n of s)u.apply(o,n)}return r.clear(),o});return new Proxy(Object.create(null),{get(o,d){if(!a.isInitialized&&typeof d=="string"&&(d.startsWith("onDid")||d.startsWith("onWill"))){let n=r.get(d);return n||(n=new C.LinkedList,r.set(d,n)),(g,P,M)=>{const j=n.push([g,P,M]);return(0,y.toDisposable)(j)}}if(d in o)return o[d];const s=a.value;let u=s[d];return typeof u!="function"||(u=u.bind(s),o[d]=u),u},set(o,d,s){return a.value[d]=s,!0},getPrototypeOf(o){return l.prototype}})}else return this.j(l,v,E)}u(c,l){if(l&&console.warn(c),this.g)throw new Error(c)}}e.InstantiationService=m;var p;(function(t){t[t.None=0]="None",t[t.Creation=1]="Creation",t[t.Invocation=2]="Invocation",t[t.Branch=3]="Branch"})(p||(p={}));class f{static traceInvocation(c,l){return c?new f(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(c,l){return c?new f(1,l.name):f.c}constructor(c,l){this.type=c,this.name=l,this.g=Date.now(),this.h=[]}branch(c,l){const v=new f(3,c.toString());return this.h.push([c,l,v]),v}stop(){const c=Date.now()-this.g;f.f+=c;let l=!1;function v(E,w){const r=[],a=new Array(E+1).join("	");for(const[o,d,s]of w.h)if(d&&s){l=!0,r.push(`${a}CREATES -> ${o}`);const u=v(E+1,s);u&&r.push(u)}else r.push(`${a}uses -> ${o}`);return r.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(c>2||l)&&f.all.add(b.join(`
`))}}e.Trace=f,f.all=new Set,f.c=new class extends f{constructor(){super(0,null)}stop(){}branch(){return this}},f.f=0}),define(ke[12],Ce([1,0,45,5,7,28,21,2,3]),function(ee,e,i,T,y,L,k,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function C(){return new Date().toISOString()}var N;(function(u){u[u.Off=0]="Off",u[u.Trace=1]="Trace",u[u.Debug=2]="Debug",u[u.Info=3]="Info",u[u.Warning=4]="Warning",u[u.Error=5]="Error"})(N=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=N.Info;function D(u,n,h){switch(n){case N.Trace:u.trace(h);break;case N.Debug:u.debug(h);break;case N.Info:u.info(h);break;case N.Warning:u.warn(h);break;case N.Error:u.error(h);break;case N.Off:break;default:throw new Error(`Invalid log level ${n}`)}}e.log=D;function m(u){let n="";for(let h=0;h<u.length;h++){let g=u[h];if(typeof g=="object")try{g=JSON.stringify(g)}catch{}n+=(h>0?" ":"")+g}return n}e.format=m;class p extends y.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new T.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(n){this.b!==n&&(this.b=n,this.c.fire(this.b))}getLevel(){return this.b}f(n){return this.b!==N.Off&&this.b<=n}}e.AbstractLogger=p;class f extends p{constructor(n){super(),this.h=n}f(n){return this.h||super.f(n)}trace(n,...h){this.f(N.Trace)&&this.g(N.Trace,m([n,...h]))}debug(n,...h){this.f(N.Debug)&&this.g(N.Debug,m([n,...h]))}info(n,...h){this.f(N.Info)&&this.g(N.Info,m([n,...h]))}warn(n,...h){this.f(N.Warning)&&this.g(N.Warning,m([n,...h]))}error(n,...h){if(this.f(N.Error))if(n instanceof Error){const g=Array.prototype.slice.call(arguments);g[0]=n.stack,this.g(N.Error,m(g))}else this.g(N.Error,m([n,...h]))}flush(){}}e.AbstractMessageLogger=f;class t extends p{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n),this.g=!k.isWindows}trace(n,...h){this.f(N.Trace)&&(this.g?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,n,...h):console.log(`[main ${C()}]`,n,...h))}debug(n,...h){this.f(N.Debug)&&(this.g?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,n,...h):console.log(`[main ${C()}]`,n,...h))}info(n,...h){this.f(N.Info)&&(this.g?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,n,...h):console.log(`[main ${C()}]`,n,...h))}warn(n,...h){this.f(N.Warning)&&(this.g?console.warn(`\x1B[93m[main ${C()}]\x1B[0m`,n,...h):console.warn(`[main ${C()}]`,n,...h))}error(n,...h){this.f(N.Error)&&(this.g?console.error(`\x1B[91m[main ${C()}]\x1B[0m`,n,...h):console.error(`[main ${C()}]`,n,...h))}dispose(){}flush(){}}e.ConsoleMainLogger=t;class c extends p{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n)}trace(n,...h){this.f(N.Trace)&&console.log("%cTRACE","color: #888",n,...h)}debug(n,...h){this.f(N.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",n,...h)}info(n,...h){this.f(N.Info)&&console.log("%c INFO","color: #33f",n,...h)}warn(n,...h){this.f(N.Warning)&&console.log("%c WARN","color: #993",n,...h)}error(n,...h){this.f(N.Error)&&console.log("%c  ERR","color: #f33",n,...h)}dispose(){}flush(){}}e.ConsoleLogger=c;class l extends p{constructor(n,h=e.DEFAULT_LOG_LEVEL){super(),this.g=n,this.setLevel(h)}trace(n,...h){this.f(N.Trace)&&this.g.log(N.Trace,[this.h(n),...h])}debug(n,...h){this.f(N.Debug)&&this.g.log(N.Debug,[this.h(n),...h])}info(n,...h){this.f(N.Info)&&this.g.log(N.Info,[this.h(n),...h])}warn(n,...h){this.f(N.Warning)&&this.g.log(N.Warning,[this.h(n),...h])}error(n,...h){this.f(N.Error)&&this.g.log(N.Error,[this.h(n),...h])}h(n){return typeof n=="string"?n:(0,i.toErrorMessage)(n,this.f(N.Trace))}dispose(){}flush(){}}e.AdapterLogger=l;class v extends p{constructor(n){super(),this.g=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const h of this.g)h.setLevel(n);super.setLevel(n)}trace(n,...h){for(const g of this.g)g.trace(n,...h)}debug(n,...h){for(const g of this.g)g.debug(n,...h)}info(n,...h){for(const g of this.g)g.info(n,...h)}warn(n,...h){for(const g of this.g)g.warn(n,...h)}error(n,...h){for(const g of this.g)g.error(n,...h)}flush(){for(const n of this.g)n.flush()}dispose(){for(const n of this.g)n.dispose()}}e.MultiplexLogService=v;class b extends y.Disposable{constructor(n){super(),this.b=n,this.B(n)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(n){this.b.setLevel(n)}getLevel(){return this.b.getLevel()}trace(n,...h){this.b.trace(n,...h)}debug(n,...h){this.b.debug(n,...h)}info(n,...h){this.b.info(n,...h)}warn(n,...h){this.b.warn(n,...h)}error(n,...h){this.b.error(n,...h)}flush(){this.b.flush()}}e.LogService=b;class E extends y.Disposable{constructor(n,h){super(),this.c=n,this.b=new L.ResourceMap,this.B(h(g=>this.setLevel(g)))}getLoggers(){return[...this.b.values()].map(({logger:n})=>n)}getLogger(n){return this.b.get(n)?.logger}createLogger(n,h,g){let P=this.b.get(n)?.logger;return P||(g=h?.always?N.Trace:g,P=this.f(n,g??this.c,h),this.b.set(n,{logger:P,logLevel:g})),P}setLevel(n,h){const g=O.URI.isUri(n)?n:void 0,P=g?h:n;if(g){const M=this.b.get(g);M&&M.logLevel!==P&&(M.logLevel=P,M.logger.setLevel(P))}else this.c=P,this.b.forEach(({logLevel:M,logger:j})=>{M===void 0&&j.setLevel(this.c)})}getLogLevel(n){return this.b.get(n)?.logLevel}dispose(){this.b.forEach(({logger:n})=>n.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=E;class w{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(n){}getLevel(){return N.Info}trace(n,...h){}debug(n,...h){}info(n,...h){}warn(n,...h){}error(n,...h){}critical(n,...h){}dispose(){}flush(){}}e.NullLogger=w;class r extends w{}e.NullLogService=r;class a extends E{constructor(){super(N.Info,T.Event.None)}f(n,h,g){return new w}}e.NullLoggerService=a;function o(u){if(u.verbose)return N.Trace;if(typeof u.logLevel=="string"){const n=s(u.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function d(u){switch(u){case N.Trace:return"trace";case N.Debug:return"debug";case N.Info:return"info";case N.Warning:return"warn";case N.Error:return"error";case N.Off:return"off"}}e.LogLevelToString=d;function s(u){switch(u){case"trace":return N.Trace;case"debug":return N.Debug;case"info":return N.Info;case"warn":return N.Warning;case"error":return N.Error;case"critical":return N.Error;case"off":return N.Off}}e.parseLogLevel=s}),define(ke[88],Ce([1,0,29,132,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(L=e.MarkerTag||(e.MarkerTag={}));var k;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(k=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function C(f,t){return t-f}S.compare=C;const N=Object.create(null);N[S.Error]=(0,T.localize)(0,null),N[S.Warning]=(0,T.localize)(1,null),N[S.Info]=(0,T.localize)(2,null);function D(f){return N[f]||""}S.toString=D;function m(f){switch(f){case i.default.Error:return S.Error;case i.default.Warning:return S.Warning;case i.default.Info:return S.Info;case i.default.Ignore:return S.Hint}}S.fromSeverity=m;function p(f){switch(f){case S.Error:return i.default.Error;case S.Warning:return i.default.Warning;case S.Info:return i.default.Info;case S.Hint:return i.default.Ignore}}S.toSeverity=p}(k=e.MarkerSeverity||(e.MarkerSeverity={}));var O;(function(S){const C="";function N(m){return D(m,!0)}S.makeKey=N;function D(m,p){const f=[C];return m.source?f.push(m.source.replace("\xA6","\\\xA6")):f.push(C),m.code?typeof m.code=="string"?f.push(m.code.replace("\xA6","\\\xA6")):f.push(m.code.value.replace("\xA6","\\\xA6")):f.push(C),m.severity!==void 0&&m.severity!==null?f.push(k.toString(m.severity)):f.push(C),m.message&&p?f.push(m.message.replace("\xA6","\\\xA6")):f.push(C),m.startLineNumber!==void 0&&m.startLineNumber!==null?f.push(m.startLineNumber.toString()):f.push(C),m.startColumn!==void 0&&m.startColumn!==null?f.push(m.startColumn.toString()):f.push(C),m.endLineNumber!==void 0&&m.endLineNumber!==null?f.push(m.endLineNumber.toString()):f.push(C),m.endColumn!==void 0&&m.endColumn!==null?f.push(m.endColumn.toString()):f.push(C),f.push(C),f.join("\xA6")}S.makeKeyOptionalMessage=D})(O=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,y.createDecorator)("markerService")}),define(ke[155],Ce([1,0,5,29,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=T.default,e.INotificationService=(0,y.createDecorator)("notificationService");var L;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.PROFILE=1]="PROFILE",C[C.APPLICATION=2]="APPLICATION"})(L=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var k;(function(C){C[C.OFF=0]="OFF",C[C.SILENT=1]="SILENT",C[C.ERROR=2]="ERROR"})(k=e.NotificationsFilter||(e.NotificationsFilter={}));class O{constructor(){this.progress=new S,this.onDidClose=i.Event.None,this.onDidChangeVisibility=i.Event.None}updateSeverity(N){}updateMessage(N){}updateActions(N){}close(){}}e.NoOpNotification=O;class S{infinite(){}done(){}total(N){}worked(N){}}e.NoOpProgress=S}),define(ke[89],Ce([1,0,10,2,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,y.createDecorator)("openerService");function L(C,N){return T.URI.isUri(C)?(0,i.equalsIgnoreCase)(C.scheme,N):(0,i.startsWithIgnoreCase)(C,N+":")}e.matchesScheme=L;function k(C,...N){return N.some(D=>L(C,D))}e.matchesSomeScheme=k;function O(C,N){return C.with({fragment:`${N.startLineNumber},${N.startColumn}${N.endLineNumber?`-${N.endLineNumber}${N.endColumn?`,${N.endColumn}`:""}`:""}`})}e.withSelection=O;function S(C){let N;const D=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(C.fragment);return D&&(N={startLineNumber:parseInt(D[1]),startColumn:D[2]?parseInt(D[2]):1,endLineNumber:D[4]?parseInt(D[4]):void 0,endColumn:D[4]?D[5]?parseInt(D[5]):1:void 0},C=C.with({fragment:""})),{selection:N,uri:C}}e.extractSelection=S}),define(ke[156],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,i.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var qe=this&&this.__decorate||function(ee,e,i,T){var y=arguments.length,L=y<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,i):T,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(ee,e,i,T);else for(var O=ee.length-1;O>=0;O--)(k=ee[O])&&(L=(y<3?k(L):y>3?k(e,i,L):k(e,i))||L);return y>3&&L&&Object.defineProperty(e,i,L),L},Ve=this&&this.__param||function(ee,e){return function(i,T){e(i,T,ee)}};define(ke[157],Ce([1,0,14,20,7,3]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,L.createDecorator)("progressService");var k;(function(N){N[N.Explorer=1]="Explorer",N[N.Scm=3]="Scm",N[N.Extensions=5]="Extensions",N[N.Window=10]="Window",N[N.Notification=15]="Notification",N[N.Dialog=20]="Dialog"})(k=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class O{get value(){return this.a}constructor(D){this.b=D}report(D){this.a=D,this.b(this.a)}}e.Progress=O,O.None=Object.freeze({report(){}});let S=class extends y.Disposable{constructor(D,m){super(),this.a=new i.DeferredPromise,m.withProgress(D,p=>(this.b=p,this.c&&p.report(this.c),this.a.p)),this.B((0,y.toDisposable)(()=>this.a.complete()))}report(D){this.b?this.b.report(D):this.c=D}};S=qe([Ve(1,e.IProgressService)],S),e.UnmanagedProgress=S;class C extends y.Disposable{constructor(D){super(),this.g=D,this.a=0,this.b=this.B(new y.DisposableStore)}start(D){this.stop();const m=++this.a,p=new T.CancellationTokenSource;return this.f=setTimeout(()=>{m===this.a&&(this.c=this.g.show(!0))},D),this.b.add((0,y.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,y.toDisposable)(()=>p.cancel())),this.b.add((0,y.toDisposable)(()=>this.c?this.c.done():void 0)),{id:m,token:p.token,stop:()=>this.h(m),isCurrent:()=>this.a===m}}stop(){this.h(this.a)}h(D){this.a===D&&this.b.clear()}}e.LongRunningOperation=C,e.IEditorProgressService=(0,L.createDecorator)("editorProgressService")}),define(ke[30],Ce([1,0,47,9]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class y{constructor(){this.a=new Map}add(k,O){i.ok(T.isString(k)),i.ok(T.isObject(O)),i.ok(!this.a.has(k),"There is already an extension with this id"),this.a.set(k,O)}knows(k){return this.a.has(k)}as(k){return this.a.get(k)||null}}e.Registry=new y}),define(ke[90],Ce([1,0,5,30]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function y(O){return O.length>0&&O.charAt(O.length-1)==="#"?O.substring(0,O.length-1):O}class L{constructor(){this.b=new i.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,C){this.a[y(S)]=C,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const k=new L;T.Registry.add(e.Extensions.JSONContribution,k)}),define(ke[91],Ce([1,0,16,5,9,128,40,90,30]),function(ee,e,i,T,y,L,k,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var N;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(N=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const D=S.Registry.as(O.Extensions.JSONContribution);class m{constructor(){this.h=new Set,this.i=new T.Emitter,this.onDidSchemaChange=this.i.event,this.j=new T.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.r()}registerConfiguration(r,a=!0){this.registerConfigurations([r],a)}registerConfigurations(r,a=!0){const o=this.k(r,a);D.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:o})}deregisterConfigurations(r){const a=this.l(r);D.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:r,remove:a}){const o=[];o.push(...this.l(a)),o.push(...this.k(r,!1)),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:(0,i.distinct)(o)})}registerDefaultConfigurations(r){const a=[],o=[];for(const{overrides:d,source:s}of r)for(const u in d)if(a.push(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const n=this.a.get(u),h=n?.valuesSources??new Map;if(s)for(const j of Object.keys(d[u]))h.set(j,s);const g={...n?.value||{},...d[u]};this.a.set(u,{source:s,value:g,valuesSources:h});const P=(0,k.getLanguageTagSettingPlainKey)(u),M={type:"object",default:g,description:L.localize(1,null,P),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:g,source:y.isString(s)?void 0:s,defaultValueSource:s};o.push(...t(u)),this.d[u]=M,this.b.properties[u]=M}else{this.a.set(u,{value:d[u],source:s});const n=this.d[u];n&&(this.s(u,n),this.o(u,n))}this.registerOverrideIdentifiers(o),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}deregisterDefaultConfigurations(r){const a=[];for(const{overrides:o,source:d}of r)for(const s in o){const u=this.a.get(s),n=y.isString(d)?d:d?.id,h=y.isString(u?.source)?u?.source:u?.source?.id;if(n===h)if(a.push(s),this.a.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.d[s],delete this.b.properties[s];else{const g=this.d[s];g&&(this.s(s,g),this.o(s,g))}}this.q(),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...r){this.i.fire()}registerOverrideIdentifiers(r){for(const a of r)this.h.add(a);this.q()}k(r,a){const o=[];return r.forEach(d=>{o.push(...this.m(d,a,d.extensionInfo,d.restrictedProperties)),this.c.push(d),this.n(d)}),o}l(r){const a=[],o=d=>{if(d.properties)for(const s in d.properties){a.push(s);const u=this.d[s];u?.policy?.name&&this.e.delete(u.policy.name),delete this.d[s],this.p(s,d.properties[s])}d.allOf?.forEach(s=>o(s))};for(const d of r){o(d);const s=this.c.indexOf(d);s!==-1&&this.c.splice(s,1)}return a}m(r,a=!0,o,d,s=3){s=y.isUndefinedOrNull(r.scope)?s:r.scope;const u=[],n=r.properties;if(n)for(const g in n){const P=n[g];if(a&&b(g,P)){delete n[g];continue}if(P.source=o,P.defaultDefaultValue=n[g].default,this.s(g,P),e.OVERRIDE_PROPERTY_REGEX.test(g)?P.scope=void 0:(P.scope=y.isUndefinedOrNull(P.scope)?s:P.scope,P.restricted=y.isUndefinedOrNull(P.restricted)?!!d?.includes(g):P.restricted),n[g].hasOwnProperty("included")&&!n[g].included){this.f[g]=n[g],delete n[g];continue}else this.d[g]=n[g],n[g].policy?.name&&this.e.set(n[g].policy.name,g);!n[g].deprecationMessage&&n[g].markdownDeprecationMessage&&(n[g].deprecationMessage=n[g].markdownDeprecationMessage),u.push(g)}const h=r.allOf;if(h)for(const g of h)u.push(...this.m(g,a,o,d,s));return u}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}n(r){const a=o=>{const d=o.properties;if(d)for(const u in d)this.o(u,d[u]);o.allOf?.forEach(a)};a(r)}o(r,a){switch(e.allSettings.properties[r]=a,a.scope){case 1:e.applicationSettings.properties[r]=a;break;case 2:e.machineSettings.properties[r]=a;break;case 6:e.machineOverridableSettings.properties[r]=a;break;case 3:e.windowSettings.properties[r]=a;break;case 4:e.resourceSettings.properties[r]=a;break;case 5:e.resourceSettings.properties[r]=a,this.g.properties[r]=a;break}}p(r,a){switch(delete e.allSettings.properties[r],a.scope){case 1:delete e.applicationSettings.properties[r];break;case 2:delete e.machineSettings.properties[r];break;case 6:delete e.machineOverridableSettings.properties[r];break;case 3:delete e.windowSettings.properties[r];break;case 4:case 5:delete e.resourceSettings.properties[r],delete this.g.properties[r];break}}q(){for(const r of this.h.values()){const a=`[${r}]`,o={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.s(a,o),e.allSettings.properties[a]=o,e.applicationSettings.properties[a]=o,e.machineSettings.properties[a]=o,e.machineOverridableSettings.properties[a]=o,e.windowSettings.properties[a]=o,e.resourceSettings.properties[a]=o}this.i.fire()}r(){const r={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,this.i.fire()}s(r,a){const o=this.a.get(r);let d=o?.value,s=o?.source;y.isUndefined(d)&&(d=a.defaultDefaultValue,s=void 0),y.isUndefined(d)&&(d=l(a.type)),a.default=d,a.defaultValueSource=s}}const p="\\[([^\\]]+)\\]",f=new RegExp(p,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${p})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function t(w){const r=[];if(e.OVERRIDE_PROPERTY_REGEX.test(w)){let a=f.exec(w);for(;a?.length;){const o=a[1].trim();o&&r.push(o),a=f.exec(w)}}return(0,i.distinct)(r)}e.overrideIdentifiersFromKey=t;function c(w){return w.reduce((r,a)=>`${r}[${a}]`,"")}e.keyFromOverrideIdentifiers=c;function l(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const v=new m;S.Registry.add(e.Extensions.Configuration,v);function b(w,r){return w.trim()?e.OVERRIDE_PROPERTY_REGEX.test(w)?L.localize(7,null,w):v.getConfigurationProperties()[w]!==void 0?L.localize(8,null,w):r.policy?.name&&v.getPolicyConfigurations().get(r.policy?.name)!==void 0?L.localize(9,null,w,r.policy?.name,v.getPolicyConfigurations().get(r.policy?.name)):null:L.localize(6,null)}e.validateProperty=b;function E(){const w=[],r=v.getConfigurationProperties();for(const a of Object.keys(r))w.push([a,r[a].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=E}),define(ke[158],Ce([1,0,16,5,109,7,28,23,9,2,40,91,30]),function(ee,e,i,T,y,L,k,O,S,C,N,D,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class p{constructor(a={},o=[],d=[],s){this.c=a,this.d=o,this.f=d,this.raw=s,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const a=this.raw.map(o=>{if(o instanceof p)return o;const d=new f("");return d.parseRaw(o),d.configurationModel});this.g=a.reduce((o,d)=>d===o?d:o.merge(d),a[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(a){return a?(0,N.getConfigurationValue)(this.contents,a):this.contents}inspect(a,o){const d=this.rawConfiguration.getValue(a),s=o?this.rawConfiguration.getOverrideValue(a,o):void 0,u=o?this.rawConfiguration.override(o).getValue(a):d;return{value:d,override:s,merged:u}}getOverrideValue(a,o){const d=this.l(o);return d?a?(0,N.getConfigurationValue)(d,a):d:void 0}getKeysForOverrideIdentifier(a){const o=[];for(const d of this.overrides)d.identifiers.includes(a)&&o.push(...d.keys);return i.distinct(o)}getAllOverrideIdentifiers(){const a=[];for(const o of this.overrides)a.push(...o.identifiers);return i.distinct(a)}override(a){let o=this.b.get(a);return o||(o=this.h(a),this.b.set(a,o)),o}merge(...a){const o=O.deepClone(this.contents),d=O.deepClone(this.overrides),s=[...this.keys],u=this.raw?.length?[...this.raw]:[this];for(const n of a)if(u.push(...n.raw?.length?n.raw:[n]),!n.isEmpty()){this.j(o,n.contents);for(const h of n.overrides){const[g]=d.filter(P=>i.equals(P.identifiers,h.identifiers));g?(this.j(g.contents,h.contents),g.keys.push(...h.keys),g.keys=i.distinct(g.keys)):d.push(O.deepClone(h))}for(const h of n.keys)s.indexOf(h)===-1&&s.push(h)}return new p(o,s,d,u.every(n=>n instanceof p)?void 0:u)}freeze(){return this.a=!0,this}clone(){return new p(O.deepClone(this.contents),[...this.keys],O.deepClone(this.overrides))}h(a){const o=this.l(a);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const d={};for(const s of i.distinct([...Object.keys(this.contents),...Object.keys(o)])){let u=this.contents[s];const n=o[s];n&&(typeof u=="object"&&typeof n=="object"?(u=O.deepClone(u),this.j(u,n)):u=n),d[s]=u}return new p(d,this.keys,this.overrides)}j(a,o){for(const d of Object.keys(o)){if(d in a&&S.isObject(a[d])&&S.isObject(o[d])){this.j(a[d],o[d]);continue}a[d]=O.deepClone(o[d])}}k(a){return this.a&&!Object.isFrozen(a)?O.deepFreeze(a):a}l(a){let o=null,d=null;const s=u=>{u&&(d?this.j(d,u):d=O.deepClone(u))};for(const u of this.overrides)i.equals(u.identifiers,[a])?o=u.contents:u.identifiers.includes(a)&&s(u.contents);return s(o),d}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(a,o){this.m(a),(0,N.addToValueTree)(this.contents,a,o,d=>{throw new Error(d)})}removeValue(a){this.n(a)&&(0,N.removeFromValueTree)(this.contents,a)}m(a){let o=this.keys.length;for(let d=0;d<o;d++)a.indexOf(this.keys[d])===0&&(o=d);this.keys.splice(o,1,a)}n(a){const o=this.keys.indexOf(a);return o!==-1?(this.keys.splice(o,1),!0):!1}}e.ConfigurationModel=p;class f{constructor(a){this.f=a,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,o){if(!S.isUndefinedOrNull(a)){const d=this.g(a);this.parseRaw(d,o)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,o){this.a=a;const{contents:d,keys:s,overrides:u,restricted:n,hasExcludedProperties:h}=this.h(a,o);this.b=new p(d,s,u,h?[a]:void 0),this.c=n||[]}g(a){let o={},d=null,s=[];const u=[],n=[];function h(P){Array.isArray(s)?s.push(P):d!==null&&(s[d]=P)}const g={onObjectBegin:()=>{const P={};h(P),u.push(s),s=P,d=null},onObjectProperty:P=>{d=P},onObjectEnd:()=>{s=u.pop()},onArrayBegin:()=>{const P=[];h(P),u.push(s),s=P,d=null},onArrayEnd:()=>{s=u.pop()},onLiteralValue:h,onError:(P,M,j)=>{n.push({error:P,offset:M,length:j})}};if(a)try{y.visit(a,g),o=s[0]||{}}catch(P){console.error(`Error while parsing settings file ${this.f}: ${P}`),this.d=[P]}return o}h(a,o){const d=m.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),s=this.j(a,d,!0,o);a=s.raw;const u=(0,N.toValuesTree)(a,g=>console.error(`Conflict in settings file ${this.f}: ${g}`)),n=Object.keys(a),h=this.l(a,g=>console.error(`Conflict in settings file ${this.f}: ${g}`));return{contents:u,keys:n,overrides:h,restricted:s.restricted,hasExcludedProperties:s.hasExcludedProperties}}j(a,o,d,s){let u=!1;if(!s?.scopes&&!s?.skipRestricted)return{raw:a,restricted:[],hasExcludedProperties:u};const n={},h=[];for(const g in a)if(D.OVERRIDE_PROPERTY_REGEX.test(g)&&d){const P=this.j(a[g],o,!1,s);n[g]=P.raw,u=u||P.hasExcludedProperties,h.push(...P.restricted)}else{const P=o[g],M=P?typeof P.scope<"u"?P.scope:3:void 0;P?.restricted&&h.push(g),(M===void 0||s.scopes===void 0||s.scopes.includes(M))&&!(s.skipRestricted&&P?.restricted)?n[g]=a[g]:u=!0}return{raw:n,restricted:h,hasExcludedProperties:u}}l(a,o){const d=[];for(const s of Object.keys(a))if(D.OVERRIDE_PROPERTY_REGEX.test(s)){const u={};for(const n in a[s])u[n]=a[s][n];d.push({identifiers:(0,D.overrideIdentifiersFromKey)(s),keys:Object.keys(u),contents:(0,N.toValuesTree)(u,o)})}return d}}e.ConfigurationModelParser=f;class t extends L.Disposable{constructor(a,o,d,s){super(),this.f=a,this.g=o,this.h=s,this.c=this.B(new T.Emitter),this.onDidChange=this.c.event,this.a=new f(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(d.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(T.Event.any(T.Event.filter(this.h.onDidFilesChange,u=>u.contains(this.f)),T.Event.filter(this.h.onDidRunOperation,u=>(u.isOperation(0)||u.isOperation(3)||u.isOperation(1)||u.isOperation(4))&&d.isEqual(u.resource,a)))(()=>this.c.fire()))}async loadConfiguration(){try{const a=await this.h.readFile(this.f);return this.a.parse(a.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new p}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=t;class c{constructor(a,o,d,s,u,n,h,g,P,M,j,Z,G){this.a=a,this.b=o,this.value=d,this.overrideIdentifiers=s,this.c=u,this.d=n,this.f=h,this.g=g,this.h=P,this.j=M,this.k=j,this.l=Z,this.m=G}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class l{constructor(a,o,d,s,u=new p,n=new p,h=new k.ResourceMap,g=new p,P=new k.ResourceMap,M=!0){this.c=a,this.d=o,this.f=d,this.g=s,this.h=u,this.j=n,this.l=h,this.m=g,this.n=P,this.p=M,this.a=null,this.b=new k.ResourceMap,this.q=null}getValue(a,o,d){return this.s(a,o,d).getValue(a)}updateValue(a,o,d={}){let s;d.resource?(s=this.n.get(d.resource),s||(s=new p,this.n.set(d.resource,s))):s=this.m,o===void 0?s.removeValue(a):s.setValue(a,o),d.resource||(this.a=null)}inspect(a,o,d){const s=this.s(a,o,d),u=this.w(o.resource,d),n=o.resource?this.n.get(o.resource)||this.m:this.m,h=new Set;for(const g of s.overrides)for(const P of g.identifiers)s.getOverrideValue(a,P)!==void 0&&h.add(P);return new c(a,o,s.getValue(a),h.size?[...h]:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),d?this.j.freeze():void 0,u?u.freeze():void 0,n.inspect(a,o.overrideIdentifier))}keys(a){const o=this.w(void 0,a);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:o?o.freeze().keys:[]}}updateDefaultConfiguration(a){this.c=a,this.a=null,this.b.clear()}updatePolicyConfiguration(a){this.d=a}updateApplicationConfiguration(a){this.f=a,this.a=null,this.b.clear()}updateLocalUserConfiguration(a){this.g=a,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(a){this.h=a,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(a){this.j=a,this.a=null,this.b.clear()}updateFolderConfiguration(a,o){this.l.set(a,o),this.b.delete(a)}deleteFolderConfiguration(a){this.r.delete(a),this.b.delete(a)}compareAndUpdateDefaultConfiguration(a,o){const d=[];if(!o){const{added:s,updated:u,removed:n}=E(this.c,a);o=[...s,...u,...n]}for(const s of o)for(const u of(0,D.overrideIdentifiersFromKey)(s)){const n=this.c.getKeysForOverrideIdentifier(u),h=a.getKeysForOverrideIdentifier(u),g=[...h.filter(P=>n.indexOf(P)===-1),...n.filter(P=>h.indexOf(P)===-1),...n.filter(P=>!O.equals(this.c.override(u).getValue(P),a.override(u).getValue(P)))];d.push([u,g])}return this.updateDefaultConfiguration(a),{keys:o,overrides:d}}compareAndUpdatePolicyConfiguration(a){const{added:o,updated:d,removed:s}=E(this.d,a),u=[...o,...d,...s];return u.length&&this.updatePolicyConfiguration(a),{keys:u,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:o,updated:d,removed:s,overrides:u}=E(this.applicationConfiguration,a),n=[...o,...d,...s];return n.length&&this.updateApplicationConfiguration(a),{keys:n,overrides:u}}compareAndUpdateLocalUserConfiguration(a){const{added:o,updated:d,removed:s,overrides:u}=E(this.localUserConfiguration,a),n=[...o,...d,...s];return n.length&&this.updateLocalUserConfiguration(a),{keys:n,overrides:u}}compareAndUpdateRemoteUserConfiguration(a){const{added:o,updated:d,removed:s,overrides:u}=E(this.remoteUserConfiguration,a),n=[...o,...d,...s];return n.length&&this.updateRemoteUserConfiguration(a),{keys:n,overrides:u}}compareAndUpdateWorkspaceConfiguration(a){const{added:o,updated:d,removed:s,overrides:u}=E(this.workspaceConfiguration,a),n=[...o,...d,...s];return n.length&&this.updateWorkspaceConfiguration(a),{keys:n,overrides:u}}compareAndUpdateFolderConfiguration(a,o){const d=this.r.get(a),{added:s,updated:u,removed:n,overrides:h}=E(d,o),g=[...s,...u,...n];return(g.length||!d)&&this.updateFolderConfiguration(a,o),{keys:g,overrides:h}}compareAndDeleteFolderConfiguration(a){const o=this.r.get(a);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:d,updated:s,removed:u,overrides:n}=E(o,void 0);return{keys:[...d,...s,...u],overrides:n}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(a,o,d){let s=this.t(o,d);return o.overrideIdentifier&&(s=s.override(o.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(a)!==void 0&&(s=s.merge(this.d)),s}t({resource:a},o){let d=this.u();if(o&&a){const s=o.getFolder(a);s&&(d=this.v(s.uri)||d);const u=this.n.get(a);u&&(d=d.merge(u))}return d}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(a){let o=this.b.get(a);if(!o){const d=this.u(),s=this.l.get(a);s?(o=d.merge(s),this.p&&(o=o.freeze()),this.b.set(a,o)):o=d}return o}w(a,o){if(o&&a){const d=o.getFolder(a);if(d)return this.l.get(d.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((a,o)=>{const{contents:d,overrides:s,keys:u}=this.l.get(o);return a.push([o,{contents:d,overrides:s,keys:u}]),a},[])}}allKeys(){const a=new Set;return this.c.freeze().keys.forEach(o=>a.add(o)),this.userConfiguration.freeze().keys.forEach(o=>a.add(o)),this.j.freeze().keys.forEach(o=>a.add(o)),this.l.forEach(o=>o.freeze().keys.forEach(d=>a.add(d))),[...a.values()]}x(){const a=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(o=>a.add(o)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>a.add(o)),this.j.freeze().getAllOverrideIdentifiers().forEach(o=>a.add(o)),this.l.forEach(o=>o.freeze().getAllOverrideIdentifiers().forEach(d=>a.add(d))),[...a.values()]}y(a){const o=new Set;return this.c.getKeysForOverrideIdentifier(a).forEach(d=>o.add(d)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(d=>o.add(d)),this.j.getKeysForOverrideIdentifier(a).forEach(d=>o.add(d)),this.l.forEach(d=>d.getKeysForOverrideIdentifier(a).forEach(s=>o.add(s))),[...o.values()]}static parse(a){const o=this.z(a.defaults),d=this.z(a.policy),s=this.z(a.application),u=this.z(a.user),n=this.z(a.workspace),h=a.folders.reduce((g,P)=>(g.set(C.URI.revive(P[0]),this.z(P[1])),g),new k.ResourceMap);return new l(o,d,s,u,new p,n,h,new p,new k.ResourceMap,!1)}static z(a){return new p(a.contents,a.keys,a.overrides).freeze()}}e.Configuration=l;function v(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const a=new Set,o=new Map;for(const s of r)s.keys.forEach(u=>a.add(u)),s.overrides.forEach(([u,n])=>{const h=(0,k.getOrSet)(o,u,new Set);n.forEach(g=>h.add(g))});const d=[];return o.forEach((s,u)=>d.push([u,[...s.values()]])),{keys:[...a.values()],overrides:d}}e.mergeChanges=v;class b{constructor(a,o,d,s){this.change=a,this.b=o,this.c=d,this.d=s,this.f=void 0;const u=new Set;a.keys.forEach(h=>u.add(h)),a.overrides.forEach(([,h])=>h.forEach(g=>u.add(g))),this.affectedKeys=[...u.values()];const n=new p;this.affectedKeys.forEach(h=>n.setValue(h,{})),this.a=n.contents}get previousConfiguration(){return!this.f&&this.b&&(this.f=l.parse(this.b.data)),this.f}affectsConfiguration(a,o){if(this.g(this.a,a)){if(o){const d=this.previousConfiguration?this.previousConfiguration.getValue(a,o,this.b?.workspace):void 0,s=this.c.getValue(a,o,this.d);return!O.equals(d,s)}return!0}return!1}g(a,o){let d=(0,N.toValuesTree)({[o]:!0},()=>{}),s;for(;typeof d=="object"&&(s=Object.keys(d)[0]);){if(a=a[s],!a)return!1;d=d[s]}return!0}}e.ConfigurationChangeEvent=b;function E(r,a){const{added:o,removed:d,updated:s}=w(a?.rawConfiguration,r?.rawConfiguration),u=[],n=r?.getAllOverrideIdentifiers()||[],h=a?.getAllOverrideIdentifiers()||[];if(a){const g=h.filter(P=>!n.includes(P));for(const P of g)u.push([P,a.getKeysForOverrideIdentifier(P)])}if(r){const g=n.filter(P=>!h.includes(P));for(const P of g)u.push([P,r.getKeysForOverrideIdentifier(P)])}if(a&&r){for(const g of n)if(h.includes(g)){const P=w({contents:r.getOverrideValue(void 0,g)||{},keys:r.getKeysForOverrideIdentifier(g)},{contents:a.getOverrideValue(void 0,g)||{},keys:a.getKeysForOverrideIdentifier(g)});u.push([g,[...P.added,...P.removed,...P.updated]])}}return{added:o,removed:d,updated:s,overrides:u}}function w(r,a){const o=r?a?r.keys.filter(u=>a.keys.indexOf(u)===-1):[...r.keys]:[],d=a?r?a.keys.filter(u=>r.keys.indexOf(u)===-1):[...a.keys]:[],s=[];if(r&&a){for(const u of a.keys)if(r.keys.indexOf(u)!==-1){const n=(0,N.getConfigurationValue)(a.contents,u),h=(0,N.getConfigurationValue)(r.contents,u);O.equals(n,h)||s.push(u)}}return{added:o,removed:d,updated:s}}}),define(ke[92],Ce([1,0,11,3]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,T.createDecorator)("remoteAuthorityResolverService");var y;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(y=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends i.ErrorNoTelemetry{static isNotAvailable(O){return O instanceof L&&O._code===y.NotAvailable}static isTemporarilyNotAvailable(O){return O instanceof L&&O._code===y.TemporarilyNotAvailable}static isNoResolverFound(O){return O instanceof L&&O._code===y.NoResolverFound}static isHandled(O){return O instanceof L&&O.isHandled}constructor(O,S=y.Unknown,C){super(O),this._message=O,this._code=S,this._detail=C,this.isHandled=S===y.NotAvailable&&C===!0,Object.setPrototypeOf(this,L.prototype)}}e.RemoteAuthorityResolverError=L}),define(ke[48],Ce([1,0,13]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function T(C){return C.scheme===i.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=T;function y(C){if(!C)return;const N=C.indexOf("+");return N<0?C:C.substr(0,N)}e.getRemoteName=y;function L(C){return`/${C.quality??"oss"}-${C.commit??"dev"}`}e.getRemoteServerRootPath=L;function k(C){const{host:N,port:D}=S(C);if(typeof D>"u")throw new Error("Remote authority doesn't contain a port!");return{host:N,port:D}}e.parseAuthorityWithPort=k;function O(C,N){let{host:D,port:m}=S(C);return typeof m>"u"&&(m=N),{host:D,port:m}}e.parseAuthorityWithOptionalPort=O;function S(C){const N=C.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(N)return{host:N[1],port:parseInt(N[2],10)};const D=C.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const m=C.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:C,port:void 0}}}),define(ke[25],Ce([1,0,10,3,48]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=L;function k(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var O;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(O=e.ExtensionType||(e.ExtensionType={}));var S;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(S=e.TargetPlatform||(e.TargetPlatform={}));class C{constructor(t){this.value=t,this.c=t.toLowerCase()}static equals(t,c){if(typeof t>"u"||t===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof t=="string"||typeof c=="string"){const l=typeof t=="string"?t:t.value,v=typeof c=="string"?c:c.value;return i.equalsIgnoreCase(l,v)}return t.c===c.c}static toKey(t){return typeof t=="string"?t.toLowerCase():t.c}}e.ExtensionIdentifier=C;function N(f){return D(f)}e.isApplicationScopedExtension=N;function D(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function m(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function p(f,t){if(t){const c=`onResolveRemoteAuthority:${(0,y.getRemoteName)(t)}`;return f.activationEvents?.indexOf(c)!==-1}return!1}e.isResolverExtension=p,e.IBuiltinExtensionsScannerService=(0,T.createDecorator)("IBuiltinExtensionsScannerService")}),define(ke[159],Ce([1,0,21,49,2,34]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(C){if(i.platform===2&&/^penguin(\.|$)/i.test(C))return"chromebook"}async function O(C,N,D,m,p,f,t,c,l,v){const b=Object.create(null);b["common.machineId"]=t,b.sessionID=(0,L.generateUuid)()+Date.now(),b.commitHash=p,b.version=f,b["common.platformVersion"]=(N||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),b["common.platform"]=(0,i.PlatformToString)(i.platform),b["common.nodePlatform"]=T.platform,b["common.nodeArch"]=m,b["common.product"]=v||"desktop",c&&(b["common.msftInternal"]=c);let E=0;const w=Date.now();Object.defineProperties(b,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-w,enumerable:!0},"common.sequence":{get:()=>E++,enumerable:!0}}),i.isLinuxSnap&&(b["common.snap"]="true");const r=k(D);r&&(b["common.platformDetail"]=r);try{const a=await C.readFile(y.URI.file(l));b["common.source"]=a.value.toString().slice(0,30)}catch{}return b}e.resolveCommonProperties=O;function S(C){const N=T.env.USERDNSDOMAIN;if(!N)return!1;const D=N.toLowerCase();return C.some(m=>D===m)}e.verifyMicrosoftInternalDomain=S}),define(ke[160],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,i.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,i.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var T;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(T=e.TelemetryLevel||(e.TelemetryLevel={}));var y;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(y=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ke[50],Ce([1,0,23,9,40,48,159,160]),function(ee,e,i,T,y,L,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class S{constructor(u){this.value=u}}e.TrustedTelemetryValue=S;class C{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(u,n){return Promise.resolve(void 0)}publicLog2(u,n){return this.publicLog(u,n)}publicLogError(u,n){return Promise.resolve(void 0)}publicLogError2(u,n){return this.publicLogError(u,n)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=C,e.NullTelemetryService=new C;class N{async publicLog(u,n,h){}async publicLogError(u,n,h){}}e.NullEndpointTelemetryService=N,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function D(s,u){return u.onDidChangeConfiguration(n=>{n.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,y.ConfigurationTargetToString)(n.source),configurationKeys:b(n.sourceConfig)})})}e.configurationTelemetry=D;function m(s,u){return!u.isBuilt&&!u.disableTelemetry?!0:!(u.disableTelemetry||!s.enableTelemetry||u.extensionTestsLocationURI)}e.supportsTelemetry=m;function p(s,u){return!(u.isBuilt||u.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.isLoggingOnly=p;function f(s){const u=s.getValue(O.TELEMETRY_SETTING_ID),n=s.getValue("telemetry.enableCrashReporter");if(s.getValue(O.TELEMETRY_OLD_SETTING_ID)===!1||n===!1)return 0;switch(u??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=f;function t(s){const u={},n={},h={};v(s,h);for(let g in h){g=g.length>150?g.substr(g.length-149):g;const P=h[g];typeof P=="number"?n[g]=P:typeof P=="boolean"?n[g]=P?1:0:typeof P=="string"?(P.length>8192&&console.warn(`Telemetry property: ${g} has been trimmed to 8192, the original length is ${P.length}`),u[g]=P.substring(0,8191)):typeof P<"u"&&P!==null&&(u[g]=P)}return{properties:u,measurements:n}}e.validateTelemetryData=t;const c=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function l(s){if(!s)return"none";const u=(0,L.getRemoteName)(s);return c.has(u)?u:"other"}e.cleanRemoteAuthority=l;function v(s,u,n=0,h){if(!!s)for(const g of Object.getOwnPropertyNames(s)){const P=s[g],M=h?h+g:g;Array.isArray(P)?u[M]=(0,i.safeStringify)(P):P instanceof Date?u[M]=P.toISOString():(0,T.isObject)(P)?n<2?v(P,u,n+1,M+"."):u[M]=(0,i.safeStringify)(P):u[M]=P}}function b(s){if(!s)return[];const u=[];return E(u,"",s),u}function E(s,u,n){n&&typeof n=="object"&&!Array.isArray(n)?Object.keys(n).forEach(h=>E(s,u?`${u}.${h}`:h,n[h])):s.push(u)}function w(s,u){const n=s.msftInternalDomains||[],h=u.getValue("telemetry.internalTesting");return(0,k.verifyMicrosoftInternalDomain)(n)||h}e.isInternalTelemetry=w;function r(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.getPiiPathsFromEnvironment=r;function a(s,u){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let n=s;const h=[];for(const j of u)for(;;){const Z=j.exec(s);if(!Z)break;h.push([Z.index,j.lastIndex])}const g=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,P=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let M=0;for(n="";;){const j=P.exec(s);if(!j)break;const Z=h.some(([G,A])=>j.index<A&&G<P.lastIndex);!g.test(j[0])&&!Z&&(n+=s.substring(M,j.index)+"<REDACTED: user-file-path>",M=P.lastIndex)}return M<s.length&&(n+=s.substr(M)),n}function o(s){if(!s)return s;const u=s.toLowerCase(),n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of n)if(h.regex.test(u))return`<REDACTED: ${h.label}>`;return s}function d(s,u){return(0,i.cloneAndChange)(s,n=>{if(n instanceof S)return n.value;if(typeof n=="string"){let h=n.replaceAll("%20"," ");h=a(h,u);for(const g of u)h=h.replace(g,"");return h=o(h),h}})}e.cleanData=d}),define(ke[161],Ce([1,0,10,87,25,21,2,11,49,50]),function(ee,e,i,T,y,L,k,O,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function N(o,d){return o.uuid&&d.uuid?o.uuid===d.uuid:o.id===d.id?!0:(0,i.compareIgnoreCase)(o.id,d.id)===0}e.areSameExtensions=N;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(d){const s=d.manifest?d.manifest.version:d.version,u=d.manifest?d.targetPlatform:d.properties.targetPlatform;return new m(d.identifier,s,u)}static parse(d){const s=D.exec(d);return s&&s[1]&&s[2]?new m({id:s[1]},s[2],s[4]||void 0):null}constructor(d,s,u="undefined"){this.version=s,this.targetPlatform=u,this.id=d.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(d){return d instanceof m?N(this,d)&&this.version===d.version&&this.targetPlatform===d.targetPlatform:!1}}e.ExtensionKey=m;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(o){const d=p.exec(o);return d&&d[1]?[c(d[1]),d[2]]:[c(o),void 0]}e.getIdAndVersion=f;function t(o,d){return`${o}.${d}`}e.getExtensionId=t;function c(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=c;function l(o,d){return c(t(o,d))}e.getGalleryExtensionId=l;function v(o,d){const s=[],u=n=>{for(const h of s)if(h.some(g=>N(d(g),d(n))))return h;return null};for(const n of o){const h=u(n);h?h.push(n):s.push([n])}return s}e.groupByExtension=v;function b(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function E(o){return{id:new C.TrustedTelemetryValue(o.identifier.id),name:new C.TrustedTelemetryValue(o.name),galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new y.ExtensionIdentifier("pprice.better-merge");function w(o,d){const s=[],u=d.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const n=u.shift();if(n&&s.every(h=>!N(h.identifier,{id:n}))){const h=o.filter(g=>N(g.identifier,{id:n}));h.length===1&&(s.push(h[0]),u.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.getExtensionDependencies=w;async function r(o,d){if(!L.isLinux)return!1;let s;try{s=(await o.readFile(k.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await o.readFile(k.URI.file("/usr/lib/os-release"))).value.toString()}catch(n){d.debug("Error while getting the os-release file.",(0,O.getErrorMessage)(n))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=r;async function a(o,d){const s=await r(o,d),u=(0,T.getTargetPlatform)(s?"alpine":L.platform,S.arch);return d.debug("ComputeTargetPlatform:",u),u}e.computeTargetPlatform=a}),define(ke[162],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class i{constructor(y){this.b=y,this.a=new Map}dispose(){for(const y of this.a.values())y.dispose()}startBuffering(y,L,k=5){const O=L(S=>{const C=typeof S=="string"?S:S.data;let N=this.a.get(y);if(N){N.data.push(C);return}const D=setTimeout(()=>this.flushBuffer(y),k);N={data:[C],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(y),O.dispose()}},this.a.set(y,N)});return O}stopBuffering(y){this.a.get(y)?.dispose()}flushBuffer(y){const L=this.a.get(y);L&&(this.a.delete(y),this.b(y,L.data.join("")))}}e.TerminalDataBufferer=i}),define(ke[163],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var i;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST_DARK="hcDark",L.HIGH_CONTRAST_LIGHT="hcLight"})(i=e.ColorScheme||(e.ColorScheme={}));function T(L){return L===i.HIGH_CONTRAST_DARK||L===i.HIGH_CONTRAST_LIGHT}e.isHighContrast=T;function y(L){return L===i.DARK||L===i.HIGH_CONTRAST_DARK}e.isDark=y}),define(ke[65],Ce([1,0,121,5,7,3,30,163]),function(ee,e,i,T,y,L,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,L.createDecorator)("themeService");var S;(function(c){function l(v){return v&&typeof v=="object"&&typeof v.id=="string"}c.isThemeColor=l})(S=e.ThemeColor||(e.ThemeColor={}));function C(c){return{id:c}}e.themeColorFromId=C;var N;(function(c){function l(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||S.isThemeColor(d.color))}c.isThemeIcon=l;const v=new RegExp(`^\\$\\((${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?)\\)$`);function b(d){const s=v.exec(d);if(!s)return;const[,u]=s;return{id:u}}c.fromString=b;function E(d){return{id:d}}c.fromId=E;function w(d,s){let u=d.id;const n=u.lastIndexOf("~");return n!==-1&&(u=u.substring(0,n)),s&&(u=`${u}~${s}`),{id:u}}c.modify=w;function r(d){const s=d.id.lastIndexOf("~");if(s!==-1)return d.id.substring(s+1)}c.getModifier=r;function a(d,s){return d.id===s.id&&d.color?.id===s.color?.id}c.isEqual=a;function o(d,s){return{id:d.id,color:s?C(s):void 0}}c.asThemeIcon=o,c.asClassNameArray=i.CSSIcon.asClassNameArray,c.asClassName=i.CSSIcon.asClassName,c.asCSSSelector=i.CSSIcon.asCSSSelector})(N=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=i.Codicon.file,e.FolderThemeIcon=i.Codicon.folder;function D(c){switch(c){case O.ColorScheme.DARK:return"vs-dark";case O.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case O.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=D,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.a=[],this.a=[],this.b=new T.Emitter}onColorThemeChange(l){return this.a.push(l),this.b.fire(l),(0,y.toDisposable)(()=>{const v=this.a.indexOf(l);this.a.splice(v,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const p=new m;k.Registry.add(e.Extensions.ThemingContribution,p);function f(c){return p.onColorThemeChange(c)}e.registerThemingParticipant=f;class t extends y.Disposable{constructor(l){super(),this.k=l,this.h=l.getColorTheme(),this.B(this.k.onDidColorThemeChange(v=>this.n(v)))}n(l){this.h=l,this.updateStyles()}updateStyles(){}w(l,v){let b=this.h.getColor(l);return b&&v&&(b=v(b,this.h)),b?b.toString():null}}e.Themable=t}),define(ke[164],Ce([1,0,5,40,3,12]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,y.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,y.createDecorator)("sharedTunnelsService");var k;(function(t){t.Http="http",t.Https="https"})(k=e.TunnelProtocol||(e.TunnelProtocol={}));var O;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(O=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function C(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!c)return{address:c[1],port:+c[2]}}e.extractLocalHostUriMetaDataForPortMapping=C,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function N(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=N,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function D(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=D;function m(t,c,l,v){if(l===1)return!1;if(l===2&&D(c)){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(v);if(b?.length===4&&parseInt(b[1])>=18)return!1}return t<1024}e.isPortPrivileged=m;class p{constructor(c,l,v){this.remoteAddress=c,this.localAddress=l,this.b=v,this.a=new i.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=p;let f=class{constructor(c,l){this.i=c,this.j=l,this.a=new i.Emitter,this.onTunnelOpened=this.a.event,this.b=new i.Emitter,this.onTunnelClosed=this.b.event,this.c=new i.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const c=this.j.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(c){return this.e=c,c?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(c){this.f=c.elevation,this.g=c.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const c=[],l=Array.from(this.d.values());for(const v of l){const b=Array.from(v.values());for(const E of b){const w=await E.value;w&&c.push(w)}}return c}async dispose(){for(const c of this.d.values()){for(const{value:l}of c.values())await l.then(v=>v?.dispose());c.clear()}this.d.clear()}setEnvironmentTunnel(c,l,v,b,E){this.o(c,l,Promise.resolve({tunnelRemoteHost:c,tunnelRemotePort:l,localAddress:v,privacy:b,protocol:E,dispose:()=>Promise.resolve()}))}async getExistingTunnel(c,l){(D(c)||N(c))&&(c=e.LOCALHOST_ADDRESSES[0]);const v=this.q(c,l);if(v)return++v.refcount,v.value}openTunnel(c,l,v,b,E=!1,w,r){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${v} on local port ${b}.`),!c)return;if(l||(l="localhost"),this.e&&this.h.has(v)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const a=this.r(c,l,v,b,E,w,r);return a?a.then(o=>{if(!o){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(l,v);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const d=this.m(o);return(o.tunnelRemoteHost!==l||o.tunnelRemotePort!==v)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(d),d}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}m(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const l=this.d.get(c.tunnelRemoteHost);if(l){const v=l.get(c.tunnelRemotePort);v&&(v.refcount--,await this.n(c.tunnelRemoteHost,c.tunnelRemotePort,v))}}}}async n(c,l,v){if(v.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${l}.`);const b=v.value.then(async E=>{E&&(await E.dispose(!0),this.b.fire({host:E.tunnelRemoteHost,port:E.tunnelRemotePort}))});return this.d.has(c)&&this.d.get(c).delete(l),b}}async closeTunnel(c,l){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${l} `);const v=this.d.get(c);if(v&&v.has(l)){const b=v.get(l);b.refcount=0,await this.n(c,l,b)}}o(c,l,v){this.d.has(c)||this.d.set(c,new Map),this.d.get(c).set(l,{refcount:1,value:v})}async p(c,l){const v=this.d.get(c);v&&(await v.get(l)||v.delete(l),v.size===0&&this.d.delete(c))}q(c,l){const v=[c];N(c)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):D(c)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const b=v.map(E=>this.d.get(E));for(const E of b){const w=E?.get(l);if(w)return w}}canTunnel(c){return!!C(c)}s(c,l,v,b,E,w,r){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${v} on local port ${b}.`);const a=v;this.h.add(a);const o=b===void 0?v:b,d={elevationRequired:E?this.isPortPrivileged(o):!1},s={remoteAddress:{host:l,port:v},localAddressPort:b,privacy:w,public:w?w!==O.Private:void 0,protocol:r},u=c.forwardPort(s,d);return u?(this.o(l,v,u),u.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(a)})):this.h.delete(a),u}};f=qe([Ve(0,L.ILogService),Ve(1,T.IConfigurationService)],f),e.AbstractTunnelService=f}),define(ke[165],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,i.createDecorator)("editSessionIdentityService");var T;(function(y){y[y.Complete=100]="Complete",y[y.Partial=50]="Partial",y[y.None=0]="None"})(T=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(ke[166],Ce([1,0,13]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function T(S){return S.scheme!==i.Schemas.file&&S.scheme!==i.Schemas.vscodeRemote}e.isVirtualResource=T;function y(S){if(S.folders.length)return S.folders.every(C=>T(C.uri))?S.folders[0].uri:void 0;if(S.configuration&&T(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=y;function L(S){return y(S)?.scheme}e.getVirtualWorkspaceScheme=L;function k(S){return y(S)?.authority}e.getVirtualWorkspaceAuthority=k;function O(S){return y(S)!==void 0}e.isVirtualWorkspace=O}),define(ke[51],Ce([1,0,133,19,46,22,2,3,13]),function(ee,e,i,T,y,L,k,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,O.createDecorator)("contextService");function C(o){const d=o;return typeof d?.id=="string"&&k.URI.isUri(d.uri)}e.isSingleFolderWorkspaceIdentifier=C;function N(o){return typeof o?.id=="string"&&!C(o)&&!m(o)}e.isEmptyWorkspaceIdentifier=N,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function D(o,d){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,T.basename)(o)}:d?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const s=o;return s.configuration?{id:s.id,configPath:s.configuration}:s.folders.length===1?{id:s.id,uri:s.folders[0].uri}:{id:s.id}}e.toWorkspaceIdentifier=D;function m(o){const d=o;return typeof d?.id=="string"&&k.URI.isUri(d.configPath)}e.isWorkspaceIdentifier=m;function p(o){const d=o;if(d?.uri)return{id:d.id,uri:k.URI.revive(d.uri)};const s=o;if(s?.configPath)return{id:s.id,configPath:k.URI.revive(s.configPath)};if(o?.id)return{id:o.id}}e.reviveIdentifier=p;var f;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(f=e.WorkbenchState||(e.WorkbenchState={}));function t(o){const d=o;return!!(d&&typeof d=="object"&&typeof d.id=="string"&&Array.isArray(d.folders))}e.isWorkspace=t;function c(o){const d=o;return!!(d&&typeof d=="object"&&k.URI.isUri(d.uri)&&typeof d.name=="string"&&typeof d.toResource=="function")}e.isWorkspaceFolder=c;class l{constructor(d,s,u,n,h){this.h=d,this.j=u,this.k=n,this.l=h,this.c=y.TernarySearchTree.forUris(this.l,()=>!0),this.folders=s}update(d){this.h=d.id,this.k=d.configuration,this.j=d.transient,this.l=d.l,this.folders=d.folders}get folders(){return this.g}set folders(d){this.g=d,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(d){this.k=d}getFolder(d){return d&&this.c.findSubstr(d)||null}n(){this.c=y.TernarySearchTree.forUris(this.l,()=>!0);for(const d of this.folders)this.c.set(d.uri,d)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=l;class v{constructor(d,s){this.raw=s,this.uri=d.uri,this.index=d.index,this.name=d.name}toResource(d){return(0,L.joinPath)(this.uri,d)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=v;function b(o){return new v({uri:o,index:0,name:(0,L.basenameOrAuthority)(o)},{uri:o.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,i.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(o,d){return L.extUriBiasedIgnorePathCase.isEqualOrParent(o,d.untitledWorkspacesHome)}e.isUntitledWorkspace=E;function w(o){let d;return k.URI.isUri(o)?d=o:d=o.configuration,d?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=w;function r(o,d){return!E(o,d)&&!w(o)}e.isSavedWorkspace=r;function a(o){return(typeof o=="string"?(0,T.extname)(o):(0,L.extname)(o))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=a}),define(ke[52],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class i{constructor(y){this.d=y,this.b=new Map,this.c=1}add(y){const L=this.c++;return this.b.set(L,y),this.e(),L}get(y,L){return this.b.has(y)?this.b.get(y)[L]:void 0}delete(y){this.b.delete(y),this.e()}e(){!i.a||console.log(`${this.d} cache size - ${this.b.size}`)}}e.Cache=i,i.a=!1}),define(ke[37],Ce([1,0,13,22,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class L{constructor(){this.a=new Set(Object.keys(i.Schemas)),this.b=new Map,this.extUri=new T.ExtUri(O=>{const S=this.b.get(O.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(O,S){S===null?this.b.delete(O.scheme):this.b.set(O.scheme,S)}isFreeScheme(O){return!this.b.has(O)&&!this.a.has(O)}getCapabilities(O){return this.b.get(O)}}e.ExtHostFileSystemInfo=L,e.IExtHostFileSystemInfo=(0,y.createDecorator)("IExtHostFileSystemInfo")}),define(ke[27],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,i.createDecorator)("IExtHostInitDataService")}),define(ke[167],Ce([1,0,14]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class T{constructor(k,O,S){this.h=new Map,this.a=k,this.b=O,this.c=S,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(C=>(this.f=C,this)),this.g=this.c.onDidChangeStorage(C=>{C.shared===this.b&&C.key===this.a&&(this.f=C.value)}),this.i=new i.RunOnceScheduler(()=>{const C=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const N of C.values())N.complete()}catch(N){for(const D of C.values())D.error(N)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,k])=>k!==void 0).map(([k])=>k)}get whenReady(){return this.d}get(k,O){let S=this.f[k];return typeof S>"u"&&(S=O),S}update(k,O){this.f[k]=O;const S=this.h.get(k);if(S!==void 0)return S.p;const C=new i.DeferredPromise;return this.h.set(k,C),this.i.isScheduled()||this.i.schedule(),C.p}dispose(){this.g.dispose()}}e.ExtensionMemento=T;class y extends T{setKeysForSync(k){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},k)}constructor(k,O){super(k.identifier.value,!0,O),this.j=k}}e.ExtensionGlobalMemento=y}),define(ke[168],Ce([1,0,5,2]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class y{constructor(k){this.c=k,this.a=new i.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new i.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(k,O,S,C){const D=this.c.getNotebookDocument(T.URI.revive(k)).acceptModelChanged(O.value,S,C);this.b.fire(D)}$acceptDirtyStateChanged(k,O){this.c.getNotebookDocument(T.URI.revive(k)).acceptDirty(O)}$acceptModelSaved(k){const O=this.c.getNotebookDocument(T.URI.revive(k));this.a.fire(O.apiNotebook)}}e.ExtHostNotebookDocuments=y}),define(ke[15],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,i.createDecorator)("IExtHostRpcService");class T{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.ExtHostRpcService=T});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(ke[169],Ce([1,0,25,5]),function(ee,e,i,T){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class L{constructor(O,S){y.set(this,void 0),this.b=new T.Emitter,this.onDidChange=this.b.event,this.a=i.ExtensionIdentifier.toKey(O.identifier),Je(this,y,S,"f"),Oe(this,y,"f").onDidChangePassword(C=>{C.extensionId===this.a&&this.b.fire({key:C.key})})}get(O){return Oe(this,y,"f").get(this.a,O)}store(O,S){return Oe(this,y,"f").store(this.a,O,S)}delete(O){return Oe(this,y,"f").delete(this.a,O)}}e.ExtensionSecrets=L,y=new WeakMap}),define(ke[66],Ce([1,0,3,164,5,15]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var k;(function(S){function C(D){return{remoteAddress:D.remoteAddress,localAddress:D.localAddress,public:!!D.public,privacy:D.privacy??(D.public?T.TunnelPrivacyId.Public:T.TunnelPrivacyId.Private),protocol:D.protocol}}S.fromApiTunnel=C;function N(D){return{remoteAddress:{host:D.tunnelRemoteHost,port:D.tunnelRemotePort},localAddress:D.localAddress,public:D.privacy!==T.TunnelPrivacyId.ConstantPrivate&&D.privacy!==T.TunnelPrivacyId.ConstantPrivate,privacy:D.privacy,protocol:D.protocol}}S.fromServiceTunnel=N})(k=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,i.createDecorator)("IExtHostTunnelService");let O=class{constructor(C){this.onDidChangeTunnels=new y.Emitter().event}async $applyCandidateFilter(C){return C}async openTunnel(C,N){}async getTunnels(){return[]}async setTunnelFactory(C){return{dispose:()=>{}}}registerPortsAttributesProvider(C,N){return{dispose:()=>{}}}async $providePortAttributes(C,N,D,m,p){return[]}async $forwardPort(C,N){}async $closeTunnel(C){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};O=qe([Ve(0,L.IExtHostRpcService)],O),e.ExtHostTunnelService=O}),define(ke[53],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,i.createDecorator)("IURITransformerService");class T{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=k=>k,this.transformOutgoing=k=>k,this.transformOutgoingURI=k=>k,this.transformOutgoingScheme=k=>k)}}e.URITransformerService=T}),define(ke[170],Ce([1,0,24]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class T{constructor(){this.buffers=[]}add(S){let C=this.buffers.indexOf(S);return C<0&&(C=this.buffers.length,this.buffers.push(S)),C}}function y(O,S){if(S.serializeBuffersForPostMessage){const C=new T,N=(p,f)=>{if(f instanceof ArrayBuffer){const t=C.add(f);return{$$vscode_array_buffer_reference$$:!0,index:t}}else if(ArrayBuffer.isView(f)){const t=L(f);if(t){const c=C.add(f.buffer);return{$$vscode_array_buffer_reference$$:!0,index:c,view:{type:t,byteLength:f.byteLength,byteOffset:f.byteOffset}}}}return f},D=JSON.stringify(O,N),m=C.buffers.map(p=>{const f=new Uint8Array(p);return i.VSBuffer.wrap(f)});return{message:D,buffers:m}}else return{message:JSON.stringify(O),buffers:[]}}e.serializeWebviewMessage=y;function L(O){switch(O.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function k(O,S){const C=S.map(m=>{const p=new ArrayBuffer(m.byteLength);return new Uint8Array(p).set(m.buffer),p}),N=S.length?(m,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const f=p,{index:t}=f,c=C[t];if(f.view)switch(f.view.type){case 1:return new Int8Array(c,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(c,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(c,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(c,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(c,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(c,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(c,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(c,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(c,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(c,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(c,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return c}return p}:void 0;return{message:JSON.parse(O,N),arrayBuffers:C}}e.deserializeWebviewMessage=k}),define(ke[93],Ce([1,0,141,9,2,7,3,30,36,13]),function(ee,e,i,T,y,L,k,O,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,i.localize)(0,null),providerDisplayName:(0,i.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var N;(function(K){K[K.PROGRAMMATIC=1]="PROGRAMMATIC",K[K.USER=2]="USER",K[K.EDIT=3]="EDIT",K[K.NAVIGATION=4]="NAVIGATION",K[K.JUMP=5]="JUMP"})(N=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var D;(function(K){K[K.IDENTICAL=1]="IDENTICAL",K[K.SIMILAR=2]="SIMILAR",K[K.DIFFERENT=3]="DIFFERENT"})(D=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function m(K){const ie=K;return!!ie&&typeof ie.getSelection=="function"&&!!ie.onDidChangeSelection}e.isEditorPaneWithSelection=m;function p(K,ie,me){for(const ue of me.visibleEditorPanes)if(ue.group.id===ie&&K.matches(ue.input))return ue.getViewState()}e.findViewStateForEditor=p;function f(K){if(s(K))return!1;const ie=K;return y.URI.isUri(ie?.resource)}e.isResourceEditorInput=f;function t(K){if(s(K))return!1;const ie=K;return ie?.original!==void 0&&ie.modified!==void 0}e.isResourceDiffEditorInput=t;function c(K){if(s(K)||t(K))return!1;const ie=K;return ie?.primary!==void 0&&ie.secondary!==void 0}e.isResourceSideBySideEditorInput=c;function l(K){if(s(K))return!1;const ie=K;return ie?ie.resource===void 0||ie.resource.scheme===C.Schemas.untitled||ie.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=l;const v=/Untitled-\d+/;function b(K){return K.scheme===C.Schemas.untitled&&K.path.length>1&&!v.test(K.path)}e.isUntitledWithAssociatedResource=b;function E(K){if(s(K))return!1;const ie=K;return y.URI.isUri(ie?.base?.resource)&&y.URI.isUri(ie?.input1?.resource)&&y.URI.isUri(ie?.input2?.resource)&&y.URI.isUri(ie?.result?.resource)}e.isResourceMergeEditorInput=E;var w;(function(K){K[K.SHORT=0]="SHORT",K[K.MEDIUM=1]="MEDIUM",K[K.LONG=2]="LONG"})(w=e.Verbosity||(e.Verbosity={}));var r;(function(K){K[K.EXPLICIT=1]="EXPLICIT",K[K.AUTO=2]="AUTO",K[K.FOCUS_CHANGE=3]="FOCUS_CHANGE",K[K.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(r=e.SaveReason||(e.SaveReason={}));class a{constructor(){this.a=new Map}registerSource(ie,me){let ue=this.a.get(ie);return ue||(ue={source:ie,label:me},this.a.set(ie,ue)),ue.source}getSourceLabel(ie){return this.a.get(ie)?.label??ie}}e.SaveSourceRegistry=new a;var o;(function(K){K[K.None=0]="None",K[K.Readonly=2]="Readonly",K[K.Untitled=4]="Untitled",K[K.Singleton=8]="Singleton",K[K.RequiresTrust=16]="RequiresTrust",K[K.CanSplitInGroup=32]="CanSplitInGroup",K[K.ForceDescription=64]="ForceDescription",K[K.CanDropIntoEditor=128]="CanDropIntoEditor",K[K.MultipleEditors=256]="MultipleEditors"})(o=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class d extends L.Disposable{}e.AbstractEditorInput=d;function s(K){return K instanceof d}e.isEditorInput=s;function u(K){const ie=K;return y.URI.isUri(ie?.preferredResource)}function n(K){const ie=K;return s(ie?.primary)&&s(ie?.secondary)}e.isSideBySideEditorInput=n;function h(K){const ie=K;return s(ie?.modified)&&s(ie?.original)}e.isDiffEditorInput=h;function g(K){return s(K?.editor)}e.isEditorInputWithOptions=g;function P(K){const ie=K;return g(K)&&ie?.group!==void 0}e.isEditorInputWithOptionsAndGroup=P;function M(K){const ie=K;return typeof ie?.groupId=="number"&&s(ie.editor)}e.isEditorIdentifier=M;var j;(function(K){K[K.UNKNOWN=0]="UNKNOWN",K[K.REPLACE=1]="REPLACE",K[K.MOVE=2]="MOVE",K[K.UNPIN=3]="UNPIN"})(j=e.EditorCloseContext||(e.EditorCloseContext={}));var Z;(function(K){K[K.GROUP_ACTIVE=0]="GROUP_ACTIVE",K[K.GROUP_INDEX=1]="GROUP_INDEX",K[K.GROUP_LOCKED=2]="GROUP_LOCKED",K[K.EDITOR_OPEN=3]="EDITOR_OPEN",K[K.EDITOR_CLOSE=4]="EDITOR_CLOSE",K[K.EDITOR_MOVE=5]="EDITOR_MOVE",K[K.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",K[K.EDITOR_LABEL=7]="EDITOR_LABEL",K[K.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",K[K.EDITOR_PIN=9]="EDITOR_PIN",K[K.EDITOR_STICKY=10]="EDITOR_STICKY",K[K.EDITOR_DIRTY=11]="EDITOR_DIRTY",K[K.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(Z=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var G;(function(K){K[K.PRIMARY=1]="PRIMARY",K[K.SECONDARY=2]="SECONDARY",K[K.BOTH=3]="BOTH",K[K.ANY=4]="ANY"})(G=e.SideBySideEditor||(e.SideBySideEditor={}));class A{getOriginalUri(ie,me){if(!ie)return;if(E(ie))return e.EditorResourceAccessor.getOriginalUri(ie.result,me);if(me?.supportSideBySide){const{primary:oe,secondary:De}=this.a(ie);if(oe&&De){if(me?.supportSideBySide===G.BOTH)return{primary:this.getOriginalUri(oe,{filterByScheme:me.filterByScheme}),secondary:this.getOriginalUri(De,{filterByScheme:me.filterByScheme})};if(me?.supportSideBySide===G.ANY)return this.getOriginalUri(oe,{filterByScheme:me.filterByScheme})??this.getOriginalUri(De,{filterByScheme:me.filterByScheme});ie=me.supportSideBySide===G.PRIMARY?oe:De}}if(t(ie)||c(ie)||E(ie))return;const ue=u(ie)?ie.preferredResource:ie.resource;return!ue||!me||!me.filterByScheme?ue:this.b(ue,me.filterByScheme)}a(ie){return n(ie)||c(ie)?{primary:ie.primary,secondary:ie.secondary}:h(ie)||t(ie)?{primary:ie.modified,secondary:ie.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ie,me){if(!ie)return;if(E(ie))return e.EditorResourceAccessor.getCanonicalUri(ie.result,me);if(me?.supportSideBySide){const{primary:oe,secondary:De}=this.a(ie);if(oe&&De){if(me?.supportSideBySide===G.BOTH)return{primary:this.getCanonicalUri(oe,{filterByScheme:me.filterByScheme}),secondary:this.getCanonicalUri(De,{filterByScheme:me.filterByScheme})};if(me?.supportSideBySide===G.ANY)return this.getCanonicalUri(oe,{filterByScheme:me.filterByScheme})??this.getCanonicalUri(De,{filterByScheme:me.filterByScheme});ie=me.supportSideBySide===G.PRIMARY?oe:De}}if(t(ie)||c(ie)||E(ie))return;const ue=ie.resource;return!ue||!me||!me.filterByScheme?ue:this.b(ue,me.filterByScheme)}b(ie,me){if(Array.isArray(me)){if(me.some(ue=>ie.scheme===ue))return ie}else if(me===ie.scheme)return ie}}e.EditorResourceAccessor=new A;var R;(function(K){K[K.LEFT=0]="LEFT",K[K.RIGHT=1]="RIGHT"})(R=e.CloseDirection||(e.CloseDirection={}));class F{constructor(){this.c=new Map,this.d=new Map}start(ie){const me=this.a=ie.get(k.IInstantiationService);for(const[ue,oe]of this.c)this.e(ue,oe,me);this.c.clear()}e(ie,me,ue){const oe=ue.createInstance(me);this.d.set(ie,oe)}registerFileEditorFactory(ie){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ie}getFileEditorFactory(){return(0,T.assertIsDefined)(this.b)}registerEditorSerializer(ie,me){if(this.c.has(ie)||this.d.has(ie))throw new Error(`A editor serializer with type ID '${ie}' was already registered.`);return this.a?this.e(ie,me,this.a):this.c.set(ie,me),(0,L.toDisposable)(()=>{this.c.delete(ie),this.d.delete(ie)})}getEditorSerializer(ie){return this.d.get(typeof ie=="string"?ie:ie.typeId)}}O.Registry.add(e.EditorExtensions.EditorFactory,new F);async function B(K,ie,me){return!K||!K.length?[]:await Promise.all(K.map(async ue=>{const oe=y.URI.revive(ue.fileUri);if(!oe){me.info("Cannot resolve the path because it is not valid.",ue);return}if(!await ie.canHandleResource(oe)){me.info("Cannot resolve the path because it cannot be handled",ue);return}let re=ue.exists,Q=ue.type;if(typeof re!="boolean"||typeof Q!="number")try{Q=(await ie.stat(oe)).isDirectory?S.FileType.Directory:S.FileType.Unknown,re=!0}catch(Ee){me.error(Ee),re=!1}if(!re&&ue.openOnlyIfExists){me.info("Cannot resolve the path because it does not exist",ue);return}if(Q===S.FileType.Directory){me.info("Cannot resolve the path because it is a directory",ue);return}const le={...ue.options,pinned:!0};return re?{resource:oe,options:le}:{resource:oe,options:le,forceUntitled:!0}}))}e.pathsToEditors=B;var z;(function(K){K[K.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",K[K.SEQUENTIAL=1]="SEQUENTIAL"})(z=e.EditorsOrder||(e.EditorsOrder={}));function V(K){const ie=K;if(!ie)return!1;const me=ie;if(me.modified)return V(me.modified);const ue=ie;return!!(ue.contributionsState&&ue.viewState&&Array.isArray(ue.cursorState))}e.isTextEditorViewState=V}),define(ke[171],Ce([1,0,5,14,142]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new i.Emitter,this.n=new i.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(O){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=O}onEvent(O){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=O}onRequest(O){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=O}sendResponse(O){O.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${O.command}`)):this.s("response",O)}sendRequest(O,S,C,N){const D={command:O};if(S&&Object.keys(S).length>0&&(D.arguments=S),this.s("request",D),typeof N=="number"){const m=setTimeout(()=>{clearTimeout(m);const p=this.f.get(D.seq);if(p){this.f.delete(D.seq);const f={type:"response",seq:0,request_seq:D.seq,success:!1,command:O,message:(0,y.localize)(0,null,N,O)};p(f)}},N)}return C&&this.f.set(D.seq,C),D.seq}acceptMessage(O){this.j?this.j(O):(this.k.push(O),this.k.length===1&&this.q())}o(O,S){return O.type!=="event"||S.type!=="event"}async q(){let O;for(;this.k.length;){if((!O||this.o(this.k[0],O))&&await(0,T.timeout)(0),O=this.k.shift(),!O)return;switch(O.type){case"event":this.i?.(O);break;case"request":this.g?.(O);break;case"response":{const S=O,C=this.f.get(S.request_seq);C&&(this.f.delete(S.request_seq),C(S));break}}}}s(O,S){S.type=O,S.seq=this.d++,this.sendMessage(S)}async u(){if(this.f.size===0)return Promise.resolve();const O=new Map;this.f.forEach((S,C)=>O.set(C,S)),await(0,T.timeout)(500),O.forEach((S,C)=>{S({type:"response",seq:0,request_seq:C,success:!1,command:"canceled",message:"canceled"}),this.f.delete(C)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=L}),define(ke[172],Ce([1,0,143,41,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new T.RawContextKey("debugType",void 0,{type:"string",description:i.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new T.RawContextKey("debugConfigurationType",void 0,{type:"string",description:i.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new T.RawContextKey("debugState","inactive",{type:"string",description:i.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new T.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:i.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new T.RawContextKey("hasDebugged",!1,{type:"boolean",description:i.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new T.RawContextKey("inDebugMode",!1,{type:"boolean",description:i.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new T.RawContextKey("inDebugRepl",!1,{type:"boolean",description:i.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new T.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:i.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new T.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:i.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new T.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:i.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new T.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:i.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new T.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:i.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new T.RawContextKey("variablesFocused",!0,{type:"boolean",description:i.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new T.RawContextKey("expressionSelected",!1,{type:"boolean",description:i.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new T.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:i.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new T.RawContextKey("callStackItemType",void 0,{type:"string",description:i.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new T.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:i.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new T.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:i.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new T.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:i.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new T.RawContextKey("watchItemType",void 0,{type:"string",description:i.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new T.RawContextKey("canViewMemory",void 0,{type:"boolean",description:i.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new T.RawContextKey("breakpointItemType",void 0,{type:"string",description:i.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new T.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:i.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new T.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:i.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new T.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:i.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new T.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:i.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new T.RawContextKey("stepBackSupported",!1,{type:"boolean",description:i.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new T.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:i.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new T.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:i.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new T.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:i.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new T.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:i.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new T.RawContextKey("breakpointsExist",!1,{type:"boolean",description:i.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new T.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:i.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new T.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:i.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new T.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:i.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new T.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:i.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new T.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:i.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new T.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:i.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new T.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:i.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new T.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:i.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new T.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:i.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new T.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:i.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new T.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:i.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new T.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:i.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new T.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:i.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new T.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:i.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new T.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:i.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new T.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:i.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new T.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:i.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new T.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:i.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new T.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:i.localize(50,null)});const L=m=>i.localize(51,null,m);e.debuggerDisabledMessage=L,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:i.localize(52,null)};var k;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(k=e.State||(e.State={}));function O(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=O;var S;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})(S=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var C;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(C=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var N;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(N=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,y.createDecorator)("debugService");var D;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE"})(D=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(ke[173],Ce([1,0,10,2,19,23,13]),function(ee,e,i,T,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const O=/{([^}]+)}/g;function S(o,d,s){return o.replace(O,function(u,n){return d&&n.length>0&&n[0]!=="_"?u:s&&s.hasOwnProperty(n)?s[n]:u})}e.formatPII=S;function C(o){const d={};for(const s of Object.keys(o))s.startsWith("!")||(d[s]=o[s]);return d}e.filterExceptionsFromTelemetry=C;function N(o){return o.configuration.request==="attach"&&!D(o)&&(!o.parentSession||N(o.parentSession))}e.isSessionAttach=N;function D(o){let d=o.configuration.type;if(!!d)return d==="vslsShare"&&(d=o.configuration.adapterProxy.configuration.type),(0,i.equalsIgnoreCase)(d,"extensionhost")||(0,i.equalsIgnoreCase)(d,"pwa-extensionhost")?o:o.parentSession?D(o.parentSession):void 0}e.getExtensionHostDebugSession=D;function m(o){return o.type&&(o.label||o.program||o.runtime)}e.isDebuggerMainContribution=m;function p(o,d,s){let u,n=0;const h=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let g=null;for(;g=h.exec(o);){const P=g.index+1,M=P+g[0].length;if(P<=d&&M>=s){u=g[0],n=P;break}}if(u){const P=/\w+/g;let M=null;for(;(M=P.exec(u))&&!(M.index+1+n+M[0].length>=s););M&&(u=u.substring(0,P.lastIndex))}return u?{start:n,end:n+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=p;const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function t(o){return!!(o&&o.match(f))}e.isUri=t;function c(o){if(typeof o.path=="string"&&!(typeof o.sourceReference=="number"&&o.sourceReference>0)){if(t(o.path))return T.URI.parse(o.path);if((0,y.isAbsolute)(o.path))return T.URI.file(o.path)}return o.path}function l(o){if(typeof o.path=="object"){const d=T.URI.revive(o.path);if(d)return d.scheme===k.Schemas.file?d.fsPath:d.toString()}return o.path}function v(o,d){const s=d?c:l,u=(0,L.deepClone)(o);return E(u,(n,h)=>{n&&h&&(h.path=s(h))}),u}e.convertToDAPaths=v;function b(o,d){const s=d?c:l,u=(0,L.deepClone)(o);return E(u,(n,h)=>{!n&&h&&(h.path=s(h))}),u}e.convertToVSCPaths=b;function E(o,d){switch(o.type){case"event":{const s=o;switch(s.event){case"output":d(!1,s.body.source);break;case"loadedSource":d(!1,s.body.source);break;case"breakpoint":d(!1,s.body.breakpoint.source);break;default:break}break}case"request":{const s=o;switch(s.command){case"setBreakpoints":d(!0,s.arguments.source);break;case"breakpointLocations":d(!0,s.arguments.source);break;case"source":d(!0,s.arguments.source);break;case"gotoTargets":d(!0,s.arguments.source);break;case"launchVSCode":s.arguments.args.forEach(u=>d(!1,u));break;default:break}break}case"response":{const s=o;if(s.success&&s.body)switch(s.command){case"stackTrace":s.body.stackFrames.forEach(u=>d(!1,u.source));break;case"loadedSources":s.body.sources.forEach(u=>d(!1,u));break;case"scopes":s.body.scopes.forEach(u=>d(!1,u.source));break;case"setFunctionBreakpoints":s.body.breakpoints.forEach(u=>d(!1,u.source));break;case"setBreakpoints":s.body.breakpoints.forEach(u=>d(!1,u.source));break;case"disassemble":s.body?.instructions.forEach(n=>d(!1,n.location));break;default:break}break}}}function w(o){return o.filter(d=>!d.presentation?.hidden).sort((d,s)=>d.presentation?s.presentation?d.presentation.group?s.presentation.group?d.presentation.group!==s.presentation.group?d.presentation.group.localeCompare(s.presentation.group):r(d.presentation.order,s.presentation.order):-1:s.presentation.group?1:r(d.presentation.order,s.presentation.order):-1:s.presentation?1:0)}e.getVisibleAndSorted=w;function r(o,d){return typeof o!="number"?typeof d!="number"?0:1:typeof d!="number"?-1:o-d}async function a(o,d){const s=o.getValue("debug.saveBeforeStart",{overrideIdentifier:d.activeTextEditorLanguageId});if(s!=="none"&&(await d.saveAll(),s==="allEditorsInActiveGroup")){const u=d.activeEditorPane;u&&u.input.resource?.scheme===k.Schemas.untitled&&await d.save({editor:u.input,groupId:u.group.id})}await o.reloadConfiguration()}e.saveAllBeforeDebugStart=a}),define(ke[67],Ce([1,0,24,35,174,62,13,19,21,41]),function(ee,e,i,T,y,L,k,O,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var N;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(N=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",L.Mimes.latex,L.Mimes.markdown,"image/png","image/jpeg",L.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[L.Mimes.latex,L.Mimes.markdown,"application/json",L.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(D=e.NotebookRunState||(e.NotebookRunState={}));var m;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(m=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var p;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(p=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var f;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(f=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var t;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(t=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var c;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(c=e.SelectionStateType||(e.SelectionStateType={}));var l;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(l=e.CellEditType||(e.CellEditType={}));var v;(function(B){B.scheme=k.Schemas.vscodeNotebookCell;const z=["W","X","Y","Z","a","b","c","d","e","f"],V=new RegExp(`^[${z.join("")}]+`),K=7;function ie(Q,le){const Ee=le.toString(K),Be=`${Ee.length<z.length?z[Ee.length-1]:"z"}${Ee}s${(0,i.encodeBase64)(i.VSBuffer.fromString(Q.scheme),!0,!0)}`;return Q.with({scheme:B.scheme,fragment:Be})}B.generate=ie;function me(Q){if(Q.scheme!==B.scheme)return;const le=Q.fragment.indexOf("s");if(le<0)return;const Ee=parseInt(Q.fragment.substring(0,le).replace(V,""),K),Ae=(0,i.decodeBase64)(Q.fragment.substring(le+1)).toString();if(!isNaN(Ee))return{handle:Ee,notebook:Q.with({scheme:Ae,fragment:null})}}B.parse=me;function ue(Q,le){return Q.with({scheme:k.Schemas.vscodeNotebookCellOutput,fragment:`op${le??""},${Q.scheme!==k.Schemas.file?Q.scheme:""}`})}B.generateCellOutputUri=ue;function oe(Q){if(Q.scheme!==k.Schemas.vscodeNotebookCellOutput)return;const le=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Q.fragment);if(!le)return;const Ee=le[1]&&le[1]!==""?le[1]:void 0,Ae=le[2];return{outputId:Ee,notebook:Q.with({scheme:Ae||k.Schemas.file,fragment:null})}}B.parseCellOutputUri=oe;function De(Q,le,Ee){return B.generate(Q,le).with({scheme:Ee})}B.generateCellPropertyUri=De;function re(Q,le){if(Q.scheme===le)return B.parse(Q.with({scheme:B.scheme}))}B.parseCellPropertyUri=re})(v=e.CellUri||(e.CellUri={}));const b=B=>S.isWindows?B.replace(/\//g,"\\"):B;class E{constructor(z=[],V=e.NOTEBOOK_DISPLAY_ORDER){this.e=V,this.d=[...new Set(z)].map(K=>({pattern:K,matches:T.parse(b(K))}))}sort(z){const V=new Map(y.Iterable.map(z,ie=>[ie,b(ie)]));let K=[];for(const{matches:ie}of this.d)for(const[me,ue]of V)if(ie(ue)){K.push(me),V.delete(me);break}return V.size&&(K=K.concat([...V.keys()].sort((ie,me)=>this.e.indexOf(ie)-this.e.indexOf(me)))),K}prioritize(z,V){const K=this.f(z);if(K===-1){this.d.unshift({pattern:z,matches:T.parse(b(z))});return}const ie=new Set(V.map(ue=>this.f(ue,K)));ie.delete(-1);const me=Array.from(ie).sort();this.d.splice(K+1,0,...me.map(ue=>this.d[ue]));for(let ue=me.length-1;ue>=0;ue--)this.d.splice(me[ue],1)}toArray(){return this.d.map(z=>z.pattern)}f(z,V=this.d.length){const K=b(z);for(let ie=0;ie<V;ie++)if(this.d[ie].matches(K))return ie;return-1}}e.MimeTypeDisplayOrder=E;function w(B,z,V,K=(ie,me)=>ie===me){const ie=[];function me(De,re,Q){if(re===0&&Q.length===0)return;const le=ie[ie.length-1];le&&le.start+le.deleteCount===De?(le.deleteCount+=re,le.toInsert.push(...Q)):ie.push({start:De,deleteCount:re,toInsert:Q})}let ue=0,oe=0;for(;;){if(ue===B.length){me(ue,0,z.slice(oe));break}if(oe===z.length){me(ue,B.length-ue,[]);break}const De=B[ue],re=z[oe];if(K(De,re)){ue+=1,oe+=1;continue}V(re)?(me(ue,1,[]),ue+=1):(me(ue,0,[re]),oe+=1)}return ie}e.diff=w,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var r;(function(B){B.default="default",B.option="option"})(r=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function a(B){const z=B;return!!((typeof z.include=="string"||T.isRelativePattern(z.include))&&(typeof z.exclude=="string"||T.isRelativePattern(z.exclude)))}e.isDocumentExcludePattern=a;function o(B,z,V){if(Array.isArray(B.viewType)&&B.viewType.indexOf(z)>=0||B.viewType===z)return!0;if(B.filenamePattern){const K=a(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,ie=a(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(T.match(K,(0,O.basename)(V.fsPath).toLowerCase()))return!(ie&&T.match(ie,(0,O.basename)(V.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling"};var d;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(d=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class s{static create(z){return`${s.d}${z}`}static parse(z){if(z.startsWith(s.d))return z.substring(s.d.length)}}e.NotebookWorkingCopyTypeIdentifier=s,s.d="notebook/";function u(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}e.isTextStreamMime=u;const n=new TextDecoder;function h(B){const z=[];let V=!1;for(const K of B)(z.length===0||V)&&(z.push(K),V=!0);return j(z),F(i.VSBuffer.concat(z.map(K=>i.VSBuffer.wrap(K))))}e.compressOutputItemStreams=h;const g=`${String.fromCharCode(27)}[A`,P=g.split("").map(B=>B.charCodeAt(0)),M=10;function j(B){B.forEach((z,V)=>{if(V===0||z.length<g.length)return;const K=B[V-1],ie=z.subarray(0,g.length);if(ie[0]===P[0]&&ie[1]===P[1]&&ie[2]===P[2]){const me=K.lastIndexOf(M);if(me===-1)return;B[V-1]=K.subarray(0,me),B[V]=z.subarray(g.length)}})}function Z(B){let z=B;do B=z,z=B.replace(/[^\n]\x08/gm,"");while(z.length<B.length);return B}function G(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const z=B.match(/^(.*)\r+/m)[1];let V=B.match(/\r+(.*)$/m)[1];V=V+z.slice(V.length,z.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,V)}return B}const A="\b".charCodeAt(0),R="\r".charCodeAt(0);function F(B){return!B.buffer.includes(A)&&!B.buffer.includes(R)?B:i.VSBuffer.fromString(G(Z(n.decode(B.buffer))))}}),define(ke[175],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var T;(function(y){y[y.Output=1]="Output",y[y.OutputItems=2]="OutputItems",y[y.ExecutionState=3]="ExecutionState"})(T=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,i.createDecorator)("INotebookExecutionService")}),define(ke[176],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function i(k){return[...k.entries()]}e.serializeEnvironmentVariableCollection=i;function T(k){return new Map(k)}e.deserializeEnvironmentVariableCollection=T;function y(k){return Array.from(k.entries()).map(O=>[O[0],i(O[1].map)])}e.serializeEnvironmentVariableCollections=y;function L(k){return new Map(k.map(O=>[O[0],{map:T(O[1])}]))}e.deserializeEnvironmentVariableCollections=L}),define(ke[42],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var i;(function(L){L.Delimiter="\0"})(i=e.TestIdPathParts||(e.TestIdPathParts={}));var T;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(T=e.TestPosition||(e.TestPosition={}));class y{static fromExtHostTestItem(k,O,S=k.parent){if(k._isRoot)return new y([O]);const C=[k.id];for(let N=S;N&&N.id!==O;N=N.parent)C.push(N.id);return C.push(O),new y(C.reverse())}static isRoot(k){return!k.includes("\0")}static root(k){const O=k.indexOf("\0");return O===-1?k:k.slice(0,O)}static fromString(k){return new y(k.split("\0"))}static join(k,O){return new y([...k.path,O])}static joinToString(k,O){return k.toString()+"\0"+O}static parentId(k){const O=k.lastIndexOf("\0");return O===-1?void 0:k.slice(0,O)}static compare(k,O){return k===O?0:O.startsWith(k+"\0")?2:k.startsWith(O+"\0")?3:1}constructor(k,O=k.length){if(this.path=k,this.d=O,k.length===0||O<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new y(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let k=1;k<=this.d;k++)yield new y(this.path,k)}*idsToRoot(){for(let k=this.d;k>0;k--)yield new y(this.path,k)}compare(k){if(typeof k=="string")return y.compare(this.toString(),k);for(let O=0;O<k.d&&O<this.d;O++)if(k.path[O]!==this.path[O])return 1;return k.d>this.d?2:k.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let k=1;k<this.d;k++)this.c+="\0",this.c+=this.path[k]}return this.c}}e.TestId=y}),define(ke[54],Ce([1,0,2,55,42]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var L;(function(u){u[u.Unset=0]="Unset",u[u.Queued=1]="Queued",u[u.Running=2]="Running",u[u.Passed=3]="Passed",u[u.Failed=4]="Failed",u[u.Skipped=5]="Skipped",u[u.Errored=6]="Errored"})(L=e.TestResultState||(e.TestResultState={}));var k;(function(u){u[u.Run=2]="Run",u[u.Debug=4]="Debug",u[u.Coverage=8]="Coverage",u[u.HasNonDefaultProfile=16]="HasNonDefaultProfile",u[u.HasConfigurable=32]="HasConfigurable"})(k=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var O;(function(u){u.serialize=n=>({range:n.range.toJSON(),uri:n.uri.toJSON()}),u.deserialize=n=>({range:T.Range.lift(n.range),uri:i.URI.revive(n.uri)})})(O=e.IRichLocation||(e.IRichLocation={}));var S;(function(u){u[u.Error=0]="Error",u[u.Output=1]="Output"})(S=e.TestMessageType||(e.TestMessageType={}));var C;(function(u){u.serialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&O.serialize(n.location)}),u.deserialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&O.deserialize(n.location)})})(C=e.ITestErrorMessage||(e.ITestErrorMessage={}));const N=(u,n)=>`${n?"s":"e"}${u}`;e.getMarkId=N;var D;(function(u){u.serialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&O.serialize(n.location)}),u.deserialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&O.deserialize(n.location)})})(D=e.ITestOutputMessage||(e.ITestOutputMessage={}));var m;(function(u){u.serialize=n=>n.type===0?C.serialize(n):D.serialize(n),u.deserialize=n=>n.type===0?C.deserialize(n):D.deserialize(n)})(m=e.ITestMessage||(e.ITestMessage={}));var p;(function(u){u.serializeWithoutMessages=n=>({state:n.state,duration:n.duration,messages:[]}),u.serialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(m.serialize)}),u.deserialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(m.deserialize)})})(p=e.ITestTaskState||(e.ITestTaskState={}));const f="\0",t=(u,n)=>u+f+n;e.namespaceTestTag=t;const c=u=>{const n=u.indexOf(f);return{ctrlId:u.slice(0,n),tagId:u.slice(n+1)}};e.denamespaceTestTag=c;var l;(function(u){u.serialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?.toJSON(),range:n.range?.toJSON()||null,description:n.description,error:n.error,sortText:n.sortText}),u.deserialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?i.URI.revive(n.uri):void 0,range:n.range?T.Range.lift(n.range):null,description:n.description,error:n.error,sortText:n.sortText})})(l=e.ITestItem||(e.ITestItem={}));var v;(function(u){u[u.NotExpandable=0]="NotExpandable",u[u.Expandable=1]="Expandable",u[u.BusyExpanding=2]="BusyExpanding",u[u.Expanded=3]="Expanded"})(v=e.TestItemExpandState||(e.TestItemExpandState={}));var b;(function(u){u.serialize=n=>({expand:n.expand,item:l.serialize(n.item)}),u.deserialize=n=>({controllerId:y.TestId.root(n.item.extId),expand:n.expand,item:l.deserialize(n.item)})})(b=e.InternalTestItem||(e.InternalTestItem={}));var E;(function(u){u.serialize=n=>{let h;return n.item&&(h={},n.item.label!==void 0&&(h.label=n.item.label),n.item.tags!==void 0&&(h.tags=n.item.tags),n.item.busy!==void 0&&(h.busy=n.item.busy),n.item.uri!==void 0&&(h.uri=n.item.uri?.toJSON()),n.item.range!==void 0&&(h.range=n.item.range?.toJSON()),n.item.description!==void 0&&(h.description=n.item.description),n.item.error!==void 0&&(h.error=n.item.error),n.item.sortText!==void 0&&(h.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:h}},u.deserialize=n=>{let h;return n.item&&(h={},n.item.label!==void 0&&(h.label=n.item.label),n.item.tags!==void 0&&(h.tags=n.item.tags),n.item.busy!==void 0&&(h.busy=n.item.busy),n.item.range!==void 0&&(h.range=n.item.range?T.Range.lift(n.item.range):null),n.item.description!==void 0&&(h.description=n.item.description),n.item.error!==void 0&&(h.error=n.item.error),n.item.sortText!==void 0&&(h.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:h}}})(E=e.ITestItemUpdate||(e.ITestItemUpdate={}));const w=(u,n)=>{n.expand!==void 0&&(u.expand=n.expand),n.item!==void 0&&(u.item=u.item?Object.assign(u.item,n.item):n.item)};e.applyTestItemUpdate=w;var r;(function(u){u.serializeWithoutMessages=n=>({...b.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(p.serializeWithoutMessages),retired:n.retired}),u.serialize=n=>({...b.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(p.serialize),retired:n.retired}),u.deserialize=n=>({...b.deserialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(p.deserialize),retired:!0})})(r=e.TestResultItem||(e.TestResultItem={}));var a;(function(u){u[u.Function=0]="Function",u[u.Statement=1]="Statement"})(a=e.DetailType||(e.DetailType={}));var o;(function(u){u[u.Add=0]="Add",u[u.Update=1]="Update",u[u.DocumentSynced=2]="DocumentSynced",u[u.Remove=3]="Remove",u[u.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",u[u.Retire=5]="Retire",u[u.AddTag=6]="AddTag",u[u.RemoveTag=7]="RemoveTag"})(o=e.TestDiffOpType||(e.TestDiffOpType={}));var d;(function(u){u.deserialize=n=>n.op===0?{op:n.op,item:b.deserialize(n.item)}:n.op===1?{op:n.op,item:E.deserialize(n.item)}:n.op===2?{op:n.op,uri:i.URI.revive(n.uri),docv:n.docv}:n,u.serialize=n=>n.op===0?{op:n.op,item:b.serialize(n.item)}:n.op===1?{op:n.op,item:E.serialize(n.item)}:n})(d=e.TestsDiffOp||(e.TestsDiffOp={}));class s{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(n){const h=this.o();for(const g of n)switch(g.op){case 0:this.j(b.deserialize(g.item),h);break;case 1:this.k(E.deserialize(g.item),h);break;case 3:this.l(g.itemId,h);break;case 5:this.m(g.itemId);break;case 4:this.updatePendingRoots(g.amount);break;case 6:this.c.set(g.tag.id,g.tag);break;case 7:this.c.delete(g.id);break}h.complete?.()}j(n,h){const g=y.TestId.parentId(n.item.extId)?.toString();let P;if(!g)P=this.p(n),this.f.add(P),this.d.set(n.item.extId,P);else if(this.d.has(g)){const M=this.d.get(g);M.children.add(n.item.extId),P=this.p(n,M),this.d.set(n.item.extId,P)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(n)}`);return}return h.add?.(P),n.expand===2&&this.g++,P}k(n,h){const g=this.d.get(n.extId);if(!!g)return n.expand!==void 0&&(g.expand===2&&this.g--,n.expand===2&&this.g++),(0,e.applyTestItemUpdate)(g,n),h.update?.(g),g}l(n,h){const g=this.d.get(n);if(!g)return;const P=y.TestId.parentId(g.item.extId)?.toString();P?this.d.get(P).children.delete(g.item.extId):this.f.delete(g);const M=[[n]];for(;M.length;)for(const j of M.pop()){const Z=this.d.get(j);Z&&(M.push(Z.children),this.d.delete(j),h.remove?.(Z,Z!==g),Z.expand===2&&this.g--)}}m(n){}updatePendingRoots(n){this.h+=n}o(){return{}}}e.AbstractIncrementalTestCollection=s}),define(ke[68],Ce([1,0,14,5,7,47,54,42]),function(ee,e,i,T,y,L,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var S;(function(v){v[v.Upsert=0]="Upsert",v[v.SetTags=1]="SetTags",v[v.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",v[v.RemoveChild=3]="RemoveChild",v[v.SetProp=4]="SetProp",v[v.Bulk=5]="Bulk",v[v.DocumentSynced=6]="DocumentSynced"})(S=e.TestItemEventOp||(e.TestItemEventOp={}));const C=(v,b)=>v===b,D=Object.entries({range:(v,b)=>v===b?!0:!v||!b?!1:v.equalsRange(b),busy:C,label:C,description:C,error:C,sortText:C,tags:(v,b)=>!(v.length!==b.length||v.some(E=>!b.includes(E)))}),m=(v,b)=>{let E;for(const[w,r]of D)r(v[w],b[w])||(E?E[w]=b[w]:E={[w]:b[w]});return E};class p extends y.Disposable{get root(){return this.m.root}constructor(b){super(),this.m=b,this.f=this.B(new i.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new T.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(b){this.h=b;for(const E of this.tree.values())this.G(E)}collectDiff(){const b=this.k;return this.k=[],b}pushDiff(b){switch(b.op){case 2:{for(const E of this.k)if(E.op===2&&E.uri===b.uri){E.docv=b.docv;return}break}case 1:{const E=this.k[this.k.length-1];if(E){if(E.op===1&&E.item.extId===b.item.extId){(0,k.applyTestItemUpdate)(E.item,b.item);return}if(E.op===0&&E.item.item.extId===b.item.extId){(0,k.applyTestItemUpdate)(E.item,b.item);return}}break}}this.k.push(b),this.f.isScheduled()||this.f.schedule()}expand(b,E){const w=this.tree.get(b);if(!!w){if((w.expandLevels===void 0||E>w.expandLevels)&&(w.expandLevels=E),w.expand===1){const r=this.I(w);return r.isOpen()?this.H(w,E-1):r.wait().then(()=>this.H(w,E-1))}else if(w.expand===3)return w.resolveBarrier?.isOpen()===!1?w.resolveBarrier.wait().then(()=>this.H(w,E-1)):this.H(w,E-1)}}dispose(){for(const b of this.tree.values())this.m.getApiFor(b.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(b,E){switch(E.op){case 3:this.L(O.TestId.joinToString(b.fullId,E.id));break;case 0:this.u(E.item,b);break;case 5:for(const w of E.ops)this.p(b,w);break;case 1:this.w(E.new,E.old,b.fullId.toString());break;case 2:this.G(b);break;case 4:this.pushDiff({op:1,item:{extId:b.fullId.toString(),item:E.update}});break;case 6:this.s(b.actual.uri);break;default:(0,L.assertNever)(E)}}s(b){b&&this.pushDiff({op:2,uri:b,docv:this.m.getDocumentVersion(b)})}u(b,E){const w=O.TestId.fromExtHostTestItem(b,this.root.id,E?.actual),r=this.m.getApiFor(b);r.parent&&r.parent!==E?.actual&&this.m.getChildren(r.parent).delete(b.id);let a=this.tree.get(w.toString());if(!a){a={fullId:w,actual:b,expandLevels:E?.expandLevels?E.expandLevels-1:void 0,expand:0},b.tags.forEach(this.y,this),this.tree.set(a.fullId.toString(),a),this.C(b,E),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:a.expand,item:this.m.toITestItem(b)}}),this.F(b,a,E);return}if(a.actual===b){this.D(b,a,E);return}if(a.actual.uri?.toString()!==b.uri?.toString())return this.L(w.toString()),this.u(b,E);const o=this.m.getChildren(a.actual),d=a.actual,s=m(this.m.toITestItem(d),this.m.toITestItem(b));this.m.getApiFor(d).listener=void 0,a.actual=b,a.expand=0,s&&(s.hasOwnProperty("tags")&&(this.w(b.tags,d.tags,w.toString()),delete s.tags),this.p(a,{op:4,update:s})),this.F(b,a,E);for(const[u,n]of o)this.m.getChildren(b).get(n.id)||this.L(O.TestId.joinToString(w,n.id));this.s(a.actual.uri)}w(b,E,w){const r=new Set(E.map(a=>a.id));for(const a of b)r.delete(a.id)||this.y(a);this.pushDiff({op:1,item:{extId:w,item:{tags:b.map(a=>(0,k.namespaceTestTag)(this.m.controllerId,a.id))}}}),r.forEach(this.z,this)}y(b){const E=this.j.get(b.id);E?E.refCount++:(this.j.set(b.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,k.namespaceTestTag)(this.m.controllerId,b.id)}}))}z(b){const E=this.j.get(b);E&&!--E.refCount&&(this.j.delete(b),this.pushDiff({op:7,id:(0,k.namespaceTestTag)(this.m.controllerId,b)}))}C(b,E){this.m.getApiFor(b).parent=E&&E.actual!==this.root?E.actual:void 0}D(b,E,w){this.C(b,w);const r=this.m.getApiFor(b);r.parent=w?.actual,r.listener=a=>this.p(E,a),this.G(E)}F(b,E,w){this.D(b,E,w);for(const[r,a]of this.m.getChildren(b))this.u(a,E)}G(b){let E;this.h?b.resolveBarrier?E=b.resolveBarrier.isOpen()?3:2:E=b.actual.canResolveChildren?1:0:E=0,E!==b.expand&&(b.expand=E,this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:E}}),E===1&&b.expandLevels!==void 0&&this.I(b))}H(b,E){if(E<0)return;const w=[];for(const[r,a]of this.m.getChildren(b.actual)){const o=this.expand(O.TestId.joinToString(b.fullId,a.id),E);(0,i.isThenable)(o)&&w.push(o)}if(w.length)return Promise.all(w).then(()=>{})}I(b){if(b.resolveBarrier)return b.resolveBarrier;if(!this.h){const a=new i.Barrier;return a.open(),a}b.expand=2,this.J(b);const E=b.resolveBarrier=new i.Barrier,w=a=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,a)};let r;try{r=this.h(b.actual===this.root?void 0:b.actual)}catch(a){w(a)}return(0,i.isThenable)(r)?r.catch(w).then(()=>{E.open(),this.G(b)}):(E.open(),this.G(b)),b.resolveBarrier}J(b){this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:b.expand}})}L(b){const E=this.tree.get(b);if(!E)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:b});const w=[E];for(;w.length;){const r=w.pop();if(!!r){this.m.getApiFor(r.actual).listener=void 0;for(const a of r.actual.tags)this.z(a.id);this.tree.delete(r.fullId.toString());for(const[a,o]of this.m.getChildren(r.actual))w.push(this.tree.get(O.TestId.joinToString(r.fullId,o.id)))}}}flushDiff(){const b=this.collectDiff();b.length&&this.g.fire(b)}}e.TestItemCollection=p;class f extends Error{constructor(b){super(`Attempted to insert a duplicate test item ID ${b}`)}}e.DuplicateTestItemError=f;class t extends Error{constructor(b){super(`TestItem with ID "${b}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=t;class c extends Error{constructor(b,E,w){super(`TestItem with ID "${b}" is from controller "${E}" and cannot be added as a child of an item from controller "${w}".`)}}e.MixedTestItemController=c;const l=(v,b,E)=>{let w=new Map;return{get size(){return w.size},forEach(r,a){for(const o of w.values())r.call(a,o,this)},[Symbol.iterator](){return w.entries()},replace(r){const a=new Map,o=new Set(w.keys()),d={op:5,ops:[]};for(const s of r){if(!(s instanceof E))throw new t(s.id);const u=b(s).controllerId;if(u!==v.controllerId)throw new c(s.id,u,v.controllerId);if(a.has(s.id))throw new f(s.id);a.set(s.id,s),o.delete(s.id),d.ops.push({op:0,item:s})}for(const s of o.keys())d.ops.push({op:3,id:s});v.listener?.(d),w=a},add(r){if(!(r instanceof E))throw new t(r.id);w.set(r.id,r),v.listener?.({op:0,item:r})},delete(r){w.delete(r)&&v.listener?.({op:3,id:r})},get(r){return w.get(r)},toJSON(){return Array.from(w.values())}}};e.createTestItemChildren=l}),define(ke[94],Ce([1,0,68]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const T=new WeakMap,y=(k,O)=>{const S={controllerId:O};return T.set(k,S),S};e.createPrivateApiFor=y;const L=k=>{const O=T.get(k);if(!O)throw new i.InvalidTestItemError(k?.id||"<unknown>");return O};e.getPrivateApiFor=L}),define(ke[69],Ce([1,0,13,2]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function y(O,S){return O.scheme===i.Schemas.http||O.scheme===i.Schemas.https?O:(S&&S.authority&&S.isRemote&&O.scheme===i.Schemas.file&&(O=T.URI.from({scheme:i.Schemas.vscodeRemote,authority:S.authority,path:O.path})),T.URI.from({scheme:i.Schemas.https,authority:`${O.scheme}+${L(O.authority)}.${e.webviewRootResourceAuthority}`,path:O.path,fragment:O.fragment,query:O.query}))}e.asWebviewUri=y;function L(O){return O.replace(/./g,S=>{const C=S.charCodeAt(0);return C>=97&&C<=122||C>=65&&C<=90||C>=48&&C<=57?S:"-"+C.toString(16).padStart(4,"0")})}function k(O){return O.replace(/-([0-9a-f]{4})/g,(S,C)=>String.fromCharCode(parseInt(C,16)))}e.decodeAuthority=k}),define(ke[177],Ce([1,0,5,7,69]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class L{constructor(O,S,C){this.d=O,this.e=S,this.f=C,this.a=0,this.b=new T.DisposableStore,this.c=new Map,this.b.add(S.onDidChangeVisibleTextEditors(()=>{const N=S.getVisibleTextEditors();for(const D of this.c.values())N.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach(O=>O.inset.dispose()),this.b.dispose()}createWebviewEditorInset(O,S,C,N,D){let m;for(const b of this.e.getVisibleTextEditors(!0))if(b.value===O){m=b;break}if(!m)throw new Error("not a visible editor");const p=this,f=this.a++,t=new i.Emitter,c=new i.Emitter,l=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(b){return(0,y.asWebviewUri)(b,p.f)}get cspSource(){return y.webviewGenericCspSource}set options(b){this.b=b,p.d.$setOptions(f,b)}get options(){return this.b}set html(b){this.a=b,p.d.$setHtml(f,b)}get html(){return this.a}get onDidReceiveMessage(){return t.event}postMessage(b){return p.d.$postMessage(f,b)}},v=new class{constructor(){this.editor=O,this.line=S,this.height=C,this.webview=l,this.onDidDispose=c.event}dispose(){p.c.has(f)&&(p.c.delete(f),p.d.$disposeEditorInset(f),c.fire(),c.dispose(),t.dispose())}};return this.d.$createEditorInset(f,m.id,m.value.document.uri,S+1,C,N||{},D.identifier,D.extensionLocation),this.c.set(f,{editor:O,inset:v,onDidReceiveMessage:t}),v}$onDidDispose(O){const S=this.c.get(O);S&&S.inset.dispose()}$onDidReceiveMessage(O,S){this.c.get(O)?.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=L}),define(ke[178],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,i.createDecorator)("configurationResolverService");var T;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(T=e.VariableKind||(e.VariableKind={}));class y extends Error{constructor(k,O){super(O),this.variable=k}}e.VariableError=y}),define(ke[179],Ce([1,0,19,49,9,23,21,84,146,178,10]),function(ee,e,i,T,y,L,k,O,S,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class D{constructor(p,f,t,c){this.g=new Map,this.a=p,this.b=f,this.d=t,c&&(this.c=c.then(l=>this.h(l)))}h(p){if(k.isWindows){const f=Object.create(null);return Object.keys(p).forEach(t=>{f[t.toLowerCase()]=p[t]}),f}return p}resolveWithEnvironment(p,f,t){return this.j({env:this.h(p),userHome:void 0},f?f.uri:void 0,t)}async resolveAsync(p,f){const t={env:await this.c,userHome:await this.d};return this.j(t,p?p.uri:void 0,f)}async i(p,f,t,c){const l=L.deepClone(f);k.isWindows&&l.windows?Object.keys(l.windows).forEach(b=>l[b]=l.windows[b]):k.isMacintosh&&l.osx?Object.keys(l.osx).forEach(b=>l[b]=l.osx[b]):k.isLinux&&l.linux&&Object.keys(l.linux).forEach(b=>l[b]=l.linux[b]),delete l.windows,delete l.osx,delete l.linux;const v={env:await this.c,userHome:await this.d};return this.j(v,p?p.uri:void 0,l,t,c)}async resolveAnyAsync(p,f,t){return this.i(p,f,t)}async resolveAnyMap(p,f,t){const c=new Map;return{newConfig:await this.i(p,f,t,c),resolvedVariables:c}}resolveWithInteractionReplace(p,f,t,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,f,t,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,f){if(this.g.has(p))throw new Error("Variable "+p+" is contributed twice.");this.g.set(p,f)}async j(p,f,t,c,l){if(y.isString(t))return this.l(p,f,t,c,l);if(Array.isArray(t))return Promise.all(t.map(v=>this.j(p,f,v,c,l)));if(y.isObject(t)){const v=Object.create(null),b=await Promise.all(Object.keys(t).map(async E=>[await this.l(p,f,E,c,l),await this.j(p,f,t[E],c,l)]));for(const[E,w]of b)v[E]=w;return v}return t}l(p,f,t,c,l){return(0,N.replaceAsync)(t,D.VARIABLE_REGEXP,async(v,b)=>{if(b.includes(D.VARIABLE_LHS))return v;let E=await this.n(p,v,b,f,c);return l?.set(b,E),E!==v&&y.isString(E)&&E.match(D.VARIABLE_REGEXP)&&(E=await this.l(p,f,E,c,l)),E})}m(p){return this.b?this.b.getUriLabel(p,{noPrefix:!0}):p.fsPath}async n(p,f,t,c,l){let v;const b=t.split(":");b.length>1&&(t=b[0],v=b[1]);const E=a=>{const o=this.a.getFilePath();if(o)return(0,O.normalizeDriveLetter)(o);throw new C.VariableError(a,(0,S.localize)(0,null,f))},w=a=>{const o=E(a);if(this.a.getWorkspaceFolderPathForFile){const d=this.a.getWorkspaceFolderPathForFile();if(d)return(0,O.normalizeDriveLetter)(d)}throw new C.VariableError(a,(0,S.localize)(1,null,f,i.basename(o)))},r=a=>{if(v){const o=this.a.getFolderUri(v);if(o)return o;throw new C.VariableError(a,(0,S.localize)(2,null,f,v))}if(c)return c;throw this.a.getWorkspaceFolderCount()>1?new C.VariableError(a,(0,S.localize)(3,null,f)):new C.VariableError(a,(0,S.localize)(4,null,f))};switch(t){case"env":if(v){if(p.env){const a=p.env[k.isWindows?v.toLowerCase():v];if(y.isString(a))return a}return""}throw new C.VariableError(C.VariableKind.Env,(0,S.localize)(5,null,f));case"config":if(v){const a=this.a.getConfigurationValue(c,v);if(y.isUndefinedOrNull(a))throw new C.VariableError(C.VariableKind.Config,(0,S.localize)(6,null,f,v));if(y.isObject(a))throw new C.VariableError(C.VariableKind.Config,(0,S.localize)(7,null,f,v));return a}throw new C.VariableError(C.VariableKind.Config,(0,S.localize)(8,null,f));case"command":return this.o(C.VariableKind.Command,f,v,l,"command");case"input":return this.o(C.VariableKind.Input,f,v,l,"input");case"extensionInstallFolder":if(v){const a=await this.a.getExtension(v);if(!a)throw new C.VariableError(C.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,f,v));return this.m(a.extensionLocation)}throw new C.VariableError(C.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,f));default:switch(t){case"workspaceRoot":case"workspaceFolder":return(0,O.normalizeDriveLetter)(this.m(r(C.VariableKind.WorkspaceFolder)));case"cwd":return c||v?(0,O.normalizeDriveLetter)(this.m(r(C.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,O.normalizeDriveLetter)(i.basename(this.m(r(C.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(p.userHome)return p.userHome;throw new C.VariableError(C.VariableKind.UserHome,(0,S.localize)(11,null,f))}case"lineNumber":{const a=this.a.getLineNumber();if(a)return a;throw new C.VariableError(C.VariableKind.LineNumber,(0,S.localize)(12,null,f))}case"selectedText":{const a=this.a.getSelectedText();if(a)return a;throw new C.VariableError(C.VariableKind.SelectedText,(0,S.localize)(13,null,f))}case"file":return E(C.VariableKind.File);case"fileWorkspaceFolder":return w(C.VariableKind.FileWorkspaceFolder);case"relativeFile":return c||v?i.relative(this.m(r(C.VariableKind.RelativeFile)),E(C.VariableKind.RelativeFile)):E(C.VariableKind.RelativeFile);case"relativeFileDirname":{const a=i.dirname(E(C.VariableKind.RelativeFileDirname));if(c||v){const o=i.relative(this.m(r(C.VariableKind.RelativeFileDirname)),a);return o.length===0?".":o}return a}case"fileDirname":return i.dirname(E(C.VariableKind.FileDirname));case"fileExtname":return i.extname(E(C.VariableKind.FileExtname));case"fileBasename":return i.basename(E(C.VariableKind.FileBasename));case"fileBasenameNoExtension":{const a=i.basename(E(C.VariableKind.FileBasenameNoExtension));return a.slice(0,a.length-i.extname(a).length)}case"fileDirnameBasename":return i.basename(i.dirname(E(C.VariableKind.FileDirnameBasename)));case"execPath":{const a=this.a.getExecPath();return a||f}case"execInstallFolder":{const a=this.a.getAppRoot();return a||f}case"pathSeparator":return i.sep;default:try{const a=v?`${t}:${v}`:t;return this.o(C.VariableKind.Unknown,f,a,l,void 0)}catch{return f}}}}o(p,f,t,c,l){if(t&&c){const v=l===void 0?c[t]:c[l+":"+t];if(typeof v=="string")return v;throw new C.VariableError(p,(0,S.localize)(14,null,f))}return f}}e.AbstractVariableResolverService=D,D.VARIABLE_LHS="${",D.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ke[95],Ce([1,0,3,93]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,i.createDecorator)("editorGroupsService");var y;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(y=e.GroupDirection||(e.GroupDirection={}));var L;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(L=e.GroupOrientation||(e.GroupOrientation={}));var k;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(k=e.GroupLocation||(e.GroupLocation={}));var O;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(O=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function C(f){const t=f;return(0,T.isEditorInput)(t?.editor)&&(0,T.isEditorInput)(t?.replacement)}e.isEditorReplacement=C;var N;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(N=e.GroupsOrder||(e.GroupsOrder={}));var D;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(D=e.OpenEditorContext||(e.OpenEditorContext={}));function m(f){const t=f;return!!t&&typeof t.id=="number"&&Array.isArray(t.editors)}e.isEditorGroup=m;function p(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=p}),define(ke[180],Ce([1,0,3,95]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,i.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function y(L){const k=L;return typeof L=="number"||(0,T.isEditorGroup)(k)}e.isPreferredGroup=y}),define(ke[181],Ce([1,0,3,152]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,i.refineServiceDecorator)(T.IEnvironmentService)}),define(ke[96],Ce([1,0,25,5,19]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class L{constructor(D){this.removedDueToLooping=D}}e.DeltaExtensionsResult=L;class k{static isHostExtension(D,m,p){if(m.getExtensionDescription(D))return!1;const f=p.getExtensionDescription(D);return f?!!((f.main||f.browser)&&f.api==="none"):!1}constructor(D){this.c=new T.Emitter,this.onDidChange=this.c.event,this.d=D,this.h()}h(){this.d.sort(S),this.e=new Map,this.f=[],this.g=new Map;for(const D of this.d){if(this.e.has(i.ExtensionIdentifier.toKey(D.identifier))){console.error("Extension `"+D.identifier.value+"` is already registered");continue}if(this.e.set(i.ExtensionIdentifier.toKey(D.identifier),D),this.f.push(D),Array.isArray(D.activationEvents))for(let m of D.activationEvents)m==="onUri"&&(m=`onUri:${i.ExtensionIdentifier.toKey(D.identifier)}`),this.g.has(m)||this.g.set(m,[]),this.g.get(m).push(D)}}set(D){this.d=D,this.h(),this.c.fire(void 0)}deltaExtensions(D,m){this.d=C(this.d,m),this.d=this.d.concat(D);const p=k.j(this.d);return this.d=C(this.d,p.map(f=>f.identifier)),this.h(),this.c.fire(void 0),new L(p)}static j(D){const m=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(l){this.d.has(l)||(this.d.add(l),this.e.push(l))}addArc(l,v){this.addNode(l),this.addNode(v),this.c.has(l)?this.c.get(l).push(v):this.c.set(l,[v])}getArcs(l){return this.c.has(l)?this.c.get(l):[]}hasOnlyGoodArcs(l,v){const b=m.getArcs(l);for(let E=0;E<b.length;E++)if(!v.has(b[E]))return!1;return!0}getNodes(){return this.e}},p=new Map;for(const l of D){const v=i.ExtensionIdentifier.toKey(l.identifier);if(p.set(v,l),l.extensionDependencies)for(const b of l.extensionDependencies){const E=i.ExtensionIdentifier.toKey(b);m.addArc(v,E)}}const f=new Set;m.getNodes().filter(l=>m.getArcs(l).length===0).forEach(l=>f.add(l));const t=m.getNodes().filter(l=>!f.has(l));let c;do{c=!1;for(let l=0;l<t.length;l++){const v=t[l];m.hasOnlyGoodArcs(v,f)&&(t.splice(l,1),l--,f.add(v),c=!0)}}while(c);return t.map(l=>p.get(l))}containsActivationEvent(D){return this.g.has(D)}containsExtension(D){return this.e.has(i.ExtensionIdentifier.toKey(D))}getExtensionDescriptionsForActivationEvent(D){const m=this.g.get(D);return m?m.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(D){const m=this.e.get(i.ExtensionIdentifier.toKey(D));return m||void 0}getExtensionDescriptionByUUID(D){for(const m of this.f)if(m.uuid===D)return m}getExtensionDescriptionByIdOrUUID(D,m){return this.getExtensionDescription(D)??(m?this.getExtensionDescriptionByUUID(m):void 0)}}e.ExtensionDescriptionRegistry=k;var O;(function(N){N[N.Builtin=0]="Builtin",N[N.User=1]="User",N[N.Dev=2]="Dev"})(O||(O={}));function S(N,D){const m=N.isBuiltin?0:N.isUnderDevelopment?2:1,p=D.isBuiltin?0:D.isUnderDevelopment?2:1;if(m!==p)return m-p;const f=y.posix.basename(N.extensionLocation.path),t=y.posix.basename(D.extensionLocation.path);return f<t?-1:f>t?1:0}function C(N,D){const m=new Set;return D.forEach(p=>m.add(i.ExtensionIdentifier.toKey(p))),N.filter(p=>!m.has(i.ExtensionIdentifier.toKey(p.identifier)))}}),define(ke[70],Ce([1,0,24]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(C){C[C.Desktop=1]="Desktop",C[C.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var y;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(y=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var L;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(L=e.MessageType||(e.MessageType={}));function k(C){const N=i.VSBuffer.alloc(1);switch(C){case 0:N.writeUInt8(1,0);break;case 1:N.writeUInt8(2,0);break;case 2:N.writeUInt8(3,0);break}return N}e.createMessageOfType=k;function O(C,N){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return N===0;case 2:return N===1;case 3:return N===2;default:return!1}}e.isMessageOfType=O;var S;(function(C){C.Start="START_NATIVE_LOG",C.End="END_NATIVE_LOG"})(S=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(ke[71],Ce([1,0,3,5,12,27,70,48,50,23,2]),function(ee,e,i,T,y,L,k,O,S,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let D=class{constructor(t,c){this.i=t,this.a=new T.Emitter,this.onDidChangeTelemetryEnabled=this.a.event,this.b=new T.Emitter,this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.d=0,this.f=!1,this.h=new Map,this.g=c.createLogger(N.URI.revive(this.i.environment.extensionTelemetryLogResource)),this.g.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.g.info("===========================================================")}getTelemetryConfiguration(){return this.d===3}getTelemetryDetails(){return{isCrashEnabled:this.d>=1,isErrorsEnabled:this.c.error?this.d>=2:!1,isUsageEnabled:this.c.usage?this.d>=3:!1}}instantiateLogger(t,c,l){const v=this.getTelemetryDetails(),b=new m(c,l,t,this.g,this.f,this.getBuiltInCommonProperties(t),{isUsageEnabled:v.isUsageEnabled,isErrorsEnabled:v.isErrorsEnabled});return this.h.set(t.identifier.value,b),b.apiTelemetryLogger}$initializeTelemetryLevel(t,c,l){this.d=t,this.f=c,this.c=l??{usage:!0,error:!0}}getBuiltInCommonProperties(t){const c={};switch(c["common.extname"]=t.name,c["common.extversion"]=t.version,c["common.vscodemachineid"]=this.i.telemetryInfo.machineId,c["common.vscodesessionid"]=this.i.telemetryInfo.sessionId,c["common.vscodeversion"]=this.i.version,c["common.isnewappinstall"]=p(this.i.telemetryInfo.firstSessionDate),c["common.product"]=this.i.environment.appHost,this.i.uiKind){case k.UIKind.Web:c["common.uikind"]="web";break;case k.UIKind.Desktop:c["common.uikind"]="desktop";break;default:c["common.uikind"]="unknown"}return c["common.remotename"]=(0,O.getRemoteName)((0,S.cleanRemoteAuthority)(this.i.remote.authority)),c}$onDidChangeTelemetryLevel(t){this.e=this.getTelemetryConfiguration(),this.d=t;const c=this.getTelemetryDetails();this.h.forEach(l=>{l.updateTelemetryEnablements(c.isUsageEnabled,c.isErrorsEnabled)}),this.e!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails())}onExtensionError(t,c){const l=this.h.get(t.value);return!l||l.ignoreUnhandledExtHostErrors?!1:(l.logError(c),!0)}};D=qe([Ve(0,L.IExtHostInitDataService),Ve(1,y.ILoggerService)],D),e.ExtHostTelemetry=D;class m{constructor(t,c,l,v,b,E,w){this.g=l,this.h=v,this.i=b,this.j=E,this.b=new T.Emitter,this.ignoreUnhandledExtHostErrors=c?.ignoreUnhandledErrors??!1,this.e=c?.ignoreBuiltInCommonProperties??!1,this.f=c?.additionalCommonProperties,this.a=t,this.c={isUsageEnabled:w.isUsageEnabled,isErrorsEnabled:w.isErrorsEnabled}}updateTelemetryEnablements(t,c){this.d&&(this.c={isUsageEnabled:t,isErrorsEnabled:c},this.b.fire(this.d))}mixInCommonPropsAndCleanData(t){let c=t.properties??t;return c=(0,S.cleanData)(c,[]),this.f&&(c=(0,C.mixin)(c,this.f)),this.e||(c=(0,C.mixin)(c,this.j)),t.properties?t.properties=c:t=c,t}k(t,c){this.g.publisher==="vscode"?t=this.g.name+"/"+t:t=this.g.identifier.value+"/"+t,c=this.mixInCommonPropsAndCleanData(c||{}),this.i||this.a.logEvent(t,c),this.h.trace(t,c)}logUsage(t,c){!this.c.isUsageEnabled||this.k(t,c)}logError(t,c){!this.c.isErrorsEnabled||(typeof t=="string"?this.k(t,c):this.a.logError(t,c))}get apiTelemetryLogger(){if(!this.d){const t=this,c={logUsage:t.logUsage.bind(t),get isUsageEnabled(){return t.c.isUsageEnabled},get isErrorsEnabled(){return t.c.isErrorsEnabled},logError:t.logError.bind(t),dispose:t.dispose.bind(t),onDidChangeEnableStates:t.b.event.bind(t)};this.d=Object.freeze(c)}return this.d}dispose(){this.a?.flush&&this.a.flush()}}e.ExtHostTelemetryLogger=m;function p(f){const t=Date.now()-new Date(f).getTime();return isNaN(t)?!1:t<1e3*60*60*24}e.isNewAppInstall=p,e.IExtHostTelemetry=(0,i.createDecorator)("IExtHostTelemetry")}),define(ke[26],Ce([1,0,5,2,3,25,161]),function(ee,e,i,T,y,L,k){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new L.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,y.createDecorator)("extensionService");class S{constructor(u){this.affinity=u,this.kind=1}equals(u){return this.kind===u.kind&&this.affinity===u.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=S;class C{constructor(u){this.affinity=u,this.kind=2}equals(u){return this.kind===u.kind&&this.affinity===u.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=C;class N{constructor(){this.kind=3,this.affinity=0}equals(u){return this.kind===u.kind}asString(){return"Remote"}}e.RemoteRunningLocation=N;class D{constructor(u){this.dependency=u}}e.MissingExtensionDependency=D;var m;(function(s){s[s.LocalProcess=1]="LocalProcess",s[s.LocalWebWorker=2]="LocalWebWorker",s[s.Remote=3]="Remote"})(m=e.ExtensionHostKind||(e.ExtensionHostKind={}));function p(s){if(s===null)return"None";switch(s){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=p;class f{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(u,n){const h=[],g=[],P=[],M=[],j=l(this.c),Z=l(u),G=(B,z)=>B.extensionLocation.toString()===z.extensionLocation.toString()||B.isBuiltin===z.isBuiltin||B.isUserBuiltin===z.isUserBuiltin||B.isUnderDevelopment===z.isUnderDevelopment;for(const B of this.c){const z=Z.get(L.ExtensionIdentifier.toKey(B.identifier));if(!z){h.push(B.identifier),j.delete(L.ExtensionIdentifier.toKey(B.identifier));continue}if(!G(B,z)){h.push(B.identifier),j.delete(L.ExtensionIdentifier.toKey(B.identifier));continue}}for(const B of u){const z=j.get(L.ExtensionIdentifier.toKey(B.identifier));if(!z){g.push(B);continue}if(!G(z,B)){h.push(z.identifier),j.delete(L.ExtensionIdentifier.toKey(z.identifier));continue}}const A=c(this.d),R=c(n);for(const B of this.d)R.has(L.ExtensionIdentifier.toKey(B))||P.push(B);for(const B of n)A.has(L.ExtensionIdentifier.toKey(B))||M.push(B);const F={toRemove:h,toAdd:g,myToRemove:P,myToAdd:M};return this.delta(F),F}delta(u){const{toRemove:n,toAdd:h,myToRemove:g,myToAdd:P}=u,M=c(n),j=c(g);for(let Z=0;Z<this.c.length;Z++)M.has(L.ExtensionIdentifier.toKey(this.c[Z].identifier))&&(this.c.splice(Z,1),Z--);for(let Z=0;Z<this.d.length;Z++)j.has(L.ExtensionIdentifier.toKey(this.d[Z]))&&(this.d.splice(Z,1),Z--);for(const Z of h)this.c.push(Z);for(const Z of P)this.d.push(Z)}containsExtension(u){for(const n of this.d)if(L.ExtensionIdentifier.equals(n,u))return!0;return!1}}e.ExtensionHostExtensions=f;class t{constructor(u){if(this[O]="ExtensionIdentifierSet",this.c=new Map,this.d=L.ExtensionIdentifier.toKey,u)for(const n of u)this.add(n)}get size(){return this.c.size}add(u){return this.c.set(this.d(u),u),this}clear(){this.c.clear()}delete(u){return this.c.delete(this.d(u))}has(u){return this.c.has(this.d(u))}forEach(u,n){this.c.forEach(h=>u.call(n,h,h,this))}*entries(){for(const[u,n]of this.c)yield[n,n]}keys(){return this.c.values()}values(){return this.c.values()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=t;function c(s){const u=new Set;for(const n of s)u.add(L.ExtensionIdentifier.toKey(n));return u}e.extensionIdentifiersArrayToSet=c;function l(s){const u=new Map;for(const n of s)u.set(L.ExtensionIdentifier.toKey(n.identifier),n);return u}function v(s,u){return s.enabledApiProposals?s.enabledApiProposals.includes(u):!1}e.isProposedApiEnabled=v;function b(s,u){if(!v(s,u))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${u}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${u}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}e.checkProposedApiEnabled=b;class E{constructor(u,n,h,g){this.codeLoadingTime=u,this.activateCallTime=n,this.activateResolvedTime=h,this.activationReason=g}}e.ActivationTimes=E;class w{constructor(u,n){this.description=u,this.value=n}}e.ExtensionPointContribution=w,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var r;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(r=e.ActivationKind||(e.ActivationKind={}));function a(s){return{type:s.isBuiltin?0:1,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,k.getGalleryExtensionId)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}e.toExtension=a;function o(s,u){return{identifier:new L.ExtensionIdentifier((0,k.getExtensionId)(s.manifest.publisher,s.manifest.name)),isBuiltin:s.type===0,isUserBuiltin:s.type===1&&s.isBuiltin,isUnderDevelopment:!!u,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform,browserNlsBundleUris:s.browserNlsBundleUris}}e.toExtensionDescription=o;class d{constructor(){this.onDidRegisterExtensions=i.Event.None,this.onDidChangeExtensionsStatus=i.Event.None,this.onDidChangeExtensions=i.Event.None,this.onWillActivateByEvent=i.Event.None,this.onDidChangeResponsiveChange=i.Event.None,this.extensions=[]}activateByEvent(u){return Promise.resolve(void 0)}activationEventIsDone(u){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(u,n){return Promise.resolve(0)}getInspectPorts(u,n){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=d}),define(ke[182],Ce([1,0,11,96,25,26,12,14]),function(ee,e,i,T,y,L,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class S{constructor(l,v,b,E){this.startup=l,this.codeLoadingTime=v,this.activateCallTime=b,this.activateResolvedTime=E}}e.ExtensionActivationTimes=S,S.NONE=new S(!1,-1,-1,-1);class C{constructor(l){this.a=l,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(l,v){return l===-1||v===-1?-1:v-l}build(){return new S(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=C;class N{constructor(l,v,b,E,w,r){this.activationFailed=l,this.activationFailedError=v,this.activationTimes=b,this.module=E,this.exports=w,this.subscriptions=r}}e.ActivatedExtension=N;class D extends N{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=D;class m extends N{constructor(){super(!1,null,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=m;class p extends N{constructor(l){super(!0,l,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let f=class{constructor(l,v,b,E){this.g=E,this.a=l,this.b=v,this.c=b,this.d=new Map,this.f=Object.create(null)}dispose(){for(const[l,v]of this.d)v.dispose()}isActivated(l){const v=this.d.get(y.ExtensionIdentifier.toKey(l));return Boolean(v&&v.value)}getActivatedExtension(l){const v=this.d.get(y.ExtensionIdentifier.toKey(l));if(!v||!v.value)throw new Error(`Extension '${l.value}' is not known or not activated`);return v.value}async activateByEvent(l,v){if(this.f[l])return;const b=this.a.getExtensionDescriptionsForActivationEvent(l);await this.h(b.map(E=>({id:E.identifier,reason:{startup:v,extensionId:E.identifier,activationEvent:l}}))),this.f[l]=!0}activateById(l,v){const b=this.a.getExtensionDescription(l);if(!b)throw new Error(`Extension '${l}' is not known`);return this.h([{id:b.identifier,reason:v}])}async h(l){const v=l.filter(b=>!this.isActivated(b.id)).map(b=>this.j(b));await Promise.all(v.map(b=>b.wait()))}j(l){if(this.d.has(y.ExtensionIdentifier.toKey(l.id)))return this.d.get(y.ExtensionIdentifier.toKey(l.id));if(this.l(l.id))return this.k(l,null,[],null);const v=this.a.getExtensionDescription(l.id);if(!v){const w=new Error(`Cannot activate unknown extension '${l.id.value}'`),r=this.k(l,null,[],new p(w));return this.c.onExtensionActivationError(l.id,w,new L.MissingExtensionDependency(l.id.value)),r}const b=[],E=typeof v.extensionDependencies>"u"?[]:v.extensionDependencies;for(const w of E){if(this.m(w))continue;const r=this.d.get(y.ExtensionIdentifier.toKey(w));if(r){b.push(r);continue}if(this.l(w)){b.push(this.j({id:this.b.getExtensionDescription(w).identifier,reason:l.reason}));continue}const a=this.a.getExtensionDescription(w);if(a){if(!a.main&&!a.browser)continue;b.push(this.j({id:a.identifier,reason:l.reason}));continue}const o=v.displayName||v.identifier.value,d=new Error(`Cannot activate the '${o}' extension because it depends on unknown extension '${w}'`),s=this.k(l,v.displayName,[],new p(d));return this.c.onExtensionActivationError(v.identifier,d,new L.MissingExtensionDependency(w)),s}return this.k(l,v.displayName,b,null)}k(l,v,b,E){const w=new t(l.id,v,l.reason,b,E,this.c,this.g);return this.d.set(y.ExtensionIdentifier.toKey(l.id),w),w}l(l){return T.ExtensionDescriptionRegistry.isHostExtension(l,this.a,this.b)}m(l){const v=this.b.getExtensionDescription(l);return v?!v.main&&!v.browser:!1}};f=qe([Ve(3,k.ILogService)],f),e.ExtensionsActivator=f;let t=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(l,v,b,E,w,r,a){this.c=l,this.d=v,this.f=b,this.g=E,this.h=w,this.j=r,this.k=a,this.a=new O.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let l=0;l<this.g.length;l++){const v=this.g[l];if(v.value&&!v.value.activationFailed){this.g.splice(l,1),l--;continue}if(v.value&&v.value.activationFailed){const b=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${v.friendlyName}' failed to activate`);b.detail=v.value.activationFailedError,this.h=new p(b),this.j.onExtensionActivationError(this.c,b,null);return}}this.g.length>0&&await Promise.race(this.g.map(l=>l.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(l){const v=new Error;if(l&&l.name&&(v.name=l.name),l&&l.message?v.message=`Activating extension '${this.c.value}' failed: ${l.message}.`:v.message=`Activating extension '${this.c.value}' failed: ${l}.`,l&&l.stack&&(v.stack=l.stack),this.h=new p(v),this.b&&i.isCancellationError(l))return;this.j.onExtensionActivationError(this.c,v,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(l)}}};t=qe([Ve(6,k.ILogService)],t)}),define(ke[183],Ce([1,0,12,27,26]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let L=class extends i.LogService{constructor(O,S){super(O.createLogger(S.logFile,{name:y.ExtensionHostLogFileName}))}};L=qe([Ve(0,i.ILoggerService),Ve(1,T.IExtHostInitDataService)],L),e.ExtHostLogService=L});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(ke[6],Ce([1,0,16,11,83,28,62,10,9,2,34,36,92,67,26]),function(ee,e,i,T,y,L,k,O,S,C,N,D,m,p,f){"use strict";var t,c,l,v,b,E,w,r,a,o,d,s,u,n,h,g,P,M,j,Z,G,A,R;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function F(W){return Object.assign(W,{apply:function(){const te=arguments.length===1?[]:arguments[1];return Reflect.construct(W,te,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(W,[]);{const[te,...be]=arguments;return Reflect.construct(W,be,te.constructor)}}})}var B;(function(W){W[W.Top=0]="Top",W[W.Bottom=1]="Bottom"})(B=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var z;(function(W){W[W.Command=0]="Command",W[W.Opener=1]="Opener"})(z=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let V=E=class{static from(...U){let te=U;return new E(function(){if(te){for(const be of te)be&&typeof be.dispose=="function"&&be.dispose();te=void 0}})}constructor(U){t.set(this,void 0),Je(this,t,U,"f")}dispose(){typeof Oe(this,t,"f")=="function"&&(Oe(this,t,"f").call(this),Je(this,t,void 0,"f"))}};t=new WeakMap,V=E=qe([F],V),e.Disposable=V;let K=w=class{static Min(...U){if(U.length===0)throw new TypeError;let te=U[0];for(let be=1;be<U.length;be++){const Ke=U[be];Ke.isBefore(te)&&(te=Ke)}return te}static Max(...U){if(U.length===0)throw new TypeError;let te=U[0];for(let be=1;be<U.length;be++){const Ke=U[be];Ke.isAfter(te)&&(te=Ke)}return te}static isPosition(U){if(!U)return!1;if(U instanceof w)return!0;const{line:te,character:be}=U;return typeof te=="number"&&typeof be=="number"}static of(U){if(U instanceof w)return U;if(this.isPosition(U))return new w(U.line,U.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(U,te){if(U<0)throw(0,T.illegalArgument)("line must be non-negative");if(te<0)throw(0,T.illegalArgument)("character must be non-negative");this.c=U,this.e=te}isBefore(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<U.e}isBeforeOrEqual(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<=U.e}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this.c===U.c&&this.e===U.e}compareTo(U){return this.c<U.c?-1:this.c>U.line?1:this.e<U.e?-1:this.e>U.e?1:0}translate(U,te=0){if(U===null||te===null)throw(0,T.illegalArgument)();let be;return typeof U>"u"?be=0:typeof U=="number"?be=U:(be=typeof U.lineDelta=="number"?U.lineDelta:0,te=typeof U.characterDelta=="number"?U.characterDelta:0),be===0&&te===0?this:new w(this.line+be,this.character+te)}with(U,te=this.character){if(U===null||te===null)throw(0,T.illegalArgument)();let be;return typeof U>"u"?be=this.line:typeof U=="number"?be=U:(be=typeof U.line=="number"?U.line:this.line,te=typeof U.character=="number"?U.character:this.character),be===this.line&&te===this.character?this:new w(be,te)}toJSON(){return{line:this.line,character:this.character}}};K=w=qe([F],K),e.Position=K;let ie=r=class{static isRange(U){return U instanceof r?!0:U?K.isPosition(U.start)&&K.isPosition(U.end):!1}static of(U){if(U instanceof r)return U;if(this.isRange(U))return new r(U.start,U.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(U,te,be,Ke){let Ye,ot;if(typeof U=="number"&&typeof te=="number"&&typeof be=="number"&&typeof Ke=="number"?(Ye=new K(U,te),ot=new K(be,Ke)):K.isPosition(U)&&K.isPosition(te)&&(Ye=K.of(U),ot=K.of(te)),!Ye||!ot)throw new Error("Invalid arguments");Ye.isBefore(ot)?(this.c=Ye,this.e=ot):(this.c=ot,this.e=Ye)}contains(U){return r.isRange(U)?this.contains(U.start)&&this.contains(U.end):K.isPosition(U)?!(K.of(U).isBefore(this.c)||this.e.isBefore(U)):!1}isEqual(U){return this.c.isEqual(U.c)&&this.e.isEqual(U.e)}intersection(U){const te=K.Max(U.start,this.c),be=K.Min(U.end,this.e);if(!te.isAfter(be))return new r(te,be)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const te=K.Min(U.start,this.c),be=K.Max(U.end,this.end);return new r(te,be)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(U,te=this.end){if(U===null||te===null)throw(0,T.illegalArgument)();let be;return U?K.isPosition(U)?be=U:(be=U.start||this.start,te=U.end||this.end):be=this.start,be.isEqual(this.c)&&te.isEqual(this.end)?this:new r(be,te)}toJSON(){return[this.start,this.end]}};ie=r=qe([F],ie),e.Range=ie;let me=a=class extends ie{static isSelection(U){return U instanceof a?!0:U?ie.isRange(U)&&K.isPosition(U.anchor)&&K.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(U,te,be,Ke){let Ye,ot;if(typeof U=="number"&&typeof te=="number"&&typeof be=="number"&&typeof Ke=="number"?(Ye=new K(U,te),ot=new K(be,Ke)):K.isPosition(U)&&K.isPosition(te)&&(Ye=K.of(U),ot=K.of(te)),!Ye||!ot)throw new Error("Invalid arguments");super(Ye,ot),this.f=Ye,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};me=a=qe([F],me),e.Selection=me;class ue{constructor(U,te,be){if(typeof U!="string"||U.length===0)throw(0,T.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,T.illegalArgument)("port");if(typeof be<"u"&&(typeof be!="string"||be.length===0||!/^[0-9A-Za-z_\-]+$/.test(be)))throw(0,T.illegalArgument)("connectionToken");this.host=U,this.port=Math.round(te),this.connectionToken=be}}e.ResolvedAuthority=ue;class oe extends Error{static NotAvailable(U,te){return new oe(U,m.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(U){return new oe(U,m.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(U,te=m.RemoteAuthorityResolverErrorCode.Unknown,be){super(U),this._message=U,this._code=te,this._detail=be,Object.setPrototypeOf(this,oe.prototype)}}e.RemoteAuthorityResolverError=oe;var De;(function(W){W[W.LF=1]="LF",W[W.CRLF=2]="CRLF"})(De=e.EndOfLine||(e.EndOfLine={}));var re;(function(W){W[W.Replace=1]="Replace",W[W.Append=2]="Append",W[W.Prepend=3]="Prepend"})(re=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let Q=o=class{static isTextEdit(U){return U instanceof o?!0:U?ie.isRange(U)&&typeof U.newText=="string":!1}static replace(U,te){return new o(U,te)}static insert(U,te){return o.replace(new ie(U,U),te)}static delete(U){return o.replace(U,"")}static setEndOfLine(U){const te=new o(new ie(new K(0,0),new K(0,0)),"");return te.newEol=U,te}get range(){return this.c}set range(U){if(U&&!ie.isRange(U))throw(0,T.illegalArgument)("range");this.c=U}get newText(){return this.e||""}set newText(U){if(U&&typeof U!="string")throw(0,T.illegalArgument)("newText");this.e=U}get newEol(){return this.f}set newEol(U){if(U&&typeof U!="number")throw(0,T.illegalArgument)("newEol");this.f=U}constructor(U,te){this.c=U,this.e=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};Q=o=qe([F],Q),e.TextEdit=Q;let le=d=class{static isNotebookCellEdit(U){return U instanceof d?!0:U?Kt.isNotebookRange(U)&&Array.isArray(U.newCells):!1}static replaceCells(U,te){return new d(U,te)}static insertCells(U,te){return new d(new Kt(U,U),te)}static deleteCells(U){return new d(U,[])}static updateCellMetadata(U,te){const be=new d(new Kt(U,U),[]);return be.newCellMetadata=te,be}static updateNotebookMetadata(U){const te=new d(new Kt(0,0),[]);return te.newNotebookMetadata=U,te}constructor(U,te){this.range=U,this.newCells=te}};le=d=qe([F],le),e.NotebookEdit=le;class Ee{static isSnippetTextEdit(U){return U instanceof Ee?!0:U?ie.isRange(U.range)&&xe.isSnippetString(U.snippet):!1}static replace(U,te){return new Ee(U,te)}static insert(U,te){return Ee.replace(new ie(U,U),te)}constructor(U,te){this.range=U,this.snippet=te}}e.SnippetTextEdit=Ee;var Ae;(function(W){W[W.File=1]="File",W[W.Text=2]="Text",W[W.Cell=3]="Cell",W[W.CellReplace=5]="CellReplace",W[W.Snippet=6]="Snippet"})(Ae=e.FileEditType||(e.FileEditType={}));let Be=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(U,te,be,Ke){this.c.push({_type:1,from:U,to:te,options:be,metadata:Ke})}createFile(U,te,be){this.c.push({_type:1,from:void 0,to:U,options:te,metadata:be})}deleteFile(U,te,be){this.c.push({_type:1,from:U,to:void 0,options:te,metadata:be})}e(U,te,be){this.c.push({_type:3,metadata:be,uri:U,edit:{editType:5,metadata:te},notebookMetadata:te})}f(U,te,be,Ke){const Ye=te.start,ot=te.end;(Ye!==ot||be.length>0)&&this.c.push({_type:5,uri:U,index:Ye,count:ot-Ye,cells:be,metadata:Ke})}g(U,te,be,Ke){this.c.push({_type:3,metadata:Ke,uri:U,edit:{editType:8,index:te,metadata:be}})}replace(U,te,be,Ke){this.c.push({_type:2,uri:U,edit:new Q(te,be),metadata:Ke})}insert(U,te,be,Ke){this.replace(U,new ie(te,te),be,Ke)}delete(U,te,be){this.replace(U,te,"",be)}has(U){return this.c.some(te=>te._type===2&&te.uri.toString()===U.toString())}set(U,te){if(te)for(const be of te){if(!be)continue;let Ke,Ye;if(Array.isArray(be)?(Ke=be[0],Ye=be[1]):Ke=be,le.isNotebookCellEdit(Ke)){if(U.scheme===p.CellUri.scheme)throw new Error("set must be called with a notebook document URI, not a cell URI.");Ke.newCellMetadata?this.g(U,Ke.range.start,Ke.newCellMetadata,Ye):Ke.newNotebookMetadata?this.e(U,Ke.newNotebookMetadata,Ye):this.f(U,Ke.range,Ke.newCells,Ye)}else Ee.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:U,range:Ke.range,edit:Ke.snippet,metadata:Ye}):this.c.push({_type:2,uri:U,edit:Ke,metadata:Ye})}else{for(let be=0;be<this.c.length;be++){const Ke=this.c[be];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===U.toString()&&(this.c[be]=void 0);break}}(0,i.coalesceInPlace)(this.c)}}get(U){const te=[];for(const be of this.c)be._type===2&&be.uri.toString()===U.toString()&&te.push(be.edit);return te}entries(){const U=new L.ResourceMap;for(const te of this.c)if(te._type===2){let be=U.get(te.uri);be||(be=[te.uri,[]],U.set(te.uri,be)),be[1].push(te.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Be=qe([F],Be),e.WorkspaceEdit=Be;let xe=s=class{static isSnippetString(U){return U instanceof s?!0:U?typeof U.value=="string":!1}static c(U){return U.replace(/\$|}|\\/g,"\\$&")}constructor(U){this.e=1,this.value=U||""}appendText(U){return this.value+=s.c(U),this}appendTabstop(U=this.e++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,te=this.e++){if(typeof U=="function"){const be=new s;be.e=this.e,U(be),this.e=be.e,U=be.value}else U=s.c(U);return this.value+="${",this.value+=te,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,te=this.e++){const be=U.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=be,this.value+="|}",this}appendVariable(U,te){if(typeof te=="function"){const be=new s;be.e=this.e,te(be),this.e=be.e,te=be.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,te&&(this.value+=":",this.value+=te),this.value+="}",this}};xe=s=qe([F],xe),e.SnippetString=xe;var Te;(function(W){W[W.Unnecessary=1]="Unnecessary",W[W.Deprecated=2]="Deprecated"})(Te=e.DiagnosticTag||(e.DiagnosticTag={}));var Ie;(function(W){W[W.Hint=3]="Hint",W[W.Information=2]="Information",W[W.Warning=1]="Warning",W[W.Error=0]="Error"})(Ie=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Se=u=class{static isLocation(U){return U instanceof u?!0:U?ie.isRange(U.range)&&C.URI.isUri(U.uri):!1}constructor(U,te){if(this.uri=U,te)if(ie.isRange(te))this.range=ie.of(te);else if(K.isPosition(te))this.range=new ie(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};Se=u=qe([F],Se),e.Location=Se;let se=class{static is(U){return U?typeof U.message=="string"&&U.location&&ie.isRange(U.location.range)&&C.URI.isUri(U.location.uri):!1}constructor(U,te){this.location=U,this.message=te}static isEqual(U,te){return U===te?!0:!U||!te?!1:U.message===te.message&&U.location.range.isEqual(te.location.range)&&U.location.uri.toString()===te.location.uri.toString()}};se=qe([F],se),e.DiagnosticRelatedInformation=se;let ce=class{constructor(U,te,be=Ie.Error){if(!ie.isRange(U))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=U,this.message=te,this.severity=be}toJSON(){return{severity:Ie[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,te){return U===te?!0:!U||!te?!1:U.message===te.message&&U.severity===te.severity&&U.code===te.code&&U.severity===te.severity&&U.source===te.source&&U.range.isEqual(te.range)&&(0,i.equals)(U.tags,te.tags)&&(0,i.equals)(U.relatedInformation,te.relatedInformation,se.isEqual)}};ce=qe([F],ce),e.Diagnostic=ce;let Y=class{constructor(U,te){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=te}};Y=qe([F],Y),e.Hover=Y;var I;(function(W){W[W.Text=0]="Text",W[W.Read=1]="Read",W[W.Write=2]="Write"})(I=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let $=class{constructor(U,te=I.Text){this.range=U,this.kind=te}toJSON(){return{range:this.range,kind:I[this.kind]}}};$=qe([F],$),e.DocumentHighlight=$;var H;(function(W){W[W.File=0]="File",W[W.Module=1]="Module",W[W.Namespace=2]="Namespace",W[W.Package=3]="Package",W[W.Class=4]="Class",W[W.Method=5]="Method",W[W.Property=6]="Property",W[W.Field=7]="Field",W[W.Constructor=8]="Constructor",W[W.Enum=9]="Enum",W[W.Interface=10]="Interface",W[W.Function=11]="Function",W[W.Variable=12]="Variable",W[W.Constant=13]="Constant",W[W.String=14]="String",W[W.Number=15]="Number",W[W.Boolean=16]="Boolean",W[W.Array=17]="Array",W[W.Object=18]="Object",W[W.Key=19]="Key",W[W.Null=20]="Null",W[W.EnumMember=21]="EnumMember",W[W.Struct=22]="Struct",W[W.Event=23]="Event",W[W.Operator=24]="Operator",W[W.TypeParameter=25]="TypeParameter"})(H=e.SymbolKind||(e.SymbolKind={}));var q;(function(W){W[W.Deprecated=1]="Deprecated"})(q=e.SymbolTag||(e.SymbolTag={}));let J=n=class{static validate(U){if(!U.name)throw new Error("name must not be falsy")}constructor(U,te,be,Ke,Ye){this.name=U,this.kind=te,this.containerName=Ye,typeof be=="string"&&(this.containerName=be),Ke instanceof Se?this.location=Ke:be instanceof ie&&(this.location=new Se(Ke,be)),n.validate(this)}toJSON(){return{name:this.name,kind:H[this.kind],location:this.location,containerName:this.containerName}}};J=n=qe([F],J),e.SymbolInformation=J;let de=h=class{static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children?.forEach(h.validate)}constructor(U,te,be,Ke,Ye){this.name=U,this.detail=te,this.kind=be,this.range=Ke,this.selectionRange=Ye,this.children=[],h.validate(this)}};de=h=qe([F],de),e.DocumentSymbol=de;var we;(function(W){W[W.Invoke=1]="Invoke",W[W.Automatic=2]="Automatic"})(we=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(U,te){this.title=U,this.kind=te}};ae=qe([F],ae),e.CodeAction=ae;let pe=g=class{constructor(U){this.value=U}append(U){return new g(this.value?this.value+g.c+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+g.c)}};pe.c=".",pe=g=qe([F],pe),e.CodeActionKind=pe,pe.Empty=new pe(""),pe.QuickFix=pe.Empty.append("quickfix"),pe.Refactor=pe.Empty.append("refactor"),pe.RefactorExtract=pe.Refactor.append("extract"),pe.RefactorInline=pe.Refactor.append("inline"),pe.RefactorMove=pe.Refactor.append("move"),pe.RefactorRewrite=pe.Refactor.append("rewrite"),pe.Source=pe.Empty.append("source"),pe.SourceOrganizeImports=pe.Source.append("organizeImports"),pe.SourceFixAll=pe.Source.append("fixAll");let ve=class{constructor(U,te){if(this.range=U,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ve=qe([F],ve),e.SelectionRange=ve;class We{constructor(U,te,be,Ke,Ye,ot){this.kind=U,this.name=te,this.detail=be,this.uri=Ke,this.range=Ye,this.selectionRange=ot}}e.CallHierarchyItem=We;class He{constructor(U,te){this.fromRanges=te,this.from=U}}e.CallHierarchyIncomingCall=He;class tt{constructor(U,te){this.fromRanges=te,this.to=U}}e.CallHierarchyOutgoingCall=tt;var Xe;(function(W){W[W.Information=0]="Information",W[W.Warning=1]="Warning",W[W.Error=2]="Error"})(Xe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(U,te){this.range=U,this.command=te}get isResolved(){return!!this.command}};et=qe([F],et),e.CodeLens=et;let it=P=class{static isMarkdownString(U){return U instanceof P?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}constructor(U,te=!1){c.set(this,void 0),Je(this,c,new y.MarkdownString(U,{supportThemeIcons:te}),"f")}get value(){return Oe(this,c,"f").value}set value(U){Oe(this,c,"f").value=U}get isTrusted(){return Oe(this,c,"f").isTrusted}set isTrusted(U){Oe(this,c,"f").isTrusted=U}get supportThemeIcons(){return Oe(this,c,"f").supportThemeIcons}set supportThemeIcons(U){Oe(this,c,"f").supportThemeIcons=U}get supportHtml(){return Oe(this,c,"f").supportHtml}set supportHtml(U){Oe(this,c,"f").supportHtml=U}get baseUri(){return Oe(this,c,"f").baseUri}set baseUri(U){Oe(this,c,"f").baseUri=U}appendText(U){return Oe(this,c,"f").appendText(U),this}appendMarkdown(U){return Oe(this,c,"f").appendMarkdown(U),this}appendCodeblock(U,te){return Oe(this,c,"f").appendCodeblock(te??"",U),this}};c=new WeakMap,it=P=qe([F],it),e.MarkdownString=it;let dt=class{constructor(U,te){this.label=U,this.documentation=te}};dt=qe([F],dt),e.ParameterInformation=dt;let Fe=class{constructor(U,te){this.label=U,this.documentation=te,this.parameters=[]}};Fe=qe([F],Fe),e.SignatureInformation=Fe;let st=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};st=qe([F],st),e.SignatureHelp=st;var _;(function(W){W[W.Invoke=1]="Invoke",W[W.TriggerCharacter=2]="TriggerCharacter",W[W.ContentChange=3]="ContentChange"})(_=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var X;(function(W){W[W.Type=1]="Type",W[W.Parameter=2]="Parameter"})(X=e.InlayHintKind||(e.InlayHintKind={}));let ge=class{constructor(U){this.value=U}};ge=qe([F],ge),e.InlayHintLabelPart=ge;let Me=class{constructor(U,te,be){this.position=U,this.label=te,this.kind=be}};Me=qe([F],Me),e.InlayHint=Me;var $e;(function(W){W[W.Invoke=0]="Invoke",W[W.TriggerCharacter=1]="TriggerCharacter",W[W.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})($e=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var je;(function(W){W[W.Text=0]="Text",W[W.Method=1]="Method",W[W.Function=2]="Function",W[W.Constructor=3]="Constructor",W[W.Field=4]="Field",W[W.Variable=5]="Variable",W[W.Class=6]="Class",W[W.Interface=7]="Interface",W[W.Module=8]="Module",W[W.Property=9]="Property",W[W.Unit=10]="Unit",W[W.Value=11]="Value",W[W.Enum=12]="Enum",W[W.Keyword=13]="Keyword",W[W.Snippet=14]="Snippet",W[W.Color=15]="Color",W[W.File=16]="File",W[W.Reference=17]="Reference",W[W.Folder=18]="Folder",W[W.EnumMember=19]="EnumMember",W[W.Constant=20]="Constant",W[W.Struct=21]="Struct",W[W.Event=22]="Event",W[W.Operator=23]="Operator",W[W.TypeParameter=24]="TypeParameter",W[W.User=25]="User",W[W.Issue=26]="Issue"})(je=e.CompletionItemKind||(e.CompletionItemKind={}));var _e;(function(W){W[W.Deprecated=1]="Deprecated"})(_e=e.CompletionItemTag||(e.CompletionItemTag={}));let nt=class{constructor(U,te){this.label=U,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&je[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};nt=qe([F],nt),e.CompletionItem=nt;let wt=class{constructor(U=[],te=!1){this.items=U,this.isIncomplete=te}};wt=qe([F],wt),e.CompletionList=wt;let St=class{constructor(U,te,be){this.insertText=U,this.range=te,this.command=be}};St=qe([F],St),e.InlineSuggestion=St;let kt=class{constructor(U){this.commands=void 0,this.items=U}};kt=qe([F],kt),e.InlineSuggestionList=kt;var lt;(function(W){W[W.Active=-1]="Active",W[W.Beside=-2]="Beside",W[W.One=1]="One",W[W.Two=2]="Two",W[W.Three=3]="Three",W[W.Four=4]="Four",W[W.Five=5]="Five",W[W.Six=6]="Six",W[W.Seven=7]="Seven",W[W.Eight=8]="Eight",W[W.Nine=9]="Nine"})(lt=e.ViewColumn||(e.ViewColumn={}));var at;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(at=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Bt;(function(W){W[W.Off=0]="Off",W[W.On=1]="On",W[W.Relative=2]="Relative"})(Bt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ot;(function(W){W[W.Manual=1]="Manual",W[W.AfterDelay=2]="AfterDelay",W[W.FocusOut=3]="FocusOut"})(Ot=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ft;(function(W){W[W.Default=0]="Default",W[W.InCenter=1]="InCenter",W[W.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",W[W.AtTop=3]="AtTop"})(Ft=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ft;(function(W){W[W.Keyboard=1]="Keyboard",W[W.Mouse=2]="Mouse",W[W.Command=3]="Command"})(ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Dt;(function(W){W[W.Undo=1]="Undo",W[W.Redo=2]="Redo"})(Dt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var $t;(function(W){W[W.OpenOpen=0]="OpenOpen",W[W.ClosedClosed=1]="ClosedClosed",W[W.OpenClosed=2]="OpenClosed",W[W.ClosedOpen=3]="ClosedOpen"})($t=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(W){function U(te){switch(te){case"keyboard":return W.Keyboard;case"mouse":return W.Mouse;case"api":return W.Command}}W.fromValue=U}(ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Nt=class{constructor(U,te){if(te&&!C.URI.isUri(te))throw(0,T.illegalArgument)("target");if(!ie.isRange(U)||U.isEmpty)throw(0,T.illegalArgument)("range");this.range=U,this.target=te}};Nt=qe([F],Nt),e.DocumentLink=Nt;let Ge=class{constructor(U,te,be,Ke){this.red=U,this.green=te,this.blue=be,this.alpha=Ke}};Ge=qe([F],Ge),e.Color=Ge;let Mt=class{constructor(U,te){if(te&&!(te instanceof Ge))throw(0,T.illegalArgument)("color");if(!ie.isRange(U)||U.isEmpty)throw(0,T.illegalArgument)("range");this.range=U,this.color=te}};Mt=qe([F],Mt),e.ColorInformation=Mt;let Lt=class{constructor(U){if(!U||typeof U!="string")throw(0,T.illegalArgument)("label");this.label=U}};Lt=qe([F],Lt),e.ColorPresentation=Lt;var Ut;(function(W){W[W.RGB=0]="RGB",W[W.HEX=1]="HEX",W[W.HSL=2]="HSL"})(Ut=e.ColorFormat||(e.ColorFormat={}));var mt;(function(W){W[W.Error=0]="Error",W[W.Warning=1]="Warning",W[W.Information=2]="Information"})(mt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Ct;(function(W){W[W.Unknown=0]="Unknown",W[W.Shutdown=1]="Shutdown",W[W.Process=2]="Process",W[W.User=3]="User",W[W.Extension=4]="Extension"})(Ct=e.TerminalExitReason||(e.TerminalExitReason={}));class ye{constructor(U,te,be){if(this.startIndex=U,this.length=te,this.tooltip=be,typeof U!="number"||U<0)throw(0,T.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,T.illegalArgument)("length");if(be!==void 0&&typeof be!="string")throw(0,T.illegalArgument)("tooltip")}}e.TerminalLink=ye;class Pe{constructor(U){this.uri=U}}e.TerminalQuickFixOpener=Pe;class fe{constructor(U){this.terminalCommand=U}}e.TerminalQuickFixCommand=fe;var x;(function(W){W[W.Panel=1]="Panel",W[W.Editor=2]="Editor"})(x=e.TerminalLocation||(e.TerminalLocation={}));class Re{constructor(U){if(this.options=U,typeof U!="object")throw(0,T.illegalArgument)("options")}}e.TerminalProfile=Re;var Le;(function(W){W[W.Always=1]="Always",W[W.Silent=2]="Silent",W[W.Never=3]="Never"})(Le=e.TaskRevealKind||(e.TaskRevealKind={}));var Qe;(function(W){W[W.Shared=1]="Shared",W[W.Dedicated=2]="Dedicated",W[W.New=3]="New"})(Qe=e.TaskPanelKind||(e.TaskPanelKind={}));let ze=M=class{static from(U){switch(U){case"clean":return M.Clean;case"build":return M.Build;case"rebuild":return M.Rebuild;case"test":return M.Test;default:return}}constructor(U,te){if(this.label=te,typeof U!="string"||typeof te!="string")throw(0,T.illegalArgument)("name");this.c=U}get id(){return this.c}};ze.Clean=new M("clean","Clean"),ze.Build=new M("build","Build"),ze.Rebuild=new M("rebuild","Rebuild"),ze.Test=new M("test","Test"),ze=M=qe([F],ze),e.TaskGroup=ze;function Ze(W){let U="";for(let te=0;te<W.length;te++)U+=W[te].replace(/,/g,",,")+",";return U}let bt=class{constructor(U,te,be){if(typeof U!="string")throw(0,T.illegalArgument)("process");this.e=[],this.c=U,te!==void 0&&(Array.isArray(te)?(this.e=te,this.f=be):this.f=te)}get process(){return this.c}set process(U){if(typeof U!="string")throw(0,T.illegalArgument)("process");this.c=U}get args(){return this.e}set args(U){Array.isArray(U)||(U=[]),this.e=U}get options(){return this.f}set options(U){this.f=U}computeId(){const U=[];if(U.push("process"),this.c!==void 0&&U.push(this.c),this.e&&this.e.length>0)for(const te of this.e)U.push(te);return Ze(U)}};bt=qe([F],bt),e.ProcessExecution=bt;let vt=class{constructor(U,te,be){if(this.f=[],Array.isArray(te)){if(!U)throw(0,T.illegalArgument)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,T.illegalArgument)("command");this.e=U,this.f=te,this.g=be}else{if(typeof U!="string")throw(0,T.illegalArgument)("commandLine");this.c=U,this.g=te}}get commandLine(){return this.c}set commandLine(U){if(typeof U!="string")throw(0,T.illegalArgument)("commandLine");this.c=U}get command(){return this.e?this.e:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,T.illegalArgument)("command");this.e=U}get args(){return this.f}set args(U){this.f=U||[]}get options(){return this.g}set options(U){this.g=U}computeId(){const U=[];if(U.push("shell"),this.c!==void 0&&U.push(this.c),this.e!==void 0&&U.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const te of this.f)U.push(typeof te=="string"?te:te.value);return Ze(U)}};vt=qe([F],vt),e.ShellExecution=vt;var At;(function(W){W[W.Escape=1]="Escape",W[W.Strong=2]="Strong",W[W.Weak=3]="Weak"})(At=e.ShellQuoting||(e.ShellQuoting={}));var pt;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace"})(pt=e.TaskScope||(e.TaskScope={}));class It{constructor(U){this.c=U}computeId(){return"customExecution"+(0,N.generateUuid)()}set callback(U){this.c=U}get callback(){return this.c}}e.CustomExecution=It;let ht=j=class{constructor(U,te,be,Ke,Ye,ot){this.j=!1,this.k=this.definition=U;let ut;typeof te=="string"?(this.m=this.name=te,this.t=this.source=be,this.execution=Ke,ut=Ye,this.j=!0):te===pt.Global||te===pt.Workspace?(this.target=te,this.m=this.name=be,this.t=this.source=Ke,this.execution=Ye,ut=ot):(this.target=te,this.m=this.name=be,this.t=this.source=Ke,this.execution=Ye,ut=ot),typeof ut=="string"?(this.o=[ut],this.q=!0):Array.isArray(ut)?(this.o=ut,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(U){this.h=U}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof bt?this.k={type:j.e,id:this.n.computeId()}:this.n instanceof vt?this.k={type:j.f,id:this.n.computeId()}:this.n instanceof It?this.k={type:j.c,id:this.n.computeId()}:this.k={type:j.g,id:(0,N.generateUuid)()}}get definition(){return this.k}set definition(U){if(U==null)throw(0,T.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=U}get scope(){return this.l}set target(U){this.y(),this.l=U}get name(){return this.m}set name(U){if(typeof U!="string")throw(0,T.illegalArgument)("name");this.y(),this.m=U}get execution(){return this.n}set execution(U){U===null&&(U=void 0),this.y(),this.n=U;const te=this.k.type;(j.g===te||j.e===te||j.f===te||j.c===te)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(U){if(Array.isArray(U))this.y(),this.o=U,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.y(),this.r=U}get source(){return this.t}set source(U){if(typeof U!="string"||U.length===0)throw(0,T.illegalArgument)("source must be a string of length > 0");this.y(),this.t=U}get group(){return this.u}set group(U){U===null&&(U=void 0),this.y(),this.u=U}get detail(){return this.x}set detail(U){U===null&&(U=void 0),this.x=U}get presentationOptions(){return this.v}set presentationOptions(U){U==null&&(U=Object.create(null)),this.y(),this.v=U}get runOptions(){return this.w}set runOptions(U){U==null&&(U=Object.create(null)),this.y(),this.w=U}};ht.c="customExecution",ht.e="process",ht.f="shell",ht.g="$empty",ht=j=qe([F],ht),e.Task=ht;var xt;(function(W){W[W.SourceControl=1]="SourceControl",W[W.Window=10]="Window",W[W.Notification=15]="Notification"})(xt=e.ProgressLocation||(e.ProgressLocation={}));var Vt;(function(W){function U(te){const be=te;return(0,S.isNumber)(be.value)?be.tooltip&&!(0,S.isString)(be.tooltip)?(console.log("INVALID view badge, invalid tooltip",be.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",be.value),!1)}W.isViewBadge=U})(Vt=e.ViewBadge||(e.ViewBadge={}));let Et=Z=class{static isTreeItem(U,te){if(U instanceof Z)return!0;const be=U;if(be.label!==void 0&&!(0,S.isString)(be.label)&&!be.label?.label)return console.log("INVALID tree item, invalid label",be.label),!1;if(be.id!==void 0&&!(0,S.isString)(be.id))return console.log("INVALID tree item, invalid id",be.id),!1;if(be.iconPath!==void 0&&!(0,S.isString)(be.iconPath)&&!C.URI.isUri(be.iconPath)&&(!be.iconPath||!(0,S.isString)(be.iconPath.id))){const Ke=be.iconPath;if(!Ke||!(0,S.isString)(Ke.light)&&!C.URI.isUri(Ke.light)&&!(0,S.isString)(Ke.dark)&&!C.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",be.iconPath),!1}if(be.description!==void 0&&!(0,S.isString)(be.description)&&typeof be.description!="boolean")return console.log("INVALID tree item, invalid description",be.description),!1;if(be.resourceUri!==void 0&&!C.URI.isUri(be.resourceUri))return console.log("INVALID tree item, invalid resourceUri",be.resourceUri),!1;if(be.tooltip!==void 0&&!(0,S.isString)(be.tooltip)&&!(be.tooltip instanceof it))return console.log("INVALID tree item, invalid tooltip",be.tooltip),!1;if(be.command!==void 0&&!be.command.command)return console.log("INVALID tree item, invalid command",be.command),!1;if(be.collapsibleState!==void 0&&be.collapsibleState<Qt.None&&be.collapsibleState>Qt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",be.collapsibleState),!1;if(be.contextValue!==void 0&&!(0,S.isString)(be.contextValue))return console.log("INVALID tree item, invalid contextValue",be.contextValue),!1;if(be.accessibilityInformation!==void 0&&!be.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",be.accessibilityInformation),!1;if(be.checkboxState!==void 0){(0,f.checkProposedApiEnabled)(te,"treeItemCheckbox");const Ke=(0,S.isNumber)(be.checkboxState)?be.checkboxState:(0,S.isObject)(be.checkboxState)&&(0,S.isNumber)(be.checkboxState.state)?be.checkboxState.state:void 0,Ye=!(0,S.isNumber)(be.checkboxState)&&(0,S.isObject)(be.checkboxState)?be.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==oi.Checked&&Ke!==oi.Unchecked||Ye!==void 0&&!(0,S.isString)(Ye))return console.log("INVALID tree item, invalid checkboxState",be.checkboxState),!1}return!0}constructor(U,te=Qt.None){this.collapsibleState=te,C.URI.isUri(U)?this.resourceUri=U:this.label=U}};Et=Z=qe([F],Et),e.TreeItem=Et;var Qt;(function(W){W[W.None=0]="None",W[W.Collapsed=1]="Collapsed",W[W.Expanded=2]="Expanded"})(Qt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var oi;(function(W){W[W.Unchecked=0]="Unchecked",W[W.Checked=1]="Checked"})(oi=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let Zt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(U,te){this.value=U,this.id=te??(0,N.generateUuid)()}};Zt=qe([F],Zt),e.DataTransferItem=Zt;let bi=class{constructor(U){l.set(this,new Map);for(const[te,be]of U??[]){const Ke=Oe(this,l,"f").get(te);Ke?Ke.push(be):Oe(this,l,"f").set(te,[be])}}get(U){return Oe(this,l,"f").get(U)?.[0]}set(U,te){Oe(this,l,"f").set(U,[te])}forEach(U,te){for(const[be,Ke]of Oe(this,l,"f"))for(const Ye of Ke)U.call(te,Ye,be,this)}*[(l=new WeakMap,Symbol.iterator)](){for(const[U,te]of Oe(this,l,"f"))for(const be of te)yield[U,be]}};bi=qe([F],bi),e.DataTransfer=bi;let Tt=class{constructor(U){this.insertText=U}};Tt=qe([F],Tt),e.DocumentDropEdit=Tt;let ai=class{constructor(U){this.insertText=U}};ai=qe([F],ai),e.DocumentPasteEdit=ai;let jt=class{constructor(U,te){this.id=U,this.color=te}static isThemeIcon(U){return typeof U.id!="string"?(console.log("INVALID ThemeIcon, invalid id",U.id),!1):!0}};jt=qe([F],jt),e.ThemeIcon=jt,jt.File=new jt("file"),jt.Folder=new jt("folder");let ei=class{constructor(U){this.id=U}};ei=qe([F],ei),e.ThemeColor=ei;var ci;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace",W[W.WorkspaceFolder=3]="WorkspaceFolder"})(ci=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ct=class{get base(){return this.c}set base(U){this.c=U,this.e=C.URI.file(U)}get baseUri(){return this.e}set baseUri(U){this.e=U,this.c=U.fsPath}constructor(U,te){if(typeof U!="string"&&(!U||!C.URI.isUri(U)&&!C.URI.isUri(U.uri)))throw(0,T.illegalArgument)("base");if(typeof te!="string")throw(0,T.illegalArgument)("pattern");typeof U=="string"?this.baseUri=C.URI.file(U):C.URI.isUri(U)?this.baseUri=U:this.baseUri=U.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ct=qe([F],ct),e.RelativePattern=ct;let ti=class{constructor(U,te,be,Ke){this.enabled=typeof U=="boolean"?U:!0,typeof te=="string"&&(this.condition=te),typeof be=="string"&&(this.hitCondition=be),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this.c||(this.c=(0,N.generateUuid)()),this.c}};ti=qe([F],ti),e.Breakpoint=ti;let qt=class extends ti{constructor(U,te,be,Ke,Ye){if(super(te,be,Ke,Ye),U===null)throw(0,T.illegalArgument)("location");this.location=U}};qt=qe([F],qt),e.SourceBreakpoint=qt;let _t=class extends ti{constructor(U,te,be,Ke,Ye){super(te,be,Ke,Ye),this.functionName=U}};_t=qe([F],_t),e.FunctionBreakpoint=_t;let ui=class extends ti{constructor(U,te,be,Ke,Ye,ot,ut){if(super(Ke,Ye,ot,ut),!te)throw(0,T.illegalArgument)("dataId");this.label=U,this.dataId=te,this.canPersist=be}};ui=qe([F],ui),e.DataBreakpoint=ui;let Ei=class{constructor(U,te,be){this.command=U,this.args=te||[],this.options=be}};Ei=qe([F],Ei),e.DebugAdapterExecutable=Ei;let li=class{constructor(U,te){this.port=U,this.host=te}};li=qe([F],li),e.DebugAdapterServer=li;let wi=class{constructor(U){this.path=U}};wi=qe([F],wi),e.DebugAdapterNamedPipeServer=wi;let di=class{constructor(U){this.implementation=U}};di=qe([F],di),e.DebugAdapterInlineImplementation=di;let ii=class{constructor(U,te){this.range=U,this.expression=te}};ii=qe([F],ii),e.EvaluatableExpression=ii;var Li;(function(W){W[W.Invoke=0]="Invoke",W[W.Automatic=1]="Automatic"})(Li=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let ni=class{constructor(U,te){this.range=U,this.text=te}};ni=qe([F],ni),e.InlineValueText=ni;let ri=class{constructor(U,te,be=!0){this.range=U,this.variableName=te,this.caseSensitiveLookup=be}};ri=qe([F],ri),e.InlineValueVariableLookup=ri;let Si=class{constructor(U,te){this.range=U,this.expression=te}};Si=qe([F],Si),e.InlineValueEvaluatableExpression=Si;let yi=class{constructor(U,te){this.frameId=U,this.stoppedLocation=te}};yi=qe([F],yi),e.InlineValueContext=yi;var si;(function(W){W[W.Changed=1]="Changed",W[W.Created=2]="Created",W[W.Deleted=3]="Deleted"})(si=e.FileChangeType||(e.FileChangeType={}));let Di=G=class extends Error{static FileExists(U){return new G(U,D.FileSystemProviderErrorCode.FileExists,G.FileExists)}static FileNotFound(U){return new G(U,D.FileSystemProviderErrorCode.FileNotFound,G.FileNotFound)}static FileNotADirectory(U){return new G(U,D.FileSystemProviderErrorCode.FileNotADirectory,G.FileNotADirectory)}static FileIsADirectory(U){return new G(U,D.FileSystemProviderErrorCode.FileIsADirectory,G.FileIsADirectory)}static NoPermissions(U){return new G(U,D.FileSystemProviderErrorCode.NoPermissions,G.NoPermissions)}static Unavailable(U){return new G(U,D.FileSystemProviderErrorCode.Unavailable,G.Unavailable)}constructor(U,te=D.FileSystemProviderErrorCode.Unknown,be){super(C.URI.isUri(U)?U.toString(!0):U),this.code=be?.name??"Unknown",(0,D.markAsFileSystemProviderError)(this,te),Object.setPrototypeOf(this,G.prototype),typeof Error.captureStackTrace=="function"&&typeof be=="function"&&Error.captureStackTrace(this,be)}};Di=G=qe([F],Di),e.FileSystemError=Di;let Ii=class{constructor(U,te,be){this.start=U,this.end=te,this.kind=be}};Ii=qe([F],Ii),e.FoldingRange=Ii;var Ui;(function(W){W[W.Comment=1]="Comment",W[W.Imports=2]="Imports",W[W.Region=3]="Region"})(Ui=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Bi;(function(W){W[W.Collapsed=0]="Collapsed",W[W.Expanded=1]="Expanded"})(Bi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var $i;(function(W){W[W.Editing=0]="Editing",W[W.Preview=1]="Preview"})($i=e.CommentMode||(e.CommentMode={}));var ki;(function(W){W[W.Unresolved=0]="Unresolved",W[W.Resolved=1]="Resolved"})(ki=e.CommentThreadState||(e.CommentThreadState={}));class Ai{constructor(U,te=[]){this.tokenTypes=U,this.tokenModifiers=te}}e.SemanticTokensLegend=Ai;function Ri(W){return typeof W>"u"||(0,S.isStringArray)(W)}class Ue{constructor(U){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,U){this.l=!0;for(let te=0,be=U.tokenTypes.length;te<be;te++)this.j.set(U.tokenTypes[te],te);for(let te=0,be=U.tokenModifiers.length;te<be;te++)this.k.set(U.tokenModifiers[te],te)}}push(U,te,be,Ke,Ye){if(typeof U=="number"&&typeof te=="number"&&typeof be=="number"&&typeof Ke=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.n(U,te,be,Ke,Ye);if(ie.isRange(U)&&typeof te=="string"&&Ri(be))return this.m(U,te,be);throw(0,T.illegalArgument)()}m(U,te,be){if(!this.l)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(te))throw new Error("`tokenType` is not in the provided legend");const Ke=U.start.line,Ye=U.start.character,ot=U.end.character-U.start.character,ut=this.j.get(te);let Rt=0;if(be)for(const Ht of be){if(!this.k.has(Ht))throw new Error("`tokenModifier` is not in the provided legend");const Gt=this.k.get(Ht);Rt|=1<<Gt>>>0}this.n(Ke,Ye,ot,ut,Rt)}n(U,te,be,Ke,Ye){if(this.f&&(U<this.c||U===this.c&&te<this.e)){this.f=!1;const Rt=this.g.length/5|0;let Ht=0,Gt=0;for(let Xt=0;Xt<Rt;Xt++){let Yt=this.g[5*Xt],Ti=this.g[5*Xt+1];Yt===0?(Yt=Ht,Ti+=Gt):Yt+=Ht,this.g[5*Xt]=Yt,this.g[5*Xt+1]=Ti,Ht=Yt,Gt=Ti}}let ot=U,ut=te;this.f&&this.h>0&&(ot-=this.c,ot===0&&(ut-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=ut,this.g[this.h++]=be,this.g[this.h++]=Ke,this.g[this.h++]=Ye,this.c=U,this.e=te}static o(U){const te=[],be=U.length/5|0;for(let ut=0;ut<be;ut++)te[ut]=ut;te.sort((ut,Rt)=>{const Ht=U[5*ut],Gt=U[5*Rt];if(Ht===Gt){const Xt=U[5*ut+1],Yt=U[5*Rt+1];return Xt-Yt}return Ht-Gt});const Ke=new Uint32Array(U.length);let Ye=0,ot=0;for(let ut=0;ut<be;ut++){const Rt=5*te[ut],Ht=U[Rt+0],Gt=U[Rt+1],Xt=U[Rt+2],Yt=U[Rt+3],Ti=U[Rt+4],tn=Ht-Ye,Tn=tn===0?Gt-ot:Gt,Pi=5*ut;Ke[Pi+0]=tn,Ke[Pi+1]=Tn,Ke[Pi+2]=Xt,Ke[Pi+3]=Yt,Ke[Pi+4]=Ti,Ye=Ht,ot=Gt}return Ke}build(U){return this.f?new Wt(new Uint32Array(this.g),U):new Wt(Ue.o(this.g),U)}}e.SemanticTokensBuilder=Ue;class Wt{constructor(U,te){this.resultId=te,this.data=U}}e.SemanticTokens=Wt;class Oi{constructor(U,te,be){this.start=U,this.deleteCount=te,this.data=be}}e.SemanticTokensEdit=Oi;class gt{constructor(U,te){this.resultId=te,this.edits=U}}e.SemanticTokensEdits=gt;var zi;(function(W){W[W.Separate=0]="Separate",W[W.MergeWithParent=1]="MergeWithParent"})(zi=e.DebugConsoleMode||(e.DebugConsoleMode={}));let hi=class{constructor(){}};hi.Back={iconPath:new jt("arrow-left")},hi=qe([F],hi),e.QuickInputButtons=hi;var Fi;(function(W){W[W.Separator=-1]="Separator",W[W.Default=0]="Default"})(Fi=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Wi;(function(W){W[W.Info=1]="Info",W[W.Warning=2]="Warning",W[W.Error=3]="Error"})(Wi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var fi;(function(W){W[W.UI=1]="UI",W[W.Workspace=2]="Workspace"})(fi=e.ExtensionKind||(e.ExtensionKind={}));class Hi{static validate(U){if(typeof U.badge=="string"){let te=(0,O.nextCharLength)(U.badge,0);if(te<U.badge.length&&(te+=(0,O.nextCharLength)(U.badge,te)),U.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(U.badge&&!jt.isThemeIcon(U.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty");return!0}constructor(U,te,be){this.badge=U,this.tooltip=te,this.color=be}}e.FileDecoration=Hi;let Ci=class{constructor(U){this.kind=U}};Ci=qe([F],Ci),e.ColorTheme=Ci;var Vi;(function(W){W[W.Light=1]="Light",W[W.Dark=2]="Dark",W[W.HighContrast=3]="HighContrast",W[W.HighContrastLight=4]="HighContrastLight"})(Vi=e.ColorThemeKind||(e.ColorThemeKind={}));class Kt{static isNotebookRange(U){return U instanceof Kt?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(U,te){if(U<0)throw(0,T.illegalArgument)("start must be positive");if(te<0)throw(0,T.illegalArgument)("end must be positive");U<=te?(this.c=U,this.e=te):(this.c=te,this.e=U)}with(U){let te=this.c,be=this.e;return U.start!==void 0&&(te=U.start),U.end!==void 0&&(be=U.end),te===this.c&&be===this.e?this:new Kt(te,be)}}e.NotebookRange=Kt;class mi{static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(te=>mi.isNotebookCellData(te))}static isNotebookCellData(U){return!0}constructor(U,te,be,Ke,Ye,ot,ut){this.kind=U,this.value=te,this.languageId=be,this.mime=Ke,this.outputs=Ye??[],this.metadata=ot,this.executionSummary=ut,mi.validate(this)}}e.NotebookCellData=mi;class ji{constructor(U){this.cells=U}}e.NotebookData=ji;class zt{static isNotebookCellOutputItem(U){return U instanceof zt?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const te={name:U.name,message:U.message,stack:U.stack};return zt.json(te,"application/vnd.code.notebook.error")}static stdout(U){return zt.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return zt.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,te="application/octet-stream"){return new zt(U,te)}static text(U,te=k.Mimes.text){const be=Oe(zt,v,"f",b).encode(String(U));return new zt(be,te)}static json(U,te="text/x-json"){const be=JSON.stringify(U,void 0,"	");return zt.text(be,te)}constructor(U,te){this.data=U,this.mime=te;const be=(0,k.normalizeMimeType)(te,!0);if(!be)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=be}}e.NotebookCellOutputItem=zt,v=zt,b={value:new TextEncoder};class gi{static isNotebookCellOutput(U){return U instanceof gi?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&Array.isArray(U.items)}static ensureUniqueMimeTypes(U,te=!1){const be=new Set,Ke=new Set;for(let Ye=0;Ye<U.length;Ye++){const ot=U[Ye],ut=(0,k.normalizeMimeType)(ot.mime);if(!be.has(ut)||(0,p.isTextStreamMime)(ut)){be.add(ut);continue}Ke.add(Ye),te&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return Ke.size===0?U:U.filter((Ye,ot)=>!Ke.has(ot))}constructor(U,te,be){this.items=gi.ensureUniqueMimeTypes(U,!0),typeof te=="string"?(this.id=te,this.metadata=be):(this.id=(0,N.generateUuid)(),this.metadata=te??be)}}e.NotebookCellOutput=gi;var qi;(function(W){W[W.Markup=1]="Markup",W[W.Code=2]="Code"})(qi=e.NotebookCellKind||(e.NotebookCellKind={}));var Ki;(function(W){W[W.Idle=1]="Idle",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})(Ki=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ne;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(ne=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var he;(function(W){W[W.Default=0]="Default",W[W.InCenter=1]="InCenter",W[W.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",W[W.AtTop=3]="AtTop"})(he=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ne{constructor(U,te){this.text=U,this.alignment=te}}e.NotebookCellStatusBarItem=Ne;var rt;(function(W){W[W.Default=1]="Default",W[W.Preferred=2]="Preferred"})(rt=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var yt;(function(W){W[W.Default=1]="Default",W[W.Preferred=2]="Preferred",W[W.Hidden=-1]="Hidden"})(yt=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class Pt{constructor(U,te=[]){this.uri=U,this.provides=(0,i.asArray)(te)}}e.NotebookRendererScript=Pt;class on{constructor(U){this.label=U}}e.NotebookKernelSourceAction=on;let Gi=class{constructor(U,te){this.label=U,this.timestamp=te}};Gi=qe([F],Gi),e.TimelineItem=Gi;var an;(function(W){W[W.Production=1]="Production",W[W.Development=2]="Development",W[W.Test=3]="Test"})(an=e.ExtensionMode||(e.ExtensionMode={}));var cn;(function(W){W[W.Node=1]="Node",W[W.Webworker=2]="Webworker"})(cn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var un;(function(W){W[W.Other=0]="Other",W[W.Comment=1]="Comment",W[W.String=2]="String",W[W.RegEx=3]="RegEx"})(un=e.StandardTokenType||(e.StandardTokenType={}));class ln{constructor(U,te){this.ranges=U,this.wordPattern=te}}e.LinkedEditingRanges=ln;class dn{constructor(U,te){this.c=U,this.e=te}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=dn;var hn;(function(W){W[W.Queued=1]="Queued",W[W.Running=2]="Running",W[W.Passed=3]="Passed",W[W.Failed=4]="Failed",W[W.Skipped=5]="Skipped",W[W.Errored=6]="Errored"})(hn=e.TestResultState||(e.TestResultState={}));var fn;(function(W){W[W.Run=1]="Run",W[W.Debug=2]="Debug",W[W.Coverage=3]="Coverage"})(fn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let xi=class{constructor(U=void 0,te=void 0,be=void 0){this.include=U,this.exclude=te,this.profile=be}};xi=qe([F],xi),e.TestRunRequest=xi;let Xi=A=class{static diff(U,te,be){const Ke=new A(U);return Ke.expectedOutput=te,Ke.actualOutput=be,Ke}constructor(U){this.message=U}};Xi=A=qe([F],Xi),e.TestMessage=Xi;let Qi=class{constructor(U){this.id=U}};Qi=qe([F],Qi),e.TestTag=Qi;let pi=class{constructor(U,te){this.covered=U,this.total=te}};pi=qe([F],pi),e.CoveredCount=pi;let _i=R=class{static fromDetails(U,te){const be=new pi(0,0),Ke=new pi(0,0),Ye=new pi(0,0);for(const ut of te)if("branches"in ut){be.total+=1,be.covered+=ut.executionCount>0?1:0;for(const Rt of ut.branches)Ke.total+=1,Ke.covered+=Rt.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=ut.executionCount>0?1:0;const ot=new R(U,be,Ke.total>0?Ke:void 0,Ye.total>0?Ye:void 0);return ot.detailedCoverage=te,ot}constructor(U,te,be,Ke){this.uri=U,this.statementCoverage=te,this.branchCoverage=be,this.functionCoverage=Ke}};_i=R=qe([F],_i),e.FileCoverage=_i;let Yi=class{constructor(U,te,be=[]){this.executionCount=U,this.location=te,this.branches=be}};Yi=qe([F],Yi),e.StatementCoverage=Yi;let Ji=class{constructor(U,te){this.executionCount=U,this.location=te}};Ji=qe([F],Ji),e.BranchCoverage=Ji;let Zi=class{constructor(U,te){this.executionCount=U,this.location=te}};Zi=qe([F],Zi),e.FunctionCoverage=Zi;var mn;(function(W){W[W.None=0]="None",W[W.Option=1]="Option",W[W.Default=2]="Default",W[W.Preferred=3]="Preferred"})(mn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var gn;(function(W){W[W.Untrusted=0]="Untrusted",W[W.Trusted=1]="Trusted",W[W.Unspecified=2]="Unspecified"})(gn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var pn;(function(W){W[W.Notify=1]="Notify",W[W.OpenBrowser=2]="OpenBrowser",W[W.OpenPreview=3]="OpenPreview",W[W.Silent=4]="Silent",W[W.Ignore=5]="Ignore",W[W.OpenBrowserOnce=6]="OpenBrowserOnce"})(pn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class vn{constructor(U,te,be,Ke,Ye,ot){this.kind=U,this.name=te,this.detail=be,this.uri=Ke,this.range=Ye,this.selectionRange=ot}}e.TypeHierarchyItem=vn;class bn{constructor(U){this.uri=U}}e.TextTabInput=bn;class En{constructor(U,te){this.original=U,this.modified=te}}e.TextDiffTabInput=En;class wn{constructor(U,te,be,Ke){this.base=U,this.input1=te,this.input2=be,this.result=Ke}}e.TextMergeTabInput=wn;class Sn{constructor(U,te){this.uri=U,this.viewType=te}}e.CustomEditorTabInput=Sn;class yn{constructor(U){this.viewType=U}}e.WebviewEditorTabInput=yn;class Dn{constructor(U,te){this.uri=U,this.notebookType=te}}e.NotebookEditorTabInput=Dn;class In{constructor(U,te,be){this.original=U,this.modified=te,this.notebookType=be}}e.NotebookDiffEditorTabInput=In;class kn{constructor(){}}e.TerminalEditorTabInput=kn;class Cn{constructor(U,te){this.uri=U,this.inputBoxUri=te}}e.InteractiveWindowInput=Cn}),define(ke[97],Ce([1,0,47,13,10,249,127,6,16]),function(ee,e,i,T,y,L,k,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const C=new Map;function N(f,t){t?C.set(f,t):C.delete(f)}e.setWordDefinitionFor=N;function D(f){return C.get(f)}class m extends L.MirrorTextModel{constructor(t,c,l,v,b,E,w,r){super(c,l,v,b),this.m=t,this.p=E,this.q=w,this.notebook=r,this.b=!1}dispose(){(0,i.ok)(!this.b),this.b=!0,this.q=!1}equalLines(t){return(0,S.equals)(this.d,t)}get document(){if(!this.a){const t=this;this.a={get uri(){return t.c},get fileName(){return t.c.fsPath},get isUntitled(){return t.c.scheme===T.Schemas.untitled},get languageId(){return t.p},get version(){return t.g},get isClosed(){return t.b},get isDirty(){return t.q},save(){return t.r()},getText(c){return c?t.s(c):t.getText()},get eol(){return t.f===`
`?O.EndOfLine.LF:O.EndOfLine.CRLF},get lineCount(){return t.d.length},lineAt(c){return t.t(c)},offsetAt(c){return t.u(c)},positionAt(c){return t.v(c)},validateRange(c){return t.w(c)},validatePosition(c){return t.x(c)},getWordRangeAtPosition(c,l){return t.y(c,l)}}}return Object.freeze(this.a)}_acceptLanguageId(t){(0,i.ok)(!this.b),this.p=t}_acceptIsDirty(t){(0,i.ok)(!this.b),this.q=t}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(t){const c=this.w(t);if(c.isEmpty)return"";if(c.isSingleLine)return this.d[c.start.line].substring(c.start.character,c.end.character);const l=this.f,v=c.start.line,b=c.end.line,E=[];E.push(this.d[v].substring(c.start.character));for(let w=v+1;w<b;w++)E.push(this.d[w]);return E.push(this.d[b].substring(0,c.end.character)),E.join(l)}t(t){let c;if(t instanceof O.Position?c=t.line:typeof t=="number"&&(c=t),typeof c!="number"||c<0||c>=this.d.length||Math.floor(c)!==c)throw new Error("Illegal value for `line`");return new p(c,this.d[c],c===this.d.length-1)}u(t){return t=this.x(t),this.k(),this.h.getPrefixSum(t.line-1)+t.character}v(t){t=Math.floor(t),t=Math.max(0,t),this.k();const c=this.h.getIndexOf(t),l=this.d[c.index].length;return new O.Position(c.index,Math.min(c.remainder,l))}w(t){if(!(t instanceof O.Range))throw new Error("Invalid argument");const c=this.x(t.start),l=this.x(t.end);return c===t.start&&l===t.end?t:new O.Range(c.line,c.character,l.line,l.character)}x(t){if(!(t instanceof O.Position))throw new Error("Invalid argument");if(this.d.length===0)return t.with(0,0);let{line:c,character:l}=t,v=!1;if(c<0)c=0,l=0,v=!0;else if(c>=this.d.length)c=this.d.length-1,l=this.d[c].length,v=!0;else{const b=this.d[c].length;l<0?(l=0,v=!0):l>b&&(l=b,v=!0)}return v?new O.Position(c,l):t}y(t,c){const l=this.x(t);if(!c)c=D(this.p);else if((0,y.regExpLeadsToEndlessLoop)(c))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${c.source}' because it matches the empty string.`);const v=(0,k.getWordAtText)(l.character+1,(0,k.ensureValidWordDefinition)(c),this.d[l.line],0);if(v)return new O.Range(l.line,v.startColumn-1,l.line,v.endColumn-1)}}e.ExtHostDocumentData=m;class p{constructor(t,c,l){this.a=t,this.b=c,this.c=l}get lineNumber(){return this.a}get text(){return this.b}get range(){return new O.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new O.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=p}),define(ke[184],Ce([1,0,6,15,5]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let L=class{constructor(O){this.a=new i.ColorTheme(i.ColorThemeKind.Dark),this.b=new y.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(O){let S;switch(O){case"light":S=i.ColorThemeKind.Light;break;case"hcDark":S=i.ColorThemeKind.HighContrast;break;case"hcLight":S=i.ColorThemeKind.HighContrastLight;break;default:S=i.ColorThemeKind.Dark}this.a=new i.ColorTheme(S),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};L=qe([Ve(0,T.IExtHostRpcService)],L),e.ExtHostTheming=L}),define(ke[8],Ce([1,0,16,24,113,185,83,28,110,82,62,23,9,2,55,72,88,94,93,67,42,54,180,6]),function(ee,e,i,T,y,L,k,O,S,C,N,D,m,p,f,t,c,l,v,b,E,w,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(ye){function Pe(x){const{selectionStartLineNumber:Re,selectionStartColumn:Le,positionLineNumber:Qe,positionColumn:ze}=x,Ze=new a.Position(Re-1,Le-1),bt=new a.Position(Qe-1,ze-1);return new a.Selection(Ze,bt)}ye.to=Pe;function fe(x){const{anchor:Re,active:Le}=x;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}ye.from=fe})(o=e.Selection||(e.Selection={}));var d;(function(ye){function Pe(x){if(!x)return;const{start:Re,end:Le}=x;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}ye.from=Pe;function fe(x){if(!x)return;const{startLineNumber:Re,startColumn:Le,endLineNumber:Qe,endColumn:ze}=x;return new a.Range(Re-1,Le-1,Qe-1,ze-1)}ye.to=fe})(d=e.Range||(e.Range={}));var s;(function(ye){function Pe(fe){switch(fe){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 3:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}ye.to=Pe})(s=e.TokenType||(e.TokenType={}));var u;(function(ye){function Pe(x){return new a.Position(x.lineNumber-1,x.column-1)}ye.to=Pe;function fe(x){return{lineNumber:x.line+1,column:x.character+1}}ye.from=fe})(u=e.Position||(e.Position={}));var n;(function(ye){function Pe(Re,Le){return(0,i.coalesce)((0,i.asArray)(Re).map(Qe=>fe(Qe,Le)))}ye.from=Pe;function fe(Re,Le){if(typeof Re=="string")return{$serialized:!0,language:Re};if(Re)return{$serialized:!0,language:Re.language,scheme:x(Re.scheme,Le),pattern:X.from(Re.pattern)??void 0,exclusive:Re.exclusive,notebookType:Re.notebookType}}function x(Re,Le){return Le&&typeof Re=="string"?Le.transformOutgoingScheme(Re):Re}})(n=e.DocumentSelector||(e.DocumentSelector={}));var h;(function(ye){function Pe(x){switch(x){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}ye.from=Pe;function fe(x){switch(x){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}ye.to=fe})(h=e.DiagnosticTag||(e.DiagnosticTag={}));var g;(function(ye){function Pe(x){let Re;return x.code&&((0,m.isString)(x.code)||(0,m.isNumber)(x.code)?Re=String(x.code):Re={value:String(x.code.value),target:x.code.target}),{...d.from(x.range),message:x.message,source:x.source,code:Re,severity:M.from(x.severity),relatedInformation:x.relatedInformation&&x.relatedInformation.map(P.from),tags:Array.isArray(x.tags)?(0,i.coalesce)(x.tags.map(h.from)):void 0}}ye.from=Pe;function fe(x){const Re=new a.Diagnostic(d.to(x),x.message,M.to(x.severity));return Re.source=x.source,Re.code=(0,m.isString)(x.code)?x.code:x.code?.value,Re.relatedInformation=x.relatedInformation&&x.relatedInformation.map(P.to),Re.tags=x.tags&&(0,i.coalesce)(x.tags.map(h.to)),Re}ye.to=fe})(g=e.Diagnostic||(e.Diagnostic={}));var P;(function(ye){function Pe(x){return{...d.from(x.location.range),message:x.message,resource:x.location.uri}}ye.from=Pe;function fe(x){return new a.DiagnosticRelatedInformation(new a.Location(x.resource,d.to(x)),x.message)}ye.to=fe})(P=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var M;(function(ye){function Pe(x){switch(x){case a.DiagnosticSeverity.Error:return c.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return c.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return c.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return c.MarkerSeverity.Hint}return c.MarkerSeverity.Error}ye.from=Pe;function fe(x){switch(x){case c.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case c.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case c.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case c.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}ye.to=fe})(M=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var j;(function(ye){function Pe(x){return typeof x=="number"&&x>=a.ViewColumn.One?x-1:x===a.ViewColumn.Beside?r.SIDE_GROUP:r.ACTIVE_GROUP}ye.from=Pe;function fe(x){if(typeof x=="number"&&x>=0)return x+1;throw new Error("invalid 'EditorGroupColumn'")}ye.to=fe})(j=e.ViewColumn||(e.ViewColumn={}));function Z(ye){return typeof ye.range<"u"}function G(ye){return ye.length===0?!0:!!Z(ye[0])}e.isDecorationOptionsArr=G;var A;(function(ye){function Pe(ze){return ze.map(ye.from)}ye.fromMany=Pe;function fe(ze){return ze&&typeof ze=="object"&&typeof ze.language=="string"&&typeof ze.value=="string"}function x(ze){let Ze;if(fe(ze)){const{language:pt,value:It}=ze;Ze={value:"```"+pt+`
`+It+"\n```\n"}}else a.MarkdownString.isMarkdownString(ze)?Ze={value:ze.value,isTrusted:ze.isTrusted,supportThemeIcons:ze.supportThemeIcons,supportHtml:ze.supportHtml,baseUri:ze.baseUri}:typeof ze=="string"?Ze={value:ze}:Ze={value:""};const bt=Object.create(null);Ze.uris=bt;const vt=pt=>{try{let It=p.URI.parse(pt,!0);It=It.with({query:Re(It.query,bt)}),bt[pt]=It}catch{}return""},At=new S.marked.Renderer;return At.link=vt,At.image=pt=>typeof pt=="string"?vt(k.parseHrefAndDimensions(pt).href):"",(0,S.marked)(Ze.value,{renderer:At}),Ze}ye.from=x;function Re(ze,Ze){if(!ze)return ze;let bt;try{bt=(0,C.parse)(ze)}catch{}if(!bt)return ze;let vt=!1;return bt=(0,D.cloneAndChange)(bt,At=>{if(p.URI.isUri(At)){const pt=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ze[pt]=At,vt=!0,pt}else return}),vt?JSON.stringify(bt):ze}function Le(ze){const Ze=new a.MarkdownString(ze.value,ze.supportThemeIcons);return Ze.isTrusted=ze.isTrusted,Ze.supportHtml=ze.supportHtml,Ze.baseUri=ze.baseUri?p.URI.from(ze.baseUri):void 0,Ze}ye.to=Le;function Qe(ze){if(!!ze)return typeof ze=="string"?ze:ye.from(ze)}ye.fromStrict=Qe})(A=e.MarkdownString||(e.MarkdownString={}));function R(ye){return G(ye)?ye.map(Pe=>({range:d.from(Pe.range),hoverMessage:Array.isArray(Pe.hoverMessage)?A.fromMany(Pe.hoverMessage):Pe.hoverMessage?A.from(Pe.hoverMessage):void 0,renderOptions:Pe.renderOptions})):ye.map(Pe=>({range:d.from(Pe)}))}e.fromRangeOrRangeWithMessage=R;function F(ye){return typeof ye>"u"?ye:typeof ye=="string"?p.URI.file(ye):ye}e.pathOrURIToURI=F;var B;(function(ye){function Pe(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?F(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}ye.from=Pe})(B=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var z;(function(ye){function Pe(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?F(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?B.from(fe.before):void 0,after:fe.after?B.from(fe.after):void 0}}ye.from=Pe})(z=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var V;(function(ye){function Pe(fe){if(typeof fe>"u")return fe;switch(fe){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}ye.from=Pe})(V=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var K;(function(ye){function Pe(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?V.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?z.from(fe.light):void 0,dark:fe.dark?z.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?F(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?B.from(fe.before):void 0,after:fe.after?B.from(fe.after):void 0}}ye.from=Pe})(K=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var ie;(function(ye){function Pe(x){return{text:x.newText,eol:x.newEol&&it.from(x.newEol),range:d.from(x.range)}}ye.from=Pe;function fe(x){const Re=new a.TextEdit(d.to(x.range),x.text);return Re.newEol=typeof x.eol>"u"?void 0:it.to(x.eol),Re}ye.to=fe})(ie=e.TextEdit||(e.TextEdit={}));var me;(function(ye){function Pe(x,Re){const Le={edits:[]};if(x instanceof a.WorkspaceEdit){const Qe=new O.ResourceSet;for(const ze of x._allEntries())ze._type===1&&p.URI.isUri(ze.to)&&ze.from===void 0&&Qe.add(ze.to);for(const ze of x._allEntries())ze._type===1?Le.edits.push({oldResource:ze.from,newResource:ze.to,options:{...ze.options,contentsBase64:ze.options?.contents&&(0,T.encodeBase64)(T.VSBuffer.wrap(ze.options.contents))},metadata:ze.metadata}):ze._type===2?Le.edits.push({resource:ze.uri,textEdit:ie.from(ze.edit),versionId:Qe.has(ze.uri)?void 0:Re?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===6?Le.edits.push({resource:ze.uri,textEdit:{range:d.from(ze.range),text:ze.edit.value,insertAsSnippet:!0},versionId:Qe.has(ze.uri)?void 0:Re?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===3?Le.edits.push({metadata:ze.metadata,resource:ze.uri,cellEdit:ze.edit,notebookMetadata:ze.notebookMetadata,notebookVersionId:Re?.getNotebookDocumentVersion(ze.uri)}):ze._type===5&&Le.edits.push({metadata:ze.metadata,resource:ze.uri,notebookVersionId:Re?.getNotebookDocumentVersion(ze.uri),cellEdit:{editType:1,index:ze.index,count:ze.count,cells:ze.cells.map(wt.from)}})}return Le}ye.from=Pe;function fe(x){const Re=new a.WorkspaceEdit;for(const Le of x.edits)Le.textEdit?Re.replace(p.URI.revive(Le.resource),d.to(Le.textEdit.range),Le.textEdit.text):Re.renameFile(p.URI.revive(Le.oldResource),p.URI.revive(Le.newResource),Le.options);return Re}ye.to=fe})(me=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ue;(function(ye){const Pe=Object.create(null);Pe[a.SymbolKind.File]=0,Pe[a.SymbolKind.Module]=1,Pe[a.SymbolKind.Namespace]=2,Pe[a.SymbolKind.Package]=3,Pe[a.SymbolKind.Class]=4,Pe[a.SymbolKind.Method]=5,Pe[a.SymbolKind.Property]=6,Pe[a.SymbolKind.Field]=7,Pe[a.SymbolKind.Constructor]=8,Pe[a.SymbolKind.Enum]=9,Pe[a.SymbolKind.Interface]=10,Pe[a.SymbolKind.Function]=11,Pe[a.SymbolKind.Variable]=12,Pe[a.SymbolKind.Constant]=13,Pe[a.SymbolKind.String]=14,Pe[a.SymbolKind.Number]=15,Pe[a.SymbolKind.Boolean]=16,Pe[a.SymbolKind.Array]=17,Pe[a.SymbolKind.Object]=18,Pe[a.SymbolKind.Key]=19,Pe[a.SymbolKind.Null]=20,Pe[a.SymbolKind.EnumMember]=21,Pe[a.SymbolKind.Struct]=22,Pe[a.SymbolKind.Event]=23,Pe[a.SymbolKind.Operator]=24,Pe[a.SymbolKind.TypeParameter]=25;function fe(Re){return typeof Pe[Re]=="number"?Pe[Re]:6}ye.from=fe;function x(Re){for(const Le in Pe)if(Pe[Le]===Re)return Number(Le);return a.SymbolKind.Property}ye.to=x})(ue=e.SymbolKind||(e.SymbolKind={}));var oe;(function(ye){function Pe(x){switch(x){case a.SymbolTag.Deprecated:return 1}}ye.from=Pe;function fe(x){switch(x){case 1:return a.SymbolTag.Deprecated}}ye.to=fe})(oe=e.SymbolTag||(e.SymbolTag={}));var De;(function(ye){function Pe(x){return{name:x.name,kind:ue.from(x.kind),tags:x.tags&&x.tags.map(oe.from),containerName:x.containerName,location:Ae.from(x.location)}}ye.from=Pe;function fe(x){const Re=new a.SymbolInformation(x.name,ue.to(x.kind),x.containerName,Ae.to(x.location));return Re.tags=x.tags&&x.tags.map(oe.to),Re}ye.to=fe})(De=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var re;(function(ye){function Pe(x){const Re={name:x.name||"!!MISSING: name!!",detail:x.detail,range:d.from(x.range),selectionRange:d.from(x.selectionRange),kind:ue.from(x.kind),tags:x.tags?.map(oe.from)??[]};return x.children&&(Re.children=x.children.map(Pe)),Re}ye.from=Pe;function fe(x){const Re=new a.DocumentSymbol(x.name,x.detail,ue.to(x.kind),d.to(x.range),d.to(x.selectionRange));return(0,i.isNonEmptyArray)(x.tags)&&(Re.tags=x.tags.map(oe.to)),x.children&&(Re.children=x.children.map(fe)),Re}ye.to=fe})(re=e.DocumentSymbol||(e.DocumentSymbol={}));var Q;(function(ye){function Pe(x){const Re=new a.CallHierarchyItem(ue.to(x.kind),x.name,x.detail||"",p.URI.revive(x.uri),d.to(x.range),d.to(x.selectionRange));return Re._sessionId=x._sessionId,Re._itemId=x._itemId,Re}ye.to=Pe;function fe(x,Re,Le){if(Re=Re??x._sessionId,Le=Le??x._itemId,Re===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Le,name:x.name,detail:x.detail,kind:ue.from(x.kind),uri:x.uri,range:d.from(x.range),selectionRange:d.from(x.selectionRange),tags:x.tags?.map(oe.from)}}ye.from=fe})(Q=e.CallHierarchyItem||(e.CallHierarchyItem={}));var le;(function(ye){function Pe(fe){return new a.CallHierarchyIncomingCall(Q.to(fe.from),fe.fromRanges.map(x=>d.to(x)))}ye.to=Pe})(le=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Ee;(function(ye){function Pe(fe){return new a.CallHierarchyOutgoingCall(Q.to(fe.to),fe.fromRanges.map(x=>d.to(x)))}ye.to=Pe})(Ee=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Ae;(function(ye){function Pe(x){return{range:x.range&&d.from(x.range),uri:x.uri}}ye.from=Pe;function fe(x){return new a.Location(p.URI.revive(x.uri),d.to(x.range))}ye.to=fe})(Ae=e.location||(e.location={}));var Be;(function(ye){function Pe(x){const Re=x,Le=x;return{originSelectionRange:Re.originSelectionRange?d.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:Le.uri,range:d.from(Re.targetRange?Re.targetRange:Le.range),targetSelectionRange:Re.targetSelectionRange?d.from(Re.targetSelectionRange):void 0}}ye.from=Pe;function fe(x){return{targetUri:p.URI.revive(x.uri),targetRange:d.to(x.range),targetSelectionRange:x.targetSelectionRange?d.to(x.targetSelectionRange):void 0,originSelectionRange:x.originSelectionRange?d.to(x.originSelectionRange):void 0}}ye.to=fe})(Be=e.DefinitionLink||(e.DefinitionLink={}));var xe;(function(ye){function Pe(x){return{range:d.from(x.range),contents:A.fromMany(x.contents)}}ye.from=Pe;function fe(x){return new a.Hover(x.contents.map(A.to),d.to(x.range))}ye.to=fe})(xe=e.Hover||(e.Hover={}));var Te;(function(ye){function Pe(x){return{range:d.from(x.range),expression:x.expression}}ye.from=Pe;function fe(x){return new a.EvaluatableExpression(d.to(x.range),x.expression)}ye.to=fe})(Te=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Ie;(function(ye){function Pe(x){if(x instanceof a.InlineValueText)return{type:"text",range:d.from(x.range),text:x.text};if(x instanceof a.InlineValueVariableLookup)return{type:"variable",range:d.from(x.range),variableName:x.variableName,caseSensitiveLookup:x.caseSensitiveLookup};if(x instanceof a.InlineValueEvaluatableExpression)return{type:"expression",range:d.from(x.range),expression:x.expression};throw new Error("Unknown 'InlineValue' type")}ye.from=Pe;function fe(x){switch(x.type){case"text":return{range:d.to(x.range),text:x.text};case"variable":return{range:d.to(x.range),variableName:x.variableName,caseSensitiveLookup:x.caseSensitiveLookup};case"expression":return{range:d.to(x.range),expression:x.expression}}}ye.to=fe})(Ie=e.InlineValue||(e.InlineValue={}));var Se;(function(ye){function Pe(x){return{frameId:x.frameId,stoppedLocation:d.from(x.stoppedLocation)}}ye.from=Pe;function fe(x){return new a.InlineValueContext(x.frameId,d.to(x.stoppedLocation))}ye.to=fe})(Se=e.InlineValueContext||(e.InlineValueContext={}));var se;(function(ye){function Pe(x){return{range:d.from(x.range),kind:x.kind}}ye.from=Pe;function fe(x){return new a.DocumentHighlight(d.to(x.range),x.kind)}ye.to=fe})(se=e.DocumentHighlight||(e.DocumentHighlight={}));var ce;(function(ye){function Pe(fe){switch(fe){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}ye.to=Pe})(ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Y;(function(ye){function Pe(fe){return{triggerKind:ce.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}ye.to=Pe})(Y=e.CompletionContext||(e.CompletionContext={}));var I;(function(ye){function Pe(x){switch(x){case a.CompletionItemTag.Deprecated:return 1}}ye.from=Pe;function fe(x){switch(x){case 1:return a.CompletionItemTag.Deprecated}}ye.to=fe})(I=e.CompletionItemTag||(e.CompletionItemTag={}));var $;(function(ye){const Pe=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function fe(Le){return Pe.get(Le)??9}ye.from=fe;const x=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function Re(Le){return x.get(Le)??a.CompletionItemKind.Property}ye.to=Re})($=e.CompletionItemKind||(e.CompletionItemKind={}));var H;(function(ye){function Pe(fe,x){const Re=new a.CompletionItem(fe.label);return Re.insertText=fe.insertText,Re.kind=$.to(fe.kind),Re.tags=fe.tags?.map(I.to),Re.detail=fe.detail,Re.documentation=k.isMarkdownString(fe.documentation)?A.to(fe.documentation):fe.documentation,Re.sortText=fe.sortText,Re.filterText=fe.filterText,Re.preselect=fe.preselect,Re.commitCharacters=fe.commitCharacters,f.Range.isIRange(fe.range)?Re.range=d.to(fe.range):typeof fe.range=="object"&&(Re.range={inserting:d.to(fe.range.insert),replacing:d.to(fe.range.replace)}),Re.keepWhitespace=typeof fe.insertTextRules>"u"?!1:Boolean(fe.insertTextRules&1),typeof fe.insertTextRules<"u"&&fe.insertTextRules&4?Re.insertText=new a.SnippetString(fe.insertText):(Re.insertText=fe.insertText,Re.textEdit=Re.range instanceof a.Range?new a.TextEdit(Re.range,Re.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(Re.additionalTextEdits=fe.additionalTextEdits.map(Le=>ie.to(Le))),Re.command=x&&fe.command?x.fromInternal(fe.command):void 0,Re}ye.to=Pe})(H=e.CompletionItem||(e.CompletionItem={}));var q;(function(ye){function Pe(x){if(typeof x.label!="string"&&!Array.isArray(x.label))throw new TypeError("Invalid label");return{label:x.label,documentation:A.fromStrict(x.documentation)}}ye.from=Pe;function fe(x){return{label:x.label,documentation:k.isMarkdownString(x.documentation)?A.to(x.documentation):x.documentation}}ye.to=fe})(q=e.ParameterInformation||(e.ParameterInformation={}));var J;(function(ye){function Pe(x){return{label:x.label,documentation:A.fromStrict(x.documentation),parameters:Array.isArray(x.parameters)?x.parameters.map(q.from):[],activeParameter:x.activeParameter}}ye.from=Pe;function fe(x){return{label:x.label,documentation:k.isMarkdownString(x.documentation)?A.to(x.documentation):x.documentation,parameters:Array.isArray(x.parameters)?x.parameters.map(q.to):[],activeParameter:x.activeParameter}}ye.to=fe})(J=e.SignatureInformation||(e.SignatureInformation={}));var de;(function(ye){function Pe(x){return{activeSignature:x.activeSignature,activeParameter:x.activeParameter,signatures:Array.isArray(x.signatures)?x.signatures.map(J.from):[]}}ye.from=Pe;function fe(x){return{activeSignature:x.activeSignature,activeParameter:x.activeParameter,signatures:Array.isArray(x.signatures)?x.signatures.map(J.to):[]}}ye.to=fe})(de=e.SignatureHelp||(e.SignatureHelp={}));var we;(function(ye){function Pe(fe,x){const Re=new a.InlayHint(u.to(x.position),typeof x.label=="string"?x.label:x.label.map(ae.to.bind(void 0,fe)),x.kind&&pe.to(x.kind));return Re.textEdits=x.textEdits&&x.textEdits.map(ie.to),Re.tooltip=k.isMarkdownString(x.tooltip)?A.to(x.tooltip):x.tooltip,Re.paddingLeft=x.paddingLeft,Re.paddingRight=x.paddingRight,Re}ye.to=Pe})(we=e.InlayHint||(e.InlayHint={}));var ae;(function(ye){function Pe(fe,x){const Re=new a.InlayHintLabelPart(x.label);return Re.tooltip=k.isMarkdownString(x.tooltip)?A.to(x.tooltip):x.tooltip,t.Command.is(x.command)&&(Re.command=fe.fromInternal(x.command)),x.location&&(Re.location=Ae.to(x.location)),Re}ye.to=Pe})(ae=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var pe;(function(ye){function Pe(x){return x}ye.from=Pe;function fe(x){return x}ye.to=fe})(pe=e.InlayHintKind||(e.InlayHintKind={}));var ve;(function(ye){function Pe(x){return{range:d.from(x.range),url:x.target,tooltip:x.tooltip}}ye.from=Pe;function fe(x){let Re;if(x.url)try{Re=typeof x.url=="string"?p.URI.parse(x.url,!0):p.URI.revive(x.url)}catch{}return new a.DocumentLink(d.to(x.range),Re)}ye.to=fe})(ve=e.DocumentLink||(e.DocumentLink={}));var We;(function(ye){function Pe(x){const Re=new a.ColorPresentation(x.label);return x.textEdit&&(Re.textEdit=ie.to(x.textEdit)),x.additionalTextEdits&&(Re.additionalTextEdits=x.additionalTextEdits.map(Le=>ie.to(Le))),Re}ye.to=Pe;function fe(x){return{label:x.label,textEdit:x.textEdit?ie.from(x.textEdit):void 0,additionalTextEdits:x.additionalTextEdits?x.additionalTextEdits.map(Re=>ie.from(Re)):void 0}}ye.from=fe})(We=e.ColorPresentation||(e.ColorPresentation={}));var He;(function(ye){function Pe(x){return new a.Color(x[0],x[1],x[2],x[3])}ye.to=Pe;function fe(x){return[x.red,x.green,x.blue,x.alpha]}ye.from=fe})(He=e.Color||(e.Color={}));var tt;(function(ye){function Pe(x){return{range:d.from(x.range)}}ye.from=Pe;function fe(x){return new a.SelectionRange(d.to(x.range))}ye.to=fe})(tt=e.SelectionRange||(e.SelectionRange={}));var Xe;(function(ye){function Pe(fe){switch(fe){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}ye.to=Pe})(Xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var et;(function(ye){function Pe(x){switch(x){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}ye.from=Pe;function fe(x){switch(x){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}ye.to=fe})(et=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var it;(function(ye){function Pe(x){if(x===a.EndOfLine.CRLF)return 1;if(x===a.EndOfLine.LF)return 0}ye.from=Pe;function fe(x){if(x===1)return a.EndOfLine.CRLF;if(x===0)return a.EndOfLine.LF}ye.to=fe})(it=e.EndOfLine||(e.EndOfLine={}));var dt;(function(ye){function Pe(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ye.from=Pe})(dt=e.ProgressLocation||(e.ProgressLocation={}));var Fe;(function(ye){function Pe(fe){const x={start:fe.start+1,end:fe.end+1};return fe.kind&&(x.kind=st.from(fe.kind)),x}ye.from=Pe})(Fe=e.FoldingRange||(e.FoldingRange={}));var st;(function(ye){function Pe(fe){if(fe)switch(fe){case a.FoldingRangeKind.Comment:return t.FoldingRangeKind.Comment;case a.FoldingRangeKind.Imports:return t.FoldingRangeKind.Imports;case a.FoldingRangeKind.Region:return t.FoldingRangeKind.Region}}ye.from=Pe})(st=e.FoldingRangeKind||(e.FoldingRangeKind={}));var _;(function(ye){function Pe(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?d.from(fe.selection):void 0,override:typeof fe.override=="boolean"?v.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}ye.from=Pe})(_=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var X;(function(ye){function Pe(Le){return Le instanceof a.RelativePattern?Le.toJSON():typeof Le=="string"?Le:fe(Le)||x(Le)?new a.RelativePattern(Le.baseUri??Le.base,Le.pattern).toJSON():Le}ye.from=Pe;function fe(Le){const Qe=Le;return Qe?p.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function x(Le){const Qe=Le;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Re(Le){return typeof Le=="string"?Le:new a.RelativePattern(p.URI.revive(Le.baseUri),Le.pattern)}ye.to=Re})(X=e.GlobPattern||(e.GlobPattern={}));var ge;(function(ye){function Pe(fe){if(fe){if(Array.isArray(fe))return fe.map(Pe);if(typeof fe=="string")return fe;{const x=fe;return{language:x.language,scheme:x.scheme,pattern:X.from(x.pattern),exclusive:x.exclusive,notebookType:x.notebookType}}}else return}ye.from=Pe})(ge=e.LanguageSelector||(e.LanguageSelector={}));var Me;(function(ye){function Pe(x){return{start:x.start,end:x.end}}ye.from=Pe;function fe(x){return new a.NotebookRange(x.start,x.end)}ye.to=fe})(Me=e.NotebookRange||(e.NotebookRange={}));var $e;(function(ye){function Pe(x){return{timing:typeof x.runStartTime=="number"&&typeof x.runEndTime=="number"?{startTime:x.runStartTime,endTime:x.runEndTime}:void 0,executionOrder:x.executionOrder,success:x.lastRunSuccess}}ye.to=Pe;function fe(x){return{lastRunSuccess:x.success,runStartTime:x.timing?.startTime,runEndTime:x.timing?.endTime,executionOrder:x.executionOrder}}ye.from=fe})($e=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var je;(function(ye){function Pe(fe){if(fe===b.NotebookCellExecutionState.Unconfirmed)return a.NotebookCellExecutionState.Pending;if(fe===b.NotebookCellExecutionState.Pending)return;if(fe===b.NotebookCellExecutionState.Executing)return a.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}ye.to=Pe})(je=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var _e;(function(ye){function Pe(x){switch(x){case a.NotebookCellKind.Markup:return b.CellKind.Markup;case a.NotebookCellKind.Code:default:return b.CellKind.Code}}ye.from=Pe;function fe(x){switch(x){case b.CellKind.Markup:return a.NotebookCellKind.Markup;case b.CellKind.Code:default:return a.NotebookCellKind.Code}}ye.to=fe})(_e=e.NotebookCellKind||(e.NotebookCellKind={}));var nt;(function(ye){function Pe(x){const Re={metadata:x.metadata??Object.create(null),cells:[]};for(const Le of x.cells)a.NotebookCellData.validate(Le),Re.cells.push(wt.from(Le));return Re}ye.from=Pe;function fe(x){const Re=new a.NotebookData(x.cells.map(wt.to));return(0,m.isEmptyObject)(x.metadata)||(Re.metadata=x.metadata),Re}ye.to=fe})(nt=e.NotebookData||(e.NotebookData={}));var wt;(function(ye){function Pe(x){return{cellKind:_e.from(x.kind),language:x.languageId,mime:x.mime,source:x.value,metadata:x.metadata,internalMetadata:$e.from(x.executionSummary??{}),outputs:x.outputs?x.outputs.map(kt.from):[]}}ye.from=Pe;function fe(x){return new a.NotebookCellData(_e.to(x.cellKind),x.source,x.language,x.mime,x.outputs?x.outputs.map(kt.to):void 0,x.metadata,x.internalMetadata?$e.to(x.internalMetadata):void 0)}ye.to=fe})(wt=e.NotebookCellData||(e.NotebookCellData={}));var St;(function(ye){function Pe(x){return{mime:x.mime,valueBytes:T.VSBuffer.wrap(x.data)}}ye.from=Pe;function fe(x){return new a.NotebookCellOutputItem(x.valueBytes.buffer,x.mime)}ye.to=fe})(St=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var kt;(function(ye){function Pe(x){return{outputId:x.id,items:x.items.map(St.from),metadata:x.metadata}}ye.from=Pe;function fe(x){const Re=x.items.map(St.to);return new a.NotebookCellOutput(Re,x.outputId,x.metadata)}ye.to=fe})(kt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var lt;(function(ye){function Pe(Re){return x(Re)?{include:(0,m.withNullAsUndefined)(X.from(Re.include)),exclude:(0,m.withNullAsUndefined)(X.from(Re.exclude))}:(0,m.withNullAsUndefined)(X.from(Re))}ye.from=Pe;function fe(Re){return x(Re)?{include:X.to(Re.include),exclude:X.to(Re.exclude)}:X.to(Re)}ye.to=fe;function x(Re){const Le=Re;return Le?!(0,m.isUndefinedOrNull)(Le.include)&&!(0,m.isUndefinedOrNull)(Le.exclude):!1}})(lt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var at;(function(ye){function Pe(fe,x,Re){const Le=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:x.toInternal(Le,Re),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}ye.from=Pe})(at=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Bt;(function(ye){function Pe(fe,x,Re){const Le=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{command:x.toInternal(Le,Re),label:fe.label,description:fe.description,detail:fe.detail}}ye.from=Pe})(Bt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Ot;(function(ye){function Pe(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}ye.from=Pe})(Ot=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ft;(function(ye){function Pe(x){return{uri:x.uri,provides:x.provides}}ye.from=Pe;function fe(x){return new a.NotebookRendererScript(p.URI.revive(x.uri),x.provides)}ye.to=fe})(Ft=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ft;(function(ye){function Pe(x){return{message:A.fromStrict(x.message)||"",type:0,expected:x.expectedOutput,actual:x.actualOutput,location:x.location&&{range:d.from(x.location.range),uri:x.location.uri}}}ye.from=Pe;function fe(x){const Re=new a.TestMessage(typeof x.message=="string"?x.message:A.to(x.message));return Re.actualOutput=x.actual,Re.expectedOutput=x.expected,Re.location=x.location?Ae.to(x.location):void 0,Re}ye.to=fe})(ft=e.TestMessage||(e.TestMessage={}));var Dt;(function(ye){ye.namespace=w.namespaceTestTag,ye.denamespace=w.denamespaceTestTag})(Dt=e.TestTag||(e.TestTag={}));var $t;(function(ye){function Pe(x){const Re=(0,l.getPrivateApiFor)(x).controllerId;return{extId:E.TestId.fromExtHostTestItem(x,Re).toString(),label:x.label,uri:p.URI.revive(x.uri),busy:x.busy,tags:x.tags.map(Le=>Dt.namespace(Re,Le.id)),range:f.Range.lift(d.from(x.range)),description:x.description||null,sortText:x.sortText||null,error:x.error&&A.fromStrict(x.error)||null}}ye.from=Pe;function fe(x){return{parent:void 0,error:void 0,id:E.TestId.fromString(x.extId).localId,label:x.label,uri:p.URI.revive(x.uri),tags:(x.tags||[]).map(Re=>{const{tagId:Le}=Dt.denamespace(Re);return new a.TestTag(Le)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:d.to(x.range||void 0),canResolveChildren:!1,busy:x.busy,description:x.description||void 0,sortText:x.sortText||void 0}}ye.toPlain=fe})($t=e.TestItem||(e.TestItem={})),function(ye){function Pe(x){return{id:x.id}}ye.from=Pe;function fe(x){return new a.TestTag(x.id)}ye.to=fe}(Dt=e.TestTag||(e.TestTag={}));var Nt;(function(ye){const Pe=(x,Re)=>{const Le=[];for(const[ze,Ze]of Re)E.TestId.compare(Ze.item.extId,ze)===2&&(Re.delete(ze),Le.push(Ze));const Qe={...$t.toPlain(x.item),parent:void 0,taskStates:x.tasks.map(ze=>({state:ze.state,duration:ze.duration,messages:ze.messages.filter(Ze=>Ze.type===0).map(ft.to)})),children:Le.map(ze=>Pe(ze,Re))};for(const ze of Qe.children)ze.parent=Qe;return Qe};function fe(x){const Re=[],Le=new Map;for(const Qe of x.items){Le.set(Qe.item.extId,Qe);const ze=E.TestId.root(Qe.item.extId);x.request.targets.some(Ze=>Ze.controllerId===ze&&Ze.testIds.includes(Qe.item.extId))&&Re.push(Qe)}return{completedAt:x.completedAt,results:Re.map(Qe=>Pe(Qe,Le))}}ye.to=fe})(Nt=e.TestResults||(e.TestResults={}));var Ge;(function(ye){function Pe(Le){return{covered:Le.covered,total:Le.covered}}function fe(Le){return"line"in Le?u.from(Le):d.from(Le)}function x(Le){return"branches"in Le?{count:Le.executionCount,location:fe(Le.location),type:1,branches:Le.branches.length?Le.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&fe(Qe.location)})):void 0}:{type:0,count:Le.executionCount,location:fe(Le.location)}}ye.fromDetailed=x;function Re(Le){return{uri:Le.uri,statement:Pe(Le.statementCoverage),branch:Le.branchCoverage&&Pe(Le.branchCoverage),function:Le.functionCoverage&&Pe(Le.functionCoverage),details:Le.detailedCoverage?.map(x)}}ye.fromFile=Re})(Ge=e.TestCoverage||(e.TestCoverage={}));var Mt;(function(ye){function Pe(fe){switch(fe){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}ye.to=Pe})(Mt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Lt;(function(ye){function Pe(x){const Re=new a.TypeHierarchyItem(ue.to(x.kind),x.name,x.detail||"",p.URI.revive(x.uri),d.to(x.range),d.to(x.selectionRange));return Re._sessionId=x._sessionId,Re._itemId=x._itemId,Re}ye.to=Pe;function fe(x,Re,Le){if(Re=Re??x._sessionId,Le=Le??x._itemId,Re===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Le,kind:ue.from(x.kind),name:x.name,detail:x.detail??"",uri:x.uri,range:d.from(x.range),selectionRange:d.from(x.selectionRange),tags:x.tags?.map(oe.from)}}ye.from=fe})(Lt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Ut;(function(ye){function Pe(fe){if(!!fe)return{value:fe.value,tooltip:fe.tooltip}}ye.from=Pe})(Ut=e.ViewBadge||(e.ViewBadge={}));var mt;(function(ye){function Pe(Le,Qe,ze){const Ze=Qe.fileData;return Ze?new class extends a.DataTransferItem{asFile(){return{name:Ze.name,uri:p.URI.revive(Ze.uri),data:(0,L.once)(()=>ze())}}}("",Qe.id):Le===N.Mimes.uriList&&Qe.uriListData?new a.DataTransferItem(Re(Qe.uriListData)):new a.DataTransferItem(Qe.asString)}ye.to=Pe;async function fe(Le,Qe){const ze=await Qe.asString();if(Le===N.Mimes.uriList)return{id:Qe.id,asString:"",fileData:void 0,uriListData:x(ze)};const Ze=Qe.asFile();return{id:Qe.id,asString:ze,fileData:Ze?{name:Ze.name,uri:Ze.uri}:void 0}}ye.from=fe;function x(Le){return y.UriList.split(Le).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return p.URI.parse(Qe)}catch{}return Qe})}function Re(Le){return y.UriList.create(Le.map(Qe=>typeof Qe=="string"?Qe:p.URI.revive(Qe)))}})(mt=e.DataTransferItem||(e.DataTransferItem={}));var Ct;(function(ye){function Pe(x,Re){const Le=x.items.map(([Qe,ze])=>[Qe,mt.to(Qe,ze,()=>Re(ze.id))]);return new a.DataTransfer(Le)}ye.toDataTransfer=Pe;async function fe(x){const Re={items:[]},Le=[];return x.forEach((Qe,ze)=>{Le.push((async()=>{Re.items.push([ze,await mt.from(ze,Qe)])})())}),await Promise.all(Le),Re}ye.toDataTransferDTO=fe})(Ct=e.DataTransfer||(e.DataTransfer={}))}),define(ke[186],Ce([1,0,2,11,6,8,154]),function(ee,e,i,T,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class O{constructor(C,N,D,m={timeout:1500,errors:3}){this.c=C,this.d=N,this.f=D,this.g=m,this.a=new k.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(C){return(N,D,m)=>{const f={dispose:this.a.push([N,D,C])};return Array.isArray(m)&&m.push(f),f}}async $participateInSave(C,N){const D=i.URI.revive(C);let m=!1;const p=setTimeout(()=>m=!0,this.g.timeout),f=[];try{for(const t of[...this.a]){if(m)break;const c=this.d.getDocument(D),l=await this.h(t,{document:c,reason:L.TextDocumentSaveReason.to(N)});f.push(l)}}finally{clearTimeout(p)}return f}h([C,N,D],m){const p=this.b.get(C);return typeof p=="number"&&p>this.g.errors?Promise.resolve(!1):this.i(D,C,N,m).then(()=>!0,f=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this.c.error(f),!(f instanceof Error)||f.message!=="concurrent_edits"){const t=this.b.get(C);this.b.set(C,t?t+1:1),typeof t=="number"&&t>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(C,N,D,m){const p=[],f=Date.now(),{document:t,reason:c}=m,{version:l}=t,v=Object.freeze({document:t,reason:c,waitUntil(b){if(Object.isFrozen(p))throw(0,T.illegalState)("waitUntil can not be called async");p.push(Promise.resolve(b))}});try{N.apply(D,[v])}catch(b){return Promise.reject(b)}return Object.freeze(p),new Promise((b,E)=>{const w=setTimeout(()=>E(new Error("timeout")),this.g.timeout);return Promise.all(p).then(r=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-f}ms`),clearTimeout(w),b(r)}).catch(r=>{clearTimeout(w),E(r)})}).then(b=>{const E={edits:[]};for(const w of b)if(Array.isArray(w)&&w.every(r=>r instanceof y.TextEdit))for(const{newText:r,newEol:a,range:o}of w)E.edits.push({resource:t.uri,versionId:void 0,textEdit:{range:o&&L.Range.from(o),text:r,eol:a&&L.EndOfLine.from(a)}});if(E.edits.length!==0)return l===t.version?this.f.$tryApplyWorkspaceEdit(E):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=O}),define(ke[187],Ce([1,0,13,2,8,6,67]),function(ee,e,i,T,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class O{constructor(D,m,p,f){this.start=D,this.deletedCount=m,this.deletedItems=p,this.items=f}asApiEvent(){return{range:new L.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(D,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:D}}constructor(D,m,p){this.notebook=D,this.h=m,this.j=p,this.handle=p.handle,this.uri=T.URI.revive(p.uri),this.cellKind=p.cellKind,this.a=p.outputs.map(y.NotebookCellOutput.to),this.e=p.internalMetadata??{},this.b=Object.freeze(p.metadata??{}),this.d=Object.freeze(y.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,m=this.h.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const p={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:y.NotebookCellKind.to(this.j.cellKind),document:m.document,get mime(){return D.g},set mime(f){D.g=f},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(p)}return this.f}setOutputs(D){this.a=D.map(y.NotebookCellOutput.to)}setOutputItems(D,m,p){const f=p.map(y.NotebookCellOutputItem.to),t=this.a.find(c=>c.id===D);if(t&&(m||(t.items.length=0),t.items.push(...f),t.items.length>1&&t.items.every(c=>k.isTextStreamMime(c.mime)))){const c=new Map,l=[];t.items.forEach(v=>{let b;c.has(v.mime)?b=c.get(v.mime):(b=[],c.set(v.mime,b),l.push(v.mime)),b.push(v.data)}),t.items.length=0,l.forEach(v=>{const b=k.compressOutputItemStreams(c.get(v));t.items.push({mime:v,data:b.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(y.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.ExtHostCell=S;class C{constructor(D,m,p,f,t){this.k=D,this.l=m,this.m=p,this.uri=f,this.handle=C.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=t.viewType,this.f=Object.freeze(t.metadata??Object.create(null)),this.r([[0,0,t.cells]],!0,void 0),this.g=t.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const D=this,m={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===i.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(p){return p=D.n(p),D.b[p].apiCell},getCells(p){return(p?D.p(p):D.b).map(t=>t.apiCell)},save(){return D.q()}};this.e=Object.freeze(m)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,m,p){this.g=D.versionId,this.h=m,this.acceptDocumentPropertiesChanged({metadata:p});const f={notebook:this.apiNotebook,metadata:p,cellChanges:[],contentChanges:[]},t=[];for(const l of D.rawEvents)l.kind===k.NotebookCellsChangeType.ModelChange?this.r(l.changes,!1,f.contentChanges):l.kind===k.NotebookCellsChangeType.Move?this.s(l.index,l.length,l.newIdx,f.contentChanges):l.kind===k.NotebookCellsChangeType.Output?(this.t(l.index,l.outputs),t.push({cell:this.b[l.index].apiCell,outputs:this.b[l.index].apiCell.outputs})):l.kind===k.NotebookCellsChangeType.OutputItem?(this.u(l.index,l.outputId,l.append,l.outputItems),t.push({cell:this.b[l.index].apiCell,outputs:this.b[l.index].apiCell.outputs})):l.kind===k.NotebookCellsChangeType.ChangeCellLanguage?(this.v(l.index,l.language),t.push({cell:this.b[l.index].apiCell,document:this.b[l.index].apiCell.document})):l.kind===k.NotebookCellsChangeType.ChangeCellContent?t.push({cell:this.b[l.index].apiCell,document:this.b[l.index].apiCell.document}):l.kind===k.NotebookCellsChangeType.ChangeCellMime?this.w(l.index,l.mime):l.kind===k.NotebookCellsChangeType.ChangeCellMetadata?(this.x(l.index,l.metadata),t.push({cell:this.b[l.index].apiCell,metadata:this.b[l.index].apiCell.metadata})):l.kind===k.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(l.index,l.internalMetadata),t.push({cell:this.b[l.index].apiCell,executionSummary:this.b[l.index].apiCell.executionSummary}));const c=new Map;for(let l=0;l<t.length;l++){const v=t[l],b=c.get(v.cell);if(b===void 0){const E=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...v});c.set(v.cell,E-1)}else f.cellChanges[b]={...f.cellChanges[b],...v}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let m=D.start|0,p=D.end|0;return m<0&&(m=0),p>this.b.length&&(p=this.b.length),D.with({start:m,end:p})}p(D){D=this.o(D);const m=[];for(let p=D.start;p<D.end;p++)m.push(this.b[p]);return m}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,m,p){if(this.j)return;const f=[],t=[],c=[];if(D.reverse().forEach(l=>{const b=l[2].map(r=>{const a=new S(this,this.l,r);return m||t.push(S.asModelAddData(this.apiNotebook,r)),a}),E=new O(l[0],l[1],[],b),w=this.b.splice(l[0],l[1],...b);for(const r of w)c.push(r.uri),E.deletedItems.push(r.apiCell);f.push(E)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:t,removedDocuments:c}),p)for(const l of f)p.push(l.asApiEvent())}s(D,m,p,f){const t=this.b.splice(D,m);this.b.splice(p,0,...t);const c=[new O(D,m,t.map(l=>l.apiCell),[]),new O(p,0,[],t)];for(const l of c)f.push(l.asApiEvent())}t(D,m){this.b[D].setOutputs(m)}u(D,m,p,f){this.b[D].setOutputItems(m,p,f)}v(D,m){const p=this.b[D];p.apiCell.document.languageId!==m&&this.m.$acceptModelLanguageChanged(p.uri,m)}w(D,m){const p=this.b[D];p.apiCell.mime=m}x(D,m){this.b[D].setMetadata(m)}y(D,m){this.b[D].setInternalMetadata(m)}getCellFromApiCell(D){return this.b.find(m=>m.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find(m=>m.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}e.ExtHostNotebookDocument=C,C.a=0}),define(ke[98],Ce([1,0,11,8,6]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class L{constructor(O,S,C,N,D,m){this.id=O,this.f=S,this.notebookData=C,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=N,this.c=m}get apiEditor(){if(!this.e){const O=this;this.e={get notebook(){return O.notebookData.apiNotebook},get selection(){return O.a[0]},set selection(S){this.selections=[S]},get selections(){return O.a},set selections(S){if(!Array.isArray(S)||!S.every(y.NotebookRange.isNotebookRange))throw(0,i.illegalArgument)("selections");O.a=S,O.g(S)},get visibleRanges(){return O.b},revealRange(S,C){O.f.$tryRevealRange(O.id,T.NotebookRange.from(S),C??y.NotebookEditorRevealType.Default)},get viewColumn(){return O.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(O){this.d=O}_acceptVisibleRanges(O){this.b=O}_acceptSelections(O){this.a=O}g(O){this.f.$trySetSelections(this.id,O.map(T.NotebookRange.from))}_acceptViewColumn(O){this.c=O}}e.ExtHostNotebookEditor=L,L.apiEditorsToExtHost=new WeakMap}),define(ke[188],Ce([1,0,5,12,8]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let L=class{constructor(O,S){this.c=O,this.d=S,this.a=new i.Emitter,this.b=new i.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(O,S){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",O,S);const C=this.d.getEditorById(O);S.visibleRanges&&C._acceptVisibleRanges(S.visibleRanges.ranges.map(y.NotebookRange.to)),S.selections&&C._acceptSelections(S.selections.selections.map(y.NotebookRange.to)),S.visibleRanges&&this.b.fire({notebookEditor:C.apiEditor,visibleRanges:C.apiEditor.visibleRanges}),S.selections&&this.a.fire(Object.freeze({notebookEditor:C.apiEditor,selections:C.apiEditor.selections}))}$acceptEditorViewColumns(O){for(const S in O)this.d.getEditorById(S)._acceptViewColumn(y.ViewColumn.to(O[S]))}};L=qe([Ve(0,T.ILogService)],L),e.ExtHostNotebookEditors=L}),define(ke[189],Ce([1,0,8,157,136,20,61,11]),function(ee,e,i,T,y,L,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(m){this.b=0,this.c=new Map,this.a=m}async withProgress(m,p,f){const t=this.b++,{title:c,location:l,cancellable:v}=p,b={label:(0,y.localize)(0,null,m.displayName||m.name),id:m.identifier.value};return this.a.$startProgress(t,{location:i.ProgressLocation.from(l),title:c,source:b,cancellable:v},m.isUnderDevelopment?void 0:m.identifier.value).catch(O.onUnexpectedExternalError),this.d(t,f,!!v)}d(m,p,f){let t;f&&(t=new L.CancellationTokenSource,this.c.set(m,t));const c=v=>{this.a.$progressEnd(v),this.c.delete(v),t?.dispose()};let l;try{l=p(new N(this.a,m),f&&t?t.token:L.CancellationToken.None)}catch(v){throw c(m),v}return l.then(v=>c(m),v=>c(m)),l}$acceptProgressCanceled(m){const p=this.c.get(m);p&&(p.cancel(),this.c.delete(m))}}e.ExtHostProgress=S;function C(D,m){return D.message=m.message,typeof m.increment=="number"&&(typeof D.increment=="number"?D.increment+=m.increment:D.increment=m.increment),D}class N extends T.Progress{constructor(m,p){super(f=>this.throttledReport(f)),this.c=m,this.d=p}throttledReport(m){this.c.$progressReport(this.d,m)}}qe([(0,k.throttle)(100,(D,m)=>C(D,m),()=>Object.create(null))],N.prototype,"throttledReport",null)}),define(ke[99],Ce([1,0,55,94,42,68,54,8,2]),function(ee,e,i,T,y,L,k,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const C=(b,E,w,r)=>{let a=E;return{enumerable:!0,configurable:!1,get(){return a},set(o){if(!w(a,o)){const d=a;a=o,b.listener?.(r(o,d))}}}},N=(b,E)=>b===E,D={range:(b,E)=>b===E?!0:!b||!E?!1:b.isEqual(E),label:N,description:N,sortText:N,busy:N,error:N,canResolveChildren:N,tags:(b,E)=>!(b.length!==E.length||b.some(w=>!E.find(r=>w.id===r.id)))},m=b=>E=>({op:4,update:b(E)}),p=(b,E)=>({range:(()=>{let w;const r=m(a=>({range:i.Range.lift(O.Range.from(a))}));return{enumerable:!0,configurable:!1,get(){return w},set(a){b.listener?.({op:6}),D.range(w,a)||(w=a,b.listener?.(r(a)))}}})(),label:C(b,E,D.label,m(w=>({label:w}))),description:C(b,void 0,D.description,m(w=>({description:w}))),sortText:C(b,void 0,D.sortText,m(w=>({sortText:w}))),canResolveChildren:C(b,!1,D.canResolveChildren,w=>({op:2,state:w})),busy:C(b,!1,D.busy,m(w=>({busy:w}))),error:C(b,void 0,D.error,m(w=>({error:O.MarkdownString.fromStrict(w)||null}))),tags:C(b,[],D.tags,(w,r)=>({op:1,new:w.map(O.TestTag.from),old:r.map(O.TestTag.from)}))}),f=b=>{const E=y.TestId.fromString(b.extId),w=new c(E.controllerId,E.localId,b.label,S.URI.revive(b.uri)||void 0);return w.range=O.Range.to(b.range||void 0),w.description=b.description||void 0,w.sortText=b.sortText||void 0,w.tags=b.tags.map(r=>O.TestTag.to({id:(0,k.denamespaceTestTag)(r).tagId})),w},t=b=>{let E;for(const w of b.tests){const r=f(w.item);(0,T.getPrivateApiFor)(r).parent=E,E=r}return E};e.toItemFromContext=t;class c{constructor(E,w,r,a){if(w.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(w)} symbol`);const o=(0,T.createPrivateApiFor)(this,E);Object.defineProperties(this,{id:{value:w,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return o.parent instanceof l?void 0:o.parent}},children:{value:(0,L.createTestItemChildren)(o,T.getPrivateApiFor,c),enumerable:!0,writable:!1},...p(o,r)})}}e.TestItemImpl=c;class l extends c{constructor(E,w){super(E,E,w,void 0),this._isRoot=!0}}e.TestItemRootImpl=l;class v extends L.TestItemCollection{constructor(E,w,r){super({controllerId:E,getDocumentVersion:a=>a&&r.getDocument(a)?.version,getApiFor:T.getPrivateApiFor,getChildren:a=>a.children,root:new l(E,w),toITestItem:O.TestItem.from})}}e.ExtHostTestItemCollection=v}),define(ke[100],Ce([1,0,47,11,81,8,6]),function(ee,e,i,T,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class O{constructor(m,p,f){const t=O.c.nextId();m.$registerTextEditorDecorationType(p.identifier,t,L.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:t,dispose(){m.$removeTextEditorDecorationType(t)}})}}e.TextEditorDecorationType=O,O.c=new y.IdGenerator("TextEditorDecorationType");class S{constructor(m,p){this.g=[],this.h=void 0,this.j=!1,this.c=m,this.d=m.version,this.e=p.undoStopBefore,this.f=p.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(m,p){this.k();let f=null;if(m instanceof k.Position)f=new k.Range(m,m);else if(m instanceof k.Range)f=m;else throw new Error("Unrecognized location");this.l(f,p,!1)}insert(m,p){this.k(),this.l(new k.Range(m,m),p,!0)}delete(m){this.k();let p=null;if(m instanceof k.Range)p=m;else throw new Error("Unrecognized location");this.l(p,null,!0)}l(m,p,f){const t=this.c.validateRange(m);this.g.push({range:t,text:p,forceMoveMarkers:f})}setEndOfLine(m){if(this.k(),m!==k.EndOfLine.LF&&m!==k.EndOfLine.CRLF)throw(0,T.illegalArgument)("endOfLine");this.h=m}}class C{constructor(m,p,f,t){this.c=m,this.d=p,this._accept(f),this.e=t;const c=this;this.value={get tabSize(){return c.f},set tabSize(l){c.m(l)},get indentSize(){return c.g},set indentSize(l){c.o(l)},get insertSpaces(){return c.h},set insertSpaces(l){c.q(l)},get cursorStyle(){return c.j},set cursorStyle(l){c.s(l)},get lineNumbers(){return c.k},set lineNumbers(l){c.t(l)}}}_accept(m){this.f=m.tabSize,this.g=m.indentSize,this.h=m.insertSpaces,this.j=m.cursorStyle,this.k=L.TextEditorLineNumbersStyle.to(m.lineNumbers)}l(m){if(m==="auto")return"auto";if(typeof m=="number"){const p=Math.floor(m);return p>0?p:null}if(typeof m=="string"){const p=parseInt(m,10);return isNaN(p)?null:p>0?p:null}return null}m(m){const p=this.l(m);if(p!==null){if(typeof p=="number"){if(this.f===p)return;this.f=p}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:p}))}}n(m){if(m==="tabSize")return"tabSize";if(typeof m=="number"){const p=Math.floor(m);return p>0?p:null}if(typeof m=="string"){const p=parseInt(m,10);return isNaN(p)?null:p>0?p:null}return null}o(m){const p=this.n(m);if(p!==null){if(typeof p=="number"){if(this.g===p)return;this.g=p}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:p}))}}p(m){return m==="auto"?"auto":m==="false"?!1:Boolean(m)}q(m){const p=this.p(m);if(typeof p=="boolean"){if(this.h===p)return;this.h=p}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:p}))}s(m){this.j!==m&&(this.j=m,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:m})))}t(m){this.k!==m&&(this.k=m,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(m)})))}assign(m){const p={};let f=!1;if(typeof m.tabSize<"u"){const t=this.l(m.tabSize);t==="auto"?(f=!0,p.tabSize=t):typeof t=="number"&&this.f!==t&&(this.f=t,f=!0,p.tabSize=t)}if(typeof m.indentSize<"u"){const t=this.n(m.indentSize);t==="tabSize"?(f=!0,p.indentSize=t):typeof t=="number"&&this.g!==t&&(this.g=t,f=!0,p.indentSize=t)}if(typeof m.insertSpaces<"u"){const t=this.p(m.insertSpaces);t==="auto"?(f=!0,p.insertSpaces=t):this.h!==t&&(this.h=t,f=!0,p.insertSpaces=t)}typeof m.cursorStyle<"u"&&this.j!==m.cursorStyle&&(this.j=m.cursorStyle,f=!0,p.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this.k!==m.lineNumbers&&(this.k=m.lineNumbers,f=!0,p.lineNumbers=L.TextEditorLineNumbersStyle.from(m.lineNumbers)),f&&this.u("setOptions",this.c.$trySetOptions(this.d,p))}u(m,p){p.catch(f=>{this.e.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this.e.warn(f)})}}e.ExtHostTextEditorOptions=C;class N{constructor(m,p,f,t,c,l,v,b){this.id=m,this.j=p,this.k=f,this.g=!1,this.h=new Set,this.c=c,this.d=new C(this.j,this.id,l,f),this.e=v,this.f=b;const E=this;this.value=Object.freeze({get document(){return t.getValue()},set document(w){throw(0,T.readonly)("document")},get selection(){return E.c&&E.c[0]},set selection(w){if(!(w instanceof k.Selection))throw(0,T.illegalArgument)("selection");E.c=[w],E.l()},get selections(){return E.c},set selections(w){if(!Array.isArray(w)||w.some(r=>!(r instanceof k.Selection)))throw(0,T.illegalArgument)("selections");E.c=w,E.l()},get visibleRanges(){return E.e},set visibleRanges(w){throw(0,T.readonly)("visibleRanges")},get options(){return E.d.value},set options(w){E.g||E.d.assign(w)},get viewColumn(){return E.f},set viewColumn(w){throw(0,T.readonly)("viewColumn")},edit(w,r={undoStopBefore:!0,undoStopAfter:!0}){if(E.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const a=new S(t.getValue(),r);return w(a),E.m(a)},insertSnippet(w,r,a={undoStopBefore:!0,undoStopAfter:!0}){if(E.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!r||Array.isArray(r)&&r.length===0)o=E.c.map(d=>L.Range.from(d));else if(r instanceof k.Position){const{lineNumber:d,column:s}=L.Position.from(r);o=[{startLineNumber:d,startColumn:s,endLineNumber:d,endColumn:s}]}else if(r instanceof k.Range)o=[L.Range.from(r)];else{o=[];for(const d of r)if(d instanceof k.Range)o.push(L.Range.from(d));else{const{lineNumber:s,column:u}=L.Position.from(d);o.push({startLineNumber:s,startColumn:u,endLineNumber:s,endColumn:u})}}return p.$tryInsertSnippet(m,t.getValue().version,w.value,o,a)},setDecorations(w,r){const a=r.length===0;a&&!E.h.has(w.key)||(a?E.h.delete(w.key):E.h.add(w.key),E.n(()=>{if(L.isDecorationOptionsArr(r))return p.$trySetDecorations(m,w.key,L.fromRangeOrRangeWithMessage(r));{const o=new Array(4*r.length);for(let d=0,s=r.length;d<s;d++){const u=r[d];o[4*d]=u.start.line+1,o[4*d+1]=u.start.character+1,o[4*d+2]=u.end.line+1,o[4*d+3]=u.end.character+1}return p.$trySetDecorationsFast(m,w.key,o)}}))},revealRange(w,r){E.n(()=>p.$tryRevealRange(m,L.Range.from(w),r||k.TextEditorRevealType.Default))},show(w){p.$tryShowEditor(m,L.ViewColumn.from(w))},hide(){p.$tryHideEditor(m)}})}dispose(){(0,i.ok)(!this.g),this.g=!0}_acceptOptions(m){(0,i.ok)(!this.g),this.d._accept(m)}_acceptVisibleRanges(m){(0,i.ok)(!this.g),this.e=m}_acceptViewColumn(m){(0,i.ok)(!this.g),this.f=m}_acceptSelections(m){(0,i.ok)(!this.g),this.c=m}async l(){const m=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,m)),this.value}m(m){const p=m.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const f=p.edits.map(c=>c.range);f.sort((c,l)=>c.end.line===l.end.line?c.end.character===l.end.character?c.start.line===l.start.line?c.start.character-l.start.character:c.start.line-l.start.line:c.end.character-l.end.character:c.end.line-l.end.line);for(let c=0,l=f.length-1;c<l;c++){const v=f[c].end;if(f[c+1].start.isBefore(v))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const t=p.edits.map(c=>({range:L.Range.from(c.range),text:c.text,forceMoveMarkers:c.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,p.documentVersionId,t,{setEndOfLine:typeof p.setEndOfLine=="number"?L.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}n(m){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this.k.warn(p),null))}}e.ExtHostTextEditor=N}),define(ke[190],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[191],Ce([1,0,147,11,29,87,90,30,25,190,156,149]),function(ee,e,i,T,y,L,k,O,S,C,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const m=O.Registry.as(k.Extensions.JSONContribution);class p{constructor(w,r,a){this.a=w,this.b=r,this.c=a}d(w,r){this.a({type:w,message:r,extensionId:this.b.identifier,extensionPointId:this.c})}error(w){this.d(y.default.Error,w)}warn(w){this.d(y.default.Warning,w)}info(w){this.d(y.default.Info,w)}}e.ExtensionMessageCollector=p;class f{static a(w){const r=new Set;for(let a=0,o=w.length;a<o;a++)r.add(S.ExtensionIdentifier.toKey(w[a].description.identifier));return r}static compute(w,r){if(!w||!w.length)return new f(r,[]);if(!r||!r.length)return new f([],w);const a=this.a(w),o=this.a(r),d=r.filter(u=>!a.has(S.ExtensionIdentifier.toKey(u.description.identifier))),s=w.filter(u=>!o.has(S.ExtensionIdentifier.toKey(u.description.identifier)));return new f(d,s)}constructor(w,r){this.added=w,this.removed=r}}e.ExtensionPointUserDelta=f;class t{constructor(w,r){this.name=w,this.defaultExtensionKind=r,this.a=null,this.b=null,this.c=null}setHandler(w){if(this.a!==null)throw new Error("Handler already set!");this.a=w,this.d()}acceptUsers(w){this.c=f.compute(this.b,w),this.b=w,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(w){(0,T.onUnexpectedError)(w)}}}e.ExtensionPoint=t;const c={type:"string",enum:["ui","workspace"],enumDescriptions:[i.localize(0,null),i.localize(1,null)]},l="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:i.localize(2,null),properties:{vscode:{type:"string",description:i.localize(3,null),default:"^1.22.0"}}},publisher:{description:i.localize(4,null),type:"string"},displayName:{description:i.localize(5,null),type:"string"},categories:{description:i.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:i.localize(7,null)}]}},galleryBanner:{type:"object",description:i.localize(8,null),properties:{color:{description:i.localize(9,null),type:"string"},theme:{description:i.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:i.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:i.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:i.localize(13,null)},enabledApiProposals:{markdownDescription:i.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(C.allApiProposals),markdownEnumDescriptions:Object.values(C.allApiProposals)}},api:{markdownDescription:i.localize(15,null),type:"string",enum:["none"],enumDescriptions:[i.localize(16,null)]},activationEvents:{description:i.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:i.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:i.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:i.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:i.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:i.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:i.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:i.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:i.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:i.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:i.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:i.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:i.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:i.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:i.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:i.localize(32,null)},{label:"onUri",body:"onUri",description:i.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:i.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:i.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:i.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:i.localize(37,null)},{label:"onRenderer",description:i.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:i.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:i.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:i.localize(41,null)},{label:"*",description:i.localize(42,null),body:"*"}]}},badges:{type:"array",description:i.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:i.localize(44,null)},href:{type:"string",description:i.localize(45,null)},description:{type:"string",description:i.localize(46,null)}}}},markdown:{type:"string",description:i.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:i.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:i.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:i.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:i.localize(51,null),type:"array",items:c,default:["workspace"],defaultSnippets:[{body:["ui"],description:i.localize(52,null)},{body:["workspace"],description:i.localize(53,null)},{body:["ui","workspace"],description:i.localize(54,null)},{body:["workspace","ui"],description:i.localize(55,null)},{body:[],description:i.localize(56,null)}]},capabilities:{description:i.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:i.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:i.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[i.localize(60,null),i.localize(61,null),i.localize(62,null)]},description:{type:"string",markdownDescription:i.localize(63,null)}}},untrustedWorkspaces:{description:i.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:i.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[i.localize(66,null),i.localize(67,null),i.localize(68,null)]},restrictedConfigurations:{description:i.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:i.localize(70,null)}}}}},sponsor:{description:i.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:i.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:i.localize(73,null),type:"string"},"vscode:uninstall":{description:i.localize(74,null),type:"string"}}},icon:{type:"string",description:i.localize(75,null)},l10n:{type:"string",description:i.localize(76,null)}}};class v{constructor(){this.a=new Map}registerExtensionPoint(w){if(this.a.has(w.extensionPoint))throw new Error("Duplicate extension point: "+w.extensionPoint);const r=new t(w.extensionPoint,w.defaultExtensionKind);return this.a.set(w.extensionPoint,r),w.activationEventsGenerator&&D.ImplicitActivationEvents.register(w.extensionPoint,w.activationEventsGenerator),e.schema.properties.contributes.properties[w.extensionPoint]=w.jsonSchema,m.registerSchema(l,e.schema),r}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=v;const b={ExtensionsRegistry:"ExtensionsRegistry"};O.Registry.add(b.ExtensionsRegistry,new v),e.ExtensionsRegistry=O.Registry.as(b.ExtensionsRegistry),m.registerSchema(l,e.schema),m.registerSchema(N.productSchemaId,{properties:{extensionEnabledApiProposals:{description:i.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(C.allApiProposals),markdownEnumDescriptions:Object.values(C.allApiProposals)}}]}}}})}),define(ke[192],Ce([1,0,144,9,23,191,41,5]),function(ee,e,i,T,y,L,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:i.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:i.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:i.localize(2,null),default:""}}};var C;(function(m){function p(f,t,c){if(!f)return;const l=T.isString(f.type)?f.type:void 0;if(!l||l.length===0){c.error(i.localize(3,null));return}const v=[];if(Array.isArray(f.required))for(const b of f.required)T.isString(b)&&v.push(b);return{extensionId:t.value,taskType:l,required:v,properties:f.properties?y.deepClone(f.properties):{},when:f.when?k.ContextKeyExpr.deserialize(f.when):void 0}}m.from=p})(C||(C={}));const N=L.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:i.localize(4,null),type:"array",items:S}});class D{constructor(){this.d=new O.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((p,f)=>{N.setHandler((t,c)=>{this.c=void 0;try{for(const l of c.removed){const v=l.value;for(const b of v)this.a&&b.type&&this.a[b.type]&&delete this.a[b.type]}for(const l of c.added){const v=l.value;for(const b of v){const E=C.from(b,l.description.identifier,l.collector);E&&(this.a[E.taskType]=E)}}(c.removed.length>0||c.added.length>0)&&this.d.fire()}catch{}p(void 0)})})}onReady(){return this.b}get(p){return this.a[p]}all(){return Object.keys(this.a).map(p=>this.a[p])}getJsonSchema(){if(this.c===void 0){const p=[];for(const f of this.all()){const t={type:"object",additionalProperties:!1};f.required.length>0&&(t.required=f.required.slice(0)),f.properties!==void 0?t.properties=y.deepClone(f.properties):t.properties=Object.create(null),t.properties.type={type:"string",enum:[f.taskType]},p.push(t)}this.c={oneOf:p}}return this.c}}e.TaskDefinitionRegistry=new D}),define(ke[193],Ce([1,0,145,9,22,23,41,192]),function(ee,e,i,T,y,L,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new k.RawContextKey("taskRunning",!1,i.localize(0,null)),e.TASKS_CATEGORY={value:i.localize(1,null),original:"Tasks"};var S;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(S=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(F){function B(z){if(!z)return F.Strong;switch(z.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=B}(S=e.ShellQuoting||(e.ShellQuoting={}));var C;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(C=e.CommandOptions||(e.CommandOptions={}));var N;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(N=e.RevealKind||(e.RevealKind={})),function(F){function B(z){switch(z.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=B}(N=e.RevealKind||(e.RevealKind={}));var D;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(D=e.RevealProblemKind||(e.RevealProblemKind={})),function(F){function B(z){switch(z.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=B}(D=e.RevealProblemKind||(e.RevealProblemKind={}));var m;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(m=e.PanelKind||(e.PanelKind={})),function(F){function B(z){switch(z.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=B}(m=e.PanelKind||(e.PanelKind={}));var p;(function(F){F.defaults={echo:!0,reveal:N.Always,revealProblems:D.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(p=e.PresentationOptions||(e.PresentationOptions={}));var f;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(f=e.RuntimeType||(e.RuntimeType={})),function(F){function B(V){switch(V.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=B;function z(V){switch(V){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=z}(f=e.RuntimeType||(e.RuntimeType={}));var t;(function(F){function B(z){return T.isString(z)?z:z.value}F.value=B})(t=e.CommandString||(e.CommandString={}));var c;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function B(V){return V===F.Clean._id||V===F.Build._id||V===F.Rebuild._id||V===F.Test._id}F.is=B;function z(V){if(V!==void 0)return T.isString(V)?B(V)?{_id:V,isDefault:!1}:void 0:V}F.from=z})(c=e.TaskGroup||(e.TaskGroup={}));var l;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(l=e.TaskScope||(e.TaskScope={}));var v;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function B(z){switch(z){case F.User:return 2;case F.WorkspaceFile:return 5;default:return 6}}F.toConfigurationTarget=B})(v=e.TaskSourceKind||(e.TaskSourceKind={}));var b;(function(F){F.parallel="parallel",F.sequence="sequence"})(b=e.DependsOrder||(e.DependsOrder={}));var E;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(E=e.RunOnOptions||(e.RunOnOptions={}));var w;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:E.default,instanceLimit:1}})(w=e.RunOptions||(e.RunOptions={}));class r{constructor(B,z,V,K,ie,me){this._label="",this._id=B,z&&(this._label=z),V&&(this.type=V),this.runOptions=K,this.configurationProperties=ie,this._source=me}getDefinition(B){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const B={folder:this.d(),id:this._id};return JSON.stringify(B)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(B,z=!1){if(B===void 0)return!1;if(T.isString(B))return B===this._label||B===this.configurationProperties.identifier||z&&B===this._id;const V=this.getDefinition(!0);return V!==void 0&&V._key===B._key}getQualifiedLabel(){const B=this.getWorkspaceFolder();return B?`${this._label} (${B.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(B){this.c===void 0&&(this.c=[]),B&&(this.c=this.c.concat(B))}get taskLoadMessages(){return this.c}}e.CommonTask=r;class a extends r{constructor(B,z,V,K,ie,me,ue,oe){super(B,V,void 0,ue,oe,z),this.command={},this._source=z,this.hasDefinedMatchers=me,ie&&(this.command=ie)}clone(){return new a(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(B=!1){if(B&&this._source.customizes!==void 0)return this._source.customizes;{let z;switch(this.command?this.command.runtime:void 0){case f.Shell:z="shell";break;case f.Process:z="process";break;case f.CustomExecution:z="customExecution";break;case void 0:z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:z,_key:this._id,id:this._id}}}static is(B){return B instanceof a}getMapKey(){const B=this._source.config.workspaceFolder;return B?`${B.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const B=this.d();if(!B)return;let z=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(z+=this._source.kind);const V={type:e.CUSTOMIZED_TASK_TYPE,folder:B,id:z};return JSON.stringify(V)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?y.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(B){return new a(B._id,B._source,B._label,B.type,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.CustomTask=a;class o extends r{constructor(B,z,V,K,ie,me,ue){super(B,V,K,me,ue,z),this._source=z,this.configures=ie}static is(B){return B instanceof o}f(B){return B}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?y.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const B=this.d();if(!B)return;let z=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(z+=this._source.kind);const V={type:e.CUSTOMIZED_TASK_TYPE,folder:B,id:z};return JSON.stringify(V)}}e.ConfiguringTask=o;class d extends r{constructor(B,z,V,K,ie,me,ue,oe,De){super(B,V,K,oe,De,z),this.defines=ie,this.hasDefinedMatchers=ue,this.command=me,this.icon=De.icon,this.hide=De.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(B){return B instanceof d}getMapKey(){const B=this._source.workspaceFolder;return B?`${this._source.scope.toString()}|${B.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const B={type:"contributed",scope:this._source.scope,id:this._id};return B.folder=this.d(),JSON.stringify(B)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(B){return new d(B._id,B._source,B._label,B.type,B.defines,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.ContributedTask=d;class s extends r{constructor(B,z,V,K,ie,me){super(B,V,K,ie,me,z),this._source=z}clone(){return new s(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(B){return B instanceof s}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(B){return new s(B._id,B._source,B._label,B.type,B.runOptions,B.configurationProperties)}}e.InMemoryTask=s;var u;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(u=e.ExecutionEngine||(e.ExecutionEngine={})),function(F){F._default=F.Terminal}(u=e.ExecutionEngine||(e.ExecutionEngine={}));var n;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(n=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class h{constructor(B){this.c=new Map;for(let z=0;z<B.length;z++)this.c.set(B[z].uri.toString(),z)}compare(B,z){const V=B.getWorkspaceFolder(),K=z.getWorkspaceFolder();if(V&&K){let ie=this.c.get(V.uri.toString());ie=ie===void 0?0:ie+1;let me=this.c.get(K.uri.toString());return me=me===void 0?0:me+1,ie===me?B._label.localeCompare(z._label):ie-me}else return!V&&K?-1:V&&!K?1:0}}e.TaskSorter=h;var g;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(g=e.TaskEventKind||(e.TaskEventKind={}));var P;(function(F){F.SingleRun="singleRun",F.Background="background"})(P=e.TaskRunType||(e.TaskRunType={}));var M;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(M=e.TaskRunSource||(e.TaskRunSource={}));var j;(function(F){function B(z,V,K,ie){if(V){const me={kind:z,taskId:V._id,taskName:V.configurationProperties.name,runType:V.configurationProperties.isBackground?"background":"singleRun",group:V.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:K,__task:V};return z==="start"?me.resolvedVariables=ie:z==="processStarted"?me.processId=ie:z==="processEnded"&&(me.exitCode=ie),Object.freeze(me)}else return Object.freeze({kind:"changed"})}F.create=B})(j=e.TaskEvent||(e.TaskEvent={}));var Z;(function(F){function B(V){const K=Object.keys(V).sort();let ie="";for(const me of K){let ue=V[me];ue instanceof Object?ue=B(ue):typeof ue=="string"&&(ue=ue.replace(/,/g,",,")),ie+=me+","+ue+","}return ie}function z(V){const ie={_key:B(V),type:V.taskType};return Object.assign(ie,V),ie}F.create=z})(Z=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var G;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection"})(G=e.TaskSettingId||(e.TaskSettingId={}));var A;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(A=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var R;(function(F){function B(z,V){const K=O.TaskDefinitionRegistry.get(z.type);if(K===void 0){const oe=L.deepClone(z);return delete oe._key,Z.create(oe)}const ie=Object.create(null);ie.type=K.taskType;const me=new Set;K.required.forEach(oe=>me.add(oe));const ue=K.properties;for(const oe of Object.keys(ue)){const De=z[oe];if(De!=null)ie[oe]=De;else if(me.has(oe)){const re=ue[oe];if(re.default!==void 0)ie[oe]=L.deepClone(re.default);else switch(re.type){case"boolean":ie[oe]=!1;break;case"number":case"integer":ie[oe]=0;break;case"string":ie[oe]="";break;default:V.error(i.localize(2,null,JSON.stringify(z,void 0,0),oe));return}}}return Z.create(ie)}F.createTaskIdentifier=B})(R=e.TaskDefinition||(e.TaskDefinition={}))}),define(ke[194],Ce([1,0,11]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((k,O)=>{this.b=k,this.d=O,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(k){this.f||this.h||(this.f=!0,this.g=k,this.a&&this.b(k))}resolveErr(k){this.f||this.h||(this.h=!0,this.i=k,this.a?this.d(k):(0,i.onUnexpectedError)(k))}then(k,O){return this.j().then(k,O)}catch(k){return this.j().then(void 0,k)}finally(k){return this.j().finally(k)}}e.LazyPromise=T;class y extends T{constructor(){super(),this.h=!0,this.i=new i.CancellationError}}e.CanceledLazyPromise=y}),define(ke[43],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class i{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++i.count}}e.ProxyIdentifier=i,i.count=0;const T=[];function y(O){const S=new i(O);return T[S.nid]=S,S}e.createProxyIdentifier=y;function L(O){return T[O].sid}e.getStringIdentifierForProxy=L;class k{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=k}),define(ke[4],Ce([1,0,43]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(t){t[t.Default=0]="Default",t[t.InCenter=1]="InCenter",t[t.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",t[t.AtTop=3]="AtTop"})(T=e.TextEditorRevealType||(e.TextEditorRevealType={}));var y;(function(t){t[t.UnknownInput=0]="UnknownInput",t[t.TextInput=1]="TextInput",t[t.TextDiffInput=2]="TextDiffInput",t[t.TextMergeInput=3]="TextMergeInput",t[t.NotebookInput=4]="NotebookInput",t[t.NotebookDiffInput=5]="NotebookDiffInput",t[t.CustomEditorInput=6]="CustomEditorInput",t[t.WebviewEditorInput=7]="WebviewEditorInput",t[t.TerminalEditorInput=8]="TerminalEditorInput",t[t.InteractiveEditorInput=9]="InteractiveEditorInput"})(y=e.TabInputKind||(e.TabInputKind={}));var L;(function(t){t[t.TAB_OPEN=0]="TAB_OPEN",t[t.TAB_CLOSE=1]="TAB_CLOSE",t[t.TAB_UPDATE=2]="TAB_UPDATE",t[t.TAB_MOVE=3]="TAB_MOVE"})(L=e.TabModelOperationKind||(e.TabModelOperationKind={}));var k;(function(t){t[t.Editable=0]="Editable",t[t.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var O;(function(t){t[t.Int8Array=1]="Int8Array",t[t.Uint8Array=2]="Uint8Array",t[t.Uint8ClampedArray=3]="Uint8ClampedArray",t[t.Int16Array=4]="Int16Array",t[t.Uint16Array=5]="Uint16Array",t[t.Int32Array=6]="Int32Array",t[t.Uint32Array=7]="Uint32Array",t[t.Float32Array=8]="Float32Array",t[t.Float64Array=9]="Float64Array",t[t.BigInt64Array=10]="BigInt64Array",t[t.BigUint64Array=11]="BigUint64Array"})(O=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var S;(function(t){t[t.Text=1]="Text",t[t.Error=2]="Error",t[t.Rich=3]="Rich"})(S=e.CellOutputKind||(e.CellOutputKind={}));var C;(function(t){t[t.Default=0]="Default",t[t.InCenter=1]="InCenter",t[t.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",t[t.AtTop=3]="AtTop"})(C=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var N;(function(t){t[t.None=0]="None",t[t.Process=1]="Process",t[t.Output=2]="Output"})(N=e.CandidatePortSource||(e.CandidatePortSource={}));class D{static mixin(c){return c._id=D.a++,c}}e.IdObject=D,D.a=0;var m;(function(t){t.label="a",t.kind="b",t.detail="c",t.documentation="d",t.sortText="e",t.filterText="f",t.preselect="g",t.insertText="h",t.insertTextRules="i",t.range="j",t.commitCharacters="k",t.additionalTextEdits="l",t.kindModifier="m",t.commandIdent="n",t.commandId="o",t.commandArguments="p"})(m=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var p;(function(t){t.defaultRanges="a",t.completions="b",t.isIncomplete="c",t.duration="d"})(p=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var f;(function(t){t[t.Workspace=0]="Workspace",t[t.TextDocument=1]="TextDocument"})(f=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,i.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,i.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,i.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,i.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,i.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,i.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,i.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,i.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,i.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,i.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,i.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,i.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,i.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,i.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,i.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,i.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,i.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,i.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,i.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,i.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,i.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,i.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,i.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,i.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,i.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,i.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,i.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,i.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,i.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,i.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,i.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,i.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,i.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,i.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,i.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,i.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,i.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,i.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,i.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,i.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,i.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,i.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,i.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,i.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,i.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,i.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,i.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,i.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,i.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,i.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,i.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,i.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,i.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,i.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,i.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,i.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,i.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,i.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,i.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,i.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,i.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,i.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,i.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,i.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,i.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,i.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,i.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,i.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,i.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,i.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,i.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,i.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,i.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,i.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,i.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,i.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,i.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,i.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,i.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,i.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,i.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,i.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,i.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,i.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,i.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,i.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,i.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,i.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,i.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,i.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,i.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,i.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,i.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,i.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,i.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,i.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,i.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,i.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,i.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,i.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,i.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,i.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,i.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,i.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,i.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,i.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,i.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,i.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,i.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,i.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,i.createProxyIdentifier)("ExtHostLocalization")}}),define(ke[73],Ce([1,0,3,12,4,15]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,i.createDecorator)("IExtHostApiDeprecationService");let k=class{constructor(S,C){this.c=C,this.a=new Set,this.b=S.getProxy(y.MainContext.MainThreadTelemetry)}report(S,C,N){const D=this.d(S,C);this.a.has(D)||(this.a.add(D),C.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${S}' is deprecated. ${N}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:C.identifier.value,apiId:S}))}d(S,C){return`${S}-${C.identifier.value}`}};k=qe([Ve(0,L.IExtHostRpcService),Ve(1,T.ILogService)],k),e.ExtHostApiDeprecationService=k,e.NullApiDeprecationService=Object.freeze(new class{report(O,S,C){}})}),define(ke[195],Ce([1,0,5,4,6,25]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class k{constructor(S){this.b=new Map,this.c=[],this.d=new i.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=S.getProxy(T.MainContext.MainThreadAuthentication)}$setProviders(S){return this.c=S,Promise.resolve()}async getSession(S,C,N,D={}){const m=L.ExtensionIdentifier.toKey(S.identifier),p=this.f.get(m)||[],f=[...N].sort().join(" ");let t=p.find(c=>c.providerId===C&&c.scopes===f);if(t)return t.result;{const c=this.g(S,m,C,N,D);t={providerId:C,scopes:f,result:c},p.push(t),this.f.set(m,p);try{await c}finally{const l=p.findIndex(v=>v.providerId===C&&v.scopes===f);l>-1&&(p.splice(l),this.f.set(m,p))}return c}}async g(S,C,N,D,m={}){await this.a.$ensureProvider(N);const p=S.displayName||S.name;return this.a.$getSession(N,D,C,p,m)}async removeSession(S,C){const N=this.b.get(S);return N?N.provider.removeSession(C):this.a.$removeSession(S,C)}registerAuthenticationProvider(S,C,N,D){if(this.b.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this.b.set(S,{label:C,provider:N,options:D??{supportsMultipleAccounts:!1}}),this.c.find(p=>p.id===S)||this.c.push({id:S,label:C});const m=N.onDidChangeSessions(p=>{this.a.$sendDidChangeSessions(S,{added:p.added??[],changed:p.changed??[],removed:p.removed??[]})});return this.a.$registerAuthenticationProvider(S,C,D?.supportsMultipleAccounts??!1),new y.Disposable(()=>{m.dispose(),this.b.delete(S);const p=this.c.findIndex(f=>f.id===S);p>-1&&this.c.splice(p),this.a.$unregisterAuthenticationProvider(S)})}$createSession(S,C){const N=this.b.get(S);if(N)return Promise.resolve(N.provider.createSession(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,C){const N=this.b.get(S);if(N)return Promise.resolve(N.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,C){const N=this.b.get(S);if(N)return Promise.resolve(N.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,C){return this.d.fire({provider:{id:S,label:C}}),Promise.resolve()}}e.ExtHostAuthentication=k}),define(ke[196],Ce([1,0,4,15,8]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let L=class{constructor(O,S){this.a=O.getProxy(i.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:C=>S.getDocument(C)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(O,S,C){const N=y.WorkspaceEdit.from(O,this.b);return this.a.$tryApplyWorkspaceEdit(N,void 0,C?.isRefactoring??!1)}};L=qe([Ve(0,T.IExtHostRpcService)],L),e.ExtHostBulkEdits=L}),define(ke[197],Ce([1,0,4]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class T{constructor(L){const k=L.getProxy(i.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return k.$readText()},writeText(O){return k.$writeText(O)}})}}e.ExtHostClipboard=T});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(ke[38],Ce([1,0,9,6,8,23,4,16,12,82,55,250,2,7,3,15,99,24,43,45,74,50]),function(ee,e,i,T,y,L,k,O,S,C,N,D,m,p,f,t,c,l,v,b,E,w){"use strict";var r,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let o=class{constructor(g,P){r.set(this,void 0),this.b=new Map,this.c=new Map,a.set(this,void 0),Je(this,r,g.getProxy(k.MainContext.MainThreadCommands),"f"),this.d=P,Je(this,a,g.getProxy(k.MainContext.MainThreadTelemetry),"f"),this.converter=new d(this,M=>{const j=this.c.get(M);return j?.result===u.Void?j:void 0},P),this.f=[{processArgument(M){return(0,C.revive)(M)}},{processArgument(M){return(0,L.cloneAndChange)(M,function(j){if(N.Range.isIRange(j))return y.Range.to(j);if(D.Position.isIPosition(j))return y.Position.to(j);if(N.Range.isIRange(j.range)&&m.URI.isUri(j.uri))return y.location.to(j);if(j instanceof l.VSBuffer)return j.buffer.buffer;if(!Array.isArray(j))return j})}}]}registerArgumentProcessor(g){this.f.push(g)}registerApiCommand(g){const P=this.registerCommand(!1,g.id,async(...M)=>{const j=g.args.map((G,A)=>{if(!G.validate(M[A]))throw new Error(`Invalid argument '${G.name}' when running '${g.id}', received: ${M[A]}`);return G.convert(M[A])}),Z=await this.executeCommand(g.internalId,...j);return g.result.convert(Z,M,this.converter)},void 0,{description:g.description,args:g.args,returns:g.result.description});return this.c.set(g.id,g),new T.Disposable(()=>{P.dispose(),this.c.delete(g.id)})}registerCommand(g,P,M,j,Z,G){if(this.d.trace("ExtHostCommands#registerCommand",P),!P.trim().length)throw new Error("invalid id");if(this.b.has(P))throw new Error(`command '${P}' already exists`);return this.b.set(P,{callback:M,thisArg:j,description:Z,extension:G}),g&&Oe(this,r,"f").$registerCommand(P),new T.Disposable(()=>{this.b.delete(P)&&g&&Oe(this,r,"f").$unregisterCommand(P)})}executeCommand(g,...P){return this.d.trace("ExtHostCommands#executeCommand",g),this.g(g,P,!0)}async g(g,P,M){if(this.b.has(g))return Oe(this,r,"f").$fireCommandActivationEvent(g),this.h(g,P,!1);{let j=!1;const Z=(0,L.cloneAndChange)(P,function(G){if(G instanceof T.Position)return y.Position.from(G);if(G instanceof T.Range)return y.Range.from(G);if(G instanceof T.Location)return y.location.from(G);if(T.NotebookRange.isNotebookRange(G))return y.NotebookRange.from(G);if(G instanceof ArrayBuffer)return j=!0,l.VSBuffer.wrap(new Uint8Array(G));if(G instanceof Uint8Array)return j=!0,l.VSBuffer.wrap(G);if(G instanceof l.VSBuffer)return j=!0,G;if(!Array.isArray(G))return G});try{const G=await Oe(this,r,"f").$executeCommand(g,j?new v.SerializableObjectWithBuffers(Z):Z,M);return(0,C.revive)(G)}catch(G){if(G instanceof Error&&G.message==="$executeCommand:retry")return this.g(g,P,!1);throw G}}}async h(g,P,M){const j=this.b.get(g);if(!j)throw new Error("Unknown command");const{callback:Z,thisArg:G,description:A}=j;if(A)for(let F=0;F<A.args.length;F++)try{(0,i.validateConstraint)(P[F],A.args[F].constraint)}catch{throw new Error(`Running the contributed command: '${g}' failed. Illegal argument '${A.args[F].name}' - ${A.args[F].description}`)}const R=E.StopWatch.create();try{return await Z.apply(G,P)}catch(F){if(g===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...P);B&&(g=B.command)}throw this.d.error(F,g,j.extension?.identifier),M?new class extends Error{constructor(){super((0,b.toErrorMessage)(F)),this.id=g,this.source=j.extension?.displayName??j.extension?.name}}:F}finally{this.j(j,g,R.elapsed())}}j(g,P,M){!g.extension||Oe(this,a,"f").$publicLog2("Extension:ActionExecuted",{extensionId:g.extension.identifier.value,id:new w.TrustedTelemetryValue(P),duration:M})}$executeContributedCommand(g,...P){this.d.trace("ExtHostCommands#$executeContributedCommand",g);const M=this.b.get(g);return M?(P=P.map(j=>this.f.reduce((Z,G)=>G.processArgument(Z,M.extension?.identifier),j)),this.h(g,P,!0)):Promise.reject(new Error(`Contributed command '${g}' does not exist.`))}getCommands(g=!1){return this.d.trace("ExtHostCommands#getCommands",g),Oe(this,r,"f").$getCommands().then(P=>(g&&(P=P.filter(M=>M[0]!=="_")),P))}$getContributedCommandHandlerDescriptions(){const g=Object.create(null);for(const[P,M]of this.b){const{description:j}=M;j&&(g[P]=j)}return Promise.resolve(g)}};r=new WeakMap,a=new WeakMap,o=qe([Ve(0,t.IExtHostRpcService),Ve(1,S.ILogService)],o),e.ExtHostCommands=o,e.IExtHostCommands=(0,f.createDecorator)("IExtHostCommands");class d{constructor(g,P,M){this.d=g,this.f=P,this.g=M,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(g,P){if(!g)return;const M={$ident:void 0,id:g.command,title:g.title,tooltip:g.tooltip};if(!g.command)return M;const j=this.f(g.command);if(j)M.id=j.internalId,M.arguments=j.args.map((Z,G)=>Z.convert(g.arguments&&g.arguments[G]));else if((0,O.isNonEmptyArray)(g.arguments)){const Z=`${g.command}/${++this.c}`;this.b.set(Z,g),P.add((0,p.toDisposable)(()=>{this.b.delete(Z),this.g.trace("CommandsConverter#DISPOSE",Z)})),M.$ident=Z,M.id=this.delegatingCommandId,M.arguments=[Z],this.g.trace("CommandsConverter#CREATE",g.command,Z)}return M}fromInternal(g){return typeof g.$ident=="string"?this.b.get(g.$ident):{command:g.id,title:g.title,arguments:g.arguments}}getActualCommand(...g){return this.b.get(g[0])}h(...g){const P=this.getActualCommand(...g);return this.g.trace("CommandsConverter#EXECUTE",g[0],P?P.command:"MISSING"),P?this.d.executeCommand(P.command,...P.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${g[0]}`)}}e.CommandsConverter=d;class s{constructor(g,P,M,j){this.name=g,this.description=P,this.validate=M,this.convert=j}optional(){return new s(this.name,`(optional) ${this.description}`,g=>g==null||this.validate(g),g=>g===void 0?void 0:g===null?null:this.convert(g))}with(g,P){return new s(g??this.name,P??this.description,this.validate,this.convert)}}e.ApiCommandArgument=s,s.Uri=new s("uri","Uri of a text document",h=>m.URI.isUri(h),h=>h),s.Position=new s("position","A position in a text document",h=>T.Position.isPosition(h),y.Position.from),s.Range=new s("range","A range in a text document",h=>T.Range.isRange(h),y.Range.from),s.Selection=new s("selection","A selection in a text document",h=>T.Selection.isSelection(h),y.Selection.from),s.Number=new s("number","",h=>typeof h=="number",h=>h),s.String=new s("string","",h=>typeof h=="string",h=>h),s.CallHierarchyItem=new s("item","A call hierarchy item",h=>h instanceof T.CallHierarchyItem,y.CallHierarchyItem.from),s.TypeHierarchyItem=new s("item","A type hierarchy item",h=>h instanceof T.TypeHierarchyItem,y.TypeHierarchyItem.from),s.TestItem=new s("testItem","A VS Code TestItem",h=>h instanceof c.TestItemImpl,y.TestItem.from);class u{constructor(g,P){this.description=g,this.convert=P}}e.ApiCommandResult=u,u.Void=new u("no result",h=>h);class n{constructor(g,P,M,j,Z){this.id=g,this.internalId=P,this.description=M,this.args=j,this.result=Z}}e.ApiCommand=n}),define(ke[198],Ce([1,0,2,8,6,72,38,16,85,89,13]),function(ee,e,i,T,y,L,k,O,S,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const D=[new k.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",p(T.DocumentHighlight.to))),new k.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[k.ApiCommandArgument.Uri],new k.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,c)=>{if((0,O.isFalsyOrEmpty)(t))return;class l extends y.SymbolInformation{static to(b){const E=new l(b.name,T.SymbolKind.to(b.kind),b.containerName||"",new y.Location(c[0],T.Range.to(b.range)));return E.detail=b.detail,E.range=E.location.range,E.selectionRange=T.Range.to(b.selectionRange),E.children=b.children?b.children.map(l.to):[],E}}return t.map(l.to)})),new k.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[k.ApiCommandArgument.Uri,new k.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new k.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(T.TextEdit.to))),new k.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Range,new k.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new k.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(T.TextEdit.to))),new k.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position,new k.ApiCommandArgument("ch","Trigger character",t=>typeof t=="string",t=>t),new k.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new k.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(T.TextEdit.to))),new k.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new k.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new k.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new k.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new k.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location-instances.",p(T.location.to))),new k.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Hover-instances.",p(T.Hover.to))),new k.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[k.ApiCommandArgument.Uri,new k.ApiCommandArgument("position","A position in a text document",t=>Array.isArray(t)&&t.every(c=>y.Position.isPosition(c)),t=>t.map(T.Position.from))],new k.ApiCommandResult("A promise that resolves to an array of ranges.",t=>t.map(c=>{let l;for(const v of c.reverse())l=new y.SelectionRange(T.Range.to(v),l);return l}))),new k.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[k.ApiCommandArgument.String.with("query","Search string")],new k.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(T.WorkspaceSymbol.to))),new k.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(T.CallHierarchyItem.to))),new k.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[k.ApiCommandArgument.CallHierarchyItem],new k.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(T.CallHierarchyIncomingCall.to))),new k.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[k.ApiCommandArgument.CallHierarchyItem],new k.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(T.CallHierarchyOutgoingCall.to))),new k.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to a range and placeholder text.",t=>{if(!!t)return{range:T.Range.to(t.range),placeholder:t.text}})),new k.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position,k.ApiCommandArgument.String.with("newName","The new symbol name")],new k.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",t=>{if(!!t){if(t.rejectReason)throw new Error(t.rejectReason);return T.WorkspaceEdit.to(t)}})),new k.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new k.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(T.DocumentLink.to))),new k.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[k.ApiCommandArgument.Uri],new k.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(!!t)return new y.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new k.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[k.ApiCommandArgument.Uri],new k.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const c=(0,S.decodeSemanticTokensDto)(t);if(c.type==="full")return new y.SemanticTokens(c.data,void 0)})),new k.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Range.optional()],new k.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(!!t)return new y.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new k.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Range],new k.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const c=(0,S.decodeSemanticTokensDto)(t);if(c.type==="full")return new y.SemanticTokens(c.data,void 0)})),new k.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position,k.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),k.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new k.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(t,c,l)=>{if(!t)return new y.CompletionList([]);const v=t.suggestions.map(b=>T.CompletionItem.to(b,l));return new y.CompletionList(v,t.incomplete)})),new k.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position,k.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new k.ApiCommandResult("A promise that resolves to SignatureHelp.",t=>{if(t)return T.SignatureHelp.to(t)})),new k.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new k.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(t,c,l)=>p(v=>new y.CodeLens(T.Range.to(v.range),v.command&&l.fromInternal(v.command)))(t))),new k.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[k.ApiCommandArgument.Uri,new k.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>y.Range.isRange(t),t=>y.Selection.isSelection(t)?T.Selection.from(t):T.Range.from(t)),k.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),k.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new k.ApiCommandResult("A promise that resolves to an array of Command-instances.",(t,c,l)=>p(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return l.fromInternal(v.command)}else{const b=new y.CodeAction(v.title,v.kind?new y.CodeActionKind(v.kind):void 0);return v.edit&&(b.edit=T.WorkspaceEdit.to(v.edit)),v.command&&(b.command=l.fromInternal(v.command)),b.isPreferred=v.isPreferred,b}})(t))),new k.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[k.ApiCommandArgument.Uri],new k.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(c=>new y.ColorInformation(T.Range.to(c.range),T.Color.to(c.color))):[])),new k.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new k.ApiCommandArgument("color","The color to show and insert",t=>t instanceof y.Color,T.Color.from),new k.ApiCommandArgument("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:T.Range.from(t.range)}))],new k.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(T.ColorPresentation.to):[])),new k.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Range],new k.ApiCommandResult("A promise that resolves to an array of Inlay objects",(t,c,l)=>t.map(T.InlayHint.to.bind(void 0,l)))),new k.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new k.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",p(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(c=>T.NotebookExclusiveDocumentPattern.to(c))})))),new k.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Range],new k.ApiCommandResult("A promise that resolves to an array of InlineValue objects",t=>t.map(T.InlineValue.to))),new k.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new k.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",t=>i.URI.isUri(t)||typeof t=="string"&&(0,C.matchesSomeScheme)(t,N.Schemas.http,N.Schemas.https),t=>t),new k.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[T.ViewColumn.from(t),void 0]:[T.ViewColumn.from(t.viewColumn),T.TextEditorOpenOptions.from(t)])).optional(),k.ApiCommandArgument.String.with("label","").optional()],k.ApiCommandResult.Void),new k.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[k.ApiCommandArgument.Uri.with("resource","Resource to open"),k.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new k.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[T.ViewColumn.from(t),void 0]:[T.ViewColumn.from(t.viewColumn),T.TextEditorOpenOptions.from(t)])).optional()],k.ApiCommandResult.Void),new k.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[k.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),k.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),k.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new k.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[T.ViewColumn.from(t.viewColumn),T.TextEditorOpenOptions.from(t)]).optional()],k.ApiCommandResult.Void),new k.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(T.TypeHierarchyItem.to))),new k.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[k.ApiCommandArgument.TypeHierarchyItem],new k.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(T.TypeHierarchyItem.to))),new k.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[k.ApiCommandArgument.TypeHierarchyItem],new k.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(T.TypeHierarchyItem.to))),new k.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[k.ApiCommandArgument.TestItem],k.ApiCommandResult.Void),new k.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[k.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],k.ApiCommandResult.Void),new k.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[k.ApiCommandArgument.String.with("name","The context key name"),new k.ApiCommandArgument("value","The context key value",()=>!0,t=>t)],k.ApiCommandResult.Void)];class m{static register(c){D.forEach(c.registerApiCommand,c)}}e.ExtHostApiCommands=m;function p(t){return c=>{if(Array.isArray(c))return c.map(t)}}function f(t){if(!Array.isArray(t))return;const c=[];for(const l of t)L.isLocationLink(l)?c.push(T.DefinitionLink.to(l)):c.push(T.location.to(l));return c}}),define(ke[199],Ce([1,0,14,61,5,7,2,72,25,8,6,26,4]),function(ee,e,i,T,y,L,k,O,S,C,N,D,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function p(f,t,c){const l=f.getProxy(m.MainContext.MainThreadComments);class v{constructor(){this.b=new Map,this.c=new Map,t.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===6){const n=this.b.get(u.handle);return n?n.value:u}else if(u&&u.$mid===7){const n=this.b.get(u.commentControlHandle);if(!n)return u;const h=n.getCommentThread(u.commentThreadHandle);return h?h.value:u}else if(u&&(u.$mid===9||u.$mid===8)){const n=this.b.get(u.thread.commentControlHandle);if(!n)return u;const h=n.getCommentThread(u.thread.commentThreadHandle);return h?u.$mid===8?h.value:{thread:h.value,text:u.text}:u}else if(u&&u.$mid===10){const n=this.b.get(u.thread.commentControlHandle);if(!n)return u;const h=n.getCommentThread(u.thread.commentThreadHandle);if(!h)return u;const g=u.commentUniqueId,P=h.getCommentByUniqueId(g);return P||u}else if(u&&u.$mid===11){const n=this.b.get(u.thread.commentControlHandle);if(!n)return u;const h=n.getCommentThread(u.thread.commentThreadHandle);if(!h)return u;const g=u.text,P=u.commentUniqueId,M=h.getCommentByUniqueId(P);return M?(typeof M.body=="string"?M.body=g:M.body=new N.MarkdownString(g),M):u}return u}})}createCommentController(u,n,h){const g=v.a++,P=new E(u,g,n,h);this.b.set(P.handle,P);const M=this.c.get(S.ExtensionIdentifier.toKey(u.identifier))||[];return M.push(P),this.c.set(S.ExtensionIdentifier.toKey(u.identifier),M),P.value}$createCommentThreadTemplate(u,n,h){const g=this.b.get(u);!g||g.$createCommentThreadTemplate(n,h)}async $updateCommentThreadTemplate(u,n,h){const g=this.b.get(u);!g||g.$updateCommentThreadTemplate(n,h)}$deleteCommentThread(u,n){this.b.get(u)?.$deleteCommentThread(n)}$provideCommentingRanges(u,n,h){const g=this.b.get(u);if(!g||!g.commentingRangeProvider)return Promise.resolve(void 0);const P=c.getDocument(k.URI.revive(n));return(0,i.asPromise)(()=>g.commentingRangeProvider.provideCommentingRanges(P,h)).then(M=>M?M.map(j=>C.Range.from(j)):void 0)}$toggleReaction(u,n,h,g,P){const M=this.b.get(u);return!M||!M.reactionHandler?Promise.resolve(void 0):(0,i.asPromise)(()=>{const j=M.getCommentThread(n);if(j){const Z=j.getCommentByUniqueId(g.uniqueIdInThread);if(M!==void 0&&Z&&M.reactionHandler)return M.reactionHandler(Z,a(P))}return Promise.resolve(void 0)})}dispose(){}}v.a=0;class b{set threadId(u){this.n=u}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(u){u.isEqual(this.p)||(this.p=u,this.b.range=u,this.c.fire())}get range(){return this.p}set canReply(u){this.d!==u&&(this.d=u,this.b.canReply=u,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(u){this.e=u,this.b.label=u,this.c.fire()}get contextValue(){return this.f}set contextValue(u){this.f=u,this.b.contextValue=u,this.c.fire()}get comments(){return this.q}set comments(u){this.q=u,this.b.comments=u,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(u){this.g=u,this.b.collapsibleState=u,this.c.fire()}get state(){return(0,D.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h}set state(u){(0,D.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h=u,this.b.state=u,this.c.fire()}get isDisposed(){return this.j}constructor(u,n,h,g,P,M,j,Z){this.m=n,this.n=h,this.o=g,this.p=P,this.q=M,this.extensionDescription=j,this.r=Z,this.handle=b.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new y.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.MutableDisposable,this.l.value=new L.DisposableStore,this.n===void 0&&(this.n=`${u}.${this.handle}`),l.$createCommentThread(n,this.handle,this.n,this.o,C.Range.from(this.p),j.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=M,this.i.push({dispose:()=>{l.$deleteCommentThread(n,this.handle)}});const G=this;this.value={get uri(){return G.uri},get range(){return G.range},set range(A){G.range=A},get comments(){return G.comments},set comments(A){G.comments=A},get collapsibleState(){return G.collapsibleState},set collapsibleState(A){G.collapsibleState=A},get canReply(){return G.canReply},set canReply(A){G.canReply=A},get contextValue(){return G.contextValue},set contextValue(A){G.contextValue=A},get label(){return G.label},set label(A){G.label=A},get state(){return G.state},set state(A){G.state=A},dispose:()=>{G.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.DisposableStore);const u=h=>Object.prototype.hasOwnProperty.call(this.b,h),n={};u("range")&&(n.range=C.Range.from(this.p)),u("label")&&(n.label=this.label),u("contextValue")&&(n.contextValue=this.contextValue??null),u("comments")&&(n.comments=this.q.map(h=>w(this,h,this.k))),u("collapsibleState")&&(n.collapseState=o(this.g)),u("canReply")&&(n.canReply=this.canReply),u("state")&&(n.state=d(this.h)),u("isTemplate")&&(n.isTemplate=this.r),this.b={},l.$updateCommentThread(this.m,this.handle,this.n,this.o,n)}getCommentByUniqueId(u){for(const n of this.k){const h=n[0],g=n[1];if(u===g)return h}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(u=>u.dispose())}}b.a=0,qe([(0,T.debounce)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class E{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(u){this.b=u,l.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(u){this.c=u,l.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this.d}set options(u){this.d=u,l.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(u,n,h,g){this.f=u,this.g=n,this.h=h,this.i=g,this.a=new Map,l.$registerCommentController(this.handle,h,g);const P=this;this.value=Object.freeze({id:P.id,label:P.label,get options(){return P.options},set options(M){P.options=M},get commentingRangeProvider(){return P.commentingRangeProvider},set commentingRangeProvider(M){P.commentingRangeProvider=M},get reactionHandler(){return P.reactionHandler},set reactionHandler(M){P.reactionHandler=M},createCommentThread(M,j,Z){return P.createCommentThread(M,j,Z).value},dispose:()=>{P.dispose()}}),this.e=[],this.e.push({dispose:()=>{l.$unregisterCommentController(this.handle)}})}createCommentThread(u,n,h,g){if(typeof u=="string"){const P=new b(this.id,this.handle,u,n,h,g,this.f,!1);return this.a.set(P.handle,P),P}else{const P=new b(this.id,this.handle,void 0,u,n,h,this.f,!1);return this.a.set(P.handle,P),P}}$createCommentThreadTemplate(u,n){const h=new b(this.id,this.handle,void 0,k.URI.revive(u),C.Range.to(n),[],this.f,!0);return h.collapsibleState=O.CommentThreadCollapsibleState.Expanded,this.a.set(h.handle,h),h}$updateCommentThreadTemplate(u,n){const h=this.a.get(u);h&&(h.range=C.Range.to(n))}$deleteCommentThread(u){this.a.get(u)?.dispose(),this.a.delete(u)}getCommentThread(u){return this.a.get(u)}dispose(){this.a.forEach(u=>{u.dispose()}),this.e.forEach(u=>u.dispose())}}function w(s,u,n){let h=n.get(u);h||(h=++s.commentHandle,n.set(u,h));const g=u.author&&u.author.iconPath?u.author.iconPath.toString():void 0;return{mode:u.mode,contextValue:u.contextValue,uniqueIdInThread:h,body:typeof u.body=="string"?u.body:C.MarkdownString.from(u.body),userName:u.author.name,userIconPath:g,label:u.label,commentReactions:u.reactions?u.reactions.map(P=>r(P)):void 0,timestamp:u.timestamp?.toJSON()}}function r(s){return{label:s.label,iconPath:s.iconPath?C.pathOrURIToURI(s.iconPath):void 0,count:s.count,hasReacted:s.authorHasReacted}}function a(s){return{label:s.label||"",count:s.count||0,iconPath:s.iconPath?k.URI.revive(s.iconPath):"",authorHasReacted:s.hasReacted||!1}}function o(s){if(s!==void 0)switch(s){case N.CommentThreadCollapsibleState.Expanded:return O.CommentThreadCollapsibleState.Expanded;case N.CommentThreadCollapsibleState.Collapsed:return O.CommentThreadCollapsibleState.Collapsed}return O.CommentThreadCollapsibleState.Collapsed}function d(s){if(s!==void 0)switch(s){case N.CommentThreadState.Unresolved:return O.CommentThreadState.Unresolved;case N.CommentThreadState.Resolved:return O.CommentThreadState.Resolved}return O.CommentThreadState.Unresolved}return new v}e.createExtHostComments=p}),define(ke[200],Ce([1,0,23,4,27,15]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let k=class{constructor(N,D){this.a=N.getProxy(T.MainContext.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(N,D){const m=this,p=console[N];Object.defineProperty(console,N,{set:()=>{},get:()=>function(){m.e(N,D,p,arguments)}})}e(N,D,m,p){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:S(p,this.b)}),this.c&&this.f(N,m,p)}};k=qe([Ve(0,L.IExtHostRpcService),Ve(1,y.IExtHostInitDataService)],k),e.AbstractExtHostConsoleForwarder=k;const O=1e5;function S(C,N){const D=[];if(C.length)for(let m=0;m<C.length;m++){let p=C[m];if(typeof p>"u")p="undefined";else if(p instanceof Error){const f=p;f.stack?p=f.stack:p=f.toString()}D.push(p)}if(N){const m=new Error().stack;m&&D.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,i.safeStringify)(D);return m.length>O?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(ke[101],Ce([1,0,2,4,6,3,15,12,16,10,19,26]),function(ee,e,i,T,y,L,k,O,S,C,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let m=class Ni{constructor(f,t){this.h=t,this.f=new Map,this.g=f.getProxy(T.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,t){const c=Ni.c++;this.f.set(c,{provider:f,extensionDescription:t}),this.g.$registerDecorationProvider(c,t.identifier.value);const l=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(v=>{if(!v){this.g.$onDidChange(c,null);return}const b=(0,S.asArray)(v);if(b.length<=Ni.d){this.g.$onDidChange(c,b);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,b.length);const E=b.map(a=>({uri:a,rank:(0,C.count)(a.path,"/")})),w=(0,S.groupBy)(E,(a,o)=>a.rank-o.rank||(0,C.compare)(a.uri.path,o.uri.path)),r=[];e:for(const a of w){let o;for(const d of a){const s=(0,N.dirname)(d.uri.path);if(o!==s&&(o=s,r.push(d.uri)>=Ni.d))break e}}this.g.$onDidChange(c,r)});return new y.Disposable(()=>{l?.dispose(),this.g.$unregisterDecorationProvider(c),this.f.delete(c)})}async $provideDecorations(f,t,c){if(!this.f.has(f))return Object.create(null);const l=Object.create(null),{provider:v,extensionDescription:b}=this.f.get(f);return await Promise.all(t.map(async E=>{try{const{uri:w,id:r}=E,a=await Promise.resolve(v.provideFileDecoration(i.URI.revive(w),c));if(!a)return;try{y.FileDecoration.validate(a),a.badge&&typeof a.badge!="string"&&(0,D.checkProposedApiEnabled)(b,"codiconDecoration"),l[r]=[a.propagate,a.tooltip,a.badge,a.color]}catch(o){this.h.warn(`INVALID decoration from extension '${b}': ${o}`)}}catch(w){this.h.error(w)}})),l}};m.c=0,m.d=250,m=qe([Ve(0,k.IExtHostRpcService),Ve(1,O.ILogService)],m),e.ExtHostDecorations=m,e.IExtHostDecorations=(0,L.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(ke[201],Ce([1,0,134,88,2,4,6,8,5,12,28,37]),function(ee,e,i,T,y,L,k,O,S,C,N,D){"use strict";var m,p,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class t{constructor(v,b,E,w,r,a,o){this.d=v,this.e=b,this.f=E,this.g=w,m.set(this,void 0),p.set(this,void 0),f.set(this,void 0),this.c=!1,Je(this,f,new N.ResourceMap(d=>r.getComparisonKey(d)),"f"),Je(this,m,a,"f"),Je(this,p,o,"f")}dispose(){this.c||(Oe(this,p,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,m,"f")?.$clear(this.e),Oe(this,f,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(v,b){if(!v){this.clear();return}this.h();let E=[];if(y.URI.isUri(v)){if(!b){this.delete(v);return}Oe(this,f,"f").set(v,b.slice()),E=[v]}else if(Array.isArray(v)){E=[];let r;v=[...v].sort(t.j);for(const a of v){const[o,d]=a;if((!r||o.toString()!==r.toString())&&(r&&Oe(this,f,"f").get(r).length===0&&Oe(this,f,"f").delete(r),r=o,E.push(o),Oe(this,f,"f").set(o,[])),d)Oe(this,f,"f").get(o)?.push(...d);else{const s=Oe(this,f,"f").get(o);s&&(s.length=0)}}}if(Oe(this,p,"f").fire(E),!Oe(this,m,"f"))return;const w=[];for(const r of E){let a=[];const o=Oe(this,f,"f").get(r);if(o)if(o.length>this.f){a=[];const d=[k.DiagnosticSeverity.Error,k.DiagnosticSeverity.Warning,k.DiagnosticSeverity.Information,k.DiagnosticSeverity.Hint];e:for(let s=0;s<4;s++)for(const u of o)if(u.severity===d[s]&&a.push({...O.Diagnostic.from(u),modelVersionId:this.g(r)})===this.f)break e;a.push({severity:T.MarkerSeverity.Info,message:(0,i.localize)(0,null,o.length-this.f),startLineNumber:a[a.length-1].startLineNumber,startColumn:a[a.length-1].startColumn,endLineNumber:a[a.length-1].endLineNumber,endColumn:a[a.length-1].endColumn})}else a=o.map(d=>({...O.Diagnostic.from(d),modelVersionId:this.g(r)}));w.push([r,a])}Oe(this,m,"f").$changeMany(this.e,w)}delete(v){this.h(),Oe(this,p,"f").fire([v]),Oe(this,f,"f").delete(v),Oe(this,m,"f")?.$changeMany(this.e,[[v,void 0]])}clear(){this.h(),Oe(this,p,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,f,"f").clear(),Oe(this,m,"f")?.$clear(this.e)}forEach(v,b){this.h();for(const[E,w]of this)v.call(b,E,w,this)}*[(m=new WeakMap,p=new WeakMap,f=new WeakMap,Symbol.iterator)](){this.h();for(const v of Oe(this,f,"f").keys())yield[v,this.get(v)]}get(v){this.h();const b=Oe(this,f,"f").get(v);return Array.isArray(b)?Object.freeze(b.slice(0)):[]}has(v){return this.h(),Array.isArray(Oe(this,f,"f").get(v))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(v,b){return v[0].toString()<b[0].toString()?-1:v[0].toString()>b[0].toString()?1:0}}e.DiagnosticCollection=t;let c=class vi{static _mapper(v){const b=new N.ResourceMap;for(const E of v)b.set(E,E);return{uris:Object.freeze(Array.from(b.values()))}}constructor(v,b,E,w){this.h=b,this.j=E,this.k=w,this.f=new Map,this.g=new S.DebounceEmitter({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this.g.event,vi._mapper),this.e=v.getProxy(L.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(v,b){const{f:E,e:w,g:r,h:a,j:o,k:d}=this,s=new class{$changeMany(h,g){w.$changeMany(h,g),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",v.value,h,g.length===0?"CLEARING":g)}$clear(h){w.$clear(h),a.trace("[DiagnosticCollection] remove all (extension, owner)",v.value,h)}dispose(){w.dispose()}};let u;if(!b)b="_generated_diagnostic_collection_name_#"+vi.c++,u=b;else if(!E.has(b))u=b;else{this.h.warn(`DiagnosticCollection with name '${b}' does already exist.`);do u=b+vi.c++;while(E.has(u))}return new class extends t{constructor(){super(b,u,vi.d,h=>d.getDocument(h)?.version,o.extUri,s,r),E.set(u,this)}dispose(){super.dispose(),E.delete(u)}}}getDiagnostics(v){if(v)return this.l(v);{const b=new Map,E=[];for(const w of this.f.values())w.forEach((r,a)=>{let o=b.get(r.toString());typeof o>"u"&&(o=E.length,b.set(r.toString(),o),E.push([r,[]])),E[o][1]=E[o][1].concat(...a)});return E}}l(v){let b=[];for(const E of this.f.values())E.has(v)&&(b=b.concat(E.get(v)));return b}$acceptMarkersChange(v){if(!this.m){const b="_generated_mirror",E=new t(b,b,vi.d,w=>{},this.j.extUri,void 0,this.g);this.f.set(b,E),this.m=E}for(const[b,E]of v)this.m.set(y.URI.revive(b),E.map(O.Diagnostic.to))}};c.c=0,c.d=1e3,c=qe([Ve(1,C.ILogService),Ve(2,D.IExtHostFileSystemInfo)],c),e.ExtHostDiagnostics=c}),define(ke[202],Ce([1,0,2,4]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class y{constructor(k){this.a=k.getProxy(T.MainContext.MainThreadDialogs)}showOpenDialog(k){return this.a.$showOpenDialog(k).then(O=>O?O.map(S=>i.URI.revive(S)):void 0)}showSaveDialog(k){return this.a.$showSaveDialog(k).then(O=>O?i.URI.revive(O):void 0)}}e.ExtHostDialogs=y}),define(ke[203],Ce([1,0,11,2,6,4,13,20,10]),function(ee,e,i,T,y,L,k,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class C{constructor(D,m,p){this.d=m,this.e=p,this.b=new Map,this.c=D.getProxy(L.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,m){if(Object.keys(k.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const p=C.a++;this.b.set(p,m),this.c.$registerTextContentProvider(p,D);let f;return typeof m.onDidChange=="function"&&(f=m.onDidChange(t=>{if(t.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${t.scheme}' which will be IGNORED`);return}this.d.getDocument(t)&&this.$provideTextDocumentContent(p,t).then(c=>{if(!c&&typeof c!="string")return;const l=this.d.getDocument(t);if(!l)return;const v=(0,S.splitLines)(c);if(!l.equalLines(v))return this.c.$onVirtualDocumentChange(t,c)},i.onUnexpectedError)})),new y.Disposable(()=>{this.b.delete(p)&&this.c.$unregisterTextContentProvider(p),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(D,m){const p=this.b.get(D);return p?Promise.resolve(p.provideTextDocumentContent(T.URI.revive(m),O.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.ExtHostDocumentContentProvider=C,C.a=0}),define(ke[204],Ce([1,0,5,7,2,4,97,8,9,23,6]),function(ee,e,i,T,y,L,k,O,S,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class D{constructor(p,f){this.a=new i.Emitter,this.b=new i.Emitter,this.c=new i.Emitter,this.d=new i.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.DisposableStore,this.h=new Map,this.f=p.getProxy(L.MainContext.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(t=>{for(const c of t)this.b.fire(c.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const c of t)this.a.fire(c.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(p){if(!p)return;const f=this.g.getDocument(p);if(f)return f}getDocument(p){const f=this.getDocumentData(p);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return f.document}ensureDocumentData(p){const f=this.g.getDocument(p);if(f)return Promise.resolve(f);let t=this.h.get(p.toString());return t||(t=this.f.$tryOpenDocument(p).then(c=>{this.h.delete(p.toString());const l=y.URI.revive(c);return(0,S.assertIsDefined)(this.g.getDocument(l))},c=>(this.h.delete(p.toString()),Promise.reject(c))),this.h.set(p.toString(),t)),t}createDocumentData(p){return this.f.$tryCreateDocument(p).then(f=>y.URI.revive(f))}$acceptModelLanguageChanged(p,f){const t=y.URI.revive(p),c=this.g.getDocument(t);if(!c)throw new Error("unknown document");this.b.fire(c.document),c._acceptLanguageId(f),this.a.fire(c.document)}$acceptModelSaved(p){const f=y.URI.revive(p),t=this.g.getDocument(f);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this.d.fire(t.document)}$acceptDirtyStateChanged(p,f){const t=y.URI.revive(p),c=this.g.getDocument(t);if(!c)throw new Error("unknown document");c._acceptIsDirty(f),this.c.fire({document:c.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,f,t){const c=y.URI.revive(p),l=this.g.getDocument(c);if(!l)throw new Error("unknown document");l._acceptIsDirty(t),l.onEvents(f);let v;f.isUndoing?v=N.TextDocumentChangeReason.Undo:f.isRedoing&&(v=N.TextDocumentChangeReason.Redo),this.c.fire((0,C.deepFreeze)({document:l.document,contentChanges:f.changes.map(b=>({range:O.Range.to(b.range),rangeOffset:b.rangeOffset,rangeLength:b.rangeLength,text:b.text})),reason:v}))}setWordDefinitionFor(p,f){(0,k.setWordDefinitionFor)(p,f)}}e.ExtHostDocuments=D}),define(ke[56],Ce([1,0,47,5,7,2,3,4,97,15,100,8,12,28,13,174,205]),function(ee,e,i,T,y,L,k,O,S,C,N,D,m,p,f,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class l{constructor(E){this.value=E,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let v=class{constructor(E,w){this.h=E,this.i=w,this.a=null,this.b=new Map,this.c=new p.ResourceMap,this.d=new T.Emitter,this.e=new T.Emitter,this.f=new T.Emitter,this.g=new T.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(E){this.acceptDocumentsAndEditorsDelta(E)}acceptDocumentsAndEditorsDelta(E){const w=[],r=[],a=[];if(E.removedDocuments)for(const o of E.removedDocuments){const d=L.URI.revive(o),s=this.c.get(d);s?.unref()&&(this.c.delete(d),w.push(s.value))}if(E.addedDocuments)for(const o of E.addedDocuments){const d=L.URI.revive(o.uri);let s=this.c.get(d);if(s&&d.scheme!==f.Schemas.vscodeNotebookCell&&d.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${d} already exists!'`);s||(s=new l(new S.ExtHostDocumentData(this.h.getProxy(O.MainContext.MainThreadDocuments),d,o.lines,o.EOL,o.versionId,o.languageId,o.isDirty,o.notebook)),this.c.set(d,s),r.push(s.value)),s.ref()}if(E.removedEditors)for(const o of E.removedEditors){const d=this.b.get(o);this.b.delete(o),d&&a.push(d)}if(E.addedEditors)for(const o of E.addedEditors){const d=L.URI.revive(o.documentUri);i.ok(this.c.has(d),`document '${d}' does not exist`),i.ok(!this.b.has(o.id),`editor '${o.id}' already exists!`);const s=this.c.get(d).value,u=new N.ExtHostTextEditor(o.id,this.h.getProxy(O.MainContext.MainThreadTextEditors),this.i,new c.Lazy(()=>s.document),o.selections.map(D.Selection.to),o.options,o.visibleRanges.map(n=>D.Range.to(n)),typeof o.editorPosition=="number"?D.ViewColumn.to(o.editorPosition):void 0);this.b.set(o.id,u)}E.newActiveEditor!==void 0&&(i.ok(E.newActiveEditor===null||this.b.has(E.newActiveEditor),`active editor '${E.newActiveEditor}' does not exist`),this.a=E.newActiveEditor),(0,y.dispose)(w),(0,y.dispose)(a),E.removedDocuments&&this.e.fire(w),E.addedDocuments&&this.d.fire(r),(E.removedEditors||E.addedEditors)&&this.f.fire(this.allEditors().map(o=>o.value)),E.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(E){return this.c.get(E)?.value}allDocuments(){return t.Iterable.map(this.c.values(),E=>E.value)}getEditor(E){return this.b.get(E)}activeEditor(E){if(!this.a)return;const w=this.b.get(this.a);return E?w:w?.value}allEditors(){return[...this.b.values()]}};v=qe([Ve(0,C.IExtHostRpcService),Ve(1,m.ILogService)],v),e.ExtHostDocumentsAndEditors=v,e.IExtHostDocumentsAndEditors=(0,k.createDecorator)("IExtHostDocumentsAndEditors")}),define(ke[57],Ce([1,0,8,4,2,5,3,6,15,9,80]),function(ee,e,i,T,y,L,k,O,S,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,k.createDecorator)("IExtHostEditorTabs");class D{constructor(c,l,v){this.e=v,this.d=l,this.acceptDtoUpdate(c)}get apiObject(){if(!this.a){const c=this,l={get isActive(){return c.b.id===c.e()},get label(){return c.b.label},get input(){return c.c},get isDirty(){return c.b.isDirty},get isPinned(){return c.b.isPinned},get isPreview(){return c.b.isPreview},get group(){return c.d.apiObject}};this.a=Object.freeze(l)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(c){this.b=c,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new O.TextTabInput(y.URI.revive(this.b.input.uri));case 2:return new O.TextDiffTabInput(y.URI.revive(this.b.input.original),y.URI.revive(this.b.input.modified));case 3:return new O.TextMergeTabInput(y.URI.revive(this.b.input.base),y.URI.revive(this.b.input.input1),y.URI.revive(this.b.input.input2),y.URI.revive(this.b.input.result));case 6:return new O.CustomEditorTabInput(y.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new O.WebviewEditorTabInput(this.b.input.viewType);case 4:return new O.NotebookEditorTabInput(y.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new O.NotebookDiffEditorTabInput(y.URI.revive(this.b.input.original),y.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new O.TerminalEditorTabInput;case 9:return new O.InteractiveWindowInput(y.URI.revive(this.b.input.uri),y.URI.revive(this.b.input.inputBoxUri));default:return}}}class m{constructor(c,l){this.c=[],this.d="",this.b=c,this.e=l;for(const v of c.tabs)v.isActive&&(this.d=v.id),this.c.push(new D(v,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const c=this,l={get isActive(){return c.b.groupId===c.e()},get viewColumn(){return i.ViewColumn.to(c.b.viewColumn)},get activeTab(){return c.c.find(v=>v.tabId===c.d)?.apiObject},get tabs(){return Object.freeze(c.c.map(v=>v.apiObject))}};this.a=Object.freeze(l)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(c){this.b=c}acceptTabOperation(c){if(c.kind===0){const v=new D(c.tabDto,this,()=>this.activeTabId());return this.c.splice(c.index,0,v),c.tabDto.isActive&&(this.d=v.tabId),v}else if(c.kind===1){const v=this.c.splice(c.index,1)[0];if(!v)throw new Error(`Tab close updated received for index ${c.index} which does not exist`);return v.tabId===this.d&&(this.d=""),v}else if(c.kind===3){if(c.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const v=this.c.splice(c.oldIndex,1)[0];if(!v)throw new Error(`Tab move updated received for index ${c.oldIndex} which does not exist`);return this.c.splice(c.index,0,v),v}const l=this.c.find(v=>v.tabId===c.tabDto.id);if(!l)throw new Error("INVALID tab");return c.tabDto.isActive?this.d=c.tabDto.id:this.d===c.tabDto.id&&!c.tabDto.isActive&&(this.d=""),l.acceptDtoUpdate(c.tabDto),l}activeTabId(){return this.d}}let p=class{constructor(c){this.b=new L.Emitter,this.c=new L.Emitter,this.e=[],this.a=c.getProxy(T.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const c=this,l={onDidChangeTabGroups:c.c.event,onDidChangeTabs:c.b.event,get all(){return Object.freeze(c.e.map(v=>v.apiObject))},get activeTabGroup(){const v=c.d;return(0,C.assertIsDefined)(c.e.find(E=>E.groupId===v)?.apiObject)},close:async(v,b)=>{const E=Array.isArray(v)?v:[v];return E.length?f(E[0])?this.j(E,b):this.i(E,b):!0}};this.f=Object.freeze(l)}return this.f}$acceptEditorTabModel(c){const l=new Set(this.e.map(o=>o.groupId)),v=new Set(c.map(o=>o.groupId)),b=(0,N.diffSets)(l,v),E=this.e.filter(o=>b.removed.includes(o.groupId)).map(o=>o.apiObject),w=[],r=[];this.e=c.map(o=>{const d=new m(o,()=>this.d);return b.added.includes(d.groupId)?w.push(d.apiObject):r.push(d.apiObject),d});const a=(0,C.assertIsDefined)(c.find(o=>o.isActive===!0)?.groupId);a!==void 0&&this.d!==a&&(this.d=a),this.c.fire(Object.freeze({opened:w,closed:E,changed:r}))}$acceptTabGroupUpdate(c){const l=this.e.find(v=>v.groupId===c.groupId);if(!l)throw new Error("Update Group IPC call received before group creation.");l.acceptGroupDtoUpdate(c),c.isActive&&(this.d=c.groupId),this.c.fire(Object.freeze({changed:[l.apiObject],opened:[],closed:[]}))}$acceptTabOperation(c){const l=this.e.find(b=>b.groupId===c.groupId);if(!l)throw new Error("Update Tabs IPC call received before group creation.");const v=l.acceptTabOperation(c);switch(c.kind){case 0:this.b.fire(Object.freeze({opened:[v.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[v.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[v.apiObject]}));return}}g(c){for(const l of this.e)for(const v of l.tabs)if(v.apiObject===c)return v}h(c){return this.e.find(l=>l.apiObject===c)}async i(c,l){const v=[];for(const b of c){const E=this.g(b);if(!E)throw new Error("Tab close: Invalid tab not found!");v.push(E.tabId)}return this.a.$closeTab(v,l)}async j(c,l){const v=[];for(const b of c){const E=this.h(b);if(!E)throw new Error("Group close: Invalid group not found!");v.push(E.groupId)}return this.a.$closeGroup(v,l)}};p=qe([Ve(0,S.IExtHostRpcService)],p),e.ExtHostEditorTabs=p;function f(t){return t.tabs!==void 0}}),define(ke[206],Ce([1,0,2,4,7,6,8,251,10,24,26]),function(ee,e,i,T,y,L,k,O,S,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class D{constructor(){this.a=[]}add(f){this.b=void 0,this.a.push(f)}delete(f){const t=this.a.indexOf(f);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const f=this.a.sort(),t=[];let c,l,v=14,b=14;for(const E of f){let w=c?(0,S.commonPrefixLength)(c,E):0;for(w===0?l=1:l=b;w<E.length;w++)w+1===E.length?(v=b,b=9):b+=1,t.push([l,E.toUpperCase().charCodeAt(w),b]),t.push([l,E.toLowerCase().charCodeAt(w),b]),l=b;c=E,b=v}t.push([9,58,10]),t.push([10,47,12]),this.b=new O.StateMachine(t)}}provideDocumentLinks(f){this.c();const t=[],c=O.LinkComputer.computeLinks({getLineContent(l){return f.lineAt(l-1).text},getLineCount(){return f.lineCount}},this.b);for(const l of c){const v=k.DocumentLink.to(l);v.target&&t.push(v)}return t}}class m{constructor(f,t){this.i=t,this.b=new D,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=f.getProxy(T.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(f,t,c,l={}){if(this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(f,"*",this.b));const v=this.h++;this.b.add(t),this.d.add(t),this.c.set(v,c);let b=2;l.isCaseSensitive&&(b+=1024),l.isReadonly&&(b+=2048),typeof c.copy=="function"&&(b+=8),typeof c.open=="function"&&typeof c.close=="function"&&typeof c.read=="function"&&typeof c.write=="function"&&((0,N.checkProposedApiEnabled)(f,"fsChunks"),b+=4),this.a.$registerFileSystemProvider(v,t,b).catch(w=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${t}`),console.error(w)});const E=c.onDidChangeFile(w=>{const r=[];for(const a of w){const{uri:o,type:d}=a;if(o.scheme!==t)continue;let s;switch(d){case L.FileChangeType.Changed:s=0;break;case L.FileChangeType.Created:s=1;break;case L.FileChangeType.Deleted:s=2;break;default:throw new Error("Unknown FileChangeType")}r.push({resource:o,type:s})}this.a.$onFileSystemChange(v,r)});return(0,y.toDisposable)(()=>{E.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(v),this.a.$unregisterProvider(v)})}static j(f){const{type:t,ctime:c,mtime:l,size:v,permissions:b}=f;return{type:t,ctime:c,mtime:l,size:v,permissions:b}}$stat(f,t){return Promise.resolve(this.k(f).stat(i.URI.revive(t))).then(c=>m.j(c))}$readdir(f,t){return Promise.resolve(this.k(f).readDirectory(i.URI.revive(t)))}$readFile(f,t){return Promise.resolve(this.k(f).readFile(i.URI.revive(t))).then(c=>C.VSBuffer.wrap(c))}$writeFile(f,t,c,l){return Promise.resolve(this.k(f).writeFile(i.URI.revive(t),c.buffer,l))}$delete(f,t,c){return Promise.resolve(this.k(f).delete(i.URI.revive(t),c))}$rename(f,t,c,l){return Promise.resolve(this.k(f).rename(i.URI.revive(t),i.URI.revive(c),l))}$copy(f,t,c,l){const v=this.k(f);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(i.URI.revive(t),i.URI.revive(c),l))}$mkdir(f,t){return Promise.resolve(this.k(f).createDirectory(i.URI.revive(t)))}$watch(f,t,c,l){const v=this.k(f).watch(i.URI.revive(c),l);this.f.set(t,v)}$unwatch(f,t){const c=this.f.get(t);c&&(c.dispose(),this.f.delete(t))}$open(f,t,c){const l=this.k(f);if(!l.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(l.open(i.URI.revive(t),c))}$close(f,t){const c=this.k(f);if(!c.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(c.close(t))}$read(f,t,c,l){const v=this.k(f);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const b=C.VSBuffer.alloc(l);return Promise.resolve(v.read(t,c,b.buffer,0,l)).then(E=>b.slice(0,E))}$write(f,t,c,l){const v=this.k(f);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(t,c,l.buffer,0,l.byteLength))}k(f){const t=this.c.get(f);if(!t){const c=new Error;throw c.name="ENOPRO",c.message="no provider",c}return t}}e.ExtHostFileSystem=m}),define(ke[58],Ce([1,0,4,36,6,24,3,15,37,7]),function(ee,e,i,T,y,L,k,O,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let N=class Jt{constructor(m,p){this.b=new Map,this.a=m.getProxy(i.MainContext.MainThreadFileSystem);const f=this;this.value=Object.freeze({async stat(t){try{const c=f.b.get(t.scheme);if(!c)return await f.a.$stat(t);await f.a.$ensureActivation(t.scheme);const l=await c.stat(t);return{type:l.type,ctime:l.ctime,mtime:l.mtime,size:l.size,permissions:l.permissions}}catch(c){Jt.c(c)}},async readDirectory(t){try{const c=f.b.get(t.scheme);return c?(await f.a.$ensureActivation(t.scheme),(await c.readDirectory(t)).slice()):await f.a.$readdir(t)}catch(c){return Jt.c(c)}},async createDirectory(t){try{return await f.a.$mkdir(t)}catch(c){return Jt.c(c)}},async readFile(t){try{const c=f.b.get(t.scheme);return c?(await f.a.$ensureActivation(t.scheme),(await c.readFile(t)).slice()):(await f.a.$readFile(t)).buffer}catch(c){return Jt.c(c)}},async writeFile(t,c){try{return await f.a.$writeFile(t,L.VSBuffer.wrap(c))}catch(l){return Jt.c(l)}},async delete(t,c){try{const l=f.b.get(t.scheme);return l?(await f.a.$ensureActivation(t.scheme),await l.delete(t,{recursive:!1,...c})):await f.a.$delete(t,{recursive:!1,useTrash:!1,...c})}catch(l){return Jt.c(l)}},async rename(t,c,l){try{return await f.a.$rename(t,c,{overwrite:!1,...l})}catch(v){return Jt.c(v)}},async copy(t,c,l){try{return await f.a.$copy(t,c,{overwrite:!1,...l})}catch(v){return Jt.c(v)}},isWritableFileSystem(t){const c=p.getCapabilities(t);if(typeof c=="number")return!(c&2048)}})}static c(m){if(m instanceof y.FileSystemError)throw m;if(!(m instanceof Error))throw new y.FileSystemError(String(m));if(m.name==="ENOPRO")throw y.FileSystemError.Unavailable(m.message);switch(m.name){case T.FileSystemProviderErrorCode.FileExists:throw y.FileSystemError.FileExists(m.message);case T.FileSystemProviderErrorCode.FileNotFound:throw y.FileSystemError.FileNotFound(m.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw y.FileSystemError.FileNotADirectory(m.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw y.FileSystemError.FileIsADirectory(m.message);case T.FileSystemProviderErrorCode.NoPermissions:throw y.FileSystemError.NoPermissions(m.message);case T.FileSystemProviderErrorCode.Unavailable:throw y.FileSystemError.Unavailable(m.message);default:throw new y.FileSystemError(m.message,m.name)}}addFileSystemProvider(m,p){return this.b.set(m,p),(0,C.toDisposable)(()=>this.b.delete(m))}};N=qe([Ve(0,O.IExtHostRpcService),Ve(1,S.IExtHostFileSystemInfo)],N),e.ExtHostConsumerFileSystem=N,e.IExtHostConsumerFileSystem=(0,k.createDecorator)("IExtHostConsumerFileSystem")}),define(ke[207],Ce([1,0,5,35,2,4,8,6]),function(ee,e,i,T,y,L,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(D,m,p,f,t,c,l,v){this.a=new i.Emitter,this.b=new i.Emitter,this.c=new i.Emitter;const b=this.h(D,p,t);this.g=0,c&&(this.g+=1),l&&(this.g+=2),v&&(this.g+=4);const E=(0,T.parse)(t),w=typeof t=="string",r=f(a=>{if(!c)for(const o of a.created){const d=y.URI.revive(o);E(d.fsPath)&&(!w||m.getWorkspaceFolder(d))&&this.a.fire(d)}if(!l)for(const o of a.changed){const d=y.URI.revive(o);E(d.fsPath)&&(!w||m.getWorkspaceFolder(d))&&this.b.fire(d)}if(!v)for(const o of a.deleted){const d=y.URI.revive(o);E(d.fsPath)&&(!w||m.getWorkspaceFolder(d))&&this.c.fire(d)}});this.d=O.Disposable.from(b,this.a,this.b,this.c,r)}h(D,m,p){const f=O.Disposable.from();if(typeof p=="string")return f;const t=D.getProxy(L.MainContext.MainThreadFileSystem);let c=!1;(p.pattern.includes(T.GLOBSTAR)||p.pattern.includes(T.GLOB_SPLIT))&&(c=!0);const l=Math.random();return t.$watch(m.identifier.value,l,p.baseUri,{recursive:c,excludes:[]}),O.Disposable.from({dispose:()=>t.$unwatch(l)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class C{constructor(D,m,p){this.j=D,this.k=m,this.l=p,this.a=new i.Emitter,this.b=new i.Emitter,this.c=new i.Emitter,this.d=new i.Emitter,this.g=new i.AsyncEmitter,this.h=new i.AsyncEmitter,this.i=new i.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(D,m,p,f,t,c){return new S(this.j,D,m,this.a.event,k.GlobPattern.from(p),f,t,c)}$onFileEvent(D){this.a.fire(D)}$onDidRunFileOperation(D,m){switch(D){case 2:this.b.fire(Object.freeze({files:m.map(p=>({oldUri:y.URI.revive(p.source),newUri:y.URI.revive(p.target)}))}));break;case 1:this.d.fire(Object.freeze({files:m.map(p=>y.URI.revive(p.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:m.map(p=>y.URI.revive(p.target))}));break;default:}}getOnWillRenameFileEvent(D){return this.m(D,this.g)}getOnWillCreateFileEvent(D){return this.m(D,this.h)}getOnWillDeleteFileEvent(D){return this.m(D,this.i)}m(D,m){return(p,f,t)=>{const c=function(v){p.call(f,v)};return c.extension=D,m.event(c,void 0,t)}}async $onWillRunFileOperation(D,m,p,f){switch(D){case 2:return await this.n(this.g,{files:m.map(t=>({oldUri:y.URI.revive(t.source),newUri:y.URI.revive(t.target)}))},p,f);case 1:return await this.n(this.i,{files:m.map(t=>y.URI.revive(t.target))},p,f);case 0:case 3:return await this.n(this.h,{files:m.map(t=>y.URI.revive(t.target))},p,f)}}async n(D,m,p,f){const t=new Set,c=[];if(await D.fireAsync(m,f,async(v,b)=>{const E=Date.now(),w=await Promise.resolve(v);w instanceof O.WorkspaceEdit&&(c.push([b.extension,w]),t.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-E>p&&this.k.warn("SLOW file-participant",b.extension.identifier)}),f.isCancellationRequested||c.length===0)return;const l={edits:[]};for(const[,v]of c){const{edits:b}=k.WorkspaceEdit.from(v,{getTextDocumentVersion:E=>this.l.getDocument(E)?.version,getNotebookDocumentVersion:()=>{}});l.edits=l.edits.concat(b)}return{edit:l,extensionNames:Array.from(t)}}}e.ExtHostFileSystemEventService=C}),define(ke[208],Ce([1,0,2,38]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class y{constructor(k,O,S,C,N){this.a=O,this.b=S,this.c=C;const D=new T.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.ApiCommandArgument("showOptions","Show Options",m=>!0,m=>m),new T.ApiCommandArgument("resource","Interactive resource Uri",m=>!0,m=>m),new T.ApiCommandArgument("controllerId","Notebook controller Id",m=>!0,m=>m),new T.ApiCommandArgument("title","Interactive editor title",m=>!0,m=>m)],new T.ApiCommandResult("Notebook and input URI",m=>{if(N.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const p=this.a.getEditorById(m.notebookEditorId);return N.debug("[ExtHostInteractive] notebook editor found",p.id),{notebookUri:i.URI.revive(m.notebookUri),inputUri:i.URI.revive(m.inputUri),notebookEditor:p.apiEditor}}return N.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:i.URI.revive(m.notebookUri),inputUri:i.URI.revive(m.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(k,O,S,C){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:O,lines:[""],languageId:S,uri:k,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(i.URI.revive(C))?.apiNotebook}]})}$willRemoveInteractiveDocument(k,O){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[k]})}}e.ExtHostInteractive=y}),define(ke[209],Ce([1,0,7,4]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class y{constructor(k){this.b=0,this.a=k.getProxy(T.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(k){const O=this.b++;return this.a.$registerResourceLabelFormatter(O,k),(0,i.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(O)})}}e.ExtHostLabelService=y}),define(ke[210],Ce([1,0,2,23,8,6,72,4,10,55,16,9,252,20,7,85,81,52,74,11,14,26]),function(ee,e,i,T,y,L,k,O,S,C,N,D,m,p,f,t,c,l,v,b,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class r{constructor(I,$){this.d=I,this.e=$}async provideDocumentSymbols(I,$){const H=this.d.getDocument(I),q=await this.e.provideDocumentSymbols(H,$);if(!(0,N.isFalsyOrEmpty)(q))return q[0]instanceof L.DocumentSymbol?q.map(y.DocumentSymbol.from):r.f(q)}static f(I){I=I.slice(0).sort((q,J)=>{let de=q.location.range.start.compareTo(J.location.range.start);return de===0&&(de=J.location.range.end.compareTo(q.location.range.end)),de});const $=[],H=[];for(const q of I){const J={name:q.name||"!!MISSING: name!!",kind:y.SymbolKind.from(q.kind),tags:q.tags?.map(y.SymbolTag.from)||[],detail:"",containerName:q.containerName,range:y.Range.from(q.location.range),selectionRange:y.Range.from(q.location.range),children:[]};for(;;){if(H.length===0){H.push(J),$.push(J);break}const de=H[H.length-1];if(C.Range.containsRange(de.range,J.range)&&!C.Range.equalsRange(de.range,J.range)){de.children?.push(J),H.push(J);break}H.pop()}}return $}}class a{constructor(I,$,H){this.g=I,this.h=$,this.j=H,this.e=new l.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(I,$){const H=this.g.getDocument(I),q=await this.j.provideCodeLenses(H,$);if(!q||$.isCancellationRequested)return;const J=this.e.add(q),de=new f.DisposableStore;this.f.set(J,de);const we={cacheId:J,lenses:[]};for(let ae=0;ae<q.length;ae++)we.lenses.push({cacheId:[J,ae],range:y.Range.from(q[ae].range),command:this.h.toInternal(q[ae].command,de)});return we}async resolveCodeLens(I,$){const H=I.cacheId&&this.e.get(...I.cacheId);if(!H)return;let q;if(typeof this.j.resolveCodeLens!="function"||H.isResolved?q=H:q=await this.j.resolveCodeLens(H,$),q||(q=H),$.isCancellationRequested)return;const J=I.cacheId&&this.f.get(I.cacheId[0]);if(!!J)return I.command=this.h.toInternal(q.command??a.d,J),I}releaseCodeLenses(I){this.f.get(I)?.dispose(),this.f.delete(I),this.e.delete(I)}}a.d={command:"missing",title:"!!MISSING: command!!"};function o(Y){return Array.isArray(Y)?Y.map(y.DefinitionLink.from):Y?[y.DefinitionLink.from(Y)]:[]}class d{constructor(I,$){this.d=I,this.e=$}async provideDefinition(I,$,H){const q=this.d.getDocument(I),J=y.Position.to($),de=await this.e.provideDefinition(q,J,H);return o(de)}}class s{constructor(I,$){this.d=I,this.e=$}async provideDeclaration(I,$,H){const q=this.d.getDocument(I),J=y.Position.to($),de=await this.e.provideDeclaration(q,J,H);return o(de)}}class u{constructor(I,$){this.d=I,this.e=$}async provideImplementation(I,$,H){const q=this.d.getDocument(I),J=y.Position.to($),de=await this.e.provideImplementation(q,J,H);return o(de)}}class n{constructor(I,$){this.d=I,this.e=$}async provideTypeDefinition(I,$,H){const q=this.d.getDocument(I),J=y.Position.to($),de=await this.e.provideTypeDefinition(q,J,H);return o(de)}}class h{constructor(I,$){this.d=I,this.e=$}async provideHover(I,$,H){const q=this.d.getDocument(I),J=y.Position.to($),de=await this.e.provideHover(q,J,H);if(!(!de||(0,N.isFalsyOrEmpty)(de.contents)))return de.range||(de.range=q.getWordRangeAtPosition(J)),de.range||(de.range=new L.Range(J,J)),y.Hover.from(de)}}class g{constructor(I,$){this.d=I,this.e=$}async provideEvaluatableExpression(I,$,H){const q=this.d.getDocument(I),J=y.Position.to($),de=await this.e.provideEvaluatableExpression(q,J,H);if(de)return y.EvaluatableExpression.from(de)}}class P{constructor(I,$){this.d=I,this.e=$}async provideInlineValues(I,$,H,q){const J=this.d.getDocument(I),de=await this.e.provideInlineValues(J,y.Range.to($),y.InlineValueContext.to(H),q);if(Array.isArray(de))return de.map(we=>y.InlineValue.from(we))}}class M{constructor(I,$){this.d=I,this.e=$}async provideDocumentHighlights(I,$,H){const q=this.d.getDocument(I),J=y.Position.to($),de=await this.e.provideDocumentHighlights(q,J,H);if(Array.isArray(de))return de.map(y.DocumentHighlight.from)}}class j{constructor(I,$){this.d=I,this.e=$}async provideLinkedEditingRanges(I,$,H){const q=this.d.getDocument(I),J=y.Position.to($),de=await this.e.provideLinkedEditingRanges(q,J,H);if(de&&Array.isArray(de.ranges))return{ranges:(0,N.coalesce)(de.ranges.map(y.Range.from)),wordPattern:de.wordPattern}}}class Z{constructor(I,$){this.d=I,this.e=$}async provideReferences(I,$,H,q){const J=this.d.getDocument(I),de=y.Position.to($),we=await this.e.provideReferences(J,de,H,q);if(Array.isArray(we))return we.map(y.location.from)}}class G{constructor(I,$,H,q,J,de,we){this.g=I,this.h=$,this.j=H,this.k=q,this.l=J,this.m=de,this.n=we,this.e=new l.Cache("CodeAction"),this.f=new Map}async provideCodeActions(I,$,H,q){const J=this.g.getDocument(I),de=m.Selection.isISelection($)?y.Selection.to($):y.Range.to($),we=[];for(const tt of this.j.getDiagnostics(I))if(de.intersection(tt.range)&&we.push(tt)>G.d)break;const ae={diagnostics:we,only:H.only?new L.CodeActionKind(H.only):void 0,triggerKind:y.CodeActionTriggerKind.to(H.trigger)},pe=await this.k.provideCodeActions(J,de,ae,q);if(!(0,N.isNonEmptyArray)(pe)||q.isCancellationRequested)return;const ve=this.e.add(pe),We=new f.DisposableStore;this.f.set(ve,We);const He=[];for(let tt=0;tt<pe.length;tt++){const Xe=pe[tt];!Xe||(G.o(Xe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),He.push({_isSynthetic:!0,title:Xe.title,command:this.h.toInternal(Xe,We)})):(ae.only&&(Xe.kind?ae.only.contains(Xe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ae.only.value} 'requested but returned code action is of kind '${Xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ae.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),He.push({cacheId:[ve,tt],title:Xe.title,command:Xe.command&&this.h.toInternal(Xe.command,We),diagnostics:Xe.diagnostics&&Xe.diagnostics.map(y.Diagnostic.from),edit:Xe.edit&&y.WorkspaceEdit.from(Xe.edit,void 0),kind:Xe.kind&&Xe.kind.value,isPreferred:Xe.isPreferred,disabled:Xe.disabled?.reason})))}return{cacheId:ve,actions:He}}async resolveCodeAction(I,$){const[H,q]=I,J=this.e.get(H,q);if(!J||G.o(J)||!this.k.resolveCodeAction)return;const de=await this.k.resolveCodeAction(J,$)??J;return de?.edit?y.WorkspaceEdit.from(de.edit,void 0):void 0}releaseCodeActions(I){this.f.get(I)?.dispose(),this.f.delete(I),this.e.delete(I)}static o(I){return typeof I.command=="string"&&typeof I.title=="string"}}G.d=1e3;class A{constructor(I,$,H,q){this.d=I,this.e=$,this.f=H,this.g=q}async prepareDocumentPaste(I,$,H,q){if(!this.f.prepareDocumentPaste)return;const J=this.e.getDocument(I),de=$.map(ae=>y.Range.to(ae)),we=y.DataTransfer.toDataTransfer(H,()=>{throw new b.NotImplementedError});return await this.f.prepareDocumentPaste(J,de,we,q),y.DataTransfer.toDataTransferDTO(we)}async providePasteEdits(I,$,H,q,J){const de=this.e.getDocument($),we=H.map(ve=>y.Range.to(ve)),ae=y.DataTransfer.toDataTransfer(q,async ve=>(await this.d.$resolvePasteFileData(this.g,I,ve)).buffer),pe=await this.f.provideDocumentPasteEdits(de,we,ae,J);if(!!pe)return{insertText:typeof pe.insertText=="string"?pe.insertText:{snippet:pe.insertText.value},additionalEdit:pe.additionalEdit?y.WorkspaceEdit.from(pe.additionalEdit,void 0):void 0}}}class R{constructor(I,$){this.d=I,this.e=$}async provideDocumentFormattingEdits(I,$,H){const q=this.d.getDocument(I),J=await this.e.provideDocumentFormattingEdits(q,$,H);if(Array.isArray(J))return J.map(y.TextEdit.from)}}class F{constructor(I,$){this.d=I,this.e=$}async provideDocumentRangeFormattingEdits(I,$,H,q){const J=this.d.getDocument(I),de=y.Range.to($),we=await this.e.provideDocumentRangeFormattingEdits(J,de,H,q);if(Array.isArray(we))return we.map(y.TextEdit.from)}}class B{constructor(I,$){this.d=I,this.e=$,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(I,$,H,q,J){const de=this.d.getDocument(I),we=y.Position.to($),ae=await this.e.provideOnTypeFormattingEdits(de,we,H,q,J);if(Array.isArray(ae))return ae.map(y.TextEdit.from)}}class z{constructor(I,$){this.e=I,this.f=$,this.d=new l.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(I,$){const H=await this.e.provideWorkspaceSymbols(I,$);if(!(0,N.isNonEmptyArray)(H))return{symbols:[]};const q=this.d.add(H),J={cacheId:q,symbols:[]};for(let de=0;de<H.length;de++){const we=H[de];if(!we||!we.name){this.f.warn("INVALID SymbolInformation",we);continue}J.symbols.push({...y.WorkspaceSymbol.from(we),cacheId:[q,de]})}return J}async resolveWorkspaceSymbol(I,$){if(typeof this.e.resolveWorkspaceSymbol!="function"||!I.cacheId)return I;const H=this.d.get(...I.cacheId);if(H){const q=await this.e.resolveWorkspaceSymbol(H,$);return q&&(0,T.mixin)(I,y.WorkspaceSymbol.from(q),!0)}}releaseWorkspaceSymbols(I){this.d.delete(I)}}class V{static supportsResolving(I){return typeof I.prepareRename=="function"}constructor(I,$,H){this.d=I,this.e=$,this.f=H}async provideRenameEdits(I,$,H,q){const J=this.d.getDocument(I),de=y.Position.to($);try{const we=await this.e.provideRenameEdits(J,de,H,q);return we?y.WorkspaceEdit.from(we):void 0}catch(we){const ae=V.g(we);return ae?{rejectReason:ae,edits:void 0}:Promise.reject(we)}}async resolveRenameLocation(I,$,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const q=this.d.getDocument(I),J=y.Position.to($);try{const de=await this.e.prepareRename(q,J,H);let we,ae;if(L.Range.isRange(de)?(we=de,ae=q.getText(de)):(0,D.isObject)(de)&&(we=de.range,ae=de.placeholder),!we||!ae)return;if(we.start.line>J.line||we.end.line<J.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:y.Range.from(we),text:ae}}catch(de){const we=V.g(de);return we?{rejectReason:we,range:void 0,text:void 0}:Promise.reject(de)}}static g(I){return typeof I=="string"?I:I instanceof Error&&typeof I.message=="string"?I.message:void 0}}class K{constructor(I,$){this.resultId=I,this.tokens=$}}class ie{constructor(I,$){this.f=I,this.g=$,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(I,$,H){const q=this.f.getDocument(I),J=$!==0?this.d.get($):null;let de=typeof J?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(q,J.resultId,H):await this.g.provideDocumentSemanticTokens(q,H);return J&&this.d.delete($),de?(de=ie.h(de),this.o(ie.n(J,de),de)):null}async releaseDocumentSemanticColoring(I){this.d.delete(I)}static h(I){return ie.j(I)?ie.k(I)?I:new L.SemanticTokens(new Uint32Array(I.data),I.resultId):ie.l(I)?ie.m(I)?I:new L.SemanticTokensEdits(I.edits.map($=>new L.SemanticTokensEdit($.start,$.deleteCount,$.data?new Uint32Array($.data):$.data)),I.resultId):I}static j(I){return I&&!!I.data}static k(I){return I.data instanceof Uint32Array}static l(I){return I&&Array.isArray(I.edits)}static m(I){for(const $ of I.edits)if(!($.data instanceof Uint32Array))return!1;return!0}static n(I,$){if(!ie.j($)||!I||!I.tokens)return $;const H=I.tokens,q=H.length,J=$.data,de=J.length;let we=0;const ae=Math.min(q,de);for(;we<ae&&H[we]===J[we];)we++;if(we===q&&we===de)return new L.SemanticTokensEdits([],$.resultId);let pe=0;const ve=ae-we;for(;pe<ve&&H[q-pe-1]===J[de-pe-1];)pe++;return new L.SemanticTokensEdits([{start:we,deleteCount:q-we-pe,data:J.subarray(we,de-pe)}],$.resultId)}o(I,$){if(ie.j(I)){const H=this.e++;return this.d.set(H,new K(I.resultId,I.data)),(0,t.encodeSemanticTokensDto)({id:H,type:"full",data:I.data})}if(ie.l(I)){const H=this.e++;return ie.j($)?this.d.set(H,new K($.resultId,$.data)):this.d.set(H,new K(I.resultId)),(0,t.encodeSemanticTokensDto)({id:H,type:"delta",deltas:(I.edits||[]).map(q=>({start:q.start,deleteCount:q.deleteCount,data:q.data}))})}return null}}class me{constructor(I,$){this.d=I,this.e=$}async provideDocumentRangeSemanticTokens(I,$,H){const q=this.d.getDocument(I),J=await this.e.provideDocumentRangeSemanticTokens(q,y.Range.to($),H);return J?this.f(J):null}f(I){return(0,t.encodeSemanticTokensDto)({id:0,type:"full",data:I.data})}}class ue{static supportsResolving(I){return typeof I.resolveCompletionItem=="function"}constructor(I,$,H,q,J){this.f=I,this.g=$,this.h=H,this.j=q,this.k=J,this.d=new l.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(I,$,H,q){const J=this.f.getDocument(I),de=y.Position.to($),we=J.getWordRangeAtPosition(de)||new L.Range(de,de),ae=we.with({end:de}),pe=new v.StopWatch(!0),ve=await this.h.provideCompletionItems(J,de,q,y.CompletionContext.to(H));if(!ve||q.isCancellationRequested)return;const We=Array.isArray(ve)?new L.CompletionList(ve):ve,He=ue.supportsResolving(this.h)?this.d.add(We.items):this.d.add([]),tt=new f.DisposableStore;this.e.set(He,tt);const Xe=[],et={x:He,b:Xe,a:{replace:y.Range.from(we),insert:y.Range.from(ae)},c:We.isIncomplete||void 0,d:pe.elapsed()};for(let it=0;it<We.items.length;it++){const dt=We.items[it],Fe=this.l(dt,[He,it],ae,we);Xe.push(Fe)}return et}async resolveCompletionItem(I,$){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...I);if(!H)return;const q=await this.h.resolveCompletionItem(H,$);if(!!q)return this.l(q,I)}releaseCompletionItems(I){this.e.get(I)?.dispose(),this.e.delete(I),this.d.delete(I)}l(I,$,H,q){const J=this.e.get($[0]);if(!J)throw Error("DisposableStore is missing...");const de=this.g.toInternal(I.command,J),we={x:$,a:I.label,b:I.kind!==void 0?y.CompletionItemKind.from(I.kind):void 0,m:I.tags&&I.tags.map(y.CompletionItemTag.from),c:I.detail,d:typeof I.documentation>"u"?void 0:y.MarkdownString.fromStrict(I.documentation),e:I.sortText!==I.label?I.sortText:void 0,f:I.filterText!==I.label?I.filterText:void 0,g:I.preselect||void 0,i:I.keepWhitespace?1:0,k:I.commitCharacters?.join(""),l:I.additionalTextEdits&&I.additionalTextEdits.map(y.TextEdit.from),n:de?.$ident,o:de?.id,p:de?.$ident?void 0:de?.arguments};I.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),we.h=I.textEdit.newText):typeof I.insertText=="string"?we.h=I.insertText:I.insertText instanceof L.SnippetString&&(we.h=I.insertText.value,we.i|=4);let ae;return I.textEdit?ae=I.textEdit.range:I.range&&(ae=I.range),L.Range.isRange(ae)?we.j=y.Range.from(ae):ae&&(!H?.isEqual(ae.inserting)||!q?.isEqual(ae.replacing))&&(we.j={insert:y.Range.from(ae.inserting),replace:y.Range.from(ae.replacing)}),we}}class oe{async provideInlineCompletions(I,$,H,q){}disposeCompletions(I){}handleDidShowCompletionItem(I,$){}}class De extends oe{constructor(I,$,H,q){super(),this.f=I,this.g=$,this.h=H,this.j=q,this.d=new re,this.e=(0,w.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[k.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[k.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,w.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&typeof this.h.handleDidShowCompletionItem=="function"}async provideInlineCompletions(I,$,H,q){const J=this.g.getDocument(I),de=y.Position.to($),we=await this.h.provideInlineCompletionItems(J,de,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:y.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},q);if(!we||q.isCancellationRequested)return;const ae=Array.isArray(we)?we:we.items,pe=this.e?Array.isArray(we)?[]:we.commands||[]:[];let ve;return{pid:this.d.createReferenceId({dispose(){ve?.dispose()},items:ae}),items:ae.map((He,tt)=>{let Xe;He.command&&(ve||(ve=new f.DisposableStore),Xe=this.j.toInternal(He.command,ve));const et=He.insertText;return{insertText:typeof et=="string"?et:{snippet:et.value},filterText:He.filterText,range:He.range?y.Range.from(He.range):void 0,command:Xe,idx:tt,completeBracketPairs:this.e?He.completeBracketPairs:!1}}),commands:pe.map(He=>(ve||(ve=new f.DisposableStore),this.j.toInternal(He,ve)))}}disposeCompletions(I){this.d.disposeReferenceId(I)?.dispose()}handleDidShowCompletionItem(I,$){const H=this.d.get(I)?.items[$];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H)}}class re{constructor(){this.d=new Map,this.e=1}createReferenceId(I){const $=this.e++;return this.d.set($,I),$}disposeReferenceId(I){const $=this.d.get(I);return this.d.delete(I),$}get(I){return this.d.get(I)}}class Q{constructor(I,$){this.e=I,this.f=$,this.d=new l.Cache("SignatureHelp")}async provideSignatureHelp(I,$,H,q){const J=this.e.getDocument(I),de=y.Position.to($),we=this.g(H),ae=await this.f.provideSignatureHelp(J,de,q,we);if(ae){const pe=this.d.add([ae]);return{...y.SignatureHelp.from(ae),id:pe}}}g(I){let $;if(I.activeSignatureHelp){const H=y.SignatureHelp.to(I.activeSignatureHelp),q=this.d.get(I.activeSignatureHelp.id,0);q?($=q,$.activeSignature=H.activeSignature,$.activeParameter=H.activeParameter):$=H}return{...I,activeSignatureHelp:$}}releaseSignatureHelp(I){this.d.delete(I)}}class le{constructor(I,$,H,q,J){this.f=I,this.g=$,this.h=H,this.j=q,this.k=J,this.d=new l.Cache("InlayHints"),this.e=new Map}async provideInlayHints(I,$,H){const q=this.f.getDocument(I),J=y.Range.to($),de=await this.h.provideInlayHints(q,J,H);if(!Array.isArray(de)||de.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${$}`);return}if(H.isCancellationRequested)return;const we=this.d.add(de);this.e.set(we,new f.DisposableStore);const ae={hints:[],cacheId:we};for(let pe=0;pe<de.length;pe++)this.l(de[pe],J)&&ae.hints.push(this.m(de[pe],[we,pe]));return this.j.trace(`[InlayHints] ${ae.hints.length} inlay hints from '${this.k.identifier.value}' for ${$}`),ae}async resolveInlayHint(I,$){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...I);if(!H)return;const q=await this.h.resolveInlayHint(H,$);if(!!q&&!!this.l(q))return this.m(q,I)}releaseHints(I){this.e.get(I)?.dispose(),this.e.delete(I),this.d.delete(I)}l(I,$){return I.label.length===0||Array.isArray(I.label)&&I.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",I),!1):!($&&!$.contains(I.position))}m(I,$){const H=this.e.get($[0]);if(!H)throw Error("DisposableStore is missing...");const q={label:"",cacheId:$,tooltip:y.MarkdownString.fromStrict(I.tooltip),position:y.Position.from(I.position),textEdits:I.textEdits&&I.textEdits.map(y.TextEdit.from),kind:I.kind&&y.InlayHintKind.from(I.kind),paddingLeft:I.paddingLeft,paddingRight:I.paddingRight};return typeof I.label=="string"?q.label=I.label:q.label=I.label.map(J=>{const de={label:J.value};return de.tooltip=y.MarkdownString.fromStrict(J.tooltip),L.Location.isLocation(J.location)&&(de.location=y.location.from(J.location)),J.command&&(de.command=this.g.toInternal(J.command,H)),de}),q}}class Ee{constructor(I,$){this.e=I,this.f=$,this.d=new l.Cache("DocumentLink")}async provideLinks(I,$){const H=this.e.getDocument(I),q=await this.f.provideDocumentLinks(H,$);if(!(!Array.isArray(q)||q.length===0)&&!$.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:q.filter(Ee.g).map(y.DocumentLink.from)};{const J=this.d.add(q),de={links:[],cacheId:J};for(let we=0;we<q.length;we++){if(!Ee.g(q[we]))continue;const ae=y.DocumentLink.from(q[we]);ae.cacheId=[J,we],de.links.push(ae)}return de}}}static g(I){return I.target&&I.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(I,$){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...I);if(!H)return;const q=await this.f.resolveDocumentLink(H,$);if(!(!q||!Ee.g(q)))return y.DocumentLink.from(q)}releaseLinks(I){this.d.delete(I)}}class Ae{constructor(I,$){this.d=I,this.e=$}async provideColors(I,$){const H=this.d.getDocument(I),q=await this.e.provideDocumentColors(H,$);return Array.isArray(q)?q.map(de=>({color:y.Color.from(de.color),range:y.Range.from(de.range)})):[]}async provideColorPresentations(I,$,H){const q=this.d.getDocument(I),J=y.Range.to($.range),de=y.Color.to($.color),we=await this.e.provideColorPresentations(de,{document:q,range:J},H);if(!!Array.isArray(we))return we.map(y.ColorPresentation.from)}}class Be{constructor(I,$){this.d=I,this.e=$}async provideFoldingRanges(I,$,H){const q=this.d.getDocument(I),J=await this.e.provideFoldingRanges(q,$,H);if(!!Array.isArray(J))return J.map(y.FoldingRange.from)}}class xe{constructor(I,$,H){this.d=I,this.e=$,this.f=H}async provideSelectionRanges(I,$,H){const q=this.d.getDocument(I),J=$.map(y.Position.to),de=await this.e.provideSelectionRanges(q,J,H);if(!(0,N.isNonEmptyArray)(de))return[];if(de.length!==J.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const we=[];for(let ae=0;ae<J.length;ae++){const pe=[];we.push(pe);let ve=J[ae],We=de[ae];for(;;){if(!We.range.contains(ve))throw new Error("INVALID selection range, must contain the previous range");if(pe.push(y.SelectionRange.from(We)),!We.parent)break;ve=We.range,We=We.parent}}return we}}class Te{constructor(I,$){this.f=I,this.g=$,this.d=new c.IdGenerator(""),this.e=new Map}async prepareSession(I,$,H){const q=this.f.getDocument(I),J=y.Position.to($),de=await this.g.prepareCallHierarchy(q,J,H);if(!de)return;const we=this.d.nextId();return this.e.set(we,new Map),Array.isArray(de)?de.map(ae=>this.h(we,ae)):[this.h(we,de)]}async provideCallsTo(I,$,H){const q=this.j(I,$);if(!q)throw new Error("missing call hierarchy item");const J=await this.g.provideCallHierarchyIncomingCalls(q,H);if(!!J)return J.map(de=>({from:this.h(I,de.from),fromRanges:de.fromRanges.map(we=>y.Range.from(we))}))}async provideCallsFrom(I,$,H){const q=this.j(I,$);if(!q)throw new Error("missing call hierarchy item");const J=await this.g.provideCallHierarchyOutgoingCalls(q,H);if(!!J)return J.map(de=>({to:this.h(I,de.to),fromRanges:de.fromRanges.map(we=>y.Range.from(we))}))}releaseSession(I){this.e.delete(I)}h(I,$){const H=this.e.get(I),q=y.CallHierarchyItem.from($,I,H.size.toString(36));return H.set(q._itemId,$),q}j(I,$){return this.e.get(I)?.get($)}}class Ie{constructor(I,$){this.f=I,this.g=$,this.d=new c.IdGenerator(""),this.e=new Map}async prepareSession(I,$,H){const q=this.f.getDocument(I),J=y.Position.to($),de=await this.g.prepareTypeHierarchy(q,J,H);if(!de)return;const we=this.d.nextId();return this.e.set(we,new Map),Array.isArray(de)?de.map(ae=>this.h(we,ae)):[this.h(we,de)]}async provideSupertypes(I,$,H){const q=this.j(I,$);if(!q)throw new Error("missing type hierarchy item");const J=await this.g.provideTypeHierarchySupertypes(q,H);if(!!J)return J.map(de=>this.h(I,de))}async provideSubtypes(I,$,H){const q=this.j(I,$);if(!q)throw new Error("missing type hierarchy item");const J=await this.g.provideTypeHierarchySubtypes(q,H);if(!!J)return J.map(de=>this.h(I,de))}releaseSession(I){this.e.delete(I)}h(I,$){const H=this.e.get(I),q=y.TypeHierarchyItem.from($,I,H.size.toString(36));return H.set(q._itemId,$),q}j(I,$){return this.e.get(I)?.get($)}}class Se{constructor(I,$,H,q){this.d=I,this.e=$,this.f=H,this.g=q}async provideDocumentOnDropEdits(I,$,H,q,J){const de=this.e.getDocument($),we=y.Position.to(H),ae=y.DataTransfer.toDataTransfer(q,async ve=>(await this.d.$resolveDocumentOnDropFileData(this.g,I,ve)).buffer),pe=await this.f.provideDocumentDropEdits(de,we,ae,J);if(!!pe)return{insertText:typeof pe.insertText=="string"?pe.insertText:{snippet:pe.insertText.value},additionalEdit:pe.additionalEdit?y.WorkspaceEdit.from(pe.additionalEdit,void 0):void 0}}}class se{constructor(I,$){this.adapter=I,this.extension=$}}class ce{constructor(I,$,H,q,J,de,we,ae){this.g=$,this.h=H,this.j=q,this.k=J,this.l=de,this.m=we,this.n=ae,this.f=new Map,this.e=I.getProxy(O.MainContext.MainThreadLanguageFeatures)}o(I){return y.DocumentSelector.from(I,this.g)}p(I){return new L.Disposable(()=>{this.f.delete(I),this.e.$unregister(I)})}q(){return ce.d++}async s(I,$,H,q,J,de=!1){const we=this.f.get(I);if(!we||!(we.adapter instanceof $))return q;const ae=Date.now();de||this.l.trace(`[${we.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const pe=H(we.adapter,we.extension);return Promise.resolve(pe).catch(ve=>{(0,b.isCancellationError)(ve)||(this.l.error(`[${we.extension.identifier.value}] provider FAILED`),this.l.error(ve),this.n.onExtensionError(we.extension.identifier,ve))}).finally(()=>{de||this.l.trace(`[${we.extension.identifier.value}] provider DONE after ${Date.now()-ae}ms`)}),p.CancellationToken.isCancellationToken(J)?(0,E.raceCancellationError)(pe,J):pe}t(I,$){const H=this.q();return this.f.set(H,new se(I,$)),H}static u(I){return I.displayName||I.name}registerDocumentSymbolProvider(I,$,H,q){const J=this.t(new r(this.h,H),I),de=q&&q.label||ce.u(I);return this.e.$registerDocumentSymbolProvider(J,this.o($),de),this.p(J)}$provideDocumentSymbols(I,$,H){return this.s(I,r,q=>q.provideDocumentSymbols(i.URI.revive($),H),void 0,H)}registerCodeLensProvider(I,$,H){const q=this.q(),J=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(q,new se(new a(this.h,this.j.converter,H),I)),this.e.$registerCodeLensSupport(q,this.o($),J);let de=this.p(q);if(J!==void 0){const we=H.onDidChangeCodeLenses(ae=>this.e.$emitCodeLensEvent(J));de=L.Disposable.from(de,we)}return de}$provideCodeLenses(I,$,H){return this.s(I,a,q=>q.provideCodeLenses(i.URI.revive($),H),void 0,H)}$resolveCodeLens(I,$,H){return this.s(I,a,q=>q.resolveCodeLens($,H),void 0,void 0)}$releaseCodeLenses(I,$){this.s(I,a,H=>Promise.resolve(H.releaseCodeLenses($)),void 0,void 0)}registerDefinitionProvider(I,$,H){const q=this.t(new d(this.h,H),I);return this.e.$registerDefinitionSupport(q,this.o($)),this.p(q)}$provideDefinition(I,$,H,q){return this.s(I,d,J=>J.provideDefinition(i.URI.revive($),H,q),[],q)}registerDeclarationProvider(I,$,H){const q=this.t(new s(this.h,H),I);return this.e.$registerDeclarationSupport(q,this.o($)),this.p(q)}$provideDeclaration(I,$,H,q){return this.s(I,s,J=>J.provideDeclaration(i.URI.revive($),H,q),[],q)}registerImplementationProvider(I,$,H){const q=this.t(new u(this.h,H),I);return this.e.$registerImplementationSupport(q,this.o($)),this.p(q)}$provideImplementation(I,$,H,q){return this.s(I,u,J=>J.provideImplementation(i.URI.revive($),H,q),[],q)}registerTypeDefinitionProvider(I,$,H){const q=this.t(new n(this.h,H),I);return this.e.$registerTypeDefinitionSupport(q,this.o($)),this.p(q)}$provideTypeDefinition(I,$,H,q){return this.s(I,n,J=>J.provideTypeDefinition(i.URI.revive($),H,q),[],q)}registerHoverProvider(I,$,H,q){const J=this.t(new h(this.h,H),I);return this.e.$registerHoverProvider(J,this.o($)),this.p(J)}$provideHover(I,$,H,q){return this.s(I,h,J=>J.provideHover(i.URI.revive($),H,q),void 0,q)}registerEvaluatableExpressionProvider(I,$,H,q){const J=this.t(new g(this.h,H),I);return this.e.$registerEvaluatableExpressionProvider(J,this.o($)),this.p(J)}$provideEvaluatableExpression(I,$,H,q){return this.s(I,g,J=>J.provideEvaluatableExpression(i.URI.revive($),H,q),void 0,q)}registerInlineValuesProvider(I,$,H,q){const J=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,de=this.t(new P(this.h,H),I);this.e.$registerInlineValuesProvider(de,this.o($),J);let we=this.p(de);if(J!==void 0){const ae=H.onDidChangeInlineValues(pe=>this.e.$emitInlineValuesEvent(J));we=L.Disposable.from(we,ae)}return we}$provideInlineValues(I,$,H,q,J){return this.s(I,P,de=>de.provideInlineValues(i.URI.revive($),H,q,J),void 0,J)}registerDocumentHighlightProvider(I,$,H){const q=this.t(new M(this.h,H),I);return this.e.$registerDocumentHighlightProvider(q,this.o($)),this.p(q)}$provideDocumentHighlights(I,$,H,q){return this.s(I,M,J=>J.provideDocumentHighlights(i.URI.revive($),H,q),void 0,q)}registerLinkedEditingRangeProvider(I,$,H){const q=this.t(new j(this.h,H),I);return this.e.$registerLinkedEditingRangeProvider(q,this.o($)),this.p(q)}$provideLinkedEditingRanges(I,$,H,q){return this.s(I,j,async J=>{const de=await J.provideLinkedEditingRanges(i.URI.revive($),H,q);if(de)return{ranges:de.ranges,wordPattern:de.wordPattern?ce.w(de.wordPattern):void 0}},void 0,q)}registerReferenceProvider(I,$,H){const q=this.t(new Z(this.h,H),I);return this.e.$registerReferenceSupport(q,this.o($)),this.p(q)}$provideReferences(I,$,H,q,J){return this.s(I,Z,de=>de.provideReferences(i.URI.revive($),H,q,J),void 0,J)}registerCodeActionProvider(I,$,H,q){const J=new f.DisposableStore,de=this.t(new G(this.h,this.j.converter,this.k,H,this.l,I,this.m),I);return this.e.$registerQuickFixSupport(de,this.o($),{providedKinds:q?.providedCodeActionKinds?.map(we=>we.value),documentation:q?.documentation?.map(we=>({kind:we.kind.value,command:this.j.converter.toInternal(we.command,J)}))},ce.u(I),Boolean(H.resolveCodeAction)),J.add(this.p(de)),J}$provideCodeActions(I,$,H,q,J){return this.s(I,G,de=>de.provideCodeActions(i.URI.revive($),H,q,J),void 0,J)}$resolveCodeAction(I,$,H){return this.s(I,G,q=>q.resolveCodeAction($,H),void 0,void 0)}$releaseCodeActions(I,$){this.s(I,G,H=>Promise.resolve(H.releaseCodeActions($)),void 0,void 0)}registerDocumentFormattingEditProvider(I,$,H){const q=this.t(new R(this.h,H),I);return this.e.$registerDocumentFormattingSupport(q,this.o($),I.identifier,I.displayName||I.name),this.p(q)}$provideDocumentFormattingEdits(I,$,H,q){return this.s(I,R,J=>J.provideDocumentFormattingEdits(i.URI.revive($),H,q),void 0,q)}registerDocumentRangeFormattingEditProvider(I,$,H){const q=this.t(new F(this.h,H),I);return this.e.$registerRangeFormattingSupport(q,this.o($),I.identifier,I.displayName||I.name),this.p(q)}$provideDocumentRangeFormattingEdits(I,$,H,q,J){return this.s(I,F,de=>de.provideDocumentRangeFormattingEdits(i.URI.revive($),H,q,J),void 0,J)}registerOnTypeFormattingEditProvider(I,$,H,q){const J=this.t(new B(this.h,H),I);return this.e.$registerOnTypeFormattingSupport(J,this.o($),q,I.identifier),this.p(J)}$provideOnTypeFormattingEdits(I,$,H,q,J,de){return this.s(I,B,we=>we.provideOnTypeFormattingEdits(i.URI.revive($),H,q,J,de),void 0,de)}registerWorkspaceSymbolProvider(I,$){const H=this.t(new z($,this.l),I);return this.e.$registerNavigateTypeSupport(H,typeof $.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(I,$,H){return this.s(I,z,q=>q.provideWorkspaceSymbols($,H),{symbols:[]},H)}$resolveWorkspaceSymbol(I,$,H){return this.s(I,z,q=>q.resolveWorkspaceSymbol($,H),void 0,void 0)}$releaseWorkspaceSymbols(I,$){this.s(I,z,H=>H.releaseWorkspaceSymbols($),void 0,void 0)}registerRenameProvider(I,$,H){const q=this.t(new V(this.h,H,this.l),I);return this.e.$registerRenameSupport(q,this.o($),V.supportsResolving(H)),this.p(q)}$provideRenameEdits(I,$,H,q,J){return this.s(I,V,de=>de.provideRenameEdits(i.URI.revive($),H,q,J),void 0,J)}$resolveRenameLocation(I,$,H,q){return this.s(I,V,J=>J.resolveRenameLocation(i.URI.revive($),H,q),void 0,q)}registerDocumentSemanticTokensProvider(I,$,H,q){const J=this.t(new ie(this.h,H),I),de=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(J,this.o($),q,de);let we=this.p(J);if(de){const ae=H.onDidChangeSemanticTokens(pe=>this.e.$emitDocumentSemanticTokensEvent(de));we=L.Disposable.from(we,ae)}return we}$provideDocumentSemanticTokens(I,$,H,q){return this.s(I,ie,J=>J.provideDocumentSemanticTokens(i.URI.revive($),H,q),null,q)}$releaseDocumentSemanticTokens(I,$){this.s(I,ie,H=>H.releaseDocumentSemanticColoring($),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(I,$,H,q){const J=this.t(new me(this.h,H),I);return this.e.$registerDocumentRangeSemanticTokensProvider(J,this.o($),q),this.p(J)}$provideDocumentRangeSemanticTokens(I,$,H,q){return this.s(I,me,J=>J.provideDocumentRangeSemanticTokens(i.URI.revive($),H,q),null,q)}registerCompletionItemProvider(I,$,H,q){const J=this.t(new ue(this.h,this.j.converter,H,this.m,I),I);return this.e.$registerCompletionsProvider(J,this.o($),q,ue.supportsResolving(H),`${I.identifier.value}(${q.join("")})`),this.p(J)}$provideCompletionItems(I,$,H,q,J){return this.s(I,ue,de=>de.provideCompletionItems(i.URI.revive($),H,q,J),void 0,J)}$resolveCompletionItem(I,$,H){return this.s(I,ue,q=>q.resolveCompletionItem($,H),void 0,H)}$releaseCompletionItems(I,$){this.s(I,ue,H=>H.releaseCompletionItems($),void 0,void 0)}registerInlineCompletionsProvider(I,$,H){const q=new De(I,this.h,H,this.j.converter),J=this.t(q,I);return this.e.$registerInlineCompletionsSupport(J,this.o($),q.supportsHandleDidShowCompletionItem),this.p(J)}$provideInlineCompletions(I,$,H,q,J){return this.s(I,oe,de=>de.provideInlineCompletions(i.URI.revive($),H,q,J),void 0,J)}$handleInlineCompletionDidShow(I,$,H){this.s(I,oe,async q=>{q.handleDidShowCompletionItem($,H)},void 0,void 0)}$freeInlineCompletionsList(I,$){this.s(I,oe,async H=>{H.disposeCompletions($)},void 0,void 0)}registerSignatureHelpProvider(I,$,H,q){const J=Array.isArray(q)?{triggerCharacters:q,retriggerCharacters:[]}:q,de=this.t(new Q(this.h,H),I);return this.e.$registerSignatureHelpProvider(de,this.o($),J),this.p(de)}$provideSignatureHelp(I,$,H,q,J){return this.s(I,Q,de=>de.provideSignatureHelp(i.URI.revive($),H,q,J),void 0,J)}$releaseSignatureHelp(I,$){this.s(I,Q,H=>H.releaseSignatureHelp($),void 0,void 0)}registerInlayHintsProvider(I,$,H){const q=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,J=this.t(new le(this.h,this.j.converter,H,this.l,I),I);this.e.$registerInlayHintsProvider(J,this.o($),typeof H.resolveInlayHint=="function",q,ce.u(I));let de=this.p(J);if(q!==void 0){const we=H.onDidChangeInlayHints(ae=>this.e.$emitInlayHintsEvent(q));de=L.Disposable.from(de,we)}return de}$provideInlayHints(I,$,H,q){return this.s(I,le,J=>J.provideInlayHints(i.URI.revive($),H,q),void 0,q)}$resolveInlayHint(I,$,H){return this.s(I,le,q=>q.resolveInlayHint($,H),void 0,H)}$releaseInlayHints(I,$){this.s(I,le,H=>H.releaseHints($),void 0,void 0)}registerDocumentLinkProvider(I,$,H){const q=this.t(new Ee(this.h,H),I);return this.e.$registerDocumentLinkProvider(q,this.o($),typeof H.resolveDocumentLink=="function"),this.p(q)}$provideDocumentLinks(I,$,H){return this.s(I,Ee,q=>q.provideLinks(i.URI.revive($),H),void 0,H,$.scheme==="output")}$resolveDocumentLink(I,$,H){return this.s(I,Ee,q=>q.resolveLink($,H),void 0,void 0,!0)}$releaseDocumentLinks(I,$){this.s(I,Ee,H=>H.releaseLinks($),void 0,void 0,!0)}registerColorProvider(I,$,H){const q=this.t(new Ae(this.h,H),I);return this.e.$registerDocumentColorProvider(q,this.o($)),this.p(q)}$provideDocumentColors(I,$,H){return this.s(I,Ae,q=>q.provideColors(i.URI.revive($),H),[],H)}$provideColorPresentations(I,$,H,q){return this.s(I,Ae,J=>J.provideColorPresentations(i.URI.revive($),H,q),void 0,q)}registerFoldingRangeProvider(I,$,H){const q=this.q(),J=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(q,new se(new Be(this.h,H),I)),this.e.$registerFoldingRangeProvider(q,this.o($),I.identifier,J);let de=this.p(q);if(J!==void 0){const we=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(J));de=L.Disposable.from(de,we)}return de}$provideFoldingRanges(I,$,H,q){return this.s(I,Be,J=>J.provideFoldingRanges(i.URI.revive($),H,q),void 0,q)}registerSelectionRangeProvider(I,$,H){const q=this.t(new xe(this.h,H,this.l),I);return this.e.$registerSelectionRangeProvider(q,this.o($)),this.p(q)}$provideSelectionRanges(I,$,H,q){return this.s(I,xe,J=>J.provideSelectionRanges(i.URI.revive($),H,q),[],q)}registerCallHierarchyProvider(I,$,H){const q=this.t(new Te(this.h,H),I);return this.e.$registerCallHierarchyProvider(q,this.o($)),this.p(q)}$prepareCallHierarchy(I,$,H,q){return this.s(I,Te,J=>Promise.resolve(J.prepareSession(i.URI.revive($),H,q)),void 0,q)}$provideCallHierarchyIncomingCalls(I,$,H,q){return this.s(I,Te,J=>J.provideCallsTo($,H,q),void 0,q)}$provideCallHierarchyOutgoingCalls(I,$,H,q){return this.s(I,Te,J=>J.provideCallsFrom($,H,q),void 0,q)}$releaseCallHierarchy(I,$){this.s(I,Te,H=>Promise.resolve(H.releaseSession($)),void 0,void 0)}registerTypeHierarchyProvider(I,$,H){const q=this.t(new Ie(this.h,H),I);return this.e.$registerTypeHierarchyProvider(q,this.o($)),this.p(q)}$prepareTypeHierarchy(I,$,H,q){return this.s(I,Ie,J=>Promise.resolve(J.prepareSession(i.URI.revive($),H,q)),void 0,q)}$provideTypeHierarchySupertypes(I,$,H,q){return this.s(I,Ie,J=>J.provideSupertypes($,H,q),void 0,q)}$provideTypeHierarchySubtypes(I,$,H,q){return this.s(I,Ie,J=>J.provideSubtypes($,H,q),void 0,q)}$releaseTypeHierarchy(I,$){this.s(I,Ie,H=>Promise.resolve(H.releaseSession($)),void 0,void 0)}registerDocumentOnDropEditProvider(I,$,H){const q=this.q();return this.f.set(q,new se(new Se(this.e,this.h,H,q),I)),this.e.$registerDocumentOnDropEditProvider(q,this.o($)),this.p(q)}$provideDocumentOnDropEdits(I,$,H,q,J,de){return this.s(I,Se,we=>Promise.resolve(we.provideDocumentOnDropEdits($,i.URI.revive(H),q,J,de)),void 0,void 0)}registerDocumentPasteEditProvider(I,$,H,q){const J=this.q();return this.f.set(J,new se(new A(this.e,this.h,H,J),I)),this.e.$registerPasteEditProvider(J,this.o($),!!H.prepareDocumentPaste,q.pasteMimeTypes),this.p(J)}$prepareDocumentPaste(I,$,H,q,J){return this.s(I,A,de=>de.prepareDocumentPaste(i.URI.revive($),H,q,J),void 0,J)}$providePasteEdits(I,$,H,q,J,de){return this.s(I,A,we=>we.providePasteEdits($,i.URI.revive(H),q,J,de),void 0,de)}static w(I){return{pattern:I.source,flags:(0,S.regExpFlags)(I)}}static y(I){return{decreaseIndentPattern:ce.w(I.decreaseIndentPattern),increaseIndentPattern:ce.w(I.increaseIndentPattern),indentNextLinePattern:I.indentNextLinePattern?ce.w(I.indentNextLinePattern):void 0,unIndentedLinePattern:I.unIndentedLinePattern?ce.w(I.unIndentedLinePattern):void 0}}static z(I){return{beforeText:ce.w(I.beforeText),afterText:I.afterText?ce.w(I.afterText):void 0,previousLineText:I.previousLineText?ce.w(I.previousLineText):void 0,action:I.action}}static B(I){return I.map(ce.z)}setLanguageConfiguration(I,$,H){const{wordPattern:q}=H;if(q&&(0,S.regExpLeadsToEndlessLoop)(q))throw new Error(`Invalid language configuration: wordPattern '${q}' is not allowed to match the empty string.`);q?this.h.setWordDefinitionFor($,q):this.h.setWordDefinitionFor($,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",I,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",I,"Do not use.");const J=this.q(),de={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?ce.w(H.wordPattern):void 0,indentationRules:H.indentationRules?ce.y(H.indentationRules):void 0,onEnterRules:H.onEnterRules?ce.B(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport};return this.e.$setLanguageConfiguration(J,$,de),this.p(J)}$setWordDefinitions(I){for(const $ of I)this.h.setWordDefinitionFor($.languageId,new RegExp($.regexSource,$.regexFlags))}}e.ExtHostLanguageFeatures=ce,ce.d=0}),define(ke[211],Ce([1,0,4,8,6,29,14,7]),function(ee,e,i,T,y,L,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(N,D,m,p){this.c=D,this.d=m,this.e=p,this.b=[],this.f=0,this.g=new Set,this.a=N.getProxy(i.MainContext.MainThreadLanguages)}$acceptLanguageIds(N){this.b=N}async getLanguages(){return this.b.slice(0)}async changeLanguage(N,D){await this.a.$changeLanguage(N,D);const m=this.c.getDocumentData(N);if(!m)throw new Error(`document '${N.toString()}' NOT found`);return m.document}async tokenAtPosition(N,D){const m=N.version,p=T.Position.from(D),f=await this.a.$tokensAtPosition(N.uri,p),t={type:y.StandardTokenType.Other,range:N.getWordRangeAtPosition(D)??new y.Range(D.line,D.character,D.line,D.character)};if(!f)return t;const c={range:T.Range.to(f.range),type:T.TokenType.to(f.type)};return!c.range.contains(D)||m!==N.version?t:c}createLanguageStatusItem(N,D,m){const p=this.f++,f=this.a,t=this.g,c=`${N.identifier.value}/${D}`;if(t.has(c))throw new Error(`LanguageStatusItem with id '${D}' ALREADY exists`);t.add(c);const l={selector:m,id:D,name:N.displayName??N.name,severity:y.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let v;const b=new O.DisposableStore,E=()=>{v?.dispose(),v=(0,k.disposableTimeout)(()=>{b.clear(),this.a.$setLanguageStatus(p,{id:c,name:l.name??N.displayName??N.name,source:N.displayName??N.name,selector:T.DocumentSelector.from(l.selector,this.e),label:l.text,detail:l.detail??"",severity:l.severity===y.LanguageStatusSeverity.Error?L.default.Error:l.severity===y.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:l.command&&this.d.toInternal(l.command,b),accessibilityInfo:l.accessibilityInformation,busy:l.busy})},0)},w={dispose(){b.dispose(),v?.dispose(),f.$removeLanguageStatus(p),t.delete(c)},get id(){return l.id},get name(){return l.name},set name(r){l.name=r,E()},get selector(){return l.selector},set selector(r){l.selector=r,E()},get text(){return l.text},set text(r){l.text=r,E()},get detail(){return l.detail},set detail(r){l.detail=r,E()},get severity(){return l.severity},set severity(r){l.severity=r,E()},get accessibilityInformation(){return l.accessibilityInformation},set accessibilityInformation(r){l.accessibilityInformation=r,E()},get command(){return l.command},set command(r){l.command=r,E()},get busy(){return l.busy},set busy(r){l.busy=r,E()}};return E(),w}}e.ExtHostLanguages=S}),define(ke[75],Ce([1,0,21,10,2,3,12,4,27,15]),function(ee,e,i,T,y,L,k,O,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let N=class{constructor(m,p,f){this.f=f,this.d=new Map,this.a=p.getProxy(O.MainContext.MainThreadLocalization),this.b=m.environment.appLanguage,this.c=this.b===i.LANGUAGE_DEFAULT}getMessage(m,p){const{message:f,args:t,comment:c}=p;if(this.c)return(0,T.format2)(f,t??{});let l=f;c&&c.length>0&&(l+=`/${Array.isArray(c)?c.join():c}`);const v=this.d.get(m)?.contents[l];return v||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${l}`),(0,T.format2)(v??f,t??{})}getBundle(m){return this.d.get(m)?.contents}getBundleUri(m){return this.d.get(m)?.uri}async initializeLocalizedMessages(m){if(this.c||!m.l10n&&!m.isBuiltin||this.d.has(m.identifier.value))return;let p;const f=await this.g(m);if(!f){this.f.error(`No bundle location found for extension ${m.identifier.value}`);return}try{const t=await this.a.$fetchBundleContents(f),c=JSON.parse(t);p=m.isBuiltin?c.contents?.bundle:c}catch(t){this.f.error(`Failed to load translations for ${m.identifier.value} from ${f}: ${t.message}`);return}p&&this.d.set(m.identifier.value,{contents:p,uri:f})}async g(m){if(m.isBuiltin){const p=await this.a.$fetchBuiltInBundleUri(m.identifier.value);return y.URI.revive(p)}return m.l10n?y.URI.joinPath(m.extensionLocation,m.l10n,`bundle.l10n.${this.b}.json`):void 0}};N=qe([Ve(0,S.IExtHostInitDataService),Ve(1,C.IExtHostRpcService),Ve(2,k.ILogService)],N),e.ExtHostLocalizationService=N,e.IExtHostLocalizationService=(0,L.createDecorator)("IExtHostLocalizationService")}),define(ke[212],Ce([1,0,12,4,27,15,2,5,9]),function(ee,e,i,T,y,L,k,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let C=class extends i.AbstractLoggerService{constructor(m,p){super(p.logLevel,O.Event.None),this.g=m.getProxy(T.MainContext.MainThreadLogger)}$setLevel(m,p){p?this.setLevel(k.URI.revive(p),m):(0,S.isUndefined)(m)||this.setLevel(m)}f(m,p,f){return new N(this.g,m,p,f)}};C=qe([Ve(0,L.IExtHostRpcService),Ve(1,y.IExtHostInitDataService)],C),e.ExtHostLoggerService=C;class N extends i.AbstractMessageLogger{constructor(m,p,f,t){super(t?.always),this.m=m,this.n=p,this.k=!1,this.l=[],this.setLevel(f),this.m.$createLogger(p,t).then(()=>{this.r(this.l),this.k=!0})}g(m,p){const f=[[m,p]];this.k?this.r(f):this.l.push(...f)}r(m){this.m.$log(this.n,m)}}}),define(ke[213],Ce([1,0,4,12,26]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function L(O){return O&&O.title}let k=class{constructor(S,C){this.b=C,this.a=S.getProxy(i.MainContext.MainThreadMessageService)}showMessage(S,C,N,D,m){const p={source:{identifier:S.identifier,label:S.displayName||S.name}};let f;typeof D=="string"||L(D)?f=[D,...m]:(p.modal=D?.modal,p.useCustom=D?.useCustom,p.detail=D?.detail,f=m),p.useCustom&&(0,y.checkProposedApiEnabled)(S,"resolvers");const t=[];for(let c=0;c<f.length;c++){const l=f[c];if(typeof l=="string")t.push({title:l,handle:c,isCloseAffordance:!1});else if(typeof l=="object"){const{title:v,isCloseAffordance:b}=l;t.push({title:v,isCloseAffordance:!!b,handle:c})}else this.b.warn("Invalid message item:",l)}return this.a.$showMessage(C,N,p,t).then(c=>{if(typeof c=="number")return f[c]})}};k=qe([Ve(1,T.ILogService)],k),e.ExtHostMessageService=k}),define(ke[214],Ce([1,0,24,5,7,28,10,9,2,52,4,38,8,6,43,187,98]),function(ee,e,i,T,y,L,k,O,S,C,N,D,m,p,f,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class l{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(b=>b.apiEditor)}constructor(b,E,w,r){this.q=w,this.r=r,this.f=new Map,this.g=new L.ResourceMap,this.h=new Map,this.j=new T.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new T.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new T.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new T.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new C.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=b.getProxy(N.MainContext.MainThreadNotebook),this.c=b.getProxy(N.MainContext.MainThreadNotebookDocuments),this.d=b.getProxy(N.MainContext.MainThreadNotebookEditors),this.i=E.converter,E.registerArgumentProcessor({processArgument:a=>{if(a&&a.$mid===13){const o=a.notebookEditor?.notebookUri,d=a.cell.handle,u=this.g.get(o)?.getCell(d);if(u)return u.apiCell}if(a&&a.$mid===14){const o=a.uri,d=this.g.get(o);if(d)return d.apiNotebook}return a}}),l.x(E)}getEditorById(b){const E=this.h.get(b);if(!E)throw new Error(`unknown text editor: ${b}. known editors: ${[...this.h.keys()]} `);return E}getIdByEditor(b){for(const[E,w]of this.h)if(w.apiEditor===b)return E}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(b,E){const w=this.g.get(b);if(!w&&!E)throw new Error(`NO notebook document for '${b}'`);return w}static s(b,E){if(!E)return;const w=E.filenamePattern.map(r=>m.NotebookExclusiveDocumentPattern.from(r)).filter(r=>r!==void 0);if(E.filenamePattern&&!w){console.warn(`Notebook content provider view options file name pattern is invalid ${E.filenamePattern}`);return}return{extension:b.identifier,providerDisplayName:b.displayName||b.name,displayName:E.displayName,filenamePattern:w,exclusive:E.exclusive||!1}}registerNotebookCellStatusBarItemProvider(b,E,w){const r=l.a++,a=typeof w.onDidChangeCellStatusBarItems=="function"?l.a++:void 0;this.f.set(r,w),this.b.$registerNotebookCellStatusBarItemProvider(r,a,E);let o;return a!==void 0&&(o=w.onDidChangeCellStatusBarItems(d=>this.b.$emitCellStatusBarEvent(a))),new p.Disposable(()=>{this.f.delete(r),this.b.$unregisterNotebookCellStatusBarItemProvider(r,a),o?.dispose()})}async createNotebookDocument(b){const E=await this.c.$tryCreateNotebook({viewType:b.viewType,content:b.content&&m.NotebookData.from(b.content)});return S.URI.revive(E)}async openNotebookDocument(b){const E=this.g.get(b);if(E)return E.apiNotebook;const w=await this.c.$tryOpenNotebook(b),r=this.g.get(S.URI.revive(w));return(0,O.assertIsDefined)(r?.apiNotebook)}async showNotebookDocument(b,E){S.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let w;typeof E=="object"?w={position:m.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus,selections:E.selections&&E.selections.map(m.NotebookRange.from),pinned:typeof E.preview=="boolean"?!E.preview:void 0}:w={preserveFocus:!1};const r=await this.d.$tryShowNotebookDocument(b.uri,b.notebookType,w),a=r&&this.h.get(r)?.apiEditor;if(a)return a;throw r?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(b,E,w,r){const a=this.f.get(b),o=S.URI.revive(E),d=this.g.get(o);if(!d||!a)return;const s=d.getCellFromIndex(w);if(!s)return;const u=await a.provideCellStatusBarItems(s.apiCell,r);if(!u)return;const n=new y.DisposableStore,h=this.p.add([n]),P=(Array.isArray(u)?u:[u]).map(M=>m.NotebookStatusBarItem.from(M,this.i,n));return{cacheId:h,items:P}}$releaseNotebookCellStatusBarItems(b){this.p.delete(b)}registerNotebookSerializer(b,E,w,r,a){if((0,k.isFalsyOrWhitespace)(E))throw new Error("viewType cannot be empty or just whitespace");const o=this.t++;return this.u.set(o,w),this.b.$registerNotebookSerializer(o,{id:b.identifier,location:b.extensionLocation},E,m.NotebookDocumentContentOptions.from(r),l.s(b,a)),(0,y.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(o)})}async $dataToNotebook(b,E,w){const r=this.u.get(b);if(!r)throw new Error("NO serializer found");const a=await r.deserializeNotebook(E.buffer,w);return new f.SerializableObjectWithBuffers(m.NotebookData.from(a))}async $notebookToData(b,E,w){const r=this.u.get(b);if(!r)throw new Error("NO serializer found");const a=await r.serializeNotebook(m.NotebookData.to(E.value),w);return i.VSBuffer.wrap(a)}w(b,E,w){if(this.h.has(E))throw new Error(`editor with id ALREADY EXSIST: ${E}`);const r=new c.ExtHostNotebookEditor(E,this.d,b,w.visibleRanges.map(m.NotebookRange.to),w.selections.map(m.NotebookRange.to),typeof w.viewColumn=="number"?m.ViewColumn.to(w.viewColumn):void 0);this.h.set(E,r)}$acceptDocumentAndEditorsDelta(b){if(b.value.removedDocuments)for(const w of b.value.removedDocuments){const r=S.URI.revive(w),a=this.g.get(r);a&&(a.dispose(),this.g.delete(r),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:a.apiNotebook.getCells().map(o=>o.document.uri)}),this.n.fire(a.apiNotebook));for(const o of this.h.values())o.notebookData.uri.toString()===r.toString()&&this.h.delete(o.id)}if(b.value.addedDocuments){const w=[];for(const r of b.value.addedDocuments){const a=S.URI.revive(r.uri);if(this.g.has(a))throw new Error(`adding EXISTING notebook ${a} `);const o=new t.ExtHostNotebookDocument(this.c,this.q,this.r,a,r);w.push(...r.cells.map(d=>t.ExtHostCell.asModelAddData(o.apiNotebook,d))),this.g.get(a)?.dispose(),this.g.set(a,o),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:w}),this.m.fire(o.apiNotebook)}}if(b.value.addedEditors)for(const w of b.value.addedEditors){if(this.h.has(w.id))return;const r=S.URI.revive(w.documentUri),a=this.g.get(r);a&&this.w(a,w.id,w)}const E=[];if(b.value.removedEditors)for(const w of b.value.removedEditors){const r=this.h.get(w);r&&(this.h.delete(w),this.k?.id===r.id&&(this.k=void 0),E.push(r))}if(b.value.visibleEditors){this.l=b.value.visibleEditors.map(r=>this.h.get(r)).filter(r=>!!r);const w=new Set;this.l.forEach(r=>w.add(r.id));for(const r of this.h.values()){const a=w.has(r.id);r._acceptVisibility(a)}this.l=[...this.h.values()].map(r=>r).filter(r=>r.visible),this.o.fire(this.visibleNotebookEditors)}b.value.newActiveEditor===null?this.k=void 0:b.value.newActiveEditor&&(this.k=this.h.get(b.value.newActiveEditor)),b.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(b){const E=D.ApiCommandArgument.String.with("notebookType","A notebook type"),w=new D.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[E,new D.ApiCommandArgument("data","Bytes to convert to data",a=>a instanceof Uint8Array,a=>i.VSBuffer.wrap(a))],new D.ApiCommandResult("Notebook Data",a=>m.NotebookData.to(a.value))),r=new D.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[E,new D.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",a=>!0,a=>new f.SerializableObjectWithBuffers(m.NotebookData.from(a)))],new D.ApiCommandResult("Bytes",a=>a.buffer));b.registerApiCommand(w),b.registerApiCommand(r)}}e.ExtHostNotebookController=l,l.a=0}),define(ke[215],Ce([1,0,16,14,20,5,7,28,2,25,12,52,4,38,8,6,69,175,26,43]),function(ee,e,i,T,y,L,k,O,S,C,N,D,m,p,f,t,c,l,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let E=class{constructor(s,u,n,h,g){this.k=u,this.l=n,this.m=h,this.n=g,this.b=new O.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new D.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=s.getProxy(m.MainContext.MainThreadNotebookKernels);const P=new p.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new p.ApiCommandArgument("options","Select kernel options",M=>!0,M=>{if(M&&"notebookEditor"in M&&"id"in M){const j=this.l.getIdByEditor(M.notebookEditor);return{id:M.id,extension:M.extension,notebookEditorId:j}}else if(M&&"notebookEditor"in M){const j=this.l.getIdByEditor(M.notebookEditor);if(j===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${M.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:j}}return M})],p.ApiCommandResult.Void);this.m.registerApiCommand(P)}createNotebookController(s,u,n,h,g,P){for(const oe of this.h.values())if(oe.controller.id===u&&C.ExtensionIdentifier.equals(s.identifier,oe.extensionId))throw new Error(`notebook controller with id '${u}' ALREADY exist`);const M=this.i++,j=this;this.n.trace(`NotebookController[${M}], CREATED by ${s.identifier.value}, ${u}`);const Z=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${s.identifier}'`);let G=!1;const A=new k.DisposableStore,R=new L.Emitter,F=new L.Emitter,B={id:o(s.identifier,u),notebookType:n,extensionId:s.identifier,extensionLocation:s.extensionLocation,label:h||s.identifier.value,preloads:P?P.map(f.NotebookRendererScript.from):[]};let z=g??Z,V;this.a.$addKernel(M,B).catch(oe=>{console.log(oe),G=!0});let K=0;const ie=()=>{if(G)return;const oe=++K;Promise.resolve().then(()=>{oe===K&&this.a.$updateKernel(M,B)})},me=new O.ResourceMap,ue={get id(){return u},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:R.event,get label(){return B.label},set label(oe){B.label=oe??s.displayName??s.name,ie()},get detail(){return B.detail??""},set detail(oe){B.detail=oe,ie()},get description(){return B.description??""},set description(oe){B.description=oe,ie()},get kind(){return(0,v.checkProposedApiEnabled)(s,"notebookControllerKind"),B.kind??""},set kind(oe){(0,v.checkProposedApiEnabled)(s,"notebookControllerKind"),B.kind=oe,ie()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages(oe){B.supportedLanguages=oe,ie()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder(oe){B.supportsExecutionOrder=oe,ie()},get rendererScripts(){return B.preloads?B.preloads.map(f.NotebookRendererScript.to):[]},get executeHandler(){return z},set executeHandler(oe){z=oe??Z},get interruptHandler(){return V},set interruptHandler(oe){V=oe,B.supportsInterrupt=Boolean(oe),ie()},createNotebookCellExecution(oe){if(G)throw new Error("notebook controller is DISPOSED");if(!me.has(oe.notebook.uri))throw j.n.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(me.keys()).map(De=>De.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.notebook.uri.toString()}`);return j._createNotebookCellExecution(oe,o(s.identifier,this.id))},dispose:()=>{G||(this.n.trace(`NotebookController[${M}], DISPOSED`),G=!0,this.h.delete(M),A.dispose(),R.dispose(),F.dispose(),this.a.$removeKernel(M))},updateNotebookAffinity(oe,De){De===t.NotebookControllerAffinity2.Hidden&&(0,v.checkProposedApiEnabled)(s,"notebookControllerAffinityHidden"),j.a.$updateNotebookPriority(M,oe.uri,De)},onDidReceiveMessage:F.event,postMessage(oe,De){return(0,v.checkProposedApiEnabled)(s,"notebookMessaging"),j.a.$postMessage(M,De&&j.l.getIdByEditor(De),oe)},asWebviewUri(oe){return(0,v.checkProposedApiEnabled)(s,"notebookMessaging"),(0,c.asWebviewUri)(oe,j.k.remote)}};return this.h.set(M,{extensionId:s.identifier,controller:ue,onDidReceiveMessage:F,onDidChangeSelection:R,associatedNotebooks:me}),ue}getIdByController(s){for(const[u,n]of this.h)if(n.controller===s)return o(n.extensionId,s.id);return null}createNotebookControllerDetectionTask(s,u){const n=this.d++,h=this;this.n.trace(`NotebookControllerDetectionTask[${n}], CREATED by ${s.identifier.value}`),this.a.$addKernelDetectionTask(n,u);const g={dispose:()=>{this.c.delete(n),h.a.$removeKernelDetectionTask(n)}};return this.c.set(n,g),g}registerKernelSourceActionProvider(s,u,n){const h=this.f++,g=this;return this.e.set(h,n),this.n.trace(`NotebookKernelSourceActionProvider[${h}], CREATED by ${s.identifier.value}`),this.a.$addKernelSourceActionProvider(h,u),{dispose:()=>{this.e.delete(h),g.a.$removeKernelSourceActionProvider(h)}}}async $provideKernelSourceActions(s,u){const n=this.e.get(s);if(n){const h=new k.DisposableStore;return this.g.add([h]),(await n.provideNotebookKernelSourceActions(u)??[]).map(P=>f.NotebookKernelSourceAction.from(P,this.m.converter,h))}return[]}$acceptNotebookAssociation(s,u,n){const h=this.h.get(s);if(h){const g=this.l.getNotebookDocument(S.URI.revive(u));n?h.associatedNotebooks.set(g.uri,!0):h.associatedNotebooks.delete(g.uri),this.n.trace(`NotebookController[${s}] ASSOCIATE notebook`,g.uri.toString(),n),h.onDidChangeSelection.fire({selected:n,notebook:g.apiNotebook})}}async $executeCells(s,u,n){const h=this.h.get(s);if(!h)return;const g=this.l.getNotebookDocument(S.URI.revive(u)),P=[];for(const M of n){const j=g.getCell(M);j&&P.push(j.apiCell)}try{this.n.trace(`NotebookController[${s}] EXECUTE cells`,g.uri.toString(),P.length),await h.controller.executeHandler.call(h.controller,P,g.apiNotebook,h.controller)}catch(M){this.n.error(`NotebookController[${s}] execute cells FAILED`,M),console.error(M)}}async $cancelCells(s,u,n){const h=this.h.get(s);if(!h)return;const g=this.l.getNotebookDocument(S.URI.revive(u));if(h.controller.interruptHandler)await h.controller.interruptHandler.call(h.controller,g.apiNotebook);else for(const P of n){const M=g.getCell(P);M&&this.b.get(M.uri)?.cancel()}}$acceptKernelMessageFromRenderer(s,u,n){const h=this.h.get(s);if(!h)return;const g=this.l.getEditorById(u);h.onDidReceiveMessage.fire(Object.freeze({editor:g.apiEditor,message:n}))}$cellExecutionChanged(s,u,n){const g=this.l.getNotebookDocument(S.URI.revive(s)).getCell(u);if(g){const P=n?f.NotebookCellExecutionState.to(n):t.NotebookCellExecutionState.Idle;P!==void 0&&this.j.fire({cell:g.apiCell,state:P})}}_createNotebookCellExecution(s,u){if(s.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const h=this.l.getNotebookDocument(s.notebook.uri).getCellFromApiCell(s);if(!h)throw new Error("invalid cell");if(this.b.has(h.uri))throw new Error(`duplicate execution for ${h.uri}`);const g=new r(u,h,this.a);this.b.set(h.uri,g);const P=g.onDidChangeState(()=>{g.state===w.Resolved&&(g.dispose(),P.dispose(),this.b.delete(h.uri))});return g.asApiObject()}};E=qe([Ve(4,N.ILogService)],E),e.ExtHostNotebookKernels=E;var w;(function(d){d[d.Init=0]="Init",d[d.Started=1]="Started",d[d.Resolved=2]="Resolved"})(w||(w={}));class r extends k.Disposable{get state(){return this.f}constructor(s,u,n){super(),this.j=u,this.k=n,this.b=r.a++,this.c=new L.Emitter,this.onDidChangeState=this.c.event,this.f=w.Init,this.g=this.B(new y.CancellationTokenSource),this.h=new a(10,h=>this.m(h)),this.i=u.internalMetadata.executionOrder,this.k.$createExecution(this.b,s,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(s){await this.h.addItem(s)}async m(s){const u=Array.isArray(s)?s:[s];return this.k.$updateExecution(this.b,new b.SerializableObjectWithBuffers(u))}n(){if(this.f===w.Init)throw new Error("Must call start before modifying cell output");if(this.f===w.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(s){let u=this.j;if(s&&(u=this.j.notebook.getCellFromApiCell(s)),!u)throw new Error("INVALID cell");return u.handle}s(s){return s.map(u=>{const n=t.NotebookCellOutput.ensureUniqueMimeTypes(u.items,!0);return n===u.items?f.NotebookCellOutput.from(u):f.NotebookCellOutput.from({items:n,id:u.id,metadata:u.metadata})})}async t(s,u,n){const h=this.r(u),g=this.s((0,i.asArray)(s));return this.l({editType:l.CellExecutionUpdateType.Output,cellHandle:h,append:n,outputs:g})}async w(s,u,n){return s=t.NotebookCellOutput.ensureUniqueMimeTypes((0,i.asArray)(s),!0),this.l({editType:l.CellExecutionUpdateType.OutputItems,items:s.map(f.NotebookCellOutputItem.from),outputId:u.id,append:n})}asApiObject(){const s=this;return Object.freeze({get token(){return s.g.token},get cell(){return s.j.apiCell},get executionOrder(){return s.i},set executionOrder(n){s.i=n,s.m([{editType:l.CellExecutionUpdateType.ExecutionState,executionOrder:s.i}])},start(n){if(s.f===w.Resolved||s.f===w.Started)throw new Error("Cannot call start again");s.f=w.Started,s.c.fire(),s.m({editType:l.CellExecutionUpdateType.ExecutionState,runStartTime:n})},end(n,h){if(s.f===w.Resolved)throw new Error("Cannot call resolve twice");s.f=w.Resolved,s.c.fire(),s.h.flush(),s.k.$completeExecution(s.b,new b.SerializableObjectWithBuffers({runEndTime:h,lastRunSuccess:n}))},clearOutput(n){return s.n(),s.t([],n,!1)},appendOutput(n,h){return s.n(),s.t(n,h,!0)},replaceOutput(n,h){return s.n(),s.t(n,h,!1)},appendOutputItems(n,h){return s.n(),s.w(n,h,!0)},replaceOutputItems(n,h){return s.n(),s.w(n,h,!1)}})}}r.a=0;class a{constructor(s,u){this.d=s,this.e=u,this.a=[],this.b=Date.now()}addItem(s){return this.a.push(s),this.c||(this.c=new T.DeferredPromise,this.b=Date.now(),(0,T.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const s=this.c;this.c=void 0;const u=this.a;return this.a=[],this.e(u).finally(()=>s.complete())}}function o(d,s){return`${d.value}/${s}`}e.createKernelId=o}),define(ke[216],Ce([1,0,5,4,98]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class L{constructor(O,S){this.c=S,this.a=new Map,this.b=O.getProxy(T.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(O,S,C){const N=this.c.getEditorById(O);this.a.get(S)?.fire({editor:N.apiEditor,message:C})}createRendererMessaging(O,S){if(!O.contributes?.notebookRenderer?.some(N=>N.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(N,D,m)=>this.d(S).event(N,D,m),postMessage:(N,D)=>{y.ExtHostNotebookEditor.apiEditorsToExtHost.has(N)&&([N,D]=[D,N]);const m=D&&y.ExtHostNotebookEditor.apiEditorsToExtHost.get(D);return this.b.$postMessage(m?.id,S,N)}}}d(O){let S=this.a.get(O);return S||(S=new i.Emitter({onDidRemoveLastListener:()=>{S?.dispose(),this.a.delete(O)}}),this.a.set(O,S),S)}}e.ExtHostNotebookRenderers=L}),define(ke[217],Ce([1,0,7,2,26,4]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class k{constructor(S){this.b=new Map,this.a=S.getProxy(L.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(S,C,N){if((0,y.checkProposedApiEnabled)(S,"profileContentHandlers"),this.b.has(C))throw new Error(`Handler with id '${C}' already registered`);return this.b.set(C,N),this.a.$registerProfileContentHandler(C,N.name,S.identifier.value),(0,i.toDisposable)(()=>{this.b.delete(C),this.a.$unregisterProfileContentHandler(C)})}async $saveProfile(S,C,N,D){const m=this.b.get(S);if(!m)throw new Error(`Unknown handler with id: ${S}`);return m.saveProfile(C,N,D)}async $readProfile(S,C,N){const D=this.b.get(S);if(!D)throw new Error(`Unknown handler with id: ${S}`);return D.readProfile(T.URI.revive(C),N)}}e.ExtHostProfileContentHandlers=k}),define(ke[218],Ce([1,0,20,5,7,4,2,6,11,16,29,65]),function(ee,e,i,T,y,L,k,O,S,C,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(p,f,t){const c=p.getProxy(L.MainContext.MainThreadQuickOpen);class l{constructor(s,u){this.e=new Map,this.f=0,this.a=s,this.b=u}showQuickPick(s,u,n=i.CancellationToken.None){this.c=void 0;const h=Promise.resolve(s),g=++this.f,P=c.$show(g,{title:u?.title,placeHolder:u?.placeHolder,matchOnDescription:u?.matchOnDescription,matchOnDetail:u?.matchOnDetail,ignoreFocusLost:u?.ignoreFocusOut,canPickMany:u?.canPickMany},n),M={},j=P.then(()=>M);return Promise.race([j,h]).then(Z=>{if(Z!==M)return h.then(G=>{const A=[];for(let R=0;R<G.length;R++){const F=G[R];typeof F=="string"?A.push({label:F,handle:R}):F.kind===O.QuickPickItemKind.Separator?A.push({type:"separator",label:F.label}):A.push({label:F.label,description:F.description,detail:F.detail,picked:F.picked,alwaysShow:F.alwaysShow,handle:R})}return u&&typeof u.onDidSelectItem=="function"&&(this.c=R=>{u.onDidSelectItem(G[R])}),c.$setItems(g,A),P.then(R=>{if(typeof R=="number")return G[R];if(Array.isArray(R))return R.map(F=>G[F])})})}).then(void 0,Z=>{if(!(0,S.isCancellationError)(Z))return c.$setError(g,Z),Promise.reject(Z)})}$onItemSelected(s){this.c?.(s)}showInput(s,u=i.CancellationToken.None){return this.d=s?.validateInput,c.$input(s,typeof this.d=="function",u).then(void 0,n=>{if(!(0,S.isCancellationError)(n))return Promise.reject(n)})}async $validateInput(s){if(!this.d)return;const u=await this.d(s);if(!u||typeof u=="string")return u;let n;switch(u.severity){case O.InputBoxValidationSeverity.Info:n=N.default.Info;break;case O.InputBoxValidationSeverity.Warning:n=N.default.Warning;break;case O.InputBoxValidationSeverity.Error:n=N.default.Error;break;default:n=u.message?N.default.Error:N.default.Ignore;break}return{content:u.message,severity:n}}async showWorkspaceFolderPick(s,u=i.CancellationToken.None){const n=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!n)return;const h=await this.a.getWorkspaceFolders2();if(!!h)return h.find(g=>g.uri.toString()===n.uri.toString())}createQuickPick(s){const u=new a(s,()=>this.e.delete(u._id));return this.e.set(u._id,u),u}createInputBox(s){const u=new o(s,()=>this.e.delete(u._id));return this.e.set(u._id,u),u}$onDidChangeValue(s,u){this.e.get(s)?._fireDidChangeValue(u)}$onDidAccept(s){this.e.get(s)?._fireDidAccept()}$onDidChangeActive(s,u){const n=this.e.get(s);n instanceof a&&n._fireDidChangeActive(u)}$onDidChangeSelection(s,u){const n=this.e.get(s);n instanceof a&&n._fireDidChangeSelection(u)}$onDidTriggerButton(s,u){this.e.get(s)?._fireDidTriggerButton(u)}$onDidTriggerItemButton(s,u,n){const h=this.e.get(s);h instanceof a&&h._fireDidTriggerItemButton(u,n)}$onDidHide(s){this.e.get(s)?._fireDidHide()}}class v{constructor(s,u){this.x=s,this.y=u,this._id=a.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.Emitter,this.q=new T.Emitter,this.r=new T.Emitter,this.s=new T.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(s){this.b=s,this.z({title:s})}get step(){return this.c}set step(s){this.c=s,this.z({step:s})}get totalSteps(){return this.d}set totalSteps(s){this.d=s,this.z({totalSteps:s})}get enabled(){return this.g}set enabled(s){this.g=s,this.z({enabled:s})}get busy(){return this.j}set busy(s){this.j=s,this.z({busy:s})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(s){this.k=s,this.z({ignoreFocusOut:s})}get value(){return this.l}set value(s){this.l=s,this.z({value:s})}get placeholder(){return this.m}set placeholder(s){this.m=s,this.z({placeholder:s})}get buttons(){return this.n}set buttons(s){this.n=s.slice(),this.o.clear(),s.forEach((u,n)=>{const h=u===O.QuickInputButtons.Back?-1:n;this.o.set(h,u)}),this.z({buttons:s.map((u,n)=>({...r(u),tooltip:u.tooltip,handle:u===O.QuickInputButtons.Back?-1:n}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(s){this.l=s,this.q.fire(s)}_fireDidTriggerButton(s){const u=this.o.get(s);u&&this.r.fire(u)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,y.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),c.$dispose(this._id))}z(s){if(!this.v){for(const u of Object.keys(s)){const n=s[u];this.u[u]=n===void 0?null:n}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){c.$createOrUpdate(this.u),this.u={id:this._id}}}v.a=1;function b(d){if(d instanceof O.ThemeIcon)return{id:d.id};const s=w(d),u=E(d);return{dark:typeof s=="string"?k.URI.file(s):s,light:typeof u=="string"?k.URI.file(u):u}}function E(d){return typeof d=="object"&&"light"in d?d.light:d}function w(d){return typeof d=="object"&&"dark"in d?d.dark:d}function r(d){const s=b(d.iconPath);let u,n;return"id"in s?n=D.ThemeIcon.asClassName(s):u=s,{iconPath:u,iconClass:n}}class a extends v{constructor(s,u){super(s.identifier,u),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.Emitter,this.L=[],this.M=new T.Emitter,this.N=new T.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(s){this.B=s.slice(),this.C.clear(),this.D.clear(),s.forEach((n,h)=>{this.C.set(h,n),this.D.set(n,h)});const u=[];for(let n=0;n<s.length;n++){const h=s[n];h.kind===O.QuickPickItemKind.Separator?u.push({type:"separator",label:h.label}):u.push({handle:n,label:h.label,description:h.description,detail:h.detail,picked:h.picked,alwaysShow:h.alwaysShow,buttons:h.buttons?.map((g,P)=>({...r(g),tooltip:g.tooltip,handle:P}))})}this.z({items:u})}get canSelectMany(){return this.E}set canSelectMany(s){this.E=s,this.z({canSelectMany:s})}get matchOnDescription(){return this.F}set matchOnDescription(s){this.F=s,this.z({matchOnDescription:s})}get matchOnDetail(){return this.G}set matchOnDetail(s){this.G=s,this.z({matchOnDetail:s})}get sortByLabel(){return this.H}set sortByLabel(s){this.H=s,this.z({sortByLabel:s})}get keepScrollPosition(){return this.I}set keepScrollPosition(s){this.I=s,this.z({keepScrollPosition:s})}get activeItems(){return this.J}set activeItems(s){this.J=s.filter(u=>this.D.has(u)),this.z({activeItems:this.J.map(u=>this.D.get(u))})}get selectedItems(){return this.L}set selectedItems(s){this.L=s.filter(u=>this.D.has(u)),this.z({selectedItems:this.L.map(u=>this.D.get(u))})}_fireDidChangeActive(s){const u=(0,C.coalesce)(s.map(n=>this.C.get(n)));this.J=u,this.K.fire(u)}_fireDidChangeSelection(s){const u=(0,C.coalesce)(s.map(n=>this.C.get(n)));this.L=u,this.M.fire(u)}_fireDidTriggerItemButton(s,u){const n=this.C.get(s);if(!n||!n.buttons||!n.buttons.length)return;const h=n.buttons[u];h&&this.N.fire({button:h,item:n})}}class o extends v{constructor(s,u){super(s.identifier,u),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(s){this.B=s,this.z({password:s})}get prompt(){return this.C}set prompt(s){this.C=s,this.z({prompt:s})}get valueSelection(){return this.D}set valueSelection(s){this.D=s,this.z({valueSelection:s})}get validationMessage(){return this.E}set validationMessage(s){this.E=s,s?typeof s=="string"?this.z({validationMessage:s,severity:N.default.Error}):this.z({validationMessage:s.message,severity:s.severity??N.default.Error}):this.z({validationMessage:void 0,severity:N.default.Ignore})}}return new l(f,t)}e.createExtHostQuickOpen=m});var Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)},Je=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i};define(ke[219],Ce([1,0,2,5,61,7,14,4,16,122,12,25,65,8,26]),function(ee,e,i,T,y,L,k,O,S,C,N,D,m,p,f){"use strict";var t,c;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function l(h){if(h)return typeof h.iconPath=="string"?i.URI.file(h.iconPath):i.URI.isUri(h.iconPath)||m.ThemeIcon.isThemeIcon(h.iconPath)?h.iconPath:void 0}function v(h,g){if(!h.iconPath&&!g.iconPath)return 0;if(h.iconPath){if(!g.iconPath)return 1}else return-1;const P=typeof h.iconPath=="string"?h.iconPath:i.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id,M=typeof g.iconPath=="string"?g.iconPath:i.URI.isUri(g.iconPath)?g.iconPath.fsPath:g.iconPath.id;return(0,C.comparePaths)(P,M)}function b(h,g){let P=0;if(h.strikeThrough!==g.strikeThrough)return h.strikeThrough?1:-1;if(h.faded!==g.faded)return h.faded?1:-1;if(h.tooltip!==g.tooltip)return(h.tooltip||"").localeCompare(g.tooltip||"");if(P=v(h,g),P!==0)return P;if(h.light&&g.light)P=v(h.light,g.light);else{if(h.light)return 1;if(g.light)return-1}if(P!==0)return P;if(h.dark&&g.dark)P=v(h.dark,g.dark);else{if(h.dark)return 1;if(g.dark)return-1}return P}function E(h,g){if(h.command!==g.command)return h.command<g.command?-1:1;if(h.title!==g.title)return h.title<g.title?-1:1;if(h.tooltip!==g.tooltip){if(h.tooltip!==void 0&&g.tooltip!==void 0)return h.tooltip<g.tooltip?-1:1;if(h.tooltip!==void 0)return 1;if(g.tooltip!==void 0)return-1}if(h.arguments===g.arguments)return 0;if(h.arguments)if(g.arguments){if(h.arguments.length!==g.arguments.length)return h.arguments.length-g.arguments.length}else return 1;else return-1;for(let P=0;P<h.arguments.length;P++){const M=h.arguments[P],j=g.arguments[P];if(M!==j)return M<j?-1:1}return 0}function w(h,g){let P=(0,C.comparePaths)(h.resourceUri.fsPath,g.resourceUri.fsPath,!0);if(P!==0)return P;if(h.command&&g.command)P=E(h.command,g.command);else{if(h.command)return 1;if(g.command)return-1}if(P!==0)return P;if(h.decorations&&g.decorations)P=b(h.decorations,g.decorations);else{if(h.decorations)return 1;if(g.decorations)return-1}return P}function r(h,g){for(let P=0;P<h.length;P++)if(h[P]!==g[P])return!1;return!0}function a(h,g){return h.command===g.command&&h.title===g.title&&h.tooltip===g.tooltip&&(h.arguments&&g.arguments?r(h.arguments,g.arguments):h.arguments===g.arguments)}function o(h,g){return(0,S.equals)(h,g,a)}class d{get value(){return this.d}set value(g){g=g??"",Oe(this,t,"f").$setInputBoxValue(this.l,g),this.m(g)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(g){Oe(this,t,"f").$setInputBoxPlaceholder(this.l,g),this.f=g}get validateInput(){return(0,f.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(g){if((0,f.checkProposedApiEnabled)(this.k,"scmValidation"),g&&typeof g!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=g,Oe(this,t,"f").$setValidationProviderIsEnabled(this.l,!!g)}get enabled(){return this.h}set enabled(g){g=!!g,this.h!==g&&(this.h=g,Oe(this,t,"f").$setInputBoxEnablement(this.l,g))}get visible(){return this.j}set visible(g){g=!!g,this.j!==g&&(this.j=g,Oe(this,t,"f").$setInputBoxVisibility(this.l,g))}constructor(g,P,M){this.k=g,this.l=M,t.set(this,void 0),this.d="",this.e=new T.Emitter,this.f="",this.h=!0,this.j=!0,Je(this,t,P,"f")}showValidationMessage(g,P){(0,f.checkProposedApiEnabled)(this.k,"scmValidation"),Oe(this,t,"f").$showValidationMessage(this.l,g,P)}$onInputBoxValueChange(g){this.m(g)}m(g){this.d=g,this.e.fire(g)}}e.ExtHostSCMInputBox=d,t=new WeakMap;class s{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(g){this.v=g,this.q.$updateGroupLabel(this.t,this.handle,g)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(g){this.p=g,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(g){this.f=[...g],this.k.fire()}constructor(g,P,M,j,Z){this.q=g,this.s=P,this.t=M,this.u=j,this.v=Z,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=s.d++}getResourceState(g){return this.g.get(g)}$executeResourceCommand(g,P){const M=this.h.get(g);return M?(0,k.asPromise)(()=>this.s.executeCommand(M.command,...M.arguments||[],P)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const g=[...this.f].sort(w),M=(0,S.sortedDiff)(this.o,g,w).map(G=>{const A=G.toInsert.map(R=>{const F=this.e++;this.g.set(F,R);const B=R.resourceUri;let z;if(R.command)if(R.command.command==="vscode.open"||R.command.command==="vscode.diff"){const le=new L.DisposableStore;z=this.s.converter.toInternal(R.command,le),this.j.set(F,le)}else this.h.set(F,R.command);const V=l(R.decorations),K=R.decorations&&l(R.decorations.light)||V,ie=R.decorations&&l(R.decorations.dark)||V,me=[K,ie],ue=R.decorations&&R.decorations.tooltip||"",oe=R.decorations&&!!R.decorations.strikeThrough,De=R.decorations&&!!R.decorations.faded,re=R.contextValue||"";return{rawResource:[F,B,me,ue,oe,De,re,z],handle:F}});return{start:G.start,deleteCount:G.deleteCount,toInsert:A}}),j=M.map(({start:G,deleteCount:A,toInsert:R})=>[G,A,R.map(F=>F.rawResource)]),Z=M.reverse();for(const{start:G,deleteCount:A,toInsert:R}of Z){const F=R.map(z=>z.handle),B=this.n.splice(G,A,...F);for(const z of B)this.g.delete(z),this.h.delete(z),this.j.get(z)?.dispose(),this.j.delete(z)}return this.o=g,j}dispose(){this.l=!0,this.m.fire()}}s.d=0;class u{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(g){this.g!==g&&(this.g=g,Oe(this,c,"f").$updateSourceControl(this.t,{count:g}))}get quickDiffProvider(){return this.h}set quickDiffProvider(g){this.h=g,Oe(this,c,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!g})}get commitTemplate(){return this.j}set commitTemplate(g){g!==this.j&&(this.j=g,Oe(this,c,"f").$updateSourceControl(this.t,{commitTemplate:g}))}get acceptInputCommand(){return this.l}set acceptInputCommand(g){this.k.value=new L.DisposableStore,this.l=g;const P=this.v.converter.toInternal(g,this.k.value);Oe(this,c,"f").$updateSourceControl(this.t,{acceptInputCommand:P})}get actionButton(){return(0,f.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(g){(0,f.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new L.DisposableStore,this.n=g;const P=g!==void 0?{command:this.v.converter.toInternal(g.command,this.m.value),secondaryCommands:g.secondaryCommands?.map(M=>M.map(j=>this.v.converter.toInternal(j,this.m.value))),description:g.description,enabled:g.enabled}:void 0;Oe(this,c,"f").$updateSourceControl(this.t,{actionButton:P??null})}get statusBarCommands(){return this.p}set statusBarCommands(g){if(this.p&&g&&o(this.p,g))return;this.o.value=new L.DisposableStore,this.p=g;const P=(g||[]).map(M=>this.v.converter.toInternal(M,this.o.value));Oe(this,c,"f").$updateSourceControl(this.t,{statusBarCommands:P})}get selected(){return this.q}constructor(g,P,M,j,Z,G){this.u=g,this.v=M,this.w=j,this.x=Z,this.y=G,c.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new L.MutableDisposable,this.l=void 0,this.m=new L.MutableDisposable,this.o=new L.MutableDisposable,this.p=void 0,this.q=!1,this.s=new T.Emitter,this.onDidChangeSelection=this.s.event,this.t=u.d++,this.z=new Map,this.A=new Set,Je(this,c,P,"f"),this.f=new d(g,Oe(this,c,"f"),this.t),Oe(this,c,"f").$registerSourceControl(this.t,j,Z,G)}createResourceGroup(g,P){const M=new s(Oe(this,c,"f"),this.v,this.t,g,P),j=T.Event.once(M.onDidDispose)(()=>this.z.delete(M));return this.z.set(M,j),this.eventuallyAddResourceGroups(),M}eventuallyAddResourceGroups(){const g=[],P=[];for(const[M,j]of this.z){j.dispose();const Z=M.onDidUpdateResourceStates(()=>{this.A.add(M),this.eventuallyUpdateResourceStates()});T.Event.once(M.onDidDispose)(()=>{this.A.delete(M),Z.dispose(),this.e.delete(M.handle),Oe(this,c,"f").$unregisterGroup(this.t,M.handle)}),g.push([M.handle,M.id,M.label,M.features]);const G=M._takeResourceStateSnapshot();G.length>0&&P.push([M.handle,G]),this.e.set(M.handle,M)}Oe(this,c,"f").$registerGroups(this.t,g,P),this.z.clear()}eventuallyUpdateResourceStates(){const g=[];this.A.forEach(P=>{const M=P._takeResourceStateSnapshot();M.length!==0&&g.push([P.handle,M])}),g.length>0&&Oe(this,c,"f").$spliceResourceStates(this.t,g),this.A.clear()}getResourceGroup(g){return this.e.get(g)}setSelectionState(g){this.q=g,this.s.fire(g)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(g=>g.dispose()),Oe(this,c,"f").$unregisterSourceControl(this.t)}}c=new WeakMap,u.d=0,qe([(0,y.debounce)(100)],u.prototype,"eventuallyAddResourceGroups",null),qe([(0,y.debounce)(100)],u.prototype,"eventuallyUpdateResourceStates",null);let n=class nn{get onDidChangeActiveProvider(){return this.j.event}constructor(g,P,M){this.l=P,this.m=M,this.g=new Map,this.h=new Map,this.j=new T.Emitter,this.e=g.getProxy(O.MainContext.MainThreadSCM),this.f=g.getProxy(O.MainContext.MainThreadTelemetry),P.registerArgumentProcessor({processArgument:j=>{if(j&&j.$mid===3){const Z=this.g.get(j.sourceControlHandle);if(!Z)return j;const G=Z.getResourceGroup(j.groupHandle);return G?G.getResourceState(j.handle):j}else if(j&&j.$mid===4){const Z=this.g.get(j.sourceControlHandle);return Z?Z.getResourceGroup(j.groupHandle):j}else if(j&&j.$mid===5){const Z=this.g.get(j.handle);return Z||j}return j}})}createSourceControl(g,P,M,j){this.m.trace("ExtHostSCM#createSourceControl",g.identifier.value,P,M,j),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:g.identifier.value});const Z=nn.d++,G=new u(g,this.e,this.l,P,M,j);this.g.set(Z,G);const A=this.h.get(D.ExtensionIdentifier.toKey(g.identifier))||[];return A.push(G),this.h.set(D.ExtensionIdentifier.toKey(g.identifier),A),G}getLastInputBox(g){this.m.trace("ExtHostSCM#getLastInputBox",g.identifier.value);const P=this.h.get(D.ExtensionIdentifier.toKey(g.identifier)),M=P&&P[P.length-1];return M&&M.inputBox}$provideOriginalResource(g,P,M){const j=i.URI.revive(P);this.m.trace("ExtHostSCM#$provideOriginalResource",g,j.toString());const Z=this.g.get(g);return!Z||!Z.quickDiffProvider||!Z.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,k.asPromise)(()=>Z.quickDiffProvider.provideOriginalResource(j,M)).then(G=>G||null)}$onInputBoxValueChange(g,P){this.m.trace("ExtHostSCM#$onInputBoxValueChange",g);const M=this.g.get(g);return M&&M.inputBox.$onInputBoxValueChange(P),Promise.resolve(void 0)}$executeResourceCommand(g,P,M,j){this.m.trace("ExtHostSCM#$executeResourceCommand",g,P,M);const Z=this.g.get(g);if(!Z)return Promise.resolve(void 0);const G=Z.getResourceGroup(P);return G?G.$executeResourceCommand(M,j):Promise.resolve(void 0)}$validateInput(g,P,M){this.m.trace("ExtHostSCM#$validateInput",g);const j=this.g.get(g);return!j||!j.inputBox.validateInput?Promise.resolve(void 0):(0,k.asPromise)(()=>j.inputBox.validateInput(P,M)).then(Z=>{if(!Z)return Promise.resolve(void 0);const G=p.MarkdownString.fromStrict(Z.message);return G?Promise.resolve([G,Z.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(g){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",g),g!==void 0&&this.g.get(g)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=g,Promise.resolve(void 0)}};n.d=0,n=qe([Ve(2,N.ILogService)],n),e.ExtHostSCM=n}),define(ke[76],Ce([1,0,4,5,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class L{constructor(O){this.b=new T.Emitter,this.onDidChangePassword=this.b.event,this.a=O.getProxy(i.MainContext.MainThreadSecretState)}async $onDidChangePassword(O){this.b.fire(O)}get(O,S){return this.a.$getPassword(O,S)}store(O,S,C){return this.a.$setPassword(O,S,C)}delete(O,S){return this.a.$deletePassword(O,S)}}e.ExtHostSecretState=L,e.IExtHostSecretState=(0,y.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(ke[220],Ce([1,0,6,4,137,7,8,9]),function(ee,e,i,T,y,L,k,O){"use strict";var S,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class N{constructor(f,t,c,l,v=i.StatusBarAlignment.Left,b){S.set(this,void 0),C.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.p=new L.DisposableStore,Je(this,S,f,"f"),Je(this,C,t,"f"),this.c=N.a++,this.e=c,this.f=l,this.g=v,this.h=this.t(b)}t(f){if(!!(0,O.isNumber)(f))return f===Number.POSITIVE_INFINITY?Number.MAX_VALUE:f===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:f}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.q?.fromApi}get accessibilityInformation(){return this.s}set text(f){this.k=f,this.u()}set name(f){this.m=f,this.u()}set tooltip(f){this.l=f,this.u()}set color(f){this.n=f,this.u()}set backgroundColor(f){f&&!N.b.has(f.id)&&(f=void 0),this.o=f,this.u()}set command(f){this.q?.fromApi!==f&&(this.p.clear(),typeof f=="string"?this.q={fromApi:f,internal:Oe(this,C,"f").toInternal({title:"",command:f},this.p)}:f?this.q={fromApi:f,internal:Oe(this,C,"f").toInternal(f,this.p)}:this.q=void 0,this.u())}set accessibilityInformation(f){this.s=f,this.u()}show(){this.j=!0,this.u()}hide(){clearTimeout(this.r),this.j=!1,Oe(this,S,"f").$dispose(this.c)}u(){this.i||!this.j||(clearTimeout(this.r),this.r=setTimeout(()=>{this.r=void 0;let f;this.e?this.f?f=`${this.e.identifier.value}.${this.f}`:f=this.e.identifier.value:f=this.f;let t;this.m?t=this.m:t=(0,y.localize)(0,null,this.e.displayName||this.e.name);let c=this.n;this.o&&(c=N.b.get(this.o.id));const l=k.MarkdownString.fromStrict(this.l);Oe(this,S,"f").$setEntry(this.c,f,t,this.k,l,this.q?.internal,c,this.o,this.g===i.StatusBarAlignment.Left,this.h,this.s)},0))}dispose(){this.hide(),this.i=!0}}e.ExtHostStatusBarEntry=N,S=new WeakMap,C=new WeakMap,N.a=0,N.b=new Map([["statusBarItem.errorBackground",new i.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new i.ThemeColor("statusBarItem.warningForeground")]]);class D{constructor(f){this.b=[],this.a=f.createStatusBarEntry(void 0,"status.extensionMessage",i.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,y.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(f){const t={message:f};return this.b.unshift(t),this.c(),new i.Disposable(()=>{const c=this.b.indexOf(t);c>=0&&(this.b.splice(c,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class m{constructor(f,t){this.a=f.getProxy(T.MainContext.MainThreadStatusBar),this.b=t,this.c=new D(this)}createStatusBarEntry(f,t,c,l){return new N(this.a,this.b,f,t,c,l)}setStatusBarMessage(f,t){const c=this.c.setMessage(f);let l;return typeof t=="number"?l=setTimeout(()=>c.dispose(),t):typeof t<"u"&&t.then(()=>c.dispose(),()=>c.dispose()),new i.Disposable(()=>{c.dispose(),clearTimeout(l)})}}e.ExtHostStatusBar=m}),define(ke[77],Ce([1,0,4,5,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class L{constructor(O,S){this.c=S,this.b=new T.Emitter,this.onDidChangeStorage=this.b.event,this.a=O.getProxy(i.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(O,S){this.a.$registerExtensionStorageKeysToSync(O,S)}async initializeExtensionStorage(O,S,C){const N=await this.a.$initializeExtensionStorage(O,S);let D;return N&&(D=this.d(O,S,N)),D||C}setValue(O,S,C){return this.a.$setValue(O,S,C)}$acceptValue(O,S,C){const N=this.d(O,S,C);N&&this.b.fire({shared:O,key:S,value:N})}d(O,S,C){try{return JSON.parse(C)}catch(N){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${S}, global: ${O}): ${N}`)}}}e.ExtHostStorage=L,e.IExtHostStorage=(0,y.createDecorator)("IExtHostStorage")}),define(ke[78],Ce([1,0,3,27,12,58,2]),function(ee,e,i,T,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,i.createDecorator)("IExtensionStoragePaths");let O=class{constructor(C,N,D){this.d=N,this.f=D,this.a=C.workspace??void 0,this.b=C.environment,this.whenReady=this.h().then(m=>this.c=m)}async g(C){return k.URI.joinPath(this.b.workspaceStorageHome,C)}async h(){if(!this.a)return Promise.resolve(void 0);const C=this.a.id,N=await this.g(C);try{return await this.f.value.stat(N),this.d.trace("[ExtHostStorage] storage dir already exists",N),N}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",N),await this.f.value.createDirectory(N),await this.f.value.writeFile(k.URI.joinPath(N,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:k.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),N}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(C){if(this.c)return k.URI.joinPath(this.c,C.identifier.value)}globalValue(C){return k.URI.joinPath(this.b.globalStorageHome,C.identifier.value.toLowerCase())}onWillDeactivateAll(){}};O=qe([Ve(0,T.IExtHostInitDataService),Ve(1,y.ILogService),Ve(2,L.IExtHostConsumerFileSystem)],O),e.ExtensionStoragePaths=O}),define(ke[59],Ce([1,0,5,4,3,2,15,7,6,138,11,176,20,34,162,65,9,14,8]),function(ee,e,i,T,y,L,k,O,S,C,N,D,m,p,f,t,c,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,y.createDecorator)("IExtHostTerminalService");class b{constructor(n,h,g,P){this.k=n,this._id=h,this.l=g,this.m=P,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(j=>this.f=j);const M=this;this.value={get name(){return M.m||""},get processId(){return M.b},get creationOptions(){return M.l},get exitStatus(){return M.h},get state(){return M.j},sendText(j,Z=!0){M.o(),M.k.$sendText(M._id,j,Z)},show(j){M.o(),M.k.$show(M._id,j)},hide(){M.o(),M.k.$hide(M._id)},dispose(){M.a||(M.a=!0,M.k.$dispose(M._id))},get dimensions(){if(!(M.d===void 0||M.g===void 0))return{columns:M.d,rows:M.g}}}}async create(n,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:n.name,shellPath:(0,c.withNullAsUndefined)(n.shellPath),shellArgs:(0,c.withNullAsUndefined)(n.shellArgs),cwd:(0,c.withNullAsUndefined)(n.cwd),env:(0,c.withNullAsUndefined)(n.env),icon:(0,c.withNullAsUndefined)(d(n.iconPath)),color:t.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,c.withNullAsUndefined)(n.message),strictEnv:(0,c.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,c.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,c.withNullAsUndefined)(h?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,c.withNullAsUndefined)(h?.useShellEnvironment),location:h?.location||this.n(n.location,h?.resolvedExtHostIdentifier),isTransient:(0,c.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,h,g,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:g,color:t.ThemeColor.isThemeColor(P)?P.id:void 0,location:this.n(n,h),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(n,h){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&h?{parentTerminal:h}:"viewColumn"in n?{viewColumn:v.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus}:void 0:n}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(n){this.m=n}setExitStatus(n,h){this.h=Object.freeze({code:n,reason:h})}setDimensions(n,h){return n===this.d&&h===this.g||n===0||h===0?!1:(this.d=n,this.g=h,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(n){this.f?(this.f(n),this.f=void 0):this.b.then(h=>{h!==n&&(this.b=Promise.resolve(n))})}}e.ExtHostTerminal=b;class E{get onProcessReady(){return this.b.event}constructor(n){this.g=n,this.id=0,this.shouldPersist=!1,this.a=new i.Emitter,this.onProcessData=this.a.event,this.b=new i.Emitter,this.d=new i.Emitter,this.onDidChangeProperty=this.d.event,this.f=new i.Emitter,this.onProcessExit=this.f.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,h){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${h}`)}async start(){}shutdown(){this.g.close()}input(n){this.g.handleInput?.(n)}resize(n,h){this.g.setDimensions?.({columns:n,rows:h})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this.g.onDidWrite(h=>this.a.fire(h)),this.g.onDidClose?.((h=void 0)=>{this.f.fire(h===void 0?void 0:h)}),this.g.onDidOverrideDimensions?.(h=>{h&&this.d.fire({type:"overrideDimensions",value:{cols:h.columns,rows:h.rows}})}),this.g.onDidChangeName?.(h=>{this.d.fire({type:"title",value:h})}),this.g.open(n||void 0),n&&this.g.setDimensions?.(n),this.b.fire({pid:-1,cwd:""})}}let w=1,r=class extends O.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(n=>n.value)}get onDidWriteTerminalData(){return this.I.event}constructor(n,h){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new i.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new i.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new i.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new i.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new i.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new i.Emitter,this.onDidChangeShell=this.J.event,this.a=h.getProxy(T.MainContext.MainThreadTerminalService),this.s=new f.TerminalDataBufferer(this.a.$sendProcessData),this.I=new i.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(n),this.B({dispose:()=>{for(const[g,P]of this.g)P.shutdown(!0)}})}getDefaultShell(n){return(n?this.n:this.m)?.path||""}getDefaultShellArgs(n){return(n?this.n:this.m)?.args||[]}createExtensionTerminal(n,h){const g=new b(this.a,(0,p.generateUuid)(),n,n.name),P=new E(n.pty);return g.createExtensionTerminal(n.location,this.L(n,h).resolvedExtHostIdentifier,d(n.iconPath),s(n.color)).then(M=>{const j=this.M(M,P);this.h[M]=j}),this.f.push(g),g.value}L(n,h){if(h=h||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const g=n.location.parentTerminal;if(g){const P=this.f.find(M=>M.value===g);P&&(h.resolvedExtHostIdentifier=P._id)}}else n.location&&typeof n.location!="object"?h.location=n.location:h.location&&typeof h.location=="object"&&"splitActiveTerminal"in h.location&&(h.location={splitActiveTerminal:!0});return h}attachPtyToTerminal(n,h){if(!this.O(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const P=new E(h),M=this.M(n,P);this.h[n]=M}async $acceptActiveTerminalChanged(n){const h=this.b;if(n===null){this.b=void 0,h!==this.b&&this.F.fire(this.b);return}const g=this.O(n);g&&(this.b=g,h!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(n,h){const g=this.O(n);g&&this.I.fire({terminal:g.value,data:h})}async $acceptTerminalDimensions(n,h,g){const P=this.O(n);P&&P.setDimensions(h,g)&&this.G.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptTerminalMaximumDimensions(n,h,g){this.g.get(n)?.resize(h,g)}async $acceptTerminalTitleChange(n,h){const g=this.O(n);g&&(g.name=h)}async $acceptTerminalClosed(n,h,g){const P=this.Q(this.f,n);if(P!==null){const M=this.f.splice(P,1)[0];M.setExitStatus(h,g),this.C.fire(M.value)}}$acceptTerminalOpened(n,h,g,P){if(h){const Z=this.Q(this.f,h);if(Z!==null){this.f[Z]._id=n,this.D.fire(this.terminals[Z]),this.f[Z].isOpen=!0;return}}const M={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:L.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},j=new b(this.a,n,M,g);this.f.push(j),this.D.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(n,h){this.O(n)?._setProcessId(h)}async $startExtensionTerminal(n,h){const g=this.O(n);if(!g)return{message:(0,C.localize)(0,null,n)};g.isOpen||await new Promise(M=>{const j=this.onDidOpenTerminal(async Z=>{Z===g.value&&(j.dispose(),M())})});const P=this.g.get(n);P?P.startSendingEvents(h):this.j[n]={initialDimensions:h}}M(n,h){const g=new O.DisposableStore;g.add(h.onProcessReady(M=>this.a.$sendProcessReady(n,M.pid,M.cwd))),g.add(h.onDidChangeProperty(M=>this.a.$sendProcessProperty(n,M))),this.s.startBuffering(n,h.onProcessData),g.add(h.onProcessExit(M=>this.N(n,M))),this.g.set(n,h);const P=this.j[n];return P&&h instanceof E&&(h.startSendingEvents(P.initialDimensions),delete this.j[n]),g}$acceptProcessAckDataEvent(n,h){this.g.get(n)?.acknowledgeDataEvent(h)}$acceptProcessInput(n,h){this.g.get(n)?.input(h)}$acceptTerminalInteraction(n){const h=this.O(n);h?.setInteractedWith()&&this.H.fire(h.value)}$acceptProcessResize(n,h,g){try{this.g.get(n)?.resize(h,g)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(n,h){this.g.get(n)?.shutdown(h)}$acceptProcessRequestInitialCwd(n){this.g.get(n)?.getInitialCwd().then(h=>this.a.$sendProcessProperty(n,{type:"initialCwd",value:h}))}$acceptProcessRequestCwd(n){this.g.get(n)?.getCwd().then(h=>this.a.$sendProcessProperty(n,{type:"cwd",value:h}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this.u.add(n),this.u.size===1&&this.a.$startLinkProvider(),new S.Disposable(()=>{this.u.delete(n),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(n,h,g){if(this.v.has(h))throw new Error(`Terminal profile provider "${h}" already registered`);return this.v.set(h,g),this.a.$registerProfileProvider(h,n.identifier.value),new S.Disposable(()=>{this.v.delete(h),this.a.$unregisterProfileProvider(h)})}registerTerminalQuickFixProvider(n,h,g){if(this.w.has(n))throw new Error(`Terminal quick fix provider "${n}" is already registered`);return this.w.set(n,g),this.a.$registerQuickFixProvider(n,h),new S.Disposable(()=>{this.w.delete(n),this.a.$unregisterQuickFixProvider(n)})}async $provideTerminalQuickFixes(n,h){const g=new m.CancellationTokenSource().token;if(g.isCancellationRequested)return;const P=this.w.get(n);if(!P)return;const M=await P.provideTerminalQuickFixes(h,g);if(M!==null)return M}async $createContributedProfileTerminal(n,h){const g=new m.CancellationTokenSource().token;let P=await this.v.get(n)?.provideTerminalProfile(g);if(!g.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,h);return}this.createTerminalFromOptions(P.options,h)}}async $provideLinks(n,h){const g=this.O(n);if(!g)return[];this.y.delete(n),this.z.get(n)?.dispose(!0);const M=new m.CancellationTokenSource;this.z.set(n,M);const j=[],Z={terminal:g.value,line:h},G=[];for(const F of this.u)G.push(l.Promises.withAsyncBody(async B=>{M.token.onCancellationRequested(()=>B({provider:F,links:[]}));const z=await F.provideTerminalLinks(Z,M.token)||[];M.token.isCancellationRequested||B({provider:F,links:z})}));const A=await Promise.all(G);if(M.token.isCancellationRequested)return[];const R=new Map;for(const F of A)F&&F.links.length>0&&j.push(...F.links.map(B=>{const z={id:w++,startIndex:B.startIndex,length:B.length,label:B.tooltip};return R.set(z.id,{provider:F.provider,link:B}),z}));return this.y.set(n,R),j}$activateLink(n,h){const g=this.y.get(n)?.get(h);!g||g.provider.handleTerminalLink(g.link)}N(n,h){this.s.stopBuffering(n),this.g.delete(n),delete this.j[n];const g=this.h[n];g&&(g.dispose(),delete this.h[n]),this.a.$sendProcessExit(n,h)}O(n){return this.P(this.f,n)}P(n,h){const g=this.Q(n,h);return g!==null?n[g]:null}Q(n,h){let g=null;return n.some((P,M)=>P._id===h?(g=M,!0):!1),g}getEnvironmentVariableCollection(n){let h=this.l.get(n.identifier.value);return h||(h=new a,this.S(n.identifier.value,h)),h}R(n,h){const g=(0,D.serializeEnvironmentVariableCollection)(h.map);this.a.$setEnvironmentVariableCollection(n,h.persistent,g.length===0?void 0:g)}$initEnvironmentVariableCollections(n){n.forEach(h=>{const g=h[0],P=new a(h[1]);this.S(g,P)})}$acceptDefaultProfile(n,h){const g=this.m;this.m=n,this.n=h,g?.path!==n.path&&this.J.fire(n.path)}S(n,h){this.l.set(n,h),h.onDidChangeCollection(()=>{this.R(n,h)})}};r=qe([Ve(1,k.IExtHostRpcService)],r),e.BaseExtHostTerminalService=r;class a{get persistent(){return this.a}set persistent(n){this.a=n,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(n){this.map=new Map,this.a=!0,this.b=new i.Emitter,this.map=new Map(n)}get size(){return this.map.size}replace(n,h){this.d(n,{value:h,type:S.EnvironmentVariableMutatorType.Replace})}append(n,h){this.d(n,{value:h,type:S.EnvironmentVariableMutatorType.Append})}prepend(n,h){this.d(n,{value:h,type:S.EnvironmentVariableMutatorType.Prepend})}d(n,h){const g=this.map.get(n);(!g||g.value!==h.value||g.type!==h.type)&&(this.map.set(n,h),this.b.fire())}get(n){return this.map.get(n)}forEach(n,h){this.map.forEach((g,P)=>n.call(h,P,g,this))}[Symbol.iterator](){return this.map.entries()}delete(n){this.map.delete(n),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let o=class extends r{constructor(n){super(!1,n)}createTerminal(n,h,g){throw new N.NotSupportedError}createTerminalFromOptions(n,h){throw new N.NotSupportedError}};o=qe([Ve(0,k.IExtHostRpcService)],o),e.WorkerExtHostTerminalService=o;function d(u){if(!(!u||typeof u=="string"))return"id"in u?{id:u.id,color:u.color}:u}function s(u){return t.ThemeColor.isThemeColor(u)?u:void 0}});var Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)},Je=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i};define(ke[221],Ce([1,0,16,14,24,20,5,185,222,7,23,9,34,4,15,99,8,6,42,68,54]),function(ee,e,i,T,y,L,k,O,S,C,N,D,m,p,f,t,c,l,v,b,E){"use strict";var w,r;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let a=class{constructor(R,F,B){this.j=B,this.c=new k.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=R.getProxy(p.MainContext.MainThreadTesting),this.h=new j(this.f),this.g=new u(this.f),F.registerArgumentProcessor({processArgument:z=>{if(z?.$mid!==15)return z;const V=z,K=V.tests[V.tests.length-1].item.extId;return this.d.get(v.TestId.root(K))?.collection.tree.get(K)?.actual??(0,t.toItemFromContext)(z)}})}createTestController(R,F,B){if(this.d.has(R))throw new Error(`Attempt to insert a duplicate controller with ID "${R}"`);const z=new C.DisposableStore,V=z.add(new t.ExtHostTestItemCollection(R,F,this.j));V.root.label=F;const K=new Map,ie=this.f,me={items:V.root.children,get label(){return F},set label(oe){F=oe,V.root.label=oe,ie.$updateController(R,{label:F})},get refreshHandler(){return B},set refreshHandler(oe){B=oe,ie.$updateController(R,{canRefresh:!!oe})},get id(){return R},createRunProfile:(oe,De,re,Q,le)=>{let Ee=(0,S.hash)(oe);for(;K.has(Ee);)Ee++;return new Z(this.f,K,R,Ee,oe,De,re,Q,le)},createTestItem(oe,De,re){return new t.TestItemImpl(R,oe,De,re)},createTestRun:(oe,De,re=!0)=>this.g.createTestRun(R,V,oe,De,re),set resolveHandler(oe){V.resolveHandler=oe},get resolveHandler(){return V.resolveHandler},dispose:()=>{z.dispose()}};ie.$registerTestController(R,F,!!B),z.add((0,C.toDisposable)(()=>ie.$unregisterTestController(R)));const ue={controller:me,collection:V,profiles:K};return this.d.set(R,ue),z.add((0,C.toDisposable)(()=>this.d.delete(R))),z.add(V.onDidGenerateDiff(oe=>ie.$publishDiff(R,oe.map(E.TestsDiffOp.serialize)))),me}createTestObserver(){return this.h.checkout()}async runTests(R,F=L.CancellationToken.None){const B=n(R);if(!B)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const z=this.d.get(B.controllerId);if(!z)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:R.include?.map(V=>v.TestId.fromExtHostTestItem(V,z.collection.root.id).toString())??[z.collection.root.id],profileGroup:G[B.kind],profileId:B.profileId,controllerId:B.controllerId}],exclude:R.exclude?.map(V=>V.id)},F)}$syncTests(){for(const{collection:R}of this.d.values())R.flushDiff();return Promise.resolve()}$provideFileCoverage(R,F,B){return(0,i.mapFind)(this.g.trackers,V=>V.id===R?V.getCoverage(F):void 0)?.provideFileCoverage(B)??Promise.resolve([])}$resolveFileCoverage(R,F,B,z){return(0,i.mapFind)(this.g.trackers,K=>K.id===R?K.getCoverage(F):void 0)?.resolveFileCoverage(B,z)??Promise.resolve([])}$configureRunProfile(R,F){this.d.get(R)?.profiles.get(F)?.configureHandler?.()}async $refreshTests(R,F){await this.d.get(R)?.controller.refreshHandler?.(F)}$publishTestResults(R){this.results=Object.freeze(R.map(F=>(0,N.deepFreeze)(c.TestResults.to(F))).concat(this.results).sort((F,B)=>B.completedAt-F.completedAt).slice(0,32)),this.c.fire()}async $expandTest(R,F){const B=this.d.get(v.TestId.fromString(R).controllerId)?.collection;B&&(await B.expand(R,F<0?1/0:F),B.flushDiff())}$acceptDiff(R){this.h.applyDiff(R.map(E.TestsDiffOp.deserialize))}async $runControllerTests(R,F){return Promise.all(R.map(B=>this.runControllerTestRequest(B,F)))}async runControllerTestRequest(R,F){const B=this.d.get(R.controllerId);if(!B)return{};const{collection:z,profiles:V}=B,K=V.get(R.profileId);if(!K)return{};const ie=R.testIds.map(De=>z.tree.get(De)).filter(D.isDefined),me=R.excludeExtIds.map(De=>B.collection.tree.get(De)).filter(D.isDefined).filter(De=>ie.some(re=>re.fullId.compare(De.fullId)===2));if(!ie.length)return{};const ue=new l.TestRunRequest(ie.some(De=>De.actual instanceof t.TestItemRootImpl)?void 0:ie.map(De=>De.actual),me.map(De=>De.actual),K),oe=this.g.prepareForMainThreadTestRun(ue,h.fromInternal(R,B.collection),F);try{return await K.runHandler(ue,F),{}}catch(De){return{error:String(De)}}finally{oe.hasRunningTasks&&!F.isCancellationRequested&&await k.Event.toPromise(oe.onEnd),oe.dispose()}}$cancelExtensionTestRun(R){R===void 0?this.g.cancelAllRuns():this.g.cancelRunById(R)}};a=qe([Ve(0,f.IExtHostRpcService)],a),e.ExtHostTesting=a;const o=1e4;var d;(function(A){A[A.Running=0]="Running",A[A.Cancelling=1]="Cancelling",A[A.Ended=2]="Ended"})(d||(d={}));class s extends C.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(R,F,B){super(),this.k=R,this.l=F,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new k.Emitter),this.onEnd=this.j.event,this.h=this.B(new L.CancellationTokenSource(B));const z=this.B(new T.RunOnceScheduler(()=>this.m(),o));this.B(this.h.token.onCancellationRequested(()=>z.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(R){return this.f.get(R)?.coverage}createRun(R){const F=this.k.id,B=this.k.controllerId,z=(0,m.generateUuid)(),V=new g(this.l,F,z),K=oe=>(De,...re)=>{if(me){console.warn(`Setting the state of test "${De.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(De)||(this.s(De),oe(De,...re))},ie=(oe,De)=>{const re=De instanceof Array?De.map(c.TestMessage.from):[c.TestMessage.from(De)];if(oe.uri&&oe.range){const Q={range:c.Range.from(oe.range),uri:oe.uri};for(const le of re)le.location=le.location||Q}this.l.$appendTestMessagesInRun(F,z,v.TestId.fromExtHostTestItem(oe,B).toString(),re)};let me=!1;const ue={isPersisted:this.k.isPersisted,token:this.h.token,name:R,get coverageProvider(){return V.coverageProvider},set coverageProvider(oe){V.coverageProvider=oe},enqueued:K(oe=>{this.l.$updateTestStateInRun(F,z,v.TestId.fromExtHostTestItem(oe,B).toString(),1)}),skipped:K(oe=>{this.l.$updateTestStateInRun(F,z,v.TestId.fromExtHostTestItem(oe,B).toString(),5)}),started:K(oe=>{this.l.$updateTestStateInRun(F,z,v.TestId.fromExtHostTestItem(oe,B).toString(),2)}),errored:K((oe,De,re)=>{ie(oe,De),this.l.$updateTestStateInRun(F,z,v.TestId.fromExtHostTestItem(oe,B).toString(),6,re)}),failed:K((oe,De,re)=>{ie(oe,De),this.l.$updateTestStateInRun(F,z,v.TestId.fromExtHostTestItem(oe,B).toString(),4,re)}),passed:K((oe,De)=>{this.l.$updateTestStateInRun(F,z,v.TestId.fromExtHostTestItem(oe,this.k.controllerId).toString(),3,De)}),appendOutput:(oe,De,re)=>{me||(re&&(this.k.isIncluded(re)?this.s(re):re=void 0),this.l.$appendOutputToRun(F,z,y.VSBuffer.fromString(oe),De&&c.location.from(De),re&&v.TestId.fromExtHostTestItem(re,B).toString()))},end:()=>{me||(me=!0,this.l.$finishedTestRunTask(F,z),this.f.delete(z),this.f.size||this.p())}};return this.f.set(z,{run:ue,coverage:V}),this.l.$startedTestRunTask(F,{id:z,name:R,running:!0}),ue}m(){for(const{run:R}of this.f.values())R.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(R){if(!(R instanceof t.TestItemImpl))throw new b.InvalidTestItemError(R.id);if(this.g.has(v.TestId.fromExtHostTestItem(R,this.k.controllerId).toString()))return;const F=[],B=this.k.colllection.root;for(;;){const z=c.TestItem.from(R);if(F.unshift(z),this.g.has(z.extId)||(this.g.add(z.extId),R===B))break;R=R.parent||B}this.l.$addTestsToRun(this.k.controllerId,this.k.id,F)}}class u{get trackers(){return this.c.values()}constructor(R){this.d=R,this.c=new Map}prepareForMainThreadTestRun(R,F,B){return this.f(R,F,B)}cancelRunById(R){for(const F of this.c.values())if(F.id===R){F.cancel();return}}cancelAllRuns(){for(const R of this.c.values())R.cancel()}createTestRun(R,F,B,z,V){const K=this.c.get(B);if(K)return K.createRun(z);const ie=h.fromPublic(R,F,B,V),me=n(B);this.d.$startedExtensionTestRun({controllerId:R,profile:me&&{group:G[me.kind],id:me.profileId},exclude:B.exclude?.map(oe=>v.TestId.fromExtHostTestItem(oe,F.root.id).toString())??[],id:ie.id,include:B.include?.map(oe=>v.TestId.fromExtHostTestItem(oe,F.root.id).toString())??[F.root.id],persist:V});const ue=this.f(B,ie);return ue.onEnd(()=>{this.d.$finishedExtensionTestRun(ie.id),ue.dispose()}),ue.createRun(z)}f(R,F,B){const z=new s(F,this.d,B);return this.c.set(R,z),z.onEnd(()=>this.c.delete(R)),z}}e.TestRunCoordinator=u;const n=A=>{if(!!A.profile){if(!(A.profile instanceof Z))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return A.profile}};class h{static fromPublic(R,F,B,z){return new h(R,(0,m.generateUuid)(),B.include?.map(V=>v.TestId.fromExtHostTestItem(V,R).toString())??[R],B.exclude?.map(V=>v.TestId.fromExtHostTestItem(V,R).toString())??[],z,F)}static fromInternal(R,F){return new h(R.controllerId,R.runId,R.testIds,R.excludeExtIds,!0,F)}constructor(R,F,B,z,V,K){this.controllerId=R,this.id=F,this.isPersisted=V,this.colllection=K,this.c=B.map(ie=>ie+"\0"),this.d=z.map(ie=>ie+"\0")}isIncluded(R){const F=v.TestId.fromExtHostTestItem(R,this.controllerId).toString()+"\0";for(const B of this.d)if(F===B||F.startsWith(B))return!1;for(const B of this.c)if(F===B||F.startsWith(B))return!0;return!1}}e.TestRunDto=h;class g{set coverageProvider(R){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!R||(this.c=R,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(R,F,B){this.f=R,this.g=F,this.h=B}async provideFileCoverage(R){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(R))());try{return(await this.d)?.map(c.TestCoverage.fromFile)??[]}catch(F){throw this.d=void 0,F}}async resolveFileCoverage(R,F){const B=await this.d;let z=B?.[R];return!this.c||!B||!z?[]:(z.detailedCoverage||(z=B[R]=await this.c.resolveFileCoverage?.(z,F)??z),z.detailedCoverage?.map(c.TestCoverage.fromDetailed)??[])}}class P{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(R){this.h=R,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(R){this.c.add(R)}update(R){Object.assign(R.revived,c.TestItem.toPlain(R.item)),this.c.has(R)||this.d.add(R)}remove(R){if(this.c.has(R)){this.c.delete(R);return}this.d.delete(R);const F=v.TestId.parentId(R.item.extId);if(F&&this.g.has(F.toString())){this.g.add(R.item.extId);return}this.f.add(R)}getChangeEvent(){const{c:R,d:F,f:B}=this;return{get added(){return[...R].map(z=>z.revived)},get updated(){return[...F].map(z=>z.revived)},get removed(){return[...B].map(z=>z.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class M extends E.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new k.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(R){return this.d.get(R)}getMirroredTestDataByReference(R){return this.d.get(R.id)}p(R,F){return{...R,revived:c.TestItem.toPlain(R.item),depth:F?F.depth+1:0,children:new Set}}o(){return new P(this.q)}}e.MirroredTestCollection=M;class j{constructor(R){this.d=R}checkout(){this.c||(this.c=this.f());const R=this.c;return R.observers++,{onDidChangeTest:R.tests.onDidChangeTests,get tests(){return[...R.tests.rootTests].map(F=>F.revived)},dispose:(0,O.once)(()=>{--R.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(R){return this.c?.tests.getMirroredTestDataByReference(R)}applyDiff(R){this.c?.tests.apply(R)}f(){const R=new M;return this.d.$subscribeToDiffs(),{observers:0,tests:R}}}class Z{get label(){return this.d}set label(R){R!==this.d&&(this.d=R,Oe(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:R}))}get isDefault(){return this.f}set isDefault(R){R!==this.f&&(this.f=R,Oe(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:R}))}get tag(){return this._tag}set tag(R){R?.id!==this._tag?.id&&(this._tag=R,Oe(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:R?c.TestTag.namespace(this.controllerId,R.id):null}))}get configureHandler(){return this.c}set configureHandler(R){R!==this.c&&(this.c=R,Oe(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!R}))}constructor(R,F,B,z,V,K,ie,me=!1,ue=void 0){this.controllerId=B,this.profileId=z,this.d=V,this.kind=K,this.runHandler=ie,this.f=me,this._tag=ue,w.set(this,void 0),r.set(this,void 0),Je(this,w,R,"f"),Je(this,r,F,"f"),F.set(z,this);const oe=G[K];if(typeof oe!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);Oe(this,w,"f").$publishTestRunProfile({profileId:z,controllerId:B,tag:ue?c.TestTag.namespace(this.controllerId,ue.id):null,label:V,group:oe,isDefault:me,hasConfigurationHandler:!1})}dispose(){Oe(this,r,"f")?.delete(this.profileId)&&(Je(this,r,void 0,"f"),Oe(this,w,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=Z,w=new WeakMap,r=new WeakMap;const G={[l.TestRunProfileKind.Coverage]:8,[l.TestRunProfileKind.Debug]:4,[l.TestRunProfileKind.Run]:2}}),define(ke[223],Ce([1,0,16,5,4,100,8,6]),function(ee,e,i,T,y,L,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(N,D){this.i=D,this.a=new T.Emitter,this.b=new T.Emitter,this.c=new T.Emitter,this.d=new T.Emitter,this.f=new T.Emitter,this.g=new T.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=N.getProxy(y.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(m=>this.g.fire(m)),this.i.onDidChangeActiveTextEditor(m=>this.f.fire(m))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(N){const D=this.i.allEditors();return N?D:D.map(m=>m.value)}async showTextDocument(N,D,m){let p;typeof D=="number"?p={position:k.ViewColumn.from(D),preserveFocus:m}:typeof D=="object"?p={position:k.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selection:typeof D.selection=="object"?k.Range.from(D.selection):void 0,pinned:typeof D.preview=="boolean"?!D.preview:void 0}:p={preserveFocus:!1};const f=await this.h.$tryShowTextDocument(N.uri,p),t=f&&this.i.getEditor(f);if(t)return t.value;throw f?new Error(`Could NOT open editor for "${N.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${N.uri.toString()}".`)}createTextEditorDecorationType(N,D){return new L.TextEditorDecorationType(this.h,N,D).value}$acceptEditorPropertiesChanged(N,D){const m=this.i.getEditor(N);if(!m)throw new Error("unknown text editor");if(D.options&&m._acceptOptions(D.options),D.selections){const p=D.selections.selections.map(k.Selection.to);m._acceptSelections(p)}if(D.visibleRanges){const p=i.coalesce(D.visibleRanges.map(k.Range.to));m._acceptVisibleRanges(p)}if(D.options&&this.b.fire({textEditor:m.value,options:{...D.options,lineNumbers:k.TextEditorLineNumbersStyle.to(D.options.lineNumbers)}}),D.selections){const p=O.TextEditorSelectionChangeKind.fromValue(D.selections.source),f=D.selections.selections.map(k.Selection.to);this.a.fire({textEditor:m.value,selections:f,kind:p})}if(D.visibleRanges){const p=i.coalesce(D.visibleRanges.map(k.Range.to));this.c.fire({textEditor:m.value,visibleRanges:p})}}$acceptEditorPositionData(N){for(const D in N){const m=this.i.getEditor(D);if(!m)throw new Error("Unknown text editor");const p=k.ViewColumn.to(N[D]);m.value.viewColumn!==p&&(m._acceptViewColumn(p),this.d.fire({textEditor:m.value,viewColumn:p}))}}getDiffInformation(N){return Promise.resolve(this.h.$getDiffInformation(N))}}e.ExtHostEditors=S}),define(ke[224],Ce([1,0,2,3,4,7,6,8,25,9]),function(ee,e,i,T,y,L,k,O,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,T.createDecorator)("IExtHostTimeline");class N{constructor(p,f){this.b=new Map,this.c=new Map,this.a=p.getProxy(y.MainContext.MainThreadTimeline),f.registerArgumentProcessor({processArgument:(t,c)=>{if(t&&t.$mid===12)if(this.b.get(t.source)&&S.ExtensionIdentifier.equals(c,this.b.get(t.source)?.extension)){const l=t.uri===void 0?void 0:i.URI.revive(t.uri);return this.c.get(t.source)?.get(D(l))?.get(t.handle)}else return;return t}})}async $getTimeline(p,f,t,c){return this.b.get(p)?.provider.provideTimeline(i.URI.revive(f),t,c)}registerTimelineProvider(p,f,t,c){const l=new L.DisposableStore,v=this.d(f.id,c,l).bind(this);let b;f.onDidChange&&(b=f.onDidChange(w=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...w,id:f.id}),this));const E=this.c;return this.f({...f,scheme:p,onDidChange:void 0,async provideTimeline(w,r,a){r?.resetCache&&(l.clear(),E.get(f.id)?.clear());const o=await f.provideTimeline(w,r,a);if(o==null)return;const d=v(w,r);return{...o,source:f.id,items:o.items.map(d)}},dispose(){for(const w of E.values())w.get(f.id)?.clear();b?.dispose(),l.dispose()}},t)}d(p,f,t){return(c,l)=>{let v;if(l?.cacheResults){let b=this.c.get(p);b===void 0&&(b=new Map,this.c.set(p,b));const E=D(c);v=b.get(E),v===void 0&&(v=new Map,b.set(E,v))}return b=>{const{iconPath:E,...w}=b,r=`${p}|${b.id??b.timestamp}`;v?.set(r,b);let a,o,d;b.iconPath&&(E instanceof k.ThemeIcon?d={id:E.id,color:E.color}:i.URI.isUri(E)?(a=E,o=E):{light:a,dark:o}=E);let s;return k.MarkdownString.isMarkdownString(w.tooltip)?s=O.MarkdownString.from(w.tooltip):(0,C.isString)(w.tooltip)?s=w.tooltip:k.MarkdownString.isMarkdownString(w.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=O.MarkdownString.from(w.detail)):(0,C.isString)(w.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=w.detail),{...w,id:w.id??void 0,handle:r,source:p,command:b.command?f.toInternal(b.command,t):void 0,icon:a,iconDark:o,themeIcon:d,tooltip:s,accessibilityInformation:b.accessibilityInformation}}}}f(p,f){if(this.b.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this.a.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this.b.set(p.id,{provider:p,extension:f}),(0,L.toDisposable)(()=>{for(const c of this.c.values())c.get(p.id)?.clear();this.b.delete(p.id),this.a.$unregisterTimelineProvider(p.id),p.dispose()})}}e.ExtHostTimeline=N;function D(m){return m?.toString()}}),define(ke[225],Ce([1,0,7,13,2,4]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class k{constructor(S){this.c=new Map,this.b=S.getProxy(L.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,C,N,D){if(this.c.has(C))throw new Error(`Opener with id '${C}' already registered`);const m=D.schemes.find(p=>!k.a.has(p));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this.c.set(C,N),this.b.$registerUriOpener(C,D.schemes,S,D.label),(0,i.toDisposable)(()=>{this.c.delete(C),this.b.$unregisterUriOpener(C)})}async $canOpenUri(S,C,N){const D=this.c.get(S);if(!D)throw new Error(`Unknown opener with id: ${S}`);const m=y.URI.revive(C);return D.canOpenExternalUri(m,N)}async $openUri(S,C,N){const D=this.c.get(S);if(!D)throw new Error(`Unknown opener id: '${S}'`);return D.openExternalUri(y.URI.revive(C.resolvedUri),{sourceUri:y.URI.revive(C.sourceUri)},N)}}e.ExtHostUriOpeners=k,k.a=new Set([T.Schemas.http,T.Schemas.https])}),define(ke[226],Ce([1,0,4,2,7,11,25]),function(ee,e,i,T,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class O{constructor(C){this.c=new Set,this.d=new Map,this.b=C.getProxy(i.MainContext.MainThreadUrls)}registerUriHandler(C,N){if(this.c.has(k.ExtensionIdentifier.toKey(C)))throw new Error(`Protocol handler already registered for extension ${C}`);const D=O.a++;return this.c.add(k.ExtensionIdentifier.toKey(C)),this.d.set(D,N),this.b.$registerUriHandler(D,C),(0,y.toDisposable)(()=>{this.c.delete(k.ExtensionIdentifier.toKey(C)),this.d.delete(D),this.b.$unregisterUriHandler(D)})}$handleExternalUri(C,N){const D=this.d.get(C);if(!D)return Promise.resolve(void 0);try{D.handleUri(T.URI.revive(N))}catch(m){(0,L.onUnexpectedError)(m)}return Promise.resolve(void 0)}async createAppUri(C){return T.URI.revive(await this.b.$createAppUri(C))}}e.ExtHostUrls=O,O.a=0});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(ke[60],Ce([1,0,5,13,23,2,150,170,69,4]),function(ee,e,i,T,y,L,k,O,S,C){"use strict";var N,D,m,p,f,t,c,l,v,b,E,w,r;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class a{constructor(M,j,Z,G,A,R,F){N.set(this,void 0),D.set(this,void 0),m.set(this,void 0),p.set(this,void 0),f.set(this,void 0),t.set(this,void 0),c.set(this,""),l.set(this,void 0),v.set(this,!1),b.set(this,!1),E.set(this,void 0),w.set(this,void 0),this._onMessageEmitter=new i.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,r.set(this,new i.Emitter),this._onDidDispose=Oe(this,r,"f").event,Je(this,N,M,"f"),Je(this,D,j,"f"),Je(this,l,Z,"f"),Je(this,p,G,"f"),Je(this,f,A,"f"),Je(this,t,R,"f"),Je(this,E,o(R),"f"),Je(this,w,d(R),"f"),Je(this,m,F,"f")}dispose(){Je(this,v,!0,"f"),Oe(this,r,"f").fire(),Oe(this,r,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(M){return Je(this,b,!0,"f"),(0,S.asWebviewUri)(M,Oe(this,p,"f"))}get cspSource(){const M=Oe(this,t,"f").extensionLocation;if(M.scheme===T.Schemas.https||M.scheme===T.Schemas.http){let j=M.toString();return j.endsWith("/")||(j+="/"),j+" "+S.webviewGenericCspSource}return S.webviewGenericCspSource}get html(){return this.a(),Oe(this,c,"f")}set html(M){this.a(),Oe(this,c,"f")!==M&&(Je(this,c,M,"f"),Oe(this,w,"f")&&!Oe(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(M)&&(Je(this,b,!0,"f"),Oe(this,m,"f").report("Webview vscode-resource: uris",Oe(this,t,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,D,"f").$setHtml(Oe(this,N,"f"),this.b(M)))}get options(){return this.a(),Oe(this,l,"f")}set options(M){this.a(),y.equals(Oe(this,l,"f"),M)||Oe(this,D,"f").$setOptions(Oe(this,N,"f"),n(Oe(this,t,"f"),Oe(this,f,"f"),M)),Je(this,l,M,"f")}async postMessage(M){if(Oe(this,v,"f"))return!1;const j=(0,O.serializeWebviewMessage)(M,{serializeBuffersForPostMessage:Oe(this,E,"f")});return Oe(this,D,"f").$postMessage(Oe(this,N,"f"),j.message,...j.buffers)}a(){if(Oe(this,v,"f"))throw new Error("Webview is disposed")}b(M){if(!Oe(this,w,"f"))return M;const j=Oe(this,t,"f").extensionLocation?.scheme===T.Schemas.vscodeRemote,Z=Oe(this,t,"f").extensionLocation.scheme===T.Schemas.vscodeRemote?Oe(this,t,"f").extensionLocation.authority:void 0;return M.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(G,A,R,F,B,z)=>{const V=L.URI.from({scheme:F||"file",path:decodeURIComponent(B)}),K=(0,S.asWebviewUri)(V,{isRemote:j,authority:Z}).toString();return`${A}${K}${z}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(G,A,R,F,B,z)=>{const V=L.URI.from({scheme:F||"file",path:decodeURIComponent(B)}),K=(0,S.asWebviewUri)(V,{isRemote:j,authority:Z}).toString();return`${A}${K}${z}`})}}e.ExtHostWebview=a,N=new WeakMap,D=new WeakMap,m=new WeakMap,p=new WeakMap,f=new WeakMap,t=new WeakMap,c=new WeakMap,l=new WeakMap,v=new WeakMap,b=new WeakMap,E=new WeakMap,w=new WeakMap,r=new WeakMap;function o(P){try{const M=(0,k.normalizeVersion)((0,k.parseVersion)(P.engines.vscode));return!!M&&M.majorBase>=1&&M.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=o;function d(P){try{const M=(0,k.normalizeVersion)((0,k.parseVersion)(P.engines.vscode));return M?M.majorBase<1||M.majorBase===1&&M.minorBase<60:!1}catch{return!1}}class s{constructor(M,j,Z,G,A){this.c=j,this.d=Z,this.e=G,this.f=A,this.b=new Map,this.a=M.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(M,j,Z){const G=this.g(M);if(G){const{message:A}=(0,O.deserializeWebviewMessage)(j,Z.value);G._onMessageEmitter.fire(A)}}$onMissingCsp(M,j){this.e.warn(`${j} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(M,j,Z){const G=new a(M,this.a,h(j),this.c,this.d,Z,this.f);return this.b.set(M,G),G._onDidDispose(()=>{this.b.delete(M)}),G}deleteWebview(M){this.b.delete(M)}g(M){return this.b.get(M)}}e.ExtHostWebviews=s;function u(P){return{id:P.identifier,location:P.extensionLocation}}e.toExtensionData=u;function n(P,M,j){return{enableCommandUris:j.enableCommandUris,enableScripts:j.enableScripts,enableForms:j.enableForms,portMapping:j.portMapping,localResourceRoots:j.localResourceRoots||g(P,M)}}e.serializeWebviewOptions=n;function h(P){return{enableCommandUris:P.enableCommandUris,enableScripts:P.enableScripts,enableForms:P.enableForms,portMapping:P.portMapping,localResourceRoots:P.localResourceRoots?.map(M=>L.URI.from(M))}}function g(P,M){return[...(M?.getWorkspaceFolders()||[]).map(j=>j.uri),P.extensionLocation]}}),define(ke[227],Ce([1,0,20,222,7,13,22,2,8,60,52,4,6]),function(ee,e,i,T,y,L,k,O,S,C,N,D,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class p{constructor(a,o){this.document=a,this.b=o,this.a=1,this.c=new N.Cache("custom documents")}addEdit(a){return this.c.add([a])}async undo(a,o){await this.f(a).undo(),o||this.disposeBackup()}async redo(a,o){await this.f(a).redo(),o||this.disposeBackup()}disposeEdits(a){for(const o of a)this.c.delete(o)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const a=w(this.document.uri)+this.a++;return(0,k.joinPath)(this.b,a)}updateBackup(a){this.d?.delete(),this.d=a}disposeBackup(){this.d?.delete(),this.d=void 0}f(a){const o=this.c.get(a,0);if(!o)throw new Error("No edit found");return o}}class f{constructor(){this.a=new Map}get(a,o){return this.a.get(this.b(a,o))}add(a,o,d){const s=this.b(a,o.uri);if(this.a.has(s))throw new Error(`Document already exists for viewType:${a} resource:${o.uri}`);const u=new p(o,d);return this.a.set(s,u),u}delete(a,o){const d=this.b(a,o.uri);this.a.delete(d)}b(a,o){return`${a}@@@${o}`}}var t;(function(r){r[r.Text=0]="Text",r[r.Custom=1]="Custom"})(t||(t={}));class c{constructor(){this.a=new Map}addTextProvider(a,o,d){return this.b(0,a,o,d)}addCustomProvider(a,o,d){return this.b(1,a,o,d)}get(a){return this.a.get(a)}b(a,o,d,s){if(this.a.has(o))throw new Error(`Provider for viewType:${o} already registered`);return this.a.set(o,{type:a,extension:d,provider:s}),new m.Disposable(()=>this.a.delete(o))}}class l{constructor(a,o,d,s,u){this.d=o,this.f=d,this.g=s,this.h=u,this.b=new c,this.c=new f,this.a=a.getProxy(D.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(a,o,d,s){const u=new y.DisposableStore;return b(d)?(u.add(this.b.addTextProvider(o,a,d)),this.a.$registerTextEditorProvider((0,C.toExtensionData)(a),o,s.webviewOptions||{},{supportsMove:!!d.moveCustomTextEditor},(0,C.shouldSerializeBuffersForPostMessage)(a))):(u.add(this.b.addCustomProvider(o,a,d)),v(d)&&u.add(d.onDidChangeCustomDocument(n=>{const h=this.i(o,n.document.uri);if(E(n)){const g=h.addEdit(n);this.a.$onDidEdit(n.document.uri,o,g,n.label)}else this.a.$onContentChange(n.document.uri,o)})),this.a.$registerCustomEditorProvider((0,C.toExtensionData)(a),o,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,C.shouldSerializeBuffersForPostMessage)(a))),m.Disposable.from(u,new m.Disposable(()=>{this.a.$unregisterEditorProvider(o)}))}async $createCustomDocument(a,o,d,s,u){const n=this.b.get(o);if(!n)throw new Error(`No provider found for '${o}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${o}'`);const h=O.URI.revive(a),g=await n.provider.openCustomDocument(h,{backupId:d,untitledDocumentData:s?.buffer},u);let P;return v(n.provider)&&this.f&&(P=this.f.workspaceValue(n.extension)??this.f.globalValue(n.extension)),this.c.add(o,g,P),{editable:v(n.provider)}}async $disposeCustomDocument(a,o){const d=this.b.get(o);if(!d)throw new Error(`No provider found for '${o}'`);if(d.type!==1)throw new Error(`Invalid provider type for '${o}'`);const s=O.URI.revive(a),{document:u}=this.i(o,s);this.c.delete(o,u),u.dispose()}async $resolveCustomEditor(a,o,d,s,u,n){console.log("xxxx");const h=this.b.get(d);if(!h)throw new Error(`No provider found for '${d}'`);const g=S.ViewColumn.to(u),P=this.g.createNewWebview(o,s.contentOptions,h.extension),M=this.h.createNewWebviewPanel(o,d,s.title,g,s.options,P,!0),j=O.URI.revive(a);switch(h.type){case 1:{const{document:Z}=this.i(d,j);return h.provider.resolveCustomEditor(Z,M,n)}case 0:{const Z=this.d.getDocument(j);return h.provider.resolveCustomTextEditor(Z,M,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,o,d){this.i(o,a).disposeEdits(d)}async $onMoveCustomEditor(a,o,d){const s=this.b.get(d);if(!s)throw new Error(`No provider found for '${d}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${d}'`);const u=this.h.getWebviewPanel(a);if(!u)throw new Error("No webview found");const n=O.URI.revive(o),h=this.d.getDocument(n);await s.provider.moveCustomTextEditor(h,u,i.CancellationToken.None)}async $undo(a,o,d,s){return this.i(o,a).undo(d,s)}async $redo(a,o,d,s){return this.i(o,a).redo(d,s)}async $revert(a,o,d){const s=this.i(o,a);await this.j(o).revertCustomDocument(s.document,d),s.disposeBackup()}async $onSave(a,o,d){const s=this.i(o,a);await this.j(o).saveCustomDocument(s.document,d),s.disposeBackup()}async $onSaveAs(a,o,d,s){const u=this.i(o,a);return this.j(o).saveCustomDocumentAs(u.document,O.URI.revive(d),s)}async $backup(a,o,d){const s=this.i(o,a),n=await this.j(o).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},d);return s.updateBackup(n),n.id}i(a,o){const d=this.c.get(a,O.URI.revive(o));if(!d)throw new Error("No custom document found");return d}j(a){const d=this.b.get(a)?.provider;if(!d||!v(d))throw new Error("Custom document is not editable");return d}}e.ExtHostCustomEditors=l;function v(r){return!!r.onDidChangeCustomDocument}function b(r){return typeof r.resolveCustomTextEditor=="function"}function E(r){return typeof r.undo=="function"&&typeof r.redo=="function"}function w(r){const a=r.scheme===L.Schemas.file||r.scheme===L.Schemas.untitled?r.fsPath:r.toString();return(0,T.hash)(a)+""}});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(ke[228],Ce([1,0,5,7,2,34,8,60,4,6]),function(ee,e,i,T,y,L,k,O,S,C){"use strict";var N,D,m,p,f,t,c,l,v,b,E,w,r;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class a extends T.Disposable{constructor(u,n,h,g){super(),N.set(this,void 0),D.set(this,void 0),m.set(this,void 0),p.set(this,void 0),f.set(this,void 0),t.set(this,void 0),c.set(this,void 0),l.set(this,void 0),v.set(this,!0),b.set(this,void 0),E.set(this,!1),w.set(this,this.B(new i.Emitter)),this.onDidDispose=Oe(this,w,"f").event,r.set(this,this.B(new i.Emitter)),this.onDidChangeViewState=Oe(this,r,"f").event,Je(this,N,u,"f"),Je(this,D,n,"f"),Je(this,p,h,"f"),Je(this,m,g.viewType,"f"),Je(this,f,g.panelOptions,"f"),Je(this,l,g.viewColumn,"f"),Je(this,t,g.title,"f"),Je(this,b,g.active,"f")}dispose(){Oe(this,E,"f")||(Je(this,E,!0,"f"),Oe(this,w,"f").fire(),Oe(this,D,"f").$disposeWebview(Oe(this,N,"f")),Oe(this,p,"f").dispose(),super.dispose())}get webview(){return this.c(),Oe(this,p,"f")}get viewType(){return this.c(),Oe(this,m,"f")}get title(){return this.c(),Oe(this,t,"f")}set title(u){this.c(),Oe(this,t,"f")!==u&&(Je(this,t,u,"f"),Oe(this,D,"f").$setTitle(Oe(this,N,"f"),u))}get iconPath(){return this.c(),Oe(this,c,"f")}set iconPath(u){this.c(),Oe(this,c,"f")!==u&&(Je(this,c,u,"f"),Oe(this,D,"f").$setIconPath(Oe(this,N,"f"),y.URI.isUri(u)?{light:u,dark:u}:u))}get options(){return Oe(this,f,"f")}get viewColumn(){if(this.c(),!(typeof Oe(this,l,"f")=="number"&&Oe(this,l,"f")<0))return Oe(this,l,"f")}get active(){return this.c(),Oe(this,b,"f")}get visible(){return this.c(),Oe(this,v,"f")}_updateViewState(u){Oe(this,E,"f")||(this.active!==u.active||this.visible!==u.visible||this.viewColumn!==u.viewColumn)&&(Je(this,b,u.active,"f"),Je(this,v,u.visible,"f"),Je(this,l,u.viewColumn,"f"),Oe(this,r,"f").fire({webviewPanel:this}))}reveal(u,n){this.c(),Oe(this,D,"f").$reveal(Oe(this,N,"f"),{viewColumn:typeof u>"u"?void 0:k.ViewColumn.from(u),preserveFocus:!!n})}c(){if(Oe(this,E,"f"))throw new Error("Webview is disposed")}}N=new WeakMap,D=new WeakMap,m=new WeakMap,p=new WeakMap,f=new WeakMap,t=new WeakMap,c=new WeakMap,l=new WeakMap,v=new WeakMap,b=new WeakMap,E=new WeakMap,w=new WeakMap,r=new WeakMap;class o{static c(){return(0,L.generateUuid)()}constructor(u,n,h){this.g=n,this.h=h,this.e=new Map,this.f=new Map,this.d=u.getProxy(S.MainContext.MainThreadWebviewPanels)}createWebviewPanel(u,n,h,g,P={}){const M=typeof g=="object"?g.viewColumn:g,j={viewColumn:k.ViewColumn.from(M),preserveFocus:typeof g=="object"&&!!g.preserveFocus},Z=(0,O.shouldSerializeBuffersForPostMessage)(u),G=o.c();this.d.$createWebviewPanel((0,O.toExtensionData)(u),G,n,{title:h,panelOptions:d(P),webviewOptions:(0,O.serializeWebviewOptions)(u,this.h,P),serializeBuffersForPostMessage:Z},j);const A=this.g.createNewWebview(G,P,u);return this.createNewWebviewPanel(G,n,h,M,P,A,!0)}$onDidChangeWebviewPanelViewStates(u){const n=Object.keys(u);n.sort((h,g)=>{const P=u[h],M=u[g];return P.active?1:M.active?-1:+P.visible-+M.visible});for(const h of n){const g=this.getWebviewPanel(h);if(!g)continue;const P=u[h];g._updateViewState({active:P.active,visible:P.visible,viewColumn:k.ViewColumn.to(P.position)})}}async $onDidDisposeWebviewPanel(u){this.getWebviewPanel(u)?.dispose(),this.e.delete(u),this.g.deleteWebview(u)}registerWebviewPanelSerializer(u,n,h){if(this.f.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.f.set(n,{serializer:h,extension:u}),this.d.$registerSerializer(n,{serializeBuffersForPostMessage:(0,O.shouldSerializeBuffersForPostMessage)(u)}),new C.Disposable(()=>{this.f.delete(n),this.d.$unregisterSerializer(n)})}async $deserializeWebviewPanel(u,n,h,g){const P=this.f.get(n);if(!P)throw new Error(`No serializer found for '${n}'`);const{serializer:M,extension:j}=P,Z=this.g.createNewWebview(u,h.webviewOptions,j),G=this.createNewWebviewPanel(u,n,h.title,g,h.panelOptions,Z,h.active);await M.deserializeWebviewPanel(G,h.state)}createNewWebviewPanel(u,n,h,g,P,M,j){const Z=new a(u,this.d,M,{viewType:n,title:h,viewColumn:g,panelOptions:P,active:j});return this.e.set(u,Z),Z}getWebviewPanel(u){return this.e.get(u)}}e.ExtHostWebviewPanels=o;function d(s){return{enableFindWidget:s.enableFindWidget,retainContextWhenHidden:s.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(ke[229],Ce([1,0,5,7,60,8,4,6]),function(ee,e,i,T,y,L,k,O){"use strict";var S,C,N,D,m,p,f,t,c,l,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class b extends T.Disposable{constructor(r,a,o,d,s,u){super(),S.set(this,void 0),C.set(this,void 0),N.set(this,void 0),D.set(this,void 0),m.set(this,!1),p.set(this,void 0),f.set(this,void 0),t.set(this,void 0),c.set(this,void 0),l.set(this,this.B(new i.Emitter)),this.onDidChangeVisibility=Oe(this,l,"f").event,v.set(this,this.B(new i.Emitter)),this.onDidDispose=Oe(this,v,"f").event,Je(this,N,o,"f"),Je(this,f,d,"f"),Je(this,S,r,"f"),Je(this,C,a,"f"),Je(this,D,s,"f"),Je(this,p,u,"f")}dispose(){Oe(this,m,"f")||(Je(this,m,!0,"f"),Oe(this,v,"f").fire(),Oe(this,D,"f").dispose(),super.dispose())}get title(){return this.a(),Oe(this,f,"f")}set title(r){this.a(),Oe(this,f,"f")!==r&&(Je(this,f,r,"f"),Oe(this,C,"f").$setWebviewViewTitle(Oe(this,S,"f"),r))}get description(){return this.a(),Oe(this,t,"f")}set description(r){this.a(),Oe(this,t,"f")!==r&&(Je(this,t,r,"f"),Oe(this,C,"f").$setWebviewViewDescription(Oe(this,S,"f"),r))}get visible(){return Oe(this,p,"f")}get webview(){return Oe(this,D,"f")}get viewType(){return Oe(this,N,"f")}_setVisible(r){r===Oe(this,p,"f")||Oe(this,m,"f")||(Je(this,p,r,"f"),Oe(this,l,"f").fire())}get badge(){return this.a(),Oe(this,c,"f")}set badge(r){this.a(),!(r?.value===Oe(this,c,"f")?.value&&r?.tooltip===Oe(this,c,"f")?.tooltip)&&(Je(this,c,L.ViewBadge.from(r),"f"),Oe(this,C,"f").$setWebviewViewBadge(Oe(this,S,"f"),r))}show(r){this.a(),Oe(this,C,"f").$show(Oe(this,S,"f"),!!r)}a(){if(Oe(this,m,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,C=new WeakMap,N=new WeakMap,D=new WeakMap,m=new WeakMap,p=new WeakMap,f=new WeakMap,t=new WeakMap,c=new WeakMap,l=new WeakMap,v=new WeakMap;class E{constructor(r,a){this.d=a,this.b=new Map,this.c=new Map,this.a=r.getProxy(k.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(r,a,o,d){if(this.b.has(a))throw new Error(`View provider for '${a}' already registered`);return this.b.set(a,{provider:o,extension:r}),this.a.$registerWebviewViewProvider((0,y.toExtensionData)(r),a,{retainContextWhenHidden:d?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,y.shouldSerializeBuffersForPostMessage)(r)}),new O.Disposable(()=>{this.b.delete(a),this.a.$unregisterWebviewViewProvider(a)})}async $resolveWebviewView(r,a,o,d,s){const u=this.b.get(a);if(!u)throw new Error(`No view provider found for '${a}'`);const{provider:n,extension:h}=u,g=this.d.createNewWebview(r,{},h),P=new b(r,this.a,a,o,g,!0);this.c.set(r,P),await n.resolveWebviewView(P,{state:d},s)}async $onDidChangeWebviewViewVisibility(r,a){this.e(r)._setVisible(a)}async $disposeWebviewView(r){const a=this.e(r);this.c.delete(r),a.dispose(),this.d.deleteWebview(r)}e(r){const a=this.c.get(r);if(!a)throw new Error("No webview found");return a}}e.ExtHostWebviewViews=E}),define(ke[102],Ce([1,0,5,4,2,13,10,3,15]),function(ee,e,i,T,y,L,k,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let C=class rn{get state(){return this.d}constructor(D){this.c=new i.Emitter,this.onDidChangeWindowState=this.c.event,this.d=rn.a,this.b=D.getProxy(T.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(m=>this.$onDidChangeWindowFocus(m))}$onDidChangeWindowFocus(D){D!==this.d.focused&&(this.d={...this.d,focused:D},this.c.fire(this.d))}openUri(D,m){let p;if(typeof D=="string"){p=D;try{D=y.URI.parse(D)}catch{return Promise.reject(`Invalid uri - '${D}'`)}}return(0,k.isFalsyOrWhitespace)(D.scheme)?Promise.reject("Invalid scheme - cannot be empty"):D.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${D.scheme}'`):this.b.$openUri(D,p,m)}async asExternalUri(D,m){if((0,k.isFalsyOrWhitespace)(D.scheme))return Promise.reject("Invalid scheme - cannot be empty");const p=await this.b.$asExternalUri(D,m);return y.URI.from(p)}};C.a={focused:!0},C=qe([Ve(0,S.IExtHostRpcService)],C),e.ExtHostWindow=C,e.IExtHostWindow=(0,O.createDecorator)("IExtHostWindow")}),define(ke[230],Ce([1,0,200,27,15]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let L=class extends i.AbstractExtHostConsoleForwarder{constructor(O,S){super(O,S)}f(O,S,C){S.apply(console,C)}};L=qe([Ve(0,y.IExtHostRpcService),Ve(1,T.IExtHostInitDataService)],L),e.ExtHostConsoleForwarder=L}),define(ke[231],Ce([1,0,14,24,20,11,5,7,123,194,43]),function(ee,e,i,T,y,L,k,O,S,C,N){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function m(P,M){try{return JSON.stringify(P,M)}catch{return"null"}}const p="$$ref$$",f={[p]:-1};class t{constructor(M,j){this.jsonString=M,this.referencedBuffers=j}}function c(P,M=null,j=!1){const Z=[];return{jsonString:(j?m:JSON.stringify)(P,(A,R)=>{if(typeof R>"u")return f;if(typeof R=="object"){if(R instanceof T.VSBuffer){const F=Z.push(R)-1;return{[p]:F}}if(M)return M(A,R)}return R}),referencedBuffers:Z}}e.stringifyJsonWithBufferRefs=c;function l(P,M,j){return JSON.parse(P,(Z,G)=>{if(G){const A=G[p];if(typeof A=="number")return M[A];if(j&&G.$mid===1)return j.transformIncoming(G)}return G})}e.parseJsonAndRestoreBufferRefs=l;function v(P,M){return JSON.stringify(P,M)}function b(P){return P?(M,j)=>j&&j.$mid===1?P.transformOutgoing(j):j:null}var E;(function(P){P[P.LocalSide=0]="LocalSide",P[P.OtherSide=1]="OtherSide"})(E=e.RequestInitiator||(e.RequestInitiator={}));var w;(function(P){P[P.Responsive=0]="Responsive",P[P.Unresponsive=1]="Unresponsive"})(w=e.ResponsiveState||(e.ResponsiveState={}));const r=()=>{},a=Symbol.for("rpcProtocol"),o=Symbol.for("rpcProxy");class d extends O.Disposable{constructor(M,j=null,Z=null){super(),this[D]=!0,this.b=this.B(new k.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=M,this.f=j,this.g=Z,this.h=b(this.g),this.j=!1,this.k=[],this.l=[];for(let G=0,A=N.ProxyIdentifier.count;G<A;G++)this.k[G]=null,this.l[G]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new i.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(G=>this.G(G))}dispose(){this.j=!0,Object.keys(this.s).forEach(M=>{this.s[M].resolveErr(L.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(M){this.u===0&&(this.v=Date.now()+d.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(M){this.v=Date.now()+d.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(M){this.t!==M&&(this.t=M,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(M){return this.g?(0,S.transformIncomingURIs)(M,this.g):M}getProxy(M){const{nid:j,sid:Z}=M;return this.l[j]||(this.l[j]=this.F(j,Z)),this.l[j]}F(M,j){const Z={get:(G,A)=>(typeof A=="string"&&!G[A]&&A.charCodeAt(0)===36&&(G[A]=(...R)=>this.O(M,A,R)),A===o?j:G[A])};return new Proxy(Object.create(null),Z)}set(M,j){return this.k[M.nid]=j,j}assertRegistered(M){for(let j=0,Z=M.length;j<Z;j++){const G=M[j];if(!this.k[G.nid])throw new Error(`Missing proxy instance ${G.sid}`)}}G(M){if(this.j)return;const j=M.byteLength,Z=s.read(M,0),G=Z.readUInt8(),A=Z.readUInt32();switch(G){case 1:case 2:{let{rpcId:R,method:F,args:B}=n.deserializeRequestJSONArgs(Z);this.g&&(B=(0,S.transformIncomingURIs)(B,this.g)),this.H(j,A,R,F,B,G===2);break}case 3:case 4:{let{rpcId:R,method:F,args:B}=n.deserializeRequestMixedArgs(Z);this.g&&(B=(0,S.transformIncomingURIs)(B,this.g)),this.H(j,A,R,F,B,G===4);break}case 5:{this.f?.logIncoming(j,A,0,"ack"),this.z(A);break}case 6:{this.I(j,A);break}case 7:{this.J(j,A,void 0);break}case 9:{let R=n.deserializeReplyOKJSON(Z);this.g&&(R=(0,S.transformIncomingURIs)(R,this.g)),this.J(j,A,R);break}case 10:{const R=n.deserializeReplyOKJSONWithBuffers(Z,this.g);this.J(j,A,R);break}case 8:{const R=n.deserializeReplyOKVSBuffer(Z);this.J(j,A,R);break}case 11:{let R=n.deserializeReplyErrError(Z);this.g&&(R=(0,S.transformIncomingURIs)(R,this.g)),this.L(j,A,R);break}case 12:{this.L(j,A,void 0);break}default:console.error("received unexpected message"),console.error(M)}}H(M,j,Z,G,A,R){this.f?.logIncoming(M,j,1,`receiveRequest ${(0,N.getStringIdentifierForProxy)(Z)}.${G}(`,A);const F=String(j);let B,z;if(R){const K=new y.CancellationTokenSource;A.push(K.token),B=this.M(Z,G,A),z=()=>K.cancel()}else B=this.M(Z,G,A),z=r;this.p[F]=z;const V=n.serializeAcknowledged(j);this.f?.logOutgoing(V.byteLength,j,1,"ack"),this.c.send(V),B.then(K=>{delete this.p[F];const ie=n.serializeReplyOK(j,K,this.h);this.f?.logOutgoing(ie.byteLength,j,1,"reply:",K),this.c.send(ie)},K=>{delete this.p[F];const ie=n.serializeReplyErr(j,K);this.f?.logOutgoing(ie.byteLength,j,1,"replyErr:",K),this.c.send(ie)})}I(M,j){this.f?.logIncoming(M,j,1,"receiveCancel");const Z=String(j);this.p[Z]?.()}J(M,j,Z){this.f?.logIncoming(M,j,0,"receiveReply:",Z);const G=String(j);if(!this.s.hasOwnProperty(G))return;const A=this.s[G];delete this.s[G],A.resolveOk(Z)}L(M,j,Z){this.f?.logIncoming(M,j,0,"receiveReplyErr:",Z);const G=String(j);if(!this.s.hasOwnProperty(G))return;const A=this.s[G];delete this.s[G];let R;Z&&(Z.$isError?(R=new Error,R.name=Z.name,R.message=Z.message,R.stack=Z.stack):R=Z),A.resolveErr(R)}M(M,j,Z){try{return Promise.resolve(this.N(M,j,Z))}catch(G){return Promise.reject(G)}}N(M,j,Z){const G=this.k[M];if(!G)throw new Error("Unknown actor "+(0,N.getStringIdentifierForProxy)(M));const A=G[j];if(typeof A!="function")throw new Error("Unknown method "+j+" on actor "+(0,N.getStringIdentifierForProxy)(M));return A.apply(G,Z)}O(M,j,Z){if(this.j)return new C.CanceledLazyPromise;let G=null;if(Z.length>0&&y.CancellationToken.isCancellationToken(Z[Z.length-1])&&(G=Z.pop()),G&&G.isCancellationRequested)return Promise.reject(L.canceled());const A=n.serializeRequestArguments(Z,this.h),R=++this.m,F=String(R),B=new C.LazyPromise;G&&G.onCancellationRequested(()=>{const V=n.serializeCancel(R);this.f?.logOutgoing(V.byteLength,R,0,"cancel"),this.c.send(n.serializeCancel(R))}),this.s[F]=B,this.y(R);const z=n.serializeRequest(R,M,j,A,!!G);return this.f?.logOutgoing(z.byteLength,R,0,`request: ${(0,N.getStringIdentifierForProxy)(M)}.${j}(`,Z),this.c.send(z),B}}e.RPCProtocol=d,D=a,d.a=3*1e3;class s{static alloc(M,j,Z){const G=new s(T.VSBuffer.alloc(Z+1+4),0);return G.writeUInt8(M),G.writeUInt32(j),G}static read(M,j){return new s(M,j)}get buffer(){return this.a}constructor(M,j){this.a=M,this.b=j}static sizeUInt8(){return 1}writeUInt8(M){this.a.writeUInt8(M,this.b),this.b+=1}readUInt8(){const M=this.a.readUInt8(this.b);return this.b+=1,M}writeUInt32(M){this.a.writeUInt32BE(M,this.b),this.b+=4}readUInt32(){const M=this.a.readUInt32BE(this.b);return this.b+=4,M}static sizeShortString(M){return 1+M.byteLength}writeShortString(M){this.a.writeUInt8(M.byteLength,this.b),this.b+=1,this.a.set(M,this.b),this.b+=M.byteLength}readShortString(){const M=this.a.readUInt8(this.b);this.b+=1;const Z=this.a.slice(this.b,this.b+M).toString();return this.b+=M,Z}static sizeLongString(M){return 4+M.byteLength}writeLongString(M){this.a.writeUInt32BE(M.byteLength,this.b),this.b+=4,this.a.set(M,this.b),this.b+=M.byteLength}readLongString(){const M=this.a.readUInt32BE(this.b);this.b+=4;const Z=this.a.slice(this.b,this.b+M).toString();return this.b+=M,Z}writeBuffer(M){this.a.writeUInt32BE(M.byteLength,this.b),this.b+=4,this.a.set(M,this.b),this.b+=M.byteLength}static sizeVSBuffer(M){return 4+M.byteLength}writeVSBuffer(M){this.a.writeUInt32BE(M.byteLength,this.b),this.b+=4,this.a.set(M,this.b),this.b+=M.byteLength}readVSBuffer(){const M=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+M);return this.b+=M,j}static sizeMixedArray(M){let j=0;j+=1;for(let Z=0,G=M.length;Z<G;Z++){const A=M[Z];switch(j+=1,A.type){case 1:j+=this.sizeLongString(A.value);break;case 2:j+=this.sizeVSBuffer(A.value);break;case 3:j+=this.sizeUInt32,j+=this.sizeLongString(A.value);for(let R=0;R<A.buffers.length;++R)j+=this.sizeVSBuffer(A.buffers[R]);break;case 4:break}}return j}writeMixedArray(M){this.a.writeUInt8(M.length,this.b),this.b+=1;for(let j=0,Z=M.length;j<Z;j++){const G=M[j];switch(G.type){case 1:this.writeUInt8(1),this.writeLongString(G.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(G.value);break;case 3:this.writeUInt8(3),this.writeUInt32(G.buffers.length),this.writeLongString(G.value);for(let A=0;A<G.buffers.length;++A)this.writeBuffer(G.buffers[A]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const M=this.a.readUInt8(this.b);this.b+=1;const j=new Array(M);for(let Z=0;Z<M;Z++)switch(this.readUInt8()){case 1:j[Z]=this.readLongString();break;case 2:j[Z]=this.readVSBuffer();break;case 3:{const A=this.readUInt32(),R=this.readLongString(),F=[];for(let B=0;B<A;++B)F.push(this.readVSBuffer());j[Z]=new N.SerializableObjectWithBuffers(l(R,F,null));break}case 4:j[Z]=void 0;break}return j}}s.sizeUInt32=4;var u;(function(P){P[P.Simple=0]="Simple",P[P.Mixed=1]="Mixed"})(u||(u={}));class n{static a(M){for(let j=0,Z=M.length;j<Z;j++)if(M[j]instanceof T.VSBuffer||M[j]instanceof N.SerializableObjectWithBuffers||typeof M[j]>"u")return!0;return!1}static serializeRequestArguments(M,j){if(this.a(M)){const Z=[];for(let G=0,A=M.length;G<A;G++){const R=M[G];if(R instanceof T.VSBuffer)Z[G]={type:2,value:R};else if(typeof R>"u")Z[G]={type:4};else if(R instanceof N.SerializableObjectWithBuffers){const{jsonString:F,referencedBuffers:B}=c(R.value,j);Z[G]={type:3,value:T.VSBuffer.fromString(F),buffers:B}}else Z[G]={type:1,value:T.VSBuffer.fromString(v(R,j))}}return{type:1,args:Z}}return{type:0,args:v(M,j)}}static serializeRequest(M,j,Z,G,A){switch(G.type){case 0:return this.b(M,j,Z,G.args,A);case 1:return this.c(M,j,Z,G.args,A)}}static b(M,j,Z,G,A){const R=T.VSBuffer.fromString(Z),F=T.VSBuffer.fromString(G);let B=0;B+=s.sizeUInt8(),B+=s.sizeShortString(R),B+=s.sizeLongString(F);const z=s.alloc(A?2:1,M,B);return z.writeUInt8(j),z.writeShortString(R),z.writeLongString(F),z.buffer}static deserializeRequestJSONArgs(M){const j=M.readUInt8(),Z=M.readShortString(),G=M.readLongString();return{rpcId:j,method:Z,args:JSON.parse(G)}}static c(M,j,Z,G,A){const R=T.VSBuffer.fromString(Z);let F=0;F+=s.sizeUInt8(),F+=s.sizeShortString(R),F+=s.sizeMixedArray(G);const B=s.alloc(A?4:3,M,F);return B.writeUInt8(j),B.writeShortString(R),B.writeMixedArray(G),B.buffer}static deserializeRequestMixedArgs(M){const j=M.readUInt8(),Z=M.readShortString(),G=M.readMixedArray(),A=new Array(G.length);for(let R=0,F=G.length;R<F;R++){const B=G[R];typeof B=="string"?A[R]=JSON.parse(B):A[R]=B}return{rpcId:j,method:Z,args:A}}static serializeAcknowledged(M){return s.alloc(5,M,0).buffer}static serializeCancel(M){return s.alloc(6,M,0).buffer}static serializeReplyOK(M,j,Z){if(typeof j>"u")return this.d(M);if(j instanceof T.VSBuffer)return this.e(M,j);if(j instanceof N.SerializableObjectWithBuffers){const{jsonString:G,referencedBuffers:A}=c(j.value,Z,!0);return this.g(M,G,A)}else return this.f(M,m(j,Z))}static d(M){return s.alloc(7,M,0).buffer}static e(M,j){let Z=0;Z+=s.sizeVSBuffer(j);const G=s.alloc(8,M,Z);return G.writeVSBuffer(j),G.buffer}static deserializeReplyOKVSBuffer(M){return M.readVSBuffer()}static f(M,j){const Z=T.VSBuffer.fromString(j);let G=0;G+=s.sizeLongString(Z);const A=s.alloc(9,M,G);return A.writeLongString(Z),A.buffer}static g(M,j,Z){const G=T.VSBuffer.fromString(j);let A=0;A+=s.sizeUInt32,A+=s.sizeLongString(G);for(const F of Z)A+=s.sizeVSBuffer(F);const R=s.alloc(10,M,A);R.writeUInt32(Z.length),R.writeLongString(G);for(const F of Z)R.writeBuffer(F);return R.buffer}static deserializeReplyOKJSON(M){const j=M.readLongString();return JSON.parse(j)}static deserializeReplyOKJSONWithBuffers(M,j){const Z=M.readUInt32(),G=M.readLongString(),A=[];for(let R=0;R<Z;++R)A.push(M.readVSBuffer());return new N.SerializableObjectWithBuffers(l(G,A,j))}static serializeReplyErr(M,j){const Z=j?m(L.transformErrorForSerialization(j),null):void 0;if(typeof Z!="string")return this.h(M);const G=T.VSBuffer.fromString(Z);let A=0;A+=s.sizeLongString(G);const R=s.alloc(11,M,A);return R.writeLongString(G),R.buffer}static deserializeReplyErrError(M){const j=M.readLongString();return JSON.parse(j)}static h(M){return s.alloc(12,M,0).buffer}}var h;(function(P){P[P.RequestJSONArgs=1]="RequestJSONArgs",P[P.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",P[P.RequestMixedArgs=3]="RequestMixedArgs",P[P.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",P[P.Acknowledged=5]="Acknowledged",P[P.Cancel=6]="Cancel",P[P.ReplyOKEmpty=7]="ReplyOKEmpty",P[P.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",P[P.ReplyOKJSON=9]="ReplyOKJSON",P[P.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",P[P.ReplyErrError=11]="ReplyErrError",P[P.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var g;(function(P){P[P.String=1]="String",P[P.VSBuffer=2]="VSBuffer",P[P.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",P[P.Undefined=4]="Undefined"})(g||(g={}))}),define(ke[232],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const i=function(L){const k=O=>{self.removeEventListener("message",k);const S=O.data;Object.defineProperties(self,{postMessage:{value(C,N){S.postMessage(C,N)}},onmessage:{get(){return S.onmessage},set(C){S.onmessage=C}}}),S.addEventListener("message",C=>{self.dispatchEvent(new MessageEvent("message",{data:C.data}))}),S.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(L)};self.addEventListener("message",k)}.toString();class T extends EventTarget{constructor(L,k,O){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const S=`((${i})('${k}'))`,C=new Blob([S],{type:"application/javascript"}),N=URL.createObjectURL(C),D=new MessageChannel,m=N,p={type:"_newWorker",id:m,port:D.port2,url:N,options:O};L(p,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{L({type:"_terminateWorker",id:m}),URL.revokeObjectURL(N),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set(f){D.port1.onmessage=f}},onmessageerror:{get(){return D.port1.onmessageerror},set(f){D.port1.onmessageerror=f}}}),D.port1.addEventListener("messageerror",f=>{const t=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(t)}),D.port1.addEventListener("message",f=>{const t=new MessageEvent("message",{data:f.data});this.dispatchEvent(t)}),D.port1.start()}}e.NestedWorker=T}),define(ke[233],Ce([1,0,5,30,41,3,36,11,14]),function(ee,e,i,T,y,L,k,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new y.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new y.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new y.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,L.createDecorator)(e.OUTPUT_SERVICE_ID);var C;(function(p){p[p.Append=1]="Append",p[p.Replace=2]="Replace",p[p.Clear=3]="Clear"})(C=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class N{constructor(){this.a=new Map,this.b=new i.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new i.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(f){this.a.has(f.id)||(this.a.set(f.id,f),this.b.fire(f.id))}getChannels(){const f=[];return this.a.forEach(t=>f.push(t)),f}getChannel(f){return this.a.get(f)}removeChannel(f){this.a.delete(f),this.c.fire(f)}}T.Registry.add(e.Extensions.OutputChannels,new N);function D(p,f,t,c,l){return(0,S.createCancelablePromise)(async v=>{await(0,k.whenProviderRegistered)(t,c);const b=T.Registry.as(e.Extensions.OutputChannels);try{await m(t,1,c,l,v),b.registerChannel({id:p,label:f,file:t,log:!0})}catch(E){(0,O.isCancellationError)(E)||l.error("Error while registering log channel",t.toString(),(0,O.getErrorMessage)(E))}})}e.registerLogChannel=D;async function m(p,f,t,c,l){if(!await t.exists(p)){if(l.isCancellationRequested)throw new O.CancellationError;if(f>10)throw new Error("Timed out while waiting for file to be created");c.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",p.toString()),await(0,S.timeout)(1e3,l),await m(p,f+1,t,c,l)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new y.RawContextKey("activeOutputChannel","")}),define(ke[103],Ce([1,0,4,3,15,25,12,233,58,27,37,117,24,9,36,5,7]),function(ee,e,i,T,y,L,k,O,S,C,N,D,m,p,f,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class l extends k.AbstractMessageLogger{get disposed(){return this.l}constructor(w,r,a,o,d){super(),this.id=w,this.name=r,this.m=a,this.n=o,this.extension=d,this.k=0,this.l=!1,this.visible=!1,this.setLevel(a.getLevel()),this.B(a.onDidChangeLogLevel(s=>this.setLevel(s)))}get logLevel(){return this.getLevel()}appendLine(w){this.append(w+`
`)}append(w){this.info(w)}clear(){const w=this.k;this.m.flush(),this.n.$update(this.id,O.OutputChannelUpdateMode.Clear,w)}replace(w){const r=this.k;this.info(w),this.n.$update(this.id,O.OutputChannelUpdateMode.Replace,r),this.visible&&this.m.flush()}show(w,r){this.m.flush(),this.n.$reveal(this.id,!!(typeof w=="boolean"?w:r))}hide(){this.n.$close(this.id)}g(w,r){this.k+=m.VSBuffer.fromString(r).byteLength,(0,k.log)(this.m,w,r),this.visible&&(this.m.flush(),this.n.$update(this.id,O.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class v extends l{appendLine(w){this.append(w)}}let b=class{constructor(w,r,a,o,d,s){this.i=r,this.j=a,this.k=o,this.l=d,this.m=s,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=w.getProxy(i.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(r.logsLocation,`output_logging_${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(w){this.h=w;for(const[r,a]of this.g)a.visible=r===this.h}createOutputChannel(w,r,a){if(w=w.trim(),!w)throw new Error("illegal argument `name`. must not be falsy");const o=typeof r=="object"&&r.log,d=(0,p.isString)(r)?r:void 0;if((0,p.isString)(d)&&!d.trim())throw new Error("illegal argument `languageId`. must not be empty");let s;const u=this.i.environment.extensionLogLevel?.find(([h])=>L.ExtensionIdentifier.equals(a.identifier,h))?.[1];u&&(s=(0,k.parseLogLevel)(u));const n=o?this.o(w,s,a):this.n(w,d,a);return n.then(h=>{this.g.set(h.id,h),h.visible=h.id===this.h}),o?this.r(w,s??this.m.getLevel(),n):this.q(w,n)}async n(w,r,a){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const o=await this.c,d=this.k.extUri.joinPath(o,`${this.f++}-${w.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),s=this.l.createLogger(d,{always:!0,donotRotate:!0,donotUseFormatters:!0}),u=await this.a.$register(w,d,!1,r,a.identifier.value);return new l(u,w,s,this.a,a)}async o(w,r,a){const o=await this.p(a),d=this.k.extUri.joinPath(o,`${w.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),s=this.l.createLogger(d,{name:w},r),u=await this.a.$register(w,d,!0,void 0,a.identifier.value);return new v(u,w,s,this.a,a)}p(w){let r=this.d.get(w.identifier.value);if(!r){const a=this.k.extUri.joinPath(this.i.logsLocation,w.identifier.value);this.d.set(w.identifier.value,r=(async()=>{try{await this.j.value.createDirectory(a)}catch(o){if((0,f.toFileSystemProviderErrorCode)(o)!==f.FileSystemProviderErrorCode.FileExists)throw o}return a})())}return r}q(w,r){let a=!1;const o=()=>{if(a)throw new Error("Channel has been closed")};return{get name(){return w},append(d){o(),r.then(s=>s.append(d))},appendLine(d){o(),r.then(s=>s.appendLine(d))},clear(){o(),r.then(d=>d.clear())},replace(d){o(),r.then(s=>s.replace(d))},show(d,s){o(),r.then(u=>u.show(d,s))},hide(){o(),r.then(d=>d.hide())},dispose(){a=!0,r.then(d=>d.dispose())}}}r(w,r,a){const o=new c.DisposableStore,d=()=>{if(o.isDisposed)throw new Error("Channel has been closed")},s=o.add(new t.Emitter);return a.then(u=>{o.add(u),o.add(u.onDidChangeLogLevel(n=>{r=n,s.fire(n)}))}),{...this.q(w,a),get logLevel(){return r},onDidChangeLogLevel:s.event,trace(u,...n){d(),a.then(h=>h.trace(u,...n))},debug(u,...n){d(),a.then(h=>h.debug(u,...n))},info(u,...n){d(),a.then(h=>h.info(u,...n))},warn(u,...n){d(),a.then(h=>h.warn(u,...n))},error(u,...n){d(),a.then(h=>h.error(u,...n))},dispose(){o.dispose()}}}};b=qe([Ve(0,y.IExtHostRpcService),Ve(1,C.IExtHostInitDataService),Ve(2,S.IExtHostConsumerFileSystem),Ve(3,N.IExtHostFileSystemInfo),Ve(4,k.ILoggerService),Ve(5,k.ILogService)],b),e.ExtHostOutputService=b,e.IExtHostOutputService=(0,T.createDecorator)("IExtHostOutputService")}),define(ke[234],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,i.createDecorator)("remoteAgentService")}),define(ke[235],Ce([1,0,39,13,19,21,22,2,3,166,51,181,234]),function(ee,e,i,T,y,L,k,O,S,C,N,D,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let p=class sn{constructor(t,c,l,v){this.d=t,this.e=c,this.f=l,this.g=v,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const b=await this.e.getEnvironment();return this.c=b?.userHome??t})()}hasValidBasename(t,c,l){return typeof c=="string"||typeof c>"u"?this.a.then(v=>this.h(t,v,c)):this.h(t,c,l)}h(t,c,l){return t.scheme===T.Schemas.file||t.scheme===T.Schemas.vscodeRemote?(0,i.isValidBasename)(l??(0,k.basename)(t),c===1):!0}get defaultUriScheme(){return sn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,c){if(t.remoteAuthority)return T.Schemas.vscodeRemote;const l=(0,C.getVirtualWorkspaceScheme)(c.getWorkspace());if(l)return l;const v=c.getWorkspace().folders[0];if(v)return v.uri.scheme;const b=c.getWorkspace().configuration;return b?b.scheme:T.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?y.win32:y.posix)}async fileURI(t){let c="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const v=t.indexOf("/",2);v===-1?(c=t.substring(2),t="/"):(c=t.substring(2,v),t=t.substring(v)||"/")}return O.URI.from({scheme:T.Schemas.file,authority:c,path:t,query:"",fragment:""})}};p=qe([Ve(1,m.IRemoteAgentService),Ve(2,D.IWorkbenchEnvironmentService),Ve(3,N.IWorkspaceContextService)],p),e.AbstractPathService=p}),define(ke[104],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class i{constructor(k,O){this.line=k,this.character=O}isBefore(k){return!1}isBeforeOrEqual(k){return!1}isAfter(k){return!1}isAfterOrEqual(k){return!1}isEqual(k){return!1}compareTo(k){return 0}translate(k,O){return new i(0,0)}with(k){return new i(0,0)}}e.Position=i;class T{constructor(k,O,S,C){this.isEmpty=!1,this.isSingleLine=!1,this.start=new i(k,O),this.end=new i(S,C)}contains(k){return!1}isEqual(k){return!1}intersection(k){}union(k){return new T(0,0,0,0)}with(k){return new T(0,0,0,0)}}e.Range=T;var y;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(y=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ke[44],Ce([1,0,16,35,23,39,10,3,19,11,104,14]),function(ee,e,i,T,y,L,k,O,S,C,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return N.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const m="\u27EA ",p=" characters skipped \u27EB",f=(m.length+p.length+5)*2;e.ISearchService=(0,O.createDecorator)("searchService");var t;(function(ue){ue[ue.file=0]="file",ue[ue.text=1]="text"})(t=e.SearchProviderType||(e.SearchProviderType={}));var c;(function(ue){ue[ue.File=1]="File",ue[ue.Text=2]="Text"})(c=e.QueryType||(e.QueryType={}));function l(ue){return!!ue.preview}e.resultIsMatch=l;function v(ue){return!!ue.resource}e.isFileMatch=v;function b(ue){return!!ue.message}e.isProgressMessage=b;var E;(function(ue){ue[ue.Normal=0]="Normal",ue[ue.NewSearchStarted=1]="NewSearchStarted"})(E=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class w{constructor(oe){this.resource=oe,this.results=[]}}e.FileMatch=w;class r{constructor(oe,De,re){this.ranges=De;const Q=Array.isArray(De)?De:[De];if(re&&re.matchLines===1&&a(Q)){oe=(0,k.getNLines)(oe,re.matchLines);let le="",Ee=0,Ae=0;const Be=Math.floor(re.charsPerLine/5),xe=[];for(const Te of Q){const Ie=Math.max(Te.startColumn-Be,0),Se=Te.startColumn+re.charsPerLine;if(Ie>Ae+Be+f){const se=m+(Ie-Ae)+p;le+=se+oe.slice(Ie,Se),Ee+=Ie-(Ae+se.length)}else le+=oe.slice(Ae,Se);xe.push(new d(0,Te.startColumn-Ee,Te.endColumn-Ee)),Ae=Se}this.preview={text:le,matches:Array.isArray(this.ranges)?xe:xe[0]}}else{const le=Array.isArray(De)?De[0].startLineNumber:De.startLineNumber;this.preview={text:oe,matches:(0,i.mapArrayOrNot)(De,Ee=>new o(Ee.startLineNumber-le,Ee.startColumn,Ee.endLineNumber-le,Ee.endColumn))}}}}e.TextSearchMatch=r;function a(ue){const oe=ue[0].startLineNumber;for(const De of ue)if(De.startLineNumber!==oe||De.endLineNumber!==oe)return!1;return!0}class o{constructor(oe,De,re,Q){this.startLineNumber=oe,this.startColumn=De,this.endLineNumber=re,this.endColumn=Q}}e.SearchRange=o;class d extends o{constructor(oe,De,re){super(oe,De,oe,re)}}e.OneLineRange=d;var s;(function(ue){ue.List="list",ue.Tree="tree"})(s=e.ViewMode||(e.ViewMode={}));var u;(function(ue){ue.Default="default",ue.FileNames="fileNames",ue.Type="type",ue.Modified="modified",ue.CountDescending="countDescending",ue.CountAscending="countAscending"})(u=e.SearchSortOrder||(e.SearchSortOrder={}));function n(ue,oe=!0){const De=ue&&ue.files&&ue.files.exclude,re=oe&&ue&&ue.search&&ue.search.exclude;if(!De&&!re)return;if(!De||!re)return De||re;let Q=Object.create(null);return Q=y.mixin(Q,y.deepClone(De)),Q=y.mixin(Q,y.deepClone(re),!0),Q}e.getExcludes=n;function h(ue,oe){return ue.excludePattern&&T.match(ue.excludePattern,oe)?!1:ue.includePattern||ue.usingSearchPaths?ue.includePattern&&T.match(ue.includePattern,oe)?!0:ue.usingSearchPaths?!!ue.folderQueries&&ue.folderQueries.some(De=>{const re=De.folder.fsPath;if(L.isEqualOrParent(oe,re)){const Q=S.relative(re,oe);return!De.includePattern||!!T.match(De.includePattern,Q)}else return!1}):!1:!0}e.pathIncludedInQuery=h;var g;(function(ue){ue[ue.unknownEncoding=1]="unknownEncoding",ue[ue.regexParseError=2]="regexParseError",ue[ue.globParseError=3]="globParseError",ue[ue.invalidLiteral=4]="invalidLiteral",ue[ue.rgProcessError=5]="rgProcessError",ue[ue.other=6]="other",ue[ue.canceled=7]="canceled"})(g=e.SearchErrorCode||(e.SearchErrorCode={}));class P extends Error{constructor(oe,De){super(oe),this.code=De}}e.SearchError=P;function M(ue){const oe=ue.message;if((0,C.isCancellationError)(ue))return new P(oe,g.canceled);try{const De=JSON.parse(oe);return new P(De.message,De.code)}catch{return new P(oe,g.other)}}e.deserializeSearchError=M;function j(ue){const oe={message:ue.message,code:ue.code};return new Error(JSON.stringify(oe))}e.serializeSearchError=j;function Z(ue){return ue.type==="error"?!0:ue.type==="success"}e.isSerializedSearchComplete=Z;function G(ue){return ue.type==="success"}e.isSerializedSearchSuccess=G;function A(ue){return!!ue.path}e.isSerializedFileMatch=A;function R(ue,oe){const De=ue.searchPath?ue.searchPath:ue.relativePath;return(0,k.fuzzyContains)(De,oe)}e.isFilePatternMatch=R;class F{constructor(oe){this.path=oe,this.results=[]}addMatch(oe){this.results.push(oe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=F;function B(ue,oe){const De={...ue||{},...oe||{}};return Object.keys(De).filter(re=>{const Q=De[re];return typeof Q=="boolean"&&Q})}e.resolvePatternsForProvider=B;class z{constructor(oe,De){this.c=null,this.a={...oe.excludePattern||{},...De.excludePattern||{}},this.b=T.parse(this.a);let re=oe.includePattern;De.includePattern&&(re?re={...re,...De.includePattern}:re=De.includePattern),re&&(this.c=T.parse(re))}matchesExcludesSync(oe,De,re){return!!(this.b&&this.b(oe,De,re))}includedInQuerySync(oe,De,re){return!(this.b&&this.b(oe,De,re)||this.c&&!this.c(oe,De,re))}includedInQuery(oe,De,re){const Q=this.b(oe,De,re),le=()=>this.c?!!this.c(oe,De,re):!0;return(0,D.isThenable)(Q)?Q.then(Ee=>Ee?!1:le()):le()}hasSiblingExcludeClauses(){return V(this.a)}}e.QueryGlobTester=z;function V(ue){for(const oe in ue)if(typeof ue[oe]!="boolean")return!0;return!1}function K(ue){if(!ue)return;let oe;return De=>(oe||(oe=(ue()||Promise.resolve([])).then(re=>re?me(re):{})),oe.then(re=>!!re[De]))}e.hasSiblingPromiseFn=K;function ie(ue){if(!ue)return;let oe;return De=>{if(!oe){const re=ue();oe=re?me(re):{}}return!!oe[De]}}e.hasSiblingFn=ie;function me(ue){const oe={};for(const De of ue)oe[De]=!0;return oe}}),define(ke[31],Ce([1,0,16,14,20,5,7,46,13,111,22,10,9,2,140,3,12,155,51,37,27,15,8,6,53,44,4]),function(ee,e,i,T,y,L,k,O,S,C,N,D,m,p,f,t,c,l,v,b,E,w,r,a,o,d,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function u(G,A,R){return new N.ExtUri(F=>P(F,R)).isEqual(G,A)}function n(G,A,R){return u(G.uri,A.uri,R)?0:(0,D.compare)(G.uri.toString(),A.uri.toString())}function h(G,A,R){return G.index!==A.index?G.index<A.index?-1:1:u(G.uri,A.uri,R)?(0,D.compare)(G.name,A.name):(0,D.compare)(G.uri.toString(),A.uri.toString())}function g(G,A,R,F){const B=G.slice(0).sort((V,K)=>R(V,K,F)),z=A.slice(0).sort((V,K)=>R(V,K,F));return(0,i.delta)(B,z,(V,K)=>R(V,K,F))}function P(G,A){const R=A.getCapabilities(G.scheme);return!(R&&R&1024)}class M extends v.Workspace{static toExtHostWorkspace(A,R,F,B){if(!A)return{workspace:null,added:[],removed:[]};const{id:z,name:V,folders:K,configuration:ie,transient:me,isUntitled:ue}=A,oe=[],De=R;R?K.forEach((Ee,Ae)=>{const Be=p.URI.revive(Ee.uri),xe=M.e(F||R,Be,B);xe?(xe.name=Ee.name,xe.index=Ee.index,oe.push(xe)):oe.push({uri:Be,name:Ee.name,index:Ae})}):oe.push(...K.map(({uri:Ee,name:Ae,index:Be})=>({uri:p.URI.revive(Ee),name:Ae,index:Be}))),oe.sort((Ee,Ae)=>Ee.index<Ae.index?-1:1);const re=new M(z,V,oe,!!me,ie?p.URI.revive(ie):null,!!ue,Ee=>P(Ee,B)),{added:Q,removed:le}=g(De?De.workspaceFolders:[],re.workspaceFolders,n,B);return{workspace:re,added:Q,removed:le}}static e(A,R,F){for(let B=0;B<A.folders.length;B++){const z=A.workspaceFolders[B];if(u(z.uri,R,F))return z}}constructor(A,R,F,B,z,V,K){super(A,F.map(ie=>new v.WorkspaceFolder(ie)),B,z,K),this.s=R,this.t=V,this.o=[],this.q=O.TernarySearchTree.forUris(K),F.forEach(ie=>{this.o.push(ie),this.q.set(ie.uri,ie)})}get name(){return this.s}get isUntitled(){return this.t}get workspaceFolders(){return this.o.slice(0)}getWorkspaceFolder(A,R){return R&&this.q.get(A)&&(A=(0,N.dirname)(A)),this.q.findSubstr(A)}resolveWorkspaceFolder(A){return this.q.get(A)}}let j=class{constructor(A,R,F,B,z){this.c=new L.Emitter,this.onDidChangeWorkspace=this.c.event,this.e=new L.Emitter,this.onDidGrantWorkspaceTrust=this.e.event,this.t=[],this.u=!1,this.v=new Map,this.y=0,this.g=B,this.q=F,this.s=z,this.h=new C.Counter,this.j=new T.Barrier,this.n=A.getProxy(s.MainContext.MainThreadWorkspace),this.o=A.getProxy(s.MainContext.MainThreadMessageService);const V=R.workspace;this.k=V?new M(V.id,V.name,[],!!V.transient,V.configuration?p.URI.revive(V.configuration):null,!!V.isUntitled,K=>P(K,F)):void 0}$initializeWorkspace(A,R){this.u=R,this.$acceptWorkspaceData(A),this.j.open()}waitForInitializeCall(){return this.j.wait()}get workspace(){return this.w}get name(){return this.w?this.w.name:void 0}get workspaceFile(){if(this.w&&this.w.configuration)return this.w.isUntitled?p.URI.from({scheme:S.Schemas.untitled,path:(0,N.basename)((0,N.dirname)(this.w.configuration))}):this.w.configuration}get w(){return this.l||this.k}getWorkspaceFolders(){if(!!this.w)return this.w.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.j.wait(),!!this.w)return this.w.workspaceFolders.slice(0)}updateWorkspaceFolders(A,R,F,...B){const z=[];if(Array.isArray(B)&&B.forEach(ue=>{p.URI.isUri(ue.uri)&&!z.some(oe=>u(oe.uri,ue.uri,this.q))&&z.push({uri:ue.uri,name:ue.name||(0,N.basenameOrAuthority)(ue.uri)})}),this.l||[R,F].some(ue=>typeof ue!="number"||ue<0)||F===0&&z.length===0)return!1;const V=this.w?this.w.workspaceFolders:[];if(R+F>V.length)return!1;const K=V.slice(0);K.splice(R,F,...z.map(ue=>({uri:ue.uri,name:ue.name||(0,N.basenameOrAuthority)(ue.uri),index:void 0})));for(let ue=0;ue<K.length;ue++){const oe=K[ue];if(K.some((De,re)=>re!==ue&&u(oe.uri,De.uri,this.q)))return!1}K.forEach((ue,oe)=>ue.index=oe);const{added:ie,removed:me}=g(V,K,h,this.q);if(ie.length===0&&me.length===0)return!1;if(this.n){const ue=A.displayName||A.name;this.n.$updateWorkspaceFolders(ue,R,F,z).then(void 0,oe=>{this.l=void 0;const De={source:{identifier:A.identifier,label:A.displayName||A.name}};this.o.$showMessage(l.Severity.Error,(0,f.localize)(0,null,ue,oe.toString()),De,[])})}return this.x(K),!0}getWorkspaceFolder(A,R){if(!!this.w)return this.w.getWorkspaceFolder(A,R)}async getWorkspaceFolder2(A,R){if(await this.j.wait(),!!this.w)return this.w.getWorkspaceFolder(A,R)}async resolveWorkspaceFolder(A){if(await this.j.wait(),!!this.w)return this.w.resolveWorkspaceFolder(A)}getPath(){if(!this.w)return;const{folders:A}=this.w;if(A.length!==0)return A[0].uri.fsPath}getRelativePath(A,R){let F,B="";if(typeof A=="string"?(F=p.URI.file(A),B=A):typeof A<"u"&&(F=A,B=A.fsPath),!F)return B;const z=this.getWorkspaceFolder(F,!0);if(!z)return B;typeof R>"u"&&this.w&&(R=this.w.folders.length>1);let V=(0,N.relativePath)(z.uri,F);return R&&z.name&&(V=`${z.name}/${V}`),V}x(A){this.w&&(this.l=M.toExtHostWorkspace({id:this.w.id,name:this.w.name,configuration:this.w.configuration,folders:A,isUntitled:this.w.isUntitled},this.w,void 0,this.q).workspace||void 0)}$acceptWorkspaceData(A){const{workspace:R,added:F,removed:B}=M.toExtHostWorkspace(A,this.k,this.l,this.q);this.k=R||void 0,this.l=void 0,this.c.fire(Object.freeze({added:F,removed:B}))}findFiles(A,R,F,B,z=y.CancellationToken.None){this.g.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${B.value}, entryPoint: findFiles`);let V;if(R===null?V=!1:R&&(typeof R=="string"?V=R:V=R.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:K,folder:ie}=Z(r.GlobPattern.from(A));return this.n.$startFileSearch((0,m.withUndefinedAsNull)(K),(0,m.withUndefinedAsNull)(ie),(0,m.withUndefinedAsNull)(V),(0,m.withUndefinedAsNull)(F),z).then(me=>Array.isArray(me)?me.map(ue=>p.URI.revive(ue)):[])}async findTextInFiles(A,R,F,B,z=y.CancellationToken.None){this.g.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${B.value}, entryPoint: findTextInFiles`);const V=this.h.getNext(),K=typeof R.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:R.previewOptions,{includePattern:ie,folder:me}=Z(r.GlobPattern.from(R.include)),ue=typeof R.exclude=="string"?R.exclude:R.exclude?R.exclude.pattern:void 0,oe={ignoreSymlinks:typeof R.followSymlinks=="boolean"?!R.followSymlinks:void 0,disregardIgnoreFiles:typeof R.useIgnoreFiles=="boolean"?!R.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof R.useGlobalIgnoreFiles=="boolean"?!R.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof R.useParentIgnoreFiles=="boolean"?!R.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof R.useDefaultExcludes=="boolean"?!R.useDefaultExcludes:!0,fileEncoding:R.encoding,maxResults:R.maxResults,previewOptions:K,afterContext:R.afterContext,beforeContext:R.beforeContext,includePattern:ie,excludePattern:ue},De=!1;if(this.t[V]=re=>{if(De)return;const Q=p.URI.revive(re.resource);re.results.forEach(le=>{(0,d.resultIsMatch)(le)?F({uri:Q,preview:{text:le.preview.text,matches:(0,i.mapArrayOrNot)(le.preview.matches,Ee=>new a.Range(Ee.startLineNumber,Ee.startColumn,Ee.endLineNumber,Ee.endColumn))},ranges:(0,i.mapArrayOrNot)(le.ranges,Ee=>new a.Range(Ee.startLineNumber,Ee.startColumn,Ee.endLineNumber,Ee.endColumn))}):F({uri:Q,text:le.text,lineNumber:le.lineNumber})})},z.isCancellationRequested)return{};try{const re=await this.n.$startTextSearch(A,(0,m.withUndefinedAsNull)(me),oe,V,z);return delete this.t[V],re||{}}catch(re){throw delete this.t[V],re}}$handleTextSearchResult(A,R){this.t[R]?.(A)}saveAll(A){return this.n.$saveAll(A)}resolveProxy(A){return this.n.$resolveProxy(A)}get trusted(){return this.u}requestWorkspaceTrust(A){return this.n.$requestWorkspaceTrust(A)}$onDidGrantWorkspaceTrust(){this.u||(this.u=!0,this.e.fire())}registerEditSessionIdentityProvider(A,R){if(this.v.has(A))throw new Error(`A provider has already been registered for scheme ${A}`);this.v.set(A,R);const F=this.s.transformOutgoingScheme(A),B=this.y++;return this.n.$registerEditSessionIdentityProvider(B,F),(0,k.toDisposable)(()=>{this.v.delete(A),this.n.$unregisterEditSessionIdentityProvider(B)})}async $getEditSessionIdentifier(A,R){this.g.info("Getting edit session identifier for workspaceFolder",A);const F=await this.resolveWorkspaceFolder(p.URI.revive(A));if(!F){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const B=this.v.get(F.uri.scheme);if(this.g.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!B),!B)return;const z=await B.provideEditSessionIdentity(F,R);if(this.g.info("Provider returned edit session identifier: ",z),!!z)return z}async $provideEditSessionIdentityMatch(A,R,F,B){this.g.info("Getting edit session identifier for workspaceFolder",A);const z=await this.resolveWorkspaceFolder(p.URI.revive(A));if(!z){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",z);const V=this.v.get(z.uri.scheme);if(this.g.info(`Provider for scheme ${z.uri.scheme} is defined: `,!!V),!V)return;const K=await V.provideEditSessionIdentityMatch?.(R,F,B);if(this.g.info("Provider returned edit session identifier match result: ",K),!!K)return K}};j=qe([Ve(0,w.IExtHostRpcService),Ve(1,E.IExtHostInitDataService),Ve(2,b.IExtHostFileSystemInfo),Ve(3,c.ILogService),Ve(4,o.IURITransformerService)],j),e.ExtHostWorkspace=j,e.IExtHostWorkspace=(0,t.createDecorator)("IExtHostWorkspace");function Z(G){let A,R;return G&&(typeof G=="string"?A=G:(A=G.pattern,R=p.URI.revive(G.baseUri))),{includePattern:A,folder:R}}}),define(ke[32],Ce([1,0,23,5,31,4,6,158,91,9,14,3,15,12,2]),function(ee,e,i,T,y,L,k,O,S,C,N,D,m,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function t(a,o){if(o){const d=o.split(".");let s=a;for(let u=0;s&&u<d.length;u++)s=s[d[u]];return s}}function c(a){return a instanceof f.URI}function l(a){return a&&a.uri instanceof f.URI&&a.languageId&&typeof a.languageId=="string"}function v(a){return a&&!a.uri&&a.languageId&&typeof a.languageId=="string"}function b(a){return a&&a.uri instanceof f.URI&&(!a.name||typeof a.name=="string")&&(!a.index||typeof a.index=="number")}function E(a){if(c(a))return{resource:a};if(l(a))return{resource:a.uri,overrideIdentifier:a.languageId};if(v(a))return{overrideIdentifier:a.languageId};if(b(a))return{resource:a.uri};if(a===null)return{resource:null}}let w=class{constructor(o,d,s){this.a=o.getProxy(L.MainContext.MainThreadConfiguration),this.c=d,this.b=s,this.d=new N.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(o=>this.e)}$initializeConfiguration(o){this.e=new r(this.a,this.c,o,this.b),this.d.open()}$acceptConfigurationChanged(o,d){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(o,d))}};w=qe([Ve(0,m.IExtHostRpcService),Ve(1,y.IExtHostWorkspace),Ve(2,p.ILogService)],w),e.ExtHostConfiguration=w;class r{constructor(o,d,s,u){this.a=new T.Emitter,this.b=o,this.f=u,this.c=d,this.e=O.Configuration.parse(s),this.d=this.k(s.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(o,d){const s={data:this.e.toData(),workspace:this.c.workspace};this.e=O.Configuration.parse(o),this.d=this.k(o.configurationScopes),this.a.fire(this.j(d,s))}getConfiguration(o,d,s){const u=E(d)||{},n=this.g(o?t(this.e.getValue(void 0,u,this.c.workspace),o):this.e.getValue(void 0,u,this.c.workspace));o&&this.h(o,u,s?.identifier);function h(P){if(P==null)return null;if(typeof P=="boolean")return P?2:5;switch(P){case k.ConfigurationTarget.Global:return 2;case k.ConfigurationTarget.Workspace:return 5;case k.ConfigurationTarget.WorkspaceFolder:return 6}}const g={has(P){return typeof t(n,P)<"u"},get:(P,M)=>{this.h(o?`${o}.${P}`:P,u,s?.identifier);let j=t(n,P);if(typeof j>"u")j=M;else{let Z;const G=(A,R)=>{let F;const B=()=>{Z=Z||(0,i.deepClone)(n),F=F||t(Z,R)};return(0,C.isObject)(A)?new Proxy(A,{get:(z,V)=>{if(typeof V=="string"&&V.toLowerCase()==="tojson")return B(),()=>F;if(Z)return F=F||t(Z,R),F[V];const K=z[V];return typeof V=="string"?G(K,`${R}.${V}`):K},set:(z,V,K)=>(B(),F&&(F[V]=K),!0),deleteProperty:(z,V)=>(B(),F&&delete F[V],!0),defineProperty:(z,V,K)=>(B(),F&&Object.defineProperty(F,V,K),!0)}):A};j=G(j,P)}return j},update:(P,M,j,Z)=>{P=o?`${o}.${P}`:P;const G=h(j);return M!==void 0?this.b.$updateConfigurationOption(G,P,M,u,Z):this.b.$removeConfigurationOption(G,P,u,Z)},inspect:P=>{P=o?`${o}.${P}`:P;const M=this.e.inspect(P,u,this.c.workspace);if(M)return{key:P,defaultValue:(0,i.deepClone)(M.policy?.value??M.default?.value),globalValue:(0,i.deepClone)(M.user?.value??M.application?.value),workspaceValue:(0,i.deepClone)(M.workspace?.value),workspaceFolderValue:(0,i.deepClone)(M.workspaceFolder?.value),defaultLanguageValue:(0,i.deepClone)(M.default?.override),globalLanguageValue:(0,i.deepClone)(M.user?.override??M.application?.override),workspaceLanguageValue:(0,i.deepClone)(M.workspace?.override),workspaceFolderLanguageValue:(0,i.deepClone)(M.workspaceFolder?.override),languageIds:(0,i.deepClone)(M.overrideIdentifiers)}}};return typeof n=="object"&&(0,i.mixin)(g,n,!1),Object.freeze(g)}g(o){const d=s=>(0,C.isObject)(s)?new Proxy(s,{get:(u,n)=>d(u[n]),set:(u,n,h)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(n)}' of object`)},deleteProperty:(u,n)=>{throw new Error(`TypeError: Cannot delete read only property '${String(n)}' of object`)},defineProperty:(u,n)=>{throw new Error(`TypeError: Cannot define property '${String(n)}' for a readonly object`)},setPrototypeOf:u=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return d(o)}h(o,d,s){const u=S.OVERRIDE_PROPERTY_REGEX.test(o)?4:this.d.get(o),n=s?`[${s.value}] `:"";if(u===4){typeof d?.resource>"u"&&this.f.warn(`${n}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(u===3){d?.resource&&this.f.warn(`${n}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(o,d){const s=new O.ConfigurationChangeEvent(o,d,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(u,n)=>s.affectsConfiguration(u,E(n))})}k(o){return o.reduce((d,s)=>(d.set(s[0],s[1]),d),new Map)}}e.ExtHostConfigProvider=r,e.IExtHostConfiguration=(0,D.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(ke[105],Ce([1,0,2,14,5,4,6,31,56,32,20,59,15,27,3,13,21,12,73,193,11]),function(ee,e,i,T,y,L,k,O,S,C,N,D,m,p,f,t,c,l,v,b,E){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var r;(function(A){function R(B){if(B!=null)return B}A.from=R;function F(B){if(B!=null)return B}A.to=F})(r||(r={}));var a;(function(A){function R(B){if(B!=null)return B}A.from=R;function F(B){if(B!=null)return B}A.to=F})(a||(a={}));var o;(function(A){function R(B){if(B!=null)return B}A.from=R;function F(B){if(B!=null)return B}A.to=F})(o||(o={}));var d;(function(A){function R(z){if(z){const V=z;return V&&!!V.process}else return!1}A.is=R;function F(z){if(z==null)return;const V={process:z.process,args:z.args};return z.options&&(V.options=o.from(z.options)),V}A.from=F;function B(z){if(z!=null)return new k.ProcessExecution(z.process,z.args,z.options)}A.to=B})(d||(d={}));var s;(function(A){function R(B){if(B!=null)return B}A.from=R;function F(B){if(B!=null)return B}A.to=F})(s||(s={}));var u;(function(A){function R(z){if(z){const V=z;return V&&(!!V.commandLine||!!V.command)}else return!1}A.is=R;function F(z){if(z==null)return;const V={};return z.commandLine!==void 0?V.commandLine=z.commandLine:(V.command=z.command,V.args=z.args),z.options&&(V.options=s.from(z.options)),V}A.from=F;function B(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new k.ShellExecution(z.commandLine,z.options):new k.ShellExecution(z.command,z.args?z.args:[],z.options)}A.to=B})(u||(u={}));var n;(function(A){function R(z){if(z){const V=z;return V&&V.customExecution==="customExecution"}else return!1}A.is=R;function F(z){return{customExecution:"customExecution"}}A.from=F;function B(z,V){return V.get(z)}A.to=B})(n=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var h;(function(A){function R(F,B){let z;return F.scope!==void 0&&typeof F.scope!="number"?z=F.scope.uri:F.scope!==void 0&&typeof F.scope=="number"&&(F.scope===k.TaskScope.Workspace&&B&&B.workspaceFile?z=B.workspaceFile:z=b.USER_TASKS_GROUP_KEY),{id:F._id,workspaceFolder:z}}A.from=R})(h=e.TaskHandleDTO||(e.TaskHandleDTO={}));var g;(function(A){function R(F){if(F!=null)return{_id:F.id,isDefault:F.isDefault}}A.from=R})(g||(g={}));var P;(function(A){function R(z,V){if(z==null)return[];const K=[];for(const ie of z){const me=F(ie,V);me&&K.push(me)}return K}A.fromMany=R;function F(z,V){if(z==null)return;let K;z.execution instanceof k.ProcessExecution?K=d.from(z.execution):z.execution instanceof k.ShellExecution?K=u.from(z.execution):z.execution&&z.execution instanceof k.CustomExecution&&(K=n.from(z.execution));const ie=r.from(z.definition);let me;return z.scope?typeof z.scope=="number"?me=z.scope:me=z.scope.uri:me=k.TaskScope.Workspace,!ie||!me?void 0:{_id:z._id,definition:ie,name:z.name,source:{extensionId:V.identifier.value,label:z.source,scope:me},execution:K,isBackground:z.isBackground,group:g.from(z.group),presentationOptions:a.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}A.from=F;async function B(z,V,K){if(z==null)return;let ie;d.is(z.execution)?ie=d.to(z.execution):u.is(z.execution)?ie=u.to(z.execution):n.is(z.execution)&&(ie=n.to(z._id,K));const me=r.to(z.definition);let ue;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?ue=z.source.scope:ue=await V.resolveWorkspaceFolder(i.URI.revive(z.source.scope)):ue=k.TaskScope.Workspace),!me||!ue)return;const oe=new k.Task(me,ue,z.name,z.source.label,ie,z.problemMatchers);return z.isBackground!==void 0&&(oe.isBackground=z.isBackground),z.group!==void 0&&(oe.group=k.TaskGroup.from(z.group._id),oe.group&&z.group.isDefault&&(oe.group=new k.TaskGroup(oe.group.id,oe.group.label),z.group.isDefault===!0&&(oe.group.isDefault=z.group.isDefault))),z.presentationOptions&&(oe.presentationOptions=a.to(z.presentationOptions)),z._id&&(oe._id=z._id),z.detail&&(oe.detail=z.detail),oe}A.to=B})(P=e.TaskDTO||(e.TaskDTO={}));var M;(function(A){function R(B){return B}A.from=R;function F(B){if(!!B)return Object.assign(Object.create(null),B)}A.to=F})(M||(M={}));class j{constructor(R,F,B){this._id=F,this.a=B,w.set(this,void 0),Je(this,w,R,"f")}get task(){return this.a}terminate(){Oe(this,w,"f").terminateTask(this)}fireDidStartProcess(R){}fireDidEndProcess(R){}}w=new WeakMap;let Z=class{constructor(R,F,B,z,V,K,ie,me){this.q=new y.Emitter,this.r=new y.Emitter,this.s=new y.Emitter,this.t=new y.Emitter,this.a=R.getProxy(L.MainContext.MainThreadTask),this.b=B,this.c=z,this.d=V,this.e=K,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ie,this.g=me,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(R,F,B){if(!B)return new k.Disposable(()=>{});const z=this.w();return this.j.set(z,{type:F,provider:B,extension:R}),this.a.$registerTaskProvider(z,F),new k.Disposable(()=>{this.j.delete(z),this.a.$unregisterTaskProvider(z)})}registerTaskSystem(R,F){this.a.$registerTaskSystem(R,F)}fetchTasks(R){return this.a.$fetchTasks(M.from(R)).then(async F=>{const B=[];for(const z of F){const V=await P.to(z,this.b,this.m);V&&B.push(V)}return B})}get taskExecutions(){const R=[];return this.k.forEach(F=>R.push(F)),R}terminateTask(R){if(!(R instanceof j))throw new Error("No valid task execution provided");return this.a.$terminateTask(R._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(R,F,B){const z=this.m.get(R.id);z&&(this.o.set(R.id,z),this.e.attachPtyToTerminal(F,await z.callback(B))),this.p=R.id,this.q.fire({execution:await this.y(R)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(R){const F=await this.y(R);this.l.delete(R.id),this.k.delete(R.id),this.A(R),this.r.fire({execution:F})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(R){const F=await this.y(R.id);this.s.fire({execution:F,processId:R.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(R){const F=await this.y(R.id);this.t.fire({execution:F,exitCode:R.exitCode})}$provideTasks(R,F){const B=this.j.get(R);if(!B)return Promise.reject(new Error("no handler found"));const z=[],V=(0,T.asPromise)(()=>B.provider.provideTasks(N.CancellationToken.None)).then(K=>this.u(F,z,B,K));return new Promise(K=>{V.then(ie=>{Promise.all(z).then(()=>{K(ie)})})})}async $resolveTask(R,F){const B=this.j.get(R);if(!B)return Promise.reject(new Error("no handler found"));if(F.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${F.definition.type}] cannot be resolved by provider of type [${B.type}].`);const z=await P.to(F,this.b,this.m);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const V=await B.provider.resolveTask(z,N.CancellationToken.None);if(!V)return;this.z(V,B);const K=P.from(V,B.extension);if(!K)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return n.is(K.execution)&&await this.x(K,V,!0),await this.v(K)}w(){return this.h++}async x(R,F,B){const z=await this.a.$createTaskId(R);!B&&!this.m.has(z)&&(this.n.add(z),this.o.set(z,F.execution)),this.m.set(z,F.execution)}async y(R,F){if(typeof R=="string"){const V=this.l.get(R);if(!V)throw new E.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return V}const B=this.l.get(R.id);if(B)return B;const z=new Promise((V,K)=>{function ie(me,ue,oe){oe?V(new j(me,ue.id,oe)):K("Unexpected: Task does not exist.")}F?ie(this,R,F):P.to(R.task,this.b,this.m).then(me=>ie(this,R,me))});return this.l.set(R.id,z),z.then(V=>(this.k.set(R.id,V),V),V=>Promise.reject(V))}z(R,F){R._deprecated&&this.g.report("Task.constructor",F.extension,"Use the Task constructor that takes a `scope` instead.")}A(R){this.o.get(R.id)&&this.o.delete(R.id),this.n.has(R.id)&&this.p!==R.id&&(this.m.delete(R.id),this.n.delete(R.id));const B=this.n.values();let z=B.next();for(;!z.done;)!this.o.has(z.value)&&this.p!==z.value&&(this.m.delete(z.value),this.n.delete(z.value)),z=B.next()}};Z=qe([Ve(0,m.IExtHostRpcService),Ve(1,p.IExtHostInitDataService),Ve(2,O.IExtHostWorkspace),Ve(3,S.IExtHostDocumentsAndEditors),Ve(4,C.IExtHostConfiguration),Ve(5,D.IExtHostTerminalService),Ve(6,l.ILogService),Ve(7,v.IExtHostApiDeprecationService)],Z),e.ExtHostTaskBase=Z;let G=class extends Z{constructor(R,F,B,z,V,K,ie,me){super(R,F,B,z,V,K,ie,me),this.registerTaskSystem(t.Schemas.vscodeRemote,{scheme:t.Schemas.vscodeRemote,authority:"",platform:c.PlatformToString(0)})}async executeTask(R,F){if(!F.execution)throw new Error("Tasks to execute must include an execution");const B=P.from(F,R);if(B===void 0)throw new Error("Task is not valid");if(n.is(B.execution))await this.x(B,F,!1);else throw new E.NotSupportedError;const z=await this.y(await this.a.$getTaskExecution(B),F);return this.a.$executeTask(B).catch(V=>{throw new Error(V)}),z}u(R,F,B,z){const V=[];if(z)for(const K of z){this.z(K,B),(!K.definition||!R[K.definition.type])&&this.f.warn(`The task [${K.source}, ${K.name}] uses an undefined task type. The task will be ignored in the future.`);const ie=P.from(K,B.extension);ie&&n.is(ie.execution)?(V.push(ie),F.push(this.x(ie,K,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:V,extension:B.extension}}async v(R){if(n.is(R.execution))return R;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(R,F){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(R,F,B){}};G=qe([Ve(0,m.IExtHostRpcService),Ve(1,p.IExtHostInitDataService),Ve(2,O.IExtHostWorkspace),Ve(3,S.IExtHostDocumentsAndEditors),Ve(4,C.IExtHostConfiguration),Ve(5,D.IExtHostTerminalService),Ve(6,l.ILogService),Ve(7,v.IExtHostApiDeprecationService)],G),e.WorkerExtHostTask=G,e.IExtHostTask=(0,f.createDecorator)("IExtHostTask")}),define(ke[236],Ce([1,0,19,20,45,35,22,74,44]),function(ee,e,i,T,y,L,k,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class C{constructor(m,p,f){this.k=m,this.l=p,this.o=f,this.e=!1,this.f=0,this.g=!1,this.a=m.filePattern,this.b=m.includePattern&&L.parse(m.includePattern),this.c=m.maxResults||void 0,this.d=m.exists,this.h=new Set,this.j=m.excludePattern&&L.parse(m.excludePattern)}cancel(){this.g=!0,this.h.forEach(m=>m.cancel()),this.h=new Set}search(m){const p=this.k.folderQueries||[];return new Promise((f,t)=>{const c=l=>{this.f++,m(l)};if(this.g)return f({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(l=>{const v=l.toString(),b=i.basename(v);this.j&&this.j(v,b)||this.v(c,{base:l,basename:b})}),Promise.all(p.map(l=>this.p(l,c))).then(l=>{f({limitHit:this.e,stats:l[0]||void 0})},l=>{t(new Error((0,y.toErrorMessage)(l)))})})}async p(m,p){const f=new T.CancellationTokenSource,t=this.q(m),c=this.r(),l=new S.QueryGlobTester(this.k,m),v=!l.hasSiblingExcludeClauses();let b;try{this.h.add(f),b=O.StopWatch.create();const E=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},t,f.token),w=b.elapsed(),r=O.StopWatch.create();return this.g&&!this.e||(E&&E.forEach(a=>{const o=i.posix.relative(m.folder.path,a.path);if(v){const d=i.basename(a.path);this.v(p,{base:m.folder,relativePath:o,basename:d});return}this.s(c,m.folder,o,p)}),this.g&&!this.e)?null:(this.u(c,l,p),{providerTime:w,postProcessTime:r.elapsed()})}finally{f.dispose(),this.h.delete(f)}}q(m){const p=(0,S.resolvePatternsForProvider)(this.k.includePattern,m.includePattern),f=(0,S.resolvePatternsForProvider)(this.k.excludePattern,m.excludePattern);return{folder:m.folder,excludes:f,includes:p,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}s({pathToEntries:m},p,f,t){if(f===this.a){const l=i.basename(this.a);this.v(t,{base:p,relativePath:this.a,basename:l})}function c(l){const v=i.basename(l),b=i.dirname(l);let E=m[b];E||(E=m[b]=[],c(b)),E.push({base:p,relativePath:l,basename:v})}c(f)}u({rootEntries:m,pathToEntries:p},f,t){const c=this,l=this.a;function v(b){const E=(0,S.hasSiblingFn)(()=>b.map(w=>w.basename));for(let w=0,r=b.length;w<r;w++){const a=b[w],{relativePath:o,basename:d}=a;if(f.matchesExcludesSync(o,d,l!==d?E:void 0))continue;const s=p[o];if(s)v(s);else{if(o===l)continue;c.v(t,a)}if(c.e)break}}v(m)}v(m,p){(!this.b||p.relativePath&&this.b(p.relativePath,p.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||m(p))}}class N{constructor(){this.b=new Map}fileSearch(m,p,f,t){const c=this.c(m.cacheKey),l=new C(m,p,c&&c.token);let v=0;const b=E=>{v+=E.length,f(E.map(w=>this.d(w)))};return this.e(l,N.a,b,t).then(E=>({limitHit:E.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:v,detailStats:E.stats}}))}clearCache(m){this.c(m)?.cancel()}c(m){if(!!m)return this.b.has(m)||this.b.set(m,new T.CancellationTokenSource),this.b.get(m)}d(m){return m.relativePath?{resource:k.joinPath(m.base,m.relativePath)}:{resource:m.base}}e(m,p,f,t){t.onCancellationRequested(()=>{m.cancel()});const c=v=>{v&&(l.push(v),p>0&&l.length>=p&&(f(l),l=[]))};let l=[];return m.search(c).then(v=>(l.length&&f(l),v),v=>(l.length&&f(l),Promise.reject(v)))}}e.FileSearchManager=N,N.a=512}),define(ke[237],Ce([1,0,16,80,35,84,28,13,19,22,10,9,2,253,148,40,12,51,95,235,44]),function(ee,e,i,T,y,L,k,O,S,C,N,D,m,p,f,t,c,l,v,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let w=class{constructor(g,P,M,j,Z){this.a=g,this.b=P,this.c=M,this.d=j,this.e=Z}text(g,P,M={}){g=this.f(g,M);const j=this.a.getValue(),Z=P&&P.some(A=>!this.a.getValue({resource:A}).search.useRipgrep);return{...this.h(P?.map(l.toWorkspaceFolder),M),type:2,contentPattern:g,previewOptions:M.previewOptions,maxFileSize:M.maxFileSize,usePCRE2:j.search.usePCRE2||Z||!1,beforeContext:M.beforeContext,afterContext:M.afterContext,userDisabledExcludesAndIgnoreFiles:M.disregardExcludeSettings&&M.disregardIgnoreFiles}}f(g,P){const M=this.a.getValue();g.isRegExp&&(g.pattern=g.pattern.replace(/\r?\n/g,"\\n"));const j={...g,wordSeparators:M.editor.wordSeparators};return this.j(g,P)&&(j.isCaseSensitive=!0),this.k(g)&&(j.isMultiline=!0),j}file(g,P={}){return{...this.h(g,P),type:1,filePattern:P.filePattern?P.filePattern.trim():P.filePattern,exists:P.exists,sortByScore:P.sortByScore,cacheKey:P.cacheKey}}g(g,P){return g?(g=Array.isArray(g)?g.map(s):s(g),P?this.parseSearchPaths(g):{pattern:a(...Array.isArray(g)?g:[g])}):{}}h(g=[],P={}){const M=this.g(P.includePattern,P.expandPatterns),j=this.g(P.excludePattern,P.expandPatterns),Z=g.length>1,G=(M.searchPaths&&M.searchPaths.length?M.searchPaths.map(F=>this.q(F,P,j)):g.map(F=>this.r(F,P,j,Z))).filter(F=>!!F),A={_reason:P._reason,folderQueries:G,usingSearchPaths:!!(M.searchPaths&&M.searchPaths.length),extraFileResources:P.extraFileResources,excludePattern:j.pattern,includePattern:M.pattern,onlyOpenEditors:P.onlyOpenEditors,maxResults:P.maxResults};if(P.onlyOpenEditors){const F=i.coalesce(i.flatten(this.c.groups.map(V=>V.editors.map(K=>K.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const B=F.filter(V=>(0,E.pathIncludedInQuery)(A,V.fsPath)),z=this.i(B);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(z)),{...A,...z}}const R=P.extraFileResources&&P.extraFileResources.filter(F=>(0,E.pathIncludedInQuery)(A,F.fsPath));return A.extraFileResources=R&&R.length?R:void 0,A}i(g){const P=[],M=new k.ResourceMap,j={};let Z=!1;return g.forEach(G=>{if(G.scheme===O.Schemas.walkThrough)return;if((0,C.isAbsolutePath)(G)){const R=this.b.getWorkspaceFolder(G)?.uri??G.with({path:S.dirname(G.fsPath)});let F=M.get(R);F||(Z=!0,F={folder:R,includePattern:{}},P.push(F),M.set(R,F));const B=S.relative(R.fsPath,G.fsPath);(0,D.assertIsDefined)(F.includePattern)[B.replace(/\\/g,"/")]=!0}else G.fsPath&&(Z=!0,j[G.fsPath]=!0)}),{folderQueries:P,includePattern:j,usingSearchPaths:!0,excludePattern:Z?void 0:{"**/*":!0}}}j(g,P){if(P.isSmartCase){if(g.isRegExp){if(N.containsUppercaseCharacter(g.pattern,!0))return!0}else if(N.containsUppercaseCharacter(g.pattern))return!0}return!!g.isCaseSensitive}k(g){return g.isMultiline||g.isRegExp&&(0,p.isMultilineRegexSource)(g.pattern)||g.pattern.indexOf(`
`)>=0?!0:!!g.isMultiline}parseSearchPaths(g){const P=z=>S.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),j=(Array.isArray(g)?g:o(g)).map(z=>{const V=this.e.resolvedUserHome;return V?(0,L.untildify)(z,V.scheme===O.Schemas.file?V.fsPath:V.path):z}),Z=T.groupBy(j,z=>P(z)?"searchPaths":"exprSegments"),G=(Z.exprSegments||[]).map(z=>N.rtrim(z,"/")).map(z=>N.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),d(z))),A={},R=this.m(Z.searchPaths||[]);R&&R.length&&(A.searchPaths=R);const F=i.flatten(G),B=a(...F);return B&&(A.pattern=B),A}l(g,P){return P.disregardExcludeSettings?void 0:(0,E.getExcludes)(g,!P.disregardSearchExcludeSettings)}m(g){if(!g||!g.length)return[];const P=g.flatMap(j=>{let{pathPortion:Z,globPortion:G}=r(j);return G&&(G=u(G)),this.n(Z).flatMap(R=>this.o(R,G))}),M=new Map;return P.forEach(j=>{const Z=j.searchPath.toString(),G=M.get(Z);G?j.pattern&&(G.pattern=G.pattern||{},G.pattern[j.pattern]=!0):M.set(Z,{searchPath:j.searchPath,pattern:j.pattern?a(j.pattern):void 0})}),Array.from(M.values())}n(g){if(S.isAbsolute(g)){const P=this.b.getWorkspace().folders;return P[0]&&P[0].uri.scheme!==O.Schemas.file?[{searchPath:P[0].uri.with({path:g})}]:[{searchPath:m.URI.file(S.normalize(g))}]}if(this.b.getWorkbenchState()===2){const P=this.b.getWorkspace().folders[0].uri;if(g=s(g),g.startsWith("../")||g===".."){const j=S.posix.resolve(P.path,g);return[{searchPath:P.with({path:j})}]}const M=u(g);return[{searchPath:P,pattern:M}]}else{if(g==="./"||g===".\\")return[];{const P=g.replace(/^\.[\/\\]/,""),j=this.b.getWorkspace().folders.map(Z=>{const G=P.match(new RegExp(`^${N.escapeRegExpCharacters(Z.name)}(?:/(.*)|$)`));return G?{match:G,folder:Z}:null}).filter(D.isDefined);if(j.length)return j.map(Z=>{const G=Z.match[1];return{searchPath:Z.folder.uri,pattern:G&&u(G)}});{const Z=g.match(/\.[\/\\](.+)[\/\\]?/),G=Z?Z[1]:g,A=f.localize(0,null,G);throw new Error(A)}}}}o(g,P){const M=g.pattern&&P?`${g.pattern}/${P}`:g.pattern||P,j=[{searchPath:g.searchPath,pattern:M}];return M&&!M.endsWith("**")&&j.push({searchPath:g.searchPath,pattern:M+"/**"}),j}q(g,P,M){const j=this.r((0,l.toWorkspaceFolder)(g.searchPath),P,M,!1);return j?{...j,includePattern:g.pattern}:null}r(g,P,M,j){let Z;const G=m.URI.isUri(g)?g:g.uri;if(M.searchPaths){const z=M.searchPaths.filter(V=>(0,C.isEqual)(V.searchPath,G))[0];if(z&&!z.pattern)return null;z&&(Z=z.pattern)}const A=this.a.getValue({resource:G}),F={...this.l(A,P)||{},...Z||{}},B=m.URI.isUri(g)?(0,C.basename)(g):g.name;return{folder:G,folderName:j?B:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:A.files&&A.files.encoding,disregardIgnoreFiles:typeof P.disregardIgnoreFiles=="boolean"?P.disregardIgnoreFiles:!A.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof P.disregardGlobalIgnoreFiles=="boolean"?P.disregardGlobalIgnoreFiles:!A.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof P.disregardParentIgnoreFiles=="boolean"?P.disregardParentIgnoreFiles:!A.search.useParentIgnoreFiles,ignoreSymlinks:typeof P.ignoreSymlinks=="boolean"?P.ignoreSymlinks:!A.search.followSymlinks}}};w=qe([Ve(0,t.IConfigurationService),Ve(1,l.IWorkspaceContextService),Ve(2,v.IEditorGroupsService),Ve(3,c.ILogService),Ve(4,b.IPathService)],w),e.QueryBuilder=w;function r(h){const g=h.match(/[\*\{\}\(\)\[\]\?]/);if(g){const P=g.index,M=h.substr(0,P).match(/[/|\\][^/\\]*$/);if(M){let j=h.substr(0,M.index);return j.match(/[/\\]/)||(j+="/"),{pathPortion:j,globPortion:h.substr((M.index||0)+1)}}}return{pathPortion:h}}function a(...h){return h.length?h.reduce((g,P)=>(g[P]=!0,g),Object.create(null)):void 0}function o(h){return y.splitGlobAware(h,",").map(g=>g.trim()).filter(g=>!!g.length)}function d(h){return[`**/${h}/**`,`**/${h}`].map(P=>P.replace(/\*\*\/\*\*/g,"**"))}function s(h){return h.replace(/\\/g,"/")}function u(h){return s(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function n(h,g){h=i.distinct(h,j=>j.toString());const P=[],M=g.getWorkspace();return h&&h.forEach(j=>{let Z;if(g.getWorkbenchState()===2)Z=(0,C.relativePath)(M.folders[0].uri,j),Z&&Z!=="."&&(Z="./"+Z);else{const G=g.getWorkspaceFolder(j);if(G){const A=G.name;if(M.folders.filter(F=>F.name===A).length===1){const F=(0,C.relativePath)(G.uri,j);F===""?Z=`./${G.name}`:Z=`./${G.name}/${F}`}else Z=j.fsPath}}Z&&P.push(Z)}),P}e.resolveResourcesForSearchIncludes=n}),define(ke[238],Ce([1,0,22,2,20,11,3,237,44,51]),function(ee,e,i,T,y,L,k,O,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const N=7e3;function D(t,c){const l=c.activationEvents;if(!l)return Promise.resolve(void 0);const v=[],b=[];for(const d of l)if(/^workspaceContains:/.test(d)){const s=d.substr(18);s.indexOf("*")>=0||s.indexOf("?")>=0||t.forceUsingSearch?b.push(s):v.push(s)}if(v.length===0&&b.length===0)return Promise.resolve(void 0);let E;const w=new Promise((d,s)=>{E=d}),r=d=>E({activationEvent:d}),a=Promise.all(v.map(d=>m(t,d,r))).then(()=>{}),o=p(t,c.identifier,b,r);return Promise.all([a,o]).then(()=>{E(void 0)}),w}e.checkActivateWorkspaceContainsExtension=D;async function m(t,c,l){for(const v of t.folders)if(await t.exists(i.joinPath(T.URI.revive(v),c))){l(`workspaceContains:${c}`);return}}async function p(t,c,l,v){if(l.length===0)return Promise.resolve(void 0);const b=new y.CancellationTokenSource,E=t.checkExists(t.folders,l,b.token),w=setTimeout(async()=>{b.cancel(),t.logService.info(`Not activating extension '${c.value}': Timed out while searching for 'workspaceContains' pattern ${l.join(",")}`)},N);let r=!1;try{r=await E}catch(a){L.isCancellationError(a)||L.onUnexpectedError(a)}b.dispose(),clearTimeout(w),r&&v(`workspaceContains:${l.join(",")}`)}function f(t,c,l,v){const b=t.get(k.IInstantiationService),E=t.get(S.ISearchService),r=b.createInstance(O.QueryBuilder).file(c.map(a=>(0,C.toWorkspaceFolder)(T.URI.revive(a))),{_reason:"checkExists",includePattern:l,exists:!0});return E.fileSearch(r,v).then(a=>!!a.limitHit,a=>L.isCancellationError(a)?!1:Promise.reject(a))}e.checkGlobFileExists=f});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(ke[33],Ce([1,0,135,19,79,22,14,7,46,2,12,4,32,182,77,31,26,96,11,25,24,167,6,92,3,27,78,15,64,66,59,5,238,76,169,13,75,74]),function(ee,e,i,T,y,L,k,O,S,C,N,D,m,p,f,t,c,l,v,b,E,w,r,a,o,d,s,u,n,h,g,P,M,j,Z,G,A,R){"use strict";var F,B,z;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,o.createDecorator)("IHostUtils");let V=class Mi extends O.Disposable{constructor(re,Q,le,Ee,Ae,Be,xe,Te,Ie,Se,se){super(),this.a=this.B(new P.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=Q,this.g=le,this.f=xe,this.j=Ee,this.k=Ae,this.l=Be,this.m=Ie,this.p=Se,this.s=se,this.t=this.g.getProxy(D.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(D.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(D.MainContext.MainThreadExtensionService),this.w=new k.Barrier,this.y=new k.Barrier,this.z=new k.Barrier,this.C=new k.Barrier,this.F=new l.ExtensionDescriptionRegistry(this.f.allExtensions);const ce=(0,c.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new l.ExtensionDescriptionRegistry(me(this.F,ce)),this.G=new f.ExtHostStorage(this.g,this.l),this.H=new j.ExtHostSecretState(this.g),this.I=Te,this.h=re.createChild(new n.ServiceCollection([f.IExtHostStorage,this.G],[j.IExtHostSecretState,this.H])),this.J=this.B(new p.ExtensionsActivator(this.D,this.F,{onExtensionActivationError:(Y,I,$)=>{this.v.$onExtensionActivationError(Y,v.transformErrorForSerialization(I),$)},actualActivateExtension:async(Y,I)=>{if(l.ExtensionDescriptionRegistry.isHostExtension(Y,this.D,this.F))return await this.v.$activateExtension(Y,I),new p.HostExtension;const $=this.D.getExtensionDescription(Y);return this.Y($,I)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.nb(),this.w.open(),await this.j.waitForInitializeCall(),y.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.kb()}catch(re){v.onUnexpectedError(re)}}async Q(){this.I.onWillDeactivateAll();let re=[];try{re=this.D.getAllExtensionDescriptions().map(Ae=>Ae.identifier).filter(Ae=>this.isActivated(Ae)).map(Ae=>this.X(Ae))}catch{}await Promise.all(re)}terminate(re,Q=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${re}`),this.l.flush(),this.p.dispose(),this.J.dispose(),v.setUnexpectedErrorHandler(Ee=>{this.l.error(Ee)}),this.g.dispose();const le=this.Q();Promise.race([(0,k.timeout)(5e3),le]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${Q}`):this.l.info(`Extension host exiting with code ${Q}`),this.l.flush(),this.l.dispose(),this.c.exit(Q)})}isActivated(re){return this.z.isOpen()?this.J.isActivated(re):!1}async getExtension(re){const Q=await this.v.$getExtension(re);let le;if(Q?.browserNlsBundleUris){le={};for(const Ee of Object.keys(Q.browserNlsBundleUris))le[Ee]=C.URI.revive(Q.browserNlsBundleUris[Ee])}return Q&&{...Q,identifier:new b.ExtensionIdentifier(Q.identifier.value),extensionLocation:C.URI.revive(Q.extensionLocation),browserNlsBundleUris:le}}R(re,Q){return this.J.activateByEvent(re,Q)}S(re,Q){return this.J.activateById(re,Q)}activateByIdWithErrors(re,Q){return this.S(re,Q).then(()=>{const le=this.J.getActivatedExtension(re);if(le.activationFailed)return Promise.reject(le.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(re=>this.D)}getExtensionExports(re){return this.z.isOpen()?this.J.getActivatedExtension(re).exports:null}async U(re){if(re.scheme!==G.Schemas.file)return re;const Q=await this.c.realpath(re.fsPath);return C.URI.file(Q)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(re=>new oe(re))),this.L}async W(re){const Q=S.TernarySearchTree.forUris(le=>L.extUriBiasedIgnorePathCase.ignorePathCasing(le));return await Promise.all(re.map(async le=>{if(this.ob(le)){const Ee=await this.U(le.extensionLocation);Q.set(Ee,le)}})),Q}X(re){let Q=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(re))return Q;const le=this.J.getActivatedExtension(re);if(!le)return Q;try{typeof le.module.deactivate=="function"&&(Q=Promise.resolve(le.module.deactivate()).then(void 0,Ee=>(this.l.error(Ee),Promise.resolve(void 0))))}catch(Ee){this.l.error(`An error occurred when deactivating the extension '${re.value}':`),this.l.error(Ee)}try{(0,O.dispose)(le.subscriptions)}catch(Ee){this.l.error(`An error occurred when deactivating the subscriptions for extension '${re.value}':`),this.l.error(Ee)}return Q}async Y(re,Q){return this.f.remote.isRemote?this.v.$onWillActivateExtension(re.identifier):await this.v.$onWillActivateExtension(re.identifier),this.ab(re,Q).then(le=>{const Ee=le.activationTimes;return this.v.$onDidActivateExtension(re.identifier,Ee.codeLoadingTime,Ee.activateCallTime,Ee.activateResolvedTime,Q),this.Z(re,Q,"success",Ee),le},le=>{throw this.Z(re,Q,"failure"),le})}Z(re,Q,le,Ee){const Ae=K(re,Q);this.u.$publicLog2("extensionActivationTimes",{...Ae,...Ee||{},outcome:le})}ab(re,Q){const le=K(re,Q);this.u.$publicLog2("activatePlugin",le);const Ee=this.ob(re);if(!Ee)return Promise.resolve(new p.EmptyExtension(p.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${re.identifier.value}, startup: ${Q.startup}, activationEvent: '${Q.activationEvent}'${re.identifier.value!==Q.extensionId.value?`, root cause: ${Q.extensionId.value}`:""}`),this.l.flush();const Ae=new p.ExtensionActivationTimesBuilder(Q.startup);return Promise.all([this.pb(re,(0,L.joinPath)(re.extensionLocation,Ee),Ae),this.bb(re)]).then(Be=>(y.mark(`code/extHost/willActivateExtension/${re.identifier.value}`),Mi.cb(this.l,re.identifier,Be[0],Be[1],Ae))).then(Be=>(y.mark(`code/extHost/didActivateExtension/${re.identifier.value}`),Be))}bb(re){const Q=new w.ExtensionGlobalMemento(re,this.G),le=new w.ExtensionMemento(re.identifier.value,!1,this.G),Ee=new Z.ExtensionSecrets(re,this.H),Ae=re.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,Be=this.f.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${re.identifier.value}`),Promise.all([Q.whenReady,le.whenReady,this.I.whenReady]).then(()=>{const xe=this;let Te,Ie;const Se=(0,c.isProposedApiEnabled)(re,"ipc")?this.f.messagePorts?.get(b.ExtensionIdentifier.toKey(re.identifier)):void 0;return Object.freeze({globalState:Q,workspaceState:le,secrets:Ee,subscriptions:[],get extensionUri(){return re.extensionLocation},get extensionPath(){return re.extensionLocation.fsPath},asAbsolutePath(se){return T.join(re.extensionLocation.fsPath,se)},get storagePath(){return xe.I.workspaceValue(re)?.fsPath},get globalStoragePath(){return xe.I.globalValue(re).fsPath},get logPath(){return T.join(xe.f.logsLocation.fsPath,re.identifier.value)},get logUri(){return C.URI.joinPath(xe.f.logsLocation,re.identifier.value)},get storageUri(){return xe.I.workspaceValue(re)},get globalStorageUri(){return xe.I.globalValue(re)},get extensionMode(){return Ae},get extension(){return Te===void 0&&(Te=new ie(xe,re.identifier,re,Be,!1)),Te},get extensionRuntime(){return(0,c.checkProposedApiEnabled)(re,"extensionRuntime"),xe.extensionRuntime},get environmentVariableCollection(){return xe.p.getEnvironmentVariableCollection(re)},get messagePassingProtocol(){if(!Ie){if(!Se)return;const se=P.Event.buffer(P.Event.fromDOMEventEmitter(Se,"message",ce=>ce.data));Se.start(),Ie={onDidReceiveMessage:se,postMessage:Se.postMessage.bind(Se)}}return Ie}})})}static cb(re,Q,le,Ee,Ae){return le=le||{activate:void 0,deactivate:void 0},this.db(re,Q,le,Ee,Ae).then(Be=>new p.ActivatedExtension(!1,null,Ae.build(),le,Be,Ee.subscriptions))}static db(re,Q,le,Ee,Ae){if(typeof le.activate=="function")try{Ae.activateCallStart(),re.trace(`ExtensionService#_callActivateOptional ${Q.value}`);const Be=typeof global=="object"?global:self,xe=le.activate.apply(Be,[Ee]);return Ae.activateCallStop(),Ae.activateResolveStart(),Promise.resolve(xe).then(Te=>(Ae.activateResolveStop(),Te))}catch(Be){return Promise.reject(Be)}else return Promise.resolve(le)}eb(re,Q){this.S(re.identifier,{startup:!1,extensionId:re.identifier,activationEvent:Q}).then(void 0,le=>{this.l.error(le)})}fb(){this.v.$setPerformanceMarks(y.getMarks());for(const re of this.D.getAllExtensionDescriptions())if(re.activationEvents)for(const Q of re.activationEvents)Q==="onStartupFinished"&&this.eb(re,Q)}gb(){const re=this.R("*",!0).then(void 0,Ae=>{this.l.error(Ae)});this.B(this.j.onDidChangeWorkspace(Ae=>this.hb(Ae.added)));const Q=this.j.workspace?this.j.workspace.folders:[],le=this.hb(Q),Ee=Promise.all([re,le]).then(()=>{});return Promise.race([Ee,(0,k.timeout)(1e4)]).then(()=>{this.fb()}),Ee}hb(re){return re.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(Q=>this.ib(re,Q))).then(()=>{})}async ib(re,Q){if(this.isActivated(Q.identifier))return;const le=!this.f.remote.isRemote&&!!this.f.remote.authority,Ee={logService:this.l,folders:re.map(Be=>Be.uri),forceUsingSearch:le,exists:Be=>this.c.exists(Be.fsPath),checkExists:(Be,xe,Te)=>this.t.$checkExists(Be,xe,Te)},Ae=await(0,M.checkActivateWorkspaceContainsExtension)(Ee,Q);if(!!Ae)return this.S(Q.identifier,{startup:!0,extensionId:Q.identifier,activationEvent:Ae.activationEvent}).then(void 0,Be=>this.l.error(Be))}async $extensionTestsExecute(){await this.C.wait();try{return await this.jb()}catch(re){throw console.error(re),re}}async jb(){const{extensionDevelopmentLocationURI:re,extensionTestsLocationURI:Q}=this.f.environment;if(!re||!Q)throw new Error(i.localize(0,null));const le=await this.pb(null,Q,new p.ExtensionActivationTimesBuilder(!1));if(!le||typeof le.run!="function")throw new Error(i.localize(1,null,Q.toString()));return new Promise((Ee,Ae)=>{const Be=(Ie,Se)=>{Ie?Ae(Ie):Ee(typeof Se=="number"&&Se>0?1:0)},xe=(0,L.originalFSPath)(Q),Te=le.run(xe,Be);Te&&Te.then&&Te.then(()=>{Ee(0)}).catch(Ie=>{Ae(Ie instanceof Error&&Ie.stack?Ie.stack:String(Ie))})})}kb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.gb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(re,Q){return this.M[re]=Q,(0,O.toDisposable)(()=>{delete this.M[re]})}async lb(re){const Q=re.indexOf("+");if(Q===-1)throw new Error("Not an authority that can be resolved!");const le=re.substr(0,Q);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${le}`,!1),{authorityPrefix:le,resolver:this.M[le]}}async $resolveAuthority(re,Q){const le=R.StopWatch.create(!1),Ee=()=>`[resolveAuthority(${ue(re)},${Q})][${le.elapsed()}ms] `,Ae=Se=>this.l.info(`${Ee()}${Se}`),Be=(Se,se=void 0)=>this.l.error(`${Ee()}${Se}`,se);Ae("activating resolver...");const{authorityPrefix:xe,resolver:Te}=await this.lb(re);if(!Te)return Be("no resolver"),{type:"error",error:{code:a.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${xe}.`,detail:void 0}};const Ie=new k.IntervalTimer;try{Ae("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(Te)),Ie.cancelAndSet(()=>Ae("waiting..."),1e3),Ae("invoking resolve()..."),y.mark(`code/extHost/willResolveAuthority/${xe}`);const Se=await Te.resolve(re,{resolveAttempt:Q});y.mark(`code/extHost/didResolveAuthorityOK/${xe}`),Ie.dispose(),Ae(`returned ${Se.host}:${Se.port}`);const se={authority:re,host:Se.host,port:Se.port,connectionToken:Se.connectionToken},ce={extensionHostEnv:Se.extensionHostEnv,isTrusted:Se.isTrusted,authenticationSession:Se.authenticationSessionForInitializingExtensions?{id:Se.authenticationSessionForInitializingExtensions.id,providerId:Se.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:se,options:ce,tunnelInformation:{environmentTunnels:Se.environmentTunnels,features:Se.tunnelFeatures}}}}catch(Se){if(y.mark(`code/extHost/didResolveAuthorityError/${xe}`),Ie.dispose(),Be("returned an error",Se),Se instanceof r.RemoteAuthorityResolverError)return{type:"error",error:{code:Se._code,message:Se._message,detail:Se._detail}};throw Se}}async $getCanonicalURI(re,Q){this.l.info(`$getCanonicalURI invoked for authority (${ue(re)})`);const{resolver:le}=await this.lb(re);if(!le)return null;const Ee=C.URI.revive(Q);if(typeof le.getCanonicalURI>"u")return Ee;const Ae=await(0,k.asPromise)(()=>le.getCanonicalURI(Ee));return Ae||Ee}static mb(re,Q,le){const Ee=new l.ExtensionDescriptionRegistry(re.getAllExtensionDescriptions());Ee.deltaExtensions(le.toAdd,le.toRemove);const Ae=(0,c.extensionIdentifiersArrayToSet)(Q.getAllExtensionDescriptions().map(xe=>xe.identifier));for(const xe of le.myToRemove)Ae.delete(b.ExtensionIdentifier.toKey(xe));for(const xe of le.myToAdd)Ae.add(b.ExtensionIdentifier.toKey(xe));const Be=me(Ee,Ae);return{globalRegistry:Ee,myExtensions:Be}}$startExtensionHost(re){re.toAdd.forEach(Ee=>Ee.extensionLocation=C.URI.revive(Ee.extensionLocation));const{globalRegistry:Q,myExtensions:le}=Mi.mb(this.F,this.D,re);return this.F.set(Q.getAllExtensionDescriptions()),this.D.set(le),this.kb()}$activateByEvent(re,Q){return Q===1?this.R(re,!1):this.z.wait().then(le=>this.R(re,!1))}async $activate(re,Q){return await this.z.wait(),this.D.getExtensionDescription(re)?(await this.S(re,Q),!0):!1}async $deltaExtensions(re){re.toAdd.forEach(Be=>Be.extensionLocation=C.URI.revive(Be.extensionLocation));const{globalRegistry:Q,myExtensions:le}=Mi.mb(this.F,this.D,re),Ee=await this.W(le);return(await this.getExtensionPathIndex()).setSearchTree(Ee),this.F.set(Q.getAllExtensionDescriptions()),this.D.set(le),Promise.resolve(void 0)}async $test_latency(re){return re}async $test_up(re){return re.byteLength}async $test_down(re){const Q=E.VSBuffer.alloc(re),le=Math.random()%256;for(let Ee=0;Ee<re;Ee++)Q.writeUInt8(le,Ee);return Q}async $updateRemoteConnectionData(re){this.P=re,this.a.fire()}};V=qe([Ve(0,o.IInstantiationService),Ve(1,e.IHostUtils),Ve(2,u.IExtHostRpcService),Ve(3,t.IExtHostWorkspace),Ve(4,m.IExtHostConfiguration),Ve(5,N.ILogService),Ve(6,d.IExtHostInitDataService),Ve(7,s.IExtensionStoragePaths),Ve(8,h.IExtHostTunnelService),Ve(9,g.IExtHostTerminalService),Ve(10,A.IExtHostLocalizationService)],V),e.AbstractExtHostExtensionService=V;function K(De,re){return{id:De.identifier.value,name:De.name,extensionVersion:De.version,publisherDisplayName:De.publisher,activationEvents:De.activationEvents?De.activationEvents.join(","):null,isBuiltin:De.isBuiltin,reason:re.activationEvent,reasonId:re.extensionId.value}}e.IExtHostExtensionService=(0,o.createDecorator)("IExtHostExtensionService");class ie{constructor(re,Q,le,Ee,Ae){F.set(this,void 0),B.set(this,void 0),z.set(this,void 0),Je(this,F,re,"f"),Je(this,B,Q,"f"),Je(this,z,le.identifier,"f"),this.id=le.identifier.value,this.extensionUri=le.extensionLocation,this.extensionPath=T.normalize((0,L.originalFSPath)(le.extensionLocation)),this.packageJSON=le,this.extensionKind=Ee,this.isFromDifferentExtensionHost=Ae}get isActive(){return Oe(this,F,"f").isActivated(Oe(this,z,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Oe(this,F,"f").getExtensionExports(Oe(this,z,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Oe(this,F,"f").activateByIdWithErrors(Oe(this,z,"f"),{startup:!1,extensionId:Oe(this,B,"f"),activationEvent:"api"}),this.exports}}e.Extension=ie,F=new WeakMap,B=new WeakMap,z=new WeakMap;function me(De,re){return De.getAllExtensionDescriptions().filter(Q=>re.has(b.ExtensionIdentifier.toKey(Q.identifier)))}function ue(De){const re=De.indexOf("+");return re===-1?De:De.substring(0,re)}class oe{constructor(re){this.a=re}setSearchTree(re){this.a=re}findSubstr(re){return this.a.findSubstr(re)}forEach(re){return this.a.forEach(re)}}e.ExtensionPaths=oe}),define(ke[239],Ce([1,0,79,2,4,32,26,25,15,27,3,33,49,12,10]),function(ee,e,i,T,y,L,k,O,S,C,N,D,m,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let t=class{constructor(w,r,a,o,d,s,u){this.c=w,this.d=r,this.e=a,this.f=o,this.g=d,this.h=s,this.i=u,this.a=new Map,this.b=[]}async install(){this.j(),i.mark("code/extHost/willWaitForConfig");const w=await this.f.getConfigProvider();i.mark("code/extHost/didWaitForConfig");const r=await this.g.getExtensionPathIndex();this.register(new l(this.c,r,this.d,w,this.i)),this.register(this.e.createInstance(v,r)),this.register(this.e.createInstance(c)),this.h.remote.isRemote&&this.register(this.e.createInstance(b,r,this.h.environment.appUriScheme))}register(w){if("nodeModuleName"in w)if(Array.isArray(w.nodeModuleName))for(const r of w.nodeModuleName)this.a.set(r,w);else this.a.set(w.nodeModuleName,w);typeof w.alternativeModuleName=="function"&&this.b.push(r=>w.alternativeModuleName(r))}};t=qe([Ve(2,N.IInstantiationService),Ve(3,L.IExtHostConfiguration),Ve(4,D.IExtHostExtensionService),Ve(5,C.IExtHostInitDataService),Ve(6,p.ILogService)],t),e.RequireInterceptor=t;let c=class en{constructor(w){if(w.environment.appRoot&&en.a.size){const r=(0,f.escapeRegExpCharacters)(this.c(w.environment.appRoot.fsPath)),a="[a-z0-9_.-]",o=`@${a}+\\/${a}+|${a}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${r}/${d}\\/)(${o})(.*)$`,"i")}}alternativeModuleName(w){if(!this.b)return;const r=this.b.exec(this.c(w));if(!r)return;const[,a,o,d]=r,s=en.a.get(o);if(s!==void 0)return console.warn(`${o} as been renamed to ${s}, please update your imports`),a+s+d}c(w){return w.replace(/\\/g,"/")}};c.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),c=qe([Ve(0,C.IExtHostInitDataService)],c);class l{constructor(w,r,a,o,d){this.c=w,this.d=r,this.e=a,this.f=o,this.g=d,this.nodeModuleName="vscode",this.a=new Map}load(w,r){const a=this.d.findSubstr(r);if(a){let o=this.a.get(O.ExtensionIdentifier.toKey(a.identifier));return o||(o=this.c(a,this.e,this.f),this.a.set(O.ExtensionIdentifier.toKey(a.identifier),o)),o}if(!this.b){let o="";this.d.forEach((d,s)=>o+=`	${s} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${r}. These are the extension path mappings: 
${o}`),this.b=this.c(k.nullExtensionDescription,this.e,this.f)}return this.b}}let v=class{constructor(w,r,a){this.d=w,this.nodeModuleName="keytar",this.a=r.getProxy(y.MainContext.MainThreadTelemetry);const{environment:o}=a,d=r.getProxy(y.MainContext.MainThreadKeytar);if(o.appRoot){let s=o.appRoot.fsPath;m.platform==="win32"&&(s=s.replace(/\\/g,"/")),s[s.length-1]==="/"&&(s=s.substr(0,s.length-1)),this.b=new Set,this.b.add(`${s}/node_modules.asar/keytar`),this.b.add(`${s}/node_modules/keytar`)}this.c={getPassword:(s,u)=>d.$getPassword(s,u),setPassword:(s,u,n)=>d.$setPassword(s,u,n),deletePassword:(s,u)=>d.$deletePassword(s,u),findPassword:s=>d.$findPassword(s),findCredentials(s){return d.$findCredentials(s)}}}load(w,r){const a=this.d.findSubstr(r);return this.a.$publicLog2("shimming.keytar",{extension:a?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(w){const r=w.length;if(r<=7||!this.b)return;const a=r-7;if((w.charAt(a)==="/"||w.charAt(a)==="\\")&&w.endsWith("keytar")&&(w=w.replace(/\\/g,"/"),this.b.has(w)))return"keytar"}};v=qe([Ve(1,S.IExtHostRpcService),Ve(2,C.IExtHostInitDataService)],v);let b=class{constructor(w,r,a){this.e=w,this.f=r,this.nodeModuleName=["open","opn"],this.d=a.getProxy(y.MainContext.MainThreadTelemetry);const o=a.getProxy(y.MainContext.MainThreadWindow);this.c=(d,s)=>{const u=T.URI.parse(d);return s?this.g(d,s):u.scheme==="http"||u.scheme==="https"?o.$openUri(u,d,{allowTunneling:!0}):u.scheme==="mailto"||u.scheme===this.f?o.$openUri(u,d,{}):this.g(d,s)}}load(w,r,a){const o=this.e.findSubstr(r);return o&&(this.a=o.identifier.value,this.h()),this.b=a(w),this.c}g(w,r){return this.i(),this.b(w,r)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};b=qe([Ve(2,S.IExtHostRpcService)],b)}),define(ke[106],Ce([1,0,205,7,19,49,3,56,57,33,6,31,179,32]),function(ee,e,i,T,y,L,k,O,S,C,N,D,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,k.createDecorator)("IExtHostVariableResolverProvider");class f extends m.AbstractVariableResolverService{constructor(l,v,b,E,w,r,a){function o(){if(b){const d=b.activeEditor();if(d)return d.document.uri;const s=E.tabGroups.all.find(u=>u.isActive)?.activeTab;if(s!==void 0){if(s.input instanceof N.TextDiffTabInput||s.input instanceof N.NotebookDiffEditorTabInput)return s.input.modified;if(s.input instanceof N.TextTabInput||s.input instanceof N.NotebookEditorTabInput||s.input instanceof N.CustomEditorTabInput)return s.input.uri}}}super({getFolderUri:d=>{const s=r.folders.filter(u=>u.name===d);if(s&&s.length>0)return s[0].uri},getWorkspaceFolderCount:()=>r.folders.length,getConfigurationValue:(d,s)=>w.getConfiguration(void 0,d).get(s),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const d=o();if(d)return y.normalize(d.fsPath)},getWorkspaceFolderPathForFile:()=>{if(v){const d=o();if(d){const s=v.getWorkspaceFolder(d);if(s)return y.normalize(s.uri.fsPath)}}},getSelectedText:()=>{if(b){const d=b.activeEditor();if(d&&!d.selection.isEmpty)return d.document.getText(d.selection)}},getLineNumber:()=>{if(b){const d=b.activeEditor();if(d)return String(d.selection.end.line+1)}},getExtension:d=>l.getExtension(d)},void 0,a?Promise.resolve(a):void 0,Promise.resolve(L.env))}}let t=class extends T.Disposable{constructor(l,v,b,E,w){super(),this.b=l,this.c=v,this.g=b,this.h=E,this.i=w,this.a=new i.Lazy(async()=>{const r=await this.h.getConfigProvider(),o={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async d=>{o.folders=await this.c.getWorkspaceFolders2()||[]})),new f(this.b,this.c,this.g,this.i,r,o,this.j())})}getResolver(){return this.a.getValue()}j(){}};t=qe([Ve(0,C.IExtHostExtensionService),Ve(1,D.IExtHostWorkspace),Ve(2,O.IExtHostDocumentsAndEditors),Ve(3,p.IExtHostConfiguration),Ve(4,S.IExtHostEditorTabs)],t),e.ExtHostVariableResolverProviderService=t}),define(ke[107],Ce([1,0,14,5,9,2,3,4,57,33,15,6,31,171,173,32,106]),function(ee,e,i,T,y,L,k,O,S,C,N,D,m,p,f,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,k.createDecorator)("IExtHostDebugService");let l=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(o,d,s,u,n,h){this.D=d,this.E=s,this.F=u,this.G=n,this.H=h,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new T.Emitter,this.n=new T.Emitter,this.o=new T.Emitter,this.u=new T.Emitter,this.k=o.getProxy(O.MainContext.MainThreadDebugService),this.z=new T.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new b(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(g=>{g.onDidChange(P=>{this.I(g)}),this.I(g)})}asDebugSourceUri(o,d){const s=o;if(typeof s.sourceReference=="number"&&s.sourceReference>0){let u=`debug:${encodeURIComponent(s.path||"")}`,n="?";return d&&(u+=`${n}session=${encodeURIComponent(d.id)}`,n="&"),u+=`${n}ref=${s.sourceReference}`,L.URI.parse(u)}else{if(s.path)return L.URI.file(s.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(o){const d=[];for(const s of o.getAllExtensionDescriptions())if(s.contributes){const u=s.contributes.debuggers;if(u&&u.length>0)for(const n of u)(0,f.isDebuggerMainContribution)(n)&&d.push(n.type)}this.k.$registerDebugTypes(d)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const o=[];return this.w.forEach(d=>o.push(d)),o}addBreakpoints(o){this.T();const d=o.filter(n=>{const h=n.id;return this.w.has(h)?!1:(this.w.set(h,n),!0)});this.U(d,[],[]);const s=[],u=new Map;for(const n of d)if(n instanceof D.SourceBreakpoint){let h=u.get(n.location.uri.toString());h||(h={type:"sourceMulti",uri:n.location.uri,lines:[]},u.set(n.location.uri.toString(),h),s.push(h)),h.lines.push({id:n.id,enabled:n.enabled,condition:n.condition,hitCondition:n.hitCondition,logMessage:n.logMessage,line:n.location.range.start.line,character:n.location.range.start.character})}else n instanceof D.FunctionBreakpoint&&s.push({type:"function",id:n.id,enabled:n.enabled,hitCondition:n.hitCondition,logMessage:n.logMessage,condition:n.condition,functionName:n.functionName});return this.k.$registerBreakpoints(s)}removeBreakpoints(o){this.T();const d=o.filter(h=>this.w.delete(h.id));this.U([],d,[]);const s=d.filter(h=>h instanceof D.SourceBreakpoint).map(h=>h.id),u=d.filter(h=>h instanceof D.FunctionBreakpoint).map(h=>h.id),n=d.filter(h=>h instanceof D.DataBreakpoint).map(h=>h.id);return this.k.$unregisterBreakpoints(s,u,n)}startDebugging(o,d,s){return this.k.$startDebugging(o?o.uri:void 0,d,{parentSessionID:s.parentSession?s.parentSession.id:void 0,lifecycleManagedByParent:s.lifecycleManagedByParent,repl:s.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:s.noDebug,compact:s.compact,suppressSaveBeforeStart:s.suppressSaveBeforeStart,suppressDebugStatusbar:s.suppressDebugStatusbar??s.debugUI?.simple,suppressDebugToolbar:s.suppressDebugToolbar??s.debugUI?.simple,suppressDebugView:s.suppressDebugView??s.debugUI?.simple})}stopDebugging(o){return this.k.$stopDebugging(o?o.id:void 0)}registerDebugConfigurationProvider(o,d,s){if(!d)return new D.Disposable(()=>{});const u=this.d++;return this.f.push({type:o,handle:u,provider:d}),this.k.$registerDebugConfigurationProvider(o,s,!!d.provideDebugConfigurations,!!d.resolveDebugConfiguration,!!d.resolveDebugConfigurationWithSubstitutedVariables,u),new D.Disposable(()=>{this.f=this.f.filter(n=>n.provider!==d),this.k.$unregisterDebugConfigurationProvider(u)})}registerDebugAdapterDescriptorFactory(o,d,s){if(!s)return new D.Disposable(()=>{});if(!this.P(o,d))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${d}' debugger.`);if(this.M(d))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const u=this.g++;return this.h.push({type:d,handle:u,factory:s}),this.k.$registerDebugAdapterDescriptorFactory(d,u),new D.Disposable(()=>{this.h=this.h.filter(n=>n.factory!==s),this.k.$unregisterDebugAdapterDescriptorFactory(u)})}registerDebugAdapterTrackerFactory(o,d){if(!d)return new D.Disposable(()=>{});const s=this.i++;return this.j.push({type:o,handle:s,factory:d}),new D.Disposable(()=>{this.j=this.j.filter(u=>u.factory!==d)})}async $runInTerminal(o,d){return Promise.resolve(void 0)}async $substituteVariables(o,d){let s;const u=await this.W(o);return u&&(s={uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(s,d)}J(o,d){if(o.type==="implementation")return new w(o.implementation)}K(){}async $startDASession(o,d){const s=this,u=await this.V(d);return this.R(this.M(u.type),u).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}' (extension might have failed to activate)`);const h=this.L(n),g=this.J(h,u);if(!g)throw new Error(`Couldn't create a debug adapter for type '${u.type}'.`);const P=g;return this.A.set(o,P),this.Q(u).then(M=>(M&&this.B.set(o,M),P.onMessage(async j=>{if(j.type==="request"&&j.command==="handshake"){const Z=j,G={type:"response",seq:0,command:Z.command,request_seq:Z.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const A=await this.C.sign(Z.arguments.value);G.body={signature:A},P.sendResponse(G)}else throw new Error("no signer")}catch(A){G.success=!1,G.message=A.message,P.sendResponse(G)}}else M&&M.onDidSendMessage&&M.onDidSendMessage(j),j=(0,f.convertToVSCPaths)(j,!0),s.k.$acceptDAMessage(o,j)}),P.onError(j=>{M&&M.onError&&M.onError(j),this.k.$acceptDAError(o,j.name,j.message,j.stack)}),P.onExit(j=>{M&&M.onExit&&M.onExit((0,y.withNullAsUndefined)(j),void 0),this.k.$acceptDAExit(o,(0,y.withNullAsUndefined)(j),void 0)}),M&&M.onWillStartSession&&M.onWillStartSession(),P.startSession()))})}$sendDAMessage(o,d){d=(0,f.convertToDAPaths)(d,!1);const s=this.B.get(o);s&&s.onWillReceiveMessage&&s.onWillReceiveMessage(d),this.A.get(o)?.sendMessage(d)}$stopDASession(o){const d=this.B.get(o);this.B.delete(o),d&&d.onWillStopSession&&d.onWillStopSession();const s=this.A.get(o);return this.A.delete(o),s?s.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(o){const d=[],s=[],u=[];if(o.added)for(const n of o.added){const h=n.id;if(h&&!this.w.has(h)){let g;if(n.type==="function")g=new D.FunctionBreakpoint(n.functionName,n.enabled,n.condition,n.hitCondition,n.logMessage);else if(n.type==="data")g=new D.DataBreakpoint(n.label,n.dataId,n.canPersist,n.enabled,n.hitCondition,n.condition,n.logMessage);else{const P=L.URI.revive(n.uri);g=new D.SourceBreakpoint(new D.Location(P,new D.Position(n.line,n.character)),n.enabled,n.condition,n.hitCondition,n.logMessage)}g._id=h,this.w.set(h,g),d.push(g)}}if(o.removed)for(const n of o.removed){const h=this.w.get(n);h&&(this.w.delete(n),s.push(h))}if(o.changed){for(const n of o.changed)if(n.id){const h=this.w.get(n.id);if(h){if(h instanceof D.FunctionBreakpoint&&n.type==="function"){const g=h;g.enabled=n.enabled,g.condition=n.condition,g.hitCondition=n.hitCondition,g.logMessage=n.logMessage,g.functionName=n.functionName}else if(h instanceof D.SourceBreakpoint&&n.type==="source"){const g=h;g.enabled=n.enabled,g.condition=n.condition,g.hitCondition=n.hitCondition,g.logMessage=n.logMessage,g.location=new D.Location(L.URI.revive(n.uri),new D.Position(n.line,n.character))}u.push(h)}}}this.U(d,s,u)}$provideDebugConfigurations(o,d,s){return(0,i.asPromise)(async()=>{const u=this.O(o);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const n=await this.W(d);return u.provideDebugConfigurations(n,s)}).then(u=>{if(!u)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return u})}$resolveDebugConfiguration(o,d,s,u){return(0,i.asPromise)(async()=>{const n=this.O(o);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const h=await this.W(d);return n.resolveDebugConfiguration(h,s,u)})}$resolveDebugConfigurationWithSubstitutedVariables(o,d,s,u){return(0,i.asPromise)(async()=>{const n=this.O(o);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const h=await this.W(d);return n.resolveDebugConfigurationWithSubstitutedVariables(h,s,u)})}async $provideDebugAdapter(o,d){const s=this.N(o);if(!s)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const u=await this.V(d);return this.R(s,u).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}'`);return this.L(n)})}async $acceptDebugSessionStarted(o){const d=await this.V(o);this.m.fire(d)}async $acceptDebugSessionTerminated(o){const d=await this.V(o);d&&(this.n.fire(d),this.l.delete(d.id))}async $acceptDebugSessionActiveChanged(o){this.q=o?await this.V(o):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(o,d){(await this.V(o))?._acceptNameChanged(d)}async $acceptDebugSessionCustomEvent(o,d){const u={session:await this.V(o),event:d.event,body:d.body};this.u.fire(u)}L(o){if(o instanceof D.DebugAdapterExecutable)return{type:"executable",command:o.command,args:o.args,options:o.options};if(o instanceof D.DebugAdapterServer)return{type:"server",port:o.port,host:o.host};if(o instanceof D.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:o.path};if(o instanceof D.DebugAdapterInlineImplementation)return{type:"implementation",implementation:o.implementation};throw new Error("convertToDto unexpected type")}M(o){const d=this.h.filter(s=>s.type===o);if(d.length>0)return d[0].factory}N(o){const d=this.h.filter(s=>s.handle===o);if(d.length>0)return d[0].factory}O(o){const d=this.f.filter(s=>s.handle===o);if(d.length>0)return d[0].provider}P(o,d){if(o.contributes){const s=o.contributes.debuggers;if(s&&s.length>0){for(const u of s)if(u.label&&u.type&&u.type===d)return!0}}return!1}Q(o){const s=o.configuration.type,u=this.j.filter(n=>n.type===s||n.type==="*").map(n=>(0,i.asPromise)(()=>n.factory.createDebugAdapterTracker(o)).then(h=>h,h=>null));return Promise.race([Promise.all(u).then(n=>{const h=n.filter(g=>!!g);if(h.length>0)return new E(h)}),new Promise(n=>setTimeout(()=>n(void 0),1e3))]).catch(n=>{})}async R(o,d){const s=d.configuration.debugServer;if(typeof s=="number")return Promise.resolve(new D.DebugAdapterServer(s));if(o){const n=await this.E.getExtensionRegistry();return(0,i.asPromise)(()=>o.createDebugAdapterDescriptor(d,this.S(d,n))).then(h=>{if(h)return h})}const u=await this.E.getExtensionRegistry();return Promise.resolve(this.S(d,u))}S(o,d){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(o,d,s){(o.length>0||d.length>0||s.length>0)&&this.z.fire(Object.freeze({added:o,removed:d,changed:s}))}async V(o){if(o)if(typeof o=="string"){const d=this.l.get(o);if(d)return d}else{let d=this.l.get(o.id);if(!d){const s=await this.W(o.folderUri),u=o.parent?this.l.get(o.parent):void 0;d=new v(this.k,o.id,o.type,o.name,s,o.configuration,u),this.l.set(d.id,d),this.k.$sessionCached(d.id)}return d}throw new Error("cannot find session")}W(o){if(o){const d=L.URI.revive(o);return this.D.resolveWorkspaceFolder(d)}return Promise.resolve(void 0)}};l=qe([Ve(0,N.IExtHostRpcService),Ve(1,m.IExtHostWorkspace),Ve(2,C.IExtHostExtensionService),Ve(3,t.IExtHostConfiguration),Ve(4,S.IExtHostEditorTabs),Ve(5,c.IExtHostVariableResolverProvider)],l),e.ExtHostDebugServiceBase=l;class v{constructor(o,d,s,u,n,h,g){this.d=o,this.f=d,this.g=s,this.h=u,this.i=n,this.j=h,this.k=g}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(o){this.h=o,this.d.$setDebugSessionName(this.f,o)}get parentSession(){return this.k}_acceptNameChanged(o){this.h=o}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(o,d){return this.d.$customDebugAdapterRequest(this.f,o,d)}getDebugProtocolBreakpoint(o){return this.d.$getDebugProtocolBreakpoint(this.f,o.id)}}e.ExtHostDebugSession=v;class b{constructor(o){this.value=Object.freeze({append(d){o.$appendDebugConsole(d)},appendLine(d){this.append(d+`
`)}})}}e.ExtHostDebugConsole=b;class E{constructor(o){this.d=o}onWillStartSession(){this.d.forEach(o=>o.onWillStartSession?o.onWillStartSession():void 0)}onWillReceiveMessage(o){this.d.forEach(d=>d.onWillReceiveMessage?d.onWillReceiveMessage(o):void 0)}onDidSendMessage(o){this.d.forEach(d=>d.onDidSendMessage?d.onDidSendMessage(o):void 0)}onWillStopSession(){this.d.forEach(o=>o.onWillStopSession?o.onWillStopSession():void 0)}onError(o){this.d.forEach(d=>d.onError?d.onError(o):void 0)}onExit(o,d){this.d.forEach(s=>s.onExit?s.onExit(o,d):void 0)}}class w extends p.AbstractDebugAdapter{constructor(o){super(),this.h=o,o.onDidSendMessage(d=>{this.acceptMessage(d)})}startSession(){return Promise.resolve(void 0)}sendMessage(o){this.h.handleMessage(o)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let r=class extends l{constructor(o,d,s,u,n,h){super(o,d,s,u,n,h)}};r=qe([Ve(0,N.IExtHostRpcService),Ve(1,m.IExtHostWorkspace),Ve(2,C.IExtHostExtensionService),Ve(3,t.IExtHostConfiguration),Ve(4,S.IExtHostEditorTabs),Ve(5,c.IExtHostVariableResolverProvider)],r),e.WorkerExtHostDebugService=r}),define(ke[240],Ce([1,0,11,79,2,4,231,12,63,64,27,153,15,53,33,71]),function(ee,e,i,T,y,L,k,O,S,C,N,D,m,p,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class c{static async installEarlyHandler(b){const E=b.get(O.ILogService),r=b.get(m.IExtHostRpcService).getProxy(L.MainContext.MainThreadErrors);i.setUnexpectedErrorHandler(a=>{E.error(a);const o=i.transformErrorForSerialization(a);r.$onUnexpectedError(o)})}static async installFullHandler(b){const E=b.get(O.ILogService),w=b.get(m.IExtHostRpcService),r=b.get(f.IExtHostExtensionService),a=b.get(t.IExtHostTelemetry),o=w.getProxy(L.MainContext.MainThreadExtensionService),d=w.getProxy(L.MainContext.MainThreadErrors),s=await r.getExtensionPathIndex(),u=new WeakMap;Error.prepareStackTrace=(n,h)=>{let g="",P,M;for(const j of h)g+=`
	at ${j.toString()}`,M=j.getFileName(),!P&&M&&(P=s.findSubstr(y.URI.file(M)));return u.set(n,P?.identifier),`${n.name||"Error"}: ${n.message||""}${g}`},i.setUnexpectedErrorHandler(n=>{E.error(n);const h=i.transformErrorForSerialization(n),g=u.get(n);if(!g){d.$onUnexpectedError(h);return}o.$onExtensionRuntimeError(g,h);const P=a.onExtensionError(g,n);E.trace("forwarded error to extension?",P,g)})}}Error.stackTraceLimit=100;class l{constructor(b,E,w,r,a){this.a=w,this.b=new k.RPCProtocol(b,null,r),E=l.e(E,this.b);const o=new C.ServiceCollection(...(0,S.getSingletonServiceDescriptors)());o.set(N.IExtHostInitDataService,{_serviceBrand:void 0,...E,messagePorts:a}),o.set(m.IExtHostRpcService,new m.ExtHostRpcService(this.b)),o.set(p.IURITransformerService,new p.URITransformerService(r)),o.set(f.IHostUtils,w);const d=new D.InstantiationService(o,!0);d.invokeFunction(c.installEarlyHandler),this.d=d.invokeFunction(s=>s.get(O.ILogService)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",E),this.c=d.invokeFunction(s=>s.get(f.IExtHostExtensionService)),this.c.initialize(),d.invokeFunction(c.installFullHandler)}async asBrowserUri(b){const E=this.b.getProxy(L.MainContext.MainThreadExtensionService);return y.URI.revive(await E.$asBrowserUri(b))}terminate(b){this.c.terminate(b)}static e(b,E){b.allExtensions.forEach(r=>{r.extensionLocation=y.URI.revive(E.transformIncomingURIs(r.extensionLocation));const a={};r.browserNlsBundleUris&&(Object.keys(r.browserNlsBundleUris).forEach(o=>a[o]=y.URI.revive(E.transformIncomingURIs(r.browserNlsBundleUris[o]))),r.browserNlsBundleUris=a)}),b.environment.appRoot=y.URI.revive(E.transformIncomingURIs(b.environment.appRoot));const w=b.environment.extensionDevelopmentLocationURI;return w&&(b.environment.extensionDevelopmentLocationURI=w.map(r=>y.URI.revive(E.transformIncomingURIs(r)))),b.environment.extensionTestsLocationURI=y.URI.revive(E.transformIncomingURIs(b.environment.extensionTestsLocationURI)),b.environment.globalStorageHome=y.URI.revive(E.transformIncomingURIs(b.environment.globalStorageHome)),b.environment.workspaceStorageHome=y.URI.revive(E.transformIncomingURIs(b.environment.workspaceStorageHome)),b.environment.extensionTelemetryLogResource=y.URI.revive(E.transformIncomingURIs(b.environment.extensionTelemetryLogResource)),b.nlsBaseUrl=y.URI.revive(E.transformIncomingURIs(b.nlsBaseUrl)),b.logsLocation=y.URI.revive(E.transformIncomingURIs(b.logsLocation)),b.logFile=y.URI.revive(E.transformIncomingURIs(b.logFile)),b.workspace=E.transformIncomingURIs(b.workspace),b}}e.ExtensionHostMain=l}),define(ke[241],Ce([1,0,16,14,20,45,13,19,22,2,44]),function(ee,e,i,T,y,L,k,O,S,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class D{constructor(v,b,E,w){this.d=v,this.e=b,this.f=E,this.g=w,this.a=null,this.b=!1,this.c=0}search(v,b){const E=this.d.folderQueries||[],w=new y.CancellationTokenSource;return b.onCancellationRequested(()=>w.cancel()),new Promise((r,a)=>{this.a=new p(v);let o=!1;const d=(s,u)=>{if(!o&&!this.b){const n=this.h(s);t(s)&&typeof this.d.maxResults=="number"&&this.c+n>this.d.maxResults&&(this.b=!0,o=!0,w.cancel(),s=this.j(s,this.d.maxResults-this.c));const h=this.h(s);this.c+=h,(h>0||!t(s))&&this.a.add(s,u)}};Promise.all(E.map((s,u)=>this.k(s,n=>d(n,u),w.token))).then(s=>{w.dispose(),this.a.flush();const u=s.some(n=>!!n&&!!n.limitHit);r({limitHit:this.b||u,messages:(0,i.flatten)(s.map(n=>n?.message?Array.isArray(n.message)?n.message:[n.message]:[])),stats:{type:this.g}})},s=>{w.dispose();const u=(0,L.toErrorMessage)(s);a(new Error(u))})})}h(v){return t(v)?Array.isArray(v.ranges)?v.ranges.length:1:0}j(v,b){const E=Array.isArray(v.ranges)?v.ranges:[v.ranges],w=Array.isArray(v.preview.matches)?v.preview.matches:[v.preview.matches];return{ranges:E.slice(0,b),preview:{matches:w.slice(0,b),text:v.preview.text},uri:v.uri}}async k(v,b,E){const w=new N.QueryGlobTester(this.d,v),r=[],a={report:s=>{if(!this.l(s))return;const u=v.folder.scheme===k.Schemas.file?(0,N.hasSiblingPromiseFn)(()=>this.f.readdir(S.dirname(s.uri))):void 0,n=S.relativePath(v.folder,s.uri);if(n){const h=w.includedInQuery(n,O.basename(n),u);(0,T.isThenable)(h)?r.push(h.then(g=>{g&&b(s)})):h&&b(s)}}},o=this.n(v),d=await this.e.provideTextSearchResults(m(this.d.contentPattern),o,a,E);return r.length&&await Promise.all(r),d}l(v){if(t(v)){if(Array.isArray(v.ranges)){if(!Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(v.preview.matches.length!==v.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(v){const b=(0,N.resolvePatternsForProvider)(this.d.includePattern,v.includePattern),E=(0,N.resolvePatternsForProvider)(this.d.excludePattern,v.excludePattern),w={folder:C.URI.from(v.folder),excludes:E,includes:b,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,encoding:v.fileEncoding&&this.f.toCanonicalName(v.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return w.usePCRE2=this.d.usePCRE2,w}}e.TextSearchManager=D;function m(l){return{isCaseSensitive:l.isCaseSensitive||!1,isRegExp:l.isRegExp||!1,isWordMatch:l.isWordMatch||!1,isMultiline:l.isMultiline||!1,pattern:l.pattern}}class p{constructor(v){this.e=v,this.b=-1,this.d=null,this.a=new c(512,b=>this.g(b))}add(v,b){this.d&&(this.b!==b||!S.isEqual(this.c,v.uri))&&(this.f(),this.d=null),this.d||(this.b=b,this.d={resource:v.uri,results:[]}),this.d.results.push(f(v))}f(){const v=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,v)}flush(){this.f(),this.a.flush()}g(v){this.e(v)}}e.TextSearchResultsCollector=p;function f(l){return t(l)?{preview:{matches:(0,i.mapArrayOrNot)(l.preview.matches,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character})),text:l.preview.text},ranges:(0,i.mapArrayOrNot)(l.ranges,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character}))}:{text:l.text,lineNumber:l.lineNumber}}function t(l){return!!l.preview}e.extensionResultIsMatch=t;class c{constructor(v,b){this.g=v,this.h=b,this.c=0,this.d=[],this.e=0}addItem(v,b){!v||this.j(v,b)}addItems(v,b){!v||this.k(v,b)}j(v,b){this.d.push(v),this.e+=b,this.l()}k(v,b){this.d=this.d.concat(v),this.e+=b,this.l()}l(){this.c<c.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},c.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.BatchedCollector=c,c.a=4e3,c.b=50}),define(ke[108],Ce([1,0,7,4,3,236,15,53,12,2,241]),function(ee,e,i,T,y,L,k,O,S,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,y.createDecorator)("IExtHostSearch");let D=class{constructor(t,c,l){this.k=t,this.l=c,this.n=l,this.c=this.k.getProxy(T.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.FileSearchManager}o(t){return this.l.transformOutgoingScheme(t)}registerTextSearchProvider(t,c){if(this.g.has(t))throw new Error(`a text search provider for the scheme '${t}' is already registered`);this.g.add(t);const l=this.d++;return this.e.set(l,c),this.c.$registerTextSearchProvider(l,this.o(t)),(0,i.toDisposable)(()=>{this.g.delete(t),this.e.delete(l),this.c.$unregisterProvider(l)})}registerFileSearchProvider(t,c){if(this.i.has(t))throw new Error(`a file search provider for the scheme '${t}' is already registered`);this.i.add(t);const l=this.d++;return this.h.set(l,c),this.c.$registerFileSearchProvider(l,this.o(t)),(0,i.toDisposable)(()=>{this.i.delete(t),this.h.delete(l),this.c.$unregisterProvider(l)})}$provideFileSearchResults(t,c,l,v){const b=m(l),E=this.h.get(t);if(E)return this.j.fileSearch(b,E,w=>{this.c.$handleFileMatch(t,c,w.map(r=>r.resource))},v);throw new Error("unknown provider: "+t)}$clearCache(t){return this.j.clearCache(t),Promise.resolve(void 0)}$provideTextSearchResults(t,c,l,v){const b=this.e.get(t);if(!b||!b.provideTextSearchResults)throw new Error(`Unknown provider ${t}`);const E=m(l);return this.q(E,b).search(r=>this.c.$handleTextMatch(t,c,r),v)}$enableExtensionHostSearch(){}q(t,c){return new N.TextSearchManager(t,c,{readdir:l=>Promise.resolve([]),toCanonicalName:l=>l},"textSearchProvider")}};D=qe([Ve(0,k.IExtHostRpcService),Ve(1,O.IURITransformerService),Ve(2,S.ILogService)],D),e.ExtHostSearch=D;function m(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(p),extraFileResources:f.extraFileResources&&f.extraFileResources.map(t=>C.URI.revive(t))}}e.reviveQuery=m;function p(f){return{...f,folder:C.URI.revive(f.folder)}}}),define(ke[242],Ce([1,0,63,103,31,101,32,38,56,59,105,107,108,77,66,73,102,58,37,76,71,57,212,12,183,106,75]),function(ee,e,i,T,y,L,k,O,S,C,N,D,m,p,f,t,c,l,v,b,E,w,r,a,o,d,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,i.registerSingleton)(s.IExtHostLocalizationService,s.ExtHostLocalizationService,1),(0,i.registerSingleton)(a.ILoggerService,r.ExtHostLoggerService,1),(0,i.registerSingleton)(a.ILogService,o.ExtHostLogService,1),(0,i.registerSingleton)(t.IExtHostApiDeprecationService,t.ExtHostApiDeprecationService,1),(0,i.registerSingleton)(O.IExtHostCommands,O.ExtHostCommands,0),(0,i.registerSingleton)(k.IExtHostConfiguration,k.ExtHostConfiguration,0),(0,i.registerSingleton)(l.IExtHostConsumerFileSystem,l.ExtHostConsumerFileSystem,0),(0,i.registerSingleton)(D.IExtHostDebugService,D.WorkerExtHostDebugService,0),(0,i.registerSingleton)(L.IExtHostDecorations,L.ExtHostDecorations,0),(0,i.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors,0),(0,i.registerSingleton)(v.IExtHostFileSystemInfo,v.ExtHostFileSystemInfo,0),(0,i.registerSingleton)(T.IExtHostOutputService,T.ExtHostOutputService,1),(0,i.registerSingleton)(m.IExtHostSearch,m.ExtHostSearch,0),(0,i.registerSingleton)(p.IExtHostStorage,p.ExtHostStorage,0),(0,i.registerSingleton)(N.IExtHostTask,N.WorkerExtHostTask,0),(0,i.registerSingleton)(C.IExtHostTerminalService,C.WorkerExtHostTerminalService,0),(0,i.registerSingleton)(f.IExtHostTunnelService,f.ExtHostTunnelService,0),(0,i.registerSingleton)(c.IExtHostWindow,c.ExtHostWindow,0),(0,i.registerSingleton)(y.IExtHostWorkspace,y.ExtHostWorkspace,0),(0,i.registerSingleton)(b.IExtHostSecretState,b.ExtHostSecretState,0),(0,i.registerSingleton)(E.IExtHostTelemetry,E.ExtHostTelemetry,0),(0,i.registerSingleton)(w.IExtHostEditorTabs,w.ExtHostEditorTabs,0),(0,i.registerSingleton)(d.IExtHostVariableResolverProvider,d.ExtHostVariableResolverProviderService,0)}),define(ke[243],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class i{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(y){if(y&&this.a.has(y)){const L=this.a.get(y);return this.a.delete(y),L}}addDragOperationTransfer(y,L){this.a.set(y,L)}getRenderedTreeElement(y){if(this.b.has(y))return this.b.get(y)}addRenderedTreeItemElement(y,L){this.b.set(y,L)}removeRenderedTreeItemElement(y){this.b.has(y)&&this.b.delete(y)}}e.TreeviewsService=i}),define(ke[244],Ce([1,0,139,6,22,2,5,7,14,6,9,16,8,20,243,26]),function(ee,e,i,T,y,L,k,O,S,C,N,D,m,p,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function c(b,E){if((0,N.isString)(b))return{label:b};if(b&&typeof b=="object"&&typeof b.label=="string"){let w;return Array.isArray(b.highlights)&&(w=b.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),w=w.length?w:void 0),{label:b.label,highlights:w}}}class l{constructor(E,w,r){this.d=E,this.e=w,this.f=r,this.a=new Map,this.b=new f.TreeviewsService;function a(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}w.registerArgumentProcessor({processArgument:o=>a(o)?this.i(o):Array.isArray(o)&&o.length>0?o.map(d=>a(d)?this.i(d):d):o})}registerTreeDataProvider(E,w,r){const a=this.createTreeView(E,{treeDataProvider:w},r);return{dispose:()=>a.dispose()}}createTreeView(E,w,r){if(!w||!w.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=w.dragAndDropController?.dropMimeTypes??[],o=w.dragAndDropController?.dragMimeTypes??[],d=!!w.dragAndDropController?.handleDrag,s=!!w.dragAndDropController?.handleDrop,u=this.h(E,w,r),n=this.d.$registerTreeViewDataProvider(E,{showCollapseAll:!!w.showCollapseAll,canSelectMany:!!w.canSelectMany,dropMimeTypes:a,dragMimeTypes:o,hasHandleDrag:d,hasHandleDrop:s});return{get onDidCollapseElement(){return u.onDidCollapseElement},get onDidExpandElement(){return u.onDidExpandElement},get selection(){return u.selectedElements},get onDidChangeSelection(){return u.onDidChangeSelection},get visible(){return u.visible},get onDidChangeVisibility(){return u.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,t.checkProposedApiEnabled)(r,"treeItemCheckbox"),u.onDidChangeCheckboxState},get message(){return u.message},set message(h){u.message=h},get title(){return u.title},set title(h){u.title=h},get description(){return u.description},set description(h){u.description=h},get badge(){return u.badge},set badge(h){h!==void 0&&C.ViewBadge.isViewBadge(h)?u.badge={value:Math.floor(Math.abs(h.value)),tooltip:h.tooltip}:h===void 0&&(u.badge=void 0)},reveal:(h,g)=>u.reveal(h,g),dispose:async()=>{await n,this.a.delete(E),u.dispose()}}}$getChildren(E,w){const r=this.a.get(E);return r?r.getChildren(w):Promise.reject(new Error((0,i.localize)(0,null,E)))}async $handleDrop(E,w,r,a,o,d,s,u){const n=this.a.get(E);if(!n)return Promise.reject(new Error((0,i.localize)(1,null,E)));const h=m.DataTransfer.toDataTransfer(r,async g=>(await this.d.$resolveDropFileData(E,w,g)).buffer);return s===E&&u&&await this.g(h,n,u,o,d),n.onDrop(h,a,o)}async g(E,w,r,a,o){const d=this.b.removeDragOperationTransfer(o);if(d)(await d)?.forEach((s,u)=>{s&&E.set(u,s)});else if(o&&w.handleDrag){const s=w.handleDrag(r,E,a);this.b.addDragOperationTransfer(o,s),await s}return E}async $handleDrag(E,w,r,a){const o=this.a.get(E);if(!o)return Promise.reject(new Error((0,i.localize)(2,null,E)));const d=await this.g(new T.DataTransfer,o,w,a,r);if(!!d)return m.DataTransfer.toDataTransferDTO(d)}async $hasResolve(E){const w=this.a.get(E);if(!w)throw new Error((0,i.localize)(3,null,E));return w.hasResolve}$resolve(E,w,r){const a=this.a.get(E);if(!a)throw new Error((0,i.localize)(4,null,E));return a.resolveTreeItem(w,r)}$setExpanded(E,w,r){const a=this.a.get(E);if(!a)throw new Error((0,i.localize)(5,null,E));a.setExpanded(w,r)}$setSelection(E,w){const r=this.a.get(E);if(!r)throw new Error((0,i.localize)(6,null,E));r.setSelection(w)}$setFocus(E,w){const r=this.a.get(E);if(!r)throw new Error((0,i.localize)(7,null,E));r.setFocus(w)}$setVisible(E,w){const r=this.a.get(E);if(!r)throw new Error((0,i.localize)(8,null,E));r.setVisible(w)}$changeCheckboxState(E,w){const r=this.a.get(E);if(!r)throw new Error((0,i.localize)(9,null,E));r.setCheckboxState(w)}h(E,w,r){const a=new v(E,w,this.d,this.e.converter,this.f,r);return this.a.set(E,a),a}i(E){const w=this.a.get(E.$treeViewId);return w&&"$treeItemHandle"in E?w.getExtensionElement(E.$treeItemHandle):w&&"$focusedTreeItem"in E&&E.$focusedTreeItem?w.focusedElement:null}}e.ExtHostTreeViews=l;class v extends O.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(E=>this.getExtensionElement(E)).filter(E=>!(0,N.isUndefinedOrNull)(E))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(E,w,r,a,o,d){if(super(),this.C=E,this.D=r,this.F=a,this.G=o,this.H=d,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new k.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new k.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new k.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new k.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new k.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new k.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new p.CancellationTokenSource,d.contributes&&d.contributes.views)for(const n in d.contributes.views)for(const h of d.contributes.views[n])h.id===E&&(this.J=h.name);this.f=w.treeDataProvider,this.g=w.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(n=>this.w.fire({message:!1,element:n})));let s,u;this.B(k.Event.debounce(this.w.event,(n,h)=>(n||(n={message:!1,elements:[]}),h.element!==!1&&(s||(s=new Promise(g=>u=g),this.y=this.y.then(()=>s)),Array.isArray(h.element)?n.elements.push(...h.element):n.elements.push(h.element)),h.message&&(n.message=!0),n),200,!0)(({message:n,elements:h})=>{h.length&&(this.z=this.z.then(()=>{const g=u;return s=null,this.U(h).then(()=>g())})),n&&this.D.$setMessage(this.C,this.I)}))}async getChildren(E){const w=E?this.getExtensionElement(E):void 0;if(E&&!w)return this.G.error(`No tree item with id '${E}' found.`),Promise.resolve([]);let r=this.Q(E);return r||(r=await this.R(w)),r?r.map(a=>a.item):void 0}getExtensionElement(E){return this.i.get(E)}reveal(E,w){w=w||{select:!0,focus:!1};const r=(0,N.isUndefinedOrNull)(w.select)?!0:w.select,a=(0,N.isUndefinedOrNull)(w.focus)?!1:w.focus,o=(0,N.isUndefinedOrNull)(w.expand)?!1:w.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):E?this.y.then(()=>this.N(E)).then(d=>this.P(E,d[d.length-1]).then(s=>this.D.$reveal(this.C,{item:s.item,parentChain:d.map(u=>u.item)},{select:r,focus:a,expand:o})),d=>this.G.error(d)):this.D.$reveal(this.C,void 0,{select:r,focus:a,expand:o})}get message(){return this.I}set message(E){this.I=E,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(E){this.J=E,this.D.$setTitle(this.C,E,this.L)}get description(){return this.L}set description(E){this.L=E,this.D.$setTitle(this.C,this.J,E)}get badge(){return this.M}set badge(E){this.M?.value===E?.value&&this.M?.tooltip===E?.tooltip||(this.M=m.ViewBadge.from(E),this.D.$setBadge(this.C,E))}setExpanded(E,w){const r=this.getExtensionElement(E);r&&(w?this.r.fire(Object.freeze({element:r})):this.s.fire(Object.freeze({element:r})))}setSelection(E){(0,D.equals)(this.l,E)||(this.l=E,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(E){this.m=E}setVisible(E){E!==this.k&&(this.k=E,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(E){const w=(await Promise.all(E.map(async r=>{const a=this.getExtensionElement(r.treeItemHandle);return a?{extensionItem:a,treeItem:await this.f.getTreeItem(a),newState:r.newState?C.TreeItemCheckboxState.Checked:C.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);w.forEach(r=>{r.treeItem.checkboxState=r.newState?C.TreeItemCheckboxState.Checked:C.TreeItemCheckboxState.Unchecked}),this.v.fire({items:w.map(r=>[r.extensionItem,r.newState])})}async handleDrag(E,w,r){const a=[];for(const o of E){const d=this.getExtensionElement(o);d&&a.push(d)}if(!(!this.g?.handleDrag||a.length===0))return await this.g.handleDrag(a,w,r),w}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(E,w,r){const a=w?this.getExtensionElement(w):void 0;if(!(!a&&w||!this.g?.handleDrop))return(0,S.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(a,E,r):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(E,w){if(!this.f.resolveTreeItem)return;const r=this.i.get(E);if(r){const a=this.j.get(r);if(a){const o=await this.f.resolveTreeItem(a.extensionItem,r,w)??a.extensionItem;return this.db(o),a.item.tooltip=this.ab(o.tooltip),a.item.command=this.bb(a.disposableStore,o.command),a.item}}}N(E){return this.O(E).then(w=>w?this.N(w).then(r=>this.P(w,r[r.length-1]).then(a=>(r.push(a),r))):Promise.resolve([]))}O(E){const w=this.j.get(E);return w?Promise.resolve(w.parent?this.i.get(w.parent.item.handle):void 0):(0,S.asPromise)(()=>this.f.getParent(E))}P(E,w){const r=this.j.get(E);return r?Promise.resolve(r):(0,S.asPromise)(()=>this.f.getTreeItem(E)).then(a=>this.gb(E,a,w,!0)).then(a=>this.getChildren(w?w.item.handle:void 0).then(()=>{const o=this.getExtensionElement(a);if(o){const d=this.j.get(o);if(d)return Promise.resolve(d)}throw new Error(`Cannot resolve tree item for element ${a}`)}))}Q(E){if(E){let w;if(typeof E=="string"){const r=this.getExtensionElement(E);w=r?this.j.get(r):void 0}else w=E;return w&&w.children||void 0}return this.h}async R(E){this.nb(E);const w=new p.CancellationTokenSource(this.S.token);try{const r=E?this.j.get(E):void 0,a=await this.f.getChildren(E);if(w.token.isCancellationRequested)return;const o=await Promise.all((0,D.coalesce)(a||[]).map(async d=>{const s=await this.f.getTreeItem(d);return s&&!w.token.isCancellationRequested?this.Z(d,s,r):null}));return w.token.isCancellationRequested?void 0:(0,D.coalesce)(o)}finally{w.dispose()}}U(E){if(E.some(r=>!r))return this.S.dispose(!0),this.S=new p.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const r=this.W(E);if(r.length)return this.X(r)}return Promise.resolve(void 0)}W(E){const w=new Set,r=E.map(o=>this.j.get(o));for(const o of r)if(o&&!w.has(o.item.handle)){let d=o;for(;d&&d.parent&&r.findIndex(s=>d&&d.parent&&s&&s.item.handle===d.parent.item.handle)===-1;){const s=this.i.get(d.parent.item.handle);d=s?this.j.get(s):void 0}d&&!d.parent&&w.add(o.item.handle)}const a=[];return w.forEach(o=>{const d=this.i.get(o);if(d){const s=this.j.get(d);s&&(!s.parent||!w.has(s.parent.item.handle))&&a.push(o)}}),a}X(E){const w={};return Promise.all(E.map(r=>this.Y(r).then(a=>{a&&(w[r]=a.item)}))).then(()=>Object.keys(w).length?this.D.$refresh(this.C,w):void 0)}Y(E){const w=this.getExtensionElement(E);if(w){const r=this.j.get(w);if(r)return this.nb(w),(0,S.asPromise)(()=>this.f.getTreeItem(w)).then(a=>{if(a){const o=this.eb(w,a,r.parent);return this.lb(w,o,r,r.parent),r.dispose(),o}return null})}return Promise.resolve(null)}Z(E,w,r){const a=this.eb(E,w,r);if(w.id&&this.i.has(a.item.handle))throw new Error((0,i.localize)(10,null,w.id));return this.kb(E,a),this.mb(a,r),a}ab(E){return C.MarkdownString.isMarkdownString(E)?m.MarkdownString.from(E):E}bb(E,w){return w?{...this.F.toInternal(w,E),originalId:w.command}:void 0}cb(E){if(!E.checkboxState)return;let w,r;return typeof E.checkboxState=="number"?w=E.checkboxState:(w=E.checkboxState.state,r=E.checkboxState.tooltip),{isChecked:w===C.TreeItemCheckboxState.Checked,tooltip:r}}db(E){if(!C.TreeItem.isTreeItem(E,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(E,w,r){this.db(w);const a=new O.DisposableStore,o=this.gb(E,w,r),d=this.hb(w);return{item:{handle:o,parentHandle:r?r.item.handle:void 0,label:c(w.label,this.H),description:w.description,resourceUri:w.resourceUri,tooltip:this.ab(w.tooltip),command:this.bb(a,w.command),contextValue:w.contextValue,icon:d,iconDark:this.ib(w)||d,themeIcon:this.fb(w),collapsibleState:(0,N.isUndefinedOrNull)(w.collapsibleState)?C.TreeItemCollapsibleState.None:w.collapsibleState,accessibilityInformation:w.accessibilityInformation,checkbox:this.cb(w)},extensionItem:w,parent:r,children:void 0,disposableStore:a,dispose(){a.dispose()}}}fb(E){return E.iconPath instanceof C.ThemeIcon?E.iconPath:void 0}gb(E,{id:w,label:r,resourceUri:a},o,d){if(w)return`${v.b}/${w}`;const s=c(r,this.H),u=o?o.item.handle:v.a;let n=s?s.label:a?(0,y.basename)(a):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const h=this.j.has(E)?this.j.get(E).item.handle:void 0,g=this.Q(o)||[];let P,M=0;do{if(P=`${u}/${M}:${n}`,d||!this.i.has(P)||h===P)break;M++}while(M<=g.length);return P}hb(E){if(E.iconPath&&!(E.iconPath instanceof C.ThemeIcon))return typeof E.iconPath=="string"||L.URI.isUri(E.iconPath)?this.jb(E.iconPath):this.jb(E.iconPath.light)}ib(E){if(E.iconPath&&!(E.iconPath instanceof C.ThemeIcon)&&E.iconPath.dark)return this.jb(E.iconPath.dark)}jb(E){return L.URI.isUri(E)?E:L.URI.file(E)}kb(E,w){this.i.set(w.item.handle,E),this.j.set(E,w)}lb(E,w,r,a){this.i.delete(w.item.handle),this.j.delete(E),w.item.handle!==r.item.handle&&this.i.delete(r.item.handle),this.kb(E,w);const o=this.Q(a)||[],d=o.filter(s=>s.item.handle===r.item.handle)[0];d&&o.splice(o.indexOf(d),1,w)}mb(E,w){w?(w.children||(w.children=[]),w.children.push(E)):(this.h||(this.h=[]),this.h.push(E))}nb(E){if(E){const w=this.j.get(E);if(w){if(w.children)for(const r of w.children){const a=this.i.get(r.item.handle);a&&this.ob(a)}w.children=void 0}}else this.pb()}ob(E){const w=this.j.get(E);if(w){if(w.children)for(const r of w.children){const a=this.i.get(r.item.handle);a&&this.ob(a)}this.j.delete(E),this.i.delete(w.item.handle),w.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(E=>E.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}v.a="0",v.b="1"}),define(ke[245],Ce([1,0,20,11,5,29,2,126,254,115,124,36,4,70,198,197,38,199,32,201,202,203,186,204,56,33,206,207,210,211,213,103,189,218,219,220,77,59,223,244,8,6,50,226,60,102,31,177,209,48,101,105,107,108,12,53,15,27,214,184,66,73,195,224,78,58,229,227,228,196,37,221,225,76,57,71,215,104,216,13,89,188,168,208,7,26,172,75,165,217]),function(ee,e,i,T,y,L,k,O,S,C,N,D,m,p,f,t,c,l,v,b,E,w,r,a,o,d,s,u,n,h,g,P,M,j,Z,G,A,R,F,B,z,V,K,ie,me,ue,oe,De,re,Q,le,Ee,Ae,Be,xe,Te,Ie,Se,se,ce,Y,I,$,H,q,J,de,we,ae,pe,ve,We,He,tt,Xe,et,it,dt,Fe,st,_,X,ge,Me,$e,je,_e,nt,wt,St){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function kt(lt){const at=lt.get(Se.IExtHostInitDataService),Bt=lt.get(ve.IExtHostFileSystemInfo),Ot=lt.get(J.IExtHostConsumerFileSystem),Ft=lt.get(d.IExtHostExtensionService),ft=lt.get(oe.IExtHostWorkspace),Dt=lt.get(et.IExtHostTelemetry),$t=lt.get(v.IExtHostConfiguration),Nt=lt.get(Te.IURITransformerService),Ge=lt.get(Ie.IExtHostRpcService),Mt=lt.get(A.IExtHostStorage),Lt=lt.get(q.IExtensionStoragePaths),Ut=lt.get(xe.ILoggerService),mt=lt.get(xe.ILogService),Ct=lt.get(Y.IExtHostTunnelService),ye=lt.get(I.IExtHostApiDeprecationService),Pe=lt.get(ue.IExtHostWindow),fe=lt.get(tt.IExtHostSecretState),x=lt.get(Xe.IExtHostEditorTabs);Ge.set(m.ExtHostContext.ExtHostFileSystemInfo,Bt),Ge.set(m.ExtHostContext.ExtHostLogLevelServiceShape,Ut),Ge.set(m.ExtHostContext.ExtHostWorkspace,ft),Ge.set(m.ExtHostContext.ExtHostConfiguration,$t),Ge.set(m.ExtHostContext.ExtHostExtensionService,Ft),Ge.set(m.ExtHostContext.ExtHostStorage,Mt),Ge.set(m.ExtHostContext.ExtHostTunnelService,Ct),Ge.set(m.ExtHostContext.ExtHostWindow,Pe),Ge.set(m.ExtHostContext.ExtHostSecretState,fe),Ge.set(m.ExtHostContext.ExtHostTelemetry,Dt),Ge.set(m.ExtHostContext.ExtHostEditorTabs,x);const Re=Ge.set(m.ExtHostContext.ExtHostDecorations,lt.get(le.IExtHostDecorations)),Le=Ge.set(m.ExtHostContext.ExtHostDocumentsAndEditors,lt.get(o.IExtHostDocumentsAndEditors)),Qe=Ge.set(m.ExtHostContext.ExtHostCommands,lt.get(c.IExtHostCommands)),ze=Ge.set(m.ExtHostContext.ExtHostTerminalService,lt.get(R.IExtHostTerminalService)),Ze=Ge.set(m.ExtHostContext.ExtHostDebugService,lt.get(Ae.IExtHostDebugService)),bt=Ge.set(m.ExtHostContext.ExtHostSearch,lt.get(Be.IExtHostSearch)),vt=Ge.set(m.ExtHostContext.ExtHostTask,lt.get(Ee.IExtHostTask)),At=Ge.set(m.ExtHostContext.ExtHostOutputService,lt.get(P.IExtHostOutputService)),pt=Ge.set(m.ExtHostContext.ExtHostLocalization,lt.get(nt.IExtHostLocalizationService)),It=Ge.set(m.ExtHostContext.ExtHostUrls,new ie.ExtHostUrls(Ge)),ht=Ge.set(m.ExtHostContext.ExtHostDocuments,new a.ExtHostDocuments(Ge,Le)),xt=Ge.set(m.ExtHostContext.ExtHostDocumentContentProviders,new w.ExtHostDocumentContentProvider(Ge,Le,mt)),Vt=Ge.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new r.ExtHostDocumentSaveParticipant(mt,ht,Ge.getProxy(m.MainContext.MainThreadBulkEdits))),Et=Ge.set(m.ExtHostContext.ExtHostNotebook,new se.ExtHostNotebookController(Ge,Qe,Le,ht)),Qt=Ge.set(m.ExtHostContext.ExtHostNotebookDocuments,new ge.ExtHostNotebookDocuments(Et)),oi=Ge.set(m.ExtHostContext.ExtHostNotebookEditors,new X.ExtHostNotebookEditors(mt,Et)),Zt=Ge.set(m.ExtHostContext.ExtHostNotebookKernels,new it.ExtHostNotebookKernels(Ge,at,Et,Qe,mt)),bi=Ge.set(m.ExtHostContext.ExtHostNotebookRenderers,new Fe.ExtHostNotebookRenderers(Ge,Et)),Tt=Ge.set(m.ExtHostContext.ExtHostEditors,new F.ExtHostEditors(Ge,Le)),ai=Ge.set(m.ExtHostContext.ExtHostTreeViews,new B.ExtHostTreeViews(Ge.getProxy(m.MainContext.MainThreadTreeViews),Qe,mt)),jt=Ge.set(m.ExtHostContext.ExtHostEditorInsets,new De.ExtHostEditorInsets(Ge.getProxy(m.MainContext.MainThreadEditorInsets),Tt,at.remote)),ei=Ge.set(m.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(Ge,mt,Bt,Le)),ci=Ge.set(m.ExtHostContext.ExtHostLanguages,new h.ExtHostLanguages(Ge,ht,Qe.converter,Nt)),ct=Ge.set(m.ExtHostContext.ExtHostLanguageFeatures,new n.ExtHostLanguageFeatures(Ge,Nt,ht,Qe,ei,mt,ye,Dt)),ti=Ge.set(m.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(Ge,ct)),qt=Ge.set(m.ExtHostContext.ExtHostFileSystemEventService,new u.ExtHostFileSystemEventService(Ge,mt,Le)),_t=Ge.set(m.ExtHostContext.ExtHostQuickOpen,(0,j.createExtHostQuickOpen)(Ge,ft,Qe)),ui=Ge.set(m.ExtHostContext.ExtHostSCM,new Z.ExtHostSCM(Ge,Qe,mt)),Ei=Ge.set(m.ExtHostContext.ExtHostComments,(0,l.createExtHostComments)(Ge,Qe,ht)),li=Ge.set(m.ExtHostContext.ExtHostProgress,new M.ExtHostProgress(Ge.getProxy(m.MainContext.MainThreadProgress))),wi=Ge.set(m.ExtHostContext.ExtHosLabelService,new re.ExtHostLabelService(Ge)),di=Ge.set(m.ExtHostContext.ExtHostTheming,new ce.ExtHostTheming(Ge)),ii=Ge.set(m.ExtHostContext.ExtHostAuthentication,new $.ExtHostAuthentication(Ge)),Li=Ge.set(m.ExtHostContext.ExtHostTimeline,new H.ExtHostTimeline(Ge,Qe)),ni=Ge.set(m.ExtHostContext.ExtHostWebviews,new me.ExtHostWebviews(Ge,at.remote,ft,mt,ye)),ri=Ge.set(m.ExtHostContext.ExtHostWebviewPanels,new ae.ExtHostWebviewPanels(Ge,ni,ft)),Si=Ge.set(m.ExtHostContext.ExtHostCustomEditors,new we.ExtHostCustomEditors(Ge,ht,Lt,ni,ri)),yi=Ge.set(m.ExtHostContext.ExtHostWebviewViews,new de.ExtHostWebviewViews(Ge,ni)),si=Ge.set(m.ExtHostContext.ExtHostTesting,new We.ExtHostTesting(Ge,Qe,Le)),Di=Ge.set(m.ExtHostContext.ExtHostUriOpeners,new He.ExtHostUriOpeners(Ge)),Ii=Ge.set(m.ExtHostContext.ExtHostProfileContentHandlers,new St.ExtHostProfileContentHandlers(Ge));Ge.set(m.ExtHostContext.ExtHostInteractive,new Me.ExtHostInteractive(Ge,Et,Le,Qe,mt));const Ui=Object.values(m.ExtHostContext);Ge.assertRegistered(Ui);const Bi=new pe.ExtHostBulkEdits(Ge,Le),$i=new t.ExtHostClipboard(Ge),ki=new g.ExtHostMessageService(Ge,mt),Ai=new E.ExtHostDialogs(Ge),Ri=new G.ExtHostStatusBar(Ge,Qe.converter);return f.ExtHostApiCommands.register(Qe),function(Ue,Wt,Oi){const gt=function(){let ne=!Ue.isUnderDevelopment;function he(){ne||(mt.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Ne(rt){if(Array.isArray(rt))rt.forEach(Ne);else if(typeof rt=="string")he();else{const yt=rt;typeof yt.scheme>"u"&&he(),typeof yt.exclusive=="boolean"&&(0,je.checkProposedApiEnabled)(Ue,"documentFiltersExclusive")}return rt}}(),zi={getSession(ne,he,Ne){return ii.getSession(Ue,ne,he,Ne)},async hasSession(ne,he){return(0,je.checkProposedApiEnabled)(Ue,"authSession"),!!await ii.getSession(Ue,ne,he,{silent:!0})},get onDidChangeSessions(){return ii.onDidChangeSessions},registerAuthenticationProvider(ne,he,Ne,rt){return ii.registerAuthenticationProvider(ne,he,Ne,rt)}},hi={registerCommand(ne,he,Ne){return Qe.registerCommand(!0,ne,he,Ne,void 0,Ue)},registerTextEditorCommand(ne,he,Ne){return Qe.registerCommand(!0,ne,(...rt)=>{const yt=Tt.getActiveTextEditor();if(!yt){mt.warn("Cannot execute "+ne+" because there is no active text editor.");return}return yt.edit(Pt=>{he.apply(Ne,[yt,Pt,...rt])}).then(Pt=>{Pt||mt.warn("Edits from command "+ne+" were not applied.")},Pt=>{mt.warn("An error occurred while running command "+ne,Pt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(ne,he,Ne)=>((0,je.checkProposedApiEnabled)(Ue,"diffCommand"),Qe.registerCommand(!0,ne,async(...rt)=>{const yt=Le.activeEditor(!0);if(!yt){mt.warn("Cannot execute "+ne+" because there is no active text editor.");return}const Pt=await Tt.getDiffInformation(yt.id);he.apply(Ne,[Pt,...rt])},void 0,void 0,Ue)),executeCommand(ne,...he){return Qe.executeCommand(ne,...he)},getCommands(ne=!1){return Qe.getCommands(ne)}},Fi={get machineId(){return at.telemetryInfo.machineId},get sessionId(){return at.telemetryInfo.sessionId},get language(){return at.environment.appLanguage},get appName(){return at.environment.appName},get appRoot(){return at.environment.appRoot?.fsPath??""},get appHost(){return at.environment.appHost},get uriScheme(){return at.environment.appUriScheme},get clipboard(){return $i.value},get shell(){return ze.getDefaultShell(!1)},get onDidChangeShell(){return(0,je.checkProposedApiEnabled)(Ue,"envShellEvent"),ze.onDidChangeShell},get isTelemetryEnabled(){return Dt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Dt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,je.checkProposedApiEnabled)(Ue,"telemetry"),Dt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,je.checkProposedApiEnabled)(Ue,"telemetry"),Dt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.isNewAppInstall)(at.telemetryInfo.firstSessionDate)},createTelemetryLogger(ne){return(0,je.checkProposedApiEnabled)(Ue,"telemetryLogger"),Dt.instantiateLogger(Ue,ne)},openExternal(ne,he){return Pe.openUri(ne,{allowTunneling:!!at.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(ne){if(ne.scheme===at.environment.appUriScheme)return It.createAppUri(ne);try{return await Pe.asExternalUri(ne,{allowTunneling:!!at.remote.authority})}catch(he){if((0,_.matchesScheme)(ne,st.Schemas.http)||(0,_.matchesScheme)(ne,st.Schemas.https))return ne;throw he}},get remoteName(){return(0,Q.getRemoteName)(at.remote.authority)},get remoteAuthority(){return(0,je.checkProposedApiEnabled)(Ue,"resolvers"),at.remote.authority},get uiKind(){return at.uiKind},get logLevel(){return mt.getLevel()},get onDidChangeLogLevel(){return mt.onDidChangeLogLevel}};at.environment.extensionTestsLocationURI||Object.freeze(Fi);const Wi={createTestController(ne,he,Ne){return si.createTestController(ne,he,Ne)},createTestObserver(){return(0,je.checkProposedApiEnabled)(Ue,"testObserver"),si.createTestObserver()},runTests(ne){return(0,je.checkProposedApiEnabled)(Ue,"testObserver"),si.runTests(ne)},get onDidChangeTestResults(){return(0,je.checkProposedApiEnabled)(Ue,"testObserver"),si.onResultsChanged},get testResults(){return(0,je.checkProposedApiEnabled)(Ue,"testObserver"),si.results}},fi=at.remote.isRemote?V.ExtensionKind.Workspace:V.ExtensionKind.UI,Hi={getExtension(ne,he){(0,je.isProposedApiEnabled)(Ue,"extensionsAny")||(he=!1);const Ne=Wt.mine.getExtensionDescription(ne);if(Ne)return new d.Extension(Ft,Ue.identifier,Ne,fi,!1);if(he){const rt=Wt.all.getExtensionDescription(ne);if(rt)return new d.Extension(Ft,Ue.identifier,rt,fi,!0)}},get all(){const ne=[];for(const he of Wt.mine.getAllExtensionDescriptions())ne.push(new d.Extension(Ft,Ue.identifier,he,fi,!1));return ne},get allAcrossExtensionHosts(){(0,je.checkProposedApiEnabled)(Ue,"extensionsAny");const ne=new je.ExtensionIdentifierSet(Wt.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),he=[];for(const Ne of Wt.all.getAllExtensionDescriptions()){const rt=!ne.has(Ne.identifier);he.push(new d.Extension(Ft,Ue.identifier,Ne,fi,rt))}return he},get onDidChange(){return(0,je.isProposedApiEnabled)(Ue,"extensionsAny")?y.Event.any(Wt.mine.onDidChange,Wt.all.onDidChange):Wt.mine.onDidChange}},Ci={createDiagnosticCollection(ne){return ei.createDiagnosticCollection(Ue.identifier,ne)},get onDidChangeDiagnostics(){return ei.onDidChangeDiagnostics},getDiagnostics:ne=>ei.getDiagnostics(ne),getLanguages(){return ci.getLanguages()},setTextDocumentLanguage(ne,he){return ci.changeLanguage(ne.uri,he)},match(ne,he){const Ne=ht.getDocumentData(he.uri)?.notebook;return(0,N.score)(z.LanguageSelector.from(ne),he.uri,he.languageId,!0,Ne?.uri,Ne?.notebookType)},registerCodeActionsProvider(ne,he,Ne){return ct.registerCodeActionProvider(Ue,gt(ne),he,Ne)},registerDocumentPasteEditProvider(ne,he,Ne){return(0,je.checkProposedApiEnabled)(Ue,"documentPaste"),ct.registerDocumentPasteEditProvider(Ue,gt(ne),he,Ne)},registerCodeLensProvider(ne,he){return ct.registerCodeLensProvider(Ue,gt(ne),he)},registerDefinitionProvider(ne,he){return ct.registerDefinitionProvider(Ue,gt(ne),he)},registerDeclarationProvider(ne,he){return ct.registerDeclarationProvider(Ue,gt(ne),he)},registerImplementationProvider(ne,he){return ct.registerImplementationProvider(Ue,gt(ne),he)},registerTypeDefinitionProvider(ne,he){return ct.registerTypeDefinitionProvider(Ue,gt(ne),he)},registerHoverProvider(ne,he){return ct.registerHoverProvider(Ue,gt(ne),he,Ue.identifier)},registerEvaluatableExpressionProvider(ne,he){return ct.registerEvaluatableExpressionProvider(Ue,gt(ne),he,Ue.identifier)},registerInlineValuesProvider(ne,he){return ct.registerInlineValuesProvider(Ue,gt(ne),he,Ue.identifier)},registerDocumentHighlightProvider(ne,he){return ct.registerDocumentHighlightProvider(Ue,gt(ne),he)},registerLinkedEditingRangeProvider(ne,he){return ct.registerLinkedEditingRangeProvider(Ue,gt(ne),he)},registerReferenceProvider(ne,he){return ct.registerReferenceProvider(Ue,gt(ne),he)},registerRenameProvider(ne,he){return ct.registerRenameProvider(Ue,gt(ne),he)},registerDocumentSymbolProvider(ne,he,Ne){return ct.registerDocumentSymbolProvider(Ue,gt(ne),he,Ne)},registerWorkspaceSymbolProvider(ne){return ct.registerWorkspaceSymbolProvider(Ue,ne)},registerDocumentFormattingEditProvider(ne,he){return ct.registerDocumentFormattingEditProvider(Ue,gt(ne),he)},registerDocumentRangeFormattingEditProvider(ne,he){return ct.registerDocumentRangeFormattingEditProvider(Ue,gt(ne),he)},registerOnTypeFormattingEditProvider(ne,he,Ne,...rt){return ct.registerOnTypeFormattingEditProvider(Ue,gt(ne),he,[Ne].concat(rt))},registerDocumentSemanticTokensProvider(ne,he,Ne){return ct.registerDocumentSemanticTokensProvider(Ue,gt(ne),he,Ne)},registerDocumentRangeSemanticTokensProvider(ne,he,Ne){return ct.registerDocumentRangeSemanticTokensProvider(Ue,gt(ne),he,Ne)},registerSignatureHelpProvider(ne,he,Ne,...rt){return typeof Ne=="object"?ct.registerSignatureHelpProvider(Ue,gt(ne),he,Ne):ct.registerSignatureHelpProvider(Ue,gt(ne),he,typeof Ne>"u"?[]:[Ne,...rt])},registerCompletionItemProvider(ne,he,...Ne){return ct.registerCompletionItemProvider(Ue,gt(ne),he,Ne)},registerInlineCompletionItemProvider(ne,he){return he.handleDidShowCompletionItem&&(0,je.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Ue,gt(ne),he)},registerDocumentLinkProvider(ne,he){return ct.registerDocumentLinkProvider(Ue,gt(ne),he)},registerColorProvider(ne,he){return ct.registerColorProvider(Ue,gt(ne),he)},registerFoldingRangeProvider(ne,he){return ct.registerFoldingRangeProvider(Ue,gt(ne),he)},registerSelectionRangeProvider(ne,he){return ct.registerSelectionRangeProvider(Ue,ne,he)},registerCallHierarchyProvider(ne,he){return ct.registerCallHierarchyProvider(Ue,ne,he)},registerTypeHierarchyProvider(ne,he){return ct.registerTypeHierarchyProvider(Ue,ne,he)},setLanguageConfiguration:(ne,he)=>ct.setLanguageConfiguration(Ue,ne,he),getTokenInformationAtPosition(ne,he){return(0,je.checkProposedApiEnabled)(Ue,"tokenInformation"),ci.tokenAtPosition(ne,he)},registerInlayHintsProvider(ne,he){return ct.registerInlayHintsProvider(Ue,ne,he)},createLanguageStatusItem(ne,he){return ci.createLanguageStatusItem(Ue,ne,he)},registerDocumentDropEditProvider(ne,he){return ct.registerDocumentOnDropEditProvider(Ue,ne,he)}},Vi={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return ze.activeTerminal},get terminals(){return ze.terminals},async showTextDocument(ne,he,Ne){const rt=await(k.URI.isUri(ne)?Promise.resolve(Kt.openTextDocument(ne)):Promise.resolve(ne));return Tt.showTextDocument(rt,he,Ne)},createTextEditorDecorationType(ne){return Tt.createTextEditorDecorationType(Ue,ne)},onDidChangeActiveTextEditor(ne,he,Ne){return Tt.onDidChangeActiveTextEditor(ne,he,Ne)},onDidChangeVisibleTextEditors(ne,he,Ne){return Tt.onDidChangeVisibleTextEditors(ne,he,Ne)},onDidChangeTextEditorSelection(ne,he,Ne){return Tt.onDidChangeTextEditorSelection(ne,he,Ne)},onDidChangeTextEditorOptions(ne,he,Ne){return Tt.onDidChangeTextEditorOptions(ne,he,Ne)},onDidChangeTextEditorVisibleRanges(ne,he,Ne){return Tt.onDidChangeTextEditorVisibleRanges(ne,he,Ne)},onDidChangeTextEditorViewColumn(ne,he,Ne){return Tt.onDidChangeTextEditorViewColumn(ne,he,Ne)},onDidCloseTerminal(ne,he,Ne){return ze.onDidCloseTerminal(ne,he,Ne)},onDidOpenTerminal(ne,he,Ne){return ze.onDidOpenTerminal(ne,he,Ne)},onDidChangeActiveTerminal(ne,he,Ne){return ze.onDidChangeActiveTerminal(ne,he,Ne)},onDidChangeTerminalDimensions(ne,he,Ne){return(0,je.checkProposedApiEnabled)(Ue,"terminalDimensions"),ze.onDidChangeTerminalDimensions(ne,he,Ne)},onDidChangeTerminalState(ne,he,Ne){return ze.onDidChangeTerminalState(ne,he,Ne)},onDidWriteTerminalData(ne,he,Ne){return(0,je.checkProposedApiEnabled)(Ue,"terminalDataWriteEvent"),ze.onDidWriteTerminalData(ne,he,Ne)},get state(){return Pe.state},onDidChangeWindowState(ne,he,Ne){return Pe.onDidChangeWindowState(ne,he,Ne)},showInformationMessage(ne,...he){return ki.showMessage(Ue,L.default.Info,ne,he[0],he.slice(1))},showWarningMessage(ne,...he){return ki.showMessage(Ue,L.default.Warning,ne,he[0],he.slice(1))},showErrorMessage(ne,...he){return ki.showMessage(Ue,L.default.Error,ne,he[0],he.slice(1))},showQuickPick(ne,he,Ne){return _t.showQuickPick(ne,he,Ne)},showWorkspaceFolderPick(ne){return _t.showWorkspaceFolderPick(ne)},showInputBox(ne,he){return _t.showInput(ne,he)},showOpenDialog(ne){return Ai.showOpenDialog(ne)},showSaveDialog(ne){return Ai.showSaveDialog(ne)},createStatusBarItem(ne,he,Ne){let rt,yt,Pt;return typeof ne=="string"?(rt=ne,yt=he,Pt=Ne):(yt=ne,Pt=he),Ri.createStatusBarEntry(Ue,rt,yt,Pt)},setStatusBarMessage(ne,he){return Ri.setStatusBarMessage(ne,he)},withScmProgress(ne){return ye.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),li.withProgress(Ue,{location:V.ProgressLocation.SourceControl},(he,Ne)=>ne({report(rt){}}))},withProgress(ne,he){return li.withProgress(Ue,ne,he)},createOutputChannel(ne,he){return At.createOutputChannel(ne,he,Ue)},createWebviewPanel(ne,he,Ne,rt){return ri.createWebviewPanel(Ue,ne,he,Ne,rt)},createWebviewTextEditorInset(ne,he,Ne,rt){return(0,je.checkProposedApiEnabled)(Ue,"editorInsets"),jt.createWebviewEditorInset(ne,he,Ne,rt,Ue)},createTerminal(ne,he,Ne){return typeof ne=="object"?"pty"in ne?ze.createExtensionTerminal(ne):ze.createTerminalFromOptions(ne):ze.createTerminal(ne,he,Ne)},registerTerminalLinkProvider(ne){return ze.registerLinkProvider(ne)},registerTerminalProfileProvider(ne,he){return ze.registerProfileProvider(Ue,ne,he)},registerTerminalQuickFixProvider(ne,he){return(0,je.checkProposedApiEnabled)(Ue,"terminalQuickFixProvider"),ze.registerTerminalQuickFixProvider(ne,Ue.identifier.value,he)},registerTreeDataProvider(ne,he){return ai.registerTreeDataProvider(ne,he,Ue)},createTreeView(ne,he){return ai.createTreeView(ne,he,Ue)},registerWebviewPanelSerializer:(ne,he)=>ri.registerWebviewPanelSerializer(Ue,ne,he),registerCustomEditorProvider:(ne,he,Ne={})=>Si.registerCustomEditorProvider(Ue,ne,he,Ne),registerFileDecorationProvider(ne){return Re.registerFileDecorationProvider(ne,Ue)},registerUriHandler(ne){return It.registerUriHandler(Ue.identifier,ne)},createQuickPick(){return _t.createQuickPick(Ue)},createInputBox(){return _t.createInputBox(Ue)},get activeColorTheme(){return di.activeColorTheme},onDidChangeActiveColorTheme(ne,he,Ne){return di.onDidChangeActiveColorTheme(ne,he,Ne)},registerWebviewViewProvider(ne,he,Ne){return yi.registerWebviewViewProvider(Ue,ne,he,Ne?.webviewOptions)},get activeNotebookEditor(){return Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,he,Ne){return Et.onDidChangeActiveNotebookEditor(ne,he,Ne)},get visibleNotebookEditors(){return Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ne,he,Ne){return oi.onDidChangeNotebookEditorSelection(ne,he,Ne)},onDidChangeNotebookEditorVisibleRanges(ne,he,Ne){return oi.onDidChangeNotebookEditorVisibleRanges(ne,he,Ne)},showNotebookDocument(ne,he){return Et.showNotebookDocument(ne,he)},registerExternalUriOpener(ne,he,Ne){return(0,je.checkProposedApiEnabled)(Ue,"externalUriOpener"),Di.registerExternalUriOpener(Ue.identifier,ne,he,Ne)},registerProfileContentHandler(ne,he){return(0,je.checkProposedApiEnabled)(Ue,"profileContentHandlers"),Ii.registrProfileContentHandler(Ue,ne,he)},get tabGroups(){return x.tabGroups}},Kt={get rootPath(){return ye.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(ne){throw T.readonly()},getWorkspaceFolder(ne){return ft.getWorkspaceFolder(ne)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(ne){throw T.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(ne){throw T.readonly()},updateWorkspaceFolders:(ne,he,...Ne)=>ft.updateWorkspaceFolders(Ue,ne,he||0,...Ne),onDidChangeWorkspaceFolders:function(ne,he,Ne){return ft.onDidChangeWorkspace(ne,he,Ne)},asRelativePath:(ne,he)=>ft.getRelativePath(ne,he),findFiles:(ne,he,Ne,rt)=>ft.findFiles(ne,he,Ne,Ue.identifier,rt),findTextInFiles:(ne,he,Ne,rt)=>{(0,je.checkProposedApiEnabled)(Ue,"findTextInFiles");let yt,Pt;return typeof he=="object"?(yt=he,Pt=Ne):(yt={},Pt=he,rt=Ne),ft.findTextInFiles(ne,yt||{},Pt,Ue.identifier,rt)},saveAll:ne=>ft.saveAll(ne),applyEdit(ne,he){return Bi.applyWorkspaceEdit(ne,Ue,he)},createFileSystemWatcher:(ne,he,Ne,rt)=>qt.createFileSystemWatcher(ft,Ue,ne,he,Ne,rt),get textDocuments(){return ht.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw T.readonly()},openTextDocument(ne){let he;const Ne=ne;if(typeof ne=="string")he=Promise.resolve(k.URI.file(ne));else if(k.URI.isUri(ne))he=Promise.resolve(ne);else if(!Ne||typeof Ne=="object")he=ht.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(rt=>ht.ensureDocumentData(rt).then(yt=>yt.document))},onDidOpenTextDocument:(ne,he,Ne)=>ht.onDidAddDocument(ne,he,Ne),onDidCloseTextDocument:(ne,he,Ne)=>ht.onDidRemoveDocument(ne,he,Ne),onDidChangeTextDocument:(ne,he,Ne)=>ht.onDidChangeDocument(ne,he,Ne),onDidSaveTextDocument:(ne,he,Ne)=>ht.onDidSaveDocument(ne,he,Ne),onWillSaveTextDocument:(ne,he,Ne)=>Vt.getOnWillSaveTextDocumentEvent(Ue)(ne,he,Ne),get notebookDocuments(){return Et.notebookDocuments.map(ne=>ne.apiNotebook)},async openNotebookDocument(ne,he){let Ne;if(k.URI.isUri(ne))Ne=ne,await Et.openNotebookDocument(ne);else if(typeof ne=="string")Ne=k.URI.revive(await Et.createNotebookDocument({viewType:ne,content:he}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(ne,he,Ne){return Qt.onDidSaveNotebookDocument(ne,he,Ne)},onDidChangeNotebookDocument(ne,he,Ne){return Qt.onDidChangeNotebookDocument(ne,he,Ne)},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(ne,he,Ne,rt){return Et.registerNotebookSerializer(Ue,ne,he,Ne,(0,je.isProposedApiEnabled)(Ue,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(ne,he,Ne)=>Oi.onDidChangeConfiguration(ne,he,Ne),getConfiguration(ne,he){return he=arguments.length===1?void 0:he,Oi.getConfiguration(ne,he,Ue)},registerTextDocumentContentProvider(ne,he){return xt.registerTextDocumentContentProvider(ne,he)},registerTaskProvider:(ne,he)=>(ye.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),vt.registerTaskProvider(Ue,ne,he)),registerFileSystemProvider(ne,he,Ne){return(0,$e.combinedDisposable)(ti.registerFileSystemProvider(Ue,ne,he,Ne),Ot.addFileSystemProvider(ne,he))},get fs(){return Ot.value},registerFileSearchProvider:(ne,he)=>((0,je.checkProposedApiEnabled)(Ue,"fileSearchProvider"),bt.registerFileSearchProvider(ne,he)),registerTextSearchProvider:(ne,he)=>((0,je.checkProposedApiEnabled)(Ue,"textSearchProvider"),bt.registerTextSearchProvider(ne,he)),registerRemoteAuthorityResolver:(ne,he)=>((0,je.checkProposedApiEnabled)(Ue,"resolvers"),Ft.registerRemoteAuthorityResolver(ne,he)),registerResourceLabelFormatter:ne=>((0,je.checkProposedApiEnabled)(Ue,"resolvers"),wi.$registerResourceLabelFormatter(ne)),onDidCreateFiles:(ne,he,Ne)=>qt.onDidCreateFile(ne,he,Ne),onDidDeleteFiles:(ne,he,Ne)=>qt.onDidDeleteFile(ne,he,Ne),onDidRenameFiles:(ne,he,Ne)=>qt.onDidRenameFile(ne,he,Ne),onWillCreateFiles:(ne,he,Ne)=>qt.getOnWillCreateFileEvent(Ue)(ne,he,Ne),onWillDeleteFiles:(ne,he,Ne)=>qt.getOnWillDeleteFileEvent(Ue)(ne,he,Ne),onWillRenameFiles:(ne,he,Ne)=>qt.getOnWillRenameFileEvent(Ue)(ne,he,Ne),openTunnel:ne=>((0,je.checkProposedApiEnabled)(Ue,"tunnels"),Ct.openTunnel(Ue,ne).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,je.checkProposedApiEnabled)(Ue,"tunnels"),Ct.getTunnels()},onDidChangeTunnels:(ne,he,Ne)=>((0,je.checkProposedApiEnabled)(Ue,"tunnels"),Ct.onDidChangeTunnels(ne,he,Ne)),registerPortAttributesProvider:(ne,he)=>((0,je.checkProposedApiEnabled)(Ue,"portsAttributes"),Ct.registerPortsAttributesProvider(ne,he)),registerTimelineProvider:(ne,he)=>((0,je.checkProposedApiEnabled)(Ue,"timeline"),Li.registerTimelineProvider(ne,he,Ue.identifier,Qe.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:ne=>((0,je.checkProposedApiEnabled)(Ue,"workspaceTrust"),ft.requestWorkspaceTrust(ne)),onDidGrantWorkspaceTrust:(ne,he,Ne)=>ft.onDidGrantWorkspaceTrust(ne,he,Ne),registerEditSessionIdentityProvider:(ne,he)=>((0,je.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(ne,he))},mi={get inputBox(){return ye.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),ui.getLastInputBox(Ue)},createSourceControl(ne,he,Ne){return ui.createSourceControl(Ue,ne,he,Ne)}},ji={createCommentController(ne,he){return Ei.createCommentController(Ue,ne,he)}},zt={get activeDebugSession(){return Ze.activeDebugSession},get activeDebugConsole(){return Ze.activeDebugConsole},get breakpoints(){return Ze.breakpoints},onDidStartDebugSession(ne,he,Ne){return Ze.onDidStartDebugSession(ne,he,Ne)},onDidTerminateDebugSession(ne,he,Ne){return Ze.onDidTerminateDebugSession(ne,he,Ne)},onDidChangeActiveDebugSession(ne,he,Ne){return Ze.onDidChangeActiveDebugSession(ne,he,Ne)},onDidReceiveDebugSessionCustomEvent(ne,he,Ne){return Ze.onDidReceiveDebugSessionCustomEvent(ne,he,Ne)},onDidChangeBreakpoints(ne,he,Ne){return Ze.onDidChangeBreakpoints(ne,he,Ne)},registerDebugConfigurationProvider(ne,he,Ne){return Ze.registerDebugConfigurationProvider(ne,he,Ne||_e.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,he){return Ze.registerDebugAdapterDescriptorFactory(Ue,ne,he)},registerDebugAdapterTrackerFactory(ne,he){return Ze.registerDebugAdapterTrackerFactory(ne,he)},startDebugging(ne,he,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?Ze.startDebugging(ne,he,{parentSession:Ne}):Ze.startDebugging(ne,he,Ne||{})},stopDebugging(ne){return Ze.stopDebugging(ne)},addBreakpoints(ne){return Ze.addBreakpoints(ne)},removeBreakpoints(ne){return Ze.removeBreakpoints(ne)},asDebugSourceUri(ne,he){return Ze.asDebugSourceUri(ne,he)}},gi={registerTaskProvider:(ne,he)=>vt.registerTaskProvider(Ue,ne,he),fetchTasks:ne=>vt.fetchTasks(ne),executeTask:ne=>vt.executeTask(Ue,ne),get taskExecutions(){return vt.taskExecutions},onDidStartTask:(ne,he,Ne)=>vt.onDidStartTask(ne,he,Ne),onDidEndTask:(ne,he,Ne)=>vt.onDidEndTask(ne,he,Ne),onDidStartTaskProcess:(ne,he,Ne)=>vt.onDidStartTaskProcess(ne,he,Ne),onDidEndTaskProcess:(ne,he,Ne)=>vt.onDidEndTaskProcess(ne,he,Ne)},qi={createNotebookController(ne,he,Ne,rt,yt){return Zt.createNotebookController(Ue,ne,he,Ne,rt,(0,je.isProposedApiEnabled)(Ue,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(ne,he)=>Et.registerNotebookCellStatusBarItemProvider(Ue,ne,he),createRendererMessaging(ne){return bi.createRendererMessaging(Ue,ne)},createNotebookControllerDetectionTask(ne){return(0,je.checkProposedApiEnabled)(Ue,"notebookKernelSource"),Zt.createNotebookControllerDetectionTask(Ue,ne)},registerKernelSourceActionProvider(ne,he){return(0,je.checkProposedApiEnabled)(Ue,"notebookKernelSource"),Zt.registerKernelSourceActionProvider(Ue,ne,he)},onDidChangeNotebookCellExecutionState(ne,he,Ne){return(0,je.checkProposedApiEnabled)(Ue,"notebookCellExecutionState"),Zt.onDidChangeNotebookCellExecutionState(ne,he,Ne)}},Ki={t(...ne){if(typeof ne[0]=="string"){const he=ne.shift(),Ne=!ne||typeof ne[0]!="object"?ne:ne[0];return pt.getMessage(Ue.identifier.value,{message:he,args:Ne})}return pt.getMessage(Ue.identifier.value,ne[0])},get bundle(){return pt.getBundle(Ue.identifier.value)},get uri(){return pt.getBundleUri(Ue.identifier.value)}};return{version:at.version,authentication:zi,commands:hi,comments:ji,debug:zt,env:Fi,extensions:Hi,l10n:Ki,languages:Ci,notebooks:qi,scm:mi,tasks:gi,tests:Wi,window:Vi,workspace:Kt,Breakpoint:V.Breakpoint,TerminalOutputAnchor:V.TerminalOutputAnchor,CallHierarchyIncomingCall:V.CallHierarchyIncomingCall,CallHierarchyItem:V.CallHierarchyItem,CallHierarchyOutgoingCall:V.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:i.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:V.CodeAction,CodeActionKind:V.CodeActionKind,CodeActionTriggerKind:V.CodeActionTriggerKind,CodeLens:V.CodeLens,Color:V.Color,ColorInformation:V.ColorInformation,ColorPresentation:V.ColorPresentation,ColorThemeKind:V.ColorThemeKind,CommentMode:V.CommentMode,CommentThreadCollapsibleState:V.CommentThreadCollapsibleState,CommentThreadState:V.CommentThreadState,CompletionItem:V.CompletionItem,CompletionItemKind:V.CompletionItemKind,CompletionItemTag:V.CompletionItemTag,CompletionList:V.CompletionList,CompletionTriggerKind:V.CompletionTriggerKind,ConfigurationTarget:V.ConfigurationTarget,CustomExecution:V.CustomExecution,DebugAdapterExecutable:V.DebugAdapterExecutable,DebugAdapterInlineImplementation:V.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:V.DebugAdapterNamedPipeServer,DebugAdapterServer:V.DebugAdapterServer,DebugConfigurationProviderTriggerKind:_e.DebugConfigurationProviderTriggerKind,DebugConsoleMode:V.DebugConsoleMode,DecorationRangeBehavior:V.DecorationRangeBehavior,Diagnostic:V.Diagnostic,DiagnosticRelatedInformation:V.DiagnosticRelatedInformation,DiagnosticSeverity:V.DiagnosticSeverity,DiagnosticTag:V.DiagnosticTag,Disposable:V.Disposable,DocumentHighlight:V.DocumentHighlight,DocumentHighlightKind:V.DocumentHighlightKind,DocumentLink:V.DocumentLink,DocumentSymbol:V.DocumentSymbol,EndOfLine:V.EndOfLine,EnvironmentVariableMutatorType:V.EnvironmentVariableMutatorType,EvaluatableExpression:V.EvaluatableExpression,InlineValueText:V.InlineValueText,InlineValueVariableLookup:V.InlineValueVariableLookup,InlineValueEvaluatableExpression:V.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:V.InlineCompletionTriggerKind,EventEmitter:y.Emitter,ExtensionKind:V.ExtensionKind,ExtensionMode:V.ExtensionMode,ExternalUriOpenerPriority:V.ExternalUriOpenerPriority,FileChangeType:V.FileChangeType,FileDecoration:V.FileDecoration,FileDecoration2:V.FileDecoration,FileSystemError:V.FileSystemError,FileType:D.FileType,FilePermission:D.FilePermission,FoldingRange:V.FoldingRange,FoldingRangeKind:V.FoldingRangeKind,FunctionBreakpoint:V.FunctionBreakpoint,InlineCompletionItem:V.InlineSuggestion,InlineCompletionList:V.InlineSuggestionList,Hover:V.Hover,IndentAction:C.IndentAction,Location:V.Location,MarkdownString:V.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:V.ParameterInformation,PortAutoForwardAction:V.PortAutoForwardAction,Position:V.Position,ProcessExecution:V.ProcessExecution,ProgressLocation:V.ProgressLocation,QuickInputButtons:V.QuickInputButtons,Range:V.Range,RelativePattern:V.RelativePattern,Selection:V.Selection,SelectionRange:V.SelectionRange,SemanticTokens:V.SemanticTokens,SemanticTokensBuilder:V.SemanticTokensBuilder,SemanticTokensEdit:V.SemanticTokensEdit,SemanticTokensEdits:V.SemanticTokensEdits,SemanticTokensLegend:V.SemanticTokensLegend,ShellExecution:V.ShellExecution,ShellQuoting:V.ShellQuoting,SignatureHelp:V.SignatureHelp,SignatureHelpTriggerKind:V.SignatureHelpTriggerKind,SignatureInformation:V.SignatureInformation,SnippetString:V.SnippetString,SourceBreakpoint:V.SourceBreakpoint,StandardTokenType:V.StandardTokenType,StatusBarAlignment:V.StatusBarAlignment,SymbolInformation:V.SymbolInformation,SymbolKind:V.SymbolKind,SymbolTag:V.SymbolTag,Task:V.Task,TaskGroup:V.TaskGroup,TaskPanelKind:V.TaskPanelKind,TaskRevealKind:V.TaskRevealKind,TaskScope:V.TaskScope,TerminalLink:V.TerminalLink,TerminalQuickFixCommand:V.TerminalQuickFixCommand,TerminalQuickFixOpener:V.TerminalQuickFixOpener,TerminalLocation:V.TerminalLocation,TerminalProfile:V.TerminalProfile,TerminalExitReason:V.TerminalExitReason,TerminalQuickFixType:V.TerminalQuickFixType,TextDocumentSaveReason:V.TextDocumentSaveReason,TextEdit:V.TextEdit,SnippetTextEdit:V.SnippetTextEdit,TextEditorCursorStyle:O.TextEditorCursorStyle,TextEditorLineNumbersStyle:V.TextEditorLineNumbersStyle,TextEditorRevealType:V.TextEditorRevealType,TextEditorSelectionChangeKind:V.TextEditorSelectionChangeKind,TextDocumentChangeReason:V.TextDocumentChangeReason,ThemeColor:V.ThemeColor,ThemeIcon:V.ThemeIcon,TreeItem:V.TreeItem,TreeItem2:V.TreeItem,TreeItemCheckboxState:V.TreeItemCheckboxState,TreeItemCollapsibleState:V.TreeItemCollapsibleState,TypeHierarchyItem:V.TypeHierarchyItem,UIKind:p.UIKind,Uri:k.URI,ViewColumn:V.ViewColumn,WorkspaceEdit:V.WorkspaceEdit,DocumentDropEdit:V.DocumentDropEdit,DocumentPasteEdit:V.DocumentPasteEdit,InlayHint:V.InlayHint,InlayHintLabelPart:V.InlayHintLabelPart,InlayHintKind:V.InlayHintKind,RemoteAuthorityResolverError:V.RemoteAuthorityResolverError,ResolvedAuthority:V.ResolvedAuthority,SourceControlInputBoxValidationType:V.SourceControlInputBoxValidationType,ExtensionRuntime:V.ExtensionRuntime,TimelineItem:V.TimelineItem,NotebookRange:V.NotebookRange,NotebookCellKind:V.NotebookCellKind,NotebookCellExecutionState:V.NotebookCellExecutionState,NotebookCellData:V.NotebookCellData,NotebookData:V.NotebookData,NotebookRendererScript:V.NotebookRendererScript,NotebookCellStatusBarAlignment:V.NotebookCellStatusBarAlignment,NotebookEditorRevealType:V.NotebookEditorRevealType,NotebookCellOutput:V.NotebookCellOutput,NotebookCellOutputItem:V.NotebookCellOutputItem,NotebookCellStatusBarItem:V.NotebookCellStatusBarItem,NotebookControllerAffinity:V.NotebookControllerAffinity,NotebookControllerAffinity2:V.NotebookControllerAffinity2,NotebookEdit:V.NotebookEdit,NotebookKernelSourceAction:V.NotebookKernelSourceAction,PortAttributes:V.PortAttributes,LinkedEditingRanges:V.LinkedEditingRanges,TestResultState:V.TestResultState,TestRunRequest:V.TestRunRequest,TestMessage:V.TestMessage,TestTag:V.TestTag,TestRunProfileKind:V.TestRunProfileKind,TextSearchCompleteMessageType:dt.TextSearchCompleteMessageType,DataTransfer:V.DataTransfer,DataTransferItem:V.DataTransferItem,CoveredCount:V.CoveredCount,FileCoverage:V.FileCoverage,StatementCoverage:V.StatementCoverage,BranchCoverage:V.BranchCoverage,FunctionCoverage:V.FunctionCoverage,WorkspaceTrustState:V.WorkspaceTrustState,LanguageStatusSeverity:V.LanguageStatusSeverity,QuickPickItemKind:V.QuickPickItemKind,InputBoxValidationSeverity:V.InputBoxValidationSeverity,TabInputText:V.TextTabInput,TabInputTextDiff:V.TextDiffTabInput,TabInputTextMerge:V.TextMergeTabInput,TabInputCustom:V.CustomEditorTabInput,TabInputNotebook:V.NotebookEditorTabInput,TabInputNotebookDiff:V.NotebookDiffEditorTabInput,TabInputWebview:V.WebviewEditorTabInput,TabInputTerminal:V.TerminalEditorTabInput,TabInputInteractiveWindow:V.InteractiveWindowInput,TrustedTelemetryValue:K.TrustedTelemetryValue,LogLevel:xe.LogLevel,EditSessionIdentityMatch:wt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=kt}),define(ke[246],Ce([1,0,245,33,2,239,6,14,230]),function(ee,e,i,T,y,L,k,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class C extends L.RequireInterceptor{j(){}getModule(p,f){for(const t of this.b){const c=t(p);if(c){p=c;break}}if(this.a.has(p))return this.a.get(p).load(p,f,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class N extends T.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=k.ExtensionRuntime.Webworker}async nb(){this.h.createInstance(S.ExtHostConsoleForwarder);const p=this.h.invokeFunction(i.createApiFactoryAndRegisterActors);this.r=this.h.createInstance(C,p,{mine:this.D,all:this.F}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.tb()}ob(p){return p.browser}async pb(p,f,t){f=f.with({path:D(f.path,".js")});const c=p?.identifier.value;c&&performance.mark(`code/extHost/willFetchExtensionCode/${c}`);const l=y.URI.revive(await this.v.$asBrowserUri(f)),v=await fetch(l.toString(!0));if(c&&performance.mark(`code/extHost/didFetchExtensionCode/${c}`),v.status!==200)throw new Error(v.statusText);const b=await v.text(),E=`${f.toString(!0)}#vscode-extension`,w=`${b}
//# sourceURL=${E}`;let r;try{r=new Function("module","exports","require",w)}catch(s){throw console.error(c?`Loading code for extension ${c} failed: ${s.message}`:`Loading code failed: ${s.message}`),console.error(`${f.toString(!0)}${typeof s.line=="number"?` line ${s.line}`:""}${typeof s.column=="number"?` column ${s.column}`:""}`),console.error(s),s}p&&await this.s.initializeLocalizedMessages(p);const a={},o={exports:a},d=s=>{const u=this.r.getModule(s,f);if(u===void 0)throw new Error(`Cannot load module '${s}'`);return u};try{return t.codeLoadingStart(),c&&performance.mark(`code/extHost/willLoadExtensionCode/${c}`),r(o,a,d),o.exports!==a?o.exports:a}finally{c&&performance.mark(`code/extHost/didLoadExtensionCode/${c}`),t.codeLoadingStop()}}async $setRemoteEnvironment(p){}async tb(p=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const f=Date.now()+p;for(;Date.now()<f&&!("__jsDebugIsReady"in globalThis);)await(0,O.timeout)(10)}}e.ExtHostExtensionService=N;function D(m,p){return m.endsWith(p)?m:m+p}}),define(ke[247],Ce([1,0,63,33,78,246]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,i.registerSingleton)(T.IExtHostExtensionService,L.ExtHostExtensionService,0),(0,i.registerSingleton)(y.IExtensionStoragePaths,y.ExtensionStoragePaths,0)}),define(ke[255],Ce([1,0,24,5,70,240,232,19,79,13,2,242,247]),function(ee,e,i,T,y,L,k,O,S,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const m=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function p(r){return/^(file|vscode-remote):/i.test(r)}const f=fetch.bind(self);function t(r){self.fetch=async function(a,o){return a instanceof Request||p(String(a))&&(a=(await r(N.URI.parse(String(a)))).toString(!0)),f(a,o)},self.XMLHttpRequest=class extends XMLHttpRequest{open(a,o,d,s,u){(async()=>(p(o.toString())&&(o=(await r(N.URI.parse(o.toString()))).toString(!0)),super.open(a,o,d??!0,s,u)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const r=self.Worker;Worker=function(a,o){if(/^file:/i.test(a.toString()))a=C.FileAccess.uriToBrowserUri(N.URI.parse(a.toString())).toString(!0);else if(/^vscode-remote:/i.test(a.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const s=`(${function(g){function P(Z){return typeof Z=="string"||Z instanceof URL?String(Z).replace(/^file:\/\//i,"vscode-file://vscode-app"):Z}const M=fetch.bind(self);self.fetch=function(Z,G){return Z instanceof Request?M(Z,G):M(P(Z),G)},self.XMLHttpRequest=class extends XMLHttpRequest{open(Z,G,A,R,F){return super.open(Z,P(G),A??!0,R,F)}};const j=importScripts.bind(self);self.importScripts=(...Z)=>{j(...Z.map(P))},j(g)}.toString()}('${a}'))`;o=o||{},o.name=o.name||O.basename(a.toString());const u=new Blob([s],{type:"application/javascript"}),n=URL.createObjectURL(u);return new r(n,o)}}else self.Worker=class extends k.NestedWorker{constructor(r,a){super(m,r,{name:O.basename(r.toString()),...a})}};const c=new class{constructor(){this.pid=void 0}exit(r){D()}async exists(r){return!0}async realpath(r){return r}};class l{constructor(){const a=new MessageChannel,o=new T.Emitter;let d=!1;m(a.port2,[a.port2]),a.port1.onmessage=s=>{const{data:u}=s;if(!(u instanceof ArrayBuffer)){console.warn("UNKNOWN data received",u);return}const n=i.VSBuffer.wrap(new Uint8Array(u,0,u.byteLength));if((0,y.isMessageOfType)(n,2)){d=!0,b("received terminate message from renderer");return}o.fire(n)},this.protocol={onMessage:o.event,send:s=>{if(!d){const u=s.buffer.buffer.slice(s.buffer.byteOffset,s.buffer.byteOffset+s.buffer.byteLength);a.port1.postMessage(u,[u])}}}}}function v(r){return new Promise(a=>{const o=r.onMessage(d=>{o.dispose();const s=JSON.parse(d.toString());r.send((0,y.createMessageOfType)(0)),a({protocol:r,initData:s})});r.send((0,y.createMessageOfType)(1))})}let b=r=>D();function E(r){return!!r&&typeof r=="object"&&r.type==="vscode.init"&&r.data instanceof Map}function w(){S.mark("code/extHost/willConnectToRenderer");const r=new l;return{onmessage(a){!E(a)||v(r.protocol).then(o=>{S.mark("code/extHost/didWaitForInitData");const d=new L.ExtensionHostMain(o.protocol,o.initData,c,null,a.data);t(s=>d.asBrowserUri(s)),b=s=>d.terminate(s)})}}}e.create=w})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/42814d18a7d46adfb1c24e1349b7ab18833ec6ac/core/vs/workbench/api/worker/extensionHostWorker.js.map
